# UNICODE CHARACTER DATABASE
# This file was generated with the command:
#     ./generate_unicodedb.py --unidata_version=5.2.0 --output=unicodedb_5_2_0

from rpython.rlib.rarithmetic import r_longlong


base_mod = None
version = '5.2.0'


def trie_lookup(name):
    charnode = 0
    while 0 <= charnode < 0xffff: # 16bit number, 0xffff = None
        charnode *= 3
        leftright, parentstr, codepoint = _charnodes[charnode:charnode+3]

        if leftright < 0:
            # XXX assumes msb is sign
            left = 0x8000 | ((leftright & 0x7fffffff) >> 16)
        else:
            left = (leftright & 0x7fffffff) >> 16
        right = leftright & 0xffff

        if parentstr < 0:
            # XXX assumes msb is sign
            parent = 0x8000 | ((parentstr & 0x7fffffff) >> 16)
        else:
            parent = (parentstr & 0x7fffffff) >> 16
        stridx = parentstr & ((1 << 16) - 1)
        
        strlen = ord(_stringtable[stridx])
        substring = _stringtable[stridx+1:stridx+1+strlen]

        if codepoint != -1 and name == substring:
            return int(codepoint)
        if name.startswith(substring):
            name = name[strlen:]
            charnode = left
        else:
            charnode = right
    raise KeyError(name)

def name_of_node(charnode):
    res = []
    prevnode = -1
    while 0 <= charnode < 0xffff: # 16bit number, 0xffff = None
        charnode *= 3
        leftright, parentstr, codepoint = _charnodes[charnode:charnode+3]

        if leftright < 0:
            # XXX assumes msg is sign
            left = 0x8000 | ((leftright & 0x7fffffff) >> 16)
        else:
            left = (leftright & 0x7fffffff) >> 16
        right = leftright & 0xffff

        if parentstr < 0:
            # XXX assumes msb is sign
            parent = 0x8000 | ((parentstr & 0x7fffffff) >> 16)
        else:
            parent = (parentstr & 0x7fffffff) >> 16

        if prevnode < 0 or prevnode == left:
            stridx = parentstr & ((1<<16)-1)
            strlen = ord(_stringtable[stridx])
            substring = _stringtable[stridx+1:stridx+1+strlen]
            res.insert(0, substring)

        prevnode = charnode // 3
        charnode = parent

    return ''.join(res)
    

_stringtable = (
'\x01 '
'\x02 A'
'\x06 ABOVE'
'\x14 ABOVE LEFT TRIANGLE'
'\x14 ABOVE SLANTED EQUAL'
'\x05 ADEG'
'\x06 AGUNG'
'\x04 ALL'
'\x05 ALLO'
'\x0f ALTERNATE FORM'
'\x11 ALTERNATION MARK'
'\x05 AMPS'
'\x03 AN'
'\x05 AND '
'\n AND ACUTE'
'\n AND BREVE'
'\x0e AND DIAERESIS'
'\x14 AND DIAGONAL STROKE'
'\x0e AND DOT ABOVE'
'\x10 AND HEAVY RIGHT'
'\t AND HOOK'
'\x10 AND LIGHT RIGHT'
'\x0f AND LOWER LEFT'
'\x10 AND LOWER RIGHT'
'\x0b AND MACRON'
'\x11 AND MIDDLE TILDE'
'\x13 AND PROSGEGRAMMENI'
'\x06 AND S'
'\x15 AND SLANTED PARALLEL'
'\x0e AND SMALL TAH'
'\x12 AND SMASH PRODUCT'
'\t AND TAIL'
'\x15 AND THREE DOTS ABOVE'
'\x13 AND TWO DOTS ABOVE'
'\x12 AND YPOGEGRAMMENI'
'\x07 APLOUN'
'\t APODEXIA'
'\t ARCHAION'
'\x06 ARROW'
'\r B BAR SYMBOL'
'\x05 BACK'
'\n BACKSLASH'
'\x04 BAR'
'\r BEHIND CLOUD'
'\x06 BELOW'
'\x1c BETWEEN TWO HORIZONTAL BARS'
'\r BLACK SQUARE'
'\x06 BLOCK'
'\r BZHI MIG CAN'
'\x04 C D'
'\x05 CAPO'
'\x06 CARET'
'\x08 CEDILLA'
'\x07 CER-WA'
'\x07 CHIKI '
'\x07 CIRCLE'
'\x05 CLEF'
'\x0f CLOUD AND RAIN'
'\x0f CORNER BRACKET'
'\x1f CROSSING ASH OVER ASH OVER ASH'
'\x0e CROSSING GABA'
'\x0c CROSSING GU'
'\r CROSSING KA2'
'\x08 CURRENT'
'\x05 DEKA'
'\x0f DEYTEROU ICHOU'
'\r DIFFERENTIAL'
'\x0c DIMINUTION-'
'\r DIMINUTION-1'
'\x06 DIPLI'
'\x1b DIVIDED BY HORIZONTAL RULE'
'\x05 DOTS'
'\t DRACHMAS'
'\n ENCLOSURE'
'\x06 ENTRY'
'\t EQUAL TO'
'\x07 EQUALS'
'\x06 EQUID'
'\x03 FA'
'\x05 FACE'
'\x07 FLEXUS'
'\t FORM TWO'
'\t FROM BAR'
'\n FROM WALL'
'\x1a GAD OVER GAD GAR OVER GAR'
'\r GAR OVER GAR'
'\t GARSHUNI'
'\x05 GORA'
'\x07 GROUND'
'\x05 GUNU'
'\x05 HAA '
'\x08 HANDLES'
'\x06 HANDS'
'\x0e HASER FOR VAV'
'\x03 HE'
'\r HEADED ARROW'
'\x03 HU'
'\x08 HUNDRED'
'\x17 HUNDRED TWENTY-EIGHTH '
'\x07 HYPHEN'
'\x05 ILUT'
'\x03 IN'
'\x13 IN A RECTANGLE BOX'
'\x0c IN TRIANGLE'
'\x10 INSERTION POINT'
'\x0e ISOLATED FORM'
'\x05 JERA'
'\x02 K'
'\n KABA TENU'
'\x06 KAPAL'
'\x13 KASKAL U GUNU DISH'
'\x05 KAWI'
'\x07 KEFULA'
'\x08 KEMBANG'
'\x0e KISIM5 TIMES '
'\x05 LACA'
'\x11 LAGAB TIMES ASH2'
'\x11 LAGAR OVER LAGAR'
'\x04 LAI'
'\n LATE FORM'
'\x05 LEFT'
'\x06 LELET'
'\x06 LENGA'
'\x1a LESS THAN THE DENOMINATOR'
'\x05 LINE'
'\x0c LINE SYMBOL'
'\x06 LONGA'
'\x07 LONSUM'
'\x02 M'
'\n MAHAPRANA'
'\x05 MARK'
'\x05 MEGA'
'\x06 MELIK'
'\x07 MENDUT'
'\x07 MUQDAM'
'\x06 MURDA'
'\x1a NEGATED WITH VERTICAL BAR'
'\x04 NEO'
'\x04 NOT'
'\n NOTATION '
'\n NOTEHEAD '
'\x08 NUTILLU'
'\x03 OF'
'\x04 OF '
'\n OF DHARMA'
'\x04 OHM'
'\x10 ON BLACK SQUARE'
'\x0c ON PEDESTAL'
'\t OPENING '
'\t OPERATOR'
'\x0f OPERATOR WITH '
'\r OPPOSING KUR'
'\x04 OR '
'\x1a OR APPROXIMATELY EQUAL TO'
'\t OR EQUAL'
'\x0c OR EQUAL TO'
'\x10 OR THE IMAGE OF'
'\x08 OTTAVA '
'\t OVER BAL'
'\x0b OVER BULUG'
'\x16 OVER GAD GAR OVER GAR'
') OVER HI TIMES ASH2 KU OVER HI TIMES ASH2'
'\x0b OVER IDIM '
'\x12 OVER INVERTED SHU'
'\n OVER KAD5'
'\x08 OVER KG'
'\x0c OVER KISIM5'
'\x14 OVER LAGAR GUNU SHE'
'\t OVER LUM'
'\x07 OVER M'
'\x08 OVER MU'
'\t OVER NUN'
'\x19 OVER NUN LAGAR TIMES SAL'
'\x1d OVER RIGHTWARDS ARROW TO BAR'
'\x07 OVER S'
'\x0f OVER SIG4 SHU2'
'\x08 OVER SU'
'\x18 OVER TOP SQUARE BRACKET'
'\x14 OVER TUR ZA OVER ZA'
'\x0c OVER TWO PI'
'\x08 OVER ZI'
'\x02 P'
'\x0f PARESTIGMENON '
'\x07 PLOPHU'
'\x06 PLUS '
'\x07 PLUS A'
'\t PLUS ASH'
'\x08 PLUS DI'
'\x08 PLUS DU'
'\x08 PLUS EN'
'\t PLUS GUD'
'\x0f PLUS HI PLUS A'
'\t PLUS KU3'
'\x08 PLUS LA'
'\t PLUS LAL'
'\x08 PLUS LU'
'\x12 PLUS LU PLUS ESH2'
'\n PLUS MASH'
'\x0b PLUS MASH2'
'\x0b PLUS NUNUZ'
'\x08 PLUS RA'
'\x08 PLUS RU'
'\x11 PLUS SHA3 PLUS A'
'\n PLUS SHU2'
'\t PLUS SUM'
'\t PLUS TUR'
'\x0f POINTING INDEX'
'\x0b PROPORTION'
'\x11 PUNCTUATION MARK'
'\x06 QATAN'
'\x0f QUOTATION MARK'
'\x07 RAMBAT'
'\x08 RASWADI'
'\x05 REPA'
'\x05 REST'
'\n RESUPINUS'
'\n RGYA GRAM'
'\x04 RHO'
'\x06 RIGHT'
'\x08 ROTUNDA'
'\x03 SA'
'\x05 SARI'
'\n SCHROEDER'
'\n SEPARATOR'
'\x05 SHAD'
'\x0b SHOE STILE'
'\x05 SIGN'
'\x06 SIGN '
'\x0c SKEWED LEFT'
'\r SKEWED RIGHT'
'\x08 SLIDING'
'\x07 SLOWLY'
'\x06 SMALL'
'\x10 SOLIDUS OVERLAY'
'\x08 SQUARED'
'\x08 STATERS'
'\x07 STRIDE'
'\x03 SU'
'\x07 SYMBOL'
'\x05 TACK'
'\x0b TACK BELOW'
'\x05 TAIL'
'\x08 TALENTS'
'\x07 TEDUNG'
'\x05 TELU'
'\x05 TENU'
'\t THOUSAND'
'\x0f THROUGH CIRCLE'
'\x12 THROUGH DESCENDER'
'\x07 TIMES '
'\x08 TIMES A'
'\x10 TIMES A PLUS NA'
'\n TIMES BAD'
'\x08 TIMES E'
'\x0b TIMES ESH2'
'\t TIMES GA'
'\x10 TIMES GAN2 TENU'
'\x0f TIMES IGI GUNU'
'\r TIMES KASKAL'
'\n TIMES KUR'
'\n TIMES LAL'
'\n TIMES SHE'
'\x08 TIMES U'
'\x11 TO BLACK DIAMOND'
'\x06 TONE-'
'\t TROMIKON'
'\x08 TTUDDAG'
'" TWO DOTS OVER ONE DOT PUNCTUATION'
'\x02 U'
'\t UNDERBAR'
'\x03 UP'
'\x0b UPPER HALF'
'\r VARIANT FORM'
'\x05 WITH'
'\x06 WITH '
'\n WITH BASE'
'\x0b WITH CARON'
'\x0c WITH CIRCLE'
'\x12 WITH CIRCLE ABOVE'
'\x12 WITH CIRCLE BELOW'
'\x17 WITH CIRCUMFLEX ACCENT'
'\x0b WITH COMMA'
'\x12 WITH CROSSED-TAIL'
'\n WITH CURL'
'\x07 WITH D'
'\x0c WITH DAGESH'
'\x0b WITH DASIA'
'\x0f WITH DESCENDER'
'\x0f WITH DIAERESIS'
'\t WITH DOT'
'\n WITH DOT '
'\x0f WITH DOT ABOVE'
'\x10 WITH DOT INSIDE'
'\n WITH DOTS'
'\x19 WITH DOUBLE GRAVE ACCENT'
'\x14 WITH FATHATAN ABOVE'
'\x0e WITH FISHHOOK'
'\n WITH HOOK'
'\x14 WITH HORIZONTAL BAR'
'$ WITH HORIZONTAL MIDDLE BLACK STRIPE'
'\r WITH JEGOGAN'
'\x0e WITH LONG LEG'
'\x0b WITH MAPIQ'
'\r WITH OVERBAR'
'\x12 WITH PALATAL HOOK'
'\n WITH PLUS'
'\x14 WITH RETROFLEX HOOK'
'\x1d WITH REVERSED NEGATION SLASH'
'\x07 WITH S'
'\x13 WITH STRIKETHROUGH'
'\x0c WITH STROKE'
'\n WITH TAIL'
'\r WITH TEE TOP'
'\n WITH TICK'
'\x11 WITH TILDE ABOVE'
'\x0b WITH TITLO'
'\x0e WITH UNDERBAR'
'\r WITHOUT SNOW'
'\x07 WOLOSO'
'\x01-'
'\x02-0'
'\x02-2'
'\x11-9 QUOTATION MARK'
'\x02-A'
'\x05-ALAF'
'\x05-ARY '
'\x05-BEAM'
'\x0c-BREAK SPACE'
'\x10-BREAKING HYPHEN'
'\x0f-CARRIER LETTER'
'\x06-CREE '
'\x07-CREE R'
'\x08-CREE TH'
'\x0e-CURRENCY SIGN'
'\x0c-DZUD RTAGS '
'\r-ESASA DOTTED'
'\x0b-FEATHERED '
'\x1b-FEATHERED RIGHTWARDS ARROW'
'\x11-GAAHLAA TTUDDAAG'
'\x08-HEADED '
'\x1f-HEADED ARROW FROM SMALL CIRCLE'
'\x18-HEADED RIGHTWARDS ARROW'
'\x06-HIDET'
'\x06-HIEUH'
'\n-HIRAGANA '
'\x1e-HIRAGANA PROLONGED SOUND MARK'
'\x02-I'
'\x06-IEUNG'
'\x07-INDIC '
'\x08-KHIEUKH'
'\t-KHYUD PA'
'\x07-KIYEOK'
'\x0b-LINE STAFF'
'\n-LUE KARAN'
'\x07-MACRON'
'\x06-MINUS'
'\x0b-MINUS SIGN'
'\x02-O'
'\x04-ONE'
'\r-OR-PLUS SIGN'
'\r-PER-EM SPACE'
'\x08-PHIEUPH'
'\x06-PIEUP'
'\n-POINTING '
'\x10-POINTING ANGLE '
' -POINTING ANGLE BRACKET ORNAMENT'
'\x18-POINTING TRIANGLE WITH '
'\x15-ROUND NOTEHEAD DOWN '
'\x15-SHAPED BAG DELIMITER'
'\n-SHAPED HA'
'\x0c-SIMPLIFIED '
'\x05-SIOS'
'\t-STACCATO'
'\x0e-STEM TONE BAR'
'\x05-TAIL'
'\x03-TE'
'\x07-TIKEUT'
'\x02-U'
'\x04-UM '
'\x02-W'
'\x010'
'\x080 BRONZE'
'\x050 DWO'
'\x0b0 FOOTSTOOL'
'\x040 KO'
'\x040 MA'
'\x050 MAN'
'\x040 NI'
'\x050 OIL'
'\x040 PU'
'\x040 RA'
'\x070 SPEAR'
'\x030 U'
'\x070 WHEAT'
'\x110 WHEELED CHARIOT'
'\x040 WI'
'\x040 ZO'
'\x030-0'
'\x0207'
'\x0209'
'\x030B9'
'\x011'
'\x071 ARROW'
'\x081 BARLEY'
'\t1 CHARIOT'
'\x041 DA'
'\x041 DU'
'\x051 DWE'
'\x061 GOLD'
'\x081 HELMET'
'\x061 HORN'
'\x041 KU'
'\x031 O'
'\n1 PLASTICS'
'\x041 PO'
'\x041 QI'
'\x041 SA'
'\x041 SI'
'\x051 TWO'
'\x061 WINE'
'\x031-0'
'\x0211'
'\x03121'
'\x03155'
'\x0216'
'\x0218'
'\x0318D'
'\x021A'
'\x021D'
'\x012'
'\x0f2 CHARIOT FRAME'
'\t2 GARMENT'
'\x042 NO'
'\x072 OLIVE'
'\x042 PE'
'\n2 PLASTICS'
'\n2 PLUS ASH'
'\n2 PLUS GAL'
'\x0b2 PLUS GIR2'
'\x052 PTE'
'\x042 QO'
'\x042 RO'
'\x042 SO'
'\x042 WO'
'\x072 WOMAN'
'\x032-0'
'\x0220'
'\x0221'
'\x0222'
'\t247 DIPTE'
'\x03253'
'\x0229'
'\x022D'
'\x032DD'
'\x022F'
'\x013'
'\x043 A3'
'\x073 AREPA'
'\x083 ARMOUR'
'\x043 ME'
'\x043 MI'
'\x073 MONTH'
'\x043 MU'
'\x043 PA'
'\n3 PLASTICS'
'\x053 RA3'
'\x043 RI'
'\x073 SPICE'
'\x073 SWORD'
'\x073 WHEEL'
'\x033-0'
'\x03305'
'\x0234'
'\x0239'
'\x014'
'\x064 DART'
'\x064 DEER'
'\x044 DO'
'\x044 KE'
'\x044 NE'
'\n4 PLASTICS'
'\x044 TE'
'\x044 WA'
'\x044 ZE'
'\x034-0'
'\x0240'
'\x03439'
'\x024B'
'\x024D'
'\x024E'
'\x015'
'\x045 A2'
'\x045 AU'
'\t5 BATHTUB'
'\t5 CYPERUS'
'\x045 DE'
'\x045 JU'
'\x065 MERI'
'\x045 MO'
'\x045 NU'
'\n5 PLASTICS'
'\x045 TO'
'\x045 WE'
'\x065 WOOL'
'\x035-0'
'\x0250'
'\x0351F'
'\x0253'
'\x0255'
'\x03557'
'\x0256'
'\x0856 TURO2'
'\x016'
'\x046 JE'
'\x046 JO'
'\x046 NA'
'\n6 PLASTICS'
'\x046 QA'
'\x056 RA2'
'\x046 RU'
'\x056 TA2'
'\x066 TREE'
'\x036-0'
'\x03620'
'\x036D7'
'\x017'
'\x047 DI'
'\x047 JA'
'\x047 KA'
'\x067 KAPO'
'\x047 KI'
'\n7 PLASTICS'
'\x047 RE'
'\x047 TI'
'\x057 TWE'
'\x047 ZA'
'\x0270'
'\x0372C'
'\x0279'
'\x018'
'\x038 A'
'\x038 E'
'\x038 I'
'\x088 KANAKO'
'\x058 NWA'
'\x048 QE'
'\x058 RO2'
'\x048 SU'
'\x028C'
'\x038F0'
'\x019'
'\x079 CLOTH'
'\x049 PI'
'\x059 PU2'
'\x049 SE'
'\x049 TA'
'\x049 TU'
'\x04904A'
'\x0295'
'\x0299'
'\x039E3'
'\x01A'
'\x02A '
'\x07A -PHRU'
'\x06A HAAM'
'\x04A IE'
'\x07A NAME '
'\x11A PLUS HA PLUS DA'
'\nA PLUS IGI'
'\nA PLUS KUR'
'\nA TANG LAI'
'\x05A UNA'
'\x14A- SHOG GI MGO RGYAN'
'\x04A-HA'
'\x05A-ROL'
'\x02A0'
'\x02A2'
'\x02A4'
'\x02AA'
'\x05AADHU'
'\x03AAF'
'\x04AAFU'
'\x05AAMAE'
'\x04AAMU'
'\x03AAN'
'\x02AB'
'\nAB2 TIMES '
'\x08ABAAFILI'
'\x11ABBREVIATION MARK'
'\x11ABBREVIATION SIGN'
'\x04ABIC'
'\x04ABLE'
'\tABLED CAR'
'\x08ABOAFILI'
'\x04ABOR'
'\x05ABOVE'
'\x06ABOVE '
'\x11ABOVE EQUALS SIGN'
'\x12ABOVE GREATER-THAN'
'&ABOVE LEFTWARDS HARPOON WITH BARB DOWN'
'\x0fABOVE LESS-THAN'
"'ABOVE RIGHTWARDS HARPOON WITH BARB DOWN"
'\x15ABOVE SHORT DOWN TACK'
'\tABOVE TO '
'\x02AC'
'\x05ACCAT'
'\x06ACCENT'
'\x07ACCENT '
'\x03ACE'
'\tACE NOTE '
'\nACE SYMBOL'
'\x03ACH'
'\x0fACHES THE LIMIT'
'\x03ACK'
'\nACK CIRCLE'
'\x0bACKNOWLEDGE'
'\x08ACKSPACE'
'\x05ACRON'
'\x03ACT'
'\x07ACTION '
'\x05ACUTE'
'\x0cACUTE ACCENT'
'\x15ACUTE AND HOOK SYMBOL'
'\x0bACUTE-GRAVE'
'\x02AD'
'\x03AD3'
'\x03ADA'
'\nADAK BINDI'
'\x04ADDA'
'\nADDA WITH '
'\x05ADDAK'
'\x03ADE'
'\tADEG ADEG'
'\x04ADHE'
'\x04ADHU'
'\x10ADIAN SYLLABICS '
'\tADMA GDAN'
'\x03ADU'
'\x02AE'
'\nAEDA-PILLA'
'\x03AEF'
'\nAELA-PILLA'
'\x07AELAENG'
'\x03AEM'
'\x0bAESCULAPIUS'
'\x06AESURA'
'\x11AEUM ONE PLETHRON'
'\x02AF'
'\x08AF WITH '
'\x02AG'
'\x03AG-'
'\x04AGAB'
'\x0bAGAZ DAEG D'
'\x06AGE OF'
'\x05AGGER'
'\x1eAGGRAVATED INDEPENDENT SVARITA'
'\x03AGL'
'\x05AGMA '
'\tAGOLITIC '
'\x04AGON'
'\x06AGRANT'
'\x02AH'
'\x03AH '
'\x04AH I'
'\x08AH WITH '
'\x04AHAD'
'\x07AHAPAKH'
'\x08AHAPRANA'
'\x02AI'
'\x0eAI LENGTH MARK'
'\tAIGHTNESS'
'\x03AIL'
'\nAILED BIRD'
'\x0eAILLE PATTERN '
'\x0bAILLESS PHI'
'\x04AILM'
'\x06AILURE'
'\x03AIN'
'\x05AINS '
'\x06AISED '
'\tAISED DOT'
'\x16AISED OMISSION BRACKET'
'\x06AITING'
'\x08AIYANNOI'
'\tAJANYALAN'
'\x02AK'
'\x06AKABAT'
'\x03AKE'
'\x15AKIA TELOUS ICHIMATOS'
'\nAKKHANGYAO'
'\x04AKRA'
'\x02AL'
'\nAL BARLINE'
'\x0fAL INTERSECTION'
'\x07AL SIGN'
'\nAL SYMBOL '
'\x05AL TO'
'&AL WITH SUPERSCRIPT ALEF ISOLATED FORM'
'\x03AL2'
'\x03ALA'
'\x04ALAF'
'\x04ALAG'
'\x04ALAI'
'\x05ALAPH'
'\x15ALATALIZED HOOK BELOW'
'\x05ALATH'
'\x0fALAYHE ASSALLAM'
'\x03ALC'
'\x04ALDA'
'\x03ALE'
'\x08ALE SIGN'
'\x04ALEF'
'\x05ALEF '
'\nALEF LAMED'
'\rALEF MAKSURA '
'\x17ALEF MAKSURA FINAL FORM'
'\x1aALEF MAKSURA ISOLATED FORM'
'\x16ALEF WITH LAM WITH YEH'
'\nALENT SIGN'
'\x06ALENTS'
'\x05ALEPH'
'\x04ALES'
'\x07ALESMA '
'\x05ALETH'
'\x03ALF'
'\x05ALF H'
'\x0eALF TREE TRUNK'
'\x14ALF TRIANGULAR COLON'
'\x17ALGAMATION OR COPRODUCT'
'\tALI GALI '
'\x05ALING'
'\x03ALK'
'\x03ALL'
'\x04ALL '
'\x06ALL AA'
'!ALL BUT UPPER LEFT QUADRANT BLACK'
'\x0eALLAJALALOUHOU'
'\x05ALLEY'
'\x05ALLI '
'\x08ALLIANCE'
'\x15ALLING DIAGONAL SLASH'
'\x07ALLOT X'
'\x08ALLY EQU'
'\x0fALMOST EQUAL TO'
'\x07ALOCHKA'
'\x05ALOG '
'\tALPAPRANA'
'\x05ALPHA'
'\x03ALT'
'\x04ALTA'
'\x07ALTILLO'
'\x06ALTIRE'
'\x02AM'
'\x07AM ALEF'
'\x10AM ISOLATED FORM'
'\x07AMAKKAN'
'\x0fAMARITAN SOURCE'
'\x05AMATS'
'\x04AMBA'
'\x11AMBDA WITH STROKE'
'\x05AMBOO'
'\x04AMDA'
'\x03AME'
'\x04AME '
'\x07AME DOT'
'\x05AMED '
'\x05AMEKH'
'\x04AMIL'
'\x04AMLA'
'\x04AMMA'
'\x0eAMNUC PII KUUH'
'\x05AMOND'
'\x0fAMOUNT OF CHECK'
'\tAMPERSAND'
'\x11AMPHYLIAN DIGAMMA'
'\x04AMPI'
'\x08AMS HORN'
'\x02AN'
'\x07AN MARK'
'\x03AN2'
'\x03ANA'
'\x04ANA '
'\x04ANAP'
'\x04ANCH'
'\x06ANCHOR'
'\x03AND'
'\x04AND '
'\tAND ACUTE'
'\x0cAND CRESCENT'
'\x0fAND FEMALE SIGN'
'\x1eAND JOINED BY DASH WITH SUBSET'
'\x18AND MALE AND FEMALE SIGN'
'\x14AND NORTH EAST ARROW'
'\x14AND NORTH WEST ARROW'
'\x0cAND OPERATOR'
'\x0fAND PARALLEL TO'
'\x14AND SOUTH EAST ARROW'
'\x14AND SOUTH WEST ARROW'
'\x04ANDA'
'\x07ANDERER'
'\x08ANE TREE'
'\tANEROSIS '
'\x03ANG'
'\x04ANG '
'\x17ANG DEPARTING TONE MARK'
'\x0cANG KHANG GY'
'\x14ANGE ANTIRESTRICTION'
'\x06ANGKAT'
'\nANGKHANKHU'
'\x05ANGLE'
'\rANGLE BRACKET'
'\x06ANGUL '
'\x07ANGULAR'
'\nANGULAR TO'
'\rANNED LEATHER'
'\x0bANNOTATION '
'\x03ANO'
'\x08ANS SIGN'
'\nANS-SERIF '
'\x12ANS-SERIF CAPITAL '
'\x13ANS-SERIF CAPITAL L'
'\x06ANSIOS'
'\x13ANSPOSITION BRACKET'
'\x04ANT '
'\x0cANTARGOMUKHA'
'\tANTHAKHAT'
'\x13ANTICLOCKWISE ARROW'
'\x06ANUARY'
'\x08ANUDATTA'
'\x08ANUSVARA'
'\tAOS ICHOS'
'\x02AP'
'\tAP FILLER'
'\x03APA'
'\x07APEZIUM'
'\x03APH'
'\x06APISMA'
'\x06APITAL'
'\x07APITAL '
'\x08APITAL L'
'\x0eAPITAL LETTER '
'\x11APLI DYO DODEKATA'
'\x06APLI M'
'\x06APLOUN'
'\x04APON'
'\nAPOSTROPHE'
'\x04APPA'
'\x0bAPPROXIMATE'
'\tAPUN IYEK'
'\x07APYEOUN'
'\x0cAPYEOUNPIEUP'
'\x06APYRUS'
'\x02AR'
'\x04AR A'
'\x05AR AE'
'\x05AR B '
'\x0cAR DIAERESIS'
'\x08AR TSHES'
'\rAR WITH QUILL'
'\x04ARA '
'\x13ARABIC FORM SHAPING'
'\x1eARABIC LETTER TAH AND TWO DOTS'
'\x06ARADDO'
'\x12ARAGRAPH SEPARATOR'
'\nARAKALESMA'
'\x07ARALLEL'
'\x0cARALLELOGRAM'
'\nARANI SIGN'
'\x04ARB '
'\x06ARBUTA'
'\x03ARC'
'\x04ARC '
'\x17ARC ANTICLOCKWISE ARROW'
'\rARCHAIC KOPPA'
'\tARCHAIC M'
'\x08ARCHAION'
'\x07ARDNESS'
'\x07ARDROP-'
'\x13ARENTHESIS NOTEHEAD'
'\x05ARERU'
'\x05ARET '
'\x03ARG'
'\x04ARGA'
'\x05ARGE '
'\x0bARGE CIRCLE'
'\x0bARGE SQUARE'
'\x04ARGI'
'\rARGOSYNTHETON'
'\x04ARIA'
'\x08ARISTERA'
'\tARISTERA '
'\x04ARK '
'\x08ARKENING'
'\x15ARKENING OF THE LIGHT'
'\x08ARKLEAN '
'\rARLAUG SYMBOL'
'\x04ARON'
'\tAROSHTHI '
'\x0eAROUND-PROFILE'
'\x04ARP '
'\x0bARPEGGIATO '
'\x07ARRED B'
'\x07ARRED O'
'\x06ARRIER'
'\x05ARROW'
'\x06ARROW '
'\x0bARROW ABOVE'
'\rARROW OVERLAY'
'\x18ARROW POINTING DIRECTLY '
'\tARROWHEAD'
'\x06ARSEOS'
'\x08ARSI YEH'
'\x08ART SUIT'
'\x06ARTER '
'\x04ARTH'
'\x13ARTIAL DIFFERENTIAL'
'\x08ARTYRIA '
'\x03ARU'
'\x14ARXIS KAI FTHORA VOU'
'\x15ARYSTIAN FIVE HUNDRED'
'\x02AS'
'\x03AS '
'\tAS MEMBER'
'\x07AS SIGN'
'\x03ASE'
'\x0bASE TO THE '
'\x05ASEIA'
'\x07ASES AS'
'\x03ASH'
"'ASH FROM LEFT MEMBER OF DOUBLE VERTICAL"
'\x04ASH2'
'\x0bASHED ARROW'
'&ASHED TRIANGLE-HEADED RIGHTWARDS ARROW'
'\x06ASHGAB'
'\x04ASIA'
'\x05ASKAL'
'\x04ASLA'
'\x13ASOUL ISOLATED FORM'
'\x05ASPER'
'\x06ASSING'
'\x08AST WIND'
'\nASTERISCUS'
'\x08ASTERISK'
'\x1cASTERISKS ALIGNED VERTICALLY'
'\x11ASTERN PWO KAREN '
'\x08ASTERN W'
'\x12ASTROLOGICAL SIGN '
'\x03ASU'
'\x07ASURED '
'\x07ASUTORU'
'\x02AT'
'\x03AT '
'\x0fATA LINK ESCAPE'
'\x05ATAF '
'\x08ATAKANA '
'\nATAKANA DE'
'\x03ATE'
'\x08ATE MARK'
'\x04ATER'
'\nATER-THAN '
'\x03ATH'
'\x08ATH MARK'
'\x04ATHA'
'\tATHAMASAT'
' ATHARVAVEDIC INDEPENDENT SVARITA'
'\x08ATHERING'
'\x11ATHERING TOGETHER'
'\x03ATI'
'\x04ATIM'
'\x05ATIN '
'\x12ATIN SMALL LETTER '
'\x0fATINATE MYSLITE'
'\x0bATION POINT'
'\x05ATIYA'
'\x0cATNAH HAFUKH'
'\nATRICHISMA'
'\x06ATTIC '
'\x04ATTO'
'\x0cATTOOED HEAD'
'\x07ATURAL '
'\x02AU'
'\x0eAU LENGTH MARK'
'\x11AUKAZ LAGU LOGR L'
'\x04AULA'
'\x07AULDRON'
'\x07AUNTLET'
'\x05AUTHS'
'\x06AUTUMN'
'\x02AV'
'\x03AVA'
'\x08AVAGRAHA'
'\x03AVE'
'\nAVE ACCENT'
'\tAVE ARROW'
'\x07AVIYANI'
'\x05AVROS'
'\x08AVY BAND'
'\x02AW'
'\x03AW '
'\rAWELLEMET YAZ'
'\x05AXIMA'
'\x07AXIMATA'
'\x02AY'
'\x03AY '
'\x07AY SIGN'
'\x07AYALAM '
'\x06AYANNA'
'\x03AYB'
'\x12AYHE ISOLATED FORM'
'\x04AYIN'
'\x03AZU'
'\x01B'
'\tB DIGRAPH'
'\x02B0'
'\x03B00'
'\x02B2'
'\x10B2 TENU PLUS TAB'
'\x03B57'
'\x02B6'
'\x03B89'
'\x02BA'
'\x03BAA'
'\x05BAARU'
'\x08BACK YER'
'\tBACKSLASH'
'\rBACKSLASH BAR'
'\x03BAD'
'\x06BAFILI'
'\x0eBAG MEMBERSHIP'
'\x0cBAHIRGOMUKHA'
'\x07BAIRKAN'
'\x05BALAG'
'\x17BALLOON-SPOKED ASTERISK'
'\x06BALUDA'
'\x07BAMBOOS'
'\x03BAN'
'\x04BANG'
'\x0bBANK SYMBOL'
'\x06BANWA '
'\x03BAR'
'\x04BAR '
'\tBAR ABOVE'
'\x16BAR ABOVE INTERSECTION'
'\x0fBAR ABOVE UNION'
'\x05BARB '
'\x17BARBED RIGHTWARDS ARROW'
'\x07BARLINE'
'\x06BARREE'
'\x07BARREKH'
'\x04BASA'
'\x05BASA '
'\tBASE UNIT'
'\x04BASH'
'\x05BASSA'
'\x08BATBEIT '
'\x03BAU'
'\x07BAYANNA'
'\x02BB'
'\x10BBREVIATION MARK'
'\x10BBREVIATION SIGN'
'\x02BE'
'\x07BE ROOT'
'\x04BEAM'
'\x03BEE'
'\x06BEFILI'
'\x06BEGIN '
'\x03BEH'
'\x05BEITH'
'\x0fBELGTHOR SYMBOL'
'\x05BELOW'
'\x06BELOW '
'\x0fBELOW LONG DASH'
'\x03BEN'
'\x04BEND'
'\x05BENDE'
'\x04BER '
'\x11BERBER ACADEMY YA'
'\x04BERD'
'\x18BERKANAN BEORC BJARKAN B'
'\x07BESIDE '
'#BESIDE AND JOINED WITH INTERSECTION'
'\x1cBESIDE AND JOINED WITH UNION'
'\x15BESIDE RIGHT TRIANGLE'
'\x03BET'
'\x04BETA'
'\x0bBETA SYMBOL'
'\x06BETAN '
'\x04BETH'
'\x08BEVERAGE'
'\x03BHA'
'\x05BHADH'
'\x05BHETH'
'\x02BI'
'\x03BIB'
'\x03BIE'
'\x07BIG YUS'
'\x03BIN'
'\x0fBINARY RELATION'
'\x05BINDI'
'\x0fBINDING BRACKET'
'\x07BINING '
'\x16BINING GEMINATION MARK'
'\x0cBINING MARK '
'\x04BIRD'
'\x05BIRGA'
'\x05BISAH'
'\x06BISHOP'
'\tBJARKAN B'
'\x0fBJOINED LETTER '
'\tBKHASIAN '
'\x03BLA'
'\x05BLACK'
'\x06BLACK '
'\x0bBLACK ARROW'
'\x0cBLACK CIRCLE'
'\x18BLACK LENTICULAR BRACKET'
'\x11BLACK SHOGI PIECE'
'\x0cBLACK SQUARE'
'\nBLACK STAR'
'\x0eBLACK TRIANGLE'
'\x0eBLADE SCISSORS'
'\x05BLANK'
'\x03BLE'
'\x08BLINEAR '
'\x05BLOCK'
'\x02BO'
'\tBO BAIMAI'
'\tBO GYFU G'
'\x06BOFILI'
'\x08BOL FOR '
'\x08BOL SIGN'
'\x05BOLD '
'\x04BORE'
'\x06BOTTOM'
'\x07BOTTOM '
'\rBOTTOM CORNER'
'\x11BOTTOM HALF BLACK'
'\x10BOTTOM HALF RING'
'\x0bBOTTOM MARK'
'#BOTTOM-LIGHTED RIGHTWARDS ARROWHEAD'
'\x07BOURING'
'\x04BOVE'
'\x05BOVE '
'\x06BOWTIE'
'\x03BOX'
'\x02BR'
'\x03BRA'
'\x07BRACKET'
'\x11BRACKET EXTENSION'
'\x10BRACKET ORNAMENT'
'\x1bBRDA RNYING YIG MGO MDUN MA'
'\x1bBRDA RNYING YIG MGO SGAB MA'
'\x05BREVE'
'\x0bBREVE BELOW'
'\x07BREVIS '
'\x05BREW '
'\nBROKEN BAR'
'\tBRUL SHAD'
'\x02BS'
'\x0cBSCRIPT ALEF'
'\x04BSET'
'\x07BSET OF'
'\x14BSET OF NOR EQUAL TO'
'\nBSTRUCTION'
'\x03BU '
'\x06BULLET'
'\x0bBUMPY ABOVE'
'\x08BUNDANCE'
'\x03BUR'
'\x03BUT'
'\x19BUT NOT ACTUALLY EQUAL TO'
'\x0bBUT NOT EQU'
'\x15BUT NOT EQUIVALENT TO'
'\x03BWA'
'\x03BXG'
'\x02BY'
'\rBY DEFINITION'
'\x0cBYSMAL WATER'
'\x0bBZHI -KHYIL'
'\x0cBZHI MIG CAN'
'\x01C'
'\x03C A'
'\x06C CLEF'
'\x13C DIGRAPH WITH CURL'
'\x16C GREATER-THAN BRACKET'
'\x13C LESS-THAN BRACKET'
'\nC WITH DOT'
'\x02C-'
'\x02C0'
'\x02CA'
'\x03CA9'
'\x05CAANG'
'\x05CAKRA'
'\x03CAL'
'\x11CAL SYMBOL BOTTOM'
'\x06CALATE'
'\x05CALYA'
'\x0bCAN RGYINGS'
'\x11CANCELLATION MARK'
'\x08CANDICUS'
'\x06CANDRA'
'\x07CANDRA '
'\x0cCANDRA BELOW'
'\x0bCANDRABINDU'
'\tCANG TE-U'
'\x12CANTILLATION SIGN '
'\x08CAPITAL '
'\tCAPITAL D'
'\tCAPITAL F'
'\tCAPITAL L'
'\x0fCAPITAL LETTER '
'\tCAPITAL Q'
'\x05CARET'
'\x0bCARET TILDE'
'\x06CARIK '
'\x05CARON'
'\x04CART'
'\x06CATAWA'
'\x05CAUDA'
'\x05CAUSE'
'\x07CAYANNA'
'\x04CAYN'
'\x02CC'
'\x06CCEEDS'
'\x05CCENT'
'\tCCER BALL'
'\x0bCCUMULATION'
'\x02CE'
'\x13CE OF INTEREST SIGN'
'\x08CE SKATE'
'\x05CECAK'
'\x05CECEK'
'\x05CEDES'
'\x0bCELANDIC-YR'
'\x07CELSIUS'
'\x0cCENDING NODE'
'\tCENT SIGN'
'\x07CENTRE '
'\x14CENTRE VERTICAL LINE'
'\x0eCENTURIAL SIGN'
'\x06CER-WA'
'\x05CEREK'
'\x03CES'
'\x02CH'
'\x03CH '
'\x03CHA'
'\nCHAD RTAGS'
'\x05CHADA'
'\x06CHADIN'
'\x0cCHAIR SYMBOL'
'\x06CHAMKO'
'\x08CHATTAWA'
'\tCHAVIYANI'
'\x03CHE'
'\x05CHECK'
'\nCHECK MARK'
'\x05CHED '
'\x04CHEE'
'\x04CHEH'
'\x08CHEIKHEI'
'\x07CHEINAP'
'\x06CHEMA '
'\x03CHI'
'\x07CHIEUCH'
'\x04CHIL'
'\x06CHIRET'
'\tCHMA SIGN'
'\x06CHO CH'
'\x05CHOOL'
'\x04CHOR'
'\tCHOSEONG '
'\x06CHRIVI'
'\rCHROMA SYNAFI'
'\rCHRYSANTHEMUM'
'\x07CHU CAN'
'\x05CHULA'
'\x06CHURCH'
'\x04CHWA'
'\x0cCIAN LETTER '
'\x05CIEUC'
'\x03CIG'
'\x06CIMAL '
'\x06CIRCLE'
'\x07CIRCLE '
'\rCIRCLE INSIDE'
'\x1bCIRCLE WITH NORTHWEST ARROW'
'\x08CIRCLED '
'\x0cCIRCLED PLUS'
'\x13CIRCLED SANS-SERIF '
'\x0fCIRCUIT-OUTPUT '
'\nCIRCUMFLEX'
'\x10CIRCUMFLEX ABOVE'
'\x11CIRCUMFLEX ACCENT'
'\x17CIRCUMFLEX ACCENT ABOVE'
'\nCISIVENESS'
'\x07CISSORS'
'\x16CJK UNIFIED IDEOGRAPH-'
'\x02CK'
'\x07CK MARK'
')CK-TILTED SHADOWED WHITE RIGHTWARDS ARROW'
'\x05CKING'
'\x06CKNESS'
'\x07CKWISE '
'\x05CLICK'
'\x05CLIFF'
'\x1aCLOCKWISE ARROW WITH MINUS'
'\x0fCLOSED BY CURVE'
'\x11CLOSED LITTLE YUS'
'\tCLOSED PL'
'\x08CLOSED T'
'\x07CLOSURE'
'\x14CLUB-SPOKED ASTERISK'
'\x02CO'
'\x05COLON'
'\x0eCOLON OPERATOR'
'\x03COM'
'\nCOMBINING '
'\x05COMMA'
'\x0bCOMMA ABOVE'
'\x1dCOMMA QUOTATION MARK ORNAMENT'
'\x18COMPATIBILITY IDEOGRAPH-'
'\tCOMPLETED'
'\x0bCOMPOSITION'
'\x04COND'
'\x05COND '
'\x18CONSECUTIVE EQUALS SIGNS'
'\x0fCONSONANT SIGN '
'\x14CONSONANT SIGN HAARU'
'\x11CONSONANT SIGN PA'
'\x0bCONTAIN AS '
'\x1eCONTAINING BLACK SMALL DIAMOND'
'\x1dCONTAINING BLACK SMALL SQUARE'
'\x1bCONTINUOUS UNDERLINE SYMBOL'
'\x11CONTOURED OUTLINE'
'\x03COO'
'\x07COPTIC '
'\x06CORNER'
'\x0eCORNER BRACKET'
'\x10CORNER DOWNWARDS'
'\x10CORNER LEFTWARDS'
'\x0fCORNER WITH DOT'
'\x08COUNCIL '
'\x08COUNT OF'
'\x08COUNTERS'
'\x02CR'
'\x03CR '
'\x06CREASE'
'\x0bCREDIT SIGN'
'\x05CREEN'
'\tCRESCENDO'
'\x04CRET'
'\x0eCRIFICIAL WINE'
'\x06CRIPT '
'\rCRIPTION TAKE'
'\rCRIPTIONAL PA'
'\x08CRO SIGN'
'\x04CRON'
'\nCROPHONIC '
'\x05CROSS'
'\x11CROSS PUNCTUATION'
'\tCROSSING '
'\x0bCROSSING BU'
'\x0bCROSSING EN'
'\rCROSSING GAN2'
'\x0bCROSSING GI'
'\x0cCROSSING GI4'
'\rCROSSING GISH'
'\x0bCROSSING IM'
'\x0cCROSSING KAL'
'\x0cCROSSING LU2'
'\rCROSSING MUSH'
'\x19CROSSING NORTH EAST ARROW'
'\x0cCROSSING NUN'
'\x0bCROSSING PI'
'\x0bCROSSING UR'
'\x0cCSIMILE SIGN'
'\x02CT'
'\x11CTION APPLICATION'
'\nCTION MARK'
'\x15CTOR OR CROSS PRODUCT'
'\nCTORY HAND'
'\x05CTRIC'
'\tCUBE ROOT'
'\x05CUBED'
'\x07CULAR O'
'\x18CULINE ORDINAL INDICATOR'
'\x04CURL'
'\rCURLY BRACKET'
'\x16CURLY BRACKET ORNAMENT'
'\tCURRENCY '
'\x14CURRENCY SYMBOL RIEL'
'\x07CURVED '
'\x14CURVED ANGLE BRACKET'
'\x04CUTE'
'\x0bCUTE ACCENT'
'\x02CW'
'\x03CWA'
'\x04CWAA'
'\x03CWI'
'\x03CYA'
'\x04CYCL'
'\x01D'
'\x02D '
'\rD COMMA ABOVE'
'\x04D HA'
'\x07D MOUTH'
'\x05D OF '
'\nD OF PROOF'
'\x08D RIGHT '
'\tD SALTIRE'
'\x08D SYMBOL'
'\x07D WITH '
'\nD WITH DOT'
'\x02D0'
'\x03D42'
'\x03D70'
'\x02DA'
'\x03DA '
'\nDA PLUS HA'
'\x03DAA'
'\tDAD WITH '
'\x06DAGESH'
'\x0fDAGESH OR MAPIQ'
'\x04DAGS'
'\x04DAIR'
'\x04DAL '
'\x05DALAT'
'\x05DALET'
'\x06DALETH'
'\x05DAMMA'
'\x05DANDA'
'\x07DANESE '
'\x08DANTAJA '
'\x03DAP'
'\x03DAR'
'\x04DASH'
'\nDASH ARROW'
'\x05DASIA'
'\x0eDASIA PNEUMATA'
'\x05DATUS'
'\x07DAYANNA'
'\x02DD'
'\nDDAH ABOVE'
'\x02DE'
'\x0cDE MARK SIGN'
'\x03DE6'
'\x04DEAD'
'\x07DEAVOUR'
'\x03DEE'
'\x03DEG'
'\x03DEK'
'\x04DEL '
'\tDELIMITER'
'\x15DELIMITER TSHEG BSTAR'
'\x11DELPHIC FIVE MNAS'
'\x04DELT'
'\x05DELTA'
'\x05DENCE'
'\x13DENOMINATOR SIXTEEN'
'\x0cDENTAL CLICK'
'\x11DENTAL PERCUSSIVE'
'\tDEOGRAPH '
'\x06DERBAR'
'\x06DERMA '
'\x03DES'
'\tDESCENDER'
'\x0fDESCENDING TONE'
'\x05DESTY'
'\x10DEWAYS U BRACKET'
'\x05DEXIA'
'\x0eDEYTEROS ICHOS'
'\x1bDGE-TAILED RIGHTWARDS ARROW'
'\x04DGER'
'\x03DHA'
'\x05DHADH'
'\x07DHALATH'
'\x03DHE'
'\x02DI'
'\x0fDI ALLAHOU ANHU'
'\tDIAERESIS'
'\x19DIAERESIS AND HOOK SYMBOL'
'\rDIAERESIZED U'
'\tDIAGONAL '
'\x18DIAGONAL CROSSHATCH FILL'
'\x13DIAGONAL HALF BLACK'
'\x0fDIAGONAL STROKE'
'\x05DIAL '
'\x0fDIALYTIKA TONOS'
'\x07DIAMOND'
'\x05DIAN '
'\x07DIARGON'
'\nDIATONIKI '
'\x0bDIATONON DI'
'\x03DIB'
'\x04DIC '
'\x06DICINE'
'\x06DIESIS'
'\x08DIFONIAS'
'\x05DIGA '
'\x0fDIGA AELA-PILLA'
'\x07DIGAMMA'
'\x06DIGIT '
'\nDIGIT ZERO'
'\x15DIGRAMMOS EX DODEKATA'
'\x07DIGRAPH'
'\x0cDIGRAPH KOTO'
'\x0cDIGRAPH YORI'
'\x03DIM'
'\x04DIM2'
'\x03DIN'
'\x05DIPLI'
'\x07DIPLOUN'
'!DIRECT PRODUCT WITH BOTTOM CLOSED'
'\x14DIRECT QUESTION MARK'
'\nDIRGA MURE'
'\x04DISH'
'\x07DISIMOU'
'\x10DITORIAL CORONIS'
'\x05DIUM '
'\x06DIVIDE'
'>DIVIDED BY HORIZONTAL BAR AND TOP HALF DIVIDED BY VERTICAL BAR'
'\x03DJA'
'\x05DKAR '
'\x04DLE '
'\x07DLE DOT'
'\x03DMA'
'\x02DO'
'\x03DO '
'\x0bDOACHASHMEE'
'\x0eDOES NOT EXIST'
'\x07DOFONON'
'\x06DOKMAI'
'\x0bDOLLAR SIGN'
'\x16DOMAIN ANTIRESTRICTION'
'\x03DON'
'\x0bDONG TSHUGS'
'\x03DOT'
'\x04DOT '
'\tDOT ABOVE'
'\tDOT BELOW'
'\x17DOT BELOW AND DOT ABOVE'
'\x1eDOT BELOW AND THREE DOTS ABOVE'
'\x0cDOT OPERATOR'
'\x1dDOT OVER TWO DOTS PUNCTUATION'
'\x14DOTLESS HEAD OF KHAH'
'\x1dDOTS OVER ONE DOT PUNCTUATION'
'\x05DOTS-'
'\x06DOTTED'
'\x07DOTTED '
'\x1bDOTTED INTERPOLATION MARKER'
'\x1aDOTTED LUNATE SIGMA SYMBOL'
'\x1aDOTTED SUBSTITUTION MARKER'
'\rDOTTED ZLAMA '
'\x07DOUBLE '
'\x0bDOUBLE AND '
'\x14DOUBLE ANGLE BRACKET'
'\x1bDOUBLE ANGLE QUOTATION MARK'
'\x11DOUBLE ARCH BELOW'
'\x0cDOUBLE ARROW'
'\x19DOUBLE CANDRABINDU VIRAMA'
'\rDOUBLE CIRCLE'
'\x10DOUBLE DOT ABOVE'
'\x14DOUBLE DOT TONE MARK'
'\x10DOUBLE HEAD MARK'
'\rDOUBLE HYPHEN'
'\x15DOUBLE LEFT TURNSTILE'
'\rDOUBLE MUCAAD'
'\x1bDOUBLE PRIME QUOTATION MARK'
'\x12DOUBLE PUNCTUATION'
'\x0bDOUBLE SHAD'
'\x16DOUBLE SOLIDUS OVERLAY'
'\rDOUBLE STROKE'
'\x10DOUBLE TURNSTILE'
'\x16DOUBLE VERTICAL STROKE'
'$DOUBLE-LINE EQUAL ABOVE GREATER-THAN'
'!DOUBLE-LINE EQUAL ABOVE LESS-THAN'
'\x0eDOUBLE-STRUCK '
'\x0cDOWED WHITE '
'\x04DOWN'
'\x05DOWN '
'\tDOWN AND '
'\x13DOWN AND HORIZONTAL'
'\nDOWN ARROW'
'\x14DOWN ARROWHEAD BELOW'
'\x0cDOWN HARPOON'
'\nDOWN HEAVY'
'\x1cDOWN HEAVY AND LEFT UP LIGHT'
'\x1dDOWN HEAVY AND RIGHT UP LIGHT'
'\x15DOWN HORIZONTAL HEAVY'
'\x15DOWN HORIZONTAL LIGHT'
'\nDOWN LIGHT'
'\x10DOWN RIGHT BARB '
'\tDOWN TACK'
'\x12DOWN-OUTPUT SYMBOL'
'\tDOWNWARDS'
'\x1eDOWNWARDS AND RIGHTWARDS ARROW'
'\x0fDOWNWARDS ARROW'
'!DOWNWARDS HARPOON WITH BARB RIGHT'
'\x17DOWNWARDS THEN CURVING '
'\x16DOWNWARDS ZIGZAG ARROW'
'\x02DR'
'\x07DRACHMA'
'\x06DRAGON'
'\x16DRESSED TO THE SUBJECT'
'\x07DRIL BU'
'\x1aDROP-SHADOWED WHITE SQUARE'
'\x19DRY MEASURE FIRST SUBUNIT'
'\x08DS-CREE '
'\x17DSTONE GRAVEYARD SYMBOL'
'\x02DU'
'\x03DUG'
'\x03DUN'
'\tDUN3 GUNU'
'\x03DUR'
'\tDUS RTAGS'
'\x06DVANCE'
'\x08DVISVARA'
'\x02DY'
'\x0bDYO CHRONON'
'\x03DZE'
'\x01E'
'\x02E '
'\x07E FACE-'
'\x05E GEE'
'\x1aE ONE-WAY LEFT WAY TRAFFIC'
'\x0fE OVER INFINITY'
'\x18E PLUS A PLUS SU PLUS NA'
'\tE PLUS EN'
'\nE PLUS SUM'
'\tE TSA CAN'
'\x06E WAVE'
'\x02E0'
'\x02E2'
'\x02EA'
'\x04EACE'
'\x03EAF'
'\x05EAGLE'
'\x0cEAGULL BELOW'
'\x06EAHMUK'
'\x03EAN'
'\x11EAR SCREEN SYMBOL'
'\x08EAR SIGN'
'\tEARDROP-S'
'\nEARLY FORM'
'\x05EARTH'
'\nEARTH MARK'
'\x05EAST '
'\x06EASURE'
'\x03EAT'
'\x04EAT '
'\x0fEATER-THAN SIGN'
'\x04EATH'
'\x0cEATH PRODUCT'
'\x06EATHER'
'\x05EAVEN'
'\rEAVENLY EARTH'
'\x0bEAVER DENE '
'\tEAVY DOWN'
'\x1bEAVY WHITE RIGHTWARDS ARROW'
'\x07EAVY YA'
'\x08EBEEFILI'
'\nEBENSTIMME'
'\tEBIT SIGN'
'\x05ECEDE'
'\x06ECEDES'
'\x07ECEMBER'
'\x03ECH'
'\x08ECH YIWN'
'\x10ECIMAL SEPARATOR'
'\x08ECTANGLE'
'\x06ECTION'
'\x0bECTION MARK'
'\x02ED'
'\x03ED '
'-ED DOUBLE VERTICAL BAR DOUBLE RIGHT TURNSTILE'
'\x0bED EQUAL TO'
'\nED FIGURE-'
'\x0fED PAPER SYMBOL'
'\x0eED PARAGRAPHOS'
'\tEDESTRIAN'
'\x1cEDGE-TAILED RIGHTWARDS ARROW'
'\x06EDIAL '
'\nEDIAL FORM'
'\x06EDILLA'
'\x06EDIUM '
'\x05EDUNG'
'\x02EE'
'\x03EEE'
'\x04EEEE'
'\x04EEK '
'\x03EEL'
'\x05EEM I'
'\tEEM WITH '
'\x03EEN'
'\tEEN WITH '
'\x04EENG'
'\x06EENTH '
'\x04EENU'
'\x0cEEPING SMALL'
'\x04EESU'
'\x04EETA'
'\x02EF'
'\x03EF '
'\x10EFORE COMPLETION'
'\x03EFT'
'\x04EFT '
'\x1cEFT ARC GREATER-THAN BRACKET'
'\x0eEFT HALF BLACK'
'\x08EFT HOOK'
'\x15EFT OPEN BOX OPERATOR'
'\x0fEFT PARENTHESIS'
'\x0fEFT REPEAT SIGN'
'\x13EFT-POINTING ANGLE '
'!EFT-POINTING ANGLE QUOTATION MARK'
'\x0fEFTWARDS ARROWS'
'\x1fEFTWARDS HARPOON WITH BARB DOWN'
'\x1dEFTWARDS HARPOON WITH BARB UP'
'\rEFTWARDS TICK'
'\x03EGA'
'\x05EGALI'
'\x06EGEAN '
'\x05EGIN '
'\x05EGION'
'\x05EGL H'
'\x04EGOL'
'\x08EGORIAN '
'\x02EH'
'\x03EH '
'\x0fEH INITIAL FORM'
'\x08EH WITH '
'&EH WITH SUPERSCRIPT ALEF ISOLATED FORM'
'\x04EHEH'
'\x03EHI'
'\x02EI'
'\x03EI '
'\nEICH STARK'
'\x03EIE'
'\x05EIGHT'
'\x06EIGHT '
'\x06EIGHTH'
'\x0cEIGHTH BLOCK'
'\x0cEIGHTH NOTES'
'\x07EIGHTHS'
'\rEIGHTHS BLOCK'
'\x06EIGHTY'
'\x06EILING'
'\x04EIRT'
'\x03EIS'
'\x05EISMA'
'\x04EIWS'
'\x02EK'
'\x03EK '
'\x08EK ONKAR'
'\x04EKAA'
'\x0bEKFONITIKON'
'\x02EL'
'\x07EL PUMP'
'\x15ELATIONAL COMPOSITION'
'\x03ELD'
'\x08ELEPHONE'
'\x03ELF'
'\x03ELL'
'\x07ELLIPSE'
'\x08ELLIPSIS'
'\tELLOWSHIP'
'\x05ELMET'
'\x03ELS'
'\x03ELT'
'\nELT BUCKLE'
'\x04ELTA'
'\x04ELVE'
'\x17ELVE POINTED BLACK STAR'
'\x02EM'
'\x05EMALE'
'\x06EMASTI'
'\tEMBEDDING'
'\x1bEMICIRCULAR CLOCKWISE ARROW'
'\x08EMICOLON'
'\x11EMICOLON UNDERBAR'
'\x11EMIDIRECT PRODUCT'
'\x0cEMISOFT SIGN'
'\x03EMK'
'\x06EMKATH'
'\x05EMLJA'
'\x06EMOLO-'
'\rEMPHATIC TONE'
'\tEMPTY SET'
'\x06EMPUS '
'\x02EN'
'\x06EN BOX'
'\x0cEN FULL STOP'
'\x06EN GHE'
'\x10EN MILLIONS SIGN'
'\x07EN SIGN'
'\x05ENANO'
'\x0cENARIUS SIGN'
'\x14ENARMONIOS ANTIFONIA'
'\x04ENAT'
'\x0fENCH FRANC SIGN'
'\x03END'
'\x0eEND OF SECTION'
'\x0eENDED MULTIMAP'
'\x05ENDEP'
'\x05ENENG'
'\nENETRATION'
'\x03ENG'
'\x0bENG DIGRAPH'
'\x06ENIKI '
'\x0cENOS CHRONOU'
'\x03ENT'
'\x08ENT SIGN'
'\x07ENTAGON'
'\x1bENTATION FORM FOR VERTICAL '
'\x12ENTERING TONE MARK'
'\x04ENTH'
'\x0bENTHESIZED '
'\nENTHUSIASM'
'\x06ENTIMA'
'\x06ENTION'
'\x05ENTRE'
'\x10ENTRE WHITE STAR'
'\x07ENTRED '
'\x04ENTY'
'\x03ENU'
'\x10ENUMERATION SIGN'
'\x05ENUTO'
'\x02EO'
'\x05EO-EU'
'\nEONGCHIEUM'
'\x0bEORGIAN NAR'
'\x03EOW'
'\x02EP'
'\x05EPEAT'
'\x0eEPENTHETIC YUT'
'\x03EPH'
'\x07EPHONE '
'\x0bEPIDAUREAN '
'\x12EPIGRAPHIC LETTER '
'\x0eEPSILON SYMBOL'
'\x10EPSILON UNDERBAR'
'\x03EQU'
'\x05EQUAL'
'\x06EQUAL '
'\x08EQUAL TO'
'\x0cEQUAL TO OR '
'\x18EQUAL TO OR GREATER-THAN'
'\x15EQUAL TO OR LESS-THAN'
'\x06EQUALS'
'\x0bEQUALS SIGN'
'\x02ER'
'\x03ER '
'\x15ER RIGHT CORNER ANGLE'
'\x07ER THAN'
'\x08ER TRUTH'
'\x08ERAL URN'
'\x0bERCENT SIGN'
'\x07ERCIAL '
'\tERCIAL AT'
'\x06ERESIS'
'\x04ERET'
'\x05ERET '
'\x0eERIC INDICATOR'
'\x05ERIN2'
'\nERISPOMENI'
'\x05ERKHA'
'\x06ERMATA'
'\x05ERN W'
'\x08ERO SIGN'
'\nERO WIDTH '
'\x0cERPENDICULAR'
'\x05ERSON'
'\x0cERTICAL LINE'
'\x05ERTIE'
'\rERTION SYMBOL'
'\tERTY LINE'
'\x03ERU'
'\x07ES NOT '
'\tESAME DOT'
'\x03ESC'
'\x08ESCENDER'
'\x07ESCENDO'
'\x03ESH'
'\x0bESH DIGRAPH'
'\x08ESH LOOP'
'\x04ESH2'
'\x05ESHE3'
'\x06ESHTIN'
'\x03ESI'
'\x0fESIDE LESS-THAN'
'\x05ESIS '
'\x0bESMILO SIGN'
'\x05ESO E'
'\x03ESS'
'\x17ESS OUTLINED WHITE STAR'
'\x08ESS-THAN'
'\x0fESSARON CHRONON'
'\x04EST '
'\x08EST WIND'
'\x11ESTERN PWO KAREN '
'\x06ESTION'
'\x0bESTION MARK'
'\x07ESTIVAL'
'\x02ET'
'\x03ET '
'\x13ET WITH WHITE CROSS'
'\x03ETA'
'\x08ETA SIGN'
'\nETA SYMBOL'
'\x04ETAL'
' ETALLED BLACK AND WHITE FLORETTE'
'\x1fETALLED OUTLINED BLACK FLORETTE'
'\x0cETARTIMORION'
'\x08ETARTOS '
'\x0bETEI MAYEK '
'\tETER SIGN'
'\x03ETH'
'\x05ETION'
'\x07ETNAHTA'
'\x05ETORU'
'\x08ETRASEME'
'\tETRASIMOU'
'\x0cETRETES SIGN'
'\rETROFLEX HOOK'
'\nETTA-PILLA'
'\x06ETTER '
'\x05ETTI '
'\x02EU'
'\x04EUCH'
'\x07EULEUNG'
'\x04EUNG'
'\nEUR-DE-LIS'
'\nEUTRAL YER'
'\x03EUX'
'\x03EVA'
'\nEVANAGARI '
'\x03EVE'
'\x04EVEN'
'\x05EVEN '
'\x08EVEN OF '
'\x13EVEN POWERS OF FOUR'
'\x05EVENT'
'\x08EVENTEEN'
'\x12EVENTEEN FULL STOP'
'\x06EVENTH'
'\x06EVENTY'
'\x08EVERANCE'
'\x0eEVERSE SOLIDUS'
'\x08EVERSED '
'\rEVERSED DAMMA'
'\x1dEVERSED LUNATE EPSILON SYMBOL'
'\nEVERSED PE'
'\x14EVERSED ROTATED RANA'
'\x10EVERSED VISARGA '
'\x04EVMA'
'\x02EW'
'\rEWDATA SQUARE'
'\x0bEXCLAMATION'
'\x10EXCLAMATION MARK'
'\x06EXISTS'
'\x0fEXPONENT SYMBOL'
'\x03EXT'
'\x1cEXTENDED ARABIC-INDIC DIGIT '
'&EXTENDED ARABIC-INDIC DIGIT FOUR ABOVE'
'&EXTENDED ARABIC-INDIC DIGIT FOUR BELOW'
'\x1dEXTENDED ARABIC-INDIC DIGIT T'
'\tEXTENSION'
'\x02EY'
'\x06EYANNA'
'\x05EYYAL'
'\x03EZH'
'\x03EZI'
'\x04EZZO'
'\x01F'
'\x06F CLEF'
'\x05F COW'
'\x07F DAVID'
'\x05F EWE'
'\x06F MARE'
'\x07F SASAK'
'\nF SHE-GOAT'
'\x05F SOW'
'\x08F SYMBOL'
'\x0cF TREE TRUNK'
'\x07F WITH '
'\x02F0'
'\x03F14'
'\x02F3'
'\x03F8C'
'\x02FA'
'\x05FAAFU'
'\x12FACING SVASTI SIGN'
'\nFAHRENHEIT'
'\x05FAIHU'
'\x10FALLING DIAGONAL'
'\x0cFALLING DOTS'
'\x06FAMILY'
'\x05FATHA'
'\x06FATHA '
'\x07FAYANNA'
'\x02FE'
'\x05FEARN'
'\x0cFEATHER MARK'
'\nFEATHERED '
'\x08FEBRUARY'
'\x19FECTIVENESS OR DISTORTION'
'\x03FEE'
'\x03FEH'
'\tFEH WITH '
'\x0eFEHU FEOH FE F'
'\x0bFEMALE SIGN'
'\x0cFEMININE DOT'
'\x05FENCE'
'\x0cFERENCE MARK'
'\x06FF OF '
'\x10FFERENCE BETWEEN'
'\nFFICULTIES'
'\x19FFICULTY AT THE BEGINNING'
'\x04FFIN'
'\x0bFGHANI SIGN'
'\x03FHA'
'\x02FI'
'\x05FIFTH'
'\x06FIFTHS'
'\x05FIFTY'
'\x06FILLER'
'\x03FIN'
'\x07FINAGH '
'\x06FINAL '
'\nFINAL FORM'
'\rFINAL LETTER '
'\tFINAL MEM'
'\tFINAL NGA'
'\rFINAL SEMKATH'
'\x0bFINAL SIGMA'
'\x08FINAL TH'
'\x07FINAL Y'
'\x04FIRE'
'\tFISH TAIL'
'\x08FISHHOOK'
'\x05FISTO'
'\x04FITA'
'\x04FIVE'
'\x12FIVE EIGHTHS BLOCK'
'\x0cFIVE HUNDRED'
'\x0bFIXED-FORM '
'\rFIXED-FORM RA'
'\x02FL'
'\x05FLAKE'
'\x04FLAT'
'\tFLAT SIGN'
'\nFLATTENED '
'\x16FLATTENED OPEN A ABOVE'
'\x15FLATTENED PARENTHESIS'
'\x05FLICT'
'\x13FLORAL HEART BULLET'
'\x08FLOURISH'
'\x07FLUENCE'
'\x05FLUTE'
'\x02FO'
'\x03FO '
'\x06FONIAS'
'\x05FORCE'
'\x04FORE'
'\rFOREMENTIONED'
'\x04FORK'
'\x12FORKED PARAGRAPHOS'
'\x07FORKING'
'\x14FORMS LIGHT VERTICAL'
'\x04FOUR'
'\x1cFOUR BALLOON-SPOKED ASTERISK'
'\nFOUR BELOW'
'\tFOUR DOTS'
'\x0fFOUR DOTS ABOVE'
'\x0bFOURTH ROOT'
'\tFRACTION '
'\x0fFRACTION DIGIT '
'\x08FRAKTUR '
'\x08FRICAN D'
'\x08FROM BAR'
'\x05FSAAQ'
'\x02FT'
'\x03FT '
'\x0cFT RERENGGAN'
'\x05FTEEN'
'\x0fFTER COMPLETION'
'\x1cFTING POINT RIGHTWARDS ARROW'
'\nFTOGGOS OU'
'\rFTWARDS ARROW'
'\x03FTY'
'\tFULL STOP'
'\rFULL SURROUND'
'\x03FWA'
'\x04FWAA'
'\x01G'
'\x02G '
'\tG IN HOLE'
'\x05G YUS'
'\x02G0'
'\x02G2'
'\x02G3'
'\x02G9'
'\x02GA'
'\x10GAAHLAA TTUDDAAG'
'\x03GAB'
'\x03GAD'
'\x19GAD OVER GAD GAR OVER GAR'
'\x05GADOL'
'\x03GAG'
'\x04GAIN'
'\x03GAL'
'\x05GALGA'
'\x05GALI '
'\x05GAMAL'
'\x05GAMAN'
'\x04GAML'
'\x05GAMMA'
'\x04GAN2'
'\tGAN2 TENU'
'\nGANDA MARK'
'\x06GANGIA'
'\x13GAPPED CIRCLE ARROW'
'\x03GAR'
'\x08GARITIC '
'\nGAS BZUNG '
'\x03GAT'
'\x12GATIVE ACKNOWLEDGE'
'\x0cGAW KAREN EU'
'\rGAW KAREN SHA'
'\x03GAY'
'\x07GAYANNA'
'\x0bGAYANUKITTA'
'\x02GB'
'\x03GBA'
'\nGBAKURUNEN'
'\x08GBASINNA'
'\x02GE'
'\x07GE SIGN'
'\x06GEADAL'
'\x0cGEBA KAREN I'
'\x03GED'
'\x04GEDE'
'\x06GEDOLA'
'\x11GENERIC MATERIALS'
'\x08GENITIVE'
'\x0bGENTLE WIND'
'\x03GER'
'\x0eGERED TREMOLO-'
'\x04GESH'
'\x05GESH2'
'\x02GG'
'\x04GGER'
'\nGGRAVATION'
'\x04GGWS'
'\x0fGH VOLTAGE SIGN'
'\x03GHA'
'\x0bGHAIN WITH '
'\x06GHAMAL'
'\x03GHE'
'\x04GHOM'
'\x03GHT'
'\rGHT ARROWHEAD'
'\rGHT HALF RING'
'\x0cGHT OPEN BOX'
'\x15GHT OPEN BOX OPERATOR'
'\x0fGHT REPEAT SIGN'
'\x18GHT TRIFOLIATE SNOWFLAKE'
'\x14GHTWARDS ARROW BELOW'
'\x05GHULU'
'\x06GHUNNA'
'\x04GHWA'
'\x02GI'
'\x07GI GUNU'
'\x04GIBA'
'\x06GICAL '
'\x04GIDA'
'\x05GIMEL'
'\x08GINAL OF'
'\x07GINESE '
'\x03GIR'
'\x04GISH'
'\rGISTERED SIGN'
'\x04GIT '
'\tGITTARIUS'
'\x07GLAGOLI'
'\x06GLAZ H'
'\x04GLE '
'\x0bGLE BRACKET'
'\x0cGLOTTAL STOP'
'\x18GLOTTAL STOP WITH STROKE'
'\x05GMENT'
'\x02GN'
'\x03GNO'
'\x02GO'
'\x06GO NGU'
'\x04GOAL'
'\x05GOGI '
'\x07GOLIAN '
'\x0cGONAL STROKE'
'\x05GONEK'
'\x04GONG'
'\x04GORG'
'\x05GORGI'
'\x06GORGON'
'\x04GORT'
'\x03GOU'
'\x02GR'
'\x14GRA GCAN -CHAR RTAGS'
'\x04GRAL'
'\tGRAM FOR '
'\x0bGRAMMA SIGN'
'\x15GRAMMOS OKTO DODEKATA'
'\x05GRAPH'
'\x08GRAPH UK'
'\x05GRAVE'
'\x0cGRAVE ACCENT'
'\x0bGRAVE-ACUTE'
'\x08GREAT SA'
'\tGREATER Y'
'\x0cGREATER-THAN'
'$GREATER-THAN ABOVE DOUBLE-LINE EQUAL'
'\x1eGREATER-THAN ABOVE EQUALS SIGN'
'\x16GREATER-THAN DIAERESIS'
'\x11GREATER-THAN NOR '
'\x18GREATER-THAN OR EQUAL TO'
'\x11GREATER-THAN SIGN'
'\x05GREE '
'\nGREE SLASH'
'\x0bGREEK CROSS'
'\x17GREEK SMALL LETTER IOTA'
'\x0cGREEN DRAGON'
'\tGRIK SIGN'
'\x0fGROUP SEPARATOR'
'\x04GRU '
'\x15GRUENT WITH DOT ABOVE'
'\x02GS'
'\x06GS-PA '
'\x0bGSUM -KHYIL'
'\rGTER TSHEG MA'
'\x03GUD'
'\x04GUNU'
'\x06GURAMU'
'\x05GURE '
'\x0cGXI RADICAL '
'\rGYA GRAM SHAD'
'\x13GYPTIAN HIEROGLYPH '
'\x0eGYPTOLOGICAL A'
'\x01H'
'\x02H '
'\x06H NOTE'
'\rH-TYPE SYMBOL'
'\x03H00'
'\x02HA'
'\x03HAA'
'\x05HAALU'
'\nHAAPRAANA '
'\x07HAARKAA'
'\x03HAD'
'\x05HADDA'
'\x04HADE'
'\x1cHADED WHITE RIGHTWARDS ARROW'
'\x14HADOWED WHITE SQUARE'
'\x08HAGALL H'
'\x0bHAGGAR YAZH'
'\x03HAH'
'\x04HAH '
'\x05HAH I'
'\x10HAH INITIAL FORM'
'\x11HAH ISOLATED FORM'
'\tHAH WITH '
'\x04HAIN'
'\x05HAINU'
'\x04HAIR'
'\rHAKASSIAN CHE'
'\x03HAL'
'\x05HALA '
'\x07HALANTA'
'\x04HALF'
'\x05HALF '
'\x07HALF BL'
'\nHALF BLACK'
'\x0cHALF BRACKET'
'\x0fHALF FILL SPACE'
'\rHALF INTEGRAL'
'\tHALF RING'
'\tHALSHELET'
'\x03HAM'
'\x04HAM '
'\x06HAM AI'
'\rHAM DIGIT ONE'
'\x06HAMZA '
'\x0bHAMZA ABOVE'
'\x03HAN'
'\x04HAN '
'\nHAN DIGIT '
'\x08HAN-AKAT'
'\x15HAND INTERIOR PRODUCT'
'\x05HANGE'
'\x07HANGUL '
'\x17HANKED RIGHTWARDS ARROW'
'\x05HANNA'
'\x03HAR'
'\x04HAR2'
'\x14HAR2 TIMES GAL PLUS '
'\tHARACTER '
'\tHARACTERS'
'\x08HARMONIC'
'\x06HARP S'
'\x08HARPOON '
'\x12HARPOON WITH BARB '
'\x1bHARPOON WITH BARB DOWNWARDS'
'\x07HASANTA'
'\x0cHASIS SYMBOL'
'\x05HATHI'
'\x04HAVE'
'\x08HAVIYANI'
'\x07HAYANNA'
'\x04HAYN'
'\x02HE'
'\x03HE '
'\x06HE MGO'
'\x04HEAD'
'\x05HEAD '
'\x07HEADING'
'\nHEADSTROKE'
'\x05HEART'
'\x1fHEART EXCLAMATION MARK ORNAMENT'
'\x04HEAT'
'\x06HEAVEN'
'\x0bHEAVEN MARK'
'\x05HEAVY'
'\x06HEAVY '
'\nHEAVY AND '
'\x0fHEAVY AND LEFT '
'\x10HEAVY AND RIGHT '
'\nHEAVY BEAT'
'\x18HEAVY BLACK HEART BULLET'
'\x03HEE'
'\x04HEEN'
'\x04HEEP'
'\x08HEG SHAD'
'\x03HEH'
'\x0fHEH MEDIAL FORM'
'\x06HEISEI'
'\x04HELL'
'\x03HEN'
'\x03HER'
'\rHERICAL ANGLE'
'\x06HERMES'
'\x04HERU'
'\x06HESHIG'
'\x08HESPIAN '
'\x05HESS '
'\x04HETA'
'\x04HETH'
'\x05HETHE'
'\x16HEXIFORM LONG ANUSVARA'
'\x03HHA'
'\x02HI'
'\x05HI RO'
'\x07HI SIGN'
'\tHI SYMBOL'
'\x0cHI TIMES BAD'
'\x06HIBIT '
'\x03HID'
'\x04HID '
'\x05HIDET'
'\x06HIEUCH'
'\x05HIEUH'
'\x06HIEUKH'
'\x06HIEUPH'
'\x06HIEUTH'
'\x05HIFT '
'\x05HIGH '
'\x14HIGH RATHA OR LOW PA'
'\x10HIGH SPACING DOT'
'\tHIGH STOP'
'\x0bHIGH STROKE'
'\tHIGH TONE'
'\x14HIGH TONE APOSTROPHE'
'\x1eHIGH-REVERSED-9 QUOTATION MARK'
'\x04HIIN'
'\x04HILD'
'\tHIMA SIMA'
'\x03HIN'
'\x07HIN DOT'
'\rHINESE TONE Y'
'\x03HIP'
'\x04HIRD'
'\x05HIRIQ'
'\x04HIRT'
'\x07HIRTEEN'
'\x11HIRTEEN FULL STOP'
'\x05HIRTY'
'\x05HISTI'
'\x03HIT'
'\x05HITE '
'\nHITE ARROW'
'\x1bHITE DOWN-POINTING TRIANGLE'
'\x0bHITE DRAGON'
'\x05HIUTH'
'\x04HIVE'
'\x06HIVETE'
'\tHIYYAALAA'
'\x0bHJONG TILE '
'\x06HLAVI '
'\x02HM'
'\x07HM SIGN'
'\x10HMATULLAH ALAYHE'
'\x02HO'
'\x03HO '
'\x06HO HOI'
'\nHOGI PIECE'
'\x04HOKE'
'\x05HOLAM'
'\x05HOLAR'
'\x10HOLDING TOGETHER'
'\x05HOLE '
'\x04HOOK'
'\nHOOK ABOVE'
'\x0bHOOK SYMBOL'
'\x0bHORA DIGIT '
'\x04HORI'
'\nHORIZONTAL'
'\x0eHORIZONTAL BAR'
'\x14HORIZONTAL BAR WITH '
'\x0fHORIZONTAL DASH'
'\x11HORIZONTAL DOUBLE'
'\x13HORIZONTAL ELLIPSIS'
'\x0fHORIZONTAL FILL'
'\x10HORIZONTAL HEAVY'
'\x10HORIZONTAL LIGHT'
'\x11HORIZONTAL SINGLE'
'\x11HORIZONTAL STROKE'
'\x15HORIZONTAL TABULATION'
'\x12HORIZONTALLY BELOW'
'\x04HORN'
'\x05HORSE'
'\x05HORT '
'\x06HORT A'
'\x16HORT HORIZONTAL STROKE'
'\nHORT-TWIG-'
'\x04HOST'
'\tHOT SASAK'
'\nHOTIC HOOK'
'\x03HOU'
'\x05HOUR '
'\x07HOUSAND'
'\x15HOUSAND MILLIONS SIGN'
'\x0fHOUSAND STATERS'
'\x12HOUSANDS SEPARATOR'
'\x05HREAD'
'\x04HREE'
'\x05HREE '
'\nHREE ABOVE'
'\x0bHREE BALUDA'
'\tHREE DOTS'
'\nHREE DOTS '
'\x0fHREE DOTS ABOVE'
'\x19HREE DOTS ABOVE DOWNWARDS'
'\x0fHREE DOTS BELOW'
'\tHREE FOR '
'\x08HREE OF '
'\x07HROUGH '
'\x03HSA'
'\x04HSDA'
'\x04HSHU'
'\x1aHTORA SKLIRON CHROMA VASIS'
'\x02HU'
'\x04HUEN'
'\x03HUK'
'\x07HUNDRED'
'\x08HUNDRED '
'\x03HUR'
'\x06HUR PA'
'\x13HURISAZ THURS THORN'
'\x02HV'
'\x02HW'
'\x03HWA'
'\x04HWAA'
'\tHWAZ EH E'
'\x07HYAAUSH'
'\x06HYPHEN'
'\x0cHYPHEN-MINUS'
'\x02HZ'
'\x01I'
'\x02I '
'\nI ARCHAION'
'\x05I KOI'
'\rI LENGTH MARK'
'\x06I MAIM'
'\tI PLUS LI'
'\x07I RTAGS'
'\x08I SHAKTI'
'\x08I SYMBOL'
'\x0bI TIMES NUN'
'\rI WITH STROKE'
'\x16I YFESIS TETARTIMORION'
'\x03I-I'
'\x02I0'
'\x02IA'
'\x08IAERESIS'
'\x08IAGONAL '
'\x0eIAGONAL STROKE'
'\x03IAL'
'\tIALECT-P '
'\x08IALYTIKA'
'\tIALYTIKA '
'\x06IAMOND'
'\x0fIAMOND UNDERBAR'
'\x0bIAN LETTER '
'\x05IANCE'
'\x06IANGLE'
'\x1aIANGLE BESIDE VERTICAL BAR'
'&IANGLE CONTAINING SMALL WHITE TRIANGLE'
'\x04IANO'
'\x04IARA'
'\x06IASMA '
'\x05IAUDA'
'\x04IBE '
'\x07IBIFILI'
'\x0bIBLE-CREE Y'
'\x02IC'
'\nICAL TAPER'
'\x03ICE'
'\x05ICHON'
'\x05ICHOS'
'\x05ICRON'
'\x13ICTLY EQUIVALENT TO'
'\x02ID'
'\nIDDLE MARK'
'\x0bIDDLE TILDE'
'\x0cIDDLE-WELSH '
'\x03IDE'
'\x1bIDE ARC ANTICLOCKWISE ARROW'
'\x17IDE ARC CLOCKWISE ARROW'
'\x1bIDE-HEADED RIGHTWARDS ARROW'
'\x0cIDENTICAL TO'
'\tIDEOGRAM '
'\nIDEOGRAPH '
'\x0cIDEOGRAPHIC '
'\x11IDEOGRAPHIC COMMA'
'\x1aIDEOGRAPHIC ITERATION MARK'
'\x08IDEWAYS '
'\tIDEWAYS U'
'\x05IDGE '
'\nIDGE BELOW'
'\x0fIDING ENCLOSURE'
'\x02IE'
'\x03IER'
'\x03IES'
'\x04IEUC'
'\x05IEUNG'
'\x04IEUP'
'\x04IFAT'
'\x03IFF'
'\x06IFIED '
'\rIFIER LETTER '
'\x03IFT'
'\x06IFTEEN'
'\x10IFTEEN FULL STOP'
'\x04IFTY'
'\x02IG'
'\x06IG YUS'
'\x03IG4'
'\x06IGAMMA'
'\x08IGATURE '
'\x16IGEL LONG-BRANCH-SOL S'
'\x04IGER'
'\x0bIGGLY FENCE'
'\x03IGH'
'\x04IGH '
'\tIGH HAMZA'
'\x04IGHT'
'\x05IGHT '
'\tIGHT DOWN'
'\x08IGHT OF '
'\x07IGHTEEN'
'\x11IGHTEEN FULL STOP'
'\x06IGHTH '
'\tIGHTH ASH'
'\x0eIGHTWARDS TICK'
'\x0eIGHTWARDS VANE'
'"IGHUR KAZAKH KIRGHIZ ALEF MAKSURA '
'\x03IGI'
'\x08IGI GUNU'
'\x05IGIT '
'\x04IGMA'
'\x03IGN'
'\x04IGN '
'\x02IH'
'\x03IHI'
'\x05IHVUS'
'\x02II'
'\x03II '
'\x04IITO'
'\x02IJ'
'\x04IK H'
'\x05IKARA'
'\x05IKEUT'
'\x07IKHAHIT'
'\x04IKRI'
'\nIKRON ISON'
'\x03IKU'
'\x05IKURU'
'\x02IL'
'\x0bIL FRAGMENT'
'\x06ILBOAT'
'\x0bILCROW SIGN'
'\x04ILDE'
'\x03ILE'
'\rILE SEPARATOR'
'\tILE TILDE'
'\nILING FACE'
'\tILIPPINE '
'\x0bILIQUA SIGN'
'\x03ILK'
'\x06ILLAGE'
'\x07ILLEANN'
'\x05ILLU '
'\x04ILUY'
'\x02IM'
'\x03IM5'
'\x03IMA'
'\rIMAGE BRACKET'
'\x14IMAGE OF OR EQUAL TO'
'\x08IMANSIS '
'\x03IME'
'\x04IMEL'
'\x0bIMEL SYMBOL'
'\x10IMENSIONAL ANGLE'
'\x04IMES'
'\x05IMES '
'\x13IMIDIA SEXTULA SIGN'
'\x07IMILAR '
'\x0fIMISEOS CHRONOU'
'\x05IMMA '
'\nIMPERFECTA'
'\x0fIMPERFECTA REST'
'\x1bIMPERFECTUM CUM PROLATIONE '
'\x02IN'
'\x03IN '
'\x13IN CHEN SPUNGS SHAD'
'\x16IN DEPARTING TONE MARK'
'\x06IN DOT'
'\x0bIN EQUAL TO'
'\x08IN SPACE'
'\tIN SQUARE'
'\x0bIN TRIANGLE'
'\x1fIN WHITE CIRCLE IN BLACK SQUARE'
'\x08IN WITH '
'\x03IN2'
'\x06INAGMA'
'\nINAL SIGMA'
'\x04INAP'
'\x06INCUNX'
'\x03IND'
'\x13INDEPENDENT SVARITA'
'\x12INDEPENDENT VOWEL '
'\x0bINDERGARTEN'
'\x06INDHI '
'\x06INDIC '
'\x0bINDICESIMA '
'\x16INDIRECT QUESTION MARK'
'\x1aINDUSTRIAL STANDARD SYMBOL'
'\x03INE'
'\tINE BELOW'
'\x07INE OF '
'\x11INEAR ANNOTATION '
'\x04INES'
'\x10INES CONVERGING '
'\x06INESE '
'\x03ING'
'\tING ABOVE'
'\tING LANES'
'\nING LARGE '
'\x0cING OPERATOR'
'\x08ING ROD '
'\x0fING SYMBOL FOR '
'\x06INGAAT'
'\x06INGLE '
'\x0fINGLE HEAD MARK'
'\x05INGSA'
'\x04INGU'
'\nINHERENT A'
'\x03INI'
'\x05INIMA'
'\x17ININE ORDINAL INDICATOR'
'\x14INING OBLIQUE STROKE'
'\tINISHMENT'
'\x0cINITIAL FORM'
'\x05INITY'
'\x06INKING'
'\x04INOR'
'\x03INS'
'\x06INSHIP'
'\x06INSIDE'
'\x1dINSTRUMENTAL NOTATION SYMBOL-'
'\tINSULAR G'
'\x04INTE'
'\x08INTEGRAL'
'\x11INTEGRAL OPERATOR'
'\x0bINTEGRATION'
'\x0cINTEGRATION '
'\x05INTER'
'\x14INTERPOLATION MARKER'
'\x0bINTERROBANG'
'\x15INTERSECTING LOGICAL '
'\x0cINTERSECTION'
'\x15INTERSECTION OPERATOR'
'\x18INTERSECTION WITH SERIFS'
'\x05INTHU'
'\x04INTO'
'\x0bINTO SHRINE'
'\x03INU'
'\x17INUOUS UNDERLINE SYMBOL'
'\x04INUS'
'\x0fINUS SIGN BELOW'
'\x14INVERSE WHITE CIRCLE'
'\x08INVERTED'
'\tINVERTED '
'\x0eINVERTED BREVE'
'\x14INVERTED CANDRABINDU'
'\x0eINVERTED DAMMA'
'\x19INVERTED EXCLAMATION MARK'
'\rINVERTED FORK'
'\x15INVERTED GLOTTAL STOP'
'\x16INVERTED SMALL V ABOVE'
'\x16INVERTED SMALL V BELOW'
'\rINVERTED TURN'
'\nINVERTED V'
'\x03ION'
'\x08ION SIGN'
'\x0bIOR PRODUCT'
'\x03IOS'
'\x04IOTA'
'\x02IP'
'\x03IP '
'\x07IP SIGN'
'\x05IPEHA'
'\x05IPING'
'\x0bIPLE TONGUE'
'\x04IPOD'
'\x04IPT '
'\x04IQAA'
'\x02IR'
'\x08IR SPACE'
'\x08IRA SIGN'
'\x0cIRAGANA HOKA'
'\x05IRAMA'
'\x03IRC'
'\x05IRCLE'
'\x06IRCLE '
'\x10IRCLE X NOTEHEAD'
'\x07IRCLED '
'\x06IRCLES'
'\tIRCUMFLEX'
'\x10IRCUMFLEX ACCENT'
'\x0fIRCUMFLEX BELOW'
'\x08IRD MARK'
'\x03IRE'
'\x04IRED'
'\x04IRGA'
'\x07IRGHIZ '
'\x03IRI'
'\x06IRINGU'
'\x04IRIQ'
'\x04IRIT'
'\x03IRO'
'\x07IRPLANE'
'\tIRST MARK'
'\x0cIRST SUBUNIT'
'\x03IRT'
'\x06IRTEEN'
'\x04IRTY'
'\x0cIRTY-SECOND '
'\x03IRU'
'\x02IS'
'\x08IS-PILLA'
'\x06ISELEH'
'\tISEN-ISEN'
'\x03ISH'
'\x08ISH TAIL'
'\x04ISI '
'\x07ISIBLE '
'\x0bISIGOTHIC Z'
'\x1cISMILLAH AR-RAHMAN AR-RAHEEM'
'\rISOLATED FORM'
'\x06ISSHAR'
'\x06ISSIMO'
'\x05ISTLE'
'\x10ISTOS DISC SIGN '
'\x02IT'
'\x03IT '
'\x03ITA'
'\x0eITA PLUS GISH '
'\x06ITABLE'
'\x07ITALIC '
'\x03ITE'
'\x13ITED LIABILITY SIGN'
'\x04ITEM'
'\x0eITERATION MARK'
'\x04ITH '
'\x0fITH FINGERNAILS'
'\x06ITHER '
'\x05ITHI '
'\x06ITIAL '
'\x05ITING'
'\nITING HAND'
'\rITING THROUGH'
'\x0fITION INDICATOR'
'\x04ITLO'
'\x05ITON '
'\x07ITON RA'
'\tITRA SIGN'
'\x04ITSA'
'\tITTLE YUS'
'\x03ITU'
'\x05ITUAL'
'\x03ITY'
'\nIVALENT TO'
'\x05IVATE'
'\x03IVE'
'\x04IVE '
'\x0eIVE KEY SYMBOL'
'\x0eIVE OBOLS SIGN'
'\x07IVE OF '
'\x10IVE POINTED STAR'
'\rIVE SLOW SIGN'
'\tIVINATION'
'\x07IVISION'
'\x0eIWAZ TIR TYR T'
'\x03IWN'
'\x03IWR'
'\x02IX'
'\x03IX '
'\x06IX OF '
'\x03IXT'
'\x06IXTEEN'
'\x04IXTH'
'\nIXTHS DISH'
'\x04IXTY'
'\x06IYANNA'
'\x05IYEOK'
'\x01J'
'\x02JA'
'\x05JANG '
'\x07JARATI '
'\x08JAVIYANI'
'\x07JAYANNA'
'\x02JE'
'\x1aJECT REPLACEMENT CHARACTER'
'\x0bJECT SYMBOL'
'\x07JECTIVE'
'\x03JEE'
'\x04JEEM'
'\x05JEEM '
'\x06JEEM I'
'\x11JEEM INITIAL FORM'
'\x12JEEM ISOLATED FORM'
'\x07JEGOGAN'
'\x04JEON'
'\x03JER'
'\x07JERAN J'
'\tJERUSALEM'
'\x04JERV'
'\x05JERVI'
'\rJES SU NGA RO'
'\x03JEU'
'\x03JHA'
'\x07JIBWAY '
'\x0bJIHVAMULIYA'
'\x03JK '
'\x06JOINED'
'\x0eJOINED SQUARES'
'\x06JOINER'
'\x05JOKER'
'\x04JONG'
'\x03JOT'
'\x04JOT '
'\x03JOY'
'\x0bJOYOUS LAKE'
'\x14JUDEO-SPANISH VARIKA'
'\x05JUDGE'
'\x06JUDIJE'
'\x05JUEUI'
'\x08JUNCTION'
'\x01K'
'\x03K00'
'\x02K2'
'\nK2 PLUS BU'
'\x02K4'
'\x02KA'
'\x10KA- SHOG YIG MGO'
'\x04KAAF'
'\x03KAB'
'\tKABA TENU'
'\x04KAD3'
'\x03KAF'
'\nKAI SYMBOL'
'\x03KAK'
'\x04KAKO'
'\x03KAL'
'\x0cKANA REPEAT '
'\x04KANG'
'\x12KANTAJA NAASIKYAYA'
'\x04KAPA'
'\x04KAPH'
'\x05KAPPA'
'\x0cKAPPA SYMBOL'
'\rKAPYEOUNPIEUP'
'\x04KARA'
'\x06KASKAL'
'\x05KASRA'
'\x08KATAKANA'
'\x12KATAKANA-HIRAGANA '
'\x1bKATHAKA INDEPENDENT SVARITA'
'\x04KATO'
'\x04KAUN'
'\x06KAVYKA'
'\x03KAY'
'\x06KAYAH '
'\x07KAYANNA'
'\x12KBAR ISOLATED FORM'
'\x02KE'
'\x06KE PHO'
'\x16KEEPING STILL MOUNTAIN'
'\x04KEMP'
'\tKEMPHRENG'
'\x05KERET'
'\x03KET'
'\x06KEYCAP'
'\nKFONITIKON'
'\x02KH'
'\x05KHAH '
'\x06KHAH I'
'\x11KHAH INITIAL FORM'
'\x0cKHAMTI TONE-'
'\x05KHAPH'
'\x07KHIEUKH'
'\x0cKHMIMIC KHEI'
'\x02KI'
'\x04KICK'
'\x03KIN'
'\x04KING'
'\x0fKISIM5 TIMES BI'
'\x06KIYEOK'
'\x06KLITON'
'\x05KNIFE'
'\x06KNIFE '
'\x02KO'
'\x03KO '
'\x05KO LA'
'\x04KOET'
'\x07KOMBUVA'
'\x03KON'
'\x03KOO'
'\x05KOPPA'
'\x07KOQNDON'
'\x12KOREAN CHARACTER O'
'\x07KORONIS'
'\x03KOT'
'\x08KOUFISMA'
'\x06KRISIS'
'\x02KS'
'\tKSTREPTON'
'\x0bKTIESELSKAB'
'\x06KTIKO '
'\x02KU'
'\tKU RU KHA'
'\x03KUN'
'\x03KUR'
'\x04KURO'
'\x05KURON'
'\x06KUSHU2'
'\x05KUSMA'
'\x07KUTAARU'
'\x03KUU'
'\x02KW'
'\x04KWAA'
'\x05KWAEN'
'\x07KYLISMA'
'\x01L'
'\x02L '
'\x14L FUNCTIONAL SYMBOL '
'\x07L SEGNO'
'\x05L TAG'
'\x0bL TIMES LAL'
'\x08L-LAKUNA'
'\rL-TYPE SYMBOL'
'\x02L0'
'\x03L00'
'\x02L2'
'\x02LA'
'\x08LA LENGA'
'*LA USED AS KORANIC STOP SIGN ISOLATED FORM'
'\x03LA3'
'\x04LAAN'
'\x05LABAT'
'\x07LABIAL '
'\x05LABOR'
'\x0eLACE OF SAJDAH'
'\x04LACK'
'\x05LACK '
'\x0cLACK DIAMOND'
'\x0cLACK HEXAGON'
'\tLACKFOOT '
'\x06LAFRON'
'\x03LAG'
'\x05LAGAB'
' LAGAB TIMES U OVER LAGAB TIMES U'
'\nLAGAR GUNU'
'\x0cLAGAR TIMES '
'\x07LAGIOS '
'\x05LAGUS'
'\x11LAH ISOLATED FORM'
'\x03LAI'
'\x04LAKE'
'\x03LAL'
'\x03LAM'
'\x04LAM '
'\tLAM WITH '
'\x06LAMADH'
'\tLAMATION '
'\x04LAMD'
'\x05LAMDA'
'\x05LAMED'
'\x06LAMEDH'
'\nLANE MERGE'
'3LANTED EQUAL ABOVE GREATER-THAN ABOVE SLANTED EQUAL'
'0LANTED EQUAL ABOVE LESS-THAN ABOVE SLANTED EQUAL'
'\x11LAPPING LESS-THAN'
'\tLARGEMENT'
'\x03LAS'
'\x04LASH'
'\x08LASH BAR'
'\x05LASMA'
'\x06LASTON'
'\x04LAT '
'\x0cLATALIZATION'
'\rLATERAL CLICK'
'\x05LATIK'
'\x06LATIN '
'\x15LATIN CAPITAL LETTER '
'\x16LATIN CAPITAL LETTER S'
'\x0bLATIN CROSS'
'\x0fLATION FUNCTION'
'\x07LAYANNA'
'\x05LAYAR'
'\x06LAZY S'
'\x02LC'
'\nLCROW SIGN'
'\x02LD'
'\x03LD '
'\x10LD ASSYRIAN ONE '
'\x03LDE'
'\x02LE'
'\x03LE '
'\nLE LETTER '
'\nLE-DELAYED'
'\x06LEADER'
'\x05LEASE'
'\x03LEF'
'\x04LEF '
'\x04LEFT'
'\x05LEFT '
'\tLEFT AND '
'\x14LEFT AND LOWER RIGHT'
'\x10LEFT ARROW ABOVE'
'\x18LEFT DIAGONAL HALF BLACK'
'\x0bLEFT DOUBLE'
'\x0fLEFT DOWN BARB '
'\tLEFT HALF'
'\x0fLEFT HALF BLACK'
'\x10LEFT HALF CIRCLE'
'\x0eLEFT HALF RING'
'\x0cLEFT HARPOON'
'\nLEFT HEAVY'
'\tLEFT HOOK'
'\nLEFT LIGHT'
'\x10LEFT PARENTHESIS'
'\x19LEFT PARENTHESIS ORNAMENT'
'\rLEFT QUADRANT'
'\x0bLEFT SINGLE'
'\tLEFT TACK'
'\x08LEFT TO '
'\x13LEFT TO LOWER RIGHT'
'$LEFT TORTOISE SHELL BRACKET ORNAMENT'
'\rLEFT TRIANGLE'
'\x16LEFT TRIANGLE OPERATOR'
'\x0eLEFT TURNSTILE'
'\nLEFT-HAND '
'\x12LEFT-STEM TONE BAR'
'\tLEFTWARDS'
'\x0fLEFTWARDS ARROW'
'\x19LEFTWARDS ARROW WITH HOOK'
'\x1cLEFTWARDS OF DOWNWARDS ARROW'
'\x1aLEFTWARDS OF UPWARDS ARROW'
'\x0eLEFTWARDS TICK'
'\rLEGETOS ICHOS'
'\x04LEIA'
'\nLEK ATTAK '
'\x07LEK TOO'
'\x06LEMENT'
'\tLEMENT OF'
'\nLENDED YUS'
'\x0bLENGTH MARK'
'\x05LENIS'
'\x12LENTICULAR BRACKET'
'\x12LENTICULAR BRAKCET'
'\x04LEPH'
'\x0cLER CONSTANT'
'\x08LESS SHA'
'\tLESS-THAN'
'!LESS-THAN ABOVE DOUBLE-LINE EQUAL'
'\x1bLESS-THAN ABOVE EQUALS SIGN'
'\x0eLESS-THAN NOR '
'\x15LESS-THAN OR EQUAL TO'
'\x08LESSER Y'
'\nLET SYMBOL'
'\x04LETE'
'\x04LETH'
'\x07LETTER '
'\x0fLETTER CAPITAL '
'\x15LETTER SMALL CAPITAL '
'\x07LEUT KA'
'\x0fLEVEL TONE MARK'
'\x05LEVEN'
'\x0fLEVEN FULL STOP'
'\x02LF'
'\x03LF '
'\x08LF RING '
'\x03LFA'
'\x08LFWIDTH '
'\nLGIZ EOLHX'
'\x02LH'
'\x03LHA'
'\nLHAG RTAGS'
'\x02LI'
'\x08LI GALI '
'\x05LIDUS'
'\x04LIFI'
'\x04LIFU'
'\x05LIGHT'
'\nLIGHT AND '
'\x0fLIGHT AND LEFT '
'\x10LIGHT AND RIGHT '
'\nLIGHT BEAT'
'\x06LIGION'
'\x06LIGON '
'\nLIMITATION'
'\nLINDRICITY'
'\x04LINE'
'\x05LINE '
'\nLINE BELOW'
'\x0eLINE EXTENSION'
'\tLINE FEED'
'\x1aLINE FEED SEPARATOR SYMBOL'
'\x18LINE HORIZONTAL ELLIPSIS'
'\nLINE STAFF'
'\x04LING'
'\x0cLINGING FIRE'
'\x0cLINKING MARK'
'\x14LIQUE ANGLE OPENING '
'\x1cLIQUID MEASURE FIRST SUBUNIT'
'\x04LISH'
'\x06LISHA '
'\tLISSANDO '
'\x06LITIKI'
'\x0eLITTLE SECTION'
'\nLITTLE YUS'
'\x04LIUM'
'\tLIVERANCE'
'\x04LIWN'
'\x03LJE'
'\x02LK'
'\x03LK '
'\x02LL'
'\x07LL SIGN'
'\tLL SYMBOL'
'\x03LLA'
'\x07LLABLE '
'\tLLABLE B0'
'\tLLABLE OM'
'\x16LLAHOU ALAYHE WASALLAM'
'\x1aLLALLAHOU ALAYHE WASSALLAM'
'\tLLAR SIGN'
'\x05LLEL '
'\x04LLET'
'\x07LLIANCE'
'\x0fLLING DIAGONAL '
'\x03LLO'
'\x07LLOWING'
'\x02LM'
'\x0eLMOST EQUAL TO'
'\x0fLMOST EQUAL TO '
'\x02LO'
'\x04LO L'
'\rLOCATION SIGN'
'\x08LOCATIVE'
'\tLOCKWISE '
'\x08LOGICAL '
'\x0bLOGICAL AND'
'\nLOGICAL OR'
'\x04LOLL'
'\x03LON'
'\x0bLON SKEWED '
'\x05LONG '
'\rLONG ANUSVARA'
'\x08LONG BAR'
'\x06LONG E'
'\x16LONG HORIZONTAL STROKE'
'\x08LONG LEG'
'\nLONG OVER '
'\x08LONG S T'
'\x0fLONG VOWEL SIGN'
'\x03LOO'
'\x04LOOP'
'\x04LOOR'
'\x03LOR'
'\x08LORRAINE'
'\x03LOS'
'\x06LOSED '
'\x12LOSED CIRCLE ARROW'
'\x0bLOSED ENTRY'
'\x10LOSED LITTLE YUS'
'\x07LOSING '
'\x0bLOSING MARK'
'\x0bLOTI NAGRI '
'\x07LOTTAL '
'\x0bLOTTAL STOP'
'\x05LOURE'
'\x04LOVO'
'\x03LOW'
'\x04LOW '
'\x08LOW LINE'
'\x16LOW PARAPHRASE BRACKET'
'\x08LOW STOP'
'\x08LOW TONE'
'\x06LOWER '
'\x0cLOWER CORNER'
'\x0eLOWER DIAGONAL'
'\tLOWER DOT'
'\nLOWER HALF'
'\nLOWER HOOK'
'+LOWER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW'
'\x07LOZENGE'
'\x03LPA'
'\nLPAPRAANA '
'\x04LPHA'
'\x02LT'
'\x0bLT OF CLOTH'
'\x03LTA'
'\x0cLTA EQUAL TO'
'\x0bLTERNATE YA'
'\x03LTI'
'\x05LTIRE'
'\x02LU'
'\x0bLU PLUS IGI'
'\x03LUB'
'\x08LUB SUIT'
'\x03LUE'
'\x03LUG'
'\x04LUIS'
'\x03LUL'
'\x03LUM'
'\x04LUMN'
'\x13LUNATE SIGMA SYMBOL'
'\x03LUS'
'\x0cLUS NOTEHEAD'
'\x08LUS SIGN'
'\x0eLUS SIGN BELOW'
'\x03LVE'
'\rLVE FULL STOP'
'\rLVEOLAR CLICK'
'\tLVIN SIGN'
'\x02LY'
'\x03LY '
'\x04LY H'
'\x18LY-RECYCLED PAPER SYMBOL'
'\x07LYGISMA'
'\x01M'
'\x02M '
'\x06M BOAR'
'\x08M BRANCH'
'\x06M BULL'
'\x06M DASH'
'\tM HE-GOAT'
'\x05M RAM'
'\nM STALLION'
'\x0bM TIMES SHE'
'\x02M0'
'\x02MA'
'\x05MAAEH'
'\x06MACRON'
'\x05MACUS'
'\x0bMADDA ABOVE'
'\x0cMADDA ABOVE '
'\x06MADR M'
'\x05MADYA'
'\x07MAGE OF'
'\tMAHAPRANA'
'\x04MAI '
'\x05MAI K'
'\x07MAI SAT'
'\x07MAKSURA'
'\x08MAKSURA '
'\x15MAKSURA ISOLATED FORM'
'\x1eMAKSURA WITH SUPERSCRIPT ALEF '
'\x0fMAL SUBGROUP OF'
'\x0fMALAKON CHROMA '
'\tMALE SIGN'
'\x15MALE WITH STROKE SIGN'
'\x04MALL'
'\x05MALL '
'\x06MALL A'
'\x08MALL AXE'
'\rMALL CAPITAL '
'\x0bMALL CIRCLE'
'\x11MALL CIRCLE ABOVE'
'\x18MALL CIRCLE TO THE RIGHT'
'\x06MALL F'
'\x0cMALL LETTER '
'\rMALL LETTER J'
'\rMALL LETTER Z'
'\x15MALL Q WITH HOOK TAIL'
'\tMALL RING'
'\x0bMALL SQUARE'
'\x11MALL WHITE CIRCLE'
'\x08MALL YUS'
'\x05MALON'
'\x03MAN'
'\x04MAN '
'\x07MANCHU '
'\x11MANENT PAPER SIGN'
'\x08MANGALAM'
'\x05MANNA'
'\x0cMANNAZ MAN M'
'\x03MAP'
'\x05MAPIQ'
'\x05MAQAF'
'\x03MAR'
'\x07MARCATO'
'\x08MARITAN '
'\x04MARK'
'\x05MARK '
'\x1aMARRIED PARTNERSHIP SYMBOL'
'\x0fMARRYING MAIDEN'
'\x04MARU'
'\x04MASH'
'\rMASORA CIRCLE'
'\x12MATHEMATICAL SPACE'
'\x02MB'
'\x0bMBA BAYANNA'
'\x0cMBELLISHMENT'
'\x04MBIC'
'\x19MBINING CRYPTOGRAMMIC DOT'
'\x05MBOL '
'\x07MBOL B0'
'\x04MBOO'
'\x07MBRELLA'
'\tMBROIDERY'
'\x02ME'
'\x0bME LONG CAN'
'\nME PLUS DA'
'\nME PLUS EN'
'\x11ME PLUS GAN2 TENU'
'\x04MEAR'
'\x08MEASURE '
'\x0bMED RGYINGS'
'\x0bMEDIAL FORM'
'\x06MEDIUM'
'\x07MEDIUM '
'\x04MEEM'
'\x05MEEM '
'\x0fMEEM FINAL FORM'
'\x06MEEM I'
'\x11MEEM INITIAL FORM'
'\x05MEEMU'
'\x07MEETORU'
'\x04MEGA'
'\x05MEIZI'
'\x04MEKH'
'\rMELODIC QITSA'
'\x03MEM'
'\x08MEM-QOPH'
'\x06MEMBER'
'\x03MEN'
'\x04MEN '
'\x07MENIAN '
'\x0eMENSION ORIGIN'
'\x04MENT'
'\x07MENT OF'
'\x05MEPET'
'\x04MER '
'\tMES WITH '
'\x04MESO'
'\rMESSENIAN TEN'
'\x0cMETA STAVROU'
'\x05METEG'
'\tMETOBELUS'
'\x06METRIC'
'\x05METRY'
'\x0cMFLEX ACCENT'
'\tMHANCHOLL'
'\x02MI'
'\x03MI '
'\x05MI RO'
'\x07MICOLON'
'\x07MIDDLE '
'\x10MIDDLE AND BELOW'
'\x10MIDDLE AND RIGHT'
'\x0fMIDDLE DIAGONAL'
'\nMIDDLE DOT'
'\x0bMIDDLE HOOK'
'\x0cMIDDLE PIECE'
'\x0bMIDDLE STEM'
'\x0cMIDDLE TILDE'
'\x10MIDIRECT PRODUCT'
'\x05MIEUM'
'\x04MIIN'
'\x04MIL '
'\x06MILAR '
'\nMILLE SIGN'
'\rMILLIONS SIGN'
'\x03MIM'
'\x03MIN'
'\x12MINAL DIGIT SHAPES'
'\x04MING'
'\x0cMING TO MEET'
'\x07MINGKAL'
'\x04MINI'
'\x07MINIMA '
'\nMINO TILE '
'\x05MINUS'
'\nMINUS SIGN'
'\rMINUS SIMILAR'
'\rMINUS WHITE X'
'\x08MIONIAN '
'\x05MISRA'
'\x03MIT'
'\x03MKA'
'\x04MLYA'
'\x02MM'
'\x03MMA'
'\x04MMA '
'\x08MMATION '
'\tMMER AND '
'\x04MMU2'
'\x04MNAS'
'\x16MNYAM YIG GI MGO RGYAN'
'\x02MO'
'$MODIFIER LETTER KHAMTI REDUPLICATION'
'"MODIFIER LETTER LABIALIZATION MARK'
'\x1eMODIFIER LETTER LEFT HALF RING'
'\tMODYNAMIC'
'\x03MOI'
'\x04MON '
'\x08MON TIME'
'\x04MONO'
'\nMONOFONIAS'
'\nMONOGRAM B'
'\x1cMONOGRAMMOS TESSERA DODEKATA'
'\x0cMONOGRAPH UK'
'\nMONOSPACE '
'\nMONTH SIGN'
'\x03MOO'
'\x15MORPHOLOGICAL DIVIDER'
'\x0bMOST EQUAL '
'\x08MOTHETIC'
'\x0eMOTHETIC ABOVE'
'\x08MOUNTAIN'
'\x0bMOVED BELOW'
'\x02MP'
'\x05MPARE'
'\x08MPERSAND'
'\x0cMPHASIS MARK'
'\x03MPI'
'\x03MPL'
'\tMPLIFIED '
'\x0cMPTY CENTRE '
'\x05MROCK'
'\x04MTI '
'\x02MU'
'\x06MUCAAD'
'\x03MUG'
'\x04MUIN'
'\tMUKPHRENG'
'\x08MULTIMAP'
'\rMULTIOCULAR O'
'\x14MULTIPLE PUNCTUATION'
'\x0eMULTIPLICATION'
'\x19MULTIPLICATION SIGN BELOW'
'\x10MULTIPLICATION X'
'\x04MUM '
'\x0cMUM TIMES PA'
'\x0bMUNCIA SIGN'
'\x07MUNGKAH'
'\x04MUOY'
'\x05MUOY '
'\x05MURDA'
'\x0fMURDA MAHAPRANA'
'\x04MUSH'
'\x05MUSIC'
'\x08MUSICAL '
'\x0fMUSICAL SYMBOL '
'\x03MUT'
'\x0bMUUSIKATOAN'
'\x03MWA'
'\x04MWAA'
'\x02MX'
'\x02MY'
'\x04MYA '
'\x07MYSLITE'
'\x03MZA'
'\x0fMZA ABOVE WITH '
'\x01N'
'\x02N '
'\x06N DASH'
'\x0cN ELEMENT OF'
'\x06N SIGN'
'\x0bN THE VERGE'
'\x07N WITH '
'\x06N YANG'
'\x0fN-ARY SUMMATION'
'\x08N-JOINER'
'\x07N2 TENU'
'\x02NA'
'\x05NA PO'
'\nNAASIKYAYA'
'\x04NAAU'
'\x05NABLA'
'\x06NACLES'
'\x05NADA '
'\x04NAG '
'\x03NAH'
'\nNAKE BELOW'
'\x04NAL '
'\x08NAM BCAD'
'\x04NANA'
'\x07NANCIAL'
'\nNANGMONTHO'
'\rNAP PIZZICATO'
'\x03NAR'
'\x11NASALIZATION MARK'
'\x05NASHI'
'\nNASPIRATED'
'\x05NATE '
'\x0cNATURAL SIGN'
'\x06NAUD N'
'\x11NAUDIZ NYD NAUD N'
'\x08NAVIYANI'
'\x13NAXIAN FIVE HUNDRED'
'\x07NAYANNA'
'\x08NCE SIGN'
'\x04NCEL'
'\x05NCHU '
'\x04NCIL'
'\x0cNCK CONSTANT'
'\tNCLOSING '
'\x05NCORA'
'\x02ND'
'\x03ND '
'\nND OF AYAH'
'\x0fND OF PARAGRAPH'
'\x16ND RECORDING COPYRIGHT'
'\x13ND SLANTED PARALLEL'
'\x13ND SOUTH EAST ARROW'
'\x13ND SOUTH WEST ARROW'
'\x0bND TWO DOTS'
'\x06NDA TA'
'\x04NDA2'
'\x04NDAP'
'\x03NDO'
'\x05NDRA '
'\tNDRABINDU'
'\x02NE'
'\x03NE '
'\x07NE DOT '
'\x0fNE EIGHTH BLOCK'
'\x0cNE HALF SIGN'
'\x06NE OF '
'\x11NEGATIVE CIRCLED '
"'NEGATIVE SQUARED LATIN CAPITAL LETTER P"
'\x08NEIFORM '
'\x03NEO'
'\x04NEO '
'\x07NEQUDAA'
'\x03NER'
'\x0cNERSHIP SIGN'
'\x04NESS'
'\x07NESTED '
'\x04NET '
'\tNFORZANDO'
'\x02NG'
'\x03NG '
'\x08NG BELOW'
'\x08NG RTAGS'
'\x07NG SIGN'
'\x11NG STROKE OVERLAY'
'\x03NGA'
'\x04NGA2'
'\x06NGBAT '
'\x04NGIA'
'\x04NGLE'
'\x05NGLE '
'\x0cNGLE BARLINE'
'\x0cNGLE BRACKET'
'\x13NGLE QUOTATION MARK'
'\x05NGMAN'
'\x0cNGRATULATION'
'\x04NGSI'
'\tNGTH MARK'
'\x08NGTHENER'
'\nNGUAGE TAG'
'\x04NGUE'
'\x02NI'
'\x08NI ABOVE'
'\x03NIA'
'\x03NIB'
'\x04NIC '
'\x05NIEUN'
'\x03NIG'
'\tNIGGAHITA'
'\x05NIGHT'
'\tNIHSHVASA'
'\x03NII'
'\x07NIKAHIT'
'\x04NINE'
'\x08NINETEEN'
'\x12NINETEEN FULL STOP'
'\x06NINETY'
'\x04NING'
'\x05NINTH'
'\x04NION'
'\x06NIRUGU'
'\x06NISTER'
'\x12NITE PART INTEGRAL'
'\x0bNITIAL FORM'
'\x0bNITIAL IZHE'
'\x08NITIAL Z'
'\x19NIVERSAL RECYCLING SYMBOL'
'\x07NJAEMLI'
'\x03NJE'
'\x0fNJOINING MACRON'
'\tNK SYMBOL'
'\x03NMA'
'\x02NN'
'\x03NNA'
'\x0cNNED LEATHER'
'\x02NO'
'\x08NO SLASH'
'\tNO TELEIA'
'\tNOCULAR O'
'\x06NOKHUK'
'\x03NOO'
'\x04NOON'
'\x0fNOON FINAL FORM'
'\nNOON WITH '
'\x06NOR BU'
' NORMAL FACTOR SEMIDIRECT PRODUCT'
'\x0fNORMAL SUBGROUP'
'\x12NORMAL SUBGROUP OF'
'\x10NORTH EAST ARROW'
'\x10NORTH WEST ARROW'
'\x04NOT '
'\x0fNOT APPROXIMATE'
'\tNOT EQUAL'
'\x0cNOT EQUAL TO'
'\x16NOT INCLUDING THE POLE'
'\x08NOT SIGN'
'\x0fNOT TILDE ABOVE'
'\x05NOTCH'
'\x04NOTE'
'\tNOTEHEAD '
'\x04NOUT'
'\x08NOVEMBER'
'\x03NOW'
'\x06NOWMAN'
'\x04NPEA'
'\rNSONANT SIGN '
'\x03NSU'
'\x04NSUB'
'\x07NSULAR '
'\x08NSULAR D'
'\x08NSULAR G'
'\x06NSUZ A'
'\x15NSVERSAL INTERSECTION'
'\x05NSYON'
'\x02NT'
'\x10NT SCREEN SYMBOL'
')NT-TILTED SHADOWED WHITE RIGHTWARDS ARROW'
'\x05NTAIN'
'\x07NTAINS '
'\x11NTED EQUAL TO OR '
'\tNTERPRISE'
'\x06NTEVMA'
'\x03NTI'
'\x07NTICAL '
'"NTICLOCKWISE-ROTATED DIVISION SIGN'
'\x06NTIIMU'
'\x15NTISTRY SYMBOL LIGHT '
'\nNTITY MARK'
'\x04NTOC'
'\x06NTOGEN'
'\tNTRACTION'
'\x03NTY'
'\rNTY FULL STOP'
'\x02NU'
'\x07NUBIAN '
'\x05NUENG'
'\x0cNUITY SYMBOL'
'\x05NUKTA'
'\x03NUM'
'\x07NUMBER '
'\x0bNUMBER SIGN'
'\nNUMBER TEN'
'\x0bNUMBER ZERO'
'\x08NUMERAL '
'\x0cNUMERAL SIGN'
'\nNUMERATOR '
'\rNUMERATOR ONE'
'\rNUMERIC SIGN '
'\x03NUN'
'\x0bNUN HAFUKHA'
'\x04NUNG'
'\x08NUS SIGN'
'\x07NUSVARA'
'\x08NUSVARA '
'\x0bNUSVARA ONE'
'\tNUSVARAYA'
'\x07NUTILLU'
'\x04NUUN'
'\x08NVERTED '
'\tNVERTED M'
'\tNVERTED R'
'\x0fNVERTED UBADAMA'
'\x02NW'
'\x04NWAA'
'\x0bNWHEEL STAR'
'\x02NY'
'\x12NYET THYOOM TA-ROL'
'\x07NYI ZLA'
'\x0eNYI ZLA NAA DA'
'\x04NYIS'
'\x0bNYIS -KHYIL'
'\x03NYO'
'\x12NYOOGA NAAKSIKYAYA'
'\x01O'
'\x02O '
'\x05O ANG'
'\x03O B'
'\tO HUNDRED'
'\x05O KAI'
'\x04O MA'
'\x03O N'
'\x05O PLA'
'\x05O RUA'
'\x06O SIGN'
'\x08O SYMBOL'
'\x03O Y'
'\x02O0'
'\x0cOACTIVE SIGN'
'\nOANDAKHIAT'
'\x03OAY'
'\x04OBAT'
'\x06OBELOS'
'\x06OBELUS'
'\x0eOBLIQUE HYPHEN'
'\rOBLIQUE LINE '
'\nOBOLS SIGN'
'\x08OBOOFILI'
'\x04OBRO'
'\x15OCAL NOTATION SYMBOL-'
'\x07OCALIC '
'\tOCCLUSION'
'\x06OCENCE'
'\x06OCIETY'
'\x03OCK'
'\x1aOCKED FEMALE AND MALE SIGN'
'\x07OCTOBER'
'\x12ODD POWERS OF FOUR'
'\x06ODHADH'
'\tODIASTOLE'
'\x0fODIFIER LETTER '
'\x04ODO '
'\x02OE'
'\x03OE '
'\x03OEH'
'\x04OENG'
'\tOENICIAN '
'\x10OETIC VERSE SIGN'
'\x02OF'
'\x0bOF MASHFAAT'
'\tOF STIMME'
'\x06OFOUND'
'\x04OFT '
'\x02OG'
'\x07OGDIAN '
'\x03OGH'
'\x0fOGOGRAM KHAMTI '
'\x06OGONEK'
'\rOGOTYPE SIGN '
'\tOGRAPHIC '
'\x02OH'
'\x15OHAMMAD ISOLATED FORM'
'\x0cOHAZARD SIGN'
'\x08OHM SIGN'
'\x06OICING'
'\x0cOID NOTEHEAD'
'\x03OIN'
'\x0cOING TO MEET'
'\x05OINT '
'\x07OINTED '
'\x11OINTED BLACK STAR'
'\x06OINTER'
'\x03OIX'
'\x02OK'
'\x08OK ABOVE'
'\x05OKARA'
'\x05OKEN '
'\x05OKOJI'
'\tOKOUFISMA'
'\x07OKRYTIE'
'\x02OL'
'\x04OLAM'
'\x03OLD'
'\x19OLD ASSYRIAN WORD DIVIDER'
'\x0bOLD NUBIAN '
'\x0eOLD RESOLUTION'
'\x0bOLDING BACK'
'\x03OLE'
'\x06OLIDUS'
'\x0fOLIDUS OPERATOR'
'\x0eOLIDUS OVERLAY'
'\x03OLL'
'\nOLLAR SIGN'
'\x08OLLOWING'
'\x04OLON'
'\nOLON EQUAL'
'\x05OLONG'
'\x0eOLUME INTEGRAL'
'\x02OM'
'\x04OMAN'
'\rOMAN NUMERAL '
'\tOMBINING '
'\x04OMBU'
'\x05OMEGA'
'\x07OMERANG'
'\x05OMIKO'
'\x04OMMA'
'\x08OMMA BAR'
'\nOMMA BELOW'
'\x10OMPLETE INFINITY'
'\x03OMU'
'\x02ON'
'\x03ON '
'\tON GROUND'
'\nON MEDIAL '
'\x0bON PEDESTAL'
'\x0cON WITH BALL'
'\x12ON-SPOKED ASTERISK'
'\x04ONA '
'\x04ONAP'
'%ONCAVE-POINTED BLACK RIGHTWARDS ARROW'
'\x14ONCAVE-SIDED DIAMOND'
'\x04OND '
'\x03ONE'
'\x04ONE '
'\x07ONE BAR'
'\x10ONE EIGHTH BLOCK'
'\x08ONE FOR '
'\x0bONE HUNDRED'
'\x08ONE MARK'
'\tONE MARK-'
'\x04ONE-'
'\x04ONEK'
'\x03ONG'
'\x04ONG '
'\x08ONG DASH'
'\x07ONG LEG'
'\rONG RIGHT LEG'
'\x05ONG S'
'\x0bONG-BRANCH-'
'\x04ONGA'
'\rONGRATULATION'
'\tONGSEONG '
'\x04ONON'
'\x04ONOS'
'\x0fONTOUR INTEGRAL'
'\x02OO'
'\tOO DENNEN'
'\x08OO TYPE '
'\x03OOD'
'\x03OOF'
'\x06OOMUUT'
'\x03OON'
'\nOON LILITH'
'\rOON NOTEHEAD '
'\x04OONE'
'\x04OONU'
'\x03OOT'
'\x04OOTH'
'\x0eOOTNOTE MARKER'
'\x03OOU'
'\x02OP'
'\tOP HALF O'
'\x07OP MARK'
'\x05OPBAR'
'\x1eOPEN CENTRE EIGHT POINTED STAR'
'\x11OPEN CIRCLE ARROW'
'\x06OPEN D'
'\x06OPEN E'
'\x06OPEN P'
'\nOPEN SHELF'
'\x11OPEN-HEADED ARROW'
'\x08OPENING '
'\x0cOPENING LEFT'
'\x08OPERATOR'
'\x03OPO'
'\x04OPPA'
'\x15OPPOSING AN PLUS NAGA'
'\x0bOPPOSING EN'
'\x0bOPPOSING IM'
'\x0cOPPOSING LU2'
'\rOPPOSING NAGA'
'\x0eOPPOSING PIRIG'
'\x08OPRODUCT'
'\x02OQ'
'\x02OR'
'\x03OR '
'\x06OR EQU'
'\x08OR EQUAL'
'\x0bOR EQUAL TO'
'#OR LOWER LEFT CURLY BRACKET SECTION'
'$OR LOWER RIGHT CURLY BRACKET SECTION'
'\x0bOR OPERATOR'
'\x0bORCE SYMBOL'
'\x07ORCULUS'
'\x0eORD SEPARATOR '
'\x10OREAN CHARACTER '
'\x15OREAN STANDARD SYMBOL'
'\x06ORETTE'
'\x07OREVMA '
'\x05ORGON'
'\x03ORI'
'\x17ORIGINAL OF OR EQUAL TO'
'\x04ORII'
'\tORINHIEUH'
'\tORIZONTAL'
'\x18ORIZONTAL BAR WITH NOTCH'
'\x0fORIZONTAL COLON'
'\x12ORK ON THE DECAYED'
'\x07ORKHON '
'\x08ORM FEED'
'\x0fORMATION SOURCE'
'\x03ORN'
'\x08ORNAMENT'
'\x05ORNER'
'\rORNER BRACKET'
'\x06ORONIS'
'\x06ORPIUS'
'\x04ORT '
'\x0bORT BARLINE'
'\x0fORT EQUALS SIGN'
'\tORTH WIND'
'\x1aORTHOGONAL CROSSHATCH FILL'
'\x06ORTION'
'\x15ORTOISE SHELL BRACKET'
'\x04ORTY'
'\x03ORU'
'\x05ORUTO'
'\x02OS'
'\x06OSETTE'
'\x07OSITION'
'\x0eOSITION SYMBOL'
'\x03OSS'
'\x05OSS O'
'\nOSSED SHEI'
'\nOSTAL MARK'
'\x08OSTROPHE'
'\x02OT'
'\x03OT '
'\x08OT ABOVE'
'\x08OT BELOW'
'\x0bOT OPERATOR'
'\x0eOT PUNCTUATION'
'\x07OT SIGN'
'\x03OTA'
'\x07OTATED '
'\x0cOTATION MARK'
'\x04OTE '
'\rOTEHEAD BLACK'
'\x05OTERI'
'\x03OTH'
'\x05OTHAL'
'\x05OTHES'
'\rOTHIC LETTER '
'\x08OTIFIED '
'\x07OTLESS '
'\x12OTLESS DALATH RISH'
'\x14OTLESS J WITH STROKE'
'\x03OTO'
'\x06OTTED-'
'\x04OTTO'
'\x0cOTTOM HALF O'
'\x04OTUS'
'\x02OU'
'\x06OUBLE '
'\x0bOUBLE ACUTE'
'\x0bOUBLE ARROW'
'\x0fOUBLE BACKSLASH'
'\x0bOUBLE DANDA'
'\x11OUBLE MONOCULAR O'
'\x04OUBT'
'\x04OUND'
'\nOUND OMEGA'
'\tOUND SIGN'
'\x1cOUND-TIPPED RIGHTWARDS ARROW'
'\x0eOUNDED CORNERS'
'#OUNDED HIGH STOP WITH FILLED CENTRE'
'\x03OUR'
'\x04OUR '
'\x13OUR DOT PUNCTUATION'
'\x08OUR DOTS'
'\x0eOUR DOTS ABOVE'
'\nOUR FIFTHS'
'\x0cOUR INTEGRAL'
'\x0eOUR OBOLS SIGN'
'\x07OUR OF '
'\x10OUR POINTED STAR'
'\tOURA SIGN'
'\x05OURCE'
'\x07OURTEEN'
'\x11OURTEEN FULL STOP'
'\rOURTH SUBUNIT'
'\x0eOUSING THUNDER'
'\x03OUT'
'\x04OUT '
'\x07OUT HUB'
'\nOUTER JOIN'
'\x0fOUTH EAST ARROW'
'\tOUTH WIND'
'\x19OUTLINED RIGHTWARDS ARROW'
'\x03OVE'
'\x07OVER AN'
'\x08OVER ASH'
'\tOVER ASH '
'\x08OVER BU '
'\x07OVER DU'
'\x13OVER E NUN OVER NUN'
'\x08OVER GA2'
'\tOVER GAN2'
'\x08OVER GI4'
'\x0eOVER GUD LUGAL'
'"OVER IGI SHIR OVER SHIR UD OVER UD'
',OVER KASKAL LAGAB TIMES U OVER LAGAB TIMES U'
'\x14OVER LEFTWARDS ARROW'
'\x16OVER LEFTWARDS HARPOON'
'\tOVER LONG'
'\tOVER MUSH'
'\x08OVER NUN'
'\x15OVER RIGHTWARDS ARROW'
'\x17OVER RIGHTWARDS HARPOON'
'\x08OVER SAG'
'\tOVER SHE '
'\x16OVER SHIR BUR OVER BUR'
'"OVER TAB NI OVER NI DISH OVER DISH'
'\x08OVER TIR'
'\x19OVER TWO DOTS PUNCTUATION'
'\x07OVER U '
'\x07OVERBAR'
'\x08OVERLAID'
'\x17OVERLAPPING LOGICAL AND'
'\x07OVERLAY'
'\x08OVERLINE'
'\x08OVERRIDE'
'\x02OW'
'\x03OW '
'\x07OW LINE'
'\x05OW PA'
'\x06OW TIE'
'\x12OW TONE APOSTROPHE'
'\x13OW-9 QUOTATION MARK'
'\x05OWEL '
'\nOWEL SIGN '
'\x04OWER'
'\x05OWER '
'\x0fOWER HALF BLACK'
'\tOWER LEFT'
'\x11OWER NUMERAL SIGN'
'*OWER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW'
'\x07OWILO S'
'\x03OWN'
'\x08OWN TACK'
'\rOWN-POINTING '
'\x07OX BACK'
'\x07OX LINE'
'\x04OXIA'
'\x02OY'
'\x06OYANNA'
'\x03OZE'
'\x01P'
'\x02P '
'\tP DIGRAPH'
'\x18P DIRECTIONAL FORMATTING'
'\x08P HALF O'
'\x11P ON BLACK SQUARE'
'\x17P SYMBOL FOR LIGHTHOUSE'
'\x06P TACK'
'\x02P0'
'\x02PA'
'\x17PA OVER PA GAR OVER GAR'
'\tPAA-PILLA'
'\x05PAATO'
'\x04PACE'
'\tPADE SUIT'
'\rPAIRED ARROWS'
'\x08PAIRTHRA'
'\x0cPALATAL HOOK'
'\x07PALLAWA'
'\x08PALOCHKA'
'\x06PALUTA'
'\x07PANESE '
'\x07PANSIOS'
'\tPANYANGGA'
'\x0ePAO KAREN TONE'
'\x0cPAP PLUS PAP'
'\x13PARAGRAPH SEPARATOR'
'\x0bPARAKALESMA'
'\x0bPARALLEL TO'
'\x0bPARENTHESIS'
'\x14PARENTHESIS ORNAMENT'
'\x0ePARESTIGMENON '
'\x06PARKLE'
'\x11PARTING TONE MARK'
'\x07PARTURE'
'\x05PASEQ'
'\x05PATAH'
'\x05PATAK'
'\x08PAVIYANI'
'\x04PAWN'
'\x07PAYANNA'
'\x07PAYEROK'
'\x05PCHA '
'\x02PE'
'\x08PE DRIVE'
'\x04PEAT'
'\x06PECIAL'
'\x07PECTIVE'
'\nPEDAL MARK'
'\x03PEE'
'\x08PEE SIGN'
'\x05PEECH'
'\x04PEEP'
'\x07PEGERMA'
'\x03PEH'
'\x05PEITH'
'\x04PEN '
'\x10PEN CENTRE CROSS'
'\x05PEN E'
'\x05PEN O'
'\x05PEN-P'
'\x06PENCIL'
'\nPENDICULAR'
'\x07PENGKAL'
'\tPENTASEME'
'\x05PEPET'
'\x04PER '
'\x0cPER-EM SPACE'
'\x07PERATOR'
'\nPERCUSSIVE'
'\x08PERFECTA'
'\rPERFECTA REST'
'\x19PERFECTUM CUM PROLATIONE '
'\x12PERFIXED LETTER RA'
'\x0fPERIAL ARAMAIC '
'\x0bPERISPOMENI'
'\x04PERS'
'\x07PERSAND'
'\x06PERSET'
'\tPERSET OF'
'\x16PERSET OF NOR EQUAL TO'
'\x08PERSIAN '
'\x0fPERTHO PEORTH P'
'\x07PERVISE'
'\x02PH'
'\x03PHA'
'\x1bPHARYNGEAL VOICED FRICATIVE'
'\x0cPHEME JOINER'
'\x03PHI'
'\x07PHIEUPH'
'\x0bPHNAEK MUAN'
'\x06PHRASE'
'\x07PHUTHAO'
'\x02PI'
'\x05PI RO'
'\x03PIC'
'\x04PICK'
'\tPIDERY HA'
'\x05PIEUP'
'\x03PII'
'\x04PII '
'\x03PIN'
'\x04PING'
'\x11PINWHEEL ASTERISK'
'\rPINWHEEL STAR'
'\x06PIRIT '
'\x05PITER'
'\x10PLACEHOLDER MARK'
'\x13PLACEMENT CHARACTER'
'\x04PLE '
'\x10PLE MEASURE REST'
'\x03PLI'
'\nPLICATION '
'\x0ePLITTING APART'
'\x06PLOPHU'
'\x04PLUM'
'\x04PLUS'
'\nPLUS BELOW'
'\nPLUS ERIN2'
'\nPLUS NAGA '
'\rPLUS OPERATOR'
'\x08PLUS SAR'
'\tPLUS SIGN'
'\x0fPLUS SIGN BELOW'
'\x02PM'
'\x0cPOETRY MARK-'
'\x0cPOGEGRAMMENI'
'\x05POINT'
'\x1ePOINTED RECTILINEAR BLACK STAR'
'\x07POINTER'
'\tPOINTING '
'\x18POINTING DOWNWARDS ABOVE'
'\x0ePOINTING INDEX'
'\x16POINTING UPWARDS BELOW'
'\x06POKED '
'\x05POLI '
'\x07POMOFO '
'\x05PONSE'
'\x04POSE'
'\x08POSITION'
'\x10POSTPOSITION MEN'
'\tPOSTROPHE'
'\x03POT'
'\x02PP'
'\x03PPA'
'\nPPA SYMBOL'
'\x05PPAGE'
'\x04PPER'
'\rPPOSING LUGAL'
'\tPPOSITION'
'\x07PPROACH'
'"PPROXIMATELY NOR ACTUALLY EQUAL TO'
'\x02PR'
'\nPRALINEAR '
'\x16PRECEDED BY APOSTROPHE'
'\x08PRECEDES'
'\x11PRECEDING SOLIDUS'
'\x10PRECEDING SUBSET'
'\x10PRECHGESANG STEM'
'\x07PRENKHA'
'\rPREPONDERANCE'
'\x07PRESENT'
'\x07PRICORN'
'\x04PRIL'
'\x05PRIME'
'\x05PRING'
'\x05PRINT'
'\x0fPRIOT SYLLABLE '
'\x0fPRISHTHAMATRA E'
'\x03PRO'
'\x07PRODUCT'
'\x14PROLONGED SOUND MARK'
'\x0cPROTOS ICHOS'
'\x05PSILI'
'\x06PSILON'
'\x07PTHAHA '
'\x05PTIVE'
'\x05PTUNE'
'\x02PU'
'\x0bPUNCTUATION'
'\x0cPUNCTUATION '
'\x16PUNCTUATION KUNDDALIYA'
'\x11PUNCTUATION SIGN '
'\x08PUSHPIKA'
'\x02PV'
'\x03PWA'
'\x02PY'
'\x01Q'
'\x03Q00'
'\x02QA'
'\x04QAAF'
'\x05QAAFU'
'\x03QAF'
'\x1eQAF WITH LAM WITH ALEF MAKSURA'
'\x08QAIRTHRA'
'\x06QAMATS'
'\x04QAPH'
'\x03QAR'
'\x05QATAN'
'\x04QEF '
'\x06QETANA'
'\x05QITSA'
'\x02QN'
'\x03QOF'
'\x04QOPA'
'\x04QOPH'
'\x03QOT'
'\x02QU'
'\x03QUA'
'\x04QUAD'
'\x15QUADRANT CIRCULAR ARC'
'\x0fQUADRUPLE ARROW'
'\x0fQUADRUPLE DASH '
'\nQUALS SIGN'
'\x10QUALS SIGN BELOW'
'\x05QUARE'
'\x06QUARE '
'\x0bQUARE BELOW'
'\rQUARE BRACKET'
'\x06QUARED'
'\x07QUARIUS'
'\x07QUARTER'
'\x0bQUARTER ASH'
'\rQUARTER BLOCK'
'\x08QUARTERS'
'\x0eQUARTERS BLOCK'
'\rQUARTERS SIGN'
'\x11QUAT REVERSED ESH'
'\x05QUEEN'
'\x08QUESTION'
'\rQUESTION MARK'
'\x13QUESTION MARK ABOVE'
'\x03QUF'
'\x05QUILL'
'\x0eQUINARIUS SIGN'
'\x0bQUIQUADRATE'
'\x0cQUIRREL TAIL'
'\x05QUIRY'
'\nQUISH QUAD'
'\x0eQUOTATION MARK'
'\x17QUOTATION MARK ORNAMENT'
'\tQUSHSHAYA'
'\x01R'
'\x02R '
'\x07R ABOVE'
'\x10R PLUS GAN2 TENU'
'\tR PLUS RA'
'\x06R THAN'
'\x07R TSHES'
'\x0fR WITH FISHHOOK'
'\x02R0'
'\x02R2'
'\nR2 PLUS SU'
'\x02R7'
'\x02RA'
'\x07RA REPA'
'\x07RA SIGN'
'\x03RAA'
'\x0bRACHMA SIGN'
'\x05RACHY'
'\nRACTER TIE'
'\x10RACTION ONE HALF'
'\x08RADICAL '
'\x03RAE'
'\x04RAEA'
'\x04RAFE'
'\x07RAGANA '
'\nRAGGISMATA'
'\x0cRAH BEN YOMO'
'\x03RAI'
'\x05RAIDA'
'\x10RAIDO RAD REID R'
'\nRAINIAN IE'
'\x17RAISED OMISSION BRACKET'
'\x07RAKHANG'
'\tRAL HEART'
'\x03RAM'
'\x04RAM '
'\x08RAM FOR '
'\x04RAMA'
'\x08RAMMA GG'
'\x03RAN'
'\x19RANCH BANK IDENTIFICATION'
'\x0cRANCHING OUT'
'\x07RANGKEP'
'\x0bRANSMISSION'
'\x05RANUS'
'\x07RARIETY'
'\x05RASHA'
'\x05RASS '
'\x05RATER'
'\x05RATHA'
'\x08RAUGHTS '
'\x0bRAVE ACCENT'
'\x03RAY'
'\x07RAYANNA'
'\x03RCH'
'\x07RCHAIC '
'\x0cRCHAIC SAMPI'
'\x07RCHAION'
'\x05RCHID'
'\x05RCURY'
'\x02RD'
'\x03RD '
'\x07RD SIGN'
'\tRDEL DKAR'
'\x08RDEL NAG'
'\x0bRDHAVISARGA'
'\x07RDO RJE'
'\x02RE'
'\x07READING'
'\x0bREAKTHROUGH'
'\x04REAT'
'\x07REAT SA'
'\x0eREATIVE HEAVEN'
'\x08REATNESS'
'\x0fRECEPTIVE EARTH'
'\x10RECORD SEPARATOR'
'\x08RECORDER'
'\x1cRECT CURRENT SYMBOL FORM TWO'
'\tRECTANGLE'
'\x1cRECTANGULAR PATH AROUND POLE'
'\x16RECTILINEAR BLACK STAR'
'\nRED DRAGON'
'\x03REE'
'\x04REE '
'\x0bREE HUNDRED'
'\x08REE MARK'
'\x17REE VARIATION SELECTOR '
'\x0eREE-LINE STAFF'
'\x05REEK '
'\x0cREFACE COLON'
'\x03REH'
'\x04REH '
'\x0eREH FINAL FORM'
'\x04REIA'
'\x05RELAA'
'\nRENCY SIGN'
'\x06RENGTH'
'\x04REPA'
'\x0cREPONDERANCE'
'\x07REREKAN'
'\x05REREN'
'\x03RES'
'\x0bRESCENT BAR'
'\x04RESH'
'\x07RESILLO'
'\x07RESSION'
'\x04REST'
'\x0eRETROFLEX HOOK'
'\x08REVERSE '
'\x0cREVERSE MARK'
'\x0fREVERSE SOLIDUS'
'\x08REVERSED'
'\tREVERSED '
'\x15REVERSED FEATHER MARK'
'\nREVERSED I'
'\x14REVERSED ONE HUNDRED'
'\x0fREVERSED OPEN E'
'\x05REVIA'
'\x0eRFACE INTEGRAL'
'\x03RGE'
'\x06RGIAN '
'\x06RGLASS'
'\x03RGO'
'\x04RGON'
'\x04RGU2'
'\x03RHO'
'\nRHO SYMBOL'
'\x02RI'
'\x05RIAC '
'\x0cRIANGLE DOWN'
'\x1fRIANGLE-HEADED RIGHTWARDS ARROW'
'\x0fRIANGULAR COLON'
'\x11RIATION SELECTOR-'
'\x05RICEM'
'\x05RIEUL'
'\x03RIG'
'\x05RIGHT'
'\x06RIGHT '
'\nRIGHT AND '
'\x14RIGHT ANGLE WITH DOT'
'\x1bRIGHT ARC LESS-THAN BRACKET'
'\x0cRIGHT ARROW '
'\x11RIGHT ARROW ABOVE'
'\x17RIGHT DIAGONAL ELLIPSIS'
'\x19RIGHT DIAGONAL HALF BLACK'
'\x0cRIGHT DOUBLE'
'\x10RIGHT DOWN BARB '
'\nRIGHT HALF'
'\x10RIGHT HALF BLACK'
'\x11RIGHT HALF CIRCLE'
'\x0fRIGHT HALF RING'
'\rRIGHT HARPOON'
'\x0bRIGHT HEAVY'
'\nRIGHT HOOK'
'\x0bRIGHT LIGHT'
'\x11RIGHT PARENTHESIS'
'\x1aRIGHT PARENTHESIS ORNAMENT'
'\x0eRIGHT QUADRANT'
'\x14RIGHT QUADRANT BLACK'
'\x0fRIGHT RERENGGAN'
'\x0cRIGHT SINGLE'
'\x13RIGHT TO LOWER LEFT'
'%RIGHT TORTOISE SHELL BRACKET ORNAMENT'
'\x0eRIGHT TRIANGLE'
'\x0fRIGHT TURNSTILE'
'\x0bRIGHT-HAND '
'\x14RIGHT-POINTING ANGLE'
'#RIGHT-POINTING ANGLE QUOTATION MARK'
'\nRIGHTWARDS'
'\x10RIGHTWARDS ARROW'
'&RIGHTWARDS ARROW ABOVE LEFTWARDS ARROW'
'\x11RIGHTWARDS ARROWS'
'!RIGHTWARDS HARPOON WITH BARB DOWN'
'\x1fRIGHTWARDS HARPOON WITH BARB UP'
'\x18RIGHTWARDS THEN CURVING '
'\x0fRIGHTWARDS TICK'
'\nRIGINAL OF'
'%RIGVEDIC KASHMIRI INDEPENDENT SVARITA'
'\x06RIISAP'
'\x06RIKRIK'
'\x07RILLIC '
'\x04RIME'
'\x04RIN2'
'\x04RING'
'\x05RING '
'\nRING ABOVE'
'\x1fRING OVER TWO RINGS PUNCTUATION'
'\x0cRING OVERLAY'
'\x1fRINGS OVER ONE RING PUNCTUATION'
'\x08RINHIEUH'
'\x0cRION CHRONON'
'\x03RIP'
'\x06RIPLE '
'\x0bRIPLE ARROW'
'\x1aRIPLE DOT PUNCTUATION MARK'
'\x0bRIPLE PRIME'
'\rRIPLE SVARITA'
'\x0eRIPLE UNDERDOT'
'\x1bRIPLE VERTICAL BAR OPERATOR'
'\x04RIPT'
'\x06RIPT G'
'\x06RISEME'
'\x04RISH'
'\x07RISIMOU'
'\x0fRISING DIAGONAL'
'\x15RISING DIAGONAL SLASH'
'\x0bRISING DOTS'
'\x0bRISING TONE'
'\x10RISING TONE MARK'
'\tRISPOMENI'
'\x05RITSI'
'\x04RITU'
'\x08RIYOOSAN'
'\tRIZONTAL '
'\x10RIZONTAL ELLIPSE'
'\x02RK'
'\x0eRK NOON GHUNNA'
'\x08RK SHADE'
'\x06RKAANU'
'\x04RKLE'
'\x03RMA'
'\x0fRMAN PENNY SIGN'
'\x18RMITIAN CONJUGATE MATRIX'
'\x07RMUKHI '
'\x02RN'
'\x0cRNAM BCAD MA'
'\x0fRNAMENT STROKE-'
'\x05RNED '
'\tRNEY PARA'
'\nRNING SIGN'
'\x02RO'
'\x04ROA '
'\nROAD OMEGA'
'\x04ROAR'
'\x06ROBANG'
'\x03ROC'
'\nROEZENIAN '
'\x03ROG'
'\x07ROGRESS'
'\tROJECTION'
'\rROKEE LETTER '
'\x07ROKEN L'
'\x0bROKUTASTI A'
'\x03RON'
'\x0eRONIAN SIGN ET'
'\x05RONIS'
'\x0bRONTHISMATA'
'\x04ROOK'
'\x03ROP'
'\x0bROR-BARRED '
'\rROSGEGRAMMENI'
'\x04ROSH'
'\x04ROSS'
'\x0bROSS ACCENT'
'\x0eROSS ON SHIELD'
'\x0bROSSED-TAIL'
'\rROSSING LANES'
'\x1bROTATED FLORAL HEART BULLET'
'\x04ROTO'
'\x07ROTUNDA'
'\x16ROUND A POINT OPERATOR'
'\x0cROUNDED ZERO'
'\x04ROUT'
'\rROW POINTING '
'\tROW WITH '
'\x0cROWNING FACE'
'\rRPENTRY PLANE'
'\x0bRPOON ABOVE'
'\tRPORATION'
'\x04RPSE'
'\x03RQA'
'\x02RR'
'\x05RRECT'
'\x07RRECTUS'
'\x06RRED O'
'\x0cRRESPONDS TO'
'\rRRIAGE RETURN'
'\rRRIAGE SYMBOL'
'\x06RRIER '
'\x04RROI'
'\x04RROW'
'\x13RROW NO-BREAK SPACE'
'\x16RROW WITH ROUNDED HEAD'
'\x03RRY'
'\x08RSECTION'
'\x06RSHANA'
'\nRSI SYMBOL'
'\x06RSIAN '
'\x10RST QUARTER MOON'
'\x02RT'
'\x03RT '
'\x04RT T'
'\x04RTAR'
'\x03RTE'
'\tRTER MARK'
'\tRTER NOTE'
'\x03RTH'
'\x07RTHIAN '
'\x17RTOISE SHELL BRACKETED '
'\x03RTY'
'\x02RU'
'\x04RUCK'
'\x04RUDA'
'\x05RUDAA'
'\x03RUE'
'\x05RUHUA'
'\x04RUIS'
'\x04RUKU'
'\tRUM CLEF-'
'\x14RUMAI PALAUNG TONE-5'
'\x04RUNA'
'\x04RUNG'
'\x06RUPEE '
'\nRUPEE MARK'
'\nRUPEE SIGN'
'\x05RUSH '
'\x04RUSI'
'\x04RUTU'
'\x02RV'
'\nRVICE MARK'
'\x02RY'
'\x11RYBLION BASE SIGN'
'\x08RYNGEAL '
'\x0bRYVNIA SIGN'
'\x01S'
'\x02S '
'\x07S ABOVE'
'\x0cS ABOVE SIGN'
'\x07S BELOW'
'\tS DIGRAPH'
'\x07S ICHOS'
'\x08S INSIDE'
'\rS KAI APOTHES'
'\x03S O'
'\x1aS OVER ONE DOT PUNCTUATION'
'\x0cS SUBPUNCTIS'
'\x02S0'
'\x02SA'
'\x04SA-I'
'\x06SAADIY'
'\x1eSAD WITH LAM WITH ALEF MAKSURA'
'\x04SADI'
'\x03SAG'
'\x03SAL'
'\rSAL PLUS TUG2'
'\x03SAM'
'\x07SAMPHAO'
'\x05SAMPI'
'\rSAMYOK SANNYA'
'\x04SANG'
'\x08SANGSIOS'
'\x0bSANS-SERIF '
'\x08SANYAKA '
'\x05SARGA'
'\x05SASA '
'\x05SASAK'
'\x03SAT'
'\x05SAUIL'
'\x07SAYANNA'
'\x0cSAZ IS ISS I'
'\nSBUB -CHAL'
'\nSCAN LINE-'
'\x05SCAPE'
'\x05SCENT'
'\x04SCES'
'\x05SCHWA'
'\x14SCRIPTION CHARACTER '
'\x02SE'
'\x03SE '
'\nSE-CREE SK'
'\x06SEBALL'
'\x0bSECOND MARK'
'\x0eSECOND SUBUNIT'
'\x04SECT'
'\x07SECTION'
'\x0cSECTION MARK'
'\x0cSECTION SIGN'
'\x04SED '
'\x04SEEN'
'\x05SEGOL'
'\x04SELF'
'\x16SEMI-VOICED SOUND MARK'
' SEMICIRCULAR ANTICLOCKWISE ARROW'
'\x1dSEMICIRCULAR PATH AROUND POLE'
'\tSEMICOLON'
'\x0fSEMIVOWEL SIGN '
'\x05SENTO'
'\tSEPARATOR'
'\x14SEPARATOR KEY SYMBOL'
'\x14SEPARATOR MIDDLE DOT'
'\tSEPTEMBER'
'\x10SERIFS AT BOTTOM'
'\x07SERTION'
'\x03SET'
'\rSEVEN EIGHTHS'
'\x13SEVEN EIGHTHS BLOCK'
'\x07SEXTILE'
'\x04SEYE'
'\nSGOR RTAGS'
'\x02SH'
'\x03SH '
'\x13SH PLUS HU PLUS ASH'
'\nSH PRODUCT'
'\x07SH TAIL'
'\x0cSH ZIDA TENU'
'\x03SH2'
'\x03SHA'
'\x04SHA3'
'\x0bSHAAYATHIYA'
'\x04SHAD'
'\x05SHADE'
'\x15SHADOWED WHITE SQUARE'
'\x04SHAN'
'\x05SHAN '
'\x0eSHAN MEDIAL WA'
'\x05SHANG'
'\x04SHAR'
'\x05SHAR2'
'\x05SHARA'
'\x05SHARP'
'\nSHARP SIGN'
'\x05SHARU'
'\x06SHAYIM'
'\x03SHE'
'\x04SHE3'
'\x05SHED '
'\x0cSHED BARLINE'
'\x04SHEI'
'\x0bSHEQEL SIGN'
'\x05SHESH'
'\x07SHESHIG'
'\x05SHEYE'
'\x05SHGAB'
'\x05SHIMA'
'\x0fSHITA PLUS GISH'
'\x08SHKIR KA'
'\x08SHOE JOT'
'\nSHOE STILE'
'\x05SHOOK'
'\x05SHORT'
'\x06SHORT '
'\x07SHORT A'
'\x15SHORT LEFTWARDS ARROW'
'\x0fSHORT OVER LONG'
'\x16SHORT RIGHTWARDS ARROW'
'\x0cSHORT RIKRIK'
'\x16SHORT VERTICAL STROKES'
'\x04SHTA'
'\x04SHU2'
'\x04SHYA'
'\x02SI'
'\x1dSIBE SYLLABLE BOUNDARY MARKER'
'\x03SIC'
'\x06SICKLE'
'\x05SICLE'
'\x06SIEUNG'
'\x08SIFISTON'
'\x0cSIGMA SYMBOL'
'\x04SIGN'
'\x05SIGN '
'\rSIGN AVAGRAHA'
'\x08SIGN LAE'
'\x07SIGN PA'
'\rSIGN PAMUDPOD'
'\x0bSIGN VIRAMA'
'\x04SIKI'
'\x05SILA3'
'\x04SILI'
'\rSILI PNEUMATA'
'\x17SING DIAGONAL CROSSING '
'\x0bSINGLE AND '
'\x14SINGLE DOT TONE MARK'
'\x12SINGLE PUNCTUATION'
'\x0cSINGLE-LINE '
'\x18SINGLE-LINE NOT EQUAL TO'
'\x04SINK'
'\x05SION '
'\x04SIOS'
'\x04SIS '
'\x03SIX'
'\tSIXTEENTH'
'\x0fSIXTEENTH NOTES'
'\nSIXTEENTHS'
'\x05SIXTH'
'\x06SIXTHS'
'\x03SJE'
'\x04SKAL'
'\x06SKAPI '
'\x08SKLIRON '
'\x08SLANTED '
'\x10SLANTED EQUAL TO'
'\x05SLASH'
'\x04SLUR'
'\x03SMA'
'\x06SMALL '
'\x18SMALL ARABIC LETTER TAH '
'$SMALL ARABIC LETTER TAH AND TWO DOTS'
'\x10SMALL CAPITAL EL'
'\x0cSMALL CIRCLE'
'\x12SMALL CIRCLE ABOVE'
'\x07SMALL L'
'\rSMALL LETTER '
'\x0eSMALL LETTER J'
'\x0eSMALL TRIANGLE'
'\x07SMALL V'
'\rSMALL V ABOVE'
'\rSMALL V BELOW'
'\tSMALL YUS'
'\x07SMANYA '
'\x08SNA LDAN'
'\x02SO'
'\x03SO '
'\tSOF PASUQ'
'\x05SOL S'
'\x0cSOLATED FORM'
'\x07SOLIDUS'
'\x17SOLIDUS BINARY RELATION'
'\x03SON'
'\x04SONG'
'\x03SOO'
'\x06SOUNAP'
'\x0eSOUTH ARABIAN '
'\x10SOUTH EAST ARROW'
'\x05SPACE'
'\nSPACE MARK'
'\x13SPACING CANDRABINDU'
'\x06SPATHI'
'\x08SPERSION'
'\x06SPIRAL'
'\x0bSPIRATED FA'
'\tSPIRITUS '
'\x0fSPOKED ASTERISK'
'\x07SPRINGS'
'\x06SQUARE'
'\x0eSQUARE BRACKET'
'\x07SQUARED'
'\x08SQUARED '
'\x11SQUARED TIMES KUR'
'\x0eSQUIGGLE ARROW'
'\x02SS'
'\x07SS-THAN'
'\x08SS-THAN '
'\x0cSS-THAN SIGN'
'\x03SSA'
'\nSSANGARAEA'
'\x0bSSANGKIYEOK'
'\nSSANGPIEUP'
'\tSSANGSIOS'
'\x05SSERA'
'\x08SSESSION'
'\x0bSSIVE-PULL-'
'\x02ST'
'\x0fST QUARTER MOON'
'\x0fST SYRIAC CROSS'
'\x03STA'
'\rSTABLE SYMBOL'
'\x06STANCE'
'\x06STANCY'
'\x04STAR'
'\x07STATERS'
'\x0fSTERESIS SYMBOL'
'\x07STERING'
'\x07STERISK'
'\x08STERISK '
'\x10STERISK OPERATOR'
'\rSTERTIUS SIGN'
'\x05STILE'
'\x07STIMATE'
'\x04STLE'
'\x06STOLI '
'\x04STOP'
'\x0bSTORIC SITE'
'\x05STORM'
'\x13STRATIAN FIFTY MNAS'
'\x10STRING FRETBOARD'
'\x06STROFO'
'\x06STROKE'
'\x07STROKE '
'\x19STROKE AND TWO DOTS ABOVE'
'\x0fSTROKE NOT SIGN'
'\x0eSTROKE OVERLAY'
'\x18STROKE THROUGH DESCENDER'
'\nSTROM SIGN'
'\x07STRUCK '
'\x03STU'
'\x02SU'
'\x03SU '
'\x06SUBSET'
'\x13SUBSTITUTION MARKER'
'\x07SUCCEED'
'\x08SUCCEEDS'
'\x04SUIT'
'\x04SUKU'
'\x05SUKUN'
'\x07SUKUUDO'
'\x03SUM'
'\x04SUNG'
'\x1dSUPERSCRIPT ALEF INITIAL FORM'
'\x1eSUPERSCRIPT ALEF ISOLATED FORM'
'\x08SUPERSET'
'\x0cSUR OVER SUR'
'\x06SURANG'
'\x0eSURROUND FROM '
'\x07SVARITA'
'\nSWASH TAIL'
'\x06SWORDS'
'\x02SY'
'\tSYLLABLE '
'\x06SYMBOL'
'\x07SYMBOL '
'\x0bSYMBOL FOR '
'\x12SYMMETRIC SWAPPING'
'\x16SYMPTOTICALLY EQUAL TO'
'\x07SYNAGMA'
'\rSYNDESMOS NEO'
'\tSYNTHETON'
'\x06SYOUWA'
'\x0bSYURA SASAK'
'\x01T'
'\x02T '
'\x07T ABOVE'
'\x07T BELOW'
'\x18T BLACK RIGHTWARDS ARROW'
'\x07T MINUS'
'\x07T RIGHT'
'\x02T0'
'\x02TA'
'\x03TA '
'\x07TA MARK'
'\x03TAA'
'\x08TAALUJA '
'\x03TAB'
'\x19TAB OVER TAB GAR OVER GAR'
'\tTABE SIGN'
'\x04TACK'
'\x05TACK '
'\nTACK BELOW'
'\x03TAH'
'\x08TAI LUE '
'\x06TAIKHU'
'\x04TAIL'
'\x04TAIN'
'\x07TAISYOU'
'\x04TAK4'
'\x06TAKANA'
'\tTAKHALLUS'
'\x03TAL'
'\x08TAL MARK'
'\nTAL RUNOUT'
'\x05TAL S'
'\x07TALENTS'
'\x1bTALIC LATIN CAPITAL LETTER '
'\x07TALL AA'
'\x03TAM'
'\x06TAMING'
'\x03TAN'
'\x11TAN ISOLATED FORM'
'\tTANDSTILL'
'\x03TAO'
'\x03TAR'
'\x08TART OF '
'\x13TART OF RUB EL HIZB'
'\x03TAS'
'\x06TATED '
'\x06TAU RO'
'\x06TAUROS'
'\x03TAV'
'\x04TAWA'
'\x07TAYANNA'
'\x03TCH'
'\x07TCHFORK'
'\x02TE'
'\x0cTE SEPARATOR'
'\x06TE TSE'
'\x18TEARDROP-SPOKED ASTERISK'
'"TEARDROP-SPOKED PROPELLER ASTERISK'
'\x04TED '
'\x06TEDUNG'
'\x04TEEN'
'\x15TEEN POINTED ASTERISK'
'\x05TEGEH'
'\x03TEH'
'\nTELEGRAPH '
'\x10TELOUS ICHIMATOS'
'\nTEMPLATION'
'\x03TEN'
'\x04TEN '
'\x11TEN THOUSAND SIGN'
'\x1aTENDED ARABIC-INDIC DIGIT '
'\x0bTENS DIGIT '
'\x04TENT'
'\x04TENU'
'\x03TER'
'\x04TER '
'\nTER SYMBOL'
'\x05TERIS'
'\nTERMINATOR'
'\x06TERNAT'
'\nTERNATIVE '
'\x19TERNION INTEGRAL OPERATOR'
'\x07TERNITY'
'\x06TERON '
'\x11TERSYLLABIC TSHEG'
'\nTESE CROSS'
'\x0eTETARTOS ICHOS'
'\x0bTETRAFONIAS'
'\x04TEXT'
'\x02TH'
'\x03TH '
'\x07TH MARK'
'\x07TH ROOT'
'\x03THA'
'\x0eTHAKA ANUDATTA'
'\x0eTHALAN ETHEL O'
'\x05THAM '
'\x0bTHAM DIGIT '
'\x08THAMASAT'
'\x13THANG LONG ANUSVARA'
'\nTHAPASCAN '
'\x05THEMA'
'\x0bTHEMATICAL '
'\x04THER'
'\x07THESEOS'
'\x0cTHETA SYMBOL'
'\x07THIEUTH'
'\x08THIOPIC '
'\x05THIRD'
'\x06THIRD '
'\rTHIRD SUBUNIT'
'\x06THIRDS'
'\x07THIRDS '
'\x0bTHIRDS SIGN'
'\nTHMIKON N '
'\x03THO'
'\x0cTHODOX CROSS'
'\x04THOR'
'\x06THORA '
'\x08THOUSAND'
'\tTHOUSAND '
'\x0eTHOUSANDS SIGN'
'\x06THREE '
'\x0bTHREE DOTS '
'\x10THREE DOTS ABOVE'
'\x1aTHREE DOTS ABOVE DOWNWARDS'
'\x0eTHREE QUARTERS'
'\x0bTHREE TIMES'
'\x14THROUGH SMALL CIRCLE'
'\x07THUNDER'
'\x03THY'
'\x02TI'
'\x04TIC '
'\x06TICAL '
'\x08TICK IN '
'\x0cTICLOCKWISE '
'\x03TIE'
'\x05TIGMA'
'\x06TIKENO'
'\x06TIKEUT'
'\x04TIKI'
'\x05TILDE'
'\x06TILDE '
'\x0fTILDE DIAERESIS'
'\x0eTILDE OPERATOR'
'\x15TILDE OPERATOR ABOVE '
'\x05TIMES'
'\x06TIMES '
'\tTIMES BAD'
'\x0eTIMES OPERATOR'
'\tTIMES PAP'
'\tTIMES SHE'
'\x0eTIMES SHU TENU'
'\nTIMES SIGN'
'\nTIMES TAK4'
'\x08TIMORION'
'\x04TIN '
'\x08TINGUISH'
'\x05TINNE'
'\x03TIO'
'\x08TION KEY'
'\x13TIONAL DIGIT SHAPES'
'\x04TIP '
'\x05TIPPI'
'\rTIRTA TUMETES'
'\x06TIRYAK'
'\x08TISMOS E'
'\x03TIV'
'\x07TIVATE '
'\x03TJE'
'\x05TKAAN'
'\x03TLE'
'\x07TLINED '
'\x05TMAAU'
'\x05TNESS'
'\x02TO'
'\x03TO '
'\x06TO BAR'
'\tTO CORNER'
'\x12TO LOWER LEFT FILL'
'\x13TO LOWER RIGHT FILL'
'\x08TO-LEFT '
'\tTO-RIGHT '
'\x10TODO SOFT HYPHEN'
'\nTOM SYMBOL'
'\x03TON'
'\x05TON A'
'\x0bTONAL MARK '
'\x05TONE '
'\x08TONE BAR'
'\tTONE MAI '
'\tTONE MARK'
'\x15TONE MARK SGAW KAREN '
'\x05TONE-'
'\x05TONOS'
'\x03TOO'
'\x03TOP'
'\x04TOP '
'\nTOP CORNER'
'\x0eTOP HALF BLACK'
'\rTOP HALF RING'
'\x14TOP SEMICIRCLE ARROW'
' TOP-LIGHTED RIGHTWARDS ARROWHEAD'
'\x06TOPBAR'
'\x16TORTOISE SHELL BRACKET'
'\tTOS ICHOS'
'\x0cTRAGRAM FOR '
'\x05TRAIF'
'\tTRAIGHT U'
'\x07TRAINER'
'\x14TRANSPOSITION MARKER'
'\x06TRAPLI'
'\nTRESS AND '
'\x0bTRESS SIGN '
'\nTRETCHED C'
'\x03TRI'
'\x04TRIA'
'\x08TRIANGLE'
' TRIANGLE-HEADED RIGHTWARDS ARROW'
'\x0fTRIANGULAR MARK'
'\x07TRICAL '
'\x08TRICOLON'
'\x13TRICTED LEFT ENTRY-'
'\x0cTRIPLE DANDA'
'\x0cTRIPLE DASH '
'\x11TRIPLE DASH ARROW'
'\x16TRIPLE RIGHT TURNSTILE'
'\x16TRIPLE VERTICAL STROKE'
'\rTROFLEX CLICK'
'\x12TROFLEX HOOK BELOW'
'\x05TROKE'
'\x0eTROKE NOT SIGN'
'\rTROKE OVERLAY'
'\x0bTRUNCATED A'
'\x02TS'
'\x05TSADI'
'\x05TSERE'
'\x05TSHEG'
'\x02TT'
'\x06TTAVA '
'\x05TTED '
'\tTTED STEM'
'\x19TTED SUBSTITUTION BRACKET'
'\x08TTENTION'
'\x04TTER'
'\x05TTER '
'\x05TTERN'
'\x07TTHACAN'
'\x08TTO MARK'
'\x05TTOCK'
'\x05TTOM '
'\x05TTORU'
'\x02TU'
'\x05TUEUM'
'\x04TUG2'
'!TUG2 OVER TUG2 TUG2 OVER TUG2 PAP'
'\x04TUKI'
'\tTUKWENTIS'
'\x03TUR'
'\x0eTURKIC LETTER '
'\x04TURN'
'\x0bTURN SYMBOL'
'$TURNED COMMA QUOTATION MARK ORNAMENT'
'\x08TURNED M'
'\x13TURNED PADA PISELEH'
'\x04TURU'
'\tTUTEYASAT'
'\x05TUUMU'
'\x0fTVIMADUR SYMBOL'
'\x03TWA'
'\x04TWAA'
'\x05TWEEL'
'\x03TWO'
'\x0eTWO DOT LEADER'
'\x08TWO DOTS'
'\tTWO DOTS '
'\x0eTWO DOTS ABOVE'
'!TWO DOTS ABOVE AND TWO DOTS BELOW'
'\x16TWO HORIZONTAL STROKES'
'#TWO HORIZONTAL STROKES TO THE RIGHT'
'\nTWO SHORTS'
'\nTWO THIRDS'
'\x0eTWO WHITE DOTS'
'\x0fTWO WITH STROKE'
'\x02TY'
'\x06TY SET'
'\nTYPE COLON'
'\x05TYPE-'
'\x05TYR T'
'\x01U'
'\x02U '
'\rU LENGTH MARK'
'\x06U MARK'
'\x08U PLUS U'
'\x0fU PLUS U PLUS U'
'\x1aU REVERSED OVER U REVERSED'
'\x03U U'
'\rU WITH STROKE'
'\x02U0'
'\x02U2'
'\x02U3'
'\nU3 PLUS AN'
'\x02UA'
'\x03UAE'
'\x03UAN'
'\nUARDEDNESS'
'\x08UAREG YA'
'\x03UAT'
'\x08UATRILLO'
'\x02UB'
'\x03UB2'
'\x07UBADAMA'
'\x04UBED'
'\x0eUBHAYATO MUKHA'
'\x05UBITO'
'\x10UBJOINED LETTER '
'\x04UBLE'
'\x05UBLE '
'\x08UBLE BAR'
'\nUBLE DANDA'
'\nUBLE DASH '
'\nUBLE GRAVE'
'\x0fUBLE RING BELOW'
'\x0cUBLE SVARITA'
'\x0bUBLE TONGUE'
'\x14UBLE VERTICAL STROKE'
'\x06UBLE X'
'\x16UBSCRIPT SMALL LETTER '
'\x0cUBSCRIPT TWO'
'\tUBSTITUTE'
'\x13UBSTITUTION BRACKET'
'\x07UBUFILI'
'\x05UBURU'
'\x05UBUTS'
'\x05UCEUS'
'\x02UD'
'\x05UDAAT'
'\x06UDATTA'
'\x03UDY'
'\x02UE'
'\x03UEH'
'\rUFFLE PRODUCT'
'\x06UFISMA'
'\x02UG'
'\x0bUG RTAGS GY'
'\x0fUGMENTATION DOT'
'\x04UGU '
'\x05UGUST'
'\x04UHUR'
'6UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA '
'\x03UJA'
'\x02UK'
'\x05UKARA'
'\x07UKKAKHA'
'\x03UKU'
'\x04UKUN'
'\x03UKY'
'\x02UL'
'\x03UL '
'\x08ULA SIGN'
'\x0bULAR BULLET'
'\x10ULDERED OPEN BOX'
'\x06ULDRON'
'\x0fULGAR FRACTION '
'\x03ULL'
'\x12ULL AND CROSSBONES'
'\x0cULL NOTEHEAD'
'\x08ULL STOP'
'\x08ULLS LEG'
'\x0bULO TWO SUM'
'\x04ULTI'
')ULTIPLICATION SIGN WITH CIRCUMFLEX ACCENT'
'\x03ULU'
'\x04ULU '
'\x04ULUG'
'\x02UM'
'\x07UM IYEK'
'\nUM ROTUNDA'
'\x0fUMAI PALAUNG FA'
'\x04UMAN'
'\nUMAN EARTH'
'\nUMBER SIGN'
'\tUMED HEAD'
'\x08UMMATION'
'\x05UMMER'
'\x03UMX'
'\x02UN'
'\x0cUN WITH RAYS'
'\x04UNAH'
'\x04UNAP'
'\x06UNATE '
'\x12UNATE SIGMA SYMBOL'
'\x04UNAV'
'\nUNCIA SIGN'
'\x0bUNCTUATION '
'\x10UNCTUATION SPACE'
'\x04UND '
'\x08UND SIGN'
'\x05UNDER'
'\x0eUNDER RELATION'
'\x08UNDERBAR'
'\x08UNDERTIE'
'\x07UNDRED '
'\x03UNG'
'\tUNGSEONG '
'\x05UNION'
'\x0eUNION OPERATOR'
'\x11UNION WITH SERIFS'
'\x0bUNIT DIGIT '
'\x0eUNIT SEPARATOR'
'\x05UNITY'
'\x0bUNJO WYNN W'
'\nUNKIA SIGN'
'\x04UNNY'
'\x05UNOO '
'\x03UNT'
'\x06UNTAIN'
'\x02UO'
'\x03UON'
'\x04UON '
'\x03UOP'
'\x02UP'
'\x03UP '
'\x07UP AND '
'\x11UP AND HORIZONTAL'
'\x08UP ARROW'
'\x0cUP ARROWHEAD'
'\x12UP ARROWHEAD BELOW'
'\x06UP BOW'
'\nUP HARPOON'
'\x08UP HEAVY'
'\x1cUP HEAVY AND LEFT DOWN LIGHT'
'\x1dUP HEAVY AND RIGHT DOWN LIGHT'
'\x13UP HORIZONTAL HEAVY'
'\x13UP HORIZONTAL LIGHT'
'\x08UP LIGHT'
'\x07UP MARK'
'\x0eUP RIGHT BARB '
'\x07UP TACK'
'\x10UP-OUTPUT SYMBOL'
'\x0bUPADHMANIYA'
'\rUPERIMPOSED X'
'\x10UPERSCRIPT ALAPH'
'\x0fUPERSCRIPT ALEF'
'\x04UPLE'
'\x05UPLE '
'\rUPONDIUS SIGN'
'\x06UPPER '
'\x0cUPPER CORNER'
'\tUPPER DOT'
'\nUPPER HALF'
'\nUPPER HOOK'
'\x16UPPER RIGHT AND LOWER '
'+UPPER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW'
'\x18UPRIGHT RECTANGULAR ZERO'
'\x07UPSILON'
'\rUPSILON WITH '
'\tUPTSTIMME'
'\x06UPTURN'
'\x18UPWARD POINTING TRIANGLE'
'\x07UPWARDS'
'\x1cUPWARDS AND RIGHTWARDS ARROW'
'\rUPWARDS ARROW'
'\x1fUPWARDS HARPOON WITH BARB RIGHT'
'\x02UQ'
'\x02UR'
'\nUR CORNERS'
'\nUR HUNDRED'
'\nUR YIG MGO'
'\x03UR-'
'\x03URA'
'\tURAMAZDAA'
'\x05URAMU'
'\tURASHTRA '
'\x07URATION'
'\x04URCH'
'\x04URDA'
'\x05URDA '
'\x03URE'
'\x07URGLASS'
'\x05URITY'
'\x03URL'
'\x0cURLY BRACKET'
'\x03URN'
'\x06URNED '
'\x0bURNED COMMA'
'\x11URNED COMMA ABOVE'
'\tURNED GAN'
'\x13URRENCY SYMBOL BAHT'
'\x03URT'
'\x06URTEEN'
'\x05URTLE'
'\x03URU'
'\x04URUS'
'\tURUZ UR U'
'\x02US'
'\x04USA '
'\x03USE'
"'USED AS KORANIC STOP SIGN ISOLATED FORM"
'\x03USH'
'\rUSHING UPWARD'
'\rUSICAL LEIMMA'
'\x0eUSPENSION MARK'
'\x07USSYERU'
'\x0fUSTER NOTEHEAD '
'\x16USTOMER ACCOUNT NUMBER'
'\x0bUSTRAL SIGN'
'\x02UT'
'\x04UT H'
'\nUT NOT EQU'
'\x07UT TIME'
'\x03UTE'
'\x05UTE A'
'\x04UTER'
'\tUTER JOIN'
'\x0bUTH CORNERS'
'\x0cUTH-SLAVEY K'
'\x05UTIES'
'\nUTION SIGN'
'\x12UTLINED BLACK STAR'
'\x02UU'
'\x06UUMISH'
'\tUURDHAJA '
'\x02UX'
'\x06UYANNA'
'\x02UZ'
'\x06UZEIRO'
'\x0bUZEIRO SIGN'
'\x01V'
'\x08V OVER M'
'\x02V0'
'\x02VA'
'\x05VAAVU'
'\x07VAGRAHA'
'\x0cVAKRAHASANYA'
'\x14VAL WITH OVAL INSIDE'
'\x07VALENT '
'\x0bVAMAGOMUKHA'
'\tVANAGARI '
'\x07VANESE '
'\x05VARIA'
'\x0eVARIANT FORM A'
'\x11VARIANT FORM ASH9'
'\x10VARIANT FORM ESH'
'\x13VARIANT FORM ILIMMU'
'\x11VARIANT FORM IMIN'
'\x12VARIANT FORM LIMMU'
'\x11VARIANT FORM USSU'
'\x13VARIANT WITH SQUARE'
'\x13VARIATION INDICATOR'
'\x0bVARYS ICHOS'
'\x13VASTNESS OR WASTING'
'\x03VAV'
'\x07VAV YOD'
'\x07VAYANNA'
'\x02VE'
'\x03VE '
'\x07VE DOT '
'\x10VE EIGHTHS BLOCK'
'\nVE HUNDRED'
'\x08VE SASAK'
'\rVE-LINE STAFF'
' VED STEM PARAGRAPH SIGN ORNAMENT'
'\x04VEDE'
'\x03VEE'
'\x11VEE WITH UNDERBAR'
'\x06VELOPE'
'\tVELOPMENT'
'\x03VEN'
'\x11VEN EIGHTHS BLOCK'
'\x03VER'
'\x0cVER EQUAL TO'
'\tVER LUGAL'
'\x05VER S'
'\x11VERAGE WITH SLASH'
'\x08VERGENCE'
'\x07VERLINE'
'\tVERLONG A'
'\x17VERSAL RECYCLING SYMBOL'
'\x05VERSE'
'\rVERSE DIVIDER'
'\x13VERSE FINAL BARLINE'
'\x07VERSED '
'\x08VERTICAL'
'\tVERTICAL '
'\x0eVERTICAL ABOVE'
'\nVERTICAL B'
'\x0cVERTICAL BAR'
'\rVERTICAL BAR '
'(VERTICAL BAR AT END OF HORIZONTAL STROKE'
'\x17VERTICAL BISECTING LINE'
'\x0eVERTICAL COLON'
'\rVERTICAL FILL'
'\x0eVERTICAL HEAVY'
'\x0eVERTICAL LIGHT'
'\rVERTICAL LINE'
'\x15VERTICAL LINE OVERLAY'
'\x0fVERTICAL STROKE'
'\x13VERTICAL TABULATION'
'\x10VERTICALLY ABOVE'
'\x08VESSEL B'
'\x07VESTAN '
'\x07VEW NOW'
'\x02VI'
'\x0cVIAN LETTER '
'\rVICE CONTROL '
'\x04VIDA'
'\x04VIDE'
'\x05VIET '
'\x06VILIAN'
'\x07VILIK B'
'\x03VIN'
'\x08VINATION'
'\x04VINE'
'\nVIOUS PAGE'
'\x03VIR'
'\x06VIRAMA'
'\x06VIRIAM'
'\x03VIS'
'\x07VISARGA'
'\x08VISARGA '
'\x0bVISARGA ONE'
'\tVISARGAYA'
'\x08VISION S'
'\x06VIYANI'
'\x02VO'
'\x08VOCALIC '
'\tVOCALIC R'
'\x05VOICE'
'\x15VOICED ITERATION MARK'
'\x18VOICED LARYNGEAL SPIRANT'
'\x11VOICED SOUND MARK'
'\x08VOLUTION'
'\x0eVONIC ASTERISK'
'\x03VOU'
'\x03VOW'
'\x05VOWEL'
'\x06VOWEL '
'\x0fVOWEL SEPARATOR'
'\x0fVOWEL SHORTENER'
'\x0bVOWEL SIGN '
'\rVOWEL SIGN PA'
'\x11VRE TOURNOIS SIGN'
'\x05VRIDO'
'\x0eVRON SNOWFLAKE'
'\x02VU'
'\x03VUU'
'\x03VY '
'\x05VZMET'
'\x01W'
'\x02W '
'\x06W LINE'
'\nW OR MODEL'
'\rW RING INSIDE'
'\x02W0'
'\x02WA'
'\x03WAA'
'\x04WAAK'
'\x05WAAVU'
'\x04WAHA'
'\x03WAI'
'\x04WAIR'
'\x03WAN'
'\x05WARDS'
'\x06WARDS '
'\x0bWARDS ARROW'
'\x11WARDS ARROW BELOW'
'\x0cWARDS BULLET'
'!WARDS HARPOON WITH BARB DOWNWARDS'
'\nWARDS VANE'
'\x14WARE-FUNCTION SYMBOL'
'\x16WASALLAM ISOLATED FORM'
'\x08WASH KAF'
'\tWASH TAIL'
'\x05WATTO'
'\x03WAU'
'\x04WAVE'
'\x0bWAVY HAMZA '
'\rWAVY LOW LINE'
'\rWAVY OVERLINE'
'\x03WAW'
'\x04WAW '
'\rWAW-AYIN-RESH'
'\x03WAZ'
'\x07WAZ EOH'
'\x02WE'
'\x04WEEN'
'\x04WEET'
'\x05WENTY'
'\x06WEORTH'
'\x03WER'
'\x04WER '
'\x05WEST '
'\x12WESTERN PWO KAREN '
'\x17WESTERN PWO KAREN TONE-'
'\x02WG'
'\x05WHITE'
'\x06WHITE '
'\x0bWHITE ARROW'
'\x0cWHITE CIRCLE'
'\x0fWHITE DOT RIGHT'
'\x11WHITE PARENTHESIS'
'\x11WHITE SHOGI PIECE'
'\nWHITE STAR'
'\x12WHITE VERTICAL BAR'
'\x05WIANG'
'\x05WIDE '
'\x11WIDE BRIDGE ABOVE'
'\x06WIDTH '
'\x0cWIGGLY FENCE'
'\x07WIGNYAN'
'\x04WIND'
'\x05WINDU'
'\x05WINJA'
'\x05WISAD'
'\x05WITH '
'\rWITH ASTERISK'
'\nWITH BARB '
'\nWITH CARON'
'\x10WITH CENTRED DOT'
'\x0eWITH DIAERESIS'
'\tWITH DOT '
'\x0eWITH DOT ABOVE'
'\x0eWITH DOT BELOW'
'\x0fWITH DOWN ARROW'
'\x0eWITH FATHATAN '
'\x14WITH FOUR DOTS ABOVE'
'\x10WITH HAMZA ABOVE'
'\tWITH HOOK'
'\x16WITH HORIZONTAL STROKE'
'\rWITH INTEGRAL'
'\x16WITH JEEM INITIAL FORM'
'\nWITH MEEM '
'\x11WITH NOT EQUAL TO'
"'WITH OPEN ARM ENDING IN ARROW POINTING "
'\x0fWITH RAIN DROPS'
'\x0cWITH STROKE '
'\x12WITH STROKE SYMBOL'
'\x06WITH T'
'\x15WITH THREE DOTS ABOVE'
'\rWITH TWO DOTS'
'\rWITH UNDERBAR'
'\x16WITH VOICED SOUND MARK'
'\x13WITH YEH FINAL FORM'
'\x05WLINE'
'\x02WN'
'\x03WN '
'\x08WN ARROW'
'\x0cWN ARROWHEAD'
'\x06WN BOW'
'\x06WN BOX'
'\x07WN TACK'
'\rWN TACK BELOW'
'\x02WO'
'\x03WO '
'\x08WO ABOVE'
'\x08WO DOTS '
'\rWO DOTS ABOVE'
'\rWO DOTS BELOW'
'\x1bWO DOTS BELOW AND DOT ABOVE'
' WO DOTS OVER ONE DOT PUNCTUATION'
'\x18WO DOTS VERTICALLY ABOVE'
'&WO DOTS VERTICALLY BELOW AND SMALL TAH'
'\x07WO FOR '
'\x0fWO HEADED ARROW'
'\x07WO MARK'
'\x06WO OF '
'\nWO SHORTS '
'\x11WO VERTICAL DOTS '
'\x07WO WAEN'
'\rWO-LINE STAFF'
'\x17WO-WAY LEFT WAY TRAFFIC'
'\x08WON SIGN'
'\x0cWORD DIVIDER'
'\x0eWORD SEPARATOR'
'\tWORDSPACE'
'\x04WTIE'
'\x02WU'
'\x05WU318'
'\x04WULU'
'\tWUNG DASH'
'\x04WYNN'
'\x01X'
'\x02X '
'\x0bX DRAWINGS '
'\nX NOTEHEAD'
'\x03X00'
'\x02XA'
'\x05XAGON'
'\x0bXAGRAM FOR '
'\x03XAN'
'\x08XCELLENT'
'\x0fXCLAMATION MARK'
'\x10XCLAMATION MARK '
'\x02XE'
'\x03XEH'
'\x04XEIA'
'\x0bXESTES SIGN'
'\x02XG'
'\tXHAUSTION'
'\x02XI'
'\x03XIA'
'\tXIMATELY '
'\x0cXIRON KLASMA'
'\x02XO'
'\x0eXO EKFONITIKON'
'\x06XO NEO'
'\x02XT'
'\x07XT PAGE'
'\x0fXTEEN FULL STOP'
'\x05XTILE'
'\x05XTRA-'
'\x03XWG'
'\x01Y'
'\x02Y '
'\x07Y MUCH '
'\x11Y ON BLACK SQUARE'
'\x0eY SMALL SQUARE'
'\tY-FOURTH '
'\x03Y00'
'\x02YA'
'\x03YA '
'\x03YAA'
'\x07YAH LI '
'\x0bYAJURVEDIC '
'\x1aYAJURVEDIC MIDLINE SVARITA'
'\x06YAKASH'
'\x05YAMOK'
'\x04YANG'
'\x07YANMAR '
'\x05YANNA'
'\tYANUKITTA'
'\x03YAT'
'\x10YATHOS BASE SIGN'
'\x07YAYANNA'
'\x08YBEYFILI'
'\x06YBOARD'
'\x02YE'
'\tYEAR SIGN'
'\x05YECEK'
'\x03YEE'
'\x03YEH'
'\x04YEH '
'\tYEH ABOVE'
'\x0eYEH FINAL FORM'
'\x11YEH ISOLATED FORM'
'\tYEH WITH '
'\x06YELLOW'
'\x17YELORUSSIAN-UKRAINIAN I'
'\x08YEN SIGN'
'\x05YENAP'
'\x08YENISEI '
'\x0bYEORINHIEUH'
'\x08YER YAGH'
'\x05YEROK'
'\x06YFESIS'
'\x06YGISMA'
'\x02YI'
'\x08YIDDISH '
'\x08YIG MGO '
'\x0fYIG MGO MDUN MA'
'\x14YIG MGO PHUR SHAD MA'
'\x0fYIG MGO SGAB MA'
'\x15YIG MGO TSHEG SHAD MA'
'\x03YIN'
'\x06YIN-DO'
'\x04YIS '
'\x05YIZET'
'\x06YLISMA'
'\x08YLLABLE '
'\x06YMBOL '
'\x15YMPTOTICALLY EQUAL TO'
'\x02YN'
'\x0fYNCHRONOUS IDLE'
'\x03YNN'
'\x02YO'
'\x03YOD'
'\rYOD YOD PATAH'
'\x04YODH'
'\x03YOO'
'\x03YOT'
'\x0eYOUTHFUL FOLLY'
'\x0cYOUTHFULNESS'
'\x05YPHEN'
'\rYPOGEGRAMMENI'
'\x08YPORROON'
'\x0cYPTOGRAMMIC '
'\x02YR'
'\tYRANISMA '
'\x14YRENAIC TWO DRACHMAS'
'\x0bYRIGHT SIGN'
'\x08YRILLIC '
'\nYRILLIC EN'
'\x02YT'
'\x02YU'
'\x04YUDH'
'\x04YUKU'
'\x05YURII'
'\x03YUT'
'\rYUUKALEAPINTU'
'\x03YWA'
'\x04YWAA'
'\x18YZANTINE MUSICAL SYMBOL '
'\x01Z'
'\tZ DIGRAPH'
'\x02Z0'
'\x02Z2'
'\x02ZA'
'\x0eZAH WITH MEEM '
'\x03ZAI'
'\x04ZAIN'
'\x0fZAIN FINAL FORM'
'\tZAL SASAK'
'\x04ZATA'
'\x05ZAYIN'
'\x04ZAYN'
'\x02ZE'
'\x04ZELO'
'\x03ZEN'
'\tZENE RING'
'\x05ZENGE'
'\x03ZER'
'\x04ZERO'
'\x1bZERO FOR ODD POWERS OF FOUR'
'\tZERO SIGN'
'\x0bZERO THIRDS'
'\x04ZETA'
'\x02ZH'
'\nZH DIGRAPH'
'\x03ZHA'
'\x05ZHAIN'
'\x06ZHITSA'
'\rZHOU NUMERAL '
'\x02ZI'
'\tZIDA TENU'
'\x04ZIET'
'\x07ZIGZAG '
'\x0cZIGZAG ARROW'
'\x0bZIGZAG LINE'
'\x05ZILDE'
'\tZIR SASAK'
'\x03ZJE'
'\x02ZO'
'\x03ZOO'
'\x07ZQAPHA '
'\x03ZUP'
'\x08ZWARAKAY'
'\x05ZYGOS'
)
_charnodes =[70758,
 -54050,
 -1,
 132371,
 28690,
 -1,
 197694,
 78399,
 -1,
 262727,
 136009,
 -1,
 327957,
 202049,
 -1,
 393238,
 282198,
 -1,
 -65529,
 347734,
 195071,
 -65528,
 409735,
 195070,
 -65527,
 472608,
 195069,
 -65526,
 535774,
 195068,
 -65525,
 599670,
 195067,
 -65524,
 660852,
 195066,
 -65523,
 726337,
 195065,
 -65522,
 791821,
 195064,
 -65521,
 857286,
 195063,
 -65520,
 922753,
 195062,
 -65519,
 988169,
 195061,
 -65518,
 1053628,
 195060,
 -65517,
 1119052,
 195059,
 -65516,
 1184423,
 195058,
 -65515,
 1249807,
 195057,
 -1,
 1315215,
 195056,
 1507367,
 344199,
 -1,
 -65512,
 1461846,
 195055,
 -65511,
 1523847,
 195054,
 -65510,
 1586720,
 195053,
 -65509,
 1649886,
 195052,
 -65508,
 1713782,
 195051,
 -65507,
 1774964,
 195050,
 -65506,
 1840449,
 195049,
 -65505,
 1905933,
 195048,
 -65504,
 1971398,
 195047,
 -65503,
 2036865,
 195046,
 -65502,
 2102281,
 195045,
 -65501,
 2167740,
 195044,
 -65500,
 2233164,
 195043,
 -65499,
 2298535,
 195042,
 -65498,
 2363919,
 195041,
 -1,
 2429327,
 195040,
 2621496,
 1455648,
 -1,
 -65495,
 2575958,
 195039,
 -65494,
 2637959,
 195038,
 -65493,
 2700832,
 195037,
 -65492,
 2763998,
 195036,
 -65491,
 2827894,
 195035,
 -65490,
 2889076,
 195034,
 -65489,
 2954561,
 195033,
 -65488,
 3020045,
 195032,
 -65487,
 3085510,
 195031,
 -65486,
 3150977,
 195030,
 -65485,
 3216393,
 195029,
 -65484,
 3281852,
 195028,
 -65483,
 3347276,
 195027,
 -65482,
 3412647,
 195026,
 -65481,
 3478031,
 195025,
 -1,
 3543439,
 195024,
 3735625,
 2567390,
 -1,
 -65478,
 3690070,
 195023,
 -65477,
 3752071,
 195022,
 -65476,
 3814944,
 195021,
 -65475,
 3878110,
 195020,
 -65474,
 3942006,
 195019,
 -65473,
 4003188,
 195018,
 -65472,
 4068673,
 195017,
 -65471,
 4134157,
 195016,
 -65470,
 4199622,
 195015,
 -65469,
 4265089,
 195014,
 -65468,
 4330505,
 195013,
 -65467,
 4395964,
 195012,
 -65466,
 4461388,
 195011,
 -65465,
 4526759,
 195010,
 -65464,
 4592143,
 195009,
 -1,
 4657551,
 195008,
 4849754,
 3679862,
 -1,
 -65461,
 4804182,
 195007,
 -65460,
 4866183,
 195006,
 -65459,
 4929056,
 195005,
 -65458,
 4992222,
 195004,
 -65457,
 5056118,
 195003,
 -65456,
 5117300,
 195002,
 -65455,
 5182785,
 195001,
 -65454,
 5248269,
 195000,
 -65453,
 5313734,
 194999,
 -65452,
 5379201,
 194998,
 -65451,
 5444617,
 194997,
 -65450,
 5510076,
 194996,
 -65449,
 5575500,
 194995,
 -65448,
 5640871,
 194994,
 -65447,
 5706255,
 194993,
 -1,
 5771663,
 194992,
 5963883,
 4789620,
 -1,
 -65444,
 5918294,
 194991,
 -65443,
 5980295,
 194990,
 -65442,
 6043168,
 194989,
 -65441,
 6106334,
 194988,
 -65440,
 6170230,
 194987,
 -65439,
 6231412,
 194986,
 -65438,
 6296897,
 194985,
 -65437,
 6362381,
 194984,
 -65436,
 6427846,
 194983,
 -65435,
 6493313,
 194982,
 -65434,
 6558729,
 194981,
 -65433,
 6624188,
 194980,
 -65432,
 6689612,
 194979,
 -65431,
 6754983,
 194978,
 -65430,
 6820367,
 194977,
 -1,
 6885775,
 194976,
 7078012,
 5903681,
 -1,
 -65427,
 7032406,
 194975,
 -65426,
 7094407,
 194974,
 -65425,
 7157280,
 194973,
 -65424,
 7220446,
 194972,
 -65423,
 7284342,
 194971,
 -65422,
 7345524,
 194970,
 -65421,
 7411009,
 194969,
 -65420,
 7476493,
 194968,
 -65419,
 7541958,
 194967,
 -65418,
 7607425,
 194966,
 -65417,
 7672841,
 194965,
 -65416,
 7738300,
 194964,
 -65415,
 7803724,
 194963,
 -65414,
 7869095,
 194962,
 -65413,
 7934479,
 194961,
 -1,
 7999887,
 194960,
 8192141,
 7017741,
 -1,
 -65410,
 8146518,
 194959,
 -65409,
 8208519,
 194958,
 -65408,
 8271392,
 194957,
 -65407,
 8334558,
 194956,
 -65406,
 8398454,
 194955,
 -65405,
 8459636,
 194954,
 -65404,
 8525121,
 194953,
 -65403,
 8590605,
 194952,
 -65402,
 8656070,
 194951,
 -65401,
 8721537,
 194950,
 -65400,
 8786953,
 194949,
 -65399,
 8852412,
 194948,
 -65398,
 8917836,
 194947,
 -65397,
 8983207,
 194946,
 -65396,
 9048591,
 194945,
 -1,
 9113999,
 194944,
 9306270,
 8131782,
 -1,
 -65393,
 9260630,
 194943,
 -65392,
 9322631,
 194942,
 -65391,
 9385504,
 194941,
 -65390,
 9448670,
 194940,
 -65389,
 9512566,
 194939,
 -65388,
 9573748,
 194938,
 -65387,
 9639233,
 194937,
 -65386,
 9704717,
 194936,
 -65385,
 9770182,
 194935,
 -65384,
 9835649,
 194934,
 -65383,
 9901065,
 194933,
 -65382,
 9966524,
 194932,
 -65381,
 10031948,
 194931,
 -65380,
 10097319,
 194930,
 -65379,
 10162703,
 194929,
 -1,
 10228111,
 194928,
 10420399,
 9245825,
 -1,
 -65376,
 10374742,
 194927,
 -65375,
 10436743,
 194926,
 -65374,
 10499616,
 194925,
 -65373,
 10562782,
 194924,
 -65372,
 10626678,
 194923,
 -65371,
 10687860,
 194922,
 -65370,
 10753345,
 194921,
 -65369,
 10818829,
 194920,
 -65368,
 10884294,
 194919,
 -65367,
 10949761,
 194918,
 -65366,
 11015177,
 194917,
 -65365,
 11080636,
 194916,
 -65364,
 11146060,
 194915,
 -65363,
 11211431,
 194914,
 -65362,
 11276815,
 194913,
 -1,
 11342223,
 194912,
 11534528,
 10359817,
 -1,
 -65359,
 11488854,
 194911,
 -65358,
 11550855,
 194910,
 -65357,
 11613728,
 194909,
 -65356,
 11676894,
 194908,
 -65355,
 11740790,
 194907,
 -65354,
 11801972,
 194906,
 -65353,
 11867457,
 194905,
 -65352,
 11932941,
 194904,
 -65351,
 11998406,
 194903,
 -65350,
 12063873,
 194902,
 -65349,
 12129289,
 194901,
 -65348,
 12194748,
 194900,
 -65347,
 12260172,
 194899,
 -65346,
 12325543,
 194898,
 -65345,
 12390927,
 194897,
 -1,
 12456335,
 194896,
 12648657,
 11473852,
 -1,
 -65342,
 12602966,
 194895,
 -65341,
 12664967,
 194894,
 -65340,
 12727840,
 194893,
 -65339,
 12791006,
 194892,
 -65338,
 12854902,
 194891,
 -65337,
 12916084,
 194890,
 -65336,
 12981569,
 194889,
 -65335,
 13047053,
 194888,
 -65334,
 13112518,
 194887,
 -65333,
 13177985,
 194886,
 -65332,
 13243401,
 194885,
 -65331,
 13308860,
 194884,
 -65330,
 13374284,
 194883,
 -65329,
 13439655,
 194882,
 -65328,
 13505039,
 194881,
 -1,
 13570447,
 194880,
 13762786,
 12587852,
 -1,
 -65325,
 13717078,
 194879,
 -65324,
 13779079,
 194878,
 -65323,
 13841952,
 194877,
 -65322,
 13905118,
 194876,
 -65321,
 13969014,
 194875,
 -65320,
 14030196,
 194874,
 -65319,
 14095681,
 194873,
 -65318,
 14161165,
 194872,
 -65317,
 14226630,
 194871,
 -65316,
 14292097,
 194870,
 -65315,
 14357513,
 194869,
 -65314,
 14422972,
 194868,
 -65313,
 14488396,
 194867,
 -65312,
 14553767,
 194866,
 -65311,
 14619151,
 194865,
 -1,
 14684559,
 194864,
 14876915,
 13701799,
 -1,
 -65308,
 14831190,
 194863,
 -65307,
 14893191,
 194862,
 -65306,
 14956064,
 194861,
 -65305,
 15019230,
 194860,
 -65304,
 15083126,
 194859,
 -65303,
 15144308,
 194858,
 -65302,
 15209793,
 194857,
 -65301,
 15275277,
 194856,
 -65300,
 15340742,
 194855,
 -65299,
 15406209,
 194854,
 -65298,
 15471625,
 194853,
 -65297,
 15537084,
 194852,
 -65296,
 15602508,
 194851,
 -65295,
 15667879,
 194850,
 -65294,
 15733263,
 194849,
 -1,
 15798671,
 194848,
 15991044,
 14815759,
 -1,
 -65291,
 15945302,
 194847,
 -65290,
 16007303,
 194846,
 -65289,
 16070176,
 194845,
 -65288,
 16133342,
 194844,
 -65287,
 16197238,
 194843,
 -65286,
 16258420,
 194842,
 -65285,
 16323905,
 194841,
 -65284,
 16389389,
 194840,
 -65283,
 16454854,
 194839,
 -65282,
 16520321,
 194838,
 -65281,
 16585737,
 194837,
 -65280,
 16651196,
 194836,
 -65279,
 16716620,
 194835,
 -65278,
 16781991,
 194834,
 -65277,
 16847375,
 194833,
 -1,
 16912783,
 194832,
 17170431,
 15929743,
 -1,
 -65274,
 17059414,
 194831,
 -65273,
 17121415,
 194830,
 -65272,
 17184288,
 194829,
 -65271,
 17247454,
 194828,
 -65270,
 17311350,
 194827,
 -65269,
 17372532,
 194826,
 -65268,
 17438017,
 194825,
 -65267,
 17503501,
 194824,
 -65266,
 17568966,
 194823,
 -65265,
 17634433,
 194822,
 -65264,
 17699849,
 194821,
 -65263,
 17765308,
 194820,
 -65262,
 17830732,
 194819,
 -65261,
 17896103,
 194818,
 -65260,
 17961487,
 194817,
 -1,
 18026895,
 194816,
 18219558,
 267533,
 -1,
 18284839,
 18173526,
 -1,
 -65256,
 18239062,
 194815,
 -65255,
 18301063,
 194814,
 -65254,
 18363936,
 194813,
 -65253,
 18427102,
 194812,
 -65252,
 18490998,
 194811,
 -65251,
 18552180,
 194810,
 -65250,
 18617665,
 194809,
 -65249,
 18683149,
 194808,
 -65248,
 18748614,
 194807,
 -65247,
 18814081,
 194806,
 -65246,
 18879497,
 194805,
 -65245,
 18944956,
 194804,
 -65244,
 19010380,
 194803,
 -65243,
 19075751,
 194802,
 -65242,
 19141135,
 194801,
 -1,
 19206543,
 194800,
 19398968,
 18235527,
 -1,
 -65239,
 19353174,
 194799,
 -65238,
 19415175,
 194798,
 -65237,
 19478048,
 194797,
 -65236,
 19541214,
 194796,
 -65235,
 19605110,
 194795,
 -65234,
 19666292,
 194794,
 -65233,
 19731777,
 194793,
 -65232,
 19797261,
 194792,
 -65231,
 19862726,
 194791,
 -65230,
 19928193,
 194790,
 -65229,
 19993609,
 194789,
 -65228,
 20059068,
 194788,
 -65227,
 20124492,
 194787,
 -65226,
 20189863,
 194786,
 -65225,
 20255247,
 194785,
 -1,
 20320655,
 194784,
 20513097,
 19346976,
 -1,
 -65222,
 20467286,
 194783,
 -65221,
 20529287,
 194782,
 -65220,
 20592160,
 194781,
 -65219,
 20655326,
 194780,
 -65218,
 20719222,
 194779,
 -65217,
 20780404,
 194778,
 -65216,
 20845889,
 194777,
 -65215,
 20911373,
 194776,
 -65214,
 20976838,
 194775,
 -65213,
 21042305,
 194774,
 -65212,
 21107721,
 194773,
 -65211,
 21173180,
 194772,
 -65210,
 21238604,
 194771,
 -65209,
 21303975,
 194770,
 -65208,
 21369359,
 194769,
 -1,
 21434767,
 194768,
 21627226,
 20458718,
 -1,
 -65205,
 21581398,
 194767,
 -65204,
 21643399,
 194766,
 -65203,
 21706272,
 194765,
 -65202,
 21769438,
 194764,
 -65201,
 21833334,
 194763,
 -65200,
 21894516,
 194762,
 -65199,
 21960001,
 194761,
 -65198,
 22025485,
 194760,
 -65197,
 22090950,
 194759,
 -65196,
 22156417,
 194758,
 -65195,
 22221833,
 194757,
 -65194,
 22287292,
 194756,
 -65193,
 22352716,
 194755,
 -65192,
 22418087,
 194754,
 -65191,
 22483471,
 194753,
 -1,
 22548879,
 194752,
 22741355,
 21571190,
 -1,
 -65188,
 22695510,
 194751,
 -65187,
 22757511,
 194750,
 -65186,
 22820384,
 194749,
 -65185,
 22883550,
 194748,
 -65184,
 22947446,
 194747,
 -65183,
 23008628,
 194746,
 -65182,
 23074113,
 194745,
 -65181,
 23139597,
 194744,
 -65180,
 23205062,
 194743,
 -65179,
 23270529,
 194742,
 -65178,
 23335945,
 194741,
 -65177,
 23401404,
 194740,
 -65176,
 23466828,
 194739,
 -65175,
 23532199,
 194738,
 -65174,
 23597583,
 194737,
 -1,
 23662991,
 194736,
 23855484,
 22680948,
 -1,
 -65171,
 23809622,
 194735,
 -65170,
 23871623,
 194734,
 -65169,
 23934496,
 194733,
 -65168,
 23997662,
 194732,
 -65167,
 24061558,
 194731,
 -65166,
 24122740,
 194730,
 -65165,
 24188225,
 194729,
 -65164,
 24253709,
 194728,
 -65163,
 24319174,
 194727,
 -65162,
 24384641,
 194726,
 -65161,
 24450057,
 194725,
 -65160,
 24515516,
 194724,
 -65159,
 24580940,
 194723,
 -65158,
 24646311,
 194722,
 -65157,
 24711695,
 194721,
 -1,
 24777103,
 194720,
 24969613,
 23795009,
 -1,
 -65154,
 24923734,
 194719,
 -65153,
 24985735,
 194718,
 -65152,
 25048608,
 194717,
 -65151,
 25111774,
 194716,
 -65150,
 25175670,
 194715,
 -65149,
 25236852,
 194714,
 -65148,
 25302337,
 194713,
 -65147,
 25367821,
 194712,
 -65146,
 25433286,
 194711,
 -65145,
 25498753,
 194710,
 -65144,
 25564169,
 194709,
 -65143,
 25629628,
 194708,
 -65142,
 25695052,
 194707,
 -65141,
 25760423,
 194706,
 -65140,
 25825807,
 194705,
 -1,
 25891215,
 194704,
 26083742,
 24909069,
 -1,
 -65137,
 26037846,
 194703,
 -65136,
 26099847,
 194702,
 -65135,
 26162720,
 194701,
 -65134,
 26225886,
 194700,
 -65133,
 26289782,
 194699,
 -65132,
 26350964,
 194698,
 -65131,
 26416449,
 194697,
 -65130,
 26481933,
 194696,
 -65129,
 26547398,
 194695,
 -65128,
 26612865,
 194694,
 -65127,
 26678281,
 194693,
 -65126,
 26743740,
 194692,
 -65125,
 26809164,
 194691,
 -65124,
 26874535,
 194690,
 -65123,
 26939919,
 194689,
 -1,
 27005327,
 194688,
 27197871,
 26023110,
 -1,
 -65120,
 27151958,
 194687,
 -65119,
 27213959,
 194686,
 -65118,
 27276832,
 194685,
 -65117,
 27339998,
 194684,
 -65116,
 27403894,
 194683,
 -65115,
 27465076,
 194682,
 -65114,
 27530561,
 194681,
 -65113,
 27596045,
 194680,
 -65112,
 27661510,
 194679,
 -65111,
 27726977,
 194678,
 -65110,
 27792393,
 194677,
 -65109,
 27857852,
 194676,
 -65108,
 27923276,
 194675,
 -65107,
 27988647,
 194674,
 -65106,
 28054031,
 194673,
 -1,
 28119439,
 194672,
 28312000,
 27137153,
 -1,
 -65103,
 28266070,
 194671,
 -65102,
 28328071,
 194670,
 -65101,
 28390944,
 194669,
 -65100,
 28454110,
 194668,
 -65099,
 28518006,
 194667,
 -65098,
 28579188,
 194666,
 -65097,
 28644673,
 194665,
 -65096,
 28710157,
 194664,
 -65095,
 28775622,
 194663,
 -65094,
 28841089,
 194662,
 -65093,
 28906505,
 194661,
 -65092,
 28971964,
 194660,
 -65091,
 29037388,
 194659,
 -65090,
 29102759,
 194658,
 -65089,
 29168143,
 194657,
 -1,
 29233551,
 194656,
 29426129,
 28251145,
 -1,
 -65086,
 29380182,
 194655,
 -65085,
 29442183,
 194654,
 -65084,
 29505056,
 194653,
 -65083,
 29568222,
 194652,
 -65082,
 29632118,
 194651,
 -65081,
 29693300,
 194650,
 -65080,
 29758785,
 194649,
 -65079,
 29824269,
 194648,
 -65078,
 29889734,
 194647,
 -65077,
 29955201,
 194646,
 -65076,
 30020617,
 194645,
 -65075,
 30086076,
 194644,
 -65074,
 30151500,
 194643,
 -65073,
 30216871,
 194642,
 -65072,
 30282255,
 194641,
 -1,
 30347663,
 194640,
 30540258,
 29365180,
 -1,
 -65069,
 30494294,
 194639,
 -65068,
 30556295,
 194638,
 -65067,
 30619168,
 194637,
 -65066,
 30682334,
 194636,
 -65065,
 30746230,
 194635,
 -65064,
 30807412,
 194634,
 -65063,
 30872897,
 194633,
 -65062,
 30938381,
 194632,
 -65061,
 31003846,
 194631,
 -65060,
 31069313,
 194630,
 -65059,
 31134729,
 194629,
 -65058,
 31200188,
 194628,
 -65057,
 31265612,
 194627,
 -65056,
 31330983,
 194626,
 -65055,
 31396367,
 194625,
 -1,
 31461775,
 194624,
 31654387,
 30479180,
 -1,
 -65052,
 31608406,
 194623,
 -65051,
 31670407,
 194622,
 -65050,
 31733280,
 194621,
 -65049,
 31796446,
 194620,
 -65048,
 31860342,
 194619,
 -65047,
 31921524,
 194618,
 -65046,
 31987009,
 194617,
 -65045,
 32052493,
 194616,
 -65044,
 32117958,
 194615,
 -65043,
 32183425,
 194614,
 -65042,
 32248841,
 194613,
 -65041,
 32314300,
 194612,
 -65040,
 32379724,
 194611,
 -65039,
 32445095,
 194610,
 -65038,
 32510479,
 194609,
 -1,
 32575887,
 194608,
 32768516,
 31593127,
 -1,
 -65035,
 32722518,
 194607,
 -65034,
 32784519,
 194606,
 -65033,
 32847392,
 194605,
 -65032,
 32910558,
 194604,
 -65031,
 32974454,
 194603,
 -65030,
 33035636,
 194602,
 -65029,
 33101121,
 194601,
 -65028,
 33166605,
 194600,
 -65027,
 33232070,
 194599,
 -65026,
 33297537,
 194598,
 -65025,
 33362953,
 194597,
 -65024,
 33428412,
 194596,
 -65023,
 33493836,
 194595,
 -65022,
 33559207,
 194594,
 -65021,
 33624591,
 194593,
 -1,
 33689999,
 194592,
 33882645,
 32707087,
 -1,
 -65018,
 33836630,
 194591,
 -65017,
 33898631,
 194590,
 -65016,
 33961504,
 194589,
 -65015,
 34024670,
 194588,
 -65014,
 34088566,
 194587,
 -65013,
 34149748,
 194586,
 -65012,
 34215233,
 194585,
 -65011,
 34280717,
 194584,
 -65010,
 34346182,
 194583,
 -65009,
 34411649,
 194582,
 -65008,
 34477065,
 194581,
 -65007,
 34542524,
 194580,
 -65006,
 34607948,
 194579,
 -65005,
 34673319,
 194578,
 -65004,
 34738703,
 194577,
 -1,
 34804111,
 194576,
 35061759,
 33821071,
 -1,
 -65001,
 34950742,
 194575,
 -65000,
 35012743,
 194574,
 -64999,
 35075616,
 194573,
 -64998,
 35138782,
 194572,
 -64997,
 35202678,
 194571,
 -64996,
 35263860,
 194570,
 -64995,
 35329345,
 194569,
 -64994,
 35394829,
 194568,
 -64993,
 35460294,
 194567,
 -64992,
 35525761,
 194566,
 -64991,
 35591177,
 194565,
 -64990,
 35656636,
 194564,
 -64989,
 35722060,
 194563,
 -64988,
 35787431,
 194562,
 -64987,
 35852815,
 194561,
 -1,
 35918223,
 194560,
 36175871,
 18158964,
 -1,
 36176440,
 36049295,
 -1,
 -64983,
 36130390,
 195087,
 -64982,
 36192391,
 195086,
 -64981,
 36255264,
 195085,
 -64980,
 36318430,
 195084,
 -64979,
 36382326,
 195083,
 -64978,
 36443508,
 195082,
 -64977,
 36508993,
 195081,
 -64976,
 36574477,
 195080,
 -64975,
 36639942,
 195079,
 -64974,
 36705409,
 195078,
 -64973,
 36770825,
 195077,
 -64972,
 36836284,
 195076,
 -64971,
 36901708,
 195075,
 -64970,
 36967079,
 195074,
 -64969,
 37032463,
 195073,
 -1,
 37097871,
 195072,
 37355519,
 36114959,
 -1,
 -64966,
 37238304,
 195101,
 -64965,
 37301470,
 195100,
 -64964,
 37365366,
 195099,
 -64963,
 37426548,
 195098,
 -64962,
 37492033,
 195097,
 -64961,
 37557517,
 195096,
 -64960,
 37622982,
 195095,
 -64959,
 37688449,
 195094,
 -64958,
 37753865,
 195093,
 -64957,
 37819324,
 195092,
 -64956,
 37884748,
 195091,
 -64955,
 37950119,
 195090,
 -64954,
 38015503,
 195089,
 -1,
 38080911,
 195088,
 38338559,
 216662,
 -1,
 38339417,
 38212929,
 -1,
 38404698,
 38293078,
 -1,
 -64949,
 38358614,
 63999,
 -64948,
 38420615,
 63998,
 -64947,
 38483488,
 63997,
 -64946,
 38546654,
 63996,
 -64945,
 38610550,
 63995,
 -64944,
 38671732,
 63994,
 -64943,
 38737217,
 63993,
 -64942,
 38802701,
 63992,
 -64941,
 38868166,
 63991,
 -64940,
 38933633,
 63990,
 -64939,
 38999049,
 63989,
 -64938,
 39064508,
 63988,
 -64937,
 39129932,
 63987,
 -64936,
 39195303,
 63986,
 -64935,
 39260687,
 63985,
 -1,
 39326095,
 63984,
 39518827,
 38355079,
 -1,
 -64932,
 39472726,
 63983,
 -64931,
 39534727,
 63982,
 -64930,
 39597600,
 63981,
 -64929,
 39660766,
 63980,
 -64928,
 39724662,
 63979,
 -64927,
 39785844,
 63978,
 -64926,
 39851329,
 63977,
 -64925,
 39916813,
 63976,
 -64924,
 39982278,
 63975,
 -64923,
 40047745,
 63974,
 -64922,
 40113161,
 63973,
 -64921,
 40178620,
 63972,
 -64920,
 40244044,
 63971,
 -64919,
 40309415,
 63970,
 -64918,
 40374799,
 63969,
 -1,
 40440207,
 63968,
 40632956,
 39466528,
 -1,
 -64915,
 40586838,
 63967,
 -64914,
 40648839,
 63966,
 -64913,
 40711712,
 63965,
 -64912,
 40774878,
 63964,
 -64911,
 40838774,
 63963,
 -64910,
 40899956,
 63962,
 -64909,
 40965441,
 63961,
 -64908,
 41030925,
 63960,
 -64907,
 41096390,
 63959,
 -64906,
 41161857,
 63958,
 -64905,
 41227273,
 63957,
 -64904,
 41292732,
 63956,
 -64903,
 41358156,
 63955,
 -64902,
 41423527,
 63954,
 -64901,
 41488911,
 63953,
 -1,
 41554319,
 63952,
 41747085,
 40578270,
 -1,
 -64898,
 41700950,
 63951,
 -64897,
 41762951,
 63950,
 -64896,
 41825824,
 63949,
 -64895,
 41888990,
 63948,
 -64894,
 41952886,
 63947,
 -64893,
 42014068,
 63946,
 -64892,
 42079553,
 63945,
 -64891,
 42145037,
 63944,
 -64890,
 42210502,
 63943,
 -64889,
 42275969,
 63942,
 -64888,
 42341385,
 63941,
 -64887,
 42406844,
 63940,
 -64886,
 42472268,
 63939,
 -64885,
 42537639,
 63938,
 -64884,
 42603023,
 63937,
 -1,
 42668431,
 63936,
 42861214,
 41690742,
 -1,
 -64881,
 42815062,
 63935,
 -64880,
 42877063,
 63934,
 -64879,
 42939936,
 63933,
 -64878,
 43003102,
 63932,
 -64877,
 43066998,
 63931,
 -64876,
 43128180,
 63930,
 -64875,
 43193665,
 63929,
 -64874,
 43259149,
 63928,
 -64873,
 43324614,
 63927,
 -64872,
 43390081,
 63926,
 -64871,
 43455497,
 63925,
 -64870,
 43520956,
 63924,
 -64869,
 43586380,
 63923,
 -64868,
 43651751,
 63922,
 -64867,
 43717135,
 63921,
 -1,
 43782543,
 63920,
 43975343,
 42800500,
 -1,
 -64864,
 43929174,
 63919,
 -64863,
 43991175,
 63918,
 -64862,
 44054048,
 63917,
 -64861,
 44117214,
 63916,
 -64860,
 44181110,
 63915,
 -64859,
 44242292,
 63914,
 -64858,
 44307777,
 63913,
 -64857,
 44373261,
 63912,
 -64856,
 44438726,
 63911,
 -64855,
 44504193,
 63910,
 -64854,
 44569609,
 63909,
 -64853,
 44635068,
 63908,
 -64852,
 44700492,
 63907,
 -64851,
 44765863,
 63906,
 -64850,
 44831247,
 63905,
 -1,
 44896655,
 63904,
 45089472,
 43914561,
 -1,
 -64847,
 45043286,
 63903,
 -64846,
 45105287,
 63902,
 -64845,
 45168160,
 63901,
 -64844,
 45231326,
 63900,
 -64843,
 45295222,
 63899,
 -64842,
 45356404,
 63898,
 -64841,
 45421889,
 63897,
 -64840,
 45487373,
 63896,
 -64839,
 45552838,
 63895,
 -64838,
 45618305,
 63894,
 -64837,
 45683721,
 63893,
 -64836,
 45749180,
 63892,
 -64835,
 45814604,
 63891,
 -64834,
 45879975,
 63890,
 -64833,
 45945359,
 63889,
 -1,
 46010767,
 63888,
 46203601,
 45028621,
 -1,
 -64830,
 46157398,
 63887,
 -64829,
 46219399,
 63886,
 -64828,
 46282272,
 63885,
 -64827,
 46345438,
 63884,
 -64826,
 46409334,
 63883,
 -64825,
 46470516,
 63882,
 -64824,
 46536001,
 63881,
 -64823,
 46601485,
 63880,
 -64822,
 46666950,
 63879,
 -64821,
 46732417,
 63878,
 -64820,
 46797833,
 63877,
 -64819,
 46863292,
 63876,
 -64818,
 46928716,
 63875,
 -64817,
 46994087,
 63874,
 -64816,
 47059471,
 63873,
 -1,
 47124879,
 63872,
 47317730,
 46142662,
 -1,
 -64813,
 47271510,
 63871,
 -64812,
 47333511,
 63870,
 -64811,
 47396384,
 63869,
 -64810,
 47459550,
 63868,
 -64809,
 47523446,
 63867,
 -64808,
 47584628,
 63866,
 -64807,
 47650113,
 63865,
 -64806,
 47715597,
 63864,
 -64805,
 47781062,
 63863,
 -64804,
 47846529,
 63862,
 -64803,
 47911945,
 63861,
 -64802,
 47977404,
 63860,
 -64801,
 48042828,
 63859,
 -64800,
 48108199,
 63858,
 -64799,
 48173583,
 63857,
 -1,
 48238991,
 63856,
 48431859,
 47256705,
 -1,
 -64796,
 48385622,
 63855,
 -64795,
 48447623,
 63854,
 -64794,
 48510496,
 63853,
 -64793,
 48573662,
 63852,
 -64792,
 48637558,
 63851,
 -64791,
 48698740,
 63850,
 -64790,
 48764225,
 63849,
 -64789,
 48829709,
 63848,
 -64788,
 48895174,
 63847,
 -64787,
 48960641,
 63846,
 -64786,
 49026057,
 63845,
 -64785,
 49091516,
 63844,
 -64784,
 49156940,
 63843,
 -64783,
 49222311,
 63842,
 -64782,
 49287695,
 63841,
 -1,
 49353103,
 63840,
 49545988,
 48370697,
 -1,
 -64779,
 49499734,
 63839,
 -64778,
 49561735,
 63838,
 -64777,
 49624608,
 63837,
 -64776,
 49687774,
 63836,
 -64775,
 49751670,
 63835,
 -64774,
 49812852,
 63834,
 -64773,
 49878337,
 63833,
 -64772,
 49943821,
 63832,
 -64771,
 50009286,
 63831,
 -64770,
 50074753,
 63830,
 -64769,
 50140169,
 63829,
 -64768,
 50205628,
 63828,
 -64767,
 50271052,
 63827,
 -64766,
 50336423,
 63826,
 -64765,
 50401807,
 63825,
 -1,
 50467215,
 63824,
 50660117,
 49484732,
 -1,
 -64762,
 50613846,
 63823,
 -64761,
 50675847,
 63822,
 -64760,
 50738720,
 63821,
 -64759,
 50801886,
 63820,
 -64758,
 50865782,
 63819,
 -64757,
 50926964,
 63818,
 -64756,
 50992449,
 63817,
 -64755,
 51057933,
 63816,
 -64754,
 51123398,
 63815,
 -64753,
 51188865,
 63814,
 -64752,
 51254281,
 63813,
 -64751,
 51319740,
 63812,
 -64750,
 51385164,
 63811,
 -64749,
 51450535,
 63810,
 -64748,
 51515919,
 63809,
 -1,
 51581327,
 63808,
 51774246,
 50598732,
 -1,
 -64745,
 51727958,
 63807,
 -64744,
 51789959,
 63806,
 -64743,
 51852832,
 63805,
 -64742,
 51915998,
 63804,
 -64741,
 51979894,
 63803,
 -64740,
 52041076,
 63802,
 -64739,
 52106561,
 63801,
 -64738,
 52172045,
 63800,
 -64737,
 52237510,
 63799,
 -64736,
 52302977,
 63798,
 -64735,
 52368393,
 63797,
 -64734,
 52433852,
 63796,
 -64733,
 52499276,
 63795,
 -64732,
 52564647,
 63794,
 -64731,
 52630031,
 63793,
 -1,
 52695439,
 63792,
 52888375,
 51712679,
 -1,
 -64728,
 52842070,
 63791,
 -64727,
 52904071,
 63790,
 -64726,
 52966944,
 63789,
 -64725,
 53030110,
 63788,
 -64724,
 53094006,
 63787,
 -64723,
 53155188,
 63786,
 -64722,
 53220673,
 63785,
 -64721,
 53286157,
 63784,
 -64720,
 53351622,
 63783,
 -64719,
 53417089,
 63782,
 -64718,
 53482505,
 63781,
 -64717,
 53547964,
 63780,
 -64716,
 53613388,
 63779,
 -64715,
 53678759,
 63778,
 -64714,
 53744143,
 63777,
 -1,
 53809551,
 63776,
 54002504,
 52826639,
 -1,
 -64711,
 53956182,
 63775,
 -64710,
 54018183,
 63774,
 -64709,
 54081056,
 63773,
 -64708,
 54144222,
 63772,
 -64707,
 54208118,
 63771,
 -64706,
 54269300,
 63770,
 -64705,
 54334785,
 63769,
 -64704,
 54400269,
 63768,
 -64703,
 54465734,
 63767,
 -64702,
 54531201,
 63766,
 -64701,
 54596617,
 63765,
 -64700,
 54662076,
 63764,
 -64699,
 54727500,
 63763,
 -64698,
 54792871,
 63762,
 -64697,
 54858255,
 63761,
 -1,
 54923663,
 63760,
 55181311,
 53940623,
 -1,
 -64694,
 55070294,
 63759,
 -64693,
 55132295,
 63758,
 -64692,
 55195168,
 63757,
 -64691,
 55258334,
 63756,
 -64690,
 55322230,
 63755,
 -64689,
 55383412,
 63754,
 -64688,
 55448897,
 63753,
 -64687,
 55514381,
 63752,
 -64686,
 55579846,
 63751,
 -64685,
 55645313,
 63750,
 -64684,
 55710729,
 63749,
 -64683,
 55776188,
 63748,
 -64682,
 55841612,
 63747,
 -64681,
 55906983,
 63746,
 -64680,
 55972367,
 63745,
 -1,
 56037775,
 63744,
 56295423,
 38278516,
 -1,
 56296299,
 56175838,
 -1,
 -64676,
 56249942,
 64207,
 -64675,
 56311943,
 64206,
 -64674,
 56374816,
 64205,
 -64673,
 56437982,
 64204,
 -64672,
 56501878,
 64203,
 -64671,
 56563060,
 64202,
 -64670,
 56628545,
 64201,
 -64669,
 56694029,
 64200,
 -64668,
 56759494,
 64199,
 -64667,
 56824961,
 64198,
 -64666,
 56890377,
 64197,
 -64665,
 56955836,
 64196,
 -64664,
 57021260,
 64195,
 -64663,
 57086631,
 64194,
 -64662,
 57152015,
 64193,
 -1,
 57217423,
 64192,
 57410428,
 56239734,
 -1,
 -64659,
 57364054,
 64191,
 -64658,
 57426055,
 64190,
 -64657,
 57488928,
 64189,
 -64656,
 57552094,
 64188,
 -64655,
 57615990,
 64187,
 -64654,
 57677172,
 64186,
 -64653,
 57742657,
 64185,
 -64652,
 57808141,
 64184,
 -64651,
 57873606,
 64183,
 -64650,
 57939073,
 64182,
 -64649,
 58004489,
 64181,
 -64648,
 58069948,
 64180,
 -64647,
 58135372,
 64179,
 -64646,
 58200743,
 64178,
 -64645,
 58266127,
 64177,
 -1,
 58331535,
 64176,
 58524557,
 57349492,
 -1,
 -64642,
 58478166,
 64175,
 -64641,
 58540167,
 64174,
 -64640,
 58603040,
 64173,
 -64639,
 58666206,
 64172,
 -64638,
 58730102,
 64171,
 -64637,
 58791284,
 64170,
 -64636,
 58856769,
 64169,
 -64635,
 58922253,
 64168,
 -64634,
 58987718,
 64167,
 -64633,
 59053185,
 64166,
 -64632,
 59118601,
 64165,
 -64631,
 59184060,
 64164,
 -64630,
 59249484,
 64163,
 -64629,
 59314855,
 64162,
 -64628,
 59380239,
 64161,
 -1,
 59445647,
 64160,
 59638686,
 58463553,
 -1,
 -64625,
 59592278,
 64159,
 -64624,
 59654279,
 64158,
 -64623,
 59717152,
 64157,
 -64622,
 59780318,
 64156,
 -64621,
 59844214,
 64155,
 -64620,
 59905396,
 64154,
 -64619,
 59970881,
 64153,
 -64618,
 60036365,
 64152,
 -64617,
 60101830,
 64151,
 -64616,
 60167297,
 64150,
 -64615,
 60232713,
 64149,
 -64614,
 60298172,
 64148,
 -64613,
 60363596,
 64147,
 -64612,
 60428967,
 64146,
 -64611,
 60494351,
 64145,
 -1,
 60559759,
 64144,
 60752815,
 59577613,
 -1,
 -64608,
 60706390,
 64143,
 -64607,
 60768391,
 64142,
 -64606,
 60831264,
 64141,
 -64605,
 60894430,
 64140,
 -64604,
 60958326,
 64139,
 -64603,
 61019508,
 64138,
 -64602,
 61084993,
 64137,
 -64601,
 61150477,
 64136,
 -64600,
 61215942,
 64135,
 -64599,
 61281409,
 64134,
 -64598,
 61346825,
 64133,
 -64597,
 61412284,
 64132,
 -64596,
 61477708,
 64131,
 -64595,
 61543079,
 64130,
 -64594,
 61608463,
 64129,
 -1,
 61673871,
 64128,
 61866944,
 60691654,
 -1,
 -64591,
 61820502,
 64127,
 -64590,
 61882503,
 64126,
 -64589,
 61945376,
 64125,
 -64588,
 62008542,
 64124,
 -64587,
 62072438,
 64123,
 -64586,
 62133620,
 64122,
 -64585,
 62199105,
 64121,
 -64584,
 62264589,
 64120,
 -64583,
 62330054,
 64119,
 -64582,
 62395521,
 64118,
 -64581,
 62460937,
 64117,
 -64580,
 62526396,
 64116,
 -64579,
 62591820,
 64115,
 -64578,
 62657191,
 64114,
 -64577,
 62722575,
 64113,
 -1,
 62787983,
 64112,
 62981073,
 61805577,
 -1,
 -64574,
 62934614,
 64095,
 -64573,
 62996615,
 64094,
 -64572,
 63059488,
 64093,
 -64571,
 63122654,
 64092,
 -64570,
 63186550,
 64091,
 -64569,
 63247732,
 64090,
 -64568,
 63313217,
 64089,
 -64567,
 63378701,
 64088,
 -64566,
 63444166,
 64087,
 -64565,
 63509633,
 64086,
 -64564,
 63575049,
 64085,
 -64563,
 63640508,
 64084,
 -64562,
 63705932,
 64083,
 -64561,
 63771303,
 64082,
 -64560,
 63836687,
 64081,
 -1,
 63902095,
 64080,
 64095202,
 62919612,
 -1,
 -64557,
 64048726,
 64079,
 -64556,
 64110727,
 64078,
 -64555,
 64173600,
 64077,
 -64554,
 64236766,
 64076,
 -64553,
 64300662,
 64075,
 -64552,
 64361844,
 64074,
 -64551,
 64427329,
 64073,
 -64550,
 64492813,
 64072,
 -64549,
 64558278,
 64071,
 -64548,
 64623745,
 64070,
 -64547,
 64689161,
 64069,
 -64546,
 64754620,
 64068,
 -64545,
 64820044,
 64067,
 -64544,
 64885415,
 64066,
 -64543,
 64950799,
 64065,
 -1,
 65016207,
 64064,
 65209331,
 64033612,
 -1,
 -64540,
 65162838,
 64063,
 -64539,
 65224839,
 64062,
 -64538,
 65287712,
 64061,
 -64537,
 65350878,
 64060,
 -64536,
 65414774,
 64059,
 -64535,
 65475956,
 64058,
 -64534,
 65541441,
 64057,
 -64533,
 65606925,
 64056,
 -64532,
 65672390,
 64055,
 -64531,
 65737857,
 64054,
 -64530,
 65803273,
 64053,
 -64529,
 65868732,
 64052,
 -64528,
 65934156,
 64051,
 -64527,
 65999527,
 64050,
 -64526,
 66064911,
 64049,
 -1,
 66130319,
 64048,
 66323460,
 65147407,
 -1,
 -64523,
 66276950,
 64031,
 -64522,
 66338951,
 64030,
 -64521,
 66401824,
 64029,
 -64520,
 66464990,
 64028,
 -64519,
 66528886,
 64027,
 -64518,
 66590068,
 64026,
 -64517,
 66655553,
 64025,
 -64516,
 66721037,
 64024,
 -64515,
 66786502,
 64023,
 -64514,
 66851969,
 64022,
 -64513,
 66917385,
 64021,
 -64512,
 66982844,
 64020,
 -64511,
 67048268,
 64019,
 -64510,
 67113639,
 64018,
 -64509,
 67179023,
 64017,
 -1,
 67244431,
 64016,
 67437589,
 66261391,
 -1,
 -64506,
 67391062,
 64015,
 -64505,
 67453063,
 64014,
 -64504,
 67515936,
 64013,
 -64503,
 67579102,
 64012,
 -64502,
 67642998,
 64011,
 -64501,
 67704180,
 64010,
 -64500,
 67769665,
 64009,
 -64499,
 67835149,
 64008,
 -64498,
 67900614,
 64007,
 -64497,
 67966081,
 64006,
 -64496,
 68031497,
 64005,
 -64495,
 68096956,
 64004,
 -64494,
 68162380,
 64003,
 -64493,
 68227751,
 64002,
 -64492,
 68293135,
 64001,
 -1,
 68358543,
 64000,
 68551716,
 67376257,
 -1,
 -64489,
 68498976,
 64109,
 -64488,
 68562142,
 64108,
 -64487,
 68626038,
 64107,
 -64486,
 68687220,
 64106,
 -64485,
 68752705,
 64105,
 -64484,
 68818189,
 64104,
 -64483,
 68883654,
 64103,
 -64482,
 68949121,
 64102,
 -64481,
 69014537,
 64101,
 -64480,
 69079996,
 64100,
 -64479,
 69145420,
 64099,
 -64478,
 69210791,
 64098,
 -64477,
 69276175,
 64097,
 -1,
 69341583,
 64096,
 69534771,
 68489895,
 -1,
 -64474,
 69482016,
 64045,
 -64473,
 69545182,
 64044,
 -64472,
 69609078,
 64043,
 -64471,
 69670260,
 64042,
 -64470,
 69735745,
 64041,
 -64469,
 69801229,
 64040,
 -64468,
 69866694,
 64039,
 -64467,
 69932161,
 64038,
 -64466,
 69997577,
 64037,
 -64465,
 70063036,
 64036,
 -64464,
 70128460,
 64035,
 -64463,
 70193831,
 64034,
 -64462,
 70259215,
 64033,
 -1,
 70324623,
 64032,
 70582271,
 69482016,
 -1,
 -64459,
 70456641,
 64217,
 -64458,
 70522125,
 64216,
 -64457,
 70587590,
 64215,
 -64456,
 70653057,
 64214,
 -64455,
 70718473,
 64213,
 -64454,
 70783932,
 64212,
 -64453,
 70849356,
 64211,
 -64452,
 70914727,
 64210,
 -64451,
 70980111,
 64209,
 -1,
 71045519,
 64208,
 71238894,
 174580,
 -1,
 71304293,
 71183582,
 -1,
 71369821,
 71242054,
 -1,
 71435335,
 71350047,
 -1,
 -64445,
 71410149,
 11976,
 -64444,
 71460417,
 11952,
 -64443,
 71523361,
 11977,
 -64442,
 71582503,
 11973,
 -1,
 71638095,
 12007,
 71828555,
 71418580,
 -1,
 -64439,
 71816786,
 12019,
 -64438,
 71866068,
 12014,
 -1,
 71900899,
 11993,
 72090703,
 71781974,
 -1,
 -64435,
 72070146,
 12010,
 -64434,
 72122296,
 11996,
 -1,
 72183049,
 12005,
 72352850,
 72053592,
 -1,
 -64431,
 72324627,
 11987,
 -1,
 72368402,
 11994,
 72549461,
 72307427,
 -1,
 -64428,
 72520730,
 11984,
 -1,
 72557725,
 11988,
 72746072,
 72499335,
 -1,
 -64425,
 72735107,
 12012,
 -1,
 72754284,
 12000,
 -64423,
 72736603,
 11995,
 -64422,
 72900534,
 12002,
 -64421,
 72957893,
 12016,
 -64420,
 73018941,
 11979,
 -1,
 73083318,
 12006,
 73270368,
 71332696,
 -1,
 -64417,
 73243330,
 11970,
 -1,
 73294928,
 11905,
 73466979,
 73228671,
 -1,
 -64414,
 73456531,
 11936,
 -1,
 73518633,
 11983,
 -64412,
 73441005,
 11943,
 -1,
 73621112,
 11931,
 73794692,
 71284511,
 -1,
 73860208,
 73752959,
 -1,
 73925743,
 73828239,
 -1,
 73991275,
 73915656,
 -1,
 -64406,
 73948026,
 12008,
 -1,
 73997216,
 11980,
 74187886,
 73947275,
 -1,
 -64403,
 74160479,
 11974,
 -1,
 74193748,
 11942,
 -1,
 74179856,
 12009,
 -1,
 73890811,
 11951,
 74515575,
 73810055,
 -1,
 74581110,
 74461811,
 -1,
 74646645,
 74564308,
 -1,
 -64396,
 74637711,
 11907,
 -1,
 74670166,
 11908,
 -1,
 74618303,
 11906,
 -1,
 74521076,
 11915,
 74974332,
 74483935,
 -1,
 75039867,
 74947760,
 -1,
 -64390,
 75025762,
 11925,
 -1,
 75077055,
 11924,
 -1,
 74979786,
 11922,
 75302015,
 74949594,
 -1,
 -64386,
 75287906,
 11949,
 -1,
 75339199,
 11948,
 75498626,
 75268382,
 -1,
 -64383,
 75484514,
 11917,
 -1,
 75535807,
 11916,
 -64381,
 75485651,
 11932,
 -1,
 75652088,
 11958,
 75826319,
 73760741,
 -1,
 75891852,
 75796879,
 -1,
 75957385,
 75878964,
 -1,
 -64376,
 75943266,
 11990,
 -1,
 75994559,
 11989,
 -64374,
 75941524,
 11935,
 -64373,
 76133925,
 11965,
 -1,
 76191021,
 11933,
 76414975,
 75841671,
 -1,
 -64370,
 76331539,
 11957,
 -1,
 76358764,
 11964,
 76547225,
 75769462,
 -1,
 76612756,
 76517775,
 -1,
 -64366,
 76604164,
 11910,
 -64365,
 76647171,
 12003,
 -1,
 76709608,
 11946,
 76874903,
 76592855,
 -1,
 -64362,
 76860770,
 11963,
 -1,
 76912063,
 11962,
 -64360,
 76840759,
 11992,
 -1,
 77012152,
 11950,
 77202596,
 76537096,
 -1,
 77268129,
 77141364,
 -1,
 77333662,
 77251958,
 -1,
 -64355,
 77319522,
 11938,
 -1,
 77370815,
 11937,
 77594623,
 77298686,
 -1,
 -64352,
 77516130,
 11982,
 -1,
 77567423,
 11981,
 77791231,
 77220610,
 -1,
 -64349,
 77712738,
 11972,
 -1,
 77764031,
 11971,
 77923502,
 77165400,
 -1,
 77989035,
 77864135,
 -1,
 78054569,
 77972180,
 -1,
 -64344,
 78045583,
 11919,
 -1,
 78078038,
 11920,
 -64342,
 78026175,
 11918,
 -1,
 78205392,
 11921,
 78446591,
 77960727,
 -1,
 -64339,
 78368098,
 11986,
 -1,
 78419391,
 11985,
 78578870,
 77885225,
 -1,
 78644405,
 78516550,
 -1,
 78709939,
 78627540,
 -1,
 -64334,
 78698066,
 12018,
 -1,
 78747348,
 12013,
 -64332,
 78662786,
 12011,
 -1,
 78856133,
 12015,
 -1,
 78583810,
 11945,
 79103166,
 78534795,
 -1,
 79168700,
 79053066,
 -1,
 79234235,
 79148572,
 -1,
 -64326,
 79220066,
 11927,
 -1,
 79271359,
 11926,
 -1,
 79181344,
 12001,
 -64323,
 79141215,
 11975,
 -1,
 79437159,
 11928,
 79627462,
 79052935,
 -1,
 79692996,
 79570031,
 -1,
 79758531,
 79676116,
 -1,
 -64318,
 79749519,
 11998,
 -1,
 79781974,
 11999,
 -1,
 79730111,
 11997,
 -64315,
 79684795,
 11947,
 -1,
 80010834,
 11960,
 80151755,
 79610580,
 -1,
 -64312,
 80139858,
 12017,
 -64311,
 80176319,
 11969,
 -64310,
 80240720,
 11923,
 -1,
 80287320,
 11911,
 80479441,
 80128340,
 -1,
 80544976,
 80418164,
 -1,
 -64306,
 80519145,
 11929,
 -64305,
 80576485,
 11959,
 -1,
 80635696,
 11991,
 -1,
 80496790,
 11904,
 80872663,
 80448424,
 -1,
 80938197,
 80855764,
 -1,
 -64300,
 80929167,
 11954,
 -1,
 80961622,
 11955,
 -64298,
 80909759,
 11953,
 -1,
 81088976,
 11956,
 81265886,
 80827107,
 -1,
 81331421,
 81242862,
 -1,
 81396956,
 81314516,
 -1,
 -64293,
 81387919,
 11967,
 -1,
 81420374,
 11968,
 -1,
 81368511,
 11966,
 -1,
 81289195,
 12004,
 81724643,
 81240041,
 -1,
 81790178,
 81667608,
 -1,
 -64287,
 81775970,
 11941,
 -1,
 81827263,
 11940,
 -1,
 81742362,
 11909,
 82052327,
 81671712,
 -1,
 -64283,
 82023205,
 11944,
 -64282,
 82079429,
 11914,
 -1,
 82133403,
 11934,
 82314474,
 82014851,
 -1,
 -64279,
 82300258,
 11913,
 -1,
 82351551,
 11912,
 82511085,
 82267734,
 -1,
 -64276,
 82482896,
 11978,
 -1,
 82537597,
 11939,
 -1,
 82482202,
 11961,
 82837503,
 71221511,
 -1,
 82838781,
 82729099,
 12752,
 82904313,
 82831134,
 12757,
 82969845,
 82896670,
 12741,
 83035380,
 82962206,
 12750,
 -1,
 82989795,
 12769,
 -1,
 83009513,
 12747,
 83231991,
 82959624,
 12749,
 -1,
 83186403,
 12744,
 -64264,
 83215060,
 12746,
 -1,
 83317475,
 12742,
 83494139,
 82878441,
 12743,
 -1,
 83484326,
 12748,
 -64260,
 83485674,
 12768,
 -1,
 83579619,
 12758,
 83756295,
 82818847,
 12753,
 83821825,
 83748638,
 12759,
 -64256,
 83814174,
 12766,
 -1,
 83877542,
 12745,
 84018436,
 83811592,
 12740,
 -64253,
 84010782,
 12760,
 -1,
 84038371,
 12767,
 -64251,
 84001492,
 12761,
 -64250,
 84189161,
 12755,
 -1,
 84234979,
 12762,
 84411659,
 83730409,
 12754,
 -64247,
 84403998,
 12764,
 -64246,
 84431587,
 12770,
 -1,
 84489760,
 12763,
 84673805,
 84394708,
 12736,
 -1,
 84642015,
 12765,
 -64242,
 84665215,
 12738,
 -64241,
 84795046,
 12737,
 -64240,
 84846404,
 12771,
 -64239,
 84904159,
 12751,
 -64238,
 84948512,
 12756,
 -1,
 85011619,
 12739,
 85199338,
 118346,
 -1,
 85264864,
 85166960,
 -1,
 85330255,
 85244976,
 -1,
 85394861,
 85283555,
 -1,
 85460340,
 85333364,
 73909,
 85525858,
 85398183,
 73911,
 85655551,
 85458944,
 -1,
 85656929,
 85575748,
 -1,
 85722404,
 85595508,
 -1,
 85787936,
 85657721,
 -1,
 -64226,
 85747053,
 73914,
 -64225,
 85809321,
 73913,
 -1,
 85866130,
 73912,
 86050082,
 85768723,
 73917,
 -1,
 85988075,
 73918,
 -64221,
 86018271,
 73916,
 -1,
 86124172,
 73915,
 86312237,
 85702431,
 -1,
 86377769,
 86268043,
 -1,
 86443304,
 86327431,
 73957,
 -1,
 86378844,
 73958,
 -1,
 86401829,
 73959,
 86639916,
 86316404,
 -1,
 -64213,
 86616404,
 73956,
 -1,
 86668120,
 73955,
 -1,
 86626677,
 73960,
 86902069,
 86266595,
 -1,
 86967602,
 86860159,
 73933,
 87033137,
 86905788,
 73934,
 -1,
 86968448,
 73935,
 -1,
 87009697,
 73936,
 87293951,
 86906228,
 -1,
 -64204,
 87206228,
 73932,
 -1,
 87263539,
 73931,
 87426364,
 86864008,
 -1,
 87491896,
 87384869,
 73946,
 -1,
 87427290,
 73947,
 87622971,
 87430516,
 -1,
 -64198,
 87604558,
 73945,
 -1,
 87650440,
 73944,
 -1,
 87609011,
 73948,
 87885123,
 87382155,
 -1,
 87950657,
 87823732,
 -1,
 88016192,
 87913304,
 73938,
 -1,
 87951569,
 73939,
 -1,
 87951597,
 73937,
 -64190,
 87936749,
 73941,
 -1,
 88170922,
 73940,
 88343880,
 87834759,
 -1,
 88409414,
 88312031,
 73929,
 -1,
 88345418,
 73930,
 88604671,
 88372056,
 73927,
 -1,
 88475857,
 73928,
 88671565,
 88290848,
 -1,
 88737099,
 88629631,
 73924,
 -1,
 88703011,
 73925,
 -64180,
 88723178,
 73926,
 -1,
 88806772,
 73923,
 88999251,
 88614518,
 -1,
 89064784,
 88987007,
 73921,
 -1,
 89000227,
 73922,
 89260031,
 89003380,
 -1,
 -64174,
 89172338,
 73920,
 -1,
 89208352,
 73919,
 89392470,
 88985162,
 73962,
 89522175,
 89339424,
 73963,
 -1,
 89393307,
 73964,
 89589080,
 89362599,
 73952,
 -1,
 89524151,
 73953,
 89720155,
 89554917,
 -1,
 -64166,
 89678207,
 73951,
 -1,
 89735390,
 73950,
 89916766,
 89678207,
 -1,
 -64163,
 89897498,
 73943,
 -1,
 89937268,
 73942,
 -64161,
 89899925,
 73961,
 -64160,
 90087502,
 73954,
 -1,
 90141613,
 73949,
 -1,
 85630272,
 73965,
 90375528,
 85493983,
 73974,
 90505215,
 90313383,
 73975,
 90570751,
 90374144,
 -1,
 -64154,
 90490221,
 73976,
 -64153,
 90545481,
 73977,
 -1,
 90584163,
 73978,
 90768747,
 90338136,
 73970,
 -64150,
 90709095,
 73972,
 -1,
 90768356,
 73971,
 90965357,
 90745172,
 73979,
 -1,
 90903372,
 73980,
 91096431,
 90912288,
 73968,
 -1,
 91031302,
 73969,
 91227505,
 91039400,
 73966,
 -1,
 91161315,
 73967,
 -64142,
 91208328,
 73981,
 -64141,
 91324389,
 73973,
 -1,
 91358245,
 73910,
 91555219,
 85418367,
 73984,
 91620735,
 91531604,
 -1,
 91686269,
 91558732,
 73994,
 91815935,
 91622142,
 -1,
 -64135,
 91725902,
 73999,
 -64134,
 91782942,
 73998,
 -64133,
 91841901,
 73997,
 -64132,
 91902837,
 73996,
 -1,
 91952551,
 73995,
 92209151,
 91624103,
 73992,
 -1,
 92079141,
 73993,
 92276105,
 91600671,
 -1,
 92341640,
 92231819,
 74001,
 92471295,
 92274688,
 -1,
 92472711,
 92390100,
 -1,
 92538246,
 92432065,
 -1,
 -64123,
 92521365,
 74004,
 -1,
 92546774,
 74003,
 -1,
 92489812,
 74005,
 -1,
 92419210,
 74002,
 -1,
 92281332,
 74000,
 92931469,
 92214204,
 73988,
 93061119,
 92864512,
 -1,
 -64116,
 92970323,
 73989,
 -1,
 93009021,
 73990,
 93193618,
 92864512,
 -1,
 93259153,
 93177924,
 -1,
 -64112,
 93245002,
 73986,
 -1,
 93274247,
 73985,
 -1,
 93205617,
 73987,
 -1,
 93141474,
 73991,
 93586859,
 91541066,
 74006,
 93652380,
 93524647,
 74008,
 93782015,
 93585408,
 -1,
 93783451,
 93702212,
 -1,
 93848985,
 93745370,
 74009,
 -1,
 93784923,
 74010,
 -64102,
 93829076,
 74012,
 -1,
 93950119,
 74011,
 -1,
 93739067,
 74013,
 94176673,
 93628756,
 74021,
 94242208,
 94162506,
 -1,
 -64097,
 94222867,
 74024,
 -1,
 94275807,
 74023,
 -1,
 94180550,
 74022,
 94504359,
 94123552,
 74014,
 94633983,
 94437376,
 -1,
 94635430,
 94554180,
 -1,
 -64091,
 94597914,
 74016,
 -1,
 94639538,
 74015,
 -1,
 94608732,
 74017,
 94897577,
 94470117,
 74019,
 -1,
 94833551,
 74020,
 -64086,
 94860120,
 74018,
 -1,
 94962418,
 74007,
 95223807,
 93538970,
 73982,
 -1,
 95095673,
 73983,
 95290934,
 85357400,
 -1,
 95356418,
 95229300,
 74167,
 95421948,
 95310596,
 -1,
 95487478,
 95364726,
 74168,
 95617023,
 95420416,
 -1,
 95618549,
 95537220,
 -1,
 95684027,
 95556980,
 74169,
 95749560,
 95619193,
 -1,
 -64074,
 95712434,
 74172,
 -64073,
 95769509,
 74171,
 -1,
 95827602,
 74170,
 -64071,
 95730241,
 74175,
 -64070,
 95979743,
 74174,
 -1,
 96039768,
 74173,
 96208322,
 95669834,
 74213,
 96273855,
 96143481,
 -1,
 -64066,
 96259684,
 74215,
 -1,
 96277876,
 74214,
 -64064,
 96254483,
 74218,
 -64063,
 96417312,
 74217,
 -1,
 96473824,
 74216,
 96667083,
 96188191,
 -1,
 96732618,
 96622731,
 -1,
 96798150,
 96718509,
 74207,
 -1,
 96733511,
 74208,
 96929225,
 96759178,
 -1,
 -64056,
 96912749,
 74206,
 -1,
 96969820,
 74205,
 -1,
 96878824,
 74204,
 -1,
 96719221,
 74209,
 97256914,
 96628872,
 -1,
 97322448,
 97242698,
 -1,
 97387983,
 97284952,
 74194,
 -1,
 97323191,
 74195,
 -1,
 97325900,
 74193,
 97648639,
 97280383,
 74191,
 -1,
 97552607,
 74192,
 97715671,
 97219416,
 -1,
 97781205,
 97701450,
 74198,
 -1,
 97743704,
 74199,
 -64042,
 97742089,
 74197,
 -1,
 97851546,
 74196,
 98043357,
 97673599,
 -1,
 98108892,
 98009061,
 74188,
 98238463,
 98044025,
 -1,
 -64037,
 98139931,
 74190,
 -1,
 98195625,
 74189,
 -1,
 98063732,
 74187,
 98436578,
 97997539,
 -1,
 98502112,
 98422778,
 74182,
 -1,
 98437293,
 74183,
 98697215,
 98440564,
 74180,
 -1,
 98609492,
 74181,
 98764263,
 98419412,
 -1,
 98829798,
 98702708,
 -1,
 -64027,
 98791580,
 74211,
 -1,
 98849507,
 74210,
 -1,
 98779333,
 74212,
 99091947,
 98729957,
 -1,
 99157482,
 99041415,
 74200,
 -1,
 99092644,
 74201,
 -1,
 99145375,
 74202,
 99354095,
 99047563,
 -1,
 99419630,
 99292532,
 74184,
 -1,
 99382104,
 74185,
 -1,
 99377614,
 74186,
 99616242,
 99296886,
 -1,
 -64015,
 99574143,
 74177,
 -1,
 99620822,
 74176,
 -64013,
 99584771,
 74203,
 -64012,
 99763953,
 74179,
 -1,
 99825413,
 74178,
 -1,
 95600493,
 74219,
 100139007,
 95463764,
 74220,
 100204543,
 100007936,
 -1,
 100206074,
 100124782,
 74221,
 -1,
 100141394,
 74222,
 100401151,
 100161595,
 74223,
 -1,
 100272007,
 74224,
 100468223,
 95387621,
 74228,
 100597759,
 100404089,
 74229,
 -1,
 100469036,
 74230,
 100664833,
 100430680,
 74226,
 -1,
 100600708,
 74227,
 -1,
 100622571,
 74225,
 100861490,
 95342154,
 74235,
 100927013,
 100799143,
 74237,
 101056511,
 100859904,
 -1,
 101058080,
 100975316,
 -1,
 101123615,
 101017281,
 -1,
 101189133,
 101085320,
 -1,
 101254668,
 101128150,
 -1,
 101320203,
 101192524,
 74246,
 -1,
 101255304,
 74247,
 -1,
 101257895,
 74245,
 -1,
 101212543,
 74248,
 101582352,
 101170140,
 -1,
 -63985,
 101544081,
 74255,
 -1,
 101582984,
 74254,
 101778963,
 101550303,
 -1,
 -63982,
 101764682,
 74253,
 -1,
 101793927,
 74252,
 101975574,
 101741485,
 -1,
 -63979,
 101929752,
 74250,
 -1,
 101976200,
 74249,
 102172184,
 101927567,
 74240,
 -1,
 102107851,
 74241,
 -63975,
 102157458,
 74256,
 -63974,
 102269749,
 74251,
 -63973,
 102327903,
 74244,
 -63972,
 102390948,
 74243,
 -63971,
 102454133,
 74242,
 -63970,
 102508246,
 74239,
 -1,
 102570484,
 74238,
 -1,
 101075028,
 74257,
 102827555,
 101037855,
 -1,
 -63966,
 102803526,
 74260,
 -1,
 102849608,
 74261,
 -63964,
 102799296,
 74259,
 -1,
 102970545,
 74258,
 103155243,
 100881225,
 74263,
 103284735,
 103088128,
 -1,
 103286314,
 103190927,
 -1,
 -63959,
 103274922,
 74264,
 -1,
 103327131,
 74265,
 -1,
 103267082,
 74266,
 103548462,
 103120869,
 74269,
 103677951,
 103483292,
 74270,
 -1,
 103547903,
 74271,
 -63953,
 103510872,
 74268,
 -63952,
 103700619,
 74267,
 -63951,
 103748428,
 74262,
 -1,
 103811872,
 74236,
 104071167,
 100819327,
 74231,
 -63948,
 103987731,
 74234,
 -63947,
 104039955,
 74233,
 -1,
 104100696,
 74232,
 104269483,
 95252616,
 -1,
 104334993,
 104207732,
 74071,
 104400507,
 104270590,
 -1,
 104465990,
 104354531,
 -1,
 104531519,
 104404340,
 74082,
 104597053,
 104507732,
 74085,
 -1,
 104532277,
 74086,
 -63938,
 104565043,
 74084,
 -1,
 104690520,
 74083,
 104859204,
 104489343,
 74087,
 104924739,
 104839702,
 -1,
 -63934,
 104899712,
 74089,
 -1,
 104936586,
 74090,
 -1,
 104901022,
 74088,
 105250815,
 104844874,
 74091,
 -1,
 105163180,
 74092,
 105317968,
 104445727,
 -1,
 105383500,
 105273483,
 -1,
 -63927,
 105369162,
 74115,
 -63926,
 105407269,
 74114,
 -63925,
 105463943,
 74113,
 -1,
 105518452,
 74112,
 105711182,
 105321844,
 74110,
 -1,
 105687380,
 74111,
 -63921,
 105697364,
 74117,
 -1,
 105800842,
 74116,
 105973336,
 105283557,
 -1,
 106038870,
 105922695,
 74100,
 106168319,
 105973881,
 -1,
 -63916,
 106087547,
 74103,
 -63915,
 106124657,
 74102,
 -1,
 106184769,
 74101,
 106430463,
 105996671,
 74104,
 -1,
 106301719,
 74105,
 106497629,
 105958986,
 74119,
 -63910,
 106478099,
 74123,
 -63909,
 106530873,
 74122,
 -63908,
 106575392,
 74121,
 -1,
 106631847,
 74120,
 106825315,
 106440310,
 -1,
 106890850,
 106763636,
 -1,
 -63904,
 106867028,
 74078,
 -63903,
 106918982,
 74077,
 -1,
 106968608,
 74076,
 -1,
 106848639,
 74079,
 107218535,
 106763636,
 74072,
 107284070,
 107165216,
 74073,
 -1,
 107219143,
 74074,
 -1,
 107264590,
 74075,
 107480683,
 107180168,
 -1,
 107546218,
 107438463,
 74096,
 -1,
 107492896,
 74097,
 -1,
 107485632,
 74095,
 107742830,
 107448543,
 -1,
 -63891,
 107729363,
 74107,
 -1,
 107757703,
 74106,
 107939441,
 107705176,
 -1,
 -63888,
 107925066,
 74099,
 -1,
 107962751,
 74098,
 108136052,
 107897215,
 -1,
 -63885,
 108101605,
 74094,
 -1,
 108156273,
 74093,
 108332663,
 108085383,
 -1,
 -63882,
 108313166,
 74081,
 -1,
 108376480,
 74080,
 -63880,
 108324862,
 74124,
 -63879,
 108512292,
 74118,
 -63878,
 108574314,
 74109,
 -1,
 108635014,
 74108,
 108791425,
 104347168,
 -1,
 108856958,
 108729353,
 74131,
 -1,
 108791654,
 74132,
 -63873,
 108794812,
 74130,
 -63872,
 108925772,
 74129,
 -1,
 108991143,
 74128,
 109184645,
 108772686,
 74140,
 109314047,
 109117440,
 -1,
 -63868,
 109223310,
 74142,
 -1,
 109278288,
 74141,
 109446793,
 109146968,
 74135,
 109576191,
 109379584,
 -1,
 -63864,
 109496395,
 74136,
 -1,
 109524132,
 74137,
 109708940,
 109412325,
 -1,
 -63861,
 109646780,
 74139,
 -1,
 109712039,
 74138,
 109905550,
 109670536,
 74133,
 -1,
 109841243,
 74134,
 110036624,
 109843111,
 74125,
 -1,
 109970175,
 74126,
 -1,
 109979254,
 74127,
 110233245,
 104320586,
 74154,
 110298772,
 110209364,
 74163,
 -1,
 110233233,
 74164,
 110429846,
 110261080,
 74160,
 -1,
 110363685,
 74161,
 110560920,
 110367676,
 74157,
 -1,
 110496783,
 74158,
 -63847,
 110541778,
 74165,
 -63846,
 110659807,
 74162,
 -63845,
 110695622,
 74159,
 -63844,
 110760780,
 74156,
 -1,
 110823197,
 74155,
 111019689,
 110190975,
 74144,
 111085219,
 110999327,
 -1,
 111150753,
 111044194,
 74152,
 -1,
 111085434,
 74153,
 -63838,
 111106187,
 74151,
 -1,
 111221236,
 74150,
 111412903,
 111020798,
 -1,
 111478438,
 111398474,
 74146,
 -1,
 111425056,
 74147,
 -1,
 111421142,
 74145,
 -63832,
 111380703,
 74149,
 -1,
 111621664,
 74148,
 -63830,
 111010538,
 74166,
 -1,
 111757967,
 74143,
 111937298,
 104249119,
 -1,
 112002787,
 111892619,
 -1,
 112068294,
 111960447,
 -1,
 112133820,
 112033765,
 74438,
 112263167,
 112069374,
 -1,
 112264882,
 112158061,
 74444,
 -1,
 112198693,
 74445,
 112395957,
 112207478,
 -1,
 -63820,
 112382320,
 74441,
 -1,
 112400884,
 74440,
 -63818,
 112375760,
 74449,
 -63817,
 112560059,
 74448,
 -63816,
 112623428,
 74447,
 -63815,
 112685865,
 74446,
 -63814,
 112743333,
 74443,
 -63813,
 112802283,
 74442,
 -1,
 112858484,
 74439,
 113051328,
 112109908,
 74451,
 113180671,
 112984064,
 -1,
 -63809,
 113100141,
 74452,
 -1,
 113155653,
 74453,
 113313476,
 112997920,
 74435,
 113442815,
 113249022,
 -1,
 -63805,
 113337951,
 74437,
 -1,
 113382772,
 74436,
 -63803,
 113296149,
 74454,
 -1,
 113544338,
 74450,
 113706708,
 112006516,
 74413,
 113772241,
 113644364,
 74414,
 113901567,
 113707774,
 -1,
 113903307,
 113823306,
 74421,
 -1,
 113838208,
 74422,
 -63796,
 113888456,
 74420,
 -63795,
 114015186,
 74419,
 -63794,
 114068227,
 74418,
 -63793,
 114120104,
 74417,
 -63792,
 114173654,
 74416,
 -1,
 114234740,
 74415,
 -63790,
 113748382,
 74425,
 -63789,
 114370209,
 74424,
 -1,
 114431105,
 74423,
 114624223,
 113655943,
 74426,
 114689752,
 114604563,
 74432,
 -63785,
 114652342,
 74434,
 -1,
 114692775,
 74433,
 114886365,
 114622464,
 -1,
 114951900,
 114859579,
 -1,
 -63781,
 114934581,
 74429,
 -1,
 114971424,
 74428,
 -1,
 114909451,
 74427,
 -63778,
 114854111,
 74431,
 -1,
 115168001,
 74430,
 115408895,
 114609738,
 74455,
 -63775,
 115289179,
 74458,
 -63774,
 115348135,
 74457,
 -1,
 115410771,
 74456,
 115607298,
 111940980,
 74387,
 115672830,
 115561187,
 74389,
 115802111,
 115605504,
 -1,
 115803899,
 115722308,
 -1,
 115869421,
 115789386,
 -1,
 -63767,
 115849747,
 74406,
 -63766,
 115910996,
 74405,
 -63765,
 115965925,
 74404,
 -63764,
 116008566,
 74403,
 -1,
 116069031,
 74402,
 116262640,
 115848991,
 -1,
 -63761,
 116219064,
 74400,
 -1,
 116267508,
 74399,
 116459251,
 116224136,
 -1,
 -63758,
 116446591,
 74395,
 -1,
 116464064,
 74394,
 116655861,
 116408385,
 74391,
 -1,
 116598390,
 74392,
 -63754,
 116638513,
 74401,
 -63753,
 116756647,
 74398,
 -63752,
 116819089,
 74397,
 -63751,
 116883272,
 74396,
 -63750,
 116938921,
 74393,
 -1,
 116987252,
 74390,
 -63748,
 115777074,
 74407,
 -63747,
 117149932,
 74388,
 -1,
 117200955,
 74408,
 117376768,
 115635032,
 74409,
 -1,
 117310773,
 74410,
 -63743,
 117352788,
 74412,
 -1,
 117476334,
 74411,
 117638923,
 115592778,
 74466,
 117704453,
 117614932,
 74473,
 -1,
 117642561,
 74474,
 117835527,
 117669861,
 74471,
 -1,
 117777236,
 74472,
 117966601,
 117782048,
 74468,
 -1,
 117904039,
 74469,
 -63734,
 117924136,
 74470,
 -1,
 118032401,
 74467,
 118292479,
 117596543,
 74459,
 118294287,
 118182627,
 74461,
 118423551,
 118231996,
 74462,
 -1,
 118294529,
 74463,
 -63728,
 118256612,
 74465,
 -63727,
 118452366,
 74464,
 -1,
 118490149,
 74460,
 118687606,
 111922762,
 74507,
 118753094,
 118663508,
 74536,
 118818611,
 118738506,
 74551,
 118884145,
 118754046,
 -1,
 118949660,
 118837987,
 -1,
 119015195,
 118887796,
 74556,
 -63719,
 118991188,
 74559,
 -63718,
 119048499,
 74558,
 -1,
 119108440,
 74557,
 -1,
 119000650,
 74560,
 119342880,
 118935114,
 -1,
 -63714,
 119322226,
 74574,
 -63713,
 119354912,
 74573,
 -1,
 119408813,
 74572,
 119605028,
 119300479,
 -1,
 -63710,
 119585299,
 74564,
 -63709,
 119635941,
 74563,
 -1,
 119690609,
 74562,
 119867175,
 119584543,
 -1,
 -63706,
 119825556,
 74570,
 -1,
 119888680,
 74569,
 120063785,
 119805300,
 74552,
 -1,
 120044312,
 74553,
 -63702,
 120048777,
 74571,
 -63701,
 120168526,
 74568,
 -63700,
 120227170,
 74567,
 -63699,
 120291144,
 74566,
 -63698,
 120353358,
 74565,
 -63697,
 120412329,
 74561,
 -63696,
 120471624,
 74555,
 -1,
 120530766,
 74554,
 120782847,
 118830731,
 74575,
 -1,
 120654746,
 74576,
 120850240,
 118756007,
 74539,
 120979455,
 120785662,
 -1,
 120981305,
 120901293,
 74545,
 121110527,
 120916089,
 -1,
 -63688,
 120990029,
 74547,
 -1,
 121054036,
 74546,
 121243454,
 120919412,
 -1,
 121308989,
 121178233,
 -1,
 -63684,
 121276731,
 74541,
 -1,
 121329833,
 74540,
 -1,
 121271128,
 74542,
 -63681,
 121213095,
 74544,
 -1,
 121526441,
 74543,
 121702210,
 120807807,
 74549,
 -1,
 121639756,
 74550,
 121833285,
 121634816,
 -1,
 -63676,
 121813770,
 74538,
 -1,
 121844991,
 74537,
 -1,
 121770940,
 74548,
 122095442,
 118699552,
 74515,
 122160977,
 122028032,
 -1,
 122226509,
 122144836,
 -1,
 122292043,
 122211949,
 74519,
 -1,
 122225701,
 74520,
 -63668,
 122258577,
 74518,
 -1,
 122365654,
 74517,
 122554191,
 122206986,
 74522,
 -1,
 122489632,
 74523,
 -63664,
 122516265,
 74516,
 -1,
 122640443,
 74521,
 -1,
 122146858,
 74524,
 122881885,
 122060773,
 74525,
 122947416,
 122817278,
 -1,
 -63659,
 122932810,
 74529,
 -63658,
 122993238,
 74528,
 -63657,
 123044650,
 74527,
 -1,
 123106378,
 74526,
 123275100,
 122933621,
 74531,
 123404287,
 123210494,
 -1,
 -63653,
 123314254,
 74533,
 -1,
 123367740,
 74532,
 -1,
 123218272,
 74530,
 123602790,
 122862099,
 74577,
 123668323,
 123538174,
 -1,
 123733857,
 123630345,
 74579,
 -1,
 123709780,
 74580,
 -63646,
 123716501,
 74581,
 -1,
 123802996,
 74578,
 -63644,
 123659012,
 74582,
 -63643,
 123982287,
 74584,
 -1,
 123998887,
 74583,
 124192621,
 123535360,
 -1,
 124258155,
 124165794,
 -1,
 -63639,
 124243581,
 74512,
 -63638,
 124305938,
 74511,
 -1,
 124362833,
 74510,
 -63636,
 124243608,
 74509,
 -1,
 124475447,
 74508,
 124651377,
 124184350,
 -1,
 124716912,
 124588876,
 74586,
 -1,
 124652395,
 74587,
 -1,
 124702282,
 74588,
 124913523,
 124618975,
 74534,
 -1,
 124847141,
 74535,
 -63628,
 124898489,
 74585,
 -63627,
 124986998,
 74514,
 -1,
 125047463,
 74513,
 125241285,
 118625652,
 73728,
 125306766,
 125183606,
 73738,
 125372295,
 125239296,
 -1,
 125437830,
 125356100,
 -1,
 125503357,
 125395327,
 -1,
 -63620,
 125470050,
 73745,
 -1,
 125523316,
 73744,
 125699968,
 125457156,
 -1,
 -63617,
 125667635,
 73742,
 -1,
 125727576,
 73741,
 -63615,
 125685357,
 73748,
 -63614,
 125876996,
 73747,
 -63613,
 125924426,
 73746,
 -63612,
 125982889,
 73743,
 -63611,
 126042188,
 73740,
 -1,
 126100352,
 73739,
 -1,
 125392955,
 73749,
 126418943,
 125309607,
 73750,
 126484479,
 126290686,
 -1,
 -63606,
 126403477,
 73755,
 -63605,
 126466646,
 73754,
 -63604,
 126518069,
 73753,
 -63603,
 126571381,
 73752,
 -1,
 126625541,
 73751,
 126814107,
 125268824,
 73760,
 126879641,
 126749438,
 -1,
 126945171,
 126840968,
 -1,
 -63598,
 126902655,
 73766,
 -1,
 126949337,
 73765,
 -63596,
 126932639,
 73768,
 -63595,
 127122135,
 73767,
 -63594,
 127162537,
 73764,
 -63593,
 127227304,
 73763,
 -63592,
 127285734,
 73762,
 -1,
 127343092,
 73761,
 -63590,
 126830763,
 73770,
 -1,
 127475006,
 73769,
 127666087,
 126793503,
 -1,
 127731622,
 127621259,
 73784,
 127797156,
 127664128,
 -1,
 127862690,
 127769873,
 -1,
 127928225,
 127835400,
 73788,
 -1,
 127861443,
 73789,
 -1,
 127913111,
 73787,
 -63581,
 127854593,
 73785,
 -1,
 128086204,
 73786,
 -63579,
 127750936,
 73791,
 -1,
 128193191,
 73790,
 -1,
 127670866,
 73783,
 128452528,
 127601406,
 -1,
 -63575,
 128432076,
 73736,
 -63574,
 128485499,
 73735,
 -63573,
 128545905,
 73734,
 -63572,
 128607597,
 73733,
 -63571,
 128669865,
 73732,
 -63570,
 128734069,
 73731,
 -63569,
 128788182,
 73730,
 -1,
 128849268,
 73729,
 129042360,
 128420063,
 73773,
 129107895,
 128974848,
 -1,
 129173429,
 129082471,
 -1,
 -63564,
 129154925,
 73777,
 -1,
 129210258,
 73776,
 -63562,
 129157005,
 73775,
 -1,
 129342720,
 73774,
 -1,
 129088215,
 73778,
 129566652,
 129018196,
 -1,
 129632187,
 129505238,
 73780,
 -1,
 129567609,
 73781,
 -1,
 129593528,
 73782,
 129828800,
 129527944,
 73757,
 129957887,
 129764094,
 -1,
 -63553,
 129874724,
 73759,
 -1,
 129911253,
 73758,
 130090946,
 129794629,
 73771,
 -1,
 130026383,
 73772,
 -63549,
 130065329,
 73779,
 -63548,
 130168352,
 73756,
 -1,
 130224807,
 73737,
 130418703,
 125208799,
 -1,
 130484195,
 130403914,
 74337,
 130549730,
 130451679,
 74339,
 130615255,
 130537368,
 74349,
 130744319,
 130547712,
 -1,
 130746325,
 130618907,
 -1,
 -63540,
 130731693,
 74359,
 -63539,
 130792564,
 74358,
 -63538,
 130845443,
 74357,
 -63537,
 130905005,
 74356,
 -63536,
 130969798,
 74355,
 -63535,
 131032433,
 74354,
 -63534,
 131094583,
 74353,
 -63533,
 131153988,
 74352,
 -63532,
 131213645,
 74351,
 -1,
 131277752,
 74350,
 131530751,
 130708063,
 74360,
 -1,
 131402738,
 74361,
 131661823,
 130547712,
 -1,
 131663838,
 131560572,
 -1,
 131729371,
 131643344,
 74342,
 -1,
 131663809,
 74343,
 -63524,
 131716767,
 74344,
 -63523,
 131826325,
 74341,
 -1,
 131879845,
 74340,
 132057056,
 131609830,
 74347,
 -1,
 131990855,
 74348,
 -63519,
 132040045,
 74345,
 -1,
 132161019,
 74346,
 -1,
 130486924,
 74338,
 132384766,
 130441599,
 74316,
 132450295,
 132352741,
 74322,
 132579327,
 132385534,
 -1,
 132581355,
 132496087,
 74330,
 132710399,
 132515968,
 -1,
 132712426,
 132626963,
 74332,
 -1,
 132647048,
 74333,
 -1,
 132644982,
 74331,
 132909039,
 132519284,
 -1,
 132974574,
 132889107,
 74324,
 -1,
 132909192,
 74325,
 -1,
 132942047,
 74323,
 133171186,
 132894282,
 -1,
 -63503,
 133151251,
 74335,
 -1,
 133173984,
 74334,
 133367797,
 133138655,
 -1,
 -63500,
 133353939,
 74329,
 -1,
 133382279,
 74328,
 -63498,
 133333824,
 74327,
 -1,
 133519415,
 74326,
 133695483,
 132415461,
 74319,
 133824511,
 133630784,
 -1,
 -63494,
 133736801,
 74321,
 -1,
 133794099,
 74320,
 -63492,
 133674956,
 74336,
 -63491,
 133894823,
 74318,
 -1,
 133958443,
 74317,
 134154249,
 132322676,
 74302,
 134219781,
 134107908,
 74304,
 134285316,
 134152192,
 -1,
 -63486,
 134269048,
 74306,
 -63485,
 134322125,
 74307,
 -1,
 134376141,
 74305,
 -1,
 134261076,
 74308,
 134613000,
 134184933,
 74310,
 -63481,
 134550183,
 74311,
 -1,
 134612525,
 74309,
 -1,
 134550183,
 74303,
 134938623,
 134103175,
 74312,
 135004159,
 134807552,
 -1,
 135006222,
 134924356,
 -1,
 -63475,
 134991866,
 74314,
 -1,
 135009652,
 74313,
 -1,
 134986506,
 74315,
 135268429,
 130364960,
 -1,
 135333940,
 135206260,
 73813,
 135399471,
 135287523,
 73814,
 135528447,
 135333152,
 -1,
 135530521,
 135418595,
 -1,
 135596054,
 135487871,
 73821,
 -1,
 135571870,
 73822,
 135727128,
 135533940,
 73819,
 -1,
 135661824,
 73820,
 -1,
 135712762,
 73823,
 135923742,
 135492440,
 -1,
 135989277,
 135908938,
 73829,
 -63460,
 135954405,
 73831,
 -1,
 135989515,
 73830,
 -1,
 135927156,
 73828,
 136251425,
 135908938,
 -1,
 -63456,
 136231443,
 73837,
 -1,
 136254198,
 73836,
 136448035,
 136211440,
 73825,
 -1,
 136382692,
 73826,
 136579110,
 136390262,
 -1,
 -63451,
 136536447,
 73818,
 -1,
 136583775,
 73817,
 136775721,
 136516980,
 -1,
 -63448,
 136741445,
 73816,
 -1,
 136775936,
 73815,
 -63446,
 136758165,
 73835,
 -63445,
 136952796,
 73834,
 -63444,
 137011437,
 73833,
 -63443,
 137071363,
 73832,
 -63442,
 137130202,
 73827,
 -1,
 137189545,
 73824,
 137365555,
 135375188,
 73839,
 137494527,
 137303412,
 -1,
 -63438,
 137368508,
 73841,
 -1,
 137433932,
 73840,
 -1,
 137330661,
 73838,
 137693253,
 135319114,
 73850,
 137758778,
 137660639,
 73860,
 137824313,
 137696076,
 73861,
 137953279,
 137757733,
 73862,
 -1,
 137823269,
 73863,
 -1,
 137761724,
 73864,
 138086461,
 137700982,
 73854,
 -63428,
 138023591,
 73856,
 -1,
 138087220,
 73855,
 138283073,
 138018816,
 -1,
 -63425,
 138263306,
 73853,
 -63424,
 138321188,
 73851,
 -1,
 138369083,
 73852,
 138545219,
 138236643,
 73857,
 -1,
 138530810,
 73858,
 -63420,
 138520990,
 73865,
 -1,
 138631307,
 73859,
 138870783,
 137650559,
 73842,
 138872905,
 138772453,
 73844,
 -63416,
 138810023,
 73846,
 -1,
 138873743,
 73845,
 139069515,
 138840287,
 73847,
 -1,
 139003125,
 73848,
 -63412,
 139049491,
 73849,
 -1,
 139142774,
 73843,
 139331714,
 135217287,
 73866,
 139397222,
 139323261,
 73889,
 139526143,
 139332350,
 -1,
 139528277,
 139424600,
 -1,
 139593811,
 139466100,
 73903,
 -1,
 139555712,
 73904,
 -63404,
 139578954,
 73906,
 -1,
 139682175,
 73905,
 139855961,
 139466100,
 73890,
 139921496,
 139790554,
 73891,
 -1,
 139856772,
 73892,
 -1,
 139888863,
 73893,
 140118109,
 139817096,
 -1,
 140183644,
 140059588,
 73900,
 -1,
 140118646,
 73901,
 -1,
 140168880,
 73902,
 140380256,
 140103242,
 -1,
 -63393,
 140326432,
 73908,
 -1,
 140382887,
 73907,
 140576866,
 140335273,
 73897,
 -1,
 140510245,
 73898,
 140707940,
 140525644,
 73895,
 -1,
 140641317,
 73896,
 -63387,
 140666225,
 73899,
 -1,
 140781270,
 73894,
 140970095,
 139364575,
 73879,
 141099007,
 140902400,
 -1,
 141101164,
 141019204,
 -1,
 141166699,
 141054832,
 73880,
 -1,
 141101771,
 73881,
 -1,
 141132571,
 73882,
 -63379,
 141082477,
 73885,
 -63378,
 141334440,
 73884,
 -1,
 141374551,
 73883,
 141559928,
 140907175,
 73869,
 141688831,
 141495038,
 -1,
 141690996,
 141604639,
 -1,
 -63373,
 141646632,
 73874,
 -1,
 141695476,
 73873,
 -63371,
 141676106,
 73875,
 -63370,
 141853841,
 73872,
 -63369,
 141906853,
 73871,
 -1,
 141956501,
 73870,
 142149755,
 141535572,
 -1,
 -63366,
 142108605,
 73887,
 -1,
 142165745,
 73886,
 142346366,
 142082048,
 -1,
 -63363,
 142329956,
 73867,
 -1,
 142384428,
 73868,
 -63361,
 142326350,
 73888,
 -63360,
 142504792,
 73878,
 -63359,
 142562724,
 73877,
 -1,
 142621163,
 73876,
 142805161,
 139313876,
 -1,
 142870681,
 142742900,
 74475,
 142936205,
 142824163,
 74483,
 143065087,
 142871294,
 -1,
 143067273,
 142981651,
 -1,
 -63352,
 143052362,
 74487,
 -1,
 143081607,
 74486,
 -63350,
 143052794,
 74489,
 -63349,
 143248530,
 74488,
 -63348,
 143284279,
 74485,
 -1,
 143337805,
 74484,
 143526035,
 142868480,
 -1,
 143591569,
 143509572,
 -1,
 -63344,
 143557777,
 74478,
 -1,
 143613065,
 74477,
 -63342,
 143546427,
 74479,
 -1,
 143729668,
 74476,
 143919255,
 143468150,
 74480,
 144048127,
 143851520,
 -1,
 -63338,
 143966061,
 74482,
 -1,
 144023132,
 74481,
 -63336,
 143894868,
 74491,
 -1,
 144142492,
 74490,
 144312481,
 142827903,
 74494,
 144378015,
 144288084,
 74497,
 144506879,
 144310272,
 -1,
 144509086,
 144416383,
 74499,
 -1,
 144442340,
 74500,
 -1,
 144492690,
 74498,
 -63328,
 144339800,
 74496,
 -1,
 144640715,
 74495,
 144836775,
 144297546,
 74501,
 144902308,
 144812372,
 74505,
 -1,
 144836659,
 74506,
 -63323,
 144867301,
 74504,
 -63322,
 144994440,
 74503,
 -1,
 145052411,
 74502,
 145293311,
 144785543,
 74492,
 -1,
 145163301,
 74493,
 145361101,
 142770149,
 -1,
 145426624,
 145346122,
 74284,
 145492155,
 145406483,
 74290,
 145557684,
 145424384,
 -1,
 145623217,
 145541188,
 -1,
 -63313,
 145614640,
 74293,
 -63312,
 145650458,
 74292,
 -1,
 145692020,
 74291,
 145885363,
 145595889,
 74294,
 -1,
 145820431,
 74295,
 -1,
 145831102,
 74296,
 146145279,
 145494860,
 74297,
 146210815,
 146014208,
 -1,
 146213050,
 146131012,
 -1,
 146278585,
 146150772,
 74298,
 -1,
 146213010,
 74299,
 -1,
 146225291,
 74300,
 -1,
 146167867,
 74301,
 146540733,
 145445603,
 74286,
 -1,
 146474021,
 74287,
 -63298,
 146517477,
 74289,
 -63297,
 146640615,
 74288,
 -1,
 146671534,
 74285,
 146868425,
 145364340,
 74272,
 146933955,
 146848275,
 74278,
 -1,
 146870951,
 74279,
 147065030,
 146866176,
 -1,
 -63291,
 147048594,
 74273,
 -1,
 147085371,
 74274,
 -63289,
 147040596,
 74277,
 -63288,
 147216523,
 74276,
 -1,
 147264167,
 74275,
 147458251,
 146825599,
 74282,
 -1,
 147425503,
 74283,
 147652607,
 147406983,
 74280,
 -1,
 147568415,
 74281,
 147720424,
 145318271,
 74047,
 147785941,
 147685349,
 74062,
 147851476,
 147718144,
 -1,
 -63279,
 147835026,
 74063,
 -63278,
 147898221,
 74066,
 -63277,
 147953588,
 74065,
 -1,
 147993752,
 74064,
 -1,
 147810096,
 74067,
 148244700,
 147739363,
 74053,
 148373503,
 148201855,
 74054,
 148439039,
 148242432,
 -1,
 -63271,
 148352505,
 74056,
 -63270,
 148413803,
 74057,
 -63269,
 148461627,
 74058,
 -1,
 148519258,
 74055,
 148703455,
 148206424,
 74059,
 -63266,
 148640423,
 74061,
 -1,
 148704074,
 74060,
 148900067,
 148650466,
 74050,
 149028863,
 148834119,
 -1,
 -63262,
 148946797,
 74052,
 -1,
 148974683,
 74051,
 -63260,
 148879891,
 74070,
 -63259,
 149137748,
 74069,
 -63258,
 149194975,
 74068,
 -63257,
 149235318,
 74049,
 -1,
 149291010,
 74048,
 149489922,
 147675275,
 -1,
 149555444,
 149447039,
 74029,
 149684223,
 149490430,
 -1,
 149686509,
 149562196,
 74030,
 -1,
 149623463,
 74031,
 -63250,
 149671498,
 74038,
 -63249,
 149797591,
 74037,
 -63248,
 149852327,
 74036,
 -63247,
 149910102,
 74035,
 -63246,
 149967644,
 74034,
 -63245,
 150026815,
 74033,
 -1,
 150087382,
 74032,
 150276349,
 149540426,
 74039,
 150341884,
 150218377,
 74040,
 150470655,
 150276862,
 -1,
 -63240,
 150392826,
 74045,
 -63239,
 150436780,
 74044,
 -63238,
 150499644,
 74043,
 -63237,
 150559097,
 74042,
 -1,
 150609214,
 74041,
 -1,
 150303658,
 74046,
 150929407,
 150214004,
 74025,
 150931713,
 150798336,
 -1,
 -63232,
 150914413,
 74026,
 -1,
 150951995,
 74027,
 -1,
 150893400,
 74028,
 151193885,
 149463017,
 -1,
 151259416,
 151150975,
 74367,
 151324945,
 151191552,
 -1,
 151390480,
 151308356,
 -1,
 151456008,
 151375434,
 74375,
 -1,
 151392935,
 74376,
 151587082,
 151413119,
 74373,
 -1,
 151529078,
 74374,
 151718157,
 151529078,
 -1,
 -63220,
 151703114,
 74371,
 -1,
 151740799,
 74370,
 151914767,
 151655796,
 74368,
 -1,
 151856758,
 74369,
 -1,
 151863431,
 74372,
 -1,
 151336179,
 74377,
 152240127,
 151301725,
 74378,
 152305663,
 152109056,
 -1,
 152307991,
 152225860,
 -1,
 -63211,
 152299312,
 74381,
 -63210,
 152358906,
 74380,
 -1,
 152400099,
 74379,
 -1,
 152279003,
 74382,
 152635676,
 151197044,
 74362,
 -63206,
 152608745,
 74365,
 -63205,
 152668383,
 74364,
 -1,
 152712736,
 74363,
 -1,
 152586895,
 74366,
 152963382,
 151135862,
 -1,
 153028903,
 152900980,
 73792,
 153094434,
 152990552,
 73796,
 -63199,
 153032851,
 73798,
 -1,
 153093872,
 73797,
 153291044,
 153069908,
 73799,
 -1,
 153228785,
 73800,
 -63195,
 153246332,
 73795,
 -63194,
 153375486,
 73794,
 -1,
 153433632,
 73793,
 153618737,
 153013834,
 73805,
 153684269,
 153550848,
 -1,
 153749804,
 153656603,
 -1,
 -63189,
 153735635,
 73807,
 -1,
 153753112,
 73806,
 -1,
 153695307,
 73808,
 154011951,
 153659732,
 73811,
 -1,
 153948839,
 73812,
 154206207,
 153976635,
 73809,
 -1,
 154076922,
 73810,
 154337279,
 153575807,
 73801,
 154402815,
 154209022,
 -1,
 -63180,
 154297713,
 73804,
 -63179,
 154358693,
 73803,
 -1,
 154408308,
 73802,
 154601802,
 152954654,
 -1,
 154667326,
 154558847,
 74595,
 154732858,
 154609270,
 74598,
 -1,
 154666211,
 74599,
 -63173,
 154724141,
 74601,
 -63172,
 154817251,
 74600,
 -63171,
 154866508,
 74597,
 -1,
 154929237,
 74596,
 155126083,
 154652234,
 74602,
 155191617,
 155063305,
 74603,
 -1,
 155126534,
 74604,
 -63166,
 155156453,
 74606,
 -1,
 155266139,
 74605,
 155453769,
 155063668,
 74589,
 155519303,
 155385856,
 -1,
 -63162,
 155501933,
 74590,
 -1,
 155565950,
 74591,
 -63160,
 155486392,
 74593,
 -1,
 155669219,
 74592,
 -1,
 155402503,
 74594,
 155975679,
 154577236,
 -1,
 155978061,
 155850100,
 74383,
 -1,
 155919990,
 74384,
 -63154,
 155962954,
 74386,
 -1,
 156066175,
 74385,
 156240346,
 85299353,
 -1,
 156305782,
 156192342,
 -1,
 156371301,
 156277748,
 -1,
 156436823,
 156358771,
 74812,
 156502358,
 156368896,
 -1,
 -63147,
 156444278,
 74815,
 -1,
 156505460,
 74814,
 -1,
 156439484,
 74813,
 156764507,
 156378742,
 -1,
 156830042,
 156704073,
 74834,
 -1,
 156765199,
 74835,
 -1,
 156816984,
 74808,
 157026654,
 156744360,
 -1,
 -63139,
 157011530,
 74800,
 -1,
 157029031,
 74790,
 157223265,
 156980363,
 -1,
 -63136,
 157208138,
 74785,
 -1,
 157225639,
 74776,
 157419875,
 157164372,
 74754,
 -1,
 157354699,
 74828,
 -63132,
 157404746,
 74767,
 -1,
 157497919,
 74761,
 157745151,
 156331643,
 -1,
 157747563,
 157660959,
 -1,
 157813098,
 157702776,
 -1,
 -63127,
 157797962,
 74801,
 -1,
 157815463,
 74791,
 -1,
 157773580,
 74844,
 158075247,
 157689462,
 -1,
 158140782,
 158014793,
 74836,
 -1,
 158075919,
 74837,
 -1,
 158127704,
 74809,
 158337394,
 158028939,
 -1,
 -63119,
 158322250,
 74786,
 -1,
 158339751,
 74777,
 158534004,
 158278484,
 74755,
 -1,
 158468811,
 74829,
 -63115,
 158518858,
 74768,
 -1,
 158612031,
 74762,
 158796186,
 156287700,
 -1,
 158861706,
 158752859,
 -1,
 158927229,
 158841512,
 -1,
 158992763,
 158912074,
 74798,
 -1,
 158927887,
 74799,
 159186943,
 158929575,
 74788,
 -1,
 159058959,
 74789,
 159254913,
 158869110,
 -1,
 159320448,
 159241816,
 74806,
 -1,
 159255567,
 74807,
 -1,
 159259977,
 74833,
 159517060,
 159242300,
 -1,
 -63101,
 159453995,
 74811,
 -1,
 159519383,
 74810,
 159713671,
 159470731,
 -1,
 -63098,
 159698506,
 74784,
 -1,
 159716007,
 74775,
 159910281,
 159654740,
 74753,
 -1,
 159845067,
 74827,
 -1,
 159857215,
 74760,
 160169983,
 158851474,
 -1,
 160172430,
 160089825,
 -1,
 -63091,
 160159771,
 74846,
 -1,
 160184895,
 74843,
 160369041,
 160152232,
 -1,
 -63088,
 160353866,
 74797,
 -1,
 160371367,
 74787,
 160565652,
 160322699,
 -1,
 -63085,
 160550474,
 74783,
 -1,
 160567975,
 74774,
 160762263,
 160507510,
 -1,
 -63082,
 160749144,
 74805,
 -1,
 160767305,
 74832,
 160958873,
 160703316,
 74752,
 -1,
 160893643,
 74826,
 -1,
 160909972,
 74841,
 161155505,
 158775071,
 -1,
 161221030,
 161107079,
 -1,
 161286561,
 161208417,
 -1,
 161352096,
 161218560,
 -1,
 -63073,
 161293942,
 74819,
 -1,
 161355124,
 74818,
 -1,
 161289036,
 74817,
 -63070,
 161271370,
 74770,
 -63069,
 161594029,
 74793,
 -63068,
 161633424,
 74779,
 -63067,
 161692223,
 74764,
 -1,
 161751892,
 74757,
 161941934,
 161181425,
 -1,
 162007465,
 161882964,
 74756,
 -1,
 161942219,
 74830,
 -63062,
 161994794,
 74816,
 -63061,
 162123338,
 74769,
 -63060,
 162183853,
 74792,
 -63059,
 162223248,
 74778,
 -1,
 162282047,
 74763,
 162529279,
 161897089,
 -1,
 -63056,
 162432354,
 74803,
 -1,
 162478655,
 74802,
 162662852,
 161124751,
 -1,
 162728385,
 162630406,
 -1,
 162793910,
 162711237,
 -1,
 -63051,
 162781211,
 74845,
 -1,
 162806335,
 74842,
 162990521,
 162747531,
 -1,
 -63048,
 162975306,
 74782,
 -1,
 162992807,
 74773,
 163187132,
 162939015,
 -1,
 -63045,
 163166939,
 74840,
 -1,
 163210530,
 74847,
 163383743,
 163128950,
 -1,
 -63042,
 163370584,
 74804,
 -1,
 163388745,
 74831,
 -63040,
 163363530,
 74796,
 -1,
 163555421,
 74848,
 163774463,
 162690621,
 -1,
 -63037,
 163691837,
 74849,
 -1,
 163752021,
 74850,
 163908050,
 162630771,
 -1,
 163973583,
 163875590,
 -1,
 164039114,
 163960909,
 74822,
 -63032,
 163976124,
 74824,
 -63031,
 164041548,
 74823,
 -1,
 164102146,
 74825,
 -63029,
 164023882,
 74772,
 -63028,
 164281005,
 74795,
 -63027,
 164320400,
 74781,
 -63026,
 164379199,
 74766,
 -1,
 164438868,
 74759,
 164691967,
 163927432,
 -1,
 -63023,
 164595042,
 74838,
 -1,
 164645494,
 74839,
 164888575,
 163857725,
 -1,
 164891093,
 164812934,
 74820,
 -1,
 164827980,
 74821,
 -63018,
 164875850,
 74771,
 -63017,
 165001901,
 74794,
 -63016,
 165041296,
 74780,
 -63015,
 165100095,
 74765,
 -1,
 165159764,
 74758,
 165412863,
 156215071,
 -1,
 165415390,
 165296336,
 -1,
 -63011,
 165399356,
 74867,
 -1,
 165425643,
 74866,
 -63009,
 165403320,
 74865,
 -1,
 165581854,
 74864,
 165743080,
 85240148,
 -1,
 165808614,
 165707707,
 -1,
 165874149,
 165772525,
 -1,
 -63004,
 165844982,
 8910,
 -1,
 165879143,
 8911,
 -1,
 165817198,
 9130,
 -63001,
 165796150,
 10081,
 -1,
 166112459,
 164,
 -62999,
 165715994,
 9982,
 -1,
 166209562,
 8731,
 166399312,
 85136756,
 -1,
 166464784,
 166365407,
 -1,
 166530317,
 166402074,
 -1,
 166595282,
 166472926,
 5281,
 166660804,
 166532468,
 5264,
 166726338,
 166639014,
 -1,
 166791707,
 166707924,
 -1,
 166857215,
 166773460,
 -1,
 166922745,
 166835999,
 -1,
 166988277,
 166871175,
 5737,
 -1,
 166936711,
 5738,
 -62986,
 166973002,
 5735,
 -62985,
 167088527,
 5736,
 -62984,
 167141759,
 5739,
 -1,
 167187828,
 5740,
 167381499,
 166871175,
 5604,
 -1,
 167329927,
 5605,
 -62980,
 167366218,
 5602,
 -62979,
 167481743,
 5603,
 -62978,
 167534975,
 5606,
 -1,
 167581044,
 5607,
 167774733,
 166818648,
 -1,
 167840263,
 167729291,
 -1,
 167905795,
 167788679,
 5686,
 -1,
 167854215,
 5687,
 -62972,
 167890506,
 5684,
 -62971,
 168006031,
 5685,
 -62970,
 168059263,
 5688,
 -1,
 168105332,
 5689,
 168299017,
 167788679,
 5692,
 -1,
 168247431,
 5693,
 -62966,
 168283722,
 5690,
 -62965,
 168399247,
 5691,
 -62964,
 168452479,
 5694,
 -1,
 168498548,
 5695,
 168692244,
 167753503,
 -1,
 168757776,
 168640647,
 5725,
 -1,
 168706183,
 5726,
 -62959,
 168742474,
 5723,
 -62958,
 168857999,
 5724,
 -62957,
 168911231,
 5727,
 -1,
 168957300,
 5728,
 169213951,
 168646795,
 -1,
 169216535,
 169099399,
 5598,
 -1,
 169164935,
 5599,
 -62952,
 169201226,
 5596,
 -62951,
 169316751,
 5597,
 -62950,
 169369983,
 5600,
 -1,
 169416052,
 5601,
 169609776,
 166737440,
 -1,
 169675299,
 169600798,
 -1,
 169740831,
 169623687,
 5706,
 -1,
 169689223,
 5707,
 -62944,
 169725514,
 5704,
 -62943,
 169841039,
 5705,
 -62942,
 169894271,
 5708,
 -1,
 169940340,
 5709,
 170134058,
 169636696,
 -1,
 170199590,
 170082439,
 5674,
 -1,
 170147975,
 5675,
 -62937,
 170184266,
 5672,
 -62936,
 170299791,
 5673,
 -62935,
 170353023,
 5676,
 -1,
 170399092,
 5677,
 170592815,
 170082439,
 -1,
 170658350,
 170559711,
 -1,
 -62931,
 170640323,
 6389,
 -1,
 170672276,
 6382,
 -1,
 170606727,
 5203,
 -1,
 170549631,
 5204,
 170986050,
 169562851,
 -1,
 171051576,
 170940555,
 -1,
 171117108,
 170999943,
 5574,
 -1,
 171065479,
 5575,
 -62923,
 171101770,
 5572,
 -62922,
 171217295,
 5573,
 -62921,
 171270527,
 5576,
 -1,
 171316596,
 5577,
 171510331,
 171040008,
 -1,
 -62918,
 171494986,
 6381,
 -1,
 171513204,
 6384,
 171706941,
 171458695,
 5617,
 -1,
 171655303,
 5618,
 171838015,
 171644276,
 5620,
 -1,
 171775348,
 6383,
 -62912,
 171822666,
 5615,
 -62911,
 171938191,
 5616,
 -1,
 171991423,
 5619,
 172165712,
 170964767,
 -1,
 172231242,
 172120203,
 5722,
 172296774,
 172179591,
 5718,
 -1,
 172245127,
 5719,
 -62905,
 172281418,
 5716,
 -62904,
 172396943,
 5717,
 -62903,
 172450175,
 5720,
 -1,
 172496244,
 5721,
 172689996,
 172179591,
 5712,
 -1,
 172638343,
 5713,
 -62899,
 172674634,
 5710,
 -62898,
 172790159,
 5711,
 -62897,
 172843391,
 5714,
 -1,
 172889460,
 5715,
 173083231,
 172126344,
 -1,
 173148760,
 173043848,
 5633,
 173214292,
 173097095,
 5629,
 -1,
 173162631,
 5630,
 -62891,
 173198922,
 5627,
 -62890,
 173314447,
 5628,
 -62889,
 173367679,
 5631,
 -1,
 173413748,
 5632,
 173670399,
 173103243,
 -1,
 173673051,
 173555847,
 5623,
 -1,
 173621383,
 5624,
 -62884,
 173657674,
 5621,
 -62883,
 173773199,
 5622,
 -62882,
 173826431,
 5625,
 -1,
 173872500,
 5626,
 174066286,
 173043497,
 -1,
 174131815,
 174026537,
 -1,
 174197347,
 174080135,
 5662,
 -1,
 174145671,
 5663,
 -62876,
 174181962,
 5660,
 -62875,
 174297487,
 5661,
 -62874,
 174350719,
 5664,
 -1,
 174396788,
 5665,
 174590569,
 174080135,
 5655,
 -1,
 174538887,
 5656,
 -62870,
 174578992,
 6386,
 -62869,
 174706250,
 5652,
 -62868,
 174756239,
 5654,
 -62867,
 174809471,
 5657,
 -1,
 174855540,
 5659,
 175049340,
 174027608,
 -1,
 175114870,
 175003787,
 -1,
 175180402,
 175063175,
 5680,
 -1,
 175128711,
 5681,
 -62861,
 175165002,
 5678,
 -62860,
 175280527,
 5679,
 -62859,
 175333759,
 5682,
 -1,
 175379828,
 5683,
 175573624,
 175063175,
 5668,
 -1,
 175521927,
 5669,
 -62855,
 175558218,
 5666,
 -62854,
 175673743,
 5667,
 -62853,
 175726975,
 5670,
 -1,
 175773044,
 5671,
 175966854,
 175003787,
 5195,
 176032388,
 175955208,
 -1,
 176097920,
 175980679,
 5592,
 -1,
 176046215,
 5593,
 -62847,
 176082506,
 5590,
 -62846,
 176198031,
 5591,
 -62845,
 176251263,
 5594,
 -1,
 176297332,
 5595,
 -62843,
 175989119,
 5175,
 -1,
 176440103,
 5174,
 176622221,
 175957790,
 5702,
 176687753,
 176570503,
 5698,
 -1,
 176636039,
 5699,
 -62838,
 176672330,
 5696,
 -62837,
 176787855,
 5697,
 -62836,
 176841087,
 5700,
 -1,
 176887156,
 5701,
 177080980,
 176594921,
 5614,
 177146512,
 177029255,
 5610,
 -1,
 177094791,
 5611,
 -62831,
 177131082,
 5608,
 -62830,
 177246607,
 5609,
 -62829,
 177299839,
 5612,
 -1,
 177345908,
 5613,
 177539740,
 177047775,
 -1,
 177605271,
 177488007,
 5636,
 -1,
 177553543,
 5637,
 -62824,
 177589834,
 5634,
 -62823,
 177705359,
 5635,
 -62822,
 177758591,
 5638,
 -62821,
 177820387,
 5329,
 -1,
 177870196,
 5639,
 178064035,
 177529838,
 -1,
 178129567,
 178012295,
 5648,
 -1,
 178077831,
 5649,
 -62816,
 178114122,
 5646,
 -62815,
 178229647,
 5647,
 -62814,
 178282879,
 5650,
 -1,
 178328948,
 5651,
 178522794,
 178052360,
 -1,
 178588326,
 178471047,
 5586,
 -1,
 178536583,
 5587,
 -62809,
 178572874,
 5584,
 -62808,
 178688399,
 5585,
 -62807,
 178741631,
 5588,
 -1,
 178787700,
 5589,
 178981553,
 178497876,
 -1,
 179047085,
 178929799,
 5580,
 -1,
 178995335,
 5581,
 -62802,
 179031626,
 5578,
 -62801,
 179147151,
 5579,
 -62800,
 179200383,
 5582,
 -1,
 179246452,
 5583,
 179440312,
 178946021,
 -1,
 179505844,
 179388551,
 5642,
 -1,
 179454087,
 5643,
 -62795,
 179490378,
 5640,
 -62794,
 179605903,
 5641,
 -62793,
 179659135,
 5644,
 -1,
 179705204,
 5645,
 179899071,
 179384098,
 -1,
 179964603,
 179847303,
 5731,
 -1,
 179912839,
 5732,
 -62788,
 179949130,
 5729,
 -62787,
 180064655,
 5730,
 -62786,
 180117887,
 5733,
 -1,
 180163956,
 5734,
 180357825,
 179855743,
 5129,
 -1,
 180325677,
 5703,
 -1,
 180306727,
 5128,
 180617215,
 166663540,
 5265,
 -1,
 180511103,
 5258,
 180685516,
 166649096,
 -1,
 180751047,
 180654479,
 5272,
 -1,
 180720015,
 5274,
 180882121,
 180707711,
 5268,
 -1,
 180838783,
 5270,
 181013195,
 180819316,
 5276,
 -1,
 180950388,
 5278,
 -1,
 180961415,
 5266,
 181209806,
 180654479,
 5261,
 -1,
 181178767,
 5262,
 181340880,
 181166463,
 5259,
 -1,
 181297535,
 5260,
 -62767,
 181296274,
 5741,
 -1,
 181420167,
 5257,
 181603156,
 166583560,
 -1,
 181668670,
 181551239,
 5132,
 181796863,
 181649419,
 -1,
 181799741,
 181669680,
 -1,
 181865191,
 181778207,
 -1,
 181930719,
 181853448,
 -1,
 181996250,
 181899663,
 5373,
 -1,
 181965199,
 5375,
 182127324,
 181952895,
 5369,
 -1,
 182083967,
 5371,
 182258398,
 182064500,
 5377,
 -1,
 182195572,
 5379,
 -1,
 182206599,
 5367,
 182517759,
 181887306,
 -1,
 182520546,
 182423951,
 5406,
 -1,
 182489487,
 5408,
 182651620,
 182477183,
 5402,
 -1,
 182608255,
 5404,
 182782694,
 182588788,
 5410,
 -1,
 182719860,
 5412,
 -1,
 182730887,
 5400,
 182979317,
 181826392,
 5355,
 183044848,
 182967560,
 -1,
 183110379,
 183013775,
 5347,
 -1,
 183079311,
 5349,
 183241453,
 183067007,
 5343,
 -1,
 183198079,
 5345,
 183372527,
 183178612,
 5351,
 -1,
 183309684,
 5353,
 -1,
 183320711,
 5341,
 183569138,
 183013775,
 5450,
 -1,
 183538063,
 6369,
 183700212,
 183506292,
 5453,
 -1,
 183637364,
 6370,
 -1,
 183648391,
 5444,
 183896830,
 182969326,
 5440,
 184025087,
 183885064,
 -1,
 184027897,
 183931279,
 5430,
 -1,
 183996815,
 5432,
 184158971,
 183984511,
 5426,
 -1,
 184115583,
 5428,
 184290045,
 184096116,
 5434,
 -1,
 184227188,
 5436,
 -1,
 184238215,
 5424,
 184486664,
 183878356,
 -1,
 184552199,
 184474888,
 -1,
 184617730,
 184521103,
 5214,
 -1,
 184586639,
 5216,
 184748804,
 184574335,
 5210,
 -1,
 184705407,
 5212,
 184879878,
 184685940,
 5218,
 -1,
 184817012,
 5220,
 -1,
 184828039,
 5208,
 -1,
 184508753,
 5481,
 185142033,
 184459241,
 5194,
 185270271,
 185130248,
 -1,
 185273100,
 185176463,
 5185,
 -1,
 185241999,
 5187,
 185404174,
 185229695,
 5181,
 -1,
 185360767,
 5183,
 185535248,
 185341300,
 5189,
 -1,
 185472372,
 5191,
 -1,
 185483399,
 5179,
 185731866,
 185106405,
 5308,
 185860095,
 185720072,
 -1,
 185862933,
 185766287,
 5299,
 -1,
 185831823,
 5301,
 185994007,
 185819519,
 5295,
 -1,
 185950591,
 5297,
 186125081,
 185931124,
 5303,
 -1,
 186062196,
 5305,
 -1,
 186073223,
 5293,
 186321698,
 185720072,
 -1,
 186387229,
 186290575,
 5139,
 -1,
 186356111,
 5141,
 186518303,
 186343807,
 5135,
 -1,
 186474879,
 5137,
 186649377,
 186455412,
 5144,
 -1,
 186586484,
 5146,
 -1,
 186597511,
 5133,
 186845994,
 186282818,
 -1,
 186911525,
 186814863,
 5243,
 -1,
 186880399,
 5245,
 187042599,
 186868095,
 5239,
 -1,
 186999167,
 5241,
 187173673,
 186979700,
 5247,
 -1,
 187110772,
 5249,
 -1,
 187121799,
 5237,
 187370290,
 186791431,
 -1,
 187435821,
 187339151,
 5273,
 -1,
 187404687,
 5275,
 187566895,
 187392383,
 5269,
 -1,
 187523455,
 5271,
 187697969,
 187503988,
 5277,
 -1,
 187635060,
 5279,
 -1,
 187646087,
 5267,
 187894584,
 187345236,
 5457,
 -62668,
 187882803,
 5455,
 -62667,
 187928975,
 5516,
 -62666,
 187982207,
 5515,
 -62665,
 188039303,
 5514,
 -1,
 188093812,
 5517,
 188287804,
 187863334,
 -1,
 188353339,
 188224884,
 5324,
 -1,
 188290420,
 5326,
 -1,
 188301447,
 5322,
 -1,
 188240606,
 5468,
 -1,
 181750259,
 6365,
 188681039,
 181637519,
 5138,
 188809215,
 188649871,
 5140,
 188874751,
 188694560,
 -1,
 188877646,
 188794383,
 5535,
 188943178,
 188865800,
 -1,
 189008709,
 188912015,
 5754,
 -1,
 188977551,
 5755,
 189139783,
 188965247,
 5752,
 -1,
 189096319,
 5753,
 189270857,
 189076852,
 5756,
 -1,
 189207924,
 5757,
 -1,
 189219623,
 5751,
 -62645,
 188912015,
 5533,
 -62644,
 189423999,
 5532,
 -62643,
 189481095,
 5531,
 -1,
 189535604,
 5534,
 -1,
 188829824,
 5758,
 189795154,
 188618100,
 5143,
 -62639,
 189785070,
 6323,
 -1,
 189797748,
 5145,
 190054399,
 189751679,
 5134,
 -1,
 189948287,
 5136,
 190122904,
 181569759,
 5328,
 190188395,
 190059892,
 5319,
 190253928,
 190168403,
 -1,
 190319455,
 190232351,
 -1,
 190384986,
 190280514,
 5386,
 -1,
 190322036,
 5390,
 -62629,
 190373171,
 5380,
 -62628,
 190500179,
 5389,
 -62627,
 190555965,
 5388,
 -62626,
 190592522,
 5391,
 -1,
 190648716,
 5387,
 190843746,
 190307592,
 -1,
 -62623,
 190813828,
 5142,
 -1,
 190846455,
 5147,
 -62621,
 190834432,
 5437,
 -62620,
 191024471,
 5221,
 -62619,
 191074601,
 5327,
 -62618,
 191137971,
 5306,
 -62617,
 191198021,
 5250,
 -1,
 191247886,
 5280,
 191433578,
 190190964,
 5320,
 -1,
 191390079,
 5313,
 -1,
 191423470,
 6332,
 191630197,
 190173703,
 -1,
 191695732,
 191587754,
 5499,
 191761263,
 191664527,
 5495,
 -1,
 191730063,
 5496,
 191892337,
 191717759,
 5493,
 -1,
 191848831,
 5494,
 192023411,
 191829364,
 5497,
 -1,
 191960436,
 5498,
 -1,
 191971463,
 5492,
 -1,
 191682316,
 5500,
 192285566,
 191582947,
 5525,
 192351098,
 192222580,
 5523,
 192416633,
 192288116,
 5524,
 -1,
 192373119,
 5518,
 -1,
 192373119,
 5744,
 192613244,
 192319887,
 5521,
 -1,
 192582031,
 5522,
 192806911,
 192569727,
 5519,
 -1,
 192700799,
 5520,
 192875398,
 192273672,
 -1,
 192940929,
 192844175,
 6346,
 -1,
 192909711,
 6348,
 193072003,
 192897407,
 6342,
 -1,
 193028479,
 6344,
 193203077,
 193009012,
 5323,
 -1,
 193140084,
 5325,
 -1,
 193151111,
 5321,
 193399693,
 192842679,
 5526,
 193465225,
 193368463,
 5747,
 -1,
 193433999,
 5748,
 193596299,
 193421695,
 5745,
 -1,
 193552767,
 5746,
 193789951,
 193533300,
 5749,
 -1,
 193664372,
 5750,
 193858448,
 193368463,
 5316,
 -62577,
 193848302,
 6331,
 -1,
 193892751,
 5317,
 194055060,
 193793855,
 -1,
 194120595,
 194011519,
 5473,
 -1,
 194077055,
 5475,
 -1,
 194068615,
 5471,
 194317206,
 194011519,
 5314,
 -1,
 194273663,
 5315,
 -62569,
 194271371,
 5330,
 -1,
 194396295,
 5312,
 194579415,
 190104276,
 5222,
 194644909,
 194533515,
 5482,
 194710434,
 194580287,
 5550,
 194775965,
 194679183,
 5546,
 -1,
 194744719,
 5547,
 194907039,
 194732415,
 5544,
 -1,
 194863487,
 5545,
 195038113,
 194844020,
 5548,
 -1,
 194975092,
 5549,
 -1,
 194986119,
 5543,
 195234726,
 194698504,
 -1,
 195300261,
 195171700,
 6372,
 -1,
 195237236,
 5480,
 -1,
 195248263,
 6371,
 195496872,
 195203471,
 5476,
 -1,
 195465615,
 5477,
 195627946,
 195453311,
 5472,
 -1,
 195584383,
 5474,
 195759020,
 195564916,
 5478,
 -1,
 195695988,
 5479,
 -1,
 195707015,
 5470,
 195955642,
 194626260,
 -1,
 196021174,
 195909771,
 5487,
 196086705,
 195989903,
 5485,
 -1,
 196055439,
 6374,
 196217779,
 196023668,
 5486,
 -1,
 196154740,
 6375,
 -62540,
 196206162,
 6373,
 -62539,
 196305279,
 5484,
 -1,
 196362375,
 5483,
 -62537,
 195989903,
 5225,
 -62536,
 196501887,
 5224,
 -62535,
 196558983,
 5223,
 -1,
 196613492,
 5226,
 196807618,
 195943688,
 -1,
 196873149,
 196776335,
 5213,
 -1,
 196841871,
 5215,
 197004223,
 196829567,
 5209,
 -1,
 196960639,
 5211,
 197135297,
 196941172,
 5217,
 -1,
 197072244,
 5219,
 -1,
 197083271,
 5207,
 197331913,
 196770398,
 -1,
 197397445,
 197300623,
 5512,
 -1,
 197366159,
 6377,
 -62522,
 197385810,
 6376,
 -62521,
 197484927,
 5511,
 -62520,
 197542023,
 5510,
 -1,
 197596532,
 5513,
 197790670,
 197321710,
 -1,
 -62517,
 197759375,
 5490,
 -62516,
 197812607,
 5489,
 -62515,
 197869703,
 5488,
 -1,
 197924212,
 5491,
 198118354,
 197727604,
 5205,
 198183889,
 198055284,
 5206,
 -1,
 198140287,
 5197,
 -1,
 198173678,
 6327,
 198380500,
 198087055,
 5200,
 -1,
 198349199,
 5201,
 198511574,
 198336895,
 5198,
 -1,
 198467967,
 5199,
 -1,
 198459527,
 5196,
 198708247,
 194557727,
 5381,
 198773745,
 198645108,
 5364,
 198839279,
 198763502,
 6335,
 198967295,
 198798614,
 -1,
 198970338,
 198883859,
 -1,
 199035870,
 198939023,
 5529,
 -1,
 199004559,
 6379,
 -62497,
 199024210,
 6378,
 -62496,
 199123327,
 5528,
 -62495,
 199180423,
 5527,
 -1,
 199234932,
 5530,
 199429096,
 198924427,
 -1,
 199494629,
 199397775,
 5570,
 -1,
 199463311,
 6380,
 -62490,
 199451007,
 5569,
 -62489,
 199573639,
 5568,
 -1,
 199628148,
 5571,
 199822316,
 199388969,
 -1,
 199887851,
 199806538,
 5653,
 -1,
 199872074,
 6385,
 -1,
 199844223,
 5658,
 -62483,
 199812464,
 5441,
 -62482,
 200066575,
 5282,
 -1,
 200114149,
 5311,
 200343551,
 198776180,
 5365,
 -1,
 200237439,
 5358,
 200412164,
 198727819,
 5413,
 200477691,
 200400136,
 -1,
 200543222,
 200446351,
 5405,
 -62475,
 200532974,
 6338,
 -1,
 200577423,
 5407,
 200739832,
 200499583,
 5401,
 -1,
 200696191,
 5403,
 200870906,
 200676724,
 5409,
 -1,
 200807796,
 5411,
 -1,
 200818823,
 5399,
 201067518,
 200446351,
 5395,
 -62467,
 201057262,
 6336,
 -1,
 201101711,
 5396,
 201264129,
 201004404,
 5397,
 -62464,
 201253870,
 6337,
 -1,
 201266548,
 5398,
 201460739,
 201220479,
 5393,
 -1,
 201417087,
 5394,
 -1,
 201408647,
 5392,
 201657356,
 200400136,
 5383,
 201722887,
 201625999,
 5372,
 -1,
 201691535,
 5374,
 201853961,
 201679231,
 5368,
 -1,
 201810303,
 5370,
 201985035,
 201790836,
 5376,
 -1,
 201921908,
 5378,
 -1,
 201932935,
 5366,
 202181652,
 201625999,
 5361,
 202247186,
 202168137,
 -1,
 -62449,
 202216291,
 5255,
 -62448,
 202270094,
 5254,
 -62447,
 202327249,
 5253,
 -1,
 202381559,
 5256,
 -62445,
 202236910,
 6334,
 -1,
 202543503,
 5362,
 202705942,
 202137983,
 5359,
 -1,
 202662271,
 5360,
 -1,
 202653831,
 5357,
 202902584,
 198697966,
 5438,
 202968102,
 202837808,
 -1,
 203033628,
 202940393,
 -1,
 -62437,
 203021619,
 5192,
 -1,
 203069060,
 5173,
 -62435,
 203023940,
 5420,
 -62434,
 203218184,
 5149,
 -62433,
 203278843,
 5202,
 -62432,
 203341506,
 5363,
 -62431,
 203396740,
 5127,
 -62430,
 203460021,
 5318,
 -62429,
 203523861,
 5289,
 -62428,
 203586954,
 5337,
 -62427,
 203649704,
 5233,
 -1,
 203699008,
 5263,
 203885614,
 202956040,
 -1,
 203951145,
 203854223,
 5429,
 -1,
 203919759,
 5431,
 204082219,
 203907455,
 5425,
 -1,
 204038527,
 5427,
 204213293,
 204019060,
 5433,
 -1,
 204150132,
 5435,
 -1,
 204161159,
 5423,
 204409906,
 203822452,
 5421,
 204475441,
 204346740,
 5422,
 -1,
 204431743,
 5415,
 -1,
 204465134,
 6340,
 204672053,
 204378511,
 5418,
 -62412,
 204661742,
 6339,
 -1,
 204706191,
 5419,
 204868663,
 204628351,
 5416,
 -1,
 204824959,
 5417,
 -1,
 204816519,
 5414,
 205065303,
 202853974,
 5469,
 205130831,
 205021567,
 5461,
 205196366,
 205097339,
 -1,
 205261888,
 205171028,
 -1,
 205327423,
 205218175,
 -1,
 -62402,
 205294519,
 5156,
 -1,
 205346032,
 5155,
 -1,
 205265285,
 6367,
 205589573,
 205208260,
 -1,
 205655108,
 205573929,
 -1,
 -62397,
 205634486,
 5158,
 -1,
 205658017,
 5157,
 -1,
 205644153,
 5162,
 205917256,
 205567775,
 -1,
 -62393,
 205881791,
 6366,
 -1,
 205938633,
 5160,
 -62391,
 205900322,
 5154,
 -62390,
 206087244,
 5161,
 -62389,
 206144736,
 5159,
 -62388,
 206198469,
 5152,
 -62387,
 206252800,
 5153,
 -1,
 206313377,
 5151,
 -1,
 205152639,
 5462,
 206572626,
 205067636,
 5465,
 206700543,
 206509428,
 5466,
 -1,
 206594431,
 5460,
 206769236,
 206541199,
 5463,
 -1,
 206737807,
 5464,
 -62379,
 206757171,
 5467,
 -62378,
 206885146,
 5742,
 -1,
 206913671,
 5459,
 207096944,
 205026136,
 5354,
 207162464,
 207084808,
 -1,
 207227995,
 207131023,
 5346,
 -1,
 207196559,
 5348,
 207359069,
 207184255,
 5342,
 -1,
 207315327,
 5344,
 207490143,
 207295860,
 5350,
 -1,
 207426932,
 5352,
 -1,
 207437959,
 5340,
 207686759,
 207116427,
 5542,
 207752291,
 207655311,
 5538,
 -1,
 207720847,
 5539,
 207883365,
 207708543,
 5536,
 -1,
 207839615,
 5537,
 208076799,
 207820148,
 5540,
 -1,
 207951220,
 5541,
 208145515,
 207623540,
 5338,
 208211050,
 208082292,
 5339,
 -1,
 208167295,
 5332,
 -1,
 208200686,
 6333,
 208407661,
 208114063,
 5335,
 -1,
 208376207,
 5336,
 208538735,
 208363903,
 5333,
 -1,
 208494975,
 5334,
 -1,
 208486535,
 5331,
 208735367,
 207060965,
 5307,
 208800889,
 208723208,
 -1,
 208866420,
 208769423,
 5298,
 -1,
 208834959,
 5300,
 208997494,
 208822655,
 5294,
 -1,
 208953727,
 5296,
 209128568,
 208934260,
 5302,
 -1,
 209065332,
 5304,
 -1,
 209076359,
 5292,
 209325181,
 208737652,
 5290,
 209390716,
 209261940,
 5291,
 -1,
 209346943,
 5284,
 -1,
 209380334,
 6330,
 209587328,
 209293711,
 5287,
 209715199,
 209555855,
 5288,
 -1,
 209631391,
 5385,
 209783940,
 209535111,
 5283,
 209911807,
 209729815,
 -1,
 -62333,
 209824084,
 5458,
 -1,
 209875800,
 5356,
 210046086,
 209740159,
 5285,
 -1,
 210002303,
 5286,
 -1,
 210000011,
 5309,
 210242721,
 208676470,
 -1,
 210308253,
 210203701,
 -1,
 210373774,
 210296072,
 5759,
 -62325,
 210342287,
 5558,
 -62324,
 210395519,
 5557,
 -62323,
 210452615,
 5556,
 -1,
 210507124,
 5559,
 210701459,
 210340063,
 -1,
 -62320,
 210669967,
 5562,
 -62319,
 210723199,
 5561,
 -62318,
 210780295,
 5560,
 -1,
 210834804,
 5563,
 211029144,
 210661512,
 -1,
 -62315,
 210997647,
 5566,
 -62314,
 211050879,
 5565,
 -62313,
 211107975,
 5564,
 -1,
 211162484,
 5567,
 -62311,
 211007263,
 5384,
 -62310,
 211325327,
 5554,
 -62309,
 211378559,
 5553,
 -62308,
 211435655,
 5552,
 -1,
 211490164,
 5555,
 211684512,
 210256328,
 -1,
 -62305,
 211659092,
 6388,
 -1,
 211710808,
 6387,
 -1,
 211641057,
 5439,
 211946678,
 210217300,
 5456,
 212012202,
 211934472,
 -1,
 212077733,
 211980687,
 6353,
 -1,
 212046223,
 6354,
 212208807,
 212033919,
 6351,
 -1,
 212164991,
 6352,
 212339881,
 212145524,
 6355,
 -1,
 212276596,
 5454,
 -1,
 212288295,
 6350,
 212536494,
 211948916,
 5451,
 212602029,
 212473204,
 5452,
 -1,
 212558207,
 5445,
 -1,
 212591598,
 6341,
 212798640,
 212504975,
 5448,
 -1,
 212767119,
 5449,
 212929714,
 212754815,
 5446,
 -1,
 212885887,
 5447,
 213060789,
 212864823,
 -1,
 -62284,
 213048914,
 6368,
 -1,
 213074055,
 5443,
 -1,
 213008519,
 5442,
 213322954,
 211918825,
 5193,
 213388480,
 213310728,
 -1,
 213454011,
 213356943,
 5184,
 -62278,
 213443566,
 6326,
 -1,
 213488015,
 5186,
 213650621,
 213410175,
 5180,
 -1,
 213606783,
 5182,
 213781695,
 213587316,
 5188,
 -1,
 213718388,
 5190,
 -1,
 213729415,
 5178,
 213978308,
 213325172,
 5176,
 214043843,
 213914996,
 5177,
 -1,
 213999999,
 5168,
 -1,
 214033390,
 6325,
 214240455,
 213946767,
 5171,
 -62266,
 214229998,
 6324,
 -1,
 214274447,
 5172,
 214437065,
 214196607,
 5169,
 -1,
 214393215,
 5170,
 -1,
 214384775,
 5167,
 214633693,
 213282952,
 5251,
 214699220,
 214621448,
 5252,
 214764751,
 214635892,
 5246,
 -62258,
 214754286,
 6329,
 -1,
 214766964,
 5248,
 214961361,
 214733199,
 5242,
 -1,
 214929807,
 5244,
 215092435,
 214917503,
 5238,
 -1,
 215048575,
 5240,
 -1,
 215040135,
 5236,
 215289048,
 214635892,
 5234,
 215354583,
 215225716,
 5235,
 -1,
 215310719,
 5228,
 -1,
 215344110,
 6328,
 215551194,
 215257487,
 5231,
 -1,
 215519631,
 5232,
 215682268,
 215507327,
 5229,
 -1,
 215638399,
 5230,
 -1,
 215629959,
 5227,
 215878895,
 214602127,
 5125,
 215944428,
 215838718,
 -1,
 216009957,
 215910623,
 6361,
 216137727,
 215997704,
 -1,
 216141027,
 216043919,
 6347,
 -1,
 216109455,
 6349,
 216334335,
 216097151,
 6343,
 -1,
 216228223,
 6345,
 216403175,
 215987999,
 6362,
 -1,
 216357003,
 6363,
 -62232,
 216384212,
 6357,
 -62231,
 216506345,
 6356,
 -62230,
 216563685,
 6360,
 -62229,
 216625288,
 6358,
 -1,
 216673502,
 6359,
 -62227,
 215933934,
 6320,
 -62226,
 216830351,
 5126,
 -1,
 216893663,
 5165,
 217058554,
 215815540,
 5130,
 217124083,
 216995188,
 5131,
 -62222,
 217113582,
 6322,
 -1,
 217145727,
 5122,
 217320694,
 217106039,
 -1,
 -62219,
 217298719,
 5382,
 -1,
 217350117,
 5310,
 217517304,
 217276799,
 5148,
 -1,
 217504666,
 5551,
 -62215,
 217506798,
 6321,
 -1,
 217614559,
 5166,
 217779459,
 217032516,
 5509,
 217844991,
 217716084,
 5507,
 217910526,
 217781620,
 5508,
 -1,
 217866623,
 5502,
 -1,
 217866623,
 5743,
 218107137,
 217813391,
 5505,
 -1,
 218075535,
 5506,
 218300415,
 218063231,
 5503,
 -1,
 218194303,
 5504,
 218369286,
 217735551,
 5123,
 -62203,
 218335455,
 5164,
 -1,
 218390911,
 5124,
 218565897,
 218316935,
 5121,
 -62200,
 218532063,
 5163,
 -1,
 218571836,
 6364,
 218762508,
 218519691,
 -1,
 -62197,
 218752616,
 5120,
 -1,
 218787976,
 5501,
 -1,
 218715626,
 5150,
 219086847,
 166473352,
 -1,
 -62193,
 218999124,
 9803,
 -1,
 219050874,
 917631,
 219221322,
 166439252,
 -1,
 219286852,
 219177570,
 -1,
 219352344,
 219270730,
 66226,
 219480063,
 219336266,
 66239,
 219545599,
 219401802,
 66212,
 -62186,
 219467338,
 66235,
 -62185,
 219485004,
 66256,
 -1,
 219550375,
 66248,
 219745566,
 219330335,
 66224,
 219811099,
 219726548,
 66242,
 -1,
 219746983,
 66243,
 219942173,
 219764875,
 66222,
 -1,
 219878055,
 66223,
 -1,
 219920159,
 66232,
 220138787,
 219709413,
 66218,
 220266495,
 220079734,
 66250,
 -62175,
 220140476,
 66253,
 -62174,
 220205900,
 66252,
 -1,
 220271271,
 66251,
 220466471,
 220104927,
 66229,
 -62171,
 220432607,
 66227,
 -62170,
 220484323,
 66244,
 -1,
 220542496,
 66238,
 220728618,
 220447444,
 66221,
 220856319,
 220709588,
 66247,
 -1,
 220730023,
 66230,
 220925229,
 220689240,
 66211,
 221052927,
 220870176,
 66214,
 -1,
 220926631,
 66254,
 221121839,
 220899668,
 66213,
 -1,
 221096276,
 66249,
 221252913,
 221093865,
 66231,
 -1,
 221188775,
 66209,
 221383987,
 221212808,
 66236,
 -1,
 221319847,
 66237,
 221515061,
 221340031,
 66233,
 -1,
 221471103,
 66245,
 221646135,
 221467363,
 66240,
 -1,
 221581991,
 66241,
 221777209,
 221593735,
 66234,
 -1,
 221713063,
 66255,
 221908283,
 221722144,
 66210,
 -1,
 221844135,
 66220,
 222039358,
 221850933,
 -1,
 -62147,
 221975481,
 66246,
 -1,
 222040730,
 66225,
 222235968,
 221975924,
 66208,
 -1,
 222171815,
 66215,
 -62143,
 222225156,
 66228,
 -62142,
 222340932,
 66216,
 -62141,
 222400911,
 66219,
 -1,
 222439030,
 66217,
 222629192,
 219234439,
 -1,
 222694727,
 222610132,
 8248,
 -1,
 222627002,
 8257,
 -1,
 222627382,
 8453,
 -62135,
 222598445,
 711,
 -1,
 222825037,
 9936,
 223022413,
 219166240,
 -1,
 -62132,
 223006708,
 9764,
 -1,
 223024584,
 8454,
 -62130,
 223008604,
 9761,
 -62129,
 223199409,
 9963,
 -1,
 223258206,
 9809,
 223416263,
 166367631,
 -1,
 223481555,
 223379429,
 -1,
 223547082,
 223422858,
 -1,
 223612320,
 223489246,
 -1,
 223677840,
 223602368,
 -1,
 223743359,
 223640026,
 -1,
 223808861,
 223690887,
 -1,
 223874393,
 223786783,
 11757,
 -1,
 223809912,
 11765,
 -62118,
 223848788,
 11756,
 -62117,
 223971551,
 11753,
 -62116,
 224034789,
 11752,
 -1,
 224097112,
 11751,
 224267618,
 223764863,
 -1,
 224333153,
 224238294,
 -1,
 -62112,
 224274776,
 11775,
 -1,
 224335220,
 11772,
 -1,
 224280711,
 11767,
 224595301,
 224257822,
 -1,
 -62108,
 224549672,
 11748,
 -1,
 224608391,
 11749,
 224791912,
 224584686,
 -1,
 -62105,
 224775754,
 11771,
 -1,
 224797804,
 11770,
 224988523,
 224772820,
 -1,
 -62102,
 224966808,
 11760,
 -1,
 225001607,
 11758,
 225185134,
 224967187,
 -1,
 -62099,
 225128233,
 11763,
 -1,
 225187188,
 11762,
 225381745,
 225130016,
 -1,
 -62096,
 225341405,
 11768,
 -1,
 225394823,
 11747,
 225578356,
 225322614,
 -1,
 -62093,
 225535117,
 11774,
 -1,
 225591431,
 11744,
 -62091,
 225564916,
 11745,
 -62090,
 225747373,
 11755,
 -62089,
 225808783,
 11754,
 -62088,
 225871602,
 11769,
 -62087,
 225934296,
 11773,
 -62086,
 225996959,
 11750,
 -62085,
 226056361,
 11759,
 -62084,
 226120917,
 11746,
 -62083,
 226185391,
 11764,
 -62082,
 226242412,
 11761,
 -1,
 226301300,
 11766,
 226495877,
 223715305,
 -1,
 226561411,
 226432372,
 -1,
 -62078,
 226551132,
 42621,
 -1,
 226588066,
 1156,
 -62076,
 226540671,
 1158,
 -1,
 226726922,
 1159,
 226889097,
 226476756,
 -1,
 -62073,
 226848300,
 1155,
 -62072,
 226910231,
 42610,
 -1,
 226969359,
 42608,
 227151244,
 226844959,
 -1,
 -62069,
 227133232,
 1160,
 -1,
 227181904,
 42609,
 -62067,
 227138818,
 42607,
 -62066,
 227312976,
 1161,
 -62065,
 227373451,
 42620,
 -1,
 227424031,
 1157,
 227610006,
 223646095,
 -1,
 227675541,
 227575291,
 -1,
 227741076,
 227612277,
 787,
 -1,
 227674595,
 789,
 -1,
 227682387,
 806,
 -1,
 227642716,
 65062,
 228003226,
 227546484,
 -1,
 228068761,
 227980346,
 780,
 -1,
 228000291,
 812,
 -1,
 228035321,
 784,
 228265373,
 227966179,
 -1,
 -62052,
 228241883,
 8409,
 -1,
 228270703,
 8405,
 228461983,
 228224083,
 770,
 -1,
 228393507,
 813,
 -1,
 228410131,
 807,
 228658667,
 223572824,
 -1,
 228724167,
 228599067,
 -1,
 228789697,
 228703754,
 -1,
 228855207,
 228726132,
 867,
 -62043,
 228841390,
 7638,
 -62042,
 228888975,
 7637,
 -1,
 228933767,
 7636,
 229117355,
 228829524,
 876,
 229244927,
 229048320,
 -1,
 -62038,
 229160162,
 7651,
 -1,
 229189715,
 7626,
 229379501,
 229077848,
 7645,
 -1,
 229348923,
 7653,
 229510575,
 229335423,
 869,
 -1,
 229478132,
 7640,
 229641649,
 229458055,
 868,
 -1,
 229623311,
 7641,
 229772723,
 229584094,
 872,
 -1,
 229704316,
 7639,
 -62028,
 229762846,
 7654,
 -62027,
 229892868,
 879,
 -62026,
 229955502,
 878,
 -62025,
 230018634,
 871,
 -62024,
 230081236,
 877,
 -62023,
 230143775,
 7652,
 -62022,
 230199695,
 870,
 -62021,
 230263007,
 7648,
 -62020,
 230326245,
 875,
 -62019,
 230387848,
 7644,
 -62018,
 230447243,
 874,
 -62017,
 230511331,
 7642,
 -62016,
 230576406,
 7635,
 -1,
 230635040,
 873,
 230883327,
 228751858,
 -1,
 -62013,
 230795604,
 7650,
 -62012,
 230852831,
 7649,
 -62011,
 230916069,
 7647,
 -62010,
 230978392,
 7646,
 -1,
 231035619,
 7643,
 231214560,
 228672410,
 -1,
 231280093,
 231145472,
 -1,
 231345620,
 231216500,
 -1,
 231411153,
 231323058,
 -1,
 231476686,
 231365435,
 -1,
 -62003,
 231417939,
 852,
 -1,
 231478901,
 7678,
 231735295,
 231407616,
 -1,
 -62000,
 231614547,
 8430,
 -1,
 231675509,
 8406,
 231931903,
 231377924,
 -1,
 -61997,
 231811155,
 841,
 -1,
 231872117,
 794,
 232066521,
 231299241,
 -1,
 232132056,
 232028733,
 -1,
 -61993,
 232073299,
 796,
 -1,
 232134261,
 849,
 -1,
 232109382,
 8400,
 232394204,
 232042154,
 -1,
 -61989,
 232335443,
 845,
 -1,
 232396405,
 8417,
 -1,
 232375140,
 792,
 232718335,
 231267674,
 -1,
 -61985,
 232610518,
 8429,
 -1,
 232661627,
 8426,
 232852968,
 231182735,
 -1,
 232918503,
 232819642,
 -1,
 232984037,
 232896287,
 -1,
 -61980,
 232967145,
 822,
 -1,
 233018490,
 824,
 -61978,
 232971009,
 8402,
 -1,
 233127295,
 8427,
 -1,
 232905997,
 818,
 233439231,
 232809631,
 -1,
 -61974,
 233352985,
 65057,
 -1,
 233404149,
 65056,
 233573927,
 228603424,
 -1,
 233639437,
 233542031,
 -1,
 233704964,
 233623337,
 -1,
 233770483,
 233691704,
 -1,
 233836018,
 233732850,
 -1,
 -61967,
 233777235,
 840,
 -1,
 233838197,
 782,
 -1,
 233816377,
 8422,
 234098167,
 233752572,
 864,
 234225663,
 234029056,
 -1,
 -61962,
 234139417,
 65059,
 -1,
 234190581,
 65058,
 234360314,
 234073593,
 -1,
 -61959,
 234326974,
 858,
 -1,
 234378570,
 866,
 234556924,
 234324027,
 862,
 -1,
 234488355,
 863,
 234687998,
 234499017,
 861,
 -1,
 234619427,
 860,
 -61953,
 234659547,
 831,
 -61952,
 234782248,
 819,
 -61951,
 234842848,
 865,
 -61950,
 234903243,
 783,
 -61949,
 234959040,
 7629,
 -1,
 235018151,
 779,
 235212300,
 233685716,
 -1,
 235277833,
 235143168,
 -1,
 235343368,
 235214453,
 775,
 -1,
 235276771,
 856,
 -1,
 235284563,
 803,
 235601919,
 235259086,
 -1,
 -61941,
 235493067,
 7616,
 -1,
 235542439,
 7617,
 -1,
 235200897,
 798,
 235802149,
 233589875,
 -1,
 235867676,
 235747736,
 -1,
 235933202,
 235848404,
 -1,
 -61935,
 235921807,
 43234,
 -1,
 235954262,
 43235,
 236129813,
 235910943,
 -1,
 -61932,
 236089070,
 43238,
 -1,
 236145794,
 43239,
 236326424,
 236080726,
 -1,
 -61929,
 236297200,
 43236,
 -1,
 236351095,
 43237,
 -61927,
 236316565,
 43232,
 -61926,
 236492223,
 43233,
 -61925,
 236555452,
 43241,
 -1,
 236602679,
 43240,
 236785188,
 235829722,
 -1,
 -61922,
 236772197,
 43248,
 -61921,
 236834378,
 43243,
 -61920,
 236890543,
 43247,
 -61919,
 236953678,
 43246,
 -61918,
 237013307,
 43245,
 -61917,
 237072543,
 43244,
 -1,
 237114740,
 43242,
 -1,
 236764214,
 43249,
 237436927,
 235758089,
 776,
 -1,
 237306403,
 804,
 237506118,
 233548116,
 -1,
 237571649,
 237461887,
 -1,
 237637181,
 237524190,
 -1,
 237702716,
 237568000,
 -1,
 237768246,
 237642338,
 -1,
 237833779,
 237722427,
 -1,
 237899314,
 237770100,
 -1,
 237964849,
 237865568,
 -1,
 -61904,
 237949755,
 854,
 -1,
 237977187,
 7679,
 -1,
 237906761,
 848,
 -1,
 237840467,
 853,
 238354431,
 237764608,
 -1,
 -61899,
 238233683,
 8431,
 -1,
 238294645,
 8407,
 238489147,
 237721769,
 -1,
 238554682,
 238451261,
 -1,
 -61895,
 238495827,
 825,
 -1,
 238556789,
 855,
 -1,
 238531910,
 8401,
 -1,
 238469988,
 793,
 -1,
 237690252,
 8428,
 239009791,
 237603770,
 -1,
 -61889,
 238919379,
 8408,
 -61888,
 238954579,
 805,
 -1,
 239015541,
 778,
 239271935,
 237518983,
 -1,
 239275589,
 239196671,
 -1,
 -61884,
 239220261,
 788,
 -1,
 239274597,
 8421,
 -1,
 239258561,
 802,
 239537755,
 237459053,
 -1,
 239603281,
 239485747,
 -1,
 239668813,
 239569030,
 -1,
 239734348,
 239649492,
 -1,
 -61877,
 239710881,
 119362,
 -1,
 239750138,
 119363,
 -1,
 239706692,
 119364,
 -61874,
 239658606,
 837,
 -61873,
 239968973,
 834,
 -61872,
 240022221,
 835,
 -1,
 240072989,
 836,
 240320511,
 239539572,
 -1,
 240324186,
 240244980,
 -1,
 240389719,
 240254976,
 -1,
 240455254,
 240326447,
 768,
 -1,
 240386595,
 790,
 -1,
 240437711,
 832,
 240713727,
 240324307,
 -1,
 -61863,
 240615483,
 7621,
 -1,
 240654282,
 7624,
 -1,
 240296786,
 847,
 240914031,
 239474036,
 -1,
 240979556,
 240858614,
 -1,
 241045089,
 240910336,
 -1,
 241110624,
 240981807,
 769,
 -1,
 241041955,
 791,
 -1,
 241093071,
 833,
 241369087,
 240979667,
 -1,
 -61853,
 241270843,
 7623,
 -1,
 241325784,
 7625,
 241503849,
 240945375,
 -1,
 241569384,
 241485778,
 -1,
 -61849,
 241545691,
 8410,
 -1,
 241574511,
 8404,
 -1,
 241537064,
 8423,
 241831532,
 241483899,
 -1,
 -61845,
 241772627,
 857,
 -1,
 241833589,
 8432,
 242089983,
 241794228,
 -1,
 -61842,
 241969235,
 7677,
 -1,
 242030197,
 844,
 242224762,
 240877541,
 -1,
 242290297,
 242161551,
 772,
 242355829,
 242224851,
 -1,
 -61837,
 242308805,
 7622,
 -61836,
 242363337,
 7628,
 -1,
 242423713,
 7620,
 242679807,
 242286592,
 -1,
 -61833,
 242593561,
 65061,
 -61832,
 242644725,
 65060,
 -1,
 242690131,
 817,
 -1,
 242248360,
 800,
 242945669,
 242172039,
 -1,
 243011204,
 242911821,
 -1,
 243076735,
 242988831,
 -1,
 -61826,
 243050527,
 8414,
 -1,
 243086281,
 8418,
 243273345,
 243019842,
 8413,
 -1,
 243204613,
 8416,
 -61822,
 243258640,
 8420,
 -61821,
 243364338,
 8419,
 -1,
 243415341,
 8415,
 -1,
 242984974,
 839,
 243666575,
 242923295,
 -1,
 243732107,
 243621820,
 -1,
 243797642,
 243709727,
 -1,
 -61815,
 243780585,
 821,
 -1,
 243831930,
 823,
 -1,
 243784449,
 8403,
 -61812,
 243717823,
 7619,
 -61811,
 244033580,
 827,
 -61810,
 244091248,
 7618,
 -1,
 244138268,
 828,
 244321943,
 243647188,
 -1,
 244387476,
 244278783,
 771,
 244514815,
 244318208,
 -1,
 -61805,
 244424403,
 820,
 -1,
 244459603,
 816,
 -61803,
 244373015,
 786,
 -61802,
 244626026,
 8424,
 -1,
 244670605,
 8411,
 244846239,
 244277631,
 -1,
 244911774,
 244814073,
 -1,
 244977309,
 244853599,
 -1,
 245042844,
 244927614,
 785,
 -1,
 244974115,
 815,
 -1,
 244999189,
 826,
 -1,
 244923540,
 811,
 -1,
 244889401,
 7632,
 245370534,
 244788063,
 -1,
 245436067,
 245320830,
 774,
 -61790,
 245370986,
 7627,
 -1,
 245432867,
 814,
 245694463,
 245392399,
 -1,
 -61787,
 245573715,
 810,
 -1,
 245634677,
 838,
 245829292,
 245354058,
 -1,
 245894826,
 245800937,
 -1,
 -61783,
 245882221,
 846,
 -1,
 245893794,
 797,
 -61781,
 245872420,
 7634,
 -1,
 246065497,
 7633,
 246222513,
 245815864,
 -1,
 246288048,
 246184690,
 -1,
 -61777,
 246229075,
 809,
 -1,
 246290037,
 781,
 -1,
 246269948,
 830,
 246550197,
 246190479,
 -1,
 246615732,
 246502983,
 808,
 -1,
 246546437,
 7630,
 -1,
 246602197,
 773,
 246812345,
 246505055,
 -1,
 -61769,
 246789017,
 795,
 -61768,
 246846437,
 777,
 -1,
 246908740,
 843,
 247074492,
 246802448,
 -1,
 -61765,
 247015507,
 7631,
 -1,
 247076469,
 859,
 247271103,
 247063302,
 -1,
 -61762,
 247212115,
 851,
 -1,
 247273077,
 829,
 247467714,
 247242729,
 -1,
 -61759,
 247431039,
 799,
 -1,
 247470703,
 801,
 247664325,
 247427410,
 -1,
 -61756,
 247651415,
 12441,
 -1,
 247707912,
 12442,
 247860936,
 247615062,
 -1,
 -61753,
 247831574,
 8412,
 -1,
 247876076,
 850,
 -61751,
 247848749,
 8425,
 -1,
 248024722,
 842,
 248188623,
 223510501,
 -1,
 248254158,
 248138146,
 -1,
 -61747,
 248219057,
 8274,
 -1,
 248259692,
 64,
 -1,
 248190324,
 44,
 248516306,
 248160233,
 -1,
 -61743,
 248486418,
 9092,
 -1,
 248543456,
 8705,
 -1,
 248466237,
 9732,
 248778642,
 223453161,
 -1,
 248844177,
 248760253,
 -1,
 248909617,
 248821535,
 -1,
 248975143,
 248873344,
 -1,
 249040622,
 248942991,
 11423,
 249106157,
 249001529,
 -1,
 249171687,
 249049924,
 -1,
 249237215,
 249125003,
 -1,
 249302749,
 249173364,
 11471,
 -1,
 249283284,
 11477,
 -61730,
 249272525,
 11469,
 -1,
 249382177,
 11475,
 249564898,
 249215507,
 -1,
 -61727,
 249521766,
 11483,
 -1,
 249578785,
 11461,
 -61725,
 249534184,
 11455,
 -61724,
 249713546,
 11479,
 -61723,
 249776758,
 11463,
 -61722,
 249838249,
 11481,
 -1,
 249895284,
 11445,
 250150911,
 249139226,
 -1,
 250154731,
 250054879,
 -1,
 -61718,
 250144112,
 11489,
 -1,
 250172785,
 11487,
 -61716,
 250142206,
 11491,
 -1,
 250329886,
 11485,
 -1,
 249076529,
 11441,
 250547958,
 248985120,
 -1,
 250613492,
 250503726,
 -1,
 -61711,
 250580083,
 11451,
 -61710,
 250638604,
 11449,
 -61709,
 250699464,
 11467,
 -1,
 250747569,
 11443,
 -61707,
 250561825,
 1007,
 -1,
 250878623,
 11399,
 251072253,
 250525471,
 -1,
 251137786,
 251025547,
 -1,
 -61703,
 251094630,
 1005,
 -1,
 251151649,
 995,
 -61701,
 251108145,
 11403,
 -61700,
 251291238,
 11429,
 -1,
 251338032,
 11457,
 251531012,
 251016111,
 -1,
 251596547,
 251520645,
 -1,
 -61696,
 251575027,
 11500,
 -61695,
 251628659,
 11453,
 -61694,
 251679626,
 11502,
 -1,
 251741491,
 11447,
 -1,
 251566635,
 11459,
 251989770,
 251490440,
 -1,
 252055304,
 251943051,
 -1,
 -61689,
 252010879,
 11437,
 -1,
 252069153,
 999,
 -61687,
 252034012,
 11421,
 -1,
 252190647,
 11413,
 252382989,
 251970260,
 -1,
 -61684,
 252337256,
 11409,
 -1,
 252388751,
 11431,
 252579600,
 252354537,
 -1,
 -61681,
 252558300,
 11439,
 -1,
 252600703,
 11425,
 252776211,
 252539736,
 -1,
 -61678,
 252716467,
 11415,
 -1,
 252776763,
 11473,
 252972822,
 252729483,
 -1,
 -61675,
 252942541,
 1001,
 -1,
 252978333,
 11407,
 253169433,
 252924676,
 -1,
 -61672,
 253135866,
 1003,
 -1,
 253199863,
 11397,
 253366044,
 253120086,
 -1,
 -61669,
 253321599,
 11435,
 -1,
 253379873,
 997,
 253562655,
 253302132,
 -1,
 -61666,
 253524550,
 11393,
 -1,
 253588033,
 11465,
 -61664,
 253552485,
 11405,
 -61663,
 253746051,
 11395,
 -61662,
 253808318,
 11433,
 -61661,
 253866964,
 11427,
 -61660,
 253922419,
 11419,
 -61659,
 253985937,
 11417,
 -61658,
 254042830,
 11411,
 -1,
 254100787,
 11401,
 254345215,
 248964598,
 -1,
 254349099,
 254261023,
 -1,
 -61654,
 254329943,
 11495,
 -1,
 254369145,
 11498,
 254545710,
 254308488,
 -1,
 -61651,
 254499980,
 11497,
 -1,
 254548258,
 11492,
 -61649,
 254526544,
 11496,
 -61648,
 254714761,
 11494,
 -1,
 254772376,
 11493,
 254939016,
 248851678,
 -1,
 255004547,
 254877670,
 -1,
 255070026,
 254972303,
 11422,
 255135561,
 255030841,
 -1,
 255201091,
 255079236,
 -1,
 255266619,
 255154315,
 -1,
 255332153,
 255202676,
 11470,
 -1,
 255312596,
 11476,
 -61638,
 255301837,
 11468,
 -1,
 255411489,
 11474,
 255594302,
 255244819,
 -1,
 -61635,
 255551078,
 11482,
 -1,
 255608097,
 11460,
 -61633,
 255563496,
 11454,
 -61632,
 255742858,
 11478,
 -61631,
 255806070,
 11462,
 -61630,
 255867561,
 11480,
 -1,
 255924596,
 11444,
 256180223,
 255168538,
 -1,
 256184135,
 256084191,
 -1,
 -61626,
 256173424,
 11488,
 -1,
 256202097,
 11486,
 -61624,
 256171518,
 11490,
 -1,
 256359198,
 11484,
 -1,
 255105841,
 11440,
 256577362,
 255014432,
 -1,
 256642896,
 256533038,
 -1,
 -61619,
 256609395,
 11450,
 -61618,
 256667916,
 11448,
 -61617,
 256728776,
 11466,
 -1,
 256776881,
 11442,
 -61615,
 256591137,
 1006,
 -1,
 256907935,
 11398,
 257101657,
 256554783,
 -1,
 257167190,
 257054859,
 -1,
 -61611,
 257123942,
 1004,
 -1,
 257180961,
 994,
 -61609,
 257137457,
 11402,
 -61608,
 257320550,
 11428,
 -1,
 257367344,
 11456,
 257560416,
 257045423,
 -1,
 257625951,
 257549957,
 -1,
 -61604,
 257604339,
 11499,
 -61603,
 257657971,
 11452,
 -61602,
 257708938,
 11501,
 -1,
 257770803,
 11446,
 -1,
 257595947,
 11458,
 258019174,
 257519752,
 -1,
 258084708,
 257972363,
 -1,
 -61597,
 258040191,
 11436,
 -1,
 258098465,
 998,
 -61595,
 258063324,
 11420,
 -1,
 258219959,
 11412,
 258412393,
 257999572,
 -1,
 -61592,
 258366568,
 11408,
 -1,
 258418063,
 11430,
 258609004,
 258383849,
 -1,
 -61589,
 258587612,
 11438,
 -1,
 258630015,
 11424,
 258805615,
 258569048,
 -1,
 -61586,
 258745779,
 11414,
 -1,
 258806075,
 11472,
 259002226,
 258758795,
 -1,
 -61583,
 258971853,
 1000,
 -1,
 259007645,
 11406,
 259198837,
 258953988,
 -1,
 -61580,
 259165178,
 1002,
 -1,
 259229175,
 11396,
 259395448,
 259149398,
 -1,
 -61577,
 259350911,
 11434,
 -1,
 259409185,
 996,
 259592059,
 259331444,
 -1,
 -61574,
 259553862,
 11392,
 -1,
 259617345,
 11464,
 -61572,
 259581797,
 11404,
 -61571,
 259775363,
 11394,
 -61570,
 259837630,
 11432,
 -61569,
 259896276,
 11426,
 -61568,
 259951731,
 11418,
 -61567,
 260015249,
 11416,
 -61566,
 260072142,
 11410,
 -1,
 260130099,
 11400,
 260374527,
 254973148,
 -1,
 260378503,
 260292405,
 -1,
 -61562,
 260339976,
 11505,
 -1,
 260383715,
 11504,
 -1,
 260344950,
 11503,
 260640653,
 254907448,
 -1,
 -61558,
 260626949,
 11516,
 -61557,
 260663344,
 11515,
 -61556,
 260723394,
 11513,
 -1,
 260782623,
 11514,
 260968336,
 260591190,
 -1,
 -61553,
 260952346,
 11518,
 -1,
 261007843,
 11517,
 -1,
 260933401,
 11519,
 -1,
 248833716,
 169,
 261296049,
 248763113,
 -1,
 261361582,
 261253335,
 -1,
 261427105,
 261345958,
 -1,
 261492632,
 261407444,
 -1,
 -61545,
 261480847,
 119649,
 -1,
 261513302,
 119650,
 261689243,
 261469983,
 -1,
 -61542,
 261648110,
 119653,
 -1,
 261704834,
 119654,
 261885854,
 261639766,
 -1,
 -61539,
 261856240,
 119651,
 -1,
 261910135,
 119652,
 -61537,
 261854655,
 119648,
 -61536,
 262048956,
 119656,
 -1,
 262096183,
 119655,
 262340607,
 261408092,
 -1,
 262344613,
 262259412,
 -1,
 -61532,
 262332815,
 119658,
 -1,
 262365270,
 119659,
 262541224,
 262321951,
 -1,
 -61529,
 262500078,
 119662,
 -1,
 262556802,
 119663,
 262737835,
 262491734,
 -1,
 -61526,
 262708208,
 119660,
 -1,
 262762103,
 119661,
 -61524,
 262706623,
 119657,
 -61523,
 262900924,
 119665,
 -1,
 262948151,
 119664,
 263192575,
 261310815,
 -1,
 -61520,
 263109887,
 9013,
 -1,
 263137996,
 9012,
 263327681,
 261261535,
 -1,
 263393214,
 263307988,
 -1,
 263458748,
 263330168,
 -1,
 263524280,
 263446386,
 -1,
 -61514,
 263510647,
 8955,
 -61513,
 263560874,
 8957,
 -1,
 263617862,
 8954,
 263847935,
 263463712,
 -1,
 263851963,
 263753217,
 8883,
 -1,
 263784137,
 8885,
 -1,
 263816180,
 8715,
 -61507,
 263429168,
 8750,
 -1,
 264006283,
 9089,
 -61505,
 263352447,
 9740,
 -61504,
 264135408,
 9010,
 -1,
 264198141,
 10861,
 264376261,
 263290130,
 58,
 264503295,
 264306688,
 -1,
 -61500,
 264420395,
 8353,
 -1,
 264456524,
 8788,
 -61498,
 264353149,
 8792,
 -1,
 264589300,
 9904,
 264770014,
 223405038,
 -1,
 264835481,
 264745363,
 -1,
 264900782,
 264814082,
 -1,
 264966314,
 264850483,
 -1,
 265031647,
 264913031,
 1101,
 265097170,
 264997087,
 1085,
 265224191,
 265030691,
 -1,
 -61489,
 265143171,
 1226,
 -61488,
 265192683,
 1315,
 -61487,
 265248416,
 1224,
 -1,
 265304078,
 1187,
 265490391,
 265057112,
 1083,
 265617407,
 265423907,
 -1,
 -61483,
 265536387,
 1222,
 -61482,
 265585899,
 1313,
 -1,
 265641632,
 1299,
 265818073,
 265467679,
 1089,
 -1,
 265751767,
 1195,
 265949147,
 265791828,
 1088,
 -1,
 265883269,
 1167,
 266080221,
 265912293,
 1084,
 -1,
 266014316,
 1230,
 -61474,
 266030678,
 1092,
 -1,
 266144999,
 1261,
 266342389,
 264990856,
 -1,
 266407916,
 266310031,
 -1,
 266473451,
 266372244,
 -1,
 266538982,
 266417696,
 -1,
 -61468,
 266528833,
 1287,
 -61467,
 266563405,
 1283,
 -1,
 266616967,
 1281,
 -61465,
 266528833,
 1285,
 -61464,
 266782992,
 1295,
 -61463,
 266845514,
 1293,
 -61462,
 266898776,
 1291,
 -1,
 266959863,
 1289,
 -1,
 266446209,
 1153,
 267194354,
 266343796,
 1082,
 267321343,
 267127843,
 -1,
 -61457,
 267246359,
 1181,
 -61456,
 267305216,
 1183,
 -61455,
 267345568,
 1220,
 -1,
 267401230,
 1179,
 -61453,
 267172828,
 1135,
 -61452,
 267546445,
 1116,
 -1,
 267606379,
 1228,
 267784202,
 266297727,
 1080,
 267849728,
 267751823,
 1105,
 267976703,
 267829972,
 -1,
 267980799,
 267871316,
 -1,
 -61446,
 267969678,
 42579,
 -61445,
 268008408,
 1129,
 -61444,
 268058759,
 1125,
 -61443,
 268120486,
 42589,
 -61442,
 268183896,
 1133,
 -1,
 268244340,
 42583,
 -1,
 267916660,
 42567,
 268505092,
 267796615,
 1077,
 268632063,
 268438563,
 -1,
 -61437,
 268523205,
 1104,
 -1,
 268577737,
 1239,
 268767240,
 268438563,
 -1,
 -61434,
 268730427,
 1251,
 -61433,
 268785349,
 1117,
 -1,
 268843166,
 1253,
 269090815,
 268756969,
 1141,
 -1,
 268963128,
 1143,
 269160479,
 267761439,
 -1,
 269226004,
 269113483,
 -1,
 269291536,
 269195662,
 -1,
 269357071,
 269246847,
 1081,
 -1,
 269291116,
 1163,
 -1,
 269340234,
 1118,
 -61423,
 269278802,
 42647,
 -61422,
 269506729,
 1211,
 -61421,
 269561641,
 1097,
 -1,
 269620596,
 1096,
 269815834,
 269194016,
 -1,
 269881368,
 269762695,
 -1,
 -61417,
 269844453,
 42599,
 -1,
 269906776,
 42597,
 -61415,
 269859883,
 1100,
 -1,
 270022474,
 42595,
 270209052,
 269798049,
 1199,
 -1,
 270143071,
 1201,
 270340126,
 270151711,
 1241,
 -1,
 270273767,
 1243,
 -1,
 270288557,
 1165,
 270536747,
 269104672,
 -1,
 270602278,
 270526238,
 -1,
 270667811,
 270549127,
 1109,
 -1,
 270630084,
 42563,
 -61404,
 270657397,
 42633,
 -61403,
 270786130,
 42627,
 -1,
 270818088,
 1119,
 270995496,
 270561101,
 1106,
 -1,
 270972647,
 42569,
 -61399,
 270982738,
 42625,
 -61398,
 271096687,
 42605,
 -1,
 271138951,
 1076,
 271323193,
 270526238,
 -1,
 271388724,
 271276171,
 -1,
 271454259,
 271335559,
 1078,
 271581183,
 271387683,
 -1,
 271585330,
 271463968,
 -1,
 -61391,
 271540745,
 1245,
 -1,
 271600229,
 1175,
 -1,
 271526857,
 1218,
 -1,
 271441490,
 42629,
 271974399,
 271335559,
 1079,
 271978552,
 271846582,
 -1,
 -61385,
 271933961,
 1247,
 -1,
 271993445,
 1177,
 -1,
 271943151,
 42561,
 272240708,
 271311854,
 -1,
 272306238,
 272190027,
 1099,
 272433151,
 272239651,
 -1,
 -61379,
 272316574,
 1273,
 -1,
 272377525,
 42577,
 272568385,
 272242036,
 1103,
 -61376,
 272548564,
 1123,
 -1,
 272580743,
 1305,
 -61374,
 272551498,
 1102,
 -61373,
 272730335,
 42591,
 -1,
 272785791,
 1111,
 272961616,
 272220884,
 -1,
 273027146,
 272938783,
 -1,
 -61369,
 273014354,
 42639,
 -61368,
 273070232,
 42641,
 -61367,
 273111848,
 1115,
 -1,
 273170567,
 1094,
 273354830,
 272973959,
 1090,
 273481727,
 273288227,
 -1,
 -61363,
 273384683,
 42635,
 -1,
 273430542,
 1197,
 -61361,
 273342034,
 42637,
 -1,
 273559404,
 42643,
 273748060,
 272901750,
 -1,
 273813589,
 273683828,
 -1,
 273879124,
 273790326,
 1257,
 -1,
 273812711,
 1259,
 -1,
 273857332,
 1185,
 274075736,
 273768831,
 -1,
 -61353,
 274042276,
 42603,
 -1,
 274092786,
 1131,
 -61351,
 274064663,
 1110,
 -61350,
 274248668,
 42573,
 -61349,
 274299121,
 42587,
 -1,
 274350215,
 1073,
 274534502,
 273683828,
 1072,
 274600034,
 274475496,
 -1,
 274665568,
 274542444,
 1213,
 -1,
 274599127,
 1215,
 -61343,
 274618537,
 1193,
 -1,
 274743427,
 1249,
 274927717,
 274533411,
 -1,
 -61340,
 274872478,
 1235,
 -1,
 274934729,
 1233,
 -1,
 274889224,
 1311,
 275189871,
 274485987,
 -1,
 275255406,
 275143464,
 1075,
 275382271,
 275188771,
 -1,
 275386475,
 275300608,
 1171,
 -1,
 275316954,
 1275,
 -61332,
 275371273,
 1169,
 -61331,
 275481835,
 1173,
 -1,
 275527694,
 1271,
 -1,
 275214157,
 1107,
 275779703,
 275172938,
 1091,
 275845237,
 275713059,
 -1,
 275910772,
 275789344,
 -1,
 -61325,
 275880763,
 1267,
 -1,
 275931657,
 1265,
 -1,
 275873851,
 1263,
 276234239,
 275804296,
 1145,
 -1,
 276146758,
 1108,
 276303999,
 275732619,
 -1,
 276369534,
 276239732,
 1093,
 276435069,
 276302883,
 -1,
 -61317,
 276414720,
 1279,
 -61316,
 276455072,
 1277,
 -1,
 276510734,
 1203,
 -1,
 276409173,
 1098,
 -1,
 276356690,
 42645,
 276828296,
 276245726,
 -1,
 276893830,
 276781864,
 1095,
 277020671,
 276827171,
 -1,
 277024901,
 276903456,
 -1,
 -61308,
 276980233,
 1269,
 -1,
 277039717,
 1207,
 -1,
 277011223,
 1209,
 -61305,
 276856271,
 42585,
 -1,
 277229420,
 42631,
 277418127,
 276801876,
 -1,
 277483661,
 277368050,
 -1,
 -61301,
 277473141,
 1297,
 -61300,
 277538519,
 42581,
 -1,
 277561475,
 42565,
 -61298,
 277453707,
 1147,
 -1,
 277698729,
 1303,
 277876886,
 277389289,
 -1,
 277942420,
 277823623,
 1087,
 278069247,
 277875747,
 -1,
 -61293,
 277972203,
 1191,
 -1,
 278018062,
 1317,
 -61291,
 277920732,
 1137,
 -1,
 278142001,
 1231,
 278335643,
 277844367,
 1086,
 278401177,
 278299593,
 1121,
 -1,
 278335138,
 1149,
 -61286,
 278381268,
 1151,
 -1,
 278465767,
 1255,
 278663327,
 278295384,
 -1,
 -61283,
 278622029,
 1113,
 -61282,
 278687310,
 1127,
 -1,
 278747305,
 1301,
 278925474,
 278628575,
 -1,
 -61279,
 278884173,
 1114,
 -1,
 278940768,
 42575,
 279122085,
 278890170,
 -1,
 -61276,
 279074492,
 42571,
 -1,
 279131503,
 42601,
 -61274,
 279109202,
 1309,
 -61273,
 279304436,
 1074,
 -61272,
 279357258,
 1307,
 -61271,
 279408461,
 1112,
 -1,
 279466159,
 1139,
 279707647,
 264922271,
 -1,
 -61268,
 279626891,
 1205,
 -61267,
 279660296,
 1189,
 -1,
 279713160,
 1237,
 279908754,
 264842746,
 -1,
 279974286,
 279858227,
 -1,
 280039620,
 279920775,
 1069,
 280105143,
 280004831,
 1053,
 280231935,
 280038435,
 -1,
 -61260,
 280150915,
 1225,
 -61259,
 280200427,
 1314,
 -61258,
 280256160,
 1223,
 -1,
 280311822,
 1186,
 280498364,
 280064856,
 1051,
 280625151,
 280431651,
 -1,
 -61254,
 280544131,
 1221,
 -61253,
 280593643,
 1312,
 -1,
 280649376,
 1298,
 280826046,
 280475423,
 1057,
 -1,
 280759511,
 1194,
 280957120,
 280799572,
 1056,
 -1,
 280891013,
 1166,
 281088194,
 280920037,
 1052,
 -1,
 281022060,
 1229,
 -61245,
 281038422,
 1060,
 -1,
 281152743,
 1260,
 281350362,
 279998600,
 -1,
 281415889,
 281317775,
 -1,
 281481424,
 281379988,
 -1,
 281546955,
 281425440,
 -1,
 -61239,
 281536577,
 1286,
 -61238,
 281571149,
 1282,
 -1,
 281624711,
 1280,
 -61236,
 281536577,
 1284,
 -61235,
 281790736,
 1294,
 -61234,
 281853258,
 1292,
 -61233,
 281906520,
 1290,
 -1,
 281967607,
 1288,
 -1,
 281453953,
 1152,
 282202327,
 281351540,
 1050,
 282329087,
 282135587,
 -1,
 -61228,
 282254103,
 1180,
 -61227,
 282312960,
 1182,
 -61226,
 282353312,
 1219,
 -1,
 282408974,
 1178,
 -61224,
 282180572,
 1134,
 -61223,
 282554189,
 1036,
 -1,
 282614123,
 1227,
 282792175,
 281305471,
 1048,
 282857701,
 282759567,
 1025,
 282984447,
 282837716,
 -1,
 282988772,
 282879060,
 -1,
 -61217,
 282977422,
 42578,
 -61216,
 283016152,
 1128,
 -61215,
 283066503,
 1124,
 -61214,
 283128230,
 42588,
 -61213,
 283191640,
 1132,
 -1,
 283252084,
 42582,
 -1,
 282924404,
 42566,
 283513065,
 282804359,
 1045,
 283639807,
 283446307,
 -1,
 -61208,
 283530949,
 1024,
 -1,
 283585481,
 1238,
 283775213,
 283446307,
 -1,
 -61205,
 283738171,
 1250,
 -61204,
 283793093,
 1037,
 -1,
 283850910,
 1252,
 284098559,
 283764713,
 1140,
 -1,
 283970872,
 1142,
 284168452,
 282769183,
 -1,
 284233977,
 284121227,
 -1,
 284299509,
 284203406,
 -1,
 284365044,
 284254591,
 1049,
 -1,
 284298860,
 1162,
 -1,
 284347978,
 1038,
 -61194,
 284286546,
 42646,
 -61193,
 284514473,
 1210,
 -61192,
 284569385,
 1065,
 -1,
 284628340,
 1064,
 284823807,
 284201760,
 -1,
 284889341,
 284770439,
 -1,
 -61188,
 284852197,
 42598,
 -1,
 284914520,
 42596,
 -61186,
 284867627,
 1068,
 -1,
 285030218,
 42594,
 285217025,
 284805793,
 1198,
 -1,
 285150815,
 1200,
 285348099,
 285159455,
 1240,
 -1,
 285281511,
 1242,
 -1,
 285296301,
 1164,
 285544720,
 284112416,
 -1,
 285610251,
 285533982,
 -1,
 285675784,
 285556871,
 1029,
 -1,
 285637828,
 42562,
 -61175,
 285665141,
 42632,
 -61174,
 285793874,
 42626,
 -1,
 285825832,
 1039,
 286003469,
 285568845,
 1026,
 -1,
 285980391,
 42568,
 -61170,
 285990482,
 42624,
 -61169,
 286104431,
 42604,
 -1,
 286146695,
 1044,
 286331166,
 285533982,
 -1,
 286396697,
 286283915,
 -1,
 286462232,
 286343303,
 1046,
 286588927,
 286395427,
 -1,
 286593303,
 286471712,
 -1,
 -61162,
 286548489,
 1244,
 -1,
 286607973,
 1174,
 -1,
 286534601,
 1217,
 -1,
 286449234,
 42628,
 286982143,
 286343303,
 1047,
 286986525,
 286854326,
 -1,
 -61156,
 286941705,
 1246,
 -1,
 287001189,
 1176,
 -1,
 286950895,
 42560,
 287248681,
 286319598,
 -1,
 287314211,
 287197771,
 1067,
 287440895,
 287247395,
 -1,
 -61150,
 287324318,
 1272,
 -1,
 287385269,
 42576,
 287576358,
 287249780,
 1071,
 -61147,
 287556308,
 1122,
 -1,
 287588487,
 1304,
 -61145,
 287559242,
 1070,
 -61144,
 287738079,
 42590,
 -1,
 287793535,
 1031,
 287969589,
 287228628,
 -1,
 288035119,
 287946527,
 -1,
 -61140,
 288022098,
 42638,
 -61139,
 288077976,
 42640,
 -61138,
 288119592,
 1035,
 -1,
 288178311,
 1062,
 288362803,
 287981703,
 1058,
 288489471,
 288295971,
 -1,
 -61134,
 288392427,
 42634,
 -1,
 288438286,
 1196,
 -61132,
 288349778,
 42636,
 -1,
 288567148,
 42642,
 288756033,
 287909494,
 -1,
 288821562,
 288691572,
 -1,
 288887097,
 288798070,
 1256,
 -1,
 288820455,
 1258,
 -1,
 288865076,
 1184,
 289083709,
 288776575,
 -1,
 -61124,
 289050020,
 42602,
 -1,
 289100530,
 1130,
 -61122,
 289072407,
 1030,
 -61121,
 289256412,
 42572,
 -61120,
 289306865,
 42586,
 -1,
 289357959,
 1041,
 289542475,
 288691572,
 1040,
 289608007,
 289483240,
 -1,
 289673541,
 289550188,
 1212,
 -1,
 289606871,
 1214,
 -61114,
 289626281,
 1192,
 -1,
 289751171,
 1248,
 289935690,
 289541155,
 -1,
 -61111,
 289880222,
 1234,
 -1,
 289942473,
 1232,
 -1,
 289896968,
 1310,
 290197844,
 289493731,
 -1,
 290263379,
 290151208,
 1043,
 290390015,
 290196515,
 -1,
 290394448,
 290308352,
 1170,
 -1,
 290324698,
 1274,
 -61103,
 290379017,
 1168,
 -61102,
 290489579,
 1172,
 -1,
 290535438,
 1270,
 -1,
 290221901,
 1027,
 290787676,
 290180682,
 1059,
 290853210,
 290720803,
 -1,
 290918745,
 290797088,
 -1,
 -61096,
 290888507,
 1266,
 -1,
 290939401,
 1264,
 -1,
 290881595,
 1262,
 291241983,
 290812040,
 1144,
 -1,
 291154502,
 1028,
 291311972,
 290740363,
 -1,
 291377507,
 291247476,
 1061,
 291443042,
 291310627,
 -1,
 -61088,
 291422464,
 1278,
 -61087,
 291462816,
 1276,
 -1,
 291518478,
 1202,
 -1,
 291416917,
 1066,
 -1,
 291364434,
 42644,
 291836269,
 291253470,
 -1,
 291901803,
 291789608,
 1063,
 292028415,
 291834915,
 -1,
 292032874,
 291911200,
 -1,
 -61079,
 291987977,
 1268,
 -1,
 292047461,
 1206,
 -1,
 292018967,
 1208,
 -61076,
 291864015,
 42584,
 -1,
 292237164,
 42630,
 292426100,
 291809620,
 -1,
 292491634,
 292375794,
 -1,
 -61072,
 292480885,
 1296,
 -61071,
 292546263,
 42580,
 -1,
 292569219,
 42564,
 -61069,
 292461451,
 1146,
 -1,
 292706473,
 1302,
 292884857,
 292393359,
 1054,
 292950391,
 292848585,
 1120,
 -1,
 292884130,
 1148,
 -61064,
 292930260,
 1150,
 -1,
 293014759,
 1254,
 293212543,
 292855785,
 -1,
 293278078,
 293159047,
 1055,
 293404671,
 293211171,
 -1,
 -61059,
 293307627,
 1190,
 -1,
 293353486,
 1316,
 -1,
 293256156,
 1136,
 293605763,
 293172056,
 -1,
 -61055,
 293564237,
 1033,
 -61054,
 293629518,
 1126,
 -1,
 293689513,
 1300,
 293867910,
 293570783,
 -1,
 -61051,
 293826381,
 1034,
 -1,
 293882976,
 42574,
 294064521,
 293832378,
 -1,
 -61048,
 294016700,
 42570,
 -1,
 294073711,
 42600,
 -61046,
 294051410,
 1308,
 -61045,
 294246644,
 1042,
 -61044,
 294299466,
 1306,
 -61043,
 294350669,
 1032,
 -1,
 294408367,
 1138,
 294649855,
 279930015,
 -1,
 -61040,
 294569099,
 1204,
 -61039,
 294602504,
 1188,
 -1,
 294655368,
 1236,
 294850966,
 279869914,
 -1,
 -61036,
 294829521,
 7467,
 -61035,
 294887604,
 1216,
 -1,
 294946775,
 42606,
 -61033,
 294831920,
 1154,
 -61032,
 295084447,
 42623,
 -1,
 295137675,
 42622,
 295309789,
 264808061,
 -1,
 295375264,
 295289556,
 -1,
 -61028,
 295358026,
 67633,
 -61027,
 295408015,
 67632,
 -61026,
 295461247,
 67631,
 -61025,
 295518343,
 67630,
 -1,
 295572852,
 67629,
 295768486,
 295352095,
 -1,
 -61022,
 295751242,
 67628,
 -61021,
 295801231,
 67627,
 -61020,
 295854463,
 67626,
 -61019,
 295911559,
 67625,
 -1,
 295966068,
 67624,
 296161708,
 295741780,
 -1,
 -61016,
 296144458,
 67623,
 -61015,
 296194447,
 67622,
 -61014,
 296247679,
 67621,
 -61013,
 296304775,
 67620,
 -1,
 296359284,
 67619,
 296554930,
 296132585,
 -1,
 -61010,
 296537674,
 67618,
 -61009,
 296587663,
 67617,
 -61008,
 296640895,
 67616,
 -61007,
 296697991,
 67615,
 -1,
 296752500,
 67614,
 296948152,
 296519903,
 -1,
 -61004,
 296930890,
 67613,
 -61003,
 296980879,
 67612,
 -61002,
 297034111,
 67611,
 -61001,
 297091207,
 67610,
 -1,
 297145716,
 67609,
 297341374,
 296910821,
 -1,
 -60998,
 297324106,
 67608,
 -60997,
 297374095,
 67607,
 -60996,
 297427327,
 67606,
 -60995,
 297484423,
 67605,
 -1,
 297538932,
 67604,
 297734596,
 297300824,
 -1,
 -60992,
 297717322,
 67603,
 -60991,
 297767311,
 67602,
 -60990,
 297820543,
 67601,
 -60989,
 297877639,
 67600,
 -1,
 297932148,
 67599,
 298127818,
 297693320,
 -1,
 -60986,
 298110538,
 67598,
 -60985,
 298160527,
 67597,
 -60984,
 298213759,
 67596,
 -60983,
 298270855,
 67595,
 -1,
 298325364,
 67594,
 298521039,
 298114312,
 -1,
 -60980,
 298488207,
 67637,
 -60979,
 298541439,
 67636,
 -60978,
 298598535,
 67635,
 -1,
 298653044,
 67634,
 298848722,
 298510110,
 -1,
 -60975,
 298815887,
 67647,
 -1,
 298849652,
 67644,
 299045333,
 298836740,
 -1,
 -60972,
 298991751,
 67640,
 -1,
 299046260,
 67639,
 299241944,
 299003689,
 -1,
 -60969,
 299209103,
 67592,
 -1,
 299242868,
 67589,
 -60967,
 299224650,
 67588,
 -60966,
 299405711,
 67587,
 -60965,
 299458943,
 67586,
 -60964,
 299516039,
 67585,
 -1,
 299570548,
 67584,
 -1,
 295271138,
 9005,
 299832160,
 264727576,
 -1,
 299897693,
 299791954,
 -1,
 299963212,
 299841058,
 -1,
 300028465,
 299917695,
 -1,
 300093998,
 299972594,
 -1,
 300159474,
 300070687,
 -1,
 300225000,
 300142154,
 -1,
 -60954,
 300196647,
 12972,
 -60953,
 300255455,
 12944,
 -1,
 300314009,
 12956,
 300487147,
 300204756,
 -1,
 -60950,
 300470282,
 12971,
 -1,
 300520053,
 12945,
 300683758,
 300433543,
 -1,
 -60947,
 300669315,
 12934,
 -1,
 300692441,
 12953,
 -60945,
 300655038,
 12949,
 -60944,
 300847726,
 12947,
 -60943,
 300904174,
 12933,
 -1,
 300953554,
 12870,
 301142521,
 300109398,
 -1,
 301208055,
 301097343,
 -1,
 -60939,
 301193460,
 12932,
 -60938,
 301247364,
 12939,
 -1,
 301304206,
 12950,
 -60936,
 301177840,
 12931,
 -1,
 301418061,
 12955,
 301601280,
 301115732,
 -1,
 301666815,
 301547655,
 -1,
 301732350,
 301643551,
 -1,
 -60931,
 301712084,
 12961,
 -1,
 301767791,
 12974,
 -1,
 301693641,
 12970,
 -1,
 301622499,
 12968,
 302060038,
 301563877,
 -1,
 302125572,
 302006407,
 -1,
 -60925,
 302105515,
 12942,
 -1,
 302135651,
 12969,
 -60923,
 302093993,
 12938,
 -1,
 302258852,
 12954,
 302453259,
 302006407,
 -1,
 -60920,
 302441277,
 12957,
 -60919,
 302485383,
 12973,
 -60918,
 302540003,
 12935,
 -1,
 302588620,
 12943,
 302780945,
 302394590,
 -1,
 302846480,
 302748047,
 -1,
 -60914,
 302822760,
 12963,
 -60913,
 302884673,
 12962,
 -1,
 302943294,
 12951,
 -1,
 302794800,
 12965,
 303174165,
 302760660,
 -1,
 -60909,
 303161743,
 12929,
 -60908,
 303194198,
 12930,
 -1,
 303253233,
 12937,
 303436314,
 303139039,
 -1,
 303501849,
 303391103,
 -1,
 -60904,
 303467267,
 12936,
 -1,
 303518942,
 12976,
 -1,
 303439043,
 12948,
 303763998,
 303395672,
 -1,
 -60900,
 303734509,
 12966,
 -60899,
 303776666,
 12967,
 -1,
 303830640,
 12952,
 304026145,
 303750408,
 -1,
 -60896,
 303994522,
 12941,
 -1,
 304030890,
 12940,
 304222756,
 303984776,
 -1,
 -60893,
 304192271,
 12871,
 -1,
 304244746,
 12869,
 304419367,
 304175243,
 -1,
 -60890,
 304374992,
 12964,
 -1,
 304424421,
 12946,
 304615978,
 304354676,
 -1,
 -60887,
 304598092,
 12959,
 -1,
 304643198,
 12975,
 -60885,
 304588981,
 12868,
 -60884,
 304785015,
 12958,
 -60883,
 304846271,
 12928,
 -1,
 304901568,
 12960,
 305135615,
 300073937,
 -1,
 -60880,
 305047892,
 127276,
 -1,
 305081566,
 127275,
 305271402,
 299987800,
 -1,
 305336937,
 305210651,
 -1,
 305402446,
 305315338,
 -1,
 -60875,
 305391390,
 9449,
 -60874,
 305456110,
 9448,
 -60873,
 305521412,
 9447,
 -60872,
 305585416,
 9446,
 -60871,
 305649582,
 9445,
 -60870,
 305712714,
 9444,
 -60869,
 305775316,
 9443,
 -60868,
 305837855,
 9442,
 -60867,
 305899860,
 9441,
 -60866,
 305964868,
 9440,
 -60865,
 306028521,
 9439,
 -60864,
 306090383,
 9438,
 -60863,
 306153695,
 9437,
 -60862,
 306216933,
 9436,
 -60861,
 306279256,
 9435,
 -60860,
 306344072,
 9434,
 -60859,
 306409257,
 9433,
 -60858,
 306471295,
 9432,
 -60857,
 306534539,
 9431,
 -60856,
 306598627,
 9430,
 -60855,
 306662998,
 9429,
 -60854,
 306724999,
 9428,
 -60853,
 306787872,
 9427,
 -60852,
 306851038,
 9426,
 -60851,
 306914934,
 9425,
 -1,
 306976116,
 9424,
 307232767,
 305344004,
 -1,
 -60848,
 307160862,
 9423,
 -60847,
 307225582,
 9422,
 -60846,
 307290884,
 9421,
 -60845,
 307354888,
 9420,
 -60844,
 307419054,
 9419,
 -60843,
 307482186,
 9418,
 -60842,
 307544788,
 9417,
 -60841,
 307607327,
 9416,
 -60840,
 307669332,
 9415,
 -60839,
 307734340,
 9414,
 -60838,
 307797993,
 9413,
 -60837,
 307859855,
 9412,
 -60836,
 307923167,
 9411,
 -60835,
 307986405,
 9410,
 -60834,
 308048728,
 9409,
 -60833,
 308113544,
 9408,
 -60832,
 308178729,
 9407,
 -60831,
 308240767,
 9406,
 -60830,
 308304011,
 9405,
 -60829,
 308368099,
 9404,
 -60828,
 308432470,
 9403,
 -60827,
 308494471,
 9402,
 -60826,
 308557344,
 9401,
 -60825,
 308620510,
 9400,
 -60824,
 308684406,
 9399,
 -1,
 308745588,
 9398,
 -1,
 305285865,
 10688,
 309007030,
 305238079,
 -1,
 309072530,
 308986580,
 -1,
 309138046,
 309059154,
 -1,
 309203581,
 309104645,
 9331,
 309329919,
 309133312,
 -1,
 309334642,
 309248724,
 -1,
 -60815,
 309322127,
 12882,
 -1,
 309354582,
 12883,
 309531253,
 309311263,
 -1,
 -60812,
 309489390,
 12886,
 -1,
 309546114,
 12887,
 309727864,
 309499181,
 -1,
 -60809,
 309674119,
 12881,
 -1,
 309723719,
 12873,
 309924475,
 309677654,
 -1,
 -60806,
 309894128,
 12884,
 -1,
 309948023,
 12885,
 -60804,
 309890236,
 12889,
 -1,
 310068535,
 12888,
 -1,
 309165966,
 9323,
 310317712,
 309091756,
 -1,
 310383247,
 310305774,
 12890,
 310509567,
 310312960,
 -1,
 310514308,
 310428372,
 -1,
 -60797,
 310501775,
 12892,
 -1,
 310534230,
 12893,
 310710919,
 310490911,
 -1,
 -60794,
 310669038,
 12977,
 -1,
 310725762,
 12978,
 310907530,
 310678829,
 -1,
 -60791,
 310853767,
 12891,
 -1,
 310903367,
 12874,
 311104141,
 310857302,
 -1,
 -60788,
 311073776,
 12894,
 -1,
 311127671,
 12895,
 -60786,
 311069884,
 12980,
 -1,
 311248183,
 12979,
 -1,
 310330188,
 9324,
 311558143,
 310265585,
 9321,
 -1,
 311428687,
 12872,
 311628457,
 309022294,
 -1,
 311693989,
 311595407,
 -1,
 311759524,
 311670374,
 12981,
 311885823,
 311689216,
 -1,
 311890585,
 311804628,
 -1,
 -60776,
 311878031,
 12983,
 -1,
 311910486,
 12984,
 312087196,
 311867167,
 -1,
 -60773,
 312045294,
 12987,
 -1,
 312102018,
 12988,
 312283807,
 312055085,
 -1,
 -60770,
 312230023,
 12982,
 -1,
 312279623,
 12875,
 312480418,
 312233558,
 -1,
 -60767,
 312450032,
 12985,
 -1,
 312503927,
 12986,
 -60765,
 312446140,
 12990,
 -1,
 312624439,
 12989,
 -1,
 311744075,
 9325,
 312934399,
 311649385,
 -1,
 312939176,
 312861678,
 12991,
 -1,
 312870479,
 12876,
 -1,
 312886092,
 9326,
 313135792,
 311605023,
 -1,
 313201325,
 313093884,
 -1,
 -60756,
 313189371,
 12877,
 -1,
 313213772,
 9327,
 313458687,
 313150634,
 -1,
 -60753,
 313385979,
 12878,
 -1,
 313410380,
 9328,
 313594549,
 313081991,
 -1,
 313660084,
 313550051,
 -1,
 -60749,
 313648123,
 12879,
 -1,
 313672524,
 9329,
 -1,
 313621024,
 9322,
 -1,
 313560257,
 9330,
 313987827,
 308965512,
 -1,
 314053360,
 313926793,
 -1,
 314118846,
 314032852,
 -1,
 -60742,
 314101322,
 13025,
 -60741,
 314151311,
 13027,
 -60740,
 314204543,
 13024,
 -60739,
 314261639,
 13026,
 -1,
 314316148,
 13023,
 314512068,
 314095391,
 -1,
 -60736,
 314494538,
 13020,
 -60735,
 314544527,
 13022,
 -60734,
 314597759,
 13019,
 -60733,
 314654855,
 13021,
 -1,
 314709364,
 13018,
 314905290,
 314485076,
 -1,
 -60730,
 314887754,
 13048,
 -60729,
 314937743,
 13050,
 -60728,
 314990975,
 13047,
 -60727,
 315048071,
 13049,
 -1,
 315102580,
 13046,
 315298512,
 314869983,
 -1,
 -60724,
 315280970,
 13030,
 -60723,
 315330959,
 13032,
 -60722,
 315384191,
 13029,
 -60721,
 315441287,
 13031,
 -1,
 315495796,
 13028,
 315691734,
 315260901,
 -1,
 -60718,
 315674186,
 13040,
 -60717,
 315724175,
 13042,
 -60716,
 315777407,
 13039,
 -60715,
 315834503,
 13041,
 -1,
 315889012,
 13038,
 316084956,
 315650184,
 -1,
 -60712,
 316067402,
 13015,
 -60711,
 316117391,
 13017,
 -60710,
 316170623,
 13014,
 -60709,
 316227719,
 13016,
 -1,
 316282228,
 13013,
 316478178,
 316037259,
 -1,
 -60706,
 316460618,
 13035,
 -60705,
 316510607,
 13037,
 -60704,
 316563839,
 13034,
 -60703,
 316620935,
 13036,
 -1,
 316675444,
 13033,
 316871399,
 316464392,
 -1,
 -60700,
 316838287,
 13054,
 -60699,
 316891519,
 13052,
 -60698,
 316948615,
 13053,
 -1,
 317003124,
 13051,
 317199083,
 316859374,
 -1,
 -60695,
 317181514,
 13044,
 -60694,
 317231503,
 13045,
 -1,
 317265268,
 13043,
 -60692,
 317181514,
 13010,
 -60691,
 317428111,
 13012,
 -60690,
 317481343,
 13009,
 -60689,
 317538439,
 13011,
 -1,
 317592948,
 13008,
 317849599,
 314022033,
 -1,
 -60686,
 317747321,
 12925,
 -1,
 317796178,
 12924,
 317985561,
 313940107,
 -1,
 318051095,
 317923017,
 -1,
 318116602,
 318030548,
 -1,
 318182136,
 318072245,
 12898,
 -1,
 318111746,
 12912,
 318373887,
 318135522,
 12907,
 -1,
 318242818,
 12921,
 318444287,
 318087145,
 -1,
 318509821,
 318399558,
 12901,
 -1,
 318439426,
 12915,
 318701567,
 318463195,
 12908,
 -1,
 318570498,
 12922,
 318771972,
 318402696,
 -1,
 318837506,
 318730019,
 12896,
 -1,
 318767106,
 12910,
 319029247,
 318790868,
 12906,
 -1,
 318898178,
 12920,
 319099657,
 318713054,
 -1,
 319165191,
 319054907,
 12904,
 -1,
 319094786,
 12918,
 319356927,
 319118535,
 12905,
 -1,
 319225858,
 12919,
 319427341,
 319054912,
 12903,
 319553535,
 319356928,
 -1,
 -60660,
 319475274,
 12926,
 -1,
 319493492,
 12917,
 319689487,
 319405322,
 12902,
 -1,
 319619074,
 12916,
 319820561,
 319663703,
 12899,
 -1,
 319750146,
 12913,
 319951635,
 319786124,
 12897,
 -1,
 319881218,
 12911,
 320082709,
 319915310,
 12900,
 -1,
 320012290,
 12914,
 320274431,
 320036046,
 12909,
 -1,
 320143362,
 12923,
 -60648,
 318019842,
 9097,
 -1,
 320291294,
 10162,
 320475950,
 317928992,
 -1,
 320541484,
 320430463,
 -1,
 320607017,
 320492987,
 -1,
 320672543,
 320586452,
 -1,
 -60642,
 320659855,
 9313,
 -1,
 320692310,
 9314,
 320869154,
 320648991,
 -1,
 -60639,
 320827118,
 9317,
 -1,
 320883842,
 9318,
 321065765,
 320818774,
 -1,
 -60636,
 321035248,
 9315,
 -1,
 321089143,
 9316,
 -60634,
 321054613,
 9450,
 -60633,
 321230271,
 9312,
 -60632,
 321293500,
 9320,
 -1,
 321340727,
 9319,
 321585151,
 320592892,
 -1,
 -60629,
 321484162,
 8856,
 -1,
 321545605,
 10808,
 -60627,
 320510563,
 8857,
 -1,
 321659732,
 8861,
 321852211,
 320446441,
 -1,
 -60624,
 321821238,
 12342,
 -60623,
 321879909,
 8853,
 -60622,
 321931789,
 10681,
 -1,
 321986801,
 10679,
 322179896,
 321838344,
 -1,
 322245431,
 322133467,
 -1,
 -60618,
 322224206,
 10026,
 -1,
 322251839,
 10686,
 -1,
 322234142,
 127278,
 322507579,
 322159316,
 -1,
 -60614,
 322481666,
 9098,
 -1,
 322528956,
 8855,
 322704190,
 322480468,
 -1,
 -60611,
 322660554,
 8858,
 -1,
 322718947,
 10680,
 322900801,
 322666469,
 -1,
 -60608,
 322883901,
 10806,
 -1,
 322923171,
 8854,
 323097412,
 322841822,
 -1,
 -60605,
 323073203,
 9938,
 -1,
 323106336,
 127277,
 323294023,
 323032436,
 -1,
 -60602,
 323272836,
 8859,
 -1,
 323325860,
 10684,
 -60600,
 323279452,
 10678,
 -60599,
 323458823,
 10050,
 -60598,
 323507959,
 10689,
 -60597,
 323569996,
 8860,
 -1,
 323628095,
 10687,
 323878911,
 299892736,
 -1,
 323883868,
 323805042,
 -1,
 323949393,
 323867737,
 -1,
 -60592,
 323923908,
 9684,
 -1,
 323967390,
 9683,
 324146004,
 323925791,
 -1,
 -60589,
 324129809,
 10683,
 -1,
 324174176,
 10690,
 324342615,
 324105048,
 -1,
 -60586,
 324312908,
 9682,
 -1,
 324355008,
 9680,
 -60584,
 324328135,
 9677,
 -60583,
 324521424,
 10691,
 -60582,
 324579108,
 9681,
 -60581,
 324624088,
 10677,
 -1,
 324672436,
 9685,
 -1,
 323828330,
 10682,
 324993023,
 299880010,
 -1,
 -60577,
 324895866,
 94,
 -1,
 324957699,
 10768,
 325129273,
 299784331,
 -1,
 325194693,
 325075079,
 -1,
 325260228,
 325170200,
 -1,
 325325685,
 325239508,
 -1,
 325391211,
 325302047,
 -1,
 -60570,
 325375918,
 5096,
 -60569,
 325439050,
 5095,
 -60568,
 325489039,
 5094,
 -60567,
 325542271,
 5093,
 -60566,
 325599367,
 5092,
 -1,
 325653876,
 5091,
 325849970,
 325350232,
 -1,
 -60563,
 325834670,
 5090,
 -60562,
 325897802,
 5089,
 -60561,
 325947791,
 5088,
 -60560,
 326001023,
 5087,
 -60559,
 326058119,
 5086,
 -1,
 326112628,
 5085,
 -60557,
 325804415,
 5080,
 -60556,
 326254727,
 5078,
 -1,
 326309236,
 5076,
 326505340,
 325302047,
 5069,
 -60553,
 326490030,
 5074,
 -60552,
 326553162,
 5073,
 -60551,
 326603151,
 5072,
 -60550,
 326656383,
 5071,
 -60549,
 326713479,
 5070,
 -1,
 326767988,
 5068,
 326964100,
 326469855,
 -1,
 327029631,
 326899060,
 5054,
 -1,
 326981771,
 5056,
 -60544,
 327014318,
 5061,
 -60543,
 327142986,
 5060,
 -60542,
 327192975,
 5059,
 -60541,
 327246207,
 5058,
 -1,
 327303303,
 5057,
 327488396,
 326916235,
 -1,
 -60538,
 327473070,
 5042,
 -60537,
 327536202,
 5041,
 -60536,
 327586191,
 5040,
 -60535,
 327649595,
 5055,
 -60534,
 327704959,
 5039,
 -60533,
 327762055,
 5038,
 -1,
 327816564,
 5037,
 328012692,
 327431712,
 -1,
 -60530,
 327997358,
 5083,
 -60529,
 328060490,
 5082,
 -60528,
 328110479,
 5081,
 -60527,
 328168365,
 5084,
 -60526,
 328229247,
 5079,
 -60525,
 328286343,
 5077,
 -1,
 328340852,
 5075,
 328536987,
 328000494,
 -1,
 -60522,
 328521646,
 5108,
 -60521,
 328584778,
 5107,
 -60520,
 328634767,
 5106,
 -60519,
 328687999,
 5105,
 -60518,
 328745095,
 5104,
 -1,
 328799604,
 5103,
 328995746,
 328523016,
 -1,
 -60515,
 328980398,
 5102,
 -60514,
 329043530,
 5101,
 -60513,
 329093519,
 5100,
 -60512,
 329146751,
 5099,
 -60511,
 329203847,
 5098,
 -1,
 329258356,
 5097,
 329454505,
 328968129,
 -1,
 -60508,
 329439150,
 5067,
 -60507,
 329502282,
 5066,
 -60506,
 329552271,
 5065,
 -60505,
 329605503,
 5064,
 -60504,
 329662599,
 5063,
 -1,
 329717108,
 5062,
 329913264,
 329413464,
 -1,
 -60501,
 329897902,
 5048,
 -60500,
 329961034,
 5047,
 -60499,
 330011023,
 5046,
 -60498,
 330064255,
 5045,
 -60497,
 330121351,
 5044,
 -1,
 330175860,
 5043,
 330372023,
 329863907,
 -1,
 -60494,
 330356654,
 5036,
 -60493,
 330419786,
 5035,
 -60492,
 330469775,
 5034,
 -60491,
 330523007,
 5033,
 -60490,
 330580103,
 5032,
 -1,
 330634612,
 5030,
 330830781,
 330334181,
 -1,
 -60487,
 330813002,
 5053,
 -60486,
 330862991,
 5052,
 -60485,
 330916223,
 5051,
 -60484,
 330973319,
 5050,
 -1,
 331027828,
 5049,
 -60482,
 330815406,
 5029,
 -60481,
 331206218,
 5028,
 -60480,
 331256207,
 5027,
 -60479,
 331313311,
 5031,
 -60478,
 331374975,
 5026,
 -60477,
 331432071,
 5025,
 -1,
 331486580,
 5024,
 -1,
 325202216,
 10003,
 331748405,
 325129588,
 -1,
 331813939,
 331710439,
 -1,
 331879434,
 331774426,
 -1,
 331944916,
 331829298,
 -1,
 332010443,
 331909343,
 43590,
 -1,
 331961059,
 43586,
 -60468,
 331998190,
 43592,
 -60467,
 332120788,
 43589,
 -60466,
 332185503,
 43595,
 -60465,
 332245332,
 43593,
 -60464,
 332308457,
 43591,
 -60463,
 332362584,
 43594,
 -60462,
 332427400,
 43584,
 -60461,
 332485347,
 43585,
 -1,
 332541730,
 43588,
 332731358,
 331909343,
 -1,
 332796889,
 332683403,
 -1,
 -60457,
 332779534,
 43536,
 -60456,
 332820267,
 43538,
 -1,
 332862836,
 43537,
 333059036,
 332747491,
 -1,
 -60453,
 333041678,
 43530,
 -1,
 333059444,
 43531,
 -60451,
 333041678,
 43543,
 -1,
 333190516,
 43544,
 333386722,
 332701673,
 -1,
 -60448,
 333357134,
 43547,
 -60447,
 333404329,
 43548,
 -1,
 333452660,
 43546,
 333648870,
 333329952,
 -1,
 -60444,
 333600937,
 43542,
 -60443,
 333657739,
 43545,
 -1,
 333714804,
 43541,
 333911018,
 333588086,
 -1,
 -60440,
 333863081,
 43550,
 -60439,
 333915816,
 43553,
 -1,
 333976948,
 43549,
 334173165,
 333890260,
 -1,
 -60436,
 334125225,
 43540,
 -1,
 334173556,
 43539,
 334369776,
 334149407,
 -1,
 -60433,
 334346137,
 43558,
 -1,
 334370164,
 43559,
 334566387,
 334331877,
 -1,
 -60430,
 334549006,
 43551,
 -1,
 334566772,
 43552,
 334762998,
 334524552,
 -1,
 -60427,
 334715049,
 43527,
 -1,
 334763380,
 43526,
 334959609,
 334720809,
 -1,
 -60424,
 334911657,
 43535,
 -1,
 334959988,
 43534,
 335156220,
 334910179,
 -1,
 -60421,
 335108265,
 43529,
 -1,
 335156596,
 43528,
 335352831,
 335097634,
 -1,
 -60418,
 335304873,
 43533,
 -1,
 335353204,
 43532,
 335549441,
 335287668,
 43520,
 -1,
 335503743,
 43524,
 -60414,
 335537194,
 43554,
 -60413,
 335665084,
 43557,
 -60412,
 335728202,
 43522,
 -60411,
 335784367,
 43555,
 -60410,
 335843727,
 43525,
 -60409,
 335901613,
 43556,
 -60408,
 335962495,
 43521,
 -60407,
 336025769,
 43560,
 -1,
 336085127,
 43523,
 336270358,
 331865270,
 -1,
 336335887,
 336205172,
 -1,
 -60403,
 336318026,
 43569,
 -60402,
 336355711,
 43568,
 -1,
 336401780,
 43561,
 336598033,
 336318026,
 43565,
 -1,
 336543879,
 43570,
 336729107,
 336564623,
 43567,
 -1,
 336674951,
 43566,
 336860181,
 336683391,
 43562,
 -1,
 336814463,
 43563,
 -1,
 336807201,
 43564,
 337056804,
 336214424,
 -1,
 337122330,
 337035988,
 -1,
 -60391,
 337109391,
 43602,
 -1,
 337141846,
 43603,
 337318941,
 337098527,
 -1,
 -60388,
 337276654,
 43606,
 -1,
 337333378,
 43607,
 337515552,
 337268310,
 -1,
 -60385,
 337484784,
 43604,
 -1,
 337538679,
 43605,
 -60383,
 337504149,
 43600,
 -60382,
 337679807,
 43601,
 -60381,
 337743036,
 43609,
 -1,
 337790263,
 43608,
 337974317,
 336999058,
 -1,
 338039849,
 337924146,
 -1,
 -60377,
 338004919,
 43587,
 -60376,
 338067429,
 43596,
 -1,
 338122891,
 43597,
 -60374,
 338027562,
 43571,
 -60373,
 338287920,
 43574,
 -60372,
 338340271,
 43572,
 -1,
 338391981,
 43573,
 338624511,
 337946363,
 -1,
 338629681,
 338507296,
 -1,
 -60368,
 338598755,
 43614,
 -1,
 338632256,
 43613,
 -60366,
 338611033,
 43615,
 -1,
 338804514,
 43612,
 -60364,
 331786712,
 8256,
 -1,
 338913668,
 9939,
 339088440,
 331702655,
 -1,
 -60361,
 339063866,
 9911,
 -1,
 339085790,
 9767,
 -1,
 339072461,
 9962,
 339350608,
 325088088,
 -1,
 339416143,
 339317135,
 -1,
 339481670,
 339392664,
 -1,
 339547205,
 339424802,
 -1,
 339612738,
 339526008,
 -1,
 339678272,
 339583718,
 10960,
 -1,
 339609289,
 10962,
 339869695,
 339618830,
 10959,
 -1,
 339740361,
 10961,
 339940420,
 339595924,
 10828,
 -1,
 339870068,
 10832,
 -1,
 339896919,
 10829,
 -1,
 339479551,
 8272,
 340202574,
 339423591,
 -1,
 340268106,
 340143326,
 -1,
 -60343,
 340235892,
 8754,
 -1,
 340295088,
 10561,
 -60341,
 340249136,
 8631,
 -60340,
 340432678,
 8635,
 -60339,
 340486595,
 8753,
 -1,
 340546449,
 10227,
 -1,
 340185082,
 9729,
 -1,
 339362100,
 9114,
 340857948,
 339296391,
 -1,
 340923480,
 340823849,
 -1,
 340989015,
 340896644,
 -1,
 341054550,
 340949746,
 -1,
 -60331,
 341024475,
 65098,
 -1,
 341081640,
 65102,
 -1,
 340985246,
 8452,
 -1,
 340920869,
 162,
 341382235,
 340867211,
 -1,
 -60326,
 341343255,
 184,
 -1,
 341379621,
 8373,
 -1,
 341355773,
 9907,
 341704703,
 340830548,
 -1,
 341709925,
 341613089,
 -1,
 341775457,
 341656178,
 -1,
 -60320,
 341754440,
 9876,
 -1,
 341805896,
 127370,
 341972068,
 341706298,
 -1,
 -60317,
 341933468,
 9768,
 -1,
 341995475,
 9769,
 -1,
 341928117,
 9932,
 -1,
 341694370,
 8354,
 342302301,
 32741,
 -1,
 342366592,
 342234484,
 -1,
 342431912,
 342345352,
 -1,
 342496776,
 342406943,
 -1,
 342562268,
 342433546,
 -1,
 342627681,
 342502086,
 -1,
 342693088,
 342584736,
 -1,
 342758562,
 342670732,
 -1,
 342824050,
 342728681,
 120421,
 -60304,
 342801372,
 120769,
 -60303,
 342843775,
 120761,
 -1,
 342908041,
 120767,
 343086197,
 342803156,
 120425,
 -60300,
 343039070,
 120753,
 -1,
 343090575,
 120765,
 343282809,
 343052687,
 120420,
 343408639,
 343244773,
 -1,
 -60296,
 343302923,
 120760,
 -1,
 343360672,
 120770,
 343544956,
 343228551,
 120410,
 -60293,
 343524117,
 120752,
 -1,
 343582417,
 120750,
 343741566,
 343533342,
 120431,
 -1,
 343690072,
 120751,
 343872640,
 343728900,
 120429,
 -1,
 343826815,
 120759,
 344003714,
 343854666,
 120426,
 -1,
 343975633,
 120766,
 344134788,
 343979807,
 120424,
 -1,
 344089984,
 120764,
 344265862,
 344107348,
 120423,
 -1,
 344219231,
 120762,
 344396936,
 344230111,
 120419,
 -1,
 344378954,
 120758,
 344528010,
 344358885,
 120418,
 -1,
 344510026,
 120757,
 344659084,
 344486744,
 120417,
 -1,
 344595646,
 120756,
 344790158,
 344617096,
 120416,
 -1,
 344727589,
 120755,
 344921232,
 344744319,
 120414,
 -1,
 344889990,
 120754,
 345052306,
 344871651,
 120412,
 -1,
 344988906,
 120748,
 345183380,
 345001558,
 120411,
 -1,
 345139144,
 120763,
 345314454,
 345126432,
 120409,
 -1,
 345261608,
 120749,
 345445528,
 345255134,
 120408,
 -1,
 345398409,
 120768,
 345576602,
 345384566,
 120407,
 -1,
 345525080,
 120747,
 345707676,
 345511284,
 120406,
 -1,
 345669344,
 120746,
 -60259,
 345695214,
 120430,
 -60258,
 345824520,
 120428,
 -60257,
 345888686,
 120427,
 -60256,
 345941828,
 120422,
 -60255,
 345993001,
 120415,
 -1,
 346052747,
 120413,
 346232023,
 342699485,
 -1,
 346297511,
 346211028,
 120399,
 346363046,
 346250334,
 120727,
 -1,
 346294932,
 120737,
 -1,
 346301839,
 120739,
 346559659,
 346267625,
 120395,
 -60247,
 346536924,
 120743,
 -60246,
 346579327,
 120735,
 -1,
 346643593,
 120741,
 346821807,
 346526095,
 120394,
 346947583,
 346783717,
 -1,
 -60242,
 346841867,
 120734,
 -1,
 346899616,
 120744,
 347083954,
 346767495,
 120384,
 -60239,
 347063061,
 120726,
 -1,
 347121361,
 120724,
 347280564,
 347072286,
 120405,
 -1,
 347229016,
 120725,
 347411638,
 347267844,
 120403,
 -1,
 347365759,
 120733,
 347542712,
 347393610,
 120400,
 -1,
 347514577,
 120740,
 347673786,
 347518751,
 120398,
 -1,
 347628928,
 120738,
 347804860,
 347646292,
 120397,
 -1,
 347758175,
 120736,
 347935934,
 347769055,
 120393,
 -1,
 347917898,
 120732,
 348067008,
 347897829,
 120392,
 -1,
 348048970,
 120731,
 348198082,
 348025688,
 120391,
 -1,
 348134590,
 120730,
 348329156,
 348156040,
 120390,
 -1,
 348266533,
 120729,
 348460230,
 348283263,
 120388,
 -1,
 348428934,
 120728,
 348591304,
 348410595,
 120386,
 -1,
 348527850,
 120722,
 348722378,
 348534304,
 120383,
 -1,
 348669480,
 120723,
 348853452,
 348663006,
 120382,
 -1,
 348806281,
 120742,
 348984526,
 348792438,
 120381,
 -1,
 348932952,
 120721,
 349115600,
 348919156,
 120380,
 -1,
 349077216,
 120720,
 -60207,
 349103086,
 120404,
 -60206,
 349232392,
 120402,
 -60205,
 349296558,
 120401,
 -60204,
 349349700,
 120396,
 -60203,
 349400873,
 120389,
 -60202,
 349460619,
 120387,
 -1,
 349523542,
 120385,
 349705435,
 346202089,
 -1,
 -60199,
 349659589,
 120777,
 -60198,
 349723802,
 120775,
 -1,
 349774545,
 120771,
 -60196,
 349685409,
 120773,
 -60195,
 349941230,
 120776,
 -60194,
 349997396,
 120745,
 -60193,
 350056732,
 120774,
 -1,
 350111958,
 120772,
 350295317,
 342670732,
 -1,
 350360805,
 350265321,
 120317,
 -60189,
 350338012,
 120711,
 -60188,
 350380415,
 120703,
 -1,
 350444681,
 120709,
 350622952,
 350339796,
 120321,
 -60185,
 350575710,
 120695,
 -1,
 350627215,
 120707,
 350819564,
 350589327,
 120316,
 350945279,
 350781413,
 -1,
 -60181,
 350839563,
 120702,
 -1,
 350897312,
 120712,
 351081711,
 350765191,
 120306,
 -60178,
 351060757,
 120694,
 -1,
 351119057,
 120692,
 351278321,
 351069982,
 120327,
 -1,
 351226712,
 120693,
 351409395,
 351265540,
 120325,
 -1,
 351363455,
 120701,
 351540469,
 351391306,
 120322,
 -1,
 351512273,
 120708,
 351671543,
 351516447,
 120320,
 -1,
 351626624,
 120706,
 351802617,
 351643988,
 120319,
 -1,
 351755871,
 120704,
 351933691,
 351766751,
 120315,
 -1,
 351915594,
 120700,
 352064765,
 351895525,
 120314,
 -1,
 352046666,
 120699,
 352195839,
 352023384,
 120313,
 -1,
 352132286,
 120698,
 352326913,
 352153736,
 120312,
 -1,
 352264229,
 120697,
 352457987,
 352280959,
 120310,
 -1,
 352426630,
 120696,
 352589061,
 352408291,
 120308,
 -1,
 352525546,
 120690,
 352720135,
 352538198,
 120307,
 -1,
 352675784,
 120705,
 352851209,
 352663072,
 120305,
 -1,
 352798248,
 120691,
 352982283,
 352791774,
 120304,
 -1,
 352935049,
 120710,
 353113357,
 352921206,
 120303,
 -1,
 353061720,
 120689,
 353244431,
 353047924,
 120302,
 -1,
 353205984,
 120688,
 -60144,
 353231854,
 120326,
 -60143,
 353361160,
 120324,
 -60142,
 353425326,
 120323,
 -60141,
 353478468,
 120318,
 -60140,
 353529641,
 120311,
 -1,
 353589387,
 120309,
 353768778,
 350236125,
 -1,
 353834266,
 353747668,
 120295,
 353899801,
 353786974,
 120669,
 -1,
 353831572,
 120679,
 -1,
 353838479,
 120681,
 354096414,
 353804265,
 120291,
 -60132,
 354073564,
 120685,
 -60131,
 354115967,
 120677,
 -1,
 354180233,
 120683,
 354358562,
 354062735,
 120290,
 354484223,
 354320357,
 -1,
 -60127,
 354378507,
 120676,
 -1,
 354436256,
 120686,
 354620709,
 354304135,
 120280,
 -60124,
 354599701,
 120668,
 -1,
 354658001,
 120666,
 354817319,
 354608926,
 120301,
 -1,
 354765656,
 120667,
 354948393,
 354804484,
 120299,
 -1,
 354902399,
 120675,
 355079467,
 354930250,
 120296,
 -1,
 355051217,
 120682,
 355210541,
 355055391,
 120294,
 -1,
 355165568,
 120680,
 355341615,
 355182932,
 120293,
 -1,
 355294815,
 120678,
 355472689,
 355305695,
 120289,
 -1,
 355454538,
 120674,
 355603763,
 355434469,
 120288,
 -1,
 355585610,
 120673,
 355734837,
 355562328,
 120287,
 -1,
 355671230,
 120672,
 355865911,
 355692680,
 120286,
 -1,
 355803173,
 120671,
 355996985,
 355819903,
 120284,
 -1,
 355965574,
 120670,
 356128059,
 355947235,
 120282,
 -1,
 356064490,
 120664,
 356259133,
 356070944,
 120279,
 -1,
 356206120,
 120665,
 356390207,
 356199646,
 120278,
 -1,
 356342921,
 120684,
 356521281,
 356329078,
 120277,
 -1,
 356469592,
 120663,
 356652355,
 356455796,
 120276,
 -1,
 356613856,
 120662,
 -60092,
 356639726,
 120300,
 -60091,
 356769032,
 120298,
 -60090,
 356833198,
 120297,
 -60089,
 356886340,
 120292,
 -60088,
 356937513,
 120285,
 -60087,
 356997259,
 120283,
 -1,
 357060182,
 120281,
 357242200,
 353712536,
 -1,
 357307726,
 357221076,
 -1,
 -60083,
 357294479,
 120814,
 -1,
 357326934,
 120815,
 357504337,
 357283615,
 -1,
 -60080,
 357461742,
 120818,
 -1,
 357518466,
 120819,
 357700948,
 357453398,
 -1,
 -60077,
 357669872,
 120816,
 -1,
 357723767,
 120817,
 -60075,
 357689237,
 120812,
 -60074,
 357864895,
 120813,
 -60073,
 357928124,
 120821,
 -1,
 357975351,
 120820,
 358159708,
 357212137,
 -1,
 -60070,
 358113733,
 120719,
 -60069,
 358177946,
 120717,
 -1,
 358228689,
 120713,
 -60067,
 358139553,
 120715,
 -60066,
 358395374,
 120718,
 -60065,
 358451540,
 120687,
 -60064,
 358510876,
 120716,
 -1,
 358566102,
 120714,
 358749592,
 342584736,
 -1,
 358815101,
 358727052,
 -1,
 -60060,
 358803230,
 120379,
 -60059,
 358867950,
 120378,
 -60058,
 358933252,
 120377,
 -60057,
 358997256,
 120376,
 -60056,
 359061422,
 120375,
 -60055,
 359124554,
 120374,
 -60054,
 359187156,
 120373,
 -60053,
 359249695,
 120372,
 -60052,
 359311700,
 120371,
 -60051,
 359376708,
 120370,
 -60050,
 359440361,
 120369,
 -60049,
 359502223,
 120368,
 -60048,
 359565535,
 120367,
 -60047,
 359628773,
 120366,
 -60046,
 359691096,
 120365,
 -60045,
 359755912,
 120364,
 -60044,
 359821097,
 120363,
 -60043,
 359883135,
 120362,
 -60042,
 359946379,
 120361,
 -60041,
 360010467,
 120360,
 -60040,
 360074838,
 120359,
 -60039,
 360136839,
 120358,
 -60038,
 360199712,
 120357,
 -60037,
 360262878,
 120356,
 -60036,
 360326774,
 120355,
 -1,
 360387956,
 120354,
 360644607,
 358755805,
 -1,
 -60033,
 360572702,
 120353,
 -60032,
 360637422,
 120352,
 -60031,
 360702724,
 120351,
 -60030,
 360766728,
 120350,
 -60029,
 360830894,
 120349,
 -60028,
 360894026,
 120348,
 -60027,
 360956628,
 120347,
 -60026,
 361019167,
 120346,
 -60025,
 361081172,
 120345,
 -60024,
 361146180,
 120344,
 -60023,
 361209833,
 120343,
 -60022,
 361271695,
 120342,
 -60021,
 361335007,
 120341,
 -60020,
 361398245,
 120340,
 -60019,
 361460568,
 120339,
 -60018,
 361525384,
 120338,
 -60017,
 361590569,
 120337,
 -60016,
 361652607,
 120336,
 -60015,
 361715851,
 120335,
 -60014,
 361779939,
 120334,
 -60013,
 361844310,
 120333,
 -60012,
 361906311,
 120332,
 -60011,
 361969184,
 120331,
 -60010,
 362032350,
 120330,
 -60009,
 362096246,
 120329,
 -1,
 362157428,
 120328,
 362354099,
 358727052,
 -1,
 -60006,
 362342174,
 120275,
 -60005,
 362406894,
 120274,
 -60004,
 362472196,
 120273,
 -60003,
 362536200,
 120272,
 -60002,
 362600366,
 120271,
 -60001,
 362663498,
 120270,
 -60000,
 362726100,
 120269,
 -59999,
 362788639,
 120268,
 -59998,
 362850644,
 120267,
 -59997,
 362915652,
 120266,
 -59996,
 362979305,
 120265,
 -59995,
 363041167,
 120264,
 -59994,
 363104479,
 120263,
 -59993,
 363167717,
 120262,
 -59992,
 363230040,
 120261,
 -59991,
 363294856,
 120260,
 -59990,
 363360041,
 120259,
 -59989,
 363422079,
 120258,
 -59988,
 363485323,
 120257,
 -59987,
 363549411,
 120256,
 -59986,
 363613782,
 120255,
 -59985,
 363675783,
 120254,
 -59984,
 363738656,
 120253,
 -59983,
 363801822,
 120252,
 -59982,
 363865718,
 120251,
 -1,
 363926900,
 120250,
 364123598,
 362294749,
 -1,
 -59979,
 364111646,
 120249,
 -59978,
 364176366,
 120248,
 -59977,
 364241668,
 120247,
 -59976,
 364305672,
 120246,
 -59975,
 364369838,
 120245,
 -59974,
 364432970,
 120244,
 -59973,
 364495572,
 120243,
 -59972,
 364558111,
 120242,
 -59971,
 364620116,
 120241,
 -59970,
 364685124,
 120240,
 -59969,
 364748777,
 120239,
 -59968,
 364810639,
 120238,
 -59967,
 364873951,
 120237,
 -59966,
 364937189,
 120236,
 -59965,
 364999512,
 120235,
 -59964,
 365064328,
 120234,
 -59963,
 365129513,
 120233,
 -59962,
 365191551,
 120232,
 -59961,
 365254795,
 120231,
 -59960,
 365318883,
 120230,
 -59959,
 365383254,
 120229,
 -59958,
 365445255,
 120228,
 -59957,
 365508128,
 120227,
 -59956,
 365571294,
 120226,
 -59955,
 365635190,
 120225,
 -1,
 365696372,
 120224,
 365953023,
 364067224,
 -1,
 365958610,
 365871828,
 -1,
 -59951,
 365945231,
 120804,
 -1,
 365977686,
 120805,
 366155221,
 365934367,
 -1,
 -59948,
 366112494,
 120808,
 -1,
 366169218,
 120809,
 366351832,
 366104150,
 -1,
 -59945,
 366320624,
 120806,
 -1,
 366374519,
 120807,
 -59943,
 366339989,
 120802,
 -59942,
 366515647,
 120803,
 -59941,
 366578876,
 120811,
 -1,
 366626103,
 120810,
 366870527,
 342504429,
 -1,
 366876149,
 366787980,
 -1,
 -59937,
 366864158,
 120015,
 -59936,
 366928878,
 120014,
 -59935,
 366994180,
 120013,
 -59934,
 367058184,
 120012,
 -59933,
 367122350,
 120011,
 -59932,
 367185482,
 120010,
 -59931,
 367248084,
 120009,
 -59930,
 367310623,
 120008,
 -59929,
 367372628,
 120007,
 -59928,
 367437636,
 120006,
 -59927,
 367501289,
 120005,
 -59926,
 367560927,
 120003,
 -59925,
 367624165,
 120002,
 -59924,
 367686488,
 120001,
 -59923,
 367751304,
 120000,
 -59922,
 367816489,
 119999,
 -59921,
 367878527,
 119998,
 -59920,
 367941771,
 119997,
 -59919,
 368004694,
 119995,
 -59918,
 368064032,
 119993,
 -59917,
 368127198,
 119992,
 -59916,
 368191094,
 119991,
 -1,
 368252276,
 119990,
 368508927,
 366816733,
 -1,
 -59913,
 368437022,
 119989,
 -59912,
 368501742,
 119988,
 -59911,
 368567044,
 119987,
 -59910,
 368631048,
 119986,
 -59909,
 368695214,
 119985,
 -59908,
 368758346,
 119984,
 -59907,
 368820948,
 119983,
 -59906,
 368883487,
 119982,
 -59905,
 368944964,
 119980,
 -59904,
 369008617,
 119979,
 -59903,
 369070479,
 119978,
 -59902,
 369133791,
 119977,
 -59901,
 369193096,
 119974,
 -59900,
 369258281,
 119973,
 -59899,
 369316579,
 119970,
 -59898,
 369374752,
 119967,
 -59897,
 369437918,
 119966,
 -1,
 369497460,
 119964,
 369694575,
 342436550,
 -1,
 369759869,
 369651104,
 -1,
 369825343,
 369737100,
 -1,
 369890831,
 369795049,
 119953,
 -59891,
 369867740,
 120653,
 -59890,
 369910143,
 120645,
 -1,
 369974409,
 120651,
 370152978,
 369869524,
 119957,
 -59887,
 370105438,
 120637,
 -1,
 370156943,
 120649,
 370349590,
 370119055,
 119952,
 370475007,
 370311141,
 -1,
 -59883,
 370369291,
 120644,
 -1,
 370427040,
 120654,
 370611737,
 370294919,
 119942,
 -59880,
 370590485,
 120636,
 -1,
 370648785,
 120634,
 370808347,
 370599710,
 119963,
 -1,
 370756440,
 120635,
 370939421,
 370795268,
 119961,
 -1,
 370893183,
 120643,
 371070495,
 370921034,
 119958,
 -1,
 371042001,
 120650,
 371201569,
 371046175,
 119956,
 -1,
 371156352,
 120648,
 371332643,
 371173716,
 119955,
 -1,
 371285599,
 120646,
 371463717,
 371296479,
 119951,
 -1,
 371445322,
 120642,
 371594791,
 371425253,
 119950,
 -1,
 371576394,
 120641,
 371725865,
 371553112,
 119949,
 -1,
 371662014,
 120640,
 371856939,
 371683464,
 119948,
 -1,
 371793957,
 120639,
 371988013,
 371810687,
 119946,
 -1,
 371956358,
 120638,
 372119087,
 371938019,
 119944,
 -1,
 372055274,
 120632,
 372250161,
 372067926,
 119943,
 -1,
 372205512,
 120647,
 372381235,
 372192800,
 119941,
 -1,
 372327976,
 120633,
 372512309,
 372321502,
 119940,
 -1,
 372464777,
 120652,
 372643383,
 372450934,
 119939,
 -1,
 372591448,
 120631,
 372774457,
 372577652,
 119938,
 -1,
 372735712,
 120630,
 -59846,
 372761582,
 119962,
 -59845,
 372890888,
 119960,
 -59844,
 372955054,
 119959,
 -59843,
 373008196,
 119954,
 -59842,
 373059369,
 119947,
 -1,
 373119115,
 119945,
 373298804,
 369765853,
 -1,
 373364292,
 373277396,
 119931,
 373429827,
 373316702,
 120611,
 -1,
 373361300,
 120621,
 -1,
 373368207,
 120623,
 373626440,
 373333993,
 119927,
 -59834,
 373603292,
 120627,
 -59833,
 373645695,
 120619,
 -1,
 373709961,
 120625,
 373888588,
 373592463,
 119926,
 374013951,
 373850085,
 -1,
 -59829,
 373908235,
 120618,
 -1,
 373965984,
 120628,
 374150735,
 373833863,
 119916,
 -59826,
 374129429,
 120610,
 -1,
 374187729,
 120608,
 374347345,
 374138654,
 119937,
 -1,
 374295384,
 120609,
 374478419,
 374334212,
 119935,
 -1,
 374432127,
 120617,
 374609493,
 374459978,
 119932,
 -1,
 374580945,
 120624,
 374740567,
 374585119,
 119930,
 -1,
 374695296,
 120622,
 374871641,
 374712660,
 119929,
 -1,
 374824543,
 120620,
 375002715,
 374835423,
 119925,
 -1,
 374984266,
 120616,
 375133789,
 374964197,
 119924,
 -1,
 375115338,
 120615,
 375264863,
 375092056,
 119923,
 -1,
 375200958,
 120614,
 375395937,
 375222408,
 119922,
 -1,
 375332901,
 120613,
 375527011,
 375349631,
 119920,
 -1,
 375495302,
 120612,
 375658085,
 375476963,
 119918,
 -1,
 375594218,
 120606,
 375789159,
 375600672,
 119915,
 -1,
 375735848,
 120607,
 375920233,
 375729374,
 119914,
 -1,
 375872649,
 120626,
 376051307,
 375858806,
 119913,
 -1,
 375999320,
 120605,
 376182381,
 375985524,
 119912,
 -1,
 376143584,
 120604,
 -59794,
 376169454,
 119936,
 -59793,
 376298760,
 119934,
 -59792,
 376362926,
 119933,
 -59791,
 376416068,
 119928,
 -59790,
 376467241,
 119921,
 -59789,
 376526987,
 119919,
 -1,
 376589910,
 119917,
 376772216,
 373268457,
 -1,
 -59786,
 376725957,
 120661,
 -59785,
 376790170,
 120659,
 -1,
 376840913,
 120655,
 -59783,
 376751777,
 120657,
 -59782,
 377007598,
 120660,
 -59781,
 377063764,
 120629,
 -59780,
 377123100,
 120658,
 -1,
 377178326,
 120656,
 377362155,
 369735455,
 -1,
 377427636,
 377323806,
 -1,
 377493123,
 377397225,
 119849,
 -59775,
 377469916,
 120537,
 -59774,
 377512319,
 120529,
 -1,
 377576585,
 120535,
 377755270,
 377471700,
 119853,
 -59771,
 377707614,
 120521,
 -1,
 377759119,
 120533,
 377951882,
 377721231,
 119848,
 378077183,
 377913317,
 -1,
 -59767,
 377971467,
 120528,
 -1,
 378029216,
 120538,
 378214029,
 377897095,
 119838,
 -59764,
 378192661,
 120520,
 -1,
 378250961,
 120518,
 378410640,
 378156576,
 119837,
 -59761,
 378365080,
 120779,
 -1,
 378422824,
 120517,
 378607250,
 378398494,
 119859,
 -1,
 378555224,
 120519,
 378738324,
 378594052,
 119857,
 -1,
 378691967,
 120527,
 378869398,
 378719818,
 119854,
 -1,
 378840785,
 120534,
 379000472,
 378844959,
 119852,
 -1,
 378955136,
 120532,
 379131546,
 378972500,
 119851,
 -1,
 379084383,
 120530,
 379262620,
 379095263,
 119847,
 -1,
 379244106,
 120526,
 379393694,
 379224037,
 119846,
 -1,
 379375178,
 120525,
 379524768,
 379351896,
 119845,
 -1,
 379460798,
 120524,
 379655842,
 379482248,
 119844,
 -1,
 379592741,
 120523,
 379786916,
 379609471,
 119842,
 -1,
 379755142,
 120522,
 379917990,
 379736803,
 119840,
 -1,
 379854058,
 120516,
 380049064,
 379866710,
 119839,
 -1,
 380004296,
 120531,
 380180138,
 379989214,
 119836,
 -1,
 380132489,
 120536,
 380311212,
 380118646,
 119835,
 -1,
 380259160,
 120515,
 380442286,
 380245364,
 119834,
 -1,
 380403424,
 120514,
 -59729,
 380429294,
 119858,
 -59728,
 380558600,
 119856,
 -59727,
 380622766,
 119855,
 -59726,
 380675908,
 119850,
 -59725,
 380727081,
 119843,
 -1,
 380786827,
 119841,
 381026303,
 377369581,
 -1,
 381032144,
 380943756,
 -1,
 -59721,
 381019934,
 120067,
 -59720,
 381084654,
 120066,
 -59719,
 381149956,
 120065,
 -59718,
 381213960,
 120064,
 -59717,
 381278126,
 120063,
 -59716,
 381341258,
 120062,
 -59715,
 381403860,
 120061,
 -59714,
 381466399,
 120060,
 -59713,
 381528404,
 120059,
 -59712,
 381593412,
 120058,
 -59711,
 381657065,
 120057,
 -59710,
 381718927,
 120056,
 -59709,
 381782239,
 120055,
 -59708,
 381845477,
 120054,
 -59707,
 381907800,
 120053,
 -59706,
 381972616,
 120052,
 -59705,
 382037801,
 120051,
 -59704,
 382099839,
 120050,
 -59703,
 382163083,
 120049,
 -59702,
 382227171,
 120048,
 -59701,
 382291542,
 120047,
 -59700,
 382353543,
 120046,
 -59699,
 382416416,
 120045,
 -59698,
 382479582,
 120044,
 -59697,
 382543478,
 120043,
 -1,
 382604660,
 120042,
 382861311,
 380972509,
 -1,
 -59694,
 382789406,
 120041,
 -59693,
 382854126,
 120040,
 -59692,
 382919428,
 120039,
 -59691,
 382983432,
 120038,
 -59690,
 383047598,
 120037,
 -59689,
 383110730,
 120036,
 -59688,
 383173332,
 120035,
 -59687,
 383235871,
 120034,
 -59686,
 383297876,
 120033,
 -59685,
 383362884,
 120032,
 -59684,
 383426537,
 120031,
 -59683,
 383488399,
 120030,
 -59682,
 383551711,
 120029,
 -59681,
 383614949,
 120028,
 -59680,
 383677272,
 120027,
 -59679,
 383742088,
 120026,
 -59678,
 383807273,
 120025,
 -59677,
 383869311,
 120024,
 -59676,
 383932555,
 120023,
 -59675,
 383996643,
 120022,
 -59674,
 384061014,
 120021,
 -59673,
 384123015,
 120020,
 -59672,
 384185888,
 120019,
 -59671,
 384249054,
 120018,
 -59670,
 384312950,
 120017,
 -1,
 384374132,
 120016,
 384571170,
 377311805,
 -1,
 384636679,
 384548236,
 -1,
 -59666,
 384624414,
 120223,
 -59665,
 384689134,
 120222,
 -59664,
 384754436,
 120221,
 -59663,
 384818440,
 120220,
 -59662,
 384882606,
 120219,
 -59661,
 384945738,
 120218,
 -59660,
 385008340,
 120217,
 -59659,
 385070879,
 120216,
 -59658,
 385132884,
 120215,
 -59657,
 385197892,
 120214,
 -59656,
 385261545,
 120213,
 -59655,
 385323407,
 120212,
 -59654,
 385386719,
 120211,
 -59653,
 385449957,
 120210,
 -59652,
 385512280,
 120209,
 -59651,
 385577096,
 120208,
 -59650,
 385642281,
 120207,
 -59649,
 385704319,
 120206,
 -59648,
 385767563,
 120205,
 -59647,
 385831651,
 120204,
 -59646,
 385896022,
 120203,
 -59645,
 385958023,
 120202,
 -59644,
 386020896,
 120201,
 -59643,
 386084062,
 120200,
 -59642,
 386147958,
 120199,
 -1,
 386209140,
 120198,
 386465791,
 384576989,
 -1,
 -59639,
 386393886,
 120197,
 -59638,
 386458606,
 120196,
 -59637,
 386523908,
 120195,
 -59636,
 386587912,
 120194,
 -59635,
 386652078,
 120193,
 -59634,
 386715210,
 120192,
 -59633,
 386777812,
 120191,
 -59632,
 386840351,
 120190,
 -59631,
 386902356,
 120189,
 -59630,
 386967364,
 120188,
 -59629,
 387031017,
 120187,
 -59628,
 387092879,
 120186,
 -59627,
 387156191,
 120185,
 -59626,
 387219429,
 120184,
 -59625,
 387281752,
 120183,
 -59624,
 387346568,
 120182,
 -59623,
 387411753,
 120181,
 -59622,
 387473791,
 120180,
 -59621,
 387537035,
 120179,
 -59620,
 387601123,
 120178,
 -59619,
 387665494,
 120177,
 -59618,
 387727495,
 120176,
 -59617,
 387790368,
 120175,
 -59616,
 387853534,
 120174,
 -59615,
 387917430,
 120173,
 -1,
 387978612,
 120172,
 388175704,
 384511453,
 -1,
 388241191,
 388154068,
 119827,
 388306726,
 388193374,
 120495,
 -1,
 388237972,
 120505,
 -1,
 388244879,
 120507,
 388503339,
 388210665,
 119823,
 -59607,
 388479964,
 120511,
 -59606,
 388522367,
 120503,
 -1,
 388586633,
 120509,
 388765487,
 388469135,
 119822,
 388890623,
 388726757,
 -1,
 -59602,
 388784907,
 120502,
 -1,
 388842656,
 120512,
 389027634,
 388710535,
 119812,
 -59599,
 389006101,
 120494,
 -1,
 389064401,
 120492,
 389224245,
 388970016,
 119811,
 -59596,
 389178520,
 120778,
 -1,
 389236264,
 120491,
 389420855,
 389211934,
 119833,
 -1,
 389368664,
 120493,
 389551929,
 389407492,
 119831,
 -1,
 389505407,
 120501,
 389683003,
 389533258,
 119828,
 -1,
 389654225,
 120508,
 389814077,
 389658399,
 119826,
 -1,
 389768576,
 120506,
 389945151,
 389785940,
 119825,
 -1,
 389897823,
 120504,
 390076225,
 389908703,
 119821,
 -1,
 390057546,
 120500,
 390207299,
 390037477,
 119820,
 -1,
 390188618,
 120499,
 390338373,
 390165336,
 119819,
 -1,
 390274238,
 120498,
 390469447,
 390295688,
 119818,
 -1,
 390406181,
 120497,
 390600521,
 390422911,
 119816,
 -1,
 390568582,
 120496,
 390731595,
 390550243,
 119814,
 -1,
 390667498,
 120490,
 390862669,
 390671582,
 119810,
 -1,
 390814857,
 120510,
 390993743,
 390801014,
 119809,
 -1,
 390941528,
 120489,
 391124817,
 390927732,
 119808,
 -1,
 391085792,
 120488,
 -59566,
 391111662,
 119832,
 -59565,
 391240968,
 119830,
 -59564,
 391305134,
 119829,
 -59563,
 391358276,
 119824,
 -59562,
 391409449,
 119817,
 -59561,
 391469195,
 119815,
 -1,
 391532118,
 119813,
 391714662,
 388118936,
 -1,
 391780188,
 391693012,
 -1,
 -59557,
 391766415,
 120784,
 -1,
 391798870,
 120785,
 391976799,
 391755551,
 -1,
 -59554,
 391933678,
 120788,
 -1,
 391990402,
 120789,
 392173410,
 391925334,
 -1,
 -59551,
 392141808,
 120786,
 -1,
 392195703,
 120787,
 -59549,
 392161173,
 120782,
 -59548,
 392336831,
 120783,
 -59547,
 392400060,
 120791,
 -1,
 392447287,
 120790,
 392632170,
 391684073,
 -1,
 -59544,
 392585669,
 120545,
 -59543,
 392649882,
 120543,
 -1,
 392700625,
 120539,
 -59541,
 392611489,
 120541,
 -59540,
 392867310,
 120544,
 -59539,
 392923476,
 120513,
 -59538,
 392982812,
 120542,
 -1,
 393038038,
 120540,
 393222117,
 369651104,
 -1,
 393287591,
 393198988,
 -1,
 393353077,
 393256937,
 119901,
 -59533,
 393329628,
 120595,
 -59532,
 393372031,
 120587,
 -1,
 393436297,
 120593,
 393615226,
 393295392,
 119889,
 393680761,
 393583327,
 -1,
 -59528,
 393637673,
 120485,
 -1,
 393699711,
 120484,
 -1,
 393627176,
 120575,
 393942909,
 393593556,
 119905,
 -59524,
 393895006,
 120579,
 -1,
 393946511,
 120591,
 394139521,
 393908623,
 119900,
 394264575,
 394100709,
 -1,
 -59520,
 394158859,
 120586,
 -1,
 394216608,
 120596,
 394401668,
 394084487,
 119890,
 -59517,
 394380053,
 120578,
 -1,
 394438353,
 120576,
 394598278,
 394389278,
 119911,
 -1,
 394546008,
 120577,
 394729352,
 394584836,
 119909,
 -1,
 394682751,
 120585,
 394860426,
 394710602,
 119906,
 -1,
 394831569,
 120592,
 394991500,
 394835743,
 119904,
 -1,
 394945920,
 120590,
 395122574,
 394963284,
 119903,
 -1,
 395075167,
 120588,
 395253648,
 395086047,
 119899,
 -1,
 395234890,
 120584,
 395384722,
 395214821,
 119898,
 -1,
 395365962,
 120583,
 395515796,
 395342680,
 119897,
 -1,
 395451582,
 120582,
 395646870,
 395473032,
 119896,
 -1,
 395583525,
 120581,
 395777944,
 395600255,
 119894,
 -1,
 395745926,
 120580,
 395909018,
 395727587,
 119892,
 -1,
 395844842,
 120574,
 396040092,
 395857494,
 119891,
 -1,
 395995080,
 120589,
 396171166,
 395979998,
 119888,
 -1,
 396123273,
 120594,
 396302240,
 396109430,
 119887,
 -1,
 396249944,
 120573,
 396433314,
 396236148,
 119886,
 -1,
 396394208,
 120572,
 -59485,
 396420078,
 119910,
 -59484,
 396549384,
 119908,
 -59483,
 396613550,
 119907,
 -59482,
 396666692,
 119902,
 -1,
 396717865,
 119895,
 396892124,
 393227741,
 -1,
 396957612,
 396870356,
 119879,
 397023147,
 396909662,
 120553,
 -1,
 396954260,
 120563,
 -1,
 396961167,
 120565,
 397219760,
 396926953,
 119875,
 -59474,
 397196252,
 120569,
 -59473,
 397238655,
 120561,
 -1,
 397302921,
 120567,
 397481908,
 397185423,
 119874,
 397606911,
 397443045,
 -1,
 -59469,
 397501195,
 120560,
 -1,
 397558944,
 120570,
 397744055,
 397426823,
 119864,
 -59466,
 397722389,
 120552,
 -1,
 397780689,
 120550,
 397940665,
 397731614,
 119885,
 -1,
 397888344,
 120551,
 398071739,
 397927172,
 119883,
 -1,
 398025087,
 120559,
 398202813,
 398052938,
 119880,
 -1,
 398173905,
 120566,
 398333887,
 398178079,
 119878,
 -1,
 398288256,
 120564,
 398464961,
 398305620,
 119877,
 -1,
 398417503,
 120562,
 398596035,
 398428383,
 119873,
 -1,
 398577226,
 120558,
 398727109,
 398557157,
 119872,
 -1,
 398708298,
 120557,
 398858183,
 398685016,
 119871,
 -1,
 398793918,
 120556,
 398989257,
 398815368,
 119870,
 -1,
 398925861,
 120555,
 399120331,
 398942591,
 119868,
 -1,
 399088262,
 120554,
 399251405,
 399069923,
 119866,
 -1,
 399187178,
 120548,
 399382479,
 399193632,
 119863,
 -1,
 399328808,
 120549,
 399513553,
 399322334,
 119862,
 -1,
 399465609,
 120568,
 399644627,
 399451766,
 119861,
 -1,
 399592280,
 120547,
 399775701,
 399578484,
 119860,
 -1,
 399736544,
 120546,
 -59434,
 399762414,
 119884,
 -59433,
 399891720,
 119882,
 -59432,
 399955886,
 119881,
 -59431,
 400009028,
 119876,
 -59430,
 400060201,
 119869,
 -59429,
 400119947,
 119867,
 -1,
 400182870,
 119865,
 400365536,
 396861417,
 -1,
 -59426,
 400318917,
 120603,
 -59425,
 400383130,
 120601,
 -1,
 400433873,
 120597,
 -59423,
 400344737,
 120599,
 -59422,
 400600558,
 120602,
 -59421,
 400656724,
 120571,
 -59420,
 400716060,
 120600,
 -1,
 400771286,
 120598,
 400955434,
 393185023,
 -1,
 401020929,
 400932236,
 -1,
 -59416,
 401008414,
 120483,
 -59415,
 401073134,
 120482,
 -59414,
 401138436,
 120481,
 -59413,
 401202440,
 120480,
 -59412,
 401266606,
 120479,
 -59411,
 401329738,
 120478,
 -59410,
 401392340,
 120477,
 -59409,
 401454879,
 120476,
 -59408,
 401516884,
 120475,
 -59407,
 401581892,
 120474,
 -59406,
 401645545,
 120473,
 -59405,
 401707407,
 120472,
 -59404,
 401770719,
 120471,
 -59403,
 401833957,
 120470,
 -59402,
 401896280,
 120469,
 -59401,
 401961096,
 120468,
 -59400,
 402026281,
 120467,
 -59399,
 402088319,
 120466,
 -59398,
 402151563,
 120465,
 -59397,
 402215651,
 120464,
 -59396,
 402280022,
 120463,
 -59395,
 402342023,
 120462,
 -59394,
 402404896,
 120461,
 -59393,
 402468062,
 120460,
 -59392,
 402531958,
 120459,
 -1,
 402593140,
 120458,
 402790428,
 400960989,
 -1,
 -59389,
 402777886,
 120457,
 -59388,
 402842606,
 120456,
 -59387,
 402907908,
 120455,
 -59386,
 402971912,
 120454,
 -59385,
 403036078,
 120453,
 -59384,
 403099210,
 120452,
 -59383,
 403161812,
 120451,
 -59382,
 403224351,
 120450,
 -59381,
 403286356,
 120449,
 -59380,
 403351364,
 120448,
 -59379,
 403415017,
 120447,
 -59378,
 403476879,
 120446,
 -59377,
 403540191,
 120445,
 -59376,
 403603429,
 120444,
 -59375,
 403665752,
 120443,
 -59374,
 403730568,
 120442,
 -59373,
 403795753,
 120441,
 -59372,
 403857791,
 120440,
 -59371,
 403921035,
 120439,
 -59370,
 403985123,
 120438,
 -59369,
 404049494,
 120437,
 -59368,
 404111495,
 120436,
 -59367,
 404174368,
 120435,
 -59366,
 404237534,
 120434,
 -59365,
 404301430,
 120433,
 -1,
 404362612,
 120432,
 404619263,
 402733464,
 -1,
 404625440,
 404538068,
 -1,
 -59361,
 404611471,
 120824,
 -1,
 404643926,
 120825,
 404822051,
 404600607,
 -1,
 -59358,
 404778734,
 120828,
 -1,
 404835458,
 120829,
 405018662,
 404770390,
 -1,
 -59355,
 404986864,
 120826,
 -1,
 405040759,
 120827,
 -59353,
 405006229,
 120822,
 -59352,
 405181887,
 120823,
 -59351,
 405245116,
 120831,
 -1,
 405292343,
 120830,
 405477480,
 400899603,
 -1,
 405542982,
 405454220,
 -1,
 -59347,
 405530398,
 120171,
 -59346,
 405595118,
 120170,
 -59345,
 405660420,
 120169,
 -59344,
 405724424,
 120168,
 -59343,
 405788590,
 120167,
 -59342,
 405851722,
 120166,
 -59341,
 405914324,
 120165,
 -59340,
 405976863,
 120164,
 -59339,
 406038868,
 120163,
 -59338,
 406103876,
 120162,
 -59337,
 406167529,
 120161,
 -59336,
 406229391,
 120160,
 -59335,
 406292703,
 120159,
 -59334,
 406355941,
 120158,
 -59333,
 406418264,
 120157,
 -59332,
 406483080,
 120156,
 -59331,
 406548265,
 120155,
 -59330,
 406610303,
 120154,
 -59329,
 406673547,
 120153,
 -59328,
 406737635,
 120152,
 -59327,
 406802006,
 120151,
 -59326,
 406864007,
 120150,
 -59325,
 406926880,
 120149,
 -59324,
 406990046,
 120148,
 -59323,
 407053942,
 120147,
 -1,
 407115124,
 120146,
 407312474,
 405482973,
 -1,
 -59320,
 407299054,
 120144,
 -59319,
 407364356,
 120143,
 -59318,
 407428360,
 120142,
 -59317,
 407492526,
 120141,
 -59316,
 407555658,
 120140,
 -59315,
 407618260,
 120139,
 -59314,
 407680799,
 120138,
 -59313,
 407736719,
 120134,
 -59312,
 407797733,
 120132,
 -59311,
 407860056,
 120131,
 -59310,
 407924872,
 120130,
 -59309,
 407990057,
 120129,
 -59308,
 408052095,
 120128,
 -59307,
 408113891,
 120126,
 -59306,
 408178262,
 120125,
 -59305,
 408240263,
 120124,
 -59304,
 408303136,
 120123,
 -59303,
 408364662,
 120121,
 -1,
 408425844,
 120120,
 408682495,
 407255448,
 -1,
 408688734,
 408601300,
 -1,
 -59299,
 408674703,
 120794,
 -1,
 408707158,
 120795,
 408885345,
 408663839,
 -1,
 -59296,
 408841966,
 120798,
 -1,
 408898690,
 120799,
 409081956,
 408833622,
 -1,
 -59293,
 409050096,
 120796,
 -1,
 409103991,
 120797,
 -59291,
 409069461,
 120792,
 -59290,
 409245119,
 120793,
 -59289,
 409308348,
 120801,
 -1,
 409355575,
 120800,
 409540762,
 405426749,
 -1,
 409606276,
 409517452,
 -1,
 -59285,
 409593630,
 120119,
 -59284,
 409658350,
 120118,
 -59283,
 409723652,
 120117,
 -59282,
 409787656,
 120116,
 -59281,
 409851822,
 120115,
 -59280,
 409914954,
 120114,
 -59279,
 409977556,
 120113,
 -59278,
 410040095,
 120112,
 -59277,
 410102100,
 120111,
 -59276,
 410167108,
 120110,
 -59275,
 410230761,
 120109,
 -59274,
 410292623,
 120108,
 -59273,
 410355935,
 120107,
 -59272,
 410419173,
 120106,
 -59271,
 410481496,
 120105,
 -59270,
 410546312,
 120104,
 -59269,
 410611497,
 120103,
 -59268,
 410673535,
 120102,
 -59267,
 410736779,
 120101,
 -59266,
 410800867,
 120100,
 -59265,
 410865238,
 120099,
 -59264,
 410927239,
 120098,
 -59263,
 410990112,
 120097,
 -59262,
 411053278,
 120096,
 -59261,
 411117174,
 120095,
 -1,
 411178356,
 120094,
 411435007,
 409546205,
 -1,
 -59258,
 411362286,
 120092,
 -59257,
 411427588,
 120091,
 -59256,
 411491592,
 120090,
 -59255,
 411555758,
 120089,
 -59254,
 411618890,
 120088,
 -59253,
 411681492,
 120087,
 -59252,
 411744031,
 120086,
 -59251,
 411805508,
 120084,
 -59250,
 411869161,
 120083,
 -59249,
 411931023,
 120082,
 -59248,
 411994335,
 120081,
 -59247,
 412057573,
 120080,
 -59246,
 412119896,
 120079,
 -59245,
 412184712,
 120078,
 -59244,
 412249897,
 120077,
 -59243,
 412308195,
 120074,
 -59242,
 412372566,
 120073,
 -59241,
 412434567,
 120072,
 -59240,
 412497440,
 120071,
 -59239,
 412558966,
 120069,
 -1,
 412620148,
 120068,
 412817569,
 409513575,
 -1,
 412883102,
 412802735,
 -1,
 -59235,
 412863085,
 10221,
 -1,
 412925790,
 10215,
 -59233,
 412832045,
 10223,
 -59232,
 413023331,
 10219,
 -1,
 413081275,
 10217,
 413335551,
 412776074,
 -1,
 413341861,
 413261487,
 -1,
 -59228,
 413321837,
 10220,
 -1,
 413384542,
 10214,
 -59226,
 413290797,
 10222,
 -59225,
 413482083,
 10218,
 -1,
 413540027,
 10216,
 413735219,
 342389592,
 -1,
 413800748,
 413673031,
 -1,
 413866232,
 413759962,
 -1,
 413931702,
 413805790,
 -1,
 413997237,
 413882507,
 -1,
 414062772,
 413951572,
 -1,
 414128304,
 414025951,
 3451,
 -1,
 414091487,
 3450,
 414259378,
 414085976,
 3453,
 -1,
 414217048,
 3454,
 -59213,
 414233957,
 3452,
 -1,
 414347400,
 3455,
 -1,
 413996404,
 3355,
 -1,
 413930868,
 3354,
 414652605,
 413915054,
 -1,
 414718140,
 414618197,
 -1,
 414783674,
 414689620,
 3339,
 -1,
 414755156,
 3424,
 414973951,
 414741336,
 3340,
 -1,
 414872408,
 3425,
 -1,
 414651764,
 3381,
 415111363,
 414630612,
 -1,
 415176897,
 415089364,
 -1,
 -59200,
 415127721,
 3360,
 -1,
 415176052,
 3359,
 -59198,
 415127721,
 3365,
 -1,
 415307124,
 3364,
 415504584,
 415074527,
 -1,
 -59195,
 415491114,
 3358,
 -59194,
 415533371,
 3363,
 -59193,
 415585028,
 3353,
 -1,
 415634804,
 3368,
 415832270,
 415446560,
 -1,
 415897804,
 415774240,
 -1,
 -59189,
 415848617,
 3362,
 -1,
 415896948,
 3361,
 -59187,
 415848617,
 3367,
 -1,
 416028020,
 3366,
 416225490,
 415765876,
 3333,
 -59184,
 416206410,
 3348,
 -59183,
 416244095,
 3344,
 -1,
 416290164,
 3334,
 416487638,
 416200479,
 -1,
 -59180,
 416462745,
 3383,
 -59179,
 416503977,
 3382,
 -1,
 416552308,
 3384,
 416749787,
 416445272,
 -1,
 416815322,
 416707416,
 -1,
 -59175,
 416773037,
 3380,
 -1,
 416814452,
 3379,
 -1,
 416748916,
 3378,
 417077469,
 416730698,
 3337,
 -1,
 417058378,
 3338,
 417208544,
 417048916,
 -1,
 -59169,
 417180079,
 3377,
 -1,
 417207668,
 3376,
 417405155,
 417177577,
 -1,
 -59166,
 417355945,
 3371,
 -1,
 417404276,
 3370,
 417601765,
 417370511,
 3346,
 -1,
 417567119,
 3347,
 417732840,
 417558664,
 -1,
 -59161,
 417683625,
 3350,
 -1,
 417731956,
 3349,
 417929451,
 417689385,
 -1,
 -59158,
 417880233,
 3357,
 -1,
 417928564,
 3356,
 418126061,
 417882495,
 3335,
 -1,
 418079103,
 3336,
 418257136,
 418075363,
 -1,
 -59153,
 418207913,
 3352,
 -1,
 418256244,
 3351,
 418453746,
 418201735,
 3342,
 -1,
 418398343,
 3343,
 418584821,
 418391670,
 -1,
 -59148,
 418535593,
 3373,
 -1,
 418583924,
 3372,
 -59146,
 418571306,
 3375,
 -59145,
 418742322,
 3374,
 -1,
 418797737,
 3385,
 418978058,
 413850806,
 -1,
 419043582,
 418962447,
 -1,
 419109116,
 419014996,
 3395,
 -1,
 419080532,
 3396,
 419299327,
 419066712,
 3426,
 -1,
 419197784,
 3427,
 419371266,
 418977140,
 -1,
 -59136,
 419352138,
 3404,
 -59135,
 419389823,
 3400,
 -1,
 419435892,
 3390,
 419633412,
 419352138,
 3393,
 -1,
 419614282,
 3394,
 419764486,
 419598735,
 3402,
 -1,
 419729807,
 3403,
 419895560,
 419717503,
 3391,
 -1,
 419848575,
 3392,
 420085759,
 419840135,
 3398,
 -1,
 419971207,
 3399,
 420157722,
 418919968,
 -1,
 420223257,
 420111738,
 -1,
 420288783,
 420201172,
 -1,
 -59122,
 420274575,
 3432,
 -1,
 420307030,
 3433,
 420485394,
 420263711,
 -1,
 -59119,
 420441838,
 3436,
 -1,
 420498562,
 3437,
 420682005,
 420433494,
 -1,
 -59116,
 420649968,
 3434,
 -1,
 420703863,
 3435,
 -59114,
 420669333,
 3430,
 -59113,
 420844991,
 3431,
 -59112,
 420908220,
 3439,
 -1,
 420955447,
 3438,
 -1,
 420160673,
 3449,
 421206305,
 420133936,
 -1,
 421271838,
 421190501,
 -1,
 -59107,
 421247013,
 3331,
 -1,
 421309069,
 3405,
 421527551,
 421205364,
 -1,
 -59104,
 421451717,
 3389,
 -1,
 421499077,
 3330,
 421665062,
 421171263,
 -1,
 421730597,
 421631427,
 -1,
 -59100,
 421709597,
 3442,
 -1,
 421749015,
 3441,
 -1,
 421709094,
 3440,
 421992747,
 421614115,
 -1,
 422058282,
 421959107,
 -1,
 -59095,
 422029397,
 3443,
 -1,
 422074763,
 3444,
 -1,
 422037374,
 3445,
 -1,
 421930386,
 3415,
 422385970,
 413745289,
 -1,
 422451504,
 422371524,
 -1,
 -59089,
 422427691,
 9894,
 -1,
 422452662,
 9895,
 -59087,
 422427691,
 9794,
 -1,
 422583687,
 9893,
 -1,
 422364644,
 10016,
 422844794,
 413687344,
 -1,
 422910274,
 422819615,
 -1,
 422975802,
 422866677,
 -1,
 423041337,
 422915294,
 -1,
 -59080,
 422997058,
 127006,
 -1,
 423058080,
 126988,
 -1,
 422979370,
 126997,
 423303487,
 422923405,
 -1,
 423369022,
 423242974,
 -1,
 -59075,
 423324738,
 127007,
 -1,
 423385760,
 126989,
 -1,
 423307050,
 126998,
 -59072,
 423285193,
 127015,
 -59071,
 423601777,
 127014,
 -1,
 423664856,
 126977,
 423827789,
 422888148,
 -1,
 423893320,
 423813729,
 -1,
 423958855,
 423832798,
 -1,
 -59066,
 423914562,
 127002,
 -1,
 423975584,
 126984,
 -1,
 423896874,
 126993,
 424280063,
 423846097,
 -1,
 424286540,
 424160478,
 -1,
 -59061,
 424242242,
 127003,
 -1,
 424303264,
 126985,
 -1,
 424224554,
 126994,
 424548696,
 423775830,
 -1,
 424614227,
 424516684,
 -1,
 424679762,
 424553694,
 -1,
 -59055,
 424635458,
 127004,
 -1,
 424696480,
 126986,
 -1,
 424617770,
 126995,
 425000959,
 424570526,
 -1,
 425007447,
 424881374,
 -1,
 -59050,
 424963138,
 127005,
 -1,
 425024160,
 126987,
 -1,
 424945450,
 126996,
 425269599,
 424513935,
 -1,
 425335134,
 425233199,
 -1,
 425400669,
 425274590,
 -1,
 -59044,
 425356354,
 127001,
 -1,
 425417376,
 126983,
 -1,
 425338666,
 126992,
 -1,
 425306946,
 127011,
 425728358,
 425232607,
 -1,
 425793893,
 425683056,
 -1,
 425859428,
 425733342,
 -1,
 -59037,
 425815106,
 127009,
 -1,
 425876128,
 126991,
 -1,
 425797418,
 127000,
 -1,
 425761199,
 126979,
 426187117,
 425672839,
 -1,
 426252652,
 426140920,
 -1,
 426318187,
 426192094,
 -1,
 -59030,
 426273858,
 127008,
 -1,
 426334880,
 126990,
 -1,
 426256170,
 126999,
 -1,
 426189808,
 126976,
 426645873,
 426171656,
 -1,
 -59025,
 426600951,
 127017,
 -59024,
 426663432,
 126982,
 -1,
 426724103,
 126978,
 426908020,
 426583720,
 -1,
 -59021,
 426869508,
 127012,
 -1,
 426914085,
 127019,
 -59019,
 426880069,
 126980,
 -59018,
 427074631,
 127010,
 -59017,
 427126835,
 127018,
 -59016,
 427186129,
 126981,
 -59015,
 427241468,
 127013,
 -1,
 427304398,
 127016,
 427497853,
 422819615,
 -1,
 -59012,
 427478621,
 12348,
 -1,
 427505015,
 186,
 -59010,
 427472280,
 9901,
 -59009,
 427663404,
 9967,
 -1,
 427701273,
 175,
 427891551,
 342331791,
 -1,
 427956882,
 427832864,
 -1,
 428022416,
 427910235,
 -1,
 428087783,
 427996959,
 -1,
 428153313,
 428048670,
 -1,
 428218773,
 428131028,
 7511,
 428284306,
 428201476,
 -1,
 428349834,
 428217716,
 7492,
 -58999,
 428310240,
 7579,
 -1,
 428359815,
 7494,
 428546444,
 428321108,
 692,
 -1,
 428477814,
 693,
 428677518,
 428507109,
 7514,
 -1,
 428608969,
 7597,
 -58993,
 428660654,
 7610,
 -58992,
 428775231,
 7500,
 -58991,
 428827007,
 7502,
 -1,
 428890251,
 7587,
 -58989,
 428250863,
 7508,
 -58988,
 429022302,
 7615,
 -1,
 429067762,
 7605,
 429267359,
 428158174,
 7580,
 429332893,
 429203413,
 -1,
 429398426,
 429285759,
 7590,
 -58983,
 429363468,
 694,
 -1,
 429395551,
 7591,
 -58981,
 429379146,
 7608,
 -58980,
 429557983,
 7600,
 -1,
 429618008,
 7595,
 -58978,
 429284489,
 7521,
 -1,
 429722795,
 7581,
 429922725,
 429242143,
 738,
 429988259,
 429862110,
 -1,
 -58974,
 429961882,
 7586,
 -1,
 430006605,
 7498,
 -58972,
 429941765,
 7513,
 -1,
 430116214,
 7603,
 430315946,
 429867143,
 7497,
 -58969,
 430303185,
 7614,
 -58968,
 430360079,
 7582,
 -58967,
 430422547,
 7604,
 -1,
 430476215,
 7505,
 430643631,
 430265059,
 7501,
 430709166,
 430615701,
 -1,
 -58963,
 430678879,
 7520,
 -1,
 430723946,
 7518,
 -1,
 430644458,
 736,
 430971315,
 430581366,
 7495,
 -58959,
 430938911,
 7509,
 -58958,
 430984024,
 7517,
 -1,
 431039059,
 7601,
 431233463,
 430958366,
 7611,
 431357951,
 431164451,
 -1,
 -58954,
 431271207,
 7612,
 -1,
 431306128,
 7613,
 431495610,
 431214154,
 7512,
 -58951,
 431466193,
 7607,
 -1,
 431489552,
 7606,
 431692222,
 431466836,
 691,
 431816703,
 431639794,
 -1,
 -58947,
 431724351,
 7583,
 -1,
 431773162,
 740,
 431954370,
 431657359,
 7506,
 432078847,
 431923714,
 -1,
 -58943,
 431985039,
 7507,
 -1,
 432029831,
 7499,
 432216518,
 431911768,
 737,
 432340991,
 432147491,
 -1,
 -58939,
 432254247,
 7593,
 -1,
 432316575,
 7594,
 432478665,
 432158240,
 7496,
 -58936,
 432446202,
 7585,
 -1,
 432490024,
 7519,
 432675276,
 432412020,
 7491,
 -58933,
 432635616,
 7493,
 -1,
 432695088,
 7516,
 432871886,
 432658350,
 7515,
 -1,
 432803190,
 7609,
 433002960,
 432840681,
 7510,
 -1,
 432954505,
 7602,
 433134035,
 432965899,
 -1,
 -58926,
 433106215,
 7599,
 -1,
 433157959,
 7598,
 433330645,
 433094629,
 7504,
 -1,
 433261942,
 7596,
 433461719,
 433286953,
 690,
 -1,
 433392792,
 7592,
 433592794,
 433414527,
 -1,
 -58919,
 433560198,
 7589,
 -1,
 433589855,
 7588,
 433789404,
 433543307,
 688,
 -1,
 433720694,
 689,
 -58915,
 433775598,
 696,
 -58914,
 433906436,
 739,
 -58913,
 433970440,
 695,
 -58912,
 434008200,
 7503,
 -1,
 434064982,
 7584,
 434248164,
 428133071,
 -1,
 -58909,
 434208337,
 42785,
 -1,
 434265393,
 42784,
 434503679,
 434198667,
 -1,
 -58906,
 434411935,
 42890,
 -1,
 434456044,
 765,
 434641428,
 428027102,
 -1,
 434706946,
 434577365,
 -1,
 434772461,
 434678100,
 7487,
 434896895,
 434719986,
 -1,
 -58900,
 434800863,
 7483,
 -1,
 434847879,
 7474,
 435034607,
 434737551,
 7484,
 -1,
 435015242,
 7485,
 435165681,
 434972278,
 7470,
 -1,
 435102283,
 7471,
 435296755,
 435098996,
 7468,
 -1,
 435241095,
 7469,
 -58892,
 435281160,
 7490,
 -58891,
 435410862,
 11389,
 -58890,
 435473994,
 7489,
 -58889,
 435536596,
 7488,
 -58888,
 435593193,
 7486,
 -58887,
 435652831,
 7482,
 -58886,
 435716069,
 7481,
 -58885,
 435778392,
 7480,
 -58884,
 435843208,
 7479,
 -58883,
 435908393,
 7478,
 -58882,
 435970431,
 7477,
 -58881,
 436033675,
 7476,
 -58880,
 436097763,
 7475,
 -58879,
 436158599,
 7473,
 -1,
 436221472,
 7472,
 436410893,
 434658703,
 -1,
 436476424,
 436365107,
 -1,
 -58875,
 436452002,
 42754,
 -58874,
 436516458,
 42758,
 -58873,
 436578241,
 42756,
 -1,
 436642741,
 42752,
 436862975,
 436412004,
 -1,
 -58870,
 436779682,
 42755,
 -58869,
 436844138,
 42759,
 -58868,
 436905921,
 42757,
 -1,
 436970421,
 42753,
 437131792,
 436357191,
 -1,
 -58865,
 437104455,
 722,
 -1,
 437155616,
 723,
 -58863,
 437118665,
 7544,
 -58862,
 437302412,
 735,
 -58861,
 437359777,
 42889,
 -1,
 437414995,
 710,
 437590577,
 434598744,
 -1,
 437656110,
 437559021,
 -1,
 437721645,
 437583872,
 -1,
 437787163,
 437679749,
 -1,
 437852698,
 437715434,
 767,
 -1,
 437803830,
 753,
 -1,
 437784931,
 42773,
 438049312,
 437729988,
 -1,
 438114847,
 438029346,
 -1,
 -58850,
 438094268,
 42763,
 -1,
 438138924,
 42768,
 -1,
 438100318,
 751,
 438376995,
 438026964,
 -1,
 -58846,
 438343112,
 744,
 -1,
 438396415,
 759,
 438573606,
 438349305,
 -1,
 -58843,
 438537143,
 755,
 -1,
 438588642,
 754,
 -58841,
 438557427,
 716,
 -58840,
 438752046,
 752,
 -58839,
 438796347,
 717,
 -58838,
 438856467,
 42783,
 -58837,
 438916811,
 718,
 -58836,
 438972625,
 42888,
 -1,
 439031719,
 719,
 -1,
 437668198,
 42778,
 439353343,
 437601182,
 -1,
 -58832,
 439245268,
 703,
 -1,
 439296674,
 706,
 439491135,
 437561684,
 -1,
 439556664,
 439425406,
 -1,
 -58828,
 439538469,
 42779,
 -58827,
 439577363,
 42782,
 -58826,
 439635322,
 42781,
 -58825,
 439696984,
 42780,
 -1,
 439759339,
 760,
 439949883,
 439510248,
 -1,
 -58822,
 439900628,
 702,
 -1,
 439952034,
 707,
 440146494,
 439897330,
 -1,
 -58819,
 440096234,
 705,
 -1,
 440152591,
 701,
 -1,
 440098810,
 734,
 440408656,
 439435399,
 -1,
 440474189,
 440394724,
 -1,
 440539719,
 440434211,
 -1,
 440605253,
 440482791,
 -1,
 -58812,
 440584636,
 42764,
 -1,
 440629292,
 42769,
 -58810,
 440584636,
 745,
 -1,
 440760364,
 42774,
 440991743,
 440491247,
 -1,
 440998475,
 440876007,
 -1,
 -58806,
 440977852,
 42760,
 -1,
 441022508,
 42765,
 -58804,
 440977852,
 741,
 -1,
 441153580,
 42770,
 441384959,
 440437344,
 -1,
 -58801,
 441286225,
 764,
 -1,
 441343281,
 762,
 441522784,
 440369125,
 -1,
 441588319,
 441475455,
 -1,
 441653854,
 441529888,
 -1,
 441719385,
 441581568,
 -1,
 441784919,
 441662439,
 -1,
 -58794,
 441764284,
 42762,
 -1,
 441808940,
 42767,
 -58792,
 441764284,
 743,
 -1,
 441940012,
 42772,
 442171391,
 441662131,
 -1,
 442178141,
 442055759,
 -1,
 -58788,
 442128075,
 757,
 -1,
 442177447,
 758,
 -1,
 442128075,
 756,
 -1,
 441618620,
 727,
 -1,
 441522063,
 713,
 442571371,
 441465540,
 -1,
 442636901,
 442548950,
 -1,
 -58781,
 442620508,
 42775,
 -58780,
 442678653,
 42776,
 -1,
 442719960,
 42777,
 442899048,
 442622289,
 -1,
 -58777,
 442876761,
 725,
 -1,
 442901154,
 709,
 443154431,
 442879785,
 -1,
 -58774,
 443065963,
 698,
 -1,
 443097114,
 750,
 443292275,
 442521739,
 -1,
 443357810,
 443245780,
 -1,
 443423344,
 443300839,
 -1,
 -58769,
 443402684,
 42761,
 -1,
 443447340,
 42766,
 -58767,
 443402684,
 742,
 -1,
 443578412,
 42771,
 -1,
 443292515,
 721,
 443816569,
 443272778,
 -1,
 443882103,
 443785195,
 -1,
 -58762,
 443859801,
 724,
 -1,
 443884194,
 708,
 -58760,
 443856671,
 42864,
 -1,
 444041675,
 749,
 444209789,
 443765475,
 -1,
 -58757,
 444181257,
 715,
 -58756,
 444235272,
 704,
 -1,
 444287107,
 4348,
 444471936,
 444195822,
 -1,
 -58753,
 444426059,
 746,
 -1,
 444472937,
 747,
 444668547,
 444454830,
 -1,
 -58750,
 444634002,
 748,
 -1,
 444680736,
 712,
 444865158,
 444646100,
 -1,
 -58747,
 444847627,
 699,
 -1,
 444902959,
 720,
 445061769,
 444833769,
 -1,
 -58744,
 445034907,
 697,
 -1,
 445087606,
 726,
 445258380,
 444999730,
 -1,
 -58741,
 445218385,
 763,
 -1,
 445275441,
 761,
 445454991,
 445191540,
 -1,
 -58738,
 445425008,
 700,
 -1,
 445462011,
 714,
 -1,
 445421389,
 766,
 -58735,
 428003628,
 10762,
 -1,
 445662741,
 8871,
 445848414,
 427919583,
 -1,
 445913943,
 445797938,
 -1,
 445979445,
 445872602,
 -1,
 446044858,
 445956820,
 -1,
 446110392,
 446010064,
 -1,
 446175900,
 446043508,
 -1,
 446241435,
 446134899,
 -1,
 -58726,
 446228447,
 6297,
 -1,
 446284565,
 6296,
 -1,
 446204855,
 6218,
 446503582,
 446156362,
 6215,
 -1,
 446447751,
 6217,
 446634657,
 446481108,
 -1,
 -58720,
 446609305,
 6228,
 -1,
 446633332,
 6224,
 446831267,
 446599567,
 6214,
 -1,
 446775431,
 6216,
 446962342,
 446787369,
 -1,
 -58715,
 446915078,
 6234,
 -1,
 446961012,
 6227,
 447158952,
 446911236,
 6222,
 -1,
 447092084,
 6232,
 447290027,
 447100448,
 -1,
 -58710,
 447276848,
 6236,
 -1,
 447288692,
 6225,
 -58708,
 447276074,
 6229,
 -58707,
 447470896,
 6230,
 -58706,
 447522634,
 6221,
 -58705,
 447586382,
 6220,
 -58704,
 447646847,
 6235,
 -58703,
 447709234,
 6223,
 -58702,
 447774074,
 6211,
 -58701,
 447836319,
 6231,
 -58700,
 447897983,
 6213,
 -58699,
 447961260,
 6233,
 -58698,
 448020615,
 6212,
 -58697,
 448081705,
 6226,
 -1,
 448145064,
 6219,
 -58695,
 446085017,
 6204,
 -1,
 448271732,
 6194,
 448469727,
 445977972,
 6176,
 448535262,
 448428659,
 -1,
 448600770,
 448512724,
 -1,
 448666304,
 448578260,
 -1,
 -58689,
 448616617,
 6285,
 -1,
 448664948,
 6284,
 -58687,
 448618604,
 6278,
 -1,
 448796020,
 6288,
 448993991,
 448542240,
 -1,
 449059526,
 448927092,
 6289,
 -58683,
 449020560,
 6274,
 -1,
 449073997,
 6313,
 -1,
 449001099,
 6286,
 449321674,
 448927092,
 6279,
 -58679,
 449286358,
 6272,
 -1,
 449337483,
 6295,
 449518285,
 449308446,
 -1,
 -58676,
 449468585,
 6293,
 -1,
 449516916,
 6294,
 449714896,
 449486825,
 -1,
 -58673,
 449665193,
 6291,
 -1,
 449713524,
 6290,
 449911507,
 449677535,
 -1,
 -58670,
 449874235,
 6287,
 -1,
 449925892,
 6282,
 450108117,
 449864063,
 6280,
 -1,
 450072854,
 6276,
 450239192,
 450058640,
 -1,
 -58665,
 450225194,
 6311,
 -1,
 450285130,
 6310,
 -58663,
 450223078,
 6273,
 -58662,
 450416369,
 6275,
 -58661,
 450478016,
 6292,
 -58660,
 450523295,
 6281,
 -58659,
 450571579,
 6283,
 -1,
 450635555,
 6277,
 -1,
 448498615,
 6185,
 450894587,
 448444191,
 -1,
 450960121,
 450847444,
 -1,
 451025636,
 450946846,
 -1,
 -58653,
 450975913,
 6258,
 -1,
 451024244,
 6255,
 451222246,
 451006026,
 6241,
 -1,
 451166343,
 6240,
 451353321,
 451199700,
 -1,
 -58648,
 451327897,
 6254,
 -1,
 451351924,
 6248,
 451549931,
 451305855,
 6238,
 -1,
 451535854,
 6239,
 451681005,
 451500201,
 6245,
 -1,
 451614068,
 6253,
 451812079,
 451629828,
 6244,
 -1,
 451745140,
 6252,
 -58640,
 451787346,
 6247,
 -58639,
 451914178,
 6256,
 -58638,
 451977294,
 6246,
 -58637,
 452030623,
 6243,
 -58636,
 452095787,
 6250,
 -58635,
 452153023,
 6251,
 -58634,
 452214919,
 6237,
 -58633,
 452277899,
 6249,
 -58632,
 452341545,
 6257,
 -1,
 452402784,
 6242,
 -58630,
 450910377,
 6193,
 -1,
 452531572,
 6192,
 452729621,
 450854962,
 6190,
 452853759,
 452692533,
 -1,
 452860688,
 452729744,
 -1,
 452926209,
 452847390,
 -1,
 -58624,
 452876457,
 6308,
 -1,
 452924788,
 6309,
 453122820,
 452903636,
 -1,
 -58621,
 453100309,
 6302,
 -1,
 453121396,
 6304,
 453319431,
 453064224,
 -1,
 -58618,
 453269673,
 6305,
 -1,
 453326965,
 6303,
 453516042,
 453258462,
 -1,
 -58615,
 453501994,
 6307,
 -1,
 453514612,
 6300,
 -58613,
 453492672,
 6306,
 -58612,
 453676010,
 6299,
 -58611,
 453737057,
 6314,
 -58610,
 453799930,
 6301,
 -58609,
 453858494,
 6298,
 -1,
 453912893,
 6312,
 -58607,
 452847583,
 6263,
 -58606,
 454076847,
 6261,
 -58605,
 454127775,
 6260,
 -58604,
 454189439,
 6259,
 -1,
 454250175,
 6262,
 454433561,
 452716318,
 -1,
 -58601,
 454404527,
 6207,
 -58600,
 454450313,
 6209,
 -1,
 454497652,
 6205,
 454695707,
 454413898,
 6180,
 -1,
 454639751,
 6182,
 454826781,
 454660495,
 6179,
 -1,
 454770823,
 6181,
 454957856,
 454783832,
 -1,
 -58593,
 454908073,
 6208,
 -1,
 454956404,
 6191,
 455154467,
 454914184,
 -1,
 -58590,
 455104681,
 6203,
 -1,
 455153012,
 6202,
 455351077,
 455098503,
 6177,
 -1,
 455295111,
 6183,
 455482152,
 455290658,
 -1,
 -58585,
 455434623,
 6210,
 -1,
 455480692,
 6196,
 -58583,
 455468074,
 6198,
 -58582,
 455662896,
 6200,
 -58581,
 455715247,
 6199,
 -58580,
 455780170,
 6188,
 -58579,
 455843918,
 6187,
 -58578,
 455903547,
 6184,
 -58577,
 455962411,
 6197,
 -58576,
 456024447,
 6178,
 -58575,
 456087724,
 6206,
 -58574,
 456151812,
 6189,
 -58573,
 456216255,
 6201,
 -58572,
 456275595,
 6195,
 -1,
 456337064,
 6186,
 456530755,
 445921688,
 -1,
 456596281,
 456508116,
 -1,
 -58568,
 456581519,
 6162,
 -1,
 456613974,
 6163,
 456792892,
 456570655,
 -1,
 -58565,
 456748782,
 6166,
 -1,
 456805506,
 6167,
 456989503,
 456740438,
 -1,
 -58562,
 456956912,
 6164,
 -1,
 457010807,
 6165,
 -58560,
 456976277,
 6160,
 -58559,
 457151935,
 6161,
 -58558,
 457215164,
 6169,
 -1,
 457262391,
 6168,
 457448267,
 456478294,
 -1,
 457513801,
 457419886,
 -1,
 457579336,
 457491156,
 -1,
 -58553,
 457564559,
 6156,
 -1,
 457597014,
 6157,
 -1,
 457545151,
 6155,
 -58550,
 457494810,
 6147,
 -1,
 457808909,
 6149,
 457972558,
 457409023,
 -1,
 -58547,
 457921218,
 6153,
 -1,
 457978383,
 6152,
 458169169,
 457912808,
 -1,
 -58544,
 458130935,
 6146,
 -1,
 458194194,
 6148,
 -58542,
 458153110,
 6158,
 -58541,
 458344836,
 6150,
 -58540,
 458406879,
 6151,
 -58539,
 458460404,
 6154,
 -58538,
 458507772,
 6145,
 -1,
 458566075,
 6144,
 458817535,
 445878671,
 -1,
 458824541,
 458708618,
 -1,
 458890076,
 458810350,
 -1,
 -58533,
 458843952,
 9867,
 -1,
 458890848,
 9866,
 -1,
 458834276,
 119552,
 -1,
 458801202,
 9101,
 -1,
 445829869,
 9968,
 459283653,
 427871818,
 -1,
 459349168,
 459258877,
 -1,
 459414700,
 459282970,
 -1,
 459479966,
 459353310,
 -1,
 459545488,
 459444623,
 -1,
 459611023,
 459505637,
 -1,
 459676558,
 459549066,
 -1,
 459742063,
 459650847,
 -1,
 459807596,
 459719380,
 -1,
 459873131,
 459740969,
 -1,
 -58518,
 459837839,
 119164,
 -1,
 459894113,
 119166,
 -1,
 459818570,
 119141,
 -58515,
 459777583,
 119142,
 -58514,
 460097953,
 119213,
 -1,
 460161874,
 119176,
 460331895,
 459690227,
 -1,
 460397430,
 460265622,
 -1,
 -58510,
 460329993,
 119154,
 -58509,
 460395452,
 119153,
 -58508,
 460460876,
 119152,
 -58507,
 460526247,
 119151,
 -1,
 460591631,
 119150,
 -1,
 460352442,
 119175,
 460856191,
 460309204,
 -1,
 460921726,
 460826964,
 -1,
 460987261,
 460867275,
 -1,
 -58501,
 460919628,
 119145,
 -58500,
 460984999,
 119144,
 -1,
 461050383,
 119143,
 -1,
 460942293,
 119179,
 -1,
 460867689,
 119165,
 461380483,
 460798660,
 -1,
 -58495,
 461365611,
 119210,
 -58494,
 461426550,
 119178,
 -1,
 461467007,
 119173,
 461642631,
 461313396,
 -1,
 461708166,
 461581932,
 119163,
 -1,
 461640025,
 119169,
 -1,
 461688889,
 119149,
 461904777,
 461603401,
 119167,
 -1,
 461836633,
 119168,
 -58486,
 461886286,
 119211,
 -58485,
 462008862,
 119174,
 -58484,
 462061076,
 119170,
 -58483,
 462117546,
 119212,
 -1,
 462170228,
 119177,
 -1,
 459638449,
 119092,
 -1,
 459552395,
 119052,
 462494615,
 459502424,
 -1,
 462560148,
 462477014,
 -1,
 -58477,
 462544553,
 119130,
 -1,
 462563830,
 119131,
 462815231,
 462512511,
 -1,
 -58474,
 462740433,
 119253,
 -1,
 462782530,
 119255,
 462953370,
 462465364,
 -1,
 -58471,
 462918622,
 119247,
 -1,
 462965358,
 119186,
 -58469,
 462935836,
 119093,
 -58468,
 463105065,
 119109,
 -58467,
 463149166,
 119059,
 -1,
 463209117,
 119073,
 463412172,
 459457236,
 -1,
 463477684,
 463382868,
 119190,
 463601663,
 463430260,
 -1,
 463608753,
 463472162,
 -1,
 463674280,
 463590151,
 -1,
 463739814,
 463646311,
 -1,
 -58459,
 463724201,
 119120,
 -1,
 463743478,
 119121,
 -58457,
 463724201,
 119112,
 -1,
 463874550,
 119113,
 464067499,
 463646311,
 -1,
 -58454,
 464051881,
 119116,
 -1,
 464071158,
 119117,
 464264110,
 464025226,
 -1,
 -58451,
 464248489,
 119114,
 -1,
 464267766,
 119115,
 464519167,
 464207412,
 -1,
 -58448,
 464445097,
 119118,
 -1,
 464464374,
 119119,
 464715775,
 463540495,
 -1,
 -58445,
 464641705,
 119124,
 -1,
 464660982,
 119125,
 464853952,
 463423210,
 -1,
 464919484,
 464807700,
 -1,
 464985019,
 464873209,
 119243,
 465108991,
 464913210,
 -1,
 -58439,
 464982860,
 119246,
 -58438,
 465048231,
 119245,
 -1,
 465113615,
 119244,
 -1,
 464953977,
 119242,
 465436671,
 464888464,
 -1,
 465443775,
 465347193,
 119239,
 -1,
 465371975,
 119241,
 -1,
 465397497,
 119240,
 465640388,
 464836096,
 119191,
 465764351,
 465567744,
 -1,
 -58429,
 465687300,
 119194,
 -1,
 465747325,
 119193,
 465902537,
 465590411,
 -1,
 465968072,
 465857755,
 -1,
 -58425,
 465939746,
 119104,
 -1,
 465997480,
 119138,
 -1,
 465939590,
 119064,
 466230219,
 465868922,
 119256,
 -1,
 466160072,
 119260,
 -1,
 466215565,
 119063,
 466426866,
 463386399,
 -1,
 466492378,
 466379135,
 -1,
 466557913,
 466477828,
 -1,
 466623446,
 466535124,
 -1,
 466688979,
 466609180,
 -1,
 -58414,
 466660642,
 119105,
 -1,
 466718376,
 119139,
 466943999,
 466633567,
 -1,
 -58411,
 466857250,
 119103,
 -1,
 466914984,
 119137,
 467140607,
 466554579,
 -1,
 -58408,
 467058920,
 119068,
 -1,
 467106640,
 119067,
 -1,
 466521098,
 119040,
 467344357,
 466436231,
 -1,
 467409892,
 467305617,
 -1,
 467475424,
 467371416,
 -1,
 -58402,
 467459753,
 119229,
 -58401,
 467512610,
 119238,
 -1,
 467544566,
 119230,
 467795967,
 467413979,
 -1,
 -58398,
 467721897,
 119225,
 -58397,
 467774754,
 119236,
 -1,
 467806710,
 119226,
 -1,
 467359257,
 119051,
 468065258,
 467314725,
 -1,
 468130793,
 468029101,
 -1,
 -58392,
 468115113,
 119110,
 -1,
 468134390,
 119111,
 -1,
 468067958,
 119250,
 468392943,
 468015243,
 -1,
 468458478,
 468329018,
 -1,
 -58387,
 468439812,
 119088,
 -1,
 468467247,
 119089,
 -1,
 468425107,
 119045,
 468720625,
 468331919,
 119254,
 -1,
 468648893,
 119259,
 -1,
 468700941,
 119181,
 468917260,
 466374230,
 -1,
 468982779,
 468869503,
 -1,
 469048314,
 468945119,
 -1,
 469113849,
 468997244,
 -1,
 -58377,
 469046092,
 119148,
 -58376,
 469111463,
 119147,
 -1,
 469176847,
 119146,
 -1,
 469047799,
 119042,
 -1,
 469031208,
 119066,
 469507072,
 468947343,
 -1,
 469572607,
 469489059,
 -1,
 -58370,
 469549288,
 119069,
 -1,
 469597008,
 119065,
 -1,
 469546538,
 119185,
 469834756,
 469435037,
 119074,
 469958655,
 469763815,
 -1,
 -58365,
 469837783,
 119076,
 -1,
 469900371,
 119075,
 470096903,
 469816942,
 -1,
 -58362,
 470081193,
 119231,
 -1,
 470100470,
 119232,
 470293514,
 470054301,
 -1,
 -58359,
 470274820,
 119084,
 -1,
 470302255,
 119085,
 470548479,
 470239724,
 119056,
 -1,
 470417955,
 119057,
 470621217,
 468881807,
 -1,
 470686745,
 470594473,
 -1,
 470752273,
 470618639,
 119195,
 -58352,
 470684175,
 119205,
 -1,
 470749583,
 119204,
 -58350,
 470684993,
 119203,
 -58349,
 470881549,
 119202,
 -58348,
 470947014,
 119201,
 -58347,
 471012481,
 119200,
 -58346,
 471077897,
 119199,
 -58345,
 471143356,
 119198,
 -58344,
 471208780,
 119197,
 -1,
 471274151,
 119196,
 471473182,
 470649603,
 -1,
 471538717,
 471401583,
 -1,
 -58340,
 471510306,
 119106,
 -1,
 471568040,
 119140,
 -1,
 471470163,
 119062,
 471859199,
 471452699,
 -1,
 -58336,
 471738327,
 119095,
 -1,
 471800915,
 119094,
 471997490,
 470562336,
 -1,
 472063016,
 471930228,
 -1,
 472128549,
 472024936,
 119220,
 -1,
 472055875,
 119221,
 -58330,
 472103654,
 119044,
 -58329,
 472216434,
 119049,
 -1,
 472253039,
 119050,
 472456236,
 472030004,
 -1,
 -58326,
 472431289,
 119082,
 -58325,
 472469756,
 119083,
 -1,
 472524710,
 119041,
 472718383,
 472430225,
 -1,
 -58322,
 472650407,
 119078,
 -1,
 472715791,
 119077,
 472973311,
 472662151,
 -1,
 -58319,
 472864674,
 119209,
 -1,
 472921039,
 119187,
 473111618,
 471934582,
 -1,
 473177149,
 473082196,
 -1,
 473242682,
 473120903,
 -1,
 473308217,
 473225134,
 -1,
 473373752,
 473263340,
 119224,
 -1,
 473303490,
 119235,
 -1,
 473317511,
 119132,
 -1,
 473244862,
 119058,
 473694207,
 473175846,
 -1,
 -58308,
 473592302,
 119061,
 -1,
 473645191,
 119060,
 473890815,
 473121969,
 -1,
 -58305,
 473810911,
 119157,
 -58304,
 473873795,
 119159,
 -58303,
 473932663,
 119161,
 -1,
 473966626,
 119155,
 474160207,
 473079785,
 -1,
 474225735,
 474124687,
 -1,
 474291270,
 474199406,
 119257,
 -1,
 474219453,
 119258,
 -1,
 474232622,
 119252,
 474487884,
 474169479,
 -1,
 474553419,
 474429132,
 -1,
 -58294,
 474534869,
 119215,
 -1,
 474579546,
 119214,
 -1,
 474527625,
 119261,
 -58291,
 474447721,
 119108,
 -58290,
 474768061,
 119183,
 -1,
 474816879,
 119126,
 475012188,
 474120165,
 -1,
 475077716,
 474966312,
 119227,
 475201535,
 475004928,
 -1,
 -58285,
 475114786,
 119237,
 -1,
 475146742,
 119228,
 475339863,
 475058488,
 -1,
 -58282,
 475309073,
 119081,
 -1,
 475335106,
 119098,
 475536474,
 475305656,
 -1,
 -58279,
 475520681,
 119122,
 -1,
 475539958,
 119123,
 -58277,
 475483729,
 119184,
 -1,
 475670058,
 119222,
 475864171,
 474960611,
 -1,
 475929700,
 475834708,
 -1,
 475995233,
 475874504,
 -1,
 -58272,
 475942488,
 119249,
 -1,
 475999460,
 119248,
 476250111,
 475928386,
 -1,
 -58269,
 476167549,
 119188,
 -1,
 476220817,
 119189,
 476388456,
 475857565,
 119070,
 476512255,
 476317415,
 -1,
 -58265,
 476391383,
 119072,
 -1,
 476453971,
 119071,
 476708863,
 476347320,
 -1,
 -58262,
 476631812,
 119217,
 -1,
 476659247,
 119218,
 476847223,
 475834708,
 -1,
 476912756,
 476790919,
 -1,
 476978291,
 476881337,
 -1,
 477043826,
 476922544,
 -1,
 -58256,
 476975948,
 119055,
 -58255,
 477041319,
 119054,
 -1,
 477106703,
 119053,
 -1,
 476971896,
 119048,
 -1,
 476961299,
 119043,
 477495295,
 476864895,
 -1,
 -58250,
 477399981,
 119180,
 -1,
 477451553,
 119047,
 477633665,
 476790919,
 -1,
 477699198,
 477596256,
 -1,
 -58246,
 477677535,
 119158,
 -58245,
 477740419,
 119160,
 -58244,
 477799287,
 119162,
 -58243,
 477860623,
 119208,
 -1,
 477898786,
 119156,
 478150655,
 477652251,
 -1,
 -58240,
 478063906,
 119102,
 -1,
 478121640,
 119136,
 478289035,
 477603777,
 -1,
 478354568,
 478225093,
 -1,
 478420102,
 478333366,
 -1,
 -58235,
 478395065,
 119090,
 -1,
 478433532,
 119091,
 -58233,
 478391586,
 119101,
 -1,
 478580392,
 119135,
 478806015,
 478308388,
 -1,
 -58230,
 478685143,
 119097,
 -1,
 478747731,
 119096,
 478944402,
 478251231,
 -1,
 479009935,
 478881159,
 -1,
 -58226,
 478991108,
 119086,
 -1,
 479018543,
 119087,
 -58224,
 478990605,
 119129,
 -58223,
 479173284,
 119128,
 -1,
 479216139,
 119207,
 479403160,
 478901080,
 -1,
 479468695,
 479368781,
 119223,
 479592447,
 479395840,
 -1,
 -58218,
 479502978,
 119233,
 -1,
 479553284,
 119234,
 -1,
 479413246,
 119046,
 479796382,
 479353001,
 -1,
 479861917,
 479754809,
 -1,
 -58213,
 479833378,
 119100,
 -58212,
 479896013,
 119216,
 -1,
 479956648,
 119134,
 -1,
 479843583,
 119206,
 480189603,
 479780104,
 -1,
 480255138,
 480140954,
 -1,
 -58207,
 480226594,
 119099,
 -1,
 480284328,
 119133,
 -1,
 480210393,
 119219,
 480517286,
 480171950,
 -1,
 -58203,
 480482201,
 119127,
 -1,
 480537734,
 119251,
 480713897,
 480453183,
 -1,
 -58200,
 480695044,
 119171,
 -1,
 480722479,
 119172,
 -58198,
 480700190,
 119182,
 -58197,
 480895765,
 119107,
 -1,
 480930687,
 119192,
 481165311,
 459341824,
 -1,
 -58194,
 481082047,
 9839,
 -58193,
 481135068,
 9838,
 -1,
 481186049,
 9837,
 481369282,
 459308817,
 -1,
 481434813,
 481338406,
 -1,
 481500348,
 481410091,
 215,
 481624063,
 481427456,
 -1,
 481631417,
 481519411,
 -1,
 -58186,
 481610490,
 10811,
 -58185,
 481668917,
 10805,
 -58184,
 481720079,
 10804,
 -1,
 481770701,
 10807,
 482017279,
 481615730,
 -1,
 -58181,
 481940055,
 10801,
 -1,
 481966897,
 10800,
 -1,
 481485572,
 10005,
 482221249,
 481409493,
 8844,
 482344959,
 482148352,
 -1,
 -58176,
 482267775,
 8846,
 -1,
 482314234,
 8845,
 -1,
 482181685,
 8888,
 482607103,
 481308453,
 -1,
 -58172,
 482507087,
 8810,
 -1,
 482563831,
 8811,
 482745802,
 459269238,
 -1,
 482811211,
 482702168,
 -1,
 482876743,
 482757683,
 -1,
 482942182,
 482832520,
 -1,
 483007717,
 482891945,
 4097,
 483131391,
 482969516,
 -1,
 483138768,
 483014176,
 -1,
 483204303,
 483079712,
 -1,
 -58162,
 483154089,
 43625,
 -1,
 483202420,
 43624,
 -1,
 483154089,
 43626,
 483466451,
 483118104,
 -1,
 -58158,
 483416233,
 43623,
 -1,
 483464564,
 43622,
 483663062,
 483428575,
 -1,
 -58155,
 483648554,
 43621,
 -1,
 483661172,
 43627,
 483859673,
 483618601,
 -1,
 -58152,
 483809449,
 43620,
 -1,
 483857780,
 43619,
 484056284,
 483809419,
 -1,
 -58149,
 484006057,
 43630,
 -1,
 484054388,
 43629,
 484252895,
 483994846,
 -1,
 -58146,
 484202665,
 43618,
 -1,
 484250996,
 43617,
 -58144,
 484239152,
 43634,
 -58143,
 484434724,
 43633,
 -58142,
 484489113,
 43628,
 -58141,
 484551087,
 43635,
 -58140,
 484594436,
 43616,
 -1,
 484658879,
 43631,
 -1,
 482940276,
 4096,
 484908284,
 482916127,
 -1,
 484973817,
 484858025,
 4176,
 485097471,
 484935905,
 -1,
 485104876,
 485001439,
 -1,
 -58133,
 485090346,
 4218,
 -1,
 485102964,
 4220,
 485301487,
 485060744,
 -1,
 -58130,
 485251241,
 4214,
 -1,
 485299572,
 4213,
 -58128,
 485287728,
 4217,
 -58127,
 485475878,
 4224,
 -58126,
 485532466,
 4221,
 -58125,
 485578921,
 4225,
 -58124,
 485643012,
 4215,
 -58123,
 485707455,
 4222,
 -58122,
 485766795,
 4219,
 -58121,
 485829947,
 4216,
 -58120,
 485893800,
 4223,
 -1,
 485954932,
 4130,
 -58118,
 484947865,
 4177,
 -58117,
 486101985,
 4193,
 -1,
 486151540,
 4126,
 486350085,
 484868069,
 -1,
 486415620,
 486315312,
 -1,
 486481153,
 486352882,
 -1,
 -58112,
 486424711,
 4189,
 -1,
 486479220,
 4188,
 -58110,
 486444010,
 4186,
 -58109,
 486633466,
 4187,
 -1,
 486686855,
 4136,
 -1,
 486348148,
 4121,
 486939916,
 486312159,
 -1,
 487005449,
 486901983,
 -1,
 -58104,
 486990890,
 4106,
 -1,
 487003508,
 4111,
 -58102,
 486990890,
 4105,
 -58101,
 487150340,
 4100,
 -1,
 487200116,
 4116,
 487398673,
 486923279,
 -1,
 487464207,
 487369044,
 4178,
 -1,
 487434580,
 4179,
 487653375,
 487420760,
 4180,
 -1,
 487551832,
 4181,
 487726359,
 487375572,
 -1,
 487791893,
 487703252,
 -1,
 -58092,
 487741609,
 4108,
 -1,
 487789940,
 4107,
 -58090,
 487741609,
 4113,
 -1,
 487921012,
 4112,
 488119580,
 487669895,
 4135,
 488243199,
 488055850,
 -1,
 -58086,
 488171260,
 4207,
 -58085,
 488213885,
 4206,
 -1,
 488265068,
 4208,
 488447266,
 488060448,
 -1,
 488512800,
 488388128,
 -1,
 -58081,
 488462505,
 4110,
 -1,
 488510836,
 4109,
 -58079,
 488462505,
 4115,
 -1,
 488641908,
 4114,
 488840487,
 488430856,
 -1,
 488906022,
 488786704,
 -1,
 -58075,
 488883750,
 4197,
 -1,
 488941373,
 4198,
 -1,
 488838516,
 4125,
 489168171,
 488788707,
 -1,
 -58071,
 489139104,
 4159,
 -58070,
 489183401,
 4099,
 -1,
 489231732,
 4098,
 489430318,
 489100660,
 4129,
 -58067,
 489410122,
 4138,
 -1,
 489451063,
 43642,
 489626928,
 489410122,
 4133,
 -1,
 489606730,
 4134,
 489758003,
 489597268,
 -1,
 -58062,
 489738635,
 4238,
 -1,
 489756020,
 4123,
 489954614,
 489725929,
 -1,
 -58059,
 489904297,
 4118,
 -1,
 489952628,
 4117,
 490151225,
 489911128,
 -1,
 -58056,
 490107821,
 4128,
 -1,
 490149236,
 4124,
 490347836,
 490106665,
 -1,
 -58053,
 490297513,
 4104,
 -1,
 490345844,
 4103,
 490544446,
 490299775,
 4131,
 -1,
 490496383,
 4132,
 490675521,
 490482910,
 -1,
 -58048,
 490625193,
 4102,
 -1,
 490673524,
 4101,
 490872132,
 490612342,
 -1,
 -58045,
 490821801,
 4120,
 -1,
 490870132,
 4119,
 -58043,
 490857514,
 4122,
 -58042,
 491032975,
 4137,
 -1,
 491083945,
 4127,
 491323391,
 482841396,
 -1,
 -58039,
 491235244,
 43637,
 -58038,
 491295218,
 43636,
 -1,
 491347523,
 43638,
 491527560,
 482785055,
 -1,
 491593069,
 491480457,
 -1,
 491658586,
 491566879,
 -1,
 491724121,
 491608605,
 -1,
 491789652,
 491702767,
 -1,
 -58031,
 491721857,
 4234,
 -58030,
 491787273,
 4233,
 -58029,
 491852620,
 4232,
 -1,
 491917991,
 4231,
 492175359,
 491729812,
 -1,
 492182872,
 492095983,
 -1,
 -58025,
 492114764,
 4236,
 -1,
 492180135,
 4235,
 -1,
 492127954,
 4237,
 -1,
 491668060,
 4171,
 492510560,
 491642510,
 -1,
 -58020,
 492442633,
 4205,
 -58019,
 492508092,
 4204,
 -58018,
 492573516,
 4203,
 -58017,
 492638887,
 4202,
 -1,
 492704271,
 4201,
 492903779,
 492493669,
 -1,
 -58014,
 492877861,
 4152,
 -1,
 492939917,
 4153,
 493100390,
 492859942,
 -1,
 -58011,
 493032268,
 4251,
 -1,
 493097487,
 4250,
 493297001,
 493032820,
 -1,
 -58008,
 493271095,
 4154,
 -1,
 493326533,
 4150,
 -58006,
 493270683,
 4239,
 -58005,
 493461726,
 43643,
 -58004,
 493517769,
 4170,
 -1,
 493566779,
 4151,
 493755771,
 491543074,
 -1,
 493821297,
 493732564,
 -1,
 -58000,
 493805967,
 4242,
 -1,
 493838422,
 4243,
 494017908,
 493795103,
 -1,
 -57997,
 493973230,
 4246,
 -1,
 494029954,
 4247,
 494214519,
 493964886,
 -1,
 -57994,
 494181360,
 4244,
 -1,
 494235255,
 4245,
 -57992,
 494200725,
 4240,
 -57991,
 494376383,
 4241,
 -57990,
 494439612,
 4249,
 -1,
 494486839,
 4248,
 494731263,
 493741558,
 -1,
 494738818,
 494605684,
 -1,
 494804353,
 494693937,
 -1,
 -57985,
 494783842,
 43641,
 -57984,
 494835135,
 43640,
 -1,
 494882158,
 43639,
 -1,
 494752141,
 4174,
 495132037,
 494713485,
 -1,
 -57980,
 495097279,
 4254,
 -1,
 495144302,
 4255,
 -57978,
 495090906,
 4172,
 -57977,
 495277155,
 4175,
 -1,
 495333976,
 4173,
 495525292,
 491510966,
 -1,
 495590800,
 495499039,
 -1,
 495656335,
 495540765,
 -1,
 495721869,
 495599751,
 4228,
 -1,
 495648773,
 4229,
 -57970,
 495669385,
 4230,
 -1,
 495785463,
 4227,
 -1,
 495604692,
 4194,
 496049557,
 495574031,
 -1,
 496115091,
 496019796,
 4182,
 -1,
 496085332,
 4183,
 496304127,
 496071512,
 4184,
 -1,
 496202584,
 4185,
 496377242,
 495981940,
 -1,
 496442777,
 496329087,
 4146,
 496566271,
 496421284,
 4252,
 -1,
 496460159,
 4253,
 -1,
 496375156,
 4140,
 496704926,
 496333206,
 -1,
 -57956,
 496684618,
 4211,
 -57955,
 496734933,
 4210,
 -1,
 496780071,
 4212,
 496967073,
 496688763,
 -1,
 -57952,
 496947214,
 4200,
 -1,
 496979008,
 4199,
 497163683,
 496946762,
 4143,
 -1,
 497143370,
 4144,
 497294758,
 497125036,
 -1,
 -57947,
 497258895,
 4148,
 -1,
 497313179,
 4147,
 497491368,
 497246591,
 4141,
 -1,
 497443199,
 4142,
 497622442,
 497434759,
 4145,
 -1,
 497549317,
 4149,
 -57941,
 497599469,
 4139,
 -1,
 497701940,
 4209,
 497884602,
 495466904,
 -1,
 497950128,
 497861332,
 -1,
 -57937,
 497934735,
 4162,
 -1,
 497967190,
 4163,
 498146739,
 497923871,
 -1,
 -57934,
 498101998,
 4166,
 -1,
 498158722,
 4167,
 498343350,
 498093654,
 -1,
 -57931,
 498310128,
 4164,
 -1,
 498364023,
 4165,
 -57929,
 498329493,
 4160,
 -57928,
 498505151,
 4161,
 -57927,
 498568380,
 4169,
 -1,
 498615607,
 4168,
 498802118,
 497824402,
 -1,
 498867653,
 498761701,
 -1,
 498933185,
 498811649,
 -1,
 -57922,
 498918442,
 4155,
 -57921,
 498982192,
 4157,
 -57920,
 499034543,
 4156,
 -1,
 499079337,
 4158,
 499318783,
 498898238,
 -1,
 -57917,
 499222843,
 4190,
 -57916,
 499286066,
 4191,
 -1,
 499348397,
 4192,
 -1,
 498842259,
 4226,
 499588553,
 498780633,
 -1,
 -57912,
 499544507,
 4196,
 -1,
 499604231,
 4195,
 -1,
 499549751,
 43632,
 499850825,
 482689159,
 -1,
 499916307,
 499796940,
 -1,
 499981818,
 499872600,
 -1,
 500047353,
 499928115,
 -1,
 500112851,
 500009183,
 -1,
 500178385,
 500061801,
 43977,
 -1,
 500106674,
 44001,
 500367359,
 500110708,
 43973,
 -1,
 500237746,
 43999,
 500440535,
 500089556,
 -1,
 500506070,
 500393437,
 43975,
 -1,
 500434354,
 44000,
 -1,
 500457477,
 43978,
 500702683,
 500408297,
 -1,
 500768218,
 500634996,
 43972,
 -1,
 500696498,
 43998,
 -1,
 500718056,
 43984,
 500964831,
 500658312,
 -1,
 501030366,
 500929506,
 43968,
 -1,
 500958642,
 43995,
 -1,
 500981765,
 43976,
 501226977,
 500925927,
 43971,
 -1,
 501155250,
 43997,
 501358051,
 501183657,
 43970,
 -1,
 501286322,
 43996,
 501489126,
 501313321,
 -1,
 -57883,
 501442013,
 43990,
 -1,
 501504488,
 43987,
 501685736,
 501440895,
 43983,
 -1,
 501614002,
 44002,
 501816811,
 501633763,
 -1,
 -57878,
 501781474,
 43986,
 -1,
 501833733,
 43992,
 502013422,
 501757472,
 -1,
 -57875,
 501966301,
 43991,
 -1,
 502030341,
 43993,
 502210033,
 501950070,
 -1,
 -57872,
 502159848,
 43994,
 -1,
 502207860,
 43989,
 -57870,
 502195313,
 43980,
 -57869,
 502390087,
 43979,
 -57868,
 502452691,
 43982,
 -57867,
 502511586,
 43969,
 -57866,
 502573611,
 43988,
 -57865,
 502620435,
 43981,
 -57864,
 502673333,
 43974,
 -1,
 502736208,
 43985,
 -1,
 500027768,
 44012,
 502996488,
 499923352,
 -1,
 503062014,
 502973140,
 -1,
 -57859,
 503046543,
 44018,
 -1,
 503078998,
 44019,
 503258625,
 503035679,
 -1,
 -57856,
 503213806,
 44022,
 -1,
 503270530,
 44023,
 503455236,
 503205462,
 -1,
 -57853,
 503421936,
 44020,
 -1,
 503475831,
 44021,
 -57851,
 503441301,
 44016,
 -57850,
 503616959,
 44017,
 -57849,
 503680188,
 44025,
 -1,
 503727415,
 44024,
 503914001,
 502979766,
 -1,
 -57846,
 503899448,
 44006,
 -57845,
 503960040,
 44008,
 -57844,
 504020678,
 44007,
 -57843,
 504075642,
 44003,
 -57842,
 504139959,
 44010,
 -57841,
 504195027,
 44004,
 -57840,
 504246170,
 44009,
 -1,
 504307030,
 44005,
 -57838,
 503852945,
 44011,
 -1,
 504438838,
 44013,
 504634920,
 499858013,
 -1,
 504700441,
 504606305,
 -1,
 504765976,
 504627200,
 -1,
 -57833,
 504734002,
 10089,
 -1,
 504772003,
 10101,
 -1,
 504697045,
 10093,
 505028126,
 504657541,
 -1,
 505093661,
 504954880,
 -1,
 -57828,
 505061682,
 10088,
 -1,
 505099683,
 10100,
 -1,
 505024725,
 10092,
 505355809,
 505001759,
 -1,
 -57824,
 505315797,
 9900,
 -1,
 505370835,
 9618,
 505552420,
 505303307,
 -1,
 -57821,
 505524122,
 10091,
 -1,
 505575277,
 10090,
 -57819,
 505536194,
 9898,
 -57818,
 505731676,
 10073,
 -57817,
 505774760,
 8287,
 -1,
 505817615,
 9899,
 506011195,
 504570972,
 -1,
 506076729,
 505945781,
 8737,
 506200063,
 506003456,
 -1,
 506207800,
 506126476,
 -1,
 506273327,
 506188555,
 -1,
 -57810,
 506244705,
 10664,
 -1,
 506295941,
 10665,
 506469938,
 506244718,
 -1,
 -57807,
 506450692,
 10668,
 -1,
 506478127,
 10670,
 506666549,
 506427024,
 -1,
 -57804,
 506647300,
 10669,
 -1,
 506674735,
 10671,
 506920959,
 506609210,
 -1,
 -57801,
 506834529,
 10666,
 -1,
 506885765,
 10667,
 -1,
 506173299,
 10651,
 -57798,
 506048121,
 10653,
 -1,
 507063463,
 8798,
 507256392,
 505989940,
 -1,
 507321922,
 507232980,
 -1,
 507387456,
 507306600,
 -1,
 -57793,
 507354599,
 9173,
 -1,
 507408406,
 9174,
 -57791,
 507359905,
 9175,
 -1,
 507530234,
 9176,
 507715141,
 507280742,
 -1,
 -57788,
 507694580,
 9172,
 -1,
 507755351,
 9170,
 -57786,
 507689858,
 9171,
 -57785,
 507880004,
 9177,
 -1,
 507915209,
 9169,
 -1,
 507226952,
 9791,
 508231679,
 499802495,
 -1,
 508239448,
 508135647,
 -1,
 508304983,
 508221035,
 -1,
 508370518,
 508231680,
 -1,
 508436053,
 508345387,
 8722,
 508559359,
 508362752,
 -1,
 508567124,
 508485490,
 -1,
 -57775,
 508539611,
 10796,
 -57774,
 508579581,
 10795,
 -57773,
 508640059,
 10794,
 -1,
 508703253,
 10793,
 -1,
 508520328,
 10810,
 -1,
 508413948,
 8770,
 -1,
 508301453,
 8723,
 -1,
 508290030,
 10751,
 509156955,
 508180000,
 -1,
 -57766,
 509115191,
 8943,
 -1,
 509164216,
 183,
 -57764,
 509115397,
 8357,
 -1,
 509293584,
 181,
 509487016,
 342258520,
 -1,
 509551602,
 509416820,
 -1,
 509617032,
 509528230,
 -1,
 509681962,
 509589279,
 -1,
 509747487,
 509640990,
 -1,
 509813020,
 509703000,
 -1,
 509878545,
 509758515,
 -1,
 509943464,
 509854420,
 116,
 510008963,
 509922890,
 -1,
 510074498,
 509981625,
 -1,
 510140012,
 510044500,
 633,
 510263295,
 510069795,
 -1,
 -57750,
 510182275,
 11385,
 -57749,
 510229853,
 634,
 -1,
 510287520,
 635,
 510467695,
 510089355,
 613,
 510590975,
 510397799,
 686,
 -1,
 510460295,
 687,
 510664306,
 510399860,
 592,
 -57743,
 510623456,
 594,
 -1,
 510673031,
 7426,
 510860917,
 510628239,
 -1,
 -57740,
 510829080,
 7432,
 -1,
 510869639,
 7444,
 511057527,
 510820325,
 623,
 -1,
 510987721,
 624,
 511188601,
 511009151,
 7433,
 -1,
 511151869,
 42879,
 -57734,
 511173614,
 654,
 -57733,
 511302920,
 653,
 -57732,
 511367086,
 652,
 -57731,
 511427284,
 647,
 -57730,
 511472472,
 42881,
 -57729,
 511537288,
 670,
 -57728,
 511595235,
 7543,
 -57727,
 511656071,
 477,
 -1,
 511719347,
 397,
 -1,
 510033893,
 42871,
 511975063,
 509938723,
 -1,
 512040586,
 511913182,
 -1,
 -57722,
 512021999,
 566,
 -57721,
 512070925,
 539,
 -57720,
 512126052,
 7793,
 -57719,
 512181011,
 355,
 -1,
 512238108,
 357,
 512433809,
 511981088,
 -1,
 512499342,
 512399949,
 -1,
 -57715,
 512436307,
 7789,
 -1,
 512497269,
 7787,
 512753663,
 512451078,
 -1,
 -57712,
 512644666,
 11366,
 -1,
 512706996,
 7831,
 -57710,
 512409856,
 359,
 -57709,
 512863527,
 648,
 -57708,
 512925855,
 427,
 -57707,
 512984336,
 7541,
 -57706,
 513047288,
 7791,
 -1,
 513105568,
 429,
 513285789,
 511938959,
 -1,
 513351324,
 513248006,
 -1,
 -57702,
 513330530,
 424,
 -57701,
 513391892,
 389,
 -1,
 513429684,
 445,
 -1,
 513318929,
 7446,
 513679010,
 513235083,
 -1,
 513744545,
 513644895,
 254,
 513867775,
 513674847,
 42853,
 -1,
 513739499,
 42855,
 -1,
 513674827,
 7546,
 -57693,
 513664798,
 42793,
 -57692,
 513980225,
 678,
 -57691,
 514043154,
 42795,
 -57690,
 514083450,
 679,
 -57689,
 514141419,
 680,
 -1,
 514201948,
 11383,
 514399972,
 509907343,
 111,
 514465500,
 514329635,
 -1,
 514530995,
 514416223,
 -1,
 514596530,
 514503577,
 417,
 514719743,
 514523258,
 -1,
 -57682,
 514639868,
 7905,
 -57681,
 514678437,
 7903,
 -57680,
 514741957,
 7901,
 -57679,
 514800443,
 7907,
 -1,
 514856865,
 7899,
 -1,
 514560997,
 7887,
 515120830,
 514471456,
 -1,
 515186364,
 515084687,
 -1,
 515251897,
 515162838,
 -1,
 515317432,
 515184245,
 559,
 -1,
 515244310,
 561,
 -1,
 515254355,
 7885,
 515571711,
 515231529,
 -1,
 -57669,
 515462853,
 525,
 -1,
 515512225,
 337,
 515768319,
 515138057,
 246,
 -1,
 515637526,
 555,
 515841735,
 515058910,
 -1,
 515907270,
 515796041,
 244,
 516030463,
 515833978,
 -1,
 -57662,
 515950588,
 7895,
 -57661,
 515989157,
 7893,
 -57660,
 516052677,
 7891,
 -57659,
 516111163,
 7897,
 -1,
 516167585,
 7889,
 -1,
 515842588,
 466,
 516431564,
 515819516,
 245,
 516554751,
 516358266,
 -1,
 -57654,
 516456507,
 557,
 -57653,
 516503710,
 7759,
 -1,
 516560801,
 7757,
 516759248,
 516390971,
 333,
 516882431,
 516685946,
 -1,
 -57649,
 516773573,
 7761,
 -1,
 516822945,
 7763,
 517021396,
 516717764,
 -1,
 -57646,
 517004575,
 11386,
 -57645,
 517052140,
 42829,
 -1,
 517114840,
 42827,
 517283542,
 516997376,
 248,
 -1,
 517210240,
 511,
 517414616,
 517247812,
 491,
 -1,
 517341462,
 493,
 -57639,
 517368544,
 527,
 -57638,
 517494469,
 242,
 -57637,
 517549001,
 335,
 -1,
 517609377,
 243,
 517807841,
 514433538,
 -1,
 517873375,
 517771663,
 596,
 -1,
 517803536,
 7575,
 518062079,
 517816455,
 603,
 -1,
 517934608,
 7571,
 -57630,
 517787210,
 547,
 -57629,
 518099343,
 42831,
 -1,
 518152575,
 419,
 518332189,
 514343047,
 101,
 518397705,
 518261795,
 -1,
 518463219,
 518335710,
 -1,
 518528752,
 518417481,
 234,
 518651903,
 518455296,
 -1,
 518659823,
 518528363,
 -1,
 -57621,
 518637564,
 7877,
 -57620,
 518676133,
 7875,
 -57619,
 518739653,
 7873,
 -57618,
 518798139,
 7879,
 -1,
 518854561,
 7871,
 -1,
 518596691,
 7705,
 519118578,
 518472467,
 553,
 -1,
 519045259,
 7709,
 -1,
 519053852,
 283,
 519315194,
 518403616,
 -1,
 519380729,
 519278991,
 -1,
 519446264,
 519357142,
 -1,
 -57609,
 519383123,
 7865,
 -1,
 519444085,
 279,
 -1,
 519425870,
 517,
 -1,
 519332361,
 235,
 519773950,
 519274555,
 275,
 519897087,
 519700602,
 -1,
 -57603,
 519788229,
 7701,
 -1,
 519837601,
 7703,
 520036096,
 519751676,
 7869,
 -1,
 519963171,
 7707,
 -57599,
 520012032,
 583,
 -57598,
 520138023,
 7570,
 -57597,
 520196932,
 281,
 -57596,
 520261282,
 11384,
 -57595,
 520317664,
 519,
 -57594,
 520380069,
 7867,
 -57593,
 520443589,
 232,
 -57592,
 520498121,
 277,
 -1,
 520558497,
 233,
 520757010,
 518383569,
 658,
 520880127,
 520683520,
 -1,
 520888081,
 520806258,
 -1,
 520953615,
 520826078,
 -1,
 -57586,
 520934895,
 659,
 -1,
 520954396,
 495,
 -57584,
 520930179,
 442,
 -1,
 521121063,
 7578,
 -1,
 520858972,
 441,
 521346839,
 520731155,
 643,
 521469951,
 521276451,
 -1,
 -57579,
 521383207,
 7576,
 -57578,
 521445535,
 7563,
 -1,
 521483664,
 646,
 521674521,
 521323220,
 42859,
 -1,
 521623691,
 240,
 521805596,
 521623676,
 -1,
 -57573,
 521762428,
 42787,
 -1,
 521824048,
 42789,
 -1,
 521767863,
 331,
 522067796,
 518264180,
 97,
 522133320,
 521997347,
 -1,
 522198824,
 522071262,
 -1,
 522264359,
 522153033,
 226,
 522387455,
 522190970,
 -1,
 -57565,
 522307580,
 7851,
 -57564,
 522346149,
 7849,
 -57563,
 522409669,
 7847,
 -57562,
 522468155,
 7853,
 -1,
 522524577,
 7845,
 -1,
 522199580,
 462,
 522788657,
 522139168,
 -1,
 522854191,
 522752399,
 -1,
 522919726,
 522830550,
 -1,
 522985261,
 522851957,
 551,
 -1,
 522912022,
 481,
 -1,
 522922067,
 7841,
 -1,
 522899278,
 513,
 523304959,
 522805769,
 228,
 -1,
 523174166,
 479,
 523378488,
 522726345,
 259,
 523501567,
 523305082,
 -1,
 -57548,
 523421692,
 7861,
 -57547,
 523460261,
 7859,
 -57546,
 523523781,
 7857,
 -57545,
 523582267,
 7863,
 -1,
 523638689,
 7855,
 523837248,
 523348308,
 -1,
 523902783,
 523788671,
 -1,
 523968318,
 523865018,
 -1,
 524033853,
 523900533,
 229,
 -1,
 523960448,
 507,
 -1,
 523970643,
 7681,
 -1,
 523916528,
 7834,
 -1,
 523848730,
 7567,
 -57535,
 523814908,
 227,
 -57534,
 524337408,
 11365,
 -57533,
 524391236,
 261,
 -57532,
 524451899,
 257,
 -57531,
 524511968,
 515,
 -57530,
 524574373,
 7843,
 -57529,
 524637893,
 224,
 -1,
 524687265,
 225,
 524885836,
 522076295,
 230,
 525008895,
 524815395,
 -1,
 -57525,
 524910651,
 483,
 -1,
 524949409,
 509,
 525147982,
 524867502,
 42809,
 -1,
 525077889,
 42811,
 525279056,
 525106912,
 593,
 -1,
 525209104,
 7568,
 -57519,
 525263854,
 42813,
 -57518,
 525389386,
 42807,
 -57517,
 525439375,
 42805,
 -1,
 525473140,
 42803,
 525672325,
 522047050,
 117,
 525737857,
 525598720,
 -1,
 525803392,
 525721458,
 -1,
 525868901,
 525743648,
 -1,
 525934432,
 525820425,
 252,
 526057471,
 525860864,
 -1,
 526065503,
 525933931,
 -1,
 -57508,
 526024763,
 470,
 -57507,
 526079685,
 476,
 -57506,
 526134839,
 474,
 -1,
 526194593,
 472,
 -1,
 526002259,
 7795,
 526516223,
 525898127,
 -1,
 526524260,
 526438185,
 -1,
 -57501,
 526472901,
 533,
 -1,
 526522273,
 369,
 -1,
 526500577,
 7909,
 526786414,
 525819487,
 -1,
 526851949,
 526758809,
 432,
 526974975,
 526778490,
 -1,
 -57495,
 526895100,
 7919,
 -57494,
 526933669,
 7917,
 -57493,
 526997189,
 7915,
 -57492,
 527055675,
 7921,
 -1,
 527112097,
 7913,
 -1,
 526816229,
 7911,
 527376242,
 526764028,
 361,
 527499263,
 527302656,
 -1,
 -57487,
 527378515,
 7797,
 -1,
 527441264,
 7801,
 527638390,
 527314142,
 -1,
 527703925,
 527592521,
 251,
 -1,
 527630883,
 7799,
 -1,
 527639068,
 468,
 527900537,
 527608148,
 -1,
 -57480,
 527853739,
 367,
 -1,
 527911962,
 7577,
 528097147,
 527859771,
 363,
 -1,
 528023702,
 7803,
 -57476,
 528061252,
 371,
 -57475,
 528181984,
 535,
 -57474,
 528242373,
 249,
 -57473,
 528296905,
 365,
 -1,
 528357281,
 250,
 -1,
 525739854,
 649,
 528621443,
 525706961,
 650,
 -1,
 528551519,
 7551,
 -57468,
 528580581,
 42872,
 -1,
 528695431,
 7531,
 528883623,
 525645599,
 115,
 528949143,
 528813091,
 -1,
 529014669,
 528887006,
 -1,
 529080202,
 528949788,
 353,
 -1,
 529006778,
 7783,
 -57461,
 529044749,
 537,
 -57460,
 529165385,
 349,
 -1,
 529220371,
 351,
 529407889,
 528956204,
 -1,
 529473424,
 529344595,
 7779,
 -1,
 529399994,
 7785,
 -1,
 529405557,
 7777,
 529670035,
 529340321,
 347,
 -1,
 529596602,
 7781,
 -57452,
 529646141,
 575,
 -57451,
 529768607,
 7562,
 -57450,
 529827088,
 7540,
 -1,
 529882784,
 642,
 530063262,
 528901116,
 -1,
 530128795,
 530026895,
 7441,
 -57446,
 530096670,
 7442,
 -1,
 530124383,
 7443,
 -57444,
 530107978,
 7453,
 -57443,
 530304273,
 7455,
 -1,
 530331842,
 7454,
 530522020,
 530001118,
 -1,
 530587555,
 530473293,
 601,
 530710527,
 530517027,
 -1,
 -57438,
 530623783,
 7573,
 -1,
 530669216,
 602,
 -1,
 530559642,
 609,
 -57435,
 530491549,
 645,
 -57434,
 530864819,
 223,
 -1,
 530914392,
 42892,
 531111883,
 528853332,
 114,
 531177407,
 531038208,
 -1,
 531242942,
 531160946,
 -1,
 531308464,
 531184324,
 -1,
 531373999,
 531284694,
 -1,
 531439534,
 531310675,
 7771,
 -1,
 531366166,
 7773,
 -1,
 531371637,
 7769,
 -1,
 531353422,
 529,
 531701683,
 531264344,
 -1,
 -57422,
 531666469,
 636,
 -1,
 531720294,
 7775,
 531898293,
 531648672,
 638,
 -1,
 531824930,
 7539,
 532029368,
 531836126,
 -1,
 -57417,
 531972883,
 343,
 -1,
 532029980,
 345,
 -57415,
 532005763,
 637,
 -57414,
 532201728,
 589,
 -57413,
 532258975,
 7561,
 -57412,
 532317456,
 7538,
 -57411,
 532376288,
 531,
 -1,
 532420513,
 341,
 -1,
 531215586,
 42843,
 532684744,
 531123442,
 -1,
 532750276,
 532649791,
 604,
 532873215,
 532679715,
 -1,
 -57405,
 532786471,
 7572,
 -1,
 532831904,
 605,
 533012422,
 532688094,
 8580,
 -1,
 532942071,
 42815,
 -57401,
 532982155,
 639,
 -1,
 533086343,
 600,
 533274570,
 532664693,
 42869,
 -1,
 533203434,
 42845,
 -1,
 533208373,
 612,
 533471214,
 531067736,
 108,
 533536738,
 533400611,
 -1,
 533602258,
 533474526,
 -1,
 -57393,
 533583343,
 564,
 -57392,
 533621860,
 7741,
 -57391,
 533676819,
 316,
 -1,
 533733916,
 318,
 533929942,
 533543620,
 -1,
 533995477,
 533906145,
 7735,
 -1,
 533922070,
 7737,
 -1,
 533974831,
 11361,
 534192089,
 533890214,
 -1,
 -57384,
 534169596,
 619,
 -1,
 534199080,
 320,
 534388700,
 534128246,
 -1,
 -57381,
 534332953,
 620,
 -1,
 534388828,
 410,
 -57379,
 534364416,
 322,
 -57378,
 534555943,
 621,
 -57377,
 534618271,
 7557,
 -57376,
 534674168,
 7739,
 -57375,
 534732069,
 42825,
 -1,
 534779809,
 314,
 534978536,
 533501499,
 383,
 535101439,
 534907939,
 -1,
 535109607,
 534984224,
 -1,
 -57370,
 535075409,
 7835,
 -1,
 535126555,
 7836,
 -1,
 535059749,
 7837,
 -57367,
 534964000,
 683,
 -57366,
 535351669,
 42866,
 -57365,
 535410497,
 682,
 -57364,
 535457577,
 457,
 -57363,
 535514697,
 622,
 -1,
 535567526,
 411,
 535765006,
 533422463,
 105,
 535830532,
 535694371,
 -1,
 535896054,
 535770656,
 -1,
 535961588,
 535859599,
 -1,
 -57357,
 535940942,
 521,
 -1,
 536003297,
 7883,
 536215551,
 535912969,
 239,
 -1,
 536084608,
 7727,
 536289272,
 535873532,
 297,
 -1,
 536216099,
 7725,
 536420347,
 536227038,
 -1,
 -57350,
 536374345,
 238,
 -1,
 536420892,
 464,
 -57348,
 536396032,
 616,
 -57347,
 536587559,
 7574,
 -57346,
 536646468,
 303,
 -57345,
 536707131,
 299,
 -57344,
 536767200,
 523,
 -57343,
 536829605,
 7881,
 -57342,
 536893125,
 236,
 -57341,
 536947657,
 301,
 -1,
 537008033,
 237,
 537206795,
 535793388,
 -1,
 -57338,
 537182932,
 42887,
 -57337,
 537245471,
 42885,
 -57336,
 537307476,
 42883,
 -57335,
 537350883,
 7545,
 -57334,
 537415254,
 42876,
 -1,
 537474592,
 42874,
 537665549,
 537172614,
 617,
 -1,
 537595487,
 7548,
 -1,
 537638687,
 42861,
 537862192,
 535705120,
 100,
 537927713,
 537791523,
 -1,
 537993237,
 537865438,
 -1,
 -57326,
 537974255,
 545,
 -57325,
 538012772,
 7699,
 -57324,
 538067731,
 7697,
 -1,
 538124828,
 271,
 538320920,
 537969364,
 -1,
 -57321,
 538285825,
 396,
 -1,
 538319166,
 598,
 538517530,
 538271392,
 599,
 -1,
 538444167,
 7569,
 538648605,
 538458924,
 -1,
 -57316,
 538585171,
 7693,
 -1,
 538646133,
 7691,
 -57314,
 538624256,
 273,
 -57313,
 538812575,
 7553,
 -57312,
 538871056,
 7533,
 -1,
 538934008,
 7695,
 539107366,
 537913118,
 499,
 539230207,
 539033600,
 -1,
 539238437,
 539113920,
 675,
 -1,
 539167915,
 677,
 -1,
 539221905,
 454,
 539435051,
 539073247,
 -1,
 539500586,
 539389737,
 567,
 539623423,
 539430495,
 607,
 -1,
 539492570,
 644,
 -1,
 539451775,
 305,
 539762734,
 539377799,
 -1,
 -57299,
 539748308,
 676,
 -1,
 539786996,
 7839,
 -57297,
 539742581,
 42865,
 -1,
 539895416,
 568,
 540090440,
 537823455,
 110,
 540155974,
 540016640,
 -1,
 540221509,
 540139378,
 -1,
 540287032,
 540159198,
 -1,
 -57291,
 540268015,
 565,
 -57290,
 540306532,
 7755,
 -57289,
 540361491,
 326,
 -1,
 540418588,
 328,
 540614716,
 540242776,
 -1,
 -57286,
 540579373,
 414,
 -57285,
 540633190,
 7753,
 -1,
 540689359,
 626,
 540876863,
 540556076,
 -1,
 -57282,
 540813395,
 7751,
 -1,
 540874357,
 7749,
 -57280,
 540854268,
 241,
 -57279,
 541044007,
 627,
 -57278,
 541106335,
 7559,
 -57277,
 541164816,
 7536,
 -57276,
 541218501,
 505,
 -1,
 541267873,
 324,
 -1,
 540190188,
 329,
 -57273,
 540135797,
 42868,
 -1,
 541486889,
 460,
 541663324,
 540039307,
 104,
 541728856,
 541592611,
 -1,
 541794384,
 541668896,
 -1,
 541859918,
 541760077,
 -1,
 -57267,
 541796435,
 7717,
 -1,
 541857397,
 7715,
 -57265,
 541811209,
 7719,
 -1,
 542001765,
 11368,
 542187604,
 541732062,
 -1,
 -57262,
 542141513,
 293,
 -57261,
 542196499,
 7721,
 -1,
 542253596,
 543,
 -57259,
 542163200,
 295,
 -57258,
 542407416,
 7830,
 -57257,
 542465696,
 614,
 -1,
 542518223,
 7723,
 542711898,
 541673374,
 42791,
 -1,
 542641526,
 615,
 -57253,
 542693294,
 405,
 -1,
 542776142,
 11382,
 542974064,
 541600990,
 99,
 543039592,
 542903331,
 -1,
 543105124,
 542977246,
 -1,
 543170657,
 543048467,
 231,
 -1,
 543096960,
 7689,
 -57246,
 543151599,
 597,
 -57245,
 543255625,
 265,
 -1,
 543302172,
 269,
 -57243,
 543080704,
 572,
 -57242,
 543448736,
 392,
 -57241,
 543505201,
 267,
 -1,
 543561633,
 263,
 543760493,
 542997929,
 -1,
 543826028,
 543723919,
 -1,
 -57237,
 543793688,
 666,
 -1,
 543851465,
 631,
 -1,
 543796645,
 606,
 544088175,
 543739617,
 42797,
 -1,
 544017548,
 42799,
 -1,
 544052525,
 42863,
 544284804,
 542959390,
 122,
 544407551,
 544214051,
 -1,
 544415863,
 544290336,
 -1,
 544481398,
 544381517,
 -1,
 -57227,
 544417875,
 7827,
 -1,
 544478837,
 380,
 -1,
 544426597,
 11372,
 544743547,
 544353502,
 -1,
 -57223,
 544724463,
 657,
 -57222,
 544762953,
 7825,
 -1,
 544809500,
 382,
 545005694,
 544716575,
 -1,
 -57219,
 544988654,
 576,
 -1,
 545049556,
 438,
 -57217,
 544976167,
 656,
 -57216,
 545169567,
 7566,
 -57215,
 545228048,
 7542,
 -57214,
 545291000,
 7829,
 -57213,
 545349280,
 549,
 -1,
 545396641,
 378,
 545595542,
 544269294,
 121,
 545661077,
 545524771,
 -1,
 545726603,
 545601056,
 -1,
 545792138,
 545692237,
 -1,
 -57207,
 545728595,
 7925,
 -1,
 545789557,
 7823,
 -1,
 545743369,
 255,
 546054285,
 545676960,
 436,
 -1,
 545980421,
 7927,
 -57202,
 546031612,
 7929,
 -57201,
 546160896,
 591,
 -57200,
 546222512,
 7833,
 -57199,
 546275387,
 563,
 -57198,
 546340238,
 7935,
 -57197,
 546395845,
 7923,
 -57196,
 546451637,
 375,
 -1,
 546510753,
 253,
 -1,
 545624880,
 541,
 546775206,
 545550472,
 107,
 546840741,
 546704419,
 -1,
 546906268,
 546780704,
 -1,
 -57190,
 546871898,
 7731,
 -57189,
 546923035,
 42819,
 -1,
 546982501,
 11370,
 547168414,
 546881792,
 42817,
 -1,
 547094693,
 42821,
 547299489,
 547106014,
 -1,
 -57184,
 547242771,
 311,
 -1,
 547299868,
 489,
 -57182,
 547266719,
 7556,
 -57181,
 547453688,
 7733,
 -57180,
 547511968,
 409,
 -1,
 547559329,
 7729,
 -1,
 546810287,
 312,
 547823797,
 546722531,
 103,
 547889331,
 547752995,
 -1,
 547954860,
 547826910,
 -1,
 -57174,
 547908681,
 285,
 -57173,
 547963667,
 291,
 -1,
 548020764,
 487,
 -57171,
 547930368,
 485,
 -57170,
 548184223,
 7555,
 -57169,
 548241467,
 7713,
 -57168,
 548298400,
 608,
 -57167,
 548354865,
 289,
 -57166,
 548416457,
 287,
 -1,
 548476833,
 501,
 -57164,
 547847688,
 578,
 -1,
 548609258,
 611,
 548806851,
 547759734,
 98,
 548872384,
 548736035,
 -1,
 548937914,
 548813612,
 -1,
 -57159,
 548874323,
 7685,
 -1,
 548935285,
 7683,
 -57157,
 548915814,
 387,
 -57156,
 549110016,
 384,
 -57155,
 549167263,
 7552,
 -57154,
 549225744,
 7532,
 -57153,
 549288696,
 7687,
 -1,
 549346976,
 595,
 -57151,
 548844582,
 42823,
 -57150,
 549493535,
 7447,
 -1,
 549528147,
 629,
 549724368,
 548788142,
 118,
 549789901,
 549653539,
 -1,
 549855432,
 549729824,
 -1,
 -57145,
 549821018,
 7807,
 -1,
 549872155,
 42847,
 -57143,
 549832700,
 7805,
 -57142,
 550023025,
 11377,
 -57141,
 550084767,
 7564,
 -57140,
 550133408,
 651,
 -1,
 550188432,
 11380,
 -57138,
 549774318,
 42849,
 -57137,
 550333731,
 42851,
 -1,
 550389605,
 42857,
 550576349,
 549691369,
 112,
 550641884,
 550505507,
 -1,
 550707414,
 550614815,
 -1,
 550772949,
 550685652,
 7549,
 -1,
 550701803,
 42833,
 -1,
 550742277,
 42837,
 -57129,
 550674591,
 7560,
 -57128,
 550929680,
 7537,
 -57127,
 550985376,
 421,
 -57126,
 551047517,
 42835,
 -57125,
 551107377,
 7767,
 -1,
 551163809,
 7765,
 -1,
 550591625,
 632,
 551428330,
 550535141,
 109,
 551493862,
 551357475,
 -1,
 551559394,
 551435052,
 -1,
 -57119,
 551495763,
 7747,
 -1,
 551556725,
 7745,
 -57117,
 551526559,
 7558,
 -57116,
 551716112,
 7535,
 -57115,
 551771808,
 625,
 -1,
 551819169,
 7743,
 552018153,
 551445311,
 -1,
 -57112,
 551999406,
 7933,
 -1,
 552041474,
 7931,
 -1,
 551997813,
 42867,
 552280310,
 551410952,
 119,
 552402943,
 552209443,
 -1,
 552411377,
 552285728,
 -1,
 552476912,
 552376909,
 -1,
 -57105,
 552413267,
 7817,
 -1,
 552474229,
 7815,
 -1,
 552428041,
 7813,
 -57102,
 552382896,
 7832,
 -57101,
 552689312,
 11379,
 -57100,
 552752837,
 7809,
 -57099,
 552808629,
 373,
 -1,
 552867745,
 7811,
 553066749,
 552249156,
 113,
 553132284,
 552995875,
 -1,
 553197818,
 553082528,
 672,
 -1,
 553126574,
 587,
 -57093,
 553173320,
 42839,
 -1,
 553269511,
 42841,
 -1,
 553099246,
 569,
 553525508,
 553012822,
 102,
 553591043,
 553454627,
 -1,
 -57088,
 553558175,
 7554,
 -57087,
 553616656,
 7534,
 -57086,
 553672352,
 402,
 -1,
 553728817,
 7711,
 -1,
 553535394,
 681,
 553984267,
 553479977,
 106,
 554106879,
 553913379,
 -1,
 554115338,
 553987294,
 -1,
 -57080,
 554087591,
 669,
 -57079,
 554134601,
 309,
 -1,
 554181148,
 496,
 -1,
 554090752,
 585,
 554500095,
 553968388,
 120,
 554565631,
 554372131,
 -1,
 554574096,
 554448416,
 -1,
 -57073,
 554539601,
 7819,
 -1,
 554590729,
 7821,
 -1,
 554541215,
 7565,
 554893311,
 509830303,
 -1,
 554901784,
 554782294,
 -1,
 554967318,
 554847830,
 64256,
 -57067,
 554922840,
 64260,
 -1,
 554983807,
 64259,
 -57065,
 554922840,
 64258,
 -1,
 555114879,
 64257,
 -57063,
 554876939,
 64262,
 -57062,
 555258581,
 339,
 -57061,
 555318641,
 64261,
 -1,
 555378087,
 307,
 555614207,
 509750788,
 -1,
 -57058,
 555536028,
 7550,
 -1,
 555573722,
 7547,
 555810815,
 509726622,
 -1,
 -57055,
 555737860,
 8339,
 -57054,
 555800494,
 7525,
 -57053,
 555863626,
 7524,
 -57052,
 555923581,
 8340,
 -57051,
 555985236,
 7523,
 -57050,
 556044687,
 8338,
 -57049,
 556101417,
 11388,
 -57048,
 556163455,
 7522,
 -57047,
 556220551,
 8337,
 -1,
 556275060,
 8336,
 556475195,
 509619422,
 -1,
 556540730,
 556408797,
 -1,
 556606263,
 556485683,
 -1,
 556671336,
 556568975,
 79,
 556736866,
 556600355,
 -1,
 556802360,
 556686943,
 -1,
 556867895,
 556774297,
 416,
 556990463,
 556793978,
 -1,
 -57037,
 556910588,
 7904,
 -57036,
 556949157,
 7902,
 -57035,
 557012677,
 7900,
 -57034,
 557071163,
 7906,
 -1,
 557127585,
 7898,
 -1,
 556831717,
 7886,
 557392195,
 556742176,
 -1,
 557457729,
 557355407,
 -1,
 557523262,
 557433558,
 -1,
 557588797,
 557454965,
 558,
 -1,
 557515030,
 560,
 -1,
 557525075,
 7884,
 557842431,
 557502249,
 -1,
 -57024,
 557733573,
 524,
 -1,
 557782945,
 336,
 558039039,
 557408777,
 214,
 -1,
 557908246,
 554,
 558113100,
 557329630,
 -1,
 558178635,
 558066761,
 212,
 558301183,
 558104698,
 -1,
 -57017,
 558221308,
 7894,
 -57016,
 558259877,
 7892,
 -57015,
 558323397,
 7890,
 -57014,
 558381883,
 7896,
 -1,
 558438305,
 7888,
 -1,
 558113308,
 465,
 558702929,
 558090236,
 213,
 558825471,
 558628986,
 -1,
 -57009,
 558727227,
 556,
 -57008,
 558774430,
 7758,
 -1,
 558831521,
 7756,
 559030615,
 558661605,
 -1,
 559096150,
 558962575,
 332,
 559218687,
 559022202,
 -1,
 -57003,
 559109829,
 7760,
 -1,
 559159201,
 7762,
 -1,
 559047475,
 415,
 559423833,
 559005952,
 216,
 -1,
 559349888,
 510,
 559554907,
 559387460,
 490,
 -1,
 559481110,
 492,
 559685982,
 559512772,
 -1,
 -56995,
 559650540,
 42828,
 -1,
 559713240,
 42826,
 -56993,
 559639264,
 526,
 -56992,
 559830725,
 210,
 -56991,
 559885257,
 334,
 -1,
 559945633,
 211,
 560144741,
 556704258,
 -1,
 -56988,
 560107919,
 390,
 -1,
 560152711,
 400,
 -56986,
 560123466,
 546,
 -56985,
 560304527,
 42830,
 -1,
 560357759,
 418,
 560538011,
 556602740,
 65,
 560603535,
 560466979,
 -1,
 560669043,
 560540894,
 -1,
 560734578,
 560622665,
 194,
 560857087,
 560660602,
 -1,
 -56978,
 560777212,
 7850,
 -56977,
 560815781,
 7848,
 -56976,
 560879301,
 7846,
 -56975,
 560937787,
 7852,
 -1,
 560994209,
 7844,
 -1,
 560669212,
 461,
 561258876,
 560608800,
 -1,
 561324410,
 561222031,
 -1,
 561389945,
 561300182,
 -1,
 561455480,
 561321589,
 550,
 -1,
 561381654,
 480,
 -1,
 561391699,
 7840,
 -1,
 561368910,
 512,
 561774591,
 561275401,
 196,
 -1,
 561643798,
 478,
 561848707,
 561195977,
 258,
 561971199,
 561774714,
 -1,
 -56961,
 561891324,
 7860,
 -56960,
 561929893,
 7858,
 -56959,
 561993413,
 7856,
 -56958,
 562051899,
 7862,
 -1,
 562108321,
 7854,
 562307463,
 561820074,
 -1,
 562372998,
 562239093,
 197,
 -1,
 562299008,
 506,
 -1,
 562309203,
 7680,
 -56952,
 562284540,
 195,
 -56951,
 562544896,
 570,
 -56950,
 562598724,
 260,
 -56949,
 562659387,
 256,
 -56948,
 562719456,
 514,
 -56947,
 562781861,
 7842,
 -56946,
 562845381,
 192,
 -1,
 562894753,
 193,
 563093907,
 560545927,
 198,
 563216383,
 563022883,
 -1,
 -56942,
 563118139,
 482,
 -1,
 563156897,
 508,
 563356053,
 563074990,
 42808,
 -1,
 563285377,
 42810,
 -56938,
 563340270,
 42812,
 -56937,
 563465802,
 42806,
 -56936,
 563515791,
 42804,
 -56935,
 563576544,
 11373,
 -56934,
 563630662,
 393,
 -1,
 563680628,
 42802,
 563880393,
 560480391,
 69,
 563945918,
 563809315,
 -1,
 564011434,
 563883230,
 -1,
 564076967,
 563965001,
 202,
 564199423,
 564002816,
 -1,
 564208038,
 564075883,
 -1,
 -56926,
 564185084,
 7876,
 -56925,
 564223653,
 7874,
 -56924,
 564287173,
 7872,
 -56923,
 564345659,
 7878,
 -1,
 564402081,
 7870,
 -1,
 564144211,
 7704,
 564666793,
 564019987,
 552,
 -1,
 564592779,
 7708,
 -1,
 564601372,
 282,
 564863409,
 563951136,
 -1,
 564928944,
 564826511,
 -1,
 564994479,
 564904662,
 -1,
 -56914,
 564930643,
 7864,
 -1,
 564991605,
 278,
 -1,
 564973390,
 516,
 -1,
 564879881,
 203,
 565322165,
 564822075,
 274,
 565444607,
 565248122,
 -1,
 -56908,
 565335749,
 7700,
 -1,
 565385121,
 7702,
 565584311,
 565299196,
 7868,
 -1,
 565510691,
 7706,
 -56904,
 565559552,
 582,
 -56903,
 565678916,
 280,
 -56902,
 565734112,
 518,
 -56901,
 565796517,
 7866,
 -56900,
 565860037,
 200,
 -56899,
 565914569,
 276,
 -1,
 565974945,
 201,
 566174146,
 563931089,
 439,
 566296575,
 566099968,
 -1,
 -56895,
 566222737,
 494,
 -1,
 566275420,
 440,
 566436292,
 566149844,
 42858,
 -1,
 566384779,
 208,
 566567367,
 566384764,
 -1,
 -56890,
 566523516,
 42786,
 -1,
 566585136,
 42788,
 -56888,
 566540819,
 425,
 -1,
 566725559,
 330,
 566895093,
 563859018,
 85,
 566960628,
 566820864,
 -1,
 567026163,
 566943602,
 -1,
 567091674,
 566965792,
 -1,
 567157205,
 567042569,
 220,
 567279615,
 567083008,
 -1,
 567288276,
 567156075,
 -1,
 -56879,
 567246907,
 469,
 -56878,
 567301829,
 475,
 -56877,
 567356983,
 473,
 -1,
 567416737,
 471,
 -1,
 567224403,
 7794,
 567738367,
 567120271,
 -1,
 567747033,
 567660329,
 -1,
 -56872,
 567695045,
 532,
 -1,
 567744417,
 368,
 -1,
 567722721,
 7908,
 568009187,
 567041631,
 -1,
 568074722,
 567980953,
 431,
 568197119,
 568000634,
 -1,
 -56866,
 568117244,
 7918,
 -56865,
 568155813,
 7916,
 -56864,
 568219333,
 7914,
 -56863,
 568277819,
 7920,
 -1,
 568334241,
 7912,
 -1,
 568038373,
 7910,
 568599015,
 567986172,
 360,
 568721407,
 568524800,
 -1,
 -56858,
 568600659,
 7796,
 -1,
 568663408,
 7800,
 568861163,
 568536286,
 -1,
 568926698,
 568814665,
 219,
 -1,
 568853027,
 7798,
 -1,
 568861212,
 467,
 569123309,
 568819771,
 362,
 -1,
 569049238,
 7802,
 -56850,
 569094576,
 366,
 -56849,
 569217860,
 370,
 -56848,
 569273056,
 534,
 -56847,
 569333445,
 217,
 -56846,
 569387977,
 364,
 -1,
 569448353,
 218,
 -1,
 566961998,
 580,
 -1,
 566929105,
 433,
 569778709,
 566870740,
 84,
 569844229,
 569707555,
 -1,
 569909756,
 569781470,
 -1,
 -56839,
 569873677,
 538,
 -56838,
 569928804,
 7792,
 -56837,
 569983763,
 354,
 -1,
 570040860,
 356,
 570237441,
 569849376,
 -1,
 570302976,
 570202701,
 -1,
 -56833,
 570239059,
 7788,
 -1,
 570300021,
 7786,
 -1,
 570253851,
 574,
 -56830,
 570212608,
 358,
 -56829,
 570535207,
 430,
 -56828,
 570587896,
 7790,
 -1,
 570646176,
 428,
 570827276,
 569824772,
 -1,
 570892808,
 570758516,
 11375,
 -1,
 570851040,
 11376,
 -56823,
 570873774,
 581,
 -56822,
 570982373,
 412,
 -56821,
 571044696,
 42880,
 -1,
 571107764,
 42878,
 571286032,
 570791363,
 -1,
 -56818,
 571264354,
 423,
 -56817,
 571325716,
 388,
 -1,
 571363508,
 444,
 571548179,
 571236273,
 222,
 571670527,
 571477599,
 42852,
 -1,
 571542251,
 42854,
 -56812,
 571533086,
 42792,
 -1,
 571714834,
 42794,
 571875893,
 569729407,
 73,
 571941420,
 571804707,
 -1,
 572006943,
 571880992,
 -1,
 572072477,
 571969935,
 -1,
 572138012,
 572048086,
 -1,
 -56805,
 572074067,
 7882,
 -1,
 572135029,
 304,
 -1,
 572116814,
 520,
 572456959,
 572023305,
 207,
 -1,
 572326016,
 7726,
 572531233,
 571983868,
 296,
 -1,
 572457507,
 7724,
 572662308,
 572468446,
 -1,
 -56797,
 572615753,
 206,
 -1,
 572662300,
 463,
 -56795,
 572637440,
 407,
 -56794,
 572822340,
 302,
 -56793,
 572883003,
 298,
 -56792,
 572943072,
 522,
 -56791,
 573005477,
 7880,
 -56790,
 573068997,
 204,
 -56789,
 573123529,
 300,
 -1,
 573183905,
 205,
 573383219,
 571903724,
 -1,
 -56786,
 573358804,
 42886,
 -56785,
 573421343,
 42884,
 -56784,
 573483348,
 42882,
 -56783,
 573526755,
 42877,
 -56782,
 573591126,
 42875,
 -1,
 573650464,
 42873,
 -56780,
 573355807,
 42860,
 -1,
 573807238,
 406,
 573973064,
 571848479,
 83,
 574038596,
 573901859,
 -1,
 574104125,
 573975774,
 -1,
 574169658,
 574038556,
 352,
 -1,
 574095546,
 7782,
 -56773,
 574133517,
 536,
 -56772,
 574254153,
 348,
 -1,
 574309139,
 350,
 574497345,
 574044972,
 -1,
 574562880,
 574433363,
 7778,
 -1,
 574488762,
 7784,
 -1,
 574494325,
 7776,
 574759491,
 574429089,
 346,
 -1,
 574685370,
 7780,
 -1,
 574734909,
 11390,
 -56763,
 573997481,
 586,
 -56762,
 574905011,
 7838,
 -56761,
 574959647,
 399,
 -1,
 575020120,
 42891,
 575218270,
 573942100,
 82,
 575283802,
 575143936,
 -1,
 575349337,
 575266674,
 -1,
 575414865,
 575290052,
 -1,
 575480400,
 575390422,
 -1,
 575545935,
 575416403,
 7770,
 -1,
 575471894,
 7772,
 -1,
 575477365,
 7768,
 -1,
 575459150,
 528,
 575808084,
 575352030,
 -1,
 -56749,
 575750931,
 342,
 -1,
 575808028,
 344,
 -56747,
 575783811,
 11364,
 -56746,
 575979776,
 588,
 -56745,
 576027384,
 7774,
 -56744,
 576088800,
 530,
 -1,
 576133025,
 340,
 -1,
 575321314,
 42842,
 576397917,
 575229170,
 -1,
 -56740,
 576340103,
 398,
 -1,
 576400682,
 42814,
 -1,
 576377216,
 42844,
 576660083,
 575173464,
 76,
 576725618,
 576588835,
 -1,
 576791140,
 576666308,
 -1,
 576856675,
 576766689,
 7734,
 -1,
 576782614,
 7736,
 -1,
 576835375,
 11360,
 577053288,
 576728286,
 -1,
 -56730,
 577006692,
 7740,
 -56729,
 577061651,
 315,
 -1,
 577118748,
 317,
 577315435,
 577025823,
 -1,
 -56726,
 577293268,
 321,
 -1,
 577339789,
 456,
 577512046,
 577275046,
 -1,
 -56723,
 577488892,
 11362,
 -1,
 577518376,
 319,
 -56721,
 577469176,
 7738,
 -56720,
 577658149,
 42824,
 -56719,
 577709902,
 573,
 -1,
 577771425,
 313,
 -1,
 576679721,
 455,
 578036356,
 576644078,
 89,
 578101891,
 577965091,
 -1,
 578167418,
 578041376,
 -1,
 578232953,
 578132557,
 -1,
 -56712,
 578168915,
 7924,
 -1,
 578229877,
 7822,
 -1,
 578183689,
 376,
 578495100,
 578117280,
 435,
 -1,
 578420741,
 7926,
 -56707,
 578471932,
 7928,
 -56706,
 578601216,
 590,
 -56705,
 578650171,
 562,
 -56704,
 578715022,
 7934,
 -56703,
 578770629,
 7922,
 -56702,
 578826421,
 374,
 -1,
 578885537,
 221,
 -1,
 578065200,
 540,
 579150486,
 577997023,
 78,
 579216021,
 579079203,
 -1,
 579281546,
 579171160,
 -1,
 -56696,
 579245613,
 544,
 -56695,
 579299430,
 7752,
 -1,
 579355599,
 413,
 579543694,
 579218654,
 -1,
 -56692,
 579497060,
 7754,
 -56691,
 579552019,
 325,
 -1,
 579609116,
 327,
 579805841,
 579484460,
 -1,
 -56688,
 579741779,
 7750,
 -1,
 579802741,
 7748,
 -56686,
 579782652,
 209,
 -56685,
 579976728,
 459,
 -56684,
 580015813,
 504,
 -1,
 580065185,
 323,
 -1,
 579170089,
 458,
 580330152,
 579089952,
 68,
 580395686,
 580258851,
 -1,
 580461212,
 580368159,
 -1,
 580526747,
 580419995,
 498,
 -1,
 580455477,
 453,
 -1,
 580504532,
 272,
 580723360,
 580398302,
 -1,
 -56674,
 580676708,
 7698,
 -56673,
 580731667,
 7696,
 -1,
 580788764,
 270,
 580985507,
 580664108,
 -1,
 -56670,
 580921427,
 7692,
 -1,
 580982389,
 7690,
 -56668,
 580962918,
 395,
 -56667,
 581139192,
 7694,
 -1,
 581197472,
 394,
 581435391,
 580380446,
 497,
 -1,
 581307445,
 452,
 581509817,
 580278411,
 72,
 581575350,
 581438499,
 -1,
 581640880,
 581514784,
 -1,
 581706414,
 581605965,
 -1,
 -56659,
 581642323,
 7716,
 -1,
 581703285,
 7714,
 -56657,
 581657097,
 7718,
 -1,
 581847653,
 11367,
 582034100,
 581577950,
 -1,
 -56654,
 581987401,
 292,
 -56653,
 582042387,
 7720,
 -1,
 582099484,
 542,
 -56651,
 582009088,
 294,
 -1,
 582233039,
 7722,
 -56649,
 581557579,
 502,
 -56648,
 582371230,
 42790,
 -1,
 582425422,
 11381,
 582623943,
 581456611,
 71,
 582689477,
 582552611,
 -1,
 582755007,
 582626526,
 -1,
 -56643,
 582708297,
 284,
 -56642,
 582763283,
 290,
 -1,
 582820380,
 486,
 -56640,
 582729984,
 484,
 -56639,
 582975547,
 7712,
 -56638,
 583032480,
 403,
 -56637,
 583088945,
 288,
 -56636,
 583150537,
 286,
 -1,
 583210913,
 500,
 -56634,
 582647304,
 577,
 -1,
 583343338,
 404,
 583541461,
 582560990,
 67,
 583606994,
 583470115,
 -1,
 583672526,
 583544030,
 -1,
 583738060,
 583615251,
 199,
 -1,
 583663744,
 7688,
 -56627,
 583691337,
 264,
 -1,
 583803420,
 268,
 -56625,
 583647488,
 571,
 -56624,
 583949984,
 391,
 -56623,
 584006449,
 266,
 -1,
 584062881,
 262,
 584262356,
 583585505,
 42796,
 -1,
 584191116,
 42798,
 -1,
 584226093,
 42862,
 584458981,
 583526174,
 90,
 584581119,
 584387619,
 -1,
 584590044,
 584463904,
 -1,
 584655579,
 584555085,
 -1,
 -56614,
 584591443,
 7826,
 -1,
 584652405,
 379,
 -1,
 584600165,
 11371,
 584917727,
 584562463,
 -1,
 -56610,
 584900078,
 11391,
 -1,
 584960980,
 437,
 585114338,
 584854750,
 -1,
 -56607,
 585067593,
 7824,
 -1,
 585114140,
 381,
 -56605,
 585071352,
 7828,
 -56604,
 585260704,
 548,
 -1,
 585308065,
 377,
 585507571,
 584413320,
 75,
 585629695,
 585436195,
 -1,
 585638635,
 585512480,
 -1,
 -56599,
 585603674,
 7730,
 -56598,
 585654811,
 42818,
 -1,
 585714277,
 11369,
 585900781,
 585613568,
 42816,
 -1,
 585826469,
 42820,
 586031856,
 585837790,
 -1,
 -56593,
 585974547,
 310,
 -1,
 586031644,
 488,
 -56591,
 585988856,
 7732,
 -56590,
 586178208,
 408,
 -1,
 586225569,
 7728,
 586425087,
 585489672,
 87,
 586490622,
 586353699,
 -1,
 586556154,
 586429984,
 -1,
 586621689,
 586521165,
 -1,
 -56584,
 586557523,
 7816,
 -1,
 586618485,
 7814,
 -1,
 586572297,
 7812,
 -56581,
 586505888,
 11378,
 -56580,
 586831557,
 7808,
 -56579,
 586887349,
 372,
 -1,
 586946465,
 7810,
 -1,
 586475046,
 503,
 587211529,
 586405806,
 86,
 587277062,
 587140131,
 -1,
 587342596,
 587216416,
 -1,
 -56573,
 587307610,
 7806,
 -1,
 587358747,
 42846,
 -56571,
 587319292,
 7804,
 -1,
 587488928,
 434,
 -56569,
 587260910,
 42848,
 -56568,
 587623715,
 42850,
 -1,
 587679589,
 42856,
 587866899,
 587177961,
 80,
 587988991,
 587795491,
 -1,
 587997967,
 587904799,
 -1,
 588063502,
 587975636,
 11363,
 -1,
 587991787,
 42832,
 -1,
 588032261,
 42836,
 -56560,
 587947680,
 420,
 -56559,
 588206429,
 42834,
 -56558,
 588266289,
 7766,
 -1,
 588322721,
 7764,
 588522269,
 587802230,
 66,
 588587804,
 588450851,
 -1,
 588653336,
 588528428,
 -1,
 -56553,
 588589139,
 7684,
 -1,
 588650101,
 7682,
 -56551,
 588630630,
 386,
 -56550,
 588824832,
 579,
 -56549,
 588872440,
 7686,
 -1,
 588930720,
 385,
 -1,
 588559398,
 42822,
 589177639,
 588480485,
 77,
 589243172,
 589106211,
 -1,
 589308706,
 589183788,
 -1,
 -56543,
 589244499,
 7746,
 -1,
 589305461,
 7744,
 -56541,
 589258400,
 11374,
 -1,
 589436833,
 7742,
 589692927,
 589194047,
 -1,
 -56538,
 589617070,
 7932,
 -1,
 589659138,
 7930,
 589833003,
 589161220,
 88,
 589955071,
 589761718,
 -1,
 -56534,
 589863505,
 7818,
 -1,
 589914633,
 7820,
 590095151,
 589801284,
 81,
 590217215,
 590023715,
 -1,
 -56530,
 590135624,
 42838,
 -1,
 590166279,
 42840,
 590357299,
 590049065,
 74,
 590479359,
 590285859,
 -1,
 -56526,
 590397696,
 584,
 -1,
 590426293,
 308,
 590675967,
 590302806,
 70,
 590741503,
 590548003,
 -1,
 -56522,
 590634656,
 401,
 -1,
 590691121,
 7710,
 590938111,
 556557471,
 -1,
 -56519,
 590844629,
 338,
 -1,
 590898599,
 306,
 -1,
 556512391,
 10013,
 591143808,
 556431834,
 -1,
 591209320,
 591116063,
 -1,
 591274855,
 591167796,
 -1,
 591340355,
 591243604,
 640,
 591405890,
 591285490,
 -1,
 -56511,
 591374676,
 7449,
 -1,
 591431903,
 7438,
 -1,
 591384949,
 42870,
 591668039,
 591303055,
 7439,
 -56507,
 591646282,
 7445,
 -56506,
 591700510,
 7440,
 -1,
 591741063,
 630,
 591930187,
 591643348,
 7451,
 592052223,
 591910404,
 -1,
 -56502,
 591964500,
 7450,
 -1,
 592003207,
 11387,
 592192334,
 591872135,
 7431,
 -56499,
 592177105,
 7459,
 -1,
 592233999,
 7430,
 592388944,
 592147288,
 671,
 -1,
 592318047,
 7436,
 592520018,
 592339327,
 618,
 -1,
 592482572,
 641,
 592651092,
 592466659,
 610,
 -1,
 592579958,
 667,
 592782166,
 592586358,
 665,
 -1,
 592716363,
 7427,
 592913240,
 592713076,
 7424,
 -1,
 592855175,
 7425,
 -56487,
 592897822,
 7458,
 -56486,
 593028078,
 655,
 -56485,
 593091848,
 7457,
 -56484,
 593156014,
 7456,
 -56483,
 593219146,
 7452,
 -56482,
 593278751,
 42801,
 -56481,
 593338345,
 7448,
 -56480,
 593397983,
 628,
 -56479,
 593461221,
 7437,
 -56478,
 593522824,
 7435,
 -56477,
 593588009,
 7434,
 -56476,
 593647755,
 668,
 -56475,
 593710678,
 42800,
 -56474,
 593770016,
 7429,
 -1,
 593833182,
 7428,
 -1,
 591252198,
 663,
 594092909,
 591178628,
 -1,
 594158444,
 594074151,
 -1,
 -56469,
 594105847,
 674,
 -1,
 594168454,
 426,
 -1,
 594135987,
 451,
 594420594,
 594028877,
 -1,
 594486129,
 594375667,
 -1,
 -56464,
 594453102,
 684,
 -1,
 594489711,
 664,
 -1,
 594425824,
 685,
 594748276,
 594373435,
 662,
 -1,
 594677343,
 446,
 594879350,
 594695658,
 660,
 -1,
 594808415,
 673,
 595010425,
 594810228,
 -1,
 -56456,
 594968480,
 450,
 -1,
 595027760,
 7461,
 -56454,
 594994834,
 422,
 -56453,
 595190527,
 447,
 -56452,
 595254334,
 7460,
 -56451,
 595316249,
 443,
 -56450,
 595370806,
 661,
 -56449,
 595424687,
 449,
 -1,
 595474387,
 448,
 595722239,
 591087811,
 -1,
 595731332,
 595635557,
 -1,
 -56445,
 595697641,
 43004,
 -1,
 595742294,
 43003,
 595927943,
 595681663,
 -1,
 -56442,
 595890434,
 43005,
 -1,
 595920299,
 43006,
 -1,
 595861836,
 43007,
 596190176,
 509579665,
 -1,
 596255664,
 596146650,
 -1,
 596321167,
 596230868,
 -1,
 596386702,
 596270690,
 -1,
 -56435,
 596362229,
 3735,
 -1,
 596427207,
 3734,
 -1,
 596349327,
 3733,
 596648852,
 596287465,
 -1,
 596714387,
 596598370,
 -1,
 -56430,
 596689909,
 3742,
 -1,
 596754887,
 3740,
 -1,
 596677007,
 3739,
 596976536,
 596609247,
 -1,
 -56426,
 596960810,
 3725,
 -56425,
 597004687,
 3737,
 -1,
 597055005,
 3719,
 597238685,
 596930696,
 -1,
 597304220,
 597188194,
 -1,
 -56421,
 597279733,
 3716,
 -1,
 597344711,
 3714,
 -1,
 597266831,
 3713,
 597566368,
 597212792,
 -1,
 -56417,
 597541877,
 3722,
 -1,
 597606855,
 3754,
 597762979,
 597523655,
 -1,
 -56414,
 597726928,
 3749,
 -1,
 597780647,
 3747,
 597959590,
 597712482,
 -1,
 -56411,
 597935093,
 3758,
 -1,
 598000071,
 3755,
 598156201,
 597905783,
 -1,
 -56408,
 598131701,
 3741,
 -1,
 598196679,
 3743,
 -56406,
 598140458,
 3746,
 -56405,
 598335887,
 3751,
 -56404,
 598380943,
 3757,
 -56403,
 598443572,
 3745,
 -56402,
 598489796,
 3732,
 -56401,
 598553064,
 3720,
 -1,
 598616726,
 3738,
 598811586,
 596237494,
 -1,
 598877110,
 598742388,
 3760,
 -56397,
 598860782,
 3779,
 -56396,
 598900709,
 3763,
 -56395,
 598958463,
 3780,
 -1,
 599004532,
 3762,
 599204792,
 598860782,
 3766,
 -1,
 599188462,
 3767,
 599335866,
 599182922,
 3768,
 -1,
 599313994,
 3769,
 599466941,
 599294085,
 -1,
 -56388,
 599430445,
 3771,
 -1,
 599465278,
 3761,
 599663551,
 599417215,
 3764,
 -1,
 599613823,
 3765,
 599794625,
 599605383,
 3776,
 -1,
 599744895,
 3777,
 -1,
 599757199,
 3778,
 599991248,
 598751640,
 -1,
 600056774,
 599966420,
 -1,
 -56379,
 600039823,
 3794,
 -1,
 600072278,
 3795,
 600253385,
 600028959,
 -1,
 -56376,
 600207086,
 3798,
 -1,
 600263810,
 3799,
 600449996,
 600198742,
 -1,
 -56373,
 600415216,
 3796,
 -1,
 600469111,
 3797,
 -56371,
 600434581,
 3792,
 -56370,
 600610239,
 3793,
 -56369,
 600673468,
 3801,
 -1,
 600720695,
 3800,
 600908758,
 599968197,
 -1,
 600974292,
 600883924,
 -1,
 -56365,
 600924543,
 3786,
 -1,
 600989279,
 3785,
 -56363,
 600917405,
 3784,
 -1,
 601108034,
 3787,
 601301977,
 600881512,
 -1,
 -56360,
 601264504,
 3773,
 -1,
 601324740,
 3772,
 601498588,
 601251426,
 -1,
 -56357,
 601460110,
 3804,
 -1,
 601523764,
 3805,
 -56355,
 601459862,
 3789,
 -56354,
 601649809,
 3782,
 -56353,
 601703932,
 3759,
 -1,
 601763197,
 3788,
 601957360,
 596159946,
 -1,
 602022894,
 601882624,
 -1,
 602088423,
 601998036,
 -1,
 602153958,
 602071442,
 -1,
 -56347,
 602124776,
 68414,
 -1,
 602160060,
 68412,
 -1,
 602124921,
 11004,
 602416106,
 602052035,
 -1,
 -56343,
 602386875,
 68415,
 -1,
 602422153,
 68413,
 -56341,
 602395628,
 10200,
 -56340,
 602568699,
 10782,
 -56339,
 602619667,
 10201,
 -1,
 602681410,
 9711,
 602931199,
 601991548,
 10923,
 -1,
 602801865,
 10925,
 -56335,
 601931790,
 9790,
 -1,
 602967139,
 917505,
 603137444,
 509501823,
 -1,
 603202815,
 603097859,
 -1,
 603268344,
 603136106,
 -1,
 603333765,
 603218861,
 -1,
 603399267,
 603268726,
 -1,
 603464773,
 603329039,
 -1,
 603530252,
 603394447,
 -1,
 603595773,
 603460617,
 -1,
 -56325,
 603553816,
 65669,
 -56324,
 603606643,
 65668,
 -1,
 603653036,
 65667,
 603857920,
 603526465,
 -1,
 -56321,
 603815930,
 65677,
 -1,
 603868767,
 65676,
 604054531,
 603788557,
 -1,
 -56318,
 604012522,
 65675,
 -1,
 604065421,
 65674,
 604251142,
 603985094,
 -1,
 -56315,
 604209160,
 65673,
 -1,
 604262018,
 65672,
 604447753,
 604181633,
 -1,
 -56312,
 604405778,
 65671,
 -1,
 604458605,
 65670,
 -56310,
 604378053,
 65666,
 -56309,
 604574492,
 65665,
 -1,
 604639670,
 65664,
 604840983,
 603460737,
 -1,
 -56306,
 604771649,
 65713,
 -56305,
 604837133,
 65712,
 -56304,
 604902598,
 65711,
 -56303,
 604968065,
 65710,
 -56302,
 605033481,
 65709,
 -56301,
 605098940,
 65708,
 -56300,
 605164379,
 65707,
 -56299,
 605229753,
 65706,
 -56298,
 605295119,
 65705,
 -1,
 605360527,
 65704,
 605561889,
 604771526,
 -1,
 -56295,
 605492545,
 65722,
 -56294,
 605558029,
 65721,
 -56293,
 605623494,
 65720,
 -56292,
 605689011,
 65719,
 -56291,
 605754300,
 65718,
 -56290,
 605819758,
 65717,
 -56289,
 605885095,
 65716,
 -56288,
 605950479,
 65715,
 -1,
 606015887,
 65714,
 606217258,
 605492233,
 -1,
 -56285,
 606147907,
 65703,
 -56284,
 606213389,
 65702,
 -56283,
 606278854,
 65701,
 -56282,
 606344124,
 65699,
 -56281,
 606409548,
 65698,
 -56280,
 606474919,
 65697,
 -56279,
 606540364,
 65696,
 -1,
 606605711,
 65695,
 606807090,
 606147853,
 -1,
 -56276,
 606737729,
 65729,
 -56275,
 606802953,
 65728,
 -56274,
 606868412,
 65727,
 -56273,
 606933836,
 65726,
 -56272,
 606999207,
 65725,
 -56271,
 607064591,
 65724,
 -1,
 607129999,
 65723,
 607331384,
 606737340,
 -1,
 -56268,
 607261825,
 65694,
 -56267,
 607327321,
 65693,
 -56266,
 607392423,
 65692,
 -56265,
 607457852,
 65691,
 -1,
 607523217,
 65690,
 607724606,
 607261351,
 -1,
 -56262,
 607654943,
 65682,
 -56261,
 607720342,
 65681,
 -56260,
 607785672,
 65680,
 -56259,
 607851033,
 65679,
 -1,
 607916509,
 65678,
 608117826,
 607654732,
 -1,
 -56256,
 608047783,
 65687,
 -56255,
 608113281,
 65686,
 -1,
 608178625,
 65685,
 608436223,
 608048449,
 -1,
 -56252,
 608309827,
 65731,
 -1,
 608375183,
 65730,
 608632831,
 603394727,
 -1,
 608642128,
 608506889,
 -1,
 -56248,
 608572737,
 65757,
 -56247,
 608638221,
 65756,
 -56246,
 608703686,
 65755,
 -56245,
 608769153,
 65754,
 -56244,
 608834569,
 65753,
 -56243,
 608900030,
 65752,
 -56242,
 608965452,
 65751,
 -56241,
 609030823,
 65750,
 -1,
 609096207,
 65749,
 609297497,
 608572348,
 -1,
 -56238,
 609228097,
 65748,
 -56237,
 609293581,
 65747,
 -56236,
 609358977,
 65745,
 -56235,
 609424393,
 65744,
 -56234,
 609489830,
 65743,
 -56233,
 609555113,
 65742,
 -56232,
 609620514,
 65741,
 -1,
 609685989,
 65740,
 609887328,
 609227596,
 -1,
 -56229,
 609817729,
 65739,
 -56228,
 609883068,
 65738,
 -56227,
 609948574,
 65737,
 -56226,
 610013863,
 65736,
 -56225,
 610079249,
 65735,
 -1,
 610144721,
 65734,
 610402303,
 609817255,
 -1,
 -56222,
 610276373,
 65733,
 -1,
 610341280,
 65732,
 610598911,
 603380556,
 -1,
 610608259,
 610472615,
 -1,
 610673776,
 610537999,
 -1,
 -56217,
 610604353,
 65778,
 -56216,
 610669837,
 65777,
 -56215,
 610735302,
 65776,
 -56214,
 610800769,
 65775,
 -56213,
 610866185,
 65774,
 -56212,
 610931644,
 65773,
 -56211,
 610997068,
 65772,
 -56210,
 611062439,
 65771,
 -56209,
 611127823,
 65770,
 -1,
 611193231,
 65769,
 611394683,
 610603407,
 -1,
 -56206,
 611325249,
 65768,
 -56205,
 611390733,
 65767,
 -56204,
 611456198,
 65766,
 -56203,
 611521665,
 65765,
 -56202,
 611587081,
 65764,
 -56201,
 611652540,
 65763,
 -56200,
 611717964,
 65762,
 -56199,
 611783335,
 65761,
 -56198,
 611848719,
 65760,
 -1,
 611914127,
 65759,
 612115586,
 611324583,
 -1,
 -56195,
 612046145,
 65784,
 -56194,
 612111629,
 65783,
 -56193,
 612177094,
 65782,
 -56192,
 612242561,
 65781,
 -56191,
 612307623,
 65780,
 -1,
 612373007,
 65779,
 -1,
 612045924,
 65785,
 -56188,
 610538418,
 65786,
 -1,
 612569747,
 65758,
 612771054,
 603308623,
 -1,
 612836571,
 612727843,
 -1,
 612902033,
 612766918,
 -1,
 -56183,
 612832554,
 65572,
 -56182,
 612898002,
 65551,
 -56181,
 612963490,
 65608,
 -56180,
 613028948,
 65592,
 -56179,
 613094384,
 65597,
 -56178,
 613159785,
 65558,
 -56177,
 613225168,
 65567,
 -56176,
 613290550,
 65603,
 -1,
 613355948,
 65554,
 613557403,
 612832265,
 -1,
 -56173,
 613487963,
 65586,
 -56172,
 613553461,
 65585,
 -56171,
 613618893,
 65546,
 -56170,
 613684287,
 65565,
 -56169,
 613749739,
 65591,
 -56168,
 613815185,
 65578,
 -56167,
 613880515,
 65564,
 -56166,
 613945905,
 65545,
 -1,
 614011335,
 65570,
 614212773,
 613487271,
 -1,
 -56163,
 614143312,
 65606,
 -56162,
 614208791,
 65538,
 -56161,
 614274286,
 65577,
 -56160,
 614339752,
 65580,
 -56159,
 614405131,
 65600,
 -56158,
 614470614,
 65562,
 -56157,
 614536054,
 65560,
 -56156,
 614601324,
 65573,
 -1,
 614666748,
 65599,
 614868143,
 614142351,
 -1,
 -56153,
 614798678,
 65582,
 -56152,
 614864143,
 65536,
 -56151,
 614929608,
 65543,
 -56150,
 614995085,
 65561,
 -56149,
 615060559,
 65589,
 -56148,
 615125990,
 65587,
 -56147,
 615191419,
 65566,
 -56146,
 615256845,
 65579,
 -1,
 615322156,
 65541,
 615523512,
 614798465,
 -1,
 -56143,
 615454048,
 65590,
 -56142,
 615519535,
 65610,
 -56141,
 615584990,
 65553,
 -56140,
 615650477,
 65611,
 -56139,
 615715886,
 65550,
 -56138,
 615781122,
 65607,
 -56137,
 615846488,
 65539,
 -1,
 615911884,
 65576,
 616113345,
 615453628,
 -1,
 -56134,
 616043812,
 65605,
 -56133,
 616109187,
 65547,
 -56132,
 616174633,
 65542,
 -56131,
 616240081,
 65552,
 -56130,
 616305486,
 65601,
 -56129,
 616370967,
 65594,
 -56128,
 616436342,
 65583,
 -1,
 616501751,
 65593,
 616703178,
 616043340,
 -1,
 -56125,
 616633675,
 65568,
 -56124,
 616699155,
 65537,
 -56123,
 616764659,
 65588,
 -56122,
 616830088,
 65549,
 -56121,
 616895371,
 65609,
 -56120,
 616960776,
 65574,
 -56119,
 617026161,
 65581,
 -1,
 617091516,
 65563,
 617293011,
 616632847,
 -1,
 -56116,
 617223422,
 65596,
 -56115,
 617288861,
 65571,
 -56114,
 617354298,
 65559,
 -56113,
 617419724,
 65544,
 -56112,
 617485156,
 65557,
 -56111,
 617550610,
 65584,
 -56110,
 617615975,
 65569,
 -1,
 617681369,
 65540,
 617882840,
 617223437,
 -1,
 -56107,
 617813240,
 65612,
 -56106,
 617878544,
 65602,
 -56105,
 617943635,
 65555,
 -1,
 618009009,
 65556,
 618266623,
 617813313,
 -1,
 -56102,
 618140283,
 65613,
 -1,
 618205594,
 65604,
 618463231,
 612795132,
 -1,
 618472673,
 618337549,
 -1,
 -56098,
 618403137,
 65629,
 -56097,
 618468481,
 65628,
 -56096,
 618533708,
 65627,
 -1,
 618599079,
 65626,
 618800356,
 618402945,
 -1,
 -56093,
 618730428,
 65624,
 -1,
 618795852,
 65623,
 618996967,
 618730428,
 -1,
 -56090,
 618927425,
 65621,
 -1,
 618992838,
 65620,
 619193578,
 618926607,
 -1,
 -56087,
 619124033,
 65617,
 -1,
 619189517,
 65616,
 -56085,
 619123978,
 65625,
 -56084,
 619320437,
 65622,
 -56083,
 619385782,
 65619,
 -1,
 619451182,
 65618,
 619708415,
 612730570,
 -1,
 619717879,
 619581967,
 -1,
 619783411,
 619647820,
 -1,
 -56078,
 619713587,
 65689,
 -1,
 619778899,
 65688,
 619980022,
 619713191,
 -1,
 -56075,
 619910427,
 65684,
 -1,
 619975895,
 65683,
 -1,
 619910264,
 65700,
 -1,
 619647793,
 65746,
 620363775,
 603193344,
 -1,
 620373246,
 620259818,
 -1,
 620438781,
 620355442,
 -1,
 -56068,
 620411200,
 10771,
 -1,
 620473361,
 10770,
 -1,
 620400242,
 10772,
 -1,
 620345726,
 8232,
 620766554,
 603160549,
 -1,
 620832089,
 620702779,
 -1,
 620897576,
 620788186,
 -1,
 620963078,
 620869407,
 -1,
 -56060,
 620935065,
 6426,
 -56059,
 620976297,
 6425,
 -1,
 621024628,
 6427,
 621225224,
 620946474,
 6421,
 -1,
 621185247,
 6410,
 621356299,
 621200084,
 -1,
 -56054,
 621303977,
 6412,
 -1,
 621352308,
 6411,
 621552910,
 621322217,
 -1,
 -56051,
 621500585,
 6417,
 -1,
 621548916,
 6416,
 621749521,
 621512927,
 -1,
 -56048,
 621695748,
 6405,
 -1,
 621745524,
 6415,
 621946132,
 621703304,
 -1,
 -56045,
 621893801,
 6402,
 -1,
 621942132,
 6401,
 622142743,
 621899561,
 -1,
 -56042,
 622090409,
 6409,
 -1,
 622138740,
 6408,
 622339354,
 622088931,
 -1,
 -56039,
 622287017,
 6404,
 -1,
 622335348,
 6403,
 622535965,
 622278176,
 -1,
 -56036,
 622483625,
 6414,
 -1,
 622531956,
 6413,
 622732576,
 622472414,
 -1,
 -56033,
 622680233,
 6407,
 -1,
 622728564,
 6406,
 622929187,
 622667382,
 -1,
 -56030,
 622876841,
 6419,
 -1,
 622925172,
 6418,
 -56028,
 622910768,
 6424,
 -56027,
 623094191,
 6422,
 -56026,
 623149106,
 6420,
 -56025,
 623211437,
 6423,
 -1,
 623270057,
 6428,
 623453501,
 620869407,
 -1,
 623519028,
 623411584,
 -1,
 623584557,
 623479007,
 -1,
 -56020,
 623530756,
 6449,
 -1,
 623580532,
 6452,
 -56018,
 623559445,
 6451,
 -56017,
 623749551,
 6455,
 -56016,
 623812686,
 6453,
 -56015,
 623870002,
 6454,
 -56014,
 623932333,
 6456,
 -56013,
 623997087,
 6448,
 -1,
 624041879,
 6450,
 624239929,
 623469961,
 -1,
 -56010,
 624211868,
 6459,
 -56009,
 624265156,
 6457,
 -56008,
 624328074,
 6464,
 -1,
 624390622,
 6458,
 624623615,
 624217875,
 -1,
 -56005,
 624550954,
 6441,
 -56004,
 624614704,
 6443,
 -1,
 624667055,
 6442,
 624829769,
 623434889,
 -1,
 624895304,
 624757291,
 -1,
 624960834,
 624825716,
 6432,
 -55999,
 624938570,
 6438,
 -1,
 624976255,
 6436,
 625157444,
 624923023,
 6440,
 -1,
 625119631,
 6437,
 625288518,
 625098887,
 6439,
 -1,
 625229959,
 6435,
 -55993,
 625266250,
 6434,
 -1,
 625369471,
 6433,
 -1,
 624824096,
 6400,
 625616215,
 624769432,
 -1,
 625681741,
 625590996,
 -1,
 -55988,
 625664399,
 6472,
 -1,
 625696854,
 6473,
 625878352,
 625653535,
 -1,
 -55985,
 625831662,
 6476,
 -1,
 625888386,
 6477,
 626074963,
 625823318,
 -1,
 -55982,
 626039792,
 6474,
 -1,
 626093687,
 6475,
 -55980,
 626059157,
 6470,
 -55979,
 626234815,
 6471,
 -55978,
 626298044,
 6479,
 -1,
 626345271,
 6478,
 -55976,
 625584318,
 6469,
 -1,
 626478458,
 6468,
 -1,
 620785068,
 13007,
 626730394,
 620740987,
 -1,
 626795927,
 626686426,
 -1,
 626861418,
 626770644,
 -1,
 626926949,
 626824643,
 -1,
 626992484,
 626886846,
 -1,
 -55968,
 626968506,
 42232,
 -55967,
 627018043,
 42236,
 -55966,
 627077110,
 42237,
 -55965,
 627127831,
 42234,
 -1,
 627190422,
 42235,
 -1,
 626952510,
 42233,
 627451240,
 626898719,
 -1,
 -55961,
 627398825,
 42206,
 -1,
 627447156,
 42205,
 -55959,
 627398825,
 42197,
 -1,
 627578228,
 42196,
 627778925,
 626839114,
 42228,
 -55956,
 627726475,
 42230,
 -1,
 627785863,
 42229,
 627975536,
 627762974,
 -1,
 -55953,
 627923113,
 42211,
 -1,
 627971444,
 42212,
 628172147,
 627947295,
 -1,
 -55950,
 628119721,
 42219,
 -1,
 628168052,
 42210,
 628368758,
 628137961,
 -1,
 -55947,
 628316329,
 42194,
 -1,
 628364660,
 42193,
 628565368,
 628330895,
 42227,
 -1,
 628506759,
 42231,
 628696443,
 628525279,
 -1,
 -55942,
 628642564,
 42213,
 -1,
 628692340,
 42208,
 628893054,
 628650120,
 -1,
 -55939,
 628840617,
 42200,
 -1,
 628888948,
 42199,
 629089665,
 628840587,
 -1,
 -55936,
 629037225,
 42216,
 -1,
 629085556,
 42214,
 629286276,
 629035747,
 -1,
 -55933,
 629233833,
 42221,
 -1,
 629282164,
 42198,
 629482886,
 629227655,
 42224,
 -1,
 629460554,
 42225,
 629613961,
 629421600,
 -1,
 -55928,
 629598000,
 42204,
 -1,
 629609844,
 42195,
 629810572,
 629550302,
 -1,
 -55925,
 629758121,
 42203,
 -1,
 629806452,
 42202,
 630007182,
 629740916,
 42222,
 -1,
 629948551,
 42223,
 -55921,
 629990442,
 42220,
 -55920,
 630121252,
 42215,
 -55919,
 630185264,
 42218,
 -55918,
 630226994,
 42207,
 -55917,
 630289325,
 42209,
 -55916,
 630353707,
 42201,
 -55915,
 630415743,
 42226,
 -55914,
 630476479,
 42217,
 -1,
 630531752,
 42192,
 630783999,
 626763515,
 -1,
 -55911,
 630674114,
 42239,
 -1,
 630731279,
 42238,
 630924705,
 626676958,
 -1,
 630990240,
 630849536,
 -1,
 -55907,
 630970972,
 10072,
 -55906,
 631028332,
 9617,
 -55905,
 631091210,
 10099,
 -1,
 631142344,
 10098,
 -1,
 630951140,
 9735,
 -55902,
 630906064,
 8374,
 -55901,
 631351738,
 8356,
 -1,
 631384930,
 9806,
 631580442,
 603078791,
 -1,
 631645838,
 631525982,
 -1,
 631711264,
 631570432,
 -1,
 631776699,
 631682847,
 -1,
 631842227,
 631744568,
 91,
 631963647,
 631767040,
 -1,
 631973296,
 631889778,
 -1,
 632038830,
 631949257,
 -1,
 -55891,
 632015368,
 10637,
 -1,
 632040160,
 10639,
 -55889,
 632017495,
 10635,
 -1,
 632203492,
 8261,
 -55887,
 631952480,
 9121,
 -55886,
 632323681,
 9123,
 -1,
 632376879,
 9122,
 632563126,
 631791999,
 -1,
 -55883,
 632523812,
 8216,
 -1,
 632567854,
 11814,
 632759737,
 632504455,
 -1,
 -55880,
 632740231,
 9609,
 -1,
 632784157,
 8907,
 -55878,
 632737740,
 11778,
 -1,
 632885541,
 10181,
 633087438,
 631744852,
 -1,
 633152973,
 633038056,
 -1,
 633218500,
 633086562,
 8596,
 633339903,
 633143296,
 -1,
 633349571,
 633266034,
 -1,
 -55871,
 633330455,
 8697,
 -55870,
 633389312,
 8622,
 -1,
 633421237,
 8700,
 -1,
 633325465,
 10568,
 633677256,
 633158822,
 8660,
 633798655,
 633605155,
 -1,
 -55865,
 633723671,
 10500,
 -1,
 633782528,
 8654,
 633939403,
 633658632,
 -1,
 -55862,
 633888225,
 11012,
 -1,
 633939444,
 8621,
 -55860,
 633902936,
 8703,
 -1,
 634071555,
 11020,
 -1,
 633084303,
 11788,
 634332632,
 633068808,
 -1,
 634398167,
 634281435,
 -1,
 634463699,
 634334430,
 -1,
 -55854,
 634443251,
 10627,
 -1,
 634493298,
 12302,
 -55852,
 634440301,
 12312,
 -55851,
 634634078,
 12314,
 -55850,
 634691878,
 10629,
 -1,
 634747150,
 12310,
 -1,
 634348740,
 10712,
 634988001,
 634268894,
 -1,
 635053534,
 634967539,
 123,
 635174911,
 634978304,
 -1,
 -55844,
 635098242,
 9127,
 -55843,
 635143415,
 9128,
 -1,
 635207314,
 9129,
 -55841,
 635017586,
 12300,
 -55840,
 635338179,
 9948,
 -1,
 635389314,
 8968,
 635577837,
 634918260,
 -1,
 635643368,
 635537631,
 -1,
 635708901,
 635590110,
 12296,
 -1,
 635636983,
 10641,
 635895807,
 635647569,
 -1,
 -55833,
 635814745,
 10203,
 -1,
 635846052,
 10202,
 636092415,
 635611476,
 -1,
 636102124,
 636007713,
 -1,
 -55829,
 636075490,
 11056,
 -1,
 636104836,
 11058,
 -1,
 636038422,
 10643,
 636364278,
 635552468,
 -1,
 636429809,
 636332372,
 -1,
 -55824,
 636379771,
 10703,
 -1,
 636428099,
 11785,
 636626420,
 636379227,
 -1,
 -55821,
 636594304,
 9610,
 -1,
 636634477,
 9613,
 -55819,
 636590555,
 12308,
 -1,
 636753771,
 8867,
 636954113,
 636298870,
 -1,
 637019646,
 636887313,
 -1,
 637085179,
 636998621,
 -1,
 -55814,
 637064021,
 10574,
 -1,
 637091448,
 10570,
 637337599,
 637026050,
 -1,
 -55811,
 637260629,
 10571,
 -1,
 637288056,
 10576,
 637534207,
 636974101,
 -1,
 -55808,
 637454957,
 10647,
 -1,
 637499662,
 12304,
 637675016,
 636893892,
 -1,
 637740551,
 637652777,
 -1,
 -55804,
 637722438,
 10714,
 -55803,
 637774115,
 8220,
 -55802,
 637837606,
 11816,
 -1,
 637869755,
 12298,
 -1,
 637717554,
 11780,
 638133773,
 637640998,
 40,
 638255103,
 638058496,
 -1,
 -55797,
 638178434,
 9115,
 -55796,
 638221970,
 9117,
 -1,
 638275119,
 9116,
 638461458,
 638095759,
 -1,
 638526993,
 638421766,
 -1,
 -55792,
 638494825,
 9614,
 -1,
 638534987,
 9615,
 -1,
 638506803,
 10197,
 638789143,
 638406230,
 -1,
 638854678,
 638738815,
 -1,
 -55787,
 638834947,
 9611,
 -1,
 638892601,
 10620,
 -1,
 638811539,
 8970,
 639116826,
 638769745,
 -1,
 -55783,
 639082446,
 9144,
 -1,
 639115398,
 11808,
 639313437,
 639064470,
 -1,
 -55780,
 639275637,
 9612,
 -1,
 639309679,
 9686,
 -55778,
 639274464,
 8905,
 -55777,
 639469518,
 10204,
 -1,
 639532593,
 11804,
 639706752,
 631692634,
 -1,
 639772232,
 639640162,
 8592,
 639837767,
 639696896,
 -1,
 639903284,
 639819634,
 -1,
 639968812,
 639877844,
 -1,
 640034345,
 639899966,
 8610,
 640155647,
 639962147,
 -1,
 -55768,
 640080663,
 11065,
 -1,
 640105909,
 11066,
 640352255,
 639986621,
 -1,
 -55765,
 640275753,
 11025,
 -1,
 640302896,
 11024,
 640493103,
 639908548,
 -1,
 -55762,
 640470914,
 8698,
 -1,
 640535592,
 11064,
 -55760,
 640473879,
 8695,
 -55759,
 640663808,
 8602,
 -55758,
 640722001,
 10566,
 -55757,
 640777614,
 8619,
 -1,
 640835232,
 8617,
 641017405,
 639877844,
 -1,
 641082937,
 640979354,
 -1,
 641148472,
 641015900,
 8676,
 -1,
 641075163,
 8633,
 -1,
 641102875,
 10525,
 641400831,
 641032410,
 -1,
 -55749,
 641327876,
 11070,
 -55748,
 641384831,
 10618,
 -1,
 641431887,
 10615,
 641607236,
 640947835,
 -1,
 641672769,
 641576246,
 -1,
 -55744,
 641648665,
 11083,
 -1,
 641670177,
 11074,
 -55742,
 641648665,
 10611,
 -55741,
 641842066,
 10563,
 -1,
 641866785,
 11082,
 642065990,
 641552975,
 8612,
 -1,
 641993635,
 10527,
 -1,
 642031108,
 8646,
 -1,
 639766898,
 10521,
 642328156,
 639720122,
 -1,
 642393691,
 642310022,
 -1,
 642459220,
 642372356,
 -1,
 642524755,
 642383872,
 -1,
 642590289,
 642455163,
 -1,
 642655824,
 642544472,
 -1,
 -55729,
 642618908,
 10602,
 -1,
 642663508,
 10594,
 -1,
 642625803,
 10598,
 -55726,
 642566457,
 10578,
 -1,
 642863695,
 10586,
 -1,
 642506068,
 8636,
 643170303,
 642399791,
 -1,
 643180122,
 643039232,
 -1,
 -55721,
 643156281,
 10582,
 -55720,
 643191375,
 10590,
 -55719,
 643246176,
 10603,
 -1,
 643307230,
 10599,
 -1,
 643161428,
 8637,
 -1,
 642358810,
 8651,
 643638893,
 642302676,
 -1,
 643704426,
 643621263,
 -1,
 643769961,
 643633068,
 -1,
 643835496,
 643703400,
 -1,
 643901031,
 643817330,
 -1,
 643966565,
 643875715,
 11067,
 644087807,
 643894307,
 -1,
 -55708,
 644012823,
 11068,
 -1,
 644038069,
 11069,
 -55706,
 643947287,
 11060,
 -1,
 644169141,
 11061,
 -1,
 643846735,
 11062,
 -1,
 643812211,
 11063,
 -1,
 643695700,
 8606,
 644612095,
 643674658,
 -1,
 -55700,
 644495118,
 10510,
 -1,
 644555362,
 8666,
 644753016,
 643577376,
 -1,
 644818551,
 644717364,
 -1,
 644884086,
 644751970,
 8656,
 644949621,
 644808704,
 -1,
 645015156,
 644931442,
 -1,
 -55693,
 644995863,
 10498,
 -1,
 645054720,
 8653,
 -1,
 644960847,
 10502,
 -1,
 644878706,
 10523,
 -1,
 644822798,
 10508,
 -1,
 644752261,
 8672,
 645473915,
 644734216,
 -1,
 -55686,
 645422561,
 8678,
 -1,
 645473780,
 8604,
 -55684,
 645447568,
 8668,
 -55683,
 645638115,
 11077,
 -55682,
 645701768,
 8647,
 -55681,
 645764952,
 8701,
 -1,
 645802499,
 11013,
 646053887,
 639635155,
 -1,
 646063749,
 645974394,
 -1,
 -55677,
 646029028,
 8237,
 -55676,
 646087258,
 8206,
 -1,
 646137434,
 8234,
 646325897,
 646030573,
 -1,
 -55673,
 646265976,
 171,
 -55672,
 646329825,
 10748,
 -1,
 646389435,
 9001,
 646588044,
 646297375,
 -1,
 -55669,
 646538064,
 10553,
 -1,
 646600920,
 10154,
 646840319,
 646532808,
 4054,
 -1,
 646712621,
 4056,
 646915827,
 631611815,
 -1,
 646981317,
 646871514,
 -1,
 647046809,
 646955732,
 -1,
 647112340,
 647021268,
 -1,
 -55661,
 647059625,
 7246,
 -1,
 647107956,
 7245,
 647308951,
 647083807,
 -1,
 -55658,
 647256233,
 7192,
 -1,
 647304564,
 7191,
 -55656,
 647256233,
 7179,
 -1,
 647435636,
 7178,
 647636637,
 647012329,
 -1,
 -55653,
 647590829,
 7183,
 -55652,
 647649449,
 7184,
 -1,
 647697780,
 7182,
 647898785,
 647596255,
 -1,
 -55649,
 647881770,
 7177,
 -55648,
 647910148,
 7173,
 -1,
 647959924,
 7181,
 648160933,
 647852168,
 -1,
 -55645,
 648115117,
 7169,
 -55644,
 648173737,
 7170,
 -1,
 648222068,
 7168,
 648423081,
 648099360,
 -1,
 -55641,
 648406832,
 7193,
 -55640,
 648427147,
 7247,
 -1,
 648484212,
 7180,
 648685228,
 648394527,
 -1,
 -55637,
 648632489,
 7201,
 -1,
 648680820,
 7200,
 648881839,
 648642533,
 -1,
 -55634,
 648836013,
 7190,
 -1,
 648877428,
 7189,
 649078450,
 648829067,
 -1,
 -55631,
 649032621,
 7198,
 -1,
 649074036,
 7197,
 649275061,
 649024227,
 -1,
 -55628,
 649229229,
 7172,
 -1,
 649270644,
 7171,
 649471672,
 649219670,
 -1,
 -55625,
 649425837,
 7186,
 -1,
 649467252,
 7185,
 649668283,
 649407710,
 -1,
 -55622,
 649615529,
 7175,
 -1,
 649663860,
 7174,
 649864894,
 649602678,
 -1,
 -55619,
 649819053,
 7188,
 -1,
 649860468,
 7187,
 -55617,
 649847850,
 7194,
 -55616,
 650042672,
 7202,
 -55615,
 650106812,
 7199,
 -55614,
 650160559,
 7195,
 -55613,
 650212269,
 7196,
 -55612,
 650276651,
 7176,
 -1,
 650319220,
 7203,
 650520275,
 646920600,
 -1,
 650585801,
 650494676,
 -1,
 -55608,
 650568079,
 7234,
 -1,
 650600534,
 7235,
 650782412,
 650557215,
 -1,
 -55605,
 650735342,
 7238,
 -1,
 650792066,
 7239,
 650979023,
 650726998,
 -1,
 -55602,
 650943472,
 7236,
 -1,
 650997367,
 7237,
 -55600,
 650962837,
 7232,
 -55599,
 651138495,
 7233,
 -55598,
 651201724,
 7241,
 -1,
 651248951,
 7240,
 651437789,
 650457746,
 -1,
 651503318,
 651397343,
 7216,
 -1,
 651486676,
 7220,
 651634392,
 651456648,
 7213,
 -1,
 651566688,
 7221,
 -55591,
 651608788,
 7219,
 -55590,
 651733332,
 7218,
 -55589,
 651796457,
 7217,
 -55588,
 651853797,
 7214,
 -1,
 651916120,
 7215,
 652093157,
 651418806,
 -1,
 652158688,
 652070474,
 7210,
 -1,
 652136010,
 7211,
 652289762,
 652120463,
 7208,
 -1,
 652251535,
 7209,
 -55581,
 652239231,
 7207,
 -55580,
 652361863,
 7212,
 -1,
 652416503,
 7206,
 652617452,
 652060411,
 -1,
 652682986,
 652591828,
 -1,
 652748521,
 652655441,
 7231,
 -1,
 652673669,
 7230,
 -1,
 652678632,
 7227,
 -55573,
 652644669,
 7228,
 -1,
 652881681,
 7229,
 653131775,
 652588831,
 -1,
 653141744,
 653053715,
 -1,
 -55569,
 653124650,
 7204,
 -1,
 653175215,
 7205,
 653393919,
 653092233,
 -1,
 -55566,
 653306523,
 7222,
 -1,
 653365301,
 7223,
 653535001,
 646889386,
 -1,
 653600513,
 653496719,
 -1,
 653666048,
 653568342,
 -1,
 653731579,
 653639020,
 10877,
 653852671,
 653659393,
 -1,
 653862650,
 653727349,
 10881,
 -1,
 653789667,
 10883,
 -1,
 653814159,
 10879,
 654059262,
 653674742,
 -1,
 -55555,
 654012006,
 8818,
 -1,
 654055973,
 8804,
 -55553,
 654006007,
 8822,
 -1,
 654188586,
 10885,
 -1,
 653646237,
 8806,
 654452494,
 653530484,
 -1,
 654518027,
 654388046,
 -1,
 654583560,
 654489375,
 -1,
 654649095,
 654534363,
 -1,
 -55546,
 654612484,
 10893,
 -1,
 654644884,
 10895,
 -1,
 654603517,
 10899,
 -55543,
 654538825,
 10614,
 -55542,
 654857988,
 10897,
 -1,
 654917068,
 10891,
 655163391,
 654477920,
 -1,
 -55539,
 655080678,
 10887,
 -1,
 655134283,
 10889,
 655304466,
 654434162,
 -1,
 -55536,
 655272140,
 10875,
 -55535,
 655309608,
 8918,
 -1,
 655372369,
 10873,
 655566612,
 655241622,
 10918,
 -1,
 655491105,
 10920,
 655697687,
 655502461,
 -1,
 -55530,
 655650406,
 8934,
 -1,
 655694373,
 8808,
 -55528,
 655670315,
 60,
 -1,
 655837469,
 8922,
 -1,
 653496719,
 9804,
 656090966,
 631563246,
 -1,
 656156473,
 656027684,
 -1,
 656221983,
 656130772,
 66199,
 -55522,
 656196308,
 66200,
 -1,
 656234635,
 66185,
 656418593,
 656181471,
 66191,
 -1,
 656378079,
 66193,
 656549667,
 656375781,
 66190,
 -1,
 656506853,
 66192,
 656680741,
 656502920,
 66187,
 -1,
 656633992,
 66196,
 656811815,
 656621703,
 66177,
 -1,
 656771295,
 66202,
 656942889,
 656746102,
 66178,
 -1,
 656889995,
 66179,
 657073963,
 656872820,
 66176,
 -1,
 657033439,
 66201,
 -55508,
 657057566,
 66184,
 -55507,
 657187588,
 66204,
 -55506,
 657251592,
 66183,
 -55505,
 657313354,
 66194,
 -55504,
 657372959,
 66198,
 -55503,
 657434964,
 66197,
 -55502,
 657499972,
 66188,
 -55501,
 657563625,
 66195,
 -55500,
 657617752,
 66189,
 -55499,
 657682217,
 66186,
 -55498,
 657744255,
 66182,
 -55497,
 657807499,
 66203,
 -55496,
 657871587,
 66180,
 -1,
 657929760,
 66181,
 658178047,
 656095541,
 -1,
 658188117,
 658078170,
 -1,
 658253629,
 658162388,
 67887,
 -1,
 658227924,
 67892,
 658384703,
 658224927,
 67891,
 -1,
 658355999,
 67886,
 658515777,
 658344159,
 67883,
 -1,
 658475231,
 67896,
 658646851,
 658469720,
 67881,
 -1,
 658629614,
 67895,
 658777925,
 658587783,
 67876,
 -1,
 658737375,
 67894,
 658908999,
 658707828,
 67872,
 -1,
 658868447,
 67893,
 -55480,
 658891758,
 67879,
 -55479,
 659019694,
 67877,
 -55478,
 659082826,
 67888,
 -55477,
 659138900,
 67885,
 -55476,
 659203908,
 67890,
 -55475,
 659263887,
 67884,
 -55474,
 659324901,
 67882,
 -55473,
 659386504,
 67880,
 -55472,
 659448191,
 67878,
 -55471,
 659509987,
 67874,
 -55470,
 659574358,
 67889,
 -55469,
 659633696,
 67875,
 -55468,
 659696862,
 67897,
 -1,
 659760758,
 67873,
 -1,
 658164516,
 67903,
 660023207,
 656052623,
 -1,
 660088695,
 660004104,
 -1,
 660154227,
 660031842,
 -1,
 660219746,
 660123239,
 -1,
 660285277,
 660191007,
 -1,
 -55460,
 660232437,
 10065,
 -1,
 660293220,
 10558,
 -55458,
 660261626,
 9727,
 -55457,
 660449229,
 9694,
 -55456,
 660513322,
 9998,
 -55455,
 660553707,
 10063,
 -1,
 660616068,
 10195,
 660809574,
 660174474,
 -1,
 -55452,
 660785914,
 9722,
 -55451,
 660846879,
 10559,
 -1,
 660907981,
 9695,
 661071722,
 660756880,
 -1,
 -55448,
 661023416,
 9691,
 -55447,
 661073986,
 9697,
 -1,
 661138064,
 9604,
 661333869,
 661047103,
 -1,
 -55444,
 661301376,
 9606,
 -1,
 661341549,
 9603,
 661530480,
 661296579,
 -1,
 -55441,
 661497961,
 9602,
 -1,
 661538123,
 9601,
 -55439,
 661502439,
 9607,
 -55438,
 661672121,
 9605,
 -1,
 661727854,
 9987,
 661979135,
 660078592,
 -1,
 -55435,
 661879533,
 95,
 -55434,
 661929284,
 12319,
 -1,
 661988356,
 8270,
 662185871,
 660048826,
 -1,
 662251396,
 662140549,
 -1,
 662316927,
 662232410,
 -1,
 662382460,
 662256806,
 10232,
 -1,
 662307791,
 10237,
 662513534,
 662315618,
 10229,
 -1,
 662438863,
 10235,
 -1,
 662486928,
 11059,
 662765567,
 662241280,
 -1,
 662775683,
 662679143,
 -1,
 -55422,
 662715558,
 10234,
 -1,
 662774370,
 10231,
 -1,
 662750041,
 10206,
 663037836,
 662220385,
 -1,
 663103371,
 663018842,
 -1,
 663168904,
 663043238,
 10233,
 -1,
 663094223,
 10238,
 663299978,
 663102050,
 10230,
 -1,
 663225295,
 10236,
 -1,
 663273360,
 10239,
 -1,
 663030428,
 10205,
 663617535,
 662976032,
 -1,
 -55410,
 663514831,
 10188,
 -1,
 663561048,
 10982,
 663758757,
 662132097,
 -1,
 663824283,
 663721974,
 8744,
 663945215,
 663748608,
 -1,
 663955354,
 663871346,
 -1,
 664020888,
 663894724,
 -1,
 664086423,
 663998249,
 -1,
 -55402,
 664064599,
 10851,
 -1,
 664116906,
 10850,
 -1,
 664060633,
 10834,
 -55399,
 663979268,
 10843,
 -1,
 664297212,
 10845,
 -1,
 663920315,
 10841,
 664600575,
 663756135,
 8743,
 664666111,
 664472611,
 -1,
 664676258,
 664550084,
 -1,
 664741793,
 664653609,
 -1,
 -55392,
 664719959,
 10848,
 -1,
 664772266,
 10846,
 -1,
 664715993,
 10833,
 -55389,
 664654423,
 10847,
 -55388,
 664962308,
 10842,
 -1,
 665018108,
 10844,
 665255935,
 663742347,
 9674,
 -1,
 665125724,
 10208,
 -1,
 659948017,
 8468,
 665399015,
 509427847,
 -1,
 665463887,
 665344104,
 -1,
 665528362,
 665392500,
 -1,
 665593859,
 665457039,
 -1,
 665659323,
 665523132,
 -1,
 665724847,
 665588745,
 77877,
 -1,
 665654644,
 77878,
 665855921,
 665654092,
 77874,
 -1,
 665785716,
 77875,
 665986995,
 665784999,
 77872,
 -1,
 665916788,
 77873,
 666118069,
 665915791,
 77869,
 -1,
 666047860,
 77870,
 -55370,
 666047809,
 77882,
 -55369,
 666178829,
 77881,
 -55368,
 666244294,
 77880,
 -55367,
 666309761,
 77879,
 -55366,
 666375100,
 77876,
 -1,
 666440207,
 77871,
 666642376,
 665588239,
 -1,
 666707902,
 666571974,
 77844,
 -1,
 666637684,
 77845,
 666838976,
 666637244,
 77840,
 -1,
 666768756,
 77841,
 -55359,
 666768705,
 77847,
 -55358,
 666899725,
 77846,
 -55357,
 666965121,
 77843,
 -55356,
 667030537,
 77842,
 -55355,
 667095884,
 77839,
 -55354,
 667161255,
 77838,
 -55353,
 667226639,
 77837,
 -1,
 667292047,
 77836,
 667494357,
 666571151,
 -1,
 667559884,
 667423873,
 77830,
 -55349,
 667494006,
 77832,
 -1,
 667555188,
 77831,
 667756494,
 667489289,
 77828,
 -1,
 667686260,
 77829,
 -55345,
 667686209,
 77835,
 -55344,
 667817229,
 77834,
 -55343,
 667882694,
 77833,
 -55342,
 667947964,
 77827,
 -55341,
 668013388,
 77826,
 -55340,
 668078759,
 77825,
 -1,
 668144143,
 77824,
 668346337,
 667423564,
 -1,
 668411864,
 668275367,
 77860,
 -1,
 668341620,
 77861,
 -55335,
 668341569,
 77868,
 -55334,
 668472589,
 77867,
 -55333,
 668538054,
 77866,
 -55332,
 668603521,
 77865,
 -55331,
 668668937,
 77864,
 -55330,
 668734396,
 77863,
 -55329,
 668799820,
 77862,
 -55328,
 668865039,
 77859,
 -1,
 668930447,
 77858,
 669132780,
 668275841,
 -1,
 -55325,
 669062465,
 77902,
 -55324,
 669127949,
 77901,
 -55323,
 669193414,
 77900,
 -55322,
 669258881,
 77899,
 -55321,
 669324297,
 77898,
 -55320,
 669389756,
 77897,
 -55319,
 669455180,
 77896,
 -55318,
 669520551,
 77895,
 -55317,
 669585935,
 77894,
 -1,
 669651343,
 77893,
 669853687,
 669062153,
 -1,
 -55314,
 669783361,
 77892,
 -55313,
 669848845,
 77891,
 -55312,
 669914310,
 77890,
 -55311,
 669979777,
 77889,
 -55310,
 670045193,
 77888,
 -55309,
 670110652,
 77887,
 -55308,
 670176076,
 77886,
 -55307,
 670241447,
 77885,
 -55306,
 670306831,
 77884,
 -1,
 670372239,
 77883,
 670574594,
 669782695,
 -1,
 -55303,
 670504257,
 77857,
 -55302,
 670569741,
 77856,
 -55301,
 670635206,
 77855,
 -55300,
 670700673,
 77854,
 -55299,
 670766089,
 77853,
 -55298,
 670831548,
 77852,
 -55297,
 670896972,
 77851,
 -55296,
 670962343,
 77850,
 -55295,
 671027727,
 77849,
 -1,
 671093135,
 77848,
 -1,
 670504195,
 77903,
 671416319,
 665523694,
 -1,
 671426576,
 671289743,
 -1,
 671492104,
 671356102,
 78867,
 -55289,
 671426166,
 78869,
 -1,
 671487348,
 78868,
 -55287,
 671421761,
 78871,
 -55286,
 671618317,
 78870,
 -55285,
 671683713,
 78866,
 -55284,
 671749129,
 78865,
 -55283,
 671814588,
 78864,
 -55282,
 671880012,
 78863,
 -55281,
 671945383,
 78862,
 -1,
 672010767,
 78861,
 672213019,
 671355559,
 -1,
 -55278,
 672142657,
 78891,
 -55277,
 672208141,
 78890,
 -55276,
 672273606,
 78889,
 -55275,
 672339073,
 78888,
 -55274,
 672404489,
 78887,
 -55273,
 672469948,
 78886,
 -55272,
 672535372,
 78885,
 -55271,
 672600743,
 78884,
 -55270,
 672666127,
 78883,
 -1,
 672731535,
 78882,
 672933926,
 672141839,
 -1,
 -55267,
 672863553,
 78881,
 -55266,
 672929037,
 78880,
 -55265,
 672994502,
 78879,
 -55264,
 673059969,
 78878,
 -55263,
 673125385,
 78877,
 -55262,
 673190844,
 78876,
 -55261,
 673256268,
 78875,
 -55260,
 673321639,
 78874,
 -55259,
 673387023,
 78873,
 -1,
 673452431,
 78872,
 673710079,
 672863052,
 -1,
 -55256,
 673583783,
 78894,
 -55255,
 673649167,
 78893,
 -1,
 673714575,
 78892,
 673917081,
 665487583,
 -1,
 673982562,
 673845647,
 -1,
 674048059,
 673911628,
 -1,
 674113583,
 673977542,
 78361,
 -1,
 674043252,
 78362,
 674244657,
 674042889,
 78358,
 -1,
 674174324,
 78359,
 674375731,
 674173884,
 78356,
 -1,
 674305396,
 78357,
 674506805,
 674304844,
 78354,
 -1,
 674436468,
 78355,
 -55242,
 674436417,
 78364,
 -55241,
 674567437,
 78363,
 -55240,
 674632833,
 78360,
 -55239,
 674697895,
 78353,
 -55238,
 674763279,
 78352,
 -1,
 674828687,
 78351,
 675031112,
 673976847,
 -1,
 675096639,
 674960653,
 78336,
 -55234,
 675030646,
 78338,
 -1,
 675091828,
 78337,
 -55232,
 675026241,
 78339,
 -55231,
 675222726,
 78335,
 -55230,
 675288193,
 78334,
 -55229,
 675353609,
 78333,
 -55228,
 675419068,
 78332,
 -55227,
 675484492,
 78331,
 -55226,
 675549863,
 78330,
 -55225,
 675615247,
 78329,
 -1,
 675680655,
 78328,
 675883092,
 674960039,
 -1,
 675948619,
 675812361,
 78345,
 -1,
 675878260,
 78346,
 -55220,
 675878209,
 78350,
 -55219,
 676009229,
 78349,
 -55218,
 676074694,
 78348,
 -55217,
 676140161,
 78347,
 -55216,
 676205500,
 78344,
 -55215,
 676270924,
 78343,
 -55214,
 676336295,
 78342,
 -55213,
 676401679,
 78341,
 -1,
 676467087,
 78340,
 676669534,
 675811727,
 -1,
 -55210,
 676599105,
 78327,
 -55209,
 676664589,
 78326,
 -55208,
 676730054,
 78325,
 -55207,
 676795521,
 78324,
 -55206,
 676860937,
 78323,
 -55205,
 676926396,
 78322,
 -55204,
 676991820,
 78321,
 -55203,
 677057191,
 78320,
 -1,
 677122575,
 78319,
 677380095,
 676598716,
 -1,
 -55200,
 677253799,
 78367,
 -55199,
 677319183,
 78366,
 -1,
 677384591,
 78365,
 677587072,
 673959594,
 -1,
 677652593,
 677515791,
 -1,
 677718118,
 677582093,
 78409,
 -1,
 677647732,
 78410,
 677849192,
 677646863,
 78401,
 -1,
 677778804,
 78402,
 677980266,
 677777807,
 78399,
 -1,
 677909876,
 78400,
 -55189,
 677909825,
 78411,
 -55188,
 678040774,
 78408,
 -55187,
 678106241,
 78407,
 -55186,
 678171657,
 78406,
 -55185,
 678237116,
 78405,
 -55184,
 678302540,
 78404,
 -1,
 678367911,
 78403,
 678570107,
 677581199,
 -1,
 -55181,
 678499649,
 78398,
 -55180,
 678565133,
 78397,
 -55179,
 678630598,
 78396,
 -55178,
 678696065,
 78395,
 -55177,
 678761481,
 78394,
 -55176,
 678826940,
 78393,
 -55175,
 678892364,
 78392,
 -55174,
 678957735,
 78391,
 -1,
 679023119,
 78390,
 679280639,
 678498983,
 -1,
 679291006,
 679154343,
 78414,
 -1,
 679220596,
 78415,
 -55169,
 679219727,
 78413,
 -1,
 679350671,
 78412,
 679608319,
 677540771,
 -1,
 679618701,
 679481871,
 -1,
 679684228,
 679548102,
 78385,
 -1,
 679613812,
 78386,
 -55163,
 679613761,
 78388,
 -55162,
 679744781,
 78387,
 -55161,
 679810177,
 78384,
 -55160,
 679875593,
 78383,
 -55159,
 679941052,
 78382,
 -55158,
 680006476,
 78381,
 -55157,
 680071847,
 78380,
 -55156,
 680137231,
 78379,
 -1,
 680202639,
 78378,
 680405144,
 679547279,
 -1,
 680470672,
 680334345,
 78372,
 -1,
 680400244,
 78373,
 -55151,
 680400193,
 78377,
 -55150,
 680531213,
 78376,
 -55149,
 680596678,
 78375,
 -55148,
 680662145,
 78374,
 -55147,
 680727484,
 78371,
 -55146,
 680792908,
 78370,
 -55145,
 680858279,
 78369,
 -1,
 680923663,
 78368,
 -1,
 680334120,
 78389,
 681191677,
 673855104,
 -1,
 681257136,
 681120777,
 -1,
 681322661,
 681185679,
 77997,
 -55139,
 681271679,
 78006,
 -55138,
 681334923,
 78005,
 -55137,
 681399011,
 78004,
 -55136,
 681463382,
 78003,
 -55135,
 681525383,
 78002,
 -55134,
 681588256,
 78001,
 -55133,
 681651422,
 78000,
 -55132,
 681715318,
 77999,
 -1,
 681776500,
 77998,
 681978023,
 681251772,
 78011,
 -1,
 681907572,
 78012,
 682109097,
 681906855,
 78008,
 -1,
 682038644,
 78009,
 -55126,
 682038593,
 78017,
 -55125,
 682169613,
 78016,
 -55124,
 682235078,
 78015,
 -55123,
 682300545,
 78014,
 -55122,
 682365961,
 78013,
 -55121,
 682431308,
 78010,
 -1,
 682496527,
 78007,
 682698945,
 681186433,
 -1,
 682764474,
 682628294,
 78025,
 -55117,
 682711179,
 78033,
 -55116,
 682775267,
 78032,
 -55115,
 682839638,
 78031,
 -55114,
 682901639,
 78030,
 -55113,
 682964512,
 78029,
 -55112,
 683027678,
 78028,
 -55111,
 683091574,
 78027,
 -1,
 683152756,
 78026,
 -55109,
 682693761,
 78024,
 -55108,
 683283465,
 78023,
 -55107,
 683348924,
 78022,
 -55106,
 683414348,
 78021,
 -55105,
 683479719,
 78020,
 -55104,
 683545103,
 78019,
 -1,
 683610511,
 78018,
 683813070,
 682628028,
 -1,
 683878596,
 683742477,
 77994,
 -1,
 683808116,
 77995,
 684009670,
 683807873,
 77991,
 -1,
 683939188,
 77992,
 -55097,
 683939137,
 77996,
 -55096,
 684070086,
 77993,
 -55095,
 684135433,
 77990,
 -55094,
 684200892,
 77989,
 -55093,
 684266316,
 77988,
 -55092,
 684331687,
 77987,
 -55091,
 684397071,
 77986,
 -1,
 684462479,
 77985,
 684665051,
 683742028,
 -1,
 684730577,
 684594108,
 77978,
 -1,
 684660084,
 77979,
 684861651,
 684659215,
 77974,
 -1,
 684791156,
 77975,
 -55084,
 684791105,
 77984,
 -55083,
 684922125,
 77983,
 -55082,
 684987590,
 77982,
 -55081,
 685053057,
 77981,
 -55080,
 685118473,
 77980,
 -55079,
 685183820,
 77977,
 -55078,
 685249191,
 77976,
 -1,
 685314447,
 77973,
 685517031,
 684593831,
 -1,
 685582558,
 685446342,
 77969,
 -1,
 685512052,
 77970,
 -55073,
 685512001,
 77972,
 -55072,
 685643021,
 77971,
 -55071,
 685708417,
 77968,
 -55070,
 685773833,
 77967,
 -55069,
 685839292,
 77966,
 -55068,
 685904716,
 77965,
 -55067,
 685970087,
 77964,
 -55066,
 686035471,
 77963,
 -1,
 686100879,
 77962,
 686303474,
 685445647,
 -1,
 -55063,
 686232897,
 77961,
 -55062,
 686298381,
 77960,
 -55061,
 686363846,
 77959,
 -55060,
 686429313,
 77958,
 -55059,
 686494729,
 77957,
 -55058,
 686560188,
 77956,
 -55057,
 686625612,
 77955,
 -55056,
 686690983,
 77954,
 -55055,
 686756367,
 77953,
 -1,
 686821775,
 77952,
 687079423,
 686231951,
 -1,
 687089909,
 686953741,
 77949,
 -1,
 687019380,
 77950,
 -55050,
 687019329,
 77951,
 -55049,
 687150278,
 77948,
 -55048,
 687215745,
 77947,
 -55047,
 687281161,
 77946,
 -55046,
 687346620,
 77945,
 -55045,
 687412044,
 77944,
 -55044,
 687477415,
 77943,
 -1,
 687542799,
 77942,
 687745359,
 681170873,
 -1,
 687810840,
 687674023,
 -1,
 687876364,
 687739279,
 78726,
 -55039,
 687829848,
 78738,
 -55038,
 687894664,
 78737,
 -55037,
 687959849,
 78736,
 -55036,
 688021887,
 78735,
 -55035,
 688085131,
 78734,
 -55034,
 688149219,
 78733,
 -55033,
 688213590,
 78732,
 -55032,
 688275591,
 78731,
 -55031,
 688338464,
 78730,
 -55030,
 688401630,
 78729,
 -55029,
 688465526,
 78728,
 -1,
 688526708,
 78727,
 688728334,
 687805761,
 78749,
 -1,
 688657780,
 78750,
 688859408,
 688657677,
 78747,
 -1,
 688788852,
 78748,
 688990482,
 688788300,
 78741,
 -1,
 688919924,
 78742,
 -55021,
 688919750,
 78746,
 -55020,
 689050753,
 78745,
 -55019,
 689116169,
 78744,
 -55018,
 689181628,
 78743,
 -55017,
 689246887,
 78740,
 -1,
 689312271,
 78739,
 689514798,
 687739279,
 -1,
 689580323,
 689443343,
 78690,
 -55013,
 689529215,
 78699,
 -55012,
 689592459,
 78698,
 -55011,
 689656547,
 78697,
 -55010,
 689720918,
 78696,
 -55009,
 689782919,
 78695,
 -55008,
 689845792,
 78694,
 -55007,
 689908958,
 78693,
 -55006,
 689972854,
 78692,
 -1,
 690034036,
 78691,
 690235686,
 689509574,
 78706,
 -55003,
 690169462,
 78708,
 -1,
 690230644,
 78707,
 690432296,
 690164391,
 78700,
 -1,
 690361716,
 78701,
 -54999,
 690361665,
 78710,
 -54998,
 690492685,
 78709,
 -54997,
 690558081,
 78705,
 -54996,
 690623497,
 78704,
 -54995,
 690688956,
 78703,
 -1,
 690754380,
 78702,
 690956606,
 689443343,
 -1,
 691022131,
 690885135,
 78712,
 -54991,
 690957534,
 78715,
 -54990,
 691021430,
 78714,
 -1,
 691082612,
 78713,
 691284278,
 690950823,
 78716,
 -54987,
 691218038,
 78718,
 -1,
 691279220,
 78717,
 -54985,
 691213633,
 78725,
 -54984,
 691410189,
 78724,
 -54983,
 691475654,
 78723,
 -54982,
 691541121,
 78722,
 -54981,
 691606537,
 78721,
 -54980,
 691671996,
 78720,
 -54979,
 691737420,
 78719,
 -1,
 691802511,
 78711,
 692005197,
 690885452,
 -1,
 692070721,
 691934406,
 78761,
 -1,
 692000116,
 78762,
 692201795,
 691999564,
 78756,
 -1,
 692131188,
 78757,
 692332869,
 692130319,
 78753,
 -1,
 692262260,
 78754,
 692463943,
 692261263,
 78751,
 -1,
 692393332,
 78752,
 -54968,
 692393281,
 78764,
 -54967,
 692524301,
 78763,
 -54966,
 692589697,
 78760,
 -54965,
 692655113,
 78759,
 -54964,
 692720572,
 78758,
 -1,
 692785831,
 78755,
 693043199,
 691934201,
 78765,
 -1,
 692917620,
 78766,
 693119393,
 687706583,
 -1,
 693184866,
 693047695,
 -1,
 693250392,
 693113985,
 78423,
 -54957,
 693194326,
 78429,
 -54956,
 693256327,
 78428,
 -54955,
 693319200,
 78427,
 -54954,
 693382366,
 78426,
 -54953,
 693446262,
 78425,
 -1,
 693507444,
 78424,
 693709146,
 693179401,
 78421,
 -1,
 693638516,
 78422,
 693840220,
 693637647,
 78416,
 -1,
 693769588,
 78417,
 -54947,
 693769537,
 78432,
 -54946,
 693900557,
 78431,
 -54945,
 693966022,
 78430,
 -54944,
 694031292,
 78420,
 -54943,
 694096716,
 78419,
 -1,
 694162087,
 78418,
 694364531,
 693113676,
 -1,
 694430056,
 694293633,
 78469,
 -54939,
 694367776,
 78473,
 -54938,
 694430942,
 78472,
 -54937,
 694494838,
 78471,
 -1,
 694556020,
 78470,
 694757738,
 694358860,
 78465,
 -1,
 694687092,
 78466,
 694888812,
 694686095,
 78461,
 -1,
 694818164,
 78462,
 -54931,
 694818113,
 78476,
 -54930,
 694949133,
 78475,
 -54929,
 695014598,
 78474,
 -54928,
 695079945,
 78468,
 -54927,
 695145404,
 78467,
 -54926,
 695210663,
 78464,
 -1,
 695276047,
 78463,
 695478658,
 694293159,
 -1,
 695544182,
 695407937,
 78459,
 -1,
 695473524,
 78460,
 695675256,
 695473161,
 78454,
 -1,
 695604596,
 78455,
 695806330,
 695604156,
 78452,
 -1,
 695735668,
 78453,
 695937404,
 695734671,
 78447,
 -1,
 695866740,
 78448,
 -54915,
 695866637,
 78458,
 -54914,
 695997638,
 78457,
 -54913,
 696063105,
 78456,
 -54912,
 696128332,
 78451,
 -54911,
 696193703,
 78450,
 -1,
 696259087,
 78449,
 696461713,
 695407119,
 -1,
 696527239,
 696390031,
 78433,
 -54907,
 696462558,
 78436,
 -54906,
 696526454,
 78435,
 -1,
 696587636,
 78434,
 696789385,
 696456513,
 78445,
 -1,
 696718708,
 78446,
 -54902,
 696718605,
 78444,
 -54901,
 696849606,
 78443,
 -54900,
 696915073,
 78442,
 -54899,
 696980489,
 78441,
 -54898,
 697045948,
 78440,
 -54897,
 697111372,
 78439,
 -54896,
 697176743,
 78438,
 -1,
 697242127,
 78437,
 697444764,
 696390588,
 -1,
 -54893,
 697374017,
 78486,
 -54892,
 697439501,
 78485,
 -54891,
 697504966,
 78484,
 -54890,
 697570433,
 78483,
 -54889,
 697635849,
 78482,
 -54888,
 697701308,
 78481,
 -54887,
 697766732,
 78480,
 -54886,
 697832103,
 78479,
 -54885,
 697897487,
 78478,
 -1,
 697962895,
 78477,
 698220543,
 697373705,
 -1,
 698231200,
 698093967,
 78487,
 -54881,
 698164854,
 78489,
 -1,
 698226036,
 78488,
 -1,
 698159631,
 78490,
 698493417,
 693076015,
 -1,
 698558905,
 698421775,
 -1,
 698624428,
 698487463,
 78268,
 -54875,
 698570891,
 78276,
 -54874,
 698634979,
 78275,
 -54873,
 698699350,
 78274,
 -54872,
 698761351,
 78273,
 -54871,
 698824224,
 78272,
 -54870,
 698887390,
 78271,
 -54869,
 698951286,
 78270,
 -1,
 699012468,
 78269,
 699214254,
 698553542,
 78283,
 -1,
 699143540,
 78284,
 699345328,
 699143297,
 78281,
 -1,
 699274612,
 78282,
 699476402,
 699274249,
 78279,
 -1,
 699405684,
 78280,
 699607476,
 699404687,
 78265,
 -1,
 699536756,
 78266,
 -54859,
 699536705,
 78286,
 -54858,
 699667725,
 78285,
 -54857,
 699732924,
 78278,
 -54856,
 699798348,
 78277,
 -1,
 699863567,
 78267,
 700066247,
 698487628,
 -1,
 700131773,
 699994956,
 78304,
 -54852,
 700065398,
 78306,
 -1,
 700126580,
 78305,
 700328383,
 700060175,
 78301,
 -1,
 700257652,
 78302,
 -54848,
 700257601,
 78312,
 -54847,
 700388621,
 78311,
 -54846,
 700454086,
 78310,
 -54845,
 700519553,
 78309,
 -54844,
 700584969,
 78308,
 -54843,
 700650428,
 78307,
 -54842,
 700715687,
 78303,
 -1,
 700780943,
 78300,
 700983765,
 699994791,
 -1,
 701049290,
 700912909,
 78297,
 -1,
 700978548,
 78298,
 701180364,
 700978108,
 78292,
 -1,
 701109620,
 78293,
 701311438,
 701108903,
 78289,
 -1,
 701240692,
 78290,
 -54833,
 701240641,
 78299,
 -54832,
 701371590,
 78296,
 -54831,
 701437057,
 78295,
 -54830,
 701502473,
 78294,
 -54829,
 701567820,
 78291,
 -54828,
 701633039,
 78288,
 -1,
 701698447,
 78287,
 701901282,
 700912015,
 -1,
 701966809,
 701829647,
 78253,
 -54824,
 701900406,
 78255,
 -1,
 701961588,
 78254,
 702163419,
 701895500,
 78257,
 -1,
 702092660,
 78258,
 -54820,
 702092609,
 78264,
 -54819,
 702223629,
 78263,
 -54818,
 702289094,
 78262,
 -54817,
 702354561,
 78261,
 -54816,
 702419977,
 78260,
 -54815,
 702485436,
 78259,
 -1,
 702550695,
 78256,
 702808063,
 701830076,
 -1,
 702818789,
 702681487,
 78313,
 -1,
 702748020,
 78314,
 -54810,
 702747580,
 78318,
 -54809,
 702878540,
 78317,
 -54808,
 702943911,
 78316,
 -1,
 703009295,
 78315,
 703212081,
 698437297,
 -1,
 703277560,
 703140796,
 -1,
 703343085,
 703206598,
 78132,
 -1,
 703272308,
 78133,
 703474159,
 703272065,
 78130,
 -1,
 703403380,
 78131,
 703605233,
 703403017,
 78128,
 -1,
 703534452,
 78129,
 -54798,
 703534401,
 78135,
 -54797,
 703665421,
 78134,
 -54796,
 703730620,
 78127,
 -54795,
 703796044,
 78126,
 -54794,
 703861415,
 78125,
 -54793,
 703926799,
 78124,
 -1,
 703992207,
 78123,
 704195078,
 703206220,
 -1,
 704260603,
 704124173,
 78120,
 -1,
 704189812,
 78121,
 704391677,
 704189638,
 78118,
 -1,
 704320884,
 78119,
 704522751,
 704320015,
 78111,
 -1,
 704451956,
 78112,
 -54784,
 704451905,
 78122,
 -54783,
 704582785,
 78117,
 -54782,
 704648201,
 78116,
 -54781,
 704713660,
 78115,
 -54780,
 704779084,
 78114,
 -54779,
 704844455,
 78113,
 -1,
 704909711,
 78110,
 705112594,
 704123559,
 -1,
 705178121,
 705040911,
 78100,
 -1,
 705107316,
 78101,
 -54774,
 705107265,
 78109,
 -54773,
 705238285,
 78108,
 -54772,
 705303750,
 78107,
 -54771,
 705369217,
 78106,
 -54770,
 705434633,
 78105,
 -54769,
 705500092,
 78104,
 -54768,
 705565516,
 78103,
 -54767,
 705630887,
 78102,
 -1,
 705696143,
 78099,
 705899038,
 705040911,
 -1,
 705964565,
 705827660,
 78091,
 -1,
 705893748,
 78092,
 -54762,
 705893697,
 78098,
 -54761,
 706024717,
 78097,
 -54760,
 706090182,
 78096,
 -54759,
 706155649,
 78095,
 -54758,
 706221065,
 78094,
 -54757,
 706286524,
 78093,
 -54756,
 706351783,
 78090,
 -54755,
 706417167,
 78089,
 -1,
 706482575,
 78088,
 706685481,
 705827215,
 -1,
 706751009,
 706613775,
 78078,
 -1,
 706680180,
 78079,
 -54750,
 706680129,
 78087,
 -54749,
 706811149,
 78086,
 -54748,
 706876614,
 78085,
 -54747,
 706942081,
 78084,
 -54746,
 707007497,
 78083,
 -54745,
 707072956,
 78082,
 -54744,
 707138380,
 78081,
 -1,
 707203751,
 78080,
 707461119,
 706614281,
 -1,
 707471918,
 707334671,
 78137,
 -54740,
 707407070,
 78140,
 -54739,
 707470966,
 78139,
 -1,
 707532148,
 78138,
 -54737,
 707400524,
 78142,
 -54736,
 707662503,
 78141,
 -1,
 707727759,
 78136,
 707930744,
 703156984,
 -1,
 707996223,
 707859388,
 -1,
 708061749,
 707925001,
 78196,
 -1,
 707990900,
 78197,
 708192823,
 707990348,
 78193,
 -1,
 708121972,
 78194,
 -54728,
 708121921,
 78201,
 -54727,
 708252941,
 78200,
 -54726,
 708318406,
 78199,
 -54725,
 708383873,
 78198,
 -54724,
 708449212,
 78195,
 -54723,
 708514471,
 78192,
 -54722,
 708579855,
 78191,
 -1,
 708645263,
 78190,
 708848204,
 707924812,
 -1,
 708913730,
 708777158,
 78186,
 -1,
 708842868,
 78187,
 709044804,
 708842625,
 78184,
 -1,
 708973940,
 78185,
 -54715,
 708973889,
 78189,
 -54714,
 709104909,
 78188,
 -54713,
 709170185,
 78183,
 -54712,
 709235644,
 78182,
 -54711,
 709301068,
 78181,
 -54710,
 709366439,
 78180,
 -54709,
 709431823,
 78179,
 -1,
 709497231,
 78178,
 709700185,
 708776615,
 -1,
 709765711,
 709629057,
 78173,
 -1,
 709694836,
 78174,
 709896785,
 709693839,
 78166,
 -1,
 709825908,
 78167,
 -54702,
 709825857,
 78177,
 -54701,
 709956877,
 78176,
 -54700,
 710022342,
 78175,
 -54699,
 710087689,
 78172,
 -54698,
 710153148,
 78171,
 -54697,
 710218572,
 78170,
 -54696,
 710283943,
 78169,
 -1,
 710349327,
 78168,
 710552166,
 709628303,
 -1,
 710617693,
 710481094,
 78150,
 -54692,
 710551158,
 78152,
 -1,
 710612340,
 78151,
 710814303,
 710546561,
 78148,
 -1,
 710743412,
 78149,
 -54688,
 710743361,
 78154,
 -54687,
 710874381,
 78153,
 -54686,
 710939657,
 78147,
 -54685,
 711005116,
 78146,
 -54684,
 711070540,
 78145,
 -54683,
 711135911,
 78144,
 -1,
 711201295,
 78143,
 711404146,
 710480399,
 -1,
 711469673,
 711332367,
 78156,
 -1,
 711398772,
 78157,
 -54678,
 711398721,
 78165,
 -54677,
 711529741,
 78164,
 -54676,
 711595206,
 78163,
 -54675,
 711660673,
 78162,
 -54674,
 711726089,
 78161,
 -54673,
 711791548,
 78160,
 -54672,
 711856972,
 78159,
 -54671,
 711922343,
 78158,
 -1,
 711987599,
 78155,
 712245247,
 711332873,
 -1,
 -54668,
 712119228,
 78206,
 -54667,
 712184652,
 78205,
 -54666,
 712250023,
 78204,
 -54665,
 712315407,
 78203,
 -1,
 712380815,
 78202,
 712583860,
 707901334,
 -1,
 712649351,
 712512015,
 -1,
 712714877,
 712577980,
 78560,
 -54660,
 712648310,
 78562,
 -1,
 712709492,
 78561,
 712911487,
 712643782,
 78565,
 -1,
 712840564,
 78566,
 -54656,
 712840513,
 78568,
 -54655,
 712971533,
 78567,
 -54654,
 713036929,
 78564,
 -54653,
 713102345,
 78563,
 -54652,
 713167692,
 78559,
 -54651,
 713233063,
 78558,
 -54650,
 713298447,
 78557,
 -1,
 713363855,
 78556,
 713566868,
 712577703,
 -1,
 713632395,
 713495681,
 78575,
 -54646,
 713565814,
 78577,
 -1,
 713626996,
 78576,
 -54644,
 713561409,
 78580,
 -54643,
 713757965,
 78579,
 -54642,
 713823430,
 78578,
 -54641,
 713888777,
 78574,
 -54640,
 713954236,
 78573,
 -54639,
 714019660,
 78572,
 -54638,
 714085031,
 78571,
 -54637,
 714150415,
 78570,
 -1,
 714215823,
 78569,
 714418848,
 713495372,
 -1,
 714484375,
 714347529,
 78586,
 -1,
 714413428,
 78587,
 -54632,
 714413377,
 78591,
 -54631,
 714544397,
 78590,
 -54630,
 714609862,
 78589,
 -54629,
 714675329,
 78588,
 -54628,
 714740668,
 78585,
 -54627,
 714806092,
 78584,
 -54626,
 714871463,
 78583,
 -54625,
 714936847,
 78582,
 -1,
 715002255,
 78581,
 715205292,
 714346895,
 -1,
 715270819,
 715134081,
 78551,
 -1,
 715199860,
 78552,
 715401893,
 715199143,
 78546,
 -1,
 715330932,
 78547,
 -54618,
 715330881,
 78555,
 -54617,
 715461901,
 78554,
 -54616,
 715527366,
 78553,
 -54615,
 715592713,
 78550,
 -54614,
 715658172,
 78549,
 -54613,
 715723596,
 78548,
 -1,
 715788815,
 78545,
 716046335,
 715133884,
 -1,
 -54610,
 715920513,
 78598,
 -54609,
 715985929,
 78597,
 -54608,
 716051388,
 78596,
 -54607,
 716116812,
 78595,
 -54606,
 716182183,
 78594,
 -54605,
 716247567,
 78593,
 -1,
 716312975,
 78592,
 716516073,
 712560298,
 -1,
 716581570,
 716444327,
 -1,
 716647096,
 716510529,
 78674,
 -1,
 716576116,
 78675,
 716778170,
 716575564,
 78667,
 -1,
 716707188,
 78668,
 -54597,
 716707085,
 78673,
 -54596,
 716838086,
 78672,
 -54595,
 716903553,
 78671,
 -54594,
 716968969,
 78670,
 -54593,
 717034428,
 78669,
 -54592,
 717099687,
 78666,
 -54591,
 717165071,
 78665,
 -1,
 717230479,
 78664,
 717433550,
 716510028,
 -1,
 717499077,
 717361831,
 78678,
 -1,
 717428084,
 78679,
 -54586,
 717428033,
 78686,
 -54585,
 717559053,
 78685,
 -54584,
 717624518,
 78684,
 -54583,
 717689985,
 78683,
 -54582,
 717755401,
 78682,
 -54581,
 717820860,
 78681,
 -54580,
 717886284,
 78680,
 -54579,
 717951503,
 78677,
 -1,
 718016911,
 78676,
 718219994,
 717361551,
 -1,
 718285522,
 718148737,
 78648,
 -54575,
 718218870,
 78650,
 -1,
 718280052,
 78649,
 -54573,
 718214465,
 78653,
 -54572,
 718411021,
 78652,
 -54571,
 718476486,
 78651,
 -54570,
 718541833,
 78647,
 -54569,
 718607292,
 78646,
 -54568,
 718672716,
 78645,
 -54567,
 718738087,
 78644,
 -1,
 718803471,
 78643,
 719006437,
 718148111,
 -1,
 -54564,
 718935361,
 78663,
 -54563,
 719000845,
 78662,
 -54562,
 719066310,
 78661,
 -54561,
 719131777,
 78660,
 -54560,
 719197193,
 78659,
 -54559,
 719262652,
 78658,
 -54558,
 719328076,
 78657,
 -54557,
 719393447,
 78656,
 -54556,
 719458831,
 78655,
 -1,
 719524239,
 78654,
 719781887,
 718934972,
 -1,
 -54553,
 719655591,
 78689,
 -54552,
 719720975,
 78688,
 -1,
 719786383,
 78687,
 719989530,
 716489490,
 -1,
 720055032,
 719917455,
 -1,
 720120557,
 719983937,
 78610,
 -1,
 720049524,
 78611,
 720251631,
 720049421,
 78608,
 -1,
 720180596,
 78609,
 720382705,
 720180422,
 78606,
 -1,
 720311668,
 78607,
 720513779,
 720311116,
 78601,
 -1,
 720442740,
 78602,
 -54540,
 720442497,
 78605,
 -54539,
 720573449,
 78604,
 -54538,
 720638908,
 78603,
 -54537,
 720704167,
 78600,
 -1,
 720769551,
 78599,
 720972549,
 719983119,
 -1,
 721038075,
 720901249,
 78619,
 -1,
 720967028,
 78620,
 721169149,
 720966159,
 78613,
 -1,
 721098100,
 78614,
 -54530,
 721098049,
 78623,
 -54529,
 721229069,
 78622,
 -54528,
 721294534,
 78621,
 -54527,
 721359881,
 78618,
 -54526,
 721425340,
 78617,
 -54525,
 721490764,
 78616,
 -54524,
 721556135,
 78615,
 -1,
 721621391,
 78612,
 721824528,
 720900775,
 -1,
 -54521,
 721753409,
 78633,
 -54520,
 721818893,
 78632,
 -54519,
 721884358,
 78631,
 -54518,
 721949825,
 78630,
 -54517,
 722015241,
 78629,
 -54516,
 722080700,
 78628,
 -54515,
 722146124,
 78627,
 -54514,
 722211495,
 78626,
 -54513,
 722276879,
 78625,
 -1,
 722342287,
 78624,
 722599935,
 721752908,
 -1,
 722610963,
 722473804,
 78638,
 -1,
 722539892,
 78639,
 722742037,
 722539175,
 78636,
 -1,
 722670964,
 78637,
 -54506,
 722670721,
 78642,
 -54505,
 722801673,
 78641,
 -54504,
 722867132,
 78640,
 -54503,
 722932239,
 78635,
 -1,
 722997647,
 78634,
 723200843,
 719929604,
 -1,
 723266344,
 723128999,
 -1,
 723331870,
 723195149,
 78066,
 -1,
 723260788,
 78067,
 723462944,
 723259791,
 78057,
 -1,
 723391860,
 78058,
 -54495,
 723391809,
 78068,
 -54494,
 723522758,
 78065,
 -54493,
 723588225,
 78064,
 -54492,
 723653641,
 78063,
 -54491,
 723719100,
 78062,
 -54490,
 723784524,
 78061,
 -54489,
 723849895,
 78060,
 -1,
 723915279,
 78059,
 724118325,
 723194383,
 -1,
 724183851,
 724047046,
 78053,
 -1,
 724112756,
 78054,
 724314925,
 724112513,
 78051,
 -1,
 724243828,
 78052,
 -54482,
 724243777,
 78056,
 -54481,
 724374797,
 78055,
 -54480,
 724440073,
 78050,
 -54479,
 724505532,
 78049,
 -54478,
 724570956,
 78048,
 -54477,
 724636327,
 78047,
 -54476,
 724701711,
 78046,
 -1,
 724767119,
 78045,
 724970305,
 724046223,
 -1,
 725035832,
 724899137,
 78043,
 -1,
 724964724,
 78044,
 725166906,
 724964621,
 78041,
 -1,
 725095796,
 78042,
 -54469,
 725095622,
 78040,
 -54468,
 725226625,
 78039,
 -54467,
 725292041,
 78038,
 -54466,
 725357500,
 78037,
 -54465,
 725422924,
 78036,
 -54464,
 725488295,
 78035,
 -1,
 725553679,
 78034,
 725811199,
 724898636,
 -1,
 725822276,
 725685180,
 78073,
 -1,
 725751156,
 78074,
 -54459,
 725751053,
 78077,
 -54458,
 725882054,
 78076,
 -54457,
 725947521,
 78075,
 -54456,
 726012748,
 78072,
 -54455,
 726078119,
 78071,
 -54454,
 726143503,
 78070,
 -1,
 726208911,
 78069,
 726412151,
 723183402,
 -1,
 726477669,
 726340111,
 -1,
 726543191,
 726406153,
 78842,
 -54449,
 726491519,
 78851,
 -54448,
 726554763,
 78850,
 -54447,
 726618851,
 78849,
 -54446,
 726683222,
 78848,
 -54445,
 726745223,
 78847,
 -54444,
 726808096,
 78846,
 -54443,
 726871262,
 78845,
 -54442,
 726935158,
 78844,
 -1,
 726996340,
 78843,
 727198560,
 726471809,
 78852,
 -54439,
 727144587,
 78860,
 -54438,
 727208675,
 78859,
 -54437,
 727273046,
 78858,
 -54436,
 727335047,
 78857,
 -54435,
 727397920,
 78856,
 -54434,
 727461086,
 78855,
 -54433,
 727524982,
 78854,
 -1,
 727586164,
 78853,
 -54431,
 727126972,
 78841,
 -54430,
 727716684,
 78840,
 -54429,
 727782055,
 78839,
 -54428,
 727847439,
 78838,
 -1,
 727912847,
 78837,
 728170495,
 726405519,
 -1,
 728181611,
 728044199,
 78821,
 -54424,
 728118816,
 78825,
 -54423,
 728181982,
 78824,
 -54422,
 728245878,
 78823,
 -1,
 728307060,
 78822,
 728509294,
 728109900,
 78826,
 -54419,
 728442486,
 78828,
 -1,
 728503668,
 78827,
 728705904,
 728437769,
 78831,
 -1,
 728634740,
 78832,
 728836978,
 728634300,
 78829,
 -1,
 728765812,
 78830,
 -54413,
 728765761,
 78836,
 -54412,
 728896781,
 78835,
 -54411,
 728962246,
 78834,
 -54410,
 729027713,
 78833,
 -1,
 729092623,
 78820,
 729295773,
 726378907,
 -1,
 729361285,
 729223695,
 -1,
 729426811,
 729289857,
 78530,
 -1,
 729355636,
 78531,
 729557885,
 729354639,
 78523,
 -1,
 729486708,
 78524,
 -54402,
 729486657,
 78534,
 -54401,
 729617677,
 78533,
 -54400,
 729683142,
 78532,
 -54399,
 729748489,
 78529,
 -54398,
 729813948,
 78528,
 -54397,
 729879372,
 78527,
 -54396,
 729944743,
 78526,
 -1,
 730010127,
 78525,
 730213266,
 729289103,
 -1,
 730278793,
 730141516,
 78514,
 -54392,
 730211958,
 78516,
 -1,
 730273140,
 78515,
 730475403,
 730206887,
 78512,
 -1,
 730404212,
 78513,
 -54388,
 730404161,
 78522,
 -54387,
 730535181,
 78521,
 -54386,
 730600646,
 78520,
 -54385,
 730666113,
 78519,
 -54384,
 730731529,
 78518,
 -54383,
 730796988,
 78517,
 -1,
 730862095,
 78511,
 731119615,
 730141351,
 -1,
 -54380,
 730993985,
 78544,
 -54379,
 731059469,
 78543,
 -54378,
 731124934,
 78542,
 -54377,
 731190401,
 78541,
 -54376,
 731255817,
 78540,
 -54375,
 731321276,
 78539,
 -54374,
 731386700,
 78538,
 -54373,
 731452071,
 78537,
 -54372,
 731517455,
 78536,
 -1,
 731582863,
 78535,
 731786177,
 729275693,
 -1,
 731851693,
 731714063,
 -1,
 731917217,
 731780365,
 78789,
 -1,
 731846004,
 78790,
 732048291,
 731845830,
 78787,
 -1,
 731977076,
 78788,
 732179365,
 731976636,
 78783,
 -1,
 732108148,
 78784,
 732310439,
 732107151,
 78778,
 -1,
 732239220,
 78779,
 -54360,
 732239169,
 78791,
 -54359,
 732370049,
 78786,
 -54358,
 732435465,
 78785,
 -54357,
 732500812,
 78782,
 -54356,
 732566183,
 78781,
 -1,
 732631567,
 78780,
 732834745,
 731779471,
 -1,
 732900272,
 732763457,
 78776,
 -1,
 732829044,
 78777,
 733031346,
 732828492,
 78769,
 -1,
 732960116,
 78770,
 -54349,
 732960013,
 78775,
 -54348,
 733091014,
 78774,
 -54347,
 733156481,
 78773,
 -54346,
 733221897,
 78772,
 -54345,
 733287356,
 78771,
 -54344,
 733352615,
 78768,
 -1,
 733417999,
 78767,
 733675519,
 732762791,
 -1,
 733686716,
 733549500,
 78796,
 -1,
 733615476,
 78797,
 -54339,
 733615113,
 78798,
 -54338,
 733745996,
 78795,
 -54337,
 733811367,
 78794,
 -54336,
 733876751,
 78793,
 -1,
 733942159,
 78792,
 734145505,
 731721016,
 -1,
 734211023,
 734073231,
 -1,
 734276551,
 734139047,
 77915,
 -54331,
 734211294,
 77918,
 -54330,
 734275190,
 77917,
 -1,
 734336372,
 77916,
 -54328,
 734205249,
 77925,
 -54327,
 734467341,
 77924,
 -54326,
 734532806,
 77923,
 -54325,
 734598273,
 77922,
 -54324,
 734663689,
 77921,
 -54323,
 734729148,
 77920,
 -54322,
 734794572,
 77919,
 -1,
 734859791,
 77914,
 735063003,
 734138895,
 -1,
 735128530,
 734990735,
 77926,
 -1,
 735057268,
 77927,
 -54317,
 735057217,
 77936,
 -54316,
 735188237,
 77935,
 -54315,
 735253702,
 77934,
 -54314,
 735319169,
 77933,
 -54313,
 735384585,
 77932,
 -54312,
 735450044,
 77931,
 -54311,
 735515468,
 77930,
 -54310,
 735580839,
 77929,
 -1,
 735646223,
 77928,
 735903743,
 734991015,
 -1,
 -54307,
 735777724,
 77941,
 -54306,
 735843148,
 77940,
 -54305,
 735908519,
 77939,
 -54304,
 735973903,
 77938,
 -1,
 736039311,
 77937,
 736242679,
 734093827,
 -1,
 736308206,
 736170383,
 -1,
 736373733,
 736236865,
 78225,
 -1,
 736302452,
 78226,
 736504807,
 736302089,
 78220,
 -1,
 736433524,
 78221,
 -54296,
 736433421,
 78224,
 -54295,
 736564422,
 78223,
 -54294,
 736629889,
 78222,
 -54293,
 736695228,
 78219,
 -54292,
 736760652,
 78218,
 -54291,
 736826023,
 78217,
 -1,
 736891407,
 78216,
 737148927,
 736236047,
 -1,
 737160177,
 737022479,
 78229,
 -1,
 737088884,
 78230,
 737291251,
 737087887,
 78227,
 -1,
 737219956,
 78228,
 -54284,
 737219593,
 78234,
 -54283,
 737350588,
 78233,
 -54282,
 737416012,
 78232,
 -1,
 737481383,
 78231,
 737684487,
 736206923,
 -1,
 737750020,
 737612175,
 -1,
 737815547,
 737678156,
 78494,
 -1,
 737744244,
 78495,
 737946621,
 737743375,
 78491,
 -1,
 737875316,
 78492,
 -54274,
 737875265,
 78501,
 -54273,
 738006285,
 78500,
 -54272,
 738071750,
 78499,
 -54271,
 738137217,
 78498,
 -54270,
 738202633,
 78497,
 -54269,
 738268092,
 78496,
 -1,
 738333351,
 78493,
 738590719,
 737677839,
 -1,
 -54266,
 738464271,
 78503,
 -1,
 738529679,
 78502,
 738733076,
 737665824,
 -1,
 738798603,
 738661308,
 78802,
 -54262,
 738731638,
 78804,
 -1,
 738792820,
 78803,
 738995213,
 738727181,
 78809,
 -1,
 738923892,
 78810,
 739126287,
 738923649,
 78806,
 -1,
 739054964,
 78807,
 -54256,
 739054790,
 78808,
 -54255,
 739185673,
 78805,
 -54254,
 739251020,
 78801,
 -54253,
 739316391,
 78800,
 -1,
 739381775,
 78799,
 739585055,
 738685862,
 -1,
 739650583,
 739513473,
 78249,
 -1,
 739579252,
 78250,
 739781657,
 739578535,
 78244,
 -1,
 739710324,
 78245,
 -54246,
 739710221,
 78252,
 -54245,
 739841222,
 78251,
 -54244,
 739906569,
 78248,
 -54243,
 739972028,
 78247,
 -54242,
 740037452,
 78246,
 -1,
 740102671,
 78243,
 740305962,
 739518085,
 -1,
 740371490,
 740234249,
 77908,
 -1,
 740300148,
 77909,
 -54237,
 740300097,
 77913,
 -54236,
 740431117,
 77912,
 -54235,
 740496582,
 77911,
 -54234,
 740562049,
 77910,
 -54233,
 740627388,
 77907,
 -54232,
 740692812,
 77906,
 -54231,
 740758183,
 77905,
 -1,
 740823567,
 77904,
 741026868,
 740287526,
 -1,
 741092397,
 740954639,
 78811,
 -1,
 741021044,
 78812,
 -54226,
 741020941,
 78819,
 -54225,
 741151942,
 78818,
 -54224,
 741217409,
 78817,
 -54223,
 741282825,
 78816,
 -54222,
 741348284,
 78815,
 -54221,
 741413708,
 78814,
 -1,
 741479079,
 78813,
 741682238,
 740972709,
 -1,
 741747767,
 741610625,
 78212,
 -1,
 741676404,
 78213,
 -54216,
 741676301,
 78215,
 -54215,
 741807302,
 78214,
 -54214,
 741872649,
 78211,
 -54213,
 741938108,
 78210,
 -54212,
 742003532,
 78209,
 -54211,
 742068903,
 78208,
 -1,
 742134287,
 78207,
 742337607,
 741634186,
 -1,
 -54208,
 742266125,
 78242,
 -54207,
 742331590,
 78241,
 -54206,
 742397057,
 78240,
 -54205,
 742462473,
 78239,
 -54204,
 742527932,
 78238,
 -54203,
 742593356,
 78237,
 -54202,
 742658727,
 78236,
 -1,
 742724111,
 78235,
 742981631,
 742303558,
 -1,
 -54199,
 742855878,
 78510,
 -54198,
 742921345,
 78509,
 -54197,
 742986761,
 78508,
 -54196,
 743052220,
 78507,
 -54195,
 743117644,
 78506,
 -54194,
 743183015,
 78505,
 -1,
 743248399,
 78504,
 743452263,
 665437878,
 -1,
 743517747,
 743421727,
 -1,
 743583280,
 743499245,
 -1,
 743648385,
 743527139,
 -1,
 743713889,
 743592675,
 -1,
 743779418,
 743693576,
 -1,
 743844951,
 743719047,
 11670,
 -1,
 743784583,
 11669,
 743976025,
 743773556,
 11667,
 -1,
 743904628,
 4895,
 -1,
 743924095,
 11668,
 744172636,
 743719047,
 4893,
 -1,
 744112263,
 4892,
 744303710,
 744101236,
 4888,
 -1,
 744232308,
 4891,
 -54177,
 744279626,
 4889,
 -54176,
 744395151,
 4894,
 -1,
 744448383,
 4890,
 744631403,
 743669248,
 -1,
 744696932,
 744591759,
 4774,
 -1,
 744625524,
 11658,
 744828006,
 744636551,
 4773,
 -1,
 744767623,
 4772,
 744959080,
 744756596,
 4768,
 -1,
 744887668,
 4771,
 -54167,
 744938800,
 4775,
 -54166,
 745066058,
 4769,
 -1,
 745103743,
 4770,
 745286771,
 744612846,
 -1,
 745352302,
 745226375,
 11741,
 -1,
 745291911,
 11740,
 745483376,
 745280884,
 11736,
 -1,
 745411956,
 11739,
 -54159,
 745459274,
 11737,
 -54158,
 745574799,
 11742,
 -1,
 745628031,
 11738,
 745811065,
 745266440,
 -1,
 745876598,
 745750663,
 4885,
 -1,
 745816199,
 4884,
 746007672,
 745805172,
 4880,
 -1,
 745936244,
 4883,
 -1,
 745955711,
 4882,
 746204283,
 745771407,
 4878,
 -1,
 746132852,
 4879,
 746335357,
 746143879,
 4877,
 -1,
 746274951,
 4876,
 746466431,
 746263924,
 4872,
 -1,
 746394996,
 4875,
 -54144,
 746442314,
 4873,
 -1,
 746545535,
 4874,
 746728619,
 743618335,
 -1,
 746794124,
 746674315,
 -1,
 746859653,
 746754447,
 4670,
 -1,
 746788212,
 11652,
 746990727,
 746799239,
 4669,
 -1,
 746930311,
 4668,
 747121801,
 746919284,
 4664,
 -1,
 747050356,
 4667,
 -54134,
 747101488,
 4671,
 -54133,
 747228746,
 4665,
 -1,
 747266431,
 4666,
 747449493,
 746776350,
 -1,
 747515023,
 747389063,
 4645,
 -1,
 747454599,
 4644,
 747646097,
 747443572,
 4640,
 -1,
 747574644,
 4643,
 -54126,
 747625776,
 4647,
 -54125,
 747753034,
 4641,
 -54124,
 747803023,
 4646,
 -1,
 747856255,
 4642,
 748039325,
 747419423,
 -1,
 748104856,
 747978887,
 11685,
 -1,
 748044423,
 11684,
 748235930,
 748033396,
 11680,
 -1,
 748164468,
 11683,
 -54117,
 748211786,
 11681,
 -54116,
 748327311,
 11686,
 -1,
 748380543,
 11682,
 748563620,
 747978887,
 4661,
 748629155,
 748496861,
 -1,
 -54112,
 748595005,
 5004,
 -54111,
 748652719,
 4992,
 -54110,
 748704474,
 5000,
 -1,
 748760223,
 4996,
 -1,
 748568711,
 4660,
 749022374,
 748523919,
 4662,
 -1,
 748950900,
 11651,
 749153448,
 748950900,
 4656,
 -1,
 749081972,
 4659,
 -54103,
 749133104,
 4663,
 -54102,
 749260362,
 4657,
 -1,
 749298047,
 4658,
 749481169,
 746701524,
 -1,
 749546678,
 749426827,
 -1,
 749612207,
 749506959,
 4902,
 -1,
 749540724,
 11663,
 749743281,
 749551751,
 4901,
 -1,
 749682823,
 4900,
 749874355,
 749671796,
 4896,
 -1,
 749802868,
 4899,
 -54092,
 749854000,
 4903,
 -54091,
 749981258,
 4897,
 -1,
 750018943,
 4898,
 750202047,
 749528862,
 -1,
 750267577,
 750162319,
 4934,
 -1,
 750196084,
 4935,
 750398651,
 750207111,
 4933,
 -1,
 750338183,
 4932,
 750529725,
 750327156,
 4928,
 -1,
 750458228,
 4931,
 -54082,
 750505546,
 4929,
 -1,
 750608767,
 4930,
 750791880,
 750171935,
 -1,
 750857410,
 750731399,
 4925,
 -1,
 750796935,
 4924,
 750988484,
 750785908,
 4920,
 -1,
 750916980,
 4923,
 -54075,
 750968112,
 4927,
 -54074,
 751095370,
 4921,
 -54073,
 751145359,
 4926,
 -1,
 751198591,
 4922,
 751381706,
 750752143,
 4726,
 -1,
 751310196,
 11654,
 751512780,
 751321223,
 4725,
 -1,
 751452295,
 4724,
 751643854,
 751441268,
 4720,
 -1,
 751572340,
 4723,
 -54065,
 751623472,
 4727,
 -54064,
 751750730,
 4721,
 -1,
 751788415,
 4722,
 751971574,
 749446980,
 -1,
 752037088,
 751917195,
 -1,
 752102617,
 752016648,
 -1,
 752168150,
 752042119,
 4701,
 -1,
 752107655,
 4700,
 752299224,
 752096628,
 4696,
 -1,
 752227700,
 4699,
 -1,
 752247167,
 4698,
 752495835,
 752042119,
 4693,
 -1,
 752435335,
 4692,
 752626909,
 752424308,
 4688,
 -1,
 752555380,
 4691,
 -54050,
 752602698,
 4689,
 -54049,
 752718223,
 4694,
 -1,
 752771455,
 4690,
 752954600,
 752018414,
 -1,
 753020131,
 752894087,
 11717,
 -1,
 752959623,
 11716,
 753151205,
 752948596,
 11712,
 -1,
 753079668,
 11715,
 -54042,
 753126986,
 11713,
 -54041,
 753242511,
 11718,
 -1,
 753295743,
 11714,
 753478894,
 752934152,
 -1,
 753544427,
 753418375,
 4685,
 -1,
 753483911,
 4684,
 753675501,
 753472884,
 4680,
 -1,
 753603956,
 4683,
 -1,
 753623423,
 4682,
 753872112,
 753439119,
 4678,
 -1,
 753800564,
 4679,
 754003186,
 753811591,
 4677,
 -1,
 753942663,
 4676,
 754134260,
 753931636,
 4672,
 -1,
 754062708,
 4675,
 -54027,
 754110026,
 4673,
 -1,
 754213247,
 4674,
 754396443,
 751923336,
 -1,
 754461957,
 754377476,
 -1,
 754527486,
 754441480,
 -1,
 754593019,
 754466951,
 4805,
 -1,
 754532487,
 4804,
 754724093,
 754521460,
 4800,
 -1,
 754652532,
 4803,
 -1,
 754671999,
 4802,
 754920704,
 754466951,
 4797,
 -1,
 754860167,
 4796,
 755051778,
 754849140,
 4792,
 -1,
 754980212,
 4795,
 -54013,
 755027530,
 4793,
 -54012,
 755143055,
 4798,
 -1,
 755196287,
 4794,
 755379469,
 754443246,
 -1,
 755445000,
 755318919,
 11725,
 -1,
 755384455,
 11724,
 755576074,
 755373428,
 11720,
 -1,
 755504500,
 11723,
 -54005,
 755551818,
 11721,
 -54004,
 755667343,
 11726,
 -1,
 755720575,
 11722,
 755903763,
 755358984,
 -1,
 755969296,
 755843207,
 4789,
 -1,
 755908743,
 4788,
 756100370,
 755897716,
 4784,
 -1,
 756028788,
 4787,
 -1,
 756048255,
 4786,
 756296981,
 755863951,
 4782,
 -1,
 756225396,
 4783,
 756428055,
 756236423,
 4781,
 -1,
 756367495,
 4780,
 756559129,
 756356468,
 4776,
 -1,
 756487540,
 4779,
 -53990,
 756534858,
 4777,
 -1,
 756638079,
 4778,
 756821311,
 754330846,
 -1,
 756886828,
 756755678,
 -1,
 756952357,
 756832395,
 -1,
 757017888,
 756891783,
 11709,
 -1,
 756957319,
 11708,
 757148962,
 756946292,
 11704,
 -1,
 757077364,
 11707,
 -53981,
 757124682,
 11705,
 -53980,
 757240207,
 11710,
 -1,
 757293439,
 11706,
 757476647,
 756891783,
 11693,
 -1,
 757416071,
 11692,
 757607721,
 757405044,
 11688,
 -1,
 757536116,
 11691,
 -53974,
 757583434,
 11689,
 -53973,
 757698959,
 11694,
 -1,
 757752191,
 11690,
 757935414,
 756832395,
 -1,
 758000943,
 757895567,
 4910,
 -1,
 757929332,
 11664,
 758132017,
 757940359,
 4909,
 -1,
 758071431,
 4908,
 758263091,
 758060404,
 4904,
 -1,
 758191476,
 4907,
 -53964,
 758242608,
 4911,
 -53963,
 758369866,
 4905,
 -1,
 758407551,
 4906,
 758590776,
 757895567,
 4734,
 -1,
 758519156,
 11655,
 758721850,
 758530183,
 4733,
 -1,
 758661255,
 4732,
 758852924,
 758650228,
 4728,
 -1,
 758781300,
 4731,
 -53955,
 758832432,
 4735,
 -53954,
 758959690,
 4729,
 -1,
 758997375,
 4730,
 759180639,
 756785129,
 -1,
 759246162,
 759126155,
 -1,
 759311691,
 759174516,
 4912,
 759377226,
 759281418,
 -1,
 759442757,
 759316615,
 4821,
 -1,
 759382151,
 4820,
 759573831,
 759371124,
 4816,
 -1,
 759502196,
 4819,
 -53944,
 759549514,
 4817,
 -53943,
 759665039,
 4822,
 -1,
 759718271,
 4818,
 -1,
 759305588,
 4915,
 759967053,
 759271823,
 4918,
 -1,
 759895412,
 11665,
 760098127,
 759906439,
 4917,
 -1,
 760037511,
 4916,
 -53936,
 760077616,
 4919,
 -53935,
 760204874,
 4913,
 -1,
 760242559,
 4914,
 760425815,
 759225608,
 -1,
 760491349,
 760365191,
 5007,
 -1,
 760430727,
 5006,
 -53930,
 760439167,
 5005,
 -1,
 760550772,
 4951,
 760753497,
 760385935,
 4950,
 -1,
 760681844,
 11666,
 760884571,
 760692871,
 4949,
 -1,
 760823943,
 4948,
 761015645,
 760812916,
 4944,
 -1,
 760943988,
 4947,
 -53922,
 760991306,
 4945,
 -1,
 761094527,
 4946,
 761277818,
 759162654,
 -1,
 761343337,
 761223307,
 -1,
 761408867,
 761282695,
 4837,
 -1,
 761348231,
 4836,
 761539941,
 761337204,
 4832,
 -1,
 761468276,
 4835,
 -53914,
 761519408,
 4839,
 -53913,
 761646666,
 4833,
 -53912,
 761696655,
 4838,
 -1,
 761749887,
 4834,
 761933169,
 761325342,
 -1,
 761998700,
 761872519,
 11701,
 -1,
 761938055,
 11700,
 762129774,
 761927028,
 11696,
 -1,
 762058100,
 11699,
 -53905,
 762105418,
 11697,
 -53904,
 762220943,
 11702,
 -1,
 762274175,
 11698,
 762457459,
 761893263,
 4830,
 -1,
 762385780,
 11659,
 762588533,
 762396807,
 4829,
 -1,
 762527879,
 4828,
 762719607,
 762516852,
 4824,
 -1,
 762647924,
 4827,
 -53896,
 762699056,
 4831,
 -53895,
 762826314,
 4825,
 -1,
 762863999,
 4826,
 763047313,
 761258756,
 -1,
 763112835,
 763028462,
 -1,
 763178366,
 763052167,
 11733,
 -1,
 763117703,
 11732,
 763309440,
 763106676,
 11728,
 -1,
 763237748,
 11731,
 -53887,
 763285066,
 11729,
 -53886,
 763400591,
 11734,
 -1,
 763453823,
 11730,
 763637129,
 763092232,
 -1,
 763702662,
 763576455,
 4749,
 -1,
 763641991,
 4748,
 763833736,
 763630964,
 4744,
 -1,
 763762036,
 4747,
 -1,
 763781503,
 4746,
 764030347,
 763597199,
 4742,
 -1,
 763958644,
 4743,
 764161421,
 763969671,
 4741,
 -1,
 764100743,
 4740,
 764292495,
 764089716,
 4736,
 -1,
 764220788,
 4739,
 -53872,
 764268106,
 4737,
 -1,
 764371327,
 4738,
 764554661,
 763005151,
 -1,
 764620188,
 764535790,
 -1,
 764685717,
 764580239,
 4766,
 -1,
 764614004,
 11657,
 764816791,
 764625031,
 4765,
 -1,
 764756103,
 4764,
 764947865,
 764745076,
 4760,
 -1,
 764876148,
 4763,
 -53862,
 764927280,
 4767,
 -53861,
 765054538,
 4761,
 -1,
 765092223,
 4762,
 765275550,
 764580239,
 4758,
 -1,
 765203828,
 11656,
 765406624,
 765214855,
 4757,
 -1,
 765345927,
 4756,
 765537698,
 765334900,
 4752,
 -1,
 765465972,
 4755,
 -53853,
 765517104,
 4759,
 -53852,
 765644362,
 4753,
 -1,
 765682047,
 4754,
 765865401,
 764491296,
 -1,
 765930928,
 765802016,
 -1,
 765996457,
 765890959,
 4862,
 -1,
 765924724,
 11661,
 766127531,
 765935751,
 4861,
 -1,
 766066823,
 4860,
 766258605,
 766055796,
 4856,
 -1,
 766186868,
 4859,
 -53842,
 766238000,
 4863,
 -53841,
 766365258,
 4857,
 -1,
 766402943,
 4858,
 766586290,
 765890959,
 4854,
 -1,
 766514548,
 11660,
 766717364,
 766525575,
 4853,
 -1,
 766656647,
 4852,
 766848438,
 766645620,
 4848,
 -1,
 766776692,
 4851,
 -53833,
 766827824,
 4855,
 -53832,
 766955082,
 4849,
 -1,
 766992767,
 4850,
 767176139,
 765810827,
 -1,
 767241667,
 767121547,
 -1,
 767307197,
 767180935,
 4629,
 -1,
 767246471,
 4628,
 767438271,
 767235444,
 4624,
 -1,
 767366516,
 4627,
 -53824,
 767417648,
 4631,
 -53823,
 767544906,
 4625,
 -53822,
 767594895,
 4630,
 -1,
 767648127,
 4626,
 767831493,
 767201679,
 4614,
 -1,
 767759732,
 4615,
 767962567,
 767770759,
 4613,
 -1,
 767901831,
 4612,
 768093641,
 767890804,
 4608,
 -1,
 768021876,
 4611,
 -53814,
 768069194,
 4609,
 -1,
 768172415,
 4610,
 768355802,
 767131621,
 -1,
 768421329,
 768335112,
 -1,
 768486863,
 768360583,
 4995,
 -1,
 768426119,
 4994,
 -53808,
 768434559,
 4993,
 -1,
 768546164,
 4639,
 768749011,
 768381327,
 4638,
 -1,
 768677236,
 11649,
 768880085,
 768688263,
 4637,
 -1,
 768819335,
 4636,
 769011159,
 768808308,
 4632,
 -1,
 768939380,
 4635,
 -53800,
 768992298,
 4953,
 -53799,
 769117770,
 4633,
 -1,
 769155455,
 4634,
 769338856,
 768298582,
 -1,
 769404384,
 769318152,
 -1,
 769469918,
 769343623,
 5003,
 -1,
 769409159,
 5002,
 -53793,
 769417599,
 5001,
 -1,
 769529204,
 4943,
 769732066,
 769343623,
 4941,
 -1,
 769671303,
 4940,
 769863140,
 769660276,
 4936,
 -1,
 769791348,
 4939,
 -53787,
 769844266,
 4954,
 -53786,
 769969738,
 4937,
 -53785,
 770019727,
 4942,
 -1,
 770072959,
 4938,
 770256374,
 769271414,
 -1,
 770321902,
 770235656,
 -1,
 770387436,
 770261127,
 4999,
 -1,
 770326663,
 4998,
 -53779,
 770335103,
 4997,
 -1,
 770446708,
 4711,
 770649584,
 770281871,
 4710,
 -1,
 770577780,
 11653,
 770780658,
 770588807,
 4709,
 -1,
 770719879,
 4708,
 770911732,
 770708852,
 4704,
 -1,
 770839924,
 4707,
 -53771,
 770887242,
 4705,
 -1,
 770990463,
 4706,
 771173889,
 770222420,
 -1,
 771239417,
 771133839,
 4654,
 -1,
 771167604,
 11650,
 771370491,
 771178631,
 4653,
 -1,
 771309703,
 4652,
 771501565,
 771298676,
 4648,
 -1,
 771429748,
 4651,
 -53762,
 771482666,
 4952,
 -53761,
 771611952,
 4655,
 -53760,
 771673674,
 4649,
 -1,
 771711359,
 4650,
 771894795,
 771126104,
 -1,
 771960324,
 771854735,
 4622,
 -1,
 771888500,
 11648,
 772091398,
 771899527,
 4621,
 -1,
 772030599,
 4620,
 772222472,
 772019572,
 4616,
 -1,
 772150644,
 4619,
 -53751,
 772201776,
 4623,
 -53750,
 772329034,
 4617,
 -1,
 772366719,
 4618,
 772550165,
 771845929,
 -1,
 772615694,
 772510095,
 4870,
 -1,
 772543860,
 11662,
 772746768,
 772554887,
 4869,
 -1,
 772685959,
 4868,
 772877842,
 772674932,
 4864,
 -1,
 772806004,
 4867,
 -53741,
 772857136,
 4871,
 -53740,
 772984394,
 4865,
 -1,
 773022079,
 4866,
 773205534,
 772531182,
 -1,
 773271064,
 773165455,
 4846,
 -1,
 773199220,
 4847,
 773402138,
 773210247,
 4845,
 -1,
 773341319,
 4844,
 773533212,
 773330292,
 4840,
 -1,
 773461364,
 4843,
 -53731,
 773508682,
 4841,
 -1,
 773611903,
 4842,
 773795367,
 773184776,
 -1,
 773860897,
 773755279,
 4814,
 -1,
 773789044,
 4815,
 773991971,
 773800071,
 4813,
 -1,
 773931143,
 4812,
 774123045,
 773920116,
 4808,
 -1,
 774051188,
 4811,
 -53722,
 774098506,
 4809,
 -1,
 774201727,
 4810,
 774438911,
 773773230,
 -1,
 774450730,
 774324359,
 4717,
 -1,
 774389895,
 4716,
 774581804,
 774378868,
 4712,
 -1,
 774509940,
 4715,
 -53715,
 774561072,
 4719,
 -53714,
 774688330,
 4713,
 -53713,
 774738319,
 4718,
 -1,
 774791551,
 4714,
 775028735,
 743522439,
 -1,
 -53710,
 774931614,
 4964,
 -1,
 774976813,
 4960,
 775171650,
 743477311,
 -1,
 775237177,
 775144148,
 -1,
 775302711,
 775177969,
 4978,
 -1,
 775228113,
 4988,
 -53704,
 775282271,
 4979,
 -1,
 775380427,
 4980,
 775564860,
 775206687,
 -1,
 -53701,
 775515927,
 4983,
 -1,
 775572691,
 4984,
 775761471,
 775507542,
 -1,
 -53698,
 775723505,
 4981,
 -1,
 775775365,
 4982,
 -53696,
 775720157,
 4986,
 -53695,
 775905559,
 4987,
 -1,
 775964027,
 4985,
 776154703,
 775145898,
 -1,
 776220231,
 776091168,
 -1,
 776285766,
 776161723,
 5009,
 -1,
 776212462,
 5016,
 -1,
 776234059,
 5012,
 776482378,
 776171656,
 -1,
 -53687,
 776459847,
 5017,
 -1,
 776488784,
 5013,
 -53685,
 776463840,
 5008,
 -53684,
 776649641,
 5011,
 -53683,
 776712588,
 5010,
 -53682,
 776756417,
 5015,
 -1,
 776810426,
 5014,
 777006684,
 776092056,
 -1,
 777072211,
 776979156,
 -1,
 -53678,
 777052559,
 4970,
 -1,
 777085014,
 4971,
 777268822,
 777041695,
 -1,
 -53675,
 777219822,
 4974,
 -1,
 777276546,
 4975,
 777465433,
 777211478,
 -1,
 -53672,
 777427952,
 4972,
 -1,
 777481847,
 4973,
 -53670,
 777426367,
 4969,
 -53669,
 777620668,
 4977,
 -1,
 777667895,
 4976,
 777858657,
 776942056,
 -1,
 777924192,
 777813989,
 -1,
 -53665,
 777879602,
 4963,
 -1,
 777922962,
 4959,
 -1,
 777878802,
 4965,
 778186340,
 777822185,
 -1,
 -53661,
 778153115,
 4966,
 -1,
 778182867,
 4968,
 -53659,
 778167000,
 4961,
 -53658,
 778348734,
 4967,
 -1,
 778392258,
 4962,
 778579592,
 743417793,
 -1,
 778645123,
 778508788,
 -1,
 778710650,
 778614561,
 -1,
 778776184,
 778681387,
 61,
 778895359,
 778698752,
 -1,
 778907252,
 778769780,
 -1,
 778972786,
 778840910,
 -1,
 -53649,
 778946585,
 10867,
 -53648,
 779006111,
 10609,
 -53647,
 779068553,
 10865,
 -1,
 779122761,
 11072,
 779354111,
 778930838,
 10723,
 -1,
 779226768,
 10724,
 779485183,
 778887026,
 -1,
 -53642,
 779406743,
 10871,
 -53641,
 779434811,
 10854,
 -1,
 779496518,
 10926,
 -53639,
 778755960,
 10862,
 -1,
 779629035,
 8789,
 779878399,
 778633216,
 -1,
 779890306,
 779798837,
 -1,
 779955841,
 779851769,
 -1,
 -53634,
 779927970,
 8927,
 -53633,
 779986435,
 8926,
 -53632,
 780040527,
 8924,
 -1,
 780097271,
 8925,
 -1,
 779889834,
 8797,
 -1,
 779820550,
 8917,
 780468223,
 778592639,
 -1,
 780480135,
 780392431,
 -1,
 -53626,
 780460035,
 10872,
 -1,
 780519730,
 8781,
 -1,
 780410584,
 8794,
 780742300,
 778560260,
 -1,
 780807831,
 780715329,
 -1,
 780873357,
 780780244,
 -1,
 -53620,
 780853647,
 1778,
 -1,
 780886102,
 1779,
 781069968,
 780842783,
 -1,
 -53617,
 781020910,
 1782,
 -1,
 781077634,
 1783,
 781266579,
 781012566,
 -1,
 -53614,
 781229040,
 1780,
 -1,
 781282935,
 1781,
 -53612,
 781248405,
 1776,
 -53611,
 781424063,
 1777,
 -53610,
 781487292,
 1785,
 -1,
 781534519,
 1784,
 781778943,
 780741854,
 -1,
 781790875,
 781677776,
 -1,
 -53606,
 781756606,
 8265,
 -1,
 781812314,
 33,
 -1,
 781732557,
 8761,
 782053036,
 780695122,
 -1,
 782118569,
 782009376,
 8712,
 782237695,
 782041088,
 -1,
 782249638,
 782163826,
 -1,
 -53599,
 782228087,
 8947,
 -53598,
 782291543,
 8952,
 -53597,
 782355897,
 8953,
 -53596,
 782409386,
 8950,
 -53595,
 782466374,
 8946,
 -1,
 782514993,
 8949,
 782761983,
 782210922,
 -1,
 -53592,
 782685481,
 10194,
 -1,
 782712624,
 10969,
 782958591,
 782054745,
 -1,
 -53589,
 782834178,
 9191,
 -1,
 782893546,
 8961,
 783101625,
 782008293,
 -1,
 783167157,
 783065065,
 -1,
 783232692,
 783142444,
 8709,
 783351807,
 783158307,
 -1,
 -53583,
 783269359,
 10674,
 -53582,
 783330999,
 10675,
 -53581,
 783392426,
 10673,
 -1,
 783447727,
 10676,
 -1,
 783178490,
 9091,
 783745023,
 783089664,
 -1,
 -53577,
 783662829,
 8195,
 -53576,
 783722440,
 8193,
 -1,
 783759113,
 8212,
 783953606,
 783067476,
 -1,
 784019139,
 783922280,
 -1,
 784084671,
 783998639,
 -1,
 -53571,
 784056151,
 10734,
 -53570,
 784087341,
 10736,
 -1,
 784150594,
 10738,
 784400383,
 784017916,
 -1,
 -53567,
 784318295,
 10735,
 -53566,
 784349485,
 10737,
 -1,
 784412738,
 10739,
 784662527,
 783950650,
 -1,
 -53563,
 784576097,
 8998,
 -1,
 784627333,
 9003,
 784805585,
 783901923,
 -1,
 784871120,
 784728064,
 -1,
 784936654,
 784834537,
 -1,
 785002189,
 784896957,
 -1,
 -53557,
 784968750,
 10039,
 -53556,
 785032140,
 10037,
 -1,
 785066580,
 10036,
 -1,
 784944022,
 10049,
 -53553,
 784909483,
 10058,
 -1,
 785301311,
 10035,
 -1,
 784816272,
 9834,
 785526489,
 784763103,
 -1,
 785592022,
 785448960,
 -1,
 -53548,
 785563373,
 8194,
 -53547,
 785622984,
 8192,
 -1,
 785659657,
 8211,
 -53545,
 785570162,
 9993,
 -53544,
 785827195,
 9094,
 -1,
 785856070,
 8718,
 786050782,
 785501770,
 -1,
 786116317,
 786019284,
 -1,
 -53540,
 786042696,
 8352,
 -1,
 786106917,
 8364,
 -1,
 786069817,
 8455,
 786378466,
 785978740,
 -1,
 786444001,
 786347586,
 9793,
 -1,
 786367517,
 9178,
 -1,
 786415646,
 9841,
 786640613,
 786350249,
 -1,
 -53532,
 786609951,
 8793,
 -1,
 786642532,
 8494,
 -53530,
 786591595,
 9167,
 -1,
 786774604,
 11790,
 786970310,
 665326964,
 -1,
 787035527,
 786934100,
 -1,
 787100930,
 786962003,
 -1,
 787166446,
 787021824,
 -1,
 787231860,
 787116888,
 -1,
 787296756,
 787178655,
 -1,
 787361669,
 787265311,
 -1,
 787427121,
 787306635,
 -1,
 787492642,
 787366736,
 -1,
 787558143,
 787437707,
 -1,
 787623676,
 787486970,
 -1,
 787689207,
 787603314,
 -1,
 787754742,
 787645324,
 -1,
 -53515,
 787704165,
 64872,
 -1,
 787763257,
 64871,
 -1,
 787735781,
 64938,
 788016890,
 787636607,
 -1,
 -53511,
 787988108,
 64778,
 -1,
 788040981,
 64814,
 -53509,
 787972972,
 64824,
 -1,
 788156473,
 64806,
 788398079,
 787563732,
 -1,
 -53506,
 788300652,
 64746,
 -1,
 788359525,
 64818,
 788541196,
 787514252,
 -1,
 788606727,
 788520818,
 -1,
 788672260,
 788562828,
 -1,
 -53501,
 788621669,
 64877,
 -1,
 788680761,
 64876,
 788922367,
 788623879,
 -1,
 -53498,
 788818277,
 64875,
 -1,
 788877369,
 64874,
 789065482,
 788554111,
 -1,
 -53495,
 789036684,
 64780,
 -1,
 789089557,
 64816,
 -53493,
 789021548,
 64745,
 -1,
 789205049,
 64808,
 789393171,
 788492168,
 -1,
 789458704,
 789340543,
 -1,
 -53489,
 789429900,
 64777,
 -1,
 789482773,
 64813,
 -53487,
 789438772,
 64873,
 -53486,
 789611372,
 64823,
 -1,
 789663801,
 64805,
 789851929,
 789344775,
 -1,
 789917463,
 789799295,
 -1,
 -53482,
 789888652,
 64779,
 -1,
 789941525,
 64815,
 -53480,
 789873516,
 64825,
 -1,
 790057017,
 64807,
 790245148,
 789832918,
 -1,
 -53477,
 790195532,
 64766,
 -1,
 790253625,
 64794,
 790441759,
 790211756,
 -1,
 -53474,
 790392140,
 64781,
 -1,
 790450233,
 64809,
 790691839,
 790371015,
 -1,
 -53471,
 790588748,
 64765,
 -1,
 790646841,
 64793,
 790888447,
 787421169,
 -1,
 790900520,
 790786371,
 -1,
 790966055,
 790822912,
 -1,
 -53466,
 790922092,
 64756,
 -1,
 790981964,
 64610,
 -1,
 790938628,
 64607,
 791228205,
 790836964,
 -1,
 791293740,
 791150592,
 -1,
 -53461,
 791249772,
 64755,
 -1,
 791309644,
 64609,
 -1,
 791266308,
 64606,
 791555888,
 791170839,
 -1,
 -53457,
 791511916,
 64754,
 -1,
 791571788,
 64608,
 -1,
 791527914,
 64611,
 791818082,
 787366736,
 -1,
 791883583,
 791774092,
 -1,
 791949115,
 791863154,
 -1,
 792014647,
 791905164,
 -1,
 -53450,
 791964005,
 64867,
 -1,
 792023097,
 64866,
 792211258,
 791959843,
 -1,
 -53447,
 792160613,
 64864,
 -1,
 792219705,
 64863,
 -1,
 792162197,
 64865,
 792473406,
 791896447,
 -1,
 -53443,
 792444556,
 64543,
 -1,
 792497429,
 64688,
 -1,
 792429420,
 64743,
 792735561,
 791828619,
 -1,
 792801094,
 792664314,
 -1,
 792866628,
 792748415,
 -1,
 -53437,
 792837772,
 64541,
 -1,
 792890645,
 64686,
 -53435,
 792846424,
 64860,
 -1,
 793019244,
 64821,
 793247743,
 792741076,
 -1,
 -53432,
 793150316,
 64744,
 -1,
 793209189,
 64817,
 793390929,
 792687111,
 -1,
 793456461,
 793370482,
 -1,
 -53428,
 793437413,
 64966,
 -1,
 793451221,
 64936,
 793653072,
 793403775,
 -1,
 -53425,
 793624204,
 64542,
 -1,
 793677077,
 64687,
 -1,
 793609068,
 64822,
 793915225,
 793341832,
 -1,
 793980757,
 793894770,
 -1,
 -53420,
 793925934,
 64861,
 -1,
 793975509,
 64862,
 794177368,
 793928063,
 -1,
 -53417,
 794148492,
 64540,
 -1,
 794201365,
 64685,
 -1,
 794133356,
 64820,
 794439516,
 793896150,
 -1,
 -53413,
 794389836,
 64764,
 -1,
 794447929,
 64792,
 794636127,
 794406060,
 -1,
 -53410,
 794586444,
 64782,
 -1,
 794644537,
 64810,
 794886143,
 794565319,
 -1,
 -53407,
 794783052,
 64763,
 -1,
 794841145,
 64791,
 795082751,
 791745908,
 -1,
 795094910,
 794965613,
 -1,
 795160429,
 795040035,
 -1,
 795225962,
 795139954,
 -1,
 795291497,
 795171107,
 -1,
 -53400,
 795240805,
 64869,
 -1,
 795299897,
 64868,
 -1,
 795272421,
 64937,
 795607039,
 795173247,
 -1,
 -53396,
 795524748,
 64544,
 -1,
 795577621,
 64689,
 795750260,
 795116428,
 -1,
 795815793,
 795730031,
 -1,
 -53392,
 795765093,
 64965,
 -1,
 795824185,
 64870,
 796065791,
 795763071,
 -1,
 -53389,
 795983500,
 64545,
 -1,
 796036373,
 64691,
 796209015,
 795731158,
 -1,
 -53386,
 796159308,
 64774,
 -1,
 796217401,
 64802,
 796405626,
 796175532,
 -1,
 -53383,
 796355916,
 64783,
 -1,
 796414009,
 64811,
 796602237,
 796334791,
 -1,
 -53380,
 796552524,
 64773,
 -1,
 796610617,
 64801,
 -1,
 796553748,
 64690,
 796917759,
 795046744,
 -1,
 796929924,
 796816301,
 -1,
 796995459,
 796852224,
 -1,
 -53374,
 796972663,
 65008,
 -1,
 797011276,
 65017,
 -1,
 796949559,
 65018,
 -1,
 796859506,
 65013,
 797323234,
 787333844,
 -1,
 797388729,
 797263080,
 -1,
 797454227,
 797344652,
 -1,
 797519758,
 797433714,
 -1,
 -53366,
 797500645,
 64931,
 -53365,
 797536788,
 64855,
 -53364,
 797601685,
 64853,
 -53363,
 797661486,
 64854,
 -1,
 797711061,
 64932,
 797912977,
 797467007,
 -1,
 -53360,
 797884044,
 64526,
 -1,
 797936917,
 64676,
 -53358,
 797868908,
 64739,
 -1,
 798052409,
 64626,
 798240672,
 797399179,
 -1,
 798306205,
 798169338,
 -1,
 798371738,
 798285682,
 -1,
 798437273,
 798322568,
 -1,
 -53352,
 798386533,
 64850,
 -1,
 798445625,
 64849,
 -1,
 798393257,
 64851,
 798752767,
 798318975,
 -1,
 -53348,
 798670476,
 64524,
 -1,
 798723349,
 64674,
 798949375,
 798246100,
 -1,
 -53345,
 798851948,
 64740,
 -1,
 798910821,
 64677,
 799092648,
 798192135,
 -1,
 799158181,
 799072114,
 -1,
 -53341,
 799139045,
 64929,
 -53340,
 799179689,
 64852,
 -1,
 799218389,
 64930,
 799473663,
 799105407,
 -1,
 -53337,
 799391372,
 64525,
 -1,
 799444245,
 64675,
 799616944,
 799043464,
 -1,
 799682477,
 799596402,
 -1,
 -53333,
 799663333,
 64927,
 -53332,
 799703977,
 64848,
 -1,
 799742677,
 64928,
 799997951,
 799629695,
 -1,
 -53329,
 799915660,
 64523,
 -1,
 799968533,
 64673,
 800141235,
 799597782,
 -1,
 -53326,
 800091468,
 64528,
 -1,
 800149561,
 64629,
 800337846,
 800070343,
 -1,
 -53323,
 800288076,
 64527,
 -1,
 800346169,
 64628,
 -53321,
 800319307,
 64625,
 -53320,
 800500913,
 64624,
 -1,
 800558526,
 64627,
 800731085,
 797333643,
 -1,
 800796620,
 800670952,
 -1,
 800862145,
 800752524,
 -1,
 800927679,
 800809343,
 -1,
 -53314,
 800898700,
 64530,
 -1,
 800951573,
 64678,
 -53312,
 800883564,
 64741,
 -1,
 801067065,
 64632,
 801255364,
 800842966,
 -1,
 -53309,
 801205580,
 64532,
 -1,
 801263673,
 64635,
 801451975,
 801184455,
 -1,
 -53306,
 801402188,
 64531,
 -1,
 801460281,
 64634,
 -53304,
 801433419,
 64631,
 -53303,
 801615025,
 64630,
 -53302,
 801672638,
 64633,
 -53301,
 801730471,
 64529,
 -1,
 801790986,
 64742,
 -1,
 800725547,
 64603,
 802095103,
 800659715,
 -1,
 802107353,
 801997708,
 -1,
 802172885,
 802086770,
 -1,
 802238419,
 802117923,
 -1,
 -53294,
 802187621,
 64882,
 -1,
 802246713,
 64881,
 -53292,
 802219237,
 64884,
 -1,
 802390953,
 64883,
 802566104,
 802120063,
 -1,
 -53289,
 802537100,
 64551,
 -1,
 802589973,
 64819,
 -1,
 802521964,
 64826,
 802828252,
 802088150,
 -1,
 -53285,
 802778444,
 64758,
 -1,
 802836537,
 64786,
 803024863,
 802773288,
 -1,
 -53282,
 802995852,
 64550,
 -1,
 803048725,
 64696,
 803274751,
 802953927,
 -1,
 -53279,
 803171660,
 64757,
 -1,
 803229753,
 64785,
 803418173,
 797304070,
 -1,
 803483681,
 803362955,
 -1,
 803549214,
 803411316,
 -1,
 803614745,
 803506383,
 -1,
 803680240,
 803542388,
 -1,
 803745773,
 803632768,
 -1,
 803811307,
 803700891,
 -1,
 -53270,
 803761484,
 64515,
 -1,
 803819577,
 64616,
 -53268,
 803761484,
 64490,
 -1,
 803950649,
 64491,
 804192255,
 803684489,
 -1,
 -53265,
 804089164,
 64492,
 -1,
 804147257,
 64493,
 804335607,
 803660782,
 -1,
 804401140,
 804310604,
 -1,
 -53261,
 804351308,
 64500,
 -1,
 804409401,
 64501,
 804651007,
 804340948,
 -1,
 -53258,
 804547916,
 64516,
 -1,
 804606009,
 64617,
 804794365,
 804291468,
 -1,
 804859899,
 804741503,
 -1,
 -53254,
 804830860,
 64514,
 -1,
 804883733,
 64666,
 -53252,
 804815724,
 64735,
 -1,
 804999225,
 64614,
 805187588,
 804739211,
 -1,
 805253121,
 805127380,
 -1,
 -53248,
 805208940,
 64736,
 -1,
 805267813,
 64667,
 805502975,
 805181694,
 -1,
 -53245,
 805420684,
 64513,
 -1,
 805473557,
 64664,
 805646345,
 805126281,
 -1,
 805711880,
 805593471,
 -1,
 -53241,
 805682828,
 64502,
 -1,
 805735701,
 64504,
 -1,
 805654585,
 64503,
 805974028,
 805625395,
 -1,
 -53237,
 805924172,
 64494,
 -1,
 805982265,
 64495,
 806170639,
 805949004,
 -1,
 -53234,
 806120780,
 64496,
 -1,
 806178873,
 64497,
 806367250,
 806130392,
 -1,
 -53231,
 806317388,
 64498,
 -1,
 806375481,
 64499,
 806563861,
 806317966,
 -1,
 -53228,
 806534796,
 64512,
 -1,
 806587669,
 64663,
 -53226,
 806545227,
 64613,
 -53225,
 806726833,
 64612,
 -53224,
 806784446,
 64615,
 -1,
 806842900,
 64665,
 807075839,
 803559565,
 -1,
 807088157,
 806969727,
 -1,
 -53220,
 807059084,
 64598,
 -1,
 807111957,
 64731,
 -1,
 807067956,
 64942,
 807403519,
 803488980,
 -1,
 -53216,
 807306092,
 64753,
 -1,
 807364965,
 64734,
 807546924,
 803439500,
 -1,
 807612455,
 807526258,
 -1,
 807677990,
 807568268,
 -1,
 -53211,
 807627109,
 64925,
 -1,
 807686201,
 64924,
 -1,
 807658725,
 64944,
 807940138,
 807559551,
 -1,
 -53207,
 807911052,
 64600,
 -1,
 807963925,
 64733,
 -53205,
 807895916,
 64752,
 -1,
 808079417,
 64659,
 808267825,
 807497608,
 -1,
 808333360,
 808214911,
 -1,
 -53201,
 808304268,
 64597,
 -1,
 808357141,
 64730,
 -1,
 808313140,
 64943,
 808595508,
 808248534,
 -1,
 -53197,
 808545612,
 64602,
 -1,
 808603705,
 64662,
 808792119,
 808546829,
 -1,
 -53194,
 808763020,
 64599,
 -1,
 808815893,
 64732,
 808988730,
 808721095,
 -1,
 -53191,
 808938828,
 64601,
 -1,
 808996921,
 64661,
 -53189,
 808970059,
 64658,
 -53188,
 809151665,
 64657,
 -1,
 809209278,
 64660,
 809382012,
 803370175,
 -1,
 809447503,
 809310902,
 -1,
 809513034,
 809426802,
 -1,
 809578567,
 809458182,
 -1,
 809644100,
 809511001,
 -1,
 -53181,
 809594188,
 65273,
 -1,
 809652281,
 65274,
 809893887,
 809571963,
 -1,
 -53178,
 809790796,
 65271,
 -1,
 809848889,
 65272,
 810090495,
 809533524,
 -1,
 -53175,
 809987404,
 65269,
 -1,
 810045497,
 65270,
 810233933,
 809468059,
 -1,
 -53172,
 810184012,
 64579,
 -1,
 810242105,
 64646,
 -53170,
 810184012,
 65275,
 -1,
 810373177,
 65276,
 810561626,
 809403276,
 -1,
 810627157,
 810540914,
 -1,
 810692692,
 810572067,
 -1,
 -53165,
 810641765,
 64904,
 -1,
 810700857,
 64903,
 -1,
 810673381,
 64941,
 810954840,
 810574207,
 -1,
 -53161,
 810925708,
 64578,
 -1,
 810978581,
 64716,
 -53159,
 810910572,
 64749,
 -1,
 811094073,
 64645,
 811282534,
 810512264,
 -1,
 811348067,
 811261810,
 -1,
 811413599,
 811303820,
 -1,
 -53154,
 811362661,
 64954,
 -1,
 811421753,
 64956,
 811610210,
 811364232,
 -1,
 -53151,
 811559269,
 64899,
 -1,
 811618361,
 64900,
 -1,
 811590885,
 64940,
 811925503,
 811295103,
 -1,
 -53147,
 811843212,
 64575,
 -1,
 811896085,
 64713,
 812068978,
 811227275,
 -1,
 812134513,
 811997434,
 -1,
 812200046,
 812113778,
 -1,
 812265580,
 812155788,
 -1,
 -53141,
 812214629,
 64949,
 -1,
 812273721,
 64896,
 -53139,
 812246245,
 64897,
 -1,
 812391125,
 64898,
 812646399,
 812147071,
 -1,
 -53136,
 812564108,
 64576,
 -1,
 812616981,
 64714,
 -1,
 812074200,
 64717,
 812855417,
 812020231,
 -1,
 812920950,
 812834927,
 -1,
 -53131,
 812869989,
 64902,
 -1,
 812929081,
 64901,
 813170687,
 812867967,
 -1,
 -53128,
 813088396,
 64577,
 -1,
 813141269,
 64715,
 813367295,
 812836054,
 -1,
 -53125,
 813264204,
 64580,
 -1,
 813322297,
 64647,
 813510831,
 809332872,
 -1,
 813576353,
 813439114,
 -1,
 813641865,
 813532044,
 -1,
 813707396,
 813621106,
 -1,
 813772931,
 813663116,
 -1,
 -53118,
 813721957,
 64963,
 -1,
 813781049,
 64955,
 -1,
 813753573,
 64951,
 814035079,
 813654399,
 -1,
 -53114,
 814005900,
 64572,
 -1,
 814058773,
 64712,
 -53112,
 813990764,
 64748,
 -1,
 814174265,
 64642,
 814362767,
 813593786,
 -1,
 814428301,
 814309759,
 -1,
 -53108,
 814399116,
 64571,
 -1,
 814451989,
 64711,
 -53106,
 814383980,
 64747,
 -1,
 814567481,
 64641,
 814755989,
 814291638,
 -1,
 814821523,
 814710939,
 -1,
 -53102,
 814771532,
 64573,
 -1,
 814829625,
 64643,
 -53100,
 814771532,
 64567,
 -1,
 814960697,
 64640,
 815149208,
 814736598,
 -1,
 -53097,
 815099212,
 64574,
 -1,
 815157305,
 64644,
 815345819,
 815100429,
 -1,
 -53094,
 815316620,
 64570,
 -1,
 815369493,
 64710,
 815542430,
 815296398,
 -1,
 -53091,
 815513228,
 64568,
 -1,
 815566101,
 64708,
 815792127,
 815487272,
 -1,
 -53088,
 815709836,
 64569,
 -1,
 815762709,
 64709,
 815988735,
 813521233,
 -1,
 816001189,
 815916246,
 -1,
 -53084,
 815951180,
 64772,
 -1,
 816009273,
 64800,
 816197800,
 815956898,
 -1,
 -53081,
 816168588,
 64539,
 -1,
 816221461,
 64684,
 816394411,
 816148366,
 -1,
 -53078,
 816365196,
 64537,
 -1,
 816418069,
 64683,
 816591022,
 816323271,
 -1,
 -53075,
 816541004,
 64771,
 -1,
 816599097,
 64799,
 -1,
 816535871,
 64538,
 816853214,
 813469134,
 -1,
 816918717,
 816803720,
 -1,
 816984250,
 816897906,
 -1,
 817049781,
 816939916,
 -1,
 -53068,
 816998757,
 64920,
 -1,
 817057849,
 64919,
 817246392,
 816994595,
 -1,
 -53065,
 817195365,
 64952,
 -1,
 817254457,
 64957,
 -53063,
 817226981,
 64967,
 -1,
 817371861,
 64921,
 817627135,
 816931199,
 -1,
 -53060,
 817544844,
 64587,
 -1,
 817597717,
 64722,
 817770697,
 816863371,
 -1,
 817836230,
 817699066,
 -1,
 817901763,
 817815410,
 -1,
 -53055,
 817882341,
 64947,
 -53054,
 817922985,
 64917,
 -1,
 817961685,
 64918,
 818216959,
 817848703,
 -1,
 -53051,
 818134668,
 64588,
 -1,
 818187541,
 64723,
 818413567,
 817775828,
 -1,
 -53048,
 818316140,
 64751,
 -1,
 818375013,
 64726,
 818557138,
 817726348,
 -1,
 818622669,
 818536306,
 -1,
 -53044,
 818603237,
 64922,
 -1,
 818617045,
 64923,
 818819280,
 818569599,
 -1,
 -53041,
 818790028,
 64590,
 -1,
 818842901,
 64725,
 -53039,
 818774892,
 64750,
 -1,
 818958393,
 64652,
 819146965,
 818537686,
 -1,
 -53036,
 819096908,
 64592,
 -1,
 819155001,
 64655,
 819343576,
 819098125,
 -1,
 -53033,
 819314316,
 64589,
 -1,
 819367189,
 64724,
 819540187,
 819272391,
 -1,
 -53030,
 819490124,
 64591,
 -1,
 819548217,
 64654,
 -53028,
 819521355,
 64651,
 -53027,
 819702961,
 64650,
 -1,
 819760574,
 64653,
 819933444,
 816807909,
 -1,
 819998979,
 819872578,
 -1,
 820064489,
 819949448,
 -1,
 820130022,
 820043634,
 -1,
 -53021,
 820110565,
 64960,
 -53020,
 820151209,
 64909,
 -53019,
 820212244,
 64914,
 -1,
 820271406,
 64908,
 820510719,
 820076927,
 -1,
 -53016,
 820428428,
 64581,
 -1,
 820481301,
 64718,
 820654321,
 820015623,
 -1,
 820719854,
 820633458,
 -1,
 -53012,
 820700389,
 64953,
 -53011,
 820741033,
 64911,
 -1,
 820801429,
 64910,
 821035007,
 820666751,
 -1,
 -53008,
 820952716,
 64583,
 -1,
 821005589,
 64720,
 821178617,
 820599075,
 -1,
 821244150,
 821157746,
 -1,
 -53004,
 821224677,
 64907,
 -53003,
 821265321,
 64906,
 -1,
 821325717,
 64905,
 821559295,
 821191039,
 -1,
 -53000,
 821477004,
 64582,
 -1,
 821529877,
 64719,
 821702911,
 821134220,
 -1,
 821768445,
 821649791,
 -1,
 -52996,
 821739148,
 64584,
 -1,
 821792021,
 64721,
 -52994,
 821748020,
 64945,
 -1,
 821907513,
 64649,
 822096130,
 821631670,
 -1,
 -52991,
 822050980,
 64585,
 -1,
 822104121,
 64648,
 -1,
 822076660,
 64586,
 -1,
 819958630,
 65012,
 822423847,
 819865206,
 -1,
 822489382,
 822363368,
 -1,
 822554895,
 822433931,
 -1,
 822620428,
 822483194,
 -1,
 822685963,
 822567295,
 -1,
 -52982,
 822656652,
 64518,
 -1,
 822709525,
 64669,
 -1,
 822665524,
 64962,
 823001087,
 822559956,
 -1,
 -52978,
 822903660,
 64738,
 -1,
 822962533,
 64672,
 823144725,
 822510476,
 -1,
 823210259,
 823091583,
 -1,
 -52974,
 823180940,
 64520,
 -1,
 823233813,
 64671,
 -52972,
 823165804,
 64737,
 -1,
 823349305,
 64620,
 823537946,
 823095815,
 -1,
 823603481,
 823484799,
 -1,
 -52968,
 823574156,
 64519,
 -1,
 823627029,
 64670,
 -1,
 823583028,
 64926,
 823865629,
 823518422,
 -1,
 -52964,
 823815500,
 64522,
 -1,
 823873593,
 64623,
 824062240,
 823816078,
 -1,
 -52961,
 824032908,
 64517,
 -1,
 824085781,
 64668,
 824258851,
 823990983,
 -1,
 -52958,
 824208716,
 64521,
 -1,
 824266809,
 64622,
 -52956,
 824239947,
 64619,
 -52955,
 824421553,
 64618,
 -1,
 824479166,
 64621,
 -1,
 822439215,
 65021,
 824717643,
 822351220,
 -1,
 824783168,
 824666036,
 -1,
 824848691,
 824738700,
 -1,
 824914224,
 824827762,
 -1,
 824979758,
 824869772,
 -1,
 -52947,
 824928613,
 64887,
 -1,
 824987705,
 64886,
 -52945,
 824960229,
 64950,
 -1,
 825105109,
 64888,
 825360383,
 824861055,
 -1,
 -52942,
 825278092,
 64554,
 -1,
 825330965,
 64699,
 825504058,
 824799112,
 -1,
 825569591,
 825483375,
 -1,
 -52938,
 825518437,
 64964,
 -1,
 825577529,
 64885,
 825819135,
 825516415,
 -1,
 -52935,
 825736844,
 64553,
 -1,
 825789717,
 64698,
 825962813,
 825484502,
 -1,
 -52932,
 825912652,
 64760,
 -1,
 825970745,
 64788,
 826212351,
 825891527,
 -1,
 -52929,
 826109260,
 64759,
 -1,
 826167353,
 64787,
 826356042,
 824734552,
 -1,
 826421576,
 826295173,
 -1,
 826487109,
 826400756,
 -1,
 -52924,
 826436940,
 64829,
 -1,
 826495033,
 64828,
 826736639,
 826441914,
 -1,
 -52921,
 826633548,
 64605,
 -1,
 826691641,
 64656,
 -52919,
 826373271,
 65010,
 -1,
 826811994,
 65015,
 -1,
 826306981,
 65011,
 827076973,
 824662155,
 -1,
 827142495,
 827005187,
 -1,
 827208020,
 827097996,
 -1,
 827273553,
 827187058,
 -1,
 -52912,
 827253989,
 64858,
 -1,
 827267797,
 64859,
 827523071,
 827220351,
 -1,
 -52909,
 827440780,
 64536,
 -1,
 827493653,
 64682,
 827666777,
 827158408,
 -1,
 827732312,
 827613567,
 -1,
 -52905,
 827702924,
 64535,
 -1,
 827755797,
 64681,
 -1,
 827711796,
 64959,
 827994460,
 827647190,
 -1,
 -52901,
 827944268,
 64768,
 -1,
 828002361,
 64796,
 828243967,
 827923143,
 -1,
 -52898,
 828140876,
 64767,
 -1,
 828198969,
 64795,
 828440575,
 827081960,
 -1,
 828453223,
 828343180,
 -1,
 828518756,
 828432242,
 -1,
 -52893,
 828474281,
 64916,
 -1,
 828534677,
 64915,
 828768255,
 828465535,
 -1,
 -52890,
 828685964,
 64594,
 -1,
 828738837,
 64728,
 828911978,
 828403598,
 -1,
 -52887,
 828882572,
 64593,
 -1,
 828935445,
 64727,
 -52885,
 828892404,
 64596,
 -52884,
 829080012,
 64729,
 -1,
 829102829,
 64595,
 829305227,
 827012769,
 -1,
 829370741,
 829256199,
 -1,
 829436274,
 829349999,
 -1,
 -52879,
 829385061,
 64880,
 -1,
 829444153,
 64879,
 829685759,
 829383039,
 -1,
 -52876,
 829603468,
 64548,
 -1,
 829656341,
 64694,
 829829500,
 829315363,
 -1,
 829895033,
 829808498,
 -1,
 -52872,
 829875429,
 64939,
 -1,
 829889237,
 64878,
 830144511,
 829841791,
 -1,
 -52869,
 830062220,
 64547,
 -1,
 830115093,
 64693,
 830288255,
 829809878,
 -1,
 -52866,
 830238028,
 64776,
 -1,
 830296121,
 64804,
 830484866,
 830254252,
 -1,
 -52863,
 830434636,
 64784,
 -1,
 830492729,
 64812,
 830681477,
 830440354,
 -1,
 -52860,
 830652044,
 64549,
 -1,
 830704917,
 64695,
 830878088,
 830631822,
 -1,
 -52857,
 830848652,
 64546,
 -1,
 830901525,
 64692,
 831127551,
 830806727,
 -1,
 -52854,
 831024460,
 64775,
 -1,
 831082553,
 64803,
 831271333,
 829255465,
 -1,
 831336868,
 831210306,
 -1,
 831402391,
 831292300,
 -1,
 831467924,
 831381362,
 -1,
 831533458,
 831412515,
 -1,
 -52847,
 831482213,
 64857,
 -1,
 831541305,
 64856,
 -52845,
 831513829,
 64933,
 -1,
 831658709,
 64935,
 831913983,
 831414655,
 -1,
 -52842,
 831831692,
 64534,
 -1,
 831884565,
 64680,
 832057758,
 831346979,
 -1,
 832123291,
 832036722,
 -1,
 -52838,
 832103653,
 64958,
 -1,
 832117461,
 64934,
 832372735,
 832070015,
 -1,
 -52835,
 832290444,
 64533,
 -1,
 832343317,
 64679,
 832516513,
 832038102,
 -1,
 -52832,
 832466252,
 64770,
 -1,
 832524345,
 64798,
 832765951,
 832445127,
 -1,
 -52829,
 832662860,
 64769,
 -1,
 832720953,
 64797,
 -1,
 831265750,
 65019,
 832975294,
 831213426,
 -1,
 833040813,
 832926215,
 -1,
 833106346,
 833020015,
 -1,
 -52823,
 833055077,
 64893,
 -1,
 833114169,
 64892,
 833355775,
 833053055,
 -1,
 -52820,
 833273484,
 64559,
 -1,
 833326357,
 64704,
 833499570,
 832996236,
 -1,
 833565105,
 833446271,
 -1,
 -52816,
 833535628,
 64560,
 -1,
 833588501,
 64705,
 -1,
 833544500,
 64961,
 833827253,
 833479894,
 -1,
 -52812,
 833776972,
 64562,
 -1,
 833835065,
 64637,
 834023864,
 833777550,
 -1,
 -52809,
 833994380,
 64557,
 -1,
 834047253,
 64702,
 834220475,
 833968424,
 -1,
 -52806,
 834190988,
 64558,
 -1,
 834243861,
 64703,
 834469887,
 834149063,
 -1,
 -52803,
 834366796,
 64561,
 -1,
 834424889,
 64636,
 834613716,
 832939850,
 -1,
 834679251,
 834555561,
 -1,
 834744778,
 834634636,
 -1,
 834810311,
 834723698,
 -1,
 834875845,
 834754851,
 -1,
 -52796,
 834824549,
 64948,
 -1,
 834883641,
 64894,
 -52794,
 834856165,
 64946,
 -1,
 835027858,
 64895,
 835256319,
 834756991,
 -1,
 -52791,
 835174028,
 64564,
 -1,
 835226901,
 64707,
 835400141,
 834725078,
 -1,
 -52788,
 835349836,
 64566,
 -1,
 835407929,
 64639,
 835596752,
 835344680,
 -1,
 -52785,
 835567244,
 64563,
 -1,
 835620117,
 64706,
 835846143,
 835525319,
 -1,
 -52782,
 835743052,
 64565,
 -1,
 835801145,
 64638,
 -1,
 834630585,
 65009,
 836055526,
 834557122,
 -1,
 836121053,
 836010892,
 -1,
 836186586,
 836099954,
 -1,
 -52776,
 836166885,
 64890,
 -52775,
 836207506,
 64889,
 -1,
 836246229,
 64891,
 836501503,
 836133247,
 -1,
 -52772,
 836419212,
 64556,
 -1,
 836472085,
 64701,
 836645344,
 836101334,
 -1,
 -52769,
 836595020,
 64762,
 -1,
 836653113,
 64790,
 836841955,
 836595598,
 -1,
 -52766,
 836812428,
 64555,
 -1,
 836865301,
 64700,
 837091327,
 836770503,
 -1,
 -52763,
 836988236,
 64761,
 -1,
 837046329,
 64789,
 837235179,
 836036403,
 -1,
 837300714,
 837181823,
 -1,
 -52759,
 837271180,
 64552,
 -1,
 837324053,
 64697,
 -1,
 837256044,
 64827,
 837562864,
 837210201,
 -1,
 837628399,
 837509503,
 -1,
 -52754,
 837598860,
 64505,
 -1,
 837651733,
 64507,
 -1,
 837570617,
 64506,
 837890547,
 837527892,
 -1,
 -52750,
 837829873,
 64604,
 -1,
 837886927,
 65014,
 -1,
 837869006,
 65016,
 838205439,
 787237939,
 -1,
 838218302,
 838124244,
 -1,
 838283789,
 838157521,
 1578,
 838349318,
 838205440,
 -1,
 838414847,
 838303717,
 -1,
 838480382,
 838344982,
 1577,
 838598655,
 838402048,
 -1,
 -52740,
 838495564,
 65171,
 -52739,
 838555175,
 1731,
 -1,
 838619193,
 65172,
 -1,
 838419208,
 65176,
 838873602,
 838393714,
 -1,
 -52735,
 838846307,
 1661,
 -1,
 838906277,
 1660,
 839070213,
 838820223,
 -1,
 -52732,
 839040652,
 65173,
 -1,
 839093525,
 65175,
 -1,
 839012409,
 65174,
 839385087,
 838288593,
 1663,
 839450623,
 839254016,
 -1,
 839463435,
 839344511,
 -1,
 -52726,
 839433868,
 64354,
 -1,
 839486741,
 64356,
 -52724,
 839418732,
 64357,
 -1,
 839602233,
 64355,
 839791132,
 838217612,
 1670,
 839856661,
 839730385,
 1671,
 839974911,
 839778304,
 -1,
 839987731,
 839868799,
 -1,
 -52718,
 839958156,
 64382,
 -1,
 840011029,
 64384,
 -52716,
 839943020,
 64385,
 -1,
 840126521,
 64383,
 840368127,
 839778304,
 -1,
 840380953,
 840262015,
 -1,
 -52712,
 840351372,
 64378,
 -1,
 840404245,
 64380,
 -52710,
 840359878,
 1727,
 -52709,
 840532844,
 64381,
 -1,
 840585273,
 64379,
 840774186,
 839763195,
 1657,
 840839716,
 840713425,
 1658,
 840957951,
 840761344,
 -1,
 840970786,
 840851839,
 -1,
 -52703,
 840941196,
 64350,
 -1,
 840994069,
 64352,
 -52701,
 840926060,
 64353,
 -1,
 841109561,
 64351,
 841351167,
 840761344,
 -1,
 841364008,
 841245055,
 -1,
 -52697,
 841334412,
 64358,
 -1,
 841387285,
 64360,
 -52695,
 841319276,
 64361,
 -1,
 841502777,
 64359,
 841691702,
 840718475,
 -1,
 841757234,
 841630929,
 1579,
 841875455,
 841678848,
 -1,
 841888304,
 841769343,
 -1,
 -52689,
 841858700,
 65177,
 -1,
 841911573,
 65179,
 -52687,
 841843564,
 65180,
 -1,
 842027065,
 65178,
 842268671,
 841685492,
 1584,
 842334207,
 842137600,
 -1,
 -52683,
 842231116,
 65195,
 -1,
 842289209,
 65196,
 842530815,
 841619703,
 1591,
 842596351,
 842399744,
 -1,
 842609211,
 842490239,
 -1,
 -52678,
 842579596,
 65217,
 -1,
 842632469,
 65219,
 -52676,
 842588395,
 1695,
 -52675,
 842761068,
 65220,
 -1,
 842813497,
 65218,
 843002489,
 838162571,
 -1,
 843067995,
 842941649,
 1607,
 843186175,
 842989568,
 -1,
 843199049,
 843077159,
 1729,
 843317247,
 843120640,
 -1,
 843330118,
 843211135,
 -1,
 -52667,
 843300492,
 64422,
 -1,
 843353365,
 64424,
 -52665,
 843309080,
 1730,
 -52664,
 843481964,
 64425,
 -1,
 843534393,
 64423,
 843723344,
 843135691,
 1726,
 843841535,
 843644928,
 -1,
 843854414,
 843735423,
 -1,
 -52659,
 843824780,
 64426,
 -1,
 843877653,
 64428,
 -52657,
 843809644,
 64429,
 -1,
 843993145,
 64427,
 844182102,
 843702130,
 -1,
 844247637,
 844162267,
 1728,
 844365823,
 844169216,
 -1,
 -52652,
 844262732,
 64420,
 -1,
 844320825,
 64421,
 -1,
 844196749,
 1791,
 844575321,
 844128639,
 -1,
 -52648,
 844545676,
 65257,
 -1,
 844598549,
 65259,
 -52646,
 844530540,
 65260,
 -1,
 844714041,
 65258,
 844903028,
 842995060,
 -1,
 844968562,
 844847243,
 1581,
 845086719,
 844890112,
 -1,
 845099629,
 845012850,
 -1,
 845165158,
 845071060,
 -1,
 845230691,
 845144479,
 -1,
 -52638,
 845208130,
 1666,
 -1,
 845223541,
 1879,
 845479935,
 845176962,
 -1,
 -52635,
 845391135,
 1880,
 -1,
 845420149,
 1669,
 845623915,
 845135251,
 -1,
 845689450,
 845550964,
 -1,
 -52631,
 845646546,
 1903,
 -1,
 845687625,
 1906,
 -1,
 845621331,
 1902,
 -52628,
 845568525,
 1665,
 -1,
 845893098,
 1916,
 846082672,
 845046143,
 -1,
 -52625,
 846053004,
 65185,
 -1,
 846105877,
 65187,
 -52623,
 846037868,
 65188,
 -1,
 846221369,
 65186,
 846462975,
 844925131,
 1569,
 -1,
 846333131,
 65152,
 846594047,
 844850393,
 1652,
 846659583,
 846462976,
 -1,
 -52617,
 846587090,
 1656,
 -52616,
 846650927,
 1654,
 -1,
 846666417,
 1653,
 846869166,
 842937888,
 -1,
 846934678,
 846796148,
 -1,
 847000202,
 846885720,
 1583,
 847118335,
 846921728,
 -1,
 847131272,
 847044466,
 -1,
 847196801,
 847102676,
 -1,
 -52608,
 847176218,
 1881,
 -1,
 847208605,
 1679,
 847393412,
 847145686,
 -1,
 -52605,
 847370158,
 1774,
 -1,
 847429196,
 1882,
 847590022,
 847330107,
 1674,
 -1,
 847511909,
 1675,
 -52601,
 847557029,
 1673,
 -1,
 847663623,
 1680,
 -52599,
 847080780,
 65193,
 -1,
 847794233,
 65194,
 847983250,
 846935584,
 1590,
 848101375,
 847904768,
 -1,
 848114319,
 847995263,
 -1,
 -52594,
 848084620,
 65213,
 -1,
 848137493,
 65215,
 -52592,
 848093141,
 1787,
 -52591,
 848266092,
 65216,
 -1,
 848318521,
 65214,
 848560127,
 847927673,
 1676,
 848625663,
 848429056,
 -1,
 -52587,
 848522572,
 64388,
 -1,
 848580665,
 64389,
 848769695,
 846870155,
 -1,
 848835227,
 848720728,
 1672,
 848953343,
 848756736,
 -1,
 -52582,
 848850252,
 64392,
 -1,
 848908345,
 64393,
 849149951,
 848779641,
 1677,
 849215487,
 849018880,
 -1,
 -52578,
 849112396,
 64386,
 -1,
 849170489,
 64387,
 849359526,
 848749778,
 1668,
 849477631,
 849281024,
 -1,
 849490596,
 849371519,
 -1,
 -52573,
 849460876,
 64370,
 -1,
 849513749,
 64372,
 -52571,
 849445740,
 64373,
 -1,
 849629241,
 64371,
 849818282,
 849334450,
 1678,
 849936383,
 849739776,
 -1,
 -52567,
 849833292,
 64390,
 -1,
 849891385,
 64391,
 850132991,
 849779423,
 -1,
 -52564,
 850044760,
 1647,
 -52563,
 850087790,
 1697,
 -1,
 850143289,
 1646,
 850342623,
 846796148,
 -1,
 850408144,
 850294396,
 1575,
 850526207,
 850329600,
 -1,
 850539210,
 850451720,
 -1,
 850604742,
 850488788,
 -1,
 850670268,
 850549254,
 -1,
 850735800,
 850602067,
 1573,
 850853887,
 850657280,
 -1,
 -52553,
 850750796,
 65159,
 -1,
 850808889,
 65160,
 851050495,
 850663029,
 1571,
 851116031,
 850919424,
 -1,
 -52549,
 851012940,
 65155,
 -1,
 851071033,
 65156,
 851260096,
 850624584,
 1570,
 851378175,
 851181568,
 -1,
 -52545,
 851275084,
 65153,
 -1,
 851333177,
 65154,
 851522243,
 851238407,
 -1,
 -52542,
 851454035,
 1651,
 -1,
 851514997,
 1650,
 851771391,
 851463697,
 -1,
 -52539,
 851698070,
 1907,
 -1,
 851730529,
 1908,
 851967999,
 850535370,
 1649,
 852033535,
 851836928,
 -1,
 -52535,
 851930444,
 64336,
 -1,
 851988537,
 64337,
 852177614,
 850493587,
 1609,
 852295679,
 852099072,
 -1,
 -52531,
 852192588,
 65263,
 -1,
 852250681,
 65264,
 -52529,
 852127052,
 65165,
 -1,
 852381753,
 65166,
 852570846,
 850356016,
 1593,
 852688895,
 852492288,
 -1,
 852701913,
 852615396,
 -1,
 852767446,
 852681119,
 -1,
 -52523,
 852745019,
 1887,
 -1,
 852760181,
 1885,
 853016575,
 852713602,
 -1,
 -52520,
 852927735,
 1886,
 -1,
 852956789,
 1696,
 853160668,
 852648319,
 -1,
 -52517,
 853130892,
 65225,
 -1,
 853183765,
 65227,
 -52515,
 853115756,
 65228,
 -1,
 853299257,
 65226,
 -1,
 852508807,
 1749,
 853553932,
 850292872,
 -1,
 853619439,
 853493016,
 1705,
 853737471,
 853540864,
 -1,
 853750506,
 853663602,
 -1,
 853816041,
 853721812,
 -1,
 853881576,
 853762178,
 -1,
 -52506,
 853845279,
 1892,
 -52505,
 853878867,
 1596,
 -1,
 853939829,
 1891,
 -1,
 853860776,
 1595,
 -1,
 853752625,
 1890,
 854274797,
 853696895,
 -1,
 -52500,
 854245004,
 64398,
 -1,
 854297877,
 64400,
 -52498,
 854229868,
 64401,
 -1,
 854413369,
 64399,
 854602492,
 853547143,
 1603,
 854720511,
 854523904,
 -1,
 854733559,
 854646642,
 -1,
 854799093,
 854704852,
 -1,
 -52492,
 854778280,
 1919,
 -1,
 854810807,
 1710,
 -52490,
 854765989,
 1707,
 -1,
 854932273,
 1708,
 855126778,
 854679935,
 -1,
 -52487,
 855096972,
 65241,
 -1,
 855149845,
 65243,
 -52485,
 855081836,
 65244,
 -1,
 855265337,
 65242,
 855454469,
 854551691,
 -1,
 855520001,
 855434967,
 1737,
 855638015,
 855441408,
 -1,
 -52480,
 855534924,
 64482,
 -1,
 855593017,
 64483,
 855834623,
 855478997,
 1733,
 855900159,
 855703552,
 -1,
 -52476,
 855797068,
 64480,
 -1,
 855855161,
 64481,
 856096767,
 855398687,
 1582,
 856162303,
 855965696,
 -1,
 856175370,
 856056191,
 -1,
 -52471,
 856145548,
 65189,
 -1,
 856198421,
 65191,
 -52469,
 856130412,
 65192,
 -1,
 856313913,
 65190,
 856503094,
 853510367,
 -1,
 856568609,
 856463017,
 1606,
 856686591,
 856489984,
 -1,
 856699672,
 856612722,
 -1,
 856765203,
 856670932,
 -1,
 -52462,
 856744374,
 1895,
 -1,
 856776845,
 1725,
 856961814,
 856735116,
 -1,
 -52459,
 856938414,
 1897,
 -1,
 856998767,
 1896,
 -52457,
 856928677,
 1724,
 -1,
 857094971,
 1721,
 857289500,
 856642917,
 1722,
 857407487,
 857210880,
 -1,
 -52453,
 857304396,
 64414,
 -1,
 857362489,
 64415,
 857551647,
 857235839,
 -1,
 -52450,
 857521804,
 65253,
 -1,
 857574677,
 65255,
 -52448,
 857506668,
 65256,
 -1,
 857690169,
 65254,
 857879343,
 856511203,
 1709,
 857944873,
 857838300,
 1713,
 858062847,
 857866240,
 -1,
 858075943,
 857956735,
 -1,
 -52442,
 858046092,
 64410,
 -1,
 858098965,
 64412,
 -52440,
 858030956,
 64413,
 -1,
 858214457,
 64411,
 858456063,
 857866240,
 -1,
 858469165,
 858349951,
 -1,
 -52436,
 858439308,
 64467,
 -1,
 858492181,
 64469,
 -52434,
 858424172,
 64470,
 -1,
 858607673,
 64468,
 858849279,
 857859282,
 1667,
 858914815,
 858718208,
 -1,
 858927924,
 858808703,
 -1,
 -52429,
 858898060,
 64374,
 -1,
 858950933,
 64376,
 -52427,
 858882924,
 64377,
 -1,
 859066425,
 64375,
 859255644,
 856471327,
 -1,
 859321160,
 859194188,
 1587,
 859439103,
 859242496,
 -1,
 859452227,
 859365234,
 -1,
 859517758,
 859423444,
 -1,
 859583293,
 859463863,
 1691,
 -1,
 859505041,
 1692,
 -1,
 859562497,
 1901,
 -52417,
 859487660,
 1904,
 -52416,
 859728781,
 1918,
 -52415,
 859787783,
 1884,
 -52414,
 859852227,
 1917,
 -1,
 859913029,
 1690,
 860107590,
 859398527,
 -1,
 -52411,
 860077708,
 65201,
 -1,
 860130581,
 65203,
 -52409,
 860062572,
 65204,
 -1,
 860246073,
 65202,
 860435282,
 859248598,
 1589,
 860553215,
 860356608,
 -1,
 860566349,
 860479716,
 -1,
 -52404,
 860545462,
 1693,
 -1,
 860577933,
 1694,
 860762960,
 860512639,
 -1,
 -52401,
 860733068,
 65209,
 -1,
 860785941,
 65211,
 -52399,
 860717932,
 65212,
 -1,
 860901433,
 65210,
 861090650,
 860380147,
 1588,
 861208575,
 861011968,
 -1,
 861221719,
 861102463,
 -1,
 -52394,
 861191820,
 65205,
 -1,
 861244693,
 65207,
 -52392,
 861200341,
 1786,
 -52391,
 861373292,
 65208,
 -1,
 861425721,
 65206,
 -52389,
 861068773,
 1706,
 -1,
 861590576,
 1648,
 861746048,
 859235310,
 -1,
 861811580,
 861684945,
 1610,
 861929471,
 861732864,
 -1,
 861942635,
 861855602,
 -1,
 862008167,
 861886989,
 1574,
 862126079,
 861929472,
 -1,
 862139237,
 862019967,
 -1,
 -52380,
 862109324,
 65161,
 -1,
 862162197,
 65163,
 -52378,
 862094188,
 65164,
 -1,
 862277689,
 65162,
 862466922,
 861979348,
 -1,
 -52375,
 862412983,
 1745,
 -1,
 862460222,
 1741,
 -1,
 862436918,
 1742,
 862729079,
 861874094,
 1746,
 862846975,
 862650368,
 -1,
 862860149,
 862773106,
 -1,
 862925682,
 862804493,
 1747,
 863043583,
 862846976,
 -1,
 -52367,
 862940492,
 64432,
 -1,
 862998585,
 64433,
 863240191,
 862866961,
 -1,
 -52364,
 863166870,
 1914,
 -1,
 863199329,
 1915,
 -52362,
 862809420,
 64430,
 -1,
 863326265,
 64431,
 863515514,
 862675327,
 -1,
 -52359,
 863485580,
 65265,
 -1,
 863538453,
 65267,
 -52357,
 863470444,
 65268,
 -1,
 863653945,
 65266,
 863895551,
 861785674,
 1736,
 863961087,
 863764480,
 -1,
 -52353,
 863857996,
 64475,
 -1,
 863916089,
 64476,
 864105376,
 861710676,
 -1,
 864170901,
 864044241,
 1585,
 864288767,
 864092160,
 -1,
 864301971,
 864214898,
 -1,
 864367498,
 864270111,
 -1,
 864433033,
 864321822,
 -1,
 864498568,
 864409518,
 1682,
 -1,
 864420387,
 1685,
 -1,
 864428205,
 1905,
 -1,
 864406484,
 1883,
 864760717,
 864341374,
 -1,
 -52340,
 864738107,
 1899,
 -1,
 864753269,
 1687,
 864957327,
 864697147,
 1684,
 -1,
 864878778,
 1686,
 -52336,
 864924069,
 1683,
 -52335,
 865037197,
 1775,
 -52334,
 865098253,
 1900,
 -1,
 865161735,
 1689,
 -52332,
 864251212,
 65197,
 -1,
 865292345,
 65198,
 865481628,
 864128441,
 1723,
 865599487,
 865402880,
 -1,
 865612698,
 865493375,
 -1,
 -52327,
 865582732,
 64416,
 -1,
 865635605,
 64418,
 -52325,
 865567596,
 64419,
 -1,
 865751097,
 64417,
 865992703,
 865447080,
 1681,
 866058239,
 865861632,
 -1,
 -52321,
 865955148,
 64396,
 -1,
 866013241,
 64397,
 866202560,
 864036887,
 -1,
 866268089,
 866146443,
 1576,
 866333618,
 866189312,
 -1,
 866399149,
 866312050,
 -1,
 866464682,
 866370260,
 -1,
 866530217,
 866410626,
 -1,
 866595752,
 866493727,
 1874,
 -1,
 866517415,
 1875,
 -1,
 866541470,
 1872,
 -1,
 866509252,
 1876,
 -52309,
 866434614,
 1878,
 -52308,
 866806632,
 1877,
 -1,
 866859869,
 1873,
 867054512,
 866345343,
 -1,
 -52305,
 867024524,
 65167,
 -1,
 867077397,
 65169,
 -52303,
 867009388,
 65170,
 -1,
 867192889,
 65168,
 867434495,
 866272465,
 1664,
 867500031,
 867303424,
 -1,
 867513271,
 867393919,
 -1,
 -52298,
 867483276,
 64346,
 -1,
 867536149,
 64348,
 -52296,
 867468140,
 64349,
 -1,
 867651641,
 64347,
 867893247,
 866206929,
 1659,
 867958783,
 867762176,
 -1,
 867972030,
 867852671,
 -1,
 -52291,
 867942028,
 64338,
 -1,
 867994901,
 64340,
 -52289,
 867926892,
 64341,
 -1,
 868110393,
 64339,
 868299746,
 866143830,
 -1,
 868365266,
 868229811,
 1740,
 868483071,
 868286464,
 -1,
 868496333,
 868409202,
 -1,
 868561865,
 868437414,
 -1,
 868627400,
 868532948,
 -1,
 -52281,
 868606358,
 1909,
 -1,
 868638817,
 1910,
 -1,
 868569586,
 1911,
 868889548,
 868532948,
 -1,
 -52277,
 868868520,
 1598,
 -1,
 868901005,
 1599,
 -1,
 868838285,
 1597,
 869151696,
 868442495,
 -1,
 -52273,
 869121676,
 64508,
 -1,
 869174549,
 64510,
 -52271,
 869106540,
 64511,
 -1,
 869290041,
 64509,
 869531647,
 868304081,
 1601,
 869597183,
 869400576,
 -1,
 869610461,
 869523314,
 -1,
 869675994,
 869581524,
 -1,
 869741529,
 869621890,
 -1,
 -52264,
 869704991,
 1889,
 -1,
 869738579,
 1701,
 -1,
 869720502,
 1888,
 870055935,
 869612332,
 -1,
 -52260,
 869959516,
 1698,
 -1,
 870000723,
 1699,
 870200288,
 869556607,
 -1,
 -52257,
 870170252,
 65233,
 -1,
 870223125,
 65235,
 -52255,
 870155116,
 65236,
 -1,
 870338617,
 65234,
 870527998,
 868242147,
 -1,
 870593519,
 870455431,
 1711,
 870711295,
 870514688,
 -1,
 870724586,
 870637426,
 -1,
 870790121,
 870695636,
 -1,
 -52248,
 870769078,
 1714,
 -1,
 870801549,
 1716,
 -1,
 870756773,
 1712,
 871052269,
 870670719,
 -1,
 -52244,
 871022220,
 64402,
 -1,
 871075093,
 64404,
 -52242,
 871007084,
 64405,
 -1,
 871190585,
 64403,
 871379959,
 870537563,
 1594,
 871497727,
 871301120,
 -1,
 871511028,
 871391615,
 -1,
 -52237,
 871480972,
 65229,
 -1,
 871533845,
 65231,
 -52235,
 871489493,
 1788,
 -52234,
 871662444,
 65232,
 -1,
 871714873,
 65230,
 871956479,
 871354385,
 1715,
 872022015,
 871825408,
 -1,
 872035324,
 871915903,
 -1,
 -52229,
 872005260,
 64406,
 -1,
 872058133,
 64408,
 -52227,
 871990124,
 64409,
 -1,
 872173625,
 64407,
 872363021,
 870506031,
 1608,
 872480767,
 872284160,
 -1,
 872494091,
 872406898,
 -1,
 872559621,
 872438285,
 1572,
 872677375,
 872480768,
 -1,
 -52220,
 872574284,
 65157,
 -1,
 872632377,
 65158,
 872821768,
 872500753,
 -1,
 -52217,
 872800662,
 1912,
 -1,
 872833121,
 1913,
 -52215,
 872795528,
 1738,
 -52214,
 872984997,
 1732,
 -1,
 873020209,
 1743,
 -52212,
 872443212,
 65261,
 -1,
 873156665,
 65262,
 873346075,
 872325624,
 1662,
 873411605,
 873284817,
 1702,
 873529343,
 873332736,
 -1,
 873542675,
 873423231,
 -1,
 -52206,
 873512588,
 64366,
 -1,
 873565461,
 64368,
 -52204,
 873497452,
 64369,
 -1,
 873680953,
 64367,
 873922559,
 873332736,
 -1,
 873935897,
 873816447,
 -1,
 -52200,
 873905804,
 64342,
 -1,
 873958677,
 64344,
 -52198,
 873890668,
 64345,
 -1,
 874074169,
 64343,
 874263593,
 873297078,
 1604,
 874381311,
 874184704,
 -1,
 874394660,
 874307442,
 -1,
 874460193,
 874366790,
 -1,
 -52192,
 874391635,
 1720,
 -1,
 874452597,
 1719,
 -52190,
 874430006,
 1717,
 -52189,
 874593073,
 1718,
 -1,
 874653518,
 1898,
 874853415,
 874340735,
 -1,
 -52186,
 874823308,
 65245,
 -1,
 874876181,
 65247,
 -52184,
 874808172,
 65248,
 -1,
 874991673,
 65246,
 875181109,
 874243888,
 -1,
 875246641,
 875124875,
 1592,
 875364351,
 875167744,
 -1,
 875377711,
 875258239,
 -1,
 -52178,
 875347596,
 65221,
 -1,
 875400469,
 65223,
 -52176,
 875332460,
 65224,
 -1,
 875515961,
 65222,
 875757567,
 875194160,
 1586,
 875823103,
 875626496,
 -1,
 -52172,
 875720012,
 65199,
 -1,
 875778105,
 65200,
 875967552,
 875157748,
 1739,
 876033085,
 875911307,
 1700,
 876150783,
 875954176,
 -1,
 876164155,
 876044671,
 -1,
 -52166,
 876134028,
 64362,
 -1,
 876186901,
 64364,
 -52164,
 876118892,
 64365,
 -1,
 876302393,
 64363,
 876543999,
 875954176,
 -1,
 -52161,
 876440908,
 64478,
 -1,
 876499001,
 64479,
 876688460,
 875917133,
 -1,
 876753992,
 876627530,
 1580,
 876871679,
 876675072,
 -1,
 876885062,
 876765567,
 -1,
 -52155,
 876854924,
 65181,
 -1,
 876907797,
 65183,
 -52153,
 876839788,
 65184,
 -1,
 877023289,
 65182,
 877264895,
 876697739,
 1688,
 877330431,
 877133824,
 -1,
 -52149,
 877227340,
 64394,
 -1,
 877285433,
 64395,
 877474901,
 876662346,
 1735,
 877540434,
 877395968,
 -1,
 877605968,
 877518872,
 1655,
 -1,
 877528267,
 64477,
 -52143,
 877555020,
 64471,
 -1,
 877678649,
 64472,
 877920255,
 877487434,
 -1,
 -52140,
 877822828,
 64489,
 -1,
 877881701,
 64488,
 878064735,
 877438808,
 1602,
 878182399,
 877985792,
 -1,
 878195802,
 878108530,
 -1,
 -52135,
 878167890,
 1704,
 -1,
 878197553,
 1703,
 878392413,
 878141823,
 -1,
 -52132,
 878362252,
 65237,
 -1,
 878415125,
 65239,
 -52130,
 878347116,
 65240,
 -1,
 878530617,
 65238,
 878720105,
 878019463,
 1605,
 878837759,
 878641152,
 -1,
 878851172,
 878763964,
 -1,
 -52125,
 878782547,
 1894,
 -1,
 878843509,
 1893,
 879047783,
 878797183,
 -1,
 -52122,
 879017612,
 65249,
 -1,
 879070485,
 65251,
 -52120,
 879002476,
 65252,
 -1,
 879185977,
 65250,
 879375472,
 878657671,
 1744,
 879493119,
 879296512,
 -1,
 879506542,
 879387007,
 -1,
 -52115,
 879476364,
 64484,
 -1,
 879529237,
 64486,
 -52113,
 879461228,
 64487,
 -1,
 879644729,
 64485,
 879886335,
 879334101,
 1734,
 879951871,
 879755264,
 -1,
 -52109,
 879848780,
 64473,
 -1,
 879906873,
 64474,
 880096432,
 787199775,
 -1,
 880161941,
 880050462,
 -1,
 880227469,
 880106735,
 -1,
 880292989,
 880178008,
 -1,
 880358524,
 880239775,
 -1,
 -52102,
 880326568,
 1750,
 -52101,
 880387932,
 1751,
 -1,
 880417544,
 1558,
 -1,
 880286826,
 1753,
 880686210,
 880246757,
 -1,
 880751745,
 880624444,
 -1,
 -52096,
 880721548,
 1762,
 -1,
 880774421,
 1752,
 -1,
 880678892,
 1764,
 881013893,
 880657108,
 -1,
 -52092,
 880959608,
 1755,
 -1,
 881006839,
 1557,
 -52090,
 880994118,
 1559,
 -52089,
 881190098,
 1767,
 -52088,
 881251536,
 1760,
 -52087,
 881309944,
 1756,
 -52086,
 881374465,
 1759,
 -52085,
 881429945,
 1768,
 -52084,
 881487747,
 1754,
 -1,
 881540007,
 1761,
 881734800,
 880180771,
 -1,
 -52081,
 881703160,
 1763,
 -1,
 881755015,
 1773,
 -52079,
 881714386,
 1766,
 -52078,
 881909295,
 1765,
 -52077,
 881946947,
 1562,
 -52076,
 882003729,
 1560,
 -1,
 882063076,
 1561,
 882259108,
 880108937,
 -1,
 882324638,
 882226975,
 -1,
 882390171,
 882251124,
 -1,
 -52071,
 882346348,
 1537,
 -52070,
 882408526,
 1552,
 -1,
 882462725,
 1539,
 882704383,
 882337814,
 -1,
 -52067,
 882615647,
 1790,
 -1,
 882646292,
 1789,
 882848929,
 882289071,
 -1,
 -52064,
 882794062,
 1554,
 -1,
 882849934,
 1555,
 -52062,
 882820001,
 1556,
 -52061,
 883000801,
 1551,
 -1,
 883038859,
 1553,
 883242154,
 882232906,
 -1,
 883307689,
 883192598,
 1618,
 883425279,
 883228672,
 -1,
 -52056,
 883327852,
 65151,
 -1,
 883387724,
 65150,
 -1,
 883239937,
 1622,
 883635374,
 883185869,
 1617,
 883752959,
 883556352,
 -1,
 -52051,
 883655532,
 65149,
 -1,
 883715404,
 65148,
 -52049,
 883606577,
 1758,
 -1,
 883836544,
 1563,
 884028603,
 880037462,
 -1,
 884094136,
 883958983,
 1614,
 884159670,
 884015104,
 -1,
 -52044,
 884138241,
 1630,
 -52043,
 884179820,
 65143,
 -1,
 884239692,
 65142,
 884473855,
 884130816,
 1611,
 -1,
 884344011,
 65136,
 -52039,
 884068634,
 1748,
 -52038,
 884512473,
 1538,
 -1,
 884567718,
 1645,
 884749509,
 883963424,
 -1,
 884815044,
 884675956,
 -1,
 884880579,
 884770295,
 1615,
 884946112,
 884851712,
 1612,
 -1,
 884868299,
 65138,
 885129215,
 884867072,
 -1,
 -52030,
 885031788,
 65145,
 -1,
 885091660,
 65144,
 -1,
 884851838,
 1549,
 -1,
 884752962,
 1643,
 885404876,
 884720340,
 -1,
 885470410,
 885331316,
 -1,
 885535945,
 885443932,
 1600,
 -1,
 885460306,
 65137,
 -1,
 885482976,
 65139,
 -52021,
 885436981,
 1566,
 -1,
 885678141,
 1644,
 885863634,
 885354819,
 1616,
 885929167,
 885834752,
 1613,
 -1,
 885851339,
 65140,
 886112255,
 885850112,
 -1,
 -52015,
 886014828,
 65147,
 -1,
 886074700,
 65146,
 886256854,
 885841078,
 -1,
 -52012,
 886226494,
 1626,
 -52011,
 886270801,
 1627,
 -1,
 886324027,
 1628,
 886519002,
 886221140,
 -1,
 -52008,
 886479820,
 1772,
 -52007,
 886525179,
 1629,
 -1,
 886580792,
 1544,
 886781150,
 886480873,
 -1,
 -52004,
 886739695,
 1550,
 -52003,
 886797313,
 1769,
 -1,
 886851990,
 1642,
 887043299,
 886718599,
 -1,
 887108834,
 886998937,
 -1,
 -51999,
 887062088,
 1770,
 -1,
 887119131,
 1771,
 -1,
 887065188,
 1757,
 887370982,
 886997042,
 -1,
 -51995,
 887337792,
 1624,
 -1,
 887371583,
 1619,
 887567593,
 887314950,
 -1,
 -51992,
 887498835,
 1621,
 -1,
 887559797,
 1620,
 -51990,
 887547992,
 1625,
 -51989,
 887728318,
 1567,
 -51988,
 887787591,
 1536,
 -51987,
 887843588,
 1623,
 -1,
 887894543,
 1548,
 888143871,
 787091504,
 -1,
 888157437,
 888027544,
 -1,
 888222963,
 888128212,
 -1,
 -51982,
 888201615,
 1634,
 -1,
 888234070,
 1635,
 888419574,
 888190751,
 -1,
 -51979,
 888368878,
 1638,
 -1,
 888425602,
 1639,
 888616185,
 888360534,
 -1,
 -51976,
 888577008,
 1636,
 -1,
 888630903,
 1637,
 -51974,
 888596373,
 1632,
 -51973,
 888772031,
 1633,
 -51972,
 888835260,
 1641,
 -1,
 888882487,
 1640,
 889074944,
 888119892,
 -1,
 -51969,
 889046319,
 1546,
 -1,
 889095493,
 1545,
 -51967,
 889016855,
 1543,
 -1,
 889206111,
 1542,
 889402750,
 787055620,
 -1,
 889468223,
 889372162,
 -1,
 889533751,
 889408563,
 -1,
 889599243,
 889466078,
 -1,
 889664777,
 889542795,
 -1,
 -51960,
 889603281,
 1395,
 -1,
 889656692,
 1401,
 -51958,
 889622927,
 1409,
 -1,
 889787764,
 1390,
 889992463,
 889536647,
 -1,
 -51955,
 889963220,
 1384,
 -51954,
 890001547,
 1383,
 -1,
 890056482,
 1381,
 890254610,
 889972510,
 -1,
 -51951,
 890198824,
 1386,
 -1,
 890246516,
 1382,
 890451220,
 890234224,
 1397,
 -1,
 890429774,
 1410,
 890582295,
 890427310,
 -1,
 -51946,
 890540431,
 1400,
 -1,
 890588509,
 1406,
 890778906,
 890553044,
 -1,
 -51943,
 890737039,
 1385,
 -1,
 890793702,
 1407,
 890975517,
 890746655,
 -1,
 -51940,
 890919081,
 1399,
 -1,
 890979537,
 1405,
 891172128,
 890939732,
 -1,
 -51937,
 891110609,
 1408,
 -1,
 891164020,
 1404,
 891368739,
 891133929,
 -1,
 -51934,
 891317994,
 1411,
 -1,
 891372753,
 1402,
 891565350,
 891318712,
 -1,
 -51931,
 891521247,
 1391,
 -1,
 891574411,
 1412,
 891761961,
 891514665,
 -1,
 -51928,
 891706374,
 1403,
 -1,
 891753844,
 1393,
 891958572,
 891704035,
 -1,
 -51925,
 891905631,
 1379,
 -1,
 891967689,
 1394,
 -51923,
 891937642,
 1389,
 -51922,
 892113763,
 1413,
 -51921,
 892178117,
 1398,
 -51920,
 892240891,
 1396,
 -51919,
 892304370,
 1388,
 -51918,
 892365092,
 1387,
 -51917,
 892427871,
 1392,
 -51916,
 892489582,
 1414,
 -51915,
 892548747,
 1380,
 -51914,
 892610672,
 1378,
 -1,
 892675670,
 1377,
 892927999,
 889480351,
 -1,
 892941629,
 892830719,
 -1,
 -51910,
 892920682,
 64279,
 -51909,
 892964549,
 64275,
 -51908,
 893020452,
 64277,
 -1,
 893076021,
 64276,
 -51906,
 892918621,
 64278,
 -1,
 893207097,
 1415,
 893400436,
 889400542,
 -1,
 893465971,
 893329382,
 -1,
 893531463,
 893398238,
 -1,
 893596997,
 893474955,
 -1,
 -51900,
 893535441,
 1347,
 -1,
 893588852,
 1353,
 -51898,
 893555087,
 1361,
 -1,
 893719924,
 1342,
 893924683,
 893468807,
 -1,
 -51895,
 893895380,
 1336,
 -51894,
 893933707,
 1335,
 -1,
 893988642,
 1333,
 894186830,
 893904670,
 -1,
 -51891,
 894130984,
 1338,
 -1,
 894178676,
 1334,
 894383440,
 894166384,
 1349,
 -1,
 894361934,
 1362,
 894514515,
 894359470,
 -1,
 -51886,
 894472591,
 1352,
 -1,
 894520669,
 1358,
 894711126,
 894485204,
 -1,
 -51883,
 894669199,
 1337,
 -1,
 894725862,
 1359,
 894907737,
 894678815,
 -1,
 -51880,
 894851241,
 1351,
 -1,
 894911697,
 1357,
 895104348,
 894871892,
 -1,
 -51877,
 895042769,
 1360,
 -1,
 895096180,
 1356,
 895300959,
 895066089,
 -1,
 -51874,
 895250154,
 1363,
 -1,
 895304913,
 1354,
 895497570,
 895250872,
 -1,
 -51871,
 895453407,
 1343,
 -1,
 895506571,
 1364,
 895694181,
 895446825,
 -1,
 -51868,
 895638534,
 1355,
 -1,
 895686004,
 1345,
 895890792,
 895636195,
 -1,
 -51865,
 895837791,
 1331,
 -1,
 895899849,
 1346,
 -51863,
 895869802,
 1341,
 -51862,
 896045923,
 1365,
 -51861,
 896110277,
 1350,
 -51860,
 896173051,
 1348,
 -51859,
 896236530,
 1340,
 -51858,
 896297252,
 1339,
 -51857,
 896360031,
 1344,
 -51856,
 896421742,
 1366,
 -51855,
 896480907,
 1332,
 -51854,
 896542832,
 1330,
 -1,
 896607830,
 1329,
 -1,
 893424895,
 1373,
 896873847,
 893337735,
 -1,
 -51850,
 896852806,
 1372,
 -1,
 896894842,
 1371,
 897070458,
 896800116,
 -1,
 -51847,
 897033584,
 1370,
 -1,
 897066997,
 1375,
 -51845,
 897034430,
 1374,
 -51844,
 897222271,
 1369,
 -51843,
 897278312,
 1418,
 -1,
 897340098,
 1417,
 897529221,
 889369875,
 -1,
 897594754,
 897495339,
 -1,
 -51839,
 897570089,
 10548,
 -1,
 897597232,
 10549,
 897843199,
 897531787,
 -1,
 -51836,
 897757332,
 10551,
 -1,
 897808447,
 10550,
 -51834,
 897475639,
 9800,
 -1,
 897920222,
 8978,
 898119156,
 786997225,
 -1,
 898184683,
 898069341,
 -1,
 898250153,
 898148289,
 -1,
 898315686,
 898176982,
 9109,
 898433023,
 898236416,
 -1,
 898446741,
 898315808,
 -1,
 898512272,
 898408363,
 -1,
 -51825,
 898489697,
 9047,
 -1,
 898499189,
 9036,
 898708883,
 898457983,
 -1,
 -51822,
 898685832,
 9017,
 -1,
 898702590,
 9018,
 898957311,
 898647486,
 9044,
 -1,
 898876181,
 9037,
 899036568,
 898421508,
 -1,
 -51817,
 899013985,
 9040,
 -1,
 899023477,
 9043,
 899233179,
 898987602,
 -1,
 -51814,
 899202978,
 9027,
 -1,
 899240624,
 9031,
 899429790,
 899165406,
 -1,
 -51811,
 899388577,
 9056,
 -1,
 899443740,
 9020,
 -51809,
 899399037,
 9025,
 -51808,
 899592351,
 9032,
 -51807,
 899655861,
 9072,
 -51806,
 899714651,
 9071,
 -51805,
 899772478,
 9019,
 -51804,
 899831543,
 9028,
 -51803,
 899893498,
 9016,
 -1,
 899950270,
 9026,
 900202495,
 898275999,
 -1,
 -51800,
 900125271,
 9048,
 -1,
 900179912,
 9054,
 900347323,
 898184736,
 -1,
 900412850,
 900308907,
 -1,
 900478385,
 900333568,
 -1,
 900543919,
 900449118,
 -1,
 -51794,
 900518487,
 9034,
 -1,
 900558910,
 9038,
 -51792,
 900512582,
 9062,
 -1,
 900673060,
 9073,
 -1,
 900455854,
 9046,
 900937146,
 900351422,
 -1,
 901002679,
 900857856,
 -1,
 -51787,
 900974588,
 9067,
 -51786,
 901038243,
 9042,
 -1,
 901068958,
 9058,
 901316607,
 900973336,
 -1,
 -51783,
 901239383,
 9049,
 -1,
 901300387,
 9035,
 -1,
 900883026,
 9050,
 901526981,
 900279518,
 -1,
 901592516,
 901475362,
 -1,
 901658048,
 901562379,
 -1,
 -51777,
 901604868,
 9021,
 -1,
 901652572,
 9055,
 -51775,
 901632599,
 9052,
 -51774,
 901804094,
 9022,
 -51773,
 901855390,
 9061,
 -1,
 901916350,
 9033,
 -1,
 901551364,
 9066,
 902182350,
 901501700,
 -1,
 902247885,
 902103040,
 -1,
 902313419,
 902218590,
 -1,
 -51767,
 902274730,
 9041,
 -51766,
 902328382,
 9045,
 -1,
 902379678,
 9057,
 -51764,
 902282045,
 9053,
 -1,
 902508068,
 9074,
 -1,
 902225326,
 9039,
 902772181,
 902149919,
 -1,
 902837714,
 902742740,
 -1,
 -51759,
 902784534,
 9069,
 -1,
 902832240,
 9059,
 -51757,
 902801688,
 9015,
 -51756,
 902985095,
 9023,
 -1,
 903038601,
 9070,
 903230937,
 902717823,
 -1,
 903296472,
 903191174,
 9075,
 -1,
 903220213,
 9080,
 -1,
 903220988,
 9014,
 903493084,
 903194964,
 -1,
 -51749,
 903439675,
 9030,
 -1,
 903503455,
 9076,
 903689694,
 903451883,
 9077,
 -1,
 903613429,
 9081,
 903820769,
 903640709,
 -1,
 -51744,
 903798190,
 9029,
 -1,
 903809561,
 9063,
 904017380,
 903770178,
 -1,
 -51741,
 903991895,
 9051,
 -1,
 904018078,
 9060,
 904213990,
 903945289,
 9082,
 -1,
 904137717,
 9078,
 -51737,
 904194097,
 9068,
 -51736,
 904316937,
 9064,
 -51735,
 904353608,
 9065,
 -51734,
 904415461,
 9079,
 -1,
 904472264,
 9024,
 904672755,
 898147997,
 -1,
 904738290,
 904651667,
 -1,
 904803825,
 904677632,
 -1,
 904869360,
 904775986,
 8773,
 -1,
 904791766,
 8786,
 -1,
 904828941,
 10864,
 -1,
 904735843,
 8774,
 -1,
 904664923,
 8784,
 -1,
 904632897,
 39,
 905262660,
 898057386,
 -1,
 905328179,
 905220159,
 -1,
 905393671,
 905298644,
 -1,
 905459198,
 905370888,
 -1,
 905524732,
 905417103,
 65800,
 905641983,
 905445376,
 -1,
 -51717,
 905561885,
 65827,
 -1,
 905601303,
 65818,
 905838591,
 905463887,
 65809,
 -1,
 905710289,
 65836,
 905917957,
 905402507,
 -1,
 905983491,
 905882704,
 65801,
 906100735,
 905904128,
 -1,
 -51710,
 906020637,
 65828,
 -1,
 906060055,
 65819,
 906297343,
 905931990,
 65810,
 -1,
 906169041,
 65837,
 906428415,
 905856753,
 65808,
 -1,
 906300113,
 65835,
 906507796,
 905361183,
 -1,
 906573326,
 906456814,
 65804,
 906638859,
 906546729,
 65813,
 -1,
 906562257,
 65840,
 906821631,
 906559488,
 -1,
 -51699,
 906741533,
 65831,
 -1,
 906780951,
 65822,
 907018239,
 906513538,
 65805,
 907032081,
 906939945,
 65814,
 -1,
 906955473,
 65841,
 907214847,
 906952704,
 -1,
 -51693,
 907134749,
 65832,
 -1,
 907174167,
 65823,
 907359779,
 906448470,
 -1,
 907425308,
 907317647,
 -1,
 907490842,
 907400575,
 65802,
 907608063,
 907411456,
 -1,
 -51687,
 907527965,
 65829,
 -1,
 907567383,
 65820,
 907804671,
 907458150,
 65811,
 -1,
 907676369,
 65838,
 907935743,
 907370879,
 -1,
 907949601,
 907860212,
 65803,
 908066815,
 907870208,
 -1,
 -51680,
 907986717,
 65830,
 -1,
 908026135,
 65821,
 908263423,
 907891390,
 65812,
 -1,
 908135121,
 65839,
 908342825,
 907316412,
 65807,
 908408358,
 908316201,
 65816,
 -1,
 908331729,
 65843,
 908591103,
 908328960,
 -1,
 -51672,
 908511005,
 65834,
 -1,
 908550423,
 65825,
 908736047,
 908281143,
 65806,
 908801580,
 908714990,
 65815,
 -1,
 908724945,
 65842,
 908984319,
 908722176,
 -1,
 -51666,
 908904221,
 65833,
 -1,
 908943639,
 65824,
 909180927,
 908694975,
 65799,
 909246463,
 909049856,
 -1,
 -51662,
 909166365,
 65826,
 -1,
 909205783,
 65817,
 909391422,
 905305352,
 -1,
 909456955,
 909329725,
 -1,
 909522488,
 909397590,
 -1,
 -51657,
 909483151,
 65851,
 -1,
 909536446,
 65848,
 -51655,
 909493964,
 65850,
 -51654,
 909686973,
 65849,
 -1,
 909715400,
 65847,
 909967359,
 909416578,
 -1,
 -51651,
 909867757,
 65792,
 -1,
 909916968,
 65793,
 910112321,
 909345623,
 -1,
 -51648,
 910083788,
 65855,
 -1,
 910145725,
 65854,
 -51646,
 910064527,
 65853,
 -51645,
 910245894,
 65852,
 -1,
 910307190,
 65794,
 910505609,
 905239381,
 -1,
 910571144,
 910457306,
 -1,
 910636622,
 910497140,
 68352,
 910702154,
 910562676,
 68353,
 -51639,
 910659983,
 68355,
 -1,
 910723295,
 68357,
 910898764,
 910639239,
 68358,
 -1,
 910835847,
 68359,
 -51635,
 910856591,
 68354,
 -1,
 910985439,
 68356,
 911160918,
 910592223,
 -1,
 911226451,
 911102691,
 -1,
 -51631,
 911205563,
 68387,
 -51630,
 911268084,
 68388,
 -1,
 911294599,
 68386,
 -51628,
 911205563,
 68390,
 -51627,
 911444739,
 68391,
 -1,
 911491207,
 68389,
 911685212,
 911128351,
 -1,
 911750746,
 911628427,
 -1,
 -51623,
 911729851,
 68403,
 -1,
 911753351,
 68401,
 -51621,
 911719127,
 68404,
 -1,
 911884423,
 68399,
 912078432,
 911663876,
 -1,
 -51618,
 912057531,
 68370,
 -51617,
 912120052,
 68371,
 -1,
 912146567,
 68369,
 912340580,
 912048852,
 -1,
 -51614,
 912311419,
 68381,
 -51613,
 912349992,
 68378,
 -1,
 912408711,
 68377,
 912602728,
 912282339,
 -1,
 -51610,
 912546600,
 68374,
 -51609,
 912610338,
 68373,
 -1,
 912670855,
 68372,
 912864875,
 912582430,
 -1,
 -51606,
 912808744,
 68402,
 -1,
 912867463,
 68400,
 913061486,
 912843758,
 -1,
 -51603,
 913040571,
 68394,
 -1,
 913064071,
 68395,
 913258096,
 913034826,
 68366,
 -1,
 913231434,
 68367,
 913389170,
 913215887,
 68362,
 -1,
 913346959,
 68363,
 913520244,
 913334655,
 68364,
 -1,
 913465727,
 68365,
 913651319,
 913463435,
 -1,
 -51594,
 913605403,
 68393,
 -1,
 913653895,
 68405,
 913847929,
 913588359,
 68360,
 -1,
 913784967,
 68361,
 913979004,
 913782304,
 -1,
 -51589,
 913922856,
 68380,
 -1,
 913981575,
 68379,
 914175615,
 913909366,
 -1,
 -51586,
 914119464,
 68385,
 -1,
 914178183,
 68384,
 -51584,
 914151668,
 68396,
 -51583,
 914336644,
 68397,
 -51582,
 914399661,
 68382,
 -51581,
 914457371,
 68392,
 -51580,
 914519634,
 68398,
 -51579,
 914583992,
 68368,
 -51578,
 914648909,
 68376,
 -51577,
 914706214,
 68383,
 -1,
 914763400,
 68375,
 -1,
 910497327,
 68409,
 915027611,
 910461151,
 -1,
 915093138,
 914999250,
 -1,
 915158670,
 915025118,
 -1,
 -51571,
 915117684,
 8755,
 -1,
 915176880,
 10560,
 -51569,
 915130928,
 8630,
 -51568,
 915314470,
 8634,
 -51567,
 915368414,
 10769,
 -1,
 915428241,
 10226,
 915617432,
 915034851,
 -1,
 915682967,
 915568210,
 8736,
 915800063,
 915606563,
 -1,
 -51562,
 915722839,
 10660,
 -1,
 915781459,
 10654,
 -1,
 915652961,
 8491,
 -51559,
 915567108,
 9765,
 -51558,
 915945077,
 10193,
 -1,
 916008920,
 9875,
 916207273,
 914977624,
 -1,
 916272800,
 916162351,
 -1,
 916338335,
 916244786,
 8776,
 -1,
 916262004,
 10863,
 -1,
 916297741,
 8778,
 916534947,
 916243863,
 -1,
 -51550,
 916483712,
 9095,
 -1,
 916537498,
 9941,
 916731558,
 916484954,
 -1,
 -51547,
 916670727,
 8780,
 -1,
 916726315,
 9006,
 916979711,
 916668551,
 -1,
 -51544,
 916882135,
 9879,
 -1,
 916934291,
 8501,
 917124785,
 916174623,
 -1,
 917190318,
 917095814,
 -1,
 917255853,
 917139592,
 42,
 -1,
 917177975,
 8727,
 -1,
 917209061,
 8258,
 -51537,
 917169661,
 8771,
 -51536,
 917420493,
 8870,
 -1,
 917450446,
 9738,
 917649082,
 917056734,
 -1,
 917714613,
 917624616,
 -1,
 -51532,
 917670911,
 10655,
 -1,
 917712492,
 180,
 917911224,
 917686536,
 -1,
 -51529,
 917881463,
 8299,
 -1,
 917905561,
 8301,
 -51527,
 917844893,
 8448,
 -1,
 918029069,
 9190,
 918238909,
 917602277,
 -1,
 -51524,
 918201054,
 38,
 -1,
 918231928,
 10815,
 918435520,
 918173216,
 -1,
 -51521,
 918380988,
 9772,
 -1,
 918437836,
 8449,
 -51519,
 918411005,
 8371,
 -51518,
 918604181,
 9883,
 -51517,
 918661197,
 9810,
 -51516,
 918713078,
 8525,
 -51515,
 918777004,
 9992,
 -1,
 918835193,
 1547,
 919026647,
 786949102,
 -1,
 919092182,
 918970751,
 -1,
 919157717,
 919011328,
 -1,
 919223175,
 919126610,
 -1,
 919287695,
 919177439,
 -1,
 919353065,
 919267102,
 -1,
 919418579,
 919326282,
 41727,
 919484111,
 919382356,
 41730,
 -1,
 919462660,
 41729,
 919615185,
 919441807,
 41721,
 -1,
 919593732,
 41720,
 -51502,
 919593732,
 41726,
 -1,
 919707625,
 41728,
 919877338,
 919363967,
 41711,
 919942871,
 919814279,
 41714,
 -51498,
 919921412,
 41713,
 -1,
 919969769,
 41715,
 -51496,
 919921412,
 41710,
 -51495,
 920109780,
 41709,
 -1,
 920166377,
 41712,
 920336096,
 919856110,
 41733,
 920401629,
 920299860,
 41736,
 -1,
 920380164,
 41735,
 -51490,
 920380164,
 41732,
 -51489,
 920502996,
 41731,
 -1,
 920559593,
 41734,
 920729316,
 920262004,
 41718,
 -51486,
 920707844,
 41717,
 -51485,
 920765140,
 41716,
 -1,
 920821737,
 41719,
 920991463,
 920686991,
 -1,
 -51482,
 920969988,
 41722,
 -1,
 921018345,
 41723,
 921239551,
 920928391,
 41725,
 -1,
 921166596,
 41724,
 921319173,
 919283318,
 -1,
 921384689,
 921264511,
 41080,
 921450222,
 921321607,
 41083,
 -51475,
 921428740,
 41082,
 -1,
 921477097,
 41084,
 -51473,
 921428740,
 41079,
 -51472,
 921617108,
 41078,
 -1,
 921673705,
 41081,
 921843447,
 921363438,
 41101,
 921908980,
 921807188,
 41104,
 -1,
 921887492,
 41103,
 -51467,
 921887492,
 41100,
 -51466,
 922010324,
 41099,
 -1,
 922066921,
 41102,
 922236669,
 921816650,
 41095,
 922302202,
 922200404,
 41098,
 -1,
 922280708,
 41097,
 -51461,
 922280708,
 41094,
 -51460,
 922403540,
 41093,
 -1,
 922460137,
 41096,
 922629889,
 922194319,
 41091,
 -51457,
 922608388,
 41090,
 -51456,
 922665684,
 41089,
 -1,
 922722281,
 41092,
 922943487,
 922555764,
 41087,
 -51453,
 922870532,
 41086,
 -51452,
 922927828,
 41085,
 -1,
 922984425,
 41088,
 923154207,
 921268009,
 -1,
 923219726,
 923099519,
 42035,
 923285259,
 923156615,
 42039,
 -51447,
 923263748,
 42038,
 -51446,
 923321044,
 42037,
 -1,
 923377641,
 42040,
 -51444,
 923263748,
 42034,
 -51443,
 923517652,
 42033,
 -1,
 923574249,
 42036,
 923744021,
 923192906,
 42048,
 923809553,
 923707732,
 42051,
 -1,
 923788036,
 42050,
 923940627,
 923767183,
 42042,
 -1,
 923919108,
 42041,
 -51436,
 923919108,
 42047,
 -1,
 924033001,
 42049,
 924202779,
 923722734,
 42054,
 924268312,
 924166484,
 42057,
 -1,
 924246788,
 42056,
 -51431,
 924246788,
 42053,
 -51430,
 924369620,
 42052,
 -1,
 924426217,
 42055,
 924647423,
 924160399,
 42045,
 -51427,
 924574468,
 42044,
 -51426,
 924631764,
 42043,
 -1,
 924688361,
 42046,
 924858167,
 923117908,
 -1,
 924923686,
 924836846,
 41895,
 924989219,
 924887380,
 41898,
 -1,
 924967684,
 41897,
 -51420,
 924967684,
 41894,
 -51419,
 925090516,
 41893,
 -1,
 925147113,
 41896,
 925316908,
 924896842,
 41889,
 925382441,
 925280596,
 41892,
 -1,
 925360900,
 41891,
 -51414,
 925360900,
 41888,
 -51413,
 925483732,
 41887,
 -1,
 925540329,
 41890,
 925710128,
 925253767,
 41885,
 -51410,
 925688580,
 41884,
 -51409,
 925745876,
 41883,
 -1,
 925802473,
 41886,
 925972276,
 925635956,
 41878,
 -51406,
 925950724,
 41877,
 -51405,
 926008020,
 41876,
 -1,
 926064617,
 41879,
 926285823,
 925929871,
 41881,
 -51402,
 926212868,
 41880,
 -1,
 926261225,
 41882,
 926431055,
 924792352,
 -1,
 926496574,
 926404170,
 41316,
 926562107,
 926460244,
 41319,
 -1,
 926540548,
 41318,
 -51396,
 926540548,
 41315,
 -51395,
 926663380,
 41314,
 -1,
 926719977,
 41317,
 926889796,
 926441855,
 41299,
 926955329,
 926826631,
 41302,
 -1,
 926933764,
 41301,
 -51390,
 926933764,
 41298,
 -51389,
 927056596,
 41297,
 -1,
 927113193,
 41300,
 927283016,
 926847375,
 41309,
 -51386,
 927261444,
 41308,
 -51385,
 927318740,
 41307,
 -1,
 927375337,
 41310,
 927545164,
 927208820,
 41305,
 -51382,
 927523588,
 41304,
 -51381,
 927580884,
 41303,
 -1,
 927637481,
 41306,
 927858687,
 927481991,
 41312,
 -51378,
 927785732,
 41311,
 -1,
 927834089,
 41313,
 928003939,
 926409710,
 -1,
 928069464,
 927949183,
 42060,
 928134997,
 928006279,
 42064,
 -51373,
 928113412,
 42063,
 -51372,
 928170708,
 42062,
 -1,
 928227305,
 42065,
 -51370,
 928113412,
 42059,
 -51369,
 928367316,
 42058,
 -1,
 928423913,
 42061,
 928593759,
 928042570,
 42075,
 928659292,
 928551311,
 42067,
 -51365,
 928637700,
 42066,
 -1,
 928686057,
 42068,
 -51363,
 928637700,
 42074,
 -51362,
 928826068,
 42073,
 -1,
 928882665,
 42076,
 929103871,
 928551311,
 42071,
 -51359,
 929030916,
 42070,
 -51358,
 929088212,
 42069,
 -1,
 929144809,
 42072,
 929314677,
 927945443,
 -1,
 929380200,
 929272207,
 41577,
 -51354,
 929358596,
 41576,
 -51353,
 929415892,
 41575,
 -1,
 929472489,
 41578,
 929642348,
 929305972,
 41570,
 -51350,
 929620740,
 41569,
 -51349,
 929678036,
 41568,
 -1,
 929734633,
 41571,
 929904495,
 929616628,
 41574,
 -51346,
 929882884,
 41573,
 -1,
 929940180,
 41572,
 930101106,
 929850416,
 41566,
 -51343,
 930079492,
 41565,
 -1,
 930127849,
 41567,
 930349055,
 930037895,
 41580,
 -51340,
 930276100,
 41579,
 -1,
 930324457,
 41581,
 930494334,
 929287754,
 41363,
 930559865,
 930451855,
 41352,
 -51336,
 930538244,
 41351,
 -1,
 930586601,
 41353,
 930756475,
 930523476,
 41366,
 -1,
 930734852,
 41365,
 -51332,
 930734852,
 41362,
 -51331,
 930857684,
 41361,
 -1,
 930914281,
 41364,
 931084165,
 930439551,
 41343,
 931149698,
 931020935,
 41346,
 -51327,
 931128068,
 41345,
 -1,
 931176425,
 41347,
 -51325,
 931128068,
 41342,
 -51324,
 931316436,
 41341,
 -1,
 931373033,
 41344,
 931542921,
 931041679,
 41356,
 -51321,
 931521284,
 41355,
 -51320,
 931578580,
 41354,
 -1,
 931635177,
 41357,
 931805068,
 931479687,
 41359,
 -51317,
 931783428,
 41358,
 -1,
 931831785,
 41360,
 932052991,
 931730804,
 41349,
 -51314,
 931980036,
 41348,
 -1,
 932028393,
 41350,
 932198418,
 919230603,
 -1,
 932263857,
 932148056,
 -1,
 932329370,
 932236874,
 41389,
 932394901,
 932286863,
 41379,
 -51308,
 932373252,
 41378,
 -1,
 932421609,
 41380,
 932591511,
 932358484,
 41392,
 -1,
 932569860,
 41391,
 -51304,
 932569860,
 41388,
 -51303,
 932692692,
 41387,
 -1,
 932749289,
 41390,
 932919201,
 932274559,
 41369,
 932984734,
 932855943,
 41372,
 -51299,
 932963076,
 41371,
 -1,
 933011433,
 41373,
 -51297,
 932963076,
 41368,
 -51296,
 933151444,
 41367,
 -1,
 933208041,
 41370,
 933377959,
 932897774,
 41395,
 933443492,
 933341524,
 41398,
 -1,
 933421828,
 41397,
 -51291,
 933421828,
 41394,
 -51290,
 933544660,
 41393,
 -1,
 933601257,
 41396,
 933771179,
 933303668,
 41376,
 -51287,
 933749508,
 41375,
 -51286,
 933806804,
 41374,
 -1,
 933863401,
 41377,
 934033326,
 933728655,
 41382,
 -51283,
 934011652,
 41381,
 -1,
 934060009,
 41383,
 934281215,
 933970055,
 41385,
 -51280,
 934208260,
 41384,
 -1,
 934256617,
 41386,
 934426575,
 932216805,
 -1,
 934492091,
 934399562,
 41125,
 934557622,
 934449551,
 41117,
 -51275,
 934535940,
 41116,
 -1,
 934584297,
 41118,
 934754232,
 934521172,
 41128,
 -1,
 934732548,
 41127,
 -51271,
 934732548,
 41124,
 -51270,
 934855380,
 41123,
 -1,
 934911977,
 41126,
 935081922,
 934437247,
 41107,
 935147455,
 935018631,
 41110,
 -51266,
 935125764,
 41109,
 -1,
 935174121,
 41111,
 -51264,
 935125764,
 41106,
 -51263,
 935314132,
 41105,
 -1,
 935370729,
 41108,
 935540679,
 935060462,
 41130,
 935606213,
 935504212,
 41133,
 -1,
 935584516,
 41132,
 -51258,
 935584516,
 41129,
 -1,
 935698409,
 41131,
 935868363,
 935498127,
 41121,
 -51255,
 935846660,
 41120,
 -51254,
 935903956,
 41119,
 -1,
 935960553,
 41122,
 936181759,
 935794036,
 41114,
 -51251,
 936108804,
 41113,
 -51250,
 936166100,
 41112,
 -1,
 936222697,
 41115,
 936392679,
 934404868,
 -1,
 936458200,
 936337791,
 41544,
 936523733,
 936394887,
 41548,
 -51245,
 936502020,
 41547,
 -51244,
 936559316,
 41546,
 -1,
 936615913,
 41549,
 -51242,
 936502020,
 41543,
 -51241,
 936755924,
 41542,
 -1,
 936812521,
 41545,
 936982492,
 936432372,
 41556,
 -51238,
 936960772,
 41555,
 -51237,
 937018068,
 41554,
 -1,
 937074665,
 41557,
 937244640,
 936939919,
 41560,
 -51234,
 937222916,
 41559,
 -51233,
 937280212,
 41558,
 -1,
 937336809,
 41561,
 937506788,
 937170292,
 41552,
 -51230,
 937485060,
 41551,
 -51229,
 937542356,
 41550,
 -1,
 937598953,
 41553,
 937820159,
 937443463,
 41563,
 -51226,
 937747204,
 41562,
 -1,
 937795561,
 41564,
 937965567,
 936347871,
 -1,
 938031088,
 937910655,
 41322,
 938096621,
 937967751,
 41326,
 -51221,
 938074884,
 41325,
 -51220,
 938132180,
 41324,
 -1,
 938188777,
 41327,
 -51218,
 938074884,
 41321,
 -51217,
 938328788,
 41320,
 -1,
 938385385,
 41323,
 938555380,
 937956724,
 41330,
 -51214,
 938533636,
 41329,
 -51213,
 938590932,
 41328,
 -1,
 938647529,
 41331,
 938817528,
 938528330,
 -1,
 938883063,
 938774927,
 41333,
 -1,
 938861316,
 41332,
 -1,
 938853076,
 41340,
 939079676,
 938774927,
 -1,
 -51206,
 939057924,
 41335,
 -51205,
 939115220,
 41334,
 -1,
 939171817,
 41336,
 939393023,
 939016327,
 41338,
 -51202,
 939320068,
 41337,
 -1,
 939368425,
 41339,
 939538435,
 937939700,
 41591,
 -51199,
 939516676,
 41590,
 -51198,
 939573972,
 41589,
 -1,
 939630569,
 41592,
 939800583,
 939495823,
 41595,
 -51195,
 939778820,
 41594,
 -51194,
 939836116,
 41593,
 -1,
 939892713,
 41596,
 940062731,
 939726196,
 41587,
 -51191,
 940040964,
 41586,
 -51190,
 940098260,
 41585,
 -1,
 940154857,
 41588,
 940324879,
 940007807,
 -1,
 940390414,
 940261511,
 41584,
 -1,
 940368644,
 41583,
 -1,
 940360404,
 41582,
 940638207,
 940261511,
 41598,
 -51183,
 940565252,
 41597,
 -1,
 940613609,
 41599,
 940783726,
 932177694,
 -1,
 940849201,
 940762910,
 -1,
 940914716,
 940794239,
 41682,
 940980249,
 940851335,
 41686,
 -51177,
 940958468,
 41685,
 -51176,
 941015764,
 41684,
 -1,
 941072361,
 41687,
 -51174,
 940958468,
 41681,
 -51173,
 941212372,
 41680,
 -1,
 941268969,
 41683,
 941439010,
 940893166,
 41705,
 941504543,
 941402452,
 41708,
 -1,
 941482756,
 41707,
 -51168,
 941482756,
 41704,
 -51167,
 941605588,
 41703,
 -1,
 941662185,
 41706,
 941832231,
 941411914,
 41699,
 941897765,
 941795668,
 41702,
 -1,
 941875972,
 41701,
 -51162,
 941875972,
 41698,
 -1,
 941989865,
 41700,
 942159915,
 941757812,
 41690,
 -51159,
 942138116,
 41689,
 -51158,
 942195412,
 41688,
 -1,
 942252009,
 41691,
 942422062,
 942117263,
 41693,
 -51155,
 942400260,
 41692,
 -1,
 942448617,
 41694,
 942669823,
 942358663,
 41696,
 -51152,
 942596868,
 41695,
 -1,
 942645225,
 41697,
 942815309,
 940791947,
 -1,
 942880827,
 942788170,
 41815,
 942946358,
 942838159,
 41803,
 -51147,
 942924548,
 41802,
 -1,
 942972905,
 41804,
 943142968,
 942909780,
 41818,
 -1,
 943121156,
 41817,
 -51143,
 943121156,
 41814,
 -51142,
 943243988,
 41813,
 -1,
 943300585,
 41816,
 943470657,
 942859246,
 41821,
 943536190,
 943434068,
 41824,
 -1,
 943514372,
 41823,
 -51137,
 943514372,
 41820,
 -51136,
 943637204,
 41819,
 -1,
 943693801,
 41822,
 943863877,
 943427983,
 41807,
 -51133,
 943842052,
 41806,
 -51132,
 943899348,
 41805,
 -1,
 943955945,
 41808,
 944126025,
 943800455,
 41811,
 -51129,
 944104196,
 41810,
 -51128,
 944161492,
 41809,
 -1,
 944218089,
 41812,
 944439295,
 944051572,
 41800,
 -51125,
 944366340,
 41799,
 -51124,
 944423636,
 41798,
 -1,
 944480233,
 41801,
 944650326,
 942788170,
 41636,
 944715857,
 944607631,
 41625,
 -51120,
 944694020,
 41624,
 -1,
 944742377,
 41626,
 944912467,
 944679252,
 41639,
 -1,
 944890628,
 41638,
 -51116,
 944890628,
 41635,
 -51115,
 945013460,
 41634,
 -1,
 945070057,
 41637,
 945240157,
 944595327,
 41615,
 945305690,
 945176711,
 41618,
 -51111,
 945283844,
 41617,
 -1,
 945332201,
 41619,
 -51109,
 945283844,
 41614,
 -51108,
 945472212,
 41613,
 -1,
 945528809,
 41616,
 945698915,
 945218542,
 41642,
 945764448,
 945662292,
 41645,
 -1,
 945742596,
 41644,
 -51103,
 945742596,
 41641,
 -51102,
 945865428,
 41640,
 -1,
 945922025,
 41643,
 946092135,
 945656207,
 41629,
 -51099,
 946070276,
 41628,
 -51098,
 946127572,
 41627,
 -1,
 946184169,
 41630,
 946354283,
 946017652,
 41622,
 -51095,
 946332420,
 41621,
 -51094,
 946389716,
 41620,
 -1,
 946446313,
 41623,
 946667519,
 946290823,
 41632,
 -51091,
 946594564,
 41631,
 -1,
 946642921,
 41633,
 946813129,
 940750623,
 -1,
 946878604,
 946779935,
 -1,
 946944119,
 946823551,
 41772,
 947009652,
 946880647,
 41775,
 -51085,
 946987780,
 41774,
 -1,
 947036137,
 41776,
 -51083,
 946987780,
 41771,
 -51082,
 947176148,
 41770,
 -1,
 947232745,
 41773,
 947402877,
 946922478,
 41794,
 947468410,
 947366228,
 41797,
 -1,
 947446532,
 41796,
 -51077,
 947446532,
 41793,
 -51076,
 947569364,
 41792,
 -1,
 947625961,
 41795,
 947796097,
 947375690,
 41790,
 -51073,
 947774212,
 41789,
 -51072,
 947831508,
 41788,
 -1,
 947888105,
 41791,
 948058245,
 947753359,
 41783,
 -51069,
 948036356,
 41782,
 -51068,
 948093652,
 41781,
 -1,
 948150249,
 41784,
 948320393,
 947983732,
 41779,
 -51065,
 948298500,
 41778,
 -51064,
 948355796,
 41777,
 -1,
 948412393,
 41780,
 948633599,
 948256903,
 41786,
 -51061,
 948560644,
 41785,
 -1,
 948609001,
 41787,
 948779176,
 946821259,
 -1,
 948844694,
 948751946,
 41916,
 948910225,
 948801935,
 41904,
 -51056,
 948888324,
 41903,
 -1,
 948936681,
 41905,
 949106835,
 948873556,
 41919,
 -1,
 949084932,
 41918,
 -51052,
 949084932,
 41915,
 -51051,
 949207764,
 41914,
 -1,
 949264361,
 41917,
 949434524,
 948823022,
 41922,
 949500057,
 949397844,
 41925,
 -1,
 949478148,
 41924,
 -51046,
 949478148,
 41921,
 -51045,
 949600980,
 41920,
 -1,
 949657577,
 41923,
 949827744,
 949391759,
 41908,
 -51042,
 949805828,
 41907,
 -51041,
 949863124,
 41906,
 -1,
 949919721,
 41909,
 950089892,
 949764231,
 41912,
 -51038,
 950067972,
 41911,
 -51037,
 950125268,
 41910,
 -1,
 950181865,
 41913,
 950403071,
 950015348,
 41901,
 -51034,
 950330116,
 41900,
 -51033,
 950387412,
 41899,
 -1,
 950444009,
 41902,
 950614193,
 948751946,
 41760,
 950679724,
 950571407,
 41749,
 -51029,
 950657796,
 41748,
 -1,
 950706153,
 41750,
 950876334,
 950643028,
 41763,
 -1,
 950854404,
 41762,
 -51025,
 950854404,
 41759,
 -51024,
 950977236,
 41758,
 -1,
 951033833,
 41761,
 951204024,
 950559103,
 41739,
 951269557,
 951140487,
 41742,
 -51020,
 951247620,
 41741,
 -1,
 951295977,
 41743,
 -51018,
 951247620,
 41738,
 -51017,
 951435988,
 41737,
 -1,
 951492585,
 41740,
 951662782,
 951182318,
 41766,
 951728315,
 951626068,
 41769,
 -1,
 951706372,
 41768,
 -51012,
 951706372,
 41765,
 -51011,
 951829204,
 41764,
 -1,
 951885801,
 41767,
 952056002,
 951619983,
 41753,
 -51008,
 952034052,
 41752,
 -51007,
 952091348,
 41751,
 -1,
 952147945,
 41754,
 952318150,
 951981428,
 41746,
 -51004,
 952296196,
 41745,
 -51003,
 952353492,
 41744,
 -1,
 952410089,
 41747,
 952631295,
 952254599,
 41756,
 -51000,
 952558340,
 41755,
 -1,
 952606697,
 41757,
 952776973,
 946742902,
 -1,
 952842475,
 952706678,
 -1,
 952907988,
 952815178,
 41070,
 952973519,
 952865167,
 41059,
 -50994,
 952951556,
 41058,
 -1,
 952999913,
 41060,
 953170129,
 952936788,
 41073,
 -1,
 953148164,
 41072,
 -50990,
 953148164,
 41069,
 -50989,
 953270996,
 41068,
 -1,
 953327593,
 41071,
 953497820,
 952852863,
 41048,
 953563353,
 953434247,
 41052,
 -50985,
 953541380,
 41051,
 -50984,
 953598676,
 41050,
 -1,
 953655273,
 41053,
 -50982,
 953541380,
 41047,
 -50981,
 953795284,
 41046,
 -1,
 953851881,
 41049,
 954022112,
 953476078,
 41076,
 -50978,
 954000132,
 41075,
 -50977,
 954057428,
 41074,
 -1,
 954114025,
 41077,
 954284260,
 953979279,
 41063,
 -50974,
 954262276,
 41062,
 -50973,
 954319572,
 41061,
 -1,
 954376169,
 41064,
 954546408,
 954209652,
 41056,
 -50970,
 954524420,
 41055,
 -50969,
 954581716,
 41054,
 -1,
 954638313,
 41057,
 954859519,
 954482823,
 41066,
 -50966,
 954786564,
 41065,
 -1,
 954834921,
 41067,
 955005172,
 952815178,
 41006,
 955070703,
 954962319,
 40995,
 -50962,
 955048708,
 40994,
 -1,
 955097065,
 40996,
 955267313,
 955033940,
 41009,
 -1,
 955245316,
 41008,
 -50958,
 955245316,
 41005,
 -50957,
 955368148,
 41004,
 -1,
 955424745,
 41007,
 955595004,
 954950015,
 40984,
 955660537,
 955531399,
 40988,
 -50953,
 955638532,
 40987,
 -50952,
 955695828,
 40986,
 -1,
 955752425,
 40989,
 -50950,
 955638532,
 40983,
 -50949,
 955892436,
 40982,
 -1,
 955949033,
 40985,
 956119298,
 955573230,
 41012,
 956184831,
 956082516,
 41015,
 -1,
 956162820,
 41014,
 -50944,
 956162820,
 41011,
 -50943,
 956285652,
 41010,
 -1,
 956342249,
 41013,
 956512518,
 956076431,
 40999,
 -50940,
 956490500,
 40998,
 -50939,
 956547796,
 40997,
 -1,
 956604393,
 41000,
 956774666,
 956437876,
 40992,
 -50936,
 956752644,
 40991,
 -50935,
 956809940,
 40990,
 -1,
 956866537,
 40993,
 957087743,
 956711047,
 41002,
 -50932,
 957014788,
 41001,
 -1,
 957063145,
 41003,
 957233484,
 952708318,
 -1,
 957298986,
 957175947,
 -1,
 957364504,
 957271626,
 41842,
 957430036,
 957321615,
 41831,
 -50926,
 957408004,
 41830,
 -50925,
 957465300,
 41829,
 -1,
 957521897,
 41832,
 957692182,
 957393236,
 41845,
 -1,
 957670148,
 41844,
 -50921,
 957670148,
 41841,
 -1,
 957784041,
 41843,
 957954334,
 957342702,
 41848,
 958019867,
 957917524,
 41851,
 -1,
 957997828,
 41850,
 -50916,
 957997828,
 41847,
 -50915,
 958120660,
 41846,
 -1,
 958177257,
 41849,
 958347554,
 957911439,
 41835,
 -50912,
 958325508,
 41834,
 -50911,
 958382804,
 41833,
 -1,
 958439401,
 41836,
 958609702,
 958283911,
 41839,
 -50908,
 958587652,
 41838,
 -50907,
 958644948,
 41837,
 -1,
 958701545,
 41840,
 958922751,
 958535028,
 41827,
 -50904,
 958849796,
 41826,
 -50903,
 958907092,
 41825,
 -1,
 958963689,
 41828,
 959134003,
 957271626,
 41670,
 959199534,
 959091087,
 41659,
 -50899,
 959177476,
 41658,
 -1,
 959225833,
 41660,
 959396144,
 959162708,
 41673,
 -1,
 959374084,
 41672,
 -50895,
 959374084,
 41669,
 -50894,
 959496916,
 41668,
 -1,
 959553513,
 41671,
 959723835,
 959078783,
 41648,
 959789368,
 959660167,
 41652,
 -50890,
 959767300,
 41651,
 -50889,
 959824596,
 41650,
 -1,
 959881193,
 41653,
 -50887,
 959767300,
 41647,
 -50886,
 960021204,
 41646,
 -1,
 960077801,
 41649,
 960248129,
 959701998,
 41676,
 960313662,
 960211284,
 41679,
 -1,
 960291588,
 41678,
 -50881,
 960291588,
 41675,
 -50880,
 960414420,
 41674,
 -1,
 960471017,
 41677,
 960641349,
 960205199,
 41663,
 -50877,
 960619268,
 41662,
 -50876,
 960676564,
 41661,
 -1,
 960733161,
 41664,
 960903497,
 960566644,
 41656,
 -50873,
 960881412,
 41655,
 -50872,
 960938708,
 41654,
 -1,
 960995305,
 41657,
 961216511,
 960839815,
 41666,
 -50869,
 961143556,
 41665,
 -1,
 961191913,
 41667,
 961362312,
 957174499,
 -1,
 961427818,
 961303267,
 -1,
 961493336,
 961400394,
 41516,
 961558867,
 961450383,
 41504,
 -50863,
 961536772,
 41503,
 -50862,
 961594068,
 41502,
 -1,
 961650665,
 41505,
 961821013,
 961522004,
 41519,
 -1,
 961798916,
 41518,
 -50858,
 961798916,
 41515,
 -50857,
 961921748,
 41514,
 -1,
 961978345,
 41517,
 962148702,
 961438079,
 41494,
 962214236,
 962084999,
 41496,
 -50853,
 962192132,
 41495,
 -1,
 962240489,
 41497,
 -50851,
 962192132,
 41493,
 -1,
 962380500,
 41492,
 962541922,
 962105743,
 41508,
 -50848,
 962519812,
 41507,
 -50847,
 962577108,
 41506,
 -1,
 962633705,
 41509,
 962804070,
 962478215,
 41512,
 -50844,
 962781956,
 41511,
 -50843,
 962839252,
 41510,
 -1,
 962895849,
 41513,
 963117055,
 962729332,
 41500,
 -50840,
 963044100,
 41499,
 -50839,
 963101396,
 41498,
 -1,
 963157993,
 41501,
 963328372,
 961400394,
 41460,
 963393903,
 963285391,
 41448,
 -50835,
 963371780,
 41447,
 -50834,
 963429076,
 41446,
 -1,
 963485673,
 41449,
 963656049,
 963357012,
 41463,
 -1,
 963633924,
 41462,
 -50830,
 963633924,
 41459,
 -50829,
 963756756,
 41458,
 -1,
 963813353,
 41461,
 963983740,
 963273087,
 41436,
 964049273,
 963920007,
 41440,
 -50825,
 964027140,
 41439,
 -50824,
 964084436,
 41438,
 -1,
 964141033,
 41441,
 -50822,
 964027140,
 41435,
 -50821,
 964281044,
 41434,
 -1,
 964337641,
 41437,
 964508032,
 963940751,
 41452,
 -50818,
 964485892,
 41451,
 -50817,
 964543188,
 41450,
 -1,
 964599785,
 41453,
 964770180,
 964444295,
 41456,
 -50814,
 964748036,
 41455,
 -50813,
 964805332,
 41454,
 -1,
 964861929,
 41457,
 965083135,
 964695412,
 41444,
 -50810,
 965010180,
 41443,
 -50809,
 965067476,
 41442,
 -1,
 965124073,
 41445,
 965294527,
 961314789,
 -1,
 965360032,
 965235427,
 -1,
 965425555,
 965332554,
 41538,
 965491086,
 965382543,
 41527,
 -50803,
 965468932,
 41526,
 -1,
 965517289,
 41528,
 965687696,
 965454164,
 41541,
 -1,
 965665540,
 41540,
 -50799,
 965665540,
 41537,
 -50798,
 965788372,
 41536,
 -1,
 965844969,
 41539,
 966015383,
 965382543,
 41531,
 -50795,
 965993220,
 41530,
 -50794,
 966050516,
 41529,
 -1,
 966107113,
 41532,
 966277531,
 965940596,
 41524,
 -50791,
 966255364,
 41523,
 -50790,
 966312660,
 41522,
 -1,
 966369257,
 41525,
 966539678,
 966213767,
 41534,
 -50787,
 966517508,
 41533,
 -1,
 966565865,
 41535,
 966787071,
 966485040,
 41521,
 -1,
 966714116,
 41520,
 966867370,
 965332554,
 41157,
 966932901,
 966824335,
 41147,
 -50781,
 966910724,
 41146,
 -50780,
 966968020,
 41145,
 -1,
 967024617,
 41148,
 967195047,
 966895956,
 41160,
 -1,
 967172868,
 41159,
 -50776,
 967172868,
 41156,
 -50775,
 967295700,
 41155,
 -1,
 967352297,
 41158,
 967522737,
 966812031,
 41136,
 967588270,
 967458951,
 41139,
 -50771,
 967566084,
 41138,
 -1,
 967614441,
 41140,
 -50769,
 967566084,
 41135,
 -50768,
 967754452,
 41134,
 -1,
 967811049,
 41137,
 967981493,
 967500782,
 41163,
 -50765,
 967959300,
 41162,
 -50764,
 968016596,
 41161,
 -1,
 968073193,
 41164,
 968243641,
 967938447,
 41151,
 -50761,
 968221444,
 41150,
 -50760,
 968278740,
 41149,
 -1,
 968335337,
 41152,
 968505789,
 968168820,
 41143,
 -50757,
 968483588,
 41142,
 -50756,
 968540884,
 41141,
 -1,
 968597481,
 41144,
 968818687,
 968441991,
 41154,
 -1,
 968745732,
 41153,
 968899062,
 965242665,
 -1,
 968964570,
 968847145,
 -1,
 969030090,
 968937034,
 42025,
 969095621,
 968987023,
 42017,
 -50748,
 969073412,
 42016,
 -1,
 969121769,
 42018,
 969292231,
 969058644,
 42028,
 -1,
 969270020,
 42027,
 -50744,
 969270020,
 42024,
 -50743,
 969392852,
 42023,
 -1,
 969449449,
 42026,
 969619922,
 968974719,
 42010,
 969685455,
 969556103,
 42014,
 -50739,
 969663236,
 42013,
 -50738,
 969720532,
 42012,
 -1,
 969777129,
 42015,
 -50736,
 969663236,
 42009,
 -50735,
 969917140,
 42008,
 -1,
 969973737,
 42011,
 970144214,
 969597934,
 42031,
 -50732,
 970121988,
 42030,
 -50731,
 970179284,
 42029,
 -1,
 970235881,
 42032,
 970457087,
 970101135,
 42021,
 -50728,
 970384132,
 42020,
 -50727,
 970441428,
 42019,
 -1,
 970498025,
 42022,
 970668516,
 968937034,
 41970,
 970734047,
 970625423,
 41962,
 -50723,
 970711812,
 41961,
 -50722,
 970769108,
 41960,
 -1,
 970825705,
 41963,
 970996193,
 970697044,
 41973,
 -1,
 970973956,
 41972,
 -50718,
 970973956,
 41969,
 -50717,
 971096788,
 41968,
 -1,
 971153385,
 41971,
 971323884,
 970613119,
 41954,
 971389417,
 971260039,
 41958,
 -50713,
 971367172,
 41957,
 -50712,
 971424468,
 41956,
 -1,
 971481065,
 41959,
 -50710,
 971367172,
 41953,
 -50709,
 971621076,
 41952,
 -1,
 971677673,
 41955,
 971848178,
 971301870,
 41976,
 971913711,
 971811156,
 41979,
 -1,
 971891460,
 41978,
 -50704,
 971891460,
 41975,
 -50703,
 972014292,
 41974,
 -1,
 972070889,
 41977,
 972292095,
 971805071,
 41966,
 -50700,
 972219140,
 41965,
 -50699,
 972276436,
 41964,
 -1,
 972333033,
 41967,
 972503597,
 968832544,
 -1,
 972569107,
 972437024,
 -1,
 972634625,
 972541514,
 41293,
 972700156,
 972591503,
 41282,
 -50693,
 972677892,
 41281,
 -1,
 972726249,
 41283,
 972896766,
 972663124,
 41296,
 -1,
 972874500,
 41295,
 -50689,
 972874500,
 41292,
 -50688,
 972997332,
 41291,
 -1,
 973053929,
 41294,
 973224456,
 972579199,
 41272,
 973289989,
 973160583,
 41275,
 -50684,
 973267716,
 41274,
 -1,
 973316073,
 41276,
 -50682,
 973267716,
 41271,
 -50681,
 973456084,
 41270,
 -1,
 973512681,
 41273,
 973683212,
 973181327,
 41286,
 -50678,
 973660932,
 41285,
 -50677,
 973718228,
 41284,
 -1,
 973774825,
 41287,
 973945360,
 973608308,
 41279,
 -50674,
 973923076,
 41278,
 -50673,
 973980372,
 41277,
 -1,
 974036969,
 41280,
 974258175,
 973881479,
 41289,
 -50670,
 974185220,
 41288,
 -1,
 974233577,
 41290,
 974404123,
 972541514,
 41238,
 974469654,
 974367060,
 41241,
 -1,
 974447364,
 41240,
 974600728,
 974426511,
 41228,
 -1,
 974578436,
 41227,
 -50663,
 974578436,
 41237,
 -50662,
 974701268,
 41236,
 -1,
 974757865,
 41239,
 974928418,
 974348671,
 41218,
 974993951,
 974864519,
 41221,
 -50658,
 974971652,
 41220,
 -1,
 975020009,
 41222,
 -50656,
 974971652,
 41217,
 -50655,
 975160020,
 41216,
 -1,
 975216617,
 41219,
 975387174,
 974885263,
 41231,
 -50652,
 975364868,
 41230,
 -50651,
 975422164,
 41229,
 -1,
 975478761,
 41232,
 975649322,
 975312244,
 41225,
 -50648,
 975627012,
 41224,
 -50647,
 975684308,
 41223,
 -1,
 975740905,
 41226,
 975962111,
 975585415,
 41234,
 -50644,
 975889156,
 41233,
 -1,
 975937513,
 41235,
 976108129,
 972466516,
 -1,
 976173639,
 976070996,
 -1,
 976239159,
 976145994,
 41866,
 976304690,
 976202068,
 41869,
 -1,
 976282372,
 41868,
 976435764,
 976261519,
 41855,
 -1,
 976413444,
 41854,
 -50635,
 976413444,
 41865,
 -50634,
 976536276,
 41864,
 -1,
 976592873,
 41867,
 976763453,
 976217070,
 41872,
 976828986,
 976726356,
 41875,
 -1,
 976806660,
 41874,
 -50629,
 976806660,
 41871,
 -50628,
 976929492,
 41870,
 -1,
 976986089,
 41873,
 977156673,
 976720271,
 41858,
 -50625,
 977134340,
 41857,
 -50624,
 977191636,
 41856,
 -1,
 977248233,
 41859,
 977418821,
 977092743,
 41862,
 -50621,
 977396484,
 41861,
 -50620,
 977453780,
 41860,
 -1,
 977510377,
 41863,
 977731583,
 977343860,
 41853,
 -1,
 977658628,
 41852,
 977812048,
 976145994,
 41942,
 977877579,
 977768847,
 41931,
 -50614,
 977855236,
 41930,
 -1,
 977903593,
 41932,
 978074189,
 977840468,
 41945,
 -1,
 978051844,
 41944,
 -50610,
 978051844,
 41941,
 -50609,
 978174676,
 41940,
 -1,
 978231273,
 41943,
 978401878,
 977789934,
 41948,
 978467411,
 978364756,
 41951,
 -1,
 978445060,
 41950,
 -50604,
 978445060,
 41947,
 -50603,
 978567892,
 41946,
 -1,
 978624489,
 41949,
 978795098,
 978358671,
 41935,
 -50600,
 978772740,
 41934,
 -50599,
 978830036,
 41933,
 -1,
 978886633,
 41936,
 979057246,
 978720116,
 41928,
 -50596,
 979034884,
 41927,
 -50595,
 979092180,
 41926,
 -1,
 979148777,
 41929,
 979369983,
 978993287,
 41938,
 -50592,
 979297028,
 41937,
 -1,
 979345385,
 41939,
 979516037,
 976057176,
 -1,
 979581548,
 979488330,
 41424,
 979647079,
 979538319,
 41413,
 -50587,
 979624708,
 41412,
 -50586,
 979682004,
 41411,
 -1,
 979738601,
 41414,
 979909225,
 979609940,
 41427,
 -1,
 979886852,
 41426,
 -50582,
 979886852,
 41423,
 -50581,
 980009684,
 41422,
 -1,
 980066281,
 41425,
 980236916,
 979526015,
 41401,
 980302449,
 980172935,
 41405,
 -50577,
 980280068,
 41404,
 -50576,
 980337364,
 41403,
 -1,
 980393961,
 41406,
 -50574,
 980280068,
 41400,
 -50573,
 980533972,
 41399,
 -1,
 980590569,
 41402,
 980761210,
 980214766,
 41430,
 980826743,
 980724052,
 41433,
 -1,
 980804356,
 41432,
 -50568,
 980804356,
 41429,
 -50567,
 980927188,
 41428,
 -1,
 980983785,
 41431,
 981154430,
 980717967,
 41417,
 -50564,
 981132036,
 41416,
 -50563,
 981189332,
 41415,
 -1,
 981245929,
 41418,
 981416578,
 981079412,
 41409,
 -50560,
 981394180,
 41408,
 -50559,
 981451476,
 41407,
 -1,
 981508073,
 41410,
 981729279,
 981352583,
 41420,
 -50556,
 981656324,
 41419,
 -1,
 981704681,
 41421,
 981875365,
 979490734,
 -1,
 981940878,
 981819775,
 41188,
 982006411,
 981876871,
 41192,
 -50551,
 981984004,
 41191,
 -50550,
 982041300,
 41190,
 -1,
 982097897,
 41193,
 -50548,
 981984004,
 41187,
 -50547,
 982237908,
 41186,
 -1,
 982294505,
 41189,
 982465172,
 981918702,
 41212,
 982530705,
 982427988,
 41215,
 -1,
 982508292,
 41214,
 -50542,
 982508292,
 41211,
 -50541,
 982631124,
 41210,
 -1,
 982687721,
 41213,
 982858394,
 982437450,
 41206,
 982923927,
 982821204,
 41209,
 -1,
 982901508,
 41208,
 -50536,
 982901508,
 41205,
 -50535,
 983024340,
 41204,
 -1,
 983080937,
 41207,
 983251614,
 982815119,
 41200,
 -50532,
 983229188,
 41199,
 -50531,
 983286484,
 41198,
 -1,
 983343081,
 41201,
 983513762,
 983176564,
 41196,
 -50528,
 983491332,
 41195,
 -50527,
 983548628,
 41194,
 -1,
 983605225,
 41197,
 983826431,
 983449735,
 -1,
 -50524,
 983753476,
 41202,
 -1,
 983801833,
 41203,
 983972548,
 981835753,
 -1,
 984038063,
 983944778,
 41036,
 984103594,
 983994767,
 41028,
 -50519,
 984081156,
 41027,
 -1,
 984129513,
 41029,
 984300204,
 984066388,
 41039,
 -1,
 984277764,
 41038,
 -50515,
 984277764,
 41035,
 -50514,
 984400596,
 41034,
 -1,
 984457193,
 41037,
 984627894,
 983982463,
 41018,
 984693427,
 984563847,
 41021,
 -50510,
 984670980,
 41020,
 -1,
 984719337,
 41022,
 -50508,
 984670980,
 41017,
 -50507,
 984859348,
 41016,
 -1,
 984915945,
 41019,
 985086652,
 984605678,
 41042,
 985152185,
 985049428,
 41045,
 -1,
 985129732,
 41044,
 -50502,
 985129732,
 41041,
 -50501,
 985252564,
 41040,
 -1,
 985309161,
 41043,
 985479872,
 985043343,
 41032,
 -50498,
 985457412,
 41031,
 -50497,
 985514708,
 41030,
 -1,
 985571305,
 41033,
 985792511,
 985404788,
 41025,
 -50494,
 985719556,
 41024,
 -50493,
 985776852,
 41023,
 -1,
 985833449,
 41026,
 986004193,
 983950318,
 -1,
 986069711,
 985976394,
 42115,
 986135242,
 986026383,
 42107,
 -50488,
 986112772,
 42106,
 -50487,
 986170068,
 42105,
 -1,
 986226665,
 42108,
 986397388,
 986098004,
 42118,
 -1,
 986374916,
 42117,
 -50483,
 986374916,
 42114,
 -50482,
 986497748,
 42113,
 -1,
 986554345,
 42116,
 986725079,
 986014079,
 42099,
 986790612,
 986660999,
 42103,
 -50478,
 986768132,
 42102,
 -50477,
 986825428,
 42101,
 -1,
 986882025,
 42104,
 -50475,
 986768132,
 42098,
 -50474,
 987022036,
 42097,
 -1,
 987078633,
 42100,
 987249373,
 986702830,
 42121,
 987314906,
 987212116,
 42124,
 -1,
 987292420,
 42123,
 -50469,
 987292420,
 42120,
 -50468,
 987415252,
 42119,
 -1,
 987471849,
 42122,
 987693055,
 987206031,
 42111,
 -50465,
 987620100,
 42110,
 -50464,
 987677396,
 42109,
 -1,
 987733993,
 42112,
 987904766,
 985973460,
 -1,
 987970284,
 987876938,
 41266,
 988035815,
 987926927,
 41255,
 -50459,
 988013316,
 41254,
 -50458,
 988070612,
 41253,
 -1,
 988127209,
 41256,
 988297961,
 987998548,
 41269,
 -1,
 988275460,
 41268,
 -50454,
 988275460,
 41265,
 -50453,
 988398292,
 41264,
 -1,
 988454889,
 41267,
 988625651,
 987914623,
 41244,
 988691184,
 988561543,
 41247,
 -50449,
 988668676,
 41246,
 -1,
 988717033,
 41248,
 -50447,
 988668676,
 41243,
 -50446,
 988857044,
 41242,
 -1,
 988913641,
 41245,
 989084407,
 988582287,
 41259,
 -50443,
 989061892,
 41258,
 -50442,
 989119188,
 41257,
 -1,
 989175785,
 41260,
 989346555,
 989009268,
 41251,
 -50439,
 989324036,
 41250,
 -50438,
 989381332,
 41249,
 -1,
 989437929,
 41252,
 989659135,
 989282439,
 41262,
 -50435,
 989586180,
 41261,
 -1,
 989634537,
 41263,
 989805339,
 987866948,
 -1,
 989870857,
 989777482,
 41998,
 989936388,
 989827471,
 41990,
 -50430,
 989913860,
 41989,
 -50429,
 989971156,
 41988,
 -1,
 990027753,
 41991,
 990198534,
 989899092,
 42001,
 -1,
 990176004,
 42000,
 -50425,
 990176004,
 41997,
 -50424,
 990298836,
 41996,
 -1,
 990355433,
 41999,
 990526225,
 989815167,
 41982,
 990591758,
 990462087,
 41986,
 -50420,
 990569220,
 41985,
 -50419,
 990626516,
 41984,
 -1,
 990683113,
 41987,
 -50417,
 990569220,
 41981,
 -50416,
 990823124,
 41980,
 -1,
 990879721,
 41983,
 991050519,
 990503918,
 42004,
 991116052,
 991013204,
 42007,
 -1,
 991093508,
 42006,
 -50411,
 991093508,
 42003,
 -50410,
 991216340,
 42002,
 -1,
 991272937,
 42005,
 991494143,
 991007119,
 41994,
 -50407,
 991421188,
 41993,
 -50406,
 991478484,
 41992,
 -1,
 991535081,
 41995,
 991705912,
 989753480,
 -1,
 991771429,
 991678026,
 41488,
 991836960,
 991728015,
 41476,
 -50401,
 991814404,
 41475,
 -1,
 991862761,
 41477,
 992033570,
 991799636,
 41491,
 -1,
 992011012,
 41490,
 -50397,
 992011012,
 41487,
 -50396,
 992133844,
 41486,
 -1,
 992190441,
 41489,
 992361260,
 991715711,
 41466,
 992426793,
 992297095,
 41469,
 -50392,
 992404228,
 41468,
 -1,
 992452585,
 41470,
 -50390,
 992404228,
 41465,
 -50389,
 992592596,
 41464,
 -1,
 992649193,
 41467,
 992820016,
 992317839,
 41480,
 -50386,
 992797444,
 41479,
 -50385,
 992854740,
 41478,
 -1,
 992911337,
 41481,
 993082164,
 992755847,
 41484,
 -50382,
 993059588,
 41483,
 -50381,
 993116884,
 41482,
 -1,
 993173481,
 41485,
 993394687,
 993006964,
 41473,
 -50378,
 993321732,
 41472,
 -50377,
 993379028,
 41471,
 -1,
 993435625,
 41474,
 993606478,
 991645270,
 -1,
 993671999,
 993578570,
 41178,
 993737532,
 993634644,
 41181,
 -1,
 993714948,
 41180,
 -50371,
 993714948,
 41177,
 -50370,
 993837780,
 41176,
 -1,
 993894377,
 41179,
 994065219,
 993649646,
 41184,
 -50367,
 994042628,
 41183,
 -50366,
 994099924,
 41182,
 -1,
 994156521,
 41185,
 994327367,
 994009471,
 41167,
 -50363,
 994304772,
 41166,
 -50362,
 994362068,
 41165,
 -1,
 994418665,
 41168,
 994589515,
 994252148,
 41171,
 -50359,
 994566916,
 41170,
 -50358,
 994624212,
 41169,
 -1,
 994680809,
 41172,
 994902015,
 994546063,
 41174,
 -50355,
 994829060,
 41173,
 -1,
 994877417,
 41175,
 995048291,
 993583876,
 -1,
 995113815,
 994992511,
 42079,
 995179348,
 995049607,
 42083,
 -50350,
 995156740,
 42082,
 -50349,
 995214036,
 42081,
 -1,
 995270633,
 42084,
 -50347,
 995156740,
 42078,
 -50346,
 995410644,
 42077,
 -1,
 995467241,
 42080,
 995638109,
 995091438,
 42093,
 995703642,
 995600724,
 42096,
 -1,
 995681028,
 42095,
 -50341,
 995681028,
 42092,
 -50340,
 995803860,
 42091,
 -1,
 995860457,
 42094,
 996031329,
 995594639,
 42089,
 -50337,
 996008708,
 42088,
 -50336,
 996066004,
 42087,
 -1,
 996122601,
 42090,
 996343807,
 996004596,
 42086,
 -1,
 996270852,
 42085,
 996424562,
 995024136,
 -1,
 996490088,
 996396618,
 40981,
 996605951,
 996446607,
 41605,
 -50329,
 996532996,
 41604,
 -1,
 996581353,
 41606,
 996752236,
 996414836,
 41602,
 -50326,
 996729604,
 41601,
 -50325,
 996786900,
 41600,
 -1,
 996843497,
 41603,
 997014383,
 996708751,
 41608,
 -50322,
 996991748,
 41607,
 -1,
 997040105,
 41609,
 997261311,
 996950151,
 41611,
 -50319,
 997188356,
 41610,
 -1,
 997236713,
 41612,
 997407610,
 996368767,
 40962,
 997473143,
 997343367,
 40966,
 -50315,
 997450500,
 40965,
 -50314,
 997507796,
 40964,
 -1,
 997564393,
 40967,
 -50312,
 997450500,
 40961,
 -50311,
 997704404,
 40960,
 -1,
 997761001,
 40963,
 997931902,
 997364111,
 40977,
 -50308,
 997909252,
 40976,
 -50307,
 997966548,
 40975,
 -1,
 998023145,
 40978,
 998194050,
 997856628,
 40970,
 -50304,
 998171396,
 40969,
 -50303,
 998228692,
 40968,
 -1,
 998285289,
 40971,
 998456197,
 998167284,
 40973,
 -50300,
 998433540,
 40972,
 -1,
 998481897,
 40974,
 998703103,
 998391943,
 40980,
 -1,
 998630148,
 40979,
 998834175,
 919185908,
 -1,
 998849423,
 998714590,
 -1,
 998914956,
 998826990,
 42172,
 -50293,
 998884052,
 42147,
 -1,
 998940649,
 42132,
 -50291,
 998888192,
 42173,
 -50290,
 999058362,
 42174,
 -1,
 999119656,
 42179,
 999308182,
 998827806,
 -1,
 999373715,
 999280202,
 -1,
 -50286,
 999336276,
 42177,
 -1,
 999399401,
 42146,
 -50284,
 999352331,
 42180,
 -50283,
 999529034,
 42155,
 -1,
 999560564,
 42162,
 999766941,
 999274271,
 -1,
 999832476,
 999708811,
 -1,
 -50279,
 999810030,
 42160,
 -50278,
 999871871,
 42170,
 -50277,
 999921388,
 42178,
 -1,
 999957612,
 42176,
 -1,
 999799772,
 42133,
 1000225700,
 999707363,
 -1,
 1000291233,
 1000166115,
 -1,
 -50272,
 1000264436,
 42150,
 -1,
 1000314604,
 42134,
 -50270,
 1000249930,
 42166,
 -50269,
 1000425619,
 42135,
 -1,
 1000478068,
 42145,
 1000684458,
 1000179935,
 -1,
 1000749992,
 1000661998,
 -1,
 -50265,
 1000707820,
 42151,
 -1,
 1000762298,
 42131,
 -50263,
 1000728660,
 42164,
 -1,
 1000876372,
 42181,
 1001077680,
 1000632105,
 -1,
 1001143215,
 1001025321,
 -1,
 -50259,
 1001120750,
 42165,
 -50258,
 1001182985,
 42154,
 -1,
 1001219120,
 42167,
 -1,
 1001099663,
 42163,
 1001470902,
 1001019531,
 -1,
 1001536437,
 1001448196,
 -1,
 -50253,
 1001509620,
 42143,
 -50252,
 1001559788,
 42175,
 -1,
 1001614719,
 42137,
 -1,
 1001489972,
 42157,
 1001864122,
 1001419608,
 -1,
 1001929657,
 1001808255,
 42129,
 -1,
 1001865351,
 42171,
 -1,
 1001907858,
 42138,
 1002126269,
 1001841646,
 -1,
 -50244,
 1002082703,
 42141,
 -1,
 1002139007,
 42158,
 1002322880,
 1002100654,
 -1,
 -50241,
 1002296703,
 42159,
 -1,
 1002326163,
 42161,
 1002519491,
 1002291924,
 -1,
 -50238,
 1002491466,
 42152,
 -1,
 1002513516,
 42144,
 1002716102,
 1002479593,
 -1,
 -50235,
 1002694356,
 42156,
 -1,
 1002755849,
 42142,
 1002912713,
 1002668005,
 -1,
 -50232,
 1002870508,
 42140,
 -1,
 1002922367,
 42136,
 1003109324,
 1002860680,
 -1,
 -50229,
 1003056511,
 42130,
 -1,
 1003110535,
 42182,
 1003305935,
 1003042336,
 -1,
 -50226,
 1003277898,
 42169,
 -1,
 1003307094,
 42148,
 1003502546,
 1003234934,
 -1,
 -50223,
 1003476351,
 42149,
 -1,
 1003498591,
 42139,
 -50221,
 1003479439,
 42168,
 -50220,
 1003661245,
 42128,
 -1,
 1003722476,
 42153,
 -1,
 919111955,
 9775,
 -1,
 919029536,
 165,
 1004028395,
 918955638,
 -1,
 1004092639,
 1003989332,
 -1,
 1004158171,
 1004017997,
 -1,
 1004223706,
 1004092378,
 -1,
 1004289115,
 1004147215,
 10241,
 1004354588,
 1004212903,
 10243,
 1004420093,
 1004278604,
 10247,
 1004485614,
 1004344252,
 10255,
 1004551143,
 1004409865,
 10271,
 1004616676,
 1004475521,
 10303,
 1004682211,
 1004541126,
 10367,
 -1,
 1004606733,
 10495,
 -1,
 1004606733,
 10431,
 1004878822,
 1004541126,
 10335,
 -1,
 1004803341,
 10463,
 -1,
 1004803341,
 10399,
 1005075435,
 1004475521,
 10287,
 1005140970,
 1004999878,
 10351,
 -1,
 1005065485,
 10479,
 -1,
 1005065485,
 10415,
 1005337581,
 1004999878,
 10319,
 -1,
 1005262093,
 10447,
 -1,
 1005262093,
 10383,
 1005534198,
 1004409865,
 10263,
 1005599731,
 1005458561,
 10295,
 1005665266,
 1005524166,
 10359,
 -1,
 1005589773,
 10487,
 -1,
 1005589773,
 10423,
 1005861877,
 1005524166,
 10327,
 -1,
 1005786381,
 10455,
 -1,
 1005786381,
 10391,
 1006058490,
 1005458561,
 10279,
 1006124025,
 1005982918,
 10343,
 -1,
 1006048525,
 10471,
 -1,
 1006048525,
 10407,
 1006320636,
 1005982918,
 10311,
 -1,
 1006245133,
 10439,
 -1,
 1006245133,
 10375,
 1006517261,
 1004344252,
 10251,
 1006582790,
 1006441481,
 10267,
 1006648323,
 1006507137,
 10299,
 1006713858,
 1006572742,
 10363,
 -1,
 1006638349,
 10491,
 -1,
 1006638349,
 10427,
 1006910469,
 1006572742,
 10331,
 -1,
 1006834957,
 10459,
 -1,
 1006834957,
 10395,
 1007107082,
 1006507137,
 10283,
 1007172617,
 1007031494,
 10347,
 -1,
 1007097101,
 10475,
 -1,
 1007097101,
 10411,
 1007369228,
 1007031494,
 10315,
 -1,
 1007293709,
 10443,
 -1,
 1007293709,
 10379,
 1007565845,
 1006441481,
 10259,
 1007631378,
 1007490177,
 10291,
 1007696913,
 1007555782,
 10355,
 -1,
 1007621389,
 10483,
 -1,
 1007621389,
 10419,
 1007893524,
 1007555782,
 10323,
 -1,
 1007817997,
 10451,
 -1,
 1007817997,
 10387,
 1008090137,
 1007490177,
 10275,
 1008155672,
 1008014534,
 10339,
 -1,
 1008080141,
 10467,
 -1,
 1008080141,
 10403,
 1008352283,
 1008014534,
 10307,
 -1,
 1008276749,
 10435,
 -1,
 1008276749,
 10371,
 1008548924,
 1004278604,
 10245,
 1008614445,
 1008473020,
 10253,
 1008679974,
 1008538633,
 10269,
 1008745507,
 1008604289,
 10301,
 1008811042,
 1008669894,
 10365,
 -1,
 1008735501,
 10493,
 -1,
 1008735501,
 10429,
 1009007653,
 1008669894,
 10333,
 -1,
 1008932109,
 10461,
 -1,
 1008932109,
 10397,
 1009204266,
 1008604289,
 10285,
 1009269801,
 1009128646,
 10349,
 -1,
 1009194253,
 10477,
 -1,
 1009194253,
 10413,
 1009466412,
 1009128646,
 10317,
 -1,
 1009390861,
 10445,
 -1,
 1009390861,
 10381,
 1009663029,
 1008538633,
 10261,
 1009728562,
 1009587329,
 10293,
 1009794097,
 1009652934,
 10357,
 -1,
 1009718541,
 10485,
 -1,
 1009718541,
 10421,
 1009990708,
 1009652934,
 10325,
 -1,
 1009915149,
 10453,
 -1,
 1009915149,
 10389,
 1010187321,
 1009587329,
 10277,
 1010252856,
 1010111686,
 10341,
 -1,
 1010177293,
 10469,
 -1,
 1010177293,
 10405,
 1010449467,
 1010111686,
 10309,
 -1,
 1010373901,
 10437,
 -1,
 1010373901,
 10373,
 1010646092,
 1008473020,
 10249,
 1010711621,
 1010570249,
 10265,
 1010777154,
 1010635905,
 10297,
 1010842689,
 1010701510,
 10361,
 -1,
 1010767117,
 10489,
 -1,
 1010767117,
 10425,
 1011039300,
 1010701510,
 10329,
 -1,
 1010963725,
 10457,
 -1,
 1010963725,
 10393,
 1011235913,
 1010635905,
 10281,
 1011301448,
 1011160262,
 10345,
 -1,
 1011225869,
 10473,
 -1,
 1011225869,
 10409,
 1011498059,
 1011160262,
 10313,
 -1,
 1011422477,
 10441,
 -1,
 1011422477,
 10377,
 1011694676,
 1010570249,
 10257,
 1011760209,
 1011618945,
 10289,
 1011825744,
 1011684550,
 10353,
 -1,
 1011750157,
 10481,
 -1,
 1011750157,
 10417,
 1012022355,
 1011684550,
 10321,
 -1,
 1011946765,
 10449,
 -1,
 1011946765,
 10385,
 1012218968,
 1011618945,
 10273,
 1012284503,
 1012143302,
 10337,
 -1,
 1012208909,
 10465,
 -1,
 1012208909,
 10401,
 1012481114,
 1012143302,
 10305,
 -1,
 1012405517,
 10433,
 -1,
 1012405517,
 10369,
 1012677787,
 1004212903,
 10242,
 1012743292,
 1012601676,
 10246,
 1012808813,
 1012667324,
 10254,
 1012874342,
 1012732937,
 10270,
 1012939875,
 1012798593,
 10302,
 1013005410,
 1012864198,
 10366,
 -1,
 1012929805,
 10494,
 -1,
 1012929805,
 10430,
 1013202021,
 1012864198,
 10334,
 -1,
 1013126413,
 10462,
 -1,
 1013126413,
 10398,
 1013398634,
 1012798593,
 10286,
 1013464169,
 1013322950,
 10350,
 -1,
 1013388557,
 10478,
 -1,
 1013388557,
 10414,
 1013660780,
 1013322950,
 10318,
 -1,
 1013585165,
 10446,
 -1,
 1013585165,
 10382,
 1013857397,
 1012732937,
 10262,
 1013922930,
 1013781633,
 10294,
 1013988465,
 1013847238,
 10358,
 -1,
 1013912845,
 10486,
 -1,
 1013912845,
 10422,
 1014185076,
 1013847238,
 10326,
 -1,
 1014109453,
 10454,
 -1,
 1014109453,
 10390,
 1014381689,
 1013781633,
 10278,
 1014447224,
 1014305990,
 10342,
 -1,
 1014371597,
 10470,
 -1,
 1014371597,
 10406,
 1014643835,
 1014305990,
 10310,
 -1,
 1014568205,
 10438,
 -1,
 1014568205,
 10374,
 1014840460,
 1012667324,
 10250,
 1014905989,
 1014764553,
 10266,
 1014971522,
 1014830209,
 10298,
 1015037057,
 1014895814,
 10362,
 -1,
 1014961421,
 10490,
 -1,
 1014961421,
 10426,
 1015233668,
 1014895814,
 10330,
 -1,
 1015158029,
 10458,
 -1,
 1015158029,
 10394,
 1015430281,
 1014830209,
 10282,
 1015495816,
 1015354566,
 10346,
 -1,
 1015420173,
 10474,
 -1,
 1015420173,
 10410,
 1015692427,
 1015354566,
 10314,
 -1,
 1015616781,
 10442,
 -1,
 1015616781,
 10378,
 1015889044,
 1014764553,
 10258,
 1015954577,
 1015813249,
 10290,
 1016020112,
 1015878854,
 10354,
 -1,
 1015944461,
 10482,
 -1,
 1015944461,
 10418,
 1016216723,
 1015878854,
 10322,
 -1,
 1016141069,
 10450,
 -1,
 1016141069,
 10386,
 1016413336,
 1015813249,
 10274,
 1016478871,
 1016337606,
 10338,
 -1,
 1016403213,
 10466,
 -1,
 1016403213,
 10402,
 1016675482,
 1016337606,
 10306,
 -1,
 1016599821,
 10434,
 -1,
 1016599821,
 10370,
 1016872123,
 1012601676,
 10244,
 1016937644,
 1016796092,
 10252,
 1017003173,
 1016861705,
 10268,
 1017068706,
 1016927361,
 10300,
 1017134241,
 1016992966,
 10364,
 -1,
 1017058573,
 10492,
 -1,
 1017058573,
 10428,
 1017330852,
 1016992966,
 10332,
 -1,
 1017255181,
 10460,
 -1,
 1017255181,
 10396,
 1017527465,
 1016927361,
 10284,
 1017593000,
 1017451718,
 10348,
 -1,
 1017517325,
 10476,
 -1,
 1017517325,
 10412,
 1017789611,
 1017451718,
 10316,
 -1,
 1017713933,
 10444,
 -1,
 1017713933,
 10380,
 1017986228,
 1016861705,
 10260,
 1018051761,
 1017910401,
 10292,
 1018117296,
 1017976006,
 10356,
 -1,
 1018041613,
 10484,
 -1,
 1018041613,
 10420,
 1018313907,
 1017976006,
 10324,
 -1,
 1018238221,
 10452,
 -1,
 1018238221,
 10388,
 1018510520,
 1017910401,
 10276,
 1018576055,
 1018434758,
 10340,
 -1,
 1018500365,
 10468,
 -1,
 1018500365,
 10404,
 1018772666,
 1018434758,
 10308,
 -1,
 1018696973,
 10436,
 -1,
 1018696973,
 10372,
 1018969291,
 1016796092,
 10248,
 1019034820,
 1018893321,
 10264,
 1019100353,
 1018958977,
 10296,
 1019165888,
 1019024582,
 10360,
 -1,
 1019090189,
 10488,
 -1,
 1019090189,
 10424,
 1019362499,
 1019024582,
 10328,
 -1,
 1019286797,
 10456,
 -1,
 1019286797,
 10392,
 1019559112,
 1018958977,
 10280,
 1019624647,
 1019483334,
 10344,
 -1,
 1019548941,
 10472,
 -1,
 1019548941,
 10408,
 1019821258,
 1019483334,
 10312,
 -1,
 1019745549,
 10440,
 -1,
 1019745549,
 10376,
 1020017875,
 1018893321,
 10256,
 1020083408,
 1019942017,
 10288,
 1020148943,
 1020007622,
 10352,
 -1,
 1020073229,
 10480,
 -1,
 1020073229,
 10416,
 1020345554,
 1020007622,
 10320,
 -1,
 1020269837,
 10448,
 -1,
 1020269837,
 10384,
 1020542167,
 1019942017,
 10272,
 1020607702,
 1020466374,
 10336,
 -1,
 1020531981,
 10464,
 -1,
 1020531981,
 10400,
 1020804313,
 1020466374,
 10304,
 -1,
 1020728589,
 10432,
 -1,
 1020728589,
 10368,
 -1,
 1004153469,
 10240,
 1021066462,
 1004114932,
 -1,
 -49955,
 1020997727,
 9099,
 -1,
 1021060942,
 166,
 -1,
 1021004926,
 728,
 1021328991,
 1004070661,
 -1,
 1021394193,
 1021252980,
 -1,
 1021459699,
 1021353961,
 -1,
 1021525231,
 1021415823,
 -1,
 1021590763,
 1021493497,
 -1,
 1021656296,
 1021556511,
 118801,
 1021771775,
 1021575168,
 -1,
 -49945,
 1021676409,
 118865,
 -1,
 1021721071,
 118802,
 1021968383,
 1021600129,
 -1,
 -49942,
 1021887754,
 118957,
 -1,
 1021952681,
 118866,
 1022115054,
 1021523971,
 -1,
 -49939,
 1022069625,
 118916,
 -1,
 1022107990,
 118818,
 -1,
 1022084738,
 118819,
 1022377202,
 1021463239,
 -1,
 -49935,
 1022354364,
 118835,
 -1,
 1022390777,
 118797,
 -1,
 1022327408,
 118917,
 1022639359,
 1021421908,
 -1,
 1022704892,
 1022587650,
 -1,
 -49930,
 1022683205,
 119022,
 -49929,
 1022745729,
 119018,
 -49928,
 1022795854,
 119017,
 -49927,
 1022856307,
 119023,
 -49926,
 1022915000,
 119021,
 -49925,
 1022972676,
 119019,
 -1,
 1023031435,
 119020,
 1023279103,
 1022645789,
 -1,
 -49922,
 1023197879,
 118899,
 -1,
 1023248607,
 118935,
 1023425804,
 1022580268,
 -1,
 1023491331,
 1023386941,
 -1,
 -49918,
 1023432279,
 118945,
 -1,
 1023484342,
 118938,
 1023687942,
 1023443739,
 -1,
 -49915,
 1023658741,
 118941,
 -1,
 1023720412,
 118942,
 1023884553,
 1023628882,
 -1,
 -49912,
 1023842994,
 118944,
 -1,
 1023893887,
 118943,
 1024131071,
 1023811983,
 -1,
 -49909,
 1024039602,
 118939,
 -1,
 1024090495,
 118940,
 1024327679,
 1023379679,
 -1,
 1024343312,
 1024247785,
 -1,
 -49905,
 1024294962,
 118876,
 -1,
 1024357200,
 118882,
 -1,
 1024271715,
 118824,
 1024605500,
 1021341832,
 -1,
 1024671008,
 1024542754,
 -1,
 1024736538,
 1024639765,
 118800,
 1024851967,
 1024655360,
 -1,
 1024867609,
 1024756605,
 -1,
 -49897,
 1024820285,
 119024,
 -49896,
 1024881025,
 119026,
 -1,
 1024925437,
 118862,
 -1,
 1024794966,
 118812,
 1025245183,
 1024655360,
 -1,
 1025260831,
 1025149821,
 -1,
 -49891,
 1025213501,
 119025,
 -49890,
 1025274241,
 119027,
 -1,
 1025318653,
 118863,
 -1,
 1025188182,
 118811,
 1025588525,
 1024633172,
 -1,
 1025654060,
 1025516822,
 -1,
 1025719593,
 1025578356,
 -1,
 1025785128,
 1025638400,
 -1,
 1025850663,
 1025709428,
 -1,
 -49882,
 1025813306,
 118913,
 -1,
 1025866902,
 118914,
 -1,
 1025805177,
 118915,
 -1,
 1025753877,
 118834,
 1026228223,
 1025675663,
 -1,
 -49877,
 1026156156,
 118868,
 -1,
 1026192089,
 118860,
 -1,
 1025590867,
 118796,
 1026440498,
 1025544591,
 -1,
 1026506032,
 1026396049,
 118842,
 -1,
 1026424904,
 118850,
 -49871,
 1026478115,
 118858,
 -1,
 1026602061,
 118921,
 1026768182,
 1026389392,
 118820,
 1026883583,
 1026686976,
 -1,
 -49867,
 1026781569,
 119028,
 -1,
 1026825981,
 118911,
 1027030331,
 1026696300,
 -1,
 1027095866,
 1026958808,
 -1,
 -49863,
 1027063176,
 118906,
 -1,
 1027083196,
 118839,
 -1,
 1027038673,
 118791,
 -1,
 1027007974,
 118881,
 1027423579,
 1024571167,
 -1,
 1027489098,
 1027368589,
 -1,
 1027554628,
 1027458713,
 119006,
 1027670015,
 1027473408,
 -1,
 1027685699,
 1027588820,
 -1,
 -49854,
 1027650221,
 119008,
 -1,
 1027689475,
 119009,
 -1,
 1027619396,
 119007,
 1027997695,
 1027482284,
 119010,
 1028063231,
 1027866624,
 -1,
 1028078921,
 1027982036,
 -1,
 -49848,
 1028043437,
 119012,
 -1,
 1028082691,
 119013,
 -1,
 1028012612,
 119011,
 1028341075,
 1027466222,
 -1,
 1028406609,
 1028294879,
 -1,
 1028472144,
 1028331739,
 -1,
 -49842,
 1028426617,
 118885,
 -49841,
 1028490320,
 118827,
 -1,
 1028530518,
 118826,
 -1,
 1028410712,
 118803,
 1028849663,
 1028371300,
 118886,
 -1,
 1028769783,
 118792,
 1028930904,
 1028309716,
 -1,
 1028996438,
 1028859398,
 118910,
 -1,
 1028915670,
 118815,
 -49833,
 1028958739,
 118852,
 -1,
 1029072256,
 119016,
 1029258586,
 1028867474,
 118825,
 -1,
 1029178893,
 118889,
 -1,
 1029187120,
 118813,
 1029455228,
 1027383273,
 -1,
 1029520742,
 1029422044,
 -1,
 1029586275,
 1029460137,
 -1,
 1029651808,
 1029540063,
 118841,
 -1,
 1029572109,
 118874,
 -49823,
 1029620385,
 118897,
 -49822,
 1029742862,
 118895,
 -1,
 1029799901,
 118892,
 1030029311,
 1029534552,
 -1,
 -49819,
 1029936429,
 118807,
 -1,
 1029988735,
 118784,
 1030176111,
 1029456007,
 -1,
 1030241644,
 1030145093,
 -1,
 1030307179,
 1030210260,
 -1,
 -49814,
 1030263808,
 118859,
 -1,
 1030316415,
 118857,
 -1,
 1030258738,
 118849,
 1030569326,
 1030190486,
 118840,
 -1,
 1030489613,
 118861,
 -1,
 1030533892,
 118786,
 1030765945,
 1030103132,
 -1,
 1030831480,
 1030691264,
 -1,
 1030897013,
 1030781890,
 118793,
 1031012351,
 1030815744,
 -1,
 -49804,
 1030916985,
 118878,
 -1,
 1030955350,
 118846,
 1031208959,
 1030822716,
 -1,
 -49801,
 1031113593,
 118879,
 -1,
 1031151958,
 118845,
 -1,
 1030775551,
 118814,
 1031471103,
 1030709959,
 -1,
 -49797,
 1031375737,
 118873,
 -1,
 1031414102,
 118822,
 1031617946,
 1029394006,
 -1,
 1031683477,
 1031587606,
 -1,
 1031749000,
 1031616835,
 -1,
 1031814532,
 1031702751,
 -1,
 1031880067,
 1031758209,
 -1,
 -49790,
 1031827841,
 118977,
 -1,
 1031872253,
 118978,
 -1,
 1031806285,
 118971,
 -49787,
 1031792709,
 118976,
 -49786,
 1032101966,
 118970,
 -49785,
 1032155576,
 118975,
 -1,
 1032206475,
 118973,
 1032404363,
 1031716186,
 -1,
 -49782,
 1032337742,
 118974,
 -1,
 1032400878,
 118982,
 1032600974,
 1032358111,
 -1,
 -49779,
 1032537896,
 118983,
 -1,
 1032593312,
 118972,
 1032797585,
 1032552681,
 -1,
 -49776,
 1032750783,
 118980,
 -1,
 1032796529,
 118979,
 1032994195,
 1032724822,
 118836,
 -1,
 1032913692,
 118969,
 -49772,
 1032937960,
 118987,
 -1,
 1033062203,
 118988,
 1033256345,
 1031609942,
 -1,
 -49769,
 1033225726,
 118958,
 -49768,
 1033275071,
 118959,
 -1,
 1033320817,
 118960,
 -1,
 1033199856,
 118981,
 1033584058,
 1031550496,
 -1,
 1033649592,
 1033527679,
 -1,
 1033715109,
 1033587381,
 -1,
 1033780642,
 1033683668,
 -1,
 1033846177,
 1033743865,
 -1,
 -49760,
 1033816221,
 118990,
 -1,
 1033852576,
 118995,
 -1,
 1033784246,
 118991,
 -49757,
 1033733845,
 118993,
 -49756,
 1034041770,
 118994,
 -1,
 1034100725,
 118992,
 1034304941,
 1033655011,
 -1,
 1034370476,
 1034262727,
 118930,
 1034485759,
 1034291297,
 -1,
 1034501547,
 1034363351,
 -1,
 -49750,
 1034449281,
 118931,
 -1,
 1034493693,
 118932,
 -1,
 1034434623,
 118933,
 -1,
 1034332818,
 119014,
 1034829237,
 1034229108,
 -1,
 1034894772,
 1034797238,
 -1,
 1034960306,
 1034821639,
 -1,
 -49743,
 1034905027,
 119002,
 -1,
 1034962084,
 119003,
 -49741,
 1034929817,
 119005,
 -1,
 1035090415,
 119004,
 -1,
 1034857952,
 118937,
 1035353527,
 1034789922,
 118918,
 -1,
 1035272672,
 118912,
 -1,
 1035293349,
 119015,
 -49735,
 1033627178,
 118831,
 -1,
 1035477830,
 118785,
 1035681241,
 1033552596,
 -1,
 1035746763,
 1035643220,
 -1,
 1035812295,
 1035703545,
 -1,
 1035877826,
 1035765985,
 -1,
 1035943361,
 1035801972,
 -1,
 -49728,
 1035905850,
 118838,
 -1,
 1035959446,
 118851,
 -1,
 1035897721,
 118883,
 1036205509,
 1035837417,
 -1,
 -49724,
 1036172309,
 118891,
 -1,
 1036198118,
 118894,
 -49722,
 1036173985,
 118896,
 -1,
 1036353501,
 118893,
 1036582911,
 1035755903,
 -1,
 -49719,
 1036493858,
 118919,
 -49718,
 1036539485,
 118934,
 -1,
 1036588404,
 118832,
 1036795348,
 1035688075,
 -1,
 1036860883,
 1036730503,
 -1,
 1036926418,
 1036812338,
 118829,
 1036991953,
 1036896507,
 -1,
 -49712,
 1036968874,
 118903,
 -1,
 1037024885,
 118902,
 -1,
 1036911054,
 118904,
 -1,
 1036891996,
 118905,
 -1,
 1036807558,
 118804,
 1037385176,
 1036730503,
 -1,
 -49706,
 1037355720,
 118920,
 -49705,
 1037418480,
 118833,
 -1,
 1037465800,
 118799,
 -1,
 1037330369,
 118823,
 1037712880,
 1035632613,
 -1,
 1037778415,
 1037640421,
 -1,
 1037843938,
 1037746900,
 -1,
 1037909471,
 1037807097,
 -1,
 -49698,
 1037879940,
 118950,
 -1,
 1037914491,
 118951,
 1038155775,
 1037847491,
 -1,
 -49695,
 1038055610,
 118953,
 -1,
 1038115589,
 118952,
 1038302697,
 1037803497,
 -1,
 1038368230,
 1038267613,
 -1,
 -49691,
 1038342336,
 118962,
 -1,
 1038399307,
 118946,
 1038614527,
 1038316681,
 -1,
 -49688,
 1038534127,
 118963,
 -1,
 1038574341,
 118955,
 1038761452,
 1038228459,
 -1,
 -49685,
 1038722750,
 118947,
 -1,
 1038760005,
 118949,
 -49683,
 1038735552,
 118961,
 -49682,
 1038907578,
 118954,
 -1,
 1038956613,
 118948,
 -1,
 1037723080,
 118871,
 1039220226,
 1037689838,
 -1,
 1039285756,
 1039159078,
 -1,
 1039351289,
 1039252751,
 -1,
 1039416822,
 1039321841,
 -1,
 -49675,
 1039386781,
 118989,
 -1,
 1039423136,
 118999,
 -49673,
 1039369941,
 118997,
 -49672,
 1039546794,
 118998,
 -1,
 1039605749,
 118996,
 1039859711,
 1039304929,
 -1,
 -49669,
 1039757697,
 118908,
 -1,
 1039802109,
 118909,
 1040056319,
 1039245289,
 -1,
 1040072193,
 1039962511,
 -1,
 1040137728,
 1040020194,
 118794,
 -1,
 1040057173,
 118795,
 -1,
 1040102829,
 118867,
 -1,
 1040039034,
 118864,
 1040399893,
 1039160035,
 -1,
 1040465425,
 1040357366,
 -1,
 1040530958,
 1040406045,
 -1,
 1040596493,
 1040484577,
 -1,
 1040662025,
 1040556359,
 -1,
 -49656,
 1040595007,
 118929,
 -1,
 1040654798,
 118928,
 1040858636,
 1040616317,
 -1,
 -49653,
 1040806273,
 119029,
 -1,
 1040850685,
 118927,
 -1,
 1040785750,
 118806,
 -1,
 1040564919,
 118898,
 1041235967,
 1040500469,
 -1,
 -49648,
 1041119733,
 118965,
 -1,
 1041178638,
 118964,
 1041382932,
 1040402350,
 -1,
 -49645,
 1041360226,
 119001,
 -1,
 1041381738,
 119000,
 -1,
 1041347667,
 118853,
 1041645091,
 1040355727,
 -1,
 1041710620,
 1041621870,
 -1,
 1041776155,
 1041629184,
 -1,
 -49639,
 1041730425,
 118856,
 -49638,
 1041778098,
 118787,
 -1,
 1041840623,
 118788,
 -1,
 1041719684,
 118816,
 1042103839,
 1041688213,
 -1,
 -49634,
 1042058105,
 118901,
 -1,
 1042096470,
 118828,
 1042300450,
 1042053840,
 -1,
 -49631,
 1042254713,
 118855,
 -1,
 1042293078,
 118805,
 -1,
 1042252272,
 118875,
 1042562609,
 1041588607,
 -1,
 1042628139,
 1042515089,
 -1,
 1042693674,
 1042566742,
 -1,
 1042759209,
 1042663185,
 -1,
 -49624,
 1042715949,
 118968,
 -1,
 1042748788,
 118837,
 -1,
 1042716266,
 118967,
 -1,
 1042626875,
 118936,
 1043086896,
 1042593567,
 -1,
 1043152431,
 1043043632,
 -1,
 -49618,
 1043106681,
 118854,
 -1,
 1043145046,
 118810,
 -1,
 1043077582,
 118956,
 -1,
 1043017534,
 118847,
 1043480124,
 1042497671,
 -1,
 1043545653,
 1043449291,
 -1,
 -49612,
 1043505422,
 118880,
 -1,
 1043538363,
 118900,
 1043742264,
 1043499231,
 -1,
 -49609,
 1043675878,
 118907,
 -1,
 1043735282,
 118966,
 -49607,
 1043719085,
 118798,
 -49606,
 1043898864,
 118888,
 -49605,
 1043952703,
 118869,
 -1,
 1044017900,
 118884,
 1044201031,
 1043428184,
 -1,
 1044266566,
 1044136071,
 -1,
 1044332101,
 1044211443,
 -1,
 1044397634,
 1044300500,
 -1,
 -49599,
 1044361745,
 118924,
 -1,
 1044400882,
 118925,
 -49597,
 1044342499,
 118926,
 -49596,
 1044531125,
 118922,
 -1,
 1044594807,
 118923,
 -1,
 1044285096,
 118830,
 -1,
 1044243817,
 118877,
 1044921938,
 1044131618,
 -1,
 1044987468,
 1044886487,
 -1,
 -49590,
 1044965473,
 118984,
 -49589,
 1045020434,
 118986,
 -1,
 1045066358,
 118985,
 1045249615,
 1044945087,
 -1,
 -49586,
 1045203833,
 118887,
 -1,
 1045242198,
 118843,
 1045495807,
 1045175520,
 -1,
 -49583,
 1045402925,
 118808,
 -1,
 1045455231,
 118870,
 1045642842,
 1044895676,
 -1,
 1045708377,
 1045605568,
 -1,
 1045773912,
 1045626880,
 -1,
 -49578,
 1045728121,
 118872,
 -49577,
 1045775794,
 118789,
 -1,
 1045838319,
 118790,
 -1,
 1045717380,
 118817,
 -1,
 1045678006,
 118809,
 1046167133,
 1045604692,
 -1,
 -49572,
 1046105432,
 118821,
 -1,
 1046159303,
 118844,
 -49570,
 1046143901,
 118890,
 -1,
 1046317449,
 118848,
 1046495101,
 1021252980,
 -1,
 1046560519,
 1046442840,
 -1,
 1046626047,
 1046505632,
 -1,
 1046691490,
 1046575578,
 -1,
 1046756970,
 1046659796,
 -1,
 1046822505,
 1046680948,
 6946,
 1046937599,
 1046740992,
 -1,
 -49561,
 1046856802,
 6947,
 -49560,
 1046906987,
 6942,
 -1,
 1046967741,
 6941,
 -1,
 1046800439,
 6983,
 1047215727,
 1046710495,
 -1,
 1047281261,
 1047139700,
 6950,
 -1,
 1047202219,
 6945,
 -49554,
 1047258154,
 6940,
 -1,
 1047352068,
 6935,
 1047543412,
 1047163016,
 -1,
 1047608947,
 1047467380,
 6931,
 -49550,
 1047547514,
 6981,
 -1,
 1047594429,
 6932,
 -1,
 1047551984,
 6982,
 1047871098,
 1047475851,
 6948,
 1047986175,
 1047791034,
 -1,
 1048002169,
 1047909847,
 -1,
 -49544,
 1047953526,
 6944,
 -1,
 1047993407,
 6943,
 -1,
 1047926837,
 6949,
 1048264319,
 1047795060,
 -1,
 1048329853,
 1048211767,
 6917,
 -1,
 1048251069,
 6918,
 -49538,
 1048298184,
 6987,
 -1,
 1048405423,
 6928,
 1048592003,
 1048229785,
 6962,
 1048707071,
 1048513011,
 -1,
 -49534,
 1048617038,
 6961,
 -1,
 1048662788,
 6960,
 1048854150,
 1048553903,
 6957,
 1048969215,
 1048775100,
 6923,
 -1,
 1048840893,
 6924,
 1049050761,
 1048802221,
 6958,
 1049165823,
 1048970614,
 6925,
 -1,
 1049037501,
 6926,
 1049247371,
 1049022615,
 6921,
 -1,
 1049168573,
 6922,
 1049378445,
 1049206862,
 6951,
 -1,
 1049298158,
 6952,
 1049509519,
 1049334766,
 6929,
 -1,
 1049430717,
 6930,
 1049640593,
 1049456427,
 6938,
 -1,
 1049560282,
 6939,
 1049771667,
 1049585071,
 6919,
 -1,
 1049692861,
 6920,
 1049902741,
 1049711364,
 6933,
 -1,
 1049822231,
 6934,
 1050033816,
 1049837703,
 -1,
 -49513,
 1049981239,
 6927,
 -1,
 1050037882,
 6984,
 1050230426,
 1049963835,
 6936,
 -1,
 1050150191,
 6937,
 1050361500,
 1050158760,
 6953,
 -1,
 1050281239,
 6954,
 -49507,
 1050339163,
 6986,
 -49506,
 1050469418,
 6956,
 -49505,
 1050533168,
 6959,
 -49504,
 1050597663,
 6985,
 -49503,
 1050640434,
 6955,
 -1,
 1050695849,
 6963,
 1050885835,
 1046644879,
 -1,
 1050951345,
 1050818080,
 -1,
 1051016875,
 1050875252,
 -1,
 1051082409,
 1050971063,
 7012,
 1051197439,
 1051000832,
 -1,
 -49496,
 1051116063,
 7013,
 -1,
 1051153477,
 7018,
 -49494,
 1051027623,
 7017,
 -1,
 1051281310,
 7015,
 1051475630,
 1050951815,
 -1,
 -49491,
 1051447921,
 7016,
 -1,
 1051495351,
 7010,
 -49489,
 1051447921,
 7011,
 -49488,
 1051629075,
 7009,
 -1,
 1051682983,
 7014,
 1051868860,
 1050882564,
 -1,
 1051934391,
 1051816409,
 -1,
 1051999925,
 1051906226,
 7021,
 -1,
 1051921851,
 7024,
 1052180479,
 1051949680,
 7022,
 -1,
 1052052923,
 7025,
 -49480,
 1051903221,
 7019,
 -49479,
 1052209082,
 7023,
 -49478,
 1052268109,
 7027,
 -49477,
 1052329863,
 7020,
 -1,
 1052387449,
 7026,
 1052589764,
 1051818017,
 -1,
 1052655297,
 1052546886,
 -1,
 -49473,
 1052627569,
 7033,
 -49472,
 1052666023,
 7036,
 -1,
 1052712544,
 7032,
 1052966911,
 1052586424,
 -1,
 -49469,
 1052889236,
 7035,
 -1,
 1052907968,
 7034,
 1053163519,
 1052553295,
 -1,
 1053179592,
 1053071160,
 -1,
 -49465,
 1053151274,
 7028,
 -1,
 1053169811,
 7029,
 1053425663,
 1053110722,
 -1,
 -49462,
 1053347988,
 7030,
 -1,
 1053366720,
 7031,
 1053572829,
 1050860726,
 -1,
 1053638355,
 1053541076,
 -1,
 1053703890,
 1053563802,
 6974,
 1053818879,
 1053622272,
 -1,
 1053834961,
 1053732061,
 6975,
 -1,
 1053756093,
 6977,
 -1,
 1053803731,
 6976,
 -1,
 1053639457,
 6965,
 1054097109,
 1053610343,
 6966,
 -1,
 1054018039,
 6967,
 1054228183,
 1054065072,
 6968,
 -1,
 1054147727,
 6969,
 1054359257,
 1054190002,
 6970,
 -1,
 1054280381,
 6971,
 1054490331,
 1054319182,
 6978,
 -1,
 1054411453,
 6979,
 1054670847,
 1054438320,
 6972,
 -1,
 1054542525,
 6973,
 1054752491,
 1053505944,
 -1,
 1054818017,
 1054720724,
 -1,
 -49440,
 1054794127,
 6994,
 -1,
 1054826582,
 6995,
 1055014628,
 1054783263,
 -1,
 -49437,
 1054961390,
 6998,
 -1,
 1055018114,
 6999,
 1055211239,
 1054953046,
 -1,
 -49434,
 1055169520,
 6996,
 -1,
 1055223415,
 6997,
 -49432,
 1055188885,
 6992,
 -49431,
 1055364543,
 6993,
 -49430,
 1055427772,
 7001,
 -1,
 1055474999,
 7000,
 1055670003,
 1054719024,
 -1,
 1055735535,
 1055641963,
 -1,
 -49426,
 1055698513,
 6912,
 -1,
 1055731096,
 6913,
 -49424,
 1055703583,
 6915,
 -49423,
 1055894767,
 6964,
 -49422,
 1055927982,
 6914,
 -1,
 1055992257,
 6916,
 1056194296,
 1055629390,
 -1,
 1056259831,
 1056145381,
 -1,
 -49418,
 1056196493,
 7008,
 -1,
 1056249821,
 7003,
 -1,
 1056214936,
 7002,
 1056521981,
 1056124464,
 -1,
 1056587516,
 1056481358,
 -1,
 -49413,
 1056550135,
 7007,
 -1,
 1056606290,
 7005,
 -1,
 1056554095,
 7006,
 -49410,
 1056497504,
 7004,
 -1,
 1056774150,
 6980,
 1057030143,
 1046576324,
 -1,
 1057046278,
 1056948950,
 -1,
 1057111813,
 1056975707,
 9744,
 1057226751,
 1057033251,
 -1,
 -49404,
 1057153796,
 9746,
 -1,
 1057173360,
 9745,
 -1,
 1057088260,
 10007,
 -1,
 1057002850,
 10057,
 1057505147,
 1046513716,
 -1,
 1057570672,
 1057454554,
 -1,
 1057636124,
 1057523935,
 -1,
 1057701646,
 1057582889,
 -1,
 -49396,
 1057672897,
 42686,
 -49395,
 1057702695,
 42694,
 -1,
 1057757278,
 42674,
 1057963794,
 1057641187,
 -1,
 -49392,
 1057911626,
 42707,
 -49391,
 1057968900,
 42708,
 -1,
 1058018676,
 42709,
 1058225940,
 1057934922,
 42685,
 -1,
 1058150457,
 42684,
 1058357015,
 1058194132,
 -1,
 -49386,
 1058330490,
 42731,
 -1,
 1058358055,
 42695,
 -49384,
 1058334064,
 42664,
 -49383,
 1058519634,
 42691,
 -49382,
 1058562431,
 42703,
 -49381,
 1058616989,
 42673,
 -1,
 1058674036,
 42715,
 1058881321,
 1057583240,
 -1,
 1058946848,
 1058836879,
 42719,
 -49377,
 1058921722,
 42734,
 -1,
 1058952409,
 42735,
 1059143460,
 1058881671,
 -1,
 -49374,
 1059116942,
 42692,
 -49373,
 1059177172,
 42683,
 -1,
 1059227871,
 42706,
 -49371,
 1059120334,
 42682,
 -49370,
 1059376714,
 42659,
 -49369,
 1059430478,
 42729,
 -49368,
 1059479935,
 42725,
 -1,
 1059526004,
 42657,
 1059733300,
 1058832357,
 42675,
 1059798829,
 1059668103,
 -1,
 -49364,
 1059752159,
 42722,
 -1,
 1059799850,
 42671,
 1059995440,
 1059726966,
 -1,
 -49361,
 1059931889,
 42720,
 -1,
 1059984887,
 42727,
 -49359,
 1059966538,
 42677,
 -49358,
 1060147599,
 42726,
 -49357,
 1060200831,
 42702,
 -1,
 1060246900,
 42723,
 1060454206,
 1059698463,
 -1,
 1060519738,
 1060395147,
 -1,
 -49353,
 1060490826,
 42688,
 -49352,
 1060540815,
 42710,
 -49351,
 1060595099,
 42678,
 -1,
 1060654187,
 42680,
 -49349,
 1060493178,
 42676,
 -49348,
 1060790655,
 42679,
 -49347,
 1060850795,
 42681,
 -1,
 1060904097,
 42732,
 1061109576,
 1060415828,
 -1,
 1061175107,
 1061044359,
 -1,
 -49343,
 1061148558,
 42704,
 -49342,
 1061193951,
 42721,
 -1,
 1061240967,
 42661,
 1061437254,
 1061118335,
 -1,
 -49339,
 1061380479,
 42668,
 -1,
 1061438247,
 42669,
 -49337,
 1061408330,
 42700,
 -1,
 1061558329,
 42705,
 1061764945,
 1061068777,
 -1,
 1061830476,
 1061736010,
 -1,
 -49333,
 1061765255,
 42696,
 -1,
 1061820473,
 42711,
 1062027087,
 1061765255,
 -1,
 -49330,
 1062000526,
 42693,
 -1,
 1062027399,
 42698,
 -49328,
 1061970303,
 42717,
 -1,
 1062147444,
 42667,
 1062354777,
 1061733076,
 -1,
 1062420309,
 1062289543,
 -1,
 -49324,
 1062388436,
 42728,
 -1,
 1062439135,
 42730,
 1062616920,
 1062344052,
 -1,
 -49321,
 1062551687,
 42662,
 -1,
 1062606196,
 42672,
 -1,
 1062560127,
 42724,
 1062879071,
 1062302552,
 -1,
 -49317,
 1062850122,
 42701,
 -49316,
 1062901747,
 42718,
 -49315,
 1062953343,
 42716,
 -49314,
 1063011118,
 42670,
 -1,
 1063064948,
 42666,
 1063272292,
 1062817366,
 -1,
 -49311,
 1063243338,
 42712,
 -49310,
 1063294150,
 42713,
 -49309,
 1063338791,
 42699,
 -1,
 1063392777,
 42733,
 1063599976,
 1063248878,
 -1,
 -49306,
 1063572860,
 42689,
 -49305,
 1063622643,
 42687,
 -1,
 1063654772,
 42690,
 1063862123,
 1063574792,
 -1,
 -49302,
 1063833614,
 42697,
 -1,
 1063851380,
 42714,
 -49300,
 1063833162,
 42658,
 -49299,
 1064014223,
 42663,
 -49298,
 1064067455,
 42665,
 -49297,
 1064125223,
 42660,
 -1,
 1064179060,
 42656,
 1064386423,
 1057501672,
 -1,
 1064451958,
 1064337381,
 -1,
 1064517493,
 1064380841,
 -1,
 -49292,
 1064488126,
 42737,
 -1,
 1064530610,
 42736,
 -1,
 1064468530,
 42741,
 -1,
 1064402194,
 42740,
 -49288,
 1064352094,
 42742,
 -49287,
 1064806590,
 42743,
 -49286,
 1064865104,
 42738,
 -1,
 1064915650,
 42739,
 -49284,
 1057470634,
 9918,
 -1,
 1065038128,
 10155,
 1065238677,
 1046450575,
 -1,
 1065304122,
 1065214729,
 -1,
 1065369528,
 1065251672,
 -1,
 1065435053,
 1065313512,
 -1,
 1065500560,
 1065367072,
 -1,
 1065566091,
 1065456015,
 -1,
 1065631624,
 1065541966,
 9591,
 1065746431,
 1065549946,
 -1,
 -49274,
 1065660001,
 9484,
 -49273,
 1065711237,
 9488,
 -1,
 1065770701,
 9516,
 1066008575,
 1065602883,
 -1,
 -49270,
 1065933359,
 9550,
 -1,
 1065967309,
 9548,
 1066205183,
 1065509394,
 -1,
 1066221455,
 1066128473,
 -1,
 -49266,
 1066184694,
 9585,
 -1,
 1066235828,
 9586,
 -1,
 1066153001,
 9587,
 1066483607,
 1065472772,
 9589,
 1066598399,
 1066401914,
 -1,
 1066614677,
 1066489995,
 -1,
 -49260,
 1066572024,
 9524,
 -1,
 1066615252,
 9597,
 -49258,
 1066577505,
 9492,
 -1,
 1066759813,
 9496,
 1066942364,
 1066457647,
 9474,
 1067057151,
 1066860666,
 -1,
 -49254,
 1066970721,
 9500,
 -49253,
 1067021957,
 9508,
 -1,
 1067081421,
 9532,
 1067270051,
 1066869025,
 -1,
 1067335584,
 1067242251,
 -1,
 -49249,
 1067298401,
 9584,
 -1,
 1067349637,
 9583,
 1067581439,
 1067269690,
 -1,
 -49246,
 1067495009,
 9581,
 -1,
 1067546245,
 9582,
 1067728806,
 1067240294,
 -1,
 -49243,
 1067702831,
 9478,
 -1,
 1067736781,
 9476,
 1067925417,
 1067689971,
 -1,
 -49240,
 1067899439,
 9482,
 -1,
 1067933389,
 9480,
 1068122027,
 1067873925,
 9588,
 -1,
 1068040393,
 9596,
 -49236,
 1068084833,
 9590,
 -1,
 1068195533,
 9472,
 1068433407,
 1065370526,
 -1,
 1068449714,
 1068333741,
 -1,
 -49232,
 1068423893,
 9546,
 -49231,
 1068487520,
 9530,
 -1,
 1068514949,
 9522,
 1068711862,
 1068391354,
 -1,
 -49228,
 1068686052,
 9533,
 -49227,
 1068749772,
 9525,
 -1,
 1068777207,
 9517,
 -49225,
 1068684166,
 9539,
 -1,
 1068908205,
 9541,
 1069105123,
 1065302724,
 -1,
 1069170644,
 1069080913,
 -1,
 1069236163,
 1069120146,
 -1,
 1069301694,
 1069198951,
 -1,
 -49219,
 1069273952,
 9505,
 -1,
 1069308818,
 9485,
 1069498305,
 1069250186,
 -1,
 -49216,
 1069470560,
 9513,
 -1,
 1069505426,
 9489,
 -49214,
 1069470628,
 9543,
 -1,
 1069637442,
 9519,
 1069825996,
 1069177759,
 -1,
 1069891527,
 1069788775,
 -1,
 -49210,
 1069863884,
 9503,
 -1,
 1069906572,
 9486,
 1070088138,
 1069840010,
 -1,
 -49207,
 1070060492,
 9511,
 -1,
 1070103180,
 9490,
 -49205,
 1070060472,
 9537,
 -1,
 1070227283,
 9520,
 1070415824,
 1069792421,
 -1,
 -49202,
 1070378747,
 9554,
 -49201,
 1070429913,
 9557,
 -1,
 1070489356,
 9572,
 1070727167,
 1070349399,
 -1,
 -49198,
 1070641129,
 9555,
 -49197,
 1070692245,
 9558,
 -1,
 1070751588,
 9573,
 1070989311,
 1069141801,
 -1,
 1071005658,
 1070914095,
 9553,
 1071120383,
 1070923898,
 -1,
 -49192,
 1071033953,
 9568,
 -49191,
 1071085189,
 9571,
 -1,
 1071144653,
 9580,
 1071333342,
 1070977803,
 -1,
 -49188,
 1071296097,
 9562,
 -49187,
 1071347333,
 9565,
 -1,
 1071406797,
 9577,
 1071595490,
 1071267386,
 -1,
 -49184,
 1071558241,
 9556,
 -49183,
 1071609477,
 9559,
 -1,
 1071668941,
 9574,
 -1,
 1071537869,
 9552,
 1071923203,
 1069046680,
 -1,
 1071988717,
 1071856324,
 -1,
 1072054250,
 1071964494,
 9595,
 1072168959,
 1071972474,
 -1,
 -49176,
 1072082529,
 9487,
 -49175,
 1072133765,
 9491,
 -1,
 1072193229,
 9523,
 1072431103,
 1072025411,
 -1,
 -49172,
 1072355887,
 9551,
 -1,
 1072389837,
 9549,
 1072578548,
 1071960836,
 9593,
 1072693247,
 1072496762,
 -1,
 1072709618,
 1072591704,
 -1,
 -49167,
 1072653550,
 9599,
 -1,
 1072710554,
 9499,
 -49165,
 1072672353,
 9495,
 -1,
 1072848589,
 9531,
 1073037305,
 1072552495,
 9475,
 1073151999,
 1072955514,
 -1,
 -49161,
 1073065569,
 9507,
 -49160,
 1073116805,
 9515,
 -1,
 1073176269,
 9547,
 1073364988,
 1073007462,
 -1,
 -49157,
 1073338927,
 9479,
 -1,
 1073372877,
 9477,
 1073561599,
 1073326067,
 -1,
 -49154,
 1073535535,
 9483,
 -1,
 1073569485,
 9481,
 1073758209,
 1073510021,
 9592,
 -1,
 1073676516,
 9598,
 -49150,
 1073720929,
 9594,
 -1,
 1073831629,
 9473,
 1074020382,
 1071895303,
 -1,
 1074085901,
 1073969810,
 -1,
 1074151432,
 1074048615,
 -1,
 -49145,
 1074092946,
 9493,
 -1,
 1074151045,
 9506,
 1074348043,
 1074099850,
 -1,
 -49142,
 1074289554,
 9497,
 -1,
 1074347653,
 9514,
 -49140,
 1074290498,
 9527,
 -1,
 1074478795,
 9544,
 1074675734,
 1074027423,
 -1,
 1074741265,
 1074638439,
 -1,
 -49136,
 1074690700,
 9494,
 -1,
 1074740983,
 9502,
 1074937876,
 1074689674,
 -1,
 -49133,
 1074887308,
 9498,
 -1,
 1074937591,
 9510,
 -49131,
 1074880339,
 9528,
 -1,
 1075068641,
 9536,
 1075265562,
 1074642085,
 -1,
 -49128,
 1075228411,
 9560,
 -49127,
 1075279577,
 9563,
 -1,
 1075339020,
 9575,
 1075576831,
 1075199063,
 -1,
 -49124,
 1075490793,
 9561,
 -49123,
 1075541909,
 9564,
 -1,
 1075601252,
 9576,
 1075789871,
 1073994296,
 -1,
 1075855395,
 1075756197,
 -1,
 -49119,
 1075818235,
 9566,
 -49118,
 1075869401,
 9569,
 -1,
 1075928844,
 9578,
 1076117543,
 1075804818,
 -1,
 -49115,
 1076080485,
 9501,
 -49114,
 1076131644,
 9509,
 -1,
 1076191042,
 9535,
 1076379691,
 1076059039,
 -1,
 -49111,
 1076342652,
 9504,
 -49110,
 1076393809,
 9512,
 -1,
 1076453203,
 9538,
 1076690943,
 1076313175,
 -1,
 -49107,
 1076604905,
 9567,
 -49106,
 1076656021,
 9570,
 -1,
 1076715364,
 9579,
 1076953087,
 1075752551,
 -1,
 1076969524,
 1076853405,
 -1,
 -49102,
 1076943573,
 9545,
 -49101,
 1077007200,
 9529,
 -1,
 1077034629,
 9521,
 1077231672,
 1076911018,
 -1,
 -49098,
 1077205732,
 9534,
 -49097,
 1077269452,
 9526,
 -1,
 1077296887,
 9518,
 -49095,
 1077203817,
 9540,
 -1,
 1077427856,
 9542,
 1077624959,
 1065264451,
 -1,
 1077690490,
 1077574106,
 -1,
 1077755973,
 1077613940,
 12570,
 1077821504,
 1077709023,
 12578,
 -49089,
 1077774559,
 12713,
 -1,
 1077826275,
 12580,
 1078018114,
 1077792330,
 12576,
 -1,
 1077972346,
 12719,
 1078149188,
 1077961087,
 12574,
 -1,
 1078103418,
 12718,
 -1,
 1078099941,
 12720,
 1078345805,
 1077690503,
 12572,
 1078411337,
 1078298847,
 12579,
 -49080,
 1078364383,
 12709,
 -1,
 1078416099,
 12581,
 -49078,
 1078372692,
 12582,
 -49077,
 1078550911,
 12575,
 -49076,
 1078614155,
 12573,
 -1,
 1078673543,
 12708,
 1078870100,
 1078288767,
 12583,
 1078935632,
 1078824314,
 12714,
 -1,
 1078888671,
 12723,
 -49071,
 1078906442,
 12585,
 -49070,
 1079028052,
 12712,
 -49069,
 1079082981,
 12716,
 -1,
 1079138443,
 12589,
 1079328859,
 1078825359,
 12571,
 1079394392,
 1079281887,
 -1,
 -49065,
 1079347423,
 12711,
 -1,
 1079399139,
 12722,
 -49063,
 1079365194,
 12577,
 -49062,
 1079546255,
 12710,
 -1,
 1079607269,
 12721,
 1079787614,
 1079306014,
 12567,
 -49059,
 1079730559,
 12705,
 -1,
 1079793803,
 12563,
 1079984225,
 1079740639,
 12555,
 1080098815,
 1079923427,
 12587,
 -1,
 1079988963,
 12717,
 1080180836,
 1079923427,
 12557,
 -49053,
 1080151626,
 12707,
 -1,
 1080199391,
 12588,
 1080377446,
 1080151626,
 12584,
 -1,
 1080331642,
 12715,
 1080508520,
 1080342303,
 12569,
 -1,
 1080449163,
 12565,
 1080639594,
 1080454953,
 12560,
 -1,
 1080582527,
 12706,
 1080770668,
 1080569054,
 12568,
 -1,
 1080711307,
 12564,
 1080901742,
 1080698486,
 12549,
 -1,
 1080872522,
 12704,
 -49041,
 1080877828,
 12562,
 -49040,
 1081005998,
 12586,
 -49039,
 1081066196,
 12554,
 -49038,
 1081125204,
 12566,
 -49037,
 1081190212,
 12561,
 -49036,
 1081253865,
 12550,
 -49035,
 1081311205,
 12551,
 -49034,
 1081373528,
 12556,
 -49033,
 1081438344,
 12558,
 -49032,
 1081497739,
 12559,
 -49031,
 1081560662,
 12552,
 -1,
 1081620000,
 12553,
 1081868287,
 1077628996,
 -1,
 -49028,
 1081787092,
 12725,
 -49027,
 1081843689,
 12724,
 -49026,
 1081897096,
 12726,
 -1,
 1081956491,
 12727,
 1082146961,
 1077595261,
 -1,
 1082212485,
 1082109543,
 -1,
 1082278020,
 1082141918,
 -1,
 -49021,
 1082242148,
 8972,
 -1,
 1082300780,
 8991,
 -1,
 1082218921,
 11813,
 1082540170,
 1082160778,
 -1,
 1082605705,
 1082469598,
 -1,
 -49016,
 1082569828,
 8973,
 -1,
 1082628460,
 8990,
 -1,
 1082546601,
 11812,
 1082867852,
 1082507102,
 9141,
 -1,
 1082787866,
 9142,
 -49011,
 1082837613,
 9185,
 -49010,
 1082958118,
 9181,
 -49009,
 1083005382,
 8993,
 -49008,
 1083061653,
 9183,
 -1,
 1083121958,
 10555,
 1083375615,
 1082122978,
 8904,
 1083441151,
 1083247651,
 -1,
 -49004,
 1083354916,
 10706,
 -1,
 1083406079,
 10705,
 1083588893,
 1065173127,
 -1,
 1083654421,
 1083541727,
 -1,
 1083719955,
 1083593555,
 -1,
 1083785437,
 1083668954,
 -1,
 1083850912,
 1083746644,
 -1,
 1083916446,
 1083774324,
 2480,
 1084030975,
 1083837475,
 -1,
 -48995,
 1083933904,
 2544,
 -1,
 1083997806,
 2545,
 -48993,
 1083877807,
 2524,
 -1,
 1084119209,
 2525,
 1084309669,
 1083825167,
 -1,
 1084375203,
 1084270932,
 2443,
 -1,
 1084336468,
 2528,
 1084555263,
 1084322648,
 2444,
 -1,
 1084453720,
 2529,
 1084637355,
 1084277460,
 -1,
 1084702889,
 1084605140,
 -1,
 -48984,
 1084643497,
 2464,
 -1,
 1084691828,
 2463,
 -48982,
 1084643497,
 2469,
 -1,
 1084822900,
 2468,
 1085030576,
 1084590303,
 -1,
 -48979,
 1085006890,
 2462,
 -48978,
 1085049147,
 2467,
 -48977,
 1085100804,
 2457,
 -1,
 1085150580,
 2472,
 1085358262,
 1084962336,
 -1,
 1085423796,
 1085290016,
 -1,
 -48973,
 1085364393,
 2466,
 -1,
 1085412724,
 2465,
 -48971,
 1085364393,
 2471,
 -1,
 1085543796,
 2470,
 1085751482,
 1085281652,
 2437,
 -48968,
 1085722186,
 2452,
 -48967,
 1085759871,
 2448,
 -1,
 1085805940,
 2438,
 1086013630,
 1085716255,
 -1,
 -48964,
 1085978521,
 2487,
 -48963,
 1086019753,
 2486,
 -1,
 1086068084,
 2488,
 1086275778,
 1085960328,
 -1,
 1086341313,
 1086216361,
 2454,
 -1,
 1086294750,
 2510,
 -1,
 1086264692,
 2453,
 1086537925,
 1086252014,
 -1,
 -48956,
 1086514218,
 2527,
 -1,
 1086526836,
 2479,
 1086734535,
 1086508618,
 2441,
 -1,
 1086705226,
 2442,
 1086865610,
 1086693353,
 -1,
 -48951,
 1086806185,
 2475,
 -1,
 1086854516,
 2474,
 1087062221,
 1086811945,
 -1,
 -48948,
 1087002793,
 2461,
 -1,
 1087051124,
 2460,
 1087258831,
 1087005055,
 2439,
 -1,
 1087201663,
 2440,
 1087389906,
 1087197923,
 -1,
 -48943,
 1087330473,
 2456,
 -1,
 1087378804,
 2455,
 1087586517,
 1087319262,
 -1,
 -48940,
 1087527081,
 2459,
 -1,
 1087575412,
 2458,
 1087783128,
 1087514230,
 -1,
 -48937,
 1087723689,
 2477,
 -1,
 1087772020,
 2476,
 -48935,
 1087738255,
 2451,
 -48934,
 1087930418,
 2478,
 -48933,
 1087992749,
 2482,
 -48932,
 1088051369,
 2489,
 -1,
 1088110727,
 2447,
 1088307437,
 1083759798,
 -1,
 1088372963,
 1088281615,
 -1,
 1088438497,
 1088334164,
 2499,
 -1,
 1088399700,
 2500,
 1088618495,
 1088385880,
 2530,
 -1,
 1088516952,
 2531,
 1088700647,
 1088296308,
 -1,
 -48923,
 1088671306,
 2508,
 -48922,
 1088708991,
 2504,
 -1,
 1088755060,
 2494,
 1088962793,
 1088671306,
 2497,
 -1,
 1088933450,
 2498,
 1089093867,
 1088905599,
 2495,
 -1,
 1089036671,
 2496,
 -48916,
 1089048975,
 2507,
 -1,
 1089159303,
 2503,
 1089356027,
 1088240024,
 -1,
 1089421553,
 1089323732,
 -1,
 -48912,
 1089397135,
 2536,
 -1,
 1089429590,
 2537,
 1089618164,
 1089386271,
 -1,
 -48909,
 1089564398,
 2540,
 -1,
 1089621122,
 2541,
 1089814775,
 1089556054,
 -1,
 -48906,
 1089772528,
 2538,
 -1,
 1089826423,
 2539,
 -48904,
 1089791893,
 2534,
 -48903,
 1089967551,
 2535,
 -48902,
 1090030780,
 2543,
 -1,
 1090078007,
 2542,
 1090273540,
 1089322032,
 -1,
 1090339071,
 1090247525,
 -1,
 -48898,
 1090304037,
 2435,
 -1,
 1090366093,
 2509,
 1090535682,
 1090262388,
 -1,
 -48895,
 1090508741,
 2493,
 -1,
 1090556101,
 2434,
 -48893,
 1090490421,
 2492,
 -1,
 1090661812,
 2433,
 1090863373,
 1090205114,
 -1,
 1090928908,
 1090818176,
 -1,
 1090994441,
 1090896596,
 -1,
 -48888,
 1090969999,
 2549,
 -1,
 1091002454,
 2550,
 1091191051,
 1090950591,
 2548,
 -1,
 1091110269,
 2552,
 -1,
 1091129808,
 2551,
 -1,
 1090860991,
 2553,
 1091453200,
 1090827962,
 -1,
 -48881,
 1091419179,
 2547,
 -1,
 1091469914,
 2546,
 -48879,
 1091399002,
 2554,
 -48878,
 1091588991,
 2555,
 -1,
 1091642770,
 2519,
 1091895295,
 1083697025,
 9004,
 -1,
 1091767361,
 9187,
 1091977496,
 1083622100,
 -1,
 -48873,
 1091952213,
 8812,
 -1,
 1091963540,
 8502,
 1092174107,
 1091902676,
 -1,
 -48870,
 1092140322,
 9836,
 -1,
 1092175192,
 9835,
 -48868,
 1092123661,
 9086,
 -1,
 1092300367,
 8757,
 1092501924,
 1083536301,
 -1,
 1092567459,
 1092432165,
 -1,
 1092632984,
 1092485120,
 -1,
 1092698417,
 1092562142,
 -1,
 1092763945,
 1092639832,
 -1,
 1092829477,
 1092710536,
 -1,
 -48860,
 1092783264,
 9822,
 -1,
 1092839591,
 9818,
 -48858,
 1092793439,
 9820,
 -48857,
 1092987055,
 9819,
 -48856,
 1093050770,
 9823,
 -1,
 1093085639,
 9821,
 1093288238,
 1092709404,
 9679,
 1093402623,
 1093209123,
 -1,
 -48852,
 1093328591,
 9864,
 -48851,
 1093389834,
 9865,
 -1,
 1093418584,
 10733,
 -48849,
 1093252248,
 9960,
 -48848,
 1093566254,
 9827,
 -1,
 1093617718,
 10028,
 1093812545,
 1092663071,
 -1,
 1093878074,
 1093763045,
 -1,
 1093943609,
 1093802920,
 -1,
 1094009143,
 1093908255,
 -1,
 -48842,
 1093977124,
 11089,
 -1,
 1094035487,
 9642,
 -48840,
 1093959369,
 11050,
 -1,
 1094138157,
 11049,
 -1,
 1093887520,
 9787,
 -48837,
 1093849558,
 9728,
 -48836,
 1094370340,
 9733,
 -48835,
 1094428703,
 9632,
 -48834,
 1094492286,
 9824,
 -48833,
 1094553289,
 9927,
 -48832,
 1094606445,
 9751,
 -1,
 1094660358,
 9986,
 1094861139,
 1093759832,
 -1,
 1094926667,
 1094796186,
 -1,
 1094992199,
 1094848697,
 -1,
 -48827,
 1094961914,
 9664,
 -48826,
 1095024167,
 9666,
 -1,
 1095083237,
 9668,
 1095254346,
 1094909952,
 -1,
 -48823,
 1095214352,
 9754,
 -1,
 1095267570,
 9944,
 -1,
 1095228799,
 8268,
 1095516496,
 1094881679,
 -1,
 1095582031,
 1095491184,
 -1,
 -48818,
 1095544880,
 9698,
 -1,
 1095596013,
 9699,
 -1,
 1095559051,
 10731,
 1095892991,
 1095442840,
 -1,
 -48814,
 1095810903,
 11035,
 -1,
 1095839810,
 11044,
 1096040801,
 1094822228,
 -1,
 1096106336,
 1095984355,
 -1,
 1096171867,
 1096028345,
 -1,
 1096237401,
 1096130537,
 -1,
 -48808,
 1096192983,
 9658,
 -1,
 1096239055,
 11091,
 -48806,
 1096207098,
 9654,
 -1,
 1096400423,
 9656,
 1096565087,
 1096146266,
 -1,
 1096630622,
 1096491618,
 10145,
 -1,
 1096571702,
 10148,
 -1,
 1096559679,
 8269,
 -1,
 1096485222,
 9755,
 -1,
 1096041043,
 9644,
 1096958317,
 1095972384,
 -1,
 1097023847,
 1096901195,
 9670,
 1097138175,
 1096941568,
 -1,
 -48795,
 1097064420,
 10730,
 -48794,
 1097122219,
 9830,
 -1,
 1097172426,
 10070,
 1097351530,
 1096985344,
 -1,
 -48791,
 1097302518,
 9922,
 -1,
 1097364058,
 9923,
 1097596927,
 1097310136,
 -1,
 -48788,
 1097517818,
 9660,
 -1,
 1097580071,
 9662,
 1097744758,
 1096928842,
 -1,
 1097810293,
 1097703401,
 -1,
 1097875826,
 1097769556,
 -1,
 -48783,
 1097838640,
 9701,
 -1,
 1097889773,
 9700,
 1098121215,
 1097797817,
 -1,
 -48780,
 1098042106,
 9650,
 -1,
 1098104359,
 9652,
 -1,
 1097764150,
 9851,
 1098334590,
 1097695205,
 -1,
 1098400125,
 1098269466,
 -1,
 1098465659,
 1098364703,
 -1,
 -48774,
 1098426399,
 9724,
 -1,
 1098482121,
 9726,
 -48772,
 1098415817,
 11047,
 -1,
 1098594605,
 11045,
 -1,
 1098356397,
 9912,
 1098858885,
 1098274955,
 -1,
 1098924418,
 1098813839,
 -1,
 -48767,
 1098896865,
 10711,
 -1,
 1098953516,
 11052,
 1099169791,
 1098858631,
 -1,
 -48764,
 1099096871,
 11042,
 -1,
 1099113148,
 9829,
 1099317642,
 1098832281,
 -1,
 1099383177,
 1099286466,
 -1,
 -48760,
 1099344903,
 9646,
 -1,
 1099384308,
 11054,
 -1,
 1099359245,
 11037,
 1099645326,
 1099285204,
 -1,
 -48756,
 1099621019,
 9942,
 -48755,
 1099675245,
 9951,
 -1,
 1099711971,
 9742,
 1099907475,
 1099583062,
 -1,
 1099973010,
 1099854680,
 -1,
 -48751,
 1099929784,
 10047,
 -1,
 1099962515,
 9873,
 -1,
 1099930708,
 10022,
 1100235158,
 1099866089,
 -1,
 -48747,
 1100171215,
 11039,
 -1,
 1100226809,
 9648,
 -48745,
 1100188803,
 10002,
 -1,
 1100360532,
 10707,
 1100611583,
 1092554451,
 -1,
 1100628383,
 1100511714,
 -1,
 -48741,
 1100605214,
 8488,
 -48740,
 1100654932,
 8476,
 -48739,
 1100702079,
 8465,
 -48738,
 1100765323,
 8460,
 -1,
 1100819678,
 8493,
 1101070335,
 1100566332,
 -1,
 -48735,
 1100988124,
 10164,
 -48734,
 1101050015,
 10165,
 -1,
 1101106724,
 10166,
 -1,
 1092521324,
 9250,
 1101349350,
 1092472394,
 -1,
 1101414858,
 1101288860,
 -1,
 1101480386,
 1101363674,
 -1,
 1101545904,
 1101433055,
 -1,
 1101611435,
 1101521902,
 -1,
 -48726,
 1101540667,
 6671,
 -1,
 1101600116,
 6670,
 1101808046,
 1101550307,
 -1,
 -48723,
 1101754527,
 6659,
 -1,
 1101796724,
 6658,
 -48721,
 1101769135,
 6667,
 -1,
 1101927796,
 6666,
 1102135731,
 1101496293,
 -1,
 -48718,
 1102094414,
 6663,
 -1,
 1102124404,
 6662,
 -48716,
 1102111786,
 6672,
 -48715,
 1102305212,
 6675,
 -48714,
 1102365461,
 6664,
 -48713,
 1102428057,
 6676,
 -48712,
 1102490031,
 6673,
 -48711,
 1102553166,
 6660,
 -48710,
 1102607277,
 6674,
 -48709,
 1102672031,
 6656,
 -48708,
 1102737195,
 6669,
 -48707,
 1102796969,
 6678,
 -48706,
 1102861060,
 6657,
 -48705,
 1102919307,
 6665,
 -48704,
 1102982459,
 6668,
 -48703,
 1103046312,
 6661,
 -1,
 1103107444,
 6677,
 1103315400,
 1101454518,
 -1,
 -48700,
 1103285834,
 6680,
 -48699,
 1103335823,
 6682,
 -48698,
 1103389055,
 6679,
 -48697,
 1103446151,
 6681,
 -1,
 1103501369,
 6683,
 -48695,
 1103274156,
 6686,
 -1,
 1103644521,
 6687,
 1103839714,
 1101356220,
 -1,
 1103905247,
 1103788506,
 -1,
 1103970767,
 1103857887,
 -1,
 -48690,
 1103909636,
 5957,
 -1,
 1103959412,
 5960,
 -48688,
 1103946794,
 5964,
 -48687,
 1104141616,
 5967,
 -48686,
 1104203338,
 5954,
 -48685,
 1104266005,
 5958,
 -48684,
 1104328601,
 5968,
 -48683,
 1104390575,
 5965,
 -48682,
 1104453710,
 5961,
 -48681,
 1104511026,
 5963,
 -48680,
 1104573357,
 5966,
 -48679,
 1104638111,
 5955,
 -48678,
 1104699775,
 5953,
 -48677,
 1104763049,
 5969,
 -48676,
 1104827140,
 5956,
 -48675,
 1104885387,
 5959,
 -48674,
 1104946856,
 5962,
 -1,
 1105007988,
 5952,
 1105264639,
 1103879350,
 -1,
 -48671,
 1105186378,
 5971,
 -1,
 1105224063,
 5970,
 1105461247,
 1103789058,
 -1,
 1105478117,
 1105349437,
 8226,
 -1,
 1105397367,
 8729,
 -1,
 1105443331,
 9678,
 1105723391,
 1101291903,
 -1,
 1105740266,
 1105613541,
 -1,
 -48663,
 1105706649,
 10744,
 -1,
 1105767756,
 10745,
 -1,
 1105695612,
 9763,
 1106003951,
 1003995860,
 -1,
 1106068514,
 1105925492,
 -1,
 1106133790,
 1106010497,
 -1,
 1106199190,
 1106101832,
 -1,
 1106264627,
 1106147802,
 -1,
 1106330120,
 1106211672,
 -1,
 1106395652,
 1106288368,
 -1,
 1106461174,
 1106342024,
 -1,
 -48652,
 1106436900,
 6692,
 -48651,
 1106466985,
 6693,
 -1,
 1106515316,
 6691,
 1106723321,
 1106428628,
 -1,
 -48648,
 1106663593,
 6709,
 -1,
 1106711924,
 6708,
 1106919932,
 1106681833,
 -1,
 -48645,
 1106860201,
 6717,
 -1,
 1106908532,
 6715,
 1107116543,
 1106848990,
 -1,
 -48642,
 1107056809,
 6699,
 -1,
 1107105140,
 6697,
 -48640,
 1107092522,
 6719,
 -48639,
 1107277721,
 6698,
 -48638,
 1107340026,
 6704,
 -48637,
 1107384489,
 6732,
 -1,
 1107447487,
 6716,
 1107640838,
 1106318708,
 6723,
 -1,
 1107574919,
 6739,
 -48633,
 1107611662,
 6724,
 -1,
 1107719085,
 6730,
 1107903006,
 1106271471,
 -1,
 1107968525,
 1107867423,
 -1,
 -48629,
 1107933081,
 6727,
 -48628,
 1107974313,
 6726,
 -1,
 1108022644,
 6728,
 1108230673,
 1107914888,
 -1,
 -48625,
 1108206372,
 6690,
 -48624,
 1108236457,
 6689,
 -1,
 1108284788,
 6688,
 1108492820,
 1108198100,
 -1,
 -48621,
 1108433065,
 6707,
 -1,
 1108481396,
 6706,
 1108689431,
 1108451305,
 -1,
 -48618,
 1108629673,
 6713,
 -1,
 1108678004,
 6712,
 1108886042,
 1108618462,
 -1,
 -48615,
 1108826281,
 6696,
 -1,
 1108874612,
 6695,
 -48613,
 1108861994,
 6720,
 -48612,
 1109043962,
 6702,
 -48611,
 1109088425,
 6729,
 -1,
 1109151423,
 6714,
 1109344803,
 1107863892,
 -1,
 1109410338,
 1109267828,
 6721,
 -48607,
 1109377813,
 6701,
 -1,
 1109428539,
 6705,
 -1,
 1109381134,
 6722,
 1109672487,
 1109297375,
 -1,
 -48603,
 1109648426,
 6700,
 -48602,
 1109676804,
 6694,
 -1,
 1109726580,
 6710,
 1109934633,
 1109642826,
 6735,
 -1,
 1109904970,
 6736,
 1110065707,
 1109877119,
 6733,
 -1,
 1110008191,
 6734,
 -48596,
 1110039856,
 6725,
 -48595,
 1110152836,
 6738,
 -48594,
 1110212658,
 6718,
 -48593,
 1110267620,
 6740,
 -48592,
 1110328103,
 6737,
 -48591,
 1110390411,
 6703,
 -48590,
 1110451880,
 6711,
 -1,
 1110513012,
 6731,
 1110721109,
 1106230320,
 -1,
 1110786622,
 1110667400,
 -1,
 1110852155,
 1110728974,
 -1,
 1110917690,
 1110772661,
 -1,
 -48584,
 1110840329,
 6777,
 -48583,
 1110905788,
 6776,
 -1,
 1110971212,
 6775,
 -1,
 1110839391,
 6780,
 1111245373,
 1110775316,
 6824,
 -1,
 1111192382,
 6825,
 -1,
 1111181455,
 6819,
 1111441987,
 1110751129,
 -1,
 1111507521,
 1111410964,
 6826,
 -1,
 1111454526,
 6827,
 -48574,
 1111481680,
 6818,
 -1,
 1111585493,
 6752,
 1111769672,
 1111392384,
 -1,
 1111835206,
 1111716084,
 6772,
 -1,
 1111754073,
 6744,
 -48569,
 1111811179,
 6823,
 -1,
 1111930850,
 6779,
 1112097354,
 1111744289,
 6816,
 -1,
 1112071479,
 6817,
 1112228429,
 1112066543,
 -1,
 -48564,
 1112150695,
 6774,
 -1,
 1112216079,
 6773,
 1112425040,
 1112189268,
 -1,
 -48561,
 1112362290,
 6822,
 -1,
 1112413569,
 6778,
 1112621651,
 1112365195,
 -1,
 -48558,
 1112580059,
 6820,
 -1,
 1112612448,
 6828,
 -48556,
 1112554222,
 6821,
 -1,
 1112747330,
 6829,
 1112949355,
 1110695094,
 -1,
 1113014876,
 1112904079,
 6763,
 1113080410,
 1112937846,
 -1,
 -48551,
 1113008211,
 6764,
 -1,
 1113069173,
 6771,
 -48549,
 1113056238,
 6765,
 -1,
 1113231759,
 6768,
 1113408096,
 1112985162,
 6761,
 1113473631,
 1113378378,
 6762,
 -1,
 1113407623,
 6760,
 -1,
 1113407623,
 6759,
 1113670244,
 1113331060,
 6753,
 -48542,
 1113612671,
 6769,
 -48541,
 1113669767,
 6767,
 -1,
 1113724276,
 6755,
 1113932391,
 1113637588,
 -1,
 -48538,
 1113872881,
 6770,
 -1,
 1113922477,
 6756,
 1114129001,
 1113874815,
 6757,
 -1,
 1114071423,
 6758,
 -48534,
 1114079371,
 6754,
 -1,
 1114194055,
 6766,
 1114391161,
 1112917582,
 -1,
 1114456687,
 1114358484,
 -1,
 -48530,
 1114431887,
 6802,
 -1,
 1114464342,
 6803,
 1114653298,
 1114421023,
 -1,
 -48527,
 1114599150,
 6806,
 -1,
 1114655874,
 6807,
 1114849909,
 1114590806,
 -1,
 -48524,
 1114807280,
 6804,
 -1,
 1114861175,
 6805,
 -48522,
 1114826645,
 6800,
 -48521,
 1115002303,
 6801,
 -48520,
 1115065532,
 6809,
 -1,
 1115112759,
 6808,
 1115308679,
 1114332860,
 -1,
 1115374205,
 1115275988,
 -1,
 -48516,
 1115349391,
 6786,
 -1,
 1115381846,
 6787,
 1115570816,
 1115338527,
 -1,
 -48513,
 1115516654,
 6790,
 -1,
 1115573378,
 6791,
 1115767427,
 1115508310,
 -1,
 -48510,
 1115724784,
 6788,
 -1,
 1115778679,
 6789,
 -48508,
 1115744149,
 6784,
 -48507,
 1115919807,
 6785,
 -48506,
 1115983036,
 6793,
 -1,
 1116030263,
 6792,
 1116274687,
 1115238888,
 -1,
 1116291733,
 1116180181,
 -1,
 1116357262,
 1116241893,
 -1,
 1116422797,
 1116291841,
 -1,
 -48500,
 1116383663,
 6741,
 -1,
 1116435373,
 6742,
 -1,
 1116345716,
 6748,
 1116684945,
 1116304216,
 -1,
 -48496,
 1116643068,
 6746,
 -1,
 1116673469,
 6743,
 -48494,
 1116649369,
 6750,
 -48493,
 1116822773,
 6747,
 -48492,
 1116885084,
 6745,
 -1,
 1116939944,
 6749,
 -1,
 1116242652,
 6783,
 1117209332,
 1106172813,
 -1,
 1117274838,
 1117157850,
 -1,
 1117340343,
 1117224483,
 -1,
 1117405853,
 1117292767,
 -1,
 -48485,
 1117382186,
 43664,
 -48484,
 1117426063,
 43672,
 -1,
 1117476381,
 43656,
 1117668002,
 1117352072,
 -1,
 1117733537,
 1117608075,
 -1,
 -48480,
 1117688207,
 43650,
 -1,
 1117740639,
 43652,
 -1,
 1117688207,
 43648,
 1117995685,
 1117635284,
 -1,
 -48476,
 1117950351,
 43668,
 -1,
 1118002783,
 43670,
 1118192296,
 1117954025,
 -1,
 -48473,
 1118146959,
 43676,
 -1,
 1118199391,
 43678,
 1118388907,
 1118121182,
 -1,
 -48470,
 1118343567,
 43658,
 -1,
 1118395999,
 43660,
 -48468,
 1118365226,
 43684,
 -48467,
 1118559244,
 43690,
 -48466,
 1118617205,
 43662,
 -48465,
 1118680020,
 43686,
 -48464,
 1118736783,
 43694,
 -48463,
 1118799412,
 43682,
 -48462,
 1118862532,
 43688,
 -48461,
 1118920287,
 43692,
 -48460,
 1118983709,
 43654,
 -48459,
 1119048052,
 43680,
 -48458,
 1119107780,
 43666,
 -1,
 1119169174,
 43674,
 1119420415,
 1117281519,
 -1,
 1119437500,
 1119324383,
 -1,
 -48454,
 1119413802,
 43665,
 -48453,
 1119457679,
 43673,
 -1,
 1119507997,
 43657,
 1119699649,
 1119383688,
 -1,
 1119765184,
 1119639691,
 -1,
 -48449,
 1119719823,
 43651,
 -1,
 1119772255,
 43653,
 -1,
 1119719823,
 43649,
 1120027332,
 1119666900,
 -1,
 -48445,
 1119981967,
 43669,
 -1,
 1120034399,
 43671,
 1120223943,
 1119985641,
 -1,
 -48442,
 1120178575,
 43677,
 -1,
 1120231007,
 43679,
 1120420554,
 1120152798,
 -1,
 -48439,
 1120375183,
 43659,
 -1,
 1120427615,
 43661,
 -48437,
 1120396842,
 43685,
 -48436,
 1120590860,
 43691,
 -48435,
 1120648821,
 43663,
 -48434,
 1120711636,
 43687,
 -48433,
 1120768399,
 43695,
 -48432,
 1120831028,
 43683,
 -48431,
 1120894148,
 43689,
 -48430,
 1120951903,
 43693,
 -48429,
 1121015325,
 43655,
 -48428,
 1121079668,
 43681,
 -48427,
 1121139396,
 43667,
 -1,
 1121200790,
 43675,
 1121403621,
 1117248655,
 -1,
 1121469149,
 1121326452,
 -1,
 -48423,
 1121444846,
 43708,
 -48422,
 1121505294,
 43707,
 -48421,
 1121552607,
 43709,
 -48420,
 1121615845,
 43710,
 -1,
 1121654132,
 43697,
 1121862369,
 1121439306,
 43700,
 1121927904,
 1121796231,
 43699,
 -1,
 1121850740,
 43705,
 -1,
 1121850740,
 43706,
 1122124515,
 1121804671,
 43698,
 -1,
 1122047348,
 43704,
 -48412,
 1122079119,
 43702,
 -1,
 1122189447,
 43701,
 1122386668,
 1121370723,
 -1,
 1122452201,
 1122333322,
 -1,
 -48408,
 1122404575,
 43739,
 -1,
 1122460047,
 43743,
 -48406,
 1122416610,
 43741,
 -48405,
 1122603042,
 43740,
 -1,
 1122655846,
 43742,
 1122845425,
 1122355653,
 -1,
 -48402,
 1122813696,
 43713,
 -48401,
 1122877117,
 43714,
 -48400,
 1122930722,
 43712,
 -1,
 1122977181,
 43711,
 1123221503,
 1122795653,
 -1,
 -48397,
 1123114455,
 43703,
 -1,
 1123163744,
 43696,
 1123418111,
 1117156953,
 -1,
 1123435265,
 1123336916,
 -1,
 1123500796,
 1123390985,
 -1,
 -48392,
 1123423361,
 6516,
 -48391,
 1123488777,
 6515,
 -48390,
 1123554236,
 6514,
 -48389,
 1123619660,
 6513,
 -1,
 1123685031,
 6512,
 1123894015,
 1123464991,
 -1,
 -48386,
 1123834025,
 6497,
 -1,
 1123882356,
 6483,
 -48384,
 1123834025,
 6487,
 -1,
 1124013428,
 6486,
 1124221700,
 1123369095,
 6507,
 -48381,
 1124161675,
 6502,
 -1,
 1124221063,
 6501,
 1124418311,
 1124144500,
 6499,
 -48378,
 1124388878,
 6508,
 -1,
 1124426111,
 6509,
 1124614921,
 1124388426,
 6503,
 -1,
 1124548743,
 6506,
 1124745996,
 1124573161,
 -1,
 -48373,
 1124685993,
 6490,
 -1,
 1124734324,
 6489,
 1124942606,
 1124700559,
 6505,
 -1,
 1124897167,
 6504,
 1125073681,
 1124894943,
 -1,
 -48368,
 1125012228,
 6482,
 -1,
 1125062004,
 6498,
 1125270292,
 1125019784,
 -1,
 -48365,
 1125210281,
 6496,
 -1,
 1125258612,
 6480,
 -48363,
 1125245994,
 6485,
 -48362,
 1125442340,
 6481,
 -48361,
 1125504956,
 6493,
 -48360,
 1125562265,
 6484,
 -48359,
 1125623626,
 6495,
 -48358,
 1125679154,
 6491,
 -48357,
 1125741485,
 6488,
 -48356,
 1125802367,
 6500,
 -48355,
 1125865641,
 6494,
 -1,
 1125928639,
 6492,
 1126122435,
 1106072291,
 -1,
 1126187925,
 1126039552,
 -1,
 1126253407,
 1126134616,
 -1,
 1126318936,
 1126180123,
 -1,
 1126384445,
 1126284810,
 -1,
 -48348,
 1126360862,
 917626,
 -48347,
 1126425582,
 917625,
 -48346,
 1126490884,
 917624,
 -48345,
 1126554888,
 917623,
 -48344,
 1126619054,
 917622,
 -48343,
 1126682186,
 917621,
 -48342,
 1126744788,
 917620,
 -48341,
 1126807327,
 917619,
 -48340,
 1126869332,
 917618,
 -48339,
 1126934340,
 917617,
 -48338,
 1126997993,
 917616,
 -48337,
 1127059855,
 917615,
 -48336,
 1127123167,
 917614,
 -48335,
 1127186405,
 917613,
 -48334,
 1127248728,
 917612,
 -48333,
 1127313544,
 917611,
 -48332,
 1127378729,
 917610,
 -48331,
 1127440767,
 917609,
 -48330,
 1127504011,
 917608,
 -48329,
 1127568099,
 917607,
 -48328,
 1127632470,
 917606,
 -48327,
 1127694471,
 917605,
 -48326,
 1127757344,
 917604,
 -48325,
 1127820510,
 917603,
 -48324,
 1127884406,
 917602,
 -1,
 1127945588,
 917601,
 1128202239,
 1126313476,
 -1,
 -48321,
 1128130334,
 917594,
 -48320,
 1128195054,
 917593,
 -48319,
 1128260356,
 917592,
 -48318,
 1128324360,
 917591,
 -48317,
 1128388526,
 917590,
 -48316,
 1128451658,
 917589,
 -48315,
 1128514260,
 917588,
 -48314,
 1128576799,
 917587,
 -48313,
 1128638804,
 917586,
 -48312,
 1128703812,
 917585,
 -48311,
 1128767465,
 917584,
 -48310,
 1128829327,
 917583,
 -48309,
 1128892639,
 917582,
 -48308,
 1128955877,
 917581,
 -48307,
 1129018200,
 917580,
 -48306,
 1129083016,
 917579,
 -48305,
 1129148201,
 917578,
 -48304,
 1129210239,
 917577,
 -48303,
 1129273483,
 917576,
 -48302,
 1129337571,
 917575,
 -48301,
 1129401942,
 917574,
 -48300,
 1129463943,
 917573,
 -48299,
 1129526816,
 917572,
 -48298,
 1129589982,
 917571,
 -48297,
 1129653878,
 917570,
 -1,
 1129715060,
 917569,
 1129923422,
 1126252679,
 -1,
 1129988957,
 1129861729,
 -1,
 -48293,
 1129955166,
 917595,
 -48292,
 1130012966,
 917544,
 -1,
 1130050965,
 917627,
 -1,
 1129955251,
 917564,
 -1,
 1129881332,
 917599,
 1130382191,
 1126184480,
 -1,
 1130447726,
 1130325370,
 -1,
 1130513252,
 1130414804,
 -1,
 -48285,
 1130488207,
 917554,
 -1,
 1130520662,
 917555,
 1130709863,
 1130477343,
 -1,
 -48282,
 1130655470,
 917558,
 -1,
 1130712194,
 917559,
 1130906474,
 1130647126,
 -1,
 -48279,
 1130863600,
 917556,
 -1,
 1130917495,
 917557,
 -48277,
 1130882965,
 917552,
 -48276,
 1131058623,
 917553,
 -48275,
 1131121852,
 917561,
 -1,
 1131169079,
 917560,
 -1,
 1130402957,
 917540,
 1131430773,
 1130342740,
 -1,
 1131496308,
 1131373800,
 -1,
 -48270,
 1131462494,
 917597,
 -48269,
 1131520294,
 917545,
 -1,
 1131558293,
 917629,
 -1,
 1131433187,
 917596,
 1131823996,
 1131359454,
 -1,
 1131889531,
 1131778447,
 -1,
 1131955066,
 1131841012,
 -1,
 -48263,
 1131891114,
 917568,
 -1,
 1131943284,
 917548,
 -1,
 1131904274,
 917562,
 -1,
 1131834451,
 917598,
 1132282752,
 1131788063,
 -1,
 -48258,
 1132241017,
 917536,
 -48257,
 1132303459,
 917551,
 -1,
 1132349056,
 917563,
 1132544900,
 1132205428,
 -1,
 -48254,
 1132511347,
 917546,
 -48253,
 1132569968,
 917543,
 -1,
 1132627825,
 917542,
 1132807047,
 1132505025,
 -1,
 -48250,
 1132763794,
 917538,
 -1,
 1132809001,
 917567,
 1133003658,
 1132765161,
 -1,
 -48247,
 1132953462,
 917547,
 -1,
 1133005206,
 917541,
 1133200269,
 1132942957,
 -1,
 -48244,
 1133134219,
 917566,
 -1,
 1133192681,
 917600,
 1133396880,
 1133133959,
 -1,
 -48241,
 1133372230,
 917537,
 -1,
 1133422595,
 917565,
 -48239,
 1133370099,
 917628,
 -48238,
 1133561852,
 917630,
 -48237,
 1133613127,
 917539,
 -48236,
 1133666671,
 917549,
 -1,
 1133728450,
 917550,
 1133921197,
 1126112313,
 -1,
 1133986729,
 1133869530,
 -1,
 1134052250,
 1133938911,
 -1,
 -48231,
 1133990660,
 5893,
 -1,
 1134040436,
 5896,
 -48229,
 1134027818,
 5900,
 -48228,
 1134222640,
 5903,
 -48227,
 1134284362,
 5890,
 -48226,
 1134347029,
 5894,
 -48225,
 1134409625,
 5904,
 -48224,
 1134469198,
 5897,
 -48223,
 1134526514,
 5899,
 -48222,
 1134588845,
 5902,
 -48221,
 1134653599,
 5891,
 -48220,
 1134715263,
 5889,
 -48219,
 1134778537,
 5905,
 -48218,
 1134842628,
 5892,
 -48217,
 1134900875,
 5895,
 -48216,
 1134962344,
 5898,
 -1,
 1135023476,
 5888,
 1135231916,
 1133960374,
 -1,
 -48213,
 1135201866,
 5907,
 -1,
 1135239551,
 5906,
 -1,
 1135197283,
 5908,
 1135542271,
 1133848391,
 -1,
 1135559616,
 1135442394,
 -1,
 1135625138,
 1135511775,
 -1,
 -48207,
 1135563524,
 5989,
 -1,
 1135613300,
 5992,
 -48205,
 1135600682,
 5996,
 -48204,
 1135795504,
 5999,
 -48203,
 1135857226,
 5986,
 -48202,
 1135919893,
 5990,
 -48201,
 1135982489,
 6000,
 -48200,
 1136042062,
 5993,
 -48199,
 1136099378,
 5995,
 -48198,
 1136161709,
 5998,
 -48197,
 1136226463,
 5987,
 -48196,
 1136288127,
 5985,
 -48195,
 1136349956,
 5988,
 -48194,
 1136408203,
 5991,
 -48193,
 1136469672,
 5994,
 -1,
 1136530804,
 5984,
 1136787455,
 1135533238,
 -1,
 -48190,
 1136709194,
 6003,
 -1,
 1136746879,
 6002,
 1136935968,
 1126073657,
 -1,
 1137001455,
 1136884186,
 -1,
 1137066956,
 1136953567,
 -1,
 1137132489,
 1137019103,
 -1,
 -48184,
 1137084731,
 2985,
 -1,
 1137120628,
 2979,
 -48182,
 1137108010,
 2974,
 -48181,
 1137267460,
 2969,
 -1,
 1137317236,
 2984,
 1137525712,
 1136989556,
 2949,
 -48178,
 1137495626,
 2964,
 -48177,
 1137533311,
 2960,
 -1,
 1137579380,
 2950,
 1137787860,
 1137489695,
 -1,
 -48174,
 1137751961,
 2999,
 -48173,
 1137793193,
 2998,
 -1,
 1137841524,
 3000,
 1138050009,
 1137734488,
 -1,
 1138115544,
 1137996632,
 -1,
 -48169,
 1138062253,
 2996,
 -1,
 1138103668,
 2995,
 -1,
 1138038132,
 2994,
 1138377691,
 1138019914,
 2953,
 -1,
 1138347594,
 2954,
 1138508766,
 1138344660,
 -1,
 -48163,
 1138475797,
 2975,
 -1,
 1138496884,
 2980,
 1138705377,
 1138469204,
 -1,
 -48160,
 1138665903,
 2993,
 -1,
 1138693492,
 2992,
 1138901987,
 1138659727,
 2962,
 -1,
 1138856335,
 2963,
 1139033061,
 1138844031,
 2951,
 -1,
 1138975103,
 2952,
 1139164135,
 1138966663,
 2958,
 -1,
 1139097735,
 2959,
 -48152,
 1139139626,
 2991,
 -48151,
 1139267516,
 2997,
 -48150,
 1139318862,
 2986,
 -48149,
 1139376178,
 2990,
 -48148,
 1139437727,
 2965,
 -48147,
 1139502891,
 2972,
 -48146,
 1139562665,
 3001,
 -1,
 1139617083,
 2970,
 1139819520,
 1136932384,
 -1,
 1139885054,
 1139762554,
 -1,
 1139950580,
 1139851988,
 -1,
 -48141,
 1139925391,
 3048,
 -1,
 1139957846,
 3049,
 1140147191,
 1139914527,
 -1,
 -48138,
 1140092654,
 3052,
 -1,
 1140149378,
 3053,
 1140343802,
 1140084310,
 -1,
 -48135,
 1140300784,
 3050,
 -1,
 1140354679,
 3051,
 -48133,
 1140320149,
 3046,
 -48132,
 1140495807,
 3047,
 -48131,
 1140559036,
 3055,
 -1,
 1140606263,
 3054,
 -48129,
 1139819030,
 3062,
 -1,
 1140729407,
 3059,
 1140933645,
 1139793078,
 -1,
 1140999173,
 1140856180,
 -1,
 -48125,
 1140969034,
 3020,
 -48124,
 1141006719,
 3016,
 -1,
 1141052788,
 3006,
 1141261319,
 1140969034,
 3009,
 -1,
 1141231178,
 3010,
 1141392393,
 1141215631,
 3018,
 -1,
 1141346703,
 3019,
 1141523467,
 1141334399,
 3007,
 -1,
 1141465471,
 3008,
 1141702655,
 1141457031,
 3014,
 -1,
 1141588103,
 3015,
 1141785619,
 1140887615,
 -1,
 1141851153,
 1141740995,
 -1,
 -48112,
 1141819165,
 3058,
 -1,
 1141858583,
 3057,
 -48110,
 1141818662,
 3056,
 -1,
 1142012971,
 3066,
 1142178840,
 1141750832,
 -1,
 1142244375,
 1142152037,
 -1,
 -48106,
 1142208549,
 2947,
 -1,
 1142270605,
 3021,
 -1,
 1142169495,
 2946,
 1142506523,
 1142101364,
 -1,
 -48102,
 1142476367,
 3031,
 -1,
 1142535980,
 3064,
 -48100,
 1142482110,
 3061,
 -48099,
 1142666956,
 3065,
 -48098,
 1142723782,
 3024,
 -48097,
 1142785802,
 3060,
 -1,
 1142830013,
 3063,
 -48095,
 1136907868,
 9801,
 -1,
 1142989232,
 9991,
 1143162264,
 1106010495,
 -1,
 1143227714,
 1143089448,
 -1,
 1143293070,
 1143191327,
 -1,
 1143358561,
 1143262995,
 -1,
 1143424047,
 1143325396,
 -1,
 1143489578,
 1143390932,
 -1,
 -48087,
 1143429289,
 3995,
 -1,
 1143477620,
 3994,
 1143686189,
 1143453471,
 -1,
 -48084,
 1143625897,
 4010,
 -1,
 1143674228,
 4009,
 -48082,
 1143625897,
 4000,
 -1,
 1143805300,
 3999,
 1144013880,
 1143354912,
 -1,
 1144079411,
 1143990046,
 -1,
 -48078,
 1144019113,
 4012,
 -1,
 1144067444,
 4011,
 1144276022,
 1144010272,
 -1,
 -48075,
 1144215721,
 3997,
 -1,
 1144264052,
 3996,
 -48073,
 1144215721,
 4002,
 -1,
 1144395124,
 4001,
 1144603709,
 1143965919,
 -1,
 -48070,
 1144579114,
 3993,
 -48069,
 1144621371,
 3998,
 -48068,
 1144673028,
 3988,
 -1,
 1144722804,
 4003,
 1144931393,
 1144567583,
 -1,
 -48065,
 1144895385,
 4021,
 -48064,
 1144936617,
 4020,
 -1,
 1144984948,
 4022,
 1145193541,
 1144877192,
 -1,
 -48061,
 1145159616,
 4025,
 -48060,
 1145198761,
 3985,
 -1,
 1145247092,
 3984,
 1145455689,
 1145131225,
 -1,
 -48057,
 1145431082,
 4027,
 -48056,
 1145494832,
 4026,
 -1,
 1145547183,
 4028,
 1145717836,
 1145431838,
 -1,
 -48053,
 1145657513,
 4014,
 -1,
 1145705844,
 4015,
 1145914447,
 1145675753,
 -1,
 -48050,
 1145854121,
 4005,
 -1,
 1145902452,
 4004,
 1146111058,
 1145852643,
 -1,
 -48047,
 1146050729,
 3987,
 -1,
 1146099060,
 3986,
 1146307669,
 1146039518,
 -1,
 -48044,
 1146247337,
 3990,
 -1,
 1146295668,
 3989,
 1146504280,
 1146234486,
 -1,
 -48041,
 1146443945,
 4007,
 -1,
 1146492276,
 4006,
 -48039,
 1146479658,
 4017,
 -48038,
 1146674480,
 4013,
 -48037,
 1146726831,
 4018,
 -48036,
 1146781746,
 4008,
 -48035,
 1146844077,
 4019,
 -48034,
 1146908459,
 3991,
 -48033,
 1146968233,
 4023,
 -48032,
 1147016564,
 4024,
 -1,
 1147080429,
 4016,
 1147290752,
 1143301513,
 -1,
 1147356274,
 1147251028,
 -1,
 1147421808,
 1147287415,
 -1,
 1147487338,
 1147373927,
 -1,
 1147552873,
 1147425507,
 -1,
 -48025,
 1147519427,
 4047,
 -48024,
 1147572583,
 3870,
 -1,
 1147613239,
 3869,
 -1,
 1147513693,
 4046,
 1147928575,
 1147419309,
 -1,
 1147946095,
 1147818723,
 -1,
 -48019,
 1147912643,
 3868,
 -48018,
 1147965799,
 3867,
 -1,
 1148006455,
 3866,
 -1,
 1147906919,
 3871,
 -48015,
 1147373952,
 3967,
 -1,
 1148219368,
 3966,
 1148404853,
 1147331626,
 -1,
 -48012,
 1148365187,
 3902,
 -1,
 1148423111,
 3975,
 1148601464,
 1148354533,
 -1,
 -48009,
 1148530698,
 3977,
 -1,
 1148592253,
 3903,
 1148798075,
 1148548648,
 -1,
 -48006,
 1148740020,
 3974,
 -1,
 1148797171,
 3976,
 1148994686,
 1148737528,
 -1,
 -48003,
 1148945248,
 3979,
 -1,
 1148988785,
 3978,
 -48001,
 1148960364,
 3971,
 -1,
 1149145432,
 3970,
 1149370367,
 1147266030,
 -1,
 1149387917,
 1149272822,
 -1,
 1149453447,
 1149341145,
 4041,
 1149566975,
 1149370368,
 -1,
 -47995,
 1149473132,
 4042,
 -47994,
 1149523997,
 4043,
 -1,
 1149578437,
 4044,
 1149781129,
 1149414268,
 4037,
 -1,
 1149700563,
 4039,
 1149912204,
 1149738985,
 -1,
 -47989,
 1149853996,
 4040,
 -1,
 1149900843,
 4038,
 -1,
 1149845475,
 4036,
 -1,
 1149336621,
 3840,
 1150239950,
 1143239512,
 -1,
 1150305483,
 1150176307,
 -1,
 1150370969,
 1150272212,
 -1,
 1150436500,
 1150337748,
 -1,
 -47981,
 1150376105,
 3915,
 -1,
 1150424436,
 3914,
 1150633111,
 1150400287,
 -1,
 -47978,
 1150572713,
 3930,
 -1,
 1150621044,
 3929,
 -47976,
 1150572713,
 3920,
 -1,
 1150752116,
 3919,
 1150960802,
 1150301728,
 -1,
 1151026333,
 1150936862,
 -1,
 -47972,
 1150965929,
 3932,
 -1,
 1151014260,
 3931,
 1151222944,
 1150957088,
 -1,
 -47969,
 1151162537,
 3917,
 -1,
 1151210868,
 3916,
 -47967,
 1151162537,
 3922,
 -1,
 1151341940,
 3921,
 1151550631,
 1150912735,
 -1,
 -47964,
 1151525930,
 3913,
 -47963,
 1151568187,
 3918,
 -47962,
 1151619844,
 3908,
 -1,
 1151669620,
 3923,
 1151878316,
 1151496328,
 -1,
 -47959,
 1151844288,
 3945,
 -47958,
 1151889567,
 3947,
 -47957,
 1151948969,
 3905,
 -1,
 1151997300,
 3904,
 1152206000,
 1151842079,
 -1,
 -47954,
 1152169881,
 3941,
 -47953,
 1152211113,
 3940,
 -1,
 1152259444,
 3942,
 1152468147,
 1152182046,
 -1,
 -47950,
 1152407721,
 3934,
 -1,
 1152456052,
 3935,
 1152664758,
 1152428372,
 -1,
 -47947,
 1152625071,
 3948,
 -1,
 1152652660,
 3938,
 1152861369,
 1152622569,
 -1,
 -47944,
 1152800937,
 3925,
 -1,
 1152849268,
 3924,
 1153057980,
 1152799459,
 -1,
 -47941,
 1152997545,
 3907,
 -1,
 1153045876,
 3906,
 1153254591,
 1152986334,
 -1,
 -47938,
 1153194153,
 3910,
 -1,
 1153242484,
 3909,
 1153451202,
 1153181302,
 -1,
 -47935,
 1153390761,
 3927,
 -1,
 1153439092,
 3926,
 -47933,
 1153426474,
 3937,
 -47932,
 1153621296,
 3933,
 -47931,
 1153663026,
 3928,
 -47930,
 1153725357,
 3939,
 -47929,
 1153789739,
 3911,
 -47928,
 1153849513,
 3943,
 -47927,
 1153913061,
 3946,
 -47926,
 1153963380,
 3944,
 -1,
 1154027245,
 3936,
 1154285567,
 1150260043,
 -1,
 -47923,
 1154185829,
 3862,
 -1,
 1154232109,
 3861,
 1154434313,
 1150190175,
 -1,
 1154499802,
 1154372323,
 -1,
 1154565335,
 1154467190,
 -1,
 1154630870,
 1154540924,
 -1,
 1154696405,
 1154552199,
 -1,
 -47916,
 1154659228,
 3842,
 -1,
 1154701353,
 3843,
 -1,
 1154665463,
 3841,
 -1,
 1154599954,
 3860,
 1155071999,
 1154535469,
 -1,
 -47911,
 1154979117,
 3898,
 -1,
 1155015453,
 3899,
 1155220708,
 1154428126,
 -1,
 1155286240,
 1155146121,
 -1,
 1155351775,
 1155206999,
 -1,
 -47906,
 1155302174,
 3859,
 -1,
 1155345617,
 3894,
 -1,
 1155327381,
 3846,
 1155613923,
 1155235296,
 -1,
 -47902,
 1155589546,
 3845,
 -1,
 1155607469,
 4052,
 -1,
 1155554095,
 3896,
 1155876076,
 1155172575,
 -1,
 1155941609,
 1155851739,
 -1,
 1156007144,
 1155910674,
 4050,
 -1,
 1155926547,
 3856,
 -1,
 1155971687,
 3854,
 1156251647,
 1155879858,
 -1,
 -47893,
 1156168200,
 3895,
 -1,
 1156223312,
 3893,
 1156400371,
 1155802742,
 -1,
 1156465906,
 1156364063,
 -1,
 1156531441,
 1156411528,
 -1,
 -47888,
 1156502936,
 3849,
 -1,
 1156519374,
 4048,
 -1,
 1156464730,
 3892,
 -1,
 1156411554,
 3850,
 1156859128,
 1156343600,
 -1,
 1156924663,
 1156804086,
 -1,
 -47882,
 1156900229,
 3844,
 -1,
 1156918161,
 4051,
 -1,
 1156892114,
 3851,
 1157186811,
 1156828163,
 -1,
 -47878,
 1157127165,
 3855,
 -1,
 1157174649,
 3897,
 1157383422,
 1157150495,
 -1,
 -47875,
 1157322953,
 3853,
 -1,
 1157377012,
 3848,
 1157580033,
 1157343572,
 -1,
 -47872,
 1157523255,
 3857,
 -1,
 1157584986,
 3858,
 1157776644,
 1157504641,
 -1,
 -47869,
 1157731629,
 3900,
 -1,
 1157767965,
 3901,
 -47867,
 1157752250,
 3847,
 -47866,
 1157931197,
 3973,
 -47865,
 1157989917,
 4049,
 -47864,
 1158044035,
 3972,
 -1,
 1158100870,
 3852,
 1158300965,
 1154365848,
 -1,
 1158366488,
 1158240656,
 -1,
 1158432014,
 1158333140,
 -1,
 -47859,
 1158406543,
 3883,
 -1,
 1158438998,
 3884,
 1158628625,
 1158395679,
 -1,
 -47856,
 1158573806,
 3887,
 -1,
 1158630530,
 3888,
 1158825236,
 1158565462,
 -1,
 -47853,
 1158781936,
 3885,
 -1,
 1158835831,
 3886,
 -47851,
 1158801301,
 3891,
 -47850,
 1158976959,
 3882,
 -47849,
 1159040188,
 3890,
 -1,
 1159087415,
 3889,
 1159283995,
 1158333140,
 -1,
 -47846,
 1159258511,
 3874,
 -1,
 1159290966,
 3875,
 1159480606,
 1159247647,
 -1,
 -47843,
 1159425774,
 3878,
 -1,
 1159482498,
 3879,
 1159677217,
 1159417430,
 -1,
 -47840,
 1159633904,
 3876,
 -1,
 1159687799,
 3877,
 -47838,
 1159653269,
 3872,
 -47837,
 1159828927,
 3873,
 -47836,
 1159892156,
 3881,
 -1,
 1159939383,
 3880,
 1160135990,
 1158274230,
 -1,
 1160201515,
 1160109071,
 -1,
 1160267049,
 1160161620,
 3958,
 -1,
 1160227156,
 3959,
 1160445951,
 1160213336,
 3960,
 -1,
 1160344408,
 3961,
 1160529197,
 1160171082,
 3956,
 -1,
 1160498762,
 3957,
 1160660271,
 1160490373,
 3968,
 -1,
 1160601983,
 3969,
 1160791345,
 1160614287,
 3964,
 -1,
 1160745359,
 3965,
 1160922419,
 1160733055,
 3954,
 -1,
 1160864127,
 3955,
 1161053493,
 1160855687,
 3962,
 -1,
 1160986759,
 3963,
 -1,
 1160975863,
 3953,
 1161250107,
 1160064458,
 -1,
 -47816,
 1161214038,
 4035,
 -47815,
 1161263806,
 4033,
 -47814,
 1161321419,
 4032,
 -1,
 1161375168,
 4034,
 1161577792,
 1161176133,
 -1,
 1161643327,
 1161541407,
 -1,
 -47810,
 1161582192,
 3863,
 -1,
 1161640732,
 3865,
 -1,
 1161564225,
 3864,
 1161953279,
 1161523980,
 4030,
 -1,
 1161822812,
 4031,
 1162036609,
 1143164970,
 -1,
 1162102144,
 1161984474,
 -1,
 1162167662,
 1162077166,
 -1,
 1162233195,
 1162089844,
 11568,
 1162298698,
 1162163744,
 11575,
 1162364233,
 1162229280,
 11577,
 -1,
 1162303627,
 11578,
 -1,
 1162303627,
 11576,
 1162560845,
 1162274590,
 11619,
 -47796,
 1162536734,
 11621,
 -1,
 1162565771,
 11594,
 1162757456,
 1162527444,
 11612,
 -47793,
 1162724052,
 11615,
 -1,
 1162762379,
 11613,
 1162954067,
 1162721055,
 11609,
 -47790,
 1162917663,
 11610,
 -1,
 1162958987,
 11611,
 1163150678,
 1162899592,
 11581,
 1163263999,
 1163090059,
 11589,
 -1,
 1163155595,
 11583,
 1163347289,
 1163088611,
 11571,
 1163460607,
 1163286667,
 11606,
 -1,
 1163352203,
 11572,
 1163543899,
 1163307348,
 11604,
 -1,
 1163503956,
 11605,
 1163674973,
 1163483275,
 11584,
 -1,
 1163614347,
 11587,
 1163806047,
 1163601526,
 11569,
 -1,
 1163745419,
 11570,
 -47776,
 1163781102,
 11618,
 -47775,
 1163910408,
 11617,
 -47774,
 1163974574,
 11616,
 -47773,
 1164027716,
 11591,
 -47772,
 1164091369,
 11602,
 -47771,
 1164151007,
 11599,
 -47770,
 1164214245,
 11598,
 -47769,
 1164276568,
 11597,
 -47768,
 1164341033,
 11574,
 -47767,
 1164398166,
 11580,
 -47766,
 1164455714,
 11614,
 -1,
 1164514676,
 11588,
 -47764,
 1162202698,
 11603,
 -47763,
 1164665215,
 11593,
 -1,
 1164725817,
 11579,
 1164920186,
 1162134228,
 -1,
 1164985721,
 1164889812,
 -1,
 1165051250,
 1164931208,
 11582,
 -1,
 1164990603,
 11590,
 1165182325,
 1164989155,
 -1,
 -47756,
 1165134047,
 11600,
 -1,
 1165187211,
 11607,
 -47754,
 1165158353,
 11596,
 -47753,
 1165338436,
 11592,
 -47752,
 1165396919,
 11601,
 -1,
 1165449355,
 11586,
 -1,
 1164912156,
 11620,
 1165706621,
 1164847236,
 -1,
 -47748,
 1165651753,
 11573,
 -1,
 1165711499,
 11585,
 1165950975,
 1165628788,
 -1,
 -47745,
 1165878611,
 11608,
 -1,
 1165908243,
 11595,
 -1,
 1162053212,
 11631,
 1166165392,
 1161983566,
 126,
 1166278655,
 1166082048,
 -1,
 1166296459,
 1166186368,
 8764,
 1166409727,
 1166213120,
 -1,
 1166427528,
 1166335858,
 -1,
 -47737,
 1166389979,
 10859,
 -1,
 1166424881,
 10858,
 1166671871,
 1166349947,
 -1,
 -47734,
 1166586015,
 10610,
 -1,
 1166637129,
 11081,
 1166868479,
 1166270322,
 -1,
 1166886287,
 1166752556,
 -1,
 -47730,
 1166813267,
 11807,
 -1,
 1166874229,
 11806,
 -1,
 1166848432,
 11803,
 1167148434,
 1166119226,
 10750,
 -1,
 1167068111,
 68410,
 1167279509,
 1167098931,
 -1,
 -47724,
 1167240996,
 10709,
 -1,
 1167292159,
 10708,
 -47722,
 1167242302,
 8266,
 -47721,
 1167414577,
 10053,
 -1,
 1167474869,
 10717,
 1167672985,
 1143095431,
 -1,
 1167738397,
 1167618904,
 -1,
 1167803929,
 1167708233,
 -1,
 1167869411,
 1167750738,
 -1,
 1167934946,
 1167838298,
 -1,
 1168000420,
 1167906734,
 -1,
 1168065955,
 1167954517,
 -1,
 1168131489,
 1168025940,
 3083,
 -1,
 1168091476,
 3168,
 1168310271,
 1168077656,
 3084,
 -1,
 1168208728,
 3169,
 -1,
 1167988084,
 3125,
 1168459179,
 1167966932,
 -1,
 1168524712,
 1168425684,
 -1,
 -47705,
 1168464041,
 3104,
 -1,
 1168512372,
 3103,
 -47703,
 1168488345,
 3160,
 -47702,
 1168660649,
 3109,
 -1,
 1168708980,
 3108,
 1168917938,
 1168389664,
 -1,
 1168983471,
 1168848416,
 -1,
 -47698,
 1168922793,
 3106,
 -1,
 1168971124,
 3105,
 -47696,
 1168959280,
 3161,
 -47695,
 1169119401,
 3111,
 -1,
 1169167732,
 3110,
 1169376695,
 1168869599,
 -1,
 -47692,
 1169351722,
 3102,
 -47691,
 1169393979,
 3107,
 -47690,
 1169445636,
 3097,
 -1,
 1169495412,
 3112,
 1169704379,
 1169298804,
 3077,
 -47687,
 1169673802,
 3092,
 -47686,
 1169711487,
 3088,
 -1,
 1169757556,
 3078,
 1169966527,
 1169667871,
 -1,
 -47683,
 1169930137,
 3127,
 -47682,
 1169971369,
 3126,
 -1,
 1170019700,
 3128,
 1170228673,
 1169935946,
 3081,
 -1,
 1170198090,
 3082,
 1170359748,
 1170188628,
 -1,
 -47677,
 1170319791,
 3121,
 -1,
 1170347380,
 3120,
 1170556359,
 1170317289,
 -1,
 -47674,
 1170495657,
 3115,
 -1,
 1170543988,
 3114,
 1170752969,
 1170510223,
 3090,
 -1,
 1170706831,
 3091,
 1170884044,
 1170699096,
 -1,
 -47669,
 1170830253,
 3123,
 -1,
 1170871668,
 3122,
 1171080655,
 1170829448,
 -1,
 -47666,
 1171019945,
 3094,
 -1,
 1171068276,
 3093,
 1171277266,
 1171025705,
 -1,
 -47663,
 1171216553,
 3101,
 -1,
 1171264884,
 3100,
 1171473876,
 1171218815,
 3079,
 -1,
 1171415423,
 3080,
 1171604951,
 1171411683,
 -1,
 -47658,
 1171544233,
 3096,
 -1,
 1171592564,
 3095,
 1171801561,
 1171538055,
 3086,
 -1,
 1171734663,
 3087,
 1171932636,
 1171729630,
 -1,
 -47653,
 1171871913,
 3099,
 -1,
 1171920244,
 3098,
 1172129247,
 1171859062,
 -1,
 -47650,
 1172068521,
 3117,
 -1,
 1172116852,
 3116,
 -47648,
 1172104234,
 3119,
 -47647,
 1172275250,
 3118,
 -1,
 1172330665,
 3129,
 -1,
 1167887440,
 3157,
 1172588021,
 1167842486,
 -1,
 1172653545,
 1172560911,
 -1,
 1172719079,
 1172613460,
 3139,
 -1,
 1172678996,
 3140,
 1172897791,
 1172665176,
 3170,
 -1,
 1172796248,
 3171,
 1172981229,
 1172575604,
 -1,
 -47637,
 1172950602,
 3148,
 -47636,
 1172988287,
 3144,
 -1,
 1173034356,
 3134,
 1173243375,
 1172950602,
 3137,
 -1,
 1173212746,
 3138,
 1173374449,
 1173197199,
 3146,
 -1,
 1173328271,
 3147,
 1173505523,
 1173315967,
 3135,
 -1,
 1173447039,
 3136,
 1173684223,
 1173438599,
 3142,
 -1,
 1173569671,
 3143,
 1173767683,
 1172519320,
 -1,
 1173833209,
 1173734100,
 -1,
 -47624,
 1173807503,
 3176,
 -1,
 1173839958,
 3177,
 1174029820,
 1173796639,
 -1,
 -47621,
 1173974766,
 3180,
 -1,
 1174031490,
 3181,
 1174226431,
 1173966422,
 -1,
 -47618,
 1174182896,
 3178,
 -1,
 1174236791,
 3179,
 -47616,
 1174202261,
 3174,
 -47615,
 1174377919,
 3175,
 -47614,
 1174441148,
 3183,
 -1,
 1174488375,
 3182,
 1174685199,
 1173705261,
 -1,
 1174750731,
 1174651604,
 -1,
 1174816264,
 1174725185,
 -1,
 -47609,
 1174770332,
 3194,
 -1,
 1174817942,
 3197,
 1175060479,
 1174757575,
 -1,
 -47606,
 1174966940,
 3195,
 -1,
 1175014550,
 3198,
 1175209486,
 1174705633,
 -1,
 -47603,
 1175163548,
 3193,
 -1,
 1175211158,
 3196,
 -1,
 1175185306,
 3192,
 1175471640,
 1174649904,
 -1,
 1175537171,
 1175444325,
 -1,
 -47598,
 1175500837,
 3075,
 -1,
 1175562893,
 3149,
 1175733782,
 1175459188,
 -1,
 -47595,
 1175705541,
 3133,
 -1,
 1175752901,
 3074,
 -47593,
 1175702845,
 3199,
 -1,
 1175858612,
 3073,
 -1,
 1175394597,
 3158,
 1176174591,
 1167739055,
 -1,
 -47589,
 1176091691,
 8481,
 -47588,
 1176153057,
 8981,
 -1,
 1176206540,
 9990,
 1176389267,
 1167706766,
 -1,
 1176454704,
 1176317150,
 -1,
 1176520233,
 1176408463,
 -1,
 1176585766,
 1176471775,
 -1,
 1176651301,
 1176552148,
 -1,
 -47581,
 1176611552,
 119563,
 -47580,
 1176651817,
 119582,
 -1,
 1176704917,
 119573,
 -1,
 1176617031,
 119608,
 1177026559,
 1176536971,
 -1,
 -47576,
 1176920686,
 119634,
 -1,
 1176980454,
 119630,
 1177175598,
 1176468901,
 -1,
 1177241133,
 1177108615,
 -1,
 -47572,
 1177193371,
 119590,
 -1,
 1177237048,
 119613,
 -1,
 1177212381,
 119631,
 -47569,
 1177115212,
 119585,
 -1,
 1177438256,
 119558,
 1177634366,
 1176385056,
 -1,
 1177699895,
 1177575807,
 -1,
 1177765429,
 1177649125,
 -1,
 -47564,
 1177716089,
 119625,
 -1,
 1177774427,
 119612,
 -47562,
 1177737676,
 119568,
 -1,
 1177898959,
 119636,
 1178093115,
 1177632903,
 -1,
 -47559,
 1178050927,
 119623,
 -47558,
 1178095440,
 119567,
 -1,
 1178153211,
 119586,
 -47556,
 1178064726,
 119584,
 -47555,
 1178311553,
 119619,
 -1,
 1178345958,
 119624,
 1178551879,
 1177567367,
 -1,
 1178617411,
 1178503391,
 -1,
 -47551,
 1178563956,
 119603,
 -47550,
 1178613603,
 119583,
 -1,
 1178678182,
 119600,
 -47548,
 1178592130,
 119626,
 -47547,
 1178846659,
 119610,
 -47546,
 1178895050,
 119618,
 -1,
 1178936118,
 119580,
 1179141713,
 1178511700,
 -1,
 1179207248,
 1179074695,
 -1,
 1179272782,
 1179170591,
 -1,
 1179338317,
 1179214207,
 -1,
 -47540,
 1179304000,
 119579,
 -1,
 1179334585,
 119596,
 -1,
 1179297099,
 119598,
 -47537,
 1179219574,
 119578,
 -1,
 1179522903,
 119572,
 -1,
 1179151964,
 119605,
 1179797082,
 1179078230,
 -1,
 1179862613,
 1179767030,
 -1,
 -47532,
 1179814811,
 119595,
 -1,
 1179845269,
 119559,
 1180059224,
 1179816335,
 -1,
 -47529,
 1180024939,
 119638,
 -1,
 1180073114,
 119576,
 -47527,
 1180007052,
 119606,
 -1,
 1180178797,
 119632,
 1180386914,
 1179760415,
 -1,
 1180452448,
 1180353236,
 -1,
 1180517983,
 1180406159,
 -1,
 -47522,
 1180489972,
 119601,
 -1,
 1180542352,
 119628,
 -1,
 1180478678,
 119593,
 -47519,
 1180395896,
 119621,
 -1,
 1180716250,
 119627,
 1180911208,
 1180324579,
 -1,
 1180976741,
 1180837111,
 119592,
 -1,
 1180894357,
 119615,
 -47514,
 1180946121,
 119614,
 -47513,
 1181068215,
 119602,
 -1,
 1181127594,
 119599,
 1181304430,
 1180868585,
 -1,
 1181369964,
 1181226356,
 -1,
 -47509,
 1181338720,
 119604,
 -1,
 1181364570,
 119588,
 -47507,
 1181341161,
 119594,
 -1,
 1181501331,
 119571,
 1181697651,
 1181226356,
 -1,
 -47504,
 1181661298,
 119564,
 -47503,
 1181701278,
 119633,
 -47502,
 1181761636,
 119577,
 -1,
 1181822588,
 119617,
 1182025335,
 1181646821,
 -1,
 -47499,
 1181969537,
 119560,
 -47498,
 1182024059,
 119609,
 -1,
 1182082025,
 119616,
 1182287484,
 1181971288,
 -1,
 1182353019,
 1182209396,
 -1,
 -47494,
 1182326036,
 119597,
 -1,
 1182346049,
 119637,
 -1,
 1182287031,
 119589,
 1182615168,
 1182213750,
 -1,
 -47490,
 1182575289,
 119566,
 -47489,
 1182635076,
 119587,
 -1,
 1182671451,
 119561,
 1182877315,
 1182588208,
 -1,
 -47486,
 1182844015,
 119620,
 -1,
 1182887421,
 119575,
 1183073926,
 1182830991,
 -1,
 -47483,
 1183032745,
 119565,
 -1,
 1183090943,
 119635,
 1183270537,
 1183019144,
 -1,
 -47480,
 1183213960,
 119591,
 -1,
 1183269739,
 119562,
 1183467148,
 1183213360,
 -1,
 -47477,
 1183419274,
 119622,
 -1,
 1183462326,
 119570,
 1183663759,
 1183406219,
 -1,
 -47474,
 1183618131,
 119574,
 -1,
 1183654239,
 119629,
 -47472,
 1183639131,
 119569,
 -47471,
 1183832268,
 119607,
 -47470,
 1183896257,
 119611,
 -1,
 1183936583,
 119581,
 1184122518,
 1176340703,
 -1,
 -47467,
 1184088788,
 9978,
 -1,
 1184125989,
 8376,
 1184366591,
 1184047463,
 -1,
 -47464,
 1184284479,
 10043,
 -1,
 1184311182,
 10170,
 1184515963,
 1167612043,
 -1,
 1184581471,
 1184437620,
 -1,
 1184646939,
 1184522625,
 -1,
 1184712461,
 1184574686,
 -1,
 1184777996,
 1184651926,
 -1,
 1184843445,
 1184741151,
 -1,
 1184908975,
 1184768148,
 -1,
 1184974503,
 1184830836,
 3632,
 1185040036,
 1184915875,
 -1,
 -47453,
 1185009349,
 3651,
 -1,
 1185028708,
 3652,
 -47451,
 1184989157,
 3635,
 -47450,
 1185169543,
 3649,
 -1,
 1185224052,
 3634,
 1185433259,
 1184943690,
 3640,
 1185498794,
 1185366151,
 3638,
 -1,
 1185431687,
 3639,
 -1,
 1185467978,
 3641,
 1185695405,
 1185374591,
 3636,
 -1,
 1185636735,
 3637,
 -47442,
 1185649039,
 3650,
 -1,
 1185759367,
 3648,
 1186004991,
 1184862609,
 -1,
 1186023092,
 1185920799,
 -1,
 -47438,
 1185992382,
 3626,
 -47437,
 1186042255,
 3595,
 -1,
 1186077270,
 3624,
 -1,
 1185986269,
 3625,
 1186350788,
 1184809684,
 -1,
 1186416321,
 1186289803,
 -1,
 1186481856,
 1186369937,
 -1,
 1186547390,
 1186448911,
 -1,
 1186612924,
 1186469236,
 -1,
 -47429,
 1186564319,
 3600,
 -1,
 1186617881,
 3607,
 -47427,
 1186583153,
 3606,
 -1,
 1186764307,
 3608,
 -47425,
 1186505598,
 3602,
 -1,
 1186892182,
 3601,
 -1,
 1186406249,
 3660,
 1187184639,
 1186369937,
 -1,
 -47421,
 1187103776,
 3605,
 -1,
 1187160451,
 3599,
 1187333840,
 1186299877,
 -1,
 1187399375,
 1187256610,
 -1,
 1187464909,
 1187315712,
 -1,
 1187530442,
 1187431124,
 -1,
 -47415,
 1187491321,
 3658,
 -1,
 1187536479,
 3657,
 -47413,
 1187469869,
 3633,
 -47412,
 1187661213,
 3656,
 -1,
 1187721049,
 3659,
 -47410,
 1187439723,
 3654,
 -1,
 1187890044,
 3655,
 -1,
 1187353006,
 3617,
 1188120283,
 1187278984,
 -1,
 1188185818,
 1188060767,
 -1,
 1188251353,
 1188102144,
 -1,
 1188316888,
 1188196868,
 -1,
 -47403,
 1188289863,
 3588,
 -47402,
 1188351709,
 3587,
 -47401,
 1188402477,
 3589,
 -1,
 1188436258,
 3586,
 -1,
 1188276841,
 3590,
 -1,
 1188202655,
 3675,
 -1,
 1188139432,
 3585,
 1188841189,
 1188077545,
 -1,
 1188906723,
 1188780171,
 -1,
 1188972258,
 1188860305,
 -1,
 1189037793,
 1188930351,
 -1,
 -47392,
 1189007985,
 3612,
 -1,
 1189027134,
 3614,
 -1,
 1189001190,
 3616,
 -1,
 1188915824,
 3642,
 -47388,
 1188860343,
 3611,
 -1,
 1189288365,
 3631,
 1189496555,
 1188792543,
 -1,
 1189562089,
 1189450163,
 -1,
 -47384,
 1189531210,
 3609,
 -1,
 1189562097,
 3603,
 -47382,
 1189504443,
 3661,
 -1,
 1189697056,
 3591,
 1189889777,
 1189442392,
 -1,
 1189955311,
 1189843345,
 -1,
 -47378,
 1189903195,
 3621,
 -1,
 1189949458,
 3628,
 -47376,
 1189924426,
 3622,
 -1,
 1190074852,
 3653,
 1190282998,
 1189818315,
 -1,
 1190348532,
 1190206782,
 3592,
 -1,
 1190286051,
 3594,
 -47371,
 1190302421,
 3596,
 -1,
 1190422695,
 3593,
 1190610683,
 1190257646,
 -1,
 1190676218,
 1190564307,
 -1,
 -47367,
 1190619303,
 3597,
 -1,
 1190664640,
 3618,
 -1,
 1190599811,
 3662,
 1190938367,
 1190547828,
 -1,
 1191003902,
 1190855603,
 3613,
 -1,
 1190955231,
 3615,
 -1,
 1190956088,
 3663,
 1191200514,
 1190898004,
 -1,
 -47359,
 1191169610,
 3620,
 -1,
 1191219645,
 3619,
 1191397125,
 1191140962,
 -1,
 -47356,
 1191349678,
 3630,
 -1,
 1191402909,
 3627,
 1191593736,
 1191328455,
 -1,
 -47353,
 1191524211,
 3604,
 -1,
 1191587640,
 3598,
 -47351,
 1191568005,
 3623,
 -47350,
 1191743892,
 3629,
 -47349,
 1191783065,
 3610,
 -1,
 1191845546,
 3674,
 -1,
 1184749107,
 3647,
 1192165375,
 1184643480,
 -1,
 1192183569,
 1192084180,
 -1,
 -47344,
 1192157583,
 3666,
 -1,
 1192190038,
 3667,
 1192380180,
 1192146719,
 -1,
 -47341,
 1192324846,
 3670,
 -1,
 1192381570,
 3671,
 1192576791,
 1192316502,
 -1,
 -47338,
 1192532976,
 3668,
 -1,
 1192586871,
 3669,
 -47336,
 1192552341,
 3664,
 -47335,
 1192727999,
 3665,
 -47334,
 1192791228,
 3673,
 -1,
 1192838455,
 3672,
 1193082879,
 1184570705,
 -1,
 1193101137,
 1192983002,
 -1,
 1193166627,
 1193067220,
 -1,
 1193232160,
 1193105580,
 1932,
 -1,
 1193180955,
 1947,
 -47327,
 1193198372,
 1944,
 -47326,
 1193316751,
 1952,
 -1,
 1193354750,
 1939,
 1193559849,
 1193129759,
 -1,
 1193625383,
 1193498763,
 -1,
 -47322,
 1193558886,
 1949,
 -1,
 1193616894,
 1921,
 -47320,
 1193558886,
 1936,
 -1,
 1193743866,
 1950,
 1193953070,
 1193535262,
 -1,
 1194018605,
 1193874804,
 -1,
 -47316,
 1193991173,
 1938,
 -1,
 1194005876,
 1948,
 -1,
 1193972111,
 1953,
 1194280754,
 1193890531,
 -1,
 -47312,
 1194232322,
 1935,
 -47311,
 1194285408,
 1955,
 -1,
 1194333700,
 1934,
 1194542903,
 1194210848,
 -1,
 1194608438,
 1194464628,
 -1,
 -47307,
 1194580997,
 1937,
 -1,
 1194596373,
 1951,
 -1,
 1194547376,
 1931,
 1194870586,
 1194494175,
 -1,
 -47303,
 1194825419,
 1922,
 -1,
 1194857975,
 1969,
 1195067197,
 1194816344,
 -1,
 -47300,
 1195006738,
 1925,
 -1,
 1195054607,
 1933,
 1195263808,
 1195012232,
 -1,
 -47297,
 1195202732,
 1946,
 -1,
 1195251204,
 1926,
 1195460419,
 1195202699,
 -1,
 -47294,
 1195399340,
 1945,
 -1,
 1195447799,
 1920,
 1195657030,
 1195382132,
 -1,
 -47291,
 1195604615,
 1927,
 -1,
 1195666055,
 1954,
 -47289,
 1195631665,
 1940,
 -47288,
 1195826492,
 1957,
 -47287,
 1195890623,
 1928,
 -47286,
 1195944386,
 1923,
 -47285,
 1196009298,
 1956,
 -47284,
 1196073353,
 1941,
 -47283,
 1196131259,
 1929,
 -47282,
 1196191548,
 1942,
 -47281,
 1196248770,
 1930,
 -47280,
 1196306274,
 1943,
 -1,
 1196369579,
 1924,
 1196574549,
 1193054607,
 -1,
 -47277,
 1196528177,
 1963,
 -47276,
 1196567213,
 1966,
 -1,
 1196627559,
 1967,
 1196836697,
 1196507271,
 -1,
 -47273,
 1196811435,
 1965,
 -47272,
 1196835330,
 1961,
 -1,
 1196894251,
 1964,
 1197098844,
 1196758388,
 -1,
 -47269,
 1197024986,
 1958,
 -1,
 1197086246,
 1959,
 -47267,
 1197068256,
 1962,
 -47266,
 1197261237,
 1968,
 -1,
 1197302489,
 1960,
 1197492080,
 1184541776,
 -1,
 1197557611,
 1197408256,
 -1,
 1197623142,
 1197503320,
 -1,
 1197688677,
 1197566095,
 -1,
 -47260,
 1197649505,
 9886,
 -1,
 1197700741,
 9887,
 -1,
 1197622340,
 11057,
 1197950825,
 1197553184,
 -1,
 -47256,
 1197906543,
 8278,
 -1,
 1197958827,
 10176,
 -47254,
 1197912279,
 8694,
 -1,
 1198076537,
 10870,
 1198325759,
 1197477587,
 -1,
 1198344047,
 1198208546,
 -1,
 -47250,
 1198312005,
 10146,
 -1,
 1198336797,
 10147,
 -1,
 1198301785,
 8196,
 1198606199,
 1197427039,
 -1,
 1198671734,
 1198538887,
 -1,
 1198737269,
 1198587904,
 -1,
 -47244,
 1198673291,
 8707,
 -1,
 1198734039,
 8708,
 -1,
 1198674312,
 8756,
 -1,
 1198622366,
 10727,
 1199064954,
 1198576194,
 -1,
 -47239,
 1199030478,
 9736,
 -1,
 1199047331,
 9928,
 -1,
 1199007605,
 8201,
 1199327143,
 1184475476,
 -1,
 1199392675,
 1199268223,
 -1,
 1199458192,
 1199350796,
 -1,
 1199523715,
 1199430249,
 -1,
 -47232,
 1199497267,
 10997,
 -47231,
 1199550527,
 8874,
 -47230,
 1199585148,
 10624,
 -1,
 1199647076,
 10996,
 1199851398,
 1199480809,
 -1,
 -47227,
 1199813019,
 8244,
 -1,
 1199865701,
 10747,
 1200048009,
 1199803296,
 -1,
 -47224,
 1199995215,
 10999,
 -1,
 1200051959,
 11000,
 1200244620,
 1199988455,
 -1,
 -47221,
 1200212892,
 10857,
 -1,
 1200242101,
 10856,
 -47219,
 1200211964,
 8779,
 -47218,
 1200406177,
 11003,
 -47217,
 1200449987,
 8749,
 -1,
 1200501233,
 10998,
 1200703386,
 1199396490,
 -1,
 1200768916,
 1200676104,
 -1,
 -47213,
 1200711647,
 9780,
 -1,
 1200759978,
 9781,
 -47211,
 1200736174,
 9779,
 -47210,
 1200916307,
 9782,
 -47209,
 1200977069,
 9777,
 -47208,
 1201036159,
 9776,
 -47207,
 1201098897,
 9778,
 -1,
 1201160548,
 9783,
 1201358754,
 1200627296,
 -1,
 1201424289,
 1201305170,
 -1,
 1201489824,
 1201343523,
 -1,
 -47202,
 1201459799,
 10699,
 -47201,
 1201519036,
 10701,
 -1,
 1201552177,
 10698,
 -1,
 1201410005,
 10141,
 -1,
 1201393858,
 8227,
 -1,
 1201287659,
 8285,
 1201948582,
 1199314292,
 -1,
 -47195,
 1201901325,
 10971,
 -1,
 1201944397,
 8482,
 -1,
 1201917966,
 8872,
 1202210765,
 1199280527,
 -1,
 1202276284,
 1202167787,
 -1,
 1202341806,
 1202237031,
 -1,
 1202407341,
 1202269406,
 -1,
 -47188,
 1202369636,
 8974,
 -1,
 1202428268,
 8989,
 -1,
 1202346409,
 11811,
 1202669491,
 1202288266,
 -1,
 1202735026,
 1202597086,
 -1,
 -47183,
 1202697316,
 8975,
 -1,
 1202755948,
 8988,
 -1,
 1202674089,
 11810,
 1202997175,
 1202594081,
 -1,
 1203062710,
 1202921331,
 10554,
 -1,
 1202982405,
 10557,
 -1,
 1202991483,
 10556,
 -47176,
 1202965101,
 9184,
 -47175,
 1203224414,
 9140,
 -47174,
 1203282214,
 9180,
 -47173,
 1203329478,
 8992,
 -1,
 1203385749,
 9182,
 1203587020,
 1202239054,
 -1,
 1203652555,
 1203515662,
 -1,
 1203718082,
 1203573889,
 -1,
 -47168,
 1203639558,
 127552,
 -47167,
 1203704945,
 127560,
 -1,
 1203770171,
 127557,
 1203980229,
 1203639494,
 -1,
 -47164,
 1203901634,
 127558,
 -1,
 1203966475,
 127556,
 1204176840,
 1203901449,
 -1,
 -47161,
 1204102820,
 127555,
 -1,
 1204163397,
 127559,
 1204420607,
 1204098054,
 -1,
 -47158,
 1204294970,
 127554,
 -1,
 1204359688,
 127553,
 -1,
 1203598816,
 127274,
 -1,
 1203553208,
 9008,
 1204701150,
 1202179658,
 -1,
 1204766685,
 1204663225,
 -1,
 1204832213,
 1204729631,
 -1,
 1204897748,
 1204756245,
 -1,
 -47150,
 1204872174,
 8516,
 -47149,
 1204908888,
 8514,
 -1,
 1204966115,
 8513,
 -1,
 1204846969,
 8526,
 1205225432,
 1204753780,
 -1,
 -47145,
 1205177343,
 10658,
 -1,
 1205241713,
 8523,
 -47143,
 1205198577,
 9929,
 -47142,
 1205374601,
 8985,
 -47141,
 1205426105,
 8489,
 -47140,
 1205480944,
 8498,
 -1,
 1205545525,
 9930,
 -1,
 1204705246,
 8366,
 1205862399,
 1204673800,
 -1,
 1205880814,
 1205768593,
 -1,
 1205946341,
 1205812008,
 -1,
 1206011876,
 1205862400,
 -1,
 -47133,
 1205970671,
 8282,
 -1,
 1206023791,
 8229,
 -1,
 1205974894,
 11818,
 1206274024,
 1205894381,
 -1,
 -47129,
 1206229090,
 10760,
 -1,
 1206263289,
 10759,
 1206470635,
 1206217246,
 -1,
 -47126,
 1206425590,
 10838,
 -1,
 1206459751,
 10837,
 -47124,
 1206415389,
 10697,
 -47123,
 1206596217,
 10869,
 -1,
 1206658061,
 8273,
 -1,
 1205814834,
 10041,
 1206930780,
 1105966879,
 -1,
 1206995308,
 1206888388,
 -1,
 1207060843,
 1206954884,
 -1,
 1207126303,
 1206976512,
 -1,
 1207191588,
 1207074789,
 -1,
 1207257085,
 1207160396,
 -1,
 -47114,
 1207229704,
 13244,
 -47113,
 1207293870,
 13238,
 -47112,
 1207351071,
 13234,
 -47111,
 1207402469,
 13211,
 -47110,
 1207464792,
 13205,
 -47109,
 1207522019,
 13197,
 -47108,
 1207586390,
 13196,
 -1,
 1207637364,
 13186,
 1207846916,
 1207178612,
 13187,
 1207912449,
 1207787903,
 -1,
 -47104,
 1207875178,
 13124,
 -1,
 1207923486,
 13123,
 -47102,
 1207875212,
 13126,
 -47101,
 1208061731,
 13127,
 -1,
 1208114309,
 13125,
 1208305675,
 1207762944,
 -1,
 1208371209,
 1208258959,
 -1,
 1208436744,
 1208342964,
 13223,
 -1,
 1208355446,
 13224,
 -1,
 1208376899,
 13249,
 -47094,
 1208336237,
 13217,
 -1,
 1208563049,
 13221,
 1208764432,
 1208246655,
 -1,
 1208829966,
 1208724985,
 13129,
 -1,
 1208755887,
 13130,
 -47089,
 1208775512,
 13269,
 -1,
 1208906531,
 13128,
 1209092116,
 1208713189,
 13212,
 1209204735,
 1209008128,
 -1,
 -47085,
 1209122669,
 13215,
 -1,
 1209152873,
 13219,
 1209354264,
 1209024647,
 -1,
 1209419799,
 1209291524,
 13131,
 -1,
 1209387424,
 13132,
 -1,
 1209355252,
 13133,
 1209616410,
 1209326856,
 13245,
 -1,
 1209533902,
 13247,
 1209747484,
 1209587630,
 13239,
 -1,
 1209664974,
 13241,
 1209878558,
 1209673334,
 13190,
 -1,
 1209797214,
 13268,
 -47073,
 1209841439,
 13235,
 -47072,
 1209966670,
 13227,
 -47071,
 1210029074,
 13270,
 -47070,
 1210086232,
 13206,
 -47069,
 1210147196,
 13202,
 -1,
 1210208995,
 13198,
 1210402887,
 1207136392,
 -1,
 1210468395,
 1210351589,
 13214,
 1210580991,
 1210384384,
 -1,
 1210599466,
 1210461406,
 -1,
 -47063,
 1210568441,
 13222,
 -1,
 1210589134,
 13262,
 -1,
 1210564461,
 13218,
 1210861615,
 1210412200,
 13076,
 -47059,
 1210834424,
 13079,
 -47058,
 1210876865,
 13078,
 -1,
 1210931264,
 13077,
 1211123764,
 1210783092,
 13188,
 1211189299,
 1211083092,
 -1,
 -47054,
 1211144425,
 13069,
 -1,
 1211180405,
 13068,
 -1,
 1211133075,
 13067,
 1211451447,
 1211094399,
 -1,
 -47050,
 1211422619,
 13082,
 -1,
 1211471558,
 13083,
 1211648058,
 1211404687,
 -1,
 -47047,
 1211610800,
 13085,
 -1,
 1211668361,
 13086,
 -47045,
 1211623140,
 13074,
 -47044,
 1211817224,
 13246,
 -47043,
 1211881390,
 13240,
 -47042,
 1211941588,
 13263,
 -47041,
 1211998286,
 13226,
 -47040,
 1212052312,
 13208,
 -47039,
 1212117128,
 13261,
 -47038,
 1212178812,
 13201,
 -47037,
 1212240611,
 13199,
 -47036,
 1212302200,
 13084,
 -47035,
 1212362062,
 13193,
 -47034,
 1212425846,
 13189,
 -1,
 1212483146,
 13248,
 1212696676,
 1210359785,
 -1,
 1212762190,
 1212629127,
 -1,
 1212827724,
 1212713183,
 -1,
 -47029,
 1212793208,
 13114,
 -1,
 1212835217,
 13112,
 -47027,
 1212792437,
 13111,
 -1,
 1212960333,
 13115,
 1213155411,
 1212683636,
 13225,
 1213220946,
 1213076852,
 -1,
 -47023,
 1213189257,
 13100,
 -1,
 1213249912,
 13099,
 -1,
 1213137008,
 13184,
 1213483096,
 1213096319,
 -1,
 1213548631,
 1213427848,
 -1,
 -47018,
 1213519448,
 13103,
 -1,
 1213567375,
 13104,
 -1,
 1213473892,
 13102,
 1213810779,
 1213436303,
 -1,
 -47014,
 1213762287,
 13120,
 -1,
 1213819510,
 13117,
 -47012,
 1213783304,
 13242,
 -47011,
 1213978542,
 13236,
 -47010,
 1214035743,
 13232,
 -47009,
 1214097748,
 13274,
 -47008,
 1214162083,
 13273,
 -47007,
 1214218213,
 13272,
 -47006,
 1214273675,
 13271,
 -47005,
 1214336598,
 13194,
 -1,
 1214393566,
 13174,
 1214597244,
 1212669192,
 -1,
 1214662778,
 1214541268,
 -1,
 1214728301,
 1214633049,
 -1,
 1214793834,
 1214688871,
 -1,
 -46999,
 1214761290,
 9640,
 -1,
 1214789875,
 11028,
 1215037439,
 1214740106,
 -1,
 -46996,
 1214957917,
 9639,
 -1,
 1214986483,
 9705,
 1215187058,
 1214673752,
 -1,
 1215252593,
 1215143750,
 -1,
 -46992,
 1215213281,
 9706,
 -1,
 1215264448,
 11029,
 -1,
 1215185856,
 9703,
 -46989,
 1215158983,
 9637,
 -46988,
 1215482387,
 11026,
 -46987,
 1215541028,
 9704,
 -46986,
 1215601081,
 9638,
 -46985,
 1215651634,
 9636,
 -46984,
 1215707354,
 9641,
 -46983,
 1215771438,
 10720,
 -1,
 1215834862,
 11027,
 -46981,
 1214588534,
 13277,
 -1,
 1215964533,
 13143,
 1216170128,
 1214535819,
 -1,
 1216235649,
 1216138826,
 -1,
 -46977,
 1216195227,
 13109,
 -46976,
 1216243106,
 13107,
 -1,
 1216291020,
 13106,
 1216497798,
 1216188815,
 -1,
 1216563333,
 1216450959,
 -1,
 -46972,
 1216525930,
 13121,
 -1,
 1216579807,
 13122,
 -1,
 1216514271,
 13119,
 1216825480,
 1216454633,
 13259,
 -1,
 1216746868,
 13169,
 1216956555,
 1216757895,
 -1,
 -46966,
 1216919266,
 13113,
 -1,
 1216967478,
 13110,
 1217153165,
 1216877940,
 13258,
 -1,
 1217097304,
 13098,
 -46962,
 1217128222,
 13200,
 -46961,
 1217227781,
 127488,
 -1,
 1217286883,
 13004,
 1217480863,
 1216107235,
 -1,
 1217546389,
 1217421695,
 -1,
 -46957,
 1217508983,
 13075,
 -46956,
 1217563824,
 13073,
 -1,
 1217614596,
 13072,
 1217808537,
 1217467764,
 -1,
 -46953,
 1217770554,
 13070,
 -46952,
 1217826166,
 13071,
 -1,
 1217885016,
 13311,
 1218070683,
 1217779125,
 13080,
 -1,
 1218038176,
 13081,
 -46948,
 1218044910,
 13257,
 -46947,
 1218158670,
 13228,
 -46946,
 1218208124,
 13203,
 -1,
 1218258550,
 13191,
 1218463918,
 1217440084,
 -1,
 1218529444,
 1218404735,
 -1,
 -46942,
 1218497667,
 13137,
 -46941,
 1218554287,
 13138,
 -1,
 1218598155,
 10958,
 1218791591,
 1218451414,
 13229,
 1218904063,
 1218709497,
 13230,
 -1,
 1218775670,
 13231,
 1218988202,
 1218760266,
 -1,
 -46935,
 1218957288,
 13140,
 -1,
 1219011496,
 13139,
 1219184813,
 1218920583,
 -1,
 -46932,
 1219137524,
 13142,
 -1,
 1219200945,
 13141,
 -1,
 1219139280,
 8730,
 1219446972,
 1218391262,
 -1,
 1219512499,
 1219395557,
 13213,
 1219624959,
 1219428352,
 -1,
 -46926,
 1219542893,
 13216,
 -1,
 1219573097,
 13220,
 1219774645,
 1219465615,
 13255,
 -1,
 1219736914,
 13183,
 1219905720,
 1219695988,
 -1,
 -46921,
 1219862505,
 8851,
 -1,
 1219916632,
 13192,
 -46919,
 1219875588,
 8852,
 -46918,
 1220032032,
 13253,
 -46917,
 1220095198,
 13252,
 -1,
 1220151153,
 13254,
 1220364488,
 1219376672,
 -1,
 1220430017,
 1220313061,
 13175,
 1220542463,
 1220345856,
 -1,
 -46912,
 1220460397,
 13176,
 -1,
 1220490601,
 13177,
 1220692163,
 1220351348,
 13170,
 -1,
 1220617304,
 13092,
 -46908,
 1220647414,
 13094,
 -46907,
 1220768600,
 13207,
 -46906,
 1220833065,
 127376,
 -46905,
 1220889249,
 13093,
 -1,
 1220945526,
 13256,
 1221150929,
 1220315359,
 -1,
 1221216459,
 1221072244,
 13185,
 -1,
 1221168526,
 13096,
 -46900,
 1221188872,
 13243,
 -46899,
 1221318574,
 13237,
 -46898,
 1221375775,
 13233,
 -46897,
 1221434138,
 13097,
 -46896,
 1221492709,
 13210,
 -1,
 1221545558,
 13195,
 1221740764,
 1221083271,
 -1,
 1221806297,
 1221699924,
 -1,
 1221871832,
 1221727629,
 -1,
 -46891,
 1221837709,
 13181,
 -46890,
 1221903041,
 13180,
 -46889,
 1221952462,
 13182,
 -1,
 1222007834,
 13179,
 -1,
 1221808867,
 13005,
 -46886,
 1221777326,
 13006,
 -46885,
 1222230459,
 13063,
 -1,
 1222264237,
 13064,
 1222461670,
 1221703455,
 -1,
 1222527200,
 1222395842,
 -1,
 -46881,
 1222480271,
 13091,
 -1,
 1222533503,
 13090,
 1222723811,
 1222448500,
 -1,
 -46878,
 1222676423,
 13088,
 -1,
 1222731223,
 13087,
 -46876,
 1222694830,
 13276,
 -46875,
 1222879572,
 13275,
 -1,
 1222929559,
 13089,
 1223117039,
 1222402431,
 -1,
 1223182570,
 1223067871,
 13260,
 -46871,
 1223149498,
 13061,
 -1,
 1223190804,
 13060,
 1223379182,
 1223131246,
 8847,
 1223491583,
 1223296671,
 -1,
 -46867,
 1223396965,
 8932,
 -1,
 1223444743,
 8849,
 -1,
 1223347786,
 13178,
 1223706872,
 1223042678,
 -1,
 1223772403,
 1223628148,
 -1,
 -46862,
 1223731540,
 13172,
 -1,
 1223762307,
 13101,
 -46860,
 1223743182,
 13108,
 -46859,
 1223927620,
 13251,
 -46858,
 1223989754,
 13118,
 -46857,
 1224043752,
 13105,
 -1,
 1224098685,
 13116,
 1224296704,
 1223628148,
 -1,
 -46854,
 1224265290,
 13171,
 -46853,
 1224324737,
 13057,
 -46852,
 1224384627,
 13056,
 -46851,
 1224445648,
 13058,
 -46850,
 1224507365,
 13250,
 -46849,
 1224549102,
 13059,
 -1,
 1224607654,
 13279,
 1224821000,
 1224249743,
 -1,
 1224886533,
 1224782164,
 8848,
 1224998911,
 1224803999,
 -1,
 -46844,
 1224904293,
 8933,
 -1,
 1224952071,
 8850,
 -46842,
 1224857518,
 13173,
 -46841,
 1225102633,
 13066,
 -1,
 1225166563,
 13065,
 1225345296,
 1224766296,
 -1,
 1225410828,
 1225298319,
 -1,
 -46837,
 1225385867,
 8977,
 -1,
 1225413347,
 13266,
 -46835,
 1225384708,
 13267,
 -46834,
 1225558239,
 13265,
 -46833,
 1225621477,
 13264,
 -1,
 1225671640,
 10957,
 1225869589,
 1225319406,
 -1,
 1225935124,
 1225790967,
 -1,
 -46829,
 1225897578,
 13135,
 -1,
 1225931460,
 13134,
 -1,
 1225903813,
 13136,
 1226197274,
 1225805398,
 -1,
 1226262809,
 1226150287,
 -1,
 -46824,
 1226233218,
 9974,
 -1,
 1226283594,
 9165,
 -1,
 1226211301,
 13209,
 1226524957,
 1226162900,
 -1,
 -46820,
 1226478893,
 13095,
 -1,
 1226531196,
 13204,
 -46818,
 1226495920,
 13278,
 -1,
 1226691319,
 13062,
 1226899455,
 1207055906,
 -1,
 1226918222,
 1226780942,
 -1,
 1226983729,
 1226839049,
 -1,
 1227049253,
 1226904897,
 -1,
 -46812,
 1226969919,
 127511,
 -1,
 1227035297,
 127509,
 1227245864,
 1226969932,
 -1,
 -46809,
 1227181752,
 127534,
 -1,
 1227239010,
 127506,
 1227442475,
 1227166375,
 -1,
 -46806,
 1227363331,
 127516,
 -1,
 1227428516,
 127520,
 -46804,
 1227378363,
 127517,
 -46803,
 1227568986,
 127532,
 -46802,
 1227630237,
 127505,
 -46801,
 1227691325,
 127524,
 -46800,
 1227756540,
 127525,
 -1,
 1227821725,
 127518,
 1228032318,
 1226904705,
 -1,
 1228097846,
 1227952807,
 -1,
 -46796,
 1228019050,
 127527,
 -46795,
 1228084331,
 127537,
 -1,
 1228149760,
 127504,
 1228359993,
 1228018697,
 -1,
 -46792,
 1228285570,
 127519,
 -1,
 1228346733,
 127515,
 1228556604,
 1228280652,
 -1,
 -46789,
 1228477550,
 127528,
 -1,
 1228542469,
 127535,
 -46787,
 1228492468,
 127526,
 -1,
 1228674238,
 127513,
 1228884293,
 1227953158,
 -1,
 1228949826,
 1228804495,
 -1,
 -46783,
 1228870977,
 127530,
 -1,
 1228935567,
 127529,
 -46781,
 1228871156,
 127512,
 -46780,
 1229067578,
 127508,
 -1,
 1229132610,
 127533,
 1229343049,
 1228805389,
 -1,
 -46777,
 1229272711,
 127536,
 -46776,
 1229335870,
 127523,
 -1,
 1229395312,
 127510,
 1229605197,
 1229264070,
 -1,
 -46773,
 1229534851,
 127521,
 -46772,
 1229591655,
 127522,
 -1,
 1229656719,
 127514,
 -1,
 1229526373,
 127531,
 1229932884,
 1226880799,
 -1,
 -46768,
 1229895455,
 127309,
 -46767,
 1229957151,
 10696,
 -46766,
 1230012738,
 10695,
 -46765,
 1230059040,
 127308,
 -1,
 1230117984,
 9949,
 1230326106,
 1229878730,
 -1,
 -46762,
 1230298376,
 127302,
 -46761,
 1230354207,
 127298,
 -46760,
 1230413801,
 127295,
 -46759,
 1230473439,
 127293,
 -1,
 1230513782,
 127281,
 1230719325,
 1230282729,
 -1,
 -46756,
 1230677818,
 127310,
 -1,
 1230733157,
 8862,
 1230915936,
 1230667749,
 -1,
 -46753,
 1230886830,
 127307,
 -1,
 1230924451,
 8863,
 1231112547,
 1230860424,
 -1,
 -46750,
 1231048249,
 9919,
 -1,
 1231103122,
 127507,
 1231309158,
 1231048278,
 -1,
 -46747,
 1231264761,
 11820,
 -1,
 1231297530,
 10693,
 -46745,
 1231276094,
 8864,
 -46744,
 1231467205,
 10692,
 -46743,
 1231511879,
 127306,
 -46742,
 1231567740,
 8865,
 -1,
 1231627268,
 10694,
 -1,
 1207026409,
 10151,
 1231899211,
 1206969326,
 -1,
 1231964630,
 1231859196,
 -1,
 1232030104,
 1231911386,
 -1,
 1232095608,
 1231992607,
 -1,
 1232161140,
 1232048936,
 -1,
 -46734,
 1232136163,
 1869,
 -46733,
 1232171571,
 1870,
 -1,
 1232228134,
 1871,
 -46731,
 1232131103,
 1809,
 -46730,
 1232362883,
 1835,
 -46729,
 1232422590,
 1827,
 -1,
 1232476176,
 1832,
 1232685437,
 1232052653,
 1830,
 1232797695,
 1232647681,
 -1,
 -46725,
 1232688334,
 1838,
 -46724,
 1232746623,
 1839,
 -1,
 1232808263,
 1837,
 1233013121,
 1232650964,
 -1,
 1233078656,
 1232948194,
 1819,
 -1,
 1232995341,
 1820,
 -1,
 1233004053,
 1836,
 1233275267,
 1232987866,
 1821,
 -1,
 1233192016,
 1822,
 1233406342,
 1233234260,
 -1,
 -46715,
 1233349897,
 1834,
 -1,
 1233407271,
 1831,
 1233602952,
 1233345320,
 1815,
 -1,
 1233569295,
 1818,
 1233734026,
 1233539929,
 1811,
 -1,
 1233650701,
 1812,
 1233865101,
 1233663520,
 -1,
 -46708,
 1233820391,
 1814,
 -1,
 1233853061,
 1813,
 -46706,
 1233839942,
 1817,
 -46705,
 1234034223,
 1816,
 -46704,
 1234085771,
 1833,
 -46703,
 1234145447,
 1826,
 -46702,
 1234208094,
 1825,
 -46701,
 1234269385,
 1824,
 -46700,
 1234333969,
 1823,
 -46699,
 1234391142,
 1828,
 -46698,
 1234452615,
 1829,
 -46697,
 1234512175,
 1810,
 -1,
 1234573929,
 1808,
 1234782627,
 1231968395,
 -1,
 1234848158,
 1234708413,
 -1,
 1234913693,
 1234763776,
 -1,
 -46692,
 1234839635,
 1851,
 -1,
 1234900597,
 1850,
 -1,
 1234833252,
 1852,
 1235175842,
 1234772485,
 -1,
 -46688,
 1235128834,
 1803,
 -46687,
 1235190883,
 1804,
 -1,
 1235231737,
 1805,
 -1,
 1235130651,
 1797,
 1235503532,
 1234747768,
 -1,
 1235569064,
 1235461601,
 -1,
 1235634599,
 1235497451,
 1795,
 -1,
 1235552818,
 1800,
 -1,
 1235571394,
 1793,
 1235877887,
 1235495559,
 -1,
 1235896747,
 1235759595,
 1796,
 -1,
 1235814975,
 1801,
 -1,
 1235833538,
 1794,
 1236093363,
 1235469012,
 -1,
 1236158896,
 1236066931,
 -1,
 -46673,
 1236084819,
 1860,
 -1,
 1236145781,
 1859,
 1236402175,
 1236099202,
 -1,
 -46670,
 1236281427,
 1862,
 -1,
 1236342389,
 1861,
 1236552121,
 1236052308,
 -1,
 1236617655,
 1236477890,
 -1,
 -46666,
 1236543571,
 1847,
 -1,
 1236604533,
 1846,
 -46664,
 1236589890,
 1855,
 -1,
 1236783261,
 1858,
 1236945341,
 1236527180,
 -1,
 -46661,
 1236876256,
 1845,
 -46660,
 1236936787,
 1844,
 -1,
 1236997749,
 1843,
 1237207489,
 1236903640,
 -1,
 -46657,
 1237138400,
 1842,
 -46656,
 1237198931,
 1841,
 -1,
 1237259893,
 1840,
 1237469638,
 1237139591,
 -1,
 1237535173,
 1237432363,
 -1,
 -46652,
 1237461075,
 1854,
 -1,
 1237522037,
 1853,
 -1,
 1237486191,
 1792,
 1237797323,
 1237397992,
 -1,
 1237862858,
 1237744918,
 -1,
 -46647,
 1237823073,
 1799,
 -1,
 1237874309,
 1798,
 -1,
 1237815291,
 1802,
 1238125006,
 1237750296,
 -1,
 -46643,
 1238050899,
 1864,
 -1,
 1238111861,
 1863,
 1238321617,
 1238056001,
 -1,
 -46640,
 1238261453,
 1848,
 -1,
 1238310608,
 1849,
 -46638,
 1238280522,
 1857,
 -46637,
 1238468736,
 1865,
 -46636,
 1238519703,
 1856,
 -46635,
 1238575029,
 1866,
 -1,
 1238636079,
 1807,
 1238845970,
 1231912436,
 -1,
 1238911491,
 1238792666,
 -1,
 1238976990,
 1238876884,
 -1,
 1239042524,
 1238942420,
 -1,
 -46629,
 1238995343,
 43024,
 -1,
 1239047775,
 43025,
 -46627,
 1238995343,
 43028,
 -1,
 1239178847,
 43029,
 1239370212,
 1238906400,
 -1,
 1239435746,
 1239299616,
 -1,
 -46623,
 1239388559,
 43026,
 -1,
 1239440991,
 43027,
 -46621,
 1239388559,
 43030,
 -1,
 1239572063,
 43031,
 1239763431,
 1239329108,
 -1,
 -46618,
 1239725012,
 43040,
 -1,
 1239781775,
 43038,
 1239960042,
 1239719913,
 -1,
 -46615,
 1239912847,
 43033,
 -1,
 1239965279,
 43034,
 1240156653,
 1239904392,
 -1,
 -46612,
 1240109455,
 43015,
 -1,
 1240161887,
 43016,
 1240353264,
 1240100649,
 -1,
 -46609,
 1240306063,
 43022,
 -1,
 1240358495,
 43023,
 1240549875,
 1240290019,
 -1,
 -46606,
 1240502671,
 43017,
 -1,
 1240555103,
 43018,
 1240746486,
 1240476894,
 -1,
 -46603,
 1240699279,
 43020,
 -1,
 1240751711,
 43021,
 1240943097,
 1240671862,
 -1,
 -46600,
 1240895887,
 43035,
 -1,
 1240948319,
 43036,
 -46598,
 1240911434,
 43011,
 -46597,
 1241103989,
 43041,
 -46596,
 1241158031,
 43013,
 -46595,
 1241222542,
 43032,
 -46594,
 1241286196,
 43037,
 -46593,
 1241349316,
 43039,
 -46592,
 1241407871,
 43009,
 -46591,
 1241472607,
 43042,
 -46590,
 1241530503,
 43012,
 -1,
 1241585012,
 43008,
 1241795081,
 1238883510,
 -1,
 -46587,
 1241763402,
 43045,
 -46586,
 1241814660,
 43047,
 -46585,
 1241866623,
 43044,
 -46584,
 1241923719,
 43046,
 -1,
 1241978228,
 43043,
 1242188302,
 1241752742,
 -1,
 -46581,
 1242108860,
 43051,
 -46580,
 1242174284,
 43050,
 -46579,
 1242239655,
 43049,
 -1,
 1242305039,
 43048,
 1242562559,
 1242151984,
 -1,
 -46576,
 1242454770,
 43014,
 -46575,
 1242513515,
 43010,
 -1,
 1242570647,
 43019,
 1242824703,
 1238794213,
 -1,
 1242843722,
 1242704564,
 -1,
 1242909216,
 1242806047,
 -1,
 1242974743,
 1242877890,
 9242,
 -1,
 1242891205,
 9254,
 1243105818,
 1242940456,
 -1,
 -46567,
 1243072010,
 9218,
 -1,
 1243110209,
 9217,
 1243302429,
 1243045097,
 -1,
 -46564,
 1243258028,
 9230,
 -1,
 1243309872,
 9231,
 -46562,
 1243276822,
 9238,
 -46561,
 1243455609,
 9248,
 -1,
 1243487371,
 8527,
 1243695659,
 1242838560,
 -1,
 1243761194,
 1243627655,
 -1,
 1243826728,
 1243732853,
 -1,
 1243892262,
 1243792084,
 -1,
 -46555,
 1243865487,
 9234,
 -1,
 1243897942,
 9235,
 -46553,
 1243846079,
 9233,
 -1,
 1244025296,
 9236,
 1244266495,
 1243773392,
 9249,
 -1,
 1244136389,
 9253,
 -1,
 1243686003,
 9232,
 1244416565,
 1243627655,
 -1,
 1244482100,
 1244367071,
 -1,
 1244547635,
 1244411456,
 -1,
 1244613170,
 1244512980,
 -1,
 1244678705,
 1244572366,
 9220,
 -1,
 1244594773,
 9239,
 -1,
 1244614050,
 9219,
 -1,
 1244562296,
 9241,
 -1,
 1244506386,
 9221,
 -1,
 1244444780,
 9243,
 1245071930,
 1244367071,
 -1,
 1245137465,
 1245003911,
 -1,
 -46536,
 1245110600,
 9252,
 -1,
 1245139905,
 9237,
 -1,
 1245106422,
 9216,
 1245399613,
 1245007446,
 -1,
 -46532,
 1245354310,
 9228,
 -1,
 1245406728,
 9244,
 1245596224,
 1245326651,
 -1,
 -46529,
 1245558154,
 9229,
 -1,
 1245612592,
 9240,
 1245792835,
 1245521526,
 -1,
 -46526,
 1245726192,
 9223,
 -1,
 1245779846,
 9224,
 -46524,
 1245764391,
 9227,
 -46523,
 1245958834,
 9247,
 -46522,
 1246014416,
 9246,
 -46521,
 1246067474,
 9226,
 -46520,
 1246125960,
 9225,
 -46519,
 1246189544,
 9245,
 -1,
 1246238586,
 9222,
 -1,
 1242793076,
 9007,
 1246513930,
 1231820148,
 -1,
 1246579384,
 1246483899,
 -1,
 1246644879,
 1246525914,
 -1,
 1246710357,
 1246615470,
 -1,
 1246775892,
 1246663253,
 -1,
 1246841426,
 1246734676,
 43144,
 -1,
 1246800212,
 43145,
 1247019007,
 1246786392,
 43146,
 -1,
 1246917464,
 43147,
 -1,
 1246696820,
 43182,
 1247169115,
 1246675668,
 -1,
 1247234649,
 1247134420,
 -1,
 -46504,
 1247172777,
 43165,
 -1,
 1247221108,
 43164,
 -46502,
 1247172777,
 43170,
 -1,
 1247352180,
 43169,
 1247562336,
 1247119583,
 -1,
 -46499,
 1247536170,
 43163,
 -46498,
 1247578427,
 43168,
 -46497,
 1247630084,
 43158,
 -1,
 1247679860,
 43173,
 1247890022,
 1247491616,
 -1,
 1247955556,
 1247819296,
 -1,
 -46493,
 1247893673,
 43167,
 -1,
 1247942004,
 43166,
 -46491,
 1247893673,
 43172,
 -1,
 1248073076,
 43171,
 1248283242,
 1247810932,
 43138,
 -46488,
 1248251466,
 43153,
 -46487,
 1248289151,
 43150,
 -1,
 1248335220,
 43139,
 1248545390,
 1248245535,
 -1,
 -46484,
 1248507801,
 43184,
 -46483,
 1248549033,
 43183,
 -1,
 1248597364,
 43185,
 1248807536,
 1248513610,
 43142,
 -1,
 1248775754,
 43143,
 1248938611,
 1248763881,
 -1,
 -46478,
 1248876713,
 43175,
 -1,
 1248925044,
 43174,
 1249135221,
 1248891279,
 43151,
 -1,
 1249087887,
 43152,
 1249266296,
 1249080152,
 -1,
 -46473,
 1249211309,
 43187,
 -1,
 1249252724,
 43181,
 1249462907,
 1249210504,
 -1,
 -46470,
 1249401001,
 43155,
 -1,
 1249449332,
 43154,
 1249659518,
 1249406761,
 -1,
 -46467,
 1249597609,
 43162,
 -1,
 1249645940,
 43161,
 1249856128,
 1249599871,
 43140,
 -1,
 1249796479,
 43141,
 1249987203,
 1249792739,
 -1,
 -46462,
 1249925289,
 43157,
 -1,
 1249973620,
 43156,
 1250183813,
 1249919111,
 43148,
 -1,
 1250115719,
 43149,
 1250314888,
 1250110686,
 -1,
 -46457,
 1250252969,
 43160,
 -1,
 1250301300,
 43159,
 1250511499,
 1250240118,
 -1,
 -46454,
 1250449577,
 43177,
 -1,
 1250497908,
 43176,
 -46452,
 1250485290,
 43179,
 -46451,
 1250666927,
 43180,
 -46450,
 1250721842,
 43178,
 -1,
 1250777257,
 43186,
 1250970273,
 1246616758,
 -1,
 1251035797,
 1250941967,
 -1,
 1251101331,
 1250994516,
 43194,
 -1,
 1251060052,
 43195,
 1251278847,
 1251046232,
 43196,
 -1,
 1251177304,
 43197,
 1251363481,
 1250956660,
 -1,
 -46441,
 1251331658,
 43203,
 -46440,
 1251369343,
 43200,
 -1,
 1251415412,
 43189,
 1251625627,
 1251331658,
 43192,
 -1,
 1251593802,
 43193,
 1251756701,
 1251578255,
 43201,
 -1,
 1251709327,
 43202,
 1251887775,
 1251697023,
 43190,
 -1,
 1251828095,
 43191,
 1252065279,
 1251819655,
 43198,
 -1,
 1251950727,
 43199,
 1252149938,
 1250899488,
 -1,
 1252215472,
 1252091258,
 -1,
 1252280998,
 1252180692,
 -1,
 -46427,
 1252254095,
 43218,
 -1,
 1252286550,
 43219,
 1252477609,
 1252243231,
 -1,
 -46424,
 1252421358,
 43222,
 -1,
 1252478082,
 43223,
 1252674220,
 1252413014,
 -1,
 -46421,
 1252629488,
 43220,
 -1,
 1252683383,
 43221,
 -46419,
 1252648853,
 43216,
 -46418,
 1252824511,
 43217,
 -46417,
 1252887740,
 43225,
 -1,
 1252934967,
 43224,
 -46415,
 1252170595,
 43215,
 -1,
 1253056064,
 43214,
 1253264055,
 1252113456,
 -1,
 1253329590,
 1253235557,
 -1,
 -46411,
 1253292069,
 43137,
 -1,
 1253354125,
 43204,
 -1,
 1253253015,
 43136,
 -1,
 1253192354,
 43188,
 1253657350,
 1246528081,
 -1,
 1253722836,
 1253603802,
 -1,
 1253788350,
 1253688020,
 -1,
 -46404,
 1253750689,
 2065,
 -46403,
 1253797247,
 2056,
 -1,
 1253840384,
 2069,
 1254050498,
 1253728639,
 -1,
 -46400,
 1254024174,
 2052,
 -46399,
 1254081236,
 2055,
 -1,
 1254131935,
 2063,
 1254312645,
 1254012703,
 -1,
 -46396,
 1254254832,
 2062,
 -1,
 1254316569,
 2068,
 1254509256,
 1254237814,
 -1,
 -46393,
 1254452607,
 2049,
 -1,
 1254495735,
 2053,
 -46391,
 1254483837,
 2054,
 -46390,
 1254680298,
 2057,
 -46389,
 1254732456,
 2067,
 -46388,
 1254795488,
 2066,
 -46387,
 1254854823,
 2061,
 -46386,
 1254917470,
 2060,
 -46385,
 1254978541,
 2059,
 -46384,
 1255043251,
 2058,
 -46383,
 1255101279,
 2050,
 -46382,
 1255165961,
 2064,
 -46381,
 1255225041,
 2051,
 -1,
 1255283290,
 2048,
 1255492326,
 1253694646,
 -1,
 1255557851,
 1255439650,
 -1,
 1255623384,
 1255478644,
 2082,
 -1,
 1255544180,
 2079,
 -46375,
 1255591498,
 2086,
 -46374,
 1255694719,
 2089,
 -1,
 1255751815,
 2076,
 1255951070,
 1255510415,
 2091,
 1256062975,
 1255922141,
 2081,
 -1,
 1255937396,
 2078,
 1256147681,
 1255913247,
 -1,
 -46368,
 1256116393,
 2092,
 -1,
 1256153026,
 2085,
 1256344291,
 1256068468,
 2083,
 -1,
 1256265076,
 2080,
 -46364,
 1256312394,
 2087,
 -46363,
 1256415615,
 2090,
 -1,
 1256472711,
 2077,
 1256671993,
 1255450363,
 -1,
 1256737518,
 1256592756,
 -1,
 1256803051,
 1256687839,
 -1,
 -46358,
 1256753487,
 2110,
 -1,
 1256805441,
 2098,
 -46356,
 1256769830,
 2100,
 -46355,
 1256960856,
 2108,
 -1,
 1257001560,
 2097,
 1257196273,
 1256711966,
 -1,
 -46352,
 1257139179,
 2104,
 -1,
 1257183303,
 2106,
 1257392884,
 1257158431,
 -1,
 -46349,
 1257345795,
 2109,
 -1,
 1257397798,
 2101,
 -46347,
 1257360686,
 2107,
 -46346,
 1257547686,
 2105,
 -46345,
 1257606018,
 2096,
 -46344,
 1257669593,
 2103,
 -1,
 1257711590,
 2099,
 1257917189,
 1256620005,
 -1,
 1257982721,
 1257841121,
 -1,
 1258048253,
 1257924400,
 2070,
 -1,
 1257967344,
 2071,
 -46338,
 1258000989,
 2072,
 -46337,
 1258130306,
 2093,
 -46336,
 1258178716,
 2075,
 -1,
 1258239659,
 2073,
 1258487807,
 1257935552,
 -1,
 -46333,
 1258404708,
 2084,
 -46332,
 1258447231,
 2088,
 -1,
 1258506396,
 2074,
 -1,
 1257838127,
 2102,
 -46329,
 1253625051,
 9796,
 -46328,
 1258716949,
 9747,
 -46327,
 1258776044,
 9973,
 -1,
 1258837440,
 9808,
 1259031491,
 1246481994,
 -1,
 1259096916,
 1258981599,
 9737,
 1259162451,
 1259026160,
 -1,
 1259227953,
 1259108826,
 -1,
 1259293458,
 1259178207,
 -1,
 -46320,
 1259267114,
 7057,
 -46319,
 1259295492,
 7053,
 -1,
 1259345268,
 7060,
 1259555605,
 1259255583,
 -1,
 -46316,
 1259529258,
 7087,
 -1,
 1259541876,
 7070,
 1259752216,
 1259499656,
 -1,
 -46313,
 1259690153,
 7086,
 -1,
 1259738484,
 7050,
 1259948826,
 1259683975,
 7048,
 -1,
 1259916874,
 7049,
 1260079900,
 1259869556,
 7043,
 -1,
 1260011655,
 7046,
 -46307,
 1260054320,
 7056,
 -46306,
 1260184618,
 7066,
 -46305,
 1260249892,
 7071,
 -46304,
 1260313904,
 7069,
 -46303,
 1260378044,
 7063,
 -46302,
 1260441162,
 7045,
 -46301,
 1260503829,
 7058,
 -46300,
 1260562863,
 7067,
 -46299,
 1260627786,
 7051,
 -46298,
 1260691534,
 7061,
 -46297,
 1260753295,
 7047,
 -46296,
 1260814386,
 7065,
 -46295,
 1260876717,
 7068,
 -46294,
 1260941099,
 7055,
 -46293,
 1261003135,
 7044,
 -46292,
 1261066409,
 7072,
 -46291,
 1261130500,
 7052,
 -46290,
 1261194943,
 7062,
 -46289,
 1261254283,
 7059,
 -46288,
 1261317435,
 7054,
 -1,
 1261381288,
 7064,
 1261587263,
 1259157912,
 -1,
 1261652789,
 1261552340,
 -1,
 -46284,
 1261625743,
 7090,
 -1,
 1261658198,
 7091,
 1261849400,
 1261614879,
 -1,
 -46281,
 1261793006,
 7094,
 -1,
 1261849730,
 7095,
 1262046011,
 1261784662,
 -1,
 -46278,
 1262001136,
 7092,
 -1,
 1262055031,
 7093,
 -46276,
 1262020501,
 7088,
 -46275,
 1262196159,
 7089,
 -46274,
 1262259388,
 7097,
 -1,
 1262306615,
 7096,
 1262504775,
 1261558978,
 -1,
 1262570310,
 1262455007,
 -1,
 -46270,
 1262544607,
 7077,
 -46269,
 1262589105,
 7079,
 -46268,
 1262638431,
 7076,
 -46267,
 1262701640,
 7081,
 -1,
 1262753878,
 7078,
 -1,
 1262519336,
 7080,
 1263029070,
 1262468173,
 -1,
 1263094605,
 1262979295,
 -1,
 1263160140,
 1263031011,
 -1,
 -46261,
 1263132524,
 7042,
 -1,
 1263171099,
 7041,
 -1,
 1263133896,
 7040,
 -1,
 1263042613,
 7082,
 1263534079,
 1262957239,
 -1,
 1263553362,
 1263440186,
 -1,
 -46255,
 1263494611,
 7075,
 -1,
 1263540719,
 7074,
 -1,
 1263502731,
 7073,
 -1,
 1259078165,
 9925,
 1263881093,
 1259053785,
 -1,
 1263946605,
 1263815488,
 -1,
 1264012128,
 1263899392,
 8835,
 1264123903,
 1263927296,
 -1,
 1264143197,
 1263998587,
 -1,
 -46246,
 1264109593,
 10952,
 -46245,
 1264160357,
 10956,
 -46244,
 1264208211,
 10950,
 -1,
 1264262177,
 10954,
 1264470879,
 1264097293,
 8839,
 -1,
 1264389388,
 10948,
 -1,
 1264443514,
 8843,
 1264667492,
 1263984498,
 -1,
 -46238,
 1264624787,
 10944,
 -46237,
 1264683017,
 10946,
 -1,
 1264728872,
 10942,
 1264929641,
 1264588411,
 -1,
 1264995176,
 1264894328,
 -1,
 -46233,
 1264952038,
 10966,
 -1,
 1264987150,
 10964,
 -1,
 1264941129,
 10619,
 1265257324,
 1264855220,
 -1,
 -46229,
 1265222015,
 10967,
 -1,
 1265245591,
 10968,
 -1,
 1265214988,
 10185,
 1265565695,
 1263875053,
 -1,
 1265585011,
 1265464152,
 -1,
 1265650546,
 1265509665,
 -1,
 -46223,
 1265600735,
 8319,
 -1,
 1265656191,
 8305,
 -1,
 1265583086,
 8317,
 1265912694,
 1265550036,
 -1,
 -46219,
 1265885583,
 178,
 -1,
 1265918038,
 179,
 1266109305,
 1265874719,
 -1,
 -46216,
 1266052846,
 8310,
 -1,
 1266109570,
 8311,
 1266305916,
 1266044502,
 -1,
 -46213,
 1266260976,
 8308,
 -1,
 1266314871,
 8309,
 1266502527,
 1266237575,
 -1,
 -46210,
 1266460675,
 8316,
 -1,
 1266509027,
 8312,
 -46208,
 1266476949,
 8304,
 -46207,
 1266659208,
 8318,
 -46206,
 1266721929,
 8314,
 -46205,
 1266783679,
 185,
 -46204,
 1266846908,
 8313,
 -1,
 1266910635,
 8315,
 1267092398,
 1263807486,
 -1,
 1267157914,
 1267020781,
 -1,
 1267223434,
 1267122900,
 -1,
 -46199,
 1267196303,
 8322,
 -1,
 1267228758,
 8323,
 1267420045,
 1267185439,
 -1,
 -46196,
 1267363566,
 8326,
 -1,
 1267420290,
 8327,
 1267616656,
 1267355222,
 -1,
 -46193,
 1267571696,
 8324,
 -1,
 1267625591,
 8325,
 1267813267,
 1267548295,
 -1,
 -46190,
 1267771395,
 8332,
 -1,
 1267819747,
 8328,
 -46188,
 1267787669,
 8320,
 -46187,
 1267969928,
 8334,
 -46186,
 1268032649,
 8330,
 -46185,
 1268094399,
 8321,
 -46184,
 1268157628,
 8329,
 -46183,
 1268221355,
 8331,
 -1,
 1268283228,
 8333,
 1268514815,
 1267092288,
 -1,
 1268534181,
 1268421376,
 8834,
 1268645887,
 1268449280,
 -1,
 1268665250,
 1268520571,
 -1,
 -46177,
 1268631577,
 10951,
 -46176,
 1268682341,
 10955,
 -46175,
 1268730195,
 10949,
 -1,
 1268784161,
 10953,
 1268992932,
 1268619277,
 8838,
 -1,
 1268911372,
 10947,
 -1,
 1268965498,
 8842,
 1269189545,
 1268506482,
 -1,
 -46169,
 1269146771,
 10943,
 -46168,
 1269205001,
 10945,
 -1,
 1269250856,
 10941,
 1269497855,
 1269110395,
 -1,
 1269517229,
 1269416312,
 -1,
 -46164,
 1269474022,
 10963,
 -1,
 1269509134,
 10965,
 -1,
 1269477535,
 10617,
 1269779390,
 1267019365,
 8827,
 1269891071,
 1269694464,
 -1,
 1269910457,
 1269765755,
 -1,
 1269975988,
 1269873881,
 -1,
 -46157,
 1269927525,
 10930,
 -1,
 1269975379,
 10928,
 1270172599,
 1269927494,
 -1,
 -46154,
 1270106375,
 10934,
 -1,
 1270160417,
 10938,
 -46152,
 1270106451,
 10932,
 -1,
 1270291489,
 10936,
 1270500284,
 1269864445,
 -1,
 -46149,
 1270443622,
 8831,
 -1,
 1270487589,
 8829,
 -46147,
 1270469192,
 8881,
 -1,
 1270623369,
 8937,
 1270827970,
 1269728768,
 -1,
 -46144,
 1270800458,
 10763,
 -46143,
 1270860287,
 9138,
 -1,
 1270885073,
 9139,
 -1,
 1270787515,
 8751,
 1271155788,
 1258971519,
 -1,
 1271221310,
 1271105759,
 -1,
 1271286839,
 1271159165,
 -1,
 1271352344,
 1271232986,
 -1,
 1271417821,
 1271272820,
 -1,
 1271483349,
 1271365333,
 -1,
 1271548876,
 1271448276,
 -1,
 -46133,
 1271514215,
 3495,
 -1,
 1271539279,
 3501,
 1271745487,
 1271477792,
 -1,
 -46130,
 1271674676,
 3497,
 -1,
 1271735887,
 3503,
 -46128,
 1271701911,
 3508,
 -46127,
 1271886237,
 3482,
 -46126,
 1271951173,
 3490,
 -46125,
 1272009715,
 3484,
 -46124,
 1272065621,
 3488,
 -1,
 1272129514,
 3510,
 1272335320,
 1271414919,
 -1,
 -46121,
 1272308862,
 3463,
 -1,
 1272335932,
 3464,
 -46119,
 1272308862,
 3461,
 -46118,
 1272502161,
 3478,
 -46117,
 1272545982,
 3513,
 -46116,
 1272606492,
 3475,
 -1,
 1272653391,
 3462,
 1272859633,
 1271365605,
 -1,
 1272925165,
 1272780148,
 -1,
 1272990700,
 1272862902,
 -1,
 1273056227,
 1272955604,
 -1,
 -46110,
 1273021543,
 3496,
 -1,
 1273046607,
 3502,
 1273252838,
 1272985120,
 -1,
 -46107,
 1273182004,
 3498,
 -1,
 1273243215,
 3504,
 -46105,
 1273209239,
 3509,
 -46104,
 1273393565,
 3483,
 -46103,
 1273458501,
 3491,
 -46102,
 1273517043,
 3485,
 -46101,
 1273572949,
 3489,
 -1,
 1273636842,
 3511,
 -1,
 1272964222,
 3512,
 1273954303,
 1272895364,
 -1,
 -46097,
 1273870401,
 3522,
 -46096,
 1273924127,
 3499,
 -1,
 1273984531,
 3525,
 1274170362,
 1272799615,
 -1,
 1274235893,
 1274132074,
 -1,
 -46092,
 1274209406,
 3469,
 -1,
 1274271633,
 3470,
 1274432504,
 1274183451,
 -1,
 -46089,
 1274406014,
 3471,
 -1,
 1274468241,
 3472,
 -46087,
 1274406014,
 3465,
 -1,
 1274572572,
 3466,
 1274760192,
 1274132508,
 -1,
 1274825726,
 1274689056,
 -1,
 -46083,
 1274754868,
 3500,
 -1,
 1274816079,
 3507,
 -46081,
 1274769221,
 3494,
 -1,
 1274958835,
 3487,
 1275153413,
 1274725160,
 -1,
 1275218948,
 1275115417,
 -1,
 -46077,
 1275192446,
 3521,
 -1,
 1275236732,
 3493,
 -1,
 1275169092,
 3492,
 1275481097,
 1275082488,
 -1,
 -46073,
 1275443265,
 3523,
 -46072,
 1275496991,
 3505,
 -1,
 1275557395,
 3517,
 1275743244,
 1275448906,
 -1,
 -46069,
 1275716734,
 3467,
 -1,
 1275778961,
 3468,
 1275939855,
 1275695503,
 -1,
 -46066,
 1275913342,
 3476,
 -1,
 1275961310,
 3477,
 1276136466,
 1275871367,
 -1,
 -46063,
 1276109950,
 3473,
 -1,
 1276137020,
 3474,
 -46061,
 1276109987,
 3514,
 -46060,
 1276303596,
 3520,
 -46059,
 1276357401,
 3515,
 -46058,
 1276408057,
 3486,
 -46057,
 1276467995,
 3524,
 -1,
 1276530462,
 3526,
 1276726321,
 1271323830,
 -1,
 1276791845,
 1276670088,
 -1,
 1276857377,
 1276744934,
 -1,
 1276922912,
 1276827580,
 3545,
 1277034495,
 1276838955,
 -1,
 -46050,
 1276924923,
 3550,
 -46049,
 1276983680,
 3549,
 -1,
 1277040715,
 3548,
 -1,
 1276838678,
 3547,
 1277362175,
 1276791866,
 -1,
 -46045,
 1277272169,
 3540,
 -46044,
 1277324527,
 3538,
 -1,
 1277368380,
 3536,
 1277578285,
 1276721530,
 -1,
 1277643817,
 1277514500,
 -1,
 -46040,
 1277617284,
 3571,
 -1,
 1277643816,
 3570,
 -46038,
 1277599849,
 3542,
 -46037,
 1277784732,
 3546,
 -46036,
 1277848815,
 3539,
 -1,
 1277892668,
 3537,
 1278102576,
 1277514500,
 -1,
 -46033,
 1278076036,
 3551,
 -1,
 1278102568,
 3544,
 -1,
 1278023755,
 3535,
 1278364726,
 1276689456,
 -1,
 1278430261,
 1278285172,
 -1,
 -46028,
 1278382306,
 3458,
 -1,
 1278440332,
 3530,
 -1,
 1278401522,
 3459,
 -1,
 1278322440,
 3572,
 1278757949,
 1271223769,
 -1,
 1278823483,
 1278702424,
 -1,
 -46022,
 1278779164,
 8218,
 -1,
 1278821410,
 8249,
 -46020,
 1278783600,
 8250,
 -1,
 1278958928,
 8219,
 -1,
 1278689533,
 8767,
 1279216710,
 1271170366,
 -1,
 1279282242,
 1279170553,
 -1,
 -46015,
 1279228239,
 10909,
 -1,
 1279284983,
 10910,
 1279478853,
 1279202939,
 -1,
 -46012,
 1279424891,
 10911,
 -1,
 1279481641,
 10912,
 -1,
 1279428028,
 10860,
 1279787007,
 1279189764,
 -1,
 1279806538,
 1279658078,
 -1,
 -46007,
 1279759301,
 10038,
 -1,
 1279806325,
 10046,
 -46005,
 1279771871,
 10042,
 -1,
 1279922331,
 8198,
 1280134302,
 1271093387,
 -1,
 1280199825,
 1280054644,
 -1,
 1280265356,
 1280170856,
 -1,
 1280330841,
 1280185716,
 -1,
 1280396371,
 1280289108,
 -1,
 -45998,
 1280355093,
 66684,
 -1,
 1280393351,
 66680,
 -45996,
 1280368210,
 66679,
 -45995,
 1280555539,
 66664,
 -45994,
 1280601072,
 66682,
 -45993,
 1280661643,
 66669,
 -45992,
 1280726050,
 66673,
 -1,
 1280785092,
 66665,
 1280986208,
 1280283023,
 -1,
 -45989,
 1280956169,
 66668,
 -45988,
 1281010004,
 66681,
 -45987,
 1281073125,
 66677,
 -45986,
 1281132767,
 66666,
 -45985,
 1281189341,
 66678,
 -1,
 1281235392,
 66676,
 1281444966,
 1280917639,
 -1,
 1281510500,
 1281365364,
 -1,
 -45981,
 1281475284,
 66672,
 -1,
 1281534292,
 66685,
 -45979,
 1281471845,
 66683,
 -1,
 1281643670,
 66663,
 1281838187,
 1281409748,
 -1,
 1281903722,
 1281775755,
 -1,
 -45975,
 1281844432,
 66644,
 -1,
 1281904185,
 66654,
 -1,
 1281858122,
 66641,
 1282165871,
 1281778047,
 -1,
 -45971,
 1282100822,
 66662,
 -45970,
 1282158216,
 66674,
 -1,
 1282219326,
 66686,
 1282428018,
 1282139323,
 -1,
 -45967,
 1282399496,
 66687,
 -1,
 1282413940,
 66648,
 1282624629,
 1282400655,
 -1,
 -45964,
 1282577426,
 66667,
 -1,
 1282621575,
 66658,
 1282821240,
 1282586399,
 -1,
 -45961,
 1282790877,
 66646,
 -1,
 1282838927,
 66645,
 1283017851,
 1282768869,
 -1,
 -45958,
 1282958998,
 66661,
 -1,
 1283015035,
 66656,
 1283214462,
 1282955403,
 -1,
 -45955,
 1283183217,
 66649,
 -1,
 1283200483,
 66659,
 -45953,
 1283188808,
 66655,
 -45952,
 1283382405,
 66653,
 -45951,
 1283445508,
 66675,
 -45950,
 1283503079,
 66670,
 -45949,
 1283564011,
 66640,
 -45948,
 1283625127,
 66671,
 -45947,
 1283685645,
 66660,
 -45946,
 1283748433,
 66642,
 -45945,
 1283813484,
 66657,
 -45944,
 1283871552,
 66652,
 -45943,
 1283936106,
 66643,
 -45942,
 1283995486,
 66651,
 -45941,
 1284059160,
 66647,
 -1,
 1284122960,
 66650,
 1284328592,
 1280196130,
 -1,
 -45938,
 1284292686,
 10032,
 -45937,
 1284339191,
 10014,
 -1,
 1284386882,
 10061,
 -1,
 1284278182,
 9752,
 1284656284,
 1280151951,
 -1,
 1284721819,
 1284617756,
 -1,
 1284787351,
 1284690924,
 10976,
 1284898815,
 1284702208,
 -1,
 -45930,
 1284825359,
 10984,
 -1,
 1284839174,
 10985,
 1285049497,
 1284718355,
 10975,
 -1,
 1284967908,
 10983,
 -45926,
 1285009584,
 10564,
 -1,
 1285126049,
 10974,
 -1,
 1284690126,
 9085,
 -45923,
 1284624405,
 10722,
 -1,
 1285319291,
 9961,
 1285508334,
 1280081893,
 -1,
 1285573869,
 1285428596,
 -1,
 1285639404,
 1285520386,
 -1,
 1285704938,
 1285554176,
 -1,
 1285770432,
 1285663060,
 -1,
 1285835963,
 1285723342,
 -1,
 1285901482,
 1285800660,
 -1,
 1285967016,
 1285872904,
 -1,
 -45913,
 1285919119,
 8561,
 -1,
 1285965357,
 8571,
 -45911,
 1285906518,
 8562,
 -1,
 1286096625,
 8569,
 1286294704,
 1285836374,
 -1,
 1286360239,
 1286234495,
 -1,
 1286425774,
 1286330612,
 8564,
 -1,
 1286341734,
 8574,
 -1,
 1286361790,
 8572,
 -1,
 1286314992,
 8563,
 1286687924,
 1286247871,
 8560,
 1286799359,
 1286602752,
 -1,
 -45901,
 1286719261,
 8575,
 -1,
 1286758679,
 8573,
 1286950071,
 1286649631,
 -1,
 -45898,
 1286893294,
 8565,
 -1,
 1286950018,
 8566,
 1287146682,
 1286881415,
 -1,
 -45895,
 1287092768,
 8570,
 -1,
 1287152867,
 8567,
 -1,
 1287097532,
 8568,
 1287408831,
 1285776616,
 -1,
 -45891,
 1287375469,
 65118,
 -45890,
 1287430438,
 65114,
 -1,
 1287468437,
 65116,
 -1,
 1287343331,
 65128,
 1287736520,
 1285701767,
 -1,
 1287802053,
 1287682279,
 8714,
 1287913471,
 1287719971,
 -1,
 -45884,
 1287838327,
 8948,
 -1,
 1287888554,
 8951,
 -45882,
 1287775046,
 65111,
 -45881,
 1288022019,
 65126,
 -1,
 1288077313,
 65112,
 1288260818,
 1287664104,
 -1,
 1288326350,
 1288212333,
 -1,
 1288391885,
 1288298354,
 -1,
 -45876,
 1288362615,
 8956,
 -1,
 1288412842,
 8958,
 -1,
 1288315684,
 8717,
 1288654033,
 1288275444,
 -1,
 -45872,
 1288587690,
 65131,
 -1,
 1288639860,
 65104,
 -1,
 1288600850,
 65109,
 1288916184,
 1288205906,
 -1,
 1288981719,
 1288852065,
 -1,
 -45867,
 1288948333,
 65117,
 -45866,
 1289003302,
 65113,
 -1,
 1289041301,
 65115,
 -1,
 1288945587,
 65124,
 1289309403,
 1288880852,
 -1,
 -45862,
 1289282016,
 68411,
 -1,
 1289315839,
 732,
 1289506014,
 1289265129,
 -1,
 -45859,
 1289453430,
 65122,
 -1,
 1289505174,
 65130,
 1289702625,
 1289426292,
 -1,
 -45856,
 1289666675,
 65121,
 -1,
 1289717617,
 65120,
 -45854,
 1289673056,
 10849,
 -45853,
 1289861470,
 65108,
 -45852,
 1289922750,
 65110,
 -45851,
 1289982023,
 65119,
 -45850,
 1290036175,
 65105,
 -45849,
 1290101103,
 65123,
 -45848,
 1290164106,
 65125,
 -45847,
 1290228418,
 65106,
 -1,
 1290287861,
 65129,
 1290534911,
 1285638524,
 10922,
 -1,
 1290405577,
 10924,
 -1,
 1285601838,
 10803,
 -1,
 1285514756,
 8995,
 1290751242,
 1285460367,
 -1,
 1290816772,
 1290718794,
 -1,
 1290882307,
 1290782226,
 -1,
 1290947835,
 1290813813,
 -1,
 1291013368,
 1290871394,
 8600,
 1291124735,
 1290928128,
 -1,
 -45835,
 1291051049,
 10533,
 -45834,
 1291110720,
 8690,
 -45833,
 1291138252,
 10541,
 -1,
 1291197995,
 10537,
 -45831,
 1290985142,
 11010,
 -45830,
 1291336870,
 8664,
 -1,
 1291397635,
 11018,
 1291649023,
 1290919541,
 -1,
 1291668736,
 1291526754,
 8601,
 1291780095,
 1291583488,
 -1,
 -45825,
 1291706409,
 10534,
 -1,
 1291722212,
 10538,
 -45823,
 1291640502,
 11011,
 -45822,
 1291861158,
 8665,
 -1,
 1291921923,
 11019,
 -1,
 1290832511,
 8471,
 1292193030,
 1290762876,
 47,
 -1,
 1292111332,
 10742,
 1292324105,
 1292128862,
 -1,
 -45816,
 1292295609,
 9108,
 -1,
 1292305543,
 173,
 -1,
 1292250738,
 9917,
 1292586271,
 1290677470,
 -1,
 1292651805,
 1292544340,
 -1,
 1292717340,
 1292594150,
 -1,
 1292782871,
 1292643805,
 -1,
 -45809,
 1292740948,
 8475,
 -45808,
 1292804073,
 8472,
 -45807,
 1292861413,
 8499,
 -45806,
 1292923736,
 8466,
 -45805,
 1292984703,
 8464,
 -45804,
 1293047947,
 8459,
 -45803,
 1293110870,
 8497,
 -45802,
 1293172871,
 8496,
 -1,
 1293231734,
 8492,
 1293484031,
 1292746124,
 -1,
 -45799,
 1293390223,
 8500,
 -45798,
 1293448024,
 8467,
 -45797,
 1293505251,
 8458,
 -1,
 1293566087,
 8495,
 -1,
 1292686400,
 8456,
 -45794,
 1292605831,
 9807,
 -1,
 1293753143,
 9878,
 1293962542,
 1292517511,
 -1,
 1294028068,
 1293911185,
 -1,
 -45790,
 1293990395,
 9914,
 -45789,
 1294023165,
 10802,
 -1,
 1294086635,
 59,
 1294290215,
 1293989663,
 -1,
 -45786,
 1294248185,
 9916,
 -1,
 1294277836,
 65093,
 1294486826,
 1294218520,
 -1,
 -45783,
 1294440438,
 8980,
 -1,
 1294494620,
 167,
 -45781,
 1294459870,
 9913,
 -45780,
 1294648066,
 8726,
 -45779,
 1294710506,
 8480,
 -1,
 1294751248,
 8979,
 1294945597,
 1293927124,
 -1,
 1295011129,
 1294865780,
 -1,
 1295076662,
 1294969174,
 -1,
 1295142196,
 1295028623,
 -1,
 -45773,
 1295098470,
 8902,
 -1,
 1295142501,
 10017,
 -45771,
 1295075660,
 8795,
 -1,
 1295261050,
 9770,
 1295515647,
 1295011767,
 -1,
 -45768,
 1295408188,
 9882,
 -1,
 1295456354,
 9877,
 1295712255,
 1294969172,
 -1,
 -45765,
 1295606545,
 8803,
 -45764,
 1295665873,
 10025,
 -1,
 1295718708,
 9188,
 1295928650,
 1294889816,
 -1,
 1295994181,
 1295848820,
 -1,
 1296059716,
 1295945589,
 -1,
 1296125250,
 1296005455,
 10901,
 -1,
 1296043292,
 10903,
 1296302079,
 1296062199,
 10902,
 -1,
 1296174364,
 10904,
 -1,
 1296030834,
 42611,
 1296498687,
 1295947500,
 -1,
 1296518473,
 1296394431,
 -1,
 -45752,
 1296472054,
 10839,
 -1,
 1296506215,
 10840,
 -1,
 1296449671,
 9011,
 1296780627,
 1295884265,
 -1,
 1296846159,
 1296718894,
 8738,
 1296957439,
 1296762477,
 -1,
 -45746,
 1296880388,
 10657,
 -1,
 1296922245,
 10656,
 1297108306,
 1296766324,
 -1,
 -45743,
 1297068895,
 10055,
 -1,
 1297100424,
 32,
 -1,
 1297042107,
 8375,
 1297370455,
 1296731845,
 -1,
 1297435990,
 1297318390,
 9731,
 -1,
 1297354429,
 9924,
 -1,
 1297371382,
 10052,
 1297632602,
 1297313928,
 -1,
 -45735,
 1297600762,
 9760,
 -1,
 1297638451,
 9975,
 -45733,
 1297605365,
 8275,
 -1,
 1297745069,
 10700,
 1297961573,
 1206868107,
 -1,
 1298026610,
 1297880436,
 -1,
 1298091990,
 1297975519,
 -1,
 1298157501,
 1298027235,
 -1,
 1298223019,
 1298124981,
 -1,
 1298288265,
 1298165545,
 -1,
 1298353689,
 1298241120,
 -1,
 1298419081,
 1298312791,
 4527,
 1298530303,
 1298337491,
 -1,
 1298550126,
 1298440169,
 -1,
 1298615660,
 1298490438,
 4530,
 1298726911,
 1298534099,
 -1,
 -45719,
 1298647024,
 55257,
 -45718,
 1298709770,
 4563,
 -45717,
 1298768739,
 55258,
 -1,
 1298816206,
 4564,
 -45715,
 1298554075,
 4533,
 -1,
 1298931516,
 4567,
 1299139957,
 1298493576,
 -1,
 1299205491,
 1299083043,
 4528,
 1299316735,
 1299123923,
 -1,
 -45710,
 1299234058,
 4556,
 -1,
 1299274958,
 55254,
 -45708,
 1299143892,
 4568,
 -1,
 1299390536,
 4565,
 1299598714,
 1299088686,
 4529,
 1299709951,
 1299517139,
 -1,
 -45704,
 1299627274,
 4562,
 -45703,
 1299673711,
 4561,
 -1,
 1299733710,
 55256,
 1299926398,
 1299571899,
 -1,
 1299991933,
 1299880174,
 4569,
 -1,
 1299910645,
 55260,
 -1,
 1299954702,
 55259,
 1300188546,
 1299890900,
 -1,
 1300254081,
 1300129205,
 4558,
 -1,
 1300172789,
 4559,
 -1,
 1300192482,
 4532,
 1300450695,
 1300150047,
 -1,
 1300516230,
 1300412418,
 -1,
 -45691,
 1300479242,
 4566,
 -1,
 1300525679,
 55253,
 -1,
 1300458417,
 4531,
 -45688,
 1300401292,
 4557,
 -1,
 1300716750,
 4534,
 1300909482,
 1298380575,
 -1,
 1300975001,
 1300871170,
 -1,
 1301040527,
 1300937994,
 4539,
 1301151743,
 1300958931,
 -1,
 -45682,
 1301071856,
 55277,
 -1,
 1301115503,
 55276,
 1301302673,
 1301006320,
 55245,
 -1,
 1301221554,
 55246,
 1301433747,
 1301261911,
 4560,
 -1,
 1301352504,
 55255,
 -45676,
 1301390242,
 55270,
 -45675,
 1301515404,
 4607,
 -45674,
 1301579054,
 55264,
 -45673,
 1301639791,
 4521,
 -45672,
 1301701696,
 4590,
 -1,
 1301753905,
 55289,
 1302003711,
 1300917169,
 4538,
 1302069247,
 1301876435,
 -1,
 1302089118,
 1301988052,
 -1,
 -45667,
 1302029749,
 4584,
 -1,
 1302093026,
 55281,
 1302285729,
 1302044649,
 -1,
 -45664,
 1302225990,
 4586,
 -1,
 1302273852,
 55278,
 1302482340,
 1302229128,
 -1,
 -45661,
 1302425379,
 4583,
 -1,
 1302470728,
 55275,
 1302678951,
 1302408414,
 -1,
 -45658,
 1302619195,
 55279,
 -1,
 1302682823,
 55280,
 -45656,
 1302638167,
 4585,
 -45655,
 1302824238,
 55274,
 -1,
 1302879438,
 55282,
 1303072193,
 1300865001,
 -1,
 1303137720,
 1303012422,
 4536,
 1303248895,
 1303056083,
 -1,
 1303268783,
 1303166218,
 4537,
 -1,
 1303187836,
 55271,
 1303399857,
 1303227991,
 4579,
 -1,
 1303318697,
 55268,
 1303530932,
 1303325918,
 -1,
 -45645,
 1303471163,
 55272,
 -1,
 1303534791,
 55273,
 -45643,
 1303496688,
 55267,
 -45642,
 1303683939,
 4580,
 -45641,
 1303741742,
 55269,
 -1,
 1303796942,
 4581,
 1303989693,
 1303076059,
 4545,
 1304100863,
 1303908051,
 -1,
 -45637,
 1304020654,
 55291,
 -45636,
 1304083722,
 55290,
 -1,
 1304142754,
 4595,
 1304363007,
 1303912252,
 4587,
 1304428543,
 1304235731,
 -1,
 -45632,
 1304339362,
 55283,
 -1,
 1304391977,
 55284,
 1304579539,
 1303015560,
 -1,
 1304645068,
 1304522531,
 4520,
 1304756223,
 1304563411,
 -1,
 1304776134,
 1304673546,
 4522,
 -1,
 1304694859,
 4548,
 -45625,
 1304735319,
 4547,
 -45624,
 1304863650,
 4603,
 -45623,
 1304923276,
 4602,
 -45622,
 1304982073,
 4605,
 -45621,
 1305042126,
 4606,
 -1,
 1305096109,
 4604,
 1305300434,
 1304567872,
 -1,
 1305365968,
 1305255913,
 -1,
 -45617,
 1305306182,
 4582,
 -1,
 1305369819,
 4596,
 -45615,
 1305325143,
 55261,
 -1,
 1305511214,
 4578,
 -1,
 1305238740,
 4543,
 1305759205,
 1304528174,
 4535,
 1305870335,
 1305677523,
 -1,
 1305890266,
 1305786143,
 -1,
 1305955801,
 1305851906,
 -1,
 -45608,
 1305918730,
 4574,
 -1,
 1305971852,
 55263,
 -1,
 1305897905,
 4573,
 1306217950,
 1305845737,
 -1,
 1306283485,
 1306158150,
 4572,
 -1,
 1306202451,
 55265,
 -1,
 1306206012,
 4575,
 1306480097,
 1306143966,
 -1,
 -45600,
 1306420283,
 55266,
 -1,
 1306483911,
 4576,
 -45598,
 1306439255,
 4571,
 -45597,
 1306627212,
 55262,
 -45596,
 1306686063,
 4570,
 -1,
 1306746062,
 4577,
 1306938866,
 1305723604,
 -1,
 1307004401,
 1306879413,
 4526,
 1307115519,
 1306922707,
 -1,
 1307135466,
 1307032842,
 55248,
 -1,
 1307054155,
 55249,
 1307266541,
 1307061470,
 -1,
 -45588,
 1307206715,
 55250,
 -1,
 1307270343,
 55251,
 -45586,
 1307231918,
 55252,
 -45585,
 1307422295,
 4555,
 -45584,
 1307485090,
 55247,
 -1,
 1307538031,
 4554,
 -1,
 1306942690,
 4544,
 1307790847,
 1306889356,
 4523,
 1307901951,
 1307709139,
 -1,
 1307921911,
 1307820756,
 -1,
 -45578,
 1307862453,
 4550,
 -1,
 1307925730,
 4553,
 1308118522,
 1307847902,
 -1,
 -45575,
 1308058683,
 4524,
 -1,
 1308122311,
 55244,
 -45573,
 1308081418,
 4551,
 -45572,
 1308274263,
 55243,
 -45571,
 1308336332,
 4552,
 -45570,
 1308389999,
 4549,
 -1,
 1308449998,
 4525,
 1308642823,
 1307763899,
 -1,
 1308708358,
 1308605454,
 4592,
 1308819455,
 1308626643,
 -1,
 -45565,
 1308736778,
 4593,
 -45564,
 1308795084,
 4594,
 -45563,
 1308853550,
 55285,
 -1,
 1308908750,
 55286,
 -1,
 1308661998,
 4601,
 1309167117,
 1308581070,
 4546,
 1309278207,
 1309085395,
 -1,
 -45558,
 1309191767,
 4598,
 -45557,
 1309254562,
 4600,
 -45556,
 1309314188,
 4597,
 -1,
 1309377838,
 4599,
 1309560339,
 1309107264,
 4540,
 1309671423,
 1309478611,
 -1,
 1309691410,
 1309569160,
 -1,
 -45551,
 1309634339,
 4588,
 -1,
 1309695188,
 4591,
 -1,
 1309654991,
 4589,
 1309999103,
 1309486302,
 -1,
 1310019096,
 1309893691,
 4541,
 1310130175,
 1309937363,
 -1,
 -45545,
 1310048219,
 55288,
 -1,
 1310106530,
 55287,
 -1,
 1309957319,
 4542,
 1310392319,
 1298322037,
 -1,
 1310412351,
 1310319598,
 -1,
 1310477862,
 1310379594,
 4466,
 1310588927,
 1310396115,
 -1,
 1310608927,
 1310516411,
 4498,
 -1,
 1310560655,
 4497,
 1310740001,
 1310539911,
 4496,
 -1,
 1310691727,
 4495,
 1310871075,
 1310659956,
 4494,
 -1,
 1310802055,
 55223,
 -45532,
 1310838346,
 4499,
 -45531,
 1310953871,
 55224,
 -1,
 1311007103,
 4500,
 1311198769,
 1310429583,
 4461,
 1311309823,
 1311117011,
 -1,
 1311329836,
 1311237102,
 -1,
 1311395371,
 1311249780,
 4484,
 -1,
 1311326343,
 4485,
 -1,
 1311328367,
 4486,
 1311591982,
 1311249780,
 55218,
 -1,
 1311522951,
 55219,
 -45521,
 1311543695,
 4487,
 -45520,
 1311662463,
 4488,
 -1,
 1311721583,
 55220,
 1311919671,
 1311129735,
 4456,
 1312030719,
 1311871375,
 4455,
 1312096255,
 1311903443,
 -1,
 -45515,
 1312023594,
 4517,
 -45514,
 1312083530,
 4478,
 -1,
 1312133519,
 4477,
 1312312893,
 1311839604,
 4451,
 1312378428,
 1312231123,
 -1,
 -45510,
 1312351786,
 4473,
 -45509,
 1312411210,
 4516,
 -1,
 1312461199,
 4472,
 -1,
 1312309383,
 4452,
 1312751615,
 1312252287,
 4468,
 -1,
 1312625028,
 4503,
 1312837200,
 1310351743,
 4469,
 1312948223,
 1312755411,
 -1,
 1312968265,
 1312875502,
 -1,
 1313033797,
 1312888180,
 4505,
 -45500,
 1312964743,
 55230,
 -1,
 1313017989,
 55229,
 1313230407,
 1312964743,
 55232,
 -1,
 1313182095,
 55231,
 -45496,
 1313197642,
 55235,
 -1,
 1313313167,
 55234,
 1313492555,
 1312919951,
 4506,
 -1,
 1313411110,
 55233,
 1313623629,
 1313412468,
 4504,
 -1,
 1313581569,
 4509,
 -45490,
 1313590858,
 4507,
 -45489,
 1313694079,
 55236,
 -1,
 1313754176,
 4508,
 1313951326,
 1312768135,
 4454,
 1314016857,
 1313918538,
 4467,
 1314127871,
 1313935059,
 -1,
 1314147926,
 1314013319,
 55227,
 -45483,
 1314115146,
 4502,
 -1,
 1314165135,
 55226,
 -45481,
 1314115146,
 4501,
 -45480,
 1314296207,
 55228,
 -1,
 1314329972,
 55225,
 1314586623,
 1313968527,
 4453,
 1314652159,
 1314459347,
 -1,
 -45476,
 1314573898,
 4475,
 -45475,
 1314623887,
 4474,
 -1,
 1314671680,
 4476,
 1314868843,
 1313902991,
 4457,
 1314934378,
 1314787027,
 -1,
 1314999909,
 1314907118,
 -1,
 1315065443,
 1314930823,
 4481,
 -1,
 1315017103,
 55216,
 1315241983,
 1314985332,
 4518,
 -1,
 1315127431,
 4519,
 1315327591,
 1314951567,
 4482,
 -1,
 1315246118,
 55217,
 1315458665,
 1315258503,
 4480,
 -1,
 1315410319,
 4479,
 -1,
 1315425866,
 4483,
 -1,
 1314865287,
 4460,
 1315720824,
 1314788724,
 4449,
 1315786355,
 1315678721,
 4510,
 1315897343,
 1315704531,
 -1,
 1315917424,
 1315782791,
 55238,
 -1,
 1315869071,
 4511,
 -45455,
 1315884618,
 4512,
 -45454,
 1315987839,
 4513,
 -1,
 1316033908,
 55237,
 1316245111,
 1315704531,
 -1,
 -45451,
 1316212298,
 4471,
 -45450,
 1316262287,
 4470,
 -1,
 1316310080,
 4515,
 -1,
 1316176007,
 4450,
 1316572801,
 1315688010,
 4462,
 1316683775,
 1316490963,
 -1,
 1316703868,
 1316611259,
 4492,
 -1,
 1316655503,
 55221,
 1316834942,
 1316623732,
 4489,
 -1,
 1316765831,
 4490,
 -45441,
 1316802122,
 4493,
 -45440,
 1316905471,
 55222,
 -1,
 1316964466,
 4491,
 1317162631,
 1316543752,
 -1,
 1317228164,
 1317093511,
 4464,
 -1,
 1317179791,
 4463,
 1317359238,
 1317148020,
 4458,
 -1,
 1317290119,
 4459,
 -1,
 1317298559,
 4465,
 -45432,
 1317126084,
 4514,
 -1,
 1317490719,
 4448,
 1317687091,
 1298214877,
 -1,
 1317752495,
 1317648159,
 -1,
 1317818016,
 1317694385,
 4361,
 1317928959,
 1317736147,
 -1,
 1317949073,
 1317838825,
 -1,
 1318014608,
 1317889094,
 4402,
 -1,
 1317933131,
 4403,
 -1,
 1317952731,
 4410,
 1318211220,
 1317913300,
 -1,
 -45421,
 1318151605,
 4399,
 -1,
 1318214882,
 4409,
 1318407831,
 1318154376,
 -1,
 -45418,
 1318350627,
 4397,
 -1,
 1318411476,
 4408,
 1318604442,
 1318333662,
 -1,
 -45415,
 1318544443,
 4406,
 -1,
 1318608071,
 4407,
 -45413,
 1318567910,
 4404,
 -45412,
 1318760023,
 4400,
 -45411,
 1318816908,
 4398,
 -45410,
 1318880558,
 4401,
 -45409,
 1318937664,
 4405,
 -1,
 1319001294,
 4411,
 1319239679,
 1317779458,
 -1,
 1319259812,
 1319158484,
 -1,
 -45405,
 1319200181,
 4356,
 -1,
 1319263458,
 43385,
 1319456422,
 1319222538,
 4362,
 -1,
 1319375026,
 43381,
 1319587496,
 1319383089,
 4365,
 -1,
 1319505909,
 43384,
 -45399,
 1319560519,
 43388,
 -45398,
 1319677527,
 4377,
 -45397,
 1319740322,
 4360,
 -45396,
 1319799948,
 4372,
 -45395,
 1319858799,
 4353,
 -45394,
 1319920704,
 4423,
 -1,
 1319984334,
 4440,
 1320177357,
 1317707753,
 -1,
 1320242888,
 1320117318,
 4359,
 1320353791,
 1320160979,
 -1,
 1320373948,
 1320269599,
 -1,
 1320439483,
 1320315825,
 4385,
 1320550399,
 1320357587,
 -1,
 1320570552,
 1320469204,
 -1,
 -45385,
 1320510901,
 4387,
 -1,
 1320574178,
 43378,
 -45383,
 1320526754,
 4388,
 -45382,
 1320710767,
 4386,
 -1,
 1320759345,
 4390,
 -1,
 1320400903,
 4389,
 1321029311,
 1320338132,
 -1,
 -45378,
 1320969653,
 4384,
 -1,
 1321032930,
 4393,
 1321225922,
 1320972424,
 -1,
 -45375,
 1321168675,
 4382,
 -1,
 1321229524,
 43379,
 1321422533,
 1321151710,
 -1,
 -45372,
 1321362491,
 4391,
 -1,
 1321426119,
 4392,
 -45370,
 1321378659,
 4394,
 -45369,
 1321569420,
 4383,
 -1,
 1321622734,
 43380,
 1321815756,
 1320180955,
 4369,
 1321926655,
 1321733843,
 -1,
 -45365,
 1321837474,
 4438,
 -1,
 1321884878,
 43386,
 -1,
 1321738044,
 4416,
 1322143463,
 1320103134,
 -1,
 1322208988,
 1322081417,
 -1,
 1322274520,
 1322175628,
 -1,
 1322340053,
 1322235679,
 -1,
 1322405588,
 1322301442,
 -1,
 -45357,
 1322368266,
 4413,
 -1,
 1322397745,
 4431,
 -1,
 1322347441,
 4412,
 1322713087,
 1322265822,
 -1,
 -45353,
 1322607675,
 4430,
 -1,
 1322671303,
 4436,
 1322909695,
 1322208323,
 4366,
 1322975231,
 1322782419,
 -1,
 -45349,
 1322873401,
 4434,
 -1,
 1322933454,
 4435,
 1323126501,
 1322141816,
 -1,
 1323192034,
 1323087647,
 -1,
 1323257569,
 1323153410,
 -1,
 -45344,
 1323220234,
 4415,
 -1,
 1323249713,
 4433,
 -1,
 1323199409,
 4414,
 1323565055,
 1323117790,
 -1,
 -45340,
 1323459643,
 4432,
 -1,
 1323523271,
 4437,
 1323761663,
 1323066427,
 4364,
 -1,
 1323634729,
 4429,
 1323847417,
 1322102359,
 4357,
 1323958271,
 1323765459,
 -1,
 1323978479,
 1323874079,
 -1,
 1324044014,
 1323939842,
 -1,
 -45332,
 1324009456,
 43367,
 -45331,
 1324065698,
 43370,
 -1,
 1324118639,
 43365,
 -1,
 1323985841,
 43372,
 1324371699,
 1323921544,
 -1,
 -45327,
 1324314403,
 43364,
 -45326,
 1324375252,
 43374,
 -1,
 1324425288,
 43371,
 -45324,
 1324337136,
 43366,
 -45323,
 1324589986,
 43369,
 -45322,
 1324649612,
 4376,
 -45321,
 1324713262,
 43368,
 -45320,
 1324768462,
 4378,
 -1,
 1324822577,
 43373,
 1325027082,
 1323787328,
 4363,
 1325137919,
 1324945107,
 -1,
 1325158143,
 1325047785,
 -1,
 -45315,
 1325098054,
 4420,
 -45314,
 1325161691,
 4427,
 -1,
 1325211452,
 4422,
 1325420290,
 1325122260,
 -1,
 -45311,
 1325360565,
 4418,
 -1,
 1325423842,
 4426,
 1325616901,
 1325346014,
 -1,
 -45308,
 1325556795,
 4424,
 -1,
 1325620423,
 4425,
 -45306,
 1325579530,
 4421,
 -45305,
 1325772375,
 43382,
 -45304,
 1325827374,
 4419,
 -45303,
 1325888111,
 4417,
 -1,
 1325948110,
 43383,
 1326141204,
 1324991188,
 -1,
 1326206739,
 1326081461,
 4355,
 1326317567,
 1326124755,
 -1,
 -45298,
 1326234890,
 43362,
 -45297,
 1326296663,
 4446,
 -45296,
 1326359458,
 43361,
 -45295,
 1326417198,
 43360,
 -45294,
 1326477935,
 4375,
 -1,
 1326526513,
 43363,
 -1,
 1326144738,
 4368,
 1326796575,
 1326084232,
 -1,
 1326862108,
 1326719040,
 -1,
 1326927641,
 1326817257,
 -1,
 -45288,
 1326867526,
 4395,
 -1,
 1326931163,
 4439,
 -45286,
 1326890971,
 4396,
 -45285,
 1327083095,
 4379,
 -1,
 1327138094,
 4381,
 1327320862,
 1326804771,
 4352,
 -1,
 1327239548,
 4442,
 -1,
 1327258836,
 4367,
 1327517479,
 1326746764,
 4354,
 1327628287,
 1327435475,
 -1,
 -45278,
 1327548400,
 4373,
 -45277,
 1327611146,
 4443,
 -45276,
 1327670178,
 4374,
 -45275,
 1327723119,
 4371,
 -45274,
 1327783118,
 4445,
 -1,
 1327837233,
 4444,
 1328041773,
 1327465774,
 4358,
 1328152575,
 1327959763,
 -1,
 -45270,
 1328072688,
 43376,
 -45269,
 1328135434,
 43377,
 -45268,
 1328194466,
 4380,
 -1,
 1328247407,
 43375,
 1328434992,
 1328014523,
 -1,
 -45265,
 1328397326,
 4428,
 -1,
 1328453870,
 4441,
 1328631602,
 1328372942,
 4370,
 -1,
 1328550227,
 43387,
 -1,
 1328566303,
 4447,
 1328828328,
 1317632474,
 -1,
 1328893769,
 1328800750,
 -1,
 1328959292,
 1328824455,
 12630,
 1329024826,
 1328921614,
 12673,
 1329135615,
 1328942803,
 -1,
 -45255,
 1329052938,
 12674,
 -1,
 1329111244,
 12675,
 1329332223,
 1328976271,
 12629,
 -1,
 1329246728,
 12678,
 1329418049,
 1328926282,
 12640,
 1329528831,
 1329336019,
 -1,
 1329549120,
 1329456315,
 12683,
 -1,
 1329500559,
 12682,
 -1,
 1329488255,
 12684,
 1329745734,
 1329369487,
 12635,
 1329856511,
 1329663699,
 -1,
 1329876805,
 1329783850,
 12679,
 -1,
 1329807495,
 12680,
 -1,
 1329815935,
 12681,
 1330073416,
 1329665396,
 12625,
 -1,
 1330004103,
 12626,
 -1,
 1330012543,
 12642,
 1330270042,
 1328854815,
 -1,
 1330335571,
 1330231298,
 -1,
 -45236,
 1330300912,
 12600,
 -45235,
 1330363658,
 12614,
 -45234,
 1330422690,
 12611,
 -45233,
 1330482316,
 12645,
 -45232,
 1330541167,
 12594,
 -45231,
 1330603072,
 12672,
 -45230,
 1330666702,
 12677,
 -1,
 1330720817,
 12617,
 1330970623,
 1330277297,
 12613,
 1331036159,
 1330843347,
 -1,
 -45226,
 1330956272,
 12668,
 -45225,
 1331012514,
 12669,
 -45224,
 1331072140,
 12667,
 -45223,
 1331130991,
 12666,
 -1,
 1331179569,
 12670,
 1331384170,
 1330228823,
 12601,
 1331494911,
 1331302099,
 -1,
 1331515233,
 1331404777,
 -1,
 1331580767,
 1331455046,
 12604,
 -1,
 1331499347,
 12651,
 -45216,
 1331518683,
 12607,
 -1,
 1331633980,
 12652,
 1331842916,
 1331479252,
 -1,
 -45213,
 1331783093,
 12650,
 -1,
 1331846370,
 12606,
 1332039526,
 1331786351,
 12602,
 -1,
 1331958099,
 12649,
 -45209,
 1332012359,
 12653,
 -45208,
 1332133130,
 12605,
 -45207,
 1332184366,
 12603,
 -1,
 1332239566,
 12608,
 1332432760,
 1331339241,
 -1,
 1332498294,
 1332372550,
 12610,
 1332609023,
 1332416211,
 -1,
 1332629361,
 1332526346,
 12612,
 1332740095,
 1332547283,
 -1,
 -45200,
 1332660208,
 12661,
 -1,
 1332703855,
 12660,
 1332891508,
 1332593364,
 -1,
 -45197,
 1332831669,
 12659,
 -1,
 1332894946,
 12663,
 -45195,
 1332834927,
 12658,
 -1,
 1333014577,
 12662,
 -45193,
 1332436187,
 12621,
 -1,
 1333141308,
 12671,
 1333350274,
 1332375688,
 -1,
 1333415807,
 1333272640,
 -1,
 1333481341,
 1333370857,
 -1,
 -45188,
 1333421126,
 12664,
 -1,
 1333484763,
 12676,
 -45186,
 1333444571,
 12665,
 -1,
 1333626158,
 12657,
 1333809025,
 1333358371,
 12593,
 -1,
 1333727571,
 12595,
 -1,
 1333746900,
 12619,
 1334005641,
 1333300364,
 12596,
 1334116351,
 1333923539,
 -1,
 -45179,
 1334036464,
 12646,
 -45178,
 1334099210,
 12647,
 -45177,
 1334157516,
 12648,
 -45176,
 1334205646,
 12598,
 -1,
 1334259761,
 12597,
 1334464399,
 1333976328,
 -1,
 1334529932,
 1334395015,
 12638,
 -1,
 1334481295,
 12637,
 1334661006,
 1334449524,
 12632,
 -1,
 1334591623,
 12633,
 -1,
 1334600063,
 12639,
 1334857621,
 1334412590,
 12609,
 1334968319,
 1334775507,
 -1,
 1334988692,
 1334878185,
 -1,
 -45165,
 1334928454,
 12654,
 -1,
 1334976316,
 12656,
 -1,
 1334951178,
 12655,
 1335250841,
 1334777204,
 12623,
 1335316376,
 1335208449,
 12685,
 -1,
 1335246983,
 12686,
 -1,
 1335246983,
 12624,
 1335512988,
 1335181447,
 12628,
 -45157,
 1335479882,
 12641,
 -1,
 1335529871,
 12627,
 1335709599,
 1335476948,
 -1,
 -45154,
 1335649717,
 12599,
 -1,
 1335712994,
 12620,
 1335906209,
 1335660943,
 12631,
 -1,
 1335836807,
 12634,
 1336037283,
 1335845247,
 12643,
 -1,
 1335970896,
 12615,
 1336168358,
 1335962846,
 -1,
 -45147,
 1336108091,
 12616,
 -1,
 1336171719,
 12618,
 -45145,
 1336135242,
 12636,
 -1,
 1336302798,
 12622,
 -45143,
 1328790705,
 12334,
 -45142,
 1336430623,
 12644,
 -1,
 1336491244,
 12335,
 1336737791,
 1298196464,
 -1,
 1336758196,
 1336656596,
 -1,
 1336823728,
 1336728840,
 -1,
 -45137,
 1336775055,
 12322,
 -1,
 1336821839,
 12345,
 1337020339,
 1336760459,
 -1,
 -45134,
 1336978512,
 12323,
 -1,
 1337027798,
 12346,
 -1,
 1336952561,
 12344,
 1337282487,
 1336719135,
 -1,
 -45130,
 1337224942,
 12326,
 -1,
 1337281666,
 12327,
 1337479098,
 1337216598,
 -1,
 -45127,
 1337433072,
 12324,
 -1,
 1337486967,
 12325,
 -45125,
 1337431487,
 12321,
 -45124,
 1337625788,
 12329,
 -1,
 1337673015,
 12328,
 1337917439,
 1298125539,
 -1,
 1337937874,
 1337817562,
 -1,
 1338003394,
 1337886943,
 -1,
 -45119,
 1337938692,
 5925,
 -1,
 1337988468,
 5928,
 -45117,
 1337975850,
 5932,
 -45116,
 1338170672,
 5935,
 -45115,
 1338232394,
 5922,
 -45114,
 1338295061,
 5926,
 -45113,
 1338357657,
 5936,
 -45112,
 1338419631,
 5933,
 -45111,
 1338482766,
 5929,
 -45110,
 1338540082,
 5931,
 -45109,
 1338602413,
 5934,
 -45108,
 1338667167,
 5923,
 -45107,
 1338728831,
 5921,
 -45106,
 1338792105,
 5937,
 -45105,
 1338856196,
 5924,
 -45104,
 1338914443,
 5927,
 -45103,
 1338975912,
 5930,
 -1,
 1339037044,
 5920,
 1339248597,
 1337908406,
 -1,
 -45100,
 1339215434,
 5939,
 -1,
 1339253119,
 5938,
 -1,
 1339210837,
 5940,
 1339510894,
 1298037322,
 -1,
 1339576351,
 1339453769,
 -1,
 1339641886,
 1339490304,
 -1,
 1339707419,
 1339587034,
 -1,
 1339772907,
 1339668255,
 -1,
 1339838438,
 1339719966,
 -1,
 1339903968,
 1339810798,
 -1,
 -45090,
 1339870794,
 65389,
 -45089,
 1339920783,
 65390,
 -1,
 1339954548,
 65388,
 -45087,
 1339870794,
 65385,
 -45086,
 1340132489,
 65391,
 -45085,
 1340182927,
 65387,
 -45084,
 1340236159,
 65384,
 -45083,
 1340293255,
 65386,
 -1,
 1340347764,
 65383,
 -45081,
 1339805258,
 65405,
 -45080,
 1340510607,
 65407,
 -45079,
 1340563839,
 65404,
 -45078,
 1340620935,
 65406,
 -1,
 1340675444,
 65403,
 1340887025,
 1339721951,
 65437,
 -45075,
 1340853834,
 65415,
 -45074,
 1340903823,
 65417,
 -45073,
 1340957055,
 65414,
 -45072,
 1341014151,
 65416,
 -1,
 1341068660,
 65413,
 1341280247,
 1340850900,
 -1,
 -45069,
 1341247050,
 65410,
 -45068,
 1341297039,
 65412,
 -45067,
 1341350271,
 65409,
 -45066,
 1341407367,
 65411,
 -1,
 1341461876,
 65408,
 1341673469,
 1341237588,
 -1,
 -45063,
 1341640266,
 65433,
 -45062,
 1341690255,
 65435,
 -45061,
 1341743487,
 65432,
 -45060,
 1341800583,
 65434,
 -1,
 1341855092,
 65431,
 1342066691,
 1341620197,
 -1,
 -45057,
 1342033482,
 65425,
 -45056,
 1342083471,
 65427,
 -45055,
 1342136703,
 65424,
 -45054,
 1342193799,
 65426,
 -1,
 1342248308,
 65423,
 1342459913,
 1342009480,
 -1,
 -45051,
 1342426698,
 65400,
 -45050,
 1342476687,
 65402,
 -45049,
 1342529919,
 65399,
 -45048,
 1342587015,
 65401,
 -1,
 1342641524,
 65398,
 1342853135,
 1342396555,
 -1,
 -45045,
 1342819914,
 65420,
 -45044,
 1342869903,
 65422,
 -45043,
 1342923135,
 65419,
 -45042,
 1342980231,
 65421,
 -1,
 1343034740,
 65418,
 1343246355,
 1342825454,
 -1,
 -45039,
 1343213130,
 65429,
 -45038,
 1343263119,
 65430,
 -1,
 1343296884,
 65428,
 1343508502,
 1343216904,
 -1,
 -45035,
 1343459727,
 65382,
 -1,
 1343493492,
 65436,
 -45033,
 1343475274,
 65395,
 -45032,
 1343656335,
 65397,
 -45031,
 1343709567,
 65394,
 -45030,
 1343766663,
 65396,
 -1,
 1343821172,
 65393,
 -45028,
 1339677783,
 65438,
 -45027,
 1343994120,
 65439,
 -1,
 1344046304,
 65381,
 -1,
 1339559943,
 65392,
 1344295008,
 1339513426,
 -1,
 1344360543,
 1344240090,
 -1,
 1344426027,
 1344319063,
 65449,
 1344536575,
 1344343763,
 -1,
 1344557094,
 1344446441,
 -1,
 -45019,
 1344496710,
 65452,
 -1,
 1344560347,
 65455,
 -45017,
 1344521902,
 65454,
 -45016,
 1344716042,
 65453,
 -45015,
 1344767278,
 65451,
 -45014,
 1344828015,
 65450,
 -1,
 1344888014,
 65456,
 1345081395,
 1344398318,
 -1,
 1345146926,
 1345011847,
 65483,
 -1,
 1345098127,
 65482,
 1345278000,
 1345066356,
 65476,
 -1,
 1345208455,
 65477,
 -45007,
 1345244746,
 65495,
 -45006,
 1345360271,
 65490,
 -1,
 1345413503,
 65499,
 1345605691,
 1345042207,
 -1,
 1345671226,
 1345566722,
 -1,
 -45002,
 1345636336,
 65448,
 -45001,
 1345699082,
 65462,
 -45000,
 1345758114,
 65459,
 -44999,
 1345811055,
 65442,
 -1,
 1345859633,
 65465,
 -1,
 1345612721,
 65461,
 1346129985,
 1345576200,
 -1,
 1346195518,
 1346060423,
 65493,
 -1,
 1346146703,
 65492,
 1346326592,
 1346114932,
 65485,
 -1,
 1346257031,
 65486,
 -1,
 1346265471,
 65494,
 1346523205,
 1346084841,
 -1,
 1346588740,
 1346462790,
 65458,
 -1,
 1346507091,
 65460,
 -1,
 1346526427,
 65469,
 1346785353,
 1346473100,
 65444,
 1346895871,
 1346703059,
 -1,
 -44984,
 1346788558,
 65446,
 -1,
 1346842673,
 65445,
 1347047501,
 1346728072,
 -1,
 1347113036,
 1346989859,
 65441,
 -1,
 1347031379,
 65443,
 -1,
 1347050708,
 65467,
 1347309648,
 1346977927,
 65479,
 -44977,
 1347276362,
 65498,
 -1,
 1347326351,
 65478,
 1347506259,
 1347273428,
 -1,
 -44974,
 1347446197,
 65447,
 -1,
 1347509474,
 65468,
 1347702869,
 1347457423,
 65484,
 -1,
 1347633287,
 65487,
 1347833943,
 1347641727,
 65500,
 -1,
 1347767376,
 65463,
 1347965018,
 1347759326,
 -1,
 -44967,
 1347904571,
 65464,
 -1,
 1347968199,
 65466,
 1348161628,
 1347884404,
 65474,
 -1,
 1348092039,
 65475,
 -44963,
 1348128330,
 65491,
 -44962,
 1348240686,
 65457,
 -1,
 1348295886,
 65470,
 -1,
 1344294943,
 65440,
 1348554851,
 1344253537,
 -1,
 -44958,
 1348525409,
 65515,
 -1,
 1348534963,
 65379,
 1348751462,
 1348499077,
 -1,
 -44955,
 1348722017,
 65513,
 -1,
 1348731571,
 65378,
 1348948073,
 1348690882,
 -1,
 -44952,
 1348883138,
 65377,
 -1,
 1348940303,
 65380,
 -44950,
 1348918978,
 65518,
 -44949,
 1349113166,
 65514,
 -44948,
 1349145019,
 65512,
 -44947,
 1349205849,
 65516,
 -1,
 1349265991,
 65517,
 1349472369,
 1339459081,
 -1,
 -44944,
 1349434369,
 9773,
 -1,
 1349493651,
 9874,
 -1,
 1349413875,
 8202,
 1349734872,
 1297956999,
 -1,
 1349800230,
 1349659619,
 -1,
 1349865684,
 1349743448,
 -1,
 1349931212,
 1349798963,
 -1,
 1349996671,
 1349902119,
 -1,
 -44936,
 1349960798,
 64296,
 -44935,
 1350020365,
 64295,
 -44934,
 1350071525,
 64293,
 -44933,
 1350136011,
 64292,
 -44932,
 1350196008,
 64291,
 -44931,
 1350258770,
 64294,
 -44930,
 1350317783,
 64290,
 -1,
 1350376113,
 64289,
 1350586507,
 1349957407,
 -1,
 1350652041,
 1350524291,
 1513,
 1350762495,
 1350568995,
 -1,
 1350783110,
 1350645419,
 64329,
 1350893567,
 1350697288,
 -1,
 -44923,
 1350788962,
 64301,
 -1,
 1350851975,
 64300,
 1351090175,
 1350743839,
 -1,
 -44920,
 1350985570,
 64299,
 -1,
 1351048583,
 64298,
 1351286783,
 1350573274,
 1505,
 -1,
 1351158974,
 64321,
 1351372947,
 1350520882,
 -1,
 1351438478,
 1351328173,
 1507,
 -1,
 1351355582,
 64323,
 1351569552,
 1351381195,
 1498,
 -1,
 1351486654,
 64314,
 -44911,
 1351535622,
 1509,
 -44910,
 1351651495,
 1503,
 -1,
 1351713767,
 1501,
 1351897246,
 1351292276,
 -1,
 1351962781,
 1351840600,
 -1,
 1352028314,
 1351893890,
 1488,
 1352138751,
 1351945251,
 -1,
 -44904,
 1352050564,
 64303,
 -44903,
 1352114557,
 64302,
 -1,
 1352172089,
 64304,
 1352400895,
 1351992734,
 -1,
 -44900,
 1352311945,
 64297,
 -1,
 1352345197,
 64288,
 -1,
 1351935440,
 1506,
 1352618149,
 1351860948,
 -1,
 1352683681,
 1352579015,
 1510,
 -1,
 1352600766,
 64326,
 1352814755,
 1352616765,
 1496,
 -1,
 1352731838,
 64312,
 1352990719,
 1352738261,
 1514,
 -1,
 1352862910,
 64330,
 1353076905,
 1352590893,
 1497,
 1353187327,
 1352993827,
 -1,
 -44888,
 1353080230,
 64285,
 -1,
 1353135787,
 64313,
 1353339053,
 1353046240,
 1493,
 1353449471,
 1353255971,
 -1,
 -44884,
 1353342589,
 64331,
 -1,
 1353397931,
 64309,
 1353601201,
 1353294253,
 1508,
 1353711615,
 1353518115,
 -1,
 -44880,
 1353624070,
 64334,
 -1,
 1353660075,
 64324,
 1353863349,
 1353543883,
 1499,
 1353973759,
 1353780259,
 -1,
 -44876,
 1353886214,
 64333,
 -1,
 1353922219,
 64315,
 1354125496,
 1353800488,
 1492,
 -44873,
 1354089172,
 1495,
 -1,
 1354108376,
 64308,
 1354322108,
 1354049811,
 1489,
 1354432511,
 1354239011,
 -1,
 -44869,
 1354344966,
 64332,
 -1,
 1354380971,
 64305,
 1354584254,
 1354295146,
 1494,
 -1,
 1354501310,
 64310,
 1354715328,
 1354542349,
 1512,
 -1,
 1354632382,
 64328,
 1354846402,
 1354672047,
 1511,
 -1,
 1354763454,
 64327,
 1354977476,
 1354797223,
 1504,
 -1,
 1354894526,
 64320,
 1355108550,
 1354925031,
 1502,
 -1,
 1355025598,
 64318,
 1355239624,
 1355052261,
 1500,
 -1,
 1355156670,
 64316,
 1355370698,
 1355175309,
 1490,
 -1,
 1355287742,
 64306,
 1355546623,
 1355298519,
 1491,
 -1,
 1355418814,
 64307,
 1355677695,
 1349870751,
 -1,
 1355698387,
 1355605363,
 -1,
 1355763921,
 1355627599,
 -1,
 -44848,
 1355736621,
 1522,
 -1,
 1355798752,
 1520,
 -44846,
 1355736625,
 64287,
 -1,
 1355929828,
 1521,
 -1,
 1355619004,
 64335,
 1356157184,
 1349785398,
 -1,
 1356222684,
 1356130078,
 -1,
 1356288219,
 1356141940,
 -1,
 1356353754,
 1356244890,
 -1,
 -44839,
 1356310420,
 1428,
 -1,
 1356354362,
 1429,
 -1,
 1356313953,
 1432,
 -1,
 1356228991,
 1454,
 1356681443,
 1356186324,
 -1,
 1356746978,
 1356611719,
 -1,
 1356812513,
 1356692401,
 -1,
 -44832,
 1356769183,
 1449,
 -1,
 1356813386,
 1440,
 -1,
 1356782527,
 1435,
 -1,
 1356688329,
 1430,
 1357140200,
 1356627941,
 -1,
 1357205734,
 1357072870,
 1445,
 -1,
 1357120783,
 1446,
 -44825,
 1357173219,
 1443,
 -1,
 1357256977,
 1444,
 1357467884,
 1357075576,
 -1,
 1357533419,
 1357400694,
 1436,
 -1,
 1357448675,
 1437,
 -1,
 1357494992,
 1438,
 1357730031,
 1357440187,
 -1,
 -44818,
 1357695236,
 1434,
 -1,
 1357752862,
 1450,
 1357926642,
 1357690655,
 -1,
 -44815,
 1357863390,
 1427,
 -1,
 1357923523,
 1426,
 1358123253,
 1357883210,
 -1,
 -44812,
 1358083007,
 1439,
 -1,
 1358117568,
 1448,
 1358319864,
 1358078030,
 -1,
 -44809,
 1358292881,
 1441,
 -1,
 1358347213,
 1433,
 1358516475,
 1358247456,
 -1,
 -44806,
 1358447901,
 1453,
 -1,
 1358504339,
 1447,
 -44804,
 1358474677,
 1431,
 -44803,
 1358664799,
 1451,
 -44802,
 1358718554,
 1452,
 -44801,
 1358777324,
 1425,
 -1,
 1358832982,
 1442,
 1359040802,
 1356111849,
 -1,
 1359106330,
 1358992311,
 -1,
 1359171850,
 1359042699,
 -1,
 1359237383,
 1359094915,
 -1,
 -44795,
 1359198461,
 1457,
 -44794,
 1359259524,
 1459,
 -1,
 1359323517,
 1458,
 1359499529,
 1359189013,
 1465,
 -1,
 1359414337,
 1466,
 -1,
 1359441054,
 1460,
 1359696144,
 1359132447,
 -1,
 1359761678,
 1359632523,
 -1,
 -44787,
 1359701858,
 1473,
 -1,
 1359760495,
 1456,
 -44785,
 1359701858,
 1474,
 -1,
 1359889603,
 1462,
 1360089364,
 1359652676,
 -1,
 1360154899,
 1360010395,
 1464,
 -1,
 1360071060,
 1479,
 -1,
 1360121838,
 1467,
 -44779,
 1360055308,
 1461,
 -44778,
 1360308742,
 1471,
 -44777,
 1360372093,
 1463,
 -44776,
 1360430173,
 1469,
 -44775,
 1360490583,
 64286,
 -1,
 1360541362,
 1468,
 1360789503,
 1359073815,
 -1,
 1360810270,
 1360680056,
 -1,
 -44771,
 1360771792,
 1524,
 -1,
 1360808566,
 1523,
 -44769,
 1360772732,
 1475,
 -44768,
 1360961911,
 1472,
 -44767,
 1361023147,
 1478,
 -1,
 1361084991,
 1470,
 1361313791,
 1358987871,
 -1,
 -44764,
 1361237101,
 1476,
 -44763,
 1361281690,
 1455,
 -1,
 1361346173,
 1477,
 1361531269,
 1349772077,
 -1,
 1361596732,
 1361494740,
 -1,
 1361662267,
 1361533739,
 -1,
 1361727789,
 1361587422,
 -1,
 -44757,
 1361685416,
 19904,
 -44756,
 1361738592,
 19933,
 -1,
 1361782200,
 19953,
 1361989938,
 1361646964,
 -1,
 1362055473,
 1361946964,
 -1,
 -44752,
 1362009245,
 19954,
 -1,
 1362069691,
 19910,
 -1,
 1361980600,
 19932,
 1362317621,
 1361960200,
 -1,
 -44748,
 1362249200,
 19951,
 -1,
 1362304581,
 19959,
 -44746,
 1362275264,
 19905,
 -44745,
 1362461312,
 19957,
 -44744,
 1362522562,
 19955,
 -44743,
 1362587723,
 19961,
 -44742,
 1362646124,
 19960,
 -1,
 1362710282,
 19940,
 -1,
 1361619847,
 19913,
 1362972998,
 1361524256,
 -1,
 1363038529,
 1362903175,
 -1,
 -44737,
 1363007865,
 19956,
 -44736,
 1363049448,
 19943,
 -1,
 1363096502,
 19944,
 1363300676,
 1362977151,
 -1,
 -44733,
 1363263257,
 19962,
 -1,
 1363300314,
 19906,
 -44731,
 1363269061,
 19935,
 -1,
 1363419631,
 19939,
 1363628369,
 1362907875,
 -1,
 1363693904,
 1363585364,
 -1,
 1363759439,
 1363624326,
 -1,
 1363824974,
 1363714025,
 -1,
 1363890509,
 1363775887,
 -1,
 -44724,
 1363861100,
 19937,
 -1,
 1363918838,
 19917,
 -1,
 1363848418,
 19931,
 -1,
 1363788793,
 19929,
 -1,
 1363679038,
 19925,
 -1,
 1363617024,
 19948,
 1364349271,
 1363588895,
 -1,
 1364414805,
 1364295966,
 -1,
 -44716,
 1364378617,
 19912,
 -1,
 1364436552,
 19965,
 -44714,
 1364378646,
 19915,
 -1,
 1364567089,
 19926,
 1364742493,
 1364289328,
 -1,
 1364808027,
 1364691167,
 -1,
 -44710,
 1364759143,
 19928,
 -1,
 1364806020,
 19964,
 -44708,
 1364742502,
 19934,
 -1,
 1364931510,
 19945,
 1365135714,
 1364700036,
 -1,
 1365201249,
 1365099220,
 -1,
 -44704,
 1365169664,
 19927,
 -1,
 1365224347,
 19936,
 -1,
 1365171305,
 19952,
 1365463398,
 1365090281,
 -1,
 -44700,
 1365431971,
 19949,
 -44699,
 1365488646,
 19938,
 -1,
 1365524749,
 19914,
 1365725547,
 1365414287,
 -1,
 1365791082,
 1365681534,
 -1,
 -44695,
 1365749018,
 19950,
 -1,
 1365809674,
 19941,
 -1,
 1365716016,
 19942,
 1366053232,
 1365651944,
 -1,
 1366118767,
 1366001887,
 -1,
 -44690,
 1366082843,
 19923,
 -1,
 1366118723,
 19909,
 -1,
 1366066558,
 19947,
 1366380916,
 1365976694,
 -1,
 -44686,
 1366338447,
 19946,
 -44685,
 1366388238,
 19924,
 -1,
 1366442889,
 19967,
 1366643064,
 1366300020,
 -1,
 -44682,
 1366599091,
 19922,
 -44681,
 1366643320,
 19966,
 -1,
 1366699090,
 19958,
 1366905211,
 1366613256,
 -1,
 -44678,
 1366858027,
 19921,
 -1,
 1366890918,
 19908,
 1367101822,
 1366853172,
 -1,
 -44675,
 1367070525,
 19930,
 -1,
 1367095336,
 19918,
 1367298433,
 1367035478,
 -1,
 -44672,
 1367250072,
 19920,
 -1,
 1367295493,
 19916,
 -44670,
 1367270988,
 19907,
 -44669,
 1367440087,
 19963,
 -44668,
 1367498377,
 19911,
 -1,
 1367558167,
 19919,
 1367757268,
 1361450356,
 -1,
 1367822803,
 1367727358,
 -1,
 1367888273,
 1367747806,
 -1,
 1367953805,
 1367829532,
 11096,
 1368019340,
 1367870499,
 -1,
 -44661,
 1367982351,
 9955,
 -1,
 1368010833,
 11095,
 -1,
 1367946842,
 11097,
 1368281488,
 1367890728,
 -1,
 -44657,
 1368251624,
 10054,
 -1,
 1368273192,
 10004,
 -1,
 1368233343,
 10152,
 1368543645,
 1367811702,
 -1,
 1368609180,
 1368486928,
 -1,
 1368674711,
 1368526706,
 -1,
 -44651,
 1368637148,
 10167,
 -44650,
 1368699039,
 10168,
 -1,
 1368755748,
 10169,
 1368981503,
 1368588288,
 -1,
 1369002395,
 1368864217,
 -1,
 -44646,
 1368970545,
 10150,
 -1,
 1368997690,
 10149,
 -1,
 1368939348,
 10084,
 -1,
 1368529936,
 10008,
 1369330084,
 1368507092,
 -1,
 1369395619,
 1369260367,
 -1,
 1369461154,
 1369351478,
 -1,
 -44639,
 1369416634,
 10051,
 -1,
 1369449476,
 10045,
 -1,
 1369397850,
 10171,
 -1,
 1369353743,
 10142,
 1369788842,
 1369290527,
 -1,
 1369854376,
 1369729271,
 -1,
 -44633,
 1369820396,
 10075,
 -1,
 1369846305,
 10076,
 -44631,
 1369809238,
 10056,
 -1,
 1370004680,
 10136,
 1370182065,
 1369745748,
 -1,
 1370247600,
 1370121443,
 -1,
 1370313135,
 1370165444,
 -1,
 -44626,
 1370270002,
 10095,
 -1,
 1370303360,
 10097,
 -1,
 1370283361,
 10137,
 -1,
 1370200992,
 10140,
 1370640823,
 1370125144,
 -1,
 1370706357,
 1370571790,
 -1,
 -44620,
 1370663218,
 10094,
 -1,
 1370696576,
 10096,
 -44618,
 1370660728,
 10157,
 -1,
 1370825118,
 11093,
 1371034046,
 1370570887,
 -1,
 1371099579,
 1371005782,
 -1,
 -44614,
 1371062876,
 10071,
 -1,
 1371117923,
 10082,
 1371340799,
 1371038952,
 -1,
 -44611,
 1371260075,
 10059,
 -1,
 1371317446,
 10040,
 1371492802,
 1371004168,
 -1,
 -44608,
 1371431812,
 10132,
 -44607,
 1371495916,
 9947,
 -1,
 1371554532,
 10173,
 1371754950,
 1371443599,
 -1,
 -44604,
 1371723738,
 11094,
 -44603,
 1371789159,
 10030,
 -1,
 1371841031,
 10012,
 1372017099,
 1371682336,
 -1,
 1372082634,
 1371970356,
 -1,
 -44599,
 1372048620,
 10077,
 -1,
 1372074529,
 10078,
 -1,
 1372005265,
 10144,
 -44596,
 1371986524,
 10074,
 -44595,
 1372312740,
 10158,
 -44594,
 1372360228,
 10138,
 -44593,
 1372424227,
 10006,
 -44592,
 1372478298,
 10083,
 -44591,
 1372542893,
 10010,
 -44590,
 1372606933,
 10020,
 -1,
 1372660740,
 10033,
 -1,
 1367752745,
 9980,
 1372934615,
 1367702690,
 -1,
 -44586,
 1372867396,
 9937,
 -1,
 1372916372,
 9096,
 -1,
 1372894072,
 8889,
 1373196870,
 1349673343,
 -1,
 1373262404,
 1373153803,
 -1,
 1373327937,
 1373207002,
 -1,
 1373393392,
 1373288223,
 -1,
 1373458923,
 1373339934,
 -1,
 1373524449,
 1373430766,
 -1,
 -44577,
 1373490762,
 12421,
 -44576,
 1373540751,
 12423,
 -1,
 1373574516,
 12419,
 1373786596,
 1373466760,
 -1,
 -44573,
 1373716615,
 12438,
 -1,
 1373771124,
 12437,
 -44571,
 1373756720,
 12430,
 -44570,
 1373949514,
 12357,
 -44569,
 1374014601,
 12387,
 -44568,
 1374065039,
 12361,
 -44567,
 1374118271,
 12355,
 -44566,
 1374175367,
 12359,
 -1,
 1374229876,
 12353,
 -44564,
 1373425226,
 12377,
 -44563,
 1374392719,
 12381,
 -44562,
 1374445951,
 12375,
 -44561,
 1374503047,
 12379,
 -1,
 1374557556,
 12373,
 1374769654,
 1373341919,
 12435,
 -44558,
 1374735946,
 12396,
 -44557,
 1374785935,
 12398,
 -44556,
 1374839167,
 12395,
 -44555,
 1374896263,
 12397,
 -1,
 1374950772,
 12394,
 1375162876,
 1374742302,
 -1,
 -44552,
 1375129162,
 12378,
 -44551,
 1375179151,
 12382,
 -44550,
 1375232383,
 12376,
 -44549,
 1375289479,
 12380,
 -1,
 1375343988,
 12374,
 1375556098,
 1375126228,
 -1,
 -44546,
 1375522378,
 12388,
 -44545,
 1375572367,
 12392,
 -44544,
 1375625599,
 12385,
 -44543,
 1375682695,
 12390,
 -1,
 1375737204,
 12383,
 1375949320,
 1375512916,
 -1,
 -44540,
 1375915594,
 12427,
 -44539,
 1375965583,
 12429,
 -44538,
 1376018815,
 12426,
 -44537,
 1376075911,
 12428,
 -1,
 1376130420,
 12425,
 1376342542,
 1375903721,
 -1,
 -44534,
 1376308810,
 12407,
 -44533,
 1376358799,
 12413,
 -44532,
 1376412031,
 12404,
 -44531,
 1376469127,
 12410,
 -1,
 1376523636,
 12401,
 1376735764,
 1376288741,
 -1,
 -44528,
 1376702026,
 12416,
 -44527,
 1376752015,
 12418,
 -44526,
 1376805247,
 12415,
 -44525,
 1376862343,
 12417,
 -1,
 1376916852,
 12414,
 1377128986,
 1376678024,
 -1,
 -44522,
 1377095242,
 12367,
 -44521,
 1377145231,
 12371,
 -44520,
 1377198463,
 12365,
 -44519,
 1377255559,
 12369,
 -1,
 1377310068,
 12363,
 1377522208,
 1377065099,
 -1,
 -44516,
 1377488458,
 12405,
 -44515,
 1377538447,
 12411,
 -44514,
 1377591679,
 12402,
 -44513,
 1377648775,
 12408,
 -1,
 1377703284,
 12399,
 1377915430,
 1377456867,
 -1,
 -44510,
 1377881674,
 12368,
 -44509,
 1377931663,
 12372,
 -44508,
 1377984895,
 12366,
 -44507,
 1378041991,
 12370,
 -1,
 1378096500,
 12364,
 1378308652,
 1377842720,
 -1,
 -44504,
 1378274890,
 12389,
 -44503,
 1378324879,
 12393,
 -44502,
 1378378111,
 12386,
 -44501,
 1378435207,
 12391,
 -1,
 1378489716,
 12384,
 1378701874,
 1378231926,
 -1,
 -44498,
 1378668106,
 12406,
 -44497,
 1378718095,
 12412,
 -44496,
 1378771327,
 12403,
 -44495,
 1378828423,
 12409,
 -1,
 1378882932,
 12400,
 1379095095,
 1378671880,
 -1,
 -44492,
 1379045775,
 12434,
 -44491,
 1379099007,
 12432,
 -44490,
 1379156103,
 12433,
 -1,
 1379210612,
 12431,
 1379422779,
 1379066862,
 -1,
 -44487,
 1379389002,
 12422,
 -44486,
 1379438991,
 12424,
 -1,
 1379472756,
 12420,
 -44484,
 1379392759,
 12436,
 -44483,
 1379651146,
 12358,
 -44482,
 1379701135,
 12362,
 -44481,
 1379754367,
 12356,
 -44480,
 1379811463,
 12360,
 -1,
 1379865972,
 12354,
 -44478,
 1373297704,
 12446,
 -44477,
 1380019653,
 12445,
 -1,
 1380071893,
 12447,
 -44475,
 1373225154,
 9964,
 -1,
 1380209838,
 9889,
 1380405850,
 1373147535,
 -1,
 1380471379,
 1380365090,
 -1,
 1380536909,
 1380431969,
 -1,
 -44470,
 1380455745,
 9149,
 -44469,
 1380521158,
 9148,
 -44468,
 1380586316,
 9147,
 -1,
 1380651535,
 9146,
 1380864592,
 1380460150,
 -1,
 -44465,
 1380807720,
 11043,
 -1,
 1380851804,
 8213,
 -44463,
 1380811011,
 9897,
 -44462,
 1381006083,
 9135,
 -1,
 1381058044,
 8230,
 1381257814,
 1380437578,
 -1,
 -44459,
 1381218456,
 8962,
 -1,
 1381281237,
 8987,
 1381454425,
 1381221078,
 -1,
 -44456,
 1381416783,
 9832,
 -1,
 1381443892,
 9749,
 -1,
 1381402427,
 8763,
 1381716580,
 1380377582,
 -1,
 1381782115,
 1381670889,
 -1,
 1381847650,
 1381719078,
 8208,
 1381913184,
 1381761024,
 -1,
 -44449,
 1381883821,
 11802,
 -1,
 1381903423,
 8259,
 -44447,
 1381836100,
 8231,
 -1,
 1382027378,
 45,
 -1,
 1381798582,
 11794,
 -1,
 1381744731,
 9102,
 -1,
 1381676819,
 8372,
 1382438738,
 1297896163,
 -1,
 1382503716,
 1382394196,
 -1,
 1382569251,
 1382432903,
 -1,
 1382634745,
 1382499744,
 -1,
 1382699849,
 1382594335,
 -1,
 1382765379,
 1382646046,
 -1,
 1382830911,
 1382709722,
 -1,
 1382896279,
 1382782150,
 -1,
 1382961802,
 1382827168,
 969,
 1383071743,
 1382878243,
 -1,
 1383092859,
 1382981609,
 -1,
 1383158393,
 1383054458,
 8032,
 1383268351,
 1383071866,
 -1,
 1383289460,
 1383192597,
 8034,
 -1,
 1383203259,
 8098,
 1383420534,
 1383244493,
 8038,
 -1,
 1383334331,
 8102,
 1383551608,
 1383374806,
 8036,
 -1,
 1383465403,
 8100,
 -1,
 1383523950,
 8096,
 1383792639,
 1383090651,
 8182,
 -1,
 1383662011,
 8183,
 1383879300,
 1383020313,
 8033,
 1383989247,
 1383792762,
 -1,
 1384010367,
 1383913493,
 8035,
 -1,
 1383924155,
 8099,
 1384141441,
 1383965389,
 8039,
 -1,
 1384055227,
 8103,
 1384272515,
 1384095702,
 8037,
 -1,
 1384186299,
 8101,
 -1,
 1384244846,
 8097,
 1384469126,
 1383847957,
 8060,
 -1,
 1384382907,
 8178,
 1384600200,
 1384423382,
 8061,
 -1,
 1384513979,
 8180,
 -44407,
 1384572526,
 8179,
 -1,
 1384696309,
 974,
 1384906751,
 1382900491,
 959,
 1384972287,
 1384778787,
 -1,
 1384993424,
 1384883915,
 8000,
 1385103359,
 1384906874,
 -1,
 -44401,
 1385027605,
 8002,
 -1,
 1385078742,
 8004,
 1385255572,
 1384920857,
 8001,
 1385365503,
 1385169018,
 -1,
 -44397,
 1385289749,
 8003,
 -1,
 1385340886,
 8005,
 -44395,
 1385224213,
 8056,
 -44394,
 1385482741,
 972,
 -1,
 1385537494,
 8057,
 1385714370,
 1382826119,
 -1,
 1385779893,
 1385677589,
 951,
 1385889791,
 1385696291,
 -1,
 1385910950,
 1385799657,
 -1,
 1385976484,
 1385872506,
 7968,
 1386086399,
 1385889914,
 -1,
 1386107551,
 1386010645,
 7970,
 -1,
 1386021307,
 8082,
 1386238625,
 1386062541,
 7974,
 -1,
 1386152379,
 8086,
 1386369699,
 1386192854,
 7972,
 -1,
 1386283451,
 8084,
 -1,
 1386341998,
 8080,
 1386610687,
 1385908699,
 8134,
 -1,
 1386480059,
 8135,
 1386697391,
 1385838361,
 7969,
 1386807295,
 1386610810,
 -1,
 1386828458,
 1386731541,
 7971,
 -1,
 1386742203,
 8083,
 1386959532,
 1386783437,
 7975,
 -1,
 1386873275,
 8087,
 1387090606,
 1386913750,
 7973,
 -1,
 1387004347,
 8085,
 -1,
 1387062894,
 8081,
 1387287217,
 1386666005,
 8052,
 -1,
 1387200955,
 8130,
 1387418291,
 1387241430,
 8053,
 -1,
 1387332027,
 8132,
 -44364,
 1387390574,
 8131,
 -1,
 1387514357,
 942,
 1387724799,
 1385735889,
 949,
 1387790335,
 1387596835,
 -1,
 1387811515,
 1387701963,
 7952,
 1387921407,
 1387724922,
 -1,
 -44358,
 1387845653,
 7954,
 -1,
 1387896790,
 7956,
 1388073663,
 1387738905,
 7953,
 1388183551,
 1387987066,
 -1,
 -44354,
 1388107797,
 7955,
 -1,
 1388158934,
 7957,
 -44352,
 1388042261,
 8050,
 -44351,
 1388300789,
 941,
 -1,
 1388355542,
 8051,
 1388532454,
 1385633140,
 -1,
 1388597987,
 1388478176,
 945,
 1388707839,
 1388514339,
 -1,
 1388729041,
 1388617705,
 -1,
 1388794575,
 1388690554,
 7936,
 1388904447,
 1388707962,
 -1,
 1388925642,
 1388828693,
 7938,
 -1,
 1388839355,
 8066,
 1389056716,
 1388880589,
 7942,
 -1,
 1388970427,
 8070,
 1389187790,
 1389010902,
 7940,
 -1,
 1389101499,
 8068,
 -1,
 1389160046,
 8064,
 1389428735,
 1388726747,
 8118,
 -1,
 1389298107,
 8119,
 1389515482,
 1388656409,
 7937,
 1389625343,
 1389428858,
 -1,
 1389646549,
 1389549589,
 7939,
 -1,
 1389560251,
 8067,
 1389777623,
 1389601485,
 7943,
 -1,
 1389691323,
 8071,
 1389908697,
 1389731798,
 7941,
 -1,
 1389822395,
 8069,
 -1,
 1389880942,
 8065,
 1390105310,
 1389483950,
 -1,
 1390170845,
 1390027209,
 8048,
 -1,
 1390084539,
 8114,
 -1,
 1390127570,
 8112,
 1390367456,
 1390059478,
 8049,
 -1,
 1390281147,
 8116,
 -44319,
 1390339694,
 8115,
 -44318,
 1390463477,
 940,
 -1,
 1390510139,
 8113,
 1390739455,
 1388555045,
 -1,
 -44315,
 1390655470,
 883,
 -1,
 1390703276,
 985,
 1390891777,
 1388500201,
 965,
 1391001599,
 1390808099,
 -1,
 1391022836,
 1390884384,
 -1,
 1391088367,
 1390961208,
 971,
 1391198207,
 1391001722,
 -1,
 -44308,
 1391122453,
 8162,
 -44307,
 1391184373,
 944,
 -44306,
 1391239885,
 8167,
 -1,
 1391304662,
 8163,
 1391525887,
 1391010751,
 8017,
 1391591423,
 1391394938,
 -1,
 -44302,
 1391515669,
 8019,
 -44301,
 1391567565,
 8023,
 -1,
 1391632342,
 8021,
 1391809275,
 1390977001,
 -1,
 1391874810,
 1391770746,
 8016,
 1391984639,
 1391788154,
 -1,
 -44296,
 1391908885,
 8018,
 -44295,
 1391960781,
 8022,
 -1,
 1392025558,
 8020,
 -1,
 1391806939,
 8166,
 1392268030,
 1391777710,
 -1,
 -44291,
 1392224722,
 8160,
 -1,
 1392255433,
 8058,
 -44289,
 1392232949,
 973,
 -44288,
 1392418774,
 8059,
 -1,
 1392476219,
 8161,
 1392661276,
 1390832565,
 953,
 1392771071,
 1392577571,
 -1,
 1392792335,
 1392653856,
 -1,
 1392857866,
 1392730680,
 970,
 1392967679,
 1392771194,
 -1,
 -44281,
 1392891925,
 8146,
 -44280,
 1392953845,
 912,
 -44279,
 1393009357,
 8151,
 -1,
 1393074134,
 8147,
 1393295359,
 1392780223,
 7985,
 1393360895,
 1393164410,
 -1,
 -44275,
 1393285141,
 7987,
 -44274,
 1393337037,
 7991,
 -1,
 1393401814,
 7989,
 1393578774,
 1392746473,
 -1,
 1393644309,
 1393540218,
 7984,
 1393754111,
 1393557626,
 -1,
 -44269,
 1393678357,
 7986,
 -44268,
 1393730253,
 7990,
 -1,
 1393795030,
 7988,
 -1,
 1393576411,
 8150,
 1394037529,
 1393547182,
 -1,
 -44264,
 1393994194,
 8144,
 -1,
 1394024905,
 8054,
 -44262,
 1394002421,
 943,
 -44261,
 1394188246,
 8055,
 -1,
 1394245691,
 8145,
 1394430755,
 1392621343,
 -1,
 1394496288,
 1394349428,
 -1,
 -44257,
 1394444511,
 1019,
 -1,
 1394509703,
 993,
 -44255,
 1394460643,
 987,
 -44254,
 1394632064,
 963,
 -1,
 1394695775,
 1016,
 1394889512,
 1394384873,
 -1,
 -44251,
 1394850780,
 968,
 -44250,
 1394893183,
 960,
 -44249,
 1394957449,
 966,
 -1,
 1395006750,
 887,
 1395217196,
 1394847210,
 961,
 1395326975,
 1395133475,
 -1,
 -44245,
 1395238603,
 8164,
 -1,
 1395275545,
 8165,
 1395479343,
 1395180244,
 -1,
 -44242,
 1395416158,
 952,
 -1,
 1395467663,
 964,
 1395675954,
 1395421320,
 -1,
 -44239,
 1395627917,
 991,
 -1,
 1395662885,
 954,
 1395872565,
 1395602976,
 -1,
 -44236,
 1395811480,
 989,
 -1,
 1395869224,
 948,
 -44234,
 1395845068,
 950,
 -44233,
 1396040588,
 958,
 -44232,
 1396084759,
 957,
 -44231,
 1396148145,
 956,
 -44230,
 1396208863,
 955,
 -44229,
 1396268126,
 881,
 -44228,
 1396331370,
 947,
 -44227,
 1396396148,
 962,
 -44226,
 1396453289,
 967,
 -1,
 1396517143,
 946,
 1396724546,
 1382788453,
 -1,
 -44223,
 1396670289,
 891,
 -1,
 1396718603,
 893,
 -1,
 1396653067,
 892,
 1397030911,
 1382731678,
 -1,
 -44219,
 1396944362,
 7528,
 -44218,
 1397007199,
 7529,
 -44217,
 1397052266,
 7527,
 -44216,
 1397108649,
 7530,
 -1,
 1397172503,
 7526,
 1397380097,
 1382624733,
 -1,
 1397445627,
 1397322584,
 -1,
 1397511162,
 1397378099,
 -1,
 1397576565,
 1397462214,
 -1,
 1397642088,
 1397507232,
 937,
 1397751807,
 1397558307,
 -1,
 1397773147,
 1397661673,
 -1,
 1397838682,
 1397734522,
 8040,
 1397948415,
 1397751930,
 -1,
 1397969750,
 1397858281,
 -1,
 1398035285,
 1397901787,
 8046,
 -1,
 1397948724,
 8110,
 -1,
 1397994612,
 8104,
 1398231896,
 1397938197,
 8042,
 -1,
 1398145332,
 8106,
 1398407167,
 1398185942,
 8044,
 -1,
 1398276404,
 8108,
 -1,
 1397798004,
 8188,
 1398559589,
 1397700377,
 8041,
 1398669311,
 1398472826,
 -1,
 1398690657,
 1398579177,
 -1,
 1398756192,
 1398622683,
 8047,
 -1,
 1398669620,
 8111,
 -1,
 1398715508,
 8105,
 1398952803,
 1398659093,
 8043,
 -1,
 1398866228,
 8107,
 1399128063,
 1398906838,
 8045,
 -1,
 1398997300,
 8109,
 -44186,
 1398528021,
 8186,
 -44185,
 1399179765,
 911,
 -1,
 1399234518,
 8187,
 1399455743,
 1397580555,
 927,
 1399521279,
 1399327779,
 -1,
 1399542638,
 1399432907,
 8008,
 1399652351,
 1399455866,
 -1,
 -44179,
 1399576597,
 8010,
 -1,
 1399627734,
 8012,
 1399804786,
 1399469849,
 8009,
 1399914495,
 1399718010,
 -1,
 -44175,
 1399838741,
 8011,
 -1,
 1399889878,
 8013,
 -44173,
 1399773205,
 8184,
 -44172,
 1400031733,
 908,
 -1,
 1400086486,
 8185,
 1400263582,
 1397506183,
 -1,
 1400329105,
 1400226581,
 919,
 1400438783,
 1400245283,
 -1,
 1400460164,
 1400348649,
 -1,
 1400525699,
 1400421498,
 7976,
 1400635391,
 1400438906,
 -1,
 1400656767,
 1400545257,
 -1,
 1400722302,
 1400588763,
 7982,
 -1,
 1400635700,
 8094,
 -1,
 1400681588,
 8088,
 1400918913,
 1400625173,
 7978,
 -1,
 1400832308,
 8090,
 1401094143,
 1400872918,
 7980,
 -1,
 1400963380,
 8092,
 -1,
 1400484980,
 8140,
 1401246606,
 1400387353,
 7977,
 1401356287,
 1401159802,
 -1,
 1401377674,
 1401266153,
 -1,
 1401443209,
 1401309659,
 7983,
 -1,
 1401356596,
 8095,
 -1,
 1401402484,
 8089,
 1401639820,
 1401346069,
 7979,
 -1,
 1401553204,
 8091,
 1401815039,
 1401593814,
 7981,
 -1,
 1401684276,
 8093,
 -44145,
 1401214997,
 8138,
 -44144,
 1401866741,
 905,
 -1,
 1401921494,
 8139,
 1402142719,
 1400284881,
 917,
 1402208255,
 1402014755,
 -1,
 1402229655,
 1402119883,
 7960,
 1402339327,
 1402142842,
 -1,
 -44138,
 1402263573,
 7962,
 -1,
 1402314710,
 7964,
 1402491803,
 1402156825,
 7961,
 1402601471,
 1402404986,
 -1,
 -44134,
 1402525717,
 7963,
 -1,
 1402576854,
 7965,
 -44132,
 1402460181,
 8136,
 -44131,
 1402718709,
 904,
 -1,
 1402773462,
 8137,
 1402950590,
 1400182132,
 -1,
 1403016125,
 1402896096,
 913,
 1403125759,
 1402932259,
 -1,
 1403147181,
 1403035625,
 -1,
 1403212716,
 1403108474,
 7944,
 1403322367,
 1403125882,
 -1,
 1403343784,
 1403232233,
 -1,
 1403409319,
 1403275739,
 7950,
 -1,
 1403322676,
 8078,
 -1,
 1403368564,
 8072,
 1403605930,
 1403312149,
 7946,
 -1,
 1403519284,
 8074,
 1403781119,
 1403559894,
 7948,
 -1,
 1403650356,
 8076,
 -1,
 1403171956,
 8124,
 1403933623,
 1403074329,
 7945,
 1404043263,
 1403846778,
 -1,
 1404064691,
 1403953129,
 -1,
 1404130226,
 1403996635,
 7951,
 -1,
 1404043572,
 8079,
 -1,
 1404089460,
 8073,
 1404326837,
 1404033045,
 7947,
 -1,
 1404240180,
 8075,
 1404502015,
 1404280790,
 7949,
 -1,
 1404371252,
 8077,
 1404588986,
 1403901870,
 -1,
 -44103,
 1404545490,
 8120,
 -1,
 1404576201,
 8122,
 -44101,
 1404553717,
 902,
 -44100,
 1404739542,
 8123,
 -1,
 1404796987,
 8121,
 -1,
 1402972973,
 882,
 1405047762,
 1402891189,
 921,
 1405157375,
 1404963875,
 -1,
 1405178823,
 1405040160,
 -1,
 1405244358,
 1405100991,
 7993,
 1405353983,
 1405157498,
 -1,
 -44092,
 1405278229,
 7995,
 -44091,
 1405330125,
 7999,
 -1,
 1405394902,
 7997,
 -1,
 1405182520,
 938,
 1405637580,
 1405134539,
 7992,
 1405747199,
 1405550714,
 -1,
 -44086,
 1405671445,
 7994,
 -44085,
 1405723341,
 7998,
 -1,
 1405788118,
 7996,
 1405965263,
 1405605806,
 -1,
 -44082,
 1405921746,
 8152,
 -1,
 1405952457,
 8154,
 -44080,
 1405929973,
 906,
 -44079,
 1406115798,
 8155,
 -1,
 1406173243,
 8153,
 1406358497,
 1405015273,
 933,
 1406468095,
 1406274595,
 -1,
 1406489563,
 1406350880,
 -1,
 1406555098,
 1406411711,
 8025,
 1406664703,
 1406468218,
 -1,
 -44072,
 1406588949,
 8027,
 -44071,
 1406640845,
 8031,
 -1,
 1406705622,
 8029,
 -1,
 1406493240,
 939,
 1406948318,
 1406457774,
 -1,
 -44067,
 1406904786,
 8168,
 -1,
 1406935497,
 8170,
 -44065,
 1406913013,
 910,
 -44064,
 1407098838,
 8171,
 -1,
 1407156283,
 8169,
 1407341542,
 1406312425,
 -1,
 -44061,
 1407302620,
 936,
 -44060,
 1407345023,
 928,
 -44059,
 1407409289,
 934,
 -1,
 1407458590,
 886,
 1407669226,
 1407301407,
 -1,
 -44056,
 1407608192,
 931,
 -44055,
 1407671903,
 1015,
 -1,
 1407720766,
 1018,
 1407931373,
 1407632084,
 -1,
 -44052,
 1407867998,
 920,
 -1,
 1407919503,
 932,
 1408127983,
 1407888874,
 929,
 -1,
 1408044235,
 8172,
 -44048,
 1408100300,
 918,
 -44047,
 1408230284,
 926,
 -44046,
 1408274455,
 925,
 -44045,
 1408337841,
 924,
 -44044,
 1408398559,
 923,
 -44043,
 1408463126,
 922,
 -44042,
 1408523358,
 880,
 -44041,
 1408586602,
 915,
 -44040,
 1408645043,
 916,
 -44039,
 1408708521,
 935,
 -1,
 1408772375,
 914,
 -1,
 1397477876,
 1017,
 1409045502,
 1397402981,
 -1,
 -44035,
 1408991057,
 1021,
 -1,
 1409039371,
 1023,
 -44033,
 1409009313,
 1012,
 -44032,
 1409183951,
 975,
 -1,
 1409235979,
 1022,
 1409438806,
 1397298548,
 -1,
 1409504338,
 1409365022,
 -1,
 1409569832,
 1409426798,
 -1,
 1409635351,
 1409503241,
 -1,
 1409700880,
 1409603828,
 65859,
 1409810431,
 1409613824,
 -1,
 1409831947,
 1409729236,
 -1,
 1409897482,
 1409769487,
 65862,
 -1,
 1409813172,
 65870,
 -1,
 1409817386,
 65864,
 1410094095,
 1409769751,
 65861,
 1410203647,
 1410007040,
 -1,
 -44018,
 1410122697,
 65868,
 -1,
 1410187347,
 65875,
 -1,
 1410056275,
 65871,
 1410465791,
 1409635006,
 65860,
 1410531327,
 1410334720,
 -1,
 1410552854,
 1410450132,
 -1,
 1410618389,
 1410490383,
 65863,
 -1,
 1410534015,
 65878,
 -1,
 1410538282,
 65866,
 -1,
 1410515027,
 65873,
 1410880546,
 1409586627,
 -1,
 1410946077,
 1410816139,
 -1,
 1411011612,
 1410912873,
 -1,
 -44005,
 1410974665,
 65867,
 -1,
 1411039315,
 65874,
 -1,
 1410931530,
 65857,
 1411273760,
 1410909990,
 -1,
 -44001,
 1411236809,
 65869,
 -1,
 1411301459,
 65876,
 -43999,
 1411229781,
 65856,
 -1,
 1411399613,
 65858,
 1411645439,
 1410843946,
 -1,
 1411666982,
 1411564244,
 -1,
 -43995,
 1411604525,
 65877,
 -1,
 1411652394,
 65865,
 -43993,
 1411629139,
 65872,
 -1,
 1411810840,
 65879,
 1411994689,
 1409532628,
 -1,
 1412060217,
 1411931215,
 -1,
 1412125744,
 1412022996,
 -1,
 1412191278,
 1412061323,
 -1,
 -43987,
 1412148313,
 65899,
 -1,
 1412197590,
 65893,
 -43985,
 1412161935,
 65884,
 -1,
 1412318961,
 65892,
 1412518964,
 1412076991,
 65881,
 1412628479,
 1412431872,
 -1,
 -43981,
 1412548381,
 65905,
 -1,
 1412587799,
 65898,
 1412825087,
 1412452361,
 -1,
 1412846648,
 1412749559,
 -1,
 -43977,
 1412810525,
 65906,
 -1,
 1412849943,
 65902,
 -1,
 1412780734,
 65897,
 1413152767,
 1412019191,
 -1,
 1413174335,
 1413042185,
 -1,
 1413239869,
 1413142772,
 65887,
 -1,
 1413153894,
 65901,
 1413414911,
 1413173950,
 65894,
 -1,
 1413283918,
 65895,
 1413545983,
 1413137702,
 65888,
 -1,
 1413414990,
 65889,
 1413633095,
 1411931178,
 -1,
 1413698630,
 1413580248,
 -1,
 -43964,
 1413661990,
 65890,
 -43963,
 1413715391,
 65882,
 -1,
 1413763097,
 65896,
 -1,
 1413617781,
 65880,
 1414026315,
 1413564599,
 -1,
 1414091850,
 1413991778,
 65883,
 -1,
 1414005630,
 65886,
 -1,
 1414025420,
 65900,
 1414288462,
 1413950686,
 -1,
 -43955,
 1414260383,
 65885,
 -1,
 1414275847,
 65903,
 -43953,
 1414250708,
 65908,
 -43952,
 1414433291,
 65904,
 -43951,
 1414497346,
 65891,
 -1,
 1414543260,
 65907,
 1414747221,
 1409460564,
 -1,
 -43948,
 1414710095,
 65926,
 -1,
 1414765669,
 65927,
 -1,
 1414696346,
 903,
 1415009405,
 1409378710,
 -1,
 1415074911,
 1414927292,
 119327,
 -43943,
 1414993217,
 119356,
 -43942,
 1415058701,
 119355,
 -43941,
 1415124166,
 119354,
 -43940,
 1415189513,
 119353,
 -43939,
 1415254860,
 119352,
 -43938,
 1415320231,
 119351,
 -1,
 1415385487,
 119350,
 1415599207,
 1414992399,
 119325,
 -43935,
 1415517505,
 119337,
 -43934,
 1415582989,
 119336,
 -43933,
 1415648454,
 119335,
 -43932,
 1415713724,
 119334,
 -43931,
 1415779148,
 119333,
 -43930,
 1415844519,
 119332,
 -1,
 1415909903,
 119331,
 1416123502,
 1415516839,
 119326,
 -43927,
 1416041793,
 119343,
 -43926,
 1416107206,
 119342,
 -43925,
 1416172673,
 119341,
 -43924,
 1416238089,
 119340,
 -43923,
 1416303548,
 119339,
 -1,
 1416368972,
 119338,
 1416582260,
 1416041481,
 119328,
 -43920,
 1416500156,
 119361,
 -43919,
 1416565580,
 119360,
 -43918,
 1416630951,
 119359,
 -43917,
 1416696335,
 119358,
 -1,
 1416761743,
 119357,
 1416975483,
 1416500044,
 -1,
 -43914,
 1416893761,
 119349,
 -43913,
 1416959245,
 119348,
 -43912,
 1417024710,
 119347,
 -43911,
 1417090177,
 119346,
 -43910,
 1417155239,
 119345,
 -1,
 1417220495,
 119344,
 -43908,
 1416893709,
 119330,
 -1,
 1417352390,
 119329,
 1417565341,
 1414977454,
 -1,
 1417630876,
 1417515583,
 -1,
 1417696394,
 1417548303,
 119296,
 -43903,
 1417614657,
 119314,
 -43902,
 1417680141,
 119313,
 -43901,
 1417745606,
 119312,
 -43900,
 1417811073,
 119311,
 -43899,
 1417876489,
 119310,
 -43898,
 1417941948,
 119309,
 -43897,
 1418007372,
 119308,
 -43896,
 1418072743,
 119307,
 -43895,
 1418138127,
 119306,
 -1,
 1418203535,
 119305,
 1418417296,
 1417614345,
 119300,
 -43892,
 1418335164,
 119324,
 -43891,
 1418400588,
 119323,
 -43890,
 1418465959,
 119322,
 -43889,
 1418531343,
 119321,
 -1,
 1418596751,
 119320,
 1418810518,
 1418334887,
 119297,
 -43886,
 1418728380,
 119319,
 -43885,
 1418793804,
 119318,
 -43884,
 1418859175,
 119317,
 -43883,
 1418924559,
 119316,
 -1,
 1418989967,
 119315,
 -43881,
 1418728769,
 119304,
 -43880,
 1419121933,
 119303,
 -43879,
 1419187398,
 119302,
 -43878,
 1419252865,
 119301,
 -43877,
 1419318204,
 119299,
 -1,
 1419383628,
 119298,
 -1,
 1417552329,
 8175,
 1419662514,
 1417507672,
 -1,
 1419728045,
 1419594803,
 -1,
 1419793577,
 1419687711,
 -1,
 1419859111,
 1419739444,
 -1,
 1419924644,
 1419812841,
 -1,
 -43869,
 1419885532,
 7466,
 -1,
 1419927935,
 7464,
 -43867,
 1419881962,
 7465,
 -43866,
 1420063967,
 7463,
 -1,
 1420120938,
 7462,
 -43864,
 1419823075,
 986,
 -1,
 1420238128,
 992,
 -43862,
 1419765320,
 1011,
 -43861,
 1420391084,
 990,
 -43860,
 1420442000,
 988,
 -1,
 1420501310,
 984,
 1420711088,
 1419694573,
 -1,
 -43857,
 1420672030,
 1010,
 -1,
 1420708054,
 1013,
 -43855,
 1420664678,
 885,
 -1,
 1420848703,
 65923,
 1421038783,
 1419589152,
 -1,
 1421104313,
 1420976705,
 -1,
 1421169848,
 1421024619,
 -1,
 -43850,
 1421137941,
 8173,
 -43849,
 1421189837,
 8129,
 -1,
 1421254614,
 8174,
 -1,
 1421134325,
 901,
 1421497534,
 1421026239,
 8190,
 1421606911,
 1421410426,
 -1,
 -43844,
 1421531157,
 8157,
 -43843,
 1421583053,
 8159,
 -1,
 1421647830,
 8158,
 -1,
 1421453766,
 65915,
 1421890763,
 1421001428,
 -1,
 1421956293,
 1421826187,
 -1,
 1422021828,
 1421913172,
 -1,
 -43837,
 1421977743,
 65912,
 -1,
 1422037542,
 65918,
 -1,
 1421953893,
 977,
 1422283976,
 1421926802,
 -1,
 -43833,
 1422247657,
 65911,
 -1,
 1422299686,
 65917,
 -43831,
 1422243576,
 65929,
 -43830,
 1422431855,
 900,
 -1,
 1422465823,
 65914,
 1422677205,
 1421844457,
 -1,
 1422742737,
 1422638202,
 8127,
 1422852095,
 1422655610,
 -1,
 -43825,
 1422776341,
 8141,
 -43824,
 1422828237,
 8143,
 -1,
 1422893014,
 8142,
 -43822,
 1422701684,
 8126,
 -43821,
 1423008197,
 982,
 -43820,
 1423072410,
 981,
 -1,
 1423133147,
 8128,
 1423332571,
 1422627215,
 -1,
 1423398104,
 1423280930,
 65909,
 -1,
 1423310926,
 65910,
 -43815,
 1423369103,
 8189,
 -43814,
 1423495891,
 65924,
 -1,
 1423518397,
 65916,
 1423725793,
 1423274120,
 -1,
 1423791327,
 1423644020,
 -1,
 -43810,
 1423746437,
 1008,
 -1,
 1423794629,
 983,
 -43808,
 1423762578,
 65922,
 -1,
 1423939968,
 8125,
 1424119013,
 1423693041,
 -1,
 -43805,
 1424055984,
 978,
 -43804,
 1424111784,
 980,
 -1,
 1424168884,
 979,
 1424381162,
 1424075092,
 -1,
 1424446697,
 1424318050,
 -1,
 -43800,
 1424416977,
 1020,
 -1,
 1424474716,
 1009,
 -1,
 1424379145,
 1014,
 1424708845,
 1424352238,
 -1,
 -43796,
 1424663731,
 890,
 -1,
 1424703814,
 65913,
 1424905456,
 1424654309,
 -1,
 -43793,
 1424873137,
 119365,
 -1,
 1424903181,
 65921,
 1425102067,
 1424838230,
 -1,
 -43790,
 1425054781,
 65919,
 -1,
 1425108623,
 65920,
 -43788,
 1425074102,
 65930,
 -43787,
 1425269619,
 65925,
 -43786,
 1425320126,
 894,
 -43785,
 1425379443,
 884,
 -43784,
 1425430164,
 65928,
 -1,
 1425484060,
 976,
 1425735679,
 1382556847,
 -1,
 1425757449,
 1425641871,
 -1,
 1425822982,
 1425713494,
 -1,
 1425888513,
 1425784172,
 10878,
 1425997823,
 1425804545,
 -1,
 1426019584,
 1425872501,
 10882,
 -1,
 1425933673,
 10884,
 -1,
 1425959311,
 10880,
 1426216196,
 1425819894,
 -1,
 -43773,
 1426157158,
 8819,
 -1,
 1426201125,
 8805,
 -43771,
 1426159951,
 8823,
 -1,
 1426333738,
 10886,
 1426587647,
 1425791385,
 -1,
 -43768,
 1426486626,
 10916,
 -1,
 1426523034,
 8807,
 1426740502,
 1425675636,
 -1,
 1426806035,
 1426664270,
 -1,
 1426871568,
 1426765599,
 -1,
 1426937103,
 1426810587,
 -1,
 -43762,
 1426888708,
 10894,
 -1,
 1426921166,
 10896,
 -1,
 1426879793,
 10900,
 -43759,
 1426829471,
 10616,
 -43758,
 1427143001,
 10898,
 -1,
 1427193329,
 10892,
 1427439615,
 1426754144,
 -1,
 -43755,
 1427356902,
 10888,
 -1,
 1427410507,
 10890,
 1427592474,
 1426710386,
 -1,
 -43752,
 1427548364,
 10876,
 -43751,
 1427585832,
 8919,
 -1,
 1427648593,
 10874,
 1427854623,
 1427514998,
 -1,
 1427920158,
 1427822353,
 -1,
 -43747,
 1427861094,
 8935,
 -1,
 1427905061,
 8809,
 -1,
 1427851941,
 10917,
 1428182305,
 1427779990,
 10919,
 -1,
 1428095009,
 10921,
 -43742,
 1428143147,
 62,
 -1,
 1428244790,
 8923,
 -1,
 1382491625,
 96,
 1428510208,
 1382469194,
 -1,
 1428575638,
 1428451124,
 -1,
 1428641126,
 1428519386,
 -1,
 1428706606,
 1428608942,
 -1,
 1428772141,
 1428656725,
 -1,
 1428837675,
 1428728148,
 2699,
 -1,
 1428793684,
 2784,
 1429012479,
 1428779864,
 2700,
 -1,
 1428910936,
 2785,
 -1,
 1428690292,
 2741,
 1429165364,
 1428669140,
 -1,
 1429230898,
 1429127892,
 -1,
 -43727,
 1429166249,
 2720,
 -1,
 1429214580,
 2719,
 -43725,
 1429166249,
 2725,
 -1,
 1429345652,
 2724,
 1429558585,
 1429113055,
 -1,
 -43722,
 1429529642,
 2718,
 -43721,
 1429571899,
 2723,
 -43720,
 1429623556,
 2713,
 -1,
 1429673332,
 2728,
 1429886271,
 1429485088,
 -1,
 1429951805,
 1429812768,
 -1,
 -43716,
 1429887145,
 2722,
 -1,
 1429935476,
 2721,
 -43714,
 1429887145,
 2727,
 -1,
 1430066548,
 2726,
 1430279491,
 1429804404,
 2693,
 -43711,
 1430244938,
 2708,
 -43710,
 1430282623,
 2704,
 -1,
 1430328692,
 2694,
 1430541639,
 1430239007,
 -1,
 -43707,
 1430501273,
 2743,
 -43706,
 1430542505,
 2742,
 -1,
 1430590836,
 2744,
 1430803785,
 1430507082,
 2697,
 -1,
 1430769226,
 2698,
 1430934860,
 1430757353,
 -1,
 -43701,
 1430870185,
 2731,
 -1,
 1430918516,
 2730,
 1431131471,
 1430877016,
 -1,
 -43698,
 1431073709,
 2739,
 -1,
 1431115124,
 2738,
 1431328082,
 1431072904,
 -1,
 -43695,
 1431263401,
 2710,
 -1,
 1431311732,
 2709,
 1431524693,
 1431269161,
 -1,
 -43692,
 1431460009,
 2717,
 -1,
 1431508340,
 2716,
 1431721303,
 1431462271,
 2695,
 -1,
 1431658879,
 2696,
 1431852378,
 1431655139,
 -1,
 -43687,
 1431787689,
 2712,
 -1,
 1431836020,
 2711,
 1432048989,
 1431776478,
 -1,
 -43684,
 1431984297,
 2715,
 -1,
 1432032628,
 2714,
 1432245600,
 1431971446,
 -1,
 -43681,
 1432180905,
 2733,
 -1,
 1432229236,
 2732,
 -43679,
 1432216618,
 2735,
 -43678,
 1432398255,
 2736,
 -43677,
 1432457615,
 2707,
 -43676,
 1432518706,
 2734,
 -43675,
 1432574121,
 2745,
 -1,
 1432633479,
 2703,
 1432835453,
 1428610191,
 -1,
 1432900986,
 1432796208,
 -1,
 1432966509,
 1432869903,
 -1,
 1433032043,
 1432922452,
 2755,
 -1,
 1432987988,
 2756,
 1433206783,
 1432974168,
 2786,
 -1,
 1433105240,
 2787,
 1433294193,
 1432884596,
 -1,
 -43665,
 1433259594,
 2764,
 -43664,
 1433297279,
 2760,
 -1,
 1433343348,
 2750,
 1433556339,
 1433259594,
 2753,
 -1,
 1433521738,
 2754,
 1433687413,
 1433493887,
 2751,
 -1,
 1433624959,
 2752,
 1433818488,
 1433611679,
 -1,
 -43657,
 1433768335,
 2761,
 -1,
 1433813127,
 2757,
 -43655,
 1433768335,
 2763,
 -1,
 1433944199,
 2759,
 1434189823,
 1432825247,
 -1,
 -43652,
 1434096015,
 2705,
 -1,
 1434140807,
 2701,
 1434342795,
 1432762776,
 -1,
 1434408321,
 1434305236,
 -1,
 -43648,
 1434378639,
 2792,
 -1,
 1434411094,
 2793,
 1434604932,
 1434367775,
 -1,
 -43645,
 1434545902,
 2796,
 -1,
 1434602626,
 2797,
 1434801543,
 1434537558,
 -1,
 -43642,
 1434754032,
 2794,
 -1,
 1434807927,
 2795,
 -43640,
 1434773397,
 2790,
 -43639,
 1434949055,
 2791,
 -43638,
 1435012284,
 2799,
 -1,
 1435059511,
 2798,
 1435260308,
 1434303536,
 -1,
 1435325839,
 1435229029,
 -1,
 -43634,
 1435285541,
 2691,
 -1,
 1435347597,
 2765,
 1435522450,
 1435243892,
 -1,
 -43631,
 1435490245,
 2749,
 -1,
 1435537605,
 2690,
 -43629,
 1435471925,
 2748,
 -1,
 1435643316,
 2689,
 -43627,
 1435219660,
 2801,
 -1,
 1435800774,
 2768,
 1435981311,
 1428534161,
 -1,
 1436046808,
 1435924954,
 -1,
 1436112286,
 1436009172,
 -1,
 1436177820,
 1436074708,
 -1,
 -43621,
 1436113065,
 2592,
 -1,
 1436161396,
 2591,
 -43619,
 1436113065,
 2597,
 -1,
 1436292468,
 2596,
 1436505507,
 1436059871,
 -1,
 -43616,
 1436476458,
 2590,
 -43615,
 1436518715,
 2595,
 -43614,
 1436570372,
 2585,
 -1,
 1436620148,
 2600,
 1436833193,
 1436431904,
 -1,
 1436898727,
 1436759584,
 -1,
 -43610,
 1436833961,
 2594,
 -1,
 1436882292,
 2593,
 -43608,
 1436833961,
 2599,
 -1,
 1437013364,
 2598,
 1437226413,
 1436751220,
 2565,
 -43605,
 1437191754,
 2580,
 -43604,
 1437229439,
 2576,
 -1,
 1437275508,
 2566,
 1437488562,
 1437167752,
 -1,
 1437554097,
 1437423755,
 -1,
 -43600,
 1437489321,
 2649,
 -1,
 1437537652,
 2582,
 -1,
 1437472116,
 2581,
 1437816247,
 1437422307,
 -1,
 1437881782,
 1437751435,
 -1,
 -43595,
 1437817001,
 2650,
 -1,
 1437865332,
 2584,
 -1,
 1437799796,
 2583,
 1438143929,
 1437781578,
 2569,
 -1,
 1438109258,
 2570,
 1438275004,
 1438103327,
 -1,
 -43589,
 1438210217,
 2614,
 -1,
 1438258548,
 2616,
 1438471615,
 1438230868,
 -1,
 -43586,
 1438427567,
 2652,
 -1,
 1438455156,
 2608,
 1438668226,
 1438425065,
 -1,
 -43583,
 1438603433,
 2603,
 -1,
 1438651764,
 2602,
 1438864837,
 1438610264,
 -1,
 -43580,
 1438806957,
 2611,
 -1,
 1438848372,
 2610,
 1439061448,
 1438805801,
 -1,
 -43577,
 1438996649,
 2589,
 -1,
 1439044980,
 2588,
 1439258058,
 1438998911,
 2567,
 -1,
 1439195519,
 2568,
 1439389133,
 1439182046,
 -1,
 -43572,
 1439324329,
 2587,
 -1,
 1439372660,
 2586,
 1439585744,
 1439311478,
 -1,
 -43569,
 1439520937,
 2605,
 -1,
 1439569268,
 2604,
 -43567,
 1439557424,
 2651,
 -43566,
 1439753258,
 2607,
 -43565,
 1439815612,
 2613,
 -43564,
 1439864452,
 2579,
 -43563,
 1439924274,
 2606,
 -43562,
 1439979689,
 2617,
 -43561,
 1440042687,
 2654,
 -1,
 1440105255,
 2575,
 1440306662,
 1435974040,
 -1,
 1440372188,
 1440269012,
 -1,
 -43557,
 1440342415,
 2664,
 -1,
 1440374870,
 2665,
 1440568799,
 1440331551,
 -1,
 -43554,
 1440509678,
 2668,
 -1,
 1440566402,
 2669,
 1440765410,
 1440501334,
 -1,
 -43551,
 1440717808,
 2666,
 -1,
 1440771703,
 2667,
 -43549,
 1440737173,
 2662,
 -43548,
 1440912831,
 2663,
 -43547,
 1440976060,
 2671,
 -1,
 1441023287,
 2670,
 1441224177,
 1440275638,
 -1,
 1441289707,
 1441142132,
 -1,
 -43543,
 1441254986,
 2636,
 -43542,
 1441292671,
 2632,
 -1,
 1441338740,
 2622,
 1441551853,
 1441254986,
 2625,
 -1,
 1441517130,
 2626,
 1441682927,
 1441489279,
 2623,
 -1,
 1441620351,
 2624,
 -43536,
 1441633924,
 2635,
 -1,
 1441743655,
 2631,
 1441945082,
 1441184816,
 -1,
 1442010613,
 1441913701,
 -1,
 -43532,
 1441970213,
 2563,
 -1,
 1442032269,
 2637,
 -43530,
 1441981540,
 2677,
 -43529,
 1442172925,
 2641,
 -43528,
 1442222133,
 2620,
 -43527,
 1442261364,
 2562,
 -1,
 1442322401,
 2561,
 -43525,
 1441912231,
 2675,
 -43524,
 1442498784,
 2672,
 -43523,
 1442540691,
 2674,
 -43522,
 1442596260,
 2676,
 -1,
 1442650108,
 2673,
 -1,
 1435902214,
 8370,
 1442928302,
 1428439175,
 -1,
 1442993831,
 1442877839,
 -1,
 1443059362,
 1442950606,
 -1,
 1443124797,
 1443002842,
 -1,
 1443190283,
 1443059851,
 -1,
 1443255816,
 1443108212,
 -1,
 -43513,
 1443211604,
 4340,
 -1,
 1443250311,
 4336,
 -43511,
 1443205845,
 4341,
 -43510,
 1443390512,
 4338,
 -1,
 1443446919,
 4337,
 1443649041,
 1443114206,
 -1,
 1443714575,
 1443584139,
 -1,
 -43506,
 1443653424,
 4329,
 -1,
 1443700828,
 4333,
 -43504,
 1443653085,
 4332,
 -1,
 1443831102,
 4330,
 1444042262,
 1443611348,
 -1,
 1444107797,
 1443960180,
 -1,
 -43500,
 1444063572,
 4322,
 -1,
 1444120799,
 4311,
 -1,
 1444075049,
 4345,
 1444369945,
 1444013854,
 -1,
 -43496,
 1444305528,
 4319,
 -1,
 1444366065,
 4310,
 1444566556,
 1444329247,
 -1,
 -43493,
 1444502915,
 4328,
 -1,
 1444551998,
 4321,
 1444763167,
 1444519913,
 -1,
 -43490,
 1444698744,
 4324,
 -1,
 1444749404,
 4318,
 1444959778,
 1444704392,
 -1,
 -43487,
 1444895352,
 4325,
 -1,
 1444945214,
 4313,
 1445156389,
 1444900649,
 -1,
 -43484,
 1445094877,
 4331,
 -1,
 1445157401,
 4335,
 1445353000,
 1445090019,
 -1,
 -43481,
 1445288473,
 4326,
 -1,
 1445338430,
 4306,
 1445549611,
 1445281927,
 -1,
 -43478,
 1445497055,
 4308,
 -1,
 1445558914,
 4344,
 1445746222,
 1445467508,
 -1,
 -43475,
 1445693663,
 4304,
 -1,
 1445750576,
 4346,
 -43473,
 1445717523,
 4343,
 -43472,
 1445913401,
 4334,
 -43471,
 1445977682,
 4339,
 -43470,
 1446042530,
 4309,
 -43469,
 1446105555,
 4323,
 -43468,
 1446160893,
 4320,
 -43467,
 1446225808,
 4327,
 -43466,
 1446286637,
 4317,
 -43465,
 1446349231,
 4316,
 -43464,
 1446412790,
 4315,
 -43463,
 1446475134,
 4314,
 -43462,
 1446537008,
 4312,
 -43461,
 1446596617,
 4342,
 -43460,
 1446656792,
 4307,
 -1,
 1446717234,
 4305,
 1446925935,
 1443085834,
 -1,
 1446991429,
 1446860939,
 -1,
 1447056962,
 1446909300,
 -1,
 -43455,
 1447012692,
 11556,
 -1,
 1447051399,
 11552,
 -43453,
 1447006933,
 11557,
 -43452,
 1447191600,
 11554,
 -1,
 1447248007,
 11553,
 1447450187,
 1446915294,
 -1,
 1447515721,
 1447385227,
 -1,
 -43448,
 1447454512,
 11545,
 -1,
 1447501916,
 11549,
 -43446,
 1447454173,
 11548,
 -1,
 1447632190,
 11546,
 1447843406,
 1447421726,
 -1,
 -43443,
 1447778936,
 11535,
 -1,
 1447839473,
 11526,
 1448040017,
 1447805717,
 -1,
 -43440,
 1447995732,
 11538,
 -1,
 1448052959,
 11527,
 1448236628,
 1447999263,
 -1,
 -43437,
 1448172931,
 11544,
 -1,
 1448222014,
 11537,
 1448433239,
 1448189929,
 -1,
 -43434,
 1448368760,
 11540,
 -1,
 1448419420,
 11534,
 1448629850,
 1448374408,
 -1,
 -43431,
 1448565368,
 11541,
 -1,
 1448615230,
 11529,
 1448826461,
 1448570665,
 -1,
 -43428,
 1448764893,
 11547,
 -1,
 1448827417,
 11551,
 1449023072,
 1448760035,
 -1,
 -43425,
 1448958489,
 11542,
 -1,
 1449008446,
 11522,
 -43423,
 1448993593,
 11550,
 -43422,
 1449188946,
 11555,
 -43421,
 1449253794,
 11525,
 -43420,
 1449316819,
 11539,
 -43419,
 1449372157,
 11536,
 -43418,
 1449437072,
 11543,
 -43417,
 1449497901,
 11533,
 -43416,
 1449560495,
 11532,
 -43415,
 1449624054,
 11531,
 -43414,
 1449686398,
 11530,
 -43413,
 1449748272,
 11528,
 -43412,
 1449805553,
 11524,
 -43411,
 1449868056,
 11523,
 -43410,
 1449928498,
 11521,
 -1,
 1449991486,
 11520,
 1450202785,
 1446850052,
 -1,
 1450268279,
 1450137739,
 -1,
 1450333812,
 1450186100,
 -1,
 -43405,
 1450289492,
 4292,
 -1,
 1450328199,
 4288,
 -43403,
 1450283733,
 4293,
 -43402,
 1450468400,
 4290,
 -1,
 1450524807,
 4289,
 1450727037,
 1450192094,
 -1,
 1450792571,
 1450662027,
 -1,
 -43398,
 1450731312,
 4281,
 -1,
 1450778716,
 4285,
 -43396,
 1450730973,
 4284,
 -1,
 1450908990,
 4282,
 1451120256,
 1450698526,
 -1,
 -43393,
 1451055736,
 4271,
 -1,
 1451116273,
 4262,
 1451316867,
 1451082517,
 -1,
 -43390,
 1451272532,
 4274,
 -1,
 1451329759,
 4263,
 1451513478,
 1451276063,
 -1,
 -43387,
 1451449731,
 4280,
 -1,
 1451498814,
 4273,
 1451710089,
 1451466729,
 -1,
 -43384,
 1451645560,
 4276,
 -1,
 1451696220,
 4270,
 1451906700,
 1451651208,
 -1,
 -43381,
 1451842168,
 4277,
 -1,
 1451892030,
 4265,
 1452103311,
 1451847465,
 -1,
 -43378,
 1452041693,
 4283,
 -1,
 1452104217,
 4287,
 1452299922,
 1452036835,
 -1,
 -43375,
 1452235289,
 4278,
 -1,
 1452285246,
 4258,
 -43373,
 1452270393,
 4286,
 -43372,
 1452465746,
 4291,
 -43371,
 1452530594,
 4261,
 -43370,
 1452593619,
 4275,
 -43369,
 1452648957,
 4272,
 -43368,
 1452713872,
 4279,
 -43367,
 1452774701,
 4269,
 -43366,
 1452837295,
 4268,
 -43365,
 1452900854,
 4267,
 -43364,
 1452963198,
 4266,
 -43363,
 1453025072,
 4264,
 -43362,
 1453082353,
 4260,
 -43361,
 1453144856,
 4259,
 -43360,
 1453205298,
 4257,
 -1,
 1453268286,
 4256,
 -1,
 1450156282,
 4347,
 1453588479,
 1443005549,
 -1,
 1453610662,
 1453464600,
 -1,
 -43355,
 1453551206,
 8782,
 -1,
 1453595173,
 8785,
 -1,
 1453525366,
 8762,
 1453872811,
 1442914396,
 9881,
 1453981695,
 1453788189,
 -1,
 -43350,
 1453890741,
 9965,
 -1,
 1453917233,
 9966,
 -43348,
 1453835036,
 12307,
 -43347,
 1454093160,
 8368,
 -1,
 1454146963,
 9802,
 1454331695,
 1442870104,
 -1,
 1454397230,
 1454250209,
 -1,
 1454462703,
 1454358026,
 -1,
 1454528186,
 1454421791,
 -1,
 1454593718,
 1454463115,
 -1,
 1454659253,
 1454555925,
 11339,
 -1,
 1454613391,
 11356,
 -1,
 1454577012,
 11342,
 1454855864,
 1454539239,
 11348,
 -1,
 1454771820,
 11349,
 -43335,
 1454810008,
 11346,
 -1,
 1454931482,
 11332,
 1455118019,
 1454498798,
 -1,
 1455183552,
 1455046791,
 -1,
 1455249087,
 1455139156,
 -1,
 -43330,
 1455214154,
 11343,
 -1,
 1455251839,
 11344,
 -1,
 1455210868,
 11317,
 -43327,
 1455148618,
 11347,
 -43326,
 1455460751,
 11350,
 -1,
 1455498514,
 11345,
 1455707851,
 1455055231,
 11323,
 1455773383,
 1455679441,
 -1,
 -43322,
 1455713865,
 11355,
 -1,
 1455767687,
 11321,
 1455969994,
 1455725194,
 -1,
 -43319,
 1455930970,
 11351,
 -1,
 1455958360,
 11353,
 -1,
 1455918369,
 11322,
 1456232143,
 1455669972,
 -1,
 -43315,
 1456200930,
 11333,
 -43314,
 1456258012,
 11340,
 -1,
 1456321582,
 11357,
 1456494291,
 1456158240,
 -1,
 -43311,
 1456465784,
 11319,
 -43310,
 1456509498,
 11316,
 -1,
 1456566242,
 11324,
 1456756438,
 1456465694,
 -1,
 -43307,
 1456692767,
 11318,
 -1,
 1456752325,
 11320,
 1456953049,
 1456709609,
 -1,
 -43304,
 1456903162,
 11330,
 -1,
 1456947335,
 11338,
 1457149660,
 1456902543,
 -1,
 -43301,
 1457114249,
 11337,
 -1,
 1457164311,
 11329,
 1457346271,
 1457091416,
 -1,
 -43298,
 1457287282,
 11326,
 -1,
 1457333556,
 11358,
 1457542882,
 1457278550,
 -1,
 -43295,
 1457500948,
 11335,
 -1,
 1457548678,
 11354,
 1457739493,
 1457464950,
 -1,
 -43292,
 1457705134,
 11313,
 -1,
 1457742989,
 11352,
 -43290,
 1457707351,
 11314,
 -43289,
 1457901733,
 11334,
 -43288,
 1457959694,
 11331,
 -43287,
 1458014661,
 11328,
 -43286,
 1458079939,
 11327,
 -43285,
 1458139358,
 11325,
 -43284,
 1458199619,
 11336,
 -43283,
 1458263498,
 11315,
 -43282,
 1458319335,
 11341,
 -1,
 1458382450,
 11312,
 1458634751,
 1454386692,
 -1,
 1458657017,
 1458550559,
 -1,
 1458722549,
 1458591883,
 -1,
 1458788084,
 1458684693,
 11291,
 -1,
 1458742159,
 11308,
 -1,
 1458705780,
 11294,
 1458984695,
 1458668007,
 11300,
 -1,
 1458900588,
 11301,
 -43272,
 1458938776,
 11298,
 -1,
 1459060250,
 11284,
 1459246850,
 1458627566,
 -1,
 1459312383,
 1459175559,
 -1,
 1459377918,
 1459267924,
 -1,
 -43267,
 1459342922,
 11295,
 -1,
 1459380607,
 11296,
 -1,
 1459339636,
 11269,
 -43264,
 1459277386,
 11299,
 -43263,
 1459589519,
 11302,
 -1,
 1459627282,
 11297,
 1459836682,
 1459183999,
 11275,
 1459902214,
 1459808209,
 -1,
 -43259,
 1459842633,
 11307,
 -1,
 1459896455,
 11273,
 1460098825,
 1459853962,
 -1,
 -43256,
 1460059738,
 11303,
 -1,
 1460087128,
 11305,
 -1,
 1460047137,
 11274,
 1460360974,
 1459798740,
 -1,
 -43252,
 1460329698,
 11285,
 -43251,
 1460386780,
 11292,
 -1,
 1460450350,
 11309,
 1460623122,
 1460287008,
 -1,
 -43248,
 1460594552,
 11271,
 -43247,
 1460638266,
 11268,
 -1,
 1460695010,
 11276,
 1460885269,
 1460594462,
 -1,
 -43244,
 1460821535,
 11270,
 -1,
 1460881093,
 11272,
 1461081880,
 1460838377,
 -1,
 -43241,
 1461031930,
 11282,
 -1,
 1461076103,
 11290,
 1461278491,
 1461031311,
 -1,
 -43238,
 1461243017,
 11289,
 -1,
 1461293079,
 11281,
 1461475102,
 1461220184,
 -1,
 -43235,
 1461416050,
 11278,
 -1,
 1461462324,
 11310,
 1461671713,
 1461407318,
 -1,
 -43232,
 1461629716,
 11287,
 -1,
 1461677446,
 11306,
 1461868324,
 1461593718,
 -1,
 -43229,
 1461833902,
 11265,
 -1,
 1461871757,
 11304,
 -43227,
 1461836119,
 11266,
 -43226,
 1462030501,
 11286,
 -43225,
 1462088462,
 11283,
 -43224,
 1462143429,
 11280,
 -43223,
 1462208707,
 11279,
 -43222,
 1462268126,
 11277,
 -43221,
 1462328387,
 11288,
 -43220,
 1462392266,
 11267,
 -43219,
 1462448103,
 11293,
 -1,
 1462511218,
 11264,
 -1,
 1454327080,
 10726,
 1462785873,
 1454283464,
 -1,
 1462851381,
 1462733023,
 -1,
 1462916916,
 1462790242,
 -1,
 -43213,
 1462881833,
 66369,
 -1,
 1462895718,
 66378,
 -1,
 1462838728,
 66365,
 1463179064,
 1462813396,
 -1,
 -43209,
 1463115284,
 66360,
 -1,
 1463174552,
 66372,
 1463375675,
 1463116159,
 -1,
 -43206,
 1463341200,
 66358,
 -1,
 1463375017,
 66375,
 1463572286,
 1463310475,
 -1,
 -43203,
 1463541067,
 66376,
 -1,
 1463556311,
 66359,
 1463768897,
 1463489908,
 -1,
 -43200,
 1463707029,
 66356,
 -1,
 1463771362,
 66352,
 -43198,
 1463738214,
 66373,
 -43197,
 1463932508,
 66367,
 -43196,
 1463990331,
 66371,
 -43195,
 1464052271,
 66370,
 -43194,
 1464117115,
 66357,
 -43193,
 1464180886,
 66368,
 -43192,
 1464244924,
 66377,
 -43191,
 1464304162,
 66364,
 -43190,
 1464366225,
 66363,
 -43189,
 1464431408,
 66362,
 -43188,
 1464496071,
 66366,
 -43187,
 1464554876,
 66354,
 -43186,
 1464618726,
 66374,
 -43185,
 1464681870,
 66361,
 -43184,
 1464743618,
 66355,
 -1,
 1464805117,
 66353,
 -1,
 1462724255,
 8503,
 1465080661,
 1382379656,
 -1,
 1465145885,
 1464997236,
 -1,
 1465211130,
 1465092319,
 -1,
 1465276551,
 1465145421,
 -1,
 1465341835,
 1465235231,
 -1,
 1465407328,
 1465303764,
 -1,
 1465472860,
 1465356687,
 -1,
 1465538395,
 1465425897,
 12108,
 -1,
 1465492405,
 12169,
 -1,
 1465486083,
 12143,
 1465735007,
 1465401479,
 -1,
 -43170,
 1465688041,
 12091,
 -1,
 1465719911,
 12115,
 -1,
 1465654631,
 12148,
 1465997159,
 1465360361,
 -1,
 1466062692,
 1465925767,
 -1,
 -43165,
 1465991733,
 12180,
 -1,
 1466048604,
 12141,
 -43163,
 1466021134,
 12076,
 -43162,
 1466209961,
 12052,
 -1,
 1466264739,
 12144,
 1466455920,
 1465931915,
 -1,
 1466521453,
 1466405263,
 -1,
 1466586988,
 1466480160,
 -1,
 -43157,
 1466523728,
 12083,
 -1,
 1466571074,
 12203,
 -1,
 1466538570,
 12087,
 1466892287,
 1466450055,
 -1,
 -43153,
 1466792962,
 12185,
 -1,
 1466845331,
 12154,
 1467045749,
 1466384519,
 -1,
 -43150,
 1466989110,
 12163,
 -43149,
 1467039879,
 12178,
 -43148,
 1467101806,
 12036,
 -1,
 1467161076,
 12057,
 1467373434,
 1466987352,
 -1,
 1467438969,
 1467290996,
 -1,
 -43144,
 1467406580,
 12202,
 -1,
 1467464211,
 12035,
 -1,
 1467376379,
 12122,
 1467701118,
 1467290996,
 -1,
 -43140,
 1467671534,
 12104,
 -43139,
 1467711205,
 12228,
 -1,
 1467757534,
 12223,
 1467963265,
 1467638143,
 -1,
 -43136,
 1467907067,
 12151,
 -1,
 1467953504,
 12135,
 1468159876,
 1467886814,
 -1,
 -43133,
 1468117653,
 12098,
 -1,
 1468161667,
 12064,
 -43131,
 1468128858,
 12130,
 -43130,
 1468322259,
 12103,
 -43129,
 1468377119,
 12101,
 -43128,
 1468439430,
 12211,
 -43127,
 1468501687,
 12089,
 -43126,
 1468563737,
 12073,
 -1,
 1468625494,
 12138,
 1468815267,
 1465267744,
 -1,
 1468880790,
 1468764559,
 -1,
 1468946321,
 1468842708,
 12034,
 1469054975,
 1468908750,
 -1,
 -43120,
 1468974440,
 12136,
 -1,
 1469002101,
 12084,
 -43118,
 1468916082,
 12044,
 -43117,
 1469173655,
 12120,
 -43116,
 1469224950,
 12094,
 -43115,
 1469272803,
 12125,
 -1,
 1469318674,
 12111,
 1469536156,
 1468817791,
 -1,
 1469601690,
 1469495071,
 -1,
 -43111,
 1469565099,
 12196,
 -1,
 1469601931,
 12139,
 -43109,
 1469569958,
 12056,
 -1,
 1469752726,
 12099,
 1469929376,
 1469491540,
 -1,
 -43106,
 1469899758,
 12082,
 -43105,
 1469960565,
 12238,
 -1,
 1469978859,
 12243,
 1470234623,
 1469857927,
 -1,
 -43102,
 1470122335,
 12229,
 -1,
 1470178490,
 12109,
 1470388154,
 1468737142,
 -1,
 1470453674,
 1470337423,
 -1,
 -43098,
 1470422280,
 12088,
 -43097,
 1470466819,
 12219,
 -43096,
 1470529256,
 12134,
 -43095,
 1470578804,
 12189,
 -1,
 1470637164,
 12168,
 1470846894,
 1470409044,
 -1,
 -43092,
 1470813855,
 12160,
 -43091,
 1470852456,
 12090,
 -1,
 1470897499,
 12096,
 1471109042,
 1470788440,
 -1,
 -43088,
 1471074318,
 12205,
 -43087,
 1471125146,
 12174,
 -1,
 1471158123,
 12234,
 1471371190,
 1471046015,
 -1,
 -43084,
 1471335509,
 12191,
 -43083,
 1471392590,
 12227,
 -1,
 1471435491,
 12068,
 1471633337,
 1471288692,
 -1,
 -43080,
 1471578884,
 12149,
 -1,
 1471625328,
 12184,
 -1,
 1471562032,
 12182,
 1471895503,
 1470350036,
 -1,
 1471961023,
 1471850836,
 -1,
 -43075,
 1471900641,
 12237,
 -43074,
 1471955751,
 12106,
 -1,
 1472010091,
 12145,
 1472223171,
 1471878516,
 -1,
 -43071,
 1472171393,
 12209,
 -43070,
 1472232450,
 12220,
 -1,
 1472277123,
 12047,
 1472485317,
 1472192911,
 12038,
 -1,
 1472398394,
 12086,
 1472616392,
 1472451967,
 -1,
 -43065,
 1472579866,
 12244,
 -1,
 1472603954,
 12081,
 1472813003,
 1472565647,
 -1,
 -43062,
 1472764600,
 12242,
 -1,
 1472826478,
 12166,
 1473009614,
 1472749951,
 -1,
 -43059,
 1472951890,
 12129,
 -1,
 1473008760,
 12172,
 -1,
 1472939761,
 12055,
 1473271778,
 1471827542,
 -1,
 1473337301,
 1473208703,
 -1,
 -43054,
 1473296915,
 12226,
 -43053,
 1473358724,
 12117,
 -43052,
 1473402078,
 12222,
 -1,
 1473463775,
 12133,
 1473664985,
 1473254772,
 -1,
 -43049,
 1473627796,
 12119,
 -43048,
 1473678263,
 12123,
 -1,
 1473719944,
 12207,
 1473927132,
 1473620308,
 -1,
 -43045,
 1473876773,
 12236,
 -1,
 1473911024,
 12217,
 1474123743,
 1473868632,
 -1,
 -43042,
 1474094062,
 12214,
 -1,
 1474156324,
 12245,
 -43040,
 1474090367,
 12113,
 -43039,
 1474270928,
 12188,
 -1,
 1474314669,
 12155,
 1474516981,
 1473195230,
 -1,
 1474582505,
 1474466191,
 -1,
 -43035,
 1474551048,
 12124,
 -43034,
 1474615705,
 12045,
 -43033,
 1474671964,
 12075,
 -43032,
 1474725739,
 12112,
 -1,
 1474788760,
 12170,
 1474975727,
 1474523992,
 -1,
 1475041261,
 1474893172,
 -1,
 -43028,
 1475009800,
 12118,
 -1,
 1475053791,
 12114,
 -43026,
 1474992834,
 12176,
 -1,
 1475175504,
 12058,
 1475368947,
 1474893172,
 -1,
 -43023,
 1475336436,
 12147,
 -43022,
 1475399903,
 12224,
 -1,
 1475458585,
 12190,
 -43020,
 1475309154,
 12194,
 -1,
 1475566964,
 12070,
 1475762185,
 1474485512,
 -1,
 1475827706,
 1475679604,
 -1,
 1475893241,
 1475771387,
 12193,
 -1,
 1475806088,
 12175,
 -1,
 1475855730,
 12116,
 1476089853,
 1475782996,
 -1,
 -43012,
 1476040211,
 12206,
 -1,
 1476075434,
 12051,
 1476286464,
 1476039055,
 -1,
 -43009,
 1476244285,
 12079,
 -1,
 1476297206,
 12069,
 1476483075,
 1476224816,
 -1,
 -43006,
 1476411527,
 12195,
 -1,
 1476474400,
 12213,
 1476679686,
 1476417675,
 -1,
 -43003,
 1476619688,
 12137,
 -1,
 1476673922,
 12230,
 1476919295,
 1476608135,
 -1,
 -43000,
 1476837387,
 12177,
 -1,
 1476861973,
 12110,
 1477072923,
 1475706853,
 -1,
 1477138452,
 1477022095,
 -1,
 1477203984,
 1477103178,
 -1,
 1477269519,
 1477150943,
 -1,
 -42994,
 1477231496,
 12077,
 -1,
 1477260832,
 12201,
 -1,
 1477232143,
 12061,
 1477531667,
 1477159252,
 -1,
 -42990,
 1477493796,
 12165,
 -1,
 1477545188,
 12192,
 -1,
 1477481773,
 12105,
 1477793815,
 1477075327,
 -1,
 -42986,
 1477741819,
 12162,
 -1,
 1477803129,
 12233,
 1477990426,
 1477722247,
 -1,
 -42983,
 1477934354,
 12128,
 -1,
 1477977196,
 12161,
 -1,
 1477909822,
 12040,
 1478252587,
 1477014360,
 -1,
 1478318114,
 1478180999,
 -1,
 1478383648,
 1478235508,
 -1,
 -42977,
 1478346388,
 12208,
 -1,
 1478381142,
 12212,
 -42975,
 1478318099,
 12041,
 -1,
 1478509981,
 12210,
 1478711334,
 1478254975,
 -1,
 -42972,
 1478658819,
 12033,
 -42971,
 1478709030,
 12131,
 -1,
 1478768160,
 12039,
 1478973480,
 1478661651,
 12199,
 -1,
 1478888072,
 12085,
 1479147519,
 1478890868,
 -1,
 -42966,
 1479050011,
 12074,
 -1,
 1479094565,
 12107,
 1479301181,
 1478187147,
 -1,
 1479366706,
 1479218548,
 -1,
 1479432240,
 1479308120,
 -1,
 -42961,
 1479364252,
 12121,
 -1,
 1479420054,
 12093,
 -42959,
 1479379549,
 12095,
 -1,
 1479568368,
 12221,
 1479759927,
 1479315855,
 -1,
 1479825462,
 1479715156,
 -1,
 -42955,
 1479784600,
 12218,
 -1,
 1479837919,
 12179,
 -1,
 1479775202,
 12037,
 1480087612,
 1479688327,
 -1,
 1480153147,
 1480004980,
 -1,
 -42950,
 1480111641,
 12092,
 -1,
 1480144416,
 12216,
 -1,
 1480099688,
 12231,
 -1,
 1480025120,
 12054,
 1480480842,
 1479229575,
 -1,
 1480546370,
 1480398196,
 -1,
 1480611905,
 1480501588,
 12159,
 -1,
 1480574479,
 12063,
 -1,
 1480573652,
 12215,
 1480808516,
 1480513923,
 12241,
 -1,
 1480747175,
 12067,
 1480939591,
 1480755423,
 -1,
 -42938,
 1480902002,
 12042,
 -1,
 1480929739,
 12062,
 -42936,
 1480910011,
 12140,
 -42935,
 1481081617,
 12235,
 -1,
 1481139427,
 12043,
 1481332822,
 1480436052,
 -1,
 1481398351,
 1481269631,
 -1,
 -42931,
 1481365913,
 12078,
 -42930,
 1481397502,
 12053,
 -1,
 1481453192,
 12150,
 1481660499,
 1481315700,
 -1,
 -42927,
 1481622228,
 12239,
 -42926,
 1481678825,
 12097,
 -1,
 1481729840,
 12204,
 -42924,
 1481626067,
 12187,
 -42923,
 1481873054,
 12071,
 -1,
 1481917039,
 12186,
 1482119263,
 1481265891,
 -1,
 1482184794,
 1482068367,
 12065,
 -42919,
 1482126902,
 12198,
 -1,
 1482164822,
 12066,
 1482381405,
 1482140079,
 -1,
 -42916,
 1482342303,
 12171,
 -1,
 1482385200,
 12146,
 -42914,
 1482317803,
 12225,
 -1,
 1482499229,
 12200,
 1482709094,
 1482072041,
 -1,
 1482774627,
 1482664276,
 -1,
 -42910,
 1482724121,
 12126,
 -1,
 1482780273,
 12059,
 -42908,
 1482727233,
 12050,
 -42907,
 1482915359,
 12158,
 -1,
 1482974346,
 12183,
 1483167853,
 1482658191,
 -1,
 1483233386,
 1483120617,
 -1,
 -42903,
 1483187537,
 12167,
 -1,
 1483228916,
 12048,
 1483429996,
 1483180803,
 12032,
 -1,
 1483389187,
 12080,
 -1,
 1483372086,
 12156,
 1483626612,
 1483085172,
 -1,
 1483692145,
 1483584869,
 -1,
 -42896,
 1483644653,
 12142,
 -1,
 1483697783,
 12164,
 -42894,
 1483662183,
 12100,
 -42893,
 1483835997,
 12157,
 -1,
 1483887428,
 12060,
 1484085369,
 1483573471,
 -1,
 1484150904,
 1484034447,
 -1,
 -42889,
 1484112596,
 12102,
 -1,
 1484175512,
 12240,
 -1,
 1484081981,
 12153,
 1484413054,
 1484022143,
 -1,
 1484478589,
 1484359903,
 -1,
 -42884,
 1484437708,
 12173,
 -1,
 1484468002,
 12072,
 -1,
 1484402312,
 12046,
 1484740737,
 1484380078,
 -1,
 -42880,
 1484678725,
 12197,
 -1,
 1484725221,
 12181,
 1484937348,
 1484681003,
 -1,
 -42877,
 1484892500,
 12152,
 -1,
 1484928842,
 12127,
 -42875,
 1484907792,
 12232,
 -42874,
 1485100659,
 12132,
 -1,
 1485140605,
 12049,
 1485373439,
 1465223521,
 -1,
 1485396175,
 1485272658,
 -1,
 1485461710,
 1485360218,
 -1,
 1485527185,
 1485428654,
 -1,
 1485592720,
 1485476437,
 -1,
 1485658254,
 1485547860,
 3211,
 -1,
 1485613396,
 3296,
 1485832191,
 1485599576,
 3212,
 -1,
 1485730648,
 3297,
 -1,
 1485510004,
 3253,
 1485985943,
 1485488852,
 -1,
 1486051477,
 1485947604,
 -1,
 -42860,
 1485985961,
 3232,
 -1,
 1486034292,
 3231,
 -42858,
 1485985961,
 3237,
 -1,
 1486165364,
 3236,
 1486379164,
 1485932767,
 -1,
 -42855,
 1486349354,
 3230,
 -42854,
 1486391611,
 3235,
 -42853,
 1486443268,
 3225,
 -1,
 1486493044,
 3240,
 1486706850,
 1486304800,
 -1,
 1486772384,
 1486632480,
 -1,
 -42849,
 1486706857,
 3234,
 -1,
 1486755188,
 3233,
 -42847,
 1486706857,
 3239,
 -1,
 1486886260,
 3238,
 1487100070,
 1486624116,
 3205,
 -42844,
 1487064650,
 3220,
 -42843,
 1487102335,
 3216,
 -1,
 1487148404,
 3206,
 1487362218,
 1487058719,
 -1,
 -42840,
 1487320985,
 3255,
 -42839,
 1487362217,
 3254,
 -1,
 1487410548,
 3256,
 1487624364,
 1487326794,
 3209,
 -1,
 1487588938,
 3210,
 1487755439,
 1487579476,
 -1,
 -42834,
 1487710639,
 3249,
 -1,
 1487738228,
 3248,
 1487952050,
 1487708137,
 -1,
 -42831,
 1487886505,
 3243,
 -1,
 1487934836,
 3242,
 1488148660,
 1487901071,
 3218,
 -1,
 1488097679,
 3219,
 1488279735,
 1488089944,
 -1,
 -42826,
 1488221101,
 3251,
 -1,
 1488262516,
 3250,
 1488476346,
 1488220296,
 -1,
 -42823,
 1488410793,
 3222,
 -1,
 1488459124,
 3221,
 1488672957,
 1488416553,
 -1,
 -42820,
 1488607401,
 3229,
 -1,
 1488655732,
 3228,
 1488869567,
 1488609663,
 3207,
 -1,
 1488806271,
 3208,
 1489000642,
 1488802531,
 -1,
 -42815,
 1488935081,
 3224,
 -1,
 1488983412,
 3223,
 1489197252,
 1488928903,
 3214,
 -1,
 1489125511,
 3215,
 1489328327,
 1489120478,
 -1,
 -42810,
 1489262761,
 3227,
 -1,
 1489311092,
 3226,
 1489524938,
 1489249910,
 -1,
 -42807,
 1489459369,
 3245,
 -1,
 1489507700,
 3244,
 -42805,
 1489495082,
 3247,
 -42804,
 1489666098,
 3246,
 -42803,
 1489721513,
 3257,
 -1,
 1489784511,
 3294,
 -1,
 1485409360,
 3285,
 1490049249,
 1485364406,
 -1,
 1490114773,
 1490017295,
 -1,
 1490180307,
 1490069844,
 3267,
 -1,
 1490135380,
 3268,
 1490354175,
 1490121560,
 3298,
 -1,
 1490252632,
 3299,
 1490442457,
 1490031988,
 -1,
 -42793,
 1490406986,
 3276,
 -42792,
 1490444671,
 3272,
 -1,
 1490490740,
 3262,
 1490704603,
 1490406986,
 3265,
 -1,
 1490669130,
 3266,
 1490835677,
 1490653583,
 3274,
 -1,
 1490784655,
 3275,
 1490966751,
 1490772351,
 3263,
 -1,
 1490903423,
 3264,
 1491140607,
 1490894983,
 3270,
 -1,
 1491026055,
 3271,
 1491228911,
 1489975704,
 -1,
 1491294437,
 1491190484,
 -1,
 -42780,
 1491263887,
 3304,
 -1,
 1491296342,
 3305,
 1491491048,
 1491253023,
 -1,
 -42777,
 1491431150,
 3308,
 -1,
 1491487874,
 3309,
 1491687659,
 1491422806,
 -1,
 -42774,
 1491639280,
 3306,
 -1,
 1491693175,
 3307,
 -42772,
 1491658645,
 3302,
 -42771,
 1491834303,
 3303,
 -42770,
 1491897532,
 3311,
 -1,
 1491944759,
 3310,
 1492146425,
 1491188784,
 -1,
 1492211955,
 1492114277,
 -1,
 -42766,
 1492170789,
 3203,
 -1,
 1492232845,
 3277,
 1492408566,
 1492129140,
 -1,
 -42763,
 1492375493,
 3261,
 -1,
 1492422853,
 3202,
 -42761,
 1492374533,
 3314,
 -42760,
 1492553781,
 3260,
 -1,
 1492611078,
 3313,
 -1,
 1492064549,
 3286,
 1492867461,
 1465172890,
 -1,
 1492932992,
 1492779008,
 -1,
 1492998524,
 1492875738,
 -1,
 1493063974,
 1492956959,
 -1,
 1493129505,
 1493008670,
 -1,
 1493195013,
 1493084500,
 -1,
 -42751,
 1493159498,
 12797,
 -42750,
 1493209487,
 12799,
 -42749,
 1493262719,
 12796,
 -42748,
 1493319815,
 12798,
 -1,
 1493374324,
 12795,
 1493588235,
 1493129355,
 -1,
 -42745,
 1493552714,
 12791,
 -42744,
 1493602703,
 12793,
 -42743,
 1493655935,
 12790,
 -42742,
 1493713031,
 12792,
 -1,
 1493767540,
 12789,
 1493981455,
 1493558254,
 -1,
 -42739,
 1493945930,
 12517,
 -42738,
 1493995919,
 12519,
 -1,
 1494029684,
 12515,
 1494243603,
 1493921928,
 -1,
 -42735,
 1494208074,
 12784,
 -42734,
 1494237319,
 12534,
 -1,
 1494291828,
 12533,
 1494505750,
 1494205140,
 -1,
 -42731,
 1494470218,
 12483,
 -1,
 1494520207,
 12787,
 1494702361,
 1494464287,
 -1,
 -42728,
 1494666826,
 12786,
 -1,
 1494704511,
 12785,
 -42726,
 1494670640,
 12526,
 -42725,
 1494863434,
 12453,
 -42724,
 1494913423,
 12457,
 -42723,
 1494978583,
 12788,
 -42722,
 1495041969,
 12794,
 -42721,
 1495097727,
 12451,
 -42720,
 1495154823,
 12455,
 -1,
 1495209332,
 12449,
 -42718,
 1493093962,
 12473,
 -42717,
 1495372175,
 12477,
 -42716,
 1495425407,
 12471,
 -42715,
 1495482503,
 12475,
 -1,
 1495537012,
 12469,
 1495750956,
 1493010655,
 12531,
 -42712,
 1495715402,
 12492,
 -42711,
 1495765391,
 12494,
 -42710,
 1495818623,
 12491,
 -42709,
 1495875719,
 12493,
 -1,
 1495930228,
 12490,
 1496144178,
 1495721758,
 -1,
 -42706,
 1496108618,
 12474,
 -42705,
 1496158607,
 12478,
 -42704,
 1496211839,
 12472,
 -42703,
 1496268935,
 12476,
 -1,
 1496323444,
 12470,
 1496537400,
 1496111022,
 -1,
 -42700,
 1496501834,
 12532,
 -42699,
 1496551823,
 12538,
 -42698,
 1496605055,
 12536,
 -42697,
 1496662151,
 12537,
 -1,
 1496716660,
 12535,
 1496930622,
 1496498900,
 -1,
 -42694,
 1496895050,
 12484,
 -42693,
 1496945039,
 12488,
 -42692,
 1496998271,
 12481,
 -42691,
 1497055367,
 12486,
 -1,
 1497109876,
 12479,
 1497323844,
 1496885588,
 -1,
 -42688,
 1497288266,
 12523,
 -42687,
 1497338255,
 12525,
 -42686,
 1497391487,
 12522,
 -42685,
 1497448583,
 12524,
 -1,
 1497503092,
 12521,
 1497717066,
 1497276393,
 -1,
 -42682,
 1497681482,
 12503,
 -42681,
 1497731471,
 12509,
 -42680,
 1497784703,
 12500,
 -42679,
 1497841799,
 12506,
 -1,
 1497896308,
 12497,
 1498110288,
 1497661413,
 -1,
 -42676,
 1498074698,
 12512,
 -42675,
 1498124687,
 12514,
 -42674,
 1498177919,
 12511,
 -42673,
 1498235015,
 12513,
 -1,
 1498289524,
 12510,
 1498503510,
 1498050696,
 -1,
 -42670,
 1498467914,
 12463,
 -42669,
 1498517903,
 12467,
 -42668,
 1498571135,
 12461,
 -42667,
 1498628231,
 12465,
 -1,
 1498682740,
 12459,
 1498896732,
 1498437771,
 -1,
 -42664,
 1498861130,
 12501,
 -42663,
 1498911119,
 12507,
 -42662,
 1498964351,
 12498,
 -42661,
 1499021447,
 12504,
 -1,
 1499075956,
 12495,
 1499289954,
 1498829539,
 -1,
 -42658,
 1499254346,
 12464,
 -42657,
 1499304335,
 12468,
 -42656,
 1499357567,
 12462,
 -42655,
 1499414663,
 12466,
 -1,
 1499469172,
 12460,
 1499683176,
 1499215392,
 -1,
 -42652,
 1499647562,
 12485,
 -42651,
 1499697551,
 12489,
 -42650,
 1499750783,
 12482,
 -42649,
 1499807879,
 12487,
 -1,
 1499862388,
 12480,
 1500076398,
 1499604598,
 -1,
 -42646,
 1500040778,
 12502,
 -42645,
 1500090767,
 12508,
 -42644,
 1500143999,
 12499,
 -42643,
 1500201095,
 12505,
 -1,
 1500255604,
 12496,
 1500469619,
 1500044552,
 -1,
 -42640,
 1500418447,
 12530,
 -42639,
 1500471679,
 12528,
 -42638,
 1500528775,
 12529,
 -1,
 1500583284,
 12527,
 1500797303,
 1500439534,
 -1,
 -42635,
 1500761674,
 12518,
 -42634,
 1500811663,
 12520,
 -1,
 1500845428,
 12516,
 -42632,
 1500761674,
 12454,
 -42631,
 1501008271,
 12458,
 -42630,
 1501061503,
 12452,
 -42629,
 1501118599,
 12456,
 -1,
 1501173108,
 12450,
 -42627,
 1492966440,
 12542,
 -42626,
 1501332704,
 12539,
 -42625,
 1501392325,
 12541,
 -1,
 1501444552,
 12543,
 1501691903,
 1492848636,
 -1,
 -42622,
 1501617239,
 12443,
 -42621,
 1501673736,
 12444,
 -42620,
 1501734569,
 12540,
 -1,
 1501773074,
 12448,
 1501977053,
 1492807152,
 -1,
 1502042561,
 1501919706,
 -1,
 1502108046,
 1501967904,
 -1,
 1502173580,
 1502033440,
 -1,
 -42614,
 1502107817,
 69787,
 -42613,
 1502165109,
 69786,
 -1,
 1502221684,
 69785,
 -42611,
 1502107817,
 69793,
 -1,
 1502352756,
 69792,
 1502566804,
 1502069460,
 -1,
 1502632338,
 1502528212,
 -1,
 -42607,
 1502566569,
 69784,
 -1,
 1502614900,
 69783,
 -42605,
 1502566569,
 69791,
 -1,
 1502745972,
 69790,
 1502960025,
 1502513375,
 -1,
 -42602,
 1502929962,
 69782,
 -42601,
 1502972219,
 69789,
 -42600,
 1503023876,
 69777,
 -1,
 1503073652,
 69794,
 1503287709,
 1502877044,
 69763,
 -42597,
 1503252042,
 69772,
 -42596,
 1503289727,
 69770,
 -1,
 1503335796,
 69764,
 1503549857,
 1503246111,
 -1,
 -42593,
 1503508377,
 69805,
 -42592,
 1503549609,
 69804,
 -1,
 1503597940,
 69806,
 1503812003,
 1503514186,
 69767,
 -1,
 1503776330,
 69768,
 1503943078,
 1503766868,
 -1,
 -42587,
 1503877289,
 69788,
 -1,
 1503925620,
 69801,
 1504139689,
 1503895529,
 -1,
 -42584,
 1504073897,
 69796,
 -1,
 1504122228,
 69795,
 1504336300,
 1504080008,
 -1,
 -42581,
 1504270505,
 69774,
 -1,
 1504318836,
 69773,
 1504532911,
 1504276265,
 -1,
 -42578,
 1504467113,
 69781,
 -1,
 1504515444,
 69780,
 1504729521,
 1504469375,
 69765,
 -1,
 1504665983,
 69766,
 1504860596,
 1504662243,
 -1,
 -42573,
 1504794793,
 69776,
 -1,
 1504843124,
 69775,
 1505057207,
 1504783582,
 -1,
 -42570,
 1504991401,
 69779,
 -1,
 1505039732,
 69778,
 1505253818,
 1504978550,
 -1,
 -42567,
 1505188009,
 69798,
 -1,
 1505236340,
 69797,
 -42565,
 1505223722,
 69800,
 -42564,
 1505417148,
 69803,
 -42563,
 1505464719,
 69771,
 -42562,
 1505525810,
 69799,
 -42561,
 1505588141,
 69802,
 -42560,
 1505646761,
 69807,
 -1,
 1505706119,
 69769,
 1505909196,
 1502010550,
 -1,
 1505974726,
 1505826164,
 -1,
 -42556,
 1505939018,
 69816,
 -42555,
 1505976703,
 69814,
 -1,
 1506022772,
 69808,
 1506236872,
 1505939018,
 69811,
 -1,
 1506201162,
 69812,
 1506367946,
 1506173311,
 69809,
 -1,
 1506304383,
 69810,
 -42549,
 1506316687,
 69815,
 -1,
 1506427015,
 69813,
 1506630101,
 1505867551,
 -1,
 1506695636,
 1506567561,
 -1,
 1506761169,
 1506663269,
 -1,
 -42544,
 1506719781,
 69762,
 -1,
 1506781837,
 69817,
 -42542,
 1506709557,
 69818,
 -42541,
 1506880948,
 69760,
 -1,
 1506942871,
 69761,
 -1,
 1506624099,
 69822,
 1507219930,
 1506555424,
 -1,
 1507285465,
 1507171124,
 -1,
 -42536,
 1507244249,
 69823,
 -1,
 1507276522,
 69825,
 -1,
 1507204672,
 69824,
 -42533,
 1507168327,
 69821,
 -42532,
 1507477592,
 69820,
 -1,
 1507530305,
 69819,
 1507786751,
 1501946933,
 -1,
 1507809794,
 1507686874,
 -1,
 1507875299,
 1507756255,
 -1,
 -42527,
 1507845162,
 43281,
 -42526,
 1507873540,
 43277,
 -1,
 1507923316,
 43284,
 1508137446,
 1507836628,
 -1,
 -42523,
 1508071593,
 43294,
 -1,
 1508119924,
 43282,
 1508334057,
 1508095775,
 -1,
 -42520,
 1508268201,
 43279,
 -1,
 1508316532,
 43278,
 1508530668,
 1508286441,
 -1,
 -42517,
 1508464809,
 43286,
 -1,
 1508513140,
 43285,
 1508727279,
 1508479375,
 -1,
 -42514,
 1508675983,
 43301,
 -1,
 1508720775,
 43299,
 1508923890,
 1508667528,
 -1,
 -42511,
 1508858025,
 43275,
 -1,
 1508906356,
 43274,
 1509120501,
 1508857995,
 -1,
 -42508,
 1509081877,
 43283,
 -1,
 1509102964,
 43295,
 -42506,
 1509091120,
 43280,
 -42505,
 1509286954,
 43291,
 -42504,
 1509350704,
 43293,
 -42503,
 1509414844,
 43296,
 -42502,
 1509468591,
 43290,
 -42501,
 1509523506,
 43287,
 -42500,
 1509585837,
 43292,
 -42499,
 1509646719,
 43300,
 -42498,
 1509708548,
 43276,
 -42497,
 1509766795,
 43288,
 -42496,
 1509829947,
 43297,
 -42495,
 1509893800,
 43289,
 -1,
 1509954932,
 43298,
 1510169104,
 1507735960,
 -1,
 1510234630,
 1510130388,
 -1,
 -42491,
 1510203791,
 43266,
 -1,
 1510236246,
 43267,
 1510431241,
 1510192927,
 -1,
 -42488,
 1510371054,
 43270,
 -1,
 1510427778,
 43271,
 1510627852,
 1510362710,
 -1,
 -42485,
 1510579184,
 43268,
 -1,
 1510633079,
 43269,
 -42483,
 1510598549,
 43264,
 -42482,
 1510774207,
 43265,
 -42481,
 1510837436,
 43273,
 -1,
 1510884663,
 43272,
 1511086614,
 1510136975,
 -1,
 1511152147,
 1511050826,
 43304,
 -1,
 1511080071,
 43302,
 1511283221,
 1511080071,
 43303,
 -1,
 1511211143,
 43305,
 -1,
 1511231887,
 43306,
 1511479834,
 1511049654,
 -1,
 1511545369,
 1511402859,
 43308,
 -1,
 1511458929,
 43309,
 -1,
 1511498816,
 43307,
 1511784447,
 1511439408,
 -1,
 -42468,
 1511701463,
 43311,
 -1,
 1511732755,
 43310,
 1511938896,
 1465079947,
 -1,
 1512004339,
 1511883822,
 -1,
 1512069767,
 1511962399,
 -1,
 1512135272,
 1512039926,
 -1,
 1512200760,
 1512087529,
 -1,
 1512266292,
 1512155771,
 -1,
 1512331825,
 1512181459,
 -1,
 1512397355,
 1512253046,
 -1,
 1512462888,
 1512362747,
 -1,
 -42457,
 1512420339,
 6649,
 -1,
 1512469143,
 6633,
 1512701951,
 1512391972,
 -1,
 -42454,
 1512616947,
 6648,
 -1,
 1512665751,
 6632,
 1512856110,
 1512350636,
 -1,
 -42451,
 1512813555,
 6647,
 -1,
 1512862359,
 6631,
 1513095167,
 1512802399,
 -1,
 -42448,
 1513010163,
 6646,
 -1,
 1513058967,
 6630,
 1513291775,
 1512243200,
 -1,
 -42445,
 1513206771,
 6645,
 -1,
 1513255575,
 6629,
 1513445943,
 1512203678,
 -1,
 -42442,
 1513403379,
 6642,
 -1,
 1513452183,
 6626,
 -1,
 1513366732,
 6624,
 1513708110,
 1512126209,
 -1,
 1513773643,
 1513623251,
 -1,
 1513839169,
 1513725929,
 -1,
 1513904702,
 1513794175,
 -1,
 -42435,
 1513862131,
 6655,
 -1,
 1513910935,
 6639,
 1514143743,
 1513842078,
 -1,
 -42432,
 1514058739,
 6652,
 -1,
 1514107543,
 6636,
 1514297928,
 1513760374,
 -1,
 1514363461,
 1514263291,
 -1,
 -42428,
 1514320883,
 6654,
 -1,
 1514369687,
 6638,
 1514602495,
 1514292516,
 -1,
 -42425,
 1514517491,
 6653,
 -1,
 1514566295,
 6637,
 1514799103,
 1514244191,
 -1,
 -42422,
 1514714099,
 6651,
 -1,
 1514762903,
 6635,
 1514995711,
 1513684992,
 -1,
 -42419,
 1514910707,
 6650,
 -1,
 1514959511,
 6634,
 1515149917,
 1513650381,
 -1,
 1515215448,
 1515102185,
 -1,
 1515280983,
 1515170427,
 6133,
 1515388927,
 1515196115,
 -1,
 1515412053,
 1515267702,
 -1,
 -42412,
 1515377399,
 6137,
 -1,
 1515406625,
 6136,
 -42410,
 1515365288,
 6135,
 -1,
 1515554906,
 6134,
 -1,
 1515218331,
 6130,
 1515805275,
 1515136630,
 -1,
 -42406,
 1515770615,
 6132,
 -1,
 1515799841,
 6131,
 -42404,
 1515765433,
 6128,
 -1,
 1515948122,
 6129,
 1516132964,
 1515071094,
 -1,
 1516198497,
 1516098299,
 -1,
 -42400,
 1516155891,
 6644,
 -1,
 1516204695,
 6628,
 1516437503,
 1516127524,
 -1,
 -42397,
 1516352499,
 6643,
 -1,
 1516401303,
 6627,
 1516591719,
 1516079199,
 -1,
 -42394,
 1516549107,
 6641,
 -1,
 1516597911,
 6625,
 -1,
 1516555571,
 6640,
 1516896255,
 1512072585,
 -1,
 1516919407,
 1516775030,
 -1,
 1516984942,
 1516836212,
 -1,
 -42388,
 1516947034,
 6099,
 -42387,
 1517007641,
 6101,
 -1,
 1517064175,
 6091,
 -1,
 1516916291,
 6104,
 1517312627,
 1516859528,
 -1,
 -42383,
 1517262498,
 6106,
 -42382,
 1517312537,
 6100,
 -1,
 1517361603,
 6094,
 1517574775,
 1517229428,
 -1,
 -42379,
 1517541325,
 6108,
 -42378,
 1517603942,
 6109,
 -1,
 1517641958,
 6095,
 1517836922,
 1517535956,
 -1,
 -42375,
 1517793669,
 6090,
 -1,
 1517851111,
 6093,
 1518033533,
 1517791572,
 -1,
 -42372,
 1517982198,
 6092,
 -1,
 1518027049,
 6087,
 1518230144,
 1517956318,
 -1,
 -42369,
 1518179040,
 6098,
 -1,
 1518214383,
 6102,
 -42367,
 1518200558,
 6088,
 -42366,
 1518394314,
 6097,
 -42365,
 1518450676,
 6096,
 -42364,
 1518510955,
 6105,
 -42363,
 1518570676,
 6086,
 -42362,
 1518635171,
 6089,
 -1,
 1518696664,
 6103,
 1518885560,
 1512012250,
 -1,
 1518951057,
 1518846676,
 -1,
 1519016588,
 1518913039,
 -1,
 -42357,
 1518965135,
 6029,
 -1,
 1518998900,
 6027,
 1519213199,
 1518950539,
 -1,
 -42354,
 1519161743,
 6034,
 -1,
 1519195508,
 6032,
 -42352,
 1519161743,
 6033,
 -1,
 1519326580,
 6031,
 1519540886,
 1518897375,
 -1,
 -42349,
 1519511082,
 6025,
 -42348,
 1519554959,
 6035,
 -42347,
 1519619470,
 6030,
 -1,
 1519670813,
 6020,
 1519868572,
 1519480968,
 -1,
 1519934106,
 1519802507,
 -1,
 -42343,
 1519882639,
 6019,
 -1,
 1519916404,
 6017,
 -42341,
 1519882639,
 6018,
 -1,
 1520047476,
 6016,
 1520261794,
 1519791326,
 -1,
 1520327328,
 1520195723,
 -1,
 -42337,
 1520275855,
 6024,
 -1,
 1520309620,
 6022,
 -42335,
 1520275855,
 6023,
 -1,
 1520440692,
 6021,
 1520655014,
 1520219935,
 -1,
 -42332,
 1520615029,
 6046,
 -42331,
 1520654505,
 6045,
 -1,
 1520702836,
 6047,
 1520917163,
 1520607209,
 -1,
 1520982698,
 1520851083,
 -1,
 -42327,
 1520931215,
 6039,
 -1,
 1520964980,
 6037,
 -1,
 1520931215,
 6038,
 1521244846,
 1520857944,
 -1,
 -42323,
 1521193359,
 6043,
 -1,
 1521227124,
 6049,
 1521441457,
 1521169952,
 -1,
 -42320,
 1521389967,
 6028,
 -1,
 1521423732,
 6026,
 -42318,
 1521411626,
 6041,
 -42317,
 1521605644,
 6044,
 -42316,
 1521660884,
 6042,
 -42315,
 1521723210,
 6050,
 -42314,
 1521780276,
 6040,
 -42313,
 1521834153,
 6048,
 -1,
 1521886888,
 6036,
 1522096847,
 1518853263,
 -1,
 1522162380,
 1522056240,
 -1,
 1522227903,
 1522079092,
 -1,
 -42308,
 1522191946,
 6085,
 -42307,
 1522229631,
 6083,
 -42306,
 1522286727,
 6082,
 -1,
 1522341236,
 6070,
 1522555586,
 1522197486,
 6073,
 -42303,
 1522525166,
 6074,
 -1,
 1522537844,
 6079,
 1522752197,
 1522519626,
 6075,
 -42300,
 1522716234,
 6076,
 -1,
 1522734452,
 6077,
 1522948808,
 1522688383,
 6071,
 -42297,
 1522884991,
 6072,
 -1,
 1522942087,
 6080,
 1523145419,
 1522897295,
 -1,
 -42294,
 1523093903,
 6084,
 -1,
 1523138695,
 6078,
 -1,
 1523073159,
 6081,
 1523449855,
 1522100505,
 -1,
 -42290,
 1523361604,
 6068,
 -1,
 1523389812,
 6069,
 1523604196,
 1522034679,
 -1,
 1523669728,
 1523558212,
 -1,
 1523735253,
 1523633738,
 6055,
 1523800788,
 1523699274,
 6057,
 -1,
 1523767214,
 6058,
 -1,
 1523740808,
 6056,
 1523997402,
 1523651956,
 -1,
 -42281,
 1523961418,
 6067,
 -42280,
 1524016964,
 6051,
 -42279,
 1524064639,
 6064,
 -1,
 1524110708,
 6052,
 1524325085,
 1523947153,
 -1,
 -42276,
 1524288866,
 6066,
 -1,
 1524340159,
 6065,
 1524521695,
 1524261247,
 6053,
 -1,
 1524457855,
 6054,
 -1,
 1524449415,
 6063,
 1524718306,
 1523627765,
 6059,
 -1,
 1524687854,
 6060,
 1524891647,
 1524662200,
 6061,
 -1,
 1524818926,
 6062,
 1524980466,
 1523530136,
 -1,
 1525045992,
 1524941524,
 -1,
 -42265,
 1525014927,
 6114,
 -1,
 1525047382,
 6115,
 1525242603,
 1525004063,
 -1,
 -42262,
 1525182190,
 6118,
 -1,
 1525238914,
 6119,
 1525439214,
 1525173846,
 -1,
 -42259,
 1525390320,
 6116,
 -1,
 1525444215,
 6117,
 -42257,
 1525409685,
 6112,
 -42256,
 1525585343,
 6113,
 -42255,
 1525648572,
 6121,
 -1,
 1525695799,
 6120,
 -1,
 1524905412,
 6107,
 1526005759,
 1511924257,
 -1,
 1526029091,
 1525905882,
 -1,
 1526094588,
 1525990100,
 -1,
 1526160122,
 1526055636,
 -1,
 -42248,
 1526122022,
 68147,
 -42247,
 1526159529,
 68123,
 -1,
 1526207860,
 68122,
 -42245,
 1526093993,
 68128,
 -1,
 1526338932,
 68127,
 1526553346,
 1526019616,
 -1,
 1526618880,
 1526478368,
 -1,
 -42241,
 1526552745,
 68125,
 -1,
 1526601076,
 68124,
 -42239,
 1526552745,
 68130,
 -1,
 1526732148,
 68129,
 1526946566,
 1526511391,
 -1,
 -42236,
 1526904729,
 68142,
 -42235,
 1526945961,
 68141,
 -1,
 1526994292,
 68143,
 1527208714,
 1526892767,
 -1,
 -42232,
 1527178282,
 68121,
 -42231,
 1527220539,
 68126,
 -1,
 1527256436,
 68131,
 1527470862,
 1527148680,
 -1,
 -42228,
 1527410847,
 68146,
 -42227,
 1527470249,
 68113,
 -1,
 1527518580,
 68112,
 1527733009,
 1527422953,
 -1,
 -42224,
 1527666857,
 68133,
 -1,
 1527715188,
 68132,
 1527929620,
 1527665379,
 -1,
 -42221,
 1527863465,
 68115,
 -1,
 1527911796,
 68114,
 1528126231,
 1527852254,
 -1,
 -42218,
 1528060073,
 68118,
 -1,
 1528108404,
 68117,
 1528322842,
 1528047222,
 -1,
 -42215,
 1528256681,
 68135,
 -1,
 1528305012,
 68134,
 -42213,
 1528293168,
 68144,
 -42212,
 1528489002,
 68137,
 -42211,
 1528551356,
 68140,
 -42210,
 1528605103,
 68138,
 -42209,
 1528660018,
 68136,
 -42208,
 1528722349,
 68139,
 -42207,
 1528786731,
 68119,
 -42206,
 1528846505,
 68145,
 -1,
 1528894836,
 68096,
 1529109297,
 1525982971,
 -1,
 1529174825,
 1529034272,
 -1,
 1529240360,
 1529123215,
 -1,
 -42201,
 1529204536,
 68183,
 -1,
 1529266900,
 68176,
 -1,
 1529159232,
 68182,
 1529502508,
 1529115480,
 -1,
 -42197,
 1529453356,
 68181,
 -1,
 1529505930,
 68184,
 1529699119,
 1529425118,
 -1,
 -42194,
 1529654529,
 68179,
 -1,
 1529703452,
 68178,
 -42192,
 1529658850,
 68177,
 -1,
 1529840153,
 68180,
 1530026811,
 1529075630,
 -1,
 1530092346,
 1529978672,
 -1,
 1530157881,
 1530051632,
 -1,
 -42187,
 1530125336,
 68099,
 -42186,
 1530187338,
 68098,
 -42185,
 1530237327,
 68102,
 -42184,
 1530290559,
 68097,
 -1,
 1530347655,
 68101,
 -1,
 1530099964,
 68108,
 -1,
 1530031122,
 68159,
 1530682179,
 1529986096,
 -1,
 1530747711,
 1530608324,
 -1,
 -42178,
 1530711897,
 68109,
 -1,
 1530774241,
 68154,
 -42176,
 1530715093,
 68111,
 -42175,
 1530867273,
 68153,
 -42174,
 1530931031,
 68152,
 -1,
 1530994583,
 68110,
 1531206474,
 1530630207,
 -1,
 1531272007,
 1531167444,
 -1,
 -42170,
 1531240031,
 68165,
 -1,
 1531266801,
 68164,
 1531510783,
 1531221443,
 -1,
 -42167,
 1531430685,
 68167,
 -1,
 1531470103,
 68166,
 1531707391,
 1531132312,
 -1,
 1531730766,
 1531626196,
 -1,
 -42163,
 1531699599,
 68161,
 -1,
 1531732054,
 68162,
 -42161,
 1531680191,
 68160,
 -1,
 1531859408,
 68163,
 1532058451,
 1511866503,
 -1,
 -42158,
 1532028084,
 9000,
 -1,
 1532067758,
 8490,
 -42156,
 1532008610,
 12927,
 -1,
 1532193729,
 8365,
 1532386854,
 1465046958,
 -1,
 1532452275,
 1532302708,
 -1,
 1532517554,
 1532387713,
 -1,
 1532583073,
 1532478031,
 -1,
 1532648590,
 1532525595,
 -1,
 1532713869,
 1532594399,
 -1,
 1532779368,
 1532646115,
 42507,
 1532844901,
 1532711651,
 -1,
 1532910432,
 1532772487,
 42500,
 -42145,
 1532856543,
 42501,
 -1,
 1532903559,
 42271,
 1533107042,
 1532858767,
 42460,
 -1,
 1533055375,
 42384,
 -42141,
 1533070922,
 42421,
 -42140,
 1533174143,
 42308,
 -1,
 1533220212,
 42348,
 -42138,
 1532794157,
 42428,
 -42137,
 1533363953,
 42467,
 -1,
 1533418814,
 42315,
 1533631350,
 1532704288,
 -1,
 1533696881,
 1533579663,
 42450,
 1533762416,
 1533638229,
 -1,
 -42132,
 1533722306,
 42514,
 -42131,
 1533771826,
 42538,
 -42130,
 1533833375,
 42513,
 -42129,
 1533890239,
 42512,
 -1,
 1533950660,
 42539,
 -1,
 1533710735,
 42374,
 1534221171,
 1533624455,
 42490,
 -1,
 1534148743,
 42261,
 -42124,
 1534185034,
 42411,
 -42123,
 1534288255,
 42298,
 -1,
 1534334324,
 42337,
 1534548862,
 1533600750,
 -1,
 1534614393,
 1534497167,
 42464,
 -1,
 1534562703,
 42388,
 1534745467,
 1534541959,
 42506,
 -1,
 1534673031,
 42275,
 -42116,
 1534709322,
 42425,
 -42115,
 1534812543,
 42312,
 -1,
 1534858612,
 42352,
 1535073158,
 1534488361,
 -1,
 1535138689,
 1535021455,
 42457,
 -1,
 1535086991,
 42381,
 1535269763,
 1535066247,
 42497,
 -1,
 1535197319,
 42268,
 -42108,
 1535233610,
 42418,
 -42107,
 1535336831,
 42305,
 -1,
 1535382900,
 42344,
 1535597448,
 1535021455,
 42463,
 -1,
 1535545743,
 42387,
 1535728522,
 1535524999,
 42505,
 -1,
 1535656071,
 42274,
 -42101,
 1535692362,
 42424,
 -42100,
 1535795583,
 42311,
 -1,
 1535841652,
 42351,
 1536056229,
 1532657637,
 -1,
 1536121750,
 1535988743,
 -1,
 1536187281,
 1536070031,
 42438,
 -1,
 1536135567,
 42363,
 1536318355,
 1536114823,
 42478,
 -1,
 1536245895,
 42250,
 -42092,
 1536282186,
 42400,
 -42091,
 1536385407,
 42287,
 -1,
 1536431476,
 42326,
 1536646046,
 1536042614,
 -1,
 1536711577,
 1536594319,
 42436,
 -1,
 1536659855,
 42361,
 1536842651,
 1536639111,
 42475,
 -1,
 1536770183,
 42248,
 -42084,
 1536806474,
 42398,
 -42083,
 1536909695,
 42285,
 -1,
 1536955764,
 42323,
 1537170336,
 1536594319,
 42462,
 -1,
 1537118607,
 42386,
 1537301410,
 1537097863,
 42504,
 -1,
 1537228935,
 42273,
 -42077,
 1537265226,
 42423,
 -42076,
 1537368447,
 42310,
 -1,
 1537414516,
 42350,
 1537629117,
 1535981088,
 -1,
 1537694646,
 1537562763,
 -1,
 1537760175,
 1537628299,
 -1,
 1537825706,
 1537708431,
 42446,
 -1,
 1537773967,
 42370,
 1537956780,
 1537753223,
 42486,
 -1,
 1537884295,
 42257,
 -42067,
 1537920586,
 42407,
 -42066,
 1538023807,
 42294,
 -1,
 1538069876,
 42333,
 1538284465,
 1537708431,
 42445,
 -1,
 1538232719,
 42369,
 1538415539,
 1538211975,
 42485,
 -1,
 1538343047,
 42256,
 -42060,
 1538379338,
 42406,
 -42059,
 1538482559,
 42293,
 -1,
 1538528628,
 42332,
 1538743224,
 1537642895,
 42449,
 -1,
 1538691471,
 42373,
 1538874298,
 1538670727,
 42489,
 -1,
 1538801799,
 42260,
 -42053,
 1538838090,
 42410,
 -42052,
 1538941311,
 42297,
 -1,
 1538987380,
 42336,
 1539202000,
 1537568904,
 -1,
 1539267528,
 1539153897,
 -1,
 1539333058,
 1539195015,
 42476,
 -42047,
 1539279071,
 42477,
 -1,
 1539326087,
 42249,
 1539529668,
 1539281295,
 42437,
 -1,
 1539477903,
 42362,
 1539660742,
 1539446132,
 42324,
 -1,
 1539606751,
 42325,
 -42041,
 1539624522,
 42399,
 -1,
 1539727743,
 42286,
 1539922890,
 1539215759,
 42459,
 -1,
 1539871119,
 42383,
 1540053964,
 1539850375,
 42499,
 -1,
 1539981447,
 42270,
 1540185038,
 1539970420,
 42346,
 -1,
 1540131039,
 42347,
 -42033,
 1540148810,
 42420,
 -1,
 1540252031,
 42307,
 1540447203,
 1539134179,
 -1,
 1540512731,
 1540367990,
 -1,
 1540578261,
 1540460943,
 42439,
 -42028,
 1540526479,
 42364,
 -1,
 1540589791,
 42440,
 1540774872,
 1540505735,
 42479,
 -42025,
 1540720863,
 42480,
 -1,
 1540767879,
 42251,
 -42023,
 1540738634,
 42401,
 -42022,
 1540907391,
 42288,
 -1,
 1540953460,
 42327,
 1541168094,
 1540440199,
 42502,
 -42019,
 1541114079,
 42503,
 -1,
 1541161095,
 42272,
 1541364704,
 1541116303,
 42461,
 -1,
 1541312911,
 42385,
 -42015,
 1541328458,
 42422,
 -42014,
 1541431679,
 42309,
 -1,
 1541477748,
 42349,
 1541692403,
 1540417310,
 -1,
 1541757932,
 1541625995,
 -1,
 1541823463,
 1541706127,
 42454,
 -1,
 1541771663,
 42378,
 1541954537,
 1541750919,
 42494,
 -1,
 1541881991,
 42265,
 -42006,
 1541918282,
 42415,
 -42005,
 1542021503,
 42302,
 -1,
 1542067572,
 42341,
 1542282222,
 1541706127,
 42453,
 -1,
 1542230415,
 42377,
 1542413296,
 1542209671,
 42493,
 -1,
 1542340743,
 42264,
 -41999,
 1542377034,
 42414,
 -41998,
 1542480255,
 42301,
 -1,
 1542526324,
 42340,
 1542740994,
 1541659912,
 -1,
 1542806520,
 1542689167,
 42431,
 1542872055,
 1542754703,
 42356,
 -1,
 1542818015,
 42357,
 -1,
 1542818015,
 42432,
 1543068668,
 1542733959,
 42470,
 1543134203,
 1542996103,
 42243,
 -1,
 1543080159,
 42244,
 -1,
 1543080159,
 42471,
 1543330814,
 1543032394,
 42393,
 -1,
 1543276767,
 42394,
 1543461888,
 1543266687,
 42280,
 -1,
 1543407839,
 42281,
 1543634943,
 1543378292,
 42318,
 -1,
 1543538911,
 42319,
 1543724050,
 1542701780,
 -1,
 1543789579,
 1543657611,
 -1,
 1543855110,
 1543737743,
 42444,
 -1,
 1543803279,
 42368,
 1543986184,
 1543782535,
 42484,
 -1,
 1543913607,
 42255,
 -41975,
 1543949898,
 42405,
 -41974,
 1544053119,
 42292,
 -1,
 1544099188,
 42331,
 1544313869,
 1543737743,
 42443,
 -1,
 1544262031,
 42367,
 1544444943,
 1544241287,
 42483,
 -1,
 1544372359,
 42254,
 -41968,
 1544408650,
 42404,
 -41967,
 1544511871,
 42291,
 -1,
 1544557940,
 42330,
 1544772642,
 1543681823,
 -1,
 1544838171,
 1544706187,
 -1,
 1544903702,
 1544786319,
 42452,
 -1,
 1544851855,
 42376,
 1545034776,
 1544831111,
 42492,
 -1,
 1544962183,
 42263,
 -41959,
 1544998474,
 42413,
 -41958,
 1545101695,
 42300,
 -1,
 1545147764,
 42339,
 1545362461,
 1544786319,
 42451,
 -1,
 1545310607,
 42375,
 1545493535,
 1545289863,
 42491,
 -1,
 1545420935,
 42262,
 -41952,
 1545457226,
 42412,
 -41951,
 1545560447,
 42299,
 -1,
 1545606516,
 42338,
 1545821234,
 1544693366,
 -1,
 1545886763,
 1545754763,
 -1,
 1545952294,
 1545834895,
 42434,
 -1,
 1545900431,
 42359,
 1546083368,
 1545879687,
 42473,
 -1,
 1546010759,
 42246,
 -41943,
 1546047050,
 42396,
 -41942,
 1546150271,
 42283,
 -1,
 1546196340,
 42321,
 1546411053,
 1545834895,
 42435,
 -1,
 1546359183,
 42360,
 1546542127,
 1546338439,
 42474,
 -1,
 1546469511,
 42247,
 -41936,
 1546505802,
 42397,
 -41935,
 1546609023,
 42284,
 -1,
 1546655092,
 42322,
 1546869823,
 1545754763,
 -1,
 1546935350,
 1546817935,
 42429,
 -41931,
 1546883471,
 42355,
 -1,
 1546946783,
 42430,
 1547131961,
 1546862727,
 42468,
 -41928,
 1547077855,
 42469,
 -1,
 1547124871,
 42242,
 1547328571,
 1547095626,
 42391,
 -1,
 1547274463,
 42392,
 1547459645,
 1547264383,
 42278,
 -1,
 1547405535,
 42279,
 1547632639,
 1547375988,
 42316,
 -1,
 1547536607,
 42317,
 1547721800,
 1546810200,
 -1,
 1547787331,
 1547649159,
 42487,
 -41918,
 1547734106,
 42508,
 -1,
 1547780231,
 42258,
 1547983941,
 1547735439,
 42447,
 -1,
 1547932047,
 42371,
 -41914,
 1547947594,
 42408,
 -41913,
 1548050815,
 42295,
 -1,
 1548096884,
 42334,
 1548311632,
 1547690990,
 -1,
 1548377163,
 1548259727,
 42458,
 -1,
 1548325263,
 42382,
 1548508237,
 1548304519,
 42498,
 -1,
 1548435591,
 42269,
 -41906,
 1548471882,
 42419,
 -41905,
 1548575103,
 42306,
 -1,
 1548621172,
 42345,
 1548835928,
 1548277678,
 -1,
 1548901459,
 1548784015,
 42442,
 -1,
 1548849551,
 42366,
 1549032533,
 1548828807,
 42482,
 -1,
 1548959879,
 42253,
 -41898,
 1548996170,
 42403,
 -41897,
 1549099391,
 42290,
 -1,
 1549145460,
 42329,
 1549360224,
 1548790100,
 -1,
 1549425755,
 1549308303,
 42448,
 -1,
 1549373839,
 42372,
 1549556829,
 1549353095,
 42488,
 -1,
 1549484167,
 42259,
 -41890,
 1549520458,
 42409,
 -41889,
 1549623679,
 42296,
 -1,
 1549669748,
 42335,
 1549884520,
 1549311977,
 -1,
 1549950051,
 1549832591,
 42433,
 -1,
 1549898127,
 42358,
 1550081125,
 1549877383,
 42472,
 -1,
 1550008455,
 42245,
 -41882,
 1550044746,
 42395,
 -41881,
 1550147967,
 42282,
 -1,
 1550194036,
 42320,
 1550408816,
 1549823785,
 -1,
 1550474347,
 1550356879,
 42456,
 -1,
 1550422415,
 42380,
 1550605421,
 1550401671,
 42496,
 -1,
 1550532743,
 42267,
 -41874,
 1550569034,
 42417,
 -41873,
 1550672255,
 42304,
 -1,
 1550718324,
 42343,
 1550933112,
 1550339670,
 -1,
 1550998643,
 1550881167,
 42441,
 -1,
 1550946703,
 42365,
 1551129717,
 1550925959,
 42481,
 -1,
 1551057031,
 42252,
 -41866,
 1551093322,
 42402,
 -41865,
 1551196543,
 42289,
 -1,
 1551242612,
 42328,
 1551457408,
 1550855390,
 -1,
 1551522939,
 1551405455,
 42455,
 -1,
 1551470991,
 42379,
 1551654013,
 1551450247,
 42495,
 -1,
 1551581319,
 42266,
 -41858,
 1551617610,
 42416,
 -41857,
 1551720831,
 42303,
 -1,
 1551766900,
 42342,
 1551981700,
 1551405455,
 42426,
 1552047235,
 1551929743,
 42353,
 -1,
 1551993055,
 42354,
 -1,
 1551993055,
 42427,
 1552243848,
 1551908999,
 42465,
 1552309383,
 1552171143,
 42240,
 -1,
 1552255199,
 42241,
 -1,
 1552255199,
 42466,
 1552505994,
 1552207434,
 42389,
 -1,
 1552451807,
 42390,
 1552637068,
 1552441727,
 42276,
 -1,
 1552582879,
 42277,
 1552809983,
 1552553332,
 42313,
 -1,
 1552713951,
 42314,
 1552941055,
 1532592886,
 -1,
 1552964755,
 1552859860,
 -1,
 -41839,
 1552913939,
 42525,
 -41838,
 1552967847,
 42517,
 -1,
 1553012215,
 42521,
 1553226904,
 1552889376,
 -1,
 1553292439,
 1553174927,
 -1,
 -41834,
 1553241619,
 42523,
 -1,
 1553272965,
 42526,
 -1,
 1553210976,
 42522,
 1553554587,
 1553166472,
 -1,
 -41830,
 1553519217,
 42524,
 -1,
 1553548122,
 42516,
 1553751198,
 1553485398,
 -1,
 -41827,
 1553679194,
 42515,
 -1,
 1553733111,
 42520,
 -41825,
 1553697968,
 42518,
 -41824,
 1553887289,
 42527,
 -1,
 1553934134,
 42519,
 1554144431,
 1532508568,
 -1,
 1554209957,
 1554105044,
 -1,
 -41820,
 1554178447,
 42530,
 -1,
 1554210902,
 42531,
 1554406568,
 1554167583,
 -1,
 -41817,
 1554345710,
 42534,
 -1,
 1554402434,
 42535,
 1554603179,
 1554337366,
 -1,
 -41814,
 1554553840,
 42532,
 -1,
 1554607735,
 42533,
 -41812,
 1554573205,
 42528,
 -41811,
 1554748863,
 42529,
 -41810,
 1554812092,
 42537,
 -1,
 1554859319,
 42536,
 -41808,
 1554098366,
 42511,
 -41807,
 1554993858,
 42510,
 -1,
 1555051023,
 42509,
 1555300351,
 1532472895,
 -1,
 1555324194,
 1555173903,
 65024,
 1555389631,
 1555240257,
 917762,
 -41802,
 1555305793,
 917942,
 -41801,
 1555371277,
 917941,
 -41800,
 1555436742,
 917940,
 -41799,
 1555502209,
 917939,
 -41798,
 1555567625,
 917938,
 -41797,
 1555633084,
 917937,
 -41796,
 1555698508,
 917936,
 -41795,
 1555763879,
 917935,
 -41794,
 1555829263,
 917934,
 -1,
 1555894671,
 917933,
 1556110538,
 1555305741,
 917761,
 -41791,
 1556026689,
 917932,
 -41790,
 1556092173,
 917931,
 -41789,
 1556157638,
 917930,
 -41788,
 1556223105,
 917929,
 -41787,
 1556288521,
 917928,
 -41786,
 1556353980,
 917927,
 -41785,
 1556419404,
 917926,
 -41784,
 1556484775,
 917925,
 -41783,
 1556550159,
 917924,
 -1,
 1556615567,
 917923,
 1556831445,
 1556026566,
 917760,
 -41780,
 1556747585,
 917922,
 -41779,
 1556813069,
 917921,
 -41778,
 1556878534,
 917920,
 -41777,
 1556944001,
 917919,
 -41776,
 1557009417,
 917918,
 -41775,
 1557074876,
 917917,
 -41774,
 1557140300,
 917916,
 -41773,
 1557205671,
 917915,
 -41772,
 1557271055,
 917914,
 -1,
 1557336463,
 917913,
 1557552352,
 1556747393,
 65039,
 -41769,
 1557468481,
 917912,
 -41768,
 1557533965,
 917911,
 -41767,
 1557599430,
 917910,
 -41766,
 1557664897,
 917909,
 -41765,
 1557730313,
 917908,
 -41764,
 1557795772,
 917907,
 -41763,
 1557861196,
 917906,
 -41762,
 1557926567,
 917905,
 -41761,
 1557991951,
 917904,
 -1,
 1558057359,
 917903,
 1558273259,
 1557468169,
 65038,
 -41758,
 1558189377,
 917902,
 -41757,
 1558254861,
 917901,
 -41756,
 1558320326,
 917900,
 -41755,
 1558385793,
 917899,
 -41754,
 1558451209,
 917898,
 -41753,
 1558516668,
 917897,
 -41752,
 1558582092,
 917896,
 -41751,
 1558647463,
 917895,
 -41750,
 1558712847,
 917894,
 -1,
 1558778255,
 917893,
 1558994166,
 1558188988,
 65037,
 -41747,
 1558910273,
 917892,
 -41746,
 1558975757,
 917891,
 -41745,
 1559041222,
 917890,
 -41744,
 1559106689,
 917889,
 -41743,
 1559172105,
 917888,
 -41742,
 1559237564,
 917887,
 -41741,
 1559302988,
 917886,
 -41740,
 1559368359,
 917885,
 -41739,
 1559433743,
 917884,
 -1,
 1559499151,
 917883,
 1559715073,
 1558909772,
 65036,
 -41736,
 1559631169,
 917882,
 -41735,
 1559696653,
 917881,
 -41734,
 1559762118,
 917880,
 -41733,
 1559827585,
 917879,
 -41732,
 1559893001,
 917878,
 -41731,
 1559958460,
 917877,
 -41730,
 1560023884,
 917876,
 -41729,
 1560089255,
 917875,
 -41728,
 1560154639,
 917874,
 -1,
 1560220047,
 917873,
 1560435980,
 1559630503,
 65035,
 -41725,
 1560352065,
 917872,
 -41724,
 1560417549,
 917871,
 -41723,
 1560483014,
 917870,
 -41722,
 1560548481,
 917869,
 -41721,
 1560613897,
 917868,
 -41720,
 1560679356,
 917867,
 -41719,
 1560744780,
 917866,
 -41718,
 1560810151,
 917865,
 -41717,
 1560875535,
 917864,
 -1,
 1560940943,
 917863,
 1561156887,
 1560351247,
 65034,
 -41714,
 1561072961,
 917862,
 -41713,
 1561138445,
 917861,
 -41712,
 1561203910,
 917860,
 -41711,
 1561269377,
 917859,
 -41710,
 1561334793,
 917858,
 -41709,
 1561400252,
 917857,
 -41708,
 1561465676,
 917856,
 -41707,
 1561531047,
 917855,
 -41706,
 1561596431,
 917854,
 -1,
 1561661839,
 917853,
 1561919487,
 1561072015,
 65033,
 -41703,
 1561793857,
 917852,
 -41702,
 1561859341,
 917851,
 -41701,
 1561924806,
 917850,
 -41700,
 1561990273,
 917849,
 -41699,
 1562055689,
 917848,
 -41698,
 1562121148,
 917847,
 -41697,
 1562186572,
 917846,
 -41696,
 1562251943,
 917845,
 -41695,
 1562317327,
 917844,
 -1,
 1562382735,
 917843,
 1562598758,
 1555239591,
 65025,
 1562664238,
 1562514364,
 917767,
 -41691,
 1562580289,
 917992,
 -41690,
 1562645773,
 917991,
 -41689,
 1562711238,
 917990,
 -41688,
 1562776705,
 917989,
 -41687,
 1562842121,
 917988,
 -41686,
 1562907580,
 917987,
 -41685,
 1562973004,
 917986,
 -41684,
 1563038375,
 917985,
 -41683,
 1563103759,
 917984,
 -1,
 1563169167,
 917983,
 1563385145,
 1562579788,
 917766,
 -41680,
 1563301185,
 917982,
 -41679,
 1563366669,
 917981,
 -41678,
 1563432134,
 917980,
 -41677,
 1563497601,
 917979,
 -41676,
 1563563017,
 917978,
 -41675,
 1563628476,
 917977,
 -41674,
 1563693900,
 917976,
 -41673,
 1563759271,
 917975,
 -41672,
 1563824655,
 917974,
 -1,
 1563890063,
 917973,
 1564106052,
 1563300519,
 917765,
 -41669,
 1564022081,
 917972,
 -41668,
 1564087565,
 917971,
 -41667,
 1564153030,
 917970,
 -41666,
 1564218497,
 917969,
 -41665,
 1564283913,
 917968,
 -41664,
 1564349372,
 917967,
 -41663,
 1564414796,
 917966,
 -41662,
 1564480167,
 917965,
 -41661,
 1564545551,
 917964,
 -1,
 1564610959,
 917963,
 1564826959,
 1564021263,
 917764,
 -41658,
 1564742977,
 917962,
 -41657,
 1564808461,
 917961,
 -41656,
 1564873926,
 917960,
 -41655,
 1564939393,
 917959,
 -41654,
 1565004809,
 917958,
 -41653,
 1565070268,
 917957,
 -41652,
 1565135692,
 917956,
 -41651,
 1565201063,
 917955,
 -41650,
 1565266447,
 917954,
 -1,
 1565331855,
 917953,
 1565547866,
 1564742031,
 917763,
 -41647,
 1565463873,
 917952,
 -41646,
 1565529357,
 917951,
 -41645,
 1565594822,
 917950,
 -41644,
 1565660289,
 917949,
 -41643,
 1565725705,
 917948,
 -41642,
 1565791164,
 917947,
 -41641,
 1565856588,
 917946,
 -41640,
 1565921959,
 917945,
 -41639,
 1565987343,
 917944,
 -1,
 1566052751,
 917943,
 1566268770,
 1565463561,
 917768,
 -41636,
 1566184577,
 917999,
 -41635,
 1566249993,
 917998,
 -41634,
 1566315452,
 917997,
 -41633,
 1566380876,
 917996,
 -41632,
 1566446247,
 917995,
 -41631,
 1566511631,
 917994,
 -1,
 1566577039,
 917993,
 -41629,
 1566184769,
 917772,
 -41628,
 1566709005,
 917771,
 -41627,
 1566774470,
 917770,
 -1,
 1566839937,
 917769,
 1567055217,
 1562514753,
 65032,
 -41624,
 1566971201,
 917842,
 -41623,
 1567036685,
 917841,
 -41622,
 1567102150,
 917840,
 -41621,
 1567167617,
 917839,
 -41620,
 1567233033,
 917838,
 -41619,
 1567298492,
 917837,
 -41618,
 1567363916,
 917836,
 -41617,
 1567429287,
 917835,
 -41616,
 1567494671,
 917834,
 -1,
 1567560079,
 917833,
 1567776124,
 1566971149,
 65031,
 -41613,
 1567692097,
 917832,
 -41612,
 1567757581,
 917831,
 -41611,
 1567823046,
 917830,
 -41610,
 1567888513,
 917829,
 -41609,
 1567953929,
 917828,
 -41608,
 1568019388,
 917827,
 -41607,
 1568084812,
 917826,
 -41606,
 1568150183,
 917825,
 -41605,
 1568215567,
 917824,
 -1,
 1568280975,
 917823,
 1568497031,
 1567691974,
 65030,
 -41602,
 1568412993,
 917822,
 -41601,
 1568478477,
 917821,
 -41600,
 1568543942,
 917820,
 -41599,
 1568609409,
 917819,
 -41598,
 1568674825,
 917818,
 -41597,
 1568740284,
 917817,
 -41596,
 1568805708,
 917816,
 -41595,
 1568871079,
 917815,
 -41594,
 1568936463,
 917814,
 -1,
 1569001871,
 917813,
 1569217938,
 1568412801,
 65029,
 -41591,
 1569133889,
 917812,
 -41590,
 1569199373,
 917811,
 -41589,
 1569264838,
 917810,
 -41588,
 1569330305,
 917809,
 -41587,
 1569395721,
 917808,
 -41586,
 1569461180,
 917807,
 -41585,
 1569526604,
 917806,
 -41584,
 1569591975,
 917805,
 -41583,
 1569657359,
 917804,
 -1,
 1569722767,
 917803,
 1569938845,
 1569133577,
 65028,
 -41580,
 1569854785,
 917802,
 -41579,
 1569920269,
 917801,
 -41578,
 1569985734,
 917800,
 -41577,
 1570051201,
 917799,
 -41576,
 1570116617,
 917798,
 -41575,
 1570182076,
 917797,
 -41574,
 1570247500,
 917796,
 -41573,
 1570312871,
 917795,
 -41572,
 1570378255,
 917794,
 -1,
 1570443663,
 917793,
 1570659752,
 1569854396,
 65027,
 -41569,
 1570575681,
 917792,
 -41568,
 1570641165,
 917791,
 -41567,
 1570706630,
 917790,
 -41566,
 1570772097,
 917789,
 -41565,
 1570837513,
 917788,
 -41564,
 1570902972,
 917787,
 -41563,
 1570968396,
 917786,
 -41562,
 1571033767,
 917785,
 -41561,
 1571099151,
 917784,
 -1,
 1571164559,
 917783,
 1571422207,
 1570575180,
 65026,
 -41558,
 1571296577,
 917782,
 -41557,
 1571362061,
 917781,
 -41556,
 1571427526,
 917780,
 -41555,
 1571492993,
 917779,
 -41554,
 1571558409,
 917778,
 -41553,
 1571623868,
 917777,
 -41552,
 1571689292,
 917776,
 -41551,
 1571754663,
 917775,
 -41550,
 1571820047,
 917774,
 -1,
 1571885455,
 917773,
 1572101637,
 1532379271,
 -1,
 1572167139,
 1572026718,
 -1,
 1572232654,
 1572125744,
 -1,
 1572298174,
 1572148596,
 -1,
 1572363709,
 1572245709,
 -1,
 1572429242,
 1572329463,
 7403,
 -1,
 1572343404,
 7404,
 -41541,
 1572392702,
 7409,
 -41540,
 1572480752,
 7402,
 -1,
 1572544348,
 7401,
 -1,
 1572318064,
 7410,
 1572822468,
 1572264925,
 -1,
 1572888001,
 1572786179,
 7395,
 -1,
 1572802156,
 7399,
 1573019075,
 1572806542,
 7397,
 -1,
 1572933228,
 7400,
 -1,
 1572979253,
 7394,
 1573215689,
 1572776276,
 -1,
 1573281224,
 1573145927,
 -1,
 -41529,
 1573244931,
 7396,
 -1,
 1573265294,
 7398,
 -1,
 1573242467,
 7408,
 -41526,
 1573184585,
 7380,
 -41525,
 1573505268,
 7405,
 -41524,
 1573555366,
 7379,
 -41523,
 1573616936,
 7407,
 -1,
 1573674094,
 7406,
 1573912575,
 1572194742,
 -1,
 1573936596,
 1573839933,
 -1,
 1574002130,
 1573876069,
 7383,
 -1,
 1573915133,
 7385,
 -41517,
 1573939171,
 7382,
 -1,
 1574049976,
 7381,
 1574264280,
 1573896916,
 -1,
 -41514,
 1574232502,
 7390,
 -41513,
 1574285916,
 7387,
 -1,
 1574330551,
 7391,
 1574526427,
 1574203551,
 -1,
 -41510,
 1574487594,
 7388,
 -1,
 1574548975,
 7376,
 1574723038,
 1574451908,
 -1,
 -41507,
 1574686569,
 7386,
 -1,
 1574748897,
 7389,
 -41505,
 1574681267,
 7377,
 -41504,
 1574875487,
 7392,
 -41503,
 1574938176,
 7378,
 -41502,
 1574972839,
 7384,
 -1,
 1575036118,
 7393,
 1575247363,
 1572120916,
 -1,
 1575312895,
 1575208898,
 -1,
 1575378413,
 1575254765,
 124,
 1575485439,
 1575288832,
 -1,
 1575509484,
 1575411570,
 -1,
 1575575019,
 1575432265,
 -1,
 -41494,
 1575495763,
 10992,
 -1,
 1575556725,
 10991,
 -1,
 1575519456,
 9087,
 -1,
 1575439919,
 9168,
 1575902708,
 1575317735,
 -1,
 1575968242,
 1575846490,
 12337,
 1576075263,
 1575878656,
 -1,
 -41487,
 1575998583,
 12339,
 -1,
 1576042119,
 12341,
 1576271871,
 1575936285,
 12338,
 -1,
 1576143875,
 12340,
 1576361465,
 1575823186,
 -1,
 -41482,
 1576329267,
 10186,
 -41481,
 1576389509,
 10978,
 -41480,
 1576418592,
 10980,
 -1,
 1576478973,
 10704,
 -41478,
 1576331301,
 10650,
 -41477,
 1576650748,
 11823,
 -41476,
 1576698115,
 9896,
 -41475,
 1576756193,
 12347,
 -41474,
 1576817149,
 8286,
 -1,
 1576879612,
 8942,
 1577082370,
 1575281651,
 -1,
 -41471,
 1577023823,
 8920,
 -1,
 1577080567,
 8921,
 -1,
 1577040904,
 8483,
 -41468,
 1575206958,
 9910,
 -1,
 1577268536,
 10799,
 1577475617,
 1572065510,
 -1,
 1577541138,
 1577424323,
 -1,
 1577606666,
 1577501396,
 -1,
 -41463,
 1577541025,
 8531,
 -1,
 1577601030,
 8530,
 1577803277,
 1577563935,
 -1,
 -41460,
 1577742087,
 8537,
 -1,
 1577798860,
 8528,
 -41458,
 1577756757,
 188,
 -41457,
 1577946345,
 8529,
 -41456,
 1577998731,
 189,
 -41455,
 1578061836,
 8533,
 -1,
 1578124612,
 8539,
 1578327578,
 1577501396,
 -1,
 1578393111,
 1578262619,
 -1,
 -41451,
 1578346615,
 190,
 -41450,
 1578389522,
 8535,
 -1,
 1578452325,
 8540,
 1578696703,
 1578361234,
 -1,
 -41447,
 1578616538,
 8532,
 -1,
 1578651666,
 8534,
 1578851871,
 1578258006,
 -1,
 1578917406,
 1578790523,
 -1,
 -41443,
 1578876227,
 8538,
 -1,
 1578911077,
 8541,
 -1,
 1578867749,
 8536,
 -41440,
 1578821568,
 8585,
 -1,
 1579137497,
 8542,
 1579310629,
 1577410943,
 -1,
 -41437,
 1579265500,
 9805,
 -41436,
 1579306336,
 8983,
 -1,
 1579365710,
 9996,
 -1,
 1579259063,
 8752,
 1579639077,
 1532311072,
 -1,
 1579704156,
 1579585935,
 -1,
 1579769503,
 1579648416,
 -1,
 1579834980,
 1579735599,
 -1,
 1579900515,
 1579749077,
 -1,
 1579966003,
 1579816122,
 -1,
 -41427,
 1579881601,
 127123,
 -41426,
 1579947017,
 127122,
 -41425,
 1580012476,
 127121,
 -41424,
 1580077900,
 127120,
 -41423,
 1580143271,
 127119,
 -41422,
 1580208655,
 127118,
 -1,
 1580274063,
 127117,
 1580490299,
 1579881568,
 -1,
 -41419,
 1580405889,
 127116,
 -41418,
 1580471305,
 127115,
 -41417,
 1580536764,
 127114,
 -41416,
 1580602188,
 127113,
 -41415,
 1580667559,
 127112,
 -41414,
 1580732943,
 127111,
 -1,
 1580798351,
 127110,
 1581014595,
 1580405749,
 -1,
 -41411,
 1580930177,
 127109,
 -41410,
 1580995593,
 127108,
 -41409,
 1581061052,
 127107,
 -41408,
 1581126476,
 127106,
 -41407,
 1581191847,
 127105,
 -41406,
 1581257231,
 127104,
 -1,
 1581322639,
 127103,
 1581538891,
 1580929966,
 -1,
 -41403,
 1581454465,
 127102,
 -41402,
 1581519881,
 127101,
 -41401,
 1581585340,
 127100,
 -41400,
 1581650764,
 127099,
 -41399,
 1581716135,
 127098,
 -41398,
 1581781519,
 127097,
 -1,
 1581846927,
 127096,
 1582063187,
 1581454116,
 -1,
 -41395,
 1581978753,
 127095,
 -41394,
 1582044169,
 127094,
 -41393,
 1582109628,
 127093,
 -41392,
 1582175052,
 127092,
 -41391,
 1582240423,
 127091,
 -41390,
 1582305807,
 127090,
 -1,
 1582371215,
 127089,
 1582587483,
 1581978248,
 -1,
 -41387,
 1582503041,
 127088,
 -41386,
 1582568457,
 127087,
 -41385,
 1582633916,
 127086,
 -41384,
 1582699340,
 127085,
 -41383,
 1582764711,
 127084,
 -41382,
 1582830095,
 127083,
 -1,
 1582895503,
 127082,
 1583153151,
 1582502401,
 -1,
 -41379,
 1583027329,
 127081,
 -41378,
 1583092745,
 127080,
 -41377,
 1583158204,
 127079,
 -41376,
 1583223628,
 127078,
 -41375,
 1583288999,
 127077,
 -41374,
 1583354383,
 127076,
 -1,
 1583419791,
 127075,
 -1,
 1579811327,
 127074,
 1583742975,
 1579769549,
 -1,
 1583767198,
 1583615701,
 -1,
 1583832686,
 1583682746,
 -1,
 -41368,
 1583748225,
 127073,
 -41367,
 1583813641,
 127072,
 -41366,
 1583879100,
 127071,
 -41365,
 1583944524,
 127070,
 -41364,
 1584009895,
 127069,
 -41363,
 1584075279,
 127068,
 -1,
 1584140687,
 127067,
 1584356982,
 1583748192,
 -1,
 -41360,
 1584272513,
 127066,
 -41359,
 1584337929,
 127065,
 -41358,
 1584403388,
 127064,
 -41357,
 1584468812,
 127063,
 -41356,
 1584534183,
 127062,
 -41355,
 1584599567,
 127061,
 -1,
 1584664975,
 127060,
 1584881278,
 1584272373,
 -1,
 -41352,
 1584796801,
 127059,
 -41351,
 1584862217,
 127058,
 -41350,
 1584927676,
 127057,
 -41349,
 1584993100,
 127056,
 -41348,
 1585058471,
 127055,
 -41347,
 1585123855,
 127054,
 -1,
 1585189263,
 127053,
 1585405574,
 1584796590,
 -1,
 -41344,
 1585321089,
 127052,
 -41343,
 1585386505,
 127051,
 -41342,
 1585451964,
 127050,
 -41341,
 1585517388,
 127049,
 -41340,
 1585582759,
 127048,
 -41339,
 1585648143,
 127047,
 -1,
 1585713551,
 127046,
 1585929870,
 1585320740,
 -1,
 -41336,
 1585845377,
 127045,
 -41335,
 1585910793,
 127044,
 -41334,
 1585976252,
 127043,
 -41333,
 1586041676,
 127042,
 -41332,
 1586107047,
 127041,
 -41331,
 1586172431,
 127040,
 -1,
 1586237839,
 127039,
 1586454166,
 1585844872,
 -1,
 -41328,
 1586369665,
 127038,
 -41327,
 1586435081,
 127037,
 -41326,
 1586500540,
 127036,
 -41325,
 1586565964,
 127035,
 -41324,
 1586631335,
 127034,
 -41323,
 1586696719,
 127033,
 -1,
 1586762127,
 127032,
 1587019775,
 1586369025,
 -1,
 -41320,
 1586893953,
 127031,
 -41319,
 1586959369,
 127030,
 -41318,
 1587024828,
 127029,
 -41317,
 1587090252,
 127028,
 -41316,
 1587155623,
 127027,
 -41315,
 1587221007,
 127026,
 -1,
 1587286415,
 127025,
 -1,
 1583677951,
 127024,
 1587568395,
 1579732772,
 -1,
 1587633894,
 1587478528,
 -1,
 1587699378,
 1587555550,
 -1,
 1587764913,
 1587637306,
 -1,
 1587830448,
 1587689880,
 -1,
 1587895975,
 1587790548,
 -1,
 -41306,
 1587863951,
 9462,
 -1,
 1587896406,
 9463,
 1588092586,
 1587853087,
 -1,
 -41303,
 1588031214,
 9466,
 -1,
 1588087938,
 9467,
 1588289197,
 1588022870,
 -1,
 -41300,
 1588239344,
 9464,
 -1,
 1588293239,
 9465,
 -41298,
 1588237759,
 9461,
 -41297,
 1588432060,
 9469,
 -1,
 1588479287,
 9468,
 -1,
 1587777619,
 9470,
 -1,
 1587713190,
 10868,
 1588813500,
 1587656479,
 -1,
 1588879031,
 1588776522,
 -1,
 -41291,
 1588830950,
 8913,
 -41290,
 1588866661,
 10940,
 -1,
 1588931598,
 8912,
 1589141178,
 1588832293,
 -1,
 -41287,
 1589105279,
 10831,
 -1,
 1589144116,
 10830,
 -41285,
 1589103578,
 10988,
 -1,
 1589285994,
 11005,
 1589468869,
 1588753240,
 -1,
 1589534404,
 1589416335,
 -1,
 1589599937,
 1589501192,
 -1,
 -41280,
 1589513947,
 8222,
 -1,
 1589577112,
 8215,
 1589837823,
 1589532033,
 -1,
 -41277,
 1589745654,
 10836,
 -1,
 1589779815,
 10835,
 -1,
 1589461923,
 10645,
 1590058700,
 1589434936,
 -1,
 1590124235,
 1589978962,
 -1,
 1590189770,
 1590049871,
 -1,
 -41271,
 1590145087,
 8875,
 -1,
 1590196242,
 10981,
 -1,
 1590130706,
 10979,
 -1,
 1590065901,
 8214,
 1590517458,
 1590009833,
 -1,
 1590582993,
 1590470996,
 -1,
 1590648528,
 1590519446,
 8243,
 -1,
 1590561179,
 12318,
 -1,
 1590575654,
 10939,
 -1,
 1590525797,
 10746,
 1590910678,
 1590463392,
 -1,
 1590976213,
 1590851919,
 10913,
 -1,
 1590890158,
 10915,
 -1,
 1590908663,
 10914,
 1591172825,
 1590873674,
 -1,
 -41256,
 1591124036,
 10987,
 -1,
 1591184623,
 8915,
 1591369436,
 1591110078,
 -1,
 -41253,
 1591326182,
 8914,
 -1,
 1591367301,
 8748,
 1591566047,
 1591293472,
 -1,
 -41250,
 1591517103,
 10986,
 -1,
 1591548082,
 8225,
 -41248,
 1591533089,
 65100,
 -41247,
 1591717518,
 10646,
 -41246,
 1591781566,
 8263,
 -41245,
 1591841289,
 11799,
 -41244,
 1591893328,
 8223,
 -41243,
 1591954810,
 8252,
 -1,
 1592006567,
 733,
 1592221448,
 1587547859,
 -1,
 1592286973,
 1592181100,
 -1,
 1592352498,
 1592208861,
 -1,
 1592418027,
 1592303593,
 8473,
 -1,
 1592353151,
 8511,
 -41236,
 1592387358,
 8484,
 -41235,
 1592502612,
 8477,
 -41234,
 1592567620,
 8474,
 -41233,
 1592625375,
 8469,
 -41232,
 1592678539,
 8461,
 -41231,
 1592742762,
 8510,
 -1,
 1592798430,
 8450,
 1593007865,
 1592290720,
 -1,
 1593073400,
 1592966540,
 -1,
 -41227,
 1593012009,
 8521,
 -41226,
 1593074047,
 8520,
 -41225,
 1593131143,
 8519,
 -1,
 1593194016,
 8518,
 -1,
 1592995302,
 8517,
 1593466620,
 1592966540,
 -1,
 -41221,
 1593418630,
 8508,
 -1,
 1593463658,
 8509,
 -1,
 1593411866,
 8512,
 1593728775,
 1592228594,
 -1,
 1593794308,
 1593687395,
 -1,
 1593859842,
 1593723152,
 -1,
 -41215,
 1593801039,
 10907,
 -1,
 1593857783,
 10908,
 -41213,
 1593801126,
 11001,
 -1,
 1593988977,
 11002,
 1594228735,
 1593723152,
 -1,
 -41210,
 1594128719,
 10905,
 -1,
 1594185463,
 10906,
 -1,
 1593657208,
 10719,
 1594490879,
 1592145442,
 -1,
 -41206,
 1594392825,
 9891,
 -1,
 1594445707,
 9890,
 1594646333,
 1587536206,
 -1,
 1594711860,
 1594613082,
 -1,
 1594777371,
 1594627444,
 -1,
 1594842906,
 1594734002,
 8595,
 1594949631,
 1594753024,
 -1,
 1594973975,
 1594875762,
 -1,
 1595039508,
 1594935515,
 -1,
 -41197,
 1594994836,
 8627,
 -1,
 1595045951,
 8626,
 -41195,
 1594974070,
 10504,
 -41194,
 1595162006,
 8671,
 -1,
 1595224947,
 8629,
 -41192,
 1594935609,
 10515,
 -41191,
 1595373712,
 8693,
 -1,
 1595429455,
 8615,
 -1,
 1594788439,
 11796,
 1595694889,
 1594710723,
 -1,
 1595760420,
 1595635333,
 -1,
 1595825955,
 1595670528,
 -1,
 1595891489,
 1595746484,
 -1,
 -41184,
 1595856220,
 10607,
 -1,
 1595883369,
 10597,
 -41182,
 1595853113,
 10585,
 -1,
 1596019279,
 10593,
 -1,
 1595792724,
 8643,
 1596325887,
 1595715169,
 -1,
 1596350248,
 1596194816,
 -1,
 -41177,
 1596311865,
 10581,
 -1,
 1596346959,
 10589,
 -1,
 1596317012,
 8642,
 1596612396,
 1595654868,
 -1,
 -41173,
 1596580425,
 8609,
 -1,
 1596633641,
 10507,
 1596809007,
 1596536352,
 -1,
 -41170,
 1596758855,
 8659,
 -1,
 1596793733,
 8675,
 -41168,
 1596778520,
 8623,
 -41167,
 1596972726,
 8681,
 -41166,
 1597024227,
 10225,
 -41165,
 1597087880,
 8650,
 -1,
 1597123075,
 11015,
 1597333306,
 1594621952,
 -1,
 1597398839,
 1597293401,
 8868,
 -1,
 1597312097,
 10993,
 -41160,
 1597353673,
 8945,
 -41159,
 1597460630,
 10623,
 -1,
 1597514402,
 8964,
 1597767679,
 1597247734,
 -1,
 -41156,
 1597681444,
 10729,
 -1,
 1597732607,
 10728,
 1597923148,
 1594606292,
 -1,
 1597988679,
 1597883598,
 -1,
 1598054210,
 1597910238,
 -1,
 -41151,
 1598010503,
 8284,
 -1,
 1598057500,
 9676,
 -41149,
 1598016179,
 11784,
 -41148,
 1598209879,
 11034,
 -41147,
 1598271579,
 11798,
 -41146,
 1598329339,
 11795,
 -1,
 1598377892,
 10649,
 1598619647,
 1597898752,
 -1,
 -41143,
 1598530636,
 8724,
 -41142,
 1598592896,
 8901,
 -41141,
 1598653867,
 8760,
 -1,
 1598690933,
 729,
 1598906202,
 1597852239,
 -1,
 1598971729,
 1598858718,
 -1,
 1599037264,
 1598898720,
 8832,
 -1,
 1598949055,
 8928,
 -1,
 1598987516,
 8876,
 1599233877,
 1598894793,
 -1,
 1599299412,
 1599180289,
 8939,
 -1,
 1599211199,
 8941,
 -1,
 1599243252,
 8716,
 1599496023,
 1599193498,
 8833,
 -1,
 1599407807,
 8929,
 1599627097,
 1599421027,
 8740,
 -1,
 1599540773,
 10990,
 -1,
 1599558018,
 8878,
 -41125,
 1598852048,
 8363,
 -1,
 1599765609,
 36,
 1599955084,
 1579630727,
 -1,
 1600020492,
 1599920131,
 -1,
 1600085954,
 1599961562,
 -1,
 1600151400,
 1600042783,
 -1,
 1600216934,
 1600084107,
 -1,
 1600282469,
 1600166286,
 -1,
 -41117,
 1600229775,
 2322,
 -41116,
 1600274567,
 2318,
 -1,
 1600329076,
 2308,
 -1,
 1600198004,
 2358,
 -41113,
 1600173977,
 2359,
 -1,
 1600525684,
 2360,
 1600741233,
 1600075296,
 -1,
 1600806767,
 1600665120,
 -1,
 1600872301,
 1600730656,
 -1,
 -41108,
 1600805033,
 2396,
 -1,
 1600853364,
 2430,
 -41106,
 1600805033,
 2338,
 -1,
 1600984436,
 2337,
 -41104,
 1600739497,
 2343,
 -1,
 1601115508,
 2342,
 1601331064,
 1600706478,
 -1,
 1601396599,
 1601278549,
 -1,
 1601462133,
 1601349972,
 2315,
 -1,
 1601415508,
 2400,
 1601634303,
 1601401688,
 2316,
 -1,
 1601532760,
 2401,
 -1,
 1601312116,
 2357,
 1601789823,
 1601276127,
 -1,
 1601855356,
 1601734879,
 -1,
 -41093,
 1601800507,
 2345,
 -1,
 1601836404,
 2339,
 -41091,
 1601823786,
 2334,
 -41090,
 1601983236,
 2329,
 -1,
 1602033012,
 2344,
 1602248582,
 1601721059,
 -1,
 1602314115,
 1602181259,
 -1,
 -41086,
 1602246825,
 2394,
 -1,
 1602295156,
 2328,
 -41084,
 1602256392,
 2429,
 -41083,
 1602441988,
 2427,
 -1,
 1602491764,
 2327,
 1602707341,
 1602170078,
 -1,
 1602772876,
 1602622836,
 2330,
 1602879487,
 1602718451,
 -1,
 -41078,
 1602785679,
 2321,
 -41077,
 1602830471,
 2317,
 -1,
 1602884980,
 2418,
 -1,
 1602705577,
 2331,
 1603166099,
 1602667220,
 -1,
 1603231633,
 1603125972,
 -1,
 -41072,
 1603164329,
 2336,
 -1,
 1603212660,
 2335,
 -41070,
 1603164329,
 2341,
 -1,
 1603343732,
 2340,
 1603559319,
 1603081588,
 2309,
 -41067,
 1603522122,
 2324,
 -41066,
 1603559807,
 2320,
 -1,
 1603605876,
 2310,
 1603821467,
 1603512660,
 -1,
 -41063,
 1603774895,
 2353,
 -41062,
 1603819689,
 2397,
 -1,
 1603868020,
 2352,
 1604083616,
 1603760984,
 -1,
 1604149151,
 1604023128,
 -1,
 -41058,
 1604088749,
 2356,
 -1,
 1604130164,
 2355,
 -1,
 1604064628,
 2354,
 1604411301,
 1604022408,
 -1,
 1604476836,
 1604343947,
 -1,
 -41053,
 1604409513,
 2393,
 -1,
 1604457844,
 2326,
 -1,
 1604392308,
 2325,
 1604738985,
 1604349737,
 -1,
 -41049,
 1604677419,
 2428,
 -41048,
 1604737193,
 2333,
 -1,
 1604785524,
 2332,
 1605001133,
 1604658806,
 -1,
 -41045,
 1604933801,
 2349,
 -41044,
 1604986536,
 2431,
 -1,
 1605047668,
 2348,
 1605263280,
 1604970270,
 -1,
 -41041,
 1605195945,
 2425,
 -1,
 1605244276,
 2395,
 1605459891,
 1605231598,
 -1,
 -41038,
 1605428266,
 2399,
 -1,
 1605440884,
 2351,
 1605656501,
 1605422666,
 2313,
 -1,
 1605619274,
 2314,
 1605787576,
 1605607401,
 -1,
 -41033,
 1605720233,
 2347,
 -1,
 1605768564,
 2346,
 1605984186,
 1605722495,
 2311,
 -1,
 1605919103,
 2312,
 1606115261,
 1605916811,
 -1,
 -41028,
 1606042106,
 2426,
 -1,
 1606096244,
 2361,
 -41026,
 1606068042,
 2392,
 -41025,
 1606259087,
 2323,
 -41024,
 1606320178,
 2350,
 -41023,
 1606373055,
 2398,
 -1,
 1606434951,
 2319,
 1606639578,
 1600052406,
 -1,
 1606705096,
 1606605839,
 -1,
 1606770630,
 1606658388,
 2371,
 -1,
 1606723924,
 2372,
 1606942719,
 1606710104,
 2402,
 -1,
 1606841176,
 2403,
 1607032780,
 1606626719,
 -1,
 -41014,
 1606979983,
 2377,
 -41013,
 1607040319,
 2389,
 -1,
 1607090311,
 2373,
 1607294928,
 1606948212,
 -1,
 -41010,
 1607257674,
 2380,
 -41009,
 1607295359,
 2376,
 -1,
 1607341428,
 2366,
 1607557074,
 1607257674,
 2369,
 -1,
 1607519818,
 2370,
 1607688149,
 1607514973,
 -1,
 -41004,
 1607635343,
 2378,
 -1,
 1607680135,
 2374,
 1607884759,
 1607623039,
 2367,
 -1,
 1607819647,
 2368,
 -41000,
 1607837325,
 2382,
 -40999,
 1607963023,
 2379,
 -1,
 1608007815,
 2375,
 1608212466,
 1606596383,
 -1,
 1608277999,
 1608148361,
 -1,
 1608343523,
 1608199604,
 2305,
 1608450047,
 1608253440,
 -1,
 1608474593,
 1608368852,
 -1,
 -40992,
 1608442255,
 43253,
 -1,
 1608474710,
 43254,
 -40990,
 1608440771,
 43251,
 -1,
 1608590812,
 43255,
 1608802278,
 1608309605,
 -1,
 -40987,
 1608759333,
 2307,
 -1,
 1608821389,
 2381,
 1608998889,
 1608717684,
 -1,
 -40984,
 1608964037,
 2365,
 -1,
 1609011397,
 2306,
 -40982,
 1608957694,
 43250,
 -40981,
 1609148209,
 43256,
 -40980,
 1609207861,
 2364,
 -40979,
 1609263855,
 2304,
 -40978,
 1609325834,
 2417,
 -1,
 1609383091,
 43252,
 1609629695,
 1608239834,
 -1,
 -40975,
 1609551875,
 2385,
 -1,
 1609572238,
 2386,
 1609785347,
 1608136224,
 -1,
 1609850881,
 1609721210,
 -1,
 1609916407,
 1609810644,
 -1,
 -40970,
 1609884047,
 2408,
 -1,
 1609916502,
 2409,
 1610113018,
 1609873183,
 -1,
 -40967,
 1610051310,
 2412,
 -1,
 1610108034,
 2413,
 1610309629,
 1610042966,
 -1,
 -40964,
 1610259440,
 2410,
 -1,
 1610313335,
 2411,
 -40962,
 1610278805,
 2406,
 -40961,
 1610454463,
 2407,
 -40960,
 1610517692,
 2415,
 -1,
 1610564919,
 2414,
 -40958,
 1609800547,
 2405,
 -1,
 1610686016,
 2404,
 1610899462,
 1609716451,
 -1,
 -40955,
 1610853129,
 2387,
 -1,
 1610882989,
 43257,
 1611096073,
 1610814836,
 -1,
 -40952,
 1611019771,
 2388,
 -1,
 1611081734,
 2416,
 -40950,
 1611044038,
 2384,
 -40949,
 1611225929,
 43259,
 -1,
 1611279902,
 43258,
 1611489389,
 1599977247,
 -1,
 1611554924,
 1611418048,
 -1,
 1611620413,
 1611513354,
 -1,
 1611685914,
 1611546759,
 -1,
 1611751442,
 1611642655,
 66629,
 -1,
 1611683979,
 66631,
 1611882516,
 1611696351,
 66636,
 -1,
 1611813603,
 66637,
 -40939,
 1611848968,
 66639,
 -40938,
 1611974159,
 66627,
 -40937,
 1612032340,
 66633,
 -40936,
 1612087269,
 66635,
 -40935,
 1612149592,
 66634,
 -1,
 1612205654,
 66625,
 1612406817,
 1611643741,
 -1,
 1612472349,
 1612353935,
 66610,
 -1,
 1612419471,
 66611,
 1612603423,
 1612387700,
 66608,
 -1,
 1612535947,
 66609,
 -40928,
 1612538239,
 66606,
 -1,
 1612660871,
 66607,
 1612865576,
 1612348706,
 -1,
 1612931108,
 1612812687,
 66604,
 -1,
 1612878223,
 66605,
 1613062182,
 1612846452,
 66602,
 -1,
 1612994699,
 66603,
 -40921,
 1612996991,
 66600,
 -1,
 1613119623,
 66601,
 1613324331,
 1612834590,
 -1,
 -40918,
 1613257711,
 66632,
 -1,
 1613316903,
 66630,
 1613520942,
 1613284052,
 -1,
 -40915,
 1613454319,
 66628,
 -1,
 1613513511,
 66619,
 1613717553,
 1613468047,
 -1,
 -40912,
 1613683976,
 66613,
 -1,
 1613717887,
 66638,
 -40910,
 1613685966,
 66615,
 -40909,
 1613882087,
 66614,
 -40908,
 1613945180,
 66626,
 -40907,
 1613996504,
 66617,
 -40906,
 1614049682,
 66623,
 -40905,
 1614114687,
 66622,
 -40904,
 1614174347,
 66616,
 -40903,
 1614238703,
 66624,
 -40902,
 1614296939,
 66620,
 -40901,
 1614360455,
 66621,
 -40900,
 1614424103,
 66618,
 -1,
 1614489144,
 66612,
 1614741503,
 1611542020,
 -1,
 1614766153,
 1614626951,
 -1,
 1614831681,
 1614722847,
 66589,
 -1,
 1614764171,
 66591,
 1614962755,
 1614776543,
 66596,
 -1,
 1614893795,
 66597,
 -40892,
 1614929160,
 66599,
 -40891,
 1615054351,
 66587,
 -40890,
 1615112532,
 66593,
 -40889,
 1615167461,
 66595,
 -40888,
 1615229784,
 66594,
 -1,
 1615285846,
 66585,
 1615487056,
 1614723933,
 -1,
 1615552588,
 1615434127,
 66570,
 -1,
 1615499663,
 66571,
 1615683662,
 1615467892,
 66568,
 -1,
 1615616139,
 66569,
 -40881,
 1615618431,
 66566,
 -1,
 1615741063,
 66567,
 1615945815,
 1615428898,
 -1,
 1616011347,
 1615892879,
 66564,
 -1,
 1615958415,
 66565,
 1616142421,
 1615926644,
 66562,
 -1,
 1616074891,
 66563,
 -40874,
 1616077183,
 66560,
 -1,
 1616199815,
 66561,
 1616404570,
 1615914782,
 -1,
 -40871,
 1616337903,
 66592,
 -1,
 1616397095,
 66590,
 1616601181,
 1616364244,
 -1,
 -40868,
 1616534511,
 66588,
 -1,
 1616593703,
 66579,
 1616797792,
 1616548239,
 -1,
 -40865,
 1616764168,
 66573,
 -1,
 1616798079,
 66598,
 -40863,
 1616766158,
 66575,
 -40862,
 1616962279,
 66574,
 -40861,
 1617025372,
 66586,
 -40860,
 1617076696,
 66577,
 -40859,
 1617129874,
 66583,
 -40858,
 1617194879,
 66582,
 -40857,
 1617254539,
 66576,
 -40856,
 1617318895,
 66584,
 -40855,
 1617377131,
 66580,
 -40854,
 1617440647,
 66581,
 -40853,
 1617504295,
 66578,
 -1,
 1617569336,
 66572,
 -1,
 1611476686,
 9739,
 1617846404,
 1611435982,
 -1,
 1617911930,
 1617812024,
 -1,
 1617977463,
 1617829227,
 -1,
 1618042995,
 1617938947,
 -1,
 -40846,
 1617997409,
 9150,
 -1,
 1618048645,
 9163,
 1618239606,
 1617963736,
 -1,
 -40843,
 1618194017,
 9151,
 -1,
 1618245253,
 9164,
 -1,
 1618206210,
 9158,
 1618542591,
 1617944434,
 -1,
 -40839,
 1618463482,
 9155,
 -1,
 1618489410,
 9152,
 1618698367,
 1617875731,
 9162,
 1618804735,
 1618611235,
 -1,
 -40835,
 1618730498,
 9160,
 -40834,
 1618791162,
 9157,
 -1,
 1618817090,
 9154,
 1619066879,
 1618624068,
 9161,
 1619132415,
 1618938915,
 -1,
 -40830,
 1619058178,
 9159,
 -40829,
 1619118842,
 9156,
 -1,
 1619144770,
 9153,
 1619353736,
 1617778588,
 -1,
 -40826,
 1619311659,
 176,
 -40825,
 1619349211,
 8457,
 -1,
 1619406534,
 8451,
 1619615883,
 1619275835,
 -1,
 -40822,
 1619573128,
 9110,
 -1,
 1619611026,
 9192,
 -1,
 1619558136,
 8796,
 1619878168,
 1599889791,
 -1,
 1619943624,
 1619808995,
 -1,
 1620009146,
 1619881346,
 -1,
 1620074648,
 1619968724,
 -1,
 1620140180,
 1620042127,
 50,
 1620246527,
 1620049920,
 -1,
 -40813,
 1620136642,
 9353,
 -1,
 1620193807,
 127235,
 1620443135,
 1620074582,
 51,
 1620508671,
 1620312064,
 -1,
 -40809,
 1620398786,
 9354,
 -1,
 1620455951,
 127236,
 1620664481,
 1620031263,
 -1,
 1620730013,
 1620602606,
 54,
 1620836351,
 1620639744,
 -1,
 -40804,
 1620726466,
 9357,
 -1,
 1620783631,
 127239,
 1621032959,
 1620659330,
 55,
 1621098495,
 1620901888,
 -1,
 -40800,
 1620988610,
 9358,
 -1,
 1621045775,
 127240,
 1621254314,
 1620594262,
 -1,
 1621319846,
 1621203952,
 52,
 1621426175,
 1621229568,
 -1,
 -40795,
 1621316290,
 9355,
 -1,
 1621373455,
 127237,
 1621622783,
 1621257847,
 53,
 1621688319,
 1621491712,
 -1,
 -40791,
 1621578434,
 9356,
 -1,
 1621635599,
 127238,
 1621844142,
 1621223317,
 48,
 1621950463,
 1621753856,
 -1,
 -40787,
 1621840578,
 127232,
 -1,
 1621897743,
 127233,
 1622106290,
 1621792191,
 49,
 1622212607,
 1622016000,
 -1,
 -40783,
 1622102722,
 9352,
 -1,
 1622159887,
 127234,
 1622368438,
 1622052028,
 57,
 1622474751,
 1622278144,
 -1,
 -40779,
 1622364866,
 9360,
 -1,
 1622422031,
 127242,
 1622671359,
 1622295863,
 56,
 1622736895,
 1622540288,
 -1,
 -40775,
 1622627010,
 9359,
 -1,
 1622684175,
 127241,
 1622933503,
 1619962500,
 -1,
 1622958271,
 1622819172,
 119557,
 1623064575,
 1622900671,
 -1,
 -40770,
 1622987163,
 119556,
 -1,
 1623015860,
 119555,
 1623220418,
 1622899132,
 -1,
 -40767,
 1623156528,
 9869,
 -1,
 1623203424,
 9870,
 1623417029,
 1623152779,
 -1,
 -40764,
 1623380384,
 119554,
 -1,
 1623409082,
 119553,
 1623654399,
 1623348973,
 -1,
 -40761,
 1623549744,
 9871,
 -1,
 1623596640,
 9868,
 1623810294,
 1619889139,
 -1,
 1623875815,
 1623755574,
 -1,
 1623941337,
 1623832592,
 -1,
 1624006872,
 1623865752,
 -1,
 1624072399,
 1623966420,
 -1,
 -40754,
 1624039823,
 10123,
 -1,
 1624072278,
 10124,
 1624269010,
 1624028959,
 -1,
 -40751,
 1624207086,
 10127,
 -1,
 1624263810,
 10128,
 1624465621,
 1624198742,
 -1,
 -40748,
 1624415216,
 10125,
 -1,
 1624469111,
 10126,
 -40746,
 1624413631,
 10122,
 -40745,
 1624607932,
 10130,
 -1,
 1624655159,
 10129,
 -1,
 1623953491,
 10131,
 1624924390,
 1623865752,
 -1,
 1624989917,
 1624883924,
 -1,
 -40740,
 1624957327,
 10103,
 -1,
 1624989782,
 10104,
 1625186528,
 1624946463,
 -1,
 -40737,
 1625124590,
 10107,
 -1,
 1625181314,
 10108,
 1625383139,
 1625116246,
 -1,
 -40734,
 1625332720,
 10105,
 -1,
 1625386615,
 10106,
 -40732,
 1625331135,
 10102,
 -40731,
 1625525436,
 10110,
 -1,
 1625572663,
 10109,
 -1,
 1624870995,
 10111,
 1625882623,
 1623797905,
 -1,
 1625907445,
 1625766296,
 -1,
 1625972972,
 1625866964,
 -1,
 -40725,
 1625940367,
 10113,
 -1,
 1625972822,
 10114,
 1626169583,
 1625929503,
 -1,
 -40722,
 1626107630,
 10117,
 -1,
 1626164354,
 10118,
 1626366194,
 1626099286,
 -1,
 -40719,
 1626315760,
 10115,
 -1,
 1626369655,
 10116,
 -40717,
 1626314175,
 10112,
 -40716,
 1626508476,
 10120,
 -1,
 1626555703,
 10119,
 -1,
 1625854035,
 10121,
 1626824961,
 1623725428,
 -1,
 1626890496,
 1626767333,
 -1,
 1626956031,
 1626838458,
 -1,
 1627021566,
 1626922866,
 -1,
 -40709,
 1626982931,
 11032,
 -40708,
 1627041572,
 11031,
 -40707,
 1627092735,
 11030,
 -1,
 1627138798,
 11033,
 -1,
 1626969984,
 8900,
 -1,
 1626885080,
 8960,
 -1,
 1626818996,
 168,
 1627545864,
 1626751116,
 -1,
 -40701,
 1627460737,
 9861,
 -40700,
 1627526153,
 9860,
 -40699,
 1627591612,
 9859,
 -40698,
 1627657036,
 9858,
 -40697,
 1627722407,
 9857,
 -1,
 1627787791,
 9856,
 1628004625,
 1627510702,
 -1,
 1628070160,
 1627939199,
 -1,
 1628135695,
 1628028164,
 -1,
 1628201230,
 1628092191,
 -1,
 -40691,
 1628140930,
 8725,
 -1,
 1628202373,
 247,
 -1,
 1628162110,
 8903,
 -1,
 1628059658,
 8739,
 -1,
 1628018798,
 9902,
 1628594452,
 1627961119,
 -1,
 -40685,
 1628517138,
 9090,
 -1,
 1628575325,
 9933,
 -40683,
 1628556398,
 12291,
 -40682,
 1628744682,
 9107,
 -40681,
 1628800012,
 9009,
 -1,
 1628852158,
 8783,
 1629053216,
 1619793268,
 -1,
 1629118749,
 1629010656,
 -1,
 -40677,
 1629080323,
 10143,
 -40676,
 1629134555,
 65097,
 -1,
 1629191720,
 65101,
 -40674,
 1629074255,
 9619,
 -40673,
 1629321669,
 8504,
 -1,
 1629377689,
 8224,
 1629618175,
 1629006164,
 -1,
 1629643044,
 1629492596,
 -1,
 -40669,
 1629573768,
 10139,
 -1,
 1629630401,
 8367,
 -1,
 1629580983,
 9946,
 1629905753,
 1579585935,
 -1,
 1629971027,
 1629844312,
 -1,
 1630036499,
 1629894178,
 -1,
 1630101881,
 1629998284,
 -1,
 1630167383,
 1630050622,
 -1,
 1630232897,
 1630082420,
 68608,
 1630298422,
 1630158983,
 -1,
 -40659,
 1630266350,
 68632,
 -40658,
 1630323412,
 68677,
 -40657,
 1630385951,
 68670,
 -40656,
 1630447956,
 68668,
 -40655,
 1630505183,
 68644,
 -40654,
 1630565208,
 68640,
 -40653,
 1630630024,
 68634,
 -40652,
 1630687971,
 68623,
 -40651,
 1630746144,
 68627,
 -1,
 1630807670,
 68619,
 1631019320,
 1630254879,
 68669,
 -1,
 1630951563,
 68671,
 -40647,
 1630987246,
 68630,
 -40646,
 1631109844,
 68675,
 -40645,
 1631168852,
 68666,
 -40644,
 1631233860,
 68660,
 -40643,
 1631291615,
 68643,
 -40642,
 1631351640,
 68638,
 -40641,
 1631408867,
 68621,
 -40640,
 1631467040,
 68625,
 -1,
 1631528566,
 68617,
 1631740237,
 1630158983,
 -1,
 1631805767,
 1631684831,
 -1,
 -40636,
 1631773678,
 68650,
 -40635,
 1631830740,
 68646,
 -40634,
 1631867619,
 68653,
 -1,
 1631923422,
 68648,
 -40632,
 1631774494,
 68628,
 -40631,
 1632090643,
 68673,
 -40630,
 1632149481,
 68655,
 -40629,
 1632206821,
 68642,
 -40628,
 1632272101,
 68641,
 -1,
 1632316638,
 68658,
 1632526675,
 1631687055,
 68614,
 1632592208,
 1632452743,
 68615,
 -1,
 1632530568,
 68636,
 -40623,
 1632551636,
 68679,
 -40622,
 1632675652,
 68664,
 -1,
 1632739305,
 68656,
 1632919894,
 1632461183,
 68611,
 -40619,
 1632872260,
 68662,
 -1,
 1632906462,
 68657,
 -1,
 1632839634,
 68680,
 1633222655,
 1630135614,
 -1,
 1633247595,
 1633097076,
 68609,
 1633313121,
 1633173639,
 68610,
 1633378652,
 1633257695,
 68645,
 -1,
 1633309411,
 68654,
 -40611,
 1633346542,
 68633,
 -40610,
 1633469140,
 68678,
 -40609,
 1633513608,
 68635,
 -40608,
 1633571555,
 68624,
 -1,
 1633625718,
 68620,
 -40606,
 1633281006,
 68631,
 -40605,
 1633796820,
 68676,
 -40604,
 1633860115,
 68672,
 -40603,
 1633921364,
 68667,
 -40602,
 1633986372,
 68661,
 -40601,
 1634044855,
 68652,
 -40600,
 1634104152,
 68639,
 -40599,
 1634161379,
 68622,
 -40598,
 1634219552,
 68626,
 -1,
 1634281078,
 68618,
 1634492787,
 1633173639,
 68613,
 1634558320,
 1634437343,
 -1,
 -40594,
 1634526190,
 68651,
 -40593,
 1634583252,
 68647,
 -1,
 1634610398,
 68649,
 -40591,
 1634527006,
 68629,
 -40590,
 1634777619,
 68674,
 -1,
 1634807006,
 68659,
 1635017079,
 1634439567,
 -1,
 1635082614,
 1634943111,
 68616,
 -1,
 1635020936,
 68637,
 -1,
 1635034948,
 68665,
 1635319807,
 1634951551,
 68612,
 -1,
 1635231556,
 68663,
 1635410364,
 1630053134,
 -1,
 1635475891,
 1635367984,
 -1,
 1635541377,
 1635399200,
 -1,
 1635606911,
 1635456372,
 66477,
 1635713023,
 1635541344,
 66508,
 -1,
 1635585752,
 66509,
 -40576,
 1635569226,
 66479,
 -1,
 1635737983,
 66478,
 1635934597,
 1635456372,
 66464,
 1636040703,
 1635898795,
 66504,
 -40572,
 1635932329,
 66506,
 -1,
 1635978968,
 66505,
 1636196745,
 1635893972,
 -1,
 -40569,
 1636159050,
 66476,
 -40568,
 1636194473,
 66480,
 -1,
 1636242804,
 66475,
 1636458893,
 1636153119,
 -1,
 -40565,
 1636415385,
 66498,
 -40564,
 1636456617,
 66497,
 -1,
 1636504948,
 66495,
 1636721041,
 1636401125,
 -1,
 -40561,
 1636683338,
 66488,
 -40560,
 1636721023,
 66487,
 -1,
 1636767092,
 66486,
 1636983189,
 1636640374,
 -1,
 1637048724,
 1636898164,
 66482,
 -1,
 1636979460,
 66510,
 -1,
 1637013373,
 66511,
 1637245336,
 1636950788,
 -1,
 -40553,
 1637202523,
 66507,
 -1,
 1637225844,
 66471,
 1637441947,
 1637210030,
 -1,
 -40550,
 1637376383,
 66491,
 -1,
 1637422452,
 66490,
 1637638558,
 1637394772,
 -1,
 -40547,
 1637600842,
 66493,
 -1,
 1637619060,
 66492,
 1637835169,
 1637583071,
 -1,
 -40544,
 1637797450,
 66485,
 -1,
 1637815668,
 66484,
 1638031780,
 1637773448,
 -1,
 -40541,
 1637994058,
 66468,
 -1,
 1638012276,
 66467,
 1638228391,
 1637969705,
 -1,
 -40538,
 1638162815,
 66474,
 -1,
 1638208884,
 66473,
 1638425002,
 1638159075,
 -1,
 -40535,
 1638387274,
 66470,
 -1,
 1638405492,
 66469,
 -40533,
 1638393648,
 66496,
 -40532,
 1638589482,
 66489,
 -40531,
 1638649418,
 66466,
 -40530,
 1638703182,
 66481,
 -40529,
 1638757293,
 66494,
 -40528,
 1638818175,
 66465,
 -40527,
 1638881449,
 66499,
 -40526,
 1638944447,
 66483,
 -1,
 1639001403,
 66472,
 1639211451,
 1635422271,
 -1,
 1639276985,
 1639170772,
 -1,
 1639342520,
 1639243016,
 -1,
 -40521,
 1639289231,
 66514,
 -1,
 1639336015,
 66516,
 -1,
 1639270129,
 66515,
 -40518,
 1639224767,
 66513,
 -1,
 1639538967,
 66517,
 -1,
 1639178940,
 66512,
 1639801318,
 1635347872,
 -1,
 1639866848,
 1639741914,
 -1,
 1639932360,
 1639792775,
 66308,
 1639997889,
 1639888671,
 66324,
 -1,
 1639929995,
 66318,
 1640128963,
 1639950676,
 66323,
 -1,
 1640085279,
 66331,
 -40508,
 1640073439,
 66317,
 -40507,
 1640202213,
 66316,
 -40506,
 1640264536,
 66315,
 -40505,
 1640329961,
 66327,
 -1,
 1640386134,
 66330,
 1640587725,
 1639870600,
 -1,
 -40502,
 1640549962,
 66322,
 -40501,
 1640586024,
 66329,
 -40500,
 1640644743,
 66306,
 -1,
 1640699252,
 66314,
 1640915407,
 1640549962,
 66326,
 -1,
 1640877642,
 66334,
 1641046482,
 1640874708,
 -1,
 -40495,
 1640979240,
 66312,
 -1,
 1641037959,
 66325,
 1641243093,
 1640996841,
 -1,
 -40492,
 1641175848,
 66328,
 -1,
 1641234567,
 66320,
 1641439703,
 1641177471,
 66313,
 -1,
 1641374079,
 66333,
 -40488,
 1641408373,
 66310,
 -40487,
 1641535732,
 66309,
 -40486,
 1641593559,
 66321,
 -40485,
 1641648527,
 66319,
 -40484,
 1641700136,
 66311,
 -40483,
 1641756490,
 66307,
 -40482,
 1641820012,
 66332,
 -40481,
 1641883671,
 66305,
 -1,
 1641944436,
 66304,
 1642201087,
 1639813226,
 -1,
 1642226148,
 1642090505,
 -1,
 -40477,
 1642191092,
 66337,
 -1,
 1642222270,
 66339,
 -40475,
 1642186022,
 66338,
 -1,
 1642370495,
 66336,
 1642594303,
 1639759565,
 -1,
 1642619406,
 1642494426,
 -1,
 1642684910,
 1642578644,
 -1,
 1642750444,
 1642616971,
 -1,
 -40469,
 1642679266,
 68220,
 -1,
 1642735125,
 68219,
 -40467,
 1642679266,
 68215,
 -1,
 1642866197,
 68201,
 1643078132,
 1642641183,
 -1,
 1643143667,
 1642993012,
 -1,
 -40463,
 1643102932,
 68202,
 -40462,
 1643152340,
 68207,
 -1,
 1643198599,
 68206,
 -1,
 1643076995,
 68198,
 1643471353,
 1643001376,
 -1,
 1643536888,
 1643403433,
 -1,
 -40457,
 1643477461,
 68217,
 -1,
 1643526279,
 68211,
 -1,
 1643453252,
 68213,
 1643799036,
 1643409544,
 -1,
 -40453,
 1643732067,
 68205,
 -1,
 1643782083,
 68203,
 1643995646,
 1643731752,
 68192,
 -1,
 1643955727,
 68194,
 1644126721,
 1643926243,
 -1,
 -40448,
 1644062362,
 68212,
 -1,
 1644124963,
 68214,
 1644323332,
 1644041588,
 -1,
 -40445,
 1644291603,
 68210,
 -1,
 1644328572,
 68209,
 -40443,
 1644291952,
 68216,
 -40442,
 1644488255,
 68218,
 -40441,
 1644551727,
 68197,
 -40440,
 1644604685,
 68199,
 -40439,
 1644668856,
 68196,
 -40438,
 1644728487,
 68204,
 -40437,
 1644790759,
 68195,
 -40436,
 1644852459,
 68193,
 -40435,
 1644908326,
 68208,
 -1,
 1644964143,
 68200,
 1645215743,
 1642565691,
 -1,
 1645240850,
 1645095039,
 -1,
 -40431,
 1645188543,
 68221,
 -1,
 1645236249,
 68222,
 -1,
 1645169094,
 68223,
 1645543423,
 1629946509,
 -1,
 1645568570,
 1645443546,
 -1,
 1645634079,
 1645483380,
 -1,
 1645699611,
 1645548916,
 -1,
 -40424,
 1645665544,
 7267,
 -40423,
 1645707237,
 7266,
 -40422,
 1645768840,
 7264,
 -1,
 1645834025,
 7265,
 -40420,
 1645658836,
 7259,
 -40419,
 1645972407,
 7261,
 -40418,
 1646031704,
 7262,
 -1,
 1646088931,
 7260,
 1646289446,
 1645572952,
 -1,
 1646354978,
 1646204276,
 7258,
 -1,
 1646269812,
 7263,
 -40413,
 1646317130,
 7273,
 -40412,
 1646432655,
 7283,
 -40411,
 1646485887,
 7268,
 -1,
 1646542983,
 7278,
 1646748203,
 1646251594,
 -1,
 -40408,
 1646715886,
 7277,
 -40407,
 1646759290,
 7276,
 -40406,
 1646802464,
 7275,
 -1,
 1646865630,
 7274,
 1647075888,
 1646694799,
 -1,
 -40403,
 1647040430,
 7286,
 -40402,
 1647103000,
 7284,
 -40401,
 1647138955,
 7287,
 -1,
 1647191670,
 7285,
 1647403573,
 1647010175,
 -1,
 -40398,
 1647359775,
 7269,
 -40397,
 1647421780,
 7272,
 -40396,
 1647481146,
 7271,
 -1,
 1647532171,
 7270,
 1647771647,
 1647329415,
 -1,
 -40393,
 1647687013,
 7282,
 -40392,
 1647747049,
 7279,
 -40391,
 1647806687,
 7281,
 -1,
 1647851324,
 7280,
 1648058952,
 1645492632,
 -1,
 1648124478,
 1648018132,
 -1,
 -40387,
 1648091535,
 7250,
 -1,
 1648123990,
 7251,
 1648321089,
 1648080671,
 -1,
 -40384,
 1648258798,
 7254,
 -1,
 1648315522,
 7255,
 1648517700,
 1648250454,
 -1,
 -40381,
 1648466928,
 7252,
 -1,
 1648520823,
 7253,
 -40379,
 1648486293,
 7248,
 -40378,
 1648661951,
 7249,
 -40377,
 1648725180,
 7257,
 -1,
 1648772407,
 7256,
 1648976461,
 1648009193,
 -1,
 1649041996,
 1648939543,
 -1,
 -40373,
 1648986036,
 7294,
 -1,
 1649032502,
 7295,
 -1,
 1648974017,
 7292,
 1649304144,
 1648920497,
 -1,
 -40369,
 1649217434,
 7290,
 -1,
 1649281990,
 7288,
 -40367,
 1649257669,
 7291,
 -40366,
 1649431303,
 7289,
 -1,
 1649481996,
 7293,
 1649697485,
 1629923668,
 -1,
 1649763016,
 1649631615,
 -1,
 1649828551,
 1649730605,
 -1,
 1649894044,
 1649768922,
 -1,
 1649959518,
 1649858478,
 -1,
 1650025053,
 1649906261,
 -1,
 1650090587,
 1649977684,
 2827,
 -1,
 1650043220,
 2912,
 1650262015,
 1650029400,
 2828,
 -1,
 1650160472,
 2913,
 -1,
 1649939828,
 2869,
 1650418276,
 1649918676,
 -1,
 1650483810,
 1650377428,
 -1,
 -40351,
 1650415785,
 2848,
 -1,
 1650464116,
 2847,
 -40349,
 1650415785,
 2853,
 -1,
 1650595188,
 2852,
 1650811497,
 1650362591,
 -1,
 -40346,
 1650779178,
 2846,
 -40345,
 1650821435,
 2851,
 -40344,
 1650873092,
 2841,
 -1,
 1650922868,
 2856,
 1651139183,
 1650734624,
 -1,
 1651204717,
 1651062304,
 -1,
 -40340,
 1651136681,
 2850,
 -1,
 1651185012,
 2849,
 -40338,
 1651136681,
 2855,
 -1,
 1651316084,
 2854,
 1651532403,
 1651053940,
 2821,
 -40335,
 1651494474,
 2836,
 -40334,
 1651532159,
 2832,
 -1,
 1651578228,
 2822,
 1651794551,
 1651488543,
 -1,
 -40331,
 1651750809,
 2871,
 -40330,
 1651792041,
 2870,
 -1,
 1651840372,
 2872,
 1652056699,
 1651747156,
 -1,
 -40327,
 1652009391,
 2908,
 -40326,
 1652054185,
 2909,
 -1,
 1652102516,
 2864,
 1652318846,
 1652024302,
 -1,
 -40323,
 1652286506,
 2911,
 -1,
 1652299124,
 2863,
 1652515456,
 1652280906,
 2825,
 -1,
 1652477514,
 2826,
 1652646531,
 1652465641,
 -1,
 -40318,
 1652578473,
 2859,
 -1,
 1652626804,
 2858,
 1652843142,
 1652585304,
 -1,
 -40315,
 1652781997,
 2867,
 -1,
 1652823412,
 2866,
 1653039753,
 1652781192,
 -1,
 -40312,
 1652971689,
 2838,
 -1,
 1653020020,
 2837,
 1653236364,
 1652977449,
 -1,
 -40309,
 1653168297,
 2845,
 -1,
 1653216628,
 2844,
 1653432974,
 1653170559,
 2823,
 -1,
 1653367167,
 2824,
 1653564049,
 1653363427,
 -1,
 -40304,
 1653495977,
 2840,
 -1,
 1653544308,
 2839,
 1653760660,
 1653484766,
 -1,
 -40301,
 1653692585,
 2843,
 -1,
 1653740916,
 2842,
 1653957271,
 1653679734,
 -1,
 -40298,
 1653889193,
 2861,
 -1,
 1653937524,
 2860,
 -40296,
 1653923120,
 2929,
 -40295,
 1654100367,
 2835,
 -40294,
 1654161458,
 2862,
 -40293,
 1654216873,
 2873,
 -1,
 1654276231,
 2831,
 1654481580,
 1649859766,
 -1,
 1654547106,
 1654447119,
 -1,
 1654612640,
 1654499668,
 2883,
 -1,
 1654565204,
 2884,
 1654783999,
 1654551384,
 2914,
 -1,
 1654682456,
 2915,
 1654874790,
 1654461812,
 -1,
 -40284,
 1654836810,
 2892,
 -40283,
 1654874495,
 2888,
 -1,
 1654920564,
 2878,
 1655136936,
 1654836810,
 2881,
 -1,
 1655098954,
 2882,
 1655268010,
 1655071103,
 2879,
 -1,
 1655202175,
 2880,
 -40277,
 1655214479,
 2891,
 -1,
 1655324807,
 2887,
 1655530170,
 1654405528,
 -1,
 1655595696,
 1655489236,
 -1,
 -40273,
 1655562639,
 2920,
 -1,
 1655595094,
 2921,
 1655792307,
 1655551775,
 -1,
 -40270,
 1655729902,
 2924,
 -1,
 1655786626,
 2925,
 1655988918,
 1655721558,
 -1,
 -40267,
 1655938032,
 2922,
 -1,
 1655991927,
 2923,
 -40265,
 1655957397,
 2918,
 -40264,
 1656133055,
 2919,
 -40263,
 1656196284,
 2927,
 -1,
 1656243511,
 2926,
 1656447683,
 1655487536,
 -1,
 1656513214,
 1656413029,
 -1,
 -40259,
 1656469541,
 2819,
 -1,
 1656531597,
 2893,
 1656709825,
 1656427892,
 -1,
 -40256,
 1656674245,
 2877,
 -1,
 1656721605,
 2818,
 -40254,
 1656655925,
 2876,
 -1,
 1656827316,
 2817,
 1657037510,
 1656362356,
 -1,
 -40251,
 1656999503,
 2903,
 -1,
 1657037205,
 2902,
 -1,
 1656974682,
 2928,
 -1,
 1649759635,
 8886,
 1657365195,
 1649707478,
 -1,
 -40246,
 1657319304,
 64831,
 -1,
 1657370460,
 64830,
 -40244,
 1657325316,
 9766,
 -1,
 1657474332,
 10183,
 1657692926,
 1649655396,
 -1,
 1657758448,
 1657633242,
 -1,
 1657823954,
 1657673076,
 66710,
 -40239,
 1657763452,
 66688,
 -1,
 1657804148,
 66715,
 1658020565,
 1657779999,
 -1,
 -40236,
 1657953647,
 66697,
 -1,
 1658000756,
 66696,
 1658217175,
 1657966991,
 66713,
 -1,
 1658163599,
 66717,
 1658348250,
 1658155144,
 -1,
 -40231,
 1658280105,
 66693,
 -1,
 1658328576,
 66703,
 1658544860,
 1658273927,
 66711,
 -1,
 1658470535,
 66716,
 1658675935,
 1658467872,
 -1,
 -40226,
 1658607785,
 66698,
 -1,
 1658667832,
 66694,
 -40224,
 1658643498,
 66709,
 -40223,
 1658839844,
 66692,
 -40222,
 1658904111,
 66707,
 -40221,
 1658965578,
 66714,
 -40220,
 1659028245,
 66690,
 -40219,
 1659087279,
 66695,
 -40218,
 1659152205,
 66702,
 -40217,
 1659212020,
 66706,
 -40216,
 1659274548,
 66705,
 -40215,
 1659335656,
 66704,
 -40214,
 1659399979,
 66691,
 -40213,
 1659462015,
 66712,
 -40212,
 1659525289,
 66708,
 -40211,
 1659589380,
 66700,
 -40210,
 1659653823,
 66701,
 -40209,
 1659711069,
 66699,
 -1,
 1659774632,
 66689,
 1660026879,
 1657682328,
 -1,
 1660052212,
 1659945684,
 -1,
 -40205,
 1660019087,
 66722,
 -1,
 1660051542,
 66723,
 1660248823,
 1660008223,
 -1,
 -40202,
 1660186350,
 66726,
 -1,
 1660243074,
 66727,
 1660445434,
 1660178006,
 -1,
 -40199,
 1660394480,
 66724,
 -1,
 1660448375,
 66725,
 -40197,
 1660413845,
 66720,
 -40196,
 1660589503,
 66721,
 -40195,
 1660652732,
 66729,
 -1,
 1660699959,
 66728,
 1660904230,
 1657623267,
 -1,
 1660969765,
 1660836332,
 -1,
 1661035298,
 1660910042,
 -1,
 1661100805,
 1660997194,
 -1,
 -40189,
 1661053268,
 5778,
 -40188,
 1661101644,
 5783,
 -1,
 1661150394,
 5766,
 1661362953,
 1661026570,
 -1,
 -40185,
 1661305991,
 5785,
 -40184,
 1661352057,
 5779,
 -1,
 1661413697,
 5781,
 1661625100,
 1661318943,
 -1,
 -40181,
 1661586075,
 5774,
 -1,
 1661606206,
 5764,
 1661821711,
 1661571471,
 -1,
 -40178,
 1661774164,
 5782,
 -1,
 1661832570,
 5777,
 1662018322,
 1661765855,
 -1,
 -40175,
 1661954968,
 5765,
 -1,
 1662014509,
 5773,
 1662214933,
 1661952383,
 -1,
 -40172,
 1662161583,
 5780,
 -1,
 1662210086,
 5784,
 1662411544,
 1662135518,
 -1,
 -40169,
 1662358665,
 5769,
 -1,
 1662403977,
 5770,
 -40167,
 1662372020,
 5768,
 -40166,
 1662563975,
 5775,
 -40165,
 1662624252,
 5786,
 -40164,
 1662683071,
 5771,
 -40163,
 1662746431,
 5762,
 -40162,
 1662801508,
 5772,
 -40161,
 1662865193,
 5763,
 -40160,
 1662924487,
 5767,
 -40159,
 1662986301,
 5761,
 -1,
 1663048040,
 5776,
 -40157,
 1660993267,
 5760,
 -40156,
 1663217007,
 5788,
 -1,
 1663258415,
 5787,
 -1,
 1660917262,
 731,
 1663525689,
 1660854249,
 -1,
 1663591223,
 1663452913,
 -1,
 1663656754,
 1663500288,
 -1,
 1663722286,
 1663577829,
 -1,
 -40149,
 1663681682,
 10044,
 -40148,
 1663710249,
 10011,
 -40147,
 1663773268,
 10027,
 -1,
 1663837188,
 10034,
 1664049969,
 1663680888,
 -1,
 -40144,
 1664000742,
 10180,
 -1,
 1664035854,
 10179,
 -1,
 1663970139,
 9251,
 1664352255,
 1663569619,
 -1,
 1664377654,
 1664233637,
 -1,
 -40139,
 1664316309,
 9104,
 -1,
 1664374935,
 9103,
 -1,
 1664326882,
 10174,
 -40136,
 1663551678,
 8997,
 -1,
 1664591190,
 9741,
 1664770888,
 1663447986,
 -1,
 1664836414,
 1664689782,
 -1,
 -40132,
 1664789151,
 9286,
 -40131,
 1664851714,
 9285,
 -1,
 1664894493,
 9284,
 1665098561,
 1664759328,
 -1,
 -40128,
 1665047379,
 9290,
 -1,
 1665082196,
 9288,
 1665295172,
 1665019102,
 -1,
 -40125,
 1665259238,
 9289,
 -1,
 1665292646,
 9281,
 -40123,
 1665231661,
 9283,
 -40122,
 1665425056,
 9280,
 -40121,
 1665487259,
 9282,
 -1,
 1665539332,
 9287,
 1665753935,
 1664732746,
 -1,
 1665819470,
 1665714462,
 -1,
 -40117,
 1665785603,
 9885,
 -40116,
 1665824247,
 10015,
 -40115,
 1665882029,
 10009,
 -1,
 1665935956,
 10029,
 -1,
 1665763879,
 8485,
 1666212692,
 1665672822,
 -1,
 1666278227,
 1666153338,
 -1,
 -40110,
 1666241284,
 10662,
 -1,
 1666268719,
 10663,
 -1,
 1666215760,
 65532,
 1666540375,
 1666157322,
 -1,
 -40106,
 1666489992,
 11819,
 -1,
 1666545263,
 8228,
 -40104,
 1666505173,
 8254,
 -1,
 1666670150,
 8486,
 1666868589,
 1629858132,
 -1,
 1666933809,
 1666802047,
 -1,
 1666999335,
 1666864350,
 -1,
 1667064760,
 1666908160,
 -1,
 1667130223,
 1667020575,
 -1,
 1667195753,
 1667082296,
 93,
 1667301375,
 1667104768,
 -1,
 1667326822,
 1667227506,
 -1,
 1667392356,
 1667286985,
 -1,
 -40093,
 1667353096,
 10640,
 -1,
 1667377888,
 10638,
 -40091,
 1667355223,
 10636,
 -1,
 1667541220,
 8262,
 -40089,
 1667290208,
 9124,
 -40088,
 1667661409,
 9126,
 -1,
 1667714607,
 9125,
 1667916652,
 1667129727,
 -1,
 -40085,
 1667861540,
 8217,
 -1,
 1667905582,
 11815,
 -40083,
 1667878860,
 11779,
 -40082,
 1668040347,
 8908,
 -1,
 1668092197,
 10182,
 1668309887,
 1667044724,
 -1,
 1668375418,
 1668254719,
 8735,
 1668481023,
 1668284416,
 -1,
 1668506485,
 1668407154,
 -1,
 -40076,
 1668431779,
 9084,
 -1,
 1668489501,
 8894,
 1668703095,
 1668426598,
 12297,
 -1,
 1668615415,
 10642,
 -40072,
 1668667544,
 10652,
 -40071,
 1668792710,
 11776,
 -1,
 1668824102,
 11777,
 1669070847,
 1668327764,
 -1,
 1669096318,
 1668986145,
 -1,
 -40067,
 1669053922,
 8692,
 -1,
 1669083268,
 10228,
 -1,
 1669016831,
 10644,
 1669358473,
 1668275464,
 -1,
 1669424008,
 1669291483,
 -1,
 1669489540,
 1669344478,
 -1,
 -40061,
 1669453299,
 10628,
 -1,
 1669503346,
 12303,
 -40059,
 1669450349,
 12313,
 -40058,
 1669644126,
 12315,
 -40057,
 1669701926,
 10630,
 -1,
 1669757198,
 12311,
 -1,
 1669358788,
 10713,
 1670013842,
 1669282500,
 -1,
 1670079377,
 1669975849,
 -1,
 1670144910,
 1669993844,
 -1,
 -40051,
 1670100427,
 10608,
 -1,
 1670155287,
 12299,
 -40049,
 1670111046,
 10715,
 -40048,
 1670293795,
 8221,
 -1,
 1670357286,
 11817,
 -1,
 1670040626,
 11781,
 1670603674,
 1669934302,
 -1,
 1670669208,
 1670567411,
 125,
 1670774783,
 1670578176,
 -1,
 -40042,
 1670698114,
 9131,
 -40041,
 1670743287,
 9132,
 -1,
 1670807186,
 9133,
 -40039,
 1670617458,
 12301,
 -1,
 1670923650,
 8969,
 1671127969,
 1670562516,
 -1,
 1671193503,
 1671080276,
 -1,
 1671259038,
 1671127668,
 8895,
 -1,
 1671168012,
 10702,
 -1,
 1671176003,
 11786,
 -40032,
 1671141851,
 12309,
 -1,
 1671370603,
 8866,
 1671586726,
 1671078182,
 41,
 1671692287,
 1671495680,
 -1,
 -40028,
 1671615618,
 9118,
 -40027,
 1671659154,
 9120,
 -1,
 1671712303,
 9119,
 1671914409,
 1671551569,
 -1,
 -40024,
 1671864270,
 9145,
 -1,
 1671897222,
 11809,
 1672111020,
 1671860623,
 -1,
 -40021,
 1672075059,
 10198,
 -1,
 1672121106,
 9621,
 1672307631,
 1672042902,
 -1,
 -40018,
 1672254069,
 9616,
 -1,
 1672288111,
 9687,
 1672504242,
 1672236630,
 -1,
 -40015,
 1672445331,
 8971,
 -1,
 1672506637,
 10621,
 1672700853,
 1672423932,
 -1,
 -40012,
 1672661613,
 10648,
 -1,
 1672706318,
 12305,
 -40010,
 1672653393,
 11789,
 -40009,
 1672842720,
 8906,
 -1,
 1672904241,
 11805,
 1673094168,
 1667030362,
 -1,
 1673159648,
 1673011810,
 8594,
 1673225183,
 1673068544,
 -1,
 1673290701,
 1673191282,
 -1,
 1673356228,
 1673249492,
 -1,
 1673421761,
 1673271614,
 8611,
 1673527295,
 1673333795,
 -1,
 -40000,
 1673452311,
 10516,
 -1,
 1673477557,
 10517,
 1673723903,
 1673358269,
 -1,
 -39997,
 1673647401,
 11023,
 -1,
 1673674544,
 11022,
 1673880519,
 1673280196,
 -1,
 -39994,
 1673842562,
 8699,
 -1,
 1673907240,
 10513,
 -39992,
 1673845527,
 8696,
 -39991,
 1674035456,
 8603,
 -39990,
 1674093649,
 10565,
 -39989,
 1674149262,
 8620,
 -39988,
 1674206880,
 8618,
 -1,
 1674261346,
 8628,
 1674470357,
 1673249492,
 -1,
 1674535890,
 1674404058,
 -1,
 -39984,
 1674502916,
 10567,
 -39983,
 1674560009,
 11076,
 -1,
 1674598135,
 11075,
 1674838015,
 1674482074,
 -1,
 -39980,
 1674736667,
 10526,
 -1,
 1674780764,
 8677,
 1674994652,
 1674385019,
 -1,
 1675060185,
 1674947894,
 -1,
 -39976,
 1675020313,
 11084,
 -1,
 1675041825,
 11080,
 -39974,
 1675020313,
 10612,
 -39973,
 1675213676,
 10562,
 -1,
 1675238433,
 10613,
 1675453406,
 1674924623,
 8614,
 -1,
 1675365283,
 10528,
 -1,
 1675402683,
 8644,
 -1,
 1673138546,
 10522,
 1675715572,
 1673091770,
 -1,
 1675781107,
 1675681670,
 -1,
 1675846636,
 1675744004,
 -1,
 1675912171,
 1675755520,
 -1,
 1675977705,
 1675826811,
 -1,
 1676043240,
 1675916120,
 -1,
 -39961,
 1675990556,
 10604,
 -1,
 1676035188,
 10600,
 -1,
 1675997417,
 10596,
 -39958,
 1675938105,
 10579,
 -1,
 1676235343,
 10587,
 -1,
 1675877716,
 8640,
 1676541951,
 1675771439,
 -1,
 1676567538,
 1676410880,
 -1,
 -39953,
 1676527929,
 10583,
 -39952,
 1676563023,
 10591,
 -39951,
 1676617824,
 10605,
 -1,
 1676678823,
 10601,
 -1,
 1676533076,
 8641,
 -1,
 1675730384,
 8652,
 1677026309,
 1675674324,
 -1,
 1677091842,
 1676992911,
 -1,
 1677157377,
 1677004716,
 -1,
 1677222912,
 1677075048,
 -1,
 1677288447,
 1677188978,
 -1,
 1677353981,
 1677247363,
 10518,
 1677459455,
 1677265955,
 -1,
 -39940,
 1677384471,
 10519,
 -1,
 1677409717,
 10520,
 -39938,
 1677318935,
 10496,
 -1,
 1677540789,
 10497,
 -1,
 1677218383,
 10501,
 -1,
 1677183859,
 10512,
 -1,
 1677067348,
 8608,
 1677983743,
 1677046306,
 -1,
 -39932,
 1677866766,
 10511,
 -1,
 1677927010,
 8667,
 1678140432,
 1676949024,
 -1,
 1678205967,
 1678089012,
 -1,
 1678271502,
 1678123618,
 8658,
 1678337037,
 1678180352,
 -1,
 1678402572,
 1678303090,
 -1,
 -39925,
 1678367511,
 10499,
 -1,
 1678426368,
 8655,
 -1,
 1678332495,
 10503,
 -1,
 1678250354,
 10524,
 -1,
 1678194446,
 10509,
 -1,
 1678123909,
 8674,
 1678861332,
 1678105864,
 -1,
 1678926867,
 1678794209,
 8680,
 -1,
 1678836697,
 8688,
 -1,
 1678845428,
 8605,
 -39915,
 1678819216,
 8669,
 -39914,
 1679075299,
 11078,
 -39913,
 1679138952,
 8649,
 -1,
 1679202136,
 8702,
 1679385638,
 1673006803,
 -1,
 1679451165,
 1679346033,
 -1,
 -39909,
 1679400676,
 8238,
 -39908,
 1679458906,
 8207,
 -1,
 1679509082,
 8235,
 1679713313,
 1679402221,
 -1,
 -39905,
 1679637624,
 187,
 -39904,
 1679701473,
 10749,
 -1,
 1679761083,
 9002,
 1679975460,
 1679669023,
 -1,
 -39901,
 1679909740,
 10552,
 -1,
 1679972568,
 10153,
 1680211967,
 1679904456,
 4053,
 -1,
 1680084269,
 4055,
 -1,
 1679317558,
 10813,
 1680368685,
 1666943930,
 -1,
 -39895,
 1680319680,
 11824,
 -39894,
 1680381824,
 8728,
 -39893,
 1680435049,
 8790,
 -39892,
 1680492807,
 8791,
 -1,
 1680545397,
 730,
 1680761904,
 1680325773,
 -1,
 -39889,
 1680719580,
 10544,
 -1,
 1680756460,
 10539,
 -1,
 1680677394,
 65020,
 1681024197,
 1666895434,
 -1,
 1681089681,
 1680968839,
 -1,
 1681155211,
 1681029594,
 -1,
 1681220674,
 1681110815,
 -1,
 1681286207,
 1681154016,
 -1,
 -39881,
 1681254034,
 5863,
 -39880,
 1681313348,
 5840,
 -39879,
 1681374854,
 5836,
 -39878,
 1681431077,
 5805,
 -39877,
 1681492457,
 5823,
 -39876,
 1681555553,
 5849,
 -39875,
 1681611018,
 5821,
 -39874,
 1681664462,
 5843,
 -1,
 1681727583,
 5830,
 -39872,
 1681245184,
 5861,
 -39871,
 1681891235,
 5834,
 -1,
 1681941672,
 5835,
 1682138184,
 1681166735,
 5806,
 -39868,
 1682097721,
 5855,
 -39867,
 1682159466,
 5801,
 -39866,
 1682219556,
 5845,
 -39865,
 1682278623,
 5808,
 -1,
 1682325639,
 5807,
 1682531408,
 1682076504,
 -1,
 1682596943,
 1682478657,
 -1,
 -39861,
 1682564754,
 5862,
 -39860,
 1682610725,
 5804,
 -39859,
 1682669665,
 5848,
 -39858,
 1682725130,
 5820,
 -1,
 1682776164,
 5829,
 -1,
 1682515361,
 5850,
 1683055703,
 1682465151,
 -1,
 1683121235,
 1683000247,
 5853,
 -1,
 1683086918,
 5852,
 -39852,
 1683086922,
 5831,
 -39851,
 1683208265,
 5825,
 -39850,
 1683265526,
 5857,
 -1,
 1683304122,
 5864,
 1683514460,
 1682980999,
 5826,
 -39847,
 1683473935,
 5799,
 -39846,
 1683524535,
 5814,
 -39845,
 1683579222,
 5846,
 -1,
 1683628124,
 5856,
 1683842146,
 1683437088,
 5841,
 1683907681,
 1683790611,
 -1,
 -39841,
 1683857385,
 5844,
 -39840,
 1683917023,
 5824,
 -1,
 1683977048,
 5851,
 -1,
 1683822751,
 5854,
 1684235368,
 1683762398,
 5837,
 1684300902,
 1684160647,
 -1,
 -39835,
 1684244703,
 5811,
 -1,
 1684282011,
 5860,
 -39833,
 1684266597,
 5858,
 -1,
 1684413083,
 5859,
 1684628589,
 1684165347,
 5813,
 1684694124,
 1684553863,
 -1,
 -39829,
 1684646228,
 5828,
 -1,
 1684679331,
 5815,
 -1,
 1684611164,
 5816,
 1684956274,
 1684542836,
 -1,
 -39825,
 1684901638,
 5800,
 -39824,
 1684961875,
 5833,
 -39823,
 1685015137,
 5803,
 -1,
 1685073120,
 5802,
 1685283956,
 1684923374,
 5796,
 -1,
 1685236052,
 5795,
 1685415030,
 1685249288,
 5797,
 -1,
 1685377735,
 5817,
 1685546105,
 1685373652,
 -1,
 -39816,
 1685483223,
 5839,
 -1,
 1685545267,
 5798,
 1685742716,
 1685483910,
 -1,
 -39813,
 1685656948,
 5810,
 -1,
 1685718240,
 5812,
 1685939327,
 1685674153,
 -1,
 -39810,
 1685870034,
 5818,
 -1,
 1685931197,
 5819,
 -39808,
 1685907230,
 5838,
 -39807,
 1686102788,
 5866,
 -39806,
 1686165422,
 5793,
 -39805,
 1686230625,
 5794,
 -39804,
 1686284853,
 5809,
 -39803,
 1686349636,
 5865,
 -39802,
 1686414103,
 5832,
 -39801,
 1686473200,
 5822,
 -39800,
 1686536744,
 5847,
 -39799,
 1686597579,
 5827,
 -39798,
 1686654844,
 5792,
 -1,
 1686710427,
 5842,
 -39796,
 1681116483,
 5871,
 -39795,
 1686879430,
 5867,
 -39794,
 1686931429,
 5868,
 -39793,
 1686975535,
 5869,
 -39792,
 1687038019,
 5872,
 -1,
 1687101966,
 5870,
 1687315651,
 1681032340,
 -1,
 1687381168,
 1687261247,
 -1,
 1687446683,
 1687339732,
 -1,
 1687512215,
 1687411976,
 -1,
 -39786,
 1687458206,
 69235,
 -1,
 1687504975,
 69226,
 1687708826,
 1687443595,
 -1,
 -39783,
 1687661657,
 69236,
 -1,
 1687710934,
 69227,
 -1,
 1687635697,
 69225,
 1687970978,
 1687402271,
 -1,
 1688036511,
 1687908078,
 -1,
 -39778,
 1687997993,
 69230,
 -1,
 1688011878,
 69239,
 1688272895,
 1687964802,
 -1,
 -39775,
 1688194601,
 69231,
 -1,
 1688208486,
 69240,
 1688429737,
 1687899734,
 -1,
 1688495270,
 1688375695,
 -1,
 -39771,
 1688458637,
 69237,
 -1,
 1688516198,
 69228,
 1688731647,
 1688428927,
 -1,
 -39768,
 1688656148,
 69238,
 -1,
 1688687294,
 69229,
 1688888492,
 1688374460,
 -1,
 -39765,
 1688849961,
 69233,
 -1,
 1688863846,
 69242,
 1689085103,
 1688814903,
 -1,
 -39762,
 1689052142,
 69232,
 -1,
 1689060454,
 69241,
 -1,
 1689032170,
 69234,
 1689347261,
 1687304600,
 -1,
 1689412788,
 1689305812,
 -1,
 -39757,
 1689379215,
 69217,
 -1,
 1689411670,
 69218,
 1689609399,
 1689368351,
 -1,
 -39754,
 1689546478,
 69221,
 -1,
 1689603202,
 69222,
 1689806010,
 1689538134,
 -1,
 -39751,
 1689754608,
 69219,
 -1,
 1689808503,
 69220,
 -39749,
 1689753023,
 69216,
 -39748,
 1689947324,
 69224,
 -1,
 1689994551,
 69223,
 1690238975,
 1689276963,
 -1,
 1690264770,
 1690146243,
 -1,
 -39744,
 1690224319,
 69245,
 -39743,
 1690282069,
 69244,
 -1,
 1690327435,
 69243,
 -1,
 1690226175,
 69246,
 -39740,
 1687265756,
 8360,
 -1,
 1690531428,
 10740,
 1690723626,
 1680949383,
 -1,
 1690789109,
 1690660654,
 -1,
 1690854627,
 1690728922,
 -1,
 1690920145,
 1690798303,
 -1,
 1690985676,
 1690887150,
 -1,
 -39733,
 1690922795,
 43333,
 -1,
 1690965364,
 43323,
 1691182287,
 1690915555,
 -1,
 -39730,
 1691112196,
 43331,
 -1,
 1691161972,
 43314,
 -39728,
 1691104907,
 43332,
 -1,
 1691293044,
 43317,
 1691509972,
 1690861541,
 -1,
 -39725,
 1691428520,
 43330,
 -1,
 1691489652,
 43320,
 -39723,
 1691477034,
 43327,
 -39722,
 1691671856,
 43328,
 -39721,
 1691730709,
 43315,
 -39720,
 1691793305,
 43324,
 -39719,
 1691855279,
 43325,
 -39718,
 1691918414,
 43318,
 -39717,
 1691972525,
 43326,
 -39716,
 1692037279,
 43312,
 -39715,
 1692102443,
 43322,
 -39714,
 1692162217,
 43329,
 -39713,
 1692226308,
 43313,
 -39712,
 1692284555,
 43316,
 -39711,
 1692347707,
 43321,
 -39710,
 1692411560,
 43319,
 -1,
 1692472692,
 43334,
 1692689647,
 1690818478,
 -1,
 1692755182,
 1692639030,
 -1,
 1692820712,
 1692680327,
 43337,
 -39705,
 1692782154,
 43341,
 -1,
 1692800372,
 43342,
 1693017323,
 1692734836,
 -1,
 -39702,
 1692978762,
 43340,
 -1,
 1693016447,
 43338,
 -39700,
 1692978762,
 43336,
 -39699,
 1693159823,
 43339,
 -1,
 1693213055,
 43335,
 -1,
 1692691474,
 43347,
 1693476084,
 1692611218,
 -1,
 1693541618,
 1693419743,
 43344,
 -1,
 1693471459,
 43343,
 -39693,
 1693493588,
 43345,
 -1,
 1693603979,
 43346,
 -1,
 1693432025,
 43359,
 1693869333,
 1690753535,
 -1,
 1693934860,
 1693791778,
 -1,
 1694000379,
 1693893332,
 -1,
 1694065914,
 1693935103,
 8765,
 -1,
 1693975460,
 8909,
 -1,
 1694020176,
 8247,
 1694262527,
 1693924431,
 -1,
 1694328062,
 1694213739,
 8246,
 -1,
 1694239131,
 12317,
 -1,
 1694286121,
 10989,
 1694524674,
 1694218015,
 -1,
 -39679,
 1694451328,
 8271,
 -1,
 1694506792,
 8515,
 1694721285,
 1694474217,
 -1,
 -39676,
 1694675355,
 8245,
 -1,
 1694721523,
 8267,
 1694917895,
 1694637749,
 10659,
 -1,
 1694830254,
 10661,
 -39672,
 1694872769,
 9753,
 -39671,
 1695000766,
 11822,
 -39670,
 1695059593,
 8976,
 -39669,
 1695109536,
 11793,
 -1,
 1695172320,
 10672,
 1695416319,
 1693843456,
 -1,
 1695442194,
 1695334041,
 92,
 1695547391,
 1695350784,
 -1,
 -39664,
 1695473715,
 10743,
 -39663,
 1695524382,
 10184,
 -1,
 1695586176,
 10741,
 1695809535,
 1695402024,
 -1,
 -39660,
 1695723679,
 11079,
 -1,
 1695774793,
 11073,
 1695966497,
 1693791771,
 -1,
 1696032032,
 1695901920,
 -1,
 1696097567,
 1695993406,
 -1,
 -39655,
 1696011491,
 9849,
 -39654,
 1696076946,
 9848,
 -39653,
 1696142404,
 9847,
 -39652,
 1696207835,
 9846,
 -39651,
 1696273280,
 9845,
 -39650,
 1696338645,
 9844,
 -1,
 1696404060,
 9843,
 -1,
 1696027729,
 9850,
 -1,
 1695957691,
 9852,
 1696752934,
 1695921951,
 -1,
 1696818469,
 1696713541,
 -1,
 -39644,
 1696731815,
 9953,
 -1,
 1696797199,
 9952,
 -1,
 1696769355,
 8479,
 -39641,
 1696713952,
 9166,
 -39640,
 1697031160,
 65533,
 -39639,
 1697076653,
 174,
 -1,
 1697140650,
 8251,
 1697342818,
 1690669455,
 -1,
 1697408350,
 1697284602,
 -1,
 1697473870,
 1697353834,
 -1,
 1697539384,
 1697402454,
 -1,
 1697604919,
 1697472895,
 -1,
 1697670451,
 1697569012,
 8548,
 1697775615,
 1697579008,
 -1,
 -39630,
 1697695517,
 8577,
 -1,
 1697734935,
 8558,
 1697972223,
 1697600190,
 8556,
 1698037759,
 1697841152,
 -1,
 -39626,
 1697957661,
 8583,
 -1,
 1697988953,
 8582,
 -1,
 1697553392,
 8547,
 1698260287,
 1697497812,
 -1,
 1698325820,
 1698225416,
 -1,
 -39621,
 1698271631,
 8545,
 -1,
 1698317869,
 8555,
 1698522430,
 1698252529,
 8553,
 -1,
 1698433745,
 8578,
 -1,
 1698455638,
 8546,
 1698719045,
 1698207167,
 8544,
 1698824191,
 1698627584,
 -1,
 1698850115,
 1698744093,
 8559,
 -1,
 1698759274,
 8576,
 1699020799,
 1698783511,
 8557,
 -1,
 1698892497,
 8584,
 1699112265,
 1698674463,
 -1,
 1699177800,
 1699049198,
 8549,
 -1,
 1699087710,
 8581,
 -1,
 1699105922,
 8550,
 1699374412,
 1699037319,
 -1,
 -39605,
 1699314208,
 8554,
 -1,
 1699374307,
 8551,
 -39603,
 1699327376,
 8579,
 -1,
 1699515580,
 8552,
 1699702102,
 1697429279,
 -1,
 1699767637,
 1699627143,
 -1,
 1699833171,
 1699734467,
 -1,
 -39598,
 1699795129,
 65939,
 -1,
 1699815169,
 65936,
 -39596,
 1699790997,
 65944,
 -1,
 1699973190,
 65938,
 -1,
 1699702325,
 65941,
 1700226394,
 1699624480,
 -1,
 -39592,
 1700189259,
 65945,
 -39591,
 1700226759,
 65940,
 -1,
 1700284206,
 65942,
 -39589,
 1700188684,
 65937,
 -39588,
 1700440298,
 65943,
 -39587,
 1700474626,
 65947,
 -1,
 1700537134,
 65946,
 1700790271,
 1697367113,
 -1,
 -39584,
 1700682710,
 10085,
 -39583,
 1700745545,
 10087,
 -1,
 1700802068,
 8506,
 1701052415,
 1697256820,
 -1,
 1701078377,
 1700946303,
 -1,
 1701143912,
 1701034227,
 -1,
 -39578,
 1701101399,
 11787,
 -39577,
 1701145085,
 11782,
 -1,
 1701198831,
 11783,
 -1,
 1701087455,
 9926,
 1701471596,
 1701001355,
 -1,
 -39573,
 1701417434,
 9762,
 -1,
 1701457234,
 9143,
 -1,
 1701431482,
 8758,
 1701734253,
 1666818025,
 -1,
 1701799476,
 1701647732,
 -1,
 1701865006,
 1701751124,
 -1,
 1701930527,
 1701791755,
 -1,
 1701995944,
 1701868995,
 -1,
 1702061453,
 1701953034,
 -1,
 -39564,
 1702029086,
 9397,
 -39563,
 1702093806,
 9396,
 -39562,
 1702159108,
 9395,
 -39561,
 1702223112,
 9394,
 -39560,
 1702287278,
 9393,
 -39559,
 1702350410,
 9392,
 -39558,
 1702413012,
 9391,
 -39557,
 1702475551,
 9390,
 -39556,
 1702537556,
 9389,
 -39555,
 1702602564,
 9388,
 -39554,
 1702666217,
 9387,
 -39553,
 1702728079,
 9386,
 -39552,
 1702791391,
 9385,
 -39551,
 1702854629,
 9384,
 -39550,
 1702916952,
 9383,
 -39549,
 1702981768,
 9382,
 -39548,
 1703046953,
 9381,
 -39547,
 1703108991,
 9380,
 -39546,
 1703172235,
 9379,
 -39545,
 1703236323,
 9378,
 -39544,
 1703300694,
 9377,
 -39543,
 1703362695,
 9376,
 -39542,
 1703425568,
 9375,
 -39541,
 1703488734,
 9374,
 -39540,
 1703552630,
 9373,
 -1,
 1703613812,
 9372,
 1703870463,
 1701981700,
 -1,
 -39537,
 1703798558,
 127273,
 -39536,
 1703863278,
 127272,
 -39535,
 1703928580,
 127271,
 -39534,
 1703992584,
 127270,
 -39533,
 1704056750,
 127269,
 -39532,
 1704119882,
 127268,
 -39531,
 1704182484,
 127267,
 -39530,
 1704245023,
 127266,
 -39529,
 1704307028,
 127265,
 -39528,
 1704372036,
 127264,
 -39527,
 1704435689,
 127263,
 -39526,
 1704497551,
 127262,
 -39525,
 1704560863,
 127261,
 -39524,
 1704624101,
 127260,
 -39523,
 1704686424,
 127259,
 -39522,
 1704751240,
 127258,
 -39521,
 1704816425,
 127257,
 -39520,
 1704878463,
 127256,
 -39519,
 1704941707,
 127255,
 -39518,
 1705005795,
 127254,
 -39517,
 1705070166,
 127253,
 -39516,
 1705132167,
 127252,
 -39515,
 1705195040,
 127251,
 -39514,
 1705258206,
 127250,
 -39513,
 1705322102,
 127249,
 -1,
 1705383284,
 127248,
 1705600475,
 1701929911,
 -1,
 1705665974,
 1705555743,
 -1,
 1705731501,
 1705627210,
 -1,
 -39508,
 1705681703,
 12860,
 -1,
 1705740511,
 12848,
 1705928112,
 1705689812,
 -1,
 -39505,
 1705889802,
 12859,
 -1,
 1705939573,
 12849,
 1706124723,
 1705853063,
 -1,
 -39502,
 1706088835,
 12838,
 -1,
 1706129974,
 12866,
 -39500,
 1706074558,
 12853,
 -39499,
 1706267246,
 12851,
 -1,
 1706323694,
 12837,
 1706517949,
 1705594454,
 -1,
 1706583483,
 1706451327,
 -1,
 -39495,
 1706547444,
 12836,
 -39494,
 1706601348,
 12843,
 -1,
 1706658190,
 12854,
 -39492,
 1706531824,
 12835,
 -1,
 1706773301,
 12864,
 1706976707,
 1706470276,
 -1,
 1707042241,
 1706931999,
 -1,
 -39488,
 1707000532,
 12865,
 -1,
 1707056239,
 12862,
 -39486,
 1706993238,
 12857,
 -1,
 1707153239,
 12867,
 1707369927,
 1706934996,
 -1,
 -39483,
 1707336079,
 12833,
 -39482,
 1707368534,
 12834,
 -1,
 1707427569,
 12841,
 1707632075,
 1707294855,
 -1,
 -39479,
 1707577223,
 12861,
 -39478,
 1707631843,
 12839,
 -1,
 1707680460,
 12847,
 1707894222,
 1707597064,
 -1,
 -39475,
 1707841178,
 12845,
 -1,
 1707877546,
 12844,
 1708090833,
 1707837663,
 -1,
 -39472,
 1708025954,
 12840,
 -1,
 1708072131,
 12852,
 1708287444,
 1708031973,
 -1,
 -39469,
 1708234409,
 12842,
 -1,
 1708280688,
 12846,
 1708484055,
 1708207326,
 -1,
 -39466,
 1708430930,
 12855,
 -1,
 1708465060,
 12858,
 -39464,
 1708430783,
 12832,
 -39463,
 1708618747,
 12856,
 -39462,
 1708677901,
 12850,
 -1,
 1708727281,
 12863,
 1708942846,
 1705531986,
 -1,
 1709008355,
 1708862686,
 -1,
 1709073889,
 1708942395,
 12808,
 1709178879,
 1708982272,
 -1,
 -39456,
 1709100618,
 12828,
 -1,
 1709118836,
 12822,
 1709375487,
 1709006023,
 12809,
 -1,
 1709244418,
 12823,
 1709467112,
 1708966612,
 -1,
 1709532646,
 1709401525,
 12802,
 -1,
 1709441026,
 12816,
 1709703167,
 1709464802,
 12811,
 -1,
 1709572098,
 12825,
 1709794797,
 1709416425,
 -1,
 1709860331,
 1709728838,
 12805,
 -1,
 1709768706,
 12819,
 1710030847,
 1709792475,
 12812,
 -1,
 1709899778,
 12826,
 1710122482,
 1709731976,
 -1,
 1710188016,
 1710059299,
 12800,
 -1,
 1710096386,
 12814,
 1710358527,
 1710120148,
 12810,
 -1,
 1710227458,
 12824,
 1710450164,
 1710079242,
 12806,
 -1,
 1710358530,
 12820,
 1710581238,
 1710403159,
 12803,
 -1,
 1710489602,
 12817,
 1710712312,
 1710525580,
 12801,
 -1,
 1710620674,
 12815,
 1710843386,
 1710654766,
 12804,
 -1,
 1710751746,
 12818,
 1710974460,
 1710777408,
 12807,
 -1,
 1710882818,
 12821,
 1711144959,
 1710906574,
 12813,
 -1,
 1711013890,
 12827,
 1711236623,
 1708888127,
 -1,
 1711302149,
 1711194836,
 -1,
 1711367683,
 1711267410,
 -1,
 -39422,
 1711312901,
 9351,
 -1,
 1711374222,
 9343,
 -39420,
 1711300017,
 9344,
 -1,
 1711490801,
 9341,
 1711695368,
 1711257375,
 -1,
 -39417,
 1711632128,
 9347,
 -1,
 1711688880,
 9348,
 1711891979,
 1711623766,
 -1,
 -39414,
 1711840373,
 9345,
 -1,
 1711891565,
 9346,
 1712088590,
 1711816839,
 -1,
 -39411,
 1712028192,
 9342,
 -1,
 1712088321,
 9349,
 -1,
 1712032961,
 9350,
 1712350748,
 1711159704,
 -1,
 1712416275,
 1712308948,
 -1,
 -39406,
 1712382351,
 9333,
 -1,
 1712414806,
 9334,
 1712612886,
 1712371487,
 -1,
 -39403,
 1712549614,
 9337,
 -1,
 1712606338,
 9338,
 1712809497,
 1712541270,
 -1,
 -39400,
 1712757744,
 9335,
 -1,
 1712811639,
 9336,
 -39398,
 1712756159,
 9332,
 -39397,
 1712950460,
 9340,
 -1,
 1712997687,
 9339,
 1713242111,
 1712288442,
 -1,
 -39394,
 1713139650,
 12829,
 -1,
 1713177698,
 12830,
 1713399336,
 1701844340,
 -1,
 1713464869,
 1713339507,
 -1,
 1713530404,
 1713430386,
 -1,
 -39389,
 1713489945,
 10995,
 -1,
 1713528694,
 10994,
 -1,
 1713490226,
 8741,
 1713831935,
 1713395382,
 -1,
 -39385,
 1713740288,
 11791,
 -1,
 1713768968,
 8233,
 1714028543,
 1713357524,
 -1,
 1714054700,
 1713922602,
 -1,
 -39381,
 1713995716,
 9853,
 -1,
 1714029356,
 8706,
 -39379,
 1713998734,
 12880,
 -1,
 1714159710,
 12349,
 1714382385,
 1701822463,
 -1,
 -39376,
 1714344948,
 9106,
 -1,
 1714372381,
 9105,
 1714618367,
 1714320216,
 -1,
 -39373,
 1714520049,
 11801,
 -1,
 1714582910,
 9908,
 1714775784,
 1701730443,
 -1,
 1714841280,
 1714689396,
 -1,
 1714906752,
 1714771990,
 -1,
 1714972276,
 1714846170,
 -1,
 1715037761,
 1714930388,
 -1,
 1715103292,
 1714995924,
 -1,
 -39365,
 1715034281,
 43114,
 -1,
 1715082612,
 43113,
 1715299903,
 1715058463,
 -1,
 -39362,
 1715230889,
 43089,
 -1,
 1715279220,
 43088,
 -39360,
 1715230889,
 43081,
 -1,
 1715410292,
 43080,
 1715627590,
 1714981087,
 -1,
 -39357,
 1715594282,
 43079,
 -39356,
 1715636539,
 43116,
 -39355,
 1715688196,
 43075,
 -1,
 1715737972,
 43083,
 1715955274,
 1715582751,
 -1,
 -39352,
 1715896612,
 43094,
 -39351,
 1715951785,
 43098,
 -1,
 1716000116,
 43099,
 1716217422,
 1715877408,
 -1,
 -39348,
 1716184880,
 43090,
 -39347,
 1716205195,
 43115,
 -1,
 1716262260,
 43082,
 1716479570,
 1716137182,
 -1,
 1716545105,
 1716393332,
 43076,
 -1,
 1716488953,
 43123,
 -1,
 1716476073,
 43077,
 1716741717,
 1716393332,
 43101,
 -39340,
 1716698921,
 43120,
 -1,
 1716748037,
 43117,
 1716938328,
 1716709150,
 -1,
 -39337,
 1716869289,
 43092,
 -1,
 1716917620,
 43093,
 1717134939,
 1716902946,
 -1,
 -39334,
 1717074246,
 43118,
 -1,
 1717122611,
 43119,
 1717331550,
 1717084137,
 -1,
 -39331,
 1717262505,
 43085,
 -1,
 1717310836,
 43084,
 1717528161,
 1717268616,
 -1,
 -39328,
 1717459113,
 43073,
 -1,
 1717507444,
 43072,
 1717724772,
 1717457635,
 -1,
 -39325,
 1717654276,
 43109,
 -1,
 1717704052,
 43074,
 1717921382,
 1717649543,
 43104,
 -1,
 1717846151,
 43110,
 -39321,
 1717888042,
 43095,
 -39320,
 1718018852,
 43107,
 -39319,
 1718082864,
 43091,
 -39318,
 1718144586,
 43103,
 -39317,
 1718200751,
 43096,
 -39316,
 1718265674,
 43106,
 -39315,
 1718325647,
 43105,
 -39314,
 1718386738,
 43087,
 -39313,
 1718449069,
 43097,
 -39312,
 1718513451,
 43078,
 -39311,
 1718575487,
 43102,
 -39310,
 1718638761,
 43100,
 -39309,
 1718701759,
 43108,
 -1,
 1718757032,
 43086,
 1718969980,
 1714927391,
 -1,
 1719035515,
 1718931018,
 -1,
 1719101050,
 1718954456,
 -1,
 -39304,
 1719067690,
 43112,
 -39303,
 1719131440,
 43111,
 -1,
 1719183791,
 43121,
 -1,
 1719050922,
 43122,
 -1,
 1718970622,
 43124,
 1719494271,
 1718911583,
 -1,
 -39298,
 1719450215,
 43126,
 -1,
 1719483763,
 43127,
 -1,
 1719418113,
 43125,
 1719795711,
 1714842990,
 -1,
 1719821964,
 1719676126,
 -1,
 1719887494,
 1719767439,
 -1,
 1719953029,
 1719829179,
 66020,
 -1,
 1719888198,
 66045,
 -1,
 1719893836,
 66022,
 1720149642,
 1719801204,
 -1,
 -39288,
 1720107732,
 66028,
 -39287,
 1720169784,
 66018,
 -1,
 1720231648,
 66003,
 -39285,
 1720090410,
 66012,
 -1,
 1720343924,
 66004,
 1720542868,
 1719777055,
 -1,
 1720608400,
 1720474761,
 -1,
 -39281,
 1720557545,
 66024,
 -1,
 1720600031,
 66011,
 -39279,
 1720568491,
 66042,
 -39278,
 1720746283,
 66043,
 -39277,
 1720810331,
 66021,
 -1,
 1720854037,
 66015,
 1721067163,
 1720460918,
 -1,
 1721132696,
 1721012623,
 -1,
 -39273,
 1721097480,
 66010,
 -1,
 1721144561,
 66017,
 1721329306,
 1721058087,
 66033,
 -1,
 1721261594,
 66023,
 -1,
 1721291043,
 66027,
 1721525921,
 1721016297,
 -1,
 1721591455,
 1721463640,
 -1,
 -39266,
 1721553334,
 66001,
 -1,
 1721572941,
 66034,
 -39264,
 1721516762,
 66000,
 -1,
 1721704533,
 66036,
 1721919141,
 1721483988,
 -1,
 -39261,
 1721881310,
 66032,
 -39260,
 1721918146,
 66008,
 -1,
 1721967994,
 66002,
 1722181289,
 1721849995,
 -1,
 -39257,
 1722128735,
 66025,
 -39256,
 1722180428,
 66026,
 -1,
 1722238479,
 66006,
 1722443436,
 1722146056,
 -1,
 -39253,
 1722389705,
 66005,
 -1,
 1722426892,
 66044,
 1722640047,
 1722394964,
 -1,
 -39250,
 1722587651,
 66037,
 -1,
 1722621031,
 66029,
 1722836658,
 1722581042,
 -1,
 -39247,
 1722797175,
 66014,
 -1,
 1722845530,
 66013,
 1723033269,
 1722776176,
 -1,
 -39244,
 1722974136,
 66038,
 -1,
 1723020832,
 66016,
 1723229880,
 1722962659,
 -1,
 -39241,
 1723181812,
 66041,
 -1,
 1723213248,
 66007,
 1723426491,
 1723153092,
 -1,
 -39238,
 1723390196,
 66031,
 -1,
 1723431907,
 66019,
 -39236,
 1723390895,
 66035,
 -39235,
 1723572166,
 66039,
 -39234,
 1723617646,
 66040,
 -39233,
 1723678998,
 66030,
 -1,
 1723736674,
 66009,
 1723950821,
 1714787045,
 -1,
 1724016347,
 1723890138,
 -1,
 1724081862,
 1723971359,
 -1,
 -39228,
 1724013955,
 67860,
 -39227,
 1724073658,
 67854,
 -1,
 1724127234,
 67857,
 1724344009,
 1724039892,
 -1,
 -39224,
 1724271421,
 67848,
 -1,
 1724327311,
 67861,
 1724540619,
 1724275496,
 67844,
 -1,
 1724498644,
 67847,
 1724671694,
 1724454260,
 -1,
 -39219,
 1724611126,
 67840,
 -1,
 1724671792,
 67855,
 -39217,
 1724639042,
 67846,
 -39216,
 1724835373,
 67849,
 -39215,
 1724898814,
 67845,
 -39214,
 1724953730,
 67859,
 -39213,
 1725015983,
 67858,
 -39212,
 1725079981,
 67856,
 -39211,
 1725141159,
 67853,
 -39210,
 1725203431,
 67852,
 -39209,
 1725265114,
 67851,
 -39208,
 1725329611,
 67850,
 -39207,
 1725387621,
 67842,
 -39206,
 1725446062,
 67843,
 -1,
 1725507859,
 67841,
 1725720292,
 1723961407,
 -1,
 1725785826,
 1725678292,
 -1,
 1725851360,
 1725750536,
 -1,
 -39201,
 1725796751,
 67866,
 -1,
 1725843535,
 67864,
 -39199,
 1725784150,
 67867,
 -1,
 1725974257,
 67863,
 1726218239,
 1725732287,
 67862,
 -1,
 1726088294,
 67865,
 -1,
 1725686473,
 67871,
 1726414847,
 1723885099,
 -1,
 -39193,
 1726332102,
 5941,
 -1,
 1726365024,
 5942,
 1726572338,
 1714727252,
 -1,
 1726637865,
 1726496903,
 -1,
 1726703384,
 1726592799,
 -1,
 1726768919,
 1726629847,
 -1,
 1726834427,
 1726706520,
 -1,
 1726899962,
 1726759838,
 -1,
 1726965489,
 1726865071,
 -1,
 -39184,
 1726904590,
 65047,
 -1,
 1726952275,
 65091,
 1727162100,
 1726885086,
 -1,
 -39181,
 1727124979,
 65079,
 -1,
 1727175026,
 65089,
 -39179,
 1727122029,
 65081,
 -39178,
 1727315806,
 65095,
 -39177,
 1727373606,
 65077,
 -39176,
 1727413347,
 65085,
 -39175,
 1727474204,
 65083,
 -1,
 1727536827,
 65087,
 -1,
 1726848756,
 65075,
 1727817480,
 1726787175,
 -1,
 1727883007,
 1727782575,
 -1,
 -39170,
 1727822113,
 65048,
 -1,
 1727869779,
 65092,
 1728079618,
 1727802590,
 -1,
 -39167,
 1728042483,
 65080,
 -1,
 1728092530,
 65090,
 -39165,
 1728039533,
 65082,
 -39164,
 1728233310,
 65096,
 -39163,
 1728291110,
 65078,
 -39162,
 1728330851,
 65086,
 -39161,
 1728391708,
 65084,
 -1,
 1728454331,
 65088,
 1728669452,
 1727742087,
 -1,
 -39158,
 1728635718,
 65045,
 -39157,
 1728678116,
 65074,
 -1,
 1728741377,
 65073,
 1728931599,
 1728603074,
 -1,
 -39154,
 1728860866,
 65042,
 -1,
 1728918031,
 65041,
 1729128210,
 1728852456,
 -1,
 -39151,
 1729070583,
 65040,
 -1,
 1729133842,
 65043,
 -39149,
 1729093139,
 65076,
 -39148,
 1729285478,
 65072,
 -39147,
 1729345886,
 65044,
 -39146,
 1729407166,
 65046,
 -1,
 1729453854,
 65049,
 -1,
 1726690292,
 8478,
 1729718056,
 1726623412,
 8826,
 1729822719,
 1729626112,
 -1,
 1729849123,
 1729697403,
 -1,
 1729914654,
 1729805529,
 -1,
 -39139,
 1729859173,
 10929,
 -1,
 1729907027,
 10927,
 1730111265,
 1729859142,
 -1,
 -39136,
 1730038023,
 10933,
 -1,
 1730092065,
 10937,
 -39134,
 1730038099,
 10931,
 -1,
 1730223137,
 10935,
 1730438950,
 1729796093,
 -1,
 -39131,
 1730375270,
 8830,
 -1,
 1730419237,
 8828,
 -39129,
 1730400840,
 8880,
 -1,
 1730555017,
 8936,
 -1,
 1729682356,
 9111,
 1730832175,
 1726583183,
 -1,
 1730897710,
 1730781161,
 -1,
 1730963245,
 1730845140,
 8759,
 -1,
 1730877989,
 8733,
 -1,
 1730890305,
 8522,
 -1,
 1730834295,
 8965,
 1731264511,
 1730765183,
 -1,
 -39119,
 1731170092,
 9113,
 -1,
 1731232539,
 8242,
 1731422028,
 1726509912,
 -1,
 1731487560,
 1731382858,
 -1,
 1731553095,
 1731442463,
 -1,
 1731618630,
 1731463717,
 43,
 1731723263,
 1731526656,
 -1,
 1731749697,
 1731649394,
 -1,
 1731815227,
 1731708930,
 -1,
 -39110,
 1731733587,
 10790,
 -1,
 1731794549,
 10788,
 1732011838,
 1731770143,
 -1,
 -39107,
 1731973045,
 10791,
 -1,
 1732018510,
 10786,
 -39105,
 1731935035,
 10789,
 -39104,
 1732128995,
 10787,
 -1,
 1732192863,
 10792,
 1732405061,
 1731684147,
 -1,
 -39101,
 1732365050,
 10809,
 -39100,
 1732423477,
 10798,
 -1,
 1732474639,
 10797,
 -1,
 1732318850,
 10866,
 -1,
 1731530873,
 177,
 -1,
 1731512626,
 9799,
 1732902911,
 1731401076,
 -1,
 1732929355,
 1732807232,
 8462,
 -1,
 1732839496,
 8463,
 -1,
 1732849291,
 8984,
 1733125982,
 1731346567,
 -1,
 1733191513,
 1733077332,
 -1,
 1733257042,
 1733099520,
 -1,
 -39088,
 1733215535,
 8241,
 -39087,
 1733278763,
 8524,
 -1,
 1733330245,
 8240,
 1733519189,
 1733211935,
 -1,
 -39084,
 1733468613,
 8966,
 -1,
 1733530965,
 9977,
 1733715799,
 1733468721,
 10178,
 -1,
 1733627459,
 10977,
 -39080,
 1733657095,
 9854,
 -1,
 1733766875,
 37,
 1733977948,
 1733146399,
 -1,
 -39077,
 1733923267,
 8369,
 -1,
 1733970780,
 8359,
 -39075,
 1733921339,
 9999,
 -1,
 1734088524,
 9774,
 1734305637,
 1733058943,
 -1,
 1734371169,
 1734263923,
 8916,
 -1,
 1734282871,
 10970,
 -39070,
 1734326392,
 9811,
 -39069,
 1734447406,
 10031,
 -39068,
 1734506027,
 182,
 -1,
 1734553893,
 9935,
 1734764396,
 1734250895,
 -1,
 1734829930,
 1734719263,
 -1,
 1734895465,
 1734788015,
 12306,
 -1,
 1734804407,
 12320,
 -1,
 1734831644,
 8982,
 -39061,
 1734791737,
 163,
 -1,
 1735041016,
 8236,
 -1,
 1734726179,
 8200,
 1735289057,
 1701677279,
 -1,
 1735354386,
 1735213191,
 -1,
 1735419870,
 1735318794,
 -1,
 1735485405,
 1735377779,
 -1,
 1735550900,
 1735424474,
 -1,
 1735616399,
 1735491107,
 -1,
 1735681911,
 1735574228,
 -1,
 -39051,
 1735636889,
 6539,
 -39050,
 1735678121,
 6546,
 -1,
 1735726452,
 6545,
 1735944058,
 1735648004,
 -1,
 -39047,
 1735907260,
 6569,
 -1,
 1735923060,
 6534,
 1736140669,
 1735898911,
 -1,
 -39044,
 1736101566,
 6571,
 -1,
 1736119668,
 6540,
 1736337280,
 1736089577,
 -1,
 -39041,
 1736267945,
 6552,
 -1,
 1736316276,
 6551,
 1736533891,
 1736280287,
 -1,
 -39038,
 1736463108,
 6535,
 -1,
 1736512884,
 6547,
 1736730502,
 1736470664,
 -1,
 -39035,
 1736693692,
 6568,
 -1,
 1736709492,
 6533,
 -39033,
 1736696874,
 6541,
 -39032,
 1736890300,
 6558,
 -39031,
 1736943434,
 6529,
 -39030,
 1736998962,
 6553,
 -39029,
 1737061293,
 6559,
 -39028,
 1737119913,
 6563,
 -39027,
 1737182911,
 6557,
 -39026,
 1737242251,
 6564,
 -1,
 1737303720,
 6565,
 1737516972,
 1735548143,
 -1,
 1737582484,
 1737474772,
 -1,
 -39022,
 1737537433,
 6536,
 -39021,
 1737578665,
 6543,
 -1,
 1737626996,
 6542,
 1737844631,
 1737548548,
 -1,
 -39018,
 1737807804,
 6567,
 -1,
 1737823604,
 6531,
 1738041242,
 1737799455,
 -1,
 -39015,
 1738002110,
 6570,
 -1,
 1738020212,
 6537,
 1738237853,
 1737990121,
 -1,
 -39012,
 1738168489,
 6549,
 -1,
 1738216820,
 6548,
 1738434464,
 1738180831,
 -1,
 -39009,
 1738363652,
 6532,
 -1,
 1738413428,
 6544,
 1738631075,
 1738371208,
 -1,
 -39006,
 1738594236,
 6566,
 -1,
 1738610036,
 6530,
 -39004,
 1738597418,
 6538,
 -39003,
 1738790844,
 6555,
 -39002,
 1738843978,
 6528,
 -39001,
 1738899506,
 6550,
 -39000,
 1738961837,
 6556,
 -38999,
 1739020457,
 6560,
 -38998,
 1739083455,
 6554,
 -38997,
 1739142795,
 6561,
 -1,
 1739204264,
 6562,
 1739456511,
 1737445426,
 -1,
 1739483055,
 1739360479,
 6595,
 -1,
 1739412195,
 6594,
 -38992,
 1739446190,
 6593,
 -38991,
 1739554789,
 6596,
 -38990,
 1739616392,
 6597,
 -38989,
 1739666976,
 6598,
 -1,
 1739728502,
 6599,
 1739941832,
 1735515318,
 -1,
 1740007354,
 1739902538,
 6579,
 1740072888,
 1739931783,
 6585,
 -1,
 1740039150,
 6591,
 -38983,
 1740039150,
 6588,
 -1,
 1740164682,
 6580,
 1740335038,
 1739952527,
 6583,
 1740400573,
 1740248436,
 6584,
 -1,
 1740366830,
 6590,
 -1,
 1740366830,
 6589,
 1740597187,
 1740248436,
 -1,
 1740662721,
 1740510580,
 6577,
 -1,
 1740628974,
 6587,
 -38974,
 1740628974,
 6586,
 -1,
 1740718215,
 6582,
 1740924870,
 1740530047,
 -1,
 -38971,
 1740891118,
 6592,
 -1,
 1740923263,
 6578,
 -38969,
 1740889254,
 6576,
 -1,
 1741045895,
 6581,
 1741252566,
 1739864472,
 -1,
 1741318092,
 1741210324,
 -1,
 -38965,
 1741283727,
 6610,
 -1,
 1741316182,
 6611,
 1741514703,
 1741272863,
 -1,
 -38962,
 1741450990,
 6614,
 -1,
 1741507714,
 6615,
 1741711314,
 1741442646,
 -1,
 -38959,
 1741659120,
 6612,
 -1,
 1741713015,
 6613,
 -38957,
 1741678485,
 6608,
 -38956,
 1741854143,
 6609,
 -38955,
 1741917372,
 6617,
 -1,
 1741964599,
 6616,
 1742170075,
 1741210324,
 -1,
 1742235610,
 1742116351,
 -1,
 -38951,
 1742148263,
 6601,
 -1,
 1742213647,
 6600,
 -1,
 1742166520,
 6618,
 1742536703,
 1742126148,
 6622,
 -1,
 1742460846,
 6623,
 -1,
 1735441144,
 8362,
 1742694399,
 1735349181,
 -1,
 1742759934,
 1742630523,
 -1,
 1742825461,
 1742680187,
 -1,
 1742890993,
 1742770239,
 -1,
 1742956519,
 1742848724,
 -1,
 1743022054,
 1742921298,
 -1,
 -38939,
 1742966789,
 9460,
 -1,
 1743028110,
 9452,
 -1,
 1742953905,
 9453,
 1743284202,
 1742911263,
 -1,
 -38935,
 1743220480,
 9456,
 -1,
 1743277232,
 9457,
 1743480813,
 1743212118,
 -1,
 -38932,
 1743428725,
 9454,
 -1,
 1743479917,
 9455,
 1743677424,
 1743405191,
 -1,
 -38929,
 1743616544,
 9451,
 -1,
 1743676673,
 9458,
 -1,
 1743621313,
 9459,
 1743939572,
 1742829002,
 -1,
 -38925,
 1743888361,
 127327,
 -1,
 1743935627,
 127319,
 -1,
 1743862175,
 9471,
 1744240639,
 1742782325,
 -1,
 1744267259,
 1744139722,
 -1,
 -38920,
 1744216041,
 127359,
 -38919,
 1744273381,
 127356,
 -38918,
 1744335704,
 127355,
 -1,
 1744400169,
 127353,
 -38916,
 1744222105,
 127373,
 -38915,
 1744543822,
 127372,
 -1,
 1744593645,
 127371,
 -1,
 1742684790,
 8879,
 1744857103,
 1742630377,
 -1,
 1744922629,
 1744796055,
 -1,
 1744988164,
 1744849142,
 -1,
 -38909,
 1744924262,
 8820,
 -1,
 1744968229,
 8816,
 -1,
 1744918263,
 8824,
 1745250314,
 1744852831,
 -1,
 1745315849,
 1745176822,
 -1,
 -38904,
 1745251942,
 8821,
 -1,
 1745295909,
 8817,
 -1,
 1745254735,
 8825,
 1745616895,
 1745163636,
 -1,
 1745643534,
 1745488528,
 -1,
 -38899,
 1745593079,
 8841,
 -1,
 1745628187,
 8840,
 -1,
 1745593787,
 8775,
 -38896,
 1744823238,
 9112,
 -38895,
 1745868590,
 9906,
 -1,
 1745921766,
 9798,
 1746102364,
 1735291533,
 -1,
 1746167867,
 1746039640,
 -1,
 1746233401,
 1746095155,
 -1,
 1746298906,
 1746176223,
 2002,
 1746364440,
 1746265130,
 2018,
 -1,
 1746276043,
 2023,
 1746534399,
 1746277748,
 2019,
 -1,
 1746407115,
 2016,
 1746626592,
 1746235177,
 -1,
 1746692127,
 1746572661,
 -1,
 -38883,
 1746643375,
 2026,
 -38882,
 1746693931,
 2024,
 -1,
 1746743081,
 2025,
 -1,
 1746605428,
 2006,
 1747019811,
 1746577748,
 -1,
 -38878,
 1746971055,
 2010,
 -1,
 1746998644,
 2009,
 1747216421,
 1746964879,
 2000,
 -1,
 1747161487,
 1999,
 1747347495,
 1747140743,
 1997,
 -1,
 1747271815,
 1995,
 1747478569,
 1747269259,
 2008,
 -1,
 1747407897,
 2001,
 -38870,
 1747444778,
 2022,
 -38869,
 1747574064,
 2021,
 -38868,
 1747635786,
 1998,
 -38867,
 1747698453,
 2005,
 -38866,
 1747761049,
 2011,
 -38865,
 1747820622,
 2004,
 -38864,
 1747877938,
 2017,
 -38863,
 1747940269,
 2015,
 -38862,
 1748005023,
 2014,
 -38861,
 1748066687,
 1996,
 -38860,
 1748129961,
 2020,
 -38859,
 1748194314,
 2012,
 -38858,
 1748258495,
 2013,
 -38857,
 1748315945,
 2007,
 -38856,
 1748379304,
 2003,
 -1,
 1748440436,
 1994,
 -38854,
 1746181897,
 2037,
 -1,
 1748572598,
 2042,
 1748789321,
 1746090392,
 -1,
 1748854847,
 1748746964,
 -1,
 -38850,
 1748820367,
 1986,
 -1,
 1748852822,
 1987,
 1749051458,
 1748809503,
 -1,
 -38847,
 1748987630,
 1990,
 -1,
 1749044354,
 1991,
 1749248069,
 1748979286,
 -1,
 -38844,
 1749195760,
 1988,
 -1,
 1749249655,
 1989,
 -38842,
 1749215125,
 1984,
 -38841,
 1749390783,
 1985,
 -38840,
 1749454012,
 1993,
 -1,
 1749501239,
 1992,
 1749706839,
 1748709888,
 -1,
 1749772374,
 1749625226,
 -1,
 1749837904,
 1749712162,
 -1,
 -38835,
 1749791463,
 2033,
 -38834,
 1749843537,
 2032,
 -38833,
 1749900593,
 2031,
 -1,
 1749956632,
 2030,
 1750165588,
 1749793629,
 -1,
 -38830,
 1750119143,
 2029,
 -38829,
 1750171217,
 2028,
 -1,
 1750228273,
 2027,
 -38827,
 1750108595,
 2034,
 -1,
 1750351067,
 2035,
 -1,
 1749712946,
 2040,
 1750624346,
 1749664355,
 -1,
 -38823,
 1750570631,
 2038,
 -1,
 1750619150,
 2039,
 -38821,
 1750555963,
 2036,
 -1,
 1750748538,
 2041,
 1750952111,
 1746047375,
 -1,
 1751017611,
 1750903124,
 8893,
 1751083145,
 1750976018,
 -1,
 1751148653,
 1751047797,
 -1,
 1751214186,
 1751061876,
 -1,
 1751279721,
 1751168434,
 8598,
 1751384063,
 1751187456,
 -1,
 1751410790,
 1751304501,
 -1,
 -38811,
 1751350582,
 8632,
 -1,
 1751397196,
 8689,
 -38809,
 1751375913,
 10531,
 -38808,
 1751528652,
 10546,
 -1,
 1751588303,
 10535,
 -1,
 1751222954,
 10529,
 -38805,
 1751178934,
 11009,
 -38804,
 1751792806,
 8662,
 -1,
 1751853571,
 11017,
 1752066172,
 1751083037,
 -1,
 1752131703,
 1751994915,
 -1,
 1752197236,
 1752077763,
 -1,
 -38799,
 1752153368,
 43059,
 -38798,
 1752213589,
 43056,
 -38797,
 1752258955,
 43057,
 -1,
 1752319300,
 43060,
 1752563711,
 1752155967,
 -1,
 -38794,
 1752481074,
 43061,
 -1,
 1752541303,
 43058,
 1752721530,
 1752082372,
 -1,
 -38791,
 1752675886,
 43062,
 -1,
 1752731620,
 43065,
 -38789,
 1752676033,
 43064,
 -1,
 1752867815,
 43063,
 1753087999,
 1751990645,
 -1,
 1753114758,
 1752962420,
 -1,
 1753180293,
 1753068978,
 8599,
 1753284607,
 1753088000,
 -1,
 1753311363,
 1753166913,
 -1,
 -38782,
 1753267932,
 10542,
 -1,
 1753321013,
 10545,
 -38780,
 1753276457,
 10532,
 -1,
 1753423382,
 10536,
 -1,
 1753123518,
 10530,
 -38777,
 1753079478,
 11008,
 -38776,
 1753627814,
 8663,
 -1,
 1753688579,
 11016,
 1753939967,
 1751023833,
 8882,
 -1,
 1753810633,
 8884,
 1754032297,
 1750975188,
 -1,
 1754097830,
 1753939968,
 -1,
 1754163348,
 1754010996,
 -1,
 1754228881,
 1754073744,
 -1,
 -38768,
 1754178285,
 8837,
 -1,
 1754213395,
 8836,
 -38766,
 1754186378,
 8772,
 -38765,
 1754368235,
 8713,
 -1,
 1754430629,
 8777,
 1754622105,
 1754117919,
 -1,
 1754687640,
 1754572837,
 -1,
 -38761,
 1754634449,
 8931,
 -1,
 1754687096,
 8930,
 -1,
 1754621317,
 172,
 1754949788,
 1754579668,
 -1,
 -38757,
 1754904189,
 8877,
 -1,
 1754949119,
 8769,
 1755146398,
 1754893841,
 8938,
 -1,
 1755055817,
 8940,
 1755277473,
 1755072758,
 -1,
 -38752,
 1755213414,
 8813,
 -1,
 1755257381,
 8800,
 -38750,
 1755226394,
 8742,
 -38749,
 1755412815,
 8814,
 -38748,
 1755472800,
 8802,
 -38747,
 1755535095,
 8815,
 -1,
 1755590518,
 9083,
 1755840511,
 1754017665,
 -1,
 -38744,
 1755763876,
 10161,
 -1,
 1755807389,
 10159,
 1755998380,
 1753975007,
 -1,
 -38741,
 1755926963,
 10973,
 -1,
 1755975439,
 8209,
 -38739,
 1755940198,
 8303,
 -38738,
 1756106498,
 160,
 -1,
 1756169107,
 9940,
 1756391622,
 1750863606,
 -1,
 1756457142,
 1756310750,
 -1,
 1756522677,
 1756392506,
 -1,
 -38733,
 1756481621,
 10754,
 -38732,
 1756537970,
 10753,
 -1,
 1756576636,
 10752,
 -1,
 1756469226,
 8720,
 1756850362,
 1756418687,
 8899,
 1756954623,
 1756759681,
 -1,
 -38727,
 1756865612,
 10756,
 -1,
 1756904232,
 10755,
 1757112511,
 1756804895,
 -1,
 1757178046,
 1757063205,
 -1,
 -38723,
 1757139589,
 10758,
 -1,
 1757178433,
 10757,
 -1,
 1757139392,
 8721,
 1757440194,
 1757052141,
 -1,
 -38719,
 1757386742,
 8897,
 -1,
 1757420903,
 8896,
 -38717,
 1757404942,
 11007,
 -38716,
 1757595733,
 10761,
 -38715,
 1757652641,
 8719,
 -1,
 1757702708,
 8898,
 1757898971,
 1756352885,
 -1,
 1757964506,
 1757816959,
 -1,
 1758030030,
 1757922004,
 -1,
 1758095564,
 1757994578,
 -1,
 -38709,
 1758040073,
 9371,
 -1,
 1758101394,
 9363,
 -38707,
 1758027193,
 9364,
 -1,
 1758217979,
 9361,
 1758423251,
 1757984543,
 -1,
 1758488786,
 1758355839,
 -1,
 -38703,
 1758454734,
 9367,
 -1,
 1758483990,
 35,
 -1,
 1758416057,
 9368,
 1758750934,
 1758350934,
 -1,
 -38699,
 1758698621,
 9365,
 -1,
 1758749812,
 9366,
 1758947545,
 1758675079,
 -1,
 -38696,
 1758886438,
 9362,
 -1,
 1758946569,
 9369,
 -1,
 1758891210,
 9370,
 -1,
 1757891065,
 8470,
 1759313919,
 1757812084,
 -1,
 -38691,
 1759234247,
 8302,
 -38690,
 1759294903,
 8239,
 -38689,
 1759349341,
 8892,
 -38688,
 1759407100,
 8358,
 -1,
 1759455730,
 8711,
 1759668800,
 1735221631,
 -1,
 1759734147,
 1759590218,
 -1,
 1759799679,
 1759679321,
 -1,
 1759865161,
 1759757567,
 -1,
 1759930696,
 1759822443,
 -1,
 1759996181,
 1759852064,
 -1,
 1760061716,
 1759913531,
 -1,
 1760127234,
 1760019156,
 -1,
 1760192763,
 1760091400,
 -1,
 1760258298,
 1760116871,
 -1,
 1760323833,
 1760202757,
 13299,
 1760428031,
 1760235219,
 -1,
 1760454896,
 1760346836,
 -1,
 -38673,
 1760420239,
 13301,
 -1,
 1760452694,
 13302,
 1760651507,
 1760409375,
 -1,
 -38670,
 1760587502,
 13305,
 -1,
 1760644226,
 13306,
 1760848118,
 1760579158,
 -1,
 -38667,
 1760795632,
 13303,
 -1,
 1760849527,
 13304,
 -38665,
 1760794047,
 13300,
 -38664,
 1760988348,
 13308,
 -1,
 1761035575,
 13307,
 -1,
 1760264078,
 13291,
 -1,
 1760203151,
 13281,
 1761372417,
 1760123019,
 -1,
 1761437952,
 1761307851,
 -1,
 1761503487,
 1761403886,
 13309,
 -1,
 1761415304,
 13310,
 -1,
 1761428300,
 13292,
 -1,
 1761389648,
 13282,
 -1,
 1761298161,
 13289,
 1761831175,
 1760081695,
 -1,
 1761896709,
 1761767150,
 13285,
 -1,
 1761854682,
 13295,
 1762066431,
 1761823874,
 13286,
 -1,
 1761985754,
 13296,
 1762158861,
 1761758806,
 -1,
 1762224394,
 1762106352,
 13283,
 -1,
 1762182362,
 13293,
 1762394111,
 1762156927,
 -1,
 -38644,
 1762318580,
 13284,
 -1,
 1762349682,
 13294,
 1762552081,
 1762082951,
 -1,
 1762617616,
 1762485475,
 13287,
 -1,
 1762542412,
 13297,
 -1,
 1762556448,
 13290,
 1762814227,
 1762495676,
 13288,
 -1,
 1762772186,
 13298,
 -1,
 1762760127,
 13280,
 -1,
 1759986221,
 13003,
 1763076409,
 1759928329,
 -1,
 1763141926,
 1763033812,
 -1,
 1763207458,
 1763106056,
 -1,
 1763272993,
 1763131527,
 -1,
 1763338528,
 1763217413,
 13164,
 1763442687,
 1763249875,
 -1,
 1763469598,
 1763361492,
 -1,
 -38627,
 1763434895,
 13166,
 -1,
 1763467350,
 13167,
 -38625,
 1763415487,
 13165,
 -1,
 1763594704,
 13168,
 -1,
 1763278734,
 13156,
 -1,
 1763217807,
 13146,
 1763928357,
 1763137675,
 -1,
 -38620,
 1763880016,
 13147,
 -1,
 1763929295,
 13157,
 -1,
 1763854065,
 13154,
 1764190507,
 1763096351,
 -1,
 1764256041,
 1764126446,
 13150,
 -1,
 1764213978,
 13160,
 1764425727,
 1764183170,
 13151,
 -1,
 1764345050,
 13161,
 1764518193,
 1764118102,
 -1,
 1764583726,
 1764465648,
 13148,
 -1,
 1764541658,
 13158,
 1764753407,
 1764516223,
 -1,
 -38608,
 1764677876,
 13149,
 -1,
 1764708978,
 13159,
 1764911413,
 1764442247,
 -1,
 1764976948,
 1764844771,
 13152,
 -1,
 1764901708,
 13162,
 -1,
 1764915744,
 13155,
 1765173559,
 1764854972,
 13153,
 -1,
 1765131482,
 13163,
 -38600,
 1765140373,
 13144,
 -1,
 1765250495,
 13145,
 1765435710,
 1763012393,
 -1,
 1765501245,
 1765396042,
 -1,
 -38596,
 1765444355,
 12997,
 -1,
 1765507000,
 12998,
 -1,
 1765416839,
 12992,
 1765763393,
 1765376050,
 -1,
 -38592,
 1765729262,
 12996,
 -1,
 1765780257,
 12994,
 1765960004,
 1765676404,
 -1,
 -38589,
 1765920846,
 12999,
 -1,
 1765975654,
 12995,
 -38587,
 1765915058,
 13000,
 -38586,
 1766101652,
 13001,
 -38585,
 1766166204,
 13002,
 -1,
 1766215495,
 12993,
 -1,
 1759869724,
 12343,
 1766484319,
 1759780593,
 -1,
 1766549840,
 1766441684,
 -1,
 1766615374,
 1766480011,
 -1,
 -38579,
 1766567013,
 12692,
 -1,
 1766616180,
 12699,
 -38577,
 1766580825,
 12691,
 -1,
 1766758137,
 12694,
 1766943061,
 1766477398,
 -1,
 1767008596,
 1766890480,
 -1,
 -38573,
 1766966806,
 12700,
 -1,
 1766983112,
 12693,
 -1,
 1766943924,
 12697,
 1767270744,
 1766883301,
 -1,
 -38569,
 1767203624,
 12695,
 -1,
 1767251265,
 12703,
 -38567,
 1767225521,
 12698,
 -38566,
 1767419199,
 12689,
 -38565,
 1767478774,
 12690,
 -38564,
 1767537517,
 12688,
 -38563,
 1767594886,
 12701,
 -38562,
 1767653738,
 12702,
 -1,
 1767713553,
 12696,
 1767926131,
 1766405962,
 -1,
 1767991666,
 1767880835,
 -1,
 1768057194,
 1767948838,
 -1,
 1768122725,
 1768019033,
 -1,
 -38556,
 1768074849,
 12281,
 -1,
 1768126085,
 12280,
 1768319336,
 1768059736,
 -1,
 -38553,
 1768267612,
 12282,
 -1,
 1768309658,
 12279,
 -38551,
 1768237139,
 12278,
 -1,
 1768429173,
 12277,
 1768647021,
 1767995307,
 -1,
 -38548,
 1768599137,
 12272,
 -1,
 1768654015,
 12274,
 1768843632,
 1768560412,
 -1,
 -38545,
 1768785070,
 12275,
 -1,
 1768826963,
 12273,
 -38543,
 1768791730,
 12283,
 -1,
 1768968908,
 12276,
 -1,
 1767940445,
 12332,
 1769236854,
 1767845086,
 -1,
 -38539,
 1769182463,
 12289,
 -1,
 1769242088,
 12294,
 -38537,
 1769199788,
 12350,
 -38536,
 1769389805,
 12288,
 -38535,
 1769452275,
 12331,
 -38534,
 1769508958,
 12295,
 -38533,
 1769568784,
 12330,
 -38532,
 1769631173,
 12293,
 -38531,
 1769691574,
 12351,
 -38530,
 1769755330,
 12290,
 -1,
 1769818099,
 12333,
 1770061823,
 1759743900,
 -1,
 1770088834,
 1769982258,
 8801,
 -1,
 1769996623,
 10725,
 -1,
 1770053574,
 10855,
 1770285587,
 1759676639,
 -1,
 1770351059,
 1770239775,
 -1,
 1770416594,
 1770271746,
 -1,
 1770482094,
 1770370630,
 -1,
 1770547618,
 1770420698,
 -1,
 1770613133,
 1770501919,
 -1,
 1770678668,
 1770526068,
 -1,
 -38517,
 1770619860,
 68430,
 -1,
 1770666119,
 68433,
 -1,
 1770610051,
 68436,
 1770940816,
 1770570452,
 -1,
 -38513,
 1770867682,
 68424,
 -1,
 1770923541,
 68437,
 1771137426,
 1770871592,
 68420,
 -1,
 1771095567,
 68423,
 1771268501,
 1771050356,
 -1,
 -38508,
 1771234768,
 68431,
 -1,
 1771272500,
 68416,
 -38506,
 1771235178,
 68422,
 -38505,
 1771431487,
 68425,
 -38504,
 1771494959,
 68421,
 -38503,
 1771547917,
 68435,
 -38502,
 1771612088,
 68434,
 -38501,
 1771676077,
 68432,
 -38500,
 1771737255,
 68429,
 -38499,
 1771799527,
 68428,
 -38498,
 1771861227,
 68427,
 -38497,
 1771925777,
 68426,
 -38496,
 1771984269,
 68418,
 -38495,
 1772041949,
 68419,
 -1,
 1772103983,
 68417,
 1772355583,
 1770491967,
 -1,
 1772382633,
 1772274388,
 -1,
 1772448167,
 1772346632,
 -1,
 -38490,
 1772392847,
 68441,
 -1,
 1772439631,
 68445,
 -38488,
 1772380246,
 68442,
 -1,
 1772570353,
 68444,
 1772775853,
 1772328383,
 68440,
 1772879871,
 1772683264,
 -1,
 -38484,
 1772799773,
 68447,
 -1,
 1772839191,
 68446,
 -1,
 1772704208,
 68443,
 1773142015,
 1770413628,
 -1,
 1773169094,
 1773042138,
 -1,
 1773234613,
 1773123359,
 -1,
 1773300148,
 1773147508,
 -1,
 -38477,
 1773241300,
 68462,
 -1,
 1773287559,
 68464,
 -1,
 1773231491,
 68465,
 1773562296,
 1773191892,
 -1,
 -38473,
 1773489122,
 68456,
 -1,
 1773544981,
 68466,
 1773758906,
 1773493032,
 68452,
 -1,
 1773717007,
 68455,
 -38469,
 1773725546,
 68454,
 -38468,
 1773856319,
 68457,
 -38467,
 1773919800,
 68453,
 -38466,
 1773969837,
 68463,
 -38465,
 1774031015,
 68461,
 -38464,
 1774093291,
 68460,
 -38463,
 1774154987,
 68459,
 -38462,
 1774219537,
 68458,
 -38461,
 1774278029,
 68450,
 -38460,
 1774335709,
 68451,
 -38459,
 1774397743,
 68449,
 -1,
 1774459697,
 68448,
 1774714879,
 1773113407,
 -1,
 1774741965,
 1774633684,
 -1,
 1774807499,
 1774705928,
 -1,
 -38454,
 1774752143,
 68473,
 -1,
 1774798927,
 68477,
 -38452,
 1774739542,
 68474,
 -1,
 1774929649,
 68476,
 1775135185,
 1774687679,
 68472,
 1775239167,
 1775042560,
 -1,
 -38448,
 1775159069,
 68479,
 -1,
 1775198487,
 68478,
 -1,
 1775063504,
 68475,
 -1,
 1770342963,
 9088,
 1775528439,
 1770308731,
 -1,
 1775593960,
 1775479124,
 -1,
 1775659487,
 1775548625,
 8745,
 1775763455,
 1775566848,
 -1,
 1775790555,
 1775689586,
 -1,
 -38439,
 1775738538,
 10819,
 -38438,
 1775795446,
 10820,
 -1,
 1775844136,
 10816,
 1776052702,
 1775703675,
 -1,
 -38435,
 1776013951,
 10823,
 -1,
 1776035704,
 10825,
 -1,
 1775970492,
 10827,
 1776314853,
 1775596376,
 -1,
 1776380388,
 1776248952,
 -1,
 -38430,
 1776338316,
 65531,
 -38429,
 1776400766,
 65530,
 -1,
 1776426336,
 65529,
 -1,
 1776325241,
 9892,
 -38426,
 1776268268,
 8253,
 -38425,
 1776642981,
 10812,
 -1,
 1776692580,
 8890,
 1776943103,
 1775523461,
 8747,
 1777008639,
 1776812032,
 -1,
 1777035763,
 1776934770,
 -1,
 1777101294,
 1776996819,
 -1,
 -38419,
 1777036184,
 10778,
 -1,
 1777088508,
 10780,
 -38417,
 1777059975,
 10776,
 -38416,
 1777245866,
 10779,
 -38415,
 1777301593,
 10775,
 -38414,
 1777363508,
 10777,
 -1,
 1777417622,
 10766,
 1777625590,
 1776948596,
 -1,
 -38411,
 1777588666,
 10767,
 -1,
 1777644778,
 10773,
 -1,
 1777552943,
 9134,
 1777887751,
 1775490990,
 -1,
 1777953283,
 1777813855,
 -1,
 1778018816,
 1777910990,
 -1,
 -38405,
 1777980000,
 8276,
 -38404,
 1778034878,
 191,
 -38403,
 1778094985,
 8487,
 -38402,
 1778152993,
 8766,
 -38401,
 1778215442,
 11800,
 -1,
 1778273658,
 161,
 1778515967,
 1777973403,
 -1,
 -38398,
 1778441922,
 9689,
 -1,
 1778461759,
 9688,
 1778712575,
 1777888539,
 -1,
 -38395,
 1778632766,
 8290,
 -38394,
 1778694526,
 8291,
 -1,
 1778754636,
 8292,
 1778936331,
 1777815126,
 -1,
 1779001866,
 1778870642,
 8734,
 -1,
 1778910706,
 10718,
 -1,
 1778948431,
 8505,
 1779198480,
 1778855134,
 -1,
 1779264015,
 1779149700,
 -1,
 -38386,
 1779205147,
 8710,
 -1,
 1779245900,
 10721,
 -1,
 1779209496,
 10716,
 1779564543,
 1779129521,
 -1,
 -38382,
 1779483255,
 8298,
 -1,
 1779507353,
 8300,
 1779722815,
 1770225637,
 -1,
 1779788349,
 1779671741,
 -1,
 1779853872,
 1779726810,
 -1,
 1779919387,
 1779808031,
 -1,
 1779984922,
 1779832180,
 -1,
 -38375,
 1779925972,
 67662,
 -1,
 1779972231,
 67665,
 -1,
 1779916163,
 67668,
 1780247070,
 1779876564,
 -1,
 -38371,
 1780173794,
 67656,
 -1,
 1780229653,
 67669,
 1780443680,
 1780177704,
 67652,
 -1,
 1780401679,
 67655,
 1780574755,
 1780356468,
 -1,
 -38366,
 1780540880,
 67663,
 -1,
 1780578612,
 67648,
 -38364,
 1780541290,
 67654,
 -38363,
 1780737599,
 67657,
 -38362,
 1780801071,
 67653,
 -38361,
 1780854029,
 67667,
 -38360,
 1780918200,
 67666,
 -38359,
 1780982189,
 67664,
 -38358,
 1781043367,
 67661,
 -38357,
 1781105639,
 67660,
 -38356,
 1781167339,
 67659,
 -38355,
 1781231889,
 67658,
 -38354,
 1781290381,
 67650,
 -38353,
 1781348061,
 67651,
 -1,
 1781410095,
 67649,
 1781623356,
 1779798079,
 -1,
 1781688888,
 1781580500,
 -1,
 1781754421,
 1781652744,
 -1,
 -38348,
 1781698959,
 67673,
 -1,
 1781745743,
 67676,
 1781951031,
 1781679857,
 67675,
 -1,
 1781861073,
 67679,
 -1,
 1781882966,
 67674,
 1782185983,
 1781634495,
 67672,
 1782251519,
 1782054912,
 -1,
 -38341,
 1782171421,
 67678,
 -1,
 1782210839,
 67677,
 -1,
 1781577958,
 67671,
 1782513663,
 1779701931,
 8887,
 -1,
 1782384292,
 8787,
 -1,
 1779642015,
 9976,
 1782672134,
 1759596118,
 -1,
 1782737611,
 1782632010,
 -1,
 1782803142,
 1782676482,
 -1,
 1782868674,
 1782767423,
 -1,
 1782934148,
 1782805336,
 -1,
 1782999676,
 1782850843,
 -1,
 1783065185,
 1782955530,
 -1,
 -38328,
 1783031582,
 65370,
 -38327,
 1783096302,
 65369,
 -38326,
 1783161604,
 65368,
 -38325,
 1783225608,
 65367,
 -38324,
 1783289774,
 65366,
 -38323,
 1783352906,
 65365,
 -38322,
 1783415508,
 65364,
 -38321,
 1783478047,
 65363,
 -38320,
 1783540052,
 65362,
 -38319,
 1783605060,
 65361,
 -38318,
 1783668713,
 65360,
 -38317,
 1783730575,
 65359,
 -38316,
 1783793887,
 65358,
 -38315,
 1783857125,
 65357,
 -38314,
 1783919448,
 65356,
 -38313,
 1783984264,
 65355,
 -38312,
 1784049449,
 65354,
 -38311,
 1784111487,
 65353,
 -38310,
 1784174731,
 65352,
 -38309,
 1784238819,
 65351,
 -38308,
 1784303190,
 65350,
 -38307,
 1784365191,
 65349,
 -38306,
 1784428064,
 65348,
 -38305,
 1784491230,
 65347,
 -38304,
 1784555126,
 65346,
 -1,
 1784616308,
 65345,
 1784872959,
 1782984196,
 -1,
 -38301,
 1784801054,
 65338,
 -38300,
 1784865774,
 65337,
 -38299,
 1784931076,
 65336,
 -38298,
 1784995080,
 65335,
 -38297,
 1785059246,
 65334,
 -38296,
 1785122378,
 65333,
 -38295,
 1785184980,
 65332,
 -38294,
 1785247519,
 65331,
 -38293,
 1785309524,
 65330,
 -38292,
 1785374532,
 65329,
 -38291,
 1785438185,
 65328,
 -38290,
 1785500047,
 65327,
 -38289,
 1785563359,
 65326,
 -38288,
 1785626597,
 65325,
 -38287,
 1785688920,
 65324,
 -38286,
 1785753736,
 65323,
 -38285,
 1785818921,
 65322,
 -38284,
 1785880959,
 65321,
 -38283,
 1785944203,
 65320,
 -38282,
 1786008291,
 65319,
 -38281,
 1786072662,
 65318,
 -38280,
 1786134663,
 65317,
 -38279,
 1786197536,
 65316,
 -38278,
 1786260702,
 65315,
 -38277,
 1786324598,
 65314,
 -1,
 1786385780,
 65313,
 1786604163,
 1782923399,
 -1,
 1786669698,
 1786532449,
 -1,
 -38273,
 1786633951,
 65375,
 -38272,
 1786691422,
 65339,
 -38271,
 1786749222,
 65288,
 -1,
 1786787221,
 65371,
 -1,
 1786625971,
 65308,
 -1,
 1786552052,
 65343,
 1787128468,
 1782855200,
 -1,
 1787194003,
 1787061626,
 -1,
 1787259529,
 1787151060,
 -1,
 -38264,
 1787224463,
 65298,
 -1,
 1787256918,
 65299,
 1787456140,
 1787213599,
 -1,
 -38261,
 1787391726,
 65302,
 -1,
 1787448450,
 65303,
 1787652751,
 1787383382,
 -1,
 -38258,
 1787599856,
 65300,
 -1,
 1787653751,
 65301,
 -38256,
 1787619221,
 65296,
 -38255,
 1787794879,
 65297,
 -38254,
 1787858108,
 65305,
 -1,
 1787905335,
 65304,
 -1,
 1787139213,
 65284,
 1788177051,
 1787078996,
 -1,
 1788242586,
 1788110056,
 -1,
 -38249,
 1788206815,
 65376,
 -38248,
 1788264286,
 65341,
 -38247,
 1788322086,
 65289,
 -1,
 1788360085,
 65373,
 -1,
 1788169443,
 65340,
 1788635811,
 1788095710,
 -1,
 1788701345,
 1788580239,
 -1,
 1788766880,
 1788642804,
 -1,
 -38241,
 1788692906,
 65312,
 -1,
 1788745076,
 65292,
 -1,
 1788706066,
 65306,
 -38238,
 1788636243,
 65342,
 -1,
 1788954566,
 65504,
 1789160103,
 1788583913,
 -1,
 -38235,
 1789107094,
 65505,
 -38234,
 1789165430,
 65291,
 -1,
 1789217174,
 65285,
 1789422251,
 1789072756,
 -1,
 -38231,
 1789378675,
 65290,
 -38230,
 1789437296,
 65287,
 -1,
 1789495153,
 65286,
 1789684398,
 1789376287,
 -1,
 -38227,
 1789629539,
 65295,
 -1,
 1789675136,
 65307,
 1789881009,
 1789634497,
 -1,
 -38224,
 1789827730,
 65282,
 -1,
 1789872937,
 65311,
 1790077620,
 1789823199,
 -1,
 -38221,
 1790038443,
 65283,
 -1,
 1790089854,
 65506,
 1790274231,
 1790006893,
 -1,
 -38218,
 1790198155,
 65310,
 -1,
 1790256617,
 65344,
 1790470842,
 1790197895,
 -1,
 -38215,
 1790436166,
 65281,
 -1,
 1790486531,
 65309,
 -38213,
 1790436655,
 65509,
 -38212,
 1790632627,
 65510,
 -38211,
 1790696179,
 65372,
 -38210,
 1790756860,
 65374,
 -38209,
 1790804027,
 65507,
 -38208,
 1790861679,
 65293,
 -38207,
 1790923458,
 65294,
 -1,
 1790979049,
 65508,
 1791229951,
 1782775808,
 -1,
 -38204,
 1791148221,
 46,
 -38203,
 1791204541,
 10199,
 -1,
 1791240848,
 9608,
 1791453897,
 1782745311,
 -1,
 -38200,
 1791379853,
 9905,
 -1,
 1791440155,
 8289,
 -38198,
 1791408280,
 9179,
 -1,
 1791575489,
 9981,
 1791781598,
 1782681999,
 -1,
 1791847128,
 1791741514,
 -1,
 1791912663,
 1791797588,
 -1,
 1791978197,
 1791819776,
 -1,
 1792043730,
 1791900460,
 -1,
 -38191,
 1791993583,
 8280,
 -1,
 1792049754,
 8283,
 -38189,
 1792001170,
 10018,
 -38188,
 1792160211,
 10021,
 -1,
 1792222987,
 10019,
 -38186,
 1791936030,
 8732,
 -1,
 1792348315,
 8197,
 -1,
 1791856487,
 9970,
 1792671743,
 1791797588,
 -1,
 1792699100,
 1792569480,
 -1,
 -38181,
 1792632999,
 10972,
 -1,
 1792688843,
 11792,
 -38179,
 1792618270,
 8873,
 -1,
 1792802883,
 8704,
 1793026792,
 1791713663,
 -1,
 1793092322,
 1792989435,
 -1,
 -38175,
 1793042159,
 8281,
 -1,
 1793098330,
 11821,
 1793288933,
 1793022023,
 -1,
 -38172,
 1793244909,
 8199,
 -1,
 1793275657,
 8210,
 -38170,
 1793243922,
 9673,
 -38169,
 1793439240,
 9789,
 -1,
 1793494274,
 10765,
 1793682161,
 1792963416,
 -1,
 1793747693,
 1793626511,
 -1,
 1793813228,
 1793711724,
 9880,
 -1,
 1793722754,
 8277,
 -1,
 1793763953,
 10086,
 1794009840,
 1793660276,
 -1,
 -38161,
 1793968428,
 9189,
 -1,
 1794003688,
 9971,
 -1,
 1793936469,
 9884,
 1794271993,
 1793632596,
 -1,
 1794337525,
 1794216335,
 -1,
 -38156,
 1794302286,
 8994,
 -1,
 1794346813,
 10156,
 1794534136,
 1794250649,
 -1,
 -38153,
 1794489725,
 8260,
 -1,
 1794543755,
 8543,
 -1,
 1794459477,
 8355,
 1794796289,
 1794184564,
 -1,
 1794861823,
 1794735238,
 -1,
 1794927358,
 1794782273,
 -1,
 -38147,
 1794880181,
 10540,
 -1,
 1794936356,
 10543,
 -1,
 1794860948,
 9950,
 -38144,
 1794815478,
 9771,
 -1,
 1795110155,
 8507,
 1795358719,
 1794719879,
 -1,
 1795386117,
 1795260389,
 -1,
 -38140,
 1795320110,
 170,
 -1,
 1795365544,
 9792,
 -1,
 1795339746,
 9972,
 1795648420,
 1782632010,
 -1,
 1795713893,
 1795596265,
 -1,
 1795779385,
 1795677530,
 -1,
 1795844886,
 1795691892,
 -1,
 1795910421,
 1795798450,
 8593,
 1796014079,
 1795817472,
 -1,
 1796041490,
 1795940210,
 -1,
 1796107024,
 1795999963,
 -1,
 -38129,
 1796059284,
 8625,
 -1,
 1796110399,
 8624,
 -38127,
 1796038518,
 10505,
 -1,
 1796226454,
 8670,
 -38125,
 1796000057,
 10514,
 -38124,
 1796372595,
 8645,
 -1,
 1796428367,
 8613,
 -1,
 1795852887,
 11797,
 1796696868,
 1795775171,
 -1,
 1796762399,
 1796634245,
 -1,
 1796827934,
 1796669440,
 -1,
 1796893468,
 1796745396,
 -1,
 -38117,
 1796855132,
 10595,
 -1,
 1796882281,
 10606,
 -38115,
 1796852025,
 10584,
 -1,
 1797018191,
 10592,
 -1,
 1796791636,
 8639,
 1797324799,
 1796714081,
 -1,
 1797352227,
 1797193728,
 -1,
 -38110,
 1797310777,
 10580,
 -1,
 1797345871,
 10588,
 -1,
 1797315924,
 8638,
 1797614382,
 1796660911,
 -1,
 1797679916,
 1797530210,
 8679,
 1797783551,
 1797586944,
 -1,
 1797810987,
 1797690697,
 8683,
 1797914623,
 1797721123,
 -1,
 -38102,
 1797839452,
 8685,
 -1,
 1797873368,
 8684,
 -1,
 1797739087,
 8682,
 1798176767,
 1797602470,
 8686,
 -1,
 1798047328,
 8687,
 1798269747,
 1797571284,
 -1,
 1798335282,
 1798234511,
 -1,
 -38095,
 1798246325,
 10569,
 -1,
 1798308948,
 8607,
 -1,
 1798287913,
 10506,
 1798597430,
 1798190624,
 -1,
 -38091,
 1798544199,
 8657,
 -1,
 1798579077,
 8673,
 -38089,
 1798547427,
 10224,
 -38088,
 1798742152,
 8648,
 -1,
 1798777347,
 11014,
 1798990671,
 1795686400,
 -1,
 1799056192,
 1798913588,
 -1,
 1799121725,
 1798972002,
 8597,
 -1,
 1799031850,
 8616,
 -38082,
 1799085750,
 8691,
 -38081,
 1799175334,
 8661,
 -1,
 1799236099,
 11021,
 1799449415,
 1798973320,
 -1,
 1799514948,
 1799401224,
 -1,
 -38077,
 1799466839,
 10575,
 -1,
 1799517999,
 10572,
 1799749631,
 1799452389,
 -1,
 -38074,
 1799663447,
 10573,
 -1,
 1799714607,
 10577,
 1799908171,
 1799365218,
 -1,
 1799973706,
 1799838518,
 8963,
 -1,
 1799881258,
 8996,
 -1,
 1799883483,
 10685,
 1800170317,
 1799865177,
 8869,
 -1,
 1800080462,
 10207,
 -38066,
 1800122057,
 8944,
 -1,
 1800229014,
 10622,
 1800432482,
 1798939220,
 -1,
 1800498007,
 1800384103,
 -1,
 -38062,
 1800456954,
 9721,
 -38061,
 1800518258,
 10066,
 -38060,
 1800579021,
 9693,
 -38059,
 1800643114,
 10000,
 -38058,
 1800706073,
 9137,
 -1,
 1800749035,
 10064,
 1800956764,
 1800435338,
 -1,
 -38055,
 1800915706,
 9720,
 -38054,
 1800972237,
 9692,
 -38053,
 1801033789,
 9136,
 -1,
 1801073540,
 10196,
 1801284448,
 1800886672,
 -1,
 -38050,
 1801218744,
 9690,
 -38049,
 1801269314,
 9696,
 -1,
 1801333392,
 9600,
 -38047,
 1801229776,
 9620,
 -1,
 1801464430,
 9985,
 1801715711,
 1800343798,
 -1,
 -38044,
 1801629476,
 9710,
 -1,
 1801680639,
 9709,
 1801874318,
 1795642281,
 -1,
 1801939853,
 1801812442,
 -1,
 1802005357,
 1801893663,
 -1,
 1802070891,
 1801917812,
 -1,
 -38038,
 1802012139,
 66450,
 -1,
 1802057546,
 66453,
 -38036,
 1802027384,
 66461,
 -1,
 1802198403,
 66444,
 1802398577,
 1801962196,
 -1,
 -38033,
 1802342799,
 66458,
 -38032,
 1802394226,
 66456,
 -1,
 1802455869,
 66441,
 1802660724,
 1802364702,
 -1,
 -38029,
 1802620490,
 66449,
 -1,
 1802652504,
 66439,
 1802857335,
 1802596488,
 -1,
 -38026,
 1802786985,
 66435,
 -1,
 1802836103,
 66443,
 1803053945,
 1802788447,
 66437,
 -1,
 1803010837,
 66440,
 1803185020,
 1802982115,
 -1,
 -38021,
 1803114843,
 66457,
 -1,
 1803164901,
 66434,
 1803381631,
 1803105824,
 -1,
 -38018,
 1803311481,
 66447,
 -1,
 1803372072,
 66436,
 1803578242,
 1803294068,
 -1,
 -38015,
 1803517649,
 66432,
 -1,
 1803577136,
 66451,
 -38013,
 1803544109,
 66442,
 -38012,
 1803739535,
 66438,
 -38011,
 1803800138,
 66460,
 -38010,
 1803856616,
 66455,
 -38009,
 1803921331,
 66454,
 -38008,
 1803986668,
 66452,
 -38007,
 1804046503,
 66448,
 -38006,
 1804108775,
 66446,
 -38005,
 1804170463,
 66445,
 -38004,
 1804231039,
 66459,
 -1,
 1804282135,
 66433,
 -1,
 1801904828,
 66463,
 1804561311,
 1801816287,
 -1,
 1804626843,
 1804493183,
 -1,
 1804692378,
 1804571949,
 8746,
 1804795903,
 1804599296,
 -1,
 1804823446,
 1804722034,
 -1,
 -37996,
 1804770986,
 10818,
 -37995,
 1804830129,
 10817,
 -1,
 1804893442,
 10821,
 1805085593,
 1804736123,
 -1,
 -37992,
 1805019700,
 10822,
 -1,
 1805068129,
 10824,
 -1,
 1805002976,
 10826,
 -1,
 1804655079,
 9842,
 1805413278,
 1804547616,
 -1,
 -37987,
 1805357514,
 9100,
 -1,
 1805404717,
 8255,
 -1,
 1805353573,
 9903,
 1805675427,
 1804501769,
 9730,
 1805778943,
 1805582336,
 -1,
 -37982,
 1805705396,
 9748,
 -1,
 1805751604,
 9969,
 -1,
 1805626074,
 9797,
 1806003278,
 1795611912,
 -1,
 1806068788,
 1805932683,
 -1,
 1806134321,
 1806003624,
 -1,
 1806199856,
 1806041088,
 -1,
 1806265287,
 1806153503,
 -1,
 1806330810,
 1806215199,
 9633,
 1806434303,
 1806237696,
 -1,
 1806461881,
 1806360434,
 -1,
 1806527409,
 1806398296,
 -1,
 1806592944,
 1806475078,
 -1,
 -37969,
 1806544821,
 9714,
 -1,
 1806595975,
 9713,
 -1,
 1806517394,
 10212,
 1806855092,
 1806488665,
 -1,
 -37965,
 1806806965,
 9715,
 -1,
 1806858119,
 9712,
 1807051703,
 1806805332,
 -1,
 -37962,
 1806998461,
 9634,
 -1,
 1807050028,
 10213,
 -37960,
 1807014560,
 9707,
 -1,
 1807167213,
 9093,
 -1,
 1806381812,
 9635,
 1807444929,
 1806270437,
 -1,
 1807510464,
 1807358888,
 -1,
 1807575999,
 1807464223,
 -1,
 -37954,
 1807533092,
 11090,
 -1,
 1807591455,
 9643,
 -1,
 1807515337,
 11051,
 -1,
 1807443488,
 9786,
 -37950,
 1807405526,
 9788,
 -37949,
 1807860772,
 9734,
 -37948,
 1807917182,
 9828,
 -37947,
 1807965805,
 9750,
 -37946,
 1808026199,
 65094,
 -1,
 1808085254,
 9988,
 1808296929,
 1806183646,
 -1,
 1808362452,
 1808231452,
 9675,
 1808465919,
 1808272419,
 -1,
 1808493517,
 1808389209,
 -1,
 -37940,
 1808445365,
 9719,
 -1,
 1808496519,
 9716,
 1808690128,
 1808432730,
 -1,
 -37937,
 1808641973,
 9718,
 -1,
 1808693127,
 9717,
 1808886739,
 1808612036,
 -1,
 -37934,
 1808851285,
 10732,
 -1,
 1808909066,
 9862,
 -1,
 1808846197,
 9863,
 1809148892,
 1808292952,
 -1,
 1809214424,
 1809084552,
 -1,
 -37929,
 1809157280,
 9816,
 -1,
 1809213607,
 9812,
 -37927,
 1809167455,
 9814,
 -37926,
 1809361071,
 9813,
 -37925,
 1809424786,
 9817,
 -1,
 1809459655,
 9815,
 1809673184,
 1809094053,
 10209,
 1809776639,
 1809583139,
 -1,
 -37921,
 1809690948,
 10211,
 -1,
 1809741995,
 10210,
 -1,
 1809612590,
 9831,
 1810000880,
 1808217632,
 -1,
 1810066408,
 1809932875,
 9671,
 1810169855,
 1809973248,
 -1,
 -37915,
 1810096028,
 10192,
 -37914,
 1810153899,
 9826,
 -37913,
 1810196350,
 9931,
 -1,
 1810248405,
 9672,
 1810459629,
 1810014123,
 -1,
 1810525164,
 1810370745,
 -1,
 -37909,
 1810483962,
 9661,
 -1,
 1810546215,
 9663,
 -1,
 1810434406,
 9759,
 1810825215,
 1810410240,
 -1,
 -37905,
 1810727414,
 9920,
 -1,
 1810788954,
 9921,
 1810983930,
 1809951060,
 -1,
 1811049465,
 1810916579,
 -1,
 1811115000,
 1810960569,
 -1,
 1811180534,
 1811062761,
 -1,
 -37899,
 1811125207,
 9659,
 -1,
 1811171279,
 11092,
 -37897,
 1811139322,
 9655,
 -1,
 1811332647,
 9657,
 -1,
 1811024230,
 9758,
 -1,
 1810973267,
 9645,
 1811639300,
 1810920280,
 -1,
 1811704835,
 1811563418,
 -1,
 1811770368,
 1811615929,
 -1,
 -37890,
 1811729146,
 9665,
 -37889,
 1811791399,
 9667,
 -1,
 1811850469,
 9669,
 1812070399,
 1811677184,
 -1,
 -37886,
 1811981584,
 9756,
 -1,
 1812034802,
 9945,
 -1,
 1811620266,
 11036,
 1812294667,
 1811579775,
 -1,
 1812360201,
 1812248351,
 -1,
 -37881,
 1812317220,
 11088,
 -37880,
 1812375583,
 9723,
 -1,
 1812431305,
 9725,
 -37878,
 1812299465,
 11048,
 -1,
 1812543789,
 11046,
 1812753426,
 1812221526,
 -1,
 1812818960,
 1812689752,
 -1,
 1812884495,
 1812732051,
 9872,
 -1,
 1812794774,
 9983,
 -1,
 1812830392,
 10048,
 -37871,
 1812772139,
 9785,
 -1,
 1813027924,
 10023,
 1813212184,
 1812715929,
 -1,
 1813277719,
 1813170114,
 -1,
 -37867,
 1813228551,
 9647,
 -37866,
 1813267956,
 11055,
 -1,
 1813325646,
 11006,
 -1,
 1813242893,
 11038,
 1813605406,
 1813172996,
 -1,
 1813670941,
 1813516473,
 -1,
 1813736476,
 1813629690,
 9651,
 -1,
 1813646583,
 9708,
 -1,
 1813691943,
 9653,
 -1,
 1813580134,
 9757,
 1813998628,
 1813562068,
 -1,
 1814064162,
 1813948756,
 -1,
 -37855,
 1813996182,
 10177,
 -1,
 1814044603,
 9186,
 -37853,
 1814028955,
 9943,
 -1,
 1814185443,
 9743,
 1814391851,
 1813928075,
 -1,
 1814457384,
 1814335887,
 -1,
 -37849,
 1814418913,
 10710,
 -1,
 1814475564,
 11053,
 1814691839,
 1814380679,
 -1,
 -37846,
 1814618919,
 11041,
 -1,
 1814635196,
 9825,
 1814850606,
 1814339561,
 -1,
 -37843,
 1814775759,
 11040,
 -1,
 1814831353,
 9649,
 -37841,
 1814793347,
 10001,
 -1,
 1814965311,
 9702,
 -1,
 1806110590,
 10163,
 1815281663,
 1806058296,
 -1,
 -37837,
 1815162693,
 9855,
 -1,
 1815217727,
 9784,
 1815440451,
 1805981044,
 -1,
 1815505985,
 1815402414,
 -1,
 1815571516,
 1815471088,
 -1,
 1815637050,
 1815507800,
 -1,
 -37831,
 1815584500,
 65103,
 -1,
 1815636066,
 8967,
 -37829,
 1815584475,
 65099,
 -1,
 1815754505,
 12336,
 1816002559,
 1815494793,
 -1,
 1816030272,
 1815880329,
 -1,
 -37825,
 1815981665,
 10547,
 -1,
 1816032901,
 11071,
 -1,
 1815951113,
 12316,
 -37822,
 1815463023,
 8986,
 -1,
 1816245193,
 9888,
 1816423496,
 1815384463,
 -1,
 1816489031,
 1816374097,
 -1,
 -37818,
 1816443293,
 11825,
 -1,
 1816490028,
 8288,
 -1,
 1816430840,
 8361,
 1816751179,
 1816373588,
 -1,
 -37814,
 1816686083,
 9997,
 -1,
 1816740256,
 8768,
 1816985599,
 1816674439,
 -1,
 -37811,
 1816903710,
 9840,
 -1,
 1816934484,
 10172,
 1817144523,
 1805938473,
 -1,
 1817210055,
 1817056628,
 -1,
 1817275588,
 1817171981,
 -1,
 1817341065,
 1817212498,
 -1,
 1817406600,
 1817300058,
 -1,
 1817472091,
 1817348319,
 -1,
 1817537623,
 1817400068,
 43412,
 1817640959,
 1817445743,
 43402,
 -1,
 1817512371,
 43403,
 1817734233,
 1817502762,
 43418,
 -1,
 1817642475,
 43416,
 1817903103,
 1817646452,
 43428,
 -1,
 1817773547,
 43423,
 1817996384,
 1817428692,
 -1,
 1818061918,
 1817953045,
 43419,
 -1,
 1817970109,
 43420,
 1818230783,
 1817974132,
 43424,
 -1,
 1818101227,
 43425,
 1818324069,
 1817916960,
 -1,
 1818389603,
 1818244747,
 43421,
 -1,
 1818297789,
 43422,
 1818558463,
 1818301812,
 43426,
 -1,
 1818428861,
 43427,
 1818651753,
 1818277785,
 43441,
 1818755071,
 1818559930,
 -1,
 -37784,
 1818678738,
 43439,
 -1,
 1818695961,
 43440,
 1818913901,
 1818599502,
 43429,
 1819017215,
 1818820608,
 -1,
 -37780,
 1818921061,
 43430,
 -1,
 1818963736,
 43401,
 1819176049,
 1818849439,
 43407,
 1819279359,
 1819082752,
 -1,
 -37776,
 1819195441,
 43408,
 -1,
 1819248741,
 43409,
 1819438196,
 1819107711,
 43398,
 -37773,
 1819369855,
 43399,
 -1,
 1819411721,
 43397,
 1819634806,
 1819388335,
 43435,
 -1,
 1819541564,
 43436,
 1819765880,
 1819569963,
 43415,
 -1,
 1819674045,
 43417,
 1819896954,
 1819693828,
 43410,
 -1,
 1819805163,
 43411,
 1820028028,
 1819815227,
 43413,
 -1,
 1819936235,
 43414,
 1820159102,
 1819944616,
 43431,
 -1,
 1820067307,
 43432,
 1820290176,
 1820071284,
 43396,
 -1,
 1820221823,
 43405,
 -37759,
 1820255274,
 43434,
 -37758,
 1820384560,
 43438,
 -37757,
 1820446282,
 43400,
 -37756,
 1820496271,
 43406,
 -37755,
 1820557362,
 43433,
 -37754,
 1820619693,
 43437,
 -37753,
 1820678313,
 43442,
 -1,
 1820737671,
 43404,
 -1,
 1817334373,
 43457,
 1821011102,
 1817288782,
 -1,
 1821076635,
 1820931726,
 -1,
 1821142160,
 1821012824,
 -1,
 1821207695,
 1821101642,
 -1,
 -37746,
 1821150283,
 43465,
 -1,
 1821204776,
 43461,
 -1,
 1821141262,
 43464,
 1821469844,
 1821054324,
 -1,
 1821535379,
 1821390703,
 43466,
 -1,
 1821442102,
 43467,
 -1,
 1821477610,
 43459,
 1821731991,
 1821417449,
 -1,
 -37738,
 1821666552,
 43468,
 -1,
 1821712035,
 43463,
 -37736,
 1821695840,
 43462,
 -37735,
 1821886694,
 43486,
 -37734,
 1821933672,
 43460,
 -1,
 1821994239,
 43487,
 1822228479,
 1821019063,
 -1,
 -37731,
 1822141126,
 43471,
 -1,
 1822192292,
 43456,
 1822387372,
 1820932504,
 -1,
 1822452898,
 1822343892,
 -1,
 -37727,
 1822417295,
 43474,
 -1,
 1822449750,
 43475,
 1822649509,
 1822406431,
 -1,
 -37724,
 1822584558,
 43478,
 -1,
 1822641282,
 43479,
 1822846120,
 1822576214,
 -1,
 -37721,
 1822792688,
 43476,
 -1,
 1822846583,
 43477,
 -37719,
 1822812053,
 43472,
 -37718,
 1822987711,
 43473,
 -37717,
 1823050940,
 43481,
 -1,
 1823098167,
 43480,
 1823304888,
 1822350518,
 -1,
 1823370418,
 1823261396,
 -1,
 1823435953,
 1823282548,
 -1,
 -37712,
 1823389365,
 43444,
 -1,
 1823439707,
 43450,
 -1,
 1823380657,
 43445,
 1823698100,
 1823335152,
 43446,
 -1,
 1823606228,
 43447,
 1823829174,
 1823654320,
 43448,
 -1,
 1823737307,
 43449,
 -37705,
 1823777358,
 43452,
 -1,
 1823881780,
 43451,
 1824091326,
 1823259696,
 -1,
 1824156859,
 1824009896,
 43393,
 -1,
 1824066245,
 43443,
 -37700,
 1824120659,
 43395,
 -37699,
 1824235732,
 43392,
 -1,
 1824290331,
 43394,
 1824484546,
 1824010898,
 -1,
 -37696,
 1824432700,
 43454,
 -37695,
 1824485864,
 43453,
 -1,
 1824533832,
 43455,
 -37693,
 1824443674,
 43469,
 -1,
 1824698329,
 43458,
 1824915455,
 1817223364,
 -1,
 -37690,
 1824811079,
 12292,
 -1,
 1824859963,
 9979,
 1825074378,
 1817169482,
 -1,
 -37687,
 1825022945,
 9795,
 -1,
 1825082766,
 9909,
 -1,
 1825018790,
 10781,
 1825336554,
 1817094081,
 -1,
 1825402083,
 1825248628,
 -1,
 1825467617,
 1825324986,
 -1,
 1825533150,
 1825382231,
 -1,
 1825598683,
 1825494105,
 -1,
 1825664216,
 1825535621,
 9624,
 1825767423,
 1825570938,
 -1,
 1825795285,
 1825690765,
 -1,
 -37676,
 1825746529,
 9628,
 -1,
 1825797765,
 9627,
 1826029567,
 1825734234,
 -1,
 -37673,
 1825943137,
 9626,
 -1,
 1825994394,
 9625,
 1826226175,
 1825615457,
 9629,
 1826291711,
 1826095349,
 9630,
 -1,
 1826160901,
 9631,
 1826422783,
 1825537626,
 -1,
 -37667,
 1826336353,
 9623,
 -1,
 1826387589,
 9622,
 1826619391,
 1825494085,
 -1,
 -37664,
 1826530923,
 8279,
 -1,
 1826580940,
 10764,
 -37662,
 1825424809,
 10774,
 -1,
 1826731576,
 9833,
 1826909416,
 1825327906,
 -1,
 1826974951,
 1826816000,
 -1,
 -37658,
 1826914906,
 63,
 -1,
 1826966906,
 8264,
 -1,
 1826898596,
 8799,
 -37655,
 1826855570,
 34,
 -1,
 1827170264,
 9915,
 1827368197,
 1825302302,
 -1,
 1827433727,
 1827276311,
 -1,
 1827499251,
 1827387167,
 -1,
 1827564786,
 1827418018,
 -1,
 1827630321,
 1827512297,
 -1,
 -37648,
 1827582990,
 10785,
 -1,
 1827630031,
 10784,
 -1,
 1827549794,
 10783,
 -1,
 1827513722,
 10625,
 1827958009,
 1827449172,
 -1,
 1828023543,
 1827890408,
 -1,
 -37642,
 1827956330,
 10632,
 -1,
 1828006266,
 10634,
 -37640,
 1827947977,
 10814,
 -1,
 1828134542,
 10853,
 1828351228,
 1827894922,
 -1,
 -37637,
 1828284010,
 10631,
 -1,
 1828333946,
 10633,
 -37635,
 1828310579,
 10626,
 -37634,
 1828469505,
 10852,
 -1,
 1828529889,
 8959,
 1828782079,
 1827359234,
 -1,
 1828809987,
 1828687246,
 -1,
 -37630,
 1828751658,
 8204,
 -1,
 1828785922,
 65279,
 -37628,
 1828765421,
 8203,
 -1,
 1828941868,
 8205,
 1829175295,
 1827332868,
 -1,
 -37625,
 1829083126,
 8891,
 -1,
 1829110937,
 8999]
_charnames_32 = [
19793,
11930,
27880,
26833,
24411,
26456,
14011,
13811,
9736,
25505,
13995,
26421,
3790,
21089,
27331,
19716,
24746,
24750,
24720,
24724,
24738,
24742,
24729,
24733,
24758,
24754,
4033,
19747,
10007,
11882,
21793,
27877,
3789,
8552,
8979,
8903,
8854,
8603,
9011,
8889,
8872,
8725,
9007,
8933,
8798,
8989,
8836,
8493,
8969,
9003,
8776,
8757,
8693,
8649,
8959,
8947,
8999,
8819,
8917,
9640,
25869,
25438,
4958,
10100,
21795,
7965,
8373,
8284,
8206,
7908,
8445,
8358,
8264,
8174,
8452,
8342,
8139,
8413,
8240,
7848,
8400,
8438,
8103,
8069,
7780,
8020,
8387,
8426,
8459,
8324,
8304,
9689,
24037,
25491,
17793,
]

_charnames_160 = [
26797,
27135,
5207,
26474,
2535,
15318,
15581,
19753,
24832,
3985,
27395,
9862,
26776,
19720,
25896,
6527,
24709,
26438,
19316,
19317,
14004,
7772,
26467,
7770,
5209,
19330,
6524,
25630,
24077,
24079,
24084,
27131,
8589,
8590,
8555,
8583,
8570,
8580,
8591,
8906,
8635,
8637,
8606,
8624,
8745,
8747,
8738,
8733,
8643,
8849,
8543,
8545,
8516,
8524,
8513,
7346,
8535,
8688,
8690,
8680,
8653,
8834,
8720,
8101,
8006,
8007,
7968,
8000,
7983,
7995,
8008,
8287,
7942,
7944,
7911,
7929,
8193,
8195,
8185,
8180,
7960,
8255,
7897,
7899,
7871,
7879,
7868,
24845,
7892,
8061,
8063,
8051,
8024,
8340,
7838,
8330,
8586,
8003,
8572,
7985,
8585,
8002,
8913,
8295,
8908,
8290,
8912,
8294,
8909,
8291,
8863,
8212,
8859,
8221,
8625,
7930,
8636,
7943,
8622,
7927,
8632,
7938,
8617,
7922,
8892,
8361,
8899,
8369,
8898,
8368,
8893,
8362,
8881,
8273,
8884,
8276,
8735,
8182,
8742,
8190,
8746,
8194,
8741,
8189,
8731,
8234,
9017,
8475,
9010,
8456,
8942,
8351,
8357,
8817,
8161,
8806,
8144,
8807,
8145,
8813,
8152,
8809,
8156,
8852,
8260,
8844,
8246,
8845,
8247,
8261,
8648,
7964,
8530,
7884,
8544,
7898,
8512,
7867,
9016,
8473,
8792,
8125,
8786,
8118,
8787,
8119,
8769,
8081,
8763,
8075,
8764,
8076,
8760,
8072,
8698,
7816,
8699,
7817,
8705,
7825,
8675,
8046,
8683,
8057,
8689,
8062,
8685,
8055,
8664,
8035,
8686,
8059,
8956,
8436,
8833,
8339,
8825,
8932,
8323,
8922,
8309,
8929,
8314,
8162,
8379,
8987,
8984,
8378,
8718,
7834,
8547,
8911,
8293,
8601,
8869,
8867,
8214,
7809,
8795,
8774,
8548,
9013,
8449,
8897,
8902,
8282,
8756,
8740,
8945,
8355,
8155,
8173,
8713,
8841,
8249,
8534,
8496,
7851,
8551,
7907,
8975,
8408,
9081,
8717,
7833,
8647,
9067,
7827,
8708,
7830,
8706,
8667,
8038,
8692,
8965,
8826,
8331,
8926,
8317,
8638,
8641,
7953,
7951,
9084,
8719,
7835,
9075,
9082,
9087,
9086,
9079,
9068,
8871,
8858,
8229,
8818,
8810,
8171,
8853,
8850,
8263,
8562,
7975,
8739,
8186,
8523,
7878,
8682,
8053,
8656,
8027,
8659,
8030,
8658,
8029,
8657,
8028,
7808,
8571,
7984,
8567,
7980,
8593,
8010,
8895,
8364,
8894,
8363,
8943,
8352,
8537,
7894,
8538,
7895,
8640,
7950,
8457,
8870,
8857,
8225,
8900,
8370,
8886,
8958,
8851,
8259,
8581,
7996,
8594,
8011,
8536,
7893,
8569,
7982,
8587,
8004,
8623,
7928,
8633,
7940,
8732,
8178,
8743,
8191,
8511,
7866,
8542,
7896,
8784,
8111,
8791,
8124,
8663,
8034,
8687,
8060,
8762,
8074,
8696,
7814,
8835,
8341,
8883,
8275,
8839,
8209,
8549,
7905,
8931,
8322,
8566,
7979,
8615,
7920,
8514,
7869,
8526,
7881,
8507,
7862,
8508,
7863,
8830,
8336,
8142,
8244,
7813,
8231,
8239,
8444,
8584,
8910,
8292,
8816,
8704,
8083,
8316,
8901,
8371,
8985,
8691,
8712,
8631,
7936,
9009,
8458,
8772,
8441,
8789,
8121,
8829,
8334,
7791,
8014,
7792,
8383,
7901,
8289,
8215,
8216,
8135,
8095,
8098,
7903,
8128,
8131,
8300,
8232,
8367,
8099,
9042,
8372,
8138,
7788,
8278,
8281,
8187,
8203,
9040,
8151,
8154,
8157,
8172,
7797,
7798,
8420,
8251,
8256,
9055,
8386,
9030,
8299,
8412,
7783,
7786,
7787,
8113,
8120,
8115,
8134,
9022,
9041,
8086,
7954,
8233,
8100,
7958,
7804,
7826,
8064,
8065,
8395,
7803,
7802,
7801,
9049,
8318,
8312,
7945,
7949,
9076,
9085,
9074,
9063,
9072,
9044,
8298,
9043,
9059,
8455,
7806,
9038,
8440,
9077,
9066,
8227,
8236,
8228,
7843,
7845,
7846,
8451,
8170,
8168,
9071,
9073,
7789,
7790,
6618,
6619,
6613,
6586,
6538,
6539,
6552,
6622,
6620,
6791,
6761,
6788,
6797,
6717,
6713,
6703,
6779,
6716,
6704,
6714,
6774,
6759,
6675,
3400,
6786,
6751,
6798,
6778,
6694,
6696,
6698,
6700,
6789,
6770,
6670,
6671,
6773,
6758,
6792,
6750,
15582,
24395,
25644,
25381,
19674,
24293,
6718,
6673,
6574,
6594,
6559,
6621,
6589,
6731,
6768,
6743,
6689,
6725,
6782,
6783,
6785,
6776,
6762,
6687,
6695,
6681,
6693,
6692,
6749,
6747,
6748,
6690,
6711,
6795,
6735,
6794,
6734,
6630,
6799,
6680,
3668,
3678,
3485,
3728,
3696,
3764,
3744,
3590,
3621,
3767,
3648,
3587,
3479,
3759,
3569,
3585,
3481,
3738,
3732,
3474,
3651,
3475,
3669,
3679,
3548,
3643,
3539,
3766,
3542,
3753,
3596,
3776,
3705,
3777,
3653,
3592,
3622,
3647,
3476,
3487,
3762,
3758,
3748,
3741,
3480,
3486,
3746,
3739,
3731,
3704,
3559,
3583,
3730,
3720,
3555,
3721,
3556,
3640,
3740,
3724,
3726,
3774,
3760,
3582,
3670,
3680,
3662,
3663,
3664,
3661,
3749,
3716,
3568,
3538,
3785,
3768,
3694,
3546,
3752,
3674,
3633,
3543,
3783,
3773,
3532,
3634,
3631,
3641,
3591,
3690,
3576,
3771,
3581,
3580,
3578,
3579,
3571,
3584,
3577,
3491,
3503,
3501,
3513,
3510,
3505,
3520,
3517,
3515,
3495,
3511,
3509,
3508,
21493,
21306,
21437,
21220,
21750,
21680,
21477,
21287,
-1,
-1,
21739,
21312,
21314,
21313,
21749,
-1,
-1,
-1,
-1,
-1,
21705,
21688,
21434,
21589,
21404,
21391,
21455,
-1,
21363,
-1,
21470,
21350,
21255,
21407,
21497,
21494,
21495,
21393,
21487,
21366,
21483,
21438,
21492,
21491,
21490,
21489,
21488,
21352,
21475,
21485,
-1,
21479,
21484,
21458,
21476,
21496,
21474,
21325,
21446,
21466,
21217,
21184,
21172,
21273,
21228,
21187,
21310,
21307,
21300,
21173,
21301,
21144,
21293,
21249,
21297,
21305,
21304,
21303,
21302,
21130,
21285,
21288,
21308,
21281,
21294,
21222,
21286,
21309,
21284,
21101,
21252,
21225,
21141,
21246,
21129,
21503,
21752,
21700,
21730,
21732,
21731,
21715,
21714,
21726,
21676,
21221,
21671,
21280,
21675,
21299,
21674,
21296,
21672,
21279,
3925,
3833,
3959,
3867,
3939,
3847,
3952,
3860,
3955,
3863,
3924,
3832,
3920,
3828,
21725,
21736,
21678,
21673,
21502,
21679,
21737,
21480,
21282,
21498,
21481,
21278,
21735,
21500,
21504,
21501,
4327,
4315,
4363,
4435,
4443,
4358,
4413,
4392,
4492,
4480,
4484,
4397,
4312,
4331,
4340,
4362,
4417,
4416,
4490,
4428,
4367,
4325,
4370,
4377,
4314,
4338,
4305,
4279,
4288,
4273,
4468,
4474,
4286,
4284,
4399,
4436,
4290,
4445,
4398,
4453,
4344,
4343,
4450,
4383,
4349,
4272,
4390,
4387,
4188,
4187,
4262,
4199,
4138,
4096,
4141,
4148,
4085,
4109,
4076,
4050,
4059,
4044,
4246,
4240,
4057,
4055,
4170,
4207,
4061,
4216,
4169,
4224,
4115,
4114,
4221,
4154,
4120,
4043,
4161,
4158,
4098,
4086,
4134,
4206,
4214,
4129,
4184,
4163,
4264,
4252,
4256,
4168,
4083,
4102,
4111,
4133,
4469,
4247,
4388,
4159,
4320,
4091,
4481,
4253,
4319,
4090,
4412,
4183,
4322,
4093,
4311,
4082,
4478,
4244,
4493,
4265,
4333,
4104,
4334,
4105,
4442,
4213,
4466,
4237,
4470,
4248,
4471,
4249,
4304,
4075,
4502,
3462,
3458,
3471,
3459,
3460,
3466,
3469,
4339,
4110,
4355,
4126,
4287,
4058,
4432,
4203,
4430,
4201,
4433,
4204,
4374,
4145,
4380,
4151,
4310,
4081,
4307,
4078,
4308,
4079,
4409,
4180,
4278,
4049,
4496,
4268,
4476,
4242,
4421,
4192,
4285,
4056,
4402,
4173,
4351,
4122,
4352,
4123,
4449,
4220,
4495,
4267,
4457,
4228,
4458,
4229,
4342,
4113,
4419,
4190,
4420,
4191,
4500,
4375,
4146,
4309,
4080,
4281,
4052,
4277,
4048,
4275,
4046,
4313,
4084,
4289,
4060,
4245,
4425,
4196,
4424,
4195,
4497,
4269,
4328,
4099,
4353,
4124,
4354,
4125,
4373,
4144,
4379,
4150,
4422,
4193,
4330,
4101,
4332,
4103,
4472,
4250,
4407,
4178,
4408,
4179,
4291,
4062,
4441,
4212,
4440,
4211,
4439,
4210,
4456,
4227,
4434,
4205,
4385,
4156,
4431,
4202,
4448,
4219,
4447,
4218,
4298,
4069,
4297,
4068,
4299,
4070,
4296,
4067,
4303,
4074,
4302,
4073,
4301,
4072,
4300,
4071,
4463,
4234,
4283,
4054,
4482,
4254,
4467,
4238,
4389,
4160,
4491,
4263,
4489,
4261,
4426,
4197,
4282,
4053,
4276,
4047,
4477,
4243,
]

_charnames_1329 = [
13682,
13681,
13670,
13680,
13642,
13645,
13641,
13640,
13652,
13644,
13677,
13676,
13672,
13638,
13664,
13678,
13668,
13671,
13635,
13675,
13646,
13674,
13655,
13649,
13636,
13662,
13667,
13659,
13656,
13650,
13653,
13658,
13637,
13647,
13661,
13665,
13673,
13679,
-1,
-1,
13691,
13688,
13686,
13685,
13683,
13690,
13689,
-1,
13622,
13621,
13610,
13620,
13582,
13585,
13581,
13580,
13592,
13584,
13617,
13616,
13612,
13578,
13604,
13618,
13608,
13611,
13575,
13615,
13586,
13614,
13595,
13589,
13576,
13602,
13607,
13599,
13596,
13590,
13593,
13598,
13577,
13587,
13601,
13605,
13613,
13619,
13630,
-1,
13693,
13692,
-1,
-1,
-1,
-1,
-1,
-1,
20734,
20721,
20720,
20696,
20697,
20706,
20731,
20698,
20727,
20717,
20705,
20713,
20714,
20715,
20723,
20704,
20726,
20735,
20710,
20711,
20708,
20709,
20730,
20724,
20703,
20718,
20732,
20733,
20729,
20699,
20772,
20749,
20740,
20742,
20741,
20745,
20756,
20751,
20758,
20753,
20743,
20744,
20755,
20761,
20759,
20769,
20757,
20767,
20748,
20750,
20766,
20771,
20773,
20768,
20754,
]

_charnames_1488 = [
20629,
20664,
20680,
20682,
20661,
20649,
20668,
20662,
20641,
20645,
20622,
20657,
20678,
20626,
20676,
20625,
20674,
20617,
20637,
20620,
20653,
20624,
20639,
20672,
20670,
20608,
20643,
-1,
-1,
-1,
-1,
-1,
20688,
20690,
20687,
20765,
20764,
]

_charnames_1536 = [
13547,
13464,
13497,
13466,
-1,
-1,
13569,
13568,
13529,
13567,
13566,
14021,
13549,
13507,
13531,
13474,
13465,
13475,
13471,
13472,
13473,
13444,
13435,
13445,
13459,
13460,
13458,
13487,
-1,
-1,
13514,
13546,
-1,
12914,
12988,
12984,
13313,
12980,
13152,
12975,
13217,
12793,
12790,
12843,
13377,
12892,
13061,
12923,
12850,
13185,
13361,
13111,
13138,
13128,
12938,
12854,
13354,
13008,
13295,
13032,
13030,
13260,
13258,
13259,
13511,
13266,
13397,
13039,
13339,
13407,
13069,
12863,
13310,
13002,
13149,
13494,
13502,
13517,
13489,
13501,
13516,
13482,
13477,
13541,
13544,
13543,
13481,
13548,
13540,
13545,
13523,
13524,
13525,
13528,
13491,
-1,
13561,
13562,
13553,
13554,
13559,
13560,
13556,
13557,
13564,
13563,
13533,
13508,
13515,
13498,
12973,
12971,
13147,
12998,
12994,
12993,
12916,
12920,
12919,
13390,
12918,
12828,
12829,
13241,
12801,
12800,
13325,
12806,
13234,
12907,
12897,
13103,
12959,
12901,
12813,
12814,
12951,
12934,
12932,
12933,
12946,
12955,
12966,
12928,
12935,
13212,
13190,
13199,
13197,
13191,
13198,
13196,
13384,
13202,
13122,
13115,
13116,
13131,
13132,
12859,
13016,
12972,
13275,
13276,
13366,
13272,
13326,
13401,
13400,
13024,
13146,
13045,
13046,
13089,
13044,
13283,
13289,
13090,
13287,
13303,
13288,
13345,
13346,
13344,
13343,
13079,
13080,
13205,
13078,
13074,
12873,
12825,
12881,
12865,
12870,
12796,
13321,
13057,
13424,
13388,
13180,
13053,
13320,
13365,
13249,
13161,
13162,
13322,
13417,
13160,
13163,
13166,
13496,
13022,
13433,
13434,
13440,
13436,
13451,
13443,
13448,
13538,
13486,
13449,
13447,
13452,
13439,
13454,
13441,
13457,
13456,
13446,
13450,
13532,
13536,
13537,
13527,
13455,
12930,
13200,
11923,
11924,
11915,
11916,
11921,
11922,
11918,
11919,
11926,
11925,
13143,
12943,
13300,
13469,
13468,
12885,
18885,
18855,
18859,
18853,
18857,
18850,
18889,
18888,
18854,
18858,
18890,
18847,
18848,
18849,
-1,
18901,
18839,
18804,
18838,
18824,
18825,
18828,
18827,
18822,
18830,
18829,
18823,
18814,
18815,
18817,
18818,
18835,
18834,
18833,
18832,
18806,
18836,
18837,
18808,
18821,
18807,
18831,
18820,
18805,
18816,
18812,
18810,
18811,
18880,
18879,
18878,
18876,
18875,
18874,
18870,
18869,
18895,
18896,
18844,
18843,
18845,
18884,
18883,
18871,
18899,
18897,
18872,
18863,
18862,
18866,
18865,
18893,
18892,
18898,
18900,
-1,
-1,
18801,
18802,
18803,
13224,
13228,
13222,
13223,
13225,
13227,
13226,
12898,
12900,
12927,
12931,
13193,
13120,
13013,
13015,
13012,
13273,
13271,
13033,
13031,
13029,
13411,
13410,
13073,
13077,
13076,
13347,
13195,
13201,
13117,
12906,
12904,
13118,
13192,
12905,
12996,
12997,
13254,
13255,
13256,
13318,
13319,
13171,
13172,
12908,
13121,
13119,
13043,
18242,
18214,
18232,
18249,
18256,
18235,
18239,
18244,
18248,
18252,
18254,
18230,
18206,
18236,
18225,
18223,
18215,
18228,
18219,
18210,
18246,
18251,
18253,
18255,
18208,
18241,
18238,
18207,
18220,
18213,
18216,
18229,
18209,
18221,
18245,
18224,
18250,
18247,
18266,
18267,
18270,
18263,
18268,
18258,
18264,
18262,
18259,
18260,
18269,
18233,
]

_charnames_1984 = [
26693,
26694,
26685,
26686,
26691,
26692,
26688,
26689,
26696,
26695,
26680,
26662,
26674,
26661,
26667,
26660,
26659,
26664,
26645,
26679,
26670,
26668,
26655,
26678,
26663,
26658,
26657,
26669,
26676,
26677,
26673,
26672,
26649,
26671,
26646,
26648,
26675,
26666,
26665,
26647,
26653,
26654,
26652,
26707,
26706,
26705,
26703,
26702,
26701,
26700,
26708,
26709,
26714,
26681,
26712,
26713,
26710,
26715,
26682,
-1,
-1,
-1,
-1,
-1,
19155,
19142,
19152,
19154,
19135,
19143,
19144,
19136,
19132,
19145,
19151,
19150,
19149,
19148,
19139,
19137,
19153,
19131,
19147,
19146,
19140,
19133,
19195,
19196,
19197,
19200,
19204,
19199,
19162,
19173,
19165,
19159,
19170,
19164,
19158,
19169,
19202,
19168,
19160,
19171,
19203,
19161,
19172,
19163,
19167,
19198,
-1,
-1,
19190,
19181,
19178,
19192,
19179,
19187,
19205,
19191,
19183,
19189,
19184,
19188,
19180,
19186,
19177,
]

_charnames_2304 = [
24556,
24540,
24552,
24548,
24420,
24467,
24470,
24504,
24505,
24499,
24500,
24435,
24437,
24458,
24419,
24513,
24469,
24457,
24418,
24510,
24468,
24484,
24483,
24453,
24450,
24445,
24455,
24460,
24488,
24487,
24444,
24464,
24463,
24430,
24429,
24443,
24466,
24465,
24432,
24431,
24446,
24442,
24503,
24502,
24492,
24490,
24511,
24498,
24474,
24472,
24479,
24478,
24477,
24439,
24421,
24422,
24423,
24508,
-1,
-1,
24555,
24551,
24527,
24533,
24534,
24528,
24529,
24516,
24517,
24523,
24532,
24537,
24526,
24521,
24531,
24536,
24525,
24549,
24535,
-1,
24585,
24560,
24561,
24580,
24583,
24522,
-1,
-1,
24509,
24482,
24449,
24495,
24427,
24473,
24512,
24497,
24436,
24438,
24518,
24519,
24578,
24577,
24573,
24574,
24565,
24566,
24571,
24572,
24568,
24569,
24576,
24575,
24584,
24557,
24459,
-1,
-1,
-1,
-1,
-1,
-1,
24494,
24507,
24452,
24486,
24451,
24428,
24491,
-1,
16643,
16641,
16637,
-1,
16566,
16569,
16589,
16590,
16581,
16582,
16545,
16547,
-1,
-1,
16604,
16568,
-1,
-1,
16600,
16567,
16577,
16575,
16593,
16592,
16558,
16596,
16595,
16588,
16587,
16556,
16552,
16551,
16563,
16562,
16557,
16554,
16553,
16565,
16564,
16559,
-1,
16585,
16584,
16599,
16598,
16601,
16580,
16538,
-1,
16602,
-1,
-1,
-1,
16572,
16571,
16573,
16603,
-1,
-1,
16642,
16640,
16614,
16617,
16618,
16615,
16616,
16607,
16608,
-1,
-1,
16620,
16613,
-1,
-1,
16619,
16612,
16638,
16576,
]

_charnames_2519 = [
16658,
-1,
-1,
-1,
-1,
16542,
16543,
-1,
16579,
16546,
16548,
16609,
16610,
-1,
-1,
16631,
16632,
16623,
16624,
16629,
16630,
16626,
16627,
16634,
16633,
16540,
16541,
16655,
16654,
16649,
16647,
16648,
16651,
16650,
16652,
16656,
16657,
-1,
-1,
-1,
-1,
-1,
22009,
22008,
22003,
-1,
21929,
21932,
21960,
21961,
21943,
21944,
-1,
-1,
-1,
-1,
21975,
21931,
-1,
-1,
21971,
21930,
21937,
21936,
21942,
21941,
21921,
21964,
21963,
21959,
21958,
21919,
21915,
21914,
21926,
21925,
21920,
21917,
21916,
21928,
21927,
21922,
-1,
21953,
21952,
21967,
21966,
21972,
21969,
21950,
-1,
21956,
21955,
-1,
21970,
21946,
-1,
21947,
21973,
-1,
-1,
22007,
-1,
21994,
21997,
21998,
21995,
21996,
-1,
-1,
-1,
-1,
22000,
21993,
-1,
-1,
21999,
21992,
22004,
-1,
-1,
-1,
22006,
]

_charnames_2662 = [
21986,
21987,
21978,
21979,
21984,
21985,
21981,
21982,
21989,
21988,
22011,
22014,
22012,
22010,
22013,
22005,
]

_charnames_2689 = [
21907,
21905,
21901,
-1,
21823,
21826,
21845,
21846,
21831,
21832,
21801,
21803,
21884,
-1,
21861,
21825,
21883,
-1,
21858,
21824,
21841,
21840,
21849,
21848,
21815,
21852,
21851,
21844,
21843,
21813,
21809,
21808,
21820,
21819,
21814,
21811,
21810,
21822,
21821,
21816,
-1,
21835,
21834,
21855,
21854,
21859,
21856,
21857,
-1,
21838,
21837,
-1,
21805,
21829,
21828,
21830,
21860,
-1,
-1,
21906,
21904,
21872,
21875,
21876,
21873,
21874,
21865,
21866,
21879,
-1,
21881,
21871,
21878,
-1,
21880,
21870,
21902,
-1,
-1,
21909,
]

_charnames_2784 = [
21802,
21804,
21867,
21868,
-1,
-1,
21895,
21896,
21887,
21888,
21893,
21894,
21890,
21891,
21898,
21897,
-1,
21908,
]

_charnames_2817 = [
25282,
25280,
25276,
-1,
25199,
25202,
25228,
25229,
25214,
25215,
25177,
25179,
-1,
-1,
25243,
25201,
-1,
-1,
25240,
25200,
25224,
25223,
25232,
25231,
25191,
25235,
25234,
25227,
25226,
25189,
25185,
25184,
25196,
25195,
25190,
25187,
25186,
25198,
25197,
25192,
-1,
25218,
25217,
25238,
25237,
25241,
25213,
25210,
-1,
25221,
25220,
-1,
25181,
25205,
25204,
25206,
25242,
-1,
-1,
25281,
25279,
25253,
25256,
25257,
25254,
25255,
25246,
25247,
-1,
-1,
25259,
25252,
-1,
-1,
25258,
25251,
25277,
]

_charnames_2902 = [
25285,
25284,
-1,
-1,
-1,
-1,
25208,
25209,
-1,
25212,
25178,
25180,
25248,
25249,
-1,
-1,
25270,
25271,
25262,
25263,
25268,
25269,
25265,
25266,
25273,
25272,
25286,
25239,
]

_charnames_2946 = [
17431,
17429,
-1,
17356,
17359,
17379,
17380,
17369,
17370,
-1,
-1,
-1,
17381,
17382,
17358,
-1,
17377,
17378,
17357,
17387,
-1,
-1,
-1,
17354,
17390,
-1,
17388,
-1,
17353,
17372,
-1,
-1,
-1,
17352,
17373,
-1,
-1,
-1,
17355,
17351,
17385,
-1,
-1,
-1,
17386,
17383,
17376,
17375,
17368,
17367,
17366,
17384,
17362,
17361,
17363,
17389,
-1,
-1,
-1,
-1,
17412,
17417,
17418,
17413,
17414,
-1,
-1,
-1,
17419,
17420,
17411,
-1,
17415,
17416,
17410,
17430,
-1,
-1,
17437,
-1,
-1,
-1,
-1,
-1,
-1,
17433,
]

_charnames_3046 = [
17402,
17403,
17394,
17395,
17400,
17401,
17397,
17398,
17405,
17404,
17425,
17424,
17423,
17407,
17438,
17435,
17406,
17439,
17434,
17436,
17426,
-1,
-1,
-1,
-1,
-1,
-1,
17943,
17941,
17937,
-1,
17847,
17850,
17874,
17875,
17855,
17856,
17823,
17825,
-1,
17879,
17880,
17849,
-1,
17863,
17864,
17848,
17870,
17869,
17878,
17877,
17845,
17883,
17882,
17873,
17872,
17843,
17831,
17830,
17838,
17837,
17844,
17834,
17833,
17841,
17840,
17846,
-1,
17862,
17861,
17886,
17885,
17888,
17887,
17859,
17858,
17867,
17866,
-1,
17827,
17853,
17852,
17854,
17889,
-1,
-1,
-1,
17940,
17900,
17905,
17906,
17901,
17902,
17893,
17894,
-1,
17907,
17908,
17899,
-1,
17903,
17904,
17898,
17938,
]

_charnames_3157 = [
17890,
17944,
-1,
17832,
17839,
-1,
-1,
-1,
-1,
-1,
-1,
17824,
17826,
17895,
17896,
-1,
-1,
17919,
17920,
17911,
17912,
17917,
17918,
17914,
17915,
17922,
17921,
]

_charnames_3192 = [
17934,
17932,
17926,
17929,
17933,
17927,
17930,
17942,
-1,
-1,
22773,
22769,
-1,
22690,
22693,
22717,
22718,
22698,
22699,
22668,
22670,
-1,
22722,
22723,
22692,
-1,
22706,
22707,
22691,
22713,
22712,
22721,
22720,
22682,
22726,
22725,
22716,
22715,
22680,
22676,
22675,
22687,
22686,
22681,
22678,
22677,
22689,
22688,
22683,
-1,
22705,
22704,
22729,
22728,
22731,
22730,
22702,
22701,
22710,
22709,
-1,
22672,
22696,
22695,
22697,
22732,
-1,
-1,
22775,
22772,
22744,
22749,
22750,
22745,
22746,
22737,
22738,
-1,
22751,
22752,
22743,
-1,
22747,
22748,
22742,
22770,
]

_charnames_3294 = [
22733,
-1,
22669,
22671,
22739,
22740,
-1,
-1,
22763,
22764,
22755,
22756,
22761,
22762,
22758,
22759,
22766,
22765,
-1,
22776,
22774,
]

_charnames_3330 = [
6432,
6428,
-1,
6350,
6353,
6379,
6380,
6363,
6364,
6328,
6330,
-1,
6384,
6385,
6352,
-1,
6371,
6372,
6351,
6375,
6374,
6383,
6382,
6342,
6325,
6324,
6378,
6377,
6340,
6336,
6335,
6347,
6346,
6341,
6338,
6337,
6349,
6348,
6343,
-1,
6370,
6369,
6388,
6387,
6390,
6389,
6367,
6366,
6362,
6361,
6360,
6332,
6356,
6355,
6357,
6391,
-1,
-1,
-1,
6431,
6401,
6406,
6407,
6402,
6403,
6394,
6395,
-1,
6408,
6409,
6400,
-1,
6404,
6405,
6399,
6429,
]

_charnames_3424 = [
6329,
6331,
6396,
6397,
-1,
-1,
6421,
6422,
6413,
6414,
6419,
6420,
6416,
6417,
6424,
6423,
6437,
6436,
6435,
6440,
6441,
6442,
-1,
-1,
-1,
6425,
6319,
6318,
6322,
6320,
6321,
6323,
-1,
-1,
19507,
19509,
-1,
19416,
19420,
19414,
19415,
19448,
19449,
19466,
19467,
19443,
19444,
19446,
19447,
19472,
19473,
19419,
19469,
19470,
19417,
-1,
-1,
-1,
19408,
19431,
19410,
19433,
19477,
19455,
19411,
19434,
19409,
19432,
19460,
19459,
19454,
19402,
19425,
19405,
19428,
19439,
19452,
19403,
19426,
19406,
19429,
19463,
-1,
19453,
19407,
19430,
19412,
19435,
19436,
19418,
19474,
19476,
-1,
19464,
-1,
-1,
19475,
19458,
19438,
19462,
19478,
19440,
19479,
-1,
-1,
-1,
19508,
-1,
-1,
-1,
-1,
19504,
19492,
19500,
19491,
19499,
19490,
-1,
19497,
-1,
19503,
19483,
19498,
19488,
19487,
19486,
19485,
19502,
]

_charnames_3585 = [
18138,
18135,
18133,
18132,
18134,
18136,
18154,
18162,
18165,
18163,
18098,
18164,
18168,
18183,
18115,
18106,
18111,
18110,
18152,
18182,
18114,
18108,
18107,
18109,
18151,
18186,
18147,
18143,
18172,
18144,
18173,
18145,
18127,
18169,
18177,
18176,
18157,
18159,
18184,
18099,
18100,
18097,
18180,
18158,
18185,
18179,
18148,
18080,
18122,
18086,
18084,
18091,
18092,
18088,
18089,
18087,
18090,
18146,
-1,
-1,
-1,
-1,
18188,
18094,
18085,
18093,
18082,
18083,
18160,
18125,
18126,
18123,
18121,
18120,
18124,
18112,
18153,
18170,
18174,
18199,
18200,
18191,
18192,
18197,
18198,
18194,
18195,
18202,
18201,
18187,
18137,
]

_charnames_3713 = [
9116,
9115,
-1,
9114,
-1,
-1,
9111,
9134,
-1,
9118,
-1,
-1,
9109,
-1,
-1,
-1,
-1,
-1,
-1,
9133,
9102,
9101,
9100,
-1,
9110,
9135,
9107,
9106,
9127,
9105,
9128,
-1,
9132,
9129,
9122,
-1,
9121,
-1,
9130,
-1,
-1,
9119,
9125,
-1,
9131,
9124,
9182,
9137,
9148,
9141,
9139,
9149,
9150,
9142,
9143,
9144,
9145,
-1,
9147,
9176,
9175,
-1,
-1,
9151,
9152,
9153,
9138,
9140,
-1,
9181,
-1,
9172,
9171,
9170,
9173,
9183,
9180,
-1,
-1,
9164,
9165,
9156,
9157,
9162,
9163,
9159,
9160,
9167,
9166,
-1,
-1,
9178,
9179,
]

_charnames_3840 = [
17549,
17621,
17619,
17620,
17653,
17633,
17631,
17668,
17661,
17647,
17650,
17655,
17672,
17660,
17640,
17657,
17639,
17663,
17664,
17629,
17622,
17613,
17612,
17725,
17727,
17726,
17518,
17517,
17516,
17512,
17511,
17519,
17697,
17698,
17689,
17690,
17695,
17696,
17692,
17693,
17700,
17699,
17685,
17676,
17677,
17682,
17683,
17679,
17680,
17687,
17686,
17684,
17649,
17643,
17630,
17642,
17635,
17658,
17624,
17625,
17666,
17667,
17523,
17527,
17579,
17578,
17595,
17594,
17573,
17598,
17597,
17606,
-1,
17571,
17555,
17554,
17567,
17566,
17572,
17560,
17559,
17569,
17568,
17574,
17592,
17591,
17601,
17600,
17604,
17558,
17557,
17564,
17563,
17603,
17585,
17586,
17610,
17602,
17589,
17605,
17582,
17581,
17583,
17607,
17609,
17576,
17608,
17577,
17588,
-1,
-1,
-1,
-1,
17717,
17713,
17714,
17707,
17708,
17703,
17704,
17705,
17706,
17715,
17716,
17711,
17712,
17521,
17520,
17709,
17710,
17535,
17534,
17671,
17669,
17529,
17524,
17530,
17526,
17533,
17532,
-1,
-1,
-1,
-1,
17476,
17475,
17489,
17488,
17467,
17492,
17491,
17501,
-1,
17465,
17449,
17448,
17461,
17460,
17466,
17454,
17453,
17463,
17462,
17468,
17486,
17485,
17495,
17494,
17499,
17452,
17451,
17458,
17457,
17497,
17482,
17483,
17504,
17496,
17498,
17500,
17471,
17470,
17472,
17502,
17503,
17474,
17479,
17478,
17480,
-1,
17728,
17729,
17721,
17720,
17722,
17719,
17548,
17543,
17547,
17544,
17546,
17538,
17540,
17541,
17542,
-1,
17513,
17510,
17648,
17670,
17638,
17654,
17634,
25636,
9868,
25637,
9869,
]

_charnames_4096 = [
7397,
7369,
7466,
7465,
7434,
7488,
7487,
7483,
7482,
7433,
7431,
7444,
7443,
7455,
7454,
7432,
7446,
7445,
7457,
7456,
7435,
7477,
7476,
7491,
7490,
7428,
7492,
7474,
7480,
7462,
7419,
7494,
7479,
7467,
7416,
7484,
7485,
7470,
7471,
7447,
7427,
7493,
7468,
7594,
7577,
7590,
7591,
7585,
7586,
7592,
7574,
7589,
7588,
7593,
7528,
7532,
7521,
7522,
7527,
7613,
7615,
7614,
7616,
7464,
7606,
7607,
7598,
7599,
7604,
7605,
7601,
7602,
7609,
7608,
7531,
7513,
7557,
7559,
7553,
7558,
7399,
7417,
7437,
7438,
7439,
7440,
7569,
7570,
7571,
7572,
7425,
7426,
7424,
7423,
7618,
7619,
7620,
7418,
7567,
7624,
7623,
7460,
7461,
7584,
7583,
7519,
7518,
7517,
7516,
7515,
7450,
7449,
7451,
7595,
7580,
7579,
7581,
7406,
7405,
7411,
7414,
7407,
7402,
7413,
7403,
7409,
7412,
7415,
7408,
7410,
7621,
7566,
7563,
7564,
7565,
7507,
7506,
7505,
7504,
7511,
7510,
7512,
7473,
7529,
7543,
7544,
7535,
7536,
7541,
7542,
7538,
7539,
7546,
7545,
7525,
7524,
7575,
7576,
7555,
7556,
22176,
22175,
22161,
22174,
22173,
22164,
22143,
22146,
22172,
22155,
22171,
22170,
22169,
22168,
22152,
22142,
22166,
22149,
22145,
22165,
22151,
22154,
22160,
22167,
22148,
22137,
22140,
22157,
22139,
22138,
22162,
22158,
22131,
22134,
22133,
22163,
22130,
22132,
]

_charnames_4304 = [
22060,
22076,
22055,
22075,
22057,
22065,
22040,
22036,
22073,
22049,
22072,
22071,
22070,
22069,
22046,
22039,
22067,
22043,
22035,
22066,
22045,
22048,
22054,
22068,
22042,
22029,
22032,
22051,
22031,
22030,
22063,
22052,
22023,
22026,
22025,
22064,
22022,
22024,
22074,
22062,
22058,
22037,
22061,
22177,
6780,
-1,
-1,
-1,
20252,
20140,
20255,
20235,
20130,
20199,
20263,
20144,
20138,
20107,
20132,
20217,
20197,
20134,
20184,
20254,
20243,
20168,
20272,
20260,
20139,
20257,
20259,
20241,
20213,
20137,
20215,
20250,
20267,
20251,
20160,
20166,
20157,
20147,
20153,
20150,
20152,
20155,
20154,
20163,
20164,
20158,
20165,
20247,
20249,
20117,
20124,
20114,
20123,
20125,
20110,
20111,
20122,
20126,
20120,
20121,
20118,
20115,
20112,
20127,
20180,
20178,
20193,
20191,
20172,
20232,
20224,
20231,
20220,
20229,
20222,
20141,
20227,
20228,
20225,
20221,
20270,
20198,
20182,
20179,
20195,
20192,
20186,
20187,
20183,
20196,
20170,
20248,
20142,
20271,
20253,
20258,
20262,
20261,
20238,
20274,
20104,
20075,
20087,
20023,
20028,
20057,
20048,
20018,
20017,
20062,
20100,
20101,
20074,
20006,
20088,
20099,
20098,
20102,
19995,
20049,
20029,
20031,
20085,
20084,
20027,
20025,
20060,
20059,
20061,
20022,
20021,
20072,
20071,
20065,
20069,
20073,
20009,
20010,
20011,
20014,
20015,
20092,
20093,
20096,
20090,
20094,
20001,
20000,
19999,
19998,
19997,
20003,
20005,
20054,
20052,
20030,
20043,
20034,
20041,
20045,
20047,
20044,
20076,
20079,
20080,
20081,
20103,
20086,
20026,
20020,
20067,
20068,
19906,
19862,
19908,
19954,
19960,
19966,
19942,
19811,
19823,
19829,
19814,
19846,
19841,
19820,
19848,
19923,
19883,
19885,
19865,
19851,
19981,
19988,
19992,
19922,
19953,
19896,
19975,
19910,
19909,
19965,
19957,
19962,
19964,
19958,
19952,
19950,
19825,
19847,
19839,
19840,
19857,
19832,
19831,
19817,
19819,
19828,
19844,
19821,
19827,
19835,
19939,
19937,
19931,
19929,
19927,
19933,
19936,
19940,
19921,
19887,
19893,
19895,
19918,
19874,
19868,
19879,
19871,
19901,
19984,
19986,
19863,
19985,
19968,
19970,
19971,
19900,
19919,
19979,
19977,
19980,
19978,
19974,
19912,
19911,
19915,
19913,
19914,
19860,
11719,
11721,
11722,
11720,
11718,
11717,
11715,
11716,
11782,
11785,
11786,
11783,
11781,
11780,
11778,
11784,
11709,
11712,
11714,
11710,
11708,
11707,
11713,
11711,
11733,
11736,
11737,
11734,
11732,
11731,
11729,
11728,
11407,
11410,
11412,
11408,
11406,
11405,
11411,
11409,
11771,
11775,
11776,
11772,
11770,
11769,
11767,
11774,
11430,
11433,
11434,
11431,
11427,
11421,
11428,
11432,
11399,
11402,
11403,
11400,
11398,
11397,
11395,
11401,
11506,
11508,
11509,
11507,
11505,
11504,
11502,
11503,
11499,
-1,
11501,
11500,
11498,
11497,
-1,
-1,
11483,
11485,
11487,
11484,
11482,
11481,
11486,
-1,
11478,
-1,
11480,
11479,
11477,
11476,
-1,
-1,
11762,
11764,
11765,
11763,
11761,
11760,
11758,
11757,
11818,
11821,
11823,
11819,
11817,
11816,
11822,
11820,
11468,
11471,
11472,
11469,
11467,
11466,
11464,
11470,
11578,
11581,
11582,
11579,
11577,
11576,
11574,
11580,
11661,
11663,
11664,
11662,
11660,
11659,
11657,
11658,
11654,
-1,
11656,
11655,
11653,
11652,
-1,
-1,
11680,
11683,
11684,
11681,
11679,
11678,
11676,
11682,
11671,
11674,
11675,
11672,
11670,
11669,
11667,
11673,
11366,
11369,
11370,
11367,
11365,
11364,
11362,
11368,
11543,
11545,
11546,
11544,
11542,
11541,
11539,
11540,
11536,
-1,
11538,
11537,
11535,
11534,
-1,
-1,
11520,
11522,
11524,
11521,
11519,
11518,
11523,
-1,
11515,
-1,
11517,
11516,
11514,
11513,
-1,
-1,
11811,
11813,
11814,
11812,
11810,
11809,
11807,
11808,
11589,
11591,
11593,
11590,
11588,
11587,
11592,
-1,
11637,
11640,
11641,
11638,
11636,
11635,
11633,
11639,
11619,
11622,
11624,
11620,
11618,
11617,
11623,
11621,
11802,
11804,
11805,
11803,
11801,
11800,
11798,
11799,
11700,
11703,
11704,
11701,
11699,
11698,
11696,
11702,
11691,
11694,
11695,
11692,
11690,
11689,
11687,
11693,
11792,
11795,
11796,
11793,
11791,
11790,
11788,
11794,
11389,
11391,
11392,
11390,
11388,
11387,
11385,
11386,
11382,
-1,
11384,
11383,
11381,
11380,
-1,
-1,
11356,
11358,
11360,
11357,
11355,
11354,
11359,
11352,
11441,
11444,
11445,
11442,
11440,
11439,
11437,
11443,
11569,
11572,
11573,
11570,
11568,
11567,
11565,
11571,
11585,
11600,
11601,
11594,
11598,
11597,
11595,
11599,
11458,
11461,
11463,
11459,
11457,
11456,
11462,
11460,
11451,
11453,
11454,
11452,
11450,
11449,
11447,
11448,
11746,
11749,
11751,
11747,
11745,
11744,
11750,
11743,
11611,
11613,
11614,
11612,
11610,
11609,
11607,
11606,
11773,
11735,
11748,
-1,
-1,
-1,
-1,
11871,
11826,
11876,
11878,
11870,
11825,
11872,
11874,
11877,
11875,
11865,
11857,
11858,
11863,
11864,
11860,
11861,
11867,
11866,
11829,
11831,
11832,
11837,
11838,
11834,
11835,
11841,
11839,
11840,
11830,
-1,
-1,
-1,
11424,
11727,
11726,
11725,
11426,
11756,
11755,
11754,
11425,
11742,
11741,
11740,
11423,
11605,
11604,
11603,
11850,
11844,
11852,
11851,
11846,
11849,
11854,
11853,
11845,
11848,
-1,
-1,
-1,
-1,
-1,
-1,
5059,
5058,
5057,
5055,
5054,
5053,
5046,
5056,
5045,
5044,
5043,
5042,
5041,
5003,
5002,
5001,
4999,
4998,
4997,
5039,
5038,
5037,
5036,
5035,
5034,
5052,
5051,
5050,
5049,
5048,
4989,
5000,
4990,
4995,
4994,
4993,
4992,
4991,
5032,
5031,
5030,
5029,
5028,
5027,
4987,
4981,
4986,
4985,
4984,
4983,
4982,
5011,
4980,
5010,
4979,
5009,
4978,
5007,
5006,
5005,
5008,
4977,
4976,
4975,
4974,
4973,
4972,
4970,
4969,
4968,
4967,
4966,
4965,
5025,
5024,
5023,
5022,
5021,
5020,
5018,
5017,
5016,
5015,
5014,
5013,
]

_charnames_5120 = [
3338,
3334,
3314,
3331,
3333,
3293,
3309,
3104,
2753,
2751,
3311,
3312,
2771,
2849,
2898,
2845,
2899,
2846,
2878,
2843,
2879,
2844,
2912,
2895,
2847,
2897,
2848,
2913,
3318,
3101,
3340,
3149,
3147,
3148,
3144,
3134,
3133,
3139,
3138,
3146,
3143,
3145,
3140,
3335,
3332,
3310,
3321,
3273,
3266,
3271,
3272,
3268,
3270,
3099,
2693,
2692,
3264,
3265,
3263,
2832,
3259,
2828,
3260,
2829,
3256,
2826,
3258,
2827,
3261,
2830,
3262,
2831,
3098,
3254,
2824,
2684,
3030,
3024,
3028,
3029,
3026,
3027,
3102,
2606,
2607,
3022,
3023,
3009,
2822,
3005,
2818,
3006,
2819,
3003,
2816,
3004,
2817,
3007,
2820,
3008,
2821,
2915,
2968,
3000,
2999,
2998,
3001,
3292,
3286,
3290,
3291,
3288,
3289,
3108,
3284,
3285,
3283,
2857,
3281,
2853,
3282,
2854,
3279,
2851,
3280,
2852,
3276,
2855,
3278,
2856,
2918,
3274,
3275,
3088,
3087,
3086,
3089,
2769,
2755,
2766,
2767,
2764,
2765,
3109,
2542,
2754,
2763,
2865,
2759,
2861,
2760,
2862,
2757,
2859,
2758,
2860,
2761,
2863,
2762,
2864,
2919,
2541,
3053,
3200,
3195,
3204,
3205,
3197,
3198,
3106,
3193,
3194,
3192,
2841,
3188,
2837,
3189,
2838,
3186,
2835,
3187,
2836,
3190,
2839,
3191,
2840,
2917,
3184,
2833,
3206,
3317,
3054,
2967,
2921,
2964,
2965,
2957,
2959,
3105,
2901,
2920,
2949,
2875,
2947,
2873,
2948,
2874,
2916,
2900,
2714,
2966,
3183,
3177,
3181,
3182,
3179,
3180,
3107,
3175,
3176,
3167,
2799,
3163,
2795,
3164,
2796,
3161,
2793,
3162,
2794,
3165,
2797,
3166,
2798,
3159,
2791,
3203,
3094,
3056,
3092,
3093,
3084,
3091,
3103,
3032,
3055,
3083,
2782,
3079,
2778,
3080,
2779,
3077,
2776,
3078,
2777,
3081,
2780,
3082,
2781,
2906,
3031,
3316,
3076,
3224,
3199,
2904,
2910,
2908,
2907,
2905,
2909,
3075,
3073,
3074,
3067,
3069,
3070,
3072,
3066,
2790,
3062,
2786,
3063,
2787,
3059,
2784,
3061,
2785,
3064,
2788,
3065,
2789,
3057,
3127,
3120,
3125,
3126,
3122,
3124,
3100,
3118,
3119,
3117,
2813,
3113,
2809,
3114,
2810,
3111,
2807,
3112,
2808,
3115,
2811,
3116,
2812,
2914,
3095,
3232,
2805,
3052,
3253,
3252,
2804,
3244,
3248,
3249,
3246,
3247,
2800,
3242,
3243,
2802,
3240,
2867,
3233,
2866,
3202,
3158,
3153,
3129,
3150,
3154,
3155,
3151,
3152,
3156,
2876,
3128,
2988,
2963,
2984,
2961,
2985,
2962,
2982,
2983,
2986,
2987,
2980,
2823,
2969,
2997,
2996,
2991,
2993,
2990,
3020,
3019,
3018,
3021,
2931,
2927,
2928,
2925,
2926,
2929,
2930,
2924,
2932,
3339,
3325,
3329,
3330,
3327,
3328,
3323,
3324,
3322,
3015,
3014,
3011,
3016,
2870,
2869,
2868,
2871,
2936,
2940,
2941,
2938,
2939,
2934,
2935,
2933,
2950,
3040,
3039,
3036,
3041,
2892,
2891,
2890,
2893,
2881,
3171,
3172,
3169,
3170,
3173,
3174,
3168,
2977,
2973,
2974,
2971,
2972,
2975,
2976,
2970,
3319,
3227,
3226,
3225,
3228,
3212,
3211,
3210,
3213,
3217,
3216,
3215,
3218,
3222,
3221,
3220,
3223,
3046,
3045,
3043,
3047,
2612,
2613,
2610,
2611,
2614,
2615,
2733,
2734,
2731,
2732,
2735,
2736,
2726,
2727,
2724,
2725,
2728,
2729,
2688,
2689,
2686,
2687,
2690,
2691,
2583,
2584,
2581,
2582,
2585,
2586,
2555,
2556,
2553,
2554,
2557,
2558,
2704,
2705,
2702,
2703,
2706,
2707,
2701,
2623,
2624,
2619,
2620,
2625,
2621,
2651,
2652,
2649,
2650,
2653,
2654,
2644,
2645,
2642,
2643,
2646,
2647,
2641,
2711,
2712,
2709,
2710,
2713,
2715,
2740,
2741,
2738,
2739,
2742,
2743,
2719,
2720,
2717,
2718,
2721,
2722,
2666,
3049,
2667,
2663,
2664,
2668,
3051,
2669,
2659,
2660,
2657,
2658,
2661,
2662,
2680,
2681,
2678,
2679,
2682,
2683,
2598,
2599,
2596,
2597,
2600,
2601,
2674,
2675,
2672,
2673,
2676,
2677,
2563,
2564,
2561,
2562,
2565,
2566,
2569,
2570,
2567,
2568,
2571,
2572,
2697,
2698,
2695,
2696,
2699,
2700,
2694,
2752,
2591,
2592,
2589,
2590,
2593,
2594,
2636,
2637,
2634,
2635,
2638,
2639,
2630,
2631,
2628,
2629,
2632,
2633,
2627,
2576,
2577,
2574,
2575,
2578,
2579,
2747,
2748,
2745,
2746,
2749,
2750,
2549,
2550,
2547,
2548,
2551,
2552,
2768,
3157,
3326,
2937,
2953,
2954,
2951,
2952,
2955,
2956,
2889,
2885,
2886,
2883,
2884,
2887,
2888,
2894,
3209,
25378,
25376,
25372,
25374,
25355,
25360,
25348,
25375,
25368,
25366,
25367,
25371,
25373,
25361,
25354,
25369,
25377,
25358,
25346,
25351,
25363,
25352,
25357,
25347,
25364,
25350,
25370,
25380,
25379,
-1,
-1,
-1,
25737,
25729,
25730,
25715,
25714,
25716,
25720,
25688,
25710,
25668,
25713,
25712,
25675,
25657,
25666,
25671,
25670,
25731,
25722,
25700,
25723,
25704,
25689,
25707,
25708,
25717,
25725,
25726,
25677,
25660,
25734,
25658,
25695,
25684,
25687,
25736,
25706,
25678,
25662,
25683,
25733,
25711,
25664,
25665,
25656,
25698,
25727,
25719,
25655,
25692,
25738,
25661,
25694,
25669,
25690,
25735,
25676,
25659,
25679,
25696,
25682,
25681,
25697,
25667,
25691,
25685,
25702,
25703,
25701,
25663,
25674,
25654,
25686,
25732,
25728,
25740,
25741,
25742,
25744,
25739,
25743,
]

_charnames_5888 = [
17320,
17315,
17308,
17314,
17317,
17304,
17309,
17318,
17305,
17311,
17319,
17312,
17306,
-1,
17313,
17307,
17310,
17316,
17323,
17322,
17324,
]

_charnames_5920 = [
20433,
20428,
20420,
20427,
20430,
20416,
20421,
20431,
20417,
20424,
20432,
20425,
20418,
20423,
20426,
20419,
20422,
20429,
20436,
20435,
20437,
26342,
26343,
]

_charnames_5952 = [
16862,
16857,
16849,
16856,
16859,
16845,
16850,
16860,
16846,
16853,
16861,
16854,
16847,
16852,
16855,
16848,
16851,
16858,
16865,
16864,
]

_charnames_5984 = [
17343,
17339,
17332,
17338,
17340,
17328,
17333,
17341,
17329,
17335,
17342,
17336,
17330,
-1,
17337,
17331,
17334,
-1,
17346,
17345,
]

_charnames_6016 = [
23195,
23193,
23194,
23192,
23189,
23201,
23199,
23200,
23198,
23186,
23216,
23179,
23215,
23178,
23188,
23184,
23182,
23183,
23181,
23187,
23223,
23209,
23210,
23208,
23221,
23217,
23219,
23212,
23218,
23204,
23203,
23205,
23222,
23213,
23220,
23255,
23257,
23261,
23262,
23249,
23252,
23250,
23251,
23264,
23265,
23266,
23267,
23263,
23256,
23260,
23259,
23254,
23245,
23246,
23230,
23237,
23238,
23231,
23232,
23234,
23235,
23236,
23242,
23233,
23239,
23243,
23229,
23228,
23241,
23227,
23172,
23164,
23168,
23173,
23160,
23149,
23163,
23161,
23154,
23158,
23170,
23169,
23166,
23147,
23153,
23148,
23167,
23174,
23150,
23171,
23152,
23282,
23156,
23157,
-1,
-1,
23278,
23279,
23270,
23271,
23276,
23277,
23273,
23274,
23281,
23280,
-1,
-1,
-1,
-1,
-1,
-1,
23131,
23132,
23127,
23130,
23129,
23120,
23126,
23125,
23124,
23123,
-1,
-1,
-1,
-1,
-1,
-1,
6998,
6997,
6991,
6985,
6992,
6986,
6994,
6995,
6989,
6988,
6996,
6984,
6982,
6983,
6993,
-1,
6975,
6976,
6967,
6968,
6973,
6974,
6970,
6971,
6978,
6977,
-1,
-1,
-1,
-1,
-1,
-1,
6842,
6947,
6959,
6939,
6937,
6940,
6938,
6948,
6957,
6878,
6964,
6956,
6955,
6961,
6907,
6943,
6906,
6905,
6841,
6963,
6951,
6958,
6952,
6954,
6953,
6962,
6946,
6945,
6840,
6936,
6960,
6934,
6942,
6935,
6950,
6833,
6837,
6835,
6817,
6812,
6818,
6813,
6811,
6839,
6830,
6829,
6822,
6832,
6816,
6826,
6838,
6821,
6815,
6827,
6828,
6834,
6823,
6836,
6820,
6831,
6825,
6901,
6889,
6890,
6885,
6884,
6904,
6898,
6893,
6891,
6897,
6895,
6888,
6902,
6899,
6900,
6894,
6892,
6887,
6883,
6896,
6903,
6882,
6931,
6930,
6929,
6932,
6928,
]

_charnames_6272 = [
6856,
6872,
6852,
6873,
6868,
6877,
6848,
6855,
6867,
6875,
6866,
6876,
6847,
6846,
6854,
6865,
6849,
6851,
6863,
6862,
6874,
6859,
6860,
6857,
6810,
6809,
6926,
6923,
6921,
6925,
6914,
6918,
6915,
6917,
6922,
6920,
6911,
6912,
6871,
6870,
6927,
6853,
6924,
-1,
-1,
-1,
-1,
-1,
3308,
3320,
3313,
2896,
3269,
3267,
3257,
3025,
3287,
3277,
3196,
2958,
2922,
3178,
3090,
3033,
3068,
3071,
3060,
3123,
3121,
3245,
2945,
3299,
2946,
3300,
2943,
3297,
2944,
3298,
3241,
3237,
3238,
3235,
3236,
3239,
3304,
3303,
3306,
3307,
3305,
3295,
3301,
3302,
3336,
2877,
3142,
3135,
3251,
2801,
2803,
2981,
2979,
2995,
2992,
2994,
3013,
3012,
3038,
3037,
3044,
2617,
2605,
2622,
2618,
3050,
2665,
3231,
3230,
2604,
]

_charnames_6400 = [
9544,
9491,
9490,
9497,
9496,
9487,
9503,
9502,
9494,
9493,
9479,
9482,
9481,
9500,
9499,
9488,
9485,
9484,
9506,
9505,
9509,
9478,
9508,
9510,
9507,
9476,
9475,
9477,
9511,
-1,
-1,
-1,
9535,
9543,
9542,
9541,
9537,
9539,
9536,
9540,
9538,
9530,
9532,
9531,
-1,
-1,
-1,
-1,
9522,
9515,
9523,
9517,
9516,
9519,
9520,
9518,
9521,
9526,
9528,
9525,
-1,
-1,
-1,
-1,
9527,
-1,
-1,
-1,
9560,
9559,
9555,
9556,
9547,
9548,
9553,
9554,
9550,
9551,
9558,
9557,
17171,
17173,
17167,
17150,
17175,
17172,
17152,
17151,
17178,
17163,
17162,
17177,
17181,
17174,
17180,
17176,
17170,
17149,
17168,
17156,
17179,
17155,
17154,
17159,
17165,
17164,
17160,
17153,
17157,
17158,
-1,
-1,
17147,
17146,
17145,
17144,
17143,
]

_charnames_6528 = [
26533,
26504,
26530,
26518,
26526,
26501,
26489,
26497,
26513,
26521,
26531,
26484,
26492,
26502,
26515,
26514,
26527,
26486,
26485,
26498,
26524,
26523,
26534,
26495,
26494,
26505,
26537,
26532,
26535,
26508,
26503,
26506,
26536,
26538,
26539,
26507,
26509,
26510,
26529,
26517,
26500,
26488,
26520,
26491,
-1,
-1,
-1,
-1,
26566,
26559,
26565,
26549,
26553,
26567,
26562,
26554,
26555,
26550,
26561,
26560,
26552,
26557,
26556,
26551,
26564,
26543,
26542,
26541,
26544,
26545,
26546,
26547,
26585,
26584,
-1,
-1,
-1,
-1,
-1,
-1,
26578,
26579,
26570,
26571,
26576,
26577,
26573,
26574,
26581,
26580,
26586,
-1,
-1,
-1,
26587,
26588,
23095,
23142,
23094,
23139,
23136,
23091,
23088,
23085,
23082,
23079,
23117,
23114,
23104,
23111,
23108,
23101,
23143,
23141,
23093,
23138,
23135,
23090,
23087,
23084,
23081,
23078,
23116,
23113,
23103,
23110,
23107,
23100,
16826,
16829,
16813,
16812,
16824,
16832,
16818,
16817,
16821,
16830,
16815,
16814,
16831,
16827,
16810,
16809,
16819,
16823,
16825,
16820,
16822,
16833,
16828,
16837,
16835,
16838,
16836,
16839,
-1,
-1,
16840,
16841,
16912,
16911,
16910,
16885,
16883,
16884,
16933,
16921,
16920,
16894,
16896,
16893,
16932,
16928,
16923,
16944,
16897,
16929,
16915,
16914,
16888,
16887,
16934,
16945,
16918,
16917,
16925,
16891,
16899,
16890,
16941,
16895,
16922,
16927,
16930,
16900,
16902,
16939,
16907,
16906,
16908,
16924,
16903,
16946,
16898,
16937,
16938,
16935,
16936,
16943,
16940,
16901,
16942,
17035,
17036,
17040,
16965,
17043,
17039,
17042,
17037,
17044,
17041,
-1,
16962,
16992,
17001,
16995,
16998,
16999,
17000,
16991,
16990,
16988,
16989,
16982,
16984,
16986,
17002,
16994,
16987,
16993,
16997,
16985,
16964,
16972,
16971,
16953,
16952,
16951,
16975,
16967,
16954,
-1,
-1,
17045,
17027,
17028,
17019,
17020,
17025,
17026,
17022,
17023,
17030,
17029,
-1,
-1,
-1,
-1,
-1,
-1,
17013,
17014,
17005,
17006,
17011,
17012,
17008,
17009,
17016,
17015,
-1,
-1,
-1,
-1,
-1,
-1,
16968,
16969,
16961,
16957,
16977,
16979,
16974,
16966,
16955,
16956,
16959,
16960,
16978,
16980,
]

_charnames_6912 = [
16109,
16110,
16113,
16111,
16114,
15995,
15996,
16017,
16018,
16009,
16010,
16004,
16005,
16007,
16008,
16022,
15998,
16013,
16014,
15984,
15986,
16019,
16020,
15982,
16024,
16025,
16015,
16016,
15981,
15976,
15975,
15992,
15991,
15980,
15972,
15974,
15988,
15993,
15979,
16011,
16012,
16026,
16027,
16032,
16029,
16003,
16006,
16030,
16002,
16001,
15999,
16033,
16112,
16082,
16083,
16084,
16085,
16086,
16087,
16088,
16091,
16092,
16077,
16079,
16081,
16080,
16089,
16090,
16126,
15985,
15987,
15977,
16023,
16031,
16028,
15997,
-1,
-1,
-1,
-1,
16103,
16104,
16095,
16096,
16101,
16102,
16098,
16099,
16106,
16105,
16119,
16118,
16125,
16123,
16124,
16122,
16117,
16047,
16045,
16046,
16037,
16039,
16048,
16042,
16044,
16041,
16040,
16055,
16058,
16051,
16053,
16056,
16052,
16054,
16059,
16057,
16070,
16071,
16073,
16074,
16064,
16062,
16067,
16066,
16063,
-1,
-1,
-1,
19276,
19275,
19274,
19226,
19242,
19233,
19227,
19238,
19224,
19225,
19223,
19236,
19244,
19216,
19247,
19241,
19228,
19215,
19234,
19246,
19217,
19237,
19245,
19232,
19248,
19239,
19229,
19235,
19240,
19231,
19220,
19230,
19243,
19282,
19281,
19280,
19267,
19265,
19269,
19266,
19270,
19268,
19277,
-1,
-1,
-1,
19222,
19219,
19259,
19260,
19251,
19252,
19257,
19258,
19254,
19255,
19262,
19261,
]

_charnames_7168 = [
9892,
9890,
9891,
9908,
9907,
9887,
9914,
9913,
9923,
9886,
9880,
9879,
9896,
9888,
9884,
9882,
9883,
9911,
9910,
9917,
9916,
9902,
9901,
9878,
9877,
9894,
9918,
9921,
9922,
9905,
9904,
9920,
9899,
9898,
9919,
9924,
9966,
9967,
9956,
9954,
9952,
9953,
9950,
9951,
9955,
9942,
9947,
9948,
9940,
9946,
9945,
9944,
9941,
9943,
9969,
9970,
-1,
-1,
-1,
9961,
9962,
9963,
9960,
9959,
9935,
9936,
9927,
9928,
9933,
9934,
9930,
9931,
9938,
9937,
-1,
-1,
-1,
9875,
9874,
9895,
25156,
25157,
25148,
25149,
25154,
25155,
25151,
25152,
25159,
25158,
25120,
25115,
25118,
25116,
25117,
25121,
25113,
25114,
25112,
25111,
25124,
25137,
25140,
25139,
25138,
25122,
25130,
25129,
25128,
25127,
25125,
25143,
25145,
25144,
25142,
25123,
25133,
25135,
25132,
25134,
25167,
25169,
25166,
25168,
25164,
25170,
25162,
25163,
]

_charnames_7376 = [
24026,
24030,
24032,
24011,
24009,
24019,
24018,
24016,
24033,
24017,
24028,
24022,
24025,
24029,
24021,
24023,
24031,
24034,
24003,
23999,
24006,
24001,
24007,
24000,
24002,
23996,
23995,
23992,
23993,
24010,
24013,
24012,
24008,
23994,
23997,
]

_charnames_7424 = [
9046,
9047,
7793,
9045,
9062,
9061,
9037,
9035,
7795,
7799,
9058,
9057,
9039,
9056,
9025,
9027,
9029,
8088,
8089,
8090,
7796,
9028,
7836,
8385,
9054,
9024,
9033,
9031,
9052,
8091,
8093,
8092,
9051,
9050,
9048,
9036,
9083,
9080,
21670,
21669,
21667,
21668,
21666,
4499,
6641,
6642,
6639,
6640,
6657,
6656,
6636,
6655,
6654,
6653,
6652,
6651,
6650,
6649,
6648,
6635,
6637,
6638,
6647,
6633,
6646,
6645,
6643,
6601,
6535,
6602,
6537,
6575,
6598,
6565,
6562,
6593,
6543,
6570,
6544,
6623,
6611,
6569,
6590,
6592,
6546,
6576,
6606,
6533,
6583,
6563,
6540,
6604,
6603,
6577,
6573,
6600,
6572,
6557,
8487,
8484,
8482,
8481,
21320,
21318,
21316,
21317,
21319,
8068,
8381,
8223,
8448,
8419,
8258,
8407,
8123,
8116,
8085,
7828,
8320,
7807,
6672,
8200,
7841,
8478,
8204,
8403,
8477,
8066,
8380,
8222,
8447,
8365,
8353,
8158,
8418,
8257,
8406,
8122,
8084,
7957,
8394,
8464,
8319,
7999,
8015,
8217,
7937,
7904,
8130,
8097,
8188,
7902,
7956,
8056,
7952,
6536,
6549,
6558,
6567,
6588,
6624,
6599,
6561,
6545,
6617,
6616,
6551,
6553,
6614,
6596,
6597,
6556,
6612,
6541,
6610,
6609,
6555,
6578,
6607,
6564,
6568,
6548,
6585,
6584,
6554,
6605,
6542,
6579,
6581,
6582,
6566,
6547,
3594,
3595,
3725,
3723,
3700,
3672,
3698,
3682,
3673,
3683,
3498,
3745,
3699,
3586,
3763,
3770,
3742,
3755,
3754,
3519,
3494,
3493,
3492,
3506,
3502,
3504,
3518,
3526,
3516,
3499,
3525,
3524,
3514,
3523,
3522,
3497,
3512,
3500,
3507,
]

_charnames_7677 = [
3693,
3533,
3632,
8582,
7997,
8983,
8377,
8982,
8376,
8986,
8382,
8907,
8288,
8866,
8220,
8865,
8219,
8868,
8224,
8862,
8211,
8861,
8210,
8627,
7932,
8628,
7933,
8614,
7919,
8630,
7935,
8616,
7921,
9014,
8450,
8896,
8366,
8877,
8269,
8876,
8268,
8878,
8270,
8882,
8274,
8885,
8279,
8736,
8183,
8734,
8181,
8946,
8356,
8936,
8345,
8944,
8354,
8801,
8147,
8802,
8148,
8814,
8159,
8805,
8143,
8995,
8421,
8993,
8417,
8992,
8416,
8848,
8254,
8847,
8253,
8840,
8250,
8843,
8245,
8528,
7883,
8527,
7882,
8532,
7886,
8533,
7887,
8978,
8411,
8977,
8410,
8783,
8110,
8781,
8108,
8782,
8109,
8790,
8114,
8768,
8080,
8766,
8078,
8770,
8082,
8761,
8073,
8767,
8079,
8703,
7821,
8702,
7820,
8707,
7829,
8697,
7815,
8660,
8031,
8677,
8048,
8681,
8052,
8678,
8049,
8684,
8058,
8964,
8392,
8962,
8390,
8955,
8435,
8957,
8437,
8953,
8432,
8952,
8431,
8951,
8430,
9001,
8462,
9002,
8463,
8824,
8329,
8928,
8313,
8921,
8308,
8930,
8321,
8277,
7824,
8433,
8335,
7998,
8165,
8166,
8167,
8773,
8237,
8568,
7981,
8588,
8005,
8561,
7974,
8559,
7972,
8558,
7971,
8557,
7970,
8560,
7973,
8578,
7991,
8576,
7989,
8575,
7988,
8574,
7987,
8577,
7990,
8621,
7926,
8634,
7941,
8629,
7934,
8613,
7918,
8611,
7916,
8610,
7915,
8609,
7914,
8612,
7917,
8744,
8192,
8730,
8179,
8509,
7864,
8503,
7858,
8522,
7877,
8520,
7875,
8519,
7874,
8518,
7873,
8521,
7876,
8502,
7857,
8500,
7855,
8499,
7854,
8498,
7853,
8501,
7856,
8665,
8036,
8674,
8045,
8673,
8044,
8671,
8042,
8670,
8041,
8669,
8040,
8672,
8043,
8832,
8338,
8823,
8328,
8827,
8332,
8828,
8333,
8998,
8424,
8997,
8423,
8831,
8337,
21190,
21201,
21192,
21203,
21196,
21207,
21194,
21205,
21410,
21421,
21416,
21427,
21418,
21429,
21413,
21424,
21175,
21179,
21177,
21181,
21178,
21182,
-1,
-1,
21395,
21399,
21397,
21401,
21398,
21402,
-1,
-1,
21147,
21158,
21149,
21160,
21153,
21164,
21151,
21162,
21369,
21380,
21375,
21386,
21377,
21388,
21372,
21383,
21264,
21258,
21266,
21260,
21268,
21262,
21267,
21261,
21447,
21441,
21449,
21443,
21451,
21445,
21450,
21444,
21132,
21136,
21134,
21138,
21135,
21139,
-1,
-1,
21354,
21358,
21356,
21360,
21357,
21361,
-1,
-1,
21237,
21231,
21239,
21233,
21241,
21235,
21240,
21234,
-1,
21461,
-1,
21463,
-1,
21465,
-1,
21464,
21104,
21115,
21106,
21117,
21110,
21121,
21108,
21119,
21328,
21339,
21334,
21345,
21336,
21347,
21331,
21342,
21211,
21214,
21183,
21185,
21167,
21169,
21272,
21274,
21140,
21142,
21245,
21247,
21124,
21126,
-1,
-1,
21198,
21209,
21193,
21204,
21197,
21208,
21195,
21206,
21415,
21426,
21417,
21428,
21419,
21430,
21414,
21425,
21155,
21166,
21150,
21161,
21154,
21165,
21152,
21163,
21374,
21385,
21376,
21387,
21378,
21389,
21373,
21384,
21112,
21123,
21107,
21118,
21111,
21122,
21109,
21120,
21333,
21344,
21335,
21346,
21337,
21348,
21332,
21343,
21213,
21218,
21212,
21216,
21215,
-1,
21199,
21200,
21432,
21436,
21433,
21435,
21420,
21728,
21713,
21708,
21716,
21686,
21168,
21171,
21170,
-1,
21156,
21157,
21403,
21405,
21390,
21392,
21379,
21710,
21712,
21711,
21271,
21275,
21254,
21257,
-1,
-1,
21269,
21256,
21453,
21457,
21454,
21456,
-1,
21691,
21693,
21692,
21244,
21248,
21227,
21230,
21290,
21291,
21242,
21229,
21468,
21472,
21469,
21471,
21486,
21685,
21687,
21660,
-1,
-1,
21125,
21128,
21127,
-1,
21113,
21114,
21362,
21364,
21349,
21351,
21338,
21720,
21689,
-1,
11988,
11959,
11987,
11958,
18287,
27350,
19531,
27363,
26476,
18298,
20593,
27907,
27905,
27908,
9859,
25627,
21084,
26795,
27364,
11989,
11960,
21071,
24267,
24256,
9652,
25450,
19513,
19516,
9732,
25487,
24255,
24291,
24863,
24286,
16867,
18337,
25430,
18403,
21074,
21088,
9470,
26151,
9860,
25628,
26475,
9858,
25626,
26845,
26449,
26447,
26417,
24270,
18308,
25859,
25852,
25850,
3397,
19514,
19515,
25897,
24292,
27109,
25431,
27549,
5171,
3398,
13997,
21087,
27382,
9647,
25445,
24289,
27878,
11929,
17813,
25860,
16714,
16734,
10102,
25856,
5189,
18413,
3788,
19802,
27130,
27371,
18279,
27871,
27344,
27360,
18402,
27345,
24384,
18338,
24061,
7718,
27718,
27336,
27140,
27141,
27142,
-1,
-1,
-1,
-1,
-1,
27153,
14006,
27154,
14007,
26844,
26796,
19327,
19313,
-1,
-1,
19322,
19323,
19319,
19320,
19326,
19331,
19329,
19332,
19325,
19314,
19328,
19312,
19347,
19350,
19336,
19337,
19342,
19343,
19339,
19340,
19346,
19351,
19349,
19352,
19345,
19353,
19348,
-1,
8489,
8488,
8485,
8480,
8483,
]

_charnames_8352 = [
11995,
4035,
5221,
27384,
9634,
7771,
26847,
26459,
25795,
27719,
26589,
24410,
11996,
23380,
18397,
24867,
22188,
26458,
22015,
14016,
21092,
5210,
9633,
19794,
18069,
]

_charnames_8400 = [
3544,
3642,
3557,
3722,
3687,
3484,
3536,
3637,
3646,
3483,
3686,
3734,
3782,
3711,
3709,
3715,
3712,
3547,
3710,
3714,
3713,
3652,
3570,
3688,
3733,
3784,
3551,
3558,
3644,
3550,
3535,
3636,
3691,
]

_charnames_8448 = [
14008,
14015,
24305,
24711,
5206,
3399,
3404,
11997,
19740,
24710,
19738,
19731,
16797,
24303,
26441,
26442,
19730,
16796,
19729,
19737,
10151,
24302,
26842,
19715,
19727,
24297,
24301,
19726,
16795,
24300,
26391,
25893,
19756,
17946,
18341,
24066,
24299,
25422,
25432,
27132,
16794,
18394,
23378,
13975,
19734,
16798,
12004,
19739,
19733,
19732,
18395,
19728,
19736,
13992,
16663,
22353,
24862,
27146,
25953,
27392,
24314,
24315,
24304,
24298,
24316,
18387,
18386,
25857,
18385,
24312,
24311,
24310,
24309,
24308,
26413,
18391,
26448,
14019,
18388,
18975,
24076,
24078,
24073,
24072,
24088,
24080,
24089,
24085,
24094,
24075,
24092,
24081,
24086,
24093,
24096,
27383,
25919,
25914,
25918,
25911,
25903,
25926,
25928,
25931,
25933,
25916,
25930,
25915,
25907,
25923,
25906,
25921,
19632,
19622,
19624,
19631,
19628,
19637,
19638,
19641,
19642,
19625,
19640,
19623,
19630,
19635,
19629,
19634,
25922,
25905,
25917,
25932,
8132,
25927,
25910,
25909,
25924,
24095,
-1,
-1,
-1,
-1,
-1,
-1,
9761,
27402,
25529,
24334,
9661,
27451,
26721,
26750,
19698,
19708,
9776,
25544,
9850,
25619,
9833,
27441,
25601,
24362,
9765,
25533,
9796,
27412,
25564,
24345,
27452,
9779,
25547,
9778,
25546,
9674,
9665,
24367,
27407,
27406,
24339,
24338,
25548,
24342,
13966,
5194,
26724,
9783,
13967,
5195,
9811,
9818,
27427,
27422,
25579,
25586,
24360,
24355,
25566,
27411,
9798,
9853,
27447,
25622,
24370,
9819,
25587,
9843,
9671,
25611,
9839,
27444,
25607,
24365,
9668,
27454,
26731,
26759,
19705,
19713,
9836,
25604,
9851,
25620,
27409,
24341,
9847,
27445,
25615,
24366,
9782,
25556,
9849,
27429,
25617,
24368,
27435,
27431,
27434,
27433,
27436,
27437,
25618,
26725,
19701,
27453,
25468,
24344,
18281,
9775,
25543,
9664,
9773,
25541,
9666,
9854,
25623,
9675,
27357,
3793,
26155,
18291,
18292,
11950,
27149,
26848,
11933,
26770,
19649,
4027,
24404,
19661,
11992,
26820,
26805,
26814,
7757,
7766,
24392,
24844,
19755,
13996,
25641,
16868,
18605,
2537,
27349,
26412,
27144,
25456,
13971,
7721,
19787,
24847,
24407,
26148,
26785,
10139,
10128,
27093,
27536,
27112,
24283,
18318,
4028,
19394,
24101,
5196,
5192,
13964,
18293,
16668,
25964,
26411,
24394,
11931,
22182,
21081,
17795,
25848,
27133,
19517,
27722,
26779,
7765,
13998,
26769,
13806,
13809,
26638,
13981,
26771,
13983,
18316,
13988,
11910,
22180,
24855,
13810,
22181,
13807,
27198,
4036,
11897,
25642,
25643,
4037,
12003,
11911,
19764,
24715,
11905,
7738,
27879,
26784,
27008,
26787,
19770,
9981,
21763,
9984,
21768,
10006,
21789,
7363,
7364,
16662,
26783,
26786,
26788,
26627,
26632,
9980,
21762,
26626,
26631,
9982,
21764,
26628,
26633,
26392,
19374,
26405,
19387,
26404,
19386,
24398,
24405,
19355,
19286,
26768,
26767,
19362,
19293,
26637,
26636,
19364,
19295,
7357,
7360,
7359,
18666,
18689,
18669,
18692,
18614,
18616,
4912,
4928,
4922,
4906,
4908,
4924,
4933,
4938,
4909,
18780,
18783,
18790,
18793,
25504,
9717,
24373,
27467,
13999,
6801,
18342,
27356,
18304,
24264,
24400,
26778,
24409,
26622,
26406,
19388,
26761,
4025,
26762,
4026,
25287,
27197,
7361,
20951,
27111,
27910,
26846,
26717,
25460,
25500,
26817,
26816,
26821,
26806,
24830,
24393,
19762,
24846,
16529,
9757,
25526,
9656,
25453,
25849,
2531,
2532,
24246,
24244,
24282,
24280,
26463,
11906,
10000,
21784,
24064,
24065,
10008,
21794,
11903,
11904,
11902,
11901,
24399,
24406,
26775,
26774,
18668,
18691,
10005,
21788,
26407,
19389,
26780,
24402,
26781,
24403,
24062,
7769,
27469,
24375,
11940,
11936,
19651,
11941,
11939,
19652,
11937,
11938,
4023,
4021,
19659,
4022,
19660,
27902,
24831,
11947,
21076,
27464,
24377,
26414,
26451,
27705,
9696,
25497,
9750,
25520,
16514,
16519,
18347,
18352,
25865,
18698,
13702,
19757,
19752,
17947,
26473,
24099,
26443,
18393,
27713,
21077,
18353,
18348,
16520,
16515,
18362,
16526,
27379,
19693,
27465,
25399,
11972,
27911,
23377,
9864,
25632,
11973,
16659,
4573,
13989,
19018,
18380,
24854,
4031,
19785,
4016,
4015,
13784,
13778,
13732,
13713,
13714,
13730,
13725,
13758,
13761,
13779,
13802,
13726,
13733,
13721,
13731,
13791,
13786,
13722,
13727,
13763,
13741,
13753,
13711,
13716,
13742,
13773,
13718,
13768,
13749,
13719,
13715,
13769,
13745,
13710,
13735,
13752,
13754,
13794,
13760,
13771,
13736,
13759,
13724,
13770,
13750,
13777,
13795,
13762,
13743,
13792,
13799,
13800,
13764,
13748,
13798,
13776,
13780,
13729,
13728,
13744,
13772,
13782,
13787,
13788,
13797,
13801,
13783,
13789,
13796,
26789,
25459,
19611,
16667,
24043,
27090,
4029,
24850,
11956,
3792,
27576,
11991,
13985,
20950,
4887,
4921,
15580,
27548,
7005,
21091,
25397,
25396,
26160,
26159,
24853,
19719,
13706,
24713,
26408,
26639,
26416,
5199,
9738,
9740,
9739,
25507,
25509,
25508,
9648,
9650,
9649,
25446,
25448,
25447,
9691,
9692,
9693,
2533,
25493,
25494,
25495,
27126,
21073,
27482,
27477,
19392,
19393,
18360,
16522,
16523,
25963,
9752,
25511,
21068,
21067,
21066,
21065,
24689,
24692,
24697,
24707,
24702,
24696,
24706,
24701,
24694,
24705,
24700,
24703,
24698,
24690,
24693,
18712,
25894,
12005,
24044,
7751,
7748,
7749,
7747,
7742,
7743,
7744,
7745,
7750,
12000,
27337,
18361,
16525,
18363,
16527,
18359,
16524,
27681,
16660,
19772,
27374,
14009,
11946,
24714,
]

_charnames_9216 = [
19001,
18969,
18968,
18993,
18991,
18995,
19017,
19009,
19010,
19015,
19014,
19011,
19003,
19006,
18971,
18972,
18986,
18982,
18980,
18981,
18983,
19000,
18973,
18992,
19007,
18994,
18965,
18996,
19004,
19016,
19013,
19012,
18974,
18984,
16803,
25393,
18999,
18985,
18966,
]

_charnames_9280 = [
25413,
25411,
25414,
25412,
25405,
25404,
25403,
25415,
25408,
25410,
25407,
]

_charnames_9312 = [
4902,
4893,
4894,
4899,
4900,
4896,
4897,
4904,
4903,
4752,
4788,
4733,
4751,
4772,
4776,
4780,
4783,
4787,
4789,
4717,
26137,
26129,
26130,
26135,
26136,
26132,
26133,
26139,
26138,
26116,
26124,
26114,
26115,
26121,
26122,
26118,
26119,
26125,
26126,
26113,
24752,
24722,
24726,
24740,
24744,
24731,
24735,
24760,
24756,
26829,
26839,
26827,
26828,
26836,
26837,
26832,
26834,
26840,
26841,
26826,
25996,
25995,
25994,
25993,
25992,
25991,
25990,
25989,
25988,
25987,
25986,
25985,
25984,
25983,
25982,
25981,
25980,
25979,
25978,
25977,
25976,
25975,
25974,
25973,
25972,
25971,
4712,
4711,
4710,
4709,
4708,
4707,
4706,
4705,
4704,
4703,
4702,
4701,
4700,
4699,
4698,
4697,
4696,
4695,
4694,
4693,
4692,
4691,
4690,
4689,
4688,
4687,
4685,
4684,
4683,
4682,
4681,
4680,
4679,
4678,
4677,
4676,
4675,
4674,
4673,
4672,
4671,
4670,
4669,
4668,
4667,
4666,
4665,
4664,
4663,
4662,
4661,
4660,
4901,
26606,
26597,
26598,
26603,
26604,
26600,
26601,
26607,
26608,
26596,
24237,
24229,
24230,
24235,
24236,
24232,
24233,
24239,
24238,
24240,
26612,
16300,
16386,
16279,
16372,
16293,
16379,
16292,
16378,
16296,
16382,
16295,
16381,
16261,
16317,
16326,
16359,
16262,
16320,
16329,
16360,
16277,
16390,
16399,
16370,
16278,
16393,
16402,
16369,
16281,
16420,
16400,
16325,
16424,
16316,
16391,
16374,
16282,
16421,
16403,
16328,
16425,
16319,
16394,
16375,
16263,
16309,
16439,
16322,
16331,
16435,
16305,
16361,
16275,
16308,
16438,
16395,
16404,
16434,
16304,
16371,
16283,
16307,
16437,
16422,
16405,
16330,
16426,
16310,
16440,
16311,
16441,
16321,
16396,
16433,
16303,
16376,
16266,
16364,
16265,
16363,
16354,
16341,
16333,
16337,
16351,
16334,
16338,
16352,
16407,
16411,
16347,
16408,
16412,
16348,
16416,
16428,
16343,
16417,
16429,
16344,
16335,
16339,
16353,
16409,
16413,
16349,
16418,
16430,
16345,
16289,
16290,
16287,
16286,
16269,
16270,
16271,
16297,
16272,
16299,
16259,
16383,
16365,
16385,
16357,
16298,
16276,
16384,
16368,
27487,
10095,
10094,
10092,
10089,
10097,
10091,
10096,
27333,
9655,
9714,
9748,
9755,
9715,
9743,
9744,
25517,
9629,
7712,
24861,
27488,
25515,
27869,
27868,
27856,
27863,
27862,
27860,
27859,
27864,
27865,
27866,
16700,
27561,
27573,
27577,
18550,
18546,
18549,
18539,
18536,
18551,
16694,
27582,
16736,
27641,
16775,
27668,
16789,
27693,
16755,
27674,
16756,
27676,
16729,
27638,
16730,
27639,
16727,
27636,
16747,
27626,
16748,
27627,
16708,
27645,
16709,
27646,
16710,
27647,
16738,
27618,
27623,
27365,
10149,
27592,
24385,
4951,
16869,
16681,
4950,
4953,
4949,
4944,
4943,
4955,
9756,
25518,
27138,
27137,
27485,
10087,
27481,
27475,
10078,
10085,
27486,
10088,
16717,
16718,
16753,
16752,
27695,
18545,
18548,
18540,
18543,
27575,
27675,
27492,
27491,
9197,
27571,
27567,
27566,
27570,
27596,
27599,
27598,
27595,
27480,
27473,
10083,
27655,
16761,
27656,
16762,
10077,
16698,
5198,
27551,
19796,
3794,
16699,
27586,
9632,
18296,
19211,
14000,
24684,
4030,
25400,
16781,
27683,
16129,
16132,
16131,
19207,
27553,
21080,
27588,
16703,
19600,
25863,
16712,
16735,
27649,
27677,
27640,
27628,
19800,
3405,
25962,
16874,
3403,
13976,
25291,
5175,
5218,
5219,
19765,
27391,
14014,
20591,
26461,
15317,
18327,
18326,
18328,
18324,
18322,
18323,
18325,
18329,
27699,
27664,
27584,
16697,
27585,
27366,
9200,
7752,
27396,
11999,
6448,
27848,
19206,
27555,
26641,
26439,
13701,
17440,
22189,
3342,
10009,
24098,
9635,
19741,
19209,
3407,
14018,
26465,
27607,
27609,
27608,
27611,
27606,
27610,
16676,
16678,
16677,
16680,
16675,
16679,
16701,
27690,
27621,
16687,
27587,
16772,
16741,
27616,
21079,
27874,
11984,
16666,
16665,
7343,
7342,
7341,
27724,
12001,
27546,
25886,
25885,
25884,
25883,
25882,
25881,
25880,
25887,
16757,
25888,
26154,
26455,
27698,
24839,
24838,
24837,
24836,
24835,
24834,
27602,
27603,
16683,
16684,
7003,
7002,
24775,
24768,
24769,
24774,
27661,
16785,
20592,
13978,
5215,
19768,
19742,
13991,
27370,
22183,
19767,
14017,
27376,
25418,
18275,
18276,
27714,
21061,
24330,
24329,
27108,
6449,
6446,
6447,
24059,
21072,
7716,
7719,
7711,
6525,
24848,
27550,
4038,
27335,
26640,
5211,
26163,
27849,
24067,
5174,
16765,
19754,
19745,
27881,
19749,
19721,
16251,
18785,
27630,
27631,
16744,
16745,
19797,
19283,
25960,
16702,
18297,
18392,
18396,
27622,
5220,
24851,
-1,
26468,
3401,
20949,
4930,
5172,
26798,
13986,
16779,
27682,
16713,
27650,
24868,
20928,
9695,
18771,
27390,
16780,
25892,
25891,
-1,
20874,
-1,
-1,
-1,
-1,
16686,
19613,
5176,
3406,
21060,
22185,
22186,
6526,
7006,
27554,
27351,
27375,
27397,
19208,
18711,
19801,
27199,
26452,
18068,
27846,
20947,
27338,
2536,
27662,
-1,
27489,
16704,
10098,
27590,
-1,
17948,
17441,
14020,
11990,
-1,
-1,
24100,
27721,
10079,
26460,
27476,
27694,
16790,
5060,
20879,
7356,
20942,
16133,
20892,
25420,
20944,
25387,
20933,
9018,
19598,
25419,
6450,
19763,
27346,
27348,
20945,
27347,
16786,
27665,
-1,
19771,
4917,
25388,
16688,
25421,
20932,
26466,
19597,
20946,
25389,
11983,
11980,
11979,
19528,
11978,
20925,
18414,
19530,
18071,
25386,
20897,
19529,
16784,
27663,
11981,
4936,
20896,
19798,
17814,
20878,
19792,
20904,
16134,
11982,
20924,
-1,
19599,
-1,
10080,
27478,
10075,
27474,
-1,
-1,
-1,
16742,
20921,
9628,
7717,
20939,
20902,
20903,
20936,
20937,
-1,
-1,
2534,
20922,
20943,
20891,
25951,
27372,
25952,
7707,
7702,
7715,
7714,
7709,
7704,
20915,
20909,
20916,
20910,
9631,
9630,
7708,
7703,
24803,
24795,
24796,
24801,
24802,
24798,
24799,
24805,
24804,
24806,
24818,
24810,
24811,
24816,
24817,
24813,
24814,
24820,
24819,
24821,
24789,
24781,
24782,
24787,
24788,
24784,
24785,
24791,
24790,
24792,
20927,
-1,
-1,
-1,
20905,
20911,
20941,
24866,
20912,
18336,
20899,
24858,
20938,
16732,
18285,
18286,
16733,
20890,
20889,
18795,
20880,
25635,
9867,
16252,
27380,
20917,
20940,
26792,
-1,
26791,
4888,
27696,
16800,
16801,
16802,
20884,
20885,
20886,
18072,
20898,
27725,
20929,
25398,
-1,
18280,
27680,
26453,
25392,
25391,
9658,
25454,
25292,
25872,
19308,
24053,
-1,
10125,
-1,
-1,
-1,
27620,
13977,
11943,
10081,
27483,
9745,
25514,
27332,
9194,
9196,
9703,
9702,
9758,
10123,
10115,
27468,
10150,
27612,
27615,
27614,
27568,
27574,
6308,
6301,
6311,
6304,
6310,
6303,
6307,
6300,
6309,
6302,
27446,
24369,
13969,
5197,
25469,
10108,
10120,
10114,
10106,
10118,
10113,
10109,
10121,
10107,
10119,
10122,
15578,
15323,
15451,
15324,
15515,
15388,
15452,
15325,
15547,
15420,
15484,
15357,
15516,
15389,
15453,
15326,
15563,
15436,
15500,
15373,
15532,
15405,
15469,
15342,
15548,
15421,
15485,
15358,
15517,
15390,
15454,
15327,
15571,
15444,
15508,
15381,
15540,
15413,
15477,
15350,
15556,
15429,
15493,
15366,
15525,
15398,
15462,
15335,
15564,
15437,
15501,
15374,
15533,
15406,
15470,
15343,
15549,
15422,
15486,
15359,
15518,
15391,
15455,
15328,
15575,
15448,
15512,
15385,
15544,
15417,
15481,
15354,
15560,
15433,
15497,
15370,
15529,
15402,
15466,
15339,
15568,
15441,
15505,
15378,
15537,
15410,
15474,
15347,
15553,
15426,
15490,
15363,
15522,
15395,
15459,
15332,
15572,
15445,
15509,
15382,
15541,
15414,
15478,
15351,
15557,
15430,
15494,
15367,
15526,
15399,
15463,
15336,
15565,
15438,
15502,
15375,
15534,
15407,
15471,
15344,
15550,
15423,
15487,
15360,
15519,
15392,
15456,
15329,
15577,
15450,
15514,
15387,
15546,
15419,
15483,
15356,
15562,
15435,
15499,
15372,
15531,
15404,
15468,
15341,
15570,
15443,
15507,
15380,
15539,
15412,
15476,
15349,
15555,
15428,
15492,
15365,
15524,
15397,
15461,
15334,
15574,
15447,
15511,
15384,
15543,
15416,
15480,
15353,
15559,
15432,
15496,
15369,
15528,
15401,
15465,
15338,
15567,
15440,
15504,
15377,
15536,
15409,
15473,
15346,
15552,
15425,
15489,
15362,
15521,
15394,
15458,
15331,
15576,
15449,
15513,
15386,
15545,
15418,
15482,
15355,
15561,
15434,
15498,
15371,
15530,
15403,
15467,
15340,
15569,
15442,
15506,
15379,
15538,
15411,
15475,
15348,
15554,
15427,
15491,
15364,
15523,
15396,
15460,
15333,
15573,
15446,
15510,
15383,
15542,
15415,
15479,
15352,
15558,
15431,
15495,
15368,
15527,
15400,
15464,
15337,
15566,
15439,
15503,
15376,
15535,
15408,
15472,
15345,
15551,
15424,
15488,
15361,
15520,
15393,
15457,
15330,
25597,
25598,
9842,
25610,
9670,
25599,
9844,
25612,
24340,
27408,
27442,
24363,
9846,
25614,
9835,
25603,
25600,
25542,
27410,
24343,
25535,
25536,
25593,
25595,
25596,
9799,
25567,
9845,
25613,
9784,
25555,
9797,
25565,
26729,
26757,
26726,
26755,
19700,
19710,
26728,
26756,
19703,
19711,
25647,
27388,
19702,
26753,
27389,
25646,
26754,
26727,
27710,
13696,
13697,
13700,
13699,
25634,
9866,
18356,
16528,
18358,
18357,
10076,
10084,
13965,
5193,
25562,
9794,
19609,
25545,
9777,
25551,
9667,
27440,
9722,
9724,
27459,
27461,
9721,
27458,
9725,
27462,
9809,
25577,
27425,
24358,
9814,
25582,
27420,
24353,
9810,
25578,
27426,
24359,
9815,
25583,
27421,
24354,
9807,
27418,
25576,
24352,
9808,
9817,
25575,
25585,
9806,
9816,
25574,
25584,
27419,
24351,
25484,
11887,
17801,
9793,
25561,
25563,
9992,
9788,
21776,
19373,
9787,
19304,
9749,
25521,
27470,
24376,
18305,
27890,
27900,
9681,
25474,
9685,
25478,
27898,
27893,
27899,
27894,
9646,
25444,
9644,
25443,
9645,
25442,
9700,
25462,
9708,
25470,
24260,
24288,
9727,
25523,
24390,
24057,
7736,
25463,
7737,
13974,
14003,
19790,
19789,
18390,
25861,
13973,
25862,
25425,
25426,
7725,
7726,
7734,
7735,
7728,
7731,
7729,
7732,
25867,
11954,
11952,
11953,
11955,
4954,
4935,
4914,
4925,
4913,
4956,
4946,
4934,
27466,
4918,
4939,
4713,
4937,
4947,
4952,
18791,
18789,
18794,
18769,
18768,
18411,
18335,
18333,
19803,
18334,
25501,
9711,
24056,
16532,
16531,
16791,
17812,
17811,
27686,
16768,
9687,
25480,
9731,
25486,
27151,
17815,
27145,
24327,
18552,
27150,
19612,
11890,
11891,
27009,
22318,
18294,
24380,
24379,
16740,
16719,
27601,
16685,
11964,
11968,
11965,
11969,
11966,
11970,
25796,
25873,
19717,
25871,
16872,
16873,
24273,
18309,
9863,
25631,
17808,
7767,
26804,
26803,
26802,
26809,
26808,
26813,
26812,
18407,
18406,
26819,
6800,
19391,
27872,
27367,
27122,
27124,
4959,
13968,
9468,
9467,
9469,
27125,
27873,
27120,
27118,
27121,
27116,
27119,
27117,
27850,
9195,
27889,
27888,
27887,
26429,
26431,
26426,
26430,
26425,
26428,
26432,
7763,
7762,
7761,
7760,
26436,
26435,
24068,
7355,
7354,
19746,
19692,
7351,
7350,
4927,
7352,
4907,
26434,
7764,
7349,
27110,
25638,
27895,
14012,
27098,
27540,
27539,
27096,
27097,
27541,
27543,
27100,
27544,
27101,
27545,
27102,
5186,
5188,
24249,
24248,
5187,
10145,
10135,
24259,
24258,
18410,
18409,
19783,
19784,
10138,
10147,
10136,
10148,
10137,
10144,
10146,
10143,
19681,
10134,
10133,
27901,
27896,
11894,
27010,
18315,
18314,
17799,
17798,
19525,
4032,
11896,
13982,
13808,
11888,
26437,
11886,
24241,
18412,
18282,
11893,
11909,
10001,
21785,
9999,
21783,
9974,
21756,
9978,
21760,
9976,
21758,
9977,
21759,
9983,
21765,
9996,
21780,
9997,
21781,
9994,
21778,
9989,
21773,
9990,
21774,
9993,
21777,
9991,
21775,
19776,
19778,
19777,
19779,
24325,
24326,
24320,
24321,
19520,
19521,
19523,
19524,
24275,
24277,
24276,
21767,
21790,
10002,
21791,
10003,
21792,
19690,
9198,
19691,
9199,
11895,
26397,
19379,
26396,
19378,
26401,
19383,
26399,
19381,
26402,
19384,
26400,
19382,
24272,
24245,
19368,
19299,
19366,
19297,
19367,
19298,
19363,
19294,
19360,
19291,
19358,
19289,
19361,
19292,
19359,
19290,
18703,
18595,
5184,
5182,
5185,
5183,
19371,
19303,
19372,
19302,
19306,
19307,
11944,
26464,
18340,
27354,
26794,
19610,
19607,
19603,
26454,
24054,
24266,
24055,
24265,
10126,
19608,
19605,
19606,
24285,
24279,
24250,
25854,
24408,
24042,
24041,
24374,
26147,
26146,
18306,
18303,
18319,
18311,
18312,
24322,
24323,
18317,
9190,
24251,
27670,
26818,
26758,
26730,
19704,
19712,
9673,
9855,
27448,
24371,
26760,
26732,
19706,
19714,
9676,
27455,
25539,
25538,
9771,
9770,
18547,
18553,
18537,
18544,
24828,
24827,
24826,
24829,
24387,
16721,
27651,
16777,
27671,
16788,
27692,
27689,
16771,
21070,
16722,
16764,
27658,
16763,
27657,
16696,
16695,
27583,
16769,
27687,
16776,
27669,
9706,
18277,
9707,
10110,
9829,
9830,
9831,
9832,
9774,
9767,
9768,
9825,
9827,
9828,
9786,
27711,
11889,
25876,
9792,
25553,
25552,
9852,
25621,
25875,
25560,
17802,
9795,
9791,
25559,
-1,
-1,
-1,
27654,
16693,
27581,
16728,
27637,
20918,
20931,
20875,
20872,
20876,
]

_charnames_11264 = [
22317,
22306,
22308,
22315,
22288,
22270,
22291,
22287,
22292,
22277,
22281,
22274,
22289,
22313,
22300,
22312,
22311,
22298,
22294,
22310,
22264,
22283,
22309,
22303,
22314,
22297,
22295,
22258,
22284,
22316,
22260,
22268,
22269,
22273,
22263,
22271,
22261,
22262,
22272,
22279,
22307,
22280,
22304,
22276,
22259,
22285,
22301,
-1,
22254,
22243,
22245,
22252,
22225,
22207,
22228,
22224,
22229,
22214,
22218,
22211,
22226,
22250,
22237,
22249,
22248,
22235,
22231,
22247,
22201,
22220,
22246,
22240,
22251,
22234,
22232,
22195,
22221,
22253,
22197,
22205,
22206,
22210,
22200,
22208,
22198,
22199,
22209,
22216,
22244,
22217,
22241,
22213,
22196,
22222,
22238,
-1,
8803,
8149,
8812,
8972,
8788,
8001,
7823,
8879,
8271,
8938,
8347,
8923,
8310,
8600,
8994,
8710,
8711,
8393,
8954,
8434,
8396,
8888,
8283,
7847,
7939,
7785,
7889,
9034,
8486,
6644,
8771,
8925,
3961,
3869,
3964,
3872,
3956,
3864,
3921,
3829,
3970,
3878,
3926,
3834,
3963,
3871,
3953,
3861,
3943,
3851,
3969,
3877,
3941,
3849,
3949,
3857,
3968,
3876,
3967,
3875,
3940,
3848,
3891,
3799,
3947,
3855,
3966,
3874,
3927,
3835,
3944,
3852,
3965,
3873,
3958,
3866,
3938,
3846,
3946,
3854,
3913,
3821,
3919,
3827,
3906,
3814,
3934,
3842,
3917,
3825,
3916,
3824,
3932,
3840,
3902,
3810,
3928,
3836,
3935,
3843,
3901,
3809,
3904,
3812,
3962,
3870,
3918,
3826,
3897,
3805,
3895,
3803,
3950,
3858,
3898,
3806,
3896,
3804,
3903,
3811,
3905,
3813,
3900,
3808,
3912,
3820,
3910,
3818,
3909,
3817,
3911,
3819,
3885,
3888,
3887,
3881,
3886,
3884,
3882,
3931,
3839,
3933,
3841,
3975,
3974,
3973,
]

_charnames_11513 = [
3979,
3980,
3978,
3977,
3983,
3982,
3984,
22126,
22125,
22111,
22124,
22123,
22114,
22093,
22096,
22122,
22105,
22121,
22120,
22119,
22118,
22102,
22092,
22116,
22099,
22095,
22115,
22101,
22104,
22110,
22117,
22098,
22087,
22090,
22107,
22089,
22088,
22112,
22108,
22081,
22084,
22083,
22113,
22080,
22082,
]

_charnames_11568 = [
17733,
17757,
17758,
17750,
17752,
17787,
17767,
17734,
17737,
17735,
17736,
17773,
17768,
17747,
17776,
17749,
17755,
17788,
17784,
17756,
17770,
17748,
17777,
17762,
17782,
17772,
17740,
17791,
17781,
17766,
17765,
17764,
17779,
17783,
17763,
17771,
17753,
17754,
17751,
17780,
17790,
17744,
17745,
17746,
17741,
17743,
17769,
17742,
17761,
17760,
17759,
17738,
17785,
17739,
]

_charnames_11648 = [
11779,
11730,
11768,
11429,
11396,
11759,
11465,
11575,
11677,
11668,
11363,
11634,
11697,
11688,
11789,
11438,
11566,
11596,
11608,
11351,
11353,
11350,
11349,
]

_charnames_11680 = [
11416,
11418,
11420,
11417,
11415,
11414,
11419,
-1,
11559,
11561,
11563,
11560,
11558,
11557,
11562,
-1,
11628,
11630,
11632,
11629,
11627,
11626,
11631,
-1,
11552,
11554,
11556,
11553,
11551,
11550,
11555,
-1,
11491,
11493,
11495,
11492,
11490,
11489,
11494,
-1,
11528,
11530,
11532,
11529,
11527,
11526,
11531,
-1,
11646,
11648,
11650,
11647,
11645,
11644,
11649,
-1,
11374,
11376,
11378,
11375,
11373,
11372,
11377,
-1,
3443,
3444,
3451,
3440,
3427,
3428,
3449,
3420,
3419,
3418,
3446,
3445,
3417,
3415,
3434,
3450,
3433,
3453,
3437,
3436,
3452,
3416,
3454,
3425,
3439,
3447,
3431,
3430,
3424,
3448,
3442,
3423,
25464,
25465,
9657,
25452,
9735,
25489,
25958,
25959,
24386,
9712,
25502,
25957,
9677,
25525,
12006,
26150,
27355,
25866,
21090,
24389,
24346,
27413,
24388,
24290,
27134,
26162,
21086,
17807,
9759,
25527,
17806,
17805,
9753,
25512,
18354,
18349,
16521,
16516,
9653,
25451,
9733,
25488,
18404,
25429,
18788,
27361,
25864,
24058,
25640,
27717,
]

_charnames_11904 = [
1232,
1119,
1141,
1139,
1140,
1250,
1169,
1226,
1257,
1256,
1253,
1142,
1153,
1152,
1193,
1191,
1192,
1194,
1147,
1225,
1146,
1145,
1210,
1209,
1213,
1229,
-1,
1124,
1154,
1163,
1254,
1161,
1121,
1181,
1180,
1260,
1249,
1248,
1133,
1123,
1252,
1205,
1171,
1220,
1150,
1149,
1176,
1135,
1091,
1237,
1235,
1236,
1238,
1165,
1155,
1230,
1221,
1261,
1174,
1173,
1166,
1162,
1244,
1242,
1243,
1224,
1118,
1187,
1186,
1093,
1132,
1212,
1090,
1092,
1259,
1115,
1130,
1184,
1183,
1122,
1107,
1197,
1196,
1104,
1108,
1160,
1159,
1231,
1175,
1098,
1105,
1112,
1101,
1219,
1217,
1218,
1111,
1211,
1113,
1170,
1245,
1102,
1116,
1094,
1129,
1134,
1100,
1203,
1110,
1202,
1097,
1204,
1114,
1223,
1201,
1096,
]

_charnames_12032 = [
22634,
22563,
22413,
22392,
22387,
22582,
22467,
22565,
22554,
22560,
22597,
22601,
22417,
22501,
22653,
22466,
22633,
22662,
22627,
22524,
22373,
22605,
22588,
22478,
22426,
22388,
22510,
22626,
22643,
22543,
22598,
22592,
22403,
22615,
22617,
22595,
22453,
22527,
22516,
22612,
22652,
22409,
22569,
22502,
22372,
22541,
22604,
22526,
22635,
22471,
22429,
22378,
22416,
22567,
22468,
22380,
22437,
22408,
22444,
22365,
22585,
22575,
22419,
22576,
22445,
22609,
22402,
22427,
22641,
22406,
22646,
22405,
22395,
22547,
22461,
22570,
22361,
22434,
22536,
22421,
22503,
22495,
22508,
22366,
22521,
22482,
22507,
22486,
22418,
22574,
22393,
22487,
22500,
22420,
22625,
22659,
22552,
22476,
22404,
22564,
22661,
22484,
22439,
22400,
22415,
22532,
22410,
22425,
22599,
22371,
22639,
22363,
22374,
22462,
22620,
22512,
22367,
22455,
22606,
22399,
22658,
22648,
22383,
22497,
22636,
22642,
22628,
22591,
22443,
22553,
22549,
22385,
22640,
22545,
22474,
22632,
22441,
22362,
22504,
22619,
22477,
22651,
22448,
22520,
22509,
22535,
22386,
22581,
22370,
22656,
22457,
22629,
22456,
22382,
22613,
22611,
22496,
22440,
22514,
22451,
22546,
22519,
22515,
22529,
22424,
22655,
22616,
22566,
22622,
22542,
22391,
22379,
22610,
22447,
22523,
22488,
22558,
22464,
22561,
22407,
22559,
22530,
22493,
22593,
22586,
22491,
22580,
22438,
22465,
22577,
22483,
22397,
22513,
22621,
22481,
22452,
22396,
22433,
22533,
22587,
22660,
22550,
22449,
22600,
22490,
22460,
22430,
22608,
22647,
22594,
22473,
22431,
22470,
22494,
]

_charnames_12272 = [
26987,
26991,
26988,
26990,
26993,
26985,
26984,
26983,
26980,
26979,
26982,
26992,
-1,
-1,
-1,
-1,
26999,
26996,
27005,
24852,
27845,
27003,
26997,
27001,
9699,
25461,
9734,
25485,
9694,
25496,
9682,
25475,
9728,
25524,
26471,
22187,
9716,
25503,
9686,
25479,
9683,
25476,
9684,
25477,
27712,
25853,
24271,
10101,
26472,
20410,
20398,
20401,
20408,
20409,
20405,
20406,
20412,
20411,
27002,
27000,
26994,
27006,
20392,
20394,
27707,
24046,
24050,
24048,
24051,
24049,
4911,
26952,
20403,
20399,
20402,
24060,
6523,
26157,
26998,
27004,
-1,
20970,
21056,
20968,
21054,
20965,
21052,
20969,
21055,
20967,
21053,
21017,
21029,
21015,
21027,
21013,
21025,
21016,
21028,
21014,
21026,
20975,
20987,
20973,
20985,
20971,
20983,
20974,
20986,
20972,
20984,
20993,
21035,
20991,
21033,
20966,
20989,
21031,
20992,
21034,
20990,
21032,
20981,
20979,
20977,
20980,
20978,
21023,
21041,
21005,
21021,
21039,
21003,
21019,
21037,
21001,
21022,
21040,
21004,
21020,
21038,
21002,
21011,
21009,
21007,
21010,
21008,
20960,
21050,
20958,
21048,
20959,
21049,
20999,
20997,
20995,
20998,
20996,
20964,
21046,
21044,
21045,
21043,
20976,
21051,
20963,
20962,
-1,
-1,
3779,
3780,
22913,
22914,
21058,
21057,
21059,
22916,
22816,
22907,
22814,
22905,
22810,
22903,
22815,
22906,
22811,
22904,
22869,
22881,
22867,
22879,
22865,
22877,
22868,
22880,
22866,
22878,
22821,
22833,
22819,
22831,
22817,
22829,
22820,
22832,
22818,
22830,
22845,
22887,
22843,
22885,
22804,
22841,
22883,
22844,
22886,
22842,
22884,
22827,
22825,
22823,
22826,
22824,
22875,
22893,
22857,
22873,
22891,
22855,
22871,
22889,
22853,
22874,
22892,
22856,
22872,
22890,
22854,
22863,
22861,
22859,
22862,
22860,
22798,
22902,
22796,
22900,
22797,
22901,
22851,
22849,
22847,
22850,
22848,
22809,
22898,
22896,
22897,
22895,
22822,
22835,
22802,
22801,
22839,
22837,
22838,
22836,
22909,
22915,
22910,
22908,
22911,
-1,
-1,
-1,
-1,
-1,
16492,
16499,
16500,
16504,
16505,
16496,
16478,
16501,
16481,
16502,
16503,
16488,
16498,
16494,
16477,
16491,
16487,
16497,
16475,
16490,
16486,
16444,
16468,
16453,
16459,
16450,
16458,
16448,
16472,
16445,
16454,
16447,
16456,
16457,
16461,
16484,
16464,
16495,
16479,
16483,
16467,
-1,
-1,
-1,
20351,
20303,
20352,
20354,
20360,
20359,
20381,
20299,
20314,
20324,
20328,
20317,
20327,
20323,
20319,
20329,
20367,
20331,
20301,
20333,
20307,
20300,
20386,
20388,
20306,
20389,
20353,
20382,
20342,
20391,
20373,
20376,
20294,
20295,
20379,
20377,
20282,
20277,
20383,
20364,
20365,
20384,
20289,
20390,
20363,
20362,
20366,
20284,
20378,
20296,
20385,
20393,
20302,
20356,
20357,
20358,
20325,
20322,
20318,
20320,
20326,
20370,
20372,
20371,
20350,
20340,
20338,
20336,
20335,
20341,
20339,
20347,
20349,
20312,
20311,
20309,
20310,
20313,
20343,
20304,
20278,
20280,
20281,
20348,
20305,
20283,
20291,
20292,
20293,
20287,
20286,
20288,
20374,
20375,
-1,
26971,
26969,
26970,
26958,
26956,
26963,
26959,
26966,
26974,
26964,
26968,
26957,
26962,
26972,
26973,
26967,
16493,
16476,
16489,
16482,
16460,
16455,
16473,
16470,
16465,
16446,
16462,
16485,
16466,
16480,
16451,
16449,
16452,
16474,
16471,
16463,
16508,
16507,
16509,
16510,
]

_charnames_12736 = [
1291,
1294,
1293,
1298,
1281,
1265,
1272,
1273,
1270,
1280,
1271,
1268,
1274,
1269,
1266,
1296,
1263,
1277,
1287,
1285,
1297,
1264,
1276,
1278,
1282,
1284,
1286,
1290,
1288,
1292,
1279,
1283,
1275,
1267,
1289,
1295,
]

_charnames_12784 = [
22800,
22808,
22807,
22805,
22812,
22794,
22792,
22790,
22793,
22791,
22813,
22788,
22786,
22784,
22787,
22785,
26094,
26102,
26084,
26100,
26104,
26089,
26098,
26106,
26077,
26081,
26096,
26086,
26091,
26108,
26095,
26103,
26085,
26101,
26105,
26090,
26099,
26107,
26080,
26082,
26097,
26087,
26092,
26109,
26079,
26141,
26142,
-1,
26071,
26052,
26053,
26043,
26040,
26037,
26033,
26057,
26063,
26054,
26066,
26041,
26061,
26060,
26067,
26058,
26028,
26031,
26073,
26036,
26064,
26035,
26042,
26069,
26072,
26049,
26070,
26030,
26027,
26056,
26048,
26074,
26044,
26047,
26034,
26050,
4650,
4643,
4593,
4642,
4753,
4727,
4745,
4766,
4775,
4779,
4782,
4786,
26156,
4726,
4720,
4721,
4729,
4730,
4723,
4724,
4732,
4731,
4735,
4744,
4738,
4739,
4747,
4748,
4864,
4881,
4854,
4879,
4883,
4859,
4877,
4873,
4869,
4871,
4866,
4856,
4861,
4885,
4865,
4882,
4855,
4880,
4884,
4860,
4878,
4876,
4870,
4872,
4867,
4857,
4862,
4886,
4850,
4849,
4875,
23379,
4652,
4626,
4627,
4599,
4596,
4592,
4588,
4617,
4631,
4628,
4612,
4597,
4640,
4639,
4610,
4618,
4582,
4586,
4646,
4591,
4633,
4590,
4598,
4623,
4637,
4589,
4613,
4600,
4583,
4615,
4651,
4648,
4653,
4604,
4622,
4621,
4645,
4624,
4635,
4636,
4607,
4611,
4606,
4585,
4581,
4616,
4605,
4649,
4632,
4741,
4742,
4750,
4749,
4756,
4765,
4759,
4760,
4768,
4769,
4762,
4763,
4771,
4770,
4774,
26941,
26951,
26944,
26947,
26943,
26939,
26940,
26946,
26948,
26949,
26950,
26900,
18575,
18648,
18649,
9561,
4847,
4845,
4843,
4846,
4844,
4827,
4825,
4823,
4826,
4824,
4803,
4801,
4799,
4802,
4800,
4797,
4795,
4793,
4796,
4794,
4815,
4813,
4811,
4814,
4812,
4833,
4831,
4829,
4832,
4830,
4821,
4819,
4817,
4820,
4818,
4842,
4840,
4841,
4809,
4807,
4805,
4808,
4806,
4838,
4836,
4837,
4835,
-1,
18683,
18682,
18684,
18686,
18665,
18664,
18718,
18650,
18651,
18695,
18694,
18483,
18482,
18481,
18582,
18583,
18580,
18579,
18490,
18578,
18475,
18478,
18477,
18476,
18585,
18586,
18485,
18486,
18499,
18488,
18489,
18658,
18657,
18661,
18655,
18654,
18626,
18630,
18627,
18715,
18634,
18638,
18572,
18513,
18512,
18674,
18519,
18517,
18518,
18678,
18560,
18559,
18675,
18558,
18570,
18508,
18507,
18569,
18506,
18509,
18679,
18522,
18677,
18565,
18521,
18563,
18564,
18432,
18431,
18435,
18433,
18434,
18447,
18444,
18445,
18453,
18454,
18455,
18707,
18706,
18708,
18593,
18594,
18601,
18600,
18604,
18603,
18555,
26935,
26936,
26913,
26915,
26924,
26927,
26919,
26921,
26930,
26933,
26917,
26932,
26912,
26916,
26925,
26928,
26920,
26922,
26931,
26934,
26905,
26910,
26908,
26909,
26911,
18567,
18625,
18681,
18673,
18693,
18531,
18621,
18623,
18624,
18670,
18647,
18645,
18644,
18646,
18612,
18514,
18633,
18428,
18429,
18479,
18501,
18460,
18590,
18615,
18500,
18530,
18640,
18427,
18426,
18467,
18498,
18573,
18497,
18466,
18589,
18716,
18425,
18465,
18628,
18495,
18713,
18639,
18424,
18448,
18607,
18469,
18450,
18609,
18441,
18474,
18451,
18610,
18442,
18472,
18438,
18439,
18510,
18494,
18463,
18588,
18596,
18597,
18598,
18525,
18637,
18423,
18462,
18524,
18636,
18422,
18458,
18492,
18459,
18523,
18635,
18421,
18456,
18491,
18457,
18502,
18440,
18685,
18676,
18618,
18617,
18619,
18611,
18631,
18587,
18571,
18566,
18663,
18496,
18473,
18493,
18702,
18701,
18699,
18700,
18461,
18446,
18464,
18529,
18528,
18527,
18526,
18660,
18659,
18554,
18717,
18687,
26899,
26874,
26880,
26888,
26891,
26883,
26885,
26894,
26897,
26881,
26896,
26873,
26879,
26889,
26892,
26884,
26886,
26895,
26898,
26859,
26870,
26862,
26863,
26868,
26869,
26865,
26866,
26872,
26871,
26877,
26878,
18584,
]

_charnames_19904 = [
20778,
20789,
20803,
20865,
20858,
20846,
20784,
20867,
20819,
20795,
20837,
20821,
20864,
20812,
20861,
20868,
20863,
20857,
20853,
20845,
20850,
20815,
20822,
20831,
20825,
20814,
20860,
20813,
20785,
20779,
20827,
20804,
20832,
20811,
20836,
20805,
20794,
20841,
20842,
20799,
20800,
20828,
20849,
20847,
20816,
20835,
20840,
20787,
20833,
20780,
20783,
20791,
20798,
20790,
20855,
20788,
20793,
20792,
20802,
20866,
20826,
20820,
20854,
20851,
]

_charnames_40960 = [
15224,
15223,
15218,
15225,
15221,
15220,
15219,
15222,
15232,
15231,
15230,
15233,
15235,
15234,
15236,
15228,
15227,
15226,
15229,
15238,
15237,
15204,
14586,
14585,
14580,
14587,
14583,
14582,
14581,
14584,
14600,
14599,
14598,
14601,
14573,
14572,
14574,
14596,
14595,
14594,
14597,
14603,
14602,
14604,
14578,
14577,
14571,
14579,
14576,
14575,
14592,
14591,
14588,
14593,
14590,
14589,
15028,
15027,
15023,
15029,
15025,
15024,
15026,
15042,
15041,
15040,
15043,
15016,
15015,
15017,
15038,
15037,
15036,
15039,
15021,
15020,
15014,
15022,
15019,
15018,
15034,
15033,
15030,
15035,
15032,
15031,
14554,
14553,
14548,
14555,
14551,
14550,
14549,
14552,
14566,
14565,
14564,
14567,
14541,
14540,
14542,
14562,
14561,
14560,
14563,
14569,
14568,
14570,
14546,
14545,
14539,
14547,
14544,
14543,
14558,
14557,
14556,
14559,
14063,
14062,
14058,
14064,
14060,
14059,
14061,
14083,
14082,
14081,
14084,
14079,
14078,
14077,
14080,
14075,
14074,
14071,
14076,
14073,
14072,
14069,
14068,
14065,
14070,
14067,
14066,
14272,
14271,
14267,
14273,
14269,
14268,
14270,
14285,
14284,
14283,
14286,
14260,
14259,
14261,
14281,
14280,
14279,
14282,
14265,
14264,
14258,
14266,
14263,
14262,
14277,
14274,
14278,
14276,
14275,
14767,
14766,
14762,
14768,
14764,
14763,
14765,
14779,
14778,
14777,
14780,
14755,
14754,
14753,
14756,
14775,
14774,
14773,
14776,
14782,
14781,
14760,
14759,
14752,
14761,
14758,
14757,
14771,
14770,
14769,
14772,
15173,
15172,
15171,
15174,
15177,
15176,
15175,
15178,
15180,
15179,
15181,
15165,
15164,
15161,
15166,
15163,
15162,
15169,
15168,
15167,
15170,
14988,
14987,
14982,
14989,
14985,
14984,
14983,
14986,
15008,
15007,
15006,
15009,
15004,
15003,
15002,
15005,
15011,
15012,
15000,
14999,
14996,
15001,
14998,
14997,
14994,
14993,
14990,
14995,
14992,
14991,
14880,
14879,
14875,
14881,
14877,
14876,
14878,
14888,
14887,
14886,
14889,
14871,
14870,
14884,
14883,
14882,
14885,
14891,
14890,
14892,
14873,
14872,
14867,
14874,
14869,
14868,
15089,
15088,
15084,
15090,
15086,
15085,
15087,
15097,
15096,
15095,
15098,
15077,
15076,
15075,
15078,
15093,
15092,
15091,
15094,
15100,
15099,
15101,
15082,
15081,
15074,
15083,
15080,
15079,
14854,
14853,
14849,
14855,
14851,
14850,
14852,
14862,
14861,
14860,
14863,
14842,
14841,
14843,
14858,
14857,
14856,
14859,
14865,
14864,
14866,
14847,
14846,
14840,
14848,
14845,
14844,
14146,
14145,
14142,
14147,
14144,
14143,
14154,
14153,
14152,
14155,
14150,
14149,
14148,
14151,
14157,
14156,
14158,
14140,
14139,
14136,
14141,
14138,
14137,
14318,
14317,
14312,
14319,
14315,
14314,
14313,
14316,
14322,
14321,
14320,
14323,
14326,
14325,
14330,
14329,
14331,
14333,
14332,
14334,
14327,
14211,
14210,
14206,
14212,
14208,
14207,
14209,
14221,
14220,
14222,
14199,
14198,
14200,
14215,
14214,
14213,
14216,
14218,
14217,
14219,
14204,
14203,
14197,
14205,
14202,
14201,
14239,
14238,
14234,
14240,
14236,
14235,
14237,
14249,
14248,
14247,
14250,
14227,
14226,
14228,
14252,
14251,
14253,
14255,
14254,
14256,
14232,
14231,
14225,
14233,
14230,
14229,
14245,
14244,
14241,
14246,
14243,
14242,
14962,
14961,
14956,
14963,
14959,
14958,
14957,
14960,
14976,
14975,
14974,
14977,
14949,
14948,
14947,
14950,
14972,
14971,
14970,
14973,
14979,
14978,
14980,
14954,
14953,
14946,
14955,
14952,
14951,
14968,
14967,
14964,
14969,
14966,
14965,
14714,
14713,
14708,
14715,
14711,
14710,
14709,
14712,
14726,
14725,
14724,
14727,
14701,
14700,
14699,
14702,
14718,
14717,
14716,
14719,
14722,
14721,
14720,
14723,
14706,
14705,
14698,
14707,
14704,
14703,
15146,
15145,
15141,
15147,
15143,
15142,
15144,
15158,
15157,
15156,
15159,
15134,
15133,
15135,
15150,
15149,
15148,
15151,
15154,
15153,
15152,
15155,
15139,
15138,
15132,
15140,
15137,
15136,
14685,
14684,
14680,
14682,
14681,
14683,
14696,
14695,
14694,
14697,
14673,
14672,
14671,
14674,
14688,
14687,
14686,
14689,
14692,
14691,
14690,
14693,
14678,
14677,
14670,
14679,
14676,
14675,
14751,
14750,
14745,
14744,
14743,
14746,
14732,
14731,
14733,
14741,
14740,
14739,
14742,
14748,
14747,
14749,
14737,
14736,
14730,
14738,
14735,
14734,
14294,
14293,
14288,
14295,
14291,
14290,
14289,
14292,
14306,
14305,
14304,
14307,
14298,
14297,
14296,
14299,
14302,
14301,
14300,
14303,
14309,
14308,
14310,
14192,
14191,
14193,
14186,
14185,
14184,
14187,
14190,
14189,
14188,
14182,
14181,
14180,
14183,
14195,
14194,
14196,
14350,
14349,
14348,
14345,
14344,
14343,
14346,
14337,
14336,
14335,
14338,
14341,
14340,
14339,
14342,
14352,
14351,
14353,
15210,
15209,
15208,
15211,
15206,
15205,
15207,
15213,
15212,
15214,
15216,
15215,
15217,
14427,
14426,
14422,
14428,
14424,
14423,
14425,
14441,
14440,
14439,
14442,
14415,
14414,
14416,
14437,
14436,
14435,
14438,
14444,
14443,
14445,
14420,
14419,
14413,
14421,
14418,
14417,
14433,
14432,
14429,
14434,
14431,
14430,
14649,
14648,
14643,
14650,
14646,
14645,
14644,
14647,
14663,
14662,
14661,
14664,
14636,
14635,
14637,
14659,
14658,
14657,
14660,
14666,
14665,
14667,
14641,
14640,
14634,
14642,
14639,
14638,
14655,
14654,
14651,
14656,
14653,
14652,
14362,
14361,
14356,
14363,
14359,
14358,
14357,
14360,
14377,
14376,
14375,
14378,
14380,
14379,
14381,
14383,
14382,
14384,
14373,
14370,
14374,
14372,
14371,
14368,
14367,
14364,
14369,
14366,
14365,
14040,
14039,
14035,
14041,
14037,
14036,
14038,
14050,
14049,
14048,
14051,
14032,
14031,
14053,
14054,
14056,
14055,
14033,
14028,
14034,
14030,
14029,
14046,
14045,
14042,
14047,
14044,
14043,
14518,
14517,
14513,
14519,
14515,
14514,
14516,
14532,
14531,
14530,
14533,
14506,
14505,
14507,
14528,
14527,
14526,
14529,
14535,
14534,
14536,
14511,
14510,
14504,
14512,
14509,
14508,
14524,
14523,
14520,
14525,
14522,
14521,
14453,
14452,
14448,
14454,
14450,
14449,
14451,
14471,
14470,
14469,
14472,
14467,
14466,
14465,
14468,
14474,
14473,
14475,
14463,
14462,
14461,
14464,
14459,
14458,
14455,
14460,
14457,
14456,
14411,
14410,
14409,
14412,
14388,
14387,
14389,
14403,
14402,
14401,
14404,
14407,
14406,
14405,
14408,
14393,
14392,
14386,
14394,
14391,
14390,
14399,
14398,
14395,
14400,
14397,
14396,
14632,
14631,
14630,
14633,
14610,
14609,
14608,
14611,
14624,
14623,
14622,
14625,
14628,
14627,
14626,
14629,
14614,
14607,
14615,
14613,
14612,
14620,
14619,
14616,
14621,
14618,
14617,
14918,
14917,
14899,
14898,
14911,
14910,
14909,
14912,
14915,
14914,
14913,
14916,
14901,
14900,
14895,
14902,
14897,
14896,
14907,
14906,
14903,
14908,
14905,
14904,
14130,
14129,
14128,
14131,
14133,
14132,
14134,
14126,
14125,
14124,
14127,
14122,
14121,
14118,
14123,
14120,
14119,
14116,
14115,
14112,
14117,
14114,
14113,
14502,
14501,
14500,
14503,
14479,
14478,
14480,
14494,
14493,
14492,
14495,
14498,
14497,
14496,
14499,
14484,
14483,
14477,
14485,
14482,
14481,
14490,
14489,
14486,
14491,
14488,
14487,
14940,
14939,
14938,
14941,
14921,
14920,
14922,
14936,
14935,
14934,
14937,
14943,
14942,
14944,
14926,
14925,
14919,
14927,
14924,
14923,
14932,
14931,
14928,
14933,
14930,
14929,
14826,
14825,
14820,
14827,
14823,
14822,
14821,
14824,
14813,
14812,
14811,
14814,
14836,
14835,
14834,
14837,
14818,
14817,
14810,
14819,
14816,
14815,
14832,
14831,
14828,
14833,
14830,
14829,
15119,
15118,
15113,
15120,
15116,
15115,
15114,
15117,
15106,
15105,
15104,
15107,
15129,
15128,
15127,
15130,
15111,
15110,
15103,
15112,
15109,
15108,
15125,
15124,
15121,
15126,
15123,
15122,
14800,
14799,
14794,
14801,
14797,
14796,
14795,
14798,
14787,
14786,
14788,
14808,
14807,
14806,
14809,
14792,
14791,
14785,
14793,
14790,
14789,
14804,
14803,
14802,
14805,
14092,
14091,
14086,
14093,
14089,
14088,
14087,
14090,
14098,
14097,
14109,
14108,
14107,
14110,
14099,
14094,
14100,
14096,
14095,
14105,
14104,
14101,
14106,
14103,
14102,
14166,
14165,
14160,
14167,
14163,
14162,
14161,
14164,
14170,
14169,
14171,
14177,
14176,
14175,
14178,
14173,
14172,
14168,
14174,
15189,
15188,
15183,
15190,
15186,
15185,
15184,
15187,
15202,
15201,
15199,
15198,
15197,
15200,
15195,
15194,
15191,
15196,
15193,
15192,
15061,
15060,
15055,
15062,
15058,
15057,
15056,
15059,
15048,
15047,
15046,
15049,
15071,
15070,
15069,
15072,
15053,
15052,
15045,
15054,
15051,
15050,
15067,
15066,
15063,
15068,
15065,
15064,
-1,
-1,
-1,
15315,
15287,
15306,
15271,
15243,
15260,
15264,
15266,
15304,
15284,
15289,
15313,
15303,
15291,
15301,
15282,
15298,
15267,
15250,
15242,
15310,
15312,
15263,
15270,
15297,
15316,
15277,
15252,
15300,
15285,
15292,
15294,
15256,
15295,
15253,
15279,
15272,
15276,
15265,
15278,
15314,
15309,
15257,
15288,
15241,
15244,
15245,
15283,
15259,
15249,
15258,
15246,
15251,
15273,
15307,
]

_charnames_42192 = [
9622,
9589,
9588,
9608,
9577,
9576,
9603,
9597,
9596,
9619,
9611,
9610,
9607,
9575,
9574,
9617,
9594,
9618,
9586,
9582,
9583,
9593,
9600,
9615,
9599,
9621,
9616,
9585,
9614,
9602,
9612,
9613,
9604,
9605,
9620,
9590,
9578,
9580,
9579,
9591,
9567,
9572,
9570,
9571,
9568,
9569,
9625,
9624,
23685,
23686,
23608,
23545,
23546,
23652,
23591,
23598,
23450,
23489,
23442,
23511,
23668,
23636,
23566,
23559,
23474,
23467,
23618,
23644,
23481,
23410,
23582,
23575,
23535,
23528,
23676,
23660,
23426,
23628,
23499,
23391,
23517,
23457,
23433,
23418,
23690,
23691,
23611,
23612,
23550,
23551,
23654,
23593,
23600,
23452,
23495,
23444,
23513,
23670,
23638,
23568,
23561,
23476,
23469,
23622,
23646,
23483,
23412,
23584,
23577,
23537,
23530,
23678,
23662,
23428,
23630,
23503,
23395,
23521,
23459,
23435,
23420,
23692,
23693,
23399,
23613,
23614,
23552,
23553,
23655,
23594,
23601,
23453,
23492,
23493,
23445,
23514,
23671,
23639,
23569,
23562,
23477,
23470,
23623,
23647,
23484,
23413,
23585,
23578,
23538,
23531,
23679,
23663,
23429,
23631,
23500,
23501,
23396,
23522,
23460,
23436,
23421,
23681,
23682,
23604,
23541,
23542,
23650,
23589,
23596,
23448,
23491,
23440,
23507,
23666,
23634,
23564,
23557,
23472,
23465,
23620,
23642,
23479,
23408,
23580,
23573,
23533,
23526,
23674,
23658,
23424,
23626,
23497,
23393,
23519,
23455,
23431,
23416,
23688,
23689,
23609,
23610,
23548,
23549,
23653,
23592,
23599,
23451,
23494,
23443,
23512,
23669,
23637,
23567,
23560,
23475,
23468,
23621,
23645,
23482,
23411,
23583,
23576,
23536,
23529,
23677,
23661,
23427,
23629,
23502,
23394,
23520,
23458,
23434,
23419,
23680,
23683,
23397,
23603,
23605,
23540,
23543,
23649,
23588,
23595,
23447,
23490,
23439,
23506,
23508,
23665,
23633,
23563,
23556,
23471,
23464,
23619,
23641,
23478,
23401,
23579,
23572,
23532,
23525,
23673,
23657,
23423,
23625,
23496,
23392,
23518,
23454,
23430,
23415,
23684,
23687,
23398,
23606,
23607,
23544,
23547,
23651,
23590,
23597,
23449,
23487,
23488,
23441,
23509,
23510,
23667,
23635,
23565,
23558,
23473,
23466,
23616,
23643,
23480,
23409,
23581,
23574,
23534,
23527,
23675,
23659,
23425,
23627,
23498,
23389,
23390,
23515,
23516,
23456,
23432,
23417,
23387,
23617,
23729,
23728,
23727,
23406,
23405,
23403,
23708,
23706,
23697,
23710,
23712,
23709,
23698,
23703,
23701,
23705,
23696,
23702,
23711,
23723,
23724,
23715,
23716,
23721,
23722,
23718,
23719,
23726,
23725,
23404,
23407,
]

_charnames_42560 = [
4381,
4152,
4359,
4130,
4465,
4236,
4324,
4095,
4364,
4135,
4487,
4259,
4414,
4185,
4485,
4257,
4386,
4157,
4318,
4089,
4464,
4235,
4323,
4094,
4459,
4230,
4415,
4186,
4321,
4092,
4391,
4162,
-1,
-1,
4350,
4121,
4348,
4119,
4347,
4118,
4488,
4260,
4411,
4182,
4366,
4137,
4501,
3468,
3464,
3467,
3463,
19780,
]

_charnames_42620 = [
3470,
3457,
4504,
4503,
4365,
4136,
4361,
4132,
4376,
4147,
4460,
4231,
4360,
4131,
4401,
4172,
4403,
4174,
4395,
4166,
4396,
4167,
4404,
4175,
4451,
4222,
4341,
4112,
]

_charnames_42656 = [
16239,
16168,
16235,
16165,
16238,
16194,
16214,
16236,
16151,
16237,
16222,
16208,
16196,
16197,
16221,
16172,
16215,
16154,
16141,
16169,
16186,
16176,
16184,
16187,
16185,
16188,
16164,
16162,
16147,
16146,
16139,
16230,
16182,
16229,
16231,
16152,
16161,
16205,
16140,
16150,
16202,
16233,
16206,
16226,
16198,
16218,
16178,
16153,
16192,
16199,
16163,
16143,
16144,
16145,
16183,
16203,
16224,
16225,
16234,
16155,
16220,
16207,
16219,
16157,
16174,
16193,
16171,
16179,
16216,
16167,
16177,
16175,
16211,
16166,
16212,
16149,
16189,
16227,
16158,
16159,
16244,
16243,
16249,
16250,
16246,
16245,
16247,
16248,
]

_charnames_42752 = [
6663,
6668,
6660,
6665,
6662,
6667,
6661,
6666,
6729,
6766,
6741,
6685,
6723,
6730,
6767,
6742,
6686,
6724,
6732,
6769,
6744,
6682,
6726,
6754,
6755,
6756,
6701,
6707,
6710,
6709,
6708,
6697,
6627,
6626,
8645,
7962,
8646,
7963,
8887,
8280,
8723,
7842,
8724,
7844,
8914,
8301,
8915,
8302,
9060,
9053,
8602,
8019,
8599,
8018,
8598,
8017,
8595,
8012,
8596,
8013,
8597,
8016,
8796,
8133,
8939,
8348,
8937,
8346,
8940,
8349,
8988,
8384,
8815,
8160,
8541,
7891,
8540,
7890,
8550,
7906,
8973,
8404,
8976,
8409,
8974,
8405,
9005,
8442,
9006,
8443,
8793,
8126,
8797,
8137,
8963,
8391,
8966,
8397,
8967,
8398,
8721,
7839,
8722,
7840,
8968,
8399,
8642,
7959,
8755,
8205,
8916,
8303,
6775,
8238,
8169,
8425,
8262,
8136,
9026,
7810,
8067,
8754,
8202,
8753,
8201,
8752,
8715,
7800,
8714,
7805,
8751,
8199,
8750,
8198,
8749,
8197,
6699,
6674,
6629,
8775,
8102,
]

_charnames_43003 = [
9091,
9090,
9093,
9094,
9095,
18946,
18943,
18960,
18937,
18945,
18939,
18959,
18923,
18924,
18929,
18930,
18961,
18932,
18933,
18926,
18927,
18906,
18907,
18912,
18913,
18908,
18909,
18914,
18915,
18940,
18920,
18921,
18935,
18936,
18941,
18918,
18942,
18917,
18938,
18944,
18952,
18950,
18948,
18951,
18949,
18957,
18956,
18955,
18954,
-1,
-1,
-1,
-1,
26737,
26738,
26742,
26736,
26739,
26741,
26744,
26747,
26746,
26745,
-1,
-1,
-1,
-1,
-1,
-1,
26208,
26207,
26211,
26180,
26191,
26193,
26223,
26178,
26176,
26175,
26189,
26181,
26205,
26204,
26227,
26221,
26174,
26173,
26187,
26216,
26198,
26199,
26183,
26214,
26218,
26222,
26184,
26185,
26225,
26194,
26224,
26217,
26212,
26220,
26219,
26215,
26226,
26210,
26213,
26232,
26231,
26171,
26170,
26188,
26179,
26196,
26201,
26202,
26195,
26233,
26234,
26192,
26235,
26239,
26237,
26238,
]

_charnames_43136 = [
19126,
19124,
19046,
19049,
19070,
19071,
19054,
19055,
19024,
19025,
19026,
19027,
19075,
19076,
19048,
19059,
19060,
19047,
19066,
19065,
19074,
19073,
19038,
19079,
19078,
19069,
19068,
19036,
19032,
19031,
19043,
19042,
19037,
19034,
19033,
19045,
19044,
19039,
19058,
19057,
19082,
19081,
19085,
19083,
19084,
19063,
19028,
19052,
19051,
19053,
19086,
19062,
19127,
19096,
19101,
19102,
19097,
19098,
19089,
19090,
19091,
19092,
19103,
19104,
19095,
19099,
19100,
19094,
19125,
]

_charnames_43214 = [
19121,
19120,
19116,
19117,
19108,
19109,
19114,
19115,
19111,
19112,
19119,
19118,
-1,
-1,
-1,
-1,
-1,
-1,
3608,
3609,
3600,
3601,
3606,
3607,
3603,
3604,
3611,
3610,
3619,
3614,
3618,
3617,
3616,
3615,
3613,
3620,
24553,
24545,
24558,
24543,
24544,
24546,
24554,
24581,
24587,
24586,
-1,
-1,
-1,
-1,
23052,
23053,
23044,
23045,
23050,
23051,
23047,
23048,
23055,
23054,
23025,
23024,
23037,
23009,
23016,
23015,
23029,
23008,
23013,
23027,
23010,
23019,
23018,
23034,
23038,
23040,
23033,
23030,
23035,
23031,
23012,
23028,
23032,
23039,
23041,
23022,
23036,
23021,
23058,
23059,
23057,
23060,
23061,
23065,
23063,
23064,
23068,
23067,
25819,
25822,
25806,
25814,
25823,
25808,
25817,
25825,
25811,
25824,
25820,
25803,
25815,
25816,
25818,
25812,
25813,
25821,
25810,
25805,
25807,
25802,
25826,
25837,
25835,
25829,
25834,
25836,
25833,
25830,
25831,
25841,
25840,
25842,
25843,
25838,
]

_charnames_43359 = [
25844,
20240,
20239,
20237,
20242,
20208,
20205,
20211,
20203,
20214,
20212,
20204,
20210,
20206,
20216,
20209,
20268,
20265,
20266,
20151,
20161,
20167,
20133,
20230,
20233,
20135,
20131,
20171,
20273,
20136,
-1,
-1,
-1,
27836,
27833,
27837,
27835,
27774,
27763,
27761,
27762,
27778,
27756,
27733,
27734,
27783,
27775,
27779,
27757,
27759,
27760,
27768,
27769,
27732,
27770,
27771,
27766,
27736,
27767,
27735,
27740,
27741,
27745,
27746,
27738,
27742,
27743,
27747,
27748,
27737,
27753,
27755,
27772,
27773,
27780,
27776,
27764,
27765,
27781,
27777,
27751,
27752,
27749,
27782,
27834,
27823,
27825,
27826,
27827,
27828,
27829,
27824,
27831,
27830,
27840,
27839,
27841,
27805,
27784,
27843,
27795,
27801,
27790,
27799,
27798,
27791,
27789,
27793,
27794,
27797,
27842,
-1,
27804,
27816,
27817,
27808,
27809,
27814,
27815,
27811,
27812,
27819,
27818,
-1,
-1,
-1,
-1,
27800,
27802,
]

_charnames_43520 = [
5119,
5127,
5123,
5129,
5120,
5125,
5109,
5108,
5115,
5114,
5082,
5083,
5118,
5117,
5112,
5111,
5078,
5080,
5079,
5100,
5099,
5093,
5091,
5084,
5085,
5092,
5089,
5087,
5088,
5097,
5095,
5105,
5106,
5096,
5121,
5124,
5126,
5122,
5102,
5103,
5128,
5134,
5139,
5140,
5141,
5135,
5138,
5137,
5133,
5132,
5136,
5161,
5163,
5164,
5162,
]

_charnames_43584 = [
5073,
5074,
5066,
5158,
5075,
5068,
5065,
5071,
5067,
5070,
5072,
5069,
5159,
5160,
-1,
-1,
5152,
5153,
5144,
5145,
5150,
5151,
5147,
5148,
5155,
5154,
-1,
-1,
5170,
5168,
5167,
5169,
7395,
7390,
7389,
7384,
7383,
7380,
7378,
7377,
7374,
7373,
7375,
7381,
7393,
7387,
7386,
7396,
7625,
7392,
7391,
7394,
7497,
7496,
7498,
7552,
7551,
7550,
7469,
7530,
-1,
-1,
-1,
-1,
17057,
17088,
17055,
17086,
17056,
17087,
17075,
17106,
17052,
17083,
17065,
17096,
17066,
17097,
17069,
17100,
17050,
17081,
17077,
17108,
17059,
17090,
17060,
17091,
17051,
17082,
17078,
17109,
17062,
17093,
17063,
17094,
17076,
17107,
17072,
17103,
17067,
17098,
17070,
17101,
17073,
17104,
17068,
17099,
17074,
17105,
17071,
17102,
17139,
17116,
17121,
17118,
17117,
17124,
17123,
17138,
17122,
17119,
17120,
17113,
17112,
17114,
17115,
17136,
17135,
17133,
17134,
]

_charnames_43968 = [
7644,
7668,
7649,
7647,
7640,
7633,
7671,
7636,
7646,
7631,
7638,
7666,
7665,
7670,
7667,
7654,
7642,
7672,
7657,
7653,
7669,
7664,
7652,
7660,
7658,
7661,
7663,
7645,
7650,
7648,
7641,
7634,
7637,
7632,
7655,
7692,
7694,
7696,
7689,
7691,
7690,
7695,
7693,
7697,
7673,
7698,
-1,
-1,
7684,
7685,
7676,
7677,
7682,
7683,
7679,
7680,
7687,
7686,
]

_charnames_55216 = [
20066,
20070,
20012,
20013,
20016,
20091,
20095,
20002,
20004,
20056,
20053,
20051,
20055,
20036,
20035,
20038,
20037,
20042,
20040,
20039,
20046,
20082,
20078,
-1,
-1,
-1,
-1,
19963,
19961,
19855,
19856,
19951,
19944,
19945,
19947,
19948,
19949,
19845,
19826,
19858,
19833,
19816,
19818,
19837,
19836,
19920,
19938,
19928,
19861,
19932,
19935,
19892,
19888,
19894,
19859,
19886,
19890,
19891,
19880,
19875,
19854,
19853,
19872,
19877,
19878,
19869,
19881,
19903,
19904,
19972,
19973,
19991,
19990,
19864,
19899,
19898,
]

_charnames_63744 = [
856,
855,
854,
853,
852,
851,
850,
849,
848,
847,
846,
845,
844,
843,
842,
841,
839,
838,
837,
836,
835,
834,
833,
832,
831,
830,
829,
828,
827,
826,
825,
824,
822,
821,
820,
819,
818,
817,
816,
815,
814,
813,
812,
811,
810,
809,
808,
807,
805,
804,
803,
802,
801,
800,
799,
798,
797,
796,
795,
794,
793,
792,
791,
790,
788,
787,
786,
785,
784,
783,
782,
781,
780,
779,
778,
777,
776,
775,
774,
773,
771,
770,
769,
768,
767,
766,
765,
764,
763,
762,
761,
760,
759,
758,
757,
756,
754,
753,
752,
751,
750,
749,
748,
747,
746,
745,
744,
743,
742,
741,
740,
739,
737,
736,
735,
734,
733,
732,
731,
730,
729,
728,
727,
726,
725,
724,
723,
722,
720,
719,
718,
717,
716,
715,
714,
713,
712,
711,
710,
709,
708,
707,
706,
705,
703,
702,
701,
700,
699,
698,
697,
696,
695,
694,
693,
692,
691,
690,
689,
688,
686,
685,
684,
683,
682,
681,
680,
679,
678,
677,
676,
675,
674,
673,
672,
671,
669,
668,
667,
666,
665,
664,
663,
662,
661,
660,
659,
658,
657,
656,
655,
654,
652,
651,
650,
649,
648,
647,
646,
645,
644,
643,
642,
641,
640,
639,
638,
637,
635,
634,
633,
632,
631,
630,
629,
628,
627,
626,
625,
624,
623,
622,
621,
620,
618,
617,
616,
615,
614,
613,
612,
611,
610,
609,
608,
607,
606,
605,
604,
603,
601,
600,
599,
598,
597,
596,
595,
594,
593,
592,
591,
590,
589,
588,
587,
586,
1044,
1043,
1042,
1041,
1040,
1039,
1038,
1037,
1036,
1035,
1034,
1033,
1032,
1031,
1030,
1029,
1027,
1026,
1025,
1024,
1023,
1022,
1021,
1020,
1019,
1018,
1017,
1016,
1015,
1014,
1013,
1012,
1074,
1073,
1072,
1071,
1070,
1069,
1068,
1067,
1066,
1065,
1064,
1063,
1062,
1061,
-1,
-1,
1010,
1009,
1008,
1007,
1006,
1005,
1004,
1003,
1002,
1001,
1000,
999,
998,
997,
996,
995,
993,
992,
991,
990,
989,
988,
987,
986,
985,
984,
983,
982,
981,
980,
979,
978,
976,
975,
974,
973,
972,
971,
970,
969,
968,
967,
966,
965,
964,
963,
962,
961,
1059,
1058,
1057,
1056,
1055,
1054,
1053,
1052,
1051,
1050,
1049,
1048,
1047,
1046,
-1,
-1,
959,
958,
957,
956,
955,
954,
953,
952,
951,
950,
949,
948,
947,
946,
945,
944,
942,
941,
940,
939,
938,
937,
936,
935,
934,
933,
932,
931,
930,
929,
928,
927,
925,
924,
923,
922,
921,
920,
919,
918,
917,
916,
915,
914,
913,
912,
911,
910,
908,
907,
906,
905,
904,
903,
902,
901,
900,
899,
898,
897,
896,
895,
894,
893,
891,
890,
889,
888,
887,
886,
885,
884,
883,
882,
881,
880,
879,
878,
877,
876,
874,
873,
872,
871,
870,
869,
868,
867,
866,
865,
864,
863,
862,
861,
860,
859,
1085,
1084,
1083,
1082,
1081,
1080,
1079,
1078,
1077,
1076,
]

_charnames_64256 = [
8467,
8471,
8470,
8469,
8468,
8474,
8472,
]

_charnames_64275 = [
13626,
13628,
13627,
13629,
13625,
-1,
-1,
-1,
-1,
-1,
20647,
20760,
20689,
20636,
20606,
20605,
20603,
20602,
20601,
20604,
20600,
20599,
20635,
20616,
20615,
20613,
20612,
20632,
20631,
20633,
20667,
20681,
20683,
20663,
20652,
20669,
-1,
20642,
20648,
20623,
20660,
20679,
-1,
20677,
-1,
20675,
20618,
-1,
20621,
20656,
-1,
20640,
20673,
20671,
20610,
20644,
20651,
20666,
20659,
20655,
20691,
13000,
13001,
13244,
13247,
13245,
13246,
13335,
13338,
13336,
13337,
13237,
13240,
13238,
13239,
12832,
12835,
12833,
12834,
12809,
12812,
12810,
12811,
12838,
12841,
12839,
12840,
13369,
13372,
13370,
13371,
13329,
13332,
13330,
13331,
12962,
12965,
12963,
12964,
13106,
13109,
13107,
13108,
12823,
12827,
12824,
12826,
12817,
12820,
12818,
12819,
12957,
12958,
12948,
12949,
12968,
12969,
12953,
12954,
13386,
13387,
13214,
13215,
13035,
13038,
13036,
13037,
13291,
13294,
13292,
13293,
13306,
13309,
13307,
13308,
13093,
13096,
13094,
13095,
13082,
13083,
13208,
13211,
13209,
13210,
12883,
12884,
12868,
12872,
12869,
12871,
12876,
12879,
12877,
12878,
13173,
13174,
13168,
13169,
]

_charnames_64467 = [
13099,
13102,
13100,
13101,
13392,
13393,
13426,
13427,
13182,
13183,
13391,
13374,
13375,
13059,
13060,
13055,
13056,
13420,
13423,
13421,
13422,
13396,
13395,
12267,
12268,
12270,
12271,
12298,
12299,
12301,
12302,
12304,
12305,
12274,
12275,
12294,
12296,
12295,
12781,
12783,
12782,
13262,
13265,
13263,
13264,
12307,
12290,
12281,
12265,
12277,
12574,
12553,
12567,
12561,
12577,
12571,
12206,
12187,
12198,
12175,
12212,
12209,
12234,
12221,
12229,
12226,
12700,
12693,
12630,
12626,
12457,
12462,
12454,
12118,
12098,
12110,
12092,
12139,
12146,
12678,
12666,
12659,
12675,
12253,
12246,
12776,
12600,
12593,
12769,
12763,
12726,
12729,
12715,
12719,
12732,
12723,
12750,
12744,
12753,
12747,
12435,
12444,
12447,
12441,
12427,
12421,
12433,
12438,
12388,
12399,
12407,
12374,
12363,
12410,
12519,
12535,
12527,
12539,
12544,
12546,
12475,
12484,
12502,
12494,
12505,
12499,
12648,
12645,
12652,
12650,
12334,
12315,
12341,
12328,
12344,
12338,
12236,
12785,
12614,
12076,
12071,
12079,
12075,
12070,
12080,
12310,
12309,
12284,
12311,
12266,
12278,
12580,
12579,
12564,
12581,
12578,
12572,
12215,
12214,
12178,
12216,
12213,
12210,
12232,
12231,
12224,
12233,
12230,
12227,
12733,
12724,
12754,
12748,
12436,
12430,
12424,
12434,
12439,
12377,
12364,
12411,
12545,
12542,
12508,
12507,
12497,
12509,
12506,
12500,
12615,
12347,
12346,
12331,
12348,
12345,
12339,
12308,
12291,
12312,
12282,
12288,
12575,
12554,
12568,
12562,
12558,
12207,
12188,
12199,
12176,
12191,
12222,
12701,
12694,
12631,
12627,
12458,
12455,
12119,
12099,
12111,
12093,
12140,
12157,
12147,
12679,
12667,
12660,
12676,
12254,
12777,
12601,
12594,
12770,
12764,
12727,
12730,
12716,
12720,
12751,
12745,
12445,
12448,
12442,
12428,
12422,
12389,
12400,
12408,
12375,
12401,
12520,
12536,
12528,
12540,
12476,
12485,
12503,
12495,
12488,
12649,
12646,
12651,
12335,
12316,
12342,
12329,
12320,
12283,
12287,
12563,
12557,
12177,
12190,
12223,
12235,
12094,
12103,
12042,
12029,
12429,
12423,
12376,
12496,
12487,
12330,
12319,
12078,
12074,
12069,
12256,
12250,
12606,
12603,
12772,
12766,
12128,
12122,
12064,
12058,
12637,
12634,
12706,
12703,
12460,
12451,
12155,
12149,
12681,
12669,
12046,
12024,
12053,
12040,
12061,
12125,
12152,
12672,
12257,
12251,
12607,
12604,
12773,
12767,
12129,
12123,
12065,
12059,
12638,
12635,
12707,
12704,
12461,
12452,
12156,
12150,
12682,
12670,
12050,
12027,
12056,
12043,
12062,
12126,
12153,
12673,
12047,
12025,
12054,
12041,
12104,
12030,
12247,
12120,
12101,
12112,
12049,
12026,
12055,
12248,
12778,
12612,
12611,
25290,
25289,
]

_charnames_64848 = [
12203,
12184,
12183,
12185,
12195,
12171,
12172,
12170,
12689,
12688,
12623,
12624,
12100,
12115,
12116,
12089,
12088,
12090,
12086,
12085,
12136,
12135,
12144,
12021,
12020,
12048,
12038,
12037,
12035,
12034,
12664,
12657,
12656,
12242,
12241,
12244,
12243,
12598,
12589,
12588,
12591,
12760,
12759,
12761,
12713,
12712,
12740,
12742,
12395,
12396,
12397,
12384,
12385,
12405,
12404,
12371,
12370,
12533,
12532,
12531,
12517,
12515,
12525,
12524,
-1,
-1,
12516,
12643,
12642,
12481,
12482,
12468,
12467,
12473,
12491,
12492,
12325,
12324,
12569,
12202,
12204,
12194,
12196,
12169,
12173,
12690,
12698,
12691,
12108,
12137,
12022,
12663,
12386,
12372,
12317,
12336,
12326,
12541,
12741,
12480,
12739,
12394,
12590,
12419,
12470,
12523,
12381,
12418,
12382,
12471,
12697,
12632,
12514,
12721,
12555,
12417,
12597,
12143,
12107,
12472,
]

_charnames_65008 = [
12161,
12755,
12616,
12618,
12547,
12164,
12786,
12617,
12787,
12162,
12163,
12708,
25648,
12582,
-1,
-1,
23731,
23842,
23976,
23965,
23954,
23943,
23932,
23921,
23910,
23831,
23820,
23809,
23798,
23787,
23776,
23765,
26384,
26382,
26381,
26385,
26388,
26377,
26389,
26351,
26365,
26390,
-1,
-1,
-1,
-1,
-1,
-1,
3562,
3561,
3574,
3573,
3703,
3702,
3477,
]

_charnames_65072 = [
26387,
26379,
26378,
26362,
26386,
26358,
26372,
26354,
26368,
26356,
26370,
26360,
26374,
26359,
26373,
26361,
26375,
26355,
26369,
26352,
26366,
19750,
27589,
26357,
26371,
24859,
5204,
27706,
24287,
24860,
5205,
27704,
19664,
19685,
19688,
-1,
19682,
19665,
19683,
19653,
19655,
19669,
19645,
19670,
19646,
19668,
19644,
19684,
19680,
19679,
19676,
19686,
19671,
19687,
19654,
-1,
19647,
19689,
19677,
19663,
-1,
-1,
-1,
-1,
13495,
13512,
13503,
13513,
13518,
-1,
13493,
13492,
13506,
13505,
13521,
13520,
13485,
13484,
13480,
13479,
12915,
12990,
12991,
12986,
12987,
13315,
13316,
12982,
12983,
13155,
13158,
13156,
13157,
13006,
13007,
13230,
13233,
13231,
13232,
12795,
12797,
12803,
12805,
12804,
12798,
12846,
12849,
12847,
12848,
13380,
13383,
13381,
13382,
12910,
12913,
12911,
12912,
13064,
13067,
13065,
13066,
12936,
12937,
12852,
12853,
13203,
13204,
13363,
13364,
13124,
13127,
13125,
13126,
13141,
13145,
13142,
13144,
13134,
13137,
13135,
13136,
12941,
12945,
12942,
12944,
12857,
12861,
12858,
12860,
13357,
13360,
13358,
13359,
13018,
13021,
13019,
13020,
13298,
13302,
13299,
13301,
13278,
13281,
13279,
13280,
13403,
13406,
13404,
13405,
13048,
13051,
13049,
13050,
13349,
13352,
13350,
13351,
13413,
13416,
13414,
13415,
13085,
13088,
13086,
13087,
12887,
12890,
12888,
12889,
13323,
13324,
13004,
13005,
13176,
13179,
13177,
13178,
12360,
12361,
12357,
12358,
12354,
12355,
12365,
12366,
-1,
-1,
27906,
-1,
27320,
27311,
27314,
27283,
27302,
27306,
27305,
27264,
27288,
27304,
27301,
27295,
27327,
27328,
27308,
27279,
27280,
27271,
27272,
27277,
27278,
27274,
27275,
27282,
27281,
27296,
27309,
27266,
27321,
27317,
27312,
27294,
27259,
27258,
27257,
27256,
27255,
27254,
27253,
27252,
27251,
27250,
27249,
27248,
27247,
27246,
27245,
27244,
27243,
27242,
27241,
27240,
27239,
27238,
27237,
27236,
27235,
27234,
27263,
27290,
27287,
27297,
27267,
27318,
27232,
27231,
27230,
27229,
27228,
27227,
27226,
27225,
27224,
27223,
27222,
27221,
27220,
27219,
27218,
27217,
27216,
27215,
27214,
27213,
27212,
27211,
27210,
27209,
27208,
27207,
27265,
27324,
27289,
27325,
27262,
27286,
20583,
20581,
20578,
20584,
20509,
20500,
20453,
20451,
20448,
20452,
20450,
20447,
20445,
20446,
20449,
20510,
20506,
20504,
20502,
20505,
20503,
20488,
20486,
20484,
20487,
20485,
20458,
20456,
20454,
20457,
20455,
20470,
20468,
20466,
20469,
20467,
20464,
20462,
20460,
20463,
20461,
20494,
20492,
20490,
20493,
20491,
20482,
20480,
20478,
20481,
20479,
20498,
20496,
20497,
20476,
20474,
20472,
20475,
20473,
20501,
20459,
20507,
20508,
20575,
20554,
20536,
20555,
20549,
20552,
20551,
20561,
20533,
20513,
20521,
20520,
20516,
20519,
20518,
20517,
20522,
20573,
20546,
20535,
20547,
20538,
20534,
20566,
20568,
20537,
20569,
20556,
20562,
20548,
20574,
-1,
-1,
-1,
20570,
20571,
20526,
20527,
20559,
20557,
-1,
-1,
20525,
20524,
20563,
20542,
20543,
20564,
-1,
-1,
20529,
20572,
20541,
20540,
20544,
20528,
-1,
-1,
20558,
20530,
20565,
-1,
-1,
-1,
27298,
27300,
27315,
27326,
27329,
27322,
27323,
-1,
20587,
20580,
20586,
20577,
20588,
20589,
20585,
]

_charnames_65529 = [
27107,
27106,
27105,
25427,
25895,
-1,
-1,
9383,
9411,
9373,
9398,
9426,
9390,
9403,
9384,
9422,
9369,
9364,
9402,
-1,
9413,
9396,
9353,
9404,
9394,
9360,
9430,
9431,
9423,
9357,
9421,
9378,
9385,
9377,
9417,
9368,
9365,
9388,
9358,
9410,
9425,
9370,
9420,
9352,
9379,
9415,
-1,
9399,
9374,
9367,
9389,
9375,
9416,
9382,
9407,
9424,
9363,
9362,
9387,
9412,
9386,
9392,
9366,
9355,
9408,
9406,
-1,
9419,
9356,
-1,
9380,
9376,
9405,
9429,
9359,
9434,
9401,
9372,
9397,
9354,
9414,
9393,
9395,
9428,
9433,
-1,
-1,
9449,
9448,
9453,
9452,
9446,
9445,
9451,
9443,
9442,
9450,
9440,
9439,
9438,
9437,
]

_charnames_65664 = [
9227,
9226,
9225,
9212,
9211,
9210,
9224,
9223,
9221,
9220,
9218,
9217,
9215,
9214,
9277,
9276,
9275,
9274,
9273,
9461,
9460,
9281,
9280,
9279,
9458,
9457,
9271,
9270,
9269,
9268,
9267,
9257,
9256,
9255,
9254,
9253,
9462,
9252,
9251,
9250,
9238,
9237,
9236,
9235,
9234,
9233,
9232,
9231,
9230,
9229,
9248,
9247,
9246,
9245,
9244,
9243,
9242,
9241,
9240,
9265,
9264,
9263,
9262,
9261,
9260,
9259,
9284,
9283,
9314,
9313,
9311,
9310,
9309,
9308,
9307,
9306,
9304,
9303,
9302,
9301,
9300,
9299,
9463,
9298,
9297,
9295,
9294,
9293,
9292,
9291,
9290,
9289,
9288,
9287,
9348,
9338,
9337,
9336,
9335,
9334,
9333,
9332,
9331,
9330,
9329,
9327,
9326,
9325,
9324,
9323,
9322,
9321,
9320,
9319,
9318,
9345,
9344,
9343,
9342,
9341,
9340,
9346,
9347,
-1,
-1,
-1,
-1,
-1,
13884,
13885,
13891,
-1,
-1,
-1,
-1,
13871,
13816,
13823,
13846,
13853,
13832,
13838,
13865,
13859,
13829,
13820,
13827,
13850,
13857,
13833,
13839,
13866,
13860,
13874,
13819,
13826,
13849,
13856,
13837,
13843,
13870,
13864,
13873,
13818,
13825,
13848,
13855,
13836,
13842,
13869,
13863,
13830,
13821,
13828,
13851,
13858,
13834,
13840,
13867,
13861,
-1,
-1,
-1,
13882,
13879,
13881,
13880,
13878,
13890,
13889,
13888,
13887,
21536,
21532,
21537,
21509,
21520,
21515,
21512,
21523,
21514,
21541,
21525,
21530,
21517,
21534,
21513,
21519,
21542,
21526,
21531,
21518,
21535,
21540,
21524,
21543,
21574,
21552,
21572,
21576,
21550,
21580,
21577,
21563,
21567,
21568,
21571,
21584,
21551,
21549,
21565,
21566,
21573,
21560,
21555,
21548,
21578,
21564,
21559,
21581,
21583,
21554,
21558,
21585,
21582,
21718,
21719,
21702,
21698,
21740,
21706,
21694,
21722,
21703,
21699,
21745,
21746,
21743,
21727,
21681,
21721,
21748,
21587,
21588,
21751,
21704,
21747,
-1,
-1,
-1,
-1,
-1,
25938,
25946,
25940,
25937,
25944,
25941,
25945,
25947,
25939,
25943,
25949,
25948,
]

_charnames_66000 = [
26271,
26269,
26276,
26249,
26251,
26282,
26280,
26295,
26275,
26303,
26262,
26255,
26250,
26289,
26288,
26259,
26292,
26263,
26248,
26298,
26243,
26258,
26245,
26265,
26254,
26278,
26279,
26266,
26247,
26286,
26302,
26297,
26274,
26264,
26270,
26299,
26272,
26285,
26291,
26300,
26301,
26294,
26256,
26257,
26283,
26244,
]

_charnames_66176 = [
10025,
10021,
10023,
10024,
10039,
10040,
10037,
10029,
10027,
10014,
10036,
10019,
10033,
10035,
10017,
10015,
10018,
10016,
10030,
10034,
10020,
10032,
10031,
10012,
10013,
10026,
10022,
10038,
10028,
-1,
-1,
-1,
3390,
3376,
3385,
3370,
3348,
3373,
3371,
3391,
3393,
3395,
3358,
3394,
3386,
3367,
3355,
3356,
3352,
3389,
3346,
3364,
3392,
3363,
3369,
3375,
3357,
3379,
3383,
3349,
3377,
3378,
3366,
3347,
3381,
3382,
3353,
3354,
3365,
3380,
3388,
3368,
3351,
3374,
3359,
3362,
3361,
3360,
3372,
3384,
3350,
]

_charnames_66304 = [
25055,
25054,
25035,
25052,
25022,
25048,
25047,
25051,
25040,
25045,
25036,
25029,
25028,
25027,
25024,
25050,
25044,
25049,
25033,
25025,
25023,
25041,
25037,
25030,
25043,
25034,
25031,
25026,
25053,
25046,
25038,
-1,
25061,
25058,
25060,
25059,
]

_charnames_66352 = [
22336,
22352,
22348,
22351,
22335,
22341,
22329,
22333,
22326,
22350,
22346,
22345,
22344,
22324,
22347,
22338,
22342,
22322,
22340,
22339,
22327,
22337,
22349,
22330,
22332,
22343,
22323,
]

_charnames_66432 = [
27520,
27532,
27515,
27509,
27518,
27511,
27523,
27507,
27512,
27504,
27522,
27510,
27500,
27530,
27529,
27517,
27528,
27506,
27497,
27521,
27527,
27498,
27526,
27525,
27503,
27514,
27502,
27531,
27524,
27499,
-1,
27533,
24961,
25007,
25004,
24995,
24994,
25001,
25000,
24983,
25010,
24998,
24997,
24968,
24966,
24956,
24960,
24959,
24967,
25005,
24978,
25009,
24992,
24991,
24976,
24975,
24974,
25003,
24986,
24985,
24989,
24988,
25006,
24972,
25002,
24971,
24970,
25008,
-1,
-1,
-1,
-1,
24962,
24964,
24963,
24982,
24957,
24958,
24979,
24980,
25019,
25017,
25014,
25016,
25015,
25018,
]

_charnames_66560 = [
24661,
24662,
24659,
24660,
24657,
24658,
24654,
24655,
24652,
24653,
24650,
24651,
24683,
24670,
24673,
24672,
24678,
24675,
24682,
24668,
24680,
24681,
24677,
24676,
24679,
24648,
24674,
24644,
24667,
24639,
24665,
24640,
24664,
24645,
24647,
24646,
24641,
24642,
24671,
24643,
24614,
24615,
24612,
24613,
24610,
24611,
24607,
24608,
24605,
24606,
24603,
24604,
24636,
24623,
24626,
24625,
24631,
24628,
24635,
24621,
24633,
24634,
24630,
24629,
24632,
24601,
24627,
24597,
24620,
24592,
24618,
24593,
24617,
24598,
24600,
24599,
24594,
24595,
24624,
24596,
19586,
19562,
19589,
19592,
19560,
19575,
19574,
19594,
19569,
19580,
19595,
19593,
19591,
19583,
19561,
19582,
19578,
19590,
19572,
19581,
19588,
19577,
19564,
19557,
19540,
19544,
19549,
19571,
19546,
19542,
19585,
19587,
19554,
19543,
19565,
19584,
19551,
19548,
19550,
19539,
19538,
19547,
19541,
19556,
19537,
19555,
19566,
19568,
25296,
25327,
25315,
25321,
25312,
25304,
25310,
25316,
25300,
25299,
25309,
25326,
25324,
25325,
25317,
25305,
25320,
25319,
25318,
25313,
25323,
25311,
25295,
25306,
25322,
25301,
25314,
25297,
25307,
25302,
-1,
-1,
25338,
25339,
25330,
25331,
25336,
25337,
25333,
25334,
25341,
25340,
]

_charnames_67584 = [
4572,
4571,
4570,
4569,
4568,
4567,
-1,
-1,
4566,
-1,
4553,
4552,
4551,
4550,
4549,
4547,
4546,
4545,
4544,
4543,
4541,
4540,
4539,
4538,
4537,
4535,
4534,
4533,
4532,
4531,
4529,
4528,
4527,
4526,
4525,
4523,
4522,
4521,
4520,
4519,
4517,
4516,
4515,
4514,
4513,
4511,
4510,
4509,
4508,
4507,
4558,
4557,
4556,
4555,
-1,
4564,
4563,
-1,
-1,
-1,
4561,
-1,
-1,
4560,
27170,
27183,
27181,
27182,
27166,
27173,
27171,
27167,
27164,
27172,
27180,
27179,
27178,
27177,
27160,
27169,
27176,
27161,
27175,
27174,
27162,
27165,
-1,
27196,
27192,
27187,
27191,
27189,
27188,
27195,
27194,
27190,
]

_charnames_67840 = [
26316,
26330,
26328,
26329,
26313,
26320,
26318,
26314,
26311,
26319,
26327,
26326,
26325,
26324,
26308,
26317,
26323,
26309,
26322,
26321,
26307,
26312,
26338,
26337,
26335,
26339,
26334,
26336,
-1,
-1,
-1,
26340,
10053,
10068,
10064,
10066,
10051,
10056,
10063,
10055,
10062,
10049,
10061,
10047,
10060,
10058,
10046,
10043,
10057,
10065,
10059,
10045,
10044,
10054,
10052,
10050,
10048,
10067,
-1,
-1,
-1,
-1,
-1,
10069,
]

_charnames_68096 = [
23330,
23351,
23349,
23348,
-1,
23352,
23350,
-1,
-1,
-1,
-1,
-1,
23353,
23357,
23362,
23359,
23309,
23308,
23315,
23314,
-1,
23318,
23317,
23328,
-1,
23303,
23289,
23288,
23295,
23294,
23304,
23291,
23290,
23297,
23296,
23305,
23312,
23311,
23321,
23320,
23326,
23323,
23325,
23327,
23324,
23300,
23299,
23301,
23322,
23329,
23307,
23287,
-1,
-1,
-1,
-1,
23361,
23360,
23358,
-1,
-1,
-1,
-1,
23354,
23374,
23372,
23373,
23375,
23366,
23365,
23369,
23368,
]

_charnames_68176 = [
23335,
23343,
23342,
23341,
23344,
23338,
23336,
23334,
23339,
]

_charnames_68192 = [
25084,
25099,
25085,
25098,
25096,
25094,
25075,
25095,
25101,
25069,
25072,
25083,
25097,
25082,
25074,
25073,
25100,
25091,
25090,
25079,
25087,
25080,
25088,
25068,
25092,
25078,
25093,
25067,
25066,
25104,
25105,
25106,
]

_charnames_68352 = [
13894,
13895,
13900,
13896,
13901,
13897,
13898,
13899,
13943,
13944,
13936,
13937,
13938,
13939,
13934,
13935,
13956,
13919,
13917,
13918,
13927,
13926,
13925,
13959,
13957,
13923,
13922,
13947,
13946,
13921,
13953,
13958,
13950,
13949,
13906,
13904,
13905,
13909,
13907,
13908,
13954,
13941,
13932,
13933,
13951,
13952,
13955,
13915,
13930,
13913,
13929,
13912,
13914,
13942,
-1,
-1,
-1,
13960,
17809,
19673,
9189,
9193,
9188,
9192,
27028,
27041,
27039,
27040,
27024,
27031,
27029,
27025,
27022,
27030,
27038,
27037,
27036,
27035,
27018,
27027,
27034,
27019,
27033,
27032,
27020,
27023,
-1,
-1,
27049,
27045,
27047,
27053,
27048,
27046,
27052,
27051,
27077,
27076,
27074,
27075,
27064,
27068,
27066,
27065,
27062,
27067,
27073,
27072,
27071,
27070,
27058,
27069,
27059,
27060,
27063,
-1,
-1,
-1,
-1,
-1,
27085,
27081,
27083,
27089,
27084,
27082,
27088,
27087,
]

_charnames_68608 = [
24874,
24920,
24921,
24915,
24951,
24939,
24909,
24910,
24948,
24896,
24938,
24885,
24928,
24894,
24936,
24883,
24927,
24895,
24937,
24884,
24903,
24944,
24888,
24929,
24876,
24924,
24882,
24926,
24911,
24949,
24893,
24935,
24881,
24907,
24906,
24892,
24880,
24922,
24900,
24942,
24902,
24943,
24899,
24941,
24934,
24901,
24923,
24905,
24914,
24917,
24908,
24946,
24891,
24933,
24916,
24952,
24913,
24950,
24890,
24932,
24879,
24886,
24878,
24887,
24931,
24904,
24945,
24889,
24930,
24877,
24925,
24912,
24918,
]

_charnames_69216 = [
25786,
25778,
25779,
25784,
25785,
25781,
25782,
25788,
25787,
25754,
25750,
25753,
25765,
25768,
25757,
25760,
25773,
25770,
25775,
25749,
25752,
25764,
25767,
25758,
25761,
25774,
25771,
25793,
25792,
25791,
25794,
]

_charnames_69760 = [
22994,
22995,
22991,
22937,
22940,
22959,
22960,
22945,
22946,
22976,
22939,
22972,
22938,
22955,
22954,
22963,
22962,
22935,
22966,
22965,
22958,
22957,
22933,
22929,
22928,
22923,
22922,
22921,
22948,
22934,
22931,
22930,
22925,
22924,
22936,
22952,
22951,
22969,
22968,
22973,
22970,
22949,
22974,
22971,
22943,
22942,
22944,
22975,
22981,
22984,
22985,
22982,
22983,
22987,
22980,
22986,
22979,
22992,
22993,
23004,
23003,
23002,
22996,
22999,
23001,
23000,
]

_charnames_73728 = [
1910,
1967,
1966,
1965,
1964,
1963,
1962,
1961,
1960,
1988,
1911,
1925,
1924,
1919,
1918,
1923,
1916,
1915,
1922,
1921,
1920,
1926,
1927,
1933,
1932,
1931,
1930,
1929,
1987,
1980,
1983,
1982,
1934,
1944,
1943,
1942,
1941,
1938,
1937,
1940,
1939,
1946,
1945,
1984,
1985,
1968,
1974,
1973,
1972,
1971,
1975,
1986,
1977,
1978,
1979,
1958,
1948,
1954,
1955,
1953,
1951,
1952,
1957,
1956,
2334,
2342,
2341,
2340,
2335,
2337,
2336,
2338,
2339,
2353,
2357,
2356,
2355,
2343,
2347,
2346,
2348,
2351,
2352,
2349,
2350,
2064,
2065,
2088,
2087,
2085,
2084,
2070,
2071,
2068,
2069,
2072,
2094,
2081,
2082,
2093,
2077,
2074,
2076,
2075,
2092,
2091,
2090,
2089,
2080,
2079,
2099,
2095,
2098,
2097,
2117,
2124,
2118,
2120,
2119,
2121,
2122,
2123,
2100,
2111,
2112,
2110,
2106,
2108,
2107,
2113,
2114,
2116,
2101,
2102,
2103,
2104,
2105,
2115,
2125,
2172,
2173,
2159,
2167,
2166,
2165,
2163,
2162,
2164,
2177,
2176,
2175,
2150,
2153,
2154,
2155,
2158,
2157,
2156,
2170,
2169,
2174,
2126,
2133,
2134,
2135,
2136,
2149,
2146,
2147,
2144,
2145,
2148,
2138,
2139,
2140,
2129,
2130,
2132,
2131,
2143,
2142,
1303,
1395,
1304,
1311,
1310,
1309,
1315,
1314,
1312,
1313,
1362,
1361,
1358,
1359,
1356,
1353,
1354,
1355,
1350,
1351,
1348,
1349,
1332,
1331,
1326,
1327,
1328,
1329,
1344,
1342,
1343,
1346,
1345,
1373,
1372,
1338,
1337,
1334,
1335,
1339,
1376,
1370,
1369,
1366,
1367,
1375,
1323,
1322,
1318,
1319,
1320,
1324,
1374,
1363,
1364,
1365,
1377,
1391,
1392,
1389,
1390,
1384,
1386,
1385,
1394,
1378,
1379,
1381,
1382,
1383,
1387,
1388,
1393,
1451,
1452,
1396,
1424,
1423,
1425,
1417,
1419,
1420,
1426,
1405,
1406,
1398,
1404,
1403,
1402,
1401,
1400,
1416,
1408,
1415,
1413,
1412,
1414,
1427,
1450,
1428,
1431,
1432,
1434,
1433,
1435,
1441,
1445,
1444,
1446,
1449,
1447,
1448,
1436,
1440,
1439,
1438,
2301,
2303,
2304,
2305,
2281,
2283,
2284,
2291,
2290,
2289,
2288,
2287,
2286,
2285,
2292,
2293,
2299,
2298,
2297,
2296,
2295,
2300,
2253,
2279,
2278,
2271,
2274,
2273,
2261,
2262,
2267,
2264,
2265,
2266,
2268,
2270,
2269,
2254,
2256,
2259,
2258,
2257,
2260,
2277,
2276,
2275,
1591,
1635,
1636,
1637,
1638,
1633,
1632,
1631,
1634,
1654,
1653,
1594,
1598,
1597,
1595,
1596,
1599,
1603,
1601,
1602,
1604,
1605,
1651,
1650,
1642,
1640,
1641,
1648,
1647,
1617,
1621,
1620,
1619,
1622,
1623,
1645,
1644,
1658,
1657,
1612,
1613,
1611,
1610,
1609,
1608,
1615,
1614,
1656,
1624,
1628,
1627,
1626,
1625,
1655,
1678,
1679,
1680,
1664,
1663,
1662,
1660,
1661,
1676,
1677,
1669,
1671,
1672,
1675,
1674,
1665,
1668,
1667,
1706,
1693,
1702,
1700,
1701,
1704,
1703,
1698,
1697,
1695,
1696,
1681,
1692,
1691,
1686,
1687,
1690,
1684,
1685,
1689,
1682,
1683,
1688,
1705,
1454,
1456,
1459,
1463,
1462,
1461,
1466,
1465,
1464,
1521,
1520,
1524,
1523,
1504,
1505,
1502,
1503,
1516,
1517,
1518,
1500,
1496,
1499,
1498,
1488,
1489,
1487,
1485,
1486,
1494,
1493,
1491,
1492,
1512,
1513,
1514,
1522,
1481,
1480,
1479,
1476,
1477,
1482,
1509,
1508,
1510,
1467,
1470,
1469,
1473,
1472,
1471,
1525,
1526,
1528,
1529,
1530,
1531,
1537,
1535,
1536,
1532,
1533,
1534,
1586,
1589,
1588,
1587,
1538,
1585,
1539,
1566,
1565,
1558,
1559,
1564,
1563,
1562,
1547,
1545,
1546,
1548,
1557,
1556,
1561,
1554,
1553,
1551,
1550,
1560,
1567,
1572,
1571,
1569,
1570,
1584,
1573,
1576,
1577,
1578,
1583,
1582,
1579,
1580,
1581,
2240,
2244,
2245,
2248,
2247,
2246,
2241,
2242,
2251,
2252,
2249,
2250,
2218,
2239,
2235,
2236,
2238,
2237,
2219,
2224,
2223,
2222,
2225,
2226,
2227,
2228,
2231,
2232,
2233,
2234,
2046,
2056,
2047,
2051,
2049,
2050,
2052,
2055,
2053,
2054,
2057,
2061,
2060,
2062,
2019,
2045,
2044,
2039,
2042,
2041,
2020,
2030,
2028,
2029,
2038,
2037,
2036,
2035,
2022,
2026,
2024,
2025,
2033,
2032,
2043,
1990,
2018,
1991,
2013,
2012,
2009,
2010,
2011,
2016,
2017,
2014,
2015,
1992,
2004,
2003,
2002,
2001,
2000,
1999,
1998,
1997,
1996,
1995,
2005,
2006,
2328,
2331,
2330,
2329,
2332,
2307,
2317,
2318,
2316,
2315,
2319,
2312,
2313,
2310,
2311,
2320,
2321,
2326,
2325,
2324,
2327,
2379,
2380,
2382,
2381,
1763,
1788,
1764,
1786,
1779,
1780,
1785,
1778,
1777,
1784,
1783,
1782,
1775,
1774,
1781,
1772,
1771,
1770,
1769,
1768,
1787,
1789,
1790,
1791,
1793,
1792,
1734,
1735,
1744,
1743,
1742,
1741,
1740,
1739,
1737,
1738,
1747,
1746,
1745,
1748,
1756,
1755,
1754,
1758,
1757,
1749,
1751,
1750,
1728,
1731,
1730,
1710,
1723,
1716,
1715,
1722,
1721,
1712,
1713,
1720,
1719,
1718,
1717,
1733,
1724,
1726,
1727,
1732,
1759,
1762,
1761,
1760,
1803,
1809,
1804,
1805,
1806,
1808,
1807,
1794,
1802,
1799,
1800,
1801,
1797,
1798,
1795,
1796,
2179,
2194,
2192,
2191,
2193,
2195,
2198,
2197,
2180,
2188,
2187,
2184,
2183,
2186,
2185,
2200,
2199,
2215,
2216,
2201,
2208,
2207,
2202,
2206,
2204,
2205,
2209,
2214,
2213,
2212,
2210,
2211,
1810,
1900,
1899,
1898,
1897,
1896,
1909,
1908,
1862,
1871,
1868,
1867,
1865,
1866,
1872,
1869,
1870,
1873,
1874,
1879,
1878,
1877,
1876,
1884,
1880,
1883,
1882,
1905,
1906,
1811,
1860,
1859,
1843,
1852,
1851,
1853,
1855,
1854,
1845,
1848,
1847,
1861,
1856,
1857,
1812,
1831,
1832,
1840,
1839,
1815,
1818,
1817,
1816,
1819,
1838,
1827,
1826,
1825,
1837,
1836,
1835,
1834,
1830,
1829,
1833,
1823,
1822,
1821,
1841,
1842,
1885,
1890,
1887,
1888,
1889,
1891,
1893,
1892,
1907,
1902,
1903,
1904,
2371,
2373,
2374,
2376,
2375,
2377,
2359,
2365,
2364,
2360,
2361,
2363,
2362,
2366,
2367,
2368,
2370,
2369,
]

_charnames_74752 = [
2455,
2439,
2401,
2418,
2471,
2469,
2521,
2510,
2441,
2404,
2421,
2477,
2468,
2520,
2509,
2403,
2420,
2474,
2465,
2517,
2506,
2488,
2451,
2438,
2400,
2417,
2476,
2467,
2519,
2508,
2487,
2450,
2437,
2399,
2416,
2448,
2427,
2428,
2397,
2409,
2475,
2466,
2518,
2507,
2495,
2447,
2425,
2426,
2396,
2408,
2480,
2479,
2493,
2453,
2430,
2431,
2394,
2414,
2435,
2434,
2386,
2390,
2389,
2388,
2473,
2464,
2463,
2462,
2515,
2516,
2502,
2504,
2503,
2505,
2456,
2440,
2402,
2419,
2472,
2494,
2454,
2432,
2392,
2393,
2412,
2413,
2512,
2513,
2490,
2457,
2485,
2445,
2410,
2484,
2444,
2491,
2496,
2498,
2499,
]

_charnames_77824 = [
10196,
10195,
10194,
10193,
10188,
10189,
10185,
10187,
10186,
10192,
10191,
10190,
10183,
10182,
10181,
10180,
10174,
10175,
10179,
10178,
10172,
10173,
10177,
10176,
10241,
10240,
10239,
10238,
10237,
10236,
10235,
10234,
10233,
10232,
10208,
10207,
10198,
10199,
10206,
10205,
10204,
10203,
10202,
10201,
10200,
10163,
10164,
10170,
10161,
10162,
10159,
10160,
10169,
10157,
10158,
10168,
10167,
10166,
10165,
10230,
10229,
10228,
10227,
10226,
10225,
10224,
10223,
10222,
10221,
10219,
10218,
10217,
10216,
10215,
10214,
10213,
10212,
10211,
10210,
10242,
11305,
11304,
11303,
11302,
11296,
11297,
11301,
11300,
11299,
11298,
11214,
11203,
11206,
11205,
11204,
11213,
11212,
11211,
11210,
11209,
11208,
11207,
11216,
11217,
11226,
11225,
11224,
11223,
11222,
11221,
11220,
11219,
11218,
11232,
11231,
11230,
11229,
11228,
10492,
10491,
10490,
10489,
10488,
10487,
10486,
10483,
10484,
10485,
10481,
10480,
10479,
10478,
10477,
10476,
10475,
10474,
10473,
10472,
10470,
10469,
10468,
10467,
10466,
10465,
10464,
10460,
10461,
10463,
10462,
10458,
10449,
10450,
10457,
10456,
10447,
10448,
10455,
10454,
10453,
10452,
10451,
10445,
10444,
10443,
10442,
10441,
10440,
10436,
10437,
10439,
10434,
10435,
10438,
10395,
10404,
10403,
10402,
10401,
10400,
10399,
10398,
10397,
10396,
10415,
10407,
10408,
10414,
10405,
10406,
10413,
10412,
10411,
10410,
10409,
10432,
10431,
10430,
10429,
10428,
10427,
10426,
10417,
10425,
10424,
10423,
10422,
10421,
10420,
10419,
10418,
11072,
11071,
11070,
11069,
11068,
11067,
11066,
11064,
11065,
11062,
11063,
11060,
11059,
11058,
11057,
11056,
11055,
11051,
11052,
11049,
11050,
11054,
11053,
11038,
11039,
11047,
11046,
11045,
11044,
11043,
11042,
11041,
11036,
11037,
11040,
11082,
11081,
11080,
11079,
11074,
11075,
11078,
11077,
11076,
10783,
10784,
10792,
10791,
10790,
10789,
10788,
10787,
10786,
10785,
10781,
10780,
10779,
10771,
10772,
10778,
10777,
10776,
10775,
10774,
10773,
10769,
10759,
10760,
10768,
10767,
10766,
10765,
10764,
10763,
10762,
10761,
10757,
10749,
10750,
10756,
10755,
10754,
10753,
10752,
10747,
10748,
10745,
10746,
10751,
10743,
10742,
10741,
10740,
10739,
10735,
10736,
10733,
10734,
10731,
10732,
10738,
10737,
10800,
10794,
10797,
10796,
10795,
10799,
10798,
10853,
10852,
10851,
10850,
10849,
10845,
10846,
10842,
10844,
10843,
10848,
10847,
10865,
10855,
10856,
10864,
10863,
10862,
10861,
10860,
10859,
10858,
10857,
10831,
10832,
10840,
10839,
10838,
10837,
10836,
10829,
10830,
10835,
10834,
10833,
10827,
10826,
10825,
10824,
10823,
10822,
10818,
10819,
10816,
10817,
10821,
10820,
10814,
10813,
10812,
10805,
10806,
10811,
10803,
10804,
10810,
10809,
10808,
10807,
10871,
10870,
10869,
10868,
10867,
11325,
11324,
11323,
11322,
11321,
11317,
11318,
11320,
11319,
11245,
11244,
11243,
11242,
11237,
11238,
11241,
11240,
11239,
11235,
11236,
11249,
11250,
11247,
11248,
11254,
11253,
11252,
11251,
11334,
11333,
11332,
11331,
11330,
11329,
11328,
11327,
11294,
11287,
11288,
11293,
11292,
11291,
11285,
11286,
11290,
11289,
10710,
10712,
10711,
10721,
10713,
10714,
10720,
10719,
10718,
10717,
10716,
10715,
10674,
10675,
10680,
10659,
10667,
10666,
10665,
10664,
10663,
10662,
10661,
10660,
10679,
10678,
10672,
10673,
10670,
10671,
10668,
10669,
10677,
10676,
10708,
10707,
10700,
10701,
10706,
10698,
10699,
10705,
10704,
10703,
10696,
10697,
10702,
10694,
10685,
10686,
10693,
10682,
10684,
10683,
10692,
10691,
10690,
10689,
10688,
10687,
10723,
10724,
10728,
10727,
10726,
10725,
10333,
10332,
10331,
10330,
10329,
10328,
10327,
10326,
10325,
10311,
10310,
10309,
10308,
10307,
10306,
10305,
10304,
10300,
10302,
10301,
10303,
10323,
10322,
10321,
10320,
10319,
10313,
10314,
10318,
10317,
10316,
10315,
10298,
10297,
10296,
10291,
10292,
10289,
10290,
10287,
10288,
10295,
10285,
10286,
10294,
10293,
10337,
10336,
10335,
10391,
10390,
10389,
10388,
10382,
10383,
10387,
10386,
10385,
10384,
10380,
10379,
10378,
10377,
10376,
10375,
10374,
10370,
10371,
10373,
10372,
10392,
10362,
10361,
10360,
10359,
10358,
10357,
10356,
10355,
10354,
10344,
10345,
10342,
10343,
10352,
10351,
10350,
10349,
10348,
10347,
10340,
10341,
10346,
10367,
10366,
10364,
10365,
10586,
10587,
10593,
10592,
10591,
10584,
10585,
10577,
10583,
10582,
10581,
10580,
10579,
10578,
10590,
10589,
10588,
10627,
10630,
10629,
10628,
10640,
10639,
10638,
10637,
10636,
10635,
10634,
10633,
10631,
10632,
10618,
10619,
10625,
10624,
10623,
10616,
10617,
10614,
10615,
10622,
10621,
10620,
10612,
10613,
10602,
10603,
10610,
10609,
10600,
10601,
10608,
10607,
10595,
10599,
10598,
10597,
10596,
10606,
10605,
10604,
10651,
10650,
10649,
10648,
10647,
10646,
10645,
10644,
10643,
10642,
10653,
10655,
10654,
10656,
11259,
11260,
11267,
11257,
11258,
11266,
11265,
11264,
11263,
11262,
11261,
11270,
11269,
11342,
11341,
11340,
11339,
11338,
11337,
11336,
11153,
11145,
11146,
11142,
11144,
11143,
11152,
11151,
11150,
11149,
11148,
11147,
11131,
11132,
11140,
11139,
11138,
11137,
11136,
11129,
11130,
11135,
11134,
11133,
11164,
11163,
11162,
11161,
11160,
11159,
11158,
11157,
11156,
11155,
10923,
10915,
10916,
10922,
10921,
10920,
10913,
10914,
10919,
10918,
10917,
10886,
10885,
10884,
10883,
10874,
10876,
10875,
10882,
10881,
10877,
10878,
10880,
10879,
10899,
10898,
10897,
10896,
10895,
10894,
10888,
10890,
10889,
10893,
10892,
10891,
10911,
10910,
10909,
10908,
10907,
10901,
10902,
10906,
10905,
10904,
10903,
10931,
10930,
10929,
10928,
10927,
10926,
10925,
10999,
10998,
10993,
10994,
10997,
10996,
10995,
10991,
10992,
10989,
10990,
10987,
10988,
11012,
11003,
11004,
11011,
11010,
11009,
11008,
11001,
11002,
11007,
11006,
11005,
11023,
11022,
11021,
11020,
11019,
11018,
11017,
11016,
11015,
11014,
11033,
11032,
11027,
11028,
11025,
11026,
11031,
11030,
11029,
10969,
10968,
10967,
10966,
10965,
10959,
10961,
10960,
10964,
10963,
10962,
10980,
10979,
10978,
10977,
10976,
10975,
10974,
10973,
10972,
10971,
10945,
10944,
10943,
10936,
10937,
10942,
10941,
10940,
10939,
10938,
10934,
10935,
10957,
10956,
10947,
10948,
10955,
10954,
10953,
10952,
10951,
10950,
10949,
10984,
10983,
10982,
10521,
10530,
10529,
10528,
10527,
10526,
10525,
10524,
10523,
10522,
10534,
10535,
10541,
10540,
10539,
10538,
10531,
10533,
10532,
10537,
10536,
10557,
10543,
10546,
10545,
10544,
10547,
10549,
10548,
10556,
10555,
10554,
10553,
10552,
10551,
10550,
10495,
10507,
10506,
10505,
10504,
10503,
10502,
10501,
10500,
10499,
10498,
10497,
10496,
10519,
10518,
10512,
10513,
10517,
10516,
10515,
10514,
10510,
10511,
10508,
10509,
10565,
10566,
10563,
10564,
10572,
10561,
10562,
10571,
10570,
10569,
10559,
10560,
10568,
10567,
10573,
10574,
11192,
11191,
11184,
11185,
11190,
11189,
11188,
11187,
11186,
11182,
11183,
11173,
11174,
11180,
11179,
11178,
11171,
11172,
11177,
11176,
11169,
11170,
11167,
11168,
11175,
11200,
11199,
11198,
11197,
11194,
11195,
11196,
11283,
11282,
11281,
11272,
11274,
11273,
11280,
11277,
11278,
11279,
11275,
11276,
11307,
11308,
11315,
11314,
11313,
11312,
11311,
11310,
11309,
11126,
11110,
11114,
11113,
11112,
11111,
11115,
11117,
11116,
11120,
11121,
11118,
11119,
11125,
11124,
11123,
11122,
11108,
11107,
11106,
11105,
11104,
11085,
11094,
11093,
11092,
11091,
11090,
11089,
11088,
11087,
11086,
11095,
11103,
11102,
11101,
11100,
11099,
11098,
11097,
11096,
10255,
10254,
10253,
10252,
10251,
10250,
10245,
10247,
10246,
10249,
10248,
10277,
10276,
10275,
10274,
10273,
10272,
10271,
10270,
10269,
10268,
10266,
10265,
10264,
10263,
10262,
10261,
10260,
10259,
10258,
10257,
10281,
10280,
10279,
]

_charnames_118784 = [
15717,
15801,
15726,
15897,
15898,
15958,
15959,
15674,
15698,
15729,
15870,
15871,
15660,
15601,
15928,
15831,
15635,
15588,
15591,
15696,
15827,
15905,
15884,
15716,
15952,
15961,
15918,
15647,
15641,
15706,
15736,
15701,
15899,
15960,
15597,
15598,
15666,
15963,
15739,
15832,
15632,
15704,
15695,
15694,
15902,
15821,
15941,
15800,
15818,
15830,
15656,
15600,
15761,
15912,
15807,
15673,
15724,
15710,
15662,
15950,
15964,
15735,
15732,
15920,
15966,
15723,
15663,
15808,
15702,
15892,
15917,
15904,
15896,
15722,
15664,
15721,
15659,
15725,
15640,
15646,
15873,
15590,
15594,
15872,
15658,
15930,
15953,
15855,
15957,
15738,
15711,
15906,
15630,
15942,
15731,
15734,
15923,
15675,
15631,
15809,
15931,
15693,
15697,
15949,
15929,
15705,
15965,
15811,
15714,
15814,
15812,
15713,
15813,
15712,
15885,
15613,
15924,
15901,
15824,
15823,
15825,
15826,
15672,
15926,
15866,
15867,
15700,
15669,
15798,
15653,
15654,
15655,
15596,
15602,
15797,
15816,
15829,
15665,
15939,
15940,
15936,
15937,
15938,
15883,
15880,
15879,
15782,
15785,
15786,
15787,
15817,
15614,
15914,
15796,
15618,
15626,
15627,
15620,
15621,
15624,
15623,
15617,
15845,
15850,
15854,
15851,
15837,
15838,
15841,
15840,
15853,
15848,
15919,
15593,
15766,
15767,
15768,
15852,
15844,
15847,
15888,
15887,
15927,
15913,
15911,
15762,
15749,
15747,
15757,
15751,
15753,
15750,
15748,
15745,
15746,
15760,
15759,
15769,
15754,
15756,
15945,
15947,
15946,
15763,
15764,
15860,
15775,
15777,
15780,
15778,
15779,
15776,
15864,
15862,
15863,
15861,
15891,
15890,
15792,
15793,
15795,
15794,
15678,
15683,
15681,
15682,
15684,
15689,
15687,
15688,
15788,
15799,
15703,
15607,
15606,
15610,
15611,
15609,
15605,
15608,
15638,
15644,
15639,
15645,
15668,
15882,
]

_charnames_119040 = [
7129,
7211,
7161,
7283,
7205,
7150,
7319,
7286,
7282,
7206,
7207,
7140,
7055,
7281,
7280,
7279,
7178,
7179,
7225,
7068,
7228,
7227,
7197,
7115,
7112,
7166,
7162,
7128,
7127,
7165,
7268,
7271,
7270,
7069,
7168,
7171,
7170,
7214,
7213,
-1,
-1,
7253,
7209,
7210,
7176,
7177,
7309,
7310,
7148,
7149,
7300,
7301,
7054,
7066,
7200,
7199,
7306,
7305,
7254,
7328,
7322,
7302,
7295,
7124,
7110,
7121,
7195,
7338,
7244,
7067,
7143,
7144,
7078,
7079,
7084,
7085,
7081,
7082,
7087,
7088,
7076,
7077,
7256,
7257,
7090,
7091,
7246,
7332,
7312,
7311,
7058,
7059,
7224,
7329,
7324,
7303,
7296,
7125,
7111,
7122,
7196,
7019,
7020,
7036,
7035,
7034,
7160,
7159,
7158,
7046,
7029,
7028,
7027,
7026,
7025,
7233,
7293,
7230,
7289,
7231,
7290,
7232,
7291,
7044,
7017,
7038,
7018,
7047,
7048,
7045,
7051,
7335,
7336,
7042,
7050,
7030,
7022,
7053,
7041,
7037,
7285,
7153,
7337,
7245,
7258,
7167,
7065,
7217,
7266,
7267,
7071,
7104,
7339,
7107,
7106,
7182,
7192,
7191,
7190,
7189,
7188,
7187,
7186,
7185,
7184,
7183,
7325,
7313,
7292,
7216,
7040,
7049,
7052,
7021,
7242,
7241,
7323,
7273,
7274,
7330,
7203,
7204,
7259,
7315,
7222,
7137,
7139,
7248,
7251,
7133,
7135,
7173,
7174,
7317,
7318,
7223,
7138,
7250,
7134,
7101,
7103,
7102,
7099,
7094,
7098,
7097,
7096,
7064,
7264,
7263,
7145,
7333,
7238,
7061,
7151,
7062,
7113,
7236,
7237,
7152,
7114,
7243,
]

_charnames_119296 = [
21631,
21648,
21659,
21658,
21642,
21657,
21656,
21655,
21654,
21641,
21640,
21639,
21638,
21637,
21636,
21635,
21634,
21633,
21632,
21653,
21652,
21651,
21650,
21649,
21647,
21646,
21645,
21644,
21643,
21599,
21607,
21591,
21614,
21628,
21627,
21606,
21605,
21604,
21603,
21602,
21601,
21600,
21613,
21612,
21611,
21610,
21609,
21608,
21626,
21625,
21624,
21623,
21622,
21621,
21598,
21597,
21596,
21595,
21594,
21593,
21592,
21619,
21618,
21617,
21616,
21615,
3658,
3659,
3660,
21742,
]

_charnames_119552 = [
7004,
24772,
24771,
24766,
24765,
24763,
17967,
18004,
18036,
18047,
18056,
17954,
18031,
18052,
18045,
17977,
17973,
18063,
18059,
18029,
17999,
17956,
18061,
18050,
18007,
18033,
17998,
17995,
17990,
18066,
17955,
17985,
17979,
17966,
17978,
18046,
18027,
18043,
17963,
18055,
18019,
18015,
18028,
18003,
17996,
18041,
17997,
18023,
17986,
18013,
18022,
17984,
18026,
18000,
18008,
18064,
17957,
18037,
17988,
18065,
17972,
17964,
18021,
18020,
18038,
18034,
17989,
17980,
18049,
18016,
18058,
17976,
17981,
17971,
17987,
18017,
18014,
18062,
17960,
17965,
18009,
18032,
17959,
18053,
17974,
18042,
18006,
]

_charnames_119648 = [
3998,
3990,
3991,
3996,
3997,
3993,
3994,
4000,
3999,
4011,
4003,
4004,
4009,
4010,
4006,
4007,
4013,
4012,
]

_charnames_119808 = [
5967,
5965,
5963,
5938,
5935,
5975,
5961,
5974,
5959,
5973,
5957,
5955,
5953,
5951,
5931,
5927,
5972,
5949,
5947,
5923,
5945,
5971,
5970,
5943,
5969,
5941,
5804,
5802,
5800,
5773,
5770,
5798,
5796,
5811,
5794,
5810,
5792,
5790,
5788,
5786,
5766,
5759,
5809,
5784,
5782,
5763,
5780,
5808,
5807,
5778,
5806,
5776,
6099,
6097,
6095,
6093,
6068,
6107,
6091,
6106,
6089,
6105,
6087,
6085,
6083,
6081,
6064,
6060,
6104,
6079,
6077,
6056,
6075,
6103,
6102,
6073,
6101,
6071,
6048,
6046,
6044,
6005,
6017,
6042,
6040,
-1,
6038,
6054,
6036,
6034,
6032,
6030,
6013,
6001,
6053,
6028,
6026,
6010,
6024,
6052,
6051,
6022,
6050,
6020,
5739,
5737,
5735,
5733,
5708,
5747,
5731,
5746,
5729,
5745,
5727,
5725,
5723,
5721,
5704,
5700,
5744,
5719,
5717,
5696,
5715,
5743,
5742,
5713,
5741,
5711,
5687,
5685,
5683,
5681,
5654,
5679,
5677,
5694,
5675,
5693,
5673,
5671,
5669,
5667,
5650,
5643,
5692,
5665,
5663,
5647,
5661,
5691,
5690,
5659,
5689,
5657,
5639,
-1,
5638,
5637,
-1,
-1,
5636,
-1,
-1,
5635,
5634,
-1,
-1,
5633,
5632,
5631,
5630,
-1,
5629,
5628,
5627,
5626,
5625,
5624,
5623,
5622,
5620,
5619,
5618,
5617,
-1,
5616,
-1,
5615,
5614,
5613,
5612,
5611,
5610,
5609,
-1,
5608,
5607,
5606,
5605,
5604,
5603,
5602,
5601,
5600,
5599,
5598,
5866,
5865,
5864,
5863,
5862,
5861,
5860,
5859,
5858,
5857,
5856,
5855,
5854,
5853,
5852,
5851,
5850,
5849,
5848,
5847,
5846,
5845,
5844,
5843,
5842,
5841,
5839,
5838,
5837,
5836,
5835,
5834,
5833,
5832,
5831,
5830,
5829,
5828,
5827,
5826,
5825,
5824,
5823,
5822,
5821,
5820,
5819,
5818,
5817,
5816,
5815,
5814,
6297,
6296,
-1,
6295,
6294,
6293,
6292,
-1,
-1,
6291,
6290,
6289,
6288,
6287,
6286,
6285,
6284,
-1,
6283,
6282,
6281,
6280,
6279,
6278,
6277,
-1,
6275,
6274,
6273,
6272,
6271,
6270,
6269,
6268,
6267,
6266,
6265,
6264,
6263,
6262,
6261,
6260,
6259,
6258,
6257,
6256,
6255,
6254,
6253,
6252,
6251,
6250,
6233,
6232,
-1,
6231,
6230,
6229,
6228,
-1,
6227,
6226,
6225,
6224,
6223,
-1,
6222,
-1,
-1,
-1,
6221,
6220,
6219,
6218,
6217,
6216,
6215,
-1,
6213,
6212,
6211,
6210,
6209,
6208,
6207,
6206,
6205,
6204,
6203,
6202,
6201,
6200,
6199,
6198,
6197,
6196,
6195,
6194,
6193,
6192,
6191,
6190,
6189,
6188,
5921,
5920,
5919,
5918,
5917,
5916,
5915,
5914,
5913,
5912,
5911,
5910,
5909,
5908,
5907,
5906,
5905,
5904,
5903,
5902,
5901,
5900,
5899,
5898,
5897,
5896,
5894,
5893,
5892,
5891,
5890,
5889,
5888,
5887,
5886,
5885,
5884,
5883,
5882,
5881,
5880,
5879,
5878,
5877,
5876,
5875,
5874,
5873,
5872,
5871,
5870,
5869,
5581,
5580,
5579,
5578,
5577,
5576,
5575,
5574,
5573,
5572,
5571,
5570,
5569,
5568,
5567,
5566,
5565,
5564,
5563,
5562,
5561,
5560,
5559,
5558,
5557,
5556,
5554,
5553,
5552,
5551,
5550,
5549,
5548,
5547,
5546,
5545,
5544,
5543,
5542,
5541,
5540,
5539,
5538,
5537,
5536,
5535,
5534,
5533,
5532,
5531,
5530,
5529,
5441,
5439,
5437,
5435,
5410,
5449,
5433,
5448,
5431,
5447,
5429,
5427,
5425,
5423,
5406,
5402,
5446,
5421,
5419,
5398,
5417,
5445,
5444,
5415,
5443,
5413,
5389,
5387,
5385,
5383,
5356,
5381,
5379,
5396,
5377,
5395,
5375,
5373,
5371,
5369,
5352,
5345,
5394,
5367,
5365,
5349,
5363,
5393,
5392,
5361,
5391,
5359,
5527,
5526,
5525,
5524,
5523,
5522,
5521,
5520,
5519,
5518,
5517,
5516,
5515,
5514,
5513,
5512,
5511,
5510,
5509,
5508,
5507,
5506,
5505,
5504,
5503,
5502,
5500,
5499,
5498,
5497,
5496,
5495,
5494,
5493,
5492,
5491,
5490,
5489,
5488,
5487,
5486,
5485,
5484,
5483,
5482,
5481,
5480,
5479,
5478,
5477,
5476,
5475,
5326,
5324,
5322,
5320,
5295,
5334,
5318,
5333,
5316,
5332,
5314,
5312,
5310,
5308,
5291,
5287,
5331,
5306,
5304,
5283,
5302,
5330,
5329,
5300,
5328,
5298,
5274,
5272,
5270,
5268,
5241,
5266,
5264,
5281,
5262,
5280,
5260,
5258,
5256,
5254,
5237,
5230,
5279,
5252,
5250,
5234,
5248,
5278,
5277,
5246,
5276,
5244,
6171,
6170,
6169,
6168,
6167,
6166,
6165,
6164,
6163,
6162,
6161,
6160,
6159,
6158,
6157,
6156,
6155,
6154,
6153,
6152,
6151,
6150,
6149,
6148,
6147,
6146,
6144,
6143,
6142,
6141,
6140,
6139,
6138,
6137,
6136,
6135,
6134,
6133,
6132,
6131,
6130,
6129,
6128,
6127,
6126,
6125,
6124,
6123,
6122,
6121,
6120,
6119,
6008,
6007,
-1,
-1,
5968,
5966,
5962,
5940,
5937,
5942,
5936,
5924,
5960,
5958,
5956,
5954,
5952,
5944,
5933,
5929,
5950,
5925,
5948,
5926,
5946,
5930,
5964,
5928,
5934,
5996,
5805,
5803,
5797,
5775,
5772,
5777,
5771,
5764,
5795,
5793,
5791,
5789,
5787,
5779,
5768,
5761,
5785,
5799,
5783,
5765,
5781,
5762,
5801,
5760,
5769,
5993,
5998,
5994,
5997,
5992,
5995,
5991,
6100,
6098,
6092,
6094,
6070,
6072,
6069,
6057,
6090,
6088,
6086,
6084,
6082,
6074,
6066,
6062,
6080,
6058,
6078,
6059,
6076,
6063,
6096,
6061,
6067,
6114,
6049,
6047,
6041,
6009,
6019,
6021,
6018,
6011,
6039,
6037,
6035,
6033,
6031,
6023,
6015,
6003,
6029,
6043,
6027,
6012,
6025,
6004,
6045,
6002,
6016,
6111,
6116,
6112,
6115,
6110,
6113,
6109,
5740,
5738,
5732,
5734,
5710,
5712,
5709,
5697,
5730,
5728,
5726,
5724,
5722,
5714,
5706,
5702,
5720,
5698,
5718,
5699,
5716,
5703,
5736,
5701,
5707,
5754,
5688,
5686,
5678,
5682,
5656,
5658,
5655,
5648,
5676,
5674,
5672,
5670,
5668,
5660,
5652,
5645,
5666,
5680,
5664,
5649,
5662,
5646,
5684,
5644,
5653,
5751,
5756,
5752,
5755,
5750,
5753,
5749,
5442,
5440,
5434,
5436,
5412,
5414,
5411,
5399,
5432,
5430,
5428,
5426,
5424,
5416,
5408,
5404,
5422,
5400,
5420,
5401,
5418,
5405,
5438,
5403,
5409,
5470,
5390,
5388,
5380,
5384,
5358,
5360,
5357,
5350,
5378,
5376,
5374,
5372,
5370,
5362,
5354,
5347,
5368,
5382,
5366,
5351,
5364,
5348,
5386,
5346,
5355,
5467,
5472,
5468,
5471,
5466,
5469,
5465,
5327,
5325,
5319,
5321,
5297,
5299,
5296,
5284,
5317,
5315,
5313,
5311,
5309,
5301,
5293,
5289,
5307,
5285,
5305,
5286,
5303,
5290,
5323,
5288,
5294,
5341,
5275,
5273,
5265,
5269,
5243,
5245,
5242,
5235,
5263,
5261,
5259,
5257,
5255,
5247,
5239,
5232,
5253,
5267,
5251,
5236,
5249,
5233,
5271,
5231,
5240,
5338,
5343,
5339,
5342,
5337,
5340,
5336,
5939,
5774,
-1,
-1,
5986,
5987,
5978,
5979,
5984,
5985,
5981,
5982,
5989,
5988,
6244,
6245,
6236,
6237,
6242,
6243,
6239,
6240,
6247,
6246,
5592,
5593,
5584,
5585,
5590,
5591,
5587,
5588,
5595,
5594,
5460,
5461,
5452,
5453,
5458,
5459,
5455,
5456,
5463,
5462,
6182,
6183,
6174,
6175,
6180,
6181,
6177,
6178,
6185,
6184,
]

_charnames_126976 = [
6508,
6465,
6512,
6501,
6516,
6519,
6511,
6492,
6470,
6475,
6481,
6486,
6456,
6461,
6506,
6499,
6493,
6471,
6476,
6482,
6487,
6457,
6462,
6507,
6500,
6491,
6469,
6474,
6480,
6485,
6455,
6460,
6505,
6498,
6517,
6494,
6514,
6520,
6464,
6463,
6521,
6510,
6518,
6515,
-1,
-1,
-1,
-1,
24222,
24221,
24220,
24219,
24218,
24217,
24216,
24215,
24213,
24212,
24211,
24210,
24209,
24208,
24207,
24205,
24204,
24203,
24202,
24201,
24200,
24199,
24197,
24196,
24195,
24194,
24193,
24192,
24191,
24189,
24188,
24187,
24186,
24185,
24184,
24183,
24181,
24180,
24179,
24178,
24177,
24176,
24175,
24173,
24172,
24171,
24170,
24169,
24168,
24167,
24163,
24162,
24161,
24160,
24159,
24158,
24157,
24156,
24154,
24153,
24152,
24151,
24150,
24149,
24148,
24146,
24145,
24144,
24143,
24142,
24141,
24140,
24138,
24137,
24136,
24135,
24134,
24133,
24132,
24130,
24129,
24128,
24127,
24126,
24125,
24124,
24122,
24121,
24120,
24119,
24118,
24117,
24116,
24114,
24113,
24112,
24111,
24110,
24109,
24108,
]

_charnames_127232 = [
24748,
24749,
24753,
24723,
24727,
24741,
24745,
24732,
24736,
24761,
24757,
-1,
-1,
-1,
-1,
-1,
26023,
26022,
26021,
26020,
26019,
26018,
26017,
26016,
26015,
26014,
26013,
26012,
26011,
26010,
26009,
26008,
26007,
26006,
26005,
26004,
26003,
26002,
26001,
26000,
25999,
25998,
18379,
4656,
4655,
4931,
4919,
-1,
-1,
18777,
]

_charnames_127293 = [
18776,
-1,
18775,
-1,
-1,
18774,
-1,
-1,
-1,
18773,
-1,
-1,
-1,
18792,
18782,
18770,
18767,
18779,
]

_charnames_127353 = [
26618,
-1,
26617,
26616,
-1,
-1,
26615,
]

_charnames_127370 = [
5216,
26621,
26620,
26619,
-1,
-1,
18629,
]

_charnames_127504 = [
18741,
18733,
18727,
18786,
18755,
18724,
18760,
18723,
18754,
18749,
18764,
18744,
18729,
18731,
18736,
18743,
18730,
18762,
18763,
18759,
18734,
18735,
18748,
18739,
18746,
18753,
18752,
18765,
18732,
18756,
18726,
18747,
18758,
18740,
]

_charnames_127552 = [
18367,
18378,
18377,
18374,
18372,
18369,
18371,
18375,
18368,
]

_charnames_194560 = [
549,
548,
547,
546,
545,
544,
543,
542,
541,
540,
539,
538,
537,
536,
535,
534,
532,
531,
530,
529,
528,
527,
526,
525,
524,
523,
522,
521,
520,
519,
518,
517,
515,
514,
513,
512,
511,
510,
509,
508,
507,
506,
505,
504,
503,
502,
501,
500,
498,
497,
496,
495,
494,
493,
492,
491,
490,
489,
488,
487,
486,
485,
484,
483,
481,
480,
479,
478,
477,
476,
475,
474,
473,
472,
471,
470,
469,
468,
467,
466,
464,
463,
462,
461,
460,
459,
458,
457,
456,
455,
454,
453,
452,
451,
450,
449,
447,
446,
445,
444,
443,
442,
441,
440,
439,
438,
437,
436,
435,
434,
433,
432,
430,
429,
428,
427,
426,
425,
424,
423,
422,
421,
420,
419,
418,
417,
416,
415,
413,
412,
411,
410,
409,
408,
407,
406,
405,
404,
403,
402,
401,
400,
399,
398,
396,
395,
394,
393,
392,
391,
390,
389,
388,
387,
386,
385,
384,
383,
382,
381,
379,
378,
377,
376,
375,
374,
373,
372,
371,
370,
369,
368,
367,
366,
365,
364,
362,
361,
360,
359,
358,
357,
356,
355,
354,
353,
352,
351,
350,
349,
348,
347,
345,
344,
343,
342,
341,
340,
339,
338,
337,
336,
335,
334,
333,
332,
331,
330,
328,
327,
326,
325,
324,
323,
322,
321,
320,
319,
318,
317,
316,
315,
314,
313,
311,
310,
309,
308,
307,
306,
305,
304,
303,
302,
301,
300,
299,
298,
297,
296,
294,
293,
292,
291,
290,
289,
288,
287,
286,
285,
284,
283,
282,
281,
280,
279,
276,
275,
274,
273,
272,
271,
270,
269,
268,
267,
266,
265,
264,
263,
262,
261,
259,
258,
257,
256,
255,
254,
253,
252,
251,
250,
249,
248,
247,
246,
245,
244,
242,
241,
240,
239,
238,
237,
236,
235,
234,
233,
232,
231,
230,
229,
228,
227,
225,
224,
223,
222,
221,
220,
219,
218,
217,
216,
215,
214,
213,
212,
211,
210,
208,
207,
206,
205,
204,
203,
202,
201,
200,
199,
198,
197,
196,
195,
194,
193,
191,
190,
189,
188,
187,
186,
185,
184,
183,
182,
181,
180,
179,
178,
177,
176,
174,
173,
172,
171,
170,
169,
168,
167,
166,
165,
164,
163,
162,
161,
160,
159,
157,
156,
155,
154,
153,
152,
151,
150,
149,
148,
147,
146,
145,
144,
143,
142,
140,
139,
138,
137,
136,
135,
134,
133,
132,
131,
130,
129,
128,
127,
126,
125,
123,
122,
121,
120,
119,
118,
117,
116,
115,
114,
113,
112,
111,
110,
109,
108,
106,
105,
104,
103,
102,
101,
100,
99,
98,
97,
96,
95,
94,
93,
92,
91,
89,
88,
87,
86,
85,
84,
83,
82,
81,
80,
79,
78,
77,
76,
75,
74,
72,
71,
70,
69,
68,
67,
66,
65,
64,
63,
62,
61,
60,
59,
58,
57,
55,
54,
53,
52,
51,
50,
49,
48,
47,
46,
45,
44,
43,
42,
41,
40,
38,
37,
36,
35,
34,
33,
32,
31,
30,
29,
28,
27,
26,
25,
24,
23,
21,
20,
19,
18,
17,
16,
15,
14,
13,
12,
11,
10,
9,
8,
7,
6,
567,
566,
565,
564,
563,
562,
561,
560,
559,
558,
557,
556,
555,
554,
553,
552,
582,
581,
580,
579,
578,
577,
576,
575,
574,
573,
572,
571,
570,
569,
]

_charnames_917536 = [
17277,
17294,
17285,
17298,
17262,
17289,
17283,
17282,
17243,
17266,
17281,
17288,
17273,
17299,
17300,
17278,
17258,
17259,
17250,
17251,
17256,
17257,
17253,
17254,
17261,
17260,
17274,
17279,
17245,
17295,
17291,
17286,
17272,
17239,
17238,
17237,
17236,
17235,
17234,
17233,
17232,
17231,
17230,
17229,
17228,
17227,
17226,
17225,
17224,
17223,
17222,
17221,
17220,
17219,
17218,
17217,
17216,
17215,
17214,
17242,
17268,
17265,
17275,
17246,
17292,
17212,
17211,
17210,
17209,
17208,
17207,
17206,
17205,
17204,
17203,
17202,
17201,
17200,
17199,
17198,
17197,
17196,
17195,
17194,
17193,
17192,
17191,
17190,
17189,
17188,
17187,
17244,
17296,
17267,
17297,
3343,
]

_charnames_917760 = [
23754,
23743,
23732,
23887,
23876,
23865,
23854,
23843,
23898,
23909,
23908,
23907,
23906,
23986,
23985,
23984,
23983,
23982,
23981,
23980,
23979,
23978,
23977,
23975,
23974,
23973,
23972,
23971,
23970,
23969,
23968,
23967,
23966,
23964,
23963,
23962,
23961,
23960,
23959,
23958,
23957,
23956,
23955,
23953,
23952,
23951,
23950,
23949,
23948,
23947,
23946,
23945,
23944,
23942,
23941,
23940,
23939,
23938,
23937,
23936,
23935,
23934,
23933,
23931,
23930,
23929,
23928,
23927,
23926,
23925,
23924,
23923,
23922,
23920,
23919,
23918,
23917,
23916,
23915,
23914,
23913,
23912,
23911,
23841,
23840,
23839,
23838,
23837,
23836,
23835,
23834,
23833,
23832,
23830,
23829,
23828,
23827,
23826,
23825,
23824,
23823,
23822,
23821,
23819,
23818,
23817,
23816,
23815,
23814,
23813,
23812,
23811,
23810,
23808,
23807,
23806,
23805,
23804,
23803,
23802,
23801,
23800,
23799,
23797,
23796,
23795,
23794,
23793,
23792,
23791,
23790,
23789,
23788,
23786,
23785,
23784,
23783,
23782,
23781,
23780,
23779,
23778,
23777,
23775,
23774,
23773,
23772,
23771,
23770,
23769,
23768,
23767,
23766,
23764,
23763,
23762,
23761,
23760,
23759,
23758,
23757,
23756,
23755,
23753,
23752,
23751,
23750,
23749,
23748,
23747,
23746,
23745,
23744,
23742,
23741,
23740,
23739,
23738,
23737,
23736,
23735,
23734,
23733,
23897,
23896,
23895,
23894,
23893,
23892,
23891,
23890,
23889,
23888,
23886,
23885,
23884,
23883,
23882,
23881,
23880,
23879,
23878,
23877,
23875,
23874,
23873,
23872,
23871,
23870,
23869,
23868,
23867,
23866,
23864,
23863,
23862,
23861,
23860,
23859,
23858,
23857,
23856,
23855,
23853,
23852,
23851,
23850,
23849,
23848,
23847,
23846,
23845,
23844,
23905,
23904,
23903,
23902,
23901,
23900,
23899,
]

def lookup_charcode(code):
    res = -1
    if 32 <= code <= 126: res = _charnames_32[code-32]
    if 160 <= code <= 1317: res = _charnames_160[code-160]
    if 1329 <= code <= 1479: res = _charnames_1329[code-1329]
    if 1488 <= code <= 1524: res = _charnames_1488[code-1488]
    if 1536 <= code <= 1969: res = _charnames_1536[code-1536]
    if 1984 <= code <= 2110: res = _charnames_1984[code-1984]
    if 2304 <= code <= 2510: res = _charnames_2304[code-2304]
    if 2519 <= code <= 2641: res = _charnames_2519[code-2519]
    if code == 2649: res = 21935
    if code == 2650: res = 21940
    if code == 2651: res = 21968
    if code == 2652: res = 21949
    if code == 2654: res = 21974
    if 2662 <= code <= 2677: res = _charnames_2662[code-2662]
    if 2689 <= code <= 2768: res = _charnames_2689[code-2689]
    if 2784 <= code <= 2801: res = _charnames_2784[code-2784]
    if 2817 <= code <= 2893: res = _charnames_2817[code-2817]
    if 2902 <= code <= 2929: res = _charnames_2902[code-2902]
    if 2946 <= code <= 3031: res = _charnames_2946[code-2946]
    if 3046 <= code <= 3149: res = _charnames_3046[code-3046]
    if 3157 <= code <= 3183: res = _charnames_3157[code-3157]
    if 3192 <= code <= 3277: res = _charnames_3192[code-3192]
    if code == 3285: res = 22734
    if code == 3286: res = 22777
    if 3294 <= code <= 3314: res = _charnames_3294[code-3294]
    if 3330 <= code <= 3405: res = _charnames_3330[code-3330]
    if code == 3415: res = 6443
    if 3424 <= code <= 3551: res = _charnames_3424[code-3424]
    if code == 3570: res = 19496
    if code == 3571: res = 19495
    if code == 3572: res = 19510
    if 3585 <= code <= 3675: res = _charnames_3585[code-3585]
    if 3713 <= code <= 3805: res = _charnames_3713[code-3713]
    if 3840 <= code <= 4056: res = _charnames_3840[code-3840]
    if 4096 <= code <= 4293: res = _charnames_4096[code-4096]
    if 4304 <= code <= 5108: res = _charnames_4304[code-4304]
    if 5120 <= code <= 5872: res = _charnames_5120[code-5120]
    if 5888 <= code <= 5908: res = _charnames_5888[code-5888]
    if 5920 <= code <= 5942: res = _charnames_5920[code-5920]
    if 5952 <= code <= 5971: res = _charnames_5952[code-5952]
    if 5984 <= code <= 6003: res = _charnames_5984[code-5984]
    if 6016 <= code <= 6263: res = _charnames_6016[code-6016]
    if 6272 <= code <= 6389: res = _charnames_6272[code-6272]
    if 6400 <= code <= 6516: res = _charnames_6400[code-6400]
    if 6528 <= code <= 6829: res = _charnames_6528[code-6528]
    if 6912 <= code <= 7097: res = _charnames_6912[code-6912]
    if 7168 <= code <= 7295: res = _charnames_7168[code-7168]
    if 7376 <= code <= 7410: res = _charnames_7376[code-7376]
    if 7424 <= code <= 7654: res = _charnames_7424[code-7424]
    if 7677 <= code <= 8340: res = _charnames_7677[code-7677]
    if 8352 <= code <= 8376: res = _charnames_8352[code-8352]
    if 8400 <= code <= 8432: res = _charnames_8400[code-8400]
    if 8448 <= code <= 9192: res = _charnames_8448[code-8448]
    if 9216 <= code <= 9254: res = _charnames_9216[code-9216]
    if 9280 <= code <= 9290: res = _charnames_9280[code-9280]
    if 9312 <= code <= 11097: res = _charnames_9312[code-9312]
    if 11264 <= code <= 11505: res = _charnames_11264[code-11264]
    if 11513 <= code <= 11557: res = _charnames_11513[code-11513]
    if 11568 <= code <= 11621: res = _charnames_11568[code-11568]
    if code == 11631: res = 17792
    if 11648 <= code <= 11670: res = _charnames_11648[code-11648]
    if 11680 <= code <= 11825: res = _charnames_11680[code-11680]
    if 11904 <= code <= 12019: res = _charnames_11904[code-11904]
    if 12032 <= code <= 12245: res = _charnames_12032[code-12032]
    if 12272 <= code <= 12727: res = _charnames_12272[code-12272]
    if 12736 <= code <= 12771: res = _charnames_12736[code-12736]
    if 12784 <= code <= 13311: res = _charnames_12784[code-12784]
    if 19904 <= code <= 19967: res = _charnames_19904[code-19904]
    if 40960 <= code <= 42182: res = _charnames_40960[code-40960]
    if 42192 <= code <= 42539: res = _charnames_42192[code-42192]
    if 42560 <= code <= 42611: res = _charnames_42560[code-42560]
    if 42620 <= code <= 42647: res = _charnames_42620[code-42620]
    if 42656 <= code <= 42743: res = _charnames_42656[code-42656]
    if 42752 <= code <= 42892: res = _charnames_42752[code-42752]
    if 43003 <= code <= 43127: res = _charnames_43003[code-43003]
    if 43136 <= code <= 43204: res = _charnames_43136[code-43136]
    if 43214 <= code <= 43347: res = _charnames_43214[code-43214]
    if 43359 <= code <= 43487: res = _charnames_43359[code-43359]
    if 43520 <= code <= 43574: res = _charnames_43520[code-43520]
    if 43584 <= code <= 43714: res = _charnames_43584[code-43584]
    if code == 43739: res = 17127
    if code == 43740: res = 17130
    if code == 43741: res = 17129
    if code == 43742: res = 17131
    if code == 43743: res = 17128
    if 43968 <= code <= 44025: res = _charnames_43968[code-43968]
    if 55216 <= code <= 55291: res = _charnames_55216[code-55216]
    if 63744 <= code <= 64217: res = _charnames_63744[code-63744]
    if 64256 <= code <= 64262: res = _charnames_64256[code-64256]
    if 64275 <= code <= 64433: res = _charnames_64275[code-64275]
    if 64467 <= code <= 64831: res = _charnames_64467[code-64467]
    if 64848 <= code <= 64967: res = _charnames_64848[code-64848]
    if 65008 <= code <= 65062: res = _charnames_65008[code-65008]
    if 65072 <= code <= 65518: res = _charnames_65072[code-65072]
    if 65529 <= code <= 65629: res = _charnames_65529[code-65529]
    if 65664 <= code <= 65947: res = _charnames_65664[code-65664]
    if 66000 <= code <= 66045: res = _charnames_66000[code-66000]
    if 66176 <= code <= 66256: res = _charnames_66176[code-66176]
    if 66304 <= code <= 66339: res = _charnames_66304[code-66304]
    if 66352 <= code <= 66378: res = _charnames_66352[code-66352]
    if 66432 <= code <= 66517: res = _charnames_66432[code-66432]
    if 66560 <= code <= 66729: res = _charnames_66560[code-66560]
    if 67584 <= code <= 67679: res = _charnames_67584[code-67584]
    if 67840 <= code <= 67903: res = _charnames_67840[code-67840]
    if 68096 <= code <= 68167: res = _charnames_68096[code-68096]
    if 68176 <= code <= 68184: res = _charnames_68176[code-68176]
    if 68192 <= code <= 68223: res = _charnames_68192[code-68192]
    if 68352 <= code <= 68479: res = _charnames_68352[code-68352]
    if 68608 <= code <= 68680: res = _charnames_68608[code-68608]
    if 69216 <= code <= 69246: res = _charnames_69216[code-69216]
    if 69760 <= code <= 69825: res = _charnames_69760[code-69760]
    if 73728 <= code <= 74606: res = _charnames_73728[code-73728]
    if 74752 <= code <= 74850: res = _charnames_74752[code-74752]
    if code == 74864: res = 2527
    if code == 74865: res = 2526
    if code == 74866: res = 2525
    if code == 74867: res = 2524
    if 77824 <= code <= 78894: res = _charnames_77824[code-77824]
    if 118784 <= code <= 119029: res = _charnames_118784[code-118784]
    if 119040 <= code <= 119261: res = _charnames_119040[code-119040]
    if 119296 <= code <= 119365: res = _charnames_119296[code-119296]
    if 119552 <= code <= 119638: res = _charnames_119552[code-119552]
    if 119648 <= code <= 119665: res = _charnames_119648[code-119648]
    if 119808 <= code <= 120831: res = _charnames_119808[code-119808]
    if 126976 <= code <= 127123: res = _charnames_126976[code-126976]
    if 127232 <= code <= 127281: res = _charnames_127232[code-127232]
    if 127293 <= code <= 127310: res = _charnames_127293[code-127293]
    if code == 127319: res = 26611
    if code == 127327: res = 26610
    if 127353 <= code <= 127359: res = _charnames_127353[code-127353]
    if 127370 <= code <= 127376: res = _charnames_127370[code-127370]
    if code == 127488: res = 18574
    if 127504 <= code <= 127537: res = _charnames_127504[code-127504]
    if 127552 <= code <= 127560: res = _charnames_127552[code-127552]
    if 194560 <= code <= 195101: res = _charnames_194560[code-194560]
    if code == 917505: res = 9201
    if 917536 <= code <= 917631: res = _charnames_917536[code-917536]
    if 917760 <= code <= 917999: res = _charnames_917760[code-917760]
    if res == -1: raise KeyError(code)
    return name_of_node(res)

# the following dictionary is used by modules that take this as a base
_orig_names = {
'AC CURRENT': 9190,
'ACCOUNT OF': 8448,
'ACTIVATE ARABIC FORM SHAPING': 8301,
'ACTIVATE SYMMETRIC SWAPPING': 8299,
'ACUTE ACCENT': 180,
'ACUTE ANGLE': 10655,
'ADDRESSED TO THE SUBJECT': 8449,
'ADI SHAKTI': 9772,
'AEGEAN CHECK MARK': 65794,
'AEGEAN DRY MEASURE FIRST SUBUNIT': 65852,
'AEGEAN LIQUID MEASURE FIRST SUBUNIT': 65853,
'AEGEAN MEASURE SECOND SUBUNIT': 65854,
'AEGEAN MEASURE THIRD SUBUNIT': 65855,
'AEGEAN NUMBER EIGHT': 65806,
'AEGEAN NUMBER EIGHT HUNDRED': 65824,
'AEGEAN NUMBER EIGHT THOUSAND': 65833,
'AEGEAN NUMBER EIGHTY': 65815,
'AEGEAN NUMBER EIGHTY THOUSAND': 65842,
'AEGEAN NUMBER FIFTY': 65812,
'AEGEAN NUMBER FIFTY THOUSAND': 65839,
'AEGEAN NUMBER FIVE': 65803,
'AEGEAN NUMBER FIVE HUNDRED': 65821,
'AEGEAN NUMBER FIVE THOUSAND': 65830,
'AEGEAN NUMBER FORTY': 65811,
'AEGEAN NUMBER FORTY THOUSAND': 65838,
'AEGEAN NUMBER FOUR': 65802,
'AEGEAN NUMBER FOUR HUNDRED': 65820,
'AEGEAN NUMBER FOUR THOUSAND': 65829,
'AEGEAN NUMBER NINE': 65807,
'AEGEAN NUMBER NINE HUNDRED': 65825,
'AEGEAN NUMBER NINE THOUSAND': 65834,
'AEGEAN NUMBER NINETY': 65816,
'AEGEAN NUMBER NINETY THOUSAND': 65843,
'AEGEAN NUMBER ONE': 65799,
'AEGEAN NUMBER ONE HUNDRED': 65817,
'AEGEAN NUMBER ONE THOUSAND': 65826,
'AEGEAN NUMBER SEVEN': 65805,
'AEGEAN NUMBER SEVEN HUNDRED': 65823,
'AEGEAN NUMBER SEVEN THOUSAND': 65832,
'AEGEAN NUMBER SEVENTY': 65814,
'AEGEAN NUMBER SEVENTY THOUSAND': 65841,
'AEGEAN NUMBER SIX': 65804,
'AEGEAN NUMBER SIX HUNDRED': 65822,
'AEGEAN NUMBER SIX THOUSAND': 65831,
'AEGEAN NUMBER SIXTY': 65813,
'AEGEAN NUMBER SIXTY THOUSAND': 65840,
'AEGEAN NUMBER TEN': 65808,
'AEGEAN NUMBER TEN THOUSAND': 65835,
'AEGEAN NUMBER THIRTY': 65810,
'AEGEAN NUMBER THIRTY THOUSAND': 65837,
'AEGEAN NUMBER THREE': 65801,
'AEGEAN NUMBER THREE HUNDRED': 65819,
'AEGEAN NUMBER THREE THOUSAND': 65828,
'AEGEAN NUMBER TWENTY': 65809,
'AEGEAN NUMBER TWENTY THOUSAND': 65836,
'AEGEAN NUMBER TWO': 65800,
'AEGEAN NUMBER TWO HUNDRED': 65818,
'AEGEAN NUMBER TWO THOUSAND': 65827,
'AEGEAN WEIGHT BASE UNIT': 65847,
'AEGEAN WEIGHT FIRST SUBUNIT': 65848,
'AEGEAN WEIGHT FOURTH SUBUNIT': 65851,
'AEGEAN WEIGHT SECOND SUBUNIT': 65849,
'AEGEAN WEIGHT THIRD SUBUNIT': 65850,
'AEGEAN WORD SEPARATOR DOT': 65793,
'AEGEAN WORD SEPARATOR LINE': 65792,
'AFGHANI SIGN': 1547,
'AIRPLANE': 9992,
'AKTIESELSKAB': 8525,
'ALEF SYMBOL': 8501,
'ALEMBIC': 9879,
'ALL AROUND-PROFILE': 9006,
'ALL EQUAL TO': 8780,
'ALMOST EQUAL OR EQUAL TO': 8778,
'ALMOST EQUAL TO': 8776,
'ALMOST EQUAL TO WITH CIRCUMFLEX ACCENT': 10863,
'ALTERNATE ONE-WAY LEFT WAY TRAFFIC': 9941,
'ALTERNATIVE KEY SYMBOL': 9095,
'AMALGAMATION OR COPRODUCT': 10815,
'AMPERSAND': 38,
'ANCHOR': 9875,
'AND WITH DOT': 10193,
'ANGLE': 8736,
'ANGLE WITH S INSIDE': 10654,
'ANGLE WITH UNDERBAR': 10660,
'ANGSTROM SIGN': 8491,
'ANKH': 9765,
'ANTICLOCKWISE CLOSED CIRCLE ARROW': 10560,
'ANTICLOCKWISE CONTOUR INTEGRAL': 8755,
'ANTICLOCKWISE GAPPED CIRCLE ARROW': 10226,
'ANTICLOCKWISE INTEGRATION': 10769,
'ANTICLOCKWISE OPEN CIRCLE ARROW': 8634,
'ANTICLOCKWISE TOP SEMICIRCLE ARROW': 8630,
'APL FUNCTIONAL SYMBOL ALPHA': 9082,
'APL FUNCTIONAL SYMBOL ALPHA UNDERBAR': 9078,
'APL FUNCTIONAL SYMBOL BACKSLASH BAR': 9024,
'APL FUNCTIONAL SYMBOL CIRCLE BACKSLASH': 9033,
'APL FUNCTIONAL SYMBOL CIRCLE DIAERESIS': 9061,
'APL FUNCTIONAL SYMBOL CIRCLE JOT': 9022,
'APL FUNCTIONAL SYMBOL CIRCLE STAR': 9055,
'APL FUNCTIONAL SYMBOL CIRCLE STILE': 9021,
'APL FUNCTIONAL SYMBOL CIRCLE UNDERBAR': 9052,
'APL FUNCTIONAL SYMBOL COMMA BAR': 9066,
'APL FUNCTIONAL SYMBOL DEL DIAERESIS': 9058,
'APL FUNCTIONAL SYMBOL DEL STILE': 9042,
'APL FUNCTIONAL SYMBOL DEL TILDE': 9067,
'APL FUNCTIONAL SYMBOL DELTA STILE': 9035,
'APL FUNCTIONAL SYMBOL DELTA UNDERBAR': 9049,
'APL FUNCTIONAL SYMBOL DIAMOND UNDERBAR': 9050,
'APL FUNCTIONAL SYMBOL DOWN CARET TILDE': 9073,
'APL FUNCTIONAL SYMBOL DOWN SHOE STILE': 9062,
'APL FUNCTIONAL SYMBOL DOWN TACK JOT': 9038,
'APL FUNCTIONAL SYMBOL DOWN TACK UNDERBAR': 9034,
'APL FUNCTIONAL SYMBOL DOWNWARDS VANE': 9046,
'APL FUNCTIONAL SYMBOL EPSILON UNDERBAR': 9079,
'APL FUNCTIONAL SYMBOL GREATER-THAN DIAERESIS': 9065,
'APL FUNCTIONAL SYMBOL I-BEAM': 9014,
'APL FUNCTIONAL SYMBOL IOTA': 9075,
'APL FUNCTIONAL SYMBOL IOTA UNDERBAR': 9080,
'APL FUNCTIONAL SYMBOL JOT DIAERESIS': 9060,
'APL FUNCTIONAL SYMBOL JOT UNDERBAR': 9051,
'APL FUNCTIONAL SYMBOL LEFT SHOE STILE': 9063,
'APL FUNCTIONAL SYMBOL LEFTWARDS VANE': 9029,
'APL FUNCTIONAL SYMBOL OMEGA': 9077,
'APL FUNCTIONAL SYMBOL OMEGA UNDERBAR': 9081,
'APL FUNCTIONAL SYMBOL QUAD': 9109,
'APL FUNCTIONAL SYMBOL QUAD BACKSLASH': 9026,
'APL FUNCTIONAL SYMBOL QUAD CIRCLE': 9020,
'APL FUNCTIONAL SYMBOL QUAD COLON': 9056,
'APL FUNCTIONAL SYMBOL QUAD DEL': 9044,
'APL FUNCTIONAL SYMBOL QUAD DELTA': 9037,
'APL FUNCTIONAL SYMBOL QUAD DIAMOND': 9018,
'APL FUNCTIONAL SYMBOL QUAD DIVIDE': 9017,
'APL FUNCTIONAL SYMBOL QUAD DOWN CARET': 9036,
'APL FUNCTIONAL SYMBOL QUAD DOWNWARDS ARROW': 9047,
'APL FUNCTIONAL SYMBOL QUAD EQUAL': 9016,
'APL FUNCTIONAL SYMBOL QUAD GREATER-THAN': 9028,
'APL FUNCTIONAL SYMBOL QUAD JOT': 9019,
'APL FUNCTIONAL SYMBOL QUAD LEFTWARDS ARROW': 9031,
'APL FUNCTIONAL SYMBOL QUAD LESS-THAN': 9027,
'APL FUNCTIONAL SYMBOL QUAD NOT EQUAL': 9071,
'APL FUNCTIONAL SYMBOL QUAD QUESTION': 9072,
'APL FUNCTIONAL SYMBOL QUAD RIGHTWARDS ARROW': 9032,
'APL FUNCTIONAL SYMBOL QUAD SLASH': 9025,
'APL FUNCTIONAL SYMBOL QUAD UP CARET': 9043,
'APL FUNCTIONAL SYMBOL QUAD UPWARDS ARROW': 9040,
'APL FUNCTIONAL SYMBOL QUOTE QUAD': 9054,
'APL FUNCTIONAL SYMBOL QUOTE UNDERBAR': 9048,
'APL FUNCTIONAL SYMBOL RHO': 9076,
'APL FUNCTIONAL SYMBOL RIGHTWARDS VANE': 9030,
'APL FUNCTIONAL SYMBOL SEMICOLON UNDERBAR': 9070,
'APL FUNCTIONAL SYMBOL SLASH BAR': 9023,
'APL FUNCTIONAL SYMBOL SQUISH QUAD': 9015,
'APL FUNCTIONAL SYMBOL STAR DIAERESIS': 9059,
'APL FUNCTIONAL SYMBOL STILE TILDE': 9069,
'APL FUNCTIONAL SYMBOL TILDE DIAERESIS': 9064,
'APL FUNCTIONAL SYMBOL UP CARET TILDE': 9074,
'APL FUNCTIONAL SYMBOL UP SHOE JOT': 9053,
'APL FUNCTIONAL SYMBOL UP TACK DIAERESIS': 9057,
'APL FUNCTIONAL SYMBOL UP TACK JOT': 9045,
'APL FUNCTIONAL SYMBOL UP TACK OVERBAR': 9041,
'APL FUNCTIONAL SYMBOL UPWARDS VANE': 9039,
'APL FUNCTIONAL SYMBOL ZILDE': 9068,
'APOSTROPHE': 39,
'APPROACHES THE LIMIT': 8784,
'APPROXIMATELY BUT NOT ACTUALLY EQUAL TO': 8774,
'APPROXIMATELY EQUAL OR EQUAL TO': 10864,
'APPROXIMATELY EQUAL TO': 8773,
'APPROXIMATELY EQUAL TO OR THE IMAGE OF': 8786,
'AQUARIUS': 9810,
'ARABIC COMMA': 1548,
'ARABIC DAMMA': 1615,
'ARABIC DAMMA ISOLATED FORM': 65144,
'ARABIC DAMMA MEDIAL FORM': 65145,
'ARABIC DAMMATAN': 1612,
'ARABIC DAMMATAN ISOLATED FORM': 65138,
'ARABIC DATE SEPARATOR': 1549,
'ARABIC DECIMAL SEPARATOR': 1643,
'ARABIC EMPTY CENTRE HIGH STOP': 1771,
'ARABIC EMPTY CENTRE LOW STOP': 1770,
'ARABIC END OF AYAH': 1757,
'ARABIC FATHA': 1614,
'ARABIC FATHA ISOLATED FORM': 65142,
'ARABIC FATHA MEDIAL FORM': 65143,
'ARABIC FATHA WITH TWO DOTS': 1630,
'ARABIC FATHATAN': 1611,
'ARABIC FATHATAN ISOLATED FORM': 65136,
'ARABIC FIVE POINTED STAR': 1645,
'ARABIC FOOTNOTE MARKER': 1538,
'ARABIC FULL STOP': 1748,
'ARABIC HAMZA ABOVE': 1620,
'ARABIC HAMZA BELOW': 1621,
'ARABIC INVERTED DAMMA': 1623,
'ARABIC KASRA': 1616,
'ARABIC KASRA ISOLATED FORM': 65146,
'ARABIC KASRA MEDIAL FORM': 65147,
'ARABIC KASRATAN': 1613,
'ARABIC KASRATAN ISOLATED FORM': 65140,
'ARABIC LETTER AE': 1749,
'ARABIC LETTER AIN': 1593,
'ARABIC LETTER AIN FINAL FORM': 65226,
'ARABIC LETTER AIN INITIAL FORM': 65227,
'ARABIC LETTER AIN ISOLATED FORM': 65225,
'ARABIC LETTER AIN MEDIAL FORM': 65228,
'ARABIC LETTER AIN WITH THREE DOTS ABOVE': 1696,
'ARABIC LETTER AIN WITH THREE DOTS POINTING DOWNWARDS ABOVE': 1886,
'ARABIC LETTER AIN WITH TWO DOTS ABOVE': 1885,
'ARABIC LETTER AIN WITH TWO DOTS VERTICALLY ABOVE': 1887,
'ARABIC LETTER ALEF': 1575,
'ARABIC LETTER ALEF FINAL FORM': 65166,
'ARABIC LETTER ALEF ISOLATED FORM': 65165,
'ARABIC LETTER ALEF MAKSURA': 1609,
'ARABIC LETTER ALEF MAKSURA FINAL FORM': 65264,
'ARABIC LETTER ALEF MAKSURA ISOLATED FORM': 65263,
'ARABIC LETTER ALEF WASLA': 1649,
'ARABIC LETTER ALEF WASLA FINAL FORM': 64337,
'ARABIC LETTER ALEF WASLA ISOLATED FORM': 64336,
'ARABIC LETTER ALEF WITH EXTENDED ARABIC-INDIC DIGIT THREE ABOVE': 1908,
'ARABIC LETTER ALEF WITH EXTENDED ARABIC-INDIC DIGIT TWO ABOVE': 1907,
'ARABIC LETTER ALEF WITH HAMZA ABOVE': 1571,
'ARABIC LETTER ALEF WITH HAMZA ABOVE FINAL FORM': 65156,
'ARABIC LETTER ALEF WITH HAMZA ABOVE ISOLATED FORM': 65155,
'ARABIC LETTER ALEF WITH HAMZA BELOW': 1573,
'ARABIC LETTER ALEF WITH HAMZA BELOW FINAL FORM': 65160,
'ARABIC LETTER ALEF WITH HAMZA BELOW ISOLATED FORM': 65159,
'ARABIC LETTER ALEF WITH MADDA ABOVE': 1570,
'ARABIC LETTER ALEF WITH MADDA ABOVE FINAL FORM': 65154,
'ARABIC LETTER ALEF WITH MADDA ABOVE ISOLATED FORM': 65153,
'ARABIC LETTER ALEF WITH WAVY HAMZA ABOVE': 1650,
'ARABIC LETTER ALEF WITH WAVY HAMZA BELOW': 1651,
'ARABIC LETTER BEEH': 1659,
'ARABIC LETTER BEEH FINAL FORM': 64339,
'ARABIC LETTER BEEH INITIAL FORM': 64340,
'ARABIC LETTER BEEH ISOLATED FORM': 64338,
'ARABIC LETTER BEEH MEDIAL FORM': 64341,
'ARABIC LETTER BEH': 1576,
'ARABIC LETTER BEH FINAL FORM': 65168,
'ARABIC LETTER BEH INITIAL FORM': 65169,
'ARABIC LETTER BEH ISOLATED FORM': 65167,
'ARABIC LETTER BEH MEDIAL FORM': 65170,
'ARABIC LETTER BEH WITH DOT BELOW AND THREE DOTS ABOVE': 1873,
'ARABIC LETTER BEH WITH INVERTED SMALL V BELOW': 1877,
'ARABIC LETTER BEH WITH SMALL V': 1878,
'ARABIC LETTER BEH WITH THREE DOTS HORIZONTALLY BELOW': 1872,
'ARABIC LETTER BEH WITH THREE DOTS POINTING UPWARDS BELOW': 1874,
'ARABIC LETTER BEH WITH THREE DOTS POINTING UPWARDS BELOW AND TWO DOTS ABOVE': 1875,
'ARABIC LETTER BEH WITH TWO DOTS BELOW AND DOT ABOVE': 1876,
'ARABIC LETTER BEHEH': 1664,
'ARABIC LETTER BEHEH FINAL FORM': 64347,
'ARABIC LETTER BEHEH INITIAL FORM': 64348,
'ARABIC LETTER BEHEH ISOLATED FORM': 64346,
'ARABIC LETTER BEHEH MEDIAL FORM': 64349,
'ARABIC LETTER DAD': 1590,
'ARABIC LETTER DAD FINAL FORM': 65214,
'ARABIC LETTER DAD INITIAL FORM': 65215,
'ARABIC LETTER DAD ISOLATED FORM': 65213,
'ARABIC LETTER DAD MEDIAL FORM': 65216,
'ARABIC LETTER DAD WITH DOT BELOW': 1787,
'ARABIC LETTER DAHAL': 1676,
'ARABIC LETTER DAHAL FINAL FORM': 64389,
'ARABIC LETTER DAHAL ISOLATED FORM': 64388,
'ARABIC LETTER DAL': 1583,
'ARABIC LETTER DAL FINAL FORM': 65194,
'ARABIC LETTER DAL ISOLATED FORM': 65193,
'ARABIC LETTER DAL WITH DOT BELOW': 1674,
'ARABIC LETTER DAL WITH DOT BELOW AND SMALL TAH': 1675,
'ARABIC LETTER DAL WITH FOUR DOTS ABOVE': 1680,
'ARABIC LETTER DAL WITH INVERTED SMALL V BELOW': 1882,
'ARABIC LETTER DAL WITH INVERTED V': 1774,
'ARABIC LETTER DAL WITH RING': 1673,
'ARABIC LETTER DAL WITH THREE DOTS ABOVE DOWNWARDS': 1679,
'ARABIC LETTER DAL WITH TWO DOTS VERTICALLY BELOW AND SMALL TAH': 1881,
'ARABIC LETTER DDAHAL': 1677,
'ARABIC LETTER DDAHAL FINAL FORM': 64387,
'ARABIC LETTER DDAHAL ISOLATED FORM': 64386,
'ARABIC LETTER DDAL': 1672,
'ARABIC LETTER DDAL FINAL FORM': 64393,
'ARABIC LETTER DDAL ISOLATED FORM': 64392,
'ARABIC LETTER DOTLESS BEH': 1646,
'ARABIC LETTER DOTLESS FEH': 1697,
'ARABIC LETTER DOTLESS QAF': 1647,
'ARABIC LETTER DUL': 1678,
'ARABIC LETTER DUL FINAL FORM': 64391,
'ARABIC LETTER DUL ISOLATED FORM': 64390,
'ARABIC LETTER DYEH': 1668,
'ARABIC LETTER DYEH FINAL FORM': 64371,
'ARABIC LETTER DYEH INITIAL FORM': 64372,
'ARABIC LETTER DYEH ISOLATED FORM': 64370,
'ARABIC LETTER DYEH MEDIAL FORM': 64373,
'ARABIC LETTER E': 1744,
'ARABIC LETTER E FINAL FORM': 64485,
'ARABIC LETTER E INITIAL FORM': 64486,
'ARABIC LETTER E ISOLATED FORM': 64484,
'ARABIC LETTER E MEDIAL FORM': 64487,
'ARABIC LETTER FARSI YEH': 1740,
'ARABIC LETTER FARSI YEH FINAL FORM': 64509,
'ARABIC LETTER FARSI YEH INITIAL FORM': 64510,
'ARABIC LETTER FARSI YEH ISOLATED FORM': 64508,
'ARABIC LETTER FARSI YEH MEDIAL FORM': 64511,
'ARABIC LETTER FARSI YEH WITH EXTENDED ARABIC-INDIC DIGIT FOUR BELOW': 1911,
'ARABIC LETTER FARSI YEH WITH EXTENDED ARABIC-INDIC DIGIT THREE ABOVE': 1910,
'ARABIC LETTER FARSI YEH WITH EXTENDED ARABIC-INDIC DIGIT TWO ABOVE': 1909,
'ARABIC LETTER FARSI YEH WITH INVERTED V': 1597,
'ARABIC LETTER FARSI YEH WITH THREE DOTS ABOVE': 1599,
'ARABIC LETTER FARSI YEH WITH TWO DOTS ABOVE': 1598,
'ARABIC LETTER FEH': 1601,
'ARABIC LETTER FEH FINAL FORM': 65234,
'ARABIC LETTER FEH INITIAL FORM': 65235,
'ARABIC LETTER FEH ISOLATED FORM': 65233,
'ARABIC LETTER FEH MEDIAL FORM': 65236,
'ARABIC LETTER FEH WITH DOT BELOW': 1699,
'ARABIC LETTER FEH WITH DOT MOVED BELOW': 1698,
'ARABIC LETTER FEH WITH THREE DOTS BELOW': 1701,
'ARABIC LETTER FEH WITH THREE DOTS POINTING UPWARDS BELOW': 1889,
'ARABIC LETTER FEH WITH TWO DOTS BELOW': 1888,
'ARABIC LETTER GAF': 1711,
'ARABIC LETTER GAF FINAL FORM': 64403,
'ARABIC LETTER GAF INITIAL FORM': 64404,
'ARABIC LETTER GAF ISOLATED FORM': 64402,
'ARABIC LETTER GAF MEDIAL FORM': 64405,
'ARABIC LETTER GAF WITH RING': 1712,
'ARABIC LETTER GAF WITH THREE DOTS ABOVE': 1716,
'ARABIC LETTER GAF WITH TWO DOTS BELOW': 1714,
'ARABIC LETTER GHAIN': 1594,
'ARABIC LETTER GHAIN FINAL FORM': 65230,
'ARABIC LETTER GHAIN INITIAL FORM': 65231,
'ARABIC LETTER GHAIN ISOLATED FORM': 65229,
'ARABIC LETTER GHAIN MEDIAL FORM': 65232,
'ARABIC LETTER GHAIN WITH DOT BELOW': 1788,
'ARABIC LETTER GUEH': 1715,
'ARABIC LETTER GUEH FINAL FORM': 64407,
'ARABIC LETTER GUEH INITIAL FORM': 64408,
'ARABIC LETTER GUEH ISOLATED FORM': 64406,
'ARABIC LETTER GUEH MEDIAL FORM': 64409,
'ARABIC LETTER HAH': 1581,
'ARABIC LETTER HAH FINAL FORM': 65186,
'ARABIC LETTER HAH INITIAL FORM': 65187,
'ARABIC LETTER HAH ISOLATED FORM': 65185,
'ARABIC LETTER HAH MEDIAL FORM': 65188,
'ARABIC LETTER HAH WITH EXTENDED ARABIC-INDIC DIGIT FOUR BELOW': 1916,
'ARABIC LETTER HAH WITH HAMZA ABOVE': 1665,
'ARABIC LETTER HAH WITH SMALL ARABIC LETTER TAH ABOVE': 1906,
'ARABIC LETTER HAH WITH SMALL ARABIC LETTER TAH AND TWO DOTS': 1903,
'ARABIC LETTER HAH WITH SMALL ARABIC LETTER TAH BELOW': 1902,
'ARABIC LETTER HAH WITH THREE DOTS ABOVE': 1669,
'ARABIC LETTER HAH WITH THREE DOTS POINTING UPWARDS BELOW': 1880,
'ARABIC LETTER HAH WITH TWO DOTS ABOVE': 1879,
'ARABIC LETTER HAH WITH TWO DOTS VERTICAL ABOVE': 1666,
'ARABIC LETTER HAMZA': 1569,
'ARABIC LETTER HAMZA ISOLATED FORM': 65152,
'ARABIC LETTER HEH': 1607,
'ARABIC LETTER HEH DOACHASHMEE': 1726,
'ARABIC LETTER HEH DOACHASHMEE FINAL FORM': 64427,
'ARABIC LETTER HEH DOACHASHMEE INITIAL FORM': 64428,
'ARABIC LETTER HEH DOACHASHMEE ISOLATED FORM': 64426,
'ARABIC LETTER HEH DOACHASHMEE MEDIAL FORM': 64429,
'ARABIC LETTER HEH FINAL FORM': 65258,
'ARABIC LETTER HEH GOAL': 1729,
'ARABIC LETTER HEH GOAL FINAL FORM': 64423,
'ARABIC LETTER HEH GOAL INITIAL FORM': 64424,
'ARABIC LETTER HEH GOAL ISOLATED FORM': 64422,
'ARABIC LETTER HEH GOAL MEDIAL FORM': 64425,
'ARABIC LETTER HEH GOAL WITH HAMZA ABOVE': 1730,
'ARABIC LETTER HEH INITIAL FORM': 65259,
'ARABIC LETTER HEH ISOLATED FORM': 65257,
'ARABIC LETTER HEH MEDIAL FORM': 65260,
'ARABIC LETTER HEH WITH INVERTED V': 1791,
'ARABIC LETTER HEH WITH YEH ABOVE': 1728,
'ARABIC LETTER HEH WITH YEH ABOVE FINAL FORM': 64421,
'ARABIC LETTER HEH WITH YEH ABOVE ISOLATED FORM': 64420,
'ARABIC LETTER HIGH HAMZA': 1652,
'ARABIC LETTER HIGH HAMZA ALEF': 1653,
'ARABIC LETTER HIGH HAMZA WAW': 1654,
'ARABIC LETTER HIGH HAMZA YEH': 1656,
'ARABIC LETTER JEEM': 1580,
'ARABIC LETTER JEEM FINAL FORM': 65182,
'ARABIC LETTER JEEM INITIAL FORM': 65183,
'ARABIC LETTER JEEM ISOLATED FORM': 65181,
'ARABIC LETTER JEEM MEDIAL FORM': 65184,
'ARABIC LETTER JEH': 1688,
'ARABIC LETTER JEH FINAL FORM': 64395,
'ARABIC LETTER JEH ISOLATED FORM': 64394,
'ARABIC LETTER KAF': 1603,
'ARABIC LETTER KAF FINAL FORM': 65242,
'ARABIC LETTER KAF INITIAL FORM': 65243,
'ARABIC LETTER KAF ISOLATED FORM': 65241,
'ARABIC LETTER KAF MEDIAL FORM': 65244,
'ARABIC LETTER KAF WITH DOT ABOVE': 1708,
'ARABIC LETTER KAF WITH RING': 1707,
'ARABIC LETTER KAF WITH THREE DOTS BELOW': 1710,
'ARABIC LETTER KAF WITH TWO DOTS ABOVE': 1919,
'ARABIC LETTER KEHEH': 1705,
'ARABIC LETTER KEHEH FINAL FORM': 64399,
'ARABIC LETTER KEHEH INITIAL FORM': 64400,
'ARABIC LETTER KEHEH ISOLATED FORM': 64398,
'ARABIC LETTER KEHEH MEDIAL FORM': 64401,
'ARABIC LETTER KEHEH WITH DOT ABOVE': 1890,
'ARABIC LETTER KEHEH WITH THREE DOTS ABOVE': 1891,
'ARABIC LETTER KEHEH WITH THREE DOTS BELOW': 1596,
'ARABIC LETTER KEHEH WITH THREE DOTS POINTING UPWARDS BELOW': 1892,
'ARABIC LETTER KEHEH WITH TWO DOTS ABOVE': 1595,
'ARABIC LETTER KHAH': 1582,
'ARABIC LETTER KHAH FINAL FORM': 65190,
'ARABIC LETTER KHAH INITIAL FORM': 65191,
'ARABIC LETTER KHAH ISOLATED FORM': 65189,
'ARABIC LETTER KHAH MEDIAL FORM': 65192,
'ARABIC LETTER KIRGHIZ OE': 1733,
'ARABIC LETTER KIRGHIZ OE FINAL FORM': 64481,
'ARABIC LETTER KIRGHIZ OE ISOLATED FORM': 64480,
'ARABIC LETTER KIRGHIZ YU': 1737,
'ARABIC LETTER KIRGHIZ YU FINAL FORM': 64483,
'ARABIC LETTER KIRGHIZ YU ISOLATED FORM': 64482,
'ARABIC LETTER LAM': 1604,
'ARABIC LETTER LAM FINAL FORM': 65246,
'ARABIC LETTER LAM INITIAL FORM': 65247,
'ARABIC LETTER LAM ISOLATED FORM': 65245,
'ARABIC LETTER LAM MEDIAL FORM': 65248,
'ARABIC LETTER LAM WITH BAR': 1898,
'ARABIC LETTER LAM WITH DOT ABOVE': 1718,
'ARABIC LETTER LAM WITH SMALL V': 1717,
'ARABIC LETTER LAM WITH THREE DOTS ABOVE': 1719,
'ARABIC LETTER LAM WITH THREE DOTS BELOW': 1720,
'ARABIC LETTER MEEM': 1605,
'ARABIC LETTER MEEM FINAL FORM': 65250,
'ARABIC LETTER MEEM INITIAL FORM': 65251,
'ARABIC LETTER MEEM ISOLATED FORM': 65249,
'ARABIC LETTER MEEM MEDIAL FORM': 65252,
'ARABIC LETTER MEEM WITH DOT ABOVE': 1893,
'ARABIC LETTER MEEM WITH DOT BELOW': 1894,
'ARABIC LETTER NG': 1709,
'ARABIC LETTER NG FINAL FORM': 64468,
'ARABIC LETTER NG INITIAL FORM': 64469,
'ARABIC LETTER NG ISOLATED FORM': 64467,
'ARABIC LETTER NG MEDIAL FORM': 64470,
'ARABIC LETTER NGOEH': 1713,
'ARABIC LETTER NGOEH FINAL FORM': 64411,
'ARABIC LETTER NGOEH INITIAL FORM': 64412,
'ARABIC LETTER NGOEH ISOLATED FORM': 64410,
'ARABIC LETTER NGOEH MEDIAL FORM': 64413,
'ARABIC LETTER NOON': 1606,
'ARABIC LETTER NOON FINAL FORM': 65254,
'ARABIC LETTER NOON GHUNNA': 1722,
'ARABIC LETTER NOON GHUNNA FINAL FORM': 64415,
'ARABIC LETTER NOON GHUNNA ISOLATED FORM': 64414,
'ARABIC LETTER NOON INITIAL FORM': 65255,
'ARABIC LETTER NOON ISOLATED FORM': 65253,
'ARABIC LETTER NOON MEDIAL FORM': 65256,
'ARABIC LETTER NOON WITH DOT BELOW': 1721,
'ARABIC LETTER NOON WITH RING': 1724,
'ARABIC LETTER NOON WITH SMALL TAH': 1896,
'ARABIC LETTER NOON WITH SMALL V': 1897,
'ARABIC LETTER NOON WITH THREE DOTS ABOVE': 1725,
'ARABIC LETTER NOON WITH TWO DOTS BELOW': 1895,
'ARABIC LETTER NYEH': 1667,
'ARABIC LETTER NYEH FINAL FORM': 64375,
'ARABIC LETTER NYEH INITIAL FORM': 64376,
'ARABIC LETTER NYEH ISOLATED FORM': 64374,
'ARABIC LETTER NYEH MEDIAL FORM': 64377,
'ARABIC LETTER OE': 1734,
'ARABIC LETTER OE FINAL FORM': 64474,
'ARABIC LETTER OE ISOLATED FORM': 64473,
'ARABIC LETTER PEH': 1662,
'ARABIC LETTER PEH FINAL FORM': 64343,
'ARABIC LETTER PEH INITIAL FORM': 64344,
'ARABIC LETTER PEH ISOLATED FORM': 64342,
'ARABIC LETTER PEH MEDIAL FORM': 64345,
'ARABIC LETTER PEHEH': 1702,
'ARABIC LETTER PEHEH FINAL FORM': 64367,
'ARABIC LETTER PEHEH INITIAL FORM': 64368,
'ARABIC LETTER PEHEH ISOLATED FORM': 64366,
'ARABIC LETTER PEHEH MEDIAL FORM': 64369,
'ARABIC LETTER QAF': 1602,
'ARABIC LETTER QAF FINAL FORM': 65238,
'ARABIC LETTER QAF INITIAL FORM': 65239,
'ARABIC LETTER QAF ISOLATED FORM': 65237,
'ARABIC LETTER QAF MEDIAL FORM': 65240,
'ARABIC LETTER QAF WITH DOT ABOVE': 1703,
'ARABIC LETTER QAF WITH THREE DOTS ABOVE': 1704,
'ARABIC LETTER REH': 1585,
'ARABIC LETTER REH FINAL FORM': 65198,
'ARABIC LETTER REH ISOLATED FORM': 65197,
'ARABIC LETTER REH WITH DOT BELOW': 1684,
'ARABIC LETTER REH WITH DOT BELOW AND DOT ABOVE': 1686,
'ARABIC LETTER REH WITH FOUR DOTS ABOVE': 1689,
'ARABIC LETTER REH WITH HAMZA ABOVE': 1900,
'ARABIC LETTER REH WITH INVERTED V': 1775,
'ARABIC LETTER REH WITH RING': 1683,
'ARABIC LETTER REH WITH SMALL ARABIC LETTER TAH AND TWO DOTS': 1905,
'ARABIC LETTER REH WITH SMALL V': 1682,
'ARABIC LETTER REH WITH SMALL V BELOW': 1685,
'ARABIC LETTER REH WITH STROKE': 1883,
'ARABIC LETTER REH WITH TWO DOTS ABOVE': 1687,
'ARABIC LETTER REH WITH TWO DOTS VERTICALLY ABOVE': 1899,
'ARABIC LETTER RNOON': 1723,
'ARABIC LETTER RNOON FINAL FORM': 64417,
'ARABIC LETTER RNOON INITIAL FORM': 64418,
'ARABIC LETTER RNOON ISOLATED FORM': 64416,
'ARABIC LETTER RNOON MEDIAL FORM': 64419,
'ARABIC LETTER RREH': 1681,
'ARABIC LETTER RREH FINAL FORM': 64397,
'ARABIC LETTER RREH ISOLATED FORM': 64396,
'ARABIC LETTER SAD': 1589,
'ARABIC LETTER SAD FINAL FORM': 65210,
'ARABIC LETTER SAD INITIAL FORM': 65211,
'ARABIC LETTER SAD ISOLATED FORM': 65209,
'ARABIC LETTER SAD MEDIAL FORM': 65212,
'ARABIC LETTER SAD WITH THREE DOTS ABOVE': 1694,
'ARABIC LETTER SAD WITH TWO DOTS BELOW': 1693,
'ARABIC LETTER SEEN': 1587,
'ARABIC LETTER SEEN FINAL FORM': 65202,
'ARABIC LETTER SEEN INITIAL FORM': 65203,
'ARABIC LETTER SEEN ISOLATED FORM': 65201,
'ARABIC LETTER SEEN MEDIAL FORM': 65204,
'ARABIC LETTER SEEN WITH DOT BELOW AND DOT ABOVE': 1690,
'ARABIC LETTER SEEN WITH EXTENDED ARABIC-INDIC DIGIT FOUR ABOVE': 1917,
'ARABIC LETTER SEEN WITH FOUR DOTS ABOVE': 1884,
'ARABIC LETTER SEEN WITH INVERTED V': 1918,
'ARABIC LETTER SEEN WITH SMALL ARABIC LETTER TAH AND TWO DOTS': 1904,
'ARABIC LETTER SEEN WITH THREE DOTS BELOW': 1691,
'ARABIC LETTER SEEN WITH THREE DOTS BELOW AND THREE DOTS ABOVE': 1692,
'ARABIC LETTER SEEN WITH TWO DOTS VERTICALLY ABOVE': 1901,
'ARABIC LETTER SHEEN': 1588,
'ARABIC LETTER SHEEN FINAL FORM': 65206,
'ARABIC LETTER SHEEN INITIAL FORM': 65207,
'ARABIC LETTER SHEEN ISOLATED FORM': 65205,
'ARABIC LETTER SHEEN MEDIAL FORM': 65208,
'ARABIC LETTER SHEEN WITH DOT BELOW': 1786,
'ARABIC LETTER SUPERSCRIPT ALEF': 1648,
'ARABIC LETTER SWASH KAF': 1706,
'ARABIC LETTER TAH': 1591,
'ARABIC LETTER TAH FINAL FORM': 65218,
'ARABIC LETTER TAH INITIAL FORM': 65219,
'ARABIC LETTER TAH ISOLATED FORM': 65217,
'ARABIC LETTER TAH MEDIAL FORM': 65220,
'ARABIC LETTER TAH WITH THREE DOTS ABOVE': 1695,
'ARABIC LETTER TCHEH': 1670,
'ARABIC LETTER TCHEH FINAL FORM': 64379,
'ARABIC LETTER TCHEH INITIAL FORM': 64380,
'ARABIC LETTER TCHEH ISOLATED FORM': 64378,
'ARABIC LETTER TCHEH MEDIAL FORM': 64381,
'ARABIC LETTER TCHEH WITH DOT ABOVE': 1727,
'ARABIC LETTER TCHEHEH': 1671,
'ARABIC LETTER TCHEHEH FINAL FORM': 64383,
'ARABIC LETTER TCHEHEH INITIAL FORM': 64384,
'ARABIC LETTER TCHEHEH ISOLATED FORM': 64382,
'ARABIC LETTER TCHEHEH MEDIAL FORM': 64385,
'ARABIC LETTER TEH': 1578,
'ARABIC LETTER TEH FINAL FORM': 65174,
'ARABIC LETTER TEH INITIAL FORM': 65175,
'ARABIC LETTER TEH ISOLATED FORM': 65173,
'ARABIC LETTER TEH MARBUTA': 1577,
'ARABIC LETTER TEH MARBUTA FINAL FORM': 65172,
'ARABIC LETTER TEH MARBUTA GOAL': 1731,
'ARABIC LETTER TEH MARBUTA ISOLATED FORM': 65171,
'ARABIC LETTER TEH MEDIAL FORM': 65176,
'ARABIC LETTER TEH WITH RING': 1660,
'ARABIC LETTER TEH WITH THREE DOTS ABOVE DOWNWARDS': 1661,
'ARABIC LETTER TEHEH': 1663,
'ARABIC LETTER TEHEH FINAL FORM': 64355,
'ARABIC LETTER TEHEH INITIAL FORM': 64356,
'ARABIC LETTER TEHEH ISOLATED FORM': 64354,
'ARABIC LETTER TEHEH MEDIAL FORM': 64357,
'ARABIC LETTER THAL': 1584,
'ARABIC LETTER THAL FINAL FORM': 65196,
'ARABIC LETTER THAL ISOLATED FORM': 65195,
'ARABIC LETTER THEH': 1579,
'ARABIC LETTER THEH FINAL FORM': 65178,
'ARABIC LETTER THEH INITIAL FORM': 65179,
'ARABIC LETTER THEH ISOLATED FORM': 65177,
'ARABIC LETTER THEH MEDIAL FORM': 65180,
'ARABIC LETTER TTEH': 1657,
'ARABIC LETTER TTEH FINAL FORM': 64359,
'ARABIC LETTER TTEH INITIAL FORM': 64360,
'ARABIC LETTER TTEH ISOLATED FORM': 64358,
'ARABIC LETTER TTEH MEDIAL FORM': 64361,
'ARABIC LETTER TTEHEH': 1658,
'ARABIC LETTER TTEHEH FINAL FORM': 64351,
'ARABIC LETTER TTEHEH INITIAL FORM': 64352,
'ARABIC LETTER TTEHEH ISOLATED FORM': 64350,
'ARABIC LETTER TTEHEH MEDIAL FORM': 64353,
'ARABIC LETTER U': 1735,
'ARABIC LETTER U FINAL FORM': 64472,
'ARABIC LETTER U ISOLATED FORM': 64471,
'ARABIC LETTER U WITH HAMZA ABOVE': 1655,
'ARABIC LETTER U WITH HAMZA ABOVE ISOLATED FORM': 64477,
'ARABIC LETTER UIGHUR KAZAKH KIRGHIZ ALEF MAKSURA INITIAL FORM': 64488,
'ARABIC LETTER UIGHUR KAZAKH KIRGHIZ ALEF MAKSURA MEDIAL FORM': 64489,
'ARABIC LETTER VE': 1739,
'ARABIC LETTER VE FINAL FORM': 64479,
'ARABIC LETTER VE ISOLATED FORM': 64478,
'ARABIC LETTER VEH': 1700,
'ARABIC LETTER VEH FINAL FORM': 64363,
'ARABIC LETTER VEH INITIAL FORM': 64364,
'ARABIC LETTER VEH ISOLATED FORM': 64362,
'ARABIC LETTER VEH MEDIAL FORM': 64365,
'ARABIC LETTER WAW': 1608,
'ARABIC LETTER WAW FINAL FORM': 65262,
'ARABIC LETTER WAW ISOLATED FORM': 65261,
'ARABIC LETTER WAW WITH DOT ABOVE': 1743,
'ARABIC LETTER WAW WITH EXTENDED ARABIC-INDIC DIGIT THREE ABOVE': 1913,
'ARABIC LETTER WAW WITH EXTENDED ARABIC-INDIC DIGIT TWO ABOVE': 1912,
'ARABIC LETTER WAW WITH HAMZA ABOVE': 1572,
'ARABIC LETTER WAW WITH HAMZA ABOVE FINAL FORM': 65158,
'ARABIC LETTER WAW WITH HAMZA ABOVE ISOLATED FORM': 65157,
'ARABIC LETTER WAW WITH RING': 1732,
'ARABIC LETTER WAW WITH TWO DOTS ABOVE': 1738,
'ARABIC LETTER YEH': 1610,
'ARABIC LETTER YEH BARREE': 1746,
'ARABIC LETTER YEH BARREE FINAL FORM': 64431,
'ARABIC LETTER YEH BARREE ISOLATED FORM': 64430,
'ARABIC LETTER YEH BARREE WITH EXTENDED ARABIC-INDIC DIGIT THREE ABOVE': 1915,
'ARABIC LETTER YEH BARREE WITH EXTENDED ARABIC-INDIC DIGIT TWO ABOVE': 1914,
'ARABIC LETTER YEH BARREE WITH HAMZA ABOVE': 1747,
'ARABIC LETTER YEH BARREE WITH HAMZA ABOVE FINAL FORM': 64433,
'ARABIC LETTER YEH BARREE WITH HAMZA ABOVE ISOLATED FORM': 64432,
'ARABIC LETTER YEH FINAL FORM': 65266,
'ARABIC LETTER YEH INITIAL FORM': 65267,
'ARABIC LETTER YEH ISOLATED FORM': 65265,
'ARABIC LETTER YEH MEDIAL FORM': 65268,
'ARABIC LETTER YEH WITH HAMZA ABOVE': 1574,
'ARABIC LETTER YEH WITH HAMZA ABOVE FINAL FORM': 65162,
'ARABIC LETTER YEH WITH HAMZA ABOVE INITIAL FORM': 65163,
'ARABIC LETTER YEH WITH HAMZA ABOVE ISOLATED FORM': 65161,
'ARABIC LETTER YEH WITH HAMZA ABOVE MEDIAL FORM': 65164,
'ARABIC LETTER YEH WITH SMALL V': 1742,
'ARABIC LETTER YEH WITH TAIL': 1741,
'ARABIC LETTER YEH WITH THREE DOTS BELOW': 1745,
'ARABIC LETTER YU': 1736,
'ARABIC LETTER YU FINAL FORM': 64476,
'ARABIC LETTER YU ISOLATED FORM': 64475,
'ARABIC LETTER ZAH': 1592,
'ARABIC LETTER ZAH FINAL FORM': 65222,
'ARABIC LETTER ZAH INITIAL FORM': 65223,
'ARABIC LETTER ZAH ISOLATED FORM': 65221,
'ARABIC LETTER ZAH MEDIAL FORM': 65224,
'ARABIC LETTER ZAIN': 1586,
'ARABIC LETTER ZAIN FINAL FORM': 65200,
'ARABIC LETTER ZAIN ISOLATED FORM': 65199,
'ARABIC LIGATURE AIN WITH ALEF MAKSURA FINAL FORM': 64787,
'ARABIC LIGATURE AIN WITH ALEF MAKSURA ISOLATED FORM': 64759,
'ARABIC LIGATURE AIN WITH JEEM INITIAL FORM': 64698,
'ARABIC LIGATURE AIN WITH JEEM ISOLATED FORM': 64553,
'ARABIC LIGATURE AIN WITH JEEM WITH MEEM FINAL FORM': 64885,
'ARABIC LIGATURE AIN WITH JEEM WITH MEEM INITIAL FORM': 64964,
'ARABIC LIGATURE AIN WITH MEEM INITIAL FORM': 64699,
'ARABIC LIGATURE AIN WITH MEEM ISOLATED FORM': 64554,
'ARABIC LIGATURE AIN WITH MEEM WITH ALEF MAKSURA FINAL FORM': 64888,
'ARABIC LIGATURE AIN WITH MEEM WITH MEEM FINAL FORM': 64886,
'ARABIC LIGATURE AIN WITH MEEM WITH MEEM INITIAL FORM': 64887,
'ARABIC LIGATURE AIN WITH MEEM WITH YEH FINAL FORM': 64950,
'ARABIC LIGATURE AIN WITH YEH FINAL FORM': 64788,
'ARABIC LIGATURE AIN WITH YEH ISOLATED FORM': 64760,
'ARABIC LIGATURE AKBAR ISOLATED FORM': 65011,
'ARABIC LIGATURE ALAYHE ISOLATED FORM': 65015,
'ARABIC LIGATURE ALEF MAKSURA WITH SUPERSCRIPT ALEF FINAL FORM': 64656,
'ARABIC LIGATURE ALEF MAKSURA WITH SUPERSCRIPT ALEF ISOLATED FORM': 64605,
'ARABIC LIGATURE ALEF WITH FATHATAN FINAL FORM': 64828,
'ARABIC LIGATURE ALEF WITH FATHATAN ISOLATED FORM': 64829,
'ARABIC LIGATURE ALLAH ISOLATED FORM': 65010,
'ARABIC LIGATURE BEH WITH ALEF MAKSURA FINAL FORM': 64622,
'ARABIC LIGATURE BEH WITH ALEF MAKSURA ISOLATED FORM': 64521,
'ARABIC LIGATURE BEH WITH HAH INITIAL FORM': 64669,
'ARABIC LIGATURE BEH WITH HAH ISOLATED FORM': 64518,
'ARABIC LIGATURE BEH WITH HAH WITH YEH FINAL FORM': 64962,
'ARABIC LIGATURE BEH WITH HEH INITIAL FORM': 64672,
'ARABIC LIGATURE BEH WITH HEH MEDIAL FORM': 64738,
'ARABIC LIGATURE BEH WITH JEEM INITIAL FORM': 64668,
'ARABIC LIGATURE BEH WITH JEEM ISOLATED FORM': 64517,
'ARABIC LIGATURE BEH WITH KHAH INITIAL FORM': 64670,
'ARABIC LIGATURE BEH WITH KHAH ISOLATED FORM': 64519,
'ARABIC LIGATURE BEH WITH KHAH WITH YEH FINAL FORM': 64926,
'ARABIC LIGATURE BEH WITH MEEM FINAL FORM': 64620,
'ARABIC LIGATURE BEH WITH MEEM INITIAL FORM': 64671,
'ARABIC LIGATURE BEH WITH MEEM ISOLATED FORM': 64520,
'ARABIC LIGATURE BEH WITH MEEM MEDIAL FORM': 64737,
'ARABIC LIGATURE BEH WITH NOON FINAL FORM': 64621,
'ARABIC LIGATURE BEH WITH REH FINAL FORM': 64618,
'ARABIC LIGATURE BEH WITH YEH FINAL FORM': 64623,
'ARABIC LIGATURE BEH WITH YEH ISOLATED FORM': 64522,
'ARABIC LIGATURE BEH WITH ZAIN FINAL FORM': 64619,
'ARABIC LIGATURE BISMILLAH AR-RAHMAN AR-RAHEEM': 65021,
'ARABIC LIGATURE DAD WITH ALEF MAKSURA FINAL FORM': 64803,
'ARABIC LIGATURE DAD WITH ALEF MAKSURA ISOLATED FORM': 64775,
'ARABIC LIGATURE DAD WITH HAH INITIAL FORM': 64693,
'ARABIC LIGATURE DAD WITH HAH ISOLATED FORM': 64547,
'ARABIC LIGATURE DAD WITH HAH WITH ALEF MAKSURA FINAL FORM': 64878,
'ARABIC LIGATURE DAD WITH HAH WITH YEH FINAL FORM': 64939,
'ARABIC LIGATURE DAD WITH JEEM INITIAL FORM': 64692,
'ARABIC LIGATURE DAD WITH JEEM ISOLATED FORM': 64546,
'ARABIC LIGATURE DAD WITH KHAH INITIAL FORM': 64694,
'ARABIC LIGATURE DAD WITH KHAH ISOLATED FORM': 64548,
'ARABIC LIGATURE DAD WITH KHAH WITH MEEM FINAL FORM': 64879,
'ARABIC LIGATURE DAD WITH KHAH WITH MEEM INITIAL FORM': 64880,
'ARABIC LIGATURE DAD WITH MEEM INITIAL FORM': 64695,
'ARABIC LIGATURE DAD WITH MEEM ISOLATED FORM': 64549,
'ARABIC LIGATURE DAD WITH REH FINAL FORM': 64812,
'ARABIC LIGATURE DAD WITH REH ISOLATED FORM': 64784,
'ARABIC LIGATURE DAD WITH YEH FINAL FORM': 64804,
'ARABIC LIGATURE DAD WITH YEH ISOLATED FORM': 64776,
'ARABIC LIGATURE FEH WITH ALEF MAKSURA FINAL FORM': 64636,
'ARABIC LIGATURE FEH WITH ALEF MAKSURA ISOLATED FORM': 64561,
'ARABIC LIGATURE FEH WITH HAH INITIAL FORM': 64703,
'ARABIC LIGATURE FEH WITH HAH ISOLATED FORM': 64558,
'ARABIC LIGATURE FEH WITH JEEM INITIAL FORM': 64702,
'ARABIC LIGATURE FEH WITH JEEM ISOLATED FORM': 64557,
'ARABIC LIGATURE FEH WITH KHAH INITIAL FORM': 64704,
'ARABIC LIGATURE FEH WITH KHAH ISOLATED FORM': 64559,
'ARABIC LIGATURE FEH WITH KHAH WITH MEEM FINAL FORM': 64892,
'ARABIC LIGATURE FEH WITH KHAH WITH MEEM INITIAL FORM': 64893,
'ARABIC LIGATURE FEH WITH MEEM INITIAL FORM': 64705,
'ARABIC LIGATURE FEH WITH MEEM ISOLATED FORM': 64560,
'ARABIC LIGATURE FEH WITH MEEM WITH YEH FINAL FORM': 64961,
'ARABIC LIGATURE FEH WITH YEH FINAL FORM': 64637,
'ARABIC LIGATURE FEH WITH YEH ISOLATED FORM': 64562,
'ARABIC LIGATURE GHAIN WITH ALEF MAKSURA FINAL FORM': 64789,
'ARABIC LIGATURE GHAIN WITH ALEF MAKSURA ISOLATED FORM': 64761,
'ARABIC LIGATURE GHAIN WITH JEEM INITIAL FORM': 64700,
'ARABIC LIGATURE GHAIN WITH JEEM ISOLATED FORM': 64555,
'ARABIC LIGATURE GHAIN WITH MEEM INITIAL FORM': 64701,
'ARABIC LIGATURE GHAIN WITH MEEM ISOLATED FORM': 64556,
'ARABIC LIGATURE GHAIN WITH MEEM WITH ALEF MAKSURA FINAL FORM': 64891,
'ARABIC LIGATURE GHAIN WITH MEEM WITH MEEM FINAL FORM': 64889,
'ARABIC LIGATURE GHAIN WITH MEEM WITH YEH FINAL FORM': 64890,
'ARABIC LIGATURE GHAIN WITH YEH FINAL FORM': 64790,
'ARABIC LIGATURE GHAIN WITH YEH ISOLATED FORM': 64762,
'ARABIC LIGATURE HAH WITH ALEF MAKSURA FINAL FORM': 64795,
'ARABIC LIGATURE HAH WITH ALEF MAKSURA ISOLATED FORM': 64767,
'ARABIC LIGATURE HAH WITH JEEM INITIAL FORM': 64681,
'ARABIC LIGATURE HAH WITH JEEM ISOLATED FORM': 64535,
'ARABIC LIGATURE HAH WITH JEEM WITH YEH FINAL FORM': 64959,
'ARABIC LIGATURE HAH WITH MEEM INITIAL FORM': 64682,
'ARABIC LIGATURE HAH WITH MEEM ISOLATED FORM': 64536,
'ARABIC LIGATURE HAH WITH MEEM WITH ALEF MAKSURA FINAL FORM': 64859,
'ARABIC LIGATURE HAH WITH MEEM WITH YEH FINAL FORM': 64858,
'ARABIC LIGATURE HAH WITH YEH FINAL FORM': 64796,
'ARABIC LIGATURE HAH WITH YEH ISOLATED FORM': 64768,
'ARABIC LIGATURE HEH WITH ALEF MAKSURA ISOLATED FORM': 64595,
'ARABIC LIGATURE HEH WITH JEEM INITIAL FORM': 64727,
'ARABIC LIGATURE HEH WITH JEEM ISOLATED FORM': 64593,
'ARABIC LIGATURE HEH WITH MEEM INITIAL FORM': 64728,
'ARABIC LIGATURE HEH WITH MEEM ISOLATED FORM': 64594,
'ARABIC LIGATURE HEH WITH MEEM WITH JEEM INITIAL FORM': 64915,
'ARABIC LIGATURE HEH WITH MEEM WITH MEEM INITIAL FORM': 64916,
'ARABIC LIGATURE HEH WITH SUPERSCRIPT ALEF INITIAL FORM': 64729,
'ARABIC LIGATURE HEH WITH YEH ISOLATED FORM': 64596,
'ARABIC LIGATURE JALLAJALALOUHOU': 65019,
'ARABIC LIGATURE JEEM WITH ALEF MAKSURA FINAL FORM': 64797,
'ARABIC LIGATURE JEEM WITH ALEF MAKSURA ISOLATED FORM': 64769,
'ARABIC LIGATURE JEEM WITH HAH INITIAL FORM': 64679,
'ARABIC LIGATURE JEEM WITH HAH ISOLATED FORM': 64533,
'ARABIC LIGATURE JEEM WITH HAH WITH ALEF MAKSURA FINAL FORM': 64934,
'ARABIC LIGATURE JEEM WITH HAH WITH YEH FINAL FORM': 64958,
'ARABIC LIGATURE JEEM WITH MEEM INITIAL FORM': 64680,
'ARABIC LIGATURE JEEM WITH MEEM ISOLATED FORM': 64534,
'ARABIC LIGATURE JEEM WITH MEEM WITH ALEF MAKSURA FINAL FORM': 64935,
'ARABIC LIGATURE JEEM WITH MEEM WITH HAH FINAL FORM': 64856,
'ARABIC LIGATURE JEEM WITH MEEM WITH HAH INITIAL FORM': 64857,
'ARABIC LIGATURE JEEM WITH MEEM WITH YEH FINAL FORM': 64933,
'ARABIC LIGATURE JEEM WITH YEH FINAL FORM': 64798,
'ARABIC LIGATURE JEEM WITH YEH ISOLATED FORM': 64770,
'ARABIC LIGATURE KAF WITH ALEF FINAL FORM': 64640,
'ARABIC LIGATURE KAF WITH ALEF ISOLATED FORM': 64567,
'ARABIC LIGATURE KAF WITH ALEF MAKSURA FINAL FORM': 64643,
'ARABIC LIGATURE KAF WITH ALEF MAKSURA ISOLATED FORM': 64573,
'ARABIC LIGATURE KAF WITH HAH INITIAL FORM': 64709,
'ARABIC LIGATURE KAF WITH HAH ISOLATED FORM': 64569,
'ARABIC LIGATURE KAF WITH JEEM INITIAL FORM': 64708,
'ARABIC LIGATURE KAF WITH JEEM ISOLATED FORM': 64568,
'ARABIC LIGATURE KAF WITH KHAH INITIAL FORM': 64710,
'ARABIC LIGATURE KAF WITH KHAH ISOLATED FORM': 64570,
'ARABIC LIGATURE KAF WITH LAM FINAL FORM': 64641,
'ARABIC LIGATURE KAF WITH LAM INITIAL FORM': 64711,
'ARABIC LIGATURE KAF WITH LAM ISOLATED FORM': 64571,
'ARABIC LIGATURE KAF WITH LAM MEDIAL FORM': 64747,
'ARABIC LIGATURE KAF WITH MEEM FINAL FORM': 64642,
'ARABIC LIGATURE KAF WITH MEEM INITIAL FORM': 64712,
'ARABIC LIGATURE KAF WITH MEEM ISOLATED FORM': 64572,
'ARABIC LIGATURE KAF WITH MEEM MEDIAL FORM': 64748,
'ARABIC LIGATURE KAF WITH MEEM WITH MEEM FINAL FORM': 64955,
'ARABIC LIGATURE KAF WITH MEEM WITH MEEM INITIAL FORM': 64963,
'ARABIC LIGATURE KAF WITH MEEM WITH YEH FINAL FORM': 64951,
'ARABIC LIGATURE KAF WITH YEH FINAL FORM': 64644,
'ARABIC LIGATURE KAF WITH YEH ISOLATED FORM': 64574,
'ARABIC LIGATURE KHAH WITH ALEF MAKSURA FINAL FORM': 64799,
'ARABIC LIGATURE KHAH WITH ALEF MAKSURA ISOLATED FORM': 64771,
'ARABIC LIGATURE KHAH WITH HAH ISOLATED FORM': 64538,
'ARABIC LIGATURE KHAH WITH JEEM INITIAL FORM': 64683,
'ARABIC LIGATURE KHAH WITH JEEM ISOLATED FORM': 64537,
'ARABIC LIGATURE KHAH WITH MEEM INITIAL FORM': 64684,
'ARABIC LIGATURE KHAH WITH MEEM ISOLATED FORM': 64539,
'ARABIC LIGATURE KHAH WITH YEH FINAL FORM': 64800,
'ARABIC LIGATURE KHAH WITH YEH ISOLATED FORM': 64772,
'ARABIC LIGATURE LAM WITH ALEF FINAL FORM': 65276,
'ARABIC LIGATURE LAM WITH ALEF ISOLATED FORM': 65275,
'ARABIC LIGATURE LAM WITH ALEF MAKSURA FINAL FORM': 64646,
'ARABIC LIGATURE LAM WITH ALEF MAKSURA ISOLATED FORM': 64579,
'ARABIC LIGATURE LAM WITH ALEF WITH HAMZA ABOVE FINAL FORM': 65272,
'ARABIC LIGATURE LAM WITH ALEF WITH HAMZA ABOVE ISOLATED FORM': 65271,
'ARABIC LIGATURE LAM WITH ALEF WITH HAMZA BELOW FINAL FORM': 65274,
'ARABIC LIGATURE LAM WITH ALEF WITH HAMZA BELOW ISOLATED FORM': 65273,
'ARABIC LIGATURE LAM WITH ALEF WITH MADDA ABOVE FINAL FORM': 65270,
'ARABIC LIGATURE LAM WITH ALEF WITH MADDA ABOVE ISOLATED FORM': 65269,
'ARABIC LIGATURE LAM WITH HAH INITIAL FORM': 64714,
'ARABIC LIGATURE LAM WITH HAH ISOLATED FORM': 64576,
'ARABIC LIGATURE LAM WITH HAH WITH ALEF MAKSURA FINAL FORM': 64898,
'ARABIC LIGATURE LAM WITH HAH WITH MEEM FINAL FORM': 64896,
'ARABIC LIGATURE LAM WITH HAH WITH MEEM INITIAL FORM': 64949,
'ARABIC LIGATURE LAM WITH HAH WITH YEH FINAL FORM': 64897,
'ARABIC LIGATURE LAM WITH HEH INITIAL FORM': 64717,
'ARABIC LIGATURE LAM WITH JEEM INITIAL FORM': 64713,
'ARABIC LIGATURE LAM WITH JEEM ISOLATED FORM': 64575,
'ARABIC LIGATURE LAM WITH JEEM WITH JEEM FINAL FORM': 64900,
'ARABIC LIGATURE LAM WITH JEEM WITH JEEM INITIAL FORM': 64899,
'ARABIC LIGATURE LAM WITH JEEM WITH MEEM FINAL FORM': 64956,
'ARABIC LIGATURE LAM WITH JEEM WITH MEEM INITIAL FORM': 64954,
'ARABIC LIGATURE LAM WITH JEEM WITH YEH FINAL FORM': 64940,
'ARABIC LIGATURE LAM WITH KHAH INITIAL FORM': 64715,
'ARABIC LIGATURE LAM WITH KHAH ISOLATED FORM': 64577,
'ARABIC LIGATURE LAM WITH KHAH WITH MEEM FINAL FORM': 64901,
'ARABIC LIGATURE LAM WITH KHAH WITH MEEM INITIAL FORM': 64902,
'ARABIC LIGATURE LAM WITH MEEM FINAL FORM': 64645,
'ARABIC LIGATURE LAM WITH MEEM INITIAL FORM': 64716,
'ARABIC LIGATURE LAM WITH MEEM ISOLATED FORM': 64578,
'ARABIC LIGATURE LAM WITH MEEM MEDIAL FORM': 64749,
'ARABIC LIGATURE LAM WITH MEEM WITH HAH FINAL FORM': 64903,
'ARABIC LIGATURE LAM WITH MEEM WITH HAH INITIAL FORM': 64904,
'ARABIC LIGATURE LAM WITH MEEM WITH YEH FINAL FORM': 64941,
'ARABIC LIGATURE LAM WITH YEH FINAL FORM': 64647,
'ARABIC LIGATURE LAM WITH YEH ISOLATED FORM': 64580,
'ARABIC LIGATURE MEEM WITH ALEF FINAL FORM': 64648,
'ARABIC LIGATURE MEEM WITH ALEF MAKSURA ISOLATED FORM': 64585,
'ARABIC LIGATURE MEEM WITH HAH INITIAL FORM': 64719,
'ARABIC LIGATURE MEEM WITH HAH ISOLATED FORM': 64582,
'ARABIC LIGATURE MEEM WITH HAH WITH JEEM INITIAL FORM': 64905,
'ARABIC LIGATURE MEEM WITH HAH WITH MEEM INITIAL FORM': 64906,
'ARABIC LIGATURE MEEM WITH HAH WITH YEH FINAL FORM': 64907,
'ARABIC LIGATURE MEEM WITH JEEM INITIAL FORM': 64718,
'ARABIC LIGATURE MEEM WITH JEEM ISOLATED FORM': 64581,
'ARABIC LIGATURE MEEM WITH JEEM WITH HAH INITIAL FORM': 64908,
'ARABIC LIGATURE MEEM WITH JEEM WITH KHAH INITIAL FORM': 64914,
'ARABIC LIGATURE MEEM WITH JEEM WITH MEEM INITIAL FORM': 64909,
'ARABIC LIGATURE MEEM WITH JEEM WITH YEH FINAL FORM': 64960,
'ARABIC LIGATURE MEEM WITH KHAH INITIAL FORM': 64720,
'ARABIC LIGATURE MEEM WITH KHAH ISOLATED FORM': 64583,
'ARABIC LIGATURE MEEM WITH KHAH WITH JEEM INITIAL FORM': 64910,
'ARABIC LIGATURE MEEM WITH KHAH WITH MEEM INITIAL FORM': 64911,
'ARABIC LIGATURE MEEM WITH KHAH WITH YEH FINAL FORM': 64953,
'ARABIC LIGATURE MEEM WITH MEEM FINAL FORM': 64649,
'ARABIC LIGATURE MEEM WITH MEEM INITIAL FORM': 64721,
'ARABIC LIGATURE MEEM WITH MEEM ISOLATED FORM': 64584,
'ARABIC LIGATURE MEEM WITH MEEM WITH YEH FINAL FORM': 64945,
'ARABIC LIGATURE MEEM WITH YEH ISOLATED FORM': 64586,
'ARABIC LIGATURE MOHAMMAD ISOLATED FORM': 65012,
'ARABIC LIGATURE NOON WITH ALEF MAKSURA FINAL FORM': 64654,
'ARABIC LIGATURE NOON WITH ALEF MAKSURA ISOLATED FORM': 64591,
'ARABIC LIGATURE NOON WITH HAH INITIAL FORM': 64723,
'ARABIC LIGATURE NOON WITH HAH ISOLATED FORM': 64588,
'ARABIC LIGATURE NOON WITH HAH WITH ALEF MAKSURA FINAL FORM': 64918,
'ARABIC LIGATURE NOON WITH HAH WITH MEEM INITIAL FORM': 64917,
'ARABIC LIGATURE NOON WITH HAH WITH YEH FINAL FORM': 64947,
'ARABIC LIGATURE NOON WITH HEH INITIAL FORM': 64726,
'ARABIC LIGATURE NOON WITH HEH MEDIAL FORM': 64751,
'ARABIC LIGATURE NOON WITH JEEM INITIAL FORM': 64722,
'ARABIC LIGATURE NOON WITH JEEM ISOLATED FORM': 64587,
'ARABIC LIGATURE NOON WITH JEEM WITH ALEF MAKSURA FINAL FORM': 64921,
'ARABIC LIGATURE NOON WITH JEEM WITH HAH FINAL FORM': 64957,
'ARABIC LIGATURE NOON WITH JEEM WITH HAH INITIAL FORM': 64952,
'ARABIC LIGATURE NOON WITH JEEM WITH MEEM FINAL FORM': 64919,
'ARABIC LIGATURE NOON WITH JEEM WITH MEEM INITIAL FORM': 64920,
'ARABIC LIGATURE NOON WITH JEEM WITH YEH FINAL FORM': 64967,
'ARABIC LIGATURE NOON WITH KHAH INITIAL FORM': 64724,
'ARABIC LIGATURE NOON WITH KHAH ISOLATED FORM': 64589,
'ARABIC LIGATURE NOON WITH MEEM FINAL FORM': 64652,
'ARABIC LIGATURE NOON WITH MEEM INITIAL FORM': 64725,
'ARABIC LIGATURE NOON WITH MEEM ISOLATED FORM': 64590,
'ARABIC LIGATURE NOON WITH MEEM MEDIAL FORM': 64750,
'ARABIC LIGATURE NOON WITH MEEM WITH ALEF MAKSURA FINAL FORM': 64923,
'ARABIC LIGATURE NOON WITH MEEM WITH YEH FINAL FORM': 64922,
'ARABIC LIGATURE NOON WITH NOON FINAL FORM': 64653,
'ARABIC LIGATURE NOON WITH REH FINAL FORM': 64650,
'ARABIC LIGATURE NOON WITH YEH FINAL FORM': 64655,
'ARABIC LIGATURE NOON WITH YEH ISOLATED FORM': 64592,
'ARABIC LIGATURE NOON WITH ZAIN FINAL FORM': 64651,
'ARABIC LIGATURE QAF WITH ALEF MAKSURA FINAL FORM': 64638,
'ARABIC LIGATURE QAF WITH ALEF MAKSURA ISOLATED FORM': 64565,
'ARABIC LIGATURE QAF WITH HAH INITIAL FORM': 64706,
'ARABIC LIGATURE QAF WITH HAH ISOLATED FORM': 64563,
'ARABIC LIGATURE QAF WITH MEEM INITIAL FORM': 64707,
'ARABIC LIGATURE QAF WITH MEEM ISOLATED FORM': 64564,
'ARABIC LIGATURE QAF WITH MEEM WITH HAH FINAL FORM': 64894,
'ARABIC LIGATURE QAF WITH MEEM WITH HAH INITIAL FORM': 64948,
'ARABIC LIGATURE QAF WITH MEEM WITH MEEM FINAL FORM': 64895,
'ARABIC LIGATURE QAF WITH MEEM WITH YEH FINAL FORM': 64946,
'ARABIC LIGATURE QAF WITH YEH FINAL FORM': 64639,
'ARABIC LIGATURE QAF WITH YEH ISOLATED FORM': 64566,
'ARABIC LIGATURE QALA USED AS KORANIC STOP SIGN ISOLATED FORM': 65009,
'ARABIC LIGATURE RASOUL ISOLATED FORM': 65014,
'ARABIC LIGATURE REH WITH SUPERSCRIPT ALEF ISOLATED FORM': 64604,
'ARABIC LIGATURE SAD WITH ALEF MAKSURA FINAL FORM': 64801,
'ARABIC LIGATURE SAD WITH ALEF MAKSURA ISOLATED FORM': 64773,
'ARABIC LIGATURE SAD WITH HAH INITIAL FORM': 64689,
'ARABIC LIGATURE SAD WITH HAH ISOLATED FORM': 64544,
'ARABIC LIGATURE SAD WITH HAH WITH HAH FINAL FORM': 64868,
'ARABIC LIGATURE SAD WITH HAH WITH HAH INITIAL FORM': 64869,
'ARABIC LIGATURE SAD WITH HAH WITH YEH FINAL FORM': 64937,
'ARABIC LIGATURE SAD WITH KHAH INITIAL FORM': 64690,
'ARABIC LIGATURE SAD WITH MEEM INITIAL FORM': 64691,
'ARABIC LIGATURE SAD WITH MEEM ISOLATED FORM': 64545,
'ARABIC LIGATURE SAD WITH MEEM WITH MEEM FINAL FORM': 64870,
'ARABIC LIGATURE SAD WITH MEEM WITH MEEM INITIAL FORM': 64965,
'ARABIC LIGATURE SAD WITH REH FINAL FORM': 64811,
'ARABIC LIGATURE SAD WITH REH ISOLATED FORM': 64783,
'ARABIC LIGATURE SAD WITH YEH FINAL FORM': 64802,
'ARABIC LIGATURE SAD WITH YEH ISOLATED FORM': 64774,
'ARABIC LIGATURE SALAM ISOLATED FORM': 65013,
'ARABIC LIGATURE SALLA ISOLATED FORM': 65017,
'ARABIC LIGATURE SALLA USED AS KORANIC STOP SIGN ISOLATED FORM': 65008,
'ARABIC LIGATURE SALLALLAHOU ALAYHE WASALLAM': 65018,
'ARABIC LIGATURE SEEN WITH ALEF MAKSURA FINAL FORM': 64791,
'ARABIC LIGATURE SEEN WITH ALEF MAKSURA ISOLATED FORM': 64763,
'ARABIC LIGATURE SEEN WITH HAH INITIAL FORM': 64686,
'ARABIC LIGATURE SEEN WITH HAH ISOLATED FORM': 64541,
'ARABIC LIGATURE SEEN WITH HAH MEDIAL FORM': 64821,
'ARABIC LIGATURE SEEN WITH HAH WITH JEEM INITIAL FORM': 64860,
'ARABIC LIGATURE SEEN WITH HEH INITIAL FORM': 64817,
'ARABIC LIGATURE SEEN WITH HEH MEDIAL FORM': 64744,
'ARABIC LIGATURE SEEN WITH JEEM INITIAL FORM': 64685,
'ARABIC LIGATURE SEEN WITH JEEM ISOLATED FORM': 64540,
'ARABIC LIGATURE SEEN WITH JEEM MEDIAL FORM': 64820,
'ARABIC LIGATURE SEEN WITH JEEM WITH ALEF MAKSURA FINAL FORM': 64862,
'ARABIC LIGATURE SEEN WITH JEEM WITH HAH INITIAL FORM': 64861,
'ARABIC LIGATURE SEEN WITH KHAH INITIAL FORM': 64687,
'ARABIC LIGATURE SEEN WITH KHAH ISOLATED FORM': 64542,
'ARABIC LIGATURE SEEN WITH KHAH MEDIAL FORM': 64822,
'ARABIC LIGATURE SEEN WITH KHAH WITH ALEF MAKSURA FINAL FORM': 64936,
'ARABIC LIGATURE SEEN WITH KHAH WITH YEH FINAL FORM': 64966,
'ARABIC LIGATURE SEEN WITH MEEM INITIAL FORM': 64688,
'ARABIC LIGATURE SEEN WITH MEEM ISOLATED FORM': 64543,
'ARABIC LIGATURE SEEN WITH MEEM MEDIAL FORM': 64743,
'ARABIC LIGATURE SEEN WITH MEEM WITH HAH FINAL FORM': 64863,
'ARABIC LIGATURE SEEN WITH MEEM WITH HAH INITIAL FORM': 64864,
'ARABIC LIGATURE SEEN WITH MEEM WITH JEEM INITIAL FORM': 64865,
'ARABIC LIGATURE SEEN WITH MEEM WITH MEEM FINAL FORM': 64866,
'ARABIC LIGATURE SEEN WITH MEEM WITH MEEM INITIAL FORM': 64867,
'ARABIC LIGATURE SEEN WITH REH FINAL FORM': 64810,
'ARABIC LIGATURE SEEN WITH REH ISOLATED FORM': 64782,
'ARABIC LIGATURE SEEN WITH YEH FINAL FORM': 64792,
'ARABIC LIGATURE SEEN WITH YEH ISOLATED FORM': 64764,
'ARABIC LIGATURE SHADDA WITH DAMMA ISOLATED FORM': 64609,
'ARABIC LIGATURE SHADDA WITH DAMMA MEDIAL FORM': 64755,
'ARABIC LIGATURE SHADDA WITH DAMMATAN ISOLATED FORM': 64606,
'ARABIC LIGATURE SHADDA WITH FATHA ISOLATED FORM': 64608,
'ARABIC LIGATURE SHADDA WITH FATHA MEDIAL FORM': 64754,
'ARABIC LIGATURE SHADDA WITH KASRA ISOLATED FORM': 64610,
'ARABIC LIGATURE SHADDA WITH KASRA MEDIAL FORM': 64756,
'ARABIC LIGATURE SHADDA WITH KASRATAN ISOLATED FORM': 64607,
'ARABIC LIGATURE SHADDA WITH SUPERSCRIPT ALEF ISOLATED FORM': 64611,
'ARABIC LIGATURE SHEEN WITH ALEF MAKSURA FINAL FORM': 64793,
'ARABIC LIGATURE SHEEN WITH ALEF MAKSURA ISOLATED FORM': 64765,
'ARABIC LIGATURE SHEEN WITH HAH FINAL FORM': 64806,
'ARABIC LIGATURE SHEEN WITH HAH INITIAL FORM': 64814,
'ARABIC LIGATURE SHEEN WITH HAH ISOLATED FORM': 64778,
'ARABIC LIGATURE SHEEN WITH HAH MEDIAL FORM': 64824,
'ARABIC LIGATURE SHEEN WITH HAH WITH MEEM FINAL FORM': 64871,
'ARABIC LIGATURE SHEEN WITH HAH WITH MEEM INITIAL FORM': 64872,
'ARABIC LIGATURE SHEEN WITH HAH WITH YEH FINAL FORM': 64938,
'ARABIC LIGATURE SHEEN WITH HEH INITIAL FORM': 64818,
'ARABIC LIGATURE SHEEN WITH HEH MEDIAL FORM': 64746,
'ARABIC LIGATURE SHEEN WITH JEEM FINAL FORM': 64805,
'ARABIC LIGATURE SHEEN WITH JEEM INITIAL FORM': 64813,
'ARABIC LIGATURE SHEEN WITH JEEM ISOLATED FORM': 64777,
'ARABIC LIGATURE SHEEN WITH JEEM MEDIAL FORM': 64823,
'ARABIC LIGATURE SHEEN WITH JEEM WITH YEH FINAL FORM': 64873,
'ARABIC LIGATURE SHEEN WITH KHAH FINAL FORM': 64807,
'ARABIC LIGATURE SHEEN WITH KHAH INITIAL FORM': 64815,
'ARABIC LIGATURE SHEEN WITH KHAH ISOLATED FORM': 64779,
'ARABIC LIGATURE SHEEN WITH KHAH MEDIAL FORM': 64825,
'ARABIC LIGATURE SHEEN WITH MEEM FINAL FORM': 64808,
'ARABIC LIGATURE SHEEN WITH MEEM INITIAL FORM': 64816,
'ARABIC LIGATURE SHEEN WITH MEEM ISOLATED FORM': 64780,
'ARABIC LIGATURE SHEEN WITH MEEM MEDIAL FORM': 64745,
'ARABIC LIGATURE SHEEN WITH MEEM WITH KHAH FINAL FORM': 64874,
'ARABIC LIGATURE SHEEN WITH MEEM WITH KHAH INITIAL FORM': 64875,
'ARABIC LIGATURE SHEEN WITH MEEM WITH MEEM FINAL FORM': 64876,
'ARABIC LIGATURE SHEEN WITH MEEM WITH MEEM INITIAL FORM': 64877,
'ARABIC LIGATURE SHEEN WITH REH FINAL FORM': 64809,
'ARABIC LIGATURE SHEEN WITH REH ISOLATED FORM': 64781,
'ARABIC LIGATURE SHEEN WITH YEH FINAL FORM': 64794,
'ARABIC LIGATURE SHEEN WITH YEH ISOLATED FORM': 64766,
'ARABIC LIGATURE TAH WITH ALEF MAKSURA FINAL FORM': 64785,
'ARABIC LIGATURE TAH WITH ALEF MAKSURA ISOLATED FORM': 64757,
'ARABIC LIGATURE TAH WITH HAH INITIAL FORM': 64696,
'ARABIC LIGATURE TAH WITH HAH ISOLATED FORM': 64550,
'ARABIC LIGATURE TAH WITH MEEM INITIAL FORM': 64819,
'ARABIC LIGATURE TAH WITH MEEM ISOLATED FORM': 64551,
'ARABIC LIGATURE TAH WITH MEEM MEDIAL FORM': 64826,
'ARABIC LIGATURE TAH WITH MEEM WITH HAH FINAL FORM': 64881,
'ARABIC LIGATURE TAH WITH MEEM WITH HAH INITIAL FORM': 64882,
'ARABIC LIGATURE TAH WITH MEEM WITH MEEM INITIAL FORM': 64883,
'ARABIC LIGATURE TAH WITH MEEM WITH YEH FINAL FORM': 64884,
'ARABIC LIGATURE TAH WITH YEH FINAL FORM': 64786,
'ARABIC LIGATURE TAH WITH YEH ISOLATED FORM': 64758,
'ARABIC LIGATURE TEH WITH ALEF MAKSURA FINAL FORM': 64628,
'ARABIC LIGATURE TEH WITH ALEF MAKSURA ISOLATED FORM': 64527,
'ARABIC LIGATURE TEH WITH HAH INITIAL FORM': 64674,
'ARABIC LIGATURE TEH WITH HAH ISOLATED FORM': 64524,
'ARABIC LIGATURE TEH WITH HAH WITH JEEM FINAL FORM': 64849,
'ARABIC LIGATURE TEH WITH HAH WITH JEEM INITIAL FORM': 64850,
'ARABIC LIGATURE TEH WITH HAH WITH MEEM INITIAL FORM': 64851,
'ARABIC LIGATURE TEH WITH HEH INITIAL FORM': 64677,
'ARABIC LIGATURE TEH WITH HEH MEDIAL FORM': 64740,
'ARABIC LIGATURE TEH WITH JEEM INITIAL FORM': 64673,
'ARABIC LIGATURE TEH WITH JEEM ISOLATED FORM': 64523,
'ARABIC LIGATURE TEH WITH JEEM WITH ALEF MAKSURA FINAL FORM': 64928,
'ARABIC LIGATURE TEH WITH JEEM WITH MEEM INITIAL FORM': 64848,
'ARABIC LIGATURE TEH WITH JEEM WITH YEH FINAL FORM': 64927,
'ARABIC LIGATURE TEH WITH KHAH INITIAL FORM': 64675,
'ARABIC LIGATURE TEH WITH KHAH ISOLATED FORM': 64525,
'ARABIC LIGATURE TEH WITH KHAH WITH ALEF MAKSURA FINAL FORM': 64930,
'ARABIC LIGATURE TEH WITH KHAH WITH MEEM INITIAL FORM': 64852,
'ARABIC LIGATURE TEH WITH KHAH WITH YEH FINAL FORM': 64929,
'ARABIC LIGATURE TEH WITH MEEM FINAL FORM': 64626,
'ARABIC LIGATURE TEH WITH MEEM INITIAL FORM': 64676,
'ARABIC LIGATURE TEH WITH MEEM ISOLATED FORM': 64526,
'ARABIC LIGATURE TEH WITH MEEM MEDIAL FORM': 64739,
'ARABIC LIGATURE TEH WITH MEEM WITH ALEF MAKSURA FINAL FORM': 64932,
'ARABIC LIGATURE TEH WITH MEEM WITH HAH INITIAL FORM': 64854,
'ARABIC LIGATURE TEH WITH MEEM WITH JEEM INITIAL FORM': 64853,
'ARABIC LIGATURE TEH WITH MEEM WITH KHAH INITIAL FORM': 64855,
'ARABIC LIGATURE TEH WITH MEEM WITH YEH FINAL FORM': 64931,
'ARABIC LIGATURE TEH WITH NOON FINAL FORM': 64627,
'ARABIC LIGATURE TEH WITH REH FINAL FORM': 64624,
'ARABIC LIGATURE TEH WITH YEH FINAL FORM': 64629,
'ARABIC LIGATURE TEH WITH YEH ISOLATED FORM': 64528,
'ARABIC LIGATURE TEH WITH ZAIN FINAL FORM': 64625,
'ARABIC LIGATURE THAL WITH SUPERSCRIPT ALEF ISOLATED FORM': 64603,
'ARABIC LIGATURE THEH WITH ALEF MAKSURA FINAL FORM': 64634,
'ARABIC LIGATURE THEH WITH ALEF MAKSURA ISOLATED FORM': 64531,
'ARABIC LIGATURE THEH WITH HEH MEDIAL FORM': 64742,
'ARABIC LIGATURE THEH WITH JEEM ISOLATED FORM': 64529,
'ARABIC LIGATURE THEH WITH MEEM FINAL FORM': 64632,
'ARABIC LIGATURE THEH WITH MEEM INITIAL FORM': 64678,
'ARABIC LIGATURE THEH WITH MEEM ISOLATED FORM': 64530,
'ARABIC LIGATURE THEH WITH MEEM MEDIAL FORM': 64741,
'ARABIC LIGATURE THEH WITH NOON FINAL FORM': 64633,
'ARABIC LIGATURE THEH WITH REH FINAL FORM': 64630,
'ARABIC LIGATURE THEH WITH YEH FINAL FORM': 64635,
'ARABIC LIGATURE THEH WITH YEH ISOLATED FORM': 64532,
'ARABIC LIGATURE THEH WITH ZAIN FINAL FORM': 64631,
'ARABIC LIGATURE UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA FINAL FORM': 64506,
'ARABIC LIGATURE UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA INITIAL FORM': 64507,
'ARABIC LIGATURE UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA ISOLATED FORM': 64505,
'ARABIC LIGATURE WASALLAM ISOLATED FORM': 65016,
'ARABIC LIGATURE YEH WITH ALEF MAKSURA FINAL FORM': 64661,
'ARABIC LIGATURE YEH WITH ALEF MAKSURA ISOLATED FORM': 64601,
'ARABIC LIGATURE YEH WITH HAH INITIAL FORM': 64731,
'ARABIC LIGATURE YEH WITH HAH ISOLATED FORM': 64598,
'ARABIC LIGATURE YEH WITH HAH WITH YEH FINAL FORM': 64942,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH AE FINAL FORM': 64493,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH AE ISOLATED FORM': 64492,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF FINAL FORM': 64491,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF ISOLATED FORM': 64490,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF MAKSURA FINAL FORM': 64616,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF MAKSURA ISOLATED FORM': 64515,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH E FINAL FORM': 64503,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH E INITIAL FORM': 64504,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH E ISOLATED FORM': 64502,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HAH INITIAL FORM': 64664,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HAH ISOLATED FORM': 64513,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HEH INITIAL FORM': 64667,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HEH MEDIAL FORM': 64736,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH JEEM INITIAL FORM': 64663,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH JEEM ISOLATED FORM': 64512,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH KHAH INITIAL FORM': 64665,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM FINAL FORM': 64614,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM INITIAL FORM': 64666,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM ISOLATED FORM': 64514,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM MEDIAL FORM': 64735,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH NOON FINAL FORM': 64615,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH OE FINAL FORM': 64499,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH OE ISOLATED FORM': 64498,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH REH FINAL FORM': 64612,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH U FINAL FORM': 64497,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH U ISOLATED FORM': 64496,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH WAW FINAL FORM': 64495,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH WAW ISOLATED FORM': 64494,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YEH FINAL FORM': 64617,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YEH ISOLATED FORM': 64516,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YU FINAL FORM': 64501,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YU ISOLATED FORM': 64500,
'ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ZAIN FINAL FORM': 64613,
'ARABIC LIGATURE YEH WITH HEH INITIAL FORM': 64734,
'ARABIC LIGATURE YEH WITH HEH MEDIAL FORM': 64753,
'ARABIC LIGATURE YEH WITH JEEM INITIAL FORM': 64730,
'ARABIC LIGATURE YEH WITH JEEM ISOLATED FORM': 64597,
'ARABIC LIGATURE YEH WITH JEEM WITH YEH FINAL FORM': 64943,
'ARABIC LIGATURE YEH WITH KHAH INITIAL FORM': 64732,
'ARABIC LIGATURE YEH WITH KHAH ISOLATED FORM': 64599,
'ARABIC LIGATURE YEH WITH MEEM FINAL FORM': 64659,
'ARABIC LIGATURE YEH WITH MEEM INITIAL FORM': 64733,
'ARABIC LIGATURE YEH WITH MEEM ISOLATED FORM': 64600,
'ARABIC LIGATURE YEH WITH MEEM MEDIAL FORM': 64752,
'ARABIC LIGATURE YEH WITH MEEM WITH MEEM FINAL FORM': 64924,
'ARABIC LIGATURE YEH WITH MEEM WITH MEEM INITIAL FORM': 64925,
'ARABIC LIGATURE YEH WITH MEEM WITH YEH FINAL FORM': 64944,
'ARABIC LIGATURE YEH WITH NOON FINAL FORM': 64660,
'ARABIC LIGATURE YEH WITH REH FINAL FORM': 64657,
'ARABIC LIGATURE YEH WITH YEH FINAL FORM': 64662,
'ARABIC LIGATURE YEH WITH YEH ISOLATED FORM': 64602,
'ARABIC LIGATURE YEH WITH ZAIN FINAL FORM': 64658,
'ARABIC LIGATURE ZAH WITH MEEM INITIAL FORM': 64697,
'ARABIC LIGATURE ZAH WITH MEEM ISOLATED FORM': 64552,
'ARABIC LIGATURE ZAH WITH MEEM MEDIAL FORM': 64827,
'ARABIC MADDAH ABOVE': 1619,
'ARABIC MARK NOON GHUNNA': 1624,
'ARABIC NUMBER SIGN': 1536,
'ARABIC PERCENT SIGN': 1642,
'ARABIC PLACE OF SAJDAH': 1769,
'ARABIC POETIC VERSE SIGN': 1550,
'ARABIC QUESTION MARK': 1567,
'ARABIC RAY': 1544,
'ARABIC REVERSED DAMMA': 1629,
'ARABIC ROUNDED HIGH STOP WITH FILLED CENTRE': 1772,
'ARABIC SEMICOLON': 1563,
'ARABIC SHADDA': 1617,
'ARABIC SHADDA ISOLATED FORM': 65148,
'ARABIC SHADDA MEDIAL FORM': 65149,
'ARABIC SIGN ALAYHE ASSALLAM': 1553,
'ARABIC SIGN MISRA': 1551,
'ARABIC SIGN RADI ALLAHOU ANHU': 1555,
'ARABIC SIGN RAHMATULLAH ALAYHE': 1554,
'ARABIC SIGN SAFHA': 1539,
'ARABIC SIGN SALLALLAHOU ALAYHE WASSALLAM': 1552,
'ARABIC SIGN SANAH': 1537,
'ARABIC SIGN SINDHI AMPERSAND': 1789,
'ARABIC SIGN SINDHI POSTPOSITION MEN': 1790,
'ARABIC SIGN TAKHALLUS': 1556,
'ARABIC SMALL DAMMA': 1561,
'ARABIC SMALL FATHA': 1560,
'ARABIC SMALL HIGH DOTLESS HEAD OF KHAH': 1761,
'ARABIC SMALL HIGH JEEM': 1754,
'ARABIC SMALL HIGH LAM ALEF': 1753,
'ARABIC SMALL HIGH LIGATURE ALEF WITH LAM WITH YEH': 1558,
'ARABIC SMALL HIGH LIGATURE QAF WITH LAM WITH ALEF MAKSURA': 1751,
'ARABIC SMALL HIGH LIGATURE SAD WITH LAM WITH ALEF MAKSURA': 1750,
'ARABIC SMALL HIGH MADDA': 1764,
'ARABIC SMALL HIGH MEEM INITIAL FORM': 1752,
'ARABIC SMALL HIGH MEEM ISOLATED FORM': 1762,
'ARABIC SMALL HIGH NOON': 1768,
'ARABIC SMALL HIGH ROUNDED ZERO': 1759,
'ARABIC SMALL HIGH SEEN': 1756,
'ARABIC SMALL HIGH TAH': 1557,
'ARABIC SMALL HIGH THREE DOTS': 1755,
'ARABIC SMALL HIGH UPRIGHT RECTANGULAR ZERO': 1760,
'ARABIC SMALL HIGH YEH': 1767,
'ARABIC SMALL HIGH ZAIN': 1559,
'ARABIC SMALL KASRA': 1562,
'ARABIC SMALL LOW MEEM': 1773,
'ARABIC SMALL LOW SEEN': 1763,
'ARABIC SMALL WAW': 1765,
'ARABIC SMALL YEH': 1766,
'ARABIC START OF RUB EL HIZB': 1758,
'ARABIC SUBSCRIPT ALEF': 1622,
'ARABIC SUKUN': 1618,
'ARABIC SUKUN ISOLATED FORM': 65150,
'ARABIC SUKUN MEDIAL FORM': 65151,
'ARABIC TAIL FRAGMENT': 65139,
'ARABIC TATWEEL': 1600,
'ARABIC TATWEEL WITH FATHATAN ABOVE': 65137,
'ARABIC THOUSANDS SEPARATOR': 1644,
'ARABIC TRIPLE DOT PUNCTUATION MARK': 1566,
'ARABIC VOWEL SIGN DOT BELOW': 1628,
'ARABIC VOWEL SIGN INVERTED SMALL V ABOVE': 1627,
'ARABIC VOWEL SIGN SMALL V ABOVE': 1626,
'ARABIC ZWARAKAY': 1625,
'ARABIC-INDIC CUBE ROOT': 1542,
'ARABIC-INDIC DIGIT EIGHT': 1640,
'ARABIC-INDIC DIGIT FIVE': 1637,
'ARABIC-INDIC DIGIT FOUR': 1636,
'ARABIC-INDIC DIGIT NINE': 1641,
'ARABIC-INDIC DIGIT ONE': 1633,
'ARABIC-INDIC DIGIT SEVEN': 1639,
'ARABIC-INDIC DIGIT SIX': 1638,
'ARABIC-INDIC DIGIT THREE': 1635,
'ARABIC-INDIC DIGIT TWO': 1634,
'ARABIC-INDIC DIGIT ZERO': 1632,
'ARABIC-INDIC FOURTH ROOT': 1543,
'ARABIC-INDIC PER MILLE SIGN': 1545,
'ARABIC-INDIC PER TEN THOUSAND SIGN': 1546,
'ARC': 8978,
'ARIES': 9800,
'ARMENIAN ABBREVIATION MARK': 1375,
'ARMENIAN APOSTROPHE': 1370,
'ARMENIAN CAPITAL LETTER AYB': 1329,
'ARMENIAN CAPITAL LETTER BEN': 1330,
'ARMENIAN CAPITAL LETTER CA': 1342,
'ARMENIAN CAPITAL LETTER CHA': 1353,
'ARMENIAN CAPITAL LETTER CHEH': 1347,
'ARMENIAN CAPITAL LETTER CO': 1361,
'ARMENIAN CAPITAL LETTER DA': 1332,
'ARMENIAN CAPITAL LETTER ECH': 1333,
'ARMENIAN CAPITAL LETTER EH': 1335,
'ARMENIAN CAPITAL LETTER ET': 1336,
'ARMENIAN CAPITAL LETTER FEH': 1366,
'ARMENIAN CAPITAL LETTER GHAD': 1346,
'ARMENIAN CAPITAL LETTER GIM': 1331,
'ARMENIAN CAPITAL LETTER HO': 1344,
'ARMENIAN CAPITAL LETTER INI': 1339,
'ARMENIAN CAPITAL LETTER JA': 1345,
'ARMENIAN CAPITAL LETTER JHEH': 1355,
'ARMENIAN CAPITAL LETTER KEH': 1364,
'ARMENIAN CAPITAL LETTER KEN': 1343,
'ARMENIAN CAPITAL LETTER LIWN': 1340,
'ARMENIAN CAPITAL LETTER MEN': 1348,
'ARMENIAN CAPITAL LETTER NOW': 1350,
'ARMENIAN CAPITAL LETTER OH': 1365,
'ARMENIAN CAPITAL LETTER PEH': 1354,
'ARMENIAN CAPITAL LETTER PIWR': 1363,
'ARMENIAN CAPITAL LETTER RA': 1356,
'ARMENIAN CAPITAL LETTER REH': 1360,
'ARMENIAN CAPITAL LETTER SEH': 1357,
'ARMENIAN CAPITAL LETTER SHA': 1351,
'ARMENIAN CAPITAL LETTER TIWN': 1359,
'ARMENIAN CAPITAL LETTER TO': 1337,
'ARMENIAN CAPITAL LETTER VEW': 1358,
'ARMENIAN CAPITAL LETTER VO': 1352,
'ARMENIAN CAPITAL LETTER XEH': 1341,
'ARMENIAN CAPITAL LETTER YI': 1349,
'ARMENIAN CAPITAL LETTER YIWN': 1362,
'ARMENIAN CAPITAL LETTER ZA': 1334,
'ARMENIAN CAPITAL LETTER ZHE': 1338,
'ARMENIAN COMMA': 1373,
'ARMENIAN EMPHASIS MARK': 1371,
'ARMENIAN EXCLAMATION MARK': 1372,
'ARMENIAN FULL STOP': 1417,
'ARMENIAN HYPHEN': 1418,
'ARMENIAN MODIFIER LETTER LEFT HALF RING': 1369,
'ARMENIAN QUESTION MARK': 1374,
'ARMENIAN SMALL LETTER AYB': 1377,
'ARMENIAN SMALL LETTER BEN': 1378,
'ARMENIAN SMALL LETTER CA': 1390,
'ARMENIAN SMALL LETTER CHA': 1401,
'ARMENIAN SMALL LETTER CHEH': 1395,
'ARMENIAN SMALL LETTER CO': 1409,
'ARMENIAN SMALL LETTER DA': 1380,
'ARMENIAN SMALL LETTER ECH': 1381,
'ARMENIAN SMALL LETTER EH': 1383,
'ARMENIAN SMALL LETTER ET': 1384,
'ARMENIAN SMALL LETTER FEH': 1414,
'ARMENIAN SMALL LETTER GHAD': 1394,
'ARMENIAN SMALL LETTER GIM': 1379,
'ARMENIAN SMALL LETTER HO': 1392,
'ARMENIAN SMALL LETTER INI': 1387,
'ARMENIAN SMALL LETTER JA': 1393,
'ARMENIAN SMALL LETTER JHEH': 1403,
'ARMENIAN SMALL LETTER KEH': 1412,
'ARMENIAN SMALL LETTER KEN': 1391,
'ARMENIAN SMALL LETTER LIWN': 1388,
'ARMENIAN SMALL LETTER MEN': 1396,
'ARMENIAN SMALL LETTER NOW': 1398,
'ARMENIAN SMALL LETTER OH': 1413,
'ARMENIAN SMALL LETTER PEH': 1402,
'ARMENIAN SMALL LETTER PIWR': 1411,
'ARMENIAN SMALL LETTER RA': 1404,
'ARMENIAN SMALL LETTER REH': 1408,
'ARMENIAN SMALL LETTER SEH': 1405,
'ARMENIAN SMALL LETTER SHA': 1399,
'ARMENIAN SMALL LETTER TIWN': 1407,
'ARMENIAN SMALL LETTER TO': 1385,
'ARMENIAN SMALL LETTER VEW': 1406,
'ARMENIAN SMALL LETTER VO': 1400,
'ARMENIAN SMALL LETTER XEH': 1389,
'ARMENIAN SMALL LETTER YI': 1397,
'ARMENIAN SMALL LETTER YIWN': 1410,
'ARMENIAN SMALL LETTER ZA': 1382,
'ARMENIAN SMALL LETTER ZHE': 1386,
'ARMENIAN SMALL LIGATURE ECH YIWN': 1415,
'ARMENIAN SMALL LIGATURE MEN ECH': 64276,
'ARMENIAN SMALL LIGATURE MEN INI': 64277,
'ARMENIAN SMALL LIGATURE MEN NOW': 64275,
'ARMENIAN SMALL LIGATURE MEN XEH': 64279,
'ARMENIAN SMALL LIGATURE VEW NOW': 64278,
'ARROW POINTING DOWNWARDS THEN CURVING LEFTWARDS': 10550,
'ARROW POINTING DOWNWARDS THEN CURVING RIGHTWARDS': 10551,
'ARROW POINTING RIGHTWARDS THEN CURVING DOWNWARDS': 10549,
'ARROW POINTING RIGHTWARDS THEN CURVING UPWARDS': 10548,
'ASCENDING NODE': 9738,
'ASSERTION': 8870,
'ASTERISK': 42,
'ASTERISK OPERATOR': 8727,
'ASTERISM': 8258,
'ASYMPTOTICALLY EQUAL TO': 8771,
'ATOM SYMBOL': 9883,
'AUSTRAL SIGN': 8371,
'AVESTAN ABBREVIATION MARK': 68409,
'AVESTAN LETTER A': 68352,
'AVESTAN LETTER AA': 68353,
'AVESTAN LETTER AAN': 68357,
'AVESTAN LETTER AAO': 68355,
'AVESTAN LETTER AE': 68358,
'AVESTAN LETTER AEE': 68359,
'AVESTAN LETTER AN': 68356,
'AVESTAN LETTER AO': 68354,
'AVESTAN LETTER BE': 68384,
'AVESTAN LETTER BHE': 68385,
'AVESTAN LETTER CE': 68375,
'AVESTAN LETTER DE': 68379,
'AVESTAN LETTER DHE': 68380,
'AVESTAN LETTER E': 68360,
'AVESTAN LETTER EE': 68361,
'AVESTAN LETTER FE': 68383,
'AVESTAN LETTER GE': 68372,
'AVESTAN LETTER GGE': 68373,
'AVESTAN LETTER GHE': 68374,
'AVESTAN LETTER HE': 68405,
'AVESTAN LETTER HME': 68393,
'AVESTAN LETTER I': 68364,
'AVESTAN LETTER II': 68365,
'AVESTAN LETTER JE': 68376,
'AVESTAN LETTER KE': 68368,
'AVESTAN LETTER LE': 68398,
'AVESTAN LETTER ME': 68392,
'AVESTAN LETTER NE': 68389,
'AVESTAN LETTER NGE': 68386,
'AVESTAN LETTER NGVE': 68388,
'AVESTAN LETTER NGYE': 68387,
'AVESTAN LETTER NNE': 68391,
'AVESTAN LETTER NYE': 68390,
'AVESTAN LETTER O': 68362,
'AVESTAN LETTER OO': 68363,
'AVESTAN LETTER PE': 68382,
'AVESTAN LETTER RE': 68397,
'AVESTAN LETTER SE': 68399,
'AVESTAN LETTER SHE': 68401,
'AVESTAN LETTER SHYE': 68403,
'AVESTAN LETTER SSHE': 68404,
'AVESTAN LETTER TE': 68377,
'AVESTAN LETTER THE': 68378,
'AVESTAN LETTER TTE': 68381,
'AVESTAN LETTER U': 68366,
'AVESTAN LETTER UU': 68367,
'AVESTAN LETTER VE': 68396,
'AVESTAN LETTER XE': 68369,
'AVESTAN LETTER XVE': 68371,
'AVESTAN LETTER XYE': 68370,
'AVESTAN LETTER YE': 68395,
'AVESTAN LETTER YYE': 68394,
'AVESTAN LETTER ZE': 68400,
'AVESTAN LETTER ZHE': 68402,
'BACK-TILTED SHADOWED WHITE RIGHTWARDS ARROW': 10155,
'BALINESE ADEG ADEG': 6980,
'BALINESE CARIK PAMUNGKAH': 7005,
'BALINESE CARIK PAREREN': 7007,
'BALINESE CARIK SIKI': 7006,
'BALINESE DIGIT EIGHT': 7000,
'BALINESE DIGIT FIVE': 6997,
'BALINESE DIGIT FOUR': 6996,
'BALINESE DIGIT NINE': 7001,
'BALINESE DIGIT ONE': 6993,
'BALINESE DIGIT SEVEN': 6999,
'BALINESE DIGIT SIX': 6998,
'BALINESE DIGIT THREE': 6995,
'BALINESE DIGIT TWO': 6994,
'BALINESE DIGIT ZERO': 6992,
'BALINESE LETTER AIKARA': 6928,
'BALINESE LETTER AKARA': 6917,
'BALINESE LETTER AKARA TEDUNG': 6918,
'BALINESE LETTER ASYURA SASAK': 6987,
'BALINESE LETTER BA': 6953,
'BALINESE LETTER BA KEMBANG': 6954,
'BALINESE LETTER CA': 6936,
'BALINESE LETTER CA LACA': 6937,
'BALINESE LETTER DA': 6948,
'BALINESE LETTER DA MADU': 6949,
'BALINESE LETTER DA MURDA ALPAPRANA': 6943,
'BALINESE LETTER DA MURDA MAHAPRANA': 6944,
'BALINESE LETTER EF SASAK': 6984,
'BALINESE LETTER EKARA': 6927,
'BALINESE LETTER GA': 6933,
'BALINESE LETTER GA GORA': 6934,
'BALINESE LETTER HA': 6963,
'BALINESE LETTER IKARA': 6919,
'BALINESE LETTER IKARA TEDUNG': 6920,
'BALINESE LETTER JA': 6938,
'BALINESE LETTER JA JERA': 6939,
'BALINESE LETTER KA': 6931,
'BALINESE LETTER KA MAHAPRANA': 6932,
'BALINESE LETTER KAF SASAK': 6981,
'BALINESE LETTER KHOT SASAK': 6982,
'BALINESE LETTER LA': 6958,
'BALINESE LETTER LA LENGA': 6925,
'BALINESE LETTER LA LENGA TEDUNG': 6926,
'BALINESE LETTER MA': 6955,
'BALINESE LETTER NA': 6950,
'BALINESE LETTER NA RAMBAT': 6945,
'BALINESE LETTER NGA': 6935,
'BALINESE LETTER NYA': 6940,
'BALINESE LETTER OKARA': 6929,
'BALINESE LETTER OKARA TEDUNG': 6930,
'BALINESE LETTER PA': 6951,
'BALINESE LETTER PA KAPAL': 6952,
'BALINESE LETTER RA': 6957,
'BALINESE LETTER RA REPA': 6923,
'BALINESE LETTER RA REPA TEDUNG': 6924,
'BALINESE LETTER SA': 6962,
'BALINESE LETTER SA SAGA': 6960,
'BALINESE LETTER SA SAPA': 6961,
'BALINESE LETTER TA': 6946,
'BALINESE LETTER TA LATIK': 6941,
'BALINESE LETTER TA MURDA MAHAPRANA': 6942,
'BALINESE LETTER TA TAWA': 6947,
'BALINESE LETTER TZIR SASAK': 6983,
'BALINESE LETTER UKARA': 6921,
'BALINESE LETTER UKARA TEDUNG': 6922,
'BALINESE LETTER VE SASAK': 6985,
'BALINESE LETTER WA': 6959,
'BALINESE LETTER YA': 6956,
'BALINESE LETTER ZAL SASAK': 6986,
'BALINESE MUSICAL SYMBOL COMBINING BENDE': 7026,
'BALINESE MUSICAL SYMBOL COMBINING ENDEP': 7020,
'BALINESE MUSICAL SYMBOL COMBINING GONG': 7027,
'BALINESE MUSICAL SYMBOL COMBINING JEGOGAN': 7023,
'BALINESE MUSICAL SYMBOL COMBINING KEMPLI': 7022,
'BALINESE MUSICAL SYMBOL COMBINING KEMPLI WITH JEGOGAN': 7025,
'BALINESE MUSICAL SYMBOL COMBINING KEMPUL': 7021,
'BALINESE MUSICAL SYMBOL COMBINING KEMPUL WITH JEGOGAN': 7024,
'BALINESE MUSICAL SYMBOL COMBINING TEGEH': 7019,
'BALINESE MUSICAL SYMBOL DAENG': 7015,
'BALINESE MUSICAL SYMBOL DAING': 7017,
'BALINESE MUSICAL SYMBOL DANG': 7012,
'BALINESE MUSICAL SYMBOL DANG GEDE': 7018,
'BALINESE MUSICAL SYMBOL DANG SURANG': 7013,
'BALINESE MUSICAL SYMBOL DENG': 7010,
'BALINESE MUSICAL SYMBOL DEUNG': 7016,
'BALINESE MUSICAL SYMBOL DING': 7014,
'BALINESE MUSICAL SYMBOL DONG': 7009,
'BALINESE MUSICAL SYMBOL DUNG': 7011,
'BALINESE MUSICAL SYMBOL LEFT-HAND CLOSED PLAK': 7034,
'BALINESE MUSICAL SYMBOL LEFT-HAND CLOSED PLUK': 7035,
'BALINESE MUSICAL SYMBOL LEFT-HAND OPEN PANG': 7032,
'BALINESE MUSICAL SYMBOL LEFT-HAND OPEN PING': 7036,
'BALINESE MUSICAL SYMBOL LEFT-HAND OPEN PUNG': 7033,
'BALINESE MUSICAL SYMBOL RIGHT-HAND CLOSED TAK': 7031,
'BALINESE MUSICAL SYMBOL RIGHT-HAND CLOSED TUK': 7030,
'BALINESE MUSICAL SYMBOL RIGHT-HAND OPEN DAG': 7029,
'BALINESE MUSICAL SYMBOL RIGHT-HAND OPEN DUG': 7028,
'BALINESE PAMADA': 7003,
'BALINESE PAMENENG': 7008,
'BALINESE PANTI': 7002,
'BALINESE SIGN BISAH': 6916,
'BALINESE SIGN CECEK': 6914,
'BALINESE SIGN REREKAN': 6964,
'BALINESE SIGN SURANG': 6915,
'BALINESE SIGN ULU CANDRA': 6913,
'BALINESE SIGN ULU RICEM': 6912,
'BALINESE VOWEL SIGN LA LENGA': 6972,
'BALINESE VOWEL SIGN LA LENGA TEDUNG': 6973,
'BALINESE VOWEL SIGN PEPET': 6978,
'BALINESE VOWEL SIGN PEPET TEDUNG': 6979,
'BALINESE VOWEL SIGN RA REPA': 6970,
'BALINESE VOWEL SIGN RA REPA TEDUNG': 6971,
'BALINESE VOWEL SIGN SUKU': 6968,
'BALINESE VOWEL SIGN SUKU ILUT': 6969,
'BALINESE VOWEL SIGN TALING': 6974,
'BALINESE VOWEL SIGN TALING REPA': 6975,
'BALINESE VOWEL SIGN TALING REPA TEDUNG': 6977,
'BALINESE VOWEL SIGN TALING TEDUNG': 6976,
'BALINESE VOWEL SIGN TEDUNG': 6965,
'BALINESE VOWEL SIGN ULU': 6966,
'BALINESE VOWEL SIGN ULU SARI': 6967,
'BALINESE WINDU': 7004,
'BALLOON-SPOKED ASTERISK': 10057,
'BALLOT BOX': 9744,
'BALLOT BOX WITH CHECK': 9745,
'BALLOT BOX WITH X': 9746,
'BALLOT X': 10007,
'BAMUM COLON': 42740,
'BAMUM COMBINING MARK KOQNDON': 42736,
'BAMUM COMBINING MARK TUKWENTIS': 42737,
'BAMUM COMMA': 42741,
'BAMUM FULL STOP': 42739,
'BAMUM LETTER A': 42656,
'BAMUM LETTER EE': 42660,
'BAMUM LETTER FAAMAE': 42733,
'BAMUM LETTER FEE': 42699,
'BAMUM LETTER FOM': 42713,
'BAMUM LETTER FU': 42712,
'BAMUM LETTER I': 42665,
'BAMUM LETTER KA': 42657,
'BAMUM LETTER KEN': 42706,
'BAMUM LETTER KET': 42683,
'BAMUM LETTER KEUX': 42692,
'BAMUM LETTER KI': 42725,
'BAMUM LETTER KO': 42719,
'BAMUM LETTER KOGHOM': 42735,
'BAMUM LETTER KOVUU': 42734,
'BAMUM LETTER KPA': 42729,
'BAMUM LETTER KU': 42659,
'BAMUM LETTER KYEE': 42682,
'BAMUM LETTER LA': 42666,
'BAMUM LETTER LEEEE': 42670,
'BAMUM LETTER LI': 42716,
'BAMUM LETTER LOQ': 42718,
'BAMUM LETTER LU': 42701,
'BAMUM LETTER M': 42675,
'BAMUM LETTER MA': 42723,
'BAMUM LETTER MBAA': 42727,
'BAMUM LETTER MBEN': 42720,
'BAMUM LETTER MEEEE': 42671,
'BAMUM LETTER MEN': 42722,
'BAMUM LETTER MI': 42702,
'BAMUM LETTER MO': 42726,
'BAMUM LETTER MU': 42677,
'BAMUM LETTER NA': 42715,
'BAMUM LETTER NDAA': 42673,
'BAMUM LETTER NGA': 42709,
'BAMUM LETTER NGGA': 42708,
'BAMUM LETTER NGKWAEN': 42707,
'BAMUM LETTER NI': 42703,
'BAMUM LETTER NJAEM': 42674,
'BAMUM LETTER NJEE': 42694,
'BAMUM LETTER NJUAE': 42686,
'BAMUM LETTER NSHA': 42691,
'BAMUM LETTER NTEE': 42695,
'BAMUM LETTER NTUU': 42731,
'BAMUM LETTER NU': 42685,
'BAMUM LETTER NUAE': 42684,
'BAMUM LETTER NYI': 42664,
'BAMUM LETTER O': 42663,
'BAMUM LETTER PA': 42667,
'BAMUM LETTER PEE': 42698,
'BAMUM LETTER PEUX': 42693,
'BAMUM LETTER PI': 42717,
'BAMUM LETTER PUAE': 42711,
'BAMUM LETTER PUE': 42696,
'BAMUM LETTER RAE': 42705,
'BAMUM LETTER REE': 42661,
'BAMUM LETTER REN': 42721,
'BAMUM LETTER REUX': 42704,
'BAMUM LETTER RIEE': 42669,
'BAMUM LETTER RII': 42668,
'BAMUM LETTER RU': 42700,
'BAMUM LETTER SAMBA': 42732,
'BAMUM LETTER SEUX': 42681,
'BAMUM LETTER SHEUX': 42680,
'BAMUM LETTER SHII': 42678,
'BAMUM LETTER SHO': 42710,
'BAMUM LETTER SHU': 42688,
'BAMUM LETTER SI': 42679,
'BAMUM LETTER SUU': 42676,
'BAMUM LETTER TAA': 42672,
'BAMUM LETTER TAE': 42662,
'BAMUM LETTER TEN': 42730,
'BAMUM LETTER TET': 42728,
'BAMUM LETTER TI': 42724,
'BAMUM LETTER U': 42658,
'BAMUM LETTER WA': 42714,
'BAMUM LETTER WUE': 42697,
'BAMUM LETTER YA': 42690,
'BAMUM LETTER YOQ': 42687,
'BAMUM LETTER YUQ': 42689,
'BAMUM NJAEMLI': 42738,
'BAMUM QUESTION MARK': 42743,
'BAMUM SEMICOLON': 42742,
'BASEBALL': 9918,
'BEAMED EIGHTH NOTES': 9835,
'BEAMED SIXTEENTH NOTES': 9836,
'BECAUSE': 8757,
'BELL SYMBOL': 9086,
'BENGALI AU LENGTH MARK': 2519,
'BENGALI CURRENCY DENOMINATOR SIXTEEN': 2553,
'BENGALI CURRENCY NUMERATOR FOUR': 2551,
'BENGALI CURRENCY NUMERATOR ONE': 2548,
'BENGALI CURRENCY NUMERATOR ONE LESS THAN THE DENOMINATOR': 2552,
'BENGALI CURRENCY NUMERATOR THREE': 2550,
'BENGALI CURRENCY NUMERATOR TWO': 2549,
'BENGALI DIGIT EIGHT': 2542,
'BENGALI DIGIT FIVE': 2539,
'BENGALI DIGIT FOUR': 2538,
'BENGALI DIGIT NINE': 2543,
'BENGALI DIGIT ONE': 2535,
'BENGALI DIGIT SEVEN': 2541,
'BENGALI DIGIT SIX': 2540,
'BENGALI DIGIT THREE': 2537,
'BENGALI DIGIT TWO': 2536,
'BENGALI DIGIT ZERO': 2534,
'BENGALI GANDA MARK': 2555,
'BENGALI ISSHAR': 2554,
'BENGALI LETTER A': 2437,
'BENGALI LETTER AA': 2438,
'BENGALI LETTER AI': 2448,
'BENGALI LETTER AU': 2452,
'BENGALI LETTER BA': 2476,
'BENGALI LETTER BHA': 2477,
'BENGALI LETTER CA': 2458,
'BENGALI LETTER CHA': 2459,
'BENGALI LETTER DA': 2470,
'BENGALI LETTER DDA': 2465,
'BENGALI LETTER DDHA': 2466,
'BENGALI LETTER DHA': 2471,
'BENGALI LETTER E': 2447,
'BENGALI LETTER GA': 2455,
'BENGALI LETTER GHA': 2456,
'BENGALI LETTER HA': 2489,
'BENGALI LETTER I': 2439,
'BENGALI LETTER II': 2440,
'BENGALI LETTER JA': 2460,
'BENGALI LETTER JHA': 2461,
'BENGALI LETTER KA': 2453,
'BENGALI LETTER KHA': 2454,
'BENGALI LETTER KHANDA TA': 2510,
'BENGALI LETTER LA': 2482,
'BENGALI LETTER MA': 2478,
'BENGALI LETTER NA': 2472,
'BENGALI LETTER NGA': 2457,
'BENGALI LETTER NNA': 2467,
'BENGALI LETTER NYA': 2462,
'BENGALI LETTER O': 2451,
'BENGALI LETTER PA': 2474,
'BENGALI LETTER PHA': 2475,
'BENGALI LETTER RA': 2480,
'BENGALI LETTER RA WITH LOWER DIAGONAL': 2545,
'BENGALI LETTER RA WITH MIDDLE DIAGONAL': 2544,
'BENGALI LETTER RHA': 2525,
'BENGALI LETTER RRA': 2524,
'BENGALI LETTER SA': 2488,
'BENGALI LETTER SHA': 2486,
'BENGALI LETTER SSA': 2487,
'BENGALI LETTER TA': 2468,
'BENGALI LETTER THA': 2469,
'BENGALI LETTER TTA': 2463,
'BENGALI LETTER TTHA': 2464,
'BENGALI LETTER U': 2441,
'BENGALI LETTER UU': 2442,
'BENGALI LETTER VOCALIC L': 2444,
'BENGALI LETTER VOCALIC LL': 2529,
'BENGALI LETTER VOCALIC R': 2443,
'BENGALI LETTER VOCALIC RR': 2528,
'BENGALI LETTER YA': 2479,
'BENGALI LETTER YYA': 2527,
'BENGALI RUPEE MARK': 2546,
'BENGALI RUPEE SIGN': 2547,
'BENGALI SIGN ANUSVARA': 2434,
'BENGALI SIGN AVAGRAHA': 2493,
'BENGALI SIGN CANDRABINDU': 2433,
'BENGALI SIGN NUKTA': 2492,
'BENGALI SIGN VIRAMA': 2509,
'BENGALI SIGN VISARGA': 2435,
'BENGALI VOWEL SIGN AA': 2494,
'BENGALI VOWEL SIGN AI': 2504,
'BENGALI VOWEL SIGN AU': 2508,
'BENGALI VOWEL SIGN E': 2503,
'BENGALI VOWEL SIGN I': 2495,
'BENGALI VOWEL SIGN II': 2496,
'BENGALI VOWEL SIGN O': 2507,
'BENGALI VOWEL SIGN U': 2497,
'BENGALI VOWEL SIGN UU': 2498,
'BENGALI VOWEL SIGN VOCALIC L': 2530,
'BENGALI VOWEL SIGN VOCALIC LL': 2531,
'BENGALI VOWEL SIGN VOCALIC R': 2499,
'BENGALI VOWEL SIGN VOCALIC RR': 2500,
'BENZENE RING': 9004,
'BENZENE RING WITH CIRCLE': 9187,
'BET SYMBOL': 8502,
'BETWEEN': 8812,
'BIG REVERSE SOLIDUS': 10745,
'BIG SOLIDUS': 10744,
'BIOHAZARD SIGN': 9763,
'BLACK BOWTIE': 10707,
'BLACK CENTRE WHITE STAR': 10028,
'BLACK CHESS BISHOP': 9821,
'BLACK CHESS KING': 9818,
'BLACK CHESS KNIGHT': 9822,
'BLACK CHESS PAWN': 9823,
'BLACK CHESS QUEEN': 9819,
'BLACK CHESS ROOK': 9820,
'BLACK CIRCLE': 9679,
'BLACK CIRCLE WITH DOWN ARROW': 10733,
'BLACK CIRCLE WITH TWO WHITE DOTS': 9865,
'BLACK CIRCLE WITH WHITE DOT RIGHT': 9864,
'BLACK CLUB SUIT': 9827,
'BLACK CROSS ON SHIELD': 9960,
'BLACK DIAMOND': 9670,
'BLACK DIAMOND MINUS WHITE X': 10070,
'BLACK DIAMOND SUIT': 9830,
'BLACK DIAMOND WITH DOWN ARROW': 10730,
'BLACK DOWN-POINTING SMALL TRIANGLE': 9662,
'BLACK DOWN-POINTING TRIANGLE': 9660,
'BLACK DRAUGHTS KING': 9923,
'BLACK DRAUGHTS MAN': 9922,
'BLACK FLAG': 9873,
'BLACK FLORETTE': 10047,
'BLACK FOUR POINTED STAR': 10022,
'BLACK HEART SUIT': 9829,
'BLACK HEXAGON': 11042,
'BLACK HORIZONTAL ELLIPSE': 11052,
'BLACK HOURGLASS': 10711,
'BLACK LARGE CIRCLE': 11044,
'BLACK LARGE SQUARE': 11035,
'BLACK LEFT LANE MERGE': 9944,
'BLACK LEFT POINTING INDEX': 9754,
'BLACK LEFT-POINTING POINTER': 9668,
'BLACK LEFT-POINTING SMALL TRIANGLE': 9666,
'BLACK LEFT-POINTING TRIANGLE': 9664,
'BLACK LEFTWARDS BULLET': 8268,
'BLACK LOWER LEFT TRIANGLE': 9699,
'BLACK LOWER RIGHT TRIANGLE': 9698,
'BLACK LOZENGE': 10731,
'BLACK MEDIUM DIAMOND': 11045,
'BLACK MEDIUM LOZENGE': 11047,
'BLACK MEDIUM SMALL SQUARE': 9726,
'BLACK MEDIUM SQUARE': 9724,
'BLACK MOON LILITH': 9912,
'BLACK NIB': 10002,
'BLACK PARALLELOGRAM': 9648,
'BLACK PENTAGON': 11039,
'BLACK RECTANGLE': 9644,
'BLACK RIGHT POINTING INDEX': 9755,
'BLACK RIGHT-POINTING PENTAGON': 11091,
'BLACK RIGHT-POINTING POINTER': 9658,
'BLACK RIGHT-POINTING SMALL TRIANGLE': 9656,
'BLACK RIGHT-POINTING TRIANGLE': 9654,
'BLACK RIGHTWARDS ARROW': 10145,
'BLACK RIGHTWARDS ARROWHEAD': 10148,
'BLACK RIGHTWARDS BULLET': 8269,
'BLACK SCISSORS': 9986,
'BLACK SHOGI PIECE': 9751,
'BLACK SMALL DIAMOND': 11049,
'BLACK SMALL LOZENGE': 11050,
'BLACK SMALL SQUARE': 9642,
'BLACK SMALL STAR': 11089,
'BLACK SMILING FACE': 9787,
'BLACK SNOWMAN': 9927,
'BLACK SPADE SUIT': 9824,
'BLACK SQUARE': 9632,
'BLACK STAR': 9733,
'BLACK SUN WITH RAYS': 9728,
'BLACK TELEPHONE': 9742,
'BLACK TRUCK': 9951,
'BLACK TWO-WAY LEFT WAY TRAFFIC': 9942,
'BLACK UNIVERSAL RECYCLING SYMBOL': 9851,
'BLACK UP-POINTING SMALL TRIANGLE': 9652,
'BLACK UP-POINTING TRIANGLE': 9650,
'BLACK UPPER LEFT TRIANGLE': 9700,
'BLACK UPPER RIGHT TRIANGLE': 9701,
'BLACK VERTICAL ELLIPSE': 11054,
'BLACK VERTICAL RECTANGLE': 9646,
'BLACK VERY SMALL SQUARE': 11037,
'BLACK-FEATHERED NORTH EAST ARROW': 10166,
'BLACK-FEATHERED RIGHTWARDS ARROW': 10165,
'BLACK-FEATHERED SOUTH EAST ARROW': 10164,
'BLACK-LETTER CAPITAL C': 8493,
'BLACK-LETTER CAPITAL H': 8460,
'BLACK-LETTER CAPITAL I': 8465,
'BLACK-LETTER CAPITAL R': 8476,
'BLACK-LETTER CAPITAL Z': 8488,
'BLANK SYMBOL': 9250,
'BOPOMOFO FINAL LETTER H': 12727,
'BOPOMOFO FINAL LETTER K': 12726,
'BOPOMOFO FINAL LETTER P': 12724,
'BOPOMOFO FINAL LETTER T': 12725,
'BOPOMOFO LETTER A': 12570,
'BOPOMOFO LETTER AI': 12574,
'BOPOMOFO LETTER AINN': 12718,
'BOPOMOFO LETTER AM': 12720,
'BOPOMOFO LETTER AN': 12578,
'BOPOMOFO LETTER ANG': 12580,
'BOPOMOFO LETTER ANN': 12713,
'BOPOMOFO LETTER AU': 12576,
'BOPOMOFO LETTER AUNN': 12719,
'BOPOMOFO LETTER B': 12549,
'BOPOMOFO LETTER BU': 12704,
'BOPOMOFO LETTER C': 12568,
'BOPOMOFO LETTER CH': 12564,
'BOPOMOFO LETTER D': 12553,
'BOPOMOFO LETTER E': 12572,
'BOPOMOFO LETTER EE': 12708,
'BOPOMOFO LETTER EH': 12573,
'BOPOMOFO LETTER EI': 12575,
'BOPOMOFO LETTER EN': 12579,
'BOPOMOFO LETTER ENG': 12581,
'BOPOMOFO LETTER ENN': 12709,
'BOPOMOFO LETTER ER': 12582,
'BOPOMOFO LETTER F': 12552,
'BOPOMOFO LETTER G': 12557,
'BOPOMOFO LETTER GN': 12588,
'BOPOMOFO LETTER GU': 12707,
'BOPOMOFO LETTER H': 12559,
'BOPOMOFO LETTER I': 12583,
'BOPOMOFO LETTER IH': 12589,
'BOPOMOFO LETTER IM': 12716,
'BOPOMOFO LETTER INN': 12714,
'BOPOMOFO LETTER INNN': 12723,
'BOPOMOFO LETTER IR': 12712,
'BOPOMOFO LETTER IU': 12585,
'BOPOMOFO LETTER J': 12560,
'BOPOMOFO LETTER JI': 12706,
'BOPOMOFO LETTER K': 12558,
'BOPOMOFO LETTER L': 12556,
'BOPOMOFO LETTER M': 12551,
'BOPOMOFO LETTER N': 12555,
'BOPOMOFO LETTER NG': 12587,
'BOPOMOFO LETTER NGG': 12717,
'BOPOMOFO LETTER O': 12571,
'BOPOMOFO LETTER OM': 12721,
'BOPOMOFO LETTER ONG': 12722,
'BOPOMOFO LETTER ONN': 12711,
'BOPOMOFO LETTER OO': 12710,
'BOPOMOFO LETTER OU': 12577,
'BOPOMOFO LETTER P': 12550,
'BOPOMOFO LETTER Q': 12561,
'BOPOMOFO LETTER R': 12566,
'BOPOMOFO LETTER S': 12569,
'BOPOMOFO LETTER SH': 12565,
'BOPOMOFO LETTER T': 12554,
'BOPOMOFO LETTER U': 12584,
'BOPOMOFO LETTER UNN': 12715,
'BOPOMOFO LETTER V': 12586,
'BOPOMOFO LETTER X': 12562,
'BOPOMOFO LETTER Z': 12567,
'BOPOMOFO LETTER ZH': 12563,
'BOPOMOFO LETTER ZI': 12705,
'BOTTOM ARC ANTICLOCKWISE ARROW': 10555,
'BOTTOM CURLY BRACKET': 9183,
'BOTTOM HALF INTEGRAL': 8993,
'BOTTOM LEFT CORNER': 8990,
'BOTTOM LEFT CROP': 8973,
'BOTTOM LEFT HALF BRACKET': 11812,
'BOTTOM PARENTHESIS': 9181,
'BOTTOM RIGHT CORNER': 8991,
'BOTTOM RIGHT CROP': 8972,
'BOTTOM RIGHT HALF BRACKET': 11813,
'BOTTOM SQUARE BRACKET': 9141,
'BOTTOM SQUARE BRACKET OVER TOP SQUARE BRACKET': 9142,
'BOTTOM TORTOISE SHELL BRACKET': 9185,
'BOWTIE': 8904,
'BOWTIE WITH LEFT HALF BLACK': 10705,
'BOWTIE WITH RIGHT HALF BLACK': 10706,
'BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL': 9574,
'BOX DRAWINGS DOUBLE DOWN AND LEFT': 9559,
'BOX DRAWINGS DOUBLE DOWN AND RIGHT': 9556,
'BOX DRAWINGS DOUBLE HORIZONTAL': 9552,
'BOX DRAWINGS DOUBLE UP AND HORIZONTAL': 9577,
'BOX DRAWINGS DOUBLE UP AND LEFT': 9565,
'BOX DRAWINGS DOUBLE UP AND RIGHT': 9562,
'BOX DRAWINGS DOUBLE VERTICAL': 9553,
'BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL': 9580,
'BOX DRAWINGS DOUBLE VERTICAL AND LEFT': 9571,
'BOX DRAWINGS DOUBLE VERTICAL AND RIGHT': 9568,
'BOX DRAWINGS DOWN DOUBLE AND HORIZONTAL SINGLE': 9573,
'BOX DRAWINGS DOWN DOUBLE AND LEFT SINGLE': 9558,
'BOX DRAWINGS DOWN DOUBLE AND RIGHT SINGLE': 9555,
'BOX DRAWINGS DOWN HEAVY AND HORIZONTAL LIGHT': 9520,
'BOX DRAWINGS DOWN HEAVY AND LEFT LIGHT': 9490,
'BOX DRAWINGS DOWN HEAVY AND LEFT UP LIGHT': 9511,
'BOX DRAWINGS DOWN HEAVY AND RIGHT LIGHT': 9486,
'BOX DRAWINGS DOWN HEAVY AND RIGHT UP LIGHT': 9503,
'BOX DRAWINGS DOWN HEAVY AND UP HORIZONTAL LIGHT': 9537,
'BOX DRAWINGS DOWN LIGHT AND HORIZONTAL HEAVY': 9519,
'BOX DRAWINGS DOWN LIGHT AND LEFT HEAVY': 9489,
'BOX DRAWINGS DOWN LIGHT AND LEFT UP HEAVY': 9513,
'BOX DRAWINGS DOWN LIGHT AND RIGHT HEAVY': 9485,
'BOX DRAWINGS DOWN LIGHT AND RIGHT UP HEAVY': 9505,
'BOX DRAWINGS DOWN LIGHT AND UP HORIZONTAL HEAVY': 9543,
'BOX DRAWINGS DOWN SINGLE AND HORIZONTAL DOUBLE': 9572,
'BOX DRAWINGS DOWN SINGLE AND LEFT DOUBLE': 9557,
'BOX DRAWINGS DOWN SINGLE AND RIGHT DOUBLE': 9554,
'BOX DRAWINGS HEAVY DOUBLE DASH HORIZONTAL': 9549,
'BOX DRAWINGS HEAVY DOUBLE DASH VERTICAL': 9551,
'BOX DRAWINGS HEAVY DOWN': 9595,
'BOX DRAWINGS HEAVY DOWN AND HORIZONTAL': 9523,
'BOX DRAWINGS HEAVY DOWN AND LEFT': 9491,
'BOX DRAWINGS HEAVY DOWN AND RIGHT': 9487,
'BOX DRAWINGS HEAVY HORIZONTAL': 9473,
'BOX DRAWINGS HEAVY LEFT': 9592,
'BOX DRAWINGS HEAVY LEFT AND LIGHT RIGHT': 9598,
'BOX DRAWINGS HEAVY QUADRUPLE DASH HORIZONTAL': 9481,
'BOX DRAWINGS HEAVY QUADRUPLE DASH VERTICAL': 9483,
'BOX DRAWINGS HEAVY RIGHT': 9594,
'BOX DRAWINGS HEAVY TRIPLE DASH HORIZONTAL': 9477,
'BOX DRAWINGS HEAVY TRIPLE DASH VERTICAL': 9479,
'BOX DRAWINGS HEAVY UP': 9593,
'BOX DRAWINGS HEAVY UP AND HORIZONTAL': 9531,
'BOX DRAWINGS HEAVY UP AND LEFT': 9499,
'BOX DRAWINGS HEAVY UP AND LIGHT DOWN': 9599,
'BOX DRAWINGS HEAVY UP AND RIGHT': 9495,
'BOX DRAWINGS HEAVY VERTICAL': 9475,
'BOX DRAWINGS HEAVY VERTICAL AND HORIZONTAL': 9547,
'BOX DRAWINGS HEAVY VERTICAL AND LEFT': 9515,
'BOX DRAWINGS HEAVY VERTICAL AND RIGHT': 9507,
'BOX DRAWINGS LEFT DOWN HEAVY AND RIGHT UP LIGHT': 9541,
'BOX DRAWINGS LEFT HEAVY AND RIGHT DOWN LIGHT': 9517,
'BOX DRAWINGS LEFT HEAVY AND RIGHT UP LIGHT': 9525,
'BOX DRAWINGS LEFT HEAVY AND RIGHT VERTICAL LIGHT': 9533,
'BOX DRAWINGS LEFT LIGHT AND RIGHT DOWN HEAVY': 9522,
'BOX DRAWINGS LEFT LIGHT AND RIGHT UP HEAVY': 9530,
'BOX DRAWINGS LEFT LIGHT AND RIGHT VERTICAL HEAVY': 9546,
'BOX DRAWINGS LEFT UP HEAVY AND RIGHT DOWN LIGHT': 9539,
'BOX DRAWINGS LIGHT ARC DOWN AND LEFT': 9582,
'BOX DRAWINGS LIGHT ARC DOWN AND RIGHT': 9581,
'BOX DRAWINGS LIGHT ARC UP AND LEFT': 9583,
'BOX DRAWINGS LIGHT ARC UP AND RIGHT': 9584,
'BOX DRAWINGS LIGHT DIAGONAL CROSS': 9587,
'BOX DRAWINGS LIGHT DIAGONAL UPPER LEFT TO LOWER RIGHT': 9586,
'BOX DRAWINGS LIGHT DIAGONAL UPPER RIGHT TO LOWER LEFT': 9585,
'BOX DRAWINGS LIGHT DOUBLE DASH HORIZONTAL': 9548,
'BOX DRAWINGS LIGHT DOUBLE DASH VERTICAL': 9550,
'BOX DRAWINGS LIGHT DOWN': 9591,
'BOX DRAWINGS LIGHT DOWN AND HORIZONTAL': 9516,
'BOX DRAWINGS LIGHT DOWN AND LEFT': 9488,
'BOX DRAWINGS LIGHT DOWN AND RIGHT': 9484,
'BOX DRAWINGS LIGHT HORIZONTAL': 9472,
'BOX DRAWINGS LIGHT LEFT': 9588,
'BOX DRAWINGS LIGHT LEFT AND HEAVY RIGHT': 9596,
'BOX DRAWINGS LIGHT QUADRUPLE DASH HORIZONTAL': 9480,
'BOX DRAWINGS LIGHT QUADRUPLE DASH VERTICAL': 9482,
'BOX DRAWINGS LIGHT RIGHT': 9590,
'BOX DRAWINGS LIGHT TRIPLE DASH HORIZONTAL': 9476,
'BOX DRAWINGS LIGHT TRIPLE DASH VERTICAL': 9478,
'BOX DRAWINGS LIGHT UP': 9589,
'BOX DRAWINGS LIGHT UP AND HEAVY DOWN': 9597,
'BOX DRAWINGS LIGHT UP AND HORIZONTAL': 9524,
'BOX DRAWINGS LIGHT UP AND LEFT': 9496,
'BOX DRAWINGS LIGHT UP AND RIGHT': 9492,
'BOX DRAWINGS LIGHT VERTICAL': 9474,
'BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL': 9532,
'BOX DRAWINGS LIGHT VERTICAL AND LEFT': 9508,
'BOX DRAWINGS LIGHT VERTICAL AND RIGHT': 9500,
'BOX DRAWINGS RIGHT DOWN HEAVY AND LEFT UP LIGHT': 9542,
'BOX DRAWINGS RIGHT HEAVY AND LEFT DOWN LIGHT': 9518,
'BOX DRAWINGS RIGHT HEAVY AND LEFT UP LIGHT': 9526,
'BOX DRAWINGS RIGHT HEAVY AND LEFT VERTICAL LIGHT': 9534,
'BOX DRAWINGS RIGHT LIGHT AND LEFT DOWN HEAVY': 9521,
'BOX DRAWINGS RIGHT LIGHT AND LEFT UP HEAVY': 9529,
'BOX DRAWINGS RIGHT LIGHT AND LEFT VERTICAL HEAVY': 9545,
'BOX DRAWINGS RIGHT UP HEAVY AND LEFT DOWN LIGHT': 9540,
'BOX DRAWINGS UP DOUBLE AND HORIZONTAL SINGLE': 9576,
'BOX DRAWINGS UP DOUBLE AND LEFT SINGLE': 9564,
'BOX DRAWINGS UP DOUBLE AND RIGHT SINGLE': 9561,
'BOX DRAWINGS UP HEAVY AND DOWN HORIZONTAL LIGHT': 9536,
'BOX DRAWINGS UP HEAVY AND HORIZONTAL LIGHT': 9528,
'BOX DRAWINGS UP HEAVY AND LEFT DOWN LIGHT': 9510,
'BOX DRAWINGS UP HEAVY AND LEFT LIGHT': 9498,
'BOX DRAWINGS UP HEAVY AND RIGHT DOWN LIGHT': 9502,
'BOX DRAWINGS UP HEAVY AND RIGHT LIGHT': 9494,
'BOX DRAWINGS UP LIGHT AND DOWN HORIZONTAL HEAVY': 9544,
'BOX DRAWINGS UP LIGHT AND HORIZONTAL HEAVY': 9527,
'BOX DRAWINGS UP LIGHT AND LEFT DOWN HEAVY': 9514,
'BOX DRAWINGS UP LIGHT AND LEFT HEAVY': 9497,
'BOX DRAWINGS UP LIGHT AND RIGHT DOWN HEAVY': 9506,
'BOX DRAWINGS UP LIGHT AND RIGHT HEAVY': 9493,
'BOX DRAWINGS UP SINGLE AND HORIZONTAL DOUBLE': 9575,
'BOX DRAWINGS UP SINGLE AND LEFT DOUBLE': 9563,
'BOX DRAWINGS UP SINGLE AND RIGHT DOUBLE': 9560,
'BOX DRAWINGS VERTICAL DOUBLE AND HORIZONTAL SINGLE': 9579,
'BOX DRAWINGS VERTICAL DOUBLE AND LEFT SINGLE': 9570,
'BOX DRAWINGS VERTICAL DOUBLE AND RIGHT SINGLE': 9567,
'BOX DRAWINGS VERTICAL HEAVY AND HORIZONTAL LIGHT': 9538,
'BOX DRAWINGS VERTICAL HEAVY AND LEFT LIGHT': 9512,
'BOX DRAWINGS VERTICAL HEAVY AND RIGHT LIGHT': 9504,
'BOX DRAWINGS VERTICAL LIGHT AND HORIZONTAL HEAVY': 9535,
'BOX DRAWINGS VERTICAL LIGHT AND LEFT HEAVY': 9509,
'BOX DRAWINGS VERTICAL LIGHT AND RIGHT HEAVY': 9501,
'BOX DRAWINGS VERTICAL SINGLE AND HORIZONTAL DOUBLE': 9578,
'BOX DRAWINGS VERTICAL SINGLE AND LEFT DOUBLE': 9569,
'BOX DRAWINGS VERTICAL SINGLE AND RIGHT DOUBLE': 9566,
'BRAILLE PATTERN BLANK': 10240,
'BRAILLE PATTERN DOTS-1': 10241,
'BRAILLE PATTERN DOTS-12': 10243,
'BRAILLE PATTERN DOTS-123': 10247,
'BRAILLE PATTERN DOTS-1234': 10255,
'BRAILLE PATTERN DOTS-12345': 10271,
'BRAILLE PATTERN DOTS-123456': 10303,
'BRAILLE PATTERN DOTS-1234567': 10367,
'BRAILLE PATTERN DOTS-12345678': 10495,
'BRAILLE PATTERN DOTS-1234568': 10431,
'BRAILLE PATTERN DOTS-123457': 10335,
'BRAILLE PATTERN DOTS-1234578': 10463,
'BRAILLE PATTERN DOTS-123458': 10399,
'BRAILLE PATTERN DOTS-12346': 10287,
'BRAILLE PATTERN DOTS-123467': 10351,
'BRAILLE PATTERN DOTS-1234678': 10479,
'BRAILLE PATTERN DOTS-123468': 10415,
'BRAILLE PATTERN DOTS-12347': 10319,
'BRAILLE PATTERN DOTS-123478': 10447,
'BRAILLE PATTERN DOTS-12348': 10383,
'BRAILLE PATTERN DOTS-1235': 10263,
'BRAILLE PATTERN DOTS-12356': 10295,
'BRAILLE PATTERN DOTS-123567': 10359,
'BRAILLE PATTERN DOTS-1235678': 10487,
'BRAILLE PATTERN DOTS-123568': 10423,
'BRAILLE PATTERN DOTS-12357': 10327,
'BRAILLE PATTERN DOTS-123578': 10455,
'BRAILLE PATTERN DOTS-12358': 10391,
'BRAILLE PATTERN DOTS-1236': 10279,
'BRAILLE PATTERN DOTS-12367': 10343,
'BRAILLE PATTERN DOTS-123678': 10471,
'BRAILLE PATTERN DOTS-12368': 10407,
'BRAILLE PATTERN DOTS-1237': 10311,
'BRAILLE PATTERN DOTS-12378': 10439,
'BRAILLE PATTERN DOTS-1238': 10375,
'BRAILLE PATTERN DOTS-124': 10251,
'BRAILLE PATTERN DOTS-1245': 10267,
'BRAILLE PATTERN DOTS-12456': 10299,
'BRAILLE PATTERN DOTS-124567': 10363,
'BRAILLE PATTERN DOTS-1245678': 10491,
'BRAILLE PATTERN DOTS-124568': 10427,
'BRAILLE PATTERN DOTS-12457': 10331,
'BRAILLE PATTERN DOTS-124578': 10459,
'BRAILLE PATTERN DOTS-12458': 10395,
'BRAILLE PATTERN DOTS-1246': 10283,
'BRAILLE PATTERN DOTS-12467': 10347,
'BRAILLE PATTERN DOTS-124678': 10475,
'BRAILLE PATTERN DOTS-12468': 10411,
'BRAILLE PATTERN DOTS-1247': 10315,
'BRAILLE PATTERN DOTS-12478': 10443,
'BRAILLE PATTERN DOTS-1248': 10379,
'BRAILLE PATTERN DOTS-125': 10259,
'BRAILLE PATTERN DOTS-1256': 10291,
'BRAILLE PATTERN DOTS-12567': 10355,
'BRAILLE PATTERN DOTS-125678': 10483,
'BRAILLE PATTERN DOTS-12568': 10419,
'BRAILLE PATTERN DOTS-1257': 10323,
'BRAILLE PATTERN DOTS-12578': 10451,
'BRAILLE PATTERN DOTS-1258': 10387,
'BRAILLE PATTERN DOTS-126': 10275,
'BRAILLE PATTERN DOTS-1267': 10339,
'BRAILLE PATTERN DOTS-12678': 10467,
'BRAILLE PATTERN DOTS-1268': 10403,
'BRAILLE PATTERN DOTS-127': 10307,
'BRAILLE PATTERN DOTS-1278': 10435,
'BRAILLE PATTERN DOTS-128': 10371,
'BRAILLE PATTERN DOTS-13': 10245,
'BRAILLE PATTERN DOTS-134': 10253,
'BRAILLE PATTERN DOTS-1345': 10269,
'BRAILLE PATTERN DOTS-13456': 10301,
'BRAILLE PATTERN DOTS-134567': 10365,
'BRAILLE PATTERN DOTS-1345678': 10493,
'BRAILLE PATTERN DOTS-134568': 10429,
'BRAILLE PATTERN DOTS-13457': 10333,
'BRAILLE PATTERN DOTS-134578': 10461,
'BRAILLE PATTERN DOTS-13458': 10397,
'BRAILLE PATTERN DOTS-1346': 10285,
'BRAILLE PATTERN DOTS-13467': 10349,
'BRAILLE PATTERN DOTS-134678': 10477,
'BRAILLE PATTERN DOTS-13468': 10413,
'BRAILLE PATTERN DOTS-1347': 10317,
'BRAILLE PATTERN DOTS-13478': 10445,
'BRAILLE PATTERN DOTS-1348': 10381,
'BRAILLE PATTERN DOTS-135': 10261,
'BRAILLE PATTERN DOTS-1356': 10293,
'BRAILLE PATTERN DOTS-13567': 10357,
'BRAILLE PATTERN DOTS-135678': 10485,
'BRAILLE PATTERN DOTS-13568': 10421,
'BRAILLE PATTERN DOTS-1357': 10325,
'BRAILLE PATTERN DOTS-13578': 10453,
'BRAILLE PATTERN DOTS-1358': 10389,
'BRAILLE PATTERN DOTS-136': 10277,
'BRAILLE PATTERN DOTS-1367': 10341,
'BRAILLE PATTERN DOTS-13678': 10469,
'BRAILLE PATTERN DOTS-1368': 10405,
'BRAILLE PATTERN DOTS-137': 10309,
'BRAILLE PATTERN DOTS-1378': 10437,
'BRAILLE PATTERN DOTS-138': 10373,
'BRAILLE PATTERN DOTS-14': 10249,
'BRAILLE PATTERN DOTS-145': 10265,
'BRAILLE PATTERN DOTS-1456': 10297,
'BRAILLE PATTERN DOTS-14567': 10361,
'BRAILLE PATTERN DOTS-145678': 10489,
'BRAILLE PATTERN DOTS-14568': 10425,
'BRAILLE PATTERN DOTS-1457': 10329,
'BRAILLE PATTERN DOTS-14578': 10457,
'BRAILLE PATTERN DOTS-1458': 10393,
'BRAILLE PATTERN DOTS-146': 10281,
'BRAILLE PATTERN DOTS-1467': 10345,
'BRAILLE PATTERN DOTS-14678': 10473,
'BRAILLE PATTERN DOTS-1468': 10409,
'BRAILLE PATTERN DOTS-147': 10313,
'BRAILLE PATTERN DOTS-1478': 10441,
'BRAILLE PATTERN DOTS-148': 10377,
'BRAILLE PATTERN DOTS-15': 10257,
'BRAILLE PATTERN DOTS-156': 10289,
'BRAILLE PATTERN DOTS-1567': 10353,
'BRAILLE PATTERN DOTS-15678': 10481,
'BRAILLE PATTERN DOTS-1568': 10417,
'BRAILLE PATTERN DOTS-157': 10321,
'BRAILLE PATTERN DOTS-1578': 10449,
'BRAILLE PATTERN DOTS-158': 10385,
'BRAILLE PATTERN DOTS-16': 10273,
'BRAILLE PATTERN DOTS-167': 10337,
'BRAILLE PATTERN DOTS-1678': 10465,
'BRAILLE PATTERN DOTS-168': 10401,
'BRAILLE PATTERN DOTS-17': 10305,
'BRAILLE PATTERN DOTS-178': 10433,
'BRAILLE PATTERN DOTS-18': 10369,
'BRAILLE PATTERN DOTS-2': 10242,
'BRAILLE PATTERN DOTS-23': 10246,
'BRAILLE PATTERN DOTS-234': 10254,
'BRAILLE PATTERN DOTS-2345': 10270,
'BRAILLE PATTERN DOTS-23456': 10302,
'BRAILLE PATTERN DOTS-234567': 10366,
'BRAILLE PATTERN DOTS-2345678': 10494,
'BRAILLE PATTERN DOTS-234568': 10430,
'BRAILLE PATTERN DOTS-23457': 10334,
'BRAILLE PATTERN DOTS-234578': 10462,
'BRAILLE PATTERN DOTS-23458': 10398,
'BRAILLE PATTERN DOTS-2346': 10286,
'BRAILLE PATTERN DOTS-23467': 10350,
'BRAILLE PATTERN DOTS-234678': 10478,
'BRAILLE PATTERN DOTS-23468': 10414,
'BRAILLE PATTERN DOTS-2347': 10318,
'BRAILLE PATTERN DOTS-23478': 10446,
'BRAILLE PATTERN DOTS-2348': 10382,
'BRAILLE PATTERN DOTS-235': 10262,
'BRAILLE PATTERN DOTS-2356': 10294,
'BRAILLE PATTERN DOTS-23567': 10358,
'BRAILLE PATTERN DOTS-235678': 10486,
'BRAILLE PATTERN DOTS-23568': 10422,
'BRAILLE PATTERN DOTS-2357': 10326,
'BRAILLE PATTERN DOTS-23578': 10454,
'BRAILLE PATTERN DOTS-2358': 10390,
'BRAILLE PATTERN DOTS-236': 10278,
'BRAILLE PATTERN DOTS-2367': 10342,
'BRAILLE PATTERN DOTS-23678': 10470,
'BRAILLE PATTERN DOTS-2368': 10406,
'BRAILLE PATTERN DOTS-237': 10310,
'BRAILLE PATTERN DOTS-2378': 10438,
'BRAILLE PATTERN DOTS-238': 10374,
'BRAILLE PATTERN DOTS-24': 10250,
'BRAILLE PATTERN DOTS-245': 10266,
'BRAILLE PATTERN DOTS-2456': 10298,
'BRAILLE PATTERN DOTS-24567': 10362,
'BRAILLE PATTERN DOTS-245678': 10490,
'BRAILLE PATTERN DOTS-24568': 10426,
'BRAILLE PATTERN DOTS-2457': 10330,
'BRAILLE PATTERN DOTS-24578': 10458,
'BRAILLE PATTERN DOTS-2458': 10394,
'BRAILLE PATTERN DOTS-246': 10282,
'BRAILLE PATTERN DOTS-2467': 10346,
'BRAILLE PATTERN DOTS-24678': 10474,
'BRAILLE PATTERN DOTS-2468': 10410,
'BRAILLE PATTERN DOTS-247': 10314,
'BRAILLE PATTERN DOTS-2478': 10442,
'BRAILLE PATTERN DOTS-248': 10378,
'BRAILLE PATTERN DOTS-25': 10258,
'BRAILLE PATTERN DOTS-256': 10290,
'BRAILLE PATTERN DOTS-2567': 10354,
'BRAILLE PATTERN DOTS-25678': 10482,
'BRAILLE PATTERN DOTS-2568': 10418,
'BRAILLE PATTERN DOTS-257': 10322,
'BRAILLE PATTERN DOTS-2578': 10450,
'BRAILLE PATTERN DOTS-258': 10386,
'BRAILLE PATTERN DOTS-26': 10274,
'BRAILLE PATTERN DOTS-267': 10338,
'BRAILLE PATTERN DOTS-2678': 10466,
'BRAILLE PATTERN DOTS-268': 10402,
'BRAILLE PATTERN DOTS-27': 10306,
'BRAILLE PATTERN DOTS-278': 10434,
'BRAILLE PATTERN DOTS-28': 10370,
'BRAILLE PATTERN DOTS-3': 10244,
'BRAILLE PATTERN DOTS-34': 10252,
'BRAILLE PATTERN DOTS-345': 10268,
'BRAILLE PATTERN DOTS-3456': 10300,
'BRAILLE PATTERN DOTS-34567': 10364,
'BRAILLE PATTERN DOTS-345678': 10492,
'BRAILLE PATTERN DOTS-34568': 10428,
'BRAILLE PATTERN DOTS-3457': 10332,
'BRAILLE PATTERN DOTS-34578': 10460,
'BRAILLE PATTERN DOTS-3458': 10396,
'BRAILLE PATTERN DOTS-346': 10284,
'BRAILLE PATTERN DOTS-3467': 10348,
'BRAILLE PATTERN DOTS-34678': 10476,
'BRAILLE PATTERN DOTS-3468': 10412,
'BRAILLE PATTERN DOTS-347': 10316,
'BRAILLE PATTERN DOTS-3478': 10444,
'BRAILLE PATTERN DOTS-348': 10380,
'BRAILLE PATTERN DOTS-35': 10260,
'BRAILLE PATTERN DOTS-356': 10292,
'BRAILLE PATTERN DOTS-3567': 10356,
'BRAILLE PATTERN DOTS-35678': 10484,
'BRAILLE PATTERN DOTS-3568': 10420,
'BRAILLE PATTERN DOTS-357': 10324,
'BRAILLE PATTERN DOTS-3578': 10452,
'BRAILLE PATTERN DOTS-358': 10388,
'BRAILLE PATTERN DOTS-36': 10276,
'BRAILLE PATTERN DOTS-367': 10340,
'BRAILLE PATTERN DOTS-3678': 10468,
'BRAILLE PATTERN DOTS-368': 10404,
'BRAILLE PATTERN DOTS-37': 10308,
'BRAILLE PATTERN DOTS-378': 10436,
'BRAILLE PATTERN DOTS-38': 10372,
'BRAILLE PATTERN DOTS-4': 10248,
'BRAILLE PATTERN DOTS-45': 10264,
'BRAILLE PATTERN DOTS-456': 10296,
'BRAILLE PATTERN DOTS-4567': 10360,
'BRAILLE PATTERN DOTS-45678': 10488,
'BRAILLE PATTERN DOTS-4568': 10424,
'BRAILLE PATTERN DOTS-457': 10328,
'BRAILLE PATTERN DOTS-4578': 10456,
'BRAILLE PATTERN DOTS-458': 10392,
'BRAILLE PATTERN DOTS-46': 10280,
'BRAILLE PATTERN DOTS-467': 10344,
'BRAILLE PATTERN DOTS-4678': 10472,
'BRAILLE PATTERN DOTS-468': 10408,
'BRAILLE PATTERN DOTS-47': 10312,
'BRAILLE PATTERN DOTS-478': 10440,
'BRAILLE PATTERN DOTS-48': 10376,
'BRAILLE PATTERN DOTS-5': 10256,
'BRAILLE PATTERN DOTS-56': 10288,
'BRAILLE PATTERN DOTS-567': 10352,
'BRAILLE PATTERN DOTS-5678': 10480,
'BRAILLE PATTERN DOTS-568': 10416,
'BRAILLE PATTERN DOTS-57': 10320,
'BRAILLE PATTERN DOTS-578': 10448,
'BRAILLE PATTERN DOTS-58': 10384,
'BRAILLE PATTERN DOTS-6': 10272,
'BRAILLE PATTERN DOTS-67': 10336,
'BRAILLE PATTERN DOTS-678': 10464,
'BRAILLE PATTERN DOTS-68': 10400,
'BRAILLE PATTERN DOTS-7': 10304,
'BRAILLE PATTERN DOTS-78': 10432,
'BRAILLE PATTERN DOTS-8': 10368,
'BREVE': 728,
'BROKEN BAR': 166,
'BROKEN CIRCLE WITH NORTHWEST ARROW': 9099,
'BUGINESE END OF SECTION': 6687,
'BUGINESE LETTER A': 6677,
'BUGINESE LETTER BA': 6661,
'BUGINESE LETTER CA': 6668,
'BUGINESE LETTER DA': 6665,
'BUGINESE LETTER GA': 6657,
'BUGINESE LETTER HA': 6678,
'BUGINESE LETTER JA': 6669,
'BUGINESE LETTER KA': 6656,
'BUGINESE LETTER LA': 6674,
'BUGINESE LETTER MA': 6662,
'BUGINESE LETTER MPA': 6663,
'BUGINESE LETTER NA': 6666,
'BUGINESE LETTER NGA': 6658,
'BUGINESE LETTER NGKA': 6659,
'BUGINESE LETTER NRA': 6667,
'BUGINESE LETTER NYA': 6670,
'BUGINESE LETTER NYCA': 6671,
'BUGINESE LETTER PA': 6660,
'BUGINESE LETTER RA': 6673,
'BUGINESE LETTER SA': 6676,
'BUGINESE LETTER TA': 6664,
'BUGINESE LETTER VA': 6675,
'BUGINESE LETTER YA': 6672,
'BUGINESE PALLAWA': 6686,
'BUGINESE VOWEL SIGN AE': 6683,
'BUGINESE VOWEL SIGN E': 6681,
'BUGINESE VOWEL SIGN I': 6679,
'BUGINESE VOWEL SIGN O': 6682,
'BUGINESE VOWEL SIGN U': 6680,
'BUHID LETTER A': 5952,
'BUHID LETTER BA': 5962,
'BUHID LETTER DA': 5959,
'BUHID LETTER GA': 5956,
'BUHID LETTER HA': 5969,
'BUHID LETTER I': 5953,
'BUHID LETTER KA': 5955,
'BUHID LETTER LA': 5966,
'BUHID LETTER MA': 5963,
'BUHID LETTER NA': 5960,
'BUHID LETTER NGA': 5957,
'BUHID LETTER PA': 5961,
'BUHID LETTER RA': 5965,
'BUHID LETTER SA': 5968,
'BUHID LETTER TA': 5958,
'BUHID LETTER U': 5954,
'BUHID LETTER WA': 5967,
'BUHID LETTER YA': 5964,
'BUHID VOWEL SIGN I': 5970,
'BUHID VOWEL SIGN U': 5971,
'BULLET': 8226,
'BULLET OPERATOR': 8729,
'BULLSEYE': 9678,
'BYZANTINE MUSICAL SYMBOL AGOGI ARGI': 118940,
'BYZANTINE MUSICAL SYMBOL AGOGI ARGOTERI': 118939,
'BYZANTINE MUSICAL SYMBOL AGOGI GORGI': 118943,
'BYZANTINE MUSICAL SYMBOL AGOGI GORGOTERI': 118944,
'BYZANTINE MUSICAL SYMBOL AGOGI MESI': 118942,
'BYZANTINE MUSICAL SYMBOL AGOGI METRIA': 118941,
'BYZANTINE MUSICAL SYMBOL AGOGI POLI ARGI': 118938,
'BYZANTINE MUSICAL SYMBOL AGOGI POLI GORGI': 118945,
'BYZANTINE MUSICAL SYMBOL ANATRICHISMA': 118824,
'BYZANTINE MUSICAL SYMBOL ANTIKENOKYLISMA': 118882,
'BYZANTINE MUSICAL SYMBOL ANTIKENOMA': 118876,
'BYZANTINE MUSICAL SYMBOL APESO EKFONITIKON': 118797,
'BYZANTINE MUSICAL SYMBOL APESO EXO NEO': 118835,
'BYZANTINE MUSICAL SYMBOL APLI': 118917,
'BYZANTINE MUSICAL SYMBOL APODERMA ARCHAION': 118818,
'BYZANTINE MUSICAL SYMBOL APODERMA NEO': 118916,
'BYZANTINE MUSICAL SYMBOL APOSTROFOI SYNDESMOS NEO': 118866,
'BYZANTINE MUSICAL SYMBOL APOSTROFOI TELOUS ICHIMATOS': 118957,
'BYZANTINE MUSICAL SYMBOL APOSTROFOS': 118801,
'BYZANTINE MUSICAL SYMBOL APOSTROFOS DIPLI': 118802,
'BYZANTINE MUSICAL SYMBOL APOSTROFOS NEO': 118865,
'BYZANTINE MUSICAL SYMBOL APOTHEMA': 118819,
'BYZANTINE MUSICAL SYMBOL ARGON': 118935,
'BYZANTINE MUSICAL SYMBOL ARGOSYNTHETON': 118899,
'BYZANTINE MUSICAL SYMBOL ARKTIKO DI': 119020,
'BYZANTINE MUSICAL SYMBOL ARKTIKO GA': 119019,
'BYZANTINE MUSICAL SYMBOL ARKTIKO KE': 119021,
'BYZANTINE MUSICAL SYMBOL ARKTIKO NI': 119023,
'BYZANTINE MUSICAL SYMBOL ARKTIKO PA': 119017,
'BYZANTINE MUSICAL SYMBOL ARKTIKO VOU': 119018,
'BYZANTINE MUSICAL SYMBOL ARKTIKO ZO': 119022,
'BYZANTINE MUSICAL SYMBOL CHAMILI': 118870,
'BYZANTINE MUSICAL SYMBOL CHAMILON': 118808,
'BYZANTINE MUSICAL SYMBOL CHOREVMA ARCHAION': 118843,
'BYZANTINE MUSICAL SYMBOL CHOREVMA NEO': 118887,
'BYZANTINE MUSICAL SYMBOL CHROA KLITON': 118985,
'BYZANTINE MUSICAL SYMBOL CHROA SPATHI': 118986,
'BYZANTINE MUSICAL SYMBOL CHROA ZYGOS': 118984,
'BYZANTINE MUSICAL SYMBOL DASEIA': 118785,
'BYZANTINE MUSICAL SYMBOL DIARGON': 118937,
'BYZANTINE MUSICAL SYMBOL DIASTOLI APLI MEGALI': 119003,
'BYZANTINE MUSICAL SYMBOL DIASTOLI APLI MIKRI': 119002,
'BYZANTINE MUSICAL SYMBOL DIASTOLI DIPLI': 119004,
'BYZANTINE MUSICAL SYMBOL DIASTOLI THESEOS': 119005,
'BYZANTINE MUSICAL SYMBOL DIESIS APLI DYO DODEKATA': 118992,
'BYZANTINE MUSICAL SYMBOL DIESIS DIGRAMMOS EX DODEKATA': 118994,
'BYZANTINE MUSICAL SYMBOL DIESIS MONOGRAMMOS TESSERA DODEKATA': 118993,
'BYZANTINE MUSICAL SYMBOL DIESIS TETARTIMORION': 118991,
'BYZANTINE MUSICAL SYMBOL DIESIS TRIGRAMMOS OKTO DODEKATA': 118995,
'BYZANTINE MUSICAL SYMBOL DIESIS TRITIMORION': 118990,
'BYZANTINE MUSICAL SYMBOL DIFTOGGOS OU': 119015,
'BYZANTINE MUSICAL SYMBOL DIGORGON': 118930,
'BYZANTINE MUSICAL SYMBOL DIGORGON PARESTIGMENON ARISTERA ANO': 118932,
'BYZANTINE MUSICAL SYMBOL DIGORGON PARESTIGMENON ARISTERA KATO': 118931,
'BYZANTINE MUSICAL SYMBOL DIGORGON PARESTIGMENON DEXIA': 118933,
'BYZANTINE MUSICAL SYMBOL DIGRAMMA GG': 119014,
'BYZANTINE MUSICAL SYMBOL DIPLI': 118918,
'BYZANTINE MUSICAL SYMBOL DIPLI ARCHAION': 118912,
'BYZANTINE MUSICAL SYMBOL DYO': 118831,
'BYZANTINE MUSICAL SYMBOL EKSTREPTON': 118884,
'BYZANTINE MUSICAL SYMBOL ELAFRON': 118869,
'BYZANTINE MUSICAL SYMBOL ENARXIS KAI FTHORA VOU': 118966,
'BYZANTINE MUSICAL SYMBOL ENDOFONON': 118907,
'BYZANTINE MUSICAL SYMBOL EPEGERMA': 118888,
'BYZANTINE MUSICAL SYMBOL ETERON ARGOSYNTHETON': 118900,
'BYZANTINE MUSICAL SYMBOL ETERON PARAKALESMA': 118880,
'BYZANTINE MUSICAL SYMBOL EXO EKFONITIKON': 118798,
'BYZANTINE MUSICAL SYMBOL FANEROSIS DIFONIAS': 118960,
'BYZANTINE MUSICAL SYMBOL FANEROSIS MONOFONIAS': 118959,
'BYZANTINE MUSICAL SYMBOL FANEROSIS TETRAFONIAS': 118958,
'BYZANTINE MUSICAL SYMBOL FHTORA SKLIRON CHROMA VASIS': 118981,
'BYZANTINE MUSICAL SYMBOL FTHORA ARCHAION': 118836,
'BYZANTINE MUSICAL SYMBOL FTHORA ARCHAION DEYTEROU ICHOU': 118969,
'BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI DI': 118973,
'BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI KE': 118975,
'BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI NANA': 118971,
'BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI NI ANO': 118978,
'BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI NI KATO': 118977,
'BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI PA': 118970,
'BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI ZO': 118976,
'BYZANTINE MUSICAL SYMBOL FTHORA ENARMONIOS ANTIFONIA': 118988,
'BYZANTINE MUSICAL SYMBOL FTHORA I YFESIS TETARTIMORION': 118987,
'BYZANTINE MUSICAL SYMBOL FTHORA MALAKON CHROMA DIFONIAS': 118979,
'BYZANTINE MUSICAL SYMBOL FTHORA MALAKON CHROMA MONOFONIAS': 118980,
'BYZANTINE MUSICAL SYMBOL FTHORA NAOS ICHOS': 118972,
'BYZANTINE MUSICAL SYMBOL FTHORA NENANO': 118983,
'BYZANTINE MUSICAL SYMBOL FTHORA SKLIRON CHROMA SYNAFI': 118982,
'BYZANTINE MUSICAL SYMBOL FTHORA SKLIRON DIATONON DI': 118974,
'BYZANTINE MUSICAL SYMBOL GENIKI DIESIS': 119000,
'BYZANTINE MUSICAL SYMBOL GENIKI YFESIS': 119001,
'BYZANTINE MUSICAL SYMBOL GORGON ARCHAION': 118806,
'BYZANTINE MUSICAL SYMBOL GORGON NEO ANO': 118927,
'BYZANTINE MUSICAL SYMBOL GORGON NEO KATO': 119029,
'BYZANTINE MUSICAL SYMBOL GORGON PARESTIGMENON ARISTERA': 118928,
'BYZANTINE MUSICAL SYMBOL GORGON PARESTIGMENON DEXIA': 118929,
'BYZANTINE MUSICAL SYMBOL GORGOSYNTHETON': 118898,
'BYZANTINE MUSICAL SYMBOL GORTHMIKON N APLOUN': 118964,
'BYZANTINE MUSICAL SYMBOL GORTHMIKON N DIPLOUN': 118965,
'BYZANTINE MUSICAL SYMBOL GRONTHISMATA': 118853,
'BYZANTINE MUSICAL SYMBOL ICHADIN': 118847,
'BYZANTINE MUSICAL SYMBOL IMIDIARGON': 118936,
'BYZANTINE MUSICAL SYMBOL IMIFONON': 118967,
'BYZANTINE MUSICAL SYMBOL IMIFTHORA': 118837,
'BYZANTINE MUSICAL SYMBOL IMIFTHORON': 118968,
'BYZANTINE MUSICAL SYMBOL ISAKIA TELOUS ICHIMATOS': 118956,
'BYZANTINE MUSICAL SYMBOL ISON ARCHAION': 118810,
'BYZANTINE MUSICAL SYMBOL ISON NEO': 118854,
'BYZANTINE MUSICAL SYMBOL KATAVA TROMIKON': 118839,
'BYZANTINE MUSICAL SYMBOL KATAVASMA': 118906,
'BYZANTINE MUSICAL SYMBOL KATHISTI': 118791,
'BYZANTINE MUSICAL SYMBOL KENTIMA ARCHAION': 118811,
'BYZANTINE MUSICAL SYMBOL KENTIMA NEO ANO': 118863,
'BYZANTINE MUSICAL SYMBOL KENTIMA NEO KATO': 119027,
'BYZANTINE MUSICAL SYMBOL KENTIMA NEO MESO': 119025,
'BYZANTINE MUSICAL SYMBOL KENTIMATA': 118800,
'BYZANTINE MUSICAL SYMBOL KENTIMATA ARCHAION': 118812,
'BYZANTINE MUSICAL SYMBOL KENTIMATA NEO ANO': 118862,
'BYZANTINE MUSICAL SYMBOL KENTIMATA NEO KATO': 119026,
'BYZANTINE MUSICAL SYMBOL KENTIMATA NEO MESO': 119024,
'BYZANTINE MUSICAL SYMBOL KLASMA': 118820,
'BYZANTINE MUSICAL SYMBOL KLASMA ANO': 118911,
'BYZANTINE MUSICAL SYMBOL KLASMA KATO': 119028,
'BYZANTINE MUSICAL SYMBOL KONTEVMA': 118842,
'BYZANTINE MUSICAL SYMBOL KONTEVMA ALLO': 118850,
'BYZANTINE MUSICAL SYMBOL KORONIS': 118921,
'BYZANTINE MUSICAL SYMBOL KOUFISMA': 118858,
'BYZANTINE MUSICAL SYMBOL KRATIMA ALLO': 118914,
'BYZANTINE MUSICAL SYMBOL KRATIMA ARCHAION': 118913,
'BYZANTINE MUSICAL SYMBOL KRATIMA NEO': 118915,
'BYZANTINE MUSICAL SYMBOL KRATIMATA': 118834,
'BYZANTINE MUSICAL SYMBOL KRATIMOKOUFISMA': 118860,
'BYZANTINE MUSICAL SYMBOL KRATIMOYPORROON': 118868,
'BYZANTINE MUSICAL SYMBOL KREMASTI': 118796,
'BYZANTINE MUSICAL SYMBOL KYLISMA': 118881,
'BYZANTINE MUSICAL SYMBOL LEIMMA DYO CHRONON': 118923,
'BYZANTINE MUSICAL SYMBOL LEIMMA ENOS CHRONOU': 118922,
'BYZANTINE MUSICAL SYMBOL LEIMMA IMISEOS CHRONOU': 118926,
'BYZANTINE MUSICAL SYMBOL LEIMMA TESSARON CHRONON': 118925,
'BYZANTINE MUSICAL SYMBOL LEIMMA TRION CHRONON': 118924,
'BYZANTINE MUSICAL SYMBOL LEMOI': 118830,
'BYZANTINE MUSICAL SYMBOL LYGISMA': 118877,
'BYZANTINE MUSICAL SYMBOL MARTYRIA ALLI DEYTEROS ICHOS': 118949,
'BYZANTINE MUSICAL SYMBOL MARTYRIA ALLI PROTOS ICHOS': 118947,
'BYZANTINE MUSICAL SYMBOL MARTYRIA DEYTEROS ICHOS': 118948,
'BYZANTINE MUSICAL SYMBOL MARTYRIA LEGETOS ICHOS': 118954,
'BYZANTINE MUSICAL SYMBOL MARTYRIA PLAGIOS ICHOS': 118955,
'BYZANTINE MUSICAL SYMBOL MARTYRIA PLAGIOS TETARTOS ICHOS': 118963,
'BYZANTINE MUSICAL SYMBOL MARTYRIA PROTOS ICHOS': 118946,
'BYZANTINE MUSICAL SYMBOL MARTYRIA PROTOVARYS ICHOS': 118962,
'BYZANTINE MUSICAL SYMBOL MARTYRIA TETARTOS ICHOS': 118952,
'BYZANTINE MUSICAL SYMBOL MARTYRIA TETARTOS LEGETOS ICHOS': 118953,
'BYZANTINE MUSICAL SYMBOL MARTYRIA TRIFONIAS': 118951,
'BYZANTINE MUSICAL SYMBOL MARTYRIA TRITOS ICHOS': 118950,
'BYZANTINE MUSICAL SYMBOL MARTYRIA VARYS ICHOS': 118961,
'BYZANTINE MUSICAL SYMBOL MIKRON ISON': 118871,
'BYZANTINE MUSICAL SYMBOL NANA': 118848,
'BYZANTINE MUSICAL SYMBOL OLIGON ARCHAION': 118805,
'BYZANTINE MUSICAL SYMBOL OLIGON NEO': 118855,
'BYZANTINE MUSICAL SYMBOL OMALON': 118875,
'BYZANTINE MUSICAL SYMBOL OXEIA DIPLI': 118788,
'BYZANTINE MUSICAL SYMBOL OXEIA EKFONITIKON': 118787,
'BYZANTINE MUSICAL SYMBOL OXEIA NEO': 118856,
'BYZANTINE MUSICAL SYMBOL OXEIAI ARCHAION': 118816,
'BYZANTINE MUSICAL SYMBOL OYRANISMA ARCHAION': 118828,
'BYZANTINE MUSICAL SYMBOL OYRANISMA NEO': 118901,
'BYZANTINE MUSICAL SYMBOL PARAKALESMA ARCHAION': 118845,
'BYZANTINE MUSICAL SYMBOL PARAKALESMA NEO': 118879,
'BYZANTINE MUSICAL SYMBOL PARAKLITIKI': 118793,
'BYZANTINE MUSICAL SYMBOL PARAKLITIKI ARCHAION': 118846,
'BYZANTINE MUSICAL SYMBOL PARAKLITIKI NEO': 118878,
'BYZANTINE MUSICAL SYMBOL PARICHON': 118814,
'BYZANTINE MUSICAL SYMBOL PELASTON': 118840,
'BYZANTINE MUSICAL SYMBOL PELASTON NEO': 118861,
'BYZANTINE MUSICAL SYMBOL PERISPOMENI': 118786,
'BYZANTINE MUSICAL SYMBOL PETASMA': 118849,
'BYZANTINE MUSICAL SYMBOL PETASTI': 118857,
'BYZANTINE MUSICAL SYMBOL PETASTOKOUFISMA': 118859,
'BYZANTINE MUSICAL SYMBOL PIASMA ARCHAION': 118822,
'BYZANTINE MUSICAL SYMBOL PIASMA NEO': 118873,
'BYZANTINE MUSICAL SYMBOL PSIFISTOLYGISMA': 118892,
'BYZANTINE MUSICAL SYMBOL PSIFISTON': 118841,
'BYZANTINE MUSICAL SYMBOL PSIFISTON NEO': 118874,
'BYZANTINE MUSICAL SYMBOL PSIFISTOPARAKALESMA': 118895,
'BYZANTINE MUSICAL SYMBOL PSIFISTOSYNAGMA': 118897,
'BYZANTINE MUSICAL SYMBOL PSILI': 118784,
'BYZANTINE MUSICAL SYMBOL PSILON': 118807,
'BYZANTINE MUSICAL SYMBOL RAPISMA': 118844,
'BYZANTINE MUSICAL SYMBOL REVMA': 118821,
'BYZANTINE MUSICAL SYMBOL SAXIMATA': 118813,
'BYZANTINE MUSICAL SYMBOL SEISMA': 118825,
'BYZANTINE MUSICAL SYMBOL SEISMA NEO': 118889,
'BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS': 119010,
'BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS DISIMOU': 119011,
'BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS TETRASIMOU': 119013,
'BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS TRISIMOU': 119012,
'BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS': 119006,
'BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS DISIMOU': 119007,
'BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS TETRASIMOU': 119009,
'BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS TRISIMOU': 119008,
'BYZANTINE MUSICAL SYMBOL STAVROS': 118910,
'BYZANTINE MUSICAL SYMBOL STAVROS APODEXIA': 118815,
'BYZANTINE MUSICAL SYMBOL STIGMA': 119016,
'BYZANTINE MUSICAL SYMBOL STRAGGISMATA': 118852,
'BYZANTINE MUSICAL SYMBOL SYNAGMA ARCHAION': 118826,
'BYZANTINE MUSICAL SYMBOL SYNAGMA META STAVROU': 118827,
'BYZANTINE MUSICAL SYMBOL SYNAGMA NEO': 118885,
'BYZANTINE MUSICAL SYMBOL SYNEVMA': 118803,
'BYZANTINE MUSICAL SYMBOL SYRMA': 118886,
'BYZANTINE MUSICAL SYMBOL SYRMATIKI': 118792,
'BYZANTINE MUSICAL SYMBOL TELEIA': 118799,
'BYZANTINE MUSICAL SYMBOL TESSERA': 118833,
'BYZANTINE MUSICAL SYMBOL TETRAPLI': 118920,
'BYZANTINE MUSICAL SYMBOL THEMA': 118829,
'BYZANTINE MUSICAL SYMBOL THEMA APLOUN': 118904,
'BYZANTINE MUSICAL SYMBOL THEMATISMOS ESO': 118902,
'BYZANTINE MUSICAL SYMBOL THEMATISMOS EXO': 118903,
'BYZANTINE MUSICAL SYMBOL THES KAI APOTHES': 118905,
'BYZANTINE MUSICAL SYMBOL THITA': 118804,
'BYZANTINE MUSICAL SYMBOL TINAGMA': 118823,
'BYZANTINE MUSICAL SYMBOL TRIA': 118832,
'BYZANTINE MUSICAL SYMBOL TRIGORGON': 118934,
'BYZANTINE MUSICAL SYMBOL TRIPLI': 118919,
'BYZANTINE MUSICAL SYMBOL TROMIKOLYGISMA': 118893,
'BYZANTINE MUSICAL SYMBOL TROMIKON ALLO': 118851,
'BYZANTINE MUSICAL SYMBOL TROMIKON ARCHAION': 118838,
'BYZANTINE MUSICAL SYMBOL TROMIKON NEO': 118883,
'BYZANTINE MUSICAL SYMBOL TROMIKOPARAKALESMA': 118894,
'BYZANTINE MUSICAL SYMBOL TROMIKOPSIFISTON': 118891,
'BYZANTINE MUSICAL SYMBOL TROMIKOSYNAGMA': 118896,
'BYZANTINE MUSICAL SYMBOL VAREIA DIPLI': 118790,
'BYZANTINE MUSICAL SYMBOL VAREIA EKFONITIKON': 118789,
'BYZANTINE MUSICAL SYMBOL VAREIA NEO': 118872,
'BYZANTINE MUSICAL SYMBOL VAREIAI ARCHAION': 118817,
'BYZANTINE MUSICAL SYMBOL VATHY': 118809,
'BYZANTINE MUSICAL SYMBOL XIRON KLASMA': 118890,
'BYZANTINE MUSICAL SYMBOL YFEN ANO': 118909,
'BYZANTINE MUSICAL SYMBOL YFEN KATO': 118908,
'BYZANTINE MUSICAL SYMBOL YFESIS APLI DYO DODEKATA': 118996,
'BYZANTINE MUSICAL SYMBOL YFESIS DIGRAMMOS EX DODEKATA': 118998,
'BYZANTINE MUSICAL SYMBOL YFESIS MONOGRAMMOS TESSERA DODEKATA': 118997,
'BYZANTINE MUSICAL SYMBOL YFESIS TRIGRAMMOS OKTO DODEKATA': 118999,
'BYZANTINE MUSICAL SYMBOL YFESIS TRITIMORION': 118989,
'BYZANTINE MUSICAL SYMBOL YPOKRISIS': 118794,
'BYZANTINE MUSICAL SYMBOL YPOKRISIS DIPLI': 118795,
'BYZANTINE MUSICAL SYMBOL YPORROI': 118867,
'BYZANTINE MUSICAL SYMBOL YPSILI': 118864,
'CADA UNA': 8454,
'CADUCEUS': 9764,
'CANADIAN SYLLABICS A': 5130,
'CANADIAN SYLLABICS AA': 5131,
'CANADIAN SYLLABICS AAI': 5122,
'CANADIAN SYLLABICS AAY': 6322,
'CANADIAN SYLLABICS AI': 5148,
'CANADIAN SYLLABICS AIVILIK B': 5551,
'CANADIAN SYLLABICS AN': 5166,
'CANADIAN SYLLABICS ATHAPASCAN M': 5310,
'CANADIAN SYLLABICS ATHAPASCAN S': 5382,
'CANADIAN SYLLABICS AY': 6321,
'CANADIAN SYLLABICS BEAVER DENE L': 6387,
'CANADIAN SYLLABICS BEAVER DENE R': 6388,
'CANADIAN SYLLABICS BIBLE-CREE Y': 5439,
'CANADIAN SYLLABICS BLACKFOOT A': 5555,
'CANADIAN SYLLABICS BLACKFOOT E': 5552,
'CANADIAN SYLLABICS BLACKFOOT I': 5553,
'CANADIAN SYLLABICS BLACKFOOT KA': 5567,
'CANADIAN SYLLABICS BLACKFOOT KE': 5564,
'CANADIAN SYLLABICS BLACKFOOT KI': 5565,
'CANADIAN SYLLABICS BLACKFOOT KO': 5566,
'CANADIAN SYLLABICS BLACKFOOT NA': 5563,
'CANADIAN SYLLABICS BLACKFOOT NE': 5560,
'CANADIAN SYLLABICS BLACKFOOT NI': 5561,
'CANADIAN SYLLABICS BLACKFOOT NO': 5562,
'CANADIAN SYLLABICS BLACKFOOT O': 5554,
'CANADIAN SYLLABICS BLACKFOOT S': 5384,
'CANADIAN SYLLABICS BLACKFOOT W': 5759,
'CANADIAN SYLLABICS BLACKFOOT WA': 5559,
'CANADIAN SYLLABICS BLACKFOOT WE': 5556,
'CANADIAN SYLLABICS BLACKFOOT WI': 5557,
'CANADIAN SYLLABICS BLACKFOOT WO': 5558,
'CANADIAN SYLLABICS C': 5281,
'CANADIAN SYLLABICS CA': 5264,
'CANADIAN SYLLABICS CAA': 5265,
'CANADIAN SYLLABICS CAAI': 5258,
'CANADIAN SYLLABICS CARRIER CHA': 5734,
'CANADIAN SYLLABICS CARRIER CHE': 5731,
'CANADIAN SYLLABICS CARRIER CHEE': 5732,
'CANADIAN SYLLABICS CARRIER CHI': 5733,
'CANADIAN SYLLABICS CARRIER CHO': 5730,
'CANADIAN SYLLABICS CARRIER CHU': 5729,
'CANADIAN SYLLABICS CARRIER DEE': 5203,
'CANADIAN SYLLABICS CARRIER DENE GEE': 6382,
'CANADIAN SYLLABICS CARRIER DENTAL S': 6389,
'CANADIAN SYLLABICS CARRIER DI': 5204,
'CANADIAN SYLLABICS CARRIER DLA': 5677,
'CANADIAN SYLLABICS CARRIER DLE': 5674,
'CANADIAN SYLLABICS CARRIER DLEE': 5675,
'CANADIAN SYLLABICS CARRIER DLI': 5676,
'CANADIAN SYLLABICS CARRIER DLO': 5673,
'CANADIAN SYLLABICS CARRIER DLU': 5672,
'CANADIAN SYLLABICS CARRIER DZA': 5709,
'CANADIAN SYLLABICS CARRIER DZE': 5706,
'CANADIAN SYLLABICS CARRIER DZEE': 5707,
'CANADIAN SYLLABICS CARRIER DZI': 5708,
'CANADIAN SYLLABICS CARRIER DZO': 5705,
'CANADIAN SYLLABICS CARRIER DZU': 5704,
'CANADIAN SYLLABICS CARRIER EE': 5128,
'CANADIAN SYLLABICS CARRIER GA': 5620,
'CANADIAN SYLLABICS CARRIER GAA': 6383,
'CANADIAN SYLLABICS CARRIER GE': 5617,
'CANADIAN SYLLABICS CARRIER GEE': 5618,
'CANADIAN SYLLABICS CARRIER GHA': 5577,
'CANADIAN SYLLABICS CARRIER GHE': 5574,
'CANADIAN SYLLABICS CARRIER GHEE': 5575,
'CANADIAN SYLLABICS CARRIER GHI': 5576,
'CANADIAN SYLLABICS CARRIER GHO': 5573,
'CANADIAN SYLLABICS CARRIER GHU': 5572,
'CANADIAN SYLLABICS CARRIER GI': 5619,
'CANADIAN SYLLABICS CARRIER GO': 5616,
'CANADIAN SYLLABICS CARRIER GU': 5615,
'CANADIAN SYLLABICS CARRIER GWA': 6384,
'CANADIAN SYLLABICS CARRIER GWU': 6381,
'CANADIAN SYLLABICS CARRIER H': 5195,
'CANADIAN SYLLABICS CARRIER HEE': 5174,
'CANADIAN SYLLABICS CARRIER HI': 5175,
'CANADIAN SYLLABICS CARRIER HWA': 5595,
'CANADIAN SYLLABICS CARRIER HWE': 5592,
'CANADIAN SYLLABICS CARRIER HWEE': 5593,
'CANADIAN SYLLABICS CARRIER HWI': 5594,
'CANADIAN SYLLABICS CARRIER HWO': 5591,
'CANADIAN SYLLABICS CARRIER HWU': 5590,
'CANADIAN SYLLABICS CARRIER I': 5129,
'CANADIAN SYLLABICS CARRIER INITIAL Z': 5703,
'CANADIAN SYLLABICS CARRIER JA': 5659,
'CANADIAN SYLLABICS CARRIER JE': 5655,
'CANADIAN SYLLABICS CARRIER JEE': 5656,
'CANADIAN SYLLABICS CARRIER JI': 5657,
'CANADIAN SYLLABICS CARRIER JJA': 5665,
'CANADIAN SYLLABICS CARRIER JJE': 5662,
'CANADIAN SYLLABICS CARRIER JJEE': 5663,
'CANADIAN SYLLABICS CARRIER JJI': 5664,
'CANADIAN SYLLABICS CARRIER JJO': 5661,
'CANADIAN SYLLABICS CARRIER JJU': 5660,
'CANADIAN SYLLABICS CARRIER JO': 5654,
'CANADIAN SYLLABICS CARRIER JU': 5652,
'CANADIAN SYLLABICS CARRIER JWA': 6386,
'CANADIAN SYLLABICS CARRIER KHA': 5626,
'CANADIAN SYLLABICS CARRIER KHE': 5623,
'CANADIAN SYLLABICS CARRIER KHEE': 5624,
'CANADIAN SYLLABICS CARRIER KHI': 5625,
'CANADIAN SYLLABICS CARRIER KHO': 5622,
'CANADIAN SYLLABICS CARRIER KHU': 5621,
'CANADIAN SYLLABICS CARRIER KK': 5633,
'CANADIAN SYLLABICS CARRIER KKA': 5632,
'CANADIAN SYLLABICS CARRIER KKE': 5629,
'CANADIAN SYLLABICS CARRIER KKEE': 5630,
'CANADIAN SYLLABICS CARRIER KKI': 5631,
'CANADIAN SYLLABICS CARRIER KKO': 5628,
'CANADIAN SYLLABICS CARRIER KKU': 5627,
'CANADIAN SYLLABICS CARRIER LA': 5671,
'CANADIAN SYLLABICS CARRIER LE': 5668,
'CANADIAN SYLLABICS CARRIER LEE': 5669,
'CANADIAN SYLLABICS CARRIER LHA': 5683,
'CANADIAN SYLLABICS CARRIER LHE': 5680,
'CANADIAN SYLLABICS CARRIER LHEE': 5681,
'CANADIAN SYLLABICS CARRIER LHI': 5682,
'CANADIAN SYLLABICS CARRIER LHO': 5679,
'CANADIAN SYLLABICS CARRIER LHU': 5678,
'CANADIAN SYLLABICS CARRIER LI': 5670,
'CANADIAN SYLLABICS CARRIER LO': 5667,
'CANADIAN SYLLABICS CARRIER LU': 5666,
'CANADIAN SYLLABICS CARRIER MA': 5645,
'CANADIAN SYLLABICS CARRIER ME': 5642,
'CANADIAN SYLLABICS CARRIER MEE': 5643,
'CANADIAN SYLLABICS CARRIER MI': 5644,
'CANADIAN SYLLABICS CARRIER MO': 5641,
'CANADIAN SYLLABICS CARRIER MU': 5640,
'CANADIAN SYLLABICS CARRIER NA': 5639,
'CANADIAN SYLLABICS CARRIER NE': 5636,
'CANADIAN SYLLABICS CARRIER NEE': 5637,
'CANADIAN SYLLABICS CARRIER NG': 5329,
'CANADIAN SYLLABICS CARRIER NI': 5638,
'CANADIAN SYLLABICS CARRIER NO': 5635,
'CANADIAN SYLLABICS CARRIER NU': 5634,
'CANADIAN SYLLABICS CARRIER P': 5614,
'CANADIAN SYLLABICS CARRIER PA': 5613,
'CANADIAN SYLLABICS CARRIER PE': 5610,
'CANADIAN SYLLABICS CARRIER PEE': 5611,
'CANADIAN SYLLABICS CARRIER PI': 5612,
'CANADIAN SYLLABICS CARRIER PO': 5609,
'CANADIAN SYLLABICS CARRIER PU': 5608,
'CANADIAN SYLLABICS CARRIER RA': 5583,
'CANADIAN SYLLABICS CARRIER RE': 5580,
'CANADIAN SYLLABICS CARRIER REE': 5581,
'CANADIAN SYLLABICS CARRIER RI': 5582,
'CANADIAN SYLLABICS CARRIER RO': 5579,
'CANADIAN SYLLABICS CARRIER RU': 5578,
'CANADIAN SYLLABICS CARRIER SA': 5715,
'CANADIAN SYLLABICS CARRIER SE': 5712,
'CANADIAN SYLLABICS CARRIER SEE': 5713,
'CANADIAN SYLLABICS CARRIER SH': 5722,
'CANADIAN SYLLABICS CARRIER SHA': 5721,
'CANADIAN SYLLABICS CARRIER SHE': 5718,
'CANADIAN SYLLABICS CARRIER SHEE': 5719,
'CANADIAN SYLLABICS CARRIER SHI': 5720,
'CANADIAN SYLLABICS CARRIER SHO': 5717,
'CANADIAN SYLLABICS CARRIER SHU': 5716,
'CANADIAN SYLLABICS CARRIER SI': 5714,
'CANADIAN SYLLABICS CARRIER SO': 5711,
'CANADIAN SYLLABICS CARRIER SU': 5710,
'CANADIAN SYLLABICS CARRIER THA': 5601,
'CANADIAN SYLLABICS CARRIER THE': 5598,
'CANADIAN SYLLABICS CARRIER THEE': 5599,
'CANADIAN SYLLABICS CARRIER THI': 5600,
'CANADIAN SYLLABICS CARRIER THO': 5597,
'CANADIAN SYLLABICS CARRIER THU': 5596,
'CANADIAN SYLLABICS CARRIER TLA': 5695,
'CANADIAN SYLLABICS CARRIER TLE': 5692,
'CANADIAN SYLLABICS CARRIER TLEE': 5693,
'CANADIAN SYLLABICS CARRIER TLHA': 5689,
'CANADIAN SYLLABICS CARRIER TLHE': 5686,
'CANADIAN SYLLABICS CARRIER TLHEE': 5687,
'CANADIAN SYLLABICS CARRIER TLHI': 5688,
'CANADIAN SYLLABICS CARRIER TLHO': 5685,
'CANADIAN SYLLABICS CARRIER TLHU': 5684,
'CANADIAN SYLLABICS CARRIER TLI': 5694,
'CANADIAN SYLLABICS CARRIER TLO': 5691,
'CANADIAN SYLLABICS CARRIER TLU': 5690,
'CANADIAN SYLLABICS CARRIER TSA': 5728,
'CANADIAN SYLLABICS CARRIER TSE': 5725,
'CANADIAN SYLLABICS CARRIER TSEE': 5726,
'CANADIAN SYLLABICS CARRIER TSI': 5727,
'CANADIAN SYLLABICS CARRIER TSO': 5724,
'CANADIAN SYLLABICS CARRIER TSU': 5723,
'CANADIAN SYLLABICS CARRIER TTA': 5607,
'CANADIAN SYLLABICS CARRIER TTE': 5604,
'CANADIAN SYLLABICS CARRIER TTEE': 5605,
'CANADIAN SYLLABICS CARRIER TTI': 5606,
'CANADIAN SYLLABICS CARRIER TTO': 5603,
'CANADIAN SYLLABICS CARRIER TTSA': 5740,
'CANADIAN SYLLABICS CARRIER TTSE': 5737,
'CANADIAN SYLLABICS CARRIER TTSEE': 5738,
'CANADIAN SYLLABICS CARRIER TTSI': 5739,
'CANADIAN SYLLABICS CARRIER TTSO': 5736,
'CANADIAN SYLLABICS CARRIER TTSU': 5735,
'CANADIAN SYLLABICS CARRIER TTU': 5602,
'CANADIAN SYLLABICS CARRIER WA': 5589,
'CANADIAN SYLLABICS CARRIER WE': 5586,
'CANADIAN SYLLABICS CARRIER WEE': 5587,
'CANADIAN SYLLABICS CARRIER WI': 5588,
'CANADIAN SYLLABICS CARRIER WO': 5585,
'CANADIAN SYLLABICS CARRIER WU': 5584,
'CANADIAN SYLLABICS CARRIER YA': 5651,
'CANADIAN SYLLABICS CARRIER YE': 5648,
'CANADIAN SYLLABICS CARRIER YEE': 5649,
'CANADIAN SYLLABICS CARRIER YI': 5650,
'CANADIAN SYLLABICS CARRIER YO': 5647,
'CANADIAN SYLLABICS CARRIER YU': 5646,
'CANADIAN SYLLABICS CARRIER Z': 5702,
'CANADIAN SYLLABICS CARRIER ZA': 5701,
'CANADIAN SYLLABICS CARRIER ZE': 5698,
'CANADIAN SYLLABICS CARRIER ZEE': 5699,
'CANADIAN SYLLABICS CARRIER ZI': 5700,
'CANADIAN SYLLABICS CARRIER ZO': 5697,
'CANADIAN SYLLABICS CARRIER ZU': 5696,
'CANADIAN SYLLABICS CE': 5257,
'CANADIAN SYLLABICS CHI SIGN': 5741,
'CANADIAN SYLLABICS CI': 5259,
'CANADIAN SYLLABICS CII': 5260,
'CANADIAN SYLLABICS CO': 5261,
'CANADIAN SYLLABICS COO': 5262,
'CANADIAN SYLLABICS CWA': 5276,
'CANADIAN SYLLABICS CWAA': 5278,
'CANADIAN SYLLABICS CWE': 5266,
'CANADIAN SYLLABICS CWI': 5268,
'CANADIAN SYLLABICS CWII': 5270,
'CANADIAN SYLLABICS CWO': 5272,
'CANADIAN SYLLABICS CWOO': 5274,
'CANADIAN SYLLABICS E': 5121,
'CANADIAN SYLLABICS EASTERN W': 6364,
'CANADIAN SYLLABICS EN': 5163,
'CANADIAN SYLLABICS F': 5469,
'CANADIAN SYLLABICS FA': 5465,
'CANADIAN SYLLABICS FAA': 5466,
'CANADIAN SYLLABICS FAAI': 5460,
'CANADIAN SYLLABICS FE': 5459,
'CANADIAN SYLLABICS FI': 5461,
'CANADIAN SYLLABICS FII': 5462,
'CANADIAN SYLLABICS FINAL ACUTE': 5151,
'CANADIAN SYLLABICS FINAL BOTTOM HALF RING': 5153,
'CANADIAN SYLLABICS FINAL DOUBLE ACUTE': 5157,
'CANADIAN SYLLABICS FINAL DOUBLE SHORT VERTICAL STROKES': 5158,
'CANADIAN SYLLABICS FINAL DOWN TACK': 5162,
'CANADIAN SYLLABICS FINAL GRAVE': 5152,
'CANADIAN SYLLABICS FINAL MIDDLE DOT': 5159,
'CANADIAN SYLLABICS FINAL PLUS': 5161,
'CANADIAN SYLLABICS FINAL RAISED DOT': 6367,
'CANADIAN SYLLABICS FINAL RIGHT HALF RING': 5155,
'CANADIAN SYLLABICS FINAL RING': 5156,
'CANADIAN SYLLABICS FINAL SHORT HORIZONTAL STROKE': 5160,
'CANADIAN SYLLABICS FINAL SMALL RING': 6366,
'CANADIAN SYLLABICS FINAL TOP HALF RING': 5154,
'CANADIAN SYLLABICS FO': 5463,
'CANADIAN SYLLABICS FOO': 5464,
'CANADIAN SYLLABICS FULL STOP': 5742,
'CANADIAN SYLLABICS FWAA': 5467,
'CANADIAN SYLLABICS GLOTTAL STOP': 5150,
'CANADIAN SYLLABICS HK': 5501,
'CANADIAN SYLLABICS HYPHEN': 5120,
'CANADIAN SYLLABICS I': 5123,
'CANADIAN SYLLABICS II': 5124,
'CANADIAN SYLLABICS IN': 5164,
'CANADIAN SYLLABICS K': 5251,
'CANADIAN SYLLABICS KA': 5234,
'CANADIAN SYLLABICS KAA': 5235,
'CANADIAN SYLLABICS KAAI': 5228,
'CANADIAN SYLLABICS KAY': 6328,
'CANADIAN SYLLABICS KE': 5227,
'CANADIAN SYLLABICS KI': 5229,
'CANADIAN SYLLABICS KII': 5230,
'CANADIAN SYLLABICS KO': 5231,
'CANADIAN SYLLABICS KOO': 5232,
'CANADIAN SYLLABICS KW': 5252,
'CANADIAN SYLLABICS KWA': 5246,
'CANADIAN SYLLABICS KWAA': 5248,
'CANADIAN SYLLABICS KWAY': 6329,
'CANADIAN SYLLABICS KWE': 5236,
'CANADIAN SYLLABICS KWI': 5238,
'CANADIAN SYLLABICS KWII': 5240,
'CANADIAN SYLLABICS KWO': 5242,
'CANADIAN SYLLABICS KWOO': 5244,
'CANADIAN SYLLABICS L': 5354,
'CANADIAN SYLLABICS LA': 5338,
'CANADIAN SYLLABICS LAA': 5339,
'CANADIAN SYLLABICS LAAI': 5332,
'CANADIAN SYLLABICS LAY': 6333,
'CANADIAN SYLLABICS LE': 5331,
'CANADIAN SYLLABICS LH': 5542,
'CANADIAN SYLLABICS LHA': 5540,
'CANADIAN SYLLABICS LHAA': 5541,
'CANADIAN SYLLABICS LHI': 5536,
'CANADIAN SYLLABICS LHII': 5537,
'CANADIAN SYLLABICS LHO': 5538,
'CANADIAN SYLLABICS LHOO': 5539,
'CANADIAN SYLLABICS LI': 5333,
'CANADIAN SYLLABICS LII': 5334,
'CANADIAN SYLLABICS LO': 5335,
'CANADIAN SYLLABICS LOO': 5336,
'CANADIAN SYLLABICS LWA': 5350,
'CANADIAN SYLLABICS LWAA': 5352,
'CANADIAN SYLLABICS LWE': 5340,
'CANADIAN SYLLABICS LWI': 5342,
'CANADIAN SYLLABICS LWII': 5344,
'CANADIAN SYLLABICS LWO': 5346,
'CANADIAN SYLLABICS LWOO': 5348,
'CANADIAN SYLLABICS M': 5307,
'CANADIAN SYLLABICS MA': 5290,
'CANADIAN SYLLABICS MAA': 5291,
'CANADIAN SYLLABICS MAAI': 5284,
'CANADIAN SYLLABICS MAY': 6330,
'CANADIAN SYLLABICS ME': 5283,
'CANADIAN SYLLABICS MEDIAL L': 5356,
'CANADIAN SYLLABICS MEDIAL R': 5458,
'CANADIAN SYLLABICS MH': 5309,
'CANADIAN SYLLABICS MI': 5285,
'CANADIAN SYLLABICS MII': 5286,
'CANADIAN SYLLABICS MO': 5287,
'CANADIAN SYLLABICS MOO': 5288,
'CANADIAN SYLLABICS MOOSE-CREE SK': 5385,
'CANADIAN SYLLABICS MWA': 5302,
'CANADIAN SYLLABICS MWAA': 5304,
'CANADIAN SYLLABICS MWE': 5292,
'CANADIAN SYLLABICS MWI': 5294,
'CANADIAN SYLLABICS MWII': 5296,
'CANADIAN SYLLABICS MWO': 5298,
'CANADIAN SYLLABICS MWOO': 5300,
'CANADIAN SYLLABICS N': 5328,
'CANADIAN SYLLABICS N-CREE THE': 5471,
'CANADIAN SYLLABICS N-CREE THI': 5473,
'CANADIAN SYLLABICS N-CREE THII': 5475,
'CANADIAN SYLLABICS NA': 5319,
'CANADIAN SYLLABICS NAA': 5320,
'CANADIAN SYLLABICS NAAI': 5313,
'CANADIAN SYLLABICS NASKAPI CWAA': 5280,
'CANADIAN SYLLABICS NASKAPI KWAA': 5250,
'CANADIAN SYLLABICS NASKAPI MWAA': 5306,
'CANADIAN SYLLABICS NASKAPI NWAA': 5327,
'CANADIAN SYLLABICS NASKAPI S-W': 5387,
'CANADIAN SYLLABICS NASKAPI SCWA': 5391,
'CANADIAN SYLLABICS NASKAPI SKW': 5386,
'CANADIAN SYLLABICS NASKAPI SKWA': 5390,
'CANADIAN SYLLABICS NASKAPI SPWA': 5388,
'CANADIAN SYLLABICS NASKAPI STWA': 5389,
'CANADIAN SYLLABICS NASKAPI SWAA': 5380,
'CANADIAN SYLLABICS NASKAPI TWAA': 5221,
'CANADIAN SYLLABICS NASKAPI WAA': 5147,
'CANADIAN SYLLABICS NASKAPI WOO': 5142,
'CANADIAN SYLLABICS NASKAPI YWAA': 5437,
'CANADIAN SYLLABICS NAY': 6332,
'CANADIAN SYLLABICS NE': 5312,
'CANADIAN SYLLABICS NG': 5525,
'CANADIAN SYLLABICS NGA': 5523,
'CANADIAN SYLLABICS NGAA': 5524,
'CANADIAN SYLLABICS NGAAI': 5518,
'CANADIAN SYLLABICS NGAI': 5744,
'CANADIAN SYLLABICS NGI': 5519,
'CANADIAN SYLLABICS NGII': 5520,
'CANADIAN SYLLABICS NGO': 5521,
'CANADIAN SYLLABICS NGOO': 5522,
'CANADIAN SYLLABICS NH': 5330,
'CANADIAN SYLLABICS NI': 5314,
'CANADIAN SYLLABICS NII': 5315,
'CANADIAN SYLLABICS NNG': 5526,
'CANADIAN SYLLABICS NNGA': 5749,
'CANADIAN SYLLABICS NNGAA': 5750,
'CANADIAN SYLLABICS NNGI': 5745,
'CANADIAN SYLLABICS NNGII': 5746,
'CANADIAN SYLLABICS NNGO': 5747,
'CANADIAN SYLLABICS NNGOO': 5748,
'CANADIAN SYLLABICS NO': 5316,
'CANADIAN SYLLABICS NOO': 5317,
'CANADIAN SYLLABICS NOY': 6331,
'CANADIAN SYLLABICS NUNAVIK H': 5499,
'CANADIAN SYLLABICS NUNAVIK HA': 5497,
'CANADIAN SYLLABICS NUNAVIK HAA': 5498,
'CANADIAN SYLLABICS NUNAVIK HE': 5492,
'CANADIAN SYLLABICS NUNAVIK HI': 5493,
'CANADIAN SYLLABICS NUNAVIK HII': 5494,
'CANADIAN SYLLABICS NUNAVIK HO': 5495,
'CANADIAN SYLLABICS NUNAVIK HOO': 5496,
'CANADIAN SYLLABICS NUNAVUT H': 5500,
'CANADIAN SYLLABICS NWA': 5323,
'CANADIAN SYLLABICS NWAA': 5325,
'CANADIAN SYLLABICS NWE': 5321,
'CANADIAN SYLLABICS NWI': 6342,
'CANADIAN SYLLABICS NWII': 6344,
'CANADIAN SYLLABICS NWO': 6346,
'CANADIAN SYLLABICS NWOO': 6348,
'CANADIAN SYLLABICS O': 5125,
'CANADIAN SYLLABICS OJIBWAY C': 6359,
'CANADIAN SYLLABICS OJIBWAY K': 6358,
'CANADIAN SYLLABICS OJIBWAY M': 6360,
'CANADIAN SYLLABICS OJIBWAY N': 6361,
'CANADIAN SYLLABICS OJIBWAY NWI': 6343,
'CANADIAN SYLLABICS OJIBWAY NWII': 6345,
'CANADIAN SYLLABICS OJIBWAY NWO': 6347,
'CANADIAN SYLLABICS OJIBWAY NWOO': 6349,
'CANADIAN SYLLABICS OJIBWAY P': 6356,
'CANADIAN SYLLABICS OJIBWAY S': 6362,
'CANADIAN SYLLABICS OJIBWAY SH': 6363,
'CANADIAN SYLLABICS OJIBWAY T': 6357,
'CANADIAN SYLLABICS ON': 5165,
'CANADIAN SYLLABICS OO': 5126,
'CANADIAN SYLLABICS OY': 6320,
'CANADIAN SYLLABICS P': 5193,
'CANADIAN SYLLABICS PA': 5176,
'CANADIAN SYLLABICS PAA': 5177,
'CANADIAN SYLLABICS PAAI': 5168,
'CANADIAN SYLLABICS PAY': 6325,
'CANADIAN SYLLABICS PE': 5167,
'CANADIAN SYLLABICS PI': 5169,
'CANADIAN SYLLABICS PII': 5170,
'CANADIAN SYLLABICS PO': 5171,
'CANADIAN SYLLABICS POO': 5172,
'CANADIAN SYLLABICS POY': 6324,
'CANADIAN SYLLABICS PWA': 5188,
'CANADIAN SYLLABICS PWAA': 5190,
'CANADIAN SYLLABICS PWE': 5178,
'CANADIAN SYLLABICS PWI': 5180,
'CANADIAN SYLLABICS PWII': 5182,
'CANADIAN SYLLABICS PWO': 5184,
'CANADIAN SYLLABICS PWOO': 5186,
'CANADIAN SYLLABICS PWOY': 6326,
'CANADIAN SYLLABICS Q': 5509,
'CANADIAN SYLLABICS QA': 5507,
'CANADIAN SYLLABICS QAA': 5508,
'CANADIAN SYLLABICS QAAI': 5502,
'CANADIAN SYLLABICS QAI': 5743,
'CANADIAN SYLLABICS QI': 5503,
'CANADIAN SYLLABICS QII': 5504,
'CANADIAN SYLLABICS QO': 5505,
'CANADIAN SYLLABICS QOO': 5506,
'CANADIAN SYLLABICS R': 5456,
'CANADIAN SYLLABICS R-CREE RE': 5443,
'CANADIAN SYLLABICS R-CREE RWE': 6368,
'CANADIAN SYLLABICS RA': 5451,
'CANADIAN SYLLABICS RAA': 5452,
'CANADIAN SYLLABICS RAAI': 5445,
'CANADIAN SYLLABICS RAY': 6341,
'CANADIAN SYLLABICS RE': 5442,
'CANADIAN SYLLABICS RI': 5446,
'CANADIAN SYLLABICS RII': 5447,
'CANADIAN SYLLABICS RO': 5448,
'CANADIAN SYLLABICS ROO': 5449,
'CANADIAN SYLLABICS RWA': 6355,
'CANADIAN SYLLABICS RWAA': 5454,
'CANADIAN SYLLABICS RWEE': 6350,
'CANADIAN SYLLABICS RWI': 6351,
'CANADIAN SYLLABICS RWII': 6352,
'CANADIAN SYLLABICS RWO': 6353,
'CANADIAN SYLLABICS RWOO': 6354,
'CANADIAN SYLLABICS S': 5381,
'CANADIAN SYLLABICS SA': 5364,
'CANADIAN SYLLABICS SAA': 5365,
'CANADIAN SYLLABICS SAAI': 5358,
'CANADIAN SYLLABICS SAY': 6335,
'CANADIAN SYLLABICS SAYISI HA': 5571,
'CANADIAN SYLLABICS SAYISI HE': 5568,
'CANADIAN SYLLABICS SAYISI HI': 5569,
'CANADIAN SYLLABICS SAYISI HO': 5570,
'CANADIAN SYLLABICS SAYISI HOO': 6380,
'CANADIAN SYLLABICS SAYISI JI': 5658,
'CANADIAN SYLLABICS SAYISI JU': 5653,
'CANADIAN SYLLABICS SAYISI JUU': 6385,
'CANADIAN SYLLABICS SAYISI M': 5311,
'CANADIAN SYLLABICS SAYISI SHA': 5530,
'CANADIAN SYLLABICS SAYISI SHE': 5527,
'CANADIAN SYLLABICS SAYISI SHI': 5528,
'CANADIAN SYLLABICS SAYISI SHO': 5529,
'CANADIAN SYLLABICS SAYISI SHOO': 6379,
'CANADIAN SYLLABICS SAYISI SHWE': 6378,
'CANADIAN SYLLABICS SAYISI TH': 5282,
'CANADIAN SYLLABICS SAYISI YI': 5441,
'CANADIAN SYLLABICS SE': 5357,
'CANADIAN SYLLABICS SH': 5413,
'CANADIAN SYLLABICS SHA': 5397,
'CANADIAN SYLLABICS SHAA': 5398,
'CANADIAN SYLLABICS SHAY': 6337,
'CANADIAN SYLLABICS SHE': 5392,
'CANADIAN SYLLABICS SHI': 5393,
'CANADIAN SYLLABICS SHII': 5394,
'CANADIAN SYLLABICS SHO': 5395,
'CANADIAN SYLLABICS SHOO': 5396,
'CANADIAN SYLLABICS SHOY': 6336,
'CANADIAN SYLLABICS SHWA': 5409,
'CANADIAN SYLLABICS SHWAA': 5411,
'CANADIAN SYLLABICS SHWE': 5399,
'CANADIAN SYLLABICS SHWI': 5401,
'CANADIAN SYLLABICS SHWII': 5403,
'CANADIAN SYLLABICS SHWO': 5405,
'CANADIAN SYLLABICS SHWOO': 5407,
'CANADIAN SYLLABICS SHWOY': 6338,
'CANADIAN SYLLABICS SI': 5359,
'CANADIAN SYLLABICS SII': 5360,
'CANADIAN SYLLABICS SO': 5361,
'CANADIAN SYLLABICS SOO': 5362,
'CANADIAN SYLLABICS SOUTH-SLAVEY KAH': 5256,
'CANADIAN SYLLABICS SOUTH-SLAVEY KEH': 5253,
'CANADIAN SYLLABICS SOUTH-SLAVEY KIH': 5254,
'CANADIAN SYLLABICS SOUTH-SLAVEY KOH': 5255,
'CANADIAN SYLLABICS SOY': 6334,
'CANADIAN SYLLABICS SW': 5383,
'CANADIAN SYLLABICS SWA': 5376,
'CANADIAN SYLLABICS SWAA': 5378,
'CANADIAN SYLLABICS SWE': 5366,
'CANADIAN SYLLABICS SWI': 5368,
'CANADIAN SYLLABICS SWII': 5370,
'CANADIAN SYLLABICS SWO': 5372,
'CANADIAN SYLLABICS SWOO': 5374,
'CANADIAN SYLLABICS T': 5222,
'CANADIAN SYLLABICS TA': 5205,
'CANADIAN SYLLABICS TAA': 5206,
'CANADIAN SYLLABICS TAAI': 5197,
'CANADIAN SYLLABICS TAY': 6327,
'CANADIAN SYLLABICS TE': 5196,
'CANADIAN SYLLABICS TH': 5482,
'CANADIAN SYLLABICS TH-CREE TH': 5550,
'CANADIAN SYLLABICS TH-CREE THA': 5548,
'CANADIAN SYLLABICS TH-CREE THAA': 5549,
'CANADIAN SYLLABICS TH-CREE THE': 5543,
'CANADIAN SYLLABICS TH-CREE THI': 5544,
'CANADIAN SYLLABICS TH-CREE THII': 5545,
'CANADIAN SYLLABICS TH-CREE THO': 5546,
'CANADIAN SYLLABICS TH-CREE THOO': 5547,
'CANADIAN SYLLABICS THA': 5478,
'CANADIAN SYLLABICS THAA': 5479,
'CANADIAN SYLLABICS THE': 5470,
'CANADIAN SYLLABICS THI': 5472,
'CANADIAN SYLLABICS THII': 5474,
'CANADIAN SYLLABICS THO': 5476,
'CANADIAN SYLLABICS THOO': 5477,
'CANADIAN SYLLABICS THWA': 6372,
'CANADIAN SYLLABICS THWAA': 5480,
'CANADIAN SYLLABICS THWE': 6371,
'CANADIAN SYLLABICS TI': 5198,
'CANADIAN SYLLABICS TII': 5199,
'CANADIAN SYLLABICS TLHA': 5513,
'CANADIAN SYLLABICS TLHE': 5510,
'CANADIAN SYLLABICS TLHI': 5511,
'CANADIAN SYLLABICS TLHO': 5512,
'CANADIAN SYLLABICS TLHOO': 6377,
'CANADIAN SYLLABICS TLHWE': 6376,
'CANADIAN SYLLABICS TO': 5200,
'CANADIAN SYLLABICS TOO': 5201,
'CANADIAN SYLLABICS TTA': 5226,
'CANADIAN SYLLABICS TTE': 5223,
'CANADIAN SYLLABICS TTH': 5487,
'CANADIAN SYLLABICS TTHA': 5486,
'CANADIAN SYLLABICS TTHAA': 6375,
'CANADIAN SYLLABICS TTHE': 5483,
'CANADIAN SYLLABICS TTHI': 5484,
'CANADIAN SYLLABICS TTHO': 5485,
'CANADIAN SYLLABICS TTHOO': 6374,
'CANADIAN SYLLABICS TTHWE': 6373,
'CANADIAN SYLLABICS TTI': 5224,
'CANADIAN SYLLABICS TTO': 5225,
'CANADIAN SYLLABICS TWA': 5217,
'CANADIAN SYLLABICS TWAA': 5219,
'CANADIAN SYLLABICS TWE': 5207,
'CANADIAN SYLLABICS TWI': 5209,
'CANADIAN SYLLABICS TWII': 5211,
'CANADIAN SYLLABICS TWO': 5213,
'CANADIAN SYLLABICS TWOO': 5215,
'CANADIAN SYLLABICS TYA': 5491,
'CANADIAN SYLLABICS TYE': 5488,
'CANADIAN SYLLABICS TYI': 5489,
'CANADIAN SYLLABICS TYO': 5490,
'CANADIAN SYLLABICS WA': 5143,
'CANADIAN SYLLABICS WAA': 5145,
'CANADIAN SYLLABICS WAY': 6323,
'CANADIAN SYLLABICS WE': 5132,
'CANADIAN SYLLABICS WEST-CREE CWA': 5277,
'CANADIAN SYLLABICS WEST-CREE CWAA': 5279,
'CANADIAN SYLLABICS WEST-CREE CWE': 5267,
'CANADIAN SYLLABICS WEST-CREE CWI': 5269,
'CANADIAN SYLLABICS WEST-CREE CWII': 5271,
'CANADIAN SYLLABICS WEST-CREE CWO': 5273,
'CANADIAN SYLLABICS WEST-CREE CWOO': 5275,
'CANADIAN SYLLABICS WEST-CREE FWAA': 5468,
'CANADIAN SYLLABICS WEST-CREE KWA': 5247,
'CANADIAN SYLLABICS WEST-CREE KWAA': 5249,
'CANADIAN SYLLABICS WEST-CREE KWE': 5237,
'CANADIAN SYLLABICS WEST-CREE KWI': 5239,
'CANADIAN SYLLABICS WEST-CREE KWII': 5241,
'CANADIAN SYLLABICS WEST-CREE KWO': 5243,
'CANADIAN SYLLABICS WEST-CREE KWOO': 5245,
'CANADIAN SYLLABICS WEST-CREE L': 5355,
'CANADIAN SYLLABICS WEST-CREE LA': 5453,
'CANADIAN SYLLABICS WEST-CREE LAA': 6370,
'CANADIAN SYLLABICS WEST-CREE LE': 5444,
'CANADIAN SYLLABICS WEST-CREE LO': 5450,
'CANADIAN SYLLABICS WEST-CREE LOO': 6369,
'CANADIAN SYLLABICS WEST-CREE LWA': 5351,
'CANADIAN SYLLABICS WEST-CREE LWAA': 5353,
'CANADIAN SYLLABICS WEST-CREE LWE': 5341,
'CANADIAN SYLLABICS WEST-CREE LWI': 5343,
'CANADIAN SYLLABICS WEST-CREE LWII': 5345,
'CANADIAN SYLLABICS WEST-CREE LWO': 5347,
'CANADIAN SYLLABICS WEST-CREE LWOO': 5349,
'CANADIAN SYLLABICS WEST-CREE M': 5308,
'CANADIAN SYLLABICS WEST-CREE MWA': 5303,
'CANADIAN SYLLABICS WEST-CREE MWAA': 5305,
'CANADIAN SYLLABICS WEST-CREE MWE': 5293,
'CANADIAN SYLLABICS WEST-CREE MWI': 5295,
'CANADIAN SYLLABICS WEST-CREE MWII': 5297,
'CANADIAN SYLLABICS WEST-CREE MWO': 5299,
'CANADIAN SYLLABICS WEST-CREE MWOO': 5301,
'CANADIAN SYLLABICS WEST-CREE NWA': 5324,
'CANADIAN SYLLABICS WEST-CREE NWAA': 5326,
'CANADIAN SYLLABICS WEST-CREE NWE': 5322,
'CANADIAN SYLLABICS WEST-CREE P': 5194,
'CANADIAN SYLLABICS WEST-CREE PWA': 5189,
'CANADIAN SYLLABICS WEST-CREE PWAA': 5191,
'CANADIAN SYLLABICS WEST-CREE PWE': 5179,
'CANADIAN SYLLABICS WEST-CREE PWI': 5181,
'CANADIAN SYLLABICS WEST-CREE PWII': 5183,
'CANADIAN SYLLABICS WEST-CREE PWO': 5185,
'CANADIAN SYLLABICS WEST-CREE PWOO': 5187,
'CANADIAN SYLLABICS WEST-CREE R': 5457,
'CANADIAN SYLLABICS WEST-CREE RA': 5517,
'CANADIAN SYLLABICS WEST-CREE RE': 5514,
'CANADIAN SYLLABICS WEST-CREE RI': 5515,
'CANADIAN SYLLABICS WEST-CREE RO': 5516,
'CANADIAN SYLLABICS WEST-CREE RWAA': 5455,
'CANADIAN SYLLABICS WEST-CREE SHWA': 5410,
'CANADIAN SYLLABICS WEST-CREE SHWAA': 5412,
'CANADIAN SYLLABICS WEST-CREE SHWE': 5400,
'CANADIAN SYLLABICS WEST-CREE SHWI': 5402,
'CANADIAN SYLLABICS WEST-CREE SHWII': 5404,
'CANADIAN SYLLABICS WEST-CREE SHWO': 5406,
'CANADIAN SYLLABICS WEST-CREE SHWOO': 5408,
'CANADIAN SYLLABICS WEST-CREE SWA': 5377,
'CANADIAN SYLLABICS WEST-CREE SWAA': 5379,
'CANADIAN SYLLABICS WEST-CREE SWE': 5367,
'CANADIAN SYLLABICS WEST-CREE SWI': 5369,
'CANADIAN SYLLABICS WEST-CREE SWII': 5371,
'CANADIAN SYLLABICS WEST-CREE SWO': 5373,
'CANADIAN SYLLABICS WEST-CREE SWOO': 5375,
'CANADIAN SYLLABICS WEST-CREE THWAA': 5481,
'CANADIAN SYLLABICS WEST-CREE TWA': 5218,
'CANADIAN SYLLABICS WEST-CREE TWAA': 5220,
'CANADIAN SYLLABICS WEST-CREE TWE': 5208,
'CANADIAN SYLLABICS WEST-CREE TWI': 5210,
'CANADIAN SYLLABICS WEST-CREE TWII': 5212,
'CANADIAN SYLLABICS WEST-CREE TWO': 5214,
'CANADIAN SYLLABICS WEST-CREE TWOO': 5216,
'CANADIAN SYLLABICS WEST-CREE WA': 5144,
'CANADIAN SYLLABICS WEST-CREE WAA': 5146,
'CANADIAN SYLLABICS WEST-CREE WE': 5133,
'CANADIAN SYLLABICS WEST-CREE WI': 5135,
'CANADIAN SYLLABICS WEST-CREE WII': 5137,
'CANADIAN SYLLABICS WEST-CREE WO': 5139,
'CANADIAN SYLLABICS WEST-CREE WOO': 5141,
'CANADIAN SYLLABICS WEST-CREE Y': 5440,
'CANADIAN SYLLABICS WEST-CREE YWA': 5434,
'CANADIAN SYLLABICS WEST-CREE YWAA': 5436,
'CANADIAN SYLLABICS WEST-CREE YWE': 5424,
'CANADIAN SYLLABICS WEST-CREE YWI': 5426,
'CANADIAN SYLLABICS WEST-CREE YWII': 5428,
'CANADIAN SYLLABICS WEST-CREE YWO': 5430,
'CANADIAN SYLLABICS WEST-CREE YWOO': 5432,
'CANADIAN SYLLABICS WESTERN W': 6365,
'CANADIAN SYLLABICS WI': 5134,
'CANADIAN SYLLABICS WII': 5136,
'CANADIAN SYLLABICS WO': 5138,
'CANADIAN SYLLABICS WOO': 5140,
'CANADIAN SYLLABICS WOODS-CREE FINAL TH': 5758,
'CANADIAN SYLLABICS WOODS-CREE TH': 5535,
'CANADIAN SYLLABICS WOODS-CREE THA': 5534,
'CANADIAN SYLLABICS WOODS-CREE THE': 5531,
'CANADIAN SYLLABICS WOODS-CREE THI': 5532,
'CANADIAN SYLLABICS WOODS-CREE THO': 5533,
'CANADIAN SYLLABICS WOODS-CREE THWA': 5756,
'CANADIAN SYLLABICS WOODS-CREE THWAA': 5757,
'CANADIAN SYLLABICS WOODS-CREE THWEE': 5751,
'CANADIAN SYLLABICS WOODS-CREE THWI': 5752,
'CANADIAN SYLLABICS WOODS-CREE THWII': 5753,
'CANADIAN SYLLABICS WOODS-CREE THWO': 5754,
'CANADIAN SYLLABICS WOODS-CREE THWOO': 5755,
'CANADIAN SYLLABICS Y': 5438,
'CANADIAN SYLLABICS Y-CREE COO': 5263,
'CANADIAN SYLLABICS Y-CREE KOO': 5233,
'CANADIAN SYLLABICS Y-CREE LOO': 5337,
'CANADIAN SYLLABICS Y-CREE MOO': 5289,
'CANADIAN SYLLABICS Y-CREE NOO': 5318,
'CANADIAN SYLLABICS Y-CREE OO': 5127,
'CANADIAN SYLLABICS Y-CREE POO': 5173,
'CANADIAN SYLLABICS Y-CREE PWAA': 5192,
'CANADIAN SYLLABICS Y-CREE SOO': 5363,
'CANADIAN SYLLABICS Y-CREE TOO': 5202,
'CANADIAN SYLLABICS Y-CREE W': 5149,
'CANADIAN SYLLABICS Y-CREE YOO': 5420,
'CANADIAN SYLLABICS YA': 5421,
'CANADIAN SYLLABICS YAA': 5422,
'CANADIAN SYLLABICS YAAI': 5415,
'CANADIAN SYLLABICS YAY': 6340,
'CANADIAN SYLLABICS YE': 5414,
'CANADIAN SYLLABICS YI': 5416,
'CANADIAN SYLLABICS YII': 5417,
'CANADIAN SYLLABICS YO': 5418,
'CANADIAN SYLLABICS YOO': 5419,
'CANADIAN SYLLABICS YOY': 6339,
'CANADIAN SYLLABICS YWA': 5433,
'CANADIAN SYLLABICS YWAA': 5435,
'CANADIAN SYLLABICS YWE': 5423,
'CANADIAN SYLLABICS YWI': 5425,
'CANADIAN SYLLABICS YWII': 5427,
'CANADIAN SYLLABICS YWO': 5429,
'CANADIAN SYLLABICS YWOO': 5431,
'CANCEL TAG': 917631,
'CANCER': 9803,
'CAPRICORN': 9809,
'CAR SLIDING': 9936,
'CARE OF': 8453,
'CARET': 8248,
'CARET INSERTION POINT': 8257,
'CARIAN LETTER A': 66208,
'CARIAN LETTER A2': 66215,
'CARIAN LETTER B': 66217,
'CARIAN LETTER C-18': 66225,
'CARIAN LETTER C-39': 66246,
'CARIAN LETTER D': 66210,
'CARIAN LETTER D2': 66220,
'CARIAN LETTER E': 66234,
'CARIAN LETTER E2': 66255,
'CARIAN LETTER G': 66240,
'CARIAN LETTER G2': 66241,
'CARIAN LETTER I': 66233,
'CARIAN LETTER II': 66245,
'CARIAN LETTER K': 66236,
'CARIAN LETTER K2': 66237,
'CARIAN LETTER L': 66211,
'CARIAN LETTER LD': 66214,
'CARIAN LETTER LD2': 66254,
'CARIAN LETTER M': 66218,
'CARIAN LETTER MB': 66250,
'CARIAN LETTER MB2': 66251,
'CARIAN LETTER MB3': 66252,
'CARIAN LETTER MB4': 66253,
'CARIAN LETTER N': 66229,
'CARIAN LETTER ND': 66238,
'CARIAN LETTER NG': 66244,
'CARIAN LETTER NN': 66227,
'CARIAN LETTER O': 66219,
'CARIAN LETTER P': 66231,
'CARIAN LETTER P2': 66209,
'CARIAN LETTER Q': 66216,
'CARIAN LETTER R': 66213,
'CARIAN LETTER RR': 66249,
'CARIAN LETTER S': 66224,
'CARIAN LETTER SH': 66222,
'CARIAN LETTER SH2': 66223,
'CARIAN LETTER SS': 66232,
'CARIAN LETTER ST': 66242,
'CARIAN LETTER ST2': 66243,
'CARIAN LETTER T': 66221,
'CARIAN LETTER TT': 66247,
'CARIAN LETTER TT2': 66230,
'CARIAN LETTER U': 66226,
'CARIAN LETTER UU': 66239,
'CARIAN LETTER UUU': 66212,
'CARIAN LETTER UUU2': 66248,
'CARIAN LETTER UUU3': 66256,
'CARIAN LETTER UUUU': 66235,
'CARIAN LETTER X': 66228,
'CARON': 711,
'CASTLE': 9963,
'CAUTION SIGN': 9761,
'CEDI SIGN': 8373,
'CEDILLA': 184,
'CENT SIGN': 162,
'CENTRE LINE SYMBOL': 8452,
'CENTRELINE LOW LINE': 65102,
'CENTRELINE OVERLINE': 65098,
'CERES': 9907,
'CHAINS': 9939,
'CHAM CONSONANT SIGN FINAL H': 43597,
'CHAM CONSONANT SIGN FINAL M': 43596,
'CHAM CONSONANT SIGN FINAL NG': 43587,
'CHAM CONSONANT SIGN LA': 43573,
'CHAM CONSONANT SIGN RA': 43572,
'CHAM CONSONANT SIGN WA': 43574,
'CHAM CONSONANT SIGN YA': 43571,
'CHAM DIGIT EIGHT': 43608,
'CHAM DIGIT FIVE': 43605,
'CHAM DIGIT FOUR': 43604,
'CHAM DIGIT NINE': 43609,
'CHAM DIGIT ONE': 43601,
'CHAM DIGIT SEVEN': 43607,
'CHAM DIGIT SIX': 43606,
'CHAM DIGIT THREE': 43603,
'CHAM DIGIT TWO': 43602,
'CHAM DIGIT ZERO': 43600,
'CHAM LETTER A': 43520,
'CHAM LETTER AI': 43524,
'CHAM LETTER BA': 43549,
'CHAM LETTER BBA': 43553,
'CHAM LETTER BHA': 43550,
'CHAM LETTER CHA': 43532,
'CHAM LETTER CHHA': 43533,
'CHAM LETTER DA': 43541,
'CHAM LETTER DDA': 43545,
'CHAM LETTER DHA': 43542,
'CHAM LETTER E': 43523,
'CHAM LETTER FINAL CH': 43588,
'CHAM LETTER FINAL G': 43585,
'CHAM LETTER FINAL K': 43584,
'CHAM LETTER FINAL L': 43594,
'CHAM LETTER FINAL N': 43590,
'CHAM LETTER FINAL NG': 43586,
'CHAM LETTER FINAL P': 43591,
'CHAM LETTER FINAL R': 43593,
'CHAM LETTER FINAL SS': 43595,
'CHAM LETTER FINAL T': 43589,
'CHAM LETTER FINAL Y': 43592,
'CHAM LETTER GA': 43528,
'CHAM LETTER GHA': 43529,
'CHAM LETTER HA': 43560,
'CHAM LETTER I': 43521,
'CHAM LETTER JA': 43534,
'CHAM LETTER JHA': 43535,
'CHAM LETTER KA': 43526,
'CHAM LETTER KHA': 43527,
'CHAM LETTER LA': 43556,
'CHAM LETTER MA': 43552,
'CHAM LETTER MUE': 43551,
'CHAM LETTER NA': 43544,
'CHAM LETTER NGA': 43531,
'CHAM LETTER NGUE': 43530,
'CHAM LETTER NHA': 43537,
'CHAM LETTER NHJA': 43538,
'CHAM LETTER NHUE': 43536,
'CHAM LETTER NUE': 43543,
'CHAM LETTER O': 43525,
'CHAM LETTER PA': 43546,
'CHAM LETTER PHA': 43548,
'CHAM LETTER PPA': 43547,
'CHAM LETTER RA': 43555,
'CHAM LETTER SA': 43559,
'CHAM LETTER SSA': 43558,
'CHAM LETTER TA': 43539,
'CHAM LETTER THA': 43540,
'CHAM LETTER U': 43522,
'CHAM LETTER VA': 43557,
'CHAM LETTER YA': 43554,
'CHAM PUNCTUATION DANDA': 43613,
'CHAM PUNCTUATION DOUBLE DANDA': 43614,
'CHAM PUNCTUATION SPIRAL': 43612,
'CHAM PUNCTUATION TRIPLE DANDA': 43615,
'CHAM VOWEL SIGN AA': 43561,
'CHAM VOWEL SIGN AI': 43568,
'CHAM VOWEL SIGN AU': 43569,
'CHAM VOWEL SIGN EI': 43564,
'CHAM VOWEL SIGN I': 43562,
'CHAM VOWEL SIGN II': 43563,
'CHAM VOWEL SIGN O': 43567,
'CHAM VOWEL SIGN OE': 43566,
'CHAM VOWEL SIGN U': 43565,
'CHAM VOWEL SIGN UE': 43570,
'CHARACTER TIE': 8256,
'CHECK MARK': 10003,
'CHEROKEE LETTER A': 5024,
'CHEROKEE LETTER DA': 5075,
'CHEROKEE LETTER DE': 5077,
'CHEROKEE LETTER DI': 5079,
'CHEROKEE LETTER DLA': 5084,
'CHEROKEE LETTER DO': 5081,
'CHEROKEE LETTER DU': 5082,
'CHEROKEE LETTER DV': 5083,
'CHEROKEE LETTER E': 5025,
'CHEROKEE LETTER GA': 5030,
'CHEROKEE LETTER GE': 5032,
'CHEROKEE LETTER GI': 5033,
'CHEROKEE LETTER GO': 5034,
'CHEROKEE LETTER GU': 5035,
'CHEROKEE LETTER GV': 5036,
'CHEROKEE LETTER HA': 5037,
'CHEROKEE LETTER HE': 5038,
'CHEROKEE LETTER HI': 5039,
'CHEROKEE LETTER HNA': 5055,
'CHEROKEE LETTER HO': 5040,
'CHEROKEE LETTER HU': 5041,
'CHEROKEE LETTER HV': 5042,
'CHEROKEE LETTER I': 5026,
'CHEROKEE LETTER KA': 5031,
'CHEROKEE LETTER LA': 5043,
'CHEROKEE LETTER LE': 5044,
'CHEROKEE LETTER LI': 5045,
'CHEROKEE LETTER LO': 5046,
'CHEROKEE LETTER LU': 5047,
'CHEROKEE LETTER LV': 5048,
'CHEROKEE LETTER MA': 5049,
'CHEROKEE LETTER ME': 5050,
'CHEROKEE LETTER MI': 5051,
'CHEROKEE LETTER MO': 5052,
'CHEROKEE LETTER MU': 5053,
'CHEROKEE LETTER NA': 5054,
'CHEROKEE LETTER NAH': 5056,
'CHEROKEE LETTER NE': 5057,
'CHEROKEE LETTER NI': 5058,
'CHEROKEE LETTER NO': 5059,
'CHEROKEE LETTER NU': 5060,
'CHEROKEE LETTER NV': 5061,
'CHEROKEE LETTER O': 5027,
'CHEROKEE LETTER QUA': 5062,
'CHEROKEE LETTER QUE': 5063,
'CHEROKEE LETTER QUI': 5064,
'CHEROKEE LETTER QUO': 5065,
'CHEROKEE LETTER QUU': 5066,
'CHEROKEE LETTER QUV': 5067,
'CHEROKEE LETTER S': 5069,
'CHEROKEE LETTER SA': 5068,
'CHEROKEE LETTER SE': 5070,
'CHEROKEE LETTER SI': 5071,
'CHEROKEE LETTER SO': 5072,
'CHEROKEE LETTER SU': 5073,
'CHEROKEE LETTER SV': 5074,
'CHEROKEE LETTER TA': 5076,
'CHEROKEE LETTER TE': 5078,
'CHEROKEE LETTER TI': 5080,
'CHEROKEE LETTER TLA': 5085,
'CHEROKEE LETTER TLE': 5086,
'CHEROKEE LETTER TLI': 5087,
'CHEROKEE LETTER TLO': 5088,
'CHEROKEE LETTER TLU': 5089,
'CHEROKEE LETTER TLV': 5090,
'CHEROKEE LETTER TSA': 5091,
'CHEROKEE LETTER TSE': 5092,
'CHEROKEE LETTER TSI': 5093,
'CHEROKEE LETTER TSO': 5094,
'CHEROKEE LETTER TSU': 5095,
'CHEROKEE LETTER TSV': 5096,
'CHEROKEE LETTER U': 5028,
'CHEROKEE LETTER V': 5029,
'CHEROKEE LETTER WA': 5097,
'CHEROKEE LETTER WE': 5098,
'CHEROKEE LETTER WI': 5099,
'CHEROKEE LETTER WO': 5100,
'CHEROKEE LETTER WU': 5101,
'CHEROKEE LETTER WV': 5102,
'CHEROKEE LETTER YA': 5103,
'CHEROKEE LETTER YE': 5104,
'CHEROKEE LETTER YI': 5105,
'CHEROKEE LETTER YO': 5106,
'CHEROKEE LETTER YU': 5107,
'CHEROKEE LETTER YV': 5108,
'CHI RHO': 9767,
'CHIRON': 9911,
'CHURCH': 9962,
'CIRCLE DIVIDED BY HORIZONTAL BAR AND TOP HALF DIVIDED BY VERTICAL BAR': 10682,
'CIRCLE WITH ALL BUT UPPER LEFT QUADRANT BLACK': 9685,
'CIRCLE WITH HORIZONTAL BAR': 10677,
'CIRCLE WITH LEFT HALF BLACK': 9680,
'CIRCLE WITH LOWER HALF BLACK': 9682,
'CIRCLE WITH RIGHT HALF BLACK': 9681,
'CIRCLE WITH SMALL CIRCLE TO THE RIGHT': 10690,
'CIRCLE WITH SUPERIMPOSED X': 10683,
'CIRCLE WITH TWO HORIZONTAL STROKES TO THE RIGHT': 10691,
'CIRCLE WITH UPPER HALF BLACK': 9683,
'CIRCLE WITH UPPER RIGHT QUADRANT BLACK': 9684,
'CIRCLE WITH VERTICAL FILL': 9677,
'CIRCLED ANTICLOCKWISE-ROTATED DIVISION SIGN': 10684,
'CIRCLED ASTERISK OPERATOR': 8859,
'CIRCLED BULLET': 10687,
'CIRCLED CD': 127277,
'CIRCLED CROSSING LANES': 9938,
'CIRCLED DASH': 8861,
'CIRCLED DIGIT EIGHT': 9319,
'CIRCLED DIGIT FIVE': 9316,
'CIRCLED DIGIT FOUR': 9315,
'CIRCLED DIGIT NINE': 9320,
'CIRCLED DIGIT ONE': 9312,
'CIRCLED DIGIT SEVEN': 9318,
'CIRCLED DIGIT SIX': 9317,
'CIRCLED DIGIT THREE': 9314,
'CIRCLED DIGIT TWO': 9313,
'CIRCLED DIGIT ZERO': 9450,
'CIRCLED DIVISION SIGN': 10808,
'CIRCLED DIVISION SLASH': 8856,
'CIRCLED DOT OPERATOR': 8857,
'CIRCLED EQUALS': 8860,
'CIRCLED GREATER-THAN': 10689,
'CIRCLED HANGUL CHIEUCH': 12905,
'CIRCLED HANGUL CHIEUCH A': 12919,
'CIRCLED HANGUL CIEUC': 12904,
'CIRCLED HANGUL CIEUC A': 12918,
'CIRCLED HANGUL HIEUH': 12909,
'CIRCLED HANGUL HIEUH A': 12923,
'CIRCLED HANGUL IEUNG': 12903,
'CIRCLED HANGUL IEUNG A': 12917,
'CIRCLED HANGUL IEUNG U': 12926,
'CIRCLED HANGUL KHIEUKH': 12906,
'CIRCLED HANGUL KHIEUKH A': 12920,
'CIRCLED HANGUL KIYEOK': 12896,
'CIRCLED HANGUL KIYEOK A': 12910,
'CIRCLED HANGUL MIEUM': 12900,
'CIRCLED HANGUL MIEUM A': 12914,
'CIRCLED HANGUL NIEUN': 12897,
'CIRCLED HANGUL NIEUN A': 12911,
'CIRCLED HANGUL PHIEUPH': 12908,
'CIRCLED HANGUL PHIEUPH A': 12922,
'CIRCLED HANGUL PIEUP': 12901,
'CIRCLED HANGUL PIEUP A': 12915,
'CIRCLED HANGUL RIEUL': 12899,
'CIRCLED HANGUL RIEUL A': 12913,
'CIRCLED HANGUL SIOS': 12902,
'CIRCLED HANGUL SIOS A': 12916,
'CIRCLED HANGUL THIEUTH': 12907,
'CIRCLED HANGUL THIEUTH A': 12921,
'CIRCLED HANGUL TIKEUT': 12898,
'CIRCLED HANGUL TIKEUT A': 12912,
'CIRCLED HEAVY WHITE RIGHTWARDS ARROW': 10162,
'CIRCLED HORIZONTAL BAR WITH NOTCH': 9097,
'CIRCLED IDEOGRAPH ALLIANCE': 12975,
'CIRCLED IDEOGRAPH ATTENTION': 12959,
'CIRCLED IDEOGRAPH CENTRE': 12965,
'CIRCLED IDEOGRAPH CONGRATULATION': 12951,
'CIRCLED IDEOGRAPH COPY': 12962,
'CIRCLED IDEOGRAPH CORRECT': 12963,
'CIRCLED IDEOGRAPH EARTH': 12943,
'CIRCLED IDEOGRAPH EIGHT': 12935,
'CIRCLED IDEOGRAPH ENTERPRISE': 12973,
'CIRCLED IDEOGRAPH EXCELLENT': 12957,
'CIRCLED IDEOGRAPH FEMALE': 12955,
'CIRCLED IDEOGRAPH FINANCIAL': 12950,
'CIRCLED IDEOGRAPH FIRE': 12939,
'CIRCLED IDEOGRAPH FIVE': 12932,
'CIRCLED IDEOGRAPH FOUR': 12931,
'CIRCLED IDEOGRAPH HAVE': 12946,
'CIRCLED IDEOGRAPH HIGH': 12964,
'CIRCLED IDEOGRAPH ITEM': 12960,
'CIRCLED IDEOGRAPH KINDERGARTEN': 12869,
'CIRCLED IDEOGRAPH KOTO': 12871,
'CIRCLED IDEOGRAPH LABOR': 12952,
'CIRCLED IDEOGRAPH LEFT': 12967,
'CIRCLED IDEOGRAPH LOW': 12966,
'CIRCLED IDEOGRAPH MALE': 12954,
'CIRCLED IDEOGRAPH MEDICINE': 12969,
'CIRCLED IDEOGRAPH METAL': 12942,
'CIRCLED IDEOGRAPH MOON': 12938,
'CIRCLED IDEOGRAPH NAME': 12948,
'CIRCLED IDEOGRAPH NIGHT': 12976,
'CIRCLED IDEOGRAPH NINE': 12936,
'CIRCLED IDEOGRAPH ONE': 12928,
'CIRCLED IDEOGRAPH PRINT': 12958,
'CIRCLED IDEOGRAPH QUESTION': 12868,
'CIRCLED IDEOGRAPH RELIGION': 12970,
'CIRCLED IDEOGRAPH RESOURCE': 12974,
'CIRCLED IDEOGRAPH REST': 12961,
'CIRCLED IDEOGRAPH RIGHT': 12968,
'CIRCLED IDEOGRAPH SCHOOL': 12870,
'CIRCLED IDEOGRAPH SECRET': 12953,
'CIRCLED IDEOGRAPH SEVEN': 12934,
'CIRCLED IDEOGRAPH SIX': 12933,
'CIRCLED IDEOGRAPH SOCIETY': 12947,
'CIRCLED IDEOGRAPH SPECIAL': 12949,
'CIRCLED IDEOGRAPH STOCK': 12945,
'CIRCLED IDEOGRAPH STUDY': 12971,
'CIRCLED IDEOGRAPH SUITABLE': 12956,
'CIRCLED IDEOGRAPH SUN': 12944,
'CIRCLED IDEOGRAPH SUPERVISE': 12972,
'CIRCLED IDEOGRAPH TEN': 12937,
'CIRCLED IDEOGRAPH THREE': 12930,
'CIRCLED IDEOGRAPH TWO': 12929,
'CIRCLED IDEOGRAPH WATER': 12940,
'CIRCLED IDEOGRAPH WOOD': 12941,
'CIRCLED ITALIC LATIN CAPITAL LETTER C': 127275,
'CIRCLED ITALIC LATIN CAPITAL LETTER R': 127276,
'CIRCLED KATAKANA A': 13008,
'CIRCLED KATAKANA E': 13011,
'CIRCLED KATAKANA HA': 13033,
'CIRCLED KATAKANA HE': 13036,
'CIRCLED KATAKANA HI': 13034,
'CIRCLED KATAKANA HO': 13037,
'CIRCLED KATAKANA HU': 13035,
'CIRCLED KATAKANA I': 13009,
'CIRCLED KATAKANA KA': 13013,
'CIRCLED KATAKANA KE': 13016,
'CIRCLED KATAKANA KI': 13014,
'CIRCLED KATAKANA KO': 13017,
'CIRCLED KATAKANA KU': 13015,
'CIRCLED KATAKANA MA': 13038,
'CIRCLED KATAKANA ME': 13041,
'CIRCLED KATAKANA MI': 13039,
'CIRCLED KATAKANA MO': 13042,
'CIRCLED KATAKANA MU': 13040,
'CIRCLED KATAKANA NA': 13028,
'CIRCLED KATAKANA NE': 13031,
'CIRCLED KATAKANA NI': 13029,
'CIRCLED KATAKANA NO': 13032,
'CIRCLED KATAKANA NU': 13030,
'CIRCLED KATAKANA O': 13012,
'CIRCLED KATAKANA RA': 13046,
'CIRCLED KATAKANA RE': 13049,
'CIRCLED KATAKANA RI': 13047,
'CIRCLED KATAKANA RO': 13050,
'CIRCLED KATAKANA RU': 13048,
'CIRCLED KATAKANA SA': 13018,
'CIRCLED KATAKANA SE': 13021,
'CIRCLED KATAKANA SI': 13019,
'CIRCLED KATAKANA SO': 13022,
'CIRCLED KATAKANA SU': 13020,
'CIRCLED KATAKANA TA': 13023,
'CIRCLED KATAKANA TE': 13026,
'CIRCLED KATAKANA TI': 13024,
'CIRCLED KATAKANA TO': 13027,
'CIRCLED KATAKANA TU': 13025,
'CIRCLED KATAKANA U': 13010,
'CIRCLED KATAKANA WA': 13051,
'CIRCLED KATAKANA WE': 13053,
'CIRCLED KATAKANA WI': 13052,
'CIRCLED KATAKANA WO': 13054,
'CIRCLED KATAKANA YA': 13043,
'CIRCLED KATAKANA YO': 13045,
'CIRCLED KATAKANA YU': 13044,
'CIRCLED KOREAN CHARACTER CHAMKO': 12924,
'CIRCLED KOREAN CHARACTER JUEUI': 12925,
'CIRCLED LATIN CAPITAL LETTER A': 9398,
'CIRCLED LATIN CAPITAL LETTER B': 9399,
'CIRCLED LATIN CAPITAL LETTER C': 9400,
'CIRCLED LATIN CAPITAL LETTER D': 9401,
'CIRCLED LATIN CAPITAL LETTER E': 9402,
'CIRCLED LATIN CAPITAL LETTER F': 9403,
'CIRCLED LATIN CAPITAL LETTER G': 9404,
'CIRCLED LATIN CAPITAL LETTER H': 9405,
'CIRCLED LATIN CAPITAL LETTER I': 9406,
'CIRCLED LATIN CAPITAL LETTER J': 9407,
'CIRCLED LATIN CAPITAL LETTER K': 9408,
'CIRCLED LATIN CAPITAL LETTER L': 9409,
'CIRCLED LATIN CAPITAL LETTER M': 9410,
'CIRCLED LATIN CAPITAL LETTER N': 9411,
'CIRCLED LATIN CAPITAL LETTER O': 9412,
'CIRCLED LATIN CAPITAL LETTER P': 9413,
'CIRCLED LATIN CAPITAL LETTER Q': 9414,
'CIRCLED LATIN CAPITAL LETTER R': 9415,
'CIRCLED LATIN CAPITAL LETTER S': 9416,
'CIRCLED LATIN CAPITAL LETTER T': 9417,
'CIRCLED LATIN CAPITAL LETTER U': 9418,
'CIRCLED LATIN CAPITAL LETTER V': 9419,
'CIRCLED LATIN CAPITAL LETTER W': 9420,
'CIRCLED LATIN CAPITAL LETTER X': 9421,
'CIRCLED LATIN CAPITAL LETTER Y': 9422,
'CIRCLED LATIN CAPITAL LETTER Z': 9423,
'CIRCLED LATIN SMALL LETTER A': 9424,
'CIRCLED LATIN SMALL LETTER B': 9425,
'CIRCLED LATIN SMALL LETTER C': 9426,
'CIRCLED LATIN SMALL LETTER D': 9427,
'CIRCLED LATIN SMALL LETTER E': 9428,
'CIRCLED LATIN SMALL LETTER F': 9429,
'CIRCLED LATIN SMALL LETTER G': 9430,
'CIRCLED LATIN SMALL LETTER H': 9431,
'CIRCLED LATIN SMALL LETTER I': 9432,
'CIRCLED LATIN SMALL LETTER J': 9433,
'CIRCLED LATIN SMALL LETTER K': 9434,
'CIRCLED LATIN SMALL LETTER L': 9435,
'CIRCLED LATIN SMALL LETTER M': 9436,
'CIRCLED LATIN SMALL LETTER N': 9437,
'CIRCLED LATIN SMALL LETTER O': 9438,
'CIRCLED LATIN SMALL LETTER P': 9439,
'CIRCLED LATIN SMALL LETTER Q': 9440,
'CIRCLED LATIN SMALL LETTER R': 9441,
'CIRCLED LATIN SMALL LETTER S': 9442,
'CIRCLED LATIN SMALL LETTER T': 9443,
'CIRCLED LATIN SMALL LETTER U': 9444,
'CIRCLED LATIN SMALL LETTER V': 9445,
'CIRCLED LATIN SMALL LETTER W': 9446,
'CIRCLED LATIN SMALL LETTER X': 9447,
'CIRCLED LATIN SMALL LETTER Y': 9448,
'CIRCLED LATIN SMALL LETTER Z': 9449,
'CIRCLED LESS-THAN': 10688,
'CIRCLED MINUS': 8854,
'CIRCLED MULTIPLICATION SIGN WITH CIRCUMFLEX ACCENT': 10806,
'CIRCLED NUMBER EIGHTEEN': 9329,
'CIRCLED NUMBER EIGHTY ON BLACK SQUARE': 12879,
'CIRCLED NUMBER ELEVEN': 9322,
'CIRCLED NUMBER FIFTEEN': 9326,
'CIRCLED NUMBER FIFTY': 12991,
'CIRCLED NUMBER FIFTY ON BLACK SQUARE': 12876,
'CIRCLED NUMBER FORTY': 12981,
'CIRCLED NUMBER FORTY EIGHT': 12989,
'CIRCLED NUMBER FORTY FIVE': 12986,
'CIRCLED NUMBER FORTY FOUR': 12985,
'CIRCLED NUMBER FORTY NINE': 12990,
'CIRCLED NUMBER FORTY ON BLACK SQUARE': 12875,
'CIRCLED NUMBER FORTY ONE': 12982,
'CIRCLED NUMBER FORTY SEVEN': 12988,
'CIRCLED NUMBER FORTY SIX': 12987,
'CIRCLED NUMBER FORTY THREE': 12984,
'CIRCLED NUMBER FORTY TWO': 12983,
'CIRCLED NUMBER FOURTEEN': 9325,
'CIRCLED NUMBER NINETEEN': 9330,
'CIRCLED NUMBER SEVENTEEN': 9328,
'CIRCLED NUMBER SEVENTY ON BLACK SQUARE': 12878,
'CIRCLED NUMBER SIXTEEN': 9327,
'CIRCLED NUMBER SIXTY ON BLACK SQUARE': 12877,
'CIRCLED NUMBER TEN': 9321,
'CIRCLED NUMBER TEN ON BLACK SQUARE': 12872,
'CIRCLED NUMBER THIRTEEN': 9324,
'CIRCLED NUMBER THIRTY': 12890,
'CIRCLED NUMBER THIRTY EIGHT': 12979,
'CIRCLED NUMBER THIRTY FIVE': 12895,
'CIRCLED NUMBER THIRTY FOUR': 12894,
'CIRCLED NUMBER THIRTY NINE': 12980,
'CIRCLED NUMBER THIRTY ON BLACK SQUARE': 12874,
'CIRCLED NUMBER THIRTY ONE': 12891,
'CIRCLED NUMBER THIRTY SEVEN': 12978,
'CIRCLED NUMBER THIRTY SIX': 12977,
'CIRCLED NUMBER THIRTY THREE': 12893,
'CIRCLED NUMBER THIRTY TWO': 12892,
'CIRCLED NUMBER TWELVE': 9323,
'CIRCLED NUMBER TWENTY': 9331,
'CIRCLED NUMBER TWENTY EIGHT': 12888,
'CIRCLED NUMBER TWENTY FIVE': 12885,
'CIRCLED NUMBER TWENTY FOUR': 12884,
'CIRCLED NUMBER TWENTY NINE': 12889,
'CIRCLED NUMBER TWENTY ON BLACK SQUARE': 12873,
'CIRCLED NUMBER TWENTY ONE': 12881,
'CIRCLED NUMBER TWENTY SEVEN': 12887,
'CIRCLED NUMBER TWENTY SIX': 12886,
'CIRCLED NUMBER TWENTY THREE': 12883,
'CIRCLED NUMBER TWENTY TWO': 12882,
'CIRCLED OPEN CENTRE EIGHT POINTED STAR': 10050,
'CIRCLED PARALLEL': 10679,
'CIRCLED PERPENDICULAR': 10681,
'CIRCLED PLUS': 8853,
'CIRCLED POSTAL MARK': 12342,
'CIRCLED REVERSE SOLIDUS': 10680,
'CIRCLED RING OPERATOR': 8858,
'CIRCLED TIMES': 8855,
'CIRCLED TRIANGLE DOWN': 9098,
'CIRCLED VERTICAL BAR': 10678,
'CIRCLED WHITE BULLET': 10686,
'CIRCLED WHITE STAR': 10026,
'CIRCLED WZ': 127278,
'CIRCULATION FUNCTION': 10768,
'CIRCUMFLEX ACCENT': 94,
'CJK COMPATIBILITY IDEOGRAPH-2F800': 194560,
'CJK COMPATIBILITY IDEOGRAPH-2F801': 194561,
'CJK COMPATIBILITY IDEOGRAPH-2F802': 194562,
'CJK COMPATIBILITY IDEOGRAPH-2F803': 194563,
'CJK COMPATIBILITY IDEOGRAPH-2F804': 194564,
'CJK COMPATIBILITY IDEOGRAPH-2F805': 194565,
'CJK COMPATIBILITY IDEOGRAPH-2F806': 194566,
'CJK COMPATIBILITY IDEOGRAPH-2F807': 194567,
'CJK COMPATIBILITY IDEOGRAPH-2F808': 194568,
'CJK COMPATIBILITY IDEOGRAPH-2F809': 194569,
'CJK COMPATIBILITY IDEOGRAPH-2F80A': 194570,
'CJK COMPATIBILITY IDEOGRAPH-2F80B': 194571,
'CJK COMPATIBILITY IDEOGRAPH-2F80C': 194572,
'CJK COMPATIBILITY IDEOGRAPH-2F80D': 194573,
'CJK COMPATIBILITY IDEOGRAPH-2F80E': 194574,
'CJK COMPATIBILITY IDEOGRAPH-2F80F': 194575,
'CJK COMPATIBILITY IDEOGRAPH-2F810': 194576,
'CJK COMPATIBILITY IDEOGRAPH-2F811': 194577,
'CJK COMPATIBILITY IDEOGRAPH-2F812': 194578,
'CJK COMPATIBILITY IDEOGRAPH-2F813': 194579,
'CJK COMPATIBILITY IDEOGRAPH-2F814': 194580,
'CJK COMPATIBILITY IDEOGRAPH-2F815': 194581,
'CJK COMPATIBILITY IDEOGRAPH-2F816': 194582,
'CJK COMPATIBILITY IDEOGRAPH-2F817': 194583,
'CJK COMPATIBILITY IDEOGRAPH-2F818': 194584,
'CJK COMPATIBILITY IDEOGRAPH-2F819': 194585,
'CJK COMPATIBILITY IDEOGRAPH-2F81A': 194586,
'CJK COMPATIBILITY IDEOGRAPH-2F81B': 194587,
'CJK COMPATIBILITY IDEOGRAPH-2F81C': 194588,
'CJK COMPATIBILITY IDEOGRAPH-2F81D': 194589,
'CJK COMPATIBILITY IDEOGRAPH-2F81E': 194590,
'CJK COMPATIBILITY IDEOGRAPH-2F81F': 194591,
'CJK COMPATIBILITY IDEOGRAPH-2F820': 194592,
'CJK COMPATIBILITY IDEOGRAPH-2F821': 194593,
'CJK COMPATIBILITY IDEOGRAPH-2F822': 194594,
'CJK COMPATIBILITY IDEOGRAPH-2F823': 194595,
'CJK COMPATIBILITY IDEOGRAPH-2F824': 194596,
'CJK COMPATIBILITY IDEOGRAPH-2F825': 194597,
'CJK COMPATIBILITY IDEOGRAPH-2F826': 194598,
'CJK COMPATIBILITY IDEOGRAPH-2F827': 194599,
'CJK COMPATIBILITY IDEOGRAPH-2F828': 194600,
'CJK COMPATIBILITY IDEOGRAPH-2F829': 194601,
'CJK COMPATIBILITY IDEOGRAPH-2F82A': 194602,
'CJK COMPATIBILITY IDEOGRAPH-2F82B': 194603,
'CJK COMPATIBILITY IDEOGRAPH-2F82C': 194604,
'CJK COMPATIBILITY IDEOGRAPH-2F82D': 194605,
'CJK COMPATIBILITY IDEOGRAPH-2F82E': 194606,
'CJK COMPATIBILITY IDEOGRAPH-2F82F': 194607,
'CJK COMPATIBILITY IDEOGRAPH-2F830': 194608,
'CJK COMPATIBILITY IDEOGRAPH-2F831': 194609,
'CJK COMPATIBILITY IDEOGRAPH-2F832': 194610,
'CJK COMPATIBILITY IDEOGRAPH-2F833': 194611,
'CJK COMPATIBILITY IDEOGRAPH-2F834': 194612,
'CJK COMPATIBILITY IDEOGRAPH-2F835': 194613,
'CJK COMPATIBILITY IDEOGRAPH-2F836': 194614,
'CJK COMPATIBILITY IDEOGRAPH-2F837': 194615,
'CJK COMPATIBILITY IDEOGRAPH-2F838': 194616,
'CJK COMPATIBILITY IDEOGRAPH-2F839': 194617,
'CJK COMPATIBILITY IDEOGRAPH-2F83A': 194618,
'CJK COMPATIBILITY IDEOGRAPH-2F83B': 194619,
'CJK COMPATIBILITY IDEOGRAPH-2F83C': 194620,
'CJK COMPATIBILITY IDEOGRAPH-2F83D': 194621,
'CJK COMPATIBILITY IDEOGRAPH-2F83E': 194622,
'CJK COMPATIBILITY IDEOGRAPH-2F83F': 194623,
'CJK COMPATIBILITY IDEOGRAPH-2F840': 194624,
'CJK COMPATIBILITY IDEOGRAPH-2F841': 194625,
'CJK COMPATIBILITY IDEOGRAPH-2F842': 194626,
'CJK COMPATIBILITY IDEOGRAPH-2F843': 194627,
'CJK COMPATIBILITY IDEOGRAPH-2F844': 194628,
'CJK COMPATIBILITY IDEOGRAPH-2F845': 194629,
'CJK COMPATIBILITY IDEOGRAPH-2F846': 194630,
'CJK COMPATIBILITY IDEOGRAPH-2F847': 194631,
'CJK COMPATIBILITY IDEOGRAPH-2F848': 194632,
'CJK COMPATIBILITY IDEOGRAPH-2F849': 194633,
'CJK COMPATIBILITY IDEOGRAPH-2F84A': 194634,
'CJK COMPATIBILITY IDEOGRAPH-2F84B': 194635,
'CJK COMPATIBILITY IDEOGRAPH-2F84C': 194636,
'CJK COMPATIBILITY IDEOGRAPH-2F84D': 194637,
'CJK COMPATIBILITY IDEOGRAPH-2F84E': 194638,
'CJK COMPATIBILITY IDEOGRAPH-2F84F': 194639,
'CJK COMPATIBILITY IDEOGRAPH-2F850': 194640,
'CJK COMPATIBILITY IDEOGRAPH-2F851': 194641,
'CJK COMPATIBILITY IDEOGRAPH-2F852': 194642,
'CJK COMPATIBILITY IDEOGRAPH-2F853': 194643,
'CJK COMPATIBILITY IDEOGRAPH-2F854': 194644,
'CJK COMPATIBILITY IDEOGRAPH-2F855': 194645,
'CJK COMPATIBILITY IDEOGRAPH-2F856': 194646,
'CJK COMPATIBILITY IDEOGRAPH-2F857': 194647,
'CJK COMPATIBILITY IDEOGRAPH-2F858': 194648,
'CJK COMPATIBILITY IDEOGRAPH-2F859': 194649,
'CJK COMPATIBILITY IDEOGRAPH-2F85A': 194650,
'CJK COMPATIBILITY IDEOGRAPH-2F85B': 194651,
'CJK COMPATIBILITY IDEOGRAPH-2F85C': 194652,
'CJK COMPATIBILITY IDEOGRAPH-2F85D': 194653,
'CJK COMPATIBILITY IDEOGRAPH-2F85E': 194654,
'CJK COMPATIBILITY IDEOGRAPH-2F85F': 194655,
'CJK COMPATIBILITY IDEOGRAPH-2F860': 194656,
'CJK COMPATIBILITY IDEOGRAPH-2F861': 194657,
'CJK COMPATIBILITY IDEOGRAPH-2F862': 194658,
'CJK COMPATIBILITY IDEOGRAPH-2F863': 194659,
'CJK COMPATIBILITY IDEOGRAPH-2F864': 194660,
'CJK COMPATIBILITY IDEOGRAPH-2F865': 194661,
'CJK COMPATIBILITY IDEOGRAPH-2F866': 194662,
'CJK COMPATIBILITY IDEOGRAPH-2F867': 194663,
'CJK COMPATIBILITY IDEOGRAPH-2F868': 194664,
'CJK COMPATIBILITY IDEOGRAPH-2F869': 194665,
'CJK COMPATIBILITY IDEOGRAPH-2F86A': 194666,
'CJK COMPATIBILITY IDEOGRAPH-2F86B': 194667,
'CJK COMPATIBILITY IDEOGRAPH-2F86C': 194668,
'CJK COMPATIBILITY IDEOGRAPH-2F86D': 194669,
'CJK COMPATIBILITY IDEOGRAPH-2F86E': 194670,
'CJK COMPATIBILITY IDEOGRAPH-2F86F': 194671,
'CJK COMPATIBILITY IDEOGRAPH-2F870': 194672,
'CJK COMPATIBILITY IDEOGRAPH-2F871': 194673,
'CJK COMPATIBILITY IDEOGRAPH-2F872': 194674,
'CJK COMPATIBILITY IDEOGRAPH-2F873': 194675,
'CJK COMPATIBILITY IDEOGRAPH-2F874': 194676,
'CJK COMPATIBILITY IDEOGRAPH-2F875': 194677,
'CJK COMPATIBILITY IDEOGRAPH-2F876': 194678,
'CJK COMPATIBILITY IDEOGRAPH-2F877': 194679,
'CJK COMPATIBILITY IDEOGRAPH-2F878': 194680,
'CJK COMPATIBILITY IDEOGRAPH-2F879': 194681,
'CJK COMPATIBILITY IDEOGRAPH-2F87A': 194682,
'CJK COMPATIBILITY IDEOGRAPH-2F87B': 194683,
'CJK COMPATIBILITY IDEOGRAPH-2F87C': 194684,
'CJK COMPATIBILITY IDEOGRAPH-2F87D': 194685,
'CJK COMPATIBILITY IDEOGRAPH-2F87E': 194686,
'CJK COMPATIBILITY IDEOGRAPH-2F87F': 194687,
'CJK COMPATIBILITY IDEOGRAPH-2F880': 194688,
'CJK COMPATIBILITY IDEOGRAPH-2F881': 194689,
'CJK COMPATIBILITY IDEOGRAPH-2F882': 194690,
'CJK COMPATIBILITY IDEOGRAPH-2F883': 194691,
'CJK COMPATIBILITY IDEOGRAPH-2F884': 194692,
'CJK COMPATIBILITY IDEOGRAPH-2F885': 194693,
'CJK COMPATIBILITY IDEOGRAPH-2F886': 194694,
'CJK COMPATIBILITY IDEOGRAPH-2F887': 194695,
'CJK COMPATIBILITY IDEOGRAPH-2F888': 194696,
'CJK COMPATIBILITY IDEOGRAPH-2F889': 194697,
'CJK COMPATIBILITY IDEOGRAPH-2F88A': 194698,
'CJK COMPATIBILITY IDEOGRAPH-2F88B': 194699,
'CJK COMPATIBILITY IDEOGRAPH-2F88C': 194700,
'CJK COMPATIBILITY IDEOGRAPH-2F88D': 194701,
'CJK COMPATIBILITY IDEOGRAPH-2F88E': 194702,
'CJK COMPATIBILITY IDEOGRAPH-2F88F': 194703,
'CJK COMPATIBILITY IDEOGRAPH-2F890': 194704,
'CJK COMPATIBILITY IDEOGRAPH-2F891': 194705,
'CJK COMPATIBILITY IDEOGRAPH-2F892': 194706,
'CJK COMPATIBILITY IDEOGRAPH-2F893': 194707,
'CJK COMPATIBILITY IDEOGRAPH-2F894': 194708,
'CJK COMPATIBILITY IDEOGRAPH-2F895': 194709,
'CJK COMPATIBILITY IDEOGRAPH-2F896': 194710,
'CJK COMPATIBILITY IDEOGRAPH-2F897': 194711,
'CJK COMPATIBILITY IDEOGRAPH-2F898': 194712,
'CJK COMPATIBILITY IDEOGRAPH-2F899': 194713,
'CJK COMPATIBILITY IDEOGRAPH-2F89A': 194714,
'CJK COMPATIBILITY IDEOGRAPH-2F89B': 194715,
'CJK COMPATIBILITY IDEOGRAPH-2F89C': 194716,
'CJK COMPATIBILITY IDEOGRAPH-2F89D': 194717,
'CJK COMPATIBILITY IDEOGRAPH-2F89E': 194718,
'CJK COMPATIBILITY IDEOGRAPH-2F89F': 194719,
'CJK COMPATIBILITY IDEOGRAPH-2F8A0': 194720,
'CJK COMPATIBILITY IDEOGRAPH-2F8A1': 194721,
'CJK COMPATIBILITY IDEOGRAPH-2F8A2': 194722,
'CJK COMPATIBILITY IDEOGRAPH-2F8A3': 194723,
'CJK COMPATIBILITY IDEOGRAPH-2F8A4': 194724,
'CJK COMPATIBILITY IDEOGRAPH-2F8A5': 194725,
'CJK COMPATIBILITY IDEOGRAPH-2F8A6': 194726,
'CJK COMPATIBILITY IDEOGRAPH-2F8A7': 194727,
'CJK COMPATIBILITY IDEOGRAPH-2F8A8': 194728,
'CJK COMPATIBILITY IDEOGRAPH-2F8A9': 194729,
'CJK COMPATIBILITY IDEOGRAPH-2F8AA': 194730,
'CJK COMPATIBILITY IDEOGRAPH-2F8AB': 194731,
'CJK COMPATIBILITY IDEOGRAPH-2F8AC': 194732,
'CJK COMPATIBILITY IDEOGRAPH-2F8AD': 194733,
'CJK COMPATIBILITY IDEOGRAPH-2F8AE': 194734,
'CJK COMPATIBILITY IDEOGRAPH-2F8AF': 194735,
'CJK COMPATIBILITY IDEOGRAPH-2F8B0': 194736,
'CJK COMPATIBILITY IDEOGRAPH-2F8B1': 194737,
'CJK COMPATIBILITY IDEOGRAPH-2F8B2': 194738,
'CJK COMPATIBILITY IDEOGRAPH-2F8B3': 194739,
'CJK COMPATIBILITY IDEOGRAPH-2F8B4': 194740,
'CJK COMPATIBILITY IDEOGRAPH-2F8B5': 194741,
'CJK COMPATIBILITY IDEOGRAPH-2F8B6': 194742,
'CJK COMPATIBILITY IDEOGRAPH-2F8B7': 194743,
'CJK COMPATIBILITY IDEOGRAPH-2F8B8': 194744,
'CJK COMPATIBILITY IDEOGRAPH-2F8B9': 194745,
'CJK COMPATIBILITY IDEOGRAPH-2F8BA': 194746,
'CJK COMPATIBILITY IDEOGRAPH-2F8BB': 194747,
'CJK COMPATIBILITY IDEOGRAPH-2F8BC': 194748,
'CJK COMPATIBILITY IDEOGRAPH-2F8BD': 194749,
'CJK COMPATIBILITY IDEOGRAPH-2F8BE': 194750,
'CJK COMPATIBILITY IDEOGRAPH-2F8BF': 194751,
'CJK COMPATIBILITY IDEOGRAPH-2F8C0': 194752,
'CJK COMPATIBILITY IDEOGRAPH-2F8C1': 194753,
'CJK COMPATIBILITY IDEOGRAPH-2F8C2': 194754,
'CJK COMPATIBILITY IDEOGRAPH-2F8C3': 194755,
'CJK COMPATIBILITY IDEOGRAPH-2F8C4': 194756,
'CJK COMPATIBILITY IDEOGRAPH-2F8C5': 194757,
'CJK COMPATIBILITY IDEOGRAPH-2F8C6': 194758,
'CJK COMPATIBILITY IDEOGRAPH-2F8C7': 194759,
'CJK COMPATIBILITY IDEOGRAPH-2F8C8': 194760,
'CJK COMPATIBILITY IDEOGRAPH-2F8C9': 194761,
'CJK COMPATIBILITY IDEOGRAPH-2F8CA': 194762,
'CJK COMPATIBILITY IDEOGRAPH-2F8CB': 194763,
'CJK COMPATIBILITY IDEOGRAPH-2F8CC': 194764,
'CJK COMPATIBILITY IDEOGRAPH-2F8CD': 194765,
'CJK COMPATIBILITY IDEOGRAPH-2F8CE': 194766,
'CJK COMPATIBILITY IDEOGRAPH-2F8CF': 194767,
'CJK COMPATIBILITY IDEOGRAPH-2F8D0': 194768,
'CJK COMPATIBILITY IDEOGRAPH-2F8D1': 194769,
'CJK COMPATIBILITY IDEOGRAPH-2F8D2': 194770,
'CJK COMPATIBILITY IDEOGRAPH-2F8D3': 194771,
'CJK COMPATIBILITY IDEOGRAPH-2F8D4': 194772,
'CJK COMPATIBILITY IDEOGRAPH-2F8D5': 194773,
'CJK COMPATIBILITY IDEOGRAPH-2F8D6': 194774,
'CJK COMPATIBILITY IDEOGRAPH-2F8D7': 194775,
'CJK COMPATIBILITY IDEOGRAPH-2F8D8': 194776,
'CJK COMPATIBILITY IDEOGRAPH-2F8D9': 194777,
'CJK COMPATIBILITY IDEOGRAPH-2F8DA': 194778,
'CJK COMPATIBILITY IDEOGRAPH-2F8DB': 194779,
'CJK COMPATIBILITY IDEOGRAPH-2F8DC': 194780,
'CJK COMPATIBILITY IDEOGRAPH-2F8DD': 194781,
'CJK COMPATIBILITY IDEOGRAPH-2F8DE': 194782,
'CJK COMPATIBILITY IDEOGRAPH-2F8DF': 194783,
'CJK COMPATIBILITY IDEOGRAPH-2F8E0': 194784,
'CJK COMPATIBILITY IDEOGRAPH-2F8E1': 194785,
'CJK COMPATIBILITY IDEOGRAPH-2F8E2': 194786,
'CJK COMPATIBILITY IDEOGRAPH-2F8E3': 194787,
'CJK COMPATIBILITY IDEOGRAPH-2F8E4': 194788,
'CJK COMPATIBILITY IDEOGRAPH-2F8E5': 194789,
'CJK COMPATIBILITY IDEOGRAPH-2F8E6': 194790,
'CJK COMPATIBILITY IDEOGRAPH-2F8E7': 194791,
'CJK COMPATIBILITY IDEOGRAPH-2F8E8': 194792,
'CJK COMPATIBILITY IDEOGRAPH-2F8E9': 194793,
'CJK COMPATIBILITY IDEOGRAPH-2F8EA': 194794,
'CJK COMPATIBILITY IDEOGRAPH-2F8EB': 194795,
'CJK COMPATIBILITY IDEOGRAPH-2F8EC': 194796,
'CJK COMPATIBILITY IDEOGRAPH-2F8ED': 194797,
'CJK COMPATIBILITY IDEOGRAPH-2F8EE': 194798,
'CJK COMPATIBILITY IDEOGRAPH-2F8EF': 194799,
'CJK COMPATIBILITY IDEOGRAPH-2F8F0': 194800,
'CJK COMPATIBILITY IDEOGRAPH-2F8F1': 194801,
'CJK COMPATIBILITY IDEOGRAPH-2F8F2': 194802,
'CJK COMPATIBILITY IDEOGRAPH-2F8F3': 194803,
'CJK COMPATIBILITY IDEOGRAPH-2F8F4': 194804,
'CJK COMPATIBILITY IDEOGRAPH-2F8F5': 194805,
'CJK COMPATIBILITY IDEOGRAPH-2F8F6': 194806,
'CJK COMPATIBILITY IDEOGRAPH-2F8F7': 194807,
'CJK COMPATIBILITY IDEOGRAPH-2F8F8': 194808,
'CJK COMPATIBILITY IDEOGRAPH-2F8F9': 194809,
'CJK COMPATIBILITY IDEOGRAPH-2F8FA': 194810,
'CJK COMPATIBILITY IDEOGRAPH-2F8FB': 194811,
'CJK COMPATIBILITY IDEOGRAPH-2F8FC': 194812,
'CJK COMPATIBILITY IDEOGRAPH-2F8FD': 194813,
'CJK COMPATIBILITY IDEOGRAPH-2F8FE': 194814,
'CJK COMPATIBILITY IDEOGRAPH-2F8FF': 194815,
'CJK COMPATIBILITY IDEOGRAPH-2F900': 194816,
'CJK COMPATIBILITY IDEOGRAPH-2F901': 194817,
'CJK COMPATIBILITY IDEOGRAPH-2F902': 194818,
'CJK COMPATIBILITY IDEOGRAPH-2F903': 194819,
'CJK COMPATIBILITY IDEOGRAPH-2F904': 194820,
'CJK COMPATIBILITY IDEOGRAPH-2F905': 194821,
'CJK COMPATIBILITY IDEOGRAPH-2F906': 194822,
'CJK COMPATIBILITY IDEOGRAPH-2F907': 194823,
'CJK COMPATIBILITY IDEOGRAPH-2F908': 194824,
'CJK COMPATIBILITY IDEOGRAPH-2F909': 194825,
'CJK COMPATIBILITY IDEOGRAPH-2F90A': 194826,
'CJK COMPATIBILITY IDEOGRAPH-2F90B': 194827,
'CJK COMPATIBILITY IDEOGRAPH-2F90C': 194828,
'CJK COMPATIBILITY IDEOGRAPH-2F90D': 194829,
'CJK COMPATIBILITY IDEOGRAPH-2F90E': 194830,
'CJK COMPATIBILITY IDEOGRAPH-2F90F': 194831,
'CJK COMPATIBILITY IDEOGRAPH-2F910': 194832,
'CJK COMPATIBILITY IDEOGRAPH-2F911': 194833,
'CJK COMPATIBILITY IDEOGRAPH-2F912': 194834,
'CJK COMPATIBILITY IDEOGRAPH-2F913': 194835,
'CJK COMPATIBILITY IDEOGRAPH-2F914': 194836,
'CJK COMPATIBILITY IDEOGRAPH-2F915': 194837,
'CJK COMPATIBILITY IDEOGRAPH-2F916': 194838,
'CJK COMPATIBILITY IDEOGRAPH-2F917': 194839,
'CJK COMPATIBILITY IDEOGRAPH-2F918': 194840,
'CJK COMPATIBILITY IDEOGRAPH-2F919': 194841,
'CJK COMPATIBILITY IDEOGRAPH-2F91A': 194842,
'CJK COMPATIBILITY IDEOGRAPH-2F91B': 194843,
'CJK COMPATIBILITY IDEOGRAPH-2F91C': 194844,
'CJK COMPATIBILITY IDEOGRAPH-2F91D': 194845,
'CJK COMPATIBILITY IDEOGRAPH-2F91E': 194846,
'CJK COMPATIBILITY IDEOGRAPH-2F91F': 194847,
'CJK COMPATIBILITY IDEOGRAPH-2F920': 194848,
'CJK COMPATIBILITY IDEOGRAPH-2F921': 194849,
'CJK COMPATIBILITY IDEOGRAPH-2F922': 194850,
'CJK COMPATIBILITY IDEOGRAPH-2F923': 194851,
'CJK COMPATIBILITY IDEOGRAPH-2F924': 194852,
'CJK COMPATIBILITY IDEOGRAPH-2F925': 194853,
'CJK COMPATIBILITY IDEOGRAPH-2F926': 194854,
'CJK COMPATIBILITY IDEOGRAPH-2F927': 194855,
'CJK COMPATIBILITY IDEOGRAPH-2F928': 194856,
'CJK COMPATIBILITY IDEOGRAPH-2F929': 194857,
'CJK COMPATIBILITY IDEOGRAPH-2F92A': 194858,
'CJK COMPATIBILITY IDEOGRAPH-2F92B': 194859,
'CJK COMPATIBILITY IDEOGRAPH-2F92C': 194860,
'CJK COMPATIBILITY IDEOGRAPH-2F92D': 194861,
'CJK COMPATIBILITY IDEOGRAPH-2F92E': 194862,
'CJK COMPATIBILITY IDEOGRAPH-2F92F': 194863,
'CJK COMPATIBILITY IDEOGRAPH-2F930': 194864,
'CJK COMPATIBILITY IDEOGRAPH-2F931': 194865,
'CJK COMPATIBILITY IDEOGRAPH-2F932': 194866,
'CJK COMPATIBILITY IDEOGRAPH-2F933': 194867,
'CJK COMPATIBILITY IDEOGRAPH-2F934': 194868,
'CJK COMPATIBILITY IDEOGRAPH-2F935': 194869,
'CJK COMPATIBILITY IDEOGRAPH-2F936': 194870,
'CJK COMPATIBILITY IDEOGRAPH-2F937': 194871,
'CJK COMPATIBILITY IDEOGRAPH-2F938': 194872,
'CJK COMPATIBILITY IDEOGRAPH-2F939': 194873,
'CJK COMPATIBILITY IDEOGRAPH-2F93A': 194874,
'CJK COMPATIBILITY IDEOGRAPH-2F93B': 194875,
'CJK COMPATIBILITY IDEOGRAPH-2F93C': 194876,
'CJK COMPATIBILITY IDEOGRAPH-2F93D': 194877,
'CJK COMPATIBILITY IDEOGRAPH-2F93E': 194878,
'CJK COMPATIBILITY IDEOGRAPH-2F93F': 194879,
'CJK COMPATIBILITY IDEOGRAPH-2F940': 194880,
'CJK COMPATIBILITY IDEOGRAPH-2F941': 194881,
'CJK COMPATIBILITY IDEOGRAPH-2F942': 194882,
'CJK COMPATIBILITY IDEOGRAPH-2F943': 194883,
'CJK COMPATIBILITY IDEOGRAPH-2F944': 194884,
'CJK COMPATIBILITY IDEOGRAPH-2F945': 194885,
'CJK COMPATIBILITY IDEOGRAPH-2F946': 194886,
'CJK COMPATIBILITY IDEOGRAPH-2F947': 194887,
'CJK COMPATIBILITY IDEOGRAPH-2F948': 194888,
'CJK COMPATIBILITY IDEOGRAPH-2F949': 194889,
'CJK COMPATIBILITY IDEOGRAPH-2F94A': 194890,
'CJK COMPATIBILITY IDEOGRAPH-2F94B': 194891,
'CJK COMPATIBILITY IDEOGRAPH-2F94C': 194892,
'CJK COMPATIBILITY IDEOGRAPH-2F94D': 194893,
'CJK COMPATIBILITY IDEOGRAPH-2F94E': 194894,
'CJK COMPATIBILITY IDEOGRAPH-2F94F': 194895,
'CJK COMPATIBILITY IDEOGRAPH-2F950': 194896,
'CJK COMPATIBILITY IDEOGRAPH-2F951': 194897,
'CJK COMPATIBILITY IDEOGRAPH-2F952': 194898,
'CJK COMPATIBILITY IDEOGRAPH-2F953': 194899,
'CJK COMPATIBILITY IDEOGRAPH-2F954': 194900,
'CJK COMPATIBILITY IDEOGRAPH-2F955': 194901,
'CJK COMPATIBILITY IDEOGRAPH-2F956': 194902,
'CJK COMPATIBILITY IDEOGRAPH-2F957': 194903,
'CJK COMPATIBILITY IDEOGRAPH-2F958': 194904,
'CJK COMPATIBILITY IDEOGRAPH-2F959': 194905,
'CJK COMPATIBILITY IDEOGRAPH-2F95A': 194906,
'CJK COMPATIBILITY IDEOGRAPH-2F95B': 194907,
'CJK COMPATIBILITY IDEOGRAPH-2F95C': 194908,
'CJK COMPATIBILITY IDEOGRAPH-2F95D': 194909,
'CJK COMPATIBILITY IDEOGRAPH-2F95E': 194910,
'CJK COMPATIBILITY IDEOGRAPH-2F95F': 194911,
'CJK COMPATIBILITY IDEOGRAPH-2F960': 194912,
'CJK COMPATIBILITY IDEOGRAPH-2F961': 194913,
'CJK COMPATIBILITY IDEOGRAPH-2F962': 194914,
'CJK COMPATIBILITY IDEOGRAPH-2F963': 194915,
'CJK COMPATIBILITY IDEOGRAPH-2F964': 194916,
'CJK COMPATIBILITY IDEOGRAPH-2F965': 194917,
'CJK COMPATIBILITY IDEOGRAPH-2F966': 194918,
'CJK COMPATIBILITY IDEOGRAPH-2F967': 194919,
'CJK COMPATIBILITY IDEOGRAPH-2F968': 194920,
'CJK COMPATIBILITY IDEOGRAPH-2F969': 194921,
'CJK COMPATIBILITY IDEOGRAPH-2F96A': 194922,
'CJK COMPATIBILITY IDEOGRAPH-2F96B': 194923,
'CJK COMPATIBILITY IDEOGRAPH-2F96C': 194924,
'CJK COMPATIBILITY IDEOGRAPH-2F96D': 194925,
'CJK COMPATIBILITY IDEOGRAPH-2F96E': 194926,
'CJK COMPATIBILITY IDEOGRAPH-2F96F': 194927,
'CJK COMPATIBILITY IDEOGRAPH-2F970': 194928,
'CJK COMPATIBILITY IDEOGRAPH-2F971': 194929,
'CJK COMPATIBILITY IDEOGRAPH-2F972': 194930,
'CJK COMPATIBILITY IDEOGRAPH-2F973': 194931,
'CJK COMPATIBILITY IDEOGRAPH-2F974': 194932,
'CJK COMPATIBILITY IDEOGRAPH-2F975': 194933,
'CJK COMPATIBILITY IDEOGRAPH-2F976': 194934,
'CJK COMPATIBILITY IDEOGRAPH-2F977': 194935,
'CJK COMPATIBILITY IDEOGRAPH-2F978': 194936,
'CJK COMPATIBILITY IDEOGRAPH-2F979': 194937,
'CJK COMPATIBILITY IDEOGRAPH-2F97A': 194938,
'CJK COMPATIBILITY IDEOGRAPH-2F97B': 194939,
'CJK COMPATIBILITY IDEOGRAPH-2F97C': 194940,
'CJK COMPATIBILITY IDEOGRAPH-2F97D': 194941,
'CJK COMPATIBILITY IDEOGRAPH-2F97E': 194942,
'CJK COMPATIBILITY IDEOGRAPH-2F97F': 194943,
'CJK COMPATIBILITY IDEOGRAPH-2F980': 194944,
'CJK COMPATIBILITY IDEOGRAPH-2F981': 194945,
'CJK COMPATIBILITY IDEOGRAPH-2F982': 194946,
'CJK COMPATIBILITY IDEOGRAPH-2F983': 194947,
'CJK COMPATIBILITY IDEOGRAPH-2F984': 194948,
'CJK COMPATIBILITY IDEOGRAPH-2F985': 194949,
'CJK COMPATIBILITY IDEOGRAPH-2F986': 194950,
'CJK COMPATIBILITY IDEOGRAPH-2F987': 194951,
'CJK COMPATIBILITY IDEOGRAPH-2F988': 194952,
'CJK COMPATIBILITY IDEOGRAPH-2F989': 194953,
'CJK COMPATIBILITY IDEOGRAPH-2F98A': 194954,
'CJK COMPATIBILITY IDEOGRAPH-2F98B': 194955,
'CJK COMPATIBILITY IDEOGRAPH-2F98C': 194956,
'CJK COMPATIBILITY IDEOGRAPH-2F98D': 194957,
'CJK COMPATIBILITY IDEOGRAPH-2F98E': 194958,
'CJK COMPATIBILITY IDEOGRAPH-2F98F': 194959,
'CJK COMPATIBILITY IDEOGRAPH-2F990': 194960,
'CJK COMPATIBILITY IDEOGRAPH-2F991': 194961,
'CJK COMPATIBILITY IDEOGRAPH-2F992': 194962,
'CJK COMPATIBILITY IDEOGRAPH-2F993': 194963,
'CJK COMPATIBILITY IDEOGRAPH-2F994': 194964,
'CJK COMPATIBILITY IDEOGRAPH-2F995': 194965,
'CJK COMPATIBILITY IDEOGRAPH-2F996': 194966,
'CJK COMPATIBILITY IDEOGRAPH-2F997': 194967,
'CJK COMPATIBILITY IDEOGRAPH-2F998': 194968,
'CJK COMPATIBILITY IDEOGRAPH-2F999': 194969,
'CJK COMPATIBILITY IDEOGRAPH-2F99A': 194970,
'CJK COMPATIBILITY IDEOGRAPH-2F99B': 194971,
'CJK COMPATIBILITY IDEOGRAPH-2F99C': 194972,
'CJK COMPATIBILITY IDEOGRAPH-2F99D': 194973,
'CJK COMPATIBILITY IDEOGRAPH-2F99E': 194974,
'CJK COMPATIBILITY IDEOGRAPH-2F99F': 194975,
'CJK COMPATIBILITY IDEOGRAPH-2F9A0': 194976,
'CJK COMPATIBILITY IDEOGRAPH-2F9A1': 194977,
'CJK COMPATIBILITY IDEOGRAPH-2F9A2': 194978,
'CJK COMPATIBILITY IDEOGRAPH-2F9A3': 194979,
'CJK COMPATIBILITY IDEOGRAPH-2F9A4': 194980,
'CJK COMPATIBILITY IDEOGRAPH-2F9A5': 194981,
'CJK COMPATIBILITY IDEOGRAPH-2F9A6': 194982,
'CJK COMPATIBILITY IDEOGRAPH-2F9A7': 194983,
'CJK COMPATIBILITY IDEOGRAPH-2F9A8': 194984,
'CJK COMPATIBILITY IDEOGRAPH-2F9A9': 194985,
'CJK COMPATIBILITY IDEOGRAPH-2F9AA': 194986,
'CJK COMPATIBILITY IDEOGRAPH-2F9AB': 194987,
'CJK COMPATIBILITY IDEOGRAPH-2F9AC': 194988,
'CJK COMPATIBILITY IDEOGRAPH-2F9AD': 194989,
'CJK COMPATIBILITY IDEOGRAPH-2F9AE': 194990,
'CJK COMPATIBILITY IDEOGRAPH-2F9AF': 194991,
'CJK COMPATIBILITY IDEOGRAPH-2F9B0': 194992,
'CJK COMPATIBILITY IDEOGRAPH-2F9B1': 194993,
'CJK COMPATIBILITY IDEOGRAPH-2F9B2': 194994,
'CJK COMPATIBILITY IDEOGRAPH-2F9B3': 194995,
'CJK COMPATIBILITY IDEOGRAPH-2F9B4': 194996,
'CJK COMPATIBILITY IDEOGRAPH-2F9B5': 194997,
'CJK COMPATIBILITY IDEOGRAPH-2F9B6': 194998,
'CJK COMPATIBILITY IDEOGRAPH-2F9B7': 194999,
'CJK COMPATIBILITY IDEOGRAPH-2F9B8': 195000,
'CJK COMPATIBILITY IDEOGRAPH-2F9B9': 195001,
'CJK COMPATIBILITY IDEOGRAPH-2F9BA': 195002,
'CJK COMPATIBILITY IDEOGRAPH-2F9BB': 195003,
'CJK COMPATIBILITY IDEOGRAPH-2F9BC': 195004,
'CJK COMPATIBILITY IDEOGRAPH-2F9BD': 195005,
'CJK COMPATIBILITY IDEOGRAPH-2F9BE': 195006,
'CJK COMPATIBILITY IDEOGRAPH-2F9BF': 195007,
'CJK COMPATIBILITY IDEOGRAPH-2F9C0': 195008,
'CJK COMPATIBILITY IDEOGRAPH-2F9C1': 195009,
'CJK COMPATIBILITY IDEOGRAPH-2F9C2': 195010,
'CJK COMPATIBILITY IDEOGRAPH-2F9C3': 195011,
'CJK COMPATIBILITY IDEOGRAPH-2F9C4': 195012,
'CJK COMPATIBILITY IDEOGRAPH-2F9C5': 195013,
'CJK COMPATIBILITY IDEOGRAPH-2F9C6': 195014,
'CJK COMPATIBILITY IDEOGRAPH-2F9C7': 195015,
'CJK COMPATIBILITY IDEOGRAPH-2F9C8': 195016,
'CJK COMPATIBILITY IDEOGRAPH-2F9C9': 195017,
'CJK COMPATIBILITY IDEOGRAPH-2F9CA': 195018,
'CJK COMPATIBILITY IDEOGRAPH-2F9CB': 195019,
'CJK COMPATIBILITY IDEOGRAPH-2F9CC': 195020,
'CJK COMPATIBILITY IDEOGRAPH-2F9CD': 195021,
'CJK COMPATIBILITY IDEOGRAPH-2F9CE': 195022,
'CJK COMPATIBILITY IDEOGRAPH-2F9CF': 195023,
'CJK COMPATIBILITY IDEOGRAPH-2F9D0': 195024,
'CJK COMPATIBILITY IDEOGRAPH-2F9D1': 195025,
'CJK COMPATIBILITY IDEOGRAPH-2F9D2': 195026,
'CJK COMPATIBILITY IDEOGRAPH-2F9D3': 195027,
'CJK COMPATIBILITY IDEOGRAPH-2F9D4': 195028,
'CJK COMPATIBILITY IDEOGRAPH-2F9D5': 195029,
'CJK COMPATIBILITY IDEOGRAPH-2F9D6': 195030,
'CJK COMPATIBILITY IDEOGRAPH-2F9D7': 195031,
'CJK COMPATIBILITY IDEOGRAPH-2F9D8': 195032,
'CJK COMPATIBILITY IDEOGRAPH-2F9D9': 195033,
'CJK COMPATIBILITY IDEOGRAPH-2F9DA': 195034,
'CJK COMPATIBILITY IDEOGRAPH-2F9DB': 195035,
'CJK COMPATIBILITY IDEOGRAPH-2F9DC': 195036,
'CJK COMPATIBILITY IDEOGRAPH-2F9DD': 195037,
'CJK COMPATIBILITY IDEOGRAPH-2F9DE': 195038,
'CJK COMPATIBILITY IDEOGRAPH-2F9DF': 195039,
'CJK COMPATIBILITY IDEOGRAPH-2F9E0': 195040,
'CJK COMPATIBILITY IDEOGRAPH-2F9E1': 195041,
'CJK COMPATIBILITY IDEOGRAPH-2F9E2': 195042,
'CJK COMPATIBILITY IDEOGRAPH-2F9E3': 195043,
'CJK COMPATIBILITY IDEOGRAPH-2F9E4': 195044,
'CJK COMPATIBILITY IDEOGRAPH-2F9E5': 195045,
'CJK COMPATIBILITY IDEOGRAPH-2F9E6': 195046,
'CJK COMPATIBILITY IDEOGRAPH-2F9E7': 195047,
'CJK COMPATIBILITY IDEOGRAPH-2F9E8': 195048,
'CJK COMPATIBILITY IDEOGRAPH-2F9E9': 195049,
'CJK COMPATIBILITY IDEOGRAPH-2F9EA': 195050,
'CJK COMPATIBILITY IDEOGRAPH-2F9EB': 195051,
'CJK COMPATIBILITY IDEOGRAPH-2F9EC': 195052,
'CJK COMPATIBILITY IDEOGRAPH-2F9ED': 195053,
'CJK COMPATIBILITY IDEOGRAPH-2F9EE': 195054,
'CJK COMPATIBILITY IDEOGRAPH-2F9EF': 195055,
'CJK COMPATIBILITY IDEOGRAPH-2F9F0': 195056,
'CJK COMPATIBILITY IDEOGRAPH-2F9F1': 195057,
'CJK COMPATIBILITY IDEOGRAPH-2F9F2': 195058,
'CJK COMPATIBILITY IDEOGRAPH-2F9F3': 195059,
'CJK COMPATIBILITY IDEOGRAPH-2F9F4': 195060,
'CJK COMPATIBILITY IDEOGRAPH-2F9F5': 195061,
'CJK COMPATIBILITY IDEOGRAPH-2F9F6': 195062,
'CJK COMPATIBILITY IDEOGRAPH-2F9F7': 195063,
'CJK COMPATIBILITY IDEOGRAPH-2F9F8': 195064,
'CJK COMPATIBILITY IDEOGRAPH-2F9F9': 195065,
'CJK COMPATIBILITY IDEOGRAPH-2F9FA': 195066,
'CJK COMPATIBILITY IDEOGRAPH-2F9FB': 195067,
'CJK COMPATIBILITY IDEOGRAPH-2F9FC': 195068,
'CJK COMPATIBILITY IDEOGRAPH-2F9FD': 195069,
'CJK COMPATIBILITY IDEOGRAPH-2F9FE': 195070,
'CJK COMPATIBILITY IDEOGRAPH-2F9FF': 195071,
'CJK COMPATIBILITY IDEOGRAPH-2FA00': 195072,
'CJK COMPATIBILITY IDEOGRAPH-2FA01': 195073,
'CJK COMPATIBILITY IDEOGRAPH-2FA02': 195074,
'CJK COMPATIBILITY IDEOGRAPH-2FA03': 195075,
'CJK COMPATIBILITY IDEOGRAPH-2FA04': 195076,
'CJK COMPATIBILITY IDEOGRAPH-2FA05': 195077,
'CJK COMPATIBILITY IDEOGRAPH-2FA06': 195078,
'CJK COMPATIBILITY IDEOGRAPH-2FA07': 195079,
'CJK COMPATIBILITY IDEOGRAPH-2FA08': 195080,
'CJK COMPATIBILITY IDEOGRAPH-2FA09': 195081,
'CJK COMPATIBILITY IDEOGRAPH-2FA0A': 195082,
'CJK COMPATIBILITY IDEOGRAPH-2FA0B': 195083,
'CJK COMPATIBILITY IDEOGRAPH-2FA0C': 195084,
'CJK COMPATIBILITY IDEOGRAPH-2FA0D': 195085,
'CJK COMPATIBILITY IDEOGRAPH-2FA0E': 195086,
'CJK COMPATIBILITY IDEOGRAPH-2FA0F': 195087,
'CJK COMPATIBILITY IDEOGRAPH-2FA10': 195088,
'CJK COMPATIBILITY IDEOGRAPH-2FA11': 195089,
'CJK COMPATIBILITY IDEOGRAPH-2FA12': 195090,
'CJK COMPATIBILITY IDEOGRAPH-2FA13': 195091,
'CJK COMPATIBILITY IDEOGRAPH-2FA14': 195092,
'CJK COMPATIBILITY IDEOGRAPH-2FA15': 195093,
'CJK COMPATIBILITY IDEOGRAPH-2FA16': 195094,
'CJK COMPATIBILITY IDEOGRAPH-2FA17': 195095,
'CJK COMPATIBILITY IDEOGRAPH-2FA18': 195096,
'CJK COMPATIBILITY IDEOGRAPH-2FA19': 195097,
'CJK COMPATIBILITY IDEOGRAPH-2FA1A': 195098,
'CJK COMPATIBILITY IDEOGRAPH-2FA1B': 195099,
'CJK COMPATIBILITY IDEOGRAPH-2FA1C': 195100,
'CJK COMPATIBILITY IDEOGRAPH-2FA1D': 195101,
'CJK COMPATIBILITY IDEOGRAPH-F900': 63744,
'CJK COMPATIBILITY IDEOGRAPH-F901': 63745,
'CJK COMPATIBILITY IDEOGRAPH-F902': 63746,
'CJK COMPATIBILITY IDEOGRAPH-F903': 63747,
'CJK COMPATIBILITY IDEOGRAPH-F904': 63748,
'CJK COMPATIBILITY IDEOGRAPH-F905': 63749,
'CJK COMPATIBILITY IDEOGRAPH-F906': 63750,
'CJK COMPATIBILITY IDEOGRAPH-F907': 63751,
'CJK COMPATIBILITY IDEOGRAPH-F908': 63752,
'CJK COMPATIBILITY IDEOGRAPH-F909': 63753,
'CJK COMPATIBILITY IDEOGRAPH-F90A': 63754,
'CJK COMPATIBILITY IDEOGRAPH-F90B': 63755,
'CJK COMPATIBILITY IDEOGRAPH-F90C': 63756,
'CJK COMPATIBILITY IDEOGRAPH-F90D': 63757,
'CJK COMPATIBILITY IDEOGRAPH-F90E': 63758,
'CJK COMPATIBILITY IDEOGRAPH-F90F': 63759,
'CJK COMPATIBILITY IDEOGRAPH-F910': 63760,
'CJK COMPATIBILITY IDEOGRAPH-F911': 63761,
'CJK COMPATIBILITY IDEOGRAPH-F912': 63762,
'CJK COMPATIBILITY IDEOGRAPH-F913': 63763,
'CJK COMPATIBILITY IDEOGRAPH-F914': 63764,
'CJK COMPATIBILITY IDEOGRAPH-F915': 63765,
'CJK COMPATIBILITY IDEOGRAPH-F916': 63766,
'CJK COMPATIBILITY IDEOGRAPH-F917': 63767,
'CJK COMPATIBILITY IDEOGRAPH-F918': 63768,
'CJK COMPATIBILITY IDEOGRAPH-F919': 63769,
'CJK COMPATIBILITY IDEOGRAPH-F91A': 63770,
'CJK COMPATIBILITY IDEOGRAPH-F91B': 63771,
'CJK COMPATIBILITY IDEOGRAPH-F91C': 63772,
'CJK COMPATIBILITY IDEOGRAPH-F91D': 63773,
'CJK COMPATIBILITY IDEOGRAPH-F91E': 63774,
'CJK COMPATIBILITY IDEOGRAPH-F91F': 63775,
'CJK COMPATIBILITY IDEOGRAPH-F920': 63776,
'CJK COMPATIBILITY IDEOGRAPH-F921': 63777,
'CJK COMPATIBILITY IDEOGRAPH-F922': 63778,
'CJK COMPATIBILITY IDEOGRAPH-F923': 63779,
'CJK COMPATIBILITY IDEOGRAPH-F924': 63780,
'CJK COMPATIBILITY IDEOGRAPH-F925': 63781,
'CJK COMPATIBILITY IDEOGRAPH-F926': 63782,
'CJK COMPATIBILITY IDEOGRAPH-F927': 63783,
'CJK COMPATIBILITY IDEOGRAPH-F928': 63784,
'CJK COMPATIBILITY IDEOGRAPH-F929': 63785,
'CJK COMPATIBILITY IDEOGRAPH-F92A': 63786,
'CJK COMPATIBILITY IDEOGRAPH-F92B': 63787,
'CJK COMPATIBILITY IDEOGRAPH-F92C': 63788,
'CJK COMPATIBILITY IDEOGRAPH-F92D': 63789,
'CJK COMPATIBILITY IDEOGRAPH-F92E': 63790,
'CJK COMPATIBILITY IDEOGRAPH-F92F': 63791,
'CJK COMPATIBILITY IDEOGRAPH-F930': 63792,
'CJK COMPATIBILITY IDEOGRAPH-F931': 63793,
'CJK COMPATIBILITY IDEOGRAPH-F932': 63794,
'CJK COMPATIBILITY IDEOGRAPH-F933': 63795,
'CJK COMPATIBILITY IDEOGRAPH-F934': 63796,
'CJK COMPATIBILITY IDEOGRAPH-F935': 63797,
'CJK COMPATIBILITY IDEOGRAPH-F936': 63798,
'CJK COMPATIBILITY IDEOGRAPH-F937': 63799,
'CJK COMPATIBILITY IDEOGRAPH-F938': 63800,
'CJK COMPATIBILITY IDEOGRAPH-F939': 63801,
'CJK COMPATIBILITY IDEOGRAPH-F93A': 63802,
'CJK COMPATIBILITY IDEOGRAPH-F93B': 63803,
'CJK COMPATIBILITY IDEOGRAPH-F93C': 63804,
'CJK COMPATIBILITY IDEOGRAPH-F93D': 63805,
'CJK COMPATIBILITY IDEOGRAPH-F93E': 63806,
'CJK COMPATIBILITY IDEOGRAPH-F93F': 63807,
'CJK COMPATIBILITY IDEOGRAPH-F940': 63808,
'CJK COMPATIBILITY IDEOGRAPH-F941': 63809,
'CJK COMPATIBILITY IDEOGRAPH-F942': 63810,
'CJK COMPATIBILITY IDEOGRAPH-F943': 63811,
'CJK COMPATIBILITY IDEOGRAPH-F944': 63812,
'CJK COMPATIBILITY IDEOGRAPH-F945': 63813,
'CJK COMPATIBILITY IDEOGRAPH-F946': 63814,
'CJK COMPATIBILITY IDEOGRAPH-F947': 63815,
'CJK COMPATIBILITY IDEOGRAPH-F948': 63816,
'CJK COMPATIBILITY IDEOGRAPH-F949': 63817,
'CJK COMPATIBILITY IDEOGRAPH-F94A': 63818,
'CJK COMPATIBILITY IDEOGRAPH-F94B': 63819,
'CJK COMPATIBILITY IDEOGRAPH-F94C': 63820,
'CJK COMPATIBILITY IDEOGRAPH-F94D': 63821,
'CJK COMPATIBILITY IDEOGRAPH-F94E': 63822,
'CJK COMPATIBILITY IDEOGRAPH-F94F': 63823,
'CJK COMPATIBILITY IDEOGRAPH-F950': 63824,
'CJK COMPATIBILITY IDEOGRAPH-F951': 63825,
'CJK COMPATIBILITY IDEOGRAPH-F952': 63826,
'CJK COMPATIBILITY IDEOGRAPH-F953': 63827,
'CJK COMPATIBILITY IDEOGRAPH-F954': 63828,
'CJK COMPATIBILITY IDEOGRAPH-F955': 63829,
'CJK COMPATIBILITY IDEOGRAPH-F956': 63830,
'CJK COMPATIBILITY IDEOGRAPH-F957': 63831,
'CJK COMPATIBILITY IDEOGRAPH-F958': 63832,
'CJK COMPATIBILITY IDEOGRAPH-F959': 63833,
'CJK COMPATIBILITY IDEOGRAPH-F95A': 63834,
'CJK COMPATIBILITY IDEOGRAPH-F95B': 63835,
'CJK COMPATIBILITY IDEOGRAPH-F95C': 63836,
'CJK COMPATIBILITY IDEOGRAPH-F95D': 63837,
'CJK COMPATIBILITY IDEOGRAPH-F95E': 63838,
'CJK COMPATIBILITY IDEOGRAPH-F95F': 63839,
'CJK COMPATIBILITY IDEOGRAPH-F960': 63840,
'CJK COMPATIBILITY IDEOGRAPH-F961': 63841,
'CJK COMPATIBILITY IDEOGRAPH-F962': 63842,
'CJK COMPATIBILITY IDEOGRAPH-F963': 63843,
'CJK COMPATIBILITY IDEOGRAPH-F964': 63844,
'CJK COMPATIBILITY IDEOGRAPH-F965': 63845,
'CJK COMPATIBILITY IDEOGRAPH-F966': 63846,
'CJK COMPATIBILITY IDEOGRAPH-F967': 63847,
'CJK COMPATIBILITY IDEOGRAPH-F968': 63848,
'CJK COMPATIBILITY IDEOGRAPH-F969': 63849,
'CJK COMPATIBILITY IDEOGRAPH-F96A': 63850,
'CJK COMPATIBILITY IDEOGRAPH-F96B': 63851,
'CJK COMPATIBILITY IDEOGRAPH-F96C': 63852,
'CJK COMPATIBILITY IDEOGRAPH-F96D': 63853,
'CJK COMPATIBILITY IDEOGRAPH-F96E': 63854,
'CJK COMPATIBILITY IDEOGRAPH-F96F': 63855,
'CJK COMPATIBILITY IDEOGRAPH-F970': 63856,
'CJK COMPATIBILITY IDEOGRAPH-F971': 63857,
'CJK COMPATIBILITY IDEOGRAPH-F972': 63858,
'CJK COMPATIBILITY IDEOGRAPH-F973': 63859,
'CJK COMPATIBILITY IDEOGRAPH-F974': 63860,
'CJK COMPATIBILITY IDEOGRAPH-F975': 63861,
'CJK COMPATIBILITY IDEOGRAPH-F976': 63862,
'CJK COMPATIBILITY IDEOGRAPH-F977': 63863,
'CJK COMPATIBILITY IDEOGRAPH-F978': 63864,
'CJK COMPATIBILITY IDEOGRAPH-F979': 63865,
'CJK COMPATIBILITY IDEOGRAPH-F97A': 63866,
'CJK COMPATIBILITY IDEOGRAPH-F97B': 63867,
'CJK COMPATIBILITY IDEOGRAPH-F97C': 63868,
'CJK COMPATIBILITY IDEOGRAPH-F97D': 63869,
'CJK COMPATIBILITY IDEOGRAPH-F97E': 63870,
'CJK COMPATIBILITY IDEOGRAPH-F97F': 63871,
'CJK COMPATIBILITY IDEOGRAPH-F980': 63872,
'CJK COMPATIBILITY IDEOGRAPH-F981': 63873,
'CJK COMPATIBILITY IDEOGRAPH-F982': 63874,
'CJK COMPATIBILITY IDEOGRAPH-F983': 63875,
'CJK COMPATIBILITY IDEOGRAPH-F984': 63876,
'CJK COMPATIBILITY IDEOGRAPH-F985': 63877,
'CJK COMPATIBILITY IDEOGRAPH-F986': 63878,
'CJK COMPATIBILITY IDEOGRAPH-F987': 63879,
'CJK COMPATIBILITY IDEOGRAPH-F988': 63880,
'CJK COMPATIBILITY IDEOGRAPH-F989': 63881,
'CJK COMPATIBILITY IDEOGRAPH-F98A': 63882,
'CJK COMPATIBILITY IDEOGRAPH-F98B': 63883,
'CJK COMPATIBILITY IDEOGRAPH-F98C': 63884,
'CJK COMPATIBILITY IDEOGRAPH-F98D': 63885,
'CJK COMPATIBILITY IDEOGRAPH-F98E': 63886,
'CJK COMPATIBILITY IDEOGRAPH-F98F': 63887,
'CJK COMPATIBILITY IDEOGRAPH-F990': 63888,
'CJK COMPATIBILITY IDEOGRAPH-F991': 63889,
'CJK COMPATIBILITY IDEOGRAPH-F992': 63890,
'CJK COMPATIBILITY IDEOGRAPH-F993': 63891,
'CJK COMPATIBILITY IDEOGRAPH-F994': 63892,
'CJK COMPATIBILITY IDEOGRAPH-F995': 63893,
'CJK COMPATIBILITY IDEOGRAPH-F996': 63894,
'CJK COMPATIBILITY IDEOGRAPH-F997': 63895,
'CJK COMPATIBILITY IDEOGRAPH-F998': 63896,
'CJK COMPATIBILITY IDEOGRAPH-F999': 63897,
'CJK COMPATIBILITY IDEOGRAPH-F99A': 63898,
'CJK COMPATIBILITY IDEOGRAPH-F99B': 63899,
'CJK COMPATIBILITY IDEOGRAPH-F99C': 63900,
'CJK COMPATIBILITY IDEOGRAPH-F99D': 63901,
'CJK COMPATIBILITY IDEOGRAPH-F99E': 63902,
'CJK COMPATIBILITY IDEOGRAPH-F99F': 63903,
'CJK COMPATIBILITY IDEOGRAPH-F9A0': 63904,
'CJK COMPATIBILITY IDEOGRAPH-F9A1': 63905,
'CJK COMPATIBILITY IDEOGRAPH-F9A2': 63906,
'CJK COMPATIBILITY IDEOGRAPH-F9A3': 63907,
'CJK COMPATIBILITY IDEOGRAPH-F9A4': 63908,
'CJK COMPATIBILITY IDEOGRAPH-F9A5': 63909,
'CJK COMPATIBILITY IDEOGRAPH-F9A6': 63910,
'CJK COMPATIBILITY IDEOGRAPH-F9A7': 63911,
'CJK COMPATIBILITY IDEOGRAPH-F9A8': 63912,
'CJK COMPATIBILITY IDEOGRAPH-F9A9': 63913,
'CJK COMPATIBILITY IDEOGRAPH-F9AA': 63914,
'CJK COMPATIBILITY IDEOGRAPH-F9AB': 63915,
'CJK COMPATIBILITY IDEOGRAPH-F9AC': 63916,
'CJK COMPATIBILITY IDEOGRAPH-F9AD': 63917,
'CJK COMPATIBILITY IDEOGRAPH-F9AE': 63918,
'CJK COMPATIBILITY IDEOGRAPH-F9AF': 63919,
'CJK COMPATIBILITY IDEOGRAPH-F9B0': 63920,
'CJK COMPATIBILITY IDEOGRAPH-F9B1': 63921,
'CJK COMPATIBILITY IDEOGRAPH-F9B2': 63922,
'CJK COMPATIBILITY IDEOGRAPH-F9B3': 63923,
'CJK COMPATIBILITY IDEOGRAPH-F9B4': 63924,
'CJK COMPATIBILITY IDEOGRAPH-F9B5': 63925,
'CJK COMPATIBILITY IDEOGRAPH-F9B6': 63926,
'CJK COMPATIBILITY IDEOGRAPH-F9B7': 63927,
'CJK COMPATIBILITY IDEOGRAPH-F9B8': 63928,
'CJK COMPATIBILITY IDEOGRAPH-F9B9': 63929,
'CJK COMPATIBILITY IDEOGRAPH-F9BA': 63930,
'CJK COMPATIBILITY IDEOGRAPH-F9BB': 63931,
'CJK COMPATIBILITY IDEOGRAPH-F9BC': 63932,
'CJK COMPATIBILITY IDEOGRAPH-F9BD': 63933,
'CJK COMPATIBILITY IDEOGRAPH-F9BE': 63934,
'CJK COMPATIBILITY IDEOGRAPH-F9BF': 63935,
'CJK COMPATIBILITY IDEOGRAPH-F9C0': 63936,
'CJK COMPATIBILITY IDEOGRAPH-F9C1': 63937,
'CJK COMPATIBILITY IDEOGRAPH-F9C2': 63938,
'CJK COMPATIBILITY IDEOGRAPH-F9C3': 63939,
'CJK COMPATIBILITY IDEOGRAPH-F9C4': 63940,
'CJK COMPATIBILITY IDEOGRAPH-F9C5': 63941,
'CJK COMPATIBILITY IDEOGRAPH-F9C6': 63942,
'CJK COMPATIBILITY IDEOGRAPH-F9C7': 63943,
'CJK COMPATIBILITY IDEOGRAPH-F9C8': 63944,
'CJK COMPATIBILITY IDEOGRAPH-F9C9': 63945,
'CJK COMPATIBILITY IDEOGRAPH-F9CA': 63946,
'CJK COMPATIBILITY IDEOGRAPH-F9CB': 63947,
'CJK COMPATIBILITY IDEOGRAPH-F9CC': 63948,
'CJK COMPATIBILITY IDEOGRAPH-F9CD': 63949,
'CJK COMPATIBILITY IDEOGRAPH-F9CE': 63950,
'CJK COMPATIBILITY IDEOGRAPH-F9CF': 63951,
'CJK COMPATIBILITY IDEOGRAPH-F9D0': 63952,
'CJK COMPATIBILITY IDEOGRAPH-F9D1': 63953,
'CJK COMPATIBILITY IDEOGRAPH-F9D2': 63954,
'CJK COMPATIBILITY IDEOGRAPH-F9D3': 63955,
'CJK COMPATIBILITY IDEOGRAPH-F9D4': 63956,
'CJK COMPATIBILITY IDEOGRAPH-F9D5': 63957,
'CJK COMPATIBILITY IDEOGRAPH-F9D6': 63958,
'CJK COMPATIBILITY IDEOGRAPH-F9D7': 63959,
'CJK COMPATIBILITY IDEOGRAPH-F9D8': 63960,
'CJK COMPATIBILITY IDEOGRAPH-F9D9': 63961,
'CJK COMPATIBILITY IDEOGRAPH-F9DA': 63962,
'CJK COMPATIBILITY IDEOGRAPH-F9DB': 63963,
'CJK COMPATIBILITY IDEOGRAPH-F9DC': 63964,
'CJK COMPATIBILITY IDEOGRAPH-F9DD': 63965,
'CJK COMPATIBILITY IDEOGRAPH-F9DE': 63966,
'CJK COMPATIBILITY IDEOGRAPH-F9DF': 63967,
'CJK COMPATIBILITY IDEOGRAPH-F9E0': 63968,
'CJK COMPATIBILITY IDEOGRAPH-F9E1': 63969,
'CJK COMPATIBILITY IDEOGRAPH-F9E2': 63970,
'CJK COMPATIBILITY IDEOGRAPH-F9E3': 63971,
'CJK COMPATIBILITY IDEOGRAPH-F9E4': 63972,
'CJK COMPATIBILITY IDEOGRAPH-F9E5': 63973,
'CJK COMPATIBILITY IDEOGRAPH-F9E6': 63974,
'CJK COMPATIBILITY IDEOGRAPH-F9E7': 63975,
'CJK COMPATIBILITY IDEOGRAPH-F9E8': 63976,
'CJK COMPATIBILITY IDEOGRAPH-F9E9': 63977,
'CJK COMPATIBILITY IDEOGRAPH-F9EA': 63978,
'CJK COMPATIBILITY IDEOGRAPH-F9EB': 63979,
'CJK COMPATIBILITY IDEOGRAPH-F9EC': 63980,
'CJK COMPATIBILITY IDEOGRAPH-F9ED': 63981,
'CJK COMPATIBILITY IDEOGRAPH-F9EE': 63982,
'CJK COMPATIBILITY IDEOGRAPH-F9EF': 63983,
'CJK COMPATIBILITY IDEOGRAPH-F9F0': 63984,
'CJK COMPATIBILITY IDEOGRAPH-F9F1': 63985,
'CJK COMPATIBILITY IDEOGRAPH-F9F2': 63986,
'CJK COMPATIBILITY IDEOGRAPH-F9F3': 63987,
'CJK COMPATIBILITY IDEOGRAPH-F9F4': 63988,
'CJK COMPATIBILITY IDEOGRAPH-F9F5': 63989,
'CJK COMPATIBILITY IDEOGRAPH-F9F6': 63990,
'CJK COMPATIBILITY IDEOGRAPH-F9F7': 63991,
'CJK COMPATIBILITY IDEOGRAPH-F9F8': 63992,
'CJK COMPATIBILITY IDEOGRAPH-F9F9': 63993,
'CJK COMPATIBILITY IDEOGRAPH-F9FA': 63994,
'CJK COMPATIBILITY IDEOGRAPH-F9FB': 63995,
'CJK COMPATIBILITY IDEOGRAPH-F9FC': 63996,
'CJK COMPATIBILITY IDEOGRAPH-F9FD': 63997,
'CJK COMPATIBILITY IDEOGRAPH-F9FE': 63998,
'CJK COMPATIBILITY IDEOGRAPH-F9FF': 63999,
'CJK COMPATIBILITY IDEOGRAPH-FA00': 64000,
'CJK COMPATIBILITY IDEOGRAPH-FA01': 64001,
'CJK COMPATIBILITY IDEOGRAPH-FA02': 64002,
'CJK COMPATIBILITY IDEOGRAPH-FA03': 64003,
'CJK COMPATIBILITY IDEOGRAPH-FA04': 64004,
'CJK COMPATIBILITY IDEOGRAPH-FA05': 64005,
'CJK COMPATIBILITY IDEOGRAPH-FA06': 64006,
'CJK COMPATIBILITY IDEOGRAPH-FA07': 64007,
'CJK COMPATIBILITY IDEOGRAPH-FA08': 64008,
'CJK COMPATIBILITY IDEOGRAPH-FA09': 64009,
'CJK COMPATIBILITY IDEOGRAPH-FA0A': 64010,
'CJK COMPATIBILITY IDEOGRAPH-FA0B': 64011,
'CJK COMPATIBILITY IDEOGRAPH-FA0C': 64012,
'CJK COMPATIBILITY IDEOGRAPH-FA0D': 64013,
'CJK COMPATIBILITY IDEOGRAPH-FA0E': 64014,
'CJK COMPATIBILITY IDEOGRAPH-FA0F': 64015,
'CJK COMPATIBILITY IDEOGRAPH-FA10': 64016,
'CJK COMPATIBILITY IDEOGRAPH-FA11': 64017,
'CJK COMPATIBILITY IDEOGRAPH-FA12': 64018,
'CJK COMPATIBILITY IDEOGRAPH-FA13': 64019,
'CJK COMPATIBILITY IDEOGRAPH-FA14': 64020,
'CJK COMPATIBILITY IDEOGRAPH-FA15': 64021,
'CJK COMPATIBILITY IDEOGRAPH-FA16': 64022,
'CJK COMPATIBILITY IDEOGRAPH-FA17': 64023,
'CJK COMPATIBILITY IDEOGRAPH-FA18': 64024,
'CJK COMPATIBILITY IDEOGRAPH-FA19': 64025,
'CJK COMPATIBILITY IDEOGRAPH-FA1A': 64026,
'CJK COMPATIBILITY IDEOGRAPH-FA1B': 64027,
'CJK COMPATIBILITY IDEOGRAPH-FA1C': 64028,
'CJK COMPATIBILITY IDEOGRAPH-FA1D': 64029,
'CJK COMPATIBILITY IDEOGRAPH-FA1E': 64030,
'CJK COMPATIBILITY IDEOGRAPH-FA1F': 64031,
'CJK COMPATIBILITY IDEOGRAPH-FA20': 64032,
'CJK COMPATIBILITY IDEOGRAPH-FA21': 64033,
'CJK COMPATIBILITY IDEOGRAPH-FA22': 64034,
'CJK COMPATIBILITY IDEOGRAPH-FA23': 64035,
'CJK COMPATIBILITY IDEOGRAPH-FA24': 64036,
'CJK COMPATIBILITY IDEOGRAPH-FA25': 64037,
'CJK COMPATIBILITY IDEOGRAPH-FA26': 64038,
'CJK COMPATIBILITY IDEOGRAPH-FA27': 64039,
'CJK COMPATIBILITY IDEOGRAPH-FA28': 64040,
'CJK COMPATIBILITY IDEOGRAPH-FA29': 64041,
'CJK COMPATIBILITY IDEOGRAPH-FA2A': 64042,
'CJK COMPATIBILITY IDEOGRAPH-FA2B': 64043,
'CJK COMPATIBILITY IDEOGRAPH-FA2C': 64044,
'CJK COMPATIBILITY IDEOGRAPH-FA2D': 64045,
'CJK COMPATIBILITY IDEOGRAPH-FA30': 64048,
'CJK COMPATIBILITY IDEOGRAPH-FA31': 64049,
'CJK COMPATIBILITY IDEOGRAPH-FA32': 64050,
'CJK COMPATIBILITY IDEOGRAPH-FA33': 64051,
'CJK COMPATIBILITY IDEOGRAPH-FA34': 64052,
'CJK COMPATIBILITY IDEOGRAPH-FA35': 64053,
'CJK COMPATIBILITY IDEOGRAPH-FA36': 64054,
'CJK COMPATIBILITY IDEOGRAPH-FA37': 64055,
'CJK COMPATIBILITY IDEOGRAPH-FA38': 64056,
'CJK COMPATIBILITY IDEOGRAPH-FA39': 64057,
'CJK COMPATIBILITY IDEOGRAPH-FA3A': 64058,
'CJK COMPATIBILITY IDEOGRAPH-FA3B': 64059,
'CJK COMPATIBILITY IDEOGRAPH-FA3C': 64060,
'CJK COMPATIBILITY IDEOGRAPH-FA3D': 64061,
'CJK COMPATIBILITY IDEOGRAPH-FA3E': 64062,
'CJK COMPATIBILITY IDEOGRAPH-FA3F': 64063,
'CJK COMPATIBILITY IDEOGRAPH-FA40': 64064,
'CJK COMPATIBILITY IDEOGRAPH-FA41': 64065,
'CJK COMPATIBILITY IDEOGRAPH-FA42': 64066,
'CJK COMPATIBILITY IDEOGRAPH-FA43': 64067,
'CJK COMPATIBILITY IDEOGRAPH-FA44': 64068,
'CJK COMPATIBILITY IDEOGRAPH-FA45': 64069,
'CJK COMPATIBILITY IDEOGRAPH-FA46': 64070,
'CJK COMPATIBILITY IDEOGRAPH-FA47': 64071,
'CJK COMPATIBILITY IDEOGRAPH-FA48': 64072,
'CJK COMPATIBILITY IDEOGRAPH-FA49': 64073,
'CJK COMPATIBILITY IDEOGRAPH-FA4A': 64074,
'CJK COMPATIBILITY IDEOGRAPH-FA4B': 64075,
'CJK COMPATIBILITY IDEOGRAPH-FA4C': 64076,
'CJK COMPATIBILITY IDEOGRAPH-FA4D': 64077,
'CJK COMPATIBILITY IDEOGRAPH-FA4E': 64078,
'CJK COMPATIBILITY IDEOGRAPH-FA4F': 64079,
'CJK COMPATIBILITY IDEOGRAPH-FA50': 64080,
'CJK COMPATIBILITY IDEOGRAPH-FA51': 64081,
'CJK COMPATIBILITY IDEOGRAPH-FA52': 64082,
'CJK COMPATIBILITY IDEOGRAPH-FA53': 64083,
'CJK COMPATIBILITY IDEOGRAPH-FA54': 64084,
'CJK COMPATIBILITY IDEOGRAPH-FA55': 64085,
'CJK COMPATIBILITY IDEOGRAPH-FA56': 64086,
'CJK COMPATIBILITY IDEOGRAPH-FA57': 64087,
'CJK COMPATIBILITY IDEOGRAPH-FA58': 64088,
'CJK COMPATIBILITY IDEOGRAPH-FA59': 64089,
'CJK COMPATIBILITY IDEOGRAPH-FA5A': 64090,
'CJK COMPATIBILITY IDEOGRAPH-FA5B': 64091,
'CJK COMPATIBILITY IDEOGRAPH-FA5C': 64092,
'CJK COMPATIBILITY IDEOGRAPH-FA5D': 64093,
'CJK COMPATIBILITY IDEOGRAPH-FA5E': 64094,
'CJK COMPATIBILITY IDEOGRAPH-FA5F': 64095,
'CJK COMPATIBILITY IDEOGRAPH-FA60': 64096,
'CJK COMPATIBILITY IDEOGRAPH-FA61': 64097,
'CJK COMPATIBILITY IDEOGRAPH-FA62': 64098,
'CJK COMPATIBILITY IDEOGRAPH-FA63': 64099,
'CJK COMPATIBILITY IDEOGRAPH-FA64': 64100,
'CJK COMPATIBILITY IDEOGRAPH-FA65': 64101,
'CJK COMPATIBILITY IDEOGRAPH-FA66': 64102,
'CJK COMPATIBILITY IDEOGRAPH-FA67': 64103,
'CJK COMPATIBILITY IDEOGRAPH-FA68': 64104,
'CJK COMPATIBILITY IDEOGRAPH-FA69': 64105,
'CJK COMPATIBILITY IDEOGRAPH-FA6A': 64106,
'CJK COMPATIBILITY IDEOGRAPH-FA6B': 64107,
'CJK COMPATIBILITY IDEOGRAPH-FA6C': 64108,
'CJK COMPATIBILITY IDEOGRAPH-FA6D': 64109,
'CJK COMPATIBILITY IDEOGRAPH-FA70': 64112,
'CJK COMPATIBILITY IDEOGRAPH-FA71': 64113,
'CJK COMPATIBILITY IDEOGRAPH-FA72': 64114,
'CJK COMPATIBILITY IDEOGRAPH-FA73': 64115,
'CJK COMPATIBILITY IDEOGRAPH-FA74': 64116,
'CJK COMPATIBILITY IDEOGRAPH-FA75': 64117,
'CJK COMPATIBILITY IDEOGRAPH-FA76': 64118,
'CJK COMPATIBILITY IDEOGRAPH-FA77': 64119,
'CJK COMPATIBILITY IDEOGRAPH-FA78': 64120,
'CJK COMPATIBILITY IDEOGRAPH-FA79': 64121,
'CJK COMPATIBILITY IDEOGRAPH-FA7A': 64122,
'CJK COMPATIBILITY IDEOGRAPH-FA7B': 64123,
'CJK COMPATIBILITY IDEOGRAPH-FA7C': 64124,
'CJK COMPATIBILITY IDEOGRAPH-FA7D': 64125,
'CJK COMPATIBILITY IDEOGRAPH-FA7E': 64126,
'CJK COMPATIBILITY IDEOGRAPH-FA7F': 64127,
'CJK COMPATIBILITY IDEOGRAPH-FA80': 64128,
'CJK COMPATIBILITY IDEOGRAPH-FA81': 64129,
'CJK COMPATIBILITY IDEOGRAPH-FA82': 64130,
'CJK COMPATIBILITY IDEOGRAPH-FA83': 64131,
'CJK COMPATIBILITY IDEOGRAPH-FA84': 64132,
'CJK COMPATIBILITY IDEOGRAPH-FA85': 64133,
'CJK COMPATIBILITY IDEOGRAPH-FA86': 64134,
'CJK COMPATIBILITY IDEOGRAPH-FA87': 64135,
'CJK COMPATIBILITY IDEOGRAPH-FA88': 64136,
'CJK COMPATIBILITY IDEOGRAPH-FA89': 64137,
'CJK COMPATIBILITY IDEOGRAPH-FA8A': 64138,
'CJK COMPATIBILITY IDEOGRAPH-FA8B': 64139,
'CJK COMPATIBILITY IDEOGRAPH-FA8C': 64140,
'CJK COMPATIBILITY IDEOGRAPH-FA8D': 64141,
'CJK COMPATIBILITY IDEOGRAPH-FA8E': 64142,
'CJK COMPATIBILITY IDEOGRAPH-FA8F': 64143,
'CJK COMPATIBILITY IDEOGRAPH-FA90': 64144,
'CJK COMPATIBILITY IDEOGRAPH-FA91': 64145,
'CJK COMPATIBILITY IDEOGRAPH-FA92': 64146,
'CJK COMPATIBILITY IDEOGRAPH-FA93': 64147,
'CJK COMPATIBILITY IDEOGRAPH-FA94': 64148,
'CJK COMPATIBILITY IDEOGRAPH-FA95': 64149,
'CJK COMPATIBILITY IDEOGRAPH-FA96': 64150,
'CJK COMPATIBILITY IDEOGRAPH-FA97': 64151,
'CJK COMPATIBILITY IDEOGRAPH-FA98': 64152,
'CJK COMPATIBILITY IDEOGRAPH-FA99': 64153,
'CJK COMPATIBILITY IDEOGRAPH-FA9A': 64154,
'CJK COMPATIBILITY IDEOGRAPH-FA9B': 64155,
'CJK COMPATIBILITY IDEOGRAPH-FA9C': 64156,
'CJK COMPATIBILITY IDEOGRAPH-FA9D': 64157,
'CJK COMPATIBILITY IDEOGRAPH-FA9E': 64158,
'CJK COMPATIBILITY IDEOGRAPH-FA9F': 64159,
'CJK COMPATIBILITY IDEOGRAPH-FAA0': 64160,
'CJK COMPATIBILITY IDEOGRAPH-FAA1': 64161,
'CJK COMPATIBILITY IDEOGRAPH-FAA2': 64162,
'CJK COMPATIBILITY IDEOGRAPH-FAA3': 64163,
'CJK COMPATIBILITY IDEOGRAPH-FAA4': 64164,
'CJK COMPATIBILITY IDEOGRAPH-FAA5': 64165,
'CJK COMPATIBILITY IDEOGRAPH-FAA6': 64166,
'CJK COMPATIBILITY IDEOGRAPH-FAA7': 64167,
'CJK COMPATIBILITY IDEOGRAPH-FAA8': 64168,
'CJK COMPATIBILITY IDEOGRAPH-FAA9': 64169,
'CJK COMPATIBILITY IDEOGRAPH-FAAA': 64170,
'CJK COMPATIBILITY IDEOGRAPH-FAAB': 64171,
'CJK COMPATIBILITY IDEOGRAPH-FAAC': 64172,
'CJK COMPATIBILITY IDEOGRAPH-FAAD': 64173,
'CJK COMPATIBILITY IDEOGRAPH-FAAE': 64174,
'CJK COMPATIBILITY IDEOGRAPH-FAAF': 64175,
'CJK COMPATIBILITY IDEOGRAPH-FAB0': 64176,
'CJK COMPATIBILITY IDEOGRAPH-FAB1': 64177,
'CJK COMPATIBILITY IDEOGRAPH-FAB2': 64178,
'CJK COMPATIBILITY IDEOGRAPH-FAB3': 64179,
'CJK COMPATIBILITY IDEOGRAPH-FAB4': 64180,
'CJK COMPATIBILITY IDEOGRAPH-FAB5': 64181,
'CJK COMPATIBILITY IDEOGRAPH-FAB6': 64182,
'CJK COMPATIBILITY IDEOGRAPH-FAB7': 64183,
'CJK COMPATIBILITY IDEOGRAPH-FAB8': 64184,
'CJK COMPATIBILITY IDEOGRAPH-FAB9': 64185,
'CJK COMPATIBILITY IDEOGRAPH-FABA': 64186,
'CJK COMPATIBILITY IDEOGRAPH-FABB': 64187,
'CJK COMPATIBILITY IDEOGRAPH-FABC': 64188,
'CJK COMPATIBILITY IDEOGRAPH-FABD': 64189,
'CJK COMPATIBILITY IDEOGRAPH-FABE': 64190,
'CJK COMPATIBILITY IDEOGRAPH-FABF': 64191,
'CJK COMPATIBILITY IDEOGRAPH-FAC0': 64192,
'CJK COMPATIBILITY IDEOGRAPH-FAC1': 64193,
'CJK COMPATIBILITY IDEOGRAPH-FAC2': 64194,
'CJK COMPATIBILITY IDEOGRAPH-FAC3': 64195,
'CJK COMPATIBILITY IDEOGRAPH-FAC4': 64196,
'CJK COMPATIBILITY IDEOGRAPH-FAC5': 64197,
'CJK COMPATIBILITY IDEOGRAPH-FAC6': 64198,
'CJK COMPATIBILITY IDEOGRAPH-FAC7': 64199,
'CJK COMPATIBILITY IDEOGRAPH-FAC8': 64200,
'CJK COMPATIBILITY IDEOGRAPH-FAC9': 64201,
'CJK COMPATIBILITY IDEOGRAPH-FACA': 64202,
'CJK COMPATIBILITY IDEOGRAPH-FACB': 64203,
'CJK COMPATIBILITY IDEOGRAPH-FACC': 64204,
'CJK COMPATIBILITY IDEOGRAPH-FACD': 64205,
'CJK COMPATIBILITY IDEOGRAPH-FACE': 64206,
'CJK COMPATIBILITY IDEOGRAPH-FACF': 64207,
'CJK COMPATIBILITY IDEOGRAPH-FAD0': 64208,
'CJK COMPATIBILITY IDEOGRAPH-FAD1': 64209,
'CJK COMPATIBILITY IDEOGRAPH-FAD2': 64210,
'CJK COMPATIBILITY IDEOGRAPH-FAD3': 64211,
'CJK COMPATIBILITY IDEOGRAPH-FAD4': 64212,
'CJK COMPATIBILITY IDEOGRAPH-FAD5': 64213,
'CJK COMPATIBILITY IDEOGRAPH-FAD6': 64214,
'CJK COMPATIBILITY IDEOGRAPH-FAD7': 64215,
'CJK COMPATIBILITY IDEOGRAPH-FAD8': 64216,
'CJK COMPATIBILITY IDEOGRAPH-FAD9': 64217,
'CJK RADICAL BAMBOO': 11950,
'CJK RADICAL BLUE': 11992,
'CJK RADICAL BOLT OF CLOTH': 11946,
'CJK RADICAL BONE': 12003,
'CJK RADICAL BOX': 11910,
'CJK RADICAL BRUSH ONE': 11962,
'CJK RADICAL BRUSH TWO': 11963,
'CJK RADICAL C-SIMPLIFIED BIRD': 12006,
'CJK RADICAL C-SIMPLIFIED CART': 11979,
'CJK RADICAL C-SIMPLIFIED DRAGON': 12016,
'CJK RADICAL C-SIMPLIFIED EAT': 12000,
'CJK RADICAL C-SIMPLIFIED EVEN': 12012,
'CJK RADICAL C-SIMPLIFIED FISH': 12005,
'CJK RADICAL C-SIMPLIFIED FLY': 11996,
'CJK RADICAL C-SIMPLIFIED FROG': 12010,
'CJK RADICAL C-SIMPLIFIED GATE': 11988,
'CJK RADICAL C-SIMPLIFIED GOLD': 11984,
'CJK RADICAL C-SIMPLIFIED HORSE': 12002,
'CJK RADICAL C-SIMPLIFIED LEAF': 11994,
'CJK RADICAL C-SIMPLIFIED LONG': 11987,
'CJK RADICAL C-SIMPLIFIED SALT': 12007,
'CJK RADICAL C-SIMPLIFIED SEE': 11973,
'CJK RADICAL C-SIMPLIFIED SHELL': 11977,
'CJK RADICAL C-SIMPLIFIED SILK': 11952,
'CJK RADICAL C-SIMPLIFIED SPEECH': 11976,
'CJK RADICAL C-SIMPLIFIED TANNED LEATHER': 11993,
'CJK RADICAL C-SIMPLIFIED TOOTH': 12014,
'CJK RADICAL C-SIMPLIFIED TURTLE': 12019,
'CJK RADICAL C-SIMPLIFIED WIND': 11995,
'CJK RADICAL CHOKE': 11931,
'CJK RADICAL CITY': 11983,
'CJK RADICAL CIVILIAN': 11936,
'CJK RADICAL CLIFF': 11905,
'CJK RADICAL CLOTHES': 11970,
'CJK RADICAL COW': 11943,
'CJK RADICAL DEATH': 11934,
'CJK RADICAL DIVINATION': 11914,
'CJK RADICAL DOG': 11944,
'CJK RADICAL EAT ONE': 11997,
'CJK RADICAL EAT THREE': 11999,
'CJK RADICAL EAT TWO': 11998,
'CJK RADICAL EWE': 11960,
'CJK RADICAL EYE': 11947,
'CJK RADICAL FIRE': 11939,
'CJK RADICAL FOOT': 11978,
'CJK RADICAL GHOST': 12004,
'CJK RADICAL GRASS ONE': 11966,
'CJK RADICAL GRASS THREE': 11968,
'CJK RADICAL GRASS TWO': 11967,
'CJK RADICAL HAND': 11928,
'CJK RADICAL HEAD': 12001,
'CJK RADICAL HEART ONE': 11926,
'CJK RADICAL HEART TWO': 11927,
'CJK RADICAL HORN': 11975,
'CJK RADICAL J-SIMPLIFIED DRAGON': 12015,
'CJK RADICAL J-SIMPLIFIED EVEN': 12011,
'CJK RADICAL J-SIMPLIFIED TOOTH': 12013,
'CJK RADICAL J-SIMPLIFIED TURTLE': 12018,
'CJK RADICAL JADE': 11945,
'CJK RADICAL KNIFE ONE': 11912,
'CJK RADICAL KNIFE TWO': 11913,
'CJK RADICAL LAME FOUR': 11921,
'CJK RADICAL LAME ONE': 11918,
'CJK RADICAL LAME THREE': 11920,
'CJK RADICAL LAME TWO': 11919,
'CJK RADICAL LONG ONE': 11985,
'CJK RADICAL LONG TWO': 11986,
'CJK RADICAL MEAT': 11964,
'CJK RADICAL MESH': 11957,
'CJK RADICAL MOON': 11933,
'CJK RADICAL MORTAR': 11965,
'CJK RADICAL MOTHER': 11935,
'CJK RADICAL MOUND ONE': 11989,
'CJK RADICAL MOUND TWO': 11990,
'CJK RADICAL NET FOUR': 11956,
'CJK RADICAL NET ONE': 11953,
'CJK RADICAL NET THREE': 11955,
'CJK RADICAL NET TWO': 11954,
'CJK RADICAL OLD': 11961,
'CJK RADICAL PAW ONE': 11940,
'CJK RADICAL PAW TWO': 11941,
'CJK RADICAL PERSON': 11909,
'CJK RADICAL RAIN': 11991,
'CJK RADICAL RAM': 11959,
'CJK RADICAL RAP': 11929,
'CJK RADICAL REPEAT': 11904,
'CJK RADICAL SEAL': 11915,
'CJK RADICAL SECOND ONE': 11906,
'CJK RADICAL SECOND THREE': 11908,
'CJK RADICAL SECOND TWO': 11907,
'CJK RADICAL SHEEP': 11958,
'CJK RADICAL SILK': 11951,
'CJK RADICAL SIMPLIFIED HALF TREE TRUNK': 11942,
'CJK RADICAL SIMPLIFIED HORN': 11974,
'CJK RADICAL SIMPLIFIED WALK': 11980,
'CJK RADICAL SIMPLIFIED WHEAT': 12008,
'CJK RADICAL SIMPLIFIED YELLOW': 12009,
'CJK RADICAL SMALL ONE': 11916,
'CJK RADICAL SMALL TWO': 11917,
'CJK RADICAL SNAKE': 11922,
'CJK RADICAL SNOUT ONE': 11924,
'CJK RADICAL SNOUT TWO': 11925,
'CJK RADICAL SPIRIT ONE': 11948,
'CJK RADICAL SPIRIT TWO': 11949,
'CJK RADICAL SUN': 11932,
'CJK RADICAL TABLE': 11911,
'CJK RADICAL THREAD': 11923,
'CJK RADICAL TIGER': 11969,
'CJK RADICAL TURTLE': 12017,
'CJK RADICAL WALK ONE': 11981,
'CJK RADICAL WALK TWO': 11982,
'CJK RADICAL WATER ONE': 11937,
'CJK RADICAL WATER TWO': 11938,
'CJK RADICAL WEST ONE': 11971,
'CJK RADICAL WEST TWO': 11972,
'CJK STROKE BXG': 12739,
'CJK STROKE D': 12756,
'CJK STROKE H': 12752,
'CJK STROKE HG': 12758,
'CJK STROKE HP': 12743,
'CJK STROKE HPWG': 12748,
'CJK STROKE HXWG': 12768,
'CJK STROKE HZ': 12757,
'CJK STROKE HZG': 12742,
'CJK STROKE HZT': 12746,
'CJK STROKE HZW': 12749,
'CJK STROKE HZWG': 12744,
'CJK STROKE HZZ': 12741,
'CJK STROKE HZZP': 12747,
'CJK STROKE HZZZ': 12750,
'CJK STROKE HZZZG': 12769,
'CJK STROKE N': 12751,
'CJK STROKE P': 12754,
'CJK STROKE PD': 12763,
'CJK STROKE PG': 12770,
'CJK STROKE PZ': 12764,
'CJK STROKE Q': 12771,
'CJK STROKE S': 12753,
'CJK STROKE SG': 12762,
'CJK STROKE SP': 12755,
'CJK STROKE ST': 12761,
'CJK STROKE SW': 12740,
'CJK STROKE SWG': 12767,
'CJK STROKE SWZ': 12760,
'CJK STROKE SZ': 12759,
'CJK STROKE SZWG': 12745,
'CJK STROKE SZZ': 12766,
'CJK STROKE T': 12736,
'CJK STROKE TN': 12765,
'CJK STROKE WG': 12737,
'CJK STROKE XG': 12738,
'CLEAR SCREEN SYMBOL': 9114,
'CLOCKWISE CLOSED CIRCLE ARROW': 10561,
'CLOCKWISE CONTOUR INTEGRAL': 8754,
'CLOCKWISE GAPPED CIRCLE ARROW': 10227,
'CLOCKWISE INTEGRAL': 8753,
'CLOCKWISE OPEN CIRCLE ARROW': 8635,
'CLOCKWISE TOP SEMICIRCLE ARROW': 8631,
'CLOSE UP': 8272,
'CLOSED INTERSECTION WITH SERIFS': 10829,
'CLOSED SUBSET': 10959,
'CLOSED SUBSET OR EQUAL TO': 10961,
'CLOSED SUPERSET': 10960,
'CLOSED SUPERSET OR EQUAL TO': 10962,
'CLOSED UNION WITH SERIFS': 10828,
'CLOSED UNION WITH SERIFS AND SMASH PRODUCT': 10832,
'CLOUD': 9729,
'COFFIN': 9904,
'COLON': 58,
'COLON EQUALS': 8788,
'COLON SIGN': 8353,
'COMBINING ACUTE ACCENT': 769,
'COMBINING ACUTE ACCENT BELOW': 791,
'COMBINING ACUTE TONE MARK': 833,
'COMBINING ACUTE-GRAVE-ACUTE': 7625,
'COMBINING ACUTE-MACRON': 7623,
'COMBINING ALMOST EQUAL TO ABOVE': 844,
'COMBINING ALMOST EQUAL TO BELOW': 7677,
'COMBINING ANNUITY SYMBOL': 8423,
'COMBINING ANTICLOCKWISE ARROW ABOVE': 8404,
'COMBINING ANTICLOCKWISE RING OVERLAY': 8410,
'COMBINING ASTERISK ABOVE': 8432,
'COMBINING ASTERISK BELOW': 857,
'COMBINING BREVE': 774,
'COMBINING BREVE BELOW': 814,
'COMBINING BREVE-MACRON': 7627,
'COMBINING BRIDGE ABOVE': 838,
'COMBINING BRIDGE BELOW': 810,
'COMBINING CANDRABINDU': 784,
'COMBINING CARON': 780,
'COMBINING CARON BELOW': 812,
'COMBINING CEDILLA': 807,
'COMBINING CIRCUMFLEX ACCENT': 770,
'COMBINING CIRCUMFLEX ACCENT BELOW': 813,
'COMBINING CLOCKWISE ARROW ABOVE': 8405,
'COMBINING CLOCKWISE RING OVERLAY': 8409,
'COMBINING COMMA ABOVE': 787,
'COMBINING COMMA ABOVE RIGHT': 789,
'COMBINING COMMA BELOW': 806,
'COMBINING CONJOINING MACRON': 65062,
'COMBINING CYRILLIC DASIA PNEUMATA': 1157,
'COMBINING CYRILLIC HUNDRED MILLIONS SIGN': 42609,
'COMBINING CYRILLIC HUNDRED THOUSANDS SIGN': 1160,
'COMBINING CYRILLIC KAVYKA': 42620,
'COMBINING CYRILLIC LETTER A': 11766,
'COMBINING CYRILLIC LETTER BE': 11744,
'COMBINING CYRILLIC LETTER BIG YUS': 11774,
'COMBINING CYRILLIC LETTER CHE': 11761,
'COMBINING CYRILLIC LETTER DE': 11747,
'COMBINING CYRILLIC LETTER DJERV': 11768,
'COMBINING CYRILLIC LETTER EL': 11751,
'COMBINING CYRILLIC LETTER EM': 11752,
'COMBINING CYRILLIC LETTER EN': 11753,
'COMBINING CYRILLIC LETTER ER': 11756,
'COMBINING CYRILLIC LETTER ES': 11757,
'COMBINING CYRILLIC LETTER ES-TE': 11765,
'COMBINING CYRILLIC LETTER FITA': 11764,
'COMBINING CYRILLIC LETTER GHE': 11746,
'COMBINING CYRILLIC LETTER HA': 11759,
'COMBINING CYRILLIC LETTER IE': 11767,
'COMBINING CYRILLIC LETTER IOTIFIED A': 11772,
'COMBINING CYRILLIC LETTER IOTIFIED BIG YUS': 11775,
'COMBINING CYRILLIC LETTER KA': 11750,
'COMBINING CYRILLIC LETTER LITTLE YUS': 11773,
'COMBINING CYRILLIC LETTER MONOGRAPH UK': 11769,
'COMBINING CYRILLIC LETTER O': 11754,
'COMBINING CYRILLIC LETTER PE': 11755,
'COMBINING CYRILLIC LETTER SHA': 11762,
'COMBINING CYRILLIC LETTER SHCHA': 11763,
'COMBINING CYRILLIC LETTER TE': 11758,
'COMBINING CYRILLIC LETTER TSE': 11760,
'COMBINING CYRILLIC LETTER VE': 11745,
'COMBINING CYRILLIC LETTER YAT': 11770,
'COMBINING CYRILLIC LETTER YU': 11771,
'COMBINING CYRILLIC LETTER ZE': 11749,
'COMBINING CYRILLIC LETTER ZHE': 11748,
'COMBINING CYRILLIC MILLIONS SIGN': 1161,
'COMBINING CYRILLIC PALATALIZATION': 1156,
'COMBINING CYRILLIC PAYEROK': 42621,
'COMBINING CYRILLIC POKRYTIE': 1159,
'COMBINING CYRILLIC PSILI PNEUMATA': 1158,
'COMBINING CYRILLIC TEN MILLIONS SIGN': 42608,
'COMBINING CYRILLIC THOUSAND MILLIONS SIGN': 42610,
'COMBINING CYRILLIC TITLO': 1155,
'COMBINING CYRILLIC VZMET': 42607,
'COMBINING DEVANAGARI DIGIT EIGHT': 43240,
'COMBINING DEVANAGARI DIGIT FIVE': 43237,
'COMBINING DEVANAGARI DIGIT FOUR': 43236,
'COMBINING DEVANAGARI DIGIT NINE': 43241,
'COMBINING DEVANAGARI DIGIT ONE': 43233,
'COMBINING DEVANAGARI DIGIT SEVEN': 43239,
'COMBINING DEVANAGARI DIGIT SIX': 43238,
'COMBINING DEVANAGARI DIGIT THREE': 43235,
'COMBINING DEVANAGARI DIGIT TWO': 43234,
'COMBINING DEVANAGARI DIGIT ZERO': 43232,
'COMBINING DEVANAGARI LETTER A': 43242,
'COMBINING DEVANAGARI LETTER KA': 43244,
'COMBINING DEVANAGARI LETTER NA': 43245,
'COMBINING DEVANAGARI LETTER PA': 43246,
'COMBINING DEVANAGARI LETTER RA': 43247,
'COMBINING DEVANAGARI LETTER U': 43243,
'COMBINING DEVANAGARI LETTER VI': 43248,
'COMBINING DEVANAGARI SIGN AVAGRAHA': 43249,
'COMBINING DIAERESIS': 776,
'COMBINING DIAERESIS BELOW': 804,
'COMBINING DOT ABOVE': 775,
'COMBINING DOT ABOVE RIGHT': 856,
'COMBINING DOT BELOW': 803,
'COMBINING DOTTED ACUTE ACCENT': 7617,
'COMBINING DOTTED GRAVE ACCENT': 7616,
'COMBINING DOUBLE ACUTE ACCENT': 779,
'COMBINING DOUBLE BREVE': 861,
'COMBINING DOUBLE BREVE BELOW': 860,
'COMBINING DOUBLE CIRCUMFLEX ABOVE': 7629,
'COMBINING DOUBLE GRAVE ACCENT': 783,
'COMBINING DOUBLE INVERTED BREVE': 865,
'COMBINING DOUBLE LOW LINE': 819,
'COMBINING DOUBLE MACRON': 862,
'COMBINING DOUBLE MACRON BELOW': 863,
'COMBINING DOUBLE OVERLINE': 831,
'COMBINING DOUBLE RIGHTWARDS ARROW BELOW': 866,
'COMBINING DOUBLE RING BELOW': 858,
'COMBINING DOUBLE TILDE': 864,
'COMBINING DOUBLE TILDE LEFT HALF': 65058,
'COMBINING DOUBLE TILDE RIGHT HALF': 65059,
'COMBINING DOUBLE VERTICAL LINE ABOVE': 782,
'COMBINING DOUBLE VERTICAL LINE BELOW': 840,
'COMBINING DOUBLE VERTICAL STROKE OVERLAY': 8422,
'COMBINING DOWN TACK BELOW': 798,
'COMBINING ENCLOSING CIRCLE': 8413,
'COMBINING ENCLOSING CIRCLE BACKSLASH': 8416,
'COMBINING ENCLOSING DIAMOND': 8415,
'COMBINING ENCLOSING KEYCAP': 8419,
'COMBINING ENCLOSING SCREEN': 8418,
'COMBINING ENCLOSING SQUARE': 8414,
'COMBINING ENCLOSING UPWARD POINTING TRIANGLE': 8420,
'COMBINING EQUALS SIGN BELOW': 839,
'COMBINING FERMATA': 850,
'COMBINING FOUR DOTS ABOVE': 8412,
'COMBINING GRAPHEME JOINER': 847,
'COMBINING GRAVE ACCENT': 768,
'COMBINING GRAVE ACCENT BELOW': 790,
'COMBINING GRAVE TONE MARK': 832,
'COMBINING GRAVE-ACUTE-GRAVE': 7624,
'COMBINING GRAVE-MACRON': 7621,
'COMBINING GREEK DIALYTIKA TONOS': 836,
'COMBINING GREEK KORONIS': 835,
'COMBINING GREEK MUSICAL PENTASEME': 119364,
'COMBINING GREEK MUSICAL TETRASEME': 119363,
'COMBINING GREEK MUSICAL TRISEME': 119362,
'COMBINING GREEK PERISPOMENI': 834,
'COMBINING GREEK YPOGEGRAMMENI': 837,
'COMBINING HOMOTHETIC ABOVE': 843,
'COMBINING HOOK ABOVE': 777,
'COMBINING HORN': 795,
'COMBINING INVERTED BREVE': 785,
'COMBINING INVERTED BREVE BELOW': 815,
'COMBINING INVERTED BRIDGE BELOW': 826,
'COMBINING INVERTED DOUBLE ARCH BELOW': 811,
'COMBINING IS BELOW': 7632,
'COMBINING KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK': 12442,
'COMBINING KATAKANA-HIRAGANA VOICED SOUND MARK': 12441,
'COMBINING LATIN LETTER SMALL CAPITAL G': 7643,
'COMBINING LATIN LETTER SMALL CAPITAL L': 7646,
'COMBINING LATIN LETTER SMALL CAPITAL M': 7647,
'COMBINING LATIN LETTER SMALL CAPITAL N': 7649,
'COMBINING LATIN LETTER SMALL CAPITAL R': 7650,
'COMBINING LATIN SMALL LETTER A': 867,
'COMBINING LATIN SMALL LETTER AE': 7636,
'COMBINING LATIN SMALL LETTER AO': 7637,
'COMBINING LATIN SMALL LETTER AV': 7638,
'COMBINING LATIN SMALL LETTER C': 872,
'COMBINING LATIN SMALL LETTER C CEDILLA': 7639,
'COMBINING LATIN SMALL LETTER D': 873,
'COMBINING LATIN SMALL LETTER E': 868,
'COMBINING LATIN SMALL LETTER ETH': 7641,
'COMBINING LATIN SMALL LETTER FLATTENED OPEN A ABOVE': 7635,
'COMBINING LATIN SMALL LETTER G': 7642,
'COMBINING LATIN SMALL LETTER H': 874,
'COMBINING LATIN SMALL LETTER I': 869,
'COMBINING LATIN SMALL LETTER INSULAR D': 7640,
'COMBINING LATIN SMALL LETTER K': 7644,
'COMBINING LATIN SMALL LETTER L': 7645,
'COMBINING LATIN SMALL LETTER LONG S': 7653,
'COMBINING LATIN SMALL LETTER M': 875,
'COMBINING LATIN SMALL LETTER N': 7648,
'COMBINING LATIN SMALL LETTER O': 870,
'COMBINING LATIN SMALL LETTER R': 876,
'COMBINING LATIN SMALL LETTER R BELOW': 7626,
'COMBINING LATIN SMALL LETTER R ROTUNDA': 7651,
'COMBINING LATIN SMALL LETTER S': 7652,
'COMBINING LATIN SMALL LETTER T': 877,
'COMBINING LATIN SMALL LETTER U': 871,
'COMBINING LATIN SMALL LETTER V': 878,
'COMBINING LATIN SMALL LETTER X': 879,
'COMBINING LATIN SMALL LETTER Z': 7654,
'COMBINING LEFT ANGLE ABOVE': 794,
'COMBINING LEFT ANGLE BELOW': 841,
'COMBINING LEFT ARROW ABOVE': 8406,
'COMBINING LEFT ARROW BELOW': 8430,
'COMBINING LEFT ARROWHEAD ABOVE': 7678,
'COMBINING LEFT ARROWHEAD BELOW': 852,
'COMBINING LEFT HALF RING ABOVE': 849,
'COMBINING LEFT HALF RING BELOW': 796,
'COMBINING LEFT HARPOON ABOVE': 8400,
'COMBINING LEFT RIGHT ARROW ABOVE': 8417,
'COMBINING LEFT RIGHT ARROW BELOW': 845,
'COMBINING LEFT TACK BELOW': 792,
'COMBINING LEFTWARDS ARROW OVERLAY': 8426,
'COMBINING LEFTWARDS HARPOON WITH BARB DOWNWARDS': 8429,
'COMBINING LIGATURE LEFT HALF': 65056,
'COMBINING LIGATURE RIGHT HALF': 65057,
'COMBINING LONG DOUBLE SOLIDUS OVERLAY': 8427,
'COMBINING LONG SOLIDUS OVERLAY': 824,
'COMBINING LONG STROKE OVERLAY': 822,
'COMBINING LONG VERTICAL LINE OVERLAY': 8402,
'COMBINING LOW LINE': 818,
'COMBINING MACRON': 772,
'COMBINING MACRON BELOW': 817,
'COMBINING MACRON LEFT HALF': 65060,
'COMBINING MACRON RIGHT HALF': 65061,
'COMBINING MACRON-ACUTE': 7620,
'COMBINING MACRON-BREVE': 7628,
'COMBINING MACRON-GRAVE': 7622,
'COMBINING MINUS SIGN BELOW': 800,
'COMBINING NOT TILDE ABOVE': 842,
'COMBINING OGONEK': 808,
'COMBINING OGONEK ABOVE': 7630,
'COMBINING OVERLINE': 773,
'COMBINING PALATALIZED HOOK BELOW': 801,
'COMBINING PLUS SIGN BELOW': 799,
'COMBINING RETROFLEX HOOK BELOW': 802,
'COMBINING REVERSE SOLIDUS OVERLAY': 8421,
'COMBINING REVERSED COMMA ABOVE': 788,
'COMBINING RIGHT ARROW ABOVE': 8407,
'COMBINING RIGHT ARROW BELOW': 8431,
'COMBINING RIGHT ARROWHEAD ABOVE': 848,
'COMBINING RIGHT ARROWHEAD AND DOWN ARROWHEAD BELOW': 7679,
'COMBINING RIGHT ARROWHEAD AND UP ARROWHEAD BELOW': 854,
'COMBINING RIGHT ARROWHEAD BELOW': 853,
'COMBINING RIGHT HALF RING ABOVE': 855,
'COMBINING RIGHT HALF RING BELOW': 825,
'COMBINING RIGHT HARPOON ABOVE': 8401,
'COMBINING RIGHT TACK BELOW': 793,
'COMBINING RIGHTWARDS HARPOON WITH BARB DOWNWARDS': 8428,
'COMBINING RING ABOVE': 778,
'COMBINING RING BELOW': 805,
'COMBINING RING OVERLAY': 8408,
'COMBINING SEAGULL BELOW': 828,
'COMBINING SHORT SOLIDUS OVERLAY': 823,
'COMBINING SHORT STROKE OVERLAY': 821,
'COMBINING SHORT VERTICAL LINE OVERLAY': 8403,
'COMBINING SNAKE BELOW': 7618,
'COMBINING SQUARE BELOW': 827,
'COMBINING SUSPENSION MARK': 7619,
'COMBINING THREE DOTS ABOVE': 8411,
'COMBINING TILDE': 771,
'COMBINING TILDE BELOW': 816,
'COMBINING TILDE OVERLAY': 820,
'COMBINING TRIPLE UNDERDOT': 8424,
'COMBINING TURNED COMMA ABOVE': 786,
'COMBINING UP TACK BELOW': 797,
'COMBINING UPWARDS ARROW BELOW': 846,
'COMBINING UR ABOVE': 7633,
'COMBINING US ABOVE': 7634,
'COMBINING VERTICAL LINE ABOVE': 781,
'COMBINING VERTICAL LINE BELOW': 809,
'COMBINING VERTICAL TILDE': 830,
'COMBINING WIDE BRIDGE ABOVE': 8425,
'COMBINING X ABOVE': 829,
'COMBINING X BELOW': 851,
'COMBINING ZIGZAG ABOVE': 859,
'COMBINING ZIGZAG BELOW': 7631,
'COMET': 9732,
'COMMA': 44,
'COMMERCIAL AT': 64,
'COMMERCIAL MINUS SIGN': 8274,
'COMPLEMENT': 8705,
'COMPOSITION SYMBOL': 9092,
'CONGRUENT WITH DOT ABOVE': 10861,
'CONICAL TAPER': 9010,
'CONJUNCTION': 9740,
'CONTAINS AS MEMBER': 8715,
'CONTAINS AS NORMAL SUBGROUP': 8883,
'CONTAINS AS NORMAL SUBGROUP OR EQUAL TO': 8885,
'CONTAINS WITH LONG HORIZONTAL STROKE': 8954,
'CONTAINS WITH OVERBAR': 8957,
'CONTAINS WITH VERTICAL BAR AT END OF HORIZONTAL STROKE': 8955,
'CONTINUOUS UNDERLINE SYMBOL': 9089,
'CONTOUR INTEGRAL': 8750,
'COPTIC CAPITAL LETTER AKHMIMIC KHEI': 11464,
'COPTIC CAPITAL LETTER ALFA': 11392,
'COPTIC CAPITAL LETTER CROSSED SHEI': 11458,
'COPTIC CAPITAL LETTER CRYPTOGRAMMIC EIE': 11446,
'COPTIC CAPITAL LETTER CRYPTOGRAMMIC GANGIA': 11501,
'COPTIC CAPITAL LETTER CRYPTOGRAMMIC NI': 11452,
'COPTIC CAPITAL LETTER CRYPTOGRAMMIC SHEI': 11499,
'COPTIC CAPITAL LETTER DALDA': 11398,
'COPTIC CAPITAL LETTER DEI': 1006,
'COPTIC CAPITAL LETTER DIALECT-P ALEF': 11442,
'COPTIC CAPITAL LETTER DIALECT-P HORI': 11466,
'COPTIC CAPITAL LETTER DIALECT-P KAPA': 11448,
'COPTIC CAPITAL LETTER DIALECT-P NI': 11450,
'COPTIC CAPITAL LETTER EIE': 11400,
'COPTIC CAPITAL LETTER FEI': 996,
'COPTIC CAPITAL LETTER FI': 11434,
'COPTIC CAPITAL LETTER GAMMA': 11396,
'COPTIC CAPITAL LETTER GANGIA': 1002,
'COPTIC CAPITAL LETTER HATE': 11406,
'COPTIC CAPITAL LETTER HORI': 1000,
'COPTIC CAPITAL LETTER IAUDA': 11410,
'COPTIC CAPITAL LETTER KAPA': 11412,
'COPTIC CAPITAL LETTER KHEI': 998,
'COPTIC CAPITAL LETTER KHI': 11436,
'COPTIC CAPITAL LETTER KSI': 11420,
'COPTIC CAPITAL LETTER L-SHAPED HA': 11472,
'COPTIC CAPITAL LETTER LAULA': 11414,
'COPTIC CAPITAL LETTER MI': 11416,
'COPTIC CAPITAL LETTER NI': 11418,
'COPTIC CAPITAL LETTER O': 11422,
'COPTIC CAPITAL LETTER OLD COPTIC AIN': 11444,
'COPTIC CAPITAL LETTER OLD COPTIC DJA': 11480,
'COPTIC CAPITAL LETTER OLD COPTIC ESH': 11462,
'COPTIC CAPITAL LETTER OLD COPTIC GANGIA': 11478,
'COPTIC CAPITAL LETTER OLD COPTIC HA': 11470,
'COPTIC CAPITAL LETTER OLD COPTIC HAT': 11476,
'COPTIC CAPITAL LETTER OLD COPTIC HEI': 11474,
'COPTIC CAPITAL LETTER OLD COPTIC HORI': 11468,
'COPTIC CAPITAL LETTER OLD COPTIC OOU': 11454,
'COPTIC CAPITAL LETTER OLD COPTIC SHEI': 11460,
'COPTIC CAPITAL LETTER OLD COPTIC SHIMA': 11482,
'COPTIC CAPITAL LETTER OLD NUBIAN NGI': 11486,
'COPTIC CAPITAL LETTER OLD NUBIAN NYI': 11488,
'COPTIC CAPITAL LETTER OLD NUBIAN SHIMA': 11484,
'COPTIC CAPITAL LETTER OLD NUBIAN WAU': 11490,
'COPTIC CAPITAL LETTER OOU': 11440,
'COPTIC CAPITAL LETTER PI': 11424,
'COPTIC CAPITAL LETTER PSI': 11438,
'COPTIC CAPITAL LETTER RO': 11426,
'COPTIC CAPITAL LETTER SAMPI': 11456,
'COPTIC CAPITAL LETTER SHEI': 994,
'COPTIC CAPITAL LETTER SHIMA': 1004,
'COPTIC CAPITAL LETTER SIMA': 11428,
'COPTIC CAPITAL LETTER SOU': 11402,
'COPTIC CAPITAL LETTER TAU': 11430,
'COPTIC CAPITAL LETTER THETHE': 11408,
'COPTIC CAPITAL LETTER UA': 11432,
'COPTIC CAPITAL LETTER VIDA': 11394,
'COPTIC CAPITAL LETTER ZATA': 11404,
'COPTIC COMBINING NI ABOVE': 11503,
'COPTIC COMBINING SPIRITUS ASPER': 11504,
'COPTIC COMBINING SPIRITUS LENIS': 11505,
'COPTIC FRACTION ONE HALF': 11517,
'COPTIC FULL STOP': 11518,
'COPTIC MORPHOLOGICAL DIVIDER': 11519,
'COPTIC OLD NUBIAN DIRECT QUESTION MARK': 11514,
'COPTIC OLD NUBIAN FULL STOP': 11513,
'COPTIC OLD NUBIAN INDIRECT QUESTION MARK': 11515,
'COPTIC OLD NUBIAN VERSE DIVIDER': 11516,
'COPTIC SMALL LETTER AKHMIMIC KHEI': 11465,
'COPTIC SMALL LETTER ALFA': 11393,
'COPTIC SMALL LETTER CROSSED SHEI': 11459,
'COPTIC SMALL LETTER CRYPTOGRAMMIC EIE': 11447,
'COPTIC SMALL LETTER CRYPTOGRAMMIC GANGIA': 11502,
'COPTIC SMALL LETTER CRYPTOGRAMMIC NI': 11453,
'COPTIC SMALL LETTER CRYPTOGRAMMIC SHEI': 11500,
'COPTIC SMALL LETTER DALDA': 11399,
'COPTIC SMALL LETTER DEI': 1007,
'COPTIC SMALL LETTER DIALECT-P ALEF': 11443,
'COPTIC SMALL LETTER DIALECT-P HORI': 11467,
'COPTIC SMALL LETTER DIALECT-P KAPA': 11449,
'COPTIC SMALL LETTER DIALECT-P NI': 11451,
'COPTIC SMALL LETTER EIE': 11401,
'COPTIC SMALL LETTER FEI': 997,
'COPTIC SMALL LETTER FI': 11435,
'COPTIC SMALL LETTER GAMMA': 11397,
'COPTIC SMALL LETTER GANGIA': 1003,
'COPTIC SMALL LETTER HATE': 11407,
'COPTIC SMALL LETTER HORI': 1001,
'COPTIC SMALL LETTER IAUDA': 11411,
'COPTIC SMALL LETTER KAPA': 11413,
'COPTIC SMALL LETTER KHEI': 999,
'COPTIC SMALL LETTER KHI': 11437,
'COPTIC SMALL LETTER KSI': 11421,
'COPTIC SMALL LETTER L-SHAPED HA': 11473,
'COPTIC SMALL LETTER LAULA': 11415,
'COPTIC SMALL LETTER MI': 11417,
'COPTIC SMALL LETTER NI': 11419,
'COPTIC SMALL LETTER O': 11423,
'COPTIC SMALL LETTER OLD COPTIC AIN': 11445,
'COPTIC SMALL LETTER OLD COPTIC DJA': 11481,
'COPTIC SMALL LETTER OLD COPTIC ESH': 11463,
'COPTIC SMALL LETTER OLD COPTIC GANGIA': 11479,
'COPTIC SMALL LETTER OLD COPTIC HA': 11471,
'COPTIC SMALL LETTER OLD COPTIC HAT': 11477,
'COPTIC SMALL LETTER OLD COPTIC HEI': 11475,
'COPTIC SMALL LETTER OLD COPTIC HORI': 11469,
'COPTIC SMALL LETTER OLD COPTIC OOU': 11455,
'COPTIC SMALL LETTER OLD COPTIC SHEI': 11461,
'COPTIC SMALL LETTER OLD COPTIC SHIMA': 11483,
'COPTIC SMALL LETTER OLD NUBIAN NGI': 11487,
'COPTIC SMALL LETTER OLD NUBIAN NYI': 11489,
'COPTIC SMALL LETTER OLD NUBIAN SHIMA': 11485,
'COPTIC SMALL LETTER OLD NUBIAN WAU': 11491,
'COPTIC SMALL LETTER OOU': 11441,
'COPTIC SMALL LETTER PI': 11425,
'COPTIC SMALL LETTER PSI': 11439,
'COPTIC SMALL LETTER RO': 11427,
'COPTIC SMALL LETTER SAMPI': 11457,
'COPTIC SMALL LETTER SHEI': 995,
'COPTIC SMALL LETTER SHIMA': 1005,
'COPTIC SMALL LETTER SIMA': 11429,
'COPTIC SMALL LETTER SOU': 11403,
'COPTIC SMALL LETTER TAU': 11431,
'COPTIC SMALL LETTER THETHE': 11409,
'COPTIC SMALL LETTER UA': 11433,
'COPTIC SMALL LETTER VIDA': 11395,
'COPTIC SMALL LETTER ZATA': 11405,
'COPTIC SYMBOL KAI': 11492,
'COPTIC SYMBOL KHI RO': 11497,
'COPTIC SYMBOL MI RO': 11493,
'COPTIC SYMBOL PI RO': 11494,
'COPTIC SYMBOL SHIMA SIMA': 11498,
'COPTIC SYMBOL STAUROS': 11495,
'COPTIC SYMBOL TAU RO': 11496,
'COPYRIGHT SIGN': 169,
'CORRESPONDS TO': 8792,
'COUNTERBORE': 9012,
'COUNTERSINK': 9013,
'COUNTING ROD TENS DIGIT EIGHT': 119664,
'COUNTING ROD TENS DIGIT FIVE': 119661,
'COUNTING ROD TENS DIGIT FOUR': 119660,
'COUNTING ROD TENS DIGIT NINE': 119665,
'COUNTING ROD TENS DIGIT ONE': 119657,
'COUNTING ROD TENS DIGIT SEVEN': 119663,
'COUNTING ROD TENS DIGIT SIX': 119662,
'COUNTING ROD TENS DIGIT THREE': 119659,
'COUNTING ROD TENS DIGIT TWO': 119658,
'COUNTING ROD UNIT DIGIT EIGHT': 119655,
'COUNTING ROD UNIT DIGIT FIVE': 119652,
'COUNTING ROD UNIT DIGIT FOUR': 119651,
'COUNTING ROD UNIT DIGIT NINE': 119656,
'COUNTING ROD UNIT DIGIT ONE': 119648,
'COUNTING ROD UNIT DIGIT SEVEN': 119654,
'COUNTING ROD UNIT DIGIT SIX': 119653,
'COUNTING ROD UNIT DIGIT THREE': 119650,
'COUNTING ROD UNIT DIGIT TWO': 119649,
'CROSS OF JERUSALEM': 9769,
'CROSS OF LORRAINE': 9768,
'CROSSED NEGATIVE SQUARED LATIN CAPITAL LETTER P': 127370,
'CROSSED SWORDS': 9876,
'CROSSING LANES': 9932,
'CRUZEIRO SIGN': 8354,
'CUBE ROOT': 8731,
'CUNEIFORM NUMERIC SIGN EIGHT ASH': 74758,
'CUNEIFORM NUMERIC SIGN EIGHT DISH': 74765,
'CUNEIFORM NUMERIC SIGN EIGHT GESH2': 74780,
'CUNEIFORM NUMERIC SIGN EIGHT SHAR2': 74794,
'CUNEIFORM NUMERIC SIGN EIGHT U': 74771,
'CUNEIFORM NUMERIC SIGN EIGHT VARIANT FORM USSU': 74820,
'CUNEIFORM NUMERIC SIGN EIGHT VARIANT FORM USSU3': 74821,
'CUNEIFORM NUMERIC SIGN FIVE ASH': 74755,
'CUNEIFORM NUMERIC SIGN FIVE ASH TENU': 74829,
'CUNEIFORM NUMERIC SIGN FIVE BAN2': 74836,
'CUNEIFORM NUMERIC SIGN FIVE BAN2 VARIANT FORM': 74837,
'CUNEIFORM NUMERIC SIGN FIVE BURU': 74809,
'CUNEIFORM NUMERIC SIGN FIVE DISH': 74762,
'CUNEIFORM NUMERIC SIGN FIVE GESH2': 74777,
'CUNEIFORM NUMERIC SIGN FIVE GESHU': 74786,
'CUNEIFORM NUMERIC SIGN FIVE SHAR2': 74791,
'CUNEIFORM NUMERIC SIGN FIVE SHARU': 74801,
'CUNEIFORM NUMERIC SIGN FIVE SIXTHS DISH': 74844,
'CUNEIFORM NUMERIC SIGN FIVE U': 74768,
'CUNEIFORM NUMERIC SIGN FOUR ASH': 74754,
'CUNEIFORM NUMERIC SIGN FOUR ASH TENU': 74828,
'CUNEIFORM NUMERIC SIGN FOUR BAN2': 74834,
'CUNEIFORM NUMERIC SIGN FOUR BAN2 VARIANT FORM': 74835,
'CUNEIFORM NUMERIC SIGN FOUR BURU': 74808,
'CUNEIFORM NUMERIC SIGN FOUR DISH': 74761,
'CUNEIFORM NUMERIC SIGN FOUR GESH2': 74776,
'CUNEIFORM NUMERIC SIGN FOUR GESHU': 74785,
'CUNEIFORM NUMERIC SIGN FOUR SHAR2': 74790,
'CUNEIFORM NUMERIC SIGN FOUR SHARU': 74800,
'CUNEIFORM NUMERIC SIGN FOUR U': 74767,
'CUNEIFORM NUMERIC SIGN FOUR VARIANT FORM LIMMU': 74812,
'CUNEIFORM NUMERIC SIGN FOUR VARIANT FORM LIMMU A': 74814,
'CUNEIFORM NUMERIC SIGN FOUR VARIANT FORM LIMMU B': 74815,
'CUNEIFORM NUMERIC SIGN FOUR VARIANT FORM LIMMU4': 74813,
'CUNEIFORM NUMERIC SIGN NIGIDAESH': 74839,
'CUNEIFORM NUMERIC SIGN NIGIDAMIN': 74838,
'CUNEIFORM NUMERIC SIGN NINE ASH': 74759,
'CUNEIFORM NUMERIC SIGN NINE DISH': 74766,
'CUNEIFORM NUMERIC SIGN NINE GESH2': 74781,
'CUNEIFORM NUMERIC SIGN NINE SHAR2': 74795,
'CUNEIFORM NUMERIC SIGN NINE U': 74772,
'CUNEIFORM NUMERIC SIGN NINE VARIANT FORM ILIMMU': 74822,
'CUNEIFORM NUMERIC SIGN NINE VARIANT FORM ILIMMU A': 74825,
'CUNEIFORM NUMERIC SIGN NINE VARIANT FORM ILIMMU3': 74823,
'CUNEIFORM NUMERIC SIGN NINE VARIANT FORM ILIMMU4': 74824,
'CUNEIFORM NUMERIC SIGN OLD ASSYRIAN ONE QUARTER': 74850,
'CUNEIFORM NUMERIC SIGN OLD ASSYRIAN ONE SIXTH': 74849,
'CUNEIFORM NUMERIC SIGN ONE BAN2': 74831,
'CUNEIFORM NUMERIC SIGN ONE BURU': 74804,
'CUNEIFORM NUMERIC SIGN ONE EIGHTH ASH': 74847,
'CUNEIFORM NUMERIC SIGN ONE ESHE3': 74840,
'CUNEIFORM NUMERIC SIGN ONE GESH2': 74773,
'CUNEIFORM NUMERIC SIGN ONE GESHU': 74782,
'CUNEIFORM NUMERIC SIGN ONE QUARTER ASH': 74848,
'CUNEIFORM NUMERIC SIGN ONE SHARU': 74796,
'CUNEIFORM NUMERIC SIGN ONE THIRD DISH': 74842,
'CUNEIFORM NUMERIC SIGN ONE THIRD VARIANT FORM A': 74845,
'CUNEIFORM NUMERIC SIGN SEVEN ASH': 74757,
'CUNEIFORM NUMERIC SIGN SEVEN DISH': 74764,
'CUNEIFORM NUMERIC SIGN SEVEN GESH2': 74779,
'CUNEIFORM NUMERIC SIGN SEVEN SHAR2': 74793,
'CUNEIFORM NUMERIC SIGN SEVEN U': 74770,
'CUNEIFORM NUMERIC SIGN SEVEN VARIANT FORM IMIN A': 74818,
'CUNEIFORM NUMERIC SIGN SEVEN VARIANT FORM IMIN B': 74819,
'CUNEIFORM NUMERIC SIGN SEVEN VARIANT FORM IMIN3': 74817,
'CUNEIFORM NUMERIC SIGN SHAR2 TIMES GAL PLUS DISH': 74802,
'CUNEIFORM NUMERIC SIGN SHAR2 TIMES GAL PLUS MIN': 74803,
'CUNEIFORM NUMERIC SIGN SIX ASH': 74756,
'CUNEIFORM NUMERIC SIGN SIX ASH TENU': 74830,
'CUNEIFORM NUMERIC SIGN SIX DISH': 74763,
'CUNEIFORM NUMERIC SIGN SIX GESH2': 74778,
'CUNEIFORM NUMERIC SIGN SIX SHAR2': 74792,
'CUNEIFORM NUMERIC SIGN SIX U': 74769,
'CUNEIFORM NUMERIC SIGN SIX VARIANT FORM ASH9': 74816,
'CUNEIFORM NUMERIC SIGN THREE ASH': 74753,
'CUNEIFORM NUMERIC SIGN THREE ASH TENU': 74827,
'CUNEIFORM NUMERIC SIGN THREE BAN2': 74833,
'CUNEIFORM NUMERIC SIGN THREE BURU': 74806,
'CUNEIFORM NUMERIC SIGN THREE BURU VARIANT FORM': 74807,
'CUNEIFORM NUMERIC SIGN THREE DISH': 74760,
'CUNEIFORM NUMERIC SIGN THREE GESH2': 74775,
'CUNEIFORM NUMERIC SIGN THREE GESHU': 74784,
'CUNEIFORM NUMERIC SIGN THREE SHAR2': 74788,
'CUNEIFORM NUMERIC SIGN THREE SHAR2 VARIANT FORM': 74789,
'CUNEIFORM NUMERIC SIGN THREE SHARU': 74798,
'CUNEIFORM NUMERIC SIGN THREE SHARU VARIANT FORM': 74799,
'CUNEIFORM NUMERIC SIGN THREE VARIANT FORM ESH16': 74810,
'CUNEIFORM NUMERIC SIGN THREE VARIANT FORM ESH21': 74811,
'CUNEIFORM NUMERIC SIGN TWO ASH': 74752,
'CUNEIFORM NUMERIC SIGN TWO ASH TENU': 74826,
'CUNEIFORM NUMERIC SIGN TWO BAN2': 74832,
'CUNEIFORM NUMERIC SIGN TWO BURU': 74805,
'CUNEIFORM NUMERIC SIGN TWO ESHE3': 74841,
'CUNEIFORM NUMERIC SIGN TWO GESH2': 74774,
'CUNEIFORM NUMERIC SIGN TWO GESHU': 74783,
'CUNEIFORM NUMERIC SIGN TWO SHAR2': 74787,
'CUNEIFORM NUMERIC SIGN TWO SHARU': 74797,
'CUNEIFORM NUMERIC SIGN TWO THIRDS DISH': 74843,
'CUNEIFORM NUMERIC SIGN TWO THIRDS VARIANT FORM A': 74846,
'CUNEIFORM PUNCTUATION SIGN DIAGONAL COLON': 74866,
'CUNEIFORM PUNCTUATION SIGN DIAGONAL TRICOLON': 74867,
'CUNEIFORM PUNCTUATION SIGN OLD ASSYRIAN WORD DIVIDER': 74864,
'CUNEIFORM PUNCTUATION SIGN VERTICAL COLON': 74865,
'CUNEIFORM SIGN A': 73728,
'CUNEIFORM SIGN A TIMES A': 73729,
'CUNEIFORM SIGN A TIMES BAD': 73730,
'CUNEIFORM SIGN A TIMES GAN2 TENU': 73731,
'CUNEIFORM SIGN A TIMES HA': 73732,
'CUNEIFORM SIGN A TIMES IGI': 73733,
'CUNEIFORM SIGN A TIMES LAGAR GUNU': 73734,
'CUNEIFORM SIGN A TIMES MUSH': 73735,
'CUNEIFORM SIGN A TIMES SAG': 73736,
'CUNEIFORM SIGN A2': 73737,
'CUNEIFORM SIGN AB': 73738,
'CUNEIFORM SIGN AB GUNU': 73749,
'CUNEIFORM SIGN AB TIMES ASH2': 73739,
'CUNEIFORM SIGN AB TIMES DUN3 GUNU': 73740,
'CUNEIFORM SIGN AB TIMES GAL': 73741,
'CUNEIFORM SIGN AB TIMES GAN2 TENU': 73742,
'CUNEIFORM SIGN AB TIMES HA': 73743,
'CUNEIFORM SIGN AB TIMES IGI GUNU': 73744,
'CUNEIFORM SIGN AB TIMES IMIN': 73745,
'CUNEIFORM SIGN AB TIMES LAGAB': 73746,
'CUNEIFORM SIGN AB TIMES SHESH': 73747,
'CUNEIFORM SIGN AB TIMES U PLUS U PLUS U': 73748,
'CUNEIFORM SIGN AB2': 73750,
'CUNEIFORM SIGN AB2 TIMES BALAG': 73751,
'CUNEIFORM SIGN AB2 TIMES GAN2 TENU': 73752,
'CUNEIFORM SIGN AB2 TIMES ME PLUS EN': 73753,
'CUNEIFORM SIGN AB2 TIMES SHA3': 73754,
'CUNEIFORM SIGN AB2 TIMES TAK4': 73755,
'CUNEIFORM SIGN AD': 73756,
'CUNEIFORM SIGN AK': 73757,
'CUNEIFORM SIGN AK TIMES ERIN2': 73758,
'CUNEIFORM SIGN AK TIMES SHITA PLUS GISH': 73759,
'CUNEIFORM SIGN AL': 73760,
'CUNEIFORM SIGN AL TIMES AL': 73761,
'CUNEIFORM SIGN AL TIMES DIM2': 73762,
'CUNEIFORM SIGN AL TIMES GISH': 73763,
'CUNEIFORM SIGN AL TIMES HA': 73764,
'CUNEIFORM SIGN AL TIMES KAD3': 73765,
'CUNEIFORM SIGN AL TIMES KI': 73766,
'CUNEIFORM SIGN AL TIMES SHE': 73767,
'CUNEIFORM SIGN AL TIMES USH': 73768,
'CUNEIFORM SIGN ALAN': 73769,
'CUNEIFORM SIGN ALEPH': 73770,
'CUNEIFORM SIGN AMAR': 73771,
'CUNEIFORM SIGN AMAR TIMES SHE': 73772,
'CUNEIFORM SIGN AN': 73773,
'CUNEIFORM SIGN AN OVER AN': 73774,
'CUNEIFORM SIGN AN PLUS NAGA OPPOSING AN PLUS NAGA': 73776,
'CUNEIFORM SIGN AN PLUS NAGA SQUARED': 73777,
'CUNEIFORM SIGN AN THREE TIMES': 73775,
'CUNEIFORM SIGN ANSHE': 73778,
'CUNEIFORM SIGN APIN': 73779,
'CUNEIFORM SIGN ARAD': 73780,
'CUNEIFORM SIGN ARAD TIMES KUR': 73781,
'CUNEIFORM SIGN ARKAB': 73782,
'CUNEIFORM SIGN ASAL2': 73783,
'CUNEIFORM SIGN ASH': 73784,
'CUNEIFORM SIGN ASH KABA TENU': 73786,
'CUNEIFORM SIGN ASH OVER ASH OVER ASH': 73788,
'CUNEIFORM SIGN ASH OVER ASH OVER ASH CROSSING ASH OVER ASH OVER ASH': 73789,
'CUNEIFORM SIGN ASH OVER ASH TUG2 OVER TUG2 TUG2 OVER TUG2 PAP': 73787,
'CUNEIFORM SIGN ASH ZIDA TENU': 73785,
'CUNEIFORM SIGN ASH2': 73790,
'CUNEIFORM SIGN ASHGAB': 73791,
'CUNEIFORM SIGN BA': 73792,
'CUNEIFORM SIGN BAD': 73793,
'CUNEIFORM SIGN BAG3': 73794,
'CUNEIFORM SIGN BAHAR2': 73795,
'CUNEIFORM SIGN BAL': 73796,
'CUNEIFORM SIGN BAL OVER BAL': 73797,
'CUNEIFORM SIGN BALAG': 73798,
'CUNEIFORM SIGN BAR': 73799,
'CUNEIFORM SIGN BARA2': 73800,
'CUNEIFORM SIGN BI': 73801,
'CUNEIFORM SIGN BI TIMES A': 73802,
'CUNEIFORM SIGN BI TIMES GAR': 73803,
'CUNEIFORM SIGN BI TIMES IGI GUNU': 73804,
'CUNEIFORM SIGN BU': 73805,
'CUNEIFORM SIGN BU CROSSING BU': 73808,
'CUNEIFORM SIGN BU OVER BU AB': 73806,
'CUNEIFORM SIGN BU OVER BU UN': 73807,
'CUNEIFORM SIGN BULUG': 73809,
'CUNEIFORM SIGN BULUG OVER BULUG': 73810,
'CUNEIFORM SIGN BUR': 73811,
'CUNEIFORM SIGN BUR2': 73812,
'CUNEIFORM SIGN DA': 73813,
'CUNEIFORM SIGN DAG': 73814,
'CUNEIFORM SIGN DAG KISIM5 TIMES A PLUS MASH': 73815,
'CUNEIFORM SIGN DAG KISIM5 TIMES AMAR': 73816,
'CUNEIFORM SIGN DAG KISIM5 TIMES BALAG': 73817,
'CUNEIFORM SIGN DAG KISIM5 TIMES BI': 73818,
'CUNEIFORM SIGN DAG KISIM5 TIMES GA': 73819,
'CUNEIFORM SIGN DAG KISIM5 TIMES GA PLUS MASH': 73820,
'CUNEIFORM SIGN DAG KISIM5 TIMES GI': 73821,
'CUNEIFORM SIGN DAG KISIM5 TIMES GIR2': 73822,
'CUNEIFORM SIGN DAG KISIM5 TIMES GUD': 73823,
'CUNEIFORM SIGN DAG KISIM5 TIMES HA': 73824,
'CUNEIFORM SIGN DAG KISIM5 TIMES IR': 73825,
'CUNEIFORM SIGN DAG KISIM5 TIMES IR PLUS LU': 73826,
'CUNEIFORM SIGN DAG KISIM5 TIMES KAK': 73827,
'CUNEIFORM SIGN DAG KISIM5 TIMES LA': 73828,
'CUNEIFORM SIGN DAG KISIM5 TIMES LU': 73829,
'CUNEIFORM SIGN DAG KISIM5 TIMES LU PLUS MASH2': 73830,
'CUNEIFORM SIGN DAG KISIM5 TIMES LUM': 73831,
'CUNEIFORM SIGN DAG KISIM5 TIMES NE': 73832,
'CUNEIFORM SIGN DAG KISIM5 TIMES PAP PLUS PAP': 73833,
'CUNEIFORM SIGN DAG KISIM5 TIMES SI': 73834,
'CUNEIFORM SIGN DAG KISIM5 TIMES TAK4': 73835,
'CUNEIFORM SIGN DAG KISIM5 TIMES U2 PLUS GIR2': 73836,
'CUNEIFORM SIGN DAG KISIM5 TIMES USH': 73837,
'CUNEIFORM SIGN DAM': 73838,
'CUNEIFORM SIGN DAR': 73839,
'CUNEIFORM SIGN DARA3': 73840,
'CUNEIFORM SIGN DARA4': 73841,
'CUNEIFORM SIGN DI': 73842,
'CUNEIFORM SIGN DIB': 73843,
'CUNEIFORM SIGN DIM': 73844,
'CUNEIFORM SIGN DIM TIMES SHE': 73845,
'CUNEIFORM SIGN DIM2': 73846,
'CUNEIFORM SIGN DIN': 73847,
'CUNEIFORM SIGN DIN KASKAL U GUNU DISH': 73848,
'CUNEIFORM SIGN DISH': 73849,
'CUNEIFORM SIGN DU': 73850,
'CUNEIFORM SIGN DU GUNU': 73852,
'CUNEIFORM SIGN DU OVER DU': 73851,
'CUNEIFORM SIGN DU SHESHIG': 73853,
'CUNEIFORM SIGN DUB': 73854,
'CUNEIFORM SIGN DUB TIMES ESH2': 73855,
'CUNEIFORM SIGN DUB2': 73856,
'CUNEIFORM SIGN DUG': 73857,
'CUNEIFORM SIGN DUGUD': 73858,
'CUNEIFORM SIGN DUH': 73859,
'CUNEIFORM SIGN DUN': 73860,
'CUNEIFORM SIGN DUN3': 73861,
'CUNEIFORM SIGN DUN3 GUNU': 73862,
'CUNEIFORM SIGN DUN3 GUNU GUNU': 73863,
'CUNEIFORM SIGN DUN4': 73864,
'CUNEIFORM SIGN DUR2': 73865,
'CUNEIFORM SIGN E': 73866,
'CUNEIFORM SIGN E OVER E NUN OVER NUN': 73868,
'CUNEIFORM SIGN E TIMES PAP': 73867,
'CUNEIFORM SIGN E2': 73869,
'CUNEIFORM SIGN E2 TIMES A PLUS HA PLUS DA': 73870,
'CUNEIFORM SIGN E2 TIMES GAR': 73871,
'CUNEIFORM SIGN E2 TIMES MI': 73872,
'CUNEIFORM SIGN E2 TIMES SAL': 73873,
'CUNEIFORM SIGN E2 TIMES SHE': 73874,
'CUNEIFORM SIGN E2 TIMES U': 73875,
'CUNEIFORM SIGN EDIN': 73876,
'CUNEIFORM SIGN EGIR': 73877,
'CUNEIFORM SIGN EL': 73878,
'CUNEIFORM SIGN EN': 73879,
'CUNEIFORM SIGN EN CROSSING EN': 73883,
'CUNEIFORM SIGN EN OPPOSING EN': 73884,
'CUNEIFORM SIGN EN SQUARED': 73885,
'CUNEIFORM SIGN EN TIMES GAN2': 73880,
'CUNEIFORM SIGN EN TIMES GAN2 TENU': 73881,
'CUNEIFORM SIGN EN TIMES ME': 73882,
'CUNEIFORM SIGN EREN': 73886,
'CUNEIFORM SIGN ERIN2': 73887,
'CUNEIFORM SIGN ESH2': 73888,
'CUNEIFORM SIGN EZEN': 73889,
'CUNEIFORM SIGN EZEN TIMES A': 73890,
'CUNEIFORM SIGN EZEN TIMES A PLUS LAL': 73891,
'CUNEIFORM SIGN EZEN TIMES A PLUS LAL TIMES LAL': 73892,
'CUNEIFORM SIGN EZEN TIMES AN': 73893,
'CUNEIFORM SIGN EZEN TIMES BAD': 73894,
'CUNEIFORM SIGN EZEN TIMES DUN3 GUNU': 73895,
'CUNEIFORM SIGN EZEN TIMES DUN3 GUNU GUNU': 73896,
'CUNEIFORM SIGN EZEN TIMES HA': 73897,
'CUNEIFORM SIGN EZEN TIMES HA GUNU': 73898,
'CUNEIFORM SIGN EZEN TIMES IGI GUNU': 73899,
'CUNEIFORM SIGN EZEN TIMES KASKAL': 73900,
'CUNEIFORM SIGN EZEN TIMES KASKAL SQUARED': 73901,
'CUNEIFORM SIGN EZEN TIMES KU3': 73902,
'CUNEIFORM SIGN EZEN TIMES LA': 73903,
'CUNEIFORM SIGN EZEN TIMES LAL TIMES LAL': 73904,
'CUNEIFORM SIGN EZEN TIMES LI': 73905,
'CUNEIFORM SIGN EZEN TIMES LU': 73906,
'CUNEIFORM SIGN EZEN TIMES U2': 73907,
'CUNEIFORM SIGN EZEN TIMES UD': 73908,
'CUNEIFORM SIGN GA': 73909,
'CUNEIFORM SIGN GA GUNU': 73910,
'CUNEIFORM SIGN GA2': 73911,
'CUNEIFORM SIGN GA2 OVER GA2': 73965,
'CUNEIFORM SIGN GA2 TIMES A PLUS DA PLUS HA': 73912,
'CUNEIFORM SIGN GA2 TIMES A PLUS HA': 73913,
'CUNEIFORM SIGN GA2 TIMES A PLUS IGI': 73914,
'CUNEIFORM SIGN GA2 TIMES AB2 TENU PLUS TAB': 73915,
'CUNEIFORM SIGN GA2 TIMES AN': 73916,
'CUNEIFORM SIGN GA2 TIMES ASH': 73917,
'CUNEIFORM SIGN GA2 TIMES ASH2 PLUS GAL': 73918,
'CUNEIFORM SIGN GA2 TIMES BAD': 73919,
'CUNEIFORM SIGN GA2 TIMES BAR PLUS RA': 73920,
'CUNEIFORM SIGN GA2 TIMES BUR': 73921,
'CUNEIFORM SIGN GA2 TIMES BUR PLUS RA': 73922,
'CUNEIFORM SIGN GA2 TIMES DA': 73923,
'CUNEIFORM SIGN GA2 TIMES DI': 73924,
'CUNEIFORM SIGN GA2 TIMES DIM TIMES SHE': 73925,
'CUNEIFORM SIGN GA2 TIMES DUB': 73926,
'CUNEIFORM SIGN GA2 TIMES EL': 73927,
'CUNEIFORM SIGN GA2 TIMES EL PLUS LA': 73928,
'CUNEIFORM SIGN GA2 TIMES EN': 73929,
'CUNEIFORM SIGN GA2 TIMES EN TIMES GAN2 TENU': 73930,
'CUNEIFORM SIGN GA2 TIMES GAN2 TENU': 73931,
'CUNEIFORM SIGN GA2 TIMES GAR': 73932,
'CUNEIFORM SIGN GA2 TIMES GI': 73933,
'CUNEIFORM SIGN GA2 TIMES GI4': 73934,
'CUNEIFORM SIGN GA2 TIMES GI4 PLUS A': 73935,
'CUNEIFORM SIGN GA2 TIMES GIR2 PLUS SU': 73936,
'CUNEIFORM SIGN GA2 TIMES HA PLUS LU PLUS ESH2': 73937,
'CUNEIFORM SIGN GA2 TIMES HAL': 73938,
'CUNEIFORM SIGN GA2 TIMES HAL PLUS LA': 73939,
'CUNEIFORM SIGN GA2 TIMES HI PLUS LI': 73940,
'CUNEIFORM SIGN GA2 TIMES HUB2': 73941,
'CUNEIFORM SIGN GA2 TIMES IGI GUNU': 73942,
'CUNEIFORM SIGN GA2 TIMES ISH PLUS HU PLUS ASH': 73943,
'CUNEIFORM SIGN GA2 TIMES KAK': 73944,
'CUNEIFORM SIGN GA2 TIMES KASKAL': 73945,
'CUNEIFORM SIGN GA2 TIMES KID': 73946,
'CUNEIFORM SIGN GA2 TIMES KID PLUS LAL': 73947,
'CUNEIFORM SIGN GA2 TIMES KU3 PLUS AN': 73948,
'CUNEIFORM SIGN GA2 TIMES LA': 73949,
'CUNEIFORM SIGN GA2 TIMES ME PLUS EN': 73950,
'CUNEIFORM SIGN GA2 TIMES MI': 73951,
'CUNEIFORM SIGN GA2 TIMES NUN': 73952,
'CUNEIFORM SIGN GA2 TIMES NUN OVER NUN': 73953,
'CUNEIFORM SIGN GA2 TIMES PA': 73954,
'CUNEIFORM SIGN GA2 TIMES SAL': 73955,
'CUNEIFORM SIGN GA2 TIMES SAR': 73956,
'CUNEIFORM SIGN GA2 TIMES SHE': 73957,
'CUNEIFORM SIGN GA2 TIMES SHE PLUS TUR': 73958,
'CUNEIFORM SIGN GA2 TIMES SHID': 73959,
'CUNEIFORM SIGN GA2 TIMES SUM': 73960,
'CUNEIFORM SIGN GA2 TIMES TAK4': 73961,
'CUNEIFORM SIGN GA2 TIMES U': 73962,
'CUNEIFORM SIGN GA2 TIMES UD': 73963,
'CUNEIFORM SIGN GA2 TIMES UD PLUS DU': 73964,
'CUNEIFORM SIGN GABA': 73966,
'CUNEIFORM SIGN GABA CROSSING GABA': 73967,
'CUNEIFORM SIGN GAD': 73968,
'CUNEIFORM SIGN GAD OVER GAD GAR OVER GAR': 73969,
'CUNEIFORM SIGN GAL': 73970,
'CUNEIFORM SIGN GAL GAD OVER GAD GAR OVER GAR': 73971,
'CUNEIFORM SIGN GALAM': 73972,
'CUNEIFORM SIGN GAM': 73973,
'CUNEIFORM SIGN GAN': 73974,
'CUNEIFORM SIGN GAN2': 73975,
'CUNEIFORM SIGN GAN2 CROSSING GAN2': 73978,
'CUNEIFORM SIGN GAN2 OVER GAN2': 73977,
'CUNEIFORM SIGN GAN2 TENU': 73976,
'CUNEIFORM SIGN GAR': 73979,
'CUNEIFORM SIGN GAR3': 73980,
'CUNEIFORM SIGN GASHAN': 73981,
'CUNEIFORM SIGN GESHTIN': 73982,
'CUNEIFORM SIGN GESHTIN TIMES KUR': 73983,
'CUNEIFORM SIGN GI': 73984,
'CUNEIFORM SIGN GI CROSSING GI': 73987,
'CUNEIFORM SIGN GI TIMES E': 73985,
'CUNEIFORM SIGN GI TIMES U': 73986,
'CUNEIFORM SIGN GI4': 73988,
'CUNEIFORM SIGN GI4 CROSSING GI4': 73990,
'CUNEIFORM SIGN GI4 OVER GI4': 73989,
'CUNEIFORM SIGN GIDIM': 73991,
'CUNEIFORM SIGN GIR2': 73992,
'CUNEIFORM SIGN GIR2 GUNU': 73993,
'CUNEIFORM SIGN GIR3': 73994,
'CUNEIFORM SIGN GIR3 TIMES A PLUS IGI': 73995,
'CUNEIFORM SIGN GIR3 TIMES GAN2 TENU': 73996,
'CUNEIFORM SIGN GIR3 TIMES IGI': 73997,
'CUNEIFORM SIGN GIR3 TIMES LU PLUS IGI': 73998,
'CUNEIFORM SIGN GIR3 TIMES PA': 73999,
'CUNEIFORM SIGN GISAL': 74000,
'CUNEIFORM SIGN GISH': 74001,
'CUNEIFORM SIGN GISH CROSSING GISH': 74002,
'CUNEIFORM SIGN GISH TENU': 74005,
'CUNEIFORM SIGN GISH TIMES BAD': 74003,
'CUNEIFORM SIGN GISH TIMES TAK4': 74004,
'CUNEIFORM SIGN GU': 74006,
'CUNEIFORM SIGN GU CROSSING GU': 74007,
'CUNEIFORM SIGN GU2': 74008,
'CUNEIFORM SIGN GU2 GUNU': 74013,
'CUNEIFORM SIGN GU2 TIMES KAK': 74009,
'CUNEIFORM SIGN GU2 TIMES KAK TIMES IGI GUNU': 74010,
'CUNEIFORM SIGN GU2 TIMES NUN': 74011,
'CUNEIFORM SIGN GU2 TIMES SAL PLUS TUG2': 74012,
'CUNEIFORM SIGN GUD': 74014,
'CUNEIFORM SIGN GUD OVER GUD LUGAL': 74017,
'CUNEIFORM SIGN GUD TIMES A PLUS KUR': 74015,
'CUNEIFORM SIGN GUD TIMES KUR': 74016,
'CUNEIFORM SIGN GUL': 74018,
'CUNEIFORM SIGN GUM': 74019,
'CUNEIFORM SIGN GUM TIMES SHE': 74020,
'CUNEIFORM SIGN GUR': 74021,
'CUNEIFORM SIGN GUR7': 74022,
'CUNEIFORM SIGN GURUN': 74023,
'CUNEIFORM SIGN GURUSH': 74024,
'CUNEIFORM SIGN HA': 74025,
'CUNEIFORM SIGN HA GUNU': 74027,
'CUNEIFORM SIGN HA TENU': 74026,
'CUNEIFORM SIGN HAL': 74028,
'CUNEIFORM SIGN HI': 74029,
'CUNEIFORM SIGN HI TIMES ASH': 74030,
'CUNEIFORM SIGN HI TIMES ASH2': 74031,
'CUNEIFORM SIGN HI TIMES BAD': 74032,
'CUNEIFORM SIGN HI TIMES DISH': 74033,
'CUNEIFORM SIGN HI TIMES GAD': 74034,
'CUNEIFORM SIGN HI TIMES KIN': 74035,
'CUNEIFORM SIGN HI TIMES NUN': 74036,
'CUNEIFORM SIGN HI TIMES SHE': 74037,
'CUNEIFORM SIGN HI TIMES U': 74038,
'CUNEIFORM SIGN HU': 74039,
'CUNEIFORM SIGN HUB2': 74040,
'CUNEIFORM SIGN HUB2 TIMES AN': 74041,
'CUNEIFORM SIGN HUB2 TIMES HAL': 74042,
'CUNEIFORM SIGN HUB2 TIMES KASKAL': 74043,
'CUNEIFORM SIGN HUB2 TIMES LISH': 74044,
'CUNEIFORM SIGN HUB2 TIMES UD': 74045,
'CUNEIFORM SIGN HUL2': 74046,
'CUNEIFORM SIGN I': 74047,
'CUNEIFORM SIGN I A': 74048,
'CUNEIFORM SIGN IB': 74049,
'CUNEIFORM SIGN IDIM': 74050,
'CUNEIFORM SIGN IDIM OVER IDIM BUR': 74051,
'CUNEIFORM SIGN IDIM OVER IDIM SQUARED': 74052,
'CUNEIFORM SIGN IG': 74053,
'CUNEIFORM SIGN IGI': 74054,
'CUNEIFORM SIGN IGI DIB': 74055,
'CUNEIFORM SIGN IGI GUNU': 74058,
'CUNEIFORM SIGN IGI OVER IGI SHIR OVER SHIR UD OVER UD': 74057,
'CUNEIFORM SIGN IGI RI': 74056,
'CUNEIFORM SIGN IL': 74059,
'CUNEIFORM SIGN IL TIMES GAN2 TENU': 74060,
'CUNEIFORM SIGN IL2': 74061,
'CUNEIFORM SIGN IM': 74062,
'CUNEIFORM SIGN IM CROSSING IM': 74064,
'CUNEIFORM SIGN IM OPPOSING IM': 74065,
'CUNEIFORM SIGN IM SQUARED': 74066,
'CUNEIFORM SIGN IM TIMES TAK4': 74063,
'CUNEIFORM SIGN IMIN': 74067,
'CUNEIFORM SIGN IN': 74068,
'CUNEIFORM SIGN IR': 74069,
'CUNEIFORM SIGN ISH': 74070,
'CUNEIFORM SIGN KA': 74071,
'CUNEIFORM SIGN KA TIMES A': 74072,
'CUNEIFORM SIGN KA TIMES AD': 74073,
'CUNEIFORM SIGN KA TIMES AD PLUS KU3': 74074,
'CUNEIFORM SIGN KA TIMES ASH2': 74075,
'CUNEIFORM SIGN KA TIMES BAD': 74076,
'CUNEIFORM SIGN KA TIMES BALAG': 74077,
'CUNEIFORM SIGN KA TIMES BAR': 74078,
'CUNEIFORM SIGN KA TIMES BI': 74079,
'CUNEIFORM SIGN KA TIMES ERIN2': 74080,
'CUNEIFORM SIGN KA TIMES ESH2': 74081,
'CUNEIFORM SIGN KA TIMES GA': 74082,
'CUNEIFORM SIGN KA TIMES GAL': 74083,
'CUNEIFORM SIGN KA TIMES GAN2 TENU': 74084,
'CUNEIFORM SIGN KA TIMES GAR': 74085,
'CUNEIFORM SIGN KA TIMES GAR PLUS SHA3 PLUS A': 74086,
'CUNEIFORM SIGN KA TIMES GI': 74087,
'CUNEIFORM SIGN KA TIMES GIR2': 74088,
'CUNEIFORM SIGN KA TIMES GISH CROSSING GISH': 74090,
'CUNEIFORM SIGN KA TIMES GISH PLUS SAR': 74089,
'CUNEIFORM SIGN KA TIMES GU': 74091,
'CUNEIFORM SIGN KA TIMES GUR7': 74092,
'CUNEIFORM SIGN KA TIMES IGI': 74093,
'CUNEIFORM SIGN KA TIMES IM': 74094,
'CUNEIFORM SIGN KA TIMES KAK': 74095,
'CUNEIFORM SIGN KA TIMES KI': 74096,
'CUNEIFORM SIGN KA TIMES KID': 74097,
'CUNEIFORM SIGN KA TIMES LI': 74098,
'CUNEIFORM SIGN KA TIMES LU': 74099,
'CUNEIFORM SIGN KA TIMES ME': 74100,
'CUNEIFORM SIGN KA TIMES ME PLUS DU': 74101,
'CUNEIFORM SIGN KA TIMES ME PLUS GI': 74102,
'CUNEIFORM SIGN KA TIMES ME PLUS TE': 74103,
'CUNEIFORM SIGN KA TIMES MI': 74104,
'CUNEIFORM SIGN KA TIMES MI PLUS NUNUZ': 74105,
'CUNEIFORM SIGN KA TIMES NE': 74106,
'CUNEIFORM SIGN KA TIMES NUN': 74107,
'CUNEIFORM SIGN KA TIMES PI': 74108,
'CUNEIFORM SIGN KA TIMES RU': 74109,
'CUNEIFORM SIGN KA TIMES SA': 74110,
'CUNEIFORM SIGN KA TIMES SAR': 74111,
'CUNEIFORM SIGN KA TIMES SHA': 74112,
'CUNEIFORM SIGN KA TIMES SHE': 74113,
'CUNEIFORM SIGN KA TIMES SHID': 74114,
'CUNEIFORM SIGN KA TIMES SHU': 74115,
'CUNEIFORM SIGN KA TIMES SIG': 74116,
'CUNEIFORM SIGN KA TIMES SUHUR': 74117,
'CUNEIFORM SIGN KA TIMES TAR': 74118,
'CUNEIFORM SIGN KA TIMES U': 74119,
'CUNEIFORM SIGN KA TIMES U2': 74120,
'CUNEIFORM SIGN KA TIMES UD': 74121,
'CUNEIFORM SIGN KA TIMES UMUM TIMES PA': 74122,
'CUNEIFORM SIGN KA TIMES USH': 74123,
'CUNEIFORM SIGN KA TIMES ZI': 74124,
'CUNEIFORM SIGN KA2': 74125,
'CUNEIFORM SIGN KA2 CROSSING KA2': 74126,
'CUNEIFORM SIGN KAB': 74127,
'CUNEIFORM SIGN KAD2': 74128,
'CUNEIFORM SIGN KAD3': 74129,
'CUNEIFORM SIGN KAD4': 74130,
'CUNEIFORM SIGN KAD5': 74131,
'CUNEIFORM SIGN KAD5 OVER KAD5': 74132,
'CUNEIFORM SIGN KAK': 74133,
'CUNEIFORM SIGN KAK TIMES IGI GUNU': 74134,
'CUNEIFORM SIGN KAL': 74135,
'CUNEIFORM SIGN KAL CROSSING KAL': 74137,
'CUNEIFORM SIGN KAL TIMES BAD': 74136,
'CUNEIFORM SIGN KAM2': 74138,
'CUNEIFORM SIGN KAM4': 74139,
'CUNEIFORM SIGN KASKAL': 74140,
'CUNEIFORM SIGN KASKAL LAGAB TIMES U OVER LAGAB TIMES U': 74141,
'CUNEIFORM SIGN KASKAL OVER KASKAL LAGAB TIMES U OVER LAGAB TIMES U': 74142,
'CUNEIFORM SIGN KESH2': 74143,
'CUNEIFORM SIGN KI': 74144,
'CUNEIFORM SIGN KI TIMES BAD': 74145,
'CUNEIFORM SIGN KI TIMES U': 74146,
'CUNEIFORM SIGN KI TIMES UD': 74147,
'CUNEIFORM SIGN KID': 74148,
'CUNEIFORM SIGN KIN': 74149,
'CUNEIFORM SIGN KISAL': 74150,
'CUNEIFORM SIGN KISH': 74151,
'CUNEIFORM SIGN KISIM5': 74152,
'CUNEIFORM SIGN KISIM5 OVER KISIM5': 74153,
'CUNEIFORM SIGN KU': 74154,
'CUNEIFORM SIGN KU OVER HI TIMES ASH2 KU OVER HI TIMES ASH2': 74155,
'CUNEIFORM SIGN KU3': 74156,
'CUNEIFORM SIGN KU4': 74157,
'CUNEIFORM SIGN KU4 VARIANT FORM': 74158,
'CUNEIFORM SIGN KU7': 74159,
'CUNEIFORM SIGN KUL': 74160,
'CUNEIFORM SIGN KUL GUNU': 74161,
'CUNEIFORM SIGN KUN': 74162,
'CUNEIFORM SIGN KUR': 74163,
'CUNEIFORM SIGN KUR OPPOSING KUR': 74164,
'CUNEIFORM SIGN KUSHU2': 74165,
'CUNEIFORM SIGN KWU318': 74166,
'CUNEIFORM SIGN LA': 74167,
'CUNEIFORM SIGN LAGAB': 74168,
'CUNEIFORM SIGN LAGAB SQUARED': 74219,
'CUNEIFORM SIGN LAGAB TIMES A': 74169,
'CUNEIFORM SIGN LAGAB TIMES A PLUS DA PLUS HA': 74170,
'CUNEIFORM SIGN LAGAB TIMES A PLUS GAR': 74171,
'CUNEIFORM SIGN LAGAB TIMES A PLUS LAL': 74172,
'CUNEIFORM SIGN LAGAB TIMES AL': 74173,
'CUNEIFORM SIGN LAGAB TIMES AN': 74174,
'CUNEIFORM SIGN LAGAB TIMES ASH ZIDA TENU': 74175,
'CUNEIFORM SIGN LAGAB TIMES BAD': 74176,
'CUNEIFORM SIGN LAGAB TIMES BI': 74177,
'CUNEIFORM SIGN LAGAB TIMES DAR': 74178,
'CUNEIFORM SIGN LAGAB TIMES EN': 74179,
'CUNEIFORM SIGN LAGAB TIMES GA': 74180,
'CUNEIFORM SIGN LAGAB TIMES GAR': 74181,
'CUNEIFORM SIGN LAGAB TIMES GUD': 74182,
'CUNEIFORM SIGN LAGAB TIMES GUD PLUS GUD': 74183,
'CUNEIFORM SIGN LAGAB TIMES HA': 74184,
'CUNEIFORM SIGN LAGAB TIMES HAL': 74185,
'CUNEIFORM SIGN LAGAB TIMES HI TIMES NUN': 74186,
'CUNEIFORM SIGN LAGAB TIMES IGI GUNU': 74187,
'CUNEIFORM SIGN LAGAB TIMES IM': 74188,
'CUNEIFORM SIGN LAGAB TIMES IM PLUS HA': 74189,
'CUNEIFORM SIGN LAGAB TIMES IM PLUS LU': 74190,
'CUNEIFORM SIGN LAGAB TIMES KI': 74191,
'CUNEIFORM SIGN LAGAB TIMES KIN': 74192,
'CUNEIFORM SIGN LAGAB TIMES KU3': 74193,
'CUNEIFORM SIGN LAGAB TIMES KUL': 74194,
'CUNEIFORM SIGN LAGAB TIMES KUL PLUS HI PLUS A': 74195,
'CUNEIFORM SIGN LAGAB TIMES LAGAB': 74196,
'CUNEIFORM SIGN LAGAB TIMES LISH': 74197,
'CUNEIFORM SIGN LAGAB TIMES LU': 74198,
'CUNEIFORM SIGN LAGAB TIMES LUL': 74199,
'CUNEIFORM SIGN LAGAB TIMES ME': 74200,
'CUNEIFORM SIGN LAGAB TIMES ME PLUS EN': 74201,
'CUNEIFORM SIGN LAGAB TIMES MUSH': 74202,
'CUNEIFORM SIGN LAGAB TIMES NE': 74203,
'CUNEIFORM SIGN LAGAB TIMES SHE PLUS SUM': 74204,
'CUNEIFORM SIGN LAGAB TIMES SHITA PLUS GISH PLUS ERIN2': 74205,
'CUNEIFORM SIGN LAGAB TIMES SHITA PLUS GISH TENU': 74206,
'CUNEIFORM SIGN LAGAB TIMES SHU2': 74207,
'CUNEIFORM SIGN LAGAB TIMES SHU2 PLUS SHU2': 74208,
'CUNEIFORM SIGN LAGAB TIMES SUM': 74209,
'CUNEIFORM SIGN LAGAB TIMES TAG': 74210,
'CUNEIFORM SIGN LAGAB TIMES TAK4': 74211,
'CUNEIFORM SIGN LAGAB TIMES TE PLUS A PLUS SU PLUS NA': 74212,
'CUNEIFORM SIGN LAGAB TIMES U': 74213,
'CUNEIFORM SIGN LAGAB TIMES U PLUS A': 74214,
'CUNEIFORM SIGN LAGAB TIMES U PLUS U PLUS U': 74215,
'CUNEIFORM SIGN LAGAB TIMES U2 PLUS ASH': 74216,
'CUNEIFORM SIGN LAGAB TIMES UD': 74217,
'CUNEIFORM SIGN LAGAB TIMES USH': 74218,
'CUNEIFORM SIGN LAGAR': 74220,
'CUNEIFORM SIGN LAGAR GUNU': 74223,
'CUNEIFORM SIGN LAGAR GUNU OVER LAGAR GUNU SHE': 74224,
'CUNEIFORM SIGN LAGAR TIMES SHE': 74221,
'CUNEIFORM SIGN LAGAR TIMES SHE PLUS SUM': 74222,
'CUNEIFORM SIGN LAHSHU': 74225,
'CUNEIFORM SIGN LAL': 74226,
'CUNEIFORM SIGN LAL TIMES LAL': 74227,
'CUNEIFORM SIGN LAM': 74228,
'CUNEIFORM SIGN LAM TIMES KUR': 74229,
'CUNEIFORM SIGN LAM TIMES KUR PLUS RU': 74230,
'CUNEIFORM SIGN LI': 74231,
'CUNEIFORM SIGN LIL': 74232,
'CUNEIFORM SIGN LIMMU2': 74233,
'CUNEIFORM SIGN LISH': 74234,
'CUNEIFORM SIGN LU': 74235,
'CUNEIFORM SIGN LU TIMES BAD': 74236,
'CUNEIFORM SIGN LU2': 74237,
'CUNEIFORM SIGN LU2 CROSSING LU2': 74258,
'CUNEIFORM SIGN LU2 OPPOSING LU2': 74259,
'CUNEIFORM SIGN LU2 SHESHIG': 74261,
'CUNEIFORM SIGN LU2 SQUARED': 74260,
'CUNEIFORM SIGN LU2 TENU': 74257,
'CUNEIFORM SIGN LU2 TIMES AL': 74238,
'CUNEIFORM SIGN LU2 TIMES BAD': 74239,
'CUNEIFORM SIGN LU2 TIMES ESH2': 74240,
'CUNEIFORM SIGN LU2 TIMES ESH2 TENU': 74241,
'CUNEIFORM SIGN LU2 TIMES GAN2 TENU': 74242,
'CUNEIFORM SIGN LU2 TIMES HI TIMES BAD': 74243,
'CUNEIFORM SIGN LU2 TIMES IM': 74244,
'CUNEIFORM SIGN LU2 TIMES KAD2': 74245,
'CUNEIFORM SIGN LU2 TIMES KAD3': 74246,
'CUNEIFORM SIGN LU2 TIMES KAD3 PLUS ASH': 74247,
'CUNEIFORM SIGN LU2 TIMES KI': 74248,
'CUNEIFORM SIGN LU2 TIMES LA PLUS ASH': 74249,
'CUNEIFORM SIGN LU2 TIMES LAGAB': 74250,
'CUNEIFORM SIGN LU2 TIMES ME PLUS EN': 74251,
'CUNEIFORM SIGN LU2 TIMES NE': 74252,
'CUNEIFORM SIGN LU2 TIMES NU': 74253,
'CUNEIFORM SIGN LU2 TIMES SI PLUS ASH': 74254,
'CUNEIFORM SIGN LU2 TIMES SIK2 PLUS BU': 74255,
'CUNEIFORM SIGN LU2 TIMES TUG2': 74256,
'CUNEIFORM SIGN LU3': 74262,
'CUNEIFORM SIGN LUGAL': 74263,
'CUNEIFORM SIGN LUGAL OPPOSING LUGAL': 74265,
'CUNEIFORM SIGN LUGAL OVER LUGAL': 74264,
'CUNEIFORM SIGN LUGAL SHESHIG': 74266,
'CUNEIFORM SIGN LUH': 74267,
'CUNEIFORM SIGN LUL': 74268,
'CUNEIFORM SIGN LUM': 74269,
'CUNEIFORM SIGN LUM OVER LUM': 74270,
'CUNEIFORM SIGN LUM OVER LUM GAR OVER GAR': 74271,
'CUNEIFORM SIGN MA': 74272,
'CUNEIFORM SIGN MA GUNU': 74274,
'CUNEIFORM SIGN MA TIMES TAK4': 74273,
'CUNEIFORM SIGN MA2': 74275,
'CUNEIFORM SIGN MAH': 74276,
'CUNEIFORM SIGN MAR': 74277,
'CUNEIFORM SIGN MASH': 74278,
'CUNEIFORM SIGN MASH2': 74279,
'CUNEIFORM SIGN ME': 74280,
'CUNEIFORM SIGN MES': 74281,
'CUNEIFORM SIGN MI': 74282,
'CUNEIFORM SIGN MIN': 74283,
'CUNEIFORM SIGN MU': 74284,
'CUNEIFORM SIGN MU OVER MU': 74285,
'CUNEIFORM SIGN MUG': 74286,
'CUNEIFORM SIGN MUG GUNU': 74287,
'CUNEIFORM SIGN MUNSUB': 74288,
'CUNEIFORM SIGN MURGU2': 74289,
'CUNEIFORM SIGN MUSH': 74290,
'CUNEIFORM SIGN MUSH CROSSING MUSH': 74296,
'CUNEIFORM SIGN MUSH OVER MUSH': 74294,
'CUNEIFORM SIGN MUSH OVER MUSH TIMES A PLUS NA': 74295,
'CUNEIFORM SIGN MUSH TIMES A': 74291,
'CUNEIFORM SIGN MUSH TIMES KUR': 74292,
'CUNEIFORM SIGN MUSH TIMES ZA': 74293,
'CUNEIFORM SIGN MUSH3': 74297,
'CUNEIFORM SIGN MUSH3 GUNU': 74301,
'CUNEIFORM SIGN MUSH3 TIMES A': 74298,
'CUNEIFORM SIGN MUSH3 TIMES A PLUS DI': 74299,
'CUNEIFORM SIGN MUSH3 TIMES DI': 74300,
'CUNEIFORM SIGN NA': 74302,
'CUNEIFORM SIGN NA2': 74303,
'CUNEIFORM SIGN NAGA': 74304,
'CUNEIFORM SIGN NAGA INVERTED': 74305,
'CUNEIFORM SIGN NAGA OPPOSING NAGA': 74307,
'CUNEIFORM SIGN NAGA TIMES SHU TENU': 74306,
'CUNEIFORM SIGN NAGAR': 74308,
'CUNEIFORM SIGN NAM': 74310,
'CUNEIFORM SIGN NAM NUTILLU': 74309,
'CUNEIFORM SIGN NAM2': 74311,
'CUNEIFORM SIGN NE': 74312,
'CUNEIFORM SIGN NE SHESHIG': 74315,
'CUNEIFORM SIGN NE TIMES A': 74313,
'CUNEIFORM SIGN NE TIMES UD': 74314,
'CUNEIFORM SIGN NI': 74316,
'CUNEIFORM SIGN NI TIMES E': 74317,
'CUNEIFORM SIGN NI2': 74318,
'CUNEIFORM SIGN NIM': 74319,
'CUNEIFORM SIGN NIM TIMES GAN2 TENU': 74320,
'CUNEIFORM SIGN NIM TIMES GAR PLUS GAN2 TENU': 74321,
'CUNEIFORM SIGN NINDA2': 74322,
'CUNEIFORM SIGN NINDA2 TIMES AN': 74323,
'CUNEIFORM SIGN NINDA2 TIMES ASH': 74324,
'CUNEIFORM SIGN NINDA2 TIMES ASH PLUS ASH': 74325,
'CUNEIFORM SIGN NINDA2 TIMES GUD': 74326,
'CUNEIFORM SIGN NINDA2 TIMES ME PLUS GAN2 TENU': 74327,
'CUNEIFORM SIGN NINDA2 TIMES NE': 74328,
'CUNEIFORM SIGN NINDA2 TIMES NUN': 74329,
'CUNEIFORM SIGN NINDA2 TIMES SHE': 74330,
'CUNEIFORM SIGN NINDA2 TIMES SHE PLUS A AN': 74331,
'CUNEIFORM SIGN NINDA2 TIMES SHE PLUS ASH': 74332,
'CUNEIFORM SIGN NINDA2 TIMES SHE PLUS ASH PLUS ASH': 74333,
'CUNEIFORM SIGN NINDA2 TIMES U2 PLUS ASH': 74334,
'CUNEIFORM SIGN NINDA2 TIMES USH': 74335,
'CUNEIFORM SIGN NISAG': 74336,
'CUNEIFORM SIGN NU': 74337,
'CUNEIFORM SIGN NU11': 74338,
'CUNEIFORM SIGN NUN': 74339,
'CUNEIFORM SIGN NUN CROSSING NUN': 74347,
'CUNEIFORM SIGN NUN CROSSING NUN LAGAR OVER LAGAR': 74348,
'CUNEIFORM SIGN NUN LAGAR TIMES GAR': 74340,
'CUNEIFORM SIGN NUN LAGAR TIMES MASH': 74341,
'CUNEIFORM SIGN NUN LAGAR TIMES SAL': 74342,
'CUNEIFORM SIGN NUN LAGAR TIMES SAL OVER NUN LAGAR TIMES SAL': 74343,
'CUNEIFORM SIGN NUN LAGAR TIMES USH': 74344,
'CUNEIFORM SIGN NUN OVER NUN': 74346,
'CUNEIFORM SIGN NUN TENU': 74345,
'CUNEIFORM SIGN NUNUZ': 74349,
'CUNEIFORM SIGN NUNUZ AB2 TIMES ASHGAB': 74350,
'CUNEIFORM SIGN NUNUZ AB2 TIMES BI': 74351,
'CUNEIFORM SIGN NUNUZ AB2 TIMES DUG': 74352,
'CUNEIFORM SIGN NUNUZ AB2 TIMES GUD': 74353,
'CUNEIFORM SIGN NUNUZ AB2 TIMES IGI GUNU': 74354,
'CUNEIFORM SIGN NUNUZ AB2 TIMES KAD3': 74355,
'CUNEIFORM SIGN NUNUZ AB2 TIMES LA': 74356,
'CUNEIFORM SIGN NUNUZ AB2 TIMES NE': 74357,
'CUNEIFORM SIGN NUNUZ AB2 TIMES SILA3': 74358,
'CUNEIFORM SIGN NUNUZ AB2 TIMES U2': 74359,
'CUNEIFORM SIGN NUNUZ KISIM5 TIMES BI': 74360,
'CUNEIFORM SIGN NUNUZ KISIM5 TIMES BI U': 74361,
'CUNEIFORM SIGN PA': 74362,
'CUNEIFORM SIGN PAD': 74363,
'CUNEIFORM SIGN PAN': 74364,
'CUNEIFORM SIGN PAP': 74365,
'CUNEIFORM SIGN PESH2': 74366,
'CUNEIFORM SIGN PI': 74367,
'CUNEIFORM SIGN PI CROSSING PI': 74377,
'CUNEIFORM SIGN PI TIMES A': 74368,
'CUNEIFORM SIGN PI TIMES AB': 74369,
'CUNEIFORM SIGN PI TIMES BI': 74370,
'CUNEIFORM SIGN PI TIMES BU': 74371,
'CUNEIFORM SIGN PI TIMES E': 74372,
'CUNEIFORM SIGN PI TIMES I': 74373,
'CUNEIFORM SIGN PI TIMES IB': 74374,
'CUNEIFORM SIGN PI TIMES U': 74375,
'CUNEIFORM SIGN PI TIMES U2': 74376,
'CUNEIFORM SIGN PIRIG': 74378,
'CUNEIFORM SIGN PIRIG OPPOSING PIRIG': 74382,
'CUNEIFORM SIGN PIRIG TIMES KAL': 74379,
'CUNEIFORM SIGN PIRIG TIMES UD': 74380,
'CUNEIFORM SIGN PIRIG TIMES ZA': 74381,
'CUNEIFORM SIGN RA': 74383,
'CUNEIFORM SIGN RAB': 74384,
'CUNEIFORM SIGN RI': 74385,
'CUNEIFORM SIGN RU': 74386,
'CUNEIFORM SIGN SA': 74387,
'CUNEIFORM SIGN SAG': 74389,
'CUNEIFORM SIGN SAG GUNU': 74408,
'CUNEIFORM SIGN SAG NUTILLU': 74388,
'CUNEIFORM SIGN SAG OVER SAG': 74407,
'CUNEIFORM SIGN SAG TIMES A': 74390,
'CUNEIFORM SIGN SAG TIMES DU': 74391,
'CUNEIFORM SIGN SAG TIMES DUB': 74392,
'CUNEIFORM SIGN SAG TIMES HA': 74393,
'CUNEIFORM SIGN SAG TIMES KAK': 74394,
'CUNEIFORM SIGN SAG TIMES KUR': 74395,
'CUNEIFORM SIGN SAG TIMES LUM': 74396,
'CUNEIFORM SIGN SAG TIMES MI': 74397,
'CUNEIFORM SIGN SAG TIMES NUN': 74398,
'CUNEIFORM SIGN SAG TIMES SAL': 74399,
'CUNEIFORM SIGN SAG TIMES SHID': 74400,
'CUNEIFORM SIGN SAG TIMES TAB': 74401,
'CUNEIFORM SIGN SAG TIMES U2': 74402,
'CUNEIFORM SIGN SAG TIMES UB': 74403,
'CUNEIFORM SIGN SAG TIMES UM': 74404,
'CUNEIFORM SIGN SAG TIMES UR': 74405,
'CUNEIFORM SIGN SAG TIMES USH': 74406,
'CUNEIFORM SIGN SAL': 74409,
'CUNEIFORM SIGN SAL LAGAB TIMES ASH2': 74410,
'CUNEIFORM SIGN SANGA2': 74411,
'CUNEIFORM SIGN SAR': 74412,
'CUNEIFORM SIGN SHA': 74413,
'CUNEIFORM SIGN SHA3': 74414,
'CUNEIFORM SIGN SHA3 TIMES A': 74415,
'CUNEIFORM SIGN SHA3 TIMES BAD': 74416,
'CUNEIFORM SIGN SHA3 TIMES GISH': 74417,
'CUNEIFORM SIGN SHA3 TIMES NE': 74418,
'CUNEIFORM SIGN SHA3 TIMES SHU2': 74419,
'CUNEIFORM SIGN SHA3 TIMES TUR': 74420,
'CUNEIFORM SIGN SHA3 TIMES U': 74421,
'CUNEIFORM SIGN SHA3 TIMES U PLUS A': 74422,
'CUNEIFORM SIGN SHA6': 74423,
'CUNEIFORM SIGN SHAB6': 74424,
'CUNEIFORM SIGN SHAR2': 74425,
'CUNEIFORM SIGN SHE': 74426,
'CUNEIFORM SIGN SHE HU': 74427,
'CUNEIFORM SIGN SHE OVER SHE GAD OVER GAD GAR OVER GAR': 74428,
'CUNEIFORM SIGN SHE OVER SHE TAB OVER TAB GAR OVER GAR': 74429,
'CUNEIFORM SIGN SHEG9': 74430,
'CUNEIFORM SIGN SHEN': 74431,
'CUNEIFORM SIGN SHESH': 74432,
'CUNEIFORM SIGN SHESH2': 74433,
'CUNEIFORM SIGN SHESHLAM': 74434,
'CUNEIFORM SIGN SHID': 74435,
'CUNEIFORM SIGN SHID TIMES A': 74436,
'CUNEIFORM SIGN SHID TIMES IM': 74437,
'CUNEIFORM SIGN SHIM': 74438,
'CUNEIFORM SIGN SHIM TIMES A': 74439,
'CUNEIFORM SIGN SHIM TIMES BAL': 74440,
'CUNEIFORM SIGN SHIM TIMES BULUG': 74441,
'CUNEIFORM SIGN SHIM TIMES DIN': 74442,
'CUNEIFORM SIGN SHIM TIMES GAR': 74443,
'CUNEIFORM SIGN SHIM TIMES IGI': 74444,
'CUNEIFORM SIGN SHIM TIMES IGI GUNU': 74445,
'CUNEIFORM SIGN SHIM TIMES KUSHU2': 74446,
'CUNEIFORM SIGN SHIM TIMES LUL': 74447,
'CUNEIFORM SIGN SHIM TIMES MUG': 74448,
'CUNEIFORM SIGN SHIM TIMES SAL': 74449,
'CUNEIFORM SIGN SHINIG': 74450,
'CUNEIFORM SIGN SHIR': 74451,
'CUNEIFORM SIGN SHIR OVER SHIR BUR OVER BUR': 74453,
'CUNEIFORM SIGN SHIR TENU': 74452,
'CUNEIFORM SIGN SHITA': 74454,
'CUNEIFORM SIGN SHU': 74455,
'CUNEIFORM SIGN SHU OVER INVERTED SHU': 74456,
'CUNEIFORM SIGN SHU2': 74457,
'CUNEIFORM SIGN SHUBUR': 74458,
'CUNEIFORM SIGN SI': 74459,
'CUNEIFORM SIGN SI GUNU': 74460,
'CUNEIFORM SIGN SIG': 74461,
'CUNEIFORM SIGN SIG4': 74462,
'CUNEIFORM SIGN SIG4 OVER SIG4 SHU2': 74463,
'CUNEIFORM SIGN SIK2': 74464,
'CUNEIFORM SIGN SILA3': 74465,
'CUNEIFORM SIGN SU': 74466,
'CUNEIFORM SIGN SU OVER SU': 74467,
'CUNEIFORM SIGN SUD': 74468,
'CUNEIFORM SIGN SUD2': 74469,
'CUNEIFORM SIGN SUHUR': 74470,
'CUNEIFORM SIGN SUM': 74471,
'CUNEIFORM SIGN SUMASH': 74472,
'CUNEIFORM SIGN SUR': 74473,
'CUNEIFORM SIGN SUR9': 74474,
'CUNEIFORM SIGN TA': 74475,
'CUNEIFORM SIGN TA ASTERISK': 74476,
'CUNEIFORM SIGN TA GUNU': 74479,
'CUNEIFORM SIGN TA TIMES HI': 74477,
'CUNEIFORM SIGN TA TIMES MI': 74478,
'CUNEIFORM SIGN TAB': 74480,
'CUNEIFORM SIGN TAB OVER TAB NI OVER NI DISH OVER DISH': 74481,
'CUNEIFORM SIGN TAB SQUARED': 74482,
'CUNEIFORM SIGN TAG': 74483,
'CUNEIFORM SIGN TAG TIMES BI': 74484,
'CUNEIFORM SIGN TAG TIMES GUD': 74485,
'CUNEIFORM SIGN TAG TIMES SHE': 74486,
'CUNEIFORM SIGN TAG TIMES SHU': 74487,
'CUNEIFORM SIGN TAG TIMES TUG2': 74488,
'CUNEIFORM SIGN TAG TIMES UD': 74489,
'CUNEIFORM SIGN TAK4': 74490,
'CUNEIFORM SIGN TAR': 74491,
'CUNEIFORM SIGN TE': 74492,
'CUNEIFORM SIGN TE GUNU': 74493,
'CUNEIFORM SIGN TI': 74494,
'CUNEIFORM SIGN TI TENU': 74495,
'CUNEIFORM SIGN TIL': 74496,
'CUNEIFORM SIGN TIR': 74497,
'CUNEIFORM SIGN TIR OVER TIR': 74499,
'CUNEIFORM SIGN TIR OVER TIR GAD OVER GAD GAR OVER GAR': 74500,
'CUNEIFORM SIGN TIR TIMES TAK4': 74498,
'CUNEIFORM SIGN TU': 74501,
'CUNEIFORM SIGN TUG2': 74502,
'CUNEIFORM SIGN TUK': 74503,
'CUNEIFORM SIGN TUM': 74504,
'CUNEIFORM SIGN TUR': 74505,
'CUNEIFORM SIGN TUR OVER TUR ZA OVER ZA': 74506,
'CUNEIFORM SIGN U': 74507,
'CUNEIFORM SIGN U GUD': 74508,
'CUNEIFORM SIGN U OVER U PA OVER PA GAR OVER GAR': 74510,
'CUNEIFORM SIGN U OVER U SUR OVER SUR': 74511,
'CUNEIFORM SIGN U OVER U U REVERSED OVER U REVERSED': 74512,
'CUNEIFORM SIGN U U U': 74509,
'CUNEIFORM SIGN U2': 74513,
'CUNEIFORM SIGN UB': 74514,
'CUNEIFORM SIGN UD': 74515,
'CUNEIFORM SIGN UD GUNU': 74521,
'CUNEIFORM SIGN UD KUSHU2': 74516,
'CUNEIFORM SIGN UD SHESHIG': 74522,
'CUNEIFORM SIGN UD SHESHIG TIMES BAD': 74523,
'CUNEIFORM SIGN UD TIMES BAD': 74517,
'CUNEIFORM SIGN UD TIMES MI': 74518,
'CUNEIFORM SIGN UD TIMES U PLUS U PLUS U': 74519,
'CUNEIFORM SIGN UD TIMES U PLUS U PLUS U GUNU': 74520,
'CUNEIFORM SIGN UDUG': 74524,
'CUNEIFORM SIGN UM': 74525,
'CUNEIFORM SIGN UM TIMES LAGAB': 74526,
'CUNEIFORM SIGN UM TIMES ME PLUS DA': 74527,
'CUNEIFORM SIGN UM TIMES SHA3': 74528,
'CUNEIFORM SIGN UM TIMES U': 74529,
'CUNEIFORM SIGN UMBIN': 74530,
'CUNEIFORM SIGN UMUM': 74531,
'CUNEIFORM SIGN UMUM TIMES KASKAL': 74532,
'CUNEIFORM SIGN UMUM TIMES PA': 74533,
'CUNEIFORM SIGN UN': 74534,
'CUNEIFORM SIGN UN GUNU': 74535,
'CUNEIFORM SIGN UR': 74536,
'CUNEIFORM SIGN UR CROSSING UR': 74537,
'CUNEIFORM SIGN UR SHESHIG': 74538,
'CUNEIFORM SIGN UR2': 74539,
'CUNEIFORM SIGN UR2 TIMES A PLUS HA': 74540,
'CUNEIFORM SIGN UR2 TIMES A PLUS NA': 74541,
'CUNEIFORM SIGN UR2 TIMES AL': 74542,
'CUNEIFORM SIGN UR2 TIMES HA': 74543,
'CUNEIFORM SIGN UR2 TIMES NUN': 74544,
'CUNEIFORM SIGN UR2 TIMES U2': 74545,
'CUNEIFORM SIGN UR2 TIMES U2 PLUS ASH': 74546,
'CUNEIFORM SIGN UR2 TIMES U2 PLUS BI': 74547,
'CUNEIFORM SIGN UR4': 74548,
'CUNEIFORM SIGN URI': 74549,
'CUNEIFORM SIGN URI3': 74550,
'CUNEIFORM SIGN URU': 74551,
'CUNEIFORM SIGN URU TIMES A': 74552,
'CUNEIFORM SIGN URU TIMES ASHGAB': 74553,
'CUNEIFORM SIGN URU TIMES BAR': 74554,
'CUNEIFORM SIGN URU TIMES DUN': 74555,
'CUNEIFORM SIGN URU TIMES GA': 74556,
'CUNEIFORM SIGN URU TIMES GAL': 74557,
'CUNEIFORM SIGN URU TIMES GAN2 TENU': 74558,
'CUNEIFORM SIGN URU TIMES GAR': 74559,
'CUNEIFORM SIGN URU TIMES GU': 74560,
'CUNEIFORM SIGN URU TIMES HA': 74561,
'CUNEIFORM SIGN URU TIMES IGI': 74562,
'CUNEIFORM SIGN URU TIMES IM': 74563,
'CUNEIFORM SIGN URU TIMES ISH': 74564,
'CUNEIFORM SIGN URU TIMES KI': 74565,
'CUNEIFORM SIGN URU TIMES LUM': 74566,
'CUNEIFORM SIGN URU TIMES MIN': 74567,
'CUNEIFORM SIGN URU TIMES PA': 74568,
'CUNEIFORM SIGN URU TIMES SHE': 74569,
'CUNEIFORM SIGN URU TIMES SIG4': 74570,
'CUNEIFORM SIGN URU TIMES TU': 74571,
'CUNEIFORM SIGN URU TIMES U PLUS GUD': 74572,
'CUNEIFORM SIGN URU TIMES UD': 74573,
'CUNEIFORM SIGN URU TIMES URUDA': 74574,
'CUNEIFORM SIGN URUDA': 74575,
'CUNEIFORM SIGN URUDA TIMES U': 74576,
'CUNEIFORM SIGN USH': 74577,
'CUNEIFORM SIGN USH TIMES A': 74578,
'CUNEIFORM SIGN USH TIMES KU': 74579,
'CUNEIFORM SIGN USH TIMES KUR': 74580,
'CUNEIFORM SIGN USH TIMES TAK4': 74581,
'CUNEIFORM SIGN USH2': 74583,
'CUNEIFORM SIGN USHUMX': 74584,
'CUNEIFORM SIGN USHX': 74582,
'CUNEIFORM SIGN UTUKI': 74585,
'CUNEIFORM SIGN UZ3': 74586,
'CUNEIFORM SIGN UZ3 TIMES KASKAL': 74587,
'CUNEIFORM SIGN UZU': 74588,
'CUNEIFORM SIGN ZA': 74589,
'CUNEIFORM SIGN ZA SQUARED TIMES KUR': 74591,
'CUNEIFORM SIGN ZA TENU': 74590,
'CUNEIFORM SIGN ZAG': 74592,
'CUNEIFORM SIGN ZAMX': 74593,
'CUNEIFORM SIGN ZE2': 74594,
'CUNEIFORM SIGN ZI': 74595,
'CUNEIFORM SIGN ZI OVER ZI': 74596,
'CUNEIFORM SIGN ZI3': 74597,
'CUNEIFORM SIGN ZIB': 74598,
'CUNEIFORM SIGN ZIB KABA TENU': 74599,
'CUNEIFORM SIGN ZIG': 74600,
'CUNEIFORM SIGN ZIZ2': 74601,
'CUNEIFORM SIGN ZU': 74602,
'CUNEIFORM SIGN ZU5': 74603,
'CUNEIFORM SIGN ZU5 TIMES A': 74604,
'CUNEIFORM SIGN ZUBUR': 74605,
'CUNEIFORM SIGN ZUM': 74606,
'CUP ON BLACK SQUARE': 9982,
'CURLY BRACKET EXTENSION': 9130,
'CURLY LOGICAL AND': 8911,
'CURLY LOGICAL OR': 8910,
'CURRENCY SIGN': 164,
'CURVED STEM PARAGRAPH SIGN ORNAMENT': 10081,
'CYLINDRICITY': 9005,
'CYPRIOT SYLLABLE A': 67584,
'CYPRIOT SYLLABLE E': 67585,
'CYPRIOT SYLLABLE I': 67586,
'CYPRIOT SYLLABLE JA': 67589,
'CYPRIOT SYLLABLE JO': 67592,
'CYPRIOT SYLLABLE KA': 67594,
'CYPRIOT SYLLABLE KE': 67595,
'CYPRIOT SYLLABLE KI': 67596,
'CYPRIOT SYLLABLE KO': 67597,
'CYPRIOT SYLLABLE KU': 67598,
'CYPRIOT SYLLABLE LA': 67599,
'CYPRIOT SYLLABLE LE': 67600,
'CYPRIOT SYLLABLE LI': 67601,
'CYPRIOT SYLLABLE LO': 67602,
'CYPRIOT SYLLABLE LU': 67603,
'CYPRIOT SYLLABLE MA': 67604,
'CYPRIOT SYLLABLE ME': 67605,
'CYPRIOT SYLLABLE MI': 67606,
'CYPRIOT SYLLABLE MO': 67607,
'CYPRIOT SYLLABLE MU': 67608,
'CYPRIOT SYLLABLE NA': 67609,
'CYPRIOT SYLLABLE NE': 67610,
'CYPRIOT SYLLABLE NI': 67611,
'CYPRIOT SYLLABLE NO': 67612,
'CYPRIOT SYLLABLE NU': 67613,
'CYPRIOT SYLLABLE O': 67587,
'CYPRIOT SYLLABLE PA': 67614,
'CYPRIOT SYLLABLE PE': 67615,
'CYPRIOT SYLLABLE PI': 67616,
'CYPRIOT SYLLABLE PO': 67617,
'CYPRIOT SYLLABLE PU': 67618,
'CYPRIOT SYLLABLE RA': 67619,
'CYPRIOT SYLLABLE RE': 67620,
'CYPRIOT SYLLABLE RI': 67621,
'CYPRIOT SYLLABLE RO': 67622,
'CYPRIOT SYLLABLE RU': 67623,
'CYPRIOT SYLLABLE SA': 67624,
'CYPRIOT SYLLABLE SE': 67625,
'CYPRIOT SYLLABLE SI': 67626,
'CYPRIOT SYLLABLE SO': 67627,
'CYPRIOT SYLLABLE SU': 67628,
'CYPRIOT SYLLABLE TA': 67629,
'CYPRIOT SYLLABLE TE': 67630,
'CYPRIOT SYLLABLE TI': 67631,
'CYPRIOT SYLLABLE TO': 67632,
'CYPRIOT SYLLABLE TU': 67633,
'CYPRIOT SYLLABLE U': 67588,
'CYPRIOT SYLLABLE WA': 67634,
'CYPRIOT SYLLABLE WE': 67635,
'CYPRIOT SYLLABLE WI': 67636,
'CYPRIOT SYLLABLE WO': 67637,
'CYPRIOT SYLLABLE XA': 67639,
'CYPRIOT SYLLABLE XE': 67640,
'CYPRIOT SYLLABLE ZA': 67644,
'CYPRIOT SYLLABLE ZO': 67647,
'CYRILLIC CAPITAL LETTER A': 1040,
'CYRILLIC CAPITAL LETTER A WITH BREVE': 1232,
'CYRILLIC CAPITAL LETTER A WITH DIAERESIS': 1234,
'CYRILLIC CAPITAL LETTER ABKHASIAN CHE': 1212,
'CYRILLIC CAPITAL LETTER ABKHASIAN CHE WITH DESCENDER': 1214,
'CYRILLIC CAPITAL LETTER ABKHASIAN DZE': 1248,
'CYRILLIC CAPITAL LETTER ABKHASIAN HA': 1192,
'CYRILLIC CAPITAL LETTER ALEUT KA': 1310,
'CYRILLIC CAPITAL LETTER BARRED O': 1256,
'CYRILLIC CAPITAL LETTER BARRED O WITH DIAERESIS': 1258,
'CYRILLIC CAPITAL LETTER BASHKIR KA': 1184,
'CYRILLIC CAPITAL LETTER BE': 1041,
'CYRILLIC CAPITAL LETTER BIG YUS': 1130,
'CYRILLIC CAPITAL LETTER BINOCULAR O': 42602,
'CYRILLIC CAPITAL LETTER BLENDED YUS': 42586,
'CYRILLIC CAPITAL LETTER BROAD OMEGA': 42572,
'CYRILLIC CAPITAL LETTER BYELORUSSIAN-UKRAINIAN I': 1030,
'CYRILLIC CAPITAL LETTER CCHE': 42630,
'CYRILLIC CAPITAL LETTER CHE': 1063,
'CYRILLIC CAPITAL LETTER CHE WITH DESCENDER': 1206,
'CYRILLIC CAPITAL LETTER CHE WITH DIAERESIS': 1268,
'CYRILLIC CAPITAL LETTER CHE WITH VERTICAL STROKE': 1208,
'CYRILLIC CAPITAL LETTER CLOSED LITTLE YUS': 42584,
'CYRILLIC CAPITAL LETTER DE': 1044,
'CYRILLIC CAPITAL LETTER DJE': 1026,
'CYRILLIC CAPITAL LETTER DJERV': 42568,
'CYRILLIC CAPITAL LETTER DOUBLE MONOCULAR O': 42604,
'CYRILLIC CAPITAL LETTER DWE': 42624,
'CYRILLIC CAPITAL LETTER DZE': 1029,
'CYRILLIC CAPITAL LETTER DZELO': 42562,
'CYRILLIC CAPITAL LETTER DZHE': 1039,
'CYRILLIC CAPITAL LETTER DZWE': 42626,
'CYRILLIC CAPITAL LETTER DZZE': 42632,
'CYRILLIC CAPITAL LETTER E': 1069,
'CYRILLIC CAPITAL LETTER E WITH DIAERESIS': 1260,
'CYRILLIC CAPITAL LETTER EF': 1060,
'CYRILLIC CAPITAL LETTER EL': 1051,
'CYRILLIC CAPITAL LETTER EL WITH HOOK': 1298,
'CYRILLIC CAPITAL LETTER EL WITH MIDDLE HOOK': 1312,
'CYRILLIC CAPITAL LETTER EL WITH TAIL': 1221,
'CYRILLIC CAPITAL LETTER EM': 1052,
'CYRILLIC CAPITAL LETTER EM WITH TAIL': 1229,
'CYRILLIC CAPITAL LETTER EN': 1053,
'CYRILLIC CAPITAL LETTER EN WITH DESCENDER': 1186,
'CYRILLIC CAPITAL LETTER EN WITH HOOK': 1223,
'CYRILLIC CAPITAL LETTER EN WITH MIDDLE HOOK': 1314,
'CYRILLIC CAPITAL LETTER EN WITH TAIL': 1225,
'CYRILLIC CAPITAL LETTER ER': 1056,
'CYRILLIC CAPITAL LETTER ER WITH TICK': 1166,
'CYRILLIC CAPITAL LETTER ES': 1057,
'CYRILLIC CAPITAL LETTER ES WITH DESCENDER': 1194,
'CYRILLIC CAPITAL LETTER FITA': 1138,
'CYRILLIC CAPITAL LETTER GHE': 1043,
'CYRILLIC CAPITAL LETTER GHE WITH DESCENDER': 1270,
'CYRILLIC CAPITAL LETTER GHE WITH MIDDLE HOOK': 1172,
'CYRILLIC CAPITAL LETTER GHE WITH STROKE': 1170,
'CYRILLIC CAPITAL LETTER GHE WITH STROKE AND HOOK': 1274,
'CYRILLIC CAPITAL LETTER GHE WITH UPTURN': 1168,
'CYRILLIC CAPITAL LETTER GJE': 1027,
'CYRILLIC CAPITAL LETTER HA': 1061,
'CYRILLIC CAPITAL LETTER HA WITH DESCENDER': 1202,
'CYRILLIC CAPITAL LETTER HA WITH HOOK': 1276,
'CYRILLIC CAPITAL LETTER HA WITH STROKE': 1278,
'CYRILLIC CAPITAL LETTER HARD SIGN': 1066,
'CYRILLIC CAPITAL LETTER HWE': 42644,
'CYRILLIC CAPITAL LETTER I': 1048,
'CYRILLIC CAPITAL LETTER I WITH DIAERESIS': 1252,
'CYRILLIC CAPITAL LETTER I WITH GRAVE': 1037,
'CYRILLIC CAPITAL LETTER I WITH MACRON': 1250,
'CYRILLIC CAPITAL LETTER IE': 1045,
'CYRILLIC CAPITAL LETTER IE WITH BREVE': 1238,
'CYRILLIC CAPITAL LETTER IE WITH GRAVE': 1024,
'CYRILLIC CAPITAL LETTER IO': 1025,
'CYRILLIC CAPITAL LETTER IOTA': 42566,
'CYRILLIC CAPITAL LETTER IOTIFIED A': 42582,
'CYRILLIC CAPITAL LETTER IOTIFIED BIG YUS': 1132,
'CYRILLIC CAPITAL LETTER IOTIFIED CLOSED LITTLE YUS': 42588,
'CYRILLIC CAPITAL LETTER IOTIFIED E': 1124,
'CYRILLIC CAPITAL LETTER IOTIFIED LITTLE YUS': 1128,
'CYRILLIC CAPITAL LETTER IOTIFIED YAT': 42578,
'CYRILLIC CAPITAL LETTER IZHITSA': 1140,
'CYRILLIC CAPITAL LETTER IZHITSA WITH DOUBLE GRAVE ACCENT': 1142,
'CYRILLIC CAPITAL LETTER JE': 1032,
'CYRILLIC CAPITAL LETTER KA': 1050,
'CYRILLIC CAPITAL LETTER KA WITH DESCENDER': 1178,
'CYRILLIC CAPITAL LETTER KA WITH HOOK': 1219,
'CYRILLIC CAPITAL LETTER KA WITH STROKE': 1182,
'CYRILLIC CAPITAL LETTER KA WITH VERTICAL STROKE': 1180,
'CYRILLIC CAPITAL LETTER KHAKASSIAN CHE': 1227,
'CYRILLIC CAPITAL LETTER KJE': 1036,
'CYRILLIC CAPITAL LETTER KOMI DE': 1280,
'CYRILLIC CAPITAL LETTER KOMI DJE': 1282,
'CYRILLIC CAPITAL LETTER KOMI DZJE': 1286,
'CYRILLIC CAPITAL LETTER KOMI LJE': 1288,
'CYRILLIC CAPITAL LETTER KOMI NJE': 1290,
'CYRILLIC CAPITAL LETTER KOMI SJE': 1292,
'CYRILLIC CAPITAL LETTER KOMI TJE': 1294,
'CYRILLIC CAPITAL LETTER KOMI ZJE': 1284,
'CYRILLIC CAPITAL LETTER KOPPA': 1152,
'CYRILLIC CAPITAL LETTER KSI': 1134,
'CYRILLIC CAPITAL LETTER LHA': 1300,
'CYRILLIC CAPITAL LETTER LITTLE YUS': 1126,
'CYRILLIC CAPITAL LETTER LJE': 1033,
'CYRILLIC CAPITAL LETTER MONOCULAR O': 42600,
'CYRILLIC CAPITAL LETTER MONOGRAPH UK': 42570,
'CYRILLIC CAPITAL LETTER NEUTRAL YER': 42574,
'CYRILLIC CAPITAL LETTER NJE': 1034,
'CYRILLIC CAPITAL LETTER O': 1054,
'CYRILLIC CAPITAL LETTER O WITH DIAERESIS': 1254,
'CYRILLIC CAPITAL LETTER OMEGA': 1120,
'CYRILLIC CAPITAL LETTER OMEGA WITH TITLO': 1148,
'CYRILLIC CAPITAL LETTER OT': 1150,
'CYRILLIC CAPITAL LETTER PE': 1055,
'CYRILLIC CAPITAL LETTER PE WITH DESCENDER': 1316,
'CYRILLIC CAPITAL LETTER PE WITH MIDDLE HOOK': 1190,
'CYRILLIC CAPITAL LETTER PSI': 1136,
'CYRILLIC CAPITAL LETTER QA': 1306,
'CYRILLIC CAPITAL LETTER REVERSED DZE': 42564,
'CYRILLIC CAPITAL LETTER REVERSED YU': 42580,
'CYRILLIC CAPITAL LETTER REVERSED ZE': 1296,
'CYRILLIC CAPITAL LETTER RHA': 1302,
'CYRILLIC CAPITAL LETTER ROUND OMEGA': 1146,
'CYRILLIC CAPITAL LETTER SCHWA': 1240,
'CYRILLIC CAPITAL LETTER SCHWA WITH DIAERESIS': 1242,
'CYRILLIC CAPITAL LETTER SEMISOFT SIGN': 1164,
'CYRILLIC CAPITAL LETTER SHA': 1064,
'CYRILLIC CAPITAL LETTER SHCHA': 1065,
'CYRILLIC CAPITAL LETTER SHHA': 1210,
'CYRILLIC CAPITAL LETTER SHORT I': 1049,
'CYRILLIC CAPITAL LETTER SHORT I WITH TAIL': 1162,
'CYRILLIC CAPITAL LETTER SHORT U': 1038,
'CYRILLIC CAPITAL LETTER SHWE': 42646,
'CYRILLIC CAPITAL LETTER SOFT DE': 42594,
'CYRILLIC CAPITAL LETTER SOFT EL': 42596,
'CYRILLIC CAPITAL LETTER SOFT EM': 42598,
'CYRILLIC CAPITAL LETTER SOFT SIGN': 1068,
'CYRILLIC CAPITAL LETTER STRAIGHT U': 1198,
'CYRILLIC CAPITAL LETTER STRAIGHT U WITH STROKE': 1200,
'CYRILLIC CAPITAL LETTER TCHE': 42642,
'CYRILLIC CAPITAL LETTER TE': 1058,
'CYRILLIC CAPITAL LETTER TE WITH DESCENDER': 1196,
'CYRILLIC CAPITAL LETTER TE WITH MIDDLE HOOK': 42634,
'CYRILLIC CAPITAL LETTER TSE': 1062,
'CYRILLIC CAPITAL LETTER TSHE': 1035,
'CYRILLIC CAPITAL LETTER TSSE': 42640,
'CYRILLIC CAPITAL LETTER TSWE': 42638,
'CYRILLIC CAPITAL LETTER TWE': 42636,
'CYRILLIC CAPITAL LETTER U': 1059,
'CYRILLIC CAPITAL LETTER U WITH DIAERESIS': 1264,
'CYRILLIC CAPITAL LETTER U WITH DOUBLE ACUTE': 1266,
'CYRILLIC CAPITAL LETTER U WITH MACRON': 1262,
'CYRILLIC CAPITAL LETTER UK': 1144,
'CYRILLIC CAPITAL LETTER UKRAINIAN IE': 1028,
'CYRILLIC CAPITAL LETTER VE': 1042,
'CYRILLIC CAPITAL LETTER WE': 1308,
'CYRILLIC CAPITAL LETTER YA': 1071,
'CYRILLIC CAPITAL LETTER YAE': 1304,
'CYRILLIC CAPITAL LETTER YAT': 1122,
'CYRILLIC CAPITAL LETTER YERU': 1067,
'CYRILLIC CAPITAL LETTER YERU WITH BACK YER': 42576,
'CYRILLIC CAPITAL LETTER YERU WITH DIAERESIS': 1272,
'CYRILLIC CAPITAL LETTER YI': 1031,
'CYRILLIC CAPITAL LETTER YN': 42590,
'CYRILLIC CAPITAL LETTER YU': 1070,
'CYRILLIC CAPITAL LETTER ZE': 1047,
'CYRILLIC CAPITAL LETTER ZE WITH DESCENDER': 1176,
'CYRILLIC CAPITAL LETTER ZE WITH DIAERESIS': 1246,
'CYRILLIC CAPITAL LETTER ZEMLYA': 42560,
'CYRILLIC CAPITAL LETTER ZHE': 1046,
'CYRILLIC CAPITAL LETTER ZHE WITH BREVE': 1217,
'CYRILLIC CAPITAL LETTER ZHE WITH DESCENDER': 1174,
'CYRILLIC CAPITAL LETTER ZHE WITH DIAERESIS': 1244,
'CYRILLIC CAPITAL LETTER ZHWE': 42628,
'CYRILLIC CAPITAL LIGATURE A IE': 1236,
'CYRILLIC CAPITAL LIGATURE EN GHE': 1188,
'CYRILLIC CAPITAL LIGATURE TE TSE': 1204,
'CYRILLIC KAVYKA': 42622,
'CYRILLIC LETTER MULTIOCULAR O': 42606,
'CYRILLIC LETTER PALOCHKA': 1216,
'CYRILLIC LETTER SMALL CAPITAL EL': 7467,
'CYRILLIC PAYEROK': 42623,
'CYRILLIC SMALL LETTER A': 1072,
'CYRILLIC SMALL LETTER A WITH BREVE': 1233,
'CYRILLIC SMALL LETTER A WITH DIAERESIS': 1235,
'CYRILLIC SMALL LETTER ABKHASIAN CHE': 1213,
'CYRILLIC SMALL LETTER ABKHASIAN CHE WITH DESCENDER': 1215,
'CYRILLIC SMALL LETTER ABKHASIAN DZE': 1249,
'CYRILLIC SMALL LETTER ABKHASIAN HA': 1193,
'CYRILLIC SMALL LETTER ALEUT KA': 1311,
'CYRILLIC SMALL LETTER BARRED O': 1257,
'CYRILLIC SMALL LETTER BARRED O WITH DIAERESIS': 1259,
'CYRILLIC SMALL LETTER BASHKIR KA': 1185,
'CYRILLIC SMALL LETTER BE': 1073,
'CYRILLIC SMALL LETTER BIG YUS': 1131,
'CYRILLIC SMALL LETTER BINOCULAR O': 42603,
'CYRILLIC SMALL LETTER BLENDED YUS': 42587,
'CYRILLIC SMALL LETTER BROAD OMEGA': 42573,
'CYRILLIC SMALL LETTER BYELORUSSIAN-UKRAINIAN I': 1110,
'CYRILLIC SMALL LETTER CCHE': 42631,
'CYRILLIC SMALL LETTER CHE': 1095,
'CYRILLIC SMALL LETTER CHE WITH DESCENDER': 1207,
'CYRILLIC SMALL LETTER CHE WITH DIAERESIS': 1269,
'CYRILLIC SMALL LETTER CHE WITH VERTICAL STROKE': 1209,
'CYRILLIC SMALL LETTER CLOSED LITTLE YUS': 42585,
'CYRILLIC SMALL LETTER DE': 1076,
'CYRILLIC SMALL LETTER DJE': 1106,
'CYRILLIC SMALL LETTER DJERV': 42569,
'CYRILLIC SMALL LETTER DOUBLE MONOCULAR O': 42605,
'CYRILLIC SMALL LETTER DWE': 42625,
'CYRILLIC SMALL LETTER DZE': 1109,
'CYRILLIC SMALL LETTER DZELO': 42563,
'CYRILLIC SMALL LETTER DZHE': 1119,
'CYRILLIC SMALL LETTER DZWE': 42627,
'CYRILLIC SMALL LETTER DZZE': 42633,
'CYRILLIC SMALL LETTER E': 1101,
'CYRILLIC SMALL LETTER E WITH DIAERESIS': 1261,
'CYRILLIC SMALL LETTER EF': 1092,
'CYRILLIC SMALL LETTER EL': 1083,
'CYRILLIC SMALL LETTER EL WITH HOOK': 1299,
'CYRILLIC SMALL LETTER EL WITH MIDDLE HOOK': 1313,
'CYRILLIC SMALL LETTER EL WITH TAIL': 1222,
'CYRILLIC SMALL LETTER EM': 1084,
'CYRILLIC SMALL LETTER EM WITH TAIL': 1230,
'CYRILLIC SMALL LETTER EN': 1085,
'CYRILLIC SMALL LETTER EN WITH DESCENDER': 1187,
'CYRILLIC SMALL LETTER EN WITH HOOK': 1224,
'CYRILLIC SMALL LETTER EN WITH MIDDLE HOOK': 1315,
'CYRILLIC SMALL LETTER EN WITH TAIL': 1226,
'CYRILLIC SMALL LETTER ER': 1088,
'CYRILLIC SMALL LETTER ER WITH TICK': 1167,
'CYRILLIC SMALL LETTER ES': 1089,
'CYRILLIC SMALL LETTER ES WITH DESCENDER': 1195,
'CYRILLIC SMALL LETTER FITA': 1139,
'CYRILLIC SMALL LETTER GHE': 1075,
'CYRILLIC SMALL LETTER GHE WITH DESCENDER': 1271,
'CYRILLIC SMALL LETTER GHE WITH MIDDLE HOOK': 1173,
'CYRILLIC SMALL LETTER GHE WITH STROKE': 1171,
'CYRILLIC SMALL LETTER GHE WITH STROKE AND HOOK': 1275,
'CYRILLIC SMALL LETTER GHE WITH UPTURN': 1169,
'CYRILLIC SMALL LETTER GJE': 1107,
'CYRILLIC SMALL LETTER HA': 1093,
'CYRILLIC SMALL LETTER HA WITH DESCENDER': 1203,
'CYRILLIC SMALL LETTER HA WITH HOOK': 1277,
'CYRILLIC SMALL LETTER HA WITH STROKE': 1279,
'CYRILLIC SMALL LETTER HARD SIGN': 1098,
'CYRILLIC SMALL LETTER HWE': 42645,
'CYRILLIC SMALL LETTER I': 1080,
'CYRILLIC SMALL LETTER I WITH DIAERESIS': 1253,
'CYRILLIC SMALL LETTER I WITH GRAVE': 1117,
'CYRILLIC SMALL LETTER I WITH MACRON': 1251,
'CYRILLIC SMALL LETTER IE': 1077,
'CYRILLIC SMALL LETTER IE WITH BREVE': 1239,
'CYRILLIC SMALL LETTER IE WITH GRAVE': 1104,
'CYRILLIC SMALL LETTER IO': 1105,
'CYRILLIC SMALL LETTER IOTA': 42567,
'CYRILLIC SMALL LETTER IOTIFIED A': 42583,
'CYRILLIC SMALL LETTER IOTIFIED BIG YUS': 1133,
'CYRILLIC SMALL LETTER IOTIFIED CLOSED LITTLE YUS': 42589,
'CYRILLIC SMALL LETTER IOTIFIED E': 1125,
'CYRILLIC SMALL LETTER IOTIFIED LITTLE YUS': 1129,
'CYRILLIC SMALL LETTER IOTIFIED YAT': 42579,
'CYRILLIC SMALL LETTER IZHITSA': 1141,
'CYRILLIC SMALL LETTER IZHITSA WITH DOUBLE GRAVE ACCENT': 1143,
'CYRILLIC SMALL LETTER JE': 1112,
'CYRILLIC SMALL LETTER KA': 1082,
'CYRILLIC SMALL LETTER KA WITH DESCENDER': 1179,
'CYRILLIC SMALL LETTER KA WITH HOOK': 1220,
'CYRILLIC SMALL LETTER KA WITH STROKE': 1183,
'CYRILLIC SMALL LETTER KA WITH VERTICAL STROKE': 1181,
'CYRILLIC SMALL LETTER KHAKASSIAN CHE': 1228,
'CYRILLIC SMALL LETTER KJE': 1116,
'CYRILLIC SMALL LETTER KOMI DE': 1281,
'CYRILLIC SMALL LETTER KOMI DJE': 1283,
'CYRILLIC SMALL LETTER KOMI DZJE': 1287,
'CYRILLIC SMALL LETTER KOMI LJE': 1289,
'CYRILLIC SMALL LETTER KOMI NJE': 1291,
'CYRILLIC SMALL LETTER KOMI SJE': 1293,
'CYRILLIC SMALL LETTER KOMI TJE': 1295,
'CYRILLIC SMALL LETTER KOMI ZJE': 1285,
'CYRILLIC SMALL LETTER KOPPA': 1153,
'CYRILLIC SMALL LETTER KSI': 1135,
'CYRILLIC SMALL LETTER LHA': 1301,
'CYRILLIC SMALL LETTER LITTLE YUS': 1127,
'CYRILLIC SMALL LETTER LJE': 1113,
'CYRILLIC SMALL LETTER MONOCULAR O': 42601,
'CYRILLIC SMALL LETTER MONOGRAPH UK': 42571,
'CYRILLIC SMALL LETTER NEUTRAL YER': 42575,
'CYRILLIC SMALL LETTER NJE': 1114,
'CYRILLIC SMALL LETTER O': 1086,
'CYRILLIC SMALL LETTER O WITH DIAERESIS': 1255,
'CYRILLIC SMALL LETTER OMEGA': 1121,
'CYRILLIC SMALL LETTER OMEGA WITH TITLO': 1149,
'CYRILLIC SMALL LETTER OT': 1151,
'CYRILLIC SMALL LETTER PALOCHKA': 1231,
'CYRILLIC SMALL LETTER PE': 1087,
'CYRILLIC SMALL LETTER PE WITH DESCENDER': 1317,
'CYRILLIC SMALL LETTER PE WITH MIDDLE HOOK': 1191,
'CYRILLIC SMALL LETTER PSI': 1137,
'CYRILLIC SMALL LETTER QA': 1307,
'CYRILLIC SMALL LETTER REVERSED DZE': 42565,
'CYRILLIC SMALL LETTER REVERSED YU': 42581,
'CYRILLIC SMALL LETTER REVERSED ZE': 1297,
'CYRILLIC SMALL LETTER RHA': 1303,
'CYRILLIC SMALL LETTER ROUND OMEGA': 1147,
'CYRILLIC SMALL LETTER SCHWA': 1241,
'CYRILLIC SMALL LETTER SCHWA WITH DIAERESIS': 1243,
'CYRILLIC SMALL LETTER SEMISOFT SIGN': 1165,
'CYRILLIC SMALL LETTER SHA': 1096,
'CYRILLIC SMALL LETTER SHCHA': 1097,
'CYRILLIC SMALL LETTER SHHA': 1211,
'CYRILLIC SMALL LETTER SHORT I': 1081,
'CYRILLIC SMALL LETTER SHORT I WITH TAIL': 1163,
'CYRILLIC SMALL LETTER SHORT U': 1118,
'CYRILLIC SMALL LETTER SHWE': 42647,
'CYRILLIC SMALL LETTER SOFT DE': 42595,
'CYRILLIC SMALL LETTER SOFT EL': 42597,
'CYRILLIC SMALL LETTER SOFT EM': 42599,
'CYRILLIC SMALL LETTER SOFT SIGN': 1100,
'CYRILLIC SMALL LETTER STRAIGHT U': 1199,
'CYRILLIC SMALL LETTER STRAIGHT U WITH STROKE': 1201,
'CYRILLIC SMALL LETTER TCHE': 42643,
'CYRILLIC SMALL LETTER TE': 1090,
'CYRILLIC SMALL LETTER TE WITH DESCENDER': 1197,
'CYRILLIC SMALL LETTER TE WITH MIDDLE HOOK': 42635,
'CYRILLIC SMALL LETTER TSE': 1094,
'CYRILLIC SMALL LETTER TSHE': 1115,
'CYRILLIC SMALL LETTER TSSE': 42641,
'CYRILLIC SMALL LETTER TSWE': 42639,
'CYRILLIC SMALL LETTER TWE': 42637,
'CYRILLIC SMALL LETTER U': 1091,
'CYRILLIC SMALL LETTER U WITH DIAERESIS': 1265,
'CYRILLIC SMALL LETTER U WITH DOUBLE ACUTE': 1267,
'CYRILLIC SMALL LETTER U WITH MACRON': 1263,
'CYRILLIC SMALL LETTER UK': 1145,
'CYRILLIC SMALL LETTER UKRAINIAN IE': 1108,
'CYRILLIC SMALL LETTER VE': 1074,
'CYRILLIC SMALL LETTER WE': 1309,
'CYRILLIC SMALL LETTER YA': 1103,
'CYRILLIC SMALL LETTER YAE': 1305,
'CYRILLIC SMALL LETTER YAT': 1123,
'CYRILLIC SMALL LETTER YERU': 1099,
'CYRILLIC SMALL LETTER YERU WITH BACK YER': 42577,
'CYRILLIC SMALL LETTER YERU WITH DIAERESIS': 1273,
'CYRILLIC SMALL LETTER YI': 1111,
'CYRILLIC SMALL LETTER YN': 42591,
'CYRILLIC SMALL LETTER YU': 1102,
'CYRILLIC SMALL LETTER ZE': 1079,
'CYRILLIC SMALL LETTER ZE WITH DESCENDER': 1177,
'CYRILLIC SMALL LETTER ZE WITH DIAERESIS': 1247,
'CYRILLIC SMALL LETTER ZEMLYA': 42561,
'CYRILLIC SMALL LETTER ZHE': 1078,
'CYRILLIC SMALL LETTER ZHE WITH BREVE': 1218,
'CYRILLIC SMALL LETTER ZHE WITH DESCENDER': 1175,
'CYRILLIC SMALL LETTER ZHE WITH DIAERESIS': 1245,
'CYRILLIC SMALL LETTER ZHWE': 42629,
'CYRILLIC SMALL LIGATURE A IE': 1237,
'CYRILLIC SMALL LIGATURE EN GHE': 1189,
'CYRILLIC SMALL LIGATURE TE TSE': 1205,
'CYRILLIC THOUSANDS SIGN': 1154,
'DAGGER': 8224,
'DALET SYMBOL': 8504,
'DARK SHADE': 9619,
'DASHED LOW LINE': 65101,
'DASHED OVERLINE': 65097,
'DASHED TRIANGLE-HEADED RIGHTWARDS ARROW': 10143,
'DECIMAL EXPONENT SYMBOL': 9192,
'DECIMAL SEPARATOR KEY SYMBOL': 9110,
'DEGREE CELSIUS': 8451,
'DEGREE FAHRENHEIT': 8457,
'DEGREE SIGN': 176,
'DELTA EQUAL TO': 8796,
'DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL': 9161,
'DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL WITH CIRCLE': 9153,
'DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL WITH TRIANGLE': 9156,
'DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL WITH WAVE': 9159,
'DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL': 9162,
'DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL WITH CIRCLE': 9154,
'DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL WITH TRIANGLE': 9157,
'DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL WITH WAVE': 9160,
'DENTISTRY SYMBOL LIGHT VERTICAL AND BOTTOM LEFT': 9164,
'DENTISTRY SYMBOL LIGHT VERTICAL AND BOTTOM RIGHT': 9151,
'DENTISTRY SYMBOL LIGHT VERTICAL AND TOP LEFT': 9163,
'DENTISTRY SYMBOL LIGHT VERTICAL AND TOP RIGHT': 9150,
'DENTISTRY SYMBOL LIGHT VERTICAL AND WAVE': 9158,
'DENTISTRY SYMBOL LIGHT VERTICAL WITH CIRCLE': 9152,
'DENTISTRY SYMBOL LIGHT VERTICAL WITH TRIANGLE': 9155,
'DESCENDING NODE': 9739,
'DESERET CAPITAL LETTER AY': 66572,
'DESERET CAPITAL LETTER BEE': 66578,
'DESERET CAPITAL LETTER CHEE': 66581,
'DESERET CAPITAL LETTER DEE': 66580,
'DESERET CAPITAL LETTER EF': 66585,
'DESERET CAPITAL LETTER EL': 66594,
'DESERET CAPITAL LETTER EM': 66595,
'DESERET CAPITAL LETTER EN': 66596,
'DESERET CAPITAL LETTER ENG': 66597,
'DESERET CAPITAL LETTER ER': 66593,
'DESERET CAPITAL LETTER ES': 66589,
'DESERET CAPITAL LETTER ESH': 66591,
'DESERET CAPITAL LETTER ETH': 66587,
'DESERET CAPITAL LETTER EW': 66599,
'DESERET CAPITAL LETTER GAY': 66584,
'DESERET CAPITAL LETTER H': 66576,
'DESERET CAPITAL LETTER JEE': 66582,
'DESERET CAPITAL LETTER KAY': 66583,
'DESERET CAPITAL LETTER LONG A': 66562,
'DESERET CAPITAL LETTER LONG AH': 66563,
'DESERET CAPITAL LETTER LONG E': 66561,
'DESERET CAPITAL LETTER LONG I': 66560,
'DESERET CAPITAL LETTER LONG O': 66564,
'DESERET CAPITAL LETTER LONG OO': 66565,
'DESERET CAPITAL LETTER OI': 66598,
'DESERET CAPITAL LETTER OW': 66573,
'DESERET CAPITAL LETTER PEE': 66577,
'DESERET CAPITAL LETTER SHORT A': 66568,
'DESERET CAPITAL LETTER SHORT AH': 66569,
'DESERET CAPITAL LETTER SHORT E': 66567,
'DESERET CAPITAL LETTER SHORT I': 66566,
'DESERET CAPITAL LETTER SHORT O': 66570,
'DESERET CAPITAL LETTER SHORT OO': 66571,
'DESERET CAPITAL LETTER TEE': 66579,
'DESERET CAPITAL LETTER THEE': 66588,
'DESERET CAPITAL LETTER VEE': 66586,
'DESERET CAPITAL LETTER WU': 66574,
'DESERET CAPITAL LETTER YEE': 66575,
'DESERET CAPITAL LETTER ZEE': 66590,
'DESERET CAPITAL LETTER ZHEE': 66592,
'DESERET SMALL LETTER AY': 66612,
'DESERET SMALL LETTER BEE': 66618,
'DESERET SMALL LETTER CHEE': 66621,
'DESERET SMALL LETTER DEE': 66620,
'DESERET SMALL LETTER EF': 66625,
'DESERET SMALL LETTER EL': 66634,
'DESERET SMALL LETTER EM': 66635,
'DESERET SMALL LETTER EN': 66636,
'DESERET SMALL LETTER ENG': 66637,
'DESERET SMALL LETTER ER': 66633,
'DESERET SMALL LETTER ES': 66629,
'DESERET SMALL LETTER ESH': 66631,
'DESERET SMALL LETTER ETH': 66627,
'DESERET SMALL LETTER EW': 66639,
'DESERET SMALL LETTER GAY': 66624,
'DESERET SMALL LETTER H': 66616,
'DESERET SMALL LETTER JEE': 66622,
'DESERET SMALL LETTER KAY': 66623,
'DESERET SMALL LETTER LONG A': 66602,
'DESERET SMALL LETTER LONG AH': 66603,
'DESERET SMALL LETTER LONG E': 66601,
'DESERET SMALL LETTER LONG I': 66600,
'DESERET SMALL LETTER LONG O': 66604,
'DESERET SMALL LETTER LONG OO': 66605,
'DESERET SMALL LETTER OI': 66638,
'DESERET SMALL LETTER OW': 66613,
'DESERET SMALL LETTER PEE': 66617,
'DESERET SMALL LETTER SHORT A': 66608,
'DESERET SMALL LETTER SHORT AH': 66609,
'DESERET SMALL LETTER SHORT E': 66607,
'DESERET SMALL LETTER SHORT I': 66606,
'DESERET SMALL LETTER SHORT O': 66610,
'DESERET SMALL LETTER SHORT OO': 66611,
'DESERET SMALL LETTER TEE': 66619,
'DESERET SMALL LETTER THEE': 66628,
'DESERET SMALL LETTER VEE': 66626,
'DESERET SMALL LETTER WU': 66614,
'DESERET SMALL LETTER YEE': 66615,
'DESERET SMALL LETTER ZEE': 66630,
'DESERET SMALL LETTER ZHEE': 66632,
'DEVANAGARI ABBREVIATION SIGN': 2416,
'DEVANAGARI ACUTE ACCENT': 2388,
'DEVANAGARI CARET': 43258,
'DEVANAGARI DANDA': 2404,
'DEVANAGARI DIGIT EIGHT': 2414,
'DEVANAGARI DIGIT FIVE': 2411,
'DEVANAGARI DIGIT FOUR': 2410,
'DEVANAGARI DIGIT NINE': 2415,
'DEVANAGARI DIGIT ONE': 2407,
'DEVANAGARI DIGIT SEVEN': 2413,
'DEVANAGARI DIGIT SIX': 2412,
'DEVANAGARI DIGIT THREE': 2409,
'DEVANAGARI DIGIT TWO': 2408,
'DEVANAGARI DIGIT ZERO': 2406,
'DEVANAGARI DOUBLE DANDA': 2405,
'DEVANAGARI GAP FILLER': 43257,
'DEVANAGARI GRAVE ACCENT': 2387,
'DEVANAGARI HEADSTROKE': 43259,
'DEVANAGARI LETTER A': 2309,
'DEVANAGARI LETTER AA': 2310,
'DEVANAGARI LETTER AI': 2320,
'DEVANAGARI LETTER AU': 2324,
'DEVANAGARI LETTER BA': 2348,
'DEVANAGARI LETTER BBA': 2431,
'DEVANAGARI LETTER BHA': 2349,
'DEVANAGARI LETTER CA': 2330,
'DEVANAGARI LETTER CANDRA A': 2418,
'DEVANAGARI LETTER CANDRA E': 2317,
'DEVANAGARI LETTER CANDRA O': 2321,
'DEVANAGARI LETTER CHA': 2331,
'DEVANAGARI LETTER DA': 2342,
'DEVANAGARI LETTER DDA': 2337,
'DEVANAGARI LETTER DDDA': 2430,
'DEVANAGARI LETTER DDDHA': 2396,
'DEVANAGARI LETTER DDHA': 2338,
'DEVANAGARI LETTER DHA': 2343,
'DEVANAGARI LETTER E': 2319,
'DEVANAGARI LETTER FA': 2398,
'DEVANAGARI LETTER GA': 2327,
'DEVANAGARI LETTER GGA': 2427,
'DEVANAGARI LETTER GHA': 2328,
'DEVANAGARI LETTER GHHA': 2394,
'DEVANAGARI LETTER GLOTTAL STOP': 2429,
'DEVANAGARI LETTER HA': 2361,
'DEVANAGARI LETTER HEAVY YA': 2426,
'DEVANAGARI LETTER I': 2311,
'DEVANAGARI LETTER II': 2312,
'DEVANAGARI LETTER JA': 2332,
'DEVANAGARI LETTER JHA': 2333,
'DEVANAGARI LETTER JJA': 2428,
'DEVANAGARI LETTER KA': 2325,
'DEVANAGARI LETTER KHA': 2326,
'DEVANAGARI LETTER KHHA': 2393,
'DEVANAGARI LETTER LA': 2354,
'DEVANAGARI LETTER LLA': 2355,
'DEVANAGARI LETTER LLLA': 2356,
'DEVANAGARI LETTER MA': 2350,
'DEVANAGARI LETTER NA': 2344,
'DEVANAGARI LETTER NGA': 2329,
'DEVANAGARI LETTER NNA': 2339,
'DEVANAGARI LETTER NNNA': 2345,
'DEVANAGARI LETTER NYA': 2334,
'DEVANAGARI LETTER O': 2323,
'DEVANAGARI LETTER PA': 2346,
'DEVANAGARI LETTER PHA': 2347,
'DEVANAGARI LETTER QA': 2392,
'DEVANAGARI LETTER RA': 2352,
'DEVANAGARI LETTER RHA': 2397,
'DEVANAGARI LETTER RRA': 2353,
'DEVANAGARI LETTER SA': 2360,
'DEVANAGARI LETTER SHA': 2358,
'DEVANAGARI LETTER SHORT A': 2308,
'DEVANAGARI LETTER SHORT E': 2318,
'DEVANAGARI LETTER SHORT O': 2322,
'DEVANAGARI LETTER SSA': 2359,
'DEVANAGARI LETTER TA': 2340,
'DEVANAGARI LETTER THA': 2341,
'DEVANAGARI LETTER TTA': 2335,
'DEVANAGARI LETTER TTHA': 2336,
'DEVANAGARI LETTER U': 2313,
'DEVANAGARI LETTER UU': 2314,
'DEVANAGARI LETTER VA': 2357,
'DEVANAGARI LETTER VOCALIC L': 2316,
'DEVANAGARI LETTER VOCALIC LL': 2401,
'DEVANAGARI LETTER VOCALIC R': 2315,
'DEVANAGARI LETTER VOCALIC RR': 2400,
'DEVANAGARI LETTER YA': 2351,
'DEVANAGARI LETTER YYA': 2399,
'DEVANAGARI LETTER ZA': 2395,
'DEVANAGARI LETTER ZHA': 2425,
'DEVANAGARI OM': 2384,
'DEVANAGARI SIGN ANUSVARA': 2306,
'DEVANAGARI SIGN AVAGRAHA': 2365,
'DEVANAGARI SIGN CANDRABINDU': 2305,
'DEVANAGARI SIGN CANDRABINDU AVAGRAHA': 43255,
'DEVANAGARI SIGN CANDRABINDU THREE': 43254,
'DEVANAGARI SIGN CANDRABINDU TWO': 43253,
'DEVANAGARI SIGN CANDRABINDU VIRAMA': 43251,
'DEVANAGARI SIGN DOUBLE CANDRABINDU VIRAMA': 43252,
'DEVANAGARI SIGN HIGH SPACING DOT': 2417,
'DEVANAGARI SIGN INVERTED CANDRABINDU': 2304,
'DEVANAGARI SIGN NUKTA': 2364,
'DEVANAGARI SIGN PUSHPIKA': 43256,
'DEVANAGARI SIGN SPACING CANDRABINDU': 43250,
'DEVANAGARI SIGN VIRAMA': 2381,
'DEVANAGARI SIGN VISARGA': 2307,
'DEVANAGARI STRESS SIGN ANUDATTA': 2386,
'DEVANAGARI STRESS SIGN UDATTA': 2385,
'DEVANAGARI VOWEL SIGN AA': 2366,
'DEVANAGARI VOWEL SIGN AI': 2376,
'DEVANAGARI VOWEL SIGN AU': 2380,
'DEVANAGARI VOWEL SIGN CANDRA E': 2373,
'DEVANAGARI VOWEL SIGN CANDRA LONG E': 2389,
'DEVANAGARI VOWEL SIGN CANDRA O': 2377,
'DEVANAGARI VOWEL SIGN E': 2375,
'DEVANAGARI VOWEL SIGN I': 2367,
'DEVANAGARI VOWEL SIGN II': 2368,
'DEVANAGARI VOWEL SIGN O': 2379,
'DEVANAGARI VOWEL SIGN PRISHTHAMATRA E': 2382,
'DEVANAGARI VOWEL SIGN SHORT E': 2374,
'DEVANAGARI VOWEL SIGN SHORT O': 2378,
'DEVANAGARI VOWEL SIGN U': 2369,
'DEVANAGARI VOWEL SIGN UU': 2370,
'DEVANAGARI VOWEL SIGN VOCALIC L': 2402,
'DEVANAGARI VOWEL SIGN VOCALIC LL': 2403,
'DEVANAGARI VOWEL SIGN VOCALIC R': 2371,
'DEVANAGARI VOWEL SIGN VOCALIC RR': 2372,
'DIAERESIS': 168,
'DIAMETER SIGN': 8960,
'DIAMOND OPERATOR': 8900,
'DIAMOND WITH BOTTOM HALF BLACK': 11033,
'DIAMOND WITH LEFT HALF BLACK': 11030,
'DIAMOND WITH RIGHT HALF BLACK': 11031,
'DIAMOND WITH TOP HALF BLACK': 11032,
'DIE FACE-1': 9856,
'DIE FACE-2': 9857,
'DIE FACE-3': 9858,
'DIE FACE-4': 9859,
'DIE FACE-5': 9860,
'DIE FACE-6': 9861,
'DIFFERENCE BETWEEN': 8783,
'DIGIT EIGHT': 56,
'DIGIT EIGHT COMMA': 127241,
'DIGIT EIGHT FULL STOP': 9359,
'DIGIT FIVE': 53,
'DIGIT FIVE COMMA': 127238,
'DIGIT FIVE FULL STOP': 9356,
'DIGIT FOUR': 52,
'DIGIT FOUR COMMA': 127237,
'DIGIT FOUR FULL STOP': 9355,
'DIGIT NINE': 57,
'DIGIT NINE COMMA': 127242,
'DIGIT NINE FULL STOP': 9360,
'DIGIT ONE': 49,
'DIGIT ONE COMMA': 127234,
'DIGIT ONE FULL STOP': 9352,
'DIGIT SEVEN': 55,
'DIGIT SEVEN COMMA': 127240,
'DIGIT SEVEN FULL STOP': 9358,
'DIGIT SIX': 54,
'DIGIT SIX COMMA': 127239,
'DIGIT SIX FULL STOP': 9357,
'DIGIT THREE': 51,
'DIGIT THREE COMMA': 127236,
'DIGIT THREE FULL STOP': 9354,
'DIGIT TWO': 50,
'DIGIT TWO COMMA': 127235,
'DIGIT TWO FULL STOP': 9353,
'DIGIT ZERO': 48,
'DIGIT ZERO COMMA': 127233,
'DIGIT ZERO FULL STOP': 127232,
'DIGRAM FOR EARTH': 119557,
'DIGRAM FOR EARTHLY HEAVEN': 119555,
'DIGRAM FOR EARTHLY HUMAN': 119556,
'DIGRAM FOR GREATER YANG': 9868,
'DIGRAM FOR GREATER YIN': 9871,
'DIGRAM FOR HEAVENLY EARTH': 119553,
'DIGRAM FOR HUMAN EARTH': 119554,
'DIGRAM FOR LESSER YANG': 9870,
'DIGRAM FOR LESSER YIN': 9869,
'DIMENSION ORIGIN': 9009,
'DINGBAT CIRCLED SANS-SERIF DIGIT EIGHT': 10119,
'DINGBAT CIRCLED SANS-SERIF DIGIT FIVE': 10116,
'DINGBAT CIRCLED SANS-SERIF DIGIT FOUR': 10115,
'DINGBAT CIRCLED SANS-SERIF DIGIT NINE': 10120,
'DINGBAT CIRCLED SANS-SERIF DIGIT ONE': 10112,
'DINGBAT CIRCLED SANS-SERIF DIGIT SEVEN': 10118,
'DINGBAT CIRCLED SANS-SERIF DIGIT SIX': 10117,
'DINGBAT CIRCLED SANS-SERIF DIGIT THREE': 10114,
'DINGBAT CIRCLED SANS-SERIF DIGIT TWO': 10113,
'DINGBAT CIRCLED SANS-SERIF NUMBER TEN': 10121,
'DINGBAT NEGATIVE CIRCLED DIGIT EIGHT': 10109,
'DINGBAT NEGATIVE CIRCLED DIGIT FIVE': 10106,
'DINGBAT NEGATIVE CIRCLED DIGIT FOUR': 10105,
'DINGBAT NEGATIVE CIRCLED DIGIT NINE': 10110,
'DINGBAT NEGATIVE CIRCLED DIGIT ONE': 10102,
'DINGBAT NEGATIVE CIRCLED DIGIT SEVEN': 10108,
'DINGBAT NEGATIVE CIRCLED DIGIT SIX': 10107,
'DINGBAT NEGATIVE CIRCLED DIGIT THREE': 10104,
'DINGBAT NEGATIVE CIRCLED DIGIT TWO': 10103,
'DINGBAT NEGATIVE CIRCLED NUMBER TEN': 10111,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT EIGHT': 10129,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT FIVE': 10126,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT FOUR': 10125,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT NINE': 10130,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT ONE': 10122,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT SEVEN': 10128,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT SIX': 10127,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT THREE': 10124,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT TWO': 10123,
'DINGBAT NEGATIVE CIRCLED SANS-SERIF NUMBER TEN': 10131,
'DIRECT CURRENT SYMBOL FORM TWO': 9107,
'DISABLED CAR': 9933,
'DISCONTINUOUS UNDERLINE SYMBOL': 9090,
'DITTO MARK': 12291,
'DIVIDES': 8739,
'DIVISION SIGN': 247,
'DIVISION SLASH': 8725,
'DIVISION TIMES': 8903,
'DIVORCE SYMBOL': 9902,
'DOES NOT CONTAIN AS MEMBER': 8716,
'DOES NOT CONTAIN AS NORMAL SUBGROUP': 8939,
'DOES NOT CONTAIN AS NORMAL SUBGROUP OR EQUAL': 8941,
'DOES NOT DIVIDE': 8740,
'DOES NOT DIVIDE WITH REVERSED NEGATION SLASH': 10990,
'DOES NOT FORCE': 8878,
'DOES NOT PRECEDE': 8832,
'DOES NOT PRECEDE OR EQUAL': 8928,
'DOES NOT PROVE': 8876,
'DOES NOT SUCCEED': 8833,
'DOES NOT SUCCEED OR EQUAL': 8929,
'DOLLAR SIGN': 36,
'DOMINO TILE HORIZONTAL BACK': 127024,
'DOMINO TILE HORIZONTAL-00-00': 127025,
'DOMINO TILE HORIZONTAL-00-01': 127026,
'DOMINO TILE HORIZONTAL-00-02': 127027,
'DOMINO TILE HORIZONTAL-00-03': 127028,
'DOMINO TILE HORIZONTAL-00-04': 127029,
'DOMINO TILE HORIZONTAL-00-05': 127030,
'DOMINO TILE HORIZONTAL-00-06': 127031,
'DOMINO TILE HORIZONTAL-01-00': 127032,
'DOMINO TILE HORIZONTAL-01-01': 127033,
'DOMINO TILE HORIZONTAL-01-02': 127034,
'DOMINO TILE HORIZONTAL-01-03': 127035,
'DOMINO TILE HORIZONTAL-01-04': 127036,
'DOMINO TILE HORIZONTAL-01-05': 127037,
'DOMINO TILE HORIZONTAL-01-06': 127038,
'DOMINO TILE HORIZONTAL-02-00': 127039,
'DOMINO TILE HORIZONTAL-02-01': 127040,
'DOMINO TILE HORIZONTAL-02-02': 127041,
'DOMINO TILE HORIZONTAL-02-03': 127042,
'DOMINO TILE HORIZONTAL-02-04': 127043,
'DOMINO TILE HORIZONTAL-02-05': 127044,
'DOMINO TILE HORIZONTAL-02-06': 127045,
'DOMINO TILE HORIZONTAL-03-00': 127046,
'DOMINO TILE HORIZONTAL-03-01': 127047,
'DOMINO TILE HORIZONTAL-03-02': 127048,
'DOMINO TILE HORIZONTAL-03-03': 127049,
'DOMINO TILE HORIZONTAL-03-04': 127050,
'DOMINO TILE HORIZONTAL-03-05': 127051,
'DOMINO TILE HORIZONTAL-03-06': 127052,
'DOMINO TILE HORIZONTAL-04-00': 127053,
'DOMINO TILE HORIZONTAL-04-01': 127054,
'DOMINO TILE HORIZONTAL-04-02': 127055,
'DOMINO TILE HORIZONTAL-04-03': 127056,
'DOMINO TILE HORIZONTAL-04-04': 127057,
'DOMINO TILE HORIZONTAL-04-05': 127058,
'DOMINO TILE HORIZONTAL-04-06': 127059,
'DOMINO TILE HORIZONTAL-05-00': 127060,
'DOMINO TILE HORIZONTAL-05-01': 127061,
'DOMINO TILE HORIZONTAL-05-02': 127062,
'DOMINO TILE HORIZONTAL-05-03': 127063,
'DOMINO TILE HORIZONTAL-05-04': 127064,
'DOMINO TILE HORIZONTAL-05-05': 127065,
'DOMINO TILE HORIZONTAL-05-06': 127066,
'DOMINO TILE HORIZONTAL-06-00': 127067,
'DOMINO TILE HORIZONTAL-06-01': 127068,
'DOMINO TILE HORIZONTAL-06-02': 127069,
'DOMINO TILE HORIZONTAL-06-03': 127070,
'DOMINO TILE HORIZONTAL-06-04': 127071,
'DOMINO TILE HORIZONTAL-06-05': 127072,
'DOMINO TILE HORIZONTAL-06-06': 127073,
'DOMINO TILE VERTICAL BACK': 127074,
'DOMINO TILE VERTICAL-00-00': 127075,
'DOMINO TILE VERTICAL-00-01': 127076,
'DOMINO TILE VERTICAL-00-02': 127077,
'DOMINO TILE VERTICAL-00-03': 127078,
'DOMINO TILE VERTICAL-00-04': 127079,
'DOMINO TILE VERTICAL-00-05': 127080,
'DOMINO TILE VERTICAL-00-06': 127081,
'DOMINO TILE VERTICAL-01-00': 127082,
'DOMINO TILE VERTICAL-01-01': 127083,
'DOMINO TILE VERTICAL-01-02': 127084,
'DOMINO TILE VERTICAL-01-03': 127085,
'DOMINO TILE VERTICAL-01-04': 127086,
'DOMINO TILE VERTICAL-01-05': 127087,
'DOMINO TILE VERTICAL-01-06': 127088,
'DOMINO TILE VERTICAL-02-00': 127089,
'DOMINO TILE VERTICAL-02-01': 127090,
'DOMINO TILE VERTICAL-02-02': 127091,
'DOMINO TILE VERTICAL-02-03': 127092,
'DOMINO TILE VERTICAL-02-04': 127093,
'DOMINO TILE VERTICAL-02-05': 127094,
'DOMINO TILE VERTICAL-02-06': 127095,
'DOMINO TILE VERTICAL-03-00': 127096,
'DOMINO TILE VERTICAL-03-01': 127097,
'DOMINO TILE VERTICAL-03-02': 127098,
'DOMINO TILE VERTICAL-03-03': 127099,
'DOMINO TILE VERTICAL-03-04': 127100,
'DOMINO TILE VERTICAL-03-05': 127101,
'DOMINO TILE VERTICAL-03-06': 127102,
'DOMINO TILE VERTICAL-04-00': 127103,
'DOMINO TILE VERTICAL-04-01': 127104,
'DOMINO TILE VERTICAL-04-02': 127105,
'DOMINO TILE VERTICAL-04-03': 127106,
'DOMINO TILE VERTICAL-04-04': 127107,
'DOMINO TILE VERTICAL-04-05': 127108,
'DOMINO TILE VERTICAL-04-06': 127109,
'DOMINO TILE VERTICAL-05-00': 127110,
'DOMINO TILE VERTICAL-05-01': 127111,
'DOMINO TILE VERTICAL-05-02': 127112,
'DOMINO TILE VERTICAL-05-03': 127113,
'DOMINO TILE VERTICAL-05-04': 127114,
'DOMINO TILE VERTICAL-05-05': 127115,
'DOMINO TILE VERTICAL-05-06': 127116,
'DOMINO TILE VERTICAL-06-00': 127117,
'DOMINO TILE VERTICAL-06-01': 127118,
'DOMINO TILE VERTICAL-06-02': 127119,
'DOMINO TILE VERTICAL-06-03': 127120,
'DOMINO TILE VERTICAL-06-04': 127121,
'DOMINO TILE VERTICAL-06-05': 127122,
'DOMINO TILE VERTICAL-06-06': 127123,
'DONG SIGN': 8363,
'DOT ABOVE': 729,
'DOT MINUS': 8760,
'DOT OPERATOR': 8901,
'DOT PLUS': 8724,
'DOTTED CIRCLE': 9676,
'DOTTED CROSS': 8284,
'DOTTED FENCE': 10649,
'DOTTED OBELOS': 11795,
'DOTTED RIGHT-POINTING ANGLE': 11798,
'DOTTED SQUARE': 11034,
'DOTTED TRANSPOSITION MARKER': 11784,
'DOUBLE ACUTE ACCENT': 733,
'DOUBLE CIRCLED DIGIT EIGHT': 9468,
'DOUBLE CIRCLED DIGIT FIVE': 9465,
'DOUBLE CIRCLED DIGIT FOUR': 9464,
'DOUBLE CIRCLED DIGIT NINE': 9469,
'DOUBLE CIRCLED DIGIT ONE': 9461,
'DOUBLE CIRCLED DIGIT SEVEN': 9467,
'DOUBLE CIRCLED DIGIT SIX': 9466,
'DOUBLE CIRCLED DIGIT THREE': 9463,
'DOUBLE CIRCLED DIGIT TWO': 9462,
'DOUBLE CIRCLED NUMBER TEN': 9470,
'DOUBLE COLON EQUAL': 10868,
'DOUBLE DAGGER': 8225,
'DOUBLE DOWN TACK': 10986,
'DOUBLE EXCLAMATION MARK': 8252,
'DOUBLE HIGH-REVERSED-9 QUOTATION MARK': 8223,
'DOUBLE INTEGRAL': 8748,
'DOUBLE INTERSECTION': 8914,
'DOUBLE LEFT ARC GREATER-THAN BRACKET': 10645,
'DOUBLE LOGICAL AND': 10835,
'DOUBLE LOGICAL OR': 10836,
'DOUBLE LOW LINE': 8215,
'DOUBLE LOW-9 QUOTATION MARK': 8222,
'DOUBLE NESTED GREATER-THAN': 10914,
'DOUBLE NESTED LESS-THAN': 10913,
'DOUBLE NESTED LESS-THAN WITH UNDERBAR': 10915,
'DOUBLE OBLIQUE HYPHEN': 11799,
'DOUBLE PLUS': 10746,
'DOUBLE PRECEDES': 10939,
'DOUBLE PRIME': 8243,
'DOUBLE PRIME QUOTATION MARK': 12318,
'DOUBLE QUESTION MARK': 8263,
'DOUBLE RIGHT ARC LESS-THAN BRACKET': 10646,
'DOUBLE SOLIDUS OPERATOR': 11005,
'DOUBLE SQUARE INTERSECTION': 10830,
'DOUBLE SQUARE UNION': 10831,
'DOUBLE STROKE NOT SIGN': 10988,
'DOUBLE SUBSET': 8912,
'DOUBLE SUCCEEDS': 10940,
'DOUBLE SUPERSET': 8913,
'DOUBLE UNION': 8915,
'DOUBLE UP TACK': 10987,
'DOUBLE VERTICAL BAR DOUBLE LEFT TURNSTILE': 10981,
'DOUBLE VERTICAL BAR DOUBLE RIGHT TURNSTILE': 8875,
'DOUBLE VERTICAL BAR LEFT TURNSTILE': 10979,
'DOUBLE VERTICAL LINE': 8214,
'DOUBLE WAVY OVERLINE': 65100,
'DOUBLE-ENDED MULTIMAP': 10719,
'DOUBLE-LINE EQUAL TO OR GREATER-THAN': 10906,
'DOUBLE-LINE EQUAL TO OR LESS-THAN': 10905,
'DOUBLE-LINE SLANTED EQUAL TO OR GREATER-THAN': 10908,
'DOUBLE-LINE SLANTED EQUAL TO OR LESS-THAN': 10907,
'DOUBLE-LINE SLANTED GREATER-THAN OR EQUAL TO': 11002,
'DOUBLE-LINE SLANTED LESS-THAN OR EQUAL TO': 11001,
'DOUBLE-STRUCK CAPITAL C': 8450,
'DOUBLE-STRUCK CAPITAL GAMMA': 8510,
'DOUBLE-STRUCK CAPITAL H': 8461,
'DOUBLE-STRUCK CAPITAL N': 8469,
'DOUBLE-STRUCK CAPITAL P': 8473,
'DOUBLE-STRUCK CAPITAL PI': 8511,
'DOUBLE-STRUCK CAPITAL Q': 8474,
'DOUBLE-STRUCK CAPITAL R': 8477,
'DOUBLE-STRUCK CAPITAL Z': 8484,
'DOUBLE-STRUCK ITALIC CAPITAL D': 8517,
'DOUBLE-STRUCK ITALIC SMALL D': 8518,
'DOUBLE-STRUCK ITALIC SMALL E': 8519,
'DOUBLE-STRUCK ITALIC SMALL I': 8520,
'DOUBLE-STRUCK ITALIC SMALL J': 8521,
'DOUBLE-STRUCK N-ARY SUMMATION': 8512,
'DOUBLE-STRUCK SMALL GAMMA': 8509,
'DOUBLE-STRUCK SMALL PI': 8508,
'DOUBLED FEMALE SIGN': 9890,
'DOUBLED MALE SIGN': 9891,
'DOWN ARROWHEAD': 8964,
'DOWN FISH TAIL': 10623,
'DOWN RIGHT DIAGONAL ELLIPSIS': 8945,
'DOWN TACK': 8868,
'DOWN TACK WITH CIRCLE BELOW': 10993,
'DOWN-POINTING TRIANGLE WITH LEFT HALF BLACK': 10728,
'DOWN-POINTING TRIANGLE WITH RIGHT HALF BLACK': 10729,
'DOWNWARDS ANCORA': 11796,
'DOWNWARDS ARROW': 8595,
'DOWNWARDS ARROW FROM BAR': 8615,
'DOWNWARDS ARROW LEFTWARDS OF UPWARDS ARROW': 8693,
'DOWNWARDS ARROW TO BAR': 10515,
'DOWNWARDS ARROW WITH CORNER LEFTWARDS': 8629,
'DOWNWARDS ARROW WITH DOUBLE STROKE': 8671,
'DOWNWARDS ARROW WITH HORIZONTAL STROKE': 10504,
'DOWNWARDS ARROW WITH TIP LEFTWARDS': 8626,
'DOWNWARDS ARROW WITH TIP RIGHTWARDS': 8627,
'DOWNWARDS BLACK ARROW': 11015,
'DOWNWARDS DASHED ARROW': 8675,
'DOWNWARDS DOUBLE ARROW': 8659,
'DOWNWARDS HARPOON WITH BARB LEFT BESIDE DOWNWARDS HARPOON WITH BARB RIGHT': 10597,
'DOWNWARDS HARPOON WITH BARB LEFT BESIDE UPWARDS HARPOON WITH BARB RIGHT': 10607,
'DOWNWARDS HARPOON WITH BARB LEFT FROM BAR': 10593,
'DOWNWARDS HARPOON WITH BARB LEFT TO BAR': 10585,
'DOWNWARDS HARPOON WITH BARB LEFTWARDS': 8643,
'DOWNWARDS HARPOON WITH BARB RIGHT FROM BAR': 10589,
'DOWNWARDS HARPOON WITH BARB RIGHT TO BAR': 10581,
'DOWNWARDS HARPOON WITH BARB RIGHTWARDS': 8642,
'DOWNWARDS PAIRED ARROWS': 8650,
'DOWNWARDS QUADRUPLE ARROW': 10225,
'DOWNWARDS TRIPLE ARROW': 10507,
'DOWNWARDS TWO HEADED ARROW': 8609,
'DOWNWARDS WHITE ARROW': 8681,
'DOWNWARDS ZIGZAG ARROW': 8623,
'DRACHMA SIGN': 8367,
'DRAFTING POINT RIGHTWARDS ARROW': 10139,
'DRIVE SLOW SIGN': 9946,
'EARTH': 9793,
'EARTH GROUND': 9178,
'EAST SYRIAC CROSS': 9841,
'EDITORIAL CORONIS': 11790,
'EGYPTIAN HIEROGLYPH A001': 77824,
'EGYPTIAN HIEROGLYPH A002': 77825,
'EGYPTIAN HIEROGLYPH A003': 77826,
'EGYPTIAN HIEROGLYPH A004': 77827,
'EGYPTIAN HIEROGLYPH A005': 77828,
'EGYPTIAN HIEROGLYPH A005A': 77829,
'EGYPTIAN HIEROGLYPH A006': 77830,
'EGYPTIAN HIEROGLYPH A006A': 77831,
'EGYPTIAN HIEROGLYPH A006B': 77832,
'EGYPTIAN HIEROGLYPH A007': 77833,
'EGYPTIAN HIEROGLYPH A008': 77834,
'EGYPTIAN HIEROGLYPH A009': 77835,
'EGYPTIAN HIEROGLYPH A010': 77836,
'EGYPTIAN HIEROGLYPH A011': 77837,
'EGYPTIAN HIEROGLYPH A012': 77838,
'EGYPTIAN HIEROGLYPH A013': 77839,
'EGYPTIAN HIEROGLYPH A014': 77840,
'EGYPTIAN HIEROGLYPH A014A': 77841,
'EGYPTIAN HIEROGLYPH A015': 77842,
'EGYPTIAN HIEROGLYPH A016': 77843,
'EGYPTIAN HIEROGLYPH A017': 77844,
'EGYPTIAN HIEROGLYPH A017A': 77845,
'EGYPTIAN HIEROGLYPH A018': 77846,
'EGYPTIAN HIEROGLYPH A019': 77847,
'EGYPTIAN HIEROGLYPH A020': 77848,
'EGYPTIAN HIEROGLYPH A021': 77849,
'EGYPTIAN HIEROGLYPH A022': 77850,
'EGYPTIAN HIEROGLYPH A023': 77851,
'EGYPTIAN HIEROGLYPH A024': 77852,
'EGYPTIAN HIEROGLYPH A025': 77853,
'EGYPTIAN HIEROGLYPH A026': 77854,
'EGYPTIAN HIEROGLYPH A027': 77855,
'EGYPTIAN HIEROGLYPH A028': 77856,
'EGYPTIAN HIEROGLYPH A029': 77857,
'EGYPTIAN HIEROGLYPH A030': 77858,
'EGYPTIAN HIEROGLYPH A031': 77859,
'EGYPTIAN HIEROGLYPH A032': 77860,
'EGYPTIAN HIEROGLYPH A032A': 77861,
'EGYPTIAN HIEROGLYPH A033': 77862,
'EGYPTIAN HIEROGLYPH A034': 77863,
'EGYPTIAN HIEROGLYPH A035': 77864,
'EGYPTIAN HIEROGLYPH A036': 77865,
'EGYPTIAN HIEROGLYPH A037': 77866,
'EGYPTIAN HIEROGLYPH A038': 77867,
'EGYPTIAN HIEROGLYPH A039': 77868,
'EGYPTIAN HIEROGLYPH A040': 77869,
'EGYPTIAN HIEROGLYPH A040A': 77870,
'EGYPTIAN HIEROGLYPH A041': 77871,
'EGYPTIAN HIEROGLYPH A042': 77872,
'EGYPTIAN HIEROGLYPH A042A': 77873,
'EGYPTIAN HIEROGLYPH A043': 77874,
'EGYPTIAN HIEROGLYPH A043A': 77875,
'EGYPTIAN HIEROGLYPH A044': 77876,
'EGYPTIAN HIEROGLYPH A045': 77877,
'EGYPTIAN HIEROGLYPH A045A': 77878,
'EGYPTIAN HIEROGLYPH A046': 77879,
'EGYPTIAN HIEROGLYPH A047': 77880,
'EGYPTIAN HIEROGLYPH A048': 77881,
'EGYPTIAN HIEROGLYPH A049': 77882,
'EGYPTIAN HIEROGLYPH A050': 77883,
'EGYPTIAN HIEROGLYPH A051': 77884,
'EGYPTIAN HIEROGLYPH A052': 77885,
'EGYPTIAN HIEROGLYPH A053': 77886,
'EGYPTIAN HIEROGLYPH A054': 77887,
'EGYPTIAN HIEROGLYPH A055': 77888,
'EGYPTIAN HIEROGLYPH A056': 77889,
'EGYPTIAN HIEROGLYPH A057': 77890,
'EGYPTIAN HIEROGLYPH A058': 77891,
'EGYPTIAN HIEROGLYPH A059': 77892,
'EGYPTIAN HIEROGLYPH A060': 77893,
'EGYPTIAN HIEROGLYPH A061': 77894,
'EGYPTIAN HIEROGLYPH A062': 77895,
'EGYPTIAN HIEROGLYPH A063': 77896,
'EGYPTIAN HIEROGLYPH A064': 77897,
'EGYPTIAN HIEROGLYPH A065': 77898,
'EGYPTIAN HIEROGLYPH A066': 77899,
'EGYPTIAN HIEROGLYPH A067': 77900,
'EGYPTIAN HIEROGLYPH A068': 77901,
'EGYPTIAN HIEROGLYPH A069': 77902,
'EGYPTIAN HIEROGLYPH A070': 77903,
'EGYPTIAN HIEROGLYPH AA001': 78861,
'EGYPTIAN HIEROGLYPH AA002': 78862,
'EGYPTIAN HIEROGLYPH AA003': 78863,
'EGYPTIAN HIEROGLYPH AA004': 78864,
'EGYPTIAN HIEROGLYPH AA005': 78865,
'EGYPTIAN HIEROGLYPH AA006': 78866,
'EGYPTIAN HIEROGLYPH AA007': 78867,
'EGYPTIAN HIEROGLYPH AA007A': 78868,
'EGYPTIAN HIEROGLYPH AA007B': 78869,
'EGYPTIAN HIEROGLYPH AA008': 78870,
'EGYPTIAN HIEROGLYPH AA009': 78871,
'EGYPTIAN HIEROGLYPH AA010': 78872,
'EGYPTIAN HIEROGLYPH AA011': 78873,
'EGYPTIAN HIEROGLYPH AA012': 78874,
'EGYPTIAN HIEROGLYPH AA013': 78875,
'EGYPTIAN HIEROGLYPH AA014': 78876,
'EGYPTIAN HIEROGLYPH AA015': 78877,
'EGYPTIAN HIEROGLYPH AA016': 78878,
'EGYPTIAN HIEROGLYPH AA017': 78879,
'EGYPTIAN HIEROGLYPH AA018': 78880,
'EGYPTIAN HIEROGLYPH AA019': 78881,
'EGYPTIAN HIEROGLYPH AA020': 78882,
'EGYPTIAN HIEROGLYPH AA021': 78883,
'EGYPTIAN HIEROGLYPH AA022': 78884,
'EGYPTIAN HIEROGLYPH AA023': 78885,
'EGYPTIAN HIEROGLYPH AA024': 78886,
'EGYPTIAN HIEROGLYPH AA025': 78887,
'EGYPTIAN HIEROGLYPH AA026': 78888,
'EGYPTIAN HIEROGLYPH AA027': 78889,
'EGYPTIAN HIEROGLYPH AA028': 78890,
'EGYPTIAN HIEROGLYPH AA029': 78891,
'EGYPTIAN HIEROGLYPH AA030': 78892,
'EGYPTIAN HIEROGLYPH AA031': 78893,
'EGYPTIAN HIEROGLYPH AA032': 78894,
'EGYPTIAN HIEROGLYPH B001': 77904,
'EGYPTIAN HIEROGLYPH B002': 77905,
'EGYPTIAN HIEROGLYPH B003': 77906,
'EGYPTIAN HIEROGLYPH B004': 77907,
'EGYPTIAN HIEROGLYPH B005': 77908,
'EGYPTIAN HIEROGLYPH B005A': 77909,
'EGYPTIAN HIEROGLYPH B006': 77910,
'EGYPTIAN HIEROGLYPH B007': 77911,
'EGYPTIAN HIEROGLYPH B008': 77912,
'EGYPTIAN HIEROGLYPH B009': 77913,
'EGYPTIAN HIEROGLYPH C001': 77914,
'EGYPTIAN HIEROGLYPH C002': 77915,
'EGYPTIAN HIEROGLYPH C002A': 77916,
'EGYPTIAN HIEROGLYPH C002B': 77917,
'EGYPTIAN HIEROGLYPH C002C': 77918,
'EGYPTIAN HIEROGLYPH C003': 77919,
'EGYPTIAN HIEROGLYPH C004': 77920,
'EGYPTIAN HIEROGLYPH C005': 77921,
'EGYPTIAN HIEROGLYPH C006': 77922,
'EGYPTIAN HIEROGLYPH C007': 77923,
'EGYPTIAN HIEROGLYPH C008': 77924,
'EGYPTIAN HIEROGLYPH C009': 77925,
'EGYPTIAN HIEROGLYPH C010': 77926,
'EGYPTIAN HIEROGLYPH C010A': 77927,
'EGYPTIAN HIEROGLYPH C011': 77928,
'EGYPTIAN HIEROGLYPH C012': 77929,
'EGYPTIAN HIEROGLYPH C013': 77930,
'EGYPTIAN HIEROGLYPH C014': 77931,
'EGYPTIAN HIEROGLYPH C015': 77932,
'EGYPTIAN HIEROGLYPH C016': 77933,
'EGYPTIAN HIEROGLYPH C017': 77934,
'EGYPTIAN HIEROGLYPH C018': 77935,
'EGYPTIAN HIEROGLYPH C019': 77936,
'EGYPTIAN HIEROGLYPH C020': 77937,
'EGYPTIAN HIEROGLYPH C021': 77938,
'EGYPTIAN HIEROGLYPH C022': 77939,
'EGYPTIAN HIEROGLYPH C023': 77940,
'EGYPTIAN HIEROGLYPH C024': 77941,
'EGYPTIAN HIEROGLYPH D001': 77942,
'EGYPTIAN HIEROGLYPH D002': 77943,
'EGYPTIAN HIEROGLYPH D003': 77944,
'EGYPTIAN HIEROGLYPH D004': 77945,
'EGYPTIAN HIEROGLYPH D005': 77946,
'EGYPTIAN HIEROGLYPH D006': 77947,
'EGYPTIAN HIEROGLYPH D007': 77948,
'EGYPTIAN HIEROGLYPH D008': 77949,
'EGYPTIAN HIEROGLYPH D008A': 77950,
'EGYPTIAN HIEROGLYPH D009': 77951,
'EGYPTIAN HIEROGLYPH D010': 77952,
'EGYPTIAN HIEROGLYPH D011': 77953,
'EGYPTIAN HIEROGLYPH D012': 77954,
'EGYPTIAN HIEROGLYPH D013': 77955,
'EGYPTIAN HIEROGLYPH D014': 77956,
'EGYPTIAN HIEROGLYPH D015': 77957,
'EGYPTIAN HIEROGLYPH D016': 77958,
'EGYPTIAN HIEROGLYPH D017': 77959,
'EGYPTIAN HIEROGLYPH D018': 77960,
'EGYPTIAN HIEROGLYPH D019': 77961,
'EGYPTIAN HIEROGLYPH D020': 77962,
'EGYPTIAN HIEROGLYPH D021': 77963,
'EGYPTIAN HIEROGLYPH D022': 77964,
'EGYPTIAN HIEROGLYPH D023': 77965,
'EGYPTIAN HIEROGLYPH D024': 77966,
'EGYPTIAN HIEROGLYPH D025': 77967,
'EGYPTIAN HIEROGLYPH D026': 77968,
'EGYPTIAN HIEROGLYPH D027': 77969,
'EGYPTIAN HIEROGLYPH D027A': 77970,
'EGYPTIAN HIEROGLYPH D028': 77971,
'EGYPTIAN HIEROGLYPH D029': 77972,
'EGYPTIAN HIEROGLYPH D030': 77973,
'EGYPTIAN HIEROGLYPH D031': 77974,
'EGYPTIAN HIEROGLYPH D031A': 77975,
'EGYPTIAN HIEROGLYPH D032': 77976,
'EGYPTIAN HIEROGLYPH D033': 77977,
'EGYPTIAN HIEROGLYPH D034': 77978,
'EGYPTIAN HIEROGLYPH D034A': 77979,
'EGYPTIAN HIEROGLYPH D035': 77980,
'EGYPTIAN HIEROGLYPH D036': 77981,
'EGYPTIAN HIEROGLYPH D037': 77982,
'EGYPTIAN HIEROGLYPH D038': 77983,
'EGYPTIAN HIEROGLYPH D039': 77984,
'EGYPTIAN HIEROGLYPH D040': 77985,
'EGYPTIAN HIEROGLYPH D041': 77986,
'EGYPTIAN HIEROGLYPH D042': 77987,
'EGYPTIAN HIEROGLYPH D043': 77988,
'EGYPTIAN HIEROGLYPH D044': 77989,
'EGYPTIAN HIEROGLYPH D045': 77990,
'EGYPTIAN HIEROGLYPH D046': 77991,
'EGYPTIAN HIEROGLYPH D046A': 77992,
'EGYPTIAN HIEROGLYPH D047': 77993,
'EGYPTIAN HIEROGLYPH D048': 77994,
'EGYPTIAN HIEROGLYPH D048A': 77995,
'EGYPTIAN HIEROGLYPH D049': 77996,
'EGYPTIAN HIEROGLYPH D050': 77997,
'EGYPTIAN HIEROGLYPH D050A': 77998,
'EGYPTIAN HIEROGLYPH D050B': 77999,
'EGYPTIAN HIEROGLYPH D050C': 78000,
'EGYPTIAN HIEROGLYPH D050D': 78001,
'EGYPTIAN HIEROGLYPH D050E': 78002,
'EGYPTIAN HIEROGLYPH D050F': 78003,
'EGYPTIAN HIEROGLYPH D050G': 78004,
'EGYPTIAN HIEROGLYPH D050H': 78005,
'EGYPTIAN HIEROGLYPH D050I': 78006,
'EGYPTIAN HIEROGLYPH D051': 78007,
'EGYPTIAN HIEROGLYPH D052': 78008,
'EGYPTIAN HIEROGLYPH D052A': 78009,
'EGYPTIAN HIEROGLYPH D053': 78010,
'EGYPTIAN HIEROGLYPH D054': 78011,
'EGYPTIAN HIEROGLYPH D054A': 78012,
'EGYPTIAN HIEROGLYPH D055': 78013,
'EGYPTIAN HIEROGLYPH D056': 78014,
'EGYPTIAN HIEROGLYPH D057': 78015,
'EGYPTIAN HIEROGLYPH D058': 78016,
'EGYPTIAN HIEROGLYPH D059': 78017,
'EGYPTIAN HIEROGLYPH D060': 78018,
'EGYPTIAN HIEROGLYPH D061': 78019,
'EGYPTIAN HIEROGLYPH D062': 78020,
'EGYPTIAN HIEROGLYPH D063': 78021,
'EGYPTIAN HIEROGLYPH D064': 78022,
'EGYPTIAN HIEROGLYPH D065': 78023,
'EGYPTIAN HIEROGLYPH D066': 78024,
'EGYPTIAN HIEROGLYPH D067': 78025,
'EGYPTIAN HIEROGLYPH D067A': 78026,
'EGYPTIAN HIEROGLYPH D067B': 78027,
'EGYPTIAN HIEROGLYPH D067C': 78028,
'EGYPTIAN HIEROGLYPH D067D': 78029,
'EGYPTIAN HIEROGLYPH D067E': 78030,
'EGYPTIAN HIEROGLYPH D067F': 78031,
'EGYPTIAN HIEROGLYPH D067G': 78032,
'EGYPTIAN HIEROGLYPH D067H': 78033,
'EGYPTIAN HIEROGLYPH E001': 78034,
'EGYPTIAN HIEROGLYPH E002': 78035,
'EGYPTIAN HIEROGLYPH E003': 78036,
'EGYPTIAN HIEROGLYPH E004': 78037,
'EGYPTIAN HIEROGLYPH E005': 78038,
'EGYPTIAN HIEROGLYPH E006': 78039,
'EGYPTIAN HIEROGLYPH E007': 78040,
'EGYPTIAN HIEROGLYPH E008': 78041,
'EGYPTIAN HIEROGLYPH E008A': 78042,
'EGYPTIAN HIEROGLYPH E009': 78043,
'EGYPTIAN HIEROGLYPH E009A': 78044,
'EGYPTIAN HIEROGLYPH E010': 78045,
'EGYPTIAN HIEROGLYPH E011': 78046,
'EGYPTIAN HIEROGLYPH E012': 78047,
'EGYPTIAN HIEROGLYPH E013': 78048,
'EGYPTIAN HIEROGLYPH E014': 78049,
'EGYPTIAN HIEROGLYPH E015': 78050,
'EGYPTIAN HIEROGLYPH E016': 78051,
'EGYPTIAN HIEROGLYPH E016A': 78052,
'EGYPTIAN HIEROGLYPH E017': 78053,
'EGYPTIAN HIEROGLYPH E017A': 78054,
'EGYPTIAN HIEROGLYPH E018': 78055,
'EGYPTIAN HIEROGLYPH E019': 78056,
'EGYPTIAN HIEROGLYPH E020': 78057,
'EGYPTIAN HIEROGLYPH E020A': 78058,
'EGYPTIAN HIEROGLYPH E021': 78059,
'EGYPTIAN HIEROGLYPH E022': 78060,
'EGYPTIAN HIEROGLYPH E023': 78061,
'EGYPTIAN HIEROGLYPH E024': 78062,
'EGYPTIAN HIEROGLYPH E025': 78063,
'EGYPTIAN HIEROGLYPH E026': 78064,
'EGYPTIAN HIEROGLYPH E027': 78065,
'EGYPTIAN HIEROGLYPH E028': 78066,
'EGYPTIAN HIEROGLYPH E028A': 78067,
'EGYPTIAN HIEROGLYPH E029': 78068,
'EGYPTIAN HIEROGLYPH E030': 78069,
'EGYPTIAN HIEROGLYPH E031': 78070,
'EGYPTIAN HIEROGLYPH E032': 78071,
'EGYPTIAN HIEROGLYPH E033': 78072,
'EGYPTIAN HIEROGLYPH E034': 78073,
'EGYPTIAN HIEROGLYPH E034A': 78074,
'EGYPTIAN HIEROGLYPH E036': 78075,
'EGYPTIAN HIEROGLYPH E037': 78076,
'EGYPTIAN HIEROGLYPH E038': 78077,
'EGYPTIAN HIEROGLYPH F001': 78078,
'EGYPTIAN HIEROGLYPH F001A': 78079,
'EGYPTIAN HIEROGLYPH F002': 78080,
'EGYPTIAN HIEROGLYPH F003': 78081,
'EGYPTIAN HIEROGLYPH F004': 78082,
'EGYPTIAN HIEROGLYPH F005': 78083,
'EGYPTIAN HIEROGLYPH F006': 78084,
'EGYPTIAN HIEROGLYPH F007': 78085,
'EGYPTIAN HIEROGLYPH F008': 78086,
'EGYPTIAN HIEROGLYPH F009': 78087,
'EGYPTIAN HIEROGLYPH F010': 78088,
'EGYPTIAN HIEROGLYPH F011': 78089,
'EGYPTIAN HIEROGLYPH F012': 78090,
'EGYPTIAN HIEROGLYPH F013': 78091,
'EGYPTIAN HIEROGLYPH F013A': 78092,
'EGYPTIAN HIEROGLYPH F014': 78093,
'EGYPTIAN HIEROGLYPH F015': 78094,
'EGYPTIAN HIEROGLYPH F016': 78095,
'EGYPTIAN HIEROGLYPH F017': 78096,
'EGYPTIAN HIEROGLYPH F018': 78097,
'EGYPTIAN HIEROGLYPH F019': 78098,
'EGYPTIAN HIEROGLYPH F020': 78099,
'EGYPTIAN HIEROGLYPH F021': 78100,
'EGYPTIAN HIEROGLYPH F021A': 78101,
'EGYPTIAN HIEROGLYPH F022': 78102,
'EGYPTIAN HIEROGLYPH F023': 78103,
'EGYPTIAN HIEROGLYPH F024': 78104,
'EGYPTIAN HIEROGLYPH F025': 78105,
'EGYPTIAN HIEROGLYPH F026': 78106,
'EGYPTIAN HIEROGLYPH F027': 78107,
'EGYPTIAN HIEROGLYPH F028': 78108,
'EGYPTIAN HIEROGLYPH F029': 78109,
'EGYPTIAN HIEROGLYPH F030': 78110,
'EGYPTIAN HIEROGLYPH F031': 78111,
'EGYPTIAN HIEROGLYPH F031A': 78112,
'EGYPTIAN HIEROGLYPH F032': 78113,
'EGYPTIAN HIEROGLYPH F033': 78114,
'EGYPTIAN HIEROGLYPH F034': 78115,
'EGYPTIAN HIEROGLYPH F035': 78116,
'EGYPTIAN HIEROGLYPH F036': 78117,
'EGYPTIAN HIEROGLYPH F037': 78118,
'EGYPTIAN HIEROGLYPH F037A': 78119,
'EGYPTIAN HIEROGLYPH F038': 78120,
'EGYPTIAN HIEROGLYPH F038A': 78121,
'EGYPTIAN HIEROGLYPH F039': 78122,
'EGYPTIAN HIEROGLYPH F040': 78123,
'EGYPTIAN HIEROGLYPH F041': 78124,
'EGYPTIAN HIEROGLYPH F042': 78125,
'EGYPTIAN HIEROGLYPH F043': 78126,
'EGYPTIAN HIEROGLYPH F044': 78127,
'EGYPTIAN HIEROGLYPH F045': 78128,
'EGYPTIAN HIEROGLYPH F045A': 78129,
'EGYPTIAN HIEROGLYPH F046': 78130,
'EGYPTIAN HIEROGLYPH F046A': 78131,
'EGYPTIAN HIEROGLYPH F047': 78132,
'EGYPTIAN HIEROGLYPH F047A': 78133,
'EGYPTIAN HIEROGLYPH F048': 78134,
'EGYPTIAN HIEROGLYPH F049': 78135,
'EGYPTIAN HIEROGLYPH F050': 78136,
'EGYPTIAN HIEROGLYPH F051': 78137,
'EGYPTIAN HIEROGLYPH F051A': 78138,
'EGYPTIAN HIEROGLYPH F051B': 78139,
'EGYPTIAN HIEROGLYPH F051C': 78140,
'EGYPTIAN HIEROGLYPH F052': 78141,
'EGYPTIAN HIEROGLYPH F053': 78142,
'EGYPTIAN HIEROGLYPH G001': 78143,
'EGYPTIAN HIEROGLYPH G002': 78144,
'EGYPTIAN HIEROGLYPH G003': 78145,
'EGYPTIAN HIEROGLYPH G004': 78146,
'EGYPTIAN HIEROGLYPH G005': 78147,
'EGYPTIAN HIEROGLYPH G006': 78148,
'EGYPTIAN HIEROGLYPH G006A': 78149,
'EGYPTIAN HIEROGLYPH G007': 78150,
'EGYPTIAN HIEROGLYPH G007A': 78151,
'EGYPTIAN HIEROGLYPH G007B': 78152,
'EGYPTIAN HIEROGLYPH G008': 78153,
'EGYPTIAN HIEROGLYPH G009': 78154,
'EGYPTIAN HIEROGLYPH G010': 78155,
'EGYPTIAN HIEROGLYPH G011': 78156,
'EGYPTIAN HIEROGLYPH G011A': 78157,
'EGYPTIAN HIEROGLYPH G012': 78158,
'EGYPTIAN HIEROGLYPH G013': 78159,
'EGYPTIAN HIEROGLYPH G014': 78160,
'EGYPTIAN HIEROGLYPH G015': 78161,
'EGYPTIAN HIEROGLYPH G016': 78162,
'EGYPTIAN HIEROGLYPH G017': 78163,
'EGYPTIAN HIEROGLYPH G018': 78164,
'EGYPTIAN HIEROGLYPH G019': 78165,
'EGYPTIAN HIEROGLYPH G020': 78166,
'EGYPTIAN HIEROGLYPH G020A': 78167,
'EGYPTIAN HIEROGLYPH G021': 78168,
'EGYPTIAN HIEROGLYPH G022': 78169,
'EGYPTIAN HIEROGLYPH G023': 78170,
'EGYPTIAN HIEROGLYPH G024': 78171,
'EGYPTIAN HIEROGLYPH G025': 78172,
'EGYPTIAN HIEROGLYPH G026': 78173,
'EGYPTIAN HIEROGLYPH G026A': 78174,
'EGYPTIAN HIEROGLYPH G027': 78175,
'EGYPTIAN HIEROGLYPH G028': 78176,
'EGYPTIAN HIEROGLYPH G029': 78177,
'EGYPTIAN HIEROGLYPH G030': 78178,
'EGYPTIAN HIEROGLYPH G031': 78179,
'EGYPTIAN HIEROGLYPH G032': 78180,
'EGYPTIAN HIEROGLYPH G033': 78181,
'EGYPTIAN HIEROGLYPH G034': 78182,
'EGYPTIAN HIEROGLYPH G035': 78183,
'EGYPTIAN HIEROGLYPH G036': 78184,
'EGYPTIAN HIEROGLYPH G036A': 78185,
'EGYPTIAN HIEROGLYPH G037': 78186,
'EGYPTIAN HIEROGLYPH G037A': 78187,
'EGYPTIAN HIEROGLYPH G038': 78188,
'EGYPTIAN HIEROGLYPH G039': 78189,
'EGYPTIAN HIEROGLYPH G040': 78190,
'EGYPTIAN HIEROGLYPH G041': 78191,
'EGYPTIAN HIEROGLYPH G042': 78192,
'EGYPTIAN HIEROGLYPH G043': 78193,
'EGYPTIAN HIEROGLYPH G043A': 78194,
'EGYPTIAN HIEROGLYPH G044': 78195,
'EGYPTIAN HIEROGLYPH G045': 78196,
'EGYPTIAN HIEROGLYPH G045A': 78197,
'EGYPTIAN HIEROGLYPH G046': 78198,
'EGYPTIAN HIEROGLYPH G047': 78199,
'EGYPTIAN HIEROGLYPH G048': 78200,
'EGYPTIAN HIEROGLYPH G049': 78201,
'EGYPTIAN HIEROGLYPH G050': 78202,
'EGYPTIAN HIEROGLYPH G051': 78203,
'EGYPTIAN HIEROGLYPH G052': 78204,
'EGYPTIAN HIEROGLYPH G053': 78205,
'EGYPTIAN HIEROGLYPH G054': 78206,
'EGYPTIAN HIEROGLYPH H001': 78207,
'EGYPTIAN HIEROGLYPH H002': 78208,
'EGYPTIAN HIEROGLYPH H003': 78209,
'EGYPTIAN HIEROGLYPH H004': 78210,
'EGYPTIAN HIEROGLYPH H005': 78211,
'EGYPTIAN HIEROGLYPH H006': 78212,
'EGYPTIAN HIEROGLYPH H006A': 78213,
'EGYPTIAN HIEROGLYPH H007': 78214,
'EGYPTIAN HIEROGLYPH H008': 78215,
'EGYPTIAN HIEROGLYPH I001': 78216,
'EGYPTIAN HIEROGLYPH I002': 78217,
'EGYPTIAN HIEROGLYPH I003': 78218,
'EGYPTIAN HIEROGLYPH I004': 78219,
'EGYPTIAN HIEROGLYPH I005': 78220,
'EGYPTIAN HIEROGLYPH I005A': 78221,
'EGYPTIAN HIEROGLYPH I006': 78222,
'EGYPTIAN HIEROGLYPH I007': 78223,
'EGYPTIAN HIEROGLYPH I008': 78224,
'EGYPTIAN HIEROGLYPH I009': 78225,
'EGYPTIAN HIEROGLYPH I009A': 78226,
'EGYPTIAN HIEROGLYPH I010': 78227,
'EGYPTIAN HIEROGLYPH I010A': 78228,
'EGYPTIAN HIEROGLYPH I011': 78229,
'EGYPTIAN HIEROGLYPH I011A': 78230,
'EGYPTIAN HIEROGLYPH I012': 78231,
'EGYPTIAN HIEROGLYPH I013': 78232,
'EGYPTIAN HIEROGLYPH I014': 78233,
'EGYPTIAN HIEROGLYPH I015': 78234,
'EGYPTIAN HIEROGLYPH K001': 78235,
'EGYPTIAN HIEROGLYPH K002': 78236,
'EGYPTIAN HIEROGLYPH K003': 78237,
'EGYPTIAN HIEROGLYPH K004': 78238,
'EGYPTIAN HIEROGLYPH K005': 78239,
'EGYPTIAN HIEROGLYPH K006': 78240,
'EGYPTIAN HIEROGLYPH K007': 78241,
'EGYPTIAN HIEROGLYPH K008': 78242,
'EGYPTIAN HIEROGLYPH L001': 78243,
'EGYPTIAN HIEROGLYPH L002': 78244,
'EGYPTIAN HIEROGLYPH L002A': 78245,
'EGYPTIAN HIEROGLYPH L003': 78246,
'EGYPTIAN HIEROGLYPH L004': 78247,
'EGYPTIAN HIEROGLYPH L005': 78248,
'EGYPTIAN HIEROGLYPH L006': 78249,
'EGYPTIAN HIEROGLYPH L006A': 78250,
'EGYPTIAN HIEROGLYPH L007': 78251,
'EGYPTIAN HIEROGLYPH L008': 78252,
'EGYPTIAN HIEROGLYPH M001': 78253,
'EGYPTIAN HIEROGLYPH M001A': 78254,
'EGYPTIAN HIEROGLYPH M001B': 78255,
'EGYPTIAN HIEROGLYPH M002': 78256,
'EGYPTIAN HIEROGLYPH M003': 78257,
'EGYPTIAN HIEROGLYPH M003A': 78258,
'EGYPTIAN HIEROGLYPH M004': 78259,
'EGYPTIAN HIEROGLYPH M005': 78260,
'EGYPTIAN HIEROGLYPH M006': 78261,
'EGYPTIAN HIEROGLYPH M007': 78262,
'EGYPTIAN HIEROGLYPH M008': 78263,
'EGYPTIAN HIEROGLYPH M009': 78264,
'EGYPTIAN HIEROGLYPH M010': 78265,
'EGYPTIAN HIEROGLYPH M010A': 78266,
'EGYPTIAN HIEROGLYPH M011': 78267,
'EGYPTIAN HIEROGLYPH M012': 78268,
'EGYPTIAN HIEROGLYPH M012A': 78269,
'EGYPTIAN HIEROGLYPH M012B': 78270,
'EGYPTIAN HIEROGLYPH M012C': 78271,
'EGYPTIAN HIEROGLYPH M012D': 78272,
'EGYPTIAN HIEROGLYPH M012E': 78273,
'EGYPTIAN HIEROGLYPH M012F': 78274,
'EGYPTIAN HIEROGLYPH M012G': 78275,
'EGYPTIAN HIEROGLYPH M012H': 78276,
'EGYPTIAN HIEROGLYPH M013': 78277,
'EGYPTIAN HIEROGLYPH M014': 78278,
'EGYPTIAN HIEROGLYPH M015': 78279,
'EGYPTIAN HIEROGLYPH M015A': 78280,
'EGYPTIAN HIEROGLYPH M016': 78281,
'EGYPTIAN HIEROGLYPH M016A': 78282,
'EGYPTIAN HIEROGLYPH M017': 78283,
'EGYPTIAN HIEROGLYPH M017A': 78284,
'EGYPTIAN HIEROGLYPH M018': 78285,
'EGYPTIAN HIEROGLYPH M019': 78286,
'EGYPTIAN HIEROGLYPH M020': 78287,
'EGYPTIAN HIEROGLYPH M021': 78288,
'EGYPTIAN HIEROGLYPH M022': 78289,
'EGYPTIAN HIEROGLYPH M022A': 78290,
'EGYPTIAN HIEROGLYPH M023': 78291,
'EGYPTIAN HIEROGLYPH M024': 78292,
'EGYPTIAN HIEROGLYPH M024A': 78293,
'EGYPTIAN HIEROGLYPH M025': 78294,
'EGYPTIAN HIEROGLYPH M026': 78295,
'EGYPTIAN HIEROGLYPH M027': 78296,
'EGYPTIAN HIEROGLYPH M028': 78297,
'EGYPTIAN HIEROGLYPH M028A': 78298,
'EGYPTIAN HIEROGLYPH M029': 78299,
'EGYPTIAN HIEROGLYPH M030': 78300,
'EGYPTIAN HIEROGLYPH M031': 78301,
'EGYPTIAN HIEROGLYPH M031A': 78302,
'EGYPTIAN HIEROGLYPH M032': 78303,
'EGYPTIAN HIEROGLYPH M033': 78304,
'EGYPTIAN HIEROGLYPH M033A': 78305,
'EGYPTIAN HIEROGLYPH M033B': 78306,
'EGYPTIAN HIEROGLYPH M034': 78307,
'EGYPTIAN HIEROGLYPH M035': 78308,
'EGYPTIAN HIEROGLYPH M036': 78309,
'EGYPTIAN HIEROGLYPH M037': 78310,
'EGYPTIAN HIEROGLYPH M038': 78311,
'EGYPTIAN HIEROGLYPH M039': 78312,
'EGYPTIAN HIEROGLYPH M040': 78313,
'EGYPTIAN HIEROGLYPH M040A': 78314,
'EGYPTIAN HIEROGLYPH M041': 78315,
'EGYPTIAN HIEROGLYPH M042': 78316,
'EGYPTIAN HIEROGLYPH M043': 78317,
'EGYPTIAN HIEROGLYPH M044': 78318,
'EGYPTIAN HIEROGLYPH N001': 78319,
'EGYPTIAN HIEROGLYPH N002': 78320,
'EGYPTIAN HIEROGLYPH N003': 78321,
'EGYPTIAN HIEROGLYPH N004': 78322,
'EGYPTIAN HIEROGLYPH N005': 78323,
'EGYPTIAN HIEROGLYPH N006': 78324,
'EGYPTIAN HIEROGLYPH N007': 78325,
'EGYPTIAN HIEROGLYPH N008': 78326,
'EGYPTIAN HIEROGLYPH N009': 78327,
'EGYPTIAN HIEROGLYPH N010': 78328,
'EGYPTIAN HIEROGLYPH N011': 78329,
'EGYPTIAN HIEROGLYPH N012': 78330,
'EGYPTIAN HIEROGLYPH N013': 78331,
'EGYPTIAN HIEROGLYPH N014': 78332,
'EGYPTIAN HIEROGLYPH N015': 78333,
'EGYPTIAN HIEROGLYPH N016': 78334,
'EGYPTIAN HIEROGLYPH N017': 78335,
'EGYPTIAN HIEROGLYPH N018': 78336,
'EGYPTIAN HIEROGLYPH N018A': 78337,
'EGYPTIAN HIEROGLYPH N018B': 78338,
'EGYPTIAN HIEROGLYPH N019': 78339,
'EGYPTIAN HIEROGLYPH N020': 78340,
'EGYPTIAN HIEROGLYPH N021': 78341,
'EGYPTIAN HIEROGLYPH N022': 78342,
'EGYPTIAN HIEROGLYPH N023': 78343,
'EGYPTIAN HIEROGLYPH N024': 78344,
'EGYPTIAN HIEROGLYPH N025': 78345,
'EGYPTIAN HIEROGLYPH N025A': 78346,
'EGYPTIAN HIEROGLYPH N026': 78347,
'EGYPTIAN HIEROGLYPH N027': 78348,
'EGYPTIAN HIEROGLYPH N028': 78349,
'EGYPTIAN HIEROGLYPH N029': 78350,
'EGYPTIAN HIEROGLYPH N030': 78351,
'EGYPTIAN HIEROGLYPH N031': 78352,
'EGYPTIAN HIEROGLYPH N032': 78353,
'EGYPTIAN HIEROGLYPH N033': 78354,
'EGYPTIAN HIEROGLYPH N033A': 78355,
'EGYPTIAN HIEROGLYPH N034': 78356,
'EGYPTIAN HIEROGLYPH N034A': 78357,
'EGYPTIAN HIEROGLYPH N035': 78358,
'EGYPTIAN HIEROGLYPH N035A': 78359,
'EGYPTIAN HIEROGLYPH N036': 78360,
'EGYPTIAN HIEROGLYPH N037': 78361,
'EGYPTIAN HIEROGLYPH N037A': 78362,
'EGYPTIAN HIEROGLYPH N038': 78363,
'EGYPTIAN HIEROGLYPH N039': 78364,
'EGYPTIAN HIEROGLYPH N040': 78365,
'EGYPTIAN HIEROGLYPH N041': 78366,
'EGYPTIAN HIEROGLYPH N042': 78367,
'EGYPTIAN HIEROGLYPH NL001': 78368,
'EGYPTIAN HIEROGLYPH NL002': 78369,
'EGYPTIAN HIEROGLYPH NL003': 78370,
'EGYPTIAN HIEROGLYPH NL004': 78371,
'EGYPTIAN HIEROGLYPH NL005': 78372,
'EGYPTIAN HIEROGLYPH NL005A': 78373,
'EGYPTIAN HIEROGLYPH NL006': 78374,
'EGYPTIAN HIEROGLYPH NL007': 78375,
'EGYPTIAN HIEROGLYPH NL008': 78376,
'EGYPTIAN HIEROGLYPH NL009': 78377,
'EGYPTIAN HIEROGLYPH NL010': 78378,
'EGYPTIAN HIEROGLYPH NL011': 78379,
'EGYPTIAN HIEROGLYPH NL012': 78380,
'EGYPTIAN HIEROGLYPH NL013': 78381,
'EGYPTIAN HIEROGLYPH NL014': 78382,
'EGYPTIAN HIEROGLYPH NL015': 78383,
'EGYPTIAN HIEROGLYPH NL016': 78384,
'EGYPTIAN HIEROGLYPH NL017': 78385,
'EGYPTIAN HIEROGLYPH NL017A': 78386,
'EGYPTIAN HIEROGLYPH NL018': 78387,
'EGYPTIAN HIEROGLYPH NL019': 78388,
'EGYPTIAN HIEROGLYPH NL020': 78389,
'EGYPTIAN HIEROGLYPH NU001': 78390,
'EGYPTIAN HIEROGLYPH NU002': 78391,
'EGYPTIAN HIEROGLYPH NU003': 78392,
'EGYPTIAN HIEROGLYPH NU004': 78393,
'EGYPTIAN HIEROGLYPH NU005': 78394,
'EGYPTIAN HIEROGLYPH NU006': 78395,
'EGYPTIAN HIEROGLYPH NU007': 78396,
'EGYPTIAN HIEROGLYPH NU008': 78397,
'EGYPTIAN HIEROGLYPH NU009': 78398,
'EGYPTIAN HIEROGLYPH NU010': 78399,
'EGYPTIAN HIEROGLYPH NU010A': 78400,
'EGYPTIAN HIEROGLYPH NU011': 78401,
'EGYPTIAN HIEROGLYPH NU011A': 78402,
'EGYPTIAN HIEROGLYPH NU012': 78403,
'EGYPTIAN HIEROGLYPH NU013': 78404,
'EGYPTIAN HIEROGLYPH NU014': 78405,
'EGYPTIAN HIEROGLYPH NU015': 78406,
'EGYPTIAN HIEROGLYPH NU016': 78407,
'EGYPTIAN HIEROGLYPH NU017': 78408,
'EGYPTIAN HIEROGLYPH NU018': 78409,
'EGYPTIAN HIEROGLYPH NU018A': 78410,
'EGYPTIAN HIEROGLYPH NU019': 78411,
'EGYPTIAN HIEROGLYPH NU020': 78412,
'EGYPTIAN HIEROGLYPH NU021': 78413,
'EGYPTIAN HIEROGLYPH NU022': 78414,
'EGYPTIAN HIEROGLYPH NU022A': 78415,
'EGYPTIAN HIEROGLYPH O001': 78416,
'EGYPTIAN HIEROGLYPH O001A': 78417,
'EGYPTIAN HIEROGLYPH O002': 78418,
'EGYPTIAN HIEROGLYPH O003': 78419,
'EGYPTIAN HIEROGLYPH O004': 78420,
'EGYPTIAN HIEROGLYPH O005': 78421,
'EGYPTIAN HIEROGLYPH O005A': 78422,
'EGYPTIAN HIEROGLYPH O006': 78423,
'EGYPTIAN HIEROGLYPH O006A': 78424,
'EGYPTIAN HIEROGLYPH O006B': 78425,
'EGYPTIAN HIEROGLYPH O006C': 78426,
'EGYPTIAN HIEROGLYPH O006D': 78427,
'EGYPTIAN HIEROGLYPH O006E': 78428,
'EGYPTIAN HIEROGLYPH O006F': 78429,
'EGYPTIAN HIEROGLYPH O007': 78430,
'EGYPTIAN HIEROGLYPH O008': 78431,
'EGYPTIAN HIEROGLYPH O009': 78432,
'EGYPTIAN HIEROGLYPH O010': 78433,
'EGYPTIAN HIEROGLYPH O010A': 78434,
'EGYPTIAN HIEROGLYPH O010B': 78435,
'EGYPTIAN HIEROGLYPH O010C': 78436,
'EGYPTIAN HIEROGLYPH O011': 78437,
'EGYPTIAN HIEROGLYPH O012': 78438,
'EGYPTIAN HIEROGLYPH O013': 78439,
'EGYPTIAN HIEROGLYPH O014': 78440,
'EGYPTIAN HIEROGLYPH O015': 78441,
'EGYPTIAN HIEROGLYPH O016': 78442,
'EGYPTIAN HIEROGLYPH O017': 78443,
'EGYPTIAN HIEROGLYPH O018': 78444,
'EGYPTIAN HIEROGLYPH O019': 78445,
'EGYPTIAN HIEROGLYPH O019A': 78446,
'EGYPTIAN HIEROGLYPH O020': 78447,
'EGYPTIAN HIEROGLYPH O020A': 78448,
'EGYPTIAN HIEROGLYPH O021': 78449,
'EGYPTIAN HIEROGLYPH O022': 78450,
'EGYPTIAN HIEROGLYPH O023': 78451,
'EGYPTIAN HIEROGLYPH O024': 78452,
'EGYPTIAN HIEROGLYPH O024A': 78453,
'EGYPTIAN HIEROGLYPH O025': 78454,
'EGYPTIAN HIEROGLYPH O025A': 78455,
'EGYPTIAN HIEROGLYPH O026': 78456,
'EGYPTIAN HIEROGLYPH O027': 78457,
'EGYPTIAN HIEROGLYPH O028': 78458,
'EGYPTIAN HIEROGLYPH O029': 78459,
'EGYPTIAN HIEROGLYPH O029A': 78460,
'EGYPTIAN HIEROGLYPH O030': 78461,
'EGYPTIAN HIEROGLYPH O030A': 78462,
'EGYPTIAN HIEROGLYPH O031': 78463,
'EGYPTIAN HIEROGLYPH O032': 78464,
'EGYPTIAN HIEROGLYPH O033': 78465,
'EGYPTIAN HIEROGLYPH O033A': 78466,
'EGYPTIAN HIEROGLYPH O034': 78467,
'EGYPTIAN HIEROGLYPH O035': 78468,
'EGYPTIAN HIEROGLYPH O036': 78469,
'EGYPTIAN HIEROGLYPH O036A': 78470,
'EGYPTIAN HIEROGLYPH O036B': 78471,
'EGYPTIAN HIEROGLYPH O036C': 78472,
'EGYPTIAN HIEROGLYPH O036D': 78473,
'EGYPTIAN HIEROGLYPH O037': 78474,
'EGYPTIAN HIEROGLYPH O038': 78475,
'EGYPTIAN HIEROGLYPH O039': 78476,
'EGYPTIAN HIEROGLYPH O040': 78477,
'EGYPTIAN HIEROGLYPH O041': 78478,
'EGYPTIAN HIEROGLYPH O042': 78479,
'EGYPTIAN HIEROGLYPH O043': 78480,
'EGYPTIAN HIEROGLYPH O044': 78481,
'EGYPTIAN HIEROGLYPH O045': 78482,
'EGYPTIAN HIEROGLYPH O046': 78483,
'EGYPTIAN HIEROGLYPH O047': 78484,
'EGYPTIAN HIEROGLYPH O048': 78485,
'EGYPTIAN HIEROGLYPH O049': 78486,
'EGYPTIAN HIEROGLYPH O050': 78487,
'EGYPTIAN HIEROGLYPH O050A': 78488,
'EGYPTIAN HIEROGLYPH O050B': 78489,
'EGYPTIAN HIEROGLYPH O051': 78490,
'EGYPTIAN HIEROGLYPH P001': 78491,
'EGYPTIAN HIEROGLYPH P001A': 78492,
'EGYPTIAN HIEROGLYPH P002': 78493,
'EGYPTIAN HIEROGLYPH P003': 78494,
'EGYPTIAN HIEROGLYPH P003A': 78495,
'EGYPTIAN HIEROGLYPH P004': 78496,
'EGYPTIAN HIEROGLYPH P005': 78497,
'EGYPTIAN HIEROGLYPH P006': 78498,
'EGYPTIAN HIEROGLYPH P007': 78499,
'EGYPTIAN HIEROGLYPH P008': 78500,
'EGYPTIAN HIEROGLYPH P009': 78501,
'EGYPTIAN HIEROGLYPH P010': 78502,
'EGYPTIAN HIEROGLYPH P011': 78503,
'EGYPTIAN HIEROGLYPH Q001': 78504,
'EGYPTIAN HIEROGLYPH Q002': 78505,
'EGYPTIAN HIEROGLYPH Q003': 78506,
'EGYPTIAN HIEROGLYPH Q004': 78507,
'EGYPTIAN HIEROGLYPH Q005': 78508,
'EGYPTIAN HIEROGLYPH Q006': 78509,
'EGYPTIAN HIEROGLYPH Q007': 78510,
'EGYPTIAN HIEROGLYPH R001': 78511,
'EGYPTIAN HIEROGLYPH R002': 78512,
'EGYPTIAN HIEROGLYPH R002A': 78513,
'EGYPTIAN HIEROGLYPH R003': 78514,
'EGYPTIAN HIEROGLYPH R003A': 78515,
'EGYPTIAN HIEROGLYPH R003B': 78516,
'EGYPTIAN HIEROGLYPH R004': 78517,
'EGYPTIAN HIEROGLYPH R005': 78518,
'EGYPTIAN HIEROGLYPH R006': 78519,
'EGYPTIAN HIEROGLYPH R007': 78520,
'EGYPTIAN HIEROGLYPH R008': 78521,
'EGYPTIAN HIEROGLYPH R009': 78522,
'EGYPTIAN HIEROGLYPH R010': 78523,
'EGYPTIAN HIEROGLYPH R010A': 78524,
'EGYPTIAN HIEROGLYPH R011': 78525,
'EGYPTIAN HIEROGLYPH R012': 78526,
'EGYPTIAN HIEROGLYPH R013': 78527,
'EGYPTIAN HIEROGLYPH R014': 78528,
'EGYPTIAN HIEROGLYPH R015': 78529,
'EGYPTIAN HIEROGLYPH R016': 78530,
'EGYPTIAN HIEROGLYPH R016A': 78531,
'EGYPTIAN HIEROGLYPH R017': 78532,
'EGYPTIAN HIEROGLYPH R018': 78533,
'EGYPTIAN HIEROGLYPH R019': 78534,
'EGYPTIAN HIEROGLYPH R020': 78535,
'EGYPTIAN HIEROGLYPH R021': 78536,
'EGYPTIAN HIEROGLYPH R022': 78537,
'EGYPTIAN HIEROGLYPH R023': 78538,
'EGYPTIAN HIEROGLYPH R024': 78539,
'EGYPTIAN HIEROGLYPH R025': 78540,
'EGYPTIAN HIEROGLYPH R026': 78541,
'EGYPTIAN HIEROGLYPH R027': 78542,
'EGYPTIAN HIEROGLYPH R028': 78543,
'EGYPTIAN HIEROGLYPH R029': 78544,
'EGYPTIAN HIEROGLYPH S001': 78545,
'EGYPTIAN HIEROGLYPH S002': 78546,
'EGYPTIAN HIEROGLYPH S002A': 78547,
'EGYPTIAN HIEROGLYPH S003': 78548,
'EGYPTIAN HIEROGLYPH S004': 78549,
'EGYPTIAN HIEROGLYPH S005': 78550,
'EGYPTIAN HIEROGLYPH S006': 78551,
'EGYPTIAN HIEROGLYPH S006A': 78552,
'EGYPTIAN HIEROGLYPH S007': 78553,
'EGYPTIAN HIEROGLYPH S008': 78554,
'EGYPTIAN HIEROGLYPH S009': 78555,
'EGYPTIAN HIEROGLYPH S010': 78556,
'EGYPTIAN HIEROGLYPH S011': 78557,
'EGYPTIAN HIEROGLYPH S012': 78558,
'EGYPTIAN HIEROGLYPH S013': 78559,
'EGYPTIAN HIEROGLYPH S014': 78560,
'EGYPTIAN HIEROGLYPH S014A': 78561,
'EGYPTIAN HIEROGLYPH S014B': 78562,
'EGYPTIAN HIEROGLYPH S015': 78563,
'EGYPTIAN HIEROGLYPH S016': 78564,
'EGYPTIAN HIEROGLYPH S017': 78565,
'EGYPTIAN HIEROGLYPH S017A': 78566,
'EGYPTIAN HIEROGLYPH S018': 78567,
'EGYPTIAN HIEROGLYPH S019': 78568,
'EGYPTIAN HIEROGLYPH S020': 78569,
'EGYPTIAN HIEROGLYPH S021': 78570,
'EGYPTIAN HIEROGLYPH S022': 78571,
'EGYPTIAN HIEROGLYPH S023': 78572,
'EGYPTIAN HIEROGLYPH S024': 78573,
'EGYPTIAN HIEROGLYPH S025': 78574,
'EGYPTIAN HIEROGLYPH S026': 78575,
'EGYPTIAN HIEROGLYPH S026A': 78576,
'EGYPTIAN HIEROGLYPH S026B': 78577,
'EGYPTIAN HIEROGLYPH S027': 78578,
'EGYPTIAN HIEROGLYPH S028': 78579,
'EGYPTIAN HIEROGLYPH S029': 78580,
'EGYPTIAN HIEROGLYPH S030': 78581,
'EGYPTIAN HIEROGLYPH S031': 78582,
'EGYPTIAN HIEROGLYPH S032': 78583,
'EGYPTIAN HIEROGLYPH S033': 78584,
'EGYPTIAN HIEROGLYPH S034': 78585,
'EGYPTIAN HIEROGLYPH S035': 78586,
'EGYPTIAN HIEROGLYPH S035A': 78587,
'EGYPTIAN HIEROGLYPH S036': 78588,
'EGYPTIAN HIEROGLYPH S037': 78589,
'EGYPTIAN HIEROGLYPH S038': 78590,
'EGYPTIAN HIEROGLYPH S039': 78591,
'EGYPTIAN HIEROGLYPH S040': 78592,
'EGYPTIAN HIEROGLYPH S041': 78593,
'EGYPTIAN HIEROGLYPH S042': 78594,
'EGYPTIAN HIEROGLYPH S043': 78595,
'EGYPTIAN HIEROGLYPH S044': 78596,
'EGYPTIAN HIEROGLYPH S045': 78597,
'EGYPTIAN HIEROGLYPH S046': 78598,
'EGYPTIAN HIEROGLYPH T001': 78599,
'EGYPTIAN HIEROGLYPH T002': 78600,
'EGYPTIAN HIEROGLYPH T003': 78601,
'EGYPTIAN HIEROGLYPH T003A': 78602,
'EGYPTIAN HIEROGLYPH T004': 78603,
'EGYPTIAN HIEROGLYPH T005': 78604,
'EGYPTIAN HIEROGLYPH T006': 78605,
'EGYPTIAN HIEROGLYPH T007': 78606,
'EGYPTIAN HIEROGLYPH T007A': 78607,
'EGYPTIAN HIEROGLYPH T008': 78608,
'EGYPTIAN HIEROGLYPH T008A': 78609,
'EGYPTIAN HIEROGLYPH T009': 78610,
'EGYPTIAN HIEROGLYPH T009A': 78611,
'EGYPTIAN HIEROGLYPH T010': 78612,
'EGYPTIAN HIEROGLYPH T011': 78613,
'EGYPTIAN HIEROGLYPH T011A': 78614,
'EGYPTIAN HIEROGLYPH T012': 78615,
'EGYPTIAN HIEROGLYPH T013': 78616,
'EGYPTIAN HIEROGLYPH T014': 78617,
'EGYPTIAN HIEROGLYPH T015': 78618,
'EGYPTIAN HIEROGLYPH T016': 78619,
'EGYPTIAN HIEROGLYPH T016A': 78620,
'EGYPTIAN HIEROGLYPH T017': 78621,
'EGYPTIAN HIEROGLYPH T018': 78622,
'EGYPTIAN HIEROGLYPH T019': 78623,
'EGYPTIAN HIEROGLYPH T020': 78624,
'EGYPTIAN HIEROGLYPH T021': 78625,
'EGYPTIAN HIEROGLYPH T022': 78626,
'EGYPTIAN HIEROGLYPH T023': 78627,
'EGYPTIAN HIEROGLYPH T024': 78628,
'EGYPTIAN HIEROGLYPH T025': 78629,
'EGYPTIAN HIEROGLYPH T026': 78630,
'EGYPTIAN HIEROGLYPH T027': 78631,
'EGYPTIAN HIEROGLYPH T028': 78632,
'EGYPTIAN HIEROGLYPH T029': 78633,
'EGYPTIAN HIEROGLYPH T030': 78634,
'EGYPTIAN HIEROGLYPH T031': 78635,
'EGYPTIAN HIEROGLYPH T032': 78636,
'EGYPTIAN HIEROGLYPH T032A': 78637,
'EGYPTIAN HIEROGLYPH T033': 78638,
'EGYPTIAN HIEROGLYPH T033A': 78639,
'EGYPTIAN HIEROGLYPH T034': 78640,
'EGYPTIAN HIEROGLYPH T035': 78641,
'EGYPTIAN HIEROGLYPH T036': 78642,
'EGYPTIAN HIEROGLYPH U001': 78643,
'EGYPTIAN HIEROGLYPH U002': 78644,
'EGYPTIAN HIEROGLYPH U003': 78645,
'EGYPTIAN HIEROGLYPH U004': 78646,
'EGYPTIAN HIEROGLYPH U005': 78647,
'EGYPTIAN HIEROGLYPH U006': 78648,
'EGYPTIAN HIEROGLYPH U006A': 78649,
'EGYPTIAN HIEROGLYPH U006B': 78650,
'EGYPTIAN HIEROGLYPH U007': 78651,
'EGYPTIAN HIEROGLYPH U008': 78652,
'EGYPTIAN HIEROGLYPH U009': 78653,
'EGYPTIAN HIEROGLYPH U010': 78654,
'EGYPTIAN HIEROGLYPH U011': 78655,
'EGYPTIAN HIEROGLYPH U012': 78656,
'EGYPTIAN HIEROGLYPH U013': 78657,
'EGYPTIAN HIEROGLYPH U014': 78658,
'EGYPTIAN HIEROGLYPH U015': 78659,
'EGYPTIAN HIEROGLYPH U016': 78660,
'EGYPTIAN HIEROGLYPH U017': 78661,
'EGYPTIAN HIEROGLYPH U018': 78662,
'EGYPTIAN HIEROGLYPH U019': 78663,
'EGYPTIAN HIEROGLYPH U020': 78664,
'EGYPTIAN HIEROGLYPH U021': 78665,
'EGYPTIAN HIEROGLYPH U022': 78666,
'EGYPTIAN HIEROGLYPH U023': 78667,
'EGYPTIAN HIEROGLYPH U023A': 78668,
'EGYPTIAN HIEROGLYPH U024': 78669,
'EGYPTIAN HIEROGLYPH U025': 78670,
'EGYPTIAN HIEROGLYPH U026': 78671,
'EGYPTIAN HIEROGLYPH U027': 78672,
'EGYPTIAN HIEROGLYPH U028': 78673,
'EGYPTIAN HIEROGLYPH U029': 78674,
'EGYPTIAN HIEROGLYPH U029A': 78675,
'EGYPTIAN HIEROGLYPH U030': 78676,
'EGYPTIAN HIEROGLYPH U031': 78677,
'EGYPTIAN HIEROGLYPH U032': 78678,
'EGYPTIAN HIEROGLYPH U032A': 78679,
'EGYPTIAN HIEROGLYPH U033': 78680,
'EGYPTIAN HIEROGLYPH U034': 78681,
'EGYPTIAN HIEROGLYPH U035': 78682,
'EGYPTIAN HIEROGLYPH U036': 78683,
'EGYPTIAN HIEROGLYPH U037': 78684,
'EGYPTIAN HIEROGLYPH U038': 78685,
'EGYPTIAN HIEROGLYPH U039': 78686,
'EGYPTIAN HIEROGLYPH U040': 78687,
'EGYPTIAN HIEROGLYPH U041': 78688,
'EGYPTIAN HIEROGLYPH U042': 78689,
'EGYPTIAN HIEROGLYPH V001': 78690,
'EGYPTIAN HIEROGLYPH V001A': 78691,
'EGYPTIAN HIEROGLYPH V001B': 78692,
'EGYPTIAN HIEROGLYPH V001C': 78693,
'EGYPTIAN HIEROGLYPH V001D': 78694,
'EGYPTIAN HIEROGLYPH V001E': 78695,
'EGYPTIAN HIEROGLYPH V001F': 78696,
'EGYPTIAN HIEROGLYPH V001G': 78697,
'EGYPTIAN HIEROGLYPH V001H': 78698,
'EGYPTIAN HIEROGLYPH V001I': 78699,
'EGYPTIAN HIEROGLYPH V002': 78700,
'EGYPTIAN HIEROGLYPH V002A': 78701,
'EGYPTIAN HIEROGLYPH V003': 78702,
'EGYPTIAN HIEROGLYPH V004': 78703,
'EGYPTIAN HIEROGLYPH V005': 78704,
'EGYPTIAN HIEROGLYPH V006': 78705,
'EGYPTIAN HIEROGLYPH V007': 78706,
'EGYPTIAN HIEROGLYPH V007A': 78707,
'EGYPTIAN HIEROGLYPH V007B': 78708,
'EGYPTIAN HIEROGLYPH V008': 78709,
'EGYPTIAN HIEROGLYPH V009': 78710,
'EGYPTIAN HIEROGLYPH V010': 78711,
'EGYPTIAN HIEROGLYPH V011': 78712,
'EGYPTIAN HIEROGLYPH V011A': 78713,
'EGYPTIAN HIEROGLYPH V011B': 78714,
'EGYPTIAN HIEROGLYPH V011C': 78715,
'EGYPTIAN HIEROGLYPH V012': 78716,
'EGYPTIAN HIEROGLYPH V012A': 78717,
'EGYPTIAN HIEROGLYPH V012B': 78718,
'EGYPTIAN HIEROGLYPH V013': 78719,
'EGYPTIAN HIEROGLYPH V014': 78720,
'EGYPTIAN HIEROGLYPH V015': 78721,
'EGYPTIAN HIEROGLYPH V016': 78722,
'EGYPTIAN HIEROGLYPH V017': 78723,
'EGYPTIAN HIEROGLYPH V018': 78724,
'EGYPTIAN HIEROGLYPH V019': 78725,
'EGYPTIAN HIEROGLYPH V020': 78726,
'EGYPTIAN HIEROGLYPH V020A': 78727,
'EGYPTIAN HIEROGLYPH V020B': 78728,
'EGYPTIAN HIEROGLYPH V020C': 78729,
'EGYPTIAN HIEROGLYPH V020D': 78730,
'EGYPTIAN HIEROGLYPH V020E': 78731,
'EGYPTIAN HIEROGLYPH V020F': 78732,
'EGYPTIAN HIEROGLYPH V020G': 78733,
'EGYPTIAN HIEROGLYPH V020H': 78734,
'EGYPTIAN HIEROGLYPH V020I': 78735,
'EGYPTIAN HIEROGLYPH V020J': 78736,
'EGYPTIAN HIEROGLYPH V020K': 78737,
'EGYPTIAN HIEROGLYPH V020L': 78738,
'EGYPTIAN HIEROGLYPH V021': 78739,
'EGYPTIAN HIEROGLYPH V022': 78740,
'EGYPTIAN HIEROGLYPH V023': 78741,
'EGYPTIAN HIEROGLYPH V023A': 78742,
'EGYPTIAN HIEROGLYPH V024': 78743,
'EGYPTIAN HIEROGLYPH V025': 78744,
'EGYPTIAN HIEROGLYPH V026': 78745,
'EGYPTIAN HIEROGLYPH V027': 78746,
'EGYPTIAN HIEROGLYPH V028': 78747,
'EGYPTIAN HIEROGLYPH V028A': 78748,
'EGYPTIAN HIEROGLYPH V029': 78749,
'EGYPTIAN HIEROGLYPH V029A': 78750,
'EGYPTIAN HIEROGLYPH V030': 78751,
'EGYPTIAN HIEROGLYPH V030A': 78752,
'EGYPTIAN HIEROGLYPH V031': 78753,
'EGYPTIAN HIEROGLYPH V031A': 78754,
'EGYPTIAN HIEROGLYPH V032': 78755,
'EGYPTIAN HIEROGLYPH V033': 78756,
'EGYPTIAN HIEROGLYPH V033A': 78757,
'EGYPTIAN HIEROGLYPH V034': 78758,
'EGYPTIAN HIEROGLYPH V035': 78759,
'EGYPTIAN HIEROGLYPH V036': 78760,
'EGYPTIAN HIEROGLYPH V037': 78761,
'EGYPTIAN HIEROGLYPH V037A': 78762,
'EGYPTIAN HIEROGLYPH V038': 78763,
'EGYPTIAN HIEROGLYPH V039': 78764,
'EGYPTIAN HIEROGLYPH V040': 78765,
'EGYPTIAN HIEROGLYPH V040A': 78766,
'EGYPTIAN HIEROGLYPH W001': 78767,
'EGYPTIAN HIEROGLYPH W002': 78768,
'EGYPTIAN HIEROGLYPH W003': 78769,
'EGYPTIAN HIEROGLYPH W003A': 78770,
'EGYPTIAN HIEROGLYPH W004': 78771,
'EGYPTIAN HIEROGLYPH W005': 78772,
'EGYPTIAN HIEROGLYPH W006': 78773,
'EGYPTIAN HIEROGLYPH W007': 78774,
'EGYPTIAN HIEROGLYPH W008': 78775,
'EGYPTIAN HIEROGLYPH W009': 78776,
'EGYPTIAN HIEROGLYPH W009A': 78777,
'EGYPTIAN HIEROGLYPH W010': 78778,
'EGYPTIAN HIEROGLYPH W010A': 78779,
'EGYPTIAN HIEROGLYPH W011': 78780,
'EGYPTIAN HIEROGLYPH W012': 78781,
'EGYPTIAN HIEROGLYPH W013': 78782,
'EGYPTIAN HIEROGLYPH W014': 78783,
'EGYPTIAN HIEROGLYPH W014A': 78784,
'EGYPTIAN HIEROGLYPH W015': 78785,
'EGYPTIAN HIEROGLYPH W016': 78786,
'EGYPTIAN HIEROGLYPH W017': 78787,
'EGYPTIAN HIEROGLYPH W017A': 78788,
'EGYPTIAN HIEROGLYPH W018': 78789,
'EGYPTIAN HIEROGLYPH W018A': 78790,
'EGYPTIAN HIEROGLYPH W019': 78791,
'EGYPTIAN HIEROGLYPH W020': 78792,
'EGYPTIAN HIEROGLYPH W021': 78793,
'EGYPTIAN HIEROGLYPH W022': 78794,
'EGYPTIAN HIEROGLYPH W023': 78795,
'EGYPTIAN HIEROGLYPH W024': 78796,
'EGYPTIAN HIEROGLYPH W024A': 78797,
'EGYPTIAN HIEROGLYPH W025': 78798,
'EGYPTIAN HIEROGLYPH X001': 78799,
'EGYPTIAN HIEROGLYPH X002': 78800,
'EGYPTIAN HIEROGLYPH X003': 78801,
'EGYPTIAN HIEROGLYPH X004': 78802,
'EGYPTIAN HIEROGLYPH X004A': 78803,
'EGYPTIAN HIEROGLYPH X004B': 78804,
'EGYPTIAN HIEROGLYPH X005': 78805,
'EGYPTIAN HIEROGLYPH X006': 78806,
'EGYPTIAN HIEROGLYPH X006A': 78807,
'EGYPTIAN HIEROGLYPH X007': 78808,
'EGYPTIAN HIEROGLYPH X008': 78809,
'EGYPTIAN HIEROGLYPH X008A': 78810,
'EGYPTIAN HIEROGLYPH Y001': 78811,
'EGYPTIAN HIEROGLYPH Y001A': 78812,
'EGYPTIAN HIEROGLYPH Y002': 78813,
'EGYPTIAN HIEROGLYPH Y003': 78814,
'EGYPTIAN HIEROGLYPH Y004': 78815,
'EGYPTIAN HIEROGLYPH Y005': 78816,
'EGYPTIAN HIEROGLYPH Y006': 78817,
'EGYPTIAN HIEROGLYPH Y007': 78818,
'EGYPTIAN HIEROGLYPH Y008': 78819,
'EGYPTIAN HIEROGLYPH Z001': 78820,
'EGYPTIAN HIEROGLYPH Z002': 78821,
'EGYPTIAN HIEROGLYPH Z002A': 78822,
'EGYPTIAN HIEROGLYPH Z002B': 78823,
'EGYPTIAN HIEROGLYPH Z002C': 78824,
'EGYPTIAN HIEROGLYPH Z002D': 78825,
'EGYPTIAN HIEROGLYPH Z003': 78826,
'EGYPTIAN HIEROGLYPH Z003A': 78827,
'EGYPTIAN HIEROGLYPH Z003B': 78828,
'EGYPTIAN HIEROGLYPH Z004': 78829,
'EGYPTIAN HIEROGLYPH Z004A': 78830,
'EGYPTIAN HIEROGLYPH Z005': 78831,
'EGYPTIAN HIEROGLYPH Z005A': 78832,
'EGYPTIAN HIEROGLYPH Z006': 78833,
'EGYPTIAN HIEROGLYPH Z007': 78834,
'EGYPTIAN HIEROGLYPH Z008': 78835,
'EGYPTIAN HIEROGLYPH Z009': 78836,
'EGYPTIAN HIEROGLYPH Z010': 78837,
'EGYPTIAN HIEROGLYPH Z011': 78838,
'EGYPTIAN HIEROGLYPH Z012': 78839,
'EGYPTIAN HIEROGLYPH Z013': 78840,
'EGYPTIAN HIEROGLYPH Z014': 78841,
'EGYPTIAN HIEROGLYPH Z015': 78842,
'EGYPTIAN HIEROGLYPH Z015A': 78843,
'EGYPTIAN HIEROGLYPH Z015B': 78844,
'EGYPTIAN HIEROGLYPH Z015C': 78845,
'EGYPTIAN HIEROGLYPH Z015D': 78846,
'EGYPTIAN HIEROGLYPH Z015E': 78847,
'EGYPTIAN HIEROGLYPH Z015F': 78848,
'EGYPTIAN HIEROGLYPH Z015G': 78849,
'EGYPTIAN HIEROGLYPH Z015H': 78850,
'EGYPTIAN HIEROGLYPH Z015I': 78851,
'EGYPTIAN HIEROGLYPH Z016': 78852,
'EGYPTIAN HIEROGLYPH Z016A': 78853,
'EGYPTIAN HIEROGLYPH Z016B': 78854,
'EGYPTIAN HIEROGLYPH Z016C': 78855,
'EGYPTIAN HIEROGLYPH Z016D': 78856,
'EGYPTIAN HIEROGLYPH Z016E': 78857,
'EGYPTIAN HIEROGLYPH Z016F': 78858,
'EGYPTIAN HIEROGLYPH Z016G': 78859,
'EGYPTIAN HIEROGLYPH Z016H': 78860,
'EIGHT PETALLED OUTLINED BLACK FLORETTE': 10049,
'EIGHT POINTED BLACK STAR': 10036,
'EIGHT POINTED PINWHEEL STAR': 10037,
'EIGHT POINTED RECTILINEAR BLACK STAR': 10039,
'EIGHT SPOKED ASTERISK': 10035,
'EIGHT TEARDROP-SPOKED PROPELLER ASTERISK': 10058,
'EIGHTH NOTE': 9834,
'EJECT SYMBOL': 9167,
'ELECTRIC ARROW': 8961,
'ELECTRICAL INTERSECTION': 9191,
'ELEMENT OF': 8712,
'ELEMENT OF OPENING DOWNWARDS': 10969,
'ELEMENT OF OPENING UPWARDS': 10194,
'ELEMENT OF WITH DOT ABOVE': 8949,
'ELEMENT OF WITH LONG HORIZONTAL STROKE': 8946,
'ELEMENT OF WITH OVERBAR': 8950,
'ELEMENT OF WITH TWO HORIZONTAL STROKES': 8953,
'ELEMENT OF WITH UNDERBAR': 8952,
'ELEMENT OF WITH VERTICAL BAR AT END OF HORIZONTAL STROKE': 8947,
'EM DASH': 8212,
'EM QUAD': 8193,
'EM SPACE': 8195,
'EMPHASIS SYMBOL': 9091,
'EMPTY SET': 8709,
'EMPTY SET WITH LEFT ARROW ABOVE': 10676,
'EMPTY SET WITH OVERBAR': 10673,
'EMPTY SET WITH RIGHT ARROW ABOVE': 10675,
'EMPTY SET WITH SMALL CIRCLE ABOVE': 10674,
'EN DASH': 8211,
'EN QUAD': 8192,
'EN SPACE': 8194,
'END OF PROOF': 8718,
'ENTER SYMBOL': 9094,
'ENVELOPE': 9993,
'EQUAL AND PARALLEL TO': 8917,
'EQUAL TO BY DEFINITION': 8797,
'EQUAL TO OR GREATER-THAN': 8925,
'EQUAL TO OR LESS-THAN': 8924,
'EQUAL TO OR PRECEDES': 8926,
'EQUAL TO OR SUCCEEDS': 8927,
'EQUALS COLON': 8789,
'EQUALS SIGN': 61,
'EQUALS SIGN ABOVE LEFTWARDS ARROW': 11072,
'EQUALS SIGN ABOVE PLUS SIGN': 10865,
'EQUALS SIGN ABOVE RIGHTWARDS ARROW': 10609,
'EQUALS SIGN ABOVE TILDE OPERATOR': 10867,
'EQUALS SIGN AND SLANTED PARALLEL': 10723,
'EQUALS SIGN AND SLANTED PARALLEL WITH TILDE ABOVE': 10724,
'EQUALS SIGN WITH BUMPY ABOVE': 10926,
'EQUALS SIGN WITH DOT BELOW': 10854,
'EQUALS SIGN WITH TWO DOTS ABOVE AND TWO DOTS BELOW': 10871,
'EQUALS WITH ASTERISK': 10862,
'EQUIANGULAR TO': 8794,
'EQUIVALENT TO': 8781,
'EQUIVALENT WITH FOUR DOTS ABOVE': 10872,
'ERASE TO THE LEFT': 9003,
'ERASE TO THE RIGHT': 8998,
'ERROR-BARRED BLACK CIRCLE': 10739,
'ERROR-BARRED BLACK DIAMOND': 10737,
'ERROR-BARRED BLACK SQUARE': 10735,
'ERROR-BARRED WHITE CIRCLE': 10738,
'ERROR-BARRED WHITE DIAMOND': 10736,
'ERROR-BARRED WHITE SQUARE': 10734,
'ESTIMATED SYMBOL': 8494,
'ESTIMATES': 8793,
'ETHIOPIC COLON': 4965,
'ETHIOPIC COMBINING GEMINATION MARK': 4959,
'ETHIOPIC COMMA': 4963,
'ETHIOPIC DIGIT EIGHT': 4976,
'ETHIOPIC DIGIT FIVE': 4973,
'ETHIOPIC DIGIT FOUR': 4972,
'ETHIOPIC DIGIT NINE': 4977,
'ETHIOPIC DIGIT ONE': 4969,
'ETHIOPIC DIGIT SEVEN': 4975,
'ETHIOPIC DIGIT SIX': 4974,
'ETHIOPIC DIGIT THREE': 4971,
'ETHIOPIC DIGIT TWO': 4970,
'ETHIOPIC FULL STOP': 4962,
'ETHIOPIC NUMBER EIGHTY': 4985,
'ETHIOPIC NUMBER FIFTY': 4982,
'ETHIOPIC NUMBER FORTY': 4981,
'ETHIOPIC NUMBER HUNDRED': 4987,
'ETHIOPIC NUMBER NINETY': 4986,
'ETHIOPIC NUMBER SEVENTY': 4984,
'ETHIOPIC NUMBER SIXTY': 4983,
'ETHIOPIC NUMBER TEN': 4978,
'ETHIOPIC NUMBER TEN THOUSAND': 4988,
'ETHIOPIC NUMBER THIRTY': 4980,
'ETHIOPIC NUMBER TWENTY': 4979,
'ETHIOPIC PARAGRAPH SEPARATOR': 4968,
'ETHIOPIC PREFACE COLON': 4966,
'ETHIOPIC QUESTION MARK': 4967,
'ETHIOPIC SECTION MARK': 4960,
'ETHIOPIC SEMICOLON': 4964,
'ETHIOPIC SYLLABLE BA': 4704,
'ETHIOPIC SYLLABLE BAA': 4707,
'ETHIOPIC SYLLABLE BE': 4709,
'ETHIOPIC SYLLABLE BEE': 4708,
'ETHIOPIC SYLLABLE BI': 4706,
'ETHIOPIC SYLLABLE BO': 4710,
'ETHIOPIC SYLLABLE BOA': 11653,
'ETHIOPIC SYLLABLE BU': 4705,
'ETHIOPIC SYLLABLE BWA': 4711,
'ETHIOPIC SYLLABLE BWE': 4999,
'ETHIOPIC SYLLABLE BWEE': 4998,
'ETHIOPIC SYLLABLE BWI': 4997,
'ETHIOPIC SYLLABLE CA': 4728,
'ETHIOPIC SYLLABLE CAA': 4731,
'ETHIOPIC SYLLABLE CCA': 11688,
'ETHIOPIC SYLLABLE CCAA': 11691,
'ETHIOPIC SYLLABLE CCE': 11693,
'ETHIOPIC SYLLABLE CCEE': 11692,
'ETHIOPIC SYLLABLE CCHA': 11704,
'ETHIOPIC SYLLABLE CCHAA': 11707,
'ETHIOPIC SYLLABLE CCHE': 11709,
'ETHIOPIC SYLLABLE CCHEE': 11708,
'ETHIOPIC SYLLABLE CCHI': 11706,
'ETHIOPIC SYLLABLE CCHO': 11710,
'ETHIOPIC SYLLABLE CCHU': 11705,
'ETHIOPIC SYLLABLE CCI': 11690,
'ETHIOPIC SYLLABLE CCO': 11694,
'ETHIOPIC SYLLABLE CCU': 11689,
'ETHIOPIC SYLLABLE CE': 4733,
'ETHIOPIC SYLLABLE CEE': 4732,
'ETHIOPIC SYLLABLE CHA': 4904,
'ETHIOPIC SYLLABLE CHAA': 4907,
'ETHIOPIC SYLLABLE CHE': 4909,
'ETHIOPIC SYLLABLE CHEE': 4908,
'ETHIOPIC SYLLABLE CHI': 4906,
'ETHIOPIC SYLLABLE CHO': 4910,
'ETHIOPIC SYLLABLE CHOA': 11664,
'ETHIOPIC SYLLABLE CHU': 4905,
'ETHIOPIC SYLLABLE CHWA': 4911,
'ETHIOPIC SYLLABLE CI': 4730,
'ETHIOPIC SYLLABLE CO': 4734,
'ETHIOPIC SYLLABLE COA': 11655,
'ETHIOPIC SYLLABLE CU': 4729,
'ETHIOPIC SYLLABLE CWA': 4735,
'ETHIOPIC SYLLABLE DA': 4848,
'ETHIOPIC SYLLABLE DAA': 4851,
'ETHIOPIC SYLLABLE DDA': 4856,
'ETHIOPIC SYLLABLE DDAA': 4859,
'ETHIOPIC SYLLABLE DDE': 4861,
'ETHIOPIC SYLLABLE DDEE': 4860,
'ETHIOPIC SYLLABLE DDI': 4858,
'ETHIOPIC SYLLABLE DDO': 4862,
'ETHIOPIC SYLLABLE DDOA': 11661,
'ETHIOPIC SYLLABLE DDU': 4857,
'ETHIOPIC SYLLABLE DDWA': 4863,
'ETHIOPIC SYLLABLE DE': 4853,
'ETHIOPIC SYLLABLE DEE': 4852,
'ETHIOPIC SYLLABLE DI': 4850,
'ETHIOPIC SYLLABLE DO': 4854,
'ETHIOPIC SYLLABLE DOA': 11660,
'ETHIOPIC SYLLABLE DU': 4849,
'ETHIOPIC SYLLABLE DWA': 4855,
'ETHIOPIC SYLLABLE FA': 4936,
'ETHIOPIC SYLLABLE FAA': 4939,
'ETHIOPIC SYLLABLE FE': 4941,
'ETHIOPIC SYLLABLE FEE': 4940,
'ETHIOPIC SYLLABLE FI': 4938,
'ETHIOPIC SYLLABLE FO': 4942,
'ETHIOPIC SYLLABLE FU': 4937,
'ETHIOPIC SYLLABLE FWA': 4943,
'ETHIOPIC SYLLABLE FWE': 5003,
'ETHIOPIC SYLLABLE FWEE': 5002,
'ETHIOPIC SYLLABLE FWI': 5001,
'ETHIOPIC SYLLABLE FYA': 4954,
'ETHIOPIC SYLLABLE GA': 4872,
'ETHIOPIC SYLLABLE GAA': 4875,
'ETHIOPIC SYLLABLE GE': 4877,
'ETHIOPIC SYLLABLE GEE': 4876,
'ETHIOPIC SYLLABLE GGA': 4888,
'ETHIOPIC SYLLABLE GGAA': 4891,
'ETHIOPIC SYLLABLE GGE': 4893,
'ETHIOPIC SYLLABLE GGEE': 4892,
'ETHIOPIC SYLLABLE GGI': 4890,
'ETHIOPIC SYLLABLE GGO': 4894,
'ETHIOPIC SYLLABLE GGU': 4889,
'ETHIOPIC SYLLABLE GGWA': 11667,
'ETHIOPIC SYLLABLE GGWAA': 4895,
'ETHIOPIC SYLLABLE GGWE': 11670,
'ETHIOPIC SYLLABLE GGWEE': 11669,
'ETHIOPIC SYLLABLE GGWI': 11668,
'ETHIOPIC SYLLABLE GI': 4874,
'ETHIOPIC SYLLABLE GLOTTAL A': 4768,
'ETHIOPIC SYLLABLE GLOTTAL AA': 4771,
'ETHIOPIC SYLLABLE GLOTTAL E': 4773,
'ETHIOPIC SYLLABLE GLOTTAL EE': 4772,
'ETHIOPIC SYLLABLE GLOTTAL I': 4770,
'ETHIOPIC SYLLABLE GLOTTAL O': 4774,
'ETHIOPIC SYLLABLE GLOTTAL OA': 11658,
'ETHIOPIC SYLLABLE GLOTTAL U': 4769,
'ETHIOPIC SYLLABLE GLOTTAL WA': 4775,
'ETHIOPIC SYLLABLE GO': 4878,
'ETHIOPIC SYLLABLE GOA': 4879,
'ETHIOPIC SYLLABLE GU': 4873,
'ETHIOPIC SYLLABLE GWA': 4880,
'ETHIOPIC SYLLABLE GWAA': 4883,
'ETHIOPIC SYLLABLE GWE': 4885,
'ETHIOPIC SYLLABLE GWEE': 4884,
'ETHIOPIC SYLLABLE GWI': 4882,
'ETHIOPIC SYLLABLE GYA': 11736,
'ETHIOPIC SYLLABLE GYAA': 11739,
'ETHIOPIC SYLLABLE GYE': 11741,
'ETHIOPIC SYLLABLE GYEE': 11740,
'ETHIOPIC SYLLABLE GYI': 11738,
'ETHIOPIC SYLLABLE GYO': 11742,
'ETHIOPIC SYLLABLE GYU': 11737,
'ETHIOPIC SYLLABLE HA': 4608,
'ETHIOPIC SYLLABLE HAA': 4611,
'ETHIOPIC SYLLABLE HE': 4613,
'ETHIOPIC SYLLABLE HEE': 4612,
'ETHIOPIC SYLLABLE HHA': 4624,
'ETHIOPIC SYLLABLE HHAA': 4627,
'ETHIOPIC SYLLABLE HHE': 4629,
'ETHIOPIC SYLLABLE HHEE': 4628,
'ETHIOPIC SYLLABLE HHI': 4626,
'ETHIOPIC SYLLABLE HHO': 4630,
'ETHIOPIC SYLLABLE HHU': 4625,
'ETHIOPIC SYLLABLE HHWA': 4631,
'ETHIOPIC SYLLABLE HI': 4610,
'ETHIOPIC SYLLABLE HO': 4614,
'ETHIOPIC SYLLABLE HOA': 4615,
'ETHIOPIC SYLLABLE HU': 4609,
'ETHIOPIC SYLLABLE JA': 4864,
'ETHIOPIC SYLLABLE JAA': 4867,
'ETHIOPIC SYLLABLE JE': 4869,
'ETHIOPIC SYLLABLE JEE': 4868,
'ETHIOPIC SYLLABLE JI': 4866,
'ETHIOPIC SYLLABLE JO': 4870,
'ETHIOPIC SYLLABLE JOA': 11662,
'ETHIOPIC SYLLABLE JU': 4865,
'ETHIOPIC SYLLABLE JWA': 4871,
'ETHIOPIC SYLLABLE KA': 4776,
'ETHIOPIC SYLLABLE KAA': 4779,
'ETHIOPIC SYLLABLE KE': 4781,
'ETHIOPIC SYLLABLE KEE': 4780,
'ETHIOPIC SYLLABLE KI': 4778,
'ETHIOPIC SYLLABLE KO': 4782,
'ETHIOPIC SYLLABLE KOA': 4783,
'ETHIOPIC SYLLABLE KU': 4777,
'ETHIOPIC SYLLABLE KWA': 4784,
'ETHIOPIC SYLLABLE KWAA': 4787,
'ETHIOPIC SYLLABLE KWE': 4789,
'ETHIOPIC SYLLABLE KWEE': 4788,
'ETHIOPIC SYLLABLE KWI': 4786,
'ETHIOPIC SYLLABLE KXA': 4792,
'ETHIOPIC SYLLABLE KXAA': 4795,
'ETHIOPIC SYLLABLE KXE': 4797,
'ETHIOPIC SYLLABLE KXEE': 4796,
'ETHIOPIC SYLLABLE KXI': 4794,
'ETHIOPIC SYLLABLE KXO': 4798,
'ETHIOPIC SYLLABLE KXU': 4793,
'ETHIOPIC SYLLABLE KXWA': 4800,
'ETHIOPIC SYLLABLE KXWAA': 4803,
'ETHIOPIC SYLLABLE KXWE': 4805,
'ETHIOPIC SYLLABLE KXWEE': 4804,
'ETHIOPIC SYLLABLE KXWI': 4802,
'ETHIOPIC SYLLABLE KYA': 11720,
'ETHIOPIC SYLLABLE KYAA': 11723,
'ETHIOPIC SYLLABLE KYE': 11725,
'ETHIOPIC SYLLABLE KYEE': 11724,
'ETHIOPIC SYLLABLE KYI': 11722,
'ETHIOPIC SYLLABLE KYO': 11726,
'ETHIOPIC SYLLABLE KYU': 11721,
'ETHIOPIC SYLLABLE LA': 4616,
'ETHIOPIC SYLLABLE LAA': 4619,
'ETHIOPIC SYLLABLE LE': 4621,
'ETHIOPIC SYLLABLE LEE': 4620,
'ETHIOPIC SYLLABLE LI': 4618,
'ETHIOPIC SYLLABLE LO': 4622,
'ETHIOPIC SYLLABLE LOA': 11648,
'ETHIOPIC SYLLABLE LU': 4617,
'ETHIOPIC SYLLABLE LWA': 4623,
'ETHIOPIC SYLLABLE MA': 4632,
'ETHIOPIC SYLLABLE MAA': 4635,
'ETHIOPIC SYLLABLE ME': 4637,
'ETHIOPIC SYLLABLE MEE': 4636,
'ETHIOPIC SYLLABLE MI': 4634,
'ETHIOPIC SYLLABLE MO': 4638,
'ETHIOPIC SYLLABLE MOA': 11649,
'ETHIOPIC SYLLABLE MU': 4633,
'ETHIOPIC SYLLABLE MWA': 4639,
'ETHIOPIC SYLLABLE MWE': 4995,
'ETHIOPIC SYLLABLE MWEE': 4994,
'ETHIOPIC SYLLABLE MWI': 4993,
'ETHIOPIC SYLLABLE MYA': 4953,
'ETHIOPIC SYLLABLE NA': 4752,
'ETHIOPIC SYLLABLE NAA': 4755,
'ETHIOPIC SYLLABLE NE': 4757,
'ETHIOPIC SYLLABLE NEE': 4756,
'ETHIOPIC SYLLABLE NI': 4754,
'ETHIOPIC SYLLABLE NO': 4758,
'ETHIOPIC SYLLABLE NOA': 11656,
'ETHIOPIC SYLLABLE NU': 4753,
'ETHIOPIC SYLLABLE NWA': 4759,
'ETHIOPIC SYLLABLE NYA': 4760,
'ETHIOPIC SYLLABLE NYAA': 4763,
'ETHIOPIC SYLLABLE NYE': 4765,
'ETHIOPIC SYLLABLE NYEE': 4764,
'ETHIOPIC SYLLABLE NYI': 4762,
'ETHIOPIC SYLLABLE NYO': 4766,
'ETHIOPIC SYLLABLE NYOA': 11657,
'ETHIOPIC SYLLABLE NYU': 4761,
'ETHIOPIC SYLLABLE NYWA': 4767,
'ETHIOPIC SYLLABLE PA': 4944,
'ETHIOPIC SYLLABLE PAA': 4947,
'ETHIOPIC SYLLABLE PE': 4949,
'ETHIOPIC SYLLABLE PEE': 4948,
'ETHIOPIC SYLLABLE PHA': 4912,
'ETHIOPIC SYLLABLE PHAA': 4915,
'ETHIOPIC SYLLABLE PHARYNGEAL A': 4816,
'ETHIOPIC SYLLABLE PHARYNGEAL AA': 4819,
'ETHIOPIC SYLLABLE PHARYNGEAL E': 4821,
'ETHIOPIC SYLLABLE PHARYNGEAL EE': 4820,
'ETHIOPIC SYLLABLE PHARYNGEAL I': 4818,
'ETHIOPIC SYLLABLE PHARYNGEAL O': 4822,
'ETHIOPIC SYLLABLE PHARYNGEAL U': 4817,
'ETHIOPIC SYLLABLE PHE': 4917,
'ETHIOPIC SYLLABLE PHEE': 4916,
'ETHIOPIC SYLLABLE PHI': 4914,
'ETHIOPIC SYLLABLE PHO': 4918,
'ETHIOPIC SYLLABLE PHOA': 11665,
'ETHIOPIC SYLLABLE PHU': 4913,
'ETHIOPIC SYLLABLE PHWA': 4919,
'ETHIOPIC SYLLABLE PI': 4946,
'ETHIOPIC SYLLABLE PO': 4950,
'ETHIOPIC SYLLABLE POA': 11666,
'ETHIOPIC SYLLABLE PU': 4945,
'ETHIOPIC SYLLABLE PWA': 4951,
'ETHIOPIC SYLLABLE PWE': 5007,
'ETHIOPIC SYLLABLE PWEE': 5006,
'ETHIOPIC SYLLABLE PWI': 5005,
'ETHIOPIC SYLLABLE QA': 4672,
'ETHIOPIC SYLLABLE QAA': 4675,
'ETHIOPIC SYLLABLE QE': 4677,
'ETHIOPIC SYLLABLE QEE': 4676,
'ETHIOPIC SYLLABLE QHA': 4688,
'ETHIOPIC SYLLABLE QHAA': 4691,
'ETHIOPIC SYLLABLE QHE': 4693,
'ETHIOPIC SYLLABLE QHEE': 4692,
'ETHIOPIC SYLLABLE QHI': 4690,
'ETHIOPIC SYLLABLE QHO': 4694,
'ETHIOPIC SYLLABLE QHU': 4689,
'ETHIOPIC SYLLABLE QHWA': 4696,
'ETHIOPIC SYLLABLE QHWAA': 4699,
'ETHIOPIC SYLLABLE QHWE': 4701,
'ETHIOPIC SYLLABLE QHWEE': 4700,
'ETHIOPIC SYLLABLE QHWI': 4698,
'ETHIOPIC SYLLABLE QI': 4674,
'ETHIOPIC SYLLABLE QO': 4678,
'ETHIOPIC SYLLABLE QOA': 4679,
'ETHIOPIC SYLLABLE QU': 4673,
'ETHIOPIC SYLLABLE QWA': 4680,
'ETHIOPIC SYLLABLE QWAA': 4683,
'ETHIOPIC SYLLABLE QWE': 4685,
'ETHIOPIC SYLLABLE QWEE': 4684,
'ETHIOPIC SYLLABLE QWI': 4682,
'ETHIOPIC SYLLABLE QYA': 11712,
'ETHIOPIC SYLLABLE QYAA': 11715,
'ETHIOPIC SYLLABLE QYE': 11717,
'ETHIOPIC SYLLABLE QYEE': 11716,
'ETHIOPIC SYLLABLE QYI': 11714,
'ETHIOPIC SYLLABLE QYO': 11718,
'ETHIOPIC SYLLABLE QYU': 11713,
'ETHIOPIC SYLLABLE RA': 4648,
'ETHIOPIC SYLLABLE RAA': 4651,
'ETHIOPIC SYLLABLE RE': 4653,
'ETHIOPIC SYLLABLE REE': 4652,
'ETHIOPIC SYLLABLE RI': 4650,
'ETHIOPIC SYLLABLE RO': 4654,
'ETHIOPIC SYLLABLE ROA': 11650,
'ETHIOPIC SYLLABLE RU': 4649,
'ETHIOPIC SYLLABLE RWA': 4655,
'ETHIOPIC SYLLABLE RYA': 4952,
'ETHIOPIC SYLLABLE SA': 4656,
'ETHIOPIC SYLLABLE SAA': 4659,
'ETHIOPIC SYLLABLE SE': 4661,
'ETHIOPIC SYLLABLE SEBATBEIT BWA': 4996,
'ETHIOPIC SYLLABLE SEBATBEIT FWA': 5000,
'ETHIOPIC SYLLABLE SEBATBEIT MWA': 4992,
'ETHIOPIC SYLLABLE SEBATBEIT PWA': 5004,
'ETHIOPIC SYLLABLE SEE': 4660,
'ETHIOPIC SYLLABLE SHA': 4664,
'ETHIOPIC SYLLABLE SHAA': 4667,
'ETHIOPIC SYLLABLE SHE': 4669,
'ETHIOPIC SYLLABLE SHEE': 4668,
'ETHIOPIC SYLLABLE SHI': 4666,
'ETHIOPIC SYLLABLE SHO': 4670,
'ETHIOPIC SYLLABLE SHOA': 11652,
'ETHIOPIC SYLLABLE SHU': 4665,
'ETHIOPIC SYLLABLE SHWA': 4671,
'ETHIOPIC SYLLABLE SI': 4658,
'ETHIOPIC SYLLABLE SO': 4662,
'ETHIOPIC SYLLABLE SOA': 11651,
'ETHIOPIC SYLLABLE SSA': 11680,
'ETHIOPIC SYLLABLE SSAA': 11683,
'ETHIOPIC SYLLABLE SSE': 11685,
'ETHIOPIC SYLLABLE SSEE': 11684,
'ETHIOPIC SYLLABLE SSI': 11682,
'ETHIOPIC SYLLABLE SSO': 11686,
'ETHIOPIC SYLLABLE SSU': 11681,
'ETHIOPIC SYLLABLE SU': 4657,
'ETHIOPIC SYLLABLE SWA': 4663,
'ETHIOPIC SYLLABLE SZA': 4640,
'ETHIOPIC SYLLABLE SZAA': 4643,
'ETHIOPIC SYLLABLE SZE': 4645,
'ETHIOPIC SYLLABLE SZEE': 4644,
'ETHIOPIC SYLLABLE SZI': 4642,
'ETHIOPIC SYLLABLE SZO': 4646,
'ETHIOPIC SYLLABLE SZU': 4641,
'ETHIOPIC SYLLABLE SZWA': 4647,
'ETHIOPIC SYLLABLE TA': 4720,
'ETHIOPIC SYLLABLE TAA': 4723,
'ETHIOPIC SYLLABLE TE': 4725,
'ETHIOPIC SYLLABLE TEE': 4724,
'ETHIOPIC SYLLABLE THA': 4896,
'ETHIOPIC SYLLABLE THAA': 4899,
'ETHIOPIC SYLLABLE THE': 4901,
'ETHIOPIC SYLLABLE THEE': 4900,
'ETHIOPIC SYLLABLE THI': 4898,
'ETHIOPIC SYLLABLE THO': 4902,
'ETHIOPIC SYLLABLE THOA': 11663,
'ETHIOPIC SYLLABLE THU': 4897,
'ETHIOPIC SYLLABLE THWA': 4903,
'ETHIOPIC SYLLABLE TI': 4722,
'ETHIOPIC SYLLABLE TO': 4726,
'ETHIOPIC SYLLABLE TOA': 11654,
'ETHIOPIC SYLLABLE TSA': 4920,
'ETHIOPIC SYLLABLE TSAA': 4923,
'ETHIOPIC SYLLABLE TSE': 4925,
'ETHIOPIC SYLLABLE TSEE': 4924,
'ETHIOPIC SYLLABLE TSI': 4922,
'ETHIOPIC SYLLABLE TSO': 4926,
'ETHIOPIC SYLLABLE TSU': 4921,
'ETHIOPIC SYLLABLE TSWA': 4927,
'ETHIOPIC SYLLABLE TU': 4721,
'ETHIOPIC SYLLABLE TWA': 4727,
'ETHIOPIC SYLLABLE TZA': 4928,
'ETHIOPIC SYLLABLE TZAA': 4931,
'ETHIOPIC SYLLABLE TZE': 4933,
'ETHIOPIC SYLLABLE TZEE': 4932,
'ETHIOPIC SYLLABLE TZI': 4930,
'ETHIOPIC SYLLABLE TZO': 4934,
'ETHIOPIC SYLLABLE TZOA': 4935,
'ETHIOPIC SYLLABLE TZU': 4929,
'ETHIOPIC SYLLABLE VA': 4712,
'ETHIOPIC SYLLABLE VAA': 4715,
'ETHIOPIC SYLLABLE VE': 4717,
'ETHIOPIC SYLLABLE VEE': 4716,
'ETHIOPIC SYLLABLE VI': 4714,
'ETHIOPIC SYLLABLE VO': 4718,
'ETHIOPIC SYLLABLE VU': 4713,
'ETHIOPIC SYLLABLE VWA': 4719,
'ETHIOPIC SYLLABLE WA': 4808,
'ETHIOPIC SYLLABLE WAA': 4811,
'ETHIOPIC SYLLABLE WE': 4813,
'ETHIOPIC SYLLABLE WEE': 4812,
'ETHIOPIC SYLLABLE WI': 4810,
'ETHIOPIC SYLLABLE WO': 4814,
'ETHIOPIC SYLLABLE WOA': 4815,
'ETHIOPIC SYLLABLE WU': 4809,
'ETHIOPIC SYLLABLE XA': 4736,
'ETHIOPIC SYLLABLE XAA': 4739,
'ETHIOPIC SYLLABLE XE': 4741,
'ETHIOPIC SYLLABLE XEE': 4740,
'ETHIOPIC SYLLABLE XI': 4738,
'ETHIOPIC SYLLABLE XO': 4742,
'ETHIOPIC SYLLABLE XOA': 4743,
'ETHIOPIC SYLLABLE XU': 4737,
'ETHIOPIC SYLLABLE XWA': 4744,
'ETHIOPIC SYLLABLE XWAA': 4747,
'ETHIOPIC SYLLABLE XWE': 4749,
'ETHIOPIC SYLLABLE XWEE': 4748,
'ETHIOPIC SYLLABLE XWI': 4746,
'ETHIOPIC SYLLABLE XYA': 11728,
'ETHIOPIC SYLLABLE XYAA': 11731,
'ETHIOPIC SYLLABLE XYE': 11733,
'ETHIOPIC SYLLABLE XYEE': 11732,
'ETHIOPIC SYLLABLE XYI': 11730,
'ETHIOPIC SYLLABLE XYO': 11734,
'ETHIOPIC SYLLABLE XYU': 11729,
'ETHIOPIC SYLLABLE YA': 4840,
'ETHIOPIC SYLLABLE YAA': 4843,
'ETHIOPIC SYLLABLE YE': 4845,
'ETHIOPIC SYLLABLE YEE': 4844,
'ETHIOPIC SYLLABLE YI': 4842,
'ETHIOPIC SYLLABLE YO': 4846,
'ETHIOPIC SYLLABLE YOA': 4847,
'ETHIOPIC SYLLABLE YU': 4841,
'ETHIOPIC SYLLABLE ZA': 4824,
'ETHIOPIC SYLLABLE ZAA': 4827,
'ETHIOPIC SYLLABLE ZE': 4829,
'ETHIOPIC SYLLABLE ZEE': 4828,
'ETHIOPIC SYLLABLE ZHA': 4832,
'ETHIOPIC SYLLABLE ZHAA': 4835,
'ETHIOPIC SYLLABLE ZHE': 4837,
'ETHIOPIC SYLLABLE ZHEE': 4836,
'ETHIOPIC SYLLABLE ZHI': 4834,
'ETHIOPIC SYLLABLE ZHO': 4838,
'ETHIOPIC SYLLABLE ZHU': 4833,
'ETHIOPIC SYLLABLE ZHWA': 4839,
'ETHIOPIC SYLLABLE ZI': 4826,
'ETHIOPIC SYLLABLE ZO': 4830,
'ETHIOPIC SYLLABLE ZOA': 11659,
'ETHIOPIC SYLLABLE ZU': 4825,
'ETHIOPIC SYLLABLE ZWA': 4831,
'ETHIOPIC SYLLABLE ZZA': 11696,
'ETHIOPIC SYLLABLE ZZAA': 11699,
'ETHIOPIC SYLLABLE ZZE': 11701,
'ETHIOPIC SYLLABLE ZZEE': 11700,
'ETHIOPIC SYLLABLE ZZI': 11698,
'ETHIOPIC SYLLABLE ZZO': 11702,
'ETHIOPIC SYLLABLE ZZU': 11697,
'ETHIOPIC TONAL MARK CHIRET': 5014,
'ETHIOPIC TONAL MARK DERET': 5009,
'ETHIOPIC TONAL MARK DERET-HIDET': 5016,
'ETHIOPIC TONAL MARK DIFAT': 5012,
'ETHIOPIC TONAL MARK HIDET': 5015,
'ETHIOPIC TONAL MARK KENAT': 5013,
'ETHIOPIC TONAL MARK KURT': 5017,
'ETHIOPIC TONAL MARK RIKRIK': 5010,
'ETHIOPIC TONAL MARK SHORT RIKRIK': 5011,
'ETHIOPIC TONAL MARK YIZET': 5008,
'ETHIOPIC WORDSPACE': 4961,
'EULER CONSTANT': 8455,
'EURO SIGN': 8364,
'EURO-CURRENCY SIGN': 8352,
'EXCESS': 8761,
'EXCLAMATION MARK': 33,
'EXCLAMATION QUESTION MARK': 8265,
'EXTENDED ARABIC-INDIC DIGIT EIGHT': 1784,
'EXTENDED ARABIC-INDIC DIGIT FIVE': 1781,
'EXTENDED ARABIC-INDIC DIGIT FOUR': 1780,
'EXTENDED ARABIC-INDIC DIGIT NINE': 1785,
'EXTENDED ARABIC-INDIC DIGIT ONE': 1777,
'EXTENDED ARABIC-INDIC DIGIT SEVEN': 1783,
'EXTENDED ARABIC-INDIC DIGIT SIX': 1782,
'EXTENDED ARABIC-INDIC DIGIT THREE': 1779,
'EXTENDED ARABIC-INDIC DIGIT TWO': 1778,
'EXTENDED ARABIC-INDIC DIGIT ZERO': 1776,
'FACSIMILE SIGN': 8507,
'FALLING DIAGONAL CROSSING NORTH EAST ARROW': 10543,
'FALLING DIAGONAL CROSSING RISING DIAGONAL': 10540,
'FALLING DIAGONAL IN WHITE CIRCLE IN BLACK SQUARE': 9950,
'FARSI SYMBOL': 9771,
'FEMALE SIGN': 9792,
'FEMININE ORDINAL INDICATOR': 170,
'FERRY': 9972,
'FIGURE DASH': 8210,
'FIGURE SPACE': 8199,
'FINITE PART INTEGRAL': 10765,
'FIRST QUARTER MOON': 9789,
'FISHEYE': 9673,
'FIVE DOT MARK': 11821,
'FIVE DOT PUNCTUATION': 8281,
'FLAG IN HOLE': 9971,
'FLATNESS': 9189,
'FLEUR-DE-LIS': 9884,
'FLORAL HEART': 10086,
'FLOWER': 9880,
'FLOWER PUNCTUATION MARK': 8277,
'FOR ALL': 8704,
'FORCES': 8873,
'FORKED PARAGRAPHOS': 11792,
'FORKING': 10972,
'FOUNTAIN': 9970,
'FOUR BALLOON-SPOKED ASTERISK': 10019,
'FOUR CLUB-SPOKED ASTERISK': 10021,
'FOUR DOT MARK': 8283,
'FOUR DOT PUNCTUATION': 8280,
'FOUR TEARDROP-SPOKED ASTERISK': 10018,
'FOUR-PER-EM SPACE': 8197,
'FOURTH ROOT': 8732,
'FRACTION NUMERATOR ONE': 8543,
'FRACTION SLASH': 8260,
'FRENCH FRANC SIGN': 8355,
'FRONT-TILTED SHADOWED WHITE RIGHTWARDS ARROW': 10156,
'FROWN': 8994,
'FUEL PUMP': 9981,
'FULL BLOCK': 9608,
'FULL OUTER JOIN': 10199,
'FULL STOP': 46,
'FULLWIDTH AMPERSAND': 65286,
'FULLWIDTH APOSTROPHE': 65287,
'FULLWIDTH ASTERISK': 65290,
'FULLWIDTH BROKEN BAR': 65508,
'FULLWIDTH CENT SIGN': 65504,
'FULLWIDTH CIRCUMFLEX ACCENT': 65342,
'FULLWIDTH COLON': 65306,
'FULLWIDTH COMMA': 65292,
'FULLWIDTH COMMERCIAL AT': 65312,
'FULLWIDTH DIGIT EIGHT': 65304,
'FULLWIDTH DIGIT FIVE': 65301,
'FULLWIDTH DIGIT FOUR': 65300,
'FULLWIDTH DIGIT NINE': 65305,
'FULLWIDTH DIGIT ONE': 65297,
'FULLWIDTH DIGIT SEVEN': 65303,
'FULLWIDTH DIGIT SIX': 65302,
'FULLWIDTH DIGIT THREE': 65299,
'FULLWIDTH DIGIT TWO': 65298,
'FULLWIDTH DIGIT ZERO': 65296,
'FULLWIDTH DOLLAR SIGN': 65284,
'FULLWIDTH EQUALS SIGN': 65309,
'FULLWIDTH EXCLAMATION MARK': 65281,
'FULLWIDTH FULL STOP': 65294,
'FULLWIDTH GRAVE ACCENT': 65344,
'FULLWIDTH GREATER-THAN SIGN': 65310,
'FULLWIDTH HYPHEN-MINUS': 65293,
'FULLWIDTH LATIN CAPITAL LETTER A': 65313,
'FULLWIDTH LATIN CAPITAL LETTER B': 65314,
'FULLWIDTH LATIN CAPITAL LETTER C': 65315,
'FULLWIDTH LATIN CAPITAL LETTER D': 65316,
'FULLWIDTH LATIN CAPITAL LETTER E': 65317,
'FULLWIDTH LATIN CAPITAL LETTER F': 65318,
'FULLWIDTH LATIN CAPITAL LETTER G': 65319,
'FULLWIDTH LATIN CAPITAL LETTER H': 65320,
'FULLWIDTH LATIN CAPITAL LETTER I': 65321,
'FULLWIDTH LATIN CAPITAL LETTER J': 65322,
'FULLWIDTH LATIN CAPITAL LETTER K': 65323,
'FULLWIDTH LATIN CAPITAL LETTER L': 65324,
'FULLWIDTH LATIN CAPITAL LETTER M': 65325,
'FULLWIDTH LATIN CAPITAL LETTER N': 65326,
'FULLWIDTH LATIN CAPITAL LETTER O': 65327,
'FULLWIDTH LATIN CAPITAL LETTER P': 65328,
'FULLWIDTH LATIN CAPITAL LETTER Q': 65329,
'FULLWIDTH LATIN CAPITAL LETTER R': 65330,
'FULLWIDTH LATIN CAPITAL LETTER S': 65331,
'FULLWIDTH LATIN CAPITAL LETTER T': 65332,
'FULLWIDTH LATIN CAPITAL LETTER U': 65333,
'FULLWIDTH LATIN CAPITAL LETTER V': 65334,
'FULLWIDTH LATIN CAPITAL LETTER W': 65335,
'FULLWIDTH LATIN CAPITAL LETTER X': 65336,
'FULLWIDTH LATIN CAPITAL LETTER Y': 65337,
'FULLWIDTH LATIN CAPITAL LETTER Z': 65338,
'FULLWIDTH LATIN SMALL LETTER A': 65345,
'FULLWIDTH LATIN SMALL LETTER B': 65346,
'FULLWIDTH LATIN SMALL LETTER C': 65347,
'FULLWIDTH LATIN SMALL LETTER D': 65348,
'FULLWIDTH LATIN SMALL LETTER E': 65349,
'FULLWIDTH LATIN SMALL LETTER F': 65350,
'FULLWIDTH LATIN SMALL LETTER G': 65351,
'FULLWIDTH LATIN SMALL LETTER H': 65352,
'FULLWIDTH LATIN SMALL LETTER I': 65353,
'FULLWIDTH LATIN SMALL LETTER J': 65354,
'FULLWIDTH LATIN SMALL LETTER K': 65355,
'FULLWIDTH LATIN SMALL LETTER L': 65356,
'FULLWIDTH LATIN SMALL LETTER M': 65357,
'FULLWIDTH LATIN SMALL LETTER N': 65358,
'FULLWIDTH LATIN SMALL LETTER O': 65359,
'FULLWIDTH LATIN SMALL LETTER P': 65360,
'FULLWIDTH LATIN SMALL LETTER Q': 65361,
'FULLWIDTH LATIN SMALL LETTER R': 65362,
'FULLWIDTH LATIN SMALL LETTER S': 65363,
'FULLWIDTH LATIN SMALL LETTER T': 65364,
'FULLWIDTH LATIN SMALL LETTER U': 65365,
'FULLWIDTH LATIN SMALL LETTER V': 65366,
'FULLWIDTH LATIN SMALL LETTER W': 65367,
'FULLWIDTH LATIN SMALL LETTER X': 65368,
'FULLWIDTH LATIN SMALL LETTER Y': 65369,
'FULLWIDTH LATIN SMALL LETTER Z': 65370,
'FULLWIDTH LEFT CURLY BRACKET': 65371,
'FULLWIDTH LEFT PARENTHESIS': 65288,
'FULLWIDTH LEFT SQUARE BRACKET': 65339,
'FULLWIDTH LEFT WHITE PARENTHESIS': 65375,
'FULLWIDTH LESS-THAN SIGN': 65308,
'FULLWIDTH LOW LINE': 65343,
'FULLWIDTH MACRON': 65507,
'FULLWIDTH NOT SIGN': 65506,
'FULLWIDTH NUMBER SIGN': 65283,
'FULLWIDTH PERCENT SIGN': 65285,
'FULLWIDTH PLUS SIGN': 65291,
'FULLWIDTH POUND SIGN': 65505,
'FULLWIDTH QUESTION MARK': 65311,
'FULLWIDTH QUOTATION MARK': 65282,
'FULLWIDTH REVERSE SOLIDUS': 65340,
'FULLWIDTH RIGHT CURLY BRACKET': 65373,
'FULLWIDTH RIGHT PARENTHESIS': 65289,
'FULLWIDTH RIGHT SQUARE BRACKET': 65341,
'FULLWIDTH RIGHT WHITE PARENTHESIS': 65376,
'FULLWIDTH SEMICOLON': 65307,
'FULLWIDTH SOLIDUS': 65295,
'FULLWIDTH TILDE': 65374,
'FULLWIDTH VERTICAL LINE': 65372,
'FULLWIDTH WON SIGN': 65510,
'FULLWIDTH YEN SIGN': 65509,
'FUNCTION APPLICATION': 8289,
'FUNERAL URN': 9905,
'FUSE': 9179,
'GEAR': 9881,
'GEAR WITH HANDLES': 9966,
'GEAR WITHOUT HUB': 9965,
'GEMINI': 9802,
'GEOMETRIC PROPORTION': 8762,
'GEOMETRICALLY EQUAL TO': 8785,
'GEOMETRICALLY EQUIVALENT TO': 8782,
'GEORGIAN CAPITAL LETTER AN': 4256,
'GEORGIAN CAPITAL LETTER BAN': 4257,
'GEORGIAN CAPITAL LETTER CAN': 4282,
'GEORGIAN CAPITAL LETTER CHAR': 4285,
'GEORGIAN CAPITAL LETTER CHIN': 4281,
'GEORGIAN CAPITAL LETTER CIL': 4284,
'GEORGIAN CAPITAL LETTER DON': 4259,
'GEORGIAN CAPITAL LETTER EN': 4260,
'GEORGIAN CAPITAL LETTER GAN': 4258,
'GEORGIAN CAPITAL LETTER GHAN': 4278,
'GEORGIAN CAPITAL LETTER HAE': 4288,
'GEORGIAN CAPITAL LETTER HAR': 4292,
'GEORGIAN CAPITAL LETTER HE': 4289,
'GEORGIAN CAPITAL LETTER HIE': 4290,
'GEORGIAN CAPITAL LETTER HOE': 4293,
'GEORGIAN CAPITAL LETTER IN': 4264,
'GEORGIAN CAPITAL LETTER JHAN': 4287,
'GEORGIAN CAPITAL LETTER JIL': 4283,
'GEORGIAN CAPITAL LETTER KAN': 4265,
'GEORGIAN CAPITAL LETTER KHAR': 4277,
'GEORGIAN CAPITAL LETTER LAS': 4266,
'GEORGIAN CAPITAL LETTER MAN': 4267,
'GEORGIAN CAPITAL LETTER NAR': 4268,
'GEORGIAN CAPITAL LETTER ON': 4269,
'GEORGIAN CAPITAL LETTER PAR': 4270,
'GEORGIAN CAPITAL LETTER PHAR': 4276,
'GEORGIAN CAPITAL LETTER QAR': 4279,
'GEORGIAN CAPITAL LETTER RAE': 4272,
'GEORGIAN CAPITAL LETTER SAN': 4273,
'GEORGIAN CAPITAL LETTER SHIN': 4280,
'GEORGIAN CAPITAL LETTER TAN': 4263,
'GEORGIAN CAPITAL LETTER TAR': 4274,
'GEORGIAN CAPITAL LETTER UN': 4275,
'GEORGIAN CAPITAL LETTER VIN': 4261,
'GEORGIAN CAPITAL LETTER WE': 4291,
'GEORGIAN CAPITAL LETTER XAN': 4286,
'GEORGIAN CAPITAL LETTER ZEN': 4262,
'GEORGIAN CAPITAL LETTER ZHAR': 4271,
'GEORGIAN LETTER AIN': 4346,
'GEORGIAN LETTER AN': 4304,
'GEORGIAN LETTER BAN': 4305,
'GEORGIAN LETTER CAN': 4330,
'GEORGIAN LETTER CHAR': 4333,
'GEORGIAN LETTER CHIN': 4329,
'GEORGIAN LETTER CIL': 4332,
'GEORGIAN LETTER DON': 4307,
'GEORGIAN LETTER ELIFI': 4344,
'GEORGIAN LETTER EN': 4308,
'GEORGIAN LETTER FI': 4342,
'GEORGIAN LETTER GAN': 4306,
'GEORGIAN LETTER GHAN': 4326,
'GEORGIAN LETTER HAE': 4336,
'GEORGIAN LETTER HAR': 4340,
'GEORGIAN LETTER HE': 4337,
'GEORGIAN LETTER HIE': 4338,
'GEORGIAN LETTER HOE': 4341,
'GEORGIAN LETTER IN': 4312,
'GEORGIAN LETTER JHAN': 4335,
'GEORGIAN LETTER JIL': 4331,
'GEORGIAN LETTER KAN': 4313,
'GEORGIAN LETTER KHAR': 4325,
'GEORGIAN LETTER LAS': 4314,
'GEORGIAN LETTER MAN': 4315,
'GEORGIAN LETTER NAR': 4316,
'GEORGIAN LETTER ON': 4317,
'GEORGIAN LETTER PAR': 4318,
'GEORGIAN LETTER PHAR': 4324,
'GEORGIAN LETTER QAR': 4327,
'GEORGIAN LETTER RAE': 4320,
'GEORGIAN LETTER SAN': 4321,
'GEORGIAN LETTER SHIN': 4328,
'GEORGIAN LETTER TAN': 4311,
'GEORGIAN LETTER TAR': 4322,
'GEORGIAN LETTER TURNED GAN': 4345,
'GEORGIAN LETTER UN': 4323,
'GEORGIAN LETTER VIN': 4309,
'GEORGIAN LETTER WE': 4339,
'GEORGIAN LETTER XAN': 4334,
'GEORGIAN LETTER YN': 4343,
'GEORGIAN LETTER ZEN': 4310,
'GEORGIAN LETTER ZHAR': 4319,
'GEORGIAN PARAGRAPH SEPARATOR': 4347,
'GEORGIAN SMALL LETTER AN': 11520,
'GEORGIAN SMALL LETTER BAN': 11521,
'GEORGIAN SMALL LETTER CAN': 11546,
'GEORGIAN SMALL LETTER CHAR': 11549,
'GEORGIAN SMALL LETTER CHIN': 11545,
'GEORGIAN SMALL LETTER CIL': 11548,
'GEORGIAN SMALL LETTER DON': 11523,
'GEORGIAN SMALL LETTER EN': 11524,
'GEORGIAN SMALL LETTER GAN': 11522,
'GEORGIAN SMALL LETTER GHAN': 11542,
'GEORGIAN SMALL LETTER HAE': 11552,
'GEORGIAN SMALL LETTER HAR': 11556,
'GEORGIAN SMALL LETTER HE': 11553,
'GEORGIAN SMALL LETTER HIE': 11554,
'GEORGIAN SMALL LETTER HOE': 11557,
'GEORGIAN SMALL LETTER IN': 11528,
'GEORGIAN SMALL LETTER JHAN': 11551,
'GEORGIAN SMALL LETTER JIL': 11547,
'GEORGIAN SMALL LETTER KAN': 11529,
'GEORGIAN SMALL LETTER KHAR': 11541,
'GEORGIAN SMALL LETTER LAS': 11530,
'GEORGIAN SMALL LETTER MAN': 11531,
'GEORGIAN SMALL LETTER NAR': 11532,
'GEORGIAN SMALL LETTER ON': 11533,
'GEORGIAN SMALL LETTER PAR': 11534,
'GEORGIAN SMALL LETTER PHAR': 11540,
'GEORGIAN SMALL LETTER QAR': 11543,
'GEORGIAN SMALL LETTER RAE': 11536,
'GEORGIAN SMALL LETTER SAN': 11537,
'GEORGIAN SMALL LETTER SHIN': 11544,
'GEORGIAN SMALL LETTER TAN': 11527,
'GEORGIAN SMALL LETTER TAR': 11538,
'GEORGIAN SMALL LETTER UN': 11539,
'GEORGIAN SMALL LETTER VIN': 11525,
'GEORGIAN SMALL LETTER WE': 11555,
'GEORGIAN SMALL LETTER XAN': 11550,
'GEORGIAN SMALL LETTER ZEN': 11526,
'GEORGIAN SMALL LETTER ZHAR': 11535,
'GERMAN PENNY SIGN': 8368,
'GETA MARK': 12307,
'GIMEL SYMBOL': 8503,
'GLAGOLITIC CAPITAL LETTER AZU': 11264,
'GLAGOLITIC CAPITAL LETTER BIG YUS': 11304,
'GLAGOLITIC CAPITAL LETTER BUKY': 11265,
'GLAGOLITIC CAPITAL LETTER CHRIVI': 11293,
'GLAGOLITIC CAPITAL LETTER DJERVI': 11276,
'GLAGOLITIC CAPITAL LETTER DOBRO': 11268,
'GLAGOLITIC CAPITAL LETTER DZELO': 11271,
'GLAGOLITIC CAPITAL LETTER FITA': 11306,
'GLAGOLITIC CAPITAL LETTER FRITU': 11287,
'GLAGOLITIC CAPITAL LETTER GLAGOLI': 11267,
'GLAGOLITIC CAPITAL LETTER HERU': 11288,
'GLAGOLITIC CAPITAL LETTER I': 11275,
'GLAGOLITIC CAPITAL LETTER INITIAL IZHE': 11274,
'GLAGOLITIC CAPITAL LETTER IOTATED BIG YUS': 11305,
'GLAGOLITIC CAPITAL LETTER IOTATED SMALL YUS': 11303,
'GLAGOLITIC CAPITAL LETTER IZHE': 11273,
'GLAGOLITIC CAPITAL LETTER IZHITSA': 11307,
'GLAGOLITIC CAPITAL LETTER KAKO': 11277,
'GLAGOLITIC CAPITAL LETTER LATINATE MYSLITE': 11310,
'GLAGOLITIC CAPITAL LETTER LJUDIJE': 11278,
'GLAGOLITIC CAPITAL LETTER MYSLITE': 11279,
'GLAGOLITIC CAPITAL LETTER NASHI': 11280,
'GLAGOLITIC CAPITAL LETTER ONU': 11281,
'GLAGOLITIC CAPITAL LETTER OTU': 11289,
'GLAGOLITIC CAPITAL LETTER PE': 11290,
'GLAGOLITIC CAPITAL LETTER POKOJI': 11282,
'GLAGOLITIC CAPITAL LETTER RITSI': 11283,
'GLAGOLITIC CAPITAL LETTER SHA': 11294,
'GLAGOLITIC CAPITAL LETTER SHTA': 11291,
'GLAGOLITIC CAPITAL LETTER SHTAPIC': 11308,
'GLAGOLITIC CAPITAL LETTER SLOVO': 11284,
'GLAGOLITIC CAPITAL LETTER SMALL YUS': 11300,
'GLAGOLITIC CAPITAL LETTER SMALL YUS WITH TAIL': 11301,
'GLAGOLITIC CAPITAL LETTER SPIDERY HA': 11298,
'GLAGOLITIC CAPITAL LETTER TROKUTASTI A': 11309,
'GLAGOLITIC CAPITAL LETTER TSI': 11292,
'GLAGOLITIC CAPITAL LETTER TVRIDO': 11285,
'GLAGOLITIC CAPITAL LETTER UKU': 11286,
'GLAGOLITIC CAPITAL LETTER VEDE': 11266,
'GLAGOLITIC CAPITAL LETTER YATI': 11297,
'GLAGOLITIC CAPITAL LETTER YERI': 11296,
'GLAGOLITIC CAPITAL LETTER YERU': 11295,
'GLAGOLITIC CAPITAL LETTER YESTU': 11269,
'GLAGOLITIC CAPITAL LETTER YO': 11302,
'GLAGOLITIC CAPITAL LETTER YU': 11299,
'GLAGOLITIC CAPITAL LETTER ZEMLJA': 11272,
'GLAGOLITIC CAPITAL LETTER ZHIVETE': 11270,
'GLAGOLITIC SMALL LETTER AZU': 11312,
'GLAGOLITIC SMALL LETTER BIG YUS': 11352,
'GLAGOLITIC SMALL LETTER BUKY': 11313,
'GLAGOLITIC SMALL LETTER CHRIVI': 11341,
'GLAGOLITIC SMALL LETTER DJERVI': 11324,
'GLAGOLITIC SMALL LETTER DOBRO': 11316,
'GLAGOLITIC SMALL LETTER DZELO': 11319,
'GLAGOLITIC SMALL LETTER FITA': 11354,
'GLAGOLITIC SMALL LETTER FRITU': 11335,
'GLAGOLITIC SMALL LETTER GLAGOLI': 11315,
'GLAGOLITIC SMALL LETTER HERU': 11336,
'GLAGOLITIC SMALL LETTER I': 11323,
'GLAGOLITIC SMALL LETTER INITIAL IZHE': 11322,
'GLAGOLITIC SMALL LETTER IOTATED BIG YUS': 11353,
'GLAGOLITIC SMALL LETTER IOTATED SMALL YUS': 11351,
'GLAGOLITIC SMALL LETTER IZHE': 11321,
'GLAGOLITIC SMALL LETTER IZHITSA': 11355,
'GLAGOLITIC SMALL LETTER KAKO': 11325,
'GLAGOLITIC SMALL LETTER LATINATE MYSLITE': 11358,
'GLAGOLITIC SMALL LETTER LJUDIJE': 11326,
'GLAGOLITIC SMALL LETTER MYSLITE': 11327,
'GLAGOLITIC SMALL LETTER NASHI': 11328,
'GLAGOLITIC SMALL LETTER ONU': 11329,
'GLAGOLITIC SMALL LETTER OTU': 11337,
'GLAGOLITIC SMALL LETTER PE': 11338,
'GLAGOLITIC SMALL LETTER POKOJI': 11330,
'GLAGOLITIC SMALL LETTER RITSI': 11331,
'GLAGOLITIC SMALL LETTER SHA': 11342,
'GLAGOLITIC SMALL LETTER SHTA': 11339,
'GLAGOLITIC SMALL LETTER SHTAPIC': 11356,
'GLAGOLITIC SMALL LETTER SLOVO': 11332,
'GLAGOLITIC SMALL LETTER SMALL YUS': 11348,
'GLAGOLITIC SMALL LETTER SMALL YUS WITH TAIL': 11349,
'GLAGOLITIC SMALL LETTER SPIDERY HA': 11346,
'GLAGOLITIC SMALL LETTER TROKUTASTI A': 11357,
'GLAGOLITIC SMALL LETTER TSI': 11340,
'GLAGOLITIC SMALL LETTER TVRIDO': 11333,
'GLAGOLITIC SMALL LETTER UKU': 11334,
'GLAGOLITIC SMALL LETTER VEDE': 11314,
'GLAGOLITIC SMALL LETTER YATI': 11345,
'GLAGOLITIC SMALL LETTER YERI': 11344,
'GLAGOLITIC SMALL LETTER YERU': 11343,
'GLAGOLITIC SMALL LETTER YESTU': 11317,
'GLAGOLITIC SMALL LETTER YO': 11350,
'GLAGOLITIC SMALL LETTER YU': 11347,
'GLAGOLITIC SMALL LETTER ZEMLJA': 11320,
'GLAGOLITIC SMALL LETTER ZHIVETE': 11318,
'GLEICH STARK': 10726,
'GOTHIC LETTER AHSA': 66352,
'GOTHIC LETTER AIHVUS': 66356,
'GOTHIC LETTER BAIRKAN': 66353,
'GOTHIC LETTER DAGS': 66355,
'GOTHIC LETTER EIS': 66361,
'GOTHIC LETTER FAIHU': 66374,
'GOTHIC LETTER GIBA': 66354,
'GOTHIC LETTER HAGL': 66359,
'GOTHIC LETTER HWAIR': 66376,
'GOTHIC LETTER IGGWS': 66375,
'GOTHIC LETTER IUJA': 66358,
'GOTHIC LETTER JER': 66366,
'GOTHIC LETTER KUSMA': 66362,
'GOTHIC LETTER LAGUS': 66363,
'GOTHIC LETTER MANNA': 66364,
'GOTHIC LETTER NAUTHS': 66365,
'GOTHIC LETTER NINE HUNDRED': 66378,
'GOTHIC LETTER NINETY': 66369,
'GOTHIC LETTER OTHAL': 66377,
'GOTHIC LETTER PAIRTHRA': 66368,
'GOTHIC LETTER QAIRTHRA': 66357,
'GOTHIC LETTER RAIDA': 66370,
'GOTHIC LETTER SAUIL': 66371,
'GOTHIC LETTER TEIWS': 66372,
'GOTHIC LETTER THIUTH': 66360,
'GOTHIC LETTER URUS': 66367,
'GOTHIC LETTER WINJA': 66373,
'GRAVE ACCENT': 96,
'GREATER-THAN ABOVE DOUBLE-LINE EQUAL ABOVE LESS-THAN': 10892,
'GREATER-THAN ABOVE LESS-THAN ABOVE DOUBLE-LINE EQUAL': 10898,
'GREATER-THAN ABOVE RIGHTWARDS ARROW': 10616,
'GREATER-THAN ABOVE SIMILAR ABOVE LESS-THAN': 10896,
'GREATER-THAN ABOVE SIMILAR OR EQUAL': 10894,
'GREATER-THAN ABOVE SLANTED EQUAL ABOVE LESS-THAN ABOVE SLANTED EQUAL': 10900,
'GREATER-THAN AND NOT APPROXIMATE': 10890,
'GREATER-THAN AND SINGLE-LINE NOT EQUAL TO': 10888,
'GREATER-THAN BESIDE LESS-THAN': 10917,
'GREATER-THAN BUT NOT EQUAL TO': 8809,
'GREATER-THAN BUT NOT EQUIVALENT TO': 8935,
'GREATER-THAN CLOSED BY CURVE': 10919,
'GREATER-THAN CLOSED BY CURVE ABOVE SLANTED EQUAL': 10921,
'GREATER-THAN EQUAL TO OR LESS-THAN': 8923,
'GREATER-THAN OR APPROXIMATE': 10886,
'GREATER-THAN OR EQUAL TO': 8805,
'GREATER-THAN OR EQUIVALENT TO': 8819,
'GREATER-THAN OR LESS-THAN': 8823,
'GREATER-THAN OR SLANTED EQUAL TO': 10878,
'GREATER-THAN OR SLANTED EQUAL TO WITH DOT ABOVE': 10882,
'GREATER-THAN OR SLANTED EQUAL TO WITH DOT ABOVE LEFT': 10884,
'GREATER-THAN OR SLANTED EQUAL TO WITH DOT INSIDE': 10880,
'GREATER-THAN OVER EQUAL TO': 8807,
'GREATER-THAN OVERLAPPING LESS-THAN': 10916,
'GREATER-THAN SIGN': 62,
'GREATER-THAN WITH CIRCLE INSIDE': 10874,
'GREATER-THAN WITH DOT': 8919,
'GREATER-THAN WITH QUESTION MARK ABOVE': 10876,
'GREEK ACROPHONIC ATTIC FIFTY': 65860,
'GREEK ACROPHONIC ATTIC FIFTY STATERS': 65873,
'GREEK ACROPHONIC ATTIC FIFTY TALENTS': 65866,
'GREEK ACROPHONIC ATTIC FIFTY THOUSAND': 65863,
'GREEK ACROPHONIC ATTIC FIFTY THOUSAND STATERS': 65878,
'GREEK ACROPHONIC ATTIC FIVE': 65859,
'GREEK ACROPHONIC ATTIC FIVE HUNDRED': 65861,
'GREEK ACROPHONIC ATTIC FIVE HUNDRED STATERS': 65875,
'GREEK ACROPHONIC ATTIC FIVE HUNDRED TALENTS': 65868,
'GREEK ACROPHONIC ATTIC FIVE STATERS': 65871,
'GREEK ACROPHONIC ATTIC FIVE TALENTS': 65864,
'GREEK ACROPHONIC ATTIC FIVE THOUSAND': 65862,
'GREEK ACROPHONIC ATTIC FIVE THOUSAND TALENTS': 65870,
'GREEK ACROPHONIC ATTIC ONE DRACHMA': 65858,
'GREEK ACROPHONIC ATTIC ONE HALF': 65857,
'GREEK ACROPHONIC ATTIC ONE HUNDRED STATERS': 65874,
'GREEK ACROPHONIC ATTIC ONE HUNDRED TALENTS': 65867,
'GREEK ACROPHONIC ATTIC ONE QUARTER': 65856,
'GREEK ACROPHONIC ATTIC ONE THOUSAND STATERS': 65876,
'GREEK ACROPHONIC ATTIC ONE THOUSAND TALENTS': 65869,
'GREEK ACROPHONIC ATTIC TEN MNAS': 65879,
'GREEK ACROPHONIC ATTIC TEN STATERS': 65872,
'GREEK ACROPHONIC ATTIC TEN TALENTS': 65865,
'GREEK ACROPHONIC ATTIC TEN THOUSAND STATERS': 65877,
'GREEK ACROPHONIC CARYSTIAN FIVE HUNDRED': 65903,
'GREEK ACROPHONIC CYRENAIC TWO DRACHMAS': 65885,
'GREEK ACROPHONIC DELPHIC FIVE MNAS': 65907,
'GREEK ACROPHONIC EPIDAUREAN FIVE HUNDRED': 65900,
'GREEK ACROPHONIC EPIDAUREAN TWO': 65883,
'GREEK ACROPHONIC EPIDAUREAN TWO DRACHMAS': 65886,
'GREEK ACROPHONIC HERAEUM ONE PLETHRON': 65880,
'GREEK ACROPHONIC HERMIONIAN FIFTY': 65896,
'GREEK ACROPHONIC HERMIONIAN ONE': 65882,
'GREEK ACROPHONIC HERMIONIAN TEN': 65890,
'GREEK ACROPHONIC MESSENIAN TEN': 65891,
'GREEK ACROPHONIC NAXIAN FIVE HUNDRED': 65904,
'GREEK ACROPHONIC STRATIAN FIFTY MNAS': 65908,
'GREEK ACROPHONIC THESPIAN FIFTY': 65897,
'GREEK ACROPHONIC THESPIAN FIVE HUNDRED': 65902,
'GREEK ACROPHONIC THESPIAN FIVE THOUSAND': 65906,
'GREEK ACROPHONIC THESPIAN ONE': 65881,
'GREEK ACROPHONIC THESPIAN ONE HUNDRED': 65898,
'GREEK ACROPHONIC THESPIAN ONE THOUSAND': 65905,
'GREEK ACROPHONIC THESPIAN TEN': 65892,
'GREEK ACROPHONIC THESPIAN THIRTY': 65893,
'GREEK ACROPHONIC THESPIAN THREE HUNDRED': 65899,
'GREEK ACROPHONIC THESPIAN TWO': 65884,
'GREEK ACROPHONIC TROEZENIAN FIFTY': 65894,
'GREEK ACROPHONIC TROEZENIAN FIFTY ALTERNATE FORM': 65895,
'GREEK ACROPHONIC TROEZENIAN FIVE': 65887,
'GREEK ACROPHONIC TROEZENIAN FIVE HUNDRED': 65901,
'GREEK ACROPHONIC TROEZENIAN TEN': 65888,
'GREEK ACROPHONIC TROEZENIAN TEN ALTERNATE FORM': 65889,
'GREEK ANO TELEIA': 903,
'GREEK AROURA SIGN': 65927,
'GREEK ARTABE SIGN': 65926,
'GREEK BETA SYMBOL': 976,
'GREEK CAPITAL DOTTED LUNATE SIGMA SYMBOL': 1022,
'GREEK CAPITAL KAI SYMBOL': 975,
'GREEK CAPITAL LETTER ALPHA': 913,
'GREEK CAPITAL LETTER ALPHA WITH DASIA': 7945,
'GREEK CAPITAL LETTER ALPHA WITH DASIA AND OXIA': 7949,
'GREEK CAPITAL LETTER ALPHA WITH DASIA AND OXIA AND PROSGEGRAMMENI': 8077,
'GREEK CAPITAL LETTER ALPHA WITH DASIA AND PERISPOMENI': 7951,
'GREEK CAPITAL LETTER ALPHA WITH DASIA AND PERISPOMENI AND PROSGEGRAMMENI': 8079,
'GREEK CAPITAL LETTER ALPHA WITH DASIA AND PROSGEGRAMMENI': 8073,
'GREEK CAPITAL LETTER ALPHA WITH DASIA AND VARIA': 7947,
'GREEK CAPITAL LETTER ALPHA WITH DASIA AND VARIA AND PROSGEGRAMMENI': 8075,
'GREEK CAPITAL LETTER ALPHA WITH MACRON': 8121,
'GREEK CAPITAL LETTER ALPHA WITH OXIA': 8123,
'GREEK CAPITAL LETTER ALPHA WITH PROSGEGRAMMENI': 8124,
'GREEK CAPITAL LETTER ALPHA WITH PSILI': 7944,
'GREEK CAPITAL LETTER ALPHA WITH PSILI AND OXIA': 7948,
'GREEK CAPITAL LETTER ALPHA WITH PSILI AND OXIA AND PROSGEGRAMMENI': 8076,
'GREEK CAPITAL LETTER ALPHA WITH PSILI AND PERISPOMENI': 7950,
'GREEK CAPITAL LETTER ALPHA WITH PSILI AND PERISPOMENI AND PROSGEGRAMMENI': 8078,
'GREEK CAPITAL LETTER ALPHA WITH PSILI AND PROSGEGRAMMENI': 8072,
'GREEK CAPITAL LETTER ALPHA WITH PSILI AND VARIA': 7946,
'GREEK CAPITAL LETTER ALPHA WITH PSILI AND VARIA AND PROSGEGRAMMENI': 8074,
'GREEK CAPITAL LETTER ALPHA WITH TONOS': 902,
'GREEK CAPITAL LETTER ALPHA WITH VARIA': 8122,
'GREEK CAPITAL LETTER ALPHA WITH VRACHY': 8120,
'GREEK CAPITAL LETTER ARCHAIC SAMPI': 882,
'GREEK CAPITAL LETTER BETA': 914,
'GREEK CAPITAL LETTER CHI': 935,
'GREEK CAPITAL LETTER DELTA': 916,
'GREEK CAPITAL LETTER EPSILON': 917,
'GREEK CAPITAL LETTER EPSILON WITH DASIA': 7961,
'GREEK CAPITAL LETTER EPSILON WITH DASIA AND OXIA': 7965,
'GREEK CAPITAL LETTER EPSILON WITH DASIA AND VARIA': 7963,
'GREEK CAPITAL LETTER EPSILON WITH OXIA': 8137,
'GREEK CAPITAL LETTER EPSILON WITH PSILI': 7960,
'GREEK CAPITAL LETTER EPSILON WITH PSILI AND OXIA': 7964,
'GREEK CAPITAL LETTER EPSILON WITH PSILI AND VARIA': 7962,
'GREEK CAPITAL LETTER EPSILON WITH TONOS': 904,
'GREEK CAPITAL LETTER EPSILON WITH VARIA': 8136,
'GREEK CAPITAL LETTER ETA': 919,
'GREEK CAPITAL LETTER ETA WITH DASIA': 7977,
'GREEK CAPITAL LETTER ETA WITH DASIA AND OXIA': 7981,
'GREEK CAPITAL LETTER ETA WITH DASIA AND OXIA AND PROSGEGRAMMENI': 8093,
'GREEK CAPITAL LETTER ETA WITH DASIA AND PERISPOMENI': 7983,
'GREEK CAPITAL LETTER ETA WITH DASIA AND PERISPOMENI AND PROSGEGRAMMENI': 8095,
'GREEK CAPITAL LETTER ETA WITH DASIA AND PROSGEGRAMMENI': 8089,
'GREEK CAPITAL LETTER ETA WITH DASIA AND VARIA': 7979,
'GREEK CAPITAL LETTER ETA WITH DASIA AND VARIA AND PROSGEGRAMMENI': 8091,
'GREEK CAPITAL LETTER ETA WITH OXIA': 8139,
'GREEK CAPITAL LETTER ETA WITH PROSGEGRAMMENI': 8140,
'GREEK CAPITAL LETTER ETA WITH PSILI': 7976,
'GREEK CAPITAL LETTER ETA WITH PSILI AND OXIA': 7980,
'GREEK CAPITAL LETTER ETA WITH PSILI AND OXIA AND PROSGEGRAMMENI': 8092,
'GREEK CAPITAL LETTER ETA WITH PSILI AND PERISPOMENI': 7982,
'GREEK CAPITAL LETTER ETA WITH PSILI AND PERISPOMENI AND PROSGEGRAMMENI': 8094,
'GREEK CAPITAL LETTER ETA WITH PSILI AND PROSGEGRAMMENI': 8088,
'GREEK CAPITAL LETTER ETA WITH PSILI AND VARIA': 7978,
'GREEK CAPITAL LETTER ETA WITH PSILI AND VARIA AND PROSGEGRAMMENI': 8090,
'GREEK CAPITAL LETTER ETA WITH TONOS': 905,
'GREEK CAPITAL LETTER ETA WITH VARIA': 8138,
'GREEK CAPITAL LETTER GAMMA': 915,
'GREEK CAPITAL LETTER HETA': 880,
'GREEK CAPITAL LETTER IOTA': 921,
'GREEK CAPITAL LETTER IOTA WITH DASIA': 7993,
'GREEK CAPITAL LETTER IOTA WITH DASIA AND OXIA': 7997,
'GREEK CAPITAL LETTER IOTA WITH DASIA AND PERISPOMENI': 7999,
'GREEK CAPITAL LETTER IOTA WITH DASIA AND VARIA': 7995,
'GREEK CAPITAL LETTER IOTA WITH DIALYTIKA': 938,
'GREEK CAPITAL LETTER IOTA WITH MACRON': 8153,
'GREEK CAPITAL LETTER IOTA WITH OXIA': 8155,
'GREEK CAPITAL LETTER IOTA WITH PSILI': 7992,
'GREEK CAPITAL LETTER IOTA WITH PSILI AND OXIA': 7996,
'GREEK CAPITAL LETTER IOTA WITH PSILI AND PERISPOMENI': 7998,
'GREEK CAPITAL LETTER IOTA WITH PSILI AND VARIA': 7994,
'GREEK CAPITAL LETTER IOTA WITH TONOS': 906,
'GREEK CAPITAL LETTER IOTA WITH VARIA': 8154,
'GREEK CAPITAL LETTER IOTA WITH VRACHY': 8152,
'GREEK CAPITAL LETTER KAPPA': 922,
'GREEK CAPITAL LETTER LAMDA': 923,
'GREEK CAPITAL LETTER MU': 924,
'GREEK CAPITAL LETTER NU': 925,
'GREEK CAPITAL LETTER OMEGA': 937,
'GREEK CAPITAL LETTER OMEGA WITH DASIA': 8041,
'GREEK CAPITAL LETTER OMEGA WITH DASIA AND OXIA': 8045,
'GREEK CAPITAL LETTER OMEGA WITH DASIA AND OXIA AND PROSGEGRAMMENI': 8109,
'GREEK CAPITAL LETTER OMEGA WITH DASIA AND PERISPOMENI': 8047,
'GREEK CAPITAL LETTER OMEGA WITH DASIA AND PERISPOMENI AND PROSGEGRAMMENI': 8111,
'GREEK CAPITAL LETTER OMEGA WITH DASIA AND PROSGEGRAMMENI': 8105,
'GREEK CAPITAL LETTER OMEGA WITH DASIA AND VARIA': 8043,
'GREEK CAPITAL LETTER OMEGA WITH DASIA AND VARIA AND PROSGEGRAMMENI': 8107,
'GREEK CAPITAL LETTER OMEGA WITH OXIA': 8187,
'GREEK CAPITAL LETTER OMEGA WITH PROSGEGRAMMENI': 8188,
'GREEK CAPITAL LETTER OMEGA WITH PSILI': 8040,
'GREEK CAPITAL LETTER OMEGA WITH PSILI AND OXIA': 8044,
'GREEK CAPITAL LETTER OMEGA WITH PSILI AND OXIA AND PROSGEGRAMMENI': 8108,
'GREEK CAPITAL LETTER OMEGA WITH PSILI AND PERISPOMENI': 8046,
'GREEK CAPITAL LETTER OMEGA WITH PSILI AND PERISPOMENI AND PROSGEGRAMMENI': 8110,
'GREEK CAPITAL LETTER OMEGA WITH PSILI AND PROSGEGRAMMENI': 8104,
'GREEK CAPITAL LETTER OMEGA WITH PSILI AND VARIA': 8042,
'GREEK CAPITAL LETTER OMEGA WITH PSILI AND VARIA AND PROSGEGRAMMENI': 8106,
'GREEK CAPITAL LETTER OMEGA WITH TONOS': 911,
'GREEK CAPITAL LETTER OMEGA WITH VARIA': 8186,
'GREEK CAPITAL LETTER OMICRON': 927,
'GREEK CAPITAL LETTER OMICRON WITH DASIA': 8009,
'GREEK CAPITAL LETTER OMICRON WITH DASIA AND OXIA': 8013,
'GREEK CAPITAL LETTER OMICRON WITH DASIA AND VARIA': 8011,
'GREEK CAPITAL LETTER OMICRON WITH OXIA': 8185,
'GREEK CAPITAL LETTER OMICRON WITH PSILI': 8008,
'GREEK CAPITAL LETTER OMICRON WITH PSILI AND OXIA': 8012,
'GREEK CAPITAL LETTER OMICRON WITH PSILI AND VARIA': 8010,
'GREEK CAPITAL LETTER OMICRON WITH TONOS': 908,
'GREEK CAPITAL LETTER OMICRON WITH VARIA': 8184,
'GREEK CAPITAL LETTER PAMPHYLIAN DIGAMMA': 886,
'GREEK CAPITAL LETTER PHI': 934,
'GREEK CAPITAL LETTER PI': 928,
'GREEK CAPITAL LETTER PSI': 936,
'GREEK CAPITAL LETTER RHO': 929,
'GREEK CAPITAL LETTER RHO WITH DASIA': 8172,
'GREEK CAPITAL LETTER SAN': 1018,
'GREEK CAPITAL LETTER SHO': 1015,
'GREEK CAPITAL LETTER SIGMA': 931,
'GREEK CAPITAL LETTER TAU': 932,
'GREEK CAPITAL LETTER THETA': 920,
'GREEK CAPITAL LETTER UPSILON': 933,
'GREEK CAPITAL LETTER UPSILON WITH DASIA': 8025,
'GREEK CAPITAL LETTER UPSILON WITH DASIA AND OXIA': 8029,
'GREEK CAPITAL LETTER UPSILON WITH DASIA AND PERISPOMENI': 8031,
'GREEK CAPITAL LETTER UPSILON WITH DASIA AND VARIA': 8027,
'GREEK CAPITAL LETTER UPSILON WITH DIALYTIKA': 939,
'GREEK CAPITAL LETTER UPSILON WITH MACRON': 8169,
'GREEK CAPITAL LETTER UPSILON WITH OXIA': 8171,
'GREEK CAPITAL LETTER UPSILON WITH TONOS': 910,
'GREEK CAPITAL LETTER UPSILON WITH VARIA': 8170,
'GREEK CAPITAL LETTER UPSILON WITH VRACHY': 8168,
'GREEK CAPITAL LETTER XI': 926,
'GREEK CAPITAL LETTER ZETA': 918,
'GREEK CAPITAL LUNATE SIGMA SYMBOL': 1017,
'GREEK CAPITAL REVERSED DOTTED LUNATE SIGMA SYMBOL': 1023,
'GREEK CAPITAL REVERSED LUNATE SIGMA SYMBOL': 1021,
'GREEK CAPITAL THETA SYMBOL': 1012,
'GREEK DASIA': 8190,
'GREEK DASIA AND OXIA': 8158,
'GREEK DASIA AND PERISPOMENI': 8159,
'GREEK DASIA AND VARIA': 8157,
'GREEK DIALYTIKA AND OXIA': 8174,
'GREEK DIALYTIKA AND PERISPOMENI': 8129,
'GREEK DIALYTIKA AND VARIA': 8173,
'GREEK DIALYTIKA TONOS': 901,
'GREEK DRACHMA SIGN': 65915,
'GREEK FIVE OBOLS SIGN': 65920,
'GREEK FOUR OBOLS SIGN': 65919,
'GREEK GRAMMA SIGN': 65928,
'GREEK INSTRUMENTAL NOTATION SYMBOL-1': 119325,
'GREEK INSTRUMENTAL NOTATION SYMBOL-11': 119331,
'GREEK INSTRUMENTAL NOTATION SYMBOL-12': 119332,
'GREEK INSTRUMENTAL NOTATION SYMBOL-13': 119333,
'GREEK INSTRUMENTAL NOTATION SYMBOL-14': 119334,
'GREEK INSTRUMENTAL NOTATION SYMBOL-17': 119335,
'GREEK INSTRUMENTAL NOTATION SYMBOL-18': 119336,
'GREEK INSTRUMENTAL NOTATION SYMBOL-19': 119337,
'GREEK INSTRUMENTAL NOTATION SYMBOL-2': 119326,
'GREEK INSTRUMENTAL NOTATION SYMBOL-23': 119338,
'GREEK INSTRUMENTAL NOTATION SYMBOL-24': 119339,
'GREEK INSTRUMENTAL NOTATION SYMBOL-25': 119340,
'GREEK INSTRUMENTAL NOTATION SYMBOL-26': 119341,
'GREEK INSTRUMENTAL NOTATION SYMBOL-27': 119342,
'GREEK INSTRUMENTAL NOTATION SYMBOL-29': 119343,
'GREEK INSTRUMENTAL NOTATION SYMBOL-30': 119344,
'GREEK INSTRUMENTAL NOTATION SYMBOL-32': 119345,
'GREEK INSTRUMENTAL NOTATION SYMBOL-36': 119346,
'GREEK INSTRUMENTAL NOTATION SYMBOL-37': 119347,
'GREEK INSTRUMENTAL NOTATION SYMBOL-38': 119348,
'GREEK INSTRUMENTAL NOTATION SYMBOL-39': 119349,
'GREEK INSTRUMENTAL NOTATION SYMBOL-4': 119327,
'GREEK INSTRUMENTAL NOTATION SYMBOL-40': 119350,
'GREEK INSTRUMENTAL NOTATION SYMBOL-42': 119351,
'GREEK INSTRUMENTAL NOTATION SYMBOL-43': 119352,
'GREEK INSTRUMENTAL NOTATION SYMBOL-45': 119353,
'GREEK INSTRUMENTAL NOTATION SYMBOL-47': 119354,
'GREEK INSTRUMENTAL NOTATION SYMBOL-48': 119355,
'GREEK INSTRUMENTAL NOTATION SYMBOL-49': 119356,
'GREEK INSTRUMENTAL NOTATION SYMBOL-5': 119328,
'GREEK INSTRUMENTAL NOTATION SYMBOL-50': 119357,
'GREEK INSTRUMENTAL NOTATION SYMBOL-51': 119358,
'GREEK INSTRUMENTAL NOTATION SYMBOL-52': 119359,
'GREEK INSTRUMENTAL NOTATION SYMBOL-53': 119360,
'GREEK INSTRUMENTAL NOTATION SYMBOL-54': 119361,
'GREEK INSTRUMENTAL NOTATION SYMBOL-7': 119329,
'GREEK INSTRUMENTAL NOTATION SYMBOL-8': 119330,
'GREEK KAI SYMBOL': 983,
'GREEK KAPPA SYMBOL': 1008,
'GREEK KORONIS': 8125,
'GREEK KYATHOS BASE SIGN': 65922,
'GREEK LETTER ARCHAIC KOPPA': 984,
'GREEK LETTER DIGAMMA': 988,
'GREEK LETTER KOPPA': 990,
'GREEK LETTER SAMPI': 992,
'GREEK LETTER SMALL CAPITAL GAMMA': 7462,
'GREEK LETTER SMALL CAPITAL LAMDA': 7463,
'GREEK LETTER SMALL CAPITAL PI': 7464,
'GREEK LETTER SMALL CAPITAL PSI': 7466,
'GREEK LETTER SMALL CAPITAL RHO': 7465,
'GREEK LETTER STIGMA': 986,
'GREEK LETTER YOT': 1011,
'GREEK LITRA SIGN': 65923,
'GREEK LOWER NUMERAL SIGN': 885,
'GREEK LUNATE EPSILON SYMBOL': 1013,
'GREEK LUNATE SIGMA SYMBOL': 1010,
'GREEK METRETES SIGN': 65921,
'GREEK MUSICAL LEIMMA': 119365,
'GREEK NUMERAL SIGN': 884,
'GREEK OBOL SIGN': 65916,
'GREEK ONE HALF SIGN': 65909,
'GREEK ONE HALF SIGN ALTERNATE FORM': 65910,
'GREEK OUNKIA SIGN': 65924,
'GREEK OXIA': 8189,
'GREEK PERISPOMENI': 8128,
'GREEK PHI SYMBOL': 981,
'GREEK PI SYMBOL': 982,
'GREEK PROSGEGRAMMENI': 8126,
'GREEK PSILI': 8127,
'GREEK PSILI AND OXIA': 8142,
'GREEK PSILI AND PERISPOMENI': 8143,
'GREEK PSILI AND VARIA': 8141,
'GREEK QUESTION MARK': 894,
'GREEK REVERSED LUNATE EPSILON SYMBOL': 1014,
'GREEK RHO SYMBOL': 1009,
'GREEK RHO WITH STROKE SYMBOL': 1020,
'GREEK SMALL DOTTED LUNATE SIGMA SYMBOL': 892,
'GREEK SMALL LETTER ALPHA': 945,
'GREEK SMALL LETTER ALPHA WITH DASIA': 7937,
'GREEK SMALL LETTER ALPHA WITH DASIA AND OXIA': 7941,
'GREEK SMALL LETTER ALPHA WITH DASIA AND OXIA AND YPOGEGRAMMENI': 8069,
'GREEK SMALL LETTER ALPHA WITH DASIA AND PERISPOMENI': 7943,
'GREEK SMALL LETTER ALPHA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI': 8071,
'GREEK SMALL LETTER ALPHA WITH DASIA AND VARIA': 7939,
'GREEK SMALL LETTER ALPHA WITH DASIA AND VARIA AND YPOGEGRAMMENI': 8067,
'GREEK SMALL LETTER ALPHA WITH DASIA AND YPOGEGRAMMENI': 8065,
'GREEK SMALL LETTER ALPHA WITH MACRON': 8113,
'GREEK SMALL LETTER ALPHA WITH OXIA': 8049,
'GREEK SMALL LETTER ALPHA WITH OXIA AND YPOGEGRAMMENI': 8116,
'GREEK SMALL LETTER ALPHA WITH PERISPOMENI': 8118,
'GREEK SMALL LETTER ALPHA WITH PERISPOMENI AND YPOGEGRAMMENI': 8119,
'GREEK SMALL LETTER ALPHA WITH PSILI': 7936,
'GREEK SMALL LETTER ALPHA WITH PSILI AND OXIA': 7940,
'GREEK SMALL LETTER ALPHA WITH PSILI AND OXIA AND YPOGEGRAMMENI': 8068,
'GREEK SMALL LETTER ALPHA WITH PSILI AND PERISPOMENI': 7942,
'GREEK SMALL LETTER ALPHA WITH PSILI AND PERISPOMENI AND YPOGEGRAMMENI': 8070,
'GREEK SMALL LETTER ALPHA WITH PSILI AND VARIA': 7938,
'GREEK SMALL LETTER ALPHA WITH PSILI AND VARIA AND YPOGEGRAMMENI': 8066,
'GREEK SMALL LETTER ALPHA WITH PSILI AND YPOGEGRAMMENI': 8064,
'GREEK SMALL LETTER ALPHA WITH TONOS': 940,
'GREEK SMALL LETTER ALPHA WITH VARIA': 8048,
'GREEK SMALL LETTER ALPHA WITH VARIA AND YPOGEGRAMMENI': 8114,
'GREEK SMALL LETTER ALPHA WITH VRACHY': 8112,
'GREEK SMALL LETTER ALPHA WITH YPOGEGRAMMENI': 8115,
'GREEK SMALL LETTER ARCHAIC KOPPA': 985,
'GREEK SMALL LETTER ARCHAIC SAMPI': 883,
'GREEK SMALL LETTER BETA': 946,
'GREEK SMALL LETTER CHI': 967,
'GREEK SMALL LETTER DELTA': 948,
'GREEK SMALL LETTER DIGAMMA': 989,
'GREEK SMALL LETTER EPSILON': 949,
'GREEK SMALL LETTER EPSILON WITH DASIA': 7953,
'GREEK SMALL LETTER EPSILON WITH DASIA AND OXIA': 7957,
'GREEK SMALL LETTER EPSILON WITH DASIA AND VARIA': 7955,
'GREEK SMALL LETTER EPSILON WITH OXIA': 8051,
'GREEK SMALL LETTER EPSILON WITH PSILI': 7952,
'GREEK SMALL LETTER EPSILON WITH PSILI AND OXIA': 7956,
'GREEK SMALL LETTER EPSILON WITH PSILI AND VARIA': 7954,
'GREEK SMALL LETTER EPSILON WITH TONOS': 941,
'GREEK SMALL LETTER EPSILON WITH VARIA': 8050,
'GREEK SMALL LETTER ETA': 951,
'GREEK SMALL LETTER ETA WITH DASIA': 7969,
'GREEK SMALL LETTER ETA WITH DASIA AND OXIA': 7973,
'GREEK SMALL LETTER ETA WITH DASIA AND OXIA AND YPOGEGRAMMENI': 8085,
'GREEK SMALL LETTER ETA WITH DASIA AND PERISPOMENI': 7975,
'GREEK SMALL LETTER ETA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI': 8087,
'GREEK SMALL LETTER ETA WITH DASIA AND VARIA': 7971,
'GREEK SMALL LETTER ETA WITH DASIA AND VARIA AND YPOGEGRAMMENI': 8083,
'GREEK SMALL LETTER ETA WITH DASIA AND YPOGEGRAMMENI': 8081,
'GREEK SMALL LETTER ETA WITH OXIA': 8053,
'GREEK SMALL LETTER ETA WITH OXIA AND YPOGEGRAMMENI': 8132,
'GREEK SMALL LETTER ETA WITH PERISPOMENI': 8134,
'GREEK SMALL LETTER ETA WITH PERISPOMENI AND YPOGEGRAMMENI': 8135,
'GREEK SMALL LETTER ETA WITH PSILI': 7968,
'GREEK SMALL LETTER ETA WITH PSILI AND OXIA': 7972,
'GREEK SMALL LETTER ETA WITH PSILI AND OXIA AND YPOGEGRAMMENI': 8084,
'GREEK SMALL LETTER ETA WITH PSILI AND PERISPOMENI': 7974,
'GREEK SMALL LETTER ETA WITH PSILI AND PERISPOMENI AND YPOGEGRAMMENI': 8086,
'GREEK SMALL LETTER ETA WITH PSILI AND VARIA': 7970,
'GREEK SMALL LETTER ETA WITH PSILI AND VARIA AND YPOGEGRAMMENI': 8082,
'GREEK SMALL LETTER ETA WITH PSILI AND YPOGEGRAMMENI': 8080,
'GREEK SMALL LETTER ETA WITH TONOS': 942,
'GREEK SMALL LETTER ETA WITH VARIA': 8052,
'GREEK SMALL LETTER ETA WITH VARIA AND YPOGEGRAMMENI': 8130,
'GREEK SMALL LETTER ETA WITH YPOGEGRAMMENI': 8131,
'GREEK SMALL LETTER FINAL SIGMA': 962,
'GREEK SMALL LETTER GAMMA': 947,
'GREEK SMALL LETTER HETA': 881,
'GREEK SMALL LETTER IOTA': 953,
'GREEK SMALL LETTER IOTA WITH DASIA': 7985,
'GREEK SMALL LETTER IOTA WITH DASIA AND OXIA': 7989,
'GREEK SMALL LETTER IOTA WITH DASIA AND PERISPOMENI': 7991,
'GREEK SMALL LETTER IOTA WITH DASIA AND VARIA': 7987,
'GREEK SMALL LETTER IOTA WITH DIALYTIKA': 970,
'GREEK SMALL LETTER IOTA WITH DIALYTIKA AND OXIA': 8147,
'GREEK SMALL LETTER IOTA WITH DIALYTIKA AND PERISPOMENI': 8151,
'GREEK SMALL LETTER IOTA WITH DIALYTIKA AND TONOS': 912,
'GREEK SMALL LETTER IOTA WITH DIALYTIKA AND VARIA': 8146,
'GREEK SMALL LETTER IOTA WITH MACRON': 8145,
'GREEK SMALL LETTER IOTA WITH OXIA': 8055,
'GREEK SMALL LETTER IOTA WITH PERISPOMENI': 8150,
'GREEK SMALL LETTER IOTA WITH PSILI': 7984,
'GREEK SMALL LETTER IOTA WITH PSILI AND OXIA': 7988,
'GREEK SMALL LETTER IOTA WITH PSILI AND PERISPOMENI': 7990,
'GREEK SMALL LETTER IOTA WITH PSILI AND VARIA': 7986,
'GREEK SMALL LETTER IOTA WITH TONOS': 943,
'GREEK SMALL LETTER IOTA WITH VARIA': 8054,
'GREEK SMALL LETTER IOTA WITH VRACHY': 8144,
'GREEK SMALL LETTER KAPPA': 954,
'GREEK SMALL LETTER KOPPA': 991,
'GREEK SMALL LETTER LAMDA': 955,
'GREEK SMALL LETTER MU': 956,
'GREEK SMALL LETTER NU': 957,
'GREEK SMALL LETTER OMEGA': 969,
'GREEK SMALL LETTER OMEGA WITH DASIA': 8033,
'GREEK SMALL LETTER OMEGA WITH DASIA AND OXIA': 8037,
'GREEK SMALL LETTER OMEGA WITH DASIA AND OXIA AND YPOGEGRAMMENI': 8101,
'GREEK SMALL LETTER OMEGA WITH DASIA AND PERISPOMENI': 8039,
'GREEK SMALL LETTER OMEGA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI': 8103,
'GREEK SMALL LETTER OMEGA WITH DASIA AND VARIA': 8035,
'GREEK SMALL LETTER OMEGA WITH DASIA AND VARIA AND YPOGEGRAMMENI': 8099,
'GREEK SMALL LETTER OMEGA WITH DASIA AND YPOGEGRAMMENI': 8097,
'GREEK SMALL LETTER OMEGA WITH OXIA': 8061,
'GREEK SMALL LETTER OMEGA WITH OXIA AND YPOGEGRAMMENI': 8180,
'GREEK SMALL LETTER OMEGA WITH PERISPOMENI': 8182,
'GREEK SMALL LETTER OMEGA WITH PERISPOMENI AND YPOGEGRAMMENI': 8183,
'GREEK SMALL LETTER OMEGA WITH PSILI': 8032,
'GREEK SMALL LETTER OMEGA WITH PSILI AND OXIA': 8036,
'GREEK SMALL LETTER OMEGA WITH PSILI AND OXIA AND YPOGEGRAMMENI': 8100,
'GREEK SMALL LETTER OMEGA WITH PSILI AND PERISPOMENI': 8038,
'GREEK SMALL LETTER OMEGA WITH PSILI AND PERISPOMENI AND YPOGEGRAMMENI': 8102,
'GREEK SMALL LETTER OMEGA WITH PSILI AND VARIA': 8034,
'GREEK SMALL LETTER OMEGA WITH PSILI AND VARIA AND YPOGEGRAMMENI': 8098,
'GREEK SMALL LETTER OMEGA WITH PSILI AND YPOGEGRAMMENI': 8096,
'GREEK SMALL LETTER OMEGA WITH TONOS': 974,
'GREEK SMALL LETTER OMEGA WITH VARIA': 8060,
'GREEK SMALL LETTER OMEGA WITH VARIA AND YPOGEGRAMMENI': 8178,
'GREEK SMALL LETTER OMEGA WITH YPOGEGRAMMENI': 8179,
'GREEK SMALL LETTER OMICRON': 959,
'GREEK SMALL LETTER OMICRON WITH DASIA': 8001,
'GREEK SMALL LETTER OMICRON WITH DASIA AND OXIA': 8005,
'GREEK SMALL LETTER OMICRON WITH DASIA AND VARIA': 8003,
'GREEK SMALL LETTER OMICRON WITH OXIA': 8057,
'GREEK SMALL LETTER OMICRON WITH PSILI': 8000,
'GREEK SMALL LETTER OMICRON WITH PSILI AND OXIA': 8004,
'GREEK SMALL LETTER OMICRON WITH PSILI AND VARIA': 8002,
'GREEK SMALL LETTER OMICRON WITH TONOS': 972,
'GREEK SMALL LETTER OMICRON WITH VARIA': 8056,
'GREEK SMALL LETTER PAMPHYLIAN DIGAMMA': 887,
'GREEK SMALL LETTER PHI': 966,
'GREEK SMALL LETTER PI': 960,
'GREEK SMALL LETTER PSI': 968,
'GREEK SMALL LETTER RHO': 961,
'GREEK SMALL LETTER RHO WITH DASIA': 8165,
'GREEK SMALL LETTER RHO WITH PSILI': 8164,
'GREEK SMALL LETTER SAMPI': 993,
'GREEK SMALL LETTER SAN': 1019,
'GREEK SMALL LETTER SHO': 1016,
'GREEK SMALL LETTER SIGMA': 963,
'GREEK SMALL LETTER STIGMA': 987,
'GREEK SMALL LETTER TAU': 964,
'GREEK SMALL LETTER THETA': 952,
'GREEK SMALL LETTER UPSILON': 965,
'GREEK SMALL LETTER UPSILON WITH DASIA': 8017,
'GREEK SMALL LETTER UPSILON WITH DASIA AND OXIA': 8021,
'GREEK SMALL LETTER UPSILON WITH DASIA AND PERISPOMENI': 8023,
'GREEK SMALL LETTER UPSILON WITH DASIA AND VARIA': 8019,
'GREEK SMALL LETTER UPSILON WITH DIALYTIKA': 971,
'GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND OXIA': 8163,
'GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND PERISPOMENI': 8167,
'GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND TONOS': 944,
'GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND VARIA': 8162,
'GREEK SMALL LETTER UPSILON WITH MACRON': 8161,
'GREEK SMALL LETTER UPSILON WITH OXIA': 8059,
'GREEK SMALL LETTER UPSILON WITH PERISPOMENI': 8166,
'GREEK SMALL LETTER UPSILON WITH PSILI': 8016,
'GREEK SMALL LETTER UPSILON WITH PSILI AND OXIA': 8020,
'GREEK SMALL LETTER UPSILON WITH PSILI AND PERISPOMENI': 8022,
'GREEK SMALL LETTER UPSILON WITH PSILI AND VARIA': 8018,
'GREEK SMALL LETTER UPSILON WITH TONOS': 973,
'GREEK SMALL LETTER UPSILON WITH VARIA': 8058,
'GREEK SMALL LETTER UPSILON WITH VRACHY': 8160,
'GREEK SMALL LETTER XI': 958,
'GREEK SMALL LETTER ZETA': 950,
'GREEK SMALL REVERSED DOTTED LUNATE SIGMA SYMBOL': 893,
'GREEK SMALL REVERSED LUNATE SIGMA SYMBOL': 891,
'GREEK SUBSCRIPT SMALL LETTER BETA': 7526,
'GREEK SUBSCRIPT SMALL LETTER CHI': 7530,
'GREEK SUBSCRIPT SMALL LETTER GAMMA': 7527,
'GREEK SUBSCRIPT SMALL LETTER PHI': 7529,
'GREEK SUBSCRIPT SMALL LETTER RHO': 7528,
'GREEK TALENT SIGN': 65914,
'GREEK THETA SYMBOL': 977,
'GREEK THREE OBOLS SIGN': 65918,
'GREEK THREE QUARTERS SIGN': 65912,
'GREEK TONOS': 900,
'GREEK TRYBLION BASE SIGN': 65929,
'GREEK TWO OBOLS SIGN': 65917,
'GREEK TWO THIRDS SIGN': 65911,
'GREEK UPSILON WITH ACUTE AND HOOK SYMBOL': 979,
'GREEK UPSILON WITH DIAERESIS AND HOOK SYMBOL': 980,
'GREEK UPSILON WITH HOOK SYMBOL': 978,
'GREEK VARIA': 8175,
'GREEK VOCAL NOTATION SYMBOL-1': 119296,
'GREEK VOCAL NOTATION SYMBOL-10': 119305,
'GREEK VOCAL NOTATION SYMBOL-11': 119306,
'GREEK VOCAL NOTATION SYMBOL-12': 119307,
'GREEK VOCAL NOTATION SYMBOL-13': 119308,
'GREEK VOCAL NOTATION SYMBOL-14': 119309,
'GREEK VOCAL NOTATION SYMBOL-15': 119310,
'GREEK VOCAL NOTATION SYMBOL-16': 119311,
'GREEK VOCAL NOTATION SYMBOL-17': 119312,
'GREEK VOCAL NOTATION SYMBOL-18': 119313,
'GREEK VOCAL NOTATION SYMBOL-19': 119314,
'GREEK VOCAL NOTATION SYMBOL-2': 119297,
'GREEK VOCAL NOTATION SYMBOL-20': 119315,
'GREEK VOCAL NOTATION SYMBOL-21': 119316,
'GREEK VOCAL NOTATION SYMBOL-22': 119317,
'GREEK VOCAL NOTATION SYMBOL-23': 119318,
'GREEK VOCAL NOTATION SYMBOL-24': 119319,
'GREEK VOCAL NOTATION SYMBOL-3': 119298,
'GREEK VOCAL NOTATION SYMBOL-4': 119299,
'GREEK VOCAL NOTATION SYMBOL-5': 119300,
'GREEK VOCAL NOTATION SYMBOL-50': 119320,
'GREEK VOCAL NOTATION SYMBOL-51': 119321,
'GREEK VOCAL NOTATION SYMBOL-52': 119322,
'GREEK VOCAL NOTATION SYMBOL-53': 119323,
'GREEK VOCAL NOTATION SYMBOL-54': 119324,
'GREEK VOCAL NOTATION SYMBOL-6': 119301,
'GREEK VOCAL NOTATION SYMBOL-7': 119302,
'GREEK VOCAL NOTATION SYMBOL-8': 119303,
'GREEK VOCAL NOTATION SYMBOL-9': 119304,
'GREEK XESTES SIGN': 65925,
'GREEK YEAR SIGN': 65913,
'GREEK YPOGEGRAMMENI': 890,
'GREEK ZERO SIGN': 65930,
'GUARANI SIGN': 8370,
'GUJARATI DIGIT EIGHT': 2798,
'GUJARATI DIGIT FIVE': 2795,
'GUJARATI DIGIT FOUR': 2794,
'GUJARATI DIGIT NINE': 2799,
'GUJARATI DIGIT ONE': 2791,
'GUJARATI DIGIT SEVEN': 2797,
'GUJARATI DIGIT SIX': 2796,
'GUJARATI DIGIT THREE': 2793,
'GUJARATI DIGIT TWO': 2792,
'GUJARATI DIGIT ZERO': 2790,
'GUJARATI LETTER A': 2693,
'GUJARATI LETTER AA': 2694,
'GUJARATI LETTER AI': 2704,
'GUJARATI LETTER AU': 2708,
'GUJARATI LETTER BA': 2732,
'GUJARATI LETTER BHA': 2733,
'GUJARATI LETTER CA': 2714,
'GUJARATI LETTER CHA': 2715,
'GUJARATI LETTER DA': 2726,
'GUJARATI LETTER DDA': 2721,
'GUJARATI LETTER DDHA': 2722,
'GUJARATI LETTER DHA': 2727,
'GUJARATI LETTER E': 2703,
'GUJARATI LETTER GA': 2711,
'GUJARATI LETTER GHA': 2712,
'GUJARATI LETTER HA': 2745,
'GUJARATI LETTER I': 2695,
'GUJARATI LETTER II': 2696,
'GUJARATI LETTER JA': 2716,
'GUJARATI LETTER JHA': 2717,
'GUJARATI LETTER KA': 2709,
'GUJARATI LETTER KHA': 2710,
'GUJARATI LETTER LA': 2738,
'GUJARATI LETTER LLA': 2739,
'GUJARATI LETTER MA': 2734,
'GUJARATI LETTER NA': 2728,
'GUJARATI LETTER NGA': 2713,
'GUJARATI LETTER NNA': 2723,
'GUJARATI LETTER NYA': 2718,
'GUJARATI LETTER O': 2707,
'GUJARATI LETTER PA': 2730,
'GUJARATI LETTER PHA': 2731,
'GUJARATI LETTER RA': 2736,
'GUJARATI LETTER SA': 2744,
'GUJARATI LETTER SHA': 2742,
'GUJARATI LETTER SSA': 2743,
'GUJARATI LETTER TA': 2724,
'GUJARATI LETTER THA': 2725,
'GUJARATI LETTER TTA': 2719,
'GUJARATI LETTER TTHA': 2720,
'GUJARATI LETTER U': 2697,
'GUJARATI LETTER UU': 2698,
'GUJARATI LETTER VA': 2741,
'GUJARATI LETTER VOCALIC L': 2700,
'GUJARATI LETTER VOCALIC LL': 2785,
'GUJARATI LETTER VOCALIC R': 2699,
'GUJARATI LETTER VOCALIC RR': 2784,
'GUJARATI LETTER YA': 2735,
'GUJARATI OM': 2768,
'GUJARATI RUPEE SIGN': 2801,
'GUJARATI SIGN ANUSVARA': 2690,
'GUJARATI SIGN AVAGRAHA': 2749,
'GUJARATI SIGN CANDRABINDU': 2689,
'GUJARATI SIGN NUKTA': 2748,
'GUJARATI SIGN VIRAMA': 2765,
'GUJARATI SIGN VISARGA': 2691,
'GUJARATI VOWEL CANDRA E': 2701,
'GUJARATI VOWEL CANDRA O': 2705,
'GUJARATI VOWEL SIGN AA': 2750,
'GUJARATI VOWEL SIGN AI': 2760,
'GUJARATI VOWEL SIGN AU': 2764,
'GUJARATI VOWEL SIGN CANDRA E': 2757,
'GUJARATI VOWEL SIGN CANDRA O': 2761,
'GUJARATI VOWEL SIGN E': 2759,
'GUJARATI VOWEL SIGN I': 2751,
'GUJARATI VOWEL SIGN II': 2752,
'GUJARATI VOWEL SIGN O': 2763,
'GUJARATI VOWEL SIGN U': 2753,
'GUJARATI VOWEL SIGN UU': 2754,
'GUJARATI VOWEL SIGN VOCALIC L': 2786,
'GUJARATI VOWEL SIGN VOCALIC LL': 2787,
'GUJARATI VOWEL SIGN VOCALIC R': 2755,
'GUJARATI VOWEL SIGN VOCALIC RR': 2756,
'GURMUKHI ADDAK': 2673,
'GURMUKHI DIGIT EIGHT': 2670,
'GURMUKHI DIGIT FIVE': 2667,
'GURMUKHI DIGIT FOUR': 2666,
'GURMUKHI DIGIT NINE': 2671,
'GURMUKHI DIGIT ONE': 2663,
'GURMUKHI DIGIT SEVEN': 2669,
'GURMUKHI DIGIT SIX': 2668,
'GURMUKHI DIGIT THREE': 2665,
'GURMUKHI DIGIT TWO': 2664,
'GURMUKHI DIGIT ZERO': 2662,
'GURMUKHI EK ONKAR': 2676,
'GURMUKHI IRI': 2674,
'GURMUKHI LETTER A': 2565,
'GURMUKHI LETTER AA': 2566,
'GURMUKHI LETTER AI': 2576,
'GURMUKHI LETTER AU': 2580,
'GURMUKHI LETTER BA': 2604,
'GURMUKHI LETTER BHA': 2605,
'GURMUKHI LETTER CA': 2586,
'GURMUKHI LETTER CHA': 2587,
'GURMUKHI LETTER DA': 2598,
'GURMUKHI LETTER DDA': 2593,
'GURMUKHI LETTER DDHA': 2594,
'GURMUKHI LETTER DHA': 2599,
'GURMUKHI LETTER EE': 2575,
'GURMUKHI LETTER FA': 2654,
'GURMUKHI LETTER GA': 2583,
'GURMUKHI LETTER GHA': 2584,
'GURMUKHI LETTER GHHA': 2650,
'GURMUKHI LETTER HA': 2617,
'GURMUKHI LETTER I': 2567,
'GURMUKHI LETTER II': 2568,
'GURMUKHI LETTER JA': 2588,
'GURMUKHI LETTER JHA': 2589,
'GURMUKHI LETTER KA': 2581,
'GURMUKHI LETTER KHA': 2582,
'GURMUKHI LETTER KHHA': 2649,
'GURMUKHI LETTER LA': 2610,
'GURMUKHI LETTER LLA': 2611,
'GURMUKHI LETTER MA': 2606,
'GURMUKHI LETTER NA': 2600,
'GURMUKHI LETTER NGA': 2585,
'GURMUKHI LETTER NNA': 2595,
'GURMUKHI LETTER NYA': 2590,
'GURMUKHI LETTER OO': 2579,
'GURMUKHI LETTER PA': 2602,
'GURMUKHI LETTER PHA': 2603,
'GURMUKHI LETTER RA': 2608,
'GURMUKHI LETTER RRA': 2652,
'GURMUKHI LETTER SA': 2616,
'GURMUKHI LETTER SHA': 2614,
'GURMUKHI LETTER TA': 2596,
'GURMUKHI LETTER THA': 2597,
'GURMUKHI LETTER TTA': 2591,
'GURMUKHI LETTER TTHA': 2592,
'GURMUKHI LETTER U': 2569,
'GURMUKHI LETTER UU': 2570,
'GURMUKHI LETTER VA': 2613,
'GURMUKHI LETTER YA': 2607,
'GURMUKHI LETTER ZA': 2651,
'GURMUKHI SIGN ADAK BINDI': 2561,
'GURMUKHI SIGN BINDI': 2562,
'GURMUKHI SIGN NUKTA': 2620,
'GURMUKHI SIGN UDAAT': 2641,
'GURMUKHI SIGN VIRAMA': 2637,
'GURMUKHI SIGN VISARGA': 2563,
'GURMUKHI SIGN YAKASH': 2677,
'GURMUKHI TIPPI': 2672,
'GURMUKHI URA': 2675,
'GURMUKHI VOWEL SIGN AA': 2622,
'GURMUKHI VOWEL SIGN AI': 2632,
'GURMUKHI VOWEL SIGN AU': 2636,
'GURMUKHI VOWEL SIGN EE': 2631,
'GURMUKHI VOWEL SIGN I': 2623,
'GURMUKHI VOWEL SIGN II': 2624,
'GURMUKHI VOWEL SIGN OO': 2635,
'GURMUKHI VOWEL SIGN U': 2625,
'GURMUKHI VOWEL SIGN UU': 2626,
'HAIR SPACE': 8202,
'HALFWIDTH BLACK SQUARE': 65517,
'HALFWIDTH DOWNWARDS ARROW': 65516,
'HALFWIDTH FORMS LIGHT VERTICAL': 65512,
'HALFWIDTH HANGUL FILLER': 65440,
'HALFWIDTH HANGUL LETTER A': 65474,
'HALFWIDTH HANGUL LETTER AE': 65475,
'HALFWIDTH HANGUL LETTER CHIEUCH': 65466,
'HALFWIDTH HANGUL LETTER CIEUC': 65464,
'HALFWIDTH HANGUL LETTER E': 65479,
'HALFWIDTH HANGUL LETTER EO': 65478,
'HALFWIDTH HANGUL LETTER EU': 65498,
'HALFWIDTH HANGUL LETTER HIEUH': 65470,
'HALFWIDTH HANGUL LETTER I': 65500,
'HALFWIDTH HANGUL LETTER IEUNG': 65463,
'HALFWIDTH HANGUL LETTER KHIEUKH': 65467,
'HALFWIDTH HANGUL LETTER KIYEOK': 65441,
'HALFWIDTH HANGUL LETTER KIYEOK-SIOS': 65443,
'HALFWIDTH HANGUL LETTER MIEUM': 65457,
'HALFWIDTH HANGUL LETTER NIEUN': 65444,
'HALFWIDTH HANGUL LETTER NIEUN-CIEUC': 65445,
'HALFWIDTH HANGUL LETTER NIEUN-HIEUH': 65446,
'HALFWIDTH HANGUL LETTER O': 65484,
'HALFWIDTH HANGUL LETTER OE': 65487,
'HALFWIDTH HANGUL LETTER PHIEUPH': 65469,
'HALFWIDTH HANGUL LETTER PIEUP': 65458,
'HALFWIDTH HANGUL LETTER PIEUP-SIOS': 65460,
'HALFWIDTH HANGUL LETTER RIEUL': 65449,
'HALFWIDTH HANGUL LETTER RIEUL-HIEUH': 65456,
'HALFWIDTH HANGUL LETTER RIEUL-KIYEOK': 65450,
'HALFWIDTH HANGUL LETTER RIEUL-MIEUM': 65451,
'HALFWIDTH HANGUL LETTER RIEUL-PHIEUPH': 65455,
'HALFWIDTH HANGUL LETTER RIEUL-PIEUP': 65452,
'HALFWIDTH HANGUL LETTER RIEUL-SIOS': 65453,
'HALFWIDTH HANGUL LETTER RIEUL-THIEUTH': 65454,
'HALFWIDTH HANGUL LETTER SIOS': 65461,
'HALFWIDTH HANGUL LETTER SSANGCIEUC': 65465,
'HALFWIDTH HANGUL LETTER SSANGKIYEOK': 65442,
'HALFWIDTH HANGUL LETTER SSANGPIEUP': 65459,
'HALFWIDTH HANGUL LETTER SSANGSIOS': 65462,
'HALFWIDTH HANGUL LETTER SSANGTIKEUT': 65448,
'HALFWIDTH HANGUL LETTER THIEUTH': 65468,
'HALFWIDTH HANGUL LETTER TIKEUT': 65447,
'HALFWIDTH HANGUL LETTER U': 65491,
'HALFWIDTH HANGUL LETTER WA': 65485,
'HALFWIDTH HANGUL LETTER WAE': 65486,
'HALFWIDTH HANGUL LETTER WE': 65493,
'HALFWIDTH HANGUL LETTER WEO': 65492,
'HALFWIDTH HANGUL LETTER WI': 65494,
'HALFWIDTH HANGUL LETTER YA': 65476,
'HALFWIDTH HANGUL LETTER YAE': 65477,
'HALFWIDTH HANGUL LETTER YE': 65483,
'HALFWIDTH HANGUL LETTER YEO': 65482,
'HALFWIDTH HANGUL LETTER YI': 65499,
'HALFWIDTH HANGUL LETTER YO': 65490,
'HALFWIDTH HANGUL LETTER YU': 65495,
'HALFWIDTH IDEOGRAPHIC COMMA': 65380,
'HALFWIDTH IDEOGRAPHIC FULL STOP': 65377,
'HALFWIDTH KATAKANA LETTER A': 65393,
'HALFWIDTH KATAKANA LETTER E': 65396,
'HALFWIDTH KATAKANA LETTER HA': 65418,
'HALFWIDTH KATAKANA LETTER HE': 65421,
'HALFWIDTH KATAKANA LETTER HI': 65419,
'HALFWIDTH KATAKANA LETTER HO': 65422,
'HALFWIDTH KATAKANA LETTER HU': 65420,
'HALFWIDTH KATAKANA LETTER I': 65394,
'HALFWIDTH KATAKANA LETTER KA': 65398,
'HALFWIDTH KATAKANA LETTER KE': 65401,
'HALFWIDTH KATAKANA LETTER KI': 65399,
'HALFWIDTH KATAKANA LETTER KO': 65402,
'HALFWIDTH KATAKANA LETTER KU': 65400,
'HALFWIDTH KATAKANA LETTER MA': 65423,
'HALFWIDTH KATAKANA LETTER ME': 65426,
'HALFWIDTH KATAKANA LETTER MI': 65424,
'HALFWIDTH KATAKANA LETTER MO': 65427,
'HALFWIDTH KATAKANA LETTER MU': 65425,
'HALFWIDTH KATAKANA LETTER N': 65437,
'HALFWIDTH KATAKANA LETTER NA': 65413,
'HALFWIDTH KATAKANA LETTER NE': 65416,
'HALFWIDTH KATAKANA LETTER NI': 65414,
'HALFWIDTH KATAKANA LETTER NO': 65417,
'HALFWIDTH KATAKANA LETTER NU': 65415,
'HALFWIDTH KATAKANA LETTER O': 65397,
'HALFWIDTH KATAKANA LETTER RA': 65431,
'HALFWIDTH KATAKANA LETTER RE': 65434,
'HALFWIDTH KATAKANA LETTER RI': 65432,
'HALFWIDTH KATAKANA LETTER RO': 65435,
'HALFWIDTH KATAKANA LETTER RU': 65433,
'HALFWIDTH KATAKANA LETTER SA': 65403,
'HALFWIDTH KATAKANA LETTER SE': 65406,
'HALFWIDTH KATAKANA LETTER SI': 65404,
'HALFWIDTH KATAKANA LETTER SMALL A': 65383,
'HALFWIDTH KATAKANA LETTER SMALL E': 65386,
'HALFWIDTH KATAKANA LETTER SMALL I': 65384,
'HALFWIDTH KATAKANA LETTER SMALL O': 65387,
'HALFWIDTH KATAKANA LETTER SMALL TU': 65391,
'HALFWIDTH KATAKANA LETTER SMALL U': 65385,
'HALFWIDTH KATAKANA LETTER SMALL YA': 65388,
'HALFWIDTH KATAKANA LETTER SMALL YO': 65390,
'HALFWIDTH KATAKANA LETTER SMALL YU': 65389,
'HALFWIDTH KATAKANA LETTER SO': 65407,
'HALFWIDTH KATAKANA LETTER SU': 65405,
'HALFWIDTH KATAKANA LETTER TA': 65408,
'HALFWIDTH KATAKANA LETTER TE': 65411,
'HALFWIDTH KATAKANA LETTER TI': 65409,
'HALFWIDTH KATAKANA LETTER TO': 65412,
'HALFWIDTH KATAKANA LETTER TU': 65410,
'HALFWIDTH KATAKANA LETTER U': 65395,
'HALFWIDTH KATAKANA LETTER WA': 65436,
'HALFWIDTH KATAKANA LETTER WO': 65382,
'HALFWIDTH KATAKANA LETTER YA': 65428,
'HALFWIDTH KATAKANA LETTER YO': 65430,
'HALFWIDTH KATAKANA LETTER YU': 65429,
'HALFWIDTH KATAKANA MIDDLE DOT': 65381,
'HALFWIDTH KATAKANA SEMI-VOICED SOUND MARK': 65439,
'HALFWIDTH KATAKANA VOICED SOUND MARK': 65438,
'HALFWIDTH KATAKANA-HIRAGANA PROLONGED SOUND MARK': 65392,
'HALFWIDTH LEFT CORNER BRACKET': 65378,
'HALFWIDTH LEFTWARDS ARROW': 65513,
'HALFWIDTH RIGHT CORNER BRACKET': 65379,
'HALFWIDTH RIGHTWARDS ARROW': 65515,
'HALFWIDTH UPWARDS ARROW': 65514,
'HALFWIDTH WHITE CIRCLE': 65518,
'HAMMER AND PICK': 9874,
'HAMMER AND SICKLE': 9773,
'HANGUL CHOSEONG CEONGCHIEUMCHIEUCH': 4437,
'HANGUL CHOSEONG CEONGCHIEUMCIEUC': 4432,
'HANGUL CHOSEONG CEONGCHIEUMSIOS': 4414,
'HANGUL CHOSEONG CEONGCHIEUMSSANGCIEUC': 4433,
'HANGUL CHOSEONG CEONGCHIEUMSSANGSIOS': 4415,
'HANGUL CHOSEONG CHIEUCH': 4366,
'HANGUL CHOSEONG CHIEUCH-HIEUH': 4435,
'HANGUL CHOSEONG CHIEUCH-KHIEUKH': 4434,
'HANGUL CHOSEONG CHITUEUMCHIEUCH': 4436,
'HANGUL CHOSEONG CHITUEUMCIEUC': 4430,
'HANGUL CHOSEONG CHITUEUMSIOS': 4412,
'HANGUL CHOSEONG CHITUEUMSSANGCIEUC': 4431,
'HANGUL CHOSEONG CHITUEUMSSANGSIOS': 4413,
'HANGUL CHOSEONG CIEUC': 4364,
'HANGUL CHOSEONG CIEUC-IEUNG': 4429,
'HANGUL CHOSEONG FILLER': 4447,
'HANGUL CHOSEONG HIEUH': 4370,
'HANGUL CHOSEONG HIEUH-SIOS': 43387,
'HANGUL CHOSEONG IEUNG': 4363,
'HANGUL CHOSEONG IEUNG-CHIEUCH': 4425,
'HANGUL CHOSEONG IEUNG-CIEUC': 4424,
'HANGUL CHOSEONG IEUNG-HIEUH': 43383,
'HANGUL CHOSEONG IEUNG-KIYEOK': 4417,
'HANGUL CHOSEONG IEUNG-MIEUM': 4419,
'HANGUL CHOSEONG IEUNG-PANSIOS': 4422,
'HANGUL CHOSEONG IEUNG-PHIEUPH': 4427,
'HANGUL CHOSEONG IEUNG-PIEUP': 4420,
'HANGUL CHOSEONG IEUNG-RIEUL': 43382,
'HANGUL CHOSEONG IEUNG-SIOS': 4421,
'HANGUL CHOSEONG IEUNG-THIEUTH': 4426,
'HANGUL CHOSEONG IEUNG-TIKEUT': 4418,
'HANGUL CHOSEONG KAPYEOUNMIEUM': 4381,
'HANGUL CHOSEONG KAPYEOUNPHIEUPH': 4439,
'HANGUL CHOSEONG KAPYEOUNPIEUP': 4395,
'HANGUL CHOSEONG KAPYEOUNRIEUL': 4379,
'HANGUL CHOSEONG KAPYEOUNSSANGPIEUP': 4396,
'HANGUL CHOSEONG KHIEUKH': 4367,
'HANGUL CHOSEONG KIYEOK': 4352,
'HANGUL CHOSEONG KIYEOK-TIKEUT': 4442,
'HANGUL CHOSEONG MIEUM': 4358,
'HANGUL CHOSEONG MIEUM-KIYEOK': 43375,
'HANGUL CHOSEONG MIEUM-PIEUP': 4380,
'HANGUL CHOSEONG MIEUM-SIOS': 43377,
'HANGUL CHOSEONG MIEUM-TIKEUT': 43376,
'HANGUL CHOSEONG NIEUN': 4354,
'HANGUL CHOSEONG NIEUN-CIEUC': 4444,
'HANGUL CHOSEONG NIEUN-HIEUH': 4445,
'HANGUL CHOSEONG NIEUN-KIYEOK': 4371,
'HANGUL CHOSEONG NIEUN-PIEUP': 4374,
'HANGUL CHOSEONG NIEUN-SIOS': 4443,
'HANGUL CHOSEONG NIEUN-TIKEUT': 4373,
'HANGUL CHOSEONG PANSIOS': 4416,
'HANGUL CHOSEONG PHIEUPH': 4369,
'HANGUL CHOSEONG PHIEUPH-HIEUH': 43386,
'HANGUL CHOSEONG PHIEUPH-PIEUP': 4438,
'HANGUL CHOSEONG PIEUP': 4359,
'HANGUL CHOSEONG PIEUP-CHIEUCH': 4392,
'HANGUL CHOSEONG PIEUP-CIEUC': 4391,
'HANGUL CHOSEONG PIEUP-HIEUH': 43380,
'HANGUL CHOSEONG PIEUP-KHIEUKH': 43379,
'HANGUL CHOSEONG PIEUP-KIYEOK': 4382,
'HANGUL CHOSEONG PIEUP-NIEUN': 4383,
'HANGUL CHOSEONG PIEUP-PHIEUPH': 4394,
'HANGUL CHOSEONG PIEUP-SIOS': 4385,
'HANGUL CHOSEONG PIEUP-SIOS-CIEUC': 4390,
'HANGUL CHOSEONG PIEUP-SIOS-KIYEOK': 4386,
'HANGUL CHOSEONG PIEUP-SIOS-PIEUP': 4388,
'HANGUL CHOSEONG PIEUP-SIOS-THIEUTH': 43378,
'HANGUL CHOSEONG PIEUP-SIOS-TIKEUT': 4387,
'HANGUL CHOSEONG PIEUP-SSANGSIOS': 4389,
'HANGUL CHOSEONG PIEUP-THIEUTH': 4393,
'HANGUL CHOSEONG PIEUP-TIKEUT': 4384,
'HANGUL CHOSEONG RIEUL': 4357,
'HANGUL CHOSEONG RIEUL-CIEUC': 43373,
'HANGUL CHOSEONG RIEUL-HIEUH': 4378,
'HANGUL CHOSEONG RIEUL-KAPYEOUNPIEUP': 43371,
'HANGUL CHOSEONG RIEUL-KHIEUKH': 43374,
'HANGUL CHOSEONG RIEUL-KIYEOK': 43364,
'HANGUL CHOSEONG RIEUL-MIEUM': 43368,
'HANGUL CHOSEONG RIEUL-NIEUN': 4376,
'HANGUL CHOSEONG RIEUL-PIEUP': 43369,
'HANGUL CHOSEONG RIEUL-SIOS': 43372,
'HANGUL CHOSEONG RIEUL-SSANGKIYEOK': 43365,
'HANGUL CHOSEONG RIEUL-SSANGPIEUP': 43370,
'HANGUL CHOSEONG RIEUL-SSANGTIKEUT': 43367,
'HANGUL CHOSEONG RIEUL-TIKEUT': 43366,
'HANGUL CHOSEONG SIOS': 4361,
'HANGUL CHOSEONG SIOS-CHIEUCH': 4407,
'HANGUL CHOSEONG SIOS-CIEUC': 4406,
'HANGUL CHOSEONG SIOS-HIEUH': 4411,
'HANGUL CHOSEONG SIOS-IEUNG': 4405,
'HANGUL CHOSEONG SIOS-KHIEUKH': 4408,
'HANGUL CHOSEONG SIOS-KIYEOK': 4397,
'HANGUL CHOSEONG SIOS-MIEUM': 4401,
'HANGUL CHOSEONG SIOS-NIEUN': 4398,
'HANGUL CHOSEONG SIOS-PHIEUPH': 4410,
'HANGUL CHOSEONG SIOS-PIEUP': 4402,
'HANGUL CHOSEONG SIOS-PIEUP-KIYEOK': 4403,
'HANGUL CHOSEONG SIOS-RIEUL': 4400,
'HANGUL CHOSEONG SIOS-SSANGSIOS': 4404,
'HANGUL CHOSEONG SIOS-THIEUTH': 4409,
'HANGUL CHOSEONG SIOS-TIKEUT': 4399,
'HANGUL CHOSEONG SSANGCIEUC': 4365,
'HANGUL CHOSEONG SSANGCIEUC-HIEUH': 43384,
'HANGUL CHOSEONG SSANGHIEUH': 4440,
'HANGUL CHOSEONG SSANGIEUNG': 4423,
'HANGUL CHOSEONG SSANGKIYEOK': 4353,
'HANGUL CHOSEONG SSANGNIEUN': 4372,
'HANGUL CHOSEONG SSANGPIEUP': 4360,
'HANGUL CHOSEONG SSANGRIEUL': 4377,
'HANGUL CHOSEONG SSANGSIOS': 4362,
'HANGUL CHOSEONG SSANGSIOS-PIEUP': 43381,
'HANGUL CHOSEONG SSANGTHIEUTH': 43385,
'HANGUL CHOSEONG SSANGTIKEUT': 4356,
'HANGUL CHOSEONG SSANGYEORINHIEUH': 43388,
'HANGUL CHOSEONG THIEUTH': 4368,
'HANGUL CHOSEONG TIKEUT': 4355,
'HANGUL CHOSEONG TIKEUT-CIEUC': 43363,
'HANGUL CHOSEONG TIKEUT-KIYEOK': 4375,
'HANGUL CHOSEONG TIKEUT-MIEUM': 43360,
'HANGUL CHOSEONG TIKEUT-PIEUP': 43361,
'HANGUL CHOSEONG TIKEUT-RIEUL': 4446,
'HANGUL CHOSEONG TIKEUT-SIOS': 43362,
'HANGUL CHOSEONG YEORINHIEUH': 4441,
'HANGUL CHOSEONG YESIEUNG': 4428,
'HANGUL DOUBLE DOT TONE MARK': 12335,
'HANGUL FILLER': 12644,
'HANGUL JONGSEONG CHIEUCH': 4542,
'HANGUL JONGSEONG CIEUC': 4541,
'HANGUL JONGSEONG CIEUC-PIEUP': 55287,
'HANGUL JONGSEONG CIEUC-SSANGPIEUP': 55288,
'HANGUL JONGSEONG HIEUH': 4546,
'HANGUL JONGSEONG HIEUH-MIEUM': 4599,
'HANGUL JONGSEONG HIEUH-NIEUN': 4597,
'HANGUL JONGSEONG HIEUH-PIEUP': 4600,
'HANGUL JONGSEONG HIEUH-RIEUL': 4598,
'HANGUL JONGSEONG IEUNG': 4540,
'HANGUL JONGSEONG IEUNG-KHIEUKH': 4591,
'HANGUL JONGSEONG IEUNG-KIYEOK': 4588,
'HANGUL JONGSEONG IEUNG-SSANGKIYEOK': 4589,
'HANGUL JONGSEONG KAPYEOUNMIEUM': 4578,
'HANGUL JONGSEONG KAPYEOUNPHIEUPH': 4596,
'HANGUL JONGSEONG KAPYEOUNPIEUP': 4582,
'HANGUL JONGSEONG KAPYEOUNRIEUL': 55261,
'HANGUL JONGSEONG KHIEUKH': 4543,
'HANGUL JONGSEONG KIYEOK': 4520,
'HANGUL JONGSEONG KIYEOK-CHIEUCH': 4604,
'HANGUL JONGSEONG KIYEOK-HIEUH': 4606,
'HANGUL JONGSEONG KIYEOK-KHIEUKH': 4605,
'HANGUL JONGSEONG KIYEOK-NIEUN': 4602,
'HANGUL JONGSEONG KIYEOK-PIEUP': 4603,
'HANGUL JONGSEONG KIYEOK-RIEUL': 4547,
'HANGUL JONGSEONG KIYEOK-SIOS': 4522,
'HANGUL JONGSEONG KIYEOK-SIOS-KIYEOK': 4548,
'HANGUL JONGSEONG MIEUM': 4535,
'HANGUL JONGSEONG MIEUM-CHIEUCH': 4576,
'HANGUL JONGSEONG MIEUM-CIEUC': 55266,
'HANGUL JONGSEONG MIEUM-HIEUH': 4577,
'HANGUL JONGSEONG MIEUM-KIYEOK': 4570,
'HANGUL JONGSEONG MIEUM-NIEUN': 55262,
'HANGUL JONGSEONG MIEUM-PANSIOS': 4575,
'HANGUL JONGSEONG MIEUM-PIEUP': 4572,
'HANGUL JONGSEONG MIEUM-PIEUP-SIOS': 55265,
'HANGUL JONGSEONG MIEUM-RIEUL': 4571,
'HANGUL JONGSEONG MIEUM-SIOS': 4573,
'HANGUL JONGSEONG MIEUM-SSANGNIEUN': 55263,
'HANGUL JONGSEONG MIEUM-SSANGSIOS': 4574,
'HANGUL JONGSEONG NIEUN': 4523,
'HANGUL JONGSEONG NIEUN-CHIEUCH': 55244,
'HANGUL JONGSEONG NIEUN-CIEUC': 4524,
'HANGUL JONGSEONG NIEUN-HIEUH': 4525,
'HANGUL JONGSEONG NIEUN-KIYEOK': 4549,
'HANGUL JONGSEONG NIEUN-PANSIOS': 4552,
'HANGUL JONGSEONG NIEUN-RIEUL': 55243,
'HANGUL JONGSEONG NIEUN-SIOS': 4551,
'HANGUL JONGSEONG NIEUN-THIEUTH': 4553,
'HANGUL JONGSEONG NIEUN-TIKEUT': 4550,
'HANGUL JONGSEONG PANSIOS': 4587,
'HANGUL JONGSEONG PANSIOS-KAPYEOUNPIEUP': 55284,
'HANGUL JONGSEONG PANSIOS-PIEUP': 55283,
'HANGUL JONGSEONG PHIEUPH': 4545,
'HANGUL JONGSEONG PHIEUPH-PIEUP': 4595,
'HANGUL JONGSEONG PHIEUPH-SIOS': 55290,
'HANGUL JONGSEONG PHIEUPH-THIEUTH': 55291,
'HANGUL JONGSEONG PIEUP': 4536,
'HANGUL JONGSEONG PIEUP-CHIEUCH': 55273,
'HANGUL JONGSEONG PIEUP-CIEUC': 55272,
'HANGUL JONGSEONG PIEUP-HIEUH': 4581,
'HANGUL JONGSEONG PIEUP-MIEUM': 55269,
'HANGUL JONGSEONG PIEUP-PHIEUPH': 4580,
'HANGUL JONGSEONG PIEUP-RIEUL': 4579,
'HANGUL JONGSEONG PIEUP-RIEUL-PHIEUPH': 55268,
'HANGUL JONGSEONG PIEUP-SIOS': 4537,
'HANGUL JONGSEONG PIEUP-SIOS-TIKEUT': 55271,
'HANGUL JONGSEONG PIEUP-TIKEUT': 55267,
'HANGUL JONGSEONG RIEUL': 4527,
'HANGUL JONGSEONG RIEUL-HIEUH': 4534,
'HANGUL JONGSEONG RIEUL-KAPYEOUNPIEUP': 4565,
'HANGUL JONGSEONG RIEUL-KHIEUKH': 4568,
'HANGUL JONGSEONG RIEUL-KIYEOK': 4528,
'HANGUL JONGSEONG RIEUL-KIYEOK-HIEUH': 55254,
'HANGUL JONGSEONG RIEUL-KIYEOK-SIOS': 4556,
'HANGUL JONGSEONG RIEUL-MIEUM': 4529,
'HANGUL JONGSEONG RIEUL-MIEUM-HIEUH': 55256,
'HANGUL JONGSEONG RIEUL-MIEUM-KIYEOK': 4561,
'HANGUL JONGSEONG RIEUL-MIEUM-SIOS': 4562,
'HANGUL JONGSEONG RIEUL-NIEUN': 4557,
'HANGUL JONGSEONG RIEUL-PANSIOS': 4567,
'HANGUL JONGSEONG RIEUL-PHIEUPH': 4533,
'HANGUL JONGSEONG RIEUL-PIEUP': 4530,
'HANGUL JONGSEONG RIEUL-PIEUP-HIEUH': 4564,
'HANGUL JONGSEONG RIEUL-PIEUP-PHIEUPH': 55258,
'HANGUL JONGSEONG RIEUL-PIEUP-SIOS': 4563,
'HANGUL JONGSEONG RIEUL-PIEUP-TIKEUT': 55257,
'HANGUL JONGSEONG RIEUL-SIOS': 4531,
'HANGUL JONGSEONG RIEUL-SSANGKIYEOK': 55253,
'HANGUL JONGSEONG RIEUL-SSANGSIOS': 4566,
'HANGUL JONGSEONG RIEUL-THIEUTH': 4532,
'HANGUL JONGSEONG RIEUL-TIKEUT': 4558,
'HANGUL JONGSEONG RIEUL-TIKEUT-HIEUH': 4559,
'HANGUL JONGSEONG RIEUL-YEORINHIEUH': 4569,
'HANGUL JONGSEONG RIEUL-YEORINHIEUH-HIEUH': 55260,
'HANGUL JONGSEONG RIEUL-YESIEUNG': 55259,
'HANGUL JONGSEONG SIOS': 4538,
'HANGUL JONGSEONG SIOS-CHIEUCH': 55280,
'HANGUL JONGSEONG SIOS-CIEUC': 55279,
'HANGUL JONGSEONG SIOS-HIEUH': 55282,
'HANGUL JONGSEONG SIOS-KAPYEOUNPIEUP': 55275,
'HANGUL JONGSEONG SIOS-KIYEOK': 4583,
'HANGUL JONGSEONG SIOS-MIEUM': 55274,
'HANGUL JONGSEONG SIOS-PANSIOS': 55278,
'HANGUL JONGSEONG SIOS-PIEUP': 4586,
'HANGUL JONGSEONG SIOS-RIEUL': 4585,
'HANGUL JONGSEONG SIOS-THIEUTH': 55281,
'HANGUL JONGSEONG SIOS-TIKEUT': 4584,
'HANGUL JONGSEONG SSANGCIEUC': 55289,
'HANGUL JONGSEONG SSANGIEUNG': 4590,
'HANGUL JONGSEONG SSANGKIYEOK': 4521,
'HANGUL JONGSEONG SSANGMIEUM': 55264,
'HANGUL JONGSEONG SSANGNIEUN': 4607,
'HANGUL JONGSEONG SSANGPIEUP': 55270,
'HANGUL JONGSEONG SSANGRIEUL': 4560,
'HANGUL JONGSEONG SSANGRIEUL-KHIEUKH': 55255,
'HANGUL JONGSEONG SSANGSIOS': 4539,
'HANGUL JONGSEONG SSANGSIOS-KIYEOK': 55276,
'HANGUL JONGSEONG SSANGSIOS-TIKEUT': 55277,
'HANGUL JONGSEONG SSANGTIKEUT': 55245,
'HANGUL JONGSEONG SSANGTIKEUT-PIEUP': 55246,
'HANGUL JONGSEONG THIEUTH': 4544,
'HANGUL JONGSEONG TIKEUT': 4526,
'HANGUL JONGSEONG TIKEUT-CHIEUCH': 55251,
'HANGUL JONGSEONG TIKEUT-CIEUC': 55250,
'HANGUL JONGSEONG TIKEUT-KIYEOK': 4554,
'HANGUL JONGSEONG TIKEUT-PIEUP': 55247,
'HANGUL JONGSEONG TIKEUT-RIEUL': 4555,
'HANGUL JONGSEONG TIKEUT-SIOS': 55248,
'HANGUL JONGSEONG TIKEUT-SIOS-KIYEOK': 55249,
'HANGUL JONGSEONG TIKEUT-THIEUTH': 55252,
'HANGUL JONGSEONG YEORINHIEUH': 4601,
'HANGUL JONGSEONG YESIEUNG': 4592,
'HANGUL JONGSEONG YESIEUNG-HIEUH': 55286,
'HANGUL JONGSEONG YESIEUNG-MIEUM': 55285,
'HANGUL JONGSEONG YESIEUNG-PANSIOS': 4594,
'HANGUL JONGSEONG YESIEUNG-SIOS': 4593,
'HANGUL JUNGSEONG A': 4449,
'HANGUL JUNGSEONG A-EU': 4515,
'HANGUL JUNGSEONG A-O': 4470,
'HANGUL JUNGSEONG A-U': 4471,
'HANGUL JUNGSEONG AE': 4450,
'HANGUL JUNGSEONG ARAEA': 4510,
'HANGUL JUNGSEONG ARAEA-A': 55237,
'HANGUL JUNGSEONG ARAEA-E': 55238,
'HANGUL JUNGSEONG ARAEA-EO': 4511,
'HANGUL JUNGSEONG ARAEA-I': 4513,
'HANGUL JUNGSEONG ARAEA-U': 4512,
'HANGUL JUNGSEONG E': 4454,
'HANGUL JUNGSEONG EO': 4453,
'HANGUL JUNGSEONG EO-EU': 4476,
'HANGUL JUNGSEONG EO-O': 4474,
'HANGUL JUNGSEONG EO-U': 4475,
'HANGUL JUNGSEONG EU': 4467,
'HANGUL JUNGSEONG EU-A': 55225,
'HANGUL JUNGSEONG EU-E': 55227,
'HANGUL JUNGSEONG EU-EO': 55226,
'HANGUL JUNGSEONG EU-EU': 4502,
'HANGUL JUNGSEONG EU-O': 55228,
'HANGUL JUNGSEONG EU-U': 4501,
'HANGUL JUNGSEONG FILLER': 4448,
'HANGUL JUNGSEONG I': 4469,
'HANGUL JUNGSEONG I-A': 4504,
'HANGUL JUNGSEONG I-ARAEA': 4509,
'HANGUL JUNGSEONG I-EU': 4508,
'HANGUL JUNGSEONG I-I': 55236,
'HANGUL JUNGSEONG I-O': 4506,
'HANGUL JUNGSEONG I-O-I': 55233,
'HANGUL JUNGSEONG I-U': 4507,
'HANGUL JUNGSEONG I-YA': 4505,
'HANGUL JUNGSEONG I-YA-O': 55229,
'HANGUL JUNGSEONG I-YAE': 55230,
'HANGUL JUNGSEONG I-YE': 55232,
'HANGUL JUNGSEONG I-YEO': 55231,
'HANGUL JUNGSEONG I-YO': 55234,
'HANGUL JUNGSEONG I-YU': 55235,
'HANGUL JUNGSEONG O': 4457,
'HANGUL JUNGSEONG O-E': 4480,
'HANGUL JUNGSEONG O-EO': 4479,
'HANGUL JUNGSEONG O-O': 4482,
'HANGUL JUNGSEONG O-O-I': 55217,
'HANGUL JUNGSEONG O-U': 4483,
'HANGUL JUNGSEONG O-YA': 4518,
'HANGUL JUNGSEONG O-YAE': 4519,
'HANGUL JUNGSEONG O-YE': 4481,
'HANGUL JUNGSEONG O-YEO': 55216,
'HANGUL JUNGSEONG OE': 4460,
'HANGUL JUNGSEONG SSANGARAEA': 4514,
'HANGUL JUNGSEONG U': 4462,
'HANGUL JUNGSEONG U-A': 4489,
'HANGUL JUNGSEONG U-AE': 4490,
'HANGUL JUNGSEONG U-EO-EU': 4491,
'HANGUL JUNGSEONG U-I-I': 55222,
'HANGUL JUNGSEONG U-U': 4493,
'HANGUL JUNGSEONG U-YE': 4492,
'HANGUL JUNGSEONG U-YEO': 55221,
'HANGUL JUNGSEONG WA': 4458,
'HANGUL JUNGSEONG WAE': 4459,
'HANGUL JUNGSEONG WE': 4464,
'HANGUL JUNGSEONG WEO': 4463,
'HANGUL JUNGSEONG WI': 4465,
'HANGUL JUNGSEONG YA': 4451,
'HANGUL JUNGSEONG YA-O': 4472,
'HANGUL JUNGSEONG YA-U': 4516,
'HANGUL JUNGSEONG YA-YO': 4473,
'HANGUL JUNGSEONG YAE': 4452,
'HANGUL JUNGSEONG YE': 4456,
'HANGUL JUNGSEONG YEO': 4455,
'HANGUL JUNGSEONG YEO-O': 4477,
'HANGUL JUNGSEONG YEO-U': 4478,
'HANGUL JUNGSEONG YEO-YA': 4517,
'HANGUL JUNGSEONG YI': 4468,
'HANGUL JUNGSEONG YI-U': 4503,
'HANGUL JUNGSEONG YO': 4461,
'HANGUL JUNGSEONG YO-A': 55218,
'HANGUL JUNGSEONG YO-AE': 55219,
'HANGUL JUNGSEONG YO-EO': 55220,
'HANGUL JUNGSEONG YO-I': 4488,
'HANGUL JUNGSEONG YO-O': 4487,
'HANGUL JUNGSEONG YO-YA': 4484,
'HANGUL JUNGSEONG YO-YAE': 4485,
'HANGUL JUNGSEONG YO-YEO': 4486,
'HANGUL JUNGSEONG YU': 4466,
'HANGUL JUNGSEONG YU-A': 4494,
'HANGUL JUNGSEONG YU-AE': 55223,
'HANGUL JUNGSEONG YU-E': 4496,
'HANGUL JUNGSEONG YU-EO': 4495,
'HANGUL JUNGSEONG YU-I': 4500,
'HANGUL JUNGSEONG YU-O': 55224,
'HANGUL JUNGSEONG YU-U': 4499,
'HANGUL JUNGSEONG YU-YE': 4498,
'HANGUL JUNGSEONG YU-YEO': 4497,
'HANGUL LETTER A': 12623,
'HANGUL LETTER AE': 12624,
'HANGUL LETTER ARAEA': 12685,
'HANGUL LETTER ARAEAE': 12686,
'HANGUL LETTER CHIEUCH': 12618,
'HANGUL LETTER CIEUC': 12616,
'HANGUL LETTER E': 12628,
'HANGUL LETTER EO': 12627,
'HANGUL LETTER EU': 12641,
'HANGUL LETTER HIEUH': 12622,
'HANGUL LETTER I': 12643,
'HANGUL LETTER IEUNG': 12615,
'HANGUL LETTER KAPYEOUNMIEUM': 12657,
'HANGUL LETTER KAPYEOUNPHIEUPH': 12676,
'HANGUL LETTER KAPYEOUNPIEUP': 12664,
'HANGUL LETTER KAPYEOUNSSANGPIEUP': 12665,
'HANGUL LETTER KHIEUKH': 12619,
'HANGUL LETTER KIYEOK': 12593,
'HANGUL LETTER KIYEOK-SIOS': 12595,
'HANGUL LETTER MIEUM': 12609,
'HANGUL LETTER MIEUM-PANSIOS': 12656,
'HANGUL LETTER MIEUM-PIEUP': 12654,
'HANGUL LETTER MIEUM-SIOS': 12655,
'HANGUL LETTER NIEUN': 12596,
'HANGUL LETTER NIEUN-CIEUC': 12597,
'HANGUL LETTER NIEUN-HIEUH': 12598,
'HANGUL LETTER NIEUN-PANSIOS': 12648,
'HANGUL LETTER NIEUN-SIOS': 12647,
'HANGUL LETTER NIEUN-TIKEUT': 12646,
'HANGUL LETTER O': 12631,
'HANGUL LETTER OE': 12634,
'HANGUL LETTER PANSIOS': 12671,
'HANGUL LETTER PHIEUPH': 12621,
'HANGUL LETTER PIEUP': 12610,
'HANGUL LETTER PIEUP-CIEUC': 12662,
'HANGUL LETTER PIEUP-KIYEOK': 12658,
'HANGUL LETTER PIEUP-SIOS': 12612,
'HANGUL LETTER PIEUP-SIOS-KIYEOK': 12660,
'HANGUL LETTER PIEUP-SIOS-TIKEUT': 12661,
'HANGUL LETTER PIEUP-THIEUTH': 12663,
'HANGUL LETTER PIEUP-TIKEUT': 12659,
'HANGUL LETTER RIEUL': 12601,
'HANGUL LETTER RIEUL-HIEUH': 12608,
'HANGUL LETTER RIEUL-KIYEOK': 12602,
'HANGUL LETTER RIEUL-KIYEOK-SIOS': 12649,
'HANGUL LETTER RIEUL-MIEUM': 12603,
'HANGUL LETTER RIEUL-PANSIOS': 12652,
'HANGUL LETTER RIEUL-PHIEUPH': 12607,
'HANGUL LETTER RIEUL-PIEUP': 12604,
'HANGUL LETTER RIEUL-PIEUP-SIOS': 12651,
'HANGUL LETTER RIEUL-SIOS': 12605,
'HANGUL LETTER RIEUL-THIEUTH': 12606,
'HANGUL LETTER RIEUL-TIKEUT': 12650,
'HANGUL LETTER RIEUL-YEORINHIEUH': 12653,
'HANGUL LETTER SIOS': 12613,
'HANGUL LETTER SIOS-CIEUC': 12670,
'HANGUL LETTER SIOS-KIYEOK': 12666,
'HANGUL LETTER SIOS-NIEUN': 12667,
'HANGUL LETTER SIOS-PIEUP': 12669,
'HANGUL LETTER SIOS-TIKEUT': 12668,
'HANGUL LETTER SSANGCIEUC': 12617,
'HANGUL LETTER SSANGHIEUH': 12677,
'HANGUL LETTER SSANGIEUNG': 12672,
'HANGUL LETTER SSANGKIYEOK': 12594,
'HANGUL LETTER SSANGNIEUN': 12645,
'HANGUL LETTER SSANGPIEUP': 12611,
'HANGUL LETTER SSANGSIOS': 12614,
'HANGUL LETTER SSANGTIKEUT': 12600,
'HANGUL LETTER THIEUTH': 12620,
'HANGUL LETTER TIKEUT': 12599,
'HANGUL LETTER U': 12636,
'HANGUL LETTER WA': 12632,
'HANGUL LETTER WAE': 12633,
'HANGUL LETTER WE': 12638,
'HANGUL LETTER WEO': 12637,
'HANGUL LETTER WI': 12639,
'HANGUL LETTER YA': 12625,
'HANGUL LETTER YAE': 12626,
'HANGUL LETTER YE': 12630,
'HANGUL LETTER YEO': 12629,
'HANGUL LETTER YEORINHIEUH': 12678,
'HANGUL LETTER YESIEUNG': 12673,
'HANGUL LETTER YESIEUNG-PANSIOS': 12675,
'HANGUL LETTER YESIEUNG-SIOS': 12674,
'HANGUL LETTER YI': 12642,
'HANGUL LETTER YO': 12635,
'HANGUL LETTER YO-I': 12681,
'HANGUL LETTER YO-YA': 12679,
'HANGUL LETTER YO-YAE': 12680,
'HANGUL LETTER YU': 12640,
'HANGUL LETTER YU-I': 12684,
'HANGUL LETTER YU-YE': 12683,
'HANGUL LETTER YU-YEO': 12682,
'HANGUL SINGLE DOT TONE MARK': 12334,
'HANGZHOU NUMERAL EIGHT': 12328,
'HANGZHOU NUMERAL FIVE': 12325,
'HANGZHOU NUMERAL FOUR': 12324,
'HANGZHOU NUMERAL NINE': 12329,
'HANGZHOU NUMERAL ONE': 12321,
'HANGZHOU NUMERAL SEVEN': 12327,
'HANGZHOU NUMERAL SIX': 12326,
'HANGZHOU NUMERAL TEN': 12344,
'HANGZHOU NUMERAL THIRTY': 12346,
'HANGZHOU NUMERAL THREE': 12323,
'HANGZHOU NUMERAL TWENTY': 12345,
'HANGZHOU NUMERAL TWO': 12322,
'HANUNOO LETTER A': 5920,
'HANUNOO LETTER BA': 5930,
'HANUNOO LETTER DA': 5927,
'HANUNOO LETTER GA': 5924,
'HANUNOO LETTER HA': 5937,
'HANUNOO LETTER I': 5921,
'HANUNOO LETTER KA': 5923,
'HANUNOO LETTER LA': 5934,
'HANUNOO LETTER MA': 5931,
'HANUNOO LETTER NA': 5928,
'HANUNOO LETTER NGA': 5925,
'HANUNOO LETTER PA': 5929,
'HANUNOO LETTER RA': 5933,
'HANUNOO LETTER SA': 5936,
'HANUNOO LETTER TA': 5926,
'HANUNOO LETTER U': 5922,
'HANUNOO LETTER WA': 5935,
'HANUNOO LETTER YA': 5932,
'HANUNOO SIGN PAMUDPOD': 5940,
'HANUNOO VOWEL SIGN I': 5938,
'HANUNOO VOWEL SIGN U': 5939,
'HEADSTONE GRAVEYARD SYMBOL': 9980,
'HEAVY ASTERISK': 10033,
'HEAVY BALLOT X': 10008,
'HEAVY BLACK CURVED DOWNWARDS AND RIGHTWARDS ARROW': 10149,
'HEAVY BLACK CURVED UPWARDS AND RIGHTWARDS ARROW': 10150,
'HEAVY BLACK HEART': 10084,
'HEAVY BLACK-FEATHERED NORTH EAST ARROW': 10169,
'HEAVY BLACK-FEATHERED RIGHTWARDS ARROW': 10168,
'HEAVY BLACK-FEATHERED SOUTH EAST ARROW': 10167,
'HEAVY CHECK MARK': 10004,
'HEAVY CHEVRON SNOWFLAKE': 10054,
'HEAVY CIRCLE': 11096,
'HEAVY CIRCLE WITH CIRCLE INSIDE': 11095,
'HEAVY CIRCLE WITH STROKE AND TWO DOTS ABOVE': 9955,
'HEAVY CIRCLED SALTIRE': 11097,
'HEAVY CONCAVE-POINTED BLACK RIGHTWARDS ARROW': 10152,
'HEAVY DASHED TRIANGLE-HEADED RIGHTWARDS ARROW': 10144,
'HEAVY DOUBLE COMMA QUOTATION MARK ORNAMENT': 10078,
'HEAVY DOUBLE TURNED COMMA QUOTATION MARK ORNAMENT': 10077,
'HEAVY EIGHT POINTED RECTILINEAR BLACK STAR': 10040,
'HEAVY EIGHT TEARDROP-SPOKED PROPELLER ASTERISK': 10059,
'HEAVY EXCLAMATION MARK ORNAMENT': 10082,
'HEAVY EXCLAMATION MARK SYMBOL': 10071,
'HEAVY FOUR BALLOON-SPOKED ASTERISK': 10020,
'HEAVY GREEK CROSS': 10010,
'HEAVY HEART EXCLAMATION MARK ORNAMENT': 10083,
'HEAVY LARGE CIRCLE': 11093,
'HEAVY LEFT-POINTING ANGLE BRACKET ORNAMENT': 10096,
'HEAVY LEFT-POINTING ANGLE QUOTATION MARK ORNAMENT': 10094,
'HEAVY LOWER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW': 10157,
'HEAVY MULTIPLICATION X': 10006,
'HEAVY NORTH EAST ARROW': 10138,
'HEAVY OPEN CENTRE CROSS': 10012,
'HEAVY OUTLINED BLACK STAR': 10030,
'HEAVY OVAL WITH OVAL INSIDE': 11094,
'HEAVY RIGHT-POINTING ANGLE BRACKET ORNAMENT': 10097,
'HEAVY RIGHT-POINTING ANGLE QUOTATION MARK ORNAMENT': 10095,
'HEAVY RIGHTWARDS ARROW': 10137,
'HEAVY ROUND-TIPPED RIGHTWARDS ARROW': 10140,
'HEAVY SINGLE COMMA QUOTATION MARK ORNAMENT': 10076,
'HEAVY SINGLE TURNED COMMA QUOTATION MARK ORNAMENT': 10075,
'HEAVY SOUTH EAST ARROW': 10136,
'HEAVY SPARKLE': 10056,
'HEAVY TEARDROP-SHANKED RIGHTWARDS ARROW': 10171,
'HEAVY TEARDROP-SPOKED ASTERISK': 10045,
'HEAVY TEARDROP-SPOKED PINWHEEL ASTERISK': 10051,
'HEAVY TRIANGLE-HEADED RIGHTWARDS ARROW': 10142,
'HEAVY UPPER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW': 10158,
'HEAVY VERTICAL BAR': 10074,
'HEAVY WEDGE-TAILED RIGHTWARDS ARROW': 10173,
'HEAVY WHITE DOWN-POINTING TRIANGLE': 9947,
'HEAVY WIDE-HEADED RIGHTWARDS ARROW': 10132,
'HEBREW ACCENT ATNAH HAFUKH': 1442,
'HEBREW ACCENT DARGA': 1447,
'HEBREW ACCENT DEHI': 1453,
'HEBREW ACCENT ETNAHTA': 1425,
'HEBREW ACCENT GERESH': 1436,
'HEBREW ACCENT GERESH MUQDAM': 1437,
'HEBREW ACCENT GERSHAYIM': 1438,
'HEBREW ACCENT ILUY': 1452,
'HEBREW ACCENT MAHAPAKH': 1444,
'HEBREW ACCENT MERKHA': 1445,
'HEBREW ACCENT MERKHA KEFULA': 1446,
'HEBREW ACCENT MUNAH': 1443,
'HEBREW ACCENT OLE': 1451,
'HEBREW ACCENT PASHTA': 1433,
'HEBREW ACCENT PAZER': 1441,
'HEBREW ACCENT QADMA': 1448,
'HEBREW ACCENT QARNEY PARA': 1439,
'HEBREW ACCENT REVIA': 1431,
'HEBREW ACCENT SEGOL': 1426,
'HEBREW ACCENT SHALSHELET': 1427,
'HEBREW ACCENT TELISHA GEDOLA': 1440,
'HEBREW ACCENT TELISHA QETANA': 1449,
'HEBREW ACCENT TEVIR': 1435,
'HEBREW ACCENT TIPEHA': 1430,
'HEBREW ACCENT YERAH BEN YOMO': 1450,
'HEBREW ACCENT YETIV': 1434,
'HEBREW ACCENT ZAQEF GADOL': 1429,
'HEBREW ACCENT ZAQEF QATAN': 1428,
'HEBREW ACCENT ZARQA': 1432,
'HEBREW ACCENT ZINOR': 1454,
'HEBREW LETTER ALEF': 1488,
'HEBREW LETTER ALEF WITH MAPIQ': 64304,
'HEBREW LETTER ALEF WITH PATAH': 64302,
'HEBREW LETTER ALEF WITH QAMATS': 64303,
'HEBREW LETTER ALTERNATIVE AYIN': 64288,
'HEBREW LETTER ALTERNATIVE PLUS SIGN': 64297,
'HEBREW LETTER AYIN': 1506,
'HEBREW LETTER BET': 1489,
'HEBREW LETTER BET WITH DAGESH': 64305,
'HEBREW LETTER BET WITH RAFE': 64332,
'HEBREW LETTER DALET': 1491,
'HEBREW LETTER DALET WITH DAGESH': 64307,
'HEBREW LETTER FINAL KAF': 1498,
'HEBREW LETTER FINAL KAF WITH DAGESH': 64314,
'HEBREW LETTER FINAL MEM': 1501,
'HEBREW LETTER FINAL NUN': 1503,
'HEBREW LETTER FINAL PE': 1507,
'HEBREW LETTER FINAL PE WITH DAGESH': 64323,
'HEBREW LETTER FINAL TSADI': 1509,
'HEBREW LETTER GIMEL': 1490,
'HEBREW LETTER GIMEL WITH DAGESH': 64306,
'HEBREW LETTER HE': 1492,
'HEBREW LETTER HE WITH MAPIQ': 64308,
'HEBREW LETTER HET': 1495,
'HEBREW LETTER KAF': 1499,
'HEBREW LETTER KAF WITH DAGESH': 64315,
'HEBREW LETTER KAF WITH RAFE': 64333,
'HEBREW LETTER LAMED': 1500,
'HEBREW LETTER LAMED WITH DAGESH': 64316,
'HEBREW LETTER MEM': 1502,
'HEBREW LETTER MEM WITH DAGESH': 64318,
'HEBREW LETTER NUN': 1504,
'HEBREW LETTER NUN WITH DAGESH': 64320,
'HEBREW LETTER PE': 1508,
'HEBREW LETTER PE WITH DAGESH': 64324,
'HEBREW LETTER PE WITH RAFE': 64334,
'HEBREW LETTER QOF': 1511,
'HEBREW LETTER QOF WITH DAGESH': 64327,
'HEBREW LETTER RESH': 1512,
'HEBREW LETTER RESH WITH DAGESH': 64328,
'HEBREW LETTER SAMEKH': 1505,
'HEBREW LETTER SAMEKH WITH DAGESH': 64321,
'HEBREW LETTER SHIN': 1513,
'HEBREW LETTER SHIN WITH DAGESH': 64329,
'HEBREW LETTER SHIN WITH DAGESH AND SHIN DOT': 64300,
'HEBREW LETTER SHIN WITH DAGESH AND SIN DOT': 64301,
'HEBREW LETTER SHIN WITH SHIN DOT': 64298,
'HEBREW LETTER SHIN WITH SIN DOT': 64299,
'HEBREW LETTER TAV': 1514,
'HEBREW LETTER TAV WITH DAGESH': 64330,
'HEBREW LETTER TET': 1496,
'HEBREW LETTER TET WITH DAGESH': 64312,
'HEBREW LETTER TSADI': 1510,
'HEBREW LETTER TSADI WITH DAGESH': 64326,
'HEBREW LETTER VAV': 1493,
'HEBREW LETTER VAV WITH DAGESH': 64309,
'HEBREW LETTER VAV WITH HOLAM': 64331,
'HEBREW LETTER WIDE ALEF': 64289,
'HEBREW LETTER WIDE DALET': 64290,
'HEBREW LETTER WIDE FINAL MEM': 64294,
'HEBREW LETTER WIDE HE': 64291,
'HEBREW LETTER WIDE KAF': 64292,
'HEBREW LETTER WIDE LAMED': 64293,
'HEBREW LETTER WIDE RESH': 64295,
'HEBREW LETTER WIDE TAV': 64296,
'HEBREW LETTER YOD': 1497,
'HEBREW LETTER YOD WITH DAGESH': 64313,
'HEBREW LETTER YOD WITH HIRIQ': 64285,
'HEBREW LETTER ZAYIN': 1494,
'HEBREW LETTER ZAYIN WITH DAGESH': 64310,
'HEBREW LIGATURE ALEF LAMED': 64335,
'HEBREW LIGATURE YIDDISH DOUBLE VAV': 1520,
'HEBREW LIGATURE YIDDISH DOUBLE YOD': 1522,
'HEBREW LIGATURE YIDDISH VAV YOD': 1521,
'HEBREW LIGATURE YIDDISH YOD YOD PATAH': 64287,
'HEBREW MARK LOWER DOT': 1477,
'HEBREW MARK MASORA CIRCLE': 1455,
'HEBREW MARK UPPER DOT': 1476,
'HEBREW POINT DAGESH OR MAPIQ': 1468,
'HEBREW POINT HATAF PATAH': 1458,
'HEBREW POINT HATAF QAMATS': 1459,
'HEBREW POINT HATAF SEGOL': 1457,
'HEBREW POINT HIRIQ': 1460,
'HEBREW POINT HOLAM': 1465,
'HEBREW POINT HOLAM HASER FOR VAV': 1466,
'HEBREW POINT JUDEO-SPANISH VARIKA': 64286,
'HEBREW POINT METEG': 1469,
'HEBREW POINT PATAH': 1463,
'HEBREW POINT QAMATS': 1464,
'HEBREW POINT QAMATS QATAN': 1479,
'HEBREW POINT QUBUTS': 1467,
'HEBREW POINT RAFE': 1471,
'HEBREW POINT SEGOL': 1462,
'HEBREW POINT SHEVA': 1456,
'HEBREW POINT SHIN DOT': 1473,
'HEBREW POINT SIN DOT': 1474,
'HEBREW POINT TSERE': 1461,
'HEBREW PUNCTUATION GERESH': 1523,
'HEBREW PUNCTUATION GERSHAYIM': 1524,
'HEBREW PUNCTUATION MAQAF': 1470,
'HEBREW PUNCTUATION NUN HAFUKHA': 1478,
'HEBREW PUNCTUATION PASEQ': 1472,
'HEBREW PUNCTUATION SOF PASUQ': 1475,
'HELM SYMBOL': 9096,
'HELMET WITH WHITE CROSS': 9937,
'HERMITIAN CONJUGATE MATRIX': 8889,
'HEXAGRAM FOR ABUNDANCE': 19958,
'HEXAGRAM FOR AFTER COMPLETION': 19966,
'HEXAGRAM FOR APPROACH': 19922,
'HEXAGRAM FOR BEFORE COMPLETION': 19967,
'HEXAGRAM FOR BITING THROUGH': 19924,
'HEXAGRAM FOR BREAKTHROUGH': 19946,
'HEXAGRAM FOR COMING TO MEET': 19947,
'HEXAGRAM FOR CONFLICT': 19909,
'HEXAGRAM FOR CONTEMPLATION': 19923,
'HEXAGRAM FOR DARKENING OF THE LIGHT': 19939,
'HEXAGRAM FOR DECREASE': 19944,
'HEXAGRAM FOR DELIVERANCE': 19943,
'HEXAGRAM FOR DEVELOPMENT': 19956,
'HEXAGRAM FOR DIFFICULTY AT THE BEGINNING': 19906,
'HEXAGRAM FOR DISPERSION': 19962,
'HEXAGRAM FOR DURATION': 19935,
'HEXAGRAM FOR ENTHUSIASM': 19919,
'HEXAGRAM FOR FELLOWSHIP': 19916,
'HEXAGRAM FOR FOLLOWING': 19920,
'HEXAGRAM FOR GATHERING TOGETHER': 19948,
'HEXAGRAM FOR GRACE': 19925,
'HEXAGRAM FOR GREAT POSSESSION': 19917,
'HEXAGRAM FOR GREAT POWER': 19937,
'HEXAGRAM FOR GREAT PREPONDERANCE': 19931,
'HEXAGRAM FOR GREAT TAMING': 19929,
'HEXAGRAM FOR HOLDING TOGETHER': 19911,
'HEXAGRAM FOR INCREASE': 19945,
'HEXAGRAM FOR INFLUENCE': 19934,
'HEXAGRAM FOR INNER TRUTH': 19964,
'HEXAGRAM FOR INNOCENCE': 19928,
'HEXAGRAM FOR LIMITATION': 19963,
'HEXAGRAM FOR MODESTY': 19918,
'HEXAGRAM FOR MOUTH CORNERS': 19930,
'HEXAGRAM FOR OBSTRUCTION': 19942,
'HEXAGRAM FOR OPPOSITION': 19941,
'HEXAGRAM FOR OPPRESSION': 19950,
'HEXAGRAM FOR PEACE': 19914,
'HEXAGRAM FOR PROGRESS': 19938,
'HEXAGRAM FOR PUSHING UPWARD': 19949,
'HEXAGRAM FOR RETREAT': 19936,
'HEXAGRAM FOR RETURN': 19927,
'HEXAGRAM FOR REVOLUTION': 19952,
'HEXAGRAM FOR SMALL PREPONDERANCE': 19965,
'HEXAGRAM FOR SMALL TAMING': 19912,
'HEXAGRAM FOR SPLITTING APART': 19926,
'HEXAGRAM FOR STANDSTILL': 19915,
'HEXAGRAM FOR THE ABYSMAL WATER': 19932,
'HEXAGRAM FOR THE ARMY': 19910,
'HEXAGRAM FOR THE AROUSING THUNDER': 19954,
'HEXAGRAM FOR THE CAULDRON': 19953,
'HEXAGRAM FOR THE CLINGING FIRE': 19933,
'HEXAGRAM FOR THE CREATIVE HEAVEN': 19904,
'HEXAGRAM FOR THE FAMILY': 19940,
'HEXAGRAM FOR THE GENTLE WIND': 19960,
'HEXAGRAM FOR THE JOYOUS LAKE': 19961,
'HEXAGRAM FOR THE KEEPING STILL MOUNTAIN': 19955,
'HEXAGRAM FOR THE MARRYING MAIDEN': 19957,
'HEXAGRAM FOR THE RECEPTIVE EARTH': 19905,
'HEXAGRAM FOR THE WANDERER': 19959,
'HEXAGRAM FOR THE WELL': 19951,
'HEXAGRAM FOR TREADING': 19913,
'HEXAGRAM FOR WAITING': 19908,
'HEXAGRAM FOR WORK ON THE DECAYED': 19921,
'HEXAGRAM FOR YOUTHFUL FOLLY': 19907,
'HIGH VOLTAGE SIGN': 9889,
'HIRAGANA DIGRAPH YORI': 12447,
'HIRAGANA ITERATION MARK': 12445,
'HIRAGANA LETTER A': 12354,
'HIRAGANA LETTER BA': 12400,
'HIRAGANA LETTER BE': 12409,
'HIRAGANA LETTER BI': 12403,
'HIRAGANA LETTER BO': 12412,
'HIRAGANA LETTER BU': 12406,
'HIRAGANA LETTER DA': 12384,
'HIRAGANA LETTER DE': 12391,
'HIRAGANA LETTER DI': 12386,
'HIRAGANA LETTER DO': 12393,
'HIRAGANA LETTER DU': 12389,
'HIRAGANA LETTER E': 12360,
'HIRAGANA LETTER GA': 12364,
'HIRAGANA LETTER GE': 12370,
'HIRAGANA LETTER GI': 12366,
'HIRAGANA LETTER GO': 12372,
'HIRAGANA LETTER GU': 12368,
'HIRAGANA LETTER HA': 12399,
'HIRAGANA LETTER HE': 12408,
'HIRAGANA LETTER HI': 12402,
'HIRAGANA LETTER HO': 12411,
'HIRAGANA LETTER HU': 12405,
'HIRAGANA LETTER I': 12356,
'HIRAGANA LETTER KA': 12363,
'HIRAGANA LETTER KE': 12369,
'HIRAGANA LETTER KI': 12365,
'HIRAGANA LETTER KO': 12371,
'HIRAGANA LETTER KU': 12367,
'HIRAGANA LETTER MA': 12414,
'HIRAGANA LETTER ME': 12417,
'HIRAGANA LETTER MI': 12415,
'HIRAGANA LETTER MO': 12418,
'HIRAGANA LETTER MU': 12416,
'HIRAGANA LETTER N': 12435,
'HIRAGANA LETTER NA': 12394,
'HIRAGANA LETTER NE': 12397,
'HIRAGANA LETTER NI': 12395,
'HIRAGANA LETTER NO': 12398,
'HIRAGANA LETTER NU': 12396,
'HIRAGANA LETTER O': 12362,
'HIRAGANA LETTER PA': 12401,
'HIRAGANA LETTER PE': 12410,
'HIRAGANA LETTER PI': 12404,
'HIRAGANA LETTER PO': 12413,
'HIRAGANA LETTER PU': 12407,
'HIRAGANA LETTER RA': 12425,
'HIRAGANA LETTER RE': 12428,
'HIRAGANA LETTER RI': 12426,
'HIRAGANA LETTER RO': 12429,
'HIRAGANA LETTER RU': 12427,
'HIRAGANA LETTER SA': 12373,
'HIRAGANA LETTER SE': 12379,
'HIRAGANA LETTER SI': 12375,
'HIRAGANA LETTER SMALL A': 12353,
'HIRAGANA LETTER SMALL E': 12359,
'HIRAGANA LETTER SMALL I': 12355,
'HIRAGANA LETTER SMALL KA': 12437,
'HIRAGANA LETTER SMALL KE': 12438,
'HIRAGANA LETTER SMALL O': 12361,
'HIRAGANA LETTER SMALL TU': 12387,
'HIRAGANA LETTER SMALL U': 12357,
'HIRAGANA LETTER SMALL WA': 12430,
'HIRAGANA LETTER SMALL YA': 12419,
'HIRAGANA LETTER SMALL YO': 12423,
'HIRAGANA LETTER SMALL YU': 12421,
'HIRAGANA LETTER SO': 12381,
'HIRAGANA LETTER SU': 12377,
'HIRAGANA LETTER TA': 12383,
'HIRAGANA LETTER TE': 12390,
'HIRAGANA LETTER TI': 12385,
'HIRAGANA LETTER TO': 12392,
'HIRAGANA LETTER TU': 12388,
'HIRAGANA LETTER U': 12358,
'HIRAGANA LETTER VU': 12436,
'HIRAGANA LETTER WA': 12431,
'HIRAGANA LETTER WE': 12433,
'HIRAGANA LETTER WI': 12432,
'HIRAGANA LETTER WO': 12434,
'HIRAGANA LETTER YA': 12420,
'HIRAGANA LETTER YO': 12424,
'HIRAGANA LETTER YU': 12422,
'HIRAGANA LETTER ZA': 12374,
'HIRAGANA LETTER ZE': 12380,
'HIRAGANA LETTER ZI': 12376,
'HIRAGANA LETTER ZO': 12382,
'HIRAGANA LETTER ZU': 12378,
'HIRAGANA VOICED ITERATION MARK': 12446,
'HISTORIC SITE': 9964,
'HOMOTHETIC': 8763,
'HORIZONTAL BAR': 8213,
'HORIZONTAL BLACK HEXAGON': 11043,
'HORIZONTAL ELLIPSIS': 8230,
'HORIZONTAL LINE EXTENSION': 9135,
'HORIZONTAL MALE WITH STROKE SIGN': 9897,
'HORIZONTAL SCAN LINE-1': 9146,
'HORIZONTAL SCAN LINE-3': 9147,
'HORIZONTAL SCAN LINE-7': 9148,
'HORIZONTAL SCAN LINE-9': 9149,
'HOT BEVERAGE': 9749,
'HOT SPRINGS': 9832,
'HOURGLASS': 8987,
'HOUSE': 8962,
'HRYVNIA SIGN': 8372,
'HYPHEN': 8208,
'HYPHEN BULLET': 8259,
'HYPHEN WITH DIAERESIS': 11802,
'HYPHEN-MINUS': 45,
'HYPHENATION POINT': 8231,
'HYPODIASTOLE': 11794,
'HYSTERESIS SYMBOL': 9102,
'ICE SKATE': 9976,
'IDENTICAL TO': 8801,
'IDENTICAL TO AND SLANTED PARALLEL': 10725,
'IDENTICAL WITH DOT ABOVE': 10855,
'IDEOGRAPHIC ANNOTATION BOTTOM MARK': 12696,
'IDEOGRAPHIC ANNOTATION EARTH MARK': 12702,
'IDEOGRAPHIC ANNOTATION FIRST MARK': 12697,
'IDEOGRAPHIC ANNOTATION FOUR MARK': 12693,
'IDEOGRAPHIC ANNOTATION FOURTH MARK': 12700,
'IDEOGRAPHIC ANNOTATION HEAVEN MARK': 12701,
'IDEOGRAPHIC ANNOTATION LINKING MARK': 12688,
'IDEOGRAPHIC ANNOTATION MAN MARK': 12703,
'IDEOGRAPHIC ANNOTATION MIDDLE MARK': 12695,
'IDEOGRAPHIC ANNOTATION ONE MARK': 12690,
'IDEOGRAPHIC ANNOTATION REVERSE MARK': 12689,
'IDEOGRAPHIC ANNOTATION SECOND MARK': 12698,
'IDEOGRAPHIC ANNOTATION THIRD MARK': 12699,
'IDEOGRAPHIC ANNOTATION THREE MARK': 12692,
'IDEOGRAPHIC ANNOTATION TOP MARK': 12694,
'IDEOGRAPHIC ANNOTATION TWO MARK': 12691,
'IDEOGRAPHIC CLOSING MARK': 12294,
'IDEOGRAPHIC COMMA': 12289,
'IDEOGRAPHIC DEPARTING TONE MARK': 12332,
'IDEOGRAPHIC DESCRIPTION CHARACTER ABOVE TO BELOW': 12273,
'IDEOGRAPHIC DESCRIPTION CHARACTER ABOVE TO MIDDLE AND BELOW': 12275,
'IDEOGRAPHIC DESCRIPTION CHARACTER FULL SURROUND': 12276,
'IDEOGRAPHIC DESCRIPTION CHARACTER LEFT TO MIDDLE AND RIGHT': 12274,
'IDEOGRAPHIC DESCRIPTION CHARACTER LEFT TO RIGHT': 12272,
'IDEOGRAPHIC DESCRIPTION CHARACTER OVERLAID': 12283,
'IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM ABOVE': 12277,
'IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM BELOW': 12278,
'IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM LEFT': 12279,
'IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM LOWER LEFT': 12282,
'IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM UPPER LEFT': 12280,
'IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM UPPER RIGHT': 12281,
'IDEOGRAPHIC ENTERING TONE MARK': 12333,
'IDEOGRAPHIC FULL STOP': 12290,
'IDEOGRAPHIC HALF FILL SPACE': 12351,
'IDEOGRAPHIC ITERATION MARK': 12293,
'IDEOGRAPHIC LEVEL TONE MARK': 12330,
'IDEOGRAPHIC NUMBER ZERO': 12295,
'IDEOGRAPHIC RISING TONE MARK': 12331,
'IDEOGRAPHIC SPACE': 12288,
'IDEOGRAPHIC TELEGRAPH LINE FEED SEPARATOR SYMBOL': 12343,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR APRIL': 12995,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR AUGUST': 12999,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY EIGHT': 13287,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY EIGHTEEN': 13297,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY ELEVEN': 13290,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FIFTEEN': 13294,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FIVE': 13284,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FOUR': 13283,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FOURTEEN': 13293,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY NINE': 13288,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY NINETEEN': 13298,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY ONE': 13280,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SEVEN': 13286,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SEVENTEEN': 13296,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SIX': 13285,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SIXTEEN': 13295,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TEN': 13289,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THIRTEEN': 13292,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THIRTY': 13309,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THIRTY-ONE': 13310,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THREE': 13282,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWELVE': 13291,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY': 13299,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-EIGHT': 13307,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-FIVE': 13304,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-FOUR': 13303,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-NINE': 13308,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-ONE': 13300,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-SEVEN': 13306,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-SIX': 13305,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-THREE': 13302,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-TWO': 13301,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWO': 13281,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR DECEMBER': 13003,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR FEBRUARY': 12993,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR EIGHT': 13152,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR EIGHTEEN': 13162,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR ELEVEN': 13155,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FIFTEEN': 13159,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FIVE': 13149,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FOUR': 13148,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FOURTEEN': 13158,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR NINE': 13153,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR NINETEEN': 13163,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR ONE': 13145,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SEVEN': 13151,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SEVENTEEN': 13161,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SIX': 13150,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SIXTEEN': 13160,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TEN': 13154,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR THIRTEEN': 13157,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR THREE': 13147,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWELVE': 13156,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY': 13164,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-FOUR': 13168,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-ONE': 13165,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-THREE': 13167,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-TWO': 13166,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWO': 13146,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR ZERO': 13144,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR JANUARY': 12992,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR JULY': 12998,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR JUNE': 12997,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR MARCH': 12994,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR MAY': 12996,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR NOVEMBER': 13002,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR OCTOBER': 13001,
'IDEOGRAPHIC TELEGRAPH SYMBOL FOR SEPTEMBER': 13000,
'IDEOGRAPHIC VARIATION INDICATOR': 12350,
'IMAGE OF': 8887,
'IMAGE OF OR APPROXIMATELY EQUAL TO': 8787,
'IMPERIAL ARAMAIC LETTER ALEPH': 67648,
'IMPERIAL ARAMAIC LETTER AYIN': 67663,
'IMPERIAL ARAMAIC LETTER BETH': 67649,
'IMPERIAL ARAMAIC LETTER DALETH': 67651,
'IMPERIAL ARAMAIC LETTER GIMEL': 67650,
'IMPERIAL ARAMAIC LETTER HE': 67652,
'IMPERIAL ARAMAIC LETTER HETH': 67655,
'IMPERIAL ARAMAIC LETTER KAPH': 67658,
'IMPERIAL ARAMAIC LETTER LAMEDH': 67659,
'IMPERIAL ARAMAIC LETTER MEM': 67660,
'IMPERIAL ARAMAIC LETTER NUN': 67661,
'IMPERIAL ARAMAIC LETTER PE': 67664,
'IMPERIAL ARAMAIC LETTER QOPH': 67666,
'IMPERIAL ARAMAIC LETTER RESH': 67667,
'IMPERIAL ARAMAIC LETTER SADHE': 67665,
'IMPERIAL ARAMAIC LETTER SAMEKH': 67662,
'IMPERIAL ARAMAIC LETTER SHIN': 67668,
'IMPERIAL ARAMAIC LETTER TAW': 67669,
'IMPERIAL ARAMAIC LETTER TETH': 67656,
'IMPERIAL ARAMAIC LETTER WAW': 67653,
'IMPERIAL ARAMAIC LETTER YODH': 67657,
'IMPERIAL ARAMAIC LETTER ZAYIN': 67654,
'IMPERIAL ARAMAIC NUMBER ONE': 67672,
'IMPERIAL ARAMAIC NUMBER ONE HUNDRED': 67677,
'IMPERIAL ARAMAIC NUMBER ONE THOUSAND': 67678,
'IMPERIAL ARAMAIC NUMBER TEN': 67675,
'IMPERIAL ARAMAIC NUMBER TEN THOUSAND': 67679,
'IMPERIAL ARAMAIC NUMBER THREE': 67674,
'IMPERIAL ARAMAIC NUMBER TWENTY': 67676,
'IMPERIAL ARAMAIC NUMBER TWO': 67673,
'IMPERIAL ARAMAIC SECTION SIGN': 67671,
'INCOMPLETE INFINITY': 10716,
'INCREASES AS': 10721,
'INCREMENT': 8710,
'INFINITY': 8734,
'INFINITY NEGATED WITH VERTICAL BAR': 10718,
'INFORMATION SOURCE': 8505,
'INHIBIT ARABIC FORM SHAPING': 8300,
'INHIBIT SYMMETRIC SWAPPING': 8298,
'INSCRIPTIONAL PAHLAVI LETTER ALEPH': 68448,
'INSCRIPTIONAL PAHLAVI LETTER BETH': 68449,
'INSCRIPTIONAL PAHLAVI LETTER DALETH': 68451,
'INSCRIPTIONAL PAHLAVI LETTER GIMEL': 68450,
'INSCRIPTIONAL PAHLAVI LETTER HE': 68452,
'INSCRIPTIONAL PAHLAVI LETTER HETH': 68455,
'INSCRIPTIONAL PAHLAVI LETTER KAPH': 68458,
'INSCRIPTIONAL PAHLAVI LETTER LAMEDH': 68459,
'INSCRIPTIONAL PAHLAVI LETTER MEM-QOPH': 68460,
'INSCRIPTIONAL PAHLAVI LETTER NUN': 68461,
'INSCRIPTIONAL PAHLAVI LETTER PE': 68463,
'INSCRIPTIONAL PAHLAVI LETTER SADHE': 68464,
'INSCRIPTIONAL PAHLAVI LETTER SAMEKH': 68462,
'INSCRIPTIONAL PAHLAVI LETTER SHIN': 68465,
'INSCRIPTIONAL PAHLAVI LETTER TAW': 68466,
'INSCRIPTIONAL PAHLAVI LETTER TETH': 68456,
'INSCRIPTIONAL PAHLAVI LETTER WAW-AYIN-RESH': 68453,
'INSCRIPTIONAL PAHLAVI LETTER YODH': 68457,
'INSCRIPTIONAL PAHLAVI LETTER ZAYIN': 68454,
'INSCRIPTIONAL PAHLAVI NUMBER FOUR': 68475,
'INSCRIPTIONAL PAHLAVI NUMBER ONE': 68472,
'INSCRIPTIONAL PAHLAVI NUMBER ONE HUNDRED': 68478,
'INSCRIPTIONAL PAHLAVI NUMBER ONE THOUSAND': 68479,
'INSCRIPTIONAL PAHLAVI NUMBER TEN': 68476,
'INSCRIPTIONAL PAHLAVI NUMBER THREE': 68474,
'INSCRIPTIONAL PAHLAVI NUMBER TWENTY': 68477,
'INSCRIPTIONAL PAHLAVI NUMBER TWO': 68473,
'INSCRIPTIONAL PARTHIAN LETTER ALEPH': 68416,
'INSCRIPTIONAL PARTHIAN LETTER AYIN': 68431,
'INSCRIPTIONAL PARTHIAN LETTER BETH': 68417,
'INSCRIPTIONAL PARTHIAN LETTER DALETH': 68419,
'INSCRIPTIONAL PARTHIAN LETTER GIMEL': 68418,
'INSCRIPTIONAL PARTHIAN LETTER HE': 68420,
'INSCRIPTIONAL PARTHIAN LETTER HETH': 68423,
'INSCRIPTIONAL PARTHIAN LETTER KAPH': 68426,
'INSCRIPTIONAL PARTHIAN LETTER LAMEDH': 68427,
'INSCRIPTIONAL PARTHIAN LETTER MEM': 68428,
'INSCRIPTIONAL PARTHIAN LETTER NUN': 68429,
'INSCRIPTIONAL PARTHIAN LETTER PE': 68432,
'INSCRIPTIONAL PARTHIAN LETTER QOPH': 68434,
'INSCRIPTIONAL PARTHIAN LETTER RESH': 68435,
'INSCRIPTIONAL PARTHIAN LETTER SADHE': 68433,
'INSCRIPTIONAL PARTHIAN LETTER SAMEKH': 68430,
'INSCRIPTIONAL PARTHIAN LETTER SHIN': 68436,
'INSCRIPTIONAL PARTHIAN LETTER TAW': 68437,
'INSCRIPTIONAL PARTHIAN LETTER TETH': 68424,
'INSCRIPTIONAL PARTHIAN LETTER WAW': 68421,
'INSCRIPTIONAL PARTHIAN LETTER YODH': 68425,
'INSCRIPTIONAL PARTHIAN LETTER ZAYIN': 68422,
'INSCRIPTIONAL PARTHIAN NUMBER FOUR': 68443,
'INSCRIPTIONAL PARTHIAN NUMBER ONE': 68440,
'INSCRIPTIONAL PARTHIAN NUMBER ONE HUNDRED': 68446,
'INSCRIPTIONAL PARTHIAN NUMBER ONE THOUSAND': 68447,
'INSCRIPTIONAL PARTHIAN NUMBER TEN': 68444,
'INSCRIPTIONAL PARTHIAN NUMBER THREE': 68442,
'INSCRIPTIONAL PARTHIAN NUMBER TWENTY': 68445,
'INSCRIPTIONAL PARTHIAN NUMBER TWO': 68441,
'INSERTION SYMBOL': 9088,
'INTEGRAL': 8747,
'INTEGRAL AROUND A POINT OPERATOR': 10773,
'INTEGRAL AVERAGE WITH SLASH': 10767,
'INTEGRAL EXTENSION': 9134,
'INTEGRAL WITH DOUBLE STROKE': 10766,
'INTEGRAL WITH INTERSECTION': 10777,
'INTEGRAL WITH LEFTWARDS ARROW WITH HOOK': 10775,
'INTEGRAL WITH OVERBAR': 10779,
'INTEGRAL WITH TIMES SIGN': 10776,
'INTEGRAL WITH UNDERBAR': 10780,
'INTEGRAL WITH UNION': 10778,
'INTERCALATE': 8890,
'INTERIOR PRODUCT': 10812,
'INTERLINEAR ANNOTATION ANCHOR': 65529,
'INTERLINEAR ANNOTATION SEPARATOR': 65530,
'INTERLINEAR ANNOTATION TERMINATOR': 65531,
'INTERLOCKED FEMALE AND MALE SIGN': 9892,
'INTERROBANG': 8253,
'INTERSECTION': 8745,
'INTERSECTION ABOVE BAR ABOVE UNION': 10825,
'INTERSECTION ABOVE UNION': 10823,
'INTERSECTION BESIDE AND JOINED WITH INTERSECTION': 10827,
'INTERSECTION WITH DOT': 10816,
'INTERSECTION WITH LOGICAL AND': 10820,
'INTERSECTION WITH OVERBAR': 10819,
'INVERSE BULLET': 9688,
'INVERSE WHITE CIRCLE': 9689,
'INVERTED EXCLAMATION MARK': 161,
'INVERTED INTERROBANG': 11800,
'INVERTED LAZY S': 8766,
'INVERTED OHM SIGN': 8487,
'INVERTED QUESTION MARK': 191,
'INVERTED UNDERTIE': 8276,
'INVISIBLE PLUS': 8292,
'INVISIBLE SEPARATOR': 8291,
'INVISIBLE TIMES': 8290,
'JAPANESE BANK SYMBOL': 9979,
'JAPANESE INDUSTRIAL STANDARD SYMBOL': 12292,
'JAVANESE CONSONANT SIGN CAKRA': 43455,
'JAVANESE CONSONANT SIGN KERET': 43453,
'JAVANESE CONSONANT SIGN PENGKAL': 43454,
'JAVANESE DIGIT EIGHT': 43480,
'JAVANESE DIGIT FIVE': 43477,
'JAVANESE DIGIT FOUR': 43476,
'JAVANESE DIGIT NINE': 43481,
'JAVANESE DIGIT ONE': 43473,
'JAVANESE DIGIT SEVEN': 43479,
'JAVANESE DIGIT SIX': 43478,
'JAVANESE DIGIT THREE': 43475,
'JAVANESE DIGIT TWO': 43474,
'JAVANESE DIGIT ZERO': 43472,
'JAVANESE LEFT RERENGGAN': 43457,
'JAVANESE LETTER A': 43396,
'JAVANESE LETTER AI': 43405,
'JAVANESE LETTER BA': 43431,
'JAVANESE LETTER BA MURDA': 43432,
'JAVANESE LETTER CA': 43413,
'JAVANESE LETTER CA MURDA': 43414,
'JAVANESE LETTER DA': 43426,
'JAVANESE LETTER DA MAHAPRANA': 43427,
'JAVANESE LETTER DDA': 43421,
'JAVANESE LETTER DDA MAHAPRANA': 43422,
'JAVANESE LETTER E': 43404,
'JAVANESE LETTER GA': 43410,
'JAVANESE LETTER GA MURDA': 43411,
'JAVANESE LETTER HA': 43442,
'JAVANESE LETTER I': 43398,
'JAVANESE LETTER I KAWI': 43397,
'JAVANESE LETTER II': 43399,
'JAVANESE LETTER JA': 43415,
'JAVANESE LETTER JA MAHAPRANA': 43417,
'JAVANESE LETTER KA': 43407,
'JAVANESE LETTER KA MURDA': 43409,
'JAVANESE LETTER KA SASAK': 43408,
'JAVANESE LETTER LA': 43437,
'JAVANESE LETTER MA': 43433,
'JAVANESE LETTER NA': 43428,
'JAVANESE LETTER NA MURDA': 43423,
'JAVANESE LETTER NGA': 43412,
'JAVANESE LETTER NGA LELET': 43402,
'JAVANESE LETTER NGA LELET RASWADI': 43403,
'JAVANESE LETTER NYA': 43418,
'JAVANESE LETTER NYA MURDA': 43416,
'JAVANESE LETTER O': 43406,
'JAVANESE LETTER PA': 43429,
'JAVANESE LETTER PA CEREK': 43401,
'JAVANESE LETTER PA MURDA': 43430,
'JAVANESE LETTER RA': 43435,
'JAVANESE LETTER RA AGUNG': 43436,
'JAVANESE LETTER SA': 43441,
'JAVANESE LETTER SA MAHAPRANA': 43440,
'JAVANESE LETTER SA MURDA': 43439,
'JAVANESE LETTER TA': 43424,
'JAVANESE LETTER TA MURDA': 43425,
'JAVANESE LETTER TTA': 43419,
'JAVANESE LETTER TTA MAHAPRANA': 43420,
'JAVANESE LETTER U': 43400,
'JAVANESE LETTER WA': 43438,
'JAVANESE LETTER YA': 43434,
'JAVANESE PADA ADEG': 43466,
'JAVANESE PADA ADEG ADEG': 43467,
'JAVANESE PADA ANDAP': 43459,
'JAVANESE PADA ISEN-ISEN': 43487,
'JAVANESE PADA LINGSA': 43464,
'JAVANESE PADA LUHUR': 43461,
'JAVANESE PADA LUNGSI': 43465,
'JAVANESE PADA MADYA': 43460,
'JAVANESE PADA PANGKAT': 43463,
'JAVANESE PADA PISELEH': 43468,
'JAVANESE PADA TIRTA TUMETES': 43486,
'JAVANESE PADA WINDU': 43462,
'JAVANESE PANGKON': 43456,
'JAVANESE PANGRANGKEP': 43471,
'JAVANESE RIGHT RERENGGAN': 43458,
'JAVANESE SIGN CECAK': 43393,
'JAVANESE SIGN CECAK TELU': 43443,
'JAVANESE SIGN LAYAR': 43394,
'JAVANESE SIGN PANYANGGA': 43392,
'JAVANESE SIGN WIGNYAN': 43395,
'JAVANESE TURNED PADA PISELEH': 43469,
'JAVANESE VOWEL SIGN DIRGA MURE': 43451,
'JAVANESE VOWEL SIGN PEPET': 43452,
'JAVANESE VOWEL SIGN SUKU': 43448,
'JAVANESE VOWEL SIGN SUKU MENDUT': 43449,
'JAVANESE VOWEL SIGN TALING': 43450,
'JAVANESE VOWEL SIGN TARUNG': 43444,
'JAVANESE VOWEL SIGN TOLONG': 43445,
'JAVANESE VOWEL SIGN WULU': 43446,
'JAVANESE VOWEL SIGN WULU MELIK': 43447,
'JOIN': 10781,
'JUNO': 9909,
'JUPITER': 9795,
'KAITHI ABBREVIATION SIGN': 69819,
'KAITHI DANDA': 69824,
'KAITHI DOUBLE DANDA': 69825,
'KAITHI DOUBLE SECTION MARK': 69823,
'KAITHI ENUMERATION SIGN': 69820,
'KAITHI LETTER A': 69763,
'KAITHI LETTER AA': 69764,
'KAITHI LETTER AI': 69770,
'KAITHI LETTER AU': 69772,
'KAITHI LETTER BA': 69797,
'KAITHI LETTER BHA': 69798,
'KAITHI LETTER CA': 69778,
'KAITHI LETTER CHA': 69779,
'KAITHI LETTER DA': 69792,
'KAITHI LETTER DDA': 69785,
'KAITHI LETTER DDDHA': 69786,
'KAITHI LETTER DDHA': 69787,
'KAITHI LETTER DHA': 69793,
'KAITHI LETTER E': 69769,
'KAITHI LETTER GA': 69775,
'KAITHI LETTER GHA': 69776,
'KAITHI LETTER HA': 69807,
'KAITHI LETTER I': 69765,
'KAITHI LETTER II': 69766,
'KAITHI LETTER JA': 69780,
'KAITHI LETTER JHA': 69781,
'KAITHI LETTER KA': 69773,
'KAITHI LETTER KHA': 69774,
'KAITHI LETTER LA': 69802,
'KAITHI LETTER MA': 69799,
'KAITHI LETTER NA': 69794,
'KAITHI LETTER NGA': 69777,
'KAITHI LETTER NNA': 69789,
'KAITHI LETTER NYA': 69782,
'KAITHI LETTER O': 69771,
'KAITHI LETTER PA': 69795,
'KAITHI LETTER PHA': 69796,
'KAITHI LETTER RA': 69801,
'KAITHI LETTER RHA': 69788,
'KAITHI LETTER SA': 69806,
'KAITHI LETTER SHA': 69804,
'KAITHI LETTER SSA': 69805,
'KAITHI LETTER TA': 69790,
'KAITHI LETTER THA': 69791,
'KAITHI LETTER TTA': 69783,
'KAITHI LETTER TTHA': 69784,
'KAITHI LETTER U': 69767,
'KAITHI LETTER UU': 69768,
'KAITHI LETTER VA': 69803,
'KAITHI LETTER YA': 69800,
'KAITHI NUMBER SIGN': 69821,
'KAITHI SECTION MARK': 69822,
'KAITHI SIGN ANUSVARA': 69761,
'KAITHI SIGN CANDRABINDU': 69760,
'KAITHI SIGN NUKTA': 69818,
'KAITHI SIGN VIRAMA': 69817,
'KAITHI SIGN VISARGA': 69762,
'KAITHI VOWEL SIGN AA': 69808,
'KAITHI VOWEL SIGN AI': 69814,
'KAITHI VOWEL SIGN AU': 69816,
'KAITHI VOWEL SIGN E': 69813,
'KAITHI VOWEL SIGN I': 69809,
'KAITHI VOWEL SIGN II': 69810,
'KAITHI VOWEL SIGN O': 69815,
'KAITHI VOWEL SIGN U': 69811,
'KAITHI VOWEL SIGN UU': 69812,
'KANGXI RADICAL AGAIN': 12060,
'KANGXI RADICAL AND': 12157,
'KANGXI RADICAL ARRIVE': 12164,
'KANGXI RADICAL ARROW': 12142,
'KANGXI RADICAL AXE': 12100,
'KANGXI RADICAL BADGER': 12184,
'KANGXI RADICAL BAMBOO': 12149,
'KANGXI RADICAL BEAN': 12182,
'KANGXI RADICAL BIG': 12068,
'KANGXI RADICAL BIRD': 12227,
'KANGXI RADICAL BITTER': 12191,
'KANGXI RADICAL BLACK': 12234,
'KANGXI RADICAL BLOOD': 12174,
'KANGXI RADICAL BLUE': 12205,
'KANGXI RADICAL BOAT': 12168,
'KANGXI RADICAL BODY': 12189,
'KANGXI RADICAL BOLT OF CLOTH': 12134,
'KANGXI RADICAL BONE': 12219,
'KANGXI RADICAL BOW': 12088,
'KANGXI RADICAL BRANCH': 12096,
'KANGXI RADICAL BRISTLE': 12090,
'KANGXI RADICAL BRUSH': 12160,
'KANGXI RADICAL CART': 12190,
'KANGXI RADICAL CAULDRON': 12224,
'KANGXI RADICAL CAVE': 12147,
'KANGXI RADICAL CHILD': 12070,
'KANGXI RADICAL CITY': 12194,
'KANGXI RADICAL CLAN': 12114,
'KANGXI RADICAL CLAW': 12118,
'KANGXI RADICAL CLIFF': 12058,
'KANGXI RADICAL CLOTHES': 12176,
'KANGXI RADICAL COLOR': 12170,
'KANGXI RADICAL COMPARE': 12112,
'KANGXI RADICAL CORPSE': 12075,
'KANGXI RADICAL COVER': 12045,
'KANGXI RADICAL COW': 12124,
'KANGXI RADICAL DEATH': 12109,
'KANGXI RADICAL DEER': 12229,
'KANGXI RADICAL DIPPER': 12099,
'KANGXI RADICAL DISH': 12139,
'KANGXI RADICAL DISTINGUISH': 12196,
'KANGXI RADICAL DIVINATION': 12056,
'KANGXI RADICAL DO NOT': 12111,
'KANGXI RADICAL DOG': 12125,
'KANGXI RADICAL DOOR': 12094,
'KANGXI RADICAL DOT': 12034,
'KANGXI RADICAL DOTTED CLIFF': 12084,
'KANGXI RADICAL DOTTED TENT': 12136,
'KANGXI RADICAL DOUBLE X': 12120,
'KANGXI RADICAL DOWN BOX': 12044,
'KANGXI RADICAL DRAGON': 12243,
'KANGXI RADICAL DRUM': 12238,
'KANGXI RADICAL DRY': 12082,
'KANGXI RADICAL EAR': 12159,
'KANGXI RADICAL EARTH': 12063,
'KANGXI RADICAL EAT': 12215,
'KANGXI RADICAL EIGHT': 12043,
'KANGXI RADICAL EMBROIDERY': 12235,
'KANGXI RADICAL ENCLOSURE': 12062,
'KANGXI RADICAL ENTER': 12042,
'KANGXI RADICAL EVEN': 12241,
'KANGXI RADICAL EVENING': 12067,
'KANGXI RADICAL EYE': 12140,
'KANGXI RADICAL FACE': 12207,
'KANGXI RADICAL FANG': 12123,
'KANGXI RADICAL FATHER': 12119,
'KANGXI RADICAL FEATHER': 12155,
'KANGXI RADICAL FIELD': 12133,
'KANGXI RADICAL FIGHT': 12222,
'KANGXI RADICAL FIRE': 12117,
'KANGXI RADICAL FISH': 12226,
'KANGXI RADICAL FLUTE': 12245,
'KANGXI RADICAL FLY': 12214,
'KANGXI RADICAL FOOT': 12188,
'KANGXI RADICAL FRAGRANT': 12217,
'KANGXI RADICAL FROG': 12236,
'KANGXI RADICAL FUR': 12113,
'KANGXI RADICAL GATE': 12200,
'KANGXI RADICAL GHOST': 12225,
'KANGXI RADICAL GO': 12065,
'KANGXI RADICAL GO SLOWLY': 12066,
'KANGXI RADICAL GOLD': 12198,
'KANGXI RADICAL GRAIN': 12146,
'KANGXI RADICAL GRASS': 12171,
'KANGXI RADICAL HAIR': 12221,
'KANGXI RADICAL HALBERD': 12093,
'KANGXI RADICAL HALF TREE TRUNK': 12121,
'KANGXI RADICAL HAND': 12095,
'KANGXI RADICAL HEAD': 12216,
'KANGXI RADICAL HEART': 12092,
'KANGXI RADICAL HEMP': 12231,
'KANGXI RADICAL HIDING ENCLOSURE': 12054,
'KANGXI RADICAL HOOK': 12037,
'KANGXI RADICAL HORN': 12179,
'KANGXI RADICAL HORSE': 12218,
'KANGXI RADICAL ICE': 12046,
'KANGXI RADICAL INCH': 12072,
'KANGXI RADICAL INSECT': 12173,
'KANGXI RADICAL JADE': 12127,
'KANGXI RADICAL JAR': 12152,
'KANGXI RADICAL KNIFE': 12049,
'KANGXI RADICAL LACK': 12107,
'KANGXI RADICAL LAME': 12074,
'KANGXI RADICAL LEAF': 12212,
'KANGXI RADICAL LEATHER': 12208,
'KANGXI RADICAL LEEK': 12210,
'KANGXI RADICAL LEGS': 12041,
'KANGXI RADICAL LID': 12039,
'KANGXI RADICAL LIFE': 12131,
'KANGXI RADICAL LINE': 12033,
'KANGXI RADICAL LONG': 12199,
'KANGXI RADICAL LONG STRIDE': 12085,
'KANGXI RADICAL MAN': 12040,
'KANGXI RADICAL MEAT': 12161,
'KANGXI RADICAL MELON': 12128,
'KANGXI RADICAL MILLET': 12233,
'KANGXI RADICAL MINISTER': 12162,
'KANGXI RADICAL MOON': 12105,
'KANGXI RADICAL MORNING': 12192,
'KANGXI RADICAL MORTAR': 12165,
'KANGXI RADICAL MOUND': 12201,
'KANGXI RADICAL MOUNTAIN': 12077,
'KANGXI RADICAL MOUTH': 12061,
'KANGXI RADICAL NET': 12153,
'KANGXI RADICAL NOSE': 12240,
'KANGXI RADICAL NOT': 12102,
'KANGXI RADICAL OLD': 12156,
'KANGXI RADICAL ONE': 12032,
'KANGXI RADICAL ONESELF': 12080,
'KANGXI RADICAL OPEN BOX': 12048,
'KANGXI RADICAL OPPOSE': 12167,
'KANGXI RADICAL PIG': 12183,
'KANGXI RADICAL PLOW': 12158,
'KANGXI RADICAL POWER': 12050,
'KANGXI RADICAL PRIVATE': 12059,
'KANGXI RADICAL PROFOUND': 12126,
'KANGXI RADICAL RAIN': 12204,
'KANGXI RADICAL RAP': 12097,
'KANGXI RADICAL RAT': 12239,
'KANGXI RADICAL RED': 12186,
'KANGXI RADICAL RICE': 12150,
'KANGXI RADICAL RIGHT OPEN BOX': 12053,
'KANGXI RADICAL RIVER': 12078,
'KANGXI RADICAL ROOF': 12071,
'KANGXI RADICAL RUN': 12187,
'KANGXI RADICAL SACRIFICIAL WINE': 12223,
'KANGXI RADICAL SALT': 12228,
'KANGXI RADICAL SAY': 12104,
'KANGXI RADICAL SCHOLAR': 12064,
'KANGXI RADICAL SCRIPT': 12098,
'KANGXI RADICAL SEAL': 12057,
'KANGXI RADICAL SECOND': 12036,
'KANGXI RADICAL SEE': 12178,
'KANGXI RADICAL SELF': 12163,
'KANGXI RADICAL SHEEP': 12154,
'KANGXI RADICAL SHELL': 12185,
'KANGXI RADICAL SHOOT': 12087,
'KANGXI RADICAL SHORT TAILED BIRD': 12203,
'KANGXI RADICAL SHORT THREAD': 12083,
'KANGXI RADICAL SICKNESS': 12135,
'KANGXI RADICAL SILK': 12151,
'KANGXI RADICAL SKIN': 12138,
'KANGXI RADICAL SLASH': 12035,
'KANGXI RADICAL SLAVE': 12202,
'KANGXI RADICAL SLICE': 12122,
'KANGXI RADICAL SMALL': 12073,
'KANGXI RADICAL SNOUT': 12089,
'KANGXI RADICAL SOUND': 12211,
'KANGXI RADICAL SPEAR': 12141,
'KANGXI RADICAL SPEECH': 12180,
'KANGXI RADICAL SPIRIT': 12144,
'KANGXI RADICAL SPOON': 12052,
'KANGXI RADICAL SPROUT': 12076,
'KANGXI RADICAL SQUARE': 12101,
'KANGXI RADICAL STAND': 12148,
'KANGXI RADICAL STEAM': 12115,
'KANGXI RADICAL STEP': 12091,
'KANGXI RADICAL STONE': 12143,
'KANGXI RADICAL STOP': 12108,
'KANGXI RADICAL STOPPING': 12169,
'KANGXI RADICAL SUN': 12103,
'KANGXI RADICAL SWEET': 12130,
'KANGXI RADICAL TABLE': 12047,
'KANGXI RADICAL TALL': 12220,
'KANGXI RADICAL TANNED LEATHER': 12209,
'KANGXI RADICAL TEN': 12055,
'KANGXI RADICAL TIGER': 12172,
'KANGXI RADICAL TILE': 12129,
'KANGXI RADICAL TONGUE': 12166,
'KANGXI RADICAL TOOTH': 12242,
'KANGXI RADICAL TRACK': 12145,
'KANGXI RADICAL TREE': 12106,
'KANGXI RADICAL TRIPOD': 12237,
'KANGXI RADICAL TURBAN': 12081,
'KANGXI RADICAL TURTLE': 12244,
'KANGXI RADICAL TWO': 12038,
'KANGXI RADICAL TWO HANDS': 12086,
'KANGXI RADICAL USE': 12132,
'KANGXI RADICAL VALLEY': 12181,
'KANGXI RADICAL VILLAGE': 12197,
'KANGXI RADICAL WALK': 12193,
'KANGXI RADICAL WALK ENCLOSURE': 12175,
'KANGXI RADICAL WATER': 12116,
'KANGXI RADICAL WEAPON': 12110,
'KANGXI RADICAL WEST': 12177,
'KANGXI RADICAL WHEAT': 12230,
'KANGXI RADICAL WHITE': 12137,
'KANGXI RADICAL WIND': 12213,
'KANGXI RADICAL WINE': 12195,
'KANGXI RADICAL WOMAN': 12069,
'KANGXI RADICAL WORK': 12079,
'KANGXI RADICAL WRAP': 12051,
'KANGXI RADICAL WRONG': 12206,
'KANGXI RADICAL YELLOW': 12232,
'KANNADA AI LENGTH MARK': 3286,
'KANNADA DIGIT EIGHT': 3310,
'KANNADA DIGIT FIVE': 3307,
'KANNADA DIGIT FOUR': 3306,
'KANNADA DIGIT NINE': 3311,
'KANNADA DIGIT ONE': 3303,
'KANNADA DIGIT SEVEN': 3309,
'KANNADA DIGIT SIX': 3308,
'KANNADA DIGIT THREE': 3305,
'KANNADA DIGIT TWO': 3304,
'KANNADA DIGIT ZERO': 3302,
'KANNADA LENGTH MARK': 3285,
'KANNADA LETTER A': 3205,
'KANNADA LETTER AA': 3206,
'KANNADA LETTER AI': 3216,
'KANNADA LETTER AU': 3220,
'KANNADA LETTER BA': 3244,
'KANNADA LETTER BHA': 3245,
'KANNADA LETTER CA': 3226,
'KANNADA LETTER CHA': 3227,
'KANNADA LETTER DA': 3238,
'KANNADA LETTER DDA': 3233,
'KANNADA LETTER DDHA': 3234,
'KANNADA LETTER DHA': 3239,
'KANNADA LETTER E': 3214,
'KANNADA LETTER EE': 3215,
'KANNADA LETTER FA': 3294,
'KANNADA LETTER GA': 3223,
'KANNADA LETTER GHA': 3224,
'KANNADA LETTER HA': 3257,
'KANNADA LETTER I': 3207,
'KANNADA LETTER II': 3208,
'KANNADA LETTER JA': 3228,
'KANNADA LETTER JHA': 3229,
'KANNADA LETTER KA': 3221,
'KANNADA LETTER KHA': 3222,
'KANNADA LETTER LA': 3250,
'KANNADA LETTER LLA': 3251,
'KANNADA LETTER MA': 3246,
'KANNADA LETTER NA': 3240,
'KANNADA LETTER NGA': 3225,
'KANNADA LETTER NNA': 3235,
'KANNADA LETTER NYA': 3230,
'KANNADA LETTER O': 3218,
'KANNADA LETTER OO': 3219,
'KANNADA LETTER PA': 3242,
'KANNADA LETTER PHA': 3243,
'KANNADA LETTER RA': 3248,
'KANNADA LETTER RRA': 3249,
'KANNADA LETTER SA': 3256,
'KANNADA LETTER SHA': 3254,
'KANNADA LETTER SSA': 3255,
'KANNADA LETTER TA': 3236,
'KANNADA LETTER THA': 3237,
'KANNADA LETTER TTA': 3231,
'KANNADA LETTER TTHA': 3232,
'KANNADA LETTER U': 3209,
'KANNADA LETTER UU': 3210,
'KANNADA LETTER VA': 3253,
'KANNADA LETTER VOCALIC L': 3212,
'KANNADA LETTER VOCALIC LL': 3297,
'KANNADA LETTER VOCALIC R': 3211,
'KANNADA LETTER VOCALIC RR': 3296,
'KANNADA LETTER YA': 3247,
'KANNADA SIGN ANUSVARA': 3202,
'KANNADA SIGN AVAGRAHA': 3261,
'KANNADA SIGN JIHVAMULIYA': 3313,
'KANNADA SIGN NUKTA': 3260,
'KANNADA SIGN UPADHMANIYA': 3314,
'KANNADA SIGN VIRAMA': 3277,
'KANNADA SIGN VISARGA': 3203,
'KANNADA VOWEL SIGN AA': 3262,
'KANNADA VOWEL SIGN AI': 3272,
'KANNADA VOWEL SIGN AU': 3276,
'KANNADA VOWEL SIGN E': 3270,
'KANNADA VOWEL SIGN EE': 3271,
'KANNADA VOWEL SIGN I': 3263,
'KANNADA VOWEL SIGN II': 3264,
'KANNADA VOWEL SIGN O': 3274,
'KANNADA VOWEL SIGN OO': 3275,
'KANNADA VOWEL SIGN U': 3265,
'KANNADA VOWEL SIGN UU': 3266,
'KANNADA VOWEL SIGN VOCALIC L': 3298,
'KANNADA VOWEL SIGN VOCALIC LL': 3299,
'KANNADA VOWEL SIGN VOCALIC R': 3267,
'KANNADA VOWEL SIGN VOCALIC RR': 3268,
'KATAKANA DIGRAPH KOTO': 12543,
'KATAKANA ITERATION MARK': 12541,
'KATAKANA LETTER A': 12450,
'KATAKANA LETTER BA': 12496,
'KATAKANA LETTER BE': 12505,
'KATAKANA LETTER BI': 12499,
'KATAKANA LETTER BO': 12508,
'KATAKANA LETTER BU': 12502,
'KATAKANA LETTER DA': 12480,
'KATAKANA LETTER DE': 12487,
'KATAKANA LETTER DI': 12482,
'KATAKANA LETTER DO': 12489,
'KATAKANA LETTER DU': 12485,
'KATAKANA LETTER E': 12456,
'KATAKANA LETTER GA': 12460,
'KATAKANA LETTER GE': 12466,
'KATAKANA LETTER GI': 12462,
'KATAKANA LETTER GO': 12468,
'KATAKANA LETTER GU': 12464,
'KATAKANA LETTER HA': 12495,
'KATAKANA LETTER HE': 12504,
'KATAKANA LETTER HI': 12498,
'KATAKANA LETTER HO': 12507,
'KATAKANA LETTER HU': 12501,
'KATAKANA LETTER I': 12452,
'KATAKANA LETTER KA': 12459,
'KATAKANA LETTER KE': 12465,
'KATAKANA LETTER KI': 12461,
'KATAKANA LETTER KO': 12467,
'KATAKANA LETTER KU': 12463,
'KATAKANA LETTER MA': 12510,
'KATAKANA LETTER ME': 12513,
'KATAKANA LETTER MI': 12511,
'KATAKANA LETTER MO': 12514,
'KATAKANA LETTER MU': 12512,
'KATAKANA LETTER N': 12531,
'KATAKANA LETTER NA': 12490,
'KATAKANA LETTER NE': 12493,
'KATAKANA LETTER NI': 12491,
'KATAKANA LETTER NO': 12494,
'KATAKANA LETTER NU': 12492,
'KATAKANA LETTER O': 12458,
'KATAKANA LETTER PA': 12497,
'KATAKANA LETTER PE': 12506,
'KATAKANA LETTER PI': 12500,
'KATAKANA LETTER PO': 12509,
'KATAKANA LETTER PU': 12503,
'KATAKANA LETTER RA': 12521,
'KATAKANA LETTER RE': 12524,
'KATAKANA LETTER RI': 12522,
'KATAKANA LETTER RO': 12525,
'KATAKANA LETTER RU': 12523,
'KATAKANA LETTER SA': 12469,
'KATAKANA LETTER SE': 12475,
'KATAKANA LETTER SI': 12471,
'KATAKANA LETTER SMALL A': 12449,
'KATAKANA LETTER SMALL E': 12455,
'KATAKANA LETTER SMALL HA': 12789,
'KATAKANA LETTER SMALL HE': 12792,
'KATAKANA LETTER SMALL HI': 12790,
'KATAKANA LETTER SMALL HO': 12793,
'KATAKANA LETTER SMALL HU': 12791,
'KATAKANA LETTER SMALL I': 12451,
'KATAKANA LETTER SMALL KA': 12533,
'KATAKANA LETTER SMALL KE': 12534,
'KATAKANA LETTER SMALL KU': 12784,
'KATAKANA LETTER SMALL MU': 12794,
'KATAKANA LETTER SMALL NU': 12788,
'KATAKANA LETTER SMALL O': 12457,
'KATAKANA LETTER SMALL RA': 12795,
'KATAKANA LETTER SMALL RE': 12798,
'KATAKANA LETTER SMALL RI': 12796,
'KATAKANA LETTER SMALL RO': 12799,
'KATAKANA LETTER SMALL RU': 12797,
'KATAKANA LETTER SMALL SI': 12785,
'KATAKANA LETTER SMALL SU': 12786,
'KATAKANA LETTER SMALL TO': 12787,
'KATAKANA LETTER SMALL TU': 12483,
'KATAKANA LETTER SMALL U': 12453,
'KATAKANA LETTER SMALL WA': 12526,
'KATAKANA LETTER SMALL YA': 12515,
'KATAKANA LETTER SMALL YO': 12519,
'KATAKANA LETTER SMALL YU': 12517,
'KATAKANA LETTER SO': 12477,
'KATAKANA LETTER SU': 12473,
'KATAKANA LETTER TA': 12479,
'KATAKANA LETTER TE': 12486,
'KATAKANA LETTER TI': 12481,
'KATAKANA LETTER TO': 12488,
'KATAKANA LETTER TU': 12484,
'KATAKANA LETTER U': 12454,
'KATAKANA LETTER VA': 12535,
'KATAKANA LETTER VE': 12537,
'KATAKANA LETTER VI': 12536,
'KATAKANA LETTER VO': 12538,
'KATAKANA LETTER VU': 12532,
'KATAKANA LETTER WA': 12527,
'KATAKANA LETTER WE': 12529,
'KATAKANA LETTER WI': 12528,
'KATAKANA LETTER WO': 12530,
'KATAKANA LETTER YA': 12516,
'KATAKANA LETTER YO': 12520,
'KATAKANA LETTER YU': 12518,
'KATAKANA LETTER ZA': 12470,
'KATAKANA LETTER ZE': 12476,
'KATAKANA LETTER ZI': 12472,
'KATAKANA LETTER ZO': 12478,
'KATAKANA LETTER ZU': 12474,
'KATAKANA MIDDLE DOT': 12539,
'KATAKANA VOICED ITERATION MARK': 12542,
'KATAKANA-HIRAGANA DOUBLE HYPHEN': 12448,
'KATAKANA-HIRAGANA PROLONGED SOUND MARK': 12540,
'KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK': 12444,
'KATAKANA-HIRAGANA VOICED SOUND MARK': 12443,
'KAYAH LI DIGIT EIGHT': 43272,
'KAYAH LI DIGIT FIVE': 43269,
'KAYAH LI DIGIT FOUR': 43268,
'KAYAH LI DIGIT NINE': 43273,
'KAYAH LI DIGIT ONE': 43265,
'KAYAH LI DIGIT SEVEN': 43271,
'KAYAH LI DIGIT SIX': 43270,
'KAYAH LI DIGIT THREE': 43267,
'KAYAH LI DIGIT TWO': 43266,
'KAYAH LI DIGIT ZERO': 43264,
'KAYAH LI LETTER A': 43298,
'KAYAH LI LETTER BA': 43289,
'KAYAH LI LETTER CA': 43297,
'KAYAH LI LETTER DA': 43288,
'KAYAH LI LETTER GA': 43276,
'KAYAH LI LETTER HA': 43295,
'KAYAH LI LETTER HTA': 43283,
'KAYAH LI LETTER I': 43300,
'KAYAH LI LETTER KA': 43274,
'KAYAH LI LETTER KHA': 43275,
'KAYAH LI LETTER LA': 43292,
'KAYAH LI LETTER MA': 43287,
'KAYAH LI LETTER NA': 43284,
'KAYAH LI LETTER NGA': 43277,
'KAYAH LI LETTER NYA': 43281,
'KAYAH LI LETTER OE': 43299,
'KAYAH LI LETTER OO': 43301,
'KAYAH LI LETTER PA': 43285,
'KAYAH LI LETTER PHA': 43286,
'KAYAH LI LETTER RA': 43290,
'KAYAH LI LETTER SA': 43278,
'KAYAH LI LETTER SHA': 43279,
'KAYAH LI LETTER TA': 43282,
'KAYAH LI LETTER THA': 43294,
'KAYAH LI LETTER VA': 43296,
'KAYAH LI LETTER WA': 43293,
'KAYAH LI LETTER YA': 43291,
'KAYAH LI LETTER ZA': 43280,
'KAYAH LI SIGN CWI': 43310,
'KAYAH LI SIGN SHYA': 43311,
'KAYAH LI TONE CALYA': 43308,
'KAYAH LI TONE CALYA PLOPHU': 43309,
'KAYAH LI TONE PLOPHU': 43307,
'KAYAH LI VOWEL E': 43303,
'KAYAH LI VOWEL EE': 43305,
'KAYAH LI VOWEL O': 43306,
'KAYAH LI VOWEL U': 43304,
'KAYAH LI VOWEL UE': 43302,
'KELVIN SIGN': 8490,
'KEYBOARD': 9000,
'KHAROSHTHI DIGIT FOUR': 68163,
'KHAROSHTHI DIGIT ONE': 68160,
'KHAROSHTHI DIGIT THREE': 68162,
'KHAROSHTHI DIGIT TWO': 68161,
'KHAROSHTHI LETTER A': 68096,
'KHAROSHTHI LETTER BA': 68134,
'KHAROSHTHI LETTER BHA': 68135,
'KHAROSHTHI LETTER CA': 68117,
'KHAROSHTHI LETTER CHA': 68118,
'KHAROSHTHI LETTER DA': 68129,
'KHAROSHTHI LETTER DDA': 68124,
'KHAROSHTHI LETTER DDHA': 68125,
'KHAROSHTHI LETTER DHA': 68130,
'KHAROSHTHI LETTER GA': 68114,
'KHAROSHTHI LETTER GHA': 68115,
'KHAROSHTHI LETTER HA': 68145,
'KHAROSHTHI LETTER JA': 68119,
'KHAROSHTHI LETTER KA': 68112,
'KHAROSHTHI LETTER KHA': 68113,
'KHAROSHTHI LETTER KKA': 68146,
'KHAROSHTHI LETTER LA': 68139,
'KHAROSHTHI LETTER MA': 68136,
'KHAROSHTHI LETTER NA': 68131,
'KHAROSHTHI LETTER NNA': 68126,
'KHAROSHTHI LETTER NYA': 68121,
'KHAROSHTHI LETTER PA': 68132,
'KHAROSHTHI LETTER PHA': 68133,
'KHAROSHTHI LETTER RA': 68138,
'KHAROSHTHI LETTER SA': 68143,
'KHAROSHTHI LETTER SHA': 68141,
'KHAROSHTHI LETTER SSA': 68142,
'KHAROSHTHI LETTER TA': 68127,
'KHAROSHTHI LETTER THA': 68128,
'KHAROSHTHI LETTER TTA': 68122,
'KHAROSHTHI LETTER TTHA': 68123,
'KHAROSHTHI LETTER TTTHA': 68147,
'KHAROSHTHI LETTER VA': 68140,
'KHAROSHTHI LETTER YA': 68137,
'KHAROSHTHI LETTER ZA': 68144,
'KHAROSHTHI NUMBER ONE HUNDRED': 68166,
'KHAROSHTHI NUMBER ONE THOUSAND': 68167,
'KHAROSHTHI NUMBER TEN': 68164,
'KHAROSHTHI NUMBER TWENTY': 68165,
'KHAROSHTHI PUNCTUATION CIRCLE': 68178,
'KHAROSHTHI PUNCTUATION CRESCENT BAR': 68179,
'KHAROSHTHI PUNCTUATION DANDA': 68182,
'KHAROSHTHI PUNCTUATION DOT': 68176,
'KHAROSHTHI PUNCTUATION DOUBLE DANDA': 68183,
'KHAROSHTHI PUNCTUATION LINES': 68184,
'KHAROSHTHI PUNCTUATION LOTUS': 68181,
'KHAROSHTHI PUNCTUATION MANGALAM': 68180,
'KHAROSHTHI PUNCTUATION SMALL CIRCLE': 68177,
'KHAROSHTHI SIGN ANUSVARA': 68110,
'KHAROSHTHI SIGN BAR ABOVE': 68152,
'KHAROSHTHI SIGN CAUDA': 68153,
'KHAROSHTHI SIGN DOT BELOW': 68154,
'KHAROSHTHI SIGN DOUBLE RING BELOW': 68109,
'KHAROSHTHI SIGN VISARGA': 68111,
'KHAROSHTHI VIRAMA': 68159,
'KHAROSHTHI VOWEL LENGTH MARK': 68108,
'KHAROSHTHI VOWEL SIGN E': 68101,
'KHAROSHTHI VOWEL SIGN I': 68097,
'KHAROSHTHI VOWEL SIGN O': 68102,
'KHAROSHTHI VOWEL SIGN U': 68098,
'KHAROSHTHI VOWEL SIGN VOCALIC R': 68099,
'KHMER CURRENCY SYMBOL RIEL': 6107,
'KHMER DIGIT EIGHT': 6120,
'KHMER DIGIT FIVE': 6117,
'KHMER DIGIT FOUR': 6116,
'KHMER DIGIT NINE': 6121,
'KHMER DIGIT ONE': 6113,
'KHMER DIGIT SEVEN': 6119,
'KHMER DIGIT SIX': 6118,
'KHMER DIGIT THREE': 6115,
'KHMER DIGIT TWO': 6114,
'KHMER DIGIT ZERO': 6112,
'KHMER INDEPENDENT VOWEL LY': 6061,
'KHMER INDEPENDENT VOWEL LYY': 6062,
'KHMER INDEPENDENT VOWEL QAA': 6052,
'KHMER INDEPENDENT VOWEL QAI': 6064,
'KHMER INDEPENDENT VOWEL QAQ': 6051,
'KHMER INDEPENDENT VOWEL QAU': 6067,
'KHMER INDEPENDENT VOWEL QE': 6063,
'KHMER INDEPENDENT VOWEL QI': 6053,
'KHMER INDEPENDENT VOWEL QII': 6054,
'KHMER INDEPENDENT VOWEL QOO TYPE ONE': 6065,
'KHMER INDEPENDENT VOWEL QOO TYPE TWO': 6066,
'KHMER INDEPENDENT VOWEL QU': 6055,
'KHMER INDEPENDENT VOWEL QUK': 6056,
'KHMER INDEPENDENT VOWEL QUU': 6057,
'KHMER INDEPENDENT VOWEL QUUV': 6058,
'KHMER INDEPENDENT VOWEL RY': 6059,
'KHMER INDEPENDENT VOWEL RYY': 6060,
'KHMER LETTER BA': 6036,
'KHMER LETTER CA': 6021,
'KHMER LETTER CHA': 6022,
'KHMER LETTER CHO': 6024,
'KHMER LETTER CO': 6023,
'KHMER LETTER DA': 6026,
'KHMER LETTER DO': 6028,
'KHMER LETTER HA': 6048,
'KHMER LETTER KA': 6016,
'KHMER LETTER KHA': 6017,
'KHMER LETTER KHO': 6019,
'KHMER LETTER KO': 6018,
'KHMER LETTER LA': 6049,
'KHMER LETTER LO': 6043,
'KHMER LETTER MO': 6040,
'KHMER LETTER NGO': 6020,
'KHMER LETTER NNO': 6030,
'KHMER LETTER NO': 6035,
'KHMER LETTER NYO': 6025,
'KHMER LETTER PHA': 6037,
'KHMER LETTER PHO': 6039,
'KHMER LETTER PO': 6038,
'KHMER LETTER QA': 6050,
'KHMER LETTER RO': 6042,
'KHMER LETTER SA': 6047,
'KHMER LETTER SHA': 6045,
'KHMER LETTER SSO': 6046,
'KHMER LETTER TA': 6031,
'KHMER LETTER THA': 6032,
'KHMER LETTER THO': 6034,
'KHMER LETTER TO': 6033,
'KHMER LETTER TTHA': 6027,
'KHMER LETTER TTHO': 6029,
'KHMER LETTER VO': 6044,
'KHMER LETTER YO': 6041,
'KHMER SIGN AHSDA': 6095,
'KHMER SIGN ATTHACAN': 6109,
'KHMER SIGN AVAKRAHASANYA': 6108,
'KHMER SIGN BANTOC': 6091,
'KHMER SIGN BARIYOOSAN': 6101,
'KHMER SIGN BATHAMASAT': 6099,
'KHMER SIGN BEYYAL': 6104,
'KHMER SIGN CAMNUC PII KUUH': 6102,
'KHMER SIGN COENG': 6098,
'KHMER SIGN KAKABAT': 6094,
'KHMER SIGN KHAN': 6100,
'KHMER SIGN KOOMUUT': 6106,
'KHMER SIGN LEK TOO': 6103,
'KHMER SIGN MUUSIKATOAN': 6089,
'KHMER SIGN NIKAHIT': 6086,
'KHMER SIGN PHNAEK MUAN': 6105,
'KHMER SIGN REAHMUK': 6087,
'KHMER SIGN ROBAT': 6092,
'KHMER SIGN SAMYOK SANNYA': 6096,
'KHMER SIGN TOANDAKHIAT': 6093,
'KHMER SIGN TRIISAP': 6090,
'KHMER SIGN VIRIAM': 6097,
'KHMER SIGN YUUKALEAPINTU': 6088,
'KHMER SYMBOL BEI KOET': 6627,
'KHMER SYMBOL BEI ROC': 6643,
'KHMER SYMBOL BUON KOET': 6628,
'KHMER SYMBOL BUON ROC': 6644,
'KHMER SYMBOL DAP KOET': 6634,
'KHMER SYMBOL DAP ROC': 6650,
'KHMER SYMBOL DAP-BEI KOET': 6637,
'KHMER SYMBOL DAP-BEI ROC': 6653,
'KHMER SYMBOL DAP-BUON KOET': 6638,
'KHMER SYMBOL DAP-BUON ROC': 6654,
'KHMER SYMBOL DAP-MUOY KOET': 6635,
'KHMER SYMBOL DAP-MUOY ROC': 6651,
'KHMER SYMBOL DAP-PII KOET': 6636,
'KHMER SYMBOL DAP-PII ROC': 6652,
'KHMER SYMBOL DAP-PRAM KOET': 6639,
'KHMER SYMBOL DAP-PRAM ROC': 6655,
'KHMER SYMBOL LEK ATTAK BEI': 6131,
'KHMER SYMBOL LEK ATTAK BUON': 6132,
'KHMER SYMBOL LEK ATTAK MUOY': 6129,
'KHMER SYMBOL LEK ATTAK PII': 6130,
'KHMER SYMBOL LEK ATTAK PRAM': 6133,
'KHMER SYMBOL LEK ATTAK PRAM-BEI': 6136,
'KHMER SYMBOL LEK ATTAK PRAM-BUON': 6137,
'KHMER SYMBOL LEK ATTAK PRAM-MUOY': 6134,
'KHMER SYMBOL LEK ATTAK PRAM-PII': 6135,
'KHMER SYMBOL LEK ATTAK SON': 6128,
'KHMER SYMBOL MUOY KOET': 6625,
'KHMER SYMBOL MUOY ROC': 6641,
'KHMER SYMBOL PATHAMASAT': 6624,
'KHMER SYMBOL PII KOET': 6626,
'KHMER SYMBOL PII ROC': 6642,
'KHMER SYMBOL PRAM KOET': 6629,
'KHMER SYMBOL PRAM ROC': 6645,
'KHMER SYMBOL PRAM-BEI KOET': 6632,
'KHMER SYMBOL PRAM-BEI ROC': 6648,
'KHMER SYMBOL PRAM-BUON KOET': 6633,
'KHMER SYMBOL PRAM-BUON ROC': 6649,
'KHMER SYMBOL PRAM-MUOY KOET': 6630,
'KHMER SYMBOL PRAM-MUOY ROC': 6646,
'KHMER SYMBOL PRAM-PII KOET': 6631,
'KHMER SYMBOL PRAM-PII ROC': 6647,
'KHMER SYMBOL TUTEYASAT': 6640,
'KHMER VOWEL INHERENT AA': 6069,
'KHMER VOWEL INHERENT AQ': 6068,
'KHMER VOWEL SIGN AA': 6070,
'KHMER VOWEL SIGN AE': 6082,
'KHMER VOWEL SIGN AI': 6083,
'KHMER VOWEL SIGN AU': 6085,
'KHMER VOWEL SIGN E': 6081,
'KHMER VOWEL SIGN I': 6071,
'KHMER VOWEL SIGN IE': 6080,
'KHMER VOWEL SIGN II': 6072,
'KHMER VOWEL SIGN OE': 6078,
'KHMER VOWEL SIGN OO': 6084,
'KHMER VOWEL SIGN U': 6075,
'KHMER VOWEL SIGN UA': 6077,
'KHMER VOWEL SIGN UU': 6076,
'KHMER VOWEL SIGN Y': 6073,
'KHMER VOWEL SIGN YA': 6079,
'KHMER VOWEL SIGN YY': 6074,
'KIP SIGN': 8365,
'KOREAN STANDARD SYMBOL': 12927,
'L B BAR SYMBOL': 8468,
'LANGUAGE TAG': 917505,
'LAO CANCELLATION MARK': 3788,
'LAO DIGIT EIGHT': 3800,
'LAO DIGIT FIVE': 3797,
'LAO DIGIT FOUR': 3796,
'LAO DIGIT NINE': 3801,
'LAO DIGIT ONE': 3793,
'LAO DIGIT SEVEN': 3799,
'LAO DIGIT SIX': 3798,
'LAO DIGIT THREE': 3795,
'LAO DIGIT TWO': 3794,
'LAO DIGIT ZERO': 3792,
'LAO ELLIPSIS': 3759,
'LAO HO MO': 3805,
'LAO HO NO': 3804,
'LAO KO LA': 3782,
'LAO LETTER BO': 3738,
'LAO LETTER CO': 3720,
'LAO LETTER DO': 3732,
'LAO LETTER FO SUNG': 3743,
'LAO LETTER FO TAM': 3741,
'LAO LETTER HO SUNG': 3755,
'LAO LETTER HO TAM': 3758,
'LAO LETTER KHO SUNG': 3714,
'LAO LETTER KHO TAM': 3716,
'LAO LETTER KO': 3713,
'LAO LETTER LO LING': 3747,
'LAO LETTER LO LOOT': 3749,
'LAO LETTER MO': 3745,
'LAO LETTER NGO': 3719,
'LAO LETTER NO': 3737,
'LAO LETTER NYO': 3725,
'LAO LETTER O': 3757,
'LAO LETTER PHO SUNG': 3740,
'LAO LETTER PHO TAM': 3742,
'LAO LETTER PO': 3739,
'LAO LETTER SO SUNG': 3754,
'LAO LETTER SO TAM': 3722,
'LAO LETTER THO SUNG': 3734,
'LAO LETTER THO TAM': 3735,
'LAO LETTER TO': 3733,
'LAO LETTER WO': 3751,
'LAO LETTER YO': 3746,
'LAO NIGGAHITA': 3789,
'LAO SEMIVOWEL SIGN LO': 3772,
'LAO SEMIVOWEL SIGN NYO': 3773,
'LAO TONE MAI CATAWA': 3787,
'LAO TONE MAI EK': 3784,
'LAO TONE MAI THO': 3785,
'LAO TONE MAI TI': 3786,
'LAO VOWEL SIGN A': 3760,
'LAO VOWEL SIGN AA': 3762,
'LAO VOWEL SIGN AI': 3780,
'LAO VOWEL SIGN AM': 3763,
'LAO VOWEL SIGN AY': 3779,
'LAO VOWEL SIGN E': 3776,
'LAO VOWEL SIGN EI': 3777,
'LAO VOWEL SIGN I': 3764,
'LAO VOWEL SIGN II': 3765,
'LAO VOWEL SIGN MAI KAN': 3761,
'LAO VOWEL SIGN MAI KON': 3771,
'LAO VOWEL SIGN O': 3778,
'LAO VOWEL SIGN U': 3768,
'LAO VOWEL SIGN UU': 3769,
'LAO VOWEL SIGN Y': 3766,
'LAO VOWEL SIGN YY': 3767,
'LARGE CIRCLE': 9711,
'LARGE DOWN TACK': 10201,
'LARGE LEFT TRIANGLE OPERATOR': 10782,
'LARGE ONE DOT OVER TWO DOTS PUNCTUATION': 68413,
'LARGE ONE RING OVER TWO RINGS PUNCTUATION': 68415,
'LARGE TRIPLE VERTICAL BAR OPERATOR': 11004,
'LARGE TWO DOTS OVER ONE DOT PUNCTUATION': 68412,
'LARGE TWO RINGS OVER ONE RING PUNCTUATION': 68414,
'LARGE UP TACK': 10200,
'LARGER THAN': 10923,
'LARGER THAN OR EQUAL TO': 10925,
'LAST QUARTER MOON': 9790,
'LATIN CAPITAL LETTER A': 65,
'LATIN CAPITAL LETTER A WITH ACUTE': 193,
'LATIN CAPITAL LETTER A WITH BREVE': 258,
'LATIN CAPITAL LETTER A WITH BREVE AND ACUTE': 7854,
'LATIN CAPITAL LETTER A WITH BREVE AND DOT BELOW': 7862,
'LATIN CAPITAL LETTER A WITH BREVE AND GRAVE': 7856,
'LATIN CAPITAL LETTER A WITH BREVE AND HOOK ABOVE': 7858,
'LATIN CAPITAL LETTER A WITH BREVE AND TILDE': 7860,
'LATIN CAPITAL LETTER A WITH CARON': 461,
'LATIN CAPITAL LETTER A WITH CIRCUMFLEX': 194,
'LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND ACUTE': 7844,
'LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND DOT BELOW': 7852,
'LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND GRAVE': 7846,
'LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE': 7848,
'LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND TILDE': 7850,
'LATIN CAPITAL LETTER A WITH DIAERESIS': 196,
'LATIN CAPITAL LETTER A WITH DIAERESIS AND MACRON': 478,
'LATIN CAPITAL LETTER A WITH DOT ABOVE': 550,
'LATIN CAPITAL LETTER A WITH DOT ABOVE AND MACRON': 480,
'LATIN CAPITAL LETTER A WITH DOT BELOW': 7840,
'LATIN CAPITAL LETTER A WITH DOUBLE GRAVE': 512,
'LATIN CAPITAL LETTER A WITH GRAVE': 192,
'LATIN CAPITAL LETTER A WITH HOOK ABOVE': 7842,
'LATIN CAPITAL LETTER A WITH INVERTED BREVE': 514,
'LATIN CAPITAL LETTER A WITH MACRON': 256,
'LATIN CAPITAL LETTER A WITH OGONEK': 260,
'LATIN CAPITAL LETTER A WITH RING ABOVE': 197,
'LATIN CAPITAL LETTER A WITH RING ABOVE AND ACUTE': 506,
'LATIN CAPITAL LETTER A WITH RING BELOW': 7680,
'LATIN CAPITAL LETTER A WITH STROKE': 570,
'LATIN CAPITAL LETTER A WITH TILDE': 195,
'LATIN CAPITAL LETTER AA': 42802,
'LATIN CAPITAL LETTER AE': 198,
'LATIN CAPITAL LETTER AE WITH ACUTE': 508,
'LATIN CAPITAL LETTER AE WITH MACRON': 482,
'LATIN CAPITAL LETTER AFRICAN D': 393,
'LATIN CAPITAL LETTER ALPHA': 11373,
'LATIN CAPITAL LETTER AO': 42804,
'LATIN CAPITAL LETTER AU': 42806,
'LATIN CAPITAL LETTER AV': 42808,
'LATIN CAPITAL LETTER AV WITH HORIZONTAL BAR': 42810,
'LATIN CAPITAL LETTER AY': 42812,
'LATIN CAPITAL LETTER B': 66,
'LATIN CAPITAL LETTER B WITH DOT ABOVE': 7682,
'LATIN CAPITAL LETTER B WITH DOT BELOW': 7684,
'LATIN CAPITAL LETTER B WITH HOOK': 385,
'LATIN CAPITAL LETTER B WITH LINE BELOW': 7686,
'LATIN CAPITAL LETTER B WITH STROKE': 579,
'LATIN CAPITAL LETTER B WITH TOPBAR': 386,
'LATIN CAPITAL LETTER BROKEN L': 42822,
'LATIN CAPITAL LETTER C': 67,
'LATIN CAPITAL LETTER C WITH ACUTE': 262,
'LATIN CAPITAL LETTER C WITH CARON': 268,
'LATIN CAPITAL LETTER C WITH CEDILLA': 199,
'LATIN CAPITAL LETTER C WITH CEDILLA AND ACUTE': 7688,
'LATIN CAPITAL LETTER C WITH CIRCUMFLEX': 264,
'LATIN CAPITAL LETTER C WITH DOT ABOVE': 266,
'LATIN CAPITAL LETTER C WITH HOOK': 391,
'LATIN CAPITAL LETTER C WITH STROKE': 571,
'LATIN CAPITAL LETTER CON': 42862,
'LATIN CAPITAL LETTER CUATRILLO': 42796,
'LATIN CAPITAL LETTER CUATRILLO WITH COMMA': 42798,
'LATIN CAPITAL LETTER D': 68,
'LATIN CAPITAL LETTER D WITH CARON': 270,
'LATIN CAPITAL LETTER D WITH CEDILLA': 7696,
'LATIN CAPITAL LETTER D WITH CIRCUMFLEX BELOW': 7698,
'LATIN CAPITAL LETTER D WITH DOT ABOVE': 7690,
'LATIN CAPITAL LETTER D WITH DOT BELOW': 7692,
'LATIN CAPITAL LETTER D WITH HOOK': 394,
'LATIN CAPITAL LETTER D WITH LINE BELOW': 7694,
'LATIN CAPITAL LETTER D WITH SMALL LETTER Z': 498,
'LATIN CAPITAL LETTER D WITH SMALL LETTER Z WITH CARON': 453,
'LATIN CAPITAL LETTER D WITH STROKE': 272,
'LATIN CAPITAL LETTER D WITH TOPBAR': 395,
'LATIN CAPITAL LETTER DZ': 497,
'LATIN CAPITAL LETTER DZ WITH CARON': 452,
'LATIN CAPITAL LETTER E': 69,
'LATIN CAPITAL LETTER E WITH ACUTE': 201,
'LATIN CAPITAL LETTER E WITH BREVE': 276,
'LATIN CAPITAL LETTER E WITH CARON': 282,
'LATIN CAPITAL LETTER E WITH CEDILLA': 552,
'LATIN CAPITAL LETTER E WITH CEDILLA AND BREVE': 7708,
'LATIN CAPITAL LETTER E WITH CIRCUMFLEX': 202,
'LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND ACUTE': 7870,
'LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND DOT BELOW': 7878,
'LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND GRAVE': 7872,
'LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND HOOK ABOVE': 7874,
'LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND TILDE': 7876,
'LATIN CAPITAL LETTER E WITH CIRCUMFLEX BELOW': 7704,
'LATIN CAPITAL LETTER E WITH DIAERESIS': 203,
'LATIN CAPITAL LETTER E WITH DOT ABOVE': 278,
'LATIN CAPITAL LETTER E WITH DOT BELOW': 7864,
'LATIN CAPITAL LETTER E WITH DOUBLE GRAVE': 516,
'LATIN CAPITAL LETTER E WITH GRAVE': 200,
'LATIN CAPITAL LETTER E WITH HOOK ABOVE': 7866,
'LATIN CAPITAL LETTER E WITH INVERTED BREVE': 518,
'LATIN CAPITAL LETTER E WITH MACRON': 274,
'LATIN CAPITAL LETTER E WITH MACRON AND ACUTE': 7702,
'LATIN CAPITAL LETTER E WITH MACRON AND GRAVE': 7700,
'LATIN CAPITAL LETTER E WITH OGONEK': 280,
'LATIN CAPITAL LETTER E WITH STROKE': 582,
'LATIN CAPITAL LETTER E WITH TILDE': 7868,
'LATIN CAPITAL LETTER E WITH TILDE BELOW': 7706,
'LATIN CAPITAL LETTER EGYPTOLOGICAL AIN': 42788,
'LATIN CAPITAL LETTER EGYPTOLOGICAL ALEF': 42786,
'LATIN CAPITAL LETTER ENG': 330,
'LATIN CAPITAL LETTER ESH': 425,
'LATIN CAPITAL LETTER ET': 42858,
'LATIN CAPITAL LETTER ETH': 208,
'LATIN CAPITAL LETTER EZH': 439,
'LATIN CAPITAL LETTER EZH REVERSED': 440,
'LATIN CAPITAL LETTER EZH WITH CARON': 494,
'LATIN CAPITAL LETTER F': 70,
'LATIN CAPITAL LETTER F WITH DOT ABOVE': 7710,
'LATIN CAPITAL LETTER F WITH HOOK': 401,
'LATIN CAPITAL LETTER G': 71,
'LATIN CAPITAL LETTER G WITH ACUTE': 500,
'LATIN CAPITAL LETTER G WITH BREVE': 286,
'LATIN CAPITAL LETTER G WITH CARON': 486,
'LATIN CAPITAL LETTER G WITH CEDILLA': 290,
'LATIN CAPITAL LETTER G WITH CIRCUMFLEX': 284,
'LATIN CAPITAL LETTER G WITH DOT ABOVE': 288,
'LATIN CAPITAL LETTER G WITH HOOK': 403,
'LATIN CAPITAL LETTER G WITH MACRON': 7712,
'LATIN CAPITAL LETTER G WITH STROKE': 484,
'LATIN CAPITAL LETTER GAMMA': 404,
'LATIN CAPITAL LETTER GLOTTAL STOP': 577,
'LATIN CAPITAL LETTER H': 72,
'LATIN CAPITAL LETTER H WITH BREVE BELOW': 7722,
'LATIN CAPITAL LETTER H WITH CARON': 542,
'LATIN CAPITAL LETTER H WITH CEDILLA': 7720,
'LATIN CAPITAL LETTER H WITH CIRCUMFLEX': 292,
'LATIN CAPITAL LETTER H WITH DESCENDER': 11367,
'LATIN CAPITAL LETTER H WITH DIAERESIS': 7718,
'LATIN CAPITAL LETTER H WITH DOT ABOVE': 7714,
'LATIN CAPITAL LETTER H WITH DOT BELOW': 7716,
'LATIN CAPITAL LETTER H WITH STROKE': 294,
'LATIN CAPITAL LETTER HALF H': 11381,
'LATIN CAPITAL LETTER HENG': 42790,
'LATIN CAPITAL LETTER HWAIR': 502,
'LATIN CAPITAL LETTER I': 73,
'LATIN CAPITAL LETTER I WITH ACUTE': 205,
'LATIN CAPITAL LETTER I WITH BREVE': 300,
'LATIN CAPITAL LETTER I WITH CARON': 463,
'LATIN CAPITAL LETTER I WITH CIRCUMFLEX': 206,
'LATIN CAPITAL LETTER I WITH DIAERESIS': 207,
'LATIN CAPITAL LETTER I WITH DIAERESIS AND ACUTE': 7726,
'LATIN CAPITAL LETTER I WITH DOT ABOVE': 304,
'LATIN CAPITAL LETTER I WITH DOT BELOW': 7882,
'LATIN CAPITAL LETTER I WITH DOUBLE GRAVE': 520,
'LATIN CAPITAL LETTER I WITH GRAVE': 204,
'LATIN CAPITAL LETTER I WITH HOOK ABOVE': 7880,
'LATIN CAPITAL LETTER I WITH INVERTED BREVE': 522,
'LATIN CAPITAL LETTER I WITH MACRON': 298,
'LATIN CAPITAL LETTER I WITH OGONEK': 302,
'LATIN CAPITAL LETTER I WITH STROKE': 407,
'LATIN CAPITAL LETTER I WITH TILDE': 296,
'LATIN CAPITAL LETTER I WITH TILDE BELOW': 7724,
'LATIN CAPITAL LETTER INSULAR D': 42873,
'LATIN CAPITAL LETTER INSULAR F': 42875,
'LATIN CAPITAL LETTER INSULAR G': 42877,
'LATIN CAPITAL LETTER INSULAR R': 42882,
'LATIN CAPITAL LETTER INSULAR S': 42884,
'LATIN CAPITAL LETTER INSULAR T': 42886,
'LATIN CAPITAL LETTER IOTA': 406,
'LATIN CAPITAL LETTER IS': 42860,
'LATIN CAPITAL LETTER J': 74,
'LATIN CAPITAL LETTER J WITH CIRCUMFLEX': 308,
'LATIN CAPITAL LETTER J WITH STROKE': 584,
'LATIN CAPITAL LETTER K': 75,
'LATIN CAPITAL LETTER K WITH ACUTE': 7728,
'LATIN CAPITAL LETTER K WITH CARON': 488,
'LATIN CAPITAL LETTER K WITH CEDILLA': 310,
'LATIN CAPITAL LETTER K WITH DESCENDER': 11369,
'LATIN CAPITAL LETTER K WITH DIAGONAL STROKE': 42818,
'LATIN CAPITAL LETTER K WITH DOT BELOW': 7730,
'LATIN CAPITAL LETTER K WITH HOOK': 408,
'LATIN CAPITAL LETTER K WITH LINE BELOW': 7732,
'LATIN CAPITAL LETTER K WITH STROKE': 42816,
'LATIN CAPITAL LETTER K WITH STROKE AND DIAGONAL STROKE': 42820,
'LATIN CAPITAL LETTER L': 76,
'LATIN CAPITAL LETTER L WITH ACUTE': 313,
'LATIN CAPITAL LETTER L WITH BAR': 573,
'LATIN CAPITAL LETTER L WITH CARON': 317,
'LATIN CAPITAL LETTER L WITH CEDILLA': 315,
'LATIN CAPITAL LETTER L WITH CIRCUMFLEX BELOW': 7740,
'LATIN CAPITAL LETTER L WITH DOT BELOW': 7734,
'LATIN CAPITAL LETTER L WITH DOT BELOW AND MACRON': 7736,
'LATIN CAPITAL LETTER L WITH DOUBLE BAR': 11360,
'LATIN CAPITAL LETTER L WITH HIGH STROKE': 42824,
'LATIN CAPITAL LETTER L WITH LINE BELOW': 7738,
'LATIN CAPITAL LETTER L WITH MIDDLE DOT': 319,
'LATIN CAPITAL LETTER L WITH MIDDLE TILDE': 11362,
'LATIN CAPITAL LETTER L WITH SMALL LETTER J': 456,
'LATIN CAPITAL LETTER L WITH STROKE': 321,
'LATIN CAPITAL LETTER LJ': 455,
'LATIN CAPITAL LETTER M': 77,
'LATIN CAPITAL LETTER M WITH ACUTE': 7742,
'LATIN CAPITAL LETTER M WITH DOT ABOVE': 7744,
'LATIN CAPITAL LETTER M WITH DOT BELOW': 7746,
'LATIN CAPITAL LETTER M WITH HOOK': 11374,
'LATIN CAPITAL LETTER MIDDLE-WELSH LL': 7930,
'LATIN CAPITAL LETTER MIDDLE-WELSH V': 7932,
'LATIN CAPITAL LETTER N': 78,
'LATIN CAPITAL LETTER N WITH ACUTE': 323,
'LATIN CAPITAL LETTER N WITH CARON': 327,
'LATIN CAPITAL LETTER N WITH CEDILLA': 325,
'LATIN CAPITAL LETTER N WITH CIRCUMFLEX BELOW': 7754,
'LATIN CAPITAL LETTER N WITH DOT ABOVE': 7748,
'LATIN CAPITAL LETTER N WITH DOT BELOW': 7750,
'LATIN CAPITAL LETTER N WITH GRAVE': 504,
'LATIN CAPITAL LETTER N WITH LEFT HOOK': 413,
'LATIN CAPITAL LETTER N WITH LINE BELOW': 7752,
'LATIN CAPITAL LETTER N WITH LONG RIGHT LEG': 544,
'LATIN CAPITAL LETTER N WITH SMALL LETTER J': 459,
'LATIN CAPITAL LETTER N WITH TILDE': 209,
'LATIN CAPITAL LETTER NJ': 458,
'LATIN CAPITAL LETTER O': 79,
'LATIN CAPITAL LETTER O WITH ACUTE': 211,
'LATIN CAPITAL LETTER O WITH BREVE': 334,
'LATIN CAPITAL LETTER O WITH CARON': 465,
'LATIN CAPITAL LETTER O WITH CIRCUMFLEX': 212,
'LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND ACUTE': 7888,
'LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND DOT BELOW': 7896,
'LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND GRAVE': 7890,
'LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE': 7892,
'LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND TILDE': 7894,
'LATIN CAPITAL LETTER O WITH DIAERESIS': 214,
'LATIN CAPITAL LETTER O WITH DIAERESIS AND MACRON': 554,
'LATIN CAPITAL LETTER O WITH DOT ABOVE': 558,
'LATIN CAPITAL LETTER O WITH DOT ABOVE AND MACRON': 560,
'LATIN CAPITAL LETTER O WITH DOT BELOW': 7884,
'LATIN CAPITAL LETTER O WITH DOUBLE ACUTE': 336,
'LATIN CAPITAL LETTER O WITH DOUBLE GRAVE': 524,
'LATIN CAPITAL LETTER O WITH GRAVE': 210,
'LATIN CAPITAL LETTER O WITH HOOK ABOVE': 7886,
'LATIN CAPITAL LETTER O WITH HORN': 416,
'LATIN CAPITAL LETTER O WITH HORN AND ACUTE': 7898,
'LATIN CAPITAL LETTER O WITH HORN AND DOT BELOW': 7906,
'LATIN CAPITAL LETTER O WITH HORN AND GRAVE': 7900,
'LATIN CAPITAL LETTER O WITH HORN AND HOOK ABOVE': 7902,
'LATIN CAPITAL LETTER O WITH HORN AND TILDE': 7904,
'LATIN CAPITAL LETTER O WITH INVERTED BREVE': 526,
'LATIN CAPITAL LETTER O WITH LONG STROKE OVERLAY': 42826,
'LATIN CAPITAL LETTER O WITH LOOP': 42828,
'LATIN CAPITAL LETTER O WITH MACRON': 332,
'LATIN CAPITAL LETTER O WITH MACRON AND ACUTE': 7762,
'LATIN CAPITAL LETTER O WITH MACRON AND GRAVE': 7760,
'LATIN CAPITAL LETTER O WITH MIDDLE TILDE': 415,
'LATIN CAPITAL LETTER O WITH OGONEK': 490,
'LATIN CAPITAL LETTER O WITH OGONEK AND MACRON': 492,
'LATIN CAPITAL LETTER O WITH STROKE': 216,
'LATIN CAPITAL LETTER O WITH STROKE AND ACUTE': 510,
'LATIN CAPITAL LETTER O WITH TILDE': 213,
'LATIN CAPITAL LETTER O WITH TILDE AND ACUTE': 7756,
'LATIN CAPITAL LETTER O WITH TILDE AND DIAERESIS': 7758,
'LATIN CAPITAL LETTER O WITH TILDE AND MACRON': 556,
'LATIN CAPITAL LETTER OI': 418,
'LATIN CAPITAL LETTER OO': 42830,
'LATIN CAPITAL LETTER OPEN E': 400,
'LATIN CAPITAL LETTER OPEN O': 390,
'LATIN CAPITAL LETTER OU': 546,
'LATIN CAPITAL LETTER P': 80,
'LATIN CAPITAL LETTER P WITH ACUTE': 7764,
'LATIN CAPITAL LETTER P WITH DOT ABOVE': 7766,
'LATIN CAPITAL LETTER P WITH FLOURISH': 42834,
'LATIN CAPITAL LETTER P WITH HOOK': 420,
'LATIN CAPITAL LETTER P WITH SQUIRREL TAIL': 42836,
'LATIN CAPITAL LETTER P WITH STROKE': 11363,
'LATIN CAPITAL LETTER P WITH STROKE THROUGH DESCENDER': 42832,
'LATIN CAPITAL LETTER Q': 81,
'LATIN CAPITAL LETTER Q WITH DIAGONAL STROKE': 42840,
'LATIN CAPITAL LETTER Q WITH STROKE THROUGH DESCENDER': 42838,
'LATIN CAPITAL LETTER R': 82,
'LATIN CAPITAL LETTER R ROTUNDA': 42842,
'LATIN CAPITAL LETTER R WITH ACUTE': 340,
'LATIN CAPITAL LETTER R WITH CARON': 344,
'LATIN CAPITAL LETTER R WITH CEDILLA': 342,
'LATIN CAPITAL LETTER R WITH DOT ABOVE': 7768,
'LATIN CAPITAL LETTER R WITH DOT BELOW': 7770,
'LATIN CAPITAL LETTER R WITH DOT BELOW AND MACRON': 7772,
'LATIN CAPITAL LETTER R WITH DOUBLE GRAVE': 528,
'LATIN CAPITAL LETTER R WITH INVERTED BREVE': 530,
'LATIN CAPITAL LETTER R WITH LINE BELOW': 7774,
'LATIN CAPITAL LETTER R WITH STROKE': 588,
'LATIN CAPITAL LETTER R WITH TAIL': 11364,
'LATIN CAPITAL LETTER REVERSED C WITH DOT': 42814,
'LATIN CAPITAL LETTER REVERSED E': 398,
'LATIN CAPITAL LETTER RUM ROTUNDA': 42844,
'LATIN CAPITAL LETTER S': 83,
'LATIN CAPITAL LETTER S WITH ACUTE': 346,
'LATIN CAPITAL LETTER S WITH ACUTE AND DOT ABOVE': 7780,
'LATIN CAPITAL LETTER S WITH CARON': 352,
'LATIN CAPITAL LETTER S WITH CARON AND DOT ABOVE': 7782,
'LATIN CAPITAL LETTER S WITH CEDILLA': 350,
'LATIN CAPITAL LETTER S WITH CIRCUMFLEX': 348,
'LATIN CAPITAL LETTER S WITH COMMA BELOW': 536,
'LATIN CAPITAL LETTER S WITH DOT ABOVE': 7776,
'LATIN CAPITAL LETTER S WITH DOT BELOW': 7778,
'LATIN CAPITAL LETTER S WITH DOT BELOW AND DOT ABOVE': 7784,
'LATIN CAPITAL LETTER S WITH SWASH TAIL': 11390,
'LATIN CAPITAL LETTER SALTILLO': 42891,
'LATIN CAPITAL LETTER SCHWA': 399,
'LATIN CAPITAL LETTER SHARP S': 7838,
'LATIN CAPITAL LETTER SMALL Q WITH HOOK TAIL': 586,
'LATIN CAPITAL LETTER T': 84,
'LATIN CAPITAL LETTER T WITH CARON': 356,
'LATIN CAPITAL LETTER T WITH CEDILLA': 354,
'LATIN CAPITAL LETTER T WITH CIRCUMFLEX BELOW': 7792,
'LATIN CAPITAL LETTER T WITH COMMA BELOW': 538,
'LATIN CAPITAL LETTER T WITH DIAGONAL STROKE': 574,
'LATIN CAPITAL LETTER T WITH DOT ABOVE': 7786,
'LATIN CAPITAL LETTER T WITH DOT BELOW': 7788,
'LATIN CAPITAL LETTER T WITH HOOK': 428,
'LATIN CAPITAL LETTER T WITH LINE BELOW': 7790,
'LATIN CAPITAL LETTER T WITH RETROFLEX HOOK': 430,
'LATIN CAPITAL LETTER T WITH STROKE': 358,
'LATIN CAPITAL LETTER THORN': 222,
'LATIN CAPITAL LETTER THORN WITH STROKE': 42852,
'LATIN CAPITAL LETTER THORN WITH STROKE THROUGH DESCENDER': 42854,
'LATIN CAPITAL LETTER TONE FIVE': 444,
'LATIN CAPITAL LETTER TONE SIX': 388,
'LATIN CAPITAL LETTER TONE TWO': 423,
'LATIN CAPITAL LETTER TRESILLO': 42794,
'LATIN CAPITAL LETTER TURNED A': 11375,
'LATIN CAPITAL LETTER TURNED ALPHA': 11376,
'LATIN CAPITAL LETTER TURNED INSULAR G': 42878,
'LATIN CAPITAL LETTER TURNED L': 42880,
'LATIN CAPITAL LETTER TURNED M': 412,
'LATIN CAPITAL LETTER TURNED V': 581,
'LATIN CAPITAL LETTER TZ': 42792,
'LATIN CAPITAL LETTER U': 85,
'LATIN CAPITAL LETTER U BAR': 580,
'LATIN CAPITAL LETTER U WITH ACUTE': 218,
'LATIN CAPITAL LETTER U WITH BREVE': 364,
'LATIN CAPITAL LETTER U WITH CARON': 467,
'LATIN CAPITAL LETTER U WITH CIRCUMFLEX': 219,
'LATIN CAPITAL LETTER U WITH CIRCUMFLEX BELOW': 7798,
'LATIN CAPITAL LETTER U WITH DIAERESIS': 220,
'LATIN CAPITAL LETTER U WITH DIAERESIS AND ACUTE': 471,
'LATIN CAPITAL LETTER U WITH DIAERESIS AND CARON': 473,
'LATIN CAPITAL LETTER U WITH DIAERESIS AND GRAVE': 475,
'LATIN CAPITAL LETTER U WITH DIAERESIS AND MACRON': 469,
'LATIN CAPITAL LETTER U WITH DIAERESIS BELOW': 7794,
'LATIN CAPITAL LETTER U WITH DOT BELOW': 7908,
'LATIN CAPITAL LETTER U WITH DOUBLE ACUTE': 368,
'LATIN CAPITAL LETTER U WITH DOUBLE GRAVE': 532,
'LATIN CAPITAL LETTER U WITH GRAVE': 217,
'LATIN CAPITAL LETTER U WITH HOOK ABOVE': 7910,
'LATIN CAPITAL LETTER U WITH HORN': 431,
'LATIN CAPITAL LETTER U WITH HORN AND ACUTE': 7912,
'LATIN CAPITAL LETTER U WITH HORN AND DOT BELOW': 7920,
'LATIN CAPITAL LETTER U WITH HORN AND GRAVE': 7914,
'LATIN CAPITAL LETTER U WITH HORN AND HOOK ABOVE': 7916,
'LATIN CAPITAL LETTER U WITH HORN AND TILDE': 7918,
'LATIN CAPITAL LETTER U WITH INVERTED BREVE': 534,
'LATIN CAPITAL LETTER U WITH MACRON': 362,
'LATIN CAPITAL LETTER U WITH MACRON AND DIAERESIS': 7802,
'LATIN CAPITAL LETTER U WITH OGONEK': 370,
'LATIN CAPITAL LETTER U WITH RING ABOVE': 366,
'LATIN CAPITAL LETTER U WITH TILDE': 360,
'LATIN CAPITAL LETTER U WITH TILDE AND ACUTE': 7800,
'LATIN CAPITAL LETTER U WITH TILDE BELOW': 7796,
'LATIN CAPITAL LETTER UPSILON': 433,
'LATIN CAPITAL LETTER V': 86,
'LATIN CAPITAL LETTER V WITH DIAGONAL STROKE': 42846,
'LATIN CAPITAL LETTER V WITH DOT BELOW': 7806,
'LATIN CAPITAL LETTER V WITH HOOK': 434,
'LATIN CAPITAL LETTER V WITH TILDE': 7804,
'LATIN CAPITAL LETTER VEND': 42856,
'LATIN CAPITAL LETTER VISIGOTHIC Z': 42850,
'LATIN CAPITAL LETTER VY': 42848,
'LATIN CAPITAL LETTER W': 87,
'LATIN CAPITAL LETTER W WITH ACUTE': 7810,
'LATIN CAPITAL LETTER W WITH CIRCUMFLEX': 372,
'LATIN CAPITAL LETTER W WITH DIAERESIS': 7812,
'LATIN CAPITAL LETTER W WITH DOT ABOVE': 7814,
'LATIN CAPITAL LETTER W WITH DOT BELOW': 7816,
'LATIN CAPITAL LETTER W WITH GRAVE': 7808,
'LATIN CAPITAL LETTER W WITH HOOK': 11378,
'LATIN CAPITAL LETTER WYNN': 503,
'LATIN CAPITAL LETTER X': 88,
'LATIN CAPITAL LETTER X WITH DIAERESIS': 7820,
'LATIN CAPITAL LETTER X WITH DOT ABOVE': 7818,
'LATIN CAPITAL LETTER Y': 89,
'LATIN CAPITAL LETTER Y WITH ACUTE': 221,
'LATIN CAPITAL LETTER Y WITH CIRCUMFLEX': 374,
'LATIN CAPITAL LETTER Y WITH DIAERESIS': 376,
'LATIN CAPITAL LETTER Y WITH DOT ABOVE': 7822,
'LATIN CAPITAL LETTER Y WITH DOT BELOW': 7924,
'LATIN CAPITAL LETTER Y WITH GRAVE': 7922,
'LATIN CAPITAL LETTER Y WITH HOOK': 435,
'LATIN CAPITAL LETTER Y WITH HOOK ABOVE': 7926,
'LATIN CAPITAL LETTER Y WITH LOOP': 7934,
'LATIN CAPITAL LETTER Y WITH MACRON': 562,
'LATIN CAPITAL LETTER Y WITH STROKE': 590,
'LATIN CAPITAL LETTER Y WITH TILDE': 7928,
'LATIN CAPITAL LETTER YOGH': 540,
'LATIN CAPITAL LETTER Z': 90,
'LATIN CAPITAL LETTER Z WITH ACUTE': 377,
'LATIN CAPITAL LETTER Z WITH CARON': 381,
'LATIN CAPITAL LETTER Z WITH CIRCUMFLEX': 7824,
'LATIN CAPITAL LETTER Z WITH DESCENDER': 11371,
'LATIN CAPITAL LETTER Z WITH DOT ABOVE': 379,
'LATIN CAPITAL LETTER Z WITH DOT BELOW': 7826,
'LATIN CAPITAL LETTER Z WITH HOOK': 548,
'LATIN CAPITAL LETTER Z WITH LINE BELOW': 7828,
'LATIN CAPITAL LETTER Z WITH STROKE': 437,
'LATIN CAPITAL LETTER Z WITH SWASH TAIL': 11391,
'LATIN CAPITAL LIGATURE IJ': 306,
'LATIN CAPITAL LIGATURE OE': 338,
'LATIN CROSS': 10013,
'LATIN EPIGRAPHIC LETTER ARCHAIC M': 43007,
'LATIN EPIGRAPHIC LETTER I LONGA': 43006,
'LATIN EPIGRAPHIC LETTER INVERTED M': 43005,
'LATIN EPIGRAPHIC LETTER REVERSED F': 43003,
'LATIN EPIGRAPHIC LETTER REVERSED P': 43004,
'LATIN LETTER AIN': 7461,
'LATIN LETTER ALVEOLAR CLICK': 450,
'LATIN LETTER BIDENTAL PERCUSSIVE': 685,
'LATIN LETTER BILABIAL CLICK': 664,
'LATIN LETTER BILABIAL PERCUSSIVE': 684,
'LATIN LETTER DENTAL CLICK': 448,
'LATIN LETTER GLOTTAL STOP': 660,
'LATIN LETTER GLOTTAL STOP WITH STROKE': 673,
'LATIN LETTER INVERTED GLOTTAL STOP': 662,
'LATIN LETTER INVERTED GLOTTAL STOP WITH STROKE': 446,
'LATIN LETTER LATERAL CLICK': 449,
'LATIN LETTER PHARYNGEAL VOICED FRICATIVE': 661,
'LATIN LETTER RETROFLEX CLICK': 451,
'LATIN LETTER REVERSED ESH LOOP': 426,
'LATIN LETTER REVERSED GLOTTAL STOP WITH STROKE': 674,
'LATIN LETTER SMALL CAPITAL A': 7424,
'LATIN LETTER SMALL CAPITAL AE': 7425,
'LATIN LETTER SMALL CAPITAL B': 665,
'LATIN LETTER SMALL CAPITAL BARRED B': 7427,
'LATIN LETTER SMALL CAPITAL C': 7428,
'LATIN LETTER SMALL CAPITAL D': 7429,
'LATIN LETTER SMALL CAPITAL E': 7431,
'LATIN LETTER SMALL CAPITAL ETH': 7430,
'LATIN LETTER SMALL CAPITAL EZH': 7459,
'LATIN LETTER SMALL CAPITAL F': 42800,
'LATIN LETTER SMALL CAPITAL G': 610,
'LATIN LETTER SMALL CAPITAL G WITH HOOK': 667,
'LATIN LETTER SMALL CAPITAL H': 668,
'LATIN LETTER SMALL CAPITAL I': 618,
'LATIN LETTER SMALL CAPITAL INVERTED R': 641,
'LATIN LETTER SMALL CAPITAL J': 7434,
'LATIN LETTER SMALL CAPITAL K': 7435,
'LATIN LETTER SMALL CAPITAL L': 671,
'LATIN LETTER SMALL CAPITAL L WITH STROKE': 7436,
'LATIN LETTER SMALL CAPITAL M': 7437,
'LATIN LETTER SMALL CAPITAL N': 628,
'LATIN LETTER SMALL CAPITAL O': 7439,
'LATIN LETTER SMALL CAPITAL OE': 630,
'LATIN LETTER SMALL CAPITAL OPEN O': 7440,
'LATIN LETTER SMALL CAPITAL OU': 7445,
'LATIN LETTER SMALL CAPITAL P': 7448,
'LATIN LETTER SMALL CAPITAL R': 640,
'LATIN LETTER SMALL CAPITAL REVERSED N': 7438,
'LATIN LETTER SMALL CAPITAL REVERSED R': 7449,
'LATIN LETTER SMALL CAPITAL RUM': 42870,
'LATIN LETTER SMALL CAPITAL S': 42801,
'LATIN LETTER SMALL CAPITAL T': 7451,
'LATIN LETTER SMALL CAPITAL TURNED E': 11387,
'LATIN LETTER SMALL CAPITAL TURNED R': 7450,
'LATIN LETTER SMALL CAPITAL U': 7452,
'LATIN LETTER SMALL CAPITAL V': 7456,
'LATIN LETTER SMALL CAPITAL W': 7457,
'LATIN LETTER SMALL CAPITAL Y': 655,
'LATIN LETTER SMALL CAPITAL Z': 7458,
'LATIN LETTER STRETCHED C': 663,
'LATIN LETTER TWO WITH STROKE': 443,
'LATIN LETTER VOICED LARYNGEAL SPIRANT': 7460,
'LATIN LETTER WYNN': 447,
'LATIN LETTER YR': 422,
'LATIN SMALL CAPITAL LETTER I WITH STROKE': 7547,
'LATIN SMALL CAPITAL LETTER U WITH STROKE': 7550,
'LATIN SMALL LETTER A': 97,
'LATIN SMALL LETTER A WITH ACUTE': 225,
'LATIN SMALL LETTER A WITH BREVE': 259,
'LATIN SMALL LETTER A WITH BREVE AND ACUTE': 7855,
'LATIN SMALL LETTER A WITH BREVE AND DOT BELOW': 7863,
'LATIN SMALL LETTER A WITH BREVE AND GRAVE': 7857,
'LATIN SMALL LETTER A WITH BREVE AND HOOK ABOVE': 7859,
'LATIN SMALL LETTER A WITH BREVE AND TILDE': 7861,
'LATIN SMALL LETTER A WITH CARON': 462,
'LATIN SMALL LETTER A WITH CIRCUMFLEX': 226,
'LATIN SMALL LETTER A WITH CIRCUMFLEX AND ACUTE': 7845,
'LATIN SMALL LETTER A WITH CIRCUMFLEX AND DOT BELOW': 7853,
'LATIN SMALL LETTER A WITH CIRCUMFLEX AND GRAVE': 7847,
'LATIN SMALL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE': 7849,
'LATIN SMALL LETTER A WITH CIRCUMFLEX AND TILDE': 7851,
'LATIN SMALL LETTER A WITH DIAERESIS': 228,
'LATIN SMALL LETTER A WITH DIAERESIS AND MACRON': 479,
'LATIN SMALL LETTER A WITH DOT ABOVE': 551,
'LATIN SMALL LETTER A WITH DOT ABOVE AND MACRON': 481,
'LATIN SMALL LETTER A WITH DOT BELOW': 7841,
'LATIN SMALL LETTER A WITH DOUBLE GRAVE': 513,
'LATIN SMALL LETTER A WITH GRAVE': 224,
'LATIN SMALL LETTER A WITH HOOK ABOVE': 7843,
'LATIN SMALL LETTER A WITH INVERTED BREVE': 515,
'LATIN SMALL LETTER A WITH MACRON': 257,
'LATIN SMALL LETTER A WITH OGONEK': 261,
'LATIN SMALL LETTER A WITH RETROFLEX HOOK': 7567,
'LATIN SMALL LETTER A WITH RIGHT HALF RING': 7834,
'LATIN SMALL LETTER A WITH RING ABOVE': 229,
'LATIN SMALL LETTER A WITH RING ABOVE AND ACUTE': 507,
'LATIN SMALL LETTER A WITH RING BELOW': 7681,
'LATIN SMALL LETTER A WITH STROKE': 11365,
'LATIN SMALL LETTER A WITH TILDE': 227,
'LATIN SMALL LETTER AA': 42803,
'LATIN SMALL LETTER AE': 230,
'LATIN SMALL LETTER AE WITH ACUTE': 509,
'LATIN SMALL LETTER AE WITH MACRON': 483,
'LATIN SMALL LETTER ALPHA': 593,
'LATIN SMALL LETTER ALPHA WITH RETROFLEX HOOK': 7568,
'LATIN SMALL LETTER AO': 42805,
'LATIN SMALL LETTER AU': 42807,
'LATIN SMALL LETTER AV': 42809,
'LATIN SMALL LETTER AV WITH HORIZONTAL BAR': 42811,
'LATIN SMALL LETTER AY': 42813,
'LATIN SMALL LETTER B': 98,
'LATIN SMALL LETTER B WITH DOT ABOVE': 7683,
'LATIN SMALL LETTER B WITH DOT BELOW': 7685,
'LATIN SMALL LETTER B WITH HOOK': 595,
'LATIN SMALL LETTER B WITH LINE BELOW': 7687,
'LATIN SMALL LETTER B WITH MIDDLE TILDE': 7532,
'LATIN SMALL LETTER B WITH PALATAL HOOK': 7552,
'LATIN SMALL LETTER B WITH STROKE': 384,
'LATIN SMALL LETTER B WITH TOPBAR': 387,
'LATIN SMALL LETTER BARRED O': 629,
'LATIN SMALL LETTER BOTTOM HALF O': 7447,
'LATIN SMALL LETTER BROKEN L': 42823,
'LATIN SMALL LETTER C': 99,
'LATIN SMALL LETTER C WITH ACUTE': 263,
'LATIN SMALL LETTER C WITH CARON': 269,
'LATIN SMALL LETTER C WITH CEDILLA': 231,
'LATIN SMALL LETTER C WITH CEDILLA AND ACUTE': 7689,
'LATIN SMALL LETTER C WITH CIRCUMFLEX': 265,
'LATIN SMALL LETTER C WITH CURL': 597,
'LATIN SMALL LETTER C WITH DOT ABOVE': 267,
'LATIN SMALL LETTER C WITH HOOK': 392,
'LATIN SMALL LETTER C WITH STROKE': 572,
'LATIN SMALL LETTER CLOSED OMEGA': 631,
'LATIN SMALL LETTER CLOSED OPEN E': 666,
'LATIN SMALL LETTER CLOSED REVERSED OPEN E': 606,
'LATIN SMALL LETTER CON': 42863,
'LATIN SMALL LETTER CUATRILLO': 42797,
'LATIN SMALL LETTER CUATRILLO WITH COMMA': 42799,
'LATIN SMALL LETTER D': 100,
'LATIN SMALL LETTER D WITH CARON': 271,
'LATIN SMALL LETTER D WITH CEDILLA': 7697,
'LATIN SMALL LETTER D WITH CIRCUMFLEX BELOW': 7699,
'LATIN SMALL LETTER D WITH CURL': 545,
'LATIN SMALL LETTER D WITH DOT ABOVE': 7691,
'LATIN SMALL LETTER D WITH DOT BELOW': 7693,
'LATIN SMALL LETTER D WITH HOOK': 599,
'LATIN SMALL LETTER D WITH HOOK AND TAIL': 7569,
'LATIN SMALL LETTER D WITH LINE BELOW': 7695,
'LATIN SMALL LETTER D WITH MIDDLE TILDE': 7533,
'LATIN SMALL LETTER D WITH PALATAL HOOK': 7553,
'LATIN SMALL LETTER D WITH STROKE': 273,
'LATIN SMALL LETTER D WITH TAIL': 598,
'LATIN SMALL LETTER D WITH TOPBAR': 396,
'LATIN SMALL LETTER DB DIGRAPH': 568,
'LATIN SMALL LETTER DELTA': 7839,
'LATIN SMALL LETTER DEZH DIGRAPH': 676,
'LATIN SMALL LETTER DOTLESS I': 305,
'LATIN SMALL LETTER DOTLESS J': 567,
'LATIN SMALL LETTER DOTLESS J WITH STROKE': 607,
'LATIN SMALL LETTER DOTLESS J WITH STROKE AND HOOK': 644,
'LATIN SMALL LETTER DUM': 42865,
'LATIN SMALL LETTER DZ': 499,
'LATIN SMALL LETTER DZ DIGRAPH': 675,
'LATIN SMALL LETTER DZ DIGRAPH WITH CURL': 677,
'LATIN SMALL LETTER DZ WITH CARON': 454,
'LATIN SMALL LETTER E': 101,
'LATIN SMALL LETTER E WITH ACUTE': 233,
'LATIN SMALL LETTER E WITH BREVE': 277,
'LATIN SMALL LETTER E WITH CARON': 283,
'LATIN SMALL LETTER E WITH CEDILLA': 553,
'LATIN SMALL LETTER E WITH CEDILLA AND BREVE': 7709,
'LATIN SMALL LETTER E WITH CIRCUMFLEX': 234,
'LATIN SMALL LETTER E WITH CIRCUMFLEX AND ACUTE': 7871,
'LATIN SMALL LETTER E WITH CIRCUMFLEX AND DOT BELOW': 7879,
'LATIN SMALL LETTER E WITH CIRCUMFLEX AND GRAVE': 7873,
'LATIN SMALL LETTER E WITH CIRCUMFLEX AND HOOK ABOVE': 7875,
'LATIN SMALL LETTER E WITH CIRCUMFLEX AND TILDE': 7877,
'LATIN SMALL LETTER E WITH CIRCUMFLEX BELOW': 7705,
'LATIN SMALL LETTER E WITH DIAERESIS': 235,
'LATIN SMALL LETTER E WITH DOT ABOVE': 279,
'LATIN SMALL LETTER E WITH DOT BELOW': 7865,
'LATIN SMALL LETTER E WITH DOUBLE GRAVE': 517,
'LATIN SMALL LETTER E WITH GRAVE': 232,
'LATIN SMALL LETTER E WITH HOOK ABOVE': 7867,
'LATIN SMALL LETTER E WITH INVERTED BREVE': 519,
'LATIN SMALL LETTER E WITH MACRON': 275,
'LATIN SMALL LETTER E WITH MACRON AND ACUTE': 7703,
'LATIN SMALL LETTER E WITH MACRON AND GRAVE': 7701,
'LATIN SMALL LETTER E WITH NOTCH': 11384,
'LATIN SMALL LETTER E WITH OGONEK': 281,
'LATIN SMALL LETTER E WITH RETROFLEX HOOK': 7570,
'LATIN SMALL LETTER E WITH STROKE': 583,
'LATIN SMALL LETTER E WITH TILDE': 7869,
'LATIN SMALL LETTER E WITH TILDE BELOW': 7707,
'LATIN SMALL LETTER EGYPTOLOGICAL AIN': 42789,
'LATIN SMALL LETTER EGYPTOLOGICAL ALEF': 42787,
'LATIN SMALL LETTER ENG': 331,
'LATIN SMALL LETTER ESH': 643,
'LATIN SMALL LETTER ESH WITH CURL': 646,
'LATIN SMALL LETTER ESH WITH PALATAL HOOK': 7563,
'LATIN SMALL LETTER ESH WITH RETROFLEX HOOK': 7576,
'LATIN SMALL LETTER ET': 42859,
'LATIN SMALL LETTER ETH': 240,
'LATIN SMALL LETTER EZH': 658,
'LATIN SMALL LETTER EZH REVERSED': 441,
'LATIN SMALL LETTER EZH WITH CARON': 495,
'LATIN SMALL LETTER EZH WITH CURL': 659,
'LATIN SMALL LETTER EZH WITH RETROFLEX HOOK': 7578,
'LATIN SMALL LETTER EZH WITH TAIL': 442,
'LATIN SMALL LETTER F': 102,
'LATIN SMALL LETTER F WITH DOT ABOVE': 7711,
'LATIN SMALL LETTER F WITH HOOK': 402,
'LATIN SMALL LETTER F WITH MIDDLE TILDE': 7534,
'LATIN SMALL LETTER F WITH PALATAL HOOK': 7554,
'LATIN SMALL LETTER FENG DIGRAPH': 681,
'LATIN SMALL LETTER G': 103,
'LATIN SMALL LETTER G WITH ACUTE': 501,
'LATIN SMALL LETTER G WITH BREVE': 287,
'LATIN SMALL LETTER G WITH CARON': 487,
'LATIN SMALL LETTER G WITH CEDILLA': 291,
'LATIN SMALL LETTER G WITH CIRCUMFLEX': 285,
'LATIN SMALL LETTER G WITH DOT ABOVE': 289,
'LATIN SMALL LETTER G WITH HOOK': 608,
'LATIN SMALL LETTER G WITH MACRON': 7713,
'LATIN SMALL LETTER G WITH PALATAL HOOK': 7555,
'LATIN SMALL LETTER G WITH STROKE': 485,
'LATIN SMALL LETTER GAMMA': 611,
'LATIN SMALL LETTER GLOTTAL STOP': 578,
'LATIN SMALL LETTER H': 104,
'LATIN SMALL LETTER H WITH BREVE BELOW': 7723,
'LATIN SMALL LETTER H WITH CARON': 543,
'LATIN SMALL LETTER H WITH CEDILLA': 7721,
'LATIN SMALL LETTER H WITH CIRCUMFLEX': 293,
'LATIN SMALL LETTER H WITH DESCENDER': 11368,
'LATIN SMALL LETTER H WITH DIAERESIS': 7719,
'LATIN SMALL LETTER H WITH DOT ABOVE': 7715,
'LATIN SMALL LETTER H WITH DOT BELOW': 7717,
'LATIN SMALL LETTER H WITH HOOK': 614,
'LATIN SMALL LETTER H WITH LINE BELOW': 7830,
'LATIN SMALL LETTER H WITH STROKE': 295,
'LATIN SMALL LETTER HALF H': 11382,
'LATIN SMALL LETTER HENG': 42791,
'LATIN SMALL LETTER HENG WITH HOOK': 615,
'LATIN SMALL LETTER HV': 405,
'LATIN SMALL LETTER I': 105,
'LATIN SMALL LETTER I WITH ACUTE': 237,
'LATIN SMALL LETTER I WITH BREVE': 301,
'LATIN SMALL LETTER I WITH CARON': 464,
'LATIN SMALL LETTER I WITH CIRCUMFLEX': 238,
'LATIN SMALL LETTER I WITH DIAERESIS': 239,
'LATIN SMALL LETTER I WITH DIAERESIS AND ACUTE': 7727,
'LATIN SMALL LETTER I WITH DOT BELOW': 7883,
'LATIN SMALL LETTER I WITH DOUBLE GRAVE': 521,
'LATIN SMALL LETTER I WITH GRAVE': 236,
'LATIN SMALL LETTER I WITH HOOK ABOVE': 7881,
'LATIN SMALL LETTER I WITH INVERTED BREVE': 523,
'LATIN SMALL LETTER I WITH MACRON': 299,
'LATIN SMALL LETTER I WITH OGONEK': 303,
'LATIN SMALL LETTER I WITH RETROFLEX HOOK': 7574,
'LATIN SMALL LETTER I WITH STROKE': 616,
'LATIN SMALL LETTER I WITH TILDE': 297,
'LATIN SMALL LETTER I WITH TILDE BELOW': 7725,
'LATIN SMALL LETTER INSULAR D': 42874,
'LATIN SMALL LETTER INSULAR F': 42876,
'LATIN SMALL LETTER INSULAR G': 7545,
'LATIN SMALL LETTER INSULAR R': 42883,
'LATIN SMALL LETTER INSULAR S': 42885,
'LATIN SMALL LETTER INSULAR T': 42887,
'LATIN SMALL LETTER IOTA': 617,
'LATIN SMALL LETTER IOTA WITH STROKE': 7548,
'LATIN SMALL LETTER IS': 42861,
'LATIN SMALL LETTER J': 106,
'LATIN SMALL LETTER J WITH CARON': 496,
'LATIN SMALL LETTER J WITH CIRCUMFLEX': 309,
'LATIN SMALL LETTER J WITH CROSSED-TAIL': 669,
'LATIN SMALL LETTER J WITH STROKE': 585,
'LATIN SMALL LETTER K': 107,
'LATIN SMALL LETTER K WITH ACUTE': 7729,
'LATIN SMALL LETTER K WITH CARON': 489,
'LATIN SMALL LETTER K WITH CEDILLA': 311,
'LATIN SMALL LETTER K WITH DESCENDER': 11370,
'LATIN SMALL LETTER K WITH DIAGONAL STROKE': 42819,
'LATIN SMALL LETTER K WITH DOT BELOW': 7731,
'LATIN SMALL LETTER K WITH HOOK': 409,
'LATIN SMALL LETTER K WITH LINE BELOW': 7733,
'LATIN SMALL LETTER K WITH PALATAL HOOK': 7556,
'LATIN SMALL LETTER K WITH STROKE': 42817,
'LATIN SMALL LETTER K WITH STROKE AND DIAGONAL STROKE': 42821,
'LATIN SMALL LETTER KRA': 312,
'LATIN SMALL LETTER L': 108,
'LATIN SMALL LETTER L WITH ACUTE': 314,
'LATIN SMALL LETTER L WITH BAR': 410,
'LATIN SMALL LETTER L WITH BELT': 620,
'LATIN SMALL LETTER L WITH CARON': 318,
'LATIN SMALL LETTER L WITH CEDILLA': 316,
'LATIN SMALL LETTER L WITH CIRCUMFLEX BELOW': 7741,
'LATIN SMALL LETTER L WITH CURL': 564,
'LATIN SMALL LETTER L WITH DOT BELOW': 7735,
'LATIN SMALL LETTER L WITH DOT BELOW AND MACRON': 7737,
'LATIN SMALL LETTER L WITH DOUBLE BAR': 11361,
'LATIN SMALL LETTER L WITH HIGH STROKE': 42825,
'LATIN SMALL LETTER L WITH LINE BELOW': 7739,
'LATIN SMALL LETTER L WITH MIDDLE DOT': 320,
'LATIN SMALL LETTER L WITH MIDDLE TILDE': 619,
'LATIN SMALL LETTER L WITH PALATAL HOOK': 7557,
'LATIN SMALL LETTER L WITH RETROFLEX HOOK': 621,
'LATIN SMALL LETTER L WITH STROKE': 322,
'LATIN SMALL LETTER LAMBDA WITH STROKE': 411,
'LATIN SMALL LETTER LEZH': 622,
'LATIN SMALL LETTER LJ': 457,
'LATIN SMALL LETTER LONG S': 383,
'LATIN SMALL LETTER LONG S WITH DIAGONAL STROKE': 7836,
'LATIN SMALL LETTER LONG S WITH DOT ABOVE': 7835,
'LATIN SMALL LETTER LONG S WITH HIGH STROKE': 7837,
'LATIN SMALL LETTER LS DIGRAPH': 682,
'LATIN SMALL LETTER LUM': 42866,
'LATIN SMALL LETTER LZ DIGRAPH': 683,
'LATIN SMALL LETTER M': 109,
'LATIN SMALL LETTER M WITH ACUTE': 7743,
'LATIN SMALL LETTER M WITH DOT ABOVE': 7745,
'LATIN SMALL LETTER M WITH DOT BELOW': 7747,
'LATIN SMALL LETTER M WITH HOOK': 625,
'LATIN SMALL LETTER M WITH MIDDLE TILDE': 7535,
'LATIN SMALL LETTER M WITH PALATAL HOOK': 7558,
'LATIN SMALL LETTER MIDDLE-WELSH LL': 7931,
'LATIN SMALL LETTER MIDDLE-WELSH V': 7933,
'LATIN SMALL LETTER MUM': 42867,
'LATIN SMALL LETTER N': 110,
'LATIN SMALL LETTER N PRECEDED BY APOSTROPHE': 329,
'LATIN SMALL LETTER N WITH ACUTE': 324,
'LATIN SMALL LETTER N WITH CARON': 328,
'LATIN SMALL LETTER N WITH CEDILLA': 326,
'LATIN SMALL LETTER N WITH CIRCUMFLEX BELOW': 7755,
'LATIN SMALL LETTER N WITH CURL': 565,
'LATIN SMALL LETTER N WITH DOT ABOVE': 7749,
'LATIN SMALL LETTER N WITH DOT BELOW': 7751,
'LATIN SMALL LETTER N WITH GRAVE': 505,
'LATIN SMALL LETTER N WITH LEFT HOOK': 626,
'LATIN SMALL LETTER N WITH LINE BELOW': 7753,
'LATIN SMALL LETTER N WITH LONG RIGHT LEG': 414,
'LATIN SMALL LETTER N WITH MIDDLE TILDE': 7536,
'LATIN SMALL LETTER N WITH PALATAL HOOK': 7559,
'LATIN SMALL LETTER N WITH RETROFLEX HOOK': 627,
'LATIN SMALL LETTER N WITH TILDE': 241,
'LATIN SMALL LETTER NJ': 460,
'LATIN SMALL LETTER NUM': 42868,
'LATIN SMALL LETTER O': 111,
'LATIN SMALL LETTER O WITH ACUTE': 243,
'LATIN SMALL LETTER O WITH BREVE': 335,
'LATIN SMALL LETTER O WITH CARON': 466,
'LATIN SMALL LETTER O WITH CIRCUMFLEX': 244,
'LATIN SMALL LETTER O WITH CIRCUMFLEX AND ACUTE': 7889,
'LATIN SMALL LETTER O WITH CIRCUMFLEX AND DOT BELOW': 7897,
'LATIN SMALL LETTER O WITH CIRCUMFLEX AND GRAVE': 7891,
'LATIN SMALL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE': 7893,
'LATIN SMALL LETTER O WITH CIRCUMFLEX AND TILDE': 7895,
'LATIN SMALL LETTER O WITH DIAERESIS': 246,
'LATIN SMALL LETTER O WITH DIAERESIS AND MACRON': 555,
'LATIN SMALL LETTER O WITH DOT ABOVE': 559,
'LATIN SMALL LETTER O WITH DOT ABOVE AND MACRON': 561,
'LATIN SMALL LETTER O WITH DOT BELOW': 7885,
'LATIN SMALL LETTER O WITH DOUBLE ACUTE': 337,
'LATIN SMALL LETTER O WITH DOUBLE GRAVE': 525,
'LATIN SMALL LETTER O WITH GRAVE': 242,
'LATIN SMALL LETTER O WITH HOOK ABOVE': 7887,
'LATIN SMALL LETTER O WITH HORN': 417,
'LATIN SMALL LETTER O WITH HORN AND ACUTE': 7899,
'LATIN SMALL LETTER O WITH HORN AND DOT BELOW': 7907,
'LATIN SMALL LETTER O WITH HORN AND GRAVE': 7901,
'LATIN SMALL LETTER O WITH HORN AND HOOK ABOVE': 7903,
'LATIN SMALL LETTER O WITH HORN AND TILDE': 7905,
'LATIN SMALL LETTER O WITH INVERTED BREVE': 527,
'LATIN SMALL LETTER O WITH LONG STROKE OVERLAY': 42827,
'LATIN SMALL LETTER O WITH LOOP': 42829,
'LATIN SMALL LETTER O WITH LOW RING INSIDE': 11386,
'LATIN SMALL LETTER O WITH MACRON': 333,
'LATIN SMALL LETTER O WITH MACRON AND ACUTE': 7763,
'LATIN SMALL LETTER O WITH MACRON AND GRAVE': 7761,
'LATIN SMALL LETTER O WITH OGONEK': 491,
'LATIN SMALL LETTER O WITH OGONEK AND MACRON': 493,
'LATIN SMALL LETTER O WITH STROKE': 248,
'LATIN SMALL LETTER O WITH STROKE AND ACUTE': 511,
'LATIN SMALL LETTER O WITH TILDE': 245,
'LATIN SMALL LETTER O WITH TILDE AND ACUTE': 7757,
'LATIN SMALL LETTER O WITH TILDE AND DIAERESIS': 7759,
'LATIN SMALL LETTER O WITH TILDE AND MACRON': 557,
'LATIN SMALL LETTER OI': 419,
'LATIN SMALL LETTER OO': 42831,
'LATIN SMALL LETTER OPEN E': 603,
'LATIN SMALL LETTER OPEN E WITH RETROFLEX HOOK': 7571,
'LATIN SMALL LETTER OPEN O': 596,
'LATIN SMALL LETTER OPEN O WITH RETROFLEX HOOK': 7575,
'LATIN SMALL LETTER OU': 547,
'LATIN SMALL LETTER P': 112,
'LATIN SMALL LETTER P WITH ACUTE': 7765,
'LATIN SMALL LETTER P WITH DOT ABOVE': 7767,
'LATIN SMALL LETTER P WITH FLOURISH': 42835,
'LATIN SMALL LETTER P WITH HOOK': 421,
'LATIN SMALL LETTER P WITH MIDDLE TILDE': 7537,
'LATIN SMALL LETTER P WITH PALATAL HOOK': 7560,
'LATIN SMALL LETTER P WITH SQUIRREL TAIL': 42837,
'LATIN SMALL LETTER P WITH STROKE': 7549,
'LATIN SMALL LETTER P WITH STROKE THROUGH DESCENDER': 42833,
'LATIN SMALL LETTER PHI': 632,
'LATIN SMALL LETTER Q': 113,
'LATIN SMALL LETTER Q WITH DIAGONAL STROKE': 42841,
'LATIN SMALL LETTER Q WITH HOOK': 672,
'LATIN SMALL LETTER Q WITH HOOK TAIL': 587,
'LATIN SMALL LETTER Q WITH STROKE THROUGH DESCENDER': 42839,
'LATIN SMALL LETTER QP DIGRAPH': 569,
'LATIN SMALL LETTER R': 114,
'LATIN SMALL LETTER R ROTUNDA': 42843,
'LATIN SMALL LETTER R WITH ACUTE': 341,
'LATIN SMALL LETTER R WITH CARON': 345,
'LATIN SMALL LETTER R WITH CEDILLA': 343,
'LATIN SMALL LETTER R WITH DOT ABOVE': 7769,
'LATIN SMALL LETTER R WITH DOT BELOW': 7771,
'LATIN SMALL LETTER R WITH DOT BELOW AND MACRON': 7773,
'LATIN SMALL LETTER R WITH DOUBLE GRAVE': 529,
'LATIN SMALL LETTER R WITH FISHHOOK': 638,
'LATIN SMALL LETTER R WITH FISHHOOK AND MIDDLE TILDE': 7539,
'LATIN SMALL LETTER R WITH INVERTED BREVE': 531,
'LATIN SMALL LETTER R WITH LINE BELOW': 7775,
'LATIN SMALL LETTER R WITH LONG LEG': 636,
'LATIN SMALL LETTER R WITH MIDDLE TILDE': 7538,
'LATIN SMALL LETTER R WITH PALATAL HOOK': 7561,
'LATIN SMALL LETTER R WITH STROKE': 589,
'LATIN SMALL LETTER R WITH TAIL': 637,
'LATIN SMALL LETTER RAMS HORN': 612,
'LATIN SMALL LETTER REVERSED C': 8580,
'LATIN SMALL LETTER REVERSED C WITH DOT': 42815,
'LATIN SMALL LETTER REVERSED E': 600,
'LATIN SMALL LETTER REVERSED OPEN E': 604,
'LATIN SMALL LETTER REVERSED OPEN E WITH HOOK': 605,
'LATIN SMALL LETTER REVERSED OPEN E WITH RETROFLEX HOOK': 7572,
'LATIN SMALL LETTER REVERSED R WITH FISHHOOK': 639,
'LATIN SMALL LETTER RUM': 42869,
'LATIN SMALL LETTER RUM ROTUNDA': 42845,
'LATIN SMALL LETTER S': 115,
'LATIN SMALL LETTER S WITH ACUTE': 347,
'LATIN SMALL LETTER S WITH ACUTE AND DOT ABOVE': 7781,
'LATIN SMALL LETTER S WITH CARON': 353,
'LATIN SMALL LETTER S WITH CARON AND DOT ABOVE': 7783,
'LATIN SMALL LETTER S WITH CEDILLA': 351,
'LATIN SMALL LETTER S WITH CIRCUMFLEX': 349,
'LATIN SMALL LETTER S WITH COMMA BELOW': 537,
'LATIN SMALL LETTER S WITH DOT ABOVE': 7777,
'LATIN SMALL LETTER S WITH DOT BELOW': 7779,
'LATIN SMALL LETTER S WITH DOT BELOW AND DOT ABOVE': 7785,
'LATIN SMALL LETTER S WITH HOOK': 642,
'LATIN SMALL LETTER S WITH MIDDLE TILDE': 7540,
'LATIN SMALL LETTER S WITH PALATAL HOOK': 7562,
'LATIN SMALL LETTER S WITH SWASH TAIL': 575,
'LATIN SMALL LETTER SALTILLO': 42892,
'LATIN SMALL LETTER SCHWA': 601,
'LATIN SMALL LETTER SCHWA WITH HOOK': 602,
'LATIN SMALL LETTER SCHWA WITH RETROFLEX HOOK': 7573,
'LATIN SMALL LETTER SCRIPT G': 609,
'LATIN SMALL LETTER SHARP S': 223,
'LATIN SMALL LETTER SIDEWAYS DIAERESIZED U': 7454,
'LATIN SMALL LETTER SIDEWAYS O': 7441,
'LATIN SMALL LETTER SIDEWAYS O WITH STROKE': 7443,
'LATIN SMALL LETTER SIDEWAYS OPEN O': 7442,
'LATIN SMALL LETTER SIDEWAYS TURNED M': 7455,
'LATIN SMALL LETTER SIDEWAYS U': 7453,
'LATIN SMALL LETTER SQUAT REVERSED ESH': 645,
'LATIN SMALL LETTER T': 116,
'LATIN SMALL LETTER T WITH CARON': 357,
'LATIN SMALL LETTER T WITH CEDILLA': 355,
'LATIN SMALL LETTER T WITH CIRCUMFLEX BELOW': 7793,
'LATIN SMALL LETTER T WITH COMMA BELOW': 539,
'LATIN SMALL LETTER T WITH CURL': 566,
'LATIN SMALL LETTER T WITH DIAERESIS': 7831,
'LATIN SMALL LETTER T WITH DIAGONAL STROKE': 11366,
'LATIN SMALL LETTER T WITH DOT ABOVE': 7787,
'LATIN SMALL LETTER T WITH DOT BELOW': 7789,
'LATIN SMALL LETTER T WITH HOOK': 429,
'LATIN SMALL LETTER T WITH LINE BELOW': 7791,
'LATIN SMALL LETTER T WITH MIDDLE TILDE': 7541,
'LATIN SMALL LETTER T WITH PALATAL HOOK': 427,
'LATIN SMALL LETTER T WITH RETROFLEX HOOK': 648,
'LATIN SMALL LETTER T WITH STROKE': 359,
'LATIN SMALL LETTER TAILLESS PHI': 11383,
'LATIN SMALL LETTER TC DIGRAPH WITH CURL': 680,
'LATIN SMALL LETTER TESH DIGRAPH': 679,
'LATIN SMALL LETTER TH WITH STRIKETHROUGH': 7546,
'LATIN SMALL LETTER THORN': 254,
'LATIN SMALL LETTER THORN WITH STROKE': 42853,
'LATIN SMALL LETTER THORN WITH STROKE THROUGH DESCENDER': 42855,
'LATIN SMALL LETTER TONE FIVE': 445,
'LATIN SMALL LETTER TONE SIX': 389,
'LATIN SMALL LETTER TONE TWO': 424,
'LATIN SMALL LETTER TOP HALF O': 7446,
'LATIN SMALL LETTER TRESILLO': 42795,
'LATIN SMALL LETTER TS DIGRAPH': 678,
'LATIN SMALL LETTER TUM': 42871,
'LATIN SMALL LETTER TURNED A': 592,
'LATIN SMALL LETTER TURNED AE': 7426,
'LATIN SMALL LETTER TURNED ALPHA': 594,
'LATIN SMALL LETTER TURNED DELTA': 397,
'LATIN SMALL LETTER TURNED E': 477,
'LATIN SMALL LETTER TURNED G': 7543,
'LATIN SMALL LETTER TURNED H': 613,
'LATIN SMALL LETTER TURNED H WITH FISHHOOK': 686,
'LATIN SMALL LETTER TURNED H WITH FISHHOOK AND TAIL': 687,
'LATIN SMALL LETTER TURNED I': 7433,
'LATIN SMALL LETTER TURNED INSULAR G': 42879,
'LATIN SMALL LETTER TURNED K': 670,
'LATIN SMALL LETTER TURNED L': 42881,
'LATIN SMALL LETTER TURNED M': 623,
'LATIN SMALL LETTER TURNED M WITH LONG LEG': 624,
'LATIN SMALL LETTER TURNED OE': 7444,
'LATIN SMALL LETTER TURNED OPEN E': 7432,
'LATIN SMALL LETTER TURNED R': 633,
'LATIN SMALL LETTER TURNED R WITH HOOK': 635,
'LATIN SMALL LETTER TURNED R WITH LONG LEG': 634,
'LATIN SMALL LETTER TURNED R WITH TAIL': 11385,
'LATIN SMALL LETTER TURNED T': 647,
'LATIN SMALL LETTER TURNED V': 652,
'LATIN SMALL LETTER TURNED W': 653,
'LATIN SMALL LETTER TURNED Y': 654,
'LATIN SMALL LETTER TZ': 42793,
'LATIN SMALL LETTER U': 117,
'LATIN SMALL LETTER U BAR': 649,
'LATIN SMALL LETTER U WITH ACUTE': 250,
'LATIN SMALL LETTER U WITH BREVE': 365,
'LATIN SMALL LETTER U WITH CARON': 468,
'LATIN SMALL LETTER U WITH CIRCUMFLEX': 251,
'LATIN SMALL LETTER U WITH CIRCUMFLEX BELOW': 7799,
'LATIN SMALL LETTER U WITH DIAERESIS': 252,
'LATIN SMALL LETTER U WITH DIAERESIS AND ACUTE': 472,
'LATIN SMALL LETTER U WITH DIAERESIS AND CARON': 474,
'LATIN SMALL LETTER U WITH DIAERESIS AND GRAVE': 476,
'LATIN SMALL LETTER U WITH DIAERESIS AND MACRON': 470,
'LATIN SMALL LETTER U WITH DIAERESIS BELOW': 7795,
'LATIN SMALL LETTER U WITH DOT BELOW': 7909,
'LATIN SMALL LETTER U WITH DOUBLE ACUTE': 369,
'LATIN SMALL LETTER U WITH DOUBLE GRAVE': 533,
'LATIN SMALL LETTER U WITH GRAVE': 249,
'LATIN SMALL LETTER U WITH HOOK ABOVE': 7911,
'LATIN SMALL LETTER U WITH HORN': 432,
'LATIN SMALL LETTER U WITH HORN AND ACUTE': 7913,
'LATIN SMALL LETTER U WITH HORN AND DOT BELOW': 7921,
'LATIN SMALL LETTER U WITH HORN AND GRAVE': 7915,
'LATIN SMALL LETTER U WITH HORN AND HOOK ABOVE': 7917,
'LATIN SMALL LETTER U WITH HORN AND TILDE': 7919,
'LATIN SMALL LETTER U WITH INVERTED BREVE': 535,
'LATIN SMALL LETTER U WITH MACRON': 363,
'LATIN SMALL LETTER U WITH MACRON AND DIAERESIS': 7803,
'LATIN SMALL LETTER U WITH OGONEK': 371,
'LATIN SMALL LETTER U WITH RETROFLEX HOOK': 7577,
'LATIN SMALL LETTER U WITH RING ABOVE': 367,
'LATIN SMALL LETTER U WITH TILDE': 361,
'LATIN SMALL LETTER U WITH TILDE AND ACUTE': 7801,
'LATIN SMALL LETTER U WITH TILDE BELOW': 7797,
'LATIN SMALL LETTER UE': 7531,
'LATIN SMALL LETTER UM': 42872,
'LATIN SMALL LETTER UPSILON': 650,
'LATIN SMALL LETTER UPSILON WITH STROKE': 7551,
'LATIN SMALL LETTER V': 118,
'LATIN SMALL LETTER V WITH CURL': 11380,
'LATIN SMALL LETTER V WITH DIAGONAL STROKE': 42847,
'LATIN SMALL LETTER V WITH DOT BELOW': 7807,
'LATIN SMALL LETTER V WITH HOOK': 651,
'LATIN SMALL LETTER V WITH PALATAL HOOK': 7564,
'LATIN SMALL LETTER V WITH RIGHT HOOK': 11377,
'LATIN SMALL LETTER V WITH TILDE': 7805,
'LATIN SMALL LETTER VEND': 42857,
'LATIN SMALL LETTER VISIGOTHIC Z': 42851,
'LATIN SMALL LETTER VY': 42849,
'LATIN SMALL LETTER W': 119,
'LATIN SMALL LETTER W WITH ACUTE': 7811,
'LATIN SMALL LETTER W WITH CIRCUMFLEX': 373,
'LATIN SMALL LETTER W WITH DIAERESIS': 7813,
'LATIN SMALL LETTER W WITH DOT ABOVE': 7815,
'LATIN SMALL LETTER W WITH DOT BELOW': 7817,
'LATIN SMALL LETTER W WITH GRAVE': 7809,
'LATIN SMALL LETTER W WITH HOOK': 11379,
'LATIN SMALL LETTER W WITH RING ABOVE': 7832,
'LATIN SMALL LETTER X': 120,
'LATIN SMALL LETTER X WITH DIAERESIS': 7821,
'LATIN SMALL LETTER X WITH DOT ABOVE': 7819,
'LATIN SMALL LETTER X WITH PALATAL HOOK': 7565,
'LATIN SMALL LETTER Y': 121,
'LATIN SMALL LETTER Y WITH ACUTE': 253,
'LATIN SMALL LETTER Y WITH CIRCUMFLEX': 375,
'LATIN SMALL LETTER Y WITH DIAERESIS': 255,
'LATIN SMALL LETTER Y WITH DOT ABOVE': 7823,
'LATIN SMALL LETTER Y WITH DOT BELOW': 7925,
'LATIN SMALL LETTER Y WITH GRAVE': 7923,
'LATIN SMALL LETTER Y WITH HOOK': 436,
'LATIN SMALL LETTER Y WITH HOOK ABOVE': 7927,
'LATIN SMALL LETTER Y WITH LOOP': 7935,
'LATIN SMALL LETTER Y WITH MACRON': 563,
'LATIN SMALL LETTER Y WITH RING ABOVE': 7833,
'LATIN SMALL LETTER Y WITH STROKE': 591,
'LATIN SMALL LETTER Y WITH TILDE': 7929,
'LATIN SMALL LETTER YOGH': 541,
'LATIN SMALL LETTER Z': 122,
'LATIN SMALL LETTER Z WITH ACUTE': 378,
'LATIN SMALL LETTER Z WITH CARON': 382,
'LATIN SMALL LETTER Z WITH CIRCUMFLEX': 7825,
'LATIN SMALL LETTER Z WITH CURL': 657,
'LATIN SMALL LETTER Z WITH DESCENDER': 11372,
'LATIN SMALL LETTER Z WITH DOT ABOVE': 380,
'LATIN SMALL LETTER Z WITH DOT BELOW': 7827,
'LATIN SMALL LETTER Z WITH HOOK': 549,
'LATIN SMALL LETTER Z WITH LINE BELOW': 7829,
'LATIN SMALL LETTER Z WITH MIDDLE TILDE': 7542,
'LATIN SMALL LETTER Z WITH PALATAL HOOK': 7566,
'LATIN SMALL LETTER Z WITH RETROFLEX HOOK': 656,
'LATIN SMALL LETTER Z WITH STROKE': 438,
'LATIN SMALL LETTER Z WITH SWASH TAIL': 576,
'LATIN SMALL LIGATURE FF': 64256,
'LATIN SMALL LIGATURE FFI': 64259,
'LATIN SMALL LIGATURE FFL': 64260,
'LATIN SMALL LIGATURE FI': 64257,
'LATIN SMALL LIGATURE FL': 64258,
'LATIN SMALL LIGATURE IJ': 307,
'LATIN SMALL LIGATURE LONG S T': 64261,
'LATIN SMALL LIGATURE OE': 339,
'LATIN SMALL LIGATURE ST': 64262,
'LATIN SUBSCRIPT SMALL LETTER A': 8336,
'LATIN SUBSCRIPT SMALL LETTER E': 8337,
'LATIN SUBSCRIPT SMALL LETTER I': 7522,
'LATIN SUBSCRIPT SMALL LETTER J': 11388,
'LATIN SUBSCRIPT SMALL LETTER O': 8338,
'LATIN SUBSCRIPT SMALL LETTER R': 7523,
'LATIN SUBSCRIPT SMALL LETTER SCHWA': 8340,
'LATIN SUBSCRIPT SMALL LETTER U': 7524,
'LATIN SUBSCRIPT SMALL LETTER V': 7525,
'LATIN SUBSCRIPT SMALL LETTER X': 8339,
'LEFT AND RIGHT DOUBLE TURNSTILE': 10202,
'LEFT AND RIGHT TACK': 10203,
'LEFT ANGLE BRACKET': 12296,
'LEFT ANGLE BRACKET WITH DOT': 10641,
'LEFT ARC LESS-THAN BRACKET': 10643,
'LEFT ARROW WITH CIRCLED PLUS': 11058,
'LEFT ARROW WITH SMALL CIRCLE': 11056,
'LEFT BARB DOWN RIGHT BARB DOWN HARPOON': 10576,
'LEFT BARB DOWN RIGHT BARB UP HARPOON': 10571,
'LEFT BARB UP RIGHT BARB DOWN HARPOON': 10570,
'LEFT BARB UP RIGHT BARB UP HARPOON': 10574,
'LEFT BLACK LENTICULAR BRACKET': 12304,
'LEFT BLACK TORTOISE SHELL BRACKET': 10647,
'LEFT CEILING': 8968,
'LEFT CLOSED ENTRY': 9948,
'LEFT CORNER BRACKET': 12300,
'LEFT CURLY BRACKET': 123,
'LEFT CURLY BRACKET LOWER HOOK': 9129,
'LEFT CURLY BRACKET MIDDLE PIECE': 9128,
'LEFT CURLY BRACKET UPPER HOOK': 9127,
'LEFT DOTTED SUBSTITUTION BRACKET': 11780,
'LEFT DOUBLE ANGLE BRACKET': 12298,
'LEFT DOUBLE PARENTHESIS': 11816,
'LEFT DOUBLE QUOTATION MARK': 8220,
'LEFT DOUBLE WIGGLY FENCE': 10714,
'LEFT FISH TAIL': 10620,
'LEFT FIVE EIGHTHS BLOCK': 9611,
'LEFT FLOOR': 8970,
'LEFT HALF BLACK CIRCLE': 9686,
'LEFT HALF BLOCK': 9612,
'LEFT LOW PARAPHRASE BRACKET': 11804,
'LEFT MULTIMAP': 10204,
'LEFT NORMAL FACTOR SEMIDIRECT PRODUCT': 8905,
'LEFT ONE EIGHTH BLOCK': 9615,
'LEFT ONE QUARTER BLOCK': 9614,
'LEFT OUTER JOIN': 10197,
'LEFT PARENTHESIS': 40,
'LEFT PARENTHESIS EXTENSION': 9116,
'LEFT PARENTHESIS LOWER HOOK': 9117,
'LEFT PARENTHESIS UPPER HOOK': 9115,
'LEFT RAISED OMISSION BRACKET': 11788,
'LEFT RIGHT ARROW': 8596,
'LEFT RIGHT ARROW THROUGH SMALL CIRCLE': 10568,
'LEFT RIGHT ARROW WITH DOUBLE VERTICAL STROKE': 8700,
'LEFT RIGHT ARROW WITH STROKE': 8622,
'LEFT RIGHT ARROW WITH VERTICAL STROKE': 8697,
'LEFT RIGHT BLACK ARROW': 11020,
'LEFT RIGHT DOUBLE ARROW': 8660,
'LEFT RIGHT DOUBLE ARROW WITH STROKE': 8654,
'LEFT RIGHT DOUBLE ARROW WITH VERTICAL STROKE': 10500,
'LEFT RIGHT OPEN-HEADED ARROW': 8703,
'LEFT RIGHT WAVE ARROW': 8621,
'LEFT RIGHT WHITE ARROW': 11012,
'LEFT S-SHAPED BAG DELIMITER': 10181,
'LEFT SEMIDIRECT PRODUCT': 8907,
'LEFT SEVEN EIGHTHS BLOCK': 9609,
'LEFT SIDEWAYS U BRACKET': 11814,
'LEFT SINGLE QUOTATION MARK': 8216,
'LEFT SQUARE BRACKET': 91,
'LEFT SQUARE BRACKET EXTENSION': 9122,
'LEFT SQUARE BRACKET LOWER CORNER': 9123,
'LEFT SQUARE BRACKET UPPER CORNER': 9121,
'LEFT SQUARE BRACKET WITH QUILL': 8261,
'LEFT SQUARE BRACKET WITH TICK IN BOTTOM CORNER': 10639,
'LEFT SQUARE BRACKET WITH TICK IN TOP CORNER': 10637,
'LEFT SQUARE BRACKET WITH UNDERBAR': 10635,
'LEFT SUBSTITUTION BRACKET': 11778,
'LEFT TACK': 8867,
'LEFT THREE EIGHTHS BLOCK': 9613,
'LEFT THREE QUARTERS BLOCK': 9610,
'LEFT TORTOISE SHELL BRACKET': 12308,
'LEFT TRANSPOSITION BRACKET': 11785,
'LEFT TRIANGLE BESIDE VERTICAL BAR': 10703,
'LEFT VERTICAL BAR WITH QUILL': 11808,
'LEFT VERTICAL BOX LINE': 9144,
'LEFT WHITE CORNER BRACKET': 12302,
'LEFT WHITE CURLY BRACKET': 10627,
'LEFT WHITE LENTICULAR BRACKET': 12310,
'LEFT WHITE PARENTHESIS': 10629,
'LEFT WHITE SQUARE BRACKET': 12314,
'LEFT WHITE TORTOISE SHELL BRACKET': 12312,
'LEFT WIGGLY FENCE': 10712,
'LEFT-FACING SVASTI SIGN': 4054,
'LEFT-FACING SVASTI SIGN WITH DOTS': 4056,
'LEFT-POINTING ANGLE BRACKET': 9001,
'LEFT-POINTING CURVED ANGLE BRACKET': 10748,
'LEFT-POINTING DOUBLE ANGLE QUOTATION MARK': 171,
'LEFT-SHADED WHITE RIGHTWARDS ARROW': 10154,
'LEFT-SIDE ARC ANTICLOCKWISE ARROW': 10553,
'LEFT-TO-RIGHT EMBEDDING': 8234,
'LEFT-TO-RIGHT MARK': 8206,
'LEFT-TO-RIGHT OVERRIDE': 8237,
'LEFTWARDS ARROW': 8592,
'LEFTWARDS ARROW ABOVE ALMOST EQUAL TO': 11082,
'LEFTWARDS ARROW ABOVE REVERSE ALMOST EQUAL TO': 11074,
'LEFTWARDS ARROW ABOVE REVERSE TILDE OPERATOR': 11083,
'LEFTWARDS ARROW ABOVE SHORT RIGHTWARDS ARROW': 10563,
'LEFTWARDS ARROW ABOVE TILDE OPERATOR': 10611,
'LEFTWARDS ARROW FROM BAR': 8612,
'LEFTWARDS ARROW FROM BAR TO BLACK DIAMOND': 10527,
'LEFTWARDS ARROW OVER RIGHTWARDS ARROW': 8646,
'LEFTWARDS ARROW THROUGH LESS-THAN': 10615,
'LEFTWARDS ARROW THROUGH SUBSET': 10618,
'LEFTWARDS ARROW THROUGH X': 11070,
'LEFTWARDS ARROW TO BAR': 8676,
'LEFTWARDS ARROW TO BAR OVER RIGHTWARDS ARROW TO BAR': 8633,
'LEFTWARDS ARROW TO BLACK DIAMOND': 10525,
'LEFTWARDS ARROW WITH DOTTED STEM': 11064,
'LEFTWARDS ARROW WITH DOUBLE VERTICAL STROKE': 8698,
'LEFTWARDS ARROW WITH HOOK': 8617,
'LEFTWARDS ARROW WITH LOOP': 8619,
'LEFTWARDS ARROW WITH PLUS BELOW': 10566,
'LEFTWARDS ARROW WITH STROKE': 8602,
'LEFTWARDS ARROW WITH TAIL': 8610,
'LEFTWARDS ARROW WITH TAIL WITH DOUBLE VERTICAL STROKE': 11066,
'LEFTWARDS ARROW WITH TAIL WITH VERTICAL STROKE': 11065,
'LEFTWARDS ARROW WITH TIP DOWNWARDS': 11024,
'LEFTWARDS ARROW WITH TIP UPWARDS': 11025,
'LEFTWARDS ARROW WITH VERTICAL STROKE': 8695,
'LEFTWARDS ARROW-TAIL': 10521,
'LEFTWARDS BLACK ARROW': 11013,
'LEFTWARDS DASHED ARROW': 8672,
'LEFTWARDS DOUBLE ARROW': 8656,
'LEFTWARDS DOUBLE ARROW FROM BAR': 10502,
'LEFTWARDS DOUBLE ARROW WITH STROKE': 8653,
'LEFTWARDS DOUBLE ARROW WITH VERTICAL STROKE': 10498,
'LEFTWARDS DOUBLE ARROW-TAIL': 10523,
'LEFTWARDS DOUBLE DASH ARROW': 10508,
'LEFTWARDS HARPOON OVER RIGHTWARDS HARPOON': 8651,
'LEFTWARDS HARPOON WITH BARB DOWN ABOVE RIGHTWARDS HARPOON WITH BARB DOWN': 10599,
'LEFTWARDS HARPOON WITH BARB DOWN BELOW LONG DASH': 10603,
'LEFTWARDS HARPOON WITH BARB DOWN FROM BAR': 10590,
'LEFTWARDS HARPOON WITH BARB DOWN TO BAR': 10582,
'LEFTWARDS HARPOON WITH BARB DOWNWARDS': 8637,
'LEFTWARDS HARPOON WITH BARB UP ABOVE LEFTWARDS HARPOON WITH BARB DOWN': 10594,
'LEFTWARDS HARPOON WITH BARB UP ABOVE LONG DASH': 10602,
'LEFTWARDS HARPOON WITH BARB UP ABOVE RIGHTWARDS HARPOON WITH BARB UP': 10598,
'LEFTWARDS HARPOON WITH BARB UP FROM BAR': 10586,
'LEFTWARDS HARPOON WITH BARB UP TO BAR': 10578,
'LEFTWARDS HARPOON WITH BARB UPWARDS': 8636,
'LEFTWARDS OPEN-HEADED ARROW': 8701,
'LEFTWARDS PAIRED ARROWS': 8647,
'LEFTWARDS QUADRUPLE ARROW': 11077,
'LEFTWARDS SQUIGGLE ARROW': 8668,
'LEFTWARDS TRIPLE ARROW': 8666,
'LEFTWARDS TRIPLE DASH ARROW': 10510,
'LEFTWARDS TWO HEADED ARROW': 8606,
'LEFTWARDS TWO-HEADED ARROW FROM BAR': 11062,
'LEFTWARDS TWO-HEADED ARROW WITH DOUBLE VERTICAL STROKE': 11061,
'LEFTWARDS TWO-HEADED ARROW WITH TAIL': 11067,
'LEFTWARDS TWO-HEADED ARROW WITH TAIL WITH DOUBLE VERTICAL STROKE': 11069,
'LEFTWARDS TWO-HEADED ARROW WITH TAIL WITH VERTICAL STROKE': 11068,
'LEFTWARDS TWO-HEADED ARROW WITH VERTICAL STROKE': 11060,
'LEFTWARDS TWO-HEADED TRIPLE DASH ARROW': 11063,
'LEFTWARDS WAVE ARROW': 8604,
'LEFTWARDS WHITE ARROW': 8678,
'LEO': 9804,
'LEPCHA CONSONANT SIGN K': 7213,
'LEPCHA CONSONANT SIGN KANG': 7221,
'LEPCHA CONSONANT SIGN L': 7215,
'LEPCHA CONSONANT SIGN M': 7214,
'LEPCHA CONSONANT SIGN N': 7216,
'LEPCHA CONSONANT SIGN NYIN-DO': 7220,
'LEPCHA CONSONANT SIGN P': 7217,
'LEPCHA CONSONANT SIGN R': 7218,
'LEPCHA CONSONANT SIGN T': 7219,
'LEPCHA DIGIT EIGHT': 7240,
'LEPCHA DIGIT FIVE': 7237,
'LEPCHA DIGIT FOUR': 7236,
'LEPCHA DIGIT NINE': 7241,
'LEPCHA DIGIT ONE': 7233,
'LEPCHA DIGIT SEVEN': 7239,
'LEPCHA DIGIT SIX': 7238,
'LEPCHA DIGIT THREE': 7235,
'LEPCHA DIGIT TWO': 7234,
'LEPCHA DIGIT ZERO': 7232,
'LEPCHA LETTER A': 7203,
'LEPCHA LETTER BA': 7187,
'LEPCHA LETTER BLA': 7188,
'LEPCHA LETTER CA': 7174,
'LEPCHA LETTER CHA': 7175,
'LEPCHA LETTER DA': 7180,
'LEPCHA LETTER DDA': 7247,
'LEPCHA LETTER DZA': 7193,
'LEPCHA LETTER FA': 7185,
'LEPCHA LETTER FLA': 7186,
'LEPCHA LETTER GA': 7171,
'LEPCHA LETTER GLA': 7172,
'LEPCHA LETTER HA': 7197,
'LEPCHA LETTER HLA': 7198,
'LEPCHA LETTER JA': 7176,
'LEPCHA LETTER KA': 7168,
'LEPCHA LETTER KHA': 7170,
'LEPCHA LETTER KLA': 7169,
'LEPCHA LETTER LA': 7196,
'LEPCHA LETTER MA': 7189,
'LEPCHA LETTER MLA': 7190,
'LEPCHA LETTER NA': 7181,
'LEPCHA LETTER NGA': 7173,
'LEPCHA LETTER NYA': 7177,
'LEPCHA LETTER PA': 7182,
'LEPCHA LETTER PHA': 7184,
'LEPCHA LETTER PLA': 7183,
'LEPCHA LETTER RA': 7195,
'LEPCHA LETTER SA': 7200,
'LEPCHA LETTER SHA': 7201,
'LEPCHA LETTER TA': 7178,
'LEPCHA LETTER THA': 7179,
'LEPCHA LETTER TSA': 7191,
'LEPCHA LETTER TSHA': 7192,
'LEPCHA LETTER TTA': 7245,
'LEPCHA LETTER TTHA': 7246,
'LEPCHA LETTER VA': 7199,
'LEPCHA LETTER WA': 7202,
'LEPCHA LETTER YA': 7194,
'LEPCHA PUNCTUATION CER-WA': 7229,
'LEPCHA PUNCTUATION NYET THYOOM TA-ROL': 7228,
'LEPCHA PUNCTUATION TA-ROL': 7227,
'LEPCHA PUNCTUATION TSHOOK': 7231,
'LEPCHA PUNCTUATION TSHOOK CER-WA': 7230,
'LEPCHA SIGN NUKTA': 7223,
'LEPCHA SIGN RAN': 7222,
'LEPCHA SUBJOINED LETTER RA': 7205,
'LEPCHA SUBJOINED LETTER YA': 7204,
'LEPCHA VOWEL SIGN AA': 7206,
'LEPCHA VOWEL SIGN E': 7212,
'LEPCHA VOWEL SIGN I': 7207,
'LEPCHA VOWEL SIGN O': 7208,
'LEPCHA VOWEL SIGN OO': 7209,
'LEPCHA VOWEL SIGN U': 7210,
'LEPCHA VOWEL SIGN UU': 7211,
'LESS-THAN ABOVE DOUBLE-LINE EQUAL ABOVE GREATER-THAN': 10891,
'LESS-THAN ABOVE GREATER-THAN ABOVE DOUBLE-LINE EQUAL': 10897,
'LESS-THAN ABOVE LEFTWARDS ARROW': 10614,
'LESS-THAN ABOVE SIMILAR ABOVE GREATER-THAN': 10895,
'LESS-THAN ABOVE SIMILAR OR EQUAL': 10893,
'LESS-THAN ABOVE SLANTED EQUAL ABOVE GREATER-THAN ABOVE SLANTED EQUAL': 10899,
'LESS-THAN AND NOT APPROXIMATE': 10889,
'LESS-THAN AND SINGLE-LINE NOT EQUAL TO': 10887,
'LESS-THAN BUT NOT EQUAL TO': 8808,
'LESS-THAN BUT NOT EQUIVALENT TO': 8934,
'LESS-THAN CLOSED BY CURVE': 10918,
'LESS-THAN CLOSED BY CURVE ABOVE SLANTED EQUAL': 10920,
'LESS-THAN EQUAL TO OR GREATER-THAN': 8922,
'LESS-THAN OR APPROXIMATE': 10885,
'LESS-THAN OR EQUAL TO': 8804,
'LESS-THAN OR EQUIVALENT TO': 8818,
'LESS-THAN OR GREATER-THAN': 8822,
'LESS-THAN OR SLANTED EQUAL TO': 10877,
'LESS-THAN OR SLANTED EQUAL TO WITH DOT ABOVE': 10881,
'LESS-THAN OR SLANTED EQUAL TO WITH DOT ABOVE RIGHT': 10883,
'LESS-THAN OR SLANTED EQUAL TO WITH DOT INSIDE': 10879,
'LESS-THAN OVER EQUAL TO': 8806,
'LESS-THAN SIGN': 60,
'LESS-THAN WITH CIRCLE INSIDE': 10873,
'LESS-THAN WITH DOT': 8918,
'LESS-THAN WITH QUESTION MARK ABOVE': 10875,
'LIBRA': 9806,
'LIGHT LEFT TORTOISE SHELL BRACKET ORNAMENT': 10098,
'LIGHT RIGHT TORTOISE SHELL BRACKET ORNAMENT': 10099,
'LIGHT SHADE': 9617,
'LIGHT VERTICAL BAR': 10072,
'LIGHTNING': 9735,
'LIMBU DIGIT EIGHT': 6478,
'LIMBU DIGIT FIVE': 6475,
'LIMBU DIGIT FOUR': 6474,
'LIMBU DIGIT NINE': 6479,
'LIMBU DIGIT ONE': 6471,
'LIMBU DIGIT SEVEN': 6477,
'LIMBU DIGIT SIX': 6476,
'LIMBU DIGIT THREE': 6473,
'LIMBU DIGIT TWO': 6472,
'LIMBU DIGIT ZERO': 6470,
'LIMBU EXCLAMATION MARK': 6468,
'LIMBU LETTER BA': 6418,
'LIMBU LETTER BHA': 6419,
'LIMBU LETTER CA': 6406,
'LIMBU LETTER CHA': 6407,
'LIMBU LETTER DA': 6413,
'LIMBU LETTER DHA': 6414,
'LIMBU LETTER GA': 6403,
'LIMBU LETTER GHA': 6404,
'LIMBU LETTER HA': 6428,
'LIMBU LETTER JA': 6408,
'LIMBU LETTER JHA': 6409,
'LIMBU LETTER KA': 6401,
'LIMBU LETTER KHA': 6402,
'LIMBU LETTER LA': 6423,
'LIMBU LETTER MA': 6420,
'LIMBU LETTER NA': 6415,
'LIMBU LETTER NGA': 6405,
'LIMBU LETTER PA': 6416,
'LIMBU LETTER PHA': 6417,
'LIMBU LETTER RA': 6422,
'LIMBU LETTER SA': 6427,
'LIMBU LETTER SHA': 6425,
'LIMBU LETTER SSA': 6426,
'LIMBU LETTER TA': 6411,
'LIMBU LETTER THA': 6412,
'LIMBU LETTER WA': 6424,
'LIMBU LETTER YA': 6421,
'LIMBU LETTER YAN': 6410,
'LIMBU QUESTION MARK': 6469,
'LIMBU SIGN KEMPHRENG': 6458,
'LIMBU SIGN LOO': 6464,
'LIMBU SIGN MUKPHRENG': 6457,
'LIMBU SIGN SA-I': 6459,
'LIMBU SMALL LETTER ANUSVARA': 6450,
'LIMBU SMALL LETTER KA': 6448,
'LIMBU SMALL LETTER LA': 6456,
'LIMBU SMALL LETTER MA': 6454,
'LIMBU SMALL LETTER NA': 6452,
'LIMBU SMALL LETTER NGA': 6449,
'LIMBU SMALL LETTER PA': 6453,
'LIMBU SMALL LETTER RA': 6455,
'LIMBU SMALL LETTER TA': 6451,
'LIMBU SUBJOINED LETTER RA': 6442,
'LIMBU SUBJOINED LETTER WA': 6443,
'LIMBU SUBJOINED LETTER YA': 6441,
'LIMBU VOWEL SIGN A': 6432,
'LIMBU VOWEL SIGN AI': 6436,
'LIMBU VOWEL SIGN AU': 6438,
'LIMBU VOWEL SIGN E': 6439,
'LIMBU VOWEL SIGN EE': 6435,
'LIMBU VOWEL SIGN I': 6433,
'LIMBU VOWEL SIGN O': 6440,
'LIMBU VOWEL SIGN OO': 6437,
'LIMBU VOWEL SIGN U': 6434,
'LIMBU VOWEL-CARRIER LETTER': 6400,
'LIMITED LIABILITY SIGN': 13007,
'LINE INTEGRATION NOT INCLUDING THE POLE': 10772,
'LINE INTEGRATION WITH RECTANGULAR PATH AROUND POLE': 10770,
'LINE INTEGRATION WITH SEMICIRCULAR PATH AROUND POLE': 10771,
'LINE SEPARATOR': 8232,
'LINEAR B IDEOGRAM B100 MAN': 65664,
'LINEAR B IDEOGRAM B102 WOMAN': 65665,
'LINEAR B IDEOGRAM B104 DEER': 65666,
'LINEAR B IDEOGRAM B105 EQUID': 65667,
'LINEAR B IDEOGRAM B105F MARE': 65668,
'LINEAR B IDEOGRAM B105M STALLION': 65669,
'LINEAR B IDEOGRAM B106F EWE': 65670,
'LINEAR B IDEOGRAM B106M RAM': 65671,
'LINEAR B IDEOGRAM B107F SHE-GOAT': 65672,
'LINEAR B IDEOGRAM B107M HE-GOAT': 65673,
'LINEAR B IDEOGRAM B108F SOW': 65674,
'LINEAR B IDEOGRAM B108M BOAR': 65675,
'LINEAR B IDEOGRAM B109F COW': 65676,
'LINEAR B IDEOGRAM B109M BULL': 65677,
'LINEAR B IDEOGRAM B120 WHEAT': 65678,
'LINEAR B IDEOGRAM B121 BARLEY': 65679,
'LINEAR B IDEOGRAM B122 OLIVE': 65680,
'LINEAR B IDEOGRAM B123 SPICE': 65681,
'LINEAR B IDEOGRAM B125 CYPERUS': 65682,
'LINEAR B IDEOGRAM B130 OIL': 65685,
'LINEAR B IDEOGRAM B131 WINE': 65686,
'LINEAR B IDEOGRAM B132': 65687,
'LINEAR B IDEOGRAM B140 BRONZE': 65690,
'LINEAR B IDEOGRAM B141 GOLD': 65691,
'LINEAR B IDEOGRAM B142': 65692,
'LINEAR B IDEOGRAM B145 WOOL': 65693,
'LINEAR B IDEOGRAM B146': 65694,
'LINEAR B IDEOGRAM B150': 65695,
'LINEAR B IDEOGRAM B151 HORN': 65696,
'LINEAR B IDEOGRAM B152': 65697,
'LINEAR B IDEOGRAM B153': 65698,
'LINEAR B IDEOGRAM B154': 65699,
'LINEAR B IDEOGRAM B157': 65701,
'LINEAR B IDEOGRAM B158': 65702,
'LINEAR B IDEOGRAM B159 CLOTH': 65703,
'LINEAR B IDEOGRAM B160': 65704,
'LINEAR B IDEOGRAM B161': 65705,
'LINEAR B IDEOGRAM B162 GARMENT': 65706,
'LINEAR B IDEOGRAM B163 ARMOUR': 65707,
'LINEAR B IDEOGRAM B164': 65708,
'LINEAR B IDEOGRAM B165': 65709,
'LINEAR B IDEOGRAM B166': 65710,
'LINEAR B IDEOGRAM B167': 65711,
'LINEAR B IDEOGRAM B168': 65712,
'LINEAR B IDEOGRAM B169': 65713,
'LINEAR B IDEOGRAM B170': 65714,
'LINEAR B IDEOGRAM B171': 65715,
'LINEAR B IDEOGRAM B172': 65716,
'LINEAR B IDEOGRAM B173 MONTH': 65717,
'LINEAR B IDEOGRAM B174': 65718,
'LINEAR B IDEOGRAM B176 TREE': 65719,
'LINEAR B IDEOGRAM B177': 65720,
'LINEAR B IDEOGRAM B178': 65721,
'LINEAR B IDEOGRAM B179': 65722,
'LINEAR B IDEOGRAM B180': 65723,
'LINEAR B IDEOGRAM B181': 65724,
'LINEAR B IDEOGRAM B182': 65725,
'LINEAR B IDEOGRAM B183': 65726,
'LINEAR B IDEOGRAM B184': 65727,
'LINEAR B IDEOGRAM B185': 65728,
'LINEAR B IDEOGRAM B189': 65729,
'LINEAR B IDEOGRAM B190': 65730,
'LINEAR B IDEOGRAM B191 HELMET': 65731,
'LINEAR B IDEOGRAM B220 FOOTSTOOL': 65732,
'LINEAR B IDEOGRAM B225 BATHTUB': 65733,
'LINEAR B IDEOGRAM B230 SPEAR': 65734,
'LINEAR B IDEOGRAM B231 ARROW': 65735,
'LINEAR B IDEOGRAM B232': 65736,
'LINEAR B IDEOGRAM B233 SWORD': 65737,
'LINEAR B IDEOGRAM B234': 65738,
'LINEAR B IDEOGRAM B236': 65739,
'LINEAR B IDEOGRAM B240 WHEELED CHARIOT': 65740,
'LINEAR B IDEOGRAM B241 CHARIOT': 65741,
'LINEAR B IDEOGRAM B242 CHARIOT FRAME': 65742,
'LINEAR B IDEOGRAM B243 WHEEL': 65743,
'LINEAR B IDEOGRAM B245': 65744,
'LINEAR B IDEOGRAM B246': 65745,
'LINEAR B IDEOGRAM B248': 65747,
'LINEAR B IDEOGRAM B249': 65748,
'LINEAR B IDEOGRAM B251': 65749,
'LINEAR B IDEOGRAM B252': 65750,
'LINEAR B IDEOGRAM B253': 65751,
'LINEAR B IDEOGRAM B254 DART': 65752,
'LINEAR B IDEOGRAM B255': 65753,
'LINEAR B IDEOGRAM B256': 65754,
'LINEAR B IDEOGRAM B257': 65755,
'LINEAR B IDEOGRAM B258': 65756,
'LINEAR B IDEOGRAM B259': 65757,
'LINEAR B IDEOGRAM VESSEL B155': 65758,
'LINEAR B IDEOGRAM VESSEL B200': 65759,
'LINEAR B IDEOGRAM VESSEL B201': 65760,
'LINEAR B IDEOGRAM VESSEL B202': 65761,
'LINEAR B IDEOGRAM VESSEL B203': 65762,
'LINEAR B IDEOGRAM VESSEL B204': 65763,
'LINEAR B IDEOGRAM VESSEL B205': 65764,
'LINEAR B IDEOGRAM VESSEL B206': 65765,
'LINEAR B IDEOGRAM VESSEL B207': 65766,
'LINEAR B IDEOGRAM VESSEL B208': 65767,
'LINEAR B IDEOGRAM VESSEL B209': 65768,
'LINEAR B IDEOGRAM VESSEL B210': 65769,
'LINEAR B IDEOGRAM VESSEL B211': 65770,
'LINEAR B IDEOGRAM VESSEL B212': 65771,
'LINEAR B IDEOGRAM VESSEL B213': 65772,
'LINEAR B IDEOGRAM VESSEL B214': 65773,
'LINEAR B IDEOGRAM VESSEL B215': 65774,
'LINEAR B IDEOGRAM VESSEL B216': 65775,
'LINEAR B IDEOGRAM VESSEL B217': 65776,
'LINEAR B IDEOGRAM VESSEL B218': 65777,
'LINEAR B IDEOGRAM VESSEL B219': 65778,
'LINEAR B IDEOGRAM VESSEL B221': 65779,
'LINEAR B IDEOGRAM VESSEL B222': 65780,
'LINEAR B IDEOGRAM VESSEL B226': 65781,
'LINEAR B IDEOGRAM VESSEL B227': 65782,
'LINEAR B IDEOGRAM VESSEL B228': 65783,
'LINEAR B IDEOGRAM VESSEL B229': 65784,
'LINEAR B IDEOGRAM VESSEL B250': 65785,
'LINEAR B IDEOGRAM VESSEL B305': 65786,
'LINEAR B MONOGRAM B127 KAPO': 65683,
'LINEAR B MONOGRAM B128 KANAKO': 65684,
'LINEAR B MONOGRAM B133 AREPA': 65688,
'LINEAR B MONOGRAM B135 MERI': 65689,
'LINEAR B MONOGRAM B156 TURO2': 65700,
'LINEAR B MONOGRAM B247 DIPTE': 65746,
'LINEAR B SYLLABLE B001 DA': 65541,
'LINEAR B SYLLABLE B002 RO': 65579,
'LINEAR B SYLLABLE B003 PA': 65566,
'LINEAR B SYLLABLE B004 TE': 65587,
'LINEAR B SYLLABLE B005 TO': 65589,
'LINEAR B SYLLABLE B006 NA': 65561,
'LINEAR B SYLLABLE B007 DI': 65543,
'LINEAR B SYLLABLE B008 A': 65536,
'LINEAR B SYLLABLE B009 SE': 65582,
'LINEAR B SYLLABLE B010 U': 65540,
'LINEAR B SYLLABLE B011 PO': 65569,
'LINEAR B SYLLABLE B012 SO': 65584,
'LINEAR B SYLLABLE B013 ME': 65557,
'LINEAR B SYLLABLE B014 DO': 65544,
'LINEAR B SYLLABLE B015 MO': 65559,
'LINEAR B SYLLABLE B016 QA': 65571,
'LINEAR B SYLLABLE B017 ZA': 65596,
'LINEAR B SYLLABLE B020 ZO': 65599,
'LINEAR B SYLLABLE B021 QI': 65573,
'LINEAR B SYLLABLE B023 MU': 65560,
'LINEAR B SYLLABLE B024 NE': 65562,
'LINEAR B SYLLABLE B025 A2': 65600,
'LINEAR B SYLLABLE B026 RU': 65580,
'LINEAR B SYLLABLE B027 RE': 65577,
'LINEAR B SYLLABLE B028 I': 65538,
'LINEAR B SYLLABLE B029 PU2': 65606,
'LINEAR B SYLLABLE B030 NI': 65563,
'LINEAR B SYLLABLE B031 SA': 65581,
'LINEAR B SYLLABLE B032 QO': 65574,
'LINEAR B SYLLABLE B033 RA3': 65609,
'LINEAR B SYLLABLE B036 JO': 65549,
'LINEAR B SYLLABLE B037 TI': 65588,
'LINEAR B SYLLABLE B038 E': 65537,
'LINEAR B SYLLABLE B039 PI': 65568,
'LINEAR B SYLLABLE B040 WI': 65593,
'LINEAR B SYLLABLE B041 SI': 65583,
'LINEAR B SYLLABLE B042 WO': 65594,
'LINEAR B SYLLABLE B043 A3': 65601,
'LINEAR B SYLLABLE B044 KE': 65552,
'LINEAR B SYLLABLE B045 DE': 65542,
'LINEAR B SYLLABLE B046 JE': 65547,
'LINEAR B SYLLABLE B048 NWA': 65605,
'LINEAR B SYLLABLE B050 PU': 65570,
'LINEAR B SYLLABLE B051 DU': 65545,
'LINEAR B SYLLABLE B052 NO': 65564,
'LINEAR B SYLLABLE B053 RI': 65578,
'LINEAR B SYLLABLE B054 WA': 65591,
'LINEAR B SYLLABLE B055 NU': 65565,
'LINEAR B SYLLABLE B057 JA': 65546,
'LINEAR B SYLLABLE B058 SU': 65585,
'LINEAR B SYLLABLE B059 TA': 65586,
'LINEAR B SYLLABLE B060 RA': 65576,
'LINEAR B SYLLABLE B061 O': 65539,
'LINEAR B SYLLABLE B062 PTE': 65607,
'LINEAR B SYLLABLE B065 JU': 65550,
'LINEAR B SYLLABLE B066 TA2': 65611,
'LINEAR B SYLLABLE B067 KI': 65553,
'LINEAR B SYLLABLE B068 RO2': 65610,
'LINEAR B SYLLABLE B069 TU': 65590,
'LINEAR B SYLLABLE B070 KO': 65554,
'LINEAR B SYLLABLE B071 DWE': 65603,
'LINEAR B SYLLABLE B072 PE': 65567,
'LINEAR B SYLLABLE B073 MI': 65558,
'LINEAR B SYLLABLE B074 ZE': 65597,
'LINEAR B SYLLABLE B075 WE': 65592,
'LINEAR B SYLLABLE B076 RA2': 65608,
'LINEAR B SYLLABLE B077 KA': 65551,
'LINEAR B SYLLABLE B078 QE': 65572,
'LINEAR B SYLLABLE B080 MA': 65556,
'LINEAR B SYLLABLE B081 KU': 65555,
'LINEAR B SYLLABLE B085 AU': 65602,
'LINEAR B SYLLABLE B087 TWE': 65612,
'LINEAR B SYLLABLE B090 DWO': 65604,
'LINEAR B SYLLABLE B091 TWO': 65613,
'LINEAR B SYMBOL B018': 65616,
'LINEAR B SYMBOL B019': 65617,
'LINEAR B SYMBOL B022': 65618,
'LINEAR B SYMBOL B034': 65619,
'LINEAR B SYMBOL B047': 65620,
'LINEAR B SYMBOL B049': 65621,
'LINEAR B SYMBOL B056': 65622,
'LINEAR B SYMBOL B063': 65623,
'LINEAR B SYMBOL B064': 65624,
'LINEAR B SYMBOL B079': 65625,
'LINEAR B SYMBOL B082': 65626,
'LINEAR B SYMBOL B083': 65627,
'LINEAR B SYMBOL B086': 65628,
'LINEAR B SYMBOL B089': 65629,
'LIRA SIGN': 8356,
'LISU LETTER A': 42222,
'LISU LETTER AE': 42223,
'LISU LETTER BA': 42192,
'LISU LETTER CA': 42202,
'LISU LETTER CHA': 42203,
'LISU LETTER DA': 42195,
'LISU LETTER DZA': 42204,
'LISU LETTER E': 42224,
'LISU LETTER EU': 42225,
'LISU LETTER FA': 42217,
'LISU LETTER GA': 42198,
'LISU LETTER GHA': 42221,
'LISU LETTER HA': 42214,
'LISU LETTER HHA': 42216,
'LISU LETTER I': 42226,
'LISU LETTER JA': 42201,
'LISU LETTER KA': 42199,
'LISU LETTER KHA': 42200,
'LISU LETTER LA': 42209,
'LISU LETTER MA': 42207,
'LISU LETTER NA': 42208,
'LISU LETTER NGA': 42213,
'LISU LETTER O': 42227,
'LISU LETTER OE': 42231,
'LISU LETTER PA': 42193,
'LISU LETTER PHA': 42194,
'LISU LETTER SA': 42210,
'LISU LETTER SHA': 42219,
'LISU LETTER TA': 42196,
'LISU LETTER THA': 42197,
'LISU LETTER TONE MYA BO': 42235,
'LISU LETTER TONE MYA CYA': 42234,
'LISU LETTER TONE MYA JEU': 42237,
'LISU LETTER TONE MYA NA': 42236,
'LISU LETTER TONE MYA TI': 42232,
'LISU LETTER TONE NA PO': 42233,
'LISU LETTER TSA': 42205,
'LISU LETTER TSHA': 42206,
'LISU LETTER U': 42228,
'LISU LETTER UE': 42229,
'LISU LETTER UH': 42230,
'LISU LETTER WA': 42218,
'LISU LETTER XA': 42215,
'LISU LETTER YA': 42220,
'LISU LETTER ZA': 42212,
'LISU LETTER ZHA': 42211,
'LISU PUNCTUATION COMMA': 42238,
'LISU PUNCTUATION FULL STOP': 42239,
'LIVRE TOURNOIS SIGN': 8374,
'LOGICAL AND': 8743,
'LOGICAL AND WITH DOT ABOVE': 10833,
'LOGICAL AND WITH DOUBLE OVERBAR': 10846,
'LOGICAL AND WITH DOUBLE UNDERBAR': 10848,
'LOGICAL AND WITH HORIZONTAL DASH': 10844,
'LOGICAL AND WITH MIDDLE STEM': 10842,
'LOGICAL AND WITH UNDERBAR': 10847,
'LOGICAL OR': 8744,
'LOGICAL OR OVERLAPPING LOGICAL AND': 10841,
'LOGICAL OR WITH DOT ABOVE': 10834,
'LOGICAL OR WITH DOUBLE OVERBAR': 10850,
'LOGICAL OR WITH DOUBLE UNDERBAR': 10851,
'LOGICAL OR WITH HORIZONTAL DASH': 10845,
'LOGICAL OR WITH MIDDLE STEM': 10843,
'LONG DASH FROM LEFT MEMBER OF DOUBLE VERTICAL': 10982,
'LONG DIVISION': 10188,
'LONG LEFT RIGHT ARROW': 10231,
'LONG LEFT RIGHT DOUBLE ARROW': 10234,
'LONG LEFT TACK': 10206,
'LONG LEFTWARDS ARROW': 10229,
'LONG LEFTWARDS ARROW FROM BAR': 10235,
'LONG LEFTWARDS DOUBLE ARROW': 10232,
'LONG LEFTWARDS DOUBLE ARROW FROM BAR': 10237,
'LONG LEFTWARDS SQUIGGLE ARROW': 11059,
'LONG RIGHT TACK': 10205,
'LONG RIGHTWARDS ARROW': 10230,
'LONG RIGHTWARDS ARROW FROM BAR': 10236,
'LONG RIGHTWARDS DOUBLE ARROW': 10233,
'LONG RIGHTWARDS DOUBLE ARROW FROM BAR': 10238,
'LONG RIGHTWARDS SQUIGGLE ARROW': 10239,
'LOW ASTERISK': 8270,
'LOW DOUBLE PRIME QUOTATION MARK': 12319,
'LOW LINE': 95,
'LOWER BLADE SCISSORS': 9987,
'LOWER FIVE EIGHTHS BLOCK': 9605,
'LOWER HALF BLOCK': 9604,
'LOWER HALF CIRCLE': 9697,
'LOWER HALF INVERSE WHITE CIRCLE': 9691,
'LOWER LEFT QUADRANT CIRCULAR ARC': 9695,
'LOWER LEFT SEMICIRCULAR ANTICLOCKWISE ARROW': 10559,
'LOWER LEFT TRIANGLE': 9722,
'LOWER ONE EIGHTH BLOCK': 9601,
'LOWER ONE QUARTER BLOCK': 9602,
'LOWER RIGHT CORNER WITH DOT': 10195,
'LOWER RIGHT DROP-SHADOWED WHITE SQUARE': 10063,
'LOWER RIGHT PENCIL': 9998,
'LOWER RIGHT QUADRANT CIRCULAR ARC': 9694,
'LOWER RIGHT SEMICIRCULAR CLOCKWISE ARROW': 10558,
'LOWER RIGHT SHADOWED WHITE SQUARE': 10065,
'LOWER RIGHT TRIANGLE': 9727,
'LOWER SEVEN EIGHTHS BLOCK': 9607,
'LOWER THREE EIGHTHS BLOCK': 9603,
'LOWER THREE QUARTERS BLOCK': 9606,
'LOZENGE': 9674,
'LOZENGE DIVIDED BY HORIZONTAL RULE': 10208,
'LYCIAN LETTER A': 66176,
'LYCIAN LETTER AN': 66201,
'LYCIAN LETTER B': 66178,
'LYCIAN LETTER BH': 66179,
'LYCIAN LETTER D': 66181,
'LYCIAN LETTER E': 66177,
'LYCIAN LETTER EN': 66202,
'LYCIAN LETTER G': 66180,
'LYCIAN LETTER H': 66203,
'LYCIAN LETTER I': 66182,
'LYCIAN LETTER J': 66186,
'LYCIAN LETTER K': 66187,
'LYCIAN LETTER KK': 66196,
'LYCIAN LETTER L': 66189,
'LYCIAN LETTER M': 66190,
'LYCIAN LETTER MM': 66192,
'LYCIAN LETTER N': 66191,
'LYCIAN LETTER NN': 66193,
'LYCIAN LETTER P': 66195,
'LYCIAN LETTER Q': 66188,
'LYCIAN LETTER R': 66197,
'LYCIAN LETTER S': 66198,
'LYCIAN LETTER T': 66199,
'LYCIAN LETTER TH': 66185,
'LYCIAN LETTER TT': 66200,
'LYCIAN LETTER U': 66194,
'LYCIAN LETTER W': 66183,
'LYCIAN LETTER X': 66204,
'LYCIAN LETTER Z': 66184,
'LYDIAN LETTER A': 67872,
'LYDIAN LETTER AN': 67893,
'LYDIAN LETTER B': 67873,
'LYDIAN LETTER C': 67897,
'LYDIAN LETTER D': 67875,
'LYDIAN LETTER E': 67876,
'LYDIAN LETTER EN': 67894,
'LYDIAN LETTER F': 67889,
'LYDIAN LETTER G': 67874,
'LYDIAN LETTER I': 67878,
'LYDIAN LETTER K': 67880,
'LYDIAN LETTER L': 67881,
'LYDIAN LETTER LY': 67895,
'LYDIAN LETTER M': 67882,
'LYDIAN LETTER N': 67883,
'LYDIAN LETTER NN': 67896,
'LYDIAN LETTER O': 67884,
'LYDIAN LETTER Q': 67890,
'LYDIAN LETTER R': 67885,
'LYDIAN LETTER S': 67891,
'LYDIAN LETTER SS': 67886,
'LYDIAN LETTER T': 67887,
'LYDIAN LETTER TT': 67892,
'LYDIAN LETTER U': 67888,
'LYDIAN LETTER V': 67877,
'LYDIAN LETTER Y': 67879,
'LYDIAN TRIANGULAR MARK': 67903,
'MACRON': 175,
'MAHJONG TILE AUTUMN': 127016,
'MAHJONG TILE BACK': 127019,
'MAHJONG TILE BAMBOO': 127012,
'MAHJONG TILE CHRYSANTHEMUM': 127013,
'MAHJONG TILE EAST WIND': 126976,
'MAHJONG TILE EIGHT OF BAMBOOS': 126999,
'MAHJONG TILE EIGHT OF CHARACTERS': 126990,
'MAHJONG TILE EIGHT OF CIRCLES': 127008,
'MAHJONG TILE FIVE OF BAMBOOS': 126996,
'MAHJONG TILE FIVE OF CHARACTERS': 126987,
'MAHJONG TILE FIVE OF CIRCLES': 127005,
'MAHJONG TILE FOUR OF BAMBOOS': 126995,
'MAHJONG TILE FOUR OF CHARACTERS': 126986,
'MAHJONG TILE FOUR OF CIRCLES': 127004,
'MAHJONG TILE GREEN DRAGON': 126981,
'MAHJONG TILE JOKER': 127018,
'MAHJONG TILE NINE OF BAMBOOS': 127000,
'MAHJONG TILE NINE OF CHARACTERS': 126991,
'MAHJONG TILE NINE OF CIRCLES': 127009,
'MAHJONG TILE NORTH WIND': 126979,
'MAHJONG TILE ONE OF BAMBOOS': 126992,
'MAHJONG TILE ONE OF CHARACTERS': 126983,
'MAHJONG TILE ONE OF CIRCLES': 127001,
'MAHJONG TILE ORCHID': 127011,
'MAHJONG TILE PLUM': 127010,
'MAHJONG TILE RED DRAGON': 126980,
'MAHJONG TILE SEVEN OF BAMBOOS': 126998,
'MAHJONG TILE SEVEN OF CHARACTERS': 126989,
'MAHJONG TILE SEVEN OF CIRCLES': 127007,
'MAHJONG TILE SIX OF BAMBOOS': 126997,
'MAHJONG TILE SIX OF CHARACTERS': 126988,
'MAHJONG TILE SIX OF CIRCLES': 127006,
'MAHJONG TILE SOUTH WIND': 126977,
'MAHJONG TILE SPRING': 127014,
'MAHJONG TILE SUMMER': 127015,
'MAHJONG TILE THREE OF BAMBOOS': 126994,
'MAHJONG TILE THREE OF CHARACTERS': 126985,
'MAHJONG TILE THREE OF CIRCLES': 127003,
'MAHJONG TILE TWO OF BAMBOOS': 126993,
'MAHJONG TILE TWO OF CHARACTERS': 126984,
'MAHJONG TILE TWO OF CIRCLES': 127002,
'MAHJONG TILE WEST WIND': 126978,
'MAHJONG TILE WHITE DRAGON': 126982,
'MAHJONG TILE WINTER': 127017,
'MALAYALAM AU LENGTH MARK': 3415,
'MALAYALAM DATE MARK': 3449,
'MALAYALAM DIGIT EIGHT': 3438,
'MALAYALAM DIGIT FIVE': 3435,
'MALAYALAM DIGIT FOUR': 3434,
'MALAYALAM DIGIT NINE': 3439,
'MALAYALAM DIGIT ONE': 3431,
'MALAYALAM DIGIT SEVEN': 3437,
'MALAYALAM DIGIT SIX': 3436,
'MALAYALAM DIGIT THREE': 3433,
'MALAYALAM DIGIT TWO': 3432,
'MALAYALAM DIGIT ZERO': 3430,
'MALAYALAM FRACTION ONE HALF': 3444,
'MALAYALAM FRACTION ONE QUARTER': 3443,
'MALAYALAM FRACTION THREE QUARTERS': 3445,
'MALAYALAM LETTER A': 3333,
'MALAYALAM LETTER AA': 3334,
'MALAYALAM LETTER AI': 3344,
'MALAYALAM LETTER AU': 3348,
'MALAYALAM LETTER BA': 3372,
'MALAYALAM LETTER BHA': 3373,
'MALAYALAM LETTER CA': 3354,
'MALAYALAM LETTER CHA': 3355,
'MALAYALAM LETTER CHILLU K': 3455,
'MALAYALAM LETTER CHILLU L': 3453,
'MALAYALAM LETTER CHILLU LL': 3454,
'MALAYALAM LETTER CHILLU N': 3451,
'MALAYALAM LETTER CHILLU NN': 3450,
'MALAYALAM LETTER CHILLU RR': 3452,
'MALAYALAM LETTER DA': 3366,
'MALAYALAM LETTER DDA': 3361,
'MALAYALAM LETTER DDHA': 3362,
'MALAYALAM LETTER DHA': 3367,
'MALAYALAM LETTER E': 3342,
'MALAYALAM LETTER EE': 3343,
'MALAYALAM LETTER GA': 3351,
'MALAYALAM LETTER GHA': 3352,
'MALAYALAM LETTER HA': 3385,
'MALAYALAM LETTER I': 3335,
'MALAYALAM LETTER II': 3336,
'MALAYALAM LETTER JA': 3356,
'MALAYALAM LETTER JHA': 3357,
'MALAYALAM LETTER KA': 3349,
'MALAYALAM LETTER KHA': 3350,
'MALAYALAM LETTER LA': 3378,
'MALAYALAM LETTER LLA': 3379,
'MALAYALAM LETTER LLLA': 3380,
'MALAYALAM LETTER MA': 3374,
'MALAYALAM LETTER NA': 3368,
'MALAYALAM LETTER NGA': 3353,
'MALAYALAM LETTER NNA': 3363,
'MALAYALAM LETTER NYA': 3358,
'MALAYALAM LETTER O': 3346,
'MALAYALAM LETTER OO': 3347,
'MALAYALAM LETTER PA': 3370,
'MALAYALAM LETTER PHA': 3371,
'MALAYALAM LETTER RA': 3376,
'MALAYALAM LETTER RRA': 3377,
'MALAYALAM LETTER SA': 3384,
'MALAYALAM LETTER SHA': 3382,
'MALAYALAM LETTER SSA': 3383,
'MALAYALAM LETTER TA': 3364,
'MALAYALAM LETTER THA': 3365,
'MALAYALAM LETTER TTA': 3359,
'MALAYALAM LETTER TTHA': 3360,
'MALAYALAM LETTER U': 3337,
'MALAYALAM LETTER UU': 3338,
'MALAYALAM LETTER VA': 3381,
'MALAYALAM LETTER VOCALIC L': 3340,
'MALAYALAM LETTER VOCALIC LL': 3425,
'MALAYALAM LETTER VOCALIC R': 3339,
'MALAYALAM LETTER VOCALIC RR': 3424,
'MALAYALAM LETTER YA': 3375,
'MALAYALAM NUMBER ONE HUNDRED': 3441,
'MALAYALAM NUMBER ONE THOUSAND': 3442,
'MALAYALAM NUMBER TEN': 3440,
'MALAYALAM SIGN ANUSVARA': 3330,
'MALAYALAM SIGN AVAGRAHA': 3389,
'MALAYALAM SIGN VIRAMA': 3405,
'MALAYALAM SIGN VISARGA': 3331,
'MALAYALAM VOWEL SIGN AA': 3390,
'MALAYALAM VOWEL SIGN AI': 3400,
'MALAYALAM VOWEL SIGN AU': 3404,
'MALAYALAM VOWEL SIGN E': 3398,
'MALAYALAM VOWEL SIGN EE': 3399,
'MALAYALAM VOWEL SIGN I': 3391,
'MALAYALAM VOWEL SIGN II': 3392,
'MALAYALAM VOWEL SIGN O': 3402,
'MALAYALAM VOWEL SIGN OO': 3403,
'MALAYALAM VOWEL SIGN U': 3393,
'MALAYALAM VOWEL SIGN UU': 3394,
'MALAYALAM VOWEL SIGN VOCALIC L': 3426,
'MALAYALAM VOWEL SIGN VOCALIC LL': 3427,
'MALAYALAM VOWEL SIGN VOCALIC R': 3395,
'MALAYALAM VOWEL SIGN VOCALIC RR': 3396,
'MALE AND FEMALE SIGN': 9893,
'MALE SIGN': 9794,
'MALE WITH STROKE AND MALE AND FEMALE SIGN': 9895,
'MALE WITH STROKE SIGN': 9894,
'MALTESE CROSS': 10016,
'MAP SYMBOL FOR LIGHTHOUSE': 9967,
'MARRIAGE SYMBOL': 9901,
'MASCULINE ORDINAL INDICATOR': 186,
'MASU MARK': 12348,
'MATHEMATICAL BOLD CAPITAL A': 119808,
'MATHEMATICAL BOLD CAPITAL ALPHA': 120488,
'MATHEMATICAL BOLD CAPITAL B': 119809,
'MATHEMATICAL BOLD CAPITAL BETA': 120489,
'MATHEMATICAL BOLD CAPITAL C': 119810,
'MATHEMATICAL BOLD CAPITAL CHI': 120510,
'MATHEMATICAL BOLD CAPITAL D': 119811,
'MATHEMATICAL BOLD CAPITAL DELTA': 120491,
'MATHEMATICAL BOLD CAPITAL DIGAMMA': 120778,
'MATHEMATICAL BOLD CAPITAL E': 119812,
'MATHEMATICAL BOLD CAPITAL EPSILON': 120492,
'MATHEMATICAL BOLD CAPITAL ETA': 120494,
'MATHEMATICAL BOLD CAPITAL F': 119813,
'MATHEMATICAL BOLD CAPITAL G': 119814,
'MATHEMATICAL BOLD CAPITAL GAMMA': 120490,
'MATHEMATICAL BOLD CAPITAL H': 119815,
'MATHEMATICAL BOLD CAPITAL I': 119816,
'MATHEMATICAL BOLD CAPITAL IOTA': 120496,
'MATHEMATICAL BOLD CAPITAL J': 119817,
'MATHEMATICAL BOLD CAPITAL K': 119818,
'MATHEMATICAL BOLD CAPITAL KAPPA': 120497,
'MATHEMATICAL BOLD CAPITAL L': 119819,
'MATHEMATICAL BOLD CAPITAL LAMDA': 120498,
'MATHEMATICAL BOLD CAPITAL M': 119820,
'MATHEMATICAL BOLD CAPITAL MU': 120499,
'MATHEMATICAL BOLD CAPITAL N': 119821,
'MATHEMATICAL BOLD CAPITAL NU': 120500,
'MATHEMATICAL BOLD CAPITAL O': 119822,
'MATHEMATICAL BOLD CAPITAL OMEGA': 120512,
'MATHEMATICAL BOLD CAPITAL OMICRON': 120502,
'MATHEMATICAL BOLD CAPITAL P': 119823,
'MATHEMATICAL BOLD CAPITAL PHI': 120509,
'MATHEMATICAL BOLD CAPITAL PI': 120503,
'MATHEMATICAL BOLD CAPITAL PSI': 120511,
'MATHEMATICAL BOLD CAPITAL Q': 119824,
'MATHEMATICAL BOLD CAPITAL R': 119825,
'MATHEMATICAL BOLD CAPITAL RHO': 120504,
'MATHEMATICAL BOLD CAPITAL S': 119826,
'MATHEMATICAL BOLD CAPITAL SIGMA': 120506,
'MATHEMATICAL BOLD CAPITAL T': 119827,
'MATHEMATICAL BOLD CAPITAL TAU': 120507,
'MATHEMATICAL BOLD CAPITAL THETA': 120495,
'MATHEMATICAL BOLD CAPITAL THETA SYMBOL': 120505,
'MATHEMATICAL BOLD CAPITAL U': 119828,
'MATHEMATICAL BOLD CAPITAL UPSILON': 120508,
'MATHEMATICAL BOLD CAPITAL V': 119829,
'MATHEMATICAL BOLD CAPITAL W': 119830,
'MATHEMATICAL BOLD CAPITAL X': 119831,
'MATHEMATICAL BOLD CAPITAL XI': 120501,
'MATHEMATICAL BOLD CAPITAL Y': 119832,
'MATHEMATICAL BOLD CAPITAL Z': 119833,
'MATHEMATICAL BOLD CAPITAL ZETA': 120493,
'MATHEMATICAL BOLD DIGIT EIGHT': 120790,
'MATHEMATICAL BOLD DIGIT FIVE': 120787,
'MATHEMATICAL BOLD DIGIT FOUR': 120786,
'MATHEMATICAL BOLD DIGIT NINE': 120791,
'MATHEMATICAL BOLD DIGIT ONE': 120783,
'MATHEMATICAL BOLD DIGIT SEVEN': 120789,
'MATHEMATICAL BOLD DIGIT SIX': 120788,
'MATHEMATICAL BOLD DIGIT THREE': 120785,
'MATHEMATICAL BOLD DIGIT TWO': 120784,
'MATHEMATICAL BOLD DIGIT ZERO': 120782,
'MATHEMATICAL BOLD EPSILON SYMBOL': 120540,
'MATHEMATICAL BOLD FRAKTUR CAPITAL A': 120172,
'MATHEMATICAL BOLD FRAKTUR CAPITAL B': 120173,
'MATHEMATICAL BOLD FRAKTUR CAPITAL C': 120174,
'MATHEMATICAL BOLD FRAKTUR CAPITAL D': 120175,
'MATHEMATICAL BOLD FRAKTUR CAPITAL E': 120176,
'MATHEMATICAL BOLD FRAKTUR CAPITAL F': 120177,
'MATHEMATICAL BOLD FRAKTUR CAPITAL G': 120178,
'MATHEMATICAL BOLD FRAKTUR CAPITAL H': 120179,
'MATHEMATICAL BOLD FRAKTUR CAPITAL I': 120180,
'MATHEMATICAL BOLD FRAKTUR CAPITAL J': 120181,
'MATHEMATICAL BOLD FRAKTUR CAPITAL K': 120182,
'MATHEMATICAL BOLD FRAKTUR CAPITAL L': 120183,
'MATHEMATICAL BOLD FRAKTUR CAPITAL M': 120184,
'MATHEMATICAL BOLD FRAKTUR CAPITAL N': 120185,
'MATHEMATICAL BOLD FRAKTUR CAPITAL O': 120186,
'MATHEMATICAL BOLD FRAKTUR CAPITAL P': 120187,
'MATHEMATICAL BOLD FRAKTUR CAPITAL Q': 120188,
'MATHEMATICAL BOLD FRAKTUR CAPITAL R': 120189,
'MATHEMATICAL BOLD FRAKTUR CAPITAL S': 120190,
'MATHEMATICAL BOLD FRAKTUR CAPITAL T': 120191,
'MATHEMATICAL BOLD FRAKTUR CAPITAL U': 120192,
'MATHEMATICAL BOLD FRAKTUR CAPITAL V': 120193,
'MATHEMATICAL BOLD FRAKTUR CAPITAL W': 120194,
'MATHEMATICAL BOLD FRAKTUR CAPITAL X': 120195,
'MATHEMATICAL BOLD FRAKTUR CAPITAL Y': 120196,
'MATHEMATICAL BOLD FRAKTUR CAPITAL Z': 120197,
'MATHEMATICAL BOLD FRAKTUR SMALL A': 120198,
'MATHEMATICAL BOLD FRAKTUR SMALL B': 120199,
'MATHEMATICAL BOLD FRAKTUR SMALL C': 120200,
'MATHEMATICAL BOLD FRAKTUR SMALL D': 120201,
'MATHEMATICAL BOLD FRAKTUR SMALL E': 120202,
'MATHEMATICAL BOLD FRAKTUR SMALL F': 120203,
'MATHEMATICAL BOLD FRAKTUR SMALL G': 120204,
'MATHEMATICAL BOLD FRAKTUR SMALL H': 120205,
'MATHEMATICAL BOLD FRAKTUR SMALL I': 120206,
'MATHEMATICAL BOLD FRAKTUR SMALL J': 120207,
'MATHEMATICAL BOLD FRAKTUR SMALL K': 120208,
'MATHEMATICAL BOLD FRAKTUR SMALL L': 120209,
'MATHEMATICAL BOLD FRAKTUR SMALL M': 120210,
'MATHEMATICAL BOLD FRAKTUR SMALL N': 120211,
'MATHEMATICAL BOLD FRAKTUR SMALL O': 120212,
'MATHEMATICAL BOLD FRAKTUR SMALL P': 120213,
'MATHEMATICAL BOLD FRAKTUR SMALL Q': 120214,
'MATHEMATICAL BOLD FRAKTUR SMALL R': 120215,
'MATHEMATICAL BOLD FRAKTUR SMALL S': 120216,
'MATHEMATICAL BOLD FRAKTUR SMALL T': 120217,
'MATHEMATICAL BOLD FRAKTUR SMALL U': 120218,
'MATHEMATICAL BOLD FRAKTUR SMALL V': 120219,
'MATHEMATICAL BOLD FRAKTUR SMALL W': 120220,
'MATHEMATICAL BOLD FRAKTUR SMALL X': 120221,
'MATHEMATICAL BOLD FRAKTUR SMALL Y': 120222,
'MATHEMATICAL BOLD FRAKTUR SMALL Z': 120223,
'MATHEMATICAL BOLD ITALIC CAPITAL A': 119912,
'MATHEMATICAL BOLD ITALIC CAPITAL ALPHA': 120604,
'MATHEMATICAL BOLD ITALIC CAPITAL B': 119913,
'MATHEMATICAL BOLD ITALIC CAPITAL BETA': 120605,
'MATHEMATICAL BOLD ITALIC CAPITAL C': 119914,
'MATHEMATICAL BOLD ITALIC CAPITAL CHI': 120626,
'MATHEMATICAL BOLD ITALIC CAPITAL D': 119915,
'MATHEMATICAL BOLD ITALIC CAPITAL DELTA': 120607,
'MATHEMATICAL BOLD ITALIC CAPITAL E': 119916,
'MATHEMATICAL BOLD ITALIC CAPITAL EPSILON': 120608,
'MATHEMATICAL BOLD ITALIC CAPITAL ETA': 120610,
'MATHEMATICAL BOLD ITALIC CAPITAL F': 119917,
'MATHEMATICAL BOLD ITALIC CAPITAL G': 119918,
'MATHEMATICAL BOLD ITALIC CAPITAL GAMMA': 120606,
'MATHEMATICAL BOLD ITALIC CAPITAL H': 119919,
'MATHEMATICAL BOLD ITALIC CAPITAL I': 119920,
'MATHEMATICAL BOLD ITALIC CAPITAL IOTA': 120612,
'MATHEMATICAL BOLD ITALIC CAPITAL J': 119921,
'MATHEMATICAL BOLD ITALIC CAPITAL K': 119922,
'MATHEMATICAL BOLD ITALIC CAPITAL KAPPA': 120613,
'MATHEMATICAL BOLD ITALIC CAPITAL L': 119923,
'MATHEMATICAL BOLD ITALIC CAPITAL LAMDA': 120614,
'MATHEMATICAL BOLD ITALIC CAPITAL M': 119924,
'MATHEMATICAL BOLD ITALIC CAPITAL MU': 120615,
'MATHEMATICAL BOLD ITALIC CAPITAL N': 119925,
'MATHEMATICAL BOLD ITALIC CAPITAL NU': 120616,
'MATHEMATICAL BOLD ITALIC CAPITAL O': 119926,
'MATHEMATICAL BOLD ITALIC CAPITAL OMEGA': 120628,
'MATHEMATICAL BOLD ITALIC CAPITAL OMICRON': 120618,
'MATHEMATICAL BOLD ITALIC CAPITAL P': 119927,
'MATHEMATICAL BOLD ITALIC CAPITAL PHI': 120625,
'MATHEMATICAL BOLD ITALIC CAPITAL PI': 120619,
'MATHEMATICAL BOLD ITALIC CAPITAL PSI': 120627,
'MATHEMATICAL BOLD ITALIC CAPITAL Q': 119928,
'MATHEMATICAL BOLD ITALIC CAPITAL R': 119929,
'MATHEMATICAL BOLD ITALIC CAPITAL RHO': 120620,
'MATHEMATICAL BOLD ITALIC CAPITAL S': 119930,
'MATHEMATICAL BOLD ITALIC CAPITAL SIGMA': 120622,
'MATHEMATICAL BOLD ITALIC CAPITAL T': 119931,
'MATHEMATICAL BOLD ITALIC CAPITAL TAU': 120623,
'MATHEMATICAL BOLD ITALIC CAPITAL THETA': 120611,
'MATHEMATICAL BOLD ITALIC CAPITAL THETA SYMBOL': 120621,
'MATHEMATICAL BOLD ITALIC CAPITAL U': 119932,
'MATHEMATICAL BOLD ITALIC CAPITAL UPSILON': 120624,
'MATHEMATICAL BOLD ITALIC CAPITAL V': 119933,
'MATHEMATICAL BOLD ITALIC CAPITAL W': 119934,
'MATHEMATICAL BOLD ITALIC CAPITAL X': 119935,
'MATHEMATICAL BOLD ITALIC CAPITAL XI': 120617,
'MATHEMATICAL BOLD ITALIC CAPITAL Y': 119936,
'MATHEMATICAL BOLD ITALIC CAPITAL Z': 119937,
'MATHEMATICAL BOLD ITALIC CAPITAL ZETA': 120609,
'MATHEMATICAL BOLD ITALIC EPSILON SYMBOL': 120656,
'MATHEMATICAL BOLD ITALIC KAPPA SYMBOL': 120658,
'MATHEMATICAL BOLD ITALIC NABLA': 120629,
'MATHEMATICAL BOLD ITALIC PARTIAL DIFFERENTIAL': 120655,
'MATHEMATICAL BOLD ITALIC PHI SYMBOL': 120659,
'MATHEMATICAL BOLD ITALIC PI SYMBOL': 120661,
'MATHEMATICAL BOLD ITALIC RHO SYMBOL': 120660,
'MATHEMATICAL BOLD ITALIC SMALL A': 119938,
'MATHEMATICAL BOLD ITALIC SMALL ALPHA': 120630,
'MATHEMATICAL BOLD ITALIC SMALL B': 119939,
'MATHEMATICAL BOLD ITALIC SMALL BETA': 120631,
'MATHEMATICAL BOLD ITALIC SMALL C': 119940,
'MATHEMATICAL BOLD ITALIC SMALL CHI': 120652,
'MATHEMATICAL BOLD ITALIC SMALL D': 119941,
'MATHEMATICAL BOLD ITALIC SMALL DELTA': 120633,
'MATHEMATICAL BOLD ITALIC SMALL E': 119942,
'MATHEMATICAL BOLD ITALIC SMALL EPSILON': 120634,
'MATHEMATICAL BOLD ITALIC SMALL ETA': 120636,
'MATHEMATICAL BOLD ITALIC SMALL F': 119943,
'MATHEMATICAL BOLD ITALIC SMALL FINAL SIGMA': 120647,
'MATHEMATICAL BOLD ITALIC SMALL G': 119944,
'MATHEMATICAL BOLD ITALIC SMALL GAMMA': 120632,
'MATHEMATICAL BOLD ITALIC SMALL H': 119945,
'MATHEMATICAL BOLD ITALIC SMALL I': 119946,
'MATHEMATICAL BOLD ITALIC SMALL IOTA': 120638,
'MATHEMATICAL BOLD ITALIC SMALL J': 119947,
'MATHEMATICAL BOLD ITALIC SMALL K': 119948,
'MATHEMATICAL BOLD ITALIC SMALL KAPPA': 120639,
'MATHEMATICAL BOLD ITALIC SMALL L': 119949,
'MATHEMATICAL BOLD ITALIC SMALL LAMDA': 120640,
'MATHEMATICAL BOLD ITALIC SMALL M': 119950,
'MATHEMATICAL BOLD ITALIC SMALL MU': 120641,
'MATHEMATICAL BOLD ITALIC SMALL N': 119951,
'MATHEMATICAL BOLD ITALIC SMALL NU': 120642,
'MATHEMATICAL BOLD ITALIC SMALL O': 119952,
'MATHEMATICAL BOLD ITALIC SMALL OMEGA': 120654,
'MATHEMATICAL BOLD ITALIC SMALL OMICRON': 120644,
'MATHEMATICAL BOLD ITALIC SMALL P': 119953,
'MATHEMATICAL BOLD ITALIC SMALL PHI': 120651,
'MATHEMATICAL BOLD ITALIC SMALL PI': 120645,
'MATHEMATICAL BOLD ITALIC SMALL PSI': 120653,
'MATHEMATICAL BOLD ITALIC SMALL Q': 119954,
'MATHEMATICAL BOLD ITALIC SMALL R': 119955,
'MATHEMATICAL BOLD ITALIC SMALL RHO': 120646,
'MATHEMATICAL BOLD ITALIC SMALL S': 119956,
'MATHEMATICAL BOLD ITALIC SMALL SIGMA': 120648,
'MATHEMATICAL BOLD ITALIC SMALL T': 119957,
'MATHEMATICAL BOLD ITALIC SMALL TAU': 120649,
'MATHEMATICAL BOLD ITALIC SMALL THETA': 120637,
'MATHEMATICAL BOLD ITALIC SMALL U': 119958,
'MATHEMATICAL BOLD ITALIC SMALL UPSILON': 120650,
'MATHEMATICAL BOLD ITALIC SMALL V': 119959,
'MATHEMATICAL BOLD ITALIC SMALL W': 119960,
'MATHEMATICAL BOLD ITALIC SMALL X': 119961,
'MATHEMATICAL BOLD ITALIC SMALL XI': 120643,
'MATHEMATICAL BOLD ITALIC SMALL Y': 119962,
'MATHEMATICAL BOLD ITALIC SMALL Z': 119963,
'MATHEMATICAL BOLD ITALIC SMALL ZETA': 120635,
'MATHEMATICAL BOLD ITALIC THETA SYMBOL': 120657,
'MATHEMATICAL BOLD KAPPA SYMBOL': 120542,
'MATHEMATICAL BOLD NABLA': 120513,
'MATHEMATICAL BOLD PARTIAL DIFFERENTIAL': 120539,
'MATHEMATICAL BOLD PHI SYMBOL': 120543,
'MATHEMATICAL BOLD PI SYMBOL': 120545,
'MATHEMATICAL BOLD RHO SYMBOL': 120544,
'MATHEMATICAL BOLD SCRIPT CAPITAL A': 120016,
'MATHEMATICAL BOLD SCRIPT CAPITAL B': 120017,
'MATHEMATICAL BOLD SCRIPT CAPITAL C': 120018,
'MATHEMATICAL BOLD SCRIPT CAPITAL D': 120019,
'MATHEMATICAL BOLD SCRIPT CAPITAL E': 120020,
'MATHEMATICAL BOLD SCRIPT CAPITAL F': 120021,
'MATHEMATICAL BOLD SCRIPT CAPITAL G': 120022,
'MATHEMATICAL BOLD SCRIPT CAPITAL H': 120023,
'MATHEMATICAL BOLD SCRIPT CAPITAL I': 120024,
'MATHEMATICAL BOLD SCRIPT CAPITAL J': 120025,
'MATHEMATICAL BOLD SCRIPT CAPITAL K': 120026,
'MATHEMATICAL BOLD SCRIPT CAPITAL L': 120027,
'MATHEMATICAL BOLD SCRIPT CAPITAL M': 120028,
'MATHEMATICAL BOLD SCRIPT CAPITAL N': 120029,
'MATHEMATICAL BOLD SCRIPT CAPITAL O': 120030,
'MATHEMATICAL BOLD SCRIPT CAPITAL P': 120031,
'MATHEMATICAL BOLD SCRIPT CAPITAL Q': 120032,
'MATHEMATICAL BOLD SCRIPT CAPITAL R': 120033,
'MATHEMATICAL BOLD SCRIPT CAPITAL S': 120034,
'MATHEMATICAL BOLD SCRIPT CAPITAL T': 120035,
'MATHEMATICAL BOLD SCRIPT CAPITAL U': 120036,
'MATHEMATICAL BOLD SCRIPT CAPITAL V': 120037,
'MATHEMATICAL BOLD SCRIPT CAPITAL W': 120038,
'MATHEMATICAL BOLD SCRIPT CAPITAL X': 120039,
'MATHEMATICAL BOLD SCRIPT CAPITAL Y': 120040,
'MATHEMATICAL BOLD SCRIPT CAPITAL Z': 120041,
'MATHEMATICAL BOLD SCRIPT SMALL A': 120042,
'MATHEMATICAL BOLD SCRIPT SMALL B': 120043,
'MATHEMATICAL BOLD SCRIPT SMALL C': 120044,
'MATHEMATICAL BOLD SCRIPT SMALL D': 120045,
'MATHEMATICAL BOLD SCRIPT SMALL E': 120046,
'MATHEMATICAL BOLD SCRIPT SMALL F': 120047,
'MATHEMATICAL BOLD SCRIPT SMALL G': 120048,
'MATHEMATICAL BOLD SCRIPT SMALL H': 120049,
'MATHEMATICAL BOLD SCRIPT SMALL I': 120050,
'MATHEMATICAL BOLD SCRIPT SMALL J': 120051,
'MATHEMATICAL BOLD SCRIPT SMALL K': 120052,
'MATHEMATICAL BOLD SCRIPT SMALL L': 120053,
'MATHEMATICAL BOLD SCRIPT SMALL M': 120054,
'MATHEMATICAL BOLD SCRIPT SMALL N': 120055,
'MATHEMATICAL BOLD SCRIPT SMALL O': 120056,
'MATHEMATICAL BOLD SCRIPT SMALL P': 120057,
'MATHEMATICAL BOLD SCRIPT SMALL Q': 120058,
'MATHEMATICAL BOLD SCRIPT SMALL R': 120059,
'MATHEMATICAL BOLD SCRIPT SMALL S': 120060,
'MATHEMATICAL BOLD SCRIPT SMALL T': 120061,
'MATHEMATICAL BOLD SCRIPT SMALL U': 120062,
'MATHEMATICAL BOLD SCRIPT SMALL V': 120063,
'MATHEMATICAL BOLD SCRIPT SMALL W': 120064,
'MATHEMATICAL BOLD SCRIPT SMALL X': 120065,
'MATHEMATICAL BOLD SCRIPT SMALL Y': 120066,
'MATHEMATICAL BOLD SCRIPT SMALL Z': 120067,
'MATHEMATICAL BOLD SMALL A': 119834,
'MATHEMATICAL BOLD SMALL ALPHA': 120514,
'MATHEMATICAL BOLD SMALL B': 119835,
'MATHEMATICAL BOLD SMALL BETA': 120515,
'MATHEMATICAL BOLD SMALL C': 119836,
'MATHEMATICAL BOLD SMALL CHI': 120536,
'MATHEMATICAL BOLD SMALL D': 119837,
'MATHEMATICAL BOLD SMALL DELTA': 120517,
'MATHEMATICAL BOLD SMALL DIGAMMA': 120779,
'MATHEMATICAL BOLD SMALL E': 119838,
'MATHEMATICAL BOLD SMALL EPSILON': 120518,
'MATHEMATICAL BOLD SMALL ETA': 120520,
'MATHEMATICAL BOLD SMALL F': 119839,
'MATHEMATICAL BOLD SMALL FINAL SIGMA': 120531,
'MATHEMATICAL BOLD SMALL G': 119840,
'MATHEMATICAL BOLD SMALL GAMMA': 120516,
'MATHEMATICAL BOLD SMALL H': 119841,
'MATHEMATICAL BOLD SMALL I': 119842,
'MATHEMATICAL BOLD SMALL IOTA': 120522,
'MATHEMATICAL BOLD SMALL J': 119843,
'MATHEMATICAL BOLD SMALL K': 119844,
'MATHEMATICAL BOLD SMALL KAPPA': 120523,
'MATHEMATICAL BOLD SMALL L': 119845,
'MATHEMATICAL BOLD SMALL LAMDA': 120524,
'MATHEMATICAL BOLD SMALL M': 119846,
'MATHEMATICAL BOLD SMALL MU': 120525,
'MATHEMATICAL BOLD SMALL N': 119847,
'MATHEMATICAL BOLD SMALL NU': 120526,
'MATHEMATICAL BOLD SMALL O': 119848,
'MATHEMATICAL BOLD SMALL OMEGA': 120538,
'MATHEMATICAL BOLD SMALL OMICRON': 120528,
'MATHEMATICAL BOLD SMALL P': 119849,
'MATHEMATICAL BOLD SMALL PHI': 120535,
'MATHEMATICAL BOLD SMALL PI': 120529,
'MATHEMATICAL BOLD SMALL PSI': 120537,
'MATHEMATICAL BOLD SMALL Q': 119850,
'MATHEMATICAL BOLD SMALL R': 119851,
'MATHEMATICAL BOLD SMALL RHO': 120530,
'MATHEMATICAL BOLD SMALL S': 119852,
'MATHEMATICAL BOLD SMALL SIGMA': 120532,
'MATHEMATICAL BOLD SMALL T': 119853,
'MATHEMATICAL BOLD SMALL TAU': 120533,
'MATHEMATICAL BOLD SMALL THETA': 120521,
'MATHEMATICAL BOLD SMALL U': 119854,
'MATHEMATICAL BOLD SMALL UPSILON': 120534,
'MATHEMATICAL BOLD SMALL V': 119855,
'MATHEMATICAL BOLD SMALL W': 119856,
'MATHEMATICAL BOLD SMALL X': 119857,
'MATHEMATICAL BOLD SMALL XI': 120527,
'MATHEMATICAL BOLD SMALL Y': 119858,
'MATHEMATICAL BOLD SMALL Z': 119859,
'MATHEMATICAL BOLD SMALL ZETA': 120519,
'MATHEMATICAL BOLD THETA SYMBOL': 120541,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL A': 120120,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL B': 120121,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL D': 120123,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL E': 120124,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL F': 120125,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL G': 120126,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL I': 120128,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL J': 120129,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL K': 120130,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL L': 120131,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL M': 120132,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL O': 120134,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL S': 120138,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL T': 120139,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL U': 120140,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL V': 120141,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL W': 120142,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL X': 120143,
'MATHEMATICAL DOUBLE-STRUCK CAPITAL Y': 120144,
'MATHEMATICAL DOUBLE-STRUCK DIGIT EIGHT': 120800,
'MATHEMATICAL DOUBLE-STRUCK DIGIT FIVE': 120797,
'MATHEMATICAL DOUBLE-STRUCK DIGIT FOUR': 120796,
'MATHEMATICAL DOUBLE-STRUCK DIGIT NINE': 120801,
'MATHEMATICAL DOUBLE-STRUCK DIGIT ONE': 120793,
'MATHEMATICAL DOUBLE-STRUCK DIGIT SEVEN': 120799,
'MATHEMATICAL DOUBLE-STRUCK DIGIT SIX': 120798,
'MATHEMATICAL DOUBLE-STRUCK DIGIT THREE': 120795,
'MATHEMATICAL DOUBLE-STRUCK DIGIT TWO': 120794,
'MATHEMATICAL DOUBLE-STRUCK DIGIT ZERO': 120792,
'MATHEMATICAL DOUBLE-STRUCK SMALL A': 120146,
'MATHEMATICAL DOUBLE-STRUCK SMALL B': 120147,
'MATHEMATICAL DOUBLE-STRUCK SMALL C': 120148,
'MATHEMATICAL DOUBLE-STRUCK SMALL D': 120149,
'MATHEMATICAL DOUBLE-STRUCK SMALL E': 120150,
'MATHEMATICAL DOUBLE-STRUCK SMALL F': 120151,
'MATHEMATICAL DOUBLE-STRUCK SMALL G': 120152,
'MATHEMATICAL DOUBLE-STRUCK SMALL H': 120153,
'MATHEMATICAL DOUBLE-STRUCK SMALL I': 120154,
'MATHEMATICAL DOUBLE-STRUCK SMALL J': 120155,
'MATHEMATICAL DOUBLE-STRUCK SMALL K': 120156,
'MATHEMATICAL DOUBLE-STRUCK SMALL L': 120157,
'MATHEMATICAL DOUBLE-STRUCK SMALL M': 120158,
'MATHEMATICAL DOUBLE-STRUCK SMALL N': 120159,
'MATHEMATICAL DOUBLE-STRUCK SMALL O': 120160,
'MATHEMATICAL DOUBLE-STRUCK SMALL P': 120161,
'MATHEMATICAL DOUBLE-STRUCK SMALL Q': 120162,
'MATHEMATICAL DOUBLE-STRUCK SMALL R': 120163,
'MATHEMATICAL DOUBLE-STRUCK SMALL S': 120164,
'MATHEMATICAL DOUBLE-STRUCK SMALL T': 120165,
'MATHEMATICAL DOUBLE-STRUCK SMALL U': 120166,
'MATHEMATICAL DOUBLE-STRUCK SMALL V': 120167,
'MATHEMATICAL DOUBLE-STRUCK SMALL W': 120168,
'MATHEMATICAL DOUBLE-STRUCK SMALL X': 120169,
'MATHEMATICAL DOUBLE-STRUCK SMALL Y': 120170,
'MATHEMATICAL DOUBLE-STRUCK SMALL Z': 120171,
'MATHEMATICAL FRAKTUR CAPITAL A': 120068,
'MATHEMATICAL FRAKTUR CAPITAL B': 120069,
'MATHEMATICAL FRAKTUR CAPITAL D': 120071,
'MATHEMATICAL FRAKTUR CAPITAL E': 120072,
'MATHEMATICAL FRAKTUR CAPITAL F': 120073,
'MATHEMATICAL FRAKTUR CAPITAL G': 120074,
'MATHEMATICAL FRAKTUR CAPITAL J': 120077,
'MATHEMATICAL FRAKTUR CAPITAL K': 120078,
'MATHEMATICAL FRAKTUR CAPITAL L': 120079,
'MATHEMATICAL FRAKTUR CAPITAL M': 120080,
'MATHEMATICAL FRAKTUR CAPITAL N': 120081,
'MATHEMATICAL FRAKTUR CAPITAL O': 120082,
'MATHEMATICAL FRAKTUR CAPITAL P': 120083,
'MATHEMATICAL FRAKTUR CAPITAL Q': 120084,
'MATHEMATICAL FRAKTUR CAPITAL S': 120086,
'MATHEMATICAL FRAKTUR CAPITAL T': 120087,
'MATHEMATICAL FRAKTUR CAPITAL U': 120088,
'MATHEMATICAL FRAKTUR CAPITAL V': 120089,
'MATHEMATICAL FRAKTUR CAPITAL W': 120090,
'MATHEMATICAL FRAKTUR CAPITAL X': 120091,
'MATHEMATICAL FRAKTUR CAPITAL Y': 120092,
'MATHEMATICAL FRAKTUR SMALL A': 120094,
'MATHEMATICAL FRAKTUR SMALL B': 120095,
'MATHEMATICAL FRAKTUR SMALL C': 120096,
'MATHEMATICAL FRAKTUR SMALL D': 120097,
'MATHEMATICAL FRAKTUR SMALL E': 120098,
'MATHEMATICAL FRAKTUR SMALL F': 120099,
'MATHEMATICAL FRAKTUR SMALL G': 120100,
'MATHEMATICAL FRAKTUR SMALL H': 120101,
'MATHEMATICAL FRAKTUR SMALL I': 120102,
'MATHEMATICAL FRAKTUR SMALL J': 120103,
'MATHEMATICAL FRAKTUR SMALL K': 120104,
'MATHEMATICAL FRAKTUR SMALL L': 120105,
'MATHEMATICAL FRAKTUR SMALL M': 120106,
'MATHEMATICAL FRAKTUR SMALL N': 120107,
'MATHEMATICAL FRAKTUR SMALL O': 120108,
'MATHEMATICAL FRAKTUR SMALL P': 120109,
'MATHEMATICAL FRAKTUR SMALL Q': 120110,
'MATHEMATICAL FRAKTUR SMALL R': 120111,
'MATHEMATICAL FRAKTUR SMALL S': 120112,
'MATHEMATICAL FRAKTUR SMALL T': 120113,
'MATHEMATICAL FRAKTUR SMALL U': 120114,
'MATHEMATICAL FRAKTUR SMALL V': 120115,
'MATHEMATICAL FRAKTUR SMALL W': 120116,
'MATHEMATICAL FRAKTUR SMALL X': 120117,
'MATHEMATICAL FRAKTUR SMALL Y': 120118,
'MATHEMATICAL FRAKTUR SMALL Z': 120119,
'MATHEMATICAL ITALIC CAPITAL A': 119860,
'MATHEMATICAL ITALIC CAPITAL ALPHA': 120546,
'MATHEMATICAL ITALIC CAPITAL B': 119861,
'MATHEMATICAL ITALIC CAPITAL BETA': 120547,
'MATHEMATICAL ITALIC CAPITAL C': 119862,
'MATHEMATICAL ITALIC CAPITAL CHI': 120568,
'MATHEMATICAL ITALIC CAPITAL D': 119863,
'MATHEMATICAL ITALIC CAPITAL DELTA': 120549,
'MATHEMATICAL ITALIC CAPITAL E': 119864,
'MATHEMATICAL ITALIC CAPITAL EPSILON': 120550,
'MATHEMATICAL ITALIC CAPITAL ETA': 120552,
'MATHEMATICAL ITALIC CAPITAL F': 119865,
'MATHEMATICAL ITALIC CAPITAL G': 119866,
'MATHEMATICAL ITALIC CAPITAL GAMMA': 120548,
'MATHEMATICAL ITALIC CAPITAL H': 119867,
'MATHEMATICAL ITALIC CAPITAL I': 119868,
'MATHEMATICAL ITALIC CAPITAL IOTA': 120554,
'MATHEMATICAL ITALIC CAPITAL J': 119869,
'MATHEMATICAL ITALIC CAPITAL K': 119870,
'MATHEMATICAL ITALIC CAPITAL KAPPA': 120555,
'MATHEMATICAL ITALIC CAPITAL L': 119871,
'MATHEMATICAL ITALIC CAPITAL LAMDA': 120556,
'MATHEMATICAL ITALIC CAPITAL M': 119872,
'MATHEMATICAL ITALIC CAPITAL MU': 120557,
'MATHEMATICAL ITALIC CAPITAL N': 119873,
'MATHEMATICAL ITALIC CAPITAL NU': 120558,
'MATHEMATICAL ITALIC CAPITAL O': 119874,
'MATHEMATICAL ITALIC CAPITAL OMEGA': 120570,
'MATHEMATICAL ITALIC CAPITAL OMICRON': 120560,
'MATHEMATICAL ITALIC CAPITAL P': 119875,
'MATHEMATICAL ITALIC CAPITAL PHI': 120567,
'MATHEMATICAL ITALIC CAPITAL PI': 120561,
'MATHEMATICAL ITALIC CAPITAL PSI': 120569,
'MATHEMATICAL ITALIC CAPITAL Q': 119876,
'MATHEMATICAL ITALIC CAPITAL R': 119877,
'MATHEMATICAL ITALIC CAPITAL RHO': 120562,
'MATHEMATICAL ITALIC CAPITAL S': 119878,
'MATHEMATICAL ITALIC CAPITAL SIGMA': 120564,
'MATHEMATICAL ITALIC CAPITAL T': 119879,
'MATHEMATICAL ITALIC CAPITAL TAU': 120565,
'MATHEMATICAL ITALIC CAPITAL THETA': 120553,
'MATHEMATICAL ITALIC CAPITAL THETA SYMBOL': 120563,
'MATHEMATICAL ITALIC CAPITAL U': 119880,
'MATHEMATICAL ITALIC CAPITAL UPSILON': 120566,
'MATHEMATICAL ITALIC CAPITAL V': 119881,
'MATHEMATICAL ITALIC CAPITAL W': 119882,
'MATHEMATICAL ITALIC CAPITAL X': 119883,
'MATHEMATICAL ITALIC CAPITAL XI': 120559,
'MATHEMATICAL ITALIC CAPITAL Y': 119884,
'MATHEMATICAL ITALIC CAPITAL Z': 119885,
'MATHEMATICAL ITALIC CAPITAL ZETA': 120551,
'MATHEMATICAL ITALIC EPSILON SYMBOL': 120598,
'MATHEMATICAL ITALIC KAPPA SYMBOL': 120600,
'MATHEMATICAL ITALIC NABLA': 120571,
'MATHEMATICAL ITALIC PARTIAL DIFFERENTIAL': 120597,
'MATHEMATICAL ITALIC PHI SYMBOL': 120601,
'MATHEMATICAL ITALIC PI SYMBOL': 120603,
'MATHEMATICAL ITALIC RHO SYMBOL': 120602,
'MATHEMATICAL ITALIC SMALL A': 119886,
'MATHEMATICAL ITALIC SMALL ALPHA': 120572,
'MATHEMATICAL ITALIC SMALL B': 119887,
'MATHEMATICAL ITALIC SMALL BETA': 120573,
'MATHEMATICAL ITALIC SMALL C': 119888,
'MATHEMATICAL ITALIC SMALL CHI': 120594,
'MATHEMATICAL ITALIC SMALL D': 119889,
'MATHEMATICAL ITALIC SMALL DELTA': 120575,
'MATHEMATICAL ITALIC SMALL DOTLESS I': 120484,
'MATHEMATICAL ITALIC SMALL DOTLESS J': 120485,
'MATHEMATICAL ITALIC SMALL E': 119890,
'MATHEMATICAL ITALIC SMALL EPSILON': 120576,
'MATHEMATICAL ITALIC SMALL ETA': 120578,
'MATHEMATICAL ITALIC SMALL F': 119891,
'MATHEMATICAL ITALIC SMALL FINAL SIGMA': 120589,
'MATHEMATICAL ITALIC SMALL G': 119892,
'MATHEMATICAL ITALIC SMALL GAMMA': 120574,
'MATHEMATICAL ITALIC SMALL I': 119894,
'MATHEMATICAL ITALIC SMALL IOTA': 120580,
'MATHEMATICAL ITALIC SMALL J': 119895,
'MATHEMATICAL ITALIC SMALL K': 119896,
'MATHEMATICAL ITALIC SMALL KAPPA': 120581,
'MATHEMATICAL ITALIC SMALL L': 119897,
'MATHEMATICAL ITALIC SMALL LAMDA': 120582,
'MATHEMATICAL ITALIC SMALL M': 119898,
'MATHEMATICAL ITALIC SMALL MU': 120583,
'MATHEMATICAL ITALIC SMALL N': 119899,
'MATHEMATICAL ITALIC SMALL NU': 120584,
'MATHEMATICAL ITALIC SMALL O': 119900,
'MATHEMATICAL ITALIC SMALL OMEGA': 120596,
'MATHEMATICAL ITALIC SMALL OMICRON': 120586,
'MATHEMATICAL ITALIC SMALL P': 119901,
'MATHEMATICAL ITALIC SMALL PHI': 120593,
'MATHEMATICAL ITALIC SMALL PI': 120587,
'MATHEMATICAL ITALIC SMALL PSI': 120595,
'MATHEMATICAL ITALIC SMALL Q': 119902,
'MATHEMATICAL ITALIC SMALL R': 119903,
'MATHEMATICAL ITALIC SMALL RHO': 120588,
'MATHEMATICAL ITALIC SMALL S': 119904,
'MATHEMATICAL ITALIC SMALL SIGMA': 120590,
'MATHEMATICAL ITALIC SMALL T': 119905,
'MATHEMATICAL ITALIC SMALL TAU': 120591,
'MATHEMATICAL ITALIC SMALL THETA': 120579,
'MATHEMATICAL ITALIC SMALL U': 119906,
'MATHEMATICAL ITALIC SMALL UPSILON': 120592,
'MATHEMATICAL ITALIC SMALL V': 119907,
'MATHEMATICAL ITALIC SMALL W': 119908,
'MATHEMATICAL ITALIC SMALL X': 119909,
'MATHEMATICAL ITALIC SMALL XI': 120585,
'MATHEMATICAL ITALIC SMALL Y': 119910,
'MATHEMATICAL ITALIC SMALL Z': 119911,
'MATHEMATICAL ITALIC SMALL ZETA': 120577,
'MATHEMATICAL ITALIC THETA SYMBOL': 120599,
'MATHEMATICAL LEFT ANGLE BRACKET': 10216,
'MATHEMATICAL LEFT DOUBLE ANGLE BRACKET': 10218,
'MATHEMATICAL LEFT FLATTENED PARENTHESIS': 10222,
'MATHEMATICAL LEFT WHITE SQUARE BRACKET': 10214,
'MATHEMATICAL LEFT WHITE TORTOISE SHELL BRACKET': 10220,
'MATHEMATICAL MONOSPACE CAPITAL A': 120432,
'MATHEMATICAL MONOSPACE CAPITAL B': 120433,
'MATHEMATICAL MONOSPACE CAPITAL C': 120434,
'MATHEMATICAL MONOSPACE CAPITAL D': 120435,
'MATHEMATICAL MONOSPACE CAPITAL E': 120436,
'MATHEMATICAL MONOSPACE CAPITAL F': 120437,
'MATHEMATICAL MONOSPACE CAPITAL G': 120438,
'MATHEMATICAL MONOSPACE CAPITAL H': 120439,
'MATHEMATICAL MONOSPACE CAPITAL I': 120440,
'MATHEMATICAL MONOSPACE CAPITAL J': 120441,
'MATHEMATICAL MONOSPACE CAPITAL K': 120442,
'MATHEMATICAL MONOSPACE CAPITAL L': 120443,
'MATHEMATICAL MONOSPACE CAPITAL M': 120444,
'MATHEMATICAL MONOSPACE CAPITAL N': 120445,
'MATHEMATICAL MONOSPACE CAPITAL O': 120446,
'MATHEMATICAL MONOSPACE CAPITAL P': 120447,
'MATHEMATICAL MONOSPACE CAPITAL Q': 120448,
'MATHEMATICAL MONOSPACE CAPITAL R': 120449,
'MATHEMATICAL MONOSPACE CAPITAL S': 120450,
'MATHEMATICAL MONOSPACE CAPITAL T': 120451,
'MATHEMATICAL MONOSPACE CAPITAL U': 120452,
'MATHEMATICAL MONOSPACE CAPITAL V': 120453,
'MATHEMATICAL MONOSPACE CAPITAL W': 120454,
'MATHEMATICAL MONOSPACE CAPITAL X': 120455,
'MATHEMATICAL MONOSPACE CAPITAL Y': 120456,
'MATHEMATICAL MONOSPACE CAPITAL Z': 120457,
'MATHEMATICAL MONOSPACE DIGIT EIGHT': 120830,
'MATHEMATICAL MONOSPACE DIGIT FIVE': 120827,
'MATHEMATICAL MONOSPACE DIGIT FOUR': 120826,
'MATHEMATICAL MONOSPACE DIGIT NINE': 120831,
'MATHEMATICAL MONOSPACE DIGIT ONE': 120823,
'MATHEMATICAL MONOSPACE DIGIT SEVEN': 120829,
'MATHEMATICAL MONOSPACE DIGIT SIX': 120828,
'MATHEMATICAL MONOSPACE DIGIT THREE': 120825,
'MATHEMATICAL MONOSPACE DIGIT TWO': 120824,
'MATHEMATICAL MONOSPACE DIGIT ZERO': 120822,
'MATHEMATICAL MONOSPACE SMALL A': 120458,
'MATHEMATICAL MONOSPACE SMALL B': 120459,
'MATHEMATICAL MONOSPACE SMALL C': 120460,
'MATHEMATICAL MONOSPACE SMALL D': 120461,
'MATHEMATICAL MONOSPACE SMALL E': 120462,
'MATHEMATICAL MONOSPACE SMALL F': 120463,
'MATHEMATICAL MONOSPACE SMALL G': 120464,
'MATHEMATICAL MONOSPACE SMALL H': 120465,
'MATHEMATICAL MONOSPACE SMALL I': 120466,
'MATHEMATICAL MONOSPACE SMALL J': 120467,
'MATHEMATICAL MONOSPACE SMALL K': 120468,
'MATHEMATICAL MONOSPACE SMALL L': 120469,
'MATHEMATICAL MONOSPACE SMALL M': 120470,
'MATHEMATICAL MONOSPACE SMALL N': 120471,
'MATHEMATICAL MONOSPACE SMALL O': 120472,
'MATHEMATICAL MONOSPACE SMALL P': 120473,
'MATHEMATICAL MONOSPACE SMALL Q': 120474,
'MATHEMATICAL MONOSPACE SMALL R': 120475,
'MATHEMATICAL MONOSPACE SMALL S': 120476,
'MATHEMATICAL MONOSPACE SMALL T': 120477,
'MATHEMATICAL MONOSPACE SMALL U': 120478,
'MATHEMATICAL MONOSPACE SMALL V': 120479,
'MATHEMATICAL MONOSPACE SMALL W': 120480,
'MATHEMATICAL MONOSPACE SMALL X': 120481,
'MATHEMATICAL MONOSPACE SMALL Y': 120482,
'MATHEMATICAL MONOSPACE SMALL Z': 120483,
'MATHEMATICAL RIGHT ANGLE BRACKET': 10217,
'MATHEMATICAL RIGHT DOUBLE ANGLE BRACKET': 10219,
'MATHEMATICAL RIGHT FLATTENED PARENTHESIS': 10223,
'MATHEMATICAL RIGHT WHITE SQUARE BRACKET': 10215,
'MATHEMATICAL RIGHT WHITE TORTOISE SHELL BRACKET': 10221,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL A': 120276,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL ALPHA': 120662,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL B': 120277,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL BETA': 120663,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL C': 120278,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL CHI': 120684,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL D': 120279,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL DELTA': 120665,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL E': 120280,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL EPSILON': 120666,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL ETA': 120668,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL F': 120281,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL G': 120282,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL GAMMA': 120664,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL H': 120283,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL I': 120284,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL IOTA': 120670,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL J': 120285,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL K': 120286,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL KAPPA': 120671,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL L': 120287,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL LAMDA': 120672,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL M': 120288,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL MU': 120673,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL N': 120289,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL NU': 120674,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL O': 120290,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL OMEGA': 120686,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL OMICRON': 120676,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL P': 120291,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL PHI': 120683,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL PI': 120677,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL PSI': 120685,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL Q': 120292,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL R': 120293,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL RHO': 120678,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL S': 120294,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL SIGMA': 120680,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL T': 120295,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL TAU': 120681,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL THETA': 120669,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL THETA SYMBOL': 120679,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL U': 120296,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL UPSILON': 120682,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL V': 120297,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL W': 120298,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL X': 120299,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL XI': 120675,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL Y': 120300,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL Z': 120301,
'MATHEMATICAL SANS-SERIF BOLD CAPITAL ZETA': 120667,
'MATHEMATICAL SANS-SERIF BOLD DIGIT EIGHT': 120820,
'MATHEMATICAL SANS-SERIF BOLD DIGIT FIVE': 120817,
'MATHEMATICAL SANS-SERIF BOLD DIGIT FOUR': 120816,
'MATHEMATICAL SANS-SERIF BOLD DIGIT NINE': 120821,
'MATHEMATICAL SANS-SERIF BOLD DIGIT ONE': 120813,
'MATHEMATICAL SANS-SERIF BOLD DIGIT SEVEN': 120819,
'MATHEMATICAL SANS-SERIF BOLD DIGIT SIX': 120818,
'MATHEMATICAL SANS-SERIF BOLD DIGIT THREE': 120815,
'MATHEMATICAL SANS-SERIF BOLD DIGIT TWO': 120814,
'MATHEMATICAL SANS-SERIF BOLD DIGIT ZERO': 120812,
'MATHEMATICAL SANS-SERIF BOLD EPSILON SYMBOL': 120714,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL A': 120380,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL ALPHA': 120720,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL B': 120381,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL BETA': 120721,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL C': 120382,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL CHI': 120742,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL D': 120383,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL DELTA': 120723,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL E': 120384,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL EPSILON': 120724,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL ETA': 120726,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL F': 120385,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL G': 120386,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL GAMMA': 120722,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL H': 120387,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL I': 120388,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL IOTA': 120728,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL J': 120389,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL K': 120390,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL KAPPA': 120729,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL L': 120391,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL LAMDA': 120730,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL M': 120392,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL MU': 120731,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL N': 120393,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL NU': 120732,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL O': 120394,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL OMEGA': 120744,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL OMICRON': 120734,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL P': 120395,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL PHI': 120741,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL PI': 120735,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL PSI': 120743,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL Q': 120396,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL R': 120397,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL RHO': 120736,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL S': 120398,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL SIGMA': 120738,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL T': 120399,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL TAU': 120739,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL THETA': 120727,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL THETA SYMBOL': 120737,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL U': 120400,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL UPSILON': 120740,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL V': 120401,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL W': 120402,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL X': 120403,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL XI': 120733,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL Y': 120404,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL Z': 120405,
'MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL ZETA': 120725,
'MATHEMATICAL SANS-SERIF BOLD ITALIC EPSILON SYMBOL': 120772,
'MATHEMATICAL SANS-SERIF BOLD ITALIC KAPPA SYMBOL': 120774,
'MATHEMATICAL SANS-SERIF BOLD ITALIC NABLA': 120745,
'MATHEMATICAL SANS-SERIF BOLD ITALIC PARTIAL DIFFERENTIAL': 120771,
'MATHEMATICAL SANS-SERIF BOLD ITALIC PHI SYMBOL': 120775,
'MATHEMATICAL SANS-SERIF BOLD ITALIC PI SYMBOL': 120777,
'MATHEMATICAL SANS-SERIF BOLD ITALIC RHO SYMBOL': 120776,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL A': 120406,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ALPHA': 120746,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL B': 120407,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL BETA': 120747,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL C': 120408,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL CHI': 120768,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL D': 120409,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL DELTA': 120749,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL E': 120410,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL EPSILON': 120750,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ETA': 120752,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL F': 120411,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL FINAL SIGMA': 120763,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL G': 120412,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL GAMMA': 120748,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL H': 120413,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL I': 120414,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL IOTA': 120754,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL J': 120415,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL K': 120416,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL KAPPA': 120755,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL L': 120417,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL LAMDA': 120756,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL M': 120418,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL MU': 120757,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL N': 120419,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL NU': 120758,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL O': 120420,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL OMEGA': 120770,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL OMICRON': 120760,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL P': 120421,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL PHI': 120767,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL PI': 120761,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL PSI': 120769,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL Q': 120422,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL R': 120423,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL RHO': 120762,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL S': 120424,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL SIGMA': 120764,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL T': 120425,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL TAU': 120765,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL THETA': 120753,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL U': 120426,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL UPSILON': 120766,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL V': 120427,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL W': 120428,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL X': 120429,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL XI': 120759,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL Y': 120430,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL Z': 120431,
'MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ZETA': 120751,
'MATHEMATICAL SANS-SERIF BOLD ITALIC THETA SYMBOL': 120773,
'MATHEMATICAL SANS-SERIF BOLD KAPPA SYMBOL': 120716,
'MATHEMATICAL SANS-SERIF BOLD NABLA': 120687,
'MATHEMATICAL SANS-SERIF BOLD PARTIAL DIFFERENTIAL': 120713,
'MATHEMATICAL SANS-SERIF BOLD PHI SYMBOL': 120717,
'MATHEMATICAL SANS-SERIF BOLD PI SYMBOL': 120719,
'MATHEMATICAL SANS-SERIF BOLD RHO SYMBOL': 120718,
'MATHEMATICAL SANS-SERIF BOLD SMALL A': 120302,
'MATHEMATICAL SANS-SERIF BOLD SMALL ALPHA': 120688,
'MATHEMATICAL SANS-SERIF BOLD SMALL B': 120303,
'MATHEMATICAL SANS-SERIF BOLD SMALL BETA': 120689,
'MATHEMATICAL SANS-SERIF BOLD SMALL C': 120304,
'MATHEMATICAL SANS-SERIF BOLD SMALL CHI': 120710,
'MATHEMATICAL SANS-SERIF BOLD SMALL D': 120305,
'MATHEMATICAL SANS-SERIF BOLD SMALL DELTA': 120691,
'MATHEMATICAL SANS-SERIF BOLD SMALL E': 120306,
'MATHEMATICAL SANS-SERIF BOLD SMALL EPSILON': 120692,
'MATHEMATICAL SANS-SERIF BOLD SMALL ETA': 120694,
'MATHEMATICAL SANS-SERIF BOLD SMALL F': 120307,
'MATHEMATICAL SANS-SERIF BOLD SMALL FINAL SIGMA': 120705,
'MATHEMATICAL SANS-SERIF BOLD SMALL G': 120308,
'MATHEMATICAL SANS-SERIF BOLD SMALL GAMMA': 120690,
'MATHEMATICAL SANS-SERIF BOLD SMALL H': 120309,
'MATHEMATICAL SANS-SERIF BOLD SMALL I': 120310,
'MATHEMATICAL SANS-SERIF BOLD SMALL IOTA': 120696,
'MATHEMATICAL SANS-SERIF BOLD SMALL J': 120311,
'MATHEMATICAL SANS-SERIF BOLD SMALL K': 120312,
'MATHEMATICAL SANS-SERIF BOLD SMALL KAPPA': 120697,
'MATHEMATICAL SANS-SERIF BOLD SMALL L': 120313,
'MATHEMATICAL SANS-SERIF BOLD SMALL LAMDA': 120698,
'MATHEMATICAL SANS-SERIF BOLD SMALL M': 120314,
'MATHEMATICAL SANS-SERIF BOLD SMALL MU': 120699,
'MATHEMATICAL SANS-SERIF BOLD SMALL N': 120315,
'MATHEMATICAL SANS-SERIF BOLD SMALL NU': 120700,
'MATHEMATICAL SANS-SERIF BOLD SMALL O': 120316,
'MATHEMATICAL SANS-SERIF BOLD SMALL OMEGA': 120712,
'MATHEMATICAL SANS-SERIF BOLD SMALL OMICRON': 120702,
'MATHEMATICAL SANS-SERIF BOLD SMALL P': 120317,
'MATHEMATICAL SANS-SERIF BOLD SMALL PHI': 120709,
'MATHEMATICAL SANS-SERIF BOLD SMALL PI': 120703,
'MATHEMATICAL SANS-SERIF BOLD SMALL PSI': 120711,
'MATHEMATICAL SANS-SERIF BOLD SMALL Q': 120318,
'MATHEMATICAL SANS-SERIF BOLD SMALL R': 120319,
'MATHEMATICAL SANS-SERIF BOLD SMALL RHO': 120704,
'MATHEMATICAL SANS-SERIF BOLD SMALL S': 120320,
'MATHEMATICAL SANS-SERIF BOLD SMALL SIGMA': 120706,
'MATHEMATICAL SANS-SERIF BOLD SMALL T': 120321,
'MATHEMATICAL SANS-SERIF BOLD SMALL TAU': 120707,
'MATHEMATICAL SANS-SERIF BOLD SMALL THETA': 120695,
'MATHEMATICAL SANS-SERIF BOLD SMALL U': 120322,
'MATHEMATICAL SANS-SERIF BOLD SMALL UPSILON': 120708,
'MATHEMATICAL SANS-SERIF BOLD SMALL V': 120323,
'MATHEMATICAL SANS-SERIF BOLD SMALL W': 120324,
'MATHEMATICAL SANS-SERIF BOLD SMALL X': 120325,
'MATHEMATICAL SANS-SERIF BOLD SMALL XI': 120701,
'MATHEMATICAL SANS-SERIF BOLD SMALL Y': 120326,
'MATHEMATICAL SANS-SERIF BOLD SMALL Z': 120327,
'MATHEMATICAL SANS-SERIF BOLD SMALL ZETA': 120693,
'MATHEMATICAL SANS-SERIF BOLD THETA SYMBOL': 120715,
'MATHEMATICAL SANS-SERIF CAPITAL A': 120224,
'MATHEMATICAL SANS-SERIF CAPITAL B': 120225,
'MATHEMATICAL SANS-SERIF CAPITAL C': 120226,
'MATHEMATICAL SANS-SERIF CAPITAL D': 120227,
'MATHEMATICAL SANS-SERIF CAPITAL E': 120228,
'MATHEMATICAL SANS-SERIF CAPITAL F': 120229,
'MATHEMATICAL SANS-SERIF CAPITAL G': 120230,
'MATHEMATICAL SANS-SERIF CAPITAL H': 120231,
'MATHEMATICAL SANS-SERIF CAPITAL I': 120232,
'MATHEMATICAL SANS-SERIF CAPITAL J': 120233,
'MATHEMATICAL SANS-SERIF CAPITAL K': 120234,
'MATHEMATICAL SANS-SERIF CAPITAL L': 120235,
'MATHEMATICAL SANS-SERIF CAPITAL M': 120236,
'MATHEMATICAL SANS-SERIF CAPITAL N': 120237,
'MATHEMATICAL SANS-SERIF CAPITAL O': 120238,
'MATHEMATICAL SANS-SERIF CAPITAL P': 120239,
'MATHEMATICAL SANS-SERIF CAPITAL Q': 120240,
'MATHEMATICAL SANS-SERIF CAPITAL R': 120241,
'MATHEMATICAL SANS-SERIF CAPITAL S': 120242,
'MATHEMATICAL SANS-SERIF CAPITAL T': 120243,
'MATHEMATICAL SANS-SERIF CAPITAL U': 120244,
'MATHEMATICAL SANS-SERIF CAPITAL V': 120245,
'MATHEMATICAL SANS-SERIF CAPITAL W': 120246,
'MATHEMATICAL SANS-SERIF CAPITAL X': 120247,
'MATHEMATICAL SANS-SERIF CAPITAL Y': 120248,
'MATHEMATICAL SANS-SERIF CAPITAL Z': 120249,
'MATHEMATICAL SANS-SERIF DIGIT EIGHT': 120810,
'MATHEMATICAL SANS-SERIF DIGIT FIVE': 120807,
'MATHEMATICAL SANS-SERIF DIGIT FOUR': 120806,
'MATHEMATICAL SANS-SERIF DIGIT NINE': 120811,
'MATHEMATICAL SANS-SERIF DIGIT ONE': 120803,
'MATHEMATICAL SANS-SERIF DIGIT SEVEN': 120809,
'MATHEMATICAL SANS-SERIF DIGIT SIX': 120808,
'MATHEMATICAL SANS-SERIF DIGIT THREE': 120805,
'MATHEMATICAL SANS-SERIF DIGIT TWO': 120804,
'MATHEMATICAL SANS-SERIF DIGIT ZERO': 120802,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL A': 120328,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL B': 120329,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL C': 120330,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL D': 120331,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL E': 120332,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL F': 120333,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL G': 120334,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL H': 120335,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL I': 120336,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL J': 120337,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL K': 120338,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL L': 120339,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL M': 120340,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL N': 120341,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL O': 120342,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL P': 120343,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL Q': 120344,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL R': 120345,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL S': 120346,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL T': 120347,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL U': 120348,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL V': 120349,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL W': 120350,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL X': 120351,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL Y': 120352,
'MATHEMATICAL SANS-SERIF ITALIC CAPITAL Z': 120353,
'MATHEMATICAL SANS-SERIF ITALIC SMALL A': 120354,
'MATHEMATICAL SANS-SERIF ITALIC SMALL B': 120355,
'MATHEMATICAL SANS-SERIF ITALIC SMALL C': 120356,
'MATHEMATICAL SANS-SERIF ITALIC SMALL D': 120357,
'MATHEMATICAL SANS-SERIF ITALIC SMALL E': 120358,
'MATHEMATICAL SANS-SERIF ITALIC SMALL F': 120359,
'MATHEMATICAL SANS-SERIF ITALIC SMALL G': 120360,
'MATHEMATICAL SANS-SERIF ITALIC SMALL H': 120361,
'MATHEMATICAL SANS-SERIF ITALIC SMALL I': 120362,
'MATHEMATICAL SANS-SERIF ITALIC SMALL J': 120363,
'MATHEMATICAL SANS-SERIF ITALIC SMALL K': 120364,
'MATHEMATICAL SANS-SERIF ITALIC SMALL L': 120365,
'MATHEMATICAL SANS-SERIF ITALIC SMALL M': 120366,
'MATHEMATICAL SANS-SERIF ITALIC SMALL N': 120367,
'MATHEMATICAL SANS-SERIF ITALIC SMALL O': 120368,
'MATHEMATICAL SANS-SERIF ITALIC SMALL P': 120369,
'MATHEMATICAL SANS-SERIF ITALIC SMALL Q': 120370,
'MATHEMATICAL SANS-SERIF ITALIC SMALL R': 120371,
'MATHEMATICAL SANS-SERIF ITALIC SMALL S': 120372,
'MATHEMATICAL SANS-SERIF ITALIC SMALL T': 120373,
'MATHEMATICAL SANS-SERIF ITALIC SMALL U': 120374,
'MATHEMATICAL SANS-SERIF ITALIC SMALL V': 120375,
'MATHEMATICAL SANS-SERIF ITALIC SMALL W': 120376,
'MATHEMATICAL SANS-SERIF ITALIC SMALL X': 120377,
'MATHEMATICAL SANS-SERIF ITALIC SMALL Y': 120378,
'MATHEMATICAL SANS-SERIF ITALIC SMALL Z': 120379,
'MATHEMATICAL SANS-SERIF SMALL A': 120250,
'MATHEMATICAL SANS-SERIF SMALL B': 120251,
'MATHEMATICAL SANS-SERIF SMALL C': 120252,
'MATHEMATICAL SANS-SERIF SMALL D': 120253,
'MATHEMATICAL SANS-SERIF SMALL E': 120254,
'MATHEMATICAL SANS-SERIF SMALL F': 120255,
'MATHEMATICAL SANS-SERIF SMALL G': 120256,
'MATHEMATICAL SANS-SERIF SMALL H': 120257,
'MATHEMATICAL SANS-SERIF SMALL I': 120258,
'MATHEMATICAL SANS-SERIF SMALL J': 120259,
'MATHEMATICAL SANS-SERIF SMALL K': 120260,
'MATHEMATICAL SANS-SERIF SMALL L': 120261,
'MATHEMATICAL SANS-SERIF SMALL M': 120262,
'MATHEMATICAL SANS-SERIF SMALL N': 120263,
'MATHEMATICAL SANS-SERIF SMALL O': 120264,
'MATHEMATICAL SANS-SERIF SMALL P': 120265,
'MATHEMATICAL SANS-SERIF SMALL Q': 120266,
'MATHEMATICAL SANS-SERIF SMALL R': 120267,
'MATHEMATICAL SANS-SERIF SMALL S': 120268,
'MATHEMATICAL SANS-SERIF SMALL T': 120269,
'MATHEMATICAL SANS-SERIF SMALL U': 120270,
'MATHEMATICAL SANS-SERIF SMALL V': 120271,
'MATHEMATICAL SANS-SERIF SMALL W': 120272,
'MATHEMATICAL SANS-SERIF SMALL X': 120273,
'MATHEMATICAL SANS-SERIF SMALL Y': 120274,
'MATHEMATICAL SANS-SERIF SMALL Z': 120275,
'MATHEMATICAL SCRIPT CAPITAL A': 119964,
'MATHEMATICAL SCRIPT CAPITAL C': 119966,
'MATHEMATICAL SCRIPT CAPITAL D': 119967,
'MATHEMATICAL SCRIPT CAPITAL G': 119970,
'MATHEMATICAL SCRIPT CAPITAL J': 119973,
'MATHEMATICAL SCRIPT CAPITAL K': 119974,
'MATHEMATICAL SCRIPT CAPITAL N': 119977,
'MATHEMATICAL SCRIPT CAPITAL O': 119978,
'MATHEMATICAL SCRIPT CAPITAL P': 119979,
'MATHEMATICAL SCRIPT CAPITAL Q': 119980,
'MATHEMATICAL SCRIPT CAPITAL S': 119982,
'MATHEMATICAL SCRIPT CAPITAL T': 119983,
'MATHEMATICAL SCRIPT CAPITAL U': 119984,
'MATHEMATICAL SCRIPT CAPITAL V': 119985,
'MATHEMATICAL SCRIPT CAPITAL W': 119986,
'MATHEMATICAL SCRIPT CAPITAL X': 119987,
'MATHEMATICAL SCRIPT CAPITAL Y': 119988,
'MATHEMATICAL SCRIPT CAPITAL Z': 119989,
'MATHEMATICAL SCRIPT SMALL A': 119990,
'MATHEMATICAL SCRIPT SMALL B': 119991,
'MATHEMATICAL SCRIPT SMALL C': 119992,
'MATHEMATICAL SCRIPT SMALL D': 119993,
'MATHEMATICAL SCRIPT SMALL F': 119995,
'MATHEMATICAL SCRIPT SMALL H': 119997,
'MATHEMATICAL SCRIPT SMALL I': 119998,
'MATHEMATICAL SCRIPT SMALL J': 119999,
'MATHEMATICAL SCRIPT SMALL K': 120000,
'MATHEMATICAL SCRIPT SMALL L': 120001,
'MATHEMATICAL SCRIPT SMALL M': 120002,
'MATHEMATICAL SCRIPT SMALL N': 120003,
'MATHEMATICAL SCRIPT SMALL P': 120005,
'MATHEMATICAL SCRIPT SMALL Q': 120006,
'MATHEMATICAL SCRIPT SMALL R': 120007,
'MATHEMATICAL SCRIPT SMALL S': 120008,
'MATHEMATICAL SCRIPT SMALL T': 120009,
'MATHEMATICAL SCRIPT SMALL U': 120010,
'MATHEMATICAL SCRIPT SMALL V': 120011,
'MATHEMATICAL SCRIPT SMALL W': 120012,
'MATHEMATICAL SCRIPT SMALL X': 120013,
'MATHEMATICAL SCRIPT SMALL Y': 120014,
'MATHEMATICAL SCRIPT SMALL Z': 120015,
'MEASURED ANGLE': 8737,
'MEASURED ANGLE OPENING LEFT': 10651,
'MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING DOWN AND LEFT': 10667,
'MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING DOWN AND RIGHT': 10666,
'MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING LEFT AND DOWN': 10671,
'MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING LEFT AND UP': 10669,
'MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING RIGHT AND DOWN': 10670,
'MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING RIGHT AND UP': 10668,
'MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING UP AND LEFT': 10665,
'MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING UP AND RIGHT': 10664,
'MEASURED BY': 8798,
'MEASURED RIGHT ANGLE WITH DOT': 10653,
'MEDIUM BLACK CIRCLE': 9899,
'MEDIUM FLATTENED LEFT PARENTHESIS ORNAMENT': 10090,
'MEDIUM FLATTENED RIGHT PARENTHESIS ORNAMENT': 10091,
'MEDIUM LEFT CURLY BRACKET ORNAMENT': 10100,
'MEDIUM LEFT PARENTHESIS ORNAMENT': 10088,
'MEDIUM LEFT-POINTING ANGLE BRACKET ORNAMENT': 10092,
'MEDIUM MATHEMATICAL SPACE': 8287,
'MEDIUM RIGHT CURLY BRACKET ORNAMENT': 10101,
'MEDIUM RIGHT PARENTHESIS ORNAMENT': 10089,
'MEDIUM RIGHT-POINTING ANGLE BRACKET ORNAMENT': 10093,
'MEDIUM SHADE': 9618,
'MEDIUM SMALL WHITE CIRCLE': 9900,
'MEDIUM VERTICAL BAR': 10073,
'MEDIUM WHITE CIRCLE': 9898,
'MEETEI MAYEK APUN IYEK': 44013,
'MEETEI MAYEK CHEIKHEI': 44011,
'MEETEI MAYEK DIGIT EIGHT': 44024,
'MEETEI MAYEK DIGIT FIVE': 44021,
'MEETEI MAYEK DIGIT FOUR': 44020,
'MEETEI MAYEK DIGIT NINE': 44025,
'MEETEI MAYEK DIGIT ONE': 44017,
'MEETEI MAYEK DIGIT SEVEN': 44023,
'MEETEI MAYEK DIGIT SIX': 44022,
'MEETEI MAYEK DIGIT THREE': 44019,
'MEETEI MAYEK DIGIT TWO': 44018,
'MEETEI MAYEK DIGIT ZERO': 44016,
'MEETEI MAYEK LETTER ATIYA': 43985,
'MEETEI MAYEK LETTER BA': 43989,
'MEETEI MAYEK LETTER BHAM': 43994,
'MEETEI MAYEK LETTER CHIL': 43974,
'MEETEI MAYEK LETTER DHOU': 43993,
'MEETEI MAYEK LETTER DIL': 43991,
'MEETEI MAYEK LETTER GHOU': 43992,
'MEETEI MAYEK LETTER GOK': 43986,
'MEETEI MAYEK LETTER HUK': 43981,
'MEETEI MAYEK LETTER I': 43983,
'MEETEI MAYEK LETTER I LONSUM': 44002,
'MEETEI MAYEK LETTER JHAM': 43987,
'MEETEI MAYEK LETTER JIL': 43990,
'MEETEI MAYEK LETTER KHOU': 43976,
'MEETEI MAYEK LETTER KOK': 43968,
'MEETEI MAYEK LETTER KOK LONSUM': 43995,
'MEETEI MAYEK LETTER LAI': 43970,
'MEETEI MAYEK LETTER LAI LONSUM': 43996,
'MEETEI MAYEK LETTER MIT': 43971,
'MEETEI MAYEK LETTER MIT LONSUM': 43997,
'MEETEI MAYEK LETTER NA': 43973,
'MEETEI MAYEK LETTER NA LONSUM': 43999,
'MEETEI MAYEK LETTER NGOU': 43977,
'MEETEI MAYEK LETTER NGOU LONSUM': 44001,
'MEETEI MAYEK LETTER PA': 43972,
'MEETEI MAYEK LETTER PA LONSUM': 43998,
'MEETEI MAYEK LETTER PHAM': 43984,
'MEETEI MAYEK LETTER RAI': 43988,
'MEETEI MAYEK LETTER SAM': 43969,
'MEETEI MAYEK LETTER THOU': 43978,
'MEETEI MAYEK LETTER TIL': 43975,
'MEETEI MAYEK LETTER TIL LONSUM': 44000,
'MEETEI MAYEK LETTER UN': 43982,
'MEETEI MAYEK LETTER WAI': 43979,
'MEETEI MAYEK LETTER YANG': 43980,
'MEETEI MAYEK LUM IYEK': 44012,
'MEETEI MAYEK VOWEL SIGN ANAP': 44005,
'MEETEI MAYEK VOWEL SIGN CHEINAP': 44009,
'MEETEI MAYEK VOWEL SIGN INAP': 44004,
'MEETEI MAYEK VOWEL SIGN NUNG': 44010,
'MEETEI MAYEK VOWEL SIGN ONAP': 44003,
'MEETEI MAYEK VOWEL SIGN SOUNAP': 44007,
'MEETEI MAYEK VOWEL SIGN UNAP': 44008,
'MEETEI MAYEK VOWEL SIGN YENAP': 44006,
'MERCURY': 9791,
'METRICAL BREVE': 9169,
'METRICAL LONG OVER SHORT': 9170,
'METRICAL LONG OVER TWO SHORTS': 9172,
'METRICAL PENTASEME': 9177,
'METRICAL SHORT OVER LONG': 9171,
'METRICAL TETRASEME': 9176,
'METRICAL TRISEME': 9175,
'METRICAL TWO SHORTS JOINED': 9174,
'METRICAL TWO SHORTS OVER LONG': 9173,
'MICRO SIGN': 181,
'MIDDLE DOT': 183,
'MIDLINE HORIZONTAL ELLIPSIS': 8943,
'MILL SIGN': 8357,
'MINUS SIGN': 8722,
'MINUS SIGN IN TRIANGLE': 10810,
'MINUS SIGN WITH COMMA ABOVE': 10793,
'MINUS SIGN WITH DOT BELOW': 10794,
'MINUS SIGN WITH FALLING DOTS': 10795,
'MINUS SIGN WITH RISING DOTS': 10796,
'MINUS TILDE': 8770,
'MINUS-OR-PLUS SIGN': 8723,
'MINY': 10751,
'MODELS': 8871,
'MODIFIER LETTER ACUTE ACCENT': 714,
'MODIFIER LETTER APOSTROPHE': 700,
'MODIFIER LETTER BEGIN HIGH TONE': 761,
'MODIFIER LETTER BEGIN LOW TONE': 763,
'MODIFIER LETTER CAPITAL A': 7468,
'MODIFIER LETTER CAPITAL AE': 7469,
'MODIFIER LETTER CAPITAL B': 7470,
'MODIFIER LETTER CAPITAL BARRED B': 7471,
'MODIFIER LETTER CAPITAL D': 7472,
'MODIFIER LETTER CAPITAL E': 7473,
'MODIFIER LETTER CAPITAL G': 7475,
'MODIFIER LETTER CAPITAL H': 7476,
'MODIFIER LETTER CAPITAL I': 7477,
'MODIFIER LETTER CAPITAL J': 7478,
'MODIFIER LETTER CAPITAL K': 7479,
'MODIFIER LETTER CAPITAL L': 7480,
'MODIFIER LETTER CAPITAL M': 7481,
'MODIFIER LETTER CAPITAL N': 7482,
'MODIFIER LETTER CAPITAL O': 7484,
'MODIFIER LETTER CAPITAL OU': 7485,
'MODIFIER LETTER CAPITAL P': 7486,
'MODIFIER LETTER CAPITAL R': 7487,
'MODIFIER LETTER CAPITAL REVERSED E': 7474,
'MODIFIER LETTER CAPITAL REVERSED N': 7483,
'MODIFIER LETTER CAPITAL T': 7488,
'MODIFIER LETTER CAPITAL U': 7489,
'MODIFIER LETTER CAPITAL V': 11389,
'MODIFIER LETTER CAPITAL W': 7490,
'MODIFIER LETTER CENTRED LEFT HALF RING': 723,
'MODIFIER LETTER CENTRED RIGHT HALF RING': 722,
'MODIFIER LETTER CHINESE TONE YANG PING': 42753,
'MODIFIER LETTER CHINESE TONE YANG QU': 42757,
'MODIFIER LETTER CHINESE TONE YANG RU': 42759,
'MODIFIER LETTER CHINESE TONE YANG SHANG': 42755,
'MODIFIER LETTER CHINESE TONE YIN PING': 42752,
'MODIFIER LETTER CHINESE TONE YIN QU': 42756,
'MODIFIER LETTER CHINESE TONE YIN RU': 42758,
'MODIFIER LETTER CHINESE TONE YIN SHANG': 42754,
'MODIFIER LETTER CIRCUMFLEX ACCENT': 710,
'MODIFIER LETTER COLON': 42889,
'MODIFIER LETTER CROSS ACCENT': 735,
'MODIFIER LETTER CYRILLIC EN': 7544,
'MODIFIER LETTER DOT HORIZONTAL BAR': 42777,
'MODIFIER LETTER DOT SLASH': 42776,
'MODIFIER LETTER DOT VERTICAL BAR': 42775,
'MODIFIER LETTER DOUBLE APOSTROPHE': 750,
'MODIFIER LETTER DOUBLE PRIME': 698,
'MODIFIER LETTER DOWN ARROWHEAD': 709,
'MODIFIER LETTER DOWN TACK': 725,
'MODIFIER LETTER END HIGH TONE': 762,
'MODIFIER LETTER END LOW TONE': 764,
'MODIFIER LETTER EXTRA-HIGH DOTTED LEFT-STEM TONE BAR': 42765,
'MODIFIER LETTER EXTRA-HIGH DOTTED TONE BAR': 42760,
'MODIFIER LETTER EXTRA-HIGH LEFT-STEM TONE BAR': 42770,
'MODIFIER LETTER EXTRA-HIGH TONE BAR': 741,
'MODIFIER LETTER EXTRA-LOW DOTTED LEFT-STEM TONE BAR': 42769,
'MODIFIER LETTER EXTRA-LOW DOTTED TONE BAR': 42764,
'MODIFIER LETTER EXTRA-LOW LEFT-STEM TONE BAR': 42774,
'MODIFIER LETTER EXTRA-LOW TONE BAR': 745,
'MODIFIER LETTER GEORGIAN NAR': 4348,
'MODIFIER LETTER GLOTTAL STOP': 704,
'MODIFIER LETTER GRAVE ACCENT': 715,
'MODIFIER LETTER HALF TRIANGULAR COLON': 721,
'MODIFIER LETTER HIGH DOTTED LEFT-STEM TONE BAR': 42766,
'MODIFIER LETTER HIGH DOTTED TONE BAR': 42761,
'MODIFIER LETTER HIGH LEFT-STEM TONE BAR': 42771,
'MODIFIER LETTER HIGH TONE BAR': 742,
'MODIFIER LETTER LEFT ARROWHEAD': 706,
'MODIFIER LETTER LEFT HALF RING': 703,
'MODIFIER LETTER LOW ACUTE ACCENT': 719,
'MODIFIER LETTER LOW CIRCUMFLEX ACCENT': 42888,
'MODIFIER LETTER LOW DOTTED LEFT-STEM TONE BAR': 42768,
'MODIFIER LETTER LOW DOTTED TONE BAR': 42763,
'MODIFIER LETTER LOW DOWN ARROWHEAD': 751,
'MODIFIER LETTER LOW GRAVE ACCENT': 718,
'MODIFIER LETTER LOW INVERTED EXCLAMATION MARK': 42783,
'MODIFIER LETTER LOW LEFT ARROW': 767,
'MODIFIER LETTER LOW LEFT ARROWHEAD': 753,
'MODIFIER LETTER LOW LEFT-STEM TONE BAR': 42773,
'MODIFIER LETTER LOW MACRON': 717,
'MODIFIER LETTER LOW RIGHT ARROWHEAD': 754,
'MODIFIER LETTER LOW RING': 755,
'MODIFIER LETTER LOW TILDE': 759,
'MODIFIER LETTER LOW TONE BAR': 744,
'MODIFIER LETTER LOW UP ARROWHEAD': 752,
'MODIFIER LETTER LOW VERTICAL LINE': 716,
'MODIFIER LETTER LOWER RIGHT CORNER ANGLE': 42778,
'MODIFIER LETTER MACRON': 713,
'MODIFIER LETTER MID DOTTED LEFT-STEM TONE BAR': 42767,
'MODIFIER LETTER MID DOTTED TONE BAR': 42762,
'MODIFIER LETTER MID LEFT-STEM TONE BAR': 42772,
'MODIFIER LETTER MID TONE BAR': 743,
'MODIFIER LETTER MIDDLE DOUBLE ACUTE ACCENT': 758,
'MODIFIER LETTER MIDDLE DOUBLE GRAVE ACCENT': 757,
'MODIFIER LETTER MIDDLE GRAVE ACCENT': 756,
'MODIFIER LETTER MINUS SIGN': 727,
'MODIFIER LETTER OPEN SHELF': 766,
'MODIFIER LETTER PLUS SIGN': 726,
'MODIFIER LETTER PRIME': 697,
'MODIFIER LETTER RAISED COLON': 760,
'MODIFIER LETTER RAISED DOWN ARROW': 42780,
'MODIFIER LETTER RAISED EXCLAMATION MARK': 42781,
'MODIFIER LETTER RAISED INVERTED EXCLAMATION MARK': 42782,
'MODIFIER LETTER RAISED UP ARROW': 42779,
'MODIFIER LETTER REVERSED COMMA': 701,
'MODIFIER LETTER REVERSED GLOTTAL STOP': 705,
'MODIFIER LETTER RHOTIC HOOK': 734,
'MODIFIER LETTER RIGHT ARROWHEAD': 707,
'MODIFIER LETTER RIGHT HALF RING': 702,
'MODIFIER LETTER SHELF': 765,
'MODIFIER LETTER SHORT EQUALS SIGN': 42890,
'MODIFIER LETTER SMALL A': 7491,
'MODIFIER LETTER SMALL AIN': 7516,
'MODIFIER LETTER SMALL ALPHA': 7493,
'MODIFIER LETTER SMALL B': 7495,
'MODIFIER LETTER SMALL BARRED O': 7601,
'MODIFIER LETTER SMALL BETA': 7517,
'MODIFIER LETTER SMALL BOTTOM HALF O': 7509,
'MODIFIER LETTER SMALL C': 7580,
'MODIFIER LETTER SMALL C WITH CURL': 7581,
'MODIFIER LETTER SMALL CAPITAL I': 7590,
'MODIFIER LETTER SMALL CAPITAL I WITH STROKE': 7591,
'MODIFIER LETTER SMALL CAPITAL INVERTED R': 694,
'MODIFIER LETTER SMALL CAPITAL L': 7595,
'MODIFIER LETTER SMALL CAPITAL N': 7600,
'MODIFIER LETTER SMALL CAPITAL U': 7608,
'MODIFIER LETTER SMALL CHI': 7521,
'MODIFIER LETTER SMALL D': 7496,
'MODIFIER LETTER SMALL DELTA': 7519,
'MODIFIER LETTER SMALL DOTLESS J WITH STROKE': 7585,
'MODIFIER LETTER SMALL E': 7497,
'MODIFIER LETTER SMALL ENG': 7505,
'MODIFIER LETTER SMALL ESH': 7604,
'MODIFIER LETTER SMALL ETH': 7582,
'MODIFIER LETTER SMALL EZH': 7614,
'MODIFIER LETTER SMALL F': 7584,
'MODIFIER LETTER SMALL G': 7501,
'MODIFIER LETTER SMALL GAMMA': 736,
'MODIFIER LETTER SMALL GREEK GAMMA': 7518,
'MODIFIER LETTER SMALL GREEK PHI': 7520,
'MODIFIER LETTER SMALL H': 688,
'MODIFIER LETTER SMALL H WITH HOOK': 689,
'MODIFIER LETTER SMALL I WITH STROKE': 7588,
'MODIFIER LETTER SMALL IOTA': 7589,
'MODIFIER LETTER SMALL J': 690,
'MODIFIER LETTER SMALL J WITH CROSSED-TAIL': 7592,
'MODIFIER LETTER SMALL K': 7503,
'MODIFIER LETTER SMALL L': 737,
'MODIFIER LETTER SMALL L WITH PALATAL HOOK': 7594,
'MODIFIER LETTER SMALL L WITH RETROFLEX HOOK': 7593,
'MODIFIER LETTER SMALL M': 7504,
'MODIFIER LETTER SMALL M WITH HOOK': 7596,
'MODIFIER LETTER SMALL N WITH LEFT HOOK': 7598,
'MODIFIER LETTER SMALL N WITH RETROFLEX HOOK': 7599,
'MODIFIER LETTER SMALL O': 7506,
'MODIFIER LETTER SMALL OPEN E': 7499,
'MODIFIER LETTER SMALL OPEN O': 7507,
'MODIFIER LETTER SMALL P': 7510,
'MODIFIER LETTER SMALL PHI': 7602,
'MODIFIER LETTER SMALL R': 691,
'MODIFIER LETTER SMALL REVERSED GLOTTAL STOP': 740,
'MODIFIER LETTER SMALL REVERSED OPEN E': 7583,
'MODIFIER LETTER SMALL S': 738,
'MODIFIER LETTER SMALL S WITH HOOK': 7603,
'MODIFIER LETTER SMALL SCHWA': 7498,
'MODIFIER LETTER SMALL SCRIPT G': 7586,
'MODIFIER LETTER SMALL SIDEWAYS U': 7513,
'MODIFIER LETTER SMALL T': 7511,
'MODIFIER LETTER SMALL T WITH PALATAL HOOK': 7605,
'MODIFIER LETTER SMALL THETA': 7615,
'MODIFIER LETTER SMALL TOP HALF O': 7508,
'MODIFIER LETTER SMALL TURNED A': 7492,
'MODIFIER LETTER SMALL TURNED AE': 7494,
'MODIFIER LETTER SMALL TURNED ALPHA': 7579,
'MODIFIER LETTER SMALL TURNED H': 7587,
'MODIFIER LETTER SMALL TURNED I': 7502,
'MODIFIER LETTER SMALL TURNED M': 7514,
'MODIFIER LETTER SMALL TURNED M WITH LONG LEG': 7597,
'MODIFIER LETTER SMALL TURNED OPEN E': 7500,
'MODIFIER LETTER SMALL TURNED R': 692,
'MODIFIER LETTER SMALL TURNED R WITH HOOK': 693,
'MODIFIER LETTER SMALL TURNED V': 7610,
'MODIFIER LETTER SMALL U': 7512,
'MODIFIER LETTER SMALL U BAR': 7606,
'MODIFIER LETTER SMALL UPSILON': 7607,
'MODIFIER LETTER SMALL V': 7515,
'MODIFIER LETTER SMALL V WITH HOOK': 7609,
'MODIFIER LETTER SMALL W': 695,
'MODIFIER LETTER SMALL X': 739,
'MODIFIER LETTER SMALL Y': 696,
'MODIFIER LETTER SMALL Z': 7611,
'MODIFIER LETTER SMALL Z WITH CURL': 7613,
'MODIFIER LETTER SMALL Z WITH RETROFLEX HOOK': 7612,
'MODIFIER LETTER STRESS AND HIGH TONE': 42784,
'MODIFIER LETTER STRESS AND LOW TONE': 42785,
'MODIFIER LETTER TRIANGULAR COLON': 720,
'MODIFIER LETTER TURNED COMMA': 699,
'MODIFIER LETTER UNASPIRATED': 749,
'MODIFIER LETTER UP ARROWHEAD': 708,
'MODIFIER LETTER UP TACK': 724,
'MODIFIER LETTER US': 42864,
'MODIFIER LETTER VERTICAL LINE': 712,
'MODIFIER LETTER VOICING': 748,
'MODIFIER LETTER YANG DEPARTING TONE MARK': 747,
'MODIFIER LETTER YIN DEPARTING TONE MARK': 746,
'MODULO TWO SUM': 10762,
'MONGOLIAN BIRGA': 6144,
'MONGOLIAN COLON': 6148,
'MONGOLIAN COMMA': 6146,
'MONGOLIAN DIGIT EIGHT': 6168,
'MONGOLIAN DIGIT FIVE': 6165,
'MONGOLIAN DIGIT FOUR': 6164,
'MONGOLIAN DIGIT NINE': 6169,
'MONGOLIAN DIGIT ONE': 6161,
'MONGOLIAN DIGIT SEVEN': 6167,
'MONGOLIAN DIGIT SIX': 6166,
'MONGOLIAN DIGIT THREE': 6163,
'MONGOLIAN DIGIT TWO': 6162,
'MONGOLIAN DIGIT ZERO': 6160,
'MONGOLIAN ELLIPSIS': 6145,
'MONGOLIAN FOUR DOTS': 6149,
'MONGOLIAN FREE VARIATION SELECTOR ONE': 6155,
'MONGOLIAN FREE VARIATION SELECTOR THREE': 6157,
'MONGOLIAN FREE VARIATION SELECTOR TWO': 6156,
'MONGOLIAN FULL STOP': 6147,
'MONGOLIAN LETTER A': 6176,
'MONGOLIAN LETTER ALI GALI A': 6279,
'MONGOLIAN LETTER ALI GALI AH': 6295,
'MONGOLIAN LETTER ALI GALI ANUSVARA ONE': 6272,
'MONGOLIAN LETTER ALI GALI BALUDA': 6277,
'MONGOLIAN LETTER ALI GALI CA': 6283,
'MONGOLIAN LETTER ALI GALI DA': 6289,
'MONGOLIAN LETTER ALI GALI DAGALGA': 6313,
'MONGOLIAN LETTER ALI GALI DAMARU': 6274,
'MONGOLIAN LETTER ALI GALI DDA': 6286,
'MONGOLIAN LETTER ALI GALI HALF U': 6310,
'MONGOLIAN LETTER ALI GALI HALF YA': 6311,
'MONGOLIAN LETTER ALI GALI I': 6280,
'MONGOLIAN LETTER ALI GALI INVERTED UBADAMA': 6276,
'MONGOLIAN LETTER ALI GALI KA': 6281,
'MONGOLIAN LETTER ALI GALI NGA': 6282,
'MONGOLIAN LETTER ALI GALI NNA': 6287,
'MONGOLIAN LETTER ALI GALI PA': 6290,
'MONGOLIAN LETTER ALI GALI PHA': 6291,
'MONGOLIAN LETTER ALI GALI SSA': 6292,
'MONGOLIAN LETTER ALI GALI TA': 6288,
'MONGOLIAN LETTER ALI GALI THREE BALUDA': 6278,
'MONGOLIAN LETTER ALI GALI TTA': 6284,
'MONGOLIAN LETTER ALI GALI TTHA': 6285,
'MONGOLIAN LETTER ALI GALI UBADAMA': 6275,
'MONGOLIAN LETTER ALI GALI VISARGA ONE': 6273,
'MONGOLIAN LETTER ALI GALI ZA': 6294,
'MONGOLIAN LETTER ALI GALI ZHA': 6293,
'MONGOLIAN LETTER ANG': 6185,
'MONGOLIAN LETTER BA': 6186,
'MONGOLIAN LETTER CHA': 6196,
'MONGOLIAN LETTER CHI': 6210,
'MONGOLIAN LETTER DA': 6195,
'MONGOLIAN LETTER E': 6177,
'MONGOLIAN LETTER EE': 6183,
'MONGOLIAN LETTER FA': 6201,
'MONGOLIAN LETTER GA': 6189,
'MONGOLIAN LETTER HAA': 6206,
'MONGOLIAN LETTER I': 6178,
'MONGOLIAN LETTER JA': 6197,
'MONGOLIAN LETTER KA': 6202,
'MONGOLIAN LETTER KHA': 6203,
'MONGOLIAN LETTER LA': 6191,
'MONGOLIAN LETTER LHA': 6208,
'MONGOLIAN LETTER MA': 6190,
'MONGOLIAN LETTER MANCHU ALI GALI BHA': 6312,
'MONGOLIAN LETTER MANCHU ALI GALI CA': 6300,
'MONGOLIAN LETTER MANCHU ALI GALI CYA': 6307,
'MONGOLIAN LETTER MANCHU ALI GALI DDHA': 6303,
'MONGOLIAN LETTER MANCHU ALI GALI DHA': 6305,
'MONGOLIAN LETTER MANCHU ALI GALI GHA': 6298,
'MONGOLIAN LETTER MANCHU ALI GALI JHA': 6301,
'MONGOLIAN LETTER MANCHU ALI GALI LHA': 6314,
'MONGOLIAN LETTER MANCHU ALI GALI NGA': 6299,
'MONGOLIAN LETTER MANCHU ALI GALI SSA': 6306,
'MONGOLIAN LETTER MANCHU ALI GALI TA': 6304,
'MONGOLIAN LETTER MANCHU ALI GALI TTA': 6302,
'MONGOLIAN LETTER MANCHU ALI GALI ZA': 6309,
'MONGOLIAN LETTER MANCHU ALI GALI ZHA': 6308,
'MONGOLIAN LETTER MANCHU FA': 6262,
'MONGOLIAN LETTER MANCHU I': 6259,
'MONGOLIAN LETTER MANCHU KA': 6260,
'MONGOLIAN LETTER MANCHU RA': 6261,
'MONGOLIAN LETTER MANCHU ZHA': 6263,
'MONGOLIAN LETTER NA': 6184,
'MONGOLIAN LETTER O': 6179,
'MONGOLIAN LETTER OE': 6181,
'MONGOLIAN LETTER PA': 6187,
'MONGOLIAN LETTER QA': 6188,
'MONGOLIAN LETTER RA': 6199,
'MONGOLIAN LETTER SA': 6192,
'MONGOLIAN LETTER SHA': 6193,
'MONGOLIAN LETTER SIBE ANG': 6242,
'MONGOLIAN LETTER SIBE CHA': 6257,
'MONGOLIAN LETTER SIBE DA': 6249,
'MONGOLIAN LETTER SIBE E': 6237,
'MONGOLIAN LETTER SIBE FA': 6251,
'MONGOLIAN LETTER SIBE GA': 6244,
'MONGOLIAN LETTER SIBE GAA': 6252,
'MONGOLIAN LETTER SIBE HA': 6245,
'MONGOLIAN LETTER SIBE HAA': 6253,
'MONGOLIAN LETTER SIBE I': 6238,
'MONGOLIAN LETTER SIBE IY': 6239,
'MONGOLIAN LETTER SIBE JA': 6250,
'MONGOLIAN LETTER SIBE KA': 6243,
'MONGOLIAN LETTER SIBE PA': 6246,
'MONGOLIAN LETTER SIBE RAA': 6256,
'MONGOLIAN LETTER SIBE SHA': 6247,
'MONGOLIAN LETTER SIBE TA': 6248,
'MONGOLIAN LETTER SIBE TSA': 6254,
'MONGOLIAN LETTER SIBE U': 6241,
'MONGOLIAN LETTER SIBE UE': 6240,
'MONGOLIAN LETTER SIBE ZA': 6255,
'MONGOLIAN LETTER SIBE ZHA': 6258,
'MONGOLIAN LETTER TA': 6194,
'MONGOLIAN LETTER TODO ALI GALI TA': 6296,
'MONGOLIAN LETTER TODO ALI GALI ZHA': 6297,
'MONGOLIAN LETTER TODO ANG': 6218,
'MONGOLIAN LETTER TODO BA': 6219,
'MONGOLIAN LETTER TODO CHA': 6226,
'MONGOLIAN LETTER TODO DA': 6225,
'MONGOLIAN LETTER TODO DZA': 6236,
'MONGOLIAN LETTER TODO E': 6212,
'MONGOLIAN LETTER TODO GA': 6222,
'MONGOLIAN LETTER TODO GAA': 6232,
'MONGOLIAN LETTER TODO HAA': 6233,
'MONGOLIAN LETTER TODO I': 6213,
'MONGOLIAN LETTER TODO JA': 6227,
'MONGOLIAN LETTER TODO JIA': 6234,
'MONGOLIAN LETTER TODO KA': 6231,
'MONGOLIAN LETTER TODO LONG VOWEL SIGN': 6211,
'MONGOLIAN LETTER TODO MA': 6223,
'MONGOLIAN LETTER TODO NIA': 6235,
'MONGOLIAN LETTER TODO O': 6214,
'MONGOLIAN LETTER TODO OE': 6216,
'MONGOLIAN LETTER TODO PA': 6220,
'MONGOLIAN LETTER TODO QA': 6221,
'MONGOLIAN LETTER TODO TA': 6224,
'MONGOLIAN LETTER TODO TSA': 6228,
'MONGOLIAN LETTER TODO U': 6215,
'MONGOLIAN LETTER TODO UE': 6217,
'MONGOLIAN LETTER TODO WA': 6230,
'MONGOLIAN LETTER TODO YA': 6229,
'MONGOLIAN LETTER TSA': 6204,
'MONGOLIAN LETTER U': 6180,
'MONGOLIAN LETTER UE': 6182,
'MONGOLIAN LETTER WA': 6200,
'MONGOLIAN LETTER YA': 6198,
'MONGOLIAN LETTER ZA': 6205,
'MONGOLIAN LETTER ZHI': 6209,
'MONGOLIAN LETTER ZRA': 6207,
'MONGOLIAN MANCHU COMMA': 6152,
'MONGOLIAN MANCHU FULL STOP': 6153,
'MONGOLIAN NIRUGU': 6154,
'MONGOLIAN SIBE SYLLABLE BOUNDARY MARKER': 6151,
'MONGOLIAN TODO SOFT HYPHEN': 6150,
'MONGOLIAN VOWEL SEPARATOR': 6158,
'MONOGRAM FOR EARTH': 119552,
'MONOGRAM FOR YANG': 9866,
'MONOGRAM FOR YIN': 9867,
'MONOSTABLE SYMBOL': 9101,
'MOUNTAIN': 9968,
'MUCH GREATER-THAN': 8811,
'MUCH LESS-THAN': 8810,
'MULTIMAP': 8888,
'MULTIPLICATION SIGN': 215,
'MULTIPLICATION SIGN IN DOUBLE CIRCLE': 10807,
'MULTIPLICATION SIGN IN LEFT HALF CIRCLE': 10804,
'MULTIPLICATION SIGN IN RIGHT HALF CIRCLE': 10805,
'MULTIPLICATION SIGN IN TRIANGLE': 10811,
'MULTIPLICATION SIGN WITH DOT ABOVE': 10800,
'MULTIPLICATION SIGN WITH UNDERBAR': 10801,
'MULTIPLICATION X': 10005,
'MULTISET': 8844,
'MULTISET MULTIPLICATION': 8845,
'MULTISET UNION': 8846,
'MUSIC FLAT SIGN': 9837,
'MUSIC NATURAL SIGN': 9838,
'MUSIC SHARP SIGN': 9839,
'MUSICAL SYMBOL ARPEGGIATO DOWN': 119172,
'MUSICAL SYMBOL ARPEGGIATO UP': 119171,
'MUSICAL SYMBOL BEGIN BEAM': 119155,
'MUSICAL SYMBOL BEGIN PHRASE': 119161,
'MUSICAL SYMBOL BEGIN SLUR': 119159,
'MUSICAL SYMBOL BEGIN TIE': 119157,
'MUSICAL SYMBOL BRACE': 119060,
'MUSICAL SYMBOL BRACKET': 119061,
'MUSICAL SYMBOL BREATH MARK': 119058,
'MUSICAL SYMBOL BREVE': 119132,
'MUSICAL SYMBOL BREVIS': 119224,
'MUSICAL SYMBOL BREVIS REST': 119235,
'MUSICAL SYMBOL C CLEF': 119073,
'MUSICAL SYMBOL CAESURA': 119059,
'MUSICAL SYMBOL CIRCLE X NOTEHEAD': 119109,
'MUSICAL SYMBOL CLIMACUS': 119255,
'MUSICAL SYMBOL CLIVIS': 119253,
'MUSICAL SYMBOL CLUSTER NOTEHEAD BLACK': 119131,
'MUSICAL SYMBOL CLUSTER NOTEHEAD WHITE': 119130,
'MUSICAL SYMBOL CODA': 119052,
'MUSICAL SYMBOL COMBINING ACCENT': 119163,
'MUSICAL SYMBOL COMBINING ACCENT-STACCATO': 119169,
'MUSICAL SYMBOL COMBINING AUGMENTATION DOT': 119149,
'MUSICAL SYMBOL COMBINING BEND': 119177,
'MUSICAL SYMBOL COMBINING DOIT': 119173,
'MUSICAL SYMBOL COMBINING DOUBLE TONGUE': 119178,
'MUSICAL SYMBOL COMBINING DOWN BOW': 119210,
'MUSICAL SYMBOL COMBINING FLAG-1': 119150,
'MUSICAL SYMBOL COMBINING FLAG-2': 119151,
'MUSICAL SYMBOL COMBINING FLAG-3': 119152,
'MUSICAL SYMBOL COMBINING FLAG-4': 119153,
'MUSICAL SYMBOL COMBINING FLAG-5': 119154,
'MUSICAL SYMBOL COMBINING FLIP': 119175,
'MUSICAL SYMBOL COMBINING HARMONIC': 119212,
'MUSICAL SYMBOL COMBINING LOURE': 119170,
'MUSICAL SYMBOL COMBINING MARCATO': 119167,
'MUSICAL SYMBOL COMBINING MARCATO-STACCATO': 119168,
'MUSICAL SYMBOL COMBINING RIP': 119174,
'MUSICAL SYMBOL COMBINING SMEAR': 119176,
'MUSICAL SYMBOL COMBINING SNAP PIZZICATO': 119213,
'MUSICAL SYMBOL COMBINING SPRECHGESANG STEM': 119142,
'MUSICAL SYMBOL COMBINING STACCATISSIMO': 119166,
'MUSICAL SYMBOL COMBINING STACCATO': 119164,
'MUSICAL SYMBOL COMBINING STEM': 119141,
'MUSICAL SYMBOL COMBINING TENUTO': 119165,
'MUSICAL SYMBOL COMBINING TREMOLO-1': 119143,
'MUSICAL SYMBOL COMBINING TREMOLO-2': 119144,
'MUSICAL SYMBOL COMBINING TREMOLO-3': 119145,
'MUSICAL SYMBOL COMBINING TRIPLE TONGUE': 119179,
'MUSICAL SYMBOL COMBINING UP BOW': 119211,
'MUSICAL SYMBOL COMMON TIME': 119092,
'MUSICAL SYMBOL CRESCENDO': 119186,
'MUSICAL SYMBOL CROIX': 119247,
'MUSICAL SYMBOL CUT TIME': 119093,
'MUSICAL SYMBOL DA CAPO': 119050,
'MUSICAL SYMBOL DAL SEGNO': 119049,
'MUSICAL SYMBOL DAMP': 119220,
'MUSICAL SYMBOL DAMP ALL': 119221,
'MUSICAL SYMBOL DASHED BARLINE': 119044,
'MUSICAL SYMBOL DECRESCENDO': 119187,
'MUSICAL SYMBOL DEGREE SLASH': 119209,
'MUSICAL SYMBOL DOUBLE BARLINE': 119041,
'MUSICAL SYMBOL DOUBLE FLAT': 119083,
'MUSICAL SYMBOL DOUBLE SHARP': 119082,
'MUSICAL SYMBOL DRUM CLEF-1': 119077,
'MUSICAL SYMBOL DRUM CLEF-2': 119078,
'MUSICAL SYMBOL EIGHTH NOTE': 119136,
'MUSICAL SYMBOL EIGHTH REST': 119102,
'MUSICAL SYMBOL END BEAM': 119156,
'MUSICAL SYMBOL END OF STIMME': 119208,
'MUSICAL SYMBOL END PHRASE': 119162,
'MUSICAL SYMBOL END SLUR': 119160,
'MUSICAL SYMBOL END TIE': 119158,
'MUSICAL SYMBOL F CLEF': 119074,
'MUSICAL SYMBOL F CLEF OTTAVA ALTA': 119075,
'MUSICAL SYMBOL F CLEF OTTAVA BASSA': 119076,
'MUSICAL SYMBOL FERMATA': 119056,
'MUSICAL SYMBOL FERMATA BELOW': 119057,
'MUSICAL SYMBOL FINAL BARLINE': 119042,
'MUSICAL SYMBOL FINGERED TREMOLO-1': 119146,
'MUSICAL SYMBOL FINGERED TREMOLO-2': 119147,
'MUSICAL SYMBOL FINGERED TREMOLO-3': 119148,
'MUSICAL SYMBOL FIVE-LINE STAFF': 119066,
'MUSICAL SYMBOL FLAT DOWN': 119085,
'MUSICAL SYMBOL FLAT UP': 119084,
'MUSICAL SYMBOL FORTE': 119185,
'MUSICAL SYMBOL FOUR-LINE STAFF': 119065,
'MUSICAL SYMBOL FOUR-STRING FRETBOARD': 119069,
'MUSICAL SYMBOL FUSA BLACK': 119232,
'MUSICAL SYMBOL FUSA WHITE': 119231,
'MUSICAL SYMBOL G CLEF': 119070,
'MUSICAL SYMBOL G CLEF OTTAVA ALTA': 119071,
'MUSICAL SYMBOL G CLEF OTTAVA BASSA': 119072,
'MUSICAL SYMBOL GLISSANDO DOWN': 119218,
'MUSICAL SYMBOL GLISSANDO UP': 119217,
'MUSICAL SYMBOL GRACE NOTE NO SLASH': 119189,
'MUSICAL SYMBOL GRACE NOTE SLASH': 119188,
'MUSICAL SYMBOL GREGORIAN C CLEF': 119248,
'MUSICAL SYMBOL GREGORIAN F CLEF': 119249,
'MUSICAL SYMBOL HALF NOTE': 119134,
'MUSICAL SYMBOL HALF PEDAL MARK': 119216,
'MUSICAL SYMBOL HALF REST': 119100,
'MUSICAL SYMBOL HAUPTSTIMME': 119206,
'MUSICAL SYMBOL INVERTED TURN': 119192,
'MUSICAL SYMBOL LEFT REPEAT SIGN': 119046,
'MUSICAL SYMBOL LONGA': 119223,
'MUSICAL SYMBOL LONGA IMPERFECTA REST': 119234,
'MUSICAL SYMBOL LONGA PERFECTA REST': 119233,
'MUSICAL SYMBOL MAXIMA': 119222,
'MUSICAL SYMBOL MEZZO': 119184,
'MUSICAL SYMBOL MINIMA': 119227,
'MUSICAL SYMBOL MINIMA BLACK': 119228,
'MUSICAL SYMBOL MINIMA REST': 119237,
'MUSICAL SYMBOL MOON NOTEHEAD BLACK': 119123,
'MUSICAL SYMBOL MOON NOTEHEAD WHITE': 119122,
'MUSICAL SYMBOL MULTI REST': 119098,
'MUSICAL SYMBOL MULTIPLE MEASURE REST': 119081,
'MUSICAL SYMBOL NATURAL DOWN': 119087,
'MUSICAL SYMBOL NATURAL UP': 119086,
'MUSICAL SYMBOL NEBENSTIMME': 119207,
'MUSICAL SYMBOL NOTEHEAD BLACK': 119128,
'MUSICAL SYMBOL NULL NOTEHEAD': 119129,
'MUSICAL SYMBOL ONE HUNDRED TWENTY-EIGHTH NOTE': 119140,
'MUSICAL SYMBOL ONE HUNDRED TWENTY-EIGHTH REST': 119106,
'MUSICAL SYMBOL ONE-LINE STAFF': 119062,
'MUSICAL SYMBOL ORNAMENT STROKE-1': 119195,
'MUSICAL SYMBOL ORNAMENT STROKE-10': 119204,
'MUSICAL SYMBOL ORNAMENT STROKE-11': 119205,
'MUSICAL SYMBOL ORNAMENT STROKE-2': 119196,
'MUSICAL SYMBOL ORNAMENT STROKE-3': 119197,
'MUSICAL SYMBOL ORNAMENT STROKE-4': 119198,
'MUSICAL SYMBOL ORNAMENT STROKE-5': 119199,
'MUSICAL SYMBOL ORNAMENT STROKE-6': 119200,
'MUSICAL SYMBOL ORNAMENT STROKE-7': 119201,
'MUSICAL SYMBOL ORNAMENT STROKE-8': 119202,
'MUSICAL SYMBOL ORNAMENT STROKE-9': 119203,
'MUSICAL SYMBOL OTTAVA ALTA': 119094,
'MUSICAL SYMBOL OTTAVA BASSA': 119095,
'MUSICAL SYMBOL PARENTHESIS NOTEHEAD': 119126,
'MUSICAL SYMBOL PEDAL MARK': 119214,
'MUSICAL SYMBOL PEDAL UP MARK': 119215,
'MUSICAL SYMBOL PES SUBPUNCTIS': 119261,
'MUSICAL SYMBOL PIANO': 119183,
'MUSICAL SYMBOL PLUS NOTEHEAD': 119108,
'MUSICAL SYMBOL PODATUS': 119252,
'MUSICAL SYMBOL PORRECTUS': 119257,
'MUSICAL SYMBOL PORRECTUS FLEXUS': 119258,
'MUSICAL SYMBOL QUARTER NOTE': 119135,
'MUSICAL SYMBOL QUARTER REST': 119101,
'MUSICAL SYMBOL QUARTER TONE FLAT': 119091,
'MUSICAL SYMBOL QUARTER TONE SHARP': 119090,
'MUSICAL SYMBOL QUINDICESIMA ALTA': 119096,
'MUSICAL SYMBOL QUINDICESIMA BASSA': 119097,
'MUSICAL SYMBOL REPEAT DOTS': 119048,
'MUSICAL SYMBOL REPEATED FIGURE-1': 119053,
'MUSICAL SYMBOL REPEATED FIGURE-2': 119054,
'MUSICAL SYMBOL REPEATED FIGURE-3': 119055,
'MUSICAL SYMBOL REVERSE FINAL BARLINE': 119043,
'MUSICAL SYMBOL RIGHT REPEAT SIGN': 119047,
'MUSICAL SYMBOL RINFORZANDO': 119180,
'MUSICAL SYMBOL SCANDICUS': 119254,
'MUSICAL SYMBOL SCANDICUS FLEXUS': 119259,
'MUSICAL SYMBOL SEGNO': 119051,
'MUSICAL SYMBOL SEMIBREVIS BLACK': 119226,
'MUSICAL SYMBOL SEMIBREVIS REST': 119236,
'MUSICAL SYMBOL SEMIBREVIS WHITE': 119225,
'MUSICAL SYMBOL SEMIMINIMA BLACK': 119230,
'MUSICAL SYMBOL SEMIMINIMA REST': 119238,
'MUSICAL SYMBOL SEMIMINIMA WHITE': 119229,
'MUSICAL SYMBOL SHARP DOWN': 119089,
'MUSICAL SYMBOL SHARP UP': 119088,
'MUSICAL SYMBOL SHORT BARLINE': 119045,
'MUSICAL SYMBOL SINGLE BARLINE': 119040,
'MUSICAL SYMBOL SIX-LINE STAFF': 119067,
'MUSICAL SYMBOL SIX-STRING FRETBOARD': 119068,
'MUSICAL SYMBOL SIXTEENTH NOTE': 119137,
'MUSICAL SYMBOL SIXTEENTH REST': 119103,
'MUSICAL SYMBOL SIXTY-FOURTH NOTE': 119139,
'MUSICAL SYMBOL SIXTY-FOURTH REST': 119105,
'MUSICAL SYMBOL SQUARE B': 119250,
'MUSICAL SYMBOL SQUARE NOTEHEAD BLACK': 119111,
'MUSICAL SYMBOL SQUARE NOTEHEAD WHITE': 119110,
'MUSICAL SYMBOL SUBITO': 119181,
'MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA': 119243,
'MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA DIMINUTION-1': 119244,
'MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA DIMINUTION-2': 119245,
'MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA DIMINUTION-3': 119246,
'MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE PERFECTA': 119242,
'MUSICAL SYMBOL TEMPUS PERFECTUM CUM PROLATIONE IMPERFECTA': 119240,
'MUSICAL SYMBOL TEMPUS PERFECTUM CUM PROLATIONE PERFECTA': 119239,
'MUSICAL SYMBOL TEMPUS PERFECTUM CUM PROLATIONE PERFECTA DIMINUTION-1': 119241,
'MUSICAL SYMBOL THIRTY-SECOND NOTE': 119138,
'MUSICAL SYMBOL THIRTY-SECOND REST': 119104,
'MUSICAL SYMBOL THREE-LINE STAFF': 119064,
'MUSICAL SYMBOL TORCULUS': 119256,
'MUSICAL SYMBOL TORCULUS RESUPINUS': 119260,
'MUSICAL SYMBOL TR': 119190,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD DOWN BLACK': 119119,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD DOWN WHITE': 119118,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD LEFT BLACK': 119115,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD LEFT WHITE': 119114,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD RIGHT BLACK': 119117,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD RIGHT WHITE': 119116,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD UP BLACK': 119113,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD UP RIGHT BLACK': 119121,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD UP RIGHT WHITE': 119120,
'MUSICAL SYMBOL TRIANGLE NOTEHEAD UP WHITE': 119112,
'MUSICAL SYMBOL TRIANGLE-ROUND NOTEHEAD DOWN BLACK': 119125,
'MUSICAL SYMBOL TRIANGLE-ROUND NOTEHEAD DOWN WHITE': 119124,
'MUSICAL SYMBOL TURN': 119191,
'MUSICAL SYMBOL TURN SLASH': 119193,
'MUSICAL SYMBOL TURN UP': 119194,
'MUSICAL SYMBOL TWO-LINE STAFF': 119063,
'MUSICAL SYMBOL VIRGA': 119251,
'MUSICAL SYMBOL VOID NOTEHEAD': 119127,
'MUSICAL SYMBOL WHOLE NOTE': 119133,
'MUSICAL SYMBOL WHOLE REST': 119099,
'MUSICAL SYMBOL WITH FINGERNAILS': 119219,
'MUSICAL SYMBOL X NOTEHEAD': 119107,
'MUSICAL SYMBOL Z': 119182,
'MYANMAR CONSONANT SIGN MEDIAL HA': 4158,
'MYANMAR CONSONANT SIGN MEDIAL RA': 4156,
'MYANMAR CONSONANT SIGN MEDIAL WA': 4157,
'MYANMAR CONSONANT SIGN MEDIAL YA': 4155,
'MYANMAR CONSONANT SIGN MON MEDIAL LA': 4192,
'MYANMAR CONSONANT SIGN MON MEDIAL MA': 4191,
'MYANMAR CONSONANT SIGN MON MEDIAL NA': 4190,
'MYANMAR CONSONANT SIGN SHAN MEDIAL WA': 4226,
'MYANMAR DIGIT EIGHT': 4168,
'MYANMAR DIGIT FIVE': 4165,
'MYANMAR DIGIT FOUR': 4164,
'MYANMAR DIGIT NINE': 4169,
'MYANMAR DIGIT ONE': 4161,
'MYANMAR DIGIT SEVEN': 4167,
'MYANMAR DIGIT SIX': 4166,
'MYANMAR DIGIT THREE': 4163,
'MYANMAR DIGIT TWO': 4162,
'MYANMAR DIGIT ZERO': 4160,
'MYANMAR LETTER A': 4129,
'MYANMAR LETTER AITON RA': 43642,
'MYANMAR LETTER AU': 4138,
'MYANMAR LETTER BA': 4119,
'MYANMAR LETTER BHA': 4120,
'MYANMAR LETTER CA': 4101,
'MYANMAR LETTER CHA': 4102,
'MYANMAR LETTER DA': 4114,
'MYANMAR LETTER DDA': 4109,
'MYANMAR LETTER DDHA': 4110,
'MYANMAR LETTER DHA': 4115,
'MYANMAR LETTER E': 4135,
'MYANMAR LETTER EASTERN PWO KAREN GHWA': 4208,
'MYANMAR LETTER EASTERN PWO KAREN NNA': 4206,
'MYANMAR LETTER EASTERN PWO KAREN YWA': 4207,
'MYANMAR LETTER GA': 4098,
'MYANMAR LETTER GHA': 4099,
'MYANMAR LETTER GREAT SA': 4159,
'MYANMAR LETTER HA': 4127,
'MYANMAR LETTER I': 4131,
'MYANMAR LETTER II': 4132,
'MYANMAR LETTER JA': 4103,
'MYANMAR LETTER JHA': 4104,
'MYANMAR LETTER KA': 4096,
'MYANMAR LETTER KHA': 4097,
'MYANMAR LETTER KHAMTI CA': 43617,
'MYANMAR LETTER KHAMTI CHA': 43618,
'MYANMAR LETTER KHAMTI DDA': 43624,
'MYANMAR LETTER KHAMTI DDHA': 43625,
'MYANMAR LETTER KHAMTI DHA': 43626,
'MYANMAR LETTER KHAMTI FA': 43631,
'MYANMAR LETTER KHAMTI GA': 43616,
'MYANMAR LETTER KHAMTI HA': 43629,
'MYANMAR LETTER KHAMTI HHA': 43630,
'MYANMAR LETTER KHAMTI JA': 43619,
'MYANMAR LETTER KHAMTI JHA': 43620,
'MYANMAR LETTER KHAMTI NA': 43627,
'MYANMAR LETTER KHAMTI NYA': 43621,
'MYANMAR LETTER KHAMTI RA': 43635,
'MYANMAR LETTER KHAMTI SA': 43628,
'MYANMAR LETTER KHAMTI TTA': 43622,
'MYANMAR LETTER KHAMTI TTHA': 43623,
'MYANMAR LETTER KHAMTI XA': 43633,
'MYANMAR LETTER KHAMTI ZA': 43634,
'MYANMAR LETTER LA': 4124,
'MYANMAR LETTER LLA': 4128,
'MYANMAR LETTER MA': 4121,
'MYANMAR LETTER MON BBA': 4188,
'MYANMAR LETTER MON BBE': 4189,
'MYANMAR LETTER MON E': 4136,
'MYANMAR LETTER MON JHA': 4187,
'MYANMAR LETTER MON NGA': 4186,
'MYANMAR LETTER NA': 4116,
'MYANMAR LETTER NGA': 4100,
'MYANMAR LETTER NNA': 4111,
'MYANMAR LETTER NNYA': 4106,
'MYANMAR LETTER NYA': 4105,
'MYANMAR LETTER O': 4137,
'MYANMAR LETTER PA': 4117,
'MYANMAR LETTER PHA': 4118,
'MYANMAR LETTER RA': 4123,
'MYANMAR LETTER RUMAI PALAUNG FA': 4238,
'MYANMAR LETTER SA': 4126,
'MYANMAR LETTER SGAW KAREN SHA': 4193,
'MYANMAR LETTER SHA': 4176,
'MYANMAR LETTER SHAN A': 4130,
'MYANMAR LETTER SHAN BA': 4223,
'MYANMAR LETTER SHAN CA': 4216,
'MYANMAR LETTER SHAN DA': 4219,
'MYANMAR LETTER SHAN FA': 4222,
'MYANMAR LETTER SHAN GA': 4215,
'MYANMAR LETTER SHAN HA': 4225,
'MYANMAR LETTER SHAN KA': 4213,
'MYANMAR LETTER SHAN KHA': 4214,
'MYANMAR LETTER SHAN NA': 4220,
'MYANMAR LETTER SHAN NYA': 4218,
'MYANMAR LETTER SHAN PHA': 4221,
'MYANMAR LETTER SHAN THA': 4224,
'MYANMAR LETTER SHAN ZA': 4217,
'MYANMAR LETTER SSA': 4177,
'MYANMAR LETTER TA': 4112,
'MYANMAR LETTER THA': 4113,
'MYANMAR LETTER TTA': 4107,
'MYANMAR LETTER TTHA': 4108,
'MYANMAR LETTER U': 4133,
'MYANMAR LETTER UU': 4134,
'MYANMAR LETTER VOCALIC L': 4180,
'MYANMAR LETTER VOCALIC LL': 4181,
'MYANMAR LETTER VOCALIC R': 4178,
'MYANMAR LETTER VOCALIC RR': 4179,
'MYANMAR LETTER WA': 4125,
'MYANMAR LETTER WESTERN PWO KAREN PWA': 4198,
'MYANMAR LETTER WESTERN PWO KAREN THA': 4197,
'MYANMAR LETTER YA': 4122,
'MYANMAR LOGOGRAM KHAMTI HM': 43638,
'MYANMAR LOGOGRAM KHAMTI OAY': 43636,
'MYANMAR LOGOGRAM KHAMTI QN': 43637,
'MYANMAR MODIFIER LETTER KHAMTI REDUPLICATION': 43632,
'MYANMAR SHAN DIGIT EIGHT': 4248,
'MYANMAR SHAN DIGIT FIVE': 4245,
'MYANMAR SHAN DIGIT FOUR': 4244,
'MYANMAR SHAN DIGIT NINE': 4249,
'MYANMAR SHAN DIGIT ONE': 4241,
'MYANMAR SHAN DIGIT SEVEN': 4247,
'MYANMAR SHAN DIGIT SIX': 4246,
'MYANMAR SHAN DIGIT THREE': 4243,
'MYANMAR SHAN DIGIT TWO': 4242,
'MYANMAR SHAN DIGIT ZERO': 4240,
'MYANMAR SIGN ANUSVARA': 4150,
'MYANMAR SIGN ASAT': 4154,
'MYANMAR SIGN DOT BELOW': 4151,
'MYANMAR SIGN KHAMTI TONE-1': 4250,
'MYANMAR SIGN KHAMTI TONE-3': 4251,
'MYANMAR SIGN LITTLE SECTION': 4170,
'MYANMAR SIGN PAO KAREN TONE': 43643,
'MYANMAR SIGN RUMAI PALAUNG TONE-5': 4239,
'MYANMAR SIGN SECTION': 4171,
'MYANMAR SIGN SHAN COUNCIL EMPHATIC TONE': 4237,
'MYANMAR SIGN SHAN COUNCIL TONE-2': 4235,
'MYANMAR SIGN SHAN COUNCIL TONE-3': 4236,
'MYANMAR SIGN SHAN TONE-2': 4231,
'MYANMAR SIGN SHAN TONE-3': 4232,
'MYANMAR SIGN SHAN TONE-5': 4233,
'MYANMAR SIGN SHAN TONE-6': 4234,
'MYANMAR SIGN VIRAMA': 4153,
'MYANMAR SIGN VISARGA': 4152,
'MYANMAR SIGN WESTERN PWO KAREN TONE-1': 4201,
'MYANMAR SIGN WESTERN PWO KAREN TONE-2': 4202,
'MYANMAR SIGN WESTERN PWO KAREN TONE-3': 4203,
'MYANMAR SIGN WESTERN PWO KAREN TONE-4': 4204,
'MYANMAR SIGN WESTERN PWO KAREN TONE-5': 4205,
'MYANMAR SYMBOL AFOREMENTIONED': 4174,
'MYANMAR SYMBOL AITON EXCLAMATION': 43639,
'MYANMAR SYMBOL AITON ONE': 43640,
'MYANMAR SYMBOL AITON TWO': 43641,
'MYANMAR SYMBOL COMPLETED': 4173,
'MYANMAR SYMBOL GENITIVE': 4175,
'MYANMAR SYMBOL LOCATIVE': 4172,
'MYANMAR SYMBOL SHAN EXCLAMATION': 4255,
'MYANMAR SYMBOL SHAN ONE': 4254,
'MYANMAR TONE MARK SGAW KAREN HATHI': 4195,
'MYANMAR TONE MARK SGAW KAREN KE PHO': 4196,
'MYANMAR VOWEL SIGN AA': 4140,
'MYANMAR VOWEL SIGN AI': 4146,
'MYANMAR VOWEL SIGN AITON A': 4252,
'MYANMAR VOWEL SIGN AITON AI': 4253,
'MYANMAR VOWEL SIGN E': 4145,
'MYANMAR VOWEL SIGN E ABOVE': 4149,
'MYANMAR VOWEL SIGN GEBA KAREN I': 4209,
'MYANMAR VOWEL SIGN I': 4141,
'MYANMAR VOWEL SIGN II': 4142,
'MYANMAR VOWEL SIGN KAYAH EE': 4212,
'MYANMAR VOWEL SIGN KAYAH OE': 4210,
'MYANMAR VOWEL SIGN KAYAH U': 4211,
'MYANMAR VOWEL SIGN MON II': 4147,
'MYANMAR VOWEL SIGN MON O': 4148,
'MYANMAR VOWEL SIGN SGAW KAREN EU': 4194,
'MYANMAR VOWEL SIGN SHAN AA': 4227,
'MYANMAR VOWEL SIGN SHAN E': 4228,
'MYANMAR VOWEL SIGN SHAN E ABOVE': 4229,
'MYANMAR VOWEL SIGN SHAN FINAL Y': 4230,
'MYANMAR VOWEL SIGN TALL AA': 4139,
'MYANMAR VOWEL SIGN U': 4143,
'MYANMAR VOWEL SIGN UU': 4144,
'MYANMAR VOWEL SIGN VOCALIC L': 4184,
'MYANMAR VOWEL SIGN VOCALIC LL': 4185,
'MYANMAR VOWEL SIGN VOCALIC R': 4182,
'MYANMAR VOWEL SIGN VOCALIC RR': 4183,
'MYANMAR VOWEL SIGN WESTERN PWO KAREN EU': 4199,
'MYANMAR VOWEL SIGN WESTERN PWO KAREN UE': 4200,
'N-ARY CIRCLED DOT OPERATOR': 10752,
'N-ARY CIRCLED PLUS OPERATOR': 10753,
'N-ARY CIRCLED TIMES OPERATOR': 10754,
'N-ARY COPRODUCT': 8720,
'N-ARY INTERSECTION': 8898,
'N-ARY LOGICAL AND': 8896,
'N-ARY LOGICAL OR': 8897,
'N-ARY PRODUCT': 8719,
'N-ARY SQUARE INTERSECTION OPERATOR': 10757,
'N-ARY SQUARE UNION OPERATOR': 10758,
'N-ARY SUMMATION': 8721,
'N-ARY TIMES OPERATOR': 10761,
'N-ARY UNION': 8899,
'N-ARY UNION OPERATOR WITH DOT': 10755,
'N-ARY UNION OPERATOR WITH PLUS': 10756,
'N-ARY WHITE VERTICAL BAR': 11007,
'NABLA': 8711,
'NAIRA SIGN': 8358,
'NAND': 8892,
'NARROW NO-BREAK SPACE': 8239,
'NATIONAL DIGIT SHAPES': 8302,
'NEGATED DOUBLE VERTICAL BAR DOUBLE RIGHT TURNSTILE': 8879,
'NEGATIVE CIRCLED DIGIT ZERO': 9471,
'NEGATIVE CIRCLED LATIN CAPITAL LETTER H': 127319,
'NEGATIVE CIRCLED LATIN CAPITAL LETTER P': 127327,
'NEGATIVE CIRCLED NUMBER EIGHTEEN': 9458,
'NEGATIVE CIRCLED NUMBER ELEVEN': 9451,
'NEGATIVE CIRCLED NUMBER FIFTEEN': 9455,
'NEGATIVE CIRCLED NUMBER FOURTEEN': 9454,
'NEGATIVE CIRCLED NUMBER NINETEEN': 9459,
'NEGATIVE CIRCLED NUMBER SEVENTEEN': 9457,
'NEGATIVE CIRCLED NUMBER SIXTEEN': 9456,
'NEGATIVE CIRCLED NUMBER THIRTEEN': 9453,
'NEGATIVE CIRCLED NUMBER TWELVE': 9452,
'NEGATIVE CIRCLED NUMBER TWENTY': 9460,
'NEGATIVE SQUARED IC': 127371,
'NEGATIVE SQUARED LATIN CAPITAL LETTER J': 127353,
'NEGATIVE SQUARED LATIN CAPITAL LETTER L': 127355,
'NEGATIVE SQUARED LATIN CAPITAL LETTER M': 127356,
'NEGATIVE SQUARED LATIN CAPITAL LETTER P': 127359,
'NEGATIVE SQUARED PA': 127372,
'NEGATIVE SQUARED SA': 127373,
'NEITHER A SUBSET OF NOR EQUAL TO': 8840,
'NEITHER A SUPERSET OF NOR EQUAL TO': 8841,
'NEITHER APPROXIMATELY NOR ACTUALLY EQUAL TO': 8775,
'NEITHER GREATER-THAN NOR EQUAL TO': 8817,
'NEITHER GREATER-THAN NOR EQUIVALENT TO': 8821,
'NEITHER GREATER-THAN NOR LESS-THAN': 8825,
'NEITHER LESS-THAN NOR EQUAL TO': 8816,
'NEITHER LESS-THAN NOR EQUIVALENT TO': 8820,
'NEITHER LESS-THAN NOR GREATER-THAN': 8824,
'NEPTUNE': 9798,
'NEUTER': 9906,
'NEW SHEQEL SIGN': 8362,
'NEW TAI LUE DIGIT EIGHT': 6616,
'NEW TAI LUE DIGIT FIVE': 6613,
'NEW TAI LUE DIGIT FOUR': 6612,
'NEW TAI LUE DIGIT NINE': 6617,
'NEW TAI LUE DIGIT ONE': 6609,
'NEW TAI LUE DIGIT SEVEN': 6615,
'NEW TAI LUE DIGIT SIX': 6614,
'NEW TAI LUE DIGIT THREE': 6611,
'NEW TAI LUE DIGIT TWO': 6610,
'NEW TAI LUE DIGIT ZERO': 6608,
'NEW TAI LUE LETTER FINAL B': 6599,
'NEW TAI LUE LETTER FINAL D': 6598,
'NEW TAI LUE LETTER FINAL K': 6597,
'NEW TAI LUE LETTER FINAL M': 6596,
'NEW TAI LUE LETTER FINAL N': 6595,
'NEW TAI LUE LETTER FINAL NG': 6594,
'NEW TAI LUE LETTER FINAL V': 6593,
'NEW TAI LUE LETTER HIGH BA': 6562,
'NEW TAI LUE LETTER HIGH DA': 6561,
'NEW TAI LUE LETTER HIGH FA': 6554,
'NEW TAI LUE LETTER HIGH HA': 6560,
'NEW TAI LUE LETTER HIGH KA': 6530,
'NEW TAI LUE LETTER HIGH KVA': 6566,
'NEW TAI LUE LETTER HIGH LA': 6556,
'NEW TAI LUE LETTER HIGH MA': 6550,
'NEW TAI LUE LETTER HIGH NA': 6544,
'NEW TAI LUE LETTER HIGH NGA': 6532,
'NEW TAI LUE LETTER HIGH PA': 6548,
'NEW TAI LUE LETTER HIGH PHA': 6549,
'NEW TAI LUE LETTER HIGH QA': 6528,
'NEW TAI LUE LETTER HIGH SA': 6537,
'NEW TAI LUE LETTER HIGH SUA': 6570,
'NEW TAI LUE LETTER HIGH TA': 6542,
'NEW TAI LUE LETTER HIGH THA': 6543,
'NEW TAI LUE LETTER HIGH TSA': 6536,
'NEW TAI LUE LETTER HIGH VA': 6555,
'NEW TAI LUE LETTER HIGH XA': 6531,
'NEW TAI LUE LETTER HIGH XVA': 6567,
'NEW TAI LUE LETTER HIGH YA': 6538,
'NEW TAI LUE LETTER LOW BA': 6565,
'NEW TAI LUE LETTER LOW DA': 6564,
'NEW TAI LUE LETTER LOW FA': 6557,
'NEW TAI LUE LETTER LOW HA': 6563,
'NEW TAI LUE LETTER LOW KA': 6533,
'NEW TAI LUE LETTER LOW KVA': 6568,
'NEW TAI LUE LETTER LOW LA': 6559,
'NEW TAI LUE LETTER LOW MA': 6553,
'NEW TAI LUE LETTER LOW NA': 6547,
'NEW TAI LUE LETTER LOW NGA': 6535,
'NEW TAI LUE LETTER LOW PA': 6551,
'NEW TAI LUE LETTER LOW PHA': 6552,
'NEW TAI LUE LETTER LOW QA': 6529,
'NEW TAI LUE LETTER LOW SA': 6540,
'NEW TAI LUE LETTER LOW SUA': 6571,
'NEW TAI LUE LETTER LOW TA': 6545,
'NEW TAI LUE LETTER LOW THA': 6546,
'NEW TAI LUE LETTER LOW TSA': 6539,
'NEW TAI LUE LETTER LOW VA': 6558,
'NEW TAI LUE LETTER LOW XA': 6534,
'NEW TAI LUE LETTER LOW XVA': 6569,
'NEW TAI LUE LETTER LOW YA': 6541,
'NEW TAI LUE SIGN LAE': 6622,
'NEW TAI LUE SIGN LAEV': 6623,
'NEW TAI LUE THAM DIGIT ONE': 6618,
'NEW TAI LUE TONE MARK-1': 6600,
'NEW TAI LUE TONE MARK-2': 6601,
'NEW TAI LUE VOWEL SIGN AA': 6577,
'NEW TAI LUE VOWEL SIGN AAY': 6587,
'NEW TAI LUE VOWEL SIGN AE': 6582,
'NEW TAI LUE VOWEL SIGN AY': 6586,
'NEW TAI LUE VOWEL SIGN E': 6581,
'NEW TAI LUE VOWEL SIGN II': 6578,
'NEW TAI LUE VOWEL SIGN IY': 6592,
'NEW TAI LUE VOWEL SIGN O': 6583,
'NEW TAI LUE VOWEL SIGN OA': 6584,
'NEW TAI LUE VOWEL SIGN OAY': 6590,
'NEW TAI LUE VOWEL SIGN OY': 6589,
'NEW TAI LUE VOWEL SIGN U': 6579,
'NEW TAI LUE VOWEL SIGN UE': 6585,
'NEW TAI LUE VOWEL SIGN UEY': 6591,
'NEW TAI LUE VOWEL SIGN UU': 6580,
'NEW TAI LUE VOWEL SIGN UY': 6588,
'NEW TAI LUE VOWEL SIGN VOWEL SHORTENER': 6576,
'NEXT PAGE': 9112,
'NKO COMBINING DOUBLE DOT ABOVE': 2035,
'NKO COMBINING LONG DESCENDING TONE': 2030,
'NKO COMBINING LONG HIGH TONE': 2031,
'NKO COMBINING LONG LOW TONE': 2032,
'NKO COMBINING LONG RISING TONE': 2033,
'NKO COMBINING NASALIZATION MARK': 2034,
'NKO COMBINING SHORT HIGH TONE': 2027,
'NKO COMBINING SHORT LOW TONE': 2028,
'NKO COMBINING SHORT RISING TONE': 2029,
'NKO COMMA': 2040,
'NKO DIGIT EIGHT': 1992,
'NKO DIGIT FIVE': 1989,
'NKO DIGIT FOUR': 1988,
'NKO DIGIT NINE': 1993,
'NKO DIGIT ONE': 1985,
'NKO DIGIT SEVEN': 1991,
'NKO DIGIT SIX': 1990,
'NKO DIGIT THREE': 1987,
'NKO DIGIT TWO': 1986,
'NKO DIGIT ZERO': 1984,
'NKO EXCLAMATION MARK': 2041,
'NKO HIGH TONE APOSTROPHE': 2036,
'NKO LAJANYALAN': 2042,
'NKO LETTER A': 1994,
'NKO LETTER BA': 2003,
'NKO LETTER CHA': 2007,
'NKO LETTER DA': 2008,
'NKO LETTER DAGBASINNA': 2001,
'NKO LETTER E': 1997,
'NKO LETTER EE': 1995,
'NKO LETTER FA': 2013,
'NKO LETTER GBA': 2012,
'NKO LETTER HA': 2020,
'NKO LETTER I': 1996,
'NKO LETTER JA': 2006,
'NKO LETTER JONA CHA': 2025,
'NKO LETTER JONA JA': 2024,
'NKO LETTER JONA RA': 2026,
'NKO LETTER KA': 2014,
'NKO LETTER LA': 2015,
'NKO LETTER MA': 2017,
'NKO LETTER N': 2002,
'NKO LETTER NA': 2019,
'NKO LETTER NA WOLOSO': 2016,
'NKO LETTER NYA': 2018,
'NKO LETTER NYA WOLOSO': 2023,
'NKO LETTER O': 2000,
'NKO LETTER OO': 1999,
'NKO LETTER PA': 2004,
'NKO LETTER RA': 2009,
'NKO LETTER RRA': 2010,
'NKO LETTER SA': 2011,
'NKO LETTER TA': 2005,
'NKO LETTER U': 1998,
'NKO LETTER WA': 2021,
'NKO LETTER YA': 2022,
'NKO LOW TONE APOSTROPHE': 2037,
'NKO SYMBOL GBAKURUNEN': 2039,
'NKO SYMBOL OO DENNEN': 2038,
'NO ENTRY': 9940,
'NO-BREAK SPACE': 160,
'NOMINAL DIGIT SHAPES': 8303,
'NON-BREAKING HYPHEN': 8209,
'NONFORKING': 10973,
'NOR': 8893,
'NORMAL SUBGROUP OF': 8882,
'NORMAL SUBGROUP OF OR EQUAL TO': 8884,
'NORTH EAST AND SOUTH WEST ARROW': 10530,
'NORTH EAST ARROW': 8599,
'NORTH EAST ARROW AND SOUTH EAST ARROW': 10536,
'NORTH EAST ARROW CROSSING NORTH WEST ARROW': 10545,
'NORTH EAST ARROW CROSSING SOUTH EAST ARROW': 10542,
'NORTH EAST ARROW WITH HOOK': 10532,
'NORTH EAST BLACK ARROW': 11016,
'NORTH EAST DOUBLE ARROW': 8663,
'NORTH EAST WHITE ARROW': 11008,
'NORTH INDIC FRACTION ONE EIGHTH': 43060,
'NORTH INDIC FRACTION ONE HALF': 43057,
'NORTH INDIC FRACTION ONE QUARTER': 43056,
'NORTH INDIC FRACTION ONE SIXTEENTH': 43059,
'NORTH INDIC FRACTION THREE QUARTERS': 43058,
'NORTH INDIC FRACTION THREE SIXTEENTHS': 43061,
'NORTH INDIC PLACEHOLDER MARK': 43063,
'NORTH INDIC QUANTITY MARK': 43065,
'NORTH INDIC QUARTER MARK': 43062,
'NORTH INDIC RUPEE MARK': 43064,
'NORTH WEST AND SOUTH EAST ARROW': 10529,
'NORTH WEST ARROW': 8598,
'NORTH WEST ARROW AND NORTH EAST ARROW': 10535,
'NORTH WEST ARROW CROSSING NORTH EAST ARROW': 10546,
'NORTH WEST ARROW TO CORNER': 8689,
'NORTH WEST ARROW TO LONG BAR': 8632,
'NORTH WEST ARROW WITH HOOK': 10531,
'NORTH WEST BLACK ARROW': 11017,
'NORTH WEST DOUBLE ARROW': 8662,
'NORTH WEST WHITE ARROW': 11009,
'NOT A SUBSET OF': 8836,
'NOT A SUPERSET OF': 8837,
'NOT ALMOST EQUAL TO': 8777,
'NOT AN ELEMENT OF': 8713,
'NOT ASYMPTOTICALLY EQUAL TO': 8772,
'NOT CHECK MARK': 9083,
'NOT EQUAL TO': 8800,
'NOT EQUIVALENT TO': 8813,
'NOT GREATER-THAN': 8815,
'NOT IDENTICAL TO': 8802,
'NOT LESS-THAN': 8814,
'NOT NORMAL SUBGROUP OF': 8938,
'NOT NORMAL SUBGROUP OF OR EQUAL TO': 8940,
'NOT PARALLEL TO': 8742,
'NOT SIGN': 172,
'NOT SQUARE IMAGE OF OR EQUAL TO': 8930,
'NOT SQUARE ORIGINAL OF OR EQUAL TO': 8931,
'NOT TILDE': 8769,
'NOT TRUE': 8877,
'NOTCHED LOWER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW': 10159,
'NOTCHED UPPER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW': 10161,
'NUMBER EIGHTEEN FULL STOP': 9369,
'NUMBER ELEVEN FULL STOP': 9362,
'NUMBER FIFTEEN FULL STOP': 9366,
'NUMBER FOURTEEN FULL STOP': 9365,
'NUMBER NINETEEN FULL STOP': 9370,
'NUMBER SEVENTEEN FULL STOP': 9368,
'NUMBER SIGN': 35,
'NUMBER SIXTEEN FULL STOP': 9367,
'NUMBER TEN FULL STOP': 9361,
'NUMBER THIRTEEN FULL STOP': 9364,
'NUMBER TWELVE FULL STOP': 9363,
'NUMBER TWENTY FULL STOP': 9371,
'NUMERO SIGN': 8470,
'OBJECT REPLACEMENT CHARACTER': 65532,
'OBLIQUE ANGLE OPENING DOWN': 10663,
'OBLIQUE ANGLE OPENING UP': 10662,
'OCR AMOUNT OF CHECK': 9287,
'OCR BELT BUCKLE': 9284,
'OCR BOW TIE': 9285,
'OCR BRANCH BANK IDENTIFICATION': 9286,
'OCR CHAIR': 9281,
'OCR CUSTOMER ACCOUNT NUMBER': 9289,
'OCR DASH': 9288,
'OCR DOUBLE BACKSLASH': 9290,
'OCR FORK': 9282,
'OCR HOOK': 9280,
'OCR INVERTED FORK': 9283,
'OGHAM FEATHER MARK': 5787,
'OGHAM LETTER AILM': 5776,
'OGHAM LETTER BEITH': 5761,
'OGHAM LETTER CEIRT': 5770,
'OGHAM LETTER COLL': 5769,
'OGHAM LETTER DAIR': 5767,
'OGHAM LETTER EABHADH': 5781,
'OGHAM LETTER EADHADH': 5779,
'OGHAM LETTER EAMHANCHOLL': 5785,
'OGHAM LETTER FEARN': 5763,
'OGHAM LETTER GORT': 5772,
'OGHAM LETTER IFIN': 5784,
'OGHAM LETTER IODHADH': 5780,
'OGHAM LETTER LUIS': 5762,
'OGHAM LETTER MUIN': 5771,
'OGHAM LETTER NGEADAL': 5773,
'OGHAM LETTER NION': 5765,
'OGHAM LETTER ONN': 5777,
'OGHAM LETTER OR': 5782,
'OGHAM LETTER PEITH': 5786,
'OGHAM LETTER RUIS': 5775,
'OGHAM LETTER SAIL': 5764,
'OGHAM LETTER STRAIF': 5774,
'OGHAM LETTER TINNE': 5768,
'OGHAM LETTER UATH': 5766,
'OGHAM LETTER UILLEANN': 5783,
'OGHAM LETTER UR': 5778,
'OGHAM REVERSED FEATHER MARK': 5788,
'OGHAM SPACE MARK': 5760,
'OGONEK': 731,
'OHM SIGN': 8486,
'OL CHIKI AHAD': 7293,
'OL CHIKI DIGIT EIGHT': 7256,
'OL CHIKI DIGIT FIVE': 7253,
'OL CHIKI DIGIT FOUR': 7252,
'OL CHIKI DIGIT NINE': 7257,
'OL CHIKI DIGIT ONE': 7249,
'OL CHIKI DIGIT SEVEN': 7255,
'OL CHIKI DIGIT SIX': 7254,
'OL CHIKI DIGIT THREE': 7251,
'OL CHIKI DIGIT TWO': 7250,
'OL CHIKI DIGIT ZERO': 7248,
'OL CHIKI GAAHLAA TTUDDAAG': 7289,
'OL CHIKI LETTER AAJ': 7265,
'OL CHIKI LETTER AAK': 7264,
'OL CHIKI LETTER AAM': 7266,
'OL CHIKI LETTER AAW': 7267,
'OL CHIKI LETTER AG': 7260,
'OL CHIKI LETTER AL': 7262,
'OL CHIKI LETTER ANG': 7261,
'OL CHIKI LETTER AT': 7259,
'OL CHIKI LETTER EDD': 7280,
'OL CHIKI LETTER EN': 7281,
'OL CHIKI LETTER EP': 7279,
'OL CHIKI LETTER ERR': 7282,
'OL CHIKI LETTER IH': 7270,
'OL CHIKI LETTER INY': 7271,
'OL CHIKI LETTER IR': 7272,
'OL CHIKI LETTER IS': 7269,
'OL CHIKI LETTER LA': 7258,
'OL CHIKI LETTER LAA': 7263,
'OL CHIKI LETTER LE': 7278,
'OL CHIKI LETTER LI': 7268,
'OL CHIKI LETTER LO': 7283,
'OL CHIKI LETTER LU': 7273,
'OL CHIKI LETTER OB': 7285,
'OL CHIKI LETTER OH': 7287,
'OL CHIKI LETTER OTT': 7284,
'OL CHIKI LETTER OV': 7286,
'OL CHIKI LETTER UC': 7274,
'OL CHIKI LETTER UD': 7275,
'OL CHIKI LETTER UNN': 7276,
'OL CHIKI LETTER UY': 7277,
'OL CHIKI MU TTUDDAG': 7288,
'OL CHIKI MU-GAAHLAA TTUDDAAG': 7290,
'OL CHIKI PHAARKAA': 7292,
'OL CHIKI PUNCTUATION DOUBLE MUCAAD': 7295,
'OL CHIKI PUNCTUATION MUCAAD': 7294,
'OL CHIKI RELAA': 7291,
'OLD ITALIC LETTER A': 66304,
'OLD ITALIC LETTER BE': 66305,
'OLD ITALIC LETTER CHE': 66332,
'OLD ITALIC LETTER DE': 66307,
'OLD ITALIC LETTER E': 66308,
'OLD ITALIC LETTER EF': 66330,
'OLD ITALIC LETTER EKS': 66327,
'OLD ITALIC LETTER EL': 66315,
'OLD ITALIC LETTER EM': 66316,
'OLD ITALIC LETTER EN': 66317,
'OLD ITALIC LETTER ER': 66323,
'OLD ITALIC LETTER ERS': 66331,
'OLD ITALIC LETTER ES': 66324,
'OLD ITALIC LETTER ESH': 66318,
'OLD ITALIC LETTER HE': 66311,
'OLD ITALIC LETTER I': 66313,
'OLD ITALIC LETTER II': 66333,
'OLD ITALIC LETTER KA': 66314,
'OLD ITALIC LETTER KE': 66306,
'OLD ITALIC LETTER KHE': 66329,
'OLD ITALIC LETTER KU': 66322,
'OLD ITALIC LETTER O': 66319,
'OLD ITALIC LETTER PE': 66320,
'OLD ITALIC LETTER PHE': 66328,
'OLD ITALIC LETTER SHE': 66321,
'OLD ITALIC LETTER TE': 66325,
'OLD ITALIC LETTER THE': 66312,
'OLD ITALIC LETTER U': 66326,
'OLD ITALIC LETTER UU': 66334,
'OLD ITALIC LETTER VE': 66309,
'OLD ITALIC LETTER ZE': 66310,
'OLD ITALIC NUMERAL FIFTY': 66339,
'OLD ITALIC NUMERAL FIVE': 66337,
'OLD ITALIC NUMERAL ONE': 66336,
'OLD ITALIC NUMERAL TEN': 66338,
'OLD PERSIAN NUMBER HUNDRED': 66517,
'OLD PERSIAN NUMBER ONE': 66513,
'OLD PERSIAN NUMBER TEN': 66515,
'OLD PERSIAN NUMBER TWENTY': 66516,
'OLD PERSIAN NUMBER TWO': 66514,
'OLD PERSIAN SIGN A': 66464,
'OLD PERSIAN SIGN AURAMAZDAA': 66504,
'OLD PERSIAN SIGN AURAMAZDAA-2': 66505,
'OLD PERSIAN SIGN AURAMAZDAAHA': 66506,
'OLD PERSIAN SIGN BA': 66482,
'OLD PERSIAN SIGN BAGA': 66510,
'OLD PERSIAN SIGN BUUMISH': 66511,
'OLD PERSIAN SIGN CA': 66472,
'OLD PERSIAN SIGN DA': 66477,
'OLD PERSIAN SIGN DAHYAAUSH': 66508,
'OLD PERSIAN SIGN DAHYAAUSH-2': 66509,
'OLD PERSIAN SIGN DI': 66478,
'OLD PERSIAN SIGN DU': 66479,
'OLD PERSIAN SIGN FA': 66483,
'OLD PERSIAN SIGN GA': 66469,
'OLD PERSIAN SIGN GU': 66470,
'OLD PERSIAN SIGN HA': 66499,
'OLD PERSIAN SIGN I': 66465,
'OLD PERSIAN SIGN JA': 66473,
'OLD PERSIAN SIGN JI': 66474,
'OLD PERSIAN SIGN KA': 66467,
'OLD PERSIAN SIGN KU': 66468,
'OLD PERSIAN SIGN LA': 66494,
'OLD PERSIAN SIGN MA': 66486,
'OLD PERSIAN SIGN MI': 66487,
'OLD PERSIAN SIGN MU': 66488,
'OLD PERSIAN SIGN NA': 66484,
'OLD PERSIAN SIGN NU': 66485,
'OLD PERSIAN SIGN PA': 66481,
'OLD PERSIAN SIGN RA': 66492,
'OLD PERSIAN SIGN RU': 66493,
'OLD PERSIAN SIGN SA': 66495,
'OLD PERSIAN SIGN SHA': 66497,
'OLD PERSIAN SIGN SSA': 66498,
'OLD PERSIAN SIGN TA': 66475,
'OLD PERSIAN SIGN THA': 66480,
'OLD PERSIAN SIGN TU': 66476,
'OLD PERSIAN SIGN U': 66466,
'OLD PERSIAN SIGN VA': 66490,
'OLD PERSIAN SIGN VI': 66491,
'OLD PERSIAN SIGN XA': 66471,
'OLD PERSIAN SIGN XSHAAYATHIYA': 66507,
'OLD PERSIAN SIGN YA': 66489,
'OLD PERSIAN SIGN ZA': 66496,
'OLD PERSIAN WORD DIVIDER': 66512,
'OLD SOUTH ARABIAN LETTER ALEF': 68209,
'OLD SOUTH ARABIAN LETTER AYN': 68210,
'OLD SOUTH ARABIAN LETTER BETH': 68200,
'OLD SOUTH ARABIAN LETTER DALETH': 68213,
'OLD SOUTH ARABIAN LETTER DHADHE': 68211,
'OLD SOUTH ARABIAN LETTER DHALETH': 68217,
'OLD SOUTH ARABIAN LETTER FE': 68208,
'OLD SOUTH ARABIAN LETTER GHAYN': 68214,
'OLD SOUTH ARABIAN LETTER GIMEL': 68212,
'OLD SOUTH ARABIAN LETTER HE': 68192,
'OLD SOUTH ARABIAN LETTER HETH': 68194,
'OLD SOUTH ARABIAN LETTER KAPH': 68203,
'OLD SOUTH ARABIAN LETTER KHETH': 68205,
'OLD SOUTH ARABIAN LETTER LAMEDH': 68193,
'OLD SOUTH ARABIAN LETTER MEM': 68195,
'OLD SOUTH ARABIAN LETTER NUN': 68204,
'OLD SOUTH ARABIAN LETTER QOPH': 68196,
'OLD SOUTH ARABIAN LETTER RESH': 68199,
'OLD SOUTH ARABIAN LETTER SADHE': 68206,
'OLD SOUTH ARABIAN LETTER SAMEKH': 68207,
'OLD SOUTH ARABIAN LETTER SAT': 68202,
'OLD SOUTH ARABIAN LETTER SHIN': 68198,
'OLD SOUTH ARABIAN LETTER TAW': 68201,
'OLD SOUTH ARABIAN LETTER TETH': 68215,
'OLD SOUTH ARABIAN LETTER THAW': 68219,
'OLD SOUTH ARABIAN LETTER THETH': 68220,
'OLD SOUTH ARABIAN LETTER WAW': 68197,
'OLD SOUTH ARABIAN LETTER YODH': 68218,
'OLD SOUTH ARABIAN LETTER ZAYN': 68216,
'OLD SOUTH ARABIAN NUMBER FIFTY': 68222,
'OLD SOUTH ARABIAN NUMBER ONE': 68221,
'OLD SOUTH ARABIAN NUMERIC INDICATOR': 68223,
'OLD TURKIC LETTER ORKHON A': 68608,
'OLD TURKIC LETTER ORKHON AB': 68617,
'OLD TURKIC LETTER ORKHON AD': 68625,
'OLD TURKIC LETTER ORKHON AEB': 68619,
'OLD TURKIC LETTER ORKHON AED': 68627,
'OLD TURKIC LETTER ORKHON AEG': 68623,
'OLD TURKIC LETTER ORKHON AEK': 68634,
'OLD TURKIC LETTER ORKHON AEL': 68640,
'OLD TURKIC LETTER ORKHON AEN': 68644,
'OLD TURKIC LETTER ORKHON AER': 68668,
'OLD TURKIC LETTER ORKHON AES': 68670,
'OLD TURKIC LETTER ORKHON AET': 68677,
'OLD TURKIC LETTER ORKHON AEY': 68632,
'OLD TURKIC LETTER ORKHON AG': 68621,
'OLD TURKIC LETTER ORKHON AL': 68638,
'OLD TURKIC LETTER ORKHON AN': 68643,
'OLD TURKIC LETTER ORKHON AQ': 68660,
'OLD TURKIC LETTER ORKHON AR': 68666,
'OLD TURKIC LETTER ORKHON AS': 68669,
'OLD TURKIC LETTER ORKHON ASH': 68671,
'OLD TURKIC LETTER ORKHON AT': 68675,
'OLD TURKIC LETTER ORKHON AY': 68630,
'OLD TURKIC LETTER ORKHON BASH': 68680,
'OLD TURKIC LETTER ORKHON EC': 68658,
'OLD TURKIC LETTER ORKHON ELT': 68641,
'OLD TURKIC LETTER ORKHON EM': 68642,
'OLD TURKIC LETTER ORKHON ENC': 68648,
'OLD TURKIC LETTER ORKHON ENG': 68653,
'OLD TURKIC LETTER ORKHON ENT': 68646,
'OLD TURKIC LETTER ORKHON ENY': 68650,
'OLD TURKIC LETTER ORKHON EP': 68655,
'OLD TURKIC LETTER ORKHON ESH': 68673,
'OLD TURKIC LETTER ORKHON EZ': 68628,
'OLD TURKIC LETTER ORKHON I': 68611,
'OLD TURKIC LETTER ORKHON IC': 68657,
'OLD TURKIC LETTER ORKHON IQ': 68662,
'OLD TURKIC LETTER ORKHON O': 68614,
'OLD TURKIC LETTER ORKHON OE': 68615,
'OLD TURKIC LETTER ORKHON OEK': 68636,
'OLD TURKIC LETTER ORKHON OP': 68656,
'OLD TURKIC LETTER ORKHON OQ': 68664,
'OLD TURKIC LETTER ORKHON OT': 68679,
'OLD TURKIC LETTER YENISEI A': 68609,
'OLD TURKIC LETTER YENISEI AB': 68618,
'OLD TURKIC LETTER YENISEI AD': 68626,
'OLD TURKIC LETTER YENISEI AE': 68610,
'OLD TURKIC LETTER YENISEI AEB': 68620,
'OLD TURKIC LETTER YENISEI AEG': 68624,
'OLD TURKIC LETTER YENISEI AEK': 68635,
'OLD TURKIC LETTER YENISEI AEN': 68645,
'OLD TURKIC LETTER YENISEI AENG': 68654,
'OLD TURKIC LETTER YENISEI AET': 68678,
'OLD TURKIC LETTER YENISEI AEY': 68633,
'OLD TURKIC LETTER YENISEI AG': 68622,
'OLD TURKIC LETTER YENISEI AL': 68639,
'OLD TURKIC LETTER YENISEI ANG': 68652,
'OLD TURKIC LETTER YENISEI AQ': 68661,
'OLD TURKIC LETTER YENISEI AR': 68667,
'OLD TURKIC LETTER YENISEI ASH': 68672,
'OLD TURKIC LETTER YENISEI AT': 68676,
'OLD TURKIC LETTER YENISEI AY': 68631,
'OLD TURKIC LETTER YENISEI E': 68613,
'OLD TURKIC LETTER YENISEI EC': 68659,
'OLD TURKIC LETTER YENISEI ENC': 68649,
'OLD TURKIC LETTER YENISEI ENT': 68647,
'OLD TURKIC LETTER YENISEI ENY': 68651,
'OLD TURKIC LETTER YENISEI ESH': 68674,
'OLD TURKIC LETTER YENISEI EZ': 68629,
'OLD TURKIC LETTER YENISEI I': 68612,
'OLD TURKIC LETTER YENISEI IQ': 68663,
'OLD TURKIC LETTER YENISEI OE': 68616,
'OLD TURKIC LETTER YENISEI OEK': 68637,
'OLD TURKIC LETTER YENISEI OQ': 68665,
'ONE DOT LEADER': 8228,
'ONE DOT OVER TWO DOTS PUNCTUATION': 11819,
'OPEN BOX': 9251,
'OPEN CENTRE ASTERISK': 10034,
'OPEN CENTRE BLACK STAR': 10027,
'OPEN CENTRE CROSS': 10011,
'OPEN CENTRE TEARDROP-SPOKED ASTERISK': 10044,
'OPEN SUBSET': 10179,
'OPEN SUPERSET': 10180,
'OPEN-CIRCUIT-OUTPUT H-TYPE SYMBOL': 9103,
'OPEN-CIRCUIT-OUTPUT L-TYPE SYMBOL': 9104,
'OPEN-OUTLINED RIGHTWARDS ARROW': 10174,
'OPPOSITION': 9741,
'OPTION KEY': 8997,
'OR WITH DOT INSIDE': 10183,
'ORIGINAL OF': 8886,
'ORIYA AI LENGTH MARK': 2902,
'ORIYA AU LENGTH MARK': 2903,
'ORIYA DIGIT EIGHT': 2926,
'ORIYA DIGIT FIVE': 2923,
'ORIYA DIGIT FOUR': 2922,
'ORIYA DIGIT NINE': 2927,
'ORIYA DIGIT ONE': 2919,
'ORIYA DIGIT SEVEN': 2925,
'ORIYA DIGIT SIX': 2924,
'ORIYA DIGIT THREE': 2921,
'ORIYA DIGIT TWO': 2920,
'ORIYA DIGIT ZERO': 2918,
'ORIYA ISSHAR': 2928,
'ORIYA LETTER A': 2821,
'ORIYA LETTER AA': 2822,
'ORIYA LETTER AI': 2832,
'ORIYA LETTER AU': 2836,
'ORIYA LETTER BA': 2860,
'ORIYA LETTER BHA': 2861,
'ORIYA LETTER CA': 2842,
'ORIYA LETTER CHA': 2843,
'ORIYA LETTER DA': 2854,
'ORIYA LETTER DDA': 2849,
'ORIYA LETTER DDHA': 2850,
'ORIYA LETTER DHA': 2855,
'ORIYA LETTER E': 2831,
'ORIYA LETTER GA': 2839,
'ORIYA LETTER GHA': 2840,
'ORIYA LETTER HA': 2873,
'ORIYA LETTER I': 2823,
'ORIYA LETTER II': 2824,
'ORIYA LETTER JA': 2844,
'ORIYA LETTER JHA': 2845,
'ORIYA LETTER KA': 2837,
'ORIYA LETTER KHA': 2838,
'ORIYA LETTER LA': 2866,
'ORIYA LETTER LLA': 2867,
'ORIYA LETTER MA': 2862,
'ORIYA LETTER NA': 2856,
'ORIYA LETTER NGA': 2841,
'ORIYA LETTER NNA': 2851,
'ORIYA LETTER NYA': 2846,
'ORIYA LETTER O': 2835,
'ORIYA LETTER PA': 2858,
'ORIYA LETTER PHA': 2859,
'ORIYA LETTER RA': 2864,
'ORIYA LETTER RHA': 2909,
'ORIYA LETTER RRA': 2908,
'ORIYA LETTER SA': 2872,
'ORIYA LETTER SHA': 2870,
'ORIYA LETTER SSA': 2871,
'ORIYA LETTER TA': 2852,
'ORIYA LETTER THA': 2853,
'ORIYA LETTER TTA': 2847,
'ORIYA LETTER TTHA': 2848,
'ORIYA LETTER U': 2825,
'ORIYA LETTER UU': 2826,
'ORIYA LETTER VA': 2869,
'ORIYA LETTER VOCALIC L': 2828,
'ORIYA LETTER VOCALIC LL': 2913,
'ORIYA LETTER VOCALIC R': 2827,
'ORIYA LETTER VOCALIC RR': 2912,
'ORIYA LETTER WA': 2929,
'ORIYA LETTER YA': 2863,
'ORIYA LETTER YYA': 2911,
'ORIYA SIGN ANUSVARA': 2818,
'ORIYA SIGN AVAGRAHA': 2877,
'ORIYA SIGN CANDRABINDU': 2817,
'ORIYA SIGN NUKTA': 2876,
'ORIYA SIGN VIRAMA': 2893,
'ORIYA SIGN VISARGA': 2819,
'ORIYA VOWEL SIGN AA': 2878,
'ORIYA VOWEL SIGN AI': 2888,
'ORIYA VOWEL SIGN AU': 2892,
'ORIYA VOWEL SIGN E': 2887,
'ORIYA VOWEL SIGN I': 2879,
'ORIYA VOWEL SIGN II': 2880,
'ORIYA VOWEL SIGN O': 2891,
'ORIYA VOWEL SIGN U': 2881,
'ORIYA VOWEL SIGN UU': 2882,
'ORIYA VOWEL SIGN VOCALIC L': 2914,
'ORIYA VOWEL SIGN VOCALIC LL': 2915,
'ORIYA VOWEL SIGN VOCALIC R': 2883,
'ORIYA VOWEL SIGN VOCALIC RR': 2884,
'ORNATE LEFT PARENTHESIS': 64830,
'ORNATE RIGHT PARENTHESIS': 64831,
'ORTHODOX CROSS': 9766,
'OSMANYA DIGIT EIGHT': 66728,
'OSMANYA DIGIT FIVE': 66725,
'OSMANYA DIGIT FOUR': 66724,
'OSMANYA DIGIT NINE': 66729,
'OSMANYA DIGIT ONE': 66721,
'OSMANYA DIGIT SEVEN': 66727,
'OSMANYA DIGIT SIX': 66726,
'OSMANYA DIGIT THREE': 66723,
'OSMANYA DIGIT TWO': 66722,
'OSMANYA DIGIT ZERO': 66720,
'OSMANYA LETTER A': 66710,
'OSMANYA LETTER AA': 66715,
'OSMANYA LETTER ALEF': 66688,
'OSMANYA LETTER BA': 66689,
'OSMANYA LETTER CAYN': 66699,
'OSMANYA LETTER DEEL': 66694,
'OSMANYA LETTER DHA': 66698,
'OSMANYA LETTER E': 66711,
'OSMANYA LETTER EE': 66716,
'OSMANYA LETTER FA': 66701,
'OSMANYA LETTER GA': 66700,
'OSMANYA LETTER HA': 66708,
'OSMANYA LETTER I': 66712,
'OSMANYA LETTER JA': 66691,
'OSMANYA LETTER KAAF': 66703,
'OSMANYA LETTER KHA': 66693,
'OSMANYA LETTER LAAN': 66704,
'OSMANYA LETTER MIIN': 66705,
'OSMANYA LETTER NUUN': 66706,
'OSMANYA LETTER O': 66713,
'OSMANYA LETTER OO': 66717,
'OSMANYA LETTER QAAF': 66702,
'OSMANYA LETTER RA': 66695,
'OSMANYA LETTER SA': 66696,
'OSMANYA LETTER SHIIN': 66697,
'OSMANYA LETTER TA': 66690,
'OSMANYA LETTER U': 66714,
'OSMANYA LETTER WAW': 66707,
'OSMANYA LETTER XA': 66692,
'OSMANYA LETTER YA': 66709,
'OUNCE SIGN': 8485,
'OUTLINED BLACK STAR': 10029,
'OUTLINED GREEK CROSS': 10009,
'OUTLINED LATIN CROSS': 10015,
'OUTLINED WHITE STAR': 9885,
'OVERLINE': 8254,
'PALLAS': 9908,
'PALM BRANCH': 11801,
'PARAGRAPH SEPARATOR': 8233,
'PARAGRAPHOS': 11791,
'PARALLEL TO': 8741,
'PARALLEL WITH HORIZONTAL STROKE': 10994,
'PARALLEL WITH TILDE OPERATOR': 10995,
'PARENTHESIZED DIGIT EIGHT': 9339,
'PARENTHESIZED DIGIT FIVE': 9336,
'PARENTHESIZED DIGIT FOUR': 9335,
'PARENTHESIZED DIGIT NINE': 9340,
'PARENTHESIZED DIGIT ONE': 9332,
'PARENTHESIZED DIGIT SEVEN': 9338,
'PARENTHESIZED DIGIT SIX': 9337,
'PARENTHESIZED DIGIT THREE': 9334,
'PARENTHESIZED DIGIT TWO': 9333,
'PARENTHESIZED HANGUL CHIEUCH': 12809,
'PARENTHESIZED HANGUL CHIEUCH A': 12823,
'PARENTHESIZED HANGUL CIEUC': 12808,
'PARENTHESIZED HANGUL CIEUC A': 12822,
'PARENTHESIZED HANGUL CIEUC U': 12828,
'PARENTHESIZED HANGUL HIEUH': 12813,
'PARENTHESIZED HANGUL HIEUH A': 12827,
'PARENTHESIZED HANGUL IEUNG': 12807,
'PARENTHESIZED HANGUL IEUNG A': 12821,
'PARENTHESIZED HANGUL KHIEUKH': 12810,
'PARENTHESIZED HANGUL KHIEUKH A': 12824,
'PARENTHESIZED HANGUL KIYEOK': 12800,
'PARENTHESIZED HANGUL KIYEOK A': 12814,
'PARENTHESIZED HANGUL MIEUM': 12804,
'PARENTHESIZED HANGUL MIEUM A': 12818,
'PARENTHESIZED HANGUL NIEUN': 12801,
'PARENTHESIZED HANGUL NIEUN A': 12815,
'PARENTHESIZED HANGUL PHIEUPH': 12812,
'PARENTHESIZED HANGUL PHIEUPH A': 12826,
'PARENTHESIZED HANGUL PIEUP': 12805,
'PARENTHESIZED HANGUL PIEUP A': 12819,
'PARENTHESIZED HANGUL RIEUL': 12803,
'PARENTHESIZED HANGUL RIEUL A': 12817,
'PARENTHESIZED HANGUL SIOS': 12806,
'PARENTHESIZED HANGUL SIOS A': 12820,
'PARENTHESIZED HANGUL THIEUTH': 12811,
'PARENTHESIZED HANGUL THIEUTH A': 12825,
'PARENTHESIZED HANGUL TIKEUT': 12802,
'PARENTHESIZED HANGUL TIKEUT A': 12816,
'PARENTHESIZED IDEOGRAPH ALLIANCE': 12863,
'PARENTHESIZED IDEOGRAPH CALL': 12858,
'PARENTHESIZED IDEOGRAPH CONGRATULATION': 12855,
'PARENTHESIZED IDEOGRAPH EARTH': 12847,
'PARENTHESIZED IDEOGRAPH EIGHT': 12839,
'PARENTHESIZED IDEOGRAPH ENTERPRISE': 12861,
'PARENTHESIZED IDEOGRAPH FESTIVAL': 12864,
'PARENTHESIZED IDEOGRAPH FINANCIAL': 12854,
'PARENTHESIZED IDEOGRAPH FIRE': 12843,
'PARENTHESIZED IDEOGRAPH FIVE': 12836,
'PARENTHESIZED IDEOGRAPH FOUR': 12835,
'PARENTHESIZED IDEOGRAPH HAVE': 12850,
'PARENTHESIZED IDEOGRAPH LABOR': 12856,
'PARENTHESIZED IDEOGRAPH METAL': 12846,
'PARENTHESIZED IDEOGRAPH MOON': 12842,
'PARENTHESIZED IDEOGRAPH NAME': 12852,
'PARENTHESIZED IDEOGRAPH NINE': 12840,
'PARENTHESIZED IDEOGRAPH ONE': 12832,
'PARENTHESIZED IDEOGRAPH REACH': 12867,
'PARENTHESIZED IDEOGRAPH REPRESENT': 12857,
'PARENTHESIZED IDEOGRAPH RESOURCE': 12862,
'PARENTHESIZED IDEOGRAPH REST': 12865,
'PARENTHESIZED IDEOGRAPH SELF': 12866,
'PARENTHESIZED IDEOGRAPH SEVEN': 12838,
'PARENTHESIZED IDEOGRAPH SIX': 12837,
'PARENTHESIZED IDEOGRAPH SOCIETY': 12851,
'PARENTHESIZED IDEOGRAPH SPECIAL': 12853,
'PARENTHESIZED IDEOGRAPH STOCK': 12849,
'PARENTHESIZED IDEOGRAPH STUDY': 12859,
'PARENTHESIZED IDEOGRAPH SUN': 12848,
'PARENTHESIZED IDEOGRAPH SUPERVISE': 12860,
'PARENTHESIZED IDEOGRAPH TEN': 12841,
'PARENTHESIZED IDEOGRAPH THREE': 12834,
'PARENTHESIZED IDEOGRAPH TWO': 12833,
'PARENTHESIZED IDEOGRAPH WATER': 12844,
'PARENTHESIZED IDEOGRAPH WOOD': 12845,
'PARENTHESIZED KOREAN CHARACTER O HU': 12830,
'PARENTHESIZED KOREAN CHARACTER OJEON': 12829,
'PARENTHESIZED LATIN CAPITAL LETTER A': 127248,
'PARENTHESIZED LATIN CAPITAL LETTER B': 127249,
'PARENTHESIZED LATIN CAPITAL LETTER C': 127250,
'PARENTHESIZED LATIN CAPITAL LETTER D': 127251,
'PARENTHESIZED LATIN CAPITAL LETTER E': 127252,
'PARENTHESIZED LATIN CAPITAL LETTER F': 127253,
'PARENTHESIZED LATIN CAPITAL LETTER G': 127254,
'PARENTHESIZED LATIN CAPITAL LETTER H': 127255,
'PARENTHESIZED LATIN CAPITAL LETTER I': 127256,
'PARENTHESIZED LATIN CAPITAL LETTER J': 127257,
'PARENTHESIZED LATIN CAPITAL LETTER K': 127258,
'PARENTHESIZED LATIN CAPITAL LETTER L': 127259,
'PARENTHESIZED LATIN CAPITAL LETTER M': 127260,
'PARENTHESIZED LATIN CAPITAL LETTER N': 127261,
'PARENTHESIZED LATIN CAPITAL LETTER O': 127262,
'PARENTHESIZED LATIN CAPITAL LETTER P': 127263,
'PARENTHESIZED LATIN CAPITAL LETTER Q': 127264,
'PARENTHESIZED LATIN CAPITAL LETTER R': 127265,
'PARENTHESIZED LATIN CAPITAL LETTER S': 127266,
'PARENTHESIZED LATIN CAPITAL LETTER T': 127267,
'PARENTHESIZED LATIN CAPITAL LETTER U': 127268,
'PARENTHESIZED LATIN CAPITAL LETTER V': 127269,
'PARENTHESIZED LATIN CAPITAL LETTER W': 127270,
'PARENTHESIZED LATIN CAPITAL LETTER X': 127271,
'PARENTHESIZED LATIN CAPITAL LETTER Y': 127272,
'PARENTHESIZED LATIN CAPITAL LETTER Z': 127273,
'PARENTHESIZED LATIN SMALL LETTER A': 9372,
'PARENTHESIZED LATIN SMALL LETTER B': 9373,
'PARENTHESIZED LATIN SMALL LETTER C': 9374,
'PARENTHESIZED LATIN SMALL LETTER D': 9375,
'PARENTHESIZED LATIN SMALL LETTER E': 9376,
'PARENTHESIZED LATIN SMALL LETTER F': 9377,
'PARENTHESIZED LATIN SMALL LETTER G': 9378,
'PARENTHESIZED LATIN SMALL LETTER H': 9379,
'PARENTHESIZED LATIN SMALL LETTER I': 9380,
'PARENTHESIZED LATIN SMALL LETTER J': 9381,
'PARENTHESIZED LATIN SMALL LETTER K': 9382,
'PARENTHESIZED LATIN SMALL LETTER L': 9383,
'PARENTHESIZED LATIN SMALL LETTER M': 9384,
'PARENTHESIZED LATIN SMALL LETTER N': 9385,
'PARENTHESIZED LATIN SMALL LETTER O': 9386,
'PARENTHESIZED LATIN SMALL LETTER P': 9387,
'PARENTHESIZED LATIN SMALL LETTER Q': 9388,
'PARENTHESIZED LATIN SMALL LETTER R': 9389,
'PARENTHESIZED LATIN SMALL LETTER S': 9390,
'PARENTHESIZED LATIN SMALL LETTER T': 9391,
'PARENTHESIZED LATIN SMALL LETTER U': 9392,
'PARENTHESIZED LATIN SMALL LETTER V': 9393,
'PARENTHESIZED LATIN SMALL LETTER W': 9394,
'PARENTHESIZED LATIN SMALL LETTER X': 9395,
'PARENTHESIZED LATIN SMALL LETTER Y': 9396,
'PARENTHESIZED LATIN SMALL LETTER Z': 9397,
'PARENTHESIZED NUMBER EIGHTEEN': 9349,
'PARENTHESIZED NUMBER ELEVEN': 9342,
'PARENTHESIZED NUMBER FIFTEEN': 9346,
'PARENTHESIZED NUMBER FOURTEEN': 9345,
'PARENTHESIZED NUMBER NINETEEN': 9350,
'PARENTHESIZED NUMBER SEVENTEEN': 9348,
'PARENTHESIZED NUMBER SIXTEEN': 9347,
'PARENTHESIZED NUMBER TEN': 9341,
'PARENTHESIZED NUMBER THIRTEEN': 9344,
'PARENTHESIZED NUMBER TWELVE': 9343,
'PARENTHESIZED NUMBER TWENTY': 9351,
'PART ALTERNATION MARK': 12349,
'PARTIAL DIFFERENTIAL': 8706,
'PARTIALLY-RECYCLED PAPER SYMBOL': 9853,
'PARTNERSHIP SIGN': 12880,
'PASSIVE-PULL-DOWN-OUTPUT SYMBOL': 9105,
'PASSIVE-PULL-UP-OUTPUT SYMBOL': 9106,
'PEACE SYMBOL': 9774,
'PENCIL': 9999,
'PER MILLE SIGN': 8240,
'PER SIGN': 8524,
'PER TEN THOUSAND SIGN': 8241,
'PERCENT SIGN': 37,
'PERMANENT PAPER SIGN': 9854,
'PERPENDICULAR': 10178,
'PERPENDICULAR WITH S': 10977,
'PERSON WITH BALL': 9977,
'PERSPECTIVE': 8966,
'PESETA SIGN': 8359,
'PESO SIGN': 8369,
'PHAGS-PA DOUBLE HEAD MARK': 43125,
'PHAGS-PA LETTER A': 43101,
'PHAGS-PA LETTER ALTERNATE YA': 43117,
'PHAGS-PA LETTER ASPIRATED FA': 43120,
'PHAGS-PA LETTER BA': 43086,
'PHAGS-PA LETTER CA': 43076,
'PHAGS-PA LETTER CANDRABINDU': 43123,
'PHAGS-PA LETTER CHA': 43077,
'PHAGS-PA LETTER DA': 43082,
'PHAGS-PA LETTER DDA': 43115,
'PHAGS-PA LETTER DZA': 43090,
'PHAGS-PA LETTER E': 43104,
'PHAGS-PA LETTER EE': 43110,
'PHAGS-PA LETTER FA': 43108,
'PHAGS-PA LETTER GA': 43074,
'PHAGS-PA LETTER GGA': 43109,
'PHAGS-PA LETTER HA': 43100,
'PHAGS-PA LETTER I': 43102,
'PHAGS-PA LETTER JA': 43078,
'PHAGS-PA LETTER KA': 43072,
'PHAGS-PA LETTER KHA': 43073,
'PHAGS-PA LETTER LA': 43097,
'PHAGS-PA LETTER MA': 43087,
'PHAGS-PA LETTER NA': 43083,
'PHAGS-PA LETTER NGA': 43075,
'PHAGS-PA LETTER NNA': 43116,
'PHAGS-PA LETTER NYA': 43079,
'PHAGS-PA LETTER O': 43105,
'PHAGS-PA LETTER PA': 43084,
'PHAGS-PA LETTER PHA': 43085,
'PHAGS-PA LETTER QA': 43106,
'PHAGS-PA LETTER RA': 43096,
'PHAGS-PA LETTER SA': 43099,
'PHAGS-PA LETTER SHA': 43098,
'PHAGS-PA LETTER SMALL A': 43094,
'PHAGS-PA LETTER TA': 43080,
'PHAGS-PA LETTER THA': 43081,
'PHAGS-PA LETTER TSA': 43088,
'PHAGS-PA LETTER TSHA': 43089,
'PHAGS-PA LETTER TTA': 43113,
'PHAGS-PA LETTER TTHA': 43114,
'PHAGS-PA LETTER U': 43103,
'PHAGS-PA LETTER VOICED HA': 43119,
'PHAGS-PA LETTER VOICELESS SHA': 43118,
'PHAGS-PA LETTER WA': 43091,
'PHAGS-PA LETTER XA': 43107,
'PHAGS-PA LETTER YA': 43095,
'PHAGS-PA LETTER ZA': 43093,
'PHAGS-PA LETTER ZHA': 43092,
'PHAGS-PA MARK DOUBLE SHAD': 43127,
'PHAGS-PA MARK SHAD': 43126,
'PHAGS-PA SINGLE HEAD MARK': 43124,
'PHAGS-PA SUBJOINED LETTER RA': 43121,
'PHAGS-PA SUBJOINED LETTER WA': 43111,
'PHAGS-PA SUBJOINED LETTER YA': 43112,
'PHAGS-PA SUPERFIXED LETTER RA': 43122,
'PHAISTOS DISC SIGN ARROW': 66009,
'PHAISTOS DISC SIGN BEE': 66033,
'PHAISTOS DISC SIGN BEEHIVE': 66023,
'PHAISTOS DISC SIGN BOOMERANG': 66017,
'PHAISTOS DISC SIGN BOW': 66010,
'PHAISTOS DISC SIGN BULLS LEG': 66027,
'PHAISTOS DISC SIGN CAPTIVE': 66003,
'PHAISTOS DISC SIGN CARPENTRY PLANE': 66018,
'PHAISTOS DISC SIGN CAT': 66028,
'PHAISTOS DISC SIGN CHILD': 66004,
'PHAISTOS DISC SIGN CLUB': 66012,
'PHAISTOS DISC SIGN COLUMN': 66022,
'PHAISTOS DISC SIGN COMB': 66020,
'PHAISTOS DISC SIGN COMBINING OBLIQUE STROKE': 66045,
'PHAISTOS DISC SIGN DOLIUM': 66019,
'PHAISTOS DISC SIGN DOVE': 66031,
'PHAISTOS DISC SIGN EAGLE': 66030,
'PHAISTOS DISC SIGN FLUTE': 66040,
'PHAISTOS DISC SIGN GAUNTLET': 66007,
'PHAISTOS DISC SIGN GRATER': 66041,
'PHAISTOS DISC SIGN HELMET': 66006,
'PHAISTOS DISC SIGN HIDE': 66026,
'PHAISTOS DISC SIGN HORN': 66025,
'PHAISTOS DISC SIGN LID': 66016,
'PHAISTOS DISC SIGN LILY': 66038,
'PHAISTOS DISC SIGN MANACLES': 66013,
'PHAISTOS DISC SIGN MATTOCK': 66014,
'PHAISTOS DISC SIGN OX BACK': 66039,
'PHAISTOS DISC SIGN PAPYRUS': 66036,
'PHAISTOS DISC SIGN PEDESTRIAN': 66000,
'PHAISTOS DISC SIGN PLANE TREE': 66034,
'PHAISTOS DISC SIGN PLUMED HEAD': 66001,
'PHAISTOS DISC SIGN RAM': 66029,
'PHAISTOS DISC SIGN ROSETTE': 66037,
'PHAISTOS DISC SIGN SAW': 66015,
'PHAISTOS DISC SIGN SHIELD': 66011,
'PHAISTOS DISC SIGN SHIP': 66024,
'PHAISTOS DISC SIGN SLING': 66021,
'PHAISTOS DISC SIGN SMALL AXE': 66043,
'PHAISTOS DISC SIGN STRAINER': 66042,
'PHAISTOS DISC SIGN TATTOOED HEAD': 66002,
'PHAISTOS DISC SIGN TIARA': 66008,
'PHAISTOS DISC SIGN TUNNY': 66032,
'PHAISTOS DISC SIGN VINE': 66035,
'PHAISTOS DISC SIGN WAVY BAND': 66044,
'PHAISTOS DISC SIGN WOMAN': 66005,
'PHILIPPINE DOUBLE PUNCTUATION': 5942,
'PHILIPPINE SINGLE PUNCTUATION': 5941,
'PHOENICIAN LETTER AIN': 67855,
'PHOENICIAN LETTER ALF': 67840,
'PHOENICIAN LETTER BET': 67841,
'PHOENICIAN LETTER DELT': 67843,
'PHOENICIAN LETTER GAML': 67842,
'PHOENICIAN LETTER HE': 67844,
'PHOENICIAN LETTER HET': 67847,
'PHOENICIAN LETTER KAF': 67850,
'PHOENICIAN LETTER LAMD': 67851,
'PHOENICIAN LETTER MEM': 67852,
'PHOENICIAN LETTER NUN': 67853,
'PHOENICIAN LETTER PE': 67856,
'PHOENICIAN LETTER QOF': 67858,
'PHOENICIAN LETTER ROSH': 67859,
'PHOENICIAN LETTER SADE': 67857,
'PHOENICIAN LETTER SEMK': 67854,
'PHOENICIAN LETTER SHIN': 67860,
'PHOENICIAN LETTER TAU': 67861,
'PHOENICIAN LETTER TET': 67848,
'PHOENICIAN LETTER WAU': 67845,
'PHOENICIAN LETTER YOD': 67849,
'PHOENICIAN LETTER ZAI': 67846,
'PHOENICIAN NUMBER ONE': 67862,
'PHOENICIAN NUMBER ONE HUNDRED': 67865,
'PHOENICIAN NUMBER TEN': 67863,
'PHOENICIAN NUMBER THREE': 67867,
'PHOENICIAN NUMBER TWENTY': 67864,
'PHOENICIAN NUMBER TWO': 67866,
'PHOENICIAN WORD SEPARATOR': 67871,
'PICK': 9935,
'PILCROW SIGN': 182,
'PINWHEEL STAR': 10031,
'PISCES': 9811,
'PITCHFORK': 8916,
'PITCHFORK WITH TEE TOP': 10970,
'PLACE OF INTEREST SIGN': 8984,
'PLANCK CONSTANT': 8462,
'PLANCK CONSTANT OVER TWO PI': 8463,
'PLUS SIGN': 43,
'PLUS SIGN ABOVE EQUALS SIGN': 10866,
'PLUS SIGN IN LEFT HALF CIRCLE': 10797,
'PLUS SIGN IN RIGHT HALF CIRCLE': 10798,
'PLUS SIGN IN TRIANGLE': 10809,
'PLUS SIGN WITH BLACK TRIANGLE': 10792,
'PLUS SIGN WITH CIRCUMFLEX ACCENT ABOVE': 10787,
'PLUS SIGN WITH DOT BELOW': 10789,
'PLUS SIGN WITH SMALL CIRCLE ABOVE': 10786,
'PLUS SIGN WITH SUBSCRIPT TWO': 10791,
'PLUS SIGN WITH TILDE ABOVE': 10788,
'PLUS SIGN WITH TILDE BELOW': 10790,
'PLUS-MINUS SIGN': 177,
'PLUTO': 9799,
'POP DIRECTIONAL FORMATTING': 8236,
'POSITION INDICATOR': 8982,
'POSTAL MARK': 12306,
'POSTAL MARK FACE': 12320,
'POUND SIGN': 163,
'PRECEDES': 8826,
'PRECEDES ABOVE ALMOST EQUAL TO': 10935,
'PRECEDES ABOVE EQUALS SIGN': 10931,
'PRECEDES ABOVE NOT ALMOST EQUAL TO': 10937,
'PRECEDES ABOVE NOT EQUAL TO': 10933,
'PRECEDES ABOVE SINGLE-LINE EQUALS SIGN': 10927,
'PRECEDES ABOVE SINGLE-LINE NOT EQUAL TO': 10929,
'PRECEDES BUT NOT EQUIVALENT TO': 8936,
'PRECEDES OR EQUAL TO': 8828,
'PRECEDES OR EQUIVALENT TO': 8830,
'PRECEDES UNDER RELATION': 8880,
'PRESCRIPTION TAKE': 8478,
'PRESENTATION FORM FOR VERTICAL COLON': 65043,
'PRESENTATION FORM FOR VERTICAL COMMA': 65040,
'PRESENTATION FORM FOR VERTICAL EM DASH': 65073,
'PRESENTATION FORM FOR VERTICAL EN DASH': 65074,
'PRESENTATION FORM FOR VERTICAL EXCLAMATION MARK': 65045,
'PRESENTATION FORM FOR VERTICAL HORIZONTAL ELLIPSIS': 65049,
'PRESENTATION FORM FOR VERTICAL IDEOGRAPHIC COMMA': 65041,
'PRESENTATION FORM FOR VERTICAL IDEOGRAPHIC FULL STOP': 65042,
'PRESENTATION FORM FOR VERTICAL LEFT ANGLE BRACKET': 65087,
'PRESENTATION FORM FOR VERTICAL LEFT BLACK LENTICULAR BRACKET': 65083,
'PRESENTATION FORM FOR VERTICAL LEFT CORNER BRACKET': 65089,
'PRESENTATION FORM FOR VERTICAL LEFT CURLY BRACKET': 65079,
'PRESENTATION FORM FOR VERTICAL LEFT DOUBLE ANGLE BRACKET': 65085,
'PRESENTATION FORM FOR VERTICAL LEFT PARENTHESIS': 65077,
'PRESENTATION FORM FOR VERTICAL LEFT SQUARE BRACKET': 65095,
'PRESENTATION FORM FOR VERTICAL LEFT TORTOISE SHELL BRACKET': 65081,
'PRESENTATION FORM FOR VERTICAL LEFT WHITE CORNER BRACKET': 65091,
'PRESENTATION FORM FOR VERTICAL LEFT WHITE LENTICULAR BRACKET': 65047,
'PRESENTATION FORM FOR VERTICAL LOW LINE': 65075,
'PRESENTATION FORM FOR VERTICAL QUESTION MARK': 65046,
'PRESENTATION FORM FOR VERTICAL RIGHT ANGLE BRACKET': 65088,
'PRESENTATION FORM FOR VERTICAL RIGHT BLACK LENTICULAR BRACKET': 65084,
'PRESENTATION FORM FOR VERTICAL RIGHT CORNER BRACKET': 65090,
'PRESENTATION FORM FOR VERTICAL RIGHT CURLY BRACKET': 65080,
'PRESENTATION FORM FOR VERTICAL RIGHT DOUBLE ANGLE BRACKET': 65086,
'PRESENTATION FORM FOR VERTICAL RIGHT PARENTHESIS': 65078,
'PRESENTATION FORM FOR VERTICAL RIGHT SQUARE BRACKET': 65096,
'PRESENTATION FORM FOR VERTICAL RIGHT TORTOISE SHELL BRACKET': 65082,
'PRESENTATION FORM FOR VERTICAL RIGHT WHITE CORNER BRACKET': 65092,
'PRESENTATION FORM FOR VERTICAL RIGHT WHITE LENTICULAR BRAKCET': 65048,
'PRESENTATION FORM FOR VERTICAL SEMICOLON': 65044,
'PRESENTATION FORM FOR VERTICAL TWO DOT LEADER': 65072,
'PRESENTATION FORM FOR VERTICAL WAVY LOW LINE': 65076,
'PREVIOUS PAGE': 9111,
'PRIME': 8242,
'PRINT SCREEN SYMBOL': 9113,
'PROJECTIVE': 8965,
'PROPERTY LINE': 8522,
'PROPORTION': 8759,
'PROPORTIONAL TO': 8733,
'PUNCTUATION SPACE': 8200,
'QUADRANT LOWER LEFT': 9622,
'QUADRANT LOWER RIGHT': 9623,
'QUADRANT UPPER LEFT': 9624,
'QUADRANT UPPER LEFT AND LOWER LEFT AND LOWER RIGHT': 9625,
'QUADRANT UPPER LEFT AND LOWER RIGHT': 9626,
'QUADRANT UPPER LEFT AND UPPER RIGHT AND LOWER LEFT': 9627,
'QUADRANT UPPER LEFT AND UPPER RIGHT AND LOWER RIGHT': 9628,
'QUADRANT UPPER RIGHT': 9629,
'QUADRANT UPPER RIGHT AND LOWER LEFT': 9630,
'QUADRANT UPPER RIGHT AND LOWER LEFT AND LOWER RIGHT': 9631,
'QUADRUPLE INTEGRAL OPERATOR': 10764,
'QUADRUPLE PRIME': 8279,
'QUARTER NOTE': 9833,
'QUATERNION INTEGRAL OPERATOR': 10774,
'QUESTION EXCLAMATION MARK': 8264,
'QUESTION MARK': 63,
'QUESTIONED EQUAL TO': 8799,
'QUINCUNX': 9915,
'QUOTATION MARK': 34,
'RADICAL SYMBOL BOTTOM': 9143,
'RADIOACTIVE SIGN': 9762,
'RAIN': 9926,
'RAISED DOTTED INTERPOLATION MARKER': 11783,
'RAISED INTERPOLATION MARKER': 11782,
'RAISED SQUARE': 11787,
'RATIO': 8758,
'RECYCLED PAPER SYMBOL': 9852,
'RECYCLING SYMBOL FOR GENERIC MATERIALS': 9850,
'RECYCLING SYMBOL FOR TYPE-1 PLASTICS': 9843,
'RECYCLING SYMBOL FOR TYPE-2 PLASTICS': 9844,
'RECYCLING SYMBOL FOR TYPE-3 PLASTICS': 9845,
'RECYCLING SYMBOL FOR TYPE-4 PLASTICS': 9846,
'RECYCLING SYMBOL FOR TYPE-5 PLASTICS': 9847,
'RECYCLING SYMBOL FOR TYPE-6 PLASTICS': 9848,
'RECYCLING SYMBOL FOR TYPE-7 PLASTICS': 9849,
'REFERENCE MARK': 8251,
'REGISTERED SIGN': 174,
'REJANG CONSONANT SIGN H': 43346,
'REJANG CONSONANT SIGN N': 43344,
'REJANG CONSONANT SIGN NG': 43343,
'REJANG CONSONANT SIGN R': 43345,
'REJANG LETTER A': 43334,
'REJANG LETTER BA': 43319,
'REJANG LETTER CA': 43321,
'REJANG LETTER DA': 43316,
'REJANG LETTER GA': 43313,
'REJANG LETTER HA': 43329,
'REJANG LETTER JA': 43322,
'REJANG LETTER KA': 43312,
'REJANG LETTER LA': 43326,
'REJANG LETTER MA': 43320,
'REJANG LETTER MBA': 43330,
'REJANG LETTER NA': 43317,
'REJANG LETTER NDA': 43332,
'REJANG LETTER NGA': 43314,
'REJANG LETTER NGGA': 43331,
'REJANG LETTER NYA': 43323,
'REJANG LETTER NYJA': 43333,
'REJANG LETTER PA': 43318,
'REJANG LETTER RA': 43325,
'REJANG LETTER SA': 43324,
'REJANG LETTER TA': 43315,
'REJANG LETTER WA': 43328,
'REJANG LETTER YA': 43327,
'REJANG SECTION MARK': 43359,
'REJANG VIRAMA': 43347,
'REJANG VOWEL SIGN AI': 43338,
'REJANG VOWEL SIGN AU': 43340,
'REJANG VOWEL SIGN E': 43337,
'REJANG VOWEL SIGN EA': 43342,
'REJANG VOWEL SIGN EU': 43341,
'REJANG VOWEL SIGN I': 43335,
'REJANG VOWEL SIGN O': 43339,
'REJANG VOWEL SIGN U': 43336,
'REPLACEMENT CHARACTER': 65533,
'RESPONSE': 8479,
'RESTRICTED LEFT ENTRY-1': 9952,
'RESTRICTED LEFT ENTRY-2': 9953,
'RETURN SYMBOL': 9166,
'REVERSE SOLIDUS': 92,
'REVERSE SOLIDUS OPERATOR': 10741,
'REVERSE SOLIDUS PRECEDING SUBSET': 10184,
'REVERSE SOLIDUS WITH HORIZONTAL STROKE': 10743,
'REVERSE TILDE OPERATOR ABOVE LEFTWARDS ARROW': 11073,
'REVERSE TILDE OPERATOR ABOVE RIGHTWARDS ARROW': 11079,
'REVERSED ANGLE': 10659,
'REVERSED ANGLE WITH UNDERBAR': 10661,
'REVERSED DOUBLE PRIME': 8246,
'REVERSED DOUBLE PRIME QUOTATION MARK': 12317,
'REVERSED DOUBLE STROKE NOT SIGN': 10989,
'REVERSED EMPTY SET': 10672,
'REVERSED FORKED PARAGRAPHOS': 11793,
'REVERSED NOT SIGN': 8976,
'REVERSED PILCROW SIGN': 8267,
'REVERSED PRIME': 8245,
'REVERSED QUESTION MARK': 11822,
'REVERSED ROTATED FLORAL HEART BULLET': 9753,
'REVERSED SANS-SERIF CAPITAL L': 8515,
'REVERSED SEMICOLON': 8271,
'REVERSED TILDE': 8765,
'REVERSED TILDE EQUALS': 8909,
'REVERSED TRIPLE PRIME': 8247,
'RIAL SIGN': 65020,
'RIGHT ANGLE': 8735,
'RIGHT ANGLE BRACKET': 12297,
'RIGHT ANGLE BRACKET WITH DOT': 10642,
'RIGHT ANGLE DOTTED SUBSTITUTION MARKER': 11777,
'RIGHT ANGLE SUBSTITUTION MARKER': 11776,
'RIGHT ANGLE VARIANT WITH SQUARE': 10652,
'RIGHT ANGLE WITH ARC': 8894,
'RIGHT ANGLE WITH DOWNWARDS ZIGZAG ARROW': 9084,
'RIGHT ARC GREATER-THAN BRACKET': 10644,
'RIGHT ARROW WITH CIRCLED PLUS': 10228,
'RIGHT ARROW WITH SMALL CIRCLE': 8692,
'RIGHT BLACK LENTICULAR BRACKET': 12305,
'RIGHT BLACK TORTOISE SHELL BRACKET': 10648,
'RIGHT CEILING': 8969,
'RIGHT CORNER BRACKET': 12301,
'RIGHT CURLY BRACKET': 125,
'RIGHT CURLY BRACKET LOWER HOOK': 9133,
'RIGHT CURLY BRACKET MIDDLE PIECE': 9132,
'RIGHT CURLY BRACKET UPPER HOOK': 9131,
'RIGHT DOTTED SUBSTITUTION BRACKET': 11781,
'RIGHT DOUBLE ANGLE BRACKET': 12299,
'RIGHT DOUBLE ARROW WITH ROUNDED HEAD': 10608,
'RIGHT DOUBLE PARENTHESIS': 11817,
'RIGHT DOUBLE QUOTATION MARK': 8221,
'RIGHT DOUBLE WIGGLY FENCE': 10715,
'RIGHT FISH TAIL': 10621,
'RIGHT FLOOR': 8971,
'RIGHT HALF BLACK CIRCLE': 9687,
'RIGHT HALF BLOCK': 9616,
'RIGHT LOW PARAPHRASE BRACKET': 11805,
'RIGHT NORMAL FACTOR SEMIDIRECT PRODUCT': 8906,
'RIGHT ONE EIGHTH BLOCK': 9621,
'RIGHT OUTER JOIN': 10198,
'RIGHT PARENTHESIS': 41,
'RIGHT PARENTHESIS EXTENSION': 9119,
'RIGHT PARENTHESIS LOWER HOOK': 9120,
'RIGHT PARENTHESIS UPPER HOOK': 9118,
'RIGHT RAISED OMISSION BRACKET': 11789,
'RIGHT S-SHAPED BAG DELIMITER': 10182,
'RIGHT SEMIDIRECT PRODUCT': 8908,
'RIGHT SIDEWAYS U BRACKET': 11815,
'RIGHT SINGLE QUOTATION MARK': 8217,
'RIGHT SQUARE BRACKET': 93,
'RIGHT SQUARE BRACKET EXTENSION': 9125,
'RIGHT SQUARE BRACKET LOWER CORNER': 9126,
'RIGHT SQUARE BRACKET UPPER CORNER': 9124,
'RIGHT SQUARE BRACKET WITH QUILL': 8262,
'RIGHT SQUARE BRACKET WITH TICK IN BOTTOM CORNER': 10638,
'RIGHT SQUARE BRACKET WITH TICK IN TOP CORNER': 10640,
'RIGHT SQUARE BRACKET WITH UNDERBAR': 10636,
'RIGHT SUBSTITUTION BRACKET': 11779,
'RIGHT TACK': 8866,
'RIGHT TORTOISE SHELL BRACKET': 12309,
'RIGHT TRANSPOSITION BRACKET': 11786,
'RIGHT TRIANGLE': 8895,
'RIGHT TRIANGLE ABOVE LEFT TRIANGLE': 10702,
'RIGHT VERTICAL BAR WITH QUILL': 11809,
'RIGHT VERTICAL BOX LINE': 9145,
'RIGHT WHITE CORNER BRACKET': 12303,
'RIGHT WHITE CURLY BRACKET': 10628,
'RIGHT WHITE LENTICULAR BRACKET': 12311,
'RIGHT WHITE PARENTHESIS': 10630,
'RIGHT WHITE SQUARE BRACKET': 12315,
'RIGHT WHITE TORTOISE SHELL BRACKET': 12313,
'RIGHT WIGGLY FENCE': 10713,
'RIGHT-FACING SVASTI SIGN': 4053,
'RIGHT-FACING SVASTI SIGN WITH DOTS': 4055,
'RIGHT-POINTING ANGLE BRACKET': 9002,
'RIGHT-POINTING CURVED ANGLE BRACKET': 10749,
'RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK': 187,
'RIGHT-SHADED WHITE RIGHTWARDS ARROW': 10153,
'RIGHT-SIDE ARC CLOCKWISE ARROW': 10552,
'RIGHT-TO-LEFT EMBEDDING': 8235,
'RIGHT-TO-LEFT MARK': 8207,
'RIGHT-TO-LEFT OVERRIDE': 8238,
'RIGHTHAND INTERIOR PRODUCT': 10813,
'RIGHTWARDS ARROW': 8594,
'RIGHTWARDS ARROW ABOVE ALMOST EQUAL TO': 10613,
'RIGHTWARDS ARROW ABOVE REVERSE ALMOST EQUAL TO': 11080,
'RIGHTWARDS ARROW ABOVE REVERSE TILDE OPERATOR': 11084,
'RIGHTWARDS ARROW ABOVE SHORT LEFTWARDS ARROW': 10562,
'RIGHTWARDS ARROW ABOVE TILDE OPERATOR': 10612,
'RIGHTWARDS ARROW FROM BAR': 8614,
'RIGHTWARDS ARROW FROM BAR TO BLACK DIAMOND': 10528,
'RIGHTWARDS ARROW OVER LEFTWARDS ARROW': 8644,
'RIGHTWARDS ARROW THROUGH GREATER-THAN': 11075,
'RIGHTWARDS ARROW THROUGH SUPERSET': 11076,
'RIGHTWARDS ARROW THROUGH X': 10567,
'RIGHTWARDS ARROW TO BAR': 8677,
'RIGHTWARDS ARROW TO BLACK DIAMOND': 10526,
'RIGHTWARDS ARROW WITH CORNER DOWNWARDS': 8628,
'RIGHTWARDS ARROW WITH DOTTED STEM': 10513,
'RIGHTWARDS ARROW WITH DOUBLE VERTICAL STROKE': 8699,
'RIGHTWARDS ARROW WITH HOOK': 8618,
'RIGHTWARDS ARROW WITH LOOP': 8620,
'RIGHTWARDS ARROW WITH PLUS BELOW': 10565,
'RIGHTWARDS ARROW WITH STROKE': 8603,
'RIGHTWARDS ARROW WITH TAIL': 8611,
'RIGHTWARDS ARROW WITH TAIL WITH DOUBLE VERTICAL STROKE': 10517,
'RIGHTWARDS ARROW WITH TAIL WITH VERTICAL STROKE': 10516,
'RIGHTWARDS ARROW WITH TIP DOWNWARDS': 11022,
'RIGHTWARDS ARROW WITH TIP UPWARDS': 11023,
'RIGHTWARDS ARROW WITH VERTICAL STROKE': 8696,
'RIGHTWARDS ARROW-TAIL': 10522,
'RIGHTWARDS DASHED ARROW': 8674,
'RIGHTWARDS DOUBLE ARROW': 8658,
'RIGHTWARDS DOUBLE ARROW FROM BAR': 10503,
'RIGHTWARDS DOUBLE ARROW WITH STROKE': 8655,
'RIGHTWARDS DOUBLE ARROW WITH VERTICAL STROKE': 10499,
'RIGHTWARDS DOUBLE ARROW-TAIL': 10524,
'RIGHTWARDS DOUBLE DASH ARROW': 10509,
'RIGHTWARDS HARPOON OVER LEFTWARDS HARPOON': 8652,
'RIGHTWARDS HARPOON WITH BARB DOWN ABOVE LEFTWARDS HARPOON WITH BARB DOWN': 10601,
'RIGHTWARDS HARPOON WITH BARB DOWN BELOW LONG DASH': 10605,
'RIGHTWARDS HARPOON WITH BARB DOWN FROM BAR': 10591,
'RIGHTWARDS HARPOON WITH BARB DOWN TO BAR': 10583,
'RIGHTWARDS HARPOON WITH BARB DOWNWARDS': 8641,
'RIGHTWARDS HARPOON WITH BARB UP ABOVE LEFTWARDS HARPOON WITH BARB UP': 10600,
'RIGHTWARDS HARPOON WITH BARB UP ABOVE LONG DASH': 10604,
'RIGHTWARDS HARPOON WITH BARB UP ABOVE RIGHTWARDS HARPOON WITH BARB DOWN': 10596,
'RIGHTWARDS HARPOON WITH BARB UP FROM BAR': 10587,
'RIGHTWARDS HARPOON WITH BARB UP TO BAR': 10579,
'RIGHTWARDS HARPOON WITH BARB UPWARDS': 8640,
'RIGHTWARDS OPEN-HEADED ARROW': 8702,
'RIGHTWARDS PAIRED ARROWS': 8649,
'RIGHTWARDS QUADRUPLE ARROW': 11078,
'RIGHTWARDS SQUIGGLE ARROW': 8669,
'RIGHTWARDS TRIPLE ARROW': 8667,
'RIGHTWARDS TRIPLE DASH ARROW': 10511,
'RIGHTWARDS TWO HEADED ARROW': 8608,
'RIGHTWARDS TWO-HEADED ARROW FROM BAR': 10501,
'RIGHTWARDS TWO-HEADED ARROW WITH DOUBLE VERTICAL STROKE': 10497,
'RIGHTWARDS TWO-HEADED ARROW WITH TAIL': 10518,
'RIGHTWARDS TWO-HEADED ARROW WITH TAIL WITH DOUBLE VERTICAL STROKE': 10520,
'RIGHTWARDS TWO-HEADED ARROW WITH TAIL WITH VERTICAL STROKE': 10519,
'RIGHTWARDS TWO-HEADED ARROW WITH VERTICAL STROKE': 10496,
'RIGHTWARDS TWO-HEADED TRIPLE DASH ARROW': 10512,
'RIGHTWARDS WAVE ARROW': 8605,
'RIGHTWARDS WHITE ARROW': 8680,
'RIGHTWARDS WHITE ARROW FROM WALL': 8688,
'RING ABOVE': 730,
'RING EQUAL TO': 8791,
'RING IN EQUAL TO': 8790,
'RING OPERATOR': 8728,
'RING POINT': 11824,
'RISING DIAGONAL CROSSING FALLING DIAGONAL': 10539,
'RISING DIAGONAL CROSSING SOUTH EAST ARROW': 10544,
'ROMAN AS SIGN': 65946,
'ROMAN CENTURIAL SIGN': 65947,
'ROMAN DENARIUS SIGN': 65942,
'ROMAN DIMIDIA SEXTULA SIGN': 65940,
'ROMAN DUPONDIUS SIGN': 65945,
'ROMAN NUMERAL EIGHT': 8551,
'ROMAN NUMERAL ELEVEN': 8554,
'ROMAN NUMERAL FIFTY': 8556,
'ROMAN NUMERAL FIFTY EARLY FORM': 8582,
'ROMAN NUMERAL FIFTY THOUSAND': 8583,
'ROMAN NUMERAL FIVE': 8548,
'ROMAN NUMERAL FIVE HUNDRED': 8558,
'ROMAN NUMERAL FIVE THOUSAND': 8577,
'ROMAN NUMERAL FOUR': 8547,
'ROMAN NUMERAL NINE': 8552,
'ROMAN NUMERAL ONE': 8544,
'ROMAN NUMERAL ONE HUNDRED': 8557,
'ROMAN NUMERAL ONE HUNDRED THOUSAND': 8584,
'ROMAN NUMERAL ONE THOUSAND': 8559,
'ROMAN NUMERAL ONE THOUSAND C D': 8576,
'ROMAN NUMERAL REVERSED ONE HUNDRED': 8579,
'ROMAN NUMERAL SEVEN': 8550,
'ROMAN NUMERAL SIX': 8549,
'ROMAN NUMERAL SIX LATE FORM': 8581,
'ROMAN NUMERAL TEN': 8553,
'ROMAN NUMERAL TEN THOUSAND': 8578,
'ROMAN NUMERAL THREE': 8546,
'ROMAN NUMERAL TWELVE': 8555,
'ROMAN NUMERAL TWO': 8545,
'ROMAN QUINARIUS SIGN': 65943,
'ROMAN SEMUNCIA SIGN': 65938,
'ROMAN SESTERTIUS SIGN': 65944,
'ROMAN SEXTANS SIGN': 65936,
'ROMAN SEXTULA SIGN': 65939,
'ROMAN SILIQUA SIGN': 65941,
'ROMAN UNCIA SIGN': 65937,
'ROTATED CAPITAL Q': 8506,
'ROTATED FLORAL HEART BULLET': 10087,
'ROTATED HEAVY BLACK HEART BULLET': 10085,
'RULE-DELAYED': 10740,
'RUMI DIGIT EIGHT': 69223,
'RUMI DIGIT FIVE': 69220,
'RUMI DIGIT FOUR': 69219,
'RUMI DIGIT NINE': 69224,
'RUMI DIGIT ONE': 69216,
'RUMI DIGIT SEVEN': 69222,
'RUMI DIGIT SIX': 69221,
'RUMI DIGIT THREE': 69218,
'RUMI DIGIT TWO': 69217,
'RUMI FRACTION ONE HALF': 69243,
'RUMI FRACTION ONE QUARTER': 69244,
'RUMI FRACTION ONE THIRD': 69245,
'RUMI FRACTION TWO THIRDS': 69246,
'RUMI NUMBER EIGHT HUNDRED': 69241,
'RUMI NUMBER EIGHTY': 69232,
'RUMI NUMBER FIFTY': 69229,
'RUMI NUMBER FIVE HUNDRED': 69238,
'RUMI NUMBER FORTY': 69228,
'RUMI NUMBER FOUR HUNDRED': 69237,
'RUMI NUMBER NINE HUNDRED': 69242,
'RUMI NUMBER NINETY': 69233,
'RUMI NUMBER ONE HUNDRED': 69234,
'RUMI NUMBER SEVEN HUNDRED': 69240,
'RUMI NUMBER SEVENTY': 69231,
'RUMI NUMBER SIX HUNDRED': 69239,
'RUMI NUMBER SIXTY': 69230,
'RUMI NUMBER TEN': 69225,
'RUMI NUMBER THIRTY': 69227,
'RUMI NUMBER THREE HUNDRED': 69236,
'RUMI NUMBER TWENTY': 69226,
'RUMI NUMBER TWO HUNDRED': 69235,
'RUNIC ARLAUG SYMBOL': 5870,
'RUNIC BELGTHOR SYMBOL': 5872,
'RUNIC CROSS PUNCTUATION': 5869,
'RUNIC LETTER AC A': 5802,
'RUNIC LETTER AESC': 5803,
'RUNIC LETTER ALGIZ EOLHX': 5833,
'RUNIC LETTER ANSUZ A': 5800,
'RUNIC LETTER BERKANAN BEORC BJARKAN B': 5842,
'RUNIC LETTER C': 5837,
'RUNIC LETTER CALC': 5859,
'RUNIC LETTER CEALC': 5860,
'RUNIC LETTER CEN': 5811,
'RUNIC LETTER CWEORTH': 5858,
'RUNIC LETTER D': 5841,
'RUNIC LETTER DAGAZ DAEG D': 5854,
'RUNIC LETTER DOTTED-L': 5851,
'RUNIC LETTER DOTTED-N': 5824,
'RUNIC LETTER DOTTED-P': 5844,
'RUNIC LETTER E': 5826,
'RUNIC LETTER EAR': 5856,
'RUNIC LETTER EHWAZ EH E': 5846,
'RUNIC LETTER ENG': 5814,
'RUNIC LETTER ETH': 5799,
'RUNIC LETTER FEHU FEOH FE F': 5792,
'RUNIC LETTER G': 5813,
'RUNIC LETTER GAR': 5816,
'RUNIC LETTER GEBO GYFU G': 5815,
'RUNIC LETTER GER': 5828,
'RUNIC LETTER HAEGL H': 5819,
'RUNIC LETTER HAGLAZ H': 5818,
'RUNIC LETTER ICELANDIC-YR': 5864,
'RUNIC LETTER ING': 5853,
'RUNIC LETTER INGWAZ': 5852,
'RUNIC LETTER IOR': 5857,
'RUNIC LETTER ISAZ IS ISS I': 5825,
'RUNIC LETTER IWAZ EOH': 5831,
'RUNIC LETTER JERAN J': 5827,
'RUNIC LETTER KAUN K': 5812,
'RUNIC LETTER KAUNA': 5810,
'RUNIC LETTER LAUKAZ LAGU LOGR L': 5850,
'RUNIC LETTER LONG-BRANCH-AR AE': 5829,
'RUNIC LETTER LONG-BRANCH-HAGALL H': 5820,
'RUNIC LETTER LONG-BRANCH-MADR M': 5848,
'RUNIC LETTER LONG-BRANCH-OSS O': 5804,
'RUNIC LETTER LONG-BRANCH-YR': 5862,
'RUNIC LETTER MANNAZ MAN M': 5847,
'RUNIC LETTER NAUDIZ NYD NAUD N': 5822,
'RUNIC LETTER O': 5806,
'RUNIC LETTER OE': 5807,
'RUNIC LETTER ON': 5808,
'RUNIC LETTER OPEN-P': 5845,
'RUNIC LETTER OS O': 5801,
'RUNIC LETTER OTHALAN ETHEL O': 5855,
'RUNIC LETTER PERTHO PEORTH P': 5832,
'RUNIC LETTER Q': 5865,
'RUNIC LETTER RAIDO RAD REID R': 5809,
'RUNIC LETTER SHORT-TWIG-AR A': 5830,
'RUNIC LETTER SHORT-TWIG-BJARKAN B': 5843,
'RUNIC LETTER SHORT-TWIG-HAGALL H': 5821,
'RUNIC LETTER SHORT-TWIG-MADR M': 5849,
'RUNIC LETTER SHORT-TWIG-NAUD N': 5823,
'RUNIC LETTER SHORT-TWIG-OSS O': 5805,
'RUNIC LETTER SHORT-TWIG-SOL S': 5836,
'RUNIC LETTER SHORT-TWIG-TYR T': 5840,
'RUNIC LETTER SHORT-TWIG-YR': 5863,
'RUNIC LETTER SIGEL LONG-BRANCH-SOL S': 5835,
'RUNIC LETTER SOWILO S': 5834,
'RUNIC LETTER STAN': 5861,
'RUNIC LETTER THURISAZ THURS THORN': 5798,
'RUNIC LETTER TIWAZ TIR TYR T': 5839,
'RUNIC LETTER URUZ UR U': 5794,
'RUNIC LETTER V': 5793,
'RUNIC LETTER W': 5797,
'RUNIC LETTER WUNJO WYNN W': 5817,
'RUNIC LETTER X': 5866,
'RUNIC LETTER Y': 5796,
'RUNIC LETTER YR': 5795,
'RUNIC LETTER Z': 5838,
'RUNIC MULTIPLE PUNCTUATION': 5868,
'RUNIC SINGLE PUNCTUATION': 5867,
'RUNIC TVIMADUR SYMBOL': 5871,
'RUPEE SIGN': 8360,
'S IN TRIANGLE': 10700,
'SAGITTARIUS': 9808,
'SAILBOAT': 9973,
'SALTIRE': 9747,
'SAMARITAN ABBREVIATION MARK': 2102,
'SAMARITAN LETTER ALAF': 2048,
'SAMARITAN LETTER BAA': 2053,
'SAMARITAN LETTER BIT': 2049,
'SAMARITAN LETTER DALAT': 2051,
'SAMARITAN LETTER FI': 2064,
'SAMARITAN LETTER GAMAN': 2050,
'SAMARITAN LETTER IN': 2063,
'SAMARITAN LETTER IT': 2055,
'SAMARITAN LETTER IY': 2052,
'SAMARITAN LETTER KAAF': 2058,
'SAMARITAN LETTER LABAT': 2059,
'SAMARITAN LETTER MIM': 2060,
'SAMARITAN LETTER NUN': 2061,
'SAMARITAN LETTER QUF': 2066,
'SAMARITAN LETTER RISH': 2067,
'SAMARITAN LETTER SHAN': 2068,
'SAMARITAN LETTER SINGAAT': 2062,
'SAMARITAN LETTER TAAF': 2069,
'SAMARITAN LETTER TIT': 2056,
'SAMARITAN LETTER TSAADIY': 2065,
'SAMARITAN LETTER YUT': 2057,
'SAMARITAN LETTER ZEN': 2054,
'SAMARITAN MARK DAGESH': 2073,
'SAMARITAN MARK EPENTHETIC YUT': 2075,
'SAMARITAN MARK IN': 2070,
'SAMARITAN MARK IN-ALAF': 2071,
'SAMARITAN MARK NEQUDAA': 2093,
'SAMARITAN MARK OCCLUSION': 2072,
'SAMARITAN MODIFIER LETTER EPENTHETIC YUT': 2074,
'SAMARITAN MODIFIER LETTER I': 2088,
'SAMARITAN MODIFIER LETTER SHORT A': 2084,
'SAMARITAN PUNCTUATION AFSAAQ': 2097,
'SAMARITAN PUNCTUATION ANGED': 2098,
'SAMARITAN PUNCTUATION ANNAAU': 2110,
'SAMARITAN PUNCTUATION ARKAANU': 2108,
'SAMARITAN PUNCTUATION ATMAAU': 2100,
'SAMARITAN PUNCTUATION BAU': 2099,
'SAMARITAN PUNCTUATION MELODIC QITSA': 2103,
'SAMARITAN PUNCTUATION NEQUDAA': 2096,
'SAMARITAN PUNCTUATION QITSA': 2105,
'SAMARITAN PUNCTUATION SHIYYAALAA': 2101,
'SAMARITAN PUNCTUATION SOF MASHFAAT': 2109,
'SAMARITAN PUNCTUATION TURU': 2107,
'SAMARITAN PUNCTUATION ZAEF': 2106,
'SAMARITAN PUNCTUATION ZIQAA': 2104,
'SAMARITAN VOWEL SIGN A': 2083,
'SAMARITAN VOWEL SIGN AA': 2080,
'SAMARITAN VOWEL SIGN E': 2077,
'SAMARITAN VOWEL SIGN I': 2090,
'SAMARITAN VOWEL SIGN LONG A': 2082,
'SAMARITAN VOWEL SIGN LONG AA': 2079,
'SAMARITAN VOWEL SIGN LONG E': 2076,
'SAMARITAN VOWEL SIGN LONG I': 2089,
'SAMARITAN VOWEL SIGN LONG U': 2086,
'SAMARITAN VOWEL SIGN O': 2091,
'SAMARITAN VOWEL SIGN OVERLONG A': 2081,
'SAMARITAN VOWEL SIGN OVERLONG AA': 2078,
'SAMARITAN VOWEL SIGN SHORT A': 2085,
'SAMARITAN VOWEL SIGN SUKUN': 2092,
'SAMARITAN VOWEL SIGN U': 2087,
'SATURN': 9796,
'SAURASHTRA CONSONANT SIGN HAARU': 43188,
'SAURASHTRA DANDA': 43214,
'SAURASHTRA DIGIT EIGHT': 43224,
'SAURASHTRA DIGIT FIVE': 43221,
'SAURASHTRA DIGIT FOUR': 43220,
'SAURASHTRA DIGIT NINE': 43225,
'SAURASHTRA DIGIT ONE': 43217,
'SAURASHTRA DIGIT SEVEN': 43223,
'SAURASHTRA DIGIT SIX': 43222,
'SAURASHTRA DIGIT THREE': 43219,
'SAURASHTRA DIGIT TWO': 43218,
'SAURASHTRA DIGIT ZERO': 43216,
'SAURASHTRA DOUBLE DANDA': 43215,
'SAURASHTRA LETTER A': 43138,
'SAURASHTRA LETTER AA': 43139,
'SAURASHTRA LETTER AI': 43150,
'SAURASHTRA LETTER AU': 43153,
'SAURASHTRA LETTER BA': 43176,
'SAURASHTRA LETTER BHA': 43177,
'SAURASHTRA LETTER CA': 43159,
'SAURASHTRA LETTER CHA': 43160,
'SAURASHTRA LETTER DA': 43171,
'SAURASHTRA LETTER DDA': 43166,
'SAURASHTRA LETTER DDHA': 43167,
'SAURASHTRA LETTER DHA': 43172,
'SAURASHTRA LETTER E': 43148,
'SAURASHTRA LETTER EE': 43149,
'SAURASHTRA LETTER GA': 43156,
'SAURASHTRA LETTER GHA': 43157,
'SAURASHTRA LETTER HA': 43186,
'SAURASHTRA LETTER I': 43140,
'SAURASHTRA LETTER II': 43141,
'SAURASHTRA LETTER JA': 43161,
'SAURASHTRA LETTER JHA': 43162,
'SAURASHTRA LETTER KA': 43154,
'SAURASHTRA LETTER KHA': 43155,
'SAURASHTRA LETTER LA': 43181,
'SAURASHTRA LETTER LLA': 43187,
'SAURASHTRA LETTER MA': 43178,
'SAURASHTRA LETTER NA': 43173,
'SAURASHTRA LETTER NGA': 43158,
'SAURASHTRA LETTER NNA': 43168,
'SAURASHTRA LETTER NYA': 43163,
'SAURASHTRA LETTER O': 43151,
'SAURASHTRA LETTER OO': 43152,
'SAURASHTRA LETTER PA': 43174,
'SAURASHTRA LETTER PHA': 43175,
'SAURASHTRA LETTER RA': 43180,
'SAURASHTRA LETTER SA': 43185,
'SAURASHTRA LETTER SHA': 43183,
'SAURASHTRA LETTER SSA': 43184,
'SAURASHTRA LETTER TA': 43169,
'SAURASHTRA LETTER THA': 43170,
'SAURASHTRA LETTER TTA': 43164,
'SAURASHTRA LETTER TTHA': 43165,
'SAURASHTRA LETTER U': 43142,
'SAURASHTRA LETTER UU': 43143,
'SAURASHTRA LETTER VA': 43182,
'SAURASHTRA LETTER VOCALIC L': 43146,
'SAURASHTRA LETTER VOCALIC LL': 43147,
'SAURASHTRA LETTER VOCALIC R': 43144,
'SAURASHTRA LETTER VOCALIC RR': 43145,
'SAURASHTRA LETTER YA': 43179,
'SAURASHTRA SIGN ANUSVARA': 43136,
'SAURASHTRA SIGN VIRAMA': 43204,
'SAURASHTRA SIGN VISARGA': 43137,
'SAURASHTRA VOWEL SIGN AA': 43189,
'SAURASHTRA VOWEL SIGN AI': 43200,
'SAURASHTRA VOWEL SIGN AU': 43203,
'SAURASHTRA VOWEL SIGN E': 43198,
'SAURASHTRA VOWEL SIGN EE': 43199,
'SAURASHTRA VOWEL SIGN I': 43190,
'SAURASHTRA VOWEL SIGN II': 43191,
'SAURASHTRA VOWEL SIGN O': 43201,
'SAURASHTRA VOWEL SIGN OO': 43202,
'SAURASHTRA VOWEL SIGN U': 43192,
'SAURASHTRA VOWEL SIGN UU': 43193,
'SAURASHTRA VOWEL SIGN VOCALIC L': 43196,
'SAURASHTRA VOWEL SIGN VOCALIC LL': 43197,
'SAURASHTRA VOWEL SIGN VOCALIC R': 43194,
'SAURASHTRA VOWEL SIGN VOCALIC RR': 43195,
'SCALES': 9878,
'SCORPIUS': 9807,
'SCRIPT CAPITAL B': 8492,
'SCRIPT CAPITAL E': 8496,
'SCRIPT CAPITAL F': 8497,
'SCRIPT CAPITAL H': 8459,
'SCRIPT CAPITAL I': 8464,
'SCRIPT CAPITAL L': 8466,
'SCRIPT CAPITAL M': 8499,
'SCRIPT CAPITAL P': 8472,
'SCRIPT CAPITAL R': 8475,
'SCRIPT SMALL E': 8495,
'SCRIPT SMALL G': 8458,
'SCRIPT SMALL L': 8467,
'SCRIPT SMALL O': 8500,
'SCRUPLE': 8456,
'SECTION SIGN': 167,
'SECTOR': 8980,
'SEGMENT': 8979,
'SEMICOLON': 59,
'SEMIDIRECT PRODUCT WITH BOTTOM CLOSED': 10802,
'SEMISEXTILE': 9914,
'SERVICE MARK': 8480,
'SESAME DOT': 65093,
'SESQUIQUADRATE': 9916,
'SET MINUS': 8726,
'SEXTILE': 9913,
'SHADOWED WHITE CIRCLE': 10061,
'SHADOWED WHITE LATIN CROSS': 10014,
'SHADOWED WHITE STAR': 10032,
'SHAMROCK': 9752,
'SHAVIAN LETTER ADO': 66665,
'SHAVIAN LETTER AGE': 66673,
'SHAVIAN LETTER AH': 66669,
'SHAVIAN LETTER AIR': 66682,
'SHAVIAN LETTER ARE': 66680,
'SHAVIAN LETTER ARRAY': 66684,
'SHAVIAN LETTER ASH': 66664,
'SHAVIAN LETTER AWE': 66679,
'SHAVIAN LETTER BIB': 66650,
'SHAVIAN LETTER CHURCH': 66647,
'SHAVIAN LETTER DEAD': 66651,
'SHAVIAN LETTER EAR': 66685,
'SHAVIAN LETTER EAT': 66672,
'SHAVIAN LETTER EGG': 66663,
'SHAVIAN LETTER ERR': 66683,
'SHAVIAN LETTER FEE': 66643,
'SHAVIAN LETTER GAG': 66652,
'SHAVIAN LETTER HA-HA': 66659,
'SHAVIAN LETTER HUNG': 66649,
'SHAVIAN LETTER IAN': 66686,
'SHAVIAN LETTER ICE': 66674,
'SHAVIAN LETTER IF': 66662,
'SHAVIAN LETTER JUDGE': 66657,
'SHAVIAN LETTER KICK': 66642,
'SHAVIAN LETTER LOLL': 66660,
'SHAVIAN LETTER MEASURE': 66656,
'SHAVIAN LETTER MIME': 66661,
'SHAVIAN LETTER NUN': 66671,
'SHAVIAN LETTER OAK': 66676,
'SHAVIAN LETTER OIL': 66678,
'SHAVIAN LETTER ON': 66666,
'SHAVIAN LETTER OOZE': 66677,
'SHAVIAN LETTER OR': 66681,
'SHAVIAN LETTER OUT': 66668,
'SHAVIAN LETTER PEEP': 66640,
'SHAVIAN LETTER ROAR': 66670,
'SHAVIAN LETTER SO': 66645,
'SHAVIAN LETTER SURE': 66646,
'SHAVIAN LETTER THEY': 66654,
'SHAVIAN LETTER THIGH': 66644,
'SHAVIAN LETTER TOT': 66641,
'SHAVIAN LETTER UP': 66675,
'SHAVIAN LETTER VOW': 66653,
'SHAVIAN LETTER WOE': 66658,
'SHAVIAN LETTER WOOL': 66667,
'SHAVIAN LETTER YEA': 66648,
'SHAVIAN LETTER YEW': 66687,
'SHAVIAN LETTER ZOO': 66655,
'SHINTO SHRINE': 9961,
'SHORT DOWN TACK': 10975,
'SHORT DOWN TACK WITH OVERBAR': 10983,
'SHORT LEFT TACK': 10974,
'SHORT RIGHTWARDS ARROW ABOVE LEFTWARDS ARROW': 10564,
'SHORT UP TACK': 10976,
'SHORT UP TACK ABOVE SHORT DOWN TACK': 10985,
'SHORT UP TACK WITH UNDERBAR': 10984,
'SHOULDERED OPEN BOX': 9085,
'SHUFFLE PRODUCT': 10722,
'SIMILAR ABOVE GREATER-THAN ABOVE EQUALS SIGN': 10912,
'SIMILAR ABOVE LESS-THAN ABOVE EQUALS SIGN': 10911,
'SIMILAR MINUS SIMILAR': 10860,
'SIMILAR OR GREATER-THAN': 10910,
'SIMILAR OR LESS-THAN': 10909,
'SINE WAVE': 8767,
'SINGLE HIGH-REVERSED-9 QUOTATION MARK': 8219,
'SINGLE LEFT-POINTING ANGLE QUOTATION MARK': 8249,
'SINGLE LOW-9 QUOTATION MARK': 8218,
'SINGLE RIGHT-POINTING ANGLE QUOTATION MARK': 8250,
'SINHALA LETTER AAYANNA': 3462,
'SINHALA LETTER AEEYANNA': 3464,
'SINHALA LETTER AEYANNA': 3463,
'SINHALA LETTER AIYANNA': 3475,
'SINHALA LETTER ALPAPRAANA BAYANNA': 3510,
'SINHALA LETTER ALPAPRAANA CAYANNA': 3488,
'SINHALA LETTER ALPAPRAANA DAYANNA': 3503,
'SINHALA LETTER ALPAPRAANA DDAYANNA': 3497,
'SINHALA LETTER ALPAPRAANA GAYANNA': 3484,
'SINHALA LETTER ALPAPRAANA JAYANNA': 3490,
'SINHALA LETTER ALPAPRAANA KAYANNA': 3482,
'SINHALA LETTER ALPAPRAANA PAYANNA': 3508,
'SINHALA LETTER ALPAPRAANA TAYANNA': 3501,
'SINHALA LETTER ALPAPRAANA TTAYANNA': 3495,
'SINHALA LETTER AMBA BAYANNA': 3513,
'SINHALA LETTER AUYANNA': 3478,
'SINHALA LETTER AYANNA': 3461,
'SINHALA LETTER DANTAJA LAYANNA': 3517,
'SINHALA LETTER DANTAJA NAYANNA': 3505,
'SINHALA LETTER DANTAJA SAYANNA': 3523,
'SINHALA LETTER EEYANNA': 3474,
'SINHALA LETTER EYANNA': 3473,
'SINHALA LETTER FAYANNA': 3526,
'SINHALA LETTER HAYANNA': 3524,
'SINHALA LETTER IIYANNA': 3466,
'SINHALA LETTER ILUUYANNA': 3472,
'SINHALA LETTER ILUYANNA': 3471,
'SINHALA LETTER IRUUYANNA': 3470,
'SINHALA LETTER IRUYANNA': 3469,
'SINHALA LETTER IYANNA': 3465,
'SINHALA LETTER KANTAJA NAASIKYAYA': 3486,
'SINHALA LETTER MAHAAPRAANA BAYANNA': 3511,
'SINHALA LETTER MAHAAPRAANA CAYANNA': 3489,
'SINHALA LETTER MAHAAPRAANA DAYANNA': 3504,
'SINHALA LETTER MAHAAPRAANA DDAYANNA': 3498,
'SINHALA LETTER MAHAAPRAANA GAYANNA': 3485,
'SINHALA LETTER MAHAAPRAANA JAYANNA': 3491,
'SINHALA LETTER MAHAAPRAANA KAYANNA': 3483,
'SINHALA LETTER MAHAAPRAANA PAYANNA': 3509,
'SINHALA LETTER MAHAAPRAANA TAYANNA': 3502,
'SINHALA LETTER MAHAAPRAANA TTAYANNA': 3496,
'SINHALA LETTER MAYANNA': 3512,
'SINHALA LETTER MUURDHAJA LAYANNA': 3525,
'SINHALA LETTER MUURDHAJA NAYANNA': 3499,
'SINHALA LETTER MUURDHAJA SAYANNA': 3522,
'SINHALA LETTER OOYANNA': 3477,
'SINHALA LETTER OYANNA': 3476,
'SINHALA LETTER RAYANNA': 3515,
'SINHALA LETTER SANYAKA DAYANNA': 3507,
'SINHALA LETTER SANYAKA DDAYANNA': 3500,
'SINHALA LETTER SANYAKA GAYANNA': 3487,
'SINHALA LETTER SANYAKA JAYANNA': 3494,
'SINHALA LETTER TAALUJA NAASIKYAYA': 3492,
'SINHALA LETTER TAALUJA SANYOOGA NAAKSIKYAYA': 3493,
'SINHALA LETTER TAALUJA SAYANNA': 3521,
'SINHALA LETTER UUYANNA': 3468,
'SINHALA LETTER UYANNA': 3467,
'SINHALA LETTER VAYANNA': 3520,
'SINHALA LETTER YAYANNA': 3514,
'SINHALA PUNCTUATION KUNDDALIYA': 3572,
'SINHALA SIGN AL-LAKUNA': 3530,
'SINHALA SIGN ANUSVARAYA': 3458,
'SINHALA SIGN VISARGAYA': 3459,
'SINHALA VOWEL SIGN AELA-PILLA': 3535,
'SINHALA VOWEL SIGN DIGA AEDA-PILLA': 3537,
'SINHALA VOWEL SIGN DIGA GAETTA-PILLA': 3570,
'SINHALA VOWEL SIGN DIGA GAYANUKITTA': 3571,
'SINHALA VOWEL SIGN DIGA IS-PILLA': 3539,
'SINHALA VOWEL SIGN DIGA KOMBUVA': 3546,
'SINHALA VOWEL SIGN DIGA PAA-PILLA': 3542,
'SINHALA VOWEL SIGN GAETTA-PILLA': 3544,
'SINHALA VOWEL SIGN GAYANUKITTA': 3551,
'SINHALA VOWEL SIGN KETTI AEDA-PILLA': 3536,
'SINHALA VOWEL SIGN KETTI IS-PILLA': 3538,
'SINHALA VOWEL SIGN KETTI PAA-PILLA': 3540,
'SINHALA VOWEL SIGN KOMBU DEKA': 3547,
'SINHALA VOWEL SIGN KOMBUVA': 3545,
'SINHALA VOWEL SIGN KOMBUVA HAA AELA-PILLA': 3548,
'SINHALA VOWEL SIGN KOMBUVA HAA DIGA AELA-PILLA': 3549,
'SINHALA VOWEL SIGN KOMBUVA HAA GAYANUKITTA': 3550,
'SIX PETALLED BLACK AND WHITE FLORETTE': 10046,
'SIX POINTED BLACK STAR': 10038,
'SIX-PER-EM SPACE': 8198,
'SIXTEEN POINTED ASTERISK': 10042,
'SKIER': 9975,
'SKULL AND CROSSBONES': 9760,
'SLANTED EQUAL TO OR GREATER-THAN': 10902,
'SLANTED EQUAL TO OR GREATER-THAN WITH DOT INSIDE': 10904,
'SLANTED EQUAL TO OR LESS-THAN': 10901,
'SLANTED EQUAL TO OR LESS-THAN WITH DOT INSIDE': 10903,
'SLAVONIC ASTERISK': 42611,
'SLOPE': 9011,
'SLOPING LARGE AND': 10840,
'SLOPING LARGE OR': 10839,
'SMALL AMPERSAND': 65120,
'SMALL ASTERISK': 65121,
'SMALL COLON': 65109,
'SMALL COMMA': 65104,
'SMALL COMMERCIAL AT': 65131,
'SMALL CONTAINS AS MEMBER': 8717,
'SMALL CONTAINS WITH OVERBAR': 8958,
'SMALL CONTAINS WITH VERTICAL BAR AT END OF HORIZONTAL STROKE': 8956,
'SMALL DOLLAR SIGN': 65129,
'SMALL ELEMENT OF': 8714,
'SMALL ELEMENT OF WITH OVERBAR': 8951,
'SMALL ELEMENT OF WITH VERTICAL BAR AT END OF HORIZONTAL STROKE': 8948,
'SMALL EM DASH': 65112,
'SMALL EQUALS SIGN': 65126,
'SMALL EXCLAMATION MARK': 65111,
'SMALL FULL STOP': 65106,
'SMALL GREATER-THAN SIGN': 65125,
'SMALL HYPHEN-MINUS': 65123,
'SMALL IDEOGRAPHIC COMMA': 65105,
'SMALL LEFT CURLY BRACKET': 65115,
'SMALL LEFT PARENTHESIS': 65113,
'SMALL LEFT TORTOISE SHELL BRACKET': 65117,
'SMALL LESS-THAN SIGN': 65124,
'SMALL NUMBER SIGN': 65119,
'SMALL PERCENT SIGN': 65130,
'SMALL PLUS SIGN': 65122,
'SMALL QUESTION MARK': 65110,
'SMALL REVERSE SOLIDUS': 65128,
'SMALL RIGHT CURLY BRACKET': 65116,
'SMALL RIGHT PARENTHESIS': 65114,
'SMALL RIGHT TORTOISE SHELL BRACKET': 65118,
'SMALL ROMAN NUMERAL EIGHT': 8567,
'SMALL ROMAN NUMERAL ELEVEN': 8570,
'SMALL ROMAN NUMERAL FIFTY': 8572,
'SMALL ROMAN NUMERAL FIVE': 8564,
'SMALL ROMAN NUMERAL FIVE HUNDRED': 8574,
'SMALL ROMAN NUMERAL FOUR': 8563,
'SMALL ROMAN NUMERAL NINE': 8568,
'SMALL ROMAN NUMERAL ONE': 8560,
'SMALL ROMAN NUMERAL ONE HUNDRED': 8573,
'SMALL ROMAN NUMERAL ONE THOUSAND': 8575,
'SMALL ROMAN NUMERAL SEVEN': 8566,
'SMALL ROMAN NUMERAL SIX': 8565,
'SMALL ROMAN NUMERAL TEN': 8569,
'SMALL ROMAN NUMERAL THREE': 8562,
'SMALL ROMAN NUMERAL TWELVE': 8571,
'SMALL ROMAN NUMERAL TWO': 8561,
'SMALL SEMICOLON': 65108,
'SMALL TILDE': 732,
'SMALL TWO DOTS OVER ONE DOT PUNCTUATION': 68411,
'SMALL VEE WITH UNDERBAR': 10849,
'SMALLER THAN': 10922,
'SMALLER THAN OR EQUAL TO': 10924,
'SMASH PRODUCT': 10803,
'SMILE': 8995,
'SNOWFLAKE': 10052,
'SNOWMAN': 9731,
'SNOWMAN WITHOUT SNOW': 9924,
'SOCCER BALL': 9917,
'SOFT HYPHEN': 173,
'SOFTWARE-FUNCTION SYMBOL': 9108,
'SOLIDUS': 47,
'SOLIDUS WITH OVERBAR': 10742,
'SOUND RECORDING COPYRIGHT': 8471,
'SOUTH EAST ARROW': 8600,
'SOUTH EAST ARROW AND SOUTH WEST ARROW': 10537,
'SOUTH EAST ARROW CROSSING NORTH EAST ARROW': 10541,
'SOUTH EAST ARROW TO CORNER': 8690,
'SOUTH EAST ARROW WITH HOOK': 10533,
'SOUTH EAST BLACK ARROW': 11018,
'SOUTH EAST DOUBLE ARROW': 8664,
'SOUTH EAST WHITE ARROW': 11010,
'SOUTH WEST ARROW': 8601,
'SOUTH WEST ARROW AND NORTH WEST ARROW': 10538,
'SOUTH WEST ARROW WITH HOOK': 10534,
'SOUTH WEST BLACK ARROW': 11019,
'SOUTH WEST DOUBLE ARROW': 8665,
'SOUTH WEST WHITE ARROW': 11011,
'SPACE': 32,
'SPARKLE': 10055,
'SPESMILO SIGN': 8375,
'SPHERICAL ANGLE': 8738,
'SPHERICAL ANGLE OPENING LEFT': 10656,
'SPHERICAL ANGLE OPENING UP': 10657,
'SQUARE A OVER M': 13279,
'SQUARE AARU': 13059,
'SQUARE AM': 13250,
'SQUARE ANPEA': 13058,
'SQUARE APAATO': 13056,
'SQUARE ARUHUA': 13057,
'SQUARE AU': 13171,
'SQUARE BAARERU': 13101,
'SQUARE BAR': 13172,
'SQUARE BEETA': 13116,
'SQUARE BIRU': 13105,
'SQUARE BORUTO': 13118,
'SQUARE BQ': 13251,
'SQUARE BUSSYERU': 13108,
'SQUARE C OVER KG': 13254,
'SQUARE CAL': 13192,
'SQUARE CAP': 8851,
'SQUARE CC': 13252,
'SQUARE CD': 13253,
'SQUARE CM': 13213,
'SQUARE CM CUBED': 13220,
'SQUARE CM SQUARED': 13216,
'SQUARE CO': 13255,
'SQUARE CORPORATION': 13183,
'SQUARE CUP': 8852,
'SQUARE DA': 13170,
'SQUARE DAASU': 13092,
'SQUARE DB': 13256,
'SQUARE DESI': 13093,
'SQUARE DJ': 127376,
'SQUARE DL': 13207,
'SQUARE DM': 13175,
'SQUARE DM CUBED': 13177,
'SQUARE DM SQUARED': 13176,
'SQUARE DORU': 13094,
'SQUARE EEKAA': 13064,
'SQUARE ERA NAME HEISEI': 13179,
'SQUARE ERA NAME MEIZI': 13182,
'SQUARE ERA NAME SYOUWA': 13180,
'SQUARE ERA NAME TAISYOU': 13181,
'SQUARE ERG': 13005,
'SQUARE ESUKUUDO': 13063,
'SQUARE EV': 13006,
'SQUARE FM': 13209,
'SQUARE FOOT': 9165,
'SQUARE FOUR CORNERS': 9974,
'SQUARE GAL': 13311,
'SQUARE GANMA': 13071,
'SQUARE GARON': 13070,
'SQUARE GB': 13191,
'SQUARE GHZ': 13203,
'SQUARE GIGA': 13072,
'SQUARE GINII': 13073,
'SQUARE GIRUDAA': 13075,
'SQUARE GPA': 13228,
'SQUARE GURAMU': 13080,
'SQUARE GURAMUTON': 13081,
'SQUARE GY': 13257,
'SQUARE HA': 13258,
'SQUARE HAITU': 13098,
'SQUARE HEKUTAARU': 13110,
'SQUARE HERUTU': 13113,
'SQUARE HG': 13004,
'SQUARE HIRAGANA HOKA': 127488,
'SQUARE HON': 13119,
'SQUARE HOON': 13122,
'SQUARE HOORU': 13121,
'SQUARE HP': 13259,
'SQUARE HPA': 13169,
'SQUARE HUARADDO': 13106,
'SQUARE HUIITO': 13107,
'SQUARE HURAN': 13109,
'SQUARE HZ': 13200,
'SQUARE IMAGE OF': 8847,
'SQUARE IMAGE OF OR EQUAL TO': 8849,
'SQUARE IMAGE OF OR NOT EQUAL TO': 8932,
'SQUARE IN': 13260,
'SQUARE ININGU': 13060,
'SQUARE INTI': 13061,
'SQUARE IU': 13178,
'SQUARE K OHM': 13248,
'SQUARE KA': 13188,
'SQUARE KAIRI': 13067,
'SQUARE KARATTO': 13068,
'SQUARE KARORII': 13069,
'SQUARE KB': 13189,
'SQUARE KCAL': 13193,
'SQUARE KEESU': 13084,
'SQUARE KG': 13199,
'SQUARE KHZ': 13201,
'SQUARE KIRO': 13076,
'SQUARE KIROGURAMU': 13077,
'SQUARE KIROMEETORU': 13078,
'SQUARE KIROWATTO': 13079,
'SQUARE KK': 13261,
'SQUARE KL': 13208,
'SQUARE KM': 13214,
'SQUARE KM CAPITAL': 13262,
'SQUARE KM CUBED': 13222,
'SQUARE KM SQUARED': 13218,
'SQUARE KOOPO': 13086,
'SQUARE KORUNA': 13085,
'SQUARE KPA': 13226,
'SQUARE KT': 13263,
'SQUARE KUROONE': 13083,
'SQUARE KURUZEIRO': 13082,
'SQUARE KV': 13240,
'SQUARE KW': 13246,
'SQUARE KYURII': 13074,
'SQUARE LEFT OPEN BOX OPERATOR': 10957,
'SQUARE LM': 13264,
'SQUARE LN': 13265,
'SQUARE LOG': 13266,
'SQUARE LOZENGE': 8977,
'SQUARE LX': 13267,
'SQUARE M CUBED': 13221,
'SQUARE M OHM': 13249,
'SQUARE M OVER S': 13223,
'SQUARE M OVER S SQUARED': 13224,
'SQUARE M SQUARED': 13217,
'SQUARE MA': 13187,
'SQUARE MAHHA': 13125,
'SQUARE MAIKURO': 13123,
'SQUARE MAIRU': 13124,
'SQUARE MANSYON': 13127,
'SQUARE MARUKU': 13126,
'SQUARE MB': 13190,
'SQUARE MB SMALL': 13268,
'SQUARE MEETORU': 13133,
'SQUARE MEGA': 13131,
'SQUARE MEGATON': 13132,
'SQUARE MG': 13198,
'SQUARE MHZ': 13202,
'SQUARE MIKURON': 13128,
'SQUARE MIL': 13269,
'SQUARE MIRI': 13129,
'SQUARE MIRIBAARU': 13130,
'SQUARE ML': 13206,
'SQUARE MM': 13212,
'SQUARE MM CUBED': 13219,
'SQUARE MM SQUARED': 13215,
'SQUARE MOL': 13270,
'SQUARE MPA': 13227,
'SQUARE MS': 13235,
'SQUARE MU A': 13186,
'SQUARE MU F': 13196,
'SQUARE MU G': 13197,
'SQUARE MU L': 13205,
'SQUARE MU M': 13211,
'SQUARE MU S': 13234,
'SQUARE MU V': 13238,
'SQUARE MU W': 13244,
'SQUARE MV': 13239,
'SQUARE MV MEGA': 13241,
'SQUARE MW': 13245,
'SQUARE MW MEGA': 13247,
'SQUARE NA': 13185,
'SQUARE NANO': 13096,
'SQUARE NF': 13195,
'SQUARE NM': 13210,
'SQUARE NOTTO': 13097,
'SQUARE NS': 13233,
'SQUARE NV': 13237,
'SQUARE NW': 13243,
'SQUARE ONSU': 13065,
'SQUARE OOMU': 13066,
'SQUARE ORIGINAL OF': 8848,
'SQUARE ORIGINAL OF OR EQUAL TO': 8850,
'SQUARE ORIGINAL OF OR NOT EQUAL TO': 8933,
'SQUARE OV': 13173,
'SQUARE PA': 13225,
'SQUARE PA AMPS': 13184,
'SQUARE PAASENTO': 13099,
'SQUARE PAATU': 13100,
'SQUARE PC': 13174,
'SQUARE PEEZI': 13115,
'SQUARE PENIHI': 13112,
'SQUARE PENSU': 13114,
'SQUARE PESO': 13111,
'SQUARE PF': 13194,
'SQUARE PH': 13271,
'SQUARE PIASUTORU': 13102,
'SQUARE PIKO': 13104,
'SQUARE PIKURU': 13103,
'SQUARE PM': 13272,
'SQUARE POINTO': 13117,
'SQUARE PONDO': 13120,
'SQUARE PPM': 13273,
'SQUARE PR': 13274,
'SQUARE PS': 13232,
'SQUARE PV': 13236,
'SQUARE PW': 13242,
'SQUARE RAD': 13229,
'SQUARE RAD OVER S': 13230,
'SQUARE RAD OVER S SQUARED': 13231,
'SQUARE REMU': 13141,
'SQUARE RENTOGEN': 13142,
'SQUARE RIGHT OPEN BOX OPERATOR': 10958,
'SQUARE RIRA': 13138,
'SQUARE RITTORU': 13137,
'SQUARE ROOT': 8730,
'SQUARE RUPII': 13139,
'SQUARE RUUBURU': 13140,
'SQUARE SAIKURU': 13087,
'SQUARE SANTIIMU': 13088,
'SQUARE SENTI': 13090,
'SQUARE SENTO': 13091,
'SQUARE SIRINGU': 13089,
'SQUARE SR': 13275,
'SQUARE SV': 13276,
'SQUARE THZ': 13204,
'SQUARE TON': 13095,
'SQUARE UON': 13062,
'SQUARE V OVER M': 13278,
'SQUARE WATTO': 13143,
'SQUARE WB': 13277,
'SQUARE WITH BOTTOM HALF BLACK': 11027,
'SQUARE WITH CONTOURED OUTLINE': 10720,
'SQUARE WITH DIAGONAL CROSSHATCH FILL': 9641,
'SQUARE WITH HORIZONTAL FILL': 9636,
'SQUARE WITH LEFT HALF BLACK': 9703,
'SQUARE WITH LOWER LEFT DIAGONAL HALF BLACK': 11029,
'SQUARE WITH LOWER RIGHT DIAGONAL HALF BLACK': 9706,
'SQUARE WITH ORTHOGONAL CROSSHATCH FILL': 9638,
'SQUARE WITH RIGHT HALF BLACK': 9704,
'SQUARE WITH TOP HALF BLACK': 11026,
'SQUARE WITH UPPER LEFT DIAGONAL HALF BLACK': 9705,
'SQUARE WITH UPPER LEFT TO LOWER RIGHT FILL': 9639,
'SQUARE WITH UPPER RIGHT DIAGONAL HALF BLACK': 11028,
'SQUARE WITH UPPER RIGHT TO LOWER LEFT FILL': 9640,
'SQUARE WITH VERTICAL FILL': 9637,
'SQUARE YAADO': 13134,
'SQUARE YAARU': 13135,
'SQUARE YUAN': 13136,
'SQUARED ASTERISK': 10694,
'SQUARED CJK UNIFIED IDEOGRAPH-4E00': 127529,
'SQUARED CJK UNIFIED IDEOGRAPH-4E09': 127530,
'SQUARED CJK UNIFIED IDEOGRAPH-4E2D': 127533,
'SQUARED CJK UNIFIED IDEOGRAPH-4E8C': 127508,
'SQUARED CJK UNIFIED IDEOGRAPH-4EA4': 127512,
'SQUARED CJK UNIFIED IDEOGRAPH-518D': 127518,
'SQUARED CJK UNIFIED IDEOGRAPH-521D': 127520,
'SQUARED CJK UNIFIED IDEOGRAPH-524D': 127516,
'SQUARED CJK UNIFIED IDEOGRAPH-53CC': 127506,
'SQUARED CJK UNIFIED IDEOGRAPH-53F3': 127534,
'SQUARED CJK UNIFIED IDEOGRAPH-5439': 127525,
'SQUARED CJK UNIFIED IDEOGRAPH-58F0': 127524,
'SQUARED CJK UNIFIED IDEOGRAPH-591A': 127509,
'SQUARED CJK UNIFIED IDEOGRAPH-5929': 127511,
'SQUARED CJK UNIFIED IDEOGRAPH-5B57': 127505,
'SQUARED CJK UNIFIED IDEOGRAPH-5DE6': 127532,
'SQUARED CJK UNIFIED IDEOGRAPH-5F8C': 127517,
'SQUARED CJK UNIFIED IDEOGRAPH-624B': 127504,
'SQUARED CJK UNIFIED IDEOGRAPH-6253': 127537,
'SQUARED CJK UNIFIED IDEOGRAPH-6295': 127527,
'SQUARED CJK UNIFIED IDEOGRAPH-6307': 127535,
'SQUARED CJK UNIFIED IDEOGRAPH-6355': 127528,
'SQUARED CJK UNIFIED IDEOGRAPH-6599': 127515,
'SQUARED CJK UNIFIED IDEOGRAPH-65B0': 127519,
'SQUARED CJK UNIFIED IDEOGRAPH-6620': 127513,
'SQUARED CJK UNIFIED IDEOGRAPH-6F14': 127526,
'SQUARED CJK UNIFIED IDEOGRAPH-7121': 127514,
'SQUARED CJK UNIFIED IDEOGRAPH-751F': 127522,
'SQUARED CJK UNIFIED IDEOGRAPH-7D42': 127521,
'SQUARED CJK UNIFIED IDEOGRAPH-89E3': 127510,
'SQUARED CJK UNIFIED IDEOGRAPH-8CA9': 127523,
'SQUARED CJK UNIFIED IDEOGRAPH-8D70': 127536,
'SQUARED CJK UNIFIED IDEOGRAPH-904A': 127531,
'SQUARED DOT OPERATOR': 8865,
'SQUARED FALLING DIAGONAL SLASH': 10693,
'SQUARED FOUR DOT PUNCTUATION': 11820,
'SQUARED HV': 127306,
'SQUARED KATAKANA DE': 127507,
'SQUARED KEY': 9919,
'SQUARED LATIN CAPITAL LETTER B': 127281,
'SQUARED LATIN CAPITAL LETTER N': 127293,
'SQUARED LATIN CAPITAL LETTER P': 127295,
'SQUARED LATIN CAPITAL LETTER S': 127298,
'SQUARED LATIN CAPITAL LETTER W': 127302,
'SQUARED MINUS': 8863,
'SQUARED MV': 127307,
'SQUARED PLUS': 8862,
'SQUARED PPV': 127310,
'SQUARED RISING DIAGONAL SLASH': 10692,
'SQUARED SALTIRE': 9949,
'SQUARED SD': 127308,
'SQUARED SMALL CIRCLE': 10695,
'SQUARED SQUARE': 10696,
'SQUARED SS': 127309,
'SQUARED TIMES': 8864,
'SQUAT BLACK RIGHTWARDS ARROW': 10151,
'STAFF OF AESCULAPIUS': 9877,
'STAFF OF HERMES': 9882,
'STAR AND CRESCENT': 9770,
'STAR EQUALS': 8795,
'STAR OF DAVID': 10017,
'STAR OPERATOR': 8902,
'STRAIGHTNESS': 9188,
'STRESS OUTLINED WHITE STAR': 10025,
'STRICTLY EQUIVALENT TO': 8803,
'SUBSCRIPT EIGHT': 8328,
'SUBSCRIPT EQUALS SIGN': 8332,
'SUBSCRIPT FIVE': 8325,
'SUBSCRIPT FOUR': 8324,
'SUBSCRIPT LEFT PARENTHESIS': 8333,
'SUBSCRIPT MINUS': 8331,
'SUBSCRIPT NINE': 8329,
'SUBSCRIPT ONE': 8321,
'SUBSCRIPT PLUS SIGN': 8330,
'SUBSCRIPT RIGHT PARENTHESIS': 8334,
'SUBSCRIPT SEVEN': 8327,
'SUBSCRIPT SIX': 8326,
'SUBSCRIPT THREE': 8323,
'SUBSCRIPT TWO': 8322,
'SUBSCRIPT ZERO': 8320,
'SUBSET ABOVE RIGHTWARDS ARROW': 10617,
'SUBSET ABOVE SUBSET': 10965,
'SUBSET ABOVE SUPERSET': 10963,
'SUBSET OF': 8834,
'SUBSET OF ABOVE ALMOST EQUAL TO': 10953,
'SUBSET OF ABOVE EQUALS SIGN': 10949,
'SUBSET OF ABOVE NOT EQUAL TO': 10955,
'SUBSET OF ABOVE TILDE OPERATOR': 10951,
'SUBSET OF OR EQUAL TO': 8838,
'SUBSET OF OR EQUAL TO WITH DOT ABOVE': 10947,
'SUBSET OF WITH NOT EQUAL TO': 8842,
'SUBSET WITH DOT': 10941,
'SUBSET WITH MULTIPLICATION SIGN BELOW': 10945,
'SUBSET WITH PLUS SIGN BELOW': 10943,
'SUCCEEDS': 8827,
'SUCCEEDS ABOVE ALMOST EQUAL TO': 10936,
'SUCCEEDS ABOVE EQUALS SIGN': 10932,
'SUCCEEDS ABOVE NOT ALMOST EQUAL TO': 10938,
'SUCCEEDS ABOVE NOT EQUAL TO': 10934,
'SUCCEEDS ABOVE SINGLE-LINE EQUALS SIGN': 10928,
'SUCCEEDS ABOVE SINGLE-LINE NOT EQUAL TO': 10930,
'SUCCEEDS BUT NOT EQUIVALENT TO': 8937,
'SUCCEEDS OR EQUAL TO': 8829,
'SUCCEEDS OR EQUIVALENT TO': 8831,
'SUCCEEDS UNDER RELATION': 8881,
'SUMMATION BOTTOM': 9139,
'SUMMATION TOP': 9138,
'SUMMATION WITH INTEGRAL': 10763,
'SUN': 9737,
'SUN BEHIND CLOUD': 9925,
'SUNDANESE CONSONANT SIGN PAMINGKAL': 7073,
'SUNDANESE CONSONANT SIGN PANYAKRA': 7074,
'SUNDANESE CONSONANT SIGN PANYIKU': 7075,
'SUNDANESE DIGIT EIGHT': 7096,
'SUNDANESE DIGIT FIVE': 7093,
'SUNDANESE DIGIT FOUR': 7092,
'SUNDANESE DIGIT NINE': 7097,
'SUNDANESE DIGIT ONE': 7089,
'SUNDANESE DIGIT SEVEN': 7095,
'SUNDANESE DIGIT SIX': 7094,
'SUNDANESE DIGIT THREE': 7091,
'SUNDANESE DIGIT TWO': 7090,
'SUNDANESE DIGIT ZERO': 7088,
'SUNDANESE LETTER A': 7043,
'SUNDANESE LETTER AE': 7046,
'SUNDANESE LETTER BA': 7064,
'SUNDANESE LETTER CA': 7054,
'SUNDANESE LETTER DA': 7059,
'SUNDANESE LETTER E': 7048,
'SUNDANESE LETTER EU': 7049,
'SUNDANESE LETTER FA': 7062,
'SUNDANESE LETTER GA': 7052,
'SUNDANESE LETTER HA': 7072,
'SUNDANESE LETTER I': 7044,
'SUNDANESE LETTER JA': 7055,
'SUNDANESE LETTER KA': 7050,
'SUNDANESE LETTER KHA': 7086,
'SUNDANESE LETTER LA': 7068,
'SUNDANESE LETTER MA': 7065,
'SUNDANESE LETTER NA': 7060,
'SUNDANESE LETTER NGA': 7053,
'SUNDANESE LETTER NYA': 7057,
'SUNDANESE LETTER O': 7047,
'SUNDANESE LETTER PA': 7061,
'SUNDANESE LETTER QA': 7051,
'SUNDANESE LETTER RA': 7067,
'SUNDANESE LETTER SA': 7070,
'SUNDANESE LETTER SYA': 7087,
'SUNDANESE LETTER TA': 7058,
'SUNDANESE LETTER U': 7045,
'SUNDANESE LETTER VA': 7063,
'SUNDANESE LETTER WA': 7069,
'SUNDANESE LETTER XA': 7071,
'SUNDANESE LETTER YA': 7066,
'SUNDANESE LETTER ZA': 7056,
'SUNDANESE SIGN PAMAAEH': 7082,
'SUNDANESE SIGN PANGLAYAR': 7041,
'SUNDANESE SIGN PANGWISAD': 7042,
'SUNDANESE SIGN PANYECEK': 7040,
'SUNDANESE VOWEL SIGN PAMEPET': 7080,
'SUNDANESE VOWEL SIGN PANAELAENG': 7078,
'SUNDANESE VOWEL SIGN PANEULEUNG': 7081,
'SUNDANESE VOWEL SIGN PANGHULU': 7076,
'SUNDANESE VOWEL SIGN PANOLONG': 7079,
'SUNDANESE VOWEL SIGN PANYUKU': 7077,
'SUPERSCRIPT EIGHT': 8312,
'SUPERSCRIPT EQUALS SIGN': 8316,
'SUPERSCRIPT FIVE': 8309,
'SUPERSCRIPT FOUR': 8308,
'SUPERSCRIPT LATIN SMALL LETTER I': 8305,
'SUPERSCRIPT LATIN SMALL LETTER N': 8319,
'SUPERSCRIPT LEFT PARENTHESIS': 8317,
'SUPERSCRIPT MINUS': 8315,
'SUPERSCRIPT NINE': 8313,
'SUPERSCRIPT ONE': 185,
'SUPERSCRIPT PLUS SIGN': 8314,
'SUPERSCRIPT RIGHT PARENTHESIS': 8318,
'SUPERSCRIPT SEVEN': 8311,
'SUPERSCRIPT SIX': 8310,
'SUPERSCRIPT THREE': 179,
'SUPERSCRIPT TWO': 178,
'SUPERSCRIPT ZERO': 8304,
'SUPERSET ABOVE LEFTWARDS ARROW': 10619,
'SUPERSET ABOVE SUBSET': 10964,
'SUPERSET ABOVE SUPERSET': 10966,
'SUPERSET BESIDE AND JOINED BY DASH WITH SUBSET': 10968,
'SUPERSET BESIDE SUBSET': 10967,
'SUPERSET OF': 8835,
'SUPERSET OF ABOVE ALMOST EQUAL TO': 10954,
'SUPERSET OF ABOVE EQUALS SIGN': 10950,
'SUPERSET OF ABOVE NOT EQUAL TO': 10956,
'SUPERSET OF ABOVE TILDE OPERATOR': 10952,
'SUPERSET OF OR EQUAL TO': 8839,
'SUPERSET OF OR EQUAL TO WITH DOT ABOVE': 10948,
'SUPERSET OF WITH NOT EQUAL TO': 8843,
'SUPERSET PRECEDING SOLIDUS': 10185,
'SUPERSET WITH DOT': 10942,
'SUPERSET WITH MULTIPLICATION SIGN BELOW': 10946,
'SUPERSET WITH PLUS SIGN BELOW': 10944,
'SURFACE INTEGRAL': 8751,
'SWUNG DASH': 8275,
'SYLOTI NAGRI LETTER A': 43008,
'SYLOTI NAGRI LETTER BHO': 43036,
'SYLOTI NAGRI LETTER BO': 43035,
'SYLOTI NAGRI LETTER CHO': 43021,
'SYLOTI NAGRI LETTER CO': 43020,
'SYLOTI NAGRI LETTER DDHO': 43027,
'SYLOTI NAGRI LETTER DDO': 43026,
'SYLOTI NAGRI LETTER DHO': 43031,
'SYLOTI NAGRI LETTER DO': 43030,
'SYLOTI NAGRI LETTER E': 43012,
'SYLOTI NAGRI LETTER GHO': 43018,
'SYLOTI NAGRI LETTER GO': 43017,
'SYLOTI NAGRI LETTER HO': 43042,
'SYLOTI NAGRI LETTER I': 43009,
'SYLOTI NAGRI LETTER JHO': 43023,
'SYLOTI NAGRI LETTER JO': 43022,
'SYLOTI NAGRI LETTER KHO': 43016,
'SYLOTI NAGRI LETTER KO': 43015,
'SYLOTI NAGRI LETTER LO': 43039,
'SYLOTI NAGRI LETTER MO': 43037,
'SYLOTI NAGRI LETTER NO': 43032,
'SYLOTI NAGRI LETTER O': 43013,
'SYLOTI NAGRI LETTER PHO': 43034,
'SYLOTI NAGRI LETTER PO': 43033,
'SYLOTI NAGRI LETTER RO': 43038,
'SYLOTI NAGRI LETTER RRO': 43040,
'SYLOTI NAGRI LETTER SO': 43041,
'SYLOTI NAGRI LETTER THO': 43029,
'SYLOTI NAGRI LETTER TO': 43028,
'SYLOTI NAGRI LETTER TTHO': 43025,
'SYLOTI NAGRI LETTER TTO': 43024,
'SYLOTI NAGRI LETTER U': 43011,
'SYLOTI NAGRI POETRY MARK-1': 43048,
'SYLOTI NAGRI POETRY MARK-2': 43049,
'SYLOTI NAGRI POETRY MARK-3': 43050,
'SYLOTI NAGRI POETRY MARK-4': 43051,
'SYLOTI NAGRI SIGN ANUSVARA': 43019,
'SYLOTI NAGRI SIGN DVISVARA': 43010,
'SYLOTI NAGRI SIGN HASANTA': 43014,
'SYLOTI NAGRI VOWEL SIGN A': 43043,
'SYLOTI NAGRI VOWEL SIGN E': 43046,
'SYLOTI NAGRI VOWEL SIGN I': 43044,
'SYLOTI NAGRI VOWEL SIGN OO': 43047,
'SYLOTI NAGRI VOWEL SIGN U': 43045,
'SYMBOL FOR ACKNOWLEDGE': 9222,
'SYMBOL FOR BACKSPACE': 9224,
'SYMBOL FOR BELL': 9223,
'SYMBOL FOR CANCEL': 9240,
'SYMBOL FOR CARRIAGE RETURN': 9229,
'SYMBOL FOR DATA LINK ESCAPE': 9232,
'SYMBOL FOR DELETE': 9249,
'SYMBOL FOR DELETE FORM TWO': 9253,
'SYMBOL FOR DEVICE CONTROL FOUR': 9236,
'SYMBOL FOR DEVICE CONTROL ONE': 9233,
'SYMBOL FOR DEVICE CONTROL THREE': 9235,
'SYMBOL FOR DEVICE CONTROL TWO': 9234,
'SYMBOL FOR END OF MEDIUM': 9241,
'SYMBOL FOR END OF TEXT': 9219,
'SYMBOL FOR END OF TRANSMISSION': 9220,
'SYMBOL FOR END OF TRANSMISSION BLOCK': 9239,
'SYMBOL FOR ENQUIRY': 9221,
'SYMBOL FOR ESCAPE': 9243,
'SYMBOL FOR FILE SEPARATOR': 9244,
'SYMBOL FOR FORM FEED': 9228,
'SYMBOL FOR GROUP SEPARATOR': 9245,
'SYMBOL FOR HORIZONTAL TABULATION': 9225,
'SYMBOL FOR LINE FEED': 9226,
'SYMBOL FOR NEGATIVE ACKNOWLEDGE': 9237,
'SYMBOL FOR NEWLINE': 9252,
'SYMBOL FOR NULL': 9216,
'SYMBOL FOR RECORD SEPARATOR': 9246,
'SYMBOL FOR SAMARITAN SOURCE': 8527,
'SYMBOL FOR SHIFT IN': 9231,
'SYMBOL FOR SHIFT OUT': 9230,
'SYMBOL FOR SPACE': 9248,
'SYMBOL FOR START OF HEADING': 9217,
'SYMBOL FOR START OF TEXT': 9218,
'SYMBOL FOR SUBSTITUTE': 9242,
'SYMBOL FOR SUBSTITUTE FORM TWO': 9254,
'SYMBOL FOR SYNCHRONOUS IDLE': 9238,
'SYMBOL FOR UNIT SEPARATOR': 9247,
'SYMBOL FOR VERTICAL TABULATION': 9227,
'SYMMETRY': 9007,
'SYRIAC ABBREVIATION MARK': 1807,
'SYRIAC BARREKH': 1866,
'SYRIAC COLON SKEWED LEFT': 1798,
'SYRIAC COLON SKEWED RIGHT': 1799,
'SYRIAC CONTRACTION': 1802,
'SYRIAC DOTTED ZLAMA ANGULAR': 1849,
'SYRIAC DOTTED ZLAMA HORIZONTAL': 1848,
'SYRIAC END OF PARAGRAPH': 1792,
'SYRIAC ESASA ABOVE': 1853,
'SYRIAC ESASA BELOW': 1854,
'SYRIAC FEMININE DOT': 1856,
'SYRIAC HARKLEAN ASTERISCUS': 1805,
'SYRIAC HARKLEAN METOBELUS': 1804,
'SYRIAC HARKLEAN OBELUS': 1803,
'SYRIAC HBASA ABOVE': 1850,
'SYRIAC HBASA BELOW': 1851,
'SYRIAC HBASA-ESASA DOTTED': 1852,
'SYRIAC HORIZONTAL COLON': 1797,
'SYRIAC LETTER ALAPH': 1808,
'SYRIAC LETTER BETH': 1810,
'SYRIAC LETTER DALATH': 1813,
'SYRIAC LETTER DOTLESS DALATH RISH': 1814,
'SYRIAC LETTER E': 1829,
'SYRIAC LETTER FINAL SEMKATH': 1828,
'SYRIAC LETTER GAMAL': 1811,
'SYRIAC LETTER GAMAL GARSHUNI': 1812,
'SYRIAC LETTER HE': 1815,
'SYRIAC LETTER HETH': 1818,
'SYRIAC LETTER KAPH': 1823,
'SYRIAC LETTER LAMADH': 1824,
'SYRIAC LETTER MIM': 1825,
'SYRIAC LETTER NUN': 1826,
'SYRIAC LETTER PE': 1830,
'SYRIAC LETTER PERSIAN BHETH': 1837,
'SYRIAC LETTER PERSIAN DHALATH': 1839,
'SYRIAC LETTER PERSIAN GHAMAL': 1838,
'SYRIAC LETTER QAPH': 1833,
'SYRIAC LETTER REVERSED PE': 1831,
'SYRIAC LETTER RISH': 1834,
'SYRIAC LETTER SADHE': 1832,
'SYRIAC LETTER SEMKATH': 1827,
'SYRIAC LETTER SHIN': 1835,
'SYRIAC LETTER SOGDIAN FE': 1871,
'SYRIAC LETTER SOGDIAN KHAPH': 1870,
'SYRIAC LETTER SOGDIAN ZHAIN': 1869,
'SYRIAC LETTER SUPERSCRIPT ALAPH': 1809,
'SYRIAC LETTER TAW': 1836,
'SYRIAC LETTER TETH': 1819,
'SYRIAC LETTER TETH GARSHUNI': 1820,
'SYRIAC LETTER WAW': 1816,
'SYRIAC LETTER YUDH': 1821,
'SYRIAC LETTER YUDH HE': 1822,
'SYRIAC LETTER ZAIN': 1817,
'SYRIAC MUSIC': 1865,
'SYRIAC OBLIQUE LINE ABOVE': 1863,
'SYRIAC OBLIQUE LINE BELOW': 1864,
'SYRIAC PTHAHA ABOVE': 1840,
'SYRIAC PTHAHA BELOW': 1841,
'SYRIAC PTHAHA DOTTED': 1842,
'SYRIAC QUSHSHAYA': 1857,
'SYRIAC RBASA ABOVE': 1846,
'SYRIAC RBASA BELOW': 1847,
'SYRIAC RUKKAKHA': 1858,
'SYRIAC RWAHA': 1855,
'SYRIAC SUBLINEAR COLON': 1796,
'SYRIAC SUBLINEAR COLON SKEWED RIGHT': 1801,
'SYRIAC SUBLINEAR FULL STOP': 1794,
'SYRIAC SUPRALINEAR COLON': 1795,
'SYRIAC SUPRALINEAR COLON SKEWED LEFT': 1800,
'SYRIAC SUPRALINEAR FULL STOP': 1793,
'SYRIAC THREE DOTS ABOVE': 1861,
'SYRIAC THREE DOTS BELOW': 1862,
'SYRIAC TWO VERTICAL DOTS ABOVE': 1859,
'SYRIAC TWO VERTICAL DOTS BELOW': 1860,
'SYRIAC ZQAPHA ABOVE': 1843,
'SYRIAC ZQAPHA BELOW': 1844,
'SYRIAC ZQAPHA DOTTED': 1845,
'TAG AMPERSAND': 917542,
'TAG APOSTROPHE': 917543,
'TAG ASTERISK': 917546,
'TAG CIRCUMFLEX ACCENT': 917598,
'TAG COLON': 917562,
'TAG COMMA': 917548,
'TAG COMMERCIAL AT': 917568,
'TAG DIGIT EIGHT': 917560,
'TAG DIGIT FIVE': 917557,
'TAG DIGIT FOUR': 917556,
'TAG DIGIT NINE': 917561,
'TAG DIGIT ONE': 917553,
'TAG DIGIT SEVEN': 917559,
'TAG DIGIT SIX': 917558,
'TAG DIGIT THREE': 917555,
'TAG DIGIT TWO': 917554,
'TAG DIGIT ZERO': 917552,
'TAG DOLLAR SIGN': 917540,
'TAG EQUALS SIGN': 917565,
'TAG EXCLAMATION MARK': 917537,
'TAG FULL STOP': 917550,
'TAG GRAVE ACCENT': 917600,
'TAG GREATER-THAN SIGN': 917566,
'TAG HYPHEN-MINUS': 917549,
'TAG LATIN CAPITAL LETTER A': 917569,
'TAG LATIN CAPITAL LETTER B': 917570,
'TAG LATIN CAPITAL LETTER C': 917571,
'TAG LATIN CAPITAL LETTER D': 917572,
'TAG LATIN CAPITAL LETTER E': 917573,
'TAG LATIN CAPITAL LETTER F': 917574,
'TAG LATIN CAPITAL LETTER G': 917575,
'TAG LATIN CAPITAL LETTER H': 917576,
'TAG LATIN CAPITAL LETTER I': 917577,
'TAG LATIN CAPITAL LETTER J': 917578,
'TAG LATIN CAPITAL LETTER K': 917579,
'TAG LATIN CAPITAL LETTER L': 917580,
'TAG LATIN CAPITAL LETTER M': 917581,
'TAG LATIN CAPITAL LETTER N': 917582,
'TAG LATIN CAPITAL LETTER O': 917583,
'TAG LATIN CAPITAL LETTER P': 917584,
'TAG LATIN CAPITAL LETTER Q': 917585,
'TAG LATIN CAPITAL LETTER R': 917586,
'TAG LATIN CAPITAL LETTER S': 917587,
'TAG LATIN CAPITAL LETTER T': 917588,
'TAG LATIN CAPITAL LETTER U': 917589,
'TAG LATIN CAPITAL LETTER V': 917590,
'TAG LATIN CAPITAL LETTER W': 917591,
'TAG LATIN CAPITAL LETTER X': 917592,
'TAG LATIN CAPITAL LETTER Y': 917593,
'TAG LATIN CAPITAL LETTER Z': 917594,
'TAG LATIN SMALL LETTER A': 917601,
'TAG LATIN SMALL LETTER B': 917602,
'TAG LATIN SMALL LETTER C': 917603,
'TAG LATIN SMALL LETTER D': 917604,
'TAG LATIN SMALL LETTER E': 917605,
'TAG LATIN SMALL LETTER F': 917606,
'TAG LATIN SMALL LETTER G': 917607,
'TAG LATIN SMALL LETTER H': 917608,
'TAG LATIN SMALL LETTER I': 917609,
'TAG LATIN SMALL LETTER J': 917610,
'TAG LATIN SMALL LETTER K': 917611,
'TAG LATIN SMALL LETTER L': 917612,
'TAG LATIN SMALL LETTER M': 917613,
'TAG LATIN SMALL LETTER N': 917614,
'TAG LATIN SMALL LETTER O': 917615,
'TAG LATIN SMALL LETTER P': 917616,
'TAG LATIN SMALL LETTER Q': 917617,
'TAG LATIN SMALL LETTER R': 917618,
'TAG LATIN SMALL LETTER S': 917619,
'TAG LATIN SMALL LETTER T': 917620,
'TAG LATIN SMALL LETTER U': 917621,
'TAG LATIN SMALL LETTER V': 917622,
'TAG LATIN SMALL LETTER W': 917623,
'TAG LATIN SMALL LETTER X': 917624,
'TAG LATIN SMALL LETTER Y': 917625,
'TAG LATIN SMALL LETTER Z': 917626,
'TAG LEFT CURLY BRACKET': 917627,
'TAG LEFT PARENTHESIS': 917544,
'TAG LEFT SQUARE BRACKET': 917595,
'TAG LESS-THAN SIGN': 917564,
'TAG LOW LINE': 917599,
'TAG NUMBER SIGN': 917539,
'TAG PERCENT SIGN': 917541,
'TAG PLUS SIGN': 917547,
'TAG QUESTION MARK': 917567,
'TAG QUOTATION MARK': 917538,
'TAG REVERSE SOLIDUS': 917596,
'TAG RIGHT CURLY BRACKET': 917629,
'TAG RIGHT PARENTHESIS': 917545,
'TAG RIGHT SQUARE BRACKET': 917597,
'TAG SEMICOLON': 917563,
'TAG SOLIDUS': 917551,
'TAG SPACE': 917536,
'TAG TILDE': 917630,
'TAG VERTICAL LINE': 917628,
'TAGALOG LETTER A': 5888,
'TAGALOG LETTER BA': 5898,
'TAGALOG LETTER DA': 5895,
'TAGALOG LETTER GA': 5892,
'TAGALOG LETTER HA': 5905,
'TAGALOG LETTER I': 5889,
'TAGALOG LETTER KA': 5891,
'TAGALOG LETTER LA': 5902,
'TAGALOG LETTER MA': 5899,
'TAGALOG LETTER NA': 5896,
'TAGALOG LETTER NGA': 5893,
'TAGALOG LETTER PA': 5897,
'TAGALOG LETTER SA': 5904,
'TAGALOG LETTER TA': 5894,
'TAGALOG LETTER U': 5890,
'TAGALOG LETTER WA': 5903,
'TAGALOG LETTER YA': 5900,
'TAGALOG SIGN VIRAMA': 5908,
'TAGALOG VOWEL SIGN I': 5906,
'TAGALOG VOWEL SIGN U': 5907,
'TAGBANWA LETTER A': 5984,
'TAGBANWA LETTER BA': 5994,
'TAGBANWA LETTER DA': 5991,
'TAGBANWA LETTER GA': 5988,
'TAGBANWA LETTER I': 5985,
'TAGBANWA LETTER KA': 5987,
'TAGBANWA LETTER LA': 5998,
'TAGBANWA LETTER MA': 5995,
'TAGBANWA LETTER NA': 5992,
'TAGBANWA LETTER NGA': 5989,
'TAGBANWA LETTER PA': 5993,
'TAGBANWA LETTER SA': 6000,
'TAGBANWA LETTER TA': 5990,
'TAGBANWA LETTER U': 5986,
'TAGBANWA LETTER WA': 5999,
'TAGBANWA LETTER YA': 5996,
'TAGBANWA VOWEL SIGN I': 6002,
'TAGBANWA VOWEL SIGN U': 6003,
'TAI LE LETTER A': 6499,
'TAI LE LETTER AI': 6509,
'TAI LE LETTER AUE': 6508,
'TAI LE LETTER E': 6507,
'TAI LE LETTER EE': 6501,
'TAI LE LETTER EH': 6502,
'TAI LE LETTER FA': 6492,
'TAI LE LETTER HA': 6494,
'TAI LE LETTER I': 6500,
'TAI LE LETTER KA': 6480,
'TAI LE LETTER KHA': 6496,
'TAI LE LETTER LA': 6488,
'TAI LE LETTER MA': 6491,
'TAI LE LETTER NA': 6498,
'TAI LE LETTER NGA': 6482,
'TAI LE LETTER O': 6505,
'TAI LE LETTER OO': 6504,
'TAI LE LETTER PA': 6489,
'TAI LE LETTER PHA': 6490,
'TAI LE LETTER QA': 6495,
'TAI LE LETTER SA': 6484,
'TAI LE LETTER TA': 6486,
'TAI LE LETTER THA': 6487,
'TAI LE LETTER TONE-2': 6512,
'TAI LE LETTER TONE-3': 6513,
'TAI LE LETTER TONE-4': 6514,
'TAI LE LETTER TONE-5': 6515,
'TAI LE LETTER TONE-6': 6516,
'TAI LE LETTER TSA': 6483,
'TAI LE LETTER TSHA': 6497,
'TAI LE LETTER U': 6503,
'TAI LE LETTER UE': 6506,
'TAI LE LETTER VA': 6493,
'TAI LE LETTER XA': 6481,
'TAI LE LETTER YA': 6485,
'TAI THAM COMBINING CRYPTOGRAMMIC DOT': 6783,
'TAI THAM CONSONANT SIGN BA': 6749,
'TAI THAM CONSONANT SIGN FINAL NGA': 6745,
'TAI THAM CONSONANT SIGN HIGH RATHA OR LOW PA': 6747,
'TAI THAM CONSONANT SIGN LA TANG LAI': 6743,
'TAI THAM CONSONANT SIGN LOW PA': 6746,
'TAI THAM CONSONANT SIGN MA': 6748,
'TAI THAM CONSONANT SIGN MEDIAL LA': 6742,
'TAI THAM CONSONANT SIGN MEDIAL RA': 6741,
'TAI THAM CONSONANT SIGN SA': 6750,
'TAI THAM HORA DIGIT EIGHT': 6792,
'TAI THAM HORA DIGIT FIVE': 6789,
'TAI THAM HORA DIGIT FOUR': 6788,
'TAI THAM HORA DIGIT NINE': 6793,
'TAI THAM HORA DIGIT ONE': 6785,
'TAI THAM HORA DIGIT SEVEN': 6791,
'TAI THAM HORA DIGIT SIX': 6790,
'TAI THAM HORA DIGIT THREE': 6787,
'TAI THAM HORA DIGIT TWO': 6786,
'TAI THAM HORA DIGIT ZERO': 6784,
'TAI THAM LETTER A': 6731,
'TAI THAM LETTER BA': 6711,
'TAI THAM LETTER DA': 6703,
'TAI THAM LETTER EE': 6737,
'TAI THAM LETTER GREAT SA': 6740,
'TAI THAM LETTER HIGH CA': 6695,
'TAI THAM LETTER HIGH CHA': 6696,
'TAI THAM LETTER HIGH FA': 6714,
'TAI THAM LETTER HIGH HA': 6729,
'TAI THAM LETTER HIGH KA': 6688,
'TAI THAM LETTER HIGH KHA': 6689,
'TAI THAM LETTER HIGH KXA': 6690,
'TAI THAM LETTER HIGH PA': 6712,
'TAI THAM LETTER HIGH PHA': 6713,
'TAI THAM LETTER HIGH RATHA': 6702,
'TAI THAM LETTER HIGH SA': 6728,
'TAI THAM LETTER HIGH SHA': 6726,
'TAI THAM LETTER HIGH SSA': 6727,
'TAI THAM LETTER HIGH TA': 6706,
'TAI THAM LETTER HIGH THA': 6707,
'TAI THAM LETTER HIGH YA': 6720,
'TAI THAM LETTER I': 6733,
'TAI THAM LETTER II': 6734,
'TAI THAM LETTER LA': 6723,
'TAI THAM LETTER LAE': 6739,
'TAI THAM LETTER LLA': 6730,
'TAI THAM LETTER LOW CA': 6697,
'TAI THAM LETTER LOW CHA': 6699,
'TAI THAM LETTER LOW FA': 6716,
'TAI THAM LETTER LOW HA': 6732,
'TAI THAM LETTER LOW KA': 6691,
'TAI THAM LETTER LOW KHA': 6693,
'TAI THAM LETTER LOW KXA': 6692,
'TAI THAM LETTER LOW PA': 6715,
'TAI THAM LETTER LOW PHA': 6717,
'TAI THAM LETTER LOW RATHA': 6704,
'TAI THAM LETTER LOW SA': 6698,
'TAI THAM LETTER LOW TA': 6708,
'TAI THAM LETTER LOW THA': 6709,
'TAI THAM LETTER LOW YA': 6719,
'TAI THAM LETTER LUE': 6724,
'TAI THAM LETTER MA': 6718,
'TAI THAM LETTER NA': 6710,
'TAI THAM LETTER NGA': 6694,
'TAI THAM LETTER NYA': 6700,
'TAI THAM LETTER OO': 6738,
'TAI THAM LETTER RA': 6721,
'TAI THAM LETTER RANA': 6705,
'TAI THAM LETTER RATA': 6701,
'TAI THAM LETTER RUE': 6722,
'TAI THAM LETTER U': 6735,
'TAI THAM LETTER UU': 6736,
'TAI THAM LETTER WA': 6725,
'TAI THAM SIGN CAANG': 6829,
'TAI THAM SIGN DOKMAI': 6821,
'TAI THAM SIGN HANG': 6828,
'TAI THAM SIGN HOY': 6820,
'TAI THAM SIGN KAAN': 6824,
'TAI THAM SIGN KAANKUU': 6825,
'TAI THAM SIGN KEOW': 6819,
'TAI THAM SIGN KHUEN TONE-3': 6775,
'TAI THAM SIGN KHUEN TONE-4': 6776,
'TAI THAM SIGN KHUEN TONE-5': 6777,
'TAI THAM SIGN KHUEN-LUE KARAN': 6780,
'TAI THAM SIGN MAI KANG': 6772,
'TAI THAM SIGN MAI KANG LAI': 6744,
'TAI THAM SIGN MAI SAM': 6779,
'TAI THAM SIGN MAI YAMOK': 6823,
'TAI THAM SIGN RA HAAM': 6778,
'TAI THAM SIGN REVERSED ROTATED RANA': 6822,
'TAI THAM SIGN SAKOT': 6752,
'TAI THAM SIGN SATKAAN': 6826,
'TAI THAM SIGN SATKAANKUU': 6827,
'TAI THAM SIGN SAWAN': 6818,
'TAI THAM SIGN TONE-1': 6773,
'TAI THAM SIGN TONE-2': 6774,
'TAI THAM SIGN WIANG': 6816,
'TAI THAM SIGN WIANGWAAK': 6817,
'TAI THAM THAM DIGIT EIGHT': 6808,
'TAI THAM THAM DIGIT FIVE': 6805,
'TAI THAM THAM DIGIT FOUR': 6804,
'TAI THAM THAM DIGIT NINE': 6809,
'TAI THAM THAM DIGIT ONE': 6801,
'TAI THAM THAM DIGIT SEVEN': 6807,
'TAI THAM THAM DIGIT SIX': 6806,
'TAI THAM THAM DIGIT THREE': 6803,
'TAI THAM THAM DIGIT TWO': 6802,
'TAI THAM THAM DIGIT ZERO': 6800,
'TAI THAM VOWEL SIGN A': 6753,
'TAI THAM VOWEL SIGN AA': 6755,
'TAI THAM VOWEL SIGN AE': 6767,
'TAI THAM VOWEL SIGN AI': 6769,
'TAI THAM VOWEL SIGN E': 6766,
'TAI THAM VOWEL SIGN I': 6757,
'TAI THAM VOWEL SIGN II': 6758,
'TAI THAM VOWEL SIGN MAI SAT': 6754,
'TAI THAM VOWEL SIGN O': 6763,
'TAI THAM VOWEL SIGN OA ABOVE': 6771,
'TAI THAM VOWEL SIGN OA BELOW': 6764,
'TAI THAM VOWEL SIGN OO': 6768,
'TAI THAM VOWEL SIGN OY': 6765,
'TAI THAM VOWEL SIGN TALL AA': 6756,
'TAI THAM VOWEL SIGN THAM AI': 6770,
'TAI THAM VOWEL SIGN U': 6761,
'TAI THAM VOWEL SIGN UE': 6759,
'TAI THAM VOWEL SIGN UU': 6762,
'TAI THAM VOWEL SIGN UUE': 6760,
'TAI VIET LETTER HIGH BO': 43675,
'TAI VIET LETTER HIGH CHO': 43661,
'TAI VIET LETTER HIGH CO': 43659,
'TAI VIET LETTER HIGH DO': 43667,
'TAI VIET LETTER HIGH FO': 43681,
'TAI VIET LETTER HIGH GO': 43655,
'TAI VIET LETTER HIGH HO': 43693,
'TAI VIET LETTER HIGH KHHO': 43653,
'TAI VIET LETTER HIGH KHO': 43651,
'TAI VIET LETTER HIGH KO': 43649,
'TAI VIET LETTER HIGH LO': 43689,
'TAI VIET LETTER HIGH MO': 43683,
'TAI VIET LETTER HIGH NGO': 43657,
'TAI VIET LETTER HIGH NO': 43673,
'TAI VIET LETTER HIGH NYO': 43665,
'TAI VIET LETTER HIGH O': 43695,
'TAI VIET LETTER HIGH PHO': 43679,
'TAI VIET LETTER HIGH PO': 43677,
'TAI VIET LETTER HIGH RO': 43687,
'TAI VIET LETTER HIGH SO': 43663,
'TAI VIET LETTER HIGH THO': 43671,
'TAI VIET LETTER HIGH TO': 43669,
'TAI VIET LETTER HIGH VO': 43691,
'TAI VIET LETTER HIGH YO': 43685,
'TAI VIET LETTER LOW BO': 43674,
'TAI VIET LETTER LOW CHO': 43660,
'TAI VIET LETTER LOW CO': 43658,
'TAI VIET LETTER LOW DO': 43666,
'TAI VIET LETTER LOW FO': 43680,
'TAI VIET LETTER LOW GO': 43654,
'TAI VIET LETTER LOW HO': 43692,
'TAI VIET LETTER LOW KHHO': 43652,
'TAI VIET LETTER LOW KHO': 43650,
'TAI VIET LETTER LOW KO': 43648,
'TAI VIET LETTER LOW LO': 43688,
'TAI VIET LETTER LOW MO': 43682,
'TAI VIET LETTER LOW NGO': 43656,
'TAI VIET LETTER LOW NO': 43672,
'TAI VIET LETTER LOW NYO': 43664,
'TAI VIET LETTER LOW O': 43694,
'TAI VIET LETTER LOW PHO': 43678,
'TAI VIET LETTER LOW PO': 43676,
'TAI VIET LETTER LOW RO': 43686,
'TAI VIET LETTER LOW SO': 43662,
'TAI VIET LETTER LOW THO': 43670,
'TAI VIET LETTER LOW TO': 43668,
'TAI VIET LETTER LOW VO': 43690,
'TAI VIET LETTER LOW YO': 43684,
'TAI VIET MAI KANG': 43696,
'TAI VIET MAI KHIT': 43703,
'TAI VIET SYMBOL HO HOI': 43742,
'TAI VIET SYMBOL KOI KOI': 43743,
'TAI VIET SYMBOL KON': 43739,
'TAI VIET SYMBOL NUENG': 43740,
'TAI VIET SYMBOL SAM': 43741,
'TAI VIET TONE MAI EK': 43711,
'TAI VIET TONE MAI NUENG': 43712,
'TAI VIET TONE MAI SONG': 43714,
'TAI VIET TONE MAI THO': 43713,
'TAI VIET VOWEL AA': 43697,
'TAI VIET VOWEL AM': 43710,
'TAI VIET VOWEL AN': 43709,
'TAI VIET VOWEL AUE': 43707,
'TAI VIET VOWEL AY': 43708,
'TAI VIET VOWEL E': 43701,
'TAI VIET VOWEL I': 43698,
'TAI VIET VOWEL IA': 43704,
'TAI VIET VOWEL O': 43702,
'TAI VIET VOWEL U': 43700,
'TAI VIET VOWEL UA': 43706,
'TAI VIET VOWEL UE': 43699,
'TAI VIET VOWEL UEA': 43705,
'TAMIL AS ABOVE SIGN': 3064,
'TAMIL AU LENGTH MARK': 3031,
'TAMIL CREDIT SIGN': 3063,
'TAMIL DAY SIGN': 3059,
'TAMIL DEBIT SIGN': 3062,
'TAMIL DIGIT EIGHT': 3054,
'TAMIL DIGIT FIVE': 3051,
'TAMIL DIGIT FOUR': 3050,
'TAMIL DIGIT NINE': 3055,
'TAMIL DIGIT ONE': 3047,
'TAMIL DIGIT SEVEN': 3053,
'TAMIL DIGIT SIX': 3052,
'TAMIL DIGIT THREE': 3049,
'TAMIL DIGIT TWO': 3048,
'TAMIL DIGIT ZERO': 3046,
'TAMIL LETTER A': 2949,
'TAMIL LETTER AA': 2950,
'TAMIL LETTER AI': 2960,
'TAMIL LETTER AU': 2964,
'TAMIL LETTER CA': 2970,
'TAMIL LETTER E': 2958,
'TAMIL LETTER EE': 2959,
'TAMIL LETTER HA': 3001,
'TAMIL LETTER I': 2951,
'TAMIL LETTER II': 2952,
'TAMIL LETTER JA': 2972,
'TAMIL LETTER KA': 2965,
'TAMIL LETTER LA': 2994,
'TAMIL LETTER LLA': 2995,
'TAMIL LETTER LLLA': 2996,
'TAMIL LETTER MA': 2990,
'TAMIL LETTER NA': 2984,
'TAMIL LETTER NGA': 2969,
'TAMIL LETTER NNA': 2979,
'TAMIL LETTER NNNA': 2985,
'TAMIL LETTER NYA': 2974,
'TAMIL LETTER O': 2962,
'TAMIL LETTER OO': 2963,
'TAMIL LETTER PA': 2986,
'TAMIL LETTER RA': 2992,
'TAMIL LETTER RRA': 2993,
'TAMIL LETTER SA': 3000,
'TAMIL LETTER SHA': 2998,
'TAMIL LETTER SSA': 2999,
'TAMIL LETTER TA': 2980,
'TAMIL LETTER TTA': 2975,
'TAMIL LETTER U': 2953,
'TAMIL LETTER UU': 2954,
'TAMIL LETTER VA': 2997,
'TAMIL LETTER YA': 2991,
'TAMIL MONTH SIGN': 3060,
'TAMIL NUMBER ONE HUNDRED': 3057,
'TAMIL NUMBER ONE THOUSAND': 3058,
'TAMIL NUMBER SIGN': 3066,
'TAMIL NUMBER TEN': 3056,
'TAMIL OM': 3024,
'TAMIL RUPEE SIGN': 3065,
'TAMIL SIGN ANUSVARA': 2946,
'TAMIL SIGN VIRAMA': 3021,
'TAMIL SIGN VISARGA': 2947,
'TAMIL VOWEL SIGN AA': 3006,
'TAMIL VOWEL SIGN AI': 3016,
'TAMIL VOWEL SIGN AU': 3020,
'TAMIL VOWEL SIGN E': 3014,
'TAMIL VOWEL SIGN EE': 3015,
'TAMIL VOWEL SIGN I': 3007,
'TAMIL VOWEL SIGN II': 3008,
'TAMIL VOWEL SIGN O': 3018,
'TAMIL VOWEL SIGN OO': 3019,
'TAMIL VOWEL SIGN U': 3009,
'TAMIL VOWEL SIGN UU': 3010,
'TAMIL YEAR SIGN': 3061,
'TAPE DRIVE': 9991,
'TAURUS': 9801,
'TEARDROP-BARBED RIGHTWARDS ARROW': 10170,
'TEARDROP-SPOKED ASTERISK': 10043,
'TELEPHONE LOCATION SIGN': 9990,
'TELEPHONE RECORDER': 8981,
'TELEPHONE SIGN': 8481,
'TELUGU AI LENGTH MARK': 3158,
'TELUGU DIGIT EIGHT': 3182,
'TELUGU DIGIT FIVE': 3179,
'TELUGU DIGIT FOUR': 3178,
'TELUGU DIGIT NINE': 3183,
'TELUGU DIGIT ONE': 3175,
'TELUGU DIGIT SEVEN': 3181,
'TELUGU DIGIT SIX': 3180,
'TELUGU DIGIT THREE': 3177,
'TELUGU DIGIT TWO': 3176,
'TELUGU DIGIT ZERO': 3174,
'TELUGU FRACTION DIGIT ONE FOR EVEN POWERS OF FOUR': 3196,
'TELUGU FRACTION DIGIT ONE FOR ODD POWERS OF FOUR': 3193,
'TELUGU FRACTION DIGIT THREE FOR EVEN POWERS OF FOUR': 3198,
'TELUGU FRACTION DIGIT THREE FOR ODD POWERS OF FOUR': 3195,
'TELUGU FRACTION DIGIT TWO FOR EVEN POWERS OF FOUR': 3197,
'TELUGU FRACTION DIGIT TWO FOR ODD POWERS OF FOUR': 3194,
'TELUGU FRACTION DIGIT ZERO FOR ODD POWERS OF FOUR': 3192,
'TELUGU LENGTH MARK': 3157,
'TELUGU LETTER A': 3077,
'TELUGU LETTER AA': 3078,
'TELUGU LETTER AI': 3088,
'TELUGU LETTER AU': 3092,
'TELUGU LETTER BA': 3116,
'TELUGU LETTER BHA': 3117,
'TELUGU LETTER CA': 3098,
'TELUGU LETTER CHA': 3099,
'TELUGU LETTER DA': 3110,
'TELUGU LETTER DDA': 3105,
'TELUGU LETTER DDHA': 3106,
'TELUGU LETTER DHA': 3111,
'TELUGU LETTER DZA': 3161,
'TELUGU LETTER E': 3086,
'TELUGU LETTER EE': 3087,
'TELUGU LETTER GA': 3095,
'TELUGU LETTER GHA': 3096,
'TELUGU LETTER HA': 3129,
'TELUGU LETTER I': 3079,
'TELUGU LETTER II': 3080,
'TELUGU LETTER JA': 3100,
'TELUGU LETTER JHA': 3101,
'TELUGU LETTER KA': 3093,
'TELUGU LETTER KHA': 3094,
'TELUGU LETTER LA': 3122,
'TELUGU LETTER LLA': 3123,
'TELUGU LETTER MA': 3118,
'TELUGU LETTER NA': 3112,
'TELUGU LETTER NGA': 3097,
'TELUGU LETTER NNA': 3107,
'TELUGU LETTER NYA': 3102,
'TELUGU LETTER O': 3090,
'TELUGU LETTER OO': 3091,
'TELUGU LETTER PA': 3114,
'TELUGU LETTER PHA': 3115,
'TELUGU LETTER RA': 3120,
'TELUGU LETTER RRA': 3121,
'TELUGU LETTER SA': 3128,
'TELUGU LETTER SHA': 3126,
'TELUGU LETTER SSA': 3127,
'TELUGU LETTER TA': 3108,
'TELUGU LETTER THA': 3109,
'TELUGU LETTER TSA': 3160,
'TELUGU LETTER TTA': 3103,
'TELUGU LETTER TTHA': 3104,
'TELUGU LETTER U': 3081,
'TELUGU LETTER UU': 3082,
'TELUGU LETTER VA': 3125,
'TELUGU LETTER VOCALIC L': 3084,
'TELUGU LETTER VOCALIC LL': 3169,
'TELUGU LETTER VOCALIC R': 3083,
'TELUGU LETTER VOCALIC RR': 3168,
'TELUGU LETTER YA': 3119,
'TELUGU SIGN ANUSVARA': 3074,
'TELUGU SIGN AVAGRAHA': 3133,
'TELUGU SIGN CANDRABINDU': 3073,
'TELUGU SIGN TUUMU': 3199,
'TELUGU SIGN VIRAMA': 3149,
'TELUGU SIGN VISARGA': 3075,
'TELUGU VOWEL SIGN AA': 3134,
'TELUGU VOWEL SIGN AI': 3144,
'TELUGU VOWEL SIGN AU': 3148,
'TELUGU VOWEL SIGN E': 3142,
'TELUGU VOWEL SIGN EE': 3143,
'TELUGU VOWEL SIGN I': 3135,
'TELUGU VOWEL SIGN II': 3136,
'TELUGU VOWEL SIGN O': 3146,
'TELUGU VOWEL SIGN OO': 3147,
'TELUGU VOWEL SIGN U': 3137,
'TELUGU VOWEL SIGN UU': 3138,
'TELUGU VOWEL SIGN VOCALIC L': 3170,
'TELUGU VOWEL SIGN VOCALIC LL': 3171,
'TELUGU VOWEL SIGN VOCALIC R': 3139,
'TELUGU VOWEL SIGN VOCALIC RR': 3140,
'TENGE SIGN': 8376,
'TENT': 9978,
'TETRAGRAM FOR ACCUMULATION': 119617,
'TETRAGRAM FOR ADVANCE': 119577,
'TETRAGRAM FOR AGGRAVATION': 119633,
'TETRAGRAM FOR ASCENT': 119564,
'TETRAGRAM FOR BARRIER': 119561,
'TETRAGRAM FOR BOLD RESOLUTION': 119587,
'TETRAGRAM FOR BRANCHING OUT': 119566,
'TETRAGRAM FOR CENTRE': 119558,
'TETRAGRAM FOR CHANGE': 119585,
'TETRAGRAM FOR CLOSED MOUTH': 119613,
'TETRAGRAM FOR CLOSENESS': 119590,
'TETRAGRAM FOR CLOSURE': 119631,
'TETRAGRAM FOR COMPLETION': 119630,
'TETRAGRAM FOR COMPLIANCE': 119634,
'TETRAGRAM FOR CONSTANCY': 119608,
'TETRAGRAM FOR CONTACT': 119573,
'TETRAGRAM FOR CONTENTION': 119582,
'TETRAGRAM FOR CONTRARIETY': 119563,
'TETRAGRAM FOR DARKENING': 119624,
'TETRAGRAM FOR DECISIVENESS': 119586,
'TETRAGRAM FOR DEFECTIVENESS OR DISTORTION': 119567,
'TETRAGRAM FOR DEPARTURE': 119623,
'TETRAGRAM FOR DIFFICULTIES': 119636,
'TETRAGRAM FOR DIMINISHMENT': 119612,
'TETRAGRAM FOR DIMMING': 119625,
'TETRAGRAM FOR DIVERGENCE': 119568,
'TETRAGRAM FOR DOUBT': 119619,
'TETRAGRAM FOR DUTIES': 119584,
'TETRAGRAM FOR EASE': 119580,
'TETRAGRAM FOR EMBELLISHMENT': 119618,
'TETRAGRAM FOR ENCOUNTERS': 119600,
'TETRAGRAM FOR ENDEAVOUR': 119583,
'TETRAGRAM FOR ENLARGEMENT': 119603,
'TETRAGRAM FOR ETERNITY': 119610,
'TETRAGRAM FOR EXHAUSTION': 119626,
'TETRAGRAM FOR FAILURE': 119632,
'TETRAGRAM FOR FLIGHT': 119606,
'TETRAGRAM FOR FOLLOWING': 119576,
'TETRAGRAM FOR FOSTERING': 119638,
'TETRAGRAM FOR FULL CIRCLE': 119559,
'TETRAGRAM FOR FULLNESS': 119595,
'TETRAGRAM FOR GATHERING': 119592,
'TETRAGRAM FOR GATHERING IN': 119615,
'TETRAGRAM FOR GOING TO MEET': 119599,
'TETRAGRAM FOR GREATNESS': 119602,
'TETRAGRAM FOR GUARDEDNESS': 119614,
'TETRAGRAM FOR HARDNESS': 119629,
'TETRAGRAM FOR HOLDING BACK': 119574,
'TETRAGRAM FOR INCREASE': 119570,
'TETRAGRAM FOR INNER': 119622,
'TETRAGRAM FOR JOY': 119581,
'TETRAGRAM FOR KEEPING SMALL': 119562,
'TETRAGRAM FOR KINSHIP': 119591,
'TETRAGRAM FOR LABOURING': 119637,
'TETRAGRAM FOR LAW OR MODEL': 119597,
'TETRAGRAM FOR LEGION': 119589,
'TETRAGRAM FOR MASSING': 119616,
'TETRAGRAM FOR MEASURE': 119609,
'TETRAGRAM FOR MIRED': 119560,
'TETRAGRAM FOR ON THE VERGE': 119635,
'TETRAGRAM FOR OPPOSITION': 119565,
'TETRAGRAM FOR PACKING': 119588,
'TETRAGRAM FOR PATTERN': 119604,
'TETRAGRAM FOR PENETRATION': 119571,
'TETRAGRAM FOR PURITY': 119594,
'TETRAGRAM FOR REACH': 119572,
'TETRAGRAM FOR RELEASE': 119578,
'TETRAGRAM FOR RESIDENCE': 119596,
'TETRAGRAM FOR RESISTANCE': 119579,
'TETRAGRAM FOR RESPONSE': 119598,
'TETRAGRAM FOR RITUAL': 119605,
'TETRAGRAM FOR SEVERANCE': 119627,
'TETRAGRAM FOR SINKING': 119621,
'TETRAGRAM FOR STOPPAGE': 119628,
'TETRAGRAM FOR STOVE': 119601,
'TETRAGRAM FOR STRENGTH': 119593,
'TETRAGRAM FOR UNITY': 119611,
'TETRAGRAM FOR VASTNESS OR WASTING': 119607,
'TETRAGRAM FOR WAITING': 119575,
'TETRAGRAM FOR WATCH': 119620,
'TETRAGRAM FOR YOUTHFULNESS': 119569,
'THAANA AABAAFILI': 1959,
'THAANA ABAFILI': 1958,
'THAANA EBEFILI': 1964,
'THAANA EEBEEFILI': 1961,
'THAANA EYBEYFILI': 1965,
'THAANA IBIFILI': 1960,
'THAANA LETTER AINU': 1954,
'THAANA LETTER ALIFU': 1927,
'THAANA LETTER BAA': 1924,
'THAANA LETTER CHAVIYANI': 1943,
'THAANA LETTER DAADHU': 1951,
'THAANA LETTER DAVIYANI': 1937,
'THAANA LETTER DHAALU': 1931,
'THAANA LETTER FAAFU': 1930,
'THAANA LETTER GAAFU': 1934,
'THAANA LETTER GHAINU': 1955,
'THAANA LETTER GNAVIYANI': 1935,
'THAANA LETTER HAA': 1920,
'THAANA LETTER HHAA': 1945,
'THAANA LETTER JAVIYANI': 1942,
'THAANA LETTER KAAFU': 1926,
'THAANA LETTER KHAA': 1946,
'THAANA LETTER LAAMU': 1933,
'THAANA LETTER LHAVIYANI': 1925,
'THAANA LETTER MEEMU': 1929,
'THAANA LETTER NAA': 1969,
'THAANA LETTER NOONU': 1922,
'THAANA LETTER PAVIYANI': 1941,
'THAANA LETTER QAAFU': 1956,
'THAANA LETTER RAA': 1923,
'THAANA LETTER SAADHU': 1950,
'THAANA LETTER SEENU': 1936,
'THAANA LETTER SHAVIYANI': 1921,
'THAANA LETTER SHEENU': 1949,
'THAANA LETTER TAVIYANI': 1939,
'THAANA LETTER THAA': 1932,
'THAANA LETTER THAALU': 1947,
'THAANA LETTER TO': 1952,
'THAANA LETTER TTAA': 1944,
'THAANA LETTER VAAVU': 1928,
'THAANA LETTER WAAVU': 1957,
'THAANA LETTER YAA': 1940,
'THAANA LETTER ZAA': 1948,
'THAANA LETTER ZAVIYANI': 1938,
'THAANA LETTER ZO': 1953,
'THAANA OABOAFILI': 1967,
'THAANA OBOFILI': 1966,
'THAANA OOBOOFILI': 1963,
'THAANA SUKUN': 1968,
'THAANA UBUFILI': 1962,
'THAI CHARACTER ANGKHANKHU': 3674,
'THAI CHARACTER BO BAIMAI': 3610,
'THAI CHARACTER CHO CHAN': 3592,
'THAI CHARACTER CHO CHANG': 3594,
'THAI CHARACTER CHO CHING': 3593,
'THAI CHARACTER CHO CHOE': 3596,
'THAI CHARACTER DO CHADA': 3598,
'THAI CHARACTER DO DEK': 3604,
'THAI CHARACTER FO FA': 3613,
'THAI CHARACTER FO FAN': 3615,
'THAI CHARACTER FONGMAN': 3663,
'THAI CHARACTER HO HIP': 3627,
'THAI CHARACTER HO NOKHUK': 3630,
'THAI CHARACTER KHO KHAI': 3586,
'THAI CHARACTER KHO KHON': 3589,
'THAI CHARACTER KHO KHUAT': 3587,
'THAI CHARACTER KHO KHWAI': 3588,
'THAI CHARACTER KHO RAKHANG': 3590,
'THAI CHARACTER KHOMUT': 3675,
'THAI CHARACTER KO KAI': 3585,
'THAI CHARACTER LAKKHANGYAO': 3653,
'THAI CHARACTER LO CHULA': 3628,
'THAI CHARACTER LO LING': 3621,
'THAI CHARACTER LU': 3622,
'THAI CHARACTER MAI CHATTAWA': 3659,
'THAI CHARACTER MAI EK': 3656,
'THAI CHARACTER MAI HAN-AKAT': 3633,
'THAI CHARACTER MAI THO': 3657,
'THAI CHARACTER MAI TRI': 3658,
'THAI CHARACTER MAITAIKHU': 3655,
'THAI CHARACTER MAIYAMOK': 3654,
'THAI CHARACTER MO MA': 3617,
'THAI CHARACTER NGO NGU': 3591,
'THAI CHARACTER NIKHAHIT': 3661,
'THAI CHARACTER NO NEN': 3603,
'THAI CHARACTER NO NU': 3609,
'THAI CHARACTER O ANG': 3629,
'THAI CHARACTER PAIYANNOI': 3631,
'THAI CHARACTER PHINTHU': 3642,
'THAI CHARACTER PHO PHAN': 3614,
'THAI CHARACTER PHO PHUNG': 3612,
'THAI CHARACTER PHO SAMPHAO': 3616,
'THAI CHARACTER PO PLA': 3611,
'THAI CHARACTER RO RUA': 3619,
'THAI CHARACTER RU': 3620,
'THAI CHARACTER SARA A': 3632,
'THAI CHARACTER SARA AA': 3634,
'THAI CHARACTER SARA AE': 3649,
'THAI CHARACTER SARA AI MAIMALAI': 3652,
'THAI CHARACTER SARA AI MAIMUAN': 3651,
'THAI CHARACTER SARA AM': 3635,
'THAI CHARACTER SARA E': 3648,
'THAI CHARACTER SARA I': 3636,
'THAI CHARACTER SARA II': 3637,
'THAI CHARACTER SARA O': 3650,
'THAI CHARACTER SARA U': 3640,
'THAI CHARACTER SARA UE': 3638,
'THAI CHARACTER SARA UEE': 3639,
'THAI CHARACTER SARA UU': 3641,
'THAI CHARACTER SO RUSI': 3625,
'THAI CHARACTER SO SALA': 3624,
'THAI CHARACTER SO SO': 3595,
'THAI CHARACTER SO SUA': 3626,
'THAI CHARACTER THANTHAKHAT': 3660,
'THAI CHARACTER THO NANGMONTHO': 3601,
'THAI CHARACTER THO PHUTHAO': 3602,
'THAI CHARACTER THO THAHAN': 3607,
'THAI CHARACTER THO THAN': 3600,
'THAI CHARACTER THO THONG': 3608,
'THAI CHARACTER THO THUNG': 3606,
'THAI CHARACTER TO PATAK': 3599,
'THAI CHARACTER TO TAO': 3605,
'THAI CHARACTER WO WAEN': 3623,
'THAI CHARACTER YAMAKKAN': 3662,
'THAI CHARACTER YO YAK': 3618,
'THAI CHARACTER YO YING': 3597,
'THAI CURRENCY SYMBOL BAHT': 3647,
'THAI DIGIT EIGHT': 3672,
'THAI DIGIT FIVE': 3669,
'THAI DIGIT FOUR': 3668,
'THAI DIGIT NINE': 3673,
'THAI DIGIT ONE': 3665,
'THAI DIGIT SEVEN': 3671,
'THAI DIGIT SIX': 3670,
'THAI DIGIT THREE': 3667,
'THAI DIGIT TWO': 3666,
'THAI DIGIT ZERO': 3664,
'THERE DOES NOT EXIST': 8708,
'THERE EXISTS': 8707,
'THEREFORE': 8756,
'THERMODYNAMIC': 10727,
'THIN SPACE': 8201,
'THREE CONSECUTIVE EQUALS SIGNS': 10870,
'THREE DIMENSIONAL ANGLE': 10176,
'THREE DOT PUNCTUATION': 8278,
'THREE LEFTWARDS ARROWS': 11057,
'THREE LINES CONVERGING LEFT': 9887,
'THREE LINES CONVERGING RIGHT': 9886,
'THREE RIGHTWARDS ARROWS': 8694,
'THREE-D BOTTOM-LIGHTED RIGHTWARDS ARROWHEAD': 10147,
'THREE-D TOP-LIGHTED RIGHTWARDS ARROWHEAD': 10146,
'THREE-PER-EM SPACE': 8196,
'THUNDER CLOUD AND RAIN': 9928,
'THUNDERSTORM': 9736,
'TIBETAN ASTROLOGICAL SIGN -KHYUD PA': 3864,
'TIBETAN ASTROLOGICAL SIGN SDONG TSHUGS': 3865,
'TIBETAN ASTROLOGICAL SIGN SGRA GCAN -CHAR RTAGS': 3863,
'TIBETAN CANTILLATION SIGN CANG TE-U': 4034,
'TIBETAN CANTILLATION SIGN HEAVY BEAT': 4032,
'TIBETAN CANTILLATION SIGN LIGHT BEAT': 4033,
'TIBETAN CANTILLATION SIGN SBUB -CHAL': 4035,
'TIBETAN DIGIT EIGHT': 3880,
'TIBETAN DIGIT FIVE': 3877,
'TIBETAN DIGIT FOUR': 3876,
'TIBETAN DIGIT HALF EIGHT': 3889,
'TIBETAN DIGIT HALF FIVE': 3886,
'TIBETAN DIGIT HALF FOUR': 3885,
'TIBETAN DIGIT HALF NINE': 3890,
'TIBETAN DIGIT HALF ONE': 3882,
'TIBETAN DIGIT HALF SEVEN': 3888,
'TIBETAN DIGIT HALF SIX': 3887,
'TIBETAN DIGIT HALF THREE': 3884,
'TIBETAN DIGIT HALF TWO': 3883,
'TIBETAN DIGIT HALF ZERO': 3891,
'TIBETAN DIGIT NINE': 3881,
'TIBETAN DIGIT ONE': 3873,
'TIBETAN DIGIT SEVEN': 3879,
'TIBETAN DIGIT SIX': 3878,
'TIBETAN DIGIT THREE': 3875,
'TIBETAN DIGIT TWO': 3874,
'TIBETAN DIGIT ZERO': 3872,
'TIBETAN KU RU KHA': 4030,
'TIBETAN KU RU KHA BZHI MIG CAN': 4031,
'TIBETAN LETTER -A': 3936,
'TIBETAN LETTER A': 3944,
'TIBETAN LETTER BA': 3926,
'TIBETAN LETTER BHA': 3927,
'TIBETAN LETTER CA': 3909,
'TIBETAN LETTER CHA': 3910,
'TIBETAN LETTER DA': 3921,
'TIBETAN LETTER DDA': 3916,
'TIBETAN LETTER DDHA': 3917,
'TIBETAN LETTER DHA': 3922,
'TIBETAN LETTER DZA': 3931,
'TIBETAN LETTER DZHA': 3932,
'TIBETAN LETTER FIXED-FORM RA': 3946,
'TIBETAN LETTER GA': 3906,
'TIBETAN LETTER GHA': 3907,
'TIBETAN LETTER HA': 3943,
'TIBETAN LETTER JA': 3911,
'TIBETAN LETTER KA': 3904,
'TIBETAN LETTER KHA': 3905,
'TIBETAN LETTER KKA': 3947,
'TIBETAN LETTER KSSA': 3945,
'TIBETAN LETTER LA': 3939,
'TIBETAN LETTER MA': 3928,
'TIBETAN LETTER NA': 3923,
'TIBETAN LETTER NGA': 3908,
'TIBETAN LETTER NNA': 3918,
'TIBETAN LETTER NYA': 3913,
'TIBETAN LETTER PA': 3924,
'TIBETAN LETTER PHA': 3925,
'TIBETAN LETTER RA': 3938,
'TIBETAN LETTER RRA': 3948,
'TIBETAN LETTER SA': 3942,
'TIBETAN LETTER SHA': 3940,
'TIBETAN LETTER SSA': 3941,
'TIBETAN LETTER TA': 3919,
'TIBETAN LETTER THA': 3920,
'TIBETAN LETTER TSA': 3929,
'TIBETAN LETTER TSHA': 3930,
'TIBETAN LETTER TTA': 3914,
'TIBETAN LETTER TTHA': 3915,
'TIBETAN LETTER WA': 3933,
'TIBETAN LETTER YA': 3937,
'TIBETAN LETTER ZA': 3935,
'TIBETAN LETTER ZHA': 3934,
'TIBETAN LOGOTYPE SIGN CHAD RTAGS': 3861,
'TIBETAN LOGOTYPE SIGN LHAG RTAGS': 3862,
'TIBETAN MARK ANG KHANG GYAS': 3901,
'TIBETAN MARK ANG KHANG GYON': 3900,
'TIBETAN MARK BKA- SHOG YIG MGO': 3850,
'TIBETAN MARK BSDUS RTAGS': 3892,
'TIBETAN MARK BSKA- SHOG GI MGO RGYAN': 4048,
'TIBETAN MARK BSKUR YIG MGO': 3849,
'TIBETAN MARK CARET -DZUD RTAGS BZHI MIG CAN': 3894,
'TIBETAN MARK CARET -DZUD RTAGS ME LONG CAN': 3859,
'TIBETAN MARK CARET YIG MGO PHUR SHAD MA': 3846,
'TIBETAN MARK CHE MGO': 3896,
'TIBETAN MARK CLOSING BRDA RNYING YIG MGO SGAB MA': 4052,
'TIBETAN MARK CLOSING YIG MGO SGAB MA': 3845,
'TIBETAN MARK DELIMITER TSHEG BSTAR': 3852,
'TIBETAN MARK GTER TSHEG': 3860,
'TIBETAN MARK GTER YIG MGO -UM GTER TSHEG MA': 3843,
'TIBETAN MARK GTER YIG MGO -UM RNAM BCAD MA': 3842,
'TIBETAN MARK GTER YIG MGO TRUNCATED A': 3841,
'TIBETAN MARK GUG RTAGS GYAS': 3899,
'TIBETAN MARK GUG RTAGS GYON': 3898,
'TIBETAN MARK HALANTA': 3972,
'TIBETAN MARK INITIAL BRDA RNYING YIG MGO MDUN MA': 4051,
'TIBETAN MARK INITIAL YIG MGO MDUN MA': 3844,
'TIBETAN MARK INTERSYLLABIC TSHEG': 3851,
'TIBETAN MARK MNYAM YIG GI MGO RGYAN': 4049,
'TIBETAN MARK NGAS BZUNG NYI ZLA': 3893,
'TIBETAN MARK NGAS BZUNG SGOR RTAGS': 3895,
'TIBETAN MARK NYIS SHAD': 3854,
'TIBETAN MARK NYIS TSHEG': 4050,
'TIBETAN MARK NYIS TSHEG SHAD': 3856,
'TIBETAN MARK PALUTA': 3973,
'TIBETAN MARK RGYA GRAM SHAD': 3858,
'TIBETAN MARK RIN CHEN SPUNGS SHAD': 3857,
'TIBETAN MARK SBRUL SHAD': 3848,
'TIBETAN MARK SHAD': 3853,
'TIBETAN MARK TSA -PHRU': 3897,
'TIBETAN MARK TSHEG SHAD': 3855,
'TIBETAN MARK YIG MGO TSHEG SHAD MA': 3847,
'TIBETAN SIGN GRU CAN RGYINGS': 3978,
'TIBETAN SIGN GRU MED RGYINGS': 3979,
'TIBETAN SIGN LCE TSA CAN': 3976,
'TIBETAN SIGN LCI RTAGS': 3974,
'TIBETAN SIGN MAR TSHES': 3903,
'TIBETAN SIGN MCHU CAN': 3977,
'TIBETAN SIGN NYI ZLA NAA DA': 3970,
'TIBETAN SIGN RDEL DKAR GCIG': 3866,
'TIBETAN SIGN RDEL DKAR GNYIS': 3867,
'TIBETAN SIGN RDEL DKAR GSUM': 3868,
'TIBETAN SIGN RDEL DKAR RDEL NAG': 3871,
'TIBETAN SIGN RDEL NAG GCIG': 3869,
'TIBETAN SIGN RDEL NAG GNYIS': 3870,
'TIBETAN SIGN RDEL NAG GSUM': 4047,
'TIBETAN SIGN RDEL NAG RDEL DKAR': 4046,
'TIBETAN SIGN RJES SU NGA RO': 3966,
'TIBETAN SIGN RNAM BCAD': 3967,
'TIBETAN SIGN SNA LDAN': 3971,
'TIBETAN SIGN YANG RTAGS': 3975,
'TIBETAN SIGN YAR TSHES': 3902,
'TIBETAN SUBJOINED LETTER -A': 4016,
'TIBETAN SUBJOINED LETTER A': 4024,
'TIBETAN SUBJOINED LETTER BA': 4006,
'TIBETAN SUBJOINED LETTER BHA': 4007,
'TIBETAN SUBJOINED LETTER CA': 3989,
'TIBETAN SUBJOINED LETTER CHA': 3990,
'TIBETAN SUBJOINED LETTER DA': 4001,
'TIBETAN SUBJOINED LETTER DDA': 3996,
'TIBETAN SUBJOINED LETTER DDHA': 3997,
'TIBETAN SUBJOINED LETTER DHA': 4002,
'TIBETAN SUBJOINED LETTER DZA': 4011,
'TIBETAN SUBJOINED LETTER DZHA': 4012,
'TIBETAN SUBJOINED LETTER FIXED-FORM RA': 4028,
'TIBETAN SUBJOINED LETTER FIXED-FORM WA': 4026,
'TIBETAN SUBJOINED LETTER FIXED-FORM YA': 4027,
'TIBETAN SUBJOINED LETTER GA': 3986,
'TIBETAN SUBJOINED LETTER GHA': 3987,
'TIBETAN SUBJOINED LETTER HA': 4023,
'TIBETAN SUBJOINED LETTER JA': 3991,
'TIBETAN SUBJOINED LETTER KA': 3984,
'TIBETAN SUBJOINED LETTER KHA': 3985,
'TIBETAN SUBJOINED LETTER KSSA': 4025,
'TIBETAN SUBJOINED LETTER LA': 4019,
'TIBETAN SUBJOINED LETTER MA': 4008,
'TIBETAN SUBJOINED LETTER NA': 4003,
'TIBETAN SUBJOINED LETTER NGA': 3988,
'TIBETAN SUBJOINED LETTER NNA': 3998,
'TIBETAN SUBJOINED LETTER NYA': 3993,
'TIBETAN SUBJOINED LETTER PA': 4004,
'TIBETAN SUBJOINED LETTER PHA': 4005,
'TIBETAN SUBJOINED LETTER RA': 4018,
'TIBETAN SUBJOINED LETTER SA': 4022,
'TIBETAN SUBJOINED LETTER SHA': 4020,
'TIBETAN SUBJOINED LETTER SSA': 4021,
'TIBETAN SUBJOINED LETTER TA': 3999,
'TIBETAN SUBJOINED LETTER THA': 4000,
'TIBETAN SUBJOINED LETTER TSA': 4009,
'TIBETAN SUBJOINED LETTER TSHA': 4010,
'TIBETAN SUBJOINED LETTER TTA': 3994,
'TIBETAN SUBJOINED LETTER TTHA': 3995,
'TIBETAN SUBJOINED LETTER WA': 4013,
'TIBETAN SUBJOINED LETTER YA': 4017,
'TIBETAN SUBJOINED LETTER ZA': 4015,
'TIBETAN SUBJOINED LETTER ZHA': 4014,
'TIBETAN SYLLABLE OM': 3840,
'TIBETAN SYMBOL DRIL BU': 4036,
'TIBETAN SYMBOL NOR BU': 4041,
'TIBETAN SYMBOL NOR BU BZHI -KHYIL': 4044,
'TIBETAN SYMBOL NOR BU GSUM -KHYIL': 4043,
'TIBETAN SYMBOL NOR BU NYIS -KHYIL': 4042,
'TIBETAN SYMBOL PADMA GDAN': 4038,
'TIBETAN SYMBOL PHUR PA': 4040,
'TIBETAN SYMBOL RDO RJE': 4037,
'TIBETAN SYMBOL RDO RJE RGYA GRAM': 4039,
'TIBETAN VOWEL SIGN AA': 3953,
'TIBETAN VOWEL SIGN E': 3962,
'TIBETAN VOWEL SIGN EE': 3963,
'TIBETAN VOWEL SIGN I': 3954,
'TIBETAN VOWEL SIGN II': 3955,
'TIBETAN VOWEL SIGN O': 3964,
'TIBETAN VOWEL SIGN OO': 3965,
'TIBETAN VOWEL SIGN REVERSED I': 3968,
'TIBETAN VOWEL SIGN REVERSED II': 3969,
'TIBETAN VOWEL SIGN U': 3956,
'TIBETAN VOWEL SIGN UU': 3957,
'TIBETAN VOWEL SIGN VOCALIC L': 3960,
'TIBETAN VOWEL SIGN VOCALIC LL': 3961,
'TIBETAN VOWEL SIGN VOCALIC R': 3958,
'TIBETAN VOWEL SIGN VOCALIC RR': 3959,
'TIE OVER INFINITY': 10717,
'TIFINAGH LETTER AHAGGAR YAZH': 11595,
'TIFINAGH LETTER AYER YAGH': 11608,
'TIFINAGH LETTER BERBER ACADEMY YAH': 11585,
'TIFINAGH LETTER BERBER ACADEMY YAJ': 11573,
'TIFINAGH LETTER TAWELLEMET YAZ': 11620,
'TIFINAGH LETTER TUAREG YAGH': 11607,
'TIFINAGH LETTER TUAREG YAGN': 11600,
'TIFINAGH LETTER TUAREG YAH': 11586,
'TIFINAGH LETTER TUAREG YAK': 11582,
'TIFINAGH LETTER TUAREG YAKH': 11590,
'TIFINAGH LETTER TUAREG YANG': 11601,
'TIFINAGH LETTER TUAREG YAQ': 11592,
'TIFINAGH LETTER TUAREG YAZH': 11596,
'TIFINAGH LETTER YA': 11568,
'TIFINAGH LETTER YAA': 11588,
'TIFINAGH LETTER YAB': 11569,
'TIFINAGH LETTER YABH': 11570,
'TIFINAGH LETTER YACH': 11614,
'TIFINAGH LETTER YAD': 11575,
'TIFINAGH LETTER YADD': 11577,
'TIFINAGH LETTER YADDH': 11578,
'TIFINAGH LETTER YADH': 11576,
'TIFINAGH LETTER YAF': 11580,
'TIFINAGH LETTER YAG': 11571,
'TIFINAGH LETTER YAGH': 11606,
'TIFINAGH LETTER YAGHH': 11572,
'TIFINAGH LETTER YAH': 11584,
'TIFINAGH LETTER YAHH': 11587,
'TIFINAGH LETTER YAJ': 11574,
'TIFINAGH LETTER YAK': 11581,
'TIFINAGH LETTER YAKH': 11589,
'TIFINAGH LETTER YAKHH': 11583,
'TIFINAGH LETTER YAL': 11597,
'TIFINAGH LETTER YAM': 11598,
'TIFINAGH LETTER YAN': 11599,
'TIFINAGH LETTER YAP': 11602,
'TIFINAGH LETTER YAQ': 11591,
'TIFINAGH LETTER YAR': 11604,
'TIFINAGH LETTER YARR': 11605,
'TIFINAGH LETTER YAS': 11609,
'TIFINAGH LETTER YASH': 11611,
'TIFINAGH LETTER YASS': 11610,
'TIFINAGH LETTER YAT': 11612,
'TIFINAGH LETTER YATH': 11613,
'TIFINAGH LETTER YATT': 11615,
'TIFINAGH LETTER YAV': 11616,
'TIFINAGH LETTER YAW': 11617,
'TIFINAGH LETTER YAY': 11618,
'TIFINAGH LETTER YAZ': 11619,
'TIFINAGH LETTER YAZH': 11594,
'TIFINAGH LETTER YAZZ': 11621,
'TIFINAGH LETTER YEY': 11579,
'TIFINAGH LETTER YI': 11593,
'TIFINAGH LETTER YU': 11603,
'TIFINAGH MODIFIER LETTER LABIALIZATION MARK': 11631,
'TIGHT TRIFOLIATE SNOWFLAKE': 10053,
'TILDE': 126,
'TILDE OPERATOR': 8764,
'TILDE OPERATOR ABOVE LEFTWARDS ARROW': 11081,
'TILDE OPERATOR ABOVE RIGHTWARDS ARROW': 10610,
'TILDE OPERATOR WITH DOT ABOVE': 10858,
'TILDE OPERATOR WITH RISING DOTS': 10859,
'TILDE WITH DOT ABOVE': 11806,
'TILDE WITH DOT BELOW': 11807,
'TILDE WITH RING ABOVE': 11803,
'TIMES WITH LEFT HALF BLACK': 10708,
'TIMES WITH RIGHT HALF BLACK': 10709,
'TINY': 10750,
'TINY TWO DOTS OVER ONE DOT PUNCTUATION': 68410,
'TIRONIAN SIGN ET': 8266,
'TOP ARC ANTICLOCKWISE ARROW': 10554,
'TOP ARC ANTICLOCKWISE ARROW WITH PLUS': 10557,
'TOP ARC CLOCKWISE ARROW WITH MINUS': 10556,
'TOP CURLY BRACKET': 9182,
'TOP HALF INTEGRAL': 8992,
'TOP LEFT CORNER': 8988,
'TOP LEFT CROP': 8975,
'TOP LEFT HALF BRACKET': 11810,
'TOP PARENTHESIS': 9180,
'TOP RIGHT CORNER': 8989,
'TOP RIGHT CROP': 8974,
'TOP RIGHT HALF BRACKET': 11811,
'TOP SQUARE BRACKET': 9140,
'TOP TORTOISE SHELL BRACKET': 9184,
'TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-4E09': 127553,
'TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-4E8C': 127554,
'TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-52DD': 127559,
'TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-5B89': 127555,
'TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-6253': 127557,
'TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-6557': 127560,
'TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-672C': 127552,
'TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-70B9': 127556,
'TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-76D7': 127558,
'TORTOISE SHELL BRACKETED LATIN CAPITAL LETTER S': 127274,
'TOTAL RUNOUT': 9008,
'TRADE MARK SIGN': 8482,
'TRANSVERSAL INTERSECTION': 10971,
'TRIANGLE WITH DOT ABOVE': 10698,
'TRIANGLE WITH SERIFS AT BOTTOM': 10701,
'TRIANGLE WITH UNDERBAR': 10699,
'TRIANGLE-HEADED RIGHTWARDS ARROW': 10141,
'TRIANGULAR BULLET': 8227,
'TRICOLON': 8285,
'TRIGRAM FOR EARTH': 9783,
'TRIGRAM FOR FIRE': 9778,
'TRIGRAM FOR HEAVEN': 9776,
'TRIGRAM FOR LAKE': 9777,
'TRIGRAM FOR MOUNTAIN': 9782,
'TRIGRAM FOR THUNDER': 9779,
'TRIGRAM FOR WATER': 9781,
'TRIGRAM FOR WIND': 9780,
'TRIPLE COLON OPERATOR': 10998,
'TRIPLE HORIZONTAL BAR WITH DOUBLE VERTICAL STROKE': 10856,
'TRIPLE HORIZONTAL BAR WITH TRIPLE VERTICAL STROKE': 10857,
'TRIPLE INTEGRAL': 8749,
'TRIPLE NESTED GREATER-THAN': 11000,
'TRIPLE NESTED LESS-THAN': 10999,
'TRIPLE PLUS': 10747,
'TRIPLE PRIME': 8244,
'TRIPLE SOLIDUS BINARY RELATION': 11003,
'TRIPLE TILDE': 8779,
'TRIPLE VERTICAL BAR BINARY RELATION': 10996,
'TRIPLE VERTICAL BAR DELIMITER': 10624,
'TRIPLE VERTICAL BAR RIGHT TURNSTILE': 8874,
'TRIPLE VERTICAL BAR WITH HORIZONTAL STROKE': 10997,
'TRUE': 8872,
'TUGRIK SIGN': 8366,
'TURNED AMPERSAND': 8523,
'TURNED ANGLE': 10658,
'TURNED BLACK SHOGI PIECE': 9930,
'TURNED CAPITAL F': 8498,
'TURNED GREEK SMALL LETTER IOTA': 8489,
'TURNED NOT SIGN': 8985,
'TURNED SANS-SERIF CAPITAL G': 8513,
'TURNED SANS-SERIF CAPITAL L': 8514,
'TURNED SANS-SERIF CAPITAL Y': 8516,
'TURNED SMALL F': 8526,
'TURNED WHITE SHOGI PIECE': 9929,
'TWELVE POINTED BLACK STAR': 10041,
'TWO ASTERISKS ALIGNED VERTICALLY': 8273,
'TWO CONSECUTIVE EQUALS SIGNS': 10869,
'TWO DOT LEADER': 8229,
'TWO DOT PUNCTUATION': 8282,
'TWO DOTS OVER ONE DOT PUNCTUATION': 11818,
'TWO INTERSECTING LOGICAL AND': 10837,
'TWO INTERSECTING LOGICAL OR': 10838,
'TWO JOINED SQUARES': 10697,
'TWO LOGICAL AND OPERATOR': 10759,
'TWO LOGICAL OR OPERATOR': 10760,
'UGARITIC LETTER AIN': 66451,
'UGARITIC LETTER ALPA': 66432,
'UGARITIC LETTER BETA': 66433,
'UGARITIC LETTER DELTA': 66436,
'UGARITIC LETTER DHAL': 66447,
'UGARITIC LETTER GAMLA': 66434,
'UGARITIC LETTER GHAIN': 66457,
'UGARITIC LETTER HO': 66437,
'UGARITIC LETTER HOTA': 66440,
'UGARITIC LETTER I': 66459,
'UGARITIC LETTER KAF': 66443,
'UGARITIC LETTER KHA': 66435,
'UGARITIC LETTER LAMDA': 66445,
'UGARITIC LETTER MEM': 66446,
'UGARITIC LETTER NUN': 66448,
'UGARITIC LETTER PU': 66452,
'UGARITIC LETTER QOPA': 66454,
'UGARITIC LETTER RASHA': 66455,
'UGARITIC LETTER SADE': 66453,
'UGARITIC LETTER SAMKA': 66450,
'UGARITIC LETTER SHIN': 66444,
'UGARITIC LETTER SSU': 66461,
'UGARITIC LETTER TET': 66441,
'UGARITIC LETTER THANNA': 66456,
'UGARITIC LETTER TO': 66458,
'UGARITIC LETTER U': 66460,
'UGARITIC LETTER WO': 66438,
'UGARITIC LETTER YOD': 66442,
'UGARITIC LETTER ZETA': 66439,
'UGARITIC LETTER ZU': 66449,
'UGARITIC WORD DIVIDER': 66463,
'UMBRELLA': 9730,
'UMBRELLA ON GROUND': 9969,
'UMBRELLA WITH RAIN DROPS': 9748,
'UNDERTIE': 8255,
'UNDO SYMBOL': 9100,
'UNION': 8746,
'UNION ABOVE BAR ABOVE INTERSECTION': 10824,
'UNION ABOVE INTERSECTION': 10822,
'UNION BESIDE AND JOINED WITH UNION': 10826,
'UNION WITH LOGICAL OR': 10821,
'UNION WITH MINUS SIGN': 10817,
'UNION WITH OVERBAR': 10818,
'UNIVERSAL RECYCLING SYMBOL': 9842,
'UNMARRIED PARTNERSHIP SYMBOL': 9903,
'UP ARROW THROUGH CIRCLE': 10685,
'UP ARROWHEAD': 8963,
'UP ARROWHEAD BETWEEN TWO HORIZONTAL BARS': 8996,
'UP BARB LEFT DOWN BARB LEFT HARPOON': 10577,
'UP BARB LEFT DOWN BARB RIGHT HARPOON': 10573,
'UP BARB RIGHT DOWN BARB LEFT HARPOON': 10572,
'UP BARB RIGHT DOWN BARB RIGHT HARPOON': 10575,
'UP DOWN ARROW': 8597,
'UP DOWN ARROW WITH BASE': 8616,
'UP DOWN BLACK ARROW': 11021,
'UP DOWN DOUBLE ARROW': 8661,
'UP DOWN WHITE ARROW': 8691,
'UP FISH TAIL': 10622,
'UP RIGHT DIAGONAL ELLIPSIS': 8944,
'UP TACK': 8869,
'UP TACK WITH CIRCLE ABOVE': 10207,
'UP-POINTING TRIANGLE WITH LEFT HALF BLACK': 9709,
'UP-POINTING TRIANGLE WITH RIGHT HALF BLACK': 9710,
'UPPER BLADE SCISSORS': 9985,
'UPPER HALF BLOCK': 9600,
'UPPER HALF CIRCLE': 9696,
'UPPER HALF INVERSE WHITE CIRCLE': 9690,
'UPPER LEFT CORNER WITH DOT': 10196,
'UPPER LEFT OR LOWER RIGHT CURLY BRACKET SECTION': 9136,
'UPPER LEFT QUADRANT CIRCULAR ARC': 9692,
'UPPER LEFT TRIANGLE': 9720,
'UPPER ONE EIGHTH BLOCK': 9620,
'UPPER RIGHT DROP-SHADOWED WHITE SQUARE': 10064,
'UPPER RIGHT OR LOWER LEFT CURLY BRACKET SECTION': 9137,
'UPPER RIGHT PENCIL': 10000,
'UPPER RIGHT QUADRANT CIRCULAR ARC': 9693,
'UPPER RIGHT SHADOWED WHITE SQUARE': 10066,
'UPPER RIGHT TRIANGLE': 9721,
'UPWARDS ANCORA': 11797,
'UPWARDS ARROW': 8593,
'UPWARDS ARROW FROM BAR': 8613,
'UPWARDS ARROW LEFTWARDS OF DOWNWARDS ARROW': 8645,
'UPWARDS ARROW TO BAR': 10514,
'UPWARDS ARROW WITH DOUBLE STROKE': 8670,
'UPWARDS ARROW WITH HORIZONTAL STROKE': 10505,
'UPWARDS ARROW WITH TIP LEFTWARDS': 8624,
'UPWARDS ARROW WITH TIP RIGHTWARDS': 8625,
'UPWARDS BLACK ARROW': 11014,
'UPWARDS DASHED ARROW': 8673,
'UPWARDS DOUBLE ARROW': 8657,
'UPWARDS HARPOON WITH BARB LEFT BESIDE DOWNWARDS HARPOON WITH BARB RIGHT': 10606,
'UPWARDS HARPOON WITH BARB LEFT BESIDE UPWARDS HARPOON WITH BARB RIGHT': 10595,
'UPWARDS HARPOON WITH BARB LEFT FROM BAR': 10592,
'UPWARDS HARPOON WITH BARB LEFT TO BAR': 10584,
'UPWARDS HARPOON WITH BARB LEFTWARDS': 8639,
'UPWARDS HARPOON WITH BARB RIGHT FROM BAR': 10588,
'UPWARDS HARPOON WITH BARB RIGHT TO BAR': 10580,
'UPWARDS HARPOON WITH BARB RIGHTWARDS': 8638,
'UPWARDS PAIRED ARROWS': 8648,
'UPWARDS QUADRUPLE ARROW': 10224,
'UPWARDS TRIPLE ARROW': 10506,
'UPWARDS TWO HEADED ARROW': 8607,
'UPWARDS TWO-HEADED ARROW FROM SMALL CIRCLE': 10569,
'UPWARDS WHITE ARROW': 8679,
'UPWARDS WHITE ARROW FROM BAR': 8682,
'UPWARDS WHITE ARROW ON PEDESTAL': 8683,
'UPWARDS WHITE ARROW ON PEDESTAL WITH HORIZONTAL BAR': 8684,
'UPWARDS WHITE ARROW ON PEDESTAL WITH VERTICAL BAR': 8685,
'UPWARDS WHITE DOUBLE ARROW': 8686,
'UPWARDS WHITE DOUBLE ARROW ON PEDESTAL': 8687,
'URANUS': 9797,
'VAI COMMA': 42509,
'VAI DIGIT EIGHT': 42536,
'VAI DIGIT FIVE': 42533,
'VAI DIGIT FOUR': 42532,
'VAI DIGIT NINE': 42537,
'VAI DIGIT ONE': 42529,
'VAI DIGIT SEVEN': 42535,
'VAI DIGIT SIX': 42534,
'VAI DIGIT THREE': 42531,
'VAI DIGIT TWO': 42530,
'VAI DIGIT ZERO': 42528,
'VAI FULL STOP': 42510,
'VAI QUESTION MARK': 42511,
'VAI SYLLABLE A': 42313,
'VAI SYLLABLE AN': 42314,
'VAI SYLLABLE BA': 42322,
'VAI SYLLABLE BE': 42474,
'VAI SYLLABLE BEE': 42247,
'VAI SYLLABLE BHA': 42321,
'VAI SYLLABLE BHE': 42473,
'VAI SYLLABLE BHEE': 42246,
'VAI SYLLABLE BHI': 42283,
'VAI SYLLABLE BHO': 42434,
'VAI SYLLABLE BHOO': 42359,
'VAI SYLLABLE BHU': 42396,
'VAI SYLLABLE BI': 42284,
'VAI SYLLABLE BO': 42435,
'VAI SYLLABLE BOO': 42360,
'VAI SYLLABLE BU': 42397,
'VAI SYLLABLE CA': 42342,
'VAI SYLLABLE CE': 42495,
'VAI SYLLABLE CEE': 42266,
'VAI SYLLABLE CI': 42303,
'VAI SYLLABLE CO': 42455,
'VAI SYLLABLE COO': 42379,
'VAI SYLLABLE CU': 42416,
'VAI SYLLABLE DA': 42336,
'VAI SYLLABLE DE': 42489,
'VAI SYLLABLE DEE': 42260,
'VAI SYLLABLE DHA': 42332,
'VAI SYLLABLE DHE': 42485,
'VAI SYLLABLE DHEE': 42256,
'VAI SYLLABLE DHHA': 42333,
'VAI SYLLABLE DHHE': 42486,
'VAI SYLLABLE DHHEE': 42257,
'VAI SYLLABLE DHHI': 42294,
'VAI SYLLABLE DHHO': 42446,
'VAI SYLLABLE DHHOO': 42370,
'VAI SYLLABLE DHHU': 42407,
'VAI SYLLABLE DHI': 42293,
'VAI SYLLABLE DHO': 42445,
'VAI SYLLABLE DHOO': 42369,
'VAI SYLLABLE DHU': 42406,
'VAI SYLLABLE DI': 42297,
'VAI SYLLABLE DO': 42449,
'VAI SYLLABLE DOO': 42373,
'VAI SYLLABLE DU': 42410,
'VAI SYLLABLE E': 42465,
'VAI SYLLABLE EE': 42240,
'VAI SYLLABLE EEN': 42241,
'VAI SYLLABLE EN': 42466,
'VAI SYLLABLE FA': 42328,
'VAI SYLLABLE FE': 42481,
'VAI SYLLABLE FEE': 42252,
'VAI SYLLABLE FI': 42289,
'VAI SYLLABLE FO': 42441,
'VAI SYLLABLE FOO': 42365,
'VAI SYLLABLE FU': 42402,
'VAI SYLLABLE GA': 42349,
'VAI SYLLABLE GBA': 42327,
'VAI SYLLABLE GBE': 42479,
'VAI SYLLABLE GBEE': 42251,
'VAI SYLLABLE GBEN': 42480,
'VAI SYLLABLE GBI': 42288,
'VAI SYLLABLE GBO': 42439,
'VAI SYLLABLE GBON': 42440,
'VAI SYLLABLE GBOO': 42364,
'VAI SYLLABLE GBU': 42401,
'VAI SYLLABLE GE': 42502,
'VAI SYLLABLE GEE': 42272,
'VAI SYLLABLE GEN': 42503,
'VAI SYLLABLE GI': 42309,
'VAI SYLLABLE GO': 42461,
'VAI SYLLABLE GOO': 42385,
'VAI SYLLABLE GU': 42422,
'VAI SYLLABLE HA': 42316,
'VAI SYLLABLE HAN': 42317,
'VAI SYLLABLE HE': 42468,
'VAI SYLLABLE HEE': 42242,
'VAI SYLLABLE HEN': 42469,
'VAI SYLLABLE HI': 42278,
'VAI SYLLABLE HIN': 42279,
'VAI SYLLABLE HO': 42429,
'VAI SYLLABLE HON': 42430,
'VAI SYLLABLE HOO': 42355,
'VAI SYLLABLE HU': 42391,
'VAI SYLLABLE HUN': 42392,
'VAI SYLLABLE I': 42276,
'VAI SYLLABLE IN': 42277,
'VAI SYLLABLE JA': 42343,
'VAI SYLLABLE JE': 42496,
'VAI SYLLABLE JEE': 42267,
'VAI SYLLABLE JI': 42304,
'VAI SYLLABLE JO': 42456,
'VAI SYLLABLE JOO': 42380,
'VAI SYLLABLE JU': 42417,
'VAI SYLLABLE KA': 42346,
'VAI SYLLABLE KAN': 42347,
'VAI SYLLABLE KE': 42499,
'VAI SYLLABLE KEE': 42270,
'VAI SYLLABLE KI': 42307,
'VAI SYLLABLE KO': 42459,
'VAI SYLLABLE KOO': 42383,
'VAI SYLLABLE KPA': 42324,
'VAI SYLLABLE KPAN': 42325,
'VAI SYLLABLE KPE': 42476,
'VAI SYLLABLE KPEE': 42249,
'VAI SYLLABLE KPEN': 42477,
'VAI SYLLABLE KPI': 42286,
'VAI SYLLABLE KPO': 42437,
'VAI SYLLABLE KPOO': 42362,
'VAI SYLLABLE KPU': 42399,
'VAI SYLLABLE KU': 42420,
'VAI SYLLABLE LA': 42334,
'VAI SYLLABLE LE': 42487,
'VAI SYLLABLE LEE': 42258,
'VAI SYLLABLE LENGTHENER': 42508,
'VAI SYLLABLE LI': 42295,
'VAI SYLLABLE LO': 42447,
'VAI SYLLABLE LOO': 42371,
'VAI SYLLABLE LU': 42408,
'VAI SYLLABLE MA': 42350,
'VAI SYLLABLE MBA': 42323,
'VAI SYLLABLE MBE': 42475,
'VAI SYLLABLE MBEE': 42248,
'VAI SYLLABLE MBI': 42285,
'VAI SYLLABLE MBO': 42436,
'VAI SYLLABLE MBOO': 42361,
'VAI SYLLABLE MBU': 42398,
'VAI SYLLABLE ME': 42504,
'VAI SYLLABLE MEE': 42273,
'VAI SYLLABLE MGBA': 42326,
'VAI SYLLABLE MGBE': 42478,
'VAI SYLLABLE MGBEE': 42250,
'VAI SYLLABLE MGBI': 42287,
'VAI SYLLABLE MGBO': 42438,
'VAI SYLLABLE MGBOO': 42363,
'VAI SYLLABLE MGBU': 42400,
'VAI SYLLABLE MI': 42310,
'VAI SYLLABLE MO': 42462,
'VAI SYLLABLE MOO': 42386,
'VAI SYLLABLE MU': 42423,
'VAI SYLLABLE NA': 42351,
'VAI SYLLABLE NDA': 42337,
'VAI SYLLABLE NDE': 42490,
'VAI SYLLABLE NDEE': 42261,
'VAI SYLLABLE NDI': 42298,
'VAI SYLLABLE NDO': 42450,
'VAI SYLLABLE NDOLE DO': 42539,
'VAI SYLLABLE NDOLE FA': 42512,
'VAI SYLLABLE NDOLE KA': 42513,
'VAI SYLLABLE NDOLE MA': 42538,
'VAI SYLLABLE NDOLE SOO': 42514,
'VAI SYLLABLE NDOO': 42374,
'VAI SYLLABLE NDU': 42411,
'VAI SYLLABLE NE': 42505,
'VAI SYLLABLE NEE': 42274,
'VAI SYLLABLE NG': 42507,
'VAI SYLLABLE NGAN': 42315,
'VAI SYLLABLE NGEN': 42467,
'VAI SYLLABLE NGGA': 42348,
'VAI SYLLABLE NGGE': 42500,
'VAI SYLLABLE NGGEE': 42271,
'VAI SYLLABLE NGGEN': 42501,
'VAI SYLLABLE NGGI': 42308,
'VAI SYLLABLE NGGO': 42460,
'VAI SYLLABLE NGGOO': 42384,
'VAI SYLLABLE NGGU': 42421,
'VAI SYLLABLE NGON': 42428,
'VAI SYLLABLE NI': 42311,
'VAI SYLLABLE NJA': 42344,
'VAI SYLLABLE NJE': 42497,
'VAI SYLLABLE NJEE': 42268,
'VAI SYLLABLE NJI': 42305,
'VAI SYLLABLE NJO': 42457,
'VAI SYLLABLE NJOO': 42381,
'VAI SYLLABLE NJU': 42418,
'VAI SYLLABLE NO': 42463,
'VAI SYLLABLE NOO': 42387,
'VAI SYLLABLE NU': 42424,
'VAI SYLLABLE NYA': 42352,
'VAI SYLLABLE NYE': 42506,
'VAI SYLLABLE NYEE': 42275,
'VAI SYLLABLE NYI': 42312,
'VAI SYLLABLE NYO': 42464,
'VAI SYLLABLE NYOO': 42388,
'VAI SYLLABLE NYU': 42425,
'VAI SYLLABLE O': 42426,
'VAI SYLLABLE ON': 42427,
'VAI SYLLABLE OO': 42353,
'VAI SYLLABLE OON': 42354,
'VAI SYLLABLE PA': 42320,
'VAI SYLLABLE PE': 42472,
'VAI SYLLABLE PEE': 42245,
'VAI SYLLABLE PI': 42282,
'VAI SYLLABLE PO': 42433,
'VAI SYLLABLE POO': 42358,
'VAI SYLLABLE PU': 42395,
'VAI SYLLABLE RA': 42335,
'VAI SYLLABLE RE': 42488,
'VAI SYLLABLE REE': 42259,
'VAI SYLLABLE RI': 42296,
'VAI SYLLABLE RO': 42448,
'VAI SYLLABLE ROO': 42372,
'VAI SYLLABLE RU': 42409,
'VAI SYLLABLE SA': 42338,
'VAI SYLLABLE SE': 42491,
'VAI SYLLABLE SEE': 42262,
'VAI SYLLABLE SHA': 42339,
'VAI SYLLABLE SHE': 42492,
'VAI SYLLABLE SHEE': 42263,
'VAI SYLLABLE SHI': 42300,
'VAI SYLLABLE SHO': 42452,
'VAI SYLLABLE SHOO': 42376,
'VAI SYLLABLE SHU': 42413,
'VAI SYLLABLE SI': 42299,
'VAI SYLLABLE SO': 42451,
'VAI SYLLABLE SOO': 42375,
'VAI SYLLABLE SU': 42412,
'VAI SYLLABLE TA': 42330,
'VAI SYLLABLE TE': 42483,
'VAI SYLLABLE TEE': 42254,
'VAI SYLLABLE THA': 42331,
'VAI SYLLABLE THE': 42484,
'VAI SYLLABLE THEE': 42255,
'VAI SYLLABLE THI': 42292,
'VAI SYLLABLE THO': 42444,
'VAI SYLLABLE THOO': 42368,
'VAI SYLLABLE THU': 42405,
'VAI SYLLABLE TI': 42291,
'VAI SYLLABLE TO': 42443,
'VAI SYLLABLE TOO': 42367,
'VAI SYLLABLE TU': 42404,
'VAI SYLLABLE U': 42389,
'VAI SYLLABLE UN': 42390,
'VAI SYLLABLE VA': 42329,
'VAI SYLLABLE VE': 42482,
'VAI SYLLABLE VEE': 42253,
'VAI SYLLABLE VI': 42290,
'VAI SYLLABLE VO': 42442,
'VAI SYLLABLE VOO': 42366,
'VAI SYLLABLE VU': 42403,
'VAI SYLLABLE WA': 42318,
'VAI SYLLABLE WAN': 42319,
'VAI SYLLABLE WE': 42470,
'VAI SYLLABLE WEE': 42243,
'VAI SYLLABLE WEEN': 42244,
'VAI SYLLABLE WEN': 42471,
'VAI SYLLABLE WI': 42280,
'VAI SYLLABLE WIN': 42281,
'VAI SYLLABLE WO': 42431,
'VAI SYLLABLE WON': 42432,
'VAI SYLLABLE WOO': 42356,
'VAI SYLLABLE WOON': 42357,
'VAI SYLLABLE WU': 42393,
'VAI SYLLABLE WUN': 42394,
'VAI SYLLABLE YA': 42345,
'VAI SYLLABLE YE': 42498,
'VAI SYLLABLE YEE': 42269,
'VAI SYLLABLE YI': 42306,
'VAI SYLLABLE YO': 42458,
'VAI SYLLABLE YOO': 42382,
'VAI SYLLABLE YU': 42419,
'VAI SYLLABLE ZA': 42340,
'VAI SYLLABLE ZE': 42493,
'VAI SYLLABLE ZEE': 42264,
'VAI SYLLABLE ZHA': 42341,
'VAI SYLLABLE ZHE': 42494,
'VAI SYLLABLE ZHEE': 42265,
'VAI SYLLABLE ZHI': 42302,
'VAI SYLLABLE ZHO': 42454,
'VAI SYLLABLE ZHOO': 42378,
'VAI SYLLABLE ZHU': 42415,
'VAI SYLLABLE ZI': 42301,
'VAI SYLLABLE ZO': 42453,
'VAI SYLLABLE ZOO': 42377,
'VAI SYLLABLE ZU': 42414,
'VAI SYMBOL BANG': 42519,
'VAI SYMBOL DANG': 42522,
'VAI SYMBOL DO-O': 42526,
'VAI SYMBOL DOONG': 42523,
'VAI SYMBOL FAA': 42520,
'VAI SYMBOL FEENG': 42515,
'VAI SYMBOL JONG': 42527,
'VAI SYMBOL KEENG': 42516,
'VAI SYMBOL KUNG': 42524,
'VAI SYMBOL NII': 42518,
'VAI SYMBOL TAA': 42521,
'VAI SYMBOL TING': 42517,
'VAI SYMBOL TONG': 42525,
'VARIATION SELECTOR-1': 65024,
'VARIATION SELECTOR-10': 65033,
'VARIATION SELECTOR-100': 917843,
'VARIATION SELECTOR-101': 917844,
'VARIATION SELECTOR-102': 917845,
'VARIATION SELECTOR-103': 917846,
'VARIATION SELECTOR-104': 917847,
'VARIATION SELECTOR-105': 917848,
'VARIATION SELECTOR-106': 917849,
'VARIATION SELECTOR-107': 917850,
'VARIATION SELECTOR-108': 917851,
'VARIATION SELECTOR-109': 917852,
'VARIATION SELECTOR-11': 65034,
'VARIATION SELECTOR-110': 917853,
'VARIATION SELECTOR-111': 917854,
'VARIATION SELECTOR-112': 917855,
'VARIATION SELECTOR-113': 917856,
'VARIATION SELECTOR-114': 917857,
'VARIATION SELECTOR-115': 917858,
'VARIATION SELECTOR-116': 917859,
'VARIATION SELECTOR-117': 917860,
'VARIATION SELECTOR-118': 917861,
'VARIATION SELECTOR-119': 917862,
'VARIATION SELECTOR-12': 65035,
'VARIATION SELECTOR-120': 917863,
'VARIATION SELECTOR-121': 917864,
'VARIATION SELECTOR-122': 917865,
'VARIATION SELECTOR-123': 917866,
'VARIATION SELECTOR-124': 917867,
'VARIATION SELECTOR-125': 917868,
'VARIATION SELECTOR-126': 917869,
'VARIATION SELECTOR-127': 917870,
'VARIATION SELECTOR-128': 917871,
'VARIATION SELECTOR-129': 917872,
'VARIATION SELECTOR-13': 65036,
'VARIATION SELECTOR-130': 917873,
'VARIATION SELECTOR-131': 917874,
'VARIATION SELECTOR-132': 917875,
'VARIATION SELECTOR-133': 917876,
'VARIATION SELECTOR-134': 917877,
'VARIATION SELECTOR-135': 917878,
'VARIATION SELECTOR-136': 917879,
'VARIATION SELECTOR-137': 917880,
'VARIATION SELECTOR-138': 917881,
'VARIATION SELECTOR-139': 917882,
'VARIATION SELECTOR-14': 65037,
'VARIATION SELECTOR-140': 917883,
'VARIATION SELECTOR-141': 917884,
'VARIATION SELECTOR-142': 917885,
'VARIATION SELECTOR-143': 917886,
'VARIATION SELECTOR-144': 917887,
'VARIATION SELECTOR-145': 917888,
'VARIATION SELECTOR-146': 917889,
'VARIATION SELECTOR-147': 917890,
'VARIATION SELECTOR-148': 917891,
'VARIATION SELECTOR-149': 917892,
'VARIATION SELECTOR-15': 65038,
'VARIATION SELECTOR-150': 917893,
'VARIATION SELECTOR-151': 917894,
'VARIATION SELECTOR-152': 917895,
'VARIATION SELECTOR-153': 917896,
'VARIATION SELECTOR-154': 917897,
'VARIATION SELECTOR-155': 917898,
'VARIATION SELECTOR-156': 917899,
'VARIATION SELECTOR-157': 917900,
'VARIATION SELECTOR-158': 917901,
'VARIATION SELECTOR-159': 917902,
'VARIATION SELECTOR-16': 65039,
'VARIATION SELECTOR-160': 917903,
'VARIATION SELECTOR-161': 917904,
'VARIATION SELECTOR-162': 917905,
'VARIATION SELECTOR-163': 917906,
'VARIATION SELECTOR-164': 917907,
'VARIATION SELECTOR-165': 917908,
'VARIATION SELECTOR-166': 917909,
'VARIATION SELECTOR-167': 917910,
'VARIATION SELECTOR-168': 917911,
'VARIATION SELECTOR-169': 917912,
'VARIATION SELECTOR-17': 917760,
'VARIATION SELECTOR-170': 917913,
'VARIATION SELECTOR-171': 917914,
'VARIATION SELECTOR-172': 917915,
'VARIATION SELECTOR-173': 917916,
'VARIATION SELECTOR-174': 917917,
'VARIATION SELECTOR-175': 917918,
'VARIATION SELECTOR-176': 917919,
'VARIATION SELECTOR-177': 917920,
'VARIATION SELECTOR-178': 917921,
'VARIATION SELECTOR-179': 917922,
'VARIATION SELECTOR-18': 917761,
'VARIATION SELECTOR-180': 917923,
'VARIATION SELECTOR-181': 917924,
'VARIATION SELECTOR-182': 917925,
'VARIATION SELECTOR-183': 917926,
'VARIATION SELECTOR-184': 917927,
'VARIATION SELECTOR-185': 917928,
'VARIATION SELECTOR-186': 917929,
'VARIATION SELECTOR-187': 917930,
'VARIATION SELECTOR-188': 917931,
'VARIATION SELECTOR-189': 917932,
'VARIATION SELECTOR-19': 917762,
'VARIATION SELECTOR-190': 917933,
'VARIATION SELECTOR-191': 917934,
'VARIATION SELECTOR-192': 917935,
'VARIATION SELECTOR-193': 917936,
'VARIATION SELECTOR-194': 917937,
'VARIATION SELECTOR-195': 917938,
'VARIATION SELECTOR-196': 917939,
'VARIATION SELECTOR-197': 917940,
'VARIATION SELECTOR-198': 917941,
'VARIATION SELECTOR-199': 917942,
'VARIATION SELECTOR-2': 65025,
'VARIATION SELECTOR-20': 917763,
'VARIATION SELECTOR-200': 917943,
'VARIATION SELECTOR-201': 917944,
'VARIATION SELECTOR-202': 917945,
'VARIATION SELECTOR-203': 917946,
'VARIATION SELECTOR-204': 917947,
'VARIATION SELECTOR-205': 917948,
'VARIATION SELECTOR-206': 917949,
'VARIATION SELECTOR-207': 917950,
'VARIATION SELECTOR-208': 917951,
'VARIATION SELECTOR-209': 917952,
'VARIATION SELECTOR-21': 917764,
'VARIATION SELECTOR-210': 917953,
'VARIATION SELECTOR-211': 917954,
'VARIATION SELECTOR-212': 917955,
'VARIATION SELECTOR-213': 917956,
'VARIATION SELECTOR-214': 917957,
'VARIATION SELECTOR-215': 917958,
'VARIATION SELECTOR-216': 917959,
'VARIATION SELECTOR-217': 917960,
'VARIATION SELECTOR-218': 917961,
'VARIATION SELECTOR-219': 917962,
'VARIATION SELECTOR-22': 917765,
'VARIATION SELECTOR-220': 917963,
'VARIATION SELECTOR-221': 917964,
'VARIATION SELECTOR-222': 917965,
'VARIATION SELECTOR-223': 917966,
'VARIATION SELECTOR-224': 917967,
'VARIATION SELECTOR-225': 917968,
'VARIATION SELECTOR-226': 917969,
'VARIATION SELECTOR-227': 917970,
'VARIATION SELECTOR-228': 917971,
'VARIATION SELECTOR-229': 917972,
'VARIATION SELECTOR-23': 917766,
'VARIATION SELECTOR-230': 917973,
'VARIATION SELECTOR-231': 917974,
'VARIATION SELECTOR-232': 917975,
'VARIATION SELECTOR-233': 917976,
'VARIATION SELECTOR-234': 917977,
'VARIATION SELECTOR-235': 917978,
'VARIATION SELECTOR-236': 917979,
'VARIATION SELECTOR-237': 917980,
'VARIATION SELECTOR-238': 917981,
'VARIATION SELECTOR-239': 917982,
'VARIATION SELECTOR-24': 917767,
'VARIATION SELECTOR-240': 917983,
'VARIATION SELECTOR-241': 917984,
'VARIATION SELECTOR-242': 917985,
'VARIATION SELECTOR-243': 917986,
'VARIATION SELECTOR-244': 917987,
'VARIATION SELECTOR-245': 917988,
'VARIATION SELECTOR-246': 917989,
'VARIATION SELECTOR-247': 917990,
'VARIATION SELECTOR-248': 917991,
'VARIATION SELECTOR-249': 917992,
'VARIATION SELECTOR-25': 917768,
'VARIATION SELECTOR-250': 917993,
'VARIATION SELECTOR-251': 917994,
'VARIATION SELECTOR-252': 917995,
'VARIATION SELECTOR-253': 917996,
'VARIATION SELECTOR-254': 917997,
'VARIATION SELECTOR-255': 917998,
'VARIATION SELECTOR-256': 917999,
'VARIATION SELECTOR-26': 917769,
'VARIATION SELECTOR-27': 917770,
'VARIATION SELECTOR-28': 917771,
'VARIATION SELECTOR-29': 917772,
'VARIATION SELECTOR-3': 65026,
'VARIATION SELECTOR-30': 917773,
'VARIATION SELECTOR-31': 917774,
'VARIATION SELECTOR-32': 917775,
'VARIATION SELECTOR-33': 917776,
'VARIATION SELECTOR-34': 917777,
'VARIATION SELECTOR-35': 917778,
'VARIATION SELECTOR-36': 917779,
'VARIATION SELECTOR-37': 917780,
'VARIATION SELECTOR-38': 917781,
'VARIATION SELECTOR-39': 917782,
'VARIATION SELECTOR-4': 65027,
'VARIATION SELECTOR-40': 917783,
'VARIATION SELECTOR-41': 917784,
'VARIATION SELECTOR-42': 917785,
'VARIATION SELECTOR-43': 917786,
'VARIATION SELECTOR-44': 917787,
'VARIATION SELECTOR-45': 917788,
'VARIATION SELECTOR-46': 917789,
'VARIATION SELECTOR-47': 917790,
'VARIATION SELECTOR-48': 917791,
'VARIATION SELECTOR-49': 917792,
'VARIATION SELECTOR-5': 65028,
'VARIATION SELECTOR-50': 917793,
'VARIATION SELECTOR-51': 917794,
'VARIATION SELECTOR-52': 917795,
'VARIATION SELECTOR-53': 917796,
'VARIATION SELECTOR-54': 917797,
'VARIATION SELECTOR-55': 917798,
'VARIATION SELECTOR-56': 917799,
'VARIATION SELECTOR-57': 917800,
'VARIATION SELECTOR-58': 917801,
'VARIATION SELECTOR-59': 917802,
'VARIATION SELECTOR-6': 65029,
'VARIATION SELECTOR-60': 917803,
'VARIATION SELECTOR-61': 917804,
'VARIATION SELECTOR-62': 917805,
'VARIATION SELECTOR-63': 917806,
'VARIATION SELECTOR-64': 917807,
'VARIATION SELECTOR-65': 917808,
'VARIATION SELECTOR-66': 917809,
'VARIATION SELECTOR-67': 917810,
'VARIATION SELECTOR-68': 917811,
'VARIATION SELECTOR-69': 917812,
'VARIATION SELECTOR-7': 65030,
'VARIATION SELECTOR-70': 917813,
'VARIATION SELECTOR-71': 917814,
'VARIATION SELECTOR-72': 917815,
'VARIATION SELECTOR-73': 917816,
'VARIATION SELECTOR-74': 917817,
'VARIATION SELECTOR-75': 917818,
'VARIATION SELECTOR-76': 917819,
'VARIATION SELECTOR-77': 917820,
'VARIATION SELECTOR-78': 917821,
'VARIATION SELECTOR-79': 917822,
'VARIATION SELECTOR-8': 65031,
'VARIATION SELECTOR-80': 917823,
'VARIATION SELECTOR-81': 917824,
'VARIATION SELECTOR-82': 917825,
'VARIATION SELECTOR-83': 917826,
'VARIATION SELECTOR-84': 917827,
'VARIATION SELECTOR-85': 917828,
'VARIATION SELECTOR-86': 917829,
'VARIATION SELECTOR-87': 917830,
'VARIATION SELECTOR-88': 917831,
'VARIATION SELECTOR-89': 917832,
'VARIATION SELECTOR-9': 65032,
'VARIATION SELECTOR-90': 917833,
'VARIATION SELECTOR-91': 917834,
'VARIATION SELECTOR-92': 917835,
'VARIATION SELECTOR-93': 917836,
'VARIATION SELECTOR-94': 917837,
'VARIATION SELECTOR-95': 917838,
'VARIATION SELECTOR-96': 917839,
'VARIATION SELECTOR-97': 917840,
'VARIATION SELECTOR-98': 917841,
'VARIATION SELECTOR-99': 917842,
'VECTOR OR CROSS PRODUCT': 10799,
'VEDIC SIGN ANUSVARA ANTARGOMUKHA': 7401,
'VEDIC SIGN ANUSVARA BAHIRGOMUKHA': 7402,
'VEDIC SIGN ANUSVARA UBHAYATO MUKHA': 7409,
'VEDIC SIGN ANUSVARA VAMAGOMUKHA': 7403,
'VEDIC SIGN ANUSVARA VAMAGOMUKHA WITH TAIL': 7404,
'VEDIC SIGN ARDHAVISARGA': 7410,
'VEDIC SIGN HEXIFORM LONG ANUSVARA': 7406,
'VEDIC SIGN LONG ANUSVARA': 7407,
'VEDIC SIGN NIHSHVASA': 7379,
'VEDIC SIGN REVERSED VISARGA ANUDATTA': 7398,
'VEDIC SIGN REVERSED VISARGA UDATTA': 7396,
'VEDIC SIGN RTHANG LONG ANUSVARA': 7408,
'VEDIC SIGN TIRYAK': 7405,
'VEDIC SIGN VISARGA ANUDATTA': 7397,
'VEDIC SIGN VISARGA ANUDATTA WITH TAIL': 7400,
'VEDIC SIGN VISARGA SVARITA': 7394,
'VEDIC SIGN VISARGA UDATTA': 7395,
'VEDIC SIGN VISARGA UDATTA WITH TAIL': 7399,
'VEDIC SIGN YAJURVEDIC MIDLINE SVARITA': 7380,
'VEDIC TONE ATHARVAVEDIC INDEPENDENT SVARITA': 7393,
'VEDIC TONE CANDRA BELOW': 7384,
'VEDIC TONE DOT BELOW': 7389,
'VEDIC TONE DOUBLE SVARITA': 7386,
'VEDIC TONE KARSHANA': 7376,
'VEDIC TONE KATHAKA ANUDATTA': 7388,
'VEDIC TONE PRENKHA': 7378,
'VEDIC TONE RIGVEDIC KASHMIRI INDEPENDENT SVARITA': 7392,
'VEDIC TONE SHARA': 7377,
'VEDIC TONE THREE DOTS BELOW': 7391,
'VEDIC TONE TRIPLE SVARITA': 7387,
'VEDIC TONE TWO DOTS BELOW': 7390,
'VEDIC TONE YAJURVEDIC AGGRAVATED INDEPENDENT SVARITA': 7381,
'VEDIC TONE YAJURVEDIC INDEPENDENT SVARITA': 7382,
'VEDIC TONE YAJURVEDIC KATHAKA INDEPENDENT SVARITA': 7383,
'VEDIC TONE YAJURVEDIC KATHAKA INDEPENDENT SVARITA SCHROEDER': 7385,
'VERSICLE': 8483,
'VERTICAL BAR BESIDE RIGHT TRIANGLE': 10704,
'VERTICAL BAR DOUBLE LEFT TURNSTILE': 10980,
'VERTICAL BAR TRIPLE RIGHT TURNSTILE': 10978,
'VERTICAL BAR WITH HORIZONTAL STROKE': 10186,
'VERTICAL ELLIPSIS': 8942,
'VERTICAL FOUR DOTS': 8286,
'VERTICAL IDEOGRAPHIC ITERATION MARK': 12347,
'VERTICAL KANA REPEAT MARK': 12337,
'VERTICAL KANA REPEAT MARK LOWER HALF': 12341,
'VERTICAL KANA REPEAT MARK UPPER HALF': 12339,
'VERTICAL KANA REPEAT WITH VOICED SOUND MARK': 12338,
'VERTICAL KANA REPEAT WITH VOICED SOUND MARK UPPER HALF': 12340,
'VERTICAL LINE': 124,
'VERTICAL LINE EXTENSION': 9168,
'VERTICAL LINE WITH CIRCLE ABOVE': 10991,
'VERTICAL LINE WITH CIRCLE BELOW': 10992,
'VERTICAL LINE WITH MIDDLE DOT': 9087,
'VERTICAL MALE WITH STROKE SIGN': 9896,
'VERTICAL TILDE': 11823,
'VERTICAL ZIGZAG LINE': 10650,
'VERY MUCH GREATER-THAN': 8921,
'VERY MUCH LESS-THAN': 8920,
'VESTA': 9910,
'VICTORY HAND': 9996,
'VIEWDATA SQUARE': 8983,
'VIRGO': 9805,
'VOLUME INTEGRAL': 8752,
'VULGAR FRACTION FIVE EIGHTHS': 8541,
'VULGAR FRACTION FIVE SIXTHS': 8538,
'VULGAR FRACTION FOUR FIFTHS': 8536,
'VULGAR FRACTION ONE EIGHTH': 8539,
'VULGAR FRACTION ONE FIFTH': 8533,
'VULGAR FRACTION ONE HALF': 189,
'VULGAR FRACTION ONE NINTH': 8529,
'VULGAR FRACTION ONE QUARTER': 188,
'VULGAR FRACTION ONE SEVENTH': 8528,
'VULGAR FRACTION ONE SIXTH': 8537,
'VULGAR FRACTION ONE TENTH': 8530,
'VULGAR FRACTION ONE THIRD': 8531,
'VULGAR FRACTION SEVEN EIGHTHS': 8542,
'VULGAR FRACTION THREE EIGHTHS': 8540,
'VULGAR FRACTION THREE FIFTHS': 8535,
'VULGAR FRACTION THREE QUARTERS': 190,
'VULGAR FRACTION TWO FIFTHS': 8534,
'VULGAR FRACTION TWO THIRDS': 8532,
'VULGAR FRACTION ZERO THIRDS': 8585,
'WARNING SIGN': 9888,
'WATCH': 8986,
'WAVE ARROW POINTING DIRECTLY LEFT': 11071,
'WAVE ARROW POINTING DIRECTLY RIGHT': 10547,
'WAVE DASH': 12316,
'WAVY DASH': 12336,
'WAVY LINE': 8967,
'WAVY LOW LINE': 65103,
'WAVY OVERLINE': 65099,
'WEDGE-TAILED RIGHTWARDS ARROW': 10172,
'WEST SYRIAC CROSS': 9840,
'WHEEL OF DHARMA': 9784,
'WHEELCHAIR SYMBOL': 9855,
'WHITE BULLET': 9702,
'WHITE CHESS BISHOP': 9815,
'WHITE CHESS KING': 9812,
'WHITE CHESS KNIGHT': 9816,
'WHITE CHESS PAWN': 9817,
'WHITE CHESS QUEEN': 9813,
'WHITE CHESS ROOK': 9814,
'WHITE CIRCLE': 9675,
'WHITE CIRCLE WITH DOT RIGHT': 9862,
'WHITE CIRCLE WITH DOWN ARROW': 10732,
'WHITE CIRCLE WITH LOWER LEFT QUADRANT': 9717,
'WHITE CIRCLE WITH LOWER RIGHT QUADRANT': 9718,
'WHITE CIRCLE WITH TWO DOTS': 9863,
'WHITE CIRCLE WITH UPPER LEFT QUADRANT': 9716,
'WHITE CIRCLE WITH UPPER RIGHT QUADRANT': 9719,
'WHITE CLUB SUIT': 9831,
'WHITE CONCAVE-SIDED DIAMOND': 10209,
'WHITE CONCAVE-SIDED DIAMOND WITH LEFTWARDS TICK': 10210,
'WHITE CONCAVE-SIDED DIAMOND WITH RIGHTWARDS TICK': 10211,
'WHITE DIAMOND': 9671,
'WHITE DIAMOND CONTAINING BLACK SMALL DIAMOND': 9672,
'WHITE DIAMOND IN SQUARE': 9931,
'WHITE DIAMOND SUIT': 9826,
'WHITE DIAMOND WITH CENTRED DOT': 10192,
'WHITE DOWN POINTING INDEX': 9759,
'WHITE DOWN-POINTING SMALL TRIANGLE': 9663,
'WHITE DOWN-POINTING TRIANGLE': 9661,
'WHITE DRAUGHTS KING': 9921,
'WHITE DRAUGHTS MAN': 9920,
'WHITE FLAG': 9872,
'WHITE FLAG WITH HORIZONTAL MIDDLE BLACK STRIPE': 9983,
'WHITE FLORETTE': 10048,
'WHITE FOUR POINTED STAR': 10023,
'WHITE FROWNING FACE': 9785,
'WHITE HEART SUIT': 9825,
'WHITE HEXAGON': 11041,
'WHITE HORIZONTAL ELLIPSE': 11053,
'WHITE HOURGLASS': 10710,
'WHITE LARGE SQUARE': 11036,
'WHITE LEFT LANE MERGE': 9945,
'WHITE LEFT POINTING INDEX': 9756,
'WHITE LEFT-POINTING POINTER': 9669,
'WHITE LEFT-POINTING SMALL TRIANGLE': 9667,
'WHITE LEFT-POINTING TRIANGLE': 9665,
'WHITE MEDIUM DIAMOND': 11046,
'WHITE MEDIUM LOZENGE': 11048,
'WHITE MEDIUM SMALL SQUARE': 9725,
'WHITE MEDIUM SQUARE': 9723,
'WHITE MEDIUM STAR': 11088,
'WHITE NIB': 10001,
'WHITE PARALLELOGRAM': 9649,
'WHITE PENTAGON': 11040,
'WHITE RECTANGLE': 9645,
'WHITE RIGHT POINTING INDEX': 9758,
'WHITE RIGHT-POINTING PENTAGON': 11092,
'WHITE RIGHT-POINTING POINTER': 9659,
'WHITE RIGHT-POINTING SMALL TRIANGLE': 9657,
'WHITE RIGHT-POINTING TRIANGLE': 9655,
'WHITE SCISSORS': 9988,
'WHITE SESAME DOT': 65094,
'WHITE SHOGI PIECE': 9750,
'WHITE SMALL LOZENGE': 11051,
'WHITE SMALL SQUARE': 9643,
'WHITE SMALL STAR': 11090,
'WHITE SMILING FACE': 9786,
'WHITE SPADE SUIT': 9828,
'WHITE SQUARE': 9633,
'WHITE SQUARE CONTAINING BLACK SMALL SQUARE': 9635,
'WHITE SQUARE WITH CENTRE VERTICAL LINE': 9093,
'WHITE SQUARE WITH LEFTWARDS TICK': 10212,
'WHITE SQUARE WITH LOWER LEFT QUADRANT': 9713,
'WHITE SQUARE WITH LOWER RIGHT QUADRANT': 9714,
'WHITE SQUARE WITH RIGHTWARDS TICK': 10213,
'WHITE SQUARE WITH ROUNDED CORNERS': 9634,
'WHITE SQUARE WITH UPPER LEFT QUADRANT': 9712,
'WHITE SQUARE WITH UPPER RIGHT QUADRANT': 9715,
'WHITE SQUARE WITH VERTICAL BISECTING LINE': 9707,
'WHITE STAR': 9734,
'WHITE SUN WITH RAYS': 9788,
'WHITE TELEPHONE': 9743,
'WHITE TRAPEZIUM': 9186,
'WHITE TRIANGLE CONTAINING SMALL WHITE TRIANGLE': 10177,
'WHITE TWO-WAY LEFT WAY TRAFFIC': 9943,
'WHITE UP POINTING INDEX': 9757,
'WHITE UP-POINTING SMALL TRIANGLE': 9653,
'WHITE UP-POINTING TRIANGLE': 9651,
'WHITE UP-POINTING TRIANGLE WITH DOT': 9708,
'WHITE VERTICAL BAR': 11006,
'WHITE VERTICAL ELLIPSE': 11055,
'WHITE VERTICAL RECTANGLE': 9647,
'WHITE VERY SMALL SQUARE': 11038,
'WHITE-FEATHERED RIGHTWARDS ARROW': 10163,
'WON SIGN': 8361,
'WORD JOINER': 8288,
'WORD SEPARATOR MIDDLE DOT': 11825,
'WREATH PRODUCT': 8768,
'WRITING HAND': 9997,
'X IN A RECTANGLE BOX': 8999,
'XOR': 8891,
'YEN SIGN': 165,
'YI RADICAL BBUT': 42139,
'YI RADICAL BUR': 42149,
'YI RADICAL CHE': 42179,
'YI RADICAL CIP': 42174,
'YI RADICAL CUOP': 42173,
'YI RADICAL CY': 42172,
'YI RADICAL CYP': 42132,
'YI RADICAL CYT': 42147,
'YI RADICAL DDUR': 42148,
'YI RADICAL DU': 42169,
'YI RADICAL GA': 42145,
'YI RADICAL GEP': 42135,
'YI RADICAL GGOP': 42134,
'YI RADICAL GGUO': 42150,
'YI RADICAL GOT': 42166,
'YI RADICAL HMO': 42157,
'YI RADICAL HXIT': 42137,
'YI RADICAL HXOP': 42175,
'YI RADICAL HXUO': 42143,
'YI RADICAL JJIE': 42167,
'YI RADICAL JJUT': 42154,
'YI RADICAL JJY': 42165,
'YI RADICAL JO': 42163,
'YI RADICAL KE': 42182,
'YI RADICAL KIT': 42130,
'YI RADICAL LI': 42129,
'YI RADICAL LIE': 42171,
'YI RADICAL LYR': 42138,
'YI RADICAL MI': 42136,
'YI RADICAL MOP': 42140,
'YI RADICAL NBIE': 42181,
'YI RADICAL NYIP': 42131,
'YI RADICAL NYOP': 42151,
'YI RADICAL NZUP': 42164,
'YI RADICAL OP': 42153,
'YI RADICAL PUT': 42142,
'YI RADICAL PYT': 42156,
'YI RADICAL QOT': 42128,
'YI RADICAL SHAT': 42176,
'YI RADICAL SHOP': 42178,
'YI RADICAL SHUR': 42170,
'YI RADICAL SHY': 42160,
'YI RADICAL SSI': 42133,
'YI RADICAL TAT': 42144,
'YI RADICAL TU': 42152,
'YI RADICAL VEP': 42161,
'YI RADICAL VUR': 42159,
'YI RADICAL WO': 42168,
'YI RADICAL YIT': 42158,
'YI RADICAL YO': 42141,
'YI RADICAL ZA': 42162,
'YI RADICAL ZOT': 42155,
'YI RADICAL ZUP': 42146,
'YI RADICAL ZUR': 42177,
'YI RADICAL ZZIET': 42180,
'YI SYLLABLE A': 40970,
'YI SYLLABLE AP': 40971,
'YI SYLLABLE AT': 40968,
'YI SYLLABLE AX': 40969,
'YI SYLLABLE BA': 40992,
'YI SYLLABLE BAP': 40993,
'YI SYLLABLE BAT': 40990,
'YI SYLLABLE BAX': 40991,
'YI SYLLABLE BBA': 41056,
'YI SYLLABLE BBAP': 41057,
'YI SYLLABLE BBAT': 41054,
'YI SYLLABLE BBAX': 41055,
'YI SYLLABLE BBE': 41066,
'YI SYLLABLE BBEP': 41067,
'YI SYLLABLE BBEX': 41065,
'YI SYLLABLE BBI': 41048,
'YI SYLLABLE BBIE': 41052,
'YI SYLLABLE BBIEP': 41053,
'YI SYLLABLE BBIET': 41050,
'YI SYLLABLE BBIEX': 41051,
'YI SYLLABLE BBIP': 41049,
'YI SYLLABLE BBIT': 41046,
'YI SYLLABLE BBIX': 41047,
'YI SYLLABLE BBO': 41063,
'YI SYLLABLE BBOP': 41064,
'YI SYLLABLE BBOT': 41061,
'YI SYLLABLE BBOX': 41062,
'YI SYLLABLE BBU': 41070,
'YI SYLLABLE BBUO': 41059,
'YI SYLLABLE BBUOP': 41060,
'YI SYLLABLE BBUOX': 41058,
'YI SYLLABLE BBUP': 41071,
'YI SYLLABLE BBUR': 41073,
'YI SYLLABLE BBURX': 41072,
'YI SYLLABLE BBUT': 41068,
'YI SYLLABLE BBUX': 41069,
'YI SYLLABLE BBY': 41076,
'YI SYLLABLE BBYP': 41077,
'YI SYLLABLE BBYT': 41074,
'YI SYLLABLE BBYX': 41075,
'YI SYLLABLE BE': 41002,
'YI SYLLABLE BEP': 41003,
'YI SYLLABLE BEX': 41001,
'YI SYLLABLE BI': 40984,
'YI SYLLABLE BIE': 40988,
'YI SYLLABLE BIEP': 40989,
'YI SYLLABLE BIET': 40986,
'YI SYLLABLE BIEX': 40987,
'YI SYLLABLE BIP': 40985,
'YI SYLLABLE BIT': 40982,
'YI SYLLABLE BIX': 40983,
'YI SYLLABLE BO': 40999,
'YI SYLLABLE BOP': 41000,
'YI SYLLABLE BOT': 40997,
'YI SYLLABLE BOX': 40998,
'YI SYLLABLE BU': 41006,
'YI SYLLABLE BUO': 40995,
'YI SYLLABLE BUOP': 40996,
'YI SYLLABLE BUOX': 40994,
'YI SYLLABLE BUP': 41007,
'YI SYLLABLE BUR': 41009,
'YI SYLLABLE BURX': 41008,
'YI SYLLABLE BUT': 41004,
'YI SYLLABLE BUX': 41005,
'YI SYLLABLE BY': 41012,
'YI SYLLABLE BYP': 41013,
'YI SYLLABLE BYR': 41015,
'YI SYLLABLE BYRX': 41014,
'YI SYLLABLE BYT': 41010,
'YI SYLLABLE BYX': 41011,
'YI SYLLABLE CA': 41656,
'YI SYLLABLE CAP': 41657,
'YI SYLLABLE CAT': 41654,
'YI SYLLABLE CAX': 41655,
'YI SYLLABLE CE': 41666,
'YI SYLLABLE CEP': 41667,
'YI SYLLABLE CEX': 41665,
'YI SYLLABLE CHA': 41827,
'YI SYLLABLE CHAP': 41828,
'YI SYLLABLE CHAT': 41825,
'YI SYLLABLE CHAX': 41826,
'YI SYLLABLE CHE': 41839,
'YI SYLLABLE CHEP': 41840,
'YI SYLLABLE CHET': 41837,
'YI SYLLABLE CHEX': 41838,
'YI SYLLABLE CHO': 41835,
'YI SYLLABLE CHOP': 41836,
'YI SYLLABLE CHOT': 41833,
'YI SYLLABLE CHOX': 41834,
'YI SYLLABLE CHU': 41842,
'YI SYLLABLE CHUO': 41831,
'YI SYLLABLE CHUOP': 41832,
'YI SYLLABLE CHUOT': 41829,
'YI SYLLABLE CHUOX': 41830,
'YI SYLLABLE CHUP': 41843,
'YI SYLLABLE CHUR': 41845,
'YI SYLLABLE CHURX': 41844,
'YI SYLLABLE CHUX': 41841,
'YI SYLLABLE CHY': 41848,
'YI SYLLABLE CHYP': 41849,
'YI SYLLABLE CHYR': 41851,
'YI SYLLABLE CHYRX': 41850,
'YI SYLLABLE CHYT': 41846,
'YI SYLLABLE CHYX': 41847,
'YI SYLLABLE CI': 41648,
'YI SYLLABLE CIE': 41652,
'YI SYLLABLE CIEP': 41653,
'YI SYLLABLE CIET': 41650,
'YI SYLLABLE CIEX': 41651,
'YI SYLLABLE CIP': 41649,
'YI SYLLABLE CIT': 41646,
'YI SYLLABLE CIX': 41647,
'YI SYLLABLE CO': 41663,
'YI SYLLABLE COP': 41664,
'YI SYLLABLE COT': 41661,
'YI SYLLABLE COX': 41662,
'YI SYLLABLE CU': 41670,
'YI SYLLABLE CUO': 41659,
'YI SYLLABLE CUOP': 41660,
'YI SYLLABLE CUOX': 41658,
'YI SYLLABLE CUP': 41671,
'YI SYLLABLE CUR': 41673,
'YI SYLLABLE CURX': 41672,
'YI SYLLABLE CUT': 41668,
'YI SYLLABLE CUX': 41669,
'YI SYLLABLE CY': 41676,
'YI SYLLABLE CYP': 41677,
'YI SYLLABLE CYR': 41679,
'YI SYLLABLE CYRX': 41678,
'YI SYLLABLE CYT': 41674,
'YI SYLLABLE CYX': 41675,
'YI SYLLABLE DA': 41225,
'YI SYLLABLE DAP': 41226,
'YI SYLLABLE DAT': 41223,
'YI SYLLABLE DAX': 41224,
'YI SYLLABLE DDA': 41279,
'YI SYLLABLE DDAP': 41280,
'YI SYLLABLE DDAT': 41277,
'YI SYLLABLE DDAX': 41278,
'YI SYLLABLE DDE': 41289,
'YI SYLLABLE DDEP': 41290,
'YI SYLLABLE DDEX': 41288,
'YI SYLLABLE DDI': 41272,
'YI SYLLABLE DDIE': 41275,
'YI SYLLABLE DDIEP': 41276,
'YI SYLLABLE DDIEX': 41274,
'YI SYLLABLE DDIP': 41273,
'YI SYLLABLE DDIT': 41270,
'YI SYLLABLE DDIX': 41271,
'YI SYLLABLE DDO': 41286,
'YI SYLLABLE DDOP': 41287,
'YI SYLLABLE DDOT': 41284,
'YI SYLLABLE DDOX': 41285,
'YI SYLLABLE DDU': 41293,
'YI SYLLABLE DDUO': 41282,
'YI SYLLABLE DDUOP': 41283,
'YI SYLLABLE DDUOX': 41281,
'YI SYLLABLE DDUP': 41294,
'YI SYLLABLE DDUR': 41296,
'YI SYLLABLE DDURX': 41295,
'YI SYLLABLE DDUT': 41291,
'YI SYLLABLE DDUX': 41292,
'YI SYLLABLE DE': 41234,
'YI SYLLABLE DEP': 41235,
'YI SYLLABLE DEX': 41233,
'YI SYLLABLE DI': 41218,
'YI SYLLABLE DIE': 41221,
'YI SYLLABLE DIEP': 41222,
'YI SYLLABLE DIEX': 41220,
'YI SYLLABLE DIP': 41219,
'YI SYLLABLE DIT': 41216,
'YI SYLLABLE DIX': 41217,
'YI SYLLABLE DO': 41231,
'YI SYLLABLE DOP': 41232,
'YI SYLLABLE DOT': 41229,
'YI SYLLABLE DOX': 41230,
'YI SYLLABLE DU': 41238,
'YI SYLLABLE DUO': 41228,
'YI SYLLABLE DUOX': 41227,
'YI SYLLABLE DUP': 41239,
'YI SYLLABLE DUR': 41241,
'YI SYLLABLE DURX': 41240,
'YI SYLLABLE DUT': 41236,
'YI SYLLABLE DUX': 41237,
'YI SYLLABLE E': 40980,
'YI SYLLABLE EX': 40979,
'YI SYLLABLE FA': 41171,
'YI SYLLABLE FAP': 41172,
'YI SYLLABLE FAT': 41169,
'YI SYLLABLE FAX': 41170,
'YI SYLLABLE FI': 41167,
'YI SYLLABLE FIP': 41168,
'YI SYLLABLE FIT': 41165,
'YI SYLLABLE FIX': 41166,
'YI SYLLABLE FO': 41174,
'YI SYLLABLE FOP': 41175,
'YI SYLLABLE FOX': 41173,
'YI SYLLABLE FU': 41178,
'YI SYLLABLE FUP': 41179,
'YI SYLLABLE FUR': 41181,
'YI SYLLABLE FURX': 41180,
'YI SYLLABLE FUT': 41176,
'YI SYLLABLE FUX': 41177,
'YI SYLLABLE FY': 41184,
'YI SYLLABLE FYP': 41185,
'YI SYLLABLE FYT': 41182,
'YI SYLLABLE FYX': 41183,
'YI SYLLABLE GA': 41444,
'YI SYLLABLE GAP': 41445,
'YI SYLLABLE GAT': 41442,
'YI SYLLABLE GAX': 41443,
'YI SYLLABLE GE': 41456,
'YI SYLLABLE GEP': 41457,
'YI SYLLABLE GET': 41454,
'YI SYLLABLE GEX': 41455,
'YI SYLLABLE GGA': 41500,
'YI SYLLABLE GGAP': 41501,
'YI SYLLABLE GGAT': 41498,
'YI SYLLABLE GGAX': 41499,
'YI SYLLABLE GGE': 41512,
'YI SYLLABLE GGEP': 41513,
'YI SYLLABLE GGET': 41510,
'YI SYLLABLE GGEX': 41511,
'YI SYLLABLE GGI': 41494,
'YI SYLLABLE GGIE': 41496,
'YI SYLLABLE GGIEP': 41497,
'YI SYLLABLE GGIEX': 41495,
'YI SYLLABLE GGIT': 41492,
'YI SYLLABLE GGIX': 41493,
'YI SYLLABLE GGO': 41508,
'YI SYLLABLE GGOP': 41509,
'YI SYLLABLE GGOT': 41506,
'YI SYLLABLE GGOX': 41507,
'YI SYLLABLE GGU': 41516,
'YI SYLLABLE GGUO': 41504,
'YI SYLLABLE GGUOP': 41505,
'YI SYLLABLE GGUOT': 41502,
'YI SYLLABLE GGUOX': 41503,
'YI SYLLABLE GGUP': 41517,
'YI SYLLABLE GGUR': 41519,
'YI SYLLABLE GGURX': 41518,
'YI SYLLABLE GGUT': 41514,
'YI SYLLABLE GGUX': 41515,
'YI SYLLABLE GI': 41436,
'YI SYLLABLE GIE': 41440,
'YI SYLLABLE GIEP': 41441,
'YI SYLLABLE GIET': 41438,
'YI SYLLABLE GIEX': 41439,
'YI SYLLABLE GIP': 41437,
'YI SYLLABLE GIT': 41434,
'YI SYLLABLE GIX': 41435,
'YI SYLLABLE GO': 41452,
'YI SYLLABLE GOP': 41453,
'YI SYLLABLE GOT': 41450,
'YI SYLLABLE GOX': 41451,
'YI SYLLABLE GU': 41460,
'YI SYLLABLE GUO': 41448,
'YI SYLLABLE GUOP': 41449,
'YI SYLLABLE GUOT': 41446,
'YI SYLLABLE GUOX': 41447,
'YI SYLLABLE GUP': 41461,
'YI SYLLABLE GUR': 41463,
'YI SYLLABLE GURX': 41462,
'YI SYLLABLE GUT': 41458,
'YI SYLLABLE GUX': 41459,
'YI SYLLABLE HA': 41587,
'YI SYLLABLE HAP': 41588,
'YI SYLLABLE HAT': 41585,
'YI SYLLABLE HAX': 41586,
'YI SYLLABLE HE': 41598,
'YI SYLLABLE HEP': 41599,
'YI SYLLABLE HEX': 41597,
'YI SYLLABLE HIE': 41584,
'YI SYLLABLE HIEX': 41583,
'YI SYLLABLE HIT': 41582,
'YI SYLLABLE HLA': 41376,
'YI SYLLABLE HLAP': 41377,
'YI SYLLABLE HLAT': 41374,
'YI SYLLABLE HLAX': 41375,
'YI SYLLABLE HLE': 41385,
'YI SYLLABLE HLEP': 41386,
'YI SYLLABLE HLEX': 41384,
'YI SYLLABLE HLI': 41369,
'YI SYLLABLE HLIE': 41372,
'YI SYLLABLE HLIEP': 41373,
'YI SYLLABLE HLIEX': 41371,
'YI SYLLABLE HLIP': 41370,
'YI SYLLABLE HLIT': 41367,
'YI SYLLABLE HLIX': 41368,
'YI SYLLABLE HLO': 41382,
'YI SYLLABLE HLOP': 41383,
'YI SYLLABLE HLOX': 41381,
'YI SYLLABLE HLU': 41389,
'YI SYLLABLE HLUO': 41379,
'YI SYLLABLE HLUOP': 41380,
'YI SYLLABLE HLUOX': 41378,
'YI SYLLABLE HLUP': 41390,
'YI SYLLABLE HLUR': 41392,
'YI SYLLABLE HLURX': 41391,
'YI SYLLABLE HLUT': 41387,
'YI SYLLABLE HLUX': 41388,
'YI SYLLABLE HLY': 41395,
'YI SYLLABLE HLYP': 41396,
'YI SYLLABLE HLYR': 41398,
'YI SYLLABLE HLYRX': 41397,
'YI SYLLABLE HLYT': 41393,
'YI SYLLABLE HLYX': 41394,
'YI SYLLABLE HMA': 41114,
'YI SYLLABLE HMAP': 41115,
'YI SYLLABLE HMAT': 41112,
'YI SYLLABLE HMAX': 41113,
'YI SYLLABLE HMI': 41107,
'YI SYLLABLE HMIE': 41110,
'YI SYLLABLE HMIEP': 41111,
'YI SYLLABLE HMIEX': 41109,
'YI SYLLABLE HMIP': 41108,
'YI SYLLABLE HMIT': 41105,
'YI SYLLABLE HMIX': 41106,
'YI SYLLABLE HMO': 41121,
'YI SYLLABLE HMOP': 41122,
'YI SYLLABLE HMOT': 41119,
'YI SYLLABLE HMOX': 41120,
'YI SYLLABLE HMU': 41125,
'YI SYLLABLE HMUO': 41117,
'YI SYLLABLE HMUOP': 41118,
'YI SYLLABLE HMUOX': 41116,
'YI SYLLABLE HMUP': 41126,
'YI SYLLABLE HMUR': 41128,
'YI SYLLABLE HMURX': 41127,
'YI SYLLABLE HMUT': 41123,
'YI SYLLABLE HMUX': 41124,
'YI SYLLABLE HMY': 41130,
'YI SYLLABLE HMYP': 41131,
'YI SYLLABLE HMYR': 41133,
'YI SYLLABLE HMYRX': 41132,
'YI SYLLABLE HMYX': 41129,
'YI SYLLABLE HNA': 41330,
'YI SYLLABLE HNAP': 41331,
'YI SYLLABLE HNAT': 41328,
'YI SYLLABLE HNAX': 41329,
'YI SYLLABLE HNE': 41338,
'YI SYLLABLE HNEP': 41339,
'YI SYLLABLE HNEX': 41337,
'YI SYLLABLE HNI': 41322,
'YI SYLLABLE HNIE': 41326,
'YI SYLLABLE HNIEP': 41327,
'YI SYLLABLE HNIET': 41324,
'YI SYLLABLE HNIEX': 41325,
'YI SYLLABLE HNIP': 41323,
'YI SYLLABLE HNIT': 41320,
'YI SYLLABLE HNIX': 41321,
'YI SYLLABLE HNOP': 41336,
'YI SYLLABLE HNOT': 41334,
'YI SYLLABLE HNOX': 41335,
'YI SYLLABLE HNUO': 41333,
'YI SYLLABLE HNUOX': 41332,
'YI SYLLABLE HNUT': 41340,
'YI SYLLABLE HO': 41595,
'YI SYLLABLE HOP': 41596,
'YI SYLLABLE HOT': 41593,
'YI SYLLABLE HOX': 41594,
'YI SYLLABLE HUO': 41591,
'YI SYLLABLE HUOP': 41592,
'YI SYLLABLE HUOT': 41589,
'YI SYLLABLE HUOX': 41590,
'YI SYLLABLE HXA': 41552,
'YI SYLLABLE HXAP': 41553,
'YI SYLLABLE HXAT': 41550,
'YI SYLLABLE HXAX': 41551,
'YI SYLLABLE HXE': 41563,
'YI SYLLABLE HXEP': 41564,
'YI SYLLABLE HXEX': 41562,
'YI SYLLABLE HXI': 41544,
'YI SYLLABLE HXIE': 41548,
'YI SYLLABLE HXIEP': 41549,
'YI SYLLABLE HXIET': 41546,
'YI SYLLABLE HXIEX': 41547,
'YI SYLLABLE HXIP': 41545,
'YI SYLLABLE HXIT': 41542,
'YI SYLLABLE HXIX': 41543,
'YI SYLLABLE HXO': 41560,
'YI SYLLABLE HXOP': 41561,
'YI SYLLABLE HXOT': 41558,
'YI SYLLABLE HXOX': 41559,
'YI SYLLABLE HXUO': 41556,
'YI SYLLABLE HXUOP': 41557,
'YI SYLLABLE HXUOT': 41554,
'YI SYLLABLE HXUOX': 41555,
'YI SYLLABLE I': 40962,
'YI SYLLABLE IE': 40966,
'YI SYLLABLE IEP': 40967,
'YI SYLLABLE IET': 40964,
'YI SYLLABLE IEX': 40965,
'YI SYLLABLE IP': 40963,
'YI SYLLABLE IT': 40960,
'YI SYLLABLE IX': 40961,
'YI SYLLABLE JI': 41954,
'YI SYLLABLE JIE': 41958,
'YI SYLLABLE JIEP': 41959,
'YI SYLLABLE JIET': 41956,
'YI SYLLABLE JIEX': 41957,
'YI SYLLABLE JIP': 41955,
'YI SYLLABLE JIT': 41952,
'YI SYLLABLE JIX': 41953,
'YI SYLLABLE JJI': 42010,
'YI SYLLABLE JJIE': 42014,
'YI SYLLABLE JJIEP': 42015,
'YI SYLLABLE JJIET': 42012,
'YI SYLLABLE JJIEX': 42013,
'YI SYLLABLE JJIP': 42011,
'YI SYLLABLE JJIT': 42008,
'YI SYLLABLE JJIX': 42009,
'YI SYLLABLE JJO': 42021,
'YI SYLLABLE JJOP': 42022,
'YI SYLLABLE JJOT': 42019,
'YI SYLLABLE JJOX': 42020,
'YI SYLLABLE JJU': 42025,
'YI SYLLABLE JJUO': 42017,
'YI SYLLABLE JJUOP': 42018,
'YI SYLLABLE JJUOX': 42016,
'YI SYLLABLE JJUP': 42026,
'YI SYLLABLE JJUR': 42028,
'YI SYLLABLE JJURX': 42027,
'YI SYLLABLE JJUT': 42023,
'YI SYLLABLE JJUX': 42024,
'YI SYLLABLE JJY': 42031,
'YI SYLLABLE JJYP': 42032,
'YI SYLLABLE JJYT': 42029,
'YI SYLLABLE JJYX': 42030,
'YI SYLLABLE JO': 41966,
'YI SYLLABLE JOP': 41967,
'YI SYLLABLE JOT': 41964,
'YI SYLLABLE JOX': 41965,
'YI SYLLABLE JU': 41970,
'YI SYLLABLE JUO': 41962,
'YI SYLLABLE JUOP': 41963,
'YI SYLLABLE JUOT': 41960,
'YI SYLLABLE JUOX': 41961,
'YI SYLLABLE JUP': 41971,
'YI SYLLABLE JUR': 41973,
'YI SYLLABLE JURX': 41972,
'YI SYLLABLE JUT': 41968,
'YI SYLLABLE JUX': 41969,
'YI SYLLABLE JY': 41976,
'YI SYLLABLE JYP': 41977,
'YI SYLLABLE JYR': 41979,
'YI SYLLABLE JYRX': 41978,
'YI SYLLABLE JYT': 41974,
'YI SYLLABLE JYX': 41975,
'YI SYLLABLE KA': 41473,
'YI SYLLABLE KAP': 41474,
'YI SYLLABLE KAT': 41471,
'YI SYLLABLE KAX': 41472,
'YI SYLLABLE KE': 41484,
'YI SYLLABLE KEP': 41485,
'YI SYLLABLE KET': 41482,
'YI SYLLABLE KEX': 41483,
'YI SYLLABLE KI': 41466,
'YI SYLLABLE KIE': 41469,
'YI SYLLABLE KIEP': 41470,
'YI SYLLABLE KIEX': 41468,
'YI SYLLABLE KIP': 41467,
'YI SYLLABLE KIT': 41464,
'YI SYLLABLE KIX': 41465,
'YI SYLLABLE KO': 41480,
'YI SYLLABLE KOP': 41481,
'YI SYLLABLE KOT': 41478,
'YI SYLLABLE KOX': 41479,
'YI SYLLABLE KU': 41488,
'YI SYLLABLE KUO': 41476,
'YI SYLLABLE KUOP': 41477,
'YI SYLLABLE KUOX': 41475,
'YI SYLLABLE KUP': 41489,
'YI SYLLABLE KUR': 41491,
'YI SYLLABLE KURX': 41490,
'YI SYLLABLE KUT': 41486,
'YI SYLLABLE KUX': 41487,
'YI SYLLABLE LA': 41409,
'YI SYLLABLE LAP': 41410,
'YI SYLLABLE LAT': 41407,
'YI SYLLABLE LAX': 41408,
'YI SYLLABLE LE': 41420,
'YI SYLLABLE LEP': 41421,
'YI SYLLABLE LEX': 41419,
'YI SYLLABLE LI': 41401,
'YI SYLLABLE LIE': 41405,
'YI SYLLABLE LIEP': 41406,
'YI SYLLABLE LIET': 41403,
'YI SYLLABLE LIEX': 41404,
'YI SYLLABLE LIP': 41402,
'YI SYLLABLE LIT': 41399,
'YI SYLLABLE LIX': 41400,
'YI SYLLABLE LO': 41417,
'YI SYLLABLE LOP': 41418,
'YI SYLLABLE LOT': 41415,
'YI SYLLABLE LOX': 41416,
'YI SYLLABLE LU': 41424,
'YI SYLLABLE LUO': 41413,
'YI SYLLABLE LUOP': 41414,
'YI SYLLABLE LUOT': 41411,
'YI SYLLABLE LUOX': 41412,
'YI SYLLABLE LUP': 41425,
'YI SYLLABLE LUR': 41427,
'YI SYLLABLE LURX': 41426,
'YI SYLLABLE LUT': 41422,
'YI SYLLABLE LUX': 41423,
'YI SYLLABLE LY': 41430,
'YI SYLLABLE LYP': 41431,
'YI SYLLABLE LYR': 41433,
'YI SYLLABLE LYRX': 41432,
'YI SYLLABLE LYT': 41428,
'YI SYLLABLE LYX': 41429,
'YI SYLLABLE MA': 41143,
'YI SYLLABLE MAP': 41144,
'YI SYLLABLE MAT': 41141,
'YI SYLLABLE MAX': 41142,
'YI SYLLABLE ME': 41154,
'YI SYLLABLE MEX': 41153,
'YI SYLLABLE MGA': 41524,
'YI SYLLABLE MGAP': 41525,
'YI SYLLABLE MGAT': 41522,
'YI SYLLABLE MGAX': 41523,
'YI SYLLABLE MGE': 41534,
'YI SYLLABLE MGEP': 41535,
'YI SYLLABLE MGEX': 41533,
'YI SYLLABLE MGIE': 41521,
'YI SYLLABLE MGIEX': 41520,
'YI SYLLABLE MGO': 41531,
'YI SYLLABLE MGOP': 41532,
'YI SYLLABLE MGOT': 41529,
'YI SYLLABLE MGOX': 41530,
'YI SYLLABLE MGU': 41538,
'YI SYLLABLE MGUO': 41527,
'YI SYLLABLE MGUOP': 41528,
'YI SYLLABLE MGUOX': 41526,
'YI SYLLABLE MGUP': 41539,
'YI SYLLABLE MGUR': 41541,
'YI SYLLABLE MGURX': 41540,
'YI SYLLABLE MGUT': 41536,
'YI SYLLABLE MGUX': 41537,
'YI SYLLABLE MI': 41136,
'YI SYLLABLE MIE': 41139,
'YI SYLLABLE MIEP': 41140,
'YI SYLLABLE MIEX': 41138,
'YI SYLLABLE MIP': 41137,
'YI SYLLABLE MIT': 41134,
'YI SYLLABLE MIX': 41135,
'YI SYLLABLE MO': 41151,
'YI SYLLABLE MOP': 41152,
'YI SYLLABLE MOT': 41149,
'YI SYLLABLE MOX': 41150,
'YI SYLLABLE MU': 41157,
'YI SYLLABLE MUO': 41147,
'YI SYLLABLE MUOP': 41148,
'YI SYLLABLE MUOT': 41145,
'YI SYLLABLE MUOX': 41146,
'YI SYLLABLE MUP': 41158,
'YI SYLLABLE MUR': 41160,
'YI SYLLABLE MURX': 41159,
'YI SYLLABLE MUT': 41155,
'YI SYLLABLE MUX': 41156,
'YI SYLLABLE MY': 41163,
'YI SYLLABLE MYP': 41164,
'YI SYLLABLE MYT': 41161,
'YI SYLLABLE MYX': 41162,
'YI SYLLABLE NA': 41349,
'YI SYLLABLE NAP': 41350,
'YI SYLLABLE NAX': 41348,
'YI SYLLABLE NBA': 41087,
'YI SYLLABLE NBAP': 41088,
'YI SYLLABLE NBAT': 41085,
'YI SYLLABLE NBAX': 41086,
'YI SYLLABLE NBI': 41080,
'YI SYLLABLE NBIE': 41083,
'YI SYLLABLE NBIEP': 41084,
'YI SYLLABLE NBIEX': 41082,
'YI SYLLABLE NBIP': 41081,
'YI SYLLABLE NBIT': 41078,
'YI SYLLABLE NBIX': 41079,
'YI SYLLABLE NBO': 41091,
'YI SYLLABLE NBOP': 41092,
'YI SYLLABLE NBOT': 41089,
'YI SYLLABLE NBOX': 41090,
'YI SYLLABLE NBU': 41095,
'YI SYLLABLE NBUP': 41096,
'YI SYLLABLE NBUR': 41098,
'YI SYLLABLE NBURX': 41097,
'YI SYLLABLE NBUT': 41093,
'YI SYLLABLE NBUX': 41094,
'YI SYLLABLE NBY': 41101,
'YI SYLLABLE NBYP': 41102,
'YI SYLLABLE NBYR': 41104,
'YI SYLLABLE NBYRX': 41103,
'YI SYLLABLE NBYT': 41099,
'YI SYLLABLE NBYX': 41100,
'YI SYLLABLE NDA': 41305,
'YI SYLLABLE NDAP': 41306,
'YI SYLLABLE NDAT': 41303,
'YI SYLLABLE NDAX': 41304,
'YI SYLLABLE NDE': 41312,
'YI SYLLABLE NDEP': 41313,
'YI SYLLABLE NDEX': 41311,
'YI SYLLABLE NDI': 41299,
'YI SYLLABLE NDIE': 41302,
'YI SYLLABLE NDIEX': 41301,
'YI SYLLABLE NDIP': 41300,
'YI SYLLABLE NDIT': 41297,
'YI SYLLABLE NDIX': 41298,
'YI SYLLABLE NDO': 41309,
'YI SYLLABLE NDOP': 41310,
'YI SYLLABLE NDOT': 41307,
'YI SYLLABLE NDOX': 41308,
'YI SYLLABLE NDU': 41316,
'YI SYLLABLE NDUP': 41317,
'YI SYLLABLE NDUR': 41319,
'YI SYLLABLE NDURX': 41318,
'YI SYLLABLE NDUT': 41314,
'YI SYLLABLE NDUX': 41315,
'YI SYLLABLE NE': 41359,
'YI SYLLABLE NEP': 41360,
'YI SYLLABLE NEX': 41358,
'YI SYLLABLE NGA': 41570,
'YI SYLLABLE NGAP': 41571,
'YI SYLLABLE NGAT': 41568,
'YI SYLLABLE NGAX': 41569,
'YI SYLLABLE NGE': 41580,
'YI SYLLABLE NGEP': 41581,
'YI SYLLABLE NGEX': 41579,
'YI SYLLABLE NGIE': 41566,
'YI SYLLABLE NGIEP': 41567,
'YI SYLLABLE NGIEX': 41565,
'YI SYLLABLE NGO': 41577,
'YI SYLLABLE NGOP': 41578,
'YI SYLLABLE NGOT': 41575,
'YI SYLLABLE NGOX': 41576,
'YI SYLLABLE NGUO': 41574,
'YI SYLLABLE NGUOT': 41572,
'YI SYLLABLE NGUOX': 41573,
'YI SYLLABLE NI': 41343,
'YI SYLLABLE NIE': 41346,
'YI SYLLABLE NIEP': 41347,
'YI SYLLABLE NIEX': 41345,
'YI SYLLABLE NIP': 41344,
'YI SYLLABLE NIT': 41341,
'YI SYLLABLE NIX': 41342,
'YI SYLLABLE NJI': 42035,
'YI SYLLABLE NJIE': 42039,
'YI SYLLABLE NJIEP': 42040,
'YI SYLLABLE NJIET': 42037,
'YI SYLLABLE NJIEX': 42038,
'YI SYLLABLE NJIP': 42036,
'YI SYLLABLE NJIT': 42033,
'YI SYLLABLE NJIX': 42034,
'YI SYLLABLE NJO': 42045,
'YI SYLLABLE NJOP': 42046,
'YI SYLLABLE NJOT': 42043,
'YI SYLLABLE NJOX': 42044,
'YI SYLLABLE NJU': 42048,
'YI SYLLABLE NJUO': 42042,
'YI SYLLABLE NJUOX': 42041,
'YI SYLLABLE NJUP': 42049,
'YI SYLLABLE NJUR': 42051,
'YI SYLLABLE NJURX': 42050,
'YI SYLLABLE NJUX': 42047,
'YI SYLLABLE NJY': 42054,
'YI SYLLABLE NJYP': 42055,
'YI SYLLABLE NJYR': 42057,
'YI SYLLABLE NJYRX': 42056,
'YI SYLLABLE NJYT': 42052,
'YI SYLLABLE NJYX': 42053,
'YI SYLLABLE NO': 41356,
'YI SYLLABLE NOP': 41357,
'YI SYLLABLE NOT': 41354,
'YI SYLLABLE NOX': 41355,
'YI SYLLABLE NRA': 41878,
'YI SYLLABLE NRAP': 41879,
'YI SYLLABLE NRAT': 41876,
'YI SYLLABLE NRAX': 41877,
'YI SYLLABLE NRE': 41885,
'YI SYLLABLE NREP': 41886,
'YI SYLLABLE NRET': 41883,
'YI SYLLABLE NREX': 41884,
'YI SYLLABLE NRO': 41881,
'YI SYLLABLE NROP': 41882,
'YI SYLLABLE NROX': 41880,
'YI SYLLABLE NRU': 41889,
'YI SYLLABLE NRUP': 41890,
'YI SYLLABLE NRUR': 41892,
'YI SYLLABLE NRURX': 41891,
'YI SYLLABLE NRUT': 41887,
'YI SYLLABLE NRUX': 41888,
'YI SYLLABLE NRY': 41895,
'YI SYLLABLE NRYP': 41896,
'YI SYLLABLE NRYR': 41898,
'YI SYLLABLE NRYRX': 41897,
'YI SYLLABLE NRYT': 41893,
'YI SYLLABLE NRYX': 41894,
'YI SYLLABLE NU': 41363,
'YI SYLLABLE NUO': 41352,
'YI SYLLABLE NUOP': 41353,
'YI SYLLABLE NUOX': 41351,
'YI SYLLABLE NUP': 41364,
'YI SYLLABLE NUR': 41366,
'YI SYLLABLE NURX': 41365,
'YI SYLLABLE NUT': 41361,
'YI SYLLABLE NUX': 41362,
'YI SYLLABLE NYI': 42060,
'YI SYLLABLE NYIE': 42064,
'YI SYLLABLE NYIEP': 42065,
'YI SYLLABLE NYIET': 42062,
'YI SYLLABLE NYIEX': 42063,
'YI SYLLABLE NYIP': 42061,
'YI SYLLABLE NYIT': 42058,
'YI SYLLABLE NYIX': 42059,
'YI SYLLABLE NYO': 42071,
'YI SYLLABLE NYOP': 42072,
'YI SYLLABLE NYOT': 42069,
'YI SYLLABLE NYOX': 42070,
'YI SYLLABLE NYU': 42075,
'YI SYLLABLE NYUO': 42067,
'YI SYLLABLE NYUOP': 42068,
'YI SYLLABLE NYUOX': 42066,
'YI SYLLABLE NYUP': 42076,
'YI SYLLABLE NYUT': 42073,
'YI SYLLABLE NYUX': 42074,
'YI SYLLABLE NZA': 41718,
'YI SYLLABLE NZAP': 41719,
'YI SYLLABLE NZAT': 41716,
'YI SYLLABLE NZAX': 41717,
'YI SYLLABLE NZE': 41725,
'YI SYLLABLE NZEX': 41724,
'YI SYLLABLE NZI': 41711,
'YI SYLLABLE NZIE': 41714,
'YI SYLLABLE NZIEP': 41715,
'YI SYLLABLE NZIEX': 41713,
'YI SYLLABLE NZIP': 41712,
'YI SYLLABLE NZIT': 41709,
'YI SYLLABLE NZIX': 41710,
'YI SYLLABLE NZOP': 41723,
'YI SYLLABLE NZOX': 41722,
'YI SYLLABLE NZU': 41727,
'YI SYLLABLE NZUO': 41721,
'YI SYLLABLE NZUOX': 41720,
'YI SYLLABLE NZUP': 41728,
'YI SYLLABLE NZUR': 41730,
'YI SYLLABLE NZURX': 41729,
'YI SYLLABLE NZUX': 41726,
'YI SYLLABLE NZY': 41733,
'YI SYLLABLE NZYP': 41734,
'YI SYLLABLE NZYR': 41736,
'YI SYLLABLE NZYRX': 41735,
'YI SYLLABLE NZYT': 41731,
'YI SYLLABLE NZYX': 41732,
'YI SYLLABLE O': 40977,
'YI SYLLABLE OP': 40978,
'YI SYLLABLE OT': 40975,
'YI SYLLABLE OX': 40976,
'YI SYLLABLE PA': 41025,
'YI SYLLABLE PAP': 41026,
'YI SYLLABLE PAT': 41023,
'YI SYLLABLE PAX': 41024,
'YI SYLLABLE PI': 41018,
'YI SYLLABLE PIE': 41021,
'YI SYLLABLE PIEP': 41022,
'YI SYLLABLE PIEX': 41020,
'YI SYLLABLE PIP': 41019,
'YI SYLLABLE PIT': 41016,
'YI SYLLABLE PIX': 41017,
'YI SYLLABLE PO': 41032,
'YI SYLLABLE POP': 41033,
'YI SYLLABLE POT': 41030,
'YI SYLLABLE POX': 41031,
'YI SYLLABLE PU': 41036,
'YI SYLLABLE PUO': 41028,
'YI SYLLABLE PUOP': 41029,
'YI SYLLABLE PUOX': 41027,
'YI SYLLABLE PUP': 41037,
'YI SYLLABLE PUR': 41039,
'YI SYLLABLE PURX': 41038,
'YI SYLLABLE PUT': 41034,
'YI SYLLABLE PUX': 41035,
'YI SYLLABLE PY': 41042,
'YI SYLLABLE PYP': 41043,
'YI SYLLABLE PYR': 41045,
'YI SYLLABLE PYRX': 41044,
'YI SYLLABLE PYT': 41040,
'YI SYLLABLE PYX': 41041,
'YI SYLLABLE QI': 41982,
'YI SYLLABLE QIE': 41986,
'YI SYLLABLE QIEP': 41987,
'YI SYLLABLE QIET': 41984,
'YI SYLLABLE QIEX': 41985,
'YI SYLLABLE QIP': 41983,
'YI SYLLABLE QIT': 41980,
'YI SYLLABLE QIX': 41981,
'YI SYLLABLE QO': 41994,
'YI SYLLABLE QOP': 41995,
'YI SYLLABLE QOT': 41992,
'YI SYLLABLE QOX': 41993,
'YI SYLLABLE QU': 41998,
'YI SYLLABLE QUO': 41990,
'YI SYLLABLE QUOP': 41991,
'YI SYLLABLE QUOT': 41988,
'YI SYLLABLE QUOX': 41989,
'YI SYLLABLE QUP': 41999,
'YI SYLLABLE QUR': 42001,
'YI SYLLABLE QURX': 42000,
'YI SYLLABLE QUT': 41996,
'YI SYLLABLE QUX': 41997,
'YI SYLLABLE QY': 42004,
'YI SYLLABLE QYP': 42005,
'YI SYLLABLE QYR': 42007,
'YI SYLLABLE QYRX': 42006,
'YI SYLLABLE QYT': 42002,
'YI SYLLABLE QYX': 42003,
'YI SYLLABLE RA': 41928,
'YI SYLLABLE RAP': 41929,
'YI SYLLABLE RAT': 41926,
'YI SYLLABLE RAX': 41927,
'YI SYLLABLE RE': 41938,
'YI SYLLABLE REP': 41939,
'YI SYLLABLE REX': 41937,
'YI SYLLABLE RO': 41935,
'YI SYLLABLE ROP': 41936,
'YI SYLLABLE ROT': 41933,
'YI SYLLABLE ROX': 41934,
'YI SYLLABLE RRA': 41853,
'YI SYLLABLE RRAX': 41852,
'YI SYLLABLE RRE': 41862,
'YI SYLLABLE RREP': 41863,
'YI SYLLABLE RRET': 41860,
'YI SYLLABLE RREX': 41861,
'YI SYLLABLE RRO': 41858,
'YI SYLLABLE RROP': 41859,
'YI SYLLABLE RROT': 41856,
'YI SYLLABLE RROX': 41857,
'YI SYLLABLE RRU': 41866,
'YI SYLLABLE RRUO': 41855,
'YI SYLLABLE RRUOX': 41854,
'YI SYLLABLE RRUP': 41867,
'YI SYLLABLE RRUR': 41869,
'YI SYLLABLE RRURX': 41868,
'YI SYLLABLE RRUT': 41864,
'YI SYLLABLE RRUX': 41865,
'YI SYLLABLE RRY': 41872,
'YI SYLLABLE RRYP': 41873,
'YI SYLLABLE RRYR': 41875,
'YI SYLLABLE RRYRX': 41874,
'YI SYLLABLE RRYT': 41870,
'YI SYLLABLE RRYX': 41871,
'YI SYLLABLE RU': 41942,
'YI SYLLABLE RUO': 41931,
'YI SYLLABLE RUOP': 41932,
'YI SYLLABLE RUOX': 41930,
'YI SYLLABLE RUP': 41943,
'YI SYLLABLE RUR': 41945,
'YI SYLLABLE RURX': 41944,
'YI SYLLABLE RUT': 41940,
'YI SYLLABLE RUX': 41941,
'YI SYLLABLE RY': 41948,
'YI SYLLABLE RYP': 41949,
'YI SYLLABLE RYR': 41951,
'YI SYLLABLE RYRX': 41950,
'YI SYLLABLE RYT': 41946,
'YI SYLLABLE RYX': 41947,
'YI SYLLABLE SA': 41746,
'YI SYLLABLE SAP': 41747,
'YI SYLLABLE SAT': 41744,
'YI SYLLABLE SAX': 41745,
'YI SYLLABLE SE': 41756,
'YI SYLLABLE SEP': 41757,
'YI SYLLABLE SEX': 41755,
'YI SYLLABLE SHA': 41901,
'YI SYLLABLE SHAP': 41902,
'YI SYLLABLE SHAT': 41899,
'YI SYLLABLE SHAX': 41900,
'YI SYLLABLE SHE': 41912,
'YI SYLLABLE SHEP': 41913,
'YI SYLLABLE SHET': 41910,
'YI SYLLABLE SHEX': 41911,
'YI SYLLABLE SHO': 41908,
'YI SYLLABLE SHOP': 41909,
'YI SYLLABLE SHOT': 41906,
'YI SYLLABLE SHOX': 41907,
'YI SYLLABLE SHU': 41916,
'YI SYLLABLE SHUO': 41904,
'YI SYLLABLE SHUOP': 41905,
'YI SYLLABLE SHUOX': 41903,
'YI SYLLABLE SHUP': 41917,
'YI SYLLABLE SHUR': 41919,
'YI SYLLABLE SHURX': 41918,
'YI SYLLABLE SHUT': 41914,
'YI SYLLABLE SHUX': 41915,
'YI SYLLABLE SHY': 41922,
'YI SYLLABLE SHYP': 41923,
'YI SYLLABLE SHYR': 41925,
'YI SYLLABLE SHYRX': 41924,
'YI SYLLABLE SHYT': 41920,
'YI SYLLABLE SHYX': 41921,
'YI SYLLABLE SI': 41739,
'YI SYLLABLE SIE': 41742,
'YI SYLLABLE SIEP': 41743,
'YI SYLLABLE SIEX': 41741,
'YI SYLLABLE SIP': 41740,
'YI SYLLABLE SIT': 41737,
'YI SYLLABLE SIX': 41738,
'YI SYLLABLE SO': 41753,
'YI SYLLABLE SOP': 41754,
'YI SYLLABLE SOT': 41751,
'YI SYLLABLE SOX': 41752,
'YI SYLLABLE SSA': 41779,
'YI SYLLABLE SSAP': 41780,
'YI SYLLABLE SSAT': 41777,
'YI SYLLABLE SSAX': 41778,
'YI SYLLABLE SSE': 41786,
'YI SYLLABLE SSEP': 41787,
'YI SYLLABLE SSEX': 41785,
'YI SYLLABLE SSI': 41772,
'YI SYLLABLE SSIE': 41775,
'YI SYLLABLE SSIEP': 41776,
'YI SYLLABLE SSIEX': 41774,
'YI SYLLABLE SSIP': 41773,
'YI SYLLABLE SSIT': 41770,
'YI SYLLABLE SSIX': 41771,
'YI SYLLABLE SSO': 41783,
'YI SYLLABLE SSOP': 41784,
'YI SYLLABLE SSOT': 41781,
'YI SYLLABLE SSOX': 41782,
'YI SYLLABLE SSU': 41790,
'YI SYLLABLE SSUP': 41791,
'YI SYLLABLE SSUT': 41788,
'YI SYLLABLE SSUX': 41789,
'YI SYLLABLE SSY': 41794,
'YI SYLLABLE SSYP': 41795,
'YI SYLLABLE SSYR': 41797,
'YI SYLLABLE SSYRX': 41796,
'YI SYLLABLE SSYT': 41792,
'YI SYLLABLE SSYX': 41793,
'YI SYLLABLE SU': 41760,
'YI SYLLABLE SUO': 41749,
'YI SYLLABLE SUOP': 41750,
'YI SYLLABLE SUOX': 41748,
'YI SYLLABLE SUP': 41761,
'YI SYLLABLE SUR': 41763,
'YI SYLLABLE SURX': 41762,
'YI SYLLABLE SUT': 41758,
'YI SYLLABLE SUX': 41759,
'YI SYLLABLE SY': 41766,
'YI SYLLABLE SYP': 41767,
'YI SYLLABLE SYR': 41769,
'YI SYLLABLE SYRX': 41768,
'YI SYLLABLE SYT': 41764,
'YI SYLLABLE SYX': 41765,
'YI SYLLABLE TA': 41251,
'YI SYLLABLE TAP': 41252,
'YI SYLLABLE TAT': 41249,
'YI SYLLABLE TAX': 41250,
'YI SYLLABLE TE': 41262,
'YI SYLLABLE TEP': 41263,
'YI SYLLABLE TEX': 41261,
'YI SYLLABLE TI': 41244,
'YI SYLLABLE TIE': 41247,
'YI SYLLABLE TIEP': 41248,
'YI SYLLABLE TIEX': 41246,
'YI SYLLABLE TIP': 41245,
'YI SYLLABLE TIT': 41242,
'YI SYLLABLE TIX': 41243,
'YI SYLLABLE TO': 41259,
'YI SYLLABLE TOP': 41260,
'YI SYLLABLE TOT': 41257,
'YI SYLLABLE TOX': 41258,
'YI SYLLABLE TU': 41266,
'YI SYLLABLE TUO': 41255,
'YI SYLLABLE TUOP': 41256,
'YI SYLLABLE TUOT': 41253,
'YI SYLLABLE TUOX': 41254,
'YI SYLLABLE TUP': 41267,
'YI SYLLABLE TUR': 41269,
'YI SYLLABLE TURX': 41268,
'YI SYLLABLE TUT': 41264,
'YI SYLLABLE TUX': 41265,
'YI SYLLABLE UO': 40973,
'YI SYLLABLE UOP': 40974,
'YI SYLLABLE UOX': 40972,
'YI SYLLABLE VA': 41196,
'YI SYLLABLE VAP': 41197,
'YI SYLLABLE VAT': 41194,
'YI SYLLABLE VAX': 41195,
'YI SYLLABLE VEP': 41203,
'YI SYLLABLE VEX': 41202,
'YI SYLLABLE VI': 41188,
'YI SYLLABLE VIE': 41192,
'YI SYLLABLE VIEP': 41193,
'YI SYLLABLE VIET': 41190,
'YI SYLLABLE VIEX': 41191,
'YI SYLLABLE VIP': 41189,
'YI SYLLABLE VIT': 41186,
'YI SYLLABLE VIX': 41187,
'YI SYLLABLE VO': 41200,
'YI SYLLABLE VOP': 41201,
'YI SYLLABLE VOT': 41198,
'YI SYLLABLE VOX': 41199,
'YI SYLLABLE VU': 41206,
'YI SYLLABLE VUP': 41207,
'YI SYLLABLE VUR': 41209,
'YI SYLLABLE VURX': 41208,
'YI SYLLABLE VUT': 41204,
'YI SYLLABLE VUX': 41205,
'YI SYLLABLE VY': 41212,
'YI SYLLABLE VYP': 41213,
'YI SYLLABLE VYR': 41215,
'YI SYLLABLE VYRX': 41214,
'YI SYLLABLE VYT': 41210,
'YI SYLLABLE VYX': 41211,
'YI SYLLABLE WA': 41602,
'YI SYLLABLE WAP': 41603,
'YI SYLLABLE WAT': 41600,
'YI SYLLABLE WAX': 41601,
'YI SYLLABLE WE': 41611,
'YI SYLLABLE WEP': 41612,
'YI SYLLABLE WEX': 41610,
'YI SYLLABLE WO': 41608,
'YI SYLLABLE WOP': 41609,
'YI SYLLABLE WOX': 41607,
'YI SYLLABLE WU': 40981,
'YI SYLLABLE WUO': 41605,
'YI SYLLABLE WUOP': 41606,
'YI SYLLABLE WUOX': 41604,
'YI SYLLABLE XI': 42079,
'YI SYLLABLE XIE': 42083,
'YI SYLLABLE XIEP': 42084,
'YI SYLLABLE XIET': 42081,
'YI SYLLABLE XIEX': 42082,
'YI SYLLABLE XIP': 42080,
'YI SYLLABLE XIT': 42077,
'YI SYLLABLE XIX': 42078,
'YI SYLLABLE XO': 42089,
'YI SYLLABLE XOP': 42090,
'YI SYLLABLE XOT': 42087,
'YI SYLLABLE XOX': 42088,
'YI SYLLABLE XUO': 42086,
'YI SYLLABLE XUOX': 42085,
'YI SYLLABLE XY': 42093,
'YI SYLLABLE XYP': 42094,
'YI SYLLABLE XYR': 42096,
'YI SYLLABLE XYRX': 42095,
'YI SYLLABLE XYT': 42091,
'YI SYLLABLE XYX': 42092,
'YI SYLLABLE YI': 42099,
'YI SYLLABLE YIE': 42103,
'YI SYLLABLE YIEP': 42104,
'YI SYLLABLE YIET': 42101,
'YI SYLLABLE YIEX': 42102,
'YI SYLLABLE YIP': 42100,
'YI SYLLABLE YIT': 42097,
'YI SYLLABLE YIX': 42098,
'YI SYLLABLE YO': 42111,
'YI SYLLABLE YOP': 42112,
'YI SYLLABLE YOT': 42109,
'YI SYLLABLE YOX': 42110,
'YI SYLLABLE YU': 42115,
'YI SYLLABLE YUO': 42107,
'YI SYLLABLE YUOP': 42108,
'YI SYLLABLE YUOT': 42105,
'YI SYLLABLE YUOX': 42106,
'YI SYLLABLE YUP': 42116,
'YI SYLLABLE YUR': 42118,
'YI SYLLABLE YURX': 42117,
'YI SYLLABLE YUT': 42113,
'YI SYLLABLE YUX': 42114,
'YI SYLLABLE YY': 42121,
'YI SYLLABLE YYP': 42122,
'YI SYLLABLE YYR': 42124,
'YI SYLLABLE YYRX': 42123,
'YI SYLLABLE YYT': 42119,
'YI SYLLABLE YYX': 42120,
'YI SYLLABLE ZA': 41622,
'YI SYLLABLE ZAP': 41623,
'YI SYLLABLE ZAT': 41620,
'YI SYLLABLE ZAX': 41621,
'YI SYLLABLE ZE': 41632,
'YI SYLLABLE ZEP': 41633,
'YI SYLLABLE ZEX': 41631,
'YI SYLLABLE ZHA': 41800,
'YI SYLLABLE ZHAP': 41801,
'YI SYLLABLE ZHAT': 41798,
'YI SYLLABLE ZHAX': 41799,
'YI SYLLABLE ZHE': 41811,
'YI SYLLABLE ZHEP': 41812,
'YI SYLLABLE ZHET': 41809,
'YI SYLLABLE ZHEX': 41810,
'YI SYLLABLE ZHO': 41807,
'YI SYLLABLE ZHOP': 41808,
'YI SYLLABLE ZHOT': 41805,
'YI SYLLABLE ZHOX': 41806,
'YI SYLLABLE ZHU': 41815,
'YI SYLLABLE ZHUO': 41803,
'YI SYLLABLE ZHUOP': 41804,
'YI SYLLABLE ZHUOX': 41802,
'YI SYLLABLE ZHUP': 41816,
'YI SYLLABLE ZHUR': 41818,
'YI SYLLABLE ZHURX': 41817,
'YI SYLLABLE ZHUT': 41813,
'YI SYLLABLE ZHUX': 41814,
'YI SYLLABLE ZHY': 41821,
'YI SYLLABLE ZHYP': 41822,
'YI SYLLABLE ZHYR': 41824,
'YI SYLLABLE ZHYRX': 41823,
'YI SYLLABLE ZHYT': 41819,
'YI SYLLABLE ZHYX': 41820,
'YI SYLLABLE ZI': 41615,
'YI SYLLABLE ZIE': 41618,
'YI SYLLABLE ZIEP': 41619,
'YI SYLLABLE ZIEX': 41617,
'YI SYLLABLE ZIP': 41616,
'YI SYLLABLE ZIT': 41613,
'YI SYLLABLE ZIX': 41614,
'YI SYLLABLE ZO': 41629,
'YI SYLLABLE ZOP': 41630,
'YI SYLLABLE ZOT': 41627,
'YI SYLLABLE ZOX': 41628,
'YI SYLLABLE ZU': 41636,
'YI SYLLABLE ZUO': 41625,
'YI SYLLABLE ZUOP': 41626,
'YI SYLLABLE ZUOX': 41624,
'YI SYLLABLE ZUP': 41637,
'YI SYLLABLE ZUR': 41639,
'YI SYLLABLE ZURX': 41638,
'YI SYLLABLE ZUT': 41634,
'YI SYLLABLE ZUX': 41635,
'YI SYLLABLE ZY': 41642,
'YI SYLLABLE ZYP': 41643,
'YI SYLLABLE ZYR': 41645,
'YI SYLLABLE ZYRX': 41644,
'YI SYLLABLE ZYT': 41640,
'YI SYLLABLE ZYX': 41641,
'YI SYLLABLE ZZA': 41690,
'YI SYLLABLE ZZAP': 41691,
'YI SYLLABLE ZZAT': 41688,
'YI SYLLABLE ZZAX': 41689,
'YI SYLLABLE ZZE': 41696,
'YI SYLLABLE ZZEP': 41697,
'YI SYLLABLE ZZEX': 41695,
'YI SYLLABLE ZZI': 41682,
'YI SYLLABLE ZZIE': 41686,
'YI SYLLABLE ZZIEP': 41687,
'YI SYLLABLE ZZIET': 41684,
'YI SYLLABLE ZZIEX': 41685,
'YI SYLLABLE ZZIP': 41683,
'YI SYLLABLE ZZIT': 41680,
'YI SYLLABLE ZZIX': 41681,
'YI SYLLABLE ZZO': 41693,
'YI SYLLABLE ZZOP': 41694,
'YI SYLLABLE ZZOX': 41692,
'YI SYLLABLE ZZU': 41699,
'YI SYLLABLE ZZUP': 41700,
'YI SYLLABLE ZZUR': 41702,
'YI SYLLABLE ZZURX': 41701,
'YI SYLLABLE ZZUX': 41698,
'YI SYLLABLE ZZY': 41705,
'YI SYLLABLE ZZYP': 41706,
'YI SYLLABLE ZZYR': 41708,
'YI SYLLABLE ZZYRX': 41707,
'YI SYLLABLE ZZYT': 41703,
'YI SYLLABLE ZZYX': 41704,
'YIN YANG': 9775,
'Z NOTATION BAG MEMBERSHIP': 8959,
'Z NOTATION DOMAIN ANTIRESTRICTION': 10852,
'Z NOTATION LEFT BINDING BRACKET': 10633,
'Z NOTATION LEFT IMAGE BRACKET': 10631,
'Z NOTATION RANGE ANTIRESTRICTION': 10853,
'Z NOTATION RELATIONAL COMPOSITION': 10814,
'Z NOTATION RIGHT BINDING BRACKET': 10634,
'Z NOTATION RIGHT IMAGE BRACKET': 10632,
'Z NOTATION SCHEMA COMPOSITION': 10783,
'Z NOTATION SCHEMA PIPING': 10784,
'Z NOTATION SCHEMA PROJECTION': 10785,
'Z NOTATION SPOT': 10625,
'Z NOTATION TYPE COLON': 10626,
'ZERO WIDTH JOINER': 8205,
'ZERO WIDTH NO-BREAK SPACE': 65279,
'ZERO WIDTH NON-JOINER': 8204,
'ZERO WIDTH SPACE': 8203,
}

_cjk_prefix = "CJK UNIFIED IDEOGRAPH-"
_hangul_prefix = 'HANGUL SYLLABLE '

_hangul_L = ['G', 'GG', 'N', 'D', 'DD', 'R', 'M', 'B', 'BB',
            'S', 'SS', '', 'J', 'JJ', 'C', 'K', 'T', 'P', 'H']
_hangul_V = ['A', 'AE', 'YA', 'YAE', 'EO', 'E', 'YEO', 'YE', 'O', 'WA', 'WAE',
            'OE', 'YO', 'U', 'WEO', 'WE', 'WI', 'YU', 'EU', 'YI', 'I']
_hangul_T = ['', 'G', 'GG', 'GS', 'N', 'NJ', 'NH', 'D', 'L', 'LG', 'LM',
            'LB', 'LS', 'LT', 'LP', 'LH', 'M', 'B', 'BS', 'S', 'SS',
            'NG', 'J', 'C', 'K', 'T', 'P', 'H']

def _lookup_hangul(syllables):
    l_code = v_code = t_code = -1
    for i in range(len(_hangul_L)):
        jamo = _hangul_L[i]
        if (syllables[:len(jamo)] == jamo and
            (l_code < 0 or len(jamo) > len(_hangul_L[l_code]))):
            l_code = i
    if l_code < 0:
        raise KeyError
    start = len(_hangul_L[l_code])

    for i in range(len(_hangul_V)):
        jamo = _hangul_V[i]
        if (syllables[start:start + len(jamo)] == jamo and
            (v_code < 0 or len(jamo) > len(_hangul_V[v_code]))):
            v_code = i
    if v_code < 0:
        raise KeyError
    start += len(_hangul_V[v_code])

    for i in range(len(_hangul_T)):
        jamo = _hangul_T[i]
        if (syllables[start:start + len(jamo)] == jamo and
            (t_code < 0 or len(jamo) > len(_hangul_T[t_code]))):
            t_code = i
    if t_code < 0:
        raise KeyError
    start += len(_hangul_T[t_code])

    if len(syllables[start:]):
        raise KeyError
    return 0xAC00 + (l_code * 21 + v_code) * 28 + t_code

def _lookup_cjk(cjk_code):
    if len(cjk_code) != 4 and len(cjk_code) != 5:
        raise KeyError
    for c in cjk_code:
        if not ('0' <= c <= '9' or 'A' <= c <= 'F'):
            raise KeyError
    code = int(cjk_code, 16)
    if (0x3400 <= code <= 0x4DB5 or 0x4E00 <= code <= 0x9FCB or 0x20000 <= code <= 0x2A6D6 or 0x2A700 <= code <= 0x2B734):
        return code
    raise KeyError

def lookup(name):
    if name[:len(_cjk_prefix)] == _cjk_prefix:
        return _lookup_cjk(name[len(_cjk_prefix):])
    if name[:len(_hangul_prefix)] == _hangul_prefix:
        return _lookup_hangul(name[len(_hangul_prefix):])

    if not base_mod:
        return trie_lookup(name)
    else:
        try:
            return _code_by_name[name]
        except KeyError:
            if name not in _code_by_name_corrected:
                return base_mod.trie_lookup(name)
            else:
                raise

def name(code):
    if (0x3400 <= code <= 0x4DB5 or 0x4E00 <= code <= 0x9FCB or 0x20000 <= code <= 0x2A6D6 or 0x2A700 <= code <= 0x2B734):
        return "CJK UNIFIED IDEOGRAPH-" + hex(code)[2:].upper()
    if 0xAC00 <= code <= 0xD7A3:
        # vl_code, t_code = divmod(code - 0xAC00, len(_hangul_T))
        vl_code = (code - 0xAC00) // len(_hangul_T)
        t_code = (code - 0xAC00) % len(_hangul_T)
        # l_code, v_code = divmod(vl_code,  len(_hangul_V))
        l_code = vl_code // len(_hangul_V)
        v_code = vl_code % len(_hangul_V)
        return ("HANGUL SYLLABLE " + _hangul_L[l_code] +
                _hangul_V[v_code] + _hangul_T[t_code])

    if not base_mod:
        return lookup_charcode(code)
    else:
        try:
            return _names[code]
        except KeyError:
            if code not in _names_corrected:
                return base_mod.lookup_charcode(code)
            else:
                raise

_db_records = [
('Cc', 'B', 'N', 5, 0),
('Cc', 'BN', 'N', 0, 0),
('Cc', 'S', 'N', 1, 0),
('Cc', 'S', 'N', 5, 0),
('Cc', 'WS', 'N', 5, 0),
('Cf', 'AN', 'N', 0, 0),
('Cf', 'BN', 'A', 0, 0),
('Cf', 'BN', 'N', 0, 0),
('Cf', 'L', 'N', 0, 0),
('Cf', 'LRE', 'N', 0, 0),
('Cf', 'LRO', 'N', 0, 0),
('Cf', 'ON', 'N', 0, 0),
('Cf', 'PDF', 'N', 0, 0),
('Cf', 'R', 'N', 0, 0),
('Cf', 'RLE', 'N', 0, 0),
('Cf', 'RLO', 'N', 0, 0),
('Cn', '', 'N', 0, 0),
('Cn', '', 'W', 0, 0),
('Co', 'L', 'A', 0, 0),
('Cs', 'L', 'N', 0, 0),
('Ll', 'L', 'A', 7202, 0),
('Ll', 'L', 'F', 7202, 0),
('Ll', 'L', 'N', 7202, 0),
('Ll', 'L', 'Na', 7202, 0),
('Lm', 'AL', 'N', 7170, 0),
('Lm', 'L', 'A', 7170, 0),
('Lm', 'L', 'H', 6146, 0),
('Lm', 'L', 'H', 7170, 0),
('Lm', 'L', 'N', 4098, 0),
('Lm', 'L', 'N', 7170, 0),
('Lm', 'L', 'W', 7170, 0),
('Lm', 'ON', 'A', 7170, 0),
('Lm', 'ON', 'N', 4098, 0),
('Lm', 'ON', 'N', 7170, 0),
('Lm', 'R', 'N', 7170, 0),
('Lo', 'AL', 'N', 4098, 0),
('Lo', 'AL', 'N', 7170, 0),
('Lo', 'L', 'H', 7170, 0),
('Lo', 'L', 'N', 6146, 0),
('Lo', 'L', 'N', 7170, 0),
('Lo', 'L', 'W', 7170, 0),
('Lo', 'L', 'W', 7234, 0),
('Lo', 'R', 'N', 7170, 0),
('Lt', 'L', 'N', 7186, 0),
('Lu', 'L', 'A', 7178, 0),
('Lu', 'L', 'F', 7178, 0),
('Lu', 'L', 'N', 7178, 0),
('Lu', 'L', 'Na', 7178, 0),
('Mc', 'L', 'N', 6144, 0),
('Mc', 'L', 'N', 6144, 9),
('Mc', 'L', 'N', 6144, 216),
('Mc', 'L', 'N', 6144, 226),
('Me', 'NSM', 'N', 4096, 0),
('Mn', 'L', 'N', 6144, 0),
('Mn', 'NSM', 'A', 6144, 0),
('Mn', 'NSM', 'A', 6144, 1),
('Mn', 'NSM', 'A', 6144, 202),
('Mn', 'NSM', 'A', 6144, 216),
('Mn', 'NSM', 'A', 6144, 220),
('Mn', 'NSM', 'A', 6144, 230),
('Mn', 'NSM', 'A', 6144, 232),
('Mn', 'NSM', 'A', 6144, 233),
('Mn', 'NSM', 'A', 6144, 234),
('Mn', 'NSM', 'A', 6144, 240),
('Mn', 'NSM', 'N', 6144, 0),
('Mn', 'NSM', 'N', 6144, 1),
('Mn', 'NSM', 'N', 6144, 7),
('Mn', 'NSM', 'N', 6144, 9),
('Mn', 'NSM', 'N', 6144, 10),
('Mn', 'NSM', 'N', 6144, 11),
('Mn', 'NSM', 'N', 6144, 12),
('Mn', 'NSM', 'N', 6144, 13),
('Mn', 'NSM', 'N', 6144, 14),
('Mn', 'NSM', 'N', 6144, 15),
('Mn', 'NSM', 'N', 6144, 16),
('Mn', 'NSM', 'N', 6144, 17),
('Mn', 'NSM', 'N', 6144, 18),
('Mn', 'NSM', 'N', 6144, 19),
('Mn', 'NSM', 'N', 6144, 20),
('Mn', 'NSM', 'N', 6144, 21),
('Mn', 'NSM', 'N', 6144, 22),
('Mn', 'NSM', 'N', 6144, 23),
('Mn', 'NSM', 'N', 6144, 24),
('Mn', 'NSM', 'N', 6144, 25),
('Mn', 'NSM', 'N', 6144, 26),
('Mn', 'NSM', 'N', 6144, 27),
('Mn', 'NSM', 'N', 6144, 28),
('Mn', 'NSM', 'N', 6144, 29),
('Mn', 'NSM', 'N', 6144, 30),
('Mn', 'NSM', 'N', 6144, 31),
('Mn', 'NSM', 'N', 6144, 32),
('Mn', 'NSM', 'N', 6144, 33),
('Mn', 'NSM', 'N', 6144, 34),
('Mn', 'NSM', 'N', 6144, 35),
('Mn', 'NSM', 'N', 6144, 36),
('Mn', 'NSM', 'N', 6144, 84),
('Mn', 'NSM', 'N', 6144, 91),
('Mn', 'NSM', 'N', 6144, 103),
('Mn', 'NSM', 'N', 6144, 107),
('Mn', 'NSM', 'N', 6144, 118),
('Mn', 'NSM', 'N', 6144, 122),
('Mn', 'NSM', 'N', 6144, 129),
('Mn', 'NSM', 'N', 6144, 130),
('Mn', 'NSM', 'N', 6144, 132),
('Mn', 'NSM', 'N', 6144, 202),
('Mn', 'NSM', 'N', 6144, 214),
('Mn', 'NSM', 'N', 6144, 216),
('Mn', 'NSM', 'N', 6144, 220),
('Mn', 'NSM', 'N', 6144, 222),
('Mn', 'NSM', 'N', 6144, 228),
('Mn', 'NSM', 'N', 6144, 230),
('Mn', 'NSM', 'N', 6144, 234),
('Mn', 'NSM', 'W', 6144, 8),
('Mn', 'NSM', 'W', 6144, 218),
('Mn', 'NSM', 'W', 6144, 222),
('Mn', 'NSM', 'W', 6144, 224),
('Mn', 'NSM', 'W', 6144, 228),
('Mn', 'NSM', 'W', 6144, 232),
('Nd', 'AN', 'N', 6592, 0),
('Nd', 'EN', 'F', 6592, 0),
('Nd', 'EN', 'N', 6592, 0),
('Nd', 'EN', 'Na', 6592, 0),
('Nd', 'L', 'N', 6592, 0),
('Nd', 'R', 'N', 6592, 0),
('Nl', 'L', 'A', 7232, 0),
('Nl', 'L', 'N', 7168, 0),
('Nl', 'L', 'N', 7232, 0),
('Nl', 'L', 'W', 7232, 0),
('Nl', 'ON', 'N', 7232, 0),
('No', 'AN', 'N', 4160, 0),
('No', 'AN', 'N', 4288, 0),
('No', 'EN', 'A', 4160, 0),
('No', 'EN', 'A', 4288, 0),
('No', 'EN', 'N', 4288, 0),
('No', 'L', 'N', 4160, 0),
('No', 'L', 'N', 6336, 0),
('No', 'L', 'W', 4160, 0),
('No', 'ON', 'A', 4160, 0),
('No', 'ON', 'A', 4288, 0),
('No', 'ON', 'N', 4160, 0),
('No', 'ON', 'N', 4288, 0),
('No', 'ON', 'W', 4160, 0),
('No', 'R', 'N', 4160, 0),
('No', 'R', 'N', 4288, 0),
('Pc', 'ON', 'F', 6144, 0),
('Pc', 'ON', 'N', 6144, 0),
('Pc', 'ON', 'Na', 6144, 0),
('Pc', 'ON', 'W', 6144, 0),
('Pd', 'ES', 'F', 4096, 0),
('Pd', 'ES', 'Na', 4096, 0),
('Pd', 'ES', 'W', 4096, 0),
('Pd', 'ON', 'A', 4096, 0),
('Pd', 'ON', 'N', 4096, 0),
('Pd', 'ON', 'W', 4096, 0),
('Pd', 'R', 'N', 4096, 0),
('Pe', 'ON', 'F', 4608, 0),
('Pe', 'ON', 'H', 4608, 0),
('Pe', 'ON', 'N', 4096, 0),
('Pe', 'ON', 'N', 4608, 0),
('Pe', 'ON', 'Na', 4608, 0),
('Pe', 'ON', 'W', 4096, 0),
('Pe', 'ON', 'W', 4608, 0),
('Pf', 'ON', 'A', 4096, 0),
('Pf', 'ON', 'N', 4608, 0),
('Pi', 'ON', 'A', 4096, 0),
('Pi', 'ON', 'N', 4096, 0),
('Pi', 'ON', 'N', 4608, 0),
('Po', 'AL', 'N', 4096, 0),
('Po', 'AN', 'N', 4096, 0),
('Po', 'CS', 'F', 4096, 0),
('Po', 'CS', 'N', 4096, 0),
('Po', 'CS', 'Na', 4096, 0),
('Po', 'CS', 'W', 4096, 0),
('Po', 'ET', 'A', 4096, 0),
('Po', 'ET', 'F', 4096, 0),
('Po', 'ET', 'N', 4096, 0),
('Po', 'ET', 'Na', 4096, 0),
('Po', 'ET', 'W', 4096, 0),
('Po', 'L', 'N', 4096, 0),
('Po', 'ON', 'A', 4096, 0),
('Po', 'ON', 'A', 6144, 0),
('Po', 'ON', 'F', 4096, 0),
('Po', 'ON', 'H', 4096, 0),
('Po', 'ON', 'N', 4096, 0),
('Po', 'ON', 'N', 6144, 0),
('Po', 'ON', 'Na', 4096, 0),
('Po', 'ON', 'W', 4096, 0),
('Po', 'R', 'N', 4096, 0),
('Ps', 'ON', 'F', 4608, 0),
('Ps', 'ON', 'H', 4608, 0),
('Ps', 'ON', 'N', 4096, 0),
('Ps', 'ON', 'N', 4608, 0),
('Ps', 'ON', 'Na', 4608, 0),
('Ps', 'ON', 'W', 4096, 0),
('Ps', 'ON', 'W', 4608, 0),
('Sc', 'AL', 'N', 4096, 0),
('Sc', 'ET', 'A', 4096, 0),
('Sc', 'ET', 'F', 4096, 0),
('Sc', 'ET', 'H', 4096, 0),
('Sc', 'ET', 'N', 4096, 0),
('Sc', 'ET', 'Na', 4096, 0),
('Sc', 'ET', 'W', 4096, 0),
('Sk', 'L', 'N', 4096, 0),
('Sk', 'ON', 'A', 4096, 0),
('Sk', 'ON', 'F', 4096, 0),
('Sk', 'ON', 'N', 4096, 0),
('Sk', 'ON', 'Na', 4096, 0),
('Sk', 'ON', 'W', 4096, 0),
('Sm', 'AL', 'N', 4096, 0),
('Sm', 'CS', 'N', 4096, 0),
('Sm', 'ES', 'F', 4096, 0),
('Sm', 'ES', 'N', 4096, 0),
('Sm', 'ES', 'Na', 4096, 0),
('Sm', 'ES', 'W', 4096, 0),
('Sm', 'ET', 'A', 4096, 0),
('Sm', 'ET', 'N', 4096, 0),
('Sm', 'L', 'N', 4096, 0),
('Sm', 'ON', 'A', 4096, 0),
('Sm', 'ON', 'A', 4608, 0),
('Sm', 'ON', 'F', 4096, 0),
('Sm', 'ON', 'F', 4608, 0),
('Sm', 'ON', 'H', 4096, 0),
('Sm', 'ON', 'N', 4096, 0),
('Sm', 'ON', 'N', 4608, 0),
('Sm', 'ON', 'Na', 4096, 0),
('Sm', 'ON', 'Na', 4608, 0),
('Sm', 'ON', 'W', 4096, 0),
('Sm', 'ON', 'W', 4608, 0),
('So', 'AL', 'N', 4096, 0),
('So', 'ET', 'A', 4096, 0),
('So', 'ET', 'N', 4096, 0),
('So', 'ET', 'N', 7168, 0),
('So', 'L', 'A', 4096, 0),
('So', 'L', 'N', 4096, 0),
('So', 'L', 'W', 4096, 0),
('So', 'ON', 'A', 4096, 0),
('So', 'ON', 'F', 4096, 0),
('So', 'ON', 'H', 4096, 0),
('So', 'ON', 'N', 4096, 0),
('So', 'ON', 'N', 7168, 0),
('So', 'ON', 'Na', 4096, 0),
('So', 'ON', 'W', 4096, 0),
('Zl', 'WS', 'N', 5, 0),
('Zp', 'B', 'N', 5, 0),
('Zs', 'CS', 'N', 1, 0),
('Zs', 'WS', 'F', 1, 0),
('Zs', 'WS', 'N', 1, 0),
('Zs', 'WS', 'Na', 4097, 0),
]
_db_pgtbl = (
'\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123455565575555'
'555555555555589:5;5<55=5>55555?@55AB555C5555555D555E55F555555555'
'G555H5555555IJ55555555K55555555LM555N\x15OPQRST55555555555555555555'
'55555555555555555555555UVVVVVVVVWWWWWWWWWWWWWWWWWWWWWWWWWXYZ[\\]^'
'_`abcdddefghidjdkddddddddddddddd\x15\x15\x15lmddddddddddd\x15\x15\x15\x15nddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'ddddddddddddddddopqrstuvddddddddddddddddddddddddwxyddddddddddddd'
'z{5555555|}~55555555555555555555555\x7f55555\x8055555555555555555\x815555'
'5555555555555555555555555555555555\x8255555555555555555555555555555'
'55555555555555555555555555555555555555\x835555555555555555\x84\x85\x85\x85\x85\x85\x85\x85\x85'
'\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x7f5\x86\x85\x85\x85\x85\x87'
'\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85'
'\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85'
'\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85'
'\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x85\x87'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'\x88\x89dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd'
'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW'
'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW'
'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW'
'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW\x8a'
'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW'
'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW'
'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW'
'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW\x8a'
)
_db_pages = ( 
'\x01\x01\x01\x01\x01\x01\x01\x01\x01\x02\x00\x03\x04\x00\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x00\x00\x00\x02\xf7\xb9\xb9\xb0\xc8\xb0\xb9\xb9\xc0\x9f\xb9\xd4\xab\x95\xab\xabyyyyyyyyyy\xab\xb9\xe1\xe0\xe1\xb9'
'\xb9//////////////////////////\xc0\xb9\x9f\xce\x92\xce\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\xc0\xe0\x9f\xe0\x01'
'\x01\x01\x01\x01\x01\x00\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\xf4\xb3\xc8\xc8\xc4\xc8\xf0\xeb\xcb\xee\x14\xa6\xe0\x06\xeb\xce\xe5\xd6\x84\x84\xcb\x16\xeb\xb4\xcb\x84\x14\xa3\x89\x89\x89\xb3'
'......,.........,......\xd9,.....,\x14\x14\x14\x16\x16\x16\x16\x14\x16\x14\x14\x14\x16\x14\x14\x16\x16\x14\x16\x14\x14\x16\x16\x16\xd9\x14\x14\x14\x16\x14\x16\x14\x16'
'.\x14.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x14.\x14.\x16.\x16.\x16.\x14.\x16.\x16.\x16.\x16.\x16,\x14.\x16.\x14.\x16.\x16.\x14,\x14.\x16.\x16\x14.\x16.\x16.\x16,'
'\x14,\x14.\x14.\x16.\x14\x14,\x14.\x14.\x16.\x16,\x14.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16,\x14.\x16.\x14.\x16.\x16.\x16.\x16.\x16.\x16..\x16.\x16.\x16\x16'
"\x16..\x16.\x16..\x16...\x16\x16....\x16..\x16...\x16\x16\x16..\x16..\x16.\x16.\x16..\x16.\x16\x16.\x16..\x16...\x16.\x16..\x16\x16'.\x16\x16\x16"
"''''.+\x16.+\x16.+\x16.\x14.\x14.\x14.\x14.\x14.\x14.\x14.\x14\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16\x16.+\x16.\x16...\x16.\x16.\x16.\x16"
'.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16\x16\x16\x16\x16\x16\x16..\x16..\x16'
'\x16.\x16....\x16.\x16.\x16.\x16.\x16\x16\x14\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x14\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16'
"\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16'\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d!!\x1d\x1d\x1d\x1d\x1d"
'\x1d\x1d\xcd\xcd\xcb\xcd!\x1f!\x1f\x1f\x1f!\x1f!!\x19\x1d\xcd\xcd\xcd\xcd\xcd\xcd\xcb\xcb\xcb\xcb\xcd\xcb\xcd\xcb\x1d\x1d\x1d\x1d\x1d\xcd\xcd\xcd\xcd\xcd\xcd\xcd!\xcd\x1d\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd'
';;;;;;;;;;;;;;;;;;;;;<::::<9:::::88::::88:::::::::::77777::::;;;'
';;;;;?;:::;;;::6;;;::::;<::;=>>=>>=;;;;;;;;;;;;;.\x16.\x16!\xcd.\x16\x10\x10\x1c\x16\x16\x16\xb7\x10'
'\x10\x10\x10\x10\xcd\xcd.\xb8...\x10.\x10..\x16,,,,,,,,,,,,,,,,,\x10,,,,,,,..\x16\x16\x16\x16\x16\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14'
'\x14\x14\x16\x14\x14\x14\x14\x14\x14\x14\x16\x16\x16\x16\x16.\x16\x16...\x16\x16\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16\x16\x16\x16\x16.\x16\xde.\x16..\x16\x16...'
'.,..............,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14'
'\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x16\x14\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16'
'.\x16\xe9nnnnn44.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16'
'..\x16.\x16.\x16.\x16.\x16.\x16.\x16\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16'
'.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10...............'
'.......................\x10\x10\x1d\xb2\xb2\xb2\xb2\xb2\xb2\x10\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16'
'\x16\x16\x16\x16\x16\x16\x16\x16\x10\xb2\x98\x10\x10\x10\x10\x10\x10knnnnknnnlknnnnnnkkkkkknnknnlmnDEFGHIJKLMMNOP\x9aQ'
'\xbbRS\xbbnk\xbbL\x10\x10\x10\x10\x10\x10\x10\x10***************************\x10\x10\x10\x10\x10***\xbb\xbb\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x05\x05\x05\x05\x10\x10\xde\xde\xd0\xaf\xaf\xc3\xaa\xa7\xee\xeennnnnnnnXYZ\xa7\x10\x10\xa7\xa7\x10$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
'\x18$$$$$$$$$$UVWXYZ[\\nnkknnnnnknn\x10vvvvvvvvvv\xaf\xa8\xa8\xa7$$]$$$$$$$$$$$$$$$'
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
'$$$$$$$$$$$$$$$$$$$$\xa7$nnnnnnn\x054nnnnkn\x18\x18nn\xeeknnk$$xxxxxxxxxx$$$\xe4\xe4$'
'\xa7\xa7\xa7\xa7\xa7\xa7\xa7\xa7\xa7\xa7\xa7\xa7\xa7\xa7\x10\x07$^$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$nknnknnkkknkknkn'
'nnknknknknn\x10\x10$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$@@@@@@@@@@@$\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'{{{{{{{{{{*********************************nnnnnnnkn""\xee\xb7\xb7\xb7"\x10\x10\x10\x10\x10'
'**********************nnnn"nnnnnnnnn"nnn"nnnnn\x10\x10\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
"@@@0''''''''''''''''''''''''''''''''''''''''''''''''''''''\x10\x10B'00"
"0@@@@@@@@0000C0\x10'nknn@\x10\x10''''''''''@@\xb2\xb2zzzzzzzzzz\xb2\x1d'\x10\x10\x10\x10\x10\x10'''''''"
"\x10@00\x10''''''''\x10\x10''\x10\x10''''''''''''''''''''''\x10'''''''\x10'\x10\x10\x10''''\x10\x10B'00"
"0@@@@\x10\x1000\x10\x1000C'\x10\x10\x10\x10\x10\x10\x10\x100\x10\x10\x10\x10''\x10'''@@\x10\x10zzzzzzzzzz''\xc7\xc7\x86\x86\x86\x86\x86\x86\xe9\xc7\x10\x10\x10\x10"
"\x10@@0\x10''''''\x10\x10\x10\x10''\x10\x10''''''''''''''''''''''\x10'''''''\x10''\x10''\x10''\x10\x10B\x1000"
"0@@\x10\x10\x10\x10@@\x10\x10@@C\x10\x10\x10@\x10\x10\x10\x10\x10\x10\x10''''\x10'\x10\x10\x10\x10\x10\x10\x10zzzzzzzzzz@@'''@\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
"\x10@@0\x10'''''''''\x10'''\x10''''''''''''''''''''''\x10'''''''\x10''\x10'''''\x10\x10B'00"
"0@@@@@\x10@@0\x1000C\x10\x10'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10''@@\x10\x10zzzzzzzzzz\x10\xc7\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
"\x10@00\x10''''''''\x10\x10''\x10\x10''''''''''''''''''''''\x10'''''''\x10''\x10'''''\x10\x10B'0@"
"0@@@@\x10\x1000\x10\x1000C\x10\x10\x10\x10\x10\x10\x10\x10@0\x10\x10\x10\x10''\x10'''@@\x10\x10zzzzzzzzzz\xe9'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
"\x10\x10@'\x10''''''\x10\x10\x10'''\x10''''\x10\x10\x10''\x10'\x10''\x10\x10\x10''\x10\x10\x10'''\x10\x10\x10''''''''''''\x10\x10\x10\x1000"
"@00\x10\x10\x10000\x10000C\x10\x10'\x10\x10\x10\x10\x10\x100\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10zzzzzzzzzz\x86\x86\x86\xee\xee\xee\xee\xee\xee\xc7\xee\x10\x10\x10\x10\x10"
"\x10000\x10''''''''\x10'''\x10'''''''''''''''''''''''\x10''''''''''\x10'''''\x10\x10\x10'@@"
"@0000\x10@@@\x10@@@C\x10\x10\x10\x10\x10\x10\x10_`\x10''\x10\x10\x10\x10\x10\x10''@@\x10\x10zzzzzzzzzz\x10\x10\x10\x10\x10\x10\x10\x10\x8b\x8b\x8b\x8b\x8b\x8b\x8b\xe9"
"\x10\x1000\x10''''''''\x10'''\x10'''''''''''''''''''''''\x10''''''''''\x10'''''\x10\x10B'05"
"00000\x10500\x1000@C\x10\x10\x10\x10\x10\x10\x1000\x10\x10\x10\x10\x10\x10\x10'\x10''@@\x10\x10zzzzzzzzzz\x10\xee\xee\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
"\x10\x1000\x10''''''''\x10'''\x10'''''''''''''''''''''''\x10''''''''''''''''\x10\x10\x10'00"
"0@@@@\x10000\x10000C\x10\x10\x10\x10\x10\x10\x10\x10\x100\x10\x10\x10\x10\x10\x10\x10\x10''@@\x10\x10zzzzzzzzzz\x86\x86\x86\x86\x86\x86\x10\x10\x10\xe9''''''"
"\x10\x1000\x10''''''''''''''''''\x10\x10\x10''''''''''''''''''''''''\x10'''''''''\x10'\x10\x10"
"'''''''\x10\x10\x10C\x10\x10\x10\x10000@@@\x10@\x1000000000\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x1000\xb2\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
"\x10''''''''''''''''''''''''''''''''''''''''''''''''@'&@@@@aaC\x10\x10\x10\x10\xc7"
"''''''\x1d@bbbb@@@\xb2zzzzzzzzzz\xb2\xb2\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
"\x10''\x10'\x10\x10''\x10'\x10\x10'\x10\x10\x10\x10\x10\x10''''\x10'''''''\x10'''\x10'\x10'\x10\x10''\x10''''@'&@@@@cc\x10@@'\x10\x10"
"'''''\x10\x1d\x10dddd@@\x10\x10zzzzzzzzzz\x10\x10''\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
"'\xe9\xe9\xe9\xb2\xb2\xb2\xb2\xb2\xb2\xb2\xb2\xb2\xb2\xb2\xb2\xb2\xb2\xb2\xe9\xe9\xe9\xe9\xe9kk\xe9\xe9\xe9\xe9\xe9\xe9zzzzzzzzzz\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\xe9k\xe9k\xe9j\xbf\x9e\xbf\x9e00"
"''''''''\x10''''''''''''''''''''''''''''''''''''\x10\x10\x10\x10ef@g@@@@@ffff@0"
"f@nnC\xb2nn''''\x10\x10\x10\x10@@@@@@@@\x10@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\x10\xe9\xe9"
'\xe9\xe9\xe9\xe9\xe9\xe9k\xe9\xe9\xe9\xe9\xe9\xe9\x10\xe9\xe9\xb2\xb2\xb2\xb2\xb2\xe9\xe9\xe9\xe9\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
"'''''''''''''''''''''''''''''''''''''''''''00@@@@0@@@@@B0CC00@@'"
"zzzzzzzzzz\xb2\xb2\xb2\xb2\xb2\xb2''''''00@@''''@@@'000''0000000'''@@@@'''''''''''"
"''@00@@000000k'0zzzzzzzzzz000@\xe9\xe9................................"
"......\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'''''''''''''''''''''''''''''''''''''''''''\xb2\x1d\x10\x10\x10"
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
"((((((((((((((((((((((((((((((((''''''''''''''''''''''''''''''''"
"'''''''''''''''''''''''''''''''''''(((((''''''''''''''''''''''''"
"''''''''''''''''''''''''''''''''''''''''''''''''''''''''''(((((("
"''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''"
"'''''''''\x10''''\x10\x10'''''''\x10'\x10''''\x10\x10''''''''''''''''''''''''''''''''"
"'''''''''\x10''''\x10\x10'''''''''''''''''''''''''''''''''\x10''''\x10\x10'''''''\x10"
"'\x10''''\x10\x10'''''''''''''''\x10''''''''''''''''''''''''''''''''''''''''"
"'''''''''''''''''\x10''''\x10\x10''''''''''''''''''''''''''''''''''''''''"
"'''''''''''''''''''''''''''\x10\x10\x10\x10n\xe9\xb2\xb2\xb2\xb2\xb2\xb2\xb2\xb2\x87\x87\x87\x87\x87\x87\x87\x87\x87\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x10\x10\x10"
"''''''''''''''''\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\x10\x10\x10\x10\x10\x10''''''''''''''''''''''''''''''''"
"'''''''''''''''''''''''''''''''''''''''''''''''''''''\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
"\x98'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''"
"''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''"
"''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''"
"''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''"
"''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''"
"''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''"
"''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''"
"''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''"
"''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''"
"'''''''''''''''''''''''''''''''''''''''''''''\xb2\xb2'''''''''''''''''"
"\xf6''''''''''''''''''''''''''\xbf\x9e\x10\x10\x10''''''''''''''''''''''''''''''''"
"'''''''''''''''''''''''''''''''''''''''''''\xb2\xb2\xb2~~~\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
"'''''''''''''\x10''''@@C\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10''''''''''''''''''@@C\xb2\xb2\x10\x10\x10\x10\x10\x10\x10\x10\x10"
"''''''''''''''''''@@\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'''''''''''''\x10'''\x10@@\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
"''''''''''''''''''''''''''''''''''''''''''''''''''''\x08\x080@@@@@@@00"
"000000@00@@@@@@@@@C@\xb2\xb2\xb2\x1d\xb2\xb2\xb2\xc7'n\x10\x10zzzzzzzzzz\x10\x10\x10\x10\x10\x10\x8b\x8b\x8b\x8b\x8b\x8b\x8b\x8b\x8b\x8b\x10\x10\x10\x10\x10\x10"
"\xb7\xb7\xb7\xb7\xb7\xb7\x98\xb7\xb7\xb7\xb7@@@\xf6\x10zzzzzzzzzz\x10\x10\x10\x10\x10\x10''''''''''''''''''''''''''''''''"
"'''\x1d''''''''''''''''''''''''''''''''''''''''''''''''''''\x10\x10\x10\x10\x10\x10\x10\x10"
"'''''''''''''''''''''''''''''''''''''''''m'\x10\x10\x10\x10\x10''''''''''''''''"
"''''''''''''''''''''''''''''''''''''''''''''''''''''''\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
"'''''''''''''''''''''''''''''\x10\x10\x10@@@0000@@000\x10\x10\x10\x1000@000000lnk\x10\x10\x10\x10"
"\xee\x10\x10\x10\xb7\xb7zzzzzzzzzz''''''''''''''''''''''''''''''\x10\x10'''''\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
"''''''''''''''''''''''''''''''''''''''''''''\x10\x10\x10\x100000000000000000"
"0'''''''00\x10\x10\x10\x10\x10\x10zzzzzzzzzzz\x10\x10\x10\xb7\xb7\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee"
"'''''''''''''''''''''''nk000\x10\x10\xb2\xb2''''''''''''''''''''''''''''''''"
"'''''''''''''''''''''0@0@@@@@@@\x10C0@00@@@@@@@@000000@@nnnnnnnn\x10\x10k"
'zzzzzzzzzz\x10\x10\x10\x10\x10\x10zzzzzzzzzz\x10\x10\x10\x10\x10\x10\xb2\xb2\xb2\xb2\xb2\xb2\xb2\x1d\xb2\xb2\xb2\xb2\xb2\xb2\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
"@@@@0'''''''''''''''''''''''''''''''''''''''''''''''B0@@@@@0@000"
"00@01'''''''\x10\x10\x10\x10zzzzzzzzzz\xb2\xb2\xb2\xb2\xb2\xb2\xb2\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9nknnnnnnn\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\x10\x10\x10"
"@@0''''''''''''''''''''''''''''''0@@@@00@@1\x10\x10\x10''zzzzzzzzzz\x10\x10\x10\x10\x10\x10"
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
"''''''''''''''''''''''''''''''''''''00000000@@@@@@@@00@B\x10\x10\x10\xb2\xb2\xb2\xb2\xb2"
"zzzzzzzzzz\x10\x10\x10'''zzzzzzzzzz''''''''''''''''''''''''''''''\x1d\x1d\x1d\x1d\x1d\x1d\xb2\xb2"
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
"\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10nnn\xb2Akkkkknnkkkkn0AAAAAAA''''k''''0\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
'\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d'
'\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x1d\x16\x16\x16\x16\x16\x16\x16'
'\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d'
'nnknnnnnnnknnoikhnnnnnnnnnnnnnnnnnnnnnn\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10knk'
'.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16'
'.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16'
'.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16\x16\x16\x16\x16\x16\x16\x16\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16'
'.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16'
'\x16\x16\x16\x16\x16\x16\x16\x16........\x16\x16\x16\x16\x16\x16\x10\x10......\x10\x10\x16\x16\x16\x16\x16\x16\x16\x16........\x16\x16\x16\x16\x16\x16\x16\x16........'
'\x16\x16\x16\x16\x16\x16\x10\x10......\x10\x10\x16\x16\x16\x16\x16\x16\x16\x16\x10.\x10.\x10.\x10.\x16\x16\x16\x16\x16\x16\x16\x16........\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x10\x10'
'\x16\x16\x16\x16\x16\x16\x16\x16++++++++\x16\x16\x16\x16\x16\x16\x16\x16++++++++\x16\x16\x16\x16\x16\x16\x16\x16++++++++\x16\x16\x16\x16\x16\x10\x16\x16....+\xcd\x16\xcd'
'\xcd\xcd\x16\x16\x16\x10\x16\x16....+\xcd\xcd\xcd\x16\x16\x16\x16\x10\x10\x16\x16....\x10\xcd\xcd\xcd\x16\x16\x16\x16\x16\x16\x16\x16.....\xcd\xcd\xcd\x10\x10\x16\x16\x16\x10\x16\x16....+\xcd\xcd\x10'
'\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\x07\x07\x07\x08\r\x97\x98\x98\x97\x97\x97\xb3\xb7\xa4\xa2\xbe\xa5\xa4\xa2\xbe\xa5\xb3\xb3\xb3\xb7\xb3\xb3\xb3\xb3\xf2\xf3\t\x0e\x0c\n\x0f\xf4\xad\xaf\xad\xad\xaf\xb3\xb7\xb7\xb7\xa6\xa3\xb3\xb7\xb7\xb3\x91'
'\x91\xb7\xb7\xb7\xd1\xbf\x9e\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xde\xb7\x91\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xf6\x07\x07\x07\x07\x07\x10\x10\x10\x10\x10\x07\x07\x07\x07\x07\x07\x85\x1d\x10\x10\x84\x85\x85\x85\x85\x85\xd3\xd3\xde\xbf\x9e\x19'
'\x85\x84\x84\x84\x84\x85\x85\x85\x85\x85\xd3\xd3\xde\xbf\x9e\x10\x1d\x1d\x1d\x1d\x1d\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc6\xc7\xc7\xc4\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10nnAAnnnnAAAnn4444n444AAnknAAkkkkn\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
"\xee\xee.\xeb\xee\xeb\xee.\xee\xeb\x16...\x16\x16...\x14\xee.\xeb\xee\xef.....\xee\xee\xee\xeb\xeb\xee.\xee,\xee.\xee.,..\xe7\x16....\x16''''\x16\xee\xee\x16\x16.."
'\xdf\xde\xde\xde\xde.\x16\x16\x16\x16\xee\xde\xee\xee\x16\xe9\x8b\x8b\x8b\x89\x89\x8b\x8b\x8b\x8b\x8b\x8b\x89\x89\x89\x89\x8b||||||||||||~~~~||||||||||~~~~~~'
'~~~.\x16~~~~\x89\x10\x10\x10\x10\x10\x10\xd9\xd9\xd9\xd9\xd9\xeb\xeb\xeb\xeb\xeb\xde\xde\xee\xee\xee\xee\xde\xee\xee\xde\xee\xee\xde\xee\xee\xee\xee\xee\xee\xee\xde\xee\xee\xee\xee\xee\xee\xee\xee\xee\xeb\xeb\xee\xee\xee\xee\xee\xee'
'\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xde\xde\xee\xee\xd9\xee\xd9\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xeb\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde'
'\xd9\xdf\xda\xda\xdf\xde\xde\xd9\xda\xdf\xdf\xda\xdf\xdf\xde\xd9\xde\xda\xd3\xd7\xde\xda\xdf\xde\xde\xde\xda\xdf\xdf\xda\xd9\xda\xda\xdf\xdf\xd9\xdf\xd9\xdf\xd9\xd9\xd9\xd9\xda\xda\xdf\xda\xdf\xdf\xdf\xdf\xdf\xd9\xd9\xd9\xd9\xde\xdf\xde\xdf\xda\xda\xdf\xdf'
'\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xda\xdf\xdf\xdf\xda\xde\xde\xde\xde\xde\xda\xdf\xdf\xdf\xde\xde\xde\xde\xde\xde\xde\xde\xde\xdf\xda\xd9\xdf\xde\xda\xda\xda\xda\xdf\xdf\xda\xda\xde\xde\xda\xda\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf'
'\xdf\xdf\xda\xda\xdf\xdf\xda\xda\xdf\xdf\xdf\xdf\xdf\xde\xde\xdf\xdf\xdf\xdf\xde\xde\xd9\xde\xde\xdf\xd9\xde\xde\xde\xde\xde\xde\xde\xde\xdf\xdf\xde\xd9\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xde\xde\xde\xde\xde\xdf\xda'
'\xde\xde\xde\xde\xde\xde\xde\xde\xde\xdf\xdf\xdf\xdf\xdf\xde\xde\xdf\xdf\xde\xde\xde\xde\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xde\xde\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf'
'\xee\xee\xee\xee\xee\xee\xee\xee\xdf\xdf\xdf\xdf\xee\xee\xee\xee\xee\xee\xeb\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xdf\xdf\xee\xee\xee\xee\xee\xee\xee\xc2\xa1\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9'
'\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xee\xde\xee\xee\xee'
'\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xe9\xee\xee\xee\xee\xee\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee'
'\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xde\xde\xde\xde\xde\xde\xee\xee\xee\xee\xee\xee\xee\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x8a\x8a\x8a\x8a\x8a\x8a\x8a\x8a\x8a\x89\x89\x89\x89\x89\x89\x89\x89\x89\x89\x89\x8a\x8a\x8a\x8a\x8a\x8a\x8a\x8a\x8a\x89\x89\x89'
'\x89\x89\x89\x89\x89\x89\x89\x89\x84\x84\x84\x84\x84\x84\x84\x84\x84\x83\x83\x83\x83\x83\x83\x83\x83\x83\x83\x83\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8'
'\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\x8c\x89\x89\x89\x89\x89\x89\x89\x89\x89\x89\x8a\x8a\x8a\x8a\x8a\x8a\x8a\x8a\x8a\x89\x8a'
'\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb'
'\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xee\xee\xee\xee\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee'
'\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xee\xee\xeb\xeb\xeb\xeb\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xeb\xeb\xee\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xee\xee\xee\xee\xee\xee\xee\xee\xeb\xeb\xee\xee\xeb\xd9\xee\xee\xee\xee\xeb\xeb\xee\xee'
'\xeb\xd9\xee\xee\xee\xee\xeb\xeb\xeb\xee\xee\xeb\xee\xee\xeb\xeb\xeb\xeb\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xeb\xeb\xeb\xeb\xee\xee\xee\xee\xee\xee\xee\xee\xee\xeb\xee\xee\xee\xee\xee\xee\xee\xee\xde\xde\xde\xde\xde\xde\xde\xde'
'\xee\xee\xee\xee\xee\xeb\xeb\xee\xee\xeb\xee\xee\xee\xee\xeb\xeb\xee\xee\xee\xee\xeb\xeb\xee\xee\xee\xee\xee\xee\xeb\xee\xeb\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee'
'\xeb\xee\xeb\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xeb\xeb\xee\xeb\xeb\xeb\xee\xeb\xeb\xeb\xeb\xee\xeb\xeb\xee\xd9\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee'
'\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xeb\xeb\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xe9\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xeb\xeb'
'\xee\xee\xee\xee\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\x10\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\x10\xeb\x10\x10\x10\x10\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb'
'\x10\xee\xee\xee\xee\x10\xee\xee\xee\xee\x10\x10\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\x10\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xeb\xee\xee'
'\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\x10\xee\x10\xee\xee\xee\xee\x10\x10\x10\xee\xeb\xee\xee\xee\xee\xee\xee\xee\x10\x10\xee\xee\xee\xee\xee\xee\xee\xbf\x9e\xbf\x9e\xbf\x9e\xbf\x9e\xbf\x9e\xbf\x9e\xbf\x9e\x8a\x8a\x8a\x8a\x8a\x8a\x8a\x8a\x8a\x89'
'\x8c\x8c\x8c\x8c\x8c\x8c\x8c\x8c\x8c\x8b\x8c\x8c\x8c\x8c\x8c\x8c\x8c\x8c\x8c\x8b\xee\x10\x10\x10\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\x10\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\x10'
'\xdf\xde\xde\xdf\xdf\xbf\x9e\xde\xdf\xdf\xde\x10\xdf\x10\x10\x10\xde\xde\xde\xdf\xdf\xdf\xdf\xde\xde\xde\xde\xde\xdf\xdf\xdf\xde\xde\xde\xdf\xdf\xdf\xdf\xc0\x9f\xc0\x9f\xc0\x9f\xc0\x9f\xbf\x9e\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde'
'\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9'
'\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9'
'\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9'
'\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9'
'\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde'
'\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde'
'\xde\xde\xde\xbf\x9e\xc0\x9f\xbf\x9e\xbf\x9e\xbf\x9e\xbf\x9e\xbf\x9e\xbf\x9e\xbf\x9e\xbf\x9e\xbf\x9e\xde\xde\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xde\xde\xde\xde\xde\xde\xde\xde\xdf\xde\xde\xde\xde\xde\xde\xde'
'\xdf\xdf\xdf\xdf\xdf\xdf\xde\xde\xde\xdf\xde\xde\xde\xde\xdf\xdf\xdf\xdf\xdf\xde\xdf\xdf\xde\xde\xbf\x9e\xbf\x9e\xdf\xde\xde\xde\xde\xdf\xde\xdf\xdf\xdf\xde\xde\xdf\xdf\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xdf\xdf\xdf\xdf\xdf\xdf\xde\xde\xbf\x9e\xde\xde'
'\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xde\xdf\xdf\xdf\xdf\xde\xde\xdf\xde\xdf\xde\xde\xdf\xde\xdf\xdf\xdf\xdf\xde\xde\xde\xde\xde\xdf\xdf\xde\xde\xde\xde\xde\xde\xdf\xdf\xdf\xde'
'\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xdf\xdf\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xdf\xdf\xde\xde\xde\xde\xdf\xdf\xdf\xdf\xde\xdf\xdf\xde\xde\xdf\xdf\xde\xde\xde\xde\xdf\xdf\xdf\xdf\xdf\xdf\xdf'
'\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xde\xde\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xde\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf'
'\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xde\xde\xde\xde\xde\xdf\xde\xdf\xde\xde\xde\xdf\xdf\xdf\xdf\xdf\xde\xde\xde\xde\xde\xdf\xdf\xdf\xde\xde\xde\xde\xdf\xde\xde\xde\xdf\xdf\xdf\xdf\xdf\xde\xdf\xde\xde'
'\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde'
'\xde\xde\xde\xde\xde\xee\xee\xde\xde\xde\xde\xde\xde\x10\x10\x10\xee\xee\xee\xee\xee\xeb\xeb\xeb\xeb\xeb\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'...............................................\x10\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16'
'\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x10.\x16...\x16\x16.\x16.\x16.\x16....\x16.\x16\x16.\x16\x16\x16\x16\x16\x16\x16\x1d..'
'.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16'
'.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16\x16\xee\xee\xee\xee\xee\xee.\x16.\x16nnn\x10\x10\x10\x10\x10\x10\x10\xb7\xb7\xb7\xb7\x8b\xb7\xb7'
"\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10''''''''''''''''"
"''''''''''''''''''''''''''''''''''''''\x10\x10\x10\x10\x10\x10\x10\x10\x10\x1d\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
"'''''''''''''''''''''''\x10\x10\x10\x10\x10\x10\x10\x10\x10'''''''\x10'''''''\x10'''''''\x10'''''''\x10"
"'''''''\x10'''''''\x10'''''''\x10'''''''\x10nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn"
'\xb7\xb7\xa6\xa3\xa6\xa3\xb7\xb7\xb7\xa6\xa3\xb7\xa6\xa3\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\x98\xb7\xb7\x98\xb7\xa6\xa3\xb7\xb7\xa6\xa3\xbf\x9e\xbf\x9e\xbf\x9e\xbf\x9e\xb7\xb7\xb7\xb7\xb7 \xb7\xb7\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\x10\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1'
'\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1'
'\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1'
'\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1'
'\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\x10\x10\x10\x10'
'\xf5\xba\xba\xba\xf1\x1e(\x7f\xc2\xa1\xc2\xa1\xc2\xa1\xc2\xa1\xc2\xa1\xf1\xf1\xc2\xa1\xc2\xa1\xc2\xa1\xc2\xa1\x99\xc1\xa0\xa0\xf1\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7fqturss\x99\x1e\x1e\x1e\x1e\x1e\xf1\xf1\x7f\x7f\x7f\x1e(\xba\xf1\xee'
'\x10((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((\x10\x10pp\xcf\xcf\x1e\x1e(\x99((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((\xba\x1e\x1e\x1e('
'\x10\x10\x10\x10\x10(((((((((((((((((((((((((((((((((((((((((\x10\x10\x10((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((\x10\xea\xea\x88\x88\x88\x88\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea((((((((((((((((((((((((\x10\x10\x10\x10\x10\x10\x10\x10'
'\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10(((((((((((((((('
'\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xf1\xf1\x10\x88\x88\x88\x88\x88\x88\x88\x88\x88\x88\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea'
'\xea\xea\xea\xea\xea\xea\xea\xea\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xf1\x8d\x8d\x8d\x8d\x8d\x8d\x8d\x8d\x8d\x8d\x8d\x8d\x8d\x8d\x8d\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xf1\xf1\xf1\xea'
'\x88\x88\x88\x88\x88\x88\x88\x88\x88\x88\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\x8d\x8d\x8d\x8d\x8d\x8d\x8d\x8d\x8d\x8d\x8d\x8d\x8d\x8d\x8d'
'\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xf1\xf1\xf1\xf1\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\x10'
'\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea'
'\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xf1\xf1\xf1\xf1\xea\xea\xea\xea\xea'
'\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea'
'\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xf1\xf1\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xf1'
'((((()(((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'((()(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((()((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'((((((((((((()(((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'((((((((((((((((((((((((((((((((((((((((((((((((((((((\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee'
')(()((()()(((((((((((((((((((((((((((((((((((((((((((((((((((((('
'((((((((((((((((((((((((((((()(((((((((((((((((((((((((((((((((('
'(((((((((((()((((((()()(((((((((((((((((((((((((((((((((((((((()'
')(((((((((((((((((((((((((((((()(((((((()((((((((((((((((((((((('
'((((((((((((()(((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((()((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((()((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((()(((((((((((((((((((((((((((((((((()()()(((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'()()))(((((()((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'())))((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'((((((((((((((((((((((((((()(((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'((((((((((((((((((((((((((((((((((((((((((((((((()((((((()(((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((()((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((())'
'(((((((((((()))()((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((()('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((()((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((()((((((((((((((((((((((((((((((((((((((((((((('
'(((((()((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((()((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((()('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((()((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((()((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((()(((()(((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((()((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'((((((((((((((((((((((((((((((((()(((((((((((((((((((((((((((((('
'(((((()((((()((((((((((((((((((((((((((((((((((((((((((()((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((()((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'((((((((((((\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'(((((((((((((((((((((\x1e(((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((\x10\x10\x10\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1\xf1'
"\xf1\xf1\xf1\xf1\xf1\xf1\xf1\x10\x10\x10\x10\x10\x10\x10\x10\x10''''''''''''''''''''''''''''''''''''''''\x1d\x1d\x1d\x1d\x1d\x1d\xb2\xb2"
"''''''''''''\x1d\xb7\xb7\xb7''''''''''''''''zzzzzzzzzz''\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
".\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16\x10\x10.\x16.\x16.\x16.\x16.\x16.\x16'n444\xb7\x10\x10\x10\x10\x10\x10\x10\x10nn\xb7!"
".\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16\x10\x10\x10\x10\x10\x10\x10\x10''''''''''''''''''''''''''''''''"
"''''''''''''''''''''''''''''''''''''''~~~~~~~~~~nn\xb2\xb2\xb2\xb2\xb2\xb2\x10\x10\x10\x10\x10\x10\x10\x10"
'\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd!!!!!!!!!\xcd\xcd.\x16.\x16.\x16.\x16.\x16.\x16.\x16\x16\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16'
'.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16.\x16\x1d\x16\x16\x16\x16\x16\x16\x16\x16.\x16.\x16..\x16'
'.\x16.\x16.\x16.\x16!\xca\xca.\x16\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
"\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'''''"
"''@'''C''''@'''''''''''''''''''''''00@@0\xee\xee\xee\xee\x10\x10\x10\x10\x86\x86\x86\x86\x86\x86\xe9\xe9\xc7\xe6\x10\x10\x10\x10\x10\x10"
"''''''''''''''''''''''''''''''''''''''''''''''''''''\xb7\xb7\xb7\xb7\x10\x10\x10\x10\x10\x10\x10\x10"
"00''''''''''''''''''''''''''''''''''''''''''''''''''000000000000"
"0000C\x10\x10\x10\x10\x10\x10\x10\x10\x10\xb2\xb2zzzzzzzzzz\x10\x10\x10\x10\x10\x10nnnnnnnnnnnnnnnnnn''''''\xb2\xb2\xb2'\x10\x10\x10\x10"
"zzzzzzzzzz''''''''''''''''''''''''''''@@@@@kkk\xb2\xb2''''''''''''''''"
"'''''''@@@@@@@@@@@01\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\xb2(((((((((((((((((((((((((((((\x10\x10\x10"
"@@@0'''''''''''''''''''''''''''''''''''''''''''''''B00@@@@00@000"
'1\xb2\xb2\xb2\xb2\xb2\xb2\xb2\xb2\xb2\xb2\xb2\xb2\xb2\x10\x1dzzzzzzzzzz\x10\x10\x10\x10\xb2\xb2\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
"'''''''''''''''''''''''''''''''''''''''''@@@@@@00@@00@@\x10\x10\x10\x10\x10\x10\x10\x10\x10"
"'''@''''''''@0\x10\x10zzzzzzzzzz\x10\x10\xb2\xb2\xb2\xb2''''''''''''''''\x1d''''''\xe9\xe9\xe9'0\x10\x10\x10\x10"
"''''''''''''''''''''''''''''''''''''''''''''''''n'nnk''nn'''''nn"
"'n'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10''\x1d\xb2\xb2\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
"'''''''''''''''''''''''''''''''''''00@00@00\xb20C\x10\x10zzzzzzzzzz\x10\x10\x10\x10\x10\x10"
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'((((((((((((((((((((((((((((((((((((\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10(((((((((((((((('
'(((((((\x10\x10\x10\x10(((((((((((((((((((((((((((((((((((((((((((((((((\x10\x10\x10\x10'
'\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13'
'\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13'
'\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13'
'\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13'
'\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12'
'\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12'
'\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12'
'\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12'
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'((((((((((((((((((((((((((((((((((((((((((()((((((()(((()((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((()((((((((((((('
'((((((((((((((((()()((((((((((((((((((((((((((((((((((((((((()(('
'((((((((((((((((((((((((((((((((((((((((((((((\x11\x11(((((((((((((((('
'((((((((((((((((((((((((((((((((((((((((((((((\x11\x11(((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'((((((((((((((((((((((((((\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x16\x16\x16\x16\x16\x16\x16\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x16\x16\x16\x16\x16\x10\x10\x10\x10\x10*T**********\xd3*************\x10*****\x10*\x10'
'**\x10**\x10**********$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$######$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$\xbe\x9d'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
'$$$$$$$$$$$$$$$$\x10\x10$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
'$$$$$$$$\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10$$$$$$$$$$##\xc3\xee\x10\x10'
'6666666666666666\xba\xba\xba\xba\xba\xba\xba\xc1\xa0\xba\x10\x10\x10\x10\x10\x10nnnnnnn\x10\x10\x10\x10\x10\x10\x10\x10\x10\xba\x99\x99\x93\x93\xc1\xa0\xc1\xa0\xc1\xa0\xc1\xa0\xc1\xa0\xc1'
'\xa0\xc1\xa0\xc1\xa0\xba\xba\xc1\xa0\xba\xba\xba\xba\x93\x93\x93\xac\xba\xac\x10\xba\xac\xba\xba\x99\xc2\xa1\xc2\xa1\xc2\xa1\xb1\xba\xba\xd5\x96\xe3\xe3\xe2\x10\xba\xc9\xb1\xba\x10\x10\x10\x10#$#$#\x10#$#$#$#$#$'
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$\x10\x10\x07'
'\x10\xb5\xb5\xae\xc5\xae\xb5\xb5\xbc\x9b\xb5\xd2\xa9\x94\xa9\xa9wwwwwwwwww\xa9\xb5\xdc\xdb\xdc\xb5\xb5--------------------------\xbc\xb5\x9b\xcc\x90'
'\xcc\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\xbc\xdb\x9b\xdb\xbc\x9b\xb6\xbd\x9c\xb6\xb6%%%%%%%%%%\x1b%%%%%%%%%%%%%%%'
'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\x1a\x1a%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\x10'
'\x10\x10%%%%%%\x10\x10%%%%%%\x10\x10%%%%%%\x10\x10%%%\x10\x10\x10\xc5\xc5\xdb\xcc\xec\xc5\xc5\x10\xed\xdd\xdd\xdd\xdd\xed\xed\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x0b\x0b\x0b\xee\xeb\x10\x10'
"''''''''''''\x10''''''''''''''''''''''''''\x10'''''''''''''''''''\x10''\x10'"
"''''''''''''''\x10\x10''''''''''''''\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
"''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''"
"'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''\x10\x10\x10\x10\x10"
'\xb2\xb7\xe9\x10\x10\x10\x10\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x10\x10\x10\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9'
'\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x8b\x8b\x8b\x8b\xee\xee\xee\xee\xee\xee\xee'
'\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\x8b\x10\x10\x10\x10\x10\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9k\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
"'''''''''''''''''''''''''''''\x10\x10\x10''''''''''''''''''''''''''''''''"
"'''''''''''''''''\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
"'''''''''''''''''''''''''''''''\x10\x86\x86\x86\x86\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10''''''''''''''''"
"'~''''''''~\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
"''''''''''''''''''''''''''''''\x10\xb2''''''''''''''''''''''''''''''''"
"''''\x10\x10\x10\x10''''''''\xb2~~~~~\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
'........................................\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16'
"\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16''''''''''''''''''''''''''''''''''''''''''''''''"
"''''''''''''''''''''''''''''''\x10\x10zzzzzzzzzz\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'******\x10\x10*\x10********************************************\x10**\x10\x10\x10*\x10\x10*'
'**********************\x10\xbb\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'**********************\x8e\x8e\x8e\x8e\x8e\x8e\x10\x10\x10\xb7**************************\x10\x10\x10\x10\x10\xbb'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'*@@@\x10@@\x10\x10\x10\x10\x10@k@n****\x10***\x10***************************\x10\x10\x10\x10nAk\x10\x10\x10\x10C'
'\x8f\x8f\x8f\x8f\x8e\x8e\x8e\x8e\x10\x10\x10\x10\x10\x10\x10\x10\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\x10\x10\x10\x10\x10\x10\x10*****************************\x8e\x8e\xbb'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'******************************************************\x10\x10\x10\xb7\xb7\xb7\xb7\xb7\xb7\xb7'
'**********************\x10\x10\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e*******************\x10\x10\x10\x10\x10\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'****************************************************************'
'*********\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x82\x82\x82\x82\x82\x82\x82\x82\x82\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x81\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
"@@0'''''''''''''''''''''''''''''''''''''''''''''000@@@@00CB\xb2\xb2\x08\xb2\xb2"
'\xb2\xb2\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
"''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''"
"'''''''''''''''''''''''''''''''''''''''''''''''\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}}~~~~~~~~~~~~'
'~~~~~~~~~~~~~~~~~~~~~~}}~~~~~~~~~~~\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\xb2\xb2\xb2\xb2\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
"'''''''''''''''''''''''''''''''''''''''''''''''\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10"
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9'
'\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9'
'\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9'
'\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\x10\x10\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9'
'\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe922AAA\xe9\xe9\xe9322222\x07\x07\x07\x07\x07\x07\x07\x07kkkkk'
'kkk\xe9\xe9nnnnnkk\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9nnnn\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9'
'\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee'
'\xee\xeennn\xee\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee'
'\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\x10\x10\x10\x10\x10\x10\x10\x10\x10\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x86\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'..........................\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16............'
'..............\x16\x16\x16\x16\x16\x16\x16\x10\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16........................'
'..\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16.\x10..\x10\x10.\x10\x10..\x10\x10....\x10........\x16\x16\x16\x16\x10\x16\x10\x16\x16\x16'
'\x16\x16\x16\x16\x10\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16..........................\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16'
'\x16\x16\x16\x16..\x10....\x10\x10........\x10.......\x10\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16..\x10....\x10'
'.....\x10.\x10\x10\x10.......\x10\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16....................'
'......\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16..........................\x16\x16\x16\x16\x16\x16'
'\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16..........................\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16'
'\x16\x16\x16\x16\x16\x16\x16\x16..........................\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16....'
'......................\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16................'
'..........\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x10\x10........................'
'.\xd8\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\xdf\x16\x16\x16\x16\x16\x16.........................\xd8\x16\x16\x16\x16'
'\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\xdf\x16\x16\x16\x16\x16\x16.........................\xd8\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16'
'\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\xdf\x16\x16\x16\x16\x16\x16.........................\xd8\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16'
'\x16\x16\x16\x16\x16\x16\x16\x16\x16\xdf\x16\x16\x16\x16\x16\x16.........................\xd8\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16'
'\x16\x16\x16\xdf\x16\x16\x16\x16\x16\x16.\x16\x10\x10xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'
'\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\x10\x10\x10\x10\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee'
'\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee'
'\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\xee\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x84\x84\x84\x84\x84\x84\x84\x84\x84\x84\x84\x10\x10\x10\x10\x10\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe9\x10\x10\xe8\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\xe8\x10\xe8'
'\x10\x10\xe8\x10\x10\x10\xe8\x10\x10\x10\xe8\xe8\xe8\xe8\xe8\x10\x10\x10\x10\x10\x10\x10\x10\xe8\x10\x10\x10\x10\x10\x10\x10\xe8\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\xe8\x10\xe8\xe8\x10\x10\xe8'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\xe8\xe8\xe8\xe8\x10\x10\xe8\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\xea\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\xea\xea\xea\xea\xea\xea\xea\xea\xea\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'()(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((()((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((()((((((((((((((((((((((((((((('
'((((((((((((((((((((((((((((((((()(((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((()((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'((()(((((((()((((((((((((((()((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((()(((((((((((((((((()(('
'((((((((((((((((((((((((()(((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((()((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((()((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'((((((((((((((((((((((((((()(((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'((((((((((((((((((((((((((((((((((((((((((((()(((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((('
'(((((((((((((((((((((((\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'(((((((((((((((((((((((((((((((((((((((((((((((((((((\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'((((((((((((((((((((((((((((((\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11'
'\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x10\x10'
'\x10\x07\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07'
'\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'6666666666666666666666666666666666666666666666666666666666666666'
'6666666666666666666666666666666666666666666666666666666666666666'
'6666666666666666666666666666666666666666666666666666666666666666'
'666666666666666666666666666666666666666666666666\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10'
'\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12'
'\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12'
'\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12'
'\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x10\x10'
)

def _get_record(code):
    return _db_records[ord(_db_pages[(ord(_db_pgtbl[code >> 8]) << 8) + (code & 255)])]

def category(code): return _get_record(code)[0]
def bidirectional(code): return _get_record(code)[1]
def east_asian_width(code): return _get_record(code)[2]
def isspace(code): return _get_record(code)[3] & 1 != 0
def isalpha(code): return _get_record(code)[3] & 2 != 0
def islinebreak(code): return _get_record(code)[3] & 4 != 0
def isnumeric(code): return _get_record(code)[3] & 64 != 0
def isdigit(code): return _get_record(code)[3] & 128 != 0
def isdecimal(code): return _get_record(code)[3] & 256 != 0
def isalnum(code): return _get_record(code)[3] & 66 != 0
def isupper(code): return _get_record(code)[3] & 8 != 0
def istitle(code): return _get_record(code)[3] & 16 != 0
def islower(code): return _get_record(code)[3] & 32 != 0
def iscased(code): return _get_record(code)[3] & 56 != 0
def isxidstart(code): return _get_record(code)[3] & 1024 != 0
def isxidcontinue(code): return _get_record(code)[3] & 2048 != 0
def isprintable(code): return _get_record(code)[3] & 4096 != 0
def mirrored(code): return _get_record(code)[3] & 512 != 0
def combining(code): return _get_record(code)[4]
_decimal = {
48: 0,
49: 1,
50: 2,
51: 3,
52: 4,
53: 5,
54: 6,
55: 7,
56: 8,
57: 9,
1632: 0,
1633: 1,
1634: 2,
1635: 3,
1636: 4,
1637: 5,
1638: 6,
1639: 7,
1640: 8,
1641: 9,
1776: 0,
1777: 1,
1778: 2,
1779: 3,
1780: 4,
1781: 5,
1782: 6,
1783: 7,
1784: 8,
1785: 9,
1984: 0,
1985: 1,
1986: 2,
1987: 3,
1988: 4,
1989: 5,
1990: 6,
1991: 7,
1992: 8,
1993: 9,
2406: 0,
2407: 1,
2408: 2,
2409: 3,
2410: 4,
2411: 5,
2412: 6,
2413: 7,
2414: 8,
2415: 9,
2534: 0,
2535: 1,
2536: 2,
2537: 3,
2538: 4,
2539: 5,
2540: 6,
2541: 7,
2542: 8,
2543: 9,
2662: 0,
2663: 1,
2664: 2,
2665: 3,
2666: 4,
2667: 5,
2668: 6,
2669: 7,
2670: 8,
2671: 9,
2790: 0,
2791: 1,
2792: 2,
2793: 3,
2794: 4,
2795: 5,
2796: 6,
2797: 7,
2798: 8,
2799: 9,
2918: 0,
2919: 1,
2920: 2,
2921: 3,
2922: 4,
2923: 5,
2924: 6,
2925: 7,
2926: 8,
2927: 9,
3046: 0,
3047: 1,
3048: 2,
3049: 3,
3050: 4,
3051: 5,
3052: 6,
3053: 7,
3054: 8,
3055: 9,
3174: 0,
3175: 1,
3176: 2,
3177: 3,
3178: 4,
3179: 5,
3180: 6,
3181: 7,
3182: 8,
3183: 9,
3302: 0,
3303: 1,
3304: 2,
3305: 3,
3306: 4,
3307: 5,
3308: 6,
3309: 7,
3310: 8,
3311: 9,
3430: 0,
3431: 1,
3432: 2,
3433: 3,
3434: 4,
3435: 5,
3436: 6,
3437: 7,
3438: 8,
3439: 9,
3664: 0,
3665: 1,
3666: 2,
3667: 3,
3668: 4,
3669: 5,
3670: 6,
3671: 7,
3672: 8,
3673: 9,
3792: 0,
3793: 1,
3794: 2,
3795: 3,
3796: 4,
3797: 5,
3798: 6,
3799: 7,
3800: 8,
3801: 9,
3872: 0,
3873: 1,
3874: 2,
3875: 3,
3876: 4,
3877: 5,
3878: 6,
3879: 7,
3880: 8,
3881: 9,
4160: 0,
4161: 1,
4162: 2,
4163: 3,
4164: 4,
4165: 5,
4166: 6,
4167: 7,
4168: 8,
4169: 9,
4240: 0,
4241: 1,
4242: 2,
4243: 3,
4244: 4,
4245: 5,
4246: 6,
4247: 7,
4248: 8,
4249: 9,
6112: 0,
6113: 1,
6114: 2,
6115: 3,
6116: 4,
6117: 5,
6118: 6,
6119: 7,
6120: 8,
6121: 9,
6160: 0,
6161: 1,
6162: 2,
6163: 3,
6164: 4,
6165: 5,
6166: 6,
6167: 7,
6168: 8,
6169: 9,
6470: 0,
6471: 1,
6472: 2,
6473: 3,
6474: 4,
6475: 5,
6476: 6,
6477: 7,
6478: 8,
6479: 9,
6608: 0,
6609: 1,
6610: 2,
6611: 3,
6612: 4,
6613: 5,
6614: 6,
6615: 7,
6616: 8,
6617: 9,
6618: 1,
6784: 0,
6785: 1,
6786: 2,
6787: 3,
6788: 4,
6789: 5,
6790: 6,
6791: 7,
6792: 8,
6793: 9,
6800: 0,
6801: 1,
6802: 2,
6803: 3,
6804: 4,
6805: 5,
6806: 6,
6807: 7,
6808: 8,
6809: 9,
6992: 0,
6993: 1,
6994: 2,
6995: 3,
6996: 4,
6997: 5,
6998: 6,
6999: 7,
7000: 8,
7001: 9,
7088: 0,
7089: 1,
7090: 2,
7091: 3,
7092: 4,
7093: 5,
7094: 6,
7095: 7,
7096: 8,
7097: 9,
7232: 0,
7233: 1,
7234: 2,
7235: 3,
7236: 4,
7237: 5,
7238: 6,
7239: 7,
7240: 8,
7241: 9,
7248: 0,
7249: 1,
7250: 2,
7251: 3,
7252: 4,
7253: 5,
7254: 6,
7255: 7,
7256: 8,
7257: 9,
42528: 0,
42529: 1,
42530: 2,
42531: 3,
42532: 4,
42533: 5,
42534: 6,
42535: 7,
42536: 8,
42537: 9,
43216: 0,
43217: 1,
43218: 2,
43219: 3,
43220: 4,
43221: 5,
43222: 6,
43223: 7,
43224: 8,
43225: 9,
43264: 0,
43265: 1,
43266: 2,
43267: 3,
43268: 4,
43269: 5,
43270: 6,
43271: 7,
43272: 8,
43273: 9,
43472: 0,
43473: 1,
43474: 2,
43475: 3,
43476: 4,
43477: 5,
43478: 6,
43479: 7,
43480: 8,
43481: 9,
43600: 0,
43601: 1,
43602: 2,
43603: 3,
43604: 4,
43605: 5,
43606: 6,
43607: 7,
43608: 8,
43609: 9,
44016: 0,
44017: 1,
44018: 2,
44019: 3,
44020: 4,
44021: 5,
44022: 6,
44023: 7,
44024: 8,
44025: 9,
65296: 0,
65297: 1,
65298: 2,
65299: 3,
65300: 4,
65301: 5,
65302: 6,
65303: 7,
65304: 8,
65305: 9,
66720: 0,
66721: 1,
66722: 2,
66723: 3,
66724: 4,
66725: 5,
66726: 6,
66727: 7,
66728: 8,
66729: 9,
120782: 0,
120783: 1,
120784: 2,
120785: 3,
120786: 4,
120787: 5,
120788: 6,
120789: 7,
120790: 8,
120791: 9,
120792: 0,
120793: 1,
120794: 2,
120795: 3,
120796: 4,
120797: 5,
120798: 6,
120799: 7,
120800: 8,
120801: 9,
120802: 0,
120803: 1,
120804: 2,
120805: 3,
120806: 4,
120807: 5,
120808: 6,
120809: 7,
120810: 8,
120811: 9,
120812: 0,
120813: 1,
120814: 2,
120815: 3,
120816: 4,
120817: 5,
120818: 6,
120819: 7,
120820: 8,
120821: 9,
120822: 0,
120823: 1,
120824: 2,
120825: 3,
120826: 4,
120827: 5,
120828: 6,
120829: 7,
120830: 8,
120831: 9,
}

_decimal_corrected = {
}
_digit = {
48: 0,
49: 1,
50: 2,
51: 3,
52: 4,
53: 5,
54: 6,
55: 7,
56: 8,
57: 9,
178: 2,
179: 3,
185: 1,
1632: 0,
1633: 1,
1634: 2,
1635: 3,
1636: 4,
1637: 5,
1638: 6,
1639: 7,
1640: 8,
1641: 9,
1776: 0,
1777: 1,
1778: 2,
1779: 3,
1780: 4,
1781: 5,
1782: 6,
1783: 7,
1784: 8,
1785: 9,
1984: 0,
1985: 1,
1986: 2,
1987: 3,
1988: 4,
1989: 5,
1990: 6,
1991: 7,
1992: 8,
1993: 9,
2406: 0,
2407: 1,
2408: 2,
2409: 3,
2410: 4,
2411: 5,
2412: 6,
2413: 7,
2414: 8,
2415: 9,
2534: 0,
2535: 1,
2536: 2,
2537: 3,
2538: 4,
2539: 5,
2540: 6,
2541: 7,
2542: 8,
2543: 9,
2662: 0,
2663: 1,
2664: 2,
2665: 3,
2666: 4,
2667: 5,
2668: 6,
2669: 7,
2670: 8,
2671: 9,
2790: 0,
2791: 1,
2792: 2,
2793: 3,
2794: 4,
2795: 5,
2796: 6,
2797: 7,
2798: 8,
2799: 9,
2918: 0,
2919: 1,
2920: 2,
2921: 3,
2922: 4,
2923: 5,
2924: 6,
2925: 7,
2926: 8,
2927: 9,
3046: 0,
3047: 1,
3048: 2,
3049: 3,
3050: 4,
3051: 5,
3052: 6,
3053: 7,
3054: 8,
3055: 9,
3174: 0,
3175: 1,
3176: 2,
3177: 3,
3178: 4,
3179: 5,
3180: 6,
3181: 7,
3182: 8,
3183: 9,
3302: 0,
3303: 1,
3304: 2,
3305: 3,
3306: 4,
3307: 5,
3308: 6,
3309: 7,
3310: 8,
3311: 9,
3430: 0,
3431: 1,
3432: 2,
3433: 3,
3434: 4,
3435: 5,
3436: 6,
3437: 7,
3438: 8,
3439: 9,
3664: 0,
3665: 1,
3666: 2,
3667: 3,
3668: 4,
3669: 5,
3670: 6,
3671: 7,
3672: 8,
3673: 9,
3792: 0,
3793: 1,
3794: 2,
3795: 3,
3796: 4,
3797: 5,
3798: 6,
3799: 7,
3800: 8,
3801: 9,
3872: 0,
3873: 1,
3874: 2,
3875: 3,
3876: 4,
3877: 5,
3878: 6,
3879: 7,
3880: 8,
3881: 9,
4160: 0,
4161: 1,
4162: 2,
4163: 3,
4164: 4,
4165: 5,
4166: 6,
4167: 7,
4168: 8,
4169: 9,
4240: 0,
4241: 1,
4242: 2,
4243: 3,
4244: 4,
4245: 5,
4246: 6,
4247: 7,
4248: 8,
4249: 9,
4969: 1,
4970: 2,
4971: 3,
4972: 4,
4973: 5,
4974: 6,
4975: 7,
4976: 8,
4977: 9,
6112: 0,
6113: 1,
6114: 2,
6115: 3,
6116: 4,
6117: 5,
6118: 6,
6119: 7,
6120: 8,
6121: 9,
6160: 0,
6161: 1,
6162: 2,
6163: 3,
6164: 4,
6165: 5,
6166: 6,
6167: 7,
6168: 8,
6169: 9,
6470: 0,
6471: 1,
6472: 2,
6473: 3,
6474: 4,
6475: 5,
6476: 6,
6477: 7,
6478: 8,
6479: 9,
6608: 0,
6609: 1,
6610: 2,
6611: 3,
6612: 4,
6613: 5,
6614: 6,
6615: 7,
6616: 8,
6617: 9,
6618: 1,
6784: 0,
6785: 1,
6786: 2,
6787: 3,
6788: 4,
6789: 5,
6790: 6,
6791: 7,
6792: 8,
6793: 9,
6800: 0,
6801: 1,
6802: 2,
6803: 3,
6804: 4,
6805: 5,
6806: 6,
6807: 7,
6808: 8,
6809: 9,
6992: 0,
6993: 1,
6994: 2,
6995: 3,
6996: 4,
6997: 5,
6998: 6,
6999: 7,
7000: 8,
7001: 9,
7088: 0,
7089: 1,
7090: 2,
7091: 3,
7092: 4,
7093: 5,
7094: 6,
7095: 7,
7096: 8,
7097: 9,
7232: 0,
7233: 1,
7234: 2,
7235: 3,
7236: 4,
7237: 5,
7238: 6,
7239: 7,
7240: 8,
7241: 9,
7248: 0,
7249: 1,
7250: 2,
7251: 3,
7252: 4,
7253: 5,
7254: 6,
7255: 7,
7256: 8,
7257: 9,
8304: 0,
8308: 4,
8309: 5,
8310: 6,
8311: 7,
8312: 8,
8313: 9,
8320: 0,
8321: 1,
8322: 2,
8323: 3,
8324: 4,
8325: 5,
8326: 6,
8327: 7,
8328: 8,
8329: 9,
9312: 1,
9313: 2,
9314: 3,
9315: 4,
9316: 5,
9317: 6,
9318: 7,
9319: 8,
9320: 9,
9332: 1,
9333: 2,
9334: 3,
9335: 4,
9336: 5,
9337: 6,
9338: 7,
9339: 8,
9340: 9,
9352: 1,
9353: 2,
9354: 3,
9355: 4,
9356: 5,
9357: 6,
9358: 7,
9359: 8,
9360: 9,
9450: 0,
9461: 1,
9462: 2,
9463: 3,
9464: 4,
9465: 5,
9466: 6,
9467: 7,
9468: 8,
9469: 9,
9471: 0,
10102: 1,
10103: 2,
10104: 3,
10105: 4,
10106: 5,
10107: 6,
10108: 7,
10109: 8,
10110: 9,
10112: 1,
10113: 2,
10114: 3,
10115: 4,
10116: 5,
10117: 6,
10118: 7,
10119: 8,
10120: 9,
10122: 1,
10123: 2,
10124: 3,
10125: 4,
10126: 5,
10127: 6,
10128: 7,
10129: 8,
10130: 9,
42528: 0,
42529: 1,
42530: 2,
42531: 3,
42532: 4,
42533: 5,
42534: 6,
42535: 7,
42536: 8,
42537: 9,
43216: 0,
43217: 1,
43218: 2,
43219: 3,
43220: 4,
43221: 5,
43222: 6,
43223: 7,
43224: 8,
43225: 9,
43264: 0,
43265: 1,
43266: 2,
43267: 3,
43268: 4,
43269: 5,
43270: 6,
43271: 7,
43272: 8,
43273: 9,
43472: 0,
43473: 1,
43474: 2,
43475: 3,
43476: 4,
43477: 5,
43478: 6,
43479: 7,
43480: 8,
43481: 9,
43600: 0,
43601: 1,
43602: 2,
43603: 3,
43604: 4,
43605: 5,
43606: 6,
43607: 7,
43608: 8,
43609: 9,
44016: 0,
44017: 1,
44018: 2,
44019: 3,
44020: 4,
44021: 5,
44022: 6,
44023: 7,
44024: 8,
44025: 9,
65296: 0,
65297: 1,
65298: 2,
65299: 3,
65300: 4,
65301: 5,
65302: 6,
65303: 7,
65304: 8,
65305: 9,
66720: 0,
66721: 1,
66722: 2,
66723: 3,
66724: 4,
66725: 5,
66726: 6,
66727: 7,
66728: 8,
66729: 9,
68160: 1,
68161: 2,
68162: 3,
68163: 4,
69216: 1,
69217: 2,
69218: 3,
69219: 4,
69220: 5,
69221: 6,
69222: 7,
69223: 8,
69224: 9,
120782: 0,
120783: 1,
120784: 2,
120785: 3,
120786: 4,
120787: 5,
120788: 6,
120789: 7,
120790: 8,
120791: 9,
120792: 0,
120793: 1,
120794: 2,
120795: 3,
120796: 4,
120797: 5,
120798: 6,
120799: 7,
120800: 8,
120801: 9,
120802: 0,
120803: 1,
120804: 2,
120805: 3,
120806: 4,
120807: 5,
120808: 6,
120809: 7,
120810: 8,
120811: 9,
120812: 0,
120813: 1,
120814: 2,
120815: 3,
120816: 4,
120817: 5,
120818: 6,
120819: 7,
120820: 8,
120821: 9,
120822: 0,
120823: 1,
120824: 2,
120825: 3,
120826: 4,
120827: 5,
120828: 6,
120829: 7,
120830: 8,
120831: 9,
127232: 0,
127233: 0,
127234: 1,
127235: 2,
127236: 3,
127237: 4,
127238: 5,
127239: 6,
127240: 7,
127241: 8,
127242: 9,
}

_digit_corrected = {
}
_numeric = {
48: 0.0,
49: 1.0,
50: 2.0,
51: 3.0,
52: 4.0,
53: 5.0,
54: 6.0,
55: 7.0,
56: 8.0,
57: 9.0,
178: 2.0,
179: 3.0,
185: 1.0,
188: 1.0 / 4.0,
189: 1.0 / 2.0,
190: 3.0 / 4.0,
1632: 0.0,
1633: 1.0,
1634: 2.0,
1635: 3.0,
1636: 4.0,
1637: 5.0,
1638: 6.0,
1639: 7.0,
1640: 8.0,
1641: 9.0,
1776: 0.0,
1777: 1.0,
1778: 2.0,
1779: 3.0,
1780: 4.0,
1781: 5.0,
1782: 6.0,
1783: 7.0,
1784: 8.0,
1785: 9.0,
1984: 0.0,
1985: 1.0,
1986: 2.0,
1987: 3.0,
1988: 4.0,
1989: 5.0,
1990: 6.0,
1991: 7.0,
1992: 8.0,
1993: 9.0,
2406: 0.0,
2407: 1.0,
2408: 2.0,
2409: 3.0,
2410: 4.0,
2411: 5.0,
2412: 6.0,
2413: 7.0,
2414: 8.0,
2415: 9.0,
2534: 0.0,
2535: 1.0,
2536: 2.0,
2537: 3.0,
2538: 4.0,
2539: 5.0,
2540: 6.0,
2541: 7.0,
2542: 8.0,
2543: 9.0,
2548: 1.0 / 16.0,
2549: 1.0 / 8.0,
2550: 3.0 / 16.0,
2551: 1.0 / 4.0,
2552: 3.0 / 4.0,
2553: 16.0,
2662: 0.0,
2663: 1.0,
2664: 2.0,
2665: 3.0,
2666: 4.0,
2667: 5.0,
2668: 6.0,
2669: 7.0,
2670: 8.0,
2671: 9.0,
2790: 0.0,
2791: 1.0,
2792: 2.0,
2793: 3.0,
2794: 4.0,
2795: 5.0,
2796: 6.0,
2797: 7.0,
2798: 8.0,
2799: 9.0,
2918: 0.0,
2919: 1.0,
2920: 2.0,
2921: 3.0,
2922: 4.0,
2923: 5.0,
2924: 6.0,
2925: 7.0,
2926: 8.0,
2927: 9.0,
3046: 0.0,
3047: 1.0,
3048: 2.0,
3049: 3.0,
3050: 4.0,
3051: 5.0,
3052: 6.0,
3053: 7.0,
3054: 8.0,
3055: 9.0,
3056: 10.0,
3057: 100.0,
3058: 1000.0,
3174: 0.0,
3175: 1.0,
3176: 2.0,
3177: 3.0,
3178: 4.0,
3179: 5.0,
3180: 6.0,
3181: 7.0,
3182: 8.0,
3183: 9.0,
3192: 0.0,
3193: 1.0,
3194: 2.0,
3195: 3.0,
3196: 1.0,
3197: 2.0,
3198: 3.0,
3302: 0.0,
3303: 1.0,
3304: 2.0,
3305: 3.0,
3306: 4.0,
3307: 5.0,
3308: 6.0,
3309: 7.0,
3310: 8.0,
3311: 9.0,
3430: 0.0,
3431: 1.0,
3432: 2.0,
3433: 3.0,
3434: 4.0,
3435: 5.0,
3436: 6.0,
3437: 7.0,
3438: 8.0,
3439: 9.0,
3440: 10.0,
3441: 100.0,
3442: 1000.0,
3443: 1.0 / 4.0,
3444: 1.0 / 2.0,
3445: 3.0 / 4.0,
3664: 0.0,
3665: 1.0,
3666: 2.0,
3667: 3.0,
3668: 4.0,
3669: 5.0,
3670: 6.0,
3671: 7.0,
3672: 8.0,
3673: 9.0,
3792: 0.0,
3793: 1.0,
3794: 2.0,
3795: 3.0,
3796: 4.0,
3797: 5.0,
3798: 6.0,
3799: 7.0,
3800: 8.0,
3801: 9.0,
3872: 0.0,
3873: 1.0,
3874: 2.0,
3875: 3.0,
3876: 4.0,
3877: 5.0,
3878: 6.0,
3879: 7.0,
3880: 8.0,
3881: 9.0,
3882: 1.0 / 2.0,
3883: 3.0 / 2.0,
3884: 5.0 / 2.0,
3885: 7.0 / 2.0,
3886: 9.0 / 2.0,
3887: 11.0 / 2.0,
3888: 13.0 / 2.0,
3889: 15.0 / 2.0,
3890: 17.0 / 2.0,
3891: -1.0 / 2.0,
4160: 0.0,
4161: 1.0,
4162: 2.0,
4163: 3.0,
4164: 4.0,
4165: 5.0,
4166: 6.0,
4167: 7.0,
4168: 8.0,
4169: 9.0,
4240: 0.0,
4241: 1.0,
4242: 2.0,
4243: 3.0,
4244: 4.0,
4245: 5.0,
4246: 6.0,
4247: 7.0,
4248: 8.0,
4249: 9.0,
4969: 1.0,
4970: 2.0,
4971: 3.0,
4972: 4.0,
4973: 5.0,
4974: 6.0,
4975: 7.0,
4976: 8.0,
4977: 9.0,
4978: 10.0,
4979: 20.0,
4980: 30.0,
4981: 40.0,
4982: 50.0,
4983: 60.0,
4984: 70.0,
4985: 80.0,
4986: 90.0,
4987: 100.0,
4988: 10000.0,
5870: 17.0,
5871: 18.0,
5872: 19.0,
6112: 0.0,
6113: 1.0,
6114: 2.0,
6115: 3.0,
6116: 4.0,
6117: 5.0,
6118: 6.0,
6119: 7.0,
6120: 8.0,
6121: 9.0,
6128: 0.0,
6129: 1.0,
6130: 2.0,
6131: 3.0,
6132: 4.0,
6133: 5.0,
6134: 6.0,
6135: 7.0,
6136: 8.0,
6137: 9.0,
6160: 0.0,
6161: 1.0,
6162: 2.0,
6163: 3.0,
6164: 4.0,
6165: 5.0,
6166: 6.0,
6167: 7.0,
6168: 8.0,
6169: 9.0,
6470: 0.0,
6471: 1.0,
6472: 2.0,
6473: 3.0,
6474: 4.0,
6475: 5.0,
6476: 6.0,
6477: 7.0,
6478: 8.0,
6479: 9.0,
6608: 0.0,
6609: 1.0,
6610: 2.0,
6611: 3.0,
6612: 4.0,
6613: 5.0,
6614: 6.0,
6615: 7.0,
6616: 8.0,
6617: 9.0,
6618: 1.0,
6784: 0.0,
6785: 1.0,
6786: 2.0,
6787: 3.0,
6788: 4.0,
6789: 5.0,
6790: 6.0,
6791: 7.0,
6792: 8.0,
6793: 9.0,
6800: 0.0,
6801: 1.0,
6802: 2.0,
6803: 3.0,
6804: 4.0,
6805: 5.0,
6806: 6.0,
6807: 7.0,
6808: 8.0,
6809: 9.0,
6992: 0.0,
6993: 1.0,
6994: 2.0,
6995: 3.0,
6996: 4.0,
6997: 5.0,
6998: 6.0,
6999: 7.0,
7000: 8.0,
7001: 9.0,
7088: 0.0,
7089: 1.0,
7090: 2.0,
7091: 3.0,
7092: 4.0,
7093: 5.0,
7094: 6.0,
7095: 7.0,
7096: 8.0,
7097: 9.0,
7232: 0.0,
7233: 1.0,
7234: 2.0,
7235: 3.0,
7236: 4.0,
7237: 5.0,
7238: 6.0,
7239: 7.0,
7240: 8.0,
7241: 9.0,
7248: 0.0,
7249: 1.0,
7250: 2.0,
7251: 3.0,
7252: 4.0,
7253: 5.0,
7254: 6.0,
7255: 7.0,
7256: 8.0,
7257: 9.0,
8304: 0.0,
8308: 4.0,
8309: 5.0,
8310: 6.0,
8311: 7.0,
8312: 8.0,
8313: 9.0,
8320: 0.0,
8321: 1.0,
8322: 2.0,
8323: 3.0,
8324: 4.0,
8325: 5.0,
8326: 6.0,
8327: 7.0,
8328: 8.0,
8329: 9.0,
8528: 1.0 / 7.0,
8529: 1.0 / 9.0,
8530: 1.0 / 10.0,
8531: 1.0 / 3.0,
8532: 2.0 / 3.0,
8533: 1.0 / 5.0,
8534: 2.0 / 5.0,
8535: 3.0 / 5.0,
8536: 4.0 / 5.0,
8537: 1.0 / 6.0,
8538: 5.0 / 6.0,
8539: 1.0 / 8.0,
8540: 3.0 / 8.0,
8541: 5.0 / 8.0,
8542: 7.0 / 8.0,
8543: 1.0,
8544: 1.0,
8545: 2.0,
8546: 3.0,
8547: 4.0,
8548: 5.0,
8549: 6.0,
8550: 7.0,
8551: 8.0,
8552: 9.0,
8553: 10.0,
8554: 11.0,
8555: 12.0,
8556: 50.0,
8557: 100.0,
8558: 500.0,
8559: 1000.0,
8560: 1.0,
8561: 2.0,
8562: 3.0,
8563: 4.0,
8564: 5.0,
8565: 6.0,
8566: 7.0,
8567: 8.0,
8568: 9.0,
8569: 10.0,
8570: 11.0,
8571: 12.0,
8572: 50.0,
8573: 100.0,
8574: 500.0,
8575: 1000.0,
8576: 1000.0,
8577: 5000.0,
8578: 10000.0,
8581: 6.0,
8582: 50.0,
8583: 50000.0,
8584: 100000.0,
8585: 0.0,
9312: 1.0,
9313: 2.0,
9314: 3.0,
9315: 4.0,
9316: 5.0,
9317: 6.0,
9318: 7.0,
9319: 8.0,
9320: 9.0,
9321: 10.0,
9322: 11.0,
9323: 12.0,
9324: 13.0,
9325: 14.0,
9326: 15.0,
9327: 16.0,
9328: 17.0,
9329: 18.0,
9330: 19.0,
9331: 20.0,
9332: 1.0,
9333: 2.0,
9334: 3.0,
9335: 4.0,
9336: 5.0,
9337: 6.0,
9338: 7.0,
9339: 8.0,
9340: 9.0,
9341: 10.0,
9342: 11.0,
9343: 12.0,
9344: 13.0,
9345: 14.0,
9346: 15.0,
9347: 16.0,
9348: 17.0,
9349: 18.0,
9350: 19.0,
9351: 20.0,
9352: 1.0,
9353: 2.0,
9354: 3.0,
9355: 4.0,
9356: 5.0,
9357: 6.0,
9358: 7.0,
9359: 8.0,
9360: 9.0,
9361: 10.0,
9362: 11.0,
9363: 12.0,
9364: 13.0,
9365: 14.0,
9366: 15.0,
9367: 16.0,
9368: 17.0,
9369: 18.0,
9370: 19.0,
9371: 20.0,
9450: 0.0,
9451: 11.0,
9452: 12.0,
9453: 13.0,
9454: 14.0,
9455: 15.0,
9456: 16.0,
9457: 17.0,
9458: 18.0,
9459: 19.0,
9460: 20.0,
9461: 1.0,
9462: 2.0,
9463: 3.0,
9464: 4.0,
9465: 5.0,
9466: 6.0,
9467: 7.0,
9468: 8.0,
9469: 9.0,
9470: 10.0,
9471: 0.0,
10102: 1.0,
10103: 2.0,
10104: 3.0,
10105: 4.0,
10106: 5.0,
10107: 6.0,
10108: 7.0,
10109: 8.0,
10110: 9.0,
10111: 10.0,
10112: 1.0,
10113: 2.0,
10114: 3.0,
10115: 4.0,
10116: 5.0,
10117: 6.0,
10118: 7.0,
10119: 8.0,
10120: 9.0,
10121: 10.0,
10122: 1.0,
10123: 2.0,
10124: 3.0,
10125: 4.0,
10126: 5.0,
10127: 6.0,
10128: 7.0,
10129: 8.0,
10130: 9.0,
10131: 10.0,
11517: 1.0 / 2.0,
12295: 0.0,
12321: 1.0,
12322: 2.0,
12323: 3.0,
12324: 4.0,
12325: 5.0,
12326: 6.0,
12327: 7.0,
12328: 8.0,
12329: 9.0,
12344: 10.0,
12345: 20.0,
12346: 30.0,
12690: 1.0,
12691: 2.0,
12692: 3.0,
12693: 4.0,
12832: 1.0,
12833: 2.0,
12834: 3.0,
12835: 4.0,
12836: 5.0,
12837: 6.0,
12838: 7.0,
12839: 8.0,
12840: 9.0,
12841: 10.0,
12881: 21.0,
12882: 22.0,
12883: 23.0,
12884: 24.0,
12885: 25.0,
12886: 26.0,
12887: 27.0,
12888: 28.0,
12889: 29.0,
12890: 30.0,
12891: 31.0,
12892: 32.0,
12893: 33.0,
12894: 34.0,
12895: 35.0,
12928: 1.0,
12929: 2.0,
12930: 3.0,
12931: 4.0,
12932: 5.0,
12933: 6.0,
12934: 7.0,
12935: 8.0,
12936: 9.0,
12937: 10.0,
12977: 36.0,
12978: 37.0,
12979: 38.0,
12980: 39.0,
12981: 40.0,
12982: 41.0,
12983: 42.0,
12984: 43.0,
12985: 44.0,
12986: 45.0,
12987: 46.0,
12988: 47.0,
12989: 48.0,
12990: 49.0,
12991: 50.0,
13317: 5.0,
13443: 2.0,
14378: 5.0,
15181: 7.0,
19968: 1.0,
19971: 7.0,
19975: 10000.0,
19977: 3.0,
20061: 9.0,
20108: 2.0,
20116: 5.0,
20118: 4.0,
20159: 100000000.0,
20160: 10.0,
20191: 1000.0,
20200: 3.0,
20237: 5.0,
20336: 100.0,
20740: 100000000.0,
20806: 1000000000000.0,
20841: 2.0,
20843: 8.0,
20845: 6.0,
21313: 10.0,
21315: 1000.0,
21316: 20.0,
21317: 30.0,
21324: 40.0,
21441: 3.0,
21442: 3.0,
21443: 3.0,
21444: 3.0,
22235: 4.0,
22769: 1.0,
22777: 1.0,
24186: 1.0,
24318: 9.0,
24319: 20.0,
24332: 1.0,
24333: 2.0,
24334: 3.0,
24336: 2.0,
25342: 10.0,
25420: 8.0,
26578: 7.0,
28422: 7.0,
29590: 9.0,
30334: 100.0,
32902: 4.0,
33836: 10000.0,
36014: 2.0,
36019: 2.0,
36144: 2.0,
38433: 1000.0,
38470: 6.0,
38476: 100.0,
38520: 6.0,
38646: 0.0,
42528: 0.0,
42529: 1.0,
42530: 2.0,
42531: 3.0,
42532: 4.0,
42533: 5.0,
42534: 6.0,
42535: 7.0,
42536: 8.0,
42537: 9.0,
42726: 1.0,
42727: 2.0,
42728: 3.0,
42729: 4.0,
42730: 5.0,
42731: 6.0,
42732: 7.0,
42733: 8.0,
42734: 9.0,
42735: 0.0,
43056: 1.0 / 4.0,
43057: 1.0 / 2.0,
43058: 3.0 / 4.0,
43059: 1.0 / 16.0,
43060: 1.0 / 8.0,
43061: 3.0 / 16.0,
43216: 0.0,
43217: 1.0,
43218: 2.0,
43219: 3.0,
43220: 4.0,
43221: 5.0,
43222: 6.0,
43223: 7.0,
43224: 8.0,
43225: 9.0,
43264: 0.0,
43265: 1.0,
43266: 2.0,
43267: 3.0,
43268: 4.0,
43269: 5.0,
43270: 6.0,
43271: 7.0,
43272: 8.0,
43273: 9.0,
43472: 0.0,
43473: 1.0,
43474: 2.0,
43475: 3.0,
43476: 4.0,
43477: 5.0,
43478: 6.0,
43479: 7.0,
43480: 8.0,
43481: 9.0,
43600: 0.0,
43601: 1.0,
43602: 2.0,
43603: 3.0,
43604: 4.0,
43605: 5.0,
43606: 6.0,
43607: 7.0,
43608: 8.0,
43609: 9.0,
44016: 0.0,
44017: 1.0,
44018: 2.0,
44019: 3.0,
44020: 4.0,
44021: 5.0,
44022: 6.0,
44023: 7.0,
44024: 8.0,
44025: 9.0,
63851: 3.0,
63859: 10.0,
63864: 2.0,
63922: 0.0,
63953: 6.0,
63955: 6.0,
63997: 10.0,
65296: 0.0,
65297: 1.0,
65298: 2.0,
65299: 3.0,
65300: 4.0,
65301: 5.0,
65302: 6.0,
65303: 7.0,
65304: 8.0,
65305: 9.0,
65799: 1.0,
65800: 2.0,
65801: 3.0,
65802: 4.0,
65803: 5.0,
65804: 6.0,
65805: 7.0,
65806: 8.0,
65807: 9.0,
65808: 10.0,
65809: 20.0,
65810: 30.0,
65811: 40.0,
65812: 50.0,
65813: 60.0,
65814: 70.0,
65815: 80.0,
65816: 90.0,
65817: 100.0,
65818: 200.0,
65819: 300.0,
65820: 400.0,
65821: 500.0,
65822: 600.0,
65823: 700.0,
65824: 800.0,
65825: 900.0,
65826: 1000.0,
65827: 2000.0,
65828: 3000.0,
65829: 4000.0,
65830: 5000.0,
65831: 6000.0,
65832: 7000.0,
65833: 8000.0,
65834: 9000.0,
65835: 10000.0,
65836: 20000.0,
65837: 30000.0,
65838: 40000.0,
65839: 50000.0,
65840: 60000.0,
65841: 70000.0,
65842: 80000.0,
65843: 90000.0,
65856: 1.0 / 4.0,
65857: 1.0 / 2.0,
65858: 1.0,
65859: 5.0,
65860: 50.0,
65861: 500.0,
65862: 5000.0,
65863: 50000.0,
65864: 5.0,
65865: 10.0,
65866: 50.0,
65867: 100.0,
65868: 500.0,
65869: 1000.0,
65870: 5000.0,
65871: 5.0,
65872: 10.0,
65873: 50.0,
65874: 100.0,
65875: 500.0,
65876: 1000.0,
65877: 10000.0,
65878: 50000.0,
65879: 10.0,
65880: 1.0,
65881: 1.0,
65882: 1.0,
65883: 2.0,
65884: 2.0,
65885: 2.0,
65886: 2.0,
65887: 5.0,
65888: 10.0,
65889: 10.0,
65890: 10.0,
65891: 10.0,
65892: 10.0,
65893: 30.0,
65894: 50.0,
65895: 50.0,
65896: 50.0,
65897: 50.0,
65898: 100.0,
65899: 300.0,
65900: 500.0,
65901: 500.0,
65902: 500.0,
65903: 500.0,
65904: 500.0,
65905: 1000.0,
65906: 5000.0,
65907: 5.0,
65908: 50.0,
65909: 1.0 / 2.0,
65910: 1.0 / 2.0,
65911: 2.0 / 3.0,
65912: 3.0 / 4.0,
65930: 0.0,
66336: 1.0,
66337: 5.0,
66338: 10.0,
66339: 50.0,
66369: 90.0,
66378: 900.0,
66513: 1.0,
66514: 2.0,
66515: 10.0,
66516: 20.0,
66517: 100.0,
66720: 0.0,
66721: 1.0,
66722: 2.0,
66723: 3.0,
66724: 4.0,
66725: 5.0,
66726: 6.0,
66727: 7.0,
66728: 8.0,
66729: 9.0,
67672: 1.0,
67673: 2.0,
67674: 3.0,
67675: 10.0,
67676: 20.0,
67677: 100.0,
67678: 1000.0,
67679: 10000.0,
67862: 1.0,
67863: 10.0,
67864: 20.0,
67865: 100.0,
67866: 2.0,
67867: 3.0,
68160: 1.0,
68161: 2.0,
68162: 3.0,
68163: 4.0,
68164: 10.0,
68165: 20.0,
68166: 100.0,
68167: 1000.0,
68221: 1.0,
68222: 50.0,
68440: 1.0,
68441: 2.0,
68442: 3.0,
68443: 4.0,
68444: 10.0,
68445: 20.0,
68446: 100.0,
68447: 1000.0,
68472: 1.0,
68473: 2.0,
68474: 3.0,
68475: 4.0,
68476: 10.0,
68477: 20.0,
68478: 100.0,
68479: 1000.0,
69216: 1.0,
69217: 2.0,
69218: 3.0,
69219: 4.0,
69220: 5.0,
69221: 6.0,
69222: 7.0,
69223: 8.0,
69224: 9.0,
69225: 10.0,
69226: 20.0,
69227: 30.0,
69228: 40.0,
69229: 50.0,
69230: 60.0,
69231: 70.0,
69232: 80.0,
69233: 90.0,
69234: 100.0,
69235: 200.0,
69236: 300.0,
69237: 400.0,
69238: 500.0,
69239: 600.0,
69240: 700.0,
69241: 800.0,
69242: 900.0,
69243: 1.0 / 2.0,
69244: 1.0 / 4.0,
69245: 1.0 / 3.0,
69246: 2.0 / 3.0,
74752: 2.0,
74753: 3.0,
74754: 4.0,
74755: 5.0,
74756: 6.0,
74757: 7.0,
74758: 8.0,
74759: 9.0,
74760: 3.0,
74761: 4.0,
74762: 5.0,
74763: 6.0,
74764: 7.0,
74765: 8.0,
74766: 9.0,
74767: 4.0,
74768: 5.0,
74769: 6.0,
74770: 7.0,
74771: 8.0,
74772: 9.0,
74773: 1.0,
74774: 2.0,
74775: 3.0,
74776: 4.0,
74777: 5.0,
74778: 6.0,
74779: 7.0,
74780: 8.0,
74781: 9.0,
74782: 1.0,
74783: 2.0,
74784: 3.0,
74785: 4.0,
74786: 5.0,
74787: 2.0,
74788: 3.0,
74789: 3.0,
74790: 4.0,
74791: 5.0,
74792: 6.0,
74793: 7.0,
74794: 8.0,
74795: 9.0,
74796: 1.0,
74797: 2.0,
74798: 3.0,
74799: 3.0,
74800: 4.0,
74801: 5.0,
74804: 1.0,
74805: 2.0,
74806: 3.0,
74807: 3.0,
74808: 4.0,
74809: 5.0,
74810: 3.0,
74811: 3.0,
74812: 4.0,
74813: 4.0,
74814: 4.0,
74815: 4.0,
74816: 6.0,
74817: 7.0,
74818: 7.0,
74819: 7.0,
74820: 8.0,
74821: 8.0,
74822: 9.0,
74823: 9.0,
74824: 9.0,
74825: 9.0,
74826: 2.0,
74827: 3.0,
74828: 4.0,
74829: 5.0,
74830: 6.0,
74831: 1.0,
74832: 2.0,
74833: 3.0,
74834: 4.0,
74835: 4.0,
74836: 5.0,
74837: 5.0,
74840: 1.0,
74841: 2.0,
74842: 1.0 / 3.0,
74843: 2.0 / 3.0,
74844: 5.0 / 6.0,
74845: 1.0 / 3.0,
74846: 2.0 / 3.0,
74847: 1.0 / 8.0,
74848: 1.0 / 4.0,
74849: 1.0 / 6.0,
74850: 1.0 / 4.0,
119648: 1.0,
119649: 2.0,
119650: 3.0,
119651: 4.0,
119652: 5.0,
119653: 6.0,
119654: 7.0,
119655: 8.0,
119656: 9.0,
119657: 10.0,
119658: 20.0,
119659: 30.0,
119660: 40.0,
119661: 50.0,
119662: 60.0,
119663: 70.0,
119664: 80.0,
119665: 90.0,
120782: 0.0,
120783: 1.0,
120784: 2.0,
120785: 3.0,
120786: 4.0,
120787: 5.0,
120788: 6.0,
120789: 7.0,
120790: 8.0,
120791: 9.0,
120792: 0.0,
120793: 1.0,
120794: 2.0,
120795: 3.0,
120796: 4.0,
120797: 5.0,
120798: 6.0,
120799: 7.0,
120800: 8.0,
120801: 9.0,
120802: 0.0,
120803: 1.0,
120804: 2.0,
120805: 3.0,
120806: 4.0,
120807: 5.0,
120808: 6.0,
120809: 7.0,
120810: 8.0,
120811: 9.0,
120812: 0.0,
120813: 1.0,
120814: 2.0,
120815: 3.0,
120816: 4.0,
120817: 5.0,
120818: 6.0,
120819: 7.0,
120820: 8.0,
120821: 9.0,
120822: 0.0,
120823: 1.0,
120824: 2.0,
120825: 3.0,
120826: 4.0,
120827: 5.0,
120828: 6.0,
120829: 7.0,
120830: 8.0,
120831: 9.0,
127232: 0.0,
127233: 0.0,
127234: 1.0,
127235: 2.0,
127236: 3.0,
127237: 4.0,
127238: 5.0,
127239: 6.0,
127240: 7.0,
127241: 8.0,
127242: 9.0,
131073: 7.0,
131172: 4.0,
131298: 4.0,
131361: 5.0,
133418: 1.0,
133507: 30.0,
133516: 40.0,
133532: 40.0,
133866: 6.0,
133885: 3.0,
133913: 3.0,
140176: 2.0,
141720: 3.0,
146203: 3.0,
156269: 4.0,
194704: 9.0,
}

_numeric_corrected = {
}

def decimal(code):
    try:
        return _decimal[code]
    except KeyError:
        if base_mod is not None and code not in _decimal_corrected:
            return base_mod._decimal[code]
        else:
            raise

def digit(code):
    try:
        return _digit[code]
    except KeyError:
        if base_mod is not None and code not in _digit_corrected:
            return base_mod._digit[code]
        else:
            raise

def numeric(code):
    try:
        return _numeric[code]
    except KeyError:
        if base_mod is not None and code not in _numeric_corrected:
            return base_mod._numeric[code]
        else:
            raise

_toupper = {
97: 65,
98: 66,
99: 67,
100: 68,
101: 69,
102: 70,
103: 71,
104: 72,
105: 73,
106: 74,
107: 75,
108: 76,
109: 77,
110: 78,
111: 79,
112: 80,
113: 81,
114: 82,
115: 83,
116: 84,
117: 85,
118: 86,
119: 87,
120: 88,
121: 89,
122: 90,
181: 924,
224: 192,
225: 193,
226: 194,
227: 195,
228: 196,
229: 197,
230: 198,
231: 199,
232: 200,
233: 201,
234: 202,
235: 203,
236: 204,
237: 205,
238: 206,
239: 207,
240: 208,
241: 209,
242: 210,
243: 211,
244: 212,
245: 213,
246: 214,
248: 216,
249: 217,
250: 218,
251: 219,
252: 220,
253: 221,
254: 222,
255: 376,
257: 256,
259: 258,
261: 260,
263: 262,
265: 264,
267: 266,
269: 268,
271: 270,
273: 272,
275: 274,
277: 276,
279: 278,
281: 280,
283: 282,
285: 284,
287: 286,
289: 288,
291: 290,
293: 292,
295: 294,
297: 296,
299: 298,
301: 300,
303: 302,
305: 73,
307: 306,
309: 308,
311: 310,
314: 313,
316: 315,
318: 317,
320: 319,
322: 321,
324: 323,
326: 325,
328: 327,
331: 330,
333: 332,
335: 334,
337: 336,
339: 338,
341: 340,
343: 342,
345: 344,
347: 346,
349: 348,
351: 350,
353: 352,
355: 354,
357: 356,
359: 358,
361: 360,
363: 362,
365: 364,
367: 366,
369: 368,
371: 370,
373: 372,
375: 374,
378: 377,
380: 379,
382: 381,
383: 83,
384: 579,
387: 386,
389: 388,
392: 391,
396: 395,
402: 401,
405: 502,
409: 408,
410: 573,
414: 544,
417: 416,
419: 418,
421: 420,
424: 423,
429: 428,
432: 431,
436: 435,
438: 437,
441: 440,
445: 444,
447: 503,
453: 452,
454: 452,
456: 455,
457: 455,
459: 458,
460: 458,
462: 461,
464: 463,
466: 465,
468: 467,
470: 469,
472: 471,
474: 473,
476: 475,
477: 398,
479: 478,
481: 480,
483: 482,
485: 484,
487: 486,
489: 488,
491: 490,
493: 492,
495: 494,
498: 497,
499: 497,
501: 500,
505: 504,
507: 506,
509: 508,
511: 510,
513: 512,
515: 514,
517: 516,
519: 518,
521: 520,
523: 522,
525: 524,
527: 526,
529: 528,
531: 530,
533: 532,
535: 534,
537: 536,
539: 538,
541: 540,
543: 542,
547: 546,
549: 548,
551: 550,
553: 552,
555: 554,
557: 556,
559: 558,
561: 560,
563: 562,
572: 571,
575: 11390,
576: 11391,
578: 577,
583: 582,
585: 584,
587: 586,
589: 588,
591: 590,
592: 11375,
593: 11373,
594: 11376,
595: 385,
596: 390,
598: 393,
599: 394,
601: 399,
603: 400,
608: 403,
611: 404,
616: 407,
617: 406,
619: 11362,
623: 412,
625: 11374,
626: 413,
629: 415,
637: 11364,
640: 422,
643: 425,
648: 430,
649: 580,
650: 433,
651: 434,
652: 581,
658: 439,
837: 921,
881: 880,
883: 882,
887: 886,
891: 1021,
892: 1022,
893: 1023,
940: 902,
941: 904,
942: 905,
943: 906,
945: 913,
946: 914,
947: 915,
948: 916,
949: 917,
950: 918,
951: 919,
952: 920,
953: 921,
954: 922,
955: 923,
956: 924,
957: 925,
958: 926,
959: 927,
960: 928,
961: 929,
962: 931,
963: 931,
964: 932,
965: 933,
966: 934,
967: 935,
968: 936,
969: 937,
970: 938,
971: 939,
972: 908,
973: 910,
974: 911,
976: 914,
977: 920,
981: 934,
982: 928,
983: 975,
985: 984,
987: 986,
989: 988,
991: 990,
993: 992,
995: 994,
997: 996,
999: 998,
1001: 1000,
1003: 1002,
1005: 1004,
1007: 1006,
1008: 922,
1009: 929,
1010: 1017,
1013: 917,
1016: 1015,
1019: 1018,
1072: 1040,
1073: 1041,
1074: 1042,
1075: 1043,
1076: 1044,
1077: 1045,
1078: 1046,
1079: 1047,
1080: 1048,
1081: 1049,
1082: 1050,
1083: 1051,
1084: 1052,
1085: 1053,
1086: 1054,
1087: 1055,
1088: 1056,
1089: 1057,
1090: 1058,
1091: 1059,
1092: 1060,
1093: 1061,
1094: 1062,
1095: 1063,
1096: 1064,
1097: 1065,
1098: 1066,
1099: 1067,
1100: 1068,
1101: 1069,
1102: 1070,
1103: 1071,
1104: 1024,
1105: 1025,
1106: 1026,
1107: 1027,
1108: 1028,
1109: 1029,
1110: 1030,
1111: 1031,
1112: 1032,
1113: 1033,
1114: 1034,
1115: 1035,
1116: 1036,
1117: 1037,
1118: 1038,
1119: 1039,
1121: 1120,
1123: 1122,
1125: 1124,
1127: 1126,
1129: 1128,
1131: 1130,
1133: 1132,
1135: 1134,
1137: 1136,
1139: 1138,
1141: 1140,
1143: 1142,
1145: 1144,
1147: 1146,
1149: 1148,
1151: 1150,
1153: 1152,
1163: 1162,
1165: 1164,
1167: 1166,
1169: 1168,
1171: 1170,
1173: 1172,
1175: 1174,
1177: 1176,
1179: 1178,
1181: 1180,
1183: 1182,
1185: 1184,
1187: 1186,
1189: 1188,
1191: 1190,
1193: 1192,
1195: 1194,
1197: 1196,
1199: 1198,
1201: 1200,
1203: 1202,
1205: 1204,
1207: 1206,
1209: 1208,
1211: 1210,
1213: 1212,
1215: 1214,
1218: 1217,
1220: 1219,
1222: 1221,
1224: 1223,
1226: 1225,
1228: 1227,
1230: 1229,
1231: 1216,
1233: 1232,
1235: 1234,
1237: 1236,
1239: 1238,
1241: 1240,
1243: 1242,
1245: 1244,
1247: 1246,
1249: 1248,
1251: 1250,
1253: 1252,
1255: 1254,
1257: 1256,
1259: 1258,
1261: 1260,
1263: 1262,
1265: 1264,
1267: 1266,
1269: 1268,
1271: 1270,
1273: 1272,
1275: 1274,
1277: 1276,
1279: 1278,
1281: 1280,
1283: 1282,
1285: 1284,
1287: 1286,
1289: 1288,
1291: 1290,
1293: 1292,
1295: 1294,
1297: 1296,
1299: 1298,
1301: 1300,
1303: 1302,
1305: 1304,
1307: 1306,
1309: 1308,
1311: 1310,
1313: 1312,
1315: 1314,
1317: 1316,
1377: 1329,
1378: 1330,
1379: 1331,
1380: 1332,
1381: 1333,
1382: 1334,
1383: 1335,
1384: 1336,
1385: 1337,
1386: 1338,
1387: 1339,
1388: 1340,
1389: 1341,
1390: 1342,
1391: 1343,
1392: 1344,
1393: 1345,
1394: 1346,
1395: 1347,
1396: 1348,
1397: 1349,
1398: 1350,
1399: 1351,
1400: 1352,
1401: 1353,
1402: 1354,
1403: 1355,
1404: 1356,
1405: 1357,
1406: 1358,
1407: 1359,
1408: 1360,
1409: 1361,
1410: 1362,
1411: 1363,
1412: 1364,
1413: 1365,
1414: 1366,
7545: 42877,
7549: 11363,
7681: 7680,
7683: 7682,
7685: 7684,
7687: 7686,
7689: 7688,
7691: 7690,
7693: 7692,
7695: 7694,
7697: 7696,
7699: 7698,
7701: 7700,
7703: 7702,
7705: 7704,
7707: 7706,
7709: 7708,
7711: 7710,
7713: 7712,
7715: 7714,
7717: 7716,
7719: 7718,
7721: 7720,
7723: 7722,
7725: 7724,
7727: 7726,
7729: 7728,
7731: 7730,
7733: 7732,
7735: 7734,
7737: 7736,
7739: 7738,
7741: 7740,
7743: 7742,
7745: 7744,
7747: 7746,
7749: 7748,
7751: 7750,
7753: 7752,
7755: 7754,
7757: 7756,
7759: 7758,
7761: 7760,
7763: 7762,
7765: 7764,
7767: 7766,
7769: 7768,
7771: 7770,
7773: 7772,
7775: 7774,
7777: 7776,
7779: 7778,
7781: 7780,
7783: 7782,
7785: 7784,
7787: 7786,
7789: 7788,
7791: 7790,
7793: 7792,
7795: 7794,
7797: 7796,
7799: 7798,
7801: 7800,
7803: 7802,
7805: 7804,
7807: 7806,
7809: 7808,
7811: 7810,
7813: 7812,
7815: 7814,
7817: 7816,
7819: 7818,
7821: 7820,
7823: 7822,
7825: 7824,
7827: 7826,
7829: 7828,
7835: 7776,
7841: 7840,
7843: 7842,
7845: 7844,
7847: 7846,
7849: 7848,
7851: 7850,
7853: 7852,
7855: 7854,
7857: 7856,
7859: 7858,
7861: 7860,
7863: 7862,
7865: 7864,
7867: 7866,
7869: 7868,
7871: 7870,
7873: 7872,
7875: 7874,
7877: 7876,
7879: 7878,
7881: 7880,
7883: 7882,
7885: 7884,
7887: 7886,
7889: 7888,
7891: 7890,
7893: 7892,
7895: 7894,
7897: 7896,
7899: 7898,
7901: 7900,
7903: 7902,
7905: 7904,
7907: 7906,
7909: 7908,
7911: 7910,
7913: 7912,
7915: 7914,
7917: 7916,
7919: 7918,
7921: 7920,
7923: 7922,
7925: 7924,
7927: 7926,
7929: 7928,
7931: 7930,
7933: 7932,
7935: 7934,
7936: 7944,
7937: 7945,
7938: 7946,
7939: 7947,
7940: 7948,
7941: 7949,
7942: 7950,
7943: 7951,
7952: 7960,
7953: 7961,
7954: 7962,
7955: 7963,
7956: 7964,
7957: 7965,
7968: 7976,
7969: 7977,
7970: 7978,
7971: 7979,
7972: 7980,
7973: 7981,
7974: 7982,
7975: 7983,
7984: 7992,
7985: 7993,
7986: 7994,
7987: 7995,
7988: 7996,
7989: 7997,
7990: 7998,
7991: 7999,
8000: 8008,
8001: 8009,
8002: 8010,
8003: 8011,
8004: 8012,
8005: 8013,
8017: 8025,
8019: 8027,
8021: 8029,
8023: 8031,
8032: 8040,
8033: 8041,
8034: 8042,
8035: 8043,
8036: 8044,
8037: 8045,
8038: 8046,
8039: 8047,
8048: 8122,
8049: 8123,
8050: 8136,
8051: 8137,
8052: 8138,
8053: 8139,
8054: 8154,
8055: 8155,
8056: 8184,
8057: 8185,
8058: 8170,
8059: 8171,
8060: 8186,
8061: 8187,
8064: 8072,
8065: 8073,
8066: 8074,
8067: 8075,
8068: 8076,
8069: 8077,
8070: 8078,
8071: 8079,
8080: 8088,
8081: 8089,
8082: 8090,
8083: 8091,
8084: 8092,
8085: 8093,
8086: 8094,
8087: 8095,
8096: 8104,
8097: 8105,
8098: 8106,
8099: 8107,
8100: 8108,
8101: 8109,
8102: 8110,
8103: 8111,
8112: 8120,
8113: 8121,
8115: 8124,
8126: 921,
8131: 8140,
8144: 8152,
8145: 8153,
8160: 8168,
8161: 8169,
8165: 8172,
8179: 8188,
8526: 8498,
8560: 8544,
8561: 8545,
8562: 8546,
8563: 8547,
8564: 8548,
8565: 8549,
8566: 8550,
8567: 8551,
8568: 8552,
8569: 8553,
8570: 8554,
8571: 8555,
8572: 8556,
8573: 8557,
8574: 8558,
8575: 8559,
8580: 8579,
9424: 9398,
9425: 9399,
9426: 9400,
9427: 9401,
9428: 9402,
9429: 9403,
9430: 9404,
9431: 9405,
9432: 9406,
9433: 9407,
9434: 9408,
9435: 9409,
9436: 9410,
9437: 9411,
9438: 9412,
9439: 9413,
9440: 9414,
9441: 9415,
9442: 9416,
9443: 9417,
9444: 9418,
9445: 9419,
9446: 9420,
9447: 9421,
9448: 9422,
9449: 9423,
11312: 11264,
11313: 11265,
11314: 11266,
11315: 11267,
11316: 11268,
11317: 11269,
11318: 11270,
11319: 11271,
11320: 11272,
11321: 11273,
11322: 11274,
11323: 11275,
11324: 11276,
11325: 11277,
11326: 11278,
11327: 11279,
11328: 11280,
11329: 11281,
11330: 11282,
11331: 11283,
11332: 11284,
11333: 11285,
11334: 11286,
11335: 11287,
11336: 11288,
11337: 11289,
11338: 11290,
11339: 11291,
11340: 11292,
11341: 11293,
11342: 11294,
11343: 11295,
11344: 11296,
11345: 11297,
11346: 11298,
11347: 11299,
11348: 11300,
11349: 11301,
11350: 11302,
11351: 11303,
11352: 11304,
11353: 11305,
11354: 11306,
11355: 11307,
11356: 11308,
11357: 11309,
11358: 11310,
11361: 11360,
11365: 570,
11366: 574,
11368: 11367,
11370: 11369,
11372: 11371,
11379: 11378,
11382: 11381,
11393: 11392,
11395: 11394,
11397: 11396,
11399: 11398,
11401: 11400,
11403: 11402,
11405: 11404,
11407: 11406,
11409: 11408,
11411: 11410,
11413: 11412,
11415: 11414,
11417: 11416,
11419: 11418,
11421: 11420,
11423: 11422,
11425: 11424,
11427: 11426,
11429: 11428,
11431: 11430,
11433: 11432,
11435: 11434,
11437: 11436,
11439: 11438,
11441: 11440,
11443: 11442,
11445: 11444,
11447: 11446,
11449: 11448,
11451: 11450,
11453: 11452,
11455: 11454,
11457: 11456,
11459: 11458,
11461: 11460,
11463: 11462,
11465: 11464,
11467: 11466,
11469: 11468,
11471: 11470,
11473: 11472,
11475: 11474,
11477: 11476,
11479: 11478,
11481: 11480,
11483: 11482,
11485: 11484,
11487: 11486,
11489: 11488,
11491: 11490,
11500: 11499,
11502: 11501,
11520: 4256,
11521: 4257,
11522: 4258,
11523: 4259,
11524: 4260,
11525: 4261,
11526: 4262,
11527: 4263,
11528: 4264,
11529: 4265,
11530: 4266,
11531: 4267,
11532: 4268,
11533: 4269,
11534: 4270,
11535: 4271,
11536: 4272,
11537: 4273,
11538: 4274,
11539: 4275,
11540: 4276,
11541: 4277,
11542: 4278,
11543: 4279,
11544: 4280,
11545: 4281,
11546: 4282,
11547: 4283,
11548: 4284,
11549: 4285,
11550: 4286,
11551: 4287,
11552: 4288,
11553: 4289,
11554: 4290,
11555: 4291,
11556: 4292,
11557: 4293,
42561: 42560,
42563: 42562,
42565: 42564,
42567: 42566,
42569: 42568,
42571: 42570,
42573: 42572,
42575: 42574,
42577: 42576,
42579: 42578,
42581: 42580,
42583: 42582,
42585: 42584,
42587: 42586,
42589: 42588,
42591: 42590,
42595: 42594,
42597: 42596,
42599: 42598,
42601: 42600,
42603: 42602,
42605: 42604,
42625: 42624,
42627: 42626,
42629: 42628,
42631: 42630,
42633: 42632,
42635: 42634,
42637: 42636,
42639: 42638,
42641: 42640,
42643: 42642,
42645: 42644,
42647: 42646,
42787: 42786,
42789: 42788,
42791: 42790,
42793: 42792,
42795: 42794,
42797: 42796,
42799: 42798,
42803: 42802,
42805: 42804,
42807: 42806,
42809: 42808,
42811: 42810,
42813: 42812,
42815: 42814,
42817: 42816,
42819: 42818,
42821: 42820,
42823: 42822,
42825: 42824,
42827: 42826,
42829: 42828,
42831: 42830,
42833: 42832,
42835: 42834,
42837: 42836,
42839: 42838,
42841: 42840,
42843: 42842,
42845: 42844,
42847: 42846,
42849: 42848,
42851: 42850,
42853: 42852,
42855: 42854,
42857: 42856,
42859: 42858,
42861: 42860,
42863: 42862,
42874: 42873,
42876: 42875,
42879: 42878,
42881: 42880,
42883: 42882,
42885: 42884,
42887: 42886,
42892: 42891,
65345: 65313,
65346: 65314,
65347: 65315,
65348: 65316,
65349: 65317,
65350: 65318,
65351: 65319,
65352: 65320,
65353: 65321,
65354: 65322,
65355: 65323,
65356: 65324,
65357: 65325,
65358: 65326,
65359: 65327,
65360: 65328,
65361: 65329,
65362: 65330,
65363: 65331,
65364: 65332,
65365: 65333,
65366: 65334,
65367: 65335,
65368: 65336,
65369: 65337,
65370: 65338,
66600: 66560,
66601: 66561,
66602: 66562,
66603: 66563,
66604: 66564,
66605: 66565,
66606: 66566,
66607: 66567,
66608: 66568,
66609: 66569,
66610: 66570,
66611: 66571,
66612: 66572,
66613: 66573,
66614: 66574,
66615: 66575,
66616: 66576,
66617: 66577,
66618: 66578,
66619: 66579,
66620: 66580,
66621: 66581,
66622: 66582,
66623: 66583,
66624: 66584,
66625: 66585,
66626: 66586,
66627: 66587,
66628: 66588,
66629: 66589,
66630: 66590,
66631: 66591,
66632: 66592,
66633: 66593,
66634: 66594,
66635: 66595,
66636: 66596,
66637: 66597,
66638: 66598,
66639: 66599,
}

_toupper_corrected = {
}
_tolower = {
65: 97,
66: 98,
67: 99,
68: 100,
69: 101,
70: 102,
71: 103,
72: 104,
73: 105,
74: 106,
75: 107,
76: 108,
77: 109,
78: 110,
79: 111,
80: 112,
81: 113,
82: 114,
83: 115,
84: 116,
85: 117,
86: 118,
87: 119,
88: 120,
89: 121,
90: 122,
192: 224,
193: 225,
194: 226,
195: 227,
196: 228,
197: 229,
198: 230,
199: 231,
200: 232,
201: 233,
202: 234,
203: 235,
204: 236,
205: 237,
206: 238,
207: 239,
208: 240,
209: 241,
210: 242,
211: 243,
212: 244,
213: 245,
214: 246,
216: 248,
217: 249,
218: 250,
219: 251,
220: 252,
221: 253,
222: 254,
256: 257,
258: 259,
260: 261,
262: 263,
264: 265,
266: 267,
268: 269,
270: 271,
272: 273,
274: 275,
276: 277,
278: 279,
280: 281,
282: 283,
284: 285,
286: 287,
288: 289,
290: 291,
292: 293,
294: 295,
296: 297,
298: 299,
300: 301,
302: 303,
304: 105,
306: 307,
308: 309,
310: 311,
313: 314,
315: 316,
317: 318,
319: 320,
321: 322,
323: 324,
325: 326,
327: 328,
330: 331,
332: 333,
334: 335,
336: 337,
338: 339,
340: 341,
342: 343,
344: 345,
346: 347,
348: 349,
350: 351,
352: 353,
354: 355,
356: 357,
358: 359,
360: 361,
362: 363,
364: 365,
366: 367,
368: 369,
370: 371,
372: 373,
374: 375,
376: 255,
377: 378,
379: 380,
381: 382,
385: 595,
386: 387,
388: 389,
390: 596,
391: 392,
393: 598,
394: 599,
395: 396,
398: 477,
399: 601,
400: 603,
401: 402,
403: 608,
404: 611,
406: 617,
407: 616,
408: 409,
412: 623,
413: 626,
415: 629,
416: 417,
418: 419,
420: 421,
422: 640,
423: 424,
425: 643,
428: 429,
430: 648,
431: 432,
433: 650,
434: 651,
435: 436,
437: 438,
439: 658,
440: 441,
444: 445,
452: 454,
453: 454,
455: 457,
456: 457,
458: 460,
459: 460,
461: 462,
463: 464,
465: 466,
467: 468,
469: 470,
471: 472,
473: 474,
475: 476,
478: 479,
480: 481,
482: 483,
484: 485,
486: 487,
488: 489,
490: 491,
492: 493,
494: 495,
497: 499,
498: 499,
500: 501,
502: 405,
503: 447,
504: 505,
506: 507,
508: 509,
510: 511,
512: 513,
514: 515,
516: 517,
518: 519,
520: 521,
522: 523,
524: 525,
526: 527,
528: 529,
530: 531,
532: 533,
534: 535,
536: 537,
538: 539,
540: 541,
542: 543,
544: 414,
546: 547,
548: 549,
550: 551,
552: 553,
554: 555,
556: 557,
558: 559,
560: 561,
562: 563,
570: 11365,
571: 572,
573: 410,
574: 11366,
577: 578,
579: 384,
580: 649,
581: 652,
582: 583,
584: 585,
586: 587,
588: 589,
590: 591,
880: 881,
882: 883,
886: 887,
902: 940,
904: 941,
905: 942,
906: 943,
908: 972,
910: 973,
911: 974,
913: 945,
914: 946,
915: 947,
916: 948,
917: 949,
918: 950,
919: 951,
920: 952,
921: 953,
922: 954,
923: 955,
924: 956,
925: 957,
926: 958,
927: 959,
928: 960,
929: 961,
931: 963,
932: 964,
933: 965,
934: 966,
935: 967,
936: 968,
937: 969,
938: 970,
939: 971,
975: 983,
984: 985,
986: 987,
988: 989,
990: 991,
992: 993,
994: 995,
996: 997,
998: 999,
1000: 1001,
1002: 1003,
1004: 1005,
1006: 1007,
1012: 952,
1015: 1016,
1017: 1010,
1018: 1019,
1021: 891,
1022: 892,
1023: 893,
1024: 1104,
1025: 1105,
1026: 1106,
1027: 1107,
1028: 1108,
1029: 1109,
1030: 1110,
1031: 1111,
1032: 1112,
1033: 1113,
1034: 1114,
1035: 1115,
1036: 1116,
1037: 1117,
1038: 1118,
1039: 1119,
1040: 1072,
1041: 1073,
1042: 1074,
1043: 1075,
1044: 1076,
1045: 1077,
1046: 1078,
1047: 1079,
1048: 1080,
1049: 1081,
1050: 1082,
1051: 1083,
1052: 1084,
1053: 1085,
1054: 1086,
1055: 1087,
1056: 1088,
1057: 1089,
1058: 1090,
1059: 1091,
1060: 1092,
1061: 1093,
1062: 1094,
1063: 1095,
1064: 1096,
1065: 1097,
1066: 1098,
1067: 1099,
1068: 1100,
1069: 1101,
1070: 1102,
1071: 1103,
1120: 1121,
1122: 1123,
1124: 1125,
1126: 1127,
1128: 1129,
1130: 1131,
1132: 1133,
1134: 1135,
1136: 1137,
1138: 1139,
1140: 1141,
1142: 1143,
1144: 1145,
1146: 1147,
1148: 1149,
1150: 1151,
1152: 1153,
1162: 1163,
1164: 1165,
1166: 1167,
1168: 1169,
1170: 1171,
1172: 1173,
1174: 1175,
1176: 1177,
1178: 1179,
1180: 1181,
1182: 1183,
1184: 1185,
1186: 1187,
1188: 1189,
1190: 1191,
1192: 1193,
1194: 1195,
1196: 1197,
1198: 1199,
1200: 1201,
1202: 1203,
1204: 1205,
1206: 1207,
1208: 1209,
1210: 1211,
1212: 1213,
1214: 1215,
1216: 1231,
1217: 1218,
1219: 1220,
1221: 1222,
1223: 1224,
1225: 1226,
1227: 1228,
1229: 1230,
1232: 1233,
1234: 1235,
1236: 1237,
1238: 1239,
1240: 1241,
1242: 1243,
1244: 1245,
1246: 1247,
1248: 1249,
1250: 1251,
1252: 1253,
1254: 1255,
1256: 1257,
1258: 1259,
1260: 1261,
1262: 1263,
1264: 1265,
1266: 1267,
1268: 1269,
1270: 1271,
1272: 1273,
1274: 1275,
1276: 1277,
1278: 1279,
1280: 1281,
1282: 1283,
1284: 1285,
1286: 1287,
1288: 1289,
1290: 1291,
1292: 1293,
1294: 1295,
1296: 1297,
1298: 1299,
1300: 1301,
1302: 1303,
1304: 1305,
1306: 1307,
1308: 1309,
1310: 1311,
1312: 1313,
1314: 1315,
1316: 1317,
1329: 1377,
1330: 1378,
1331: 1379,
1332: 1380,
1333: 1381,
1334: 1382,
1335: 1383,
1336: 1384,
1337: 1385,
1338: 1386,
1339: 1387,
1340: 1388,
1341: 1389,
1342: 1390,
1343: 1391,
1344: 1392,
1345: 1393,
1346: 1394,
1347: 1395,
1348: 1396,
1349: 1397,
1350: 1398,
1351: 1399,
1352: 1400,
1353: 1401,
1354: 1402,
1355: 1403,
1356: 1404,
1357: 1405,
1358: 1406,
1359: 1407,
1360: 1408,
1361: 1409,
1362: 1410,
1363: 1411,
1364: 1412,
1365: 1413,
1366: 1414,
4256: 11520,
4257: 11521,
4258: 11522,
4259: 11523,
4260: 11524,
4261: 11525,
4262: 11526,
4263: 11527,
4264: 11528,
4265: 11529,
4266: 11530,
4267: 11531,
4268: 11532,
4269: 11533,
4270: 11534,
4271: 11535,
4272: 11536,
4273: 11537,
4274: 11538,
4275: 11539,
4276: 11540,
4277: 11541,
4278: 11542,
4279: 11543,
4280: 11544,
4281: 11545,
4282: 11546,
4283: 11547,
4284: 11548,
4285: 11549,
4286: 11550,
4287: 11551,
4288: 11552,
4289: 11553,
4290: 11554,
4291: 11555,
4292: 11556,
4293: 11557,
7680: 7681,
7682: 7683,
7684: 7685,
7686: 7687,
7688: 7689,
7690: 7691,
7692: 7693,
7694: 7695,
7696: 7697,
7698: 7699,
7700: 7701,
7702: 7703,
7704: 7705,
7706: 7707,
7708: 7709,
7710: 7711,
7712: 7713,
7714: 7715,
7716: 7717,
7718: 7719,
7720: 7721,
7722: 7723,
7724: 7725,
7726: 7727,
7728: 7729,
7730: 7731,
7732: 7733,
7734: 7735,
7736: 7737,
7738: 7739,
7740: 7741,
7742: 7743,
7744: 7745,
7746: 7747,
7748: 7749,
7750: 7751,
7752: 7753,
7754: 7755,
7756: 7757,
7758: 7759,
7760: 7761,
7762: 7763,
7764: 7765,
7766: 7767,
7768: 7769,
7770: 7771,
7772: 7773,
7774: 7775,
7776: 7777,
7778: 7779,
7780: 7781,
7782: 7783,
7784: 7785,
7786: 7787,
7788: 7789,
7790: 7791,
7792: 7793,
7794: 7795,
7796: 7797,
7798: 7799,
7800: 7801,
7802: 7803,
7804: 7805,
7806: 7807,
7808: 7809,
7810: 7811,
7812: 7813,
7814: 7815,
7816: 7817,
7818: 7819,
7820: 7821,
7822: 7823,
7824: 7825,
7826: 7827,
7828: 7829,
7838: 223,
7840: 7841,
7842: 7843,
7844: 7845,
7846: 7847,
7848: 7849,
7850: 7851,
7852: 7853,
7854: 7855,
7856: 7857,
7858: 7859,
7860: 7861,
7862: 7863,
7864: 7865,
7866: 7867,
7868: 7869,
7870: 7871,
7872: 7873,
7874: 7875,
7876: 7877,
7878: 7879,
7880: 7881,
7882: 7883,
7884: 7885,
7886: 7887,
7888: 7889,
7890: 7891,
7892: 7893,
7894: 7895,
7896: 7897,
7898: 7899,
7900: 7901,
7902: 7903,
7904: 7905,
7906: 7907,
7908: 7909,
7910: 7911,
7912: 7913,
7914: 7915,
7916: 7917,
7918: 7919,
7920: 7921,
7922: 7923,
7924: 7925,
7926: 7927,
7928: 7929,
7930: 7931,
7932: 7933,
7934: 7935,
7944: 7936,
7945: 7937,
7946: 7938,
7947: 7939,
7948: 7940,
7949: 7941,
7950: 7942,
7951: 7943,
7960: 7952,
7961: 7953,
7962: 7954,
7963: 7955,
7964: 7956,
7965: 7957,
7976: 7968,
7977: 7969,
7978: 7970,
7979: 7971,
7980: 7972,
7981: 7973,
7982: 7974,
7983: 7975,
7992: 7984,
7993: 7985,
7994: 7986,
7995: 7987,
7996: 7988,
7997: 7989,
7998: 7990,
7999: 7991,
8008: 8000,
8009: 8001,
8010: 8002,
8011: 8003,
8012: 8004,
8013: 8005,
8025: 8017,
8027: 8019,
8029: 8021,
8031: 8023,
8040: 8032,
8041: 8033,
8042: 8034,
8043: 8035,
8044: 8036,
8045: 8037,
8046: 8038,
8047: 8039,
8072: 8064,
8073: 8065,
8074: 8066,
8075: 8067,
8076: 8068,
8077: 8069,
8078: 8070,
8079: 8071,
8088: 8080,
8089: 8081,
8090: 8082,
8091: 8083,
8092: 8084,
8093: 8085,
8094: 8086,
8095: 8087,
8104: 8096,
8105: 8097,
8106: 8098,
8107: 8099,
8108: 8100,
8109: 8101,
8110: 8102,
8111: 8103,
8120: 8112,
8121: 8113,
8122: 8048,
8123: 8049,
8124: 8115,
8136: 8050,
8137: 8051,
8138: 8052,
8139: 8053,
8140: 8131,
8152: 8144,
8153: 8145,
8154: 8054,
8155: 8055,
8168: 8160,
8169: 8161,
8170: 8058,
8171: 8059,
8172: 8165,
8184: 8056,
8185: 8057,
8186: 8060,
8187: 8061,
8188: 8179,
8486: 969,
8490: 107,
8491: 229,
8498: 8526,
8544: 8560,
8545: 8561,
8546: 8562,
8547: 8563,
8548: 8564,
8549: 8565,
8550: 8566,
8551: 8567,
8552: 8568,
8553: 8569,
8554: 8570,
8555: 8571,
8556: 8572,
8557: 8573,
8558: 8574,
8559: 8575,
8579: 8580,
9398: 9424,
9399: 9425,
9400: 9426,
9401: 9427,
9402: 9428,
9403: 9429,
9404: 9430,
9405: 9431,
9406: 9432,
9407: 9433,
9408: 9434,
9409: 9435,
9410: 9436,
9411: 9437,
9412: 9438,
9413: 9439,
9414: 9440,
9415: 9441,
9416: 9442,
9417: 9443,
9418: 9444,
9419: 9445,
9420: 9446,
9421: 9447,
9422: 9448,
9423: 9449,
11264: 11312,
11265: 11313,
11266: 11314,
11267: 11315,
11268: 11316,
11269: 11317,
11270: 11318,
11271: 11319,
11272: 11320,
11273: 11321,
11274: 11322,
11275: 11323,
11276: 11324,
11277: 11325,
11278: 11326,
11279: 11327,
11280: 11328,
11281: 11329,
11282: 11330,
11283: 11331,
11284: 11332,
11285: 11333,
11286: 11334,
11287: 11335,
11288: 11336,
11289: 11337,
11290: 11338,
11291: 11339,
11292: 11340,
11293: 11341,
11294: 11342,
11295: 11343,
11296: 11344,
11297: 11345,
11298: 11346,
11299: 11347,
11300: 11348,
11301: 11349,
11302: 11350,
11303: 11351,
11304: 11352,
11305: 11353,
11306: 11354,
11307: 11355,
11308: 11356,
11309: 11357,
11310: 11358,
11360: 11361,
11362: 619,
11363: 7549,
11364: 637,
11367: 11368,
11369: 11370,
11371: 11372,
11373: 593,
11374: 625,
11375: 592,
11376: 594,
11378: 11379,
11381: 11382,
11390: 575,
11391: 576,
11392: 11393,
11394: 11395,
11396: 11397,
11398: 11399,
11400: 11401,
11402: 11403,
11404: 11405,
11406: 11407,
11408: 11409,
11410: 11411,
11412: 11413,
11414: 11415,
11416: 11417,
11418: 11419,
11420: 11421,
11422: 11423,
11424: 11425,
11426: 11427,
11428: 11429,
11430: 11431,
11432: 11433,
11434: 11435,
11436: 11437,
11438: 11439,
11440: 11441,
11442: 11443,
11444: 11445,
11446: 11447,
11448: 11449,
11450: 11451,
11452: 11453,
11454: 11455,
11456: 11457,
11458: 11459,
11460: 11461,
11462: 11463,
11464: 11465,
11466: 11467,
11468: 11469,
11470: 11471,
11472: 11473,
11474: 11475,
11476: 11477,
11478: 11479,
11480: 11481,
11482: 11483,
11484: 11485,
11486: 11487,
11488: 11489,
11490: 11491,
11499: 11500,
11501: 11502,
42560: 42561,
42562: 42563,
42564: 42565,
42566: 42567,
42568: 42569,
42570: 42571,
42572: 42573,
42574: 42575,
42576: 42577,
42578: 42579,
42580: 42581,
42582: 42583,
42584: 42585,
42586: 42587,
42588: 42589,
42590: 42591,
42594: 42595,
42596: 42597,
42598: 42599,
42600: 42601,
42602: 42603,
42604: 42605,
42624: 42625,
42626: 42627,
42628: 42629,
42630: 42631,
42632: 42633,
42634: 42635,
42636: 42637,
42638: 42639,
42640: 42641,
42642: 42643,
42644: 42645,
42646: 42647,
42786: 42787,
42788: 42789,
42790: 42791,
42792: 42793,
42794: 42795,
42796: 42797,
42798: 42799,
42802: 42803,
42804: 42805,
42806: 42807,
42808: 42809,
42810: 42811,
42812: 42813,
42814: 42815,
42816: 42817,
42818: 42819,
42820: 42821,
42822: 42823,
42824: 42825,
42826: 42827,
42828: 42829,
42830: 42831,
42832: 42833,
42834: 42835,
42836: 42837,
42838: 42839,
42840: 42841,
42842: 42843,
42844: 42845,
42846: 42847,
42848: 42849,
42850: 42851,
42852: 42853,
42854: 42855,
42856: 42857,
42858: 42859,
42860: 42861,
42862: 42863,
42873: 42874,
42875: 42876,
42877: 7545,
42878: 42879,
42880: 42881,
42882: 42883,
42884: 42885,
42886: 42887,
42891: 42892,
65313: 65345,
65314: 65346,
65315: 65347,
65316: 65348,
65317: 65349,
65318: 65350,
65319: 65351,
65320: 65352,
65321: 65353,
65322: 65354,
65323: 65355,
65324: 65356,
65325: 65357,
65326: 65358,
65327: 65359,
65328: 65360,
65329: 65361,
65330: 65362,
65331: 65363,
65332: 65364,
65333: 65365,
65334: 65366,
65335: 65367,
65336: 65368,
65337: 65369,
65338: 65370,
66560: 66600,
66561: 66601,
66562: 66602,
66563: 66603,
66564: 66604,
66565: 66605,
66566: 66606,
66567: 66607,
66568: 66608,
66569: 66609,
66570: 66610,
66571: 66611,
66572: 66612,
66573: 66613,
66574: 66614,
66575: 66615,
66576: 66616,
66577: 66617,
66578: 66618,
66579: 66619,
66580: 66620,
66581: 66621,
66582: 66622,
66583: 66623,
66584: 66624,
66585: 66625,
66586: 66626,
66587: 66627,
66588: 66628,
66589: 66629,
66590: 66630,
66591: 66631,
66592: 66632,
66593: 66633,
66594: 66634,
66595: 66635,
66596: 66636,
66597: 66637,
66598: 66638,
66599: 66639,
}

_tolower_corrected = {
}
_totitle = {
97: 65,
98: 66,
99: 67,
100: 68,
101: 69,
102: 70,
103: 71,
104: 72,
105: 73,
106: 74,
107: 75,
108: 76,
109: 77,
110: 78,
111: 79,
112: 80,
113: 81,
114: 82,
115: 83,
116: 84,
117: 85,
118: 86,
119: 87,
120: 88,
121: 89,
122: 90,
181: 924,
224: 192,
225: 193,
226: 194,
227: 195,
228: 196,
229: 197,
230: 198,
231: 199,
232: 200,
233: 201,
234: 202,
235: 203,
236: 204,
237: 205,
238: 206,
239: 207,
240: 208,
241: 209,
242: 210,
243: 211,
244: 212,
245: 213,
246: 214,
248: 216,
249: 217,
250: 218,
251: 219,
252: 220,
253: 221,
254: 222,
255: 376,
257: 256,
259: 258,
261: 260,
263: 262,
265: 264,
267: 266,
269: 268,
271: 270,
273: 272,
275: 274,
277: 276,
279: 278,
281: 280,
283: 282,
285: 284,
287: 286,
289: 288,
291: 290,
293: 292,
295: 294,
297: 296,
299: 298,
301: 300,
303: 302,
305: 73,
307: 306,
309: 308,
311: 310,
314: 313,
316: 315,
318: 317,
320: 319,
322: 321,
324: 323,
326: 325,
328: 327,
331: 330,
333: 332,
335: 334,
337: 336,
339: 338,
341: 340,
343: 342,
345: 344,
347: 346,
349: 348,
351: 350,
353: 352,
355: 354,
357: 356,
359: 358,
361: 360,
363: 362,
365: 364,
367: 366,
369: 368,
371: 370,
373: 372,
375: 374,
378: 377,
380: 379,
382: 381,
383: 83,
384: 579,
387: 386,
389: 388,
392: 391,
396: 395,
402: 401,
405: 502,
409: 408,
410: 573,
414: 544,
417: 416,
419: 418,
421: 420,
424: 423,
429: 428,
432: 431,
436: 435,
438: 437,
441: 440,
445: 444,
447: 503,
452: 453,
453: 453,
454: 453,
455: 456,
456: 456,
457: 456,
458: 459,
459: 459,
460: 459,
462: 461,
464: 463,
466: 465,
468: 467,
470: 469,
472: 471,
474: 473,
476: 475,
477: 398,
479: 478,
481: 480,
483: 482,
485: 484,
487: 486,
489: 488,
491: 490,
493: 492,
495: 494,
497: 498,
498: 498,
499: 498,
501: 500,
505: 504,
507: 506,
509: 508,
511: 510,
513: 512,
515: 514,
517: 516,
519: 518,
521: 520,
523: 522,
525: 524,
527: 526,
529: 528,
531: 530,
533: 532,
535: 534,
537: 536,
539: 538,
541: 540,
543: 542,
547: 546,
549: 548,
551: 550,
553: 552,
555: 554,
557: 556,
559: 558,
561: 560,
563: 562,
572: 571,
575: 11390,
576: 11391,
578: 577,
583: 582,
585: 584,
587: 586,
589: 588,
591: 590,
592: 11375,
593: 11373,
594: 11376,
595: 385,
596: 390,
598: 393,
599: 394,
601: 399,
603: 400,
608: 403,
611: 404,
616: 407,
617: 406,
619: 11362,
623: 412,
625: 11374,
626: 413,
629: 415,
637: 11364,
640: 422,
643: 425,
648: 430,
649: 580,
650: 433,
651: 434,
652: 581,
658: 439,
837: 921,
881: 880,
883: 882,
887: 886,
891: 1021,
892: 1022,
893: 1023,
940: 902,
941: 904,
942: 905,
943: 906,
945: 913,
946: 914,
947: 915,
948: 916,
949: 917,
950: 918,
951: 919,
952: 920,
953: 921,
954: 922,
955: 923,
956: 924,
957: 925,
958: 926,
959: 927,
960: 928,
961: 929,
962: 931,
963: 931,
964: 932,
965: 933,
966: 934,
967: 935,
968: 936,
969: 937,
970: 938,
971: 939,
972: 908,
973: 910,
974: 911,
976: 914,
977: 920,
981: 934,
982: 928,
983: 975,
985: 984,
987: 986,
989: 988,
991: 990,
993: 992,
995: 994,
997: 996,
999: 998,
1001: 1000,
1003: 1002,
1005: 1004,
1007: 1006,
1008: 922,
1009: 929,
1010: 1017,
1013: 917,
1016: 1015,
1019: 1018,
1072: 1040,
1073: 1041,
1074: 1042,
1075: 1043,
1076: 1044,
1077: 1045,
1078: 1046,
1079: 1047,
1080: 1048,
1081: 1049,
1082: 1050,
1083: 1051,
1084: 1052,
1085: 1053,
1086: 1054,
1087: 1055,
1088: 1056,
1089: 1057,
1090: 1058,
1091: 1059,
1092: 1060,
1093: 1061,
1094: 1062,
1095: 1063,
1096: 1064,
1097: 1065,
1098: 1066,
1099: 1067,
1100: 1068,
1101: 1069,
1102: 1070,
1103: 1071,
1104: 1024,
1105: 1025,
1106: 1026,
1107: 1027,
1108: 1028,
1109: 1029,
1110: 1030,
1111: 1031,
1112: 1032,
1113: 1033,
1114: 1034,
1115: 1035,
1116: 1036,
1117: 1037,
1118: 1038,
1119: 1039,
1121: 1120,
1123: 1122,
1125: 1124,
1127: 1126,
1129: 1128,
1131: 1130,
1133: 1132,
1135: 1134,
1137: 1136,
1139: 1138,
1141: 1140,
1143: 1142,
1145: 1144,
1147: 1146,
1149: 1148,
1151: 1150,
1153: 1152,
1163: 1162,
1165: 1164,
1167: 1166,
1169: 1168,
1171: 1170,
1173: 1172,
1175: 1174,
1177: 1176,
1179: 1178,
1181: 1180,
1183: 1182,
1185: 1184,
1187: 1186,
1189: 1188,
1191: 1190,
1193: 1192,
1195: 1194,
1197: 1196,
1199: 1198,
1201: 1200,
1203: 1202,
1205: 1204,
1207: 1206,
1209: 1208,
1211: 1210,
1213: 1212,
1215: 1214,
1218: 1217,
1220: 1219,
1222: 1221,
1224: 1223,
1226: 1225,
1228: 1227,
1230: 1229,
1231: 1216,
1233: 1232,
1235: 1234,
1237: 1236,
1239: 1238,
1241: 1240,
1243: 1242,
1245: 1244,
1247: 1246,
1249: 1248,
1251: 1250,
1253: 1252,
1255: 1254,
1257: 1256,
1259: 1258,
1261: 1260,
1263: 1262,
1265: 1264,
1267: 1266,
1269: 1268,
1271: 1270,
1273: 1272,
1275: 1274,
1277: 1276,
1279: 1278,
1281: 1280,
1283: 1282,
1285: 1284,
1287: 1286,
1289: 1288,
1291: 1290,
1293: 1292,
1295: 1294,
1297: 1296,
1299: 1298,
1301: 1300,
1303: 1302,
1305: 1304,
1307: 1306,
1309: 1308,
1311: 1310,
1313: 1312,
1315: 1314,
1317: 1316,
1377: 1329,
1378: 1330,
1379: 1331,
1380: 1332,
1381: 1333,
1382: 1334,
1383: 1335,
1384: 1336,
1385: 1337,
1386: 1338,
1387: 1339,
1388: 1340,
1389: 1341,
1390: 1342,
1391: 1343,
1392: 1344,
1393: 1345,
1394: 1346,
1395: 1347,
1396: 1348,
1397: 1349,
1398: 1350,
1399: 1351,
1400: 1352,
1401: 1353,
1402: 1354,
1403: 1355,
1404: 1356,
1405: 1357,
1406: 1358,
1407: 1359,
1408: 1360,
1409: 1361,
1410: 1362,
1411: 1363,
1412: 1364,
1413: 1365,
1414: 1366,
7545: 42877,
7549: 11363,
7681: 7680,
7683: 7682,
7685: 7684,
7687: 7686,
7689: 7688,
7691: 7690,
7693: 7692,
7695: 7694,
7697: 7696,
7699: 7698,
7701: 7700,
7703: 7702,
7705: 7704,
7707: 7706,
7709: 7708,
7711: 7710,
7713: 7712,
7715: 7714,
7717: 7716,
7719: 7718,
7721: 7720,
7723: 7722,
7725: 7724,
7727: 7726,
7729: 7728,
7731: 7730,
7733: 7732,
7735: 7734,
7737: 7736,
7739: 7738,
7741: 7740,
7743: 7742,
7745: 7744,
7747: 7746,
7749: 7748,
7751: 7750,
7753: 7752,
7755: 7754,
7757: 7756,
7759: 7758,
7761: 7760,
7763: 7762,
7765: 7764,
7767: 7766,
7769: 7768,
7771: 7770,
7773: 7772,
7775: 7774,
7777: 7776,
7779: 7778,
7781: 7780,
7783: 7782,
7785: 7784,
7787: 7786,
7789: 7788,
7791: 7790,
7793: 7792,
7795: 7794,
7797: 7796,
7799: 7798,
7801: 7800,
7803: 7802,
7805: 7804,
7807: 7806,
7809: 7808,
7811: 7810,
7813: 7812,
7815: 7814,
7817: 7816,
7819: 7818,
7821: 7820,
7823: 7822,
7825: 7824,
7827: 7826,
7829: 7828,
7835: 7776,
7841: 7840,
7843: 7842,
7845: 7844,
7847: 7846,
7849: 7848,
7851: 7850,
7853: 7852,
7855: 7854,
7857: 7856,
7859: 7858,
7861: 7860,
7863: 7862,
7865: 7864,
7867: 7866,
7869: 7868,
7871: 7870,
7873: 7872,
7875: 7874,
7877: 7876,
7879: 7878,
7881: 7880,
7883: 7882,
7885: 7884,
7887: 7886,
7889: 7888,
7891: 7890,
7893: 7892,
7895: 7894,
7897: 7896,
7899: 7898,
7901: 7900,
7903: 7902,
7905: 7904,
7907: 7906,
7909: 7908,
7911: 7910,
7913: 7912,
7915: 7914,
7917: 7916,
7919: 7918,
7921: 7920,
7923: 7922,
7925: 7924,
7927: 7926,
7929: 7928,
7931: 7930,
7933: 7932,
7935: 7934,
7936: 7944,
7937: 7945,
7938: 7946,
7939: 7947,
7940: 7948,
7941: 7949,
7942: 7950,
7943: 7951,
7952: 7960,
7953: 7961,
7954: 7962,
7955: 7963,
7956: 7964,
7957: 7965,
7968: 7976,
7969: 7977,
7970: 7978,
7971: 7979,
7972: 7980,
7973: 7981,
7974: 7982,
7975: 7983,
7984: 7992,
7985: 7993,
7986: 7994,
7987: 7995,
7988: 7996,
7989: 7997,
7990: 7998,
7991: 7999,
8000: 8008,
8001: 8009,
8002: 8010,
8003: 8011,
8004: 8012,
8005: 8013,
8017: 8025,
8019: 8027,
8021: 8029,
8023: 8031,
8032: 8040,
8033: 8041,
8034: 8042,
8035: 8043,
8036: 8044,
8037: 8045,
8038: 8046,
8039: 8047,
8048: 8122,
8049: 8123,
8050: 8136,
8051: 8137,
8052: 8138,
8053: 8139,
8054: 8154,
8055: 8155,
8056: 8184,
8057: 8185,
8058: 8170,
8059: 8171,
8060: 8186,
8061: 8187,
8064: 8072,
8065: 8073,
8066: 8074,
8067: 8075,
8068: 8076,
8069: 8077,
8070: 8078,
8071: 8079,
8080: 8088,
8081: 8089,
8082: 8090,
8083: 8091,
8084: 8092,
8085: 8093,
8086: 8094,
8087: 8095,
8096: 8104,
8097: 8105,
8098: 8106,
8099: 8107,
8100: 8108,
8101: 8109,
8102: 8110,
8103: 8111,
8112: 8120,
8113: 8121,
8115: 8124,
8126: 921,
8131: 8140,
8144: 8152,
8145: 8153,
8160: 8168,
8161: 8169,
8165: 8172,
8179: 8188,
8526: 8498,
8560: 8544,
8561: 8545,
8562: 8546,
8563: 8547,
8564: 8548,
8565: 8549,
8566: 8550,
8567: 8551,
8568: 8552,
8569: 8553,
8570: 8554,
8571: 8555,
8572: 8556,
8573: 8557,
8574: 8558,
8575: 8559,
8580: 8579,
9424: 9398,
9425: 9399,
9426: 9400,
9427: 9401,
9428: 9402,
9429: 9403,
9430: 9404,
9431: 9405,
9432: 9406,
9433: 9407,
9434: 9408,
9435: 9409,
9436: 9410,
9437: 9411,
9438: 9412,
9439: 9413,
9440: 9414,
9441: 9415,
9442: 9416,
9443: 9417,
9444: 9418,
9445: 9419,
9446: 9420,
9447: 9421,
9448: 9422,
9449: 9423,
11312: 11264,
11313: 11265,
11314: 11266,
11315: 11267,
11316: 11268,
11317: 11269,
11318: 11270,
11319: 11271,
11320: 11272,
11321: 11273,
11322: 11274,
11323: 11275,
11324: 11276,
11325: 11277,
11326: 11278,
11327: 11279,
11328: 11280,
11329: 11281,
11330: 11282,
11331: 11283,
11332: 11284,
11333: 11285,
11334: 11286,
11335: 11287,
11336: 11288,
11337: 11289,
11338: 11290,
11339: 11291,
11340: 11292,
11341: 11293,
11342: 11294,
11343: 11295,
11344: 11296,
11345: 11297,
11346: 11298,
11347: 11299,
11348: 11300,
11349: 11301,
11350: 11302,
11351: 11303,
11352: 11304,
11353: 11305,
11354: 11306,
11355: 11307,
11356: 11308,
11357: 11309,
11358: 11310,
11361: 11360,
11365: 570,
11366: 574,
11368: 11367,
11370: 11369,
11372: 11371,
11379: 11378,
11382: 11381,
11393: 11392,
11395: 11394,
11397: 11396,
11399: 11398,
11401: 11400,
11403: 11402,
11405: 11404,
11407: 11406,
11409: 11408,
11411: 11410,
11413: 11412,
11415: 11414,
11417: 11416,
11419: 11418,
11421: 11420,
11423: 11422,
11425: 11424,
11427: 11426,
11429: 11428,
11431: 11430,
11433: 11432,
11435: 11434,
11437: 11436,
11439: 11438,
11441: 11440,
11443: 11442,
11445: 11444,
11447: 11446,
11449: 11448,
11451: 11450,
11453: 11452,
11455: 11454,
11457: 11456,
11459: 11458,
11461: 11460,
11463: 11462,
11465: 11464,
11467: 11466,
11469: 11468,
11471: 11470,
11473: 11472,
11475: 11474,
11477: 11476,
11479: 11478,
11481: 11480,
11483: 11482,
11485: 11484,
11487: 11486,
11489: 11488,
11491: 11490,
11500: 11499,
11502: 11501,
11520: 4256,
11521: 4257,
11522: 4258,
11523: 4259,
11524: 4260,
11525: 4261,
11526: 4262,
11527: 4263,
11528: 4264,
11529: 4265,
11530: 4266,
11531: 4267,
11532: 4268,
11533: 4269,
11534: 4270,
11535: 4271,
11536: 4272,
11537: 4273,
11538: 4274,
11539: 4275,
11540: 4276,
11541: 4277,
11542: 4278,
11543: 4279,
11544: 4280,
11545: 4281,
11546: 4282,
11547: 4283,
11548: 4284,
11549: 4285,
11550: 4286,
11551: 4287,
11552: 4288,
11553: 4289,
11554: 4290,
11555: 4291,
11556: 4292,
11557: 4293,
42561: 42560,
42563: 42562,
42565: 42564,
42567: 42566,
42569: 42568,
42571: 42570,
42573: 42572,
42575: 42574,
42577: 42576,
42579: 42578,
42581: 42580,
42583: 42582,
42585: 42584,
42587: 42586,
42589: 42588,
42591: 42590,
42595: 42594,
42597: 42596,
42599: 42598,
42601: 42600,
42603: 42602,
42605: 42604,
42625: 42624,
42627: 42626,
42629: 42628,
42631: 42630,
42633: 42632,
42635: 42634,
42637: 42636,
42639: 42638,
42641: 42640,
42643: 42642,
42645: 42644,
42647: 42646,
42787: 42786,
42789: 42788,
42791: 42790,
42793: 42792,
42795: 42794,
42797: 42796,
42799: 42798,
42803: 42802,
42805: 42804,
42807: 42806,
42809: 42808,
42811: 42810,
42813: 42812,
42815: 42814,
42817: 42816,
42819: 42818,
42821: 42820,
42823: 42822,
42825: 42824,
42827: 42826,
42829: 42828,
42831: 42830,
42833: 42832,
42835: 42834,
42837: 42836,
42839: 42838,
42841: 42840,
42843: 42842,
42845: 42844,
42847: 42846,
42849: 42848,
42851: 42850,
42853: 42852,
42855: 42854,
42857: 42856,
42859: 42858,
42861: 42860,
42863: 42862,
42874: 42873,
42876: 42875,
42879: 42878,
42881: 42880,
42883: 42882,
42885: 42884,
42887: 42886,
42892: 42891,
65345: 65313,
65346: 65314,
65347: 65315,
65348: 65316,
65349: 65317,
65350: 65318,
65351: 65319,
65352: 65320,
65353: 65321,
65354: 65322,
65355: 65323,
65356: 65324,
65357: 65325,
65358: 65326,
65359: 65327,
65360: 65328,
65361: 65329,
65362: 65330,
65363: 65331,
65364: 65332,
65365: 65333,
65366: 65334,
65367: 65335,
65368: 65336,
65369: 65337,
65370: 65338,
66600: 66560,
66601: 66561,
66602: 66562,
66603: 66563,
66604: 66564,
66605: 66565,
66606: 66566,
66607: 66567,
66608: 66568,
66609: 66569,
66610: 66570,
66611: 66571,
66612: 66572,
66613: 66573,
66614: 66574,
66615: 66575,
66616: 66576,
66617: 66577,
66618: 66578,
66619: 66579,
66620: 66580,
66621: 66581,
66622: 66582,
66623: 66583,
66624: 66584,
66625: 66585,
66626: 66586,
66627: 66587,
66628: 66588,
66629: 66589,
66630: 66590,
66631: 66591,
66632: 66592,
66633: 66593,
66634: 66594,
66635: 66595,
66636: 66596,
66637: 66597,
66638: 66598,
66639: 66599,
}

_totitle_corrected = {
}

def toupper(code):
    try:
        return _toupper[code]
    except KeyError:
        if base_mod is not None and code not in _toupper_corrected:
            return base_mod._toupper.get(code, code)
        else:
            return code

def tolower(code):
    try:
        return _tolower[code]
    except KeyError:
        if base_mod is not None and code not in _tolower_corrected:
            return base_mod._tolower.get(code, code)
        else:
            return code

def totitle(code):
    try:
        return _totitle[code]
    except KeyError:
        if base_mod is not None and code not in _totitle_corrected:
            return base_mod._totitle.get(code, code)
        else:
            return code

_raw_decomposition = {
160: '<noBreak> 0020',
168: '<compat> 0020 0308',
170: '<super> 0061',
175: '<compat> 0020 0304',
178: '<super> 0032',
179: '<super> 0033',
180: '<compat> 0020 0301',
181: '<compat> 03BC',
184: '<compat> 0020 0327',
185: '<super> 0031',
186: '<super> 006F',
188: '<fraction> 0031 2044 0034',
189: '<fraction> 0031 2044 0032',
190: '<fraction> 0033 2044 0034',
192: '0041 0300',
193: '0041 0301',
194: '0041 0302',
195: '0041 0303',
196: '0041 0308',
197: '0041 030A',
199: '0043 0327',
200: '0045 0300',
201: '0045 0301',
202: '0045 0302',
203: '0045 0308',
204: '0049 0300',
205: '0049 0301',
206: '0049 0302',
207: '0049 0308',
209: '004E 0303',
210: '004F 0300',
211: '004F 0301',
212: '004F 0302',
213: '004F 0303',
214: '004F 0308',
217: '0055 0300',
218: '0055 0301',
219: '0055 0302',
220: '0055 0308',
221: '0059 0301',
224: '0061 0300',
225: '0061 0301',
226: '0061 0302',
227: '0061 0303',
228: '0061 0308',
229: '0061 030A',
231: '0063 0327',
232: '0065 0300',
233: '0065 0301',
234: '0065 0302',
235: '0065 0308',
236: '0069 0300',
237: '0069 0301',
238: '0069 0302',
239: '0069 0308',
241: '006E 0303',
242: '006F 0300',
243: '006F 0301',
244: '006F 0302',
245: '006F 0303',
246: '006F 0308',
249: '0075 0300',
250: '0075 0301',
251: '0075 0302',
252: '0075 0308',
253: '0079 0301',
255: '0079 0308',
256: '0041 0304',
257: '0061 0304',
258: '0041 0306',
259: '0061 0306',
260: '0041 0328',
261: '0061 0328',
262: '0043 0301',
263: '0063 0301',
264: '0043 0302',
265: '0063 0302',
266: '0043 0307',
267: '0063 0307',
268: '0043 030C',
269: '0063 030C',
270: '0044 030C',
271: '0064 030C',
274: '0045 0304',
275: '0065 0304',
276: '0045 0306',
277: '0065 0306',
278: '0045 0307',
279: '0065 0307',
280: '0045 0328',
281: '0065 0328',
282: '0045 030C',
283: '0065 030C',
284: '0047 0302',
285: '0067 0302',
286: '0047 0306',
287: '0067 0306',
288: '0047 0307',
289: '0067 0307',
290: '0047 0327',
291: '0067 0327',
292: '0048 0302',
293: '0068 0302',
296: '0049 0303',
297: '0069 0303',
298: '0049 0304',
299: '0069 0304',
300: '0049 0306',
301: '0069 0306',
302: '0049 0328',
303: '0069 0328',
304: '0049 0307',
306: '<compat> 0049 004A',
307: '<compat> 0069 006A',
308: '004A 0302',
309: '006A 0302',
310: '004B 0327',
311: '006B 0327',
313: '004C 0301',
314: '006C 0301',
315: '004C 0327',
316: '006C 0327',
317: '004C 030C',
318: '006C 030C',
319: '<compat> 004C 00B7',
320: '<compat> 006C 00B7',
323: '004E 0301',
324: '006E 0301',
325: '004E 0327',
326: '006E 0327',
327: '004E 030C',
328: '006E 030C',
329: '<compat> 02BC 006E',
332: '004F 0304',
333: '006F 0304',
334: '004F 0306',
335: '006F 0306',
336: '004F 030B',
337: '006F 030B',
340: '0052 0301',
341: '0072 0301',
342: '0052 0327',
343: '0072 0327',
344: '0052 030C',
345: '0072 030C',
346: '0053 0301',
347: '0073 0301',
348: '0053 0302',
349: '0073 0302',
350: '0053 0327',
351: '0073 0327',
352: '0053 030C',
353: '0073 030C',
354: '0054 0327',
355: '0074 0327',
356: '0054 030C',
357: '0074 030C',
360: '0055 0303',
361: '0075 0303',
362: '0055 0304',
363: '0075 0304',
364: '0055 0306',
365: '0075 0306',
366: '0055 030A',
367: '0075 030A',
368: '0055 030B',
369: '0075 030B',
370: '0055 0328',
371: '0075 0328',
372: '0057 0302',
373: '0077 0302',
374: '0059 0302',
375: '0079 0302',
376: '0059 0308',
377: '005A 0301',
378: '007A 0301',
379: '005A 0307',
380: '007A 0307',
381: '005A 030C',
382: '007A 030C',
383: '<compat> 0073',
416: '004F 031B',
417: '006F 031B',
431: '0055 031B',
432: '0075 031B',
452: '<compat> 0044 017D',
453: '<compat> 0044 017E',
454: '<compat> 0064 017E',
455: '<compat> 004C 004A',
456: '<compat> 004C 006A',
457: '<compat> 006C 006A',
458: '<compat> 004E 004A',
459: '<compat> 004E 006A',
460: '<compat> 006E 006A',
461: '0041 030C',
462: '0061 030C',
463: '0049 030C',
464: '0069 030C',
465: '004F 030C',
466: '006F 030C',
467: '0055 030C',
468: '0075 030C',
469: '00DC 0304',
470: '00FC 0304',
471: '00DC 0301',
472: '00FC 0301',
473: '00DC 030C',
474: '00FC 030C',
475: '00DC 0300',
476: '00FC 0300',
478: '00C4 0304',
479: '00E4 0304',
480: '0226 0304',
481: '0227 0304',
482: '00C6 0304',
483: '00E6 0304',
486: '0047 030C',
487: '0067 030C',
488: '004B 030C',
489: '006B 030C',
490: '004F 0328',
491: '006F 0328',
492: '01EA 0304',
493: '01EB 0304',
494: '01B7 030C',
495: '0292 030C',
496: '006A 030C',
497: '<compat> 0044 005A',
498: '<compat> 0044 007A',
499: '<compat> 0064 007A',
500: '0047 0301',
501: '0067 0301',
504: '004E 0300',
505: '006E 0300',
506: '00C5 0301',
507: '00E5 0301',
508: '00C6 0301',
509: '00E6 0301',
510: '00D8 0301',
511: '00F8 0301',
512: '0041 030F',
513: '0061 030F',
514: '0041 0311',
515: '0061 0311',
516: '0045 030F',
517: '0065 030F',
518: '0045 0311',
519: '0065 0311',
520: '0049 030F',
521: '0069 030F',
522: '0049 0311',
523: '0069 0311',
524: '004F 030F',
525: '006F 030F',
526: '004F 0311',
527: '006F 0311',
528: '0052 030F',
529: '0072 030F',
530: '0052 0311',
531: '0072 0311',
532: '0055 030F',
533: '0075 030F',
534: '0055 0311',
535: '0075 0311',
536: '0053 0326',
537: '0073 0326',
538: '0054 0326',
539: '0074 0326',
542: '0048 030C',
543: '0068 030C',
550: '0041 0307',
551: '0061 0307',
552: '0045 0327',
553: '0065 0327',
554: '00D6 0304',
555: '00F6 0304',
556: '00D5 0304',
557: '00F5 0304',
558: '004F 0307',
559: '006F 0307',
560: '022E 0304',
561: '022F 0304',
562: '0059 0304',
563: '0079 0304',
688: '<super> 0068',
689: '<super> 0266',
690: '<super> 006A',
691: '<super> 0072',
692: '<super> 0279',
693: '<super> 027B',
694: '<super> 0281',
695: '<super> 0077',
696: '<super> 0079',
728: '<compat> 0020 0306',
729: '<compat> 0020 0307',
730: '<compat> 0020 030A',
731: '<compat> 0020 0328',
732: '<compat> 0020 0303',
733: '<compat> 0020 030B',
736: '<super> 0263',
737: '<super> 006C',
738: '<super> 0073',
739: '<super> 0078',
740: '<super> 0295',
832: '0300',
833: '0301',
835: '0313',
836: '0308 0301',
884: '02B9',
890: '<compat> 0020 0345',
894: '003B',
900: '<compat> 0020 0301',
901: '00A8 0301',
902: '0391 0301',
903: '00B7',
904: '0395 0301',
905: '0397 0301',
906: '0399 0301',
908: '039F 0301',
910: '03A5 0301',
911: '03A9 0301',
912: '03CA 0301',
938: '0399 0308',
939: '03A5 0308',
940: '03B1 0301',
941: '03B5 0301',
942: '03B7 0301',
943: '03B9 0301',
944: '03CB 0301',
970: '03B9 0308',
971: '03C5 0308',
972: '03BF 0301',
973: '03C5 0301',
974: '03C9 0301',
976: '<compat> 03B2',
977: '<compat> 03B8',
978: '<compat> 03A5',
979: '03D2 0301',
980: '03D2 0308',
981: '<compat> 03C6',
982: '<compat> 03C0',
1008: '<compat> 03BA',
1009: '<compat> 03C1',
1010: '<compat> 03C2',
1012: '<compat> 0398',
1013: '<compat> 03B5',
1017: '<compat> 03A3',
1024: '0415 0300',
1025: '0415 0308',
1027: '0413 0301',
1031: '0406 0308',
1036: '041A 0301',
1037: '0418 0300',
1038: '0423 0306',
1049: '0418 0306',
1081: '0438 0306',
1104: '0435 0300',
1105: '0435 0308',
1107: '0433 0301',
1111: '0456 0308',
1116: '043A 0301',
1117: '0438 0300',
1118: '0443 0306',
1142: '0474 030F',
1143: '0475 030F',
1217: '0416 0306',
1218: '0436 0306',
1232: '0410 0306',
1233: '0430 0306',
1234: '0410 0308',
1235: '0430 0308',
1238: '0415 0306',
1239: '0435 0306',
1242: '04D8 0308',
1243: '04D9 0308',
1244: '0416 0308',
1245: '0436 0308',
1246: '0417 0308',
1247: '0437 0308',
1250: '0418 0304',
1251: '0438 0304',
1252: '0418 0308',
1253: '0438 0308',
1254: '041E 0308',
1255: '043E 0308',
1258: '04E8 0308',
1259: '04E9 0308',
1260: '042D 0308',
1261: '044D 0308',
1262: '0423 0304',
1263: '0443 0304',
1264: '0423 0308',
1265: '0443 0308',
1266: '0423 030B',
1267: '0443 030B',
1268: '0427 0308',
1269: '0447 0308',
1272: '042B 0308',
1273: '044B 0308',
1415: '<compat> 0565 0582',
1570: '0627 0653',
1571: '0627 0654',
1572: '0648 0654',
1573: '0627 0655',
1574: '064A 0654',
1653: '<compat> 0627 0674',
1654: '<compat> 0648 0674',
1655: '<compat> 06C7 0674',
1656: '<compat> 064A 0674',
1728: '06D5 0654',
1730: '06C1 0654',
1747: '06D2 0654',
2345: '0928 093C',
2353: '0930 093C',
2356: '0933 093C',
2392: '0915 093C',
2393: '0916 093C',
2394: '0917 093C',
2395: '091C 093C',
2396: '0921 093C',
2397: '0922 093C',
2398: '092B 093C',
2399: '092F 093C',
2507: '09C7 09BE',
2508: '09C7 09D7',
2524: '09A1 09BC',
2525: '09A2 09BC',
2527: '09AF 09BC',
2611: '0A32 0A3C',
2614: '0A38 0A3C',
2649: '0A16 0A3C',
2650: '0A17 0A3C',
2651: '0A1C 0A3C',
2654: '0A2B 0A3C',
2888: '0B47 0B56',
2891: '0B47 0B3E',
2892: '0B47 0B57',
2908: '0B21 0B3C',
2909: '0B22 0B3C',
2964: '0B92 0BD7',
3018: '0BC6 0BBE',
3019: '0BC7 0BBE',
3020: '0BC6 0BD7',
3144: '0C46 0C56',
3264: '0CBF 0CD5',
3271: '0CC6 0CD5',
3272: '0CC6 0CD6',
3274: '0CC6 0CC2',
3275: '0CCA 0CD5',
3402: '0D46 0D3E',
3403: '0D47 0D3E',
3404: '0D46 0D57',
3546: '0DD9 0DCA',
3548: '0DD9 0DCF',
3549: '0DDC 0DCA',
3550: '0DD9 0DDF',
3635: '<compat> 0E4D 0E32',
3763: '<compat> 0ECD 0EB2',
3804: '<compat> 0EAB 0E99',
3805: '<compat> 0EAB 0EA1',
3852: '<noBreak> 0F0B',
3907: '0F42 0FB7',
3917: '0F4C 0FB7',
3922: '0F51 0FB7',
3927: '0F56 0FB7',
3932: '0F5B 0FB7',
3945: '0F40 0FB5',
3955: '0F71 0F72',
3957: '0F71 0F74',
3958: '0FB2 0F80',
3959: '<compat> 0FB2 0F81',
3960: '0FB3 0F80',
3961: '<compat> 0FB3 0F81',
3969: '0F71 0F80',
3987: '0F92 0FB7',
3997: '0F9C 0FB7',
4002: '0FA1 0FB7',
4007: '0FA6 0FB7',
4012: '0FAB 0FB7',
4025: '0F90 0FB5',
4134: '1025 102E',
4348: '<super> 10DC',
6918: '1B05 1B35',
6920: '1B07 1B35',
6922: '1B09 1B35',
6924: '1B0B 1B35',
6926: '1B0D 1B35',
6930: '1B11 1B35',
6971: '1B3A 1B35',
6973: '1B3C 1B35',
6976: '1B3E 1B35',
6977: '1B3F 1B35',
6979: '1B42 1B35',
7468: '<super> 0041',
7469: '<super> 00C6',
7470: '<super> 0042',
7472: '<super> 0044',
7473: '<super> 0045',
7474: '<super> 018E',
7475: '<super> 0047',
7476: '<super> 0048',
7477: '<super> 0049',
7478: '<super> 004A',
7479: '<super> 004B',
7480: '<super> 004C',
7481: '<super> 004D',
7482: '<super> 004E',
7484: '<super> 004F',
7485: '<super> 0222',
7486: '<super> 0050',
7487: '<super> 0052',
7488: '<super> 0054',
7489: '<super> 0055',
7490: '<super> 0057',
7491: '<super> 0061',
7492: '<super> 0250',
7493: '<super> 0251',
7494: '<super> 1D02',
7495: '<super> 0062',
7496: '<super> 0064',
7497: '<super> 0065',
7498: '<super> 0259',
7499: '<super> 025B',
7500: '<super> 025C',
7501: '<super> 0067',
7503: '<super> 006B',
7504: '<super> 006D',
7505: '<super> 014B',
7506: '<super> 006F',
7507: '<super> 0254',
7508: '<super> 1D16',
7509: '<super> 1D17',
7510: '<super> 0070',
7511: '<super> 0074',
7512: '<super> 0075',
7513: '<super> 1D1D',
7514: '<super> 026F',
7515: '<super> 0076',
7516: '<super> 1D25',
7517: '<super> 03B2',
7518: '<super> 03B3',
7519: '<super> 03B4',
7520: '<super> 03C6',
7521: '<super> 03C7',
7522: '<sub> 0069',
7523: '<sub> 0072',
7524: '<sub> 0075',
7525: '<sub> 0076',
7526: '<sub> 03B2',
7527: '<sub> 03B3',
7528: '<sub> 03C1',
7529: '<sub> 03C6',
7530: '<sub> 03C7',
7544: '<super> 043D',
7579: '<super> 0252',
7580: '<super> 0063',
7581: '<super> 0255',
7582: '<super> 00F0',
7583: '<super> 025C',
7584: '<super> 0066',
7585: '<super> 025F',
7586: '<super> 0261',
7587: '<super> 0265',
7588: '<super> 0268',
7589: '<super> 0269',
7590: '<super> 026A',
7591: '<super> 1D7B',
7592: '<super> 029D',
7593: '<super> 026D',
7594: '<super> 1D85',
7595: '<super> 029F',
7596: '<super> 0271',
7597: '<super> 0270',
7598: '<super> 0272',
7599: '<super> 0273',
7600: '<super> 0274',
7601: '<super> 0275',
7602: '<super> 0278',
7603: '<super> 0282',
7604: '<super> 0283',
7605: '<super> 01AB',
7606: '<super> 0289',
7607: '<super> 028A',
7608: '<super> 1D1C',
7609: '<super> 028B',
7610: '<super> 028C',
7611: '<super> 007A',
7612: '<super> 0290',
7613: '<super> 0291',
7614: '<super> 0292',
7615: '<super> 03B8',
7680: '0041 0325',
7681: '0061 0325',
7682: '0042 0307',
7683: '0062 0307',
7684: '0042 0323',
7685: '0062 0323',
7686: '0042 0331',
7687: '0062 0331',
7688: '00C7 0301',
7689: '00E7 0301',
7690: '0044 0307',
7691: '0064 0307',
7692: '0044 0323',
7693: '0064 0323',
7694: '0044 0331',
7695: '0064 0331',
7696: '0044 0327',
7697: '0064 0327',
7698: '0044 032D',
7699: '0064 032D',
7700: '0112 0300',
7701: '0113 0300',
7702: '0112 0301',
7703: '0113 0301',
7704: '0045 032D',
7705: '0065 032D',
7706: '0045 0330',
7707: '0065 0330',
7708: '0228 0306',
7709: '0229 0306',
7710: '0046 0307',
7711: '0066 0307',
7712: '0047 0304',
7713: '0067 0304',
7714: '0048 0307',
7715: '0068 0307',
7716: '0048 0323',
7717: '0068 0323',
7718: '0048 0308',
7719: '0068 0308',
7720: '0048 0327',
7721: '0068 0327',
7722: '0048 032E',
7723: '0068 032E',
7724: '0049 0330',
7725: '0069 0330',
7726: '00CF 0301',
7727: '00EF 0301',
7728: '004B 0301',
7729: '006B 0301',
7730: '004B 0323',
7731: '006B 0323',
7732: '004B 0331',
7733: '006B 0331',
7734: '004C 0323',
7735: '006C 0323',
7736: '1E36 0304',
7737: '1E37 0304',
7738: '004C 0331',
7739: '006C 0331',
7740: '004C 032D',
7741: '006C 032D',
7742: '004D 0301',
7743: '006D 0301',
7744: '004D 0307',
7745: '006D 0307',
7746: '004D 0323',
7747: '006D 0323',
7748: '004E 0307',
7749: '006E 0307',
7750: '004E 0323',
7751: '006E 0323',
7752: '004E 0331',
7753: '006E 0331',
7754: '004E 032D',
7755: '006E 032D',
7756: '00D5 0301',
7757: '00F5 0301',
7758: '00D5 0308',
7759: '00F5 0308',
7760: '014C 0300',
7761: '014D 0300',
7762: '014C 0301',
7763: '014D 0301',
7764: '0050 0301',
7765: '0070 0301',
7766: '0050 0307',
7767: '0070 0307',
7768: '0052 0307',
7769: '0072 0307',
7770: '0052 0323',
7771: '0072 0323',
7772: '1E5A 0304',
7773: '1E5B 0304',
7774: '0052 0331',
7775: '0072 0331',
7776: '0053 0307',
7777: '0073 0307',
7778: '0053 0323',
7779: '0073 0323',
7780: '015A 0307',
7781: '015B 0307',
7782: '0160 0307',
7783: '0161 0307',
7784: '1E62 0307',
7785: '1E63 0307',
7786: '0054 0307',
7787: '0074 0307',
7788: '0054 0323',
7789: '0074 0323',
7790: '0054 0331',
7791: '0074 0331',
7792: '0054 032D',
7793: '0074 032D',
7794: '0055 0324',
7795: '0075 0324',
7796: '0055 0330',
7797: '0075 0330',
7798: '0055 032D',
7799: '0075 032D',
7800: '0168 0301',
7801: '0169 0301',
7802: '016A 0308',
7803: '016B 0308',
7804: '0056 0303',
7805: '0076 0303',
7806: '0056 0323',
7807: '0076 0323',
7808: '0057 0300',
7809: '0077 0300',
7810: '0057 0301',
7811: '0077 0301',
7812: '0057 0308',
7813: '0077 0308',
7814: '0057 0307',
7815: '0077 0307',
7816: '0057 0323',
7817: '0077 0323',
7818: '0058 0307',
7819: '0078 0307',
7820: '0058 0308',
7821: '0078 0308',
7822: '0059 0307',
7823: '0079 0307',
7824: '005A 0302',
7825: '007A 0302',
7826: '005A 0323',
7827: '007A 0323',
7828: '005A 0331',
7829: '007A 0331',
7830: '0068 0331',
7831: '0074 0308',
7832: '0077 030A',
7833: '0079 030A',
7834: '<compat> 0061 02BE',
7835: '017F 0307',
7840: '0041 0323',
7841: '0061 0323',
7842: '0041 0309',
7843: '0061 0309',
7844: '00C2 0301',
7845: '00E2 0301',
7846: '00C2 0300',
7847: '00E2 0300',
7848: '00C2 0309',
7849: '00E2 0309',
7850: '00C2 0303',
7851: '00E2 0303',
7852: '1EA0 0302',
7853: '1EA1 0302',
7854: '0102 0301',
7855: '0103 0301',
7856: '0102 0300',
7857: '0103 0300',
7858: '0102 0309',
7859: '0103 0309',
7860: '0102 0303',
7861: '0103 0303',
7862: '1EA0 0306',
7863: '1EA1 0306',
7864: '0045 0323',
7865: '0065 0323',
7866: '0045 0309',
7867: '0065 0309',
7868: '0045 0303',
7869: '0065 0303',
7870: '00CA 0301',
7871: '00EA 0301',
7872: '00CA 0300',
7873: '00EA 0300',
7874: '00CA 0309',
7875: '00EA 0309',
7876: '00CA 0303',
7877: '00EA 0303',
7878: '1EB8 0302',
7879: '1EB9 0302',
7880: '0049 0309',
7881: '0069 0309',
7882: '0049 0323',
7883: '0069 0323',
7884: '004F 0323',
7885: '006F 0323',
7886: '004F 0309',
7887: '006F 0309',
7888: '00D4 0301',
7889: '00F4 0301',
7890: '00D4 0300',
7891: '00F4 0300',
7892: '00D4 0309',
7893: '00F4 0309',
7894: '00D4 0303',
7895: '00F4 0303',
7896: '1ECC 0302',
7897: '1ECD 0302',
7898: '01A0 0301',
7899: '01A1 0301',
7900: '01A0 0300',
7901: '01A1 0300',
7902: '01A0 0309',
7903: '01A1 0309',
7904: '01A0 0303',
7905: '01A1 0303',
7906: '01A0 0323',
7907: '01A1 0323',
7908: '0055 0323',
7909: '0075 0323',
7910: '0055 0309',
7911: '0075 0309',
7912: '01AF 0301',
7913: '01B0 0301',
7914: '01AF 0300',
7915: '01B0 0300',
7916: '01AF 0309',
7917: '01B0 0309',
7918: '01AF 0303',
7919: '01B0 0303',
7920: '01AF 0323',
7921: '01B0 0323',
7922: '0059 0300',
7923: '0079 0300',
7924: '0059 0323',
7925: '0079 0323',
7926: '0059 0309',
7927: '0079 0309',
7928: '0059 0303',
7929: '0079 0303',
7936: '03B1 0313',
7937: '03B1 0314',
7938: '1F00 0300',
7939: '1F01 0300',
7940: '1F00 0301',
7941: '1F01 0301',
7942: '1F00 0342',
7943: '1F01 0342',
7944: '0391 0313',
7945: '0391 0314',
7946: '1F08 0300',
7947: '1F09 0300',
7948: '1F08 0301',
7949: '1F09 0301',
7950: '1F08 0342',
7951: '1F09 0342',
7952: '03B5 0313',
7953: '03B5 0314',
7954: '1F10 0300',
7955: '1F11 0300',
7956: '1F10 0301',
7957: '1F11 0301',
7960: '0395 0313',
7961: '0395 0314',
7962: '1F18 0300',
7963: '1F19 0300',
7964: '1F18 0301',
7965: '1F19 0301',
7968: '03B7 0313',
7969: '03B7 0314',
7970: '1F20 0300',
7971: '1F21 0300',
7972: '1F20 0301',
7973: '1F21 0301',
7974: '1F20 0342',
7975: '1F21 0342',
7976: '0397 0313',
7977: '0397 0314',
7978: '1F28 0300',
7979: '1F29 0300',
7980: '1F28 0301',
7981: '1F29 0301',
7982: '1F28 0342',
7983: '1F29 0342',
7984: '03B9 0313',
7985: '03B9 0314',
7986: '1F30 0300',
7987: '1F31 0300',
7988: '1F30 0301',
7989: '1F31 0301',
7990: '1F30 0342',
7991: '1F31 0342',
7992: '0399 0313',
7993: '0399 0314',
7994: '1F38 0300',
7995: '1F39 0300',
7996: '1F38 0301',
7997: '1F39 0301',
7998: '1F38 0342',
7999: '1F39 0342',
8000: '03BF 0313',
8001: '03BF 0314',
8002: '1F40 0300',
8003: '1F41 0300',
8004: '1F40 0301',
8005: '1F41 0301',
8008: '039F 0313',
8009: '039F 0314',
8010: '1F48 0300',
8011: '1F49 0300',
8012: '1F48 0301',
8013: '1F49 0301',
8016: '03C5 0313',
8017: '03C5 0314',
8018: '1F50 0300',
8019: '1F51 0300',
8020: '1F50 0301',
8021: '1F51 0301',
8022: '1F50 0342',
8023: '1F51 0342',
8025: '03A5 0314',
8027: '1F59 0300',
8029: '1F59 0301',
8031: '1F59 0342',
8032: '03C9 0313',
8033: '03C9 0314',
8034: '1F60 0300',
8035: '1F61 0300',
8036: '1F60 0301',
8037: '1F61 0301',
8038: '1F60 0342',
8039: '1F61 0342',
8040: '03A9 0313',
8041: '03A9 0314',
8042: '1F68 0300',
8043: '1F69 0300',
8044: '1F68 0301',
8045: '1F69 0301',
8046: '1F68 0342',
8047: '1F69 0342',
8048: '03B1 0300',
8049: '03AC',
8050: '03B5 0300',
8051: '03AD',
8052: '03B7 0300',
8053: '03AE',
8054: '03B9 0300',
8055: '03AF',
8056: '03BF 0300',
8057: '03CC',
8058: '03C5 0300',
8059: '03CD',
8060: '03C9 0300',
8061: '03CE',
8064: '1F00 0345',
8065: '1F01 0345',
8066: '1F02 0345',
8067: '1F03 0345',
8068: '1F04 0345',
8069: '1F05 0345',
8070: '1F06 0345',
8071: '1F07 0345',
8072: '1F08 0345',
8073: '1F09 0345',
8074: '1F0A 0345',
8075: '1F0B 0345',
8076: '1F0C 0345',
8077: '1F0D 0345',
8078: '1F0E 0345',
8079: '1F0F 0345',
8080: '1F20 0345',
8081: '1F21 0345',
8082: '1F22 0345',
8083: '1F23 0345',
8084: '1F24 0345',
8085: '1F25 0345',
8086: '1F26 0345',
8087: '1F27 0345',
8088: '1F28 0345',
8089: '1F29 0345',
8090: '1F2A 0345',
8091: '1F2B 0345',
8092: '1F2C 0345',
8093: '1F2D 0345',
8094: '1F2E 0345',
8095: '1F2F 0345',
8096: '1F60 0345',
8097: '1F61 0345',
8098: '1F62 0345',
8099: '1F63 0345',
8100: '1F64 0345',
8101: '1F65 0345',
8102: '1F66 0345',
8103: '1F67 0345',
8104: '1F68 0345',
8105: '1F69 0345',
8106: '1F6A 0345',
8107: '1F6B 0345',
8108: '1F6C 0345',
8109: '1F6D 0345',
8110: '1F6E 0345',
8111: '1F6F 0345',
8112: '03B1 0306',
8113: '03B1 0304',
8114: '1F70 0345',
8115: '03B1 0345',
8116: '03AC 0345',
8118: '03B1 0342',
8119: '1FB6 0345',
8120: '0391 0306',
8121: '0391 0304',
8122: '0391 0300',
8123: '0386',
8124: '0391 0345',
8125: '<compat> 0020 0313',
8126: '03B9',
8127: '<compat> 0020 0313',
8128: '<compat> 0020 0342',
8129: '00A8 0342',
8130: '1F74 0345',
8131: '03B7 0345',
8132: '03AE 0345',
8134: '03B7 0342',
8135: '1FC6 0345',
8136: '0395 0300',
8137: '0388',
8138: '0397 0300',
8139: '0389',
8140: '0397 0345',
8141: '1FBF 0300',
8142: '1FBF 0301',
8143: '1FBF 0342',
8144: '03B9 0306',
8145: '03B9 0304',
8146: '03CA 0300',
8147: '0390',
8150: '03B9 0342',
8151: '03CA 0342',
8152: '0399 0306',
8153: '0399 0304',
8154: '0399 0300',
8155: '038A',
8157: '1FFE 0300',
8158: '1FFE 0301',
8159: '1FFE 0342',
8160: '03C5 0306',
8161: '03C5 0304',
8162: '03CB 0300',
8163: '03B0',
8164: '03C1 0313',
8165: '03C1 0314',
8166: '03C5 0342',
8167: '03CB 0342',
8168: '03A5 0306',
8169: '03A5 0304',
8170: '03A5 0300',
8171: '038E',
8172: '03A1 0314',
8173: '00A8 0300',
8174: '0385',
8175: '0060',
8178: '1F7C 0345',
8179: '03C9 0345',
8180: '03CE 0345',
8182: '03C9 0342',
8183: '1FF6 0345',
8184: '039F 0300',
8185: '038C',
8186: '03A9 0300',
8187: '038F',
8188: '03A9 0345',
8189: '00B4',
8190: '<compat> 0020 0314',
8192: '2002',
8193: '2003',
8194: '<compat> 0020',
8195: '<compat> 0020',
8196: '<compat> 0020',
8197: '<compat> 0020',
8198: '<compat> 0020',
8199: '<noBreak> 0020',
8200: '<compat> 0020',
8201: '<compat> 0020',
8202: '<compat> 0020',
8209: '<noBreak> 2010',
8215: '<compat> 0020 0333',
8228: '<compat> 002E',
8229: '<compat> 002E 002E',
8230: '<compat> 002E 002E 002E',
8239: '<noBreak> 0020',
8243: '<compat> 2032 2032',
8244: '<compat> 2032 2032 2032',
8246: '<compat> 2035 2035',
8247: '<compat> 2035 2035 2035',
8252: '<compat> 0021 0021',
8254: '<compat> 0020 0305',
8263: '<compat> 003F 003F',
8264: '<compat> 003F 0021',
8265: '<compat> 0021 003F',
8279: '<compat> 2032 2032 2032 2032',
8287: '<compat> 0020',
8304: '<super> 0030',
8305: '<super> 0069',
8308: '<super> 0034',
8309: '<super> 0035',
8310: '<super> 0036',
8311: '<super> 0037',
8312: '<super> 0038',
8313: '<super> 0039',
8314: '<super> 002B',
8315: '<super> 2212',
8316: '<super> 003D',
8317: '<super> 0028',
8318: '<super> 0029',
8319: '<super> 006E',
8320: '<sub> 0030',
8321: '<sub> 0031',
8322: '<sub> 0032',
8323: '<sub> 0033',
8324: '<sub> 0034',
8325: '<sub> 0035',
8326: '<sub> 0036',
8327: '<sub> 0037',
8328: '<sub> 0038',
8329: '<sub> 0039',
8330: '<sub> 002B',
8331: '<sub> 2212',
8332: '<sub> 003D',
8333: '<sub> 0028',
8334: '<sub> 0029',
8336: '<sub> 0061',
8337: '<sub> 0065',
8338: '<sub> 006F',
8339: '<sub> 0078',
8340: '<sub> 0259',
8360: '<compat> 0052 0073',
8448: '<compat> 0061 002F 0063',
8449: '<compat> 0061 002F 0073',
8450: '<font> 0043',
8451: '<compat> 00B0 0043',
8453: '<compat> 0063 002F 006F',
8454: '<compat> 0063 002F 0075',
8455: '<compat> 0190',
8457: '<compat> 00B0 0046',
8458: '<font> 0067',
8459: '<font> 0048',
8460: '<font> 0048',
8461: '<font> 0048',
8462: '<font> 0068',
8463: '<font> 0127',
8464: '<font> 0049',
8465: '<font> 0049',
8466: '<font> 004C',
8467: '<font> 006C',
8469: '<font> 004E',
8470: '<compat> 004E 006F',
8473: '<font> 0050',
8474: '<font> 0051',
8475: '<font> 0052',
8476: '<font> 0052',
8477: '<font> 0052',
8480: '<super> 0053 004D',
8481: '<compat> 0054 0045 004C',
8482: '<super> 0054 004D',
8484: '<font> 005A',
8486: '03A9',
8488: '<font> 005A',
8490: '004B',
8491: '00C5',
8492: '<font> 0042',
8493: '<font> 0043',
8495: '<font> 0065',
8496: '<font> 0045',
8497: '<font> 0046',
8499: '<font> 004D',
8500: '<font> 006F',
8501: '<compat> 05D0',
8502: '<compat> 05D1',
8503: '<compat> 05D2',
8504: '<compat> 05D3',
8505: '<font> 0069',
8507: '<compat> 0046 0041 0058',
8508: '<font> 03C0',
8509: '<font> 03B3',
8510: '<font> 0393',
8511: '<font> 03A0',
8512: '<font> 2211',
8517: '<font> 0044',
8518: '<font> 0064',
8519: '<font> 0065',
8520: '<font> 0069',
8521: '<font> 006A',
8528: '<fraction> 0031 2044 0037',
8529: '<fraction> 0031 2044 0039',
8530: '<fraction> 0031 2044 0031 0030',
8531: '<fraction> 0031 2044 0033',
8532: '<fraction> 0032 2044 0033',
8533: '<fraction> 0031 2044 0035',
8534: '<fraction> 0032 2044 0035',
8535: '<fraction> 0033 2044 0035',
8536: '<fraction> 0034 2044 0035',
8537: '<fraction> 0031 2044 0036',
8538: '<fraction> 0035 2044 0036',
8539: '<fraction> 0031 2044 0038',
8540: '<fraction> 0033 2044 0038',
8541: '<fraction> 0035 2044 0038',
8542: '<fraction> 0037 2044 0038',
8543: '<fraction> 0031 2044',
8544: '<compat> 0049',
8545: '<compat> 0049 0049',
8546: '<compat> 0049 0049 0049',
8547: '<compat> 0049 0056',
8548: '<compat> 0056',
8549: '<compat> 0056 0049',
8550: '<compat> 0056 0049 0049',
8551: '<compat> 0056 0049 0049 0049',
8552: '<compat> 0049 0058',
8553: '<compat> 0058',
8554: '<compat> 0058 0049',
8555: '<compat> 0058 0049 0049',
8556: '<compat> 004C',
8557: '<compat> 0043',
8558: '<compat> 0044',
8559: '<compat> 004D',
8560: '<compat> 0069',
8561: '<compat> 0069 0069',
8562: '<compat> 0069 0069 0069',
8563: '<compat> 0069 0076',
8564: '<compat> 0076',
8565: '<compat> 0076 0069',
8566: '<compat> 0076 0069 0069',
8567: '<compat> 0076 0069 0069 0069',
8568: '<compat> 0069 0078',
8569: '<compat> 0078',
8570: '<compat> 0078 0069',
8571: '<compat> 0078 0069 0069',
8572: '<compat> 006C',
8573: '<compat> 0063',
8574: '<compat> 0064',
8575: '<compat> 006D',
8585: '<fraction> 0030 2044 0033',
8602: '2190 0338',
8603: '2192 0338',
8622: '2194 0338',
8653: '21D0 0338',
8654: '21D4 0338',
8655: '21D2 0338',
8708: '2203 0338',
8713: '2208 0338',
8716: '220B 0338',
8740: '2223 0338',
8742: '2225 0338',
8748: '<compat> 222B 222B',
8749: '<compat> 222B 222B 222B',
8751: '<compat> 222E 222E',
8752: '<compat> 222E 222E 222E',
8769: '223C 0338',
8772: '2243 0338',
8775: '2245 0338',
8777: '2248 0338',
8800: '003D 0338',
8802: '2261 0338',
8813: '224D 0338',
8814: '003C 0338',
8815: '003E 0338',
8816: '2264 0338',
8817: '2265 0338',
8820: '2272 0338',
8821: '2273 0338',
8824: '2276 0338',
8825: '2277 0338',
8832: '227A 0338',
8833: '227B 0338',
8836: '2282 0338',
8837: '2283 0338',
8840: '2286 0338',
8841: '2287 0338',
8876: '22A2 0338',
8877: '22A8 0338',
8878: '22A9 0338',
8879: '22AB 0338',
8928: '227C 0338',
8929: '227D 0338',
8930: '2291 0338',
8931: '2292 0338',
8938: '22B2 0338',
8939: '22B3 0338',
8940: '22B4 0338',
8941: '22B5 0338',
9001: '3008',
9002: '3009',
9312: '<circle> 0031',
9313: '<circle> 0032',
9314: '<circle> 0033',
9315: '<circle> 0034',
9316: '<circle> 0035',
9317: '<circle> 0036',
9318: '<circle> 0037',
9319: '<circle> 0038',
9320: '<circle> 0039',
9321: '<circle> 0031 0030',
9322: '<circle> 0031 0031',
9323: '<circle> 0031 0032',
9324: '<circle> 0031 0033',
9325: '<circle> 0031 0034',
9326: '<circle> 0031 0035',
9327: '<circle> 0031 0036',
9328: '<circle> 0031 0037',
9329: '<circle> 0031 0038',
9330: '<circle> 0031 0039',
9331: '<circle> 0032 0030',
9332: '<compat> 0028 0031 0029',
9333: '<compat> 0028 0032 0029',
9334: '<compat> 0028 0033 0029',
9335: '<compat> 0028 0034 0029',
9336: '<compat> 0028 0035 0029',
9337: '<compat> 0028 0036 0029',
9338: '<compat> 0028 0037 0029',
9339: '<compat> 0028 0038 0029',
9340: '<compat> 0028 0039 0029',
9341: '<compat> 0028 0031 0030 0029',
9342: '<compat> 0028 0031 0031 0029',
9343: '<compat> 0028 0031 0032 0029',
9344: '<compat> 0028 0031 0033 0029',
9345: '<compat> 0028 0031 0034 0029',
9346: '<compat> 0028 0031 0035 0029',
9347: '<compat> 0028 0031 0036 0029',
9348: '<compat> 0028 0031 0037 0029',
9349: '<compat> 0028 0031 0038 0029',
9350: '<compat> 0028 0031 0039 0029',
9351: '<compat> 0028 0032 0030 0029',
9352: '<compat> 0031 002E',
9353: '<compat> 0032 002E',
9354: '<compat> 0033 002E',
9355: '<compat> 0034 002E',
9356: '<compat> 0035 002E',
9357: '<compat> 0036 002E',
9358: '<compat> 0037 002E',
9359: '<compat> 0038 002E',
9360: '<compat> 0039 002E',
9361: '<compat> 0031 0030 002E',
9362: '<compat> 0031 0031 002E',
9363: '<compat> 0031 0032 002E',
9364: '<compat> 0031 0033 002E',
9365: '<compat> 0031 0034 002E',
9366: '<compat> 0031 0035 002E',
9367: '<compat> 0031 0036 002E',
9368: '<compat> 0031 0037 002E',
9369: '<compat> 0031 0038 002E',
9370: '<compat> 0031 0039 002E',
9371: '<compat> 0032 0030 002E',
9372: '<compat> 0028 0061 0029',
9373: '<compat> 0028 0062 0029',
9374: '<compat> 0028 0063 0029',
9375: '<compat> 0028 0064 0029',
9376: '<compat> 0028 0065 0029',
9377: '<compat> 0028 0066 0029',
9378: '<compat> 0028 0067 0029',
9379: '<compat> 0028 0068 0029',
9380: '<compat> 0028 0069 0029',
9381: '<compat> 0028 006A 0029',
9382: '<compat> 0028 006B 0029',
9383: '<compat> 0028 006C 0029',
9384: '<compat> 0028 006D 0029',
9385: '<compat> 0028 006E 0029',
9386: '<compat> 0028 006F 0029',
9387: '<compat> 0028 0070 0029',
9388: '<compat> 0028 0071 0029',
9389: '<compat> 0028 0072 0029',
9390: '<compat> 0028 0073 0029',
9391: '<compat> 0028 0074 0029',
9392: '<compat> 0028 0075 0029',
9393: '<compat> 0028 0076 0029',
9394: '<compat> 0028 0077 0029',
9395: '<compat> 0028 0078 0029',
9396: '<compat> 0028 0079 0029',
9397: '<compat> 0028 007A 0029',
9398: '<circle> 0041',
9399: '<circle> 0042',
9400: '<circle> 0043',
9401: '<circle> 0044',
9402: '<circle> 0045',
9403: '<circle> 0046',
9404: '<circle> 0047',
9405: '<circle> 0048',
9406: '<circle> 0049',
9407: '<circle> 004A',
9408: '<circle> 004B',
9409: '<circle> 004C',
9410: '<circle> 004D',
9411: '<circle> 004E',
9412: '<circle> 004F',
9413: '<circle> 0050',
9414: '<circle> 0051',
9415: '<circle> 0052',
9416: '<circle> 0053',
9417: '<circle> 0054',
9418: '<circle> 0055',
9419: '<circle> 0056',
9420: '<circle> 0057',
9421: '<circle> 0058',
9422: '<circle> 0059',
9423: '<circle> 005A',
9424: '<circle> 0061',
9425: '<circle> 0062',
9426: '<circle> 0063',
9427: '<circle> 0064',
9428: '<circle> 0065',
9429: '<circle> 0066',
9430: '<circle> 0067',
9431: '<circle> 0068',
9432: '<circle> 0069',
9433: '<circle> 006A',
9434: '<circle> 006B',
9435: '<circle> 006C',
9436: '<circle> 006D',
9437: '<circle> 006E',
9438: '<circle> 006F',
9439: '<circle> 0070',
9440: '<circle> 0071',
9441: '<circle> 0072',
9442: '<circle> 0073',
9443: '<circle> 0074',
9444: '<circle> 0075',
9445: '<circle> 0076',
9446: '<circle> 0077',
9447: '<circle> 0078',
9448: '<circle> 0079',
9449: '<circle> 007A',
9450: '<circle> 0030',
10764: '<compat> 222B 222B 222B 222B',
10868: '<compat> 003A 003A 003D',
10869: '<compat> 003D 003D',
10870: '<compat> 003D 003D 003D',
10972: '2ADD 0338',
11388: '<sub> 006A',
11389: '<super> 0056',
11631: '<super> 2D61',
11935: '<compat> 6BCD',
12019: '<compat> 9F9F',
12032: '<compat> 4E00',
12033: '<compat> 4E28',
12034: '<compat> 4E36',
12035: '<compat> 4E3F',
12036: '<compat> 4E59',
12037: '<compat> 4E85',
12038: '<compat> 4E8C',
12039: '<compat> 4EA0',
12040: '<compat> 4EBA',
12041: '<compat> 513F',
12042: '<compat> 5165',
12043: '<compat> 516B',
12044: '<compat> 5182',
12045: '<compat> 5196',
12046: '<compat> 51AB',
12047: '<compat> 51E0',
12048: '<compat> 51F5',
12049: '<compat> 5200',
12050: '<compat> 529B',
12051: '<compat> 52F9',
12052: '<compat> 5315',
12053: '<compat> 531A',
12054: '<compat> 5338',
12055: '<compat> 5341',
12056: '<compat> 535C',
12057: '<compat> 5369',
12058: '<compat> 5382',
12059: '<compat> 53B6',
12060: '<compat> 53C8',
12061: '<compat> 53E3',
12062: '<compat> 56D7',
12063: '<compat> 571F',
12064: '<compat> 58EB',
12065: '<compat> 5902',
12066: '<compat> 590A',
12067: '<compat> 5915',
12068: '<compat> 5927',
12069: '<compat> 5973',
12070: '<compat> 5B50',
12071: '<compat> 5B80',
12072: '<compat> 5BF8',
12073: '<compat> 5C0F',
12074: '<compat> 5C22',
12075: '<compat> 5C38',
12076: '<compat> 5C6E',
12077: '<compat> 5C71',
12078: '<compat> 5DDB',
12079: '<compat> 5DE5',
12080: '<compat> 5DF1',
12081: '<compat> 5DFE',
12082: '<compat> 5E72',
12083: '<compat> 5E7A',
12084: '<compat> 5E7F',
12085: '<compat> 5EF4',
12086: '<compat> 5EFE',
12087: '<compat> 5F0B',
12088: '<compat> 5F13',
12089: '<compat> 5F50',
12090: '<compat> 5F61',
12091: '<compat> 5F73',
12092: '<compat> 5FC3',
12093: '<compat> 6208',
12094: '<compat> 6236',
12095: '<compat> 624B',
12096: '<compat> 652F',
12097: '<compat> 6534',
12098: '<compat> 6587',
12099: '<compat> 6597',
12100: '<compat> 65A4',
12101: '<compat> 65B9',
12102: '<compat> 65E0',
12103: '<compat> 65E5',
12104: '<compat> 66F0',
12105: '<compat> 6708',
12106: '<compat> 6728',
12107: '<compat> 6B20',
12108: '<compat> 6B62',
12109: '<compat> 6B79',
12110: '<compat> 6BB3',
12111: '<compat> 6BCB',
12112: '<compat> 6BD4',
12113: '<compat> 6BDB',
12114: '<compat> 6C0F',
12115: '<compat> 6C14',
12116: '<compat> 6C34',
12117: '<compat> 706B',
12118: '<compat> 722A',
12119: '<compat> 7236',
12120: '<compat> 723B',
12121: '<compat> 723F',
12122: '<compat> 7247',
12123: '<compat> 7259',
12124: '<compat> 725B',
12125: '<compat> 72AC',
12126: '<compat> 7384',
12127: '<compat> 7389',
12128: '<compat> 74DC',
12129: '<compat> 74E6',
12130: '<compat> 7518',
12131: '<compat> 751F',
12132: '<compat> 7528',
12133: '<compat> 7530',
12134: '<compat> 758B',
12135: '<compat> 7592',
12136: '<compat> 7676',
12137: '<compat> 767D',
12138: '<compat> 76AE',
12139: '<compat> 76BF',
12140: '<compat> 76EE',
12141: '<compat> 77DB',
12142: '<compat> 77E2',
12143: '<compat> 77F3',
12144: '<compat> 793A',
12145: '<compat> 79B8',
12146: '<compat> 79BE',
12147: '<compat> 7A74',
12148: '<compat> 7ACB',
12149: '<compat> 7AF9',
12150: '<compat> 7C73',
12151: '<compat> 7CF8',
12152: '<compat> 7F36',
12153: '<compat> 7F51',
12154: '<compat> 7F8A',
12155: '<compat> 7FBD',
12156: '<compat> 8001',
12157: '<compat> 800C',
12158: '<compat> 8012',
12159: '<compat> 8033',
12160: '<compat> 807F',
12161: '<compat> 8089',
12162: '<compat> 81E3',
12163: '<compat> 81EA',
12164: '<compat> 81F3',
12165: '<compat> 81FC',
12166: '<compat> 820C',
12167: '<compat> 821B',
12168: '<compat> 821F',
12169: '<compat> 826E',
12170: '<compat> 8272',
12171: '<compat> 8278',
12172: '<compat> 864D',
12173: '<compat> 866B',
12174: '<compat> 8840',
12175: '<compat> 884C',
12176: '<compat> 8863',
12177: '<compat> 897E',
12178: '<compat> 898B',
12179: '<compat> 89D2',
12180: '<compat> 8A00',
12181: '<compat> 8C37',
12182: '<compat> 8C46',
12183: '<compat> 8C55',
12184: '<compat> 8C78',
12185: '<compat> 8C9D',
12186: '<compat> 8D64',
12187: '<compat> 8D70',
12188: '<compat> 8DB3',
12189: '<compat> 8EAB',
12190: '<compat> 8ECA',
12191: '<compat> 8F9B',
12192: '<compat> 8FB0',
12193: '<compat> 8FB5',
12194: '<compat> 9091',
12195: '<compat> 9149',
12196: '<compat> 91C6',
12197: '<compat> 91CC',
12198: '<compat> 91D1',
12199: '<compat> 9577',
12200: '<compat> 9580',
12201: '<compat> 961C',
12202: '<compat> 96B6',
12203: '<compat> 96B9',
12204: '<compat> 96E8',
12205: '<compat> 9751',
12206: '<compat> 975E',
12207: '<compat> 9762',
12208: '<compat> 9769',
12209: '<compat> 97CB',
12210: '<compat> 97ED',
12211: '<compat> 97F3',
12212: '<compat> 9801',
12213: '<compat> 98A8',
12214: '<compat> 98DB',
12215: '<compat> 98DF',
12216: '<compat> 9996',
12217: '<compat> 9999',
12218: '<compat> 99AC',
12219: '<compat> 9AA8',
12220: '<compat> 9AD8',
12221: '<compat> 9ADF',
12222: '<compat> 9B25',
12223: '<compat> 9B2F',
12224: '<compat> 9B32',
12225: '<compat> 9B3C',
12226: '<compat> 9B5A',
12227: '<compat> 9CE5',
12228: '<compat> 9E75',
12229: '<compat> 9E7F',
12230: '<compat> 9EA5',
12231: '<compat> 9EBB',
12232: '<compat> 9EC3',
12233: '<compat> 9ECD',
12234: '<compat> 9ED1',
12235: '<compat> 9EF9',
12236: '<compat> 9EFD',
12237: '<compat> 9F0E',
12238: '<compat> 9F13',
12239: '<compat> 9F20',
12240: '<compat> 9F3B',
12241: '<compat> 9F4A',
12242: '<compat> 9F52',
12243: '<compat> 9F8D',
12244: '<compat> 9F9C',
12245: '<compat> 9FA0',
12288: '<wide> 0020',
12342: '<compat> 3012',
12344: '<compat> 5341',
12345: '<compat> 5344',
12346: '<compat> 5345',
12364: '304B 3099',
12366: '304D 3099',
12368: '304F 3099',
12370: '3051 3099',
12372: '3053 3099',
12374: '3055 3099',
12376: '3057 3099',
12378: '3059 3099',
12380: '305B 3099',
12382: '305D 3099',
12384: '305F 3099',
12386: '3061 3099',
12389: '3064 3099',
12391: '3066 3099',
12393: '3068 3099',
12400: '306F 3099',
12401: '306F 309A',
12403: '3072 3099',
12404: '3072 309A',
12406: '3075 3099',
12407: '3075 309A',
12409: '3078 3099',
12410: '3078 309A',
12412: '307B 3099',
12413: '307B 309A',
12436: '3046 3099',
12443: '<compat> 0020 3099',
12444: '<compat> 0020 309A',
12446: '309D 3099',
12447: '<vertical> 3088 308A',
12460: '30AB 3099',
12462: '30AD 3099',
12464: '30AF 3099',
12466: '30B1 3099',
12468: '30B3 3099',
12470: '30B5 3099',
12472: '30B7 3099',
12474: '30B9 3099',
12476: '30BB 3099',
12478: '30BD 3099',
12480: '30BF 3099',
12482: '30C1 3099',
12485: '30C4 3099',
12487: '30C6 3099',
12489: '30C8 3099',
12496: '30CF 3099',
12497: '30CF 309A',
12499: '30D2 3099',
12500: '30D2 309A',
12502: '30D5 3099',
12503: '30D5 309A',
12505: '30D8 3099',
12506: '30D8 309A',
12508: '30DB 3099',
12509: '30DB 309A',
12532: '30A6 3099',
12535: '30EF 3099',
12536: '30F0 3099',
12537: '30F1 3099',
12538: '30F2 3099',
12542: '30FD 3099',
12543: '<vertical> 30B3 30C8',
12593: '<compat> 1100',
12594: '<compat> 1101',
12595: '<compat> 11AA',
12596: '<compat> 1102',
12597: '<compat> 11AC',
12598: '<compat> 11AD',
12599: '<compat> 1103',
12600: '<compat> 1104',
12601: '<compat> 1105',
12602: '<compat> 11B0',
12603: '<compat> 11B1',
12604: '<compat> 11B2',
12605: '<compat> 11B3',
12606: '<compat> 11B4',
12607: '<compat> 11B5',
12608: '<compat> 111A',
12609: '<compat> 1106',
12610: '<compat> 1107',
12611: '<compat> 1108',
12612: '<compat> 1121',
12613: '<compat> 1109',
12614: '<compat> 110A',
12615: '<compat> 110B',
12616: '<compat> 110C',
12617: '<compat> 110D',
12618: '<compat> 110E',
12619: '<compat> 110F',
12620: '<compat> 1110',
12621: '<compat> 1111',
12622: '<compat> 1112',
12623: '<compat> 1161',
12624: '<compat> 1162',
12625: '<compat> 1163',
12626: '<compat> 1164',
12627: '<compat> 1165',
12628: '<compat> 1166',
12629: '<compat> 1167',
12630: '<compat> 1168',
12631: '<compat> 1169',
12632: '<compat> 116A',
12633: '<compat> 116B',
12634: '<compat> 116C',
12635: '<compat> 116D',
12636: '<compat> 116E',
12637: '<compat> 116F',
12638: '<compat> 1170',
12639: '<compat> 1171',
12640: '<compat> 1172',
12641: '<compat> 1173',
12642: '<compat> 1174',
12643: '<compat> 1175',
12644: '<compat> 1160',
12645: '<compat> 1114',
12646: '<compat> 1115',
12647: '<compat> 11C7',
12648: '<compat> 11C8',
12649: '<compat> 11CC',
12650: '<compat> 11CE',
12651: '<compat> 11D3',
12652: '<compat> 11D7',
12653: '<compat> 11D9',
12654: '<compat> 111C',
12655: '<compat> 11DD',
12656: '<compat> 11DF',
12657: '<compat> 111D',
12658: '<compat> 111E',
12659: '<compat> 1120',
12660: '<compat> 1122',
12661: '<compat> 1123',
12662: '<compat> 1127',
12663: '<compat> 1129',
12664: '<compat> 112B',
12665: '<compat> 112C',
12666: '<compat> 112D',
12667: '<compat> 112E',
12668: '<compat> 112F',
12669: '<compat> 1132',
12670: '<compat> 1136',
12671: '<compat> 1140',
12672: '<compat> 1147',
12673: '<compat> 114C',
12674: '<compat> 11F1',
12675: '<compat> 11F2',
12676: '<compat> 1157',
12677: '<compat> 1158',
12678: '<compat> 1159',
12679: '<compat> 1184',
12680: '<compat> 1185',
12681: '<compat> 1188',
12682: '<compat> 1191',
12683: '<compat> 1192',
12684: '<compat> 1194',
12685: '<compat> 119E',
12686: '<compat> 11A1',
12690: '<super> 4E00',
12691: '<super> 4E8C',
12692: '<super> 4E09',
12693: '<super> 56DB',
12694: '<super> 4E0A',
12695: '<super> 4E2D',
12696: '<super> 4E0B',
12697: '<super> 7532',
12698: '<super> 4E59',
12699: '<super> 4E19',
12700: '<super> 4E01',
12701: '<super> 5929',
12702: '<super> 5730',
12703: '<super> 4EBA',
12800: '<compat> 0028 1100 0029',
12801: '<compat> 0028 1102 0029',
12802: '<compat> 0028 1103 0029',
12803: '<compat> 0028 1105 0029',
12804: '<compat> 0028 1106 0029',
12805: '<compat> 0028 1107 0029',
12806: '<compat> 0028 1109 0029',
12807: '<compat> 0028 110B 0029',
12808: '<compat> 0028 110C 0029',
12809: '<compat> 0028 110E 0029',
12810: '<compat> 0028 110F 0029',
12811: '<compat> 0028 1110 0029',
12812: '<compat> 0028 1111 0029',
12813: '<compat> 0028 1112 0029',
12814: '<compat> 0028 1100 1161 0029',
12815: '<compat> 0028 1102 1161 0029',
12816: '<compat> 0028 1103 1161 0029',
12817: '<compat> 0028 1105 1161 0029',
12818: '<compat> 0028 1106 1161 0029',
12819: '<compat> 0028 1107 1161 0029',
12820: '<compat> 0028 1109 1161 0029',
12821: '<compat> 0028 110B 1161 0029',
12822: '<compat> 0028 110C 1161 0029',
12823: '<compat> 0028 110E 1161 0029',
12824: '<compat> 0028 110F 1161 0029',
12825: '<compat> 0028 1110 1161 0029',
12826: '<compat> 0028 1111 1161 0029',
12827: '<compat> 0028 1112 1161 0029',
12828: '<compat> 0028 110C 116E 0029',
12829: '<compat> 0028 110B 1169 110C 1165 11AB 0029',
12830: '<compat> 0028 110B 1169 1112 116E 0029',
12832: '<compat> 0028 4E00 0029',
12833: '<compat> 0028 4E8C 0029',
12834: '<compat> 0028 4E09 0029',
12835: '<compat> 0028 56DB 0029',
12836: '<compat> 0028 4E94 0029',
12837: '<compat> 0028 516D 0029',
12838: '<compat> 0028 4E03 0029',
12839: '<compat> 0028 516B 0029',
12840: '<compat> 0028 4E5D 0029',
12841: '<compat> 0028 5341 0029',
12842: '<compat> 0028 6708 0029',
12843: '<compat> 0028 706B 0029',
12844: '<compat> 0028 6C34 0029',
12845: '<compat> 0028 6728 0029',
12846: '<compat> 0028 91D1 0029',
12847: '<compat> 0028 571F 0029',
12848: '<compat> 0028 65E5 0029',
12849: '<compat> 0028 682A 0029',
12850: '<compat> 0028 6709 0029',
12851: '<compat> 0028 793E 0029',
12852: '<compat> 0028 540D 0029',
12853: '<compat> 0028 7279 0029',
12854: '<compat> 0028 8CA1 0029',
12855: '<compat> 0028 795D 0029',
12856: '<compat> 0028 52B4 0029',
12857: '<compat> 0028 4EE3 0029',
12858: '<compat> 0028 547C 0029',
12859: '<compat> 0028 5B66 0029',
12860: '<compat> 0028 76E3 0029',
12861: '<compat> 0028 4F01 0029',
12862: '<compat> 0028 8CC7 0029',
12863: '<compat> 0028 5354 0029',
12864: '<compat> 0028 796D 0029',
12865: '<compat> 0028 4F11 0029',
12866: '<compat> 0028 81EA 0029',
12867: '<compat> 0028 81F3 0029',
12868: '<circle> 554F',
12869: '<circle> 5E7C',
12870: '<circle> 6587',
12871: '<circle> 7B8F',
12880: '<square> 0050 0054 0045',
12881: '<circle> 0032 0031',
12882: '<circle> 0032 0032',
12883: '<circle> 0032 0033',
12884: '<circle> 0032 0034',
12885: '<circle> 0032 0035',
12886: '<circle> 0032 0036',
12887: '<circle> 0032 0037',
12888: '<circle> 0032 0038',
12889: '<circle> 0032 0039',
12890: '<circle> 0033 0030',
12891: '<circle> 0033 0031',
12892: '<circle> 0033 0032',
12893: '<circle> 0033 0033',
12894: '<circle> 0033 0034',
12895: '<circle> 0033 0035',
12896: '<circle> 1100',
12897: '<circle> 1102',
12898: '<circle> 1103',
12899: '<circle> 1105',
12900: '<circle> 1106',
12901: '<circle> 1107',
12902: '<circle> 1109',
12903: '<circle> 110B',
12904: '<circle> 110C',
12905: '<circle> 110E',
12906: '<circle> 110F',
12907: '<circle> 1110',
12908: '<circle> 1111',
12909: '<circle> 1112',
12910: '<circle> 1100 1161',
12911: '<circle> 1102 1161',
12912: '<circle> 1103 1161',
12913: '<circle> 1105 1161',
12914: '<circle> 1106 1161',
12915: '<circle> 1107 1161',
12916: '<circle> 1109 1161',
12917: '<circle> 110B 1161',
12918: '<circle> 110C 1161',
12919: '<circle> 110E 1161',
12920: '<circle> 110F 1161',
12921: '<circle> 1110 1161',
12922: '<circle> 1111 1161',
12923: '<circle> 1112 1161',
12924: '<circle> 110E 1161 11B7 1100 1169',
12925: '<circle> 110C 116E 110B 1174',
12926: '<circle> 110B 116E',
12928: '<circle> 4E00',
12929: '<circle> 4E8C',
12930: '<circle> 4E09',
12931: '<circle> 56DB',
12932: '<circle> 4E94',
12933: '<circle> 516D',
12934: '<circle> 4E03',
12935: '<circle> 516B',
12936: '<circle> 4E5D',
12937: '<circle> 5341',
12938: '<circle> 6708',
12939: '<circle> 706B',
12940: '<circle> 6C34',
12941: '<circle> 6728',
12942: '<circle> 91D1',
12943: '<circle> 571F',
12944: '<circle> 65E5',
12945: '<circle> 682A',
12946: '<circle> 6709',
12947: '<circle> 793E',
12948: '<circle> 540D',
12949: '<circle> 7279',
12950: '<circle> 8CA1',
12951: '<circle> 795D',
12952: '<circle> 52B4',
12953: '<circle> 79D8',
12954: '<circle> 7537',
12955: '<circle> 5973',
12956: '<circle> 9069',
12957: '<circle> 512A',
12958: '<circle> 5370',
12959: '<circle> 6CE8',
12960: '<circle> 9805',
12961: '<circle> 4F11',
12962: '<circle> 5199',
12963: '<circle> 6B63',
12964: '<circle> 4E0A',
12965: '<circle> 4E2D',
12966: '<circle> 4E0B',
12967: '<circle> 5DE6',
12968: '<circle> 53F3',
12969: '<circle> 533B',
12970: '<circle> 5B97',
12971: '<circle> 5B66',
12972: '<circle> 76E3',
12973: '<circle> 4F01',
12974: '<circle> 8CC7',
12975: '<circle> 5354',
12976: '<circle> 591C',
12977: '<circle> 0033 0036',
12978: '<circle> 0033 0037',
12979: '<circle> 0033 0038',
12980: '<circle> 0033 0039',
12981: '<circle> 0034 0030',
12982: '<circle> 0034 0031',
12983: '<circle> 0034 0032',
12984: '<circle> 0034 0033',
12985: '<circle> 0034 0034',
12986: '<circle> 0034 0035',
12987: '<circle> 0034 0036',
12988: '<circle> 0034 0037',
12989: '<circle> 0034 0038',
12990: '<circle> 0034 0039',
12991: '<circle> 0035 0030',
12992: '<compat> 0031 6708',
12993: '<compat> 0032 6708',
12994: '<compat> 0033 6708',
12995: '<compat> 0034 6708',
12996: '<compat> 0035 6708',
12997: '<compat> 0036 6708',
12998: '<compat> 0037 6708',
12999: '<compat> 0038 6708',
13000: '<compat> 0039 6708',
13001: '<compat> 0031 0030 6708',
13002: '<compat> 0031 0031 6708',
13003: '<compat> 0031 0032 6708',
13004: '<square> 0048 0067',
13005: '<square> 0065 0072 0067',
13006: '<square> 0065 0056',
13007: '<square> 004C 0054 0044',
13008: '<circle> 30A2',
13009: '<circle> 30A4',
13010: '<circle> 30A6',
13011: '<circle> 30A8',
13012: '<circle> 30AA',
13013: '<circle> 30AB',
13014: '<circle> 30AD',
13015: '<circle> 30AF',
13016: '<circle> 30B1',
13017: '<circle> 30B3',
13018: '<circle> 30B5',
13019: '<circle> 30B7',
13020: '<circle> 30B9',
13021: '<circle> 30BB',
13022: '<circle> 30BD',
13023: '<circle> 30BF',
13024: '<circle> 30C1',
13025: '<circle> 30C4',
13026: '<circle> 30C6',
13027: '<circle> 30C8',
13028: '<circle> 30CA',
13029: '<circle> 30CB',
13030: '<circle> 30CC',
13031: '<circle> 30CD',
13032: '<circle> 30CE',
13033: '<circle> 30CF',
13034: '<circle> 30D2',
13035: '<circle> 30D5',
13036: '<circle> 30D8',
13037: '<circle> 30DB',
13038: '<circle> 30DE',
13039: '<circle> 30DF',
13040: '<circle> 30E0',
13041: '<circle> 30E1',
13042: '<circle> 30E2',
13043: '<circle> 30E4',
13044: '<circle> 30E6',
13045: '<circle> 30E8',
13046: '<circle> 30E9',
13047: '<circle> 30EA',
13048: '<circle> 30EB',
13049: '<circle> 30EC',
13050: '<circle> 30ED',
13051: '<circle> 30EF',
13052: '<circle> 30F0',
13053: '<circle> 30F1',
13054: '<circle> 30F2',
13056: '<square> 30A2 30D1 30FC 30C8',
13057: '<square> 30A2 30EB 30D5 30A1',
13058: '<square> 30A2 30F3 30DA 30A2',
13059: '<square> 30A2 30FC 30EB',
13060: '<square> 30A4 30CB 30F3 30B0',
13061: '<square> 30A4 30F3 30C1',
13062: '<square> 30A6 30A9 30F3',
13063: '<square> 30A8 30B9 30AF 30FC 30C9',
13064: '<square> 30A8 30FC 30AB 30FC',
13065: '<square> 30AA 30F3 30B9',
13066: '<square> 30AA 30FC 30E0',
13067: '<square> 30AB 30A4 30EA',
13068: '<square> 30AB 30E9 30C3 30C8',
13069: '<square> 30AB 30ED 30EA 30FC',
13070: '<square> 30AC 30ED 30F3',
13071: '<square> 30AC 30F3 30DE',
13072: '<square> 30AE 30AC',
13073: '<square> 30AE 30CB 30FC',
13074: '<square> 30AD 30E5 30EA 30FC',
13075: '<square> 30AE 30EB 30C0 30FC',
13076: '<square> 30AD 30ED',
13077: '<square> 30AD 30ED 30B0 30E9 30E0',
13078: '<square> 30AD 30ED 30E1 30FC 30C8 30EB',
13079: '<square> 30AD 30ED 30EF 30C3 30C8',
13080: '<square> 30B0 30E9 30E0',
13081: '<square> 30B0 30E9 30E0 30C8 30F3',
13082: '<square> 30AF 30EB 30BC 30A4 30ED',
13083: '<square> 30AF 30ED 30FC 30CD',
13084: '<square> 30B1 30FC 30B9',
13085: '<square> 30B3 30EB 30CA',
13086: '<square> 30B3 30FC 30DD',
13087: '<square> 30B5 30A4 30AF 30EB',
13088: '<square> 30B5 30F3 30C1 30FC 30E0',
13089: '<square> 30B7 30EA 30F3 30B0',
13090: '<square> 30BB 30F3 30C1',
13091: '<square> 30BB 30F3 30C8',
13092: '<square> 30C0 30FC 30B9',
13093: '<square> 30C7 30B7',
13094: '<square> 30C9 30EB',
13095: '<square> 30C8 30F3',
13096: '<square> 30CA 30CE',
13097: '<square> 30CE 30C3 30C8',
13098: '<square> 30CF 30A4 30C4',
13099: '<square> 30D1 30FC 30BB 30F3 30C8',
13100: '<square> 30D1 30FC 30C4',
13101: '<square> 30D0 30FC 30EC 30EB',
13102: '<square> 30D4 30A2 30B9 30C8 30EB',
13103: '<square> 30D4 30AF 30EB',
13104: '<square> 30D4 30B3',
13105: '<square> 30D3 30EB',
13106: '<square> 30D5 30A1 30E9 30C3 30C9',
13107: '<square> 30D5 30A3 30FC 30C8',
13108: '<square> 30D6 30C3 30B7 30A7 30EB',
13109: '<square> 30D5 30E9 30F3',
13110: '<square> 30D8 30AF 30BF 30FC 30EB',
13111: '<square> 30DA 30BD',
13112: '<square> 30DA 30CB 30D2',
13113: '<square> 30D8 30EB 30C4',
13114: '<square> 30DA 30F3 30B9',
13115: '<square> 30DA 30FC 30B8',
13116: '<square> 30D9 30FC 30BF',
13117: '<square> 30DD 30A4 30F3 30C8',
13118: '<square> 30DC 30EB 30C8',
13119: '<square> 30DB 30F3',
13120: '<square> 30DD 30F3 30C9',
13121: '<square> 30DB 30FC 30EB',
13122: '<square> 30DB 30FC 30F3',
13123: '<square> 30DE 30A4 30AF 30ED',
13124: '<square> 30DE 30A4 30EB',
13125: '<square> 30DE 30C3 30CF',
13126: '<square> 30DE 30EB 30AF',
13127: '<square> 30DE 30F3 30B7 30E7 30F3',
13128: '<square> 30DF 30AF 30ED 30F3',
13129: '<square> 30DF 30EA',
13130: '<square> 30DF 30EA 30D0 30FC 30EB',
13131: '<square> 30E1 30AC',
13132: '<square> 30E1 30AC 30C8 30F3',
13133: '<square> 30E1 30FC 30C8 30EB',
13134: '<square> 30E4 30FC 30C9',
13135: '<square> 30E4 30FC 30EB',
13136: '<square> 30E6 30A2 30F3',
13137: '<square> 30EA 30C3 30C8 30EB',
13138: '<square> 30EA 30E9',
13139: '<square> 30EB 30D4 30FC',
13140: '<square> 30EB 30FC 30D6 30EB',
13141: '<square> 30EC 30E0',
13142: '<square> 30EC 30F3 30C8 30B2 30F3',
13143: '<square> 30EF 30C3 30C8',
13144: '<compat> 0030 70B9',
13145: '<compat> 0031 70B9',
13146: '<compat> 0032 70B9',
13147: '<compat> 0033 70B9',
13148: '<compat> 0034 70B9',
13149: '<compat> 0035 70B9',
13150: '<compat> 0036 70B9',
13151: '<compat> 0037 70B9',
13152: '<compat> 0038 70B9',
13153: '<compat> 0039 70B9',
13154: '<compat> 0031 0030 70B9',
13155: '<compat> 0031 0031 70B9',
13156: '<compat> 0031 0032 70B9',
13157: '<compat> 0031 0033 70B9',
13158: '<compat> 0031 0034 70B9',
13159: '<compat> 0031 0035 70B9',
13160: '<compat> 0031 0036 70B9',
13161: '<compat> 0031 0037 70B9',
13162: '<compat> 0031 0038 70B9',
13163: '<compat> 0031 0039 70B9',
13164: '<compat> 0032 0030 70B9',
13165: '<compat> 0032 0031 70B9',
13166: '<compat> 0032 0032 70B9',
13167: '<compat> 0032 0033 70B9',
13168: '<compat> 0032 0034 70B9',
13169: '<square> 0068 0050 0061',
13170: '<square> 0064 0061',
13171: '<square> 0041 0055',
13172: '<square> 0062 0061 0072',
13173: '<square> 006F 0056',
13174: '<square> 0070 0063',
13175: '<square> 0064 006D',
13176: '<square> 0064 006D 00B2',
13177: '<square> 0064 006D 00B3',
13178: '<square> 0049 0055',
13179: '<square> 5E73 6210',
13180: '<square> 662D 548C',
13181: '<square> 5927 6B63',
13182: '<square> 660E 6CBB',
13183: '<square> 682A 5F0F 4F1A 793E',
13184: '<square> 0070 0041',
13185: '<square> 006E 0041',
13186: '<square> 03BC 0041',
13187: '<square> 006D 0041',
13188: '<square> 006B 0041',
13189: '<square> 004B 0042',
13190: '<square> 004D 0042',
13191: '<square> 0047 0042',
13192: '<square> 0063 0061 006C',
13193: '<square> 006B 0063 0061 006C',
13194: '<square> 0070 0046',
13195: '<square> 006E 0046',
13196: '<square> 03BC 0046',
13197: '<square> 03BC 0067',
13198: '<square> 006D 0067',
13199: '<square> 006B 0067',
13200: '<square> 0048 007A',
13201: '<square> 006B 0048 007A',
13202: '<square> 004D 0048 007A',
13203: '<square> 0047 0048 007A',
13204: '<square> 0054 0048 007A',
13205: '<square> 03BC 2113',
13206: '<square> 006D 2113',
13207: '<square> 0064 2113',
13208: '<square> 006B 2113',
13209: '<square> 0066 006D',
13210: '<square> 006E 006D',
13211: '<square> 03BC 006D',
13212: '<square> 006D 006D',
13213: '<square> 0063 006D',
13214: '<square> 006B 006D',
13215: '<square> 006D 006D 00B2',
13216: '<square> 0063 006D 00B2',
13217: '<square> 006D 00B2',
13218: '<square> 006B 006D 00B2',
13219: '<square> 006D 006D 00B3',
13220: '<square> 0063 006D 00B3',
13221: '<square> 006D 00B3',
13222: '<square> 006B 006D 00B3',
13223: '<square> 006D 2215 0073',
13224: '<square> 006D 2215 0073 00B2',
13225: '<square> 0050 0061',
13226: '<square> 006B 0050 0061',
13227: '<square> 004D 0050 0061',
13228: '<square> 0047 0050 0061',
13229: '<square> 0072 0061 0064',
13230: '<square> 0072 0061 0064 2215 0073',
13231: '<square> 0072 0061 0064 2215 0073 00B2',
13232: '<square> 0070 0073',
13233: '<square> 006E 0073',
13234: '<square> 03BC 0073',
13235: '<square> 006D 0073',
13236: '<square> 0070 0056',
13237: '<square> 006E 0056',
13238: '<square> 03BC 0056',
13239: '<square> 006D 0056',
13240: '<square> 006B 0056',
13241: '<square> 004D 0056',
13242: '<square> 0070 0057',
13243: '<square> 006E 0057',
13244: '<square> 03BC 0057',
13245: '<square> 006D 0057',
13246: '<square> 006B 0057',
13247: '<square> 004D 0057',
13248: '<square> 006B 03A9',
13249: '<square> 004D 03A9',
13250: '<square> 0061 002E 006D 002E',
13251: '<square> 0042 0071',
13252: '<square> 0063 0063',
13253: '<square> 0063 0064',
13254: '<square> 0043 2215 006B 0067',
13255: '<square> 0043 006F 002E',
13256: '<square> 0064 0042',
13257: '<square> 0047 0079',
13258: '<square> 0068 0061',
13259: '<square> 0048 0050',
13260: '<square> 0069 006E',
13261: '<square> 004B 004B',
13262: '<square> 004B 004D',
13263: '<square> 006B 0074',
13264: '<square> 006C 006D',
13265: '<square> 006C 006E',
13266: '<square> 006C 006F 0067',
13267: '<square> 006C 0078',
13268: '<square> 006D 0062',
13269: '<square> 006D 0069 006C',
13270: '<square> 006D 006F 006C',
13271: '<square> 0050 0048',
13272: '<square> 0070 002E 006D 002E',
13273: '<square> 0050 0050 004D',
13274: '<square> 0050 0052',
13275: '<square> 0073 0072',
13276: '<square> 0053 0076',
13277: '<square> 0057 0062',
13278: '<square> 0056 2215 006D',
13279: '<square> 0041 2215 006D',
13280: '<compat> 0031 65E5',
13281: '<compat> 0032 65E5',
13282: '<compat> 0033 65E5',
13283: '<compat> 0034 65E5',
13284: '<compat> 0035 65E5',
13285: '<compat> 0036 65E5',
13286: '<compat> 0037 65E5',
13287: '<compat> 0038 65E5',
13288: '<compat> 0039 65E5',
13289: '<compat> 0031 0030 65E5',
13290: '<compat> 0031 0031 65E5',
13291: '<compat> 0031 0032 65E5',
13292: '<compat> 0031 0033 65E5',
13293: '<compat> 0031 0034 65E5',
13294: '<compat> 0031 0035 65E5',
13295: '<compat> 0031 0036 65E5',
13296: '<compat> 0031 0037 65E5',
13297: '<compat> 0031 0038 65E5',
13298: '<compat> 0031 0039 65E5',
13299: '<compat> 0032 0030 65E5',
13300: '<compat> 0032 0031 65E5',
13301: '<compat> 0032 0032 65E5',
13302: '<compat> 0032 0033 65E5',
13303: '<compat> 0032 0034 65E5',
13304: '<compat> 0032 0035 65E5',
13305: '<compat> 0032 0036 65E5',
13306: '<compat> 0032 0037 65E5',
13307: '<compat> 0032 0038 65E5',
13308: '<compat> 0032 0039 65E5',
13309: '<compat> 0033 0030 65E5',
13310: '<compat> 0033 0031 65E5',
13311: '<square> 0067 0061 006C',
42864: '<super> A76F',
63744: '8C48',
63745: '66F4',
63746: '8ECA',
63747: '8CC8',
63748: '6ED1',
63749: '4E32',
63750: '53E5',
63751: '9F9C',
63752: '9F9C',
63753: '5951',
63754: '91D1',
63755: '5587',
63756: '5948',
63757: '61F6',
63758: '7669',
63759: '7F85',
63760: '863F',
63761: '87BA',
63762: '88F8',
63763: '908F',
63764: '6A02',
63765: '6D1B',
63766: '70D9',
63767: '73DE',
63768: '843D',
63769: '916A',
63770: '99F1',
63771: '4E82',
63772: '5375',
63773: '6B04',
63774: '721B',
63775: '862D',
63776: '9E1E',
63777: '5D50',
63778: '6FEB',
63779: '85CD',
63780: '8964',
63781: '62C9',
63782: '81D8',
63783: '881F',
63784: '5ECA',
63785: '6717',
63786: '6D6A',
63787: '72FC',
63788: '90CE',
63789: '4F86',
63790: '51B7',
63791: '52DE',
63792: '64C4',
63793: '6AD3',
63794: '7210',
63795: '76E7',
63796: '8001',
63797: '8606',
63798: '865C',
63799: '8DEF',
63800: '9732',
63801: '9B6F',
63802: '9DFA',
63803: '788C',
63804: '797F',
63805: '7DA0',
63806: '83C9',
63807: '9304',
63808: '9E7F',
63809: '8AD6',
63810: '58DF',
63811: '5F04',
63812: '7C60',
63813: '807E',
63814: '7262',
63815: '78CA',
63816: '8CC2',
63817: '96F7',
63818: '58D8',
63819: '5C62',
63820: '6A13',
63821: '6DDA',
63822: '6F0F',
63823: '7D2F',
63824: '7E37',
63825: '964B',
63826: '52D2',
63827: '808B',
63828: '51DC',
63829: '51CC',
63830: '7A1C',
63831: '7DBE',
63832: '83F1',
63833: '9675',
63834: '8B80',
63835: '62CF',
63836: '6A02',
63837: '8AFE',
63838: '4E39',
63839: '5BE7',
63840: '6012',
63841: '7387',
63842: '7570',
63843: '5317',
63844: '78FB',
63845: '4FBF',
63846: '5FA9',
63847: '4E0D',
63848: '6CCC',
63849: '6578',
63850: '7D22',
63851: '53C3',
63852: '585E',
63853: '7701',
63854: '8449',
63855: '8AAA',
63856: '6BBA',
63857: '8FB0',
63858: '6C88',
63859: '62FE',
63860: '82E5',
63861: '63A0',
63862: '7565',
63863: '4EAE',
63864: '5169',
63865: '51C9',
63866: '6881',
63867: '7CE7',
63868: '826F',
63869: '8AD2',
63870: '91CF',
63871: '52F5',
63872: '5442',
63873: '5973',
63874: '5EEC',
63875: '65C5',
63876: '6FFE',
63877: '792A',
63878: '95AD',
63879: '9A6A',
63880: '9E97',
63881: '9ECE',
63882: '529B',
63883: '66C6',
63884: '6B77',
63885: '8F62',
63886: '5E74',
63887: '6190',
63888: '6200',
63889: '649A',
63890: '6F23',
63891: '7149',
63892: '7489',
63893: '79CA',
63894: '7DF4',
63895: '806F',
63896: '8F26',
63897: '84EE',
63898: '9023',
63899: '934A',
63900: '5217',
63901: '52A3',
63902: '54BD',
63903: '70C8',
63904: '88C2',
63905: '8AAA',
63906: '5EC9',
63907: '5FF5',
63908: '637B',
63909: '6BAE',
63910: '7C3E',
63911: '7375',
63912: '4EE4',
63913: '56F9',
63914: '5BE7',
63915: '5DBA',
63916: '601C',
63917: '73B2',
63918: '7469',
63919: '7F9A',
63920: '8046',
63921: '9234',
63922: '96F6',
63923: '9748',
63924: '9818',
63925: '4F8B',
63926: '79AE',
63927: '91B4',
63928: '96B8',
63929: '60E1',
63930: '4E86',
63931: '50DA',
63932: '5BEE',
63933: '5C3F',
63934: '6599',
63935: '6A02',
63936: '71CE',
63937: '7642',
63938: '84FC',
63939: '907C',
63940: '9F8D',
63941: '6688',
63942: '962E',
63943: '5289',
63944: '677B',
63945: '67F3',
63946: '6D41',
63947: '6E9C',
63948: '7409',
63949: '7559',
63950: '786B',
63951: '7D10',
63952: '985E',
63953: '516D',
63954: '622E',
63955: '9678',
63956: '502B',
63957: '5D19',
63958: '6DEA',
63959: '8F2A',
63960: '5F8B',
63961: '6144',
63962: '6817',
63963: '7387',
63964: '9686',
63965: '5229',
63966: '540F',
63967: '5C65',
63968: '6613',
63969: '674E',
63970: '68A8',
63971: '6CE5',
63972: '7406',
63973: '75E2',
63974: '7F79',
63975: '88CF',
63976: '88E1',
63977: '91CC',
63978: '96E2',
63979: '533F',
63980: '6EBA',
63981: '541D',
63982: '71D0',
63983: '7498',
63984: '85FA',
63985: '96A3',
63986: '9C57',
63987: '9E9F',
63988: '6797',
63989: '6DCB',
63990: '81E8',
63991: '7ACB',
63992: '7B20',
63993: '7C92',
63994: '72C0',
63995: '7099',
63996: '8B58',
63997: '4EC0',
63998: '8336',
63999: '523A',
64000: '5207',
64001: '5EA6',
64002: '62D3',
64003: '7CD6',
64004: '5B85',
64005: '6D1E',
64006: '66B4',
64007: '8F3B',
64008: '884C',
64009: '964D',
64010: '898B',
64011: '5ED3',
64012: '5140',
64013: '55C0',
64016: '585A',
64018: '6674',
64021: '51DE',
64022: '732A',
64023: '76CA',
64024: '793C',
64025: '795E',
64026: '7965',
64027: '798F',
64028: '9756',
64029: '7CBE',
64030: '7FBD',
64032: '8612',
64034: '8AF8',
64037: '9038',
64038: '90FD',
64042: '98EF',
64043: '98FC',
64044: '9928',
64045: '9DB4',
64048: '4FAE',
64049: '50E7',
64050: '514D',
64051: '52C9',
64052: '52E4',
64053: '5351',
64054: '559D',
64055: '5606',
64056: '5668',
64057: '5840',
64058: '58A8',
64059: '5C64',
64060: '5C6E',
64061: '6094',
64062: '6168',
64063: '618E',
64064: '61F2',
64065: '654F',
64066: '65E2',
64067: '6691',
64068: '6885',
64069: '6D77',
64070: '6E1A',
64071: '6F22',
64072: '716E',
64073: '722B',
64074: '7422',
64075: '7891',
64076: '793E',
64077: '7949',
64078: '7948',
64079: '7950',
64080: '7956',
64081: '795D',
64082: '798D',
64083: '798E',
64084: '7A40',
64085: '7A81',
64086: '7BC0',
64087: '7DF4',
64088: '7E09',
64089: '7E41',
64090: '7F72',
64091: '8005',
64092: '81ED',
64093: '8279',
64094: '8279',
64095: '8457',
64096: '8910',
64097: '8996',
64098: '8B01',
64099: '8B39',
64100: '8CD3',
64101: '8D08',
64102: '8FB6',
64103: '9038',
64104: '96E3',
64105: '97FF',
64106: '983B',
64107: '6075',
64108: '242EE',
64109: '8218',
64112: '4E26',
64113: '51B5',
64114: '5168',
64115: '4F80',
64116: '5145',
64117: '5180',
64118: '52C7',
64119: '52FA',
64120: '559D',
64121: '5555',
64122: '5599',
64123: '55E2',
64124: '585A',
64125: '58B3',
64126: '5944',
64127: '5954',
64128: '5A62',
64129: '5B28',
64130: '5ED2',
64131: '5ED9',
64132: '5F69',
64133: '5FAD',
64134: '60D8',
64135: '614E',
64136: '6108',
64137: '618E',
64138: '6160',
64139: '61F2',
64140: '6234',
64141: '63C4',
64142: '641C',
64143: '6452',
64144: '6556',
64145: '6674',
64146: '6717',
64147: '671B',
64148: '6756',
64149: '6B79',
64150: '6BBA',
64151: '6D41',
64152: '6EDB',
64153: '6ECB',
64154: '6F22',
64155: '701E',
64156: '716E',
64157: '77A7',
64158: '7235',
64159: '72AF',
64160: '732A',
64161: '7471',
64162: '7506',
64163: '753B',
64164: '761D',
64165: '761F',
64166: '76CA',
64167: '76DB',
64168: '76F4',
64169: '774A',
64170: '7740',
64171: '78CC',
64172: '7AB1',
64173: '7BC0',
64174: '7C7B',
64175: '7D5B',
64176: '7DF4',
64177: '7F3E',
64178: '8005',
64179: '8352',
64180: '83EF',
64181: '8779',
64182: '8941',
64183: '8986',
64184: '8996',
64185: '8ABF',
64186: '8AF8',
64187: '8ACB',
64188: '8B01',
64189: '8AFE',
64190: '8AED',
64191: '8B39',
64192: '8B8A',
64193: '8D08',
64194: '8F38',
64195: '9072',
64196: '9199',
64197: '9276',
64198: '967C',
64199: '96E3',
64200: '9756',
64201: '97DB',
64202: '97FF',
64203: '980B',
64204: '983B',
64205: '9B12',
64206: '9F9C',
64207: '2284A',
64208: '22844',
64209: '233D5',
64210: '3B9D',
64211: '4018',
64212: '4039',
64213: '25249',
64214: '25CD0',
64215: '27ED3',
64216: '9F43',
64217: '9F8E',
64256: '<compat> 0066 0066',
64257: '<compat> 0066 0069',
64258: '<compat> 0066 006C',
64259: '<compat> 0066 0066 0069',
64260: '<compat> 0066 0066 006C',
64261: '<compat> 017F 0074',
64262: '<compat> 0073 0074',
64275: '<compat> 0574 0576',
64276: '<compat> 0574 0565',
64277: '<compat> 0574 056B',
64278: '<compat> 057E 0576',
64279: '<compat> 0574 056D',
64285: '05D9 05B4',
64287: '05F2 05B7',
64288: '<font> 05E2',
64289: '<font> 05D0',
64290: '<font> 05D3',
64291: '<font> 05D4',
64292: '<font> 05DB',
64293: '<font> 05DC',
64294: '<font> 05DD',
64295: '<font> 05E8',
64296: '<font> 05EA',
64297: '<font> 002B',
64298: '05E9 05C1',
64299: '05E9 05C2',
64300: 'FB49 05C1',
64301: 'FB49 05C2',
64302: '05D0 05B7',
64303: '05D0 05B8',
64304: '05D0 05BC',
64305: '05D1 05BC',
64306: '05D2 05BC',
64307: '05D3 05BC',
64308: '05D4 05BC',
64309: '05D5 05BC',
64310: '05D6 05BC',
64312: '05D8 05BC',
64313: '05D9 05BC',
64314: '05DA 05BC',
64315: '05DB 05BC',
64316: '05DC 05BC',
64318: '05DE 05BC',
64320: '05E0 05BC',
64321: '05E1 05BC',
64323: '05E3 05BC',
64324: '05E4 05BC',
64326: '05E6 05BC',
64327: '05E7 05BC',
64328: '05E8 05BC',
64329: '05E9 05BC',
64330: '05EA 05BC',
64331: '05D5 05B9',
64332: '05D1 05BF',
64333: '05DB 05BF',
64334: '05E4 05BF',
64335: '<compat> 05D0 05DC',
64336: '<isolated> 0671',
64337: '<final> 0671',
64338: '<isolated> 067B',
64339: '<final> 067B',
64340: '<initial> 067B',
64341: '<medial> 067B',
64342: '<isolated> 067E',
64343: '<final> 067E',
64344: '<initial> 067E',
64345: '<medial> 067E',
64346: '<isolated> 0680',
64347: '<final> 0680',
64348: '<initial> 0680',
64349: '<medial> 0680',
64350: '<isolated> 067A',
64351: '<final> 067A',
64352: '<initial> 067A',
64353: '<medial> 067A',
64354: '<isolated> 067F',
64355: '<final> 067F',
64356: '<initial> 067F',
64357: '<medial> 067F',
64358: '<isolated> 0679',
64359: '<final> 0679',
64360: '<initial> 0679',
64361: '<medial> 0679',
64362: '<isolated> 06A4',
64363: '<final> 06A4',
64364: '<initial> 06A4',
64365: '<medial> 06A4',
64366: '<isolated> 06A6',
64367: '<final> 06A6',
64368: '<initial> 06A6',
64369: '<medial> 06A6',
64370: '<isolated> 0684',
64371: '<final> 0684',
64372: '<initial> 0684',
64373: '<medial> 0684',
64374: '<isolated> 0683',
64375: '<final> 0683',
64376: '<initial> 0683',
64377: '<medial> 0683',
64378: '<isolated> 0686',
64379: '<final> 0686',
64380: '<initial> 0686',
64381: '<medial> 0686',
64382: '<isolated> 0687',
64383: '<final> 0687',
64384: '<initial> 0687',
64385: '<medial> 0687',
64386: '<isolated> 068D',
64387: '<final> 068D',
64388: '<isolated> 068C',
64389: '<final> 068C',
64390: '<isolated> 068E',
64391: '<final> 068E',
64392: '<isolated> 0688',
64393: '<final> 0688',
64394: '<isolated> 0698',
64395: '<final> 0698',
64396: '<isolated> 0691',
64397: '<final> 0691',
64398: '<isolated> 06A9',
64399: '<final> 06A9',
64400: '<initial> 06A9',
64401: '<medial> 06A9',
64402: '<isolated> 06AF',
64403: '<final> 06AF',
64404: '<initial> 06AF',
64405: '<medial> 06AF',
64406: '<isolated> 06B3',
64407: '<final> 06B3',
64408: '<initial> 06B3',
64409: '<medial> 06B3',
64410: '<isolated> 06B1',
64411: '<final> 06B1',
64412: '<initial> 06B1',
64413: '<medial> 06B1',
64414: '<isolated> 06BA',
64415: '<final> 06BA',
64416: '<isolated> 06BB',
64417: '<final> 06BB',
64418: '<initial> 06BB',
64419: '<medial> 06BB',
64420: '<isolated> 06C0',
64421: '<final> 06C0',
64422: '<isolated> 06C1',
64423: '<final> 06C1',
64424: '<initial> 06C1',
64425: '<medial> 06C1',
64426: '<isolated> 06BE',
64427: '<final> 06BE',
64428: '<initial> 06BE',
64429: '<medial> 06BE',
64430: '<isolated> 06D2',
64431: '<final> 06D2',
64432: '<isolated> 06D3',
64433: '<final> 06D3',
64467: '<isolated> 06AD',
64468: '<final> 06AD',
64469: '<initial> 06AD',
64470: '<medial> 06AD',
64471: '<isolated> 06C7',
64472: '<final> 06C7',
64473: '<isolated> 06C6',
64474: '<final> 06C6',
64475: '<isolated> 06C8',
64476: '<final> 06C8',
64477: '<isolated> 0677',
64478: '<isolated> 06CB',
64479: '<final> 06CB',
64480: '<isolated> 06C5',
64481: '<final> 06C5',
64482: '<isolated> 06C9',
64483: '<final> 06C9',
64484: '<isolated> 06D0',
64485: '<final> 06D0',
64486: '<initial> 06D0',
64487: '<medial> 06D0',
64488: '<initial> 0649',
64489: '<medial> 0649',
64490: '<isolated> 0626 0627',
64491: '<final> 0626 0627',
64492: '<isolated> 0626 06D5',
64493: '<final> 0626 06D5',
64494: '<isolated> 0626 0648',
64495: '<final> 0626 0648',
64496: '<isolated> 0626 06C7',
64497: '<final> 0626 06C7',
64498: '<isolated> 0626 06C6',
64499: '<final> 0626 06C6',
64500: '<isolated> 0626 06C8',
64501: '<final> 0626 06C8',
64502: '<isolated> 0626 06D0',
64503: '<final> 0626 06D0',
64504: '<initial> 0626 06D0',
64505: '<isolated> 0626 0649',
64506: '<final> 0626 0649',
64507: '<initial> 0626 0649',
64508: '<isolated> 06CC',
64509: '<final> 06CC',
64510: '<initial> 06CC',
64511: '<medial> 06CC',
64512: '<isolated> 0626 062C',
64513: '<isolated> 0626 062D',
64514: '<isolated> 0626 0645',
64515: '<isolated> 0626 0649',
64516: '<isolated> 0626 064A',
64517: '<isolated> 0628 062C',
64518: '<isolated> 0628 062D',
64519: '<isolated> 0628 062E',
64520: '<isolated> 0628 0645',
64521: '<isolated> 0628 0649',
64522: '<isolated> 0628 064A',
64523: '<isolated> 062A 062C',
64524: '<isolated> 062A 062D',
64525: '<isolated> 062A 062E',
64526: '<isolated> 062A 0645',
64527: '<isolated> 062A 0649',
64528: '<isolated> 062A 064A',
64529: '<isolated> 062B 062C',
64530: '<isolated> 062B 0645',
64531: '<isolated> 062B 0649',
64532: '<isolated> 062B 064A',
64533: '<isolated> 062C 062D',
64534: '<isolated> 062C 0645',
64535: '<isolated> 062D 062C',
64536: '<isolated> 062D 0645',
64537: '<isolated> 062E 062C',
64538: '<isolated> 062E 062D',
64539: '<isolated> 062E 0645',
64540: '<isolated> 0633 062C',
64541: '<isolated> 0633 062D',
64542: '<isolated> 0633 062E',
64543: '<isolated> 0633 0645',
64544: '<isolated> 0635 062D',
64545: '<isolated> 0635 0645',
64546: '<isolated> 0636 062C',
64547: '<isolated> 0636 062D',
64548: '<isolated> 0636 062E',
64549: '<isolated> 0636 0645',
64550: '<isolated> 0637 062D',
64551: '<isolated> 0637 0645',
64552: '<isolated> 0638 0645',
64553: '<isolated> 0639 062C',
64554: '<isolated> 0639 0645',
64555: '<isolated> 063A 062C',
64556: '<isolated> 063A 0645',
64557: '<isolated> 0641 062C',
64558: '<isolated> 0641 062D',
64559: '<isolated> 0641 062E',
64560: '<isolated> 0641 0645',
64561: '<isolated> 0641 0649',
64562: '<isolated> 0641 064A',
64563: '<isolated> 0642 062D',
64564: '<isolated> 0642 0645',
64565: '<isolated> 0642 0649',
64566: '<isolated> 0642 064A',
64567: '<isolated> 0643 0627',
64568: '<isolated> 0643 062C',
64569: '<isolated> 0643 062D',
64570: '<isolated> 0643 062E',
64571: '<isolated> 0643 0644',
64572: '<isolated> 0643 0645',
64573: '<isolated> 0643 0649',
64574: '<isolated> 0643 064A',
64575: '<isolated> 0644 062C',
64576: '<isolated> 0644 062D',
64577: '<isolated> 0644 062E',
64578: '<isolated> 0644 0645',
64579: '<isolated> 0644 0649',
64580: '<isolated> 0644 064A',
64581: '<isolated> 0645 062C',
64582: '<isolated> 0645 062D',
64583: '<isolated> 0645 062E',
64584: '<isolated> 0645 0645',
64585: '<isolated> 0645 0649',
64586: '<isolated> 0645 064A',
64587: '<isolated> 0646 062C',
64588: '<isolated> 0646 062D',
64589: '<isolated> 0646 062E',
64590: '<isolated> 0646 0645',
64591: '<isolated> 0646 0649',
64592: '<isolated> 0646 064A',
64593: '<isolated> 0647 062C',
64594: '<isolated> 0647 0645',
64595: '<isolated> 0647 0649',
64596: '<isolated> 0647 064A',
64597: '<isolated> 064A 062C',
64598: '<isolated> 064A 062D',
64599: '<isolated> 064A 062E',
64600: '<isolated> 064A 0645',
64601: '<isolated> 064A 0649',
64602: '<isolated> 064A 064A',
64603: '<isolated> 0630 0670',
64604: '<isolated> 0631 0670',
64605: '<isolated> 0649 0670',
64606: '<isolated> 0020 064C 0651',
64607: '<isolated> 0020 064D 0651',
64608: '<isolated> 0020 064E 0651',
64609: '<isolated> 0020 064F 0651',
64610: '<isolated> 0020 0650 0651',
64611: '<isolated> 0020 0651 0670',
64612: '<final> 0626 0631',
64613: '<final> 0626 0632',
64614: '<final> 0626 0645',
64615: '<final> 0626 0646',
64616: '<final> 0626 0649',
64617: '<final> 0626 064A',
64618: '<final> 0628 0631',
64619: '<final> 0628 0632',
64620: '<final> 0628 0645',
64621: '<final> 0628 0646',
64622: '<final> 0628 0649',
64623: '<final> 0628 064A',
64624: '<final> 062A 0631',
64625: '<final> 062A 0632',
64626: '<final> 062A 0645',
64627: '<final> 062A 0646',
64628: '<final> 062A 0649',
64629: '<final> 062A 064A',
64630: '<final> 062B 0631',
64631: '<final> 062B 0632',
64632: '<final> 062B 0645',
64633: '<final> 062B 0646',
64634: '<final> 062B 0649',
64635: '<final> 062B 064A',
64636: '<final> 0641 0649',
64637: '<final> 0641 064A',
64638: '<final> 0642 0649',
64639: '<final> 0642 064A',
64640: '<final> 0643 0627',
64641: '<final> 0643 0644',
64642: '<final> 0643 0645',
64643: '<final> 0643 0649',
64644: '<final> 0643 064A',
64645: '<final> 0644 0645',
64646: '<final> 0644 0649',
64647: '<final> 0644 064A',
64648: '<final> 0645 0627',
64649: '<final> 0645 0645',
64650: '<final> 0646 0631',
64651: '<final> 0646 0632',
64652: '<final> 0646 0645',
64653: '<final> 0646 0646',
64654: '<final> 0646 0649',
64655: '<final> 0646 064A',
64656: '<final> 0649 0670',
64657: '<final> 064A 0631',
64658: '<final> 064A 0632',
64659: '<final> 064A 0645',
64660: '<final> 064A 0646',
64661: '<final> 064A 0649',
64662: '<final> 064A 064A',
64663: '<initial> 0626 062C',
64664: '<initial> 0626 062D',
64665: '<initial> 0626 062E',
64666: '<initial> 0626 0645',
64667: '<initial> 0626 0647',
64668: '<initial> 0628 062C',
64669: '<initial> 0628 062D',
64670: '<initial> 0628 062E',
64671: '<initial> 0628 0645',
64672: '<initial> 0628 0647',
64673: '<initial> 062A 062C',
64674: '<initial> 062A 062D',
64675: '<initial> 062A 062E',
64676: '<initial> 062A 0645',
64677: '<initial> 062A 0647',
64678: '<initial> 062B 0645',
64679: '<initial> 062C 062D',
64680: '<initial> 062C 0645',
64681: '<initial> 062D 062C',
64682: '<initial> 062D 0645',
64683: '<initial> 062E 062C',
64684: '<initial> 062E 0645',
64685: '<initial> 0633 062C',
64686: '<initial> 0633 062D',
64687: '<initial> 0633 062E',
64688: '<initial> 0633 0645',
64689: '<initial> 0635 062D',
64690: '<initial> 0635 062E',
64691: '<initial> 0635 0645',
64692: '<initial> 0636 062C',
64693: '<initial> 0636 062D',
64694: '<initial> 0636 062E',
64695: '<initial> 0636 0645',
64696: '<initial> 0637 062D',
64697: '<initial> 0638 0645',
64698: '<initial> 0639 062C',
64699: '<initial> 0639 0645',
64700: '<initial> 063A 062C',
64701: '<initial> 063A 0645',
64702: '<initial> 0641 062C',
64703: '<initial> 0641 062D',
64704: '<initial> 0641 062E',
64705: '<initial> 0641 0645',
64706: '<initial> 0642 062D',
64707: '<initial> 0642 0645',
64708: '<initial> 0643 062C',
64709: '<initial> 0643 062D',
64710: '<initial> 0643 062E',
64711: '<initial> 0643 0644',
64712: '<initial> 0643 0645',
64713: '<initial> 0644 062C',
64714: '<initial> 0644 062D',
64715: '<initial> 0644 062E',
64716: '<initial> 0644 0645',
64717: '<initial> 0644 0647',
64718: '<initial> 0645 062C',
64719: '<initial> 0645 062D',
64720: '<initial> 0645 062E',
64721: '<initial> 0645 0645',
64722: '<initial> 0646 062C',
64723: '<initial> 0646 062D',
64724: '<initial> 0646 062E',
64725: '<initial> 0646 0645',
64726: '<initial> 0646 0647',
64727: '<initial> 0647 062C',
64728: '<initial> 0647 0645',
64729: '<initial> 0647 0670',
64730: '<initial> 064A 062C',
64731: '<initial> 064A 062D',
64732: '<initial> 064A 062E',
64733: '<initial> 064A 0645',
64734: '<initial> 064A 0647',
64735: '<medial> 0626 0645',
64736: '<medial> 0626 0647',
64737: '<medial> 0628 0645',
64738: '<medial> 0628 0647',
64739: '<medial> 062A 0645',
64740: '<medial> 062A 0647',
64741: '<medial> 062B 0645',
64742: '<medial> 062B 0647',
64743: '<medial> 0633 0645',
64744: '<medial> 0633 0647',
64745: '<medial> 0634 0645',
64746: '<medial> 0634 0647',
64747: '<medial> 0643 0644',
64748: '<medial> 0643 0645',
64749: '<medial> 0644 0645',
64750: '<medial> 0646 0645',
64751: '<medial> 0646 0647',
64752: '<medial> 064A 0645',
64753: '<medial> 064A 0647',
64754: '<medial> 0640 064E 0651',
64755: '<medial> 0640 064F 0651',
64756: '<medial> 0640 0650 0651',
64757: '<isolated> 0637 0649',
64758: '<isolated> 0637 064A',
64759: '<isolated> 0639 0649',
64760: '<isolated> 0639 064A',
64761: '<isolated> 063A 0649',
64762: '<isolated> 063A 064A',
64763: '<isolated> 0633 0649',
64764: '<isolated> 0633 064A',
64765: '<isolated> 0634 0649',
64766: '<isolated> 0634 064A',
64767: '<isolated> 062D 0649',
64768: '<isolated> 062D 064A',
64769: '<isolated> 062C 0649',
64770: '<isolated> 062C 064A',
64771: '<isolated> 062E 0649',
64772: '<isolated> 062E 064A',
64773: '<isolated> 0635 0649',
64774: '<isolated> 0635 064A',
64775: '<isolated> 0636 0649',
64776: '<isolated> 0636 064A',
64777: '<isolated> 0634 062C',
64778: '<isolated> 0634 062D',
64779: '<isolated> 0634 062E',
64780: '<isolated> 0634 0645',
64781: '<isolated> 0634 0631',
64782: '<isolated> 0633 0631',
64783: '<isolated> 0635 0631',
64784: '<isolated> 0636 0631',
64785: '<final> 0637 0649',
64786: '<final> 0637 064A',
64787: '<final> 0639 0649',
64788: '<final> 0639 064A',
64789: '<final> 063A 0649',
64790: '<final> 063A 064A',
64791: '<final> 0633 0649',
64792: '<final> 0633 064A',
64793: '<final> 0634 0649',
64794: '<final> 0634 064A',
64795: '<final> 062D 0649',
64796: '<final> 062D 064A',
64797: '<final> 062C 0649',
64798: '<final> 062C 064A',
64799: '<final> 062E 0649',
64800: '<final> 062E 064A',
64801: '<final> 0635 0649',
64802: '<final> 0635 064A',
64803: '<final> 0636 0649',
64804: '<final> 0636 064A',
64805: '<final> 0634 062C',
64806: '<final> 0634 062D',
64807: '<final> 0634 062E',
64808: '<final> 0634 0645',
64809: '<final> 0634 0631',
64810: '<final> 0633 0631',
64811: '<final> 0635 0631',
64812: '<final> 0636 0631',
64813: '<initial> 0634 062C',
64814: '<initial> 0634 062D',
64815: '<initial> 0634 062E',
64816: '<initial> 0634 0645',
64817: '<initial> 0633 0647',
64818: '<initial> 0634 0647',
64819: '<initial> 0637 0645',
64820: '<medial> 0633 062C',
64821: '<medial> 0633 062D',
64822: '<medial> 0633 062E',
64823: '<medial> 0634 062C',
64824: '<medial> 0634 062D',
64825: '<medial> 0634 062E',
64826: '<medial> 0637 0645',
64827: '<medial> 0638 0645',
64828: '<final> 0627 064B',
64829: '<isolated> 0627 064B',
64848: '<initial> 062A 062C 0645',
64849: '<final> 062A 062D 062C',
64850: '<initial> 062A 062D 062C',
64851: '<initial> 062A 062D 0645',
64852: '<initial> 062A 062E 0645',
64853: '<initial> 062A 0645 062C',
64854: '<initial> 062A 0645 062D',
64855: '<initial> 062A 0645 062E',
64856: '<final> 062C 0645 062D',
64857: '<initial> 062C 0645 062D',
64858: '<final> 062D 0645 064A',
64859: '<final> 062D 0645 0649',
64860: '<initial> 0633 062D 062C',
64861: '<initial> 0633 062C 062D',
64862: '<final> 0633 062C 0649',
64863: '<final> 0633 0645 062D',
64864: '<initial> 0633 0645 062D',
64865: '<initial> 0633 0645 062C',
64866: '<final> 0633 0645 0645',
64867: '<initial> 0633 0645 0645',
64868: '<final> 0635 062D 062D',
64869: '<initial> 0635 062D 062D',
64870: '<final> 0635 0645 0645',
64871: '<final> 0634 062D 0645',
64872: '<initial> 0634 062D 0645',
64873: '<final> 0634 062C 064A',
64874: '<final> 0634 0645 062E',
64875: '<initial> 0634 0645 062E',
64876: '<final> 0634 0645 0645',
64877: '<initial> 0634 0645 0645',
64878: '<final> 0636 062D 0649',
64879: '<final> 0636 062E 0645',
64880: '<initial> 0636 062E 0645',
64881: '<final> 0637 0645 062D',
64882: '<initial> 0637 0645 062D',
64883: '<initial> 0637 0645 0645',
64884: '<final> 0637 0645 064A',
64885: '<final> 0639 062C 0645',
64886: '<final> 0639 0645 0645',
64887: '<initial> 0639 0645 0645',
64888: '<final> 0639 0645 0649',
64889: '<final> 063A 0645 0645',
64890: '<final> 063A 0645 064A',
64891: '<final> 063A 0645 0649',
64892: '<final> 0641 062E 0645',
64893: '<initial> 0641 062E 0645',
64894: '<final> 0642 0645 062D',
64895: '<final> 0642 0645 0645',
64896: '<final> 0644 062D 0645',
64897: '<final> 0644 062D 064A',
64898: '<final> 0644 062D 0649',
64899: '<initial> 0644 062C 062C',
64900: '<final> 0644 062C 062C',
64901: '<final> 0644 062E 0645',
64902: '<initial> 0644 062E 0645',
64903: '<final> 0644 0645 062D',
64904: '<initial> 0644 0645 062D',
64905: '<initial> 0645 062D 062C',
64906: '<initial> 0645 062D 0645',
64907: '<final> 0645 062D 064A',
64908: '<initial> 0645 062C 062D',
64909: '<initial> 0645 062C 0645',
64910: '<initial> 0645 062E 062C',
64911: '<initial> 0645 062E 0645',
64914: '<initial> 0645 062C 062E',
64915: '<initial> 0647 0645 062C',
64916: '<initial> 0647 0645 0645',
64917: '<initial> 0646 062D 0645',
64918: '<final> 0646 062D 0649',
64919: '<final> 0646 062C 0645',
64920: '<initial> 0646 062C 0645',
64921: '<final> 0646 062C 0649',
64922: '<final> 0646 0645 064A',
64923: '<final> 0646 0645 0649',
64924: '<final> 064A 0645 0645',
64925: '<initial> 064A 0645 0645',
64926: '<final> 0628 062E 064A',
64927: '<final> 062A 062C 064A',
64928: '<final> 062A 062C 0649',
64929: '<final> 062A 062E 064A',
64930: '<final> 062A 062E 0649',
64931: '<final> 062A 0645 064A',
64932: '<final> 062A 0645 0649',
64933: '<final> 062C 0645 064A',
64934: '<final> 062C 062D 0649',
64935: '<final> 062C 0645 0649',
64936: '<final> 0633 062E 0649',
64937: '<final> 0635 062D 064A',
64938: '<final> 0634 062D 064A',
64939: '<final> 0636 062D 064A',
64940: '<final> 0644 062C 064A',
64941: '<final> 0644 0645 064A',
64942: '<final> 064A 062D 064A',
64943: '<final> 064A 062C 064A',
64944: '<final> 064A 0645 064A',
64945: '<final> 0645 0645 064A',
64946: '<final> 0642 0645 064A',
64947: '<final> 0646 062D 064A',
64948: '<initial> 0642 0645 062D',
64949: '<initial> 0644 062D 0645',
64950: '<final> 0639 0645 064A',
64951: '<final> 0643 0645 064A',
64952: '<initial> 0646 062C 062D',
64953: '<final> 0645 062E 064A',
64954: '<initial> 0644 062C 0645',
64955: '<final> 0643 0645 0645',
64956: '<final> 0644 062C 0645',
64957: '<final> 0646 062C 062D',
64958: '<final> 062C 062D 064A',
64959: '<final> 062D 062C 064A',
64960: '<final> 0645 062C 064A',
64961: '<final> 0641 0645 064A',
64962: '<final> 0628 062D 064A',
64963: '<initial> 0643 0645 0645',
64964: '<initial> 0639 062C 0645',
64965: '<initial> 0635 0645 0645',
64966: '<final> 0633 062E 064A',
64967: '<final> 0646 062C 064A',
65008: '<isolated> 0635 0644 06D2',
65009: '<isolated> 0642 0644 06D2',
65010: '<isolated> 0627 0644 0644 0647',
65011: '<isolated> 0627 0643 0628 0631',
65012: '<isolated> 0645 062D 0645 062F',
65013: '<isolated> 0635 0644 0639 0645',
65014: '<isolated> 0631 0633 0648 0644',
65015: '<isolated> 0639 0644 064A 0647',
65016: '<isolated> 0648 0633 0644 0645',
65017: '<isolated> 0635 0644 0649',
65018: '<isolated> 0635 0644 0649 0020 0627 0644 0644 0647 0020 0639 0644 064A 0647 0020 0648 0633 0644 0645',
65019: '<isolated> 062C 0644 0020 062C 0644 0627 0644 0647',
65020: '<isolated> 0631 06CC 0627 0644',
65040: '<vertical> 002C',
65041: '<vertical> 3001',
65042: '<vertical> 3002',
65043: '<vertical> 003A',
65044: '<vertical> 003B',
65045: '<vertical> 0021',
65046: '<vertical> 003F',
65047: '<vertical> 3016',
65048: '<vertical> 3017',
65049: '<vertical> 2026',
65072: '<vertical> 2025',
65073: '<vertical> 2014',
65074: '<vertical> 2013',
65075: '<vertical> 005F',
65076: '<vertical> 005F',
65077: '<vertical> 0028',
65078: '<vertical> 0029',
65079: '<vertical> 007B',
65080: '<vertical> 007D',
65081: '<vertical> 3014',
65082: '<vertical> 3015',
65083: '<vertical> 3010',
65084: '<vertical> 3011',
65085: '<vertical> 300A',
65086: '<vertical> 300B',
65087: '<vertical> 3008',
65088: '<vertical> 3009',
65089: '<vertical> 300C',
65090: '<vertical> 300D',
65091: '<vertical> 300E',
65092: '<vertical> 300F',
65095: '<vertical> 005B',
65096: '<vertical> 005D',
65097: '<compat> 203E',
65098: '<compat> 203E',
65099: '<compat> 203E',
65100: '<compat> 203E',
65101: '<compat> 005F',
65102: '<compat> 005F',
65103: '<compat> 005F',
65104: '<small> 002C',
65105: '<small> 3001',
65106: '<small> 002E',
65108: '<small> 003B',
65109: '<small> 003A',
65110: '<small> 003F',
65111: '<small> 0021',
65112: '<small> 2014',
65113: '<small> 0028',
65114: '<small> 0029',
65115: '<small> 007B',
65116: '<small> 007D',
65117: '<small> 3014',
65118: '<small> 3015',
65119: '<small> 0023',
65120: '<small> 0026',
65121: '<small> 002A',
65122: '<small> 002B',
65123: '<small> 002D',
65124: '<small> 003C',
65125: '<small> 003E',
65126: '<small> 003D',
65128: '<small> 005C',
65129: '<small> 0024',
65130: '<small> 0025',
65131: '<small> 0040',
65136: '<isolated> 0020 064B',
65137: '<medial> 0640 064B',
65138: '<isolated> 0020 064C',
65140: '<isolated> 0020 064D',
65142: '<isolated> 0020 064E',
65143: '<medial> 0640 064E',
65144: '<isolated> 0020 064F',
65145: '<medial> 0640 064F',
65146: '<isolated> 0020 0650',
65147: '<medial> 0640 0650',
65148: '<isolated> 0020 0651',
65149: '<medial> 0640 0651',
65150: '<isolated> 0020 0652',
65151: '<medial> 0640 0652',
65152: '<isolated> 0621',
65153: '<isolated> 0622',
65154: '<final> 0622',
65155: '<isolated> 0623',
65156: '<final> 0623',
65157: '<isolated> 0624',
65158: '<final> 0624',
65159: '<isolated> 0625',
65160: '<final> 0625',
65161: '<isolated> 0626',
65162: '<final> 0626',
65163: '<initial> 0626',
65164: '<medial> 0626',
65165: '<isolated> 0627',
65166: '<final> 0627',
65167: '<isolated> 0628',
65168: '<final> 0628',
65169: '<initial> 0628',
65170: '<medial> 0628',
65171: '<isolated> 0629',
65172: '<final> 0629',
65173: '<isolated> 062A',
65174: '<final> 062A',
65175: '<initial> 062A',
65176: '<medial> 062A',
65177: '<isolated> 062B',
65178: '<final> 062B',
65179: '<initial> 062B',
65180: '<medial> 062B',
65181: '<isolated> 062C',
65182: '<final> 062C',
65183: '<initial> 062C',
65184: '<medial> 062C',
65185: '<isolated> 062D',
65186: '<final> 062D',
65187: '<initial> 062D',
65188: '<medial> 062D',
65189: '<isolated> 062E',
65190: '<final> 062E',
65191: '<initial> 062E',
65192: '<medial> 062E',
65193: '<isolated> 062F',
65194: '<final> 062F',
65195: '<isolated> 0630',
65196: '<final> 0630',
65197: '<isolated> 0631',
65198: '<final> 0631',
65199: '<isolated> 0632',
65200: '<final> 0632',
65201: '<isolated> 0633',
65202: '<final> 0633',
65203: '<initial> 0633',
65204: '<medial> 0633',
65205: '<isolated> 0634',
65206: '<final> 0634',
65207: '<initial> 0634',
65208: '<medial> 0634',
65209: '<isolated> 0635',
65210: '<final> 0635',
65211: '<initial> 0635',
65212: '<medial> 0635',
65213: '<isolated> 0636',
65214: '<final> 0636',
65215: '<initial> 0636',
65216: '<medial> 0636',
65217: '<isolated> 0637',
65218: '<final> 0637',
65219: '<initial> 0637',
65220: '<medial> 0637',
65221: '<isolated> 0638',
65222: '<final> 0638',
65223: '<initial> 0638',
65224: '<medial> 0638',
65225: '<isolated> 0639',
65226: '<final> 0639',
65227: '<initial> 0639',
65228: '<medial> 0639',
65229: '<isolated> 063A',
65230: '<final> 063A',
65231: '<initial> 063A',
65232: '<medial> 063A',
65233: '<isolated> 0641',
65234: '<final> 0641',
65235: '<initial> 0641',
65236: '<medial> 0641',
65237: '<isolated> 0642',
65238: '<final> 0642',
65239: '<initial> 0642',
65240: '<medial> 0642',
65241: '<isolated> 0643',
65242: '<final> 0643',
65243: '<initial> 0643',
65244: '<medial> 0643',
65245: '<isolated> 0644',
65246: '<final> 0644',
65247: '<initial> 0644',
65248: '<medial> 0644',
65249: '<isolated> 0645',
65250: '<final> 0645',
65251: '<initial> 0645',
65252: '<medial> 0645',
65253: '<isolated> 0646',
65254: '<final> 0646',
65255: '<initial> 0646',
65256: '<medial> 0646',
65257: '<isolated> 0647',
65258: '<final> 0647',
65259: '<initial> 0647',
65260: '<medial> 0647',
65261: '<isolated> 0648',
65262: '<final> 0648',
65263: '<isolated> 0649',
65264: '<final> 0649',
65265: '<isolated> 064A',
65266: '<final> 064A',
65267: '<initial> 064A',
65268: '<medial> 064A',
65269: '<isolated> 0644 0622',
65270: '<final> 0644 0622',
65271: '<isolated> 0644 0623',
65272: '<final> 0644 0623',
65273: '<isolated> 0644 0625',
65274: '<final> 0644 0625',
65275: '<isolated> 0644 0627',
65276: '<final> 0644 0627',
65281: '<wide> 0021',
65282: '<wide> 0022',
65283: '<wide> 0023',
65284: '<wide> 0024',
65285: '<wide> 0025',
65286: '<wide> 0026',
65287: '<wide> 0027',
65288: '<wide> 0028',
65289: '<wide> 0029',
65290: '<wide> 002A',
65291: '<wide> 002B',
65292: '<wide> 002C',
65293: '<wide> 002D',
65294: '<wide> 002E',
65295: '<wide> 002F',
65296: '<wide> 0030',
65297: '<wide> 0031',
65298: '<wide> 0032',
65299: '<wide> 0033',
65300: '<wide> 0034',
65301: '<wide> 0035',
65302: '<wide> 0036',
65303: '<wide> 0037',
65304: '<wide> 0038',
65305: '<wide> 0039',
65306: '<wide> 003A',
65307: '<wide> 003B',
65308: '<wide> 003C',
65309: '<wide> 003D',
65310: '<wide> 003E',
65311: '<wide> 003F',
65312: '<wide> 0040',
65313: '<wide> 0041',
65314: '<wide> 0042',
65315: '<wide> 0043',
65316: '<wide> 0044',
65317: '<wide> 0045',
65318: '<wide> 0046',
65319: '<wide> 0047',
65320: '<wide> 0048',
65321: '<wide> 0049',
65322: '<wide> 004A',
65323: '<wide> 004B',
65324: '<wide> 004C',
65325: '<wide> 004D',
65326: '<wide> 004E',
65327: '<wide> 004F',
65328: '<wide> 0050',
65329: '<wide> 0051',
65330: '<wide> 0052',
65331: '<wide> 0053',
65332: '<wide> 0054',
65333: '<wide> 0055',
65334: '<wide> 0056',
65335: '<wide> 0057',
65336: '<wide> 0058',
65337: '<wide> 0059',
65338: '<wide> 005A',
65339: '<wide> 005B',
65340: '<wide> 005C',
65341: '<wide> 005D',
65342: '<wide> 005E',
65343: '<wide> 005F',
65344: '<wide> 0060',
65345: '<wide> 0061',
65346: '<wide> 0062',
65347: '<wide> 0063',
65348: '<wide> 0064',
65349: '<wide> 0065',
65350: '<wide> 0066',
65351: '<wide> 0067',
65352: '<wide> 0068',
65353: '<wide> 0069',
65354: '<wide> 006A',
65355: '<wide> 006B',
65356: '<wide> 006C',
65357: '<wide> 006D',
65358: '<wide> 006E',
65359: '<wide> 006F',
65360: '<wide> 0070',
65361: '<wide> 0071',
65362: '<wide> 0072',
65363: '<wide> 0073',
65364: '<wide> 0074',
65365: '<wide> 0075',
65366: '<wide> 0076',
65367: '<wide> 0077',
65368: '<wide> 0078',
65369: '<wide> 0079',
65370: '<wide> 007A',
65371: '<wide> 007B',
65372: '<wide> 007C',
65373: '<wide> 007D',
65374: '<wide> 007E',
65375: '<wide> 2985',
65376: '<wide> 2986',
65377: '<narrow> 3002',
65378: '<narrow> 300C',
65379: '<narrow> 300D',
65380: '<narrow> 3001',
65381: '<narrow> 30FB',
65382: '<narrow> 30F2',
65383: '<narrow> 30A1',
65384: '<narrow> 30A3',
65385: '<narrow> 30A5',
65386: '<narrow> 30A7',
65387: '<narrow> 30A9',
65388: '<narrow> 30E3',
65389: '<narrow> 30E5',
65390: '<narrow> 30E7',
65391: '<narrow> 30C3',
65392: '<narrow> 30FC',
65393: '<narrow> 30A2',
65394: '<narrow> 30A4',
65395: '<narrow> 30A6',
65396: '<narrow> 30A8',
65397: '<narrow> 30AA',
65398: '<narrow> 30AB',
65399: '<narrow> 30AD',
65400: '<narrow> 30AF',
65401: '<narrow> 30B1',
65402: '<narrow> 30B3',
65403: '<narrow> 30B5',
65404: '<narrow> 30B7',
65405: '<narrow> 30B9',
65406: '<narrow> 30BB',
65407: '<narrow> 30BD',
65408: '<narrow> 30BF',
65409: '<narrow> 30C1',
65410: '<narrow> 30C4',
65411: '<narrow> 30C6',
65412: '<narrow> 30C8',
65413: '<narrow> 30CA',
65414: '<narrow> 30CB',
65415: '<narrow> 30CC',
65416: '<narrow> 30CD',
65417: '<narrow> 30CE',
65418: '<narrow> 30CF',
65419: '<narrow> 30D2',
65420: '<narrow> 30D5',
65421: '<narrow> 30D8',
65422: '<narrow> 30DB',
65423: '<narrow> 30DE',
65424: '<narrow> 30DF',
65425: '<narrow> 30E0',
65426: '<narrow> 30E1',
65427: '<narrow> 30E2',
65428: '<narrow> 30E4',
65429: '<narrow> 30E6',
65430: '<narrow> 30E8',
65431: '<narrow> 30E9',
65432: '<narrow> 30EA',
65433: '<narrow> 30EB',
65434: '<narrow> 30EC',
65435: '<narrow> 30ED',
65436: '<narrow> 30EF',
65437: '<narrow> 30F3',
65438: '<narrow> 3099',
65439: '<narrow> 309A',
65440: '<narrow> 3164',
65441: '<narrow> 3131',
65442: '<narrow> 3132',
65443: '<narrow> 3133',
65444: '<narrow> 3134',
65445: '<narrow> 3135',
65446: '<narrow> 3136',
65447: '<narrow> 3137',
65448: '<narrow> 3138',
65449: '<narrow> 3139',
65450: '<narrow> 313A',
65451: '<narrow> 313B',
65452: '<narrow> 313C',
65453: '<narrow> 313D',
65454: '<narrow> 313E',
65455: '<narrow> 313F',
65456: '<narrow> 3140',
65457: '<narrow> 3141',
65458: '<narrow> 3142',
65459: '<narrow> 3143',
65460: '<narrow> 3144',
65461: '<narrow> 3145',
65462: '<narrow> 3146',
65463: '<narrow> 3147',
65464: '<narrow> 3148',
65465: '<narrow> 3149',
65466: '<narrow> 314A',
65467: '<narrow> 314B',
65468: '<narrow> 314C',
65469: '<narrow> 314D',
65470: '<narrow> 314E',
65474: '<narrow> 314F',
65475: '<narrow> 3150',
65476: '<narrow> 3151',
65477: '<narrow> 3152',
65478: '<narrow> 3153',
65479: '<narrow> 3154',
65482: '<narrow> 3155',
65483: '<narrow> 3156',
65484: '<narrow> 3157',
65485: '<narrow> 3158',
65486: '<narrow> 3159',
65487: '<narrow> 315A',
65490: '<narrow> 315B',
65491: '<narrow> 315C',
65492: '<narrow> 315D',
65493: '<narrow> 315E',
65494: '<narrow> 315F',
65495: '<narrow> 3160',
65498: '<narrow> 3161',
65499: '<narrow> 3162',
65500: '<narrow> 3163',
65504: '<wide> 00A2',
65505: '<wide> 00A3',
65506: '<wide> 00AC',
65507: '<wide> 00AF',
65508: '<wide> 00A6',
65509: '<wide> 00A5',
65510: '<wide> 20A9',
65512: '<narrow> 2502',
65513: '<narrow> 2190',
65514: '<narrow> 2191',
65515: '<narrow> 2192',
65516: '<narrow> 2193',
65517: '<narrow> 25A0',
65518: '<narrow> 25CB',
69786: '11099 110BA',
69788: '1109B 110BA',
69803: '110A5 110BA',
119134: '1D157 1D165',
119135: '1D158 1D165',
119136: '1D15F 1D16E',
119137: '1D15F 1D16F',
119138: '1D15F 1D170',
119139: '1D15F 1D171',
119140: '1D15F 1D172',
119227: '1D1B9 1D165',
119228: '1D1BA 1D165',
119229: '1D1BB 1D16E',
119230: '1D1BC 1D16E',
119231: '1D1BB 1D16F',
119232: '1D1BC 1D16F',
119808: '<font> 0041',
119809: '<font> 0042',
119810: '<font> 0043',
119811: '<font> 0044',
119812: '<font> 0045',
119813: '<font> 0046',
119814: '<font> 0047',
119815: '<font> 0048',
119816: '<font> 0049',
119817: '<font> 004A',
119818: '<font> 004B',
119819: '<font> 004C',
119820: '<font> 004D',
119821: '<font> 004E',
119822: '<font> 004F',
119823: '<font> 0050',
119824: '<font> 0051',
119825: '<font> 0052',
119826: '<font> 0053',
119827: '<font> 0054',
119828: '<font> 0055',
119829: '<font> 0056',
119830: '<font> 0057',
119831: '<font> 0058',
119832: '<font> 0059',
119833: '<font> 005A',
119834: '<font> 0061',
119835: '<font> 0062',
119836: '<font> 0063',
119837: '<font> 0064',
119838: '<font> 0065',
119839: '<font> 0066',
119840: '<font> 0067',
119841: '<font> 0068',
119842: '<font> 0069',
119843: '<font> 006A',
119844: '<font> 006B',
119845: '<font> 006C',
119846: '<font> 006D',
119847: '<font> 006E',
119848: '<font> 006F',
119849: '<font> 0070',
119850: '<font> 0071',
119851: '<font> 0072',
119852: '<font> 0073',
119853: '<font> 0074',
119854: '<font> 0075',
119855: '<font> 0076',
119856: '<font> 0077',
119857: '<font> 0078',
119858: '<font> 0079',
119859: '<font> 007A',
119860: '<font> 0041',
119861: '<font> 0042',
119862: '<font> 0043',
119863: '<font> 0044',
119864: '<font> 0045',
119865: '<font> 0046',
119866: '<font> 0047',
119867: '<font> 0048',
119868: '<font> 0049',
119869: '<font> 004A',
119870: '<font> 004B',
119871: '<font> 004C',
119872: '<font> 004D',
119873: '<font> 004E',
119874: '<font> 004F',
119875: '<font> 0050',
119876: '<font> 0051',
119877: '<font> 0052',
119878: '<font> 0053',
119879: '<font> 0054',
119880: '<font> 0055',
119881: '<font> 0056',
119882: '<font> 0057',
119883: '<font> 0058',
119884: '<font> 0059',
119885: '<font> 005A',
119886: '<font> 0061',
119887: '<font> 0062',
119888: '<font> 0063',
119889: '<font> 0064',
119890: '<font> 0065',
119891: '<font> 0066',
119892: '<font> 0067',
119894: '<font> 0069',
119895: '<font> 006A',
119896: '<font> 006B',
119897: '<font> 006C',
119898: '<font> 006D',
119899: '<font> 006E',
119900: '<font> 006F',
119901: '<font> 0070',
119902: '<font> 0071',
119903: '<font> 0072',
119904: '<font> 0073',
119905: '<font> 0074',
119906: '<font> 0075',
119907: '<font> 0076',
119908: '<font> 0077',
119909: '<font> 0078',
119910: '<font> 0079',
119911: '<font> 007A',
119912: '<font> 0041',
119913: '<font> 0042',
119914: '<font> 0043',
119915: '<font> 0044',
119916: '<font> 0045',
119917: '<font> 0046',
119918: '<font> 0047',
119919: '<font> 0048',
119920: '<font> 0049',
119921: '<font> 004A',
119922: '<font> 004B',
119923: '<font> 004C',
119924: '<font> 004D',
119925: '<font> 004E',
119926: '<font> 004F',
119927: '<font> 0050',
119928: '<font> 0051',
119929: '<font> 0052',
119930: '<font> 0053',
119931: '<font> 0054',
119932: '<font> 0055',
119933: '<font> 0056',
119934: '<font> 0057',
119935: '<font> 0058',
119936: '<font> 0059',
119937: '<font> 005A',
119938: '<font> 0061',
119939: '<font> 0062',
119940: '<font> 0063',
119941: '<font> 0064',
119942: '<font> 0065',
119943: '<font> 0066',
119944: '<font> 0067',
119945: '<font> 0068',
119946: '<font> 0069',
119947: '<font> 006A',
119948: '<font> 006B',
119949: '<font> 006C',
119950: '<font> 006D',
119951: '<font> 006E',
119952: '<font> 006F',
119953: '<font> 0070',
119954: '<font> 0071',
119955: '<font> 0072',
119956: '<font> 0073',
119957: '<font> 0074',
119958: '<font> 0075',
119959: '<font> 0076',
119960: '<font> 0077',
119961: '<font> 0078',
119962: '<font> 0079',
119963: '<font> 007A',
119964: '<font> 0041',
119966: '<font> 0043',
119967: '<font> 0044',
119970: '<font> 0047',
119973: '<font> 004A',
119974: '<font> 004B',
119977: '<font> 004E',
119978: '<font> 004F',
119979: '<font> 0050',
119980: '<font> 0051',
119982: '<font> 0053',
119983: '<font> 0054',
119984: '<font> 0055',
119985: '<font> 0056',
119986: '<font> 0057',
119987: '<font> 0058',
119988: '<font> 0059',
119989: '<font> 005A',
119990: '<font> 0061',
119991: '<font> 0062',
119992: '<font> 0063',
119993: '<font> 0064',
119995: '<font> 0066',
119997: '<font> 0068',
119998: '<font> 0069',
119999: '<font> 006A',
120000: '<font> 006B',
120001: '<font> 006C',
120002: '<font> 006D',
120003: '<font> 006E',
120005: '<font> 0070',
120006: '<font> 0071',
120007: '<font> 0072',
120008: '<font> 0073',
120009: '<font> 0074',
120010: '<font> 0075',
120011: '<font> 0076',
120012: '<font> 0077',
120013: '<font> 0078',
120014: '<font> 0079',
120015: '<font> 007A',
120016: '<font> 0041',
120017: '<font> 0042',
120018: '<font> 0043',
120019: '<font> 0044',
120020: '<font> 0045',
120021: '<font> 0046',
120022: '<font> 0047',
120023: '<font> 0048',
120024: '<font> 0049',
120025: '<font> 004A',
120026: '<font> 004B',
120027: '<font> 004C',
120028: '<font> 004D',
120029: '<font> 004E',
120030: '<font> 004F',
120031: '<font> 0050',
120032: '<font> 0051',
120033: '<font> 0052',
120034: '<font> 0053',
120035: '<font> 0054',
120036: '<font> 0055',
120037: '<font> 0056',
120038: '<font> 0057',
120039: '<font> 0058',
120040: '<font> 0059',
120041: '<font> 005A',
120042: '<font> 0061',
120043: '<font> 0062',
120044: '<font> 0063',
120045: '<font> 0064',
120046: '<font> 0065',
120047: '<font> 0066',
120048: '<font> 0067',
120049: '<font> 0068',
120050: '<font> 0069',
120051: '<font> 006A',
120052: '<font> 006B',
120053: '<font> 006C',
120054: '<font> 006D',
120055: '<font> 006E',
120056: '<font> 006F',
120057: '<font> 0070',
120058: '<font> 0071',
120059: '<font> 0072',
120060: '<font> 0073',
120061: '<font> 0074',
120062: '<font> 0075',
120063: '<font> 0076',
120064: '<font> 0077',
120065: '<font> 0078',
120066: '<font> 0079',
120067: '<font> 007A',
120068: '<font> 0041',
120069: '<font> 0042',
120071: '<font> 0044',
120072: '<font> 0045',
120073: '<font> 0046',
120074: '<font> 0047',
120077: '<font> 004A',
120078: '<font> 004B',
120079: '<font> 004C',
120080: '<font> 004D',
120081: '<font> 004E',
120082: '<font> 004F',
120083: '<font> 0050',
120084: '<font> 0051',
120086: '<font> 0053',
120087: '<font> 0054',
120088: '<font> 0055',
120089: '<font> 0056',
120090: '<font> 0057',
120091: '<font> 0058',
120092: '<font> 0059',
120094: '<font> 0061',
120095: '<font> 0062',
120096: '<font> 0063',
120097: '<font> 0064',
120098: '<font> 0065',
120099: '<font> 0066',
120100: '<font> 0067',
120101: '<font> 0068',
120102: '<font> 0069',
120103: '<font> 006A',
120104: '<font> 006B',
120105: '<font> 006C',
120106: '<font> 006D',
120107: '<font> 006E',
120108: '<font> 006F',
120109: '<font> 0070',
120110: '<font> 0071',
120111: '<font> 0072',
120112: '<font> 0073',
120113: '<font> 0074',
120114: '<font> 0075',
120115: '<font> 0076',
120116: '<font> 0077',
120117: '<font> 0078',
120118: '<font> 0079',
120119: '<font> 007A',
120120: '<font> 0041',
120121: '<font> 0042',
120123: '<font> 0044',
120124: '<font> 0045',
120125: '<font> 0046',
120126: '<font> 0047',
120128: '<font> 0049',
120129: '<font> 004A',
120130: '<font> 004B',
120131: '<font> 004C',
120132: '<font> 004D',
120134: '<font> 004F',
120138: '<font> 0053',
120139: '<font> 0054',
120140: '<font> 0055',
120141: '<font> 0056',
120142: '<font> 0057',
120143: '<font> 0058',
120144: '<font> 0059',
120146: '<font> 0061',
120147: '<font> 0062',
120148: '<font> 0063',
120149: '<font> 0064',
120150: '<font> 0065',
120151: '<font> 0066',
120152: '<font> 0067',
120153: '<font> 0068',
120154: '<font> 0069',
120155: '<font> 006A',
120156: '<font> 006B',
120157: '<font> 006C',
120158: '<font> 006D',
120159: '<font> 006E',
120160: '<font> 006F',
120161: '<font> 0070',
120162: '<font> 0071',
120163: '<font> 0072',
120164: '<font> 0073',
120165: '<font> 0074',
120166: '<font> 0075',
120167: '<font> 0076',
120168: '<font> 0077',
120169: '<font> 0078',
120170: '<font> 0079',
120171: '<font> 007A',
120172: '<font> 0041',
120173: '<font> 0042',
120174: '<font> 0043',
120175: '<font> 0044',
120176: '<font> 0045',
120177: '<font> 0046',
120178: '<font> 0047',
120179: '<font> 0048',
120180: '<font> 0049',
120181: '<font> 004A',
120182: '<font> 004B',
120183: '<font> 004C',
120184: '<font> 004D',
120185: '<font> 004E',
120186: '<font> 004F',
120187: '<font> 0050',
120188: '<font> 0051',
120189: '<font> 0052',
120190: '<font> 0053',
120191: '<font> 0054',
120192: '<font> 0055',
120193: '<font> 0056',
120194: '<font> 0057',
120195: '<font> 0058',
120196: '<font> 0059',
120197: '<font> 005A',
120198: '<font> 0061',
120199: '<font> 0062',
120200: '<font> 0063',
120201: '<font> 0064',
120202: '<font> 0065',
120203: '<font> 0066',
120204: '<font> 0067',
120205: '<font> 0068',
120206: '<font> 0069',
120207: '<font> 006A',
120208: '<font> 006B',
120209: '<font> 006C',
120210: '<font> 006D',
120211: '<font> 006E',
120212: '<font> 006F',
120213: '<font> 0070',
120214: '<font> 0071',
120215: '<font> 0072',
120216: '<font> 0073',
120217: '<font> 0074',
120218: '<font> 0075',
120219: '<font> 0076',
120220: '<font> 0077',
120221: '<font> 0078',
120222: '<font> 0079',
120223: '<font> 007A',
120224: '<font> 0041',
120225: '<font> 0042',
120226: '<font> 0043',
120227: '<font> 0044',
120228: '<font> 0045',
120229: '<font> 0046',
120230: '<font> 0047',
120231: '<font> 0048',
120232: '<font> 0049',
120233: '<font> 004A',
120234: '<font> 004B',
120235: '<font> 004C',
120236: '<font> 004D',
120237: '<font> 004E',
120238: '<font> 004F',
120239: '<font> 0050',
120240: '<font> 0051',
120241: '<font> 0052',
120242: '<font> 0053',
120243: '<font> 0054',
120244: '<font> 0055',
120245: '<font> 0056',
120246: '<font> 0057',
120247: '<font> 0058',
120248: '<font> 0059',
120249: '<font> 005A',
120250: '<font> 0061',
120251: '<font> 0062',
120252: '<font> 0063',
120253: '<font> 0064',
120254: '<font> 0065',
120255: '<font> 0066',
120256: '<font> 0067',
120257: '<font> 0068',
120258: '<font> 0069',
120259: '<font> 006A',
120260: '<font> 006B',
120261: '<font> 006C',
120262: '<font> 006D',
120263: '<font> 006E',
120264: '<font> 006F',
120265: '<font> 0070',
120266: '<font> 0071',
120267: '<font> 0072',
120268: '<font> 0073',
120269: '<font> 0074',
120270: '<font> 0075',
120271: '<font> 0076',
120272: '<font> 0077',
120273: '<font> 0078',
120274: '<font> 0079',
120275: '<font> 007A',
120276: '<font> 0041',
120277: '<font> 0042',
120278: '<font> 0043',
120279: '<font> 0044',
120280: '<font> 0045',
120281: '<font> 0046',
120282: '<font> 0047',
120283: '<font> 0048',
120284: '<font> 0049',
120285: '<font> 004A',
120286: '<font> 004B',
120287: '<font> 004C',
120288: '<font> 004D',
120289: '<font> 004E',
120290: '<font> 004F',
120291: '<font> 0050',
120292: '<font> 0051',
120293: '<font> 0052',
120294: '<font> 0053',
120295: '<font> 0054',
120296: '<font> 0055',
120297: '<font> 0056',
120298: '<font> 0057',
120299: '<font> 0058',
120300: '<font> 0059',
120301: '<font> 005A',
120302: '<font> 0061',
120303: '<font> 0062',
120304: '<font> 0063',
120305: '<font> 0064',
120306: '<font> 0065',
120307: '<font> 0066',
120308: '<font> 0067',
120309: '<font> 0068',
120310: '<font> 0069',
120311: '<font> 006A',
120312: '<font> 006B',
120313: '<font> 006C',
120314: '<font> 006D',
120315: '<font> 006E',
120316: '<font> 006F',
120317: '<font> 0070',
120318: '<font> 0071',
120319: '<font> 0072',
120320: '<font> 0073',
120321: '<font> 0074',
120322: '<font> 0075',
120323: '<font> 0076',
120324: '<font> 0077',
120325: '<font> 0078',
120326: '<font> 0079',
120327: '<font> 007A',
120328: '<font> 0041',
120329: '<font> 0042',
120330: '<font> 0043',
120331: '<font> 0044',
120332: '<font> 0045',
120333: '<font> 0046',
120334: '<font> 0047',
120335: '<font> 0048',
120336: '<font> 0049',
120337: '<font> 004A',
120338: '<font> 004B',
120339: '<font> 004C',
120340: '<font> 004D',
120341: '<font> 004E',
120342: '<font> 004F',
120343: '<font> 0050',
120344: '<font> 0051',
120345: '<font> 0052',
120346: '<font> 0053',
120347: '<font> 0054',
120348: '<font> 0055',
120349: '<font> 0056',
120350: '<font> 0057',
120351: '<font> 0058',
120352: '<font> 0059',
120353: '<font> 005A',
120354: '<font> 0061',
120355: '<font> 0062',
120356: '<font> 0063',
120357: '<font> 0064',
120358: '<font> 0065',
120359: '<font> 0066',
120360: '<font> 0067',
120361: '<font> 0068',
120362: '<font> 0069',
120363: '<font> 006A',
120364: '<font> 006B',
120365: '<font> 006C',
120366: '<font> 006D',
120367: '<font> 006E',
120368: '<font> 006F',
120369: '<font> 0070',
120370: '<font> 0071',
120371: '<font> 0072',
120372: '<font> 0073',
120373: '<font> 0074',
120374: '<font> 0075',
120375: '<font> 0076',
120376: '<font> 0077',
120377: '<font> 0078',
120378: '<font> 0079',
120379: '<font> 007A',
120380: '<font> 0041',
120381: '<font> 0042',
120382: '<font> 0043',
120383: '<font> 0044',
120384: '<font> 0045',
120385: '<font> 0046',
120386: '<font> 0047',
120387: '<font> 0048',
120388: '<font> 0049',
120389: '<font> 004A',
120390: '<font> 004B',
120391: '<font> 004C',
120392: '<font> 004D',
120393: '<font> 004E',
120394: '<font> 004F',
120395: '<font> 0050',
120396: '<font> 0051',
120397: '<font> 0052',
120398: '<font> 0053',
120399: '<font> 0054',
120400: '<font> 0055',
120401: '<font> 0056',
120402: '<font> 0057',
120403: '<font> 0058',
120404: '<font> 0059',
120405: '<font> 005A',
120406: '<font> 0061',
120407: '<font> 0062',
120408: '<font> 0063',
120409: '<font> 0064',
120410: '<font> 0065',
120411: '<font> 0066',
120412: '<font> 0067',
120413: '<font> 0068',
120414: '<font> 0069',
120415: '<font> 006A',
120416: '<font> 006B',
120417: '<font> 006C',
120418: '<font> 006D',
120419: '<font> 006E',
120420: '<font> 006F',
120421: '<font> 0070',
120422: '<font> 0071',
120423: '<font> 0072',
120424: '<font> 0073',
120425: '<font> 0074',
120426: '<font> 0075',
120427: '<font> 0076',
120428: '<font> 0077',
120429: '<font> 0078',
120430: '<font> 0079',
120431: '<font> 007A',
120432: '<font> 0041',
120433: '<font> 0042',
120434: '<font> 0043',
120435: '<font> 0044',
120436: '<font> 0045',
120437: '<font> 0046',
120438: '<font> 0047',
120439: '<font> 0048',
120440: '<font> 0049',
120441: '<font> 004A',
120442: '<font> 004B',
120443: '<font> 004C',
120444: '<font> 004D',
120445: '<font> 004E',
120446: '<font> 004F',
120447: '<font> 0050',
120448: '<font> 0051',
120449: '<font> 0052',
120450: '<font> 0053',
120451: '<font> 0054',
120452: '<font> 0055',
120453: '<font> 0056',
120454: '<font> 0057',
120455: '<font> 0058',
120456: '<font> 0059',
120457: '<font> 005A',
120458: '<font> 0061',
120459: '<font> 0062',
120460: '<font> 0063',
120461: '<font> 0064',
120462: '<font> 0065',
120463: '<font> 0066',
120464: '<font> 0067',
120465: '<font> 0068',
120466: '<font> 0069',
120467: '<font> 006A',
120468: '<font> 006B',
120469: '<font> 006C',
120470: '<font> 006D',
120471: '<font> 006E',
120472: '<font> 006F',
120473: '<font> 0070',
120474: '<font> 0071',
120475: '<font> 0072',
120476: '<font> 0073',
120477: '<font> 0074',
120478: '<font> 0075',
120479: '<font> 0076',
120480: '<font> 0077',
120481: '<font> 0078',
120482: '<font> 0079',
120483: '<font> 007A',
120484: '<font> 0131',
120485: '<font> 0237',
120488: '<font> 0391',
120489: '<font> 0392',
120490: '<font> 0393',
120491: '<font> 0394',
120492: '<font> 0395',
120493: '<font> 0396',
120494: '<font> 0397',
120495: '<font> 0398',
120496: '<font> 0399',
120497: '<font> 039A',
120498: '<font> 039B',
120499: '<font> 039C',
120500: '<font> 039D',
120501: '<font> 039E',
120502: '<font> 039F',
120503: '<font> 03A0',
120504: '<font> 03A1',
120505: '<font> 03F4',
120506: '<font> 03A3',
120507: '<font> 03A4',
120508: '<font> 03A5',
120509: '<font> 03A6',
120510: '<font> 03A7',
120511: '<font> 03A8',
120512: '<font> 03A9',
120513: '<font> 2207',
120514: '<font> 03B1',
120515: '<font> 03B2',
120516: '<font> 03B3',
120517: '<font> 03B4',
120518: '<font> 03B5',
120519: '<font> 03B6',
120520: '<font> 03B7',
120521: '<font> 03B8',
120522: '<font> 03B9',
120523: '<font> 03BA',
120524: '<font> 03BB',
120525: '<font> 03BC',
120526: '<font> 03BD',
120527: '<font> 03BE',
120528: '<font> 03BF',
120529: '<font> 03C0',
120530: '<font> 03C1',
120531: '<font> 03C2',
120532: '<font> 03C3',
120533: '<font> 03C4',
120534: '<font> 03C5',
120535: '<font> 03C6',
120536: '<font> 03C7',
120537: '<font> 03C8',
120538: '<font> 03C9',
120539: '<font> 2202',
120540: '<font> 03F5',
120541: '<font> 03D1',
120542: '<font> 03F0',
120543: '<font> 03D5',
120544: '<font> 03F1',
120545: '<font> 03D6',
120546: '<font> 0391',
120547: '<font> 0392',
120548: '<font> 0393',
120549: '<font> 0394',
120550: '<font> 0395',
120551: '<font> 0396',
120552: '<font> 0397',
120553: '<font> 0398',
120554: '<font> 0399',
120555: '<font> 039A',
120556: '<font> 039B',
120557: '<font> 039C',
120558: '<font> 039D',
120559: '<font> 039E',
120560: '<font> 039F',
120561: '<font> 03A0',
120562: '<font> 03A1',
120563: '<font> 03F4',
120564: '<font> 03A3',
120565: '<font> 03A4',
120566: '<font> 03A5',
120567: '<font> 03A6',
120568: '<font> 03A7',
120569: '<font> 03A8',
120570: '<font> 03A9',
120571: '<font> 2207',
120572: '<font> 03B1',
120573: '<font> 03B2',
120574: '<font> 03B3',
120575: '<font> 03B4',
120576: '<font> 03B5',
120577: '<font> 03B6',
120578: '<font> 03B7',
120579: '<font> 03B8',
120580: '<font> 03B9',
120581: '<font> 03BA',
120582: '<font> 03BB',
120583: '<font> 03BC',
120584: '<font> 03BD',
120585: '<font> 03BE',
120586: '<font> 03BF',
120587: '<font> 03C0',
120588: '<font> 03C1',
120589: '<font> 03C2',
120590: '<font> 03C3',
120591: '<font> 03C4',
120592: '<font> 03C5',
120593: '<font> 03C6',
120594: '<font> 03C7',
120595: '<font> 03C8',
120596: '<font> 03C9',
120597: '<font> 2202',
120598: '<font> 03F5',
120599: '<font> 03D1',
120600: '<font> 03F0',
120601: '<font> 03D5',
120602: '<font> 03F1',
120603: '<font> 03D6',
120604: '<font> 0391',
120605: '<font> 0392',
120606: '<font> 0393',
120607: '<font> 0394',
120608: '<font> 0395',
120609: '<font> 0396',
120610: '<font> 0397',
120611: '<font> 0398',
120612: '<font> 0399',
120613: '<font> 039A',
120614: '<font> 039B',
120615: '<font> 039C',
120616: '<font> 039D',
120617: '<font> 039E',
120618: '<font> 039F',
120619: '<font> 03A0',
120620: '<font> 03A1',
120621: '<font> 03F4',
120622: '<font> 03A3',
120623: '<font> 03A4',
120624: '<font> 03A5',
120625: '<font> 03A6',
120626: '<font> 03A7',
120627: '<font> 03A8',
120628: '<font> 03A9',
120629: '<font> 2207',
120630: '<font> 03B1',
120631: '<font> 03B2',
120632: '<font> 03B3',
120633: '<font> 03B4',
120634: '<font> 03B5',
120635: '<font> 03B6',
120636: '<font> 03B7',
120637: '<font> 03B8',
120638: '<font> 03B9',
120639: '<font> 03BA',
120640: '<font> 03BB',
120641: '<font> 03BC',
120642: '<font> 03BD',
120643: '<font> 03BE',
120644: '<font> 03BF',
120645: '<font> 03C0',
120646: '<font> 03C1',
120647: '<font> 03C2',
120648: '<font> 03C3',
120649: '<font> 03C4',
120650: '<font> 03C5',
120651: '<font> 03C6',
120652: '<font> 03C7',
120653: '<font> 03C8',
120654: '<font> 03C9',
120655: '<font> 2202',
120656: '<font> 03F5',
120657: '<font> 03D1',
120658: '<font> 03F0',
120659: '<font> 03D5',
120660: '<font> 03F1',
120661: '<font> 03D6',
120662: '<font> 0391',
120663: '<font> 0392',
120664: '<font> 0393',
120665: '<font> 0394',
120666: '<font> 0395',
120667: '<font> 0396',
120668: '<font> 0397',
120669: '<font> 0398',
120670: '<font> 0399',
120671: '<font> 039A',
120672: '<font> 039B',
120673: '<font> 039C',
120674: '<font> 039D',
120675: '<font> 039E',
120676: '<font> 039F',
120677: '<font> 03A0',
120678: '<font> 03A1',
120679: '<font> 03F4',
120680: '<font> 03A3',
120681: '<font> 03A4',
120682: '<font> 03A5',
120683: '<font> 03A6',
120684: '<font> 03A7',
120685: '<font> 03A8',
120686: '<font> 03A9',
120687: '<font> 2207',
120688: '<font> 03B1',
120689: '<font> 03B2',
120690: '<font> 03B3',
120691: '<font> 03B4',
120692: '<font> 03B5',
120693: '<font> 03B6',
120694: '<font> 03B7',
120695: '<font> 03B8',
120696: '<font> 03B9',
120697: '<font> 03BA',
120698: '<font> 03BB',
120699: '<font> 03BC',
120700: '<font> 03BD',
120701: '<font> 03BE',
120702: '<font> 03BF',
120703: '<font> 03C0',
120704: '<font> 03C1',
120705: '<font> 03C2',
120706: '<font> 03C3',
120707: '<font> 03C4',
120708: '<font> 03C5',
120709: '<font> 03C6',
120710: '<font> 03C7',
120711: '<font> 03C8',
120712: '<font> 03C9',
120713: '<font> 2202',
120714: '<font> 03F5',
120715: '<font> 03D1',
120716: '<font> 03F0',
120717: '<font> 03D5',
120718: '<font> 03F1',
120719: '<font> 03D6',
120720: '<font> 0391',
120721: '<font> 0392',
120722: '<font> 0393',
120723: '<font> 0394',
120724: '<font> 0395',
120725: '<font> 0396',
120726: '<font> 0397',
120727: '<font> 0398',
120728: '<font> 0399',
120729: '<font> 039A',
120730: '<font> 039B',
120731: '<font> 039C',
120732: '<font> 039D',
120733: '<font> 039E',
120734: '<font> 039F',
120735: '<font> 03A0',
120736: '<font> 03A1',
120737: '<font> 03F4',
120738: '<font> 03A3',
120739: '<font> 03A4',
120740: '<font> 03A5',
120741: '<font> 03A6',
120742: '<font> 03A7',
120743: '<font> 03A8',
120744: '<font> 03A9',
120745: '<font> 2207',
120746: '<font> 03B1',
120747: '<font> 03B2',
120748: '<font> 03B3',
120749: '<font> 03B4',
120750: '<font> 03B5',
120751: '<font> 03B6',
120752: '<font> 03B7',
120753: '<font> 03B8',
120754: '<font> 03B9',
120755: '<font> 03BA',
120756: '<font> 03BB',
120757: '<font> 03BC',
120758: '<font> 03BD',
120759: '<font> 03BE',
120760: '<font> 03BF',
120761: '<font> 03C0',
120762: '<font> 03C1',
120763: '<font> 03C2',
120764: '<font> 03C3',
120765: '<font> 03C4',
120766: '<font> 03C5',
120767: '<font> 03C6',
120768: '<font> 03C7',
120769: '<font> 03C8',
120770: '<font> 03C9',
120771: '<font> 2202',
120772: '<font> 03F5',
120773: '<font> 03D1',
120774: '<font> 03F0',
120775: '<font> 03D5',
120776: '<font> 03F1',
120777: '<font> 03D6',
120778: '<font> 03DC',
120779: '<font> 03DD',
120782: '<font> 0030',
120783: '<font> 0031',
120784: '<font> 0032',
120785: '<font> 0033',
120786: '<font> 0034',
120787: '<font> 0035',
120788: '<font> 0036',
120789: '<font> 0037',
120790: '<font> 0038',
120791: '<font> 0039',
120792: '<font> 0030',
120793: '<font> 0031',
120794: '<font> 0032',
120795: '<font> 0033',
120796: '<font> 0034',
120797: '<font> 0035',
120798: '<font> 0036',
120799: '<font> 0037',
120800: '<font> 0038',
120801: '<font> 0039',
120802: '<font> 0030',
120803: '<font> 0031',
120804: '<font> 0032',
120805: '<font> 0033',
120806: '<font> 0034',
120807: '<font> 0035',
120808: '<font> 0036',
120809: '<font> 0037',
120810: '<font> 0038',
120811: '<font> 0039',
120812: '<font> 0030',
120813: '<font> 0031',
120814: '<font> 0032',
120815: '<font> 0033',
120816: '<font> 0034',
120817: '<font> 0035',
120818: '<font> 0036',
120819: '<font> 0037',
120820: '<font> 0038',
120821: '<font> 0039',
120822: '<font> 0030',
120823: '<font> 0031',
120824: '<font> 0032',
120825: '<font> 0033',
120826: '<font> 0034',
120827: '<font> 0035',
120828: '<font> 0036',
120829: '<font> 0037',
120830: '<font> 0038',
120831: '<font> 0039',
127232: '<compat> 0030 002E',
127233: '<compat> 0030 002C',
127234: '<compat> 0031 002C',
127235: '<compat> 0032 002C',
127236: '<compat> 0033 002C',
127237: '<compat> 0034 002C',
127238: '<compat> 0035 002C',
127239: '<compat> 0036 002C',
127240: '<compat> 0037 002C',
127241: '<compat> 0038 002C',
127242: '<compat> 0039 002C',
127248: '<compat> 0028 0041 0029',
127249: '<compat> 0028 0042 0029',
127250: '<compat> 0028 0043 0029',
127251: '<compat> 0028 0044 0029',
127252: '<compat> 0028 0045 0029',
127253: '<compat> 0028 0046 0029',
127254: '<compat> 0028 0047 0029',
127255: '<compat> 0028 0048 0029',
127256: '<compat> 0028 0049 0029',
127257: '<compat> 0028 004A 0029',
127258: '<compat> 0028 004B 0029',
127259: '<compat> 0028 004C 0029',
127260: '<compat> 0028 004D 0029',
127261: '<compat> 0028 004E 0029',
127262: '<compat> 0028 004F 0029',
127263: '<compat> 0028 0050 0029',
127264: '<compat> 0028 0051 0029',
127265: '<compat> 0028 0052 0029',
127266: '<compat> 0028 0053 0029',
127267: '<compat> 0028 0054 0029',
127268: '<compat> 0028 0055 0029',
127269: '<compat> 0028 0056 0029',
127270: '<compat> 0028 0057 0029',
127271: '<compat> 0028 0058 0029',
127272: '<compat> 0028 0059 0029',
127273: '<compat> 0028 005A 0029',
127274: '<compat> 3014 0053 3015',
127275: '<circle> 0043',
127276: '<circle> 0052',
127277: '<circle> 0043 0044',
127278: '<circle> 0057 005A',
127281: '<square> 0042',
127293: '<square> 004E',
127295: '<square> 0050',
127298: '<square> 0053',
127302: '<square> 0057',
127306: '<square> 0048 0056',
127307: '<square> 004D 0056',
127308: '<square> 0053 0044',
127309: '<square> 0053 0053',
127310: '<square> 0050 0050 0056',
127376: '<square> 0044 004A',
127488: '<square> 307B 304B',
127504: '<square> 624B',
127505: '<square> 5B57',
127506: '<square> 53CC',
127507: '<square> 30C7',
127508: '<square> 4E8C',
127509: '<square> 591A',
127510: '<square> 89E3',
127511: '<square> 5929',
127512: '<square> 4EA4',
127513: '<square> 6620',
127514: '<square> 7121',
127515: '<square> 6599',
127516: '<square> 524D',
127517: '<square> 5F8C',
127518: '<square> 518D',
127519: '<square> 65B0',
127520: '<square> 521D',
127521: '<square> 7D42',
127522: '<square> 751F',
127523: '<square> 8CA9',
127524: '<square> 58F0',
127525: '<square> 5439',
127526: '<square> 6F14',
127527: '<square> 6295',
127528: '<square> 6355',
127529: '<square> 4E00',
127530: '<square> 4E09',
127531: '<square> 904A',
127532: '<square> 5DE6',
127533: '<square> 4E2D',
127534: '<square> 53F3',
127535: '<square> 6307',
127536: '<square> 8D70',
127537: '<square> 6253',
127552: '<compat> 3014 672C 3015',
127553: '<compat> 3014 4E09 3015',
127554: '<compat> 3014 4E8C 3015',
127555: '<compat> 3014 5B89 3015',
127556: '<compat> 3014 70B9 3015',
127557: '<compat> 3014 6253 3015',
127558: '<compat> 3014 76D7 3015',
127559: '<compat> 3014 52DD 3015',
127560: '<compat> 3014 6557 3015',
194560: '4E3D',
194561: '4E38',
194562: '4E41',
194563: '20122',
194564: '4F60',
194565: '4FAE',
194566: '4FBB',
194567: '5002',
194568: '507A',
194569: '5099',
194570: '50E7',
194571: '50CF',
194572: '349E',
194573: '2063A',
194574: '514D',
194575: '5154',
194576: '5164',
194577: '5177',
194578: '2051C',
194579: '34B9',
194580: '5167',
194581: '518D',
194582: '2054B',
194583: '5197',
194584: '51A4',
194585: '4ECC',
194586: '51AC',
194587: '51B5',
194588: '291DF',
194589: '51F5',
194590: '5203',
194591: '34DF',
194592: '523B',
194593: '5246',
194594: '5272',
194595: '5277',
194596: '3515',
194597: '52C7',
194598: '52C9',
194599: '52E4',
194600: '52FA',
194601: '5305',
194602: '5306',
194603: '5317',
194604: '5349',
194605: '5351',
194606: '535A',
194607: '5373',
194608: '537D',
194609: '537F',
194610: '537F',
194611: '537F',
194612: '20A2C',
194613: '7070',
194614: '53CA',
194615: '53DF',
194616: '20B63',
194617: '53EB',
194618: '53F1',
194619: '5406',
194620: '549E',
194621: '5438',
194622: '5448',
194623: '5468',
194624: '54A2',
194625: '54F6',
194626: '5510',
194627: '5553',
194628: '5563',
194629: '5584',
194630: '5584',
194631: '5599',
194632: '55AB',
194633: '55B3',
194634: '55C2',
194635: '5716',
194636: '5606',
194637: '5717',
194638: '5651',
194639: '5674',
194640: '5207',
194641: '58EE',
194642: '57CE',
194643: '57F4',
194644: '580D',
194645: '578B',
194646: '5832',
194647: '5831',
194648: '58AC',
194649: '214E4',
194650: '58F2',
194651: '58F7',
194652: '5906',
194653: '591A',
194654: '5922',
194655: '5962',
194656: '216A8',
194657: '216EA',
194658: '59EC',
194659: '5A1B',
194660: '5A27',
194661: '59D8',
194662: '5A66',
194663: '36EE',
194664: '36FC',
194665: '5B08',
194666: '5B3E',
194667: '5B3E',
194668: '219C8',
194669: '5BC3',
194670: '5BD8',
194671: '5BE7',
194672: '5BF3',
194673: '21B18',
194674: '5BFF',
194675: '5C06',
194676: '5F53',
194677: '5C22',
194678: '3781',
194679: '5C60',
194680: '5C6E',
194681: '5CC0',
194682: '5C8D',
194683: '21DE4',
194684: '5D43',
194685: '21DE6',
194686: '5D6E',
194687: '5D6B',
194688: '5D7C',
194689: '5DE1',
194690: '5DE2',
194691: '382F',
194692: '5DFD',
194693: '5E28',
194694: '5E3D',
194695: '5E69',
194696: '3862',
194697: '22183',
194698: '387C',
194699: '5EB0',
194700: '5EB3',
194701: '5EB6',
194702: '5ECA',
194703: '2A392',
194704: '5EFE',
194705: '22331',
194706: '22331',
194707: '8201',
194708: '5F22',
194709: '5F22',
194710: '38C7',
194711: '232B8',
194712: '261DA',
194713: '5F62',
194714: '5F6B',
194715: '38E3',
194716: '5F9A',
194717: '5FCD',
194718: '5FD7',
194719: '5FF9',
194720: '6081',
194721: '393A',
194722: '391C',
194723: '6094',
194724: '226D4',
194725: '60C7',
194726: '6148',
194727: '614C',
194728: '614E',
194729: '614C',
194730: '617A',
194731: '618E',
194732: '61B2',
194733: '61A4',
194734: '61AF',
194735: '61DE',
194736: '61F2',
194737: '61F6',
194738: '6210',
194739: '621B',
194740: '625D',
194741: '62B1',
194742: '62D4',
194743: '6350',
194744: '22B0C',
194745: '633D',
194746: '62FC',
194747: '6368',
194748: '6383',
194749: '63E4',
194750: '22BF1',
194751: '6422',
194752: '63C5',
194753: '63A9',
194754: '3A2E',
194755: '6469',
194756: '647E',
194757: '649D',
194758: '6477',
194759: '3A6C',
194760: '654F',
194761: '656C',
194762: '2300A',
194763: '65E3',
194764: '66F8',
194765: '6649',
194766: '3B19',
194767: '6691',
194768: '3B08',
194769: '3AE4',
194770: '5192',
194771: '5195',
194772: '6700',
194773: '669C',
194774: '80AD',
194775: '43D9',
194776: '6717',
194777: '671B',
194778: '6721',
194779: '675E',
194780: '6753',
194781: '233C3',
194782: '3B49',
194783: '67FA',
194784: '6785',
194785: '6852',
194786: '6885',
194787: '2346D',
194788: '688E',
194789: '681F',
194790: '6914',
194791: '3B9D',
194792: '6942',
194793: '69A3',
194794: '69EA',
194795: '6AA8',
194796: '236A3',
194797: '6ADB',
194798: '3C18',
194799: '6B21',
194800: '238A7',
194801: '6B54',
194802: '3C4E',
194803: '6B72',
194804: '6B9F',
194805: '6BBA',
194806: '6BBB',
194807: '23A8D',
194808: '21D0B',
194809: '23AFA',
194810: '6C4E',
194811: '23CBC',
194812: '6CBF',
194813: '6CCD',
194814: '6C67',
194815: '6D16',
194816: '6D3E',
194817: '6D77',
194818: '6D41',
194819: '6D69',
194820: '6D78',
194821: '6D85',
194822: '23D1E',
194823: '6D34',
194824: '6E2F',
194825: '6E6E',
194826: '3D33',
194827: '6ECB',
194828: '6EC7',
194829: '23ED1',
194830: '6DF9',
194831: '6F6E',
194832: '23F5E',
194833: '23F8E',
194834: '6FC6',
194835: '7039',
194836: '701E',
194837: '701B',
194838: '3D96',
194839: '704A',
194840: '707D',
194841: '7077',
194842: '70AD',
194843: '20525',
194844: '7145',
194845: '24263',
194846: '719C',
194847: '243AB',
194848: '7228',
194849: '7235',
194850: '7250',
194851: '24608',
194852: '7280',
194853: '7295',
194854: '24735',
194855: '24814',
194856: '737A',
194857: '738B',
194858: '3EAC',
194859: '73A5',
194860: '3EB8',
194861: '3EB8',
194862: '7447',
194863: '745C',
194864: '7471',
194865: '7485',
194866: '74CA',
194867: '3F1B',
194868: '7524',
194869: '24C36',
194870: '753E',
194871: '24C92',
194872: '7570',
194873: '2219F',
194874: '7610',
194875: '24FA1',
194876: '24FB8',
194877: '25044',
194878: '3FFC',
194879: '4008',
194880: '76F4',
194881: '250F3',
194882: '250F2',
194883: '25119',
194884: '25133',
194885: '771E',
194886: '771F',
194887: '771F',
194888: '774A',
194889: '4039',
194890: '778B',
194891: '4046',
194892: '4096',
194893: '2541D',
194894: '784E',
194895: '788C',
194896: '78CC',
194897: '40E3',
194898: '25626',
194899: '7956',
194900: '2569A',
194901: '256C5',
194902: '798F',
194903: '79EB',
194904: '412F',
194905: '7A40',
194906: '7A4A',
194907: '7A4F',
194908: '2597C',
194909: '25AA7',
194910: '25AA7',
194911: '7AEE',
194912: '4202',
194913: '25BAB',
194914: '7BC6',
194915: '7BC9',
194916: '4227',
194917: '25C80',
194918: '7CD2',
194919: '42A0',
194920: '7CE8',
194921: '7CE3',
194922: '7D00',
194923: '25F86',
194924: '7D63',
194925: '4301',
194926: '7DC7',
194927: '7E02',
194928: '7E45',
194929: '4334',
194930: '26228',
194931: '26247',
194932: '4359',
194933: '262D9',
194934: '7F7A',
194935: '2633E',
194936: '7F95',
194937: '7FFA',
194938: '8005',
194939: '264DA',
194940: '26523',
194941: '8060',
194942: '265A8',
194943: '8070',
194944: '2335F',
194945: '43D5',
194946: '80B2',
194947: '8103',
194948: '440B',
194949: '813E',
194950: '5AB5',
194951: '267A7',
194952: '267B5',
194953: '23393',
194954: '2339C',
194955: '8201',
194956: '8204',
194957: '8F9E',
194958: '446B',
194959: '8291',
194960: '828B',
194961: '829D',
194962: '52B3',
194963: '82B1',
194964: '82B3',
194965: '82BD',
194966: '82E6',
194967: '26B3C',
194968: '82E5',
194969: '831D',
194970: '8363',
194971: '83AD',
194972: '8323',
194973: '83BD',
194974: '83E7',
194975: '8457',
194976: '8353',
194977: '83CA',
194978: '83CC',
194979: '83DC',
194980: '26C36',
194981: '26D6B',
194982: '26CD5',
194983: '452B',
194984: '84F1',
194985: '84F3',
194986: '8516',
194987: '273CA',
194988: '8564',
194989: '26F2C',
194990: '455D',
194991: '4561',
194992: '26FB1',
194993: '270D2',
194994: '456B',
194995: '8650',
194996: '865C',
194997: '8667',
194998: '8669',
194999: '86A9',
195000: '8688',
195001: '870E',
195002: '86E2',
195003: '8779',
195004: '8728',
195005: '876B',
195006: '8786',
195007: '45D7',
195008: '87E1',
195009: '8801',
195010: '45F9',
195011: '8860',
195012: '8863',
195013: '27667',
195014: '88D7',
195015: '88DE',
195016: '4635',
195017: '88FA',
195018: '34BB',
195019: '278AE',
195020: '27966',
195021: '46BE',
195022: '46C7',
195023: '8AA0',
195024: '8AED',
195025: '8B8A',
195026: '8C55',
195027: '27CA8',
195028: '8CAB',
195029: '8CC1',
195030: '8D1B',
195031: '8D77',
195032: '27F2F',
195033: '20804',
195034: '8DCB',
195035: '8DBC',
195036: '8DF0',
195037: '208DE',
195038: '8ED4',
195039: '8F38',
195040: '285D2',
195041: '285ED',
195042: '9094',
195043: '90F1',
195044: '9111',
195045: '2872E',
195046: '911B',
195047: '9238',
195048: '92D7',
195049: '92D8',
195050: '927C',
195051: '93F9',
195052: '9415',
195053: '28BFA',
195054: '958B',
195055: '4995',
195056: '95B7',
195057: '28D77',
195058: '49E6',
195059: '96C3',
195060: '5DB2',
195061: '9723',
195062: '29145',
195063: '2921A',
195064: '4A6E',
195065: '4A76',
195066: '97E0',
195067: '2940A',
195068: '4AB2',
195069: '29496',
195070: '980B',
195071: '980B',
195072: '9829',
195073: '295B6',
195074: '98E2',
195075: '4B33',
195076: '9929',
195077: '99A7',
195078: '99C2',
195079: '99FE',
195080: '4BCE',
195081: '29B30',
195082: '9B12',
195083: '9C40',
195084: '9CFD',
195085: '4CCE',
195086: '4CED',
195087: '9D67',
195088: '2A0CE',
195089: '4CF8',
195090: '2A105',
195091: '2A20E',
195092: '2A291',
195093: '9EBB',
195094: '4D56',
195095: '9EF9',
195096: '9EFE',
195097: '9F05',
195098: '9F0F',
195099: '9F16',
195100: '9F3B',
195101: '2A600',
}

_raw_decomposition_corrected = {
}

def decomposition(code):
    try:
        return _raw_decomposition[code]
    except KeyError:
        if base_mod is not None and code not in _raw_decomposition_corrected:
            return base_mod._raw_decomposition.get(code, '')
        else:
            return ''

_composition = {
r_longlong(   65 << 32 |   768):   192,
r_longlong(   65 << 32 |   769):   193,
r_longlong(   65 << 32 |   770):   194,
r_longlong(   65 << 32 |   771):   195,
r_longlong(   65 << 32 |   776):   196,
r_longlong(   65 << 32 |   778):   197,
r_longlong(   67 << 32 |   807):   199,
r_longlong(   69 << 32 |   768):   200,
r_longlong(   69 << 32 |   769):   201,
r_longlong(   69 << 32 |   770):   202,
r_longlong(   69 << 32 |   776):   203,
r_longlong(   73 << 32 |   768):   204,
r_longlong(   73 << 32 |   769):   205,
r_longlong(   73 << 32 |   770):   206,
r_longlong(   73 << 32 |   776):   207,
r_longlong(   78 << 32 |   771):   209,
r_longlong(   79 << 32 |   768):   210,
r_longlong(   79 << 32 |   769):   211,
r_longlong(   79 << 32 |   770):   212,
r_longlong(   79 << 32 |   771):   213,
r_longlong(   79 << 32 |   776):   214,
r_longlong(   85 << 32 |   768):   217,
r_longlong(   85 << 32 |   769):   218,
r_longlong(   85 << 32 |   770):   219,
r_longlong(   85 << 32 |   776):   220,
r_longlong(   89 << 32 |   769):   221,
r_longlong(   97 << 32 |   768):   224,
r_longlong(   97 << 32 |   769):   225,
r_longlong(   97 << 32 |   770):   226,
r_longlong(   97 << 32 |   771):   227,
r_longlong(   97 << 32 |   776):   228,
r_longlong(   97 << 32 |   778):   229,
r_longlong(   99 << 32 |   807):   231,
r_longlong(  101 << 32 |   768):   232,
r_longlong(  101 << 32 |   769):   233,
r_longlong(  101 << 32 |   770):   234,
r_longlong(  101 << 32 |   776):   235,
r_longlong(  105 << 32 |   768):   236,
r_longlong(  105 << 32 |   769):   237,
r_longlong(  105 << 32 |   770):   238,
r_longlong(  105 << 32 |   776):   239,
r_longlong(  110 << 32 |   771):   241,
r_longlong(  111 << 32 |   768):   242,
r_longlong(  111 << 32 |   769):   243,
r_longlong(  111 << 32 |   770):   244,
r_longlong(  111 << 32 |   771):   245,
r_longlong(  111 << 32 |   776):   246,
r_longlong(  117 << 32 |   768):   249,
r_longlong(  117 << 32 |   769):   250,
r_longlong(  117 << 32 |   770):   251,
r_longlong(  117 << 32 |   776):   252,
r_longlong(  121 << 32 |   769):   253,
r_longlong(  121 << 32 |   776):   255,
r_longlong(   65 << 32 |   772):   256,
r_longlong(   97 << 32 |   772):   257,
r_longlong(   65 << 32 |   774):   258,
r_longlong(   97 << 32 |   774):   259,
r_longlong(   65 << 32 |   808):   260,
r_longlong(   97 << 32 |   808):   261,
r_longlong(   67 << 32 |   769):   262,
r_longlong(   99 << 32 |   769):   263,
r_longlong(   67 << 32 |   770):   264,
r_longlong(   99 << 32 |   770):   265,
r_longlong(   67 << 32 |   775):   266,
r_longlong(   99 << 32 |   775):   267,
r_longlong(   67 << 32 |   780):   268,
r_longlong(   99 << 32 |   780):   269,
r_longlong(   68 << 32 |   780):   270,
r_longlong(  100 << 32 |   780):   271,
r_longlong(   69 << 32 |   772):   274,
r_longlong(  101 << 32 |   772):   275,
r_longlong(   69 << 32 |   774):   276,
r_longlong(  101 << 32 |   774):   277,
r_longlong(   69 << 32 |   775):   278,
r_longlong(  101 << 32 |   775):   279,
r_longlong(   69 << 32 |   808):   280,
r_longlong(  101 << 32 |   808):   281,
r_longlong(   69 << 32 |   780):   282,
r_longlong(  101 << 32 |   780):   283,
r_longlong(   71 << 32 |   770):   284,
r_longlong(  103 << 32 |   770):   285,
r_longlong(   71 << 32 |   774):   286,
r_longlong(  103 << 32 |   774):   287,
r_longlong(   71 << 32 |   775):   288,
r_longlong(  103 << 32 |   775):   289,
r_longlong(   71 << 32 |   807):   290,
r_longlong(  103 << 32 |   807):   291,
r_longlong(   72 << 32 |   770):   292,
r_longlong(  104 << 32 |   770):   293,
r_longlong(   73 << 32 |   771):   296,
r_longlong(  105 << 32 |   771):   297,
r_longlong(   73 << 32 |   772):   298,
r_longlong(  105 << 32 |   772):   299,
r_longlong(   73 << 32 |   774):   300,
r_longlong(  105 << 32 |   774):   301,
r_longlong(   73 << 32 |   808):   302,
r_longlong(  105 << 32 |   808):   303,
r_longlong(   73 << 32 |   775):   304,
r_longlong(   74 << 32 |   770):   308,
r_longlong(  106 << 32 |   770):   309,
r_longlong(   75 << 32 |   807):   310,
r_longlong(  107 << 32 |   807):   311,
r_longlong(   76 << 32 |   769):   313,
r_longlong(  108 << 32 |   769):   314,
r_longlong(   76 << 32 |   807):   315,
r_longlong(  108 << 32 |   807):   316,
r_longlong(   76 << 32 |   780):   317,
r_longlong(  108 << 32 |   780):   318,
r_longlong(   78 << 32 |   769):   323,
r_longlong(  110 << 32 |   769):   324,
r_longlong(   78 << 32 |   807):   325,
r_longlong(  110 << 32 |   807):   326,
r_longlong(   78 << 32 |   780):   327,
r_longlong(  110 << 32 |   780):   328,
r_longlong(   79 << 32 |   772):   332,
r_longlong(  111 << 32 |   772):   333,
r_longlong(   79 << 32 |   774):   334,
r_longlong(  111 << 32 |   774):   335,
r_longlong(   79 << 32 |   779):   336,
r_longlong(  111 << 32 |   779):   337,
r_longlong(   82 << 32 |   769):   340,
r_longlong(  114 << 32 |   769):   341,
r_longlong(   82 << 32 |   807):   342,
r_longlong(  114 << 32 |   807):   343,
r_longlong(   82 << 32 |   780):   344,
r_longlong(  114 << 32 |   780):   345,
r_longlong(   83 << 32 |   769):   346,
r_longlong(  115 << 32 |   769):   347,
r_longlong(   83 << 32 |   770):   348,
r_longlong(  115 << 32 |   770):   349,
r_longlong(   83 << 32 |   807):   350,
r_longlong(  115 << 32 |   807):   351,
r_longlong(   83 << 32 |   780):   352,
r_longlong(  115 << 32 |   780):   353,
r_longlong(   84 << 32 |   807):   354,
r_longlong(  116 << 32 |   807):   355,
r_longlong(   84 << 32 |   780):   356,
r_longlong(  116 << 32 |   780):   357,
r_longlong(   85 << 32 |   771):   360,
r_longlong(  117 << 32 |   771):   361,
r_longlong(   85 << 32 |   772):   362,
r_longlong(  117 << 32 |   772):   363,
r_longlong(   85 << 32 |   774):   364,
r_longlong(  117 << 32 |   774):   365,
r_longlong(   85 << 32 |   778):   366,
r_longlong(  117 << 32 |   778):   367,
r_longlong(   85 << 32 |   779):   368,
r_longlong(  117 << 32 |   779):   369,
r_longlong(   85 << 32 |   808):   370,
r_longlong(  117 << 32 |   808):   371,
r_longlong(   87 << 32 |   770):   372,
r_longlong(  119 << 32 |   770):   373,
r_longlong(   89 << 32 |   770):   374,
r_longlong(  121 << 32 |   770):   375,
r_longlong(   89 << 32 |   776):   376,
r_longlong(   90 << 32 |   769):   377,
r_longlong(  122 << 32 |   769):   378,
r_longlong(   90 << 32 |   775):   379,
r_longlong(  122 << 32 |   775):   380,
r_longlong(   90 << 32 |   780):   381,
r_longlong(  122 << 32 |   780):   382,
r_longlong(   79 << 32 |   795):   416,
r_longlong(  111 << 32 |   795):   417,
r_longlong(   85 << 32 |   795):   431,
r_longlong(  117 << 32 |   795):   432,
r_longlong(   65 << 32 |   780):   461,
r_longlong(   97 << 32 |   780):   462,
r_longlong(   73 << 32 |   780):   463,
r_longlong(  105 << 32 |   780):   464,
r_longlong(   79 << 32 |   780):   465,
r_longlong(  111 << 32 |   780):   466,
r_longlong(   85 << 32 |   780):   467,
r_longlong(  117 << 32 |   780):   468,
r_longlong(  220 << 32 |   772):   469,
r_longlong(  252 << 32 |   772):   470,
r_longlong(  220 << 32 |   769):   471,
r_longlong(  252 << 32 |   769):   472,
r_longlong(  220 << 32 |   780):   473,
r_longlong(  252 << 32 |   780):   474,
r_longlong(  220 << 32 |   768):   475,
r_longlong(  252 << 32 |   768):   476,
r_longlong(  196 << 32 |   772):   478,
r_longlong(  228 << 32 |   772):   479,
r_longlong(  550 << 32 |   772):   480,
r_longlong(  551 << 32 |   772):   481,
r_longlong(  198 << 32 |   772):   482,
r_longlong(  230 << 32 |   772):   483,
r_longlong(   71 << 32 |   780):   486,
r_longlong(  103 << 32 |   780):   487,
r_longlong(   75 << 32 |   780):   488,
r_longlong(  107 << 32 |   780):   489,
r_longlong(   79 << 32 |   808):   490,
r_longlong(  111 << 32 |   808):   491,
r_longlong(  490 << 32 |   772):   492,
r_longlong(  491 << 32 |   772):   493,
r_longlong(  439 << 32 |   780):   494,
r_longlong(  658 << 32 |   780):   495,
r_longlong(  106 << 32 |   780):   496,
r_longlong(   71 << 32 |   769):   500,
r_longlong(  103 << 32 |   769):   501,
r_longlong(   78 << 32 |   768):   504,
r_longlong(  110 << 32 |   768):   505,
r_longlong(  197 << 32 |   769):   506,
r_longlong(  229 << 32 |   769):   507,
r_longlong(  198 << 32 |   769):   508,
r_longlong(  230 << 32 |   769):   509,
r_longlong(  216 << 32 |   769):   510,
r_longlong(  248 << 32 |   769):   511,
r_longlong(   65 << 32 |   783):   512,
r_longlong(   97 << 32 |   783):   513,
r_longlong(   65 << 32 |   785):   514,
r_longlong(   97 << 32 |   785):   515,
r_longlong(   69 << 32 |   783):   516,
r_longlong(  101 << 32 |   783):   517,
r_longlong(   69 << 32 |   785):   518,
r_longlong(  101 << 32 |   785):   519,
r_longlong(   73 << 32 |   783):   520,
r_longlong(  105 << 32 |   783):   521,
r_longlong(   73 << 32 |   785):   522,
r_longlong(  105 << 32 |   785):   523,
r_longlong(   79 << 32 |   783):   524,
r_longlong(  111 << 32 |   783):   525,
r_longlong(   79 << 32 |   785):   526,
r_longlong(  111 << 32 |   785):   527,
r_longlong(   82 << 32 |   783):   528,
r_longlong(  114 << 32 |   783):   529,
r_longlong(   82 << 32 |   785):   530,
r_longlong(  114 << 32 |   785):   531,
r_longlong(   85 << 32 |   783):   532,
r_longlong(  117 << 32 |   783):   533,
r_longlong(   85 << 32 |   785):   534,
r_longlong(  117 << 32 |   785):   535,
r_longlong(   83 << 32 |   806):   536,
r_longlong(  115 << 32 |   806):   537,
r_longlong(   84 << 32 |   806):   538,
r_longlong(  116 << 32 |   806):   539,
r_longlong(   72 << 32 |   780):   542,
r_longlong(  104 << 32 |   780):   543,
r_longlong(   65 << 32 |   775):   550,
r_longlong(   97 << 32 |   775):   551,
r_longlong(   69 << 32 |   807):   552,
r_longlong(  101 << 32 |   807):   553,
r_longlong(  214 << 32 |   772):   554,
r_longlong(  246 << 32 |   772):   555,
r_longlong(  213 << 32 |   772):   556,
r_longlong(  245 << 32 |   772):   557,
r_longlong(   79 << 32 |   775):   558,
r_longlong(  111 << 32 |   775):   559,
r_longlong(  558 << 32 |   772):   560,
r_longlong(  559 << 32 |   772):   561,
r_longlong(   89 << 32 |   772):   562,
r_longlong(  121 << 32 |   772):   563,
r_longlong(  168 << 32 |   769):   901,
r_longlong(  913 << 32 |   769):   902,
r_longlong(  917 << 32 |   769):   904,
r_longlong(  919 << 32 |   769):   905,
r_longlong(  921 << 32 |   769):   906,
r_longlong(  927 << 32 |   769):   908,
r_longlong(  933 << 32 |   769):   910,
r_longlong(  937 << 32 |   769):   911,
r_longlong(  970 << 32 |   769):   912,
r_longlong(  921 << 32 |   776):   938,
r_longlong(  933 << 32 |   776):   939,
r_longlong(  945 << 32 |   769):   940,
r_longlong(  949 << 32 |   769):   941,
r_longlong(  951 << 32 |   769):   942,
r_longlong(  953 << 32 |   769):   943,
r_longlong(  971 << 32 |   769):   944,
r_longlong(  953 << 32 |   776):   970,
r_longlong(  965 << 32 |   776):   971,
r_longlong(  959 << 32 |   769):   972,
r_longlong(  965 << 32 |   769):   973,
r_longlong(  969 << 32 |   769):   974,
r_longlong(  978 << 32 |   769):   979,
r_longlong(  978 << 32 |   776):   980,
r_longlong( 1045 << 32 |   768):  1024,
r_longlong( 1045 << 32 |   776):  1025,
r_longlong( 1043 << 32 |   769):  1027,
r_longlong( 1030 << 32 |   776):  1031,
r_longlong( 1050 << 32 |   769):  1036,
r_longlong( 1048 << 32 |   768):  1037,
r_longlong( 1059 << 32 |   774):  1038,
r_longlong( 1048 << 32 |   774):  1049,
r_longlong( 1080 << 32 |   774):  1081,
r_longlong( 1077 << 32 |   768):  1104,
r_longlong( 1077 << 32 |   776):  1105,
r_longlong( 1075 << 32 |   769):  1107,
r_longlong( 1110 << 32 |   776):  1111,
r_longlong( 1082 << 32 |   769):  1116,
r_longlong( 1080 << 32 |   768):  1117,
r_longlong( 1091 << 32 |   774):  1118,
r_longlong( 1140 << 32 |   783):  1142,
r_longlong( 1141 << 32 |   783):  1143,
r_longlong( 1046 << 32 |   774):  1217,
r_longlong( 1078 << 32 |   774):  1218,
r_longlong( 1040 << 32 |   774):  1232,
r_longlong( 1072 << 32 |   774):  1233,
r_longlong( 1040 << 32 |   776):  1234,
r_longlong( 1072 << 32 |   776):  1235,
r_longlong( 1045 << 32 |   774):  1238,
r_longlong( 1077 << 32 |   774):  1239,
r_longlong( 1240 << 32 |   776):  1242,
r_longlong( 1241 << 32 |   776):  1243,
r_longlong( 1046 << 32 |   776):  1244,
r_longlong( 1078 << 32 |   776):  1245,
r_longlong( 1047 << 32 |   776):  1246,
r_longlong( 1079 << 32 |   776):  1247,
r_longlong( 1048 << 32 |   772):  1250,
r_longlong( 1080 << 32 |   772):  1251,
r_longlong( 1048 << 32 |   776):  1252,
r_longlong( 1080 << 32 |   776):  1253,
r_longlong( 1054 << 32 |   776):  1254,
r_longlong( 1086 << 32 |   776):  1255,
r_longlong( 1256 << 32 |   776):  1258,
r_longlong( 1257 << 32 |   776):  1259,
r_longlong( 1069 << 32 |   776):  1260,
r_longlong( 1101 << 32 |   776):  1261,
r_longlong( 1059 << 32 |   772):  1262,
r_longlong( 1091 << 32 |   772):  1263,
r_longlong( 1059 << 32 |   776):  1264,
r_longlong( 1091 << 32 |   776):  1265,
r_longlong( 1059 << 32 |   779):  1266,
r_longlong( 1091 << 32 |   779):  1267,
r_longlong( 1063 << 32 |   776):  1268,
r_longlong( 1095 << 32 |   776):  1269,
r_longlong( 1067 << 32 |   776):  1272,
r_longlong( 1099 << 32 |   776):  1273,
r_longlong( 1575 << 32 |  1619):  1570,
r_longlong( 1575 << 32 |  1620):  1571,
r_longlong( 1608 << 32 |  1620):  1572,
r_longlong( 1575 << 32 |  1621):  1573,
r_longlong( 1610 << 32 |  1620):  1574,
r_longlong( 1749 << 32 |  1620):  1728,
r_longlong( 1729 << 32 |  1620):  1730,
r_longlong( 1746 << 32 |  1620):  1747,
r_longlong( 2344 << 32 |  2364):  2345,
r_longlong( 2352 << 32 |  2364):  2353,
r_longlong( 2355 << 32 |  2364):  2356,
r_longlong( 2503 << 32 |  2494):  2507,
r_longlong( 2503 << 32 |  2519):  2508,
r_longlong( 2887 << 32 |  2902):  2888,
r_longlong( 2887 << 32 |  2878):  2891,
r_longlong( 2887 << 32 |  2903):  2892,
r_longlong( 2962 << 32 |  3031):  2964,
r_longlong( 3014 << 32 |  3006):  3018,
r_longlong( 3015 << 32 |  3006):  3019,
r_longlong( 3014 << 32 |  3031):  3020,
r_longlong( 3142 << 32 |  3158):  3144,
r_longlong( 3263 << 32 |  3285):  3264,
r_longlong( 3270 << 32 |  3285):  3271,
r_longlong( 3270 << 32 |  3286):  3272,
r_longlong( 3270 << 32 |  3266):  3274,
r_longlong( 3274 << 32 |  3285):  3275,
r_longlong( 3398 << 32 |  3390):  3402,
r_longlong( 3399 << 32 |  3390):  3403,
r_longlong( 3398 << 32 |  3415):  3404,
r_longlong( 3545 << 32 |  3530):  3546,
r_longlong( 3545 << 32 |  3535):  3548,
r_longlong( 3548 << 32 |  3530):  3549,
r_longlong( 3545 << 32 |  3551):  3550,
r_longlong( 4133 << 32 |  4142):  4134,
r_longlong( 6917 << 32 |  6965):  6918,
r_longlong( 6919 << 32 |  6965):  6920,
r_longlong( 6921 << 32 |  6965):  6922,
r_longlong( 6923 << 32 |  6965):  6924,
r_longlong( 6925 << 32 |  6965):  6926,
r_longlong( 6929 << 32 |  6965):  6930,
r_longlong( 6970 << 32 |  6965):  6971,
r_longlong( 6972 << 32 |  6965):  6973,
r_longlong( 6974 << 32 |  6965):  6976,
r_longlong( 6975 << 32 |  6965):  6977,
r_longlong( 6978 << 32 |  6965):  6979,
r_longlong(   65 << 32 |   805):  7680,
r_longlong(   97 << 32 |   805):  7681,
r_longlong(   66 << 32 |   775):  7682,
r_longlong(   98 << 32 |   775):  7683,
r_longlong(   66 << 32 |   803):  7684,
r_longlong(   98 << 32 |   803):  7685,
r_longlong(   66 << 32 |   817):  7686,
r_longlong(   98 << 32 |   817):  7687,
r_longlong(  199 << 32 |   769):  7688,
r_longlong(  231 << 32 |   769):  7689,
r_longlong(   68 << 32 |   775):  7690,
r_longlong(  100 << 32 |   775):  7691,
r_longlong(   68 << 32 |   803):  7692,
r_longlong(  100 << 32 |   803):  7693,
r_longlong(   68 << 32 |   817):  7694,
r_longlong(  100 << 32 |   817):  7695,
r_longlong(   68 << 32 |   807):  7696,
r_longlong(  100 << 32 |   807):  7697,
r_longlong(   68 << 32 |   813):  7698,
r_longlong(  100 << 32 |   813):  7699,
r_longlong(  274 << 32 |   768):  7700,
r_longlong(  275 << 32 |   768):  7701,
r_longlong(  274 << 32 |   769):  7702,
r_longlong(  275 << 32 |   769):  7703,
r_longlong(   69 << 32 |   813):  7704,
r_longlong(  101 << 32 |   813):  7705,
r_longlong(   69 << 32 |   816):  7706,
r_longlong(  101 << 32 |   816):  7707,
r_longlong(  552 << 32 |   774):  7708,
r_longlong(  553 << 32 |   774):  7709,
r_longlong(   70 << 32 |   775):  7710,
r_longlong(  102 << 32 |   775):  7711,
r_longlong(   71 << 32 |   772):  7712,
r_longlong(  103 << 32 |   772):  7713,
r_longlong(   72 << 32 |   775):  7714,
r_longlong(  104 << 32 |   775):  7715,
r_longlong(   72 << 32 |   803):  7716,
r_longlong(  104 << 32 |   803):  7717,
r_longlong(   72 << 32 |   776):  7718,
r_longlong(  104 << 32 |   776):  7719,
r_longlong(   72 << 32 |   807):  7720,
r_longlong(  104 << 32 |   807):  7721,
r_longlong(   72 << 32 |   814):  7722,
r_longlong(  104 << 32 |   814):  7723,
r_longlong(   73 << 32 |   816):  7724,
r_longlong(  105 << 32 |   816):  7725,
r_longlong(  207 << 32 |   769):  7726,
r_longlong(  239 << 32 |   769):  7727,
r_longlong(   75 << 32 |   769):  7728,
r_longlong(  107 << 32 |   769):  7729,
r_longlong(   75 << 32 |   803):  7730,
r_longlong(  107 << 32 |   803):  7731,
r_longlong(   75 << 32 |   817):  7732,
r_longlong(  107 << 32 |   817):  7733,
r_longlong(   76 << 32 |   803):  7734,
r_longlong(  108 << 32 |   803):  7735,
r_longlong( 7734 << 32 |   772):  7736,
r_longlong( 7735 << 32 |   772):  7737,
r_longlong(   76 << 32 |   817):  7738,
r_longlong(  108 << 32 |   817):  7739,
r_longlong(   76 << 32 |   813):  7740,
r_longlong(  108 << 32 |   813):  7741,
r_longlong(   77 << 32 |   769):  7742,
r_longlong(  109 << 32 |   769):  7743,
r_longlong(   77 << 32 |   775):  7744,
r_longlong(  109 << 32 |   775):  7745,
r_longlong(   77 << 32 |   803):  7746,
r_longlong(  109 << 32 |   803):  7747,
r_longlong(   78 << 32 |   775):  7748,
r_longlong(  110 << 32 |   775):  7749,
r_longlong(   78 << 32 |   803):  7750,
r_longlong(  110 << 32 |   803):  7751,
r_longlong(   78 << 32 |   817):  7752,
r_longlong(  110 << 32 |   817):  7753,
r_longlong(   78 << 32 |   813):  7754,
r_longlong(  110 << 32 |   813):  7755,
r_longlong(  213 << 32 |   769):  7756,
r_longlong(  245 << 32 |   769):  7757,
r_longlong(  213 << 32 |   776):  7758,
r_longlong(  245 << 32 |   776):  7759,
r_longlong(  332 << 32 |   768):  7760,
r_longlong(  333 << 32 |   768):  7761,
r_longlong(  332 << 32 |   769):  7762,
r_longlong(  333 << 32 |   769):  7763,
r_longlong(   80 << 32 |   769):  7764,
r_longlong(  112 << 32 |   769):  7765,
r_longlong(   80 << 32 |   775):  7766,
r_longlong(  112 << 32 |   775):  7767,
r_longlong(   82 << 32 |   775):  7768,
r_longlong(  114 << 32 |   775):  7769,
r_longlong(   82 << 32 |   803):  7770,
r_longlong(  114 << 32 |   803):  7771,
r_longlong( 7770 << 32 |   772):  7772,
r_longlong( 7771 << 32 |   772):  7773,
r_longlong(   82 << 32 |   817):  7774,
r_longlong(  114 << 32 |   817):  7775,
r_longlong(   83 << 32 |   775):  7776,
r_longlong(  115 << 32 |   775):  7777,
r_longlong(   83 << 32 |   803):  7778,
r_longlong(  115 << 32 |   803):  7779,
r_longlong(  346 << 32 |   775):  7780,
r_longlong(  347 << 32 |   775):  7781,
r_longlong(  352 << 32 |   775):  7782,
r_longlong(  353 << 32 |   775):  7783,
r_longlong( 7778 << 32 |   775):  7784,
r_longlong( 7779 << 32 |   775):  7785,
r_longlong(   84 << 32 |   775):  7786,
r_longlong(  116 << 32 |   775):  7787,
r_longlong(   84 << 32 |   803):  7788,
r_longlong(  116 << 32 |   803):  7789,
r_longlong(   84 << 32 |   817):  7790,
r_longlong(  116 << 32 |   817):  7791,
r_longlong(   84 << 32 |   813):  7792,
r_longlong(  116 << 32 |   813):  7793,
r_longlong(   85 << 32 |   804):  7794,
r_longlong(  117 << 32 |   804):  7795,
r_longlong(   85 << 32 |   816):  7796,
r_longlong(  117 << 32 |   816):  7797,
r_longlong(   85 << 32 |   813):  7798,
r_longlong(  117 << 32 |   813):  7799,
r_longlong(  360 << 32 |   769):  7800,
r_longlong(  361 << 32 |   769):  7801,
r_longlong(  362 << 32 |   776):  7802,
r_longlong(  363 << 32 |   776):  7803,
r_longlong(   86 << 32 |   771):  7804,
r_longlong(  118 << 32 |   771):  7805,
r_longlong(   86 << 32 |   803):  7806,
r_longlong(  118 << 32 |   803):  7807,
r_longlong(   87 << 32 |   768):  7808,
r_longlong(  119 << 32 |   768):  7809,
r_longlong(   87 << 32 |   769):  7810,
r_longlong(  119 << 32 |   769):  7811,
r_longlong(   87 << 32 |   776):  7812,
r_longlong(  119 << 32 |   776):  7813,
r_longlong(   87 << 32 |   775):  7814,
r_longlong(  119 << 32 |   775):  7815,
r_longlong(   87 << 32 |   803):  7816,
r_longlong(  119 << 32 |   803):  7817,
r_longlong(   88 << 32 |   775):  7818,
r_longlong(  120 << 32 |   775):  7819,
r_longlong(   88 << 32 |   776):  7820,
r_longlong(  120 << 32 |   776):  7821,
r_longlong(   89 << 32 |   775):  7822,
r_longlong(  121 << 32 |   775):  7823,
r_longlong(   90 << 32 |   770):  7824,
r_longlong(  122 << 32 |   770):  7825,
r_longlong(   90 << 32 |   803):  7826,
r_longlong(  122 << 32 |   803):  7827,
r_longlong(   90 << 32 |   817):  7828,
r_longlong(  122 << 32 |   817):  7829,
r_longlong(  104 << 32 |   817):  7830,
r_longlong(  116 << 32 |   776):  7831,
r_longlong(  119 << 32 |   778):  7832,
r_longlong(  121 << 32 |   778):  7833,
r_longlong(  383 << 32 |   775):  7835,
r_longlong(   65 << 32 |   803):  7840,
r_longlong(   97 << 32 |   803):  7841,
r_longlong(   65 << 32 |   777):  7842,
r_longlong(   97 << 32 |   777):  7843,
r_longlong(  194 << 32 |   769):  7844,
r_longlong(  226 << 32 |   769):  7845,
r_longlong(  194 << 32 |   768):  7846,
r_longlong(  226 << 32 |   768):  7847,
r_longlong(  194 << 32 |   777):  7848,
r_longlong(  226 << 32 |   777):  7849,
r_longlong(  194 << 32 |   771):  7850,
r_longlong(  226 << 32 |   771):  7851,
r_longlong( 7840 << 32 |   770):  7852,
r_longlong( 7841 << 32 |   770):  7853,
r_longlong(  258 << 32 |   769):  7854,
r_longlong(  259 << 32 |   769):  7855,
r_longlong(  258 << 32 |   768):  7856,
r_longlong(  259 << 32 |   768):  7857,
r_longlong(  258 << 32 |   777):  7858,
r_longlong(  259 << 32 |   777):  7859,
r_longlong(  258 << 32 |   771):  7860,
r_longlong(  259 << 32 |   771):  7861,
r_longlong( 7840 << 32 |   774):  7862,
r_longlong( 7841 << 32 |   774):  7863,
r_longlong(   69 << 32 |   803):  7864,
r_longlong(  101 << 32 |   803):  7865,
r_longlong(   69 << 32 |   777):  7866,
r_longlong(  101 << 32 |   777):  7867,
r_longlong(   69 << 32 |   771):  7868,
r_longlong(  101 << 32 |   771):  7869,
r_longlong(  202 << 32 |   769):  7870,
r_longlong(  234 << 32 |   769):  7871,
r_longlong(  202 << 32 |   768):  7872,
r_longlong(  234 << 32 |   768):  7873,
r_longlong(  202 << 32 |   777):  7874,
r_longlong(  234 << 32 |   777):  7875,
r_longlong(  202 << 32 |   771):  7876,
r_longlong(  234 << 32 |   771):  7877,
r_longlong( 7864 << 32 |   770):  7878,
r_longlong( 7865 << 32 |   770):  7879,
r_longlong(   73 << 32 |   777):  7880,
r_longlong(  105 << 32 |   777):  7881,
r_longlong(   73 << 32 |   803):  7882,
r_longlong(  105 << 32 |   803):  7883,
r_longlong(   79 << 32 |   803):  7884,
r_longlong(  111 << 32 |   803):  7885,
r_longlong(   79 << 32 |   777):  7886,
r_longlong(  111 << 32 |   777):  7887,
r_longlong(  212 << 32 |   769):  7888,
r_longlong(  244 << 32 |   769):  7889,
r_longlong(  212 << 32 |   768):  7890,
r_longlong(  244 << 32 |   768):  7891,
r_longlong(  212 << 32 |   777):  7892,
r_longlong(  244 << 32 |   777):  7893,
r_longlong(  212 << 32 |   771):  7894,
r_longlong(  244 << 32 |   771):  7895,
r_longlong( 7884 << 32 |   770):  7896,
r_longlong( 7885 << 32 |   770):  7897,
r_longlong(  416 << 32 |   769):  7898,
r_longlong(  417 << 32 |   769):  7899,
r_longlong(  416 << 32 |   768):  7900,
r_longlong(  417 << 32 |   768):  7901,
r_longlong(  416 << 32 |   777):  7902,
r_longlong(  417 << 32 |   777):  7903,
r_longlong(  416 << 32 |   771):  7904,
r_longlong(  417 << 32 |   771):  7905,
r_longlong(  416 << 32 |   803):  7906,
r_longlong(  417 << 32 |   803):  7907,
r_longlong(   85 << 32 |   803):  7908,
r_longlong(  117 << 32 |   803):  7909,
r_longlong(   85 << 32 |   777):  7910,
r_longlong(  117 << 32 |   777):  7911,
r_longlong(  431 << 32 |   769):  7912,
r_longlong(  432 << 32 |   769):  7913,
r_longlong(  431 << 32 |   768):  7914,
r_longlong(  432 << 32 |   768):  7915,
r_longlong(  431 << 32 |   777):  7916,
r_longlong(  432 << 32 |   777):  7917,
r_longlong(  431 << 32 |   771):  7918,
r_longlong(  432 << 32 |   771):  7919,
r_longlong(  431 << 32 |   803):  7920,
r_longlong(  432 << 32 |   803):  7921,
r_longlong(   89 << 32 |   768):  7922,
r_longlong(  121 << 32 |   768):  7923,
r_longlong(   89 << 32 |   803):  7924,
r_longlong(  121 << 32 |   803):  7925,
r_longlong(   89 << 32 |   777):  7926,
r_longlong(  121 << 32 |   777):  7927,
r_longlong(   89 << 32 |   771):  7928,
r_longlong(  121 << 32 |   771):  7929,
r_longlong(  945 << 32 |   787):  7936,
r_longlong(  945 << 32 |   788):  7937,
r_longlong( 7936 << 32 |   768):  7938,
r_longlong( 7937 << 32 |   768):  7939,
r_longlong( 7936 << 32 |   769):  7940,
r_longlong( 7937 << 32 |   769):  7941,
r_longlong( 7936 << 32 |   834):  7942,
r_longlong( 7937 << 32 |   834):  7943,
r_longlong(  913 << 32 |   787):  7944,
r_longlong(  913 << 32 |   788):  7945,
r_longlong( 7944 << 32 |   768):  7946,
r_longlong( 7945 << 32 |   768):  7947,
r_longlong( 7944 << 32 |   769):  7948,
r_longlong( 7945 << 32 |   769):  7949,
r_longlong( 7944 << 32 |   834):  7950,
r_longlong( 7945 << 32 |   834):  7951,
r_longlong(  949 << 32 |   787):  7952,
r_longlong(  949 << 32 |   788):  7953,
r_longlong( 7952 << 32 |   768):  7954,
r_longlong( 7953 << 32 |   768):  7955,
r_longlong( 7952 << 32 |   769):  7956,
r_longlong( 7953 << 32 |   769):  7957,
r_longlong(  917 << 32 |   787):  7960,
r_longlong(  917 << 32 |   788):  7961,
r_longlong( 7960 << 32 |   768):  7962,
r_longlong( 7961 << 32 |   768):  7963,
r_longlong( 7960 << 32 |   769):  7964,
r_longlong( 7961 << 32 |   769):  7965,
r_longlong(  951 << 32 |   787):  7968,
r_longlong(  951 << 32 |   788):  7969,
r_longlong( 7968 << 32 |   768):  7970,
r_longlong( 7969 << 32 |   768):  7971,
r_longlong( 7968 << 32 |   769):  7972,
r_longlong( 7969 << 32 |   769):  7973,
r_longlong( 7968 << 32 |   834):  7974,
r_longlong( 7969 << 32 |   834):  7975,
r_longlong(  919 << 32 |   787):  7976,
r_longlong(  919 << 32 |   788):  7977,
r_longlong( 7976 << 32 |   768):  7978,
r_longlong( 7977 << 32 |   768):  7979,
r_longlong( 7976 << 32 |   769):  7980,
r_longlong( 7977 << 32 |   769):  7981,
r_longlong( 7976 << 32 |   834):  7982,
r_longlong( 7977 << 32 |   834):  7983,
r_longlong(  953 << 32 |   787):  7984,
r_longlong(  953 << 32 |   788):  7985,
r_longlong( 7984 << 32 |   768):  7986,
r_longlong( 7985 << 32 |   768):  7987,
r_longlong( 7984 << 32 |   769):  7988,
r_longlong( 7985 << 32 |   769):  7989,
r_longlong( 7984 << 32 |   834):  7990,
r_longlong( 7985 << 32 |   834):  7991,
r_longlong(  921 << 32 |   787):  7992,
r_longlong(  921 << 32 |   788):  7993,
r_longlong( 7992 << 32 |   768):  7994,
r_longlong( 7993 << 32 |   768):  7995,
r_longlong( 7992 << 32 |   769):  7996,
r_longlong( 7993 << 32 |   769):  7997,
r_longlong( 7992 << 32 |   834):  7998,
r_longlong( 7993 << 32 |   834):  7999,
r_longlong(  959 << 32 |   787):  8000,
r_longlong(  959 << 32 |   788):  8001,
r_longlong( 8000 << 32 |   768):  8002,
r_longlong( 8001 << 32 |   768):  8003,
r_longlong( 8000 << 32 |   769):  8004,
r_longlong( 8001 << 32 |   769):  8005,
r_longlong(  927 << 32 |   787):  8008,
r_longlong(  927 << 32 |   788):  8009,
r_longlong( 8008 << 32 |   768):  8010,
r_longlong( 8009 << 32 |   768):  8011,
r_longlong( 8008 << 32 |   769):  8012,
r_longlong( 8009 << 32 |   769):  8013,
r_longlong(  965 << 32 |   787):  8016,
r_longlong(  965 << 32 |   788):  8017,
r_longlong( 8016 << 32 |   768):  8018,
r_longlong( 8017 << 32 |   768):  8019,
r_longlong( 8016 << 32 |   769):  8020,
r_longlong( 8017 << 32 |   769):  8021,
r_longlong( 8016 << 32 |   834):  8022,
r_longlong( 8017 << 32 |   834):  8023,
r_longlong(  933 << 32 |   788):  8025,
r_longlong( 8025 << 32 |   768):  8027,
r_longlong( 8025 << 32 |   769):  8029,
r_longlong( 8025 << 32 |   834):  8031,
r_longlong(  969 << 32 |   787):  8032,
r_longlong(  969 << 32 |   788):  8033,
r_longlong( 8032 << 32 |   768):  8034,
r_longlong( 8033 << 32 |   768):  8035,
r_longlong( 8032 << 32 |   769):  8036,
r_longlong( 8033 << 32 |   769):  8037,
r_longlong( 8032 << 32 |   834):  8038,
r_longlong( 8033 << 32 |   834):  8039,
r_longlong(  937 << 32 |   787):  8040,
r_longlong(  937 << 32 |   788):  8041,
r_longlong( 8040 << 32 |   768):  8042,
r_longlong( 8041 << 32 |   768):  8043,
r_longlong( 8040 << 32 |   769):  8044,
r_longlong( 8041 << 32 |   769):  8045,
r_longlong( 8040 << 32 |   834):  8046,
r_longlong( 8041 << 32 |   834):  8047,
r_longlong(  945 << 32 |   768):  8048,
r_longlong(  949 << 32 |   768):  8050,
r_longlong(  951 << 32 |   768):  8052,
r_longlong(  953 << 32 |   768):  8054,
r_longlong(  959 << 32 |   768):  8056,
r_longlong(  965 << 32 |   768):  8058,
r_longlong(  969 << 32 |   768):  8060,
r_longlong( 7936 << 32 |   837):  8064,
r_longlong( 7937 << 32 |   837):  8065,
r_longlong( 7938 << 32 |   837):  8066,
r_longlong( 7939 << 32 |   837):  8067,
r_longlong( 7940 << 32 |   837):  8068,
r_longlong( 7941 << 32 |   837):  8069,
r_longlong( 7942 << 32 |   837):  8070,
r_longlong( 7943 << 32 |   837):  8071,
r_longlong( 7944 << 32 |   837):  8072,
r_longlong( 7945 << 32 |   837):  8073,
r_longlong( 7946 << 32 |   837):  8074,
r_longlong( 7947 << 32 |   837):  8075,
r_longlong( 7948 << 32 |   837):  8076,
r_longlong( 7949 << 32 |   837):  8077,
r_longlong( 7950 << 32 |   837):  8078,
r_longlong( 7951 << 32 |   837):  8079,
r_longlong( 7968 << 32 |   837):  8080,
r_longlong( 7969 << 32 |   837):  8081,
r_longlong( 7970 << 32 |   837):  8082,
r_longlong( 7971 << 32 |   837):  8083,
r_longlong( 7972 << 32 |   837):  8084,
r_longlong( 7973 << 32 |   837):  8085,
r_longlong( 7974 << 32 |   837):  8086,
r_longlong( 7975 << 32 |   837):  8087,
r_longlong( 7976 << 32 |   837):  8088,
r_longlong( 7977 << 32 |   837):  8089,
r_longlong( 7978 << 32 |   837):  8090,
r_longlong( 7979 << 32 |   837):  8091,
r_longlong( 7980 << 32 |   837):  8092,
r_longlong( 7981 << 32 |   837):  8093,
r_longlong( 7982 << 32 |   837):  8094,
r_longlong( 7983 << 32 |   837):  8095,
r_longlong( 8032 << 32 |   837):  8096,
r_longlong( 8033 << 32 |   837):  8097,
r_longlong( 8034 << 32 |   837):  8098,
r_longlong( 8035 << 32 |   837):  8099,
r_longlong( 8036 << 32 |   837):  8100,
r_longlong( 8037 << 32 |   837):  8101,
r_longlong( 8038 << 32 |   837):  8102,
r_longlong( 8039 << 32 |   837):  8103,
r_longlong( 8040 << 32 |   837):  8104,
r_longlong( 8041 << 32 |   837):  8105,
r_longlong( 8042 << 32 |   837):  8106,
r_longlong( 8043 << 32 |   837):  8107,
r_longlong( 8044 << 32 |   837):  8108,
r_longlong( 8045 << 32 |   837):  8109,
r_longlong( 8046 << 32 |   837):  8110,
r_longlong( 8047 << 32 |   837):  8111,
r_longlong(  945 << 32 |   774):  8112,
r_longlong(  945 << 32 |   772):  8113,
r_longlong( 8048 << 32 |   837):  8114,
r_longlong(  945 << 32 |   837):  8115,
r_longlong(  940 << 32 |   837):  8116,
r_longlong(  945 << 32 |   834):  8118,
r_longlong( 8118 << 32 |   837):  8119,
r_longlong(  913 << 32 |   774):  8120,
r_longlong(  913 << 32 |   772):  8121,
r_longlong(  913 << 32 |   768):  8122,
r_longlong(  913 << 32 |   837):  8124,
r_longlong(  168 << 32 |   834):  8129,
r_longlong( 8052 << 32 |   837):  8130,
r_longlong(  951 << 32 |   837):  8131,
r_longlong(  942 << 32 |   837):  8132,
r_longlong(  951 << 32 |   834):  8134,
r_longlong( 8134 << 32 |   837):  8135,
r_longlong(  917 << 32 |   768):  8136,
r_longlong(  919 << 32 |   768):  8138,
r_longlong(  919 << 32 |   837):  8140,
r_longlong( 8127 << 32 |   768):  8141,
r_longlong( 8127 << 32 |   769):  8142,
r_longlong( 8127 << 32 |   834):  8143,
r_longlong(  953 << 32 |   774):  8144,
r_longlong(  953 << 32 |   772):  8145,
r_longlong(  970 << 32 |   768):  8146,
r_longlong(  953 << 32 |   834):  8150,
r_longlong(  970 << 32 |   834):  8151,
r_longlong(  921 << 32 |   774):  8152,
r_longlong(  921 << 32 |   772):  8153,
r_longlong(  921 << 32 |   768):  8154,
r_longlong( 8190 << 32 |   768):  8157,
r_longlong( 8190 << 32 |   769):  8158,
r_longlong( 8190 << 32 |   834):  8159,
r_longlong(  965 << 32 |   774):  8160,
r_longlong(  965 << 32 |   772):  8161,
r_longlong(  971 << 32 |   768):  8162,
r_longlong(  961 << 32 |   787):  8164,
r_longlong(  961 << 32 |   788):  8165,
r_longlong(  965 << 32 |   834):  8166,
r_longlong(  971 << 32 |   834):  8167,
r_longlong(  933 << 32 |   774):  8168,
r_longlong(  933 << 32 |   772):  8169,
r_longlong(  933 << 32 |   768):  8170,
r_longlong(  929 << 32 |   788):  8172,
r_longlong(  168 << 32 |   768):  8173,
r_longlong( 8060 << 32 |   837):  8178,
r_longlong(  969 << 32 |   837):  8179,
r_longlong(  974 << 32 |   837):  8180,
r_longlong(  969 << 32 |   834):  8182,
r_longlong( 8182 << 32 |   837):  8183,
r_longlong(  927 << 32 |   768):  8184,
r_longlong(  937 << 32 |   768):  8186,
r_longlong(  937 << 32 |   837):  8188,
r_longlong( 8592 << 32 |   824):  8602,
r_longlong( 8594 << 32 |   824):  8603,
r_longlong( 8596 << 32 |   824):  8622,
r_longlong( 8656 << 32 |   824):  8653,
r_longlong( 8660 << 32 |   824):  8654,
r_longlong( 8658 << 32 |   824):  8655,
r_longlong( 8707 << 32 |   824):  8708,
r_longlong( 8712 << 32 |   824):  8713,
r_longlong( 8715 << 32 |   824):  8716,
r_longlong( 8739 << 32 |   824):  8740,
r_longlong( 8741 << 32 |   824):  8742,
r_longlong( 8764 << 32 |   824):  8769,
r_longlong( 8771 << 32 |   824):  8772,
r_longlong( 8773 << 32 |   824):  8775,
r_longlong( 8776 << 32 |   824):  8777,
r_longlong(   61 << 32 |   824):  8800,
r_longlong( 8801 << 32 |   824):  8802,
r_longlong( 8781 << 32 |   824):  8813,
r_longlong(   60 << 32 |   824):  8814,
r_longlong(   62 << 32 |   824):  8815,
r_longlong( 8804 << 32 |   824):  8816,
r_longlong( 8805 << 32 |   824):  8817,
r_longlong( 8818 << 32 |   824):  8820,
r_longlong( 8819 << 32 |   824):  8821,
r_longlong( 8822 << 32 |   824):  8824,
r_longlong( 8823 << 32 |   824):  8825,
r_longlong( 8826 << 32 |   824):  8832,
r_longlong( 8827 << 32 |   824):  8833,
r_longlong( 8834 << 32 |   824):  8836,
r_longlong( 8835 << 32 |   824):  8837,
r_longlong( 8838 << 32 |   824):  8840,
r_longlong( 8839 << 32 |   824):  8841,
r_longlong( 8866 << 32 |   824):  8876,
r_longlong( 8872 << 32 |   824):  8877,
r_longlong( 8873 << 32 |   824):  8878,
r_longlong( 8875 << 32 |   824):  8879,
r_longlong( 8828 << 32 |   824):  8928,
r_longlong( 8829 << 32 |   824):  8929,
r_longlong( 8849 << 32 |   824):  8930,
r_longlong( 8850 << 32 |   824):  8931,
r_longlong( 8882 << 32 |   824):  8938,
r_longlong( 8883 << 32 |   824):  8939,
r_longlong( 8884 << 32 |   824):  8940,
r_longlong( 8885 << 32 |   824):  8941,
r_longlong(12363 << 32 | 12441): 12364,
r_longlong(12365 << 32 | 12441): 12366,
r_longlong(12367 << 32 | 12441): 12368,
r_longlong(12369 << 32 | 12441): 12370,
r_longlong(12371 << 32 | 12441): 12372,
r_longlong(12373 << 32 | 12441): 12374,
r_longlong(12375 << 32 | 12441): 12376,
r_longlong(12377 << 32 | 12441): 12378,
r_longlong(12379 << 32 | 12441): 12380,
r_longlong(12381 << 32 | 12441): 12382,
r_longlong(12383 << 32 | 12441): 12384,
r_longlong(12385 << 32 | 12441): 12386,
r_longlong(12388 << 32 | 12441): 12389,
r_longlong(12390 << 32 | 12441): 12391,
r_longlong(12392 << 32 | 12441): 12393,
r_longlong(12399 << 32 | 12441): 12400,
r_longlong(12399 << 32 | 12442): 12401,
r_longlong(12402 << 32 | 12441): 12403,
r_longlong(12402 << 32 | 12442): 12404,
r_longlong(12405 << 32 | 12441): 12406,
r_longlong(12405 << 32 | 12442): 12407,
r_longlong(12408 << 32 | 12441): 12409,
r_longlong(12408 << 32 | 12442): 12410,
r_longlong(12411 << 32 | 12441): 12412,
r_longlong(12411 << 32 | 12442): 12413,
r_longlong(12358 << 32 | 12441): 12436,
r_longlong(12445 << 32 | 12441): 12446,
r_longlong(12459 << 32 | 12441): 12460,
r_longlong(12461 << 32 | 12441): 12462,
r_longlong(12463 << 32 | 12441): 12464,
r_longlong(12465 << 32 | 12441): 12466,
r_longlong(12467 << 32 | 12441): 12468,
r_longlong(12469 << 32 | 12441): 12470,
r_longlong(12471 << 32 | 12441): 12472,
r_longlong(12473 << 32 | 12441): 12474,
r_longlong(12475 << 32 | 12441): 12476,
r_longlong(12477 << 32 | 12441): 12478,
r_longlong(12479 << 32 | 12441): 12480,
r_longlong(12481 << 32 | 12441): 12482,
r_longlong(12484 << 32 | 12441): 12485,
r_longlong(12486 << 32 | 12441): 12487,
r_longlong(12488 << 32 | 12441): 12489,
r_longlong(12495 << 32 | 12441): 12496,
r_longlong(12495 << 32 | 12442): 12497,
r_longlong(12498 << 32 | 12441): 12499,
r_longlong(12498 << 32 | 12442): 12500,
r_longlong(12501 << 32 | 12441): 12502,
r_longlong(12501 << 32 | 12442): 12503,
r_longlong(12504 << 32 | 12441): 12505,
r_longlong(12504 << 32 | 12442): 12506,
r_longlong(12507 << 32 | 12441): 12508,
r_longlong(12507 << 32 | 12442): 12509,
r_longlong(12454 << 32 | 12441): 12532,
r_longlong(12527 << 32 | 12441): 12535,
r_longlong(12528 << 32 | 12441): 12536,
r_longlong(12529 << 32 | 12441): 12537,
r_longlong(12530 << 32 | 12441): 12538,
r_longlong(12541 << 32 | 12441): 12542,
r_longlong(69785 << 32 | 69818): 69786,
r_longlong(69787 << 32 | 69818): 69788,
r_longlong(69797 << 32 | 69818): 69803,
}

_canon_decomposition = {
192: [65, 768],
193: [65, 769],
194: [65, 770],
195: [65, 771],
196: [65, 776],
197: [65, 778],
199: [67, 807],
200: [69, 768],
201: [69, 769],
202: [69, 770],
203: [69, 776],
204: [73, 768],
205: [73, 769],
206: [73, 770],
207: [73, 776],
209: [78, 771],
210: [79, 768],
211: [79, 769],
212: [79, 770],
213: [79, 771],
214: [79, 776],
217: [85, 768],
218: [85, 769],
219: [85, 770],
220: [85, 776],
221: [89, 769],
224: [97, 768],
225: [97, 769],
226: [97, 770],
227: [97, 771],
228: [97, 776],
229: [97, 778],
231: [99, 807],
232: [101, 768],
233: [101, 769],
234: [101, 770],
235: [101, 776],
236: [105, 768],
237: [105, 769],
238: [105, 770],
239: [105, 776],
241: [110, 771],
242: [111, 768],
243: [111, 769],
244: [111, 770],
245: [111, 771],
246: [111, 776],
249: [117, 768],
250: [117, 769],
251: [117, 770],
252: [117, 776],
253: [121, 769],
255: [121, 776],
256: [65, 772],
257: [97, 772],
258: [65, 774],
259: [97, 774],
260: [65, 808],
261: [97, 808],
262: [67, 769],
263: [99, 769],
264: [67, 770],
265: [99, 770],
266: [67, 775],
267: [99, 775],
268: [67, 780],
269: [99, 780],
270: [68, 780],
271: [100, 780],
274: [69, 772],
275: [101, 772],
276: [69, 774],
277: [101, 774],
278: [69, 775],
279: [101, 775],
280: [69, 808],
281: [101, 808],
282: [69, 780],
283: [101, 780],
284: [71, 770],
285: [103, 770],
286: [71, 774],
287: [103, 774],
288: [71, 775],
289: [103, 775],
290: [71, 807],
291: [103, 807],
292: [72, 770],
293: [104, 770],
296: [73, 771],
297: [105, 771],
298: [73, 772],
299: [105, 772],
300: [73, 774],
301: [105, 774],
302: [73, 808],
303: [105, 808],
304: [73, 775],
308: [74, 770],
309: [106, 770],
310: [75, 807],
311: [107, 807],
313: [76, 769],
314: [108, 769],
315: [76, 807],
316: [108, 807],
317: [76, 780],
318: [108, 780],
323: [78, 769],
324: [110, 769],
325: [78, 807],
326: [110, 807],
327: [78, 780],
328: [110, 780],
332: [79, 772],
333: [111, 772],
334: [79, 774],
335: [111, 774],
336: [79, 779],
337: [111, 779],
340: [82, 769],
341: [114, 769],
342: [82, 807],
343: [114, 807],
344: [82, 780],
345: [114, 780],
346: [83, 769],
347: [115, 769],
348: [83, 770],
349: [115, 770],
350: [83, 807],
351: [115, 807],
352: [83, 780],
353: [115, 780],
354: [84, 807],
355: [116, 807],
356: [84, 780],
357: [116, 780],
360: [85, 771],
361: [117, 771],
362: [85, 772],
363: [117, 772],
364: [85, 774],
365: [117, 774],
366: [85, 778],
367: [117, 778],
368: [85, 779],
369: [117, 779],
370: [85, 808],
371: [117, 808],
372: [87, 770],
373: [119, 770],
374: [89, 770],
375: [121, 770],
376: [89, 776],
377: [90, 769],
378: [122, 769],
379: [90, 775],
380: [122, 775],
381: [90, 780],
382: [122, 780],
416: [79, 795],
417: [111, 795],
431: [85, 795],
432: [117, 795],
461: [65, 780],
462: [97, 780],
463: [73, 780],
464: [105, 780],
465: [79, 780],
466: [111, 780],
467: [85, 780],
468: [117, 780],
469: [85, 776, 772],
470: [117, 776, 772],
471: [85, 776, 769],
472: [117, 776, 769],
473: [85, 776, 780],
474: [117, 776, 780],
475: [85, 776, 768],
476: [117, 776, 768],
478: [65, 776, 772],
479: [97, 776, 772],
480: [65, 775, 772],
481: [97, 775, 772],
482: [198, 772],
483: [230, 772],
486: [71, 780],
487: [103, 780],
488: [75, 780],
489: [107, 780],
490: [79, 808],
491: [111, 808],
492: [79, 808, 772],
493: [111, 808, 772],
494: [439, 780],
495: [658, 780],
496: [106, 780],
500: [71, 769],
501: [103, 769],
504: [78, 768],
505: [110, 768],
506: [65, 778, 769],
507: [97, 778, 769],
508: [198, 769],
509: [230, 769],
510: [216, 769],
511: [248, 769],
512: [65, 783],
513: [97, 783],
514: [65, 785],
515: [97, 785],
516: [69, 783],
517: [101, 783],
518: [69, 785],
519: [101, 785],
520: [73, 783],
521: [105, 783],
522: [73, 785],
523: [105, 785],
524: [79, 783],
525: [111, 783],
526: [79, 785],
527: [111, 785],
528: [82, 783],
529: [114, 783],
530: [82, 785],
531: [114, 785],
532: [85, 783],
533: [117, 783],
534: [85, 785],
535: [117, 785],
536: [83, 806],
537: [115, 806],
538: [84, 806],
539: [116, 806],
542: [72, 780],
543: [104, 780],
550: [65, 775],
551: [97, 775],
552: [69, 807],
553: [101, 807],
554: [79, 776, 772],
555: [111, 776, 772],
556: [79, 771, 772],
557: [111, 771, 772],
558: [79, 775],
559: [111, 775],
560: [79, 775, 772],
561: [111, 775, 772],
562: [89, 772],
563: [121, 772],
832: [768],
833: [769],
835: [787],
836: [776, 769],
884: [697],
894: [59],
901: [168, 769],
902: [913, 769],
903: [183],
904: [917, 769],
905: [919, 769],
906: [921, 769],
908: [927, 769],
910: [933, 769],
911: [937, 769],
912: [953, 776, 769],
938: [921, 776],
939: [933, 776],
940: [945, 769],
941: [949, 769],
942: [951, 769],
943: [953, 769],
944: [965, 776, 769],
970: [953, 776],
971: [965, 776],
972: [959, 769],
973: [965, 769],
974: [969, 769],
979: [978, 769],
980: [978, 776],
1024: [1045, 768],
1025: [1045, 776],
1027: [1043, 769],
1031: [1030, 776],
1036: [1050, 769],
1037: [1048, 768],
1038: [1059, 774],
1049: [1048, 774],
1081: [1080, 774],
1104: [1077, 768],
1105: [1077, 776],
1107: [1075, 769],
1111: [1110, 776],
1116: [1082, 769],
1117: [1080, 768],
1118: [1091, 774],
1142: [1140, 783],
1143: [1141, 783],
1217: [1046, 774],
1218: [1078, 774],
1232: [1040, 774],
1233: [1072, 774],
1234: [1040, 776],
1235: [1072, 776],
1238: [1045, 774],
1239: [1077, 774],
1242: [1240, 776],
1243: [1241, 776],
1244: [1046, 776],
1245: [1078, 776],
1246: [1047, 776],
1247: [1079, 776],
1250: [1048, 772],
1251: [1080, 772],
1252: [1048, 776],
1253: [1080, 776],
1254: [1054, 776],
1255: [1086, 776],
1258: [1256, 776],
1259: [1257, 776],
1260: [1069, 776],
1261: [1101, 776],
1262: [1059, 772],
1263: [1091, 772],
1264: [1059, 776],
1265: [1091, 776],
1266: [1059, 779],
1267: [1091, 779],
1268: [1063, 776],
1269: [1095, 776],
1272: [1067, 776],
1273: [1099, 776],
1570: [1575, 1619],
1571: [1575, 1620],
1572: [1608, 1620],
1573: [1575, 1621],
1574: [1610, 1620],
1728: [1749, 1620],
1730: [1729, 1620],
1747: [1746, 1620],
2345: [2344, 2364],
2353: [2352, 2364],
2356: [2355, 2364],
2392: [2325, 2364],
2393: [2326, 2364],
2394: [2327, 2364],
2395: [2332, 2364],
2396: [2337, 2364],
2397: [2338, 2364],
2398: [2347, 2364],
2399: [2351, 2364],
2507: [2503, 2494],
2508: [2503, 2519],
2524: [2465, 2492],
2525: [2466, 2492],
2527: [2479, 2492],
2611: [2610, 2620],
2614: [2616, 2620],
2649: [2582, 2620],
2650: [2583, 2620],
2651: [2588, 2620],
2654: [2603, 2620],
2888: [2887, 2902],
2891: [2887, 2878],
2892: [2887, 2903],
2908: [2849, 2876],
2909: [2850, 2876],
2964: [2962, 3031],
3018: [3014, 3006],
3019: [3015, 3006],
3020: [3014, 3031],
3144: [3142, 3158],
3264: [3263, 3285],
3271: [3270, 3285],
3272: [3270, 3286],
3274: [3270, 3266],
3275: [3270, 3266, 3285],
3402: [3398, 3390],
3403: [3399, 3390],
3404: [3398, 3415],
3546: [3545, 3530],
3548: [3545, 3535],
3549: [3545, 3535, 3530],
3550: [3545, 3551],
3907: [3906, 4023],
3917: [3916, 4023],
3922: [3921, 4023],
3927: [3926, 4023],
3932: [3931, 4023],
3945: [3904, 4021],
3955: [3953, 3954],
3957: [3953, 3956],
3958: [4018, 3968],
3960: [4019, 3968],
3969: [3953, 3968],
3987: [3986, 4023],
3997: [3996, 4023],
4002: [4001, 4023],
4007: [4006, 4023],
4012: [4011, 4023],
4025: [3984, 4021],
4134: [4133, 4142],
6918: [6917, 6965],
6920: [6919, 6965],
6922: [6921, 6965],
6924: [6923, 6965],
6926: [6925, 6965],
6930: [6929, 6965],
6971: [6970, 6965],
6973: [6972, 6965],
6976: [6974, 6965],
6977: [6975, 6965],
6979: [6978, 6965],
7680: [65, 805],
7681: [97, 805],
7682: [66, 775],
7683: [98, 775],
7684: [66, 803],
7685: [98, 803],
7686: [66, 817],
7687: [98, 817],
7688: [67, 807, 769],
7689: [99, 807, 769],
7690: [68, 775],
7691: [100, 775],
7692: [68, 803],
7693: [100, 803],
7694: [68, 817],
7695: [100, 817],
7696: [68, 807],
7697: [100, 807],
7698: [68, 813],
7699: [100, 813],
7700: [69, 772, 768],
7701: [101, 772, 768],
7702: [69, 772, 769],
7703: [101, 772, 769],
7704: [69, 813],
7705: [101, 813],
7706: [69, 816],
7707: [101, 816],
7708: [69, 807, 774],
7709: [101, 807, 774],
7710: [70, 775],
7711: [102, 775],
7712: [71, 772],
7713: [103, 772],
7714: [72, 775],
7715: [104, 775],
7716: [72, 803],
7717: [104, 803],
7718: [72, 776],
7719: [104, 776],
7720: [72, 807],
7721: [104, 807],
7722: [72, 814],
7723: [104, 814],
7724: [73, 816],
7725: [105, 816],
7726: [73, 776, 769],
7727: [105, 776, 769],
7728: [75, 769],
7729: [107, 769],
7730: [75, 803],
7731: [107, 803],
7732: [75, 817],
7733: [107, 817],
7734: [76, 803],
7735: [108, 803],
7736: [76, 803, 772],
7737: [108, 803, 772],
7738: [76, 817],
7739: [108, 817],
7740: [76, 813],
7741: [108, 813],
7742: [77, 769],
7743: [109, 769],
7744: [77, 775],
7745: [109, 775],
7746: [77, 803],
7747: [109, 803],
7748: [78, 775],
7749: [110, 775],
7750: [78, 803],
7751: [110, 803],
7752: [78, 817],
7753: [110, 817],
7754: [78, 813],
7755: [110, 813],
7756: [79, 771, 769],
7757: [111, 771, 769],
7758: [79, 771, 776],
7759: [111, 771, 776],
7760: [79, 772, 768],
7761: [111, 772, 768],
7762: [79, 772, 769],
7763: [111, 772, 769],
7764: [80, 769],
7765: [112, 769],
7766: [80, 775],
7767: [112, 775],
7768: [82, 775],
7769: [114, 775],
7770: [82, 803],
7771: [114, 803],
7772: [82, 803, 772],
7773: [114, 803, 772],
7774: [82, 817],
7775: [114, 817],
7776: [83, 775],
7777: [115, 775],
7778: [83, 803],
7779: [115, 803],
7780: [83, 769, 775],
7781: [115, 769, 775],
7782: [83, 780, 775],
7783: [115, 780, 775],
7784: [83, 803, 775],
7785: [115, 803, 775],
7786: [84, 775],
7787: [116, 775],
7788: [84, 803],
7789: [116, 803],
7790: [84, 817],
7791: [116, 817],
7792: [84, 813],
7793: [116, 813],
7794: [85, 804],
7795: [117, 804],
7796: [85, 816],
7797: [117, 816],
7798: [85, 813],
7799: [117, 813],
7800: [85, 771, 769],
7801: [117, 771, 769],
7802: [85, 772, 776],
7803: [117, 772, 776],
7804: [86, 771],
7805: [118, 771],
7806: [86, 803],
7807: [118, 803],
7808: [87, 768],
7809: [119, 768],
7810: [87, 769],
7811: [119, 769],
7812: [87, 776],
7813: [119, 776],
7814: [87, 775],
7815: [119, 775],
7816: [87, 803],
7817: [119, 803],
7818: [88, 775],
7819: [120, 775],
7820: [88, 776],
7821: [120, 776],
7822: [89, 775],
7823: [121, 775],
7824: [90, 770],
7825: [122, 770],
7826: [90, 803],
7827: [122, 803],
7828: [90, 817],
7829: [122, 817],
7830: [104, 817],
7831: [116, 776],
7832: [119, 778],
7833: [121, 778],
7835: [383, 775],
7840: [65, 803],
7841: [97, 803],
7842: [65, 777],
7843: [97, 777],
7844: [65, 770, 769],
7845: [97, 770, 769],
7846: [65, 770, 768],
7847: [97, 770, 768],
7848: [65, 770, 777],
7849: [97, 770, 777],
7850: [65, 770, 771],
7851: [97, 770, 771],
7852: [65, 803, 770],
7853: [97, 803, 770],
7854: [65, 774, 769],
7855: [97, 774, 769],
7856: [65, 774, 768],
7857: [97, 774, 768],
7858: [65, 774, 777],
7859: [97, 774, 777],
7860: [65, 774, 771],
7861: [97, 774, 771],
7862: [65, 803, 774],
7863: [97, 803, 774],
7864: [69, 803],
7865: [101, 803],
7866: [69, 777],
7867: [101, 777],
7868: [69, 771],
7869: [101, 771],
7870: [69, 770, 769],
7871: [101, 770, 769],
7872: [69, 770, 768],
7873: [101, 770, 768],
7874: [69, 770, 777],
7875: [101, 770, 777],
7876: [69, 770, 771],
7877: [101, 770, 771],
7878: [69, 803, 770],
7879: [101, 803, 770],
7880: [73, 777],
7881: [105, 777],
7882: [73, 803],
7883: [105, 803],
7884: [79, 803],
7885: [111, 803],
7886: [79, 777],
7887: [111, 777],
7888: [79, 770, 769],
7889: [111, 770, 769],
7890: [79, 770, 768],
7891: [111, 770, 768],
7892: [79, 770, 777],
7893: [111, 770, 777],
7894: [79, 770, 771],
7895: [111, 770, 771],
7896: [79, 803, 770],
7897: [111, 803, 770],
7898: [79, 795, 769],
7899: [111, 795, 769],
7900: [79, 795, 768],
7901: [111, 795, 768],
7902: [79, 795, 777],
7903: [111, 795, 777],
7904: [79, 795, 771],
7905: [111, 795, 771],
7906: [79, 795, 803],
7907: [111, 795, 803],
7908: [85, 803],
7909: [117, 803],
7910: [85, 777],
7911: [117, 777],
7912: [85, 795, 769],
7913: [117, 795, 769],
7914: [85, 795, 768],
7915: [117, 795, 768],
7916: [85, 795, 777],
7917: [117, 795, 777],
7918: [85, 795, 771],
7919: [117, 795, 771],
7920: [85, 795, 803],
7921: [117, 795, 803],
7922: [89, 768],
7923: [121, 768],
7924: [89, 803],
7925: [121, 803],
7926: [89, 777],
7927: [121, 777],
7928: [89, 771],
7929: [121, 771],
7936: [945, 787],
7937: [945, 788],
7938: [945, 787, 768],
7939: [945, 788, 768],
7940: [945, 787, 769],
7941: [945, 788, 769],
7942: [945, 787, 834],
7943: [945, 788, 834],
7944: [913, 787],
7945: [913, 788],
7946: [913, 787, 768],
7947: [913, 788, 768],
7948: [913, 787, 769],
7949: [913, 788, 769],
7950: [913, 787, 834],
7951: [913, 788, 834],
7952: [949, 787],
7953: [949, 788],
7954: [949, 787, 768],
7955: [949, 788, 768],
7956: [949, 787, 769],
7957: [949, 788, 769],
7960: [917, 787],
7961: [917, 788],
7962: [917, 787, 768],
7963: [917, 788, 768],
7964: [917, 787, 769],
7965: [917, 788, 769],
7968: [951, 787],
7969: [951, 788],
7970: [951, 787, 768],
7971: [951, 788, 768],
7972: [951, 787, 769],
7973: [951, 788, 769],
7974: [951, 787, 834],
7975: [951, 788, 834],
7976: [919, 787],
7977: [919, 788],
7978: [919, 787, 768],
7979: [919, 788, 768],
7980: [919, 787, 769],
7981: [919, 788, 769],
7982: [919, 787, 834],
7983: [919, 788, 834],
7984: [953, 787],
7985: [953, 788],
7986: [953, 787, 768],
7987: [953, 788, 768],
7988: [953, 787, 769],
7989: [953, 788, 769],
7990: [953, 787, 834],
7991: [953, 788, 834],
7992: [921, 787],
7993: [921, 788],
7994: [921, 787, 768],
7995: [921, 788, 768],
7996: [921, 787, 769],
7997: [921, 788, 769],
7998: [921, 787, 834],
7999: [921, 788, 834],
8000: [959, 787],
8001: [959, 788],
8002: [959, 787, 768],
8003: [959, 788, 768],
8004: [959, 787, 769],
8005: [959, 788, 769],
8008: [927, 787],
8009: [927, 788],
8010: [927, 787, 768],
8011: [927, 788, 768],
8012: [927, 787, 769],
8013: [927, 788, 769],
8016: [965, 787],
8017: [965, 788],
8018: [965, 787, 768],
8019: [965, 788, 768],
8020: [965, 787, 769],
8021: [965, 788, 769],
8022: [965, 787, 834],
8023: [965, 788, 834],
8025: [933, 788],
8027: [933, 788, 768],
8029: [933, 788, 769],
8031: [933, 788, 834],
8032: [969, 787],
8033: [969, 788],
8034: [969, 787, 768],
8035: [969, 788, 768],
8036: [969, 787, 769],
8037: [969, 788, 769],
8038: [969, 787, 834],
8039: [969, 788, 834],
8040: [937, 787],
8041: [937, 788],
8042: [937, 787, 768],
8043: [937, 788, 768],
8044: [937, 787, 769],
8045: [937, 788, 769],
8046: [937, 787, 834],
8047: [937, 788, 834],
8048: [945, 768],
8049: [945, 769],
8050: [949, 768],
8051: [949, 769],
8052: [951, 768],
8053: [951, 769],
8054: [953, 768],
8055: [953, 769],
8056: [959, 768],
8057: [959, 769],
8058: [965, 768],
8059: [965, 769],
8060: [969, 768],
8061: [969, 769],
8064: [945, 787, 837],
8065: [945, 788, 837],
8066: [945, 787, 768, 837],
8067: [945, 788, 768, 837],
8068: [945, 787, 769, 837],
8069: [945, 788, 769, 837],
8070: [945, 787, 834, 837],
8071: [945, 788, 834, 837],
8072: [913, 787, 837],
8073: [913, 788, 837],
8074: [913, 787, 768, 837],
8075: [913, 788, 768, 837],
8076: [913, 787, 769, 837],
8077: [913, 788, 769, 837],
8078: [913, 787, 834, 837],
8079: [913, 788, 834, 837],
8080: [951, 787, 837],
8081: [951, 788, 837],
8082: [951, 787, 768, 837],
8083: [951, 788, 768, 837],
8084: [951, 787, 769, 837],
8085: [951, 788, 769, 837],
8086: [951, 787, 834, 837],
8087: [951, 788, 834, 837],
8088: [919, 787, 837],
8089: [919, 788, 837],
8090: [919, 787, 768, 837],
8091: [919, 788, 768, 837],
8092: [919, 787, 769, 837],
8093: [919, 788, 769, 837],
8094: [919, 787, 834, 837],
8095: [919, 788, 834, 837],
8096: [969, 787, 837],
8097: [969, 788, 837],
8098: [969, 787, 768, 837],
8099: [969, 788, 768, 837],
8100: [969, 787, 769, 837],
8101: [969, 788, 769, 837],
8102: [969, 787, 834, 837],
8103: [969, 788, 834, 837],
8104: [937, 787, 837],
8105: [937, 788, 837],
8106: [937, 787, 768, 837],
8107: [937, 788, 768, 837],
8108: [937, 787, 769, 837],
8109: [937, 788, 769, 837],
8110: [937, 787, 834, 837],
8111: [937, 788, 834, 837],
8112: [945, 774],
8113: [945, 772],
8114: [945, 768, 837],
8115: [945, 837],
8116: [945, 769, 837],
8118: [945, 834],
8119: [945, 834, 837],
8120: [913, 774],
8121: [913, 772],
8122: [913, 768],
8123: [913, 769],
8124: [913, 837],
8126: [953],
8129: [168, 834],
8130: [951, 768, 837],
8131: [951, 837],
8132: [951, 769, 837],
8134: [951, 834],
8135: [951, 834, 837],
8136: [917, 768],
8137: [917, 769],
8138: [919, 768],
8139: [919, 769],
8140: [919, 837],
8141: [8127, 768],
8142: [8127, 769],
8143: [8127, 834],
8144: [953, 774],
8145: [953, 772],
8146: [953, 776, 768],
8147: [953, 776, 769],
8150: [953, 834],
8151: [953, 776, 834],
8152: [921, 774],
8153: [921, 772],
8154: [921, 768],
8155: [921, 769],
8157: [8190, 768],
8158: [8190, 769],
8159: [8190, 834],
8160: [965, 774],
8161: [965, 772],
8162: [965, 776, 768],
8163: [965, 776, 769],
8164: [961, 787],
8165: [961, 788],
8166: [965, 834],
8167: [965, 776, 834],
8168: [933, 774],
8169: [933, 772],
8170: [933, 768],
8171: [933, 769],
8172: [929, 788],
8173: [168, 768],
8174: [168, 769],
8175: [96],
8178: [969, 768, 837],
8179: [969, 837],
8180: [969, 769, 837],
8182: [969, 834],
8183: [969, 834, 837],
8184: [927, 768],
8185: [927, 769],
8186: [937, 768],
8187: [937, 769],
8188: [937, 837],
8189: [180],
8192: [8194],
8193: [8195],
8486: [937],
8490: [75],
8491: [65, 778],
8602: [8592, 824],
8603: [8594, 824],
8622: [8596, 824],
8653: [8656, 824],
8654: [8660, 824],
8655: [8658, 824],
8708: [8707, 824],
8713: [8712, 824],
8716: [8715, 824],
8740: [8739, 824],
8742: [8741, 824],
8769: [8764, 824],
8772: [8771, 824],
8775: [8773, 824],
8777: [8776, 824],
8800: [61, 824],
8802: [8801, 824],
8813: [8781, 824],
8814: [60, 824],
8815: [62, 824],
8816: [8804, 824],
8817: [8805, 824],
8820: [8818, 824],
8821: [8819, 824],
8824: [8822, 824],
8825: [8823, 824],
8832: [8826, 824],
8833: [8827, 824],
8836: [8834, 824],
8837: [8835, 824],
8840: [8838, 824],
8841: [8839, 824],
8876: [8866, 824],
8877: [8872, 824],
8878: [8873, 824],
8879: [8875, 824],
8928: [8828, 824],
8929: [8829, 824],
8930: [8849, 824],
8931: [8850, 824],
8938: [8882, 824],
8939: [8883, 824],
8940: [8884, 824],
8941: [8885, 824],
9001: [12296],
9002: [12297],
10972: [10973, 824],
12364: [12363, 12441],
12366: [12365, 12441],
12368: [12367, 12441],
12370: [12369, 12441],
12372: [12371, 12441],
12374: [12373, 12441],
12376: [12375, 12441],
12378: [12377, 12441],
12380: [12379, 12441],
12382: [12381, 12441],
12384: [12383, 12441],
12386: [12385, 12441],
12389: [12388, 12441],
12391: [12390, 12441],
12393: [12392, 12441],
12400: [12399, 12441],
12401: [12399, 12442],
12403: [12402, 12441],
12404: [12402, 12442],
12406: [12405, 12441],
12407: [12405, 12442],
12409: [12408, 12441],
12410: [12408, 12442],
12412: [12411, 12441],
12413: [12411, 12442],
12436: [12358, 12441],
12446: [12445, 12441],
12460: [12459, 12441],
12462: [12461, 12441],
12464: [12463, 12441],
12466: [12465, 12441],
12468: [12467, 12441],
12470: [12469, 12441],
12472: [12471, 12441],
12474: [12473, 12441],
12476: [12475, 12441],
12478: [12477, 12441],
12480: [12479, 12441],
12482: [12481, 12441],
12485: [12484, 12441],
12487: [12486, 12441],
12489: [12488, 12441],
12496: [12495, 12441],
12497: [12495, 12442],
12499: [12498, 12441],
12500: [12498, 12442],
12502: [12501, 12441],
12503: [12501, 12442],
12505: [12504, 12441],
12506: [12504, 12442],
12508: [12507, 12441],
12509: [12507, 12442],
12532: [12454, 12441],
12535: [12527, 12441],
12536: [12528, 12441],
12537: [12529, 12441],
12538: [12530, 12441],
12542: [12541, 12441],
63744: [35912],
63745: [26356],
63746: [36554],
63747: [36040],
63748: [28369],
63749: [20018],
63750: [21477],
63751: [40860],
63752: [40860],
63753: [22865],
63754: [37329],
63755: [21895],
63756: [22856],
63757: [25078],
63758: [30313],
63759: [32645],
63760: [34367],
63761: [34746],
63762: [35064],
63763: [37007],
63764: [27138],
63765: [27931],
63766: [28889],
63767: [29662],
63768: [33853],
63769: [37226],
63770: [39409],
63771: [20098],
63772: [21365],
63773: [27396],
63774: [29211],
63775: [34349],
63776: [40478],
63777: [23888],
63778: [28651],
63779: [34253],
63780: [35172],
63781: [25289],
63782: [33240],
63783: [34847],
63784: [24266],
63785: [26391],
63786: [28010],
63787: [29436],
63788: [37070],
63789: [20358],
63790: [20919],
63791: [21214],
63792: [25796],
63793: [27347],
63794: [29200],
63795: [30439],
63796: [32769],
63797: [34310],
63798: [34396],
63799: [36335],
63800: [38706],
63801: [39791],
63802: [40442],
63803: [30860],
63804: [31103],
63805: [32160],
63806: [33737],
63807: [37636],
63808: [40575],
63809: [35542],
63810: [22751],
63811: [24324],
63812: [31840],
63813: [32894],
63814: [29282],
63815: [30922],
63816: [36034],
63817: [38647],
63818: [22744],
63819: [23650],
63820: [27155],
63821: [28122],
63822: [28431],
63823: [32047],
63824: [32311],
63825: [38475],
63826: [21202],
63827: [32907],
63828: [20956],
63829: [20940],
63830: [31260],
63831: [32190],
63832: [33777],
63833: [38517],
63834: [35712],
63835: [25295],
63836: [27138],
63837: [35582],
63838: [20025],
63839: [23527],
63840: [24594],
63841: [29575],
63842: [30064],
63843: [21271],
63844: [30971],
63845: [20415],
63846: [24489],
63847: [19981],
63848: [27852],
63849: [25976],
63850: [32034],
63851: [21443],
63852: [22622],
63853: [30465],
63854: [33865],
63855: [35498],
63856: [27578],
63857: [36784],
63858: [27784],
63859: [25342],
63860: [33509],
63861: [25504],
63862: [30053],
63863: [20142],
63864: [20841],
63865: [20937],
63866: [26753],
63867: [31975],
63868: [33391],
63869: [35538],
63870: [37327],
63871: [21237],
63872: [21570],
63873: [22899],
63874: [24300],
63875: [26053],
63876: [28670],
63877: [31018],
63878: [38317],
63879: [39530],
63880: [40599],
63881: [40654],
63882: [21147],
63883: [26310],
63884: [27511],
63885: [36706],
63886: [24180],
63887: [24976],
63888: [25088],
63889: [25754],
63890: [28451],
63891: [29001],
63892: [29833],
63893: [31178],
63894: [32244],
63895: [32879],
63896: [36646],
63897: [34030],
63898: [36899],
63899: [37706],
63900: [21015],
63901: [21155],
63902: [21693],
63903: [28872],
63904: [35010],
63905: [35498],
63906: [24265],
63907: [24565],
63908: [25467],
63909: [27566],
63910: [31806],
63911: [29557],
63912: [20196],
63913: [22265],
63914: [23527],
63915: [23994],
63916: [24604],
63917: [29618],
63918: [29801],
63919: [32666],
63920: [32838],
63921: [37428],
63922: [38646],
63923: [38728],
63924: [38936],
63925: [20363],
63926: [31150],
63927: [37300],
63928: [38584],
63929: [24801],
63930: [20102],
63931: [20698],
63932: [23534],
63933: [23615],
63934: [26009],
63935: [27138],
63936: [29134],
63937: [30274],
63938: [34044],
63939: [36988],
63940: [40845],
63941: [26248],
63942: [38446],
63943: [21129],
63944: [26491],
63945: [26611],
63946: [27969],
63947: [28316],
63948: [29705],
63949: [30041],
63950: [30827],
63951: [32016],
63952: [39006],
63953: [20845],
63954: [25134],
63955: [38520],
63956: [20523],
63957: [23833],
63958: [28138],
63959: [36650],
63960: [24459],
63961: [24900],
63962: [26647],
63963: [29575],
63964: [38534],
63965: [21033],
63966: [21519],
63967: [23653],
63968: [26131],
63969: [26446],
63970: [26792],
63971: [27877],
63972: [29702],
63973: [30178],
63974: [32633],
63975: [35023],
63976: [35041],
63977: [37324],
63978: [38626],
63979: [21311],
63980: [28346],
63981: [21533],
63982: [29136],
63983: [29848],
63984: [34298],
63985: [38563],
63986: [40023],
63987: [40607],
63988: [26519],
63989: [28107],
63990: [33256],
63991: [31435],
63992: [31520],
63993: [31890],
63994: [29376],
63995: [28825],
63996: [35672],
63997: [20160],
63998: [33590],
63999: [21050],
64000: [20999],
64001: [24230],
64002: [25299],
64003: [31958],
64004: [23429],
64005: [27934],
64006: [26292],
64007: [36667],
64008: [34892],
64009: [38477],
64010: [35211],
64011: [24275],
64012: [20800],
64013: [21952],
64016: [22618],
64018: [26228],
64021: [20958],
64022: [29482],
64023: [30410],
64024: [31036],
64025: [31070],
64026: [31077],
64027: [31119],
64028: [38742],
64029: [31934],
64030: [32701],
64032: [34322],
64034: [35576],
64037: [36920],
64038: [37117],
64042: [39151],
64043: [39164],
64044: [39208],
64045: [40372],
64048: [20398],
64049: [20711],
64050: [20813],
64051: [21193],
64052: [21220],
64053: [21329],
64054: [21917],
64055: [22022],
64056: [22120],
64057: [22592],
64058: [22696],
64059: [23652],
64060: [23662],
64061: [24724],
64062: [24936],
64063: [24974],
64064: [25074],
64065: [25935],
64066: [26082],
64067: [26257],
64068: [26757],
64069: [28023],
64070: [28186],
64071: [28450],
64072: [29038],
64073: [29227],
64074: [29730],
64075: [30865],
64076: [31038],
64077: [31049],
64078: [31048],
64079: [31056],
64080: [31062],
64081: [31069],
64082: [31117],
64083: [31118],
64084: [31296],
64085: [31361],
64086: [31680],
64087: [32244],
64088: [32265],
64089: [32321],
64090: [32626],
64091: [32773],
64092: [33261],
64093: [33401],
64094: [33401],
64095: [33879],
64096: [35088],
64097: [35222],
64098: [35585],
64099: [35641],
64100: [36051],
64101: [36104],
64102: [36790],
64103: [36920],
64104: [38627],
64105: [38911],
64106: [38971],
64107: [24693],
64108: [148206],
64109: [33304],
64112: [20006],
64113: [20917],
64114: [20840],
64115: [20352],
64116: [20805],
64117: [20864],
64118: [21191],
64119: [21242],
64120: [21917],
64121: [21845],
64122: [21913],
64123: [21986],
64124: [22618],
64125: [22707],
64126: [22852],
64127: [22868],
64128: [23138],
64129: [23336],
64130: [24274],
64131: [24281],
64132: [24425],
64133: [24493],
64134: [24792],
64135: [24910],
64136: [24840],
64137: [24974],
64138: [24928],
64139: [25074],
64140: [25140],
64141: [25540],
64142: [25628],
64143: [25682],
64144: [25942],
64145: [26228],
64146: [26391],
64147: [26395],
64148: [26454],
64149: [27513],
64150: [27578],
64151: [27969],
64152: [28379],
64153: [28363],
64154: [28450],
64155: [28702],
64156: [29038],
64157: [30631],
64158: [29237],
64159: [29359],
64160: [29482],
64161: [29809],
64162: [29958],
64163: [30011],
64164: [30237],
64165: [30239],
64166: [30410],
64167: [30427],
64168: [30452],
64169: [30538],
64170: [30528],
64171: [30924],
64172: [31409],
64173: [31680],
64174: [31867],
64175: [32091],
64176: [32244],
64177: [32574],
64178: [32773],
64179: [33618],
64180: [33775],
64181: [34681],
64182: [35137],
64183: [35206],
64184: [35222],
64185: [35519],
64186: [35576],
64187: [35531],
64188: [35585],
64189: [35582],
64190: [35565],
64191: [35641],
64192: [35722],
64193: [36104],
64194: [36664],
64195: [36978],
64196: [37273],
64197: [37494],
64198: [38524],
64199: [38627],
64200: [38742],
64201: [38875],
64202: [38911],
64203: [38923],
64204: [38971],
64205: [39698],
64206: [40860],
64207: [141386],
64208: [141380],
64209: [144341],
64210: [15261],
64211: [16408],
64212: [16441],
64213: [152137],
64214: [154832],
64215: [163539],
64216: [40771],
64217: [40846],
64285: [1497, 1460],
64287: [1522, 1463],
64298: [1513, 1473],
64299: [1513, 1474],
64300: [1513, 1468, 1473],
64301: [1513, 1468, 1474],
64302: [1488, 1463],
64303: [1488, 1464],
64304: [1488, 1468],
64305: [1489, 1468],
64306: [1490, 1468],
64307: [1491, 1468],
64308: [1492, 1468],
64309: [1493, 1468],
64310: [1494, 1468],
64312: [1496, 1468],
64313: [1497, 1468],
64314: [1498, 1468],
64315: [1499, 1468],
64316: [1500, 1468],
64318: [1502, 1468],
64320: [1504, 1468],
64321: [1505, 1468],
64323: [1507, 1468],
64324: [1508, 1468],
64326: [1510, 1468],
64327: [1511, 1468],
64328: [1512, 1468],
64329: [1513, 1468],
64330: [1514, 1468],
64331: [1493, 1465],
64332: [1489, 1471],
64333: [1499, 1471],
64334: [1508, 1471],
69786: [69785, 69818],
69788: [69787, 69818],
69803: [69797, 69818],
119134: [119127, 119141],
119135: [119128, 119141],
119136: [119128, 119141, 119150],
119137: [119128, 119141, 119151],
119138: [119128, 119141, 119152],
119139: [119128, 119141, 119153],
119140: [119128, 119141, 119154],
119227: [119225, 119141],
119228: [119226, 119141],
119229: [119225, 119141, 119150],
119230: [119226, 119141, 119150],
119231: [119225, 119141, 119151],
119232: [119226, 119141, 119151],
194560: [20029],
194561: [20024],
194562: [20033],
194563: [131362],
194564: [20320],
194565: [20398],
194566: [20411],
194567: [20482],
194568: [20602],
194569: [20633],
194570: [20711],
194571: [20687],
194572: [13470],
194573: [132666],
194574: [20813],
194575: [20820],
194576: [20836],
194577: [20855],
194578: [132380],
194579: [13497],
194580: [20839],
194581: [20877],
194582: [132427],
194583: [20887],
194584: [20900],
194585: [20172],
194586: [20908],
194587: [20917],
194588: [168415],
194589: [20981],
194590: [20995],
194591: [13535],
194592: [21051],
194593: [21062],
194594: [21106],
194595: [21111],
194596: [13589],
194597: [21191],
194598: [21193],
194599: [21220],
194600: [21242],
194601: [21253],
194602: [21254],
194603: [21271],
194604: [21321],
194605: [21329],
194606: [21338],
194607: [21363],
194608: [21373],
194609: [21375],
194610: [21375],
194611: [21375],
194612: [133676],
194613: [28784],
194614: [21450],
194615: [21471],
194616: [133987],
194617: [21483],
194618: [21489],
194619: [21510],
194620: [21662],
194621: [21560],
194622: [21576],
194623: [21608],
194624: [21666],
194625: [21750],
194626: [21776],
194627: [21843],
194628: [21859],
194629: [21892],
194630: [21892],
194631: [21913],
194632: [21931],
194633: [21939],
194634: [21954],
194635: [22294],
194636: [22022],
194637: [22295],
194638: [22097],
194639: [22132],
194640: [20999],
194641: [22766],
194642: [22478],
194643: [22516],
194644: [22541],
194645: [22411],
194646: [22578],
194647: [22577],
194648: [22700],
194649: [136420],
194650: [22770],
194651: [22775],
194652: [22790],
194653: [22810],
194654: [22818],
194655: [22882],
194656: [136872],
194657: [136938],
194658: [23020],
194659: [23067],
194660: [23079],
194661: [23000],
194662: [23142],
194663: [14062],
194664: [14076],
194665: [23304],
194666: [23358],
194667: [23358],
194668: [137672],
194669: [23491],
194670: [23512],
194671: [23527],
194672: [23539],
194673: [138008],
194674: [23551],
194675: [23558],
194676: [24403],
194677: [23586],
194678: [14209],
194679: [23648],
194680: [23662],
194681: [23744],
194682: [23693],
194683: [138724],
194684: [23875],
194685: [138726],
194686: [23918],
194687: [23915],
194688: [23932],
194689: [24033],
194690: [24034],
194691: [14383],
194692: [24061],
194693: [24104],
194694: [24125],
194695: [24169],
194696: [14434],
194697: [139651],
194698: [14460],
194699: [24240],
194700: [24243],
194701: [24246],
194702: [24266],
194703: [172946],
194704: [24318],
194705: [140081],
194706: [140081],
194707: [33281],
194708: [24354],
194709: [24354],
194710: [14535],
194711: [144056],
194712: [156122],
194713: [24418],
194714: [24427],
194715: [14563],
194716: [24474],
194717: [24525],
194718: [24535],
194719: [24569],
194720: [24705],
194721: [14650],
194722: [14620],
194723: [24724],
194724: [141012],
194725: [24775],
194726: [24904],
194727: [24908],
194728: [24910],
194729: [24908],
194730: [24954],
194731: [24974],
194732: [25010],
194733: [24996],
194734: [25007],
194735: [25054],
194736: [25074],
194737: [25078],
194738: [25104],
194739: [25115],
194740: [25181],
194741: [25265],
194742: [25300],
194743: [25424],
194744: [142092],
194745: [25405],
194746: [25340],
194747: [25448],
194748: [25475],
194749: [25572],
194750: [142321],
194751: [25634],
194752: [25541],
194753: [25513],
194754: [14894],
194755: [25705],
194756: [25726],
194757: [25757],
194758: [25719],
194759: [14956],
194760: [25935],
194761: [25964],
194762: [143370],
194763: [26083],
194764: [26360],
194765: [26185],
194766: [15129],
194767: [26257],
194768: [15112],
194769: [15076],
194770: [20882],
194771: [20885],
194772: [26368],
194773: [26268],
194774: [32941],
194775: [17369],
194776: [26391],
194777: [26395],
194778: [26401],
194779: [26462],
194780: [26451],
194781: [144323],
194782: [15177],
194783: [26618],
194784: [26501],
194785: [26706],
194786: [26757],
194787: [144493],
194788: [26766],
194789: [26655],
194790: [26900],
194791: [15261],
194792: [26946],
194793: [27043],
194794: [27114],
194795: [27304],
194796: [145059],
194797: [27355],
194798: [15384],
194799: [27425],
194800: [145575],
194801: [27476],
194802: [15438],
194803: [27506],
194804: [27551],
194805: [27578],
194806: [27579],
194807: [146061],
194808: [138507],
194809: [146170],
194810: [27726],
194811: [146620],
194812: [27839],
194813: [27853],
194814: [27751],
194815: [27926],
194816: [27966],
194817: [28023],
194818: [27969],
194819: [28009],
194820: [28024],
194821: [28037],
194822: [146718],
194823: [27956],
194824: [28207],
194825: [28270],
194826: [15667],
194827: [28363],
194828: [28359],
194829: [147153],
194830: [28153],
194831: [28526],
194832: [147294],
194833: [147342],
194834: [28614],
194835: [28729],
194836: [28702],
194837: [28699],
194838: [15766],
194839: [28746],
194840: [28797],
194841: [28791],
194842: [28845],
194843: [132389],
194844: [28997],
194845: [148067],
194846: [29084],
194847: [148395],
194848: [29224],
194849: [29237],
194850: [29264],
194851: [149000],
194852: [29312],
194853: [29333],
194854: [149301],
194855: [149524],
194856: [29562],
194857: [29579],
194858: [16044],
194859: [29605],
194860: [16056],
194861: [16056],
194862: [29767],
194863: [29788],
194864: [29809],
194865: [29829],
194866: [29898],
194867: [16155],
194868: [29988],
194869: [150582],
194870: [30014],
194871: [150674],
194872: [30064],
194873: [139679],
194874: [30224],
194875: [151457],
194876: [151480],
194877: [151620],
194878: [16380],
194879: [16392],
194880: [30452],
194881: [151795],
194882: [151794],
194883: [151833],
194884: [151859],
194885: [30494],
194886: [30495],
194887: [30495],
194888: [30538],
194889: [16441],
194890: [30603],
194891: [16454],
194892: [16534],
194893: [152605],
194894: [30798],
194895: [30860],
194896: [30924],
194897: [16611],
194898: [153126],
194899: [31062],
194900: [153242],
194901: [153285],
194902: [31119],
194903: [31211],
194904: [16687],
194905: [31296],
194906: [31306],
194907: [31311],
194908: [153980],
194909: [154279],
194910: [154279],
194911: [31470],
194912: [16898],
194913: [154539],
194914: [31686],
194915: [31689],
194916: [16935],
194917: [154752],
194918: [31954],
194919: [17056],
194920: [31976],
194921: [31971],
194922: [32000],
194923: [155526],
194924: [32099],
194925: [17153],
194926: [32199],
194927: [32258],
194928: [32325],
194929: [17204],
194930: [156200],
194931: [156231],
194932: [17241],
194933: [156377],
194934: [32634],
194935: [156478],
194936: [32661],
194937: [32762],
194938: [32773],
194939: [156890],
194940: [156963],
194941: [32864],
194942: [157096],
194943: [32880],
194944: [144223],
194945: [17365],
194946: [32946],
194947: [33027],
194948: [17419],
194949: [33086],
194950: [23221],
194951: [157607],
194952: [157621],
194953: [144275],
194954: [144284],
194955: [33281],
194956: [33284],
194957: [36766],
194958: [17515],
194959: [33425],
194960: [33419],
194961: [33437],
194962: [21171],
194963: [33457],
194964: [33459],
194965: [33469],
194966: [33510],
194967: [158524],
194968: [33509],
194969: [33565],
194970: [33635],
194971: [33709],
194972: [33571],
194973: [33725],
194974: [33767],
194975: [33879],
194976: [33619],
194977: [33738],
194978: [33740],
194979: [33756],
194980: [158774],
194981: [159083],
194982: [158933],
194983: [17707],
194984: [34033],
194985: [34035],
194986: [34070],
194987: [160714],
194988: [34148],
194989: [159532],
194990: [17757],
194991: [17761],
194992: [159665],
194993: [159954],
194994: [17771],
194995: [34384],
194996: [34396],
194997: [34407],
194998: [34409],
194999: [34473],
195000: [34440],
195001: [34574],
195002: [34530],
195003: [34681],
195004: [34600],
195005: [34667],
195006: [34694],
195007: [17879],
195008: [34785],
195009: [34817],
195010: [17913],
195011: [34912],
195012: [34915],
195013: [161383],
195014: [35031],
195015: [35038],
195016: [17973],
195017: [35066],
195018: [13499],
195019: [161966],
195020: [162150],
195021: [18110],
195022: [18119],
195023: [35488],
195024: [35565],
195025: [35722],
195026: [35925],
195027: [162984],
195028: [36011],
195029: [36033],
195030: [36123],
195031: [36215],
195032: [163631],
195033: [133124],
195034: [36299],
195035: [36284],
195036: [36336],
195037: [133342],
195038: [36564],
195039: [36664],
195040: [165330],
195041: [165357],
195042: [37012],
195043: [37105],
195044: [37137],
195045: [165678],
195046: [37147],
195047: [37432],
195048: [37591],
195049: [37592],
195050: [37500],
195051: [37881],
195052: [37909],
195053: [166906],
195054: [38283],
195055: [18837],
195056: [38327],
195057: [167287],
195058: [18918],
195059: [38595],
195060: [23986],
195061: [38691],
195062: [168261],
195063: [168474],
195064: [19054],
195065: [19062],
195066: [38880],
195067: [168970],
195068: [19122],
195069: [169110],
195070: [38923],
195071: [38923],
195072: [38953],
195073: [169398],
195074: [39138],
195075: [19251],
195076: [39209],
195077: [39335],
195078: [39362],
195079: [39422],
195080: [19406],
195081: [170800],
195082: [39698],
195083: [40000],
195084: [40189],
195085: [19662],
195086: [19693],
195087: [40295],
195088: [172238],
195089: [19704],
195090: [172293],
195091: [172558],
195092: [172689],
195093: [40635],
195094: [19798],
195095: [40697],
195096: [40702],
195097: [40709],
195098: [40719],
195099: [40726],
195100: [40763],
195101: [173568],
}

_canon_decomposition_corrected = {
}
_compat_decomposition = {
160: [32],
168: [32, 776],
170: [97],
175: [32, 772],
178: [50],
179: [51],
180: [32, 769],
181: [956],
184: [32, 807],
185: [49],
186: [111],
188: [49, 8260, 52],
189: [49, 8260, 50],
190: [51, 8260, 52],
192: [65, 768],
193: [65, 769],
194: [65, 770],
195: [65, 771],
196: [65, 776],
197: [65, 778],
199: [67, 807],
200: [69, 768],
201: [69, 769],
202: [69, 770],
203: [69, 776],
204: [73, 768],
205: [73, 769],
206: [73, 770],
207: [73, 776],
209: [78, 771],
210: [79, 768],
211: [79, 769],
212: [79, 770],
213: [79, 771],
214: [79, 776],
217: [85, 768],
218: [85, 769],
219: [85, 770],
220: [85, 776],
221: [89, 769],
224: [97, 768],
225: [97, 769],
226: [97, 770],
227: [97, 771],
228: [97, 776],
229: [97, 778],
231: [99, 807],
232: [101, 768],
233: [101, 769],
234: [101, 770],
235: [101, 776],
236: [105, 768],
237: [105, 769],
238: [105, 770],
239: [105, 776],
241: [110, 771],
242: [111, 768],
243: [111, 769],
244: [111, 770],
245: [111, 771],
246: [111, 776],
249: [117, 768],
250: [117, 769],
251: [117, 770],
252: [117, 776],
253: [121, 769],
255: [121, 776],
256: [65, 772],
257: [97, 772],
258: [65, 774],
259: [97, 774],
260: [65, 808],
261: [97, 808],
262: [67, 769],
263: [99, 769],
264: [67, 770],
265: [99, 770],
266: [67, 775],
267: [99, 775],
268: [67, 780],
269: [99, 780],
270: [68, 780],
271: [100, 780],
274: [69, 772],
275: [101, 772],
276: [69, 774],
277: [101, 774],
278: [69, 775],
279: [101, 775],
280: [69, 808],
281: [101, 808],
282: [69, 780],
283: [101, 780],
284: [71, 770],
285: [103, 770],
286: [71, 774],
287: [103, 774],
288: [71, 775],
289: [103, 775],
290: [71, 807],
291: [103, 807],
292: [72, 770],
293: [104, 770],
296: [73, 771],
297: [105, 771],
298: [73, 772],
299: [105, 772],
300: [73, 774],
301: [105, 774],
302: [73, 808],
303: [105, 808],
304: [73, 775],
306: [73, 74],
307: [105, 106],
308: [74, 770],
309: [106, 770],
310: [75, 807],
311: [107, 807],
313: [76, 769],
314: [108, 769],
315: [76, 807],
316: [108, 807],
317: [76, 780],
318: [108, 780],
319: [76, 183],
320: [108, 183],
323: [78, 769],
324: [110, 769],
325: [78, 807],
326: [110, 807],
327: [78, 780],
328: [110, 780],
329: [700, 110],
332: [79, 772],
333: [111, 772],
334: [79, 774],
335: [111, 774],
336: [79, 779],
337: [111, 779],
340: [82, 769],
341: [114, 769],
342: [82, 807],
343: [114, 807],
344: [82, 780],
345: [114, 780],
346: [83, 769],
347: [115, 769],
348: [83, 770],
349: [115, 770],
350: [83, 807],
351: [115, 807],
352: [83, 780],
353: [115, 780],
354: [84, 807],
355: [116, 807],
356: [84, 780],
357: [116, 780],
360: [85, 771],
361: [117, 771],
362: [85, 772],
363: [117, 772],
364: [85, 774],
365: [117, 774],
366: [85, 778],
367: [117, 778],
368: [85, 779],
369: [117, 779],
370: [85, 808],
371: [117, 808],
372: [87, 770],
373: [119, 770],
374: [89, 770],
375: [121, 770],
376: [89, 776],
377: [90, 769],
378: [122, 769],
379: [90, 775],
380: [122, 775],
381: [90, 780],
382: [122, 780],
383: [115],
416: [79, 795],
417: [111, 795],
431: [85, 795],
432: [117, 795],
452: [68, 90, 780],
453: [68, 122, 780],
454: [100, 122, 780],
455: [76, 74],
456: [76, 106],
457: [108, 106],
458: [78, 74],
459: [78, 106],
460: [110, 106],
461: [65, 780],
462: [97, 780],
463: [73, 780],
464: [105, 780],
465: [79, 780],
466: [111, 780],
467: [85, 780],
468: [117, 780],
469: [85, 776, 772],
470: [117, 776, 772],
471: [85, 776, 769],
472: [117, 776, 769],
473: [85, 776, 780],
474: [117, 776, 780],
475: [85, 776, 768],
476: [117, 776, 768],
478: [65, 776, 772],
479: [97, 776, 772],
480: [65, 775, 772],
481: [97, 775, 772],
482: [198, 772],
483: [230, 772],
486: [71, 780],
487: [103, 780],
488: [75, 780],
489: [107, 780],
490: [79, 808],
491: [111, 808],
492: [79, 808, 772],
493: [111, 808, 772],
494: [439, 780],
495: [658, 780],
496: [106, 780],
497: [68, 90],
498: [68, 122],
499: [100, 122],
500: [71, 769],
501: [103, 769],
504: [78, 768],
505: [110, 768],
506: [65, 778, 769],
507: [97, 778, 769],
508: [198, 769],
509: [230, 769],
510: [216, 769],
511: [248, 769],
512: [65, 783],
513: [97, 783],
514: [65, 785],
515: [97, 785],
516: [69, 783],
517: [101, 783],
518: [69, 785],
519: [101, 785],
520: [73, 783],
521: [105, 783],
522: [73, 785],
523: [105, 785],
524: [79, 783],
525: [111, 783],
526: [79, 785],
527: [111, 785],
528: [82, 783],
529: [114, 783],
530: [82, 785],
531: [114, 785],
532: [85, 783],
533: [117, 783],
534: [85, 785],
535: [117, 785],
536: [83, 806],
537: [115, 806],
538: [84, 806],
539: [116, 806],
542: [72, 780],
543: [104, 780],
550: [65, 775],
551: [97, 775],
552: [69, 807],
553: [101, 807],
554: [79, 776, 772],
555: [111, 776, 772],
556: [79, 771, 772],
557: [111, 771, 772],
558: [79, 775],
559: [111, 775],
560: [79, 775, 772],
561: [111, 775, 772],
562: [89, 772],
563: [121, 772],
688: [104],
689: [614],
690: [106],
691: [114],
692: [633],
693: [635],
694: [641],
695: [119],
696: [121],
728: [32, 774],
729: [32, 775],
730: [32, 778],
731: [32, 808],
732: [32, 771],
733: [32, 779],
736: [611],
737: [108],
738: [115],
739: [120],
740: [661],
832: [768],
833: [769],
835: [787],
836: [776, 769],
884: [697],
890: [32, 837],
894: [59],
900: [32, 769],
901: [32, 776, 769],
902: [913, 769],
903: [183],
904: [917, 769],
905: [919, 769],
906: [921, 769],
908: [927, 769],
910: [933, 769],
911: [937, 769],
912: [953, 776, 769],
938: [921, 776],
939: [933, 776],
940: [945, 769],
941: [949, 769],
942: [951, 769],
943: [953, 769],
944: [965, 776, 769],
970: [953, 776],
971: [965, 776],
972: [959, 769],
973: [965, 769],
974: [969, 769],
976: [946],
977: [952],
978: [933],
979: [933, 769],
980: [933, 776],
981: [966],
982: [960],
1008: [954],
1009: [961],
1010: [962],
1012: [920],
1013: [949],
1017: [931],
1024: [1045, 768],
1025: [1045, 776],
1027: [1043, 769],
1031: [1030, 776],
1036: [1050, 769],
1037: [1048, 768],
1038: [1059, 774],
1049: [1048, 774],
1081: [1080, 774],
1104: [1077, 768],
1105: [1077, 776],
1107: [1075, 769],
1111: [1110, 776],
1116: [1082, 769],
1117: [1080, 768],
1118: [1091, 774],
1142: [1140, 783],
1143: [1141, 783],
1217: [1046, 774],
1218: [1078, 774],
1232: [1040, 774],
1233: [1072, 774],
1234: [1040, 776],
1235: [1072, 776],
1238: [1045, 774],
1239: [1077, 774],
1242: [1240, 776],
1243: [1241, 776],
1244: [1046, 776],
1245: [1078, 776],
1246: [1047, 776],
1247: [1079, 776],
1250: [1048, 772],
1251: [1080, 772],
1252: [1048, 776],
1253: [1080, 776],
1254: [1054, 776],
1255: [1086, 776],
1258: [1256, 776],
1259: [1257, 776],
1260: [1069, 776],
1261: [1101, 776],
1262: [1059, 772],
1263: [1091, 772],
1264: [1059, 776],
1265: [1091, 776],
1266: [1059, 779],
1267: [1091, 779],
1268: [1063, 776],
1269: [1095, 776],
1272: [1067, 776],
1273: [1099, 776],
1415: [1381, 1410],
1570: [1575, 1619],
1571: [1575, 1620],
1572: [1608, 1620],
1573: [1575, 1621],
1574: [1610, 1620],
1653: [1575, 1652],
1654: [1608, 1652],
1655: [1735, 1652],
1656: [1610, 1652],
1728: [1749, 1620],
1730: [1729, 1620],
1747: [1746, 1620],
2345: [2344, 2364],
2353: [2352, 2364],
2356: [2355, 2364],
2392: [2325, 2364],
2393: [2326, 2364],
2394: [2327, 2364],
2395: [2332, 2364],
2396: [2337, 2364],
2397: [2338, 2364],
2398: [2347, 2364],
2399: [2351, 2364],
2507: [2503, 2494],
2508: [2503, 2519],
2524: [2465, 2492],
2525: [2466, 2492],
2527: [2479, 2492],
2611: [2610, 2620],
2614: [2616, 2620],
2649: [2582, 2620],
2650: [2583, 2620],
2651: [2588, 2620],
2654: [2603, 2620],
2888: [2887, 2902],
2891: [2887, 2878],
2892: [2887, 2903],
2908: [2849, 2876],
2909: [2850, 2876],
2964: [2962, 3031],
3018: [3014, 3006],
3019: [3015, 3006],
3020: [3014, 3031],
3144: [3142, 3158],
3264: [3263, 3285],
3271: [3270, 3285],
3272: [3270, 3286],
3274: [3270, 3266],
3275: [3270, 3266, 3285],
3402: [3398, 3390],
3403: [3399, 3390],
3404: [3398, 3415],
3546: [3545, 3530],
3548: [3545, 3535],
3549: [3545, 3535, 3530],
3550: [3545, 3551],
3635: [3661, 3634],
3763: [3789, 3762],
3804: [3755, 3737],
3805: [3755, 3745],
3852: [3851],
3907: [3906, 4023],
3917: [3916, 4023],
3922: [3921, 4023],
3927: [3926, 4023],
3932: [3931, 4023],
3945: [3904, 4021],
3955: [3953, 3954],
3957: [3953, 3956],
3958: [4018, 3968],
3959: [4018, 3953, 3968],
3960: [4019, 3968],
3961: [4019, 3953, 3968],
3969: [3953, 3968],
3987: [3986, 4023],
3997: [3996, 4023],
4002: [4001, 4023],
4007: [4006, 4023],
4012: [4011, 4023],
4025: [3984, 4021],
4134: [4133, 4142],
4348: [4316],
6918: [6917, 6965],
6920: [6919, 6965],
6922: [6921, 6965],
6924: [6923, 6965],
6926: [6925, 6965],
6930: [6929, 6965],
6971: [6970, 6965],
6973: [6972, 6965],
6976: [6974, 6965],
6977: [6975, 6965],
6979: [6978, 6965],
7468: [65],
7469: [198],
7470: [66],
7472: [68],
7473: [69],
7474: [398],
7475: [71],
7476: [72],
7477: [73],
7478: [74],
7479: [75],
7480: [76],
7481: [77],
7482: [78],
7484: [79],
7485: [546],
7486: [80],
7487: [82],
7488: [84],
7489: [85],
7490: [87],
7491: [97],
7492: [592],
7493: [593],
7494: [7426],
7495: [98],
7496: [100],
7497: [101],
7498: [601],
7499: [603],
7500: [604],
7501: [103],
7503: [107],
7504: [109],
7505: [331],
7506: [111],
7507: [596],
7508: [7446],
7509: [7447],
7510: [112],
7511: [116],
7512: [117],
7513: [7453],
7514: [623],
7515: [118],
7516: [7461],
7517: [946],
7518: [947],
7519: [948],
7520: [966],
7521: [967],
7522: [105],
7523: [114],
7524: [117],
7525: [118],
7526: [946],
7527: [947],
7528: [961],
7529: [966],
7530: [967],
7544: [1085],
7579: [594],
7580: [99],
7581: [597],
7582: [240],
7583: [604],
7584: [102],
7585: [607],
7586: [609],
7587: [613],
7588: [616],
7589: [617],
7590: [618],
7591: [7547],
7592: [669],
7593: [621],
7594: [7557],
7595: [671],
7596: [625],
7597: [624],
7598: [626],
7599: [627],
7600: [628],
7601: [629],
7602: [632],
7603: [642],
7604: [643],
7605: [427],
7606: [649],
7607: [650],
7608: [7452],
7609: [651],
7610: [652],
7611: [122],
7612: [656],
7613: [657],
7614: [658],
7615: [952],
7680: [65, 805],
7681: [97, 805],
7682: [66, 775],
7683: [98, 775],
7684: [66, 803],
7685: [98, 803],
7686: [66, 817],
7687: [98, 817],
7688: [67, 807, 769],
7689: [99, 807, 769],
7690: [68, 775],
7691: [100, 775],
7692: [68, 803],
7693: [100, 803],
7694: [68, 817],
7695: [100, 817],
7696: [68, 807],
7697: [100, 807],
7698: [68, 813],
7699: [100, 813],
7700: [69, 772, 768],
7701: [101, 772, 768],
7702: [69, 772, 769],
7703: [101, 772, 769],
7704: [69, 813],
7705: [101, 813],
7706: [69, 816],
7707: [101, 816],
7708: [69, 807, 774],
7709: [101, 807, 774],
7710: [70, 775],
7711: [102, 775],
7712: [71, 772],
7713: [103, 772],
7714: [72, 775],
7715: [104, 775],
7716: [72, 803],
7717: [104, 803],
7718: [72, 776],
7719: [104, 776],
7720: [72, 807],
7721: [104, 807],
7722: [72, 814],
7723: [104, 814],
7724: [73, 816],
7725: [105, 816],
7726: [73, 776, 769],
7727: [105, 776, 769],
7728: [75, 769],
7729: [107, 769],
7730: [75, 803],
7731: [107, 803],
7732: [75, 817],
7733: [107, 817],
7734: [76, 803],
7735: [108, 803],
7736: [76, 803, 772],
7737: [108, 803, 772],
7738: [76, 817],
7739: [108, 817],
7740: [76, 813],
7741: [108, 813],
7742: [77, 769],
7743: [109, 769],
7744: [77, 775],
7745: [109, 775],
7746: [77, 803],
7747: [109, 803],
7748: [78, 775],
7749: [110, 775],
7750: [78, 803],
7751: [110, 803],
7752: [78, 817],
7753: [110, 817],
7754: [78, 813],
7755: [110, 813],
7756: [79, 771, 769],
7757: [111, 771, 769],
7758: [79, 771, 776],
7759: [111, 771, 776],
7760: [79, 772, 768],
7761: [111, 772, 768],
7762: [79, 772, 769],
7763: [111, 772, 769],
7764: [80, 769],
7765: [112, 769],
7766: [80, 775],
7767: [112, 775],
7768: [82, 775],
7769: [114, 775],
7770: [82, 803],
7771: [114, 803],
7772: [82, 803, 772],
7773: [114, 803, 772],
7774: [82, 817],
7775: [114, 817],
7776: [83, 775],
7777: [115, 775],
7778: [83, 803],
7779: [115, 803],
7780: [83, 769, 775],
7781: [115, 769, 775],
7782: [83, 780, 775],
7783: [115, 780, 775],
7784: [83, 803, 775],
7785: [115, 803, 775],
7786: [84, 775],
7787: [116, 775],
7788: [84, 803],
7789: [116, 803],
7790: [84, 817],
7791: [116, 817],
7792: [84, 813],
7793: [116, 813],
7794: [85, 804],
7795: [117, 804],
7796: [85, 816],
7797: [117, 816],
7798: [85, 813],
7799: [117, 813],
7800: [85, 771, 769],
7801: [117, 771, 769],
7802: [85, 772, 776],
7803: [117, 772, 776],
7804: [86, 771],
7805: [118, 771],
7806: [86, 803],
7807: [118, 803],
7808: [87, 768],
7809: [119, 768],
7810: [87, 769],
7811: [119, 769],
7812: [87, 776],
7813: [119, 776],
7814: [87, 775],
7815: [119, 775],
7816: [87, 803],
7817: [119, 803],
7818: [88, 775],
7819: [120, 775],
7820: [88, 776],
7821: [120, 776],
7822: [89, 775],
7823: [121, 775],
7824: [90, 770],
7825: [122, 770],
7826: [90, 803],
7827: [122, 803],
7828: [90, 817],
7829: [122, 817],
7830: [104, 817],
7831: [116, 776],
7832: [119, 778],
7833: [121, 778],
7834: [97, 702],
7835: [115, 775],
7840: [65, 803],
7841: [97, 803],
7842: [65, 777],
7843: [97, 777],
7844: [65, 770, 769],
7845: [97, 770, 769],
7846: [65, 770, 768],
7847: [97, 770, 768],
7848: [65, 770, 777],
7849: [97, 770, 777],
7850: [65, 770, 771],
7851: [97, 770, 771],
7852: [65, 803, 770],
7853: [97, 803, 770],
7854: [65, 774, 769],
7855: [97, 774, 769],
7856: [65, 774, 768],
7857: [97, 774, 768],
7858: [65, 774, 777],
7859: [97, 774, 777],
7860: [65, 774, 771],
7861: [97, 774, 771],
7862: [65, 803, 774],
7863: [97, 803, 774],
7864: [69, 803],
7865: [101, 803],
7866: [69, 777],
7867: [101, 777],
7868: [69, 771],
7869: [101, 771],
7870: [69, 770, 769],
7871: [101, 770, 769],
7872: [69, 770, 768],
7873: [101, 770, 768],
7874: [69, 770, 777],
7875: [101, 770, 777],
7876: [69, 770, 771],
7877: [101, 770, 771],
7878: [69, 803, 770],
7879: [101, 803, 770],
7880: [73, 777],
7881: [105, 777],
7882: [73, 803],
7883: [105, 803],
7884: [79, 803],
7885: [111, 803],
7886: [79, 777],
7887: [111, 777],
7888: [79, 770, 769],
7889: [111, 770, 769],
7890: [79, 770, 768],
7891: [111, 770, 768],
7892: [79, 770, 777],
7893: [111, 770, 777],
7894: [79, 770, 771],
7895: [111, 770, 771],
7896: [79, 803, 770],
7897: [111, 803, 770],
7898: [79, 795, 769],
7899: [111, 795, 769],
7900: [79, 795, 768],
7901: [111, 795, 768],
7902: [79, 795, 777],
7903: [111, 795, 777],
7904: [79, 795, 771],
7905: [111, 795, 771],
7906: [79, 795, 803],
7907: [111, 795, 803],
7908: [85, 803],
7909: [117, 803],
7910: [85, 777],
7911: [117, 777],
7912: [85, 795, 769],
7913: [117, 795, 769],
7914: [85, 795, 768],
7915: [117, 795, 768],
7916: [85, 795, 777],
7917: [117, 795, 777],
7918: [85, 795, 771],
7919: [117, 795, 771],
7920: [85, 795, 803],
7921: [117, 795, 803],
7922: [89, 768],
7923: [121, 768],
7924: [89, 803],
7925: [121, 803],
7926: [89, 777],
7927: [121, 777],
7928: [89, 771],
7929: [121, 771],
7936: [945, 787],
7937: [945, 788],
7938: [945, 787, 768],
7939: [945, 788, 768],
7940: [945, 787, 769],
7941: [945, 788, 769],
7942: [945, 787, 834],
7943: [945, 788, 834],
7944: [913, 787],
7945: [913, 788],
7946: [913, 787, 768],
7947: [913, 788, 768],
7948: [913, 787, 769],
7949: [913, 788, 769],
7950: [913, 787, 834],
7951: [913, 788, 834],
7952: [949, 787],
7953: [949, 788],
7954: [949, 787, 768],
7955: [949, 788, 768],
7956: [949, 787, 769],
7957: [949, 788, 769],
7960: [917, 787],
7961: [917, 788],
7962: [917, 787, 768],
7963: [917, 788, 768],
7964: [917, 787, 769],
7965: [917, 788, 769],
7968: [951, 787],
7969: [951, 788],
7970: [951, 787, 768],
7971: [951, 788, 768],
7972: [951, 787, 769],
7973: [951, 788, 769],
7974: [951, 787, 834],
7975: [951, 788, 834],
7976: [919, 787],
7977: [919, 788],
7978: [919, 787, 768],
7979: [919, 788, 768],
7980: [919, 787, 769],
7981: [919, 788, 769],
7982: [919, 787, 834],
7983: [919, 788, 834],
7984: [953, 787],
7985: [953, 788],
7986: [953, 787, 768],
7987: [953, 788, 768],
7988: [953, 787, 769],
7989: [953, 788, 769],
7990: [953, 787, 834],
7991: [953, 788, 834],
7992: [921, 787],
7993: [921, 788],
7994: [921, 787, 768],
7995: [921, 788, 768],
7996: [921, 787, 769],
7997: [921, 788, 769],
7998: [921, 787, 834],
7999: [921, 788, 834],
8000: [959, 787],
8001: [959, 788],
8002: [959, 787, 768],
8003: [959, 788, 768],
8004: [959, 787, 769],
8005: [959, 788, 769],
8008: [927, 787],
8009: [927, 788],
8010: [927, 787, 768],
8011: [927, 788, 768],
8012: [927, 787, 769],
8013: [927, 788, 769],
8016: [965, 787],
8017: [965, 788],
8018: [965, 787, 768],
8019: [965, 788, 768],
8020: [965, 787, 769],
8021: [965, 788, 769],
8022: [965, 787, 834],
8023: [965, 788, 834],
8025: [933, 788],
8027: [933, 788, 768],
8029: [933, 788, 769],
8031: [933, 788, 834],
8032: [969, 787],
8033: [969, 788],
8034: [969, 787, 768],
8035: [969, 788, 768],
8036: [969, 787, 769],
8037: [969, 788, 769],
8038: [969, 787, 834],
8039: [969, 788, 834],
8040: [937, 787],
8041: [937, 788],
8042: [937, 787, 768],
8043: [937, 788, 768],
8044: [937, 787, 769],
8045: [937, 788, 769],
8046: [937, 787, 834],
8047: [937, 788, 834],
8048: [945, 768],
8049: [945, 769],
8050: [949, 768],
8051: [949, 769],
8052: [951, 768],
8053: [951, 769],
8054: [953, 768],
8055: [953, 769],
8056: [959, 768],
8057: [959, 769],
8058: [965, 768],
8059: [965, 769],
8060: [969, 768],
8061: [969, 769],
8064: [945, 787, 837],
8065: [945, 788, 837],
8066: [945, 787, 768, 837],
8067: [945, 788, 768, 837],
8068: [945, 787, 769, 837],
8069: [945, 788, 769, 837],
8070: [945, 787, 834, 837],
8071: [945, 788, 834, 837],
8072: [913, 787, 837],
8073: [913, 788, 837],
8074: [913, 787, 768, 837],
8075: [913, 788, 768, 837],
8076: [913, 787, 769, 837],
8077: [913, 788, 769, 837],
8078: [913, 787, 834, 837],
8079: [913, 788, 834, 837],
8080: [951, 787, 837],
8081: [951, 788, 837],
8082: [951, 787, 768, 837],
8083: [951, 788, 768, 837],
8084: [951, 787, 769, 837],
8085: [951, 788, 769, 837],
8086: [951, 787, 834, 837],
8087: [951, 788, 834, 837],
8088: [919, 787, 837],
8089: [919, 788, 837],
8090: [919, 787, 768, 837],
8091: [919, 788, 768, 837],
8092: [919, 787, 769, 837],
8093: [919, 788, 769, 837],
8094: [919, 787, 834, 837],
8095: [919, 788, 834, 837],
8096: [969, 787, 837],
8097: [969, 788, 837],
8098: [969, 787, 768, 837],
8099: [969, 788, 768, 837],
8100: [969, 787, 769, 837],
8101: [969, 788, 769, 837],
8102: [969, 787, 834, 837],
8103: [969, 788, 834, 837],
8104: [937, 787, 837],
8105: [937, 788, 837],
8106: [937, 787, 768, 837],
8107: [937, 788, 768, 837],
8108: [937, 787, 769, 837],
8109: [937, 788, 769, 837],
8110: [937, 787, 834, 837],
8111: [937, 788, 834, 837],
8112: [945, 774],
8113: [945, 772],
8114: [945, 768, 837],
8115: [945, 837],
8116: [945, 769, 837],
8118: [945, 834],
8119: [945, 834, 837],
8120: [913, 774],
8121: [913, 772],
8122: [913, 768],
8123: [913, 769],
8124: [913, 837],
8125: [32, 787],
8126: [953],
8127: [32, 787],
8128: [32, 834],
8129: [32, 776, 834],
8130: [951, 768, 837],
8131: [951, 837],
8132: [951, 769, 837],
8134: [951, 834],
8135: [951, 834, 837],
8136: [917, 768],
8137: [917, 769],
8138: [919, 768],
8139: [919, 769],
8140: [919, 837],
8141: [32, 787, 768],
8142: [32, 787, 769],
8143: [32, 787, 834],
8144: [953, 774],
8145: [953, 772],
8146: [953, 776, 768],
8147: [953, 776, 769],
8150: [953, 834],
8151: [953, 776, 834],
8152: [921, 774],
8153: [921, 772],
8154: [921, 768],
8155: [921, 769],
8157: [32, 788, 768],
8158: [32, 788, 769],
8159: [32, 788, 834],
8160: [965, 774],
8161: [965, 772],
8162: [965, 776, 768],
8163: [965, 776, 769],
8164: [961, 787],
8165: [961, 788],
8166: [965, 834],
8167: [965, 776, 834],
8168: [933, 774],
8169: [933, 772],
8170: [933, 768],
8171: [933, 769],
8172: [929, 788],
8173: [32, 776, 768],
8174: [32, 776, 769],
8175: [96],
8178: [969, 768, 837],
8179: [969, 837],
8180: [969, 769, 837],
8182: [969, 834],
8183: [969, 834, 837],
8184: [927, 768],
8185: [927, 769],
8186: [937, 768],
8187: [937, 769],
8188: [937, 837],
8189: [32, 769],
8190: [32, 788],
8192: [32],
8193: [32],
8194: [32],
8195: [32],
8196: [32],
8197: [32],
8198: [32],
8199: [32],
8200: [32],
8201: [32],
8202: [32],
8209: [8208],
8215: [32, 819],
8228: [46],
8229: [46, 46],
8230: [46, 46, 46],
8239: [32],
8243: [8242, 8242],
8244: [8242, 8242, 8242],
8246: [8245, 8245],
8247: [8245, 8245, 8245],
8252: [33, 33],
8254: [32, 773],
8263: [63, 63],
8264: [63, 33],
8265: [33, 63],
8279: [8242, 8242, 8242, 8242],
8287: [32],
8304: [48],
8305: [105],
8308: [52],
8309: [53],
8310: [54],
8311: [55],
8312: [56],
8313: [57],
8314: [43],
8315: [8722],
8316: [61],
8317: [40],
8318: [41],
8319: [110],
8320: [48],
8321: [49],
8322: [50],
8323: [51],
8324: [52],
8325: [53],
8326: [54],
8327: [55],
8328: [56],
8329: [57],
8330: [43],
8331: [8722],
8332: [61],
8333: [40],
8334: [41],
8336: [97],
8337: [101],
8338: [111],
8339: [120],
8340: [601],
8360: [82, 115],
8448: [97, 47, 99],
8449: [97, 47, 115],
8450: [67],
8451: [176, 67],
8453: [99, 47, 111],
8454: [99, 47, 117],
8455: [400],
8457: [176, 70],
8458: [103],
8459: [72],
8460: [72],
8461: [72],
8462: [104],
8463: [295],
8464: [73],
8465: [73],
8466: [76],
8467: [108],
8469: [78],
8470: [78, 111],
8473: [80],
8474: [81],
8475: [82],
8476: [82],
8477: [82],
8480: [83, 77],
8481: [84, 69, 76],
8482: [84, 77],
8484: [90],
8486: [937],
8488: [90],
8490: [75],
8491: [65, 778],
8492: [66],
8493: [67],
8495: [101],
8496: [69],
8497: [70],
8499: [77],
8500: [111],
8501: [1488],
8502: [1489],
8503: [1490],
8504: [1491],
8505: [105],
8507: [70, 65, 88],
8508: [960],
8509: [947],
8510: [915],
8511: [928],
8512: [8721],
8517: [68],
8518: [100],
8519: [101],
8520: [105],
8521: [106],
8528: [49, 8260, 55],
8529: [49, 8260, 57],
8530: [49, 8260, 49, 48],
8531: [49, 8260, 51],
8532: [50, 8260, 51],
8533: [49, 8260, 53],
8534: [50, 8260, 53],
8535: [51, 8260, 53],
8536: [52, 8260, 53],
8537: [49, 8260, 54],
8538: [53, 8260, 54],
8539: [49, 8260, 56],
8540: [51, 8260, 56],
8541: [53, 8260, 56],
8542: [55, 8260, 56],
8543: [49, 8260],
8544: [73],
8545: [73, 73],
8546: [73, 73, 73],
8547: [73, 86],
8548: [86],
8549: [86, 73],
8550: [86, 73, 73],
8551: [86, 73, 73, 73],
8552: [73, 88],
8553: [88],
8554: [88, 73],
8555: [88, 73, 73],
8556: [76],
8557: [67],
8558: [68],
8559: [77],
8560: [105],
8561: [105, 105],
8562: [105, 105, 105],
8563: [105, 118],
8564: [118],
8565: [118, 105],
8566: [118, 105, 105],
8567: [118, 105, 105, 105],
8568: [105, 120],
8569: [120],
8570: [120, 105],
8571: [120, 105, 105],
8572: [108],
8573: [99],
8574: [100],
8575: [109],
8585: [48, 8260, 51],
8602: [8592, 824],
8603: [8594, 824],
8622: [8596, 824],
8653: [8656, 824],
8654: [8660, 824],
8655: [8658, 824],
8708: [8707, 824],
8713: [8712, 824],
8716: [8715, 824],
8740: [8739, 824],
8742: [8741, 824],
8748: [8747, 8747],
8749: [8747, 8747, 8747],
8751: [8750, 8750],
8752: [8750, 8750, 8750],
8769: [8764, 824],
8772: [8771, 824],
8775: [8773, 824],
8777: [8776, 824],
8800: [61, 824],
8802: [8801, 824],
8813: [8781, 824],
8814: [60, 824],
8815: [62, 824],
8816: [8804, 824],
8817: [8805, 824],
8820: [8818, 824],
8821: [8819, 824],
8824: [8822, 824],
8825: [8823, 824],
8832: [8826, 824],
8833: [8827, 824],
8836: [8834, 824],
8837: [8835, 824],
8840: [8838, 824],
8841: [8839, 824],
8876: [8866, 824],
8877: [8872, 824],
8878: [8873, 824],
8879: [8875, 824],
8928: [8828, 824],
8929: [8829, 824],
8930: [8849, 824],
8931: [8850, 824],
8938: [8882, 824],
8939: [8883, 824],
8940: [8884, 824],
8941: [8885, 824],
9001: [12296],
9002: [12297],
9312: [49],
9313: [50],
9314: [51],
9315: [52],
9316: [53],
9317: [54],
9318: [55],
9319: [56],
9320: [57],
9321: [49, 48],
9322: [49, 49],
9323: [49, 50],
9324: [49, 51],
9325: [49, 52],
9326: [49, 53],
9327: [49, 54],
9328: [49, 55],
9329: [49, 56],
9330: [49, 57],
9331: [50, 48],
9332: [40, 49, 41],
9333: [40, 50, 41],
9334: [40, 51, 41],
9335: [40, 52, 41],
9336: [40, 53, 41],
9337: [40, 54, 41],
9338: [40, 55, 41],
9339: [40, 56, 41],
9340: [40, 57, 41],
9341: [40, 49, 48, 41],
9342: [40, 49, 49, 41],
9343: [40, 49, 50, 41],
9344: [40, 49, 51, 41],
9345: [40, 49, 52, 41],
9346: [40, 49, 53, 41],
9347: [40, 49, 54, 41],
9348: [40, 49, 55, 41],
9349: [40, 49, 56, 41],
9350: [40, 49, 57, 41],
9351: [40, 50, 48, 41],
9352: [49, 46],
9353: [50, 46],
9354: [51, 46],
9355: [52, 46],
9356: [53, 46],
9357: [54, 46],
9358: [55, 46],
9359: [56, 46],
9360: [57, 46],
9361: [49, 48, 46],
9362: [49, 49, 46],
9363: [49, 50, 46],
9364: [49, 51, 46],
9365: [49, 52, 46],
9366: [49, 53, 46],
9367: [49, 54, 46],
9368: [49, 55, 46],
9369: [49, 56, 46],
9370: [49, 57, 46],
9371: [50, 48, 46],
9372: [40, 97, 41],
9373: [40, 98, 41],
9374: [40, 99, 41],
9375: [40, 100, 41],
9376: [40, 101, 41],
9377: [40, 102, 41],
9378: [40, 103, 41],
9379: [40, 104, 41],
9380: [40, 105, 41],
9381: [40, 106, 41],
9382: [40, 107, 41],
9383: [40, 108, 41],
9384: [40, 109, 41],
9385: [40, 110, 41],
9386: [40, 111, 41],
9387: [40, 112, 41],
9388: [40, 113, 41],
9389: [40, 114, 41],
9390: [40, 115, 41],
9391: [40, 116, 41],
9392: [40, 117, 41],
9393: [40, 118, 41],
9394: [40, 119, 41],
9395: [40, 120, 41],
9396: [40, 121, 41],
9397: [40, 122, 41],
9398: [65],
9399: [66],
9400: [67],
9401: [68],
9402: [69],
9403: [70],
9404: [71],
9405: [72],
9406: [73],
9407: [74],
9408: [75],
9409: [76],
9410: [77],
9411: [78],
9412: [79],
9413: [80],
9414: [81],
9415: [82],
9416: [83],
9417: [84],
9418: [85],
9419: [86],
9420: [87],
9421: [88],
9422: [89],
9423: [90],
9424: [97],
9425: [98],
9426: [99],
9427: [100],
9428: [101],
9429: [102],
9430: [103],
9431: [104],
9432: [105],
9433: [106],
9434: [107],
9435: [108],
9436: [109],
9437: [110],
9438: [111],
9439: [112],
9440: [113],
9441: [114],
9442: [115],
9443: [116],
9444: [117],
9445: [118],
9446: [119],
9447: [120],
9448: [121],
9449: [122],
9450: [48],
10764: [8747, 8747, 8747, 8747],
10868: [58, 58, 61],
10869: [61, 61],
10870: [61, 61, 61],
10972: [10973, 824],
11388: [106],
11389: [86],
11631: [11617],
11935: [27597],
12019: [40863],
12032: [19968],
12033: [20008],
12034: [20022],
12035: [20031],
12036: [20057],
12037: [20101],
12038: [20108],
12039: [20128],
12040: [20154],
12041: [20799],
12042: [20837],
12043: [20843],
12044: [20866],
12045: [20886],
12046: [20907],
12047: [20960],
12048: [20981],
12049: [20992],
12050: [21147],
12051: [21241],
12052: [21269],
12053: [21274],
12054: [21304],
12055: [21313],
12056: [21340],
12057: [21353],
12058: [21378],
12059: [21430],
12060: [21448],
12061: [21475],
12062: [22231],
12063: [22303],
12064: [22763],
12065: [22786],
12066: [22794],
12067: [22805],
12068: [22823],
12069: [22899],
12070: [23376],
12071: [23424],
12072: [23544],
12073: [23567],
12074: [23586],
12075: [23608],
12076: [23662],
12077: [23665],
12078: [24027],
12079: [24037],
12080: [24049],
12081: [24062],
12082: [24178],
12083: [24186],
12084: [24191],
12085: [24308],
12086: [24318],
12087: [24331],
12088: [24339],
12089: [24400],
12090: [24417],
12091: [24435],
12092: [24515],
12093: [25096],
12094: [25142],
12095: [25163],
12096: [25903],
12097: [25908],
12098: [25991],
12099: [26007],
12100: [26020],
12101: [26041],
12102: [26080],
12103: [26085],
12104: [26352],
12105: [26376],
12106: [26408],
12107: [27424],
12108: [27490],
12109: [27513],
12110: [27571],
12111: [27595],
12112: [27604],
12113: [27611],
12114: [27663],
12115: [27668],
12116: [27700],
12117: [28779],
12118: [29226],
12119: [29238],
12120: [29243],
12121: [29247],
12122: [29255],
12123: [29273],
12124: [29275],
12125: [29356],
12126: [29572],
12127: [29577],
12128: [29916],
12129: [29926],
12130: [29976],
12131: [29983],
12132: [29992],
12133: [30000],
12134: [30091],
12135: [30098],
12136: [30326],
12137: [30333],
12138: [30382],
12139: [30399],
12140: [30446],
12141: [30683],
12142: [30690],
12143: [30707],
12144: [31034],
12145: [31160],
12146: [31166],
12147: [31348],
12148: [31435],
12149: [31481],
12150: [31859],
12151: [31992],
12152: [32566],
12153: [32593],
12154: [32650],
12155: [32701],
12156: [32769],
12157: [32780],
12158: [32786],
12159: [32819],
12160: [32895],
12161: [32905],
12162: [33251],
12163: [33258],
12164: [33267],
12165: [33276],
12166: [33292],
12167: [33307],
12168: [33311],
12169: [33390],
12170: [33394],
12171: [33400],
12172: [34381],
12173: [34411],
12174: [34880],
12175: [34892],
12176: [34915],
12177: [35198],
12178: [35211],
12179: [35282],
12180: [35328],
12181: [35895],
12182: [35910],
12183: [35925],
12184: [35960],
12185: [35997],
12186: [36196],
12187: [36208],
12188: [36275],
12189: [36523],
12190: [36554],
12191: [36763],
12192: [36784],
12193: [36789],
12194: [37009],
12195: [37193],
12196: [37318],
12197: [37324],
12198: [37329],
12199: [38263],
12200: [38272],
12201: [38428],
12202: [38582],
12203: [38585],
12204: [38632],
12205: [38737],
12206: [38750],
12207: [38754],
12208: [38761],
12209: [38859],
12210: [38893],
12211: [38899],
12212: [38913],
12213: [39080],
12214: [39131],
12215: [39135],
12216: [39318],
12217: [39321],
12218: [39340],
12219: [39592],
12220: [39640],
12221: [39647],
12222: [39717],
12223: [39727],
12224: [39730],
12225: [39740],
12226: [39770],
12227: [40165],
12228: [40565],
12229: [40575],
12230: [40613],
12231: [40635],
12232: [40643],
12233: [40653],
12234: [40657],
12235: [40697],
12236: [40701],
12237: [40718],
12238: [40723],
12239: [40736],
12240: [40763],
12241: [40778],
12242: [40786],
12243: [40845],
12244: [40860],
12245: [40864],
12288: [32],
12342: [12306],
12344: [21313],
12345: [21316],
12346: [21317],
12364: [12363, 12441],
12366: [12365, 12441],
12368: [12367, 12441],
12370: [12369, 12441],
12372: [12371, 12441],
12374: [12373, 12441],
12376: [12375, 12441],
12378: [12377, 12441],
12380: [12379, 12441],
12382: [12381, 12441],
12384: [12383, 12441],
12386: [12385, 12441],
12389: [12388, 12441],
12391: [12390, 12441],
12393: [12392, 12441],
12400: [12399, 12441],
12401: [12399, 12442],
12403: [12402, 12441],
12404: [12402, 12442],
12406: [12405, 12441],
12407: [12405, 12442],
12409: [12408, 12441],
12410: [12408, 12442],
12412: [12411, 12441],
12413: [12411, 12442],
12436: [12358, 12441],
12443: [32, 12441],
12444: [32, 12442],
12446: [12445, 12441],
12447: [12424, 12426],
12460: [12459, 12441],
12462: [12461, 12441],
12464: [12463, 12441],
12466: [12465, 12441],
12468: [12467, 12441],
12470: [12469, 12441],
12472: [12471, 12441],
12474: [12473, 12441],
12476: [12475, 12441],
12478: [12477, 12441],
12480: [12479, 12441],
12482: [12481, 12441],
12485: [12484, 12441],
12487: [12486, 12441],
12489: [12488, 12441],
12496: [12495, 12441],
12497: [12495, 12442],
12499: [12498, 12441],
12500: [12498, 12442],
12502: [12501, 12441],
12503: [12501, 12442],
12505: [12504, 12441],
12506: [12504, 12442],
12508: [12507, 12441],
12509: [12507, 12442],
12532: [12454, 12441],
12535: [12527, 12441],
12536: [12528, 12441],
12537: [12529, 12441],
12538: [12530, 12441],
12542: [12541, 12441],
12543: [12467, 12488],
12593: [4352],
12594: [4353],
12595: [4522],
12596: [4354],
12597: [4524],
12598: [4525],
12599: [4355],
12600: [4356],
12601: [4357],
12602: [4528],
12603: [4529],
12604: [4530],
12605: [4531],
12606: [4532],
12607: [4533],
12608: [4378],
12609: [4358],
12610: [4359],
12611: [4360],
12612: [4385],
12613: [4361],
12614: [4362],
12615: [4363],
12616: [4364],
12617: [4365],
12618: [4366],
12619: [4367],
12620: [4368],
12621: [4369],
12622: [4370],
12623: [4449],
12624: [4450],
12625: [4451],
12626: [4452],
12627: [4453],
12628: [4454],
12629: [4455],
12630: [4456],
12631: [4457],
12632: [4458],
12633: [4459],
12634: [4460],
12635: [4461],
12636: [4462],
12637: [4463],
12638: [4464],
12639: [4465],
12640: [4466],
12641: [4467],
12642: [4468],
12643: [4469],
12644: [4448],
12645: [4372],
12646: [4373],
12647: [4551],
12648: [4552],
12649: [4556],
12650: [4558],
12651: [4563],
12652: [4567],
12653: [4569],
12654: [4380],
12655: [4573],
12656: [4575],
12657: [4381],
12658: [4382],
12659: [4384],
12660: [4386],
12661: [4387],
12662: [4391],
12663: [4393],
12664: [4395],
12665: [4396],
12666: [4397],
12667: [4398],
12668: [4399],
12669: [4402],
12670: [4406],
12671: [4416],
12672: [4423],
12673: [4428],
12674: [4593],
12675: [4594],
12676: [4439],
12677: [4440],
12678: [4441],
12679: [4484],
12680: [4485],
12681: [4488],
12682: [4497],
12683: [4498],
12684: [4500],
12685: [4510],
12686: [4513],
12690: [19968],
12691: [20108],
12692: [19977],
12693: [22235],
12694: [19978],
12695: [20013],
12696: [19979],
12697: [30002],
12698: [20057],
12699: [19993],
12700: [19969],
12701: [22825],
12702: [22320],
12703: [20154],
12800: [40, 4352, 41],
12801: [40, 4354, 41],
12802: [40, 4355, 41],
12803: [40, 4357, 41],
12804: [40, 4358, 41],
12805: [40, 4359, 41],
12806: [40, 4361, 41],
12807: [40, 4363, 41],
12808: [40, 4364, 41],
12809: [40, 4366, 41],
12810: [40, 4367, 41],
12811: [40, 4368, 41],
12812: [40, 4369, 41],
12813: [40, 4370, 41],
12814: [40, 4352, 4449, 41],
12815: [40, 4354, 4449, 41],
12816: [40, 4355, 4449, 41],
12817: [40, 4357, 4449, 41],
12818: [40, 4358, 4449, 41],
12819: [40, 4359, 4449, 41],
12820: [40, 4361, 4449, 41],
12821: [40, 4363, 4449, 41],
12822: [40, 4364, 4449, 41],
12823: [40, 4366, 4449, 41],
12824: [40, 4367, 4449, 41],
12825: [40, 4368, 4449, 41],
12826: [40, 4369, 4449, 41],
12827: [40, 4370, 4449, 41],
12828: [40, 4364, 4462, 41],
12829: [40, 4363, 4457, 4364, 4453, 4523, 41],
12830: [40, 4363, 4457, 4370, 4462, 41],
12832: [40, 19968, 41],
12833: [40, 20108, 41],
12834: [40, 19977, 41],
12835: [40, 22235, 41],
12836: [40, 20116, 41],
12837: [40, 20845, 41],
12838: [40, 19971, 41],
12839: [40, 20843, 41],
12840: [40, 20061, 41],
12841: [40, 21313, 41],
12842: [40, 26376, 41],
12843: [40, 28779, 41],
12844: [40, 27700, 41],
12845: [40, 26408, 41],
12846: [40, 37329, 41],
12847: [40, 22303, 41],
12848: [40, 26085, 41],
12849: [40, 26666, 41],
12850: [40, 26377, 41],
12851: [40, 31038, 41],
12852: [40, 21517, 41],
12853: [40, 29305, 41],
12854: [40, 36001, 41],
12855: [40, 31069, 41],
12856: [40, 21172, 41],
12857: [40, 20195, 41],
12858: [40, 21628, 41],
12859: [40, 23398, 41],
12860: [40, 30435, 41],
12861: [40, 20225, 41],
12862: [40, 36039, 41],
12863: [40, 21332, 41],
12864: [40, 31085, 41],
12865: [40, 20241, 41],
12866: [40, 33258, 41],
12867: [40, 33267, 41],
12868: [21839],
12869: [24188],
12870: [25991],
12871: [31631],
12880: [80, 84, 69],
12881: [50, 49],
12882: [50, 50],
12883: [50, 51],
12884: [50, 52],
12885: [50, 53],
12886: [50, 54],
12887: [50, 55],
12888: [50, 56],
12889: [50, 57],
12890: [51, 48],
12891: [51, 49],
12892: [51, 50],
12893: [51, 51],
12894: [51, 52],
12895: [51, 53],
12896: [4352],
12897: [4354],
12898: [4355],
12899: [4357],
12900: [4358],
12901: [4359],
12902: [4361],
12903: [4363],
12904: [4364],
12905: [4366],
12906: [4367],
12907: [4368],
12908: [4369],
12909: [4370],
12910: [4352, 4449],
12911: [4354, 4449],
12912: [4355, 4449],
12913: [4357, 4449],
12914: [4358, 4449],
12915: [4359, 4449],
12916: [4361, 4449],
12917: [4363, 4449],
12918: [4364, 4449],
12919: [4366, 4449],
12920: [4367, 4449],
12921: [4368, 4449],
12922: [4369, 4449],
12923: [4370, 4449],
12924: [4366, 4449, 4535, 4352, 4457],
12925: [4364, 4462, 4363, 4468],
12926: [4363, 4462],
12928: [19968],
12929: [20108],
12930: [19977],
12931: [22235],
12932: [20116],
12933: [20845],
12934: [19971],
12935: [20843],
12936: [20061],
12937: [21313],
12938: [26376],
12939: [28779],
12940: [27700],
12941: [26408],
12942: [37329],
12943: [22303],
12944: [26085],
12945: [26666],
12946: [26377],
12947: [31038],
12948: [21517],
12949: [29305],
12950: [36001],
12951: [31069],
12952: [21172],
12953: [31192],
12954: [30007],
12955: [22899],
12956: [36969],
12957: [20778],
12958: [21360],
12959: [27880],
12960: [38917],
12961: [20241],
12962: [20889],
12963: [27491],
12964: [19978],
12965: [20013],
12966: [19979],
12967: [24038],
12968: [21491],
12969: [21307],
12970: [23447],
12971: [23398],
12972: [30435],
12973: [20225],
12974: [36039],
12975: [21332],
12976: [22812],
12977: [51, 54],
12978: [51, 55],
12979: [51, 56],
12980: [51, 57],
12981: [52, 48],
12982: [52, 49],
12983: [52, 50],
12984: [52, 51],
12985: [52, 52],
12986: [52, 53],
12987: [52, 54],
12988: [52, 55],
12989: [52, 56],
12990: [52, 57],
12991: [53, 48],
12992: [49, 26376],
12993: [50, 26376],
12994: [51, 26376],
12995: [52, 26376],
12996: [53, 26376],
12997: [54, 26376],
12998: [55, 26376],
12999: [56, 26376],
13000: [57, 26376],
13001: [49, 48, 26376],
13002: [49, 49, 26376],
13003: [49, 50, 26376],
13004: [72, 103],
13005: [101, 114, 103],
13006: [101, 86],
13007: [76, 84, 68],
13008: [12450],
13009: [12452],
13010: [12454],
13011: [12456],
13012: [12458],
13013: [12459],
13014: [12461],
13015: [12463],
13016: [12465],
13017: [12467],
13018: [12469],
13019: [12471],
13020: [12473],
13021: [12475],
13022: [12477],
13023: [12479],
13024: [12481],
13025: [12484],
13026: [12486],
13027: [12488],
13028: [12490],
13029: [12491],
13030: [12492],
13031: [12493],
13032: [12494],
13033: [12495],
13034: [12498],
13035: [12501],
13036: [12504],
13037: [12507],
13038: [12510],
13039: [12511],
13040: [12512],
13041: [12513],
13042: [12514],
13043: [12516],
13044: [12518],
13045: [12520],
13046: [12521],
13047: [12522],
13048: [12523],
13049: [12524],
13050: [12525],
13051: [12527],
13052: [12528],
13053: [12529],
13054: [12530],
13056: [12450, 12495, 12442, 12540, 12488],
13057: [12450, 12523, 12501, 12449],
13058: [12450, 12531, 12504, 12442, 12450],
13059: [12450, 12540, 12523],
13060: [12452, 12491, 12531, 12463, 12441],
13061: [12452, 12531, 12481],
13062: [12454, 12457, 12531],
13063: [12456, 12473, 12463, 12540, 12488, 12441],
13064: [12456, 12540, 12459, 12540],
13065: [12458, 12531, 12473],
13066: [12458, 12540, 12512],
13067: [12459, 12452, 12522],
13068: [12459, 12521, 12483, 12488],
13069: [12459, 12525, 12522, 12540],
13070: [12459, 12441, 12525, 12531],
13071: [12459, 12441, 12531, 12510],
13072: [12461, 12441, 12459, 12441],
13073: [12461, 12441, 12491, 12540],
13074: [12461, 12517, 12522, 12540],
13075: [12461, 12441, 12523, 12479, 12441, 12540],
13076: [12461, 12525],
13077: [12461, 12525, 12463, 12441, 12521, 12512],
13078: [12461, 12525, 12513, 12540, 12488, 12523],
13079: [12461, 12525, 12527, 12483, 12488],
13080: [12463, 12441, 12521, 12512],
13081: [12463, 12441, 12521, 12512, 12488, 12531],
13082: [12463, 12523, 12475, 12441, 12452, 12525],
13083: [12463, 12525, 12540, 12493],
13084: [12465, 12540, 12473],
13085: [12467, 12523, 12490],
13086: [12467, 12540, 12507, 12442],
13087: [12469, 12452, 12463, 12523],
13088: [12469, 12531, 12481, 12540, 12512],
13089: [12471, 12522, 12531, 12463, 12441],
13090: [12475, 12531, 12481],
13091: [12475, 12531, 12488],
13092: [12479, 12441, 12540, 12473],
13093: [12486, 12441, 12471],
13094: [12488, 12441, 12523],
13095: [12488, 12531],
13096: [12490, 12494],
13097: [12494, 12483, 12488],
13098: [12495, 12452, 12484],
13099: [12495, 12442, 12540, 12475, 12531, 12488],
13100: [12495, 12442, 12540, 12484],
13101: [12495, 12441, 12540, 12524, 12523],
13102: [12498, 12442, 12450, 12473, 12488, 12523],
13103: [12498, 12442, 12463, 12523],
13104: [12498, 12442, 12467],
13105: [12498, 12441, 12523],
13106: [12501, 12449, 12521, 12483, 12488, 12441],
13107: [12501, 12451, 12540, 12488],
13108: [12501, 12441, 12483, 12471, 12455, 12523],
13109: [12501, 12521, 12531],
13110: [12504, 12463, 12479, 12540, 12523],
13111: [12504, 12442, 12477],
13112: [12504, 12442, 12491, 12498],
13113: [12504, 12523, 12484],
13114: [12504, 12442, 12531, 12473],
13115: [12504, 12442, 12540, 12471, 12441],
13116: [12504, 12441, 12540, 12479],
13117: [12507, 12442, 12452, 12531, 12488],
13118: [12507, 12441, 12523, 12488],
13119: [12507, 12531],
13120: [12507, 12442, 12531, 12488, 12441],
13121: [12507, 12540, 12523],
13122: [12507, 12540, 12531],
13123: [12510, 12452, 12463, 12525],
13124: [12510, 12452, 12523],
13125: [12510, 12483, 12495],
13126: [12510, 12523, 12463],
13127: [12510, 12531, 12471, 12519, 12531],
13128: [12511, 12463, 12525, 12531],
13129: [12511, 12522],
13130: [12511, 12522, 12495, 12441, 12540, 12523],
13131: [12513, 12459, 12441],
13132: [12513, 12459, 12441, 12488, 12531],
13133: [12513, 12540, 12488, 12523],
13134: [12516, 12540, 12488, 12441],
13135: [12516, 12540, 12523],
13136: [12518, 12450, 12531],
13137: [12522, 12483, 12488, 12523],
13138: [12522, 12521],
13139: [12523, 12498, 12442, 12540],
13140: [12523, 12540, 12501, 12441, 12523],
13141: [12524, 12512],
13142: [12524, 12531, 12488, 12465, 12441, 12531],
13143: [12527, 12483, 12488],
13144: [48, 28857],
13145: [49, 28857],
13146: [50, 28857],
13147: [51, 28857],
13148: [52, 28857],
13149: [53, 28857],
13150: [54, 28857],
13151: [55, 28857],
13152: [56, 28857],
13153: [57, 28857],
13154: [49, 48, 28857],
13155: [49, 49, 28857],
13156: [49, 50, 28857],
13157: [49, 51, 28857],
13158: [49, 52, 28857],
13159: [49, 53, 28857],
13160: [49, 54, 28857],
13161: [49, 55, 28857],
13162: [49, 56, 28857],
13163: [49, 57, 28857],
13164: [50, 48, 28857],
13165: [50, 49, 28857],
13166: [50, 50, 28857],
13167: [50, 51, 28857],
13168: [50, 52, 28857],
13169: [104, 80, 97],
13170: [100, 97],
13171: [65, 85],
13172: [98, 97, 114],
13173: [111, 86],
13174: [112, 99],
13175: [100, 109],
13176: [100, 109, 50],
13177: [100, 109, 51],
13178: [73, 85],
13179: [24179, 25104],
13180: [26157, 21644],
13181: [22823, 27491],
13182: [26126, 27835],
13183: [26666, 24335, 20250, 31038],
13184: [112, 65],
13185: [110, 65],
13186: [956, 65],
13187: [109, 65],
13188: [107, 65],
13189: [75, 66],
13190: [77, 66],
13191: [71, 66],
13192: [99, 97, 108],
13193: [107, 99, 97, 108],
13194: [112, 70],
13195: [110, 70],
13196: [956, 70],
13197: [956, 103],
13198: [109, 103],
13199: [107, 103],
13200: [72, 122],
13201: [107, 72, 122],
13202: [77, 72, 122],
13203: [71, 72, 122],
13204: [84, 72, 122],
13205: [956, 108],
13206: [109, 108],
13207: [100, 108],
13208: [107, 108],
13209: [102, 109],
13210: [110, 109],
13211: [956, 109],
13212: [109, 109],
13213: [99, 109],
13214: [107, 109],
13215: [109, 109, 50],
13216: [99, 109, 50],
13217: [109, 50],
13218: [107, 109, 50],
13219: [109, 109, 51],
13220: [99, 109, 51],
13221: [109, 51],
13222: [107, 109, 51],
13223: [109, 8725, 115],
13224: [109, 8725, 115, 50],
13225: [80, 97],
13226: [107, 80, 97],
13227: [77, 80, 97],
13228: [71, 80, 97],
13229: [114, 97, 100],
13230: [114, 97, 100, 8725, 115],
13231: [114, 97, 100, 8725, 115, 50],
13232: [112, 115],
13233: [110, 115],
13234: [956, 115],
13235: [109, 115],
13236: [112, 86],
13237: [110, 86],
13238: [956, 86],
13239: [109, 86],
13240: [107, 86],
13241: [77, 86],
13242: [112, 87],
13243: [110, 87],
13244: [956, 87],
13245: [109, 87],
13246: [107, 87],
13247: [77, 87],
13248: [107, 937],
13249: [77, 937],
13250: [97, 46, 109, 46],
13251: [66, 113],
13252: [99, 99],
13253: [99, 100],
13254: [67, 8725, 107, 103],
13255: [67, 111, 46],
13256: [100, 66],
13257: [71, 121],
13258: [104, 97],
13259: [72, 80],
13260: [105, 110],
13261: [75, 75],
13262: [75, 77],
13263: [107, 116],
13264: [108, 109],
13265: [108, 110],
13266: [108, 111, 103],
13267: [108, 120],
13268: [109, 98],
13269: [109, 105, 108],
13270: [109, 111, 108],
13271: [80, 72],
13272: [112, 46, 109, 46],
13273: [80, 80, 77],
13274: [80, 82],
13275: [115, 114],
13276: [83, 118],
13277: [87, 98],
13278: [86, 8725, 109],
13279: [65, 8725, 109],
13280: [49, 26085],
13281: [50, 26085],
13282: [51, 26085],
13283: [52, 26085],
13284: [53, 26085],
13285: [54, 26085],
13286: [55, 26085],
13287: [56, 26085],
13288: [57, 26085],
13289: [49, 48, 26085],
13290: [49, 49, 26085],
13291: [49, 50, 26085],
13292: [49, 51, 26085],
13293: [49, 52, 26085],
13294: [49, 53, 26085],
13295: [49, 54, 26085],
13296: [49, 55, 26085],
13297: [49, 56, 26085],
13298: [49, 57, 26085],
13299: [50, 48, 26085],
13300: [50, 49, 26085],
13301: [50, 50, 26085],
13302: [50, 51, 26085],
13303: [50, 52, 26085],
13304: [50, 53, 26085],
13305: [50, 54, 26085],
13306: [50, 55, 26085],
13307: [50, 56, 26085],
13308: [50, 57, 26085],
13309: [51, 48, 26085],
13310: [51, 49, 26085],
13311: [103, 97, 108],
42864: [42863],
63744: [35912],
63745: [26356],
63746: [36554],
63747: [36040],
63748: [28369],
63749: [20018],
63750: [21477],
63751: [40860],
63752: [40860],
63753: [22865],
63754: [37329],
63755: [21895],
63756: [22856],
63757: [25078],
63758: [30313],
63759: [32645],
63760: [34367],
63761: [34746],
63762: [35064],
63763: [37007],
63764: [27138],
63765: [27931],
63766: [28889],
63767: [29662],
63768: [33853],
63769: [37226],
63770: [39409],
63771: [20098],
63772: [21365],
63773: [27396],
63774: [29211],
63775: [34349],
63776: [40478],
63777: [23888],
63778: [28651],
63779: [34253],
63780: [35172],
63781: [25289],
63782: [33240],
63783: [34847],
63784: [24266],
63785: [26391],
63786: [28010],
63787: [29436],
63788: [37070],
63789: [20358],
63790: [20919],
63791: [21214],
63792: [25796],
63793: [27347],
63794: [29200],
63795: [30439],
63796: [32769],
63797: [34310],
63798: [34396],
63799: [36335],
63800: [38706],
63801: [39791],
63802: [40442],
63803: [30860],
63804: [31103],
63805: [32160],
63806: [33737],
63807: [37636],
63808: [40575],
63809: [35542],
63810: [22751],
63811: [24324],
63812: [31840],
63813: [32894],
63814: [29282],
63815: [30922],
63816: [36034],
63817: [38647],
63818: [22744],
63819: [23650],
63820: [27155],
63821: [28122],
63822: [28431],
63823: [32047],
63824: [32311],
63825: [38475],
63826: [21202],
63827: [32907],
63828: [20956],
63829: [20940],
63830: [31260],
63831: [32190],
63832: [33777],
63833: [38517],
63834: [35712],
63835: [25295],
63836: [27138],
63837: [35582],
63838: [20025],
63839: [23527],
63840: [24594],
63841: [29575],
63842: [30064],
63843: [21271],
63844: [30971],
63845: [20415],
63846: [24489],
63847: [19981],
63848: [27852],
63849: [25976],
63850: [32034],
63851: [21443],
63852: [22622],
63853: [30465],
63854: [33865],
63855: [35498],
63856: [27578],
63857: [36784],
63858: [27784],
63859: [25342],
63860: [33509],
63861: [25504],
63862: [30053],
63863: [20142],
63864: [20841],
63865: [20937],
63866: [26753],
63867: [31975],
63868: [33391],
63869: [35538],
63870: [37327],
63871: [21237],
63872: [21570],
63873: [22899],
63874: [24300],
63875: [26053],
63876: [28670],
63877: [31018],
63878: [38317],
63879: [39530],
63880: [40599],
63881: [40654],
63882: [21147],
63883: [26310],
63884: [27511],
63885: [36706],
63886: [24180],
63887: [24976],
63888: [25088],
63889: [25754],
63890: [28451],
63891: [29001],
63892: [29833],
63893: [31178],
63894: [32244],
63895: [32879],
63896: [36646],
63897: [34030],
63898: [36899],
63899: [37706],
63900: [21015],
63901: [21155],
63902: [21693],
63903: [28872],
63904: [35010],
63905: [35498],
63906: [24265],
63907: [24565],
63908: [25467],
63909: [27566],
63910: [31806],
63911: [29557],
63912: [20196],
63913: [22265],
63914: [23527],
63915: [23994],
63916: [24604],
63917: [29618],
63918: [29801],
63919: [32666],
63920: [32838],
63921: [37428],
63922: [38646],
63923: [38728],
63924: [38936],
63925: [20363],
63926: [31150],
63927: [37300],
63928: [38584],
63929: [24801],
63930: [20102],
63931: [20698],
63932: [23534],
63933: [23615],
63934: [26009],
63935: [27138],
63936: [29134],
63937: [30274],
63938: [34044],
63939: [36988],
63940: [40845],
63941: [26248],
63942: [38446],
63943: [21129],
63944: [26491],
63945: [26611],
63946: [27969],
63947: [28316],
63948: [29705],
63949: [30041],
63950: [30827],
63951: [32016],
63952: [39006],
63953: [20845],
63954: [25134],
63955: [38520],
63956: [20523],
63957: [23833],
63958: [28138],
63959: [36650],
63960: [24459],
63961: [24900],
63962: [26647],
63963: [29575],
63964: [38534],
63965: [21033],
63966: [21519],
63967: [23653],
63968: [26131],
63969: [26446],
63970: [26792],
63971: [27877],
63972: [29702],
63973: [30178],
63974: [32633],
63975: [35023],
63976: [35041],
63977: [37324],
63978: [38626],
63979: [21311],
63980: [28346],
63981: [21533],
63982: [29136],
63983: [29848],
63984: [34298],
63985: [38563],
63986: [40023],
63987: [40607],
63988: [26519],
63989: [28107],
63990: [33256],
63991: [31435],
63992: [31520],
63993: [31890],
63994: [29376],
63995: [28825],
63996: [35672],
63997: [20160],
63998: [33590],
63999: [21050],
64000: [20999],
64001: [24230],
64002: [25299],
64003: [31958],
64004: [23429],
64005: [27934],
64006: [26292],
64007: [36667],
64008: [34892],
64009: [38477],
64010: [35211],
64011: [24275],
64012: [20800],
64013: [21952],
64016: [22618],
64018: [26228],
64021: [20958],
64022: [29482],
64023: [30410],
64024: [31036],
64025: [31070],
64026: [31077],
64027: [31119],
64028: [38742],
64029: [31934],
64030: [32701],
64032: [34322],
64034: [35576],
64037: [36920],
64038: [37117],
64042: [39151],
64043: [39164],
64044: [39208],
64045: [40372],
64048: [20398],
64049: [20711],
64050: [20813],
64051: [21193],
64052: [21220],
64053: [21329],
64054: [21917],
64055: [22022],
64056: [22120],
64057: [22592],
64058: [22696],
64059: [23652],
64060: [23662],
64061: [24724],
64062: [24936],
64063: [24974],
64064: [25074],
64065: [25935],
64066: [26082],
64067: [26257],
64068: [26757],
64069: [28023],
64070: [28186],
64071: [28450],
64072: [29038],
64073: [29227],
64074: [29730],
64075: [30865],
64076: [31038],
64077: [31049],
64078: [31048],
64079: [31056],
64080: [31062],
64081: [31069],
64082: [31117],
64083: [31118],
64084: [31296],
64085: [31361],
64086: [31680],
64087: [32244],
64088: [32265],
64089: [32321],
64090: [32626],
64091: [32773],
64092: [33261],
64093: [33401],
64094: [33401],
64095: [33879],
64096: [35088],
64097: [35222],
64098: [35585],
64099: [35641],
64100: [36051],
64101: [36104],
64102: [36790],
64103: [36920],
64104: [38627],
64105: [38911],
64106: [38971],
64107: [24693],
64108: [148206],
64109: [33304],
64112: [20006],
64113: [20917],
64114: [20840],
64115: [20352],
64116: [20805],
64117: [20864],
64118: [21191],
64119: [21242],
64120: [21917],
64121: [21845],
64122: [21913],
64123: [21986],
64124: [22618],
64125: [22707],
64126: [22852],
64127: [22868],
64128: [23138],
64129: [23336],
64130: [24274],
64131: [24281],
64132: [24425],
64133: [24493],
64134: [24792],
64135: [24910],
64136: [24840],
64137: [24974],
64138: [24928],
64139: [25074],
64140: [25140],
64141: [25540],
64142: [25628],
64143: [25682],
64144: [25942],
64145: [26228],
64146: [26391],
64147: [26395],
64148: [26454],
64149: [27513],
64150: [27578],
64151: [27969],
64152: [28379],
64153: [28363],
64154: [28450],
64155: [28702],
64156: [29038],
64157: [30631],
64158: [29237],
64159: [29359],
64160: [29482],
64161: [29809],
64162: [29958],
64163: [30011],
64164: [30237],
64165: [30239],
64166: [30410],
64167: [30427],
64168: [30452],
64169: [30538],
64170: [30528],
64171: [30924],
64172: [31409],
64173: [31680],
64174: [31867],
64175: [32091],
64176: [32244],
64177: [32574],
64178: [32773],
64179: [33618],
64180: [33775],
64181: [34681],
64182: [35137],
64183: [35206],
64184: [35222],
64185: [35519],
64186: [35576],
64187: [35531],
64188: [35585],
64189: [35582],
64190: [35565],
64191: [35641],
64192: [35722],
64193: [36104],
64194: [36664],
64195: [36978],
64196: [37273],
64197: [37494],
64198: [38524],
64199: [38627],
64200: [38742],
64201: [38875],
64202: [38911],
64203: [38923],
64204: [38971],
64205: [39698],
64206: [40860],
64207: [141386],
64208: [141380],
64209: [144341],
64210: [15261],
64211: [16408],
64212: [16441],
64213: [152137],
64214: [154832],
64215: [163539],
64216: [40771],
64217: [40846],
64256: [102, 102],
64257: [102, 105],
64258: [102, 108],
64259: [102, 102, 105],
64260: [102, 102, 108],
64261: [115, 116],
64262: [115, 116],
64275: [1396, 1398],
64276: [1396, 1381],
64277: [1396, 1387],
64278: [1406, 1398],
64279: [1396, 1389],
64285: [1497, 1460],
64287: [1522, 1463],
64288: [1506],
64289: [1488],
64290: [1491],
64291: [1492],
64292: [1499],
64293: [1500],
64294: [1501],
64295: [1512],
64296: [1514],
64297: [43],
64298: [1513, 1473],
64299: [1513, 1474],
64300: [1513, 1468, 1473],
64301: [1513, 1468, 1474],
64302: [1488, 1463],
64303: [1488, 1464],
64304: [1488, 1468],
64305: [1489, 1468],
64306: [1490, 1468],
64307: [1491, 1468],
64308: [1492, 1468],
64309: [1493, 1468],
64310: [1494, 1468],
64312: [1496, 1468],
64313: [1497, 1468],
64314: [1498, 1468],
64315: [1499, 1468],
64316: [1500, 1468],
64318: [1502, 1468],
64320: [1504, 1468],
64321: [1505, 1468],
64323: [1507, 1468],
64324: [1508, 1468],
64326: [1510, 1468],
64327: [1511, 1468],
64328: [1512, 1468],
64329: [1513, 1468],
64330: [1514, 1468],
64331: [1493, 1465],
64332: [1489, 1471],
64333: [1499, 1471],
64334: [1508, 1471],
64335: [1488, 1500],
64336: [1649],
64337: [1649],
64338: [1659],
64339: [1659],
64340: [1659],
64341: [1659],
64342: [1662],
64343: [1662],
64344: [1662],
64345: [1662],
64346: [1664],
64347: [1664],
64348: [1664],
64349: [1664],
64350: [1658],
64351: [1658],
64352: [1658],
64353: [1658],
64354: [1663],
64355: [1663],
64356: [1663],
64357: [1663],
64358: [1657],
64359: [1657],
64360: [1657],
64361: [1657],
64362: [1700],
64363: [1700],
64364: [1700],
64365: [1700],
64366: [1702],
64367: [1702],
64368: [1702],
64369: [1702],
64370: [1668],
64371: [1668],
64372: [1668],
64373: [1668],
64374: [1667],
64375: [1667],
64376: [1667],
64377: [1667],
64378: [1670],
64379: [1670],
64380: [1670],
64381: [1670],
64382: [1671],
64383: [1671],
64384: [1671],
64385: [1671],
64386: [1677],
64387: [1677],
64388: [1676],
64389: [1676],
64390: [1678],
64391: [1678],
64392: [1672],
64393: [1672],
64394: [1688],
64395: [1688],
64396: [1681],
64397: [1681],
64398: [1705],
64399: [1705],
64400: [1705],
64401: [1705],
64402: [1711],
64403: [1711],
64404: [1711],
64405: [1711],
64406: [1715],
64407: [1715],
64408: [1715],
64409: [1715],
64410: [1713],
64411: [1713],
64412: [1713],
64413: [1713],
64414: [1722],
64415: [1722],
64416: [1723],
64417: [1723],
64418: [1723],
64419: [1723],
64420: [1749, 1620],
64421: [1749, 1620],
64422: [1729],
64423: [1729],
64424: [1729],
64425: [1729],
64426: [1726],
64427: [1726],
64428: [1726],
64429: [1726],
64430: [1746],
64431: [1746],
64432: [1746, 1620],
64433: [1746, 1620],
64467: [1709],
64468: [1709],
64469: [1709],
64470: [1709],
64471: [1735],
64472: [1735],
64473: [1734],
64474: [1734],
64475: [1736],
64476: [1736],
64477: [1735, 1652],
64478: [1739],
64479: [1739],
64480: [1733],
64481: [1733],
64482: [1737],
64483: [1737],
64484: [1744],
64485: [1744],
64486: [1744],
64487: [1744],
64488: [1609],
64489: [1609],
64490: [1610, 1620, 1575],
64491: [1610, 1620, 1575],
64492: [1610, 1620, 1749],
64493: [1610, 1620, 1749],
64494: [1610, 1620, 1608],
64495: [1610, 1620, 1608],
64496: [1610, 1620, 1735],
64497: [1610, 1620, 1735],
64498: [1610, 1620, 1734],
64499: [1610, 1620, 1734],
64500: [1610, 1620, 1736],
64501: [1610, 1620, 1736],
64502: [1610, 1620, 1744],
64503: [1610, 1620, 1744],
64504: [1610, 1620, 1744],
64505: [1610, 1620, 1609],
64506: [1610, 1620, 1609],
64507: [1610, 1620, 1609],
64508: [1740],
64509: [1740],
64510: [1740],
64511: [1740],
64512: [1610, 1620, 1580],
64513: [1610, 1620, 1581],
64514: [1610, 1620, 1605],
64515: [1610, 1620, 1609],
64516: [1610, 1620, 1610],
64517: [1576, 1580],
64518: [1576, 1581],
64519: [1576, 1582],
64520: [1576, 1605],
64521: [1576, 1609],
64522: [1576, 1610],
64523: [1578, 1580],
64524: [1578, 1581],
64525: [1578, 1582],
64526: [1578, 1605],
64527: [1578, 1609],
64528: [1578, 1610],
64529: [1579, 1580],
64530: [1579, 1605],
64531: [1579, 1609],
64532: [1579, 1610],
64533: [1580, 1581],
64534: [1580, 1605],
64535: [1581, 1580],
64536: [1581, 1605],
64537: [1582, 1580],
64538: [1582, 1581],
64539: [1582, 1605],
64540: [1587, 1580],
64541: [1587, 1581],
64542: [1587, 1582],
64543: [1587, 1605],
64544: [1589, 1581],
64545: [1589, 1605],
64546: [1590, 1580],
64547: [1590, 1581],
64548: [1590, 1582],
64549: [1590, 1605],
64550: [1591, 1581],
64551: [1591, 1605],
64552: [1592, 1605],
64553: [1593, 1580],
64554: [1593, 1605],
64555: [1594, 1580],
64556: [1594, 1605],
64557: [1601, 1580],
64558: [1601, 1581],
64559: [1601, 1582],
64560: [1601, 1605],
64561: [1601, 1609],
64562: [1601, 1610],
64563: [1602, 1581],
64564: [1602, 1605],
64565: [1602, 1609],
64566: [1602, 1610],
64567: [1603, 1575],
64568: [1603, 1580],
64569: [1603, 1581],
64570: [1603, 1582],
64571: [1603, 1604],
64572: [1603, 1605],
64573: [1603, 1609],
64574: [1603, 1610],
64575: [1604, 1580],
64576: [1604, 1581],
64577: [1604, 1582],
64578: [1604, 1605],
64579: [1604, 1609],
64580: [1604, 1610],
64581: [1605, 1580],
64582: [1605, 1581],
64583: [1605, 1582],
64584: [1605, 1605],
64585: [1605, 1609],
64586: [1605, 1610],
64587: [1606, 1580],
64588: [1606, 1581],
64589: [1606, 1582],
64590: [1606, 1605],
64591: [1606, 1609],
64592: [1606, 1610],
64593: [1607, 1580],
64594: [1607, 1605],
64595: [1607, 1609],
64596: [1607, 1610],
64597: [1610, 1580],
64598: [1610, 1581],
64599: [1610, 1582],
64600: [1610, 1605],
64601: [1610, 1609],
64602: [1610, 1610],
64603: [1584, 1648],
64604: [1585, 1648],
64605: [1609, 1648],
64606: [32, 1612, 1617],
64607: [32, 1613, 1617],
64608: [32, 1614, 1617],
64609: [32, 1615, 1617],
64610: [32, 1616, 1617],
64611: [32, 1617, 1648],
64612: [1610, 1620, 1585],
64613: [1610, 1620, 1586],
64614: [1610, 1620, 1605],
64615: [1610, 1620, 1606],
64616: [1610, 1620, 1609],
64617: [1610, 1620, 1610],
64618: [1576, 1585],
64619: [1576, 1586],
64620: [1576, 1605],
64621: [1576, 1606],
64622: [1576, 1609],
64623: [1576, 1610],
64624: [1578, 1585],
64625: [1578, 1586],
64626: [1578, 1605],
64627: [1578, 1606],
64628: [1578, 1609],
64629: [1578, 1610],
64630: [1579, 1585],
64631: [1579, 1586],
64632: [1579, 1605],
64633: [1579, 1606],
64634: [1579, 1609],
64635: [1579, 1610],
64636: [1601, 1609],
64637: [1601, 1610],
64638: [1602, 1609],
64639: [1602, 1610],
64640: [1603, 1575],
64641: [1603, 1604],
64642: [1603, 1605],
64643: [1603, 1609],
64644: [1603, 1610],
64645: [1604, 1605],
64646: [1604, 1609],
64647: [1604, 1610],
64648: [1605, 1575],
64649: [1605, 1605],
64650: [1606, 1585],
64651: [1606, 1586],
64652: [1606, 1605],
64653: [1606, 1606],
64654: [1606, 1609],
64655: [1606, 1610],
64656: [1609, 1648],
64657: [1610, 1585],
64658: [1610, 1586],
64659: [1610, 1605],
64660: [1610, 1606],
64661: [1610, 1609],
64662: [1610, 1610],
64663: [1610, 1620, 1580],
64664: [1610, 1620, 1581],
64665: [1610, 1620, 1582],
64666: [1610, 1620, 1605],
64667: [1610, 1620, 1607],
64668: [1576, 1580],
64669: [1576, 1581],
64670: [1576, 1582],
64671: [1576, 1605],
64672: [1576, 1607],
64673: [1578, 1580],
64674: [1578, 1581],
64675: [1578, 1582],
64676: [1578, 1605],
64677: [1578, 1607],
64678: [1579, 1605],
64679: [1580, 1581],
64680: [1580, 1605],
64681: [1581, 1580],
64682: [1581, 1605],
64683: [1582, 1580],
64684: [1582, 1605],
64685: [1587, 1580],
64686: [1587, 1581],
64687: [1587, 1582],
64688: [1587, 1605],
64689: [1589, 1581],
64690: [1589, 1582],
64691: [1589, 1605],
64692: [1590, 1580],
64693: [1590, 1581],
64694: [1590, 1582],
64695: [1590, 1605],
64696: [1591, 1581],
64697: [1592, 1605],
64698: [1593, 1580],
64699: [1593, 1605],
64700: [1594, 1580],
64701: [1594, 1605],
64702: [1601, 1580],
64703: [1601, 1581],
64704: [1601, 1582],
64705: [1601, 1605],
64706: [1602, 1581],
64707: [1602, 1605],
64708: [1603, 1580],
64709: [1603, 1581],
64710: [1603, 1582],
64711: [1603, 1604],
64712: [1603, 1605],
64713: [1604, 1580],
64714: [1604, 1581],
64715: [1604, 1582],
64716: [1604, 1605],
64717: [1604, 1607],
64718: [1605, 1580],
64719: [1605, 1581],
64720: [1605, 1582],
64721: [1605, 1605],
64722: [1606, 1580],
64723: [1606, 1581],
64724: [1606, 1582],
64725: [1606, 1605],
64726: [1606, 1607],
64727: [1607, 1580],
64728: [1607, 1605],
64729: [1607, 1648],
64730: [1610, 1580],
64731: [1610, 1581],
64732: [1610, 1582],
64733: [1610, 1605],
64734: [1610, 1607],
64735: [1610, 1620, 1605],
64736: [1610, 1620, 1607],
64737: [1576, 1605],
64738: [1576, 1607],
64739: [1578, 1605],
64740: [1578, 1607],
64741: [1579, 1605],
64742: [1579, 1607],
64743: [1587, 1605],
64744: [1587, 1607],
64745: [1588, 1605],
64746: [1588, 1607],
64747: [1603, 1604],
64748: [1603, 1605],
64749: [1604, 1605],
64750: [1606, 1605],
64751: [1606, 1607],
64752: [1610, 1605],
64753: [1610, 1607],
64754: [1600, 1614, 1617],
64755: [1600, 1615, 1617],
64756: [1600, 1616, 1617],
64757: [1591, 1609],
64758: [1591, 1610],
64759: [1593, 1609],
64760: [1593, 1610],
64761: [1594, 1609],
64762: [1594, 1610],
64763: [1587, 1609],
64764: [1587, 1610],
64765: [1588, 1609],
64766: [1588, 1610],
64767: [1581, 1609],
64768: [1581, 1610],
64769: [1580, 1609],
64770: [1580, 1610],
64771: [1582, 1609],
64772: [1582, 1610],
64773: [1589, 1609],
64774: [1589, 1610],
64775: [1590, 1609],
64776: [1590, 1610],
64777: [1588, 1580],
64778: [1588, 1581],
64779: [1588, 1582],
64780: [1588, 1605],
64781: [1588, 1585],
64782: [1587, 1585],
64783: [1589, 1585],
64784: [1590, 1585],
64785: [1591, 1609],
64786: [1591, 1610],
64787: [1593, 1609],
64788: [1593, 1610],
64789: [1594, 1609],
64790: [1594, 1610],
64791: [1587, 1609],
64792: [1587, 1610],
64793: [1588, 1609],
64794: [1588, 1610],
64795: [1581, 1609],
64796: [1581, 1610],
64797: [1580, 1609],
64798: [1580, 1610],
64799: [1582, 1609],
64800: [1582, 1610],
64801: [1589, 1609],
64802: [1589, 1610],
64803: [1590, 1609],
64804: [1590, 1610],
64805: [1588, 1580],
64806: [1588, 1581],
64807: [1588, 1582],
64808: [1588, 1605],
64809: [1588, 1585],
64810: [1587, 1585],
64811: [1589, 1585],
64812: [1590, 1585],
64813: [1588, 1580],
64814: [1588, 1581],
64815: [1588, 1582],
64816: [1588, 1605],
64817: [1587, 1607],
64818: [1588, 1607],
64819: [1591, 1605],
64820: [1587, 1580],
64821: [1587, 1581],
64822: [1587, 1582],
64823: [1588, 1580],
64824: [1588, 1581],
64825: [1588, 1582],
64826: [1591, 1605],
64827: [1592, 1605],
64828: [1575, 1611],
64829: [1575, 1611],
64848: [1578, 1580, 1605],
64849: [1578, 1581, 1580],
64850: [1578, 1581, 1580],
64851: [1578, 1581, 1605],
64852: [1578, 1582, 1605],
64853: [1578, 1605, 1580],
64854: [1578, 1605, 1581],
64855: [1578, 1605, 1582],
64856: [1580, 1605, 1581],
64857: [1580, 1605, 1581],
64858: [1581, 1605, 1610],
64859: [1581, 1605, 1609],
64860: [1587, 1581, 1580],
64861: [1587, 1580, 1581],
64862: [1587, 1580, 1609],
64863: [1587, 1605, 1581],
64864: [1587, 1605, 1581],
64865: [1587, 1605, 1580],
64866: [1587, 1605, 1605],
64867: [1587, 1605, 1605],
64868: [1589, 1581, 1581],
64869: [1589, 1581, 1581],
64870: [1589, 1605, 1605],
64871: [1588, 1581, 1605],
64872: [1588, 1581, 1605],
64873: [1588, 1580, 1610],
64874: [1588, 1605, 1582],
64875: [1588, 1605, 1582],
64876: [1588, 1605, 1605],
64877: [1588, 1605, 1605],
64878: [1590, 1581, 1609],
64879: [1590, 1582, 1605],
64880: [1590, 1582, 1605],
64881: [1591, 1605, 1581],
64882: [1591, 1605, 1581],
64883: [1591, 1605, 1605],
64884: [1591, 1605, 1610],
64885: [1593, 1580, 1605],
64886: [1593, 1605, 1605],
64887: [1593, 1605, 1605],
64888: [1593, 1605, 1609],
64889: [1594, 1605, 1605],
64890: [1594, 1605, 1610],
64891: [1594, 1605, 1609],
64892: [1601, 1582, 1605],
64893: [1601, 1582, 1605],
64894: [1602, 1605, 1581],
64895: [1602, 1605, 1605],
64896: [1604, 1581, 1605],
64897: [1604, 1581, 1610],
64898: [1604, 1581, 1609],
64899: [1604, 1580, 1580],
64900: [1604, 1580, 1580],
64901: [1604, 1582, 1605],
64902: [1604, 1582, 1605],
64903: [1604, 1605, 1581],
64904: [1604, 1605, 1581],
64905: [1605, 1581, 1580],
64906: [1605, 1581, 1605],
64907: [1605, 1581, 1610],
64908: [1605, 1580, 1581],
64909: [1605, 1580, 1605],
64910: [1605, 1582, 1580],
64911: [1605, 1582, 1605],
64914: [1605, 1580, 1582],
64915: [1607, 1605, 1580],
64916: [1607, 1605, 1605],
64917: [1606, 1581, 1605],
64918: [1606, 1581, 1609],
64919: [1606, 1580, 1605],
64920: [1606, 1580, 1605],
64921: [1606, 1580, 1609],
64922: [1606, 1605, 1610],
64923: [1606, 1605, 1609],
64924: [1610, 1605, 1605],
64925: [1610, 1605, 1605],
64926: [1576, 1582, 1610],
64927: [1578, 1580, 1610],
64928: [1578, 1580, 1609],
64929: [1578, 1582, 1610],
64930: [1578, 1582, 1609],
64931: [1578, 1605, 1610],
64932: [1578, 1605, 1609],
64933: [1580, 1605, 1610],
64934: [1580, 1581, 1609],
64935: [1580, 1605, 1609],
64936: [1587, 1582, 1609],
64937: [1589, 1581, 1610],
64938: [1588, 1581, 1610],
64939: [1590, 1581, 1610],
64940: [1604, 1580, 1610],
64941: [1604, 1605, 1610],
64942: [1610, 1581, 1610],
64943: [1610, 1580, 1610],
64944: [1610, 1605, 1610],
64945: [1605, 1605, 1610],
64946: [1602, 1605, 1610],
64947: [1606, 1581, 1610],
64948: [1602, 1605, 1581],
64949: [1604, 1581, 1605],
64950: [1593, 1605, 1610],
64951: [1603, 1605, 1610],
64952: [1606, 1580, 1581],
64953: [1605, 1582, 1610],
64954: [1604, 1580, 1605],
64955: [1603, 1605, 1605],
64956: [1604, 1580, 1605],
64957: [1606, 1580, 1581],
64958: [1580, 1581, 1610],
64959: [1581, 1580, 1610],
64960: [1605, 1580, 1610],
64961: [1601, 1605, 1610],
64962: [1576, 1581, 1610],
64963: [1603, 1605, 1605],
64964: [1593, 1580, 1605],
64965: [1589, 1605, 1605],
64966: [1587, 1582, 1610],
64967: [1606, 1580, 1610],
65008: [1589, 1604, 1746],
65009: [1602, 1604, 1746],
65010: [1575, 1604, 1604, 1607],
65011: [1575, 1603, 1576, 1585],
65012: [1605, 1581, 1605, 1583],
65013: [1589, 1604, 1593, 1605],
65014: [1585, 1587, 1608, 1604],
65015: [1593, 1604, 1610, 1607],
65016: [1608, 1587, 1604, 1605],
65017: [1589, 1604, 1609],
65018: [1589, 1604, 1609, 32, 1575, 1604, 1604, 1607, 32, 1593, 1604, 1610, 1607, 32, 1608, 1587, 1604, 1605],
65019: [1580, 1604, 32, 1580, 1604, 1575, 1604, 1607],
65020: [1585, 1740, 1575, 1604],
65040: [44],
65041: [12289],
65042: [12290],
65043: [58],
65044: [59],
65045: [33],
65046: [63],
65047: [12310],
65048: [12311],
65049: [46, 46, 46],
65072: [46, 46],
65073: [8212],
65074: [8211],
65075: [95],
65076: [95],
65077: [40],
65078: [41],
65079: [123],
65080: [125],
65081: [12308],
65082: [12309],
65083: [12304],
65084: [12305],
65085: [12298],
65086: [12299],
65087: [12296],
65088: [12297],
65089: [12300],
65090: [12301],
65091: [12302],
65092: [12303],
65095: [91],
65096: [93],
65097: [32, 773],
65098: [32, 773],
65099: [32, 773],
65100: [32, 773],
65101: [95],
65102: [95],
65103: [95],
65104: [44],
65105: [12289],
65106: [46],
65108: [59],
65109: [58],
65110: [63],
65111: [33],
65112: [8212],
65113: [40],
65114: [41],
65115: [123],
65116: [125],
65117: [12308],
65118: [12309],
65119: [35],
65120: [38],
65121: [42],
65122: [43],
65123: [45],
65124: [60],
65125: [62],
65126: [61],
65128: [92],
65129: [36],
65130: [37],
65131: [64],
65136: [32, 1611],
65137: [1600, 1611],
65138: [32, 1612],
65140: [32, 1613],
65142: [32, 1614],
65143: [1600, 1614],
65144: [32, 1615],
65145: [1600, 1615],
65146: [32, 1616],
65147: [1600, 1616],
65148: [32, 1617],
65149: [1600, 1617],
65150: [32, 1618],
65151: [1600, 1618],
65152: [1569],
65153: [1575, 1619],
65154: [1575, 1619],
65155: [1575, 1620],
65156: [1575, 1620],
65157: [1608, 1620],
65158: [1608, 1620],
65159: [1575, 1621],
65160: [1575, 1621],
65161: [1610, 1620],
65162: [1610, 1620],
65163: [1610, 1620],
65164: [1610, 1620],
65165: [1575],
65166: [1575],
65167: [1576],
65168: [1576],
65169: [1576],
65170: [1576],
65171: [1577],
65172: [1577],
65173: [1578],
65174: [1578],
65175: [1578],
65176: [1578],
65177: [1579],
65178: [1579],
65179: [1579],
65180: [1579],
65181: [1580],
65182: [1580],
65183: [1580],
65184: [1580],
65185: [1581],
65186: [1581],
65187: [1581],
65188: [1581],
65189: [1582],
65190: [1582],
65191: [1582],
65192: [1582],
65193: [1583],
65194: [1583],
65195: [1584],
65196: [1584],
65197: [1585],
65198: [1585],
65199: [1586],
65200: [1586],
65201: [1587],
65202: [1587],
65203: [1587],
65204: [1587],
65205: [1588],
65206: [1588],
65207: [1588],
65208: [1588],
65209: [1589],
65210: [1589],
65211: [1589],
65212: [1589],
65213: [1590],
65214: [1590],
65215: [1590],
65216: [1590],
65217: [1591],
65218: [1591],
65219: [1591],
65220: [1591],
65221: [1592],
65222: [1592],
65223: [1592],
65224: [1592],
65225: [1593],
65226: [1593],
65227: [1593],
65228: [1593],
65229: [1594],
65230: [1594],
65231: [1594],
65232: [1594],
65233: [1601],
65234: [1601],
65235: [1601],
65236: [1601],
65237: [1602],
65238: [1602],
65239: [1602],
65240: [1602],
65241: [1603],
65242: [1603],
65243: [1603],
65244: [1603],
65245: [1604],
65246: [1604],
65247: [1604],
65248: [1604],
65249: [1605],
65250: [1605],
65251: [1605],
65252: [1605],
65253: [1606],
65254: [1606],
65255: [1606],
65256: [1606],
65257: [1607],
65258: [1607],
65259: [1607],
65260: [1607],
65261: [1608],
65262: [1608],
65263: [1609],
65264: [1609],
65265: [1610],
65266: [1610],
65267: [1610],
65268: [1610],
65269: [1604, 1575, 1619],
65270: [1604, 1575, 1619],
65271: [1604, 1575, 1620],
65272: [1604, 1575, 1620],
65273: [1604, 1575, 1621],
65274: [1604, 1575, 1621],
65275: [1604, 1575],
65276: [1604, 1575],
65281: [33],
65282: [34],
65283: [35],
65284: [36],
65285: [37],
65286: [38],
65287: [39],
65288: [40],
65289: [41],
65290: [42],
65291: [43],
65292: [44],
65293: [45],
65294: [46],
65295: [47],
65296: [48],
65297: [49],
65298: [50],
65299: [51],
65300: [52],
65301: [53],
65302: [54],
65303: [55],
65304: [56],
65305: [57],
65306: [58],
65307: [59],
65308: [60],
65309: [61],
65310: [62],
65311: [63],
65312: [64],
65313: [65],
65314: [66],
65315: [67],
65316: [68],
65317: [69],
65318: [70],
65319: [71],
65320: [72],
65321: [73],
65322: [74],
65323: [75],
65324: [76],
65325: [77],
65326: [78],
65327: [79],
65328: [80],
65329: [81],
65330: [82],
65331: [83],
65332: [84],
65333: [85],
65334: [86],
65335: [87],
65336: [88],
65337: [89],
65338: [90],
65339: [91],
65340: [92],
65341: [93],
65342: [94],
65343: [95],
65344: [96],
65345: [97],
65346: [98],
65347: [99],
65348: [100],
65349: [101],
65350: [102],
65351: [103],
65352: [104],
65353: [105],
65354: [106],
65355: [107],
65356: [108],
65357: [109],
65358: [110],
65359: [111],
65360: [112],
65361: [113],
65362: [114],
65363: [115],
65364: [116],
65365: [117],
65366: [118],
65367: [119],
65368: [120],
65369: [121],
65370: [122],
65371: [123],
65372: [124],
65373: [125],
65374: [126],
65375: [10629],
65376: [10630],
65377: [12290],
65378: [12300],
65379: [12301],
65380: [12289],
65381: [12539],
65382: [12530],
65383: [12449],
65384: [12451],
65385: [12453],
65386: [12455],
65387: [12457],
65388: [12515],
65389: [12517],
65390: [12519],
65391: [12483],
65392: [12540],
65393: [12450],
65394: [12452],
65395: [12454],
65396: [12456],
65397: [12458],
65398: [12459],
65399: [12461],
65400: [12463],
65401: [12465],
65402: [12467],
65403: [12469],
65404: [12471],
65405: [12473],
65406: [12475],
65407: [12477],
65408: [12479],
65409: [12481],
65410: [12484],
65411: [12486],
65412: [12488],
65413: [12490],
65414: [12491],
65415: [12492],
65416: [12493],
65417: [12494],
65418: [12495],
65419: [12498],
65420: [12501],
65421: [12504],
65422: [12507],
65423: [12510],
65424: [12511],
65425: [12512],
65426: [12513],
65427: [12514],
65428: [12516],
65429: [12518],
65430: [12520],
65431: [12521],
65432: [12522],
65433: [12523],
65434: [12524],
65435: [12525],
65436: [12527],
65437: [12531],
65438: [12441],
65439: [12442],
65440: [4448],
65441: [4352],
65442: [4353],
65443: [4522],
65444: [4354],
65445: [4524],
65446: [4525],
65447: [4355],
65448: [4356],
65449: [4357],
65450: [4528],
65451: [4529],
65452: [4530],
65453: [4531],
65454: [4532],
65455: [4533],
65456: [4378],
65457: [4358],
65458: [4359],
65459: [4360],
65460: [4385],
65461: [4361],
65462: [4362],
65463: [4363],
65464: [4364],
65465: [4365],
65466: [4366],
65467: [4367],
65468: [4368],
65469: [4369],
65470: [4370],
65474: [4449],
65475: [4450],
65476: [4451],
65477: [4452],
65478: [4453],
65479: [4454],
65482: [4455],
65483: [4456],
65484: [4457],
65485: [4458],
65486: [4459],
65487: [4460],
65490: [4461],
65491: [4462],
65492: [4463],
65493: [4464],
65494: [4465],
65495: [4466],
65498: [4467],
65499: [4468],
65500: [4469],
65504: [162],
65505: [163],
65506: [172],
65507: [32, 772],
65508: [166],
65509: [165],
65510: [8361],
65512: [9474],
65513: [8592],
65514: [8593],
65515: [8594],
65516: [8595],
65517: [9632],
65518: [9675],
69786: [69785, 69818],
69788: [69787, 69818],
69803: [69797, 69818],
119134: [119127, 119141],
119135: [119128, 119141],
119136: [119128, 119141, 119150],
119137: [119128, 119141, 119151],
119138: [119128, 119141, 119152],
119139: [119128, 119141, 119153],
119140: [119128, 119141, 119154],
119227: [119225, 119141],
119228: [119226, 119141],
119229: [119225, 119141, 119150],
119230: [119226, 119141, 119150],
119231: [119225, 119141, 119151],
119232: [119226, 119141, 119151],
119808: [65],
119809: [66],
119810: [67],
119811: [68],
119812: [69],
119813: [70],
119814: [71],
119815: [72],
119816: [73],
119817: [74],
119818: [75],
119819: [76],
119820: [77],
119821: [78],
119822: [79],
119823: [80],
119824: [81],
119825: [82],
119826: [83],
119827: [84],
119828: [85],
119829: [86],
119830: [87],
119831: [88],
119832: [89],
119833: [90],
119834: [97],
119835: [98],
119836: [99],
119837: [100],
119838: [101],
119839: [102],
119840: [103],
119841: [104],
119842: [105],
119843: [106],
119844: [107],
119845: [108],
119846: [109],
119847: [110],
119848: [111],
119849: [112],
119850: [113],
119851: [114],
119852: [115],
119853: [116],
119854: [117],
119855: [118],
119856: [119],
119857: [120],
119858: [121],
119859: [122],
119860: [65],
119861: [66],
119862: [67],
119863: [68],
119864: [69],
119865: [70],
119866: [71],
119867: [72],
119868: [73],
119869: [74],
119870: [75],
119871: [76],
119872: [77],
119873: [78],
119874: [79],
119875: [80],
119876: [81],
119877: [82],
119878: [83],
119879: [84],
119880: [85],
119881: [86],
119882: [87],
119883: [88],
119884: [89],
119885: [90],
119886: [97],
119887: [98],
119888: [99],
119889: [100],
119890: [101],
119891: [102],
119892: [103],
119894: [105],
119895: [106],
119896: [107],
119897: [108],
119898: [109],
119899: [110],
119900: [111],
119901: [112],
119902: [113],
119903: [114],
119904: [115],
119905: [116],
119906: [117],
119907: [118],
119908: [119],
119909: [120],
119910: [121],
119911: [122],
119912: [65],
119913: [66],
119914: [67],
119915: [68],
119916: [69],
119917: [70],
119918: [71],
119919: [72],
119920: [73],
119921: [74],
119922: [75],
119923: [76],
119924: [77],
119925: [78],
119926: [79],
119927: [80],
119928: [81],
119929: [82],
119930: [83],
119931: [84],
119932: [85],
119933: [86],
119934: [87],
119935: [88],
119936: [89],
119937: [90],
119938: [97],
119939: [98],
119940: [99],
119941: [100],
119942: [101],
119943: [102],
119944: [103],
119945: [104],
119946: [105],
119947: [106],
119948: [107],
119949: [108],
119950: [109],
119951: [110],
119952: [111],
119953: [112],
119954: [113],
119955: [114],
119956: [115],
119957: [116],
119958: [117],
119959: [118],
119960: [119],
119961: [120],
119962: [121],
119963: [122],
119964: [65],
119966: [67],
119967: [68],
119970: [71],
119973: [74],
119974: [75],
119977: [78],
119978: [79],
119979: [80],
119980: [81],
119982: [83],
119983: [84],
119984: [85],
119985: [86],
119986: [87],
119987: [88],
119988: [89],
119989: [90],
119990: [97],
119991: [98],
119992: [99],
119993: [100],
119995: [102],
119997: [104],
119998: [105],
119999: [106],
120000: [107],
120001: [108],
120002: [109],
120003: [110],
120005: [112],
120006: [113],
120007: [114],
120008: [115],
120009: [116],
120010: [117],
120011: [118],
120012: [119],
120013: [120],
120014: [121],
120015: [122],
120016: [65],
120017: [66],
120018: [67],
120019: [68],
120020: [69],
120021: [70],
120022: [71],
120023: [72],
120024: [73],
120025: [74],
120026: [75],
120027: [76],
120028: [77],
120029: [78],
120030: [79],
120031: [80],
120032: [81],
120033: [82],
120034: [83],
120035: [84],
120036: [85],
120037: [86],
120038: [87],
120039: [88],
120040: [89],
120041: [90],
120042: [97],
120043: [98],
120044: [99],
120045: [100],
120046: [101],
120047: [102],
120048: [103],
120049: [104],
120050: [105],
120051: [106],
120052: [107],
120053: [108],
120054: [109],
120055: [110],
120056: [111],
120057: [112],
120058: [113],
120059: [114],
120060: [115],
120061: [116],
120062: [117],
120063: [118],
120064: [119],
120065: [120],
120066: [121],
120067: [122],
120068: [65],
120069: [66],
120071: [68],
120072: [69],
120073: [70],
120074: [71],
120077: [74],
120078: [75],
120079: [76],
120080: [77],
120081: [78],
120082: [79],
120083: [80],
120084: [81],
120086: [83],
120087: [84],
120088: [85],
120089: [86],
120090: [87],
120091: [88],
120092: [89],
120094: [97],
120095: [98],
120096: [99],
120097: [100],
120098: [101],
120099: [102],
120100: [103],
120101: [104],
120102: [105],
120103: [106],
120104: [107],
120105: [108],
120106: [109],
120107: [110],
120108: [111],
120109: [112],
120110: [113],
120111: [114],
120112: [115],
120113: [116],
120114: [117],
120115: [118],
120116: [119],
120117: [120],
120118: [121],
120119: [122],
120120: [65],
120121: [66],
120123: [68],
120124: [69],
120125: [70],
120126: [71],
120128: [73],
120129: [74],
120130: [75],
120131: [76],
120132: [77],
120134: [79],
120138: [83],
120139: [84],
120140: [85],
120141: [86],
120142: [87],
120143: [88],
120144: [89],
120146: [97],
120147: [98],
120148: [99],
120149: [100],
120150: [101],
120151: [102],
120152: [103],
120153: [104],
120154: [105],
120155: [106],
120156: [107],
120157: [108],
120158: [109],
120159: [110],
120160: [111],
120161: [112],
120162: [113],
120163: [114],
120164: [115],
120165: [116],
120166: [117],
120167: [118],
120168: [119],
120169: [120],
120170: [121],
120171: [122],
120172: [65],
120173: [66],
120174: [67],
120175: [68],
120176: [69],
120177: [70],
120178: [71],
120179: [72],
120180: [73],
120181: [74],
120182: [75],
120183: [76],
120184: [77],
120185: [78],
120186: [79],
120187: [80],
120188: [81],
120189: [82],
120190: [83],
120191: [84],
120192: [85],
120193: [86],
120194: [87],
120195: [88],
120196: [89],
120197: [90],
120198: [97],
120199: [98],
120200: [99],
120201: [100],
120202: [101],
120203: [102],
120204: [103],
120205: [104],
120206: [105],
120207: [106],
120208: [107],
120209: [108],
120210: [109],
120211: [110],
120212: [111],
120213: [112],
120214: [113],
120215: [114],
120216: [115],
120217: [116],
120218: [117],
120219: [118],
120220: [119],
120221: [120],
120222: [121],
120223: [122],
120224: [65],
120225: [66],
120226: [67],
120227: [68],
120228: [69],
120229: [70],
120230: [71],
120231: [72],
120232: [73],
120233: [74],
120234: [75],
120235: [76],
120236: [77],
120237: [78],
120238: [79],
120239: [80],
120240: [81],
120241: [82],
120242: [83],
120243: [84],
120244: [85],
120245: [86],
120246: [87],
120247: [88],
120248: [89],
120249: [90],
120250: [97],
120251: [98],
120252: [99],
120253: [100],
120254: [101],
120255: [102],
120256: [103],
120257: [104],
120258: [105],
120259: [106],
120260: [107],
120261: [108],
120262: [109],
120263: [110],
120264: [111],
120265: [112],
120266: [113],
120267: [114],
120268: [115],
120269: [116],
120270: [117],
120271: [118],
120272: [119],
120273: [120],
120274: [121],
120275: [122],
120276: [65],
120277: [66],
120278: [67],
120279: [68],
120280: [69],
120281: [70],
120282: [71],
120283: [72],
120284: [73],
120285: [74],
120286: [75],
120287: [76],
120288: [77],
120289: [78],
120290: [79],
120291: [80],
120292: [81],
120293: [82],
120294: [83],
120295: [84],
120296: [85],
120297: [86],
120298: [87],
120299: [88],
120300: [89],
120301: [90],
120302: [97],
120303: [98],
120304: [99],
120305: [100],
120306: [101],
120307: [102],
120308: [103],
120309: [104],
120310: [105],
120311: [106],
120312: [107],
120313: [108],
120314: [109],
120315: [110],
120316: [111],
120317: [112],
120318: [113],
120319: [114],
120320: [115],
120321: [116],
120322: [117],
120323: [118],
120324: [119],
120325: [120],
120326: [121],
120327: [122],
120328: [65],
120329: [66],
120330: [67],
120331: [68],
120332: [69],
120333: [70],
120334: [71],
120335: [72],
120336: [73],
120337: [74],
120338: [75],
120339: [76],
120340: [77],
120341: [78],
120342: [79],
120343: [80],
120344: [81],
120345: [82],
120346: [83],
120347: [84],
120348: [85],
120349: [86],
120350: [87],
120351: [88],
120352: [89],
120353: [90],
120354: [97],
120355: [98],
120356: [99],
120357: [100],
120358: [101],
120359: [102],
120360: [103],
120361: [104],
120362: [105],
120363: [106],
120364: [107],
120365: [108],
120366: [109],
120367: [110],
120368: [111],
120369: [112],
120370: [113],
120371: [114],
120372: [115],
120373: [116],
120374: [117],
120375: [118],
120376: [119],
120377: [120],
120378: [121],
120379: [122],
120380: [65],
120381: [66],
120382: [67],
120383: [68],
120384: [69],
120385: [70],
120386: [71],
120387: [72],
120388: [73],
120389: [74],
120390: [75],
120391: [76],
120392: [77],
120393: [78],
120394: [79],
120395: [80],
120396: [81],
120397: [82],
120398: [83],
120399: [84],
120400: [85],
120401: [86],
120402: [87],
120403: [88],
120404: [89],
120405: [90],
120406: [97],
120407: [98],
120408: [99],
120409: [100],
120410: [101],
120411: [102],
120412: [103],
120413: [104],
120414: [105],
120415: [106],
120416: [107],
120417: [108],
120418: [109],
120419: [110],
120420: [111],
120421: [112],
120422: [113],
120423: [114],
120424: [115],
120425: [116],
120426: [117],
120427: [118],
120428: [119],
120429: [120],
120430: [121],
120431: [122],
120432: [65],
120433: [66],
120434: [67],
120435: [68],
120436: [69],
120437: [70],
120438: [71],
120439: [72],
120440: [73],
120441: [74],
120442: [75],
120443: [76],
120444: [77],
120445: [78],
120446: [79],
120447: [80],
120448: [81],
120449: [82],
120450: [83],
120451: [84],
120452: [85],
120453: [86],
120454: [87],
120455: [88],
120456: [89],
120457: [90],
120458: [97],
120459: [98],
120460: [99],
120461: [100],
120462: [101],
120463: [102],
120464: [103],
120465: [104],
120466: [105],
120467: [106],
120468: [107],
120469: [108],
120470: [109],
120471: [110],
120472: [111],
120473: [112],
120474: [113],
120475: [114],
120476: [115],
120477: [116],
120478: [117],
120479: [118],
120480: [119],
120481: [120],
120482: [121],
120483: [122],
120484: [305],
120485: [567],
120488: [913],
120489: [914],
120490: [915],
120491: [916],
120492: [917],
120493: [918],
120494: [919],
120495: [920],
120496: [921],
120497: [922],
120498: [923],
120499: [924],
120500: [925],
120501: [926],
120502: [927],
120503: [928],
120504: [929],
120505: [920],
120506: [931],
120507: [932],
120508: [933],
120509: [934],
120510: [935],
120511: [936],
120512: [937],
120513: [8711],
120514: [945],
120515: [946],
120516: [947],
120517: [948],
120518: [949],
120519: [950],
120520: [951],
120521: [952],
120522: [953],
120523: [954],
120524: [955],
120525: [956],
120526: [957],
120527: [958],
120528: [959],
120529: [960],
120530: [961],
120531: [962],
120532: [963],
120533: [964],
120534: [965],
120535: [966],
120536: [967],
120537: [968],
120538: [969],
120539: [8706],
120540: [949],
120541: [952],
120542: [954],
120543: [966],
120544: [961],
120545: [960],
120546: [913],
120547: [914],
120548: [915],
120549: [916],
120550: [917],
120551: [918],
120552: [919],
120553: [920],
120554: [921],
120555: [922],
120556: [923],
120557: [924],
120558: [925],
120559: [926],
120560: [927],
120561: [928],
120562: [929],
120563: [920],
120564: [931],
120565: [932],
120566: [933],
120567: [934],
120568: [935],
120569: [936],
120570: [937],
120571: [8711],
120572: [945],
120573: [946],
120574: [947],
120575: [948],
120576: [949],
120577: [950],
120578: [951],
120579: [952],
120580: [953],
120581: [954],
120582: [955],
120583: [956],
120584: [957],
120585: [958],
120586: [959],
120587: [960],
120588: [961],
120589: [962],
120590: [963],
120591: [964],
120592: [965],
120593: [966],
120594: [967],
120595: [968],
120596: [969],
120597: [8706],
120598: [949],
120599: [952],
120600: [954],
120601: [966],
120602: [961],
120603: [960],
120604: [913],
120605: [914],
120606: [915],
120607: [916],
120608: [917],
120609: [918],
120610: [919],
120611: [920],
120612: [921],
120613: [922],
120614: [923],
120615: [924],
120616: [925],
120617: [926],
120618: [927],
120619: [928],
120620: [929],
120621: [920],
120622: [931],
120623: [932],
120624: [933],
120625: [934],
120626: [935],
120627: [936],
120628: [937],
120629: [8711],
120630: [945],
120631: [946],
120632: [947],
120633: [948],
120634: [949],
120635: [950],
120636: [951],
120637: [952],
120638: [953],
120639: [954],
120640: [955],
120641: [956],
120642: [957],
120643: [958],
120644: [959],
120645: [960],
120646: [961],
120647: [962],
120648: [963],
120649: [964],
120650: [965],
120651: [966],
120652: [967],
120653: [968],
120654: [969],
120655: [8706],
120656: [949],
120657: [952],
120658: [954],
120659: [966],
120660: [961],
120661: [960],
120662: [913],
120663: [914],
120664: [915],
120665: [916],
120666: [917],
120667: [918],
120668: [919],
120669: [920],
120670: [921],
120671: [922],
120672: [923],
120673: [924],
120674: [925],
120675: [926],
120676: [927],
120677: [928],
120678: [929],
120679: [920],
120680: [931],
120681: [932],
120682: [933],
120683: [934],
120684: [935],
120685: [936],
120686: [937],
120687: [8711],
120688: [945],
120689: [946],
120690: [947],
120691: [948],
120692: [949],
120693: [950],
120694: [951],
120695: [952],
120696: [953],
120697: [954],
120698: [955],
120699: [956],
120700: [957],
120701: [958],
120702: [959],
120703: [960],
120704: [961],
120705: [962],
120706: [963],
120707: [964],
120708: [965],
120709: [966],
120710: [967],
120711: [968],
120712: [969],
120713: [8706],
120714: [949],
120715: [952],
120716: [954],
120717: [966],
120718: [961],
120719: [960],
120720: [913],
120721: [914],
120722: [915],
120723: [916],
120724: [917],
120725: [918],
120726: [919],
120727: [920],
120728: [921],
120729: [922],
120730: [923],
120731: [924],
120732: [925],
120733: [926],
120734: [927],
120735: [928],
120736: [929],
120737: [920],
120738: [931],
120739: [932],
120740: [933],
120741: [934],
120742: [935],
120743: [936],
120744: [937],
120745: [8711],
120746: [945],
120747: [946],
120748: [947],
120749: [948],
120750: [949],
120751: [950],
120752: [951],
120753: [952],
120754: [953],
120755: [954],
120756: [955],
120757: [956],
120758: [957],
120759: [958],
120760: [959],
120761: [960],
120762: [961],
120763: [962],
120764: [963],
120765: [964],
120766: [965],
120767: [966],
120768: [967],
120769: [968],
120770: [969],
120771: [8706],
120772: [949],
120773: [952],
120774: [954],
120775: [966],
120776: [961],
120777: [960],
120778: [988],
120779: [989],
120782: [48],
120783: [49],
120784: [50],
120785: [51],
120786: [52],
120787: [53],
120788: [54],
120789: [55],
120790: [56],
120791: [57],
120792: [48],
120793: [49],
120794: [50],
120795: [51],
120796: [52],
120797: [53],
120798: [54],
120799: [55],
120800: [56],
120801: [57],
120802: [48],
120803: [49],
120804: [50],
120805: [51],
120806: [52],
120807: [53],
120808: [54],
120809: [55],
120810: [56],
120811: [57],
120812: [48],
120813: [49],
120814: [50],
120815: [51],
120816: [52],
120817: [53],
120818: [54],
120819: [55],
120820: [56],
120821: [57],
120822: [48],
120823: [49],
120824: [50],
120825: [51],
120826: [52],
120827: [53],
120828: [54],
120829: [55],
120830: [56],
120831: [57],
127232: [48, 46],
127233: [48, 44],
127234: [49, 44],
127235: [50, 44],
127236: [51, 44],
127237: [52, 44],
127238: [53, 44],
127239: [54, 44],
127240: [55, 44],
127241: [56, 44],
127242: [57, 44],
127248: [40, 65, 41],
127249: [40, 66, 41],
127250: [40, 67, 41],
127251: [40, 68, 41],
127252: [40, 69, 41],
127253: [40, 70, 41],
127254: [40, 71, 41],
127255: [40, 72, 41],
127256: [40, 73, 41],
127257: [40, 74, 41],
127258: [40, 75, 41],
127259: [40, 76, 41],
127260: [40, 77, 41],
127261: [40, 78, 41],
127262: [40, 79, 41],
127263: [40, 80, 41],
127264: [40, 81, 41],
127265: [40, 82, 41],
127266: [40, 83, 41],
127267: [40, 84, 41],
127268: [40, 85, 41],
127269: [40, 86, 41],
127270: [40, 87, 41],
127271: [40, 88, 41],
127272: [40, 89, 41],
127273: [40, 90, 41],
127274: [12308, 83, 12309],
127275: [67],
127276: [82],
127277: [67, 68],
127278: [87, 90],
127281: [66],
127293: [78],
127295: [80],
127298: [83],
127302: [87],
127306: [72, 86],
127307: [77, 86],
127308: [83, 68],
127309: [83, 83],
127310: [80, 80, 86],
127376: [68, 74],
127488: [12411, 12363],
127504: [25163],
127505: [23383],
127506: [21452],
127507: [12486, 12441],
127508: [20108],
127509: [22810],
127510: [35299],
127511: [22825],
127512: [20132],
127513: [26144],
127514: [28961],
127515: [26009],
127516: [21069],
127517: [24460],
127518: [20877],
127519: [26032],
127520: [21021],
127521: [32066],
127522: [29983],
127523: [36009],
127524: [22768],
127525: [21561],
127526: [28436],
127527: [25237],
127528: [25429],
127529: [19968],
127530: [19977],
127531: [36938],
127532: [24038],
127533: [20013],
127534: [21491],
127535: [25351],
127536: [36208],
127537: [25171],
127552: [12308, 26412, 12309],
127553: [12308, 19977, 12309],
127554: [12308, 20108, 12309],
127555: [12308, 23433, 12309],
127556: [12308, 28857, 12309],
127557: [12308, 25171, 12309],
127558: [12308, 30423, 12309],
127559: [12308, 21213, 12309],
127560: [12308, 25943, 12309],
194560: [20029],
194561: [20024],
194562: [20033],
194563: [131362],
194564: [20320],
194565: [20398],
194566: [20411],
194567: [20482],
194568: [20602],
194569: [20633],
194570: [20711],
194571: [20687],
194572: [13470],
194573: [132666],
194574: [20813],
194575: [20820],
194576: [20836],
194577: [20855],
194578: [132380],
194579: [13497],
194580: [20839],
194581: [20877],
194582: [132427],
194583: [20887],
194584: [20900],
194585: [20172],
194586: [20908],
194587: [20917],
194588: [168415],
194589: [20981],
194590: [20995],
194591: [13535],
194592: [21051],
194593: [21062],
194594: [21106],
194595: [21111],
194596: [13589],
194597: [21191],
194598: [21193],
194599: [21220],
194600: [21242],
194601: [21253],
194602: [21254],
194603: [21271],
194604: [21321],
194605: [21329],
194606: [21338],
194607: [21363],
194608: [21373],
194609: [21375],
194610: [21375],
194611: [21375],
194612: [133676],
194613: [28784],
194614: [21450],
194615: [21471],
194616: [133987],
194617: [21483],
194618: [21489],
194619: [21510],
194620: [21662],
194621: [21560],
194622: [21576],
194623: [21608],
194624: [21666],
194625: [21750],
194626: [21776],
194627: [21843],
194628: [21859],
194629: [21892],
194630: [21892],
194631: [21913],
194632: [21931],
194633: [21939],
194634: [21954],
194635: [22294],
194636: [22022],
194637: [22295],
194638: [22097],
194639: [22132],
194640: [20999],
194641: [22766],
194642: [22478],
194643: [22516],
194644: [22541],
194645: [22411],
194646: [22578],
194647: [22577],
194648: [22700],
194649: [136420],
194650: [22770],
194651: [22775],
194652: [22790],
194653: [22810],
194654: [22818],
194655: [22882],
194656: [136872],
194657: [136938],
194658: [23020],
194659: [23067],
194660: [23079],
194661: [23000],
194662: [23142],
194663: [14062],
194664: [14076],
194665: [23304],
194666: [23358],
194667: [23358],
194668: [137672],
194669: [23491],
194670: [23512],
194671: [23527],
194672: [23539],
194673: [138008],
194674: [23551],
194675: [23558],
194676: [24403],
194677: [23586],
194678: [14209],
194679: [23648],
194680: [23662],
194681: [23744],
194682: [23693],
194683: [138724],
194684: [23875],
194685: [138726],
194686: [23918],
194687: [23915],
194688: [23932],
194689: [24033],
194690: [24034],
194691: [14383],
194692: [24061],
194693: [24104],
194694: [24125],
194695: [24169],
194696: [14434],
194697: [139651],
194698: [14460],
194699: [24240],
194700: [24243],
194701: [24246],
194702: [24266],
194703: [172946],
194704: [24318],
194705: [140081],
194706: [140081],
194707: [33281],
194708: [24354],
194709: [24354],
194710: [14535],
194711: [144056],
194712: [156122],
194713: [24418],
194714: [24427],
194715: [14563],
194716: [24474],
194717: [24525],
194718: [24535],
194719: [24569],
194720: [24705],
194721: [14650],
194722: [14620],
194723: [24724],
194724: [141012],
194725: [24775],
194726: [24904],
194727: [24908],
194728: [24910],
194729: [24908],
194730: [24954],
194731: [24974],
194732: [25010],
194733: [24996],
194734: [25007],
194735: [25054],
194736: [25074],
194737: [25078],
194738: [25104],
194739: [25115],
194740: [25181],
194741: [25265],
194742: [25300],
194743: [25424],
194744: [142092],
194745: [25405],
194746: [25340],
194747: [25448],
194748: [25475],
194749: [25572],
194750: [142321],
194751: [25634],
194752: [25541],
194753: [25513],
194754: [14894],
194755: [25705],
194756: [25726],
194757: [25757],
194758: [25719],
194759: [14956],
194760: [25935],
194761: [25964],
194762: [143370],
194763: [26083],
194764: [26360],
194765: [26185],
194766: [15129],
194767: [26257],
194768: [15112],
194769: [15076],
194770: [20882],
194771: [20885],
194772: [26368],
194773: [26268],
194774: [32941],
194775: [17369],
194776: [26391],
194777: [26395],
194778: [26401],
194779: [26462],
194780: [26451],
194781: [144323],
194782: [15177],
194783: [26618],
194784: [26501],
194785: [26706],
194786: [26757],
194787: [144493],
194788: [26766],
194789: [26655],
194790: [26900],
194791: [15261],
194792: [26946],
194793: [27043],
194794: [27114],
194795: [27304],
194796: [145059],
194797: [27355],
194798: [15384],
194799: [27425],
194800: [145575],
194801: [27476],
194802: [15438],
194803: [27506],
194804: [27551],
194805: [27578],
194806: [27579],
194807: [146061],
194808: [138507],
194809: [146170],
194810: [27726],
194811: [146620],
194812: [27839],
194813: [27853],
194814: [27751],
194815: [27926],
194816: [27966],
194817: [28023],
194818: [27969],
194819: [28009],
194820: [28024],
194821: [28037],
194822: [146718],
194823: [27956],
194824: [28207],
194825: [28270],
194826: [15667],
194827: [28363],
194828: [28359],
194829: [147153],
194830: [28153],
194831: [28526],
194832: [147294],
194833: [147342],
194834: [28614],
194835: [28729],
194836: [28702],
194837: [28699],
194838: [15766],
194839: [28746],
194840: [28797],
194841: [28791],
194842: [28845],
194843: [132389],
194844: [28997],
194845: [148067],
194846: [29084],
194847: [148395],
194848: [29224],
194849: [29237],
194850: [29264],
194851: [149000],
194852: [29312],
194853: [29333],
194854: [149301],
194855: [149524],
194856: [29562],
194857: [29579],
194858: [16044],
194859: [29605],
194860: [16056],
194861: [16056],
194862: [29767],
194863: [29788],
194864: [29809],
194865: [29829],
194866: [29898],
194867: [16155],
194868: [29988],
194869: [150582],
194870: [30014],
194871: [150674],
194872: [30064],
194873: [139679],
194874: [30224],
194875: [151457],
194876: [151480],
194877: [151620],
194878: [16380],
194879: [16392],
194880: [30452],
194881: [151795],
194882: [151794],
194883: [151833],
194884: [151859],
194885: [30494],
194886: [30495],
194887: [30495],
194888: [30538],
194889: [16441],
194890: [30603],
194891: [16454],
194892: [16534],
194893: [152605],
194894: [30798],
194895: [30860],
194896: [30924],
194897: [16611],
194898: [153126],
194899: [31062],
194900: [153242],
194901: [153285],
194902: [31119],
194903: [31211],
194904: [16687],
194905: [31296],
194906: [31306],
194907: [31311],
194908: [153980],
194909: [154279],
194910: [154279],
194911: [31470],
194912: [16898],
194913: [154539],
194914: [31686],
194915: [31689],
194916: [16935],
194917: [154752],
194918: [31954],
194919: [17056],
194920: [31976],
194921: [31971],
194922: [32000],
194923: [155526],
194924: [32099],
194925: [17153],
194926: [32199],
194927: [32258],
194928: [32325],
194929: [17204],
194930: [156200],
194931: [156231],
194932: [17241],
194933: [156377],
194934: [32634],
194935: [156478],
194936: [32661],
194937: [32762],
194938: [32773],
194939: [156890],
194940: [156963],
194941: [32864],
194942: [157096],
194943: [32880],
194944: [144223],
194945: [17365],
194946: [32946],
194947: [33027],
194948: [17419],
194949: [33086],
194950: [23221],
194951: [157607],
194952: [157621],
194953: [144275],
194954: [144284],
194955: [33281],
194956: [33284],
194957: [36766],
194958: [17515],
194959: [33425],
194960: [33419],
194961: [33437],
194962: [21171],
194963: [33457],
194964: [33459],
194965: [33469],
194966: [33510],
194967: [158524],
194968: [33509],
194969: [33565],
194970: [33635],
194971: [33709],
194972: [33571],
194973: [33725],
194974: [33767],
194975: [33879],
194976: [33619],
194977: [33738],
194978: [33740],
194979: [33756],
194980: [158774],
194981: [159083],
194982: [158933],
194983: [17707],
194984: [34033],
194985: [34035],
194986: [34070],
194987: [160714],
194988: [34148],
194989: [159532],
194990: [17757],
194991: [17761],
194992: [159665],
194993: [159954],
194994: [17771],
194995: [34384],
194996: [34396],
194997: [34407],
194998: [34409],
194999: [34473],
195000: [34440],
195001: [34574],
195002: [34530],
195003: [34681],
195004: [34600],
195005: [34667],
195006: [34694],
195007: [17879],
195008: [34785],
195009: [34817],
195010: [17913],
195011: [34912],
195012: [34915],
195013: [161383],
195014: [35031],
195015: [35038],
195016: [17973],
195017: [35066],
195018: [13499],
195019: [161966],
195020: [162150],
195021: [18110],
195022: [18119],
195023: [35488],
195024: [35565],
195025: [35722],
195026: [35925],
195027: [162984],
195028: [36011],
195029: [36033],
195030: [36123],
195031: [36215],
195032: [163631],
195033: [133124],
195034: [36299],
195035: [36284],
195036: [36336],
195037: [133342],
195038: [36564],
195039: [36664],
195040: [165330],
195041: [165357],
195042: [37012],
195043: [37105],
195044: [37137],
195045: [165678],
195046: [37147],
195047: [37432],
195048: [37591],
195049: [37592],
195050: [37500],
195051: [37881],
195052: [37909],
195053: [166906],
195054: [38283],
195055: [18837],
195056: [38327],
195057: [167287],
195058: [18918],
195059: [38595],
195060: [23986],
195061: [38691],
195062: [168261],
195063: [168474],
195064: [19054],
195065: [19062],
195066: [38880],
195067: [168970],
195068: [19122],
195069: [169110],
195070: [38923],
195071: [38923],
195072: [38953],
195073: [169398],
195074: [39138],
195075: [19251],
195076: [39209],
195077: [39335],
195078: [39362],
195079: [39422],
195080: [19406],
195081: [170800],
195082: [39698],
195083: [40000],
195084: [40189],
195085: [19662],
195086: [19693],
195087: [40295],
195088: [172238],
195089: [19704],
195090: [172293],
195091: [172558],
195092: [172689],
195093: [40635],
195094: [19798],
195095: [40697],
195096: [40702],
195097: [40709],
195098: [40719],
195099: [40726],
195100: [40763],
195101: [173568],
}

_compat_decomposition_corrected = {
}

def canon_decomposition(code):
    try:
        return _canon_decomposition[code]
    except KeyError:
        if base_mod is not None and code not in _canon_decomposition_corrected:
            return base_mod._canon_decomposition.get(code, [])
        else:
            return []
def compat_decomposition(code):
    try:
        return _compat_decomposition[code]
    except KeyError:
        if base_mod is not None and code not in _compat_decomposition_corrected:
            return base_mod._compat_decomposition.get(code, [])
        else:
            return []

